/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/arrays","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/collections","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ie=function(B){for(var t=[],k=0,_=B.length;k<_;k++)t[k]=ne[B[k]];return t};const We=this,Ce=typeof global=="object"?global:{};var he;(function(B){B.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}B.Environment=t})(he||(he={}));var he;(function(B){class t{constructor(a,L,o){this.type=a,this.detail=L,this.timestamp=o}}B.LoaderEvent=t;class k{constructor(a){this._events=[new t(1,"",a)]}record(a,L){this._events.push(new t(a,L,B.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}B.LoaderEventRecorder=k;class _{record(a,L){}getEvents(){return[]}}_.INSTANCE=new _,B.NullLoaderEventRecorder=_})(he||(he={}));var he;(function(B){class t{static fileUriToFilePath(_,r){if(r=decodeURI(r).replace(/%23/g,"#"),_){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(_,r){return _.length>=r.length&&_.substr(0,r.length)===r}static endsWith(_,r){return _.length>=r.length&&_.substr(_.length-r.length)===r}static containsQueryString(_){return/^[^\#]*\?/gi.test(_)}static isAbsolutePath(_){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(_)}static forEachProperty(_,r){if(_){let a;for(a in _)_.hasOwnProperty(a)&&r(a,_[a])}}static isEmpty(_){let r=!0;return t.forEachProperty(_,()=>{r=!1}),r}static recursiveClone(_){if(!_||typeof _!="object"||_ instanceof RegExp||!Array.isArray(_)&&Object.getPrototypeOf(_)!==Object.prototype)return _;let r=Array.isArray(_)?[]:{};return t.forEachProperty(_,(a,L)=>{L&&typeof L=="object"?r[a]=t.recursiveClone(L):r[a]=L}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(_){return t.startsWith(_,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,B.Utilities=t})(he||(he={}));var he;(function(B){function t(r){if(r instanceof Error)return r;const a=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(a.stack=r.stack),a}B.ensureError=t;class k{static validateConfigurationOptions(a){function L(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError>"u"&&(a.catchError=!1),typeof a.recordStats>"u"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=L),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(B.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags>"u"&&(a.preferScriptTags=!1),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){const o=t(new Error("INVALID cached data configuration, 'path' MUST be set"));o.phase="configuration",a.onError(o),a.nodeCachedData=void 0}return a}static mergeConfigurationOptions(a=null,L=null){let o=B.Utilities.recursiveClone(L||{});return B.Utilities.forEachProperty(a,(u,s)=>{u==="ignoreDuplicateModules"&&typeof o.ignoreDuplicateModules<"u"?o.ignoreDuplicateModules=o.ignoreDuplicateModules.concat(s):u==="paths"&&typeof o.paths<"u"?B.Utilities.forEachProperty(s,(d,p)=>o.paths[d]=p):u==="config"&&typeof o.config<"u"?B.Utilities.forEachProperty(s,(d,p)=>o.config[d]=p):o[u]=B.Utilities.recursiveClone(s)}),k.validateConfigurationOptions(o)}}B.ConfigurationOptionsUtil=k;class _{constructor(a,L){if(this._env=a,this.options=k.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let o=this.options.nodeRequire.main.filename,u=Math.max(o.lastIndexOf("/"),o.lastIndexOf("\\"));this.options.baseUrl=o.substring(0,u+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,(a,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:a,to:L}):this.sortedPathsRules.push({from:a,to:[L]})}),this.sortedPathsRules.sort((a,L)=>L.from.length-a.from.length)}cloneAndMerge(a){return new _(this._env,k.mergeConfigurationOptions(a,this.options))}getOptionsLiteral(){return this.options}_applyPaths(a){let L;for(let o=0,u=this.sortedPathsRules.length;o<u;o++)if(L=this.sortedPathsRules[o],B.Utilities.startsWith(a,L.from)){let s=[];for(let d=0,p=L.to.length;d<p;d++)s.push(L.to[d]+a.substr(L.from.length));return s}return[a]}_addUrlArgsToUrl(a){return B.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a}_addUrlArgsIfNecessaryToUrls(a){if(this.options.urlArgs)for(let L=0,o=a.length;L<o;L++)a[L]=this._addUrlArgsToUrl(a[L]);return a}moduleIdToPaths(a){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a))return this.isBuild()?["empty:"]:["node|"+a];let L=a,o;if(!B.Utilities.endsWith(L,".js")&&!B.Utilities.isAbsolutePath(L)){o=this._applyPaths(L);for(let u=0,s=o.length;u<s;u++)this.isBuild()&&o[u]==="empty:"||(B.Utilities.isAbsolutePath(o[u])||(o[u]=this.options.baseUrl+o[u]),!B.Utilities.endsWith(o[u],".js")&&!B.Utilities.containsQueryString(o[u])&&(o[u]=o[u]+".js"))}else!B.Utilities.endsWith(L,".js")&&!B.Utilities.containsQueryString(L)&&(L=L+".js"),o=[L];return this._addUrlArgsIfNecessaryToUrls(o)}requireToUrl(a){let L=a;return B.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],B.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(a){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(a)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[a])}isDuplicateMessageIgnoredFor(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)}getConfigForModule(a){if(this.options.config)return this.options.config[a]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(a){this.options.onError(a)}}B.Configuration=_})(he||(he={}));var he;(function(B){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,d,p,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new k:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new k;let c={callback:p,errorback:b};if(this._callbackMap.hasOwnProperty(d)){this._callbackMap[d].push(c);return}this._callbackMap[d]=[c],this._scriptLoader.load(s,d,()=>this.triggerCallback(d),e=>this.triggerErrorback(d,e))}triggerCallback(s){let d=this._callbackMap[s];delete this._callbackMap[s];for(let p=0;p<d.length;p++)d[p].callback()}triggerErrorback(s,d){let p=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<p.length;b++)p[b].errorback(d)}}class k{attachListeners(s,d,p){let b=()=>{s.removeEventListener("load",c),s.removeEventListener("error",e)},c=$=>{b(),d()},e=$=>{b(),p($)};s.addEventListener("load",c),s.addEventListener("error",e)}load(s,d,p,b){if(/^node\|/.test(d)){let c=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),c.nodeRequire||B.global.nodeRequire),$=d.split("|"),E=null;try{E=e($[1])}catch(A){b(A);return}s.enqueueDefineAnonymousModule([],()=>E),p()}else{let c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript"),this.attachListeners(c,p,b);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(d=e.createScriptURL(d)),c.setAttribute("src",d);const{cspNonce:$}=s.getConfig().getOptionsLiteral();$&&c.setAttribute("nonce",$),document.getElementsByTagName("head")[0].appendChild(c)}}}function _(u){const{trustedTypesPolicy:s}=u.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=_(s)),this._cachedCanUseEval}load(s,d,p,b){if(/^node\|/.test(d)){const c=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),c.nodeRequire||B.global.nodeRequire),$=d.split("|");let E=null;try{E=e($[1])}catch(A){b(A);return}s.enqueueDefineAnonymousModule([],function(){return E}),p()}else{const{trustedTypesPolicy:c}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(d).then($=>{if($.status!==200)throw new Error($.statusText);return $.text()}).then($=>{$=`${$}
//# sourceURL=${d}`,(c?self.eval(c.createScript("",$)):new Function($)).call(self),p()}).then(void 0,b);return}try{c&&(d=c.createScriptURL(d)),importScripts(d),p()}catch($){b($)}}}}class a{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,d){const{nodeCachedData:p}=d.getConfig().getOptionsLiteral();if(!p||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,c=s("module");function e($){const E=$.constructor;let A=function(v){try{return $.require(v)}finally{}};return A.resolve=function(v,f){return E._resolveFilename(v,$,!1,f)},A.resolve.paths=function(v){return E._resolveLookupPaths(v,$)},A.main=process.mainModule,A.extensions=E._extensions,A.cache=E._cache,A}c.prototype._compile=function($,E){const A=c.wrap($.replace(/^#!.*/,"")),g=d.getRecorder(),v=b._getCachedDataPath(p,E),f={filename:E};let h;try{const F=b._fs.readFileSync(v);h=F.slice(0,16),f.cachedData=F.slice(16),g.record(60,v)}catch{g.record(61,v)}const i=new b._vm.Script(A,f),l=i.runInThisContext(f),N=b._path.dirname(E),m=e(this),w=[this.exports,m,this,E,N,process,Ce,Buffer],M=l.apply(this.exports,w);return b._handleCachedData(i,A,v,!f.cachedData,d),b._verifyCachedData(i,A,v,h,d),M}}load(s,d,p,b){const c=s.getConfig().getOptionsLiteral(),e=L(s.getRecorder(),c.nodeRequire||B.global.nodeRequire),$=c.nodeInstrumenter||function(A){return A};this._init(e),this._initNodeRequire(e,s);let E=s.getRecorder();if(/^node\|/.test(d)){let A=d.split("|"),g=null;try{g=e(A[1])}catch(v){b(v);return}s.enqueueDefineAnonymousModule([],()=>g),p()}else{d=B.Utilities.fileUriToFilePath(this._env.isWindows,d);const A=this._path.normalize(d),g=this._getElectronRendererScriptPathOrUri(A),v=!!c.nodeCachedData,f=v?this._getCachedDataPath(c.nodeCachedData,d):void 0;this._readSourceAndCachedData(A,f,E,(h,i,l,N)=>{if(h){b(h);return}let m;i.charCodeAt(0)===a._BOM?m=a._PREFIX+i.substring(1)+a._SUFFIX:m=a._PREFIX+i+a._SUFFIX,m=$(m,A);const w={filename:g,cachedData:l},M=this._createAndEvalScript(s,m,w,p,b);this._handleCachedData(M,m,f,v&&!l,s),this._verifyCachedData(M,m,f,N,s)})}}_createAndEvalScript(s,d,p,b,c){const e=s.getRecorder();e.record(31,p.filename);const $=new this._vm.Script(d,p),E=$.runInThisContext(p),A=s.getGlobalAMDDefineFunc();let g=!1;const v=function(){return g=!0,A.apply(null,arguments)};return v.amd=A.amd,E.call(B.global,s.getGlobalAMDRequireFunc(),v,p.filename,this._path.dirname(p.filename)),e.record(32,p.filename),g?b():c(new Error(`Didn't receive define call in ${p.filename}!`)),$}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let d=s.match(/^([a-z])\:(.*)/i);return d?`file:///${(d[1].toUpperCase()+":"+d[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,d){const p=this._crypto.createHash("md5").update(d,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(d).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${p}.code`)}_handleCachedData(s,d,p,b,c){s.cachedDataRejected?this._fs.unlink(p,e=>{c.getRecorder().record(62,p),this._createAndWriteCachedData(s,d,p,c),e&&c.getConfig().onError(e)}):b&&this._createAndWriteCachedData(s,d,p,c)}_createAndWriteCachedData(s,d,p,b){let c=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,$=0,E;const A=()=>{setTimeout(()=>{E||(E=this._crypto.createHash("md5").update(d,"utf8").digest());const g=s.createCachedData();if(!(g.length===0||g.length===e||$>=5)){if(g.length<e){A();return}e=g.length,this._fs.writeFile(p,Buffer.concat([E,g]),v=>{v&&b.getConfig().onError(v),b.getRecorder().record(63,p),A()})}},c*Math.pow(4,$++))};A()}_readSourceAndCachedData(s,d,p,b){if(!d)this._fs.readFile(s,{encoding:"utf8"},b);else{let c,e,$,E=2;const A=g=>{g?b(g):--E===0&&b(void 0,c,e,$)};this._fs.readFile(s,{encoding:"utf8"},(g,v)=>{c=v,A(g)}),this._fs.readFile(d,(g,v)=>{!g&&v&&v.length>0?($=v.slice(0,16),e=v.slice(16),p.record(60,d)):p.record(61,d),A()})}}_verifyCachedData(s,d,p,b,c){b&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(d,"utf8").digest();b.equals(e)||(c.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${p}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(p,$=>{$&&c.getConfig().onError($)}))},Math.ceil(5e3*(1+Math.random()))))}}a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`;function L(u,s){if(s.__$__isRecorded)return s;const d=function(b){u.record(33,b);try{return s(b)}finally{u.record(34,b)}};return d.__$__isRecorded=!0,d}B.ensureRecordedNodeRequire=L;function o(u){return new t(u)}B.createScriptLoader=o})(he||(he={}));var he;(function(B){class t{constructor(u){let s=u.lastIndexOf("/");s!==-1?this.fromModulePath=u.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(u){let s=u,d;for(d=/\/\.\//;d.test(s);)s=s.replace(d,"/");for(s=s.replace(/^\.\//g,""),d=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;d.test(s);)s=s.replace(d,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(u){let s=u;return B.Utilities.isAbsolutePath(s)||(B.Utilities.startsWith(s,"./")||B.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),B.ModuleIdResolver=t;class k{constructor(u,s,d,p,b,c){this.id=u,this.strId=s,this.dependencies=d,this._callback=p,this._errorback=b,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(u,s){try{return{returnedValue:u.apply(B.global,s),producedError:null}}catch(d){return{returnedValue:null,producedError:d}}}static _invokeFactory(u,s,d,p){return u.shouldInvokeFactory(s)?u.shouldCatchError()?this._safeInvokeFunction(d,p):{returnedValue:d.apply(B.global,p),producedError:null}:{returnedValue:null,producedError:null}}complete(u,s,d,p){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);let c=k._invokeFactory(s,this.strId,this._callback,d);b=c.producedError,u.record(22,this.strId),!b&&typeof c.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=c.returnedValue)}else this.exports=this._callback;if(b){let c=B.ensureError(b);c.phase="factory",c.moduleId=this.strId,c.neededBy=p(this.id),this.error=c,s.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1}isComplete(){return this._isComplete}}B.Module=k;class _{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(u){let s=this._strModuleIdToIntModuleId.get(u);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(u,s),this._intModuleIdToStrModuleId[s]=u),s}getStrModuleId(u){return this._intModuleIdToStrModuleId[u]}}class r{constructor(u){this.id=u}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),B.RegularDependency=r;class a{constructor(u,s,d){this.id=u,this.pluginId=s,this.pluginParam=d}}B.PluginDependency=a;class L{constructor(u,s,d,p,b=0){this._env=u,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=d,this._requireFunc=p,this._moduleIdProvider=new _,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(u,s){let d=c=>c.replace(/\\/g,"/"),p=d(u),b=s.split(/\n/);for(let c=0;c<b.length;c++){let e=b[c].match(/(.*):(\d+):(\d+)\)?$/);if(e){let $=e[1],E=e[2],A=e[3],g=Math.max($.lastIndexOf(" ")+1,$.lastIndexOf("(")+1);if($=$.substr(g),$=d($),$===p){let v={line:parseInt(E,10),col:parseInt(A,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+u)}getBuildInfo(){if(!this._config.isBuild())return null;let u=[],s=0;for(let d=0,p=this._modules2.length;d<p;d++){let b=this._modules2[d];if(!b)continue;let c=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,$=this._buildInfoDependencies[b.id];u[s++]={id:b.strId,path:c,defineLocation:c&&e?L._findRelevantLocationInStack(c,e):null,dependencies:$,shim:null,exports:b.exports}}return u}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(u,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let d=null;this._config.isBuild()&&(d=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:d,dependencies:u,callback:s}}defineModule(u,s,d,p,b,c=new t(u)){let e=this._moduleIdProvider.getModuleId(u);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}let $=new k(e,u,this._normalizeDependencies(s,c),d,p,c);this._modules2[e]=$,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=($.dependencies||[]).map(E=>this._moduleIdProvider.getStrModuleId(E.id))),this._resolve($)}_normalizeDependency(u,s){if(u==="exports")return r.EXPORTS;if(u==="module")return r.MODULE;if(u==="require")return r.REQUIRE;let d=u.indexOf("!");if(d>=0){let p=s.resolveModule(u.substr(0,d)),b=s.resolveModule(u.substr(d+1)),c=this._moduleIdProvider.getModuleId(p+"!"+b),e=this._moduleIdProvider.getModuleId(p);return new a(c,e,b)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(u)))}_normalizeDependencies(u,s){let d=[],p=0;for(let b=0,c=u.length;b<c;b++)d[p++]=this._normalizeDependency(u[b],s);return d}_relativeRequire(u,s,d,p){if(typeof s=="string")return this.synchronousRequire(s,u);this.defineModule(B.Utilities.generateAnonymousModule(),s,d,p,null,u)}synchronousRequire(u,s=new t(u)){let d=this._normalizeDependency(u,s),p=this._modules2[d.id];if(!p)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!p.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(p.error)throw p.error;return p.exports}configure(u,s){let d=this._config.shouldRecordStats();s?this._config=new B.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!d&&(this._recorder=null)}getConfig(){return this._config}_onLoad(u){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),s.dependencies,s.callback,null,s.stack)}}_createLoadError(u,s){let d=this._moduleIdProvider.getStrModuleId(u),p=(this._inverseDependencies2[u]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));const b=B.ensureError(s);return b.phase="loading",b.moduleId=d,b.neededBy=p,b}_onLoadError(u,s){const d=this._createLoadError(u,s);this._modules2[u]||(this._modules2[u]=new k(u,this._moduleIdProvider.getStrModuleId(u),[],()=>{},null,null));let p=[];for(let e=0,$=this._moduleIdProvider.getMaxModuleId();e<$;e++)p[e]=!1;let b=!1,c=[];for(c.push(u),p[u]=!0;c.length>0;){let e=c.shift(),$=this._modules2[e];$&&(b=$.onDependencyError(d)||b);let E=this._inverseDependencies2[e];if(E)for(let A=0,g=E.length;A<g;A++){let v=E[A];p[v]||(c.push(v),p[v]=!0)}}b||this._config.onError(d)}_hasDependencyPath(u,s){let d=this._modules2[u];if(!d)return!1;let p=[];for(let c=0,e=this._moduleIdProvider.getMaxModuleId();c<e;c++)p[c]=!1;let b=[];for(b.push(d),p[u]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let $=0,E=e.length;$<E;$++){let A=e[$];if(A.id===s)return!0;let g=this._modules2[A.id];g&&!p[A.id]&&(p[A.id]=!0,b.push(g))}}return!1}_findCyclePath(u,s,d){if(u===s||d===50)return[u];let p=this._modules2[u];if(!p)return null;let b=p.dependencies;if(b)for(let c=0,e=b.length;c<e;c++){let $=this._findCyclePath(b[c].id,s,d+1);if($!==null)return $.push(u),$}return null}_createRequire(u){let s=(d,p,b)=>this._relativeRequire(u,d,p,b);return s.toUrl=d=>this._config.requireToUrl(u.resolveModule(d)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(d,p=!1)=>{this.configure(d,p)},s.__$__nodeRequire=B.global.nodeRequire,s}_loadModule(u){if(this._modules2[u]||this._knownModules2[u])return;this._knownModules2[u]=!0;let s=this._moduleIdProvider.getStrModuleId(u),d=this._config.moduleIdToPaths(s),p=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||p.test(s))&&d.push("node|"+s);let b=-1,c=e=>{if(b++,b>=d.length)this._onLoadError(u,e);else{let $=d[b],E=this.getRecorder();if(this._config.isBuild()&&$==="empty:"){this._buildInfoPath[u]=$,this.defineModule(this._moduleIdProvider.getStrModuleId(u),[],null,null,null),this._onLoad(u);return}E.record(10,$),this._scriptLoader.load(this,$,()=>{this._config.isBuild()&&(this._buildInfoPath[u]=$),E.record(11,$),this._onLoad(u)},A=>{E.record(12,$),c(A)})}};c(null)}_loadPluginDependency(u,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let d=p=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],p,null,null)};d.error=p=>{this._config.onError(this._createLoadError(s.id,p))},u.load(s.pluginParam,this._createRequire(t.ROOT),d,this._config.getOptionsLiteral())}_resolve(u){let s=u.dependencies;if(s)for(let d=0,p=s.length;d<p;d++){let b=s[d];if(b===r.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(b===r.MODULE){u.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){u.unresolvedDependenciesCount--;continue}let c=this._modules2[b.id];if(c&&c.isComplete()){if(c.error){u.onDependencyError(c.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,u.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map($=>this._moduleIdProvider.getStrModuleId($)).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(u.id),b instanceof a){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let $=this._inversePluginDependencies2.get(b.pluginId);$||($=[],this._inversePluginDependencies2.set(b.pluginId,$)),$.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}_onModuleComplete(u){let s=this.getRecorder();if(u.isComplete())return;let d=u.dependencies,p=[];if(d)for(let $=0,E=d.length;$<E;$++){let A=d[$];if(A===r.EXPORTS){p[$]=u.exports;continue}if(A===r.MODULE){p[$]={id:u.strId,config:()=>this._config.getConfigForModule(u.strId)};continue}if(A===r.REQUIRE){p[$]=this._createRequire(u.moduleIdResolver);continue}let g=this._modules2[A.id];if(g){p[$]=g.exports;continue}p[$]=null}const b=$=>(this._inverseDependencies2[$]||[]).map(E=>this._moduleIdProvider.getStrModuleId(E));u.complete(s,this._config,p,b);let c=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,c)for(let $=0,E=c.length;$<E;$++){let A=c[$],g=this._modules2[A];g.unresolvedDependenciesCount--,g.unresolvedDependenciesCount===0&&this._onModuleComplete(g)}let e=this._inversePluginDependencies2.get(u.id);if(e){this._inversePluginDependencies2.delete(u.id);for(let $=0,E=e.length;$<E;$++)this._loadPluginDependency(u.exports,e[$])}}}B.ModuleManager=L})(he||(he={}));var te,he;(function(B){const t=new B.Environment;let k=null;const _=function(o,u,s){typeof o!="string"&&(s=u,u=o,o=null),(typeof u!="object"||!Array.isArray(u))&&(s=u,u=null),u||(u=["require","exports","module"]),o?k.defineModule(o,u,s,null,null):k.enqueueDefineAnonymousModule(u,s)};_.amd={jQuery:!0};const r=function(o,u=!1){k.configure(o,u)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return k.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){k.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=r,a.getConfig=function(){return k.getConfig().getOptionsLiteral()},a.reset=function(){k=k.reset()},a.getBuildInfo=function(){return k.getBuildInfo()},a.getStats=function(){return k.getLoaderEvents()},a.define=_;function L(){if(typeof B.global.require<"u"||typeof require<"u"){const o=B.global.require||require;if(typeof o=="function"&&typeof o.resolve=="function"){const u=B.ensureRecordedNodeRequire(k.getRecorder(),o);B.global.nodeRequire=u,a.nodeRequire=u,a.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=a:(t.isElectronRenderer||(B.global.define=_),B.global.require=a)}B.init=L,(typeof B.global.define!="function"||!B.global.define.amd)&&(k=new B.ModuleManager(t,B.createScriptLoader(t),_,a,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&a.config(B.global.require),te=function(){return _.apply(null,arguments)},te.amd=_.amd,typeof doNotInitLoader>"u"&&L())})(he||(he={})),te(ne[68],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function k(o,u,s,d){if(d=d||{},(d["vs/css"]||{}).disabled){s({});return}const b=u.toUrl(o+".css");_(o,b,()=>{s({})},c=>{typeof s.error=="function"&&s.error("Could not find "+b+".")})}t.load=k;function _(o,u,s,d){if(r(o,u)){s();return}a(o,u,s,d)}function r(o,u){const s=document.getElementsByTagName("link");for(let d=0,p=s.length;d<p;d++){const b=s[d].getAttribute("data-name"),c=s[d].getAttribute("href");if(b===o||c===u)return!0}return!1}function a(o,u,s,d){const p=document.createElement("link");p.setAttribute("rel","stylesheet"),p.setAttribute("type","text/css"),p.setAttribute("data-name",o),L(o,p,s,d),p.setAttribute("href",u),(document.head||document.getElementsByTagName("head")[0]).appendChild(p)}function L(o,u,s,d){const p=()=>{u.removeEventListener("load",b),u.removeEventListener("error",c)},b=e=>{p(),s()},c=e=>{p(),d(e)};u.addEventListener("load",b),u.addEventListener("error",c)}}),te("vs/nls",["require","exports"],function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let k=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const _="i-default";function r(e,$){let E;return $.length===0?E=e:E=e.replace(/\{(\d+)\}/g,(A,g)=>{const v=g[0],f=$[v];let h=A;return typeof f=="string"?h=f:(typeof f=="number"||typeof f=="boolean"||f===void 0||f===null)&&(h=String(f)),h}),k&&(E="\uFF3B"+E.replace(/[aouei]/g,"$&$&")+"\uFF3D"),E}function a(e,$){let E=e[$];return E||(E=e["*"],E)?E:null}function L(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function o(e,$,E){const A=L(e)+L($)+"vscode/"+L(E),g=await fetch(A);if(g.ok)return await g.json();throw new Error(`${g.status} - ${g.statusText}`)}function u(e){return function($,E){const A=Array.prototype.slice.call(arguments,2);return r(e[$],A)}}function s(e,$,...E){return r($,E)}t.localize=s;function d(e){}t.getConfiguredDefaultLocale=d;function p(e){k=e}t.setPseudoTranslation=p;function b(e,$){return{localize:u($[e]),getConfiguredDefaultLocale:$.getConfiguredDefaultLocale??(E=>{})}}t.create=b;function c(e,$,E,A){const g=A["vs/nls"]??{};if(!e||e.length===0)return E({localize:s,getConfiguredDefaultLocale:()=>g.availableLanguages?.["*"]});const v=g.availableLanguages?a(g.availableLanguages,e):null,f=v===null||v===_;let h=".nls";f||(h=h+"."+v);const i=l=>{Array.isArray(l)?l.localize=u(l):l.localize=u(l[e]),l.getConfiguredDefaultLocale=()=>g.availableLanguages?.["*"],E(l)};typeof g.loadBundle=="function"?g.loadBundle(e,v,(l,N)=>{l?$([e+".nls"],i):i(N)}):g.translationServiceUrl&&!f?(async()=>{try{const l=await o(g.translationServiceUrl,v,e);return i(l)}catch(l){if(!v.includes("-"))return console.error(l),$([e+".nls"],i);try{const N=v.split("-")[0],m=await o(g.translationServiceUrl,N,e);return g.availableLanguages??={},g.availableLanguages["*"]=N,i(m)}catch(N){return console.error(N),$([e+".nls"],i)}}})():$([e+h],i,l=>{if(h===".nls"){console.error("Failed trying to load default language strings",l);return}console.error(`Failed to load message bundle for language ${v}. Falling back to the default language:`,l),$([e+".nls"],i)})}t.load=c}),function(){const B=globalThis.MonacoEnvironment,t=B&&B.baseUrl?B.baseUrl:"../../../";function k(d,p){if(B?.createTrustedTypesPolicy)try{return B.createTrustedTypesPolicy(d,p)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(d,p)}catch(b){console.warn(b);return}}const _=k("amdLoader",{createScriptURL:d=>d,createScript:(d,...p)=>{const b=p.slice(0,-1).join(","),c=p.pop().toString();return`(function anonymous(${b}) { ${c}
})`}});function r(){try{return(_?globalThis.eval(_.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function a(){return new Promise((d,p)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return d();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(_?globalThis.eval(_.createScript("",e)):new Function(e)).call(globalThis),d()}).then(void 0,p);return}_?importScripts(_.createScriptURL(b)):importScripts(b),d()})}function L(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:_,amdModulesPattern:/^vs\//})}function o(d){a().then(()=>{L(),require([d],function(p){setTimeout(function(){const b=p.create((c,e)=>{globalThis.postMessage(c,e)},null);for(globalThis.onmessage=c=>b.onmessage(c.data,c.ports);s.length>0;){const c=s.shift();b.onmessage(c.data,c.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&L();let u=!0;const s=[];globalThis.onmessage=d=>{if(!u){s.push(d);return}u=!1,o(d.data)}}(),te(ne[9],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;function k($,E,A){const g=_($,E);if(g!==-1)return $[g]}t.$db=k;function _($,E,A=$.length-1){for(let g=A;g>=0;g--){const v=$[g];if(E(v))return g}return-1}t.$eb=_;function r($,E){const A=a($,E);return A===-1?void 0:$[A]}t.$fb=r;function a($,E,A=0,g=$.length){let v=A,f=g;for(;v<f;){const h=Math.floor((v+f)/2);E($[h])?v=h+1:f=h}return v-1}t.$gb=a;function L($,E){const A=o($,E);return A===$.length?void 0:$[A]}t.$hb=L;function o($,E,A=0,g=$.length){let v=A,f=g;for(;v<f;){const h=Math.floor((v+f)/2);E($[h])?f=h:v=h+1}return v}t.$ib=o;function u($,E,A=0,g=$.length){const v=o($,E,A,g);return v===$.length?-1:v}t.$jb=u;class s{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(s.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!E(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const A=a(this.e,E,this.c);return this.c=A+1,A===-1?void 0:this.e[A]}}t.$kb=s;function d($,E){if($.length===0)return;let A=$[0];for(let g=1;g<$.length;g++){const v=$[g];E(v,A)>0&&(A=v)}return A}t.$lb=d;function p($,E){if($.length===0)return;let A=$[0];for(let g=1;g<$.length;g++){const v=$[g];E(v,A)>=0&&(A=v)}return A}t.$mb=p;function b($,E){return d($,(A,g)=>-E(A,g))}t.$nb=b;function c($,E){if($.length===0)return-1;let A=0;for(let g=1;g<$.length;g++){const v=$[g];E(v,$[A])>0&&(A=g)}return A}t.$ob=c;function e($,E){for(const A of $){const g=E(A);if(g!==void 0)return g}}t.$pb=e}),te(ne[19],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function k(L,o){const u=Object.create(null);for(const s of L){const d=o(s);let p=u[d];p||(p=u[d]=[]),p.push(s)}return u}t.$I=k;function _(L,o){const u=[],s=[];for(const d of L)o.has(d)||u.push(d);for(const d of o)L.has(d)||s.push(d);return{removed:u,added:s}}t.$J=_;function r(L,o){const u=[],s=[];for(const[d,p]of L)o.has(d)||u.push(p);for(const[d,p]of o)L.has(d)||s.push(p);return{removed:u,added:s}}t.$K=r;class a{constructor(){this.a=new Map}add(o,u){let s=this.a.get(o);s||(s=new Set,this.a.set(o,s)),s.add(u)}delete(o,u){const s=this.a.get(o);s&&(s.delete(u),s.size===0&&this.a.delete(o))}forEach(o,u){const s=this.a.get(o);s&&s.forEach(u)}get(o){const u=this.a.get(o);return u||new Set}}t.$L=a}),te(ne[34],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=t.$Ls=t.$Ks=t.$Js=void 0;function k(o,u){const s=Math.pow(10,u);return Math.round(o*s)/s}class _{constructor(u,s,d,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=k(Math.max(Math.min(1,p),0),3)}static equals(u,s){return u.r===s.r&&u.g===s.g&&u.b===s.b&&u.a===s.a}}t.$Js=_;class r{constructor(u,s,d,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=k(Math.max(Math.min(1,s),0),3),this.l=k(Math.max(Math.min(1,d),0),3),this.a=k(Math.max(Math.min(1,p),0),3)}static equals(u,s){return u.h===s.h&&u.s===s.s&&u.l===s.l&&u.a===s.a}static fromRGBA(u){const s=u.r/255,d=u.g/255,p=u.b/255,b=u.a,c=Math.max(s,d,p),e=Math.min(s,d,p);let $=0,E=0;const A=(e+c)/2,g=c-e;if(g>0){switch(E=Math.min(A<=.5?g/(2*A):g/(2-2*A),1),c){case s:$=(d-p)/g+(d<p?6:0);break;case d:$=(p-s)/g+2;break;case p:$=(s-d)/g+4;break}$*=60,$=Math.round($)}return new r($,E,A,b)}static i(u,s,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?u+(s-u)*6*d:d<1/2?s:d<2/3?u+(s-u)*(2/3-d)*6:u}static toRGBA(u){const s=u.h/360,{s:d,l:p,a:b}=u;let c,e,$;if(d===0)c=e=$=p;else{const E=p<.5?p*(1+d):p+d-p*d,A=2*p-E;c=r.i(A,E,s+1/3),e=r.i(A,E,s),$=r.i(A,E,s-1/3)}return new _(Math.round(c*255),Math.round(e*255),Math.round($*255),b)}}t.$Ks=r;class a{constructor(u,s,d,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=k(Math.max(Math.min(1,s),0),3),this.v=k(Math.max(Math.min(1,d),0),3),this.a=k(Math.max(Math.min(1,p),0),3)}static equals(u,s){return u.h===s.h&&u.s===s.s&&u.v===s.v&&u.a===s.a}static fromRGBA(u){const s=u.r/255,d=u.g/255,p=u.b/255,b=Math.max(s,d,p),c=Math.min(s,d,p),e=b-c,$=b===0?0:e/b;let E;return e===0?E=0:b===s?E=((d-p)/e%6+6)%6:b===d?E=(p-s)/e+2:E=(s-d)/e+4,new a(Math.round(E*60),$,b,u.a)}static toRGBA(u){const{h:s,s:d,v:p,a:b}=u,c=p*d,e=c*(1-Math.abs(s/60%2-1)),$=p-c;let[E,A,g]=[0,0,0];return s<60?(E=c,A=e):s<120?(E=e,A=c):s<180?(A=c,g=e):s<240?(A=e,g=c):s<300?(E=e,g=c):s<=360&&(E=c,g=e),E=Math.round((E+$)*255),A=Math.round((A+$)*255),g=Math.round((g+$)*255),new _(E,A,g,b)}}t.$Ls=a;class L{static fromHex(u){return L.Format.CSS.parseHex(u)||L.red}static equals(u,s){return!u&&!s?!0:!u||!s?!1:u.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:a.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof _)this.rgba=u;else if(u instanceof r)this.i=u,this.rgba=r.toRGBA(u);else if(u instanceof a)this.j=u,this.rgba=a.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&_.equals(this.rgba,u.rgba)&&r.equals(this.hsla,u.hsla)&&a.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=L.k(this.rgba.r),s=L.k(this.rgba.g),d=L.k(this.rgba.b),p=.2126*u+.7152*s+.0722*d;return k(p,4)}static k(u){const s=u/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(u){const s=this.getRelativeLuminance(),d=u.getRelativeLuminance();return s>d?(s+.05)/(d+.05):(d+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const s=this.getRelativeLuminance(),d=u.getRelativeLuminance();return s>d}isDarkerThan(u){const s=this.getRelativeLuminance(),d=u.getRelativeLuminance();return s<d}lighten(u){return new L(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new L(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:s,g:d,b:p,a:b}=this.rgba;return new L(new _(s,d,p,b*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new L(new _(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const s=u.rgba,d=this.rgba.a,p=s.a,b=d+p*(1-d);if(b<1e-6)return L.transparent;const c=this.rgba.r*d/b+s.r*p*(1-d)/b,e=this.rgba.g*d/b+s.g*p*(1-d)/b,$=this.rgba.b*d/b+s.b*p*(1-d)/b;return new L(new _(c,e,$,b))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:s,g:d,b:p,a:b}=this.rgba;return new L(new _(u.rgba.r-b*(u.rgba.r-s),u.rgba.g-b*(u.rgba.g-d),u.rgba.b-b*(u.rgba.b-p),1))}flatten(...u){const s=u.reduceRight((d,p)=>L.o(p,d));return L.o(this,s)}static o(u,s){const d=1-u.rgba.a;return new L(new _(d*s.rgba.r+u.rgba.a*u.rgba.r,d*s.rgba.g+u.rgba.a*u.rgba.g,d*s.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=L.Format.CSS.format(this)),this.u}static getLighterColor(u,s,d){if(u.isLighterThan(s))return u;d=d||.5;const p=u.getRelativeLuminance(),b=s.getRelativeLuminance();return d=d*(b-p)/b,u.lighten(d)}static getDarkerColor(u,s,d){if(u.isDarkerThan(s))return u;d=d||.5;const p=u.getRelativeLuminance(),b=s.getRelativeLuminance();return d=d*(p-b)/p,u.darken(d)}static{this.white=new L(new _(255,255,255,1))}static{this.black=new L(new _(0,0,0,1))}static{this.red=new L(new _(255,0,0,1))}static{this.blue=new L(new _(0,0,255,1))}static{this.green=new L(new _(0,255,0,1))}static{this.cyan=new L(new _(0,255,255,1))}static{this.lightgrey=new L(new _(211,211,211,1))}static{this.transparent=new L(new _(0,0,0,0))}}t.$Ms=L,function(o){let u;(function(s){let d;(function(p){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:o.Format.CSS.formatRGBA(i)}p.formatRGB=b;function c(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}p.formatRGBA=c;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:o.Format.CSS.formatHSLA(i)}p.formatHSL=e;function $(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}p.formatHSLA=$;function E(i){const l=i.toString(16);return l.length!==2?"0"+l:l}function A(i){return`#${E(i.rgba.r)}${E(i.rgba.g)}${E(i.rgba.b)}`}p.formatHex=A;function g(i,l=!1){return l&&i.rgba.a===1?o.Format.CSS.formatHex(i):`#${E(i.rgba.r)}${E(i.rgba.g)}${E(i.rgba.b)}${E(Math.round(i.rgba.a*255))}`}p.formatHexA=g;function v(i){return i.isOpaque()?o.Format.CSS.formatHex(i):o.Format.CSS.formatRGBA(i)}p.format=v;function f(i){const l=i.length;if(l===0||i.charCodeAt(0)!==35)return null;if(l===7){const N=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),m=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),w=16*h(i.charCodeAt(5))+h(i.charCodeAt(6));return new o(new _(N,m,w,1))}if(l===9){const N=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),m=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),w=16*h(i.charCodeAt(5))+h(i.charCodeAt(6)),M=16*h(i.charCodeAt(7))+h(i.charCodeAt(8));return new o(new _(N,m,w,M/255))}if(l===4){const N=h(i.charCodeAt(1)),m=h(i.charCodeAt(2)),w=h(i.charCodeAt(3));return new o(new _(16*N+N,16*m+m,16*w+w))}if(l===5){const N=h(i.charCodeAt(1)),m=h(i.charCodeAt(2)),w=h(i.charCodeAt(3)),M=h(i.charCodeAt(4));return new o(new _(16*N+N,16*m+m,16*w+w,(16*M+M)/255))}return null}p.parseHex=f;function h(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=s.CSS||(s.CSS={}))})(u=o.Format||(o.Format={}))}(L||(t.$Ms=L={}))}),te(ne[35],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ls=void 0;class k{constructor(r,a,L,o){this.originalStart=r,this.originalLength=a,this.modifiedStart=L,this.modifiedLength=o}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ls=k}),te(ne[3],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class k{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?v.isErrorNoTelemetry(i)?new v(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$U=k,t.$V=new k;function _(h){t.$V.setUnexpectedErrorHandler(h)}t.setUnexpectedErrorHandler=_;function r(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$X=r;function a(h){s(h)||t.$V.onUnexpectedError(h)}t.$Y=a;function L(h){s(h)||t.$V.onUnexpectedExternalError(h)}t.$Z=L;function o(h){if(h instanceof Error){const{name:i,message:l}=h,N=h.stacktrace||h.stack;return{$isError:!0,name:i,message:l,stack:N,noTelemetry:v.isErrorNoTelemetry(h)}}return h}t.$1=o;const u="Canceled";function s(h){return h instanceof d?!0:h instanceof Error&&h.name===u&&h.message===u}t.$2=s;class d extends Error{constructor(){super(u),this.name=this.message}}t.$3=d;function p(){const h=new Error(u);return h.name=h.message,h}t.$4=p;function b(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}t.$5=b;function c(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}t.$6=c;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$7=e;function $(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}t.$8=$;class E extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$9=E;class A extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$0=A;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=g;class v extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof v)return i;const l=new v;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$_=v;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}t.$ab=f}),te(ne[7],ie([0,1,3,9]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.$5b=t.$4b=t.CompareResult=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.$Eb=t.$Db=t.top=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=t.$qb=void 0;function r(U,V=0){return U[U.length-(1+V)]}t.$qb=r;function a(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$rb=a;function L(U,V,C=(Y,Q)=>Y===Q){if(U===V)return!0;if(!U||!V||U.length!==V.length)return!1;for(let Y=0,Q=U.length;Y<Q;Y++)if(!C(U[Y],V[Y]))return!1;return!0}t.$sb=L;function o(U,V){const C=U.length-1;V<C&&(U[V]=U[C]),U.pop()}t.$tb=o;function u(U,V,C){return s(U.length,Y=>C(U[Y],V))}t.$ub=u;function s(U,V){let C=0,Y=U-1;for(;C<=Y;){const Q=(C+Y)/2|0,le=V(Q);if(le<0)C=Q+1;else if(le>0)Y=Q-1;else return Q}return-(C+1)}t.$vb=s;function d(U,V,C){if(U=U|0,U>=V.length)throw new TypeError("invalid index");const Y=V[Math.floor(V.length*Math.random())],Q=[],le=[],X=[];for(const G of V){const K=C(G,Y);K<0?Q.push(G):K>0?le.push(G):X.push(G)}return U<Q.length?d(U,Q,C):U<Q.length+X.length?X[0]:d(U-(Q.length+X.length),le,C)}t.$wb=d;function p(U,V){const C=[];let Y;for(const Q of U.slice(0).sort(V))!Y||V(Y[0],Q)!==0?(Y=[Q],C.push(Y)):Y.push(Q);return C}t.$xb=p;function*b(U,V){let C,Y;for(const Q of U)Y!==void 0&&V(Y,Q)?C.push(Q):(C&&(yield C),C=[Q]),Y=Q;C&&(yield C)}t.$yb=b;function c(U,V){for(let C=0;C<=U.length;C++)V(C===0?void 0:U[C-1],C===U.length?void 0:U[C])}t.$zb=c;function e(U,V,C){const Y=[];function Q(G,K,ee){if(K===0&&ee.length===0)return;const re=Y[Y.length-1];re&&re.start+re.deleteCount===G?(re.deleteCount+=K,re.toInsert.push(...ee)):Y.push({start:G,deleteCount:K,toInsert:ee})}let le=0,X=0;for(;;){if(le===U.length){Q(le,0,V.slice(X));break}if(X===V.length){Q(le,U.length-le,[]);break}const G=U[le],K=V[X],ee=C(G,K);ee===0?(le+=1,X+=1):ee<0?(Q(le,1,[]),le+=1):ee>0&&(Q(le,0,[K]),X+=1)}return Y}t.$Ab=e;function $(U,V,C){const Y=e(U,V,C),Q=[],le=[];for(const X of Y)Q.push(...U.slice(X.start,X.start+X.deleteCount)),le.push(...X.toInsert);return{removed:Q,added:le}}t.$Bb=$;function E(U,V,C){if(C===0)return[];const Y=U.slice(0,C).sort(V);return g(U,V,Y,C,U.length),Y}t.top=E;function A(U,V,C,Y,Q){return C===0?Promise.resolve([]):new Promise((le,X)=>{(async()=>{const G=U.length,K=U.slice(0,C).sort(V);for(let ee=C,re=Math.min(C+Y,G);ee<G;ee=re,re=Math.min(re+Y,G)){if(ee>C&&await new Promise(ae=>setTimeout(ae)),Q&&Q.isCancellationRequested)throw new k.$3;g(U,V,K,ee,re)}return K})().then(le,X)})}t.$Db=A;function g(U,V,C,Y,Q){for(const le=C.length;Y<Q;Y++){const X=U[Y];if(V(X,C[le-1])<0){C.pop();const G=(0,_.$ib)(C,K=>V(X,K)<0);C.splice(G,0,X)}}}function v(U){return U.filter(V=>!!V)}t.$Eb=v;function f(U){let V=0;for(let C=0;C<U.length;C++)U[C]&&(U[V]=U[C],V+=1);U.length=V}t.$Fb=f;function h(U,V,C){U.splice(C,0,U.splice(V,1)[0])}t.$Gb=h;function i(U){return!Array.isArray(U)||U.length===0}t.$Hb=i;function l(U){return Array.isArray(U)&&U.length>0}t.$Ib=l;function N(U,V=C=>C){const C=new Set;return U.filter(Y=>{const Q=V(Y);return C.has(Q)?!1:(C.add(Q),!0)})}t.$Jb=N;function m(U){const V=new Set;return C=>{const Y=U(C);return V.has(Y)?!1:(V.add(Y),!0)}}t.$Kb=m;function w(U,V){return U.length>0?U[0]:V}t.$Lb=w;function M(U,V){return U.length>0?U[U.length-1]:V}t.$Mb=M;function F(U,V,C=(Y,Q)=>Y===Q){let Y=0;for(let Q=0,le=Math.min(U.length,V.length);Q<le&&C(U[Q],V[Q]);Q++)Y++;return Y}t.$Nb=F;function y(U){return[].concat(...U)}t.$Ob=y;function P(U,V){let C=typeof V=="number"?U:0;typeof V=="number"?C=U:(C=0,V=U);const Y=[];if(C<=V)for(let Q=C;Q<V;Q++)Y.push(Q);else for(let Q=C;Q>V;Q--)Y.push(Q);return Y}t.$Pb=P;function R(U,V,C){return U.reduce((Y,Q)=>(Y[V(Q)]=C?C(Q):Q,Y),Object.create(null))}t.$Qb=R;function I(U,V){return U.push(V),()=>q(U,V)}t.$Rb=I;function q(U,V){const C=U.indexOf(V);if(C>-1)return U.splice(C,1),V}t.$Sb=q;function S(U,V,C){const Y=U.slice(0,V),Q=U.slice(V);return Y.concat(C,Q)}t.$Tb=S;function z(U,V){let C;if(typeof V=="number"){let Y=V;C=()=>{const Q=Math.sin(Y++)*179426549;return Q-Math.floor(Q)}}else C=Math.random;for(let Y=U.length-1;Y>0;Y-=1){const Q=Math.floor(C()*(Y+1)),le=U[Y];U[Y]=U[Q],U[Q]=le}}t.$Ub=z;function D(U,V){const C=U.indexOf(V);C>-1&&(U.splice(C,1),U.unshift(V))}t.$Vb=D;function j(U,V){const C=U.indexOf(V);C>-1&&(U.splice(C,1),U.push(V))}t.$Wb=j;function x(U,V){for(const C of V)U.push(C)}t.$Xb=x;function W(U,V){return Array.isArray(U)?U.map(V):V(U)}t.$Yb=W;function J(U){return Array.isArray(U)?U:[U]}t.$Zb=J;function n(U){return U[Math.floor(Math.random()*U.length)]}t.$1b=n;function ue(U,V,C){const Y=$e(U,V),Q=U.length,le=C.length;U.length=Q+le;for(let X=Q-1;X>=Y;X--)U[X+le]=U[X];for(let X=0;X<le;X++)U[X+Y]=C[X]}t.$2b=ue;function ce(U,V,C,Y){const Q=$e(U,V);let le=U.splice(Q,C);return le===void 0&&(le=[]),ue(U,Q,Y),le}t.$3b=ce;function $e(U,V){return V<0?Math.max(V+U.length,0):Math.min(V,U.length)}var we;(function(U){function V(le){return le<0}U.isLessThan=V;function C(le){return le<=0}U.isLessThanOrEqual=C;function Y(le){return le>0}U.isGreaterThan=Y;function Q(le){return le===0}U.isNeitherLessOrGreaterThan=Q,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(we||(t.CompareResult=we={}));function Le(U,V){return(C,Y)=>V(U(C),U(Y))}t.$4b=Le;function Re(...U){return(V,C)=>{for(const Y of U){const Q=Y(V,C);if(!we.isNeitherLessOrGreaterThan(Q))return Q}return we.neitherLessOrGreaterThan}}t.$5b=Re;const ye=(U,V)=>U-V;t.$6b=ye;const Te=(U,V)=>(0,t.$6b)(U?1:0,V?1:0);t.$7b=Te;function Ie(U){return(V,C)=>-U(V,C)}t.$8b=Ie;class qe{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let C=this.c;for(;C<this.g.length&&V(this.g[C]);)C++;const Y=C===this.c?null:this.g.slice(this.c,C);return this.c=C,Y}takeFromEndWhile(V){let C=this.d;for(;C>=0&&V(this.g[C]);)C--;const Y=C===this.d?null:this.g.slice(C+1,this.d+1);return this.d=C,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const C=this.g.slice(this.c,this.c+V);return this.c+=V,C}}t.$9b=qe;class pe{static{this.empty=new pe(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(C=>(V(C),!0))}toArray(){const V=[];return this.iterate(C=>(V.push(C),!0)),V}filter(V){return new pe(C=>this.iterate(Y=>V(Y)?C(Y):!0))}map(V){return new pe(C=>this.iterate(Y=>C(V(Y))))}some(V){let C=!1;return this.iterate(Y=>(C=V(Y),!C)),C}findFirst(V){let C;return this.iterate(Y=>V(Y)?(C=Y,!1):!0),C}findLast(V){let C;return this.iterate(Y=>(V(Y)&&(C=Y),!0)),C}findLastMaxBy(V){let C,Y=!0;return this.iterate(Q=>((Y||we.isGreaterThan(V(Q,C)))&&(Y=!1,C=Q),!0)),C}}t.$0b=pe}),te(ne[13],ie([0,1,3]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xc=t.$wc=t.$vc=t.$uc=t.ok=void 0;function _(u,s){if(!u)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=_;function r(u,s="Unreachable"){throw new Error(s)}t.$uc=r;function a(u){if(!u)throw new k.$ab("Assertion Failed")}t.$vc=a;function L(u){if(!u()){debugger;u(),(0,k.$Y)(new k.$ab("Assertion Failed"))}}t.$wc=L;function o(u,s){let d=0;for(;d<u.length-1;){const p=u[d],b=u[d+1];if(!s(p,b))return!1;d++}return!0}t.$xc=o}),te(ne[20],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function k(_){const r=this;let a=!1,L;return function(){return a||(a=!0,L=_.apply(r,arguments)),L}}t.$bb=k}),te(ne[21],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(_){function r(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}_.is=r;const a=Object.freeze([]);function L(){return a}_.empty=L;function*o(f){yield f}_.single=o;function u(f){return r(f)?f:o(f)}_.wrap=u;function s(f){return f||a}_.from=s;function d(f){return!f||f[Symbol.iterator]().next().done===!0}_.isEmpty=d;function p(f){return f[Symbol.iterator]().next().value}_.first=p;function b(f,h){for(const i of f)if(h(i))return!0;return!1}_.some=b;function c(f,h){for(const i of f)if(h(i))return i}_.find=c;function*e(f,h){for(const i of f)h(i)&&(yield i)}_.filter=e;function*$(f,h){let i=0;for(const l of f)yield h(l,i++)}_.map=$;function*E(...f){for(const h of f)for(const i of h)yield i}_.concat=E;function A(f,h,i){let l=i;for(const N of f)l=h(l,N);return l}_.reduce=A;function*g(f,h,i=f.length){for(h<0&&(h+=f.length),i<0?i+=f.length:i>f.length&&(i=f.length);h<i;h++)yield f[h]}_.slice=g;function v(f,h=Number.POSITIVE_INFINITY){const i=[];if(h===0)return[i,f];const l=f[Symbol.iterator]();for(let N=0;N<h;N++){const m=l.next();if(m.done)return[i,_.empty()];i.push(m.value)}return[i,{[Symbol.iterator](){return l}}]}_.consume=v})(k||(t.Iterable=k={}))}),te(ne[36],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tq=t.KeyMod=t.KeyCodeUtils=t.$sq=t.$rq=t.$qq=t.$pq=t.$oq=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(_||(t.ScanCode=_={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define($,E){this._keyCodeToStr[$]=E,this._strToKeyCode[E.toLowerCase()]=$}keyCodeToStr($){return this._keyCodeToStr[$]}strToKeyCode($){return this._strToKeyCode[$.toLowerCase()]||0}}const a=new r,L=new r,o=new r;t.$oq=new Array(230),t.$pq={};const u=[],s=Object.create(null),d=Object.create(null);t.$qq={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>s[e]||0,toString:e=>u[e]||"None"},t.$rq=[],t.$sq=[];for(let e=0;e<=193;e++)t.$rq[e]=-1;for(let e=0;e<=132;e++)t.$sq[e]=-1;(function(){const e="",$=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],E=[],A=[];for(const g of $){const[v,f,h,i,l,N,m,w,M]=g;if(A[f]||(A[f]=!0,u[f]=h,s[h]=f,d[h.toLowerCase()]=f,v&&(t.$rq[f]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$sq[i]=f))),!E[i]){if(E[i]=!0,!l)throw new Error(`String representation missing for key code ${i} around scan code ${h}`);a.define(i,l),L.define(i,w||l),o.define(i,M||w||l)}N&&(t.$oq[N]=i),m&&(t.$pq[m]=i)}t.$sq[3]=46})();var p;(function(e){function $(h){return a.keyCodeToStr(h)}e.toString=$;function E(h){return a.strToKeyCode(h)}e.fromString=E;function A(h){return L.keyCodeToStr(h)}e.toUserSettingsUS=A;function g(h){return o.keyCodeToStr(h)}e.toUserSettingsGeneral=g;function v(h){return L.strToKeyCode(h)||o.strToKeyCode(h)}e.fromUserSettings=v;function f(h){if(h>=98&&h<=113)return null;switch(h){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return a.keyCodeToStr(h)}e.toElectronAccelerator=f})(p||(t.KeyCodeUtils=p={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function c(e,$){const E=($&65535)<<16>>>0;return(e|E)>>>0}t.$tq=c}),te(ne[37],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class k{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=k}),te(ne[10],ie([0,1,7,19,20,21]),function(B,t,k,_,r,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.$bc=t.$ac=t.$_b=t.$$b=void 0;const L=!1;let o=null;class u{constructor(){this.b=new Map}static{this.a=0}c(R){let I=this.b.get(R);return I||(I={parent:null,source:null,isSingleton:!1,value:R,idx:u.a++},this.b.set(R,I)),I}trackDisposable(R){const I=this.c(R);I.source||(I.source=new Error().stack)}setParent(R,I){const q=this.c(R);q.parent=I}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,I){const q=I.get(R);if(q)return q;const S=R.parent?this.f(this.c(R.parent),I):R;return I.set(R,S),S}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,q])=>q.source!==null&&!this.f(q,R).isSingleton).map(([q])=>q).flat()}computeLeakingDisposables(R=10,I){let q;if(I)q=I;else{const x=new Map,W=[...this.b.values()].filter(n=>n.source!==null&&!this.f(n,x).isSingleton);if(W.length===0)return;const J=new Set(W.map(n=>n.value));if(q=W.filter(n=>!(n.parent&&J.has(n.parent))),q.length===0)throw new Error("There are cyclic diposable chains!")}if(!q)return;function S(x){function W(n,ue){for(;n.length>0&&ue.some(ce=>typeof ce=="string"?ce===n[0]:n[0].match(ce));)n.shift()}const J=x.source.split(`
`).map(n=>n.trim().replace("at ","")).filter(n=>n!=="");return W(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const z=new _.$L;for(const x of q){const W=S(x);for(let J=0;J<=W.length;J++)z.add(W.slice(0,J).join(`
`),x)}q.sort((0,k.$4b)(x=>x.idx,k.$6b));let D="",j=0;for(const x of q.slice(0,R)){j++;const W=S(x),J=[];for(let n=0;n<W.length;n++){let ue=W[n];ue=`(shared with ${z.get(W.slice(0,n+1).join(`
`)).size}/${q.length} leaks) at ${ue}`;const $e=z.get(W.slice(0,n).join(`
`)),we=(0,_.$I)([...$e].map(Le=>S(Le)[n]),Le=>Le);delete we[W[n]];for(const[Le,Re]of Object.entries(we))J.unshift(`    - stacktraces of ${Re.length} other leaks continue with ${Le}`);J.unshift(ue)}D+=`


==================== Leaking disposable ${j}/${q.length}: ${x.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return q.length>R&&(D+=`


... and ${q.length-R} more leaking disposables

`),{leaks:q,details:D}}}t.$$b=u;function s(P){o=P}if(t.$_b=s,L){const P="__is_disposable_tracked__";s(new class{trackDisposable(R){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[P]||console.log(I)},3e3)}setParent(R,I){if(R&&R!==h.None)try{R[P]=!0}catch{}}markAsDisposed(R){if(R&&R!==h.None)try{R[P]=!0}catch{}}markAsSingleton(R){}})}function d(P){return o?.trackDisposable(P),P}t.$ac=d;function p(P){o?.markAsDisposed(P)}t.$bc=p;function b(P,R){o?.setParent(P,R)}function c(P,R){if(o)for(const I of P)o.setParent(I,R)}function e(P){return o?.markAsSingleton(P),P}t.$cc=e;function $(P){return typeof P.dispose=="function"&&P.dispose.length===0}t.$dc=$;function E(P){if(a.Iterable.is(P)){const R=[];for(const I of P)if(I)try{I.dispose()}catch(q){R.push(q)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}t.$ec=E;function A(P){for(const R of P)$(R)&&R.dispose();return[]}t.$fc=A;function g(...P){const R=v(()=>E(P));return c(P,R),R}t.$gc=g;function v(P){const R=d({dispose:(0,r.$bb)(()=>{p(R),P()})});return R}t.$hc=v;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{E(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return b(R,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}}t.$ic=f;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,d(this),b(this.q,this)}dispose(){p(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}t.$jc=h;class i{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&b(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&b(R,null),R}}t.$kc=i;class l{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$lc=l;class N{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(R){let I=R;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,p(this))},this}}t.$mc=N;class m{constructor(){this.a=new Map}acquire(R,...I){let q=this.a.get(R);q||(q={counter:0,object:this.b(R,...I)},this.a.set(R,q));const{object:S}=q,z=(0,r.$bb)(()=>{--q.counter===0&&(this.c(R,q.object),this.a.delete(R))});return q.counter++,{object:S,dispose:z}}}t.$nc=m;class w{constructor(R){this.a=R}async acquire(R,...I){const q=this.a.acquire(R,...I);try{return{object:await q.object,dispose:()=>q.dispose()}}catch(S){throw q.dispose(),S}}}t.$oc=w;class M{constructor(R){this.object=R}dispose(){}}t.$pc=M;function F(P){const R=new f;try{P(R)}finally{R.dispose()}}t.$qc=F;class y{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{E(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,I,q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),q||this.a.get(R)?.dispose(),this.a.set(R,I)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$rc=y}),te(ne[22],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=void 0;class k{static{this.Undefined=new k(void 0)}constructor(a){this.element=a,this.next=k.Undefined,this.prev=k.Undefined}}class _{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let a=this.a;for(;a!==k.Undefined;){const L=a.next;a.prev=k.Undefined,a.next=k.Undefined,a=L}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(a){return this.d(a,!1)}push(a){return this.d(a,!0)}d(a,L){const o=new k(a);if(this.a===k.Undefined)this.a=o,this.b=o;else if(L){const s=this.b;this.b=o,o.prev=s,s.next=o}else{const s=this.a;this.a=o,o.next=s,s.prev=o}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(o))}}shift(){if(this.a!==k.Undefined){const a=this.a.element;return this.e(this.a),a}}pop(){if(this.b!==k.Undefined){const a=this.b.element;return this.e(this.b),a}}e(a){if(a.prev!==k.Undefined&&a.next!==k.Undefined){const L=a.prev;L.next=a.next,a.next.prev=L}else a.prev===k.Undefined&&a.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):a.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):a.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let a=this.a;for(;a!==k.Undefined;)yield a.element,a=a.next}}t.$sc=_}),te(ne[23],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class _{static create(a){return new _(a)}constructor(a){this.c=k&&a===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ad=_}),te(ne[11],ie([0,1,3,20,10,22,23]),function(B,t,k,_,r,a,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nd=t.$md=t.$ld=t.$kd=t.$jd=t.$id=t.$hd=t.$gd=t.$fd=t.$ed=t.$dd=t.$cd=t.Event=void 0;const o=!1,u=!1;var s;(function(P){P.None=()=>r.$jc.None;function R(X){if(u){const{onDidAddListener:G}=X,K=e.create();let ee=0;X.onDidAddListener=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),G?.()}}}function I(X,G){return ue(X,()=>{},0,void 0,!0,void 0,G)}P.defer=I;function q(X){return(G,K=null,ee)=>{let re=!1,ae;return ae=X(fe=>{if(!re)return ae?ae.dispose():re=!0,G.call(K,fe)},null,ee),re&&ae.dispose(),ae}}P.once=q;function S(X,G,K){return J((ee,re=null,ae)=>X(fe=>ee.call(re,G(fe)),null,ae),K)}P.map=S;function z(X,G,K){return J((ee,re=null,ae)=>X(fe=>{G(fe),ee.call(re,fe)},null,ae),K)}P.forEach=z;function D(X,G,K){return J((ee,re=null,ae)=>X(fe=>G(fe)&&ee.call(re,fe),null,ae),K)}P.filter=D;function j(X){return X}P.signal=j;function x(...X){return(G,K=null,ee)=>{const re=(0,r.$gc)(...X.map(ae=>ae(fe=>G.call(K,fe))));return n(re,ee)}}P.any=x;function W(X,G,K,ee){let re=K;return S(X,ae=>(re=G(re,ae),re),ee)}P.reduce=W;function J(X,G){let K;const ee={onWillAddFirstListener(){K=X(re.fire,re)},onDidRemoveLastListener(){K?.dispose()}};G||R(ee);const re=new v(ee);return G?.add(re),re.event}function n(X,G){return G instanceof Array?G.push(X):G&&G.add(X),X}function ue(X,G,K=100,ee=!1,re=!1,ae,fe){let me,de,Me,ve=0,ke;const Ue={leakWarningThreshold:ae,onWillAddFirstListener(){me=X(je=>{ve++,de=G(de,je),ee&&!Me&&(De.fire(de),de=void 0),ke=()=>{const Oe=de;de=void 0,Me=void 0,(!ee||ve>1)&&De.fire(Oe),ve=0},typeof K=="number"?(clearTimeout(Me),Me=setTimeout(ke,K)):Me===void 0&&(Me=0,queueMicrotask(ke))})},onWillRemoveListener(){re&&ve>0&&ke?.()},onDidRemoveLastListener(){ke=void 0,me.dispose()}};fe||R(Ue);const De=new v(Ue);return fe?.add(De),De.event}P.debounce=ue;function ce(X,G=0,K){return P.debounce(X,(ee,re)=>ee?(ee.push(re),ee):[re],G,void 0,!0,void 0,K)}P.accumulate=ce;function $e(X,G=(ee,re)=>ee===re,K){let ee=!0,re;return D(X,ae=>{const fe=ee||!G(ae,re);return ee=!1,re=ae,fe},K)}P.latch=$e;function we(X,G,K){return[P.filter(X,G,K),P.filter(X,ee=>!G(ee),K)]}P.split=we;function Le(X,G=!1,K=[],ee){let re=K.slice(),ae=X(de=>{re?re.push(de):me.fire(de)});ee&&ee.add(ae);const fe=()=>{re?.forEach(de=>me.fire(de)),re=null},me=new v({onWillAddFirstListener(){ae||(ae=X(de=>me.fire(de)),ee&&ee.add(ae))},onDidAddFirstListener(){re&&(G?setTimeout(fe):fe())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return ee&&ee.add(me),me.event}P.buffer=Le;function Re(X,G){return(ee,re,ae)=>{const fe=G(new Te);return X(function(me){const de=fe.evaluate(me);de!==ye&&ee.call(re,de)},void 0,ae)}}P.chain=Re;const ye=Symbol("HaltChainable");class Te{constructor(){this.f=[]}map(G){return this.f.push(G),this}forEach(G){return this.f.push(K=>(G(K),K)),this}filter(G){return this.f.push(K=>G(K)?K:ye),this}reduce(G,K){let ee=K;return this.f.push(re=>(ee=G(ee,re),ee)),this}latch(G=(K,ee)=>K===ee){let K=!0,ee;return this.f.push(re=>{const ae=K||!G(re,ee);return K=!1,ee=re,ae?re:ye}),this}evaluate(G){for(const K of this.f)if(G=K(G),G===ye)break;return G}}function Ie(X,G,K=ee=>ee){const ee=(...me)=>fe.fire(K(...me)),re=()=>X.on(G,ee),ae=()=>X.removeListener(G,ee),fe=new v({onWillAddFirstListener:re,onDidRemoveLastListener:ae});return fe.event}P.fromNodeEventEmitter=Ie;function qe(X,G,K=ee=>ee){const ee=(...me)=>fe.fire(K(...me)),re=()=>X.addEventListener(G,ee),ae=()=>X.removeEventListener(G,ee),fe=new v({onWillAddFirstListener:re,onDidRemoveLastListener:ae});return fe.event}P.fromDOMEventEmitter=qe;function pe(X){return new Promise(G=>q(X)(G))}P.toPromise=pe;function U(X){const G=new v;return X.then(K=>{G.fire(K)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}P.fromPromise=U;function V(X,G){return G(void 0),X(K=>G(K))}P.runAndSubscribe=V;function C(X,G){let K=null;function ee(ae){K?.dispose(),K=new r.$ic,G(ae,K)}ee(void 0);const re=X(ae=>ee(ae));return(0,r.$hc)(()=>{re.dispose(),K?.dispose()})}P.runAndSubscribeWithStore=C;class Y{constructor(G,K){this._observable=G,this.f=0,this.g=!1;const ee={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};K||R(ee),this.emitter=new v(ee),K&&K.add(this.emitter)}beginUpdate(G){this.f++}handlePossibleChange(G){}handleChange(G,K){this.g=!0}endUpdate(G){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Q(X,G){return new Y(X,G).emitter.event}P.fromObservable=Q;function le(X){return G=>{let K=0,ee=!1;const re={beginUpdate(){K++},endUpdate(){K--,K===0&&(X.reportChanges(),ee&&(ee=!1,G()))},handlePossibleChange(){},handleChange(){ee=!0}};return X.addObserver(re),X.reportChanges(),{dispose(){X.removeObserver(re)}}}}P.fromObservableLight=le})(s||(t.Event=s={}));class d{static{this.all=new Set}static{this.f=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${d.f++}`,d.all.add(this)}start(R){this.g=new L.$ad,this.listenerCount=R}stop(){if(this.g){const R=this.g.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this.g=void 0}}}t.$cd=d;let p=-1;function b(P){const R=p;return p=P,{dispose(){p=R}}}t.$dd=b;class c{constructor(R,I=Math.random().toString(18).slice(2,5)){this.threshold=R,this.name=I,this.g=0}dispose(){this.f?.clear()}check(R,I){const q=this.threshold;if(q<=0||I<q)return;this.f||(this.f=new Map);const S=this.f.get(R.value)||0;if(this.f.set(R.value,S+1),this.g-=1,this.g<=0){this.g=q*.5;let z,D=0;for(const[j,x]of this.f)(!z||D<x)&&(z=j,D=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${D}):`),console.warn(z)}return()=>{const z=this.f.get(R.value)||0;this.f.set(R.value,z-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let $=0;class E{constructor(R){this.value=R,this.id=$++}}const A=2,g=(P,R)=>{if(P instanceof E)R(P);else for(let I=0;I<P.length;I++){const q=P[I];q&&R(q)}};class v{constructor(R){this.w=0,this.f=R,this.g=p>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(o){const R=this.t;queueMicrotask(()=>{g(R,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(R,I,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$jc.None;if(this.m)return r.$jc.None;I&&(R=R.bind(I));const S=new E(R);let z,D;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(S.stack=e.create(),z=this.g.check(S.stack,this.w+1)),o&&(S.stack=D??e.create()),this.t?this.t instanceof E?(this.u??=new h,this.t=[this.t,S]):this.t.push(S):(this.f?.onWillAddFirstListener?.(this),this.t=S,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,r.$hc)(()=>{z?.(),this.x(S)});return q instanceof r.$ic?q.add(j):Array.isArray(q)&&q.push(j),j},this.q}x(R){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,q=I.indexOf(R);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[q]=void 0;const S=this.u.current===this;if(this.w*A<=I.length){let z=0;for(let D=0;D<I.length;D++)I[D]?I[z++]=I[D]:S&&(this.u.end--,z<this.u.i&&this.u.i--);I.length=z}}y(R,I){if(!R)return;const q=this.f?.onListenerError||k.$Y;if(!q){R.value(I);return}try{R.value(I)}catch(S){q(S)}}z(R){const I=R.current.t;for(;R.i<R.end;)this.y(I[R.i++],R.value);R.reset()}fire(R){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof E)this.y(this.t,R);else{const I=this.u;I.enqueue(this,R,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}t.$ed=v;const f=()=>new h;t.$fd=f;class h{constructor(){this.i=-1,this.end=0}enqueue(R,I,q){this.i=0,this.end=q,this.current=R,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends v{async fireAsync(R,I,q){if(this.t)for(this.h||(this.h=new a.$sc),g(this.t,S=>this.h.push([S.value,R]));this.h.size>0&&!I.isCancellationRequested;){const[S,z]=this.h.shift(),D=[],j={...z,token:I,waitUntil:x=>{if(Object.isFrozen(D))throw new Error("waitUntil can NOT be called asynchronous");q&&(x=q(x,S)),D.push(x)}};try{S(j)}catch(x){(0,k.$Y)(x);continue}Object.freeze(D),await Promise.allSettled(D).then(x=>{for(const W of x)W.status==="rejected"&&(0,k.$Y)(W.reason)})}}}t.$gd=i;class l extends v{get isPaused(){return this.h!==0}constructor(R){super(R),this.h=0,this.s=new a.$sc,this.A=R?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const R=Array.from(this.s);this.s.clear(),super.fire(this.A(R))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(R){this.w&&(this.h!==0?this.s.push(R):super.fire(R))}}t.$hd=l;class N extends l{constructor(R){super(R),this.k=R.delay??100}fire(R){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(R)}}t.$id=N;class m extends v{constructor(R){super(R),this.h=[],this.k=R?.merge}fire(R){this.hasListeners()&&(this.h.push(R),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}t.$jd=m;class w{constructor(){this.g=!1,this.h=[],this.f=new v({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(R){const I={event:R,listener:null};this.h.push(I),this.g&&this.m(I);const q=()=>{this.g&&this.o(I);const S=this.h.indexOf(I);this.h.splice(S,1)};return(0,r.$hc)((0,_.$bb)(q))}j(){this.g=!0,this.h.forEach(R=>this.m(R))}k(){this.g=!1,this.h.forEach(R=>this.o(R))}m(R){R.listener=R.event(I=>this.f.fire(I))}o(R){R.listener&&R.listener.dispose(),R.listener=null}dispose(){this.f.dispose()}}t.$kd=w;class M{constructor(R,I,q,S){this.f=new r.$ic;const z=this.f.add(new w),D=this.f.add(new r.$rc);function j(x){D.set(x,z.add(S(x)))}for(const x of R)j(x);this.f.add(I(x=>{j(x)})),this.f.add(q(x=>{D.deleteAndDispose(x)})),this.event=z.event}dispose(){this.f.dispose()}}t.$ld=M;class F{constructor(){this.f=[]}wrapEvent(R){return(I,q,S)=>R(z=>{const D=this.f[this.f.length-1];D?D.push(()=>I.call(q,z)):I.call(q,z)},void 0,S)}bufferEvents(R){const I=[];this.f.push(I);const q=R();return this.f.pop(),I.forEach(S=>S()),q}}t.$md=F;class y{constructor(){this.f=!1,this.g=s.None,this.h=r.$jc.None,this.j=new v({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(R){this.g=R,this.f&&(this.h.dispose(),this.h=R(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$nd=y}),te(ne[24],ie([0,1,11]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$od=t.CancellationToken=void 0;const _=Object.freeze(function(o,u){const s=setTimeout(o.bind(u),0);return{dispose(){clearTimeout(s)}}});var r;(function(o){function u(s){return s===o.None||s===o.Cancelled||s instanceof a?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}o.isCancellationToken=u,o.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),o.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(r||(t.CancellationToken=r={}));class a{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?_:(this.b||(this.b=new k.$ed),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new a),this.f}cancel(){this.f?this.f instanceof a&&this.f.cancel():this.f=r.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof a&&this.f.dispose():this.f=r.None}}t.$od=L}),te(ne[38],ie([0,1,24]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=t.$he=t.$ge=void 0;class _{constructor(o){this.b=o,this.a=null}get(){if(this.a)return this.a;const o=new k.$od,u=this.b(o.token);return this.a={promise:u,dispose:()=>{this.a=null,o.cancel(),o.dispose()}},this.a}}t.$ge=_;class r{constructor(o){this.c=o,this.a=void 0,this.b=void 0}get(o){const u=JSON.stringify(o);return this.b!==u&&(this.b=u,this.a=this.c(o)),this.a}}t.$he=r;class a{get cachedValues(){return this.a}constructor(o){this.b=o,this.a=new Map}get(o){if(this.a.has(o))return this.a.get(o);const u=this.b(o);return this.a.set(o,u),u}}t.$ie=a}),te(ne[6],ie([0,1,38,37]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hf=t.$gf=t.$ff=t.$ef=t.GraphemeBreakType=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=void 0;function r(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.$le=r;const a=/{(\d+)}/g;function L(T,...O){return O.length===0?T:T.replace(a,function(H,Z){const se=parseInt(Z,10);return isNaN(se)||se<0||se>=O.length?H:O[se]})}t.$me=L;const o=/{([^}]+)}/g;function u(T,O){return T.replace(o,(H,Z)=>O[Z]??H)}t.$ne=u;function s(T){return T.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}t.$oe=s;function d(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$pe=d;function p(T,O){let H=0;const Z=O.charCodeAt(0);for(let se=T.length-1;se>=0;se--)T.charCodeAt(se)===Z&&H++;return H}t.$qe=p;function b(T,O,H="\u2026"){return T.length<=O?T:`${T.substr(0,O)}${H}`}t.$re=b;function c(T,O=" "){const H=e(T,O);return $(H,O)}t.$se=c;function e(T,O){if(!T||!O)return T;const H=O.length;if(H===0||T.length===0)return T;let Z=0;for(;T.indexOf(O,Z)===Z;)Z=Z+H;return T.substring(Z)}t.$te=e;function $(T,O){if(!T||!O)return T;const H=O.length,Z=T.length;if(H===0||Z===0)return T;let se=Z,oe=-1;for(;oe=T.lastIndexOf(O,se-1),!(oe===-1||oe+H!==se);){if(oe===0)return"";se=oe}return T.substring(0,se)}t.$ue=$;function E(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$ve=E;function A(T){return T.replace(/\*/g,"")}t.$we=A;function g(T,O,H={}){if(!T)throw new Error("Cannot create regex from empty string");O||(T=d(T)),H.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Z="";return H.global&&(Z+="g"),H.matchCase||(Z+="i"),H.multiline&&(Z+="m"),H.unicode&&(Z+="u"),new RegExp(T,Z)}t.$xe=g;function v(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.$ye=v;function f(T){return T.split(/\r\n|\r|\n/)}t.$ze=f;function h(T){for(let O=0,H=T.length;O<H;O++){const Z=T.charCodeAt(O);if(Z!==32&&Z!==9)return O}return-1}t.$Ae=h;function i(T,O=0,H=T.length){for(let Z=O;Z<H;Z++){const se=T.charCodeAt(Z);if(se!==32&&se!==9)return T.substring(O,Z)}return T.substring(O,H)}t.$Be=i;function l(T,O=T.length-1){for(let H=O;H>=0;H--){const Z=T.charCodeAt(H);if(Z!==32&&Z!==9)return H}return-1}t.$Ce=l;function N(T,O,H){const Z=[];let se=0;for(const oe of T.matchAll(O)){if(Z.push(T.slice(se,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");se=oe.index+oe[0].length,Z.push(H(oe[0],...oe.slice(1),oe.index,T,oe.groups))}return Z.push(T.slice(se)),Promise.all(Z).then(oe=>oe.join(""))}t.$De=N;function m(T,O){return T<O?-1:T>O?1:0}t.$Ee=m;function w(T,O,H=0,Z=T.length,se=0,oe=O.length){for(;H<Z&&se<oe;H++,se++){const Ne=T.charCodeAt(H),Ae=O.charCodeAt(se);if(Ne<Ae)return-1;if(Ne>Ae)return 1}const ge=Z-H,Fe=oe-se;return ge<Fe?-1:ge>Fe?1:0}t.$Fe=w;function M(T,O){return F(T,O,0,T.length,0,O.length)}t.$Ge=M;function F(T,O,H=0,Z=T.length,se=0,oe=O.length){for(;H<Z&&se<oe;H++,se++){let Ne=T.charCodeAt(H),Ae=O.charCodeAt(se);if(Ne===Ae)continue;if(Ne>=128||Ae>=128)return w(T.toLowerCase(),O.toLowerCase(),H,Z,se,oe);P(Ne)&&(Ne-=32),P(Ae)&&(Ae-=32);const be=Ne-Ae;if(be!==0)return be}const ge=Z-H,Fe=oe-se;return ge<Fe?-1:ge>Fe?1:0}t.$He=F;function y(T){return T>=48&&T<=57}t.$Ie=y;function P(T){return T>=97&&T<=122}t.$Je=P;function R(T){return T>=65&&T<=90}t.$Ke=R;function I(T,O){return T.length===O.length&&F(T,O)===0}t.$Le=I;function q(T,O){const H=O.length;return O.length>T.length?!1:F(T,O,0,H)===0}t.$Me=q;function S(T,O){const H=Math.min(T.length,O.length);let Z;for(Z=0;Z<H;Z++)if(T.charCodeAt(Z)!==O.charCodeAt(Z))return Z;return H}t.$Ne=S;function z(T,O){const H=Math.min(T.length,O.length);let Z;const se=T.length-1,oe=O.length-1;for(Z=0;Z<H;Z++)if(T.charCodeAt(se-Z)!==O.charCodeAt(oe-Z))return Z;return H}t.$Oe=z;function D(T){return 55296<=T&&T<=56319}t.$Pe=D;function j(T){return 56320<=T&&T<=57343}t.$Qe=j;function x(T,O){return(T-55296<<10)+(O-56320)+65536}t.$Re=x;function W(T,O,H){const Z=T.charCodeAt(H);if(D(Z)&&H+1<O){const se=T.charCodeAt(H+1);if(j(se))return x(Z,se)}return Z}t.$Se=W;function J(T,O){const H=T.charCodeAt(O-1);if(j(H)&&O>1){const Z=T.charCodeAt(O-2);if(D(Z))return x(Z,H)}return H}class n{get offset(){return this.e}constructor(O,H=0){this.c=O,this.d=O.length,this.e=H}setOffset(O){this.e=O}prevCodePoint(){const O=J(this.c,this.e);return this.e-=O>=65536?2:1,O}nextCodePoint(){const O=W(this.c,this.d,this.e);return this.e+=O>=65536?2:1,O}eol(){return this.e>=this.d}}t.$Te=n;class ue{get offset(){return this.c.offset}constructor(O,H=0){this.c=new n(O,H)}nextGraphemeLength(){const O=ve.getInstance(),H=this.c,Z=H.offset;let se=O.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const oe=H.offset,ge=O.getGraphemeBreakType(H.nextCodePoint());if(de(se,ge)){H.setOffset(oe);break}se=ge}return H.offset-Z}prevGraphemeLength(){const O=ve.getInstance(),H=this.c,Z=H.offset;let se=O.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const oe=H.offset,ge=O.getGraphemeBreakType(H.prevCodePoint());if(de(ge,se)){H.setOffset(oe);break}se=ge}return Z-H.offset}eol(){return this.c.eol()}}t.$Ue=ue;function ce(T,O){return new ue(T,O).nextGraphemeLength()}t.$Ve=ce;function $e(T,O){return new ue(T,O).prevGraphemeLength()}t.$We=$e;function we(T,O){O>0&&j(T.charCodeAt(O))&&O--;const H=O+ce(T,O);return[H-$e(T,H),H]}t.$Xe=we;function Le(T){const O=new ue(T);let H=0;for(;!O.eol();)H++,O.nextGraphemeLength();return H}t.$Ye=Le;let Re;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Te(T){return Re||(Re=ye()),Re.test(T)}t.$Ze=Te;const Ie=/^[\t\n\r\x20-\x7E]*$/;function qe(T){return Ie.test(T)}t.$1e=qe,t.$2e=/[\u2028\u2029]/;function pe(T){return t.$2e.test(T)}t.$3e=pe;function U(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.$4e=U;function V(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.$5e=V;function C(T,O){if(T.length<O)return T;const H=/\b/g;let Z=0;for(;H.test(T)&&!(T.length-H.lastIndex<O);)Z=H.lastIndex,H.lastIndex+=1;return T.substring(Z).replace(/^\s/,"")}t.$6e=C;const Y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Q=/\x1b\].*?\x07/g;function le(T){return T&&(T=T.replace(Y,"").replace(Q,"")),T}t.$7e=le,t.$8e=String.fromCharCode(65279);function X(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.$9e=X;function G(T){return X(T)?T.substr(1):T}t.$0e=G;function K(T,O){if(!T||!O||T.length<O.length)return!1;const H=O.length,Z=T.toLowerCase();let se=0,oe=-1;for(;se<H;){const ge=Z.indexOf(O[se],oe+1);if(ge<0)return!1;oe=ge,se++}return!0}t.$$e=K;function ee(T,O=!1){return T?(O&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.$_e=ee;function re(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.$af=re;function ae(T,O=1){if(O===0)return"";let H=-1;do H=T.indexOf(`
`,H+1),O--;while(O>0&&H>=0);return H===-1?T:(T[H-1]==="\r"&&H--,T.substr(0,H))}t.$bf=ae;function fe(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.$cf=fe;function me(T){return ve.getInstance().getGraphemeBreakType(T)}t.$df=me;function de(T,O){return T===0?O!==5&&O!==7:T===2&&O===3?!1:T===4||T===2||T===3||O===4||O===2||O===3?!0:!(T===8&&(O===8||O===9||O===11||O===12)||(T===11||T===9)&&(O===9||O===10)||(T===12||T===10)&&O===10||O===5||O===13||O===7||T===1||T===13&&O===14||T===6&&O===6)}var Me;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(t.GraphemeBreakType=Me={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=ke()}getGraphemeBreakType(O){if(O<32)return O===10?3:O===13?2:4;if(O<127)return 0;const H=this.d,Z=H.length/3;let se=1;for(;se<=Z;)if(O<H[3*se])se=2*se;else if(O>H[3*se+1])se=2*se+1;else return H[3*se+2];return 0}}function ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(T,O){if(T===0)return 0;const H=De(T,O);if(H!==void 0)return H;const Z=new n(O,T);return Z.prevCodePoint(),Z.offset}t.$ef=Ue;function De(T,O){const H=new n(O,T);let Z=H.prevCodePoint();for(;je(Z)||Z===65039||Z===8419;){if(H.offset===0)return;Z=H.prevCodePoint()}if(!V(Z))return;let se=H.offset;return se>0&&H.prevCodePoint()===8205&&(se=H.offset),se}function je(T){return 127995<=T&&T<=127999}var Oe;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),t.$ff="\xA0";class _e{static{this.c=new _.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$he(O=>{function H(be){const Pe=new Map;for(let Ee=0;Ee<be.length;Ee+=2)Pe.set(be[Ee],be[Ee+1]);return Pe}function Z(be,Pe){const Ee=new Map(be);for(const[Be,Ve]of Pe)Ee.set(Be,Ve);return Ee}function se(be,Pe){if(!be)return Pe;const Ee=new Map;for(const[Be,Ve]of be)Pe.has(Be)&&Ee.set(Be,Ve);return Ee}const oe=this.c.value;let ge=O.filter(be=>!be.startsWith("_")&&be in oe);ge.length===0&&(ge=["_default"]);let Fe;for(const be of ge){const Pe=H(oe[be]);Fe=se(Fe,Pe)}const Ne=H(oe._common),Ae=Z(Ne,Fe);return new _e(Ae)})}static getInstance(O){return _e.d.get(Array.from(O))}static{this.e=new _.$T(()=>Object.keys(_e.c.value).filter(O=>!O.startsWith("_")))}static getLocales(){return _e.e.value}constructor(O){this.f=O}isAmbiguous(O){return this.f.has(O)}getPrimaryConfusable(O){return this.f.get(O)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$gf=_e;class Se{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Se.c())),this.d}static isInvisibleCharacter(O){return Se.e().has(O)}static get codePoints(){return Se.e()}}t.$hf=Se}),te(ne[39],ie([0,1,6]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ui=t.$ti=t.$si=t.$ri=t.$qi=t.$pi=t.$oi=void 0;function _(A){return r(A,0)}t.$oi=_;function r(A,g){switch(typeof A){case"object":return A===null?a(349,g):Array.isArray(A)?u(A,g):s(A,g);case"string":return o(A,g);case"boolean":return L(A,g);case"number":return a(A,g);case"undefined":return a(937,g);default:return a(617,g)}}t.$pi=r;function a(A,g){return(g<<5)-g+A|0}t.$qi=a;function L(A,g){return a(A?433:863,g)}function o(A,g){g=a(149417,g);for(let v=0,f=A.length;v<f;v++)g=a(A.charCodeAt(v),g);return g}t.$ri=o;function u(A,g){return g=a(104579,g),A.reduce((v,f)=>r(f,v),g)}function s(A,g){return g=a(181387,g),Object.keys(A).sort().reduce((v,f)=>(v=o(f,v),r(A[f],v)),g)}class d{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=r(g,this.g),this.g}}t.$si=d;var p;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function b(A,g,v=32){const f=v-g,h=~((1<<f)-1);return(A<<g|(h&A)>>>f)>>>0}function c(A,g=0,v=A.byteLength,f=0){for(let h=0;h<v;h++)A[g+h]=f}function e(A,g,v="0"){for(;A.length<g;)A=v+A;return A}function $(A,g=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((A>>>0).toString(16),g/4)}t.$ti=$;class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const v=g.length;if(v===0)return;const f=this.p;let h=this.r,i=this.u,l,N;for(i!==0?(l=i,N=-1,i=0):(l=g.charCodeAt(0),N=0);;){let m=l;if(k.$Pe(l))if(N+1<v){const w=g.charCodeAt(N+1);k.$Qe(w)?(N++,m=k.$Re(l,w)):m=65533}else{i=l;break}else k.$Qe(l)&&(m=65533);if(h=this.w(f,h,m),N++,N<v)l=g.charCodeAt(N);else break}this.r=h,this.u=i}w(g,v,f){return f<128?g[v++]=f:f<2048?(g[v++]=192|(f&1984)>>>6,g[v++]=128|(f&63)>>>0):f<65536?(g[v++]=224|(f&61440)>>>12,g[v++]=128|(f&4032)>>>6,g[v++]=128|(f&63)>>>0):(g[v++]=240|(f&1835008)>>>18,g[v++]=128|(f&258048)>>>12,g[v++]=128|(f&4032)>>>6,g[v++]=128|(f&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),$(this.h)+$(this.l)+$(this.m)+$(this.n)+$(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=E.g,v=this.q;for(let F=0;F<64;F+=4)g.setUint32(F,v.getUint32(F,!1),!1);for(let F=64;F<320;F+=4)g.setUint32(F,b(g.getUint32(F-12,!1)^g.getUint32(F-32,!1)^g.getUint32(F-56,!1)^g.getUint32(F-64,!1),1),!1);let f=this.h,h=this.l,i=this.m,l=this.n,N=this.o,m,w,M;for(let F=0;F<80;F++)F<20?(m=h&i|~h&l,w=1518500249):F<40?(m=h^i^l,w=1859775393):F<60?(m=h&i|h&l|i&l,w=2400959708):(m=h^i^l,w=3395469782),M=b(f,5)+m+N+w+g.getUint32(F*4,!1)&4294967295,N=l,l=i,i=b(h,30),h=f,f=M;this.h=this.h+f&4294967295,this.l=this.l+h&4294967295,this.m=this.m+i&4294967295,this.n=this.n+l&4294967295,this.o=this.o+N&4294967295}}t.$ui=E}),te(ne[25],ie([0,1,35,39]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$os=t.$ns=t.$ms=void 0;class r{constructor(b){this.a=b}getElements(){const b=this.a,c=new Int32Array(b.length);for(let e=0,$=b.length;e<$;e++)c[e]=b.charCodeAt(e);return c}}t.$ms=r;function a(p,b,c){return new d(new r(p),new r(b)).ComputeDiff(c).changes}t.$ns=a;class L{static Assert(b,c){if(!b)throw new Error(c)}}class o{static Copy(b,c,e,$,E){for(let A=0;A<E;A++)e[$+A]=b[c+A]}static Copy2(b,c,e,$,E){for(let A=0;A<E;A++)e[$+A]=b[c+A]}}var u;(function(p){p[p.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new k.$ls(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,c){this.b=Math.min(this.b,b),this.c=Math.min(this.c,c),this.d++}AddModifiedElement(b,c){this.b=Math.min(this.b,b),this.c=Math.min(this.c,c),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class d{constructor(b,c,e=null){this.a=e,this.b=b,this.c=c;const[$,E,A]=d.o(b),[g,v,f]=d.o(c);this.d=A&&f,this.e=$,this.f=E,this.g=g,this.h=v,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const c=b.getElements();if(d.n(c)){const e=new Int32Array(c.length);for(let $=0,E=c.length;$<E;$++)e[$]=(0,_.$ri)(c[$],0);return[c,e,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}p(b,c){return this.f[b]!==this.h[c]?!1:this.d?this.e[b]===this.g[c]:!0}q(b,c){if(!this.p(b,c))return!1;const e=d.r(this.b,b),$=d.r(this.c,c);return e===$}static r(b,c){return typeof b.getStrictElement=="function"?b.getStrictElement(c):null}s(b,c){return this.f[b]!==this.f[c]?!1:this.d?this.e[b]===this.e[c]:!0}u(b,c){return this.h[b]!==this.h[c]?!1:this.d?this.g[b]===this.g[c]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,c,e,$,E){const A=[!1];let g=this.w(b,c,e,$,A);return E&&(g=this.z(g)),{quitEarly:A[0],changes:g}}w(b,c,e,$,E){for(E[0]=!1;b<=c&&e<=$&&this.p(b,e);)b++,e++;for(;c>=b&&$>=e&&this.p(c,$);)c--,$--;if(b>c||e>$){let i;return e<=$?(L.Assert(b===c+1,"originalStart should only be one more than originalEnd"),i=[new k.$ls(b,0,e,$-e+1)]):b<=c?(L.Assert(e===$+1,"modifiedStart should only be one more than modifiedEnd"),i=[new k.$ls(b,c-b+1,e,0)]):(L.Assert(b===c+1,"originalStart should only be one more than originalEnd"),L.Assert(e===$+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const A=[0],g=[0],v=this.y(b,c,e,$,A,g,E),f=A[0],h=g[0];if(v!==null)return v;if(!E[0]){const i=this.w(b,f,e,h,E);let l=[];return E[0]?l=[new k.$ls(f+1,c-(f+1)+1,h+1,$-(h+1)+1)]:l=this.w(f+1,c,h+1,$,E),this.H(i,l)}return[new k.$ls(b,c-b+1,e,$-e+1)]}x(b,c,e,$,E,A,g,v,f,h,i,l,N,m,w,M,F,y){let P=null,R=null,I=new s,q=c,S=e,z=N[0]-M[0]-$,D=-1073741824,j=this.k.length-1;do{const x=z+b;x===q||x<S&&f[x-1]<f[x+1]?(i=f[x+1],m=i-z-$,i<D&&I.MarkNextChange(),D=i,I.AddModifiedElement(i+1,m),z=x+1-b):(i=f[x-1]+1,m=i-z-$,i<D&&I.MarkNextChange(),D=i-1,I.AddOriginalElement(i,m+1),z=x-1-b),j>=0&&(f=this.k[j],b=f[0],q=1,S=f.length-1)}while(--j>=-1);if(P=I.getReverseChanges(),y[0]){let x=N[0]+1,W=M[0]+1;if(P!==null&&P.length>0){const J=P[P.length-1];x=Math.max(x,J.getOriginalEnd()),W=Math.max(W,J.getModifiedEnd())}R=[new k.$ls(x,l-x+1,W,w-W+1)]}else{I=new s,q=A,S=g,z=N[0]-M[0]-v,D=1073741824,j=F?this.m.length-1:this.m.length-2;do{const x=z+E;x===q||x<S&&h[x-1]>=h[x+1]?(i=h[x+1]-1,m=i-z-v,i>D&&I.MarkNextChange(),D=i+1,I.AddOriginalElement(i+1,m+1),z=x+1-E):(i=h[x-1],m=i-z-v,i>D&&I.MarkNextChange(),D=i,I.AddModifiedElement(i+1,m+1),z=x-1-E),j>=0&&(h=this.m[j],E=h[0],q=1,S=h.length-1)}while(--j>=-1);R=I.getChanges()}return this.H(P,R)}y(b,c,e,$,E,A,g){let v=0,f=0,h=0,i=0,l=0,N=0;b--,e--,E[0]=0,A[0]=0,this.k=[],this.m=[];const m=c-b+($-e),w=m+1,M=new Int32Array(w),F=new Int32Array(w),y=$-e,P=c-b,R=b-e,I=c-$,S=(P-y)%2===0;M[y]=b,F[P]=c,g[0]=!1;for(let z=1;z<=m/2+1;z++){let D=0,j=0;h=this.J(y-z,z,y,w),i=this.J(y+z,z,y,w);for(let W=h;W<=i;W+=2){W===h||W<i&&M[W-1]<M[W+1]?v=M[W+1]:v=M[W-1]+1,f=v-(W-y)-R;const J=v;for(;v<c&&f<$&&this.p(v+1,f+1);)v++,f++;if(M[W]=v,v+f>D+j&&(D=v,j=f),!S&&Math.abs(W-P)<=z-1&&v>=F[W])return E[0]=v,A[0]=f,J<=F[W]&&1447>0&&z<=1447+1?this.x(y,h,i,R,P,l,N,I,M,F,v,c,E,f,$,A,S,g):null}const x=(D-b+(j-e)-z)/2;if(this.a!==null&&!this.a(D,x))return g[0]=!0,E[0]=D,A[0]=j,x>0&&1447>0&&z<=1447+1?this.x(y,h,i,R,P,l,N,I,M,F,v,c,E,f,$,A,S,g):(b++,e++,[new k.$ls(b,c-b+1,e,$-e+1)]);l=this.J(P-z,z,P,w),N=this.J(P+z,z,P,w);for(let W=l;W<=N;W+=2){W===l||W<N&&F[W-1]>=F[W+1]?v=F[W+1]-1:v=F[W-1],f=v-(W-P)-I;const J=v;for(;v>b&&f>e&&this.p(v,f);)v--,f--;if(F[W]=v,S&&Math.abs(W-y)<=z&&v<=M[W])return E[0]=v,A[0]=f,J>=M[W]&&1447>0&&z<=1447+1?this.x(y,h,i,R,P,l,N,I,M,F,v,c,E,f,$,A,S,g):null}if(z<=1447){let W=new Int32Array(i-h+2);W[0]=y-h+1,o.Copy2(M,h,W,1,i-h+1),this.k.push(W),W=new Int32Array(N-l+2),W[0]=P-l+1,o.Copy2(F,l,W,1,N-l+1),this.m.push(W)}}return this.x(y,h,i,R,P,l,N,I,M,F,v,c,E,f,$,A,S,g)}z(b){for(let c=0;c<b.length;c++){const e=b[c],$=c<b.length-1?b[c+1].originalStart:this.f.length,E=c<b.length-1?b[c+1].modifiedStart:this.h.length,A=e.originalLength>0,g=e.modifiedLength>0;for(;e.originalStart+e.originalLength<$&&e.modifiedStart+e.modifiedLength<E&&(!A||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!g||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const f=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!f)break;e.originalStart++,e.modifiedStart++}const v=[null];if(c<b.length-1&&this.I(b[c],b[c+1],v)){b[c]=v[0],b.splice(c+1,1),c--;continue}}for(let c=b.length-1;c>=0;c--){const e=b[c];let $=0,E=0;if(c>0){const i=b[c-1];$=i.originalStart+i.originalLength,E=i.modifiedStart+i.modifiedLength}const A=e.originalLength>0,g=e.modifiedLength>0;let v=0,f=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const l=e.originalStart-i,N=e.modifiedStart-i;if(l<$||N<E||A&&!this.s(l,l+e.originalLength)||g&&!this.u(N,N+e.modifiedLength))break;const w=(l===$&&N===E?5:0)+this.G(l,e.originalLength,N,e.modifiedLength);w>f&&(f=w,v=i)}e.originalStart-=v,e.modifiedStart-=v;const h=[null];if(c>0&&this.I(b[c-1],b[c],h)){b[c-1]=h[0],b.splice(c,1),c++;continue}}if(this.d)for(let c=1,e=b.length;c<e;c++){const $=b[c-1],E=b[c],A=E.originalStart-$.originalStart-$.originalLength,g=$.originalStart,v=E.originalStart+E.originalLength,f=v-g,h=$.modifiedStart,i=E.modifiedStart+E.modifiedLength,l=i-h;if(A<5&&f<20&&l<20){const N=this.A(g,f,h,l,A);if(N){const[m,w]=N;(m!==$.originalStart+$.originalLength||w!==$.modifiedStart+$.modifiedLength)&&($.originalLength=m-$.originalStart,$.modifiedLength=w-$.modifiedStart,E.originalStart=m+A,E.modifiedStart=w+A,E.originalLength=v-E.originalStart,E.modifiedLength=i-E.modifiedStart)}}}return b}A(b,c,e,$,E){if(c<E||$<E)return null;const A=b+c-E+1,g=e+$-E+1;let v=0,f=0,h=0;for(let i=b;i<A;i++)for(let l=e;l<g;l++){const N=this.B(i,l,E);N>0&&N>v&&(v=N,f=i,h=l)}return v>0?[f,h]:null}B(b,c,e){let $=0;for(let E=0;E<e;E++){if(!this.p(b+E,c+E))return 0;$+=this.e[b+E].length}return $}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,c){if(this.C(b)||this.C(b-1))return!0;if(c>0){const e=b+c;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,c){if(this.E(b)||this.E(b-1))return!0;if(c>0){const e=b+c;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,c,e,$){const E=this.D(b,c)?1:0,A=this.F(e,$)?1:0;return E+A}H(b,c){const e=[];if(b.length===0||c.length===0)return c.length>0?c:b;if(this.I(b[b.length-1],c[0],e)){const $=new Array(b.length+c.length-1);return o.Copy(b,0,$,0,b.length-1),$[b.length-1]=e[0],o.Copy(c,1,$,b.length,c.length-1),$}else{const $=new Array(b.length+c.length);return o.Copy(b,0,$,0,b.length),o.Copy(c,0,$,b.length,c.length),$}}I(b,c,e){if(L.Assert(b.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),L.Assert(b.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=c.originalStart||b.modifiedStart+b.modifiedLength>=c.modifiedStart){const $=b.originalStart;let E=b.originalLength;const A=b.modifiedStart;let g=b.modifiedLength;return b.originalStart+b.originalLength>=c.originalStart&&(E=c.originalStart+c.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=c.modifiedStart&&(g=c.modifiedStart+c.modifiedLength-b.modifiedStart),e[0]=new k.$ls($,E,A,g),!0}else return e[0]=null,!1}J(b,c,e,$){if(b>=0&&b<$)return b;const E=e,A=$-e-1,g=c%2===0;if(b<0){const v=E%2===0;return g===v?0:1}else{const v=A%2===0;return g===v?$-1:$-2}}}t.$os=d}),te(ne[26],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=void 0;function k(h){return typeof h=="string"}t.$if=k;function _(h){return Array.isArray(h)&&h.every(i=>k(i))}t.$jf=_;function r(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}t.$kf=r;function a(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}t.$lf=a;function L(h){return typeof h=="number"&&!isNaN(h)}t.$mf=L;function o(h){return!!h&&typeof h[Symbol.iterator]=="function"}t.$nf=o;function u(h){return h===!0||h===!1}t.$of=u;function s(h){return typeof h>"u"}t.$pf=s;function d(h){return!p(h)}t.$qf=d;function p(h){return s(h)||h===null}t.$rf=p;function b(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$sf=b;function c(h){if(p(h))throw new Error("Assertion Failed: argument is undefined or null");return h}t.$tf=c;function e(...h){const i=[];for(let l=0;l<h.length;l++){const N=h[l];if(p(N))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);i.push(N)}return i}t.$uf=e;const $=Object.prototype.hasOwnProperty;function E(h){if(!r(h))return!1;for(const i in h)if($.call(h,i))return!1;return!0}t.$vf=E;function A(h){return typeof h=="function"}t.$wf=A;function g(...h){return h.length>0&&h.every(A)}t.$xf=g;function v(h,i){const l=Math.min(h.length,i.length);for(let N=0;N<l;N++)f(h[N],i[N])}t.$yf=v;function f(h,i){if(k(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(A(i)){try{if(h instanceof i)return}catch{}if(!p(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$zf=f}),te(ne[40],ie([0,1,26]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oj=t.$Nj=t.$Mj=void 0;const _=Object.create(null);function r(o,u){if((0,k.$if)(u)){const s=_[u];if(s===void 0)throw new Error(`${o} references an unknown codicon: ${u}`);u=s}return _[o]=u,{id:o}}function a(){return _}t.$Mj=a;function L(){return Object.values(t.$Oj)}t.$Nj=L,t.$Oj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ne[14],ie([0,1,26]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6m=t.$5m=t.$4m=t.$3m=t.$2m=t.$1m=t.$Zm=t.$Ym=t.$Xm=t.$Wm=t.$Vm=t.$Um=void 0;function _(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const g=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([v,f])=>{g[v]=f&&typeof f=="object"?_(f):f}),g}t.$Um=_;function r(A){if(!A||typeof A!="object")return A;const g=[A];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const f in v)if(a.call(v,f)){const h=v[f];typeof h=="object"&&!Object.isFrozen(h)&&!(0,k.$lf)(h)&&g.push(h)}}return A}t.$Vm=r;const a=Object.prototype.hasOwnProperty;function L(A,g){return o(A,g,new Set)}t.$Wm=L;function o(A,g,v){if((0,k.$rf)(A))return A;const f=g(A);if(typeof f<"u")return f;if(Array.isArray(A)){const h=[];for(const i of A)h.push(o(i,g,v));return h}if((0,k.$kf)(A)){if(v.has(A))throw new Error("Cannot clone recursive data-structure");v.add(A);const h={};for(const i in A)a.call(A,i)&&(h[i]=o(A[i],g,v));return v.delete(A),h}return A}function u(A,g,v=!0){return(0,k.$kf)(A)?((0,k.$kf)(g)&&Object.keys(g).forEach(f=>{f in A?v&&((0,k.$kf)(A[f])&&(0,k.$kf)(g[f])?u(A[f],g[f],v):A[f]=g[f]):A[f]=g[f]}),A):g}t.$Xm=u;function s(A,g){if(A===g)return!0;if(A==null||g===null||g===void 0||typeof A!=typeof g||typeof A!="object"||Array.isArray(A)!==Array.isArray(g))return!1;let v,f;if(Array.isArray(A)){if(A.length!==g.length)return!1;for(v=0;v<A.length;v++)if(!s(A[v],g[v]))return!1}else{const h=[];for(f in A)h.push(f);h.sort();const i=[];for(f in g)i.push(f);if(i.sort(),!s(h,i))return!1;for(v=0;v<h.length;v++)if(!s(A[h[v]],g[h[v]]))return!1}return!0}t.$Ym=s;function d(A){const g=new Set;return JSON.stringify(A,(v,f)=>{if((0,k.$kf)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}t.$Zm=d;function p(A,g){const v=Object.create(null);return!A||!g||Object.keys(g).forEach(h=>{const i=A[h],l=g[h];s(i,l)||(v[h]=l)}),v}t.$1m=p;function b(A,g){const v=g.toLowerCase(),f=Object.keys(A).find(h=>h.toLowerCase()===v);return f?A[f]:A[g]}t.$2m=b;function c(A,g){const v=Object.create(null);for(const[f,h]of Object.entries(A))g(f,h)&&(v[f]=h);return v}t.$3m=c;function e(A){let g=[];for(;Object.prototype!==A;)g=g.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return g}t.$4m=e;function $(A){const g=[];for(const v of e(A))typeof A[v]=="function"&&g.push(v);return g}t.$5m=$;function E(A,g){const v=h=>function(){const i=Array.prototype.slice.call(arguments,0);return g(h,i)},f={};for(const h of A)f[h]=v(h);return f}t.$6m=E}),te(ne[27],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ke=t.$je=t.Constants=void 0;var k;(function(a){a[a.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",a[a.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",a[a.MAX_UINT_8=255]="MAX_UINT_8",a[a.MAX_UINT_16=65535]="MAX_UINT_16",a[a.MAX_UINT_32=4294967295]="MAX_UINT_32",a[a.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(t.Constants=k={}));function _(a){return a<0?0:a>255?255:a|0}t.$je=_;function r(a){return a<0?0:a>4294967295?4294967295:a|0}t.$ke=r}),te(ne[28],ie([0,1,27]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gs=t.$Fs=void 0;class _{constructor(o){const u=(0,k.$je)(o);this.c=u,this.a=_.d(u),this.b=new Map}static d(o){const u=new Uint8Array(256);return u.fill(o),u}set(o,u){const s=(0,k.$je)(u);o>=0&&o<256?this.a[o]=s:this.b.set(o,s)}get(o){return o>=0&&o<256?this.a[o]:this.b.get(o)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Fs=_;var r;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(r||(r={}));class a{constructor(){this.a=new _(0)}add(o){this.a.set(o,1)}has(o){return this.a.get(o)===1}clear(){return this.a.clear()}}t.$Gs=a}),te(ne[4],ie([0,1,3]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qs=t.$ps=void 0;class _{static addRange(L,o){let u=0;for(;u<o.length&&o[u].endExclusive<L.start;)u++;let s=u;for(;s<o.length&&o[s].start<=L.endExclusive;)s++;if(u===s)o.splice(u,0,L);else{const d=Math.min(L.start,o[u].start),p=Math.max(L.endExclusive,o[s-1].endExclusive);o.splice(u,s-u,new _(d,p))}}static tryCreate(L,o){if(!(L>o))return new _(L,o)}static ofLength(L){return new _(0,L)}constructor(L,o){if(this.start=L,this.endExclusive=o,L>o)throw new k.$ab(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(L){return new _(this.start+L,this.endExclusive+L)}deltaStart(L){return new _(this.start+L,this.endExclusive)}deltaEnd(L){return new _(this.start,this.endExclusive+L)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(L){return this.start===L.start&&this.endExclusive===L.endExclusive}containsRange(L){return this.start<=L.start&&L.endExclusive<=this.endExclusive}contains(L){return this.start<=L&&L<this.endExclusive}join(L){return new _(Math.min(this.start,L.start),Math.max(this.endExclusive,L.endExclusive))}intersect(L){const o=Math.max(this.start,L.start),u=Math.min(this.endExclusive,L.endExclusive);if(o<=u)return new _(o,u)}slice(L){return L.slice(this.start,this.endExclusive)}clip(L){if(this.isEmpty)throw new k.$ab(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,L))}clipCyclic(L){if(this.isEmpty)throw new k.$ab(`Invalid clipping range: ${this.toString()}`);return L<this.start?this.endExclusive-(this.start-L)%this.length:L>=this.endExclusive?this.start+(L-this.start)%this.length:L}map(L){const o=[];for(let u=this.start;u<this.endExclusive;u++)o.push(L(u));return o}forEach(L){for(let o=this.start;o<this.endExclusive;o++)L(o)}}t.$ps=_;class r{constructor(){this.a=[]}addRange(L){let o=0;for(;o<this.a.length&&this.a[o].endExclusive<L.start;)o++;let u=o;for(;u<this.a.length&&this.a[u].start<=L.endExclusive;)u++;if(o===u)this.a.splice(o,0,L);else{const s=Math.min(L.start,this.a[o].start),d=Math.max(L.endExclusive,this.a[u-1].endExclusive);this.a.splice(o,u-o,new _(s,d))}}toString(){return this.a.map(L=>L.toString()).join(", ")}intersectsStrict(L){let o=0;for(;o<this.a.length&&this.a[o].endExclusive<=L.start;)o++;return o<this.a.length&&this.a[o].start<L.endExclusive}intersectWithRange(L){const o=new r;for(const u of this.a){const s=u.intersect(L);s&&o.addRange(s)}return o}intersectWithRangeLength(L){return this.intersectWithRange(L).length}get length(){return this.a.reduce((L,o)=>L+o.length,0)}}t.$qs=r}),te(ne[5],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hs=void 0;class k{constructor(r,a){this.lineNumber=r,this.column=a}with(r=this.lineNumber,a=this.column){return r===this.lineNumber&&a===this.column?this:new k(r,a)}delta(r=0,a=0){return this.with(this.lineNumber+r,this.column+a)}equals(r){return k.equals(this,r)}static equals(r,a){return!r&&!a?!0:!!r&&!!a&&r.lineNumber===a.lineNumber&&r.column===a.column}isBefore(r){return k.isBefore(this,r)}static isBefore(r,a){return r.lineNumber<a.lineNumber?!0:a.lineNumber<r.lineNumber?!1:r.column<a.column}isBeforeOrEqual(r){return k.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,a){return r.lineNumber<a.lineNumber?!0:a.lineNumber<r.lineNumber?!1:r.column<=a.column}static compare(r,a){const L=r.lineNumber|0,o=a.lineNumber|0;if(L===o){const u=r.column|0,s=a.column|0;return u-s}return L-o}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new k(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.$hs=k}),te(ne[2],ie([0,1,5]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$is=void 0;class _{constructor(a,L,o,u){a>o||a===o&&L>u?(this.startLineNumber=o,this.startColumn=u,this.endLineNumber=a,this.endColumn=L):(this.startLineNumber=a,this.startColumn=L,this.endLineNumber=o,this.endColumn=u)}isEmpty(){return _.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return _.containsPosition(this,a)}static containsPosition(a,L){return!(L.lineNumber<a.startLineNumber||L.lineNumber>a.endLineNumber||L.lineNumber===a.startLineNumber&&L.column<a.startColumn||L.lineNumber===a.endLineNumber&&L.column>a.endColumn)}static strictContainsPosition(a,L){return!(L.lineNumber<a.startLineNumber||L.lineNumber>a.endLineNumber||L.lineNumber===a.startLineNumber&&L.column<=a.startColumn||L.lineNumber===a.endLineNumber&&L.column>=a.endColumn)}containsRange(a){return _.containsRange(this,a)}static containsRange(a,L){return!(L.startLineNumber<a.startLineNumber||L.endLineNumber<a.startLineNumber||L.startLineNumber>a.endLineNumber||L.endLineNumber>a.endLineNumber||L.startLineNumber===a.startLineNumber&&L.startColumn<a.startColumn||L.endLineNumber===a.endLineNumber&&L.endColumn>a.endColumn)}strictContainsRange(a){return _.strictContainsRange(this,a)}static strictContainsRange(a,L){return!(L.startLineNumber<a.startLineNumber||L.endLineNumber<a.startLineNumber||L.startLineNumber>a.endLineNumber||L.endLineNumber>a.endLineNumber||L.startLineNumber===a.startLineNumber&&L.startColumn<=a.startColumn||L.endLineNumber===a.endLineNumber&&L.endColumn>=a.endColumn)}plusRange(a){return _.plusRange(this,a)}static plusRange(a,L){let o,u,s,d;return L.startLineNumber<a.startLineNumber?(o=L.startLineNumber,u=L.startColumn):L.startLineNumber===a.startLineNumber?(o=L.startLineNumber,u=Math.min(L.startColumn,a.startColumn)):(o=a.startLineNumber,u=a.startColumn),L.endLineNumber>a.endLineNumber?(s=L.endLineNumber,d=L.endColumn):L.endLineNumber===a.endLineNumber?(s=L.endLineNumber,d=Math.max(L.endColumn,a.endColumn)):(s=a.endLineNumber,d=a.endColumn),new _(o,u,s,d)}intersectRanges(a){return _.intersectRanges(this,a)}static intersectRanges(a,L){let o=a.startLineNumber,u=a.startColumn,s=a.endLineNumber,d=a.endColumn;const p=L.startLineNumber,b=L.startColumn,c=L.endLineNumber,e=L.endColumn;return o<p?(o=p,u=b):o===p&&(u=Math.max(u,b)),s>c?(s=c,d=e):s===c&&(d=Math.min(d,e)),o>s||o===s&&u>d?null:new _(o,u,s,d)}equalsRange(a){return _.equalsRange(this,a)}static equalsRange(a,L){return!a&&!L?!0:!!a&&!!L&&a.startLineNumber===L.startLineNumber&&a.startColumn===L.startColumn&&a.endLineNumber===L.endLineNumber&&a.endColumn===L.endColumn}getEndPosition(){return _.getEndPosition(this)}static getEndPosition(a){return new k.$hs(a.endLineNumber,a.endColumn)}getStartPosition(){return _.getStartPosition(this)}static getStartPosition(a){return new k.$hs(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,L){return new _(this.startLineNumber,this.startColumn,a,L)}setStartPosition(a,L){return new _(a,L,this.endLineNumber,this.endColumn)}collapseToStart(){return _.collapseToStart(this)}static collapseToStart(a){return new _(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}collapseToEnd(){return _.collapseToEnd(this)}static collapseToEnd(a){return new _(a.endLineNumber,a.endColumn,a.endLineNumber,a.endColumn)}delta(a){return new _(this.startLineNumber+a,this.startColumn,this.endLineNumber+a,this.endColumn)}static fromPositions(a,L=a){return new _(a.lineNumber,a.column,L.lineNumber,L.column)}static lift(a){return a?new _(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,L){return!(a.endLineNumber<L.startLineNumber||a.endLineNumber===L.startLineNumber&&a.endColumn<L.startColumn||L.endLineNumber<a.startLineNumber||L.endLineNumber===a.startLineNumber&&L.endColumn<a.startColumn)}static areIntersecting(a,L){return!(a.endLineNumber<L.startLineNumber||a.endLineNumber===L.startLineNumber&&a.endColumn<=L.startColumn||L.endLineNumber<a.startLineNumber||L.endLineNumber===a.startLineNumber&&L.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,L){if(a&&L){const s=a.startLineNumber|0,d=L.startLineNumber|0;if(s===d){const p=a.startColumn|0,b=L.startColumn|0;if(p===b){const c=a.endLineNumber|0,e=L.endLineNumber|0;if(c===e){const $=a.endColumn|0,E=L.endColumn|0;return $-E}return c-e}return p-b}return s-d}return(a?1:0)-(L?1:0)}static compareRangesUsingEnds(a,L){return a.endLineNumber===L.endLineNumber?a.endColumn===L.endColumn?a.startLineNumber===L.startLineNumber?a.startColumn-L.startColumn:a.startLineNumber-L.startLineNumber:a.endColumn-L.endColumn:a.endLineNumber-L.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}toJSON(){return this}}t.$is=_}),te(ne[41],ie([0,1,2]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$js=void 0;class _{static insert(a,L){return{range:new k.$is(a.lineNumber,a.column,a.lineNumber,a.column),text:L,forceMoveMarkers:!0}}static delete(a){return{range:a,text:null}}static replace(a,L){return{range:a,text:L}}static replaceMove(a,L){return{range:a,text:L,forceMoveMarkers:!0}}}t.$js=_}),te(ne[12],ie([0,1,3,4,2,9]),function(B,t,k,_,r,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ss=t.$rs=void 0;class L{static fromRange(s){return new L(s.startLineNumber,s.endLineNumber)}static subtract(s,d){return d?s.startLineNumber<d.startLineNumber&&d.endLineNumberExclusive<s.endLineNumberExclusive?[new L(s.startLineNumber,d.startLineNumber),new L(d.endLineNumberExclusive,s.endLineNumberExclusive)]:d.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=d.endLineNumberExclusive?[]:d.endLineNumberExclusive<s.endLineNumberExclusive?[new L(Math.max(d.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new L(s.startLineNumber,Math.min(d.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let d=new o(s[0].slice());for(let p=1;p<s.length;p++)d=d.getUnion(new o(s[p].slice()));return d.ranges}static ofLength(s,d){return new L(s,s+d)}static deserialize(s){return new L(s[0],s[1])}constructor(s,d){if(s>d)throw new k.$ab(`startLineNumber ${s} cannot be after endLineNumberExclusive ${d}`);this.startLineNumber=s,this.endLineNumberExclusive=d}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new L(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new L(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new L(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const d=Math.max(this.startLineNumber,s.startLineNumber),p=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(d<=p)return new L(d,p)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$is(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$is(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const d=[];for(let p=this.startLineNumber;p<this.endLineNumberExclusive;p++)d.push(s(p));return d}forEach(s){for(let d=this.startLineNumber;d<this.endLineNumberExclusive;d++)s(d)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new _.$ps(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$rs=L;class o{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const d=(0,a.$ib)(this.c,b=>b.endLineNumberExclusive>=s.startLineNumber),p=(0,a.$gb)(this.c,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(d===p)this.c.splice(d,0,s);else if(d===p-1){const b=this.c[d];this.c[d]=b.join(s)}else{const b=this.c[d].join(this.c[p-1]).join(s);this.c.splice(d,p-d,b)}}contains(s){const d=(0,a.$fb)(this.c,p=>p.startLineNumber<=s);return!!d&&d.endLineNumberExclusive>s}intersects(s){const d=(0,a.$fb)(this.c,p=>p.startLineNumber<s.endLineNumberExclusive);return!!d&&d.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const d=[];let p=0,b=0,c=null;for(;p<this.c.length||b<s.c.length;){let e=null;if(p<this.c.length&&b<s.c.length){const $=this.c[p],E=s.c[b];$.startLineNumber<E.startLineNumber?(e=$,p++):(e=E,b++)}else p<this.c.length?(e=this.c[p],p++):(e=s.c[b],b++);c===null?c=e:c.endLineNumberExclusive>=e.startLineNumber?c=new L(c.startLineNumber,Math.max(c.endLineNumberExclusive,e.endLineNumberExclusive)):(d.push(c),c=e)}return c!==null&&d.push(c),new o(d)}subtractFrom(s){const d=(0,a.$ib)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),p=(0,a.$gb)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(d===p)return new o([s]);const b=[];let c=s.startLineNumber;for(let e=d;e<p;e++){const $=this.c[e];$.startLineNumber>c&&b.push(new L(c,$.startLineNumber)),c=$.endLineNumberExclusive}return c<s.endLineNumberExclusive&&b.push(new L(c,s.endLineNumberExclusive)),new o(b)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const d=[];let p=0,b=0;for(;p<this.c.length&&b<s.c.length;){const c=this.c[p],e=s.c[b],$=c.intersect(e);$&&!$.isEmpty&&d.push($),c.endLineNumberExclusive<e.endLineNumberExclusive?p++:b++}return new o(d)}getWithDelta(s){return new o(this.c.map(d=>d.delta(s)))}}t.$ss=o}),te(ne[42],ie([0,1,5,2]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ks=t.SelectionDirection=void 0;var r;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class a extends _.$is{constructor(o,u,s,d){super(o,u,s,d),this.selectionStartLineNumber=o,this.selectionStartColumn=u,this.positionLineNumber=s,this.positionColumn=d}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(o){return a.selectionsEqual(this,o)}static selectionsEqual(o,u){return o.selectionStartLineNumber===u.selectionStartLineNumber&&o.selectionStartColumn===u.selectionStartColumn&&o.positionLineNumber===u.positionLineNumber&&o.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(o,u){return this.getDirection()===0?new a(this.startLineNumber,this.startColumn,o,u):new a(o,u,this.startLineNumber,this.startColumn)}getPosition(){return new k.$hs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new k.$hs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(o,u){return this.getDirection()===0?new a(o,u,this.endLineNumber,this.endColumn):new a(this.endLineNumber,this.endColumn,o,u)}static fromPositions(o,u=o){return new a(o.lineNumber,o.column,u.lineNumber,u.column)}static fromRange(o,u){return u===0?new a(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):new a(o.endLineNumber,o.endColumn,o.startLineNumber,o.startColumn)}static liftSelection(o){return new a(o.selectionStartLineNumber,o.selectionStartColumn,o.positionLineNumber,o.positionColumn)}static selectionsArrEqual(o,u){if(o&&!u||!o&&u)return!1;if(!o&&!u)return!0;if(o.length!==u.length)return!1;for(let s=0,d=o.length;s<d;s++)if(!this.selectionsEqual(o[s],u[s]))return!1;return!0}static isISelection(o){return o&&typeof o.selectionStartLineNumber=="number"&&typeof o.selectionStartColumn=="number"&&typeof o.positionLineNumber=="number"&&typeof o.positionColumn=="number"}static createWithDirection(o,u,s,d,p){return p===0?new a(o,u,s,d):new a(s,d,o,u)}}t.$ks=a}),te(ne[43],ie([0,1,28]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Is=t.$Hs=t.WordCharacterClass=void 0;var _;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(_||(t.WordCharacterClass=_={}));class r extends k.$Fs{constructor(o){super(0);for(let u=0,s=o.length;u<s;u++)this.set(o.charCodeAt(u),2);this.set(32,1),this.set(9,1)}}t.$Hs=r;function a(L){const o={};return u=>(o.hasOwnProperty(u)||(o[u]=L(u)),o[u])}t.$Is=a(L=>new r(L))}),te(ne[29],ie([0,1,21,10,22]),function(B,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xr=t.$Wr=t.$Vr=t.$Ur=t.$Tr=void 0,t.$Tr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function a(p=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const c of t.$Tr)p.indexOf(c)>=0||(b+="\\"+c);return b+="\\s]+)",new RegExp(b,"g")}t.$Ur=a();function L(p){let b=t.$Ur;if(p&&p instanceof RegExp)if(p.global)b=p;else{let c="g";p.ignoreCase&&(c+="i"),p.multiline&&(c+="m"),p.unicode&&(c+="u"),b=new RegExp(p.source,c)}return b.lastIndex=0,b}t.$Vr=L;const o=new r.$sc;o.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function u(p){const b=o.unshift(p);return(0,_.$hc)(b)}t.$Wr=u;function s(p,b,c,e,$){if($||($=k.Iterable.first(o)),c.length>$.maxLen){let f=p-$.maxLen/2;return f<0?f=0:e+=f,c=c.substring(f,p+$.maxLen/2),s(p,b,c,e,$)}const E=Date.now(),A=p-1-e;let g=-1,v=null;for(let f=1;!(Date.now()-E>=$.timeBudget);f++){const h=A-$.windowSize*f;b.lastIndex=Math.max(0,h);const i=d(b,c,A,g);if(!i&&v||(v=i,h<=0))break;g=h}if(v){const f={word:v[0],startColumn:e+1+v.index,endColumn:e+1+v.index+v[0].length};return b.lastIndex=0,f}return null}t.$Xr=s;function d(p,b,c,e){let $;for(;$=p.exec(b);){const E=$.index||0;if(E<=c&&p.lastIndex>=c)return $;if(e>0&&E>e)return null}return null}}),te(ne[8],ie([0,1,7,3,4]),function(B,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wY=t.$vY=t.$uY=t.$tY=void 0;class a{static trivial(d,p){return new a([new L(new r.$ps(0,d.length),new r.$ps(0,p.length))],!1)}static trivialTimedOut(d,p){return new a([new L(new r.$ps(0,d.length),new r.$ps(0,p.length))],!0)}constructor(d,p){this.diffs=d,this.hitTimeout=p}}t.$tY=a;class L{static invert(d,p){const b=[];return(0,k.$zb)(d,(c,e)=>{const $=c?c.seq1Range.endExclusive:0,E=c?c.seq2Range.endExclusive:0,A=e?e.seq1Range.start:p,g=e?e.seq2Range.start:(c?c.seq2Range.endExclusive-c.seq1Range.endExclusive:0)+p;b.push(new L(new r.$ps($,A),new r.$ps(E,g)))}),b}constructor(d,p){this.seq1Range=d,this.seq2Range=p}swap(){return new L(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(d){return new L(this.seq1Range.join(d.seq1Range),this.seq2Range.join(d.seq2Range))}delta(d){return d===0?this:new L(this.seq1Range.delta(d),this.seq2Range.delta(d))}}t.$uY=L;class o{static{this.instance=new o}isValid(){return!0}}t.$vY=o;class u{constructor(d){if(this.e=d,this.c=Date.now(),this.d=!0,d<=0)throw new _.$ab("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$wY=u}),te(ne[30],ie([0,1,4,8]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BY=void 0;class r{compute(s,d,p=_.$vY.instance){if(s.length===0||d.length===0)return _.$tY.trivial(s,d);const b=s,c=d;function e(l,N){for(;l<b.length&&N<c.length&&b.getElement(l)===c.getElement(N);)l++,N++;return l}let $=0;const E=new L;E.set(0,e(0,0));const A=new o;A.set(0,E.get(0)===0?null:new a(null,0,0,E.get(0)));let g=0;e:for(;;){if($++,!p.isValid())return _.$tY.trivialTimedOut(b,c);const l=-Math.min($,c.length+$%2),N=Math.min($,b.length+$%2);for(g=l;g<=N;g+=2){let m=0;const w=g===N?-1:E.get(g+1),M=g===l?-1:E.get(g-1)+1;m++;const F=Math.min(Math.max(w,M),b.length),y=F-g;if(m++,F>b.length||y>c.length)continue;const P=e(F,y);E.set(g,P);const R=F===w?A.get(g+1):A.get(g-1);if(A.set(g,P!==F?new a(R,F,y,P-F):R),E.get(g)===b.length&&E.get(g)-g===c.length)break e}}let v=A.get(g);const f=[];let h=b.length,i=c.length;for(;;){const l=v?v.x+v.length:0,N=v?v.y+v.length:0;if((l!==h||N!==i)&&f.push(new _.$uY(new k.$ps(l,h),new k.$ps(N,i))),!v)break;h=v.x,i=v.y,v=v.prev}return f.reverse(),new _.$tY(f,!1)}}t.$BY=r;class a{constructor(s,d,p,b){this.prev=s,this.x=d,this.y=p,this.length=b}}class L{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,d){if(s<0){if(s=-s-1,s>=this.b.length){const p=this.b;this.b=new Int32Array(p.length*2),this.b.set(p)}this.b[s]=d}else{if(s>=this.a.length){const p=this.a;this.a=new Int32Array(p.length*2),this.a.set(p)}this.a[s]=d}}}class o{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,d){s<0?(s=-s-1,this.b[s]=d):this.a[s]=d}}}),te(ne[44],ie([0,1,4,8]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JY=t.$IY=t.$HY=t.$GY=t.$FY=void 0;function r(c,e,$){let E=$;return E=a(c,e,E),E=L(c,e,E),E}t.$FY=r;function a(c,e,$){if($.length===0)return $;const E=[];E.push($[0]);for(let g=1;g<$.length;g++){const v=E[E.length-1];let f=$[g];if(f.seq1Range.isEmpty||f.seq2Range.isEmpty){const h=f.seq1Range.start-v.seq1Range.endExclusive;let i;for(i=1;i<=h&&!(c.getElement(f.seq1Range.start-i)!==c.getElement(f.seq1Range.endExclusive-i)||e.getElement(f.seq2Range.start-i)!==e.getElement(f.seq2Range.endExclusive-i));i++);if(i--,i===h){E[E.length-1]=new _.$uY(new k.$ps(v.seq1Range.start,f.seq1Range.endExclusive-h),new k.$ps(v.seq2Range.start,f.seq2Range.endExclusive-h));continue}f=f.delta(-i)}E.push(f)}const A=[];for(let g=0;g<E.length-1;g++){const v=E[g+1];let f=E[g];if(f.seq1Range.isEmpty||f.seq2Range.isEmpty){const h=v.seq1Range.start-f.seq1Range.endExclusive;let i;for(i=0;i<h&&!(c.getElement(f.seq1Range.start+i)!==c.getElement(f.seq1Range.endExclusive+i)||e.getElement(f.seq2Range.start+i)!==e.getElement(f.seq2Range.endExclusive+i));i++);if(i===h){E[g+1]=new _.$uY(new k.$ps(f.seq1Range.start+h,v.seq1Range.endExclusive),new k.$ps(f.seq2Range.start+h,v.seq2Range.endExclusive));continue}i>0&&(f=f.delta(i))}A.push(f)}return E.length>0&&A.push(E[E.length-1]),A}function L(c,e,$){if(!c.getBoundaryScore||!e.getBoundaryScore)return $;for(let E=0;E<$.length;E++){const A=E>0?$[E-1]:void 0,g=$[E],v=E+1<$.length?$[E+1]:void 0,f=new k.$ps(A?A.seq1Range.start+1:0,v?v.seq1Range.endExclusive-1:c.length),h=new k.$ps(A?A.seq2Range.start+1:0,v?v.seq2Range.endExclusive-1:e.length);g.seq1Range.isEmpty?$[E]=o(g,c,e,f,h):g.seq2Range.isEmpty&&($[E]=o(g.swap(),e,c,h,f).swap())}return $}function o(c,e,$,E,A){let v=1;for(;c.seq1Range.start-v>=E.start&&c.seq2Range.start-v>=A.start&&$.isStronglyEqual(c.seq2Range.start-v,c.seq2Range.endExclusive-v)&&v<100;)v++;v--;let f=0;for(;c.seq1Range.start+f<E.endExclusive&&c.seq2Range.endExclusive+f<A.endExclusive&&$.isStronglyEqual(c.seq2Range.start+f,c.seq2Range.endExclusive+f)&&f<100;)f++;if(v===0&&f===0)return c;let h=0,i=-1;for(let l=-v;l<=f;l++){const N=c.seq2Range.start+l,m=c.seq2Range.endExclusive+l,w=c.seq1Range.start+l,M=e.getBoundaryScore(w)+$.getBoundaryScore(N)+$.getBoundaryScore(m);M>i&&(i=M,h=l)}return c.delta(h)}function u(c,e,$){const E=[];for(const A of $){const g=E[E.length-1];if(!g){E.push(A);continue}A.seq1Range.start-g.seq1Range.endExclusive<=2||A.seq2Range.start-g.seq2Range.endExclusive<=2?E[E.length-1]=new _.$uY(g.seq1Range.join(A.seq1Range),g.seq2Range.join(A.seq2Range)):E.push(A)}return E}t.$GY=u;function s(c,e,$){const E=[];let A;function g(){if(!A)return;const f=A.s1Range.length-A.deleted,h=A.s2Range.length-A.added;Math.max(A.deleted,A.added)+(A.count-1)>f&&E.push(new _.$uY(A.s1Range,A.s2Range)),A=void 0}for(const f of $){let h=function(w,M){if(!A||!A.s1Range.containsRange(w)||!A.s2Range.containsRange(M))if(A&&!(A.s1Range.endExclusive<w.start&&A.s2Range.endExclusive<M.start)){const P=k.$ps.tryCreate(A.s1Range.endExclusive,w.start),R=k.$ps.tryCreate(A.s2Range.endExclusive,M.start);A.deleted+=P?.length??0,A.added+=R?.length??0,A.s1Range=A.s1Range.join(w),A.s2Range=A.s2Range.join(M)}else g(),A={added:0,deleted:0,count:0,s1Range:w,s2Range:M};const F=w.intersect(f.seq1Range),y=M.intersect(f.seq2Range);A.count++,A.deleted+=F?.length??0,A.added+=y?.length??0};const i=c.findWordContaining(f.seq1Range.start-1),l=e.findWordContaining(f.seq2Range.start-1),N=c.findWordContaining(f.seq1Range.endExclusive),m=e.findWordContaining(f.seq2Range.endExclusive);i&&N&&l&&m&&i.equals(N)&&l.equals(m)?h(i,l):(i&&l&&h(i,l),N&&m&&h(N,m))}return g(),d($,E)}t.$HY=s;function d(c,e){const $=[];for(;c.length>0||e.length>0;){const E=c[0],A=e[0];let g;E&&(!A||E.seq1Range.start<A.seq1Range.start)?g=c.shift():g=e.shift(),$.length>0&&$[$.length-1].seq1Range.endExclusive>=g.seq1Range.start?$[$.length-1]=$[$.length-1].join(g):$.push(g)}return $}function p(c,e,$){let E=$;if(E.length===0)return E;let A=0,g;do{g=!1;const v=[E[0]];for(let f=1;f<E.length;f++){let l=function(m,w){const M=new k.$ps(i.seq1Range.endExclusive,h.seq1Range.start);return c.getText(M).replace(/\s/g,"").length<=4&&(m.seq1Range.length+m.seq2Range.length>5||w.seq1Range.length+w.seq2Range.length>5)};const h=E[f],i=v[v.length-1];l(i,h)?(g=!0,v[v.length-1]=v[v.length-1].join(h)):v.push(h)}E=v}while(A++<10&&g);return E}t.$IY=p;function b(c,e,$){let E=$;if(E.length===0)return E;let A=0,g;do{g=!1;const v=[E[0]];for(let f=1;f<E.length;f++){let l=function(m,w){const M=new k.$ps(i.seq1Range.endExclusive,h.seq1Range.start);if(c.countLinesIn(M)>5||M.length>500)return!1;const y=c.getText(M).trim();if(y.length>20||y.split(/\r\n|\r|\n/).length>1)return!1;const P=c.countLinesIn(m.seq1Range),R=m.seq1Range.length,I=e.countLinesIn(m.seq2Range),q=m.seq2Range.length,S=c.countLinesIn(w.seq1Range),z=w.seq1Range.length,D=e.countLinesIn(w.seq2Range),j=w.seq2Range.length,x=2*40+50;function W(J){return Math.min(J,x)}return Math.pow(Math.pow(W(P*40+R),1.5)+Math.pow(W(I*40+q),1.5),1.5)+Math.pow(Math.pow(W(S*40+z),1.5)+Math.pow(W(D*40+j),1.5),1.5)>(x**1.5)**1.5*1.3};const h=E[f],i=v[v.length-1];l(i,h)?(g=!0,v[v.length-1]=v[v.length-1].join(h)):v.push(h)}E=v}while(A++<10&&g);for(let v=0;v<E.length;v++){const f=E[v];let h=f.seq1Range,i=f.seq2Range;const l=c.extendToFullLines(f.seq1Range),N=c.getText(new k.$ps(l.start,f.seq1Range.start));N.length>0&&N.trim().length<=3&&f.seq1Range.length+f.seq2Range.length>100&&(h=f.seq1Range.deltaStart(-N.length),i=f.seq2Range.deltaStart(-N.length));const m=c.getText(new k.$ps(f.seq1Range.endExclusive,l.endExclusive));m.length>0&&m.trim().length<=3&&f.seq1Range.length+f.seq2Range.length>150&&(h=h.deltaEnd(m.length),i=i.deltaEnd(m.length)),E[v]=new _.$uY(h,i)}return E}t.$JY=b}),te(ne[45],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EY=void 0;class k{constructor(a,L){this.a=a,this.b=L}getElement(a){return this.a[a]}get length(){return this.a.length}getBoundaryScore(a){const L=a===0?0:_(this.b[a-1]),o=a===this.b.length?0:_(this.b[a]);return 1e3-(L+o)}getText(a){return this.b.slice(a.start,a.endExclusive).join(`
`)}isStronglyEqual(a,L){return this.b[a]===this.b[L]}}t.$EY=k;function _(r){let a=0;for(;a<r.length&&(r.charCodeAt(a)===32||r.charCodeAt(a)===9);)a++;return a}}),te(ne[15],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zY=t.$yY=t.$xY=void 0;class k{constructor(L,o){this.width=L,this.height=o,this.a=[],this.a=new Array(L*o)}get(L,o){return this.a[L+o*this.width]}set(L,o,u){this.a[L+o*this.width]=u}}t.$xY=k;function _(a){return a===32||a===9}t.$yY=_;class r{static{this.a=new Map}static b(L){let o=this.a.get(L);return o===void 0&&(o=this.a.size,this.a.set(L,o)),o}constructor(L,o,u){this.range=L,this.lines=o,this.source=u,this.d=[];let s=0;for(let d=L.startLineNumber-1;d<L.endLineNumberExclusive-1;d++){const p=o[d];for(let c=0;c<p.length;c++){s++;const e=p[c],$=r.b(e);this.d[$]=(this.d[$]||0)+1}s++;const b=r.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=s}computeSimilarity(L){let o=0;const u=Math.max(this.d.length,L.d.length);for(let s=0;s<u;s++)o+=Math.abs((this.d[s]??0)-(L.d[s]??0));return 1-o/(this.c+L.c)}}t.$zY=r}),te(ne[46],ie([0,1,4,8,15]),function(B,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AY=void 0;class a{compute(o,u,s=_.$vY.instance,d){if(o.length===0||u.length===0)return _.$tY.trivial(o,u);const p=new r.$xY(o.length,u.length),b=new r.$xY(o.length,u.length),c=new r.$xY(o.length,u.length);for(let f=0;f<o.length;f++)for(let h=0;h<u.length;h++){if(!s.isValid())return _.$tY.trivialTimedOut(o,u);const i=f===0?0:p.get(f-1,h),l=h===0?0:p.get(f,h-1);let N;o.getElement(f)===u.getElement(h)?(f===0||h===0?N=0:N=p.get(f-1,h-1),f>0&&h>0&&b.get(f-1,h-1)===3&&(N+=c.get(f-1,h-1)),N+=d?d(f,h):1):N=-1;const m=Math.max(i,l,N);if(m===N){const w=f>0&&h>0?c.get(f-1,h-1):0;c.set(f,h,w+1),b.set(f,h,3)}else m===i?(c.set(f,h,0),b.set(f,h,1)):m===l&&(c.set(f,h,0),b.set(f,h,2));p.set(f,h,m)}const e=[];let $=o.length,E=u.length;function A(f,h){(f+1!==$||h+1!==E)&&e.push(new _.$uY(new k.$ps(f+1,$),new k.$ps(h+1,E))),$=f,E=h}let g=o.length-1,v=u.length-1;for(;g>=0&&v>=0;)b.get(g,v)===3?(A(g,v),g--,v--):b.get(g,v)===1?g--:v--;return A(-1,-1),e.reverse(),new _.$tY(e,!1)}}t.$AY=a}),te(ne[31],ie([0,1,9,4,5,2,15]),function(B,t,k,_,r,a,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CY=void 0;class o{constructor(e,$,E){this.lines=e,this.considerWhitespaceChanges=E,this.b=[],this.c=[],this.d=[];let A=!1;$.start>0&&$.endExclusive>=e.length&&($=new _.$ps($.start-1,$.endExclusive),A=!0),this.lineRange=$,this.c[0]=0;for(let g=this.lineRange.start;g<this.lineRange.endExclusive;g++){let v=e[g],f=0;if(A)f=v.length,v="",A=!1;else if(!E){const h=v.trimStart();f=v.length-h.length,v=h.trimEnd()}this.d.push(f);for(let h=0;h<v.length;h++)this.b.push(v.charCodeAt(h));g<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[g-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new _.$ps(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map($=>String.fromCharCode($)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const $=b(e>0?this.b[e-1]:-1),E=b(e<this.b.length?this.b[e]:-1);if($===6&&E===7)return 0;let A=0;return $!==E&&(A+=10,E===1&&(A+=1)),A+=p($),A+=p(E),A}translateOffset(e){if(this.lineRange.isEmpty)return new r.$hs(this.lineRange.start+1,1);const $=(0,k.$gb)(this.c,E=>E<=e);return new r.$hs(this.lineRange.start+$+1,e-this.c[$]+this.d[$]+1)}translateRange(e){return a.$is.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!u(this.b[e]))return;let $=e;for(;$>0&&u(this.b[$-1]);)$--;let E=e;for(;E<this.b.length&&u(this.b[E]);)E++;return new _.$ps($,E)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,$){return this.b[e]===this.b[$]}extendToFullLines(e){const $=(0,k.$fb)(this.c,A=>A<=e.start)??0,E=(0,k.$hb)(this.c,A=>e.endExclusive<=A)??this.b.length;return new _.$ps($,E)}}t.$CY=o;function u(c){return c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57}var s;(function(c){c[c.WordLower=0]="WordLower",c[c.WordUpper=1]="WordUpper",c[c.WordNumber=2]="WordNumber",c[c.End=3]="End",c[c.Other=4]="Other",c[c.Space=5]="Space",c[c.LineBreakCR=6]="LineBreakCR",c[c.LineBreakLF=7]="LineBreakLF"})(s||(s={}));const d={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function p(c){return d[c]}function b(c){return c===10?7:c===13?6:(0,L.$yY)(c)?5:c>=97&&c<=122?0:c>=65&&c<=90?1:c>=48&&c<=57?2:c===-1?3:4}}),te(ne[32],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xs=t.$ws=void 0;class k{constructor(a,L,o){this.changes=a,this.moves=L,this.hitTimeout=o}}t.$ws=k;class _{constructor(a,L){this.lineRangeMapping=a,this.changes=L}flip(){return new _(this.lineRangeMapping.flip(),this.changes.map(a=>a.flip()))}}t.$xs=_}),te(ne[16],ie([0,1,12]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vs=t.$us=t.$ts=void 0;class _{static inverse(o,u,s){const d=[];let p=1,b=1;for(const e of o){const $=new r(new k.$rs(p,e.original.startLineNumber),new k.$rs(b,e.modified.startLineNumber),void 0);$.modified.isEmpty||d.push($),p=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const c=new r(new k.$rs(p,u+1),new k.$rs(b,s+1),void 0);return c.modified.isEmpty||d.push(c),d}constructor(o,u){this.original=o,this.modified=u}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new _(this.modified,this.original)}join(o){return new _(this.original.join(o.original),this.modified.join(o.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$ts=_;class r extends _{constructor(o,u,s){super(o,u),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(o=>o.flip()))}}t.$us=r;class a{constructor(o,u){this.originalRange=o,this.modifiedRange=u}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}}t.$vs=a}),te(ne[47],ie([0,1,8,16,7,9,19,12,4,31,15,30]),function(B,t,k,_,r,a,L,o,u,s,d,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DY=void 0;function b(g,v,f,h,i,l){let{moves:N,excludedChanges:m}=c(g,v,f,l);if(!l.isValid())return[];const w=g.filter(F=>!m.has(F)),M=e(w,h,i,v,f,l);return(0,r.$Xb)(N,M),N=E(N),N=N.filter(F=>F.original.toOffsetRange().slice(v).map(P=>P.trim()).join(`
`).length>=10),N=A(g,N),N}t.$DY=b;function c(g,v,f,h){const i=[],l=g.filter(w=>w.modified.isEmpty&&w.original.length>=3).map(w=>new d.$zY(w.original,v,w)),N=new Set(g.filter(w=>w.original.isEmpty&&w.modified.length>=3).map(w=>new d.$zY(w.modified,f,w))),m=new Set;for(const w of l){let M=-1,F;for(const y of N){const P=w.computeSimilarity(y);P>M&&(M=P,F=y)}if(M>.9&&F&&(N.delete(F),i.push(new _.$ts(w.range,F.range)),m.add(w.source),m.add(F.source)),!h.isValid())return{moves:i,excludedChanges:m}}return{moves:i,excludedChanges:m}}function e(g,v,f,h,i,l){const N=[],m=new L.$L;for(const P of g)for(let R=P.original.startLineNumber;R<P.original.endLineNumberExclusive-2;R++){const I=`${v[R-1]}:${v[R+1-1]}:${v[R+2-1]}`;m.add(I,{range:new o.$rs(R,R+3)})}const w=[];g.sort((0,r.$4b)(P=>P.modified.startLineNumber,r.$6b));for(const P of g){let R=[];for(let I=P.modified.startLineNumber;I<P.modified.endLineNumberExclusive-2;I++){const q=`${f[I-1]}:${f[I+1-1]}:${f[I+2-1]}`,S=new o.$rs(I,I+3),z=[];m.forEach(q,({range:D})=>{for(const x of R)if(x.originalLineRange.endLineNumberExclusive+1===D.endLineNumberExclusive&&x.modifiedLineRange.endLineNumberExclusive+1===S.endLineNumberExclusive){x.originalLineRange=new o.$rs(x.originalLineRange.startLineNumber,D.endLineNumberExclusive),x.modifiedLineRange=new o.$rs(x.modifiedLineRange.startLineNumber,S.endLineNumberExclusive),z.push(x);return}const j={modifiedLineRange:S,originalLineRange:D};w.push(j),z.push(j)}),R=z}if(!l.isValid())return[]}w.sort((0,r.$8b)((0,r.$4b)(P=>P.modifiedLineRange.length,r.$6b)));const M=new o.$ss,F=new o.$ss;for(const P of w){const R=P.modifiedLineRange.startLineNumber-P.originalLineRange.startLineNumber,I=M.subtractFrom(P.modifiedLineRange),q=F.subtractFrom(P.originalLineRange).getWithDelta(R),S=I.getIntersection(q);for(const z of S.ranges){if(z.length<3)continue;const D=z,j=z.delta(-R);N.push(new _.$ts(j,D)),M.addRange(D),F.addRange(j)}}N.sort((0,r.$4b)(P=>P.original.startLineNumber,r.$6b));const y=new a.$kb(g);for(let P=0;P<N.length;P++){const R=N[P],I=y.findLastMonotonous(J=>J.original.startLineNumber<=R.original.startLineNumber),q=(0,a.$fb)(g,J=>J.modified.startLineNumber<=R.modified.startLineNumber),S=Math.max(R.original.startLineNumber-I.original.startLineNumber,R.modified.startLineNumber-q.modified.startLineNumber),z=y.findLastMonotonous(J=>J.original.startLineNumber<R.original.endLineNumberExclusive),D=(0,a.$fb)(g,J=>J.modified.startLineNumber<R.modified.endLineNumberExclusive),j=Math.max(z.original.endLineNumberExclusive-R.original.endLineNumberExclusive,D.modified.endLineNumberExclusive-R.modified.endLineNumberExclusive);let x;for(x=0;x<S;x++){const J=R.original.startLineNumber-x-1,n=R.modified.startLineNumber-x-1;if(M.contains(n)||F.contains(J)||!$(h[J-1],i[n-1],l))break}x>0&&(F.addRange(new o.$rs(R.original.startLineNumber-x,R.original.startLineNumber)),M.addRange(new o.$rs(R.modified.startLineNumber-x,R.modified.startLineNumber)));let W;for(W=0;W<j;W++){const J=R.original.endLineNumberExclusive+W,n=R.modified.endLineNumberExclusive+W;if(M.contains(n)||F.contains(J)||!$(h[J-1],i[n-1],l))break}W>0&&(F.addRange(new o.$rs(R.original.endLineNumberExclusive,R.original.endLineNumberExclusive+W)),M.addRange(new o.$rs(R.modified.endLineNumberExclusive,R.modified.endLineNumberExclusive+W))),(x>0||W>0)&&(N[P]=new _.$ts(new o.$rs(R.original.startLineNumber-x,R.original.endLineNumberExclusive+W),new o.$rs(R.modified.startLineNumber-x,R.modified.endLineNumberExclusive+W)))}return N}function $(g,v,f){if(g.trim()===v.trim())return!0;if(g.length>300&&v.length>300)return!1;const i=new p.$BY().compute(new s.$CY([g],new u.$ps(0,1),!1),new s.$CY([v],new u.$ps(0,1),!1),f);let l=0;const N=k.$uY.invert(i.diffs,g.length);for(const F of N)F.seq1Range.forEach(y=>{(0,d.$yY)(g.charCodeAt(y))||l++});function m(F){let y=0;for(let P=0;P<g.length;P++)(0,d.$yY)(F.charCodeAt(P))||y++;return y}const w=m(g.length>v.length?g:v);return l/w>.6&&w>10}function E(g){if(g.length===0)return g;g.sort((0,r.$4b)(f=>f.original.startLineNumber,r.$6b));const v=[g[0]];for(let f=1;f<g.length;f++){const h=v[v.length-1],i=g[f],l=i.original.startLineNumber-h.original.endLineNumberExclusive,N=i.modified.startLineNumber-h.modified.endLineNumberExclusive;if(l>=0&&N>=0&&l+N<=2){v[v.length-1]=h.join(i);continue}v.push(i)}return v}function A(g,v){const f=new a.$kb(g);return v=v.filter(h=>{const i=f.findLastMonotonous(w=>w.original.endLineNumberExclusive<=h.original.startLineNumber)||new _.$ts(new o.$rs(1,1),new o.$rs(1,1)),l=h.modified.startLineNumber-i.modified.endLineNumberExclusive,N=h.original.startLineNumber-i.original.endLineNumberExclusive;return l!==N}),v}}),te(ne[48],ie([0,1,7,13,12,4,2,8,46,30,47,44,32,16,31,45]),function(B,t,k,_,r,a,L,o,u,s,d,p,b,c,e,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MY=t.$LY=t.$KY=void 0;class E{constructor(){this.e=new u.$AY,this.f=new s.$BY}computeDiff(f,h,i){if(f.length<=1&&(0,k.$sb)(f,h,(J,n)=>J===n))return new b.$ws([],[],!1);if(f.length===1&&f[0].length===0||h.length===1&&h[0].length===0)return new b.$ws([new c.$us(new r.$rs(1,f.length+1),new r.$rs(1,h.length+1),[new c.$vs(new L.$is(1,1,f.length,f[0].length+1),new L.$is(1,1,h.length,h[0].length+1))])],[],!1);const l=i.maxComputationTimeMs===0?o.$vY.instance:new o.$wY(i.maxComputationTimeMs),N=!i.ignoreTrimWhitespace,m=new Map;function w(J){let n=m.get(J);return n===void 0&&(n=m.size,m.set(J,n)),n}const M=f.map(J=>w(J.trim())),F=h.map(J=>w(J.trim())),y=new $.$EY(M,f),P=new $.$EY(F,h),R=(()=>y.length+P.length<1700?this.e.compute(y,P,l,(J,n)=>f[J]===h[n]?h[n].length===0?.1:1+Math.log(1+h[n].length):.99):this.f.compute(y,P))();let I=R.diffs,q=R.hitTimeout;I=(0,p.$FY)(y,P,I),I=(0,p.$IY)(y,P,I);const S=[],z=J=>{if(N)for(let n=0;n<J;n++){const ue=D+n,ce=j+n;if(f[ue]!==h[ce]){const $e=this.j(f,h,new o.$uY(new a.$ps(ue,ue+1),new a.$ps(ce,ce+1)),l,N);for(const we of $e.mappings)S.push(we);$e.hitTimeout&&(q=!0)}}};let D=0,j=0;for(const J of I){(0,_.$wc)(()=>J.seq1Range.start-D===J.seq2Range.start-j);const n=J.seq1Range.start-D;z(n),D=J.seq1Range.endExclusive,j=J.seq2Range.endExclusive;const ue=this.j(f,h,J,l,N);ue.hitTimeout&&(q=!0);for(const ce of ue.mappings)S.push(ce)}z(f.length-D);const x=A(S,f,h);let W=[];return i.computeMoves&&(W=this.h(x,f,h,M,F,l,N)),(0,_.$wc)(()=>{function J(ue,ce){if(ue.lineNumber<1||ue.lineNumber>ce.length)return!1;const $e=ce[ue.lineNumber-1];return!(ue.column<1||ue.column>$e.length+1)}function n(ue,ce){return!(ue.startLineNumber<1||ue.startLineNumber>ce.length+1||ue.endLineNumberExclusive<1||ue.endLineNumberExclusive>ce.length+1)}for(const ue of x){if(!ue.innerChanges)return!1;for(const ce of ue.innerChanges)if(!(J(ce.modifiedRange.getStartPosition(),h)&&J(ce.modifiedRange.getEndPosition(),h)&&J(ce.originalRange.getStartPosition(),f)&&J(ce.originalRange.getEndPosition(),f)))return!1;if(!n(ue.modified,h)||!n(ue.original,f))return!1}return!0}),new b.$ws(x,W,q)}h(f,h,i,l,N,m,w){return(0,d.$DY)(f,h,i,l,N,m).map(y=>{const P=this.j(h,i,new o.$uY(y.original.toOffsetRange(),y.modified.toOffsetRange()),m,w),R=A(P.mappings,h,i,!0);return new b.$xs(y,R)})}j(f,h,i,l,N){const m=new e.$CY(f,i.seq1Range,N),w=new e.$CY(h,i.seq2Range,N),M=m.length+w.length<500?this.e.compute(m,w,l):this.f.compute(m,w,l);let F=M.diffs;return F=(0,p.$FY)(m,w,F),F=(0,p.$HY)(m,w,F),F=(0,p.$GY)(m,w,F),F=(0,p.$JY)(m,w,F),{mappings:F.map(P=>new c.$vs(m.translateRange(P.seq1Range),w.translateRange(P.seq2Range))),hitTimeout:M.hitTimeout}}}t.$KY=E;function A(v,f,h,i=!1){const l=[];for(const N of(0,k.$yb)(v.map(m=>g(m,f,h)),(m,w)=>m.original.overlapOrTouch(w.original)||m.modified.overlapOrTouch(w.modified))){const m=N[0],w=N[N.length-1];l.push(new c.$us(m.original.join(w.original),m.modified.join(w.modified),N.map(M=>M.innerChanges[0])))}return(0,_.$wc)(()=>!i&&l.length>0&&l[0].original.startLineNumber!==l[0].modified.startLineNumber?!1:(0,_.$xc)(l,(N,m)=>m.original.startLineNumber-N.original.endLineNumberExclusive===m.modified.startLineNumber-N.modified.endLineNumberExclusive&&N.original.endLineNumberExclusive<m.original.startLineNumber&&N.modified.endLineNumberExclusive<m.modified.startLineNumber)),l}t.$LY=A;function g(v,f,h){let i=0,l=0;v.modifiedRange.endColumn===1&&v.originalRange.endColumn===1&&v.originalRange.startLineNumber+i<=v.originalRange.endLineNumber&&v.modifiedRange.startLineNumber+i<=v.modifiedRange.endLineNumber&&(l=-1),v.modifiedRange.startColumn-1>=h[v.modifiedRange.startLineNumber-1].length&&v.originalRange.startColumn-1>=f[v.originalRange.startLineNumber-1].length&&v.originalRange.startLineNumber<=v.originalRange.endLineNumber+l&&v.modifiedRange.startLineNumber<=v.modifiedRange.endLineNumber+l&&(i=1);const N=new r.$rs(v.originalRange.startLineNumber+i,v.originalRange.endLineNumber+1+l),m=new r.$rs(v.modifiedRange.startLineNumber+i,v.modifiedRange.endLineNumber+1+l);return new c.$us(N,m,[v])}t.$MY=g}),te(ne[33],ie([0,1,25,32,16,6,2,13,12]),function(B,t,k,_,r,a,L,o,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=t.$ys=void 0;const s=3;class d{computeDiff(i,l,N){const w=new A(i,l,{maxComputationTime:N.maxComputationTimeMs,shouldIgnoreTrimWhitespace:N.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let F=null;for(const y of w.changes){let P;y.originalEndLineNumber===0?P=new u.$rs(y.originalStartLineNumber+1,y.originalStartLineNumber+1):P=new u.$rs(y.originalStartLineNumber,y.originalEndLineNumber+1);let R;y.modifiedEndLineNumber===0?R=new u.$rs(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):R=new u.$rs(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let I=new r.$us(P,R,y.charChanges?.map(q=>new r.$vs(new L.$is(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new L.$is(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));F&&(F.modified.endLineNumberExclusive===I.modified.startLineNumber||F.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new r.$us(F.original.join(I.original),F.modified.join(I.modified),F.innerChanges&&I.innerChanges?F.innerChanges.concat(I.innerChanges):void 0),M.pop()),M.push(I),F=I}return(0,o.$wc)(()=>(0,o.$xc)(M,(y,P)=>P.original.startLineNumber-y.original.endLineNumberExclusive===P.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<P.original.startLineNumber&&y.modified.endLineNumberExclusive<P.modified.startLineNumber)),new _.$ws(M,[],w.quitEarly)}}t.$ys=d;function p(h,i,l,N){return new k.$os(h,i,l).ComputeDiff(N)}class b{constructor(i){const l=[],N=[];for(let m=0,w=i.length;m<w;m++)l[m]=g(i[m],1),N[m]=v(i[m],1);this.lines=i,this.a=l,this.b=N}getElements(){const i=[];for(let l=0,N=this.lines.length;l<N;l++)i[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,l,N){const m=[],w=[],M=[];let F=0;for(let y=l;y<=N;y++){const P=this.lines[y],R=i?this.a[y]:1,I=i?this.b[y]:P.length+1;for(let q=R;q<I;q++)m[F]=P.charCodeAt(q-1),w[F]=y+1,M[F]=q,F++;!i&&y<N&&(m[F]=10,w[F]=y+1,M[F]=P.length+1,F++)}return new c(m,w,M)}}class c{constructor(i,l,N){this.a=i,this.b=l,this.d=N}toString(){return"["+this.a.map((i,l)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(i,l){if(i<0||i>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,l,N,m,w,M,F,y){this.originalStartLineNumber=i,this.originalStartColumn=l,this.originalEndLineNumber=N,this.originalEndColumn=m,this.modifiedStartLineNumber=w,this.modifiedStartColumn=M,this.modifiedEndLineNumber=F,this.modifiedEndColumn=y}static createFromDiffChange(i,l,N){const m=l.getStartLineNumber(i.originalStart),w=l.getStartColumn(i.originalStart),M=l.getEndLineNumber(i.originalStart+i.originalLength-1),F=l.getEndColumn(i.originalStart+i.originalLength-1),y=N.getStartLineNumber(i.modifiedStart),P=N.getStartColumn(i.modifiedStart),R=N.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),I=N.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(m,w,M,F,y,P,R,I)}}function $(h){if(h.length<=1)return h;const i=[h[0]];let l=i[0];for(let N=1,m=h.length;N<m;N++){const w=h[N],M=w.originalStart-(l.originalStart+l.originalLength),F=w.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(M,F)<s?(l.originalLength=w.originalStart+w.originalLength-l.originalStart,l.modifiedLength=w.modifiedStart+w.modifiedLength-l.modifiedStart):(i.push(w),l=w)}return i}class E{constructor(i,l,N,m,w){this.originalStartLineNumber=i,this.originalEndLineNumber=l,this.modifiedStartLineNumber=N,this.modifiedEndLineNumber=m,this.charChanges=w}static createFromDiffResult(i,l,N,m,w,M,F){let y,P,R,I,q;if(l.originalLength===0?(y=N.getStartLineNumber(l.originalStart)-1,P=0):(y=N.getStartLineNumber(l.originalStart),P=N.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(R=m.getStartLineNumber(l.modifiedStart)-1,I=0):(R=m.getStartLineNumber(l.modifiedStart),I=m.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),M&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&w()){const S=N.createCharSequence(i,l.originalStart,l.originalStart+l.originalLength-1),z=m.createCharSequence(i,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(S.getElements().length>0&&z.getElements().length>0){let D=p(S,z,w,!0).changes;F&&(D=$(D)),q=[];for(let j=0,x=D.length;j<x;j++)q.push(e.createFromDiffChange(D[j],S,z))}}return new E(y,P,R,I,q)}}class A{constructor(i,l,N){this.a=N.shouldComputeCharChanges,this.b=N.shouldPostProcessCharChanges,this.d=N.shouldIgnoreTrimWhitespace,this.e=N.shouldMakePrettyDiff,this.f=i,this.g=l,this.h=new b(i),this.j=new b(l),this.k=f(N.maxComputationTime),this.l=f(N.maxComputationTime===0?0:Math.min(N.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=p(this.h,this.j,this.k,this.e),l=i.changes,N=i.quitEarly;if(this.d){const F=[];for(let y=0,P=l.length;y<P;y++)F.push(E.createFromDiffResult(this.d,l[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:N,changes:F}}const m=[];let w=0,M=0;for(let F=-1,y=l.length;F<y;F++){const P=F+1<y?l[F+1]:null,R=P?P.originalStart:this.f.length,I=P?P.modifiedStart:this.g.length;for(;w<R&&M<I;){const q=this.f[w],S=this.g[M];if(q!==S){{let z=g(q,1),D=g(S,1);for(;z>1&&D>1;){const j=q.charCodeAt(z-2),x=S.charCodeAt(D-2);if(j!==x)break;z--,D--}(z>1||D>1)&&this.m(m,w+1,1,z,M+1,1,D)}{let z=v(q,1),D=v(S,1);const j=q.length+1,x=S.length+1;for(;z<j&&D<x;){const W=q.charCodeAt(z-1),J=q.charCodeAt(D-1);if(W!==J)break;z++,D++}(z<j||D<x)&&this.m(m,w+1,z,j,M+1,D,x)}}w++,M++}P&&(m.push(E.createFromDiffResult(this.d,P,this.h,this.j,this.l,this.a,this.b)),w+=P.originalLength,M+=P.modifiedLength)}return{quitEarly:N,changes:m}}m(i,l,N,m,w,M,F){if(this.n(i,l,N,m,w,M,F))return;let y;this.a&&(y=[new e(l,N,l,m,w,M,w,F)]),i.push(new E(l,l,w,w,y))}n(i,l,N,m,w,M,F){const y=i.length;if(y===0)return!1;const P=i[y-1];return P.originalEndLineNumber===0||P.modifiedEndLineNumber===0?!1:P.originalEndLineNumber===l&&P.modifiedEndLineNumber===w?(this.a&&P.charChanges&&P.charChanges.push(new e(l,N,l,m,w,M,w,F)),!0):P.originalEndLineNumber+1===l&&P.modifiedEndLineNumber+1===w?(P.originalEndLineNumber=l,P.modifiedEndLineNumber=w,this.a&&P.charChanges&&P.charChanges.push(new e(l,N,l,m,w,M,w,F)),!0):!1}}t.$zs=A;function g(h,i){const l=a.$Ae(h);return l===-1?i:l+1}function v(h,i){const l=a.$Ce(h);return l===-1?i:l+2}function f(h){if(h===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<h}}),te(ne[49],ie([0,1,33,48]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NY=void 0,t.$NY={getLegacy:()=>new k.$ys,getDefault:()=>new _.$KY}}),te(ne[50],ie([0,1,34]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OY=void 0;function _(b){const c=[];for(const e of b){const $=Number(e);($||$===0&&e.replace(/\s/g,"")!=="")&&c.push($)}return c}function r(b,c,e,$){return{red:b/255,blue:e/255,green:c/255,alpha:$}}function a(b,c){const e=c.index,$=c[0].length;if(!e)return;const E=b.positionAt(e);return{startLineNumber:E.lineNumber,startColumn:E.column,endLineNumber:E.lineNumber,endColumn:E.column+$}}function L(b,c){if(!b)return;const e=k.$Ms.Format.CSS.parseHex(c);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function o(b,c,e){if(!b||c.length!==1)return;const E=c[0].values(),A=_(E);return{range:b,color:r(A[0],A[1],A[2],e?A[3]:1)}}function u(b,c,e){if(!b||c.length!==1)return;const E=c[0].values(),A=_(E),g=new k.$Ms(new k.$Ks(A[0],A[1]/100,A[2]/100,e?A[3]:1));return{range:b,color:r(g.rgba.r,g.rgba.g,g.rgba.b,g.rgba.a)}}function s(b,c){return typeof b=="string"?[...b.matchAll(c)]:b.findMatches(c)}function d(b){const c=[],$=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if($.length>0)for(const E of $){const A=E.filter(h=>h!==void 0),g=A[1],v=A[2];if(!v)continue;let f;if(g==="rgb"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;f=o(a(b,E),s(v,h),!1)}else if(g==="rgba"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;f=o(a(b,E),s(v,h),!0)}else if(g==="hsl"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;f=u(a(b,E),s(v,h),!1)}else if(g==="hsla"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;f=u(a(b,E),s(v,h),!0)}else g==="#"&&(f=L(a(b,E),g+v));f&&c.push(f)}return c}function p(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:d(b)}t.$OY=p}),te(ne[51],ie([0,1,28]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pY=t.$oY=t.$nY=t.State=void 0;var _;(function(c){c[c.Invalid=0]="Invalid",c[c.Start=1]="Start",c[c.H=2]="H",c[c.HT=3]="HT",c[c.HTT=4]="HTT",c[c.HTTP=5]="HTTP",c[c.F=6]="F",c[c.FI=7]="FI",c[c.FIL=8]="FIL",c[c.BeforeColon=9]="BeforeColon",c[c.AfterColon=10]="AfterColon",c[c.AlmostThere=11]="AlmostThere",c[c.End=12]="End",c[c.Accept=13]="Accept",c[c.LastKnownState=14]="LastKnownState"})(_||(t.State=_={}));class r{constructor(e,$,E){const A=new Uint8Array(e*$);for(let g=0,v=e*$;g<v;g++)A[g]=E;this.a=A,this.rows=e,this.cols=$}get(e,$){return this.a[e*this.cols+$]}set(e,$,E){this.a[e*this.cols+$]=E}}class a{constructor(e){let $=0,E=0;for(let g=0,v=e.length;g<v;g++){const[f,h,i]=e[g];h>$&&($=h),f>E&&(E=f),i>E&&(E=i)}$++,E++;const A=new r(E,$,0);for(let g=0,v=e.length;g<v;g++){const[f,h,i]=e[g];A.set(f,h,i)}this.a=A,this.b=$}nextState(e,$){return $<0||$>=this.b?0:this.a.get(e,$)}}t.$nY=a;let L=null;function o(){return L===null&&(L=new a([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var u;(function(c){c[c.None=0]="None",c[c.ForceTermination=1]="ForceTermination",c[c.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let s=null;function d(){if(s===null){s=new k.$Fs(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let $=0;$<c.length;$++)s.set(c.charCodeAt($),1);const e=".,;:";for(let $=0;$<e.length;$++)s.set(e.charCodeAt($),2)}return s}class p{static a(e,$,E,A,g){let v=g-1;do{const f=$.charCodeAt(v);if(e.get(f)!==2)break;v--}while(v>A);if(A>0){const f=$.charCodeAt(A-1),h=$.charCodeAt(v);(f===40&&h===41||f===91&&h===93||f===123&&h===125)&&v--}return{range:{startLineNumber:E,startColumn:A+1,endLineNumber:E,endColumn:v+2},url:$.substring(A,v+1)}}static computeLinks(e,$=o()){const E=d(),A=[];for(let g=1,v=e.getLineCount();g<=v;g++){const f=e.getLineContent(g),h=f.length;let i=0,l=0,N=0,m=1,w=!1,M=!1,F=!1,y=!1;for(;i<h;){let P=!1;const R=f.charCodeAt(i);if(m===13){let I;switch(R){case 40:w=!0,I=0;break;case 41:I=w?0:1;break;case 91:F=!0,M=!0,I=0;break;case 93:F=!1,I=M?0:1;break;case 123:y=!0,I=0;break;case 125:I=y?0:1;break;case 39:case 34:case 96:N===R?I=1:N===39||N===34||N===96?I=0:I=1;break;case 42:I=N===42?1:0;break;case 124:I=N===124?1:0;break;case 32:I=F?0:1;break;default:I=E.get(R)}I===1&&(A.push(p.a(E,f,g,l,i)),P=!0)}else if(m===12){let I;R===91?(M=!0,I=0):I=E.get(R),I===1?P=!0:m=13}else m=$.nextState(m,R),m===0&&(P=!0);P&&(m=1,w=!1,M=!1,y=!1,l=i+1,N=R),i++}m===13&&A.push(p.a(E,f,g,l,h))}return A}}t.$oY=p;function b(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:p.computeLinks(c)}t.$pY=b}),te(ne[52],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qY=void 0;class k{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new k}navigateValueSet(r,a,L,o,u){if(r&&a){const s=this.a(a,u);if(s)return{range:r,value:s}}if(L&&o){const s=this.a(o,u);if(s)return{range:L,value:s}}return null}a(r,a){const L=this.b(r,a);return L!==null?L:this.d(r,a)}b(r,a){const L=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let o=Number(r);const u=parseFloat(r);return!isNaN(o)&&!isNaN(u)&&o===u?o===0&&!a?null:(o=Math.floor(o*L),o+=a?L:-L,String(o/L)):null}d(r,a){return this.e(this.c,r,a)}e(r,a,L){let o=null;for(let u=0,s=r.length;o===null&&u<s;u++)o=this.f(r[u],a,L);return o}f(r,a,L){let o=r.indexOf(a);return o>=0?(o+=L?1:-1,o<0?o=r.length-1:o%=r.length,r[o]):null}}t.$qY=k}),te(ne[53],ie([0,1,14]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eu=t.$Du=t.$Cu=t.$Bu=t.ModelConstants=t.PositionAffinity=t.$Au=t.TrackedRangeStickiness=t.$zu=t.$yu=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var _;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(_||(t.OverviewRulerLane=_={}));var r;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var a;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(a||(t.MinimapPosition=a={}));var L;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(L||(t.InjectedTextCursorStops=L={}));var o;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(o||(t.EndOfLinePreference=o={}));var u;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var s;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class d{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),h.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,h.indentSize|0),this.a=!1),this.insertSpaces=!!h.insertSpaces,this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=!!h.trimAutoWhitespace,this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.a===h.a&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,k.$Ym)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}t.$yu=d;class p{constructor(h,i){this._findMatchBrand=void 0,this.range=h,this.matches=i}}t.$zu=p;var b;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function c(f){return f&&typeof f.read=="function"}t.$Au=c;var e;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var $;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})($||(t.ModelConstants=$={}));class E{constructor(h,i,l,N,m,w){this.identifier=h,this.range=i,this.text=l,this.forceMoveMarkers=N,this.isAutoWhitespaceEdit=m,this._isTracked=w}}t.$Bu=E;class A{constructor(h,i,l){this.regex=h,this.wordSeparators=i,this.simpleSearch=l}}t.$Cu=A;class g{constructor(h,i,l){this.reverseEdits=h,this.changes=i,this.trimAutoWhitespaceLineNumbers=l}}t.$Du=g;function v(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}t.$Eu=v}),te(ne[54],ie([0,1,7,27]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ju=t.$Iu=t.$Hu=void 0;class r{constructor(u){this.a=u,this.b=new Uint32Array(u.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(u,s){u=(0,_.$ke)(u);const d=this.a,p=this.b,b=s.length;return b===0?!1:(this.a=new Uint32Array(d.length+b),this.a.set(d.subarray(0,u),0),this.a.set(d.subarray(u),u+b),this.a.set(s,u),u-1<this.c[0]&&(this.c[0]=u-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(p.subarray(0,this.c[0]+1)),!0)}setValue(u,s){return u=(0,_.$ke)(u),s=(0,_.$ke)(s),this.a[u]===s?!1:(this.a[u]=s,u-1<this.c[0]&&(this.c[0]=u-1),!0)}removeValues(u,s){u=(0,_.$ke)(u),s=(0,_.$ke)(s);const d=this.a,p=this.b;if(u>=d.length)return!1;const b=d.length-u;return s>=b&&(s=b),s===0?!1:(this.a=new Uint32Array(d.length-s),this.a.set(d.subarray(0,u),0),this.a.set(d.subarray(u+s),u),this.b=new Uint32Array(this.a.length),u-1<this.c[0]&&(this.c[0]=u-1),this.c[0]>=0&&this.b.set(p.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(u){return u<0?0:(u=(0,_.$ke)(u),this.d(u))}d(u){if(u<=this.c[0])return this.b[u];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),u>=this.a.length&&(u=this.a.length-1);for(let d=s;d<=u;d++)this.b[d]=this.b[d-1]+this.a[d];return this.c[0]=Math.max(this.c[0],u),this.b[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let s=0,d=this.a.length-1,p=0,b=0,c=0;for(;s<=d;)if(p=s+(d-s)/2|0,b=this.b[p],c=b-this.a[p],u<c)d=p-1;else if(u>=b)s=p+1;else break;return new L(p,u-c)}}t.$Hu=r;class a{constructor(u){this.a=u,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(u){return this.g(),u===0?0:this.d[u-1]}getIndexOf(u){this.g();const s=this.e[u],d=s>0?this.d[s-1]:0;return new L(s,u-d)}removeValues(u,s){this.a.splice(u,s),this.f(u)}insertValues(u,s){this.a=(0,k.$Tb)(this.a,u,s),this.f(u)}f(u){this.b=!1,this.c=Math.min(this.c,u-1)}g(){if(!this.b){for(let u=this.c+1,s=this.a.length;u<s;u++){const d=this.a[u],p=u>0?this.d[u-1]:0;this.d[u]=p+d;for(let b=0;b<d;b++)this.e[p+b]=u}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(u,s){this.a[u]!==s&&(this.a[u]=s,this.f(u))}}t.$Iu=a;class L{constructor(u,s){this.index=u,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=s}}t.$Ju=L}),te(ne[55],ie([0,1,6,5,54]),function(B,t,k,_,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ku=void 0;class a{constructor(o,u,s,d){this.d=o,this.f=u,this.g=s,this.h=d,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(o){o.eol&&o.eol!==this.g&&(this.g=o.eol,this.j=null);const u=o.changes;for(const s of u)this.o(s.range),this.p(new _.$hs(s.range.startLineNumber,s.range.startColumn),s.text);this.h=o.versionId,this.k=null}l(){if(!this.j){const o=this.g.length,u=this.f.length,s=new Uint32Array(u);for(let d=0;d<u;d++)s[d]=this.f[d].length+o;this.j=new r.$Hu(s)}}n(o,u){this.f[o]=u,this.j&&this.j.setValue(o,this.f[o].length+this.g.length)}o(o){if(o.startLineNumber===o.endLineNumber){if(o.startColumn===o.endColumn)return;this.n(o.startLineNumber-1,this.f[o.startLineNumber-1].substring(0,o.startColumn-1)+this.f[o.startLineNumber-1].substring(o.endColumn-1));return}this.n(o.startLineNumber-1,this.f[o.startLineNumber-1].substring(0,o.startColumn-1)+this.f[o.endLineNumber-1].substring(o.endColumn-1)),this.f.splice(o.startLineNumber,o.endLineNumber-o.startLineNumber),this.j&&this.j.removeValues(o.startLineNumber,o.endLineNumber-o.startLineNumber)}p(o,u){if(u.length===0)return;const s=(0,k.$ze)(u);if(s.length===1){this.n(o.lineNumber-1,this.f[o.lineNumber-1].substring(0,o.column-1)+s[0]+this.f[o.lineNumber-1].substring(o.column-1));return}s[s.length-1]+=this.f[o.lineNumber-1].substring(o.column-1),this.n(o.lineNumber-1,this.f[o.lineNumber-1].substring(0,o.column-1)+s[0]);const d=new Uint32Array(s.length-1);for(let p=1;p<s.length;p++)this.f.splice(o.lineNumber+p-1,0,s[p]),d[p-1]=s[p].length+this.g.length;this.j&&this.j.insertValues(o.lineNumber,d)}}t.$Ku=a}),te(ne[56],ie([0,1,6,43,5,2,53]),function(B,t,k,_,r,a,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jC=t.$iC=t.$hC=t.$gC=t.$fC=t.$eC=void 0;const o=999;class u{constructor(g,v,f,h){this.searchString=g,this.isRegex=v,this.matchCase=f,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=s(this.searchString):g=this.searchString.indexOf(`
`)>=0;let v=null;try{v=k.$xe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!v)return null;let f=!this.isRegex&&!g;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new L.$Cu(v,this.wordSeparators?(0,_.$Is)(this.wordSeparators):null,f?this.searchString:null)}}t.$eC=u;function s(A){if(!A||A.length===0)return!1;for(let g=0,v=A.length;g<v;g++){const f=A.charCodeAt(g);if(f===10)return!0;if(f===92){if(g++,g>=v)break;const h=A.charCodeAt(g);if(h===110||h===114||h===87)return!0}}return!1}t.$fC=s;function d(A,g,v){if(!v)return new L.$zu(A,null);const f=[];for(let h=0,i=g.length;h<i;h++)f[h]=g[h];return new L.$zu(A,f)}t.$gC=d;class p{constructor(g){const v=[];let f=0;for(let h=0,i=g.length;h<i;h++)g.charCodeAt(h)===10&&(v[f++]=h);this.a=v}findLineFeedCountBeforeOffset(g){const v=this.a;let f=0,h=v.length-1;if(h===-1||g<=v[0])return 0;for(;f<h;){const i=f+((h-f)/2>>0);v[i]>=g?h=i-1:v[i+1]>=g?(f=i,h=i):f=i+1}return f+1}}class b{static findMatches(g,v,f,h,i){const l=v.parseSearchRequest();return l?l.regex.multiline?this.b(g,f,new E(l.wordSeparators,l.regex),h,i):this.c(g,f,l,h,i):[]}static a(g,v,f,h,i,l){let N,m=0;h?(m=h.findLineFeedCountBeforeOffset(i),N=v+i+m):N=v+i;let w;if(h){const P=h.findLineFeedCountBeforeOffset(i+l.length)-m;w=N+l.length+P}else w=N+l.length;const M=g.getPositionAt(N),F=g.getPositionAt(w);return new a.$is(M.lineNumber,M.column,F.lineNumber,F.column)}static b(g,v,f,h,i){const l=g.getOffsetAt(v.getStartPosition()),N=g.getValueInRange(v,1),m=g.getEOL()===`\r
`?new p(N):null,w=[];let M=0,F;for(f.reset(0);F=f.next(N);)if(w[M++]=d(this.a(g,l,N,m,F.index,F[0]),F,h),M>=i)return w;return w}static c(g,v,f,h,i){const l=[];let N=0;if(v.startLineNumber===v.endLineNumber){const w=g.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return N=this.d(f,w,v.startLineNumber,v.startColumn-1,N,l,h,i),l}const m=g.getLineContent(v.startLineNumber).substring(v.startColumn-1);N=this.d(f,m,v.startLineNumber,v.startColumn-1,N,l,h,i);for(let w=v.startLineNumber+1;w<v.endLineNumber&&N<i;w++)N=this.d(f,g.getLineContent(w),w,0,N,l,h,i);if(N<i){const w=g.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);N=this.d(f,w,v.endLineNumber,0,N,l,h,i)}return l}static d(g,v,f,h,i,l,N,m){const w=g.wordSeparators;if(!N&&g.simpleSearch){const y=g.simpleSearch,P=y.length,R=v.length;let I=-P;for(;(I=v.indexOf(y,I+P))!==-1;)if((!w||$(w,v,R,I,P))&&(l[i++]=new L.$zu(new a.$is(f,I+1+h,f,I+1+P+h),null),i>=m))return i;return i}const M=new E(g.wordSeparators,g.regex);let F;M.reset(0);do if(F=M.next(v),F&&(l[i++]=d(new a.$is(f,F.index+1+h,f,F.index+1+F[0].length+h),F,N),i>=m))return i;while(F);return i}static findNextMatch(g,v,f,h){const i=v.parseSearchRequest();if(!i)return null;const l=new E(i.wordSeparators,i.regex);return i.regex.multiline?this.e(g,f,l,h):this.f(g,f,l,h)}static e(g,v,f,h){const i=new r.$hs(v.lineNumber,1),l=g.getOffsetAt(i),N=g.getLineCount(),m=g.getValueInRange(new a.$is(i.lineNumber,i.column,N,g.getLineMaxColumn(N)),1),w=g.getEOL()===`\r
`?new p(m):null;f.reset(v.column-1);const M=f.next(m);return M?d(this.a(g,l,m,w,M.index,M[0]),M,h):v.lineNumber!==1||v.column!==1?this.e(g,new r.$hs(1,1),f,h):null}static f(g,v,f,h){const i=g.getLineCount(),l=v.lineNumber,N=g.getLineContent(l),m=this.g(f,N,l,v.column,h);if(m)return m;for(let w=1;w<=i;w++){const M=(l+w-1)%i,F=g.getLineContent(M+1),y=this.g(f,F,M+1,1,h);if(y)return y}return null}static g(g,v,f,h,i){g.reset(h-1);const l=g.next(v);return l?d(new a.$is(f,l.index+1,f,l.index+1+l[0].length),l,i):null}static findPreviousMatch(g,v,f,h){const i=v.parseSearchRequest();if(!i)return null;const l=new E(i.wordSeparators,i.regex);return i.regex.multiline?this.h(g,f,l,h):this.j(g,f,l,h)}static h(g,v,f,h){const i=this.b(g,new a.$is(1,1,v.lineNumber,v.column),f,h,10*o);if(i.length>0)return i[i.length-1];const l=g.getLineCount();return v.lineNumber!==l||v.column!==g.getLineMaxColumn(l)?this.h(g,new r.$hs(l,g.getLineMaxColumn(l)),f,h):null}static j(g,v,f,h){const i=g.getLineCount(),l=v.lineNumber,N=g.getLineContent(l).substring(0,v.column-1),m=this.k(f,N,l,h);if(m)return m;for(let w=1;w<=i;w++){const M=(i+l-w-1)%i,F=g.getLineContent(M+1),y=this.k(f,F,M+1,h);if(y)return y}return null}static k(g,v,f,h){let i=null,l;for(g.reset(0);l=g.next(v);)i=d(new a.$is(f,l.index+1,f,l.index+1+l[0].length),l,h);return i}}t.$hC=b;function c(A,g,v,f,h){if(f===0)return!0;const i=g.charCodeAt(f-1);if(A.get(i)!==0||i===13||i===10)return!0;if(h>0){const l=g.charCodeAt(f);if(A.get(l)!==0)return!0}return!1}function e(A,g,v,f,h){if(f+h===v)return!0;const i=g.charCodeAt(f+h);if(A.get(i)!==0||i===13||i===10)return!0;if(h>0){const l=g.charCodeAt(f+h-1);if(A.get(l)!==0)return!0}return!1}function $(A,g,v,f,h){return c(A,g,v,f,h)&&e(A,g,v,f,h)}t.$iC=$;class E{constructor(g,v){this._wordSeparators=g,this.a=v,this.b=-1,this.c=0}reset(g){this.a.lastIndex=g,this.b=-1,this.c=0}next(g){const v=g.length;let f;do{if(this.b+this.c===v||(f=this.a.exec(g),!f))return null;const h=f.index,i=f[0].length;if(h===this.b&&i===this.c){if(i===0){k.$Se(g,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=h,this.c=i,!this._wordSeparators||$(this._wordSeparators,g,v,h,i))return f}while(f);return null}}t.$jC=E}),te(ne[57],ie([0,1,2,56,6,13,29]),function(B,t,k,_,r,a,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$mY=void 0;class o{static computeUnicodeHighlights(e,$,E){const A=E?E.startLineNumber:1,g=E?E.endLineNumber:e.getLineCount(),v=new d($),f=v.getCandidateCodePoints();let h;f==="allNonBasicAscii"?h=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):h=new RegExp(`${u(Array.from(f))}`,"g");const i=new _.$jC(null,h),l=[];let N=!1,m,w=0,M=0,F=0;e:for(let y=A,P=g;y<=P;y++){const R=e.getLineContent(y),I=R.length;i.reset(0);do if(m=i.next(R),m){let q=m.index,S=m.index+m[0].length;if(q>0){const x=R.charCodeAt(q-1);r.$Pe(x)&&q--}if(S+1<I){const x=R.charCodeAt(S-1);r.$Pe(x)&&S++}const z=R.substring(q,S);let D=(0,L.$Xr)(q+1,L.$Ur,R,0);D&&D.endColumn<=q+1&&(D=null);const j=v.shouldHighlightNonBasicASCII(z,D?D.word:null);if(j!==0){j===3?w++:j===2?M++:j===1?F++:(0,a.$uc)(j);const x=1e3;if(l.length>=x){N=!0;break e}l.push(new k.$is(y,q+1,y,S+1))}}while(m)}return{ranges:l,hasMore:N,ambiguousCharacterCount:w,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:F}}static computeUnicodeHighlightReason(e,$){const E=new d($);switch(E.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const g=e.codePointAt(0),v=E.ambiguousCharacters.getPrimaryConfusable(g),f=r.$gf.getLocales().filter(h=>!r.$gf.getInstance(new Set([...$.allowedLocales,h])).isAmbiguous(g));return{kind:0,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:f}}case 1:return{kind:2}}}}t.$mY=o;function u(c,e){return`[${r.$pe(c.map(E=>String.fromCodePoint(E)).join(""))}]`}var s;(function(c){c[c.Ambiguous=0]="Ambiguous",c[c.Invisible=1]="Invisible",c[c.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class d{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$gf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const $ of r.$hf.codePoints)p(String.fromCodePoint($))||e.add($);if(this.b.ambiguousCharacters)for(const $ of this.ambiguousCharacters.getConfusableCodePoints())e.add($);for(const $ of this.a)e.delete($);return e}shouldHighlightNonBasicASCII(e,$){const E=e.codePointAt(0);if(this.a.has(E))return 0;if(this.b.nonBasicASCII)return 1;let A=!1,g=!1;if($)for(const v of $){const f=v.codePointAt(0),h=r.$1e(v);A=A||h,!h&&!this.ambiguousCharacters.isAmbiguous(f)&&!r.$hf.isInvisibleCharacter(f)&&(g=!0)}return!A&&g?0:this.b.invisibleCharacters&&!p(e)&&r.$hf.isInvisibleCharacter(E)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(E)?3:0}}function p(c){return c===" "||c===`
`||c==="	"}var b;(function(c){c[c.None=0]="None",c[c.NonBasicASCII=1]="NonBasicASCII",c[c.Invisible=2]="Invisible",c[c.Ambiguous=3]="Ambiguous"})(b||(b={}))}),te(ne[58],ie([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var k;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(k||(t.AccessibilitySupport=k={}));var _;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(_||(t.CodeActionTriggerType=_={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var a;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(a||(t.CompletionItemKind=a={}));var L;(function(n){n[n.Deprecated=1]="Deprecated"})(L||(t.CompletionItemTag=L={}));var o;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(o||(t.CompletionTriggerKind=o={}));var u;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(u||(t.ContentWidgetPositionPreference=u={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var d;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(d||(t.DefaultEndOfLine=d={}));var p;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(p||(t.DocumentHighlightKind=p={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var c;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(c||(t.EditorOption=c={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var $;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})($||(t.EndOfLineSequence=$={}));var E;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(E||(t.GlyphMarginLane=E={}));var A;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(A||(t.IndentAction=A={}));var g;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(g||(t.InjectedTextCursorStops=g={}));var v;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(v||(t.InlayHintKind=v={}));var f;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(f||(t.InlineCompletionTriggerKind=f={}));var h;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(h||(t.KeyCode=h={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var l;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(l||(t.MarkerTag=l={}));var N;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(N||(t.MinimapPosition=N={}));var m;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(m||(t.MouseTargetType=m={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var F;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(F||(t.PositionAffinity=F={}));var y;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(y||(t.RenderLineNumbersType=y={}));var P;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(P||(t.RenderMinimap=P={}));var R;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(R||(t.ScrollType=R={}));var I;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(I||(t.ScrollbarVisibility=I={}));var q;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(q||(t.SelectionDirection=q={}));var S;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(S||(t.SignatureHelpTriggerKind=S={}));var z;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(z||(t.SymbolKind=z={}));var D;(function(n){n[n.Deprecated=1]="Deprecated"})(D||(t.SymbolTag=D={}));var j;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(j||(t.TextEditorCursorBlinkingStyle=j={}));var x;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(x||(t.TextEditorCursorStyle=x={}));var W;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(W||(t.TrackedRangeStickiness=W={}));var J;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(J||(t.WrappingIndent=J={}))}),te(ne[59],ie([0,1,11,10]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ts=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new k.$ed,this.onDidChange=this.c.event,this.d=null}handleChange(o){this.c.fire({changedLanguages:o,changedColorMap:!1})}register(o,u){return this.a.set(o,u),this.handleChange([o]),(0,_.$hc)(()=>{this.a.get(o)===u&&(this.a.delete(o),this.handleChange([o]))})}get(o){return this.a.get(o)||null}registerFactory(o,u){this.b.get(o)?.dispose();const s=new a(this,o,u);return this.b.set(o,s),(0,_.$hc)(()=>{const d=this.b.get(o);!d||d!==s||(this.b.delete(o),d.dispose())})}async getOrCreate(o){const u=this.get(o);if(u)return u;const s=this.b.get(o);return!s||s.isResolved?null:(await s.resolve(),this.get(o))}isResolved(o){if(this.get(o))return!0;const s=this.b.get(o);return!!(!s||s.isResolved)}setColorMap(o){this.d=o,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Ts=r;class a extends _.$jc{get isResolved(){return this.c}constructor(o,u,s){super(),this.f=o,this.g=u,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const o=await this.h.tokenizationSupport;this.c=!0,o&&!this.a&&this.B(this.f.register(this.g,o))}}}),te(ne[60],ie([61,62]),function(B,t){return B.create("vs/base/common/platform",t)}),te(ne[17],ie([0,1,60]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let _=!1,r=!1,a=!1,L=!1,o=!1,u=!1,s=!1,d=!1,p=!1,b=!1,c,e=t.$f,$=t.$f,E,A;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?g=t.$g.vscode.process:typeof process<"u"&&(g=process);const v=typeof g?.versions?.electron=="string",f=v&&g?.type==="renderer";if(typeof navigator=="object"&&!f)A=navigator.userAgent,_=A.indexOf("Windows")>=0,r=A.indexOf("Macintosh")>=0,d=(A.indexOf("Macintosh")>=0||A.indexOf("iPad")>=0||A.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,a=A.indexOf("Linux")>=0,b=A?.indexOf("Mobi")>=0,u=!0,c=k.getConfiguredDefaultLocale(k.localize(0,null))||t.$f,e=c,$=navigator.language;else if(typeof g=="object"){_=g.platform==="win32",r=g.platform==="darwin",a=g.platform==="linux",L=a&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,s=v,p=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=t.$f,e=t.$f;const y=g.env.VSCODE_NLS_CONFIG;if(y)try{const P=JSON.parse(y),R=P.availableLanguages["*"];c=P.locale,$=P.osLocale,e=R||t.$f,E=P._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");var h;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(h||(t.Platform=h={}));function i(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=i;let l=0;r?l=1:_?l=3:a&&(l=2),t.$i=_,t.$j=r,t.$k=a,t.$l=L,t.$m=o,t.$n=s,t.$o=u,t.$p=u&&typeof t.$g.importScripts=="function",t.$q=d,t.$r=b,t.$s=p,t.$t=l,t.$u=A,t.$v=e;var N;(function(y){function P(){return t.$v}y.value=P;function R(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}y.isDefaultVariant=R;function I(){return t.$v==="en"}y.isDefault=I})(N||(t.Language=N={})),t.$w=c,t.$x=$,t.$y=E,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const y=[];t.$g.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let I=0,q=y.length;I<q;I++){const S=y[I];if(S.id===R.data.vscodeScheduleAsyncWork){y.splice(I,1),S.callback();return}}});let P=0;return R=>{const I=++P;y.push({id:I,callback:R}),t.$g.postMessage({vscodeScheduleAsyncWork:I},"*")}}return y=>setTimeout(y)})();var m;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(m||(t.OperatingSystem=m={})),t.OS=r||d?2:_?1:3;let w=!0,M=!1;function F(){if(!M){M=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,w=new Uint16Array(y.buffer)[0]===(2<<8)+1}return w}t.$C=F,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),te(ne[63],ie([0,1,17]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.$2d=t.env=t.cwd=void 0;let _;if(typeof k.$g.vscode<"u"&&typeof k.$g.vscode.process<"u"){const r=k.$g.vscode.process;_={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:_={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=_.cwd,t.env=_.env,t.$2d=_.platform,t.$3d=_.arch}),te(ne[64],ie([0,1,63]),function(B,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=t.sep=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=void 0;const _=65,r=97,a=90,L=122,o=46,u=47,s=92,d=58,p=63;class b extends Error{constructor(l,N,m){let w;typeof N=="string"&&N.indexOf("not ")===0?(w="must not be",N=N.replace(/^not /,"")):w="must be";const M=l.indexOf(".")!==-1?"property":"argument";let F=`The "${l}" ${M} ${w} of type ${N}`;F+=`. Received type ${typeof m}`,super(F),this.code="ERR_INVALID_ARG_TYPE"}}function c(i,l){if(i===null||typeof i!="object")throw new b(l,"Object",i)}function e(i,l){if(typeof i!="string")throw new b(l,"string",i)}const $=k.$2d==="win32";function E(i){return i===u||i===s}function A(i){return i===u}function g(i){return i>=_&&i<=a||i>=r&&i<=L}function v(i,l,N,m){let w="",M=0,F=-1,y=0,P=0;for(let R=0;R<=i.length;++R){if(R<i.length)P=i.charCodeAt(R);else{if(m(P))break;P=u}if(m(P)){if(!(F===R-1||y===1))if(y===2){if(w.length<2||M!==2||w.charCodeAt(w.length-1)!==o||w.charCodeAt(w.length-2)!==o){if(w.length>2){const I=w.lastIndexOf(N);I===-1?(w="",M=0):(w=w.slice(0,I),M=w.length-1-w.lastIndexOf(N)),F=R,y=0;continue}else if(w.length!==0){w="",M=0,F=R,y=0;continue}}l&&(w+=w.length>0?`${N}..`:"..",M=2)}else w.length>0?w+=`${N}${i.slice(F+1,R)}`:w=i.slice(F+1,R),M=R-F-1;F=R,y=0}else P===o&&y!==-1?++y:y=-1}return w}function f(i,l){c(l,"pathObject");const N=l.dir||l.root,m=l.base||`${l.name||""}${l.ext||""}`;return N?N===l.root?`${N}${m}`:`${N}${i}${m}`:m}t.$4d={resolve(...i){let l="",N="",m=!1;for(let w=i.length-1;w>=-1;w--){let M;if(w>=0){if(M=i[w],e(M,"path"),M.length===0)continue}else l.length===0?M=k.cwd():(M=k.env[`=${l}`]||k.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==l.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${l}\\`));const F=M.length;let y=0,P="",R=!1;const I=M.charCodeAt(0);if(F===1)E(I)&&(y=1,R=!0);else if(E(I))if(R=!0,E(M.charCodeAt(1))){let q=2,S=q;for(;q<F&&!E(M.charCodeAt(q));)q++;if(q<F&&q!==S){const z=M.slice(S,q);for(S=q;q<F&&E(M.charCodeAt(q));)q++;if(q<F&&q!==S){for(S=q;q<F&&!E(M.charCodeAt(q));)q++;(q===F||q!==S)&&(P=`\\\\${z}\\${M.slice(S,q)}`,y=q)}}}else y=1;else g(I)&&M.charCodeAt(1)===d&&(P=M.slice(0,2),y=2,F>2&&E(M.charCodeAt(2))&&(R=!0,y=3));if(P.length>0)if(l.length>0){if(P.toLowerCase()!==l.toLowerCase())continue}else l=P;if(m){if(l.length>0)break}else if(N=`${M.slice(y)}\\${N}`,m=R,R&&l.length>0)break}return N=v(N,!m,"\\",E),m?`${l}\\${N}`:`${l}${N}`||"."},normalize(i){e(i,"path");const l=i.length;if(l===0)return".";let N=0,m,w=!1;const M=i.charCodeAt(0);if(l===1)return A(M)?"\\":i;if(E(M))if(w=!0,E(i.charCodeAt(1))){let y=2,P=y;for(;y<l&&!E(i.charCodeAt(y));)y++;if(y<l&&y!==P){const R=i.slice(P,y);for(P=y;y<l&&E(i.charCodeAt(y));)y++;if(y<l&&y!==P){for(P=y;y<l&&!E(i.charCodeAt(y));)y++;if(y===l)return`\\\\${R}\\${i.slice(P)}\\`;y!==P&&(m=`\\\\${R}\\${i.slice(P,y)}`,N=y)}}}else N=1;else g(M)&&i.charCodeAt(1)===d&&(m=i.slice(0,2),N=2,l>2&&E(i.charCodeAt(2))&&(w=!0,N=3));let F=N<l?v(i.slice(N),!w,"\\",E):"";return F.length===0&&!w&&(F="."),F.length>0&&E(i.charCodeAt(l-1))&&(F+="\\"),m===void 0?w?`\\${F}`:F:w?`${m}\\${F}`:`${m}${F}`},isAbsolute(i){e(i,"path");const l=i.length;if(l===0)return!1;const N=i.charCodeAt(0);return E(N)||l>2&&g(N)&&i.charCodeAt(1)===d&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,N;for(let M=0;M<i.length;++M){const F=i[M];e(F,"path"),F.length>0&&(l===void 0?l=N=F:l+=`\\${F}`)}if(l===void 0)return".";let m=!0,w=0;if(typeof N=="string"&&E(N.charCodeAt(0))){++w;const M=N.length;M>1&&E(N.charCodeAt(1))&&(++w,M>2&&(E(N.charCodeAt(2))?++w:m=!1))}if(m){for(;w<l.length&&E(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return t.$4d.normalize(l)},relative(i,l){if(e(i,"from"),e(l,"to"),i===l)return"";const N=t.$4d.resolve(i),m=t.$4d.resolve(l);if(N===m||(i=N.toLowerCase(),l=m.toLowerCase(),i===l))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===s;)w++;let M=i.length;for(;M-1>w&&i.charCodeAt(M-1)===s;)M--;const F=M-w;let y=0;for(;y<l.length&&l.charCodeAt(y)===s;)y++;let P=l.length;for(;P-1>y&&l.charCodeAt(P-1)===s;)P--;const R=P-y,I=F<R?F:R;let q=-1,S=0;for(;S<I;S++){const D=i.charCodeAt(w+S);if(D!==l.charCodeAt(y+S))break;D===s&&(q=S)}if(S!==I){if(q===-1)return m}else{if(R>I){if(l.charCodeAt(y+S)===s)return m.slice(y+S+1);if(S===2)return m.slice(y+S)}F>I&&(i.charCodeAt(w+S)===s?q=S:S===2&&(q=3)),q===-1&&(q=0)}let z="";for(S=w+q+1;S<=M;++S)(S===M||i.charCodeAt(S)===s)&&(z+=z.length===0?"..":"\\..");return y+=q,z.length>0?`${z}${m.slice(y,P)}`:(m.charCodeAt(y)===s&&++y,m.slice(y,P))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=t.$4d.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const N=l.charCodeAt(2);if(N!==p&&N!==o)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(g(l.charCodeAt(0))&&l.charCodeAt(1)===d&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return i},dirname(i){e(i,"path");const l=i.length;if(l===0)return".";let N=-1,m=0;const w=i.charCodeAt(0);if(l===1)return E(w)?i:".";if(E(w)){if(N=m=1,E(i.charCodeAt(1))){let y=2,P=y;for(;y<l&&!E(i.charCodeAt(y));)y++;if(y<l&&y!==P){for(P=y;y<l&&E(i.charCodeAt(y));)y++;if(y<l&&y!==P){for(P=y;y<l&&!E(i.charCodeAt(y));)y++;if(y===l)return i;y!==P&&(N=m=y+1)}}}}else g(w)&&i.charCodeAt(1)===d&&(N=l>2&&E(i.charCodeAt(2))?3:2,m=N);let M=-1,F=!0;for(let y=l-1;y>=m;--y)if(E(i.charCodeAt(y))){if(!F){M=y;break}}else F=!1;if(M===-1){if(N===-1)return".";M=N}return i.slice(0,M)},basename(i,l){l!==void 0&&e(l,"ext"),e(i,"path");let N=0,m=-1,w=!0,M;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===d&&(N=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let F=l.length-1,y=-1;for(M=i.length-1;M>=N;--M){const P=i.charCodeAt(M);if(E(P)){if(!w){N=M+1;break}}else y===-1&&(w=!1,y=M+1),F>=0&&(P===l.charCodeAt(F)?--F===-1&&(m=M):(F=-1,m=y))}return N===m?m=y:m===-1&&(m=i.length),i.slice(N,m)}for(M=i.length-1;M>=N;--M)if(E(i.charCodeAt(M))){if(!w){N=M+1;break}}else m===-1&&(w=!1,m=M+1);return m===-1?"":i.slice(N,m)},extname(i){e(i,"path");let l=0,N=-1,m=0,w=-1,M=!0,F=0;i.length>=2&&i.charCodeAt(1)===d&&g(i.charCodeAt(0))&&(l=m=2);for(let y=i.length-1;y>=l;--y){const P=i.charCodeAt(y);if(E(P)){if(!M){m=y+1;break}continue}w===-1&&(M=!1,w=y+1),P===o?N===-1?N=y:F!==1&&(F=1):N!==-1&&(F=-1)}return N===-1||w===-1||F===0||F===1&&N===w-1&&N===m+1?"":i.slice(N,w)},format:f.bind(null,"\\"),parse(i){e(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const N=i.length;let m=0,w=i.charCodeAt(0);if(N===1)return E(w)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(E(w)){if(m=1,E(i.charCodeAt(1))){let q=2,S=q;for(;q<N&&!E(i.charCodeAt(q));)q++;if(q<N&&q!==S){for(S=q;q<N&&E(i.charCodeAt(q));)q++;if(q<N&&q!==S){for(S=q;q<N&&!E(i.charCodeAt(q));)q++;q===N?m=q:q!==S&&(m=q+1)}}}}else if(g(w)&&i.charCodeAt(1)===d){if(N<=2)return l.root=l.dir=i,l;if(m=2,E(i.charCodeAt(2))){if(N===3)return l.root=l.dir=i,l;m=3}}m>0&&(l.root=i.slice(0,m));let M=-1,F=m,y=-1,P=!0,R=i.length-1,I=0;for(;R>=m;--R){if(w=i.charCodeAt(R),E(w)){if(!P){F=R+1;break}continue}y===-1&&(P=!1,y=R+1),w===o?M===-1?M=R:I!==1&&(I=1):M!==-1&&(I=-1)}return y!==-1&&(M===-1||I===0||I===1&&M===y-1&&M===F+1?l.base=l.name=i.slice(F,y):(l.name=i.slice(F,M),l.base=i.slice(F,y),l.ext=i.slice(M,y))),F>0&&F!==m?l.dir=i.slice(0,F-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if($){const i=/\\/g;return()=>{const l=k.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>k.cwd()})();t.$5d={resolve(...i){let l="",N=!1;for(let m=i.length-1;m>=-1&&!N;m--){const w=m>=0?i[m]:h();e(w,"path"),w.length!==0&&(l=`${w}/${l}`,N=w.charCodeAt(0)===u)}return l=v(l,!N,"/",A),N?`/${l}`:l.length>0?l:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===u,N=i.charCodeAt(i.length-1)===u;return i=v(i,!l,"/",A),i.length===0?l?"/":N?"./":".":(N&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let l;for(let N=0;N<i.length;++N){const m=i[N];e(m,"path"),m.length>0&&(l===void 0?l=m:l+=`/${m}`)}return l===void 0?".":t.$5d.normalize(l)},relative(i,l){if(e(i,"from"),e(l,"to"),i===l||(i=t.$5d.resolve(i),l=t.$5d.resolve(l),i===l))return"";const N=1,m=i.length,w=m-N,M=1,F=l.length-M,y=w<F?w:F;let P=-1,R=0;for(;R<y;R++){const q=i.charCodeAt(N+R);if(q!==l.charCodeAt(M+R))break;q===u&&(P=R)}if(R===y)if(F>y){if(l.charCodeAt(M+R)===u)return l.slice(M+R+1);if(R===0)return l.slice(M+R)}else w>y&&(i.charCodeAt(N+R)===u?P=R:R===0&&(P=0));let I="";for(R=N+P+1;R<=m;++R)(R===m||i.charCodeAt(R)===u)&&(I+=I.length===0?"..":"/..");return`${I}${l.slice(M+P)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===u;let N=-1,m=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===u){if(!m){N=w;break}}else m=!1;return N===-1?l?"/":".":l&&N===1?"//":i.slice(0,N)},basename(i,l){l!==void 0&&e(l,"ext"),e(i,"path");let N=0,m=-1,w=!0,M;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let F=l.length-1,y=-1;for(M=i.length-1;M>=0;--M){const P=i.charCodeAt(M);if(P===u){if(!w){N=M+1;break}}else y===-1&&(w=!1,y=M+1),F>=0&&(P===l.charCodeAt(F)?--F===-1&&(m=M):(F=-1,m=y))}return N===m?m=y:m===-1&&(m=i.length),i.slice(N,m)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===u){if(!w){N=M+1;break}}else m===-1&&(w=!1,m=M+1);return m===-1?"":i.slice(N,m)},extname(i){e(i,"path");let l=-1,N=0,m=-1,w=!0,M=0;for(let F=i.length-1;F>=0;--F){const y=i.charCodeAt(F);if(y===u){if(!w){N=F+1;break}continue}m===-1&&(w=!1,m=F+1),y===o?l===-1?l=F:M!==1&&(M=1):l!==-1&&(M=-1)}return l===-1||m===-1||M===0||M===1&&l===m-1&&l===N+1?"":i.slice(l,m)},format:f.bind(null,"/"),parse(i){e(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const N=i.charCodeAt(0)===u;let m;N?(l.root="/",m=1):m=0;let w=-1,M=0,F=-1,y=!0,P=i.length-1,R=0;for(;P>=m;--P){const I=i.charCodeAt(P);if(I===u){if(!y){M=P+1;break}continue}F===-1&&(y=!1,F=P+1),I===o?w===-1?w=P:R!==1&&(R=1):w!==-1&&(R=-1)}if(F!==-1){const I=M===0&&N?1:M;w===-1||R===0||R===1&&w===F-1&&w===M+1?l.base=l.name=i.slice(I,F):(l.name=i.slice(I,w),l.base=i.slice(I,F),l.ext=i.slice(w,F))}return M>0?l.dir=i.slice(0,M-1):N&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$5d.win32=t.$4d.win32=t.$4d,t.$5d.posix=t.$4d.posix=t.$5d,t.$6d=$?t.$4d.normalize:t.$5d.normalize,t.$7d=$?t.$4d.isAbsolute:t.$5d.isAbsolute,t.$8d=$?t.$4d.join:t.$5d.join,t.$9d=$?t.$4d.resolve:t.$5d.resolve,t.$0d=$?t.$4d.relative:t.$5d.relative,t.$$d=$?t.$4d.dirname:t.$5d.dirname,t.$_d=$?t.$4d.basename:t.$5d.basename,t.$ae=$?t.$4d.extname:t.$5d.extname,t.$be=$?t.$4d.format:t.$5d.format,t.$ce=$?t.$4d.parse:t.$5d.parse,t.$de=$?t.$4d.toNamespacedPath:t.$5d.toNamespacedPath,t.sep=$?t.$4d.sep:t.$5d.sep,t.$fe=$?t.$4d.delimiter:t.$5d.delimiter}),te(ne[18],ie([0,1,64,17]),function(B,t,k,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sf=t.$Rf=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,a=/^\//,L=/^\/\//;function o(m,w){if(!m.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!r.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!a.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(m,w){return!m&&!w?"file":m}function s(m,w){switch(m){case"https":case"http":case"file":w?w[0]!==p&&(w=p+w):w=p;break}return w}const d="",p="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(w){return w instanceof c?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,M,F,y,P,R=!1){typeof w=="object"?(this.scheme=w.scheme||d,this.authority=w.authority||d,this.path=w.path||d,this.query=w.query||d,this.fragment=w.fragment||d):(this.scheme=u(w,R),this.authority=M||d,this.path=s(this.scheme,F||d),this.query=y||d,this.fragment=P||d,o(this,R))}get fsPath(){return f(this,!1)}with(w){if(!w)return this;let{scheme:M,authority:F,path:y,query:P,fragment:R}=w;return M===void 0?M=this.scheme:M===null&&(M=d),F===void 0?F=this.authority:F===null&&(F=d),y===void 0?y=this.path:y===null&&(y=d),P===void 0?P=this.query:P===null&&(P=d),R===void 0?R=this.fragment:R===null&&(R=d),M===this.scheme&&F===this.authority&&y===this.path&&P===this.query&&R===this.fragment?this:new E(M,F,y,P,R)}static parse(w,M=!1){const F=b.exec(w);return F?new E(F[2]||d,N(F[4]||d),N(F[5]||d),N(F[7]||d),N(F[9]||d),M):new E(d,d,d,d,d)}static file(w){let M=d;if(_.$i&&(w=w.replace(/\\/g,p)),w[0]===p&&w[1]===p){const F=w.indexOf(p,2);F===-1?(M=w.substring(2),w=p):(M=w.substring(2,F),w=w.substring(F)||p)}return new E("file",M,w,d,d)}static from(w,M){return new E(w.scheme,w.authority,w.path,w.query,w.fragment,M)}static joinPath(w,...M){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let F;return _.$i&&w.scheme==="file"?F=c.file(k.$4d.join(f(w,!0),...M)).path:F=k.$5d.join(w.path,...M),w.with({path:F})}toString(w=!1){return h(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof c)return w;{const M=new E(w);return M._formatted=w.external??null,M._fsPath=w._sep===$?w.fsPath??null:null,M}}else return w}}t.URI=c;function e(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}t.$Rf=e;const $=_.$i?1:void 0;class E extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(w=!1){return w?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=$),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const A={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(m,w,M){let F,y=-1;for(let P=0;P<m.length;P++){const R=m.charCodeAt(P);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||w&&R===47||M&&R===91||M&&R===93||M&&R===58)y!==-1&&(F+=encodeURIComponent(m.substring(y,P)),y=-1),F!==void 0&&(F+=m.charAt(P));else{F===void 0&&(F=m.substr(0,P));const I=A[R];I!==void 0?(y!==-1&&(F+=encodeURIComponent(m.substring(y,P)),y=-1),F+=I):y===-1&&(y=P)}}return y!==-1&&(F+=encodeURIComponent(m.substring(y))),F!==void 0?F:m}function v(m){let w;for(let M=0;M<m.length;M++){const F=m.charCodeAt(M);F===35||F===63?(w===void 0&&(w=m.substr(0,M)),w+=A[F]):w!==void 0&&(w+=m[M])}return w!==void 0?w:m}function f(m,w){let M;return m.authority&&m.path.length>1&&m.scheme==="file"?M=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?w?M=m.path.substr(1):M=m.path[1].toLowerCase()+m.path.substr(2):M=m.path,_.$i&&(M=M.replace(/\//g,"\\")),M}t.$Sf=f;function h(m,w){const M=w?v:g;let F="",{scheme:y,authority:P,path:R,query:I,fragment:q}=m;if(y&&(F+=y,F+=":"),(P||y==="file")&&(F+=p,F+=p),P){let S=P.indexOf("@");if(S!==-1){const z=P.substr(0,S);P=P.substr(S+1),S=z.lastIndexOf(":"),S===-1?F+=M(z,!1,!1):(F+=M(z.substr(0,S),!1,!1),F+=":",F+=M(z.substr(S+1),!1,!0)),F+="@"}P=P.toLowerCase(),S=P.lastIndexOf(":"),S===-1?F+=M(P,!1,!0):(F+=M(P.substr(0,S),!1,!0),F+=P.substr(S))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const S=R.charCodeAt(1);S>=65&&S<=90&&(R=`/${String.fromCharCode(S+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const S=R.charCodeAt(0);S>=65&&S<=90&&(R=`${String.fromCharCode(S+32)}:${R.substr(2)}`)}F+=M(R,!0,!1)}return I&&(F+="?",F+=M(I,!1,!1)),q&&(F+="#",F+=w?q:g(q,!1,!1)),F}function i(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+i(m.substr(3)):m}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(m){return m.match(l)?m.replace(l,w=>i(w)):m}}),te(ne[69],ie([0,1,3,11,10,14,17,6]),function(B,t,k,_,r,a,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const u="$initialize";let s=!1;function d(N){L.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(N.message))}t.logOnceWebWorkerWarning=d;var p;(function(N){N[N.Request=0]="Request",N[N.Reply=1]="Reply",N[N.SubscribeEvent=2]="SubscribeEvent",N[N.Event=3]="Event",N[N.UnsubscribeEvent=4]="UnsubscribeEvent"})(p||(p={}));class b{constructor(m,w,M,F){this.vsWorker=m,this.req=w,this.method=M,this.args=F,this.type=0}}class c{constructor(m,w,M,F){this.vsWorker=m,this.seq=w,this.res=M,this.err=F,this.type=1}}class e{constructor(m,w,M,F){this.vsWorker=m,this.req=w,this.eventName=M,this.arg=F,this.type=2}}class ${constructor(m,w,M){this.vsWorker=m,this.req=w,this.event=M,this.type=3}}class E{constructor(m,w){this.vsWorker=m,this.req=w,this.type=4}}class A{constructor(m){this.a=-1,this.g=m,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(m){this.a=m}sendMessage(m,w){const M=String(++this.b);return new Promise((F,y)=>{this.c[M]={resolve:F,reject:y},this.o(new b(this.a,M,m,w))})}listen(m,w){let M=null;const F=new _.$ed({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,F),this.o(new e(this.a,M,m,w))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new E(this.a,M)),M=null}});return F.event}handleMessage(m){!m||!m.vsWorker||this.a!==-1&&m.vsWorker!==this.a||this.h(m)}h(m){switch(m.type){case 1:return this.j(m);case 0:return this.k(m);case 2:return this.l(m);case 3:return this.m(m);case 4:return this.n(m)}}j(m){if(!this.c[m.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[m.seq];if(delete this.c[m.seq],m.err){let M=m.err;m.err.$isError&&(M=new Error,M.name=m.err.name,M.message=m.err.message,M.stack=m.err.stack),w.reject(M);return}w.resolve(m.res)}k(m){const w=m.req;this.g.handleMessage(m.method,m.args).then(F=>{this.o(new c(this.a,w,F,void 0))},F=>{F.detail instanceof Error&&(F.detail=(0,k.$1)(F.detail)),this.o(new c(this.a,w,void 0,(0,k.$1)(F)))})}l(m){const w=m.req,M=this.g.handleEvent(m.eventName,m.arg)(F=>{this.o(new $(this.a,w,F))});this.f.set(w,M)}m(m){if(!this.d.has(m.req)){console.warn("Got event for unknown req");return}this.d.get(m.req).fire(m.event)}n(m){if(!this.f.has(m.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(m.req).dispose(),this.f.delete(m.req)}o(m){const w=[];if(m.type===0)for(let M=0;M<m.args.length;M++)m.args[M]instanceof ArrayBuffer&&w.push(m.args[M]);else m.type===1&&m.res instanceof ArrayBuffer&&w.push(m.res);this.g.sendMessage(m,w)}}class g extends r.$jc{constructor(m,w,M){super();let F=null;this.a=this.B(m.create("vs/base/common/worker/simpleWorker",S=>{this.c.handleMessage(S)},S=>{F?.(S)})),this.c=new A({sendMessage:(S,z)=>{this.a.postMessage(S,z)},handleMessage:(S,z)=>{if(typeof M[S]!="function")return Promise.reject(new Error("Missing method "+S+" on main thread host."));try{return Promise.resolve(M[S].apply(M,z))}catch(D){return Promise.reject(D)}},handleEvent:(S,z)=>{if(f(S)){const D=M[S].call(M,z);if(typeof D!="function")throw new Error(`Missing dynamic event ${S} on main thread host.`);return D}if(v(S)){const D=M[S];if(typeof D!="function")throw new Error(`Missing event ${S} on main thread host.`);return D}throw new Error(`Malformed event name ${S}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const P=globalThis.require;typeof P<"u"&&typeof P.getConfig=="function"?y=P.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const R=(0,a.$5m)(M);this.b=this.c.sendMessage(u,[this.a.getId(),JSON.parse(JSON.stringify(y)),w,R]);const I=(S,z)=>this.g(S,z),q=(S,z)=>this.c.listen(S,z);this.f=new Promise((S,z)=>{F=z,this.b.then(D=>{S(h(D,I,q))},D=>{z(D),this.h("Worker failed to load "+w,D)})})}getProxyObject(){return this.f}g(m,w){return new Promise((M,F)=>{this.b.then(()=>{this.c.sendMessage(m,w).then(M,F)},F)})}h(m,w){console.error(m),console.info(w)}}t.SimpleWorkerClient=g;function v(N){return N[0]==="o"&&N[1]==="n"&&o.$Ke(N.charCodeAt(2))}function f(N){return/^onDynamic/.test(N)&&o.$Ke(N.charCodeAt(9))}function h(N,m,w){const M=P=>function(){const R=Array.prototype.slice.call(arguments,0);return m(P,R)},F=P=>function(R){return w(P,R)},y={};for(const P of N){if(f(P)){y[P]=F(P);continue}if(v(P)){y[P]=w(P,void 0);continue}y[P]=M(P)}return y}class i{constructor(m,w){this.a=w,this.b=null,this.c=new A({sendMessage:(M,F)=>{m(M,F)},handleMessage:(M,F)=>this.d(M,F),handleEvent:(M,F)=>this.f(M,F)})}onmessage(m){this.c.handleMessage(m)}d(m,w){if(m===u)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this.b[m].apply(this.b,w))}catch(M){return Promise.reject(M)}}f(m,w){if(!this.b)throw new Error("Missing requestHandler");if(f(m)){const M=this.b[m].call(this.b,w);if(typeof M!="function")throw new Error(`Missing dynamic event ${m} on request handler.`);return M}if(v(m)){const M=this.b[m];if(typeof M!="function")throw new Error(`Missing event ${m} on request handler.`);return M}throw new Error(`Malformed event name ${m}`)}g(m,w,M,F){this.c.setWorkerId(m);const R=h(F,(I,q)=>this.c.sendMessage(I,q),(I,q)=>this.c.listen(I,q));return this.a?(this.b=this.a(R),Promise.resolve((0,a.$5m)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy!==void 0&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((I,q)=>{(globalThis.require||B)([M],z=>{if(this.b=z.create(R),!this.b){q(new Error("No RequestHandler!"));return}I((0,a.$5m)(this.b))},q)}))}}t.SimpleWorkerServer=i;function l(N){return new i(N,null)}t.create=l}),te(ne[65],ie([61,62]),function(B,t){return B.create("vs/editor/common/languages",t)}),te(ne[66],ie([0,1,40,18,41,2,59,65]),function(B,t,k,_,r,a,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$_s=t.$$s=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$0s=t.$9s=t.SymbolKinds=t.SymbolTag=t.$8s=t.$7s=t.SymbolKind=t.$6s=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$5s=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$4s=t.$3s=t.$2s=void 0;class u{constructor(j,x,W){this.offset=j,this.type=x,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$2s=u;class s{constructor(j,x){this.tokens=j,this.endState=x,this._tokenizationResultBrand=void 0}}t.$3s=s;class d{constructor(j,x){this.tokens=j,this.endState=x,this._encodedTokenizationResultBrand=void 0}}t.$4s=d;var p;(function(D){D[D.Method=0]="Method",D[D.Function=1]="Function",D[D.Constructor=2]="Constructor",D[D.Field=3]="Field",D[D.Variable=4]="Variable",D[D.Class=5]="Class",D[D.Struct=6]="Struct",D[D.Interface=7]="Interface",D[D.Module=8]="Module",D[D.Property=9]="Property",D[D.Event=10]="Event",D[D.Operator=11]="Operator",D[D.Unit=12]="Unit",D[D.Value=13]="Value",D[D.Constant=14]="Constant",D[D.Enum=15]="Enum",D[D.EnumMember=16]="EnumMember",D[D.Keyword=17]="Keyword",D[D.Text=18]="Text",D[D.Color=19]="Color",D[D.File=20]="File",D[D.Reference=21]="Reference",D[D.Customcolor=22]="Customcolor",D[D.Folder=23]="Folder",D[D.TypeParameter=24]="TypeParameter",D[D.User=25]="User",D[D.Issue=26]="Issue",D[D.Snippet=27]="Snippet"})(p||(t.CompletionItemKind=p={}));var b;(function(D){const j=new Map;j.set(0,k.$Oj.symbolMethod),j.set(1,k.$Oj.symbolFunction),j.set(2,k.$Oj.symbolConstructor),j.set(3,k.$Oj.symbolField),j.set(4,k.$Oj.symbolVariable),j.set(5,k.$Oj.symbolClass),j.set(6,k.$Oj.symbolStruct),j.set(7,k.$Oj.symbolInterface),j.set(8,k.$Oj.symbolModule),j.set(9,k.$Oj.symbolProperty),j.set(10,k.$Oj.symbolEvent),j.set(11,k.$Oj.symbolOperator),j.set(12,k.$Oj.symbolUnit),j.set(13,k.$Oj.symbolValue),j.set(15,k.$Oj.symbolEnum),j.set(14,k.$Oj.symbolConstant),j.set(15,k.$Oj.symbolEnum),j.set(16,k.$Oj.symbolEnumMember),j.set(17,k.$Oj.symbolKeyword),j.set(27,k.$Oj.symbolSnippet),j.set(18,k.$Oj.symbolText),j.set(19,k.$Oj.symbolColor),j.set(20,k.$Oj.symbolFile),j.set(21,k.$Oj.symbolReference),j.set(22,k.$Oj.symbolCustomColor),j.set(23,k.$Oj.symbolFolder),j.set(24,k.$Oj.symbolTypeParameter),j.set(25,k.$Oj.account),j.set(26,k.$Oj.issues);function x(n){let ue=j.get(n);return ue||(console.info("No codicon found for CompletionItemKind "+n),ue=k.$Oj.symbolProperty),ue}D.toIcon=x;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function J(n,ue){let ce=W.get(n);return typeof ce>"u"&&!ue&&(ce=9),ce}D.fromString=J})(b||(t.CompletionItemKinds=b={}));var c;(function(D){D[D.Deprecated=1]="Deprecated"})(c||(t.CompletionItemTag=c={}));var e;(function(D){D[D.None=0]="None",D[D.KeepWhitespace=1]="KeepWhitespace",D[D.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var $;(function(D){D[D.Invoke=0]="Invoke",D[D.TriggerCharacter=1]="TriggerCharacter",D[D.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(t.CompletionTriggerKind=$={}));var E;(function(D){D[D.Automatic=0]="Automatic",D[D.Explicit=1]="Explicit"})(E||(t.InlineCompletionTriggerKind=E={}));class A{constructor(j,x,W,J){this.range=j,this.text=x,this.completionKind=W,this.isSnippetText=J}equals(j){return a.$is.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}t.$5s=A;var g;(function(D){D[D.Invoke=1]="Invoke",D[D.Auto=2]="Auto"})(g||(t.CodeActionTriggerType=g={}));var v;(function(D){D[D.Invoke=1]="Invoke",D[D.TriggerCharacter=2]="TriggerCharacter",D[D.ContentChange=3]="ContentChange"})(v||(t.SignatureHelpTriggerKind=v={}));var f;(function(D){D[D.Text=0]="Text",D[D.Read=1]="Read",D[D.Write=2]="Write"})(f||(t.DocumentHighlightKind=f={}));function h(D){return D&&_.URI.isUri(D.uri)&&a.$is.isIRange(D.range)&&(a.$is.isIRange(D.originSelectionRange)||a.$is.isIRange(D.targetSelectionRange))}t.$6s=h;var i;(function(D){D[D.File=0]="File",D[D.Module=1]="Module",D[D.Namespace=2]="Namespace",D[D.Package=3]="Package",D[D.Class=4]="Class",D[D.Method=5]="Method",D[D.Property=6]="Property",D[D.Field=7]="Field",D[D.Constructor=8]="Constructor",D[D.Enum=9]="Enum",D[D.Interface=10]="Interface",D[D.Function=11]="Function",D[D.Variable=12]="Variable",D[D.Constant=13]="Constant",D[D.String=14]="String",D[D.Number=15]="Number",D[D.Boolean=16]="Boolean",D[D.Array=17]="Array",D[D.Object=18]="Object",D[D.Key=19]="Key",D[D.Null=20]="Null",D[D.EnumMember=21]="EnumMember",D[D.Struct=22]="Struct",D[D.Event=23]="Event",D[D.Operator=24]="Operator",D[D.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$7s={[17]:(0,o.localize)(0,null),[16]:(0,o.localize)(1,null),[4]:(0,o.localize)(2,null),[13]:(0,o.localize)(3,null),[8]:(0,o.localize)(4,null),[9]:(0,o.localize)(5,null),[21]:(0,o.localize)(6,null),[23]:(0,o.localize)(7,null),[7]:(0,o.localize)(8,null),[0]:(0,o.localize)(9,null),[11]:(0,o.localize)(10,null),[10]:(0,o.localize)(11,null),[19]:(0,o.localize)(12,null),[5]:(0,o.localize)(13,null),[1]:(0,o.localize)(14,null),[2]:(0,o.localize)(15,null),[20]:(0,o.localize)(16,null),[15]:(0,o.localize)(17,null),[18]:(0,o.localize)(18,null),[24]:(0,o.localize)(19,null),[3]:(0,o.localize)(20,null),[6]:(0,o.localize)(21,null),[14]:(0,o.localize)(22,null),[22]:(0,o.localize)(23,null),[25]:(0,o.localize)(24,null),[12]:(0,o.localize)(25,null)};function l(D,j){return(0,o.localize)(26,null,D,t.$7s[j])}t.$8s=l;var N;(function(D){D[D.Deprecated=1]="Deprecated"})(N||(t.SymbolTag=N={}));var m;(function(D){const j=new Map;j.set(0,k.$Oj.symbolFile),j.set(1,k.$Oj.symbolModule),j.set(2,k.$Oj.symbolNamespace),j.set(3,k.$Oj.symbolPackage),j.set(4,k.$Oj.symbolClass),j.set(5,k.$Oj.symbolMethod),j.set(6,k.$Oj.symbolProperty),j.set(7,k.$Oj.symbolField),j.set(8,k.$Oj.symbolConstructor),j.set(9,k.$Oj.symbolEnum),j.set(10,k.$Oj.symbolInterface),j.set(11,k.$Oj.symbolFunction),j.set(12,k.$Oj.symbolVariable),j.set(13,k.$Oj.symbolConstant),j.set(14,k.$Oj.symbolString),j.set(15,k.$Oj.symbolNumber),j.set(16,k.$Oj.symbolBoolean),j.set(17,k.$Oj.symbolArray),j.set(18,k.$Oj.symbolObject),j.set(19,k.$Oj.symbolKey),j.set(20,k.$Oj.symbolNull),j.set(21,k.$Oj.symbolEnumMember),j.set(22,k.$Oj.symbolStruct),j.set(23,k.$Oj.symbolEvent),j.set(24,k.$Oj.symbolOperator),j.set(25,k.$Oj.symbolTypeParameter);function x(W){let J=j.get(W);return J||(console.info("No codicon found for SymbolKind "+W),J=k.$Oj.symbolProperty),J}D.toIcon=x})(m||(t.SymbolKinds=m={}));class w{static asEditOperation(j){return r.$js.replace(a.$is.lift(j.range),j.text)}}t.$9s=w;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(j){switch(j){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(j)}constructor(j){this.value=j}}t.$0s=M;var F;(function(D){function j(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}D.is=j})(F||(t.Command=F={}));var y;(function(D){D[D.Collapsed=0]="Collapsed",D[D.Expanded=1]="Expanded"})(y||(t.CommentThreadCollapsibleState=y={}));var P;(function(D){D[D.Unresolved=0]="Unresolved",D[D.Resolved=1]="Resolved"})(P||(t.CommentThreadState=P={}));var R;(function(D){D[D.Editing=0]="Editing",D[D.Preview=1]="Preview"})(R||(t.CommentMode=R={}));var I;(function(D){D[D.Published=0]="Published",D[D.Draft=1]="Draft"})(I||(t.CommentState=I={}));var q;(function(D){D[D.Type=1]="Type",D[D.Parameter=2]="Parameter"})(q||(t.InlayHintKind=q={}));class S{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$$s=S,t.$_s=new L.$Ts;var z;(function(D){D[D.None=0]="None",D[D.Option=1]="Option",D[D.Default=2]="Default",D[D.Preferred=3]="Preferred"})(z||(t.ExternalUriOpenerPriority=z={}))}),te(ne[67],ie([0,1,24,11,36,18,5,2,42,66,58]),function(B,t,k,_,r,a,L,o,u,s,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sY=t.$rY=void 0;class p{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,$){return(0,r.$tq)(e,$)}}t.$rY=p;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:k.$od,Emitter:_.$ed,KeyCode:d.KeyCode,KeyMod:p,Position:L.$hs,Range:o.$is,Selection:u.$ks,SelectionDirection:d.SelectionDirection,MarkerSeverity:d.MarkerSeverity,MarkerTag:d.MarkerTag,Uri:a.URI,Token:s.$2s}}t.$sY=b}),te(ne[70],ie([0,1,25,18,5,2,55,29,51,52,67,23,57,33,49,14,3,50]),function(B,t,k,_,r,a,L,o,u,s,d,p,b,c,e,$,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class g extends L.$Ku{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const l=[];for(let N=0;N<this.f.length;N++){const m=this.f[N],w=this.offsetAt(new r.$hs(N+1,1)),M=m.matchAll(i);for(const F of M)(F.index||F.index===0)&&(F.index=F.index+w),l.push(F)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,l){const N=(0,o.$Xr)(i.column,(0,o.$Vr)(l),this.f[i.lineNumber-1],0);return N?new a.$is(i.lineNumber,N.startColumn,i.lineNumber,N.endColumn):null}getWordUntilPosition(i,l){const N=this.getWordAtPosition(i,l);return N?{word:this.f[i.lineNumber-1].substring(N.startColumn-1,i.column-1),startColumn:N.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const l=this.f,N=this.q.bind(this);let m=0,w="",M=0,F=[];return{*[Symbol.iterator](){for(;;)if(M<F.length){const y=w.substring(F[M].start,F[M].end);M+=1,yield y}else if(m<l.length)w=l[m],F=N(w,i),M=0,m+=1;else break}}}getLineWords(i,l){const N=this.f[i-1],m=this.q(N,l),w=[];for(const M of m)w.push({word:N.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return w}q(i,l){const N=[];let m;for(l.lastIndex=0;(m=l.exec(i))&&m[0].length!==0;)N.push({start:m.index,end:m.index+m[0].length});return N}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const l=this.g,N=i.startLineNumber-1,m=i.endLineNumber-1,w=[];w.push(this.f[N].substring(i.startColumn-1));for(let M=N+1;M<m;M++)w.push(this.f[M]);return w.push(this.f[m].substring(0,i.endColumn-1)),w.join(l)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const l=this.j.getIndexOf(i),N=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,N)}}r(i){const l=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),N=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return l.lineNumber!==i.startLineNumber||l.column!==i.startColumn||N.lineNumber!==i.endLineNumber||N.column!==i.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:N.lineNumber,endColumn:N.column}:i}s(i){if(!r.$hs.isIPosition(i))throw new Error("bad position");let{lineNumber:l,column:N}=i,m=!1;if(l<1)l=1,N=1,m=!0;else if(l>this.f.length)l=this.f.length,N=this.f[l-1].length+1,m=!0;else{const w=this.f[l-1].length+1;N<1?(N=1,m=!0):N>w&&(N=w,m=!0)}return m?{lineNumber:l,column:N}:i}}class v{constructor(i,l){this.d=i,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(l=>i.push(this.f[l])),i}acceptNewModel(i){this.f[i.url]=new g(_.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,l){if(!this.f[i])return;this.f[i].onEvents(l)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,l,N){const m=this.j(i);return m?b.$mY.computeUnicodeHighlights(m,l,N):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,l,N,m){const w=this.j(i),M=this.j(l);return!w||!M?null:v.l(w,M,N,m)}static l(i,l,N,m){const w=m==="advanced"?e.$NY.getDefault():e.$NY.getLegacy(),M=i.getLinesContent(),F=l.getLinesContent(),y=w.computeDiff(M,F,N),P=y.changes.length>0?!1:this.n(i,l);function R(I){return I.map(q=>[q.original.startLineNumber,q.original.endLineNumberExclusive,q.modified.startLineNumber,q.modified.endLineNumberExclusive,q.innerChanges?.map(S=>[S.originalRange.startLineNumber,S.originalRange.startColumn,S.originalRange.endLineNumber,S.originalRange.endColumn,S.modifiedRange.startLineNumber,S.modifiedRange.startColumn,S.modifiedRange.endLineNumber,S.modifiedRange.endColumn])])}return{identical:P,quitEarly:y.hitTimeout,changes:R(y.changes),moves:y.moves.map(I=>[I.lineRangeMapping.original.startLineNumber,I.lineRangeMapping.original.endLineNumberExclusive,I.lineRangeMapping.modified.startLineNumber,I.lineRangeMapping.modified.endLineNumberExclusive,R(I.changes)])}}static n(i,l){const N=i.getLineCount(),m=l.getLineCount();if(N!==m)return!1;for(let w=1;w<=N;w++){const M=i.getLineContent(w),F=l.getLineContent(w);if(M!==F)return!1}return!0}async computeDirtyDiff(i,l,N){const m=this.j(i),w=this.j(l);if(!m||!w)return null;const M=m.getLinesContent(),F=w.getLinesContent();return new c.$zs(M,F,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:N,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(i,l,N){const m=this.j(i);if(!m)return l;const w=[];let M;l=l.slice(0).sort((y,P)=>{if(y.range&&P.range)return a.$is.compareRangesUsingStarts(y.range,P.range);const R=y.range?0:1,I=P.range?0:1;return R-I});let F=0;for(let y=1;y<l.length;y++)a.$is.getEndPosition(l[F].range).equals(a.$is.getStartPosition(l[y].range))?(l[F].range=a.$is.fromPositions(a.$is.getStartPosition(l[F].range),a.$is.getEndPosition(l[y].range)),l[F].text+=l[y].text):(F++,l[F]=l[y]);l.length=F+1;for(let{range:y,text:P,eol:R}of l){if(typeof R=="number"&&(M=R),a.$is.isEmpty(y)&&!P)continue;const I=m.getValueInRange(y);if(P=P.replace(/\r\n|\n|\r/g,m.eol),I===P)continue;if(Math.max(P.length,I.length)>v.o){w.push({range:y,text:P});continue}const q=(0,k.$ns)(I,P,N),S=m.offsetAt(a.$is.lift(y).getStartPosition());for(const z of q){const D=m.positionAt(S+z.originalStart),j=m.positionAt(S+z.originalStart+z.originalLength),x={text:P.substr(z.modifiedStart,z.modifiedLength),range:{startLineNumber:D.lineNumber,startColumn:D.column,endLineNumber:j.lineNumber,endColumn:j.column}};m.getValueInRange(x.range)!==x.text&&w.push(x)}}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeHumanReadableDiff(i,l,N){const m=this.j(i);if(!m)return l;const w=[];let M;l=l.slice(0).sort((F,y)=>{if(F.range&&y.range)return a.$is.compareRangesUsingStarts(F.range,y.range);const P=F.range?0:1,R=y.range?0:1;return P-R});for(let{range:F,text:y,eol:P}of l){let D=function(x,W){return new r.$hs(x.lineNumber+W.lineNumber-1,W.lineNumber===1?x.column+W.column-1:W.column)},j=function(x,W){const J=[];for(let n=W.startLineNumber;n<=W.endLineNumber;n++){const ue=x[n-1];n===W.startLineNumber&&n===W.endLineNumber?J.push(ue.substring(W.startColumn-1,W.endColumn-1)):n===W.startLineNumber?J.push(ue.substring(W.startColumn-1)):n===W.endLineNumber?J.push(ue.substring(0,W.endColumn-1)):J.push(ue)}return J};if(typeof P=="number"&&(M=P),a.$is.isEmpty(F)&&!y)continue;const R=m.getValueInRange(F);if(y=y.replace(/\r\n|\n|\r/g,m.eol),R===y)continue;if(Math.max(y.length,R.length)>v.o){w.push({range:F,text:y});continue}const I=R.split(/\r\n|\n|\r/),q=y.split(/\r\n|\n|\r/),S=e.$NY.getDefault().computeDiff(I,q,N),z=a.$is.lift(F).getStartPosition();for(const x of S.changes)if(x.innerChanges)for(const W of x.innerChanges)w.push({range:a.$is.fromPositions(D(z,W.originalRange.getStartPosition()),D(z,W.originalRange.getEndPosition())),text:j(q,W.modifiedRange).join(m.eol)});else throw new E.$ab("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const l=this.j(i);return l?(0,u.$pY)(l):null}async computeDefaultDocumentColors(i){const l=this.j(i);return l?(0,A.$OY)(l):null}static{this.p=1e4}async textualSuggest(i,l,N,m){const w=new p.$ad,M=new RegExp(N,m),F=new Set;e:for(const y of i){const P=this.j(y);if(P){for(const R of P.words(M))if(!(R===l||!isNaN(Number(R)))&&(F.add(R),F.size>v.p))break e}}return{words:Array.from(F),duration:w.elapsed()}}async computeWordRanges(i,l,N,m){const w=this.j(i);if(!w)return Object.create(null);const M=new RegExp(N,m),F=Object.create(null);for(let y=l.startLineNumber;y<l.endLineNumber;y++){const P=w.getLineWords(y,M);for(const R of P){if(!isNaN(Number(R.word)))continue;let I=F[R.word];I||(I=[],F[R.word]=I),I.push({startLineNumber:y,startColumn:R.startColumn,endLineNumber:y,endColumn:R.endColumn})}}return F}async navigateValueSet(i,l,N,m,w){const M=this.j(i);if(!M)return null;const F=new RegExp(m,w);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const y=M.getValueInRange(l),P=M.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},F);if(!P)return null;const R=M.getValueInRange(P);return s.$qY.INSTANCE.navigateValueSet(l,y,P,R,N)}loadForeignModule(i,l,N){const m=(F,y)=>this.d.fhr(F,y),M={host:(0,$.$6m)(N,m),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,l),Promise.resolve((0,$.$5m)(this.h))):new Promise((F,y)=>{B([i],P=>{this.h=P.create(M,l),F((0,$.$5m)(this.h))},y)})}fmr(i,l){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,l))}catch(N){return Promise.reject(N)}}}t.EditorSimpleWorker=v;function f(h){return new v(h,null)}t.create=f,typeof importScripts=="function"&&(globalThis.monaco=(0,d.$sY)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f36df69328ed10f76d4be03e8a82b61794b49711/core/vs/base/worker/workerMain.js.map
