/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(J){for(var e=[],P=0,O=J.length;P<O;P++)e[P]=te[J[P]];return e};define(te[133],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function P(w,g,c){const a=O(w,g);if(a!==-1)return w[a]}e.$db=P;function O(w,g,c=w.length-1){for(let a=c;a>=0;a--){const m=w[a];if(g(m))return a}return-1}e.$eb=O;function s(w,g){const c=M(w,g);return c===-1?void 0:w[c]}e.$fb=s;function M(w,g,c=0,a=w.length){let m=c,E=a;for(;m<E;){const d=Math.floor((m+E)/2);g(w[d])?m=d+1:E=d}return m-1}e.$gb=M;function A(w,g){const c=S(w,g);return c===w.length?void 0:w[c]}e.$hb=A;function S(w,g,c=0,a=w.length){let m=c,E=a;for(;m<E;){const d=Math.floor((m+E)/2);g(w[d])?E=d:m=d+1}return m}e.$ib=S;function h(w,g,c=0,a=w.length){const m=S(w,g,c,a);return m===w.length?-1:m}e.$jb=h;class l{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(l.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!g(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const c=M(this.e,g,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$kb=l;function b(w,g){if(w.length===0)return;let c=w[0];for(let a=1;a<w.length;a++){const m=w[a];g(m,c)>0&&(c=m)}return c}e.$lb=b;function $(w,g){if(w.length===0)return;let c=w[0];for(let a=1;a<w.length;a++){const m=w[a];g(m,c)>=0&&(c=m)}return c}e.$mb=$;function p(w,g){return b(w,(c,a)=>-g(c,a))}e.$nb=p;function f(w,g){if(w.length===0)return-1;let c=0;for(let a=1;a<w.length;a++){const m=w[a];g(m,w[c])>0&&(c=a)}return c}e.$ob=f;function y(w,g){for(const c of w){const a=g(c);if(a!==void 0)return a}}e.$pb=y}),define(te[134],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function P(A,S){const h=Object.create(null);for(const l of A){const b=S(l);let $=h[b];$||($=h[b]=[]),$.push(l)}return h}e.$I=P;function O(A,S){const h=[],l=[];for(const b of A)S.has(b)||h.push(b);for(const b of S)A.has(b)||l.push(b);return{removed:h,added:l}}e.$J=O;function s(A,S){const h=[],l=[];for(const[b,$]of A)S.has(b)||h.push($);for(const[b,$]of S)A.has(b)||l.push($);return{removed:h,added:l}}e.$K=s;class M{constructor(){this.a=new Map}add(S,h){let l=this.a.get(S);l||(l=new Set,this.a.set(S,l)),l.add(h)}delete(S,h){const l=this.a.get(S);l&&(l.delete(h),l.size===0&&this.a.delete(S))}forEach(S,h){const l=this.a.get(S);l&&l.forEach(h)}get(S){const h=this.a.get(S);return h||new Set}}e.$L=M}),define(te[135],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=e.$Ls=e.$Ks=e.$Js=void 0;function P(S,h){const l=Math.pow(10,h);return Math.round(S*l)/l}class O{constructor(h,l,b,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=P(Math.max(Math.min(1,$),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.$Js=O;class s{constructor(h,l,b,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,b),0),3),this.a=P(Math.max(Math.min(1,$),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,b=h.g/255,$=h.b/255,p=h.a,f=Math.max(l,b,$),y=Math.min(l,b,$);let w=0,g=0;const c=(y+f)/2,a=f-y;if(a>0){switch(g=Math.min(c<=.5?a/(2*c):a/(2-2*c),1),f){case l:w=(b-$)/a+(b<$?6:0);break;case b:w=($-l)/a+2;break;case $:w=(l-b)/a+4;break}w*=60,w=Math.round(w)}return new s(w,g,c,p)}static i(h,l,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?h+(l-h)*6*b:b<1/2?l:b<2/3?h+(l-h)*(2/3-b)*6:h}static toRGBA(h){const l=h.h/360,{s:b,l:$,a:p}=h;let f,y,w;if(b===0)f=y=w=$;else{const g=$<.5?$*(1+b):$+b-$*b,c=2*$-g;f=s.i(c,g,l+1/3),y=s.i(c,g,l),w=s.i(c,g,l-1/3)}return new O(Math.round(f*255),Math.round(y*255),Math.round(w*255),p)}}e.$Ks=s;class M{constructor(h,l,b,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,b),0),3),this.a=P(Math.max(Math.min(1,$),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,b=h.g/255,$=h.b/255,p=Math.max(l,b,$),f=Math.min(l,b,$),y=p-f,w=p===0?0:y/p;let g;return y===0?g=0:p===l?g=((b-$)/y%6+6)%6:p===b?g=($-l)/y+2:g=(l-b)/y+4,new M(Math.round(g*60),w,p,h.a)}static toRGBA(h){const{h:l,s:b,v:$,a:p}=h,f=$*b,y=f*(1-Math.abs(l/60%2-1)),w=$-f;let[g,c,a]=[0,0,0];return l<60?(g=f,c=y):l<120?(g=y,c=f):l<180?(c=f,a=y):l<240?(c=y,a=f):l<300?(g=y,a=f):l<=360&&(g=f,a=y),g=Math.round((g+w)*255),c=Math.round((c+w)*255),a=Math.round((a+w)*255),new O(g,c,a,p)}}e.$Ls=M;class A{static fromHex(h){return A.Format.CSS.parseHex(h)||A.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof O)this.rgba=h;else if(h instanceof s)this.i=h,this.rgba=s.toRGBA(h);else if(h instanceof M)this.j=h,this.rgba=M.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&O.equals(this.rgba,h.rgba)&&s.equals(this.hsla,h.hsla)&&M.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=A.k(this.rgba.r),l=A.k(this.rgba.g),b=A.k(this.rgba.b),$=.2126*h+.7152*l+.0722*b;return P($,4)}static k(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),b=h.getRelativeLuminance();return l>b?(l+.05)/(b+.05):(b+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),b=h.getRelativeLuminance();return l>b}isDarkerThan(h){const l=this.getRelativeLuminance(),b=h.getRelativeLuminance();return l<b}lighten(h){return new A(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new A(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:b,b:$,a:p}=this.rgba;return new A(new O(l,b,$,p*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,b=this.rgba.a,$=l.a,p=b+$*(1-b);if(p<1e-6)return A.transparent;const f=this.rgba.r*b/p+l.r*$*(1-b)/p,y=this.rgba.g*b/p+l.g*$*(1-b)/p,w=this.rgba.b*b/p+l.b*$*(1-b)/p;return new A(new O(f,y,w,p))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:b,b:$,a:p}=this.rgba;return new A(new O(h.rgba.r-p*(h.rgba.r-l),h.rgba.g-p*(h.rgba.g-b),h.rgba.b-p*(h.rgba.b-$),1))}flatten(...h){const l=h.reduceRight((b,$)=>A.o($,b));return A.o(this,l)}static o(h,l){const b=1-h.rgba.a;return new A(new O(b*l.rgba.r+h.rgba.a*h.rgba.r,b*l.rgba.g+h.rgba.a*h.rgba.g,b*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(h,l,b){if(h.isLighterThan(l))return h;b=b||.5;const $=h.getRelativeLuminance(),p=l.getRelativeLuminance();return b=b*(p-$)/p,h.lighten(b)}static getDarkerColor(h,l,b){if(h.isDarkerThan(l))return h;b=b||.5;const $=h.getRelativeLuminance(),p=l.getRelativeLuminance();return b=b*($-p)/$,h.darken(b)}static{this.white=new A(new O(255,255,255,1))}static{this.black=new A(new O(0,0,0,1))}static{this.red=new A(new O(255,0,0,1))}static{this.blue=new A(new O(0,0,255,1))}static{this.green=new A(new O(0,255,0,1))}static{this.cyan=new A(new O(0,255,255,1))}static{this.lightgrey=new A(new O(211,211,211,1))}static{this.transparent=new A(new O(0,0,0,0))}}e.$Ms=A,function(S){let h;(function(l){let b;(function($){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}$.formatRGB=p;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}$.formatRGBA=f;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}$.formatHSL=y;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}$.formatHSLA=w;function g(t){const u=t.toString(16);return u.length!==2?"0"+u:u}function c(t){return`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}`}$.formatHex=c;function a(t,u=!1){return u&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}${g(Math.round(t.rgba.a*255))}`}$.formatHexA=a;function m(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}$.format=m;function E(t){const u=t.length;if(u===0||t.charCodeAt(0)!==35)return null;if(u===7){const r=16*d(t.charCodeAt(1))+d(t.charCodeAt(2)),i=16*d(t.charCodeAt(3))+d(t.charCodeAt(4)),n=16*d(t.charCodeAt(5))+d(t.charCodeAt(6));return new S(new O(r,i,n,1))}if(u===9){const r=16*d(t.charCodeAt(1))+d(t.charCodeAt(2)),i=16*d(t.charCodeAt(3))+d(t.charCodeAt(4)),n=16*d(t.charCodeAt(5))+d(t.charCodeAt(6)),o=16*d(t.charCodeAt(7))+d(t.charCodeAt(8));return new S(new O(r,i,n,o/255))}if(u===4){const r=d(t.charCodeAt(1)),i=d(t.charCodeAt(2)),n=d(t.charCodeAt(3));return new S(new O(16*r+r,16*i+i,16*n+n))}if(u===5){const r=d(t.charCodeAt(1)),i=d(t.charCodeAt(2)),n=d(t.charCodeAt(3)),o=d(t.charCodeAt(4));return new S(new O(16*r+r,16*i+i,16*n+n,(16*o+o)/255))}return null}$.parseHex=E;function d(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=l.CSS||(l.CSS={}))})(h=S.Format||(S.Format={}))}(A||(e.$Ms=A={}))}),define(te[55],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function P(A){return(S,h,l)=>{let b=null,$=null;if(typeof l.value=="function"?(b="value",$=l.value):typeof l.get=="function"&&(b="get",$=l.get),!$)throw new Error("not supported");l[b]=A($,h)}}function O(A,S,h){let l=null,b=null;if(typeof h.value=="function"?(l="value",b=h.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",b=h.get),!b)throw new Error("not supported");const $=`$memoize$${S}`;h[l]=function(...p){return this.hasOwnProperty($)||Object.defineProperty(this,$,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,p)}),this[$]}}e.$5g=O;function s(A,S,h){return P((l,b)=>{const $=`$debounce$${b}`,p=`$debounce$result$${b}`;return function(...f){this[p]||(this[p]=h?h():void 0),clearTimeout(this[$]),S&&(this[p]=S(this[p],...f),f=[this[p]]),this[$]=setTimeout(()=>{l.apply(this,f),this[p]=h?h():void 0},A)}})}e.$6g=s;function M(A,S,h){return P((l,b)=>{const $=`$throttle$timer$${b}`,p=`$throttle$result$${b}`,f=`$throttle$lastRun$${b}`,y=`$throttle$pending$${b}`;return function(...w){if(this[p]||(this[p]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[p]=S(this[p],...w)),this[y])return;const g=this[f]+A;g<=Date.now()?(this[f]=Date.now(),l.apply(this,[this[p]]),this[p]=h?h():void 0):(this[y]=!0,this[$]=setTimeout(()=>{this[y]=!1,this[f]=Date.now(),l.apply(this,[this[p]]),this[p]=h?h():void 0},g-Date.now()))}})}e.$7g=M}),define(te[14],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(u=>{u(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=P,e.$V=new P;function O(d){e.$V.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=O;function s(d){if(!d||typeof d!="object")return!1;const t=d;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=s;function M(d){l(d)||e.$V.onUnexpectedError(d)}e.$Y=M;function A(d){l(d)||e.$V.onUnexpectedExternalError(d)}e.$Z=A;function S(d){if(d instanceof Error){const{name:t,message:u}=d,r=d.stacktrace||d.stack;return{$isError:!0,name:t,message:u,stack:r,noTelemetry:m.isErrorNoTelemetry(d)}}return d}e.$1=S;const h="Canceled";function l(d){return d instanceof b?!0:d instanceof Error&&d.name===h&&d.message===h}e.$2=l;class b extends Error{constructor(){super(h),this.name=this.message}}e.$3=b;function $(){const d=new Error(h);return d.name=d.message,d}e.$4=$;function p(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.$5=p;function f(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.$6=f;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=y;function w(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.$8=w;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=g;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=c;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=a;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const u=new m;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=m;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$ab=E}),define(te[23],ie([0,1,14,133]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.$4b=e.CompareResult=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.top=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function s(U,W=0){return U[U.length-(1+W)]}e.$qb=s;function M(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.$rb=M;function A(U,W,q=(V,re)=>V===re){if(U===W)return!0;if(!U||!W||U.length!==W.length)return!1;for(let V=0,re=U.length;V<re;V++)if(!q(U[V],W[V]))return!1;return!0}e.$sb=A;function S(U,W){const q=U.length-1;W<q&&(U[W]=U[q]),U.pop()}e.$tb=S;function h(U,W,q){return l(U.length,V=>q(U[V],W))}e.$ub=h;function l(U,W){let q=0,V=U-1;for(;q<=V;){const re=(q+V)/2|0,$e=W(re);if($e<0)q=re+1;else if($e>0)V=re-1;else return re}return-(q+1)}e.$vb=l;function b(U,W,q){if(U=U|0,U>=W.length)throw new TypeError("invalid index");const V=W[Math.floor(W.length*Math.random())],re=[],$e=[],de=[];for(const ue of W){const be=q(ue,V);be<0?re.push(ue):be>0?$e.push(ue):de.push(ue)}return U<re.length?b(U,re,q):U<re.length+de.length?de[0]:b(U-(re.length+de.length),$e,q)}e.$wb=b;function $(U,W){const q=[];let V;for(const re of U.slice(0).sort(W))!V||W(V[0],re)!==0?(V=[re],q.push(V)):V.push(re);return q}e.$xb=$;function*p(U,W){let q,V;for(const re of U)V!==void 0&&W(V,re)?q.push(re):(q&&(yield q),q=[re]),V=re;q&&(yield q)}e.$yb=p;function f(U,W){for(let q=0;q<=U.length;q++)W(q===0?void 0:U[q-1],q===U.length?void 0:U[q])}e.$zb=f;function y(U,W,q){const V=[];function re(ue,be,me){if(be===0&&me.length===0)return;const Se=V[V.length-1];Se&&Se.start+Se.deleteCount===ue?(Se.deleteCount+=be,Se.toInsert.push(...me)):V.push({start:ue,deleteCount:be,toInsert:me})}let $e=0,de=0;for(;;){if($e===U.length){re($e,0,W.slice(de));break}if(de===W.length){re($e,U.length-$e,[]);break}const ue=U[$e],be=W[de],me=q(ue,be);me===0?($e+=1,de+=1):me<0?(re($e,1,[]),$e+=1):me>0&&(re($e,0,[be]),de+=1)}return V}e.$Ab=y;function w(U,W,q){const V=y(U,W,q),re=[],$e=[];for(const de of V)re.push(...U.slice(de.start,de.start+de.deleteCount)),$e.push(...de.toInsert);return{removed:re,added:$e}}e.$Bb=w;function g(U,W,q){if(q===0)return[];const V=U.slice(0,q).sort(W);return a(U,W,V,q,U.length),V}e.top=g;function c(U,W,q,V,re){return q===0?Promise.resolve([]):new Promise(($e,de)=>{(async()=>{const ue=U.length,be=U.slice(0,q).sort(W);for(let me=q,Se=Math.min(q+V,ue);me<ue;me=Se,Se=Math.min(Se+V,ue)){if(me>q&&await new Promise(Ae=>setTimeout(Ae)),re&&re.isCancellationRequested)throw new P.$3;a(U,W,be,me,Se)}return be})().then($e,de)})}e.$Db=c;function a(U,W,q,V,re){for(const $e=q.length;V<re;V++){const de=U[V];if(W(de,q[$e-1])<0){q.pop();const ue=(0,O.$ib)(q,be=>W(de,be)<0);q.splice(ue,0,de)}}}function m(U){return U.filter(W=>!!W)}e.$Eb=m;function E(U){let W=0;for(let q=0;q<U.length;q++)U[q]&&(U[W]=U[q],W+=1);U.length=W}e.$Fb=E;function d(U,W,q){U.splice(q,0,U.splice(W,1)[0])}e.$Gb=d;function t(U){return!Array.isArray(U)||U.length===0}e.$Hb=t;function u(U){return Array.isArray(U)&&U.length>0}e.$Ib=u;function r(U,W=q=>q){const q=new Set;return U.filter(V=>{const re=W(V);return q.has(re)?!1:(q.add(re),!0)})}e.$Jb=r;function i(U){const W=new Set;return q=>{const V=U(q);return W.has(V)?!1:(W.add(V),!0)}}e.$Kb=i;function n(U,W){return U.length>0?U[0]:W}e.$Lb=n;function o(U,W){return U.length>0?U[U.length-1]:W}e.$Mb=o;function k(U,W,q=(V,re)=>V===re){let V=0;for(let re=0,$e=Math.min(U.length,W.length);re<$e&&q(U[re],W[re]);re++)V++;return V}e.$Nb=k;function I(U){return[].concat(...U)}e.$Ob=I;function D(U,W){let q=typeof W=="number"?U:0;typeof W=="number"?q=U:(q=0,W=U);const V=[];if(q<=W)for(let re=q;re<W;re++)V.push(re);else for(let re=q;re>W;re--)V.push(re);return V}e.$Pb=D;function v(U,W,q){return U.reduce((V,re)=>(V[W(re)]=q?q(re):re,V),Object.create(null))}e.$Qb=v;function R(U,W){return U.push(W),()=>j(U,W)}e.$Rb=R;function j(U,W){const q=U.indexOf(W);if(q>-1)return U.splice(q,1),W}e.$Sb=j;function N(U,W,q){const V=U.slice(0,W),re=U.slice(W);return V.concat(q,re)}e.$Tb=N;function z(U,W){let q;if(typeof W=="number"){let V=W;q=()=>{const re=Math.sin(V++)*179426549;return re-Math.floor(re)}}else q=Math.random;for(let V=U.length-1;V>0;V-=1){const re=Math.floor(q()*(V+1)),$e=U[V];U[V]=U[re],U[re]=$e}}e.$Ub=z;function se(U,W){const q=U.indexOf(W);q>-1&&(U.splice(q,1),U.unshift(W))}e.$Vb=se;function ee(U,W){const q=U.indexOf(W);q>-1&&(U.splice(q,1),U.push(W))}e.$Wb=ee;function ae(U,W){for(const q of W)U.push(q)}e.$Xb=ae;function ne(U,W){return Array.isArray(U)?U.map(W):W(U)}e.$Yb=ne;function oe(U){return Array.isArray(U)?U:[U]}e.$Zb=oe;function G(U){return U[Math.floor(Math.random()*U.length)]}e.$1b=G;function K(U,W,q){const V=F(U,W),re=U.length,$e=q.length;U.length=re+$e;for(let de=re-1;de>=V;de--)U[de+$e]=U[de];for(let de=0;de<$e;de++)U[de+V]=q[de]}e.$2b=K;function B(U,W,q,V){const re=F(U,W);let $e=U.splice(re,q);return $e===void 0&&($e=[]),K(U,re,V),$e}e.$3b=B;function F(U,W){return W<0?Math.max(W+U.length,0):Math.min(W,U.length)}var T;(function(U){function W($e){return $e<0}U.isLessThan=W;function q($e){return $e<=0}U.isLessThanOrEqual=q;function V($e){return $e>0}U.isGreaterThan=V;function re($e){return $e===0}U.isNeitherLessOrGreaterThan=re,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(T||(e.CompareResult=T={}));function H(U,W){return(q,V)=>W(U(q),U(V))}e.$4b=H;function Q(...U){return(W,q)=>{for(const V of U){const re=V(W,q);if(!T.isNeitherLessOrGreaterThan(re))return re}return T.neitherLessOrGreaterThan}}e.$5b=Q;const x=(U,W)=>U-W;e.$6b=x;const ce=(U,W)=>(0,e.$6b)(U?1:0,W?1:0);e.$7b=ce;function Y(U){return(W,q)=>-U(W,q)}e.$8b=Y;class C{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let q=this.c;for(;q<this.g.length&&W(this.g[q]);)q++;const V=q===this.c?null:this.g.slice(this.c,q);return this.c=q,V}takeFromEndWhile(W){let q=this.d;for(;q>=0&&W(this.g[q]);)q--;const V=q===this.d?null:this.g.slice(q+1,this.d+1);return this.d=q,V}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const q=this.g.slice(this.c,this.c+W);return this.c+=W,q}}e.$9b=C;class L{static{this.empty=new L(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(q=>(W(q),!0))}toArray(){const W=[];return this.iterate(q=>(W.push(q),!0)),W}filter(W){return new L(q=>this.iterate(V=>W(V)?q(V):!0))}map(W){return new L(q=>this.iterate(V=>q(W(V))))}some(W){let q=!1;return this.iterate(V=>(q=W(V),!q)),q}findFirst(W){let q;return this.iterate(V=>W(V)?(q=V,!1):!0),q}findLast(W){let q;return this.iterate(V=>(W(V)&&(q=V),!0)),q}findLastMaxBy(W){let q,V=!0;return this.iterate(re=>((V||T.isGreaterThan(W(re,q)))&&(V=!1,q=re),!0)),q}}e.$0b=L}),define(te[136],ie([0,1,14]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xc=e.$wc=e.$vc=e.$uc=e.ok=void 0;function O(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=O;function s(h,l="Unreachable"){throw new Error(l)}e.$uc=s;function M(h){if(!h)throw new P.$ab("Assertion Failed")}e.$vc=M;function A(h){if(!h()){debugger;h(),(0,P.$Y)(new P.$ab("Assertion Failed"))}}e.$wc=A;function S(h,l){let b=0;for(;b<h.length-1;){const $=h[b],p=h[b+1];if(!l($,p))return!1;b++}return!0}e.$xc=S}),define(te[49],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function P(O){const s=this;let M=!1,A;return function(){return M||(M=!0,A=O.apply(s,arguments)),A}}e.$bb=P}),define(te[68],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(O){function s(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}O.is=s;const M=Object.freeze([]);function A(){return M}O.empty=A;function*S(E){yield E}O.single=S;function h(E){return s(E)?E:S(E)}O.wrap=h;function l(E){return E||M}O.from=l;function b(E){return!E||E[Symbol.iterator]().next().done===!0}O.isEmpty=b;function $(E){return E[Symbol.iterator]().next().value}O.first=$;function p(E,d){for(const t of E)if(d(t))return!0;return!1}O.some=p;function f(E,d){for(const t of E)if(d(t))return t}O.find=f;function*y(E,d){for(const t of E)d(t)&&(yield t)}O.filter=y;function*w(E,d){let t=0;for(const u of E)yield d(u,t++)}O.map=w;function*g(...E){for(const d of E)for(const t of d)yield t}O.concat=g;function c(E,d,t){let u=t;for(const r of E)u=d(u,r);return u}O.reduce=c;function*a(E,d,t=E.length){for(d<0&&(d+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);d<t;d++)yield E[d]}O.slice=a;function m(E,d=Number.POSITIVE_INFINITY){const t=[];if(d===0)return[t,E];const u=E[Symbol.iterator]();for(let r=0;r<d;r++){const i=u.next();if(i.done)return[t,O.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return u}}]}O.consume=m})(P||(e.Iterable=P={}))}),define(te[44],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(t,u=!1){let r=0;const i=t.length;let n="",o=0,k=16,I=0;function D(ee){let ae=0,ne=0;for(;ae<ee;){const oe=t.charCodeAt(r);if(oe>=48&&oe<=57)ne=ne*16+oe-48;else if(oe>=65&&oe<=70)ne=ne*16+oe-65+10;else if(oe>=97&&oe<=102)ne=ne*16+oe-97+10;else break;r++,ae++}return ae<ee&&(ne=-1),ne}function v(ee){r=ee,n="",o=0,k=16,I=0}function R(){const ee=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return I=3,t.substring(ee,r);let ae=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;ae=r}else I=3;return t.substring(ee,ae)}function j(){let ee="",ae=r;for(;;){if(r>=i){ee+=t.substring(ae,r),I=2;break}const ne=t.charCodeAt(r);if(ne===34){ee+=t.substring(ae,r),r++;break}if(ne===92){if(ee+=t.substring(ae,r),r++,r>=i){I=2;break}switch(t.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const G=D(4);G>=0?ee+=String.fromCharCode(G):I=4;break}default:I=5}ae=r;continue}if(ne>=0&&ne<=31)if(h(ne)){ee+=t.substring(ae,r),I=2;break}else I=6;r++}return ee}function N(){if(n="",I=0,o=r,r>=i)return o=i,k=17;let ee=t.charCodeAt(r);if(S(ee)){do r++,n+=String.fromCharCode(ee),ee=t.charCodeAt(r);while(S(ee));return k=15}if(h(ee))return r++,n+=String.fromCharCode(ee),ee===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),k=14;switch(ee){case 123:return r++,k=1;case 125:return r++,k=2;case 91:return r++,k=3;case 93:return r++,k=4;case 58:return r++,k=6;case 44:return r++,k=5;case 34:return r++,n=j(),k=10;case 47:{const ae=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!h(t.charCodeAt(r));)r++;return n=t.substring(ae,r),k=12}if(t.charCodeAt(r+1)===42){r+=2;const ne=i-1;let oe=!1;for(;r<ne;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,oe=!0;break}r++}return oe||(r++,I=1),n=t.substring(ae,r),k=13}return n+=String.fromCharCode(ee),r++,k=16}case 45:if(n+=String.fromCharCode(ee),r++,r===i||!l(t.charCodeAt(r)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),k=11;default:for(;r<i&&z(ee);)r++,ee=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return n+=String.fromCharCode(ee),r++,k=16}}function z(ee){if(S(ee)||h(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ee;do ee=N();while(ee>=12&&ee<=15);return ee}return{setPosition:v,getPosition:()=>r,scan:u?se:N,getToken:()=>k,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>I}}e.$Im=A;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function $(t,u){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function I(D,v,R,j){o.value=D,o.offset=v,o.length=R,o.type=j,o.colonOffset=void 0,n=o}try{m(t,{onObjectBegin:(D,v)=>{if(u<=D)throw i;n=void 0,k=u>D,r.push("")},onObjectProperty:(D,v,R)=>{if(u<v||(I(D,v,R,"property"),r[r.length-1]=D,u<=v+R))throw i},onObjectEnd:(D,v)=>{if(u<=D)throw i;n=void 0,r.pop()},onArrayBegin:(D,v)=>{if(u<=D)throw i;n=void 0,r.push(0)},onArrayEnd:(D,v)=>{if(u<=D)throw i;n=void 0,r.pop()},onLiteralValue:(D,v,R)=>{if(u<v||(I(D,v,R,d(D)),u<=v+R))throw i},onSeparator:(D,v,R)=>{if(u<=v)throw i;if(D===":"&&n&&n.type==="property")n.colonOffset=v,k=!1,n=void 0;else if(D===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(k=!0,r[r.length-1]=""),n=void 0}}})}catch(D){if(D!==i)throw D}return{path:r,previousNode:n,isAtPropertyKey:k,matches:D=>{let v=0;for(let R=0;v<D.length&&R<r.length;R++)if(D[v]===r[R]||D[v]==="*")v++;else if(D[v]!=="**")return!1;return v===D.length}}}e.$Jm=$;function p(t,u=[],r=M.DEFAULT){let i=null,n=[];const o=[];function k(D){Array.isArray(n)?n.push(D):i!==null&&(n[i]=D)}return m(t,{onObjectBegin:()=>{const D={};k(D),o.push(n),n=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const D=[];k(D),o.push(n),n=D,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:k,onError:(D,v,R)=>{u.push({error:D,offset:v,length:R})}},r),n[0]}e.$Km=p;function f(t,u=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function o(D){return i.children.push(D),D}m(t,{onObjectBegin:D=>{i=o({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,v,R)=>{i=o({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:v,length:R,parent:i})},onObjectEnd:(D,v)=>{i.length=D+v-i.offset,i=i.parent,n(D+v)},onArrayBegin:(D,v)=>{i=o({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,v)=>{i.length=D+v-i.offset,i=i.parent,n(D+v)},onLiteralValue:(D,v,R)=>{o({type:d(D),offset:v,length:R,parent:i,value:D}),n(v+R)},onSeparator:(D,v,R)=>{i.type==="property"&&(D===":"?i.colonOffset=v:D===","&&n(v))},onError:(D,v,R)=>{u.push({error:D,offset:v,length:R})}},r);const I=i.children[0];return I&&delete I.parent,I}e.$Lm=f;function y(t,u){if(!t)return;let r=t;for(const i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Mm=y;function w(t){if(!t.parent||!t.parent.children)return[];const u=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}e.$Nm=w;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const u=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(u[r.children[0].value]=g(i))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Om=g;function c(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}e.$Pm=c;function a(t,u,r=!1){if(c(t,u,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=u;n++){const o=a(i[n],u,r);if(o)return o}return t}}e.$Qm=a;function m(t,u,r=M.DEFAULT){const i=A(t,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Q){return Q?x=>Q(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const k=n(u.onObjectBegin),I=o(u.onObjectProperty),D=n(u.onObjectEnd),v=n(u.onArrayBegin),R=n(u.onArrayEnd),j=o(u.onLiteralValue),N=o(u.onSeparator),z=n(u.onComment),se=o(u.onError),ee=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function ne(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:ee||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(Q){case 12:case 13:ee?oe(10):z();break;case 16:oe(1);break;case 15:case 14:break;default:return Q}}}function oe(Q,x=[],ce=[]){if(se(Q),x.length+ce.length>0){let Y=i.getToken();for(;Y!==17;){if(x.indexOf(Y)!==-1){ne();break}else if(ce.indexOf(Y)!==-1)break;Y=ne()}}}function G(Q){const x=i.getTokenValue();return Q?j(x):I(x),ne(),!0}function K(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(oe(2),Q=0)}catch{oe(2)}j(Q);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return ne(),!0}function B(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(N(":"),ne(),H()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function F(){k(),ne();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),N(","),ne(),i.getToken()===2&&ae)break}else Q&&oe(6,[],[]);B()||oe(4,[],[2,5]),Q=!0}return D(),i.getToken()!==2?oe(7,[2],[]):ne(),!0}function T(){v(),ne();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),N(","),ne(),i.getToken()===4&&ae)break}else Q&&oe(6,[],[]);H()||oe(4,[],[4,5]),Q=!0}return R(),i.getToken()!==4?oe(8,[4],[]):ne(),!0}function H(){switch(i.getToken()){case 3:return T();case 1:return F();case 10:return G(!0);default:return K()}}return ne(),i.getToken()===17?r.allowEmptyContent?!0:(oe(4,[],[]),!1):H()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$Rm=m;function E(t,u){const r=A(t),i=[];let n,o=0,k;do switch(k=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:o!==k&&i.push(t.substring(o,k)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),o=r.getPosition();break}while(n!==17);return i.join("")}e.$Sm=E;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=d}),define(te[137],ie([0,1,44]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rS=e.$qS=e.$pS=e.$oS=void 0;function O(l,b,$){let p,f,y,w,g;if(b){for(w=b.offset,g=w+b.length,y=w;y>0&&!h(l,y-1);)y--;let k=g;for(;k<l.length&&!h(l,k);)k++;f=l.substring(y,k),p=A(f,$)}else f=l,p=0,y=0,w=0,g=l.length;const c=S($,l);let a=!1,m=0,E;$.insertSpaces?E=M(" ",$.tabSize||4):E="	";const d=(0,P.$Im)(f,!1);let t=!1;function u(){return c+M(E,p+m)}function r(){let k=d.scan();for(a=!1;k===15||k===14;)a=a||k===14,k=d.scan();return t=k===16||d.getTokenError()!==0,k}const i=[];function n(k,I,D){!t&&I<g&&D>w&&l.substring(I,D)!==k&&i.push({offset:I,length:D-I,content:k})}let o=r();if(o!==17){const k=d.getTokenOffset()+y,I=M(E,p);n(I,y,k)}for(;o!==17;){let k=d.getTokenOffset()+d.getTokenLength()+y,I=r(),D="";for(;!a&&(I===12||I===13);){const R=d.getTokenOffset()+y;n(" ",k,R),k=d.getTokenOffset()+d.getTokenLength()+y,D=I===12?u():"",I=r()}if(I===2)o!==1&&(m--,D=u());else if(I===4)o!==3&&(m--,D=u());else{switch(o){case 3:case 1:m++,D=u();break;case 5:case 12:D=u();break;case 13:a?D=u():D=" ";break;case 6:D=" ";break;case 10:if(I===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?D=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}a&&(I===12||I===13)&&(D=u())}const v=d.getTokenOffset()+y;n(D,k,v),o=I}return i}e.$oS=O;function s(l,b){const $=JSON.stringify(l,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?$.replace(/\r\n|\r|\n/g,b.eol):$}e.$pS=s;function M(l,b){let $="";for(let p=0;p<b;p++)$+=l;return $}function A(l,b){let $=0,p=0;const f=b.tabSize||4;for(;$<l.length;){const y=l.charAt($);if(y===" ")p++;else if(y==="	")p+=f;else break;$++}return Math.floor(p/f)}function S(l,b){for(let $=0;$<b.length;$++){const p=b.charAt($);if(p==="\r")return $+1<b.length&&b.charAt($+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return l&&l.eol||`
`}e.$qS=S;function h(l,b){return`\r
`.indexOf(l.charAt(b))!==-1}e.$rS=h}),define(te[138],ie([0,1,44,137]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wS=e.$vS=e.$uS=e.$tS=e.$sS=void 0;function s(l,b,$){return M(l,b,void 0,$)}e.$sS=s;function M(l,b,$,p,f){const y=b.slice(),w=[],g=(0,P.$Lm)(l,w);let c,a;for(;y.length>0&&(a=y.pop(),c=(0,P.$Mm)(g,y),c===void 0&&$!==void 0);)typeof a=="string"?$={[a]:$}:$=[$];if(c)if(c.type==="object"&&typeof a=="string"&&Array.isArray(c.children)){const m=(0,P.$Mm)(c,[a]);if(m!==void 0)if($===void 0){if(!m.parent)throw new Error("Malformed AST");const E=c.children.indexOf(m.parent);let d,t=m.parent.offset+m.parent.length;if(E>0){const u=c.children[E-1];d=u.offset+u.length}else d=c.offset+1,c.children.length>1&&(t=c.children[1].offset);return A(l,{offset:d,length:t-d,content:""},p)}else return A(l,{offset:m.offset,length:m.length,content:JSON.stringify($)},p);else{if($===void 0)return[];const E=`${JSON.stringify(a)}: ${JSON.stringify($)}`,d=f?f(c.children.map(u=>u.children[0].value)):c.children.length;let t;if(d>0){const u=c.children[d-1];t={offset:u.offset+u.length,length:0,content:","+E}}else c.children.length===0?t={offset:c.offset+1,length:0,content:E}:t={offset:c.offset+1,length:0,content:E+","};return A(l,t,p)}}else if(c.type==="array"&&typeof a=="number"&&Array.isArray(c.children))if($!==void 0){const m=`${JSON.stringify($)}`;let E;if(c.children.length===0||a===0)E={offset:c.offset+1,length:0,content:c.children.length===0?m:m+","};else{const d=a===-1||a>c.children.length?c.children.length:a,t=c.children[d-1];E={offset:t.offset+t.length,length:0,content:","+m}}return A(l,E,p)}else{const m=a,E=c.children[m];let d;if(c.children.length===1)d={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===m){const t=c.children[m-1],u=t.offset+t.length,r=c.offset+c.length;d={offset:u,length:r-2-u,content:""}}else d={offset:E.offset,length:c.children[m+1].offset-E.offset,content:""};return A(l,d,p)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${c.type}`);else{if($===void 0)throw new Error("Can not delete in empty document");return A(l,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify($)},p)}}e.$tS=M;function A(l,b,$){let p=S(l,b),f=b.offset,y=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;f>0&&!(0,O.$rS)(p,f-1);)f--;for(;y<p.length&&!(0,O.$rS)(p,y);)y++}const w=(0,O.$oS)(p,{offset:f,length:y-f},$);for(let c=w.length-1;c>=0;c--){const a=w[c];p=S(p,a),f=Math.min(f,a.offset),y=Math.max(y,a.offset+a.length),y+=a.content.length-a.length}const g=l.length-(p.length-y)-f;return[{offset:f,length:g,content:p.substring(f,y)}]}e.$uS=A;function S(l,b){return l.substring(0,b.offset)+b.content+l.substring(b.offset+b.length)}e.$vS=S;function h(l,b){const $=b.slice(0).sort((f,y)=>{const w=f.offset-y.offset;return w===0?f.length-y.length:w});let p=l.length;for(let f=$.length-1;f>=0;f--){const y=$[f];if(y.offset+y.length<=p)l=S(l,y);else throw new Error("Overlapping edit");p=y.offset}return l}e.$wS=h}),define(te[84],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=P}),define(te[2],ie([0,1,23,134,49,68]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=void 0;const A=!1;let S=null;class h{constructor(){this.b=new Map}static{this.a=0}c(v){let R=this.b.get(v);return R||(R={parent:null,source:null,isSingleton:!1,value:v,idx:h.a++},this.b.set(v,R)),R}trackDisposable(v){const R=this.c(v);R.source||(R.source=new Error().stack)}setParent(v,R){const j=this.c(v);j.parent=R}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,R){const j=R.get(v);if(j)return j;const N=v.parent?this.f(this.c(v.parent),R):v;return R.set(v,N),N}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,v).isSingleton).map(([j])=>j).flat()}computeLeakingDisposables(v=10,R){let j;if(R)j=R;else{const ae=new Map,ne=[...this.b.values()].filter(G=>G.source!==null&&!this.f(G,ae).isSingleton);if(ne.length===0)return;const oe=new Set(ne.map(G=>G.value));if(j=ne.filter(G=>!(G.parent&&oe.has(G.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function N(ae){function ne(G,K){for(;G.length>0&&K.some(B=>typeof B=="string"?B===G[0]:G[0].match(B));)G.shift()}const oe=ae.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return ne(oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),oe.reverse()}const z=new O.$L;for(const ae of j){const ne=N(ae);for(let oe=0;oe<=ne.length;oe++)z.add(ne.slice(0,oe).join(`
`),ae)}j.sort((0,P.$4b)(ae=>ae.idx,P.$6b));let se="",ee=0;for(const ae of j.slice(0,v)){ee++;const ne=N(ae),oe=[];for(let G=0;G<ne.length;G++){let K=ne[G];K=`(shared with ${z.get(ne.slice(0,G+1).join(`
`)).size}/${j.length} leaks) at ${K}`;const F=z.get(ne.slice(0,G).join(`
`)),T=(0,O.$I)([...F].map(H=>N(H)[G]),H=>H);delete T[ne[G]];for(const[H,Q]of Object.entries(T))oe.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${H}`);oe.unshift(K)}se+=`


==================== Leaking disposable ${ee}/${j.length}: ${ae.value.constructor.name} ====================
${oe.join(`
`)}
============================================================

`}return j.length>v&&(se+=`


... and ${j.length-v} more leaking disposables

`),{leaks:j,details:se}}}e.$$b=h;function l(D){S=D}if(e.$_b=l,A){const D="__is_disposable_tracked__";l(new class{trackDisposable(v){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[D]||console.log(R)},3e3)}setParent(v,R){if(v&&v!==d.None)try{v[D]=!0}catch{}}markAsDisposed(v){if(v&&v!==d.None)try{v[D]=!0}catch{}}markAsSingleton(v){}})}function b(D){return S?.trackDisposable(D),D}e.$ac=b;function $(D){S?.markAsDisposed(D)}e.$bc=$;function p(D,v){S?.setParent(D,v)}function f(D,v){if(S)for(const R of D)S.setParent(R,v)}function y(D){return S?.markAsSingleton(D),D}e.$cc=y;function w(D){return typeof D.dispose=="function"&&D.dispose.length===0}e.$dc=w;function g(D){if(M.Iterable.is(D)){const v=[];for(const R of D)if(R)try{R.dispose()}catch(j){v.push(j)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}e.$ec=g;function c(D){for(const v of D)w(v)&&v.dispose();return[]}e.$fc=c;function a(...D){const v=m(()=>g(D));return f(D,v),v}e.$gc=a;function m(D){const v=b({dispose:(0,s.$bb)(()=>{$(v),D()})});return v}e.$hc=m;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return p(v,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}}e.$ic=E;class d{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,b(this),p(this.q,this)}dispose(){$(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$jc=d;class t{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&p(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&p(v,null),v}}e.$kc=t;class u{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$lc=u;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(v){let R=v;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,$(this))},this}}e.$mc=r;class i{constructor(){this.a=new Map}acquire(v,...R){let j=this.a.get(v);j||(j={counter:0,object:this.b(v,...R)},this.a.set(v,j));const{object:N}=j,z=(0,s.$bb)(()=>{--j.counter===0&&(this.c(v,j.object),this.a.delete(v))});return j.counter++,{object:N,dispose:z}}}e.$nc=i;class n{constructor(v){this.a=v}async acquire(v,...R){const j=this.a.acquire(v,...R);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(N){throw j.dispose(),N}}}e.$oc=n;class o{constructor(v){this.object=v}dispose(){}}e.$pc=o;function k(D){const v=new E;try{D(v)}finally{v.dispose()}}e.$qc=k;class I{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,R,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(v)?.dispose(),this.a.set(v,R)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$rc=I}),define(te[101],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class O{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const A=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=A}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(A){const l=this.b;this.b=S,S.prev=l,l.next=S}else{const l=this.a;this.a=S,S.next=l,l.prev=S}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$sc=O}),define(te[34],ie([0,1]),function(J,e){"use strict";var P,O,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.Touch=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;function M(g,c,a){let m=g.get(c);return m===void 0&&(m=a,g.set(c,m)),m}e.$vi=M;function A(g){const c=[];return g.forEach((a,m)=>{c.push(`${m} => ${a}`)}),`Map(${g.size}) {${c.join(", ")}}`}e.$wi=A;function S(g){const c=[];return g.forEach(a=>{c.push(a)}),`Set(${g.size}) {${c.join(", ")}}`}e.$xi=S;class h{constructor(c,a){this.uri=c,this.value=a}}class l{static{this.a=c=>c.toString()}constructor(c,a){this[P]="ResourceMap",c instanceof l?(this.b=new Map(c.b),this.c=a??l.a):(this.b=new Map,this.c=c??l.a)}set(c,a){return this.b.set(this.c(c),new h(c,a)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,a){typeof a<"u"&&(c=c.bind(a));for(const[m,E]of this.b)c(E.value,E.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$yi=l;class b{constructor(c,a){this[O]="ResourceSet",!c||typeof c=="function"?this.a=new l(c):(this.a=new l(a),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,a){this.a.forEach((m,E)=>c.call(a,E,E,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zi=b;var $;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})($||(e.Touch=$={}));class p{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,a=0){const m=this.a.get(c);if(m)return a!==0&&this.j(m,a),m.value}set(c,a,m=0){let E=this.a.get(c);if(E)E.value=a,m!==0&&this.j(E,m);else{switch(E={key:c,value:a,next:void 0,previous:void 0},m){case 0:this.h(E);break;case 1:this.g(E);break;case 2:this.h(E);break;default:this.h(E);break}this.a.set(c,E),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const a=this.a.get(c);if(a)return this.a.delete(c),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,a){const m=this.e;let E=this.b;for(;E;){if(a?c.bind(a)(E.value,E.key,this):c(E.value,E.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const c=this,a=this.e;let m=this.b;const E={[Symbol.iterator](){return E},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const d={value:m.key,done:!1};return m=m.next,d}else return{value:void 0,done:!0}}};return E}values(){const c=this,a=this.e;let m=this.b;const E={[Symbol.iterator](){return E},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const d={value:m.value,done:!1};return m=m.next,d}else return{value:void 0,done:!0}}};return E}entries(){const c=this,a=this.e;let m=this.b;const E={[Symbol.iterator](){return E},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if(m){const d={value:[m.key,m.value],done:!1};return m=m.next,d}else return{value:void 0,done:!0}}};return E}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let a=this.b,m=this.size;for(;a&&m>c;)this.a.delete(a.key),a=a.next,m--;this.b=a,this.d=m,a&&(a.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const a=c.next,m=c.previous;if(!a||!m)throw new Error("Invalid list");a.previous=m,m.next=a}c.next=void 0,c.previous=void 0,this.e++}j(c,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(c===this.b)return;const m=c.next,E=c.previous;c===this.c?(E.next=void 0,this.c=E):(m.previous=E,E.next=m),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(a===2){if(c===this.c)return;const m=c.next,E=c.previous;c===this.b?(m.previous=void 0,this.b=m):(m.previous=E,E.next=m),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((a,m)=>{c.push([m,a])}),c}fromJSON(c){this.clear();for(const[a,m]of c)this.set(a,m)}}e.$Ai=p;class f extends p{constructor(c,a=1){super(),this.k=c,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,a=2){return super.get(c,a)}peek(c){return super.get(c,0)}set(c,a){return super.set(c,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bi=f;class y{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let a=this.a.get(c)||0;return a===0?!1:(a--,a===0?this.a.delete(c):this.a.set(c,a),!0)}has(c){return this.a.has(c)}}e.$Ci=y;class w{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[a,m]of c)this.set(a,m)}clear(){this.a.clear(),this.b.clear()}set(c,a){this.a.set(c,a),this.b.set(a,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const a=this.a.get(c);return a===void 0?!1:(this.a.delete(c),this.b.delete(a),!0)}forEach(c,a){this.a.forEach((m,E)=>{c.call(a,m,E,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Di=w}),define(te[85],ie([0,1,34]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=e.$gl=void 0;const O=new P.$Bi(1e4);function s(l){return h(l,"NFC",O)}e.$gl=s;const M=new P.$Bi(1e4);function A(l){return h(l,"NFD",M)}e.$hl=A;const S=/[^\u0000-\u0080]/;function h(l,b,$){if(!l)return l;const p=$.get(l);if(p)return p;let f;return S.test(l)?f=l.normalize(b):f=l,$.set(l,f),f}e.$il=function(){const l=/[\u0300-\u036f]/g;return function(b){return A(b).replace(l,"")}}()}),define(te[139],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.rot=e.$Gl=void 0;function P(S,h,l){return Math.min(Math.max(S,h),l)}e.$Gl=P;function O(S,h){return(h+S%h)%h}e.rot=O;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Il=s;class M{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jl=M;class A{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const l=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Kl=A}),function(){function J(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function A(h){M.push(h,Date.now())}function S(){const h=[];for(let l=0;l<M.length;l+=2)h.push({name:M[l],startTime:M[l+1]});return h}return{mark:A,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(s+A.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=P(O))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var O in P)(typeof exports=="object"?exports:J)[O]=P[O]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function P(O){if(e[O])return e[O].exports;var s=e[O]={i:O,l:!1,exports:{}};return J[O].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=J,P.c=e,P.d=function(O,s,M){P.o(O,s)||Object.defineProperty(O,s,{enumerable:!0,get:M})},P.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},P.t=function(O,s){if(1&s&&(O=P(O)),8&s||4&s&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&s&&typeof O!="string")for(var A in O)P.d(M,A,function(S){return O[S]}.bind(null,A));return M},P.n=function(O){var s=O&&O.__esModule?function(){return O.default}:function(){return O};return P.d(s,"a",s),s},P.o=function(O,s){return Object.prototype.hasOwnProperty.call(O,s)},P.p="",P(P.s=0)}([function(J,e,P){(function(O){var s;e=J.exports=ce,s=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],h=e.src=[],l=0,b=l++;h[b]="0|[1-9]\\d*";var $=l++;h[$]="[0-9]+";var p=l++;h[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=l++;h[f]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var y=l++;h[y]="("+h[$]+")\\.("+h[$]+")\\.("+h[$]+")";var w=l++;h[w]="(?:"+h[b]+"|"+h[p]+")";var g=l++;h[g]="(?:"+h[$]+"|"+h[p]+")";var c=l++;h[c]="(?:-("+h[w]+"(?:\\."+h[w]+")*))";var a=l++;h[a]="(?:-?("+h[g]+"(?:\\."+h[g]+")*))";var m=l++;h[m]="[0-9A-Za-z-]+";var E=l++;h[E]="(?:\\+("+h[m]+"(?:\\."+h[m]+")*))";var d=l++,t="v?"+h[f]+h[c]+"?"+h[E]+"?";h[d]="^"+t+"$";var u="[v=\\s]*"+h[y]+h[a]+"?"+h[E]+"?",r=l++;h[r]="^"+u+"$";var i=l++;h[i]="((?:<|>)?=?)";var n=l++;h[n]=h[$]+"|x|X|\\*";var o=l++;h[o]=h[b]+"|x|X|\\*";var k=l++;h[k]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[E]+"?)?)?";var I=l++;h[I]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[a]+")?"+h[E]+"?)?)?";var D=l++;h[D]="^"+h[i]+"\\s*"+h[k]+"$";var v=l++;h[v]="^"+h[i]+"\\s*"+h[I]+"$";var R=l++;h[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=l++;h[j]="(?:~>?)";var N=l++;h[N]="(\\s*)"+h[j]+"\\s+",S[N]=new RegExp(h[N],"g");var z=l++;h[z]="^"+h[j]+h[k]+"$";var se=l++;h[se]="^"+h[j]+h[I]+"$";var ee=l++;h[ee]="(?:\\^)";var ae=l++;h[ae]="(\\s*)"+h[ee]+"\\s+",S[ae]=new RegExp(h[ae],"g");var ne=l++;h[ne]="^"+h[ee]+h[k]+"$";var oe=l++;h[oe]="^"+h[ee]+h[I]+"$";var G=l++;h[G]="^"+h[i]+"\\s*("+u+")$|^$";var K=l++;h[K]="^"+h[i]+"\\s*("+t+")$|^$";var B=l++;h[B]="(\\s*)"+h[i]+"\\s*("+u+"|"+h[k]+")",S[B]=new RegExp(h[B],"g");var F=l++;h[F]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var T=l++;h[T]="^\\s*("+h[I]+")\\s+-\\s+("+h[I]+")\\s*$";var H=l++;h[H]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)s(Q,h[Q]),S[Q]||(S[Q]=new RegExp(h[Q]));function x(X,le){if(X instanceof ce)return X;if(typeof X!="string"||X.length>M||!(le?S[r]:S[d]).test(X))return null;try{return new ce(X,le)}catch{return null}}function ce(X,le){if(X instanceof ce){if(X.loose===le)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ce))return new ce(X,le);s("SemVer",X,le),this.loose=le;var fe=X.trim().match(le?S[r]:S[d]);if(!fe)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ce=+Ee;if(Ce>=0&&Ce<A)return Ce}return Ee}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=x,e.valid=function(X,le){var fe=x(X,le);return fe?fe.version:null},e.clean=function(X,le){var fe=x(X.trim().replace(/^[=v]+/,""),le);return fe?fe.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(X){return s("SemVer.compare",this.version,this.loose,X),X instanceof ce||(X=new ce(X,this.loose)),this.compareMain(X)||this.comparePre(X)},ce.prototype.compareMain=function(X){return X instanceof ce||(X=new ce(X,this.loose)),C(this.major,X.major)||C(this.minor,X.minor)||C(this.patch,X.patch)},ce.prototype.comparePre=function(X){if(X instanceof ce||(X=new ce(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var le=0;do{var fe=this.prerelease[le],Ee=X.prerelease[le];if(s("prerelease compare",le,fe,Ee),fe===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ee)return C(fe,Ee)}while(++le)},ce.prototype.inc=function(X,le){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,le,fe,Ee){typeof fe=="string"&&(Ee=fe,fe=void 0);try{return new ce(X,fe).inc(le,Ee).version}catch{return null}},e.diff=function(X,le){if(q(X,le))return null;var fe=x(X),Ee=x(le);if(fe.prerelease.length||Ee.prerelease.length){for(var Ce in fe)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&fe[Ce]!==Ee[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in fe)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&fe[Ce]!==Ee[Ce])return Ce},e.compareIdentifiers=C;var Y=/^[0-9]+$/;function C(X,le){var fe=Y.test(X),Ee=Y.test(le);return fe&&Ee&&(X=+X,le=+le),fe&&!Ee?-1:Ee&&!fe?1:X<le?-1:X>le?1:0}function L(X,le,fe){return new ce(X,fe).compare(new ce(le,fe))}function U(X,le,fe){return L(X,le,fe)>0}function W(X,le,fe){return L(X,le,fe)<0}function q(X,le,fe){return L(X,le,fe)===0}function V(X,le,fe){return L(X,le,fe)!==0}function re(X,le,fe){return L(X,le,fe)>=0}function $e(X,le,fe){return L(X,le,fe)<=0}function de(X,le,fe,Ee){var Ce;switch(le){case"===":typeof X=="object"&&(X=X.version),typeof fe=="object"&&(fe=fe.version),Ce=X===fe;break;case"!==":typeof X=="object"&&(X=X.version),typeof fe=="object"&&(fe=fe.version),Ce=X!==fe;break;case"":case"=":case"==":Ce=q(X,fe,Ee);break;case"!=":Ce=V(X,fe,Ee);break;case">":Ce=U(X,fe,Ee);break;case">=":Ce=re(X,fe,Ee);break;case"<":Ce=W(X,fe,Ee);break;case"<=":Ce=$e(X,fe,Ee);break;default:throw new TypeError("Invalid operator: "+le)}return Ce}function ue(X,le){if(X instanceof ue){if(X.loose===le)return X;X=X.value}if(!(this instanceof ue))return new ue(X,le);s("comparator",X,le),this.loose=le,this.parse(X),this.semver===be?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(X,le){return C(le,X)},e.major=function(X,le){return new ce(X,le).major},e.minor=function(X,le){return new ce(X,le).minor},e.patch=function(X,le){return new ce(X,le).patch},e.compare=L,e.compareLoose=function(X,le){return L(X,le,!0)},e.rcompare=function(X,le,fe){return L(le,X,fe)},e.sort=function(X,le){return X.sort(function(fe,Ee){return e.compare(fe,Ee,le)})},e.rsort=function(X,le){return X.sort(function(fe,Ee){return e.rcompare(fe,Ee,le)})},e.gt=U,e.lt=W,e.eq=q,e.neq=V,e.gte=re,e.lte=$e,e.cmp=de,e.Comparator=ue;var be={};function me(X,le){if(X instanceof me)return X.loose===le?X:new me(X.raw,le);if(X instanceof ue)return new me(X.value,le);if(!(this instanceof me))return new me(X,le);if(this.loose=le,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Se(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ae(X,le,fe,Ee,Ce,Ue,Oe,ze,We,Z,he,ge,ye){return((le=Se(fe)?"":Se(Ee)?">="+fe+".0.0":Se(Ce)?">="+fe+"."+Ee+".0":">="+le)+" "+(ze=Se(We)?"":Se(Z)?"<"+(+We+1)+".0.0":Se(he)?"<"+We+"."+(+Z+1)+".0":ge?"<="+We+"."+Z+"."+he+"-"+ge:"<="+ze)).trim()}function Le(X,le){for(var fe=0;fe<X.length;fe++)if(!X[fe].test(le))return!1;if(le.prerelease.length){for(fe=0;fe<X.length;fe++)if(s(X[fe].semver),X[fe].semver!==be&&X[fe].semver.prerelease.length>0){var Ee=X[fe].semver;if(Ee.major===le.major&&Ee.minor===le.minor&&Ee.patch===le.patch)return!0}return!1}return!0}function ve(X,le,fe){try{le=new me(le,fe)}catch{return!1}return le.test(X)}function we(X,le,fe,Ee){var Ce,Ue,Oe,ze,We;switch(X=new ce(X,Ee),le=new me(le,Ee),fe){case">":Ce=U,Ue=$e,Oe=W,ze=">",We=">=";break;case"<":Ce=W,Ue=re,Oe=U,ze="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(X,le,Ee))return!1;for(var Z=0;Z<le.set.length;++Z){var he=le.set[Z],ge=null,ye=null;if(he.forEach(function(Re){Re.semver===be&&(Re=new ue(">=0.0.0")),ge=ge||Re,ye=ye||Re,Ce(Re.semver,ge.semver,Ee)?ge=Re:Oe(Re.semver,ye.semver,Ee)&&(ye=Re)}),ge.operator===ze||ge.operator===We||(!ye.operator||ye.operator===ze)&&Ue(X,ye.semver)||ye.operator===We&&Oe(X,ye.semver))return!1}return!0}ue.prototype.parse=function(X){var le=this.loose?S[G]:S[K],fe=X.match(le);if(!fe)throw new TypeError("Invalid comparator: "+X);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ce(fe[2],this.loose):this.semver=be},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(X){return s("Comparator.test",X,this.loose),this.semver===be||(typeof X=="string"&&(X=new ce(X,this.loose)),de(X,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(X,le){if(!(X instanceof ue))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new me(X.value,le),ve(this.value,fe,le);if(X.operator==="")return fe=new me(this.value,le),ve(X.semver,fe,le);var Ee=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Ue=this.semver.version===X.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ze=de(this.semver,"<",X.semver,le)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),We=de(this.semver,">",X.semver,le)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Ee||Ce||Ue&&Oe||ze||We},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(X){var le=this.loose;X=X.trim(),s("range",X,le);var fe=le?S[T]:S[F];X=X.replace(fe,Ae),s("hyphen replace",X),X=X.replace(S[B],"$1$2$3"),s("comparator trim",X,S[B]),X=(X=(X=X.replace(S[N],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var Ee=le?S[G]:S[K],Ce=X.split(" ").map(function(Ue){return function(Oe,ze){return s("comp",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function(ge,ye){s("caret",ge,ye);var Re=ye?S[oe]:S[ne];return ge.replace(Re,function(Fe,je,Ne,Be,qe){var He;return s("caret",ge,Fe,je,Ne,Be,qe),Se(je)?He="":Se(Ne)?He=">="+je+".0.0 <"+(+je+1)+".0.0":Se(Be)?He=je==="0"?">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+".0 <"+(+je+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=je==="0"?Ne==="0"?">="+je+"."+Ne+"."+Be+qe+" <"+je+"."+Ne+"."+(+Be+1):">="+je+"."+Ne+"."+Be+qe+" <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+"."+Be+qe+" <"+(+je+1)+".0.0"):(s("no pr"),He=je==="0"?Ne==="0"?">="+je+"."+Ne+"."+Be+" <"+je+"."+Ne+"."+(+Be+1):">="+je+"."+Ne+"."+Be+" <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+"."+Be+" <"+(+je+1)+".0.0"),s("caret return",He),He})}(he,Z)}).join(" ")}(Oe,ze),s("caret",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function(ge,ye){var Re=ye?S[se]:S[z];return ge.replace(Re,function(Fe,je,Ne,Be,qe){var He;return s("tilde",ge,Fe,je,Ne,Be,qe),Se(je)?He="":Se(Ne)?He=">="+je+".0.0 <"+(+je+1)+".0.0":Se(Be)?He=">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=">="+je+"."+Ne+"."+Be+qe+" <"+je+"."+(+Ne+1)+".0"):He=">="+je+"."+Ne+"."+Be+" <"+je+"."+(+Ne+1)+".0",s("tilde return",He),He})}(he,Z)}).join(" ")}(Oe,ze),s("tildes",Oe),Oe=function(We,Z){return s("replaceXRanges",We,Z),We.split(/\s+/).map(function(he){return function(ge,ye){ge=ge.trim();var Re=ye?S[v]:S[D];return ge.replace(Re,function(Fe,je,Ne,Be,qe,He){s("xRange",ge,Fe,je,Ne,Be,qe,He);var xe=Se(Ne),Qe=xe||Se(Be),tt=Qe||Se(qe);return je==="="&&tt&&(je=""),xe?Fe=je===">"||je==="<"?"<0.0.0":"*":je&&tt?(Qe&&(Be=0),tt&&(qe=0),je===">"?(je=">=",Qe?(Ne=+Ne+1,Be=0,qe=0):tt&&(Be=+Be+1,qe=0)):je==="<="&&(je="<",Qe?Ne=+Ne+1:Be=+Be+1),Fe=je+Ne+"."+Be+"."+qe):Qe?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":tt&&(Fe=">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0"),s("xRange return",Fe),Fe})}(he,Z)}).join(" ")}(Oe,ze),s("xrange",Oe),Oe=function(We,Z){return s("replaceStars",We,Z),We.trim().replace(S[H],"")}(Oe,ze),s("stars",Oe),Oe}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Ue){return!!Ue.match(Ee)})),Ce=Ce.map(function(Ue){return new ue(Ue,le)})},me.prototype.intersects=function(X,le){if(!(X instanceof me))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ee){return X.set.some(function(Ce){return Ce.every(function(Ue){return Ee.intersects(Ue,le)})})})})},e.toComparators=function(X,le){return new me(X,le).set.map(function(fe){return fe.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},me.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new ce(X,this.loose));for(var le=0;le<this.set.length;le++)if(Le(this.set[le],X))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(X,le,fe){var Ee=null,Ce=null;try{var Ue=new me(le,fe)}catch{return null}return X.forEach(function(Oe){Ue.test(Oe)&&(Ee&&Ce.compare(Oe)!==-1||(Ce=new ce(Ee=Oe,fe)))}),Ee},e.minSatisfying=function(X,le,fe){var Ee=null,Ce=null;try{var Ue=new me(le,fe)}catch{return null}return X.forEach(function(Oe){Ue.test(Oe)&&(Ee&&Ce.compare(Oe)!==1||(Ce=new ce(Ee=Oe,fe)))}),Ee},e.validRange=function(X,le){try{return new me(X,le).range||"*"}catch{return null}},e.ltr=function(X,le,fe){return we(X,le,"<",fe)},e.gtr=function(X,le,fe){return we(X,le,">",fe)},e.outside=we,e.prerelease=function(X,le){var fe=x(X,le);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(X,le,fe){return X=new me(X,fe),le=new me(le,fe),X.intersects(le)},e.coerce=function(X){if(X instanceof ce)return X;if(typeof X!="string")return null;var le=X.match(S[R]);return le==null?null:x((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(J,e){var P,O,s=J.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function S(g){if(P===setTimeout)return setTimeout(g,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout(g,0);try{return P(g,0)}catch{try{return P.call(null,g,0)}catch{return P.call(this,g,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var h,l=[],b=!1,$=-1;function p(){b&&h&&(b=!1,h.length?l=h.concat(l):$=-1,l.length&&f())}function f(){if(!b){var g=S(p);b=!0;for(var c=l.length;c;){for(h=l,l=[];++$<c;)h&&h[$].run();$=-1,c=l.length}h=null,b=!1,function(a){if(O===clearTimeout)return clearTimeout(a);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(a);try{O(a)}catch{try{return O.call(null,a)}catch{return O.call(this,a)}}}(g)}}function y(g,c){this.fun=g,this.array=c}function w(){}s.nextTick=function(g){var c=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)c[a-1]=arguments[a];l.push(new y(g,c)),l.length!==1||b||S(f)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function(g){return[]},s.binding=function(g){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(g){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[140],ie([0,1]),function(J,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class O{constructor(S,h,l){this.level=S,this.key=h,this.value=l,this.forward=[]}}const s=void 0;class M{constructor(S,h=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new O(this.c,s,s)}get size(){return this.f}clear(){this.e=new O(this.c,s,s)}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,h){return M.h(this,S,h,this.comparator)&&(this.f+=1),this}delete(S){const h=M.k(this,S,this.comparator);return h&&(this.f-=1),h}forEach(S,h){let l=this.e.forward[0];for(;l;)S.call(h,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",h=this.e.forward[0];for(;h;)S+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return S}static g(S,h,l){let b=S.e;for(let $=S.d-1;$>=0;$--)for(;b.forward[$]&&l(b.forward[$].key,h)<0;)b=b.forward[$];if(b=b.forward[0],b&&l(b.key,h)===0)return b}static h(S,h,l,b){const $=[];let p=S.e;for(let f=S.d-1;f>=0;f--){for(;p.forward[f]&&b(p.forward[f].key,h)<0;)p=p.forward[f];$[f]=p}if(p=p.forward[0],p&&b(p.key,h)===0)return p.value=l,!1;{const f=M.j(S);if(f>S.d){for(let y=S.d;y<f;y++)$[y]=S.e;S.d=f}p=new O(f,h,l);for(let y=0;y<f;y++)p.forward[y]=$[y].forward[y],$[y].forward[y]=p;return!0}}static j(S,h=.5){let l=1;for(;Math.random()<h&&l<S.c;)l+=1;return l}static k(S,h,l){const b=[];let $=S.e;for(let p=S.d-1;p>=0;p--){for(;$.forward[p]&&l($.forward[p].key,h)<0;)$=$.forward[p];b[p]=$}if($=$.forward[0],!$||l($.key,h)!==0)return!1;for(let p=0;p<S.d&&b[p].forward[p]===$;p++)b[p].forward[p]=$.forward[p];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$mr=M}),define(te[69],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(M){return new O(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ad=O}),define(te[3],ie([0,1,14,49,2,101,69]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.Event=void 0;const S=!1,h=!1;var l;(function(D){D.None=()=>s.$jc.None;function v(de){if(h){const{onDidAddListener:ue}=de,be=y.create();let me=0;de.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),ue?.()}}}function R(de,ue){return K(de,()=>{},0,void 0,!0,void 0,ue)}D.defer=R;function j(de){return(ue,be=null,me)=>{let Se=!1,Ae;return Ae=de(Le=>{if(!Se)return Ae?Ae.dispose():Se=!0,ue.call(be,Le)},null,me),Se&&Ae.dispose(),Ae}}D.once=j;function N(de,ue,be){return oe((me,Se=null,Ae)=>de(Le=>me.call(Se,ue(Le)),null,Ae),be)}D.map=N;function z(de,ue,be){return oe((me,Se=null,Ae)=>de(Le=>{ue(Le),me.call(Se,Le)},null,Ae),be)}D.forEach=z;function se(de,ue,be){return oe((me,Se=null,Ae)=>de(Le=>ue(Le)&&me.call(Se,Le),null,Ae),be)}D.filter=se;function ee(de){return de}D.signal=ee;function ae(...de){return(ue,be=null,me)=>{const Se=(0,s.$gc)(...de.map(Ae=>Ae(Le=>ue.call(be,Le))));return G(Se,me)}}D.any=ae;function ne(de,ue,be,me){let Se=be;return N(de,Ae=>(Se=ue(Se,Ae),Se),me)}D.reduce=ne;function oe(de,ue){let be;const me={onWillAddFirstListener(){be=de(Se.fire,Se)},onDidRemoveLastListener(){be?.dispose()}};ue||v(me);const Se=new m(me);return ue?.add(Se),Se.event}function G(de,ue){return ue instanceof Array?ue.push(de):ue&&ue.add(de),de}function K(de,ue,be=100,me=!1,Se=!1,Ae,Le){let ve,we,X,le=0,fe;const Ee={leakWarningThreshold:Ae,onWillAddFirstListener(){ve=de(Ue=>{le++,we=ue(we,Ue),me&&!X&&(Ce.fire(we),we=void 0),fe=()=>{const Oe=we;we=void 0,X=void 0,(!me||le>1)&&Ce.fire(Oe),le=0},typeof be=="number"?(clearTimeout(X),X=setTimeout(fe,be)):X===void 0&&(X=0,queueMicrotask(fe))})},onWillRemoveListener(){Se&&le>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,ve.dispose()}};Le||v(Ee);const Ce=new m(Ee);return Le?.add(Ce),Ce.event}D.debounce=K;function B(de,ue=0,be){return D.debounce(de,(me,Se)=>me?(me.push(Se),me):[Se],ue,void 0,!0,void 0,be)}D.accumulate=B;function F(de,ue=(me,Se)=>me===Se,be){let me=!0,Se;return se(de,Ae=>{const Le=me||!ue(Ae,Se);return me=!1,Se=Ae,Le},be)}D.latch=F;function T(de,ue,be){return[D.filter(de,ue,be),D.filter(de,me=>!ue(me),be)]}D.split=T;function H(de,ue=!1,be=[],me){let Se=be.slice(),Ae=de(we=>{Se?Se.push(we):ve.fire(we)});me&&me.add(Ae);const Le=()=>{Se?.forEach(we=>ve.fire(we)),Se=null},ve=new m({onWillAddFirstListener(){Ae||(Ae=de(we=>ve.fire(we)),me&&me.add(Ae))},onDidAddFirstListener(){Se&&(ue?setTimeout(Le):Le())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return me&&me.add(ve),ve.event}D.buffer=H;function Q(de,ue){return(me,Se,Ae)=>{const Le=ue(new ce);return de(function(ve){const we=Le.evaluate(ve);we!==x&&me.call(Se,we)},void 0,Ae)}}D.chain=Q;const x=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(be=>(ue(be),be)),this}filter(ue){return this.f.push(be=>ue(be)?be:x),this}reduce(ue,be){let me=be;return this.f.push(Se=>(me=ue(me,Se),me)),this}latch(ue=(be,me)=>be===me){let be=!0,me;return this.f.push(Se=>{const Ae=be||!ue(Se,me);return be=!1,me=Se,Ae?Se:x}),this}evaluate(ue){for(const be of this.f)if(ue=be(ue),ue===x)break;return ue}}function Y(de,ue,be=me=>me){const me=(...ve)=>Le.fire(be(...ve)),Se=()=>de.on(ue,me),Ae=()=>de.removeListener(ue,me),Le=new m({onWillAddFirstListener:Se,onDidRemoveLastListener:Ae});return Le.event}D.fromNodeEventEmitter=Y;function C(de,ue,be=me=>me){const me=(...ve)=>Le.fire(be(...ve)),Se=()=>de.addEventListener(ue,me),Ae=()=>de.removeEventListener(ue,me),Le=new m({onWillAddFirstListener:Se,onDidRemoveLastListener:Ae});return Le.event}D.fromDOMEventEmitter=C;function L(de){return new Promise(ue=>j(de)(ue))}D.toPromise=L;function U(de){const ue=new m;return de.then(be=>{ue.fire(be)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}D.fromPromise=U;function W(de,ue){return ue(void 0),de(be=>ue(be))}D.runAndSubscribe=W;function q(de,ue){let be=null;function me(Ae){be?.dispose(),be=new s.$ic,ue(Ae,be)}me(void 0);const Se=de(Ae=>me(Ae));return(0,s.$hc)(()=>{Se.dispose(),be?.dispose()})}D.runAndSubscribeWithStore=q;class V{constructor(ue,be){this._observable=ue,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};be||v(me),this.emitter=new m(me),be&&be.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,be){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function re(de,ue){return new V(de,ue).emitter.event}D.fromObservable=re;function $e(de){return ue=>{let be=0,me=!1;const Se={beginUpdate(){be++},endUpdate(){be--,be===0&&(de.reportChanges(),me&&(me=!1,ue()))},handlePossibleChange(){},handleChange(){me=!0}};return de.addObserver(Se),de.reportChanges(),{dispose(){de.removeObserver(Se)}}}}D.fromObservableLight=$e})(l||(e.Event=l={}));class b{static{this.all=new Set}static{this.f=0}constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${b.f++}`,b.all.add(this)}start(v){this.g=new A.$ad,this.listenerCount=v}stop(){if(this.g){const v=this.g.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.g=void 0}}}e.$cd=b;let $=-1;function p(D){const v=$;return $=D,{dispose(){$=v}}}e.$dd=p;class f{constructor(v,R=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=R,this.g=0}dispose(){this.f?.clear()}check(v,R){const j=this.threshold;if(j<=0||R<j)return;this.f||(this.f=new Map);const N=this.f.get(v.value)||0;if(this.f.set(v.value,N+1),this.g-=1,this.g<=0){this.g=j*.5;let z,se=0;for(const[ee,ae]of this.f)(!z||se<ae)&&(z=ee,se=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${se}):`),console.warn(z)}return()=>{const z=this.f.get(v.value)||0;this.f.set(v.value,z-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class g{constructor(v){this.value=v,this.id=w++}}const c=2,a=(D,v)=>{if(D instanceof g)v(D);else for(let R=0;R<D.length;R++){const j=D[R];j&&v(j)}};class m{constructor(v){this.w=0,this.f=v,this.g=$>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const v=this.t;queueMicrotask(()=>{a(v,R=>R.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(v,R,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$jc.None;if(this.m)return s.$jc.None;R&&(v=v.bind(R));const N=new g(v);let z,se;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=y.create(),z=this.g.check(N.stack,this.w+1)),S&&(N.stack=se??y.create()),this.t?this.t instanceof g?(this.u??=new d,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,s.$hc)(()=>{z?.(),this.x(N)});return j instanceof s.$ic?j.add(ee):Array.isArray(j)&&j.push(ee),ee},this.q}x(v){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const R=this.t,j=R.indexOf(v);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,R[j]=void 0;const N=this.u.current===this;if(this.w*c<=R.length){let z=0;for(let se=0;se<R.length;se++)R[se]?R[z++]=R[se]:N&&(this.u.end--,z<this.u.i&&this.u.i--);R.length=z}}y(v,R){if(!v)return;const j=this.f?.onListenerError||P.$Y;if(!j){v.value(R);return}try{v.value(R)}catch(N){j(N)}}z(v){const R=v.current.t;for(;v.i<v.end;)this.y(R[v.i++],v.value);v.reset()}fire(v){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,v);else{const R=this.u;R.enqueue(this,v,this.t.length),this.z(R)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ed=m;const E=()=>new d;e.$fd=E;class d{constructor(){this.i=-1,this.end=0}enqueue(v,R,j){this.i=0,this.end=j,this.current=v,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends m{async fireAsync(v,R,j){if(this.t)for(this.h||(this.h=new M.$sc),a(this.t,N=>this.h.push([N.value,v]));this.h.size>0&&!R.isCancellationRequested;){const[N,z]=this.h.shift(),se=[],ee={...z,token:R,waitUntil:ae=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");j&&(ae=j(ae,N)),se.push(ae)}};try{N(ee)}catch(ae){(0,P.$Y)(ae);continue}Object.freeze(se),await Promise.allSettled(se).then(ae=>{for(const ne of ae)ne.status==="rejected"&&(0,P.$Y)(ne.reason)})}}}e.$gd=t;class u extends m{get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new M.$sc,this.A=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.A(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.w&&(this.h!==0?this.s.push(v):super.fire(v))}}e.$hd=u;class r extends u{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}e.$id=r;class i extends m{constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(R=>super.fire(R)),this.h=[]}))}}e.$jd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new m({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(v){const R={event:v,listener:null};this.h.push(R),this.g&&this.m(R);const j=()=>{this.g&&this.o(R);const N=this.h.indexOf(R);this.h.splice(N,1)};return(0,s.$hc)((0,O.$bb)(j))}j(){this.g=!0,this.h.forEach(v=>this.m(v))}k(){this.g=!1,this.h.forEach(v=>this.o(v))}m(v){v.listener=v.event(R=>this.f.fire(R))}o(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.f.dispose()}}e.$kd=n;class o{constructor(v,R,j,N){this.f=new s.$ic;const z=this.f.add(new n),se=this.f.add(new s.$rc);function ee(ae){se.set(ae,z.add(N(ae)))}for(const ae of v)ee(ae);this.f.add(R(ae=>{ee(ae)})),this.f.add(j(ae=>{se.deleteAndDispose(ae)})),this.event=z.event}dispose(){this.f.dispose()}}e.$ld=o;class k{constructor(){this.f=[]}wrapEvent(v){return(R,j,N)=>v(z=>{const se=this.f[this.f.length-1];se?se.push(()=>R.call(j,z)):R.call(j,z)},void 0,N)}bufferEvents(v){const R=[];this.f.push(R);const j=v();return this.f.pop(),R.forEach(N=>N()),j}}e.$md=k;class I{constructor(){this.f=!1,this.g=l.None,this.h=s.$jc.None,this.j=new m({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(v){this.g=v,this.f&&(this.h.dispose(),this.h=v(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$nd=I}),define(te[22],ie([0,1,3]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.CancellationToken=void 0;const O=Object.freeze(function(S,h){const l=setTimeout(S.bind(h),0);return{dispose(){clearTimeout(l)}}});var s;(function(S){function h(l){return l===S.None||l===S.Cancelled||l instanceof M?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}S.isCancellationToken=h,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new P.$ed),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$od=A}),define(te[141],ie([0,1,22]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=void 0;class O{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$od,h=this.b(S.token);return this.a={promise:h,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$ge=O;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const h=JSON.stringify(S);return this.b!==h&&(this.b=h,this.a=this.c(S)),this.a}}e.$he=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const h=this.b(S);return this.a.set(S,h),h}}e.$ie=M}),define(te[56],ie([0,1,14,2]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function s(E){const d=E;return d?typeof d.read=="function":!1}e.$pd=s;function M(E){const d=E;return d?[d.on,d.pause,d.resume,d.destroy].every(t=>typeof t=="function"):!1}e.$qd=M;function A(E){const d=E;return d?M(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.$rd=A;function S(E,d){return new h(E,d)}e.$sd=S;class h{constructor(d,t){this.e=d,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(t=>t(d))}h(d){this.c.error.length===0?(0,P.$Y)(d):this.c.error.slice(0).forEach(t=>t(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,t){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(d,t){if(this.a.destroyed)return;let u;switch(d){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const r=u.indexOf(t);r>=0&&u.splice(r,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(E,d){const t=[];let u;for(;(u=E.read())!==null;)t.push(u);return d(t)}e.$td=l;function b(E,d,t){const u=[];let r;for(;(r=E.read())!==null&&u.length<t;)u.push(r);return r===null&&u.length>0?d(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return E.read()}}}e.$ud=b;function $(E,d){return new Promise((t,u)=>{const r=[];p(E,{onData:i=>{d&&r.push(i)},onError:i=>{d?u(i):t(void 0)},onEnd:()=>{t(d?d(r):void 0)}})})}e.$vd=$;function p(E,d,t){E.on("error",u=>{t?.isCancellationRequested||d.onError(u)}),E.on("end",()=>{t?.isCancellationRequested||d.onEnd()}),E.on("data",u=>{t?.isCancellationRequested||d.onData(u)})}e.$wd=p;function f(E,d){return new Promise((t,u)=>{const r=new O.$ic,i=[],n=I=>{if(i.push(I),i.length>d)return r.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},o=I=>(r.dispose(),u(I)),k=()=>(r.dispose(),t({stream:E,buffer:i,ended:!0}));r.add((0,O.$hc)(()=>E.removeListener("error",o))),E.on("error",o),r.add((0,O.$hc)(()=>E.removeListener("end",k))),E.on("end",k),r.add((0,O.$hc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$xd=f;function y(E,d){const t=S(d);return t.end(E),t}e.$yd=y;function w(){const E=S(()=>{throw new Error("not supported")});return E.end(),E}e.$zd=w;function g(E){let d=!1;return{read:()=>d?null:(d=!0,E)}}e.$Ad=g;function c(E,d,t){const u=S(t);return p(E,{onData:r=>u.write(d.data(r)),onError:r=>u.error(d.error?d.error(r):r),onEnd:()=>u.end()}),u}e.$Bd=c;function a(E,d,t){let u=!1;return{read:()=>{const r=d.read();return u?r:(u=!0,r!==null?t([E,r]):E)}}}e.$Cd=a;function m(E,d,t){let u=!1;const r=S(t);return p(d,{onData:i=>u?r.write(i):(u=!0,r.write(t([E,i]))),onError:i=>r.error(i),onEnd:()=>{u||(u=!0,r.write(E)),r.end()}}),r}e.$Dd=m}),define(te[17],ie([0,1,84,56]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const s=typeof Buffer<"u",M=new P.$T(()=>new Uint8Array(256));let A,S;class h{static alloc(R){return s?new h(Buffer.allocUnsafe(R)):new h(new Uint8Array(R))}static wrap(R){return s&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new h(R)}static fromString(R,j){return!(j?.dontUseNodeBuffer||!1)&&s?new h(Buffer.from(R)):(A||(A=new TextEncoder),new h(A.encode(R)))}static fromByteArray(R){const j=h.alloc(R.length);for(let N=0,z=R.length;N<z;N++)j.buffer[N]=R[N];return j}static concat(R,j){if(typeof j>"u"){j=0;for(let se=0,ee=R.length;se<ee;se++)j+=R[se].byteLength}const N=h.alloc(j);let z=0;for(let se=0,ee=R.length;se<ee;se++){const ae=R[se];N.set(ae,z),z+=ae.byteLength}return N}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=h.alloc(this.byteLength);return R.set(this),R}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(R,j){return new h(this.buffer.subarray(R,j))}set(R,j){if(R instanceof h)this.buffer.set(R.buffer,j);else if(R instanceof Uint8Array)this.buffer.set(R,j);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),j);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return p(this.buffer,R)}writeUInt32BE(R,j){f(this.buffer,R,j)}readUInt32LE(R){return y(this.buffer,R)}writeUInt32LE(R,j){w(this.buffer,R,j)}readUInt8(R){return g(this.buffer,R)}writeUInt8(R,j){c(this.buffer,R,j)}indexOf(R,j=0){return l(this.buffer,R instanceof h?R.buffer:R,j)}}e.$Ed=h;function l(v,R,j=0){const N=R.byteLength,z=v.byteLength;if(N===0)return 0;if(N===1)return v.indexOf(R[0]);if(N>z-j)return-1;const se=M.value;se.fill(R.length);for(let oe=0;oe<R.length;oe++)se[R[oe]]=R.length-oe-1;let ee=j+R.length-1,ae=ee,ne=-1;for(;ee<z;)if(v[ee]===R[ae]){if(ae===0){ne=ee;break}ee--,ae--}else ee+=Math.max(R.length-ae,se[v[ee]]),ae=R.length-1;return ne}e.$Fd=l;function b(v,R){return v[R+0]<<0>>>0|v[R+1]<<8>>>0}e.$Gd=b;function $(v,R,j){v[j+0]=R&255,R=R>>>8,v[j+1]=R&255}e.$Hd=$;function p(v,R){return v[R]*2**24+v[R+1]*2**16+v[R+2]*2**8+v[R+3]}e.$Id=p;function f(v,R,j){v[j+3]=R,R=R>>>8,v[j+2]=R,R=R>>>8,v[j+1]=R,R=R>>>8,v[j]=R}e.$Jd=f;function y(v,R){return v[R+0]<<0>>>0|v[R+1]<<8>>>0|v[R+2]<<16>>>0|v[R+3]<<24>>>0}e.$Kd=y;function w(v,R,j){v[j+0]=R&255,R=R>>>8,v[j+1]=R&255,R=R>>>8,v[j+2]=R&255,R=R>>>8,v[j+3]=R&255}e.$Ld=w;function g(v,R){return v[R]}e.$Md=g;function c(v,R,j){v[j]=R}e.$Nd=c;function a(v){return O.$td(v,R=>h.concat(R))}e.$Od=a;function m(v){return O.$Ad(v)}e.$Pd=m;function E(v){return O.$vd(v,R=>h.concat(R))}e.$Qd=E;async function d(v){return v.ended?h.concat(v.buffer):h.concat([...v.buffer,await E(v.stream)])}e.$Rd=d;function t(v){return O.$yd(v,R=>h.concat(R))}e.$Sd=t;function u(v){return O.$Bd(v,{data:R=>typeof R=="string"?h.fromString(R):h.wrap(R)},R=>h.concat(R))}e.$Td=u;function r(v){return O.$sd(R=>h.concat(R),v)}e.$Ud=r;function i(v,R){return O.$Cd(v,R,j=>h.concat(j))}e.$Vd=i;function n(v,R){return O.$Dd(v,R,j=>h.concat(j))}e.$Wd=n;function o(v){let R=0,j=0,N=0;const z=new Uint8Array(Math.floor(v.length/4*3)),se=ae=>{switch(j){case 3:z[N++]=R|ae,j=0;break;case 2:z[N++]=R|ae>>>2,R=ae<<6,j=3;break;case 1:z[N++]=R|ae>>>4,R=ae<<4,j=2;break;default:R=ae<<2,j=1}};for(let ae=0;ae<v.length;ae++){const ne=v.charCodeAt(ae);if(ne>=65&&ne<=90)se(ne-65);else if(ne>=97&&ne<=122)se(ne-97+26);else if(ne>=48&&ne<=57)se(ne-48+52);else if(ne===43||ne===45)se(62);else if(ne===47||ne===95)se(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${v[ae]}`)}}const ee=N;for(;j>0;)se(0);return h.wrap(z).slice(0,ee)}e.$Xd=o;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:v},R=!0,j=!1){const N=j?I:k;let z="";const se=v.byteLength%3;let ee=0;for(;ee<v.byteLength-se;ee+=3){const ae=v[ee+0],ne=v[ee+1],oe=v[ee+2];z+=N[ae>>>2],z+=N[(ae<<4|ne>>>4)&63],z+=N[(ne<<2|oe>>>6)&63],z+=N[oe&63]}if(se===1){const ae=v[ee+0];z+=N[ae>>>2],z+=N[ae<<4&63],R&&(z+="==")}else if(se===2){const ae=v[ee+0],ne=v[ee+1];z+=N[ae>>>2],z+=N[(ae<<4|ne>>>4)&63],z+=N[ne<<2&63],R&&(z+="=")}return z}e.$Yd=D}),define(te[26],ie([0,1,141,84]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hf=e.$gf=e.$ff=e.$ef=e.GraphemeBreakType=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function s(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.$le=s;const M=/{(\d+)}/g;function A(Z,...he){return he.length===0?Z:Z.replace(M,function(ge,ye){const Re=parseInt(ye,10);return isNaN(Re)||Re<0||Re>=he.length?ge:he[Re]})}e.$me=A;const S=/{([^}]+)}/g;function h(Z,he){return Z.replace(S,(ge,ye)=>he[ye]??ge)}e.$ne=h;function l(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$oe=l;function b(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pe=b;function $(Z,he){let ge=0;const ye=he.charCodeAt(0);for(let Re=Z.length-1;Re>=0;Re--)Z.charCodeAt(Re)===ye&&ge++;return ge}e.$qe=$;function p(Z,he,ge="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${ge}`}e.$re=p;function f(Z,he=" "){const ge=y(Z,he);return w(ge,he)}e.$se=f;function y(Z,he){if(!Z||!he)return Z;const ge=he.length;if(ge===0||Z.length===0)return Z;let ye=0;for(;Z.indexOf(he,ye)===ye;)ye=ye+ge;return Z.substring(ye)}e.$te=y;function w(Z,he){if(!Z||!he)return Z;const ge=he.length,ye=Z.length;if(ge===0||ye===0)return Z;let Re=ye,Fe=-1;for(;Fe=Z.lastIndexOf(he,Re-1),!(Fe===-1||Fe+ge!==Re);){if(Fe===0)return"";Re=Fe}return Z.substring(0,Re)}e.$ue=w;function g(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$ve=g;function c(Z){return Z.replace(/\*/g,"")}e.$we=c;function a(Z,he,ge={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=b(Z)),ge.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ye="";return ge.global&&(ye+="g"),ge.matchCase||(ye+="i"),ge.multiline&&(ye+="m"),ge.unicode&&(ye+="u"),new RegExp(Z,ye)}e.$xe=a;function m(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.$ye=m;function E(Z){return Z.split(/\r\n|\r|\n/)}e.$ze=E;function d(Z){for(let he=0,ge=Z.length;he<ge;he++){const ye=Z.charCodeAt(he);if(ye!==32&&ye!==9)return he}return-1}e.$Ae=d;function t(Z,he=0,ge=Z.length){for(let ye=he;ye<ge;ye++){const Re=Z.charCodeAt(ye);if(Re!==32&&Re!==9)return Z.substring(he,ye)}return Z.substring(he,ge)}e.$Be=t;function u(Z,he=Z.length-1){for(let ge=he;ge>=0;ge--){const ye=Z.charCodeAt(ge);if(ye!==32&&ye!==9)return ge}return-1}e.$Ce=u;function r(Z,he,ge){const ye=[];let Re=0;for(const Fe of Z.matchAll(he)){if(ye.push(Z.slice(Re,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Re=Fe.index+Fe[0].length,ye.push(ge(Fe[0],...Fe.slice(1),Fe.index,Z,Fe.groups))}return ye.push(Z.slice(Re)),Promise.all(ye).then(Fe=>Fe.join(""))}e.$De=r;function i(Z,he){return Z<he?-1:Z>he?1:0}e.$Ee=i;function n(Z,he,ge=0,ye=Z.length,Re=0,Fe=he.length){for(;ge<ye&&Re<Fe;ge++,Re++){const Be=Z.charCodeAt(ge),qe=he.charCodeAt(Re);if(Be<qe)return-1;if(Be>qe)return 1}const je=ye-ge,Ne=Fe-Re;return je<Ne?-1:je>Ne?1:0}e.$Fe=n;function o(Z,he){return k(Z,he,0,Z.length,0,he.length)}e.$Ge=o;function k(Z,he,ge=0,ye=Z.length,Re=0,Fe=he.length){for(;ge<ye&&Re<Fe;ge++,Re++){let Be=Z.charCodeAt(ge),qe=he.charCodeAt(Re);if(Be===qe)continue;if(Be>=128||qe>=128)return n(Z.toLowerCase(),he.toLowerCase(),ge,ye,Re,Fe);D(Be)&&(Be-=32),D(qe)&&(qe-=32);const He=Be-qe;if(He!==0)return He}const je=ye-ge,Ne=Fe-Re;return je<Ne?-1:je>Ne?1:0}e.$He=k;function I(Z){return Z>=48&&Z<=57}e.$Ie=I;function D(Z){return Z>=97&&Z<=122}e.$Je=D;function v(Z){return Z>=65&&Z<=90}e.$Ke=v;function R(Z,he){return Z.length===he.length&&k(Z,he)===0}e.$Le=R;function j(Z,he){const ge=he.length;return he.length>Z.length?!1:k(Z,he,0,ge)===0}e.$Me=j;function N(Z,he){const ge=Math.min(Z.length,he.length);let ye;for(ye=0;ye<ge;ye++)if(Z.charCodeAt(ye)!==he.charCodeAt(ye))return ye;return ge}e.$Ne=N;function z(Z,he){const ge=Math.min(Z.length,he.length);let ye;const Re=Z.length-1,Fe=he.length-1;for(ye=0;ye<ge;ye++)if(Z.charCodeAt(Re-ye)!==he.charCodeAt(Fe-ye))return ye;return ge}e.$Oe=z;function se(Z){return 55296<=Z&&Z<=56319}e.$Pe=se;function ee(Z){return 56320<=Z&&Z<=57343}e.$Qe=ee;function ae(Z,he){return(Z-55296<<10)+(he-56320)+65536}e.$Re=ae;function ne(Z,he,ge){const ye=Z.charCodeAt(ge);if(se(ye)&&ge+1<he){const Re=Z.charCodeAt(ge+1);if(ee(Re))return ae(ye,Re)}return ye}e.$Se=ne;function oe(Z,he){const ge=Z.charCodeAt(he-1);if(ee(ge)&&he>1){const ye=Z.charCodeAt(he-2);if(se(ye))return ae(ye,ge)}return ge}class G{get offset(){return this.e}constructor(he,ge=0){this.c=he,this.d=he.length,this.e=ge}setOffset(he){this.e=he}prevCodePoint(){const he=oe(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=ne(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$Te=G;class K{get offset(){return this.c.offset}constructor(he,ge=0){this.c=new G(he,ge)}nextGraphemeLength(){const he=le.getInstance(),ge=this.c,ye=ge.offset;let Re=he.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Fe=ge.offset,je=he.getGraphemeBreakType(ge.nextCodePoint());if(we(Re,je)){ge.setOffset(Fe);break}Re=je}return ge.offset-ye}prevGraphemeLength(){const he=le.getInstance(),ge=this.c,ye=ge.offset;let Re=he.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Fe=ge.offset,je=he.getGraphemeBreakType(ge.prevCodePoint());if(we(je,Re)){ge.setOffset(Fe);break}Re=je}return ye-ge.offset}eol(){return this.c.eol()}}e.$Ue=K;function B(Z,he){return new K(Z,he).nextGraphemeLength()}e.$Ve=B;function F(Z,he){return new K(Z,he).prevGraphemeLength()}e.$We=F;function T(Z,he){he>0&&ee(Z.charCodeAt(he))&&he--;const ge=he+B(Z,he);return[ge-F(Z,ge),ge]}e.$Xe=T;function H(Z){const he=new K(Z);let ge=0;for(;!he.eol();)ge++,he.nextGraphemeLength();return ge}e.$Ye=H;let Q;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ce(Z){return Q||(Q=x()),Q.test(Z)}e.$Ze=ce;const Y=/^[\t\n\r\x20-\x7E]*$/;function C(Z){return Y.test(Z)}e.$1e=C,e.$2e=/[\u2028\u2029]/;function L(Z){return e.$2e.test(Z)}e.$3e=L;function U(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.$4e=U;function W(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.$5e=W;function q(Z,he){if(Z.length<he)return Z;const ge=/\b/g;let ye=0;for(;ge.test(Z)&&!(Z.length-ge.lastIndex<he);)ye=ge.lastIndex,ge.lastIndex+=1;return Z.substring(ye).replace(/^\s/,"")}e.$6e=q;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function $e(Z){return Z&&(Z=Z.replace(V,"").replace(re,"")),Z}e.$7e=$e,e.$8e=String.fromCharCode(65279);function de(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.$9e=de;function ue(Z){return de(Z)?Z.substr(1):Z}e.$0e=ue;function be(Z,he){if(!Z||!he||Z.length<he.length)return!1;const ge=he.length,ye=Z.toLowerCase();let Re=0,Fe=-1;for(;Re<ge;){const je=ye.indexOf(he[Re],Fe+1);if(je<0)return!1;Fe=je,Re++}return!0}e.$$e=be;function me(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.$_e=me;function Se(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.$af=Se;function Ae(Z,he=1){if(he===0)return"";let ge=-1;do ge=Z.indexOf(`
`,ge+1),he--;while(he>0&&ge>=0);return ge===-1?Z:(Z[ge-1]==="\r"&&ge--,Z.substr(0,ge))}e.$bf=Ae;function Le(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}e.$cf=Le;function ve(Z){return le.getInstance().getGraphemeBreakType(Z)}e.$df=ve;function we(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var X;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(X||(e.GraphemeBreakType=X={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=fe()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const ge=this.d,ye=ge.length/3;let Re=1;for(;Re<=ye;)if(he<ge[3*Re])Re=2*Re;else if(he>ge[3*Re+1])Re=2*Re+1;else return ge[3*Re+2];return 0}}function fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(Z,he){if(Z===0)return 0;const ge=Ce(Z,he);if(ge!==void 0)return ge;const ye=new G(he,Z);return ye.prevCodePoint(),ye.offset}e.$ef=Ee;function Ce(Z,he){const ge=new G(he,Z);let ye=ge.prevCodePoint();for(;Ue(ye)||ye===65039||ye===8419;){if(ge.offset===0)return;ye=ge.prevCodePoint()}if(!W(ye))return;let Re=ge.offset;return Re>0&&ge.prevCodePoint()===8205&&(Re=ge.offset),Re}function Ue(Z){return 127995<=Z&&Z<=127999}var Oe;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$ff="\xA0";class ze{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$he(he=>{function ge(He){const xe=new Map;for(let Qe=0;Qe<He.length;Qe+=2)xe.set(He[Qe],He[Qe+1]);return xe}function ye(He,xe){const Qe=new Map(He);for(const[tt,nt]of xe)Qe.set(tt,nt);return Qe}function Re(He,xe){if(!He)return xe;const Qe=new Map;for(const[tt,nt]of He)xe.has(tt)&&Qe.set(tt,nt);return Qe}const Fe=this.c.value;let je=he.filter(He=>!He.startsWith("_")&&He in Fe);je.length===0&&(je=["_default"]);let Ne;for(const He of je){const xe=ge(Fe[He]);Ne=Re(Ne,xe)}const Be=ge(Fe._common),qe=ye(Be,Ne);return new ze(qe)})}static getInstance(he){return ze.d.get(Array.from(he))}static{this.e=new O.$T(()=>Object.keys(ze.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return ze.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$gf=ze;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(he){return We.e().has(he)}static get codePoints(){return We.e()}}e.$hf=We}),define(te[57],ie([0,1,26]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0;function O(c){return s(c,0)}e.$oi=O;function s(c,a){switch(typeof c){case"object":return c===null?M(349,a):Array.isArray(c)?h(c,a):l(c,a);case"string":return S(c,a);case"boolean":return A(c,a);case"number":return M(c,a);case"undefined":return M(937,a);default:return M(617,a)}}e.$pi=s;function M(c,a){return(a<<5)-a+c|0}e.$qi=M;function A(c,a){return M(c?433:863,a)}function S(c,a){a=M(149417,a);for(let m=0,E=c.length;m<E;m++)a=M(c.charCodeAt(m),a);return a}e.$ri=S;function h(c,a){return a=M(104579,a),c.reduce((m,E)=>s(E,m),a)}function l(c,a){return a=M(181387,a),Object.keys(c).sort().reduce((m,E)=>(m=S(E,m),s(c[E],m)),a)}class b{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=s(a,this.g),this.g}}e.$si=b;var $;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function p(c,a,m=32){const E=m-a,d=~((1<<E)-1);return(c<<a|(d&c)>>>E)>>>0}function f(c,a=0,m=c.byteLength,E=0){for(let d=0;d<m;d++)c[a+d]=E}function y(c,a,m="0"){for(;c.length<a;)c=m+c;return c}function w(c,a=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(m=>m.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),a/4)}e.$ti=w;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const m=a.length;if(m===0)return;const E=this.p;let d=this.r,t=this.u,u,r;for(t!==0?(u=t,r=-1,t=0):(u=a.charCodeAt(0),r=0);;){let i=u;if(P.$Pe(u))if(r+1<m){const n=a.charCodeAt(r+1);P.$Qe(n)?(r++,i=P.$Re(u,n)):i=65533}else{t=u;break}else P.$Qe(u)&&(i=65533);if(d=this.w(E,d,i),r++,r<m)u=a.charCodeAt(r);else break}this.r=d,this.u=t}w(a,m,E){return E<128?a[m++]=E:E<2048?(a[m++]=192|(E&1984)>>>6,a[m++]=128|(E&63)>>>0):E<65536?(a[m++]=224|(E&61440)>>>12,a[m++]=128|(E&4032)>>>6,a[m++]=128|(E&63)>>>0):(a[m++]=240|(E&1835008)>>>18,a[m++]=128|(E&258048)>>>12,a[m++]=128|(E&4032)>>>6,a[m++]=128|(E&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=g.g,m=this.q;for(let k=0;k<64;k+=4)a.setUint32(k,m.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)a.setUint32(k,p(a.getUint32(k-12,!1)^a.getUint32(k-32,!1)^a.getUint32(k-56,!1)^a.getUint32(k-64,!1),1),!1);let E=this.h,d=this.l,t=this.m,u=this.n,r=this.o,i,n,o;for(let k=0;k<80;k++)k<20?(i=d&t|~d&u,n=1518500249):k<40?(i=d^t^u,n=1859775393):k<60?(i=d&t|d&u|t&u,n=2400959708):(i=d^t^u,n=3395469782),o=p(E,5)+i+r+n+a.getUint32(k*4,!1)&4294967295,r=u,u=t,t=p(d,30),d=E,E=o;this.h=this.h+E&4294967295,this.l=this.l+d&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+r&4294967295}}e.$ui=g}),define(te[70],ie([0,1,26]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(O||(O={})),function(s){const M="error",A="warning",S="warn",h="info",l="ignore";function b(p){return p?P.$Le(M,p)?s.Error:P.$Le(A,p)||P.$Le(S,p)?s.Warning:P.$Le(h,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=b;function $(p){switch(p){case s.Error:return M;case s.Warning:return A;case s.Info:return h;default:return l}}s.toString=$}(O||(O={})),e.default=O}),define(te[142],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(te[58],ie([0,1,23,26]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const y=f.charCodeAt(0),w=this.b.charCodeAt(this.c);return y-w}value(){return this.b[this.c]}}e.$Ch=s;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,O.$Fe)(f,this.b,0,f.length,this.c,this.d):(0,O.$He)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Dh=M;class A{constructor(f=!0,y=!0){this.f=f,this.g=y}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let y=f.length-1;y>=0;y--,this.c--){const w=this.b.charCodeAt(y);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,O.$Fe)(f,this.b,0,f.length,this.d,this.e):(0,O.$He)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Eh=A;var S;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(S||(S={}));class h{constructor(f,y){this.f=f,this.g=y,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,O.$Ge)(f,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Ge)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,O.$Ee)(f,this.c.query);if(this.d[this.e]===5)return(0,O.$Ee)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fh=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(b||(b={}));class ${static forUris(f=()=>!1,y=()=>!1){return new $(new h(f,y))}static forPaths(f=!1){return new $(new A(void 0,!f))}static forStrings(){return new $(new s)}static forConfigKeys(){return new $(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,y){if(y){const w=y.slice(0);(0,P.$Ub)(w);for(const g of w)this.set(g,f)}else{const w=f.slice(0);(0,P.$Ub)(w);for(const g of w)this.set(g[0],g[1])}}set(f,y){const w=this.b.reset(f);let g;this.c||(this.c=new l,this.c.segment=w.value());const c=[];for(g=this.c;;){const m=w.cmp(g.segment);if(m>0)g.left||(g.left=new l,g.left.segment=w.value()),c.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new l,g.right.segment=w.value()),c.push([1,g]),g=g.right;else if(w.hasNext())w.next(),g.mid||(g.mid=new l,g.mid.segment=w.value()),c.push([0,g]),g=g.mid;else break}const a=g.value;g.value=y,g.key=f;for(let m=c.length-1;m>=0;m--){const E=c[m][1];E.updateHeight();const d=E.balanceFactor();if(d<-1||d>1){const t=c[m][0],u=c[m+1][0];if(t===1&&u===1)c[m][1]=E.rotateLeft();else if(t===-1&&u===-1)c[m][1]=E.rotateRight();else if(t===1&&u===-1)E.right=c[m+1][1]=c[m+1][1].rotateRight(),c[m][1]=E.rotateLeft();else if(t===-1&&u===1)E.left=c[m+1][1]=c[m+1][1].rotateLeft(),c[m][1]=E.rotateRight();else throw new Error;if(m>0)switch(c[m-1][0]){case-1:c[m-1][1].left=c[m][1];break;case 1:c[m-1][1].right=c[m][1];break;case 0:c[m-1][1].mid=c[m][1];break}else this.c=c[0][1]}}return a}get(f){return this.d(f)?.value}d(f){const y=this.b.reset(f);let w=this.c;for(;w;){const g=y.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(f){const y=this.d(f);return!(y?.value===void 0&&y?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,y){const w=this.b.reset(f),g=[];let c=this.c;for(;c;){const a=w.cmp(c.segment);if(a>0)g.push([-1,c]),c=c.left;else if(a<0)g.push([1,c]),c=c.right;else if(w.hasNext())w.next(),g.push([0,c]),c=c.mid;else break}if(c){if(y?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const a=this.f(c.right);if(a.key){const{key:m,value:E,segment:d}=a;this.e(a.key,!1),c.key=m,c.value=E,c.segment=d}}else{const a=c.left??c.right;if(g.length>0){const[m,E]=g[g.length-1];switch(m){case-1:E.left=a;break;case 0:E.mid=a;break;case 1:E.right=a;break}}else this.c=a}for(let a=g.length-1;a>=0;a--){const m=g[a][1];m.updateHeight();const E=m.balanceFactor();if(E>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[a][1]=m.rotateLeft()):E<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[a][1]=m.rotateRight()),a>0)switch(g[a-1][0]){case-1:g[a-1][1].left=g[a][1];break;case 1:g[a-1][1].right=g[a][1];break;case 0:g[a-1][1].mid=g[a][1];break}else this.c=g[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const y=this.b.reset(f);let w=this.c,g;for(;w;){const c=y.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(y.hasNext())y.next(),g=w.value||g,w=w.mid;else break}return w&&w.value||g}findSuperstr(f){return this.g(f,!1)}g(f,y){const w=this.b.reset(f);let g=this.c;for(;g;){const c=w.cmp(g.segment);if(c>0)g=g.left;else if(c<0)g=g.right;else if(w.hasNext())w.next(),g=g.mid;else return g.mid?this.h(g.mid):y?g.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[y,w]of this)f(w,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const y=[];return this.j(f,y),y[Symbol.iterator]()}j(f,y){f&&(f.left&&this.j(f.left,y),f.value&&y.push([f.key,f.value]),f.mid&&this.j(f.mid,y),f.right&&this.j(f.right,y))}_isBalanced(){const f=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:f(y.left)&&f(y.right)};return f(this.c)}}e.$Gh=$}),define(te[12],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=void 0;function P(d){return typeof d=="string"}e.$if=P;function O(d){return Array.isArray(d)&&d.every(t=>P(t))}e.$jf=O;function s(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.$kf=s;function M(d){const t=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof t}e.$lf=M;function A(d){return typeof d=="number"&&!isNaN(d)}e.$mf=A;function S(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.$nf=S;function h(d){return d===!0||d===!1}e.$of=h;function l(d){return typeof d>"u"}e.$pf=l;function b(d){return!$(d)}e.$qf=b;function $(d){return l(d)||d===null}e.$rf=$;function p(d,t){if(!d)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$sf=p;function f(d){if($(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.$tf=f;function y(...d){const t=[];for(let u=0;u<d.length;u++){const r=d[u];if($(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(r)}return t}e.$uf=y;const w=Object.prototype.hasOwnProperty;function g(d){if(!s(d))return!1;for(const t in d)if(w.call(d,t))return!1;return!0}e.$vf=g;function c(d){return typeof d=="function"}e.$wf=c;function a(...d){return d.length>0&&d.every(c)}e.$xf=a;function m(d,t){const u=Math.min(d.length,t.length);for(let r=0;r<u;r++)E(d[r],t[r])}e.$yf=m;function E(d,t){if(P(t)){if(typeof d!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(d instanceof t)return}catch{}if(!$(d)&&d.constructor===t||t.length===1&&t.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$zf=E}),define(te[71],ie([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=void 0;const O=Object.create(null);function s(S,h){if((0,P.$if)(h)){const l=O[h];if(l===void 0)throw new Error(`${S} references an unknown codicon: ${h}`);h=l}return O[S]=h,{id:S}}function M(){return O}e.$Mj=M;function A(){return Object.values(e.$Oj)}e.$Nj=A,e.$Oj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=void 0;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const a=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([m,E])=>{a[m]=E&&typeof E=="object"?O(E):E}),a}e.$Um=O;function s(c){if(!c||typeof c!="object")return c;const a=[c];for(;a.length>0;){const m=a.shift();Object.freeze(m);for(const E in m)if(M.call(m,E)){const d=m[E];typeof d=="object"&&!Object.isFrozen(d)&&!(0,P.$lf)(d)&&a.push(d)}}return c}e.$Vm=s;const M=Object.prototype.hasOwnProperty;function A(c,a){return S(c,a,new Set)}e.$Wm=A;function S(c,a,m){if((0,P.$rf)(c))return c;const E=a(c);if(typeof E<"u")return E;if(Array.isArray(c)){const d=[];for(const t of c)d.push(S(t,a,m));return d}if((0,P.$kf)(c)){if(m.has(c))throw new Error("Cannot clone recursive data-structure");m.add(c);const d={};for(const t in c)M.call(c,t)&&(d[t]=S(c[t],a,m));return m.delete(c),d}return c}function h(c,a,m=!0){return(0,P.$kf)(c)?((0,P.$kf)(a)&&Object.keys(a).forEach(E=>{E in c?m&&((0,P.$kf)(c[E])&&(0,P.$kf)(a[E])?h(c[E],a[E],m):c[E]=a[E]):c[E]=a[E]}),c):a}e.$Xm=h;function l(c,a){if(c===a)return!0;if(c==null||a===null||a===void 0||typeof c!=typeof a||typeof c!="object"||Array.isArray(c)!==Array.isArray(a))return!1;let m,E;if(Array.isArray(c)){if(c.length!==a.length)return!1;for(m=0;m<c.length;m++)if(!l(c[m],a[m]))return!1}else{const d=[];for(E in c)d.push(E);d.sort();const t=[];for(E in a)t.push(E);if(t.sort(),!l(d,t))return!1;for(m=0;m<d.length;m++)if(!l(c[d[m]],a[d[m]]))return!1}return!0}e.$Ym=l;function b(c){const a=new Set;return JSON.stringify(c,(m,E)=>{if((0,P.$kf)(E)||Array.isArray(E)){if(a.has(E))return"[Circular]";a.add(E)}return E})}e.$Zm=b;function $(c,a){const m=Object.create(null);return!c||!a||Object.keys(a).forEach(d=>{const t=c[d],u=a[d];l(t,u)||(m[d]=u)}),m}e.$1m=$;function p(c,a){const m=a.toLowerCase(),E=Object.keys(c).find(d=>d.toLowerCase()===m);return E?c[E]:c[a]}e.$2m=p;function f(c,a){const m=Object.create(null);for(const[E,d]of Object.entries(c))a(E,d)&&(m[E]=d);return m}e.$3m=f;function y(c){let a=[];for(;Object.prototype!==c;)a=a.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return a}e.$4m=y;function w(c){const a=[];for(const m of y(c))typeof c[m]=="function"&&a.push(m);return a}e.$5m=w;function g(c,a){const m=d=>function(){const t=Array.prototype.slice.call(arguments,0);return a(d,t)},E={};for(const d of c)E[d]=m(d);return E}e.$6m=g}),define(te[102],ie([0,1,71]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Pj=e.ThemeColor=void 0;var O;(function(A){function S(h){return h&&typeof h=="object"&&typeof h.id=="string"}A.isThemeColor=S})(O||(e.ThemeColor=O={}));function s(A){return{id:A}}e.$Pj=s;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function h(a){const m=S.exec(a.id);if(!m)return h(P.$Oj.error);const[,E,d]=m,t=["codicon","codicon-"+E];return d&&t.push("codicon-modifier-"+d.substring(1)),t}A.asClassNameArray=h;function l(a){return h(a).join(" ")}A.asClassName=l;function b(a){return"."+h(a).join(".")}A.asCSSSelector=b;function $(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||O.isThemeColor(a.color))}A.isThemeIcon=$;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function f(a){const m=p.exec(a);if(!m)return;const[,E]=m;return{id:E}}A.fromString=f;function y(a){return{id:a}}A.fromId=y;function w(a,m){let E=a.id;const d=E.lastIndexOf("~");return d!==-1&&(E=E.substring(0,d)),m&&(E=`${E}~${m}`),{id:E}}A.modify=w;function g(a){const m=a.id.lastIndexOf("~");if(m!==-1)return a.id.substring(m+1)}A.getModifier=g;function c(a,m){return a.id===m.id&&a.color?.id===m.color?.id}A.isEqual=c})(M||(e.ThemeIcon=M={}))}),define(te[31],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(s){return P.test(s)}e.$2f=O,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let h=0;h<S.length;h++)S[h]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,l="";return l+=A[M[h++]],l+=A[M[h++]],l+=A[M[h++]],l+=A[M[h++]],l+="-",l+=A[M[h++]],l+=A[M[h++]],l+="-",l+=A[M[h++]],l+=A[M[h++]],l+="-",l+=A[M[h++]],l+=A[M[h++]],l+="-",l+=A[M[h++]],l+=A[M[h++]],l+=A[M[h++]],l+=A[M[h++]],l+=A[M[h++]],l+=A[M[h++]],l}}()}),define(te[143],ie([0,1,72,45,49]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ES=void 0;async function M(A,S){if(await new Promise((b,$)=>{const p=O.createReadStream(A),f=P.createHash("sha1");p.pipe(f);const y=(0,s.$bb)((w,g)=>{p.removeAllListeners(),f.removeAllListeners(),w?$(w):b(g)});p.once("error",y),p.once("end",y),f.once("error",y),f.once("data",w=>y(void 0,w.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$ES=M}),define(te[144],ie([0,1,27]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(A){const S=A.replace(/\-/g,":").toLowerCase();return!O.has(S)}function M(){const A=(0,P.networkInterfaces)();for(const S in A){const h=A[S];if(h){for(const{mac:l}of h)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Fm=M}),define(te[86],ie([0,1,27,58,31,144]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Gm=new class{c(l){return this.a||(this.a=O.$Gh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,b=0;const $=(0,P.networkInterfaces)();for(const p in $){const f=$[p];if(f)for(const{mac:y,internal:w}of f)w||(b+=1,this.c(y.toUpperCase())&&(l+=1))}this.b=b>0?l/b:0}return this.b}};let A;async function S(l){return A||(A=(async()=>await h(l)||s.$3f())()),A}e.$Hm=S;async function h(l){try{const b=await new Promise((p,f)=>{J(["crypto"],p,f)}),$=(0,M.$Fm)();return b.createHash("sha256").update($,"utf8").digest("hex")}catch(b){l(b);return}}}),define(te[103],ie([0,1,87]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=void 0;function O(S,h,l,b=1){let $=!1;return new Promise(p=>{const f=setTimeout(()=>{if(!$)return $=!0,p(0)},l);s(S,h,b,y=>{if(!$)return $=!0,clearTimeout(f),p(y)})})}e.$5f=O;function s(S,h,l,b){if(h===0)return b(0);const $=new P.Socket;$.once("connect",()=>(A($),s(S+l,h-1,l,b))),$.once("data",()=>{}),$.once("error",p=>(A($),p.code!=="ECONNREFUSED"?s(S+l,h-1,l,b):b(S))),$.connect(S,"127.0.0.1")}e.$6f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,h,l,b="127.0.0.1"){let $=!1,p,f=1;const y=P.createServer({pauseOnConnect:!0});function w(g,c){$||($=!0,y.removeAllListeners(),y.close(),p&&clearTimeout(p),c(g))}return new Promise(g=>{p=setTimeout(()=>{w(0,g)},l),y.on("listening",()=>{w(S,g)}),y.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&f<h?(S++,f++,y.listen(S,b)):w(0,g)}),y.on("close",()=>{w(0,g)}),y.listen(S,b)})}e.$7f=M;function A(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(h){console.error(h)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function P(h){const l=new Set;if(Array.isArray(h))for(const b of h)typeof b=="string"&&l.add(b);return Array.from(l)}function O(){const h=e();return h?Array.from(h):[]}function s(h){if(process.platform!=="win32")return;const l=e();if(l)if(typeof h=="string")l.add(h.toLowerCase());else for(const b of P(h))s(b)}function M(h){if(typeof h!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let b;for(const $ of l){if(h.indexOf($)!==0)continue;const f=h.indexOf("\\",$.length);if(f===-1)continue;const y=h.substring($.length,f);if(y){b=y;break}}return b}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[145],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IS=e.$HS=void 0,e.$HS="vscode:contextmenu",e.$IS="vscode:onCloseContextMenu"}),define(te[146],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PS=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$PS=P}),define(te[38],ie([0,1,15,14]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JS=void 0;class s{constructor(){this.a=new WeakMap}on(A,S){const h=(l,...b)=>{this.b(A,l)&&S(l,...b)};return this.a.set(S,h),P.ipcMain.on(A,h),this}once(A,S){return P.ipcMain.once(A,(h,...l)=>{this.b(A,h)&&S(h,...l)}),this}handle(A,S){return P.ipcMain.handle(A,(h,...l)=>this.b(A,h)?S(h,...l):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return P.ipcMain.removeHandler(A),this}removeListener(A,S){const h=this.a.get(S);return h&&(P.ipcMain.removeListener(A,h),this.a.delete(S)),this}b(A,S){if(!A||!A.startsWith("vscode:"))return(0,O.$Y)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const h=S.senderFrame,l=h.url;if(!l||l==="about:blank")return!0;let b="unknown";try{b=new URL(l).host}catch{return(0,O.$Y)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${l}'.`),!1}return b!=="vscode-app"?((0,O.$Y)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${b}'.`),!1):h.parent!==null?((0,O.$Y)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$JS=new s}),define(te[147],ie([0,1,15,38,145]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KS=void 0;function M(){O.$JS.on(s.$HS,(S,h,l,b,$)=>{const p=A(S,b,l);p.popup({window:P.BrowserWindow.fromWebContents(S.sender)??void 0,x:$?$.x:void 0,y:$?$.y:void 0,positioningItem:$?$.positioningItem:void 0,callback:()=>{p&&S.sender.send(s.$IS,h)}})})}e.$KS=M;function A(S,h,l){const b=new P.Menu;return l.forEach($=>{let p;$.type==="separator"?p=new P.MenuItem({type:$.type}):Array.isArray($.submenu)?p=new P.MenuItem({submenu:A(S,h,$.submenu),label:$.label}):p=new P.MenuItem({label:$.label,type:$.type,accelerator:$.accelerator,checked:$.checked,enabled:$.enabled,visible:$.visible,click:(f,y,w)=>S.sender.send(h,$.id,w)}),b.append(p)}),b}}),define(te[148],ie([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[149],ie([0,1,148]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const O=60,s=O*60,M=s*24,A=M*7,S=M*30,h=M*365;function l($,p,f,y){typeof $!="number"&&($=$.getTime());const w=Math.round((new Date().getTime()-$)/1e3);if(w<-30)return(0,P.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,P.localize)(1,null);let g;return w<O?(g=w,p?g===1?f?(0,P.localize)(2,null,g):(0,P.localize)(3,null,g):f?(0,P.localize)(4,null,g):(0,P.localize)(5,null,g):g===1?f?(0,P.localize)(6,null,g):(0,P.localize)(7,null,g):f?(0,P.localize)(8,null,g):(0,P.localize)(9,null,g)):w<s?(g=Math.floor(w/O),p?g===1?f?(0,P.localize)(10,null,g):(0,P.localize)(11,null,g):f?(0,P.localize)(12,null,g):(0,P.localize)(13,null,g):g===1?f?(0,P.localize)(14,null,g):(0,P.localize)(15,null,g):f?(0,P.localize)(16,null,g):(0,P.localize)(17,null,g)):w<M?(g=Math.floor(w/s),p?g===1?f?(0,P.localize)(18,null,g):(0,P.localize)(19,null,g):f?(0,P.localize)(20,null,g):(0,P.localize)(21,null,g):g===1?f?(0,P.localize)(22,null,g):(0,P.localize)(23,null,g):f?(0,P.localize)(24,null,g):(0,P.localize)(25,null,g)):w<A?(g=Math.floor(w/M),p?g===1?(0,P.localize)(26,null,g):(0,P.localize)(27,null,g):g===1?(0,P.localize)(28,null,g):(0,P.localize)(29,null,g)):w<S?(g=Math.floor(w/A),p?g===1?f?(0,P.localize)(30,null,g):(0,P.localize)(31,null,g):f?(0,P.localize)(32,null,g):(0,P.localize)(33,null,g):g===1?f?(0,P.localize)(34,null,g):(0,P.localize)(35,null,g):f?(0,P.localize)(36,null,g):(0,P.localize)(37,null,g)):w<h?(g=Math.floor(w/S),p?g===1?f?(0,P.localize)(38,null,g):(0,P.localize)(39,null,g):f?(0,P.localize)(40,null,g):(0,P.localize)(41,null,g):g===1?f?(0,P.localize)(42,null,g):(0,P.localize)(43,null,g):f?(0,P.localize)(44,null,g):(0,P.localize)(45,null,g)):(g=Math.floor(w/h),p?g===1?f?(0,P.localize)(46,null,g):(0,P.localize)(47,null,g):f?(0,P.localize)(48,null,g):(0,P.localize)(49,null,g):g===1?f?(0,P.localize)(50,null,g):(0,P.localize)(51,null,g):f?(0,P.localize)(52,null,g):(0,P.localize)(53,null,g))}e.$5l=l;function b($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=b}),define(te[150],ie([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,23,12,150]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function M($,p){return p&&($.stack||$.stacktrace)?s.localize(0,null,S($),A($.stack)||A($.stacktrace)):S($)}function A($){return Array.isArray($)?$.join(`
`):$}function S($){return $.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${$.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof $.code=="string"&&typeof $.errno=="number"&&typeof $.syscall=="string"?s.localize(1,null,$.message):$.message||s.localize(2,null)}function h($=null,p=!1){if(!$)return s.localize(3,null);if(Array.isArray($)){const f=P.$Eb($),y=h(f[0],p);return f.length>1?s.localize(4,null,y,f.length):y}if(O.$if($))return $;if($.detail){const f=$.detail;if(f.error)return M(f.error,p);if(f.exception)return M(f.exception,p)}return $.stack?M($,p):$.message?$.message:s.localize(5,null)}e.$li=h;function l($){const p=$;return p instanceof Error&&Array.isArray(p.actions)}e.$mi=l;function b($,p){let f;return typeof $=="string"?f=new Error($):f=$,f.actions=p,f}e.$ni=b}),define(te[151],ie([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(te[152],ie([0,1,151]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;function O(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$kp=O}),define(te[153],ie([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,153]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let O=!1,s=!1,M=!1,A=!1,S=!1,h=!1,l=!1,b=!1,$=!1,p=!1,f,y=e.$f,w=e.$f,g,c;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?a=e.$g.vscode.process:typeof process<"u"&&(a=process);const m=typeof a?.versions?.electron=="string",E=m&&a?.type==="renderer";if(typeof navigator=="object"&&!E)c=navigator.userAgent,O=c.indexOf("Windows")>=0,s=c.indexOf("Macintosh")>=0,b=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=c.indexOf("Linux")>=0,p=c?.indexOf("Mobi")>=0,h=!0,f=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$f,y=f,w=navigator.language;else if(typeof a=="object"){O=a.platform==="win32",s=a.platform==="darwin",M=a.platform==="linux",A=M&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,l=m,$=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$f,y=e.$f;const I=a.env.VSCODE_NLS_CONFIG;if(I)try{const D=JSON.parse(I),v=D.availableLanguages["*"];f=D.locale,w=D.osLocale,y=v||e.$f,g=D._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var d;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(d||(e.Platform=d={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let u=0;s?u=1:O?u=3:M&&(u=2),e.$i=O,e.$j=s,e.$k=M,e.$l=A,e.$m=S,e.$n=l,e.$o=h,e.$p=h&&typeof e.$g.importScripts=="function",e.$q=b,e.$r=p,e.$s=$,e.$t=u,e.$u=c,e.$v=y;var r;(function(I){function D(){return e.$v}I.value=D;function v(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}I.isDefaultVariant=v;function R(){return e.$v==="en"}I.isDefault=R})(r||(e.Language=r={})),e.$w=f,e.$x=w,e.$y=g,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const I=[];e.$g.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let R=0,j=I.length;R<j;R++){const N=I[R];if(N.id===v.data.vscodeScheduleAsyncWork){I.splice(R,1),N.callback();return}}});let D=0;return v=>{const R=++D;I.push({id:R,callback:v}),e.$g.postMessage({vscodeScheduleAsyncWork:R},"*")}}return I=>setTimeout(I)})();var i;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||b?2:O?1:3;let n=!0,o=!1;function k(){if(!o){o=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,n=new Uint16Array(I.buffer)[0]===(2<<8)+1}return n}e.$C=k,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.$2d=e.env=e.cwd=void 0;let O;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.process<"u"){const s=P.$g.vscode.process;O={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$2d=O.platform,e.$3d=O.arch}),define(te[9],ie([0,1,35]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.sep=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;const O=65,s=97,M=90,A=122,S=46,h=47,l=92,b=58,$=63;class p extends Error{constructor(u,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=u.indexOf(".")!==-1?"property":"argument";let k=`The "${u}" ${o} ${n} of type ${r}`;k+=`. Received type ${typeof i}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,u){if(t===null||typeof t!="object")throw new p(u,"Object",t)}function y(t,u){if(typeof t!="string")throw new p(u,"string",t)}const w=P.$2d==="win32";function g(t){return t===h||t===l}function c(t){return t===h}function a(t){return t>=O&&t<=M||t>=s&&t<=A}function m(t,u,r,i){let n="",o=0,k=-1,I=0,D=0;for(let v=0;v<=t.length;++v){if(v<t.length)D=t.charCodeAt(v);else{if(i(D))break;D=h}if(i(D)){if(!(k===v-1||I===1))if(I===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const R=n.lastIndexOf(r);R===-1?(n="",o=0):(n=n.slice(0,R),o=n.length-1-n.lastIndexOf(r)),k=v,I=0;continue}else if(n.length!==0){n="",o=0,k=v,I=0;continue}}u&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(k+1,v)}`:n=t.slice(k+1,v),o=v-k-1;k=v,I=0}else D===S&&I!==-1?++I:I=-1}return n}function E(t,u){f(u,"pathObject");const r=u.dir||u.root,i=u.base||`${u.name||""}${u.ext||""}`;return r?r===u.root?`${r}${i}`:`${r}${t}${i}`:i}e.$4d={resolve(...t){let u="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else u.length===0?o=P.cwd():(o=P.env[`=${u}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===l)&&(o=`${u}\\`));const k=o.length;let I=0,D="",v=!1;const R=o.charCodeAt(0);if(k===1)g(R)&&(I=1,v=!0);else if(g(R))if(v=!0,g(o.charCodeAt(1))){let j=2,N=j;for(;j<k&&!g(o.charCodeAt(j));)j++;if(j<k&&j!==N){const z=o.slice(N,j);for(N=j;j<k&&g(o.charCodeAt(j));)j++;if(j<k&&j!==N){for(N=j;j<k&&!g(o.charCodeAt(j));)j++;(j===k||j!==N)&&(D=`\\\\${z}\\${o.slice(N,j)}`,I=j)}}}else I=1;else a(R)&&o.charCodeAt(1)===b&&(D=o.slice(0,2),I=2,k>2&&g(o.charCodeAt(2))&&(v=!0,I=3));if(D.length>0)if(u.length>0){if(D.toLowerCase()!==u.toLowerCase())continue}else u=D;if(i){if(u.length>0)break}else if(r=`${o.slice(I)}\\${r}`,i=v,v&&u.length>0)break}return r=m(r,!i,"\\",g),i?`${u}\\${r}`:`${u}${r}`||"."},normalize(t){y(t,"path");const u=t.length;if(u===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(u===1)return c(o)?"\\":t;if(g(o))if(n=!0,g(t.charCodeAt(1))){let I=2,D=I;for(;I<u&&!g(t.charCodeAt(I));)I++;if(I<u&&I!==D){const v=t.slice(D,I);for(D=I;I<u&&g(t.charCodeAt(I));)I++;if(I<u&&I!==D){for(D=I;I<u&&!g(t.charCodeAt(I));)I++;if(I===u)return`\\\\${v}\\${t.slice(D)}\\`;I!==D&&(i=`\\\\${v}\\${t.slice(D,I)}`,r=I)}}}else r=1;else a(o)&&t.charCodeAt(1)===b&&(i=t.slice(0,2),r=2,u>2&&g(t.charCodeAt(2))&&(n=!0,r=3));let k=r<u?m(t.slice(r),!n,"\\",g):"";return k.length===0&&!n&&(k="."),k.length>0&&g(t.charCodeAt(u-1))&&(k+="\\"),i===void 0?n?`\\${k}`:k:n?`${i}\\${k}`:`${i}${k}`},isAbsolute(t){y(t,"path");const u=t.length;if(u===0)return!1;const r=t.charCodeAt(0);return g(r)||u>2&&a(r)&&t.charCodeAt(1)===b&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,r;for(let o=0;o<t.length;++o){const k=t[o];y(k,"path"),k.length>0&&(u===void 0?u=r=k:u+=`\\${k}`)}if(u===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&g(r.charCodeAt(0))){++n;const o=r.length;o>1&&g(r.charCodeAt(1))&&(++n,o>2&&(g(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<u.length&&g(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.$4d.normalize(u)},relative(t,u){if(y(t,"from"),y(u,"to"),t===u)return"";const r=e.$4d.resolve(t),i=e.$4d.resolve(u);if(r===i||(t=r.toLowerCase(),u=i.toLowerCase(),t===u))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===l;)o--;const k=o-n;let I=0;for(;I<u.length&&u.charCodeAt(I)===l;)I++;let D=u.length;for(;D-1>I&&u.charCodeAt(D-1)===l;)D--;const v=D-I,R=k<v?k:v;let j=-1,N=0;for(;N<R;N++){const se=t.charCodeAt(n+N);if(se!==u.charCodeAt(I+N))break;se===l&&(j=N)}if(N!==R){if(j===-1)return i}else{if(v>R){if(u.charCodeAt(I+N)===l)return i.slice(I+N+1);if(N===2)return i.slice(I+N)}k>R&&(t.charCodeAt(n+N)===l?j=N:N===2&&(j=3)),j===-1&&(j=0)}let z="";for(N=n+j+1;N<=o;++N)(N===o||t.charCodeAt(N)===l)&&(z+=z.length===0?"..":"\\..");return I+=j,z.length>0?`${z}${i.slice(I,D)}`:(i.charCodeAt(I)===l&&++I,i.slice(I,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$4d.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===l){if(u.charCodeAt(1)===l){const r=u.charCodeAt(2);if(r!==$&&r!==S)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(a(u.charCodeAt(0))&&u.charCodeAt(1)===b&&u.charCodeAt(2)===l)return`\\\\?\\${u}`;return t},dirname(t){y(t,"path");const u=t.length;if(u===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(u===1)return g(n)?t:".";if(g(n)){if(r=i=1,g(t.charCodeAt(1))){let I=2,D=I;for(;I<u&&!g(t.charCodeAt(I));)I++;if(I<u&&I!==D){for(D=I;I<u&&g(t.charCodeAt(I));)I++;if(I<u&&I!==D){for(D=I;I<u&&!g(t.charCodeAt(I));)I++;if(I===u)return t;I!==D&&(r=i=I+1)}}}}else a(n)&&t.charCodeAt(1)===b&&(r=u>2&&g(t.charCodeAt(2))?3:2,i=r);let o=-1,k=!0;for(let I=u-1;I>=i;--I)if(g(t.charCodeAt(I))){if(!k){o=I;break}}else k=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,u){u!==void 0&&y(u,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(r=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,I=-1;for(o=t.length-1;o>=r;--o){const D=t.charCodeAt(o);if(g(D)){if(!n){r=o+1;break}}else I===-1&&(n=!1,I=o+1),k>=0&&(D===u.charCodeAt(k)?--k===-1&&(i=o):(k=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if(g(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let u=0,r=-1,i=0,n=-1,o=!0,k=0;t.length>=2&&t.charCodeAt(1)===b&&a(t.charCodeAt(0))&&(u=i=2);for(let I=t.length-1;I>=u;--I){const D=t.charCodeAt(I);if(g(D)){if(!o){i=I+1;break}continue}n===-1&&(o=!1,n=I+1),D===S?r===-1?r=I:k!==1&&(k=1):r!==-1&&(k=-1)}return r===-1||n===-1||k===0||k===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:E.bind(null,"\\"),parse(t){y(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return g(n)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(g(n)){if(i=1,g(t.charCodeAt(1))){let j=2,N=j;for(;j<r&&!g(t.charCodeAt(j));)j++;if(j<r&&j!==N){for(N=j;j<r&&g(t.charCodeAt(j));)j++;if(j<r&&j!==N){for(N=j;j<r&&!g(t.charCodeAt(j));)j++;j===r?i=j:j!==N&&(i=j+1)}}}}else if(a(n)&&t.charCodeAt(1)===b){if(r<=2)return u.root=u.dir=t,u;if(i=2,g(t.charCodeAt(2))){if(r===3)return u.root=u.dir=t,u;i=3}}i>0&&(u.root=t.slice(0,i));let o=-1,k=i,I=-1,D=!0,v=t.length-1,R=0;for(;v>=i;--v){if(n=t.charCodeAt(v),g(n)){if(!D){k=v+1;break}continue}I===-1&&(D=!1,I=v+1),n===S?o===-1?o=v:R!==1&&(R=1):o!==-1&&(R=-1)}return I!==-1&&(o===-1||R===0||R===1&&o===I-1&&o===k+1?u.base=u.name=t.slice(k,I):(u.name=t.slice(k,o),u.base=t.slice(k,I),u.ext=t.slice(o,I))),k>0&&k!==i?u.dir=t.slice(0,k-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(w){const t=/\\/g;return()=>{const u=P.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>P.cwd()})();e.$5d={resolve(...t){let u="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:d();y(n,"path"),n.length!==0&&(u=`${n}/${u}`,r=n.charCodeAt(0)===h)}return u=m(u,!r,"/",c),r?`/${u}`:u.length>0?u:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=m(t,!u,"/",c),t.length===0?u?"/":r?"./":".":(r&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let u;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(u===void 0?u=i:u+=`/${i}`)}return u===void 0?".":e.$5d.normalize(u)},relative(t,u){if(y(t,"from"),y(u,"to"),t===u||(t=e.$5d.resolve(t),u=e.$5d.resolve(u),t===u))return"";const r=1,i=t.length,n=i-r,o=1,k=u.length-o,I=n<k?n:k;let D=-1,v=0;for(;v<I;v++){const j=t.charCodeAt(r+v);if(j!==u.charCodeAt(o+v))break;j===h&&(D=v)}if(v===I)if(k>I){if(u.charCodeAt(o+v)===h)return u.slice(o+v+1);if(v===0)return u.slice(o+v)}else n>I&&(t.charCodeAt(r+v)===h?D=v:v===0&&(D=0));let R="";for(v=r+D+1;v<=i;++v)(v===i||t.charCodeAt(v)===h)&&(R+=R.length===0?"..":"/..");return`${R}${u.slice(o+D)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===h;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===h){if(!i){r=n;break}}else i=!1;return r===-1?u?"/":".":u&&r===1?"//":t.slice(0,r)},basename(t,u){u!==void 0&&y(u,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,I=-1;for(o=t.length-1;o>=0;--o){const D=t.charCodeAt(o);if(D===h){if(!n){r=o+1;break}}else I===-1&&(n=!1,I=o+1),k>=0&&(D===u.charCodeAt(k)?--k===-1&&(i=o):(k=-1,i=I))}return r===i?i=I:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===h){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let u=-1,r=0,i=-1,n=!0,o=0;for(let k=t.length-1;k>=0;--k){const I=t.charCodeAt(k);if(I===h){if(!n){r=k+1;break}continue}i===-1&&(n=!1,i=k+1),I===S?u===-1?u=k:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||i===-1||o===0||o===1&&u===i-1&&u===r+1?"":t.slice(u,i)},format:E.bind(null,"/"),parse(t){y(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.charCodeAt(0)===h;let i;r?(u.root="/",i=1):i=0;let n=-1,o=0,k=-1,I=!0,D=t.length-1,v=0;for(;D>=i;--D){const R=t.charCodeAt(D);if(R===h){if(!I){o=D+1;break}continue}k===-1&&(I=!1,k=D+1),R===S?n===-1?n=D:v!==1&&(v=1):n!==-1&&(v=-1)}if(k!==-1){const R=o===0&&r?1:o;n===-1||v===0||v===1&&n===k-1&&n===o+1?u.base=u.name=t.slice(R,k):(u.name=t.slice(R,n),u.base=t.slice(R,k),u.ext=t.slice(n,k))}return o>0?u.dir=t.slice(0,o-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$5d.win32=e.$4d.win32=e.$4d,e.$5d.posix=e.$4d.posix=e.$5d,e.$6d=w?e.$4d.normalize:e.$5d.normalize,e.$7d=w?e.$4d.isAbsolute:e.$5d.isAbsolute,e.$8d=w?e.$4d.join:e.$5d.join,e.$9d=w?e.$4d.resolve:e.$5d.resolve,e.$0d=w?e.$4d.relative:e.$5d.relative,e.$$d=w?e.$4d.dirname:e.$5d.dirname,e.$_d=w?e.$4d.basename:e.$5d.basename,e.$ae=w?e.$4d.extname:e.$5d.extname,e.$be=w?e.$4d.format:e.$5d.format,e.$ce=w?e.$4d.parse:e.$5d.parse,e.$de=w?e.$4d.toNamespacedPath:e.$5d.toNamespacedPath,e.sep=w?e.$4d.sep:e.$5d.sep,e.$fe=w?e.$4d.delimiter:e.$5d.delimiter}),define(te[32],ie([0,1,9,4,26,12]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function A(o){return o===47||o===92}e.$Af=A;function S(o){return o.replace(/[\\/]/g,P.$5d.sep)}e.$Bf=S;function h(o){return o.indexOf("/")===-1&&(o=S(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Cf=h;function l(o,k=P.$5d.sep){if(!o)return"";const I=o.length,D=o.charCodeAt(0);if(A(D)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let R=3;const j=R;for(;R<I&&!A(o.charCodeAt(R));R++);if(j!==R&&!A(o.charCodeAt(R+1))){for(R+=1;R<I;R++)if(A(o.charCodeAt(R)))return o.slice(0,R+1).replace(/[\\/]/g,k)}}return k}else if(c(D)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+k:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<I;v++)if(A(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.$Df=l;function b(o){if(!O.$i||!o||o.length<5)return!1;let k=o.charCodeAt(0);if(k!==92||(k=o.charCodeAt(1),k!==92))return!1;let I=2;const D=I;for(;I<o.length&&(k=o.charCodeAt(I),k!==92);I++);return!(D===I||(k=o.charCodeAt(I+1),isNaN(k)||k===92))}e.$Ef=b;const $=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,k=O.$i){const I=k?$:p;return!(!o||o.length===0||/^\s+$/.test(o)||(I.lastIndex=0,I.test(o))||k&&f.test(o)||o==="."||o===".."||k&&o[o.length-1]==="."||k&&o.length!==o.trim().length||o.length>255)}e.$Ff=y;function w(o,k,I){const D=o===k;return!I||D?D:!o||!k?!1:(0,s.$Le)(o,k)}e.$Gf=w;function g(o,k,I,D=P.sep){if(o===k)return!0;if(!o||!k||k.length>o.length)return!1;if(I){if(!(0,s.$Me)(o,k))return!1;if(k.length===o.length)return!0;let R=k.length;return k.charAt(k.length-1)===D&&R--,o.charAt(R)===D}return k.charAt(k.length-1)!==D&&(k+=D),o.indexOf(k)===0}e.$Hf=g;function c(o){return o>=65&&o<=90||o>=97&&o<=122}e.$If=c;function a(o,k){return O.$i&&o.endsWith(":")&&(o+=P.sep),(0,P.$7d)(o)||(o=(0,P.$8d)(k,o)),o=(0,P.$6d)(o),O.$i?(o=(0,s.$ue)(o,P.sep),o.endsWith(":")&&(o+=P.sep)):(o=(0,s.$ue)(o,P.sep),o||(o=P.sep)),o}e.$Jf=a;function m(o){const k=(0,P.$6d)(o);return O.$i?o.length>3?!1:E(k)&&(o.length===2||k.charCodeAt(2)===92):k===P.$5d.sep}e.$Kf=m;function E(o,k=O.$i){return k?c(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Lf=E;function d(o,k=O.$i){return E(o,k)?o[0]:void 0}e.$Mf=d;function t(o,k,I){return k.length>o.length?-1:o===k?0:(I&&(o=o.toLowerCase(),k=k.toLowerCase()),o.indexOf(k))}e.$Nf=t;function u(o){const k=o.split(":");let I,D,v;for(const R of k){const j=Number(R);(0,M.$mf)(j)?D===void 0?D=j:v===void 0&&(v=j):I=I?[I,R].join(":"):R}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:D!==void 0?D:void 0,column:v!==void 0?v:D!==void 0?1:void 0}}e.$Of=u;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,k,I=8){let D="";for(let R=0;R<I;R++){let j;R===0&&O.$i&&!k&&(I===3||I===4)?j=i:j=r,D+=j.charAt(Math.floor(Math.random()*j.length))}let v;return k?v=`${k}-${D}`:v=D,o?(0,P.$8d)(o,v):v}e.$Pf=n}),define(te[73],ie([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.TerminateResponseCode=e.Source=void 0;var O;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(O||(e.Source=O={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...h){const l=h.reduce((p,f)=>(p[f]=!0,p),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(p=>!l[p]).forEach(p=>{for(let f=0;f<b.length;f++)if(p.search(b[f])!==-1){delete S[p];break}})}e.$rl=M;function A(S){S&&(delete S.DEBUG,P.$j&&delete S.DYLD_LIBRARY_PATH,P.$k&&delete S.LD_PRELOAD)}e.$sl=A}),define(te[7],ie([0,1,9,4]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==$&&(n=$+n):n=$;break}return n}const b="",$="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,k,I,D,v=!1){typeof n=="object"?(this.scheme=n.scheme||b,this.authority=n.authority||b,this.path=n.path||b,this.query=n.query||b,this.fragment=n.fragment||b):(this.scheme=h(n,v),this.authority=o||b,this.path=l(this.scheme,k||b),this.query=I||b,this.fragment=D||b,S(this,v))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:k,path:I,query:D,fragment:v}=n;return o===void 0?o=this.scheme:o===null&&(o=b),k===void 0?k=this.authority:k===null&&(k=b),I===void 0?I=this.path:I===null&&(I=b),D===void 0?D=this.query:D===null&&(D=b),v===void 0?v=this.fragment:v===null&&(v=b),o===this.scheme&&k===this.authority&&I===this.path&&D===this.query&&v===this.fragment?this:new g(o,k,I,D,v)}static parse(n,o=!1){const k=p.exec(n);return k?new g(k[2]||b,r(k[4]||b),r(k[5]||b),r(k[7]||b),r(k[9]||b),o):new g(b,b,b,b,b)}static file(n){let o=b;if(O.$i&&(n=n.replace(/\\/g,$)),n[0]===$&&n[1]===$){const k=n.indexOf($,2);k===-1?(o=n.substring(2),n=$):(o=n.substring(2,k),n=n.substring(k)||$)}return new g("file",o,n,b,b)}static from(n,o){return new g(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return O.$i&&n.scheme==="file"?k=f.file(P.$4d.join(E(n,!0),...o)).path:k=P.$5d.join(n.path,...o),n.with({path:k})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new g(n);return o._formatted=n.external??null,o._fsPath=n._sep===w?n.fsPath??null:null,o}}else return n}}e.URI=f;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Rf=y;const w=O.$i?1:void 0;class g extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,n,o){let k,I=-1;for(let D=0;D<i.length;D++){const v=i.charCodeAt(D);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||n&&v===47||o&&v===91||o&&v===93||o&&v===58)I!==-1&&(k+=encodeURIComponent(i.substring(I,D)),I=-1),k!==void 0&&(k+=i.charAt(D));else{k===void 0&&(k=i.substr(0,D));const R=c[v];R!==void 0?(I!==-1&&(k+=encodeURIComponent(i.substring(I,D)),I=-1),k+=R):I===-1&&(I=D)}}return I!==-1&&(k+=encodeURIComponent(i.substring(I))),k!==void 0?k:i}function m(i){let n;for(let o=0;o<i.length;o++){const k=i.charCodeAt(o);k===35||k===63?(n===void 0&&(n=i.substr(0,o)),n+=c[k]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function E(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,O.$i&&(o=o.replace(/\//g,"\\")),o}e.$Sf=E;function d(i,n){const o=n?m:a;let k="",{scheme:I,authority:D,path:v,query:R,fragment:j}=i;if(I&&(k+=I,k+=":"),(D||I==="file")&&(k+=$,k+=$),D){let N=D.indexOf("@");if(N!==-1){const z=D.substr(0,N);D=D.substr(N+1),N=z.lastIndexOf(":"),N===-1?k+=o(z,!1,!1):(k+=o(z.substr(0,N),!1,!1),k+=":",k+=o(z.substr(N+1),!1,!0)),k+="@"}D=D.toLowerCase(),N=D.lastIndexOf(":"),N===-1?k+=o(D,!1,!0):(k+=o(D.substr(0,N),!1,!0),k+=D.substr(N))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const N=v.charCodeAt(1);N>=65&&N<=90&&(v=`/${String.fromCharCode(N+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const N=v.charCodeAt(0);N>=65&&N<=90&&(v=`${String.fromCharCode(N+32)}:${v.substr(2)}`)}k+=o(v,!0,!1)}return R&&(k+="?",k+=o(R,!1,!1)),j&&(k+="#",k+=n?j:a(j,!1,!1)),k}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(u)?i.replace(u,n=>t(n)):i}}),define(te[154],ie([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Np=e.$Mp=e.$Lp=void 0;function O(l){const b=l;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.$Lp=O;function s(l){const b=[];let $;try{const p=JSON.parse(l.arguments),f=p[p.length-1];f&&f.__$stack&&(p.pop(),$=f.__$stack),b.push(...p)}catch{b.push("Unable to log remote console arguments",l.arguments)}return{args:b,stack:$}}e.$Mp=s;function M(l){if(typeof l!="string")return M(s(l).stack);const b=l;if(b){const $=A(b),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec($||"");if(p&&p.length===4)return{uri:P.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Np=M;function A(l){if(!l)return l;const b=l.indexOf(`
`);return b===-1?l:l.substring(0,b)}function S(l,b){const{args:$,stack:p}=s(l),f=typeof $[0]=="string"&&$.length===1;let y=A(p);y&&(y=`(${y.trim()})`);let w=[];if(typeof $[0]=="string"?y&&f?w=[`%c[${b}] %c${$[0]} %c${y}`,h("blue"),h(""),h("grey")]:w=[`%c[${b}] %c${$[0]}`,h("blue"),h(""),...$.slice(1)]:w=[`%c[${b}]%`,h("blue"),...$],y&&!f&&w.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,w)}e.log=S;function h(l){return`color: ${l}`}}),define(te[74],ie([0,1,17,7]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function s(h){return JSON.stringify(h,A)}e.$8g=s;function M(h){let l=JSON.parse(h);return l=S(l),l}e.$9g=M;function A(h,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function S(h,l=0){if(!h||l>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return O.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof P.$Ed||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let b=0;b<h.length;++b)h[b]=S(h[b],l+1);else for(const b in h)Object.hasOwnProperty.call(h,b)&&(h[b]=S(h[b],l+1))}return h}e.$0g=S}),define(te[13],ie([0,1,14,4,7]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var M;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b){this.f=`${b}/${M.vscodeRemoteResource}`}set(b,$,p){this.a[b]=$,this.b[b]=p}setConnectionToken(b,$){this.c[b]=$}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(g){return P.$Y(g),b}const $=b.authority;let p=this.a[$];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const f=this.b[$],y=this.c[$];let w=`path=${encodeURIComponent(b.path)}`;return typeof y=="string"&&(w+=`&${e.$Uf}=${encodeURIComponent(y)}`),s.URI.from({scheme:O.$o?this.d:M.vscodeRemoteResource,authority:`${p}:${f}`,path:this.f,query:w})}}e.$Vf=new A,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class S{static{this.a="vscode-app"}asBrowserUri(b){const $=this.b(b,J);return this.uriToBrowserUri($)}uriToBrowserUri(b){return b.scheme===M.vscodeRemote?e.$Vf.rewrite(b):b.scheme===M.file&&(O.$m||O.$p&&O.$g.origin===`${M.vscodeFileResource}://${S.a}`)?b.with({scheme:M.vscodeFileResource,authority:b.authority||S.a,query:null,fragment:null}):b}asFileUri(b){const $=this.b(b,J);return this.uriToFileUri($)}uriToFileUri(b){return b.scheme===M.vscodeFileResource?b.with({scheme:M.file,authority:b.authority!==S.a?b.authority:null,query:null,fragment:null}):b}b(b,$){return s.URI.isUri(b)?b:s.URI.parse($.toUrl(b))}}e.$1f=new S;var h;(function(l){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(b.get("3"));const $="vscode-coi";function p(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:s.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const g=w?.get($);if(g)return b.get(g)}l.getHeadersFromQuery=p;function f(y,w,g){if(!globalThis.crossOriginIsolated)return;const c=w&&g?"3":g?"2":"1";y instanceof URLSearchParams?y.set($,c):y[$]=c}l.addSearchParam=f})(h||(e.COI=h={}))}),define(te[19],ie([0,1,32,13,9,4,26,7]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function h(f){return(0,S.$Sf)(f,!0)}e.$8f=h;class l{constructor(y){this.a=y}compare(y,w,g=!1){return y===w?0:(0,A.$Ee)(this.getComparisonKey(y,g),this.getComparisonKey(w,g))}isEqual(y,w,g=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,g)===this.getComparisonKey(w,g)}getComparisonKey(y,w=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,w,g=!1){if(y.scheme===w.scheme){if(y.scheme===O.Schemas.file)return P.$Hf(h(y),h(w),this.a(y))&&y.query===w.query&&(g||y.fragment===w.fragment);if((0,e.$mg)(y.authority,w.authority))return P.$Hf(y.path,w.path,this.a(y),"/")&&y.query===w.query&&(g||y.fragment===w.fragment)}return!1}joinPath(y,...w){return S.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.$eg)(y)||y.authority}basename(y){return s.$5d.basename(y.path)}extname(y){return s.$5d.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===O.Schemas.file?w=S.URI.file(s.$$d(h(y))).path:(w=s.$5d.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===O.Schemas.file?w=S.URI.file(s.$6d(h(y))).path:w=s.$5d.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.$mg)(y.authority,w.authority))return;if(y.scheme===O.Schemas.file){const a=s.$0d(h(y),h(w));return M.$i?P.$Bf(a):a}let g=y.path||"/";const c=w.path||"/";if(this.a(y)){let a=0;for(const m=Math.min(g.length,c.length);a<m&&!(g.charCodeAt(a)!==c.charCodeAt(a)&&g.charAt(a).toLowerCase()!==c.charAt(a).toLowerCase());a++);g=c.substr(0,a)+g.substr(a)}return s.$5d.relative(g,c)}resolvePath(y,w){if(y.scheme===O.Schemas.file){const g=S.URI.file(s.$9d(h(y),w));return y.with({authority:g.authority,path:g.path})}return w=P.$Cf(w),y.with({path:s.$5d.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,A.$Le)(y,w)}hasTrailingPathSeparator(y,w=s.sep){if(y.scheme===O.Schemas.file){const g=h(y);return g.length>P.$Df(g).length&&g[g.length-1]===w}else{const g=y.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=s.sep){return(0,e.$ng)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=s.sep){let g=!1;if(y.scheme===O.Schemas.file){const c=h(y);g=c!==void 0&&c.length===P.$Df(c).length&&c[c.length-1]===w}else{w="/";const c=y.path;g=c.length===1&&c.charCodeAt(c.length-1)===47}return!g&&!(0,e.$ng)(y,w)?y.with({path:y.path+"/"}):y}}e.$9f=l,e.$0f=new l(()=>!1),e.$$f=new l(f=>f.scheme===O.Schemas.file?!M.$k:!0),e.$_f=new l(f=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function b(f,y){const w=[];for(let g=0;g<f.length;g++){const c=y(f[g]);f.some((a,m)=>m===g?!1:(0,e.$bg)(c,y(a)))||w.push(f[g])}return w}e.$qg=b;var $;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function y(w){const g=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(m=>{const[E,d]=m.split(":");E&&d&&g.set(E,d)});const a=w.path.substring(0,w.path.indexOf(";"));return a&&g.set(f.META_DATA_MIME,a),g}f.parseMetaData=y})($||(e.DataUri=$={}));function p(f,y,w){if(y){let g=f.path;return g&&g[0]!==s.$5d.sep&&(g=s.$5d.sep+g),f.with({scheme:w,authority:y,path:g})}return f.with({scheme:w})}e.$rg=p}),define(te[8],ie([0,1,22,14,3,2,19,4,142]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function l(C){return!!C&&typeof C.then=="function"}e.$sg=l;function b(C){const L=new P.$od,U=C(L.token),W=new Promise((q,V)=>{const re=L.token.onCancellationRequested(()=>{re.dispose(),L.dispose(),V(new O.$3)});Promise.resolve(U).then($e=>{re.dispose(),L.dispose(),q($e)},$e=>{re.dispose(),L.dispose(),V($e)})});return new class{cancel(){L.cancel()}then(q,V){return W.then(q,V)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.$tg=b;function $(C,L,U){return new Promise((W,q)=>{const V=L.onCancellationRequested(()=>{V.dispose(),W(U)});C.then(W,q).finally(()=>V.dispose())})}e.$ug=$;function p(C,L){return new Promise((U,W)=>{const q=L.onCancellationRequested(()=>{q.dispose(),W(new O.$3)});C.then(U,W).finally(()=>q.dispose())})}e.$vg=p;async function f(C){let L=-1;const U=C.map((W,q)=>W.then(V=>(L=q,V)));try{return await Promise.race(U)}finally{C.forEach((W,q)=>{q!==L&&W.cancel()})}}e.$wg=f;function y(C,L,U){let W;const q=setTimeout(()=>{W?.(void 0),U?.()},L);return Promise.race([C.finally(()=>clearTimeout(q)),new Promise(V=>W=V)])}e.$xg=y;function w(C){return new Promise((L,U)=>{const W=C();l(W)?W.then(L,U):L(W)})}e.$yg=w;class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=L,!this.b){const U=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(U,U).then(W)})}return new Promise((U,W)=>{this.b.then(U,W)})}return this.a=L(),new Promise((U,W)=>{this.a.then(q=>{this.a=null,U(q)},q=>{this.a=null,W(q)})})}dispose(){this.f=!0}}e.$zg=g;class c{constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$Ag=c;class a{constructor(){this.a=new Map}queue(L,U){const q=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(L)===q&&this.a.delete(L)});return this.a.set(L,q),q}}e.$Bg=a;const m=(C,L)=>{let U=!0;const W=setTimeout(()=>{U=!1,L()},C);return{isTriggered:()=>U,dispose:()=>{clearTimeout(W),U=!1}}},E=C=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,C())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class d{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,U=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((q,V)=>{this.d=q,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=U===h.$bd?E(W):m(U,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=d;class t{constructor(L){this.a=new d(L),this.b=new g}trigger(L,U){return this.a.trigger(()=>this.b.queue(L),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=t;class u{constructor(){this.a=!1,this.b=new Promise((L,U)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=u;class r extends u{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$Fg=r;function i(C,L){return L?new Promise((U,W)=>{const q=setTimeout(()=>{V.dispose(),U()},C),V=L.onCancellationRequested(()=>{clearTimeout(q),V.dispose(),W(new O.$3)})}):b(U=>i(C,U))}e.$Gg=i;function n(C,L=0){const U=setTimeout(C,L);return(0,M.$hc)(()=>clearTimeout(U))}e.$Hg=n;function o(C){const L=[];let U=0;const W=C.length;function q(){return U<W?C[U++]():null}function V(re){re!=null&&L.push(re);const $e=q();return $e?$e.then(V):Promise.resolve(L)}return Promise.resolve(null).then(V)}e.$Ig=o;function k(C,L=W=>!!W,U=null){let W=0;const q=C.length,V=()=>{if(W>=q)return Promise.resolve(U);const re=C[W++];return Promise.resolve(re()).then(de=>L(de)?Promise.resolve(de):V())};return V()}e.$Jg=k;function I(C,L=W=>!!W,U=null){if(C.length===0)return Promise.resolve(U);let W=C.length;const q=()=>{W=-1;for(const V of C)V.cancel?.()};return new Promise((V,re)=>{for(const $e of C)$e.then(de=>{--W>=0&&L(de)?(q(),V(de)):W===0&&V(U)}).catch(de=>{--W>=0&&(q(),re(de))})})}e.$Kg=I;class D{constructor(L){this.a=0,this.d=L,this.f=[],this.b=0,this.g=new s.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(L){return this.a++,new Promise((U,W)=>{this.f.push({factory:L,c:U,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const L=this.f.shift();this.b++;const U=L.factory();U.then(L.c,L.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=D;class v extends D{constructor(){super(1)}}e.$Mg=v;class R{constructor(){this.a=new K,this.b=0}queue(L){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,L())):this.a.run(this.b++,L())}}e.$Ng=R;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const L=new T;return this.b.add(L),L.p}g(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueFor(L,U=A.$0f){const W=U.getComparisonKey(L);let q=this.a.get(W);if(!q){q=new v;const V=this.f++,re=s.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(V),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$rc),this.d.set(V,re),this.a.set(W,q)}return q}h(){this.g()&&this.j()}j(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=j;class N{constructor(L,U){this.a=-1,typeof L=="function"&&typeof U=="number"&&this.setIfNotSet(L,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},U)}setIfNotSet(L,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},U))}}e.$Pg=N;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(L,U){this.cancel(),this.a=setInterval(()=>{L()},U)}}e.$Qg=z;class se{constructor(L,U){this.b=-1,this.a=L,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=se;class ee{constructor(L,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=L,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=ee;class ae extends se{constructor(L,U){super(L,U),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$Tg=ae;class ne extends M.$jc{constructor(L,U){super(),this.g=L,this.h=U,this.a=[],this.b=this.B(new M.$kc),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of L)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=C=>{(0,S.$A)(()=>{if(L)return;const U=Date.now()+15;C(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.$Vg=(C,L)=>{const U=requestIdleCallback(C,typeof L=="number"?{timeout:L}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(U))}}}}();class oe{constructor(L){this.d=!1,this.a=()=>{try{this.f=L()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=oe;async function G(C,L,U){let W;for(let q=0;q<U;q++)try{return await C()}catch(V){W=V,await i(L)}throw W}e.$Xg=G;class K{isRunning(L){return typeof L=="number"?this.a?.taskId===L:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(L,U,W){return this.a={taskId:L,cancel:()=>W?.(),promise:U},U.then(()=>this.d(L),()=>this.d(L)),U}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this.b)this.b.run=L;else{let U,W;const q=new Promise((V,re)=>{U=V,W=re});this.b={run:L,promise:q,promiseResolve:U,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=K;class B{constructor(L,U=()=>Date.now()){this.d=L,this.f=U,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$Zg=B;var F;(function(C){C[C.Resolved=0]="Resolved",C[C.Rejected=1]="Rejected"})(F||(F={}));class T{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,U)=>{this.a=L,this.b=U})}complete(L){return new Promise(U=>{this.a(L),this.d={outcome:0,value:L},U()})}error(L){return new Promise(U=>{this.b(L),this.d={outcome:1,value:L},U()})}cancel(){return this.error(new O.$3)}}e.$1g=T;var H;(function(C){async function L(W){let q;const V=await Promise.all(W.map(re=>re.then($e=>$e,$e=>{q||(q=$e)})));if(typeof q<"u")throw q;return V}C.settled=L;function U(W){return new Promise(async(q,V)=>{try{await W(q,V)}catch(re){V(re)}})}C.withAsyncBody=U})(H||(e.Promises=H={}));var Q;(function(C){C[C.Initial=0]="Initial",C[C.DoneOK=1]="DoneOK",C[C.DoneError=2]="DoneError"})(Q||(Q={}));class x{static fromArray(L){return new x(U=>{U.emitMany(L)})}static fromPromise(L){return new x(async U=>{U.emitMany(await L)})}static fromPromises(L){return new x(async U=>{await Promise.all(L.map(async W=>U.emitOne(await W)))})}static merge(L){return new x(async U=>{await Promise.all(L.map(async W=>{for await(const q of W)U.emitOne(q)}))})}static{this.EMPTY=x.fromArray([])}constructor(L){this.a=0,this.b=[],this.d=null,this.f=new s.$ed,queueMicrotask(async()=>{const U={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(L(U)),this.j()}catch(W){this.k(W)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(L,U){return new x(async W=>{for await(const q of L)W.emitOne(U(q))})}map(L){return x.map(this,L)}static filter(L,U){return new x(async W=>{for await(const q of L)U(q)&&W.emitOne(q)})}filter(L){return x.filter(this,L)}static coalesce(L){return x.filter(L,U=>!!U)}coalesce(){return x.coalesce(this)}static async toPromise(L){const U=[];for await(const W of L)U.push(W);return U}toPromise(){return x.toPromise(this)}g(L){this.a===0&&(this.b.push(L),this.f.fire())}h(L){this.a===0&&(this.b=this.b.concat(L),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(L){this.a===0&&(this.a=2,this.d=L,this.f.fire())}}e.$2g=x;class ce extends x{constructor(L,U){super(U),this.l=L}cancel(){this.l.cancel()}}e.$3g=ce;function Y(C){const L=new P.$od,U=C(L.token);return new ce(L,async W=>{const q=L.token.onCancellationRequested(()=>{q.dispose(),L.dispose(),W.reject(new O.$3)});try{for await(const V of U){if(L.token.isCancellationRequested)return;W.emitOne(V)}q.dispose(),L.dispose()}catch(V){q.dispose(),L.dispose(),W.reject(V)}})}e.$4g=Y}),define(te[104],ie([0,1,23,8,32,34,9,4,26]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0;function l(){return Object.create(null)}e.$lj=l,e.$mj="**",e.$nj="/";const b="[/\\\\]",$="[^/\\\\]",p=/\//g;function f(K,B){switch(K){case 0:return"";case 1:return`${$}*?`;default:return`(?:${b}|${$}+${b}${B?`|${b}${$}+`:""})*?`}}function y(K,B){if(!K)return[];const F=[];let T=!1,H=!1,Q="";for(const x of K){switch(x){case B:if(!T&&!H){F.push(Q),Q="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":H=!0;break;case"]":H=!1;break}Q+=x}return Q&&F.push(Q),F}e.$oj=y;function w(K){if(!K)return"";let B="";const F=y(K,e.$nj);if(F.every(T=>T===e.$mj))B=".*";else{let T=!1;F.forEach((H,Q)=>{if(H===e.$mj){if(T)return;B+=f(2,Q===F.length-1)}else{let x=!1,ce="",Y=!1,C="";for(const L of H){if(L!=="}"&&x){ce+=L;continue}if(Y&&(L!=="]"||!C)){let U;L==="-"?U=L:(L==="^"||L==="!")&&!C?U="^":L===e.$nj?U="":U=(0,h.$pe)(L),C+=U;continue}switch(L){case"{":x=!0;continue;case"[":Y=!0;continue;case"}":{const W=`(?:${y(ce,",").map(q=>w(q)).join("|")})`;B+=W,x=!1,ce="";break}case"]":{B+="["+C+"]",Y=!1,C="";break}case"?":B+=$;continue;case"*":B+=f(1);continue;default:B+=(0,h.$pe)(L)}}Q<F.length-1&&(F[Q+1]!==e.$mj||Q+2<F.length)&&(B+=b)}T=H===e.$mj})}return B}const g=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Bi(1e4),u=function(){return!1},r=function(){return null};function i(K,B){if(!K)return r;let F;typeof K!="string"?F=K.pattern:F=K,F=F.trim();const T=`${F}_${!!B.trimForExclusions}`;let H=t.get(T);if(H)return n(H,K);let Q;return g.test(F)?H=k(F.substr(4),F):(Q=c.exec(o(F,B)))?H=I(Q[1],F):(B.trimForExclusions?m:a).test(F)?H=D(F,B):(Q=E.exec(o(F,B)))?H=v(Q[1].substr(1),F,!0):(Q=d.exec(o(F,B)))?H=v(Q[1],F,!1):H=R(F),t.set(T,H),n(H,K)}function n(K,B){if(typeof B=="string")return K;const F=function(T,H){return(0,s.$Hf)(T,B.base,!S.$k)?K((0,h.$te)(T.substr(B.base.length),A.sep),H):null};return F.allBasenames=K.allBasenames,F.allPaths=K.allPaths,F.basenames=K.basenames,F.patterns=K.patterns,F}function o(K,B){return B.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function k(K,B){return function(F,T){return typeof F=="string"&&F.endsWith(K)?B:null}}function I(K,B){const F=`/${K}`,T=`\\${K}`,H=function(x,ce){return typeof x!="string"?null:ce?ce===K?B:null:x===K||x.endsWith(F)||x.endsWith(T)?B:null},Q=[K];return H.basenames=Q,H.patterns=[B],H.allBasenames=Q,H}function D(K,B){const F=oe(K.slice(1,-1).split(",").map(ce=>i(ce,B)).filter(ce=>ce!==r),K),T=F.length;if(!T)return r;if(T===1)return F[0];const H=function(ce,Y){for(let C=0,L=F.length;C<L;C++)if(F[C](ce,Y))return K;return null},Q=F.find(ce=>!!ce.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const x=F.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return x.length&&(H.allPaths=x),H}function v(K,B,F){const T=A.sep===A.$5d.sep,H=T?K:K.replace(p,A.sep),Q=A.sep+H,x=A.$5d.sep+K;let ce;return F?ce=function(Y,C){return typeof Y=="string"&&(Y===H||Y.endsWith(Q)||!T&&(Y===K||Y.endsWith(x)))?B:null}:ce=function(Y,C){return typeof Y=="string"&&(Y===H||!T&&Y===K)?B:null},ce.allPaths=[(F?"*/":"./")+K],ce}function R(K){try{const B=new RegExp(`^${w(K)}$`);return function(F){return B.lastIndex=0,typeof F=="string"&&B.test(F)?K:null}}catch{return r}}function j(K,B,F){return!K||typeof B!="string"?!1:N(K)(B,void 0,F)}e.$pj=j;function N(K,B={}){if(!K)return u;if(typeof K=="string"||z(K)){const F=i(K,B);if(F===r)return u;const T=function(H,Q){return!!F(H,Q)};return F.allBasenames&&(T.allBasenames=F.allBasenames),F.allPaths&&(T.allPaths=F.allPaths),T}return ae(K,B)}e.$qj=N;function z(K){const B=K;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.$rj=z;function se(K){return K.allBasenames||[]}e.$sj=se;function ee(K){return K.allPaths||[]}e.$tj=ee;function ae(K,B){const F=oe(Object.getOwnPropertyNames(K).map(ce=>ne(ce,K[ce],B)).filter(ce=>ce!==r)),T=F.length;if(!T)return r;if(!F.some(ce=>!!ce.requiresSiblings)){if(T===1)return F[0];const ce=function(L,U){let W;for(let q=0,V=F.length;q<V;q++){const re=F[q](L,U);if(typeof re=="string")return re;(0,O.$sg)(re)&&(W||(W=[]),W.push(re))}return W?(async()=>{for(const q of W){const V=await q;if(typeof V=="string")return V}return null})():null},Y=F.find(L=>!!L.allBasenames);Y&&(ce.allBasenames=Y.allBasenames);const C=F.reduce((L,U)=>U.allPaths?L.concat(U.allPaths):L,[]);return C.length&&(ce.allPaths=C),ce}const H=function(ce,Y,C){let L,U;for(let W=0,q=F.length;W<q;W++){const V=F[W];V.requiresSiblings&&C&&(Y||(Y=(0,A.$_d)(ce)),L||(L=Y.substr(0,Y.length-(0,A.$ae)(ce).length)));const re=V(ce,Y,L,C);if(typeof re=="string")return re;(0,O.$sg)(re)&&(U||(U=[]),U.push(re))}return U?(async()=>{for(const W of U){const q=await W;if(typeof q=="string")return q}return null})():null},Q=F.find(ce=>!!ce.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const x=F.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return x.length&&(H.allPaths=x),H}function ne(K,B,F){if(B===!1)return r;const T=i(K,F);if(T===r)return r;if(typeof B=="boolean")return T;if(B){const H=B.when;if(typeof H=="string"){const Q=(x,ce,Y,C)=>{if(!C||!T(x,ce))return null;const L=H.replace("$(basename)",()=>Y),U=C(L);return(0,O.$sg)(U)?U.then(W=>W?K:null):U?K:null};return Q.requiresSiblings=!0,Q}}return T}function oe(K,B){const F=K.filter(ce=>!!ce.basenames);if(F.length<2)return K;const T=F.reduce((ce,Y)=>{const C=Y.basenames;return C?ce.concat(C):ce},[]);let H;if(B){H=[];for(let ce=0,Y=T.length;ce<Y;ce++)H.push(B)}else H=F.reduce((ce,Y)=>{const C=Y.patterns;return C?ce.concat(C):ce},[]);const Q=function(ce,Y){if(typeof ce!="string")return null;if(!Y){let L;for(L=ce.length;L>0;L--){const U=ce.charCodeAt(L-1);if(U===47||U===92)break}Y=ce.substr(L)}const C=T.indexOf(Y);return C!==-1?H[C]:null};Q.basenames=T,Q.patterns=H,Q.allBasenames=T;const x=K.filter(ce=>!ce.basenames);return x.push(Q),x}function G(K,B){return(0,P.$sb)(K,B,(F,T)=>typeof F=="string"&&typeof T=="string"?F===T:typeof F!="string"&&typeof T!="string"?F.base===T.base&&F.pattern===T.pattern:!1)}e.$uj=G}),define(te[46],ie([0,1,23,32,9,4,19,26]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=e.$bA=void 0;function h(i,n){const{os:o,tildify:k,relative:I}=n;if(I){const R=l(i,I,o);if(typeof R=="string")return R}let D=i.fsPath;if(o===1&&!M.$i?D=D.replace(/\//g,"\\"):o!==1&&M.$i&&(D=D.replace(/\\/g,"/")),o!==1&&k?.userHome){const R=k.userHome.fsPath;let j;i.scheme!==k.userHome.scheme&&i.path.startsWith(s.$5d.sep)?j=k.userHome.with({path:i.path}).fsPath:j=i.fsPath,D=p(j,R,o)}return(o===1?s.$4d:s.$5d).normalize(b(D,o===1))}e.$bA=h;function l(i,n,o){const k=o===1?s.$4d:s.$5d,I=o===3?A.$0f:A.$_f,D=n.getWorkspace(),v=(0,P.$Lb)(D.folders);if(!v)return;i.scheme!==v.uri.scheme&&i.path.startsWith(s.$5d.sep)&&(i=v.uri.with({path:i.path}));const R=n.getWorkspaceFolder(i);if(!R)return;let j;if(I.isEqual(R.uri,i)?j="":j=I.relativePath(R.uri,i)??"",j&&(j=k.normalize(j)),D.folders.length>1&&!n.noPrefix){const N=R.name?R.name:I.basenameOrAuthority(R.uri);j=j?`${N} \u2022 ${j}`:N}return j}function b(i,n=M.$i){return(0,O.$Lf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$cA=b;let $=Object.create(null);function p(i,n,o=M.OS){if(o===1||!i||!n)return i;let k=$.original===n?$.normalized:void 0;k||(k=n,M.$i&&(k=(0,O.$Bf)(k)),k=`${(0,S.$ue)(k,s.$5d.sep)}${s.$5d.sep}`,$={original:n,normalized:k});let I=i;return M.$i&&(I=(0,O.$Bf)(I)),(o===3?I.startsWith(k):(0,S.$Me)(I,k))?`~/${I.substr(k.length)}`:i}e.$dA=p;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$eA=f;const y="\u2026",w="\\\\",g="~";function c(i,n=s.sep){const o=new Array(i.length);let k=!1;for(let I=0;I<i.length;I++){const D=i[I];if(D===""){o[I]=`.${n}`;continue}if(!D){o[I]=D;continue}k=!0;let v="",R=D;R.indexOf(w)===0?(v=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length)):R.indexOf(n)===0?(v=R.substr(0,R.indexOf(n)+n.length),R=R.substr(R.indexOf(n)+n.length)):R.indexOf(g)===0&&(v=R.substr(0,R.indexOf(g)+g.length),R=R.substr(R.indexOf(g)+g.length));const j=R.split(n);for(let N=1;k&&N<=j.length;N++)for(let z=j.length-N;k&&z>=0;z--){k=!1;let se=j.slice(z,z+N).join(n);for(let ee=0;!k&&ee<i.length;ee++)if(ee!==I&&i[ee]&&i[ee].indexOf(se)>-1){const ae=z+N===j.length,ne=z>0&&i[ee].indexOf(n)>-1?n+se:se,oe=i[ee].endsWith(ne);k=!ae||oe}if(!k){let ee="";(j[0].endsWith(":")||v!=="")&&(z===1&&(z=0,N++,se=j[0]+n+se),z>0&&(ee=j[0]+n),ee=v+ee),z>0&&(ee=ee+y+n),ee=ee+se,z+N<j.length&&(ee=ee+n+y),o[I]=ee}}k&&(o[I]=D)}return o}e.$fA=c;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function m(i,n=Object.create(null)){const o=[];let k=!1,I="";for(const D of i)if(D==="$"||k&&D==="{")I&&o.push({value:I,type:a.TEXT}),I="",k=!0;else if(D==="}"&&k){const v=n[I];if(typeof v=="string")v.length&&o.push({value:v,type:a.VARIABLE});else if(v){const R=o[o.length-1];(!R||R.type!==a.SEPARATOR)&&o.push({value:v.label,type:a.SEPARATOR})}I="",k=!1}else I+=D;return I&&!k&&o.push({value:I,type:a.TEXT}),o.filter((D,v)=>{if(D.type===a.SEPARATOR){const R=o[v-1],j=o[v+1];return[R,j].every(N=>N&&(N.type===a.VARIABLE||N.type===a.TEXT)&&N.value.length>0)}return!0}).map(D=>D.value).join("")}e.$gA=m;function E(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$hA=E;function d(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$iA=d;function t(i){return i.replace(/&/g,"&&")}e.$jA=t;function u(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=r(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return r(i)}e.$kA=u;function r(i){const n=i.indexOf("/")!==-1?s.$5d:s.$4d,o=n.basename(i),k=n.dirname(i);return o.length?{name:o,parentPath:k}:{name:k,parentPath:""}}}),define(te[155],ie([0,1,17,7]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0;function s($){return $.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const f=this.a.transformIncoming(p);return f===p?p:s(O.URI.from(f))}transformOutgoing(p){const f=this.a.transformOutgoing(p);return f===p?p:s(O.URI.from(f))}transformOutgoingURI(p){const f=this.a.transformOutgoing(p);return f===p?p:O.URI.from(f)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Am=M,e.$Bm=new class{transformIncoming($){return $}transformOutgoing($){return $}transformOutgoingURI($){return $}transformOutgoingScheme($){return $}};function A($,p,f){if(!$||f>200)return null;if(typeof $=="object"){if($ instanceof O.URI)return p.transformOutgoing($);for(const y in $)if(Object.hasOwnProperty.call($,y)){const w=A($[y],p,f+1);w!==null&&($[y]=w)}}return null}function S($,p){const f=A($,p,0);return f===null?$:f}e.$Cm=S;function h($,p,f,y){if(!$||y>200)return null;if(typeof $=="object"){if($.$mid===1)return f?O.URI.revive(p.transformIncoming($)):p.transformIncoming($);if($ instanceof P.$Ed)return null;for(const w in $)if(Object.hasOwnProperty.call($,w)){const g=h($[w],p,f,y+1);g!==null&&($[w]=g)}}return null}function l($,p){const f=h($,p,!1,0);return f===null?$:f}e.$Dm=l;function b($,p){const f=h($,p,!0,0);return f===null?$:f}e.$Em=b}),define(te[21],ie([0,1,45,27,156,8,32,85,9,4,19,7]),function(J,e,P,O,s,M,A,S,h,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function f(ne,oe=p.UNLINK,G){if((0,A.$Kf)(ne))throw new Error("rimraf - will refuse to recursively delete root");return oe===p.UNLINK?w(ne):y(ne,G)}async function y(ne,oe=(0,A.$Pf)((0,O.tmpdir)())){try{try{await P.promises.rename(ne,oe)}catch(G){return G.code==="ENOENT"?void 0:w(ne)}w(oe).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function w(ne){return(0,s.promisify)(P.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function g(ne){if((0,A.$Kf)(ne))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function c(ne,oe){return E(await(oe?a(ne):(0,s.promisify)(P.readdir)(ne)))}async function a(ne){try{return await(0,s.promisify)(P.readdir)(ne,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const oe=[],G=await c(ne);for(const K of G){let B=!1,F=!1,T=!1;try{const H=await e.Promises.lstat((0,h.$8d)(ne,K));B=H.isFile(),F=H.isDirectory(),T=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}oe.push({name:K,isFile:()=>B,isDirectory:()=>F,isSymbolicLink:()=>T})}return oe}function m(ne){return E(P.readdirSync(ne))}e.readdirSync=m;function E(ne){return ne.map(oe=>typeof oe=="string"?l.$j?(0,S.$gl)(oe):oe:(oe.name=l.$j?(0,S.$gl)(oe.name):oe.name,oe))}async function d(ne){const oe=await c(ne),G=[];for(const K of oe)await u.existsDirectory((0,h.$8d)(ne,K))&&G.push(K);return G}function t(ne,oe=1e3){return new Promise(G=>{let K=!1;const B=setInterval(()=>{K||(K=!0,P.access(ne,F=>{K=!1,F&&(clearInterval(B),G(void 0))}))},oe)})}e.whenDeleted=t;var u;(function(ne){async function oe(B){let F;try{if(F=await e.Promises.lstat(B),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(l.$i&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw H}throw T}}ne.stat=oe;async function G(B){try{const{stat:F,symbolicLink:T}=await ne.stat(B);return F.isFile()&&T?.dangling!==!0}catch{}return!1}ne.existsFile=G;async function K(B){try{const{stat:F,symbolicLink:T}=await ne.stat(B);return F.isDirectory()&&T?.dangling!==!0}catch{}return!1}ne.existsDirectory=K})(u||(e.SymlinkSupport=u={}));const r=new M.$Og;function i(ne,oe,G){return r.queueFor($.URI.file(ne),b.$$f).queue(()=>{const K=D(G);return new Promise((B,F)=>k(ne,oe,K,T=>T?F(T):B()))})}let n=!0;function o(ne){n=ne}e.configureFlushOnWrite=o;function k(ne,oe,G,K){if(!n)return P.writeFile(ne,oe,{mode:G.mode,flag:G.flag},K);P.open(ne,G.flag,G.mode,(B,F)=>{if(B)return K(B);P.writeFile(F,oe,T=>{if(T)return P.close(F,()=>K(T));P.fdatasync(F,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),o(!1)),P.close(F,Q=>K(Q))))})})}function I(ne,oe,G){const K=D(G);if(!n)return P.writeFileSync(ne,oe,{mode:K.mode,flag:K.flag});const B=P.openSync(ne,K.flag,K.mode);try{P.writeFileSync(B,oe);try{P.fdatasyncSync(B)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),o(!1)}}finally{P.closeSync(B)}}e.writeFileSync=I;function D(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function v(ne,oe,G=6e4){if(ne!==oe)try{l.$i&&typeof G=="number"?await R(ne,oe,Date.now(),G):await(0,s.promisify)(P.rename)(ne,oe)}catch(K){if(ne.toLowerCase()!==oe.toLowerCase()&&K.code==="EXDEV"||ne.endsWith("."))await j(ne,oe,{preserveSymlinks:!1}),await f(ne,p.MOVE);else throw K}}async function R(ne,oe,G,K,B=0){try{return await(0,s.promisify)(P.rename)(ne,oe)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-G>=K)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${F}`),F;if(B===0){let T=!1;try{const{stat:H}=await u.stat(oe);H.isFile()||(T=!0)}catch{}if(T)throw F}return await(0,M.$Gg)(Math.min(100,B*10)),R(ne,oe,G,K,B+1)}}async function j(ne,oe,G){return z(ne,oe,{root:{source:ne,target:oe},options:G,handledSourcePaths:new Set})}const N=511;async function z(ne,oe,G){if(G.handledSourcePaths.has(ne))return;G.handledSourcePaths.add(ne);const{stat:K,symbolicLink:B}=await u.stat(ne);if(B){if(G.options.preserveSymlinks)try{return await ae(ne,oe,G)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(B.dangling)return}return K.isDirectory()?se(ne,oe,K.mode&N,G):ee(ne,oe,K.mode&N)}async function se(ne,oe,G,K){await e.Promises.mkdir(oe,{recursive:!0,mode:G});const B=await c(ne);for(const F of B)await z((0,h.$8d)(ne,F),(0,h.$8d)(oe,F),K)}async function ee(ne,oe,G){await e.Promises.copyFile(ne,oe),await e.Promises.chmod(oe,G)}async function ae(ne,oe,G){let K=await e.Promises.readlink(ne);(0,A.$Hf)(K,G.root.source,!l.$k)&&(K=(0,h.$8d)(G.root.target,K.substr(G.root.source.length+1))),await e.Promises.symlink(K,oe)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(ne,oe,G,K,B)=>new Promise((F,T)=>{P.read(ne,oe,G,K,B,(H,Q,x)=>H?T(H):F({bytesRead:Q,buffer:x}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(ne,oe,G,K,B)=>new Promise((F,T)=>{P.write(ne,oe,G,K,B,(H,Q,x)=>H?T(H):F({bytesWritten:Q,buffer:x}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return d}get writeFile(){return i}get rm(){return f}get rename(){return v}get copy(){return j}}}),define(te[105],ie([0,1,45,9,4,26,21]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function S(p){if(s.$k)return p;const f=(0,O.$$d)(p);if(p===f)return p;const y=((0,O.$_d)(p)||p).toLowerCase();try{const g=(0,A.readdirSync)(f).filter(c=>c.toLowerCase()===y);if(g.length===1){const c=S(f);if(c)return(0,O.$8d)(c,g[0])}else if(g.length>1){const c=g.indexOf(y);if(c>=0){const a=S(f);if(a)return(0,O.$8d)(a,g[c])}}}catch{}return null}e.$Sp=S;async function h(p){if(s.$k)return p;const f=(0,O.$$d)(p);if(p===f)return p;const y=((0,O.$_d)(p)||p).toLowerCase();try{const g=(await A.Promises.readdir(f)).filter(c=>c.toLowerCase()===y);if(g.length===1){const c=await h(f);if(c)return(0,O.$8d)(c,g[0])}else if(g.length>1){const c=g.indexOf(y);if(c>=0){const a=await h(f);if(a)return(0,O.$8d)(a,g[c])}}}catch{}return null}e.$Tp=h;async function l(p){try{return await A.Promises.realpath(p)}catch{const y=$(p);return await A.Promises.access(y,P.constants.R_OK),y}}e.$Up=l;function b(p){try{return P.realpathSync(p)}catch{const y=$(p);return P.accessSync(y,P.constants.R_OK),y}}e.$Vp=b;function $(p){return(0,M.$ue)((0,O.$6d)(p),O.sep)}}),define(te[106],ie([0,1,27,9,21]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=void 0;const M=/^\d+$/,A=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class ${constructor(d,t,u){this.exePath=d,this.displayName=t,this.a=u}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:E=!1}={}){return E?l===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:d=!1}={}){const t=p({useAlternateBitness:E});if(!t)return null;const u=O.$8d(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(u))return null;let r=-1,i=null;for(const k of await s.Promises.readdir(u)){let I=-1;if(d){const v=k.indexOf("-");if(v<0)continue;const R=k.substring(0,v);if(!M.test(R)||k.substring(v+1)!=="preview")continue;I=parseInt(R,10)}else{if(!M.test(k))continue;I=parseInt(k,10)}if(I<=r)continue;const D=O.$8d(u,k,"pwsh.exe");await s.SymlinkSupport.existsFile(D)&&(i=D,r=I)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=d?" Preview":"";return new $(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const d=O.$8d(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:t,pwshMsixName:u}=E?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(d))if(t.test(r)){const i=O.$8d(d,r,"pwsh.exe");return new $(i,u)}return null}function w(){const E=O.$8d(P.homedir(),".dotnet","tools","pwsh.exe");return new $(E,".NET Core PowerShell Global Tool")}function g(){const E=O.$8d(process.env.windir,l===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new $(E,"Windows PowerShell",!0)}async function*c(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=w(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=g(),E&&(yield E)}async function*a(){for await(const E of c())await E.exists()&&(yield E)}e.$pl=a;async function m(){for await(const E of a())return E;return null}e.$ql=m}),define(te[88],ie([0,1,9,4,35,73,12,21]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function h($=s.env){return $.comspec||"cmd.exe"}e.$tl=h;function l($){let p=[],f=!1;const y=function(w){if(f){p.push(w);return}(!$.send(w,c=>{if(c&&console.error(c),f=!1,p.length>0){const a=p.slice(0);p=[],a.forEach(m=>y(m))}})||O.$i)&&(f=!0)};return{send:y}}e.$ul=l;var b;(function($){async function p(f,y,w){if(P.$7d(f))return f;if(y===void 0&&(y=s.cwd()),P.$$d(f)!=="."||(w===void 0&&A.$if(s.env.PATH)&&(w=s.env.PATH.split(P.$fe)),w===void 0||w.length===0))return P.$8d(y,f);async function c(a){if(await S.Promises.exists(a)){let m;try{m=await S.Promises.stat(a)}catch(E){E.message.startsWith("EACCES")&&(m=await S.Promises.lstat(a))}return m?!m.isDirectory():!1}return!1}for(const a of w){let m;if(P.$7d(a)?m=P.$8d(a,f):m=P.$8d(y,a,f),await c(m))return m;let E=m+".com";if(await c(E)||(E=m+".exe",await c(E)))return E}return P.$8d(y,f)}$.findExecutable=p})(b||(e.win32=b={}))}),define(te[107],ie([0,1,47,13]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;function s(A){return new Promise((S,h)=>{let l;const b=new Map;function $(f,y,w,g,c){const a=b.get(y);if(f===A||a){const m={name:p(w),cmd:w,pid:f,ppid:y,load:g,mem:c};b.set(f,m),f===A&&(l=m),a&&(a.children||(a.children=[]),a.children.push(m),a.children.length>1&&(a.children=a.children.sort((E,d)=>E.pid-d.pid)))}}function p(f){const y=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,g=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,a=/conhost\.exe.+--headless/i,m=/--type=([a-zA-Z-]+)/;if(g.exec(f))return"electron-crash-reporter";if(c.exec(f))return"winpty-agent";if(a.exec(f))return"conpty-agent";let E=m.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const d=/[a-zA-Z-]+\.js/g;let t="";do E=d.exec(f),E&&(t+=E+" ");while(E);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,w)=>{J(["@vscode/windows-process-tree"],y,w)}).then(y=>{y.getProcessList(A,w=>{if(!w){h(new Error(`Root process ${A} not found`));return}y.getProcessCpuUsage(w,g=>{const c=new Map;g.forEach(a=>{const m=f(a.commandLine||"");c.set(a.pid,{name:p(m),cmd:m,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),l=c.get(A),l?(c.forEach(a=>{const m=c.get(a.ppid);m&&(m.children||(m.children=[]),m.children.push(a))}),c.forEach(a=>{a.children&&(a.children=a.children.sort((m,E)=>m.pid-E.pid))}),S(l)):h(new Error(`Root process ${A} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let f=function(){let y=[l];const w=[];for(;y.length;){const c=y.shift();c&&(w.push(c.pid),c.children&&(y=y.concat(c.children)))}let g=JSON.stringify(O.$1f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+w.join(" "),(0,P.exec)(g,{},(c,a,m)=>{if(c||m)h(c||new Error(m.toString()));else{const E=a.toString().split(`
`);for(let d=0;d<w.length;d++){const t=b.get(w[d]);t.load=parseFloat(E[d])}if(!l){h(new Error(`Root process ${A} not found`));return}S(l)}})};(0,P.exec)("which ps",{},(y,w,g)=>{if(y||g)if(process.platform!=="linux")h(y||new Error(g.toString()));else{const c=JSON.stringify(O.$1f.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(c,{},(a,m,E)=>{a||E?h(a||new Error(E.toString())):(M(m,$),f())})}else{const c=w.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${c} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,E,d)=>{m||d&&!d.includes("screen size is bogus")?h(m||new Error(d.toString())):(M(E,$),process.platform==="linux"?f():l?S(l):h(new Error(`Root process ${A} not found`)))})}})}})}e.$qr=s;function M(A,S){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=A.toString().split(`
`);for(const b of l){const $=h.exec(b.trim());$&&$.length===6&&S(parseInt($[1]),parseInt($[2]),$[5],parseFloat($[3]),parseFloat($[4]))}}}),define(te[108],ie([0,1,27,4,106,88]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=void 0;async function A($,p){return $===1?O.$i?b():M.$tl(p):h($,p)}e.$vl=A;let S=null;function h($,p){if(O.$k&&$===2||O.$j&&$===3)return"/bin/bash";if(!S){let f;if(O.$i)f="/bin/bash";else{if(f=p.SHELL,!f)try{f=(0,P.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}S=f}return S}let l=null;async function b(){return l||(l=(await(0,s.$ql)()).exePath),l}});var ke=this&&this.__decorate||function(J,e,P,O){var s=arguments.length,M=s<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,P):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(J,e,P,O);else for(var S=J.length-1;S>=0;S--)(A=J[S])&&(M=(s<3?A(M):s>3?A(e,P,M):A(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(te[42],ie([0,1,23,8,17,22,55,14,3,2,74,26,12]),function(J,e,P,O,s,M,A,S,h,l,b,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.ProxyChannel=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.RequestInitiator=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0;var f;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(f||(f={}));function y(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(w||(w={}));function g(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(c||(c={}));function a(B){let F=0;for(let T=0;;T+=7){const H=B.read(1);if(F|=(H.buffer[0]&127)<<T,!(H.buffer[0]&128))return F}}const m=r(0);function E(B,F){if(F===0){B.write(m);return}let T=0;for(let Q=F;Q!==0;Q=Q>>>7)T++;const H=s.$Ed.alloc(T);for(let Q=0;F!==0;Q++)H.buffer[Q]=F&127,F=F>>>7,F>0&&(H.buffer[Q]|=128);B.write(H)}class d{constructor(F){this.b=F,this.a=0}read(F){const T=this.b.slice(this.a,this.a+F);return this.a+=T.byteLength,T}}e.$$g=d;class t{constructor(){this.a=[]}get buffer(){return s.$Ed.concat(this.a)}write(F){this.a.push(F)}}e.$_g=t;var u;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(u||(u={}));function r(B){const F=s.$Ed.alloc(1);return F.writeUInt8(B,0),F}const i={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object),Uint:r(u.Int)},n=typeof Buffer<"u";function o(B,F){if(typeof F>"u")B.write(i.Undefined);else if(typeof F=="string"){const T=s.$Ed.fromString(F);B.write(i.String),E(B,T.byteLength),B.write(T)}else if(n&&Buffer.isBuffer(F)){const T=s.$Ed.wrap(F);B.write(i.Buffer),E(B,T.byteLength),B.write(T)}else if(F instanceof s.$Ed)B.write(i.VSBuffer),E(B,F.byteLength),B.write(F);else if(Array.isArray(F)){B.write(i.Array),E(B,F.length);for(const T of F)o(B,T)}else if(typeof F=="number"&&(F|0)===F)B.write(i.Uint),E(B,F);else{const T=s.$Ed.fromString(JSON.stringify(F));B.write(i.Object),E(B,T.byteLength),B.write(T)}}e.$ah=o;function k(B){switch(B.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return B.read(a(B)).toString();case u.Buffer:return B.read(a(B)).buffer;case u.VSBuffer:return B.read(a(B));case u.Array:{const T=a(B),H=[];for(let Q=0;Q<T;Q++)H.push(k(B));return H}case u.Object:return JSON.parse(B.read(a(B)).toString());case u.Int:return a(B)}}e.$bh=k;class I{constructor(F,T,H=null,Q=1e3){this.h=F,this.j=T,this.k=H,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(F,T){this.b.set(F,T),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const T=this.o([F.type]);this.k?.logOutgoing(T,0,1,g(F.type));return}case 201:case 202:case 204:case 203:{const T=this.o([F.type,F.id],F.data);this.k?.logOutgoing(T,F.id,1,g(F.type),F.data);return}}}o(F,T=void 0){const H=new t;return o(H,F),o(H,T),this.p(H.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const T=new d(F),H=k(T),Q=k(T),x=H[0];switch(x){case 100:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(x)}: ${H[2]}.${H[3]}`,Q),this.s({type:x,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(x)}: ${H[2]}.${H[3]}`,Q),this.t({type:x,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(x)}`),this.u({type:x,id:H[1]});case 103:return this.k?.logIncoming(F.byteLength,H[1],1,`${y(x)}`),this.u({type:x,id:H[1]})}}s(F){const T=this.b.get(F.channelName);if(!T){this.v(F);return}const H=new M.$od;let Q;try{Q=T.call(this.j,F.name,F.arg,H.token)}catch(Y){Q=Promise.reject(Y)}const x=F.id;Q.then(Y=>{this.m({id:x,data:Y,type:201})},Y=>{Y instanceof Error?this.m({id:x,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.m({id:x,data:Y,type:203})}).finally(()=>{ce.dispose(),this.d.delete(F.id)});const ce=(0,l.$hc)(()=>H.cancel());this.d.set(F.id,ce)}t(F){const T=this.b.get(F.channelName);if(!T){this.v(F);return}const H=F.id,x=T.listen(this.j,F.name,F.arg)(ce=>this.m({id:H,data:ce,type:204}));this.d.set(F.id,x)}u(F){const T=this.d.get(F.id);T&&(T.dispose(),this.d.delete(F.id))}v(F){let T=this.g.get(F.channelName);T||(T=[],this.g.set(F.channelName,T));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:F,timeoutTimer:H})}w(F){const T=this.g.get(F);if(T){for(const H of T)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$ec)(this.d.values()),this.d.clear()}}e.$ch=I;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class v{constructor(F,T=null){this.l=F,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$ed,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=T}getChannel(F){const T=this;return{call(H,Q,x){return T.a?Promise.reject(new S.$3):T.m(F,H,Q,x)},listen(H,Q){return T.a?h.Event.None:T.o(F,H,Q)}}}m(F,T,H,Q=M.CancellationToken.None){const x=this.g++,Y={id:x,type:100,channelName:F,name:T,arg:H};if(Q.isCancellationRequested)return Promise.reject(new S.$3);let C;return new Promise((U,W)=>{if(Q.isCancellationRequested)return W(new S.$3);const q=()=>{const de=ue=>{switch(ue.type){case 201:this.f.delete(x),U(ue.data);break;case 202:{this.f.delete(x);const be=new Error(ue.data.message);be.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,be.name=ue.data.name,W(be);break}case 203:this.f.delete(x),W(ue.data);break}};this.f.set(x,de),this.p(Y)};let V=null;this.b===c.Idle?q():(V=(0,O.$tg)(de=>this.u()),V.then(()=>{V=null,q()}));const re=()=>{V?(V.cancel(),V=null):this.p({id:x,type:101}),W(new S.$3)},$e=Q.onCancellationRequested(re);C=(0,l.$gc)((0,l.$hc)(re),$e),this.d.add(C)}).finally(()=>{C.dispose(),this.d.delete(C)})}o(F,T,H){const Q=this.g++,ce={id:Q,type:102,channelName:F,name:T,arg:H};let Y=null;const C=new h.$ed({onWillAddFirstListener:()=>{Y=(0,O.$tg)(U=>this.u()),Y.then(()=>{Y=null,this.d.add(C),this.p(ce)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.d.delete(C),this.p({id:Q,type:103}))}}),L=U=>C.fire(U.data);return this.f.set(Q,L),C.event}p(F){switch(F.type){case 100:case 102:{const T=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(T,F.id,0,`${y(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const T=this.q([F.type,F.id]);this.j?.logOutgoing(T,F.id,0,y(F.type));return}}}q(F,T=void 0){const H=new t;return o(H,F),o(H,T),this.r(H.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const T=new d(F),H=k(T),Q=k(T),x=H[0];switch(x){case 200:return this.j?.logIncoming(F.byteLength,0,0,g(x)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,H[1],0,g(x),Q),this.t({type:H[0],id:H[1],data:Q})}}t(F){if(F.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$ec)(this.d.values()),this.d.clear()}}e.$dh=v,ke([A.$5g],v.prototype,"onDidInitializePromise",null);class R{get connections(){const F=[];return this.f.forEach(T=>F.push(T)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new h.$ed,this.onDidAddConnection=this.g.event,this.h=new h.$ed,this.onDidRemoveConnection=this.h.event,this.j=new l.$ic,this.j.add(F(({protocol:T,onDidClientDisconnect:H})=>{const Q=h.Event.once(T.onMessage);this.j.add(Q(x=>{const ce=new d(x),Y=k(ce),C=new I(T,Y),L=new v(T);this.a.forEach((W,q)=>C.registerChannel(q,W));const U={channelServer:C,channelClient:L,ctx:Y};this.f.add(U),this.g.fire(U),this.j.add(H(()=>{C.dispose(),L.dispose(),this.f.delete(U),this.h.fire(U)}))}))}))}getChannel(F,T){const H=this;return{call(Q,x,ce){let Y;if((0,p.$wf)(T)){const L=(0,P.$1b)(H.connections.filter(T));Y=L?Promise.resolve(L):h.Event.toPromise(h.Event.filter(H.onDidAddConnection,T))}else Y=T.routeCall(H,Q,x);const C=Y.then(L=>L.channelClient.getChannel(F));return N(C).call(Q,x,ce)},listen(Q,x){if((0,p.$wf)(T))return H.k(F,T,Q,x);const ce=T.routeEvent(H,Q,x).then(Y=>Y.channelClient.getChannel(F));return N(ce).listen(Q,x)}}}k(F,T,H,Q){const x=this;let ce;const Y=new h.$ed({onWillAddFirstListener:()=>{ce=new l.$ic;const C=new h.$kd,L=new Map,U=q=>{const re=q.channelClient.getChannel(F).listen(H,Q),$e=C.add(re);L.set(q,$e)},W=q=>{const V=L.get(q);V&&(V.dispose(),L.delete(q))};x.connections.filter(T).forEach(U),h.Event.filter(x.onDidAddConnection,T)(U,void 0,ce),x.onDidRemoveConnection(W,void 0,ce),C.event(Y.fire,Y,ce),ce.add(C)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return Y.event}registerChannel(F,T){this.a.set(F,T);for(const H of this.f)H.channelServer.registerChannel(F,T)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$eh=R;class j{constructor(F,T,H=null){const Q=new t;o(Q,T),F.send(Q.buffer),this.a=new v(F,H),this.d=new I(F,T,H)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,T){this.d.registerChannel(F,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fh=j;function N(B){return{call(F,T,H){return B.then(Q=>Q.call(F,T,H))},listen(F,T){const H=new h.$nd;return B.then(Q=>H.input=Q.listen(F,T)),H.event}}}e.$gh=N;function z(B){let F=!1;return{call(T,H,Q){return F?B.call(T,H,Q):(0,O.$Gg)(0).then(()=>F=!0).then(()=>B.call(T,H,Q))},listen(T,H){if(F)return B.listen(T,H);const Q=new h.$nd;return(0,O.$Gg)(0).then(()=>F=!0).then(()=>Q.input=B.listen(T,H)),Q.event}}}e.$hh=z;class se{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const T of F.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await h.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$ih=se;var ee;(function(B){function F(x,ce,Y){const C=x,L=Y&&Y.disableMarshalling,U=new Map;for(const W in C)H(W)&&U.set(W,h.Event.buffer(C[W],!0,void 0,ce));return new class{listen(W,q,V){const re=U.get(q);if(re)return re;if(Q(q)){const $e=C[q];if(typeof $e=="function")return $e.call(C,V)}throw new S.$_(`Event not found: ${q}`)}call(W,q,V){const re=C[q];if(typeof re=="function"){if(!L&&Array.isArray(V))for(let $e=0;$e<V.length;$e++)V[$e]=(0,b.$0g)(V[$e]);return re.apply(C,V)}throw new S.$_(`Method not found: ${q}`)}}}B.fromService=F;function T(x,ce){const Y=ce&&ce.disableMarshalling;return new Proxy({},{get(C,L){if(typeof L=="string")return ce?.properties?.has(L)?ce.properties.get(L):Q(L)?function(U){return x.listen(L,U)}:H(L)?x.listen(L):async function(...U){let W;ce&&!(0,p.$rf)(ce.context)?W=[ce.context,...U]:W=U;const q=await x.call(L,W);return Y?q:(0,b.$0g)(q)};throw new S.$_(`Property not found: ${String(L)}`)}})}B.toService=T;function H(x){return x[0]==="o"&&x[1]==="n"&&$.$Ke(x.charCodeAt(2))}function Q(x){return/^onDynamic/.test(x)&&$.$Ke(x.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const F=B.toString();if(F!=="[object Object]")return F}return B}function oe(B){return Array.isArray(B)?B.map(ne):ne(B)}function G(B,F,T,H,Q,x,ce){ce=oe(ce);const Y=ae[Q],C=Y[H%Y.length];let L=[`%c[${B}]%c[${String(F).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(x)?(L=L.concat(ce),L.push(")")):L.push(ce),console.log.apply(console,L)}class K{constructor(F,T){this.d=F,this.f=T,this.a=0,this.b=0}logOutgoing(F,T,H,Q,x){this.b+=F,G(this.d,this.b,F,T,H,Q,x)}logIncoming(F,T,H,Q,x){this.a+=F,G(this.f,this.a,F,T,H,Q,x)}}e.$jh=K}),define(te[157],ie([0,1,17,3,42]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NS=e.$MS=void 0;class M{constructor(h){this.a=h,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",l=>P.$Ed.wrap(l.data)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$MS=M;class A extends s.$fh{constructor(h,l){const b=new M(h);super(b,l),this.b=b}dispose(){this.b.disconnect()}}e.$NS=A}),define(te[109],ie([0,1,17,3,2,42]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.ProtocolConstants=e.$kh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function k(D,v){if(!n.has(D)){const R=String(++o);n.set(D,R)}return n.get(D)}function I(D,v,R,j){if(!i.enableDiagnostics)return;const N=k(D,v);if(j instanceof P.$Ed||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const z=P.$Ed.alloc(j.byteLength);z.set(j),i.records.push({timestamp:Date.now(),id:N,label:v,type:R,buff:z})}else i.records.push({timestamp:Date.now(),id:N,label:v,type:R,data:j})}i.traceSocketEvent=I})(S||(e.SocketDiagnostics=S={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let l=null;function b(){return l||(l=P.$Ed.alloc(0)),l}class ${get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return b();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const v=this.a[0];return o&&(this.a.shift(),this.b-=n),v}if(this.a[0].byteLength>n){const v=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),v}const k=P.$Ed.alloc(n);let I=0,D=0;for(;n>0;){const v=this.a[D];if(v.byteLength>n){const R=v.slice(0,n);k.set(R,I),I+=n,o&&(this.a[D]=v.slice(n),this.b-=n),n-=n}else k.set(v,I),I+=v.byteLength,o?(this.a.shift(),this.b-=v.byteLength):D++,n-=v.byteLength}return k}}e.$kh=$;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class w{constructor(n,o,k,I){this.type=n,this.id=o,this.ack=k,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends s.$jc{constructor(n){super(),this.f=this.B(new O.$ed),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new $,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,I=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new w(k,I,D,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=P.$Ed.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const k=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,k}h(){const n=P.$Ed.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class a extends s.$jc{constructor(n){super(),this.f=new O.$ed,this.onMessage=this.f.event,this.g=new O.$ed,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new c(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$lh=a;class m extends M.$fh{static fromSocket(n,o){return new m(new a(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,k=null){super(n,o,k),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$mh=m;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$ed({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$nh=E;class d{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,k=this.a;for(;k;)n[o++]=k.data,k=k.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new d(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class u{static{this.a=10}static{this.b=null}static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<u.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=u.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+u.a)*1e3;let k=0;for(let I=0;I<u.a;I++)n-this.c[I]<=o&&k++;return 1-k/u.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??u.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$ic,this.o=n.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,b());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,b());this.p.write(n)}sendResume(){const n=new w(8,0,0,b());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new s.$ic,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,b());this.p.write(n);const o=this.b.toArray();for(let k=0,I=o.length;k<I;k++)this.p.write(o[k]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new w(6,0,0,b())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let k=0,I=o.length;k<I;k++)this.p.write(o[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const k=new w(1,o,this.h,n);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(n){const o=new w(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,k=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(o>=2e4&&k>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:k});return}const D=Math.max(2e4-o,2e4-k,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,b());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,b());this.p.write(n)}}e.$oh=r}),define(te[158],ie([0,1,38,17,3,2,42,146]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QS=void 0;function h(b,$){const p=s.Event.fromNodeEventEmitter(P.$JS,$,(y,w)=>({event:y,message:w})),f=s.Event.filter(p,({event:y})=>y.sender.id===b);return s.Event.map(f,({message:y})=>y&&O.$Ed.wrap(y))}class l extends A.$eh{static{this.b=new Map}static d(){const $=s.Event.fromNodeEventEmitter(P.$JS,"vscode:hello",({sender:p})=>p);return s.Event.map($,p=>{const f=p.id;l.b.get(f)?.dispose();const w=new s.$ed;l.b.set(f,(0,M.$hc)(()=>w.fire()));const g=h(f,"vscode:message"),c=s.Event.any(s.Event.signal(h(f,"vscode:disconnect")),w.event);return{protocol:new S.$PS(p,g),onDidClientDisconnect:c}})}constructor(){super(l.d())}}e.$QS=l}),define(te[110],ie([0,1,38,3,31,157]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SS=e.$RS=void 0;class A extends M.$NS{constructor(l,b){super({addEventListener:($,p)=>l.addListener($,p),removeEventListener:($,p)=>l.removeListener($,p),postMessage:$=>l.postMessage($),start:()=>l.start(),close:()=>l.close()},b)}}e.$RS=A;async function S(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.$3f)();h.webContents.send("vscode:createMessageChannel",l);const b=O.Event.fromNodeEventEmitter(P.$JS,"vscode:createMessageChannelResult",(p,f)=>({nonce:f,port:p.ports[0]})),{port:$}=await O.Event.toPromise(O.Event.once(O.Event.filter(b,p=>p.nonce===l)));return $}e.$SS=S}),define(te[159],ie([0,1,47,8,17,22,154,14,3,2,37,88,73,42]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class y extends f.$ch{constructor(c){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",a=>s.$Ed.wrap(Buffer.from(a,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Pp=y;class w{constructor(c,a){this.i=c,this.j=a,this.c=new Set,this.g=new Map,this.h=new h.$ed,this.onDidProcessExit=this.h.event;const m=a&&a.timeout?a.timeout:6e4;this.b=new O.$Cg(m),this.d=null,this.f=null}getChannel(c){const a=this;return{call(m,E,d){return a.k(c,m,E,d)},listen(m,E){return a.l(c,m,E)}}}k(c,a,m,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(S.$4());this.b.cancel();const d=this.n(c),t=(0,O.$tg)(i=>d.call(a,m,i)),u=E.onCancellationRequested(()=>t.cancel()),r=(0,l.$hc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{u.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,a,m){if(!this.b)return h.Event.None;this.b.cancel();let E;const d=new h.$ed({onWillAddFirstListener:()=>{E=this.n(c).listen(a,m)(d.fire,d),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return d.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,b.$Um)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$sl)(a.env),this.d=(0,P.fork)(this.i,c,a);const m=new h.$ed;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$Lp)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}m.fire(s.$Ed.wrap(Buffer.from(n,"base64")))});const d=this.j.useQueue?(0,$.$ul)(this.d):this.d,t=n=>this.d&&this.d.connected&&d.send(n.buffer.toString("base64")),u=m.event,r={send:t,onMessage:u};this.f=new f.$dh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(k=>(0,l.$ec)(k)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(c){let a=this.g.get(c);return a||(a=this.m.getChannel(c),this.g.set(c,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Qp=w}),define(te[111],ie([0,1,8,3,2,74,12]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.StorageState=e.$Oo=e.StorageHint=void 0;var S;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function h(p){const f=p;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$Oo=h;var l;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(l||(e.StorageState=l={}));class b extends s.$jc{static{this.a=100}constructor(f,y=Object.create(null)){super(),this.r=f,this.s=y,this.b=this.B(new O.$hd),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$Dg(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((y,w)=>this.w(w,y)),f.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(f,y){if(this.c===l.Closed)return;let w=!1;(0,A.$rf)(y)?w=this.f.delete(f):this.f.get(f)!==y&&(this.f.set(f,y),w=!0),w&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,y){const w=this.f.get(f);return(0,A.$rf)(w)?y:w}getBoolean(f,y){const w=this.get(f);return(0,A.$rf)(w)?y:w==="true"}getNumber(f,y){const w=this.get(f);return(0,A.$rf)(w)?y:parseInt(w,10)}getObject(f,y){const w=this.get(f);return(0,A.$rf)(w)?y:(0,M.$9g)(w)}async set(f,y,w=!1){if(this.c===l.Closed)return;if((0,A.$rf)(y))return this.delete(f,w);const g=(0,A.$kf)(y)||Array.isArray(y)?(0,M.$8g)(y):String(y);if(this.f.get(f)!==g)return this.f.set(f,g),this.j.set(f,g),this.h.delete(f),this.b.fire({key:f,external:w}),this.D()}async delete(f,y=!1){if(!(this.c===l.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:y}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Po=b;class ${constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((y,w)=>this.a.set(w,y)),f.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Qo=$}),define(te[160],ie([0,1,8,3,34,9,21]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cT=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return O.Event.None}static{this.a=2e3}static{this.b=256}constructor(b,$=Object.create(null)){this.g=b,this.h=$,this.c=(0,M.$_d)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,$=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(f=>$.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${$.size} rows`),$}async updateItems(b){const $=await this.f;return this.j($,b)}j(b,$){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${$.insert?(0,s.$wi)($.insert):"0"}), delete(${$.delete?(0,s.$xi)($.delete):"0"})`),this.t(b,()=>{const p=$.insert,f=$.delete;if(p&&p.size>0){const y=[];y.push([]);let w=0;p.forEach((g,c)=>{let a=y[w];a.length>S.b&&(w++,a=[],y.push(a)),a.push(c,g)}),y.forEach(g=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(g.length/2).fill("(?,?)").join(",")}`,c=>c.run(g),()=>{const c=[];let a=0;return p.forEach((m,E)=>{c.push(E),a+=m.length}),`Keys: ${c.join(", ")} Length: ${a}`})})}if(f&&f.size){const y=[];y.push([]);let w=0;f.forEach(g=>{let c=y[w];c.length>S.b&&(w++,c=[],y.push(c)),c.push(g)}),y.forEach(g=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(g.length).fill("?").join(",")})`,c=>c.run(g),()=>{const c=[];return f.forEach(a=>{c.push(a)}),`Keys: ${c.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const b=await this.f;return this.q(b,"VACUUM")}async close(b){this.d.trace(`[storage ${this.c}] close()`);const $=await this.f;return this.k($,b)}k(b,$){return new Promise((p,f)=>{b.db.close(y=>(y&&this.o(b,`[storage ${this.c}] close(): ${y}`),this.g===S.IN_MEMORY_PATH?p():!b.isErroneous&&!b.isInMemory?this.l().then(p,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),p())):typeof $=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const g=()=>this.k(w,void 0);return this.j(w,{insert:$()}).then(()=>g(),c=>(g(),Promise.reject(c)))})).then(p,f):f(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return A.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const $=await this.f,p=await this.r($,b?"PRAGMA integrity_check":"PRAGMA quick_check"),f=b?p.integrity_check:p.quick_check;return $.isErroneous?`${f} (last error: ${$.lastError})`:$.isInMemory?`${f} (in-memory!)`:f}async n(b,$=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${$})`);try{return await this.p(b)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&$)return await(0,P.$Gg)(S.a),this.n(b,!1);try{await A.Promises.unlink(b);try{await A.Promises.rename(this.m(b),b,!1)}catch{}return await this.p(b)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(S.IN_MEMORY_PATH)}}}o(b,$){b.isErroneous=!0,b.lastError=$,this.d.error($)}p(b){return new Promise(($,p)=>{new Promise((f,y)=>{J(["@vscode/sqlite3"],f,y)}).then(f=>{const y={db:new(this.d.isTracing?f.verbose().Database:f.Database)(b,w=>w?y.db&&w.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(w)):p(w):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>$(y),g=>y.db.close(()=>p(g)))),isInMemory:b===S.IN_MEMORY_PATH};y.db.on("error",w=>this.o(y,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&y.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},p)})}q(b,$){return new Promise((p,f)=>{b.db.exec($,y=>y?(this.o(b,`[storage ${this.c}] exec(): ${y}`),f(y)):p())})}r(b,$){return new Promise((p,f)=>{b.db.get($,(y,w)=>y?(this.o(b,`[storage ${this.c}] get(): ${y}`),f(y)):p(w))})}s(b,$){return new Promise((p,f)=>{b.db.all($,(y,w)=>y?(this.o(b,`[storage ${this.c}] all(): ${y}`),f(y)):p(w))})}t(b,$){return new Promise((p,f)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),$(),b.db.run("END TRANSACTION",y=>y?(this.o(b,`[storage ${this.c}] transaction(): ${y}`),f(y)):p())})})}u(b,$,p,f){const y=b.db.prepare($),w=g=>{this.o(b,`[storage ${this.c}] prepare(): ${g} (${$}). Details: ${f()}`)};y.on("error",w),p(y),y.finalize(g=>{g&&w(g),y.removeListener("error",w)})}}e.$cT=S;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(b){b&&typeof b.logTrace=="function"&&process.env[h.a]&&(this.b=b.logTrace),b&&typeof b.logError=="function"&&(this.c=b.logError)}get isTracing(){return!!this.b}trace(b){this.b?.(b)}error(b){this.c?.(b)}}}),define(te[161],ie([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(te[162],ie([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[163],ie([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(te[164],ie([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(te[165],ie([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(te[166],ie([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[167],ie([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[168],ie([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[169],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[170],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[171],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[172],ie([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[173],ie([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[174],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[175],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[176],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[177],ie([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[178],ie([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[179],ie([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[180],ie([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[181],ie([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[182],ie([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[183],ie([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(te[184],ie([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[185],ie([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[186],ie([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[187],ie([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(te[188],ie([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[189],ie([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[190],ie([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[191],ie([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(te[192],ie([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[193],ie([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[194],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6T=e.$5T=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$5T=P;function O(s){return s&&s.hasOwnProperty("workspace")}e.$6T=O}),define(te[195],ie([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j5b=e.$i5b=e.$h5b=void 0;function O(A){return typeof A?.backupFolder=="string"}e.$h5b=O;function s(A){let S=[];try{Array.isArray(A.workspaces)&&(S=A.workspaces.map(h=>({workspace:{id:h.id,configPath:P.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return S}e.$i5b=s;function M(A){let S=[];try{Array.isArray(A.folders)&&(S=A.folders.map(h=>({folderUri:P.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return S}e.$j5b=M}),define(te[196],ie([0,1,14,164]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...l){switch(l.length){case 1:return(0,O.localize)(0,null,l[0]);case 2:return(0,O.localize)(1,null,l[0],l[1]);case 3:return(0,O.localize)(2,null,l[0],l[1],l[2]);default:return}}const A=(0,O.localize)(3,null),S=(0,O.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,P.$6)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const $=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:$})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const $=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:$})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const $=this.d,p=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:p};this.g.push({offset:$,lexeme:p,additionalInfo:b}),this.f.push(f)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const $=this.c.substring(this.d,this.e),p=h.b.get($);p?this.k(p):this.f.push({type:17,lexeme:$,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,$=!1,p=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(S);return}const y=this.c.charCodeAt(b);if($)$=!1;else if(y===47&&!p){b++;break}else y===91?p=!0:y===92?$=!0:y===93&&(p=!1);b++}for(;b<this.c.length&&h.a.has(this.c.charCodeAt(b));)b++;this.e=b;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=h}),define(te[197],ie([0,1,3,2]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0;class s{constructor(){this.a=new P.$ed,this.b=new P.$ed,this.c=new P.$ed,this.d=new P.$ed}static{this.ChannelName="extensionhostdebugservice"}call(S,h,l){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(S,h,l){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$An=s;class M extends O.$jc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,h,l){this.b.call("attach",[S,h,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,h){this.b.call("terminate",[S,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,h){return this.b.call("openExtensionDevelopmentHostWindow",[S,h])}}e.$Bn=M}),define(te[198],ie([0,1,149,55,13,9,35,19,7]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=void 0,e.$7l=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,M.$$d)(s.$1f.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,M.$8d)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,S.$hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$8d)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$hg)(h.URI.file((0,M.$8d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?h.URI.file((0,M.$8d)(f,"argv.json")):(0,S.$hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.$8d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,M.$9d)(f):(0,M.$6d)((0,M.$8d)(s.$1f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,M.$9d)(f)):h.URI.file((0,M.$8d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,M.$9d)(f);const y=A.env.VSCODE_EXTENSIONS;if(y)return y;const w=A.env.VSCODE_PORTABLE;return w?(0,M.$8d)(w,"extensions"):(0,S.$hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,M.$6d)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,M.$6d)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$7l.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const w=e.$7l.exec(y);w&&w[1]&&w[2]&&f.push([w[1],w[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,S.$hg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?h.URI.file((0,M.$8d)(f,"policy.json")):(0,S.$hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,y,w){this.a=f,this.b=y,this.c=w,this.editSessionId=this.args.editSessionId}}e.$8l=l,ke([O.$5g],l.prototype,"appRoot",null),ke([O.$5g],l.prototype,"userHome",null),ke([O.$5g],l.prototype,"userDataPath",null),ke([O.$5g],l.prototype,"appSettingsHome",null),ke([O.$5g],l.prototype,"tmpDir",null),ke([O.$5g],l.prototype,"cacheHome",null),ke([O.$5g],l.prototype,"stateResource",null),ke([O.$5g],l.prototype,"userRoamingDataHome",null),ke([O.$5g],l.prototype,"userDataSyncHome",null),ke([O.$5g],l.prototype,"sync",null),ke([O.$5g],l.prototype,"machineSettingsResource",null),ke([O.$5g],l.prototype,"workspaceStorageHome",null),ke([O.$5g],l.prototype,"localHistoryHome",null),ke([O.$5g],l.prototype,"keyboardLayoutResource",null),ke([O.$5g],l.prototype,"argvResource",null),ke([O.$5g],l.prototype,"isExtensionDevelopment",null),ke([O.$5g],l.prototype,"untitledWorkspacesHome",null),ke([O.$5g],l.prototype,"builtinExtensionsPath",null),ke([O.$5g],l.prototype,"extensionsPath",null),ke([O.$5g],l.prototype,"extensionDevelopmentLocationURI",null),ke([O.$5g],l.prototype,"extensionDevelopmentKind",null),ke([O.$5g],l.prototype,"extensionTestsLocationURI",null),ke([O.$5g],l.prototype,"debugExtensionHost",null),ke([O.$5g],l.prototype,"logLevel",null),ke([O.$5g],l.prototype,"extensionLogLevel",null),ke([O.$5g],l.prototype,"serviceMachineIdResource",null),ke([O.$5g],l.prototype,"disableTelemetry",null),ke([O.$5g],l.prototype,"disableWorkspaceTrust",null),ke([O.$5g],l.prototype,"useInMemorySecretStorage",null),ke([O.$5g],l.prototype,"policyFile",null);function b(p,f){return $(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}e.$9l=b;function $(p,f,y,w,g,c){const m=Number(f||p)||(w?null:y),E=m?!!f:!1;let d;if(c)try{d=JSON.parse(c)}catch{}return{port:m,break:E,debugId:g,env:d}}e.$0l=$}),define(te[112],ie([0,1,307,4,167]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$wl=["tunnel","serve-web"],e.$xl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(w,g,c=A){const a=w.find(o=>o.length>0&&o[0]!=="-"),m={},E=["_"],d=[],t={};let u;for(const o in g){const k=g[o];k.type==="subcommand"?o===a&&(u=k):(k.alias&&(m[o]=k.alias),k.type==="string"||k.type==="string[]"?(E.push(o),k.deprecates&&E.push(...k.deprecates)):k.type==="boolean"&&(d.push(o),k.deprecates&&d.push(...k.deprecates)),k.global&&(t[o]=k))}if(u&&a){const o=t;for(const v in u.options)o[v]=u.options[v];const k=w.filter(v=>v!==a),I=c.getSubcommandReporter?c.getSubcommandReporter(a):void 0,D=S(k,o,I);return{[a]:D,_:[]}}const r=P(w,{string:E,boolean:d,alias:m}),i={},n=r;i._=r._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in g){const k=g[o];if(k.type==="subcommand")continue;k.alias&&delete n[k.alias];let I=n[o];if(k.deprecates)for(const D of k.deprecates)n.hasOwnProperty(D)&&(I||(I=n[D],I&&c.onDeprecatedOption(D,k.deprecationMessage||(0,s.localize)(37,null,o))),delete n[D]);if(typeof I<"u"){if(k.type==="string[]"){if(Array.isArray(I)||(I=[I]),!k.allowEmptyValue){const D=I.filter(v=>v.length>0);D.length!==I.length&&(c.onEmptyValue(o),I=D.length>0?D:void 0)}}else k.type==="string"&&(Array.isArray(I)?(I=I.pop(),c.onMultipleValues(o,I)):!I&&!k.allowEmptyValue&&(c.onEmptyValue(o),I=void 0));i[o]=I,k.deprecationMessage&&c.onDeprecatedOption(o,k.deprecationMessage)}delete n[o]}for(const o in n)c.onUnknownOption(o);return i}e.$yl=S;function h(w,g){let c="";return g.args&&(Array.isArray(g.args)?c=` <${g.args.join("> <")}>`:c=` <${g.args}>`),g.alias?`-${g.alias} --${w}${c}`:`--${w}${c}`}function l(w,g){const c=[];for(const a in w){const m=w[a],E=h(a,m);c.push([E,m.description])}return b(c,g)}e.$zl=l;function b(w,g){const a=w.reduce((d,t)=>Math.max(d,t[0].length),12)+2+1;if(g-a<25)return w.reduce((d,t)=>d.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const m=g-a-1,E=[];for(const d of w){const t=d[0],u=p(d[1],m),r=$(a-t.length-2);E.push("  "+t+r+u[0]);for(let i=1;i<u.length;i++)E.push($(a)+u[i])}return E}function $(w){return" ".repeat(w)}function p(w,g){const c=[];for(;w.length;){const a=w.length<g?w.length:w.lastIndexOf(" ",g),m=w.slice(0,a).trim();w=w.slice(a),c.push(m)}return c}function f(w,g,c,a,m){const E=process.stdout.isTTY&&process.stdout.columns||80,d=m?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${w} ${c}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${g} [${(0,s.localize)(40,null)}]${d}`),t.push(""),m?.noPipe!==!0&&(O.$i?t.push((0,s.localize)(41,null,g)):t.push((0,s.localize)(42,null,g)),t.push(""));const u={},r=[];for(const i in a){const n=a[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let o=u[n.cat];o||(u[n.cat]=o={}),o[i]=n}}for(const i in u){const n=i,o=u[n];o&&(t.push(M[n]),t.push(...l(o,E)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...b(r.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}e.$Al=f;function y(w,g){return`${w||(0,s.localize)(44,null)}
${g||(0,s.localize)(45,null)}
${process.arch}`}e.$Bl=y}),define(te[199],ie([0,1,87,197,112]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q5b=void 0;class M extends O.$An{constructor(S){super(),this.f=S}call(S,h,l){return h==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(S,h,l)}async g(S,h){const l=(0,s.$yl)(S,s.$xl);l.debugRenderer=h;const b=l.extensionDevelopmentPath;if(!b)return{success:!1};const[$]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const p=$.win;if(!p)return{success:!0};const f=p.webContents.debugger;let y=f.isAttached()?1/0:0;const w=(0,P.createServer)(g=>{y++===0&&f.attach();let c=!1;const a=d=>{c||g.write(JSON.stringify(d)+"\0")},m=(d,t,u,r)=>a({method:t,params:u,sessionId:r});p.on("close",()=>{f.removeListener("message",m),g.end(),c=!0}),f.addListener("message",m);let E=Buffer.alloc(0);g.on("data",d=>{E=Buffer.concat([E,d]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let u;try{const r=E.slice(0,t).toString("utf8");E=E.slice(t+1),u=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(u.method,u.params,u.sessionId).then(r=>a({id:u.id,sessionId:u.sessionId,result:r})).catch(r=>a({id:u.id,sessionId:u.sessionId,error:{code:0,message:r.message}}))}}),g.on("error",d=>{console.error("error on cdp pipe:",d)}),g.on("close",()=>{c=!0,--y===0&&f.detach()})});return await new Promise(g=>w.listen(0,g)),p.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$q5b=M}),define(te[63],ie([0,1,308,168,112]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Dl=e.$Cl=void 0;function M($,p){const f=(m,E)=>{console.warn((0,O.localize)(0,null,m,E))},y=m=>{console.warn((0,O.localize)(1,null,m))},w=(m,E)=>{console.warn((0,O.localize)(2,null,m,E))},g=m=>({onUnknownOption:E=>{s.$wl.includes(m)||console.warn((0,O.localize)(3,null,E,m))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:s.$wl.includes(m)?g:void 0}),c={onUnknownOption:m=>{console.warn((0,O.localize)(4,null,m))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:g},a=(0,s.$yl)($,s.$xl,p?c:void 0);return a.goto&&a._.forEach(m=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(m),(0,O.localize)(5,null))),a}function A($){const p=$.findIndex(f=>!/^-/.test(f));if(p>-1)return[...$.slice(0,p),...$.slice(p+1)]}function S($){let[,...p]=$;process.env.VSCODE_DEV&&(p=A(p)||[]);const f=!b(process.env);return M(p,f)}e.$Cl=S;function h($){let[,,...p]=$;return process.env.VSCODE_DEV&&(p=A(p)||[]),M(p,!0)}e.$Dl=h;function l($,...p){const f=$.indexOf("--");return f===-1?$.push(...p):$.splice(f,0,...p),$}e.$El=l;function b($){return $.VSCODE_CLI==="1"}e.$Fl=b}),function(){"use strict";function J(e,P,O){function s(A,S){const h=M(A,S),l=[h];return e.isAbsolute(h)||l.unshift(O),e.resolve(...l)}function M(A,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,S);const b=A["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const $=process.env.USERPROFILE;if(typeof $!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join($,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,S)}return{getUserDataPath:s}}if(typeof define=="function")define(te[200],ie([113,27,35]),function(e,P,O){return J(e,P,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=J(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,27,198,200]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=void 0;class M extends O.$8l{constructor(l,b){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,b.nameShort)},b)}}e.$$l=M;function A(h,l){return(0,O.$0l)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}e.$_l=A;function S(h,l){return(0,O.$0l)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}e.$am=S}),define(te[201],ie([0,1,45,27,32]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=void 0;function M(A){const S=(0,s.$Pf)((0,O.tmpdir)());try{return(0,P.writeFileSync)(S,""),A&&console.log(`Marker file for --wait created: ${S}`),S}catch(h){A&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.$S6b=M}),define(te[202],ie([0,1,12,170]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;function s(A,S,h,l){try{M(A,S,h,l)}catch(b){A.error(b?.message??b)}return S}e.$lp=s;function M(A,S,h,l){const b=($,p,f)=>{const y=$[p];if((0,P.$if)(y)){const w=y,g=w.length;if(g>1&&w[0]==="%"&&w[g-1]==="%"){const c=w.substr(1,g-2);let a=h[c];a===void 0&&l&&(a=l[c]);const m=typeof a=="string"?a:a?.message,E=l?.[c],d=typeof E=="string"?E:E?.message;if(!m){d||A.warn(`[${S.name}]: ${(0,O.localize)(0,null,c)}`);return}if(f&&(p==="title"||p==="category")&&d&&d!==m){const t={value:m,original:d};$[p]=t}else $[p]=m}}else if((0,P.$kf)(y))for(const w in y)y.hasOwnProperty(w)&&(w==="commands"?b(y,w,!0):b(y,w,f));else if(Array.isArray(y))for(let w=0;w<y.length;w++)b(y,w,f)};for(const $ in S)S.hasOwnProperty($)&&b(S,$)}}),define(te[203],ie([0,1,19,70,172,204]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function h(c){return c=c.trim(),c==="*"||A.test(c)}e.$Ao=h;function l(c){if(!h(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=c.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$Bo=l;function b(c){if(!c)return null;const a=c.majorBase,m=c.majorMustEqual,E=c.minorBase;let d=c.minorMustEqual;const t=c.patchBase;let u=c.patchMustEqual;c.hasCaret&&(a===0||(d=!1),u=!1);let r=0;if(c.preRelease){const i=S.exec(c.preRelease);if(i){const[,n,o,k]=i;r=Date.UTC(Number(n),Number(o)-1,Number(k))}}return{majorBase:a,majorMustEqual:m,minorBase:E,minorMustEqual:d,patchBase:t,patchMustEqual:u,isMinimum:c.hasGreaterEquals,notBefore:r}}e.$Co=b;function $(c,a,m){let E;typeof c=="string"?E=b(l(c)):E=c;let d;a instanceof Date?d=a.getTime():typeof a=="string"&&(d=new Date(a).getTime());let t;if(typeof m=="string"?t=b(l(m)):t=m,!E||!t)return!1;const u=E.majorBase,r=E.minorBase,i=E.patchBase;let n=t.majorBase,o=t.minorBase,k=t.patchBase;const I=t.notBefore;let D=t.majorMustEqual,v=t.minorMustEqual,R=t.patchMustEqual;return t.isMinimum?u>n?!0:u<n?!1:r>o?!0:r<o||d&&d<I?!1:i>=k:(u===1&&n===0&&(!D||!v||!R)&&(n=1,o=0,k=0,D=!0,v=!1,R=!1),u<n?!1:u>n?!D:r<o?!1:r>o?!v:i<k?!1:i>k?!R:!(d&&d<I))}e.$Do=$;function p(c,a,m,E,d){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([O.default.Error,s.localize(0,null)]),t;if(typeof E.name!="string")return t.push([O.default.Error,s.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([O.default.Error,s.localize(2,null,"version")]),t;if(!E.engines)return t.push([O.default.Error,s.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([O.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!g(E.extensionDependencies))return t.push([O.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!g(E.activationEvents))return t.push([O.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([O.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([O.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([O.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$hg)(m,E.main);(0,P.$bg)(i,m)||t.push([O.default.Warning,s.localize(10,null,i.path,m.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([O.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$hg)(m,E.browser);(0,P.$bg)(i,m)||t.push([O.default.Warning,s.localize(12,null,i.path,m.path)])}}if(!M.valid(E.version))return t.push([O.default.Error,s.localize(13,null)]),t;const u=[];if(!f(c,a,E,d,u))for(const i of u)t.push([O.default.Error,i]);return t}e.$Eo=p;function f(c,a,m,E,d){return E||typeof m.main>"u"&&typeof m.browser>"u"?!0:w(c,a,m.engines.vscode,d)}e.$Fo=f;function y(c,a,m){return c==="*"||w(a,m,c)}e.$Go=y;function w(c,a,m,E=[]){const d=b(l(m));if(!d)return E.push(s.localize(14,null,m)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return E.push(s.localize(15,null,m)),!1}else if(!d.majorMustEqual)return E.push(s.localize(16,null,m)),!1;return $(c,a,d)?!0:(E.push(s.localize(17,null,c,m)),!1)}function g(c){if(!Array.isArray(c))return!1;for(let a=0,m=c.length;a<m;a++)if(typeof c[a]!="string")return!1;return!0}}),define(te[205],ie([0,1,17,31]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0;async function s(M,A,S){let h=S&&S.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const b=(await A.readFile(M.serviceMachineIdResource)).value.toString();h=(0,O.$2f)(b)?b:null}catch{h=null}if(!h){h=(0,O.$3f)();try{await A.writeFile(M.serviceMachineIdResource,P.$Ed.fromString(h))}catch{}}return S?.store("storage.serviceMachineId",h,-1,1),h}e.$Zo=s}),define(te[75],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class P{constructor(s,M=[],A=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$xh=P}),define(te[206],ie([0,1,75]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.InstantiationType=void 0;const O=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,h,l){h instanceof P.$xh||(h=new P.$xh(h,[],!!l)),O.push([S,h])}e.$kr=M;function A(){return O}e.$lr=A}),define(te[207],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class P{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$2p=P;class O{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const S=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(A);S.outgoing.set(h.key,h),h.incoming.set(S.key,S)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const S of this.a.values())S.outgoing.delete(A),S.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let S=this.a.get(A);return S||(S=new P(A,M),this.a.set(A,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,S]of this.a)M.push(`${A}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const S=new Set([M]),h=this.c(A,S);if(h)return h}}c(M,A){for(const[S,h]of M.outgoing){if(A.has(S))return[...A,S].join(" -> ");A.add(S);const l=this.c(h,A);if(l)return l;A.delete(S)}}}e.$3p=O}),define(te[6],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e._util=void 0;var P;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function S(h){return h[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=S})(P||(e._util=P={})),e.$zh=s("instantiationService");function O(A,S,h){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:A,index:h}):(S[P.DI_DEPENDENCIES]=[{id:A,index:h}],S[P.DI_TARGET]=S)}function s(A){if(P.serviceIds.has(A))return P.serviceIds.get(A);const S=function(h,l,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(S,h,b)};return S.toString=()=>A,P.serviceIds.set(A,S),S}e.$Ah=s;function M(A){return A}e.$Bh=M}),define(te[64],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k5b=void 0,e.$k5b=(0,P.$Ah)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,s.$Ah)("configurationService");function M(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.$8h=M;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.$9h=A;var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function h(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=h;function l(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$$h=l;function b(c,a){const m=Object.create(null);for(const E in c)$(m,E,c[E],a);return m}e.$_h=b;function $(c,a,m,E){const d=a.split("."),t=d.pop();let u=c;for(let r=0;r<d.length;r++){const i=d[r];let n=u[i];switch(typeof n){case"undefined":n=u[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${a} as ${d.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}u=n}if(typeof u=="object"&&u!==null)try{u[t]=m}catch{E(`Ignoring ${a} as ${d.join(".")} is ${JSON.stringify(u)}`)}else E(`Ignoring ${a} as ${d.join(".")} is ${JSON.stringify(u)}`)}e.$ai=$;function p(c,a){const m=a.split(".");f(c,m)}e.$bi=p;function f(c,a){const m=a.shift();if(a.length===0){delete c[m];return}if(Object.keys(c).indexOf(m)!==-1){const E=c[m];typeof E=="object"&&!Array.isArray(E)&&(f(E,a),Object.keys(E).length===0&&delete c[m])}}function y(c,a,m){function E(u,r){let i=u;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const d=a.split("."),t=E(c,d);return typeof t>"u"?m:t}e.$ci=y;function w(c,a,m){Object.keys(a).forEach(E=>{E!=="__proto__"&&(E in c?P.$kf(c[E])&&P.$kf(a[E])?w(c[E],a[E],m):m&&(c[E]=a[E]):c[E]=a[E])})}e.$di=w;function g(c){return c.replace(/[\[\]]/g,"")}e.$ei=g}),define(te[114],ie([0,1,4,26,196,6,163,14]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",P.$j),h.set("isLinux",P.$k),h.set("isWindows",P.$i),h.set("isWeb",P.$o),h.set("isMacNative",P.$j&&!P.$o),h.set("isEdge",P.$G),h.set("isFirefox",P.$E),h.set("isChrome",P.$D),h.set("isSafari",P.$F);function l(Y,C){if(h.get(Y)!==void 0)throw(0,S.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(Y,C)}e.$Fi=l;const b=Object.prototype.hasOwnProperty;var $;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const p={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),y=(0,A.localize)(1,null),w=(0,A.localize)(2,null),g=(0,A.localize)(3,null),c=(0,A.localize)(4,null),a=(0,A.localize)(5,null),m=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=p){this.k=C,this.d=new s.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const U=this.D(),W=U.type===17?a:void 0;throw this.h.push({message:c,offset:U.offset,lexeme:s.$Ei.getLexeme(U),additionalInfo:W}),d.c}return L}catch(L){if(L!==d.c)throw L;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const L=this.o();C.push(L)}return C.length===1?C[0]:t.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const L=this.s();C.push(L)}return C.length===1?C[0]:t.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const L=this.l();return this.A(1,g),L?.negate()}case 17:return this.z(),j.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const L=this.l();return this.A(1,g),L}case 17:{const L=C.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const q=W.lexeme,V=q.lastIndexOf("/"),re=V===q.length-1?void 0:this.w(q.substring(V+1));let $e;try{$e=new RegExp(q.substring(1,V),re)}catch{throw this.B("REGEX",W)}return ne.create(L,$e)}switch(W.type){case 10:case 19:{const q=[W.lexeme];this.z();let V=this.D(),re=0;for(let me=0;me<W.lexeme.length;me++)W.lexeme.charCodeAt(me)===40?re++:W.lexeme.charCodeAt(me)===41&&re--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let me=0;me<V.lexeme.length;me++)V.lexeme.charCodeAt(me)===40?re++:W.lexeme.charCodeAt(me)===41&&re--}if(re<0)break;q.push(s.$Ei.getLexeme(V)),this.z(),V=this.D()}const $e=q.join(""),de=$e.lastIndexOf("/"),ue=de===$e.length-1?void 0:this.w($e.substring(de+1));let be;try{be=new RegExp($e.substring(1,de),ue)}catch{throw this.B("REGEX",W)}return t.regex(L,be)}case 18:{const q=W.lexeme;this.z();let V=null;if(!(0,O.$le)(q)){const re=q.indexOf("/"),$e=q.lastIndexOf("/");if(re!==$e&&re>=0){const de=q.slice(re+1,$e),ue=q[$e+1]==="i"?"i":"";try{V=new RegExp(de,ue)}catch{throw this.B("REGEX",W)}}}if(V===null)throw this.B("REGEX",W);return ne.create(L,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const W=this.u();return t.notIn(L,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return t.equals(L,W);switch(W){case"true":return t.has(L);case"false":return t.not(L);default:return t.equals(L,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return t.notEquals(L,W);switch(W){case"true":return t.not(L);case"false":return t.has(L);default:return t.notEquals(L,W)}}case 5:return this.z(),ee.create(L,this.u());case 6:return this.z(),ae.create(L,this.u());case 7:return this.z(),z.create(L,this.u());case 8:return this.z(),se.create(L,this.u());case 13:return this.z(),t.in(L,this.u());default:return t.has(L)}}case 20:throw this.h.push({message:m,offset:C.offset,lexeme:"",additionalInfo:E}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,L){if(this.C(C))return this.z();throw this.B(L,this.D())}B(C,L,U){const W=(0,A.localize)(8,null,C,s.$Ei.getLexeme(L)),q=L.offset,V=s.$Ei.getLexeme(L);return this.h.push({message:W,offset:q,lexeme:V,additionalInfo:U}),d.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=d;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(C){return k.create(C)}static equals(C,L){return I.create(C,L)}static notEquals(C,L){return R.create(C,L)}static regex(C,L){return ne.create(C,L)}static in(C,L){return D.create(C,L)}static notIn(C,L){return v.create(C,L)}static not(C){return j.create(C)}static and(...C){return K.create(C,null,!0)}static or(...C){return B.create(C,null,!0)}static greater(C,L){return z.create(C,L)}static greaterEquals(C,L){return se.create(C,L)}static smaller(C,L){return ee.create(C,L)}static smallerEquals(C,L){return ae.create(C,L)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(C){return C==null?void 0:this.c.parse(C)}}e.$Hi=t;function u(Y){const C=new d({regexParsingWithErrorRecovery:!1});return Y.map(L=>(C.parse(L),C.lexingErrors.length>0?C.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,A.localize)(9,null,U.additionalInfo):(0,A.localize)(10,null),offset:U.offset,length:U.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.$Ii=u;function r(Y,C){const L=Y?Y.substituteConstants():void 0,U=C?C.substituteConstants():void 0;return!L&&!U?!0:!L||!U?!1:L.equals(U)}e.$Ji=r;function i(Y,C){return Y.cmp(C)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return o.INSTANCE}}e.$Ki=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return n.INSTANCE}}e.$Li=o;class k{static create(C,L=null){const U=h.get(C);return typeof U=="boolean"?U?o.INSTANCE:n.INSTANCE:new k(C,L)}constructor(C,L){this.key=C,this.c=L,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=h.get(this.key);return typeof C=="boolean"?C?o.INSTANCE:n.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Mi=k;class I{static create(C,L,U=null){if(typeof L=="boolean")return L?k.create(C,U):j.create(C,U);const W=h.get(C);return typeof W=="boolean"?L===(W?"true":"false")?o.INSTANCE:n.INSTANCE:new I(C,L,U)}constructor(C,L,U){this.c=C,this.d=L,this.f=U,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=h.get(this.c);if(typeof C=="boolean"){const L=C?"true":"false";return this.d===L?o.INSTANCE:n.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Ni=I;class D{static create(C,L){return new D(C,L)}constructor(C,L){this.d=C,this.f=L,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:H(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const L=C.getValue(this.f),U=C.getValue(this.d);return Array.isArray(L)?L.includes(U):typeof U=="string"&&typeof L=="object"&&L!==null?b.call(L,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Oi=D;class v{static create(C,L){return new v(C,L)}constructor(C,L){this.d=C,this.f=L,this.type=11,this.c=D.create(C,L)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=v;class R{static create(C,L,U=null){if(typeof L=="boolean")return L?j.create(C,U):k.create(C,U);const W=h.get(C);return typeof W=="boolean"?L===(W?"true":"false")?n.INSTANCE:o.INSTANCE:new R(C,L,U)}constructor(C,L,U){this.c=C,this.d=L,this.f=U,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=h.get(this.c);if(typeof C=="boolean"){const L=C?"true":"false";return this.d===L?n.INSTANCE:o.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Qi=R;class j{static create(C,L=null){const U=h.get(C);return typeof U=="boolean"?U?n.INSTANCE:o.INSTANCE:new j(C,L)}constructor(C,L){this.c=C,this.d=L,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:T(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=h.get(this.c);return typeof C=="boolean"?C?n.INSTANCE:o.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Ri=j;function N(Y,C){if(typeof Y=="string"){const L=parseFloat(Y);isNaN(L)||(Y=L)}return typeof Y=="string"||typeof Y=="number"?C(Y):n.INSTANCE}class z{static create(C,L,U=null){return N(L,W=>new z(C,W,U))}constructor(C,L,U){this.c=C,this.d=L,this.f=U,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Si=z;class se{static create(C,L,U=null){return N(L,W=>new se(C,W,U))}constructor(C,L,U){this.c=C,this.d=L,this.f=U,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Ti=se;class ee{static create(C,L,U=null){return N(L,W=>new ee(C,W,U))}constructor(C,L,U){this.c=C,this.d=L,this.f=U,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Ui=ee;class ae{static create(C,L,U=null){return N(L,W=>new ae(C,W,U))}constructor(C,L,U){this.c=C,this.d=L,this.f=U,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Vi=ae;class ne{static create(C,L){return new ne(C,L)}constructor(C,L){this.d=C,this.f=L,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const L=this.f?this.f.source:"",U=C.f?C.f.source:"";return L<U?-1:L>U?1:0}equals(C){if(C.type===this.type){const L=this.f?this.f.source:"",U=C.f?C.f.source:"";return this.d===C.d&&L===U}return!1}substituteConstants(){return this}evaluate(C){const L=C.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$Wi=ne;class oe{static create(C){return new oe(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(C){return new oe(this.c.map(C))}negate(){return this.c}}e.$Xi=oe;function G(Y){let C=null;for(let L=0,U=Y.length;L<U;L++){const W=Y[L].substituteConstants();if(Y[L]!==W&&C===null){C=[];for(let q=0;q<L;q++)C[q]=Y[q]}C!==null&&(C[L]=W)}return C===null?Y:C}class K{static create(C,L,U){return K.d(C,L,U)}constructor(C,L){this.expr=C,this.c=L,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let L=0,U=this.expr.length;L<U;L++){const W=i(this.expr[L],C.expr[L]);if(W!==0)return W}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let L=0,U=this.expr.length;L<U;L++)if(!this.expr[L].equals(C.expr[L]))return!1;return!0}return!1}substituteConstants(){const C=G(this.expr);return C===this.expr?this:K.create(C,this.c,!1)}evaluate(C){for(let L=0,U=this.expr.length;L<U;L++)if(!this.expr[L].evaluate(C))return!1;return!0}static d(C,L,U){const W=[];let q=!1;for(const V of C)if(V){if(V.type===1){q=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){W.push(...V.expr);continue}W.push(V)}if(W.length===0&&q)return o.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];for(;W.length>1;){const V=W[W.length-1];if(V.type!==9)break;W.pop();const re=W.pop(),$e=W.length===0,de=B.create(V.expr.map(ue=>K.create([ue,re],null,U)),null,$e);de&&(W.push(de),W.sort(i))}if(W.length===1)return W[0];if(U){for(let V=0;V<W.length;V++)for(let re=V+1;re<W.length;re++)if(W[V].negate().equals(W[re]))return n.INSTANCE;if(W.length===1)return W[0]}return new K(W,L)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const L of this.expr)C.push(...L.keys());return C}map(C){return new K(this.expr.map(L=>L.map(C)),null)}negate(){if(!this.c){const C=[];for(const L of this.expr)C.push(L.negate());this.c=B.create(C,this,!0)}return this.c}}e.$Yi=K;class B{static create(C,L,U){return B.d(C,L,U)}constructor(C,L){this.expr=C,this.c=L,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let L=0,U=this.expr.length;L<U;L++){const W=i(this.expr[L],C.expr[L]);if(W!==0)return W}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let L=0,U=this.expr.length;L<U;L++)if(!this.expr[L].equals(C.expr[L]))return!1;return!0}return!1}substituteConstants(){const C=G(this.expr);return C===this.expr?this:B.create(C,this.c,!1)}evaluate(C){for(let L=0,U=this.expr.length;L<U;L++)if(this.expr[L].evaluate(C))return!0;return!1}static d(C,L,U){let W=[],q=!1;if(C){for(let V=0,re=C.length;V<re;V++){const $e=C[V];if($e){if($e.type===0){q=!0;continue}if($e.type===1)return o.INSTANCE;if($e.type===9){W=W.concat($e.expr);continue}W.push($e)}}if(W.length===0&&q)return n.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];if(U){for(let V=0;V<W.length;V++)for(let re=V+1;re<W.length;re++)if(W[V].negate().equals(W[re]))return o.INSTANCE;if(W.length===1)return W[0]}return new B(W,L)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const L of this.expr)C.push(...L.keys());return C}map(C){return new B(this.expr.map(L=>L.map(C)),null)}negate(){if(!this.c){const C=[];for(const L of this.expr)C.push(L.negate());for(;C.length>1;){const L=C.shift(),U=C.shift(),W=[];for(const q of ce(L))for(const V of ce(U))W.push(K.create([q,V],null,!1));C.unshift(B.create(W,null,!1))}this.c=B.create(C,this,!0)}return this.c}}e.$Zi=B;class F extends k{static{this.d=[]}static all(){return F.d.values()}constructor(C,L,U){super(C,null),this.f=L,typeof U=="object"?F.d.push({...U,key:C}):U!==!0&&F.d.push({key:C,description:U,type:L!=null?typeof L:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return I.create(this.key,C)}notEqualsTo(C){return R.create(this.key,C)}}e.$1i=F,e.$2i=(0,M.$Ah)("contextKeyService");function T(Y,C){return Y<C?-1:Y>C?1:0}function H(Y,C,L,U){return Y<L?-1:Y>L?1:C<U?-1:C>U?1:0}function Q(Y,C){if(Y.type===0||C.type===1)return!0;if(Y.type===9)return C.type===9?x(Y.expr,C.expr):!1;if(C.type===9){for(const L of C.expr)if(Q(Y,L))return!0;return!1}if(Y.type===6){if(C.type===6)return x(C.expr,Y.expr);for(const L of Y.expr)if(Q(L,C))return!0;return!1}return Y.equals(C)}e.$3i=Q;function x(Y,C){let L=0,U=0;for(;L<Y.length&&U<C.length;){const W=Y[L].cmp(C[U]);if(W<0)return!1;W===0&&L++,U++}return L===Y.length}function ce(Y){return Y.type===9?Y.expr:[Y]}}),define(te[90],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=e.ID=void 0,e.ID="diagnosticsService",e.$fm=(0,P.$Ah)(e.ID);function O(M){return!!M.hostName&&!!M.errorMessage}e.$gm=O;class s{async getPerformanceInfo(A,S){return{}}async getSystemInfo(A,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,S){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$hm=s}),define(te[91],ie([0,1,19,70,165,6,46,4,37]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pA=e.$oA=e.ConfirmResult=e.$nA=e.$mA=e.$lA=void 0,e.$lA=(0,M.$Ah)("dialogService");var l;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(l||(l={}));class b{a(g){return this.d(g,l.Confirmation)}b(g){return this.d(g,l.Prompt)}c(g){return this.d(g,l.Input)}d(g,c){const a=[];switch(c){case l.Confirmation:{const m=g;m.primaryButton?a.push(m.primaryButton):a.push((0,s.localize)(0,null)),m.cancelButton?a.push(m.cancelButton):a.push((0,s.localize)(1,null));break}case l.Prompt:{const m=g;Array.isArray(m.buttons)&&m.buttons.length>0&&a.push(...m.buttons.map(E=>E.label)),m.cancelButton&&(m.cancelButton===!0?a.push((0,s.localize)(2,null)):typeof m.cancelButton=="string"?a.push(m.cancelButton):m.cancelButton.label?a.push(m.cancelButton.label):a.push((0,s.localize)(3,null))),a.length===0&&a.push((0,s.localize)(4,null));break}case l.Input:{const m=g;m.primaryButton?a.push(m.primaryButton):a.push((0,s.localize)(5,null)),m.cancelButton?a.push(m.cancelButton):a.push((0,s.localize)(6,null));break}}return a}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===O.default.Info?"info":g===O.default.Error?"error":g===O.default.Warning?"warning":"none"}async f(g,c,a){const m=[...g.buttons??[]];return g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&m.push(g.cancelButton),{result:await m[c]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.$mA=b,e.$nA=(0,M.$Ah)("fileDialogService");var $;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})($||(e.ConfirmResult=$={}));const p=10;function f(w){const g=[];return g.push(...w.slice(0,p).map(c=>typeof c=="string"?c:(0,P.$eg)(c))),w.length>p&&(w.length-p===1?g.push((0,s.localize)(7,null)):g.push((0,s.localize)(8,null,w.length-p))),g.push(""),g.join(`
`)}e.$oA=f;function y(w,g){const c=(0,h.$Um)(w);let a=(c.buttons??[]).map(t=>(0,A.$iA)(t)),m=(w.buttons||[]).map((t,u)=>u),E=0,d=c.cancelId??a.length-1;if(a.length>1){const t=typeof d=="number"?a[d]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&a.length>1&&d!==1){a.splice(d,1),a.splice(1,0,t);const u=m[d];m.splice(d,1),m.splice(1,0,u),d=1}S.$k&&a.length>1&&(a=a.reverse(),m=m.reverse(),E=a.length-1,typeof t=="string"&&(d=E-1))}else if(S.$i&&typeof t=="string"&&a.length>1&&d!==a.length-1){a.splice(d,1),a.push(t);const u=m[d];m.splice(d,1),m.push(u),d=a.length-1}}return c.buttons=a,c.defaultId=E,c.cancelId=d,c.noLink=!0,c.title=c.title||g.nameLong,{options:c,buttonIndeces:m}}e.$pA=y}),define(te[115],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tT=e.$sT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$rT=e.$qT=void 0,e.$qT=(0,P.$Ah)("encryptionService"),e.$rT=(0,P.$Ah)("encryptionMainService");var O;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(O||(e.PasswordStoreCLIOption=O={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$sT=M;function A(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$tT=A}),define(te[36],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,P.$Ah)("environmentService"),e.$Ih=(0,P.$Bh)(e.$Hh)}),define(te[116],ie([0,1,169,6]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function s(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=s;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=M;function A(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=A;function S(a,m){return m==="web"&&!a.includes("web")}e.$Un=S;function h(a,m,E){return S(m,E)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===E?!0:l(E).includes(a)}e.$Vn=h;function l(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=l;function b(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$Xn=b;var $;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var f;(function(a){a.Install="install",a.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$Yn=(0,O.$Ah)("extensionGalleryService");var w;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var g;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class c extends Error{constructor(m,E){super(m),this.code=E,this.name=E}}e.$Zn=c,e.$1n=(0,O.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,O.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,O.$Ah)("IExtensionTipsService"),e.$6n=(0,P.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,P.localize)(1,null),original:"Preferences"}}),define(te[208],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skb=void 0,e.$Skb=(0,P.$Ah)("extensionUrlTrustService")}),define(te[209],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G5b=e.$F5b=void 0,e.$F5b=(0,P.$Ah)("extensionHostStarter"),e.$G5b="extensionHostStarter"}),define(te[117],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YWb=e.$XWb=e.$WWb=void 0,e.$WWb=(0,P.$Ah)("externalTerminal"),e.$XWb="Terminal.app",e.$YWb=(0,P.$Ah)("externalTerminal")}),define(te[210],ie([0,1,47,13,9,4,73,21,88,173,117]),function(J,e,P,O,s,M,A,S,h,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K5b=e.$J5b=e.$I5b=void 0;const $=l.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends p{static{this.b="cmd.exe"}openTerminal(E,d){return this.spawnTerminal(P,E,h.$tl(),d)}spawnTerminal(E,d,t,u){const r=d.windowsExec||f.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=s.$_d(r,".exe").toLowerCase();if(i==="cmder")return E.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((o,k)=>{const I=g(process),D=E.spawn(t,n,{cwd:u,env:I});D.on("error",k),D.on("exit",()=>o())})}runInTerminal(E,d,t,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,o)=>{const k=`"${d} - ${$}"`,I=`""${t.join('" "')}" & pause"`,D=Object.assign({},g(process),u);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const v={cwd:d,env:D,windowsVerbatimArguments:!0};let R,j;s.$_d(i,".exe")==="wt"?(R=i,j=["-d",".",f.b,"/c",I]):(R=f.b,j=["/c","start",k,"/wait",i,"/c",I]),P.spawn(R,j,v).on("error",z=>{o(c(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$I5b=f;class y extends p{static{this.b="/usr/bin/osascript"}openTerminal(E,d){return this.spawnTerminal(P,E,d)}runInTerminal(E,d,t,u,r){const i=r.osxExec||b.$XWb;return new Promise((n,o)=>{if(i===b.$XWb||i==="iTerm.app"){const k=i===b.$XWb?"TerminalHelper":"iTermHelper",D=[O.$1f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",E||$,"-w",d];for(const j of t)D.push("-a"),D.push(j);if(u){const j=Object.assign({},g(process),u);for(const N in j){const z=j[N];z===null?(D.push("-u"),D.push(N)):(D.push("-e"),D.push(`${N}=${z}`))}}let v="";const R=P.spawn(y.b,D);R.on("error",j=>{o(c(j))}),R.stderr.on("data",j=>{v+=j.toString()}),R.on("exit",j=>{if(j===0)n(void 0);else if(v){const N=v.split(`
`,1);o(new Error(N[0]))}else o(new Error(l.localize(1,null,k,j)))})}else o(new Error(l.localize(2,null,i)))})}spawnTerminal(E,d,t){const u=d.osxExec||b.$XWb;return new Promise((r,i)=>{const n=["-a",u];t&&n.push(t);const o=g(process),k=E.spawn("/usr/bin/open",n,{cwd:t,env:o});k.on("error",i),k.on("exit",()=>r())})}}e.$J5b=y;class w extends p{static{this.b=l.localize(3,null)}openTerminal(E,d){return this.spawnTerminal(P,E,d)}runInTerminal(E,d,t,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const k=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const D=`${a(t)}; echo; read -p "${w.b}" -n1;`;k.push(`''${D}''`);const v=Object.assign({},g(process),u);Object.keys(v).filter(z=>v[z]===null).forEach(z=>delete v[z]);const R={cwd:d,env:v};let j="";const N=P.spawn(I,k,R);N.on("error",z=>{o(c(z))}),N.stderr.on("data",z=>{j+=z.toString()}),N.on("exit",z=>{if(z===0)n(void 0);else if(j){const se=j.split(`
`,1);o(new Error(se[0]))}else o(new Error(l.localize(4,null,I,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!M.$k)w.d=Promise.resolve("xterm");else{const E=await S.Promises.exists("/etc/debian_version");w.d=new Promise(d=>{E?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm")})}return w.d}spawnTerminal(E,d,t){const u=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(n=>{const o=g(process),k=E.spawn(n,[],{cwd:t,env:o});k.on("error",i),k.on("exit",()=>r())})})}}e.$K5b=w;function g(m){const E={...m.env};return(0,A.$rl)(E),E}function c(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(l.localize(5,null,m.path)):m}function a(m){let E="";for(const d of m)d.indexOf(" ")>=0?E+='"'+d+'"':E+=d,E+=" ";return E}}),define(te[16],ie([0,1,58,9,26,12,7,175,6,4,13]),function(J,e,P,O,s,M,A,S,h,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileKind=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileOperationResult=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileChangeType=e.$jk=e.FileOperation=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileSystemProviderErrorCode=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$6j=e.$5j=void 0,e.$5j=(0,h.$Ah)("fileService");function $(T){return T.create===!0}e.$6j=$;var p;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var f;(function(T){T[T.Readonly=1]="Readonly",T[T.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileAtomicWrite=32768]="FileAtomicWrite",T[T.FileAtomicDelete=65536]="FileAtomicDelete",T[T.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function w(T){return!!(T.capabilities&2)}e.$7j=w;function g(T){return!!(T.capabilities&8)}e.$8j=g;function c(T){return!!(T.capabilities&131072)}e.$9j=c;function a(T){return!!(T.capabilities&4)}e.$0j=a;function m(T){return!!(T.capabilities&16)}e.$$j=m;function E(T){return w(T)?!!(T.capabilities&16384):!1}e.$_j=E;function d(T){return w(T)?!!(T.capabilities&32768):!1}e.$ak=d;function t(T){return!!(T.capabilities&65536)}e.$bk=t;function u(T){return!!(T.capabilities&2048)}e.$ck=u;var r;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsStorageQuota="EntryExceedsStorageQuota",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(H,Q){const x=new i(H.toString(),Q);return k(x,Q),x}constructor(H,Q){super(H),this.code=Q}}e.$dk=i;function n(T,H){return i.create(T,H)}e.$ek=n;function o(T){return T||n((0,S.localize)(0,null),r.Unknown)}e.$fk=o;function k(T,H){return T.name=H?`${H} (FileSystemError)`:"FileSystemError",T}e.$gk=k;function I(T){if(!T)return r.Unknown;if(T instanceof i)return T.code;const H=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!H)return r.Unknown;switch(H[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$hk=I;function D(T){if(T instanceof se)return T.fileOperationResult;switch(I(T)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$ik=D;var v;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(v||(e.FileOperation=v={}));class R{constructor(H,Q,x){this.resource=H,this.operation=Q,this.target=x}isOperation(H){return this.operation===H}}e.$jk=R;var j;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class N{constructor(H,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const x=new Map;for(const ce of H){const Y=x.get(ce.type);switch(Y?Y.push([ce.resource,ce]):x.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,Y]of x)switch(ce){case 1:this.a=P.$Gh.forUris(()=>Q),this.a.fill(Y);break;case 0:this.b=P.$Gh.forUris(()=>Q),this.b.fill(Y);break;case 2:this.c=P.$Gh.forUris(()=>Q),this.c.fill(Y);break}}contains(H,...Q){return this.d(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.d(H,{includeChildren:!0},...Q)}d(H,Q,...x){if(!H)return!1;const ce=x.length>0;return!!((!ce||x.includes(1))&&(this.a?.get(H)||Q.includeChildren&&this.a?.findSuperstr(H))||(!ce||x.includes(0))&&(this.b?.get(H)||Q.includeChildren&&this.b?.findSuperstr(H))||(!ce||x.includes(2))&&(this.c?.findSubstr(H)||Q.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$kk=N;function z(T,H,Q){return!T||!H||T===H||H.length>T.length?!1:(H.charAt(H.length-1)!==O.sep&&(H+=O.sep),Q?(0,s.$Me)(T,H):T.indexOf(H)===0)}e.$lk=z;class se extends Error{constructor(H,Q,x){super(H),this.fileOperationResult=Q,this.options=x}}e.$mk=se;class ee extends se{constructor(H,Q,x,ce){super(H,Q,ce),this.fileOperationResult=Q,this.size=x}}e.$nk=ee;class ae extends se{constructor(H,Q,x){super(H,2,x),this.stat=Q}}e.$ok=ae;var ne;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$rk="files.associations",e.$sk="files.exclude",e.$tk="files.readonlyInclude",e.$uk="files.readonlyExclude",e.$vk="files.readonlyFromPermissions";var oe;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(oe||(e.FileKind=oe={})),e.$wk="";function G(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.$xk=G;async function K(T,H){if(!H.hasProvider(A.URI.from({scheme:T.scheme})))return new Promise(Q=>{const x=H.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===T.scheme&&ce.added&&(x.dispose(),Q())})})}e.$yk=K;class B{static{this.KB=1024}static{this.MB=B.KB*B.KB}static{this.GB=B.MB*B.KB}static{this.TB=B.GB*B.KB}static formatSize(H){return(0,M.$mf)(H)||(H=0),H<B.KB?(0,S.localize)(1,null,H.toFixed(0)):H<B.MB?(0,S.localize)(2,null,(H/B.KB).toFixed(2)):H<B.GB?(0,S.localize)(3,null,(H/B.MB).toFixed(2)):H<B.TB?(0,S.localize)(4,null,(H/B.GB).toFixed(2)):(0,S.localize)(5,null,(H/B.TB).toFixed(2))}}e.$zk=B;function F(T){const H=typeof T=="string"||T?.scheme===b.Schemas.vscodeRemote;return typeof T!="string"&&T?.scheme===b.Schemas.file?1024*B.MB:H?10*B.MB:l.$o?50*B.MB:1024*B.MB}e.$Ak=F}),define(te[211],ie([0,1,17,50,14,3,2,56,7,31,16]),function(J,e,P,O,s,M,A,S,h,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=void 0,e.$1M="localFilesystem";class $ extends A.$jc{constructor(f,y){super(),this.a=f,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$ed),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$ed),this.onDidWatchError=this.g.event,this.h=(0,l.$3f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,y){const{buffer:w}=await this.a.call("readFile",[f,y]);return w}readFileStream(f,y,w){const g=(0,S.$sd)(a=>P.$Ed.concat(a.map(m=>P.$Ed.wrap(m))).buffer),c=new A.$ic;return c.add(this.a.listen("readFileStream",[f,y])(a=>{if(a instanceof P.$Ed)g.write(a.buffer);else{if(a==="end")g.end();else{let m;if(a instanceof Error)m=a;else{const E=a;m=(0,b.$ek)(E.message??(0,O.$li)(E),E.code??b.FileSystemProviderErrorCode.Unknown)}g.error(m),g.end()}c.dispose()}})),c.add(w.onCancellationRequested(()=>{g.error((0,s.$4)()),g.end(),c.dispose()})),g}writeFile(f,y,w){return this.a.call("writeFile",[f,P.$Ed.wrap(y),w])}open(f,y){return this.a.call("open",[f,y])}close(f){return this.a.call("close",[f])}async read(f,y,w,g,c){const[a,m]=await this.a.call("read",[f,y,c]);return w.set(a.buffer.slice(0,m),g),m}write(f,y,w,g,c){return this.a.call("write",[f,y,P.$Ed.wrap(w),g,c])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,y){return this.a.call("delete",[f,y])}rename(f,y,w){return this.a.call("rename",[f,y,w])}copy(f,y,w){return this.a.call("copy",[f,y,w])}cloneFile(f,y){return this.a.call("cloneFile",[f,y])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const y=f;this.f.fire(y.map(w=>({resource:h.URI.revive(w.resource),type:w.type})))}else{const y=f;this.g.fire(y)}}))}watch(f,y){const w=(0,l.$3f)();return this.a.call("watch",[this.h,w,f,y]),(0,A.$hc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$2M=$}),define(te[118],ie([0,1,17,14,176,16]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function A(b,$,p,f,y,w){let g;try{await S(b,$,p,f,y,w)}catch(c){g=c}finally{g&&y.errorTransformer&&(g=y.errorTransformer(g)),typeof g<"u"&&p.error(g),p.end()}}e.$Ap=A;async function S(b,$,p,f,y,w){h(w);const g=await b.open($,{create:!1});try{h(w);let c=0,a=0,m=y&&typeof y.length=="number"?y.length:void 0,E=P.$Ed.alloc(Math.min(y.bufferSize,typeof m=="number"?m:y.bufferSize)),d=y&&typeof y.position=="number"?y.position:0,t=0;do a=await b.read(g,d,E.buffer,t,E.byteLength-t),d+=a,t+=a,c+=a,typeof m=="number"&&(m-=a),t===E.byteLength&&(await p.write(f(E)),E=P.$Ed.alloc(Math.min(y.bufferSize,typeof m=="number"?m:y.bufferSize)),t=0);while(a>0&&(typeof m!="number"||m>0)&&h(w)&&l(c,y));if(t>0){let u=t;typeof m=="number"&&(u=Math.min(t,m)),p.write(f(E.slice(0,u)))}}catch(c){throw(0,M.$fk)(c)}finally{await b.close(g)}}function h(b){if(b.isCancellationRequested)throw(0,O.$4)();return!0}function l(b,$){if(typeof $?.limits?.size=="number"&&b>$.limits.size)throw(0,M.$ek)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[76],ie([0,1,104,2,9,4,7,16]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=void 0;function h(c){return c.recursive===!0}e.$Cp=h;class l extends O.$jc{static{this.a=5}constructor(a,m,E,d){super(),this.h=a,this.j=m,this.m=E,this.n=d,this.c=this.B(new O.$kc),this.f=void 0,this.g=0}s(){const a=new O.$ic;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile(m=>this.h(m))),a.add(this.b.onDidLogMessage(m=>this.j(m))),a.add(this.b.onDidError(m=>this.t(m)))}t(a){this.n.restartOnError?this.g<l.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Dp=l;class b extends l{constructor(a,m,E){super(a,m,E,{type:"node.js",restartOnError:!1})}}e.$Ep=b;class $ extends l{constructor(a,m,E){super(a,m,E,{type:"universal",restartOnError:!0})}}e.$Fp=$;function p(c){return c.map(a=>({type:a.type,resource:A.URI.file(a.path)}))}e.$Gp=p;function f(c){const a=new g;for(const m of c)a.processEvent(m);return a.coalesce()}e.$Hp=f;function y(c,a){return typeof a=="string"&&!a.startsWith(P.$mj)&&!(0,s.$7d)(a)?{base:c,pattern:a}:a}e.$Ip=y;function w(c,a){const m=[];for(const E of a)m.push((0,P.$qj)(y(c,E)));return m}e.$Jp=w;class g{constructor(){this.a=new Set,this.b=new Map}c(a){return M.$k?a.path:a.path.toLowerCase()}processEvent(a){const m=this.b.get(this.c(a));let E=!1;if(m){const d=m.type,t=a.type;m.path!==a.path&&(a.type===2||a.type===1)?E=!0:d===1&&t===2?(this.b.delete(this.c(a)),this.a.delete(m)):d===2&&t===1?m.type=0:d===1&&t===0||(m.type=t)}else E=!0;E&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],m=[];return Array.from(this.a).filter(E=>E.type!==2?(a.push(E),!1):!0).sort((E,d)=>E.path.length-d.path.length).filter(E=>m.some(d=>(0,S.$lk)(E.path,d,!M.$k))?!1:(m.push(E.path),!0)).concat(a)}}}),define(te[212],ie([0,1,45,8,22,32,2,85,9,4,105,21,76]),function(J,e,P,O,s,M,A,S,h,l,b,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;class f extends A.$jc{static{this.a=100}static{this.b=75}constructor(g,c,a,m){super(),this.m=g,this.n=c,this.r=a,this.s=m,this.c=this.B(new O.$Ug({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.n(E))),this.f=this.B(new O.$Tg(E=>this.z(E),f.b)),this.g=(0,p.$Jp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,p.$Jp)(this.m.path,this.m.includes):void 0,this.j=new s.$od,this.ready=this.t()}async t(){try{const g=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const c=await $.Promises.stat(g);this.B(await this.w(g,c.isDirectory()))}catch(g){g.code!=="ENOENT"?this.D(g):this.G(g)}}async u(g){let c=g.path;try{c=await $.Promises.realpath(g.path),g.path===c&&(c=await(0,b.$Tp)(g.path)??g.path),g.path!==c&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${c})`)}catch{}return c}async w(g,c){if(l.$j&&(0,M.$Hf)(g,"/Volumes/",!0))return this.D(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$jc.None;const a=new s.$od(this.j.token),m=new A.$ic;try{const E=(0,h.$_d)(g),d=(0,P.watch)(g);m.add((0,A.$hc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${g}'`);const t=new Set;if(c)try{for(const r of await $.Promises.readdir(g))t.add(r)}catch(r){this.D(r)}const u=new Map;m.add((0,A.$hc)(()=>{for(const[,r]of u)r.dispose();u.clear()})),d.on("error",(r,i)=>{this.D(`Failed to watch ${g} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),d.on("change",(r,i)=>{if(a.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${i}`);let n="";if(i&&(n=i.toString(),l.$j&&(n=(0,S.$gl)(n))),!(!n||r!=="change"&&r!=="rename"))if(c)if(r==="rename"){u.get(n)?.dispose();const o=setTimeout(async()=>{if(u.delete(n),n===E&&!await $.Promises.exists(g)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,h.$8d)(g,n));if(a.token.isCancellationRequested)return;let I;k?t.has(n)?I=0:(I=1,t.add(n)):(t.delete(n),I=2),this.y({path:(0,h.$8d)(this.m.path,n),type:I})},f.a);u.set(n,(0,A.$hc)(()=>clearTimeout(o)))}else{let o;t.has(n)?o=0:(o=1,t.add(n)),this.y({path:(0,h.$8d)(this.m.path,n),type:o})}else if(r==="rename"||n!==E){const o=setTimeout(async()=>{const k=await $.Promises.exists(g);a.token.isCancellationRequested||(k?(this.y({path:this.m.path,type:0},!0),m.add(await this.w(g,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);m.clear(),m.add((0,A.$hc)(()=>clearTimeout(o)))}else this.y({path:this.m.path,type:0},!0)})}catch(E){await $.Promises.exists(g)&&!a.token.isCancellationRequested&&this.D(`Failed to watch ${g} for changes using fs.watch() (${E.toString()})`)}return(0,A.$hc)(()=>{a.dispose(!0),m.dispose()})}y(g,c=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!c&&this.g.some(a=>a(g.path))?this.s&&this.G(` >> ignored (excluded) ${g.path}`):!c&&this.h&&this.h.length>0&&!this.h.some(a=>a(g.path))?this.s&&this.G(` >> ignored (not included) ${g.path}`):this.f.work(g))}z(g){const c=(0,p.$Hp)(g);if(c.length>0){if(this.s)for(const m of c)this.G(`>> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`);this.c.work(c)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(g){if(l.$k)return $.Promises.exists(g);try{const c=(0,h.$_d)(g);return(await $.Promises.readdir((0,h.$$d)(g))).some(m=>m===c)}catch(c){return this.G(c),!1}}setVerboseLogging(g){this.s=g}D(g){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}F(g){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}G(g){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Wp=f;async function y(w,g,c,a,m=512){const E=await $.Promises.open(w,"r"),d=Buffer.allocUnsafe(m),t=new s.$od(a);let u,r=!1;const i={path:w,excludes:[],recursive:!1},n=new f(i,o=>{(async()=>{for(const{type:k}of o)if(k===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await $.Promises.read(E,d,0,m,null);if(!I||t.token.isCancellationRequested)break;g(d.slice(0,I))}}catch(I){u=new Error(I),t.dispose(!0)}finally{r=!1}}})()});return await n.ready,c(),new Promise((o,k)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await $.Promises.close(E)}catch(I){u=new Error(I)}u?k(u):o()})})}e.$Xp=y}),define(te[213],ie([0,1,3,104,2,4,212]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class S extends s.$jc{constructor(){super(...arguments),this.a=this.B(new P.$ed),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$ed),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(l){const b=this.j(l),$=b.filter(f=>{const y=this.c.get(f.path);return y?!(0,O.$uj)(y.request.excludes,f.excludes)||!(0,O.$uj)(y.request.includes,f.includes):!0}),p=Array.from(this.c.values()).filter(({request:f})=>!b.find(y=>y.path===f.path&&(0,O.$uj)(y.excludes,f.excludes)&&(0,O.$uj)(y.includes,f.includes))).map(({request:f})=>f.path);$.length&&this.m(`Request to start watching: ${$.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const f of p)this.h(f);for(const f of $)this.g(f)}g(l){const b=new A.$Wp(l,p=>this.a.fire(p),p=>this.b.fire(p),this.f),$={request:l,instance:b};this.c.set(l.path,$)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const b=this.c.get(l);b&&(this.c.delete(l),b.instance.dispose())}j(l){const b=new Map;for(const $ of l){const p=M.$k?$.path:$.path.toLowerCase();b.set(p,$)}return Array.from(b.values())}async setVerboseLogging(l){this.f=l;for(const[,b]of this.c)b.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,b){return b?`[File Watcher (node.js)] ${l} (path: ${b.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Yp=S}),define(te[214],ie([0,1,76,213]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class s extends P.$Ep{constructor(A,S,h){super(A,S,h),this.s()}r(A){return A.add(new O.$Yp)}}e.$Zp=s}),define(te[215],ie([0,1,13,42,159,76]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class A extends M.$Fp{constructor(h,l,b){super(h,l,b),this.s()}r(h){const l=h.add(new s.$Qp(P.$1f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:b,signal:$})=>this.t(`terminated by itself with code ${b}, signal: ${$}`))),O.ProxyChannel.toService((0,O.$hh)(l.getChannel("watcher")))}}e.$Rp=A}),define(te[92],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class P{constructor(...s){this.a=new Map;for(const[M,A]of s)this.set(M,A)}set(s,M){const A=this.a.get(s);return this.a.set(s,M),A}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$yh=P}),define(te[216],ie([0,1,8,14,2,75,207,6,92,101]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;const b=!1;class $ extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class p{constructor(g=new h.$yh,c=!1,a,m=b){this.f=g,this.g=c,this.h=a,this.i=m,this.o=new Set,this.f.set(S.$zh,this),this._globalGraph=m?a?._globalGraph??new A.$3p(E=>E):void 0}createChild(g){return new p(g,this.g,this,this.i)}invokeFunction(g,...c){const a=y.traceInvocation(this.i,g);let m=!1;try{return g({get:d=>{if(m)throw(0,O.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(d,a);if(!t)throw new Error(`[invokeFunction] unknown service '${d}'`);return t}},...c)}finally{m=!0,a.stop()}}createInstance(g,...c){let a,m;return g instanceof M.$xh?(a=y.traceCreation(this.i,g.ctor),m=this.j(g.ctor,g.staticArguments.concat(c),a)):(a=y.traceCreation(this.i,g),m=this.j(g,c,a)),a.stop(),m}j(g,c=[],a){const m=S._util.getServiceDependencies(g).sort((t,u)=>t.index-u.index),E=[];for(const t of m){const u=this.m(t.id,a);u||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(u)}const d=m.length>0?m[0].index:c.length;if(c.length!==d){console.trace(`[createInstance] First service dependency of ${g.name} at position ${d+1} conflicts with ${c.length} static arguments`);const t=d-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,d)}return Reflect.construct(g,c.concat(E))}k(g,c){if(this.f.get(g)instanceof M.$xh)this.f.set(g,c);else if(this.h)this.h.k(g,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const c=this.f.get(g);return!c&&this.h?this.h.l(g):c}m(g,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const a=this.l(g);return a instanceof M.$xh?this.q(g,a,c.branch(g,!0)):(c.branch(g,!1),a)}q(g,c,a){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,c,a)}finally{this.o.delete(g)}}r(g,c,a){const m=new A.$3p(t=>t.id.toString());let E=0;const d=[{id:g,desc:c,_trace:a}];for(;d.length;){const t=d.pop();if(m.lookupOrInsertNode(t),E++>1e3)throw new $(m);for(const u of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(u.id);if(r||this.u(`[createInstance] ${g} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),r instanceof M.$xh){const i={id:u.id,desc:r,_trace:t._trace.branch(u.id,!0)};m.insertEdge(t,i),d.push(i)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new $(m);break}for(const{data:u}of t){if(this.l(u.id)instanceof M.$xh){const i=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,i)}m.removeNode(u)}}return this.l(g)}s(g,c,a=[],m,E){if(this.f.get(g)instanceof M.$xh)return this.t(g,c,a,m,E);if(this.h)return this.h.s(g,c,a,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(g,c,a=[],m,E){if(m){const d=new p(void 0,this.g,this,this.i);d.c=String(g);const t=new Map,u=new P.$Wg(()=>{const r=d.j(c,a,E);for(const[i,n]of t){const o=r[i];if(typeof o=="function")for(const k of n)o.apply(r,k)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!u.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let k=t.get(i);return k||(k=new l.$sc,t.set(i,k)),(D,v,R)=>{const j=k.push([D,v,R]);return(0,s.$hc)(j)}}if(i in r)return r[i];const n=u.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),r[i]=o),o},set(r,i,n){return u.value[i]=n,!0},getPrototypeOf(r){return c.prototype}})}else return this.j(c,a,E)}u(g,c){if(c&&console.warn(g),this.g)throw new Error(g)}}e.$4p=p;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,c){return g?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(g,c){return g?new y(1,c.name):y.c}static{this.f=0}constructor(g,c){this.type=g,this.name=c,this.g=Date.now(),this.h=[]}branch(g,c){const a=new y(3,g.toString());return this.h.push([g,c,a]),a}stop(){const g=Date.now()-this.g;y.f+=g;let c=!1;function a(E,d){const t=[],u=new Array(E+1).join("	");for(const[r,i,n]of d.h)if(i&&n){c=!0,t.push(`${u}CREATES -> ${r}`);const o=a(E+1,n);o&&t.push(o)}else t.push(`${u}uses -> ${r}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(g>2||c)&&y.all.add(m.join(`
`))}}e.$5p=y}),define(te[217],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$btb=e.IssueType=void 0;var O;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(O||(e.IssueType=O={})),e.$btb=(0,P.$Ah)("issueService")}),define(te[5],ie([0,1,50,3,57,2,34,4,19,12,7,114,6]),function(J,e,P,O,s,M,A,S,h,l,b,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,p.$Ah)("logService"),e.$5i=(0,p.$Ah)("loggerService");function f(){return new Date().toISOString()}function y(D){return(0,l.$mf)(D)}e.$6i=y;var w;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$7i=w.Info;function g(D,v,R){switch(v){case w.Trace:D.trace(R);break;case w.Debug:D.debug(R);break;case w.Info:D.info(R);break;case w.Warning:D.warn(R);break;case w.Error:D.error(R);break;case w.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=g;function c(D,v=!1){let R="";for(let j=0;j<D.length;j++){let N=D[j];if(N instanceof Error&&(N=(0,P.$li)(N,v)),typeof N=="object")try{N=JSON.stringify(N)}catch{}R+=(j>0?" ":"")+N}return R}class a extends M.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new O.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==w.Off&&this.b<=v}}e.$9i=a;class m extends a{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...R){this.f(w.Trace)&&this.g(w.Trace,c([v,...R],!0))}debug(v,...R){this.f(w.Debug)&&this.g(w.Debug,c([v,...R]))}info(v,...R){this.f(w.Info)&&this.g(w.Info,c([v,...R]))}warn(v,...R){this.f(w.Warning)&&this.g(w.Warning,c([v,...R]))}error(v,...R){if(this.f(w.Error))if(v instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=v.stack,this.g(w.Error,c(j))}else this.g(w.Error,c([v,...R]))}flush(){}}e.$0i=m;class E extends a{constructor(v=e.$7i){super(),this.setLevel(v),this.g=!S.$i}trace(v,...R){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...R):console.log(`[main ${f()}]`,v,...R))}debug(v,...R){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...R):console.log(`[main ${f()}]`,v,...R))}info(v,...R){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...R):console.log(`[main ${f()}]`,v,...R))}warn(v,...R){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,v,...R):console.warn(`[main ${f()}]`,v,...R))}error(v,...R){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,v,...R):console.error(`[main ${f()}]`,v,...R))}dispose(){}flush(){}}e.$$i=E;class d extends a{constructor(v=e.$7i,R=!0){super(),this.g=R,this.setLevel(v)}trace(v,...R){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...R):console.log(v,...R))}debug(v,...R){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...R):console.log(v,...R))}info(v,...R){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...R):console.log(v,...R))}warn(v,...R){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...R):console.log(v,...R))}error(v,...R){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...R):console.error(v,...R))}dispose(){}flush(){}}e.$_i=d;class t extends a{constructor(v,R=e.$7i){super(),this.g=v,this.setLevel(R)}trace(v,...R){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(v),...R])}debug(v,...R){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(v),...R])}info(v,...R){this.f(w.Info)&&this.g.log(w.Info,[this.h(v),...R])}warn(v,...R){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(v),...R])}error(v,...R){this.f(w.Error)&&this.g.log(w.Error,[this.h(v),...R])}h(v){return typeof v=="string"?v:(0,P.$li)(v,this.f(w.Trace))}dispose(){}flush(){}}e.$aj=t;class u extends a{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const R of this.g)R.setLevel(v);super.setLevel(v)}trace(v,...R){for(const j of this.g)j.trace(v,...R)}debug(v,...R){for(const j of this.g)j.debug(v,...R)}info(v,...R){for(const j of this.g)j.info(v,...R)}warn(v,...R){for(const j of this.g)j.warn(v,...R)}error(v,...R){for(const j of this.g)j.error(v,...R)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose()}}e.$bj=u;class r extends M.$jc{constructor(v,R,j){if(super(),this.h=v,this.j=R,this.b=new A.$yi,this.c=this.B(new O.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$ed),this.onDidChangeVisibility=this.g.event,j)for(const N of j)this.b.set(N.resource,{logger:void 0,info:N})}m(v){return(0,l.$if)(v)?[...this.b.values()].find(R=>R.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,R){const j=this.n(v),N=(0,l.$if)(v)?v:R?.id??(0,s.$oi)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const se=R?.logLevel==="always"?w.Trace:R?.logLevel;z||(z=this.s(j,se??this.getLogLevel(j)??this.h,{...R,id:N}));const ee={logger:z,info:{resource:j,id:N,logLevel:se,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(ee.info),this.b.set(j,ee),z}n(v){return(0,l.$if)(v)?(0,h.$hg)(this.j,`${v}.log`):v}setLogLevel(v,R){if(b.URI.isUri(v)){const j=v,N=R,z=this.b.get(j);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([j,N]))}else{this.h=v;for(const[j,N]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,R){const j=this.m(v);j&&R!==!j.info.hidden&&(j.info.hidden=!R,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,R]))}getLogLevel(v){let R;return v&&(R=this.b.get(v)?.info.logLevel),R??this.h}registerLogger(v){const R=this.b.get(v.resource);R?R.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const R=this.b.get(v);R&&(R.logger&&R.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=r;class i{constructor(){this.onDidChangeLogLevel=new O.$ed().event}setLevel(v){}getLevel(){return w.Info}trace(v,...R){}debug(v,...R){}info(v,...R){}warn(v,...R){}error(v,...R){}critical(v,...R){}dispose(){}flush(){}}e.$dj=i;class n extends i{}e.$ej=n;function o(D){if(D.verbose)return w.Trace;if(typeof D.logLevel=="string"){const v=I(D.logLevel.toLowerCase());if(v!==void 0)return v}return e.$7i}e.$fj=o;function k(D){switch(D){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$gj=k;function I(D){switch(D){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$hj=I,e.$ij=new $.$1i("logLevel",k(w.Info))});var _=this&&this.__param||function(J,e){return function(P,O){e(P,O,J)}};define(te[218],ie([0,1,15,4,5]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D5b=void 0;const M=P.safeStorage;let A=class{constructor(h){this.a=h,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(M.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(h){let l;try{if(l=JSON.parse(h),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const b=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const $=M.decryptString(b);return this.a.trace("[EncryptionMainService] Decrypted value."),$}catch(b){throw this.a.error(b),b}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(O.$i)return Promise.resolve("dpapi");if(O.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const h=M.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(O.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(O.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$D5b=A,e.$D5b=A=ke([_(0,s.$4i)],A)}),define(te[219],ie([0,1,23,8,14,3,2,9,76,5]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class b extends A.$jc{constructor(p,f){super(),this.a=p,this.b=f,this.c=this.B(new M.$ed),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$ed),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$Dg(0)),this.w=[],this.y=this.B(new O.$Dg(0))}watch(p,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(p,f):this.z(p,f)}n(p,f){const y={path:this.H(p),excludes:f.excludes,includes:f.includes,recursive:f.recursive},w=(0,P.$Rb)(this.j,y);return this.r(),(0,A.$hc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$Y)(p))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Gp)(f)),f=>this.G(f),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const f of this.j)(0,h.$Cp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const f of this.j)(0,h.$Cp)(f)&&p.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,f){const y={path:this.H(p),excludes:f.excludes,includes:f.includes,recursive:!1},w=(0,P.$Rb)(this.w,y);return this.C(),(0,A.$hc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,h.$Gp)(p)),p=>this.G(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,S.$6d)(p.fsPath)}}e.$Kp=b}),define(te[220],ie([0,1,23,8,17,22,3,57,68,2,58,13,65,19,56,174,16,118,5,14]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;let E=class extends l.$jc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new A.$ed),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$ed),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$ed),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$ed),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$ed),this.onDidFilesChange=this.X.event,this.Y=this.B(new A.$ed),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new O.$Og)}registerProvider(t,u){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const r=new l.$ic;return this.h.set(t,u),this.c.fire({added:!0,scheme:t,provider:u}),r.add(u.onDidChangeFile(i=>this.X.fire(new g.$kk(i,!this.S(u))))),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(i=>this.Y.fire(new Error(i)))),r.add(u.onDidChangeCapabilities(()=>this.g.fire({provider:u,scheme:t}))),(0,l.$hc)(()=>{this.c.fire({added:!1,scheme:t,provider:u}),this.h.delete(t),(0,l.$ec)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const u=[];this.f.fire({scheme:t,join(r){u.push(r)}}),!this.h.has(t)&&await O.Promises.settled(u)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,u){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return h.Iterable.map(this.h,([t,u])=>({scheme:t,capabilities:u.capabilities}))}async j(t){if(!(0,f.$lg)(t))throw new g.$mk((0,w.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const u=this.h.get(t.scheme);if(!u){const r=new m.$_;throw r.message=(0,w.localize)(1,null,t.toString()),r}return u}async m(t){const u=await this.j(t);if((0,g.$0j)(u)||(0,g.$7j)(u)||(0,g.$$j)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const u=await this.j(t);if((0,g.$0j)(u)||(0,g.$7j)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,u){try{return await this.s(t,u)}catch(r){throw(0,g.$hk)(r)===g.FileSystemProviderErrorCode.FileNotFound?new g.$mk((0,w.localize)(2,null,this.rb(t)),1):(0,g.$fk)(r)}}async s(t,u){const r=await this.j(t),i=this.S(r),n=u?.resolveTo,o=u?.resolveSingleChildDescendants,k=u?.resolveMetadata,I=await r.stat(t);let D;return this.t(r,t,I,void 0,!!k,(v,R)=>(D||(D=b.$Gh.forUris(()=>!i),D.set(t,!0),n&&D.fill(!0,n)),D.get(v.resource)||D.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&o?R===1:!1))}async t(t,u,r,i,n,o){const{providerExtUri:k}=this.R(t),I={resource:u,name:k.basename(u),isFile:(r.type&g.FileType.File)!==0,isDirectory:(r.type&g.FileType.Directory)!==0,isSymbolicLink:(r.type&g.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&g.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&g.FilePermission.Locked),etag:(0,g.$xk)({mtime:r.mtime,size:r.size}),children:void 0};if(I.isDirectory&&o(I,i)){try{const D=await t.readdir(u),v=await O.Promises.settled(D.map(async([R,j])=>{try{const N=k.joinPath(u,R),z=n?await t.stat(N):{type:j};return await this.t(t,N,z,D.length,n,o)}catch(N){return this.b.trace(N),null}}));I.children=(0,P.$Eb)(v)}catch(D){this.b.trace(D),I.children=[]}return I}return I}async resolveAll(t){return O.Promises.settled(t.map(async u=>{try{return{stat:await this.s(u.resource,u.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const u=await this.j(t),r=await u.stat(t);return this.t(u,t,r,void 0,!0,()=>!1)}async exists(t){const u=await this.j(t);try{return!!await u.stat(t)}catch{return!1}}async canCreateFile(t,u){try{await this.u(t,u)}catch(r){return r}return!0}async u(t,u){if(!u?.overwrite&&await this.exists(t))throw new g.$mk((0,w.localize)(3,null,this.rb(t)),3,u)}async createFile(t,u=s.$Ed.fromString(""),r){await this.u(t,r);const i=await this.writeFile(t,u);return this.r.fire(new g.$jk(t,0,i)),i}async writeFile(t,u,r){const i=this.pb(await this.n(t),t),{providerExtUri:n}=this.R(i);try{await this.w(i,t,r)||await this.U(i,n.dirname(t));let k;if((0,g.$7j)(i)&&!(u instanceof s.$Ed))if((0,y.$qd)(u)){const I=await(0,y.$xd)(u,3);I.ended?k=s.$Ed.concat(I.buffer):k=I}else k=(0,y.$ud)(u,I=>s.$Ed.concat(I),3);else k=u;if(!(0,g.$0j)(i)||(0,g.$7j)(i)&&k instanceof s.$Ed)await this.gb(i,t,r,k);else{const I=k instanceof s.$Ed?(0,s.$Pd)(k):k;r?.atomic!==!1&&r?.atomic?.postfix?await this.bb(i,t,(0,f.$hg)((0,f.$gg)(t),`${(0,f.$eg)(t)}${r.atomic.postfix}`),r,I):await this.cb(i,t,r,I)}this.r.fire(new g.$jk(t,4))}catch(o){throw new g.$mk((0,w.localize)(4,null,this.rb(t),(0,g.$fk)(o).toString()),(0,g.$ik)(o),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,u,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.rb(u)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.rb(u)));if(i)throw new Error((0,w.localize)(7,null,this.rb(u)))}let o;try{o=await t.stat(u)}catch{return}if(o.type&g.FileType.Directory)throw new g.$mk((0,w.localize)(8,null,this.rb(u)),0,r);if(this.qb(u,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==g.$wk&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,g.$xk)({mtime:r.mtime,size:o.size}))throw new g.$mk((0,w.localize)(9,null),3,r);return o}async readFile(t,u,r){const i=await this.m(t);return u?.atomic?this.z(i,t,u,r):this.C(i,t,u,r)}async z(t,u,r,i){return new Promise((n,o)=>{this.ab.queueFor(u,this.R(t).providerExtUri).queue(async()=>{try{const k=await this.C(t,u,r,i);n(k)}catch(k){o(k)}})})}async C(t,u,r,i){const n=await this.D(t,u,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$Qd)(n.value)}}async readFileStream(t,u,r){const i=await this.m(t);return this.D(i,t,u,r)}async D(t,u,r,i){const n=new M.$od(i),o=this.J(u,r).then(I=>I,I=>{throw n.dispose(!0),I});let k;try{return typeof r?.etag=="string"&&r.etag!==g.$wk&&await o,r?.atomic&&(0,g.$_j)(t)||!((0,g.$0j)(t)||(0,g.$$j)(t))||(0,g.$7j)(t)&&r?.preferUnbuffered?k=this.I(t,u,r):(0,g.$$j)(t)?k=this.G(t,u,n.token,r):k=this.H(t,u,n.token,r),k.on("end",()=>n.dispose()),k.on("error",()=>n.dispose()),{...await o,value:k}}catch(I){throw k&&await(0,y.$vd)(k),this.F(I,u,r)}}F(t,u,r){const i=(0,w.localize)(10,null,this.rb(u),(0,g.$fk)(t).toString());return t instanceof g.$ok?new g.$ok(i,t.stat,r):t instanceof g.$nk?new g.$nk(i,t.fileOperationResult,t.size,t.options):new g.$mk(i,(0,g.$ik)(t),r)}G(t,u,r,i=Object.create(null)){const n=t.readFileStream(u,i,r);return(0,y.$Bd)(n,{data:o=>o instanceof s.$Ed?o:s.$Ed.wrap(o),error:o=>this.F(o,u,i)},o=>s.$Ed.concat(o))}H(t,u,r,i=Object.create(null)){const n=(0,s.$Ud)();return(0,c.$Ap)(t,u,n,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.F(o,u,i)},r),n}I(t,u,r){const i=(0,y.$sd)(n=>s.$Ed.concat(n));return(async()=>{try{let n;r?.atomic&&(0,g.$_j)(t)?n=await t.readFile(u,{atomic:!0}):n=await t.readFile(u),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.L(u,n.byteLength,r),i.end(s.$Ed.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,u){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new g.$mk((0,w.localize)(11,null,this.rb(t)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.$wk&&u.etag===r.etag)throw new g.$ok((0,w.localize)(12,null),r,u);return this.L(t,r.size,u),r}L(t,u,r){if(typeof r?.limits?.size=="number"&&u>r.limits.size)throw new g.$nk((0,w.localize)(13,null,this.rb(t)),7,u,r)}async canMove(t,u,r){return this.M(t,u,"move",r)}async canCopy(t,u,r){return this.M(t,u,"copy",r)}async M(t,u,r,i){if(t.toString()!==u.toString())try{const n=r==="move"?this.pb(await this.n(t),t):await this.m(t),o=this.pb(await this.n(u),u);await this.Q(n,t,o,u,r,i)}catch(n){return n}return!0}async move(t,u,r){const i=this.pb(await this.n(t),t),n=this.pb(await this.n(u),u),o=await this.N(i,t,n,u,"move",!!r),k=await this.resolve(u,{resolveMetadata:!0});return this.r.fire(new g.$jk(t,o==="move"?2:3,k)),k}async copy(t,u,r){const i=await this.m(t),n=this.pb(await this.n(u),u),o=await this.N(i,t,n,u,"copy",!!r),k=await this.resolve(u,{resolveMetadata:!0});return this.r.fire(new g.$jk(t,o==="copy"?3:2,k)),k}async N(t,u,r,i,n,o){if(u.toString()===i.toString())return n;const{exists:k,isSameResourceWithDifferentPathCase:I}=await this.Q(t,u,r,i,n,o);if(k&&!I&&o&&await this.del(i,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,g.$8j)(t))await t.copy(u,i,{overwrite:o});else{const D=await this.resolve(u);D.isDirectory?await this.P(t,D,r,i):await this.O(t,u,r,i)}return n}else return t===r?(await t.rename(u,i,{overwrite:o}),n):(await this.N(t,u,r,i,"copy",o),await this.del(u,{recursive:!0}),"copy")}async O(t,u,r,i){if((0,g.$0j)(t)&&(0,g.$0j)(r))return this.ib(t,u,r,i);if((0,g.$0j)(t)&&(0,g.$7j)(r))return this.ob(t,u,r,i);if((0,g.$7j)(t)&&(0,g.$0j)(r))return this.mb(t,u,r,i);if((0,g.$7j)(t)&&(0,g.$7j)(r))return this.kb(t,u,r,i)}async P(t,u,r,i){await r.mkdir(i),Array.isArray(u.children)&&await O.Promises.settled(u.children.map(async n=>{const o=this.R(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),r,o):this.O(t,n.resource,r,o)}))}async Q(t,u,r,i,n,o){let k=!1;if(t===r){const{providerExtUri:D,isPathCaseSensitive:v}=this.R(t);if(v||(k=D.isEqual(u,i)),k&&n==="copy")throw new Error((0,w.localize)(14,null,this.rb(u),this.rb(i)));if(!k&&D.isEqualOrParent(i,u))throw new Error((0,w.localize)(15,null,this.rb(u),this.rb(i)))}const I=await this.exists(i);if(I&&!k){if(!o)throw new g.$mk((0,w.localize)(16,null,this.rb(u),this.rb(i)),4);if(t===r){const{providerExtUri:D}=this.R(t);if(D.isEqualOrParent(u,i))throw new Error((0,w.localize)(17,null,this.rb(u),this.rb(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:k}}R(t){const u=this.S(t);return{providerExtUri:u?f.$0f:f.$_f,isPathCaseSensitive:u}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const u=this.pb(await this.j(t),t);await this.U(u,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$jk(t,0,r)),r}async U(t,u){const r=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(u,i.dirname(u));)try{if(!((await t.stat(u)).type&g.FileType.Directory))throw new Error((0,w.localize)(18,null,this.rb(u)));break}catch(n){if((0,g.$hk)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(u)),u=i.dirname(u)}for(let n=r.length-1;n>=0;n--){u=i.joinPath(u,r[n]);try{await t.mkdir(u)}catch(o){if((0,g.$hk)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,u){try{await this.W(t,u)}catch(r){return r}return!0}async W(t,u){const r=this.pb(await this.j(t),t),i=!!u?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,w.localize)(19,null,this.rb(t)));const n=u?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,w.localize)(20,null,this.rb(t)));if(i&&n)throw new Error((0,w.localize)(21,null,this.rb(t)));let o;try{o=await r.stat(t)}catch{}if(o)this.qb(t,o);else throw new g.$mk((0,w.localize)(22,null,this.rb(t)),1);if(!!!u?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,w.localize)(23,null,this.rb(t)))}return r}async del(t,u){const r=await this.W(t,u),i=!!u?.useTrash,n=!!u?.recursive,o=u?.atomic??!1;await r.delete(t,{recursive:n,useTrash:i,atomic:o}),this.r.fire(new g.$jk(t,1))}async cloneFile(t,u){const r=await this.j(t),i=this.pb(await this.n(u),u);if(r===i&&this.R(r).providerExtUri.isEqual(t,u))return;if(r===i&&(0,g.$9j)(r))return r.cloneFile(t,u);await this.U(i,this.R(i).providerExtUri.dirname(u));const n=this.ab.queueFor(t,this.R(r).providerExtUri);return r===i&&(0,g.$8j)(r)?n.queue(()=>r.copy(t,u,{overwrite:!0})):n.queue(()=>this.O(r,t,i,u))}watch(t,u={recursive:!1,excludes:[]}){const r=new l.$ic;let i=!1,n=()=>{i=!0};return r.add((0,l.$hc)(()=>n())),(async()=>{try{const o=await this.$(t,u);i?(0,l.$ec)(o):n=()=>(0,l.$ec)(o)}catch(o){this.b.error(o)}})(),r}async $(t,u){const r=await this.j(t),i=(0,S.$oi)([this.R(r).providerExtUri.getComparisonKey(t),u]);let n=this.Z.get(i);return n||(n={count:0,disposable:r.watch(t,u)},this.Z.set(i,n)),n.count+=1,(0,l.$hc)(()=>{n&&(n.count--,n.count===0&&((0,l.$ec)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,l.$ec)(t.disposable);this.Z.clear()}async bb(t,u,r,i,n){await this.cb(t,r,i,n);try{await t.rename(r,u,{overwrite:!0})}catch(o){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async cb(t,u,r,i){return this.ab.queueFor(u,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,y.$qd)(i)||(0,y.$rd)(i)?await this.db(t,n,i):await this.eb(t,n,i)}catch(o){throw(0,g.$fk)(o)}finally{await t.close(n)}})}async db(t,u,r){let i=0,n;if((0,y.$rd)(r)){if(r.buffer.length>0){const o=s.$Ed.concat(r.buffer);await this.fb(t,u,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,k)=>{(0,y.$wd)(n,{onData:async I=>{n.pause();try{await this.fb(t,u,I,I.byteLength,i,0)}catch(D){return k(D)}i+=I.byteLength,setTimeout(()=>n.resume())},onError:I=>k(I),onEnd:()=>o()})})}async eb(t,u,r){let i=0,n;for(;(n=r.read())!==null;)await this.fb(t,u,n,n.byteLength,i,0),i+=n.byteLength}async fb(t,u,r,i,n,o){let k=0;for(;k<i;){const I=await t.write(u,n+k,r.buffer,o+k,i-k);k+=I}}async gb(t,u,r,i){return this.ab.queueFor(u,this.R(t).providerExtUri).queue(()=>this.hb(t,u,r,i))}async hb(t,u,r,i){let n;i instanceof s.$Ed?n=i:(0,y.$qd)(i)?n=await(0,s.$Qd)(i):(0,y.$rd)(i)?n=await(0,s.$Rd)(i):n=(0,s.$Od)(i),await t.writeFile(u,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async ib(t,u,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.jb(t,u,r,i))}async jb(t,u,r,i){let n,o;try{n=await t.open(u,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const k=s.$Ed.alloc(this.a);let I=0,D=0,v=0;do v=await t.read(n,I,k.buffer,D,k.byteLength-D),await this.fb(r,o,k,v,I,D),I+=v,D+=v,D===k.byteLength&&(D=0);while(v>0)}catch(k){throw(0,g.$fk)(k)}finally{await O.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async kb(t,u,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.lb(t,u,r,i))}async lb(t,u,r,i){return r.writeFile(i,await t.readFile(u),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,u,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.nb(t,u,r,i))}async nb(t,u,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(u);await this.fb(r,n,s.$Ed.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.$fk)(o)}finally{await r.close(n)}}async ob(t,u,r,i){const n=await(0,s.$Qd)(this.H(t,u,M.CancellationToken.None));await this.gb(r,i,void 0,n)}pb(t,u){if(t.capabilities&2048)throw new g.$mk((0,w.localize)(24,null,this.rb(u)),6);return t}qb(t,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.$mk((0,w.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===$.Schemas.file?t.fsPath:t.toString(!0)}};e.$Bp=E,e.$Bp=E=ke([_(0,a.$4i)],E)}),define(te[93],ie([0,1,45,309,8,34,17,3,32,2,9,4,19,56,21,178,16,118,219,50,215,214]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0,(()=>{try{(0,O.gracefulify)(P)}catch(u){console.error(`Error enabling graceful-fs: ${(0,m.$li)(u)}`)}})();class t extends a.$Kp{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$yi(n=>p.$$f.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,$.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let k;o.isSymbolicLink()?k=(await this.stat((0,p.$hg)(r,o.name))).type:k=this.M(o),n.push([o.name,k])}catch(k){this.a.trace(k)}})),n}catch(i){throw this.eb(i)}}M(r,i){let n;return i?.dangling?n=g.FileType.Unknown:r.isFile()?n=g.FileType.File:r.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new s.$Eg;return this.N.set(r,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$hc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const o=this.H(r);return await y.Promises.readFile(o)}catch(o){throw this.eb(o)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const o=(0,f.$sd)(k=>A.$Ed.concat(k.map(I=>A.$Ed.wrap(I))).buffer);return(0,c.$Ap)(this,r,o,k=>k.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(r,(0,p.$hg)((0,p.$gg)(r),`${(0,p.$eg)(r)}${n.atomic.postfix}`),i,n):this.R(r,i,n)}async Q(r,i,n,o){await this.R(i,n,o);try{await this.rename(i,r,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}async R(r,i,n){let o;try{const k=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(k)){if(!n.overwrite)throw(0,g.$ek)((0,w.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$ek)((0,w.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(k){throw await this.fb(r,k)}finally{typeof o=="number"&&await this.close(o)}}static{this.X=!0}static configureFlushOnWrite(r){t.X=r}async open(r,i){const n=this.H(r);let o;(0,g.$6j)(i)&&(o=await this.O(r));let k;try{if((0,g.$6j)(i)&&i.unlock)try{const{stat:D}=await y.SymlinkSupport.stat(n);D.mode&128||await y.Promises.chmod(n,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let I;if((0,g.$6j)(i)){if($.$i)try{await y.Promises.truncate(n,0),I="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}I||(I="w")}else I="r";k=await y.Promises.open(n,I)}catch(I){throw o?.dispose(),(0,g.$6j)(i)?await this.fb(r,I):this.eb(I)}if(this.S.set(k,0),(0,g.$6j)(i)&&this.W.set(k,r),o){const I=this.U.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${n})`),this.U.set(k,o),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${n})`),I.dispose())}return k}async close(r){const i=this.U.get(r);try{if(this.S.delete(r),this.W.delete(r)&&t.X)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.eb(n)}finally{i&&(this.U.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.U.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,o,k){const I=this.Y(r,i);let D=null;try{D=(await y.Promises.read(r,n,o,k,I)).bytesRead}catch(v){throw this.eb(v)}finally{this.Z(r,I,D)}return D}Y(r,i){return i===this.S.get(r)?null:i}Z(r,i,n){const o=this.S.get(r);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.S.set(r,o+n):this.S.delete(r)))}async write(r,i,n,o,k){return(0,s.$Xg)(()=>this.$(r,i,n,o,k),100,3)}async $(r,i,n,o,k){const I=this.Y(r,i);let D=null;try{D=(await y.Promises.write(r,n,o,k,I)).bytesWritten}catch(v){throw await this.fb(this.W.get(r),v)}finally{this.Z(r,I,D)}return D}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(i){throw this.eb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,b.$8d)((0,b.$$d)(n),`${(0,b.$_d)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let k=!1;try{const{stat:I,symbolicLink:D}=await y.SymlinkSupport.stat(n);k=I.isDirectory()&&!D}catch{}if(k)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.eb(n)}}async rename(r,i,n){const o=this.H(r),k=this.H(i);if(o!==k)try{await this.ab(r,i,"move",n.overwrite),await y.Promises.rename(o,k)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(2,null,(0,b.$_d)(o),(0,b.$_d)((0,b.$$d)(k)),I.toString()))),this.eb(I)}}async copy(r,i,n){const o=this.H(r),k=this.H(i);if(o!==k)try{await this.ab(r,i,"copy",n.overwrite),await y.Promises.copy(o,k,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(3,null,(0,b.$_d)(o),(0,b.$_d)((0,b.$$d)(k)),I.toString()))),this.eb(I)}}async ab(r,i,n,o){const k=this.H(r),I=this.H(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,h.$Gf)(k,I,!0)),D){if(n==="copy")throw(0,g.$ek)((0,w.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.L(r);if(!R)throw(0,g.$ek)((0,w.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!o)throw(0,g.$ek)((0,w.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);R.type&g.FileType.File&&j.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.bb(r,i,!1)}async bb(r,i,n){const o=this.H(r),k=this.H(i),I=!!(this.capabilities&1024);if((0,h.$Gf)(o,k,!I))return;const D=new l.$ic;try{const[v,R]=await Promise.all([this.O(r),this.O(i)]);D.add(v),D.add(R),n&&await y.Promises.mkdir((0,b.$$d)(k),{recursive:!0}),await y.Promises.copyFile(o,k)}catch(v){if(v.code==="ENOENT"&&!n)return this.bb(r,i,!0);throw this.eb(v)}finally{D.dispose()}}t(r,i,n){return new E.$Rp(o=>r(o),o=>i(o),n)}F(r,i,n){return new d.$Zp(o=>r(o),o=>i(o),n)}eb(r){if(r instanceof g.$dk)return r;let i=r,n;switch(r.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$ek)(i,n)}async fb(r,i){let n=this.eb(i);if(r&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.H(r));o.mode&128||(n=(0,g.$ek)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$1p=t}),define(te[221],ie([0,1,3,93,2,17,56,22]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=void 0;class h extends s.$jc{constructor($,p){super(),this.a=$,this.b=p,this.F=new Map,this.G=new Map}call($,p,f){const y=this.c($);switch(p){case"stat":return this.g(y,f[0]);case"readdir":return this.h(y,f[0]);case"open":return this.r(y,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(y,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(y,f[0],f[1],f[2]);case"rename":return this.z(y,f[0],f[1],f[2]);case"copy":return this.C(y,f[0],f[1],f[2]);case"cloneFile":return this.D(y,f[0],f[1]);case"mkdir":return this.w(y,f[0]);case"delete":return this.y(y,f[0],f[1]);case"watch":return this.I(y,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${p} not found`)}listen($,p,f){const y=this.c($);switch(p){case"fileChange":return this.H(y,f[0]);case"readFileStream":return this.m(y,f[0],f[1])}throw new Error(`Unknown event ${p}`)}g($,p){const f=this.f($,p,!0);return this.a.stat(f)}h($,p){const f=this.f($,p);return this.a.readdir(f)}async j($,p,f){const y=this.f($,p,!0),w=await this.a.readFile(y,f);return M.$Ed.wrap(w)}m($,p,f){const y=this.f($,p,!0),w=new S.$od,g=new P.$ed({onDidRemoveLastListener:()=>{w.cancel()}}),c=this.a.readFileStream(y,f,w.token);return(0,A.$wd)(c,{onData:a=>g.fire(M.$Ed.wrap(a)),onError:a=>g.fire(a),onEnd:()=>{g.fire("end"),g.dispose(),w.dispose()}}),g.event}n($,p,f,y){const w=this.f($,p);return this.a.writeFile(w,f.buffer,y)}r($,p,f){const y=this.f($,p,!0);return this.a.open(y,f)}s($){return this.a.close($)}async t($,p,f){const y=M.$Ed.alloc(f),w=0,g=await this.a.read($,p,y.buffer,w,f);return[y,g]}u($,p,f,y,w){return this.a.write($,p,f.buffer,y,w)}w($,p){const f=this.f($,p);return this.a.mkdir(f)}y($,p,f){const y=this.f($,p);return this.a.delete(y,f)}z($,p,f,y){const w=this.f($,p),g=this.f($,f);return this.a.rename(w,g,y)}C($,p,f,y){const w=this.f($,p),g=this.f($,f);return this.a.copy(w,g,y)}D($,p,f){const y=this.f($,p),w=this.f($,f);return this.a.cloneFile(y,w)}H($,p){const f=new P.$ed({onWillAddFirstListener:()=>{this.F.set(p,this.L($,f))},onDidRemoveLastListener:()=>{(0,s.$ec)(this.F.get(p)),this.F.delete(p)}});return f.event}async I($,p,f,y,w){const g=this.F.get(p);if(g){const c=this.f($,y),a=g.watch(f,c,w);this.G.set(p+f,a)}}async J($,p){const f=$+p,y=this.G.get(f);y&&((0,s.$ec)(y),this.G.delete(f))}dispose(){super.dispose();for(const[,$]of this.G)$.dispose();this.G.clear();for(const[,$]of this.F)$.dispose();this.F.clear()}}e.$wr=h;class l extends s.$jc{constructor($,p,f,y){super(),this.c=$,this.f=f,this.g=y,this.a=new Map,this.b=this.B(new O.$1p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h($){const p=this.B(new P.$ed);this.B(p.event(f=>{$.fire(f.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(f=>p.fire(f))),this.B(this.b.onDidWatchError(f=>$.fire(f)))}j($){}m($){}watch($,p,f){const y=this.m(this.g);return Array.isArray(y)&&(f.excludes=[...f.excludes,...y]),this.a.set($,this.b.watch(p,f)),(0,s.$hc)(()=>{(0,s.$ec)(this.a.get($)),this.a.delete($)})}dispose(){for(const[,$]of this.a)$.dispose();this.a.clear(),super.dispose()}}e.$xr=l}),define(te[222],ie([0,1,15,177,4,7,16,9,221,155]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L5b=void 0;class b extends h.$wr{constructor(f,y,w){super(f,y),this.M=w}c(f){return l.$Bm}f(f,y){return M.URI.revive(y)}async y(f,y,w){if(!w.useTrash)return super.y(f,y,w);const g=this.f(f,y),c=(0,S.$6d)(g.fsPath);try{await P.shell.trashItem(c)}catch{throw(0,A.$ek)(s.$i?(0,O.localize)(0,null,(0,S.$_d)(c)):(0,O.localize)(1,null,(0,S.$_d)(c)),A.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new $(f,y,this.b,this.M)}}e.$L5b=b;class $ extends h.$xr{watch(f,y,w){if(w.recursive)throw(0,A.$ek)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,w)}}}),define(te[223],ie([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N2b=void 0;class O extends P.$0i{constructor(M=P.$7i){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(A=>{this.n?.setLevel(A)}))}set logger(M){this.n=M;for(const{level:A,message:S}of this.m)(0,P.log)(M,A,S);this.m=[]}g(M,A){this.n?(0,P.log)(this.n,M,A):this.getLevel()<=M&&this.m.push({level:M,message:A})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$N2b=O}),define(te[224],ie([0,1,7,3,5,2]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0;class A extends s.$cj{constructor($,p,f,y,w){super(p,f,y),this.r=$,this.t=w,this.B(w.listen("onDidChangeLogLevel",$)(g=>{(0,s.$6i)(g)?super.setLogLevel(g):super.setLogLevel(P.URI.revive(g[0]),g[1])})),this.B(w.listen("onDidChangeVisibility",$)(([g,c])=>super.setVisibility(P.URI.revive(g),c))),this.B(w.listen("onDidChangeLoggers",$)(({added:g,removed:c})=>{for(const a of g)super.registerLogger({...a,resource:P.URI.revive(a.resource)});for(const a of c)super.deregisterLogger(a.resource)}))}createConsoleMainLogger(){return new s.$aj({log:($,p)=>{this.t.call("consoleLog",[$,p])}})}registerLogger($){super.registerLogger($),this.t.call("registerLogger",[$,this.r])}deregisterLogger($){super.deregisterLogger($),this.t.call("deregisterLogger",[$,this.r])}setLogLevel($,p){super.setLogLevel($,p),this.t.call("setLogLevel",[$,p])}setVisibility($,p){super.setVisibility($,p),this.t.call("setVisibility",[this.n($),p])}s($,p,f){return new S(this.t,$,p,f,this.r)}static setLogLevel($,p,f){return $.call("setLogLevel",[p,f])}}e.$Yq=A;class S extends s.$0i{constructor($,p,f,y,w){super(y?.logLevel==="always"),this.r=$,this.s=p,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[p,y,w]).then(()=>{this.u(this.n),this.m=!0})}g($,p){const f=[[$,p]];this.m?this.u(f):this.n.push(...f)}u($){this.r.call("log",[this.s,$])}}class h{constructor($,p){this.a=$,this.b=p}listen($,p){const f=this.b($);switch(p){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(w=>this.c(w,f)),removed:[...y.removed].map(w=>this.c(w,f))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,y=>[f.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$6i)(y)?y:[f.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${p}`)}async call($,p,f){const y=this.b($);switch(p){case"setLogLevel":return(0,s.$6i)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(P.URI.revive(y.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,y)))}throw new Error(`Call not found: ${p}`)}c($,p){return{...$,resource:p.transformOutgoingURI($.resource)}}}e.$Zq=h;class l extends M.$jc{constructor($,p){super(),p.call("setLogLevel",[$.getLogLevel()]),this.B($.onDidChangeLogLevel(f=>p.call("setLogLevel",[f]))),p.call("getRegisteredLoggers").then(f=>{for(const y of f)$.registerLogger({...y,resource:P.URI.revive(y.resource)})}),this.B(p.listen("onDidChangeVisibility")(([f,y])=>$.setVisibility(P.URI.revive(f),y))),this.B(p.listen("onDidChangeLoggers")(({added:f,removed:y})=>{for(const w of f)$.registerLogger({...w,resource:P.URI.revive(w.resource)});for(const w of y)$.deregisterLogger(w.resource)}))}}e.$1q=l}),define(te[225],ie([0,1,2,5]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;class s extends P.$jc{constructor(A,S=[]){super(),this.a=new O.$bj([A,...S]),this.B(A.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...S){this.a.trace(A,...S)}debug(A,...S){this.a.debug(A,...S)}info(A,...S){this.a.info(A,...S)}warn(A,...S){this.a.warn(A,...S)}error(A,...S){this.a.error(A,...S)}flush(){this.a.flush()}}e.$gN=s}),define(te[226],ie([0,1,34,7,5]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=void 0;class M{constructor(S){this.b=S,this.a=new P.$yi}listen(S,h,l){switch(h){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(S,h,l){switch(h){case"createLogger":this.c(O.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(O.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.$6i)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(O.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(O.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:O.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(O.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}c(S,h,l){this.a.set(S,this.b.createLogger(S,h,l))}d(S,h){let l=console.log;switch(S){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...h)}e(S,h){const l=this.a.get(S);if(!l)throw new Error("Create the logger before logging");for(const[b,$]of h)(0,s.log)(l,b,$)}}e.$J6b=M}),define(te[227],ie([0,1,16,5]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function M(l,b,$,p,f){try{const y=await new Promise((g,c)=>{J(["@vscode/spdlog"],g,c)});y.setFlushOn(s.Trace);const w=await y.createAsyncRotatingLogger(l,b,$,p);return f?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function A(l,b,$){switch(b){case O.LogLevel.Trace:l.trace($);break;case O.LogLevel.Debug:l.debug($);break;case O.LogLevel.Info:l.info($);break;case O.LogLevel.Warning:l.warn($);break;case O.LogLevel.Error:l.error($);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function S(l,b){switch(b){case O.LogLevel.Trace:l.setLevel(s.Trace);break;case O.LogLevel.Debug:l.setLevel(s.Debug);break;case O.LogLevel.Info:l.setLevel(s.Info);break;case O.LogLevel.Warning:l.setLevel(s.Warning);break;case O.LogLevel.Error:l.setLevel(s.Error);break;case O.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class h extends O.$0i{constructor(b,$,p,f,y){super(),this.m=[],this.setLevel(y),this.n=this.s(b,$,p,f),this.B(this.onDidChangeLogLevel(w=>{this.r&&S(this.r,w)}))}async s(b,$,p,f){const y=p?6:1,w=30/y*P.$zk.MB,g=await M(b,$,w,y,f);if(g){this.r=g,S(this.r,this.getLevel());for(const{level:c,message:a}of this.m)A(this.r,c,a);this.m=[]}}g(b,$){this.r?A(this.r,b,$):this.getLevel()<=b&&this.m.push({level:b,message:$})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$8M=h}),define(te[228],ie([0,1,31,5,227]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class M extends O.$cj{s(S,h,l){return new s.$8M((0,P.$3f)(),S.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.$9M=M}),define(te[66],ie([0,1,34,3,6,5,228]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$5b=e.$05b=void 0,e.$05b=(0,s.$Bh)(M.$5i);class S extends A.$9M{constructor(){super(...arguments),this.u=new P.$yi}createLogger(l,b,$){$!==void 0&&this.u.set(this.n(l),$);try{return super.createLogger(l,b)}catch(p){throw this.u.delete(this.n(l)),p}}registerLogger(l,b){b!==void 0&&this.u.set(l.resource,b),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const b=[];for(const $ of super.getRegisteredLoggers())l===this.u.get($.resource)&&b.push($);return b}getOnDidChangeLogLevelEvent(l){return O.Event.filter(this.onDidChangeLogLevel,b=>(0,M.$6i)(b)||this.w(b[0],l))}getOnDidChangeVisibilityEvent(l){return O.Event.filter(this.onDidChangeVisibility,([b])=>this.w(b,l))}getOnDidChangeLoggersEvent(l){return O.Event.filter(O.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(p=>this.w(p.resource,l)),removed:[...b.removed].filter(p=>this.w(p.resource,l))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(l){for(const[b,$]of this.u)$===l&&this.deregisterLogger(b)}w(l,b){const $=this.u.get(l);return $===void 0||$===b}dispose(){super.dispose(),this.u.clear()}}e.$$5b=S}),define(te[229],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$45b=e.$35b=e.$25b=e.$15b=void 0;function P(A){return A.submenu!==void 0}e.$15b=P;function O(A){return A.id==="vscode.menubar.separator"}e.$25b=O;function s(A){return A.uri!==void 0}e.$35b=s;function M(A){return!P(A)&&!O(A)&&!s(A)}e.$45b=M}),define(te[39],ie([0,1,3,68,2,6]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=void 0,e.$9m=(0,M.$Ah)("policy");class A extends s.$jc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$ed),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const b=Object.keys(this.f).length;return this.f={...l,...this.f},b!==Object.keys(this.f).length&&await this.j(l),O.Iterable.reduce(this.g.entries(),($,[p,f])=>({...$,[p]:f}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(l,[b,$])=>({...l,[b]:{definition:$,value:this.g.get(b)}}),{})}}e.$0m=A;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$$m=S}),define(te[230],ie([0,1,8,3,68,12,16,5,39]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=void 0;function l($,p){const f=[];for(const y of new Set(s.Iterable.concat($.keys(),p.keys())))$.get(y)!==p.get(y)&&f.push(y);return f}let b=class extends h.$0m{constructor(p,f,y){super(),this.m=p,this.n=f,this.s=y,this.c=this.B(new P.$Dg(500));const w=O.Event.filter(f.onDidFilesChange,g=>g.affects(p));this.B(f.watch(p)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const f=await this.n.readFile(this.m),y=JSON.parse(f.value.toString());if(!(0,M.$kf)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.f[w]&&p.set(w,y[w])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return p}async w(){const p=await this.u(),f=l(this.g,p);this.g=p,f.length>0&&this.h.fire(f)}};e.$26b=b,e.$26b=b=ke([_(1,A.$5j),_(2,S.$4i)],b)}),define(te[231],ie([0,1,3,2,39]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=e.$C6b=void 0;class M{constructor(h){this.b=h,this.a=new O.$ic}listen(h,l){switch(l){case"onDidChange":return P.Event.map(this.b.onDidChange,b=>b.reduce(($,p)=>({...$,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(h,l,b){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$C6b=M;class A extends s.$0m{constructor(h,l){super(),this.a=l;for(const b in h){const{definition:$,value:p}=h[b];this.f[b]=$,p!==void 0&&this.g.set(b,p)}this.a.listen("onDidChange")(b=>{for(const $ in b){const p=b[$];p===null?this.g.delete($):this.g.set($,p)}this.h.fire(Object.keys(b))})}async j(h){const l=await this.a.call("updatePolicyDefinitions",h);for(const b in l)this.g.set(b,l[b])}}e.$D6b=A}),define(te[232],ie([0,1,39,8,310,2,5]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=void 0;let S=class extends P.$0m{constructor(l,b){super(),this.m=l,this.n=b,this.a=new O.$zg,this.b=this.B(new M.$kc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((b,$)=>{try{this.b.value=(0,s.createWatcher)(this.n,l,p=>{this.t(p),b()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),$(p)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const b in l){const $=l[b];$===void 0?this.g.delete(b):this.g.set(b,$)}this.h.fire(Object.keys(l))}};e.$16b=S,e.$16b=S=ke([_(0,A.$4i)],S)}),define(te[77],ie([0,1,4,35]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.context<"u"){const M=P.$g.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[24],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,P.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,72,5,24]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E5b=void 0;let M=class{constructor(S,h){this.b=S,this.c=h,this.a=new Map}async isExtensionUrlTrusted(S,h){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const l=/^(.*)#([^#]+)$/.exec(h);if(!l)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,b,$]=l;let p=this.a.get(S);if(!p){if(p=this.b.trustedExtensionUrlPublicKeys[S],!p||p.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.a.set(S,[...p])}const f=Buffer.from(decodeURIComponent($),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const y=f.slice(0,6),w=f.readUIntBE(0,6),g=Date.now()-w;if(g<0||g>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const c=f.slice(6),a=P.createVerify("SHA256");a.write(y),a.write(Buffer.from(b)),a.end();for(let m=0;m<p.length;m++){let E=p[m];if(E!==null){if(typeof E=="string")try{E=P.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),p[m]=E}catch(d){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${m+1} for ${S}:`,d),p[m]=null;continue}if(a.verify(E,c))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.$E5b=M,e.$E5b=M=ke([_(0,s.$jj),_(1,O.$4i)],M)}),define(te[234],ie([0,1,8,5]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=void 0;let s=class{constructor(A,S,h){this.a=A,this.b=S,this.c=h}async inspect(A){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$Gg)(A);const h=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.$Q5b=s,e.$Q5b=s=ke([_(2,O.$4i)],s)}),define(te[78],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T5b=void 0,e.$T5b=(0,P.$Ah)("protocolMainService")}),define(te[43],ie([0,1,136,12]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class s{constructor(){this.a=new Map}add(A,S){P.ok(O.$if(A)),P.ok(O.$kf(S)),P.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,S)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$7m=new s}),define(te[235],ie([0,1,3,43]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,l){this.a[s(h)]=l,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;O.$7m.add(e.$8m.JSONContribution,A)}),define(te[59],ie([0,1,23,3,12,162,18,235,43]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var l;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$_m={Configuration:"base.contributions.configuration"};var b;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const $=h.$7m.as(S.$8m.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$ed,this.onDidSchemaChange=this.i.event,this.j=new O.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},$.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const r=new Set;this.n(t,u,r),$.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const u=new Set;this.o(t,u),$.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const r=new Set;this.o(u,r),this.n(t,!1,r),$.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(u.add(o),e.$jn.test(o)){const k=this.a.get(o),I=k?.valuesSources??new Map;if(n)for(const j of Object.keys(i[o]))I.set(j,n);const D={...k?.value||{},...i[o]};this.a.set(o,{source:n,value:D,valuesSources:I});const v=(0,A.$ei)(o),R={type:"object",default:D,description:M.localize(1,null,v),$ref:e.$gn,defaultDefaultValue:D,source:s.$if(n)?void 0:n,defaultValueSource:n};r.push(...w(o)),this.d[o]=R,this.b.properties[o]=R}else{this.a.set(o,{value:i[o],source:n});const k=this.d[o];k&&(this.w(o,k),this.r(o,k))}this.m(r)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),k=s.$if(i)?i:i?.id,I=s.$if(o?.source)?o?.source:o?.source?.id;if(k===I)if(u.add(n),this.a.delete(n),e.$jn.test(n))delete this.d[n],delete this.b.properties[n];else{const D=this.d[n];D&&(this.w(n,D),this.r(n,D))}}this.u()}deltaConfiguration(t){let u=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,r){t.forEach(i=>{this.p(i,u,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,u){const r=i=>{if(i.properties)for(const n in i.properties){u.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,u=!0,r,i,n=3,o){n=s.$rf(t.scope)?n:t.scope;const k=t.properties;if(k)for(const D in k){const v=k[D];if(u&&m(D,v)){delete k[D];continue}if(v.source=r,v.defaultDefaultValue=k[D].default,this.w(D,v),e.$jn.test(D)?v.scope=void 0:(v.scope=s.$rf(v.scope)?n:v.scope,v.restricted=s.$rf(v.restricted)?!!i?.includes(D):v.restricted),k[D].hasOwnProperty("included")&&!k[D].included){this.f[D]=k[D],delete k[D];continue}else this.d[D]=k[D],k[D].policy?.name&&this.e.set(k[D].policy.name,D);!k[D].deprecationMessage&&k[D].markdownDeprecationMessage&&(k[D].deprecationMessage=k[D].markdownDeprecationMessage),o.add(D)}const I=t.allOf;if(I)for(const D of I)this.p(D,u,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$an.properties[t]=u,u.scope){case 1:e.$bn.properties[t]=u;break;case 2:e.$cn.properties[t]=u;break;case 6:e.$dn.properties[t]=u;break;case 3:e.$en.properties[t]=u;break;case 4:e.$fn.properties[t]=u;break;case 5:e.$fn.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$an.properties[t],u.scope){case 1:delete e.$bn.properties[t];break;case 2:delete e.$cn.properties[t];break;case 6:delete e.$dn.properties[t];break;case 3:delete e.$en.properties[t];break;case 4:case 5:delete e.$fn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$gn};this.w(u,r),e.$an.properties[u]=r,e.$bn.properties[u]=r,e.$cn.properties[u]=r,e.$dn.properties[u]=r,e.$en.properties[u]=r,e.$fn.properties[u]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=t,e.$bn.patternProperties[e.$in]=t,e.$cn.patternProperties[e.$in]=t,e.$dn.patternProperties[e.$in]=t,e.$en.patternProperties[e.$in]=t,e.$fn.patternProperties[e.$in]=t,this.i.fire()}w(t,u){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$pf(i)&&(i=u.defaultDefaultValue,n=void 0),s.$pf(i)&&(i=c(u.type)),u.default=i,u.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.$in=`^(${f})+$`,e.$jn=new RegExp(e.$in);function w(d){const t=[];if(e.$jn.test(d)){let u=y.exec(d);for(;u?.length;){const r=u[1].trim();r&&t.push(r),u=y.exec(d)}}return(0,P.$Jb)(t)}e.$kn=w;function g(d){return d.reduce((t,u)=>`${t}[${u}]`,"")}e.$ln=g;function c(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=c;const a=new p;h.$7m.add(e.$_m.Configuration,a);function m(d,t){return d.trim()?e.$jn.test(d)?M.localize(7,null,d):a.getConfigurationProperties()[d]!==void 0?M.localize(8,null,d):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,d,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$nn=m;function E(){const d=[],t=a.getConfigurationProperties();for(const u of Object.keys(t))d.push([u,t[u].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.$on=E}),define(te[119],ie([0,1,23,3,44,2,34,37,12,7,18,59,43]),function(J,e,P,O,s,M,A,S,h,l,b,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function f(u){return Object.isFrozen(u)?u:S.$Vm(u)}class y{constructor(r={},i=[],n=[],o){this.b=r,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new w("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,b.$ci)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),o=i?this.rawConfiguration.getOverrideValue(r,i):void 0,k=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:o,merged:k}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,b.$ci)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.$Jb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.$Jb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$Um(this.contents),n=S.$Um(this.overrides),o=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const I of r)if(k.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const D of I.overrides){const[v]=n.filter(R=>P.$sb(R.identifiers,D.identifiers));v?(this.h(v.contents,D.contents),v.keys.push(...D.keys),v.keys=P.$Jb(v.keys)):n.push(S.$Um(D))}for(const D of I.keys)o.indexOf(D)===-1&&o.push(D)}return new y(i,o,n,k.every(I=>I instanceof y)?void 0:k)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of P.$Jb([...Object.keys(this.contents),...Object.keys(i)])){let k=this.contents[o];const I=i[o];I&&(typeof k=="object"&&typeof I=="object"?(k=S.$Um(k),this.h(k,I)):k=I),n[o]=k}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&h.$kf(r[n])&&h.$kf(i[n])){this.h(r[n],i[n]);continue}r[n]=S.$Um(i[n])}}i(r){let i=null,n=null;const o=k=>{k&&(n?this.h(n,k):n=S.$Um(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===r?i=k.contents:k.identifiers.includes(r)&&o(k.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,b.$bi)(this.contents,r),$.$jn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$sb(n.identifiers,(0,$.$kn)(r))),1))}j(r,i,n){(0,b.$ai)(this.contents,r,i,o=>console.error(o)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),$.$jn.test(r)&&this.overrides.push({identifiers:(0,$.$kn)(r),keys:Object.keys(this.contents[r]),contents:(0,b.$_h)(this.contents[r],o=>console.error(o))})}}e.$pn=y;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!h.$rf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:o,overrides:k,restricted:I,hasExcludedProperties:D}=this.h(r,i);this.b=new y(n,o,k,D?[r]:void 0),this.c=I||[]}g(r){let i={},n=null,o=[];const k=[],I=[];function D(R){Array.isArray(o)?o.push(R):n!==null&&(o[n]=R)}const v={onObjectBegin:()=>{const R={};D(R),k.push(o),o=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{o=k.pop()},onArrayBegin:()=>{const R=[];D(R),k.push(o),o=R,n=null},onArrayEnd:()=>{o=k.pop()},onLiteralValue:D,onError:(R,j,N)=>{I.push({error:R,offset:j,length:N})}};if(r)try{s.$Rm(r,v),i=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return i}h(r,i){const n=p.$7m.as($.$_m.Configuration).getConfigurationProperties(),o=this.i(r,n,!0,i);r=o.raw;const k=(0,b.$_h)(r,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),I=Object.keys(r),D=this.j(r,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:k,keys:I,overrides:D,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(r,i,n,o){let k=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:k};const I={},D=[];for(const v in r)if($.$jn.test(v)&&n){const R=this.i(r[v],i,!1,o);I[v]=R.raw,k=k||R.hasExcludedProperties,D.push(...R.restricted)}else{const R=i[v],j=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&D.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(j===void 0||o.scopes===void 0||o.scopes.includes(j))&&!(o.skipRestricted&&R?.restricted))?I[v]=r[v]:k=!0}return{raw:I,restricted:D,hasExcludedProperties:k}}j(r,i){const n=[];for(const o of Object.keys(r))if($.$jn.test(o)){const k={};for(const I in r[o])k[I]=r[o][I];n.push({identifiers:(0,$.$kn)(o),keys:Object.keys(k),contents:(0,b.$_h)(k,i)})}return n}}e.$qn=w;class g extends M.$jc{constructor(r,i,n,o){super(),this.c=r,this.f=i,this.g=o,this.b=this.B(new O.$ed),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&n.isEqual(k.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=g;class c{constructor(r,i,n,o,k,I,D,v,R,j,N,z,se){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=k,this.f=I,this.g=D,this.h=v,this.i=R,this.j=j,this.k=N,this.l=z,this.m=se}get value(){return f(this.c)}n(r,i,n){const o=r.inspect(i,n);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(r,i,n,o,k=new y,I=new y,D=new A.$yi,v=new y,R=new A.$yi){this.c=r,this.d=i,this.f=n,this.g=o,this.h=k,this.i=I,this.j=D,this.l=v,this.m=R,this.a=null,this.b=new A.$yi,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new y,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const o=this.q(r,i,n),k=this.u(i.resource,n),I=i.resource?this.m.get(i.resource)||this.l:this.l,D=new Set;for(const v of o.overrides)for(const R of v.identifiers)o.getOverrideValue(r,R)!==void 0&&D.add(R);return new c(r,i,o.getValue(r),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,k||void 0,I)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:k,removed:I}=d(this.c,r);i=[...o,...k,...I]}for(const o of i)for(const k of(0,$.$kn)(o)){const I=this.c.getKeysForOverrideIdentifier(k),D=r.getKeysForOverrideIdentifier(k),v=[...D.filter(R=>I.indexOf(R)===-1),...I.filter(R=>D.indexOf(R)===-1),...I.filter(R=>!S.$Ym(this.c.override(k).getValue(R),r.override(k).getValue(R)))];n.push([k,v])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=d(this.d,r),k=[...i,...n,...o];return k.length&&this.updatePolicyConfiguration(r),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:k}=d(this.applicationConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:k}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:k}=d(this.localUserConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:k}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:k}=d(this.remoteUserConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:k}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:k}=d(this.workspaceConfiguration,r),I=[...i,...n,...o];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:k}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:o,updated:k,removed:I,overrides:D}=d(n,i),v=[...o,...k,...I];return(v.length||!n)&&this.updateFolderConfiguration(r,i),{keys:v,overrides:D}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:k,overrides:I}=d(i,void 0);return{keys:[...n,...o,...k],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}r({resource:r},i){let n=this.s();if(i&&r){const o=i.getFolder(r);o&&(n=this.t(o.uri)||n);const k=this.m.get(r);k&&(n=n.merge(k))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),o=this.j.get(r);o?(i=n.merge(o),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:k}=this.j.get(i);return r.push([i,{contents:n,overrides:o,keys:k}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),o=this.x(r.application),k=this.x(r.user),I=this.x(r.workspace),D=r.folders.reduce((v,R)=>(v.set(l.URI.revive(R[0]),this.x(R[1])),v),new A.$yi);return new a(i,n,o,k,new y,I,D,new y,new A.$yi)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$sn=a;function m(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,i=new Map;for(const o of u)o.keys.forEach(k=>r.add(k)),o.overrides.forEach(([k,I])=>{const D=(0,A.$vi)(i,k,new Set);I.forEach(v=>D.add(v))});const n=[];return i.forEach((o,k)=>n.push([k,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.$tn=m;class E{constructor(r,i,n,o){this.change=r,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const I of k)this.affectedKeys.add(I);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,o=this.d.indexOf(n);if(o<0)return!1;const k=o+n.length;if(k>=this.d.length)return!1;const I=this.d.charCodeAt(k);if(I!==this.b&&I!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,v=this.g.getValue(r,i,this.h);return!S.$Ym(D,v)}return!0}}e.$un=E;function d(u,r){const{added:i,removed:n,updated:o}=t(r?.rawConfiguration,u?.rawConfiguration),k=[],I=u?.getAllOverrideIdentifiers()||[],D=r?.getAllOverrideIdentifiers()||[];if(r){const v=D.filter(R=>!I.includes(R));for(const R of v)k.push([R,r.getKeysForOverrideIdentifier(R)])}if(u){const v=I.filter(R=>!D.includes(R));for(const R of v)k.push([R,u.getKeysForOverrideIdentifier(R)])}if(r&&u){for(const v of I)if(D.includes(v)){const R=t({contents:u.getOverrideValue(void 0,v)||{},keys:u.getKeysForOverrideIdentifier(v)},{contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)});k.push([v,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:n,updated:o,overrides:k}}function t(u,r){const i=u?r?u.keys.filter(k=>r.keys.indexOf(k)===-1):[...u.keys]:[],n=r?u?r.keys.filter(k=>u.keys.indexOf(k)===-1):[...r.keys]:[],o=[];if(u&&r){for(const k of r.keys)if(u.keys.indexOf(k)!==-1){const I=(0,b.$ci)(r.contents,k),D=(0,b.$ci)(u.contents,k);S.$Ym(I,D)||o.push(k)}}return{added:i,removed:n,updated:o}}}),define(te[236],ie([0,1,23,3,2,37,12,119,59,5,39,43]),function(J,e,P,O,s,M,A,S,h,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=void 0;class p extends s.$jc{constructor(){super(...arguments),this.a=this.B(new O.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new S.$pn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B($.$7m.as(h.$_m.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.c(Array.from(g),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,c){this.h(g,$.$7m.as(h.$_m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new S.$pn;const g=$.$7m.as(h.$_m.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,c){const a=this.f();for(const m of g){const E=a[m],d=c[m];E!==void 0?this.b.addValue(m,E):d?this.b.addValue(m,d.default):this.b.removeValue(m)}}}e.$vn=p;class f{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new S.$pn}async initialize(){return this.configurationModel}}e.$wn=f;let y=class extends s.$jc{get configurationModel(){return this.b}constructor(g,c,a){super(),this.c=g,this.f=c,this.g=a,this.a=this.B(new O.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new S.$pn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const c={},a=[],m=$.$7m.as(h.$_m.Configuration).getConfigurationProperties();for(const E of g){const d=m[E];if(!d){a.push(E);continue}if(d.policy){if(d.type!=="string"&&d.type!=="number"){this.g.warn(`Policy ${d.policy.name} has unsupported type ${d.type}`);continue}a.push(E),c[d.policy.name]={type:d.type}}}return(0,A.$vf)(c)||await this.f.updatePolicyDefinitions(c),a}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const c=$.$7m.as(h.$_m.Configuration).getPolicyConfigurations(),a=(0,P.$Eb)(g.map(m=>c.get(m)));this.m(a,!0)}m(g,c){this.g.trace("PolicyConfiguration#update",g);const a=$.$7m.as(h.$_m.Configuration).getConfigurationProperties(),m=[],E=this.b.isEmpty();for(const d of g){const t=a[d]?.policy?.name;if(t){const u=this.f.getPolicyValue(t);(E?u!==void 0:!(0,M.$Ym)(this.b.getValue(d),u))&&m.push([d,u])}else this.b.getValue(d)!==void 0&&m.push([d,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const d=this.b;this.b=new S.$pn;for(const t of d.keys)this.b.setValue(t,d.getValue(t));for(const[t,u]of m)u===void 0?this.b.removeValue(t):this.b.setValue(t,u);c&&this.a.fire(this.b)}}};e.$xn=y,e.$xn=y=ke([_(1,b.$9m),_(2,l.$4i)],y)}),define(te[237],ie([0,1,8,3,2,19,18,119,236,39]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=void 0;class b extends s.$jc{constructor(p,f,y,w){super(),this.j=p,this.h=this.B(new O.$ed),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$vn),this.c=y instanceof l.$$m?new h.$wn:this.B(new h.$xn(this.b,y,w)),this.f=this.B(new S.$rn(this.j,{},M.$$f,f)),this.a=new S.$sn(this.b.configurationModel,this.c.configurationModel,new S.$pn,new S.$pn),this.g=this.B(new P.$Rg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:g,properties:c})=>this.n(g,c))),this.B(this.c.onDidChangeConfiguration(g=>this.r(g))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,f,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$sn(p,f,new S.$pn,y)}getConfigurationData(){return this.a.toData()}getValue(p,f){const y=typeof p=="string"?p:void 0,w=(0,A.$8h)(p)?p:(0,A.$8h)(f)?f:{};return this.a.getValue(y,w,void 0)}updateValue(p,f,y,w){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.m(p)}m(p){const f=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.s(y,f,2)}n(p,f){const y=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(p,f);this.s(w,y,7)}r(p){const f=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.s(y,f,7)}s(p,f,y){const w=new S.$un(p,{data:f},this.a);w.source=y,w.sourceConfig=this.t(y),this.h.fire(w)}t(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$yn=b}),define(te[238],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.$P6b=e.$O6b=void 0,e.$O6b="request",e.$P6b="remoteResourceHandler";class P{async routeCall(s,M,A){if(M!==e.$O6b)throw new Error(`Call not found: ${M}`);const S=A[0];if(S?.authority){const h=s.connections.find(l=>l.ctx===S.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$Q6b=P}),define(te[239],ie([0,1,14,6]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.RemoteAuthorityResolverErrorCode=e.$Kk=e.$Jk=e.RemoteConnectionType=e.$Ik=void 0,e.$Ik=(0,O.$Ah)("remoteAuthorityResolverService");var s;(function(b){b[b.WebSocket=0]="WebSocket",b[b.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor($){this.id=$,this.type=1}toString(){return`Managed(${this.id})`}}e.$Jk=M;class A{constructor($,p){this.host=$,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Kk=A;var S;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound",b.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class h extends P.$_{static isNotAvailable($){return $ instanceof h&&$._code===S.NotAvailable}static isTemporarilyNotAvailable($){return $ instanceof h&&$._code===S.TemporarilyNotAvailable}static isNoResolverFound($){return $ instanceof h&&$._code===S.NoResolverFound}static isInvalidAuthority($){return $ instanceof h&&$._code===S.InvalidAuthority}static isHandled($){return $ instanceof h&&$.isHandled}constructor($,p=S.Unknown,f){super($),this._message=$,this._code=p,this._detail=f,this.isHandled=p===S.NotAvailable&&f===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Lk=h;function l(b){const $=b.indexOf("+");return $===-1?b:b.substring(0,$)}e.$Mk=l}),define(te[60],ie([0,1,13]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function O(l){return l.scheme===P.Schemas.vscodeRemote?l.authority:void 0}e.$Nk=O;function s(l){if(!l)return;const b=l.indexOf("+");return b<0?l:l.substr(0,b)}e.$Ok=s;function M(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$Pk=M;function A(l){const{host:b,port:$}=h(l);if(typeof $>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:$}}e.$Qk=A;function S(l,b){let{host:$,port:p}=h(l);return typeof p>"u"&&(p=b),{host:$,port:p}}e.$Rk=S;function h(l){const b=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const $=l.match(/^(\[[0-9a-z:]+\])$/);if($)return{host:$[1],port:void 0};const p=l.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:l,port:void 0}}}),define(te[120],ie([0,1,26,6,60]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function M(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Sl=M,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(A||(e.ExtensionType=A={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class h{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,c){if(typeof g>"u"||g===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof g=="string"||typeof c=="string"){const a=typeof g=="string"?g:g.value,m=typeof c=="string"?c:c.value;return P.$Le(a,m)}return g._lower===c._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Ul=h;class l{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const c of g)this.add(c)}add(g){this.c.add(h.toKey(g))}delete(g){return this.c.delete(h.toKey(g))}has(g){return this.c.has(h.toKey(g))}}e.$Vl=l;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(h.toKey(g))}get(g){return this.c.get(h.toKey(g))}has(g){return this.c.has(h.toKey(g))}set(g,c){this.c.set(h.toKey(g),c)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=b;function $(w){return p(w)}e.$Xl=$;function p(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Yl=p;function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$Zl=f;function y(w,g){if(g){const c=`onResolveRemoteAuthority:${(0,s.$Ok)(g)}`;return!!w.activationEvents?.includes(c)}return!1}e.$1l=y,e.$2l=(0,O.$Ah)("IBuiltinExtensionsScannerService")}),define(te[240],ie([0,1,8,17,22,14,3,2,65,69,31,109,239,60]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.PersistentConnectionEventType=e.$Yk=e.$Xk=e.$Wk=e.ConnectionType=void 0;const y=30*1e3;var w;(function(Y){Y[Y.Management=1]="Management",Y[Y.ExtensionHost=2]="ExtensionHost",Y[Y.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function g(Y){switch(Y){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(Y){const C=new s.$od;return setTimeout(()=>C.cancel(),Y),C.token}function a(Y,C){if(Y.isCancellationRequested||C.isCancellationRequested)return s.CancellationToken.Cancelled;const L=new s.$od;return Y.onCancellationRequested(()=>L.cancel()),C.onCancellationRequested(()=>L.cancel()),L.token}class m{get didTimeout(){return this.c==="timedout"}constructor(C){this.c="pending",this.d=new S.$ic,this.promise=new Promise((L,U)=>{this.f=L,this.g=U}),C.isCancellationRequested?this.h():this.d.add(C.onCancellationRequested(()=>this.h()))}registerDisposable(C){this.c==="pending"?this.d.add(C):C.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const C=new Error("Time limit reached");return C.code="ETIMEDOUT",C.syscall="connect",C}resolve(C){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(C))}reject(C){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(C))}}function E(Y,C){const L=new m(C);return L.registerDisposable(Y.onControlMessage(U=>{const W=JSON.parse(U.toString()),q=F(W);q?L.reject(q):L.resolve(W)})),L.promise}function d(Y,C,L,U,W,q,V,re){const $e=new m(re),de=l.$ad.create(!1);return Y.info(`Creating a socket (${V})...`),h.mark(`code/willCreateSocket/${q}`),C.connect(L,U,W,V).then(ue=>{$e.didTimeout?(h.mark(`code/didCreateSocketError/${q}`),Y.info(`Creating a socket (${V}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(h.mark(`code/didCreateSocketOK/${q}`),Y.info(`Creating a socket (${V}) was successful after ${de.elapsed()} ms.`),$e.resolve(ue))},ue=>{h.mark(`code/didCreateSocketError/${q}`),Y.info(`Creating a socket (${V}) returned an error after ${de.elapsed()} ms.`),Y.error(ue),$e.reject(ue)}),$e.promise}function t(Y,C){const L=new m(C);return Y.then(U=>{L.didTimeout||L.resolve(U)},U=>{L.didTimeout||L.reject(U)}),L.promise}async function u(Y,C,L,U){const W=x(Y,C);Y.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let q;try{q=await d(Y.logService,Y.remoteSocketFactoryService,Y.connectTo,(0,f.$Pk)(Y),`reconnectionToken=${Y.reconnectionToken}&reconnection=${Y.reconnectionProtocol?"true":"false"}`,g(C),`renderer-${g(C)}-${Y.reconnectionToken}`,U)}catch(ue){throw Y.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),Y.logService.error(ue),ue}Y.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let V,re;Y.reconnectionProtocol?(Y.reconnectionProtocol.beginAcceptReconnection(q,null),V=Y.reconnectionProtocol,re=!1):(V=new $.$oh({socket:q}),re=!0),Y.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const $e=await t(Y.signService.createNewMessage((0,b.$3f)()),U),de={type:"auth",auth:Y.connectionToken||"00000000000000000000",data:$e.data};V.sendControl(O.$Ed.fromString(JSON.stringify(de)));try{const ue=await E(V,a(U,c(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(Y.logService.trace(`${W} 4/6. received SignRequest control message.`),!await t(Y.signService.validate($e,ue.signedData),U)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const me=await t(Y.signService.sign(ue.data),U),Se={type:"connectionType",commit:Y.commit,signedData:me,desiredConnectionType:C};return L&&(Se.args=L),Y.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(O.$Ed.fromString(JSON.stringify(Se))),{protocol:V,ownsProtocol:re}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(Y.logService.error(`${W} the handshake timed out. Error:`),Y.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(Y.logService.error(`${W} received error control message when negotiating connection. Error:`),Y.logService.error(ue)),re&&B(V),ue}}async function r(Y,C,L,U){const W=Date.now(),q=x(Y,C),{protocol:V,ownsProtocol:re}=await u(Y,C,L,U),$e=new m(U);return $e.registerDisposable(V.onControlMessage(de=>{const ue=JSON.parse(de.toString()),be=F(ue);be?(Y.logService.error(`${q} received error control message when negotiating connection. Error:`),Y.logService.error(be),re&&B(V),$e.reject(be)):(Y.reconnectionProtocol?.endAcceptReconnection(),Y.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ce(W)}!`),$e.resolve({protocol:V,firstMessage:ue}))})),$e.promise}async function i(Y,C){const{protocol:L}=await r(Y,1,void 0,C);return{protocol:L}}async function n(Y,C,L){const{protocol:U,firstMessage:W}=await r(Y,2,C,L),q=W&&W.debugPort;return{protocol:U,debugPort:q}}async function o(Y,C,L){const U=Date.now(),W=x(Y,3),{protocol:q}=await u(Y,3,C,L);return Y.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${ce(U)}!`),q}async function k(Y,C,L){const{connectTo:U,connectionToken:W}=await Y.addressProvider.getAddress();return{commit:Y.commit,quality:Y.quality,connectTo:U,connectionToken:W,reconnectionToken:C,reconnectionProtocol:L,remoteSocketFactoryService:Y.remoteSocketFactoryService,signService:Y.signService,logService:Y.logService}}async function I(Y,C,L){return v(Y,async U=>{const{protocol:W}=await i(U,s.CancellationToken.None);return new G(Y,C,L,U.reconnectionToken,W)})}e.$Wk=I;async function D(Y,C){return v(Y,async L=>{const{protocol:U,debugPort:W}=await n(L,C,s.CancellationToken.None);return new K(Y,C,L.reconnectionToken,U,W)})}e.$Xk=D;async function v(Y,C){for(let U=1;;U++)try{const W=(0,b.$3f)(),q=await k(Y,W,null);return await C(q)}catch(W){if(U<5)Y.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),Y.logService.error(W);else throw Y.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Y.logService.error(W),oe.triggerPermanentFailure(0,0,p.$Lk.isHandled(W)),W}}async function R(Y,C,L){const U=await k(Y,(0,b.$3f)(),null);return await o(U,{host:C,port:L},s.CancellationToken.None)}e.$Yk=R;function j(Y){return(0,P.$tg)(C=>new Promise((L,U)=>{const W=setTimeout(L,Y*1e3);C.onCancellationRequested(()=>{clearTimeout(W),L()})}))}var N;(function(Y){Y[Y.ConnectionLost=0]="ConnectionLost",Y[Y.ReconnectionWait=1]="ReconnectionWait",Y[Y.ReconnectionRunning=2]="ReconnectionRunning",Y[Y.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Y[Y.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class z{constructor(C,L){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.type=0}}e.$Zk=z;class se{constructor(C,L,U,W){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.durationSeconds=U,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.$1k=se;class ee{constructor(C,L,U){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.attempt=U,this.type=2}}e.$2k=ee;class ae{constructor(C,L,U){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.attempt=U,this.type=4}}e.$3k=ae;class ne{constructor(C,L,U,W){this.reconnectionToken=C,this.millisSinceLastIncomingData=L,this.attempt=U,this.handled=W,this.type=3}}e.$4k=ne;class oe extends S.$jc{static triggerPermanentFailure(C,L,U){this._permanentFailure=!0,this.f=C,this.g=L,this.h=U,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(C=>C.y())}static debugPauseSocketWriting(){this.j.forEach(C=>C.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||oe._permanentFailure}constructor(C,L,U,W,q){super(),this.t=C,this.u=L,this.reconnectionToken=U,this.protocol=W,this.w=q,this.m=this.B(new A.$ed),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(W.onSocketClose(V=>{const re=Q(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(V=>{const re=Q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),oe.j.push(this),this.B((0,S.$hc)(()=>{const V=oe.j.indexOf(this);V>=0&&oe.j.splice(V,1)})),this.n&&this.D(oe.f,oe.g,oe.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const C=Q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${C} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const W=U<L.length?L[U]:L[L.length-1];try{if(W>0){const V=j(W);this.m.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,V)),this.u.logService.info(`${C} waiting for ${W} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${C} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this.u.logService.info(`${C} resolving connection...`);const q=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${C} connecting to ${q.connectTo}...`),await this.G(q,c(y)),this.u.logService.info(`${C} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${C} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this.u.logService.error(`${C} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(p.$Lk.isTemporarilyNotAvailable(q)){this.u.logService.info(`${C} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.u.logService.info(`${C} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((0,M.$2)(q)){this.u.logService.info(`${C} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if(q instanceof p.$Lk){this.u.logService.error(`${C} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,p.$Lk.isHandled(q));break}this.u.logService.error(`${C} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this.n&&!this.s)}C(C,L,U){this.w?oe.triggerPermanentFailure(C,L,U):this.D(C,L,U)}D(C,L,U){this.m.fire(new ne(this.reconnectionToken,C,L,U)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5k=oe;class G extends oe{constructor(C,L,U,W,q){super(1,C,W,q,!0),this.client=this.B(new $.$mh(q,{remoteAuthority:L,clientId:U},C.ipcLogger))}async G(C,L){await i(C,L)}}e.$6k=G;class K extends oe{constructor(C,L,U,W,q){super(2,C,U,W,!1),this.H=L,this.debugPort=q}async G(C,L){await n(C,this.H,L)}}e.$7k=K;function B(Y){try{Y.acceptDisconnect();const C=Y.getSocket();Y.dispose(),C.dispose()}catch(C){(0,M.$Y)(C)}}function F(Y){if(Y&&Y.type==="error"){const C=new Error(`Connection error: ${Y.reason}`);return C.code="VSCODE_CONNECTION_ERROR",C}return null}function T(Y,C){for(;Y.length<C;)Y+=" ";return Y}function H(Y,C){return`[remote-connection][${T(g(Y),13)}][${C.substr(0,5)}\u2026]`}function Q(Y,C,L){return`${H(Y,C)}[${L?"reconnect":"initial"}]`}function x(Y,C){return`${Q(C,Y.reconnectionToken,!!Y.reconnectionProtocol)}[${Y.connectTo}]`}function ce(Y){return`${Date.now()-Y} ms`}}),define(te[241],ie([0,1,2,6]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=void 0,e.$Sk=(0,O.$Ah)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(A,S){return this.a[A]??=[],this.a[A].push(S),(0,P.$hc)(()=>{const h=this.a[A]?.indexOf(S);typeof h=="number"&&h>=0&&this.a[A]?.splice(h,1)})}b(A){return(this.a[A.type]||[]).find(h=>h.supports(A))}connect(A,S,h,l){const b=this.b(A);if(!b)throw new Error(`No socket factory found for ${A}`);return b.connect(A,S,h,l)}}e.$Tk=s}),define(te[242],ie([0,1,27,47,21,113]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P5b=void 0;let A;async function S(f=!1){return(A===void 0||f)&&(A=h()),A}e.$P5b=S;async function h(){const f=l();if(f===void 0)return!1;if(f>=22e3){const y=$();if(y)return new Promise(w=>{O.execFile(y,["--status"],g=>w(!g))})}else{const y=p();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(f)return parseInt(f[3])}function b(f){const y=process.env.SystemRoot;if(y){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,w?"Sysnative":"System32",f)}}function $(){return b("wsl.exe")}function p(){return b("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,14,2,182,59,6,5,43]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Ho=(0,S.$Ah)("requestService");class b{constructor(d){this.b=d}toJSON(){if(!this.a){const d=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?d[t]="*****":d[t]=this.b[t];this.a=d}return this.a}}class $ extends s.$jc{constructor(d){super(),this.b=0,this.a=d.createLogger("network",{name:(0,M.localize)(0,null),when:h.$ij.isEqualTo((0,h.$gj)(h.LogLevel.Trace)).serialize()})}async c(d,t,u){const r=`${d} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new b(t.headers??{}));try{const i=await u();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,O.$8)(i)),i}}}e.$Io=$;function p(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Jo=p;function f(E){return E.res.statusCode===204}async function y(E){return f(E)?null:(await(0,P.$Qd)(E.stream)).toString()}e.$Ko=y;async function w(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.$Lo=w;async function g(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const t=(await(0,P.$Qd)(E.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}e.$Mo=g;function c(E){m(E)}e.$No=c;let a;function m(E){const d=l.$7m.as(A.$_m.Configuration),t=a;a={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0}}},d.updateConfigurations({add:[a],remove:t?[t]:[]})}m(1)}),define(te[243],ie([0,1,17,22]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class s{constructor(S){this.a=S}listen(S,h){throw new Error("Invalid listen")}call(S,h,l,b=O.CancellationToken.None){switch(h){case"request":return this.a.request(l[0],b).then(async({res:$,stream:p})=>{const f=await(0,P.$Qd)(p);return[{statusCode:$.statusCode,headers:$.headers},f]});case"resolveProxy":return this.a.resolveProxy(l[0])}throw new Error("Invalid call")}}e.$Jq=s;class M{constructor(S){this.a=S}async request(S,h){const[l,b]=await this.a.call("request",[S],h);return{res:l,stream:(0,P.$Sd)(b)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Kq=M}),define(te[244],ie([0,1,245,12]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;function s(A,S){return A.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:A.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(A,S,h={}){const l=(0,P.parse)(A),b=h.proxyUrl||s(l,S);if(!b)return null;const $=(0,P.parse)(b);if(!/^https?:$/.test($.protocol||""))return null;const p={host:$.hostname||"",port:$.port||($.protocol==="https"?"443":"80"),auth:$.auth,rejectUnauthorized:(0,O.$of)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((f,y)=>{J(["http-proxy-agent"],f,y)}))(p):new(await new Promise((f,y)=>{J(["https-proxy-agent"],f,y)}))(p)}e.$Lq=M}),define(te[246],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=e.$a6b=e.$_5b=void 0,e.$_5b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$a6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$b6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[94],ie([0,1,47,9,183,22,50,14,4,31,108,63,8,139]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0;let y;async function w(c,a,m,E){return m["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,$.$Fl)(E)&&!m["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,$.$Fl)(E)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(d,t)=>{const u=new M.$od;let r=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,f.$Gl)(i,1,120)*1e3);const n=setTimeout(()=>{u.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{d(await g(a,u.token))}catch(o){!(0,S.$2)(o)&&!u.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,A.$li)(o)))):d({})}finally{clearTimeout(n),u.dispose()}})),y)}e.$Ll=w;async function g(c,a){const m=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",m);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",E);const d=(0,l.$3f)().replace(/-/g,"").substr(0,12),t=new RegExp(d+"({.*})"+d),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",u);const r=await(0,b.$vl)(h.OS,u);return c.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(a.isCancellationRequested)return n(new S.$3);const o=(0,O.$_d)(r);let k,I;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(k=`& '${process.execPath}' ${D} -p '''${d}'' + JSON.stringify(process.env) + ''${d}'''`,I=["-Login","-Command"]):o==="nu"?(k=`^'${process.execPath}' ${D} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,I=["-i","-l","-c"]):(k=`'${process.execPath}' ${D} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,o==="tcsh"||o==="csh"?I=["-ic"]:I=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),k);const v=(0,P.spawn)(r,[...I,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});a.onCancellationRequested(()=>(v.kill(),n(new S.$3))),v.on("error",N=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$li)(N)),n(N)});const R=[];v.stdout.on("data",N=>R.push(N));const j=[];v.stderr.on("data",N=>j.push(N)),v.on("close",(N,z)=>{const se=Buffer.concat(R).toString("utf8");c.trace("getUnixShellEnvironment#raw",se);const ee=Buffer.concat(j).toString("utf8");if(ee.trim()&&c.trace("getUnixShellEnvironment#stderr",ee),N||z)return n(new Error((0,s.localize)(2,null,N,z)));const ae=t.exec(se),ne=ae?ae[1]:"{}";try{const oe=JSON.parse(ne);m?oe.ELECTRON_RUN_AS_NODE=m:delete oe.ELECTRON_RUN_AS_NODE,E?oe.ELECTRON_NO_ATTACH_CONSOLE=E:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){c.error("getUnixShellEnvironment#errorCaught",(0,A.$li)(oe)),n(oe)}})})}}),define(te[247],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c2b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const A=String(P.a++);return this.b.set(A,M),{id:A,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const A=this.b.get(s.id);if(!A)return!1;this.b.delete(s.id);try{return A.validate(M)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$c2b=P}),define(te[95],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=void 0,e.$Uk="signService",e.$Vk=(0,P.$Ah)(e.$Uk)}),define(te[248],ie([0,1,247]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=void 0;class O extends P.$c2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(A=>new A.signer().sign(M))}h(){return new Promise((M,A)=>J(["vsda"],M,A))}}e.$Z6b=O}),define(te[33],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=void 0,e.$0M=(0,P.$Ah)("stateReadService"),e.$$M=(0,P.$Ah)("stateService")}),define(te[121],ie([0,1,8,17,2,12,36,16,5]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=e.$_M=e.SaveStrategy=void 0;var l;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class b extends s.$jc{constructor(y,w,g,c){super(),this.h=y,this.j=g,this.m=c,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new P.$Dg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.j.error(y)}}getItem(y,w){const g=this.a[y];return(0,M.$rf)(g)?w:g}setItem(y,w){this.setItems([{key:y,data:w}])}setItems(y){let w=!1;for(const{key:g,data:c}of y)this.a[g]!==c&&((0,M.$rf)(c)?(0,M.$pf)(this.a[g])||(this.a[g]=void 0,w=!0):(this.a[g]=c,w=!0));w&&this.r()}removeItem(y){(0,M.$pf)(this.a[y])||(this.a[y]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.m.writeFile(this.h,O.$Ed.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$_M=b;let $=class extends s.$jc{constructor(y,w,g,c){super(),this.a=this.B(new b(w.stateResource,y,g,c))}async init(){await this.a.init()}getItem(y,w){return this.a.getItem(y,w)}};e.$aN=$,e.$aN=$=ke([_(1,A.$Hh),_(2,h.$4i),_(3,S.$5j)],$);class p extends ${setItem(y,w){this.a.setItem(y,w)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$bN=p}),define(te[122],ie([0,1,4,35,31]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function M(h){if(P.$t===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function A(h,l,b,$,p,f,y,w){const g=Object.create(null);g["common.machineId"]=f,g.sessionID=(0,s.$3f)()+Date.now(),g.commitHash=$,g.version=p,g["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,P.$h)(P.$t),g["common.nodePlatform"]=O.$2d,g["common.nodeArch"]=b,g["common.product"]=w||"desktop",y&&(g["common.msftInternal"]=y);let c=0;const a=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),P.$l&&(g["common.snap"]="true");const m=M(l);return m&&(g["common.platformDetail"]=m),g}e.$9n=A;function S(h){const l=O.env.USERDNSDOMAIN;if(!l)return!1;const b=l.toLowerCase();return h.some($=>b===$)}e.$0n=S}),define(te[25],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,P.$Ah)("telemetryService"),e.$9k=(0,P.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[249],ie([0,1,27,8,44,13,9,4,7,86,21,107,90,16,24,25]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=e.$rr=void 0;const g=new Map;async function c(t,u){const r=`${t}::${u.join(":")}`,i=g.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,k=new Map,I=2e4;function D(R,j,N,z){const se=j.substring(R.length+1);return O.Promises.withAsyncBody(async ee=>{let ae;try{ae=await b.Promises.readdir(j,{withFileTypes:!0})}catch{ee();return}if(z.count>=I){z.count+=ae.length,z.maxReached=!0,ee();return}let ne=ae.length;if(ne===0){ee();return}let oe=ae;z.count+ae.length>I&&(z.maxReached=!0,ne=I-z.count,oe=ae.slice(0,ne)),z.count+=ae.length;for(const G of oe)if(G.isDirectory()){if(N.includes(G.name)||await D(R,(0,A.$8d)(j,G.name),N,z),--ne===0){ee();return}}else{const K=G.name.lastIndexOf(".");if(K>=0){const B=G.name.substring(K+1);B&&o.set(B,(o.get(B)??0)+1)}for(const B of n)B.relativePathPattern?.test(se)!==!1&&B.filePattern.test(G.name)&&k.set(B.tag,(k.get(B.tag)??0)+1);if(--ne===0){ee();return}}})}const v=O.Promises.withAsyncBody(async R=>{const j={count:0,maxReached:!1};await D(t,t,u,j);const N=await E(t);R({configFiles:a(k),fileTypes:a(o),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:N})});return g.set(r,v),v}e.$rr=c;function a(t){return Array.from(t.entries(),([u,r])=>({name:u,count:r})).sort((u,r)=>r.count-u.count)}function m(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/f.$zk.GB).toFixed(2)}GB (${(P.freemem()/f.$zk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$Gm.value()*100)}%`},u=P.cpus();return u&&u.length>0&&(t.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),t}e.$sr=m;async function E(t){try{const u=new Map,r=(0,A.$8d)(t,".vscode","launch.json"),i=await b.Promises.readFile(r),n=[],o=(0,s.$Km)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$Tm)(o)==="object"&&o.configurations)for(const k of o.configurations){const I=k.type;I&&(u.has(I)?u.set(I,u.get(I)+1):u.set(I,1))}return a(u)}catch{return[]}}e.$tr=E;let d=class{constructor(u,r){this.c=u,this.d=r}f(u){const r=[];return r.push(`OS Version:       ${u.os}`),r.push(`CPUs:             ${u.cpus}`),r.push(`Memory (System):  ${u.memory}`),r.push(`VM:               ${u.vmHint}`),r.join(`
`)}g(u){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/f.$zk.GB).toFixed(2)}GB (${(P.freemem()/f.$zk.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.$Gm.value()*100)}%`),r.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${u.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(u.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(u,r){return Promise.all([(0,$.$qr)(u.mainPID),this.k(u)]).then(async i=>{let[n,o]=i,k=this.m(u,n);return r.forEach(I=>{if((0,p.$gm)(I))k+=`
${I.errorMessage}`,o+=`
${I.errorMessage}`;else if(k+=`

Remote: ${I.hostName}`,I.processes&&(k+=`
${this.m(u,I.processes)}`),I.workspaceMetadata){o+=`
|  Remote: ${I.hostName}`;for(const D of Object.keys(I.workspaceMetadata)){const v=I.workspaceMetadata[D];let R=`${v.fileCount} files`;v.maxFilesReached&&(R=`more than ${R}`),o+=`|    Folder (${D}): ${R}`,o+=this.h(v)}}}),{processInfo:k,workspaceInfo:o}})}async getSystemInfo(u,r){const{memory:i,vmHint:n,os:o,cpus:k}=m(),I={os:o,memory:i,cpus:k,vmHint:n,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(I.load=`${P.loadavg().map(D=>Math.round(D)).join(", ")}`),S.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(u,r){const i=[];return(0,$.$qr)(u.mainPID).then(async n=>(i.push(""),i.push(this.g(u)),i.push(""),i.push(this.m(u,n)),u.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(u))),r.forEach(o=>{if((0,p.$gm)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(u,o.processes)),o.workspaceMetadata)for(const k of Object.keys(o.workspaceMetadata)){const I=o.workspaceMetadata[k];let D=`${I.fileCount} files`;I.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${k}): ${D}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(u){const r=[];let n=0;const o=(v,R)=>{const j=` ${v}(${R})`;n+j.length>60?(r.push(k),k="|                 ",n=k.length):n+=j.length,k+=j};let k="|      File types:";const I=10,D=u.fileTypes.length>I?I:u.fileTypes.length;for(let v=0;v<D;v++){const R=u.fileTypes[v];o(R.name,R.count)}if(r.push(k),u.configFiles.length>=0&&(k="|      Conf files:",n=0,u.configFiles.forEach(v=>{o(v.name,v.count)}),r.push(k)),u.launchConfigFiles.length>0){let v="|      Launch Configs:";u.launchConfigFiles.forEach(R=>{const j=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;v+=j}),r.push(v)}return r.join(`
`)}j(u){const r=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${u[i]}`).join(`
                  `)}k(u){const r=[],i=[];return u.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const k=h.URI.revive(o);if(k.scheme===M.Schemas.file){const I=k.fsPath;i.push(c(I,["node_modules",".git"]).then(D=>{let v=`${D.fileCount} files`;D.maxFilesReached&&(v=`more than ${v}`),r.push(`|    Folder (${(0,A.$_d)(I)}): ${v}`),r.push(this.h(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${I} (${D.toString()})`)}))}else r.push(`|    Folder (${k.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(u,r){const i=new Map;u.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),u.pidToNames.forEach(({pid:o,name:k})=>i.set(o,k));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(u.mainPID,i,n,r,0),n.join(`
`)}n(u,r,i,n,o){const k=o===0;let I;k?I=n.pid===u?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?I=r.get(n.pid):I=`${"  ".repeat(o)} ${n.name}`;const D=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(D/f.$zk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(n.children)&&n.children.forEach(v=>this.n(u,r,i,v,o+1))}async getWorkspaceFileExtensions(u){const r=new Set;for(const{uri:i}of u.folders){const n=h.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const o=n.fsPath;try{(await c(o,["node_modules",".git"])).fileTypes.forEach(I=>r.add(I.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(u){for(const{uri:r}of u.folders){const i=h.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const o=await c(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),o.fileTypes.forEach(k=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:k.name,count:k.count})}),o.launchConfigFiles.forEach(k=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:k.name,count:k.count})}),o.configFiles.forEach(k=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:k.name,count:k.count})})}catch{}}}};e.$ur=d,e.$ur=d=ke([_(0,w.$8k),_(1,y.$jj)],d)}),define(te[250],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=e.$e6b=void 0;class P{constructor(M){this.b=M}listen(M,A){throw new Error(`Event not found: ${A}`)}call(M,A,{eventName:S,data:h}){return this.b.forEach(l=>l.log(S,h)),Promise.resolve(null)}}e.$e6b=P;class O{constructor(M){this.b=M}log(M,A){return this.b.call("log",{eventName:M,data:A}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$f6b=O}),define(te[52],ie([0,1,37,12,3,18,60,122,25]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$$n=l;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=b,e.$ao=new b;class ${async publicLog(n,o,k){}async publicLogError(n,o,k){}}e.$bo=$,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(k,I)=>{const D=k?new Set([...k.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:D}},1e3,!0)(k=>{k.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$0h)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$fo=p;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$go=f;function y(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$ho=y;function w(i){const n=i.getValue(h.$cl),o=i.getValue(h.$dl);if(i.getValue(h.$el)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=w;function g(i){const n={},o={},k={};m(i,k);for(let I in k){I=I.length>150?I.substr(I.length-149):I;const D=k[I];typeof D=="number"?o[I]=D:typeof D=="boolean"?o[I]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${D.length}`),n[I]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[I]=D)}return{properties:n,measurements:o}}e.$jo=g;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const n=(0,A.$Ok)(i);return c.has(n)?n:"other"}e.$ko=a;function m(i,n,o=0,k){if(i)for(const I of Object.getOwnPropertyNames(i)){const D=i[I],v=k?k+I:I;Array.isArray(D)?n[v]=(0,P.$Zm)(D):D instanceof Date?n[v]=D.toISOString():(0,O.$kf)(D)?o<2?m(D,n,o+1,v+"."):n[v]=(0,P.$Zm)(D):n[v]=D}}function E(i,n){const o=i.msftInternalDomains||[],k=n.getValue("telemetry.internalTesting");return(0,S.$0n)(o)||k}e.$lo=E;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$mo=d;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const k=[];for(const R of n)for(;;){const j=R.exec(i);if(!j)break;k.push([j.index,R.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(o="";;){const R=D.exec(i);if(!R)break;const j=k.some(([N,z])=>R.index<z&&N<D.lastIndex);!I.test(R[0])&&!j&&(o+=i.substring(v,R.index)+"<REDACTED: user-file-path>",v=D.lastIndex)}return v<i.length&&(o+=i.substr(v)),o}function u(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function r(i,n){return(0,P.$Wm)(i,o=>{if(o instanceof l||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let k=o.replaceAll("%20"," ");k=t(k,n);for(const I of n)k=k.replace(I,"");return k=u(k),k}})}e.$no=r}),define(te[123],ie([0,1,26,116,120,4,7,14,35,52]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function b(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$Ge)(r.id,i.id)===0}e.$oo=b;const $=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,o)}static parse(i){const n=$.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$po=p;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=f.exec(r);return i&&i[1]?[g(i[1]),i[2]]:[g(r),void 0]}e.$qo=y;function w(r,i){return`${r}.${i}`}e.$ro=w;function g(r){return r.toLowerCase()}e.$so=g;function c(r,i){return g(w(r??s.$Ql,i))}e.$to=c;function a(r,i){const n=[],o=k=>{for(const I of n)if(I.some(D=>b(i(D),i(k))))return I;return null};for(const k of r){const I=o(k);I?I.push(k):n.push([k])}return n}e.$uo=a;function m(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$vo=m;function E(r){return{id:new l.$$n(r.identifier.id),name:new l.$$n(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$wo=E,e.$xo=new s.$Ul("pprice.better-merge");function d(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const k=o.shift();if(k&&n.every(I=>!b(I.identifier,{id:k}))){const I=r.filter(D=>b(D.identifier,{id:k}));I.length===1&&(n.push(I[0]),o.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$yo=d;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){i.debug("Error while getting the os-release file.",(0,S.$8)(k))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,i){const n=await t(r,i),o=(0,O.$Tn)(n?"alpine":M.$t,h.$3d);return i.debug("ComputeTargetPlatform:",o),o}e.$zo=u}),define(te[251],ie([0,1,205,52]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0;async function s(M,A,S,h,l,b,$){const p={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${A.nameShort})`};if((0,O.$go)(A,S)&&(0,O.$io)(h)===3){const f=await(0,P.$Zo)(S,l,b);p["X-Market-User-Id"]=f,p["VSCode-SessionId"]=$.machineId||f}return p}e.$1o=s}),define(te[252],ie([0,1,2,37,4,26,184,18,59,77,24,43,25,52]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,a,m){this.k=a,this.l=m,this.d={},this.i=new P.$ic,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$pe)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$pe)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(p.$cl)||E.affectsConfiguration(p.$el)||E.affectsConfiguration(p.$dl))&&this.m()}))}setExperimentProperty(c,a){this.d[c]=a}m(){let c=(0,f.$io)(this.k);const a=this.l.enabledTelemetryLevels;if(a){this.h=this.sendErrorTelemetry?a.error:!1;const m=a.usage?3:a.error?2:0;c=Math.min(c,m)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,a,m){this.g<a||(m=(0,O.$Xm)(m,this.d),m=(0,f.$no)(m,this.j),m=(0,O.$Xm)(m,this.c),this.b.forEach(E=>E.log(c,m)))}publicLog(c,a){this.n(c,3,a)}publicLog2(c,a){this.publicLog(c,a)}publicLogError(c,a){this.h&&this.n(c,2,a)}publicLogError2(c,a){this.publicLogError(c,a)}};e.$Oq=y,e.$Oq=y=ke([_(1,S.$7h),_(2,b.$jj)],y);function w(){const g=(0,A.localize)(0,null,l.default.nameLong),c=l.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=s.$o?"":(0,A.localize)(3,null),m=(0,A.localize)(4,null),E=(0,A.localize)(5,null),d=(0,A.localize)(6,null),t=(0,A.localize)(7,null),u=`
|       | ${m} | ${E} | ${d} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${g} ${c} ${a}

&nbsp;

${t}
${u}

&nbsp;

${r}
`}$.$7m.as(h.$_m.Configuration).registerConfiguration({id:p.$bl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[p.$cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),$.$7m.as(h.$_m.Configuration).registerConfiguration({id:p.$bl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[p.$el]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,A.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,A.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${p.$cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[253],ie([0,1,4,86,25]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=void 0;async function M(A,S){let h=A.getItem(s.$al);return(typeof h!="string"||P.$j&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,O.$Hm)(S.error.bind(S))),h}e.$H6b=M}),define(te[254],ie([0,1,25,253]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=void 0;async function s(M,A){const S=await(0,O.$H6b)(M,A);return M.setItem(P.$al,S),S}e.$I6b=s}),define(te[124],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(te[255],ie([0,1,4,124]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;const s=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(b){this.collections=b,this.a=new Map,this.b=new Map,b.forEach(($,p)=>{this.d($,p);const f=$.map.entries();let y=f.next();for(;!y.done;){const w=y.value[1],g=y.value[0];let c=this.a.get(g);if(c||(c=[],this.a.set(g,c)),c.length>0&&c[0].type===O.EnvironmentVariableMutatorType.Replace){y=f.next();continue}const a={extensionIdentifier:p,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};a.scope||delete a.scope,c.unshift(a),y=f.next()}})}async applyToProcessEnvironment(b,$,p){let f;P.$i&&(f={},Object.keys(b).forEach(y=>f[y.toLowerCase()]=y));for(const[y,w]of this.getVariableMap($)){const g=P.$i&&f[y.toLowerCase()]||y;for(const c of w){const a=p?await p(c.value):c.value;if(c.options?.applyAtProcessCreation??!0)switch(c.type){case O.EnvironmentVariableMutatorType.Append:b[g]=(b[g]||"")+a;break;case O.EnvironmentVariableMutatorType.Prepend:b[g]=a+(b[g]||"");break;case O.EnvironmentVariableMutatorType.Replace:b[g]=a;break}if(c.options?.applyAtShellIntegration??!1){const m=`VSCODE_ENV_${s.get(c.type)}`;b[m]=(b[m]?b[m]+":":"")+y+"="+this.c(a)}}}}c(b){return b.replaceAll(":","\\x3a")}diff(b,$){const p=new Map,f=new Map,y=new Map;if(b.getVariableMap($).forEach((w,g)=>{const c=this.getVariableMap($).get(g),a=S(w,c);a&&p.set(g,a)}),this.getVariableMap($).forEach((w,g)=>{const c=b.getVariableMap($).get(g),a=S(w,c);a&&y.set(g,a)}),this.getVariableMap($).forEach((w,g)=>{const c=b.getVariableMap($).get(g),a=h(w,c);a&&f.set(g,a)}),!(p.size===0&&f.size===0&&y.size===0))return{added:p,changed:f,removed:y}}getVariableMap(b){const $=new Map;for(const p of this.a.values()){const f=p.filter(y=>A(y,b));f.length>0&&$.set(f[0].variable,f)}return $}getDescriptionMap(b){const $=new Map;for(const p of this.b.values()){const f=p.filter(y=>A(y,b,!0));for(const y of f)$.set(y.extensionIdentifier,y.description)}return $}d(b,$){if(!b.descriptionMap)return;const p=b.descriptionMap.entries();let f=p.next();for(;!f.done;){const y=f.value[1],w=f.value[0];let g=this.b.get(w);g||(g=[],this.b.set(w,g));const c={extensionIdentifier:$,scope:y.scope,description:y.description};c.scope||delete c.scope,g.push(c),f=p.next()}}}e.$er=M;function A(l,b,$=!1){return l.scope?!!(l.scope.workspaceFolder&&b?.workspaceFolder&&l.scope.workspaceFolder.index===b.workspaceFolder.index):$?b===l.scope:!0}function S(l,b){if(!b)return l;const $=new Set;b.forEach(f=>$.add(f.extensionIdentifier));const p=[];return l.forEach(f=>{$.has(f.extensionIdentifier)||p.push(f)}),p.length===0?void 0:p}function h(l,b){if(!b)return;const $=new Map;b.forEach(f=>$.set(f.extensionIdentifier,f));const p=[];return l.forEach(f=>{const y=$.get(f.extensionIdentifier);y&&(f.type!==y.type||f.value!==y.value||f.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&p.push(y)}),p.length===0?void 0:p}}),define(te[256],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.$ar=e.$_q=e.$$q=void 0;function P(h){return[...h.entries()]}e.$$q=P;function O(h){return h?[...h.entries()]:[]}e.$_q=O;function s(h){return new Map(h)}e.$ar=s;function M(h){return new Map(h??[])}e.$br=M;function A(h){return Array.from(h.entries()).map(l=>[l[0],P(l[1].map),O(l[1].descriptionMap)])}e.$cr=A;function S(h){return new Map(h.map(l=>[l[0],{map:s(l[1]),descriptionMap:M(l[2])}]))}e.$dr=S}),define(te[257],ie([0,1,8,22,3,2,5]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let S=class extends M.$jc{constructor(l,b){super(),this.h=b,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$ed),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,M.$hc)(()=>{for(const $ of this.f.values())(0,M.$ec)($)}))}createRequest(l){return new Promise((b,$)=>{const p=++this.a;this.c.set(p,b),this.g.fire({requestId:p,...l});const f=new O.$od;(0,P.$Gg)(this.b,f.token).then(()=>$(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,M.$hc)(()=>f.cancel())])})}acceptReply(l,b){const $=this.c.get(l);$?(this.c.delete(l),(0,M.$ec)(this.f.get(l)||[]),this.f.delete(l),$(b)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$2q=S,e.$2q=S=ke([_(1,A.$4i)],S)}),define(te[125],ie([0,1,6,114,43]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Uq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Tq=void 0,e.$Tq=new O.$1i("terminalTabFocusMode",!1,!0);var M;(function(d){d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var A;(function(d){d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsDefaultColor="terminal.integrated.tabs.defaultColor",d.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.TabStopWidth="terminal.integrated.tabStopWidth",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorStyleInactive="terminal.integrated.cursorStyleInactive",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.TabFocusMode="terminal.integrated.tabFocusMode",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.HideOnStartup="terminal.integrated.hideOnStartup",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",d.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",d.EnableImages="terminal.integrated.enableImages",d.SmoothScrolling="terminal.integrated.smoothScrolling",d.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",d.FocusAfterRun="terminal.integrated.focusAfterRun",d.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",d.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",d.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var S;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(S||(e.PosixShellType=S={}));var h;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var l;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var b;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.PtyHostWindow="ptyHostWindow",d.Logger="logger",d.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var $;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})($||(e.ProcessPropertyType=$={})),e.$Uq=(0,P.$Ah)("ptyService");var p;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var f;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var y;(function(d){d.TerminalView="view",d.Editor="editor"})(y||(e.TerminalLocationString=y={}));var w;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var g;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var c;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var a;(function(d){d[d.Off=0]="Off",d[d.FinalTerm=1]="FinalTerm",d[d.VSCode=2]="VSCode"})(a||(e.ShellIntegrationStatus=a={}));var m;(function(d){d[d.Unknown=0]="Unknown",d[d.Shutdown=1]="Shutdown",d[d.Process=2]="Process",d[d.User=3]="User",d[d.Extension=4]="Extension"})(m||(e.TerminalExitReason=m={})),e.$Vq={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const u=this.b(t.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$7m.add(e.$Vq.Backend,new E),e.$Wq=(0,P.$Ah)("localPtyService"),e.$Xq=(0,P.$Ah)("terminalLogService")}),define(te[258],ie([0,1,71,7,186,102]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=e.$3q=void 0;function A(p,f){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...p.map(w=>({name:w.profileName,description:S(w)}))),f&&y.push(...f.map(w=>({name:w.title,description:h(w)}))),{values:y.map(w=>w.name),markdownDescriptions:y.map(w=>w.description)}}e.$3q=A;function S(p){let f=`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$Oj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?f+=`
- args: "${p.args}"`:f+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(f+=`
- overrideName: ${p.overrideName}`),p.color&&(f+=`
- color: ${p.color}`),p.env&&(f+=`
- env: ${JSON.stringify(p.env)}`),f}function h(p){return`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$Oj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function l(p,f){if(!p&&!f)return!0;if(typeof p=="string"&&typeof f=="string")return p===f;if(Array.isArray(p)&&Array.isArray(f)){if(p.length!==f.length)return!1;for(let y=0;y<p.length;y++)if(p[y]!==f[y])return!1;return!0}return!1}e.$4q=l;function b(p,f){if(!p&&!f)return!0;if(!p||!f)return!1;if(M.ThemeIcon.isThemeIcon(p)&&M.ThemeIcon.isThemeIcon(f))return p.id===f.id&&p.color===f.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof f=="object"&&"light"in f&&"dark"in f){const y=p,w=f;if((O.URI.isUri(y.light)||$(y.light))&&(O.URI.isUri(y.dark)||$(y.dark))&&(O.URI.isUri(w.light)||$(w.light))&&(O.URI.isUri(w.dark)||$(w.dark)))return y.light.path===w.light.path&&y.dark.path===w.dark.path}if(O.URI.isUri(p)&&O.URI.isUri(f)||$(p)||$(f)){const y=p,w=f;return y.path===w.path&&y.scheme===w.scheme}return!1}e.$5q=b;function $(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$6q=$}),define(te[259],ie([0,1,71,4,185,59,43,258]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.$7q=void 0,e.$7q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$8q={type:"string",enum:Array.from((0,P.$Nj)(),g=>g.id),markdownEnumDescriptions:Array.from((0,P.$Nj)(),g=>`$(${g.id})`)};const h={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$8q},color:{description:(0,s.localize)(3,null),...e.$7q},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},b={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function $(g){const c=g===2?"linux":g===1?"osx":"windows";return(0,s.localize)(7,null,(0,O.$h)(g),'```json\n"terminal.integrated.profile.'+c+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:$(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:$(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:$(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){A.$7m.as(M.$_m.Configuration).registerConfiguration(p),w()}e.$9q=f;let y;function w(g,c){const a=A.$7m.as(M.$_m.Configuration);let m;g&&(m=(0,S.$3q)(g?.profiles,c));const E=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:g?.os===3?m?.values:void 0,markdownEnumDescriptions:g?.os===3?m?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:g?.os===2?m?.values:void 0,markdownEnumDescriptions:g?.os===2?m?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:g?.os===1?m?.values:void 0,markdownEnumDescriptions:g?.os===1?m?.markdownDescriptions:void 0}}},a.updateConfigurations({add:[y],remove:E?[E]:[]})}e.$0q=w}),define(te[260],ie([0,1,27,13,37,9,4,35,26,12,21,124,256,255]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$fr=y;async function w(i,n,o,k=S.env,I=b.Promises.exists){if(M.$7d(i))return await I(i)?i:void 0;if(n===void 0&&(n=S.cwd()),M.$$d(i)!=="."){const j=M.$8d(n,i);return await I(j)?j:void 0}const v=(0,s.$2m)(k,"PATH");if(o===void 0&&(0,l.$if)(v)&&(o=v.split(M.$fe)),o===void 0||o.length===0){const j=M.$8d(n,i);return await I(j)?j:void 0}for(const j of o){let N;if(M.$7d(j)?N=M.$8d(j,i):N=M.$8d(n,j,i),await I(N))return N;if(A.$i){let z=N+".com";if(await I(z)||(z=N+".exe",await I(z)))return z}}const R=M.$8d(n,i);return await I(R)?R:void 0}e.$gr=w;function g(i,n,o,k,I){const D=A.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||D)return;const v=i.args,R=S.$2d==="win32"?M.$_d(i.executable).toLowerCase():M.$_d(i.executable),j=M.$$d(O.$1f.asFileUri("").fsPath);let N;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),A.$i){if(R==="pwsh.exe"||R==="powershell.exe")return!v||u(v)?N=m.get(a.WindowsPwsh):t(v)&&(N=m.get(a.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,h.$me)(N[N.length-1],j,""),{newArgs:N,envMixin:z}):void 0;k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(R){case"bash":return!v||v.length===0?N=m.get(a.Bash):r(v)&&(z.VSCODE_SHELL_LOGIN="1",c(n,z),N=m.get(a.Bash)),N?(N=[...N],N[N.length-1]=(0,h.$me)(N[N.length-1],j),{newArgs:N,envMixin:z}):void 0;case"fish":{const se=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=M.$8d(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${se}:${ee}`,c(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!v||u(v)?N=m.get(a.Pwsh):t(v)&&(N=m.get(a.PwshLogin)),N?(N=[...N],N[N.length-1]=(0,h.$me)(N[N.length-1],j,""),{newArgs:N,envMixin:z}):void 0;case"zsh":{if(!v||v.length===0?N=m.get(a.Zsh):r(v)?(N=m.get(a.ZshLogin),c(n,z)):(v===m.get(a.Zsh)||v===m.get(a.ZshLogin))&&(N=v),!N)return;N=[...N],N[N.length-1]=(0,h.$me)(N[N.length-1],j);let se;try{se=P.userInfo().username}catch{se="unknown"}const ee=M.$8d(P.tmpdir(),`${se}-${I.applicationName}-zsh`);z.ZDOTDIR=ee;const ae=o?.ZDOTDIR??P.homedir()??"~";z.USER_ZDOTDIR=ae;const ne=[];return ne.push({source:M.$8d(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$8d(ee,".zshrc")}),ne.push({source:M.$8d(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$8d(ee,".zprofile")}),ne.push({source:M.$8d(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$8d(ee,".zshenv")}),ne.push({source:M.$8d(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$8d(ee,".zlogin")}),{newArgs:N,envMixin:z,filesToCopy:ne}}}k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$hr=g;function c(i,n){if(A.$j&&i.environmentVariableCollections){const o=(0,p.$dr)(i.environmentVariableCollections),I=new f.$er(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),D=[];if(I)for(const v of I)v.type===$.EnvironmentVariableMutatorType.Prepend&&D.push(v.value);D.length>0&&(n.VSCODE_PATH_PREFIX=D.join(""))}}var a;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(a||(a={}));const m=new Map;m.set(a.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(a.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(a.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),m.set(a.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),m.set(a.Zsh,["-i"]),m.set(a.ZshLogin,["-il"]),m.set(a.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],d=["-nol","-nologo"];function t(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(d.includes(i[0].toLowerCase())||d.includes(i[1].toLowerCase()))}function u(i){return typeof i=="string"?d.includes(i.toLowerCase()):i.length===0||i?.length===1&&d.includes(i[0].toLowerCase())}function r(i){return i==="string"&&E.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&E.includes(i[0].toLowerCase())}}),define(te[261],ie([0,1,47,71,9,4,12,21,106,260,113]),function(J,e,P,O,s,M,A,S,h,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;let $,p=!0;function f(n,o,k,I,D=process.env,v,R,j,N){return v=v||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?y(k,v,D,R,I.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:I.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:I.getValue("terminal.integrated.defaultProfile.windows"),N,j):u(v,R,k,n&&typeof n=="object"?{...n}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,j,D)}e.$ir=f;async function y(n,o,k,I,D,v,R,j,N){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let ee=!1;(0,l.$fr)()>=16299&&(ee=!0),await a(j);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:O.$Oj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$Oj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:O.$Oj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$Oj.terminalBash,isAutoDetected:!0});const oe=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",oe],requiresPath:process.env.CMDER_ROOT?oe:{path:oe,isUnsafe:!0},isAutoDetected:!0})}r(v,ae);const ne=await w(ae.entries(),R,o,k,I,N);if(n&&D)try{const oe=await d(`${se}\\${ee?"wsl":"bash"}.exe`,R);for(const G of oe)(!v||!(G.profileName in v))&&ne.push(G)}catch{p&&(I?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return ne}async function w(n,o,k,I=process.env,D,v){const R=[];for(const[j,N]of n)R.push(g(j,N,o,k,I,D,v));return(await Promise.all(R)).filter(j=>!!j)}async function g(n,o,k,I,D=process.env,v,R){if(o===null)return;let j,N,z;if("source"in o&&!("path"in o)){const ne=$?.get(o.source);if(!ne)return;j=ne.paths,N=o.args||ne.args,o.icon?z=c(o.icon):ne.icon&&(z=ne.icon)}else j=Array.isArray(o.path)?o.path:[o.path],N=M.$i||Array.isArray(o.args)?o.args:void 0,z=c(o.icon);let se;if(R){const ne=j.map(G=>typeof G=="string"?G:G.path),oe=await R(ne);se=new Array(j.length);for(let G=0;G<j.length;G++)typeof j[G]=="string"?se[G]=oe[G]:se[G]={path:oe[G],isUnsafe:!0}}else se=j.slice();let ee;if(o.requiresPath){let ne;if((0,A.$if)(o.requiresPath)?ne=o.requiresPath:(ne=o.requiresPath.path,o.requiresPath.isUnsafe&&(ee=ne)),!await I.existsFile(ne))return}const ae=await i(n,k,se,I,D,N,o.env,o.overrideName,o.isAutoDetected,ee);if(!ae){v?.debug("Terminal profile not validated",n,j);return}return ae.isAutoDetected=o.isAutoDetected,ae.icon=z,ae.color=o.color,ae}function c(n){return typeof n=="string"?{id:n}:n}async function a(n){if($&&!n)return;const[o,k]=await Promise.all([m(),n||E()]);$=new Map,$.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),$.set("PowerShell",{profileName:"PowerShell",paths:k,icon:O.$Oj.terminalPowershell})}async function m(){const n=new Set,o=await(0,l.$gr)("git.exe");if(o){const D=(0,b.dirname)(o);n.add((0,b.resolve)(D,"../.."))}function k(D,v){v&&D.add(v)}k(n,process.env.ProgramW6432),k(n,process.env.ProgramFiles),k(n,process.env["ProgramFiles(X86)"]),k(n,`${process.env.LocalAppData}\\Program`);const I=[];for(const D of n)I.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function E(){const n=[];for await(const o of(0,h.$pl)())n.push(o.exePath);return n}async function d(n,o){const k=[],I=await new Promise((R,j)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,z)=>{if(N)return j("Problem occurred when getting wsl distros");R(z)})});if(!I)return[];const D=new RegExp(/[\r?\n]/),v=I.split(D).filter(R=>R.trim().length>0&&R!=="");for(const R of v){if(R===""||R.startsWith("docker-desktop"))continue;const j=`${R} (WSL)`,N={profileName:j,path:n,args:["-d",`${R}`],isDefault:j===o,icon:t(R),isAutoDetected:!1};k.push(N)}return k}function t(n){return n.includes("Ubuntu")?O.$Oj.terminalUbuntu:n.includes("Debian")?O.$Oj.terminalDebian:O.$Oj.terminalLinux}async function u(n,o,k,I,D,v,R,j){const N=new Map;if(k){const z=(await n.readFile("/etc/shells")).toString(),se=(v||z.split(`
`)).map(ae=>{const ne=ae.indexOf("#");return ne===-1?ae:ae.substring(0,ne)}).filter(ae=>ae.trim().length>0),ee=new Map;for(const ae of se){let ne=(0,s.$_d)(ae),oe=ee.get(ne)||0;oe++,oe>1&&(ne=`${ne} (${oe})`),ee.set(ne,oe),N.set(ne,{path:ae,isAutoDetected:!0})}}return r(I,N),await w(N.entries(),D,n,j,o,R)}function r(n,o){if(n)for(const[k,I]of Object.entries(n))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?o.delete(k):(I.icon=I.icon||o.get(k)?.icon,o.set(k,I))}async function i(n,o,k,I,D,v,R,j,N,z){if(k.length===0)return Promise.resolve(void 0);const se=k.shift();if(se==="")return i(n,o,k,I,D,v,R,j,N);const ee=typeof se!="string"&&se.isUnsafe,ae=typeof se=="string"?se:se.path,ne={profileName:n,path:ae,args:v,env:R,overrideName:j,isAutoDetected:N,isDefault:n===o,isUnsafePath:ee,requiresUnsafePath:z};if((0,s.$_d)(ae)===ae){const G=D.PATH?D.PATH.split(s.$fe):void 0,K=await(0,l.$gr)(ae,void 0,G,void 0,I.existsFile);return K?(ne.path=K,ne.isFromPath=!0,ne):i(n,o,k,I,D,v)}return await I.existsFile((0,s.$6d)(ae))?ne:i(n,o,k,I,D,v,R,j,N)}}),define(te[262],ie([0,1,3,2,4,42,18,5,224,94,257,125,259,261,108,69]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;var g;(function(a){a[a.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let c=class extends O.$jc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(m,E,d,t){super(),this.M=m,this.N=E,this.O=d,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$ed),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$ed),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$ed),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$ed),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$ed),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$ed),this.onProcessData=this.D.event,this.F=this.B(new P.$ed),this.onProcessReady=this.F.event,this.G=this.B(new P.$ed),this.onProcessReplay=this.G.event,this.H=this.B(new P.$ed),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$ed),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$ed),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$ed),this.onProcessExit=this.L.event,(0,p.$9q)(),this.B(this.M),this.B((0,O.$hc)(()=>this.W())),this.j=this.B(new b.$2q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,l.$Ll)(this.N,this.O,{_:[]},process.env)}catch(m){return this.O.error("ptyHost was unable to resolve shell environment",m),{}}}U(){const m=this.M.start(),E=m.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel($.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(m.onDidProcessExit(u=>{this.u.fire(u.code),!this.m&&!this.q.isDisposed&&(this.n<=g.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${u.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const t=M.ProxyChannel.toService(E.getChannel($.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(u=>this.D.fire(u))),this.B(t.onProcessReady(u=>this.F.fire(u))),this.B(t.onProcessExit(u=>this.L.fire(u))),this.B(t.onDidChangeProperty(u=>this.J.fire(u))),this.B(t.onProcessReplay(u=>this.G.fire(u))),this.B(t.onProcessOrphanQuestion(u=>this.H.fire(u))),this.B(t.onDidRequestDetach(u=>this.I.fire(u))),this.B(new h.$1q(this.P,E.getChannel($.TerminalIpcChannels.Logger))),this.a=m,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[m,t]}async createProcess(m,E,d,t,u,r,i,n,o,k,I){const D=setTimeout(()=>this.$(),$.HeartbeatConstants.CreateProcessTimeout),v=await this.f.createProcess(m,E,d,t,u,r,i,n,o,k,I);return clearTimeout(D),v}updateTitle(m,E,d){return this.f.updateTitle(m,E,d)}updateIcon(m,E,d,t){return this.f.updateIcon(m,E,d,t)}attachToProcess(m){return this.f.attachToProcess(m)}detachFromProcess(m,E){return this.f.detachFromProcess(m,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(m){return this.f.start(m)}shutdown(m,E){return this.f.shutdown(m,E)}input(m,E){return this.f.input(m,E)}processBinary(m,E){return this.f.processBinary(m,E)}resize(m,E,d){return this.f.resize(m,E,d)}clearBuffer(m){return this.f.clearBuffer(m)}acknowledgeDataEvent(m,E){return this.f.acknowledgeDataEvent(m,E)}setUnicodeVersion(m,E){return this.f.setUnicodeVersion(m,E)}getInitialCwd(m){return this.f.getInitialCwd(m)}getCwd(m){return this.f.getCwd(m)}async getLatency(){const m=new w.$ad,E=await this.f.getLatency();return m.stop(),[{label:"ptyhostservice<->ptyhost",latency:m.elapsed()},...E]}orphanQuestionReply(m){return this.f.orphanQuestionReply(m)}installAutoReply(m,E){return this.f.installAutoReply(m,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(m){return this.f.uninstallAutoReply(m)}getDefaultSystemShell(m){return this.g?.getDefaultSystemShell(m)??(0,y.$vl)(m??s.OS,process.env)}async getProfiles(m,E,d,t=!1){const u=await this.S();return(0,f.$ir)(E,d,t,this.N,u,void 0,this.O,this.bb.bind(this,m))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(m,E){return this.f.getWslPath(m,E)}getRevivedPtyNewId(m,E){return this.f.getRevivedPtyNewId(m,E)}setTerminalLayoutInfo(m){return this.f.setTerminalLayoutInfo(m)}async getTerminalLayoutInfo(m){return this.g?.getTerminalLayoutInfo(m)}async requestDetachInstance(m,E){return this.f.requestDetachInstance(m,E)}async acceptDetachInstanceReply(m,E){return this.f.acceptDetachInstanceReply(m,E)}async freePortKillProcess(m){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(m)}async serializeTerminalState(m){return this.f.serializeTerminalState(m)}async reviveTerminalProcesses(m,E,d){return this.f.reviveTerminalProcesses(m,E,d)}async refreshProperty(m,E){return this.f.refreshProperty(m,E)}async updateProperty(m,E,d){return this.f.updateProperty(m,E,d)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(m){this.ab(),this.s=setTimeout(()=>this.Y(),m?$.HeartbeatConstants.ConnectingBeatInterval:$.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${$.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),$.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${($.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.FirstWaitMultiplier+$.HeartbeatConstants.BeatInterval*$.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${$.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(m,E){return this.j.createRequest({workspaceId:m,originalText:E})}async acceptPtyHostResolvedVariables(m,E){this.j.acceptReply(m,E)}};e.$jr=c,e.$jr=c=ke([_(1,A.$7h),_(2,S.$4i),_(3,S.$5i)],c)}),define(te[79],ie([0,1,15,3,2,4,18,6,33]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O5b=e.$N5b=void 0;const l="#FFFFFF",b="#1E1E1E",$="#000000",p="#FFFFFF",f="theme",y="themeBackground",w="windowSplash";e.$N5b=(0,S.$Ah)("themeMainService");let g=class extends s.$jc{constructor(a,m){super(),this.b=a,this.c=m,this.a=this.B(new O.$ed),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const a=this.getColorScheme();if(a.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return a.dark?$:p;let m=this.b.getItem(y,null);if(!m)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":m=l;break;case"hc-black":m=$;break;case"hc-light":m=p;break;default:m=b}return M.$j&&m.toUpperCase()===b&&(m="#171717"),m}saveWindowSplash(a,m){this.b.setItems([{key:f,data:m.baseTheme},{key:y,data:m.colorInfo.background},{key:w,data:m}]),typeof a=="number"&&this.f(a,m)}f(a,m){for(const E of P.BrowserWindow.getAllWindows())if(E.id===a){E.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$O5b=g,e.$O5b=g=ke([_(0,h.$$M),_(1,A.$7h)],g)}),define(te[126],ie([0,1,3,18,6,5]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.ProvidedOnAutoForward=e.$Vz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Uz=e.$Tz=void 0,e.$Tz=(0,s.$Ah)("tunnelService"),e.$Uz=(0,s.$Ah)("sharedTunnelsService");var A;(function(g){g.Http="http",g.Https="https"})(A||(e.TunnelProtocol=A={}));var S;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(S||(e.TunnelPrivacyId=S={}));function h(g){return!!g.forwardPort}e.$Vz=h;var l;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function b(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(c)return{address:c[1],port:+c[2]}}e.$Wz=b,e.$Xz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function $(g){return e.$Xz.indexOf(g)>=0}e.$Yz=$,e.$Zz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(g){return e.$Zz.indexOf(g)>=0}e.$1z=p;function f(g,c,a,m){if(a===1)return!1;if(a===2&&p(c)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(E?.length===4&&parseInt(E[1])>=18)return!1}return g<1024}e.$2z=f;class y{constructor(c,a,m){this.remoteAddress=c,this.localAddress=a,this.b=m,this.a=new P.$ed,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$3z=y;let w=class{constructor(c,a){this.j=c,this.k=a,this.a=new P.$ed,this.onTunnelOpened=this.a.event,this.b=new P.$ed,this.onTunnelClosed=this.b.event,this.c=new P.$ed,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],a=Array.from(this.e.values());for(const m of a){const E=Array.from(m.values());for(const d of E){const t=await d.value;t&&typeof t!="string"&&c.push(t)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:a}of c.values())await a.then(m=>typeof m!="string"?m?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,a,m,E,d){this.p(c,a,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:a,localAddress:m,privacy:E,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,a){(p(c)||$(c))&&(c=e.$Xz[0]);const m=this.r(c,a);if(m)return++m.refcount,m.value}openTunnel(c,a,m,E,d,t=!1,u,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${d}.`);const i=this.f??c;if(!i)return;if(a||(a="localhost"),E||(E=this.l),this.f&&this.i.has(m)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,a,m,E,d,t,u,r);return n?n.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,m),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,m);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(o);return(o.tunnelRemoteHost!==a||o.tunnelRemotePort!==m)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&o.privacy!==u&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const a=this.e.get(c.tunnelRemoteHost);if(a){const m=a.get(c.tunnelRemotePort);m&&(m.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,m))}}}}async o(c,a,m){if(m.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${a}.`);const E=m.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(a),E}}async closeTunnel(c,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${a} `);const m=this.e.get(c);if(m&&m.has(a)){const E=m.get(a);E.refcount=0,await this.o(c,a,E)}}p(c,a,m){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(a,{refcount:1,value:m})}async q(c,a){const m=this.e.get(c);if(m){const E=m.get(a),d=E?await E.value:void 0;(!d||typeof d=="string")&&m.delete(a),m.size===0&&this.e.delete(c)}}r(c,a){const m=[c];$(c)?(m.push(...e.$Xz),m.push(...e.$Zz)):p(c)&&m.push(...e.$Zz);const E=m.map(d=>this.e.get(d));for(const d of E){const t=d?.get(a);if(t)return t}}canTunnel(c){return!!b(c)}t(c,a,m,E,d,t,u){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${E}.`);const r=m;this.i.add(r);const i=E===void 0?m:E,n={elevationRequired:d?this.isPortPrivileged(i):!1},o={remoteAddress:{host:a,port:m},localAddressPort:E,privacy:t,public:t?t!==S.Private:void 0,protocol:u},k=c.forwardPort(o,n);return k?(this.p(a,m,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),k}};e.$4z=w,e.$4z=w=ke([_(0,M.$4i),_(1,O.$7h)],w)}),define(te[48],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JT=e.$IT=e.DisablementReason=e.UpdateType=e.StateType=void 0;var O;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(O||(e.StateType=O={}));var s;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$IT={Uninitialized:{type:"uninitialized"},Disabled:A=>({type:"disabled",reason:A}),Idle:(A,S)=>({type:"idle",updateType:A,error:S}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.$JT=(0,P.$Ah)("updateService")}),define(te[263],ie([0,1,4,187,59,43]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$7m.as(s.$_m.Configuration).registerConfiguration({id:"update",order:15,title:(0,O.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,O.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,O.localize)(2,null),(0,O.localize)(3,null),(0,O.localize)(4,null),(0,O.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,O.localize)(6,null),deprecationMessage:(0,O.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,O.localize)(8,null),description:(0,O.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,O.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[264],ie([0,1,3,48]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=e.$g6b=void 0;class s{constructor(S){this.a=S}listen(S,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(S,h,l){switch(h){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.$g6b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$ed,this.onStateChange=this.a.event,this.b=O.$IT.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$h6b=M}),define(te[40],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=void 0,e.$Bk=(0,P.$Ah)("IUriIdentityService")}),define(te[265],ie([0,1,40,206,16,19,140,3,2]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class l{static{this._clock=0}constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let b=class{constructor(p){this.g=p,this.c=new h.$ic,this.f=2**16;const f=new Map,y=w=>{let g=f.get(w.scheme);return g===void 0&&(g=p.hasProvider(w)&&!this.g.hasCapability(w,1024),f.set(w.scheme,g)),g};this.c.add(S.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new M.$9f(y),this.d=new A.$mr((w,g)=>this.extUri.compare(w,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,M.$ig)(p));const f=this.d.get(p);return f?f.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);l._clock=0,this.d.clear();const f=this.f*.5;for(let y=0;y<f;y++)this.d.set(p[y][0],p[y][1].touch())}};e.$nr=b,e.$nr=b=ke([_(0,s.$5j)],b),(0,O.$kr)(P.$Bk,b,1)}),define(te[127],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xT=void 0,e.$xT=(0,P.$Ah)("urlService")}),define(te[266],ie([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=e.$p6b=e.$o6b=void 0;class O{constructor(S){this.a=S}listen(S,h){throw new Error(`Event not found: ${h}`)}call(S,h,l){switch(h){case"handleURL":return this.a.handleURL(P.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.$o6b=O;class s{constructor(S){this.a=S}handleURL(S,h){return this.a.call("handleURL",[S.toJSON(),h])}}e.$p6b=s;class M{constructor(S,h){this.a=S,this.b=h}async routeCall(S,h,l,b){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const $=P.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",$.toString(!0)),$.query){const p=/\bwindowId=(\d+)/.exec($.query);if(p){const f=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,$.toString(!0));const y=new RegExp(`window:${f}`),w=S.connections.find(g=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",g.ctx),y.test(g.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",$.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",$.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",$.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,h,l,b)}routeEvent(S,h){throw new Error(`Event not found: ${h}`)}}e.$q6b=M}),define(te[267],ie([0,1,8,2,7,24]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zT=e.$yT=void 0;class A extends O.$jc{constructor(){super(...arguments),this.a=new Set}open(l,b){const $=[...this.a.values()];return(0,P.$Jg)($.map(p=>()=>p.handleURL(l,b)),void 0,!1).then(p=>p||!1)}registerHandler(l){return this.a.add(l),(0,O.$hc)(()=>this.a.delete(l))}}e.$yT=A;let S=class extends A{constructor(l){super(),this.b=l}create(l){let{authority:b,path:$,query:p,fragment:f}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&$&&$.indexOf("/")!==0&&($=`/${$}`),s.URI.from({scheme:this.b.urlProtocol,authority:b,path:$,query:p,fragment:f})}};e.$zT=S,e.$zT=S=ke([_(0,M.$jj)],S)}),define(te[268],ie([0,1,15,8,3,2,4,7]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;class h{constructor(b,$,p,f,y,w){if(this.f=$,this.g=w,this.a=[],this.b=0,this.c=M.$jc.None,this.d=new M.$ic,b&&(w.trace("ElectronURLListener initialUrisToHandle:",b.map(a=>a.originalUrl)),this.a=b),A.$i){const a=f.isBuilt?[]:[`"${f.appRoot}"`];a.push("--open-url","--"),P.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,a)}const g=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(a,m)=>({event:a,url:m})),({event:a,url:m})=>(a.preventDefault(),m));this.d.add(g(a=>{const m=this.h(a);m&&this.f.open(m,{originalUrl:a})})),p.getWindows().filter(a=>a.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(p.onDidSignalReadyWindow)(this.i,this,this.d))}h(b){try{return S.URI.parse(b)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const $ of this.a)await this.f.open($.uri,{originalUrl:$.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",$.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",$.originalUrl),b.push($));b.length!==0&&(this.a=b,this.c=(0,O.$Hg)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$r6b=h}),define(te[269],ie([0,1,3,2,16,56,58,17,12]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;class l extends O.$jc{get capabilities(){return this.f.capabilities&-5}constructor($,p,f,y){super(),this.c=$,this.f=p,this.g=f,this.h=y,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new P.$ed),this.onDidChangeFile=this.a.event,this.b=A.$Gh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(w=>this.j(w)))}watch($,p){this.b.set($,$);const f=this.f.watch(this.m($),p);return(0,O.$hc)(()=>{this.b.delete($),f.dispose()})}stat($){return this.f.stat(this.m($))}mkdir($){return this.f.mkdir(this.m($))}rename($,p,f){return this.f.rename(this.m($),this.m(p),f)}readFile($){return this.f.readFile(this.m($),{atomic:!0})}readFileStream($,p,f){const y=(0,M.$sd)(w=>S.$Ed.concat(w.map(g=>S.$Ed.wrap(g))).buffer);return(async()=>{try{const w=await this.readFile($);y.end(w)}catch(w){y.error(w),y.end()}})(),y}readdir($){return this.f.readdir(this.m($))}writeFile($,p,f){return!(0,h.$kf)(f.atomic)&&(0,s.$ak)(this.f)&&(f={...f,atomic:{postfix:".vsctmp"}}),this.f.writeFile(this.m($),p,f)}delete($,p){return this.f.delete(this.m($),p)}copy($,p,f){if((0,s.$8j)(this.f))return this.f.copy(this.m($),this.m(p),f);throw new Error("copy not supported")}j($){const p=[];for(const f of $){if(f.resource.scheme!==this.c)continue;const y=this.n(f.resource);this.b.findSubstr(y)&&p.push({resource:y,type:f.type})}p.length&&(this.h.debug("User data changed"),this.a.fire(p))}m($){return $.with({scheme:this.c})}n($){return $.with({scheme:this.g})}}e.$36b=l}),define(te[270],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0,e.$K6b="utilityProcessWorker"}),define(te[271],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s6b=void 0,e.$s6b=(0,P.$Ah)("webviewManagerService")}),define(te[272],ie([0,1,15,2,13,7]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t6b=void 0;class A extends O.$jc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,h)}b(h,l){try{const b=M.URI.parse(h.url),$=A.a.get(b.path);if(typeof $=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${$}`,f=s.$1f.asFileUri(p);return l({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$t6b=A}),define(te[80],ie([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$MD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(b){return!!b.workspaceUri}e.$ND=O;function s(b){return!!b.folderUri}e.$OD=s;function M(b){return!!b.fileUri}e.$PD=M;function A(b){const $=S(b),p=b.getValue("window.menuBarVisibility");return p==="default"||$==="native"&&p==="compact"||P.$j&&P.$m?"classic":p}e.$QD=A;function S(b){if(P.$o)return"custom";const $=b.getValue("window");if($){if(P.$j&&$.nativeTabs===!0||P.$j&&$.nativeFullScreen===!1)return"native";const y=$.titleBarStyle;if(y==="native"||y==="custom")return y}return P.$k?"native":"custom"}e.$RD=S;function h(b){return!(!P.$i||P.$o||S(b)==="native")}e.$SD=h;function l(b=0){return Math.pow(1.2,b)}e.$TD=l}),define(te[128],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$34b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var O;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(O||(e.UnloadReason=O={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$34b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var A;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(A||(e.WindowError=A={}))}),define(te[30],ie([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$f5b=void 0,e.$f5b=(0,P.$Ah)("windowsMainService");var O;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(O||(e.OpenContext=O={}))}),define(te[273],ie([0,1,15,23,4,7,21,18,63,6,5,127,30]),function(J,e,P,O,s,M,A,S,h,l,b,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=e.$Y5b=e.ID=void 0,e.ID="launchMainService",e.$Y5b=(0,l.$Ah)(e.ID);let f=class{constructor(w,g,c,a){this.a=w,this.b=g,this.c=c,this.d=a}async start(w,g){this.a.trace("Received data from other instance: ",w,g),s.$j&&P.app.focus({steal:!0});const c=this.e(w);if(c.length){let a=Promise.resolve();if(this.b.getWindowCount()===0){const m=(0,O.$Lb)(await this.b.openEmptyWindow({context:4}));m&&(a=m.ready())}a.then(()=>{for(const{uri:m,originalUrl:E}of c)this.c.open(m,{originalUrl:E})})}else return this.f(w,g)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,O.$Eb)(w._urls.map(g=>{try{return{uri:M.URI.parse(g),originalUrl:g}}catch{return null}})):[]}async f(w,g){const c=(0,h.$Fl)(g)?0:4;let a=[];const m=w.wait&&w.waitMarkerFilePath?M.URI.file(w.waitMarkerFilePath):void 0,E=w.remote||void 0,d={context:c,cli:w,userEnv:g,waitMarkerFileURI:m,remoteAuthority:E,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,d);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||d.forceProfile||d.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)a=await this.b.open({...d,forceNewWindow:!0,forceEmpty:!0});else{const u=this.b.getLastActiveWindow();u?(this.b.openExistingWindow(u,d),a=[u]):a=await this.b.open({...d,forceEmpty:!0})}}else a=await this.b.open({...d,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(m&&a.length===1&&a[0])return Promise.race([a[0].whenClosedOrLoaded,(0,A.whenDeleted)(m.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Z5b=f,e.$Z5b=f=ke([_(0,b.$4i),_(1,p.$f5b),_(2,$.$xT),_(3,S.$7h)],f)}),define(te[274],ie([0,1,15,3,2,272,30]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=void 0;let S=class extends s.$jc{constructor(l){super(),this.b=l,this.a=this.B(new O.$ed),this.onFoundInFrame=this.a.event,this.B(new M.$t6b)}async setIgnoreMenuShortcuts(l,b){let $;if(typeof l.windowId=="number"){const{windowId:p}=l,f=this.b.getWindowById(p);if(!f?.win)throw new Error(`Invalid windowId: ${p}`);$=f.win.webContents}else{const{webContentsId:p}=l;if($=P.webContents.fromId(p),!$)throw new Error(`Invalid webContentsId: ${p}`)}$.isDestroyed()||$.setIgnoreMenuShortcuts(b)}async findInFrame(l,b,$,p){const y=this.c(l,b);if(typeof y.findInFrame=="function"){y.findInFrame($,{findNext:p.findNext,forward:p.forward});const w=(g,c)=>{c.finalUpdate&&(this.a.fire(c),y.removeListener("found-in-frame",w))};y.on("found-in-frame",w)}}async stopFindInFrame(l,b,$){const f=this.c(l,b);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame($.keepSelection?"keepSelection":"clearSelection")}c(l,b){const $=this.b.getWindowById(l.windowId);if(!$?.win)throw new Error(`Invalid windowId: ${l}`);const p=$.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===b);if(!p)throw new Error(`Unknown frame: ${b}`);return p}};e.$u6b=S,e.$u6b=S=ke([_(0,A.$f5b)],S)}),define(te[275],ie([0,1,8,3,2]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;class M extends s.$jc{constructor({onDidOpenWindow:S,onDidFocusWindow:h,getActiveWindowId:l}){super(),this.a=this.B(new s.$ic),O.Event.latch(O.Event.any(S,h))(this.f,this,this.a),this.b=(0,P.$tg)(()=>l()),(async()=>{try{const $=await this.b;this.c=typeof this.c=="number"?this.c:$}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$A6b=M}),define(te[29],ie([0,1,191,9,58,19,7,6,13]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,S.$Ah)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$Kh=l;function b(i){return typeof i?.id=="string"&&!l(i)&&!p(i)}e.$Lh=b,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function $(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$_d)(i)}:n?e.$Mh:e.$Nh;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Oh=$;function p(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$Ph=p;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$Qh=f;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Rh=w;function g(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Sh=g;class c{constructor(n,o,k,I,D){this.h=n,this.j=k,this.k=I,this.l=D,this.c=s.$Gh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Gh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=c;class a{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$hg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=a;function m(i){return new a({uri:i,index:0,name:(0,M.$dg)(i)},{uri:i.toString()})}e.$Vh=m,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,P.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function E(i,n){return M.$$f.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$1h=E;function d(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$2h=d,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$3h}e.$4h=t;function u(i,n){return!E(i,n)&&!d(i)}e.$5h=u;function r(i){return(typeof i=="string"?(0,O.$ae)(i):(0,M.$fg)(i))===e.$Xh}e.$6h=r}),define(te[61],ie([0,1,15,8,57,46,2,85,4,21,166,91,6,5,24,29]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s5b=e.$r5b=void 0,e.$r5b=(0,p.$Ah)("dialogMainService");let g=class{constructor(a,m){this.d=a,this.e=m,this.a=new Map,this.b=new Map,this.c=new O.$Mg}pickFileFolder(a,m){return this.f({...a,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},m)}pickFolder(a,m){return this.f({...a,pickFolders:!0,title:(0,b.localize)(1,null)},m)}pickFile(a,m){return this.f({...a,pickFiles:!0,title:(0,b.localize)(2,null)},m)}pickWorkspace(a,m){const E=(0,b.localize)(3,null),d=(0,M.$iA)((0,b.localize)(4,null)),t=w.$Yh;return this.f({...a,pickFiles:!0,title:E,filters:t,buttonLabel:d},m)}async f(a,m){const E={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters,defaultPath:a.defaultPath};(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(E.properties=void 0,a.pickFiles&&a.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&E.properties.push("treatPackageAsDirectory");const d=await this.showOpenDialog(E,(m||P.BrowserWindow.getFocusedWindow())??void 0);if(d&&d.filePaths&&d.filePaths.length>0)return d.filePaths}g(a){if(a){let m=this.b.get(a.id);return m||(m=new O.$Mg,this.b.set(a.id,m)),m}else return this.c}showMessageBox(a,m){return this.g(m).queue(async()=>{const{options:E,buttonIndeces:d}=(0,$.$pA)(a,this.e);let t;return m?t=await P.dialog.showMessageBox(m,E):t=await P.dialog.showMessageBox(E),{response:d[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(a,m){const E=this.j(a,m);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(m).queue(async()=>{let d;return m?d=await P.dialog.showSaveDialog(m,a):d=await P.dialog.showSaveDialog(a),d.filePath=this.h(d.filePath),d})}finally{(0,A.$ec)(E)}}h(a){return a&&h.$j&&(a=(0,S.$gl)(a)),a}i(a){return a.map(m=>this.h(m))}async showOpenDialog(a,m){a.defaultPath&&(await l.Promises.exists(a.defaultPath)||(a.defaultPath=void 0));const E=this.j(a,m);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(m).queue(async()=>{let d;return m?d=await P.dialog.showOpenDialog(m,a):d=await P.dialog.showOpenDialog(a),d.filePaths=this.i(d.filePaths),d})}finally{(0,A.$ec)(E)}}j(a,m){if(!m)return A.$jc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",a);let E=this.a.get(m.id);E||(E=new Set,this.a.set(m.id,E));const d=(0,s.$oi)(a);if(!E.has(d))return this.d.trace("[DialogMainService]: new file dialog lock created",a),E.add(d),(0,A.$hc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",a),E?.delete(d),E?.size===0&&this.a.delete(m.id)})}};e.$s5b=g,e.$s5b=g=ke([_(0,f.$4i),_(1,y.$jj)],g)}),define(te[276],ie([0,1,3,2,74,29]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d6b=void 0;class A extends O.$jc{static{this.a=100}constructor(h,l){super(),this.f=h,this.g=l,this.b=this.B(new P.$ed),this.c=new Map,this.h(l.applicationStorage,this.b)}h(h,l){this.B(P.Event.debounce(h.onDidChangeStorage,(b,$)=>(b?b.push($):b=[$],b),A.a)(b=>{b.length&&l.fire(this.j(b,h))}))}j(h,l){const b=new Map,$=new Set;return h.forEach(p=>{const f=l.get(p.key);typeof f=="string"?b.set(p.key,f):$.add(p.key)}),{changed:Array.from(b.entries()),deleted:Array.from($.values())}}listen(h,l,b){switch(l){case"onDidChangeStorage":{const $=b.profile?(0,s.$0g)(b.profile):void 0;if(!$)return this.b.event;let p=this.c.get($.id);return p||(p=this.B(new P.$ed),this.h(this.g.profileStorage($),p),this.c.set($.id,p)),p.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,b){const $=b.profile?(0,s.$0g)(b.profile):void 0,p=(0,M.$Qh)(b.workspace),f=await this.m($,p);switch(l){case"getItems":return Array.from(f.items.entries());case"updateItems":{const y=b;if(y.insert)for(const[w,g]of y.insert)f.set(w,g);y.delete?.forEach(w=>f.delete(w));break}case"optimize":return f.optimize();case"isUsed":{const y=b.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async m(h,l){let b;l?b=this.g.workspaceStorage(l):h?b=this.g.profileStorage(h):b=this.g.applicationStorage;try{await b.init()}catch($){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${$}`)}return b}}e.$d6b=A}),define(te[41],ie([0,1,57,3,2,19,7,188,36,16,6,5,29,34,40,8,31,26,12]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.ProfileResourceType=void 0;var m;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Ck=E,e.$Dk=(0,b.$Ah)("IUserDataProfilesService");function d(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Ek=d;function t(i,n,o,k,I,D){return{id:i,name:n,location:o,isDefault:!1,shortName:I?.shortName,globalStorageHome:D&&I?.useDefaultFlags?.globalState?D.globalStorageHome:(0,M.$hg)(o,"globalStorage"),settingsResource:D&&I?.useDefaultFlags?.settings?D.settingsResource:(0,M.$hg)(o,"settings.json"),keybindingsResource:D&&I?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,M.$hg)(o,"keybindings.json"),tasksResource:D&&I?.useDefaultFlags?.tasks?D.tasksResource:(0,M.$hg)(o,"tasks.json"),snippetsHome:D&&I?.useDefaultFlags?.snippets?D.snippetsHome:(0,M.$hg)(o,"snippets"),extensionsResource:D&&I?.useDefaultFlags?.extensions?D.extensionsResource:(0,M.$hg)(o,"extensions.json"),cacheHome:(0,M.$hg)(k,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$Fk=t;let u=class extends s.$jc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,k,I){super(),this.t=n,this.u=o,this.w=k,this.y=I,this.f=!0,this.h=this.B(new O.$ed),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$ed),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$ed),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$ed),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$yi,emptyWindows:new Map},this.profilesHome=(0,M.$hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,a.$if)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(t((0,M.$eg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,useDefaultFlags:D.useDefaultFlags},n))}}catch(D){this.y.error(D)}const k=new f.$yi,I=new Map;if(o.length)try{const D=this.Q();if(D.workspaces)for(const[v,R]of Object.entries(D.workspaces)){const j=A.URI.parse(v),N=o.find(z=>z.id===R);N&&k.set(j,N)}if(D.emptyWindows)for(const[v,R]of Object.entries(D.emptyWindows)){const j=o.find(N=>N.id===R);j&&I.set(v,j)}}catch(D){this.y.error(D)}this.z={profiles:o,workspaces:k,emptyWindows:I}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",k=new RegExp(`${(0,c.$pe)(o)}\\s(\\d+)`);let I=0;for(const v of this.profiles){const R=k.exec(v.name),j=R?parseInt(R[1]):0;I=j>I?j:I}const D=`${o} ${I+1}`;return this.createProfile((0,P.$oi)((0,g.$3f)()).toString(16),D,{transient:!0},n)}async createNamedProfile(n,o,k){return this.createProfile((0,P.$oi)((0,g.$3f)()).toString(16),n,o,k)}async createProfile(n,o,k,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(n,o,k);return I&&await this.setProfileForWorkspace(I,D),D}async F(n,o,k){if(!(0,a.$if)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(o);return I||(I=(async()=>{try{const D=this.profiles.find(j=>j.name===o||j.id===n);if(D)return D;const v=t(n,o,(0,M.$hg)(this.profilesHome,n),this.g,k,this.defaultProfile);await this.u.createFolder(v.location);const R=[];return this.j.fire({profile:v,join(j){R.push(j)}}),await w.Promises.settled(R),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,I)),I}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(I=>I.id===n.id);if(!k)throw new Error(`Profile '${n.name}' does not exist`);return k=t(k.id,o.name??k.name,k.location,this.g,{shortName:o.shortName??k.shortName,transient:o.transient??k.isTransient,useDefaultFlags:o.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(I=>I.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const k=[];this.m.fire({profile:o,join(I){k.push(I)}});try{await Promise.allSettled(k)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(I){(0,l.$ik)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(I=>I.id===o.id);if(!k)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,k)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(n){return(0,p.$Kh)(n)?n.uri:(0,p.$Ph)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,k){const I=[...this.profiles,...n],D=[];this.s.profiles=[];for(let v of I)v.isDefault||o.some(R=>v.id===R.id)||(v=k.find(R=>v.id===R.id)??v,v.isTransient?this.s.profiles.push(v):D.push({location:v.location,name:v.name,shortName:v.shortName,useDefaultFlags:v.useDefaultFlags}));this.P(D),this.z=void 0,this.J(n,o,k)}J(n,o,k){this.h.fire({added:n,removed:o,updated:k,all:this.profiles})}L(n,o,k){k=o?.isTransient?!0:k,k||this.L(n,void 0,!0);const I=this.G(n),D=k?this.s:this.C;A.URI.isUri(I)?(D.workspaces.delete(I),o&&D.workspaces.set(I,o)):(D.emptyWindows.delete(I),o&&D.emptyWindows.set(I,o)),k||this.M()}M(){const n={};for(const[k,I]of this.C.workspaces.entries())n[k.toString()]=I.id;const o={};for(const[k,I]of this.C.emptyWindows.entries())o[k.toString()]=I.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},k=this.D();if(n.workspaces)for(const[D,v]of Object.entries(n.workspaces)){const R=A.URI.parse(v);o[D]=this.w.extUri.isEqual(R,k.location)?k.id:this.w.extUri.basename(R)}const I={};if(n.emptyWindows)for(const[D,v]of Object.entries(n.emptyWindows)){const R=A.URI.parse(v);I[D]=this.w.extUri.isEqual(R,k.location)?k.id:this.w.extUri.basename(R)}return{workspaces:o,emptyWindows:I}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Gk=u,e.$Gk=u=ke([_(0,h.$Hh),_(1,l.$5j),_(2,y.$Bk),_(3,$.$4i)],u);class r extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Hk=r}),define(te[81],ie([0,1,8,17,2,3,34,7,116,123,16,6,5,41,40,12,14,25]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.ExtensionsProfileScanningErrorCode=void 0;var a;(function(u){u.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",u.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(a||(e.ExtensionsProfileScanningErrorCode=a={}));class m extends Error{constructor(r,i){super(r),this.code=i}}e.$hp=m,e.$ip=(0,$.$Ah)("IExtensionsProfileScannerService");let E=class extends s.$jc{constructor(r,i,n,o,k,I){super(),this.j=r,this.m=i,this.n=n,this.r=o,this.s=k,this.t=I,this.b=this.B(new M.$ed),this.onAddExtensions=this.b.event,this.c=this.B(new M.$ed),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$ed),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$ed),this.onDidRemoveExtensions=this.g.event,this.h=new A.$yi}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],o=[];try{return await this.u(i,k=>{const I=[];for(const D of k)r.some(([v])=>(0,l.$oo)(v.identifier,D.identifier)&&v.manifest.version!==D.version)?n.push(D):I.push(D);for(const[D,v]of r){const R=I.findIndex(N=>(0,l.$oo)(N.identifier,D.identifier)&&N.version===D.manifest.version),j={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:v};R===-1?(o.push(j),I.push(j)):I.splice(R,1,j)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),I}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(k){throw o.length&&this.c.fire({extensions:o,error:k,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:k,profileLocation:i}),k}}async updateMetadata(r,i){const n=[];return await this.u(i,o=>{const k=[];for(const I of o){const D=r.find(([v])=>(0,l.$oo)(v.identifier,I.identifier)&&v.manifest.version===I.version);D&&(I.metadata={...I.metadata,...D[1]},n.push(I)),k.push(I)}return k}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,o=>{const k=[];for(const I of o)(0,l.$oo)(I.identifier,r.identifier)?n.push(I):k.push(I);return n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(r,i,n){return this.F(r).queue(async()=>{let o=[],k;try{const I=await this.m.readFile(r);k=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,b.$ik)(I)!==1)throw I;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&n?.bailOutWhenFileNotFound)throw new m((0,g.$8)(I),"ERROR_PROFILE_NOT_FOUND")}if(k){Array.isArray(k)||this.w(r);let I=!1;for(const D of k){d(D)||this.w(r);let v;if((0,w.$if)(D.relativeLocation)&&D.relativeLocation)v=this.z(D.relativeLocation);else if((0,w.$if)(D.location))v=this.z(D.location),I=!0,D.relativeLocation=D.location,D.location=v.toJSON();else{v=S.URI.revive(D.location);const R=this.y(v);R&&(I=!0,D.relativeLocation=R)}o.push({identifier:D.identifier,location:v,version:D.version,metadata:D.metadata})}I&&await this.m.writeFile(r,O.$Ed.fromString(JSON.stringify(k)))}if(i){o=i(o);const I=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(r,O.$Ed.fromString(JSON.stringify(I)))}return o})}w(r){const i=new m(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(k){if((0,b.$ik)(k)===1)return;throw k}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const k=JSON.parse(n);Array.isArray(k)&&k.every(I=>d(I))?o=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$Ed.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,b.$ik)(k)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(r)}catch(k){(0,b.$ik)(k)!==1&&this.t.error(k)}try{await this.m.del(i)}catch(k){(0,b.$ik)(k)!==1&&this.t.error(k)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$Mg,this.h.set(r,i)),i}};e.$jp=E,e.$jp=E=ke([_(1,b.$5j),_(2,f.$Dk),_(3,y.$Bk),_(4,c.$8k),_(5,p.$4i)],E);function d(u){return(0,w.$kf)(u)&&(0,h.$Xn)(u.identifier)&&(t(u.location)||(0,w.$if)(u.location)&&u.location)&&((0,w.$pf)(u.relativeLocation)||(0,w.$if)(u.relativeLocation))&&u.version&&(0,w.$if)(u.version)}function t(u){return u?(0,w.$if)(u.path)&&(0,w.$if)(u.scheme):!1}}),define(te[129],ie([0,1,23,8,37,17,14,44,152,2,13,9,4,19,204,70,12,7,171,36,123,120,203,16,6,5,24,3,74,81,41,40,202]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d,t,u,r,i,n,o,k,I,D,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.Translations=void 0;var j;(function(oe){function G(K,B){if(K===B)return!0;const F=Object.keys(K),T=new Set;for(const H of Object.keys(B))T.add(H);if(F.length!==T.size)return!1;for(const H of F){if(K[H]!==B[H])return!1;T.delete(H)}return T.size===0}oe.equals=G})(j||(e.Translations=j={})),e.$mp=(0,r.$Ah)("IExtensionsScannerService");let N=class extends l.$jc{constructor(G,K,B,F,T,H,Q,x,ce,Y,C,L){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=K,this.r=B,this.s=F,this.t=T,this.u=H,this.w=Q,this.y=x,this.z=ce,this.C=Y,this.D=C,this.F=L,this.g=this.B(new o.$ed),this.onDidChangeCache=this.g.event,this.h=(0,f.$hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ee,this.s,this.h)),this.m=this.B(this.F.createInstance(ee,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$zo)(this.w,this.y)),this.G}async scanAllExtensions(G,K,B){const[F,T]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(K)]),H=B?await this.scanExtensionsUnderDevelopment(G,[...F,...T]):[];return this.L(F,T,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const K=[];K.push(this.M(!!G.useCache,G.language)),K.push(this.N(G.language,!!G.checkControlFile));const[B,F]=await Promise.all(K);return this.J([...B,...F],0,G,!1)}async scanUserExtensions(G){const K=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const B=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.P(K,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,B),T=G.useCache&&!F.devMode&&F.excludeObsolete?this.m:this.n;let H;try{H=await T.scanExtensions(F)}catch(Q){if(Q instanceof I.$hp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await T.scanExtensions(F);else throw Q}return H=await this.J(H,1,G,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(G,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(F=>F.scheme===b.Schemas.file).map(async F=>{const T=await this.P(F,!1,1,!0,G.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(T)).map(Q=>(Q.type=K.find(x=>(0,E.$oo)(x.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,T)))}))).flat();return this.J(B,"development",G,!0)}return[]}async scanExistingExtension(G,K,B){const F=await this.P(G,!1,K,!0,B.language,!0,void 0),T=await this.n.scanExtension(F);return!T||!B.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(G,K,B){const F=await this.P(G,!1,K,!0,B.language,!0,void 0),T=await this.n.scanOneOrMultipleExtensions(F);return this.J(T,K,B,!0)}async scanMetadata(G){const K=(0,f.$hg)(G,"package.json"),B=(await this.w.readFile(K)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(G,K){const B=(0,f.$hg)(G,"package.json"),F=(await this.w.readFile(B)).value.toString(),T=JSON.parse(F);K.isMachineScoped=K.isMachineScoped||void 0,K.isBuiltin=K.isBuiltin||void 0,T.__metadata={...T.__metadata,...K},await this.w.writeFile((0,f.$hg)(G,"package.json"),M.$Ed.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof I.$hp&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$Ed.fromString(JSON.stringify([])))}catch(K){(0,u.$ik)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$8)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,K,B,F){return B.includeAllVersions||(G=this.L(K===0?G:void 0,K===1?G:void 0,K==="development"?G:void 0,await this.getTargetPlatform(),F)),B.includeInvalid||(G=G.filter(T=>T.isValid)),G.sort((T,H)=>{const Q=$.$_d(T.location.fsPath),x=$.$_d(H.location.fsPath);return Q<x?-1:Q>x?1:0})}L(G,K,B,F,T){const H=(x,ce,Y)=>{if(x.isValid&&!ce.isValid)return!1;if(x.isValid===ce.isValid){if(T&&y.gt(x.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(y.eq(x.manifest.version,ce.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===F)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return Y?this.y.warn(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`),!0},Q=new d.$Wl;return G?.forEach(x=>{const ce=Q.get(x.identifier.id);(!ce||H(ce,x,!1))&&Q.set(x.identifier.id,x)}),K?.forEach(x=>{const ce=Q.get(x.identifier.id);if(!ce&&G&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!ce||H(ce,x,!1))&&Q.set(x.identifier.id,x)}),B?.forEach(x=>{const ce=Q.get(x.identifier.id);(!ce||H(ce,x,!0))&&Q.set(x.identifier.id,x),Q.set(x.identifier.id,x)}),[...Q.values()]}async M(G,K){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),T=await(G&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",T.length),T}async N(G,K){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const F=K?await this.O():{},T=[],H=c.URI.file($.$6d($.$8d(b.$1f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of B){const ce=F[x.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":T.push((0,f.$hg)(H,x.name));break;default:T.push(c.URI.file(ce));break}}const Q=await Promise.all(T.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,G,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,P.$Eb)(Q)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,K,B,F,T,H,Q){const x=await this.f(T??p.$v),ce=await this.Q(G),Y=K&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,C=Y?await this.Q(Y):void 0;return new z(G,ce,Y,C,K,Q,B,F,H,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,T,x)}async Q(G){try{const K=await this.w.stat(G);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$np=N,e.$np=N=ke([_(4,D.$Dk),_(5,I.$ip),_(6,u.$5j),_(7,i.$4i),_(8,m.$Hh),_(9,n.$jj),_(10,v.$Bk),_(11,r.$zh)],N);class z{constructor(G,K,B,F,T,H,Q,x,ce,Y,C,L,U,W,q){this.location=G,this.mtime=K,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=F,this.profile=T,this.profileScanOptions=H,this.type=Q,this.excludeObsolete=x,this.validate=ce,this.productVersion=Y,this.productDate=C,this.productCommit=L,this.devMode=U,this.language=W,this.translations=q}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,K){return(0,f.$ag)(G.location,K.location)&&G.mtime===K.mtime&&(0,f.$ag)(G.applicationExtensionslocation,K.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&G.profile===K.profile&&s.$Ym(G.profileScanOptions,K.profileScanOptions)&&G.type===K.type&&G.excludeObsolete===K.excludeObsolete&&G.validate===K.validate&&G.productVersion===K.productVersion&&G.productDate===K.productDate&&G.productCommit===K.productCommit&&G.devMode===K.devMode&&G.language===K.language&&j.equals(G.translations,K.translations)}}e.$op=z;let se=class extends l.$jc{constructor(G,K,B,F,T){super(),this.f=G,this.g=K,this.h=B,this.j=F,this.m=T}async scanExtensions(G){const K=G.profile?await this.r(G):await this.n(G);let B={};if(G.excludeObsolete&&G.type===1)try{const F=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(F)}catch{}return(0,g.$vf)(B)?K:K.filter(F=>!B[E.$po.create(F).toString()])}async n(G){const K=await this.j.resolve(G.location);if(!K.children?.length)return[];const B=await Promise.all(K.children.map(async F=>{if(!F.isDirectory||G.type===1&&(0,f.$eg)(F.resource).indexOf(".")===0)return null;const T=new z(F.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(T)}));return(0,P.$Eb)(B).sort((F,T)=>F.location.path<T.location.path?-1:1)}async r(G){let K=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){K=K.filter(F=>!F.metadata?.isApplicationScoped);const B=await this.s(G.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,G);K.push(...B)}return K}async s(G,K,B){const F=await this.g.scanProfileExtensions(G,B.profileScanOptions);if(!F.length)return[];const T=await Promise.all(F.map(async H=>{if(K(H)){const Q=new z(H.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Q,H.metadata)}return null}));return(0,P.$Eb)(T)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,f.$hg)(G.location,"package.json"))){const K=await this.scanExtension(G);return K?[K]:[]}else return await this.scanExtensions(G)}catch(K){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,A.$8)(K)),[]}}async scanExtension(G,K){try{let B=await this.scanExtensionManifest(G.location);if(B){B.publisher||(B.publisher=d.$Ql),K=K??B.__metadata,delete B.__metadata;const F=(0,E.$to)(B.publisher,B.name),T=K?.id?{id:F,uuid:K.id}:{id:F},H=K?.isSystem?0:G.type,Q=H===0||!!K?.isBuiltin;B=await this.t(G.location,B,z.createNlsConfiguration(G));const x={type:H,identifier:T,manifest:B,location:G.location,isBuiltin:Q,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return G.validate?this.validate(x,G):x}}catch(B){G.type!==0&&this.m.error(B)}return null}validate(G,K){let B=!0;const F=(0,t.$Eo)(K.productVersion,K.productDate,K.location,G.manifest,G.isBuiltin);for(const[T,H]of F)T===w.default.Error&&(B=!1,this.m.error(this.z(K.location,H)));return G.isValid=B,G.validations=F,G}async scanExtensionManifest(G){const K=(0,f.$hg)(G,"package.json");let B;try{B=(await this.j.readFile(K)).value.toString()}catch(T){return(0,u.$ik)(T)!==1&&this.m.error(this.z(G,(0,a.localize)(0,null,K.path,T.message))),null}let F;try{F=JSON.parse(B)}catch{const H=[];(0,S.$Km)(B,H);for(const Q of H)this.m.error(this.z(G,(0,a.localize)(1,null,K.path,Q.offset,Q.length,(0,h.$kp)(Q.error))));return null}return(0,S.$Tm)(F)!=="object"?(this.m.error(this.z(G,(0,a.localize)(2,null,K.path))),null):F}async t(G,K,B){const F=await this.u(G,K,B);if(F)try{const T=[],H=await this.w(F.default,T);if(T.length>0)return T.forEach(x=>{this.m.error(this.z(G,(0,a.localize)(3,null,F.default?.path,(0,h.$kp)(x.error))))}),K;if((0,S.$Tm)(F)!=="object")return this.m.error(this.z(G,(0,a.localize)(4,null,F.default?.path))),K;const Q=F.values||Object.create(null);return(0,R.$lp)(this.m,K,Q,H)}catch{}return K}async u(G,K,B){const F=(0,f.$hg)(G,"package.nls.json"),T=(ce,Y)=>{Y.forEach(C=>{this.m.error(this.z(G,(0,a.localize)(5,null,ce?.path,(0,h.$kp)(C.error))))})},H=ce=>{this.m.error(this.z(G,(0,a.localize)(6,null,ce?.path)))},Q=`${K.publisher}.${K.name}`,x=B.translations[Q];if(x)try{const ce=c.URI.file(x),Y=(await this.j.readFile(ce)).value.toString(),C=[],L=(0,S.$Km)(Y,C);return C.length>0?(T(ce,C),{values:void 0,default:F}):(0,S.$Tm)(L)!=="object"?(H(ce),{values:void 0,default:F}):{values:L.contents?L.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.j.exists(F))return;let Y;try{Y=await this.y(G,B)}catch{return}if(!Y.localized)return{values:void 0,default:Y.original};try{const C=(await this.j.readFile(Y.localized)).value.toString(),L=[],U=(0,S.$Km)(C,L);return L.length>0?(T(Y.localized,L),{values:void 0,default:Y.original}):(0,S.$Tm)(U)!=="object"?(H(Y.localized),{values:void 0,default:Y.original}):{values:U,default:Y.original}}catch{return{values:void 0,default:Y.original}}}}async w(G,K){if(G)try{const B=(await this.j.readFile(G)).value.toString();return(0,S.$Km)(B,K)}catch{}}y(G,K){return new Promise((B,F)=>{const T=H=>{const Q=(0,f.$hg)(G,`package.nls.${H}.json`);this.j.exists(Q).then(x=>{x&&B({localized:Q,original:(0,f.$hg)(G,"package.nls.json")});const ce=H.lastIndexOf("-");ce===-1?B({localized:(0,f.$hg)(G,"package.nls.json"),original:null}):(H=H.substring(0,ce),T(H))})};if(K.devMode||K.pseudo||!K.language)return B({localized:(0,f.$hg)(G,"package.nls.json"),original:null});T(K.language)})}z(G,K){return`[${G.path}]: ${K}`}};se=ke([_(1,I.$ip),_(2,v.$Bk),_(3,u.$5j),_(4,i.$4i)],se);let ee=class extends se{constructor(G,K,B,F,T,H,Q){super(K,F,T,H,Q),this.G=G,this.H=B,this.D=this.B(new O.$Dg(3e3)),this.F=this.B(new o.$ed),this.onDidChangeCache=this.F.event}async scanExtensions(G){const K=this.M(G),B=await this.I(K);if(this.C=G,B&&B.input&&z.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),B.result.map(T=>(T.location=c.URI.revive(T.location),T));const F=await super.scanExtensions(G);return await this.J(K,{input:G,result:F}),F}async I(G){try{const K=await this.j.readFile(G),B=JSON.parse(K.value.toString());return{result:B.result,input:(0,k.$0g)(B.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",G.path,(0,A.$8)(K))}return null}async J(G,K){try{await this.j.writeFile(G,M.$Ed.fromString(JSON.stringify(K)))}catch(B){this.m.debug("Error while writing the extension cache file:",G.path,(0,A.$8)(B))}}async L(){if(!this.C)return;const G=this.M(this.C),K=await this.I(G);if(!K)return;const B=K.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Ym(F,B))try{this.m.info("Invalidating Cache",B,F),await this.j.del(G),this.F.fire()}catch(T){this.m.error(T)}}M(G){const K=this.N(G);return this.h.extUri.joinPath(K.cacheHome,G.type===0?d.$Pl:d.$Ol)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(G.location,K.extensionsResource))??this.G:this.H.defaultProfile}};ee=ke([_(2,D.$Dk),_(3,I.$ip),_(4,v.$Bk),_(5,u.$5j),_(6,i.$4i)],ee);function ae(oe,G){const K=(0,E.$ro)(oe.manifest.publisher,oe.manifest.name);return{id:K,identifier:new d.$Ul(K),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:G,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$pp=ae;class ne extends N{constructor(G,K,B,F,T,H,Q,x,ce,Y,C,L){super(G,K,(0,f.$hg)(B,".vscode-oss-dev","extensions","control.json"),F,T,H,Q,x,ce,Y,C,L),this.R=(async()=>{if(p.$y)try{const U=await this.w.readFile(c.URI.file(p.$y));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(G){return this.R}}e.$qp=ne}),define(te[277],ie([0,1,5,41,40,25,81,16,36,7]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;let b=class extends A.$jp{constructor(p,f,y,w,g,c){super(l.URI.file(p.extensionsPath),f,y,w,g,c)}};e.$fN=b,e.$fN=b=ke([_(0,h.$Ih),_(1,S.$5j),_(2,O.$Dk),_(3,s.$Bk),_(4,M.$8k),_(5,P.$4i)],b)}),define(te[278],ie([0,1,7,36,81,129,16,6,5,24,40,41]),function(J,e,P,O,s,M,A,S,h,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=void 0;let p=class extends M.$qp{constructor(y,w,g,c,a,m,E,d){super(P.URI.file(a.builtinExtensionsPath),P.URI.file(a.extensionsPath),a.userHome,y.defaultProfile,y,w,g,c,a,m,E,d)}};e.$E6b=p,e.$E6b=p=ke([_(0,$.$Dk),_(1,s.$ip),_(2,A.$5j),_(3,h.$4i),_(4,O.$Ih),_(5,l.$jj),_(6,b.$Bk),_(7,S.$zh)],p)}),define(te[279],ie([0,1,15,2,13,9,4,58,7,31,38,36,5,41]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T6b=void 0;let y=class extends O.$jc{constructor(g,c,a){super(),this.c=g,this.f=a,this.a=S.$Gh.forPaths(!A.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(g.appRoot),this.addValidFileRoot(g.extensionsPath),this.addValidFileRoot(c.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(g.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:g}=P.session;g.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(c,a)=>this.j(c,a)),g.protocol.interceptFileProtocol(s.Schemas.file,(c,a)=>this.h(c,a)),this.B((0,O.$hc)(()=>{g.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(g){const c=(0,M.$6d)(g);return this.a.get(c)?O.$jc.None:(this.a.set(c,!0),(0,O.$hc)(()=>this.a.delete(c)))}h(g,c){const a=h.URI.parse(g.url);return this.f.error(`Refused to load resource ${a.fsPath} from ${s.Schemas.file}: protocol (original URL: ${g.url})`),c({error:-3})}j(g,c){const a=this.m(g);let m;return this.c.crossOriginIsolated&&((0,M.$_d)(a)==="workbench.html"||(0,M.$_d)(a)==="workbench-dev.html"?m=s.COI.CoopAndCoep:m=s.COI.getHeadersFromQuery(g.url)),this.a.findSubstr(a)?c({path:a,headers:m}):this.b.has((0,M.$ae)(a).toLowerCase())?c({path:a}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${a} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),c({error:-3}))}m(g){const c=h.URI.parse(g.url),a=s.$1f.uriToFileUri(c);return(0,M.$6d)(a.fsPath)}createIPCObjectUrl(){let g;const c=h.URI.from({scheme:"vscode",path:(0,l.$3f)()}),a=c.toString(),m=async()=>g;return b.$JS.handle(a,m),this.f.trace(`IPC Object URL: Registered new channel ${a}.`),{resource:c,update:E=>g=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${a}.`),b.$JS.removeHandler(a)}}}};e.$T6b=y,e.$T6b=y=ke([_(0,$.$Ih),_(1,f.$Dk),_(2,p.$4i)],y)}),define(te[96],ie([0,1,8,3,2,65,12,111,6,41]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$To=e.$So=e.$Ro=void 0,e.$Ro="__$__isNewStorageMarker",e.$So="__$__targetStorageMarker",e.$To=(0,h.$Ah)("storageService");var b;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var $;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})($||(e.StorageScope=$={}));var p;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function f(a){const m=a.get(e.$So);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.$Uo=f;class y extends s.$jc{static{this.a=60*1e3}constructor(m={flushInterval:y.a}){super(),this.m=m,this.b=this.B(new O.$hd),this.c=this.B(new O.$hd),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$ed),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Rg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$kc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,E,d){return O.Event.filter(this.b.event,t=>t.scope===m&&(E===void 0||t.key===E),d)}n(){this.j.value=(0,P.$Vg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$ec)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,E){const{key:d,external:t}=E;if(d===e.$So){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:d,target:this.J(m)[d],external:t})}w(m){this.f.fire({reason:m})}get(m,E,d){return this.P(E)?.get(m,d)}getBoolean(m,E,d){return this.P(E)?.getBoolean(m,d)}getNumber(m,E,d){return this.P(E)?.getNumber(m,d)}getObject(m,E,d){return this.P(E)?.getObject(m,d)}storeAll(m,E){this.y(()=>{for(const d of m)this.store(d.key,d.value,d.scope,d.target,E)})}store(m,E,d,t,u=!1){if((0,A.$rf)(E)){this.remove(m,d,u);return}this.y(()=>{this.z(m,d,t),this.P(d)?.set(m,E,u)})}remove(m,E,d=!1){this.y(()=>{this.z(m,E,void 0),this.P(E)?.delete(m,d)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,E){const d=[],t=this.J(m);for(const u of Object.keys(t))t[u]===E&&d.push(u);return d}z(m,E,d,t=!1){const u=this.J(E);typeof d=="number"?u[m]!==d&&(u[m]=d,this.P(E)?.set(e.$So,JSON.stringify(u),t)):typeof u[m]=="number"&&(delete u[m],this.P(E)?.set(e.$So,JSON.stringify(u),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const E=this.P(m);return E?f(E):Object.create(null)}isNew(m){return this.getBoolean(e.$Ro,m)===!0}async flush(m=b.NONE){this.f.fire({reason:m});const E=this.P(-1),d=this.P(0),t=this.P(1);switch(m){case b.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,d=this.P(1)?.items??new Map;return c(m,E,d,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,E){return this.w(b.NONE),(0,l.$Ck)(m)?this.R(m,E):this.S(m,E)}M(m,E){return!(m.id===E.id||w(E)&&w(m))}N(m,E,d){this.y(()=>{const t=new Set;for(const[u,r]of m)t.add(u),E.get(u)!==r&&this.u(d,{key:u,external:!0});for(const[u]of E.items)t.has(u)||this.u(d,{key:u,external:!0})})}}e.$Vo=y;function w(a){return a.isDefault||!!a.useDefaultFlags?.globalState}e.$Wo=w;class g extends y{constructor(){super(),this.U=this.B(new S.$Po(new S.$Qo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Po(new S.$Qo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Po(new S.$Qo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$Xo=g;async function c(a,m,E,d,t,u){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;a.forEach((j,N)=>{i.set(N,j),n.set(N,r(j))});const o=new Map,k=new Map;m.forEach((j,N)=>{o.set(N,j),k.set(N,r(j))});const I=new Map,D=new Map;E.forEach((j,N)=>{I.set(N,j),D.set(N,r(j))}),console.group(d!==t?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const v=[];if(i.forEach((j,N)=>{v.push({key:N,value:j})}),console.table(v),console.groupEnd(),console.log(n),d!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];o.forEach((N,z)=>{j.push({key:z,value:N})}),console.table(j),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${u})`);const R=[];I.forEach((j,N)=>{R.push({key:N,value:j})}),console.table(R),console.groupEnd(),console.log(D)}e.$Yo=c}),define(te[280],ie([0,1,23,8,3,2,9,69,7,21,111,160,5,96,25,29,13]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$4b=e.$04b=e.$94b=e.$84b=void 0;class c extends M.$jc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$ed),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$ed),this.onDidCloseStorage=this.c.event,this.f=this.B(new b.$Po(new b.$Qo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new O.$1g,this.whenInit=this.h.p,this.j=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===b.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(f.$Ro);i===void 0?r.set(f.$Ro,!0):i&&r.set(f.$Ro,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=b.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$ad(!1);await this.w(),r.stop(),r.elapsed()>c.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([o,k])=>({key:o,length:k.length})),(o,k)=>k.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=b.StorageState.Closed,await this.f.close()}}class a extends c{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,A.$8d)(this.z.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,a.y)}constructor(r,i,n,o){super(n,o),this.z=r,this.C=i}async t(){return new b.$Po(new $.$cT(this.path??$.$cT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}class m extends a{constructor(r,i,n,o){super(r,i,n,o)}}e.$84b=m;class E extends a{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$$k,void 0)===void 0&&r.set(y.$$k,new Date().toUTCString());const n=r.get(y.$0k,void 0),o=new Date().toUTCString();r.set(y.$_k,typeof n>"u"?null:n),r.set(y.$0k,o)}}e.$94b=E;class d extends c{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,A.$8d)(this.F.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.C.id,d.y)}constructor(r,i,n,o,k){super(n,k),this.C=r,this.D=i,this.F=o}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new b.$Po(new $.$cT(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:$.$cT.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.$8d)(this.F.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.C.id),i=(0,A.$8d)(r,d.y);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$Kh)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$Ph)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,A.$8d)(r,d.z);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$04b=d;class t extends c{get path(){}async t(){return new b.$Po(new b.$Qo,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.$$4b=t}),define(te[281],ie([0,1,3,2,96]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0;class M extends O.$jc{constructor(S,h,l){super(),this.b=S,this.c=h,this.f=l;const b=this.B(new O.$kc);this.a=this.B(new P.$ed({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new O.$ic;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.h(h))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let b=h.get(l.profile.id);return b||h.set(l.profile.id,b={profile:l.profile,keys:[],storage:l.storage}),b.keys.push(l.key),h},100)(h=>this.j(h))),S}h(S){const h=S.includes(s.$So)?[this.c.defaultProfile]:[],l=[];if(S=S.filter(b=>b!==s.$So),S.length){const b=(0,s.$Uo)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:S.map($=>({key:$,scope:0,target:b[$]}))})}this.m(h,l)}j(S){const h=[],l=new Map;for(const[b,$]of S.entries()){$.keys.includes(s.$So)&&h.push($.profile);const p=$.keys.filter(f=>f!==s.$So);if(p.length){const f=(0,s.$Uo)($.storage.storage);l.set(b,{profile:$.profile,changes:p.map(y=>({key:y,scope:0,target:f[y]}))})}}this.m(h,[...l.values()])}m(S,h){(S.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:S})}listen(S,h,l){switch(h){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${h}`)}async call(S,h){throw new Error(`Call not found: ${h}`)}}e.$G6b=M}),define(te[282],ie([0,1,7,36,16,5,33,40,41,12,121]),function(J,e,P,O,s,M,A,S,h,l,b){"use strict";var $,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=void 0;let f=class extends h.$Gk{static{$=this}static{this.a="profileAssociationsMigration"}constructor(c,a,m,E,d){super(m,E,a,d),this.U=c,this.W=m}O(){return this.U.getItem($.b,[]).map(a=>({...a,location:(0,l.$if)(a.location)?this.w.extUri.joinPath(this.profilesHome,a.location):P.URI.revive(a.location)}))}Q(){const c=this.U.getItem($.c,{});return this.U.getItem($.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$cN=f,e.$cN=f=$=ke([_(0,A.$0M),_(1,S.$Bk),_(2,O.$Ih),_(3,s.$5j),_(4,M.$4i)],f);let y=p=class extends f{constructor(c,a,m,E,d){super(c,a,m,E,d),this.$=c}P(c){c.length?this.$.setItem(p.b,c.map(a=>({...a,location:this.w.extUri.basename(a.location)}))):this.$.removeItem(p.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(p.c,c):this.$.removeItem(p.c)}Q(){const c="workspaceAndProfileInfo",a=this.$.getItem(c,void 0);if(a){this.$.removeItem(c);const E=a.reduce((d,{workspace:t,profile:u})=>(d[P.URI.revive(t).toString()]=P.URI.revive(u).toString(),d),{});this.$.setItem(p.c,{workspaces:E})}const m=super.Q();return this.$.getItem(p.a,!1)||(this.R(m),this.$.setItem(p.a,!0)),m}};e.$dN=y,e.$dN=y=p=ke([_(0,A.$$M),_(1,S.$Bk),_(2,O.$Ih),_(3,s.$5j),_(4,M.$4i)],y);let w=class extends y{constructor(c,a,m,E){super(new b.$bN(0,a,E,m),c,a,m,E)}async init(){return await this.$.init(),super.init()}};e.$eN=w,e.$eN=w=ke([_(0,S.$Bk),_(1,O.$Ih),_(2,s.$5j),_(3,M.$4i)],w)}),define(te[53],ie([0,1,36,16,6,5,40,41,282,33]),function(J,e,P,O,s,M,A,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a5b=e.$_4b=void 0,e.$_4b=(0,s.$Bh)(S.$Dk);let b=class extends h.$dN{constructor(p,f,y,w,g){super(p,f,y,w,g)}getAssociatedEmptyWindows(){const p=[];for(const f of this.C.emptyWindows.keys())p.push({id:f});return p}};e.$a5b=b,e.$a5b=b=ke([_(0,l.$$M),_(1,A.$Bk),_(2,P.$Ih),_(3,O.$5j),_(4,M.$4i)],b)}),define(te[130],ie([0,1,19,7,29]),function(J,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v5b=e.$u5b=e.$t5b=void 0;async function M(h,l,b){for(const p of h){const f=p.openedWorkspace;if((0,s.$Ph)(f)){const y=await b(f);if(y){if(y.folders.some(w=>P.$$f.isEqualOrParent(l,w.uri)))return p}else if(P.$$f.isEqualOrParent(l,f.configPath))return p}}const $=h.filter(p=>(0,s.$Kh)(p.openedWorkspace)&&P.$$f.isEqualOrParent(l,p.openedWorkspace.uri));if($.length)return $.sort((p,f)=>-(p.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$t5b=M;function A(h,l){for(const b of h)if((0,s.$Ph)(b.openedWorkspace)&&P.$$f.isEqual(b.openedWorkspace.configPath,l)||(0,s.$Kh)(b.openedWorkspace)&&P.$$f.isEqual(b.openedWorkspace.uri,l))return b}e.$u5b=A;function S(h,l){const b=$=>l.some(p=>P.$$f.isEqual(O.URI.file(p),O.URI.file($)));for(const $ of h)if($.config?.extensionDevelopmentPath?.some(p=>b(p)))return $}e.$v5b=S}),define(te[97],ie([0,1,32,44,138,46,13,9,4,19,7,6,60,29]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dU=e.$cU=e.$bU=e.$aU=e.$_T=e.$$T=e.$0T=e.$9T=e.$8T=e.$7T=void 0,e.$7T=(0,$.$Ah)("workspacesService");function y(D){return D.hasOwnProperty("workspace")}e.$8T=y;function w(D){return D.hasOwnProperty("folderUri")}e.$9T=w;function g(D){return D.hasOwnProperty("fileUri")}e.$0T=g;function c(D){return a(D)||m(D)}e.$$T=c;function a(D){const v=D;return typeof v?.path=="string"&&(!v.name||typeof v.name=="string")}function m(D){const v=D;return typeof v?.uri=="string"&&(!v.name||typeof v.name=="string")}function E(D,v,R,j,N){if(D.scheme!==j.scheme)return{name:R,uri:D.toString(!0)};let z=v?void 0:N.relativePath(j,D);if(z!==void 0)z.length===0?z=".":h.$i&&(z=d(z));else if(D.scheme===A.Schemas.file)z=D.fsPath,h.$i&&(z=d(z));else if(N.isEqualAuthority(D.authority,j.authority))z=D.path;else return{name:R,uri:D.toString(!0)};return{name:R,path:z}}e.$_T=E;function d(D){return D=(0,M.$cA)(D),(0,P.$Ef)(D)||(D=(0,P.$Bf)(D)),D}function t(D,v,R){const j=[],N=new Set,z=R.dirname(v);for(const se of D){let ee;if(a(se))se.path&&(ee=R.resolvePath(z,se.path));else if(m(se))try{ee=b.URI.parse(se.uri),ee.path[0]!==S.$5d.sep&&(ee=ee.with({path:S.$5d.sep+ee.path}))}catch(ae){console.warn(ae)}if(ee){const ae=R.getComparisonKey(ee);if(!N.has(ae)){N.add(ae);const ne=se.name||R.basenameOrAuthority(ee);j.push(new f.$Uh({uri:ee,name:ne,index:j.length},se))}}}return j}e.$aU=t;function u(D,v,R,j,N){const z=r(v,D),se=N.dirname(v),ee=N.dirname(j),ae=[];for(const K of z.folders){const B=a(K)?N.resolvePath(se,K.path):b.URI.parse(K.uri);let F;R?F=!1:F=!a(K)||(0,S.$7d)(K.path),ae.push(E(B,F,K.name,ee,N))}const ne={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},oe=s.$tS(D,["folders"],ae,ne);let G=s.$wS(D,oe);return(0,l.$mg)(z.remoteAuthority,(0,p.$Nk)(j))&&(G=s.$wS(G,s.$sS(G,["remoteAuthority"],ne))),G}e.$bU=u;function r(D,v){const R=O.$Km(v);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(j=>c(j));else throw new Error(`${D} looks like an invalid workspace file.`);return R}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function n(D){return typeof D.folderUri=="string"}function o(D){return typeof D.fileUri=="string"}function k(D,v){const R={workspaces:[],files:[]};if(D){const j=function(z,se){for(let ee=0;ee<z.length;ee++)try{se(z[ee],ee)}catch(ae){v.warn(`Error restoring recent entry ${JSON.stringify(z[ee])}: ${ae.toString()}. Skip entry.`)}},N=D;Array.isArray(N.entries)&&j(N.entries,z=>{const se=z.label,ee=z.remoteAuthority;i(z)?R.workspaces.push({label:se,remoteAuthority:ee,workspace:{id:z.workspace.id,configPath:b.URI.parse(z.workspace.configPath)}}):n(z)?R.workspaces.push({label:se,remoteAuthority:ee,folderUri:b.URI.parse(z.folderUri)}):o(z)&&R.files.push({label:se,remoteAuthority:ee,fileUri:b.URI.parse(z.fileUri)})})}return R}e.$cU=k;function I(D){const v={entries:[]};for(const R of D.workspaces)w(R)?v.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):v.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of D.files)v.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return v}e.$dU=I}),define(te[98],ie([0,1,72,13,4,19]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o5b=e.$n5b=e.$m5b=e.$l5b=void 0,e.$l5b=128/4;function A(l){function b(){let $=l.scheme===O.Schemas.file?(0,M.$8f)(l):l.toString();return s.$k||($=$.toLowerCase()),(0,P.createHash)("md5").update($).digest("hex")}return{id:b(),configPath:l}}e.$m5b=A;function S(l,b){function $(){if(l.scheme!==O.Schemas.file)return(0,P.createHash)("md5").update(l.toString()).digest("hex");if(!b)return;let f;return s.$k?f=b.ino:s.$j?f=b.birthtime.getTime():s.$i&&(typeof b.birthtimeMs=="number"?f=Math.floor(b.birthtimeMs):f=b.birthtime.getTime()),(0,P.createHash)("md5").update(l.fsPath).update(f?String(f):"").digest("hex")}const p=$();if(typeof p=="string")return{id:p,uri:l}}e.$n5b=S;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$o5b=h}),define(te[99],ie([0,1,72,87,27,283,17,14,3,2,9,4,31,42,109]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class w{traceSocketEvent(v,R){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,R)}constructor(v,R=""){this.f=!0,this.debugLabel=R,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,S.$Y)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const R=j=>{this.traceSocketEvent("read",j),v(A.$Ed.wrap(j))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(v){const R=j=>{v({type:0,hadError:j,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(v){const R=()=>{v()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,S.$Y)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,S.$Y)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$ph=w;var g;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var c;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(c||(c={}));class a extends l.$jc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,R){this.socket.traceSocketEvent(v,R)}constructor(v,R,j,N){super(),this.f=this.B(new h.$ed),this.g=this.B(new h.$ed),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:j?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new m(this,R,j,N,this.f,(z,se)=>this.m(z,se))),this.B(this.a.onError(z=>{console.error(z),(0,S.$Y)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new y.$kh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let R=0;for(;R<v.byteLength;)this.a.writeMessage(v.slice(R,Math.min(R+262144,v.byteLength))),R+=262144}m(v,R){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let j=2;v.byteLength<126?j+=0:v.byteLength<2**16?j+=2:j+=8;const N=A.$Ed.alloc(j);if(R?N.writeUInt8(194,0):N.writeUInt8(130,0),v.byteLength<126)N.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){N.writeUInt8(126,1);let z=1;N.writeUInt8(v.byteLength>>>8&255,++z),N.writeUInt8(v.byteLength>>>0&255,++z)}else{N.writeUInt8(127,1);let z=1;N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(0,++z),N.writeUInt8(v.byteLength>>>24&255,++z),N.writeUInt8(v.byteLength>>>16&255,++z),N.writeUInt8(v.byteLength>>>8&255,++z),N.writeUInt8(v.byteLength>>>0&255,++z)}this.socket.write(A.$Ed.concat([N,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const R=this.b.peek(this.j.readLen),j=R.readUInt8(0),N=(j&128)>>>7,z=(j&64)>>>6,se=R.readUInt8(1),ee=(se&128)>>>7,ae=se&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(ae===126?2:0)+(ae===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const R=this.b.read(this.j.readLen),j=R.readUInt8(1),N=(j&128)>>>7;let z=j&127,se=1;z===126?z=R.readUInt8(++se)*2**8+R.readUInt8(++se):z===127&&(z=R.readUInt8(++se)*0+R.readUInt8(++se)*0+R.readUInt8(++se)*0+R.readUInt8(++se)*0+R.readUInt8(++se)*2**24+R.readUInt8(++se)*2**16+R.readUInt8(++se)*2**8+R.readUInt8(++se));let ee=0;N&&(ee=R.readUInt8(++se)*2**24+R.readUInt8(++se)*2**16+R.readUInt8(++se)*2**8+R.readUInt8(++se)),this.j.state=3,this.j.readLen=z,this.j.mask=ee,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const R=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),t(R,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(R,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qh=a;class m extends l.$jc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Ed.alloc(0)}constructor(v,R,j,N,z,se){super(),this.n=v,this.r=z,this.s=se,this.a=this.B(new h.$ed),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$ed),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$ed),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new E(this.n,N,j,{windowBits:15})),this.f=this.B(new d(this.n,{windowBits:15})),this.B(this.b.onError(ee=>this.a.fire(ee))),this.B(this.f.onError(ee=>this.a.fire(ee)))):(this.b=null,this.f=null)}writeMessage(v){this.g.push(v),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const v=this.g.shift();if(this.f){const R=await this.w(this.f,v);this.s(R,!0)}else this.s(v,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,R){return new Promise((j,N)=>{v.write(R),v.flush(z=>j(z))})}acceptFrame(v,R,j){this.h.push({data:v,isCompressed:R,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const R=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,R,j){return new Promise((N,z)=>{v.write(R),j&&v.write(A.$Ed.fromByteArray([0,0,255,255])),v.flush(se=>N(se))})}}class E extends l.$jc{get recordedInflateBytes(){return this.j?A.$Ed.concat(this.f):A.$Ed.alloc(0)}constructor(v,R,j,N){super(),this.h=v,this.j=R,this.a=this.B(new h.$ed),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(N),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(A.$Ed.wrap(z))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const R=A.$Ed.concat(this.g);this.g.length=0,v(R)})}}class d extends l.$jc{constructor(v,R){super(),this.g=v,this.a=this.B(new h.$ed),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(A.$Ed.wrap(j))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let R=A.$Ed.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),v(R)})}}function t(D,v){if(v===0)return;const R=D.byteLength>>>2;for(let ae=0;ae<R;ae++){const ne=D.readUInt32BE(ae*4);D.writeUInt32BE(ne^v,ae*4)}const j=R*4,N=D.byteLength-j,z=v>>>24&255,se=v>>>16&255,ee=v>>>8&255;N>=1&&D.writeUInt8(D.readUInt8(j)^z,j),N>=2&&D.writeUInt8(D.readUInt8(j+1)^se,j+1),N>=3&&D.writeUInt8(D.readUInt8(j+2)^ee,j+2)}e.$rh=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function r(){const D=(0,p.$3f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const v=process.platform!=="darwin"&&e.$rh?e.$rh:(0,s.tmpdir)(),R=(0,b.$8d)(v,`vscode-ipc-${D}.sock`);return n(R),R}e.$sh=r;function i(D,v,R){const j=(0,P.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${R}-${v}-sock`;const N=R.substr(0,4),z=v.substr(0,6),se=j.substr(0,8);let ee;return process.platform!=="darwin"&&e.$rh&&!process.env.VSCODE_PORTABLE?ee=(0,b.$8d)(e.$rh,`vscode-${se}-${N}-${z}.sock`):ee=(0,b.$8d)(D,`${N}-${z}.sock`),n(ee),ee}e.$th=i;function n(D){const v=u[$.$t];typeof v=="number"&&D.length>=v&&console.warn(`WARNING: IPC handle "${D}" is longer than ${v} chars, try a shorter --user-data-dir`)}class o extends f.$eh{static b(v){const R=h.Event.fromNodeEventEmitter(v,"connection");return h.Event.map(R,j=>({protocol:new y.$lh(new w(j,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(j,"close"))}))}constructor(v){super(o.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$uh=o;function k(D){return new Promise((v,R)=>{const j=(0,O.createServer)();j.on("error",R),j.listen(D,()=>{j.removeListener("error",R),v(new o(j))})})}e.$vh=k;function I(D,v){return new Promise((R,j)=>{const N=(0,O.createConnection)(D,()=>{N.removeListener("error",j),R(y.$mh.fromSocket(new w(N,`ipc-client${v}`),v))});N.once("error",j)})}e.$wh=I}),define(te[28],ie([0,1,55,9,4,99,36,89,6]),function(J,e,P,O,s,M,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=e.$44b=void 0,e.$44b=(0,h.$Bh)(A.$Hh);class l extends S.$$l{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,O.$8d)(this.userDataPath,"clp")}get backupHome(){return(0,O.$8d)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$th)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,O.$8d)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const $ in process.env)if($.endsWith("_VSCODE_SNAP_ORIG")){const p=$.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[$]?process.env[p]=process.env[$]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$k)for(const $ in this.d)process.env[$]=this.d[$],delete this.d[$]}}e.$54b=l,ke([P.$5g],l.prototype,"cachedLanguagesPath",null),ke([P.$5g],l.prototype,"backupHome",null),ke([P.$5g],l.prototype,"mainIPCHandle",null),ke([P.$5g],l.prototype,"mainLockfile",null),ke([P.$5g],l.prototype,"disableUpdates",null),ke([P.$5g],l.prototype,"crossOriginIsolated",null),ke([P.$5g],l.prototype,"codeCachePath",null),ke([P.$5g],l.prototype,"useCodeCache",null)}),define(te[284],ie([0,1,72,32,13,9,4,19,21,195,18,28,33,16,5,194,29,98]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$p5b=void 0;let m=class{static{a=this}static{this.a="backupWorkspaces"}constructor(d,t,u,r){this.j=d,this.k=t,this.l=u,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$$f,this.i={isEqual:(i,n)=>(0,O.$Gf)(i,n,!A.$k)}}async initialize(){const d=this.m.getItem(a.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(d.emptyWindows),this.d=await this.u((0,l.$i5b)(d)),this.e=await this.v((0,l.$j5b)(d)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$qk.OFF}q(){return this.s()===f.$qk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$qk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(d,t){this.d.some(r=>d.workspace.id===r.workspace.id)||(this.d.push(d),this.C());const u=(0,M.$8d)(this.c,d.workspace.id);return t?this.t(u,t).then(()=>u):u}async t(d,t){if(await h.Promises.exists(d)&&await this.z(d),await h.Promises.exists(t))try{await h.Promises.rename(t,d,!1)}catch(u){this.l.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}registerFolderBackup(d){return this.e.some(t=>this.h.isEqual(d.folderUri,t.folderUri))||(this.e.push(d),this.C()),(0,M.$8d)(this.c,this.D(d))}registerEmptyWindowBackup(d){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,d.backupFolder))||(this.g.push(d),this.C()),(0,M.$8d)(this.c,d.backupFolder)}async u(d){if(!Array.isArray(d))return[];const t=new Set,u=[];for(const r of d){const i=r.workspace;if(!(0,g.$Ph)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$8d)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?u.push(r):await this.z(n):await this.x(n)}}return u}async v(d){if(!Array.isArray(d))return[];const t=[],u=new Set;for(const r of d){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!u.has(n)){u.add(n);const o=(0,M.$8d)(this.c,this.D(r));await this.B(o)?i.scheme!==s.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(r):await this.z(o):await this.x(o)}}return t}async w(d){if(!Array.isArray(d))return[];const t=[],u=new Set;for(const r of d){const i=r.backupFolder;if(typeof i!="string")return[];if(!u.has(i)){u.add(i);const n=(0,M.$8d)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(d){try{await h.Promises.rm(d,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let d=(0,c.$o5b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,d.id));)d=(0,c.$o5b)();return{backupFolder:d.id}}async z(d){const t=this.y(),u=(0,M.$8d)(this.c,t.backupFolder);try{await h.Promises.rename(d,u,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const d=[];for(const t of this.d)await this.A(t)&&d.push(t);for(const t of this.e)await this.A(t)&&d.push(t);return d}A(d){let t;return(0,l.$h5b)(d)?t=(0,M.$8d)(this.c,d.backupFolder):(0,w.$5T)(d)?t=(0,M.$8d)(this.c,this.D(d)):t=(0,M.$8d)(this.c,d.workspace.id),this.B(t)}async B(d){try{const t=await h.Promises.readdir(d);for(const u of t)try{if((await h.Promises.readdir((0,M.$8d)(d,u))).length>0)return!0}catch{}}catch{}return!1}C(){const d={workspaces:this.d.map(({workspace:t,remoteAuthority:u})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return u&&(r.remoteAuthority=u),r}),folders:this.e.map(({folderUri:t,remoteAuthority:u})=>{const r={folderUri:t.toString()};return u&&(r.remoteAuthority=u),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:u})=>{const r={backupFolder:t};return u&&(r.remoteAuthority=u),r})};this.m.setItem(a.a,d)}D(d){const t=d.folderUri;let u;return t.scheme===s.Schemas.file?u=A.$k?t.fsPath:t.fsPath.toLowerCase():u=t.toString().toLowerCase(),(0,P.createHash)("md5").update(u).digest("hex")}};e.$p5b=m,e.$p5b=m=a=ke([_(0,$.$44b),_(1,b.$7h),_(2,y.$4i),_(3,p.$$M)],m)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,33,28]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$74b=e.LifecycleMainPhase=e.ShutdownReason=e.$64b=void 0,e.$64b=(0,b.$Ah)("lifecycleMainService");var w;(function(a){a[a.QUIT=1]="QUIT",a[a.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var g;(function(a){a[a.Starting=1]="Starting",a[a.Ready=2]="Ready",a[a.AfterWindowOpen=3]="AfterWindowOpen",a[a.Eventually=4]="Eventually"})(g||(e.LifecycleMainPhase=g={}));let c=class extends A.$jc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(m,E,d){super(),this.F=m,this.G=E,this.H=d,this.c=this.B(new M.$ed),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$ed),this.onWillShutdown=this.f.event,this.g=this.B(new M.$ed),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$ed),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const m=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",m);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&P.app.quit()};P.app.addListener("window-all-closed",E),P.app.once("will-quit",d=>{this.S("Lifecycle#app.on(will-quit) - begin"),d.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",m),P.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(m){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const d=[];return this.f.fire({reason:m,join(t,u){E.trace(`Lifecycle#onWillShutdown - begin '${t}'`),d.push(u.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(d)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===m)return;this.S(`lifecycle (main): phase changed (value: ${m})`),this.n=m;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(m){if(m<=this.n)return;let E=this.C.get(m);E||(E=new s.$Eg,this.C.set(m,E)),await E.wait()}registerWindow(m){const E=new A.$ic;this.t++,E.add(m.onWillLoad(t=>this.g.fire({window:m,workspace:t.workspace,reason:t.reason})));const d=(0,l.$tf)(m.win);d.on("close",t=>{const u=m.id;if(this.r.has(u)){this.r.delete(u);return}this.S(`Lifecycle#window.on('close') - window ID ${m.id}`),t.preventDefault(),this.unload(m,1).then(r=>{if(r){this.r.delete(u);return}this.r.add(u),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${u}`),this.h.fire(m),m.close()})}),d.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.t--,E.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}async reload(m,E){await this.unload(m,3)||m.reload(E)}unload(m,E){const d=this.z.get(m.id);if(d)return d;const t=this.M(m,E).finally(()=>{this.z.delete(m.id)});return this.z.set(m.id,t),t}async M(m,E){if(!m.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${m.id}`);const d=this.j?2:E,t=await this.P(m,d);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.N(t)):(await this.Q(m,d),!1)}N(m){return m?(this.O(!0),this.j=!1,!0):!1}O(m){this.w&&(this.w(m),this.w=void 0,this.u=void 0)}P(m,E){return new Promise(d=>{const t=this.s++,u=`vscode:ok${t}`,r=`vscode:cancel${t}`;O.$JS.once(u,()=>{d(!1)}),O.$JS.once(r,()=>{d(!0)}),m.send("vscode:onBeforeUnload",{okChannel:u,cancelChannel:r,reason:E})})}Q(m,E){return new Promise(d=>{const u=`vscode:reply${this.s++}`;O.$JS.once(u,()=>d()),m.send("vscode:onWillUnload",{replyChannel:u,reason:E})})}quit(m){return this.R(m).then(E=>{if(!E&&m)try{if(S.$i){const d=(0,h.cwd)();d!==process.cwd()&&process.chdir(d)}}catch(d){this.F.error(d)}return E})}R(m){return this.S(`Lifecycle#quit() - begin (willRestart: ${m})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(m&&this.G.setItem(y.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(m){this.H.args["enable-smoke-test-driver"]?this.F.info(m):this.F.trace(m)}setRelaunchHandler(m){this.D=m}async relaunch(m){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(m?.addArgs&&E.push(...m.addArgs),m?.removeArgs)for(const u of m.removeArgs){const r=E.indexOf(u);r>=0&&E.splice(r,1)}const d=()=>{this.D?.handleRelaunch(m)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:E}))};P.app.once("quit",d),await this.quit(!0)&&P.app.removeListener("quit",d)}async kill(m){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Gg)(1e3),(async()=>{for(const E of P.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let d;E.webContents&&!E.webContents.isDestroyed()?d=new Promise(t=>E.once("closed",t)):d=Promise.resolve(),E.destroy(),await d}})()]),P.app.exit(m)}};e.$74b=c,e.$74b=c=y=ke([_(0,$.$4i),_(1,p.$$M),_(2,f.$44b)],c)}),define(te[285],ie([0,1,4,3,2,6,20]),function(J,e,P,O,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=e.$V5b=void 0,e.$V5b=(0,M.$Ah)("keyboardLayoutMainService");let S=class extends s.$jc{constructor(b){super(),this.a=this.B(new O.$ed),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise(($,p)=>{J(["native-keymap"],$,p)});this.c=h(b),P.$s||b.onDidChangeKeyboardLayout(()=>{this.c=h(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$W5b=S,e.$W5b=S=ke([_(0,A.$64b)],S);function h(l){const b=l.getKeyMap(),$=l.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:$}}}),define(te[286],ie([0,1,245,8,17,14,12,18,36,94,5,51,244,283]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=void 0;let y=class extends $.$Io{constructor(a,m,E,d){super(d),this.m=a,this.n=m,this.r=E,this.s(),this.B(a.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const a=this.m.getValue("http");this.f=a?.proxy,this.g=!!a?.proxyStrictSSL,this.h=a?.proxyAuthorization}async request(a,m){const{f:E,g:d}=this;let t;try{t=await(0,l.$Ll)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$8)(i)))}const u={...process.env,...t},r=a.agent?a.agent:await(0,p.$Lq)(a.url||"",u,{proxyUrl:E,strictSSL:d});return a.agent=r,a.strictSSL=d,this.h&&(a.headers={...a.headers||{},"Proxy-Authorization":this.h}),this.c(a.isChromiumNetwork?"electron":"node",a,()=>g(a,m))}async resolveProxy(a){}};e.$Mq=y,e.$Mq=y=ke([_(0,S.$7h),_(1,h.$Ih),_(2,b.$4i),_(3,b.$5i)],y);async function w(c){return((0,P.parse)(c.url).protocol==="https:"?await new Promise((E,d)=>{J(["https"],E,d)}):await new Promise((E,d)=>{J(["http"],E,d)})).request}async function g(c,a){return O.Promises.withAsyncBody(async(m,E)=>{const d=(0,P.parse)(c.url),t=c.getRawRequest?c.getRawRequest(c):await w(c),u={hostname:d.hostname,port:d.port?parseInt(d.port):d.protocol==="https:"?443:80,protocol:d.protocol,path:d.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$of)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(u.auth=c.user+":"+c.password);const r=t(u,i=>{const n=(0,A.$mf)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)g({...c,url:i.headers.location,followRedirects:n-1},a).then(m,E);else{let o=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,f.createGunzip)())),m({res:i,stream:(0,s.$Td)(o)})}});r.on("error",E),c.timeout&&r.setTimeout(c.timeout),c.isChromiumNetwork&&r.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&r.write(c.data),r.end(),a.onCancellationRequested(()=>{r.abort(),E(new M.$3)})})}e.$Nq=g}),define(te[287],ie([0,1,15,286]),function(J,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=void 0;function s(A){return P.net.request}class M extends O.$Mq{request(S,h){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},h)}}e.$Y6b=M}),define(te[82],ie([0,1,7,49,3,2,36,16,6,20,5,96,280,41,53,40,13]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e5b=e.$d5b=e.$c5b=e.$b5b=void 0,e.$b5b=(0,h.$Ah)("storageMainService");let c=class extends M.$jc{constructor(E,d,t,u,r,i){super(),this.c=E,this.f=d,this.g=t,this.h=u,this.j=r,this.m=i,this.a=void 0,this.b=this.B(new s.$ed),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.B(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,d]of this.t)E.join("profileStorage",d.close());for(const[,d]of this.w)E.join("workspaceStorage",d.close())})),this.B(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.j.exists(E.profile.globalStorageHome)||await this.j.createFolder(E.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(E=>{const d=this.t.get(E.profile.id);d&&E.join(d.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const E=new p.$94b(this.n(),this.g,this.c,this.j);return this.B((0,O.$bb)(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),E}profileStorage(E){if((0,$.$Wo)(E))return this.applicationStorage;let d=this.t.get(E.id);if(!d){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),d=this.B(this.u(E)),this.t.set(E.id,d);const t=this.B(d.onDidChangeStorage(u=>this.b.fire({...u,storage:d,profile:E})));this.B((0,O.$bb)(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.t.delete(E.id),t.dispose()}))}return d}u(E){return this.a===2?new p.$$4b(this.c,this.j):new p.$84b(E,this.n(),this.c,this.j)}workspaceStorage(E){let d=this.w.get(E.id);return d||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),d=this.B(this.y(E)),this.w.set(E.id,d),this.B((0,O.$bb)(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.w.delete(E.id)}))),d}y(E){return this.a===2?new p.$$4b(this.c,this.j):new p.$04b(E,this.n(),this.c,this.f,this.j)}isUsed(E){const d=P.URI.file(E);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(P.URI.file(t.path),d))return!0;return!1}};e.$c5b=c,e.$c5b=c=ke([_(0,b.$4i),_(1,A.$Hh),_(2,y.$_4b),_(3,l.$64b),_(4,S.$5j),_(5,w.$Bk)],c),e.$d5b=(0,h.$Ah)("applicationStorageMainService");let a=class extends $.$Vo{constructor(E,d){super(),this.s=E,this.U=d,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(E){if(E===-1)return this.U.applicationStorage.storage}Q(E){if(E===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$e5b=a,e.$e5b=a=ke([_(0,f.$Dk),_(1,e.$b5b)],a)}),define(te[288],ie([0,1,15,22,3,57,2,31,115,5,82,30]),function(J,e,P,O,s,M,A,S,h,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=void 0;var p;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let f=class extends A.$jc{constructor(w,g,c,a){super(),this.g=w,this.h=g,this.j=c,this.m=a,this.a="proxy-credentials://",this.b=void 0,this.c=p.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(P.app,"login",(g,c,a,m,E)=>({event:g,webContents:c,req:a,authInfo:m,callback:E}));this.B(w(this.r,this))}async r({event:w,authInfo:g,req:c,callback:a}){if(!g.isProxy)return;if(!this.b&&this.c===p.LoginDialogShown&&c.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let m;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),m=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(g);try{m=await this.b}finally{this.b=void 0}}a(m?.username,m?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.t(w);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const g=String((0,M.$oi)({scheme:w.scheme,host:w.host,port:w.port}));let c,a;try{const t=this.m.get(this.a+g,-1);if(t){const u=JSON.parse(await this.j.decrypt(t));c=u.username,a=u.password}}catch(t){this.g.error(t)}if(this.c!==p.StoredCredentialsUsed&&typeof c=="string"&&typeof a=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=p.StoredCredentialsUsed,{username:c,password:a};const m=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!m){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${m.id} to handle proxy login`);const E={authInfo:w,username:this.f?.username??c,password:this.f?.password??a,replyChannel:`vscode:proxyAuthResponse:${(0,S.$3f)()}`};m.sendWhenReady("vscode:openProxyAuthenticationDialog",O.CancellationToken.None,E),this.c=p.LoginDialogShown;const d=await new Promise(t=>{const u=async(r,i,n)=>{if(i===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${m.id}`),m.win?.webContents.off("ipc-message",u),n){const o={username:n.username,password:n.password};try{if(n.remember){const k=await this.j.encrypt(JSON.stringify(o));this.m.store(this.a+g,k,-1,1)}else this.m.remove(this.a+g,-1)}catch(k){this.g.error(k)}t({username:o.username,password:o.password})}else t(void 0)};m.win?.webContents.on("ipc-message",u)});return this.f=d,d}};e.$g5b=f,e.$g5b=f=ke([_(0,l.$4i),_(1,$.$f5b),_(2,h.$rT),_(3,b.$d5b)],f)}),define(te[289],ie([0,1,87,27,103,99,8,2,4,18,5,24,240,241,95,126,17]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=e.$W6b=e.$V6b=e.$U6b=void 0;async function c(t,u,r,i,n){let o;for(let k=3;k&&(o?.dispose(),o=await new a(t,u,r,i,n).waitForReady(),!(n&&s.$6f[n]||!s.$6f[o.tunnelLocalPort]));k--);return o}class a extends S.$jc{constructor(u,r,i,n,o){super(),this.m=r,this.n=o,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=u,this.b=P.createServer(),this.c=new A.$Eg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const u=this.n??this.tunnelRemotePort,r=(0,w.$1z)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$7f)(u,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(u){u.pause();const r=(0,w.$Yz)(this.tunnelRemoteHost)||(0,w.$1z)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$Yk)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&u.write(o.buffer),u.on("end",()=>{u.localAddress&&this.j.delete(u.localAddress),n.end()}),u.on("close",()=>n.end()),u.on("error",()=>{u.localAddress&&this.j.delete(u.localAddress),n instanceof M.$ph?n.socket.destroy():n.end()}),n instanceof M.$ph?this.t(u,n):this.s(u,n),u.localAddress&&this.j.set(u.localAddress,()=>{u.end(),n.end()})}s(u,r){r.onClose(()=>u.destroy()),r.onEnd(()=>u.end()),r.onData(i=>u.write(i.buffer)),u.on("data",i=>r.write(g.$Ed.wrap(i))),u.resume()}t(u,r){const i=r.socket;i.on("end",()=>u.end()),i.on("close",()=>u.end()),i.on("error",()=>{u.destroy()}),i.pipe(u),u.pipe(i)}}e.$U6b=a;let m=class extends w.$4z{constructor(u,r,i,n,o){super(r,o),this.u=u,this.v=i,this.w=n}isPortPrivileged(u){return(0,w.$2z)(u,this.l,h.OS,O.release())}s(u,r,i,n,o,k,I,D){const v=this.r(r,i);if(v)return++v.refcount,v.value;if((0,w.$Vz)(u))return this.t(u,r,i,o,k,I,D);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const R={commit:this.w.commit,quality:this.w.quality,addressProvider:u,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=c(R,n,r,i,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,j),j}}};e.$V6b=m,e.$V6b=m=ke([_(0,f.$Sk),_(1,b.$4i),_(2,y.$Vk),_(3,$.$jj),_(4,l.$7h)],m);let E=class extends m{constructor(u,r,i,n,o){super(u,r,i,n,o)}};e.$W6b=E,e.$W6b=E=ke([_(0,f.$Sk),_(1,b.$4i),_(2,y.$Vk),_(3,$.$jj),_(4,l.$7h)],E);let d=class extends S.$jc{constructor(u,r,i,n,o){super(),this.b=u,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(u,r,i,n,o,k,I,D,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${k}.`),!this.a.has(u)){const R=new E(this.b,this.c,this.g,this.f,this.h);this.B(R),this.a.set(u,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this.a.delete(u))})}return this.a.get(u).openTunnel(r,i,n,o,k,I,D,v)}};e.$X6b=d,e.$X6b=d=ke([_(0,f.$Sk),_(1,b.$4i),_(2,$.$jj),_(3,y.$Vk),_(4,l.$7h)],d)}),define(te[100],ie([0,1,8,22,3,18,28,20,5,24,51,48]),function(J,e,P,O,s,M,A,S,h,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=e.$i6b=void 0;function p(y,w,g){return`${g.updateUrl}/api/update/${y}/${w}/${g.commit}`}e.$i6b=p;let f=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,g,c,a,m,E){this.f=w,this.g=g,this.h=c,this.i=a,this.j=m,this.k=E,this.b=$.$IT.Uninitialized,this.c=new s.$ed,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d($.$IT.Disabled(0));return}if(this.h.disableUpdates){this.d($.$IT.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d($.$IT.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),g=this.m(w);if(!g){this.d($.$IT.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(g),!this.a){this.d($.$IT.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d($.$IT.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,c=>this.j.error(c))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,P.$Gg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},O.CancellationToken.None)).res.statusCode===204}catch(g){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(g);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$j6b=f,e.$j6b=f=ke([_(0,S.$64b),_(1,M.$7h),_(2,A.$44b),_(3,b.$Ho),_(4,h.$4i),_(5,l.$jj)],f)}),define(te[290],ie([0,1,15,55,3,2,18,28,20,5,24,51,25,48,100]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=void 0;let w=class extends y.$j6b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(c,a)=>a)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(c,a,m)=>({url:a,version:m,productVersion:m}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(c,a,m,E)=>({releaseNotes:a,version:m,productVersion:m,date:E}))}constructor(c,a,m,E,d,t,u){super(c,a,E,d,t,u),this.z=m,this.u=new M.$ic,c.setRelaunchHandler(this)}handleRelaunch(c){return c?.addArgs||c?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(c){this.j.error("UpdateService error:",c);const a=this.state.type==="checking for updates"&&this.state.explicit?c:void 0;this.d(f.$IT.Idle(1,a))}s(c){let a;this.k.darwinUniversalAssetId?a=this.k.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,y.$i6b)(a,c,this.k);try{P.autoUpdater.setFeedURL({url:m})}catch(E){this.j.error("Failed to set update feed URL",E);return}return m}t(c){this.d(f.$IT.CheckingForUpdates(c)),P.autoUpdater.checkForUpdates()}E(c){this.state.type==="checking for updates"&&this.d(f.$IT.Downloading(c))}F(c){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:c.version}),this.d(f.$IT.Ready(c)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$IT.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$k6b=w,ke([O.$5g],w.prototype,"v",null),ke([O.$5g],w.prototype,"w",null),ke([O.$5g],w.prototype,"x",null),ke([O.$5g],w.prototype,"y",null),e.$k6b=w=ke([_(0,h.$64b),_(1,A.$7h),_(2,p.$8k),_(3,S.$44b),_(4,$.$Ho),_(5,l.$4i),_(6,b.$jj)],w)}),define(te[291],ie([0,1,47,45,8,3,9,28,20,5,25,48]),function(J,e,P,O,s,M,A,S,h,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=void 0;let p=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,g,c){if(this.f=w,this.g=c,this.a=$.$IT.Uninitialized,this.b=new M.$ed,this.onStateChange=this.b.event,g.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d($.$IT.Idle(this.k())),this.h(30*1e3).then(void 0,a=>this.g.error(a))}h(w=60*60*1e3){return(0,s.$Gg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};p=ke([_(0,h.$64b),_(1,S.$44b),_(2,l.$4i)],p);let f=class extends p{constructor(w,g,c,a,m,E){super(c,a,m),this.o=w,this.p=g,this.q=E;const d=(0,O.watch)(A.$$d(this.o)),t=M.Event.fromNodeEventEmitter(d,"change",(n,o)=>o),u=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(u,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));c.onWillShutdown(()=>{i.dispose(),d.close()})}m(){this.d($.$IT.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d($.$IT.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d($.$IT.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d($.$IT.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+A.$_d(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((c,a)=>(0,O.realpath)(`${A.$$d(this.o)}/current`,(m,E)=>m?a(m):c(E))),g=A.$_d(w);return this.p!==g}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$m6b=f,e.$m6b=f=ke([_(2,h.$64b),_(3,S.$44b),_(4,l.$4i),_(5,b.$8k)],f)}),define(te[292],ie([0,1,2,20,53,29,8,30]),function(J,e,P,O,s,M,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=void 0;let h=class extends P.$jc{constructor(b,$,p){super(),this.a=$,this.b=p,this.B(b.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(b.onBeforeCloseWindow(f=>this.c(f))),this.B(new A.$Rg(()=>this.g(),30*1e3)).schedule()}async c(b){const $=this.f(b),p=this.a.getProfileForWorkspace($);p?.isTransient&&(this.a.unsetWorkspace($,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,M.$Oh)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const $=this.b.getWindows().map(p=>this.f(p));for(const p of b)$.some(f=>f.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$F6b=h,e.$F6b=h=ke([_(0,O.$64b),_(1,s.$_4b),_(2,S.$f5b)],h)}),define(te[62],ie([0,1,15,2,3,5,311,8,13,30,70,25,20,73,37,4,131]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$z5b=e.$y5b=void 0;function a(d){return typeof d.responseWindowId=="number"}let m=class extends O.$jc{static{c=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(c.b.values())}constructor(t,u,r){super(),this.t=t,this.u=u,this.w=r,this.c=String(++c.a),this.f=this.B(new s.$ed),this.onStdout=this.f.event,this.g=this.B(new s.$ed),this.onStderr=this.g.event,this.h=this.B(new s.$ed),this.onMessage=this.h.event,this.j=this.B(new s.$ed),this.onExit=this.j.event,this.m=this.B(new s.$ed),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(t,u){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`,u){case b.default.Error:this.t.error(r);break;case b.default.Warning:this.t.warn(r);break;case b.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",b.default.Error),!1):!0}start(t){const u=this.C(t);return u&&t.payload&&this.postMessage(t.payload),u}C(t){if(!this.z())return!1;this.s=t;const u=`${this.s.type}-${this.c}`,r=h.$1f.asFileUri("bootstrap-fork.js").fsPath,i=this.s.args??[],n=this.s.execArgv??[],o=this.s.allowLoadingUnsignedLibraries,k=this.s.forceAllocationsToV8Sandbox,I="pipe",D=this.D(t);return this.y("creating new...",b.default.Info),this.n=P.utilityProcess.fork(r,i,{serviceName:u,env:D,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:k,stdio:I}),this.F(this.n,this.s,u),!0}D(t){const u=t.env?{...t.env}:{...(0,y.$Um)(process.env)};u.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(u.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),u.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$i&&((0,g.isUNCAccessRestrictionsDisabled)()?u.NODE_DISABLE_UNC_ACCESS_CHECKS="1":u.NODE_UNC_HOST_ALLOWLIST=(0,g.getUNCHostAllowlist)().join("\\")),(0,f.$sl)(u);for(const r of Object.keys(u))u[r]=String(u[r]);return u}F(t,u,r){if(t.stdout){const i=new A.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new A.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.r=t.pid,typeof t.pid=="number"&&c.b.set(t.pid,{pid:t.pid,name:a(u)?`${u.type} [${u.responseWindowId}]`:u.type}),this.y("successfully created",b.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.y(`received exit event with code ${i}`,b.default.Info),this.j.fire({pid:this.r,code:i,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.y(`crashed with code ${i.exitCode} and reason '${i.reason}'`,b.default.Error),this.u.publicLog2("utilityprocesscrash",{type:u.type,reason:i.reason,code:i.exitCode}),this.m.fire({pid:this.r,code:i.exitCode,reason:i.reason}),this.G())}))}once(t,u){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),u())}))}postMessage(t,u){this.n&&this.n.postMessage(t,u)}connect(t){const{port1:u,port2:r}=new P.MessageChannelMain;return this.postMessage(t,[r]),u}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",b.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",b.default.Info),this.n.kill()?(this.y("successfully killed the process",b.default.Info),this.G()):this.y("unable to kill the process",b.default.Warning)}G(){typeof this.r=="number"&&c.b.delete(this.r),this.n=void 0}async waitForExit(t){this.n&&(this.y("waiting to exit...",b.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Gg)(t)]),this.n&&(this.y(`did not exit within ${t}ms, will kill it now...`,b.default.Info),this.kill()))}};e.$y5b=m,e.$y5b=m=c=ke([_(0,M.$4i),_(1,$.$8k),_(2,p.$64b)],m);let E=class extends m{constructor(t,u,r,i){super(t,r,i),this.H=u}start(t){const u=this.H.getWindowById(t.responseWindowId);if(!u?.win||u.win.isDestroyed()||u.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error),!0;if(!super.C(t))return!1;this.I(u.win,t);const i=this.connect(t.payload);return u.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}I(t,u){u.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$z5b=E,e.$z5b=E=ke([_(0,M.$4i),_(1,l.$f5b),_(2,$.$8k),_(3,p.$64b)],E)}),define(te[293],ie([0,1,14,5,20,8,62,30,25]),function(J,e,P,O,s,M,A,S,h){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$H5b=void 0;let b=class{static{l=this}static{this.a=0}constructor(p,f,y,w){this.d=p,this.f=f,this.g=y,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(p){const f=this.b.get(p);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(p){return this.i(p).onStdout}onDynamicStderr(p){return this.i(p).onStderr}onDynamicMessage(p){return this.i(p).onMessage}onDynamicExit(p){return this.i(p).onExit}async createExtensionHost(){if(this.c)throw(0,P.$4)();const p=String(++l.a),f=new A.$z5b(this.d,this.g,this.h,this.f);return this.b.set(p,f),f.onExit(({pid:y,code:w,signal:g})=>{this.d.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${g}.`),setTimeout(()=>{f.dispose(),this.b.delete(p)})}),{id:p}}async start(p,f){if(this.c)throw(0,P.$4)();this.i(p).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:p})}async enableInspectPort(p){if(this.c)throw(0,P.$4)();const f=this.b.get(p);return f?f.enableInspectPort():!1}async kill(p){if(this.c)throw(0,P.$4)();const f=this.b.get(p);f&&f.kill()}async _killAllNow(){for(const[,p]of this.b)p.kill()}async _waitForAllExit(p){const f=[];for(const[,y]of this.b)f.push(y.waitForExit(p));return M.Promises.settled(f).then(()=>{})}};e.$H5b=b,e.$H5b=b=l=ke([_(0,O.$4i),_(1,s.$64b),_(2,S.$f5b),_(3,h.$8k)],b)}),define(te[294],ie([0,1,38,8,2,28,20,5,41,39,66,62,52,89,12,246,24]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=void 0;let c=class extends s.$jc{constructor(m,E,d,t,u,r,i,n){super(),this.c=m,this.f=E,this.g=d,this.h=t,this.j=u,this.m=r,this.n=i,this.r=n,this.a=new O.$Eg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$JS.on(w.$a6b.request,(m,E)=>this.t(m,E,w.$a6b.response)),P.$JS.on(w.$b6b.request,(m,E)=>this.t(m,E,w.$b6b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t(m,E,d){this.j.trace(`[SharedProcess] onWindowConnection for: ${d}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(d);if(m.sender.isDestroyed())return t.close();m.sender.postMessage(d,E,[t])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$_5b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const m=new O.$1g;this.b?this.b.once(w.$_5b.initDone,()=>m.complete()):P.$JS.once(w.$_5b.initDone,()=>m.complete()),await m.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const m=new O.$1g;this.b?this.b.once(w.$_5b.ipcReady,()=>m.complete()):P.$JS.once(w.$_5b.ipcReady,()=>m.complete()),await m.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new $.$y5b(this.j,p.$ao,this.h));const m=(0,f.$am)(this.f.args,this.f.isBuilt);let E;m.port&&(E=["--nolazy"],m.break?E.push(`--inspect-brk=${m.port}`):E.push(`--inspect=${m.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect(m){return await this.z,(0,y.$tf)(this.b).connect(m)}};e.$c6b=c,e.$c6b=c=ke([_(1,M.$44b),_(2,h.$Dk),_(3,A.$64b),_(4,S.$4i),_(5,b.$05b),_(6,l.$9m),_(7,g.$jj)],c)}),define(te[295],ie([0,1,28,89,20,5,52,62,110,38,2,3,37,18,13]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=void 0;let w=class extends b.$jc{constructor(c,a,m,E,d){super(),this.f=c,this.g=a,this.h=m,this.j=E,this.m=d,this.a=void 0,this.b=new $.$ed,this.onRequestConnection=this.b.event,this.c=new $.$ed,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$JS.on("vscode:createPtyHostMessageChannel",(t,u)=>this.r(t,u)),this.B((0,b.$hc)(()=>{l.$JS.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$y5b(this.m,A.$ao,this.j);const c=(0,O.$_l)(this.h.args,this.h.isBuilt),a=c.port?["--nolazy",`--inspect${c.break?"-brk":""}=${c.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:a,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const m=this.a.connect(),E=new h.$RS(m,"ptyHost"),d=new b.$ic;return d.add(E),d.add((0,b.$hc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:d,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const c={...(0,p.$Um)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},a=this.g.getValue("terminal.integrated.developer.ptyHost.latency");a&&typeof a=="number"&&(c.VSCODE_LATENCY=String(a));const m=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return m&&typeof m=="number"&&(c.VSCODE_STARTUP_DELAY=String(m)),this.h.restoreSnapExportedVariables(),c}r(c,a){this.b.fire();const m=this.a.connect();if(c.sender.isDestroyed()){m.close();return}c.sender.postMessage("vscode:createPtyHostMessageChannelResult",a,[m])}};e.$N6b=w,e.$N6b=w=ke([_(1,f.$7h),_(2,P.$44b),_(3,s.$64b),_(4,M.$4i)],w)}),define(te[296],ie([0,1,2,6,5,30,62,25,57,3,8,20]),function(J,e,P,O,s,M,A,S,h,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=e.$L6b=void 0,e.$L6b=(0,O.$Ah)("utilityProcessWorker");let p=class extends P.$jc{constructor(w,g,c,a){super(),this.b=w,this.c=g,this.f=c,this.g=a,this.a=new Map}async createWorker(w){const g=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${g})`);const c=this.h(w);this.a.has(c)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${g})`),this.disposeWorker(w));const a=new f(this.b,this.c,this.f,this.g,w);if(!a.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(c,a);const m=new b.$1g;return l.Event.once(a.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(c),m.complete({reason:E})}),m.p}h(w){return(0,h.$oi)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const g=this.h(w),c=this.a.get(g);c&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),c.kill(),this.a.delete(g))}};e.$M6b=p,e.$M6b=p=ke([_(0,s.$4i),_(1,M.$f5b),_(2,S.$8k),_(3,$.$64b)],p);let f=class extends P.$jc{constructor(w,g,c,a,m){super(),this.c=w,this.f=g,this.g=c,this.h=a,this.j=m,this.a=this.B(new l.$ed),this.onDidTerminate=this.a.event,this.b=new A.$z5b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const g=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:g,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=ke([_(0,s.$4i),_(1,M.$f5b),_(2,S.$8k),_(3,$.$64b)],f)}),define(te[297],ie([0,1,15,2,4,19,7,18,20,5,33,30,128,29]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=e.$x6b=e.$w6b=void 0;let w=class extends O.$jc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(d,t,u,r,i){super(),this.g=d,this.h=t,this.j=u,this.m=r,this.n=i,this.b=g(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(d=>this.u(d)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(d=>{d.newCount-d.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(d=>this.u(d))}s(){this.f=!0,this.t()}t(){const d=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&d.add(t.lastActiveWindow.uiState.display))}const u=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);u&&(t.lastPluginDevelopmentHostWindow=this.w(u),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(d.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!u.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):d.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(d.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):d.add(n.uiState.display)),n}));const r=a(t);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(d){if(this.j.quitRequested)return;const t=this.w(d);d.isExtensionDevelopmentHost&&!d.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!d.isExtensionDevelopmentHost&&d.openedWorkspace&&this.b.openedWindows.forEach(u=>{const r=(0,f.$Ph)(d.openedWorkspace)&&u.workspace?.id===d.openedWorkspace.id,i=(0,f.$Kh)(d.openedWorkspace)&&u.folderUri&&M.$$f.isEqual(u.folderUri,d.openedWorkspace.uri);(r||i)&&(u.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(d){return{windowId:d.id,workspace:(0,f.$Ph)(d.openedWorkspace)?d.openedWorkspace:void 0,folderUri:(0,f.$Kh)(d.openedWorkspace)?d.openedWorkspace.uri:void 0,backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.serializeWindowState()}}getNewWindowState(d){const t=this.z(d),u=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||u?.restoreFullscreen),r||(t.mode=1)}return t}z(d){const t=this.g.getLastActiveWindow();if(!d.extensionTestsPath){if(d.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const k=d.workspace;if((0,f.$Ph)(k)){const D=this.state.openedWindows.filter(v=>v.workspace&&v.workspace.id===k.id).map(v=>v.uiState);if(D.length)return D[0]}if((0,f.$Kh)(k)){const D=this.state.openedWindows.filter(v=>v.folderUri&&M.$$f.isEqual(v.folderUri,k.uri)).map(v=>v.uiState);if(D.length)return D[0]}else if(d.backupPath){const D=this.state.openedWindows.filter(v=>v.backupPath===d.backupPath).map(v=>v.uiState);if(D.length)return D[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let u;const r=P.screen.getAllDisplays();if(r.length===1)u=r[0];else{if(s.$j){const k=P.screen.getCursorScreenPoint();u=P.screen.getDisplayNearestPoint(k)}!u&&t&&(u=P.screen.getDisplayMatching(t.getBounds())),u||(u=P.screen.getPrimaryDisplay()||r[0])}let i=(0,p.$34b)();i.x=Math.round(u.bounds.x+u.bounds.width/2-i.width/2),i.y=Math.round(u.bounds.y+u.bounds.height/2-i.height/2);const n=this.n.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const k=t.serializeWindowState();k.mode===3?i.mode=3:i=k,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.C(i)),i.hasDefaultState=!0,i}C(d){if(this.g.getWindows().length===0)return d;d.x=typeof d.x=="number"?d.x:0,d.y=typeof d.y=="number"?d.y:0;const t=this.g.getWindows().map(u=>u.getBounds());for(;t.some(u=>u.x===d.x||u.y===d.y);)d.x+=30,d.y+=30;return d}};e.$w6b=w,e.$w6b=w=y=ke([_(0,$.$f5b),_(1,b.$$M),_(2,h.$64b),_(3,l.$4i),_(4,S.$7h)],w);function g(E){const d={openedWindows:[]},t=E||{openedWindows:[]};return t.lastActiveWindow&&(d.lastActiveWindow=c(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(d.lastPluginDevelopmentHostWindow=c(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(d.openedWindows=t.openedWindows.map(u=>c(u))),d}e.$x6b=g;function c(E){const d={uiState:E.uiState};return E.backupPath&&(d.backupPath=E.backupPath),E.remoteAuthority&&(d.remoteAuthority=E.remoteAuthority),E.folder&&(d.folderUri=A.URI.parse(E.folder)),E.workspaceIdentifier&&(d.workspace={id:E.workspaceIdentifier.id,configPath:A.URI.parse(E.workspaceIdentifier.configURIPath)}),d}function a(E){return{lastActiveWindow:E.lastActiveWindow&&m(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&m(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(d=>m(d))}}e.$y6b=a;function m(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(te[54],ie([0,1,15,3,44,2,13,9,19,21,193,64,61,28,6,5,53,130,29,97,98]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=e.$w5b=void 0,e.$w5b=(0,y.$Ah)("workspacesManagementMainService");let d=class extends M.$jc{constructor(u,r,i,n,o){super(),this.g=u,this.h=r,this.j=i,this.m=n,this.n=o,this.a=this.B(new O.$ed),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new O.$ed),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const u=(await l.Promises.readdir(this.c.with({scheme:A.Schemas.file}).fsPath)).map(r=>(0,h.$hg)(this.c,r,a.$Zh));for(const r of u){const i=(0,E.$m5b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(u){u.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${u}).`)}}resolveLocalWorkspace(u){return this.r(u,r=>l.Promises.readFile(r,"utf8"))}r(u,r){if(this.s(u)&&u.scheme===A.Schemas.file)try{const i=r(u.fsPath);return i instanceof Promise?i.then(n=>this.t(u,n),n=>{}):this.t(u,i)}catch{return}}s(u){return(0,a.$1h)(u,this.g)||(0,a.$6h)(u)}t(u,r){try{const i=this.u(u,r),n=(0,E.$m5b)(u);return{id:n.id,configPath:n.configPath,folders:(0,m.$aU)(i.folders,n.configPath,h.$$f),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(u,r){const i=(0,s.$Km)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,m.$$T)(n));else throw new Error(`${u.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(u,r){const{workspace:i,storedWorkspace:n}=this.w(u,r),o=i.configPath.fsPath;return await l.Promises.mkdir((0,S.$$d)(o),{recursive:!0}),await l.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(u=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,h.$hg)(this.c,i),o=(0,h.$hg)(n,a.$Zh),k=[];for(const I of u)k.push((0,m.$_T)(I.uri,!0,I.name,n,h.$$f));return{workspace:(0,E.$m5b)(o),storedWorkspace:{folders:k,remoteAuthority:r}}}async getWorkspaceIdentifier(u){return(0,E.$m5b)(u)}isUntitledWorkspace(u){return(0,a.$1h)(u.configPath,this.g)}async deleteUntitledWorkspace(u){this.isUntitledWorkspace(u)&&(await this.y(u),this.j.isEnabled()&&this.j.unsetWorkspace(u),this.a.fire(u))}async y(u){const r=(0,h.$8f)(u.configPath);try{await l.Promises.rm((0,S.$$d)(r));const i=(0,S.$8d)(this.g.workspaceStorageHome.with({scheme:A.Schemas.file}).fsPath,u.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,S.$8d)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==u.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(u,r,i){if(!u||!u.win||!u.isReady||!await this.z(u,r,i))return;const o=await this.C(u,(0,E.$m5b)(i));if(o)return this.b.fire({window:u,workspace:o.workspace}),o}async z(u,r,i){return i?(0,a.$Ph)(u.openedWorkspace)&&h.$$f.isEqual(u.openedWorkspace.configPath,i)?!1:(0,c.$u5b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,h.$eg)(i)),detail:(0,b.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(u,r){if(!u.config)return;u.focus();let i;return u.config.extensionDevelopmentPath||(u.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:u.remoteAuthority},u.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:u.remoteAuthority})),(0,a.$Ph)(u.openedWorkspace)&&this.isUntitledWorkspace(u.openedWorkspace)&&await this.deleteUntitledWorkspace(u.openedWorkspace),u.config.workspace=r,u.config.backupPath=i,{workspace:r,backupPath:i}}};e.$x5b=d,e.$x5b=d=ke([_(0,f.$44b),_(1,w.$4i),_(2,g.$_4b),_(3,$.$k5b),_(4,p.$r5b)],d)}),define(te[132],ie([0,1,15,38,22,6,30,29,54,12,5,62]),function(J,e,P,O,s,M,A,S,h,l,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C5b=e.$B5b=e.ID=void 0,e.ID="diagnosticsMainService",e.$B5b=(0,M.$Ah)(e.ID);let p=class{constructor(y,w,g){this.a=y,this.b=w,this.c=g}async getRemoteDiagnostics(y){const w=this.a.getWindows();return(await Promise.all(w.map(async c=>{const a=c.remoteAuthority;if(!a)return;const m=`vscode:getDiagnosticInfoResponse${c.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(c):void 0};return new Promise(d=>{c.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:m,args:E}),O.$JS.once(m,(t,u)=>{u||d({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),d(u)}),setTimeout(()=>{d({hostName:a,errorMessage:`Connection to '${a}' could not be established`})},5e3)})}))).filter(c=>!!c)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const g of P.BrowserWindow.getAllWindows()){const c=this.a.getWindowById(g.id);c?y.push(await this.d(c)):y.push(this.e(g))}const w=[];for(const{pid:g,name:c}of $.$y5b.getAll())w.push({pid:g,name:c});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:w,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(y){const w=await this.f(y),g=(0,l.$tf)(y.win);return this.e(g,w,y.remoteAuthority)}e(y,w=[],g){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:w,remoteAuthority:g}}async f(y){const w=[],g=y.openedWorkspace;if((0,S.$Kh)(g))w.push(g.uri);else if((0,S.$Ph)(g)){const c=await this.b.resolveLocalWorkspace(g.configPath);c&&c.folders.forEach(m=>{w.push(m.uri)})}return w}};e.$C5b=p,e.$C5b=p=ke([_(0,A.$f5b),_(1,h.$w5b),_(2,b.$4i)],p)}),define(te[67],ie([0,1,47,15,27,156,55,3,2,13,9,4,7,105,86,21,103,181,61,28,6,20,5,24,79,30,29,54,17,242,234]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d,t,u,r,i,n,o,k,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=e.$R5b=void 0,e.$R5b=(0,E.$Ah)("nativeHostMainService");let v=class extends h.$jc{constructor(j,N,z,se,ee,ae,ne,oe){super(),this.a=j,this.b=N,this.c=z,this.f=se,this.g=ee,this.h=ae,this.j=ne,this.m=oe,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:G,x:K,y:B})=>({windowId:G.id,x:K,y:B})),({windowId:G})=>!!this.a.getWindowById(G)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-maximize",(G,K)=>K.id),G=>!!this.a.getWindowById(G)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-unmaximize",(G,K)=>K.id),G=>!!this.a.getWindowById(G)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-blur",(G,K)=>K.id),G=>!!this.a.getWindowById(G)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),G=>!!G),G=>G.id),S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-focus",(G,K)=>K.id),G=>!!this.a.getWindowById(G))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(O.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new S.$ed),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(O.screen,"display-metrics-changed",(G,K,B)=>B),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),S.Event.fromNodeEventEmitter(O.screen,"display-added"),S.Event.fromNodeEventEmitter(O.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(N=>({id:N.id,workspace:N.openedWorkspace??(0,n.$Oh)(N.backupPath,N.isExtensionDevelopmentHost),title:N.win?.getTitle()??"",filename:N.getRepresentedFilename(),dirty:N.isDocumentEdited()}))}async getWindowCount(j){return this.a.getWindowCount()}async getActiveWindowId(j){const N=O.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(N)return N.id}openWindow(j,N,z){return Array.isArray(N)?this.r(j,N,z):this.s(j,N)}async r(j,N,z=Object.create(null)){N.length>0&&await this.a.open({context:5,contextWindowId:j,urisToOpen:N,cli:this.f.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async s(j,N){await this.a.openEmptyWindow({context:5,contextWindowId:j},N)}async toggleFullScreen(j){this.C(j)?.toggleFullScreen()}async handleTitleDoubleClick(j){this.C(j)?.handleTitleDoubleClick()}async isMaximized(j){const N=this.C(j);return N?.win?N.win.isMaximized():!1}async maximizeWindow(j){const N=this.C(j);N?.win&&N.win.maximize()}async unmaximizeWindow(j){const N=this.C(j);N?.win&&N.win.unmaximize()}async minimizeWindow(j){const N=this.C(j);N?.win&&N.win.minimize()}async updateWindowControls(j,N){const z=this.C(j);z&&z.updateWindowControls(N)}async focusWindow(j,N){N&&typeof N.windowId=="number"&&(j=N.windowId),this.C(j)?.focus({force:N?.force??!1})}async setMinimumSize(j,N,z){const se=this.C(j);if(se?.win){const[ee,ae]=se.win.getSize(),[ne,oe]=se.win.getMinimumSize(),[G,K]=[N??ne,z??oe],[B,F]=[Math.max(ee,G),Math.max(ae,K)];(ne!==G||oe!==K)&&se.win.setMinimumSize(G,K),(ee!==B||ae!==F)&&se.win.setSize(B,F)}}async saveWindowSplash(j,N){this.j.saveWindowSplash(j,N)}async installShellCommand(j){const{source:N,target:z}=await this.t();try{const{symbolicLink:se}=await w.SymlinkSupport.stat(N);if(se&&!se.dangling){const ee=await(0,f.$Up)(N);if(z===ee)return}await w.Promises.unlink(N)}catch(se){if(se.code!=="ENOENT")throw se}try{await w.Promises.symlink(z,N)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ee}=await this.showMessageBox(j,{type:"info",message:(0,c.localize)(0,null,this.h.nameShort),buttons:[(0,c.localize)(1,null),(0,c.localize)(2,null)]});if(ee===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${N}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ae)}catch{throw new Error((0,c.localize)(3,null,N))}}}async uninstallShellCommand(j){const{source:N}=await this.t();try{await w.Promises.unlink(N)}catch(z){switch(z.code){case"EACCES":{const{response:se}=await this.showMessageBox(j,{type:"info",message:(0,c.localize)(4,null,this.h.nameShort),buttons:[(0,c.localize)(5,null),(0,c.localize)(6,null)]});if(se===0)try{const ee=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ee)}catch{throw new Error((0,c.localize)(7,null,N))}break}case"ENOENT":break;default:throw z}}}async t(){const j=(0,b.$9d)(this.f.appRoot,"bin","code"),N=`/usr/local/bin/${this.h.applicationName}`;if(!await w.Promises.exists(j))throw new Error((0,c.localize)(8,null,j));return{source:N,target:j}}async showMessageBox(j,N){return this.b.showMessageBox(N,this.u(j))}async showSaveDialog(j,N){return this.b.showSaveDialog(N,this.u(j))}async showOpenDialog(j,N){return this.b.showOpenDialog(N,this.u(j))}u(j){const N=this.C(j);if(N?.win)return N.win}async pickFileFolderAndOpen(j,N){const z=await this.b.pickFileFolder(N);z&&await this.w(await Promise.all(z.map(async se=>await w.SymlinkSupport.existsDirectory(se)?{folderUri:p.URI.file(se)}:{fileUri:p.URI.file(se)})),N,j)}async pickFolderAndOpen(j,N){const z=await this.b.pickFolder(N);z&&await this.w(z.map(se=>({folderUri:p.URI.file(se)})),N,j)}async pickFileAndOpen(j,N){const z=await this.b.pickFile(N);z&&await this.w(z.map(se=>({fileUri:p.URI.file(se)})),N,j)}async pickWorkspaceAndOpen(j,N){const z=await this.b.pickWorkspace(N);z&&await this.w(z.map(se=>({workspaceUri:p.URI.file(se)})),N,j)}async w(j,N,z){await this.a.open({context:3,contextWindowId:z,cli:this.f.args,urisToOpen:j,forceNewWindow:N.forceNewWindow})}async showItemInFolder(j,N){O.shell.showItemInFolder(N)}async setRepresentedFilename(j,N){this.C(j)?.setRepresentedFilename(N)}async setDocumentEdited(j,N){this.C(j)?.setDocumentEdited(N)}async openExternal(j,N){return this.f.unsetSnapExportedVariables(),O.shell.openExternal(N),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(j,N){return O.shell.trashItem(N)}async isAdmin(){let j;return $.$i?j=(await new Promise((N,z)=>{J(["native-is-elevated"],N,z)}))():j=process.getuid?.()===0,j}async writeElevated(j,N,z,se){const ee=await new Promise((ae,ne)=>{J(["@vscode/sudo-prompt"],ae,ne)});return new Promise((ae,ne)=>{const oe=[`"${this.z}"`];se?.unlock&&oe.push("--file-chmod"),oe.push("--file-write",`"${N.fsPath}"`,`"${z.fsPath}"`);const G={name:this.h.nameLong.replace("-",""),icns:$.$j&&this.f.isBuilt?(0,b.$8d)((0,b.$$d)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ee.exec(oe.join(" "),G,(K,B,F)=>{B&&this.g.trace(`[sudo-prompt] received stdout: ${B}`),F&&this.g.trace(`[sudo-prompt] received stderr: ${F}`),K?ne(K):ae(void 0)})})}async isRunningUnderARM64Translation(){return $.$k||$.$i?!1:O.app.runningUnderARM64Translation}get z(){return $.$i?this.f.isBuilt?(0,b.$8d)((0,b.$$d)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,b.$8d)(this.f.appRoot,"scripts","code-cli.bat"):$.$k?this.f.isBuilt?(0,b.$8d)((0,b.$$d)(process.execPath),"bin",`${this.h.applicationName}`):(0,b.$8d)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,b.$8d)(this.f.appRoot,"bin","code"):(0,b.$8d)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Gm.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return $.$i&&(0,I.$P5b)()}async killProcess(j,N,z){process.kill(N,z)}async readClipboardText(j,N){return O.clipboard.readText(N)}async writeClipboardText(j,N,z){return O.clipboard.writeText(N,z)}async readClipboardFindText(j){return O.clipboard.readFindText()}async writeClipboardFindText(j,N){return O.clipboard.writeFindText(N)}async writeClipboardBuffer(j,N,z,se){return O.clipboard.writeBuffer(N,Buffer.from(z.buffer),se)}async readClipboardBuffer(j,N){return k.$Ed.wrap(O.clipboard.readBuffer(N))}async hasClipboard(j,N,z){return O.clipboard.has(N,z)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){O.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){O.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){O.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){O.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){O.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(j,N){this.C(j)?.updateTouchBar(N)}async notifyReady(j){this.C(j)?.setReady()}async relaunch(j,N){return this.c.relaunch(N)}async reload(j,N){const z=this.C(j);if(z){if((0,n.$Ph)(z.openedWorkspace)){const se=z.openedWorkspace.configPath;if(se.scheme===l.Schemas.file&&(await this.m.resolveLocalWorkspace(se))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.c.reload(z,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(j){this.closeWindowById(j,j)}async closeWindowById(j,N){const z=this.C(N);if(z?.win)return z.win.close()}async quit(j){const N=this.a.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&N.win?N.win.close():this.c.quit()}async exit(j,N){await this.c.kill(N)}async resolveProxy(j,N){return this.C(j)?.win?.webContents?.session?.resolveProxy(N)}findFreePort(j,N,z,se,ee=1){return(0,g.$5f)(N,z,se,ee)}async openDevTools(j,N){const z=this.C(j);z?.win&&z.win.webContents.openDevTools(N)}async toggleDevTools(j){const N=this.C(j);N?.win&&N.win.webContents.toggleDevTools()}async sendInputEvent(j,N){const z=this.C(j);z?.win&&(N.type==="mouseDown"||N.type==="mouseUp")&&z.win.webContents.sendInputEvent(N)}async profileRenderer(j,N,z){const se=this.C(j);if(!se||!se.win)throw new Error;return await new D.$Q5b(se.win,N,this.g).inspect(z)}async windowsGetStringRegKey(j,N,z,se){if(!$.$i)return;const ee=await new Promise((ae,ne)=>{J(["@vscode/windows-registry"],ae,ne)});try{return ee.GetStringRegKey(N,z,se)}catch{return}}C(j){if(typeof j=="number")return this.a.getWindowById(j)}};e.$S5b=v,ke([A.$5g],v.prototype,"z",null),e.$S5b=v=ke([_(0,i.$f5b),_(1,a.$r5b),_(2,d.$64b),_(3,m.$44b),_(4,t.$4i),_(5,u.$jj),_(6,r.$N5b),_(7,o.$w5b)],v)}),define(te[298],ie([0,1,15,38,27,2,13,4,107,179,90,132,61,28,5,67,77,24,78,80,32,33,62,22,7,30,8]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d,t,u,r,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=void 0;const k="issue.processExplorerWindowState";let I=class{static{o=this}static{this.a="#1E1E1E"}constructor(R,j,N,z,se,ee,ae,ne,oe,G,K){this.g=R,this.h=j,this.i=N,this.j=z,this.k=se,this.l=ee,this.m=ae,this.n=ne,this.o=oe,this.p=G,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){O.$JS.on("vscode:listProcesses",async R=>{const j=[];try{j.push({name:(0,l.localize)(0,null),rootProcess:await(0,h.$qr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,b.$gm)(z)?j.push({name:z.hostName,rootProcess:z}):z.processes&&j.push({name:z.hostName,rootProcess:z.processes})})}catch(N){this.i.error(`Listing processes failed: ${N}`)}this.t(R,"vscode:listProcessesResponse",j)}),O.$JS.on("vscode:workbenchCommand",(R,j)=>{const{id:N,from:z,args:se}=j;let ee;switch(z){case"processExplorer":ee=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}ee?.webContents.send("vscode:runAction",{id:N,from:z,args:se})}),O.$JS.on("vscode:closeProcessExplorer",R=>{this.d?.close()}),O.$JS.on("vscode:pidToNameRequest",async R=>{const j=await this.k.getMainDiagnostics(),N=[];for(const z of j.windows)N.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:se}of t.$y5b.getAll())N.push([z,se]);this.t(R,"vscode:pidToNameResponse",N)})}async openReporter(R){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const j=new M.$ic,N=j.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,N,{backgroundColor:R.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:R.zoomLevel,alwaysOnTop:!1},"issue-reporter"),N.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:R,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:g.default}),this.b.loadURL(A.$1f.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(R){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const j=new M.$ic,N=j.add(this.n.createIPCObjectUrl()),z=this.p.getItem(k,void 0),se=D(z)?z:this.v(this.f,800,500);this.d=this.u(se,N,{backgroundColor:R.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:R.zoomLevel,alwaysOnTop:!0},"process-explorer"),N.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:R,product:g.default}),this.d.loadURL(A.$1f.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const ee=()=>{if(!this.d)return;const ae=this.d.getSize(),ne=this.d.getPosition();if(!ae||!ne)return;const oe={width:ae[0],height:ae[1],x:ne[0],y:ne[1]};this.p.setItem(k,oe)};this.d.on("moved",ee),this.d.on("resized",ee)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const R=await P.contentTracing.stopRecording(`${(0,E.$Pf)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,R),buttons:[(0,l.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,R)}async getSystemStatus(){const[R,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(R,j)}async $getSystemInfo(){const[R,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(R,j)}async $getPerformanceInfo(){try{const[R,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(R,j)}catch(R){throw this.i.warn("issueService#getPerformanceInfo ",R.message),R}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(R){this.i.error(R)}}async $showConfirmCloseDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);R===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:R}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return R===0}return!1}async $getIssueReporterUri(R){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");const N=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return n.Promises.withAsyncBody(async(z,se)=>{const ee=new u.$od;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",ee.token,{replyChannel:N,extensionId:R}),O.$JS.once(N,(ae,ne)=>{z(r.URI.parse(ne))});try{await(0,n.$Gg)(5e3),ee.cancel(),se(new Error("Timed out waiting for issue reporter URI"))}finally{O.$JS.removeHandler(N)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(R){R.isMinimized()&&R.restore(),R.focus()}t(R,j,...N){R.sender.isDestroyed()||R.sender.send(j,...N)}u(R,j,N,z){const se=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:R.width,height:R.height,minWidth:300,minHeight:200,x:R.x,y:R.y,title:N.title,backgroundColor:N.backgroundColor||o.a,webPreferences:{preload:A.$1f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,m.$TD)(N.zoomLevel),sandbox:!0},alwaysOnTop:N.alwaysOnTop,experimentalDarkMode:!0});return se.setMenuBarVisibility(!1),se}v(R,j,N){let z;const se=P.screen.getAllDisplays();if(se.length===1)z=se[0];else{if(S.$j){const ne=P.screen.getCursorScreenPoint();z=P.screen.getDisplayNearestPoint(ne)}!z&&R&&(z=P.screen.getDisplayMatching(R.getBounds())),z||(z=P.screen.getPrimaryDisplay()||se[0])}const ee=z.bounds,ae={width:j,height:N,x:ee.x+ee.width/2-j/2,y:ee.y+ee.height/2-N/2};return ee.width>0&&ee.height>0&&(ae.x<ee.x&&(ae.x=ee.x),ae.y<ee.y&&(ae.y=ee.y),ae.x>ee.x+ee.width&&(ae.x=ee.x),ae.y>ee.y+ee.height&&(ae.y=ee.y),ae.width>ee.width&&(ae.width=ee.width),ae.height>ee.height&&(ae.height=ee.height)),ae}};e.$U5b=I,e.$U5b=I=o=ke([_(1,f.$44b),_(2,y.$4i),_(3,b.$fm),_(4,$.$B5b),_(5,p.$r5b),_(6,w.$R5b),_(7,a.$T5b),_(8,c.$jj),_(9,d.$$M),_(10,i.$f5b)],I);function D(v){return typeof v!="object"||v===null?!1:"x"in v&&"y"in v&&"width"in v&&"height"in v}}),define(te[299],ie([0,1,22,18,28,20,5,67,24,51,25,48,100]),function(J,e,P,O,s,M,A,S,h,l,b,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0;let f=class extends p.$j6b{constructor(w,g,c,a,m,E,d,t){super(w,g,a,m,E,t),this.e=c,this.u=d}s(w){return(0,p.$i6b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d($.$IT.CheckingForUpdates(w)),this.i.request({url:this.a},P.CancellationToken.None).then(l.$Mo).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d($.$IT.Idle(1))):this.d($.$IT.AvailableForDownload(g))}).then(void 0,g=>{this.j.error(g),this.e.publicLog2("update:notAvailable",{explicit:!!w});const c=w?g.message||g:void 0;this.d($.$IT.Idle(1,c))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d($.$IT.Idle(1))}};e.$l6b=f,e.$l6b=f=ke([_(0,M.$64b),_(1,O.$7h),_(2,b.$8k),_(3,s.$44b),_(4,l.$Ho),_(5,A.$4i),_(6,S.$R5b),_(7,h.$jj)],f)}),define(te[300],ie([0,1,47,45,27,8,22,55,9,7,143,21,18,28,16,20,5,67,24,51,25,48,100]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=void 0;async function u(o,k=1e3){for(;!o();)await(0,M.$Gg)(k)}let r;function i(){return typeof r>"u"&&(r=O.existsSync(h.$8d(h.$$d(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$j6b{get cachePath(){const k=h.$8d((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return $.Promises.mkdir(k,{recursive:!0}).then(()=>k)}constructor(k,I,D,v,R,j,N,z,se){super(k,I,v,R,j,se),this.u=D,this.v=N,this.w=z,k.setRelaunchHandler(this)}handleRelaunch(k){return k?.addArgs||k?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(d.$IT.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(k){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,t.$i6b)(I,k,this.k)}t(k){this.a&&(this.d(d.$IT.CheckingForUpdates(k)),this.i.request({url:this.a},A.CancellationToken.None).then(m.$Mo).then(I=>{const D=i();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!k}),this.d(d.$IT.Idle(D)),Promise.resolve(null)):D===1?(this.d(d.$IT.AvailableForDownload(I)),Promise.resolve(null)):(this.d(d.$IT.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(v=>$.Promises.exists(v).then(R=>{if(R)return Promise.resolve(v);const j=I.url,N=I.hash,z=`${v}.tmp`;return this.i.request({url:j},A.CancellationToken.None).then(se=>this.v.writeFile(l.URI.file(z),se.stream)).then(N?()=>(0,b.$ES)(z,I.hash):()=>{}).then(()=>$.Promises.rename(z,v,!1)).then(()=>v)})).then(v=>{const R=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:v},R?this.k.target==="user"?this.p():this.d(d.$IT.Downloaded(I)):this.d(d.$IT.Ready(I))})))}).then(void 0,I=>{this.j.error(I),this.u.publicLog2("update:notAvailable",{explicit:!!k});const D=k?I.message||I:void 0;this.d(d.$IT.Idle(i(),D))}))}async o(k){k.update.url&&this.w.openExternal(void 0,k.update.url),this.d(d.$IT.Idle(i()))}async B(k){const I=await this.cachePath;return h.$8d(I,`CodeSetup-${this.k.quality}-${k}.exe`)}async C(k=null){const I=k?j=>!new RegExp(`${this.k.quality}-${k}\\.exe$`).test(j):()=>!0,D=await this.cachePath,R=(await $.Promises.readdir(D)).filter(I).map(async j=>{try{await $.Promises.unlink(h.$8d(D,j))}catch{}});await Promise.all(R)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const k=this.state.update;this.d(d.$IT.Updating(k));const I=await this.cachePath;this.e.updateFilePath=h.$8d(I,`CodeSetup-${this.k.quality}-${k.version}.flag`),await $.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(d.$IT.Idle(i()))});const v=`${this.k.win32MutexName}-ready`,R=await new Promise((j,N)=>{J(["@vscode/windows-mutex"],j,N)});u(()=>R.isActive(v)).then(()=>this.d(d.$IT.Ready(k)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?O.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(k){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.d(d.$IT.Downloading(D)),this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(d.$IT.Downloaded(D)):this.d(d.$IT.Ready(D))}};e.$n6b=n,ke([S.$5g],n.prototype,"cachePath",null),e.$n6b=n=ke([_(0,w.$64b),_(1,p.$7h),_(2,E.$8k),_(3,f.$44b),_(4,m.$Ho),_(5,g.$4i),_(6,y.$5j),_(7,c.$R5b),_(8,a.$jj)],n)}),define(te[301],ie([0,1,15,8,22,50,3,2,13,9,65,4,7,189,64,18,61,28,63,16,20,5,24,78,251,82,25,102,79,80,30,29,54,128,135,39,33,53,66,23]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d,t,u,r,i,n,o,k,I,D,v,R,j,N,z,se,ee,ae,ne){"use strict";var oe;Object.defineProperty(e,"__esModule",{value:!0}),e.$v6b=void 0;var G;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(G||(G={}));let K=class extends S.$jc{static{oe=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const F=this.R.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.R.getProfileForWorkspace(this.config.workspace??(0,v.$Oh)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(F,T,H,Q,x,ce,Y,C,L,U,W,q,V,re,$e,de,ue,be,me,Se){super(),this.N=T,this.O=H,this.P=Q,this.Q=x,this.R=ce,this.S=Y,this.U=C,this.W=L,this.X=U,this.Y=W,this.Z=q,this.$=V,this.ab=re,this.bb=$e,this.db=de,this.eb=ue,this.fb=be,this.gb=me,this.hb=Se,this.b=this.B(new A.$ed),this.onWillLoad=this.b.event,this.c=this.B(new A.$ed),this.onDidSignalReady=this.c.event,this.f=this.B(new A.$ed),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new A.$ed),this.onDidClose=this.g.event,this.h=this.B(new A.$ed),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.ib=0;{const[Ae,Le]=this.sb(F.state);this.s=Ae,this.N.trace("window#ctor: using window state",Ae);const ve=this.s.mode===0||this.s.mode===3,we=this.X.getValue("window"),X={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.Y.getBackgroundColor(),minWidth:I.$MD.WIDTH,minHeight:I.$MD.HEIGHT,show:!ve,title:this.eb.nameLong,webPreferences:{preload:h.$1f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.$TD)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};$.$k?X.icon=(0,l.$8d)(this.P.appRoot,"resources/linux/code.png"):$.$i&&!this.P.isBuilt&&(X.icon=(0,l.$8d)(this.P.appRoot,"resources/win32/code_150x150.png")),$.$j&&!this.zb()&&(X.fullscreenable=!1),$.$j&&(X.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(X.acceptFirstMouse=!1));const le=$.$j&&we?.nativeTabs===!0;le&&(X.tabbingIdentifier=this.eb.nameShort);const fe=(0,I.$RD)(this.X)==="custom";if(fe&&(X.titleBarStyle="hidden",$.$j||(X.frame=!1),(0,I.$SD)(this.X))){const Ee=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Ce=N.$Ms.fromHex(Ee).isDarker()?"#FFFFFF":"#000000";X.titleBarOverlay={height:29,color:Ee,symbolColor:Ce},this.D=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(X),(0,b.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,$.$j&&fe&&this.m.setSheetOffset(22),fe&&($.$i&&(0,I.$SD)(this.X)||$.$j)){const Ee=this.hb.getItem(oe.a);Ee&&this.updateWindowControls({height:Ee})}$.$i&&fe&&this.m.hookWindowMessage(278,()=>{const[Ce,Ue]=this.m.getPosition(),Oe=P.screen.getCursorScreenPoint(),ze=Oe.x-Ce,We=Oe.y-Ue;return(()=>!(ze>30&&We>=0&&We<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:ze,y:We})),0}),($.$j||$.$i)&&Le&&(!le||P.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Ee=>typeof Ee=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),ve&&((0,b.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3&&this.vb(!0),this.m.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.pb(),this.Db(),this.jb()}setRepresentedFilename(F){$.$j?this.m.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return $.$j?this.m.getRepresentedFilename():this.z}setDocumentEdited(F){$.$j&&this.m.setDocumentEdited(F),this.C=F}isDocumentEdited(){return $.$j?this.m.isDocumentEdited():!!this.C}focus(F){$.$j&&F?.force&&P.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.ib=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.F.push(F)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(F=>{function T(){H.dispose(),Q.dispose(),F()}const H=this.onDidClose(()=>T()),Q=this.onWillLoad(()=>T())})}jb(){this.m.on("unresponsive",()=>this.mb(1)),this.m.webContents.on("render-process-gone",(T,H)=>this.mb(2,{...H})),this.m.webContents.on("did-fail-load",(T,H,Q)=>this.mb(3,{reason:Q,exitCode:H})),this.m.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",T=>{this.r&&(this.r.maximized=!0),P.app.emit("browser-window-maximize",T,this.m)}),this.m.on("unmaximize",T=>{this.r&&(this.r.maximized=!1),P.app.emit("browser-window-unmaximize",T,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(T=>this.pb(T))),this.B(this.Z.onDidDeleteUntitledWorkspace(T=>this.ob(T)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(T,H)=>{const Q=await this.lb();H({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,Q)})})}lb(){return this.kb||(this.kb=(0,r.$1o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.kb}async mb(F,T){switch(F){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:F,reason:T?.reason,code:T?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.db.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:Q}=await this.bb.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this.r?.workspace?(0,f.localize)(5,null):void 0},this.m);if(H!==2){const x=H===0;await this.nb(x,Q)}}else if(F===2){let H;T?H=(0,f.localize)(7,null,T.reason,T.exitCode??"<unknown>"):H=(0,f.localize)(6,null);const{response:Q,checkboxChecked:x}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:H,detail:this.r?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this.r?.workspace?(0,f.localize)(13,null):void 0},this.m),ce=Q===0;await this.nb(ce,x)}break}}async nb(F,T){const H=this.r?.workspace;if(T&&H)try{const Q=this.W.workspaceStorage(H);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.N.error(Q)}if(this.h.fire(),this.m?.destroy(),F&&this.r){let Q,x;(0,v.$Kh)(H)?Q={folderUri:H.uri}:(0,v.$Ph)(H)?Q={workspaceUri:H.configPath}:x=!0,(0,ne.$Lb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:x,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}ob(F){this.r?.workspace?.id===F.id&&(this.r.workspace=void 0)}pb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const T=this.Ab();T!==this.t&&(this.t=T,this.Bb(T))}if(!F||F.affectsConfiguration("http.proxy")){let T=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.H||H!==this.I)){this.H=T,this.I=H;const Q=T||"",x=H?`${H},<local>`:"<local>";this.N.trace(`Setting proxy to '${Q}', bypassing '${x}'`),this.m.webContents.session.setProxy({proxyRules:Q,proxyBypassRules:x,pacScript:""})}}}addTabbedWindow(F){$.$j&&F.win&&this.m.addTabbedWindow(F.win)}load(F,T=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!T.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.qb(F,T),this.ib===0?this.r=F:this.L=F,this.ib=1,this.m.loadURL(h.$1f.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new O.$Rg(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:F.workspace,reason:T.isReload?3:H?2:1})}qb(F,T){const H=(this.r??this.L)?.userEnv;if(H){const Q=(0,a.$Fl)(H)&&!(0,a.$Fl)(F.userEnv),x=this.isExtensionDevelopmentHost;(Q||x)&&(F.userEnv={...H,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(F["disable-extensions"]=T.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.Y.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),F.perfMarks=(0,b.getMarks)(),this.J.update(F)}async reload(F){const T=Object.assign({},this.r);T.workspace=await this.rb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&F&&(T.verbose=F.verbose,T.debugId=F.debugId,T.extensionEnvironment=F.extensionEnvironment,T["inspect-extensions"]=F["inspect-extensions"],T["inspect-brk-extensions"]=F["inspect-brk-extensions"],T["extensions-dir"]=F["extensions-dir"]),T.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.Q.serialize(),T.continueOn=this.P.continueOn,T.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},T.logLevel=this.O.getLogLevel(),T.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async rb(F){if((0,v.$Ph)(F.workspace)){const T=F.workspace.configPath;if(T.scheme===h.Schemas.file&&!await this.S.exists(T))return}else if((0,v.$Kh)(F.workspace)){const T=F.workspace.uri;if(T.scheme===h.Schemas.file&&!await this.S.exists(T))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,j.$34b)();if(this.isFullScreen){let H;try{H=P.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,j.$34b)();return{mode:3,display:H?H.id:void 0,width:this.s.width||Q.width,height:this.s.height||Q.height,x:this.s.x||0,y:this.s.y||0}}const F=Object.create(null);let T;if(!$.$j&&this.m.isMaximized()?T=0:T=1,T===0?F.mode=0:F.mode=1,T===1||T===0){let H;T===1?H=this.getBounds():H=this.m.getNormalBounds(),F.x=H.x,F.y=H.y,F.width=H.width,F.height=H.height}return F}updateWindowControls(F){if(F.height&&this.hb.setItem(oe.a,F.height),$.$i&&this.D)this.m.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if($.$j&&F.height!==void 0){const T=(F.height-15)/2;T?this.m.setWindowButtonPosition({x:T,y:T}):this.m.setWindowButtonPosition(null)}}sb(F){(0,b.mark)("code/willRestoreCodeWindowState");let T=!1;if(F)try{const H=P.screen.getAllDisplays();T=H.length>1,F=this.tb(F,H)}catch(H){this.N.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[F||(0,j.$34b)(),T]}tb(F,T){if(this.N.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const x=this.ub(T[0]);if(x){let ce=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!x||(F.x<x.x&&(F.x=x.x),F.y<x.y&&(F.y=x.y))};this.N.trace("window#validateWindowState: 1 monitor working area",x),ce(),F.width>x.width&&(F.width=x.width),F.height>x.height&&(F.height=x.height),F.x>x.x+x.width-128&&(F.x=x.x+x.width-F.width),F.y>x.y+x.height-128&&(F.y=x.y+x.height-F.height),ce()}return F}if(F.display&&F.mode===3){const x=T.find(ce=>ce.id===F.display);if(x&&typeof x.bounds?.x=="number"&&typeof x.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,j.$34b)(3);return ce.x=x.bounds.x,ce.y=x.bounds.y,ce}}let H,Q;try{H=P.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),Q=this.ub(H)}catch{}if(H&&Q&&F.x+F.width>Q.x&&F.y+F.height>Q.y&&F.x<Q.x+Q.width&&F.y<Q.y+Q.height)return this.N.trace("window#validateWindowState: multi-monitor working area",Q),F}ub(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,T]=this.m.getPosition(),[H,Q]=this.m.getSize();return{x:F,y:T,width:H,height:Q}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(F){this.zb()?this.wb(F):this.yb(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Bb(this.t,!1)}get isFullScreen(){return $.$j&&typeof this.u=="boolean"?this.u:this.m.isFullScreen()||this.m.isSimpleFullScreen()}wb(F){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.xb(F)}xb(F){$.$j&&(this.u=F,this.w=new O.$1g,Promise.race([this.w.p,(0,O.$Gg)(1e3)]).finally(()=>this.u=void 0)),this.m.setFullScreen(F)}yb(F){this.m.isFullScreen()&&this.xb(!1),this.m.setSimpleFullScreen(F),this.m.webContents.focus()}zb(){const F=this.X.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Ab(){let F=(0,I.$QD)(this.X);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Bb(F,T=!0){$.$j||(F==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,f.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.Cb(F)}):this.Cb(F))}Cb(F){const T=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!T),this.m.autoHideMenuBar=T;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if($.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(F,T,...H){this.isReady?this.send(F,...H):this.ready().then(()=>{T.isCancellationRequested||this.send(F,...H)})}send(F,...T){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...T)}catch(H){this.N.warn(`Error sending IPC message to channel '${F}' of window ${this.j}: ${(0,M.$li)(H)}`)}}}updateTouchBar(F){$.$j&&this.G.forEach((T,H)=>{const Q=F[H];T.segments=this.Fb(Q)})}Db(){if($.$j){for(let F=0;F<10;F++){const T=this.Eb();this.G.push(T)}this.m.setTouchBar(new P.TouchBar({items:this.G}))}}Eb(F=[]){const T=this.Fb(F),H=new P.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[Q].id,from:"touchbar"})}});return H}Fb(F=[]){return F.map(H=>{let Q;H.icon&&!o.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===h.Schemas.file&&(Q=P.nativeImage.createFromPath(p.URI.revive(H.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let x;return typeof H.title=="string"?x=H.title:x=H.title.value,{id:H.id,label:Q?void 0:x,icon:Q}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$v6b=K,e.$v6b=K=oe=ke([_(1,d.$4i),_(2,ae.$05b),_(3,c.$44b),_(4,z.$9m),_(5,ee.$_4b),_(6,m.$5j),_(7,i.$d5b),_(8,i.$b5b),_(9,w.$7h),_(10,k.$N5b),_(11,R.$w5b),_(12,y.$k5b),_(13,n.$8k),_(14,g.$r5b),_(15,E.$64b),_(16,t.$jj),_(17,u.$T5b),_(18,D.$f5b),_(19,se.$$M)],K)}),define(te[83],ie([0,1,15,23,8,3,46,2,13,4,19,7,21,192,6,20,5,82,97,29,54,34]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=e.$55b=void 0,e.$55b=(0,y.$Ah)("workspacesHistoryMainService");let u=class extends S.$jc{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,o,k){super(),this.f=i,this.g=n,this.h=o,this.j=k,this.c=this.B(new M.$ed),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Dg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const I of i)if((0,a.$8T)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.u(n,I.workspace)&&n.push(I);else if((0,a.$9T)(I))this.w(n,I.folderUri)||n.push(I);else{const D=this.y(o,I.fileUri),v=I.fileUri.scheme===h.Schemas.file&&t.F.indexOf((0,b.$eg)(I.fileUri))>=0;!D&&!v&&(o.push(I),l.$i&&I.fileUri.scheme===h.Schemas.file&&P.app.addRecentDocument(I.fileUri.fsPath))}const k=await this.n({workspaces:n,files:o});n=k.workspaces,o=k.files,n.length>t.a&&(n.length=t.a),o.length>t.a&&(o.length=t.a),await this.s({workspaces:n,files:o}),this.c.fire(),l.$j&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(i){const n=D=>{const v=this.t(D);for(const R of i)if(b.$$f.isEqual(R,v))return!1;return!0},o=await this.getRecentlyOpened(),k=o.workspaces.filter(n),I=o.files.filter(n);(k.length!==o.workspaces.length||I.length!==o.files.length)&&(await this.s({files:I,workspaces:k}),this.c.fire(),l.$j&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(i){const n=new d.$yi(I=>b.$$f.getComparisonKey(I));if(i?.workspaces)for(const I of i.workspaces)n.set(this.t(I),I);const o=new d.$yi(I=>b.$$f.getComparisonKey(I));if(i?.files)for(const I of i.files)o.set(this.t(I),I);const k=await this.r();for(const I of k.workspaces){const D=n.get(this.t(I));D?D.label=D.label??I.label:n.set(this.t(I),I)}for(const I of k.files){const D=o.get(this.t(I));D?D.label=D.label??I.label:o.set(this.t(I),I)}return{workspaces:[...n.values()],files:[...o.values()]}}async r(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,a.$cU)(i,this.f)}async s(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,a.$dU)(i)),-1,1)}t(i){return(0,a.$9T)(i)?i.folderUri:(0,a.$0T)(i)?i.fileUri:i.workspace.configPath}u(i,n){return!!i.find(o=>(0,a.$8T)(o)&&o.workspace.id===n.id)}w(i,n){return!!i.find(o=>(0,a.$9T)(o)&&b.$$f.isEqual(o.folderUri,n))}y(i,n){return!!i.find(o=>b.$$f.isEqual(o.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){l.$i&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!l.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const I of P.app.getJumpListSettings().removedItems){const D=I.args;if(D){const v=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);v&&n.push($.URI.parse(v[2]))}}await this.removeRecentlyOpened(n);let o=!1;const k=(0,O.$Eb)((await this.getRecentlyOpened()).workspaces.slice(0,t.D).map(I=>{const D=(0,a.$8T)(I)?I.workspace:I.folderUri,{title:v,description:R}=this.J(D,I.label);let j;return $.URI.isUri(D)?j=`--folder-uri "${D.toString()}"`:(o=!0,j=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:v.substr(0,255),description:R.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));k.length>0&&i.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:k})}i.push({type:"recent"});try{const n=P.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(i,n){if(n)return{title:(0,A.$kA)(n).name,description:n};if($.URI.isUri(i))return{title:(0,b.$eg)(i),description:this.L(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let o=(0,b.$eg)(i.configPath);return o.endsWith(m.$Wh)&&(o=o.substr(0,o.length-m.$Wh.length-1)),{title:(0,f.localize)(5,null,o),description:this.L(i.configPath)}}L(i){return i.scheme==="file"?(0,A.$cA)(i.fsPath):i.toString()}async M(){if(!l.$j)return;P.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let I=0;I<i.workspaces.length&&o<t.z;I++){const D=this.t(i.workspaces[I]);if(D.scheme===h.Schemas.file){const v=(0,b.$8f)(D);await p.Promises.exists(v)&&(n.push(v),o++)}}const k=[];for(let I=0;I<i.files.length&&o<t.C;I++){const D=this.t(i.files[I]);if(D.scheme===h.Schemas.file){const v=(0,b.$8f)(D);if(t.F.includes((0,b.$eg)(D))||n.includes(v))continue;await p.Promises.exists(v)&&(k.push(v),o++)}}k.reverse().forEach(I=>P.app.addRecentDocument(I)),n.reverse().forEach(I=>P.app.addRecentDocument(I))}};e.$65b=u,e.$65b=u=t=ke([_(0,g.$4i),_(1,E.$w5b),_(2,w.$64b),_(3,c.$d5b)],u)}),define(te[302],ie([0,1,15,8,22,46,4,7,180,18,28,20,5,229,67,24,33,25,48,80,30,83]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=void 0;const u="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(o,k,I,D,v,R,j,N,z,se,ee){this.n=o,this.o=k,this.p=I,this.q=D,this.r=v,this.s=R,this.t=j,this.u=N,this.v=z,this.w=se,this.x=ee,this.m=Object.create(null),this.g=new O.$Rg(()=>this.E(),0),this.h=new O.$Rg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.$j||(0,m.$RD)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(t.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(R,j,N)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.newWindow"]=(R,j,N)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.files.openFileFolder"]=(R,j,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:u}}),this.m["workbench.action.files.openFolder"]=(R,j,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:u}}),this.m["workbench.action.openWorkspace"]=(R,j,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:u}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.youTubeUrl;o&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(o,"openYouTubeUrl"));const k=this.x.requestFeatureUrl;k&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(k,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(I,"openReportIssues"));const D=this.x.licenseUrl;D&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.$v){const R=D.indexOf("?")>0?"&":"?";this.Z(`${D}${R}lang=${A.$v}`,"openLicenseUrl")}else this.Z(D,"openLicenseUrl")});const v=this.x.privacyStatementUrl;v&&D&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(v,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!A.$j)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,k){this.k=o.menus,this.l=o.keybindings,this.t.setItem(t.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){A.$j&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){A.$j&&(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=P.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(A.$j?new P.Menu:null);return}const k=new P.Menu;let I;if(A.$j){const v=new P.Menu;I=new P.MenuItem({label:this.x.nameShort,submenu:v}),this.I(v),k.append(I)}if(A.$j&&!this.c){this.c=!0;const v=new P.Menu;v.append(new P.MenuItem({label:this.ab(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(v)}if(this.K("File")){const v=new P.Menu,R=new P.MenuItem({label:this.ab(h.localize(1,null)),submenu:v});this.M(v,"File"),k.append(R)}if(this.K("Edit")){const v=new P.Menu,R=new P.MenuItem({label:this.ab(h.localize(2,null)),submenu:v});this.M(v,"Edit"),k.append(R)}if(this.K("Selection")){const v=new P.Menu,R=new P.MenuItem({label:this.ab(h.localize(3,null)),submenu:v});this.M(v,"Selection"),k.append(R)}if(this.K("View")){const v=new P.Menu,R=new P.MenuItem({label:this.ab(h.localize(4,null)),submenu:v});this.M(v,"View"),k.append(R)}if(this.K("Go")){const v=new P.Menu,R=new P.MenuItem({label:this.ab(h.localize(5,null)),submenu:v});this.M(v,"Go"),k.append(R)}if(this.K("Run")){const v=new P.Menu,R=new P.MenuItem({label:this.ab(h.localize(6,null)),submenu:v});this.M(v,"Run"),k.append(R)}if(this.K("Terminal")){const v=new P.Menu,R=new P.MenuItem({label:this.ab(h.localize(7,null)),submenu:v});this.M(v,"Terminal"),k.append(R)}let D;if(this.K("Window")){const v=new P.Menu;D=new P.MenuItem({label:this.ab(h.localize(8,null)),submenu:v,role:"window"}),this.S(v)}if(D&&k.append(D),this.K("Help")){const v=new P.Menu,R=new P.MenuItem({label:this.ab(h.localize(9,null)),submenu:v,role:"help"});this.M(v,"Help"),k.append(R)}k.items&&k.items.length>0?P.Menu.setApplicationMenu(k):P.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const k=this.U(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.T();let D;if(this.K("Preferences")){const ae=new P.Menu;this.M(ae,"Preferences"),D=new P.MenuItem({label:this.ab(h.localize(11,null)),submenu:ae})}const v=new P.Menu,R=new P.MenuItem({label:h.localize(12,null),role:"services",submenu:v}),j=new P.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new P.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new P.MenuItem({label:h.localize(15,null),role:"unhide"}),se=new P.MenuItem(this.Y("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ae,ne,oe)=>{const G=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.J(oe)&&this.w.quit(void 0)}})),ee=[k];ee.push(...I),D&&ee.push(i(),D),ee.push(i(),R,i(),j,N,z,i(),se),ee.forEach(ae=>o.append(ae))}async J(o){if(this.p.getWindowCount()===0)return!0;const k=this.o.getValue("window.confirmBeforeClose");if(k==="always"||k==="keyboardOnly"&&this.Q(o)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return I===0}return!0}K(o){if(!A.$j&&(0,m.$RD)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,k){k.forEach(I=>{if((0,f.$25b)(I))o.append(i());else if((0,f.$15b)(I)){const D=new P.Menu,v=new P.MenuItem({label:this.ab(I.label),submenu:D});this.L(D,I.submenu.items),o.append(v)}else(0,f.$35b)(I)?o.append(this.O(I)):(0,f.$45b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.N(o),A.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?o.append(new P.MenuItem(this.Y(I.id,{label:this.ab(I.label),click:this.m[I.id]}))):o.append(this.U(I.label,I.id,!1,I.checked)):o.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)):o.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)))})}M(o,k){this.k&&this.k[k]&&this.L(o,this.k[k].items)}N(o){const k=this.T();k.length&&(k.forEach(I=>o.append(I)),o.append(i()))}O(o){const k=S.URI.revive(o.uri),I=o.id,D=I==="openRecentFile"?{fileUri:k}:I==="openRecentWorkspace"?{workspaceUri:k}:{folderUri:k};return new P.MenuItem(this.Y(I,{label:o.label,click:async(v,R,j)=>{const N=this.P(j);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[D],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([k])}},!1))}P(o){return!!(o&&(!A.$j&&(o.ctrlKey||o.shiftKey)||A.$j&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,k,I){const D={label:this.ab(o),role:I,enabled:!0};return new P.MenuItem(this.X(k,D))}S(o){const k=new P.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new P.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),D=new P.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),v=this.U(h.localize(23,null),"workbench.action.switchWindow"),R=[];this.C&&(R.push(i()),R.push(this.U(h.localize(24,null),"workbench.action.newWindowTab")),R.push(this.R(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.R(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.R(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.R(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[k,I,i(),v,...R,i(),D].forEach(j=>o.append(j))}T(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.ab(h.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.ab(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.ab(h.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.ab(h.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(o,k,I,D){const v=this.ab(o),R=typeof k=="function"?k:(ee,ae,ne)=>{const oe=ee?ee.userSettingsLabel:null;let G=k;Array.isArray(k)&&(G=this.P(ne)?k[1]:k[0]),oe&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:oe}):this.W({type:"commandId",commandId:G})},j=typeof I=="boolean"?I:this.p.getWindowCount()>0,N=typeof D=="boolean"?D:!1,z={label:v,click:R,enabled:j};N&&(z.type="checkbox",z.checked=N);let se;return typeof k=="string"?se=k:Array.isArray(k)&&(se=k[0]),A.$j&&(se==="editor.action.clipboardCutAction"?z.role="cut":se==="editor.action.clipboardCopyAction"?z.role="copy":se==="editor.action.clipboardPasteAction"&&(z.role="paste"),se==="undo"?z.click=this.V(R,{inDevTools:ee=>ee.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?z.click=this.V(R,{inDevTools:ee=>ee.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(z.click=this.V(R,{inDevTools:ee=>ee.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(se,z))}V(o,k){return(I,D,v)=>{const R=P.BrowserWindow.getFocusedWindow();if(!R)return k.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return k.inDevTools(R.webContents.devToolsWebContents);o(I,D||R,v)}}W(o){let k=P.BrowserWindow.getFocusedWindow();if(!k){const D=this.p.getLastActiveWindow();D?.isMinimized()&&(k=D.win)}const I=k?this.p.getWindowById(k.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",o),A.$j&&!this.q.isBuilt&&!I.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const D={id:o.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,D)}else{const D={userSettingsLabel:o.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,D)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,k){const I=typeof o=="string"?this.l[o]:void 0;if(I?.label){if(I.isNative!==!1)k.accelerator=I.label,k.userSettingsLabel=I.userSettingsLabel;else if(typeof k.label=="string"){const D=k.label.indexOf("[");D>=0?k.label=`${k.label.substr(0,D)} [${I.label}]`:k.label=`${k.label} [${I.label}]`}}else k.accelerator=void 0;return k}Y(o,k,I=!k.accelerator){I&&(k=this.X(o,k));const D=k.click;return k.click=(v,R,j)=>{this.$(o),D?.(v,R,j)},k}Z(o,k){this.w.openExternal(void 0,o),this.$(k)}$(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:u})}ab(o){return(0,M.$hA)(o,!this.B)}};e.$75b=r,e.$75b=r=t=ke([_(0,a.$JT),_(1,l.$7h),_(2,E.$f5b),_(3,b.$44b),_(4,c.$8k),_(5,d.$55b),_(6,g.$$M),_(7,$.$64b),_(8,p.$4i),_(9,y.$R5b),_(10,w.$jj)],r);function i(){return new P.MenuItem({type:"separator"})}}),define(te[303],ie([0,1,6,20,5,302]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=e.$85b=void 0,e.$85b=(0,P.$Ah)("menubarMainService");let A=class{constructor(h,l,b){this.b=h,this.c=l,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$75b)}async updateMenubar(h,l){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(l,h)}};e.$95b=A,e.$95b=A=ke([_(0,P.$zh),_(1,O.$64b),_(2,s.$4i)],A)}),define(te[304],ie([0,1,15,21,131,27,23,22,3,32,49,46,2,13,9,65,4,35,19,12,7,190,64,18,61,28,16,6,20,5,77,78,60,33,80,301,130,297,29,98,83,54,79,39,53,66]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d,t,u,r,i,n,o,k,I,D,v,R,j,N,z,se,ee,ae,ne,oe,G,K,B,F,T){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=void 0;function Q(Y){return(0,ae.$Ph)(Y?.workspace)}function x(Y){return(0,ae.$Kh)(Y?.workspace)}let ce=class extends p.$jc{static{H=this}static{this.a=[]}constructor(C,L,U,W,q,V,re,$e,de,ue,be,me,Se,Ae,Le,ve,we,X){super(),this.m=C,this.n=L,this.r=U,this.s=W,this.t=q,this.u=V,this.w=re,this.z=$e,this.C=de,this.D=ue,this.F=be,this.G=me,this.H=Se,this.I=Ae,this.J=Le,this.L=ve,this.M=we,this.N=X,this.b=this.B(new h.$ed),this.onDidOpenWindow=this.b.event,this.c=this.B(new h.$ed),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new h.$ed),this.onDidDestroyWindow=this.f.event,this.g=this.B(new h.$ed),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new h.$ed),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ee.$w6b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(C=>this.c.fire(C.window))),this.B(this.onDidSignalReadyWindow(C=>{if(C.config?.extensionDevelopmentPath||C.config?.extensionTestsPath){const L=new p.$ic;if(L.add(h.Event.any(C.onDidClose,C.onDidDestroy)(()=>L.dispose())),C.config.extensionDevelopmentPath)for(const U of C.config.extensionDevelopmentPath)L.add(this.M.addValidFileRoot(U));C.config.extensionTestsPath&&L.add(this.M.addValidFileRoot(C.config.extensionTestsPath))}}))}openEmptyWindow(C,L){const U=this.w.args,W=L?.remoteAuthority||void 0,q=!0,V=L?.forceReuseWindow,re=!V;return this.open({...C,cli:U,forceEmpty:q,forceNewWindow:re,forceReuseWindow:V,remoteAuthority:W})}openExistingWindow(C,L){C.focus(),this.P(L,[C])}async open(C){this.r.trace("windowsManager#open"),C.addMode&&(C.initialStartup||!this.getLastActiveWindow())&&(C.addMode=!1);const L=[],U=[],W=[],q=[],V=[];let re,$e=0;const de=await this.X(C);this.r.trace("windowsManager#open pathsToOpen",de);for(const Ae of de)x(Ae)?C.addMode?L.push(Ae):U.push(Ae):Q(Ae)?W.push(Ae):Ae.fileUri?(re||(re={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ae.remoteAuthority}),re.filesToOpenOrCreate.push(Ae)):Ae.backupPath?V.push({backupFolder:(0,y.$_d)(Ae.backupPath),remoteAuthority:Ae.remoteAuthority}):$e++;C.diffMode&&re&&re.filesToOpenOrCreate.length>=2&&(re.filesToDiff=re.filesToOpenOrCreate.slice(0,2),re.filesToOpenOrCreate=[]),C.mergeMode&&re&&re.filesToOpenOrCreate.length===4&&(re.filesToMerge=re.filesToOpenOrCreate.slice(0,4),re.filesToOpenOrCreate=[],re.filesToDiff=[]),re&&C.waitMarkerFileURI&&(re.filesToWait={paths:(0,A.$Eb)([...re.filesToDiff,re.filesToMerge[3],...re.filesToOpenOrCreate]),waitMarkerFileUri:C.waitMarkerFileURI}),C.initialStartup?(q.push(...this.H.getUntitledWorkspaces()),W.push(...q),V.push(...this.D.getEmptyWindowBackups())):V.length=0;const{windows:ue,filesOpenedInWindow:be}=await this.Q(C,W,U,V,$e,re,L);if(this.r.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${W.length}, foldersToOpen: ${U.length}, emptyToRestore: ${V.length}, emptyToOpen: ${$e})`),ue.length>1)if(be)be.focus();else{const Ae=this.j.state.lastActiveWindow&&!C.forceEmpty&&!C.cli._.length&&!C.cli["file-uri"]&&!C.cli["folder-uri"]&&!(C.urisToOpen&&C.urisToOpen.length);let Le=!0,ve=!0;if(Ae){const we=ue.filter(X=>this.j.state.lastActiveWindow&&X.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Le=!1,ve=!1)}if(Le)for(let we=ue.length-1;we>=0;we--){const X=ue[we];if(!(X.openedWorkspace&&q.some(le=>X.openedWorkspace&&le.workspace.id===X.openedWorkspace.id)||X.backupPath&&V.some(le=>X.backupPath&&le.backupFolder===(0,y.$_d)(X.backupPath)))){X.focus(),ve=!1;break}}ve&&ue[ue.length-1].focus()}const me=re&&re.filesToDiff.length>0,Se=re&&re.filesToMerge.length>0;if(!ue.some(Ae=>Ae.isExtensionDevelopmentHost)&&!me&&!Se&&!C.noRecentEntry){const Ae=[];for(const Le of de)Q(Le)&&!Le.transient?Ae.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):x(Le)?Ae.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Ae.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.G.addRecentlyOpened(Ae)}return this.P(C,ue),ue}P(C,L){const U=C.waitMarkerFileURI;C.context===0&&U&&L.length===1&&L[0]&&(async()=>{await L[0].whenClosedOrLoaded;try{await this.L.del(U)}catch{}})()}async Q(C,L,U,W,q,V,re){const $e=[];let de;function ue(we,X){$e.push(we),X&&(de=we,V=void 0)}let{openFolderInNewWindow:be,openFilesInNewWindow:me}=this.ib(C);if(!C.initialStartup&&re.length>0){const we=re[0].remoteAuthority,X=this.nb(we);X&&ue(this.S(X,re.map(le=>le.workspace.uri)))}const Se=U.length+L.length+W.length;if(V&&Se===0){const we=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],X=this.getWindows().filter(fe=>V&&(0,a.$mg)(fe.remoteAuthority,V.remoteAuthority));let le;we?.fileUri&&!me&&((C.context===4||C.context===0||C.context===1)&&(le=await(0,se.$t5b)(X,we.fileUri,async fe=>fe.configPath.scheme===f.Schemas.file?this.H.resolveLocalWorkspace(fe.configPath):void 0)),le||(le=this.ob(X))),le?(0,ae.$Ph)(le.openedWorkspace)?L.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):(0,ae.$Kh)(le.openedWorkspace)?U.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):ue(this.R(C,le,V),!0):ue(await this.jb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:C.forceNewTabbedWindow,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile}),!0)}const Ae=(0,A.$Jb)(L,we=>we.workspace.id);if(Ae.length>0){const we=(0,A.$Eb)(Ae.map(X=>(0,se.$u5b)(this.getWindows(),X.workspace.configPath)));if(we.length>0){const X=we[0],le=(0,a.$mg)(V?.remoteAuthority,X.remoteAuthority)?V:void 0;ue(this.R(C,X,le),!!le),be=!0}for(const X of Ae){if(we.some(Ee=>Ee.openedWorkspace&&Ee.openedWorkspace.id===X.workspace.id))continue;const le=X.remoteAuthority,fe=(0,a.$mg)(V?.remoteAuthority,le)?V:void 0;ue(await this.W(C,X,be,fe),!!fe),be=!0}}const Le=(0,A.$Jb)(U,we=>a.$$f.getComparisonKey(we.workspace.uri));if(Le.length>0){const we=(0,A.$Eb)(Le.map(X=>(0,se.$u5b)(this.getWindows(),X.workspace.uri)));if(we.length>0){const X=we[0],le=(0,a.$mg)(V?.remoteAuthority,X.remoteAuthority)?V:void 0;ue(this.R(C,X,le),!!le),be=!0}for(const X of Le){if(we.some(Ee=>(0,ae.$Kh)(Ee.openedWorkspace)&&a.$$f.isEqual(Ee.openedWorkspace.uri,X.workspace.uri)))continue;const le=X.remoteAuthority,fe=(0,a.$mg)(V?.remoteAuthority,le)?V:void 0;ue(await this.W(C,X,be,fe),!!fe),be=!0}}const ve=(0,A.$Jb)(W,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const X=we.remoteAuthority,le=(0,a.$mg)(V?.remoteAuthority,X)?V:void 0;ue(await this.U(C,!0,X,le,we),!!le),be=!0}if($e.length===0||V){V&&!q&&q++;const we=V?V.remoteAuthority:C.remoteAuthority;for(let X=0;X<q;X++)ue(await this.U(C,be,we,V),!!V),be=!0}return{windows:(0,A.$Jb)($e),filesOpenedInWindow:de}}R(C,L,U){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),L.focus();const W={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:C?.userEnv?.TERM_PROGRAM};return L.sendWhenReady("vscode:openFiles",S.CancellationToken.None,W),L}S(C,L){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:L}),C.focus();const U={foldersToAdd:L};return C.sendWhenReady("vscode:addFolders",S.CancellationToken.None,U),C}U(C,L,U,W,q){this.r.trace("windowsManager#doOpenEmpty",{restore:!!q,remoteAuthority:U,filesToOpen:W,forceNewWindow:L});let V;return!L&&typeof C.contextWindowId=="number"&&(V=this.getWindowById(C.contextWindowId)),this.jb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:U,forceNewWindow:L,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:W,windowToUse:V,emptyWindowBackupInfo:q,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}W(C,L,U,W,q){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:L,filesToOpen:W}),!U&&!q&&typeof C.contextWindowId=="number"&&(q=this.getWindowById(C.contextWindowId)),this.jb({workspace:L.workspace,userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:L.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:W,windowToUse:q,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}async X(C){let L,U=!1,W=!1;if(C.urisToOpen&&C.urisToOpen.length>0?(L=await this.Y(C),U=!0):C.forceEmpty?L=[Object.create(null)]:C.cli._.length||C.cli["folder-uri"]||C.cli["file-uri"]?(L=await this.Z(C.cli),L.length===0&&L.push(Object.create(null)),U=!0):(L=await this.ab(),L.length===0&&L.push(Object.create(null)),W=!0),!C.addMode&&U){const q=L.filter(V=>x(V));if(q.length>1){const V=q[0].remoteAuthority;if(q.every(re=>(0,a.$mg)(re.remoteAuthority,V))){const re=await this.H.createUntitledWorkspace(q.map($e=>({uri:$e.workspace.uri})));L.push({workspace:re,remoteAuthority:V}),L=L.filter($e=>!x($e))}}}if(C.initialStartup&&!W&&this.F.getValue("window")?.restoreWindows==="preserve"){const q=await this.ab();L.unshift(...q.filter(V=>Q(V)||x(V)||V.backupPath))}return L}async Y(C){const L={gotoLineMode:C.gotoLineMode,remoteAuthority:C.remoteAuthority},U=await Promise.all((0,A.$Eb)(C.urisToOpen||[]).map(async W=>{const q=await this.cb(W,L);if(q)return q.label=W.label,q;const V=this.eb(W);this.J.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:V.scheme===f.Schemas.file?(0,d.localize)(1,null):(0,d.localize)(2,null),detail:V.scheme===f.Schemas.file?(0,d.localize)(3,null,(0,$.$bA)(V,{os:g.OS,tildify:this.w})):(0,d.localize)(4,null,V.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.$Eb)(U)}async Z(C){const L=[],U={ignoreFileNotFound:!0,gotoLineMode:C.goto,remoteAuthority:C.remote||void 0,forceOpenWorkspaceAsFile:C.diff&&C._.length===2||C.merge&&C._.length===4},W=C["folder-uri"];if(W){const re=await Promise.all(W.map($e=>{const de=this.$($e);if(de)return this.cb({folderUri:de},U)}));L.push(...(0,A.$Eb)(re))}const q=C["file-uri"];if(q){const re=await Promise.all(q.map($e=>{const de=this.$($e);if(de)return this.cb((0,ae.$6h)($e)?{workspaceUri:de}:{fileUri:de},U)}));L.push(...(0,A.$Eb)(re))}const V=await Promise.all(C._.map(re=>U.remoteAuthority?this.hb(re,U):this.fb(re,U)));return L.push(...(0,A.$Eb)(V)),L}$(C){try{const L=E.URI.parse(C);if(!L.scheme){this.r.error(`Invalid URI input string, scheme missing: ${C}`);return}return L.path?L:L.with({path:"/"})}catch(L){this.r.error(`Invalid URI input string: ${C}, ${L.message}`)}}async ab(){const C=this.bb();switch(C){case"none":return[];case"one":case"all":case"preserve":case"folders":{const L=[];C!=="one"&&L.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&L.push(this.j.state.lastActiveWindow);const U=await Promise.all(L.map(async W=>{if(W.workspace){const q=await this.cb({workspaceUri:W.workspace.configPath},{remoteAuthority:W.remoteAuthority,rejectTransientWorkspaces:!0});if(Q(q))return q}else if(W.folderUri){const q=await this.cb({folderUri:W.folderUri},{remoteAuthority:W.remoteAuthority});if(x(q))return q}else if(C!=="folders"&&W.backupPath)return{backupPath:W.backupPath,remoteAuthority:W.remoteAuthority}}));return(0,A.$Eb)(U)}}}bb(){let C;return this.C.wasRestarted?C="all":(C=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(C)||(C="all")),C}async cb(C,L=Object.create(null)){const U=this.eb(C);return U.scheme===f.Schemas.file?((0,N.$PD)(C)&&(L={...L,forceOpenWorkspaceAsFile:!0}),this.fb(U.fsPath,L)):this.db(C,L)}db(C,L){let U=this.eb(C);const W=(0,R.$Nk)(U)||L.remoteAuthority;if(U=(0,a.$og)((0,a.$ig)(U)),(0,N.$PD)(C)){if(L.gotoLineMode){const{path:q,line:V,column:re}=(0,l.$Of)(U.path);return{fileUri:U.with({path:q}),options:{selection:V?{startLineNumber:V,startColumn:re||1}:void 0},remoteAuthority:W}}return{fileUri:U,remoteAuthority:W}}else if((0,N.$ND)(C))return{workspace:(0,ne.$m5b)(U),remoteAuthority:W};return{workspace:(0,ne.$n5b)(U),remoteAuthority:W}}eb(C){return(0,N.$ND)(C)?C.workspaceUri:(0,N.$OD)(C)?C.folderUri:C.fileUri}async fb(C,L,U){let W,q;L.gotoLineMode&&({path:C,line:W,column:q}=(0,l.$Of)(C)),C=(0,l.$Jf)((0,y.$6d)(C),(0,c.cwd)());try{const V=await O.Promises.stat(C);if(V.isFile()){if(!L.forceOpenWorkspaceAsFile){const re=await this.H.resolveLocalWorkspace(E.URI.file(C));if(re)return re.transient&&L.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:n.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:E.URI.file(C),type:n.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:q||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,ne.$n5b)(E.URI.file(C),V),type:n.FileType.Directory,exists:!0};if(!g.$i&&C==="/dev/null")return{fileUri:E.URI.file(C),type:n.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!U)return this.gb(C,L);const re=E.URI.file(C);if(this.G.removeRecentlyOpened([re]),L.ignoreFileNotFound)return{fileUri:re,type:n.FileType.File,exists:!1}}}async gb(C,L){const U=E.URI.file(C),{response:W,checkboxChecked:q}=await this.J.showMessageBox({type:"warning",buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null),(0,d.localize)(7,null)],message:(0,d.localize)(8,null,U.authority),detail:(0,d.localize)(9,null,(0,$.$bA)(U,{os:g.OS,tildify:this.w})),checkboxLabel:(0,d.localize)(10,null,U.authority),cancelId:1});if(W===0)return(0,s.addUNCHostToAllowlist)(U.authority),q&&this.B(h.Event.once(this.onDidOpenWindow)(V=>{V.sendWhenReady("vscode:configureAllowedUNCHost",S.CancellationToken.None,U.authority)})),this.fb(C,L,!0);if(W===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(C,L)}hb(C,L){const U=C.charCodeAt(0),W=L.remoteAuthority;let q,V;L.gotoLineMode&&({path:C,line:q,column:V}=(0,l.$Of)(C)),U!==47&&((0,l.$If)(U)&&C.charCodeAt(C.charCodeAt(1))===58&&(C=(0,l.$Bf)(C)),C=`/${C}`);const re=E.URI.from({scheme:f.Schemas.vscodeRemote,authority:W,path:C});if(C.charCodeAt(C.length-1)!==47){if((0,ae.$6h)(C))return L.forceOpenWorkspaceAsFile?{fileUri:re,options:{selection:q?{startLineNumber:q,startColumn:V||1}:void 0},remoteAuthority:L.remoteAuthority}:{workspace:(0,ne.$m5b)(re),remoteAuthority:W};if(L.gotoLineMode||y.$5d.basename(C).indexOf(".")!==-1)return{fileUri:re,options:{selection:q?{startLineNumber:q,startColumn:V||1}:void 0},remoteAuthority:W}}return{workspace:(0,ne.$n5b)(re),remoteAuthority:W}}ib(C){const L=this.F.getValue("window"),U=L?.openFoldersInNewWindow||"default",W=L?.openFilesInNewWindow||"off";let q=(C.preferNewWindow||C.forceNewWindow)&&!C.forceReuseWindow;!C.forceNewWindow&&!C.forceReuseWindow&&(U==="on"||U==="off")&&(q=U==="on");let V=!1;return C.forceNewWindow||C.forceReuseWindow?V=!!C.forceNewWindow&&!C.forceReuseWindow:(g.$j?C.context===1&&(V=!0):C.context!==3&&C.context!==2&&!(C.userEnv&&C.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!C.cli.extensionDevelopmentPath&&(W==="on"||W==="off")&&(V=W==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(C,L){const U=(0,se.$v5b)(this.getWindows(),C);if(U)return this.C.reload(U,L.cli),U.focus(),[U];let W=L.cli["folder-uri"]||[],q=L.cli["file-uri"]||[],V=L.cli._;if(!V.length&&!W.length&&!q.length&&!L.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(E.URI.isUri(ue)?ue.scheme===f.Schemas.file?V=[ue.fsPath]:W=[ue.toString()]:ue.configPath.scheme===f.Schemas.file?V=[(0,a.$8f)(ue.configPath)]:q=[ue.configPath.toString()])}let re=L.remoteAuthority;for(const de of C)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=E.URI.parse(de),be=(0,R.$Nk)(ue);be&&(re?(0,a.$mg)(be,re)||this.r.error("more than one extension development path authority"):re=be)}V=V.filter(de=>{const ue=E.URI.file(de);return(0,se.$u5b)(this.getWindows(),ue)?!1:(0,a.$mg)((0,R.$Nk)(ue),re)}),W=W.filter(de=>{const ue=this.$(de);return ue&&(0,se.$u5b)(this.getWindows(),ue)?!1:ue?(0,a.$mg)((0,R.$Nk)(ue),re):!1}),q=q.filter(de=>{const ue=this.$(de);return ue&&(0,se.$u5b)(this.getWindows(),ue)?!1:ue?(0,a.$mg)((0,R.$Nk)(ue),re):!1}),L.cli._=V,L.cli["folder-uri"]=W,L.cli["file-uri"]=q;const $e={context:L.context,cli:L.cli,forceNewWindow:!0,forceEmpty:!V.length&&!W.length&&!q.length,userEnv:L.userEnv,noRecentEntry:!0,waitMarkerFileURI:L.waitMarkerFileURI,remoteAuthority:re,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile};return this.open($e)}async jb(C){const L=this.F.getValue("window"),U=this.getLastActiveWindow(),W=U?.profile??this.z.defaultProfile;let q;!C.forceNewWindow&&!C.forceNewTabbedWindow&&(q=C.windowToUse||U,q&&q.focus());const V={...this.w.args,...C.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:C.emptyWindowBackupInfo?(0,y.$8d)(this.w.backupHome,C.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:W},homeDir:this.w.userHome.with({scheme:f.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:f.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:C.remoteAuthority,workspace:C.workspace,userEnv:{...this.n,...C.userEnv},filesToOpenOrCreate:C.filesToOpen?.filesToOpenOrCreate,filesToDiff:C.filesToOpen?.filesToDiff,filesToMerge:C.filesToOpen?.filesToMerge,filesToWait:C.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:f.Schemas.file}).fsPath,product:D.default,isInitialStartup:C.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof L?.zoomLevel=="number"?L.zoomLevel:void 0,autoDetectHighContrast:L?.autoDetectHighContrast??!0,autoDetectColorScheme:L?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(q){const re=q.config;!V.extensionDevelopmentPath&&re?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=re.extensionDevelopmentPath,V.extensionDevelopmentKind=re.extensionDevelopmentKind,V["enable-proposed-api"]=re["enable-proposed-api"],V.verbose=re.verbose,V["inspect-extensions"]=re["inspect-extensions"],V["inspect-brk-extensions"]=re["inspect-brk-extensions"],V.debugId=re.debugId,V.extensionEnvironment=re.extensionEnvironment,V["extensions-dir"]=re["extensions-dir"],V["disable-extensions"]=re["disable-extensions"]),V.loggers={global:V.loggers.global,window:re?.loggers.window??V.loggers.window}}else{const re=this.j.getNewWindowState(V);(0,w.mark)("code/willCreateCodeWindow");const $e=q=this.I.createInstance(z.$v6b,{state:re,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),C.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow($e),H.a.push($e),this.b.fire($e),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,b.$bb)($e.onDidSignalReady)(()=>this.c.fire($e)),(0,b.$bb)($e.onDidClose)(()=>this.mb($e)),(0,b.$bb)($e.onDidDestroy)(()=>this.f.fire($e)),$e.onDidTriggerSystemContextMenu(({x:ue,y:be})=>this.h.fire({window:$e,x:ue,y:be}));const de=(0,m.$tf)($e.win?.webContents);de.removeAllListeners("devtools-reload-page"),de.on("devtools-reload-page",()=>this.C.reload($e)),this.C.registerWindow($e)}return V.windowId=q.id,q.isReady?this.C.unload(q,4).then(async re=>{re||await this.kb(q,V,C,W)}):await this.kb(q,V,C,W),q}async kb(C,L,U,W){if(L.extensionDevelopmentPath||((0,ae.$Ph)(L.workspace)?L.backupPath=this.D.registerWorkspaceBackup({workspace:L.workspace,remoteAuthority:L.remoteAuthority}):(0,ae.$Kh)(L.workspace)?L.backupPath=this.D.registerFolderBackup({folderUri:L.workspace.uri,remoteAuthority:L.remoteAuthority}):L.backupPath=this.D.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,ne.$o5b)().id,remoteAuthority:L.remoteAuthority})),this.z.isEnabled()){const q=L.workspace??(0,ae.$Oh)(L.backupPath,!1),V=this.lb(U,q,W),re=V instanceof Promise?await V:V;L.profiles.profile=re,L.extensionDevelopmentPath||await this.z.setProfileForWorkspace(q,re)}C.load(L)}lb(C,L,U){return C.forceProfile?this.z.profiles.find(W=>W.name===C.forceProfile)??this.z.createNamedProfile(C.forceProfile):C.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(L)??U}mb(C){const L=H.a.indexOf(C);H.a.splice(L,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const C=P.BrowserWindow.getFocusedWindow();if(C)return this.getWindowById(C.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(C){return this.ob(this.getWindows().filter(L=>(0,a.$mg)(L.remoteAuthority,C)))}ob(C){const L=Math.max.apply(Math,C.map(U=>U.lastFocusTime));return C.find(U=>U.lastFocusTime===L)}sendToFocused(C,...L){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(C,S.CancellationToken.None,...L)}sendToAll(C,L,U){for(const W of this.getWindows())U&&U.indexOf(W.id)>=0||W.sendWhenReady(C,S.CancellationToken.None,L)}getWindows(){return H.a}getWindowCount(){return H.a.length}getWindowById(C){const L=this.getWindows().filter(U=>U.id===C);return(0,A.$Lb)(L)}getWindowByWebContents(C){const L=P.BrowserWindow.fromWebContents(C);if(L)return this.getWindowById(L.id)}};e.$z6b=ce,e.$z6b=ce=H=ke([_(2,I.$4i),_(3,T.$05b),_(4,j.$$M),_(5,B.$9m),_(6,i.$44b),_(7,F.$_4b),_(8,k.$64b),_(9,t.$k5b),_(10,u.$7h),_(11,oe.$55b),_(12,G.$w5b),_(13,o.$zh),_(14,r.$r5b),_(15,n.$5j),_(16,v.$T5b),_(17,K.$N5b)],ce)}),define(te[305],ie([0,1,64,30,83,54]),function(J,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=void 0;let A=class{constructor(h,l,b,$){this.a=h,this.b=l,this.c=b,this.d=$,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const b=this.b.getWindowById(h);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),l)}createUntitledWorkspace(h,l,b){return this.a.createUntitledWorkspace(l,b)}deleteUntitledWorkspace(h,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$B6b=A,e.$B6b=A=ke([_(0,M.$w5b),_(1,O.$f5b),_(2,s.$55b),_(3,P.$k5b)],A)}),define(te[306],ie([0,1,15,131,38,27,17,50,14,32,49,44,46,2,13,9,4,12,7,31,147,42,158,110,288,161,64,284,18,199,90,132,61,115,218,28,63,94,208,233,209,293,117,210,211,16,222,93,75,6,92,217,298,285,273,20,5,303,67,24,60,294,95,33,276,82,122,25,250,252,52,48,264,290,299,291,300,127,266,267,268,271,274,30,304,275,29,97,83,305,54,39,231,53,243,51,81,129,278,292,281,8,254,277,226,66,91,296,270,23,125,295,262,238,84]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d,t,u,r,i,n,o,k,I,D,v,R,j,N,z,se,ee,ae,ne,oe,G,K,B,F,T,H,Q,x,ce,Y,C,L,U,W,q,V,re,$e,de,ue,be,me,Se,Ae,Le,ve,we,X,le,fe,Ee,Ce,Ue,Oe,ze,We,Z,he,ge,ye,Re,Fe,je,Ne,Be,qe,He,xe,Qe,tt,nt,$t,rt,mt,wt,bt,pt,yt,vt,kt,ot,Et,St,Pt,It,At,at,Dt,ht,ct,Rt,Ct,lt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R6b=void 0;let ut=class extends f.$jc{constructor(Ie,Pe,pe,Me,De,Te,Ke,Ze,Xe,Ge,Ve,Je){super(),this.c=Ie,this.f=Pe,this.g=pe,this.h=Me,this.j=De,this.m=Te,this.n=Ke,this.s=Ze,this.t=Xe,this.u=Ge,this.w=Ve,this.y=Je,this.z(),this.C()}z(){const Ie=Ge=>Ge?.startsWith(`${y.Schemas.vscodeWebview}://`),Pe=new Set(this.w.quality==="stable"?[]:["media"]),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Ge,Ve,Je,Ye)=>Ie(Ye.requestingUrl)?Je(pe.has(Ve)):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Je(Pe.has(Ve)):Je(!1)),P.session.defaultSession.setPermissionCheckHandler((Ge,Ve,Je,Ye)=>Ie(Ye.requestingUrl)?pe.has(Ve):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Pe.has(Ve):!1);const Me=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),De=Ge=>{for(let Ve=Ge;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Te=Ge=>Ge.resourceType==="xhr"||De(Ge.frame),Ke=Ge=>{const Ve=Ge.frame;if(!Ve||!this.a)return!1;const Je=P.BrowserWindow.getAllWindows();for(const Ye of Je)if(Ve.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ze=(Ge,Ve)=>{if(Ge.path!=="/index.html")return!0;const Je=Ve.frame;if(!Je||!this.a)return!1;for(const Ye of this.a.getWindows())if(Ye.win&&Je.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Ge,Ve)=>{const Je=a.URI.parse(Ge.url);return Je.scheme===y.Schemas.vscodeWebview&&!Ze(Je,Ge)?(this.h.error("Blocked vscode-webview request",Ge.url),Ve({cancel:!0})):Je.scheme===y.Schemas.vscodeFileResource&&!Ke(Ge)?(this.h.error("Blocked vscode-file request",Ge.url),Ve({cancel:!0})):Je.path.endsWith(".svg")&&!Me.has(Je.scheme)?Ve({cancel:!Te(Ge)}):Ve({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ge,Ve)=>{const Je=Ge.responseHeaders,Ye=Je["content-type"]||Je["Content-Type"];if(Ye&&Array.isArray(Ye)){const it=a.URI.parse(Ge.url);if(it.path.endsWith(".svg")&&Me.has(it.scheme))return Je["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Je});if(!it.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(_e=>_e.toLowerCase().includes("image/svg")))return Ve({cancel:!Te(Ge)})}return Ve({cancel:!1})});const Xe=P.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.m.codeCachePath&&Xe.setCodeCachePath((0,w.$8d)(this.m.codeCachePath,"chrome")),g.$i&&(this.s.getValue("security.restrictUNCAccess")===!1?(0,O.disableUNCAccessRestrictions)():(0,O.addUNCHostToAllowlist)(this.s.getValue("security.allowedUNCHosts")))}C(){(0,h.setUnexpectedErrorHandler)(pe=>this.F(pe)),process.on("uncaughtException",pe=>{(0,h.$X)(pe)||(0,h.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,h.$Y)(pe)),this.n.onWillShutdown(()=>this.dispose()),(0,E.$KS)(),P.app.on("accessibility-support-changed",(pe,Me)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Me)}),P.app.on("activate",async(pe,Me)=>{this.h.trace("app#activate"),Me||await this.a?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(pe,Me)=>{Me.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Me.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let Ie=[],Pe;P.app.on("open-file",(pe,Me)=>{this.h.trace("app#open-file: ",Me),pe.preventDefault(),Ie.push((0,qe.$6h)(Me)?{workspaceUri:a.URI.file(Me)}:{fileUri:a.URI.file(Me)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.m.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Pe=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.$JS.handle("vscode:fetchShellEnv",pe=>{const Me=this.a?.getWindowByWebContents(pe.sender);let De,Te;return Me?.config?(De=Me.config,Te={...process.env,...Me.config.userEnv}):(De=this.m.args,Te=process.env),this.U(De,Te,!1)}),s.$JS.handle("vscode:writeNlsFile",(pe,Me,De)=>{const Te=this.D([Me]);if(!Te||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.u.writeFile(Te,A.$Ed.fromString(De))}),s.$JS.handle("vscode:readNlsFile",async(pe,...Me)=>{const De=this.D(Me);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.u.readFile(De)).value.toString()}),s.$JS.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),s.$JS.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),s.$JS.on("vscode:reloadWindow",pe=>pe.sender.reload())}D(Ie){let Pe;for(const pe of Ie)typeof pe=="string"&&(typeof Pe!="string"?Pe=pe:Pe=(0,w.$8d)(Pe,pe));if(!(typeof Pe!="string"||!(0,w.$7d)(Pe)||!(0,l.$Hf)(Pe,this.m.cachedLanguagesPath,!g.$k)))return a.URI.file(Pe)}F(Ie){if(Ie){const Pe={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.h.error(Ie.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.m.appRoot}`),this.h.debug("args:",this.m.args);const Ie=this.w.win32AppUserModelId;g.$i&&Ie&&P.app.setAppUserModelId(Ie);try{g.$j&&this.s.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Xe){this.h.error(Xe)}const Pe=new t.$QS;this.n.onWillShutdown(Xe=>{Xe.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Et.$I6b)(this.t,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Me,sharedProcessClient:De}=this.N(pe),Te=await this.O(pe,Me);this.B(Te.createInstance(r.$g5b)),this.B(Te.createInstance(vt.$F6b)),Te.invokeFunction(Xe=>this.P(Xe,Pe,De));const Ke=Te.invokeFunction(Xe=>this.G(Xe,Pe));this.H(Pe),this.n.phase=2,await Te.invokeFunction(Xe=>this.Q(Xe,Ke)),this.n.phase=3,this.R(),this.B(new ot.$Rg(()=>{this.B((0,ot.$Vg)(()=>this.n.phase=4,2500))},2500)).schedule()}G(Ie,Pe){const pe=this.a=Ie.get(je.$f5b),Me=Ie.get(Z.$xT),De=this.b=Ie.get($e.$R5b),Te=this;Me.registerHandler({async handleURL(Je,Ye){return Te.M(pe,Me,Je,Ye)}});const Ke=this.B(new Be.$A6b({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Ze=new d.$ih(Je=>Ke.getActiveClientId().then(Ye=>Je===Ye)),Xe=new he.$q6b(Ze,this.h),Ge=Pe.getChannel("urlHandler",Xe);Me.registerHandler(new he.$p6b(Ge));const Ve=this.I();return this.B(new ye.$r6b(Ve?.urls,Me,pe,this.m,this.w,this.h)),Ve}H(Ie){const Pe=()=>({statusCode:404,data:"Not found"}),pe=new Ot.$T(()=>Ie.getChannel(lt.$P6b,new lt.$Q6b));P.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Me,De)=>{const Te=a.URI.parse(Me.url);if(!Te.authority.startsWith("window:"))return De(Pe());pe.value.call(lt.$O6b,[Te]).then(Ke=>De({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.h.warn("error dispatching remote resource call",Ke),De({statusCode:500,data:String(Ke)})})})}I(){const Ie=this.m.args["open-url"]?this.m.args._urls||[]:[];Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ie);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ie.length+Pe.length===0)return;const pe=[];return{urls:[...Ie,...Pe].map(De=>{try{return{uri:a.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.J(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const Te=this.L(De.uri);return Te?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),Te),pe.push(Te),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:pe}}J(Ie){if(Ie.authority===y.Schemas.file&&g.$i){const{options:Pe,buttonIndeces:pe}=(0,At.$pA)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,p.$bA)(Ie,{os:g.OS,tildify:this.m}),this.w.nameShort),detail:(0,i.localize)(3,null)},this.w);if(pe[P.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}L(Ie){if(Ie.path){if(Ie.authority===y.Schemas.file){const Pe=a.URI.file(Ie.fsPath);return(0,qe.$6h)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ie.authority===y.Schemas.vscodeRemote){const Pe=Ie.path.indexOf(w.$5d.sep,1);if(Pe!==-1){const pe=Ie.path.substring(1,Pe),Me=Ie.path.substring(Pe);let De=Ie.query;const Te=new URLSearchParams(Ie.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),De=Te.toString());const Ke=a.URI.from({scheme:y.Schemas.vscodeRemote,authority:pe,path:Me,query:De,fragment:Ie.fragment});return(0,qe.$6h)(Me)?{workspaceUri:Ke}:/:[\d]+$/.test(Me)?{fileUri:Ke}:{folderUri:Ke}}}}}async M(Ie,Pe,pe,Me){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Me),pe.scheme===this.w.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:a.URI.parse(pe.query).path,query:""})),this.J(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let De=!1;const Te=new URLSearchParams(pe.query);Te.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Te.delete("windowId"),pe=pe.with({query:Te.toString()}),De=!0):g.$j&&Ie.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),De=!0);const Ke=Te.get("continueOn");Ke!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Te.delete("continueOn"),pe=pe.with({query:Te.toString()}),this.m.continueOn=Ke??void 0);const Ze=this.L(pe);return Ze?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ze,pe.toString(!0)),(0,ht.$Lb)(await Ie.open({context:5,cli:{...this.m.args},urisToOpen:[Ze],forceNewWindow:De,gotoLineMode:!0}))?.focus(),!0):De?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ht.$Lb)(await Ie.open({context:5,cli:{...this.m.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.$Nk)(pe)}))?.ready(),Pe.open(pe,Me)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Me),!1)}N(Ie){const Pe=this.B(this.g.createInstance(be.$c6b,Ie)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new u.$RS(De,"main")})();return{sharedProcessReady:(async()=>(await Pe.whenReady(),pe))(),sharedProcessClient:pe}}async O(Ie,Pe){const pe=new Y.$yh;switch(process.platform){case"win32":pe.set(Ee.$JT,new x.$xh(We.$n6b));break;case"linux":g.$l?pe.set(Ee.$JT,new x.$xh(ze.$m6b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Ee.$JT,new x.$xh(Oe.$l6b));break;case"darwin":pe.set(Ee.$JT,new x.$xh(Ue.$k6b));break}pe.set(je.$f5b,new x.$xh(Ne.$z6b,[Ie,this.f],!1));const Me=new R.$s5b(this.h,this.w);pe.set(R.$r5b,Me),pe.set(W.$Y5b,new x.$xh(W.$Z5b,void 0,!1)),pe.set(v.$B5b,new x.$xh(v.$C5b,void 0,!1)),pe.set(D.$fm,d.ProxyChannel.toService((0,d.$gh)(Pe.then(Xe=>Xe.getChannel("diagnostics"))))),pe.set(C.$btb,new x.$xh(L.$U5b,[this.f])),pe.set(j.$rT,new x.$xh(N.$D5b)),pe.set(U.$V5b,new x.$xh(U.$W5b)),pe.set($e.$R5b,new x.$xh($e.$S5b,void 0,!1)),pe.set(Re.$s6b,new x.$xh(Fe.$u6b)),pe.set(re.$85b,new x.$xh(re.$95b)),pe.set(ae.$Skb,new x.$xh(ne.$E5b)),pe.set(oe.$F5b,new x.$xh(G.$H5b)),pe.set(Le.$b5b,new x.$xh(Le.$c5b)),pe.set(Le.$d5b,new x.$xh(Le.$e5b));const De=new Rt.$N6b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.s.getValue("terminal.integrated.persistentSessionScrollback")??100},this.s,this.m,this.n,this.h),Te=new Ct.$jr(De,this.s,this.h,this.j);pe.set(ct.$Wq,Te),g.$i?pe.set(K.$YWb,new x.$xh(B.$I5b)):g.$j?pe.set(K.$YWb,new x.$xh(B.$J5b)):g.$k&&pe.set(K.$YWb,new x.$xh(B.$K5b));const Ke=new o.$p5b(this.m,this.s,this.h,this.t);pe.set(n.$k5b,Ke);const Ze=new tt.$x5b(this.m,this.h,this.y,Ke,Me);if(pe.set(tt.$w5b,Ze),pe.set(He.$7T,new x.$xh(Qe.$B6b,void 0,!1)),pe.set(xe.$55b,new x.$xh(xe.$65b,void 0,!1)),pe.set(Z.$xT,new x.$xh(ge.$zT,void 0,!1)),(0,fe.$go)(this.w,this.m)){const Xe=(0,fe.$lo)(this.w,this.s),Ge=(0,d.$gh)(Pe.then(_e=>_e.getChannel("telemetryAppender"))),Ve=new X.$f6b(Ge),Je=(0,ve.$9n)((0,M.release)(),(0,M.hostname)(),process.arch,this.w.commit,this.w.version,Ie,Xe),Ye=(0,fe.$mo)(this.m),it={appenders:[Ve],commonProperties:Je,piiPaths:Ye,sendErrorTelemetry:!0};pe.set(we.$8k,new x.$xh(le.$Oq,[it],!1))}else pe.set(we.$8k,fe.$ao);return pe.set(bt.$ip,new x.$xh(St.$fN,void 0,!0)),pe.set(pt.$mp,new x.$xh(yt.$E6b,void 0,!0)),pe.set(at.$L6b,new x.$xh(at.$M6b,void 0,!0)),await ot.Promises.settled([Ke.initialize(),Ze.initialize()]),this.g.createChild(pe)}P(Ie,Pe,pe){const Me=this.B(new f.$ic),De=d.ProxyChannel.fromService(Ie.get(W.$Y5b),Me,{disableMarshalling:!0});this.c.registerChannel("launch",De);const Te=d.ProxyChannel.fromService(Ie.get(v.$B5b),Me,{disableMarshalling:!0});this.c.registerChannel("diagnostics",Te);const Ke=new $t.$C6b(Ie.get(nt.$9m));Pe.registerChannel("policy",Ke),pe.then(et=>et.registerChannel("policy",Ke));const Ze=this.u.getProvider(y.Schemas.file);(0,c.$sf)(Ze instanceof Q.$1p);const Xe=new H.$L5b(Ze,this.h,this.m);Pe.registerChannel(F.$1M,Xe),pe.then(et=>et.registerChannel(F.$1M,Xe));const Ge=d.ProxyChannel.fromService(Ie.get(rt.$_4b),Me);Pe.registerChannel("userDataProfiles",Ge),pe.then(et=>et.registerChannel("userDataProfiles",Ge));const Ve=new mt.$Jq(Ie.get(wt.$Ho));pe.then(et=>et.registerChannel("request",Ve));const Je=new Ce.$g6b(Ie.get(Ee.$JT));Pe.registerChannel("update",Je);const Ye=d.ProxyChannel.fromService(Ie.get(C.$btb),Me);Pe.registerChannel("issue",Ye);const it=d.ProxyChannel.fromService(Ie.get(j.$rT),Me);Pe.registerChannel("encryption",it);const _e=d.ProxyChannel.fromService(Ie.get(me.$Vk),Me);Pe.registerChannel("sign",_e);const st=d.ProxyChannel.fromService(Ie.get(U.$V5b),Me);Pe.registerChannel("keyboardLayout",st),this.b=Ie.get($e.$R5b);const ft=d.ProxyChannel.fromService(this.b,Me);Pe.registerChannel("nativeHost",ft),pe.then(et=>et.registerChannel("nativeHost",ft));const Mt=d.ProxyChannel.fromService(Ie.get(He.$7T),Me);Pe.registerChannel("workspaces",Mt);const jt=d.ProxyChannel.fromService(Ie.get(re.$85b),Me);Pe.registerChannel("menubar",jt);const Lt=d.ProxyChannel.fromService(Ie.get(Z.$xT),Me);Pe.registerChannel("url",Lt);const Ft=d.ProxyChannel.fromService(Ie.get(ae.$Skb),Me);Pe.registerChannel("extensionUrlTrust",Ft);const Ut=d.ProxyChannel.fromService(Ie.get(Re.$s6b),Me);Pe.registerChannel("webview",Ut);const dt=this.B(new Ae.$d6b(this.h,Ie.get(Le.$b5b)));Pe.registerChannel("storage",dt),pe.then(et=>et.registerChannel("storage",dt));const Nt=this.B(new kt.$G6b(Ie.get(Le.$b5b),Ie.get(rt.$_4b),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Nt));const Tt=d.ProxyChannel.fromService(Ie.get(ct.$Wq),Me);Pe.registerChannel(ct.TerminalIpcChannels.LocalPty,Tt);const Wt=d.ProxyChannel.fromService(Ie.get(K.$YWb),Me);Pe.registerChannel("externalTerminal",Wt);const gt=new Pt.$J6b(Ie.get(It.$05b));Pe.registerChannel("logger",gt),pe.then(et=>et.registerChannel("logger",gt));const zt=new I.$q5b(Ie.get(je.$f5b));Pe.registerChannel("extensionhostdebugservice",zt);const Bt=d.ProxyChannel.fromService(Ie.get(oe.$F5b),Me);Pe.registerChannel(oe.$G5b,Bt);const qt=d.ProxyChannel.fromService(Ie.get(at.$L6b),Me);Pe.registerChannel(Dt.$K6b,qt)}async Q(Ie,Pe){const pe=this.a=Ie.get(je.$f5b),Me=(0,se.$Fl)(process.env)?0:4,De=this.m.args;if(Pe){if(Pe.openables.length>0)return pe.open({context:Me,cli:De,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const _e of Pe.urls){const st=new URLSearchParams(_e.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:st.toString()}),pe.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,Ke=De._.length,Ze=!!De["folder-uri"],Xe=!!De["file-uri"],Ge=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?a.URI.file(De.waitMarkerFilePath):void 0,Je=De.remote||void 0,Ye=De.profile,it=De["profile-temp"];if(!Ke&&!Ze&&!Xe){if(De["new-window"]||Ye||it)return pe.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:Ye,forceTempProfile:it});if(Te.length)return pe.open({context:1,cli:De,urisToOpen:Te.map(_e=>(0,qe.$6h)(_e)?{workspaceUri:a.URI.file(_e)}:{fileUri:a.URI.file(_e)}),noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0})}return pe.open({context:Me,cli:De,forceNewWindow:De["new-window"]||!Ke&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ge,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:Ye,forceTempProfile:it})}R(){this.S(),P.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ie,Pe)=>{Pe({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.U(this.m.args,process.env,!0),this.W(),g.$j&&P.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async S(){const Ie=this.w.win32MutexName;if(g.$i&&Ie)try{const Pe=await new Promise((Me,De)=>{J(["@vscode/windows-mutex"],Me,De)}),pe=new Pe.Mutex(Ie);(0,b.$bb)(this.n.onWillShutdown)(()=>pe.release())}catch(Pe){this.h.error(Pe)}}async U(Ie,Pe,pe){try{return await(0,ee.$Ll)(this.s,this.h,Ie,Pe)}catch(Me){const De=(0,S.$li)(Me);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async W(){try{const Pe=(await this.u.readFile(this.m.argvResource)).value.toString(),pe=JSON.parse((0,$.$Sm)(Pe)),De=(0,fe.$io)(this.s)>=1;if(pe["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.$3f)()}"`,"}"],Ke=Pe.substring(0,Pe.length-2).concat(`,
`,Te.join(`
`));await this.u.writeFile(this.m.argvResource,A.$Ed.fromString(Ke))}else{const Te=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);Te!==Pe&&await this.u.writeFile(this.m.argvResource,A.$Ed.fromString(Te))}}catch(Ie){this.h.error(Ie)}}};e.$R6b=ut,e.$R6b=ut=ke([_(2,ce.$zh),_(3,V.$4i),_(4,V.$5i),_(5,z.$44b),_(6,q.$64b),_(7,k.$7h),_(8,Se.$$M),_(9,T.$5j),_(10,de.$jj),_(11,rt.$_4b)],ut)}),define(te[312],ie([0,1,15,45,7,23,8,50,14,32,49,46,13,9,65,4,35,26,21,42,99,306,10,18,237,249,28,63,201,16,220,93,75,216,92,20,223,5,77,24,78,279,126,289,51,287,95,248,33,52,79,53,39,232,230,2,40,265,66,225,91,121,269,263]),function(J,e,P,O,s,M,A,S,h,l,b,$,p,f,y,w,g,c,a,m,E,d,t,u,r,i,n,o,k,I,D,v,R,j,N,z,se,ee,ae,ne,oe,G,K,B,F,T,H,Q,x,ce,Y,C,L,U,W,q,V,re,$e,de,ue,be,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ve){console.error(ve.message),P.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ve,we,X,le,fe,Ee,Ce,Ue]=this.b();try{try{await this.d(X,Ue,le,fe,Ce)}catch(Oe){throw this.f(X,Ce,Oe),Oe}await ve.invokeFunction(async Oe=>{const ze=Oe.get(ee.$4i),We=Oe.get(z.$64b),Z=Oe.get(I.$5j),he=Oe.get(ee.$5i),ge=await this.e(ze,X,We,ve,Ce,!0);return a.Promises.writeFile(X.mainLockfile,String(process.pid)).catch(ye=>{ze.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Ee.logger=he.createLogger("main",{name:(0,t.localize)(0,null)}),(0,b.$bb)(We.onWillShutdown)(ye=>{Z.dispose(),le.dispose(),ye.join("instanceLockfile",a.Promises.unlink(X.mainLockfile).catch(()=>{}))}),ve.createInstance(d.$R6b,ge,we).startup()})}catch(Oe){ve.invokeFunction(this.i,Oe)}}b(){const ve=new N.$yh,we=new q.$ic;process.once("exit",()=>we.dispose());const X={_serviceBrand:void 0,...ae.default};ve.set(ne.$jj,X);const le=new n.$54b(this.j(),X),fe=this.c(le);ve.set(n.$44b,le);const Ee=new $e.$$5b((0,ee.$fj)(le),le.logsHome);ve.set($e.$05b,Ee);const Ce=new se.$N2b(Ee.getLogLevel()),Ue=we.add(new de.$gN(Ce,[new ee.$$i(Ee.getLogLevel())]));ve.set(ee.$4i,Ue);const Oe=new D.$Bp(Ue);ve.set(I.$5j,Oe);const ze=new v.$1p(Ue);Oe.registerProvider(p.Schemas.file,ze),Oe.registerProvider(p.Schemas.vscodeUserData,new me.$36b(p.Schemas.file,ze,p.Schemas.vscodeUserData,Ue));const We=new re.$nr(Oe);ve.set(V.$Bk,We);const Z=new be.$bN(1,le,Ue,Oe);ve.set(x.$0M,Z),ve.set(x.$$M,Z);const he=new C.$a5b(Z,We,le,Oe,Ue);ve.set(C.$_4b,he);const ge=w.$i&&X.win32RegValueName?we.add(new U.$16b(Ue,X.win32RegValueName)):le.policyFile?we.add(new W.$26b(le.policyFile,Oe,Ue)):new L.$$m;ve.set(L.$9m,ge);const ye=new r.$yn(he.defaultProfile.settingsResource,Oe,ge,Ue);return ve.set(u.$7h,ye),ve.set(z.$64b,new R.$xh(z.$74b,void 0,!1)),ve.set(F.$Ho,new R.$xh(T.$Y6b,void 0,!0)),ve.set(Y.$N5b,new R.$xh(Y.$O5b)),ve.set(H.$Vk,new R.$xh(Q.$Z6b,void 0,!1)),ve.set(K.$Tz,new R.$xh(B.$W6b)),ve.set(oe.$T5b,new G.$T6b(le,he,Ue)),[new j.$4p(ve,!0),fe,le,ye,Z,Ce,X,he]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(X=>{const le=process.env[X];typeof le=="string"&&(we[X]=le)}),Object.assign(process.env,we),we}async d(ve,we,X,le,fe){await A.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsHome.with({scheme:p.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,ve.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,ve.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,ve.backupHome].map(Ee=>Ee?a.Promises.mkdir(Ee,{recursive:!0}):void 0)),le.init(),X.initialize()]),we.init()}async e(ve,we,X,le,fe,Ee){let Ce;try{(0,y.mark)("code/willStartMainServer"),Ce=await(0,E.$vh)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,b.$bb)(X.onWillShutdown)(()=>Ce.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(we,fe,Ue),Ue;let Oe;try{Oe=await(0,E.$wh)(we.mainIPCHandle,"main")}catch(he){if(!Ee||w.$i||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,t.localize)(1,null,fe.nameShort),(0,t.localize)(2,null),fe),he;try{(0,O.unlinkSync)(we.mainIPCHandle)}catch(ge){throw ve.warn("Could not delete obsolete instance handle",ge),ge}return this.e(ve,we,X,le,fe,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${fe.nameShort} is running.`;throw ve.error(he),Oe.dispose(),new Error(he)}let ze;!we.args.wait&&!we.args.status&&(ze=setTimeout(()=>{this.g((0,t.localize)(3,null,fe.nameShort),(0,t.localize)(4,null),fe)},1e4));const We=m.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Z=m.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const he=new i.$ur(ce.$ao,fe),ge=await Z.getMainDiagnostics(),ye=await Z.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Re=await he.getDiagnostics(ge,ye);throw console.log(Re),new h.$$});throw w.$i&&await this.h(We,ve),ve.trace("Sending env to running instance..."),await We.start(we.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new h.$$("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,fe.nameShort)),new h.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f(ve,we,X){if(X.code==="EACCES"||X.code==="EPERM"){const le=(0,M.$Eb)([ve.userDataPath,ve.extensionsPath,E.$rh]).map(fe=>(0,$.$bA)(s.URI.file(fe),{os:w.OS,tildify:ve}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$li)(X),le.join(`
`)),we)}}g(ve,we,X){P.dialog.showMessageBoxSync((0,ue.$pA)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ve,detail:we},X).options)}async h(ve,we){if(w.$i){const X=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",X);try{(await new Promise((le,fe)=>{J(["windows-foreground-love"],le,fe)})).allowSetForegroundWindow(X)}catch(le){we.error(le)}}}i(ve,we){const X=ve.get(ee.$4i),le=ve.get(z.$64b);let fe=0;we&&(we.isExpected?we.message&&X.trace(we.message):(fe=1,we.stack?X.error(we.stack):X.error(`Startup error: ${we.toString()}`))),le.kill(fe)}j(){const ve=this.k((0,o.$Cl)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,k.$S6b)(ve.verbose);we&&((0,o.$El)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const X=(0,g.cwd)(),le=ve.map(Ce=>{let Ue=String(Ce),Oe;we&&(Oe=(0,l.$Of)(Ue),Ue=Oe.path),Ue&&(Ue=this.m(X,Ue));const ze=(0,l.$Jf)(Ue,X),We=(0,f.$_d)(ze);return We&&!(0,l.$Ff)(We)?null:we&&Oe?(Oe.path=ze,this.n(Oe)):ze}),fe=w.$i||w.$j,Ee=(0,M.$Jb)(le,Ce=>Ce&&fe?Ce.toLowerCase():Ce||"");return(0,M.$Eb)(Ee)}m(ve,we){return w.$i&&(we=(0,c.$ue)(we,'"')),we=(0,c.$se)((0,c.$se)(we," "),"	"),w.$i&&(we=(0,f.$9d)(ve,we),we=(0,c.$ue)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f36df69328ed10f76d4be03e8a82b61794b49711/core/vs/code/electron-main/main.js.map
