/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/lazy","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(le){for(var t=[],y=0,O=le.length;y<O;y++)t[y]=be[le[y]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:jt,isFrozen:Qt,getPrototypeOf:Yt,getOwnPropertyDescriptor:Xt}=Object;let{freeze:tt,seal:ht,create:Zt}=Object,{apply:Ot,construct:Nt}=typeof Reflect<"u"&&Reflect;Ot||(Ot=function(t,y,O){return t.apply(y,O)}),tt||(tt=function(t){return t}),ht||(ht=function(t){return t}),Nt||(Nt=function(t,y){return new t(...y)});const Jt=rt(Array.prototype.forEach),zt=rt(Array.prototype.pop),mt=rt(Array.prototype.push),wt=rt(String.prototype.toLowerCase),Ft=rt(String.prototype.toString),ei=rt(String.prototype.match),ut=rt(String.prototype.replace),ti=rt(String.prototype.indexOf),ii=rt(String.prototype.trim),st=rt(RegExp.prototype.test),bt=ni(TypeError);function rt(le){return function(t){for(var y=arguments.length,O=new Array(y>1?y-1:0),i=1;i<y;i++)O[i-1]=arguments[i];return Ot(le,t,O)}}function ni(le){return function(){for(var t=arguments.length,y=new Array(t),O=0;O<t;O++)y[O]=arguments[O];return Nt(le,y)}}function Be(le,t,y){var O;y=(O=y)!==null&&O!==void 0?O:wt,jt&&jt(le,null);let i=t.length;for(;i--;){let _=t[i];if(typeof _=="string"){const D=y(_);D!==_&&(Qt(t)||(t[i]=D),_=D)}le[_]=!0}return le}function gt(le){const t=Zt(null);for(const[y,O]of Bt(le))t[y]=O;return t}function vt(le,t){for(;le!==null;){const O=Xt(le,t);if(O){if(O.get)return rt(O.get);if(typeof O.value=="function")return rt(O.value)}le=Yt(le)}function y(O){return console.warn("fallback value for",O),null}return y}const Ht=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Pt=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),si=tt(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Tt=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ri=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=tt(["#text"]),Wt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),oi=ht(/\{\{[\w\W]*|[\w\W]*\}\}/gm),li=ht(/<%[\w\W]*|[\w\W]*%>/gm),ai=ht(/\${[\w\W]*}/gm),hi=ht(/^data-[\-\w.\u00B7-\uFFFF]/),ui=ht(/^aria-[\-\w]+$/),qt=ht(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ci=ht(/^(?:\w+script|data):/i),fi=ht(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=ht(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:oi,ERB_EXPR:li,TMPLIT_EXPR:ai,DATA_ATTR:hi,ARIA_ATTR:ui,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:ci,ATTR_WHITESPACE:fi,DOCTYPE_NAME:Vt});const di=()=>typeof window>"u"?null:window,gi=function(t,y){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let O=null;const i="data-tt-policy-suffix";y&&y.hasAttribute(i)&&(O=y.getAttribute(i));const _="dompurify"+(O?"#"+O:"");try{return t.createPolicy(_,{createHTML(D){return D},createScriptURL(D){return D}})}catch{return console.warn("TrustedTypes policy "+_+" could not be created."),null}};function Kt(){let le=arguments.length>0&&arguments[0]!==void 0?arguments[0]:di();const t=Le=>Kt(Le);if(t.version="3.0.5",t.removed=[],!le||!le.document||le.document.nodeType!==9)return t.isSupported=!1,t;const y=le.document,O=y.currentScript;let{document:i}=le;const{DocumentFragment:_,HTMLTemplateElement:D,Node:w,Element:l,NodeFilter:u,NamedNodeMap:f=le.NamedNodeMap||le.MozNamedAttrMap,HTMLFormElement:P,DOMParser:r,trustedTypes:h}=le,e=l.prototype,a=vt(e,"cloneNode"),o=vt(e,"nextSibling"),s=vt(e,"childNodes"),n=vt(e,"parentNode");if(typeof D=="function"){const Le=i.createElement("template");Le.content&&Le.content.ownerDocument&&(i=Le.content.ownerDocument)}let g,b="";const{implementation:$,createNodeIterator:c,createDocumentFragment:F,getElementsByTagName:R}=i,{importNode:T}=y;let m={};t.isSupported=typeof Bt=="function"&&typeof n=="function"&&$&&$.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:z,TMPLIT_EXPR:U,DATA_ATTR:M,ARIA_ATTR:A,IS_SCRIPT_OR_DATA:H,ATTR_WHITESPACE:Q}=xt;let{IS_ALLOWED_URI:ie}=xt,re=null;const ue=Be({},[...Ht,...Pt,...Lt,...Tt,...Ut]);let he=null;const oe=Be({},[...Wt,...It,..._t,...Dt]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ce=null,Se=null,Re=!0,fe=!0,ne=!1,G=!0,V=!1,ee=!1,Z=!1,C=!1,x=!1,d=!1,p=!1,E=!0,I=!1;const N="user-content-";let B=!0,q=!1,L={},j=null;const S=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let k=null;const W=Be({},["audio","video","img","source","image","track"]);let K=null;const te=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",me="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml";let Ne=we,Ee=!1,ve=null;const Te=Be({},[se,me,we],Ft);let Pe;const qe=["application/xhtml+xml","text/html"],je="text/html";let Ie,Ge=null;const Y=i.createElement("form"),ae=function(ce){return ce instanceof RegExp||ce instanceof Function},$e=function(ce){if(!(Ge&&Ge===ce)){if((!ce||typeof ce!="object")&&(ce={}),ce=gt(ce),Pe=qe.indexOf(ce.PARSER_MEDIA_TYPE)===-1?Pe=je:Pe=ce.PARSER_MEDIA_TYPE,Ie=Pe==="application/xhtml+xml"?Ft:wt,re="ALLOWED_TAGS"in ce?Be({},ce.ALLOWED_TAGS,Ie):ue,he="ALLOWED_ATTR"in ce?Be({},ce.ALLOWED_ATTR,Ie):oe,ve="ALLOWED_NAMESPACES"in ce?Be({},ce.ALLOWED_NAMESPACES,Ft):Te,K="ADD_URI_SAFE_ATTR"in ce?Be(gt(te),ce.ADD_URI_SAFE_ATTR,Ie):te,k="ADD_DATA_URI_TAGS"in ce?Be(gt(W),ce.ADD_DATA_URI_TAGS,Ie):W,j="FORBID_CONTENTS"in ce?Be({},ce.FORBID_CONTENTS,Ie):S,Ce="FORBID_TAGS"in ce?Be({},ce.FORBID_TAGS,Ie):{},Se="FORBID_ATTR"in ce?Be({},ce.FORBID_ATTR,Ie):{},L="USE_PROFILES"in ce?ce.USE_PROFILES:!1,Re=ce.ALLOW_ARIA_ATTR!==!1,fe=ce.ALLOW_DATA_ATTR!==!1,ne=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,G=ce.ALLOW_SELF_CLOSE_IN_ATTR!==!1,V=ce.SAFE_FOR_TEMPLATES||!1,ee=ce.WHOLE_DOCUMENT||!1,x=ce.RETURN_DOM||!1,d=ce.RETURN_DOM_FRAGMENT||!1,p=ce.RETURN_TRUSTED_TYPE||!1,C=ce.FORCE_BODY||!1,E=ce.SANITIZE_DOM!==!1,I=ce.SANITIZE_NAMED_PROPS||!1,B=ce.KEEP_CONTENT!==!1,q=ce.IN_PLACE||!1,ie=ce.ALLOWED_URI_REGEXP||qt,Ne=ce.NAMESPACE||we,ge=ce.CUSTOM_ELEMENT_HANDLING||{},ce.CUSTOM_ELEMENT_HANDLING&&ae(ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&ae(ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&typeof ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),V&&(fe=!1),d&&(x=!0),L&&(re=Be({},[...Ut]),he=[],L.html===!0&&(Be(re,Ht),Be(he,Wt)),L.svg===!0&&(Be(re,Pt),Be(he,It),Be(he,Dt)),L.svgFilters===!0&&(Be(re,Lt),Be(he,It),Be(he,Dt)),L.mathMl===!0&&(Be(re,Tt),Be(he,_t),Be(he,Dt))),ce.ADD_TAGS&&(re===ue&&(re=gt(re)),Be(re,ce.ADD_TAGS,Ie)),ce.ADD_ATTR&&(he===oe&&(he=gt(he)),Be(he,ce.ADD_ATTR,Ie)),ce.ADD_URI_SAFE_ATTR&&Be(K,ce.ADD_URI_SAFE_ATTR,Ie),ce.FORBID_CONTENTS&&(j===S&&(j=gt(j)),Be(j,ce.FORBID_CONTENTS,Ie)),B&&(re["#text"]=!0),ee&&Be(re,["html","head","body"]),re.table&&(Be(re,["tbody"]),delete Ce.tbody),ce.TRUSTED_TYPES_POLICY){if(typeof ce.TRUSTED_TYPES_POLICY.createHTML!="function")throw bt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ce.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw bt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');g=ce.TRUSTED_TYPES_POLICY,b=g.createHTML("")}else g===void 0&&(g=gi(h,O)),g!==null&&typeof b=="string"&&(b=g.createHTML(""));tt&&tt(ce),Ge=ce}},De=Be({},["mi","mo","mn","ms","mtext"]),Oe=Be({},["foreignobject","desc","title","annotation-xml"]),Me=Be({},["title","style","font","a","script"]),ze=Be({},Pt);Be(ze,Lt),Be(ze,si);const Qe=Be({},Tt);Be(Qe,ri);const Ye=function(ce){let ye=n(ce);(!ye||!ye.tagName)&&(ye={namespaceURI:Ne,tagName:"template"});const ke=wt(ce.tagName),Ue=wt(ye.tagName);return ve[ce.namespaceURI]?ce.namespaceURI===me?ye.namespaceURI===we?ke==="svg":ye.namespaceURI===se?ke==="svg"&&(Ue==="annotation-xml"||De[Ue]):!!ze[ke]:ce.namespaceURI===se?ye.namespaceURI===we?ke==="math":ye.namespaceURI===me?ke==="math"&&Oe[Ue]:!!Qe[ke]:ce.namespaceURI===we?ye.namespaceURI===me&&!Oe[Ue]||ye.namespaceURI===se&&!De[Ue]?!1:!Qe[ke]&&(Me[ke]||!ze[ke]):!!(Pe==="application/xhtml+xml"&&ve[ce.namespaceURI]):!1},Ve=function(ce){mt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{ce.remove()}},We=function(ce,ye){try{mt(t.removed,{attribute:ye.getAttributeNode(ce),from:ye})}catch{mt(t.removed,{attribute:null,from:ye})}if(ye.removeAttribute(ce),ce==="is"&&!he[ce])if(x||d)try{Ve(ye)}catch{}else try{ye.setAttribute(ce,"")}catch{}},et=function(ce){let ye,ke;if(C)ce="<remove></remove>"+ce;else{const nt=ei(ce,/^[\r\n\t ]+/);ke=nt&&nt[0]}Pe==="application/xhtml+xml"&&Ne===we&&(ce='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ce+"</body></html>");const Ue=g?g.createHTML(ce):ce;if(Ne===we)try{ye=new r().parseFromString(Ue,Pe)}catch{}if(!ye||!ye.documentElement){ye=$.createDocument(Ne,"template",null);try{ye.documentElement.innerHTML=Ee?b:Ue}catch{}}const Xe=ye.body||ye.documentElement;return ce&&ke&&Xe.insertBefore(i.createTextNode(ke),Xe.childNodes[0]||null),Ne===we?R.call(ye,ee?"html":"body")[0]:ee?ye.documentElement:Xe},it=function(ce){return c.call(ce.ownerDocument||ce,ce,u.SHOW_ELEMENT|u.SHOW_COMMENT|u.SHOW_TEXT,null,!1)},ft=function(ce){return ce instanceof P&&(typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof f)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"||typeof ce.hasChildNodes!="function")},ct=function(ce){return typeof w=="object"?ce instanceof w:ce&&typeof ce=="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},ot=function(ce,ye,ke){m[ce]&&Jt(m[ce],Ue=>{Ue.call(t,ye,ke,Ge)})},yt=function(ce){let ye;if(ot("beforeSanitizeElements",ce,null),ft(ce))return Ve(ce),!0;const ke=Ie(ce.nodeName);if(ot("uponSanitizeElement",ce,{tagName:ke,allowedTags:re}),ce.hasChildNodes()&&!ct(ce.firstElementChild)&&(!ct(ce.content)||!ct(ce.content.firstElementChild))&&st(/<[/\w]/g,ce.innerHTML)&&st(/<[/\w]/g,ce.textContent))return Ve(ce),!0;if(!re[ke]||Ce[ke]){if(!Ce[ke]&&At(ke)&&(ge.tagNameCheck instanceof RegExp&&st(ge.tagNameCheck,ke)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ke)))return!1;if(B&&!j[ke]){const Ue=n(ce)||ce.parentNode,Xe=s(ce)||ce.childNodes;if(Xe&&Ue){const nt=Xe.length;for(let xe=nt-1;xe>=0;--xe)Ue.insertBefore(a(Xe[xe],!0),o(ce))}}return Ve(ce),!0}return ce instanceof l&&!Ye(ce)||(ke==="noscript"||ke==="noembed"||ke==="noframes")&&st(/<\/no(script|embed|frames)/i,ce.innerHTML)?(Ve(ce),!0):(V&&ce.nodeType===3&&(ye=ce.textContent,ye=ut(ye,v," "),ye=ut(ye,z," "),ye=ut(ye,U," "),ce.textContent!==ye&&(mt(t.removed,{element:ce.cloneNode()}),ce.textContent=ye)),ot("afterSanitizeElements",ce,null),!1)},Et=function(ce,ye,ke){if(E&&(ye==="id"||ye==="name")&&(ke in i||ke in Y))return!1;if(!(fe&&!Se[ye]&&st(M,ye))){if(!(Re&&st(A,ye))){if(!he[ye]||Se[ye]){if(!(At(ce)&&(ge.tagNameCheck instanceof RegExp&&st(ge.tagNameCheck,ce)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ce))&&(ge.attributeNameCheck instanceof RegExp&&st(ge.attributeNameCheck,ye)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(ye))||ye==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&st(ge.tagNameCheck,ke)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ke))))return!1}else if(!K[ye]){if(!st(ie,ut(ke,Q,""))){if(!((ye==="src"||ye==="xlink:href"||ye==="href")&&ce!=="script"&&ti(ke,"data:")===0&&k[ce])){if(!(ne&&!st(H,ut(ke,Q,"")))){if(ke)return!1}}}}}}return!0},At=function(ce){return ce.indexOf("-")>0},kt=function(ce){let ye,ke,Ue,Xe;ot("beforeSanitizeAttributes",ce,null);const{attributes:nt}=ce;if(!nt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:he};for(Xe=nt.length;Xe--;){ye=nt[Xe];const{name:lt,namespaceURI:$t}=ye;if(ke=lt==="value"?ye.value:ii(ye.value),Ue=Ie(lt),xe.attrName=Ue,xe.attrValue=ke,xe.keepAttr=!0,xe.forceKeepAttr=void 0,ot("uponSanitizeAttribute",ce,xe),ke=xe.attrValue,xe.forceKeepAttr||(We(lt,ce),!xe.keepAttr))continue;if(!G&&st(/\/>/i,ke)){We(lt,ce);continue}V&&(ke=ut(ke,v," "),ke=ut(ke,z," "),ke=ut(ke,U," "));const Ct=Ie(ce.nodeName);if(Et(Ct,Ue,ke)){if(I&&(Ue==="id"||Ue==="name")&&(We(lt,ce),ke=N+ke),g&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!$t)switch(h.getAttributeType(Ct,Ue)){case"TrustedHTML":{ke=g.createHTML(ke);break}case"TrustedScriptURL":{ke=g.createScriptURL(ke);break}}try{$t?ce.setAttributeNS($t,lt,ke):ce.setAttribute(lt,ke),zt(t.removed)}catch{}}}ot("afterSanitizeAttributes",ce,null)},Rt=function Le(ce){let ye;const ke=it(ce);for(ot("beforeSanitizeShadowDOM",ce,null);ye=ke.nextNode();)ot("uponSanitizeShadowNode",ye,null),!yt(ye)&&(ye.content instanceof _&&Le(ye.content),kt(ye));ot("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Le){let ce=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ye,ke,Ue,Xe;if(Ee=!Le,Ee&&(Le="<!-->"),typeof Le!="string"&&!ct(Le))if(typeof Le.toString=="function"){if(Le=Le.toString(),typeof Le!="string")throw bt("dirty is not a string, aborting")}else throw bt("toString is not a function");if(!t.isSupported)return Le;if(Z||$e(ce),t.removed=[],typeof Le=="string"&&(q=!1),q){if(Le.nodeName){const lt=Ie(Le.nodeName);if(!re[lt]||Ce[lt])throw bt("root node is forbidden and cannot be sanitized in-place")}}else if(Le instanceof w)ye=et("<!---->"),ke=ye.ownerDocument.importNode(Le,!0),ke.nodeType===1&&ke.nodeName==="BODY"||ke.nodeName==="HTML"?ye=ke:ye.appendChild(ke);else{if(!x&&!V&&!ee&&Le.indexOf("<")===-1)return g&&p?g.createHTML(Le):Le;if(ye=et(Le),!ye)return x?null:p?b:""}ye&&C&&Ve(ye.firstChild);const nt=it(q?Le:ye);for(;Ue=nt.nextNode();)yt(Ue)||(Ue.content instanceof _&&Rt(Ue.content),kt(Ue));if(q)return Le;if(x){if(d)for(Xe=F.call(ye.ownerDocument);ye.firstChild;)Xe.appendChild(ye.firstChild);else Xe=ye;return(he.shadowroot||he.shadowrootmode)&&(Xe=T.call(y,Xe,!0)),Xe}let xe=ee?ye.outerHTML:ye.innerHTML;return ee&&re["!doctype"]&&ye.ownerDocument&&ye.ownerDocument.doctype&&ye.ownerDocument.doctype.name&&st(Vt,ye.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+ye.ownerDocument.doctype.name+`>
`+xe),V&&(xe=ut(xe,v," "),xe=ut(xe,z," "),xe=ut(xe,U," ")),g&&p?g.createHTML(xe):xe},t.setConfig=function(Le){$e(Le),Z=!0},t.clearConfig=function(){Ge=null,Z=!1},t.isValidAttribute=function(Le,ce,ye){Ge||$e({});const ke=Ie(Le),Ue=Ie(ce);return Et(ke,Ue,ye)},t.addHook=function(Le,ce){typeof ce=="function"&&(m[Le]=m[Le]||[],mt(m[Le],ce))},t.removeHook=function(Le){if(m[Le])return zt(m[Le])},t.removeHooks=function(Le){m[Le]&&(m[Le]=[])},t.removeAllHooks=function(){m={}},t}var mi=Kt();define("vs/base/browser/dompurify/dompurify",function(){return mi}),define(be[39],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yP=t.$xP=void 0;class y{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const w=O(D);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(D){const w=O(D);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(D){const w=O(D);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(D){const w=O(D);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(D){const w=O(D);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(D){const w=O(D);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(D){const w=O(D);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(D){const w=O(D);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const w=O(D);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const w=O(D);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const w=O(D);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const w=O(D);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const w=O(D);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const w=O(D);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,w){this.domNode.classList.toggle(D,w),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,w){this.domNode.setAttribute(D,w)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}t.$xP=y;function O(_){return typeof _=="number"?`${_}px`:_}function i(_){return new y(_)}t.$yP=i}),define(be[67],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0N=t.$9N=void 0;let y=!1,O=null;function i(l){if(!l.parent||l.parent===l)return null;try{const u=l.location,f=l.parent.location;if(u.origin!=="null"&&f.origin!=="null"&&u.origin!==f.origin)return y=!0,null}catch{return y=!0,null}return l.parent}class _{static getSameOriginWindowChain(){if(!O){O=[];let u=window,f;do f=i(u),f?O.push({window:u,iframeElement:u.frameElement||null}):O.push({window:u,iframeElement:null}),u=f;while(u)}return O.slice(0)}static hasDifferentOriginAncestor(){return O||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(u,f){if(!f||u===f)return{top:0,left:0};let P=0,r=0;const h=this.getSameOriginWindowChain();for(const e of h){if(P+=e.window.scrollY,r+=e.window.scrollX,e.window===f||!e.iframeElement)break;const a=e.iframeElement.getBoundingClientRect();P+=a.top,r+=a.left}return{top:P,left:r}}}t.$9N=_;async function D(l,u){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const f=JSON.stringify({parentOrigin:l,salt:u}),r=new TextEncoder().encode(f),h=await crypto.subtle.digest("sha-256",r);return w(h)}t.$0N=D;function w(l){const f=Array.from(new Uint8Array(l)).map(P=>P.toString(16).padStart(2,"0")).join("");return BigInt(`0x${f}`).toString(32).padStart(52,"0")}}),define(be[68],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8P=t.$7P=t.$6P=t.ListDragOverEffect=void 0;var y;(function(_){_[_.Copy=0]="Copy",_[_.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.$6P={reject(){return{accept:!1}},accept(){return{accept:!0}}};class O extends Error{constructor(D,w){super(`ListError [${D}] ${w}`)}}t.$7P=O;class i{constructor(){this.c=new WeakMap}getHeight(D){return this.c.get(D)??this.d(D)}setDynamicHeight(D,w){w>0&&this.c.set(D,w)}}t.$8P=i}),define(be[69],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5P=void 0;class y{constructor(i){this.a=i}splice(i,_,D){this.a.forEach(w=>w.splice(i,_,D))}}t.$5P=y}),define(be[40],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DP=void 0;const y=20;class O{constructor(_,D,w,l,u,f){this.a=Math.round(D),this.b=Math.round(w),this.c=Math.round(_),this.d=l,this.e=u,this.f=f,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new O(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(_){const D=Math.round(_);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(_){const D=Math.round(_);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(_){const D=Math.round(_);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(_){this.a=Math.round(_)}setOppositeScrollbarSize(_){this.b=Math.round(_)}static l(_,D,w,l,u){const f=Math.max(0,w-_),P=Math.max(0,f-2*D),r=l>0&&l>w;if(!r)return{computedAvailableSize:Math.round(f),computedIsNeeded:r,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(y,Math.floor(w*P/l))),e=(P-h)/(l-w),a=u*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:r,computedSliderSize:Math.round(h),computedSliderRatio:e,computedSliderPosition:Math.round(a)}}m(){const _=O.l(this.b,this.c,this.d,this.e,this.f);this.g=_.computedAvailableSize,this.h=_.computedIsNeeded,this.i=_.computedSliderSize,this.j=_.computedSliderRatio,this.k=_.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(_){if(!this.h)return 0;const D=_-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(_){if(!this.h)return 0;const D=_-this.c;let w=this.f;return D<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(_){if(!this.h)return 0;const D=this.k+_;return Math.round(D/this.j)}}t.$DP=O}),define(be[24],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1R=t.$ZR=t.$YR=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(l){l[l.Hidden=0]="Hidden",l[l.Visible=1]="Visible",l[l.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var O;(function(l){l[l.Expanded=0]="Expanded",l[l.Collapsed=1]="Collapsed",l[l.PreserveOrExpanded=2]="PreserveOrExpanded",l[l.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(O||(t.ObjectTreeElementCollapseState=O={}));var i;(function(l){l[l.Unknown=0]="Unknown",l[l.Twistie=1]="Twistie",l[l.Element=2]="Element",l[l.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var _;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(_||(t.TreeDragOverBubble=_={})),t.$YR={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(l=!1){return{accept:!0,bubble:0,autoExpand:l}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(l=!1){return{accept:!0,bubble:0,effect:0,autoExpand:l}}};class D extends Error{constructor(u,f){super(`TreeError [${u}] ${f}`)}}t.$ZR=D;class w{constructor(u){this.a=u,this.b=new WeakMap}map(u){let f=this.b.get(u);return f||(f=this.a(u),this.b.set(u,f)),f}}t.$1R=w}),define(be[70],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;function y(a,o,s){const n=O(a,o);if(n!==-1)return a[n]}t.$db=y;function O(a,o,s=a.length-1){for(let n=s;n>=0;n--){const g=a[n];if(o(g))return n}return-1}t.$eb=O;function i(a,o){const s=_(a,o);return s===-1?void 0:a[s]}t.$fb=i;function _(a,o,s=0,n=a.length){let g=s,b=n;for(;g<b;){const $=Math.floor((g+b)/2);o(a[$])?g=$+1:b=$}return g-1}t.$gb=_;function D(a,o){const s=w(a,o);return s===a.length?void 0:a[s]}t.$hb=D;function w(a,o,s=0,n=a.length){let g=s,b=n;for(;g<b;){const $=Math.floor((g+b)/2);o(a[$])?b=$:g=$+1}return g}t.$ib=w;function l(a,o,s=0,n=a.length){const g=w(a,o,s,n);return g===a.length?-1:g}t.$jb=l;class u{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(u.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!o(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const s=_(this.e,o,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}t.$kb=u;function f(a,o){if(a.length===0)return;let s=a[0];for(let n=1;n<a.length;n++){const g=a[n];o(g,s)>0&&(s=g)}return s}t.$lb=f;function P(a,o){if(a.length===0)return;let s=a[0];for(let n=1;n<a.length;n++){const g=a[n];o(g,s)>=0&&(s=g)}return s}t.$mb=P;function r(a,o){return f(a,(s,n)=>-o(s,n))}t.$nb=r;function h(a,o){if(a.length===0)return-1;let s=0;for(let n=1;n<a.length;n++){const g=a[n];o(g,a[s])>0&&(s=n)}return s}t.$ob=h;function e(a,o){for(const s of a){const n=o(s);if(n!==void 0)return n}}t.$pb=e}),define(be[41],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function y(D,w){const l=Object.create(null);for(const u of D){const f=w(u);let P=l[f];P||(P=l[f]=[]),P.push(u)}return l}t.$I=y;function O(D,w){const l=[],u=[];for(const f of D)w.has(f)||l.push(f);for(const f of w)D.has(f)||u.push(f);return{removed:l,added:u}}t.$J=O;function i(D,w){const l=[],u=[];for(const[f,P]of D)w.has(f)||l.push(P);for(const[f,P]of w)D.has(f)||u.push(P);return{removed:l,added:u}}t.$K=i;class _{constructor(){this.a=new Map}add(w,l){let u=this.a.get(w);u||(u=new Set,this.a.set(w,u)),u.add(l)}delete(w,l){const u=this.a.get(w);u&&(u.delete(l),u.size===0&&this.a.delete(w))}forEach(w,l){const u=this.a.get(w);u&&u.forEach(l)}get(w){const l=this.a.get(w);return l||new Set}}t.$L=_}),define(be[71],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=t.$Ls=t.$Ks=t.$Js=void 0;function y(w,l){const u=Math.pow(10,l);return Math.round(w*u)/u}class O{constructor(l,u,f,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=y(Math.max(Math.min(1,P),0),3)}static equals(l,u){return l.r===u.r&&l.g===u.g&&l.b===u.b&&l.a===u.a}}t.$Js=O;class i{constructor(l,u,f,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=y(Math.max(Math.min(1,u),0),3),this.l=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.l===u.l&&l.a===u.a}static fromRGBA(l){const u=l.r/255,f=l.g/255,P=l.b/255,r=l.a,h=Math.max(u,f,P),e=Math.min(u,f,P);let a=0,o=0;const s=(e+h)/2,n=h-e;if(n>0){switch(o=Math.min(s<=.5?n/(2*s):n/(2-2*s),1),h){case u:a=(f-P)/n+(f<P?6:0);break;case f:a=(P-u)/n+2;break;case P:a=(u-f)/n+4;break}a*=60,a=Math.round(a)}return new i(a,o,s,r)}static i(l,u,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?l+(u-l)*6*f:f<1/2?u:f<2/3?l+(u-l)*(2/3-f)*6:l}static toRGBA(l){const u=l.h/360,{s:f,l:P,a:r}=l;let h,e,a;if(f===0)h=e=a=P;else{const o=P<.5?P*(1+f):P+f-P*f,s=2*P-o;h=i.i(s,o,u+1/3),e=i.i(s,o,u),a=i.i(s,o,u-1/3)}return new O(Math.round(h*255),Math.round(e*255),Math.round(a*255),r)}}t.$Ks=i;class _{constructor(l,u,f,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=y(Math.max(Math.min(1,u),0),3),this.v=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.v===u.v&&l.a===u.a}static fromRGBA(l){const u=l.r/255,f=l.g/255,P=l.b/255,r=Math.max(u,f,P),h=Math.min(u,f,P),e=r-h,a=r===0?0:e/r;let o;return e===0?o=0:r===u?o=((f-P)/e%6+6)%6:r===f?o=(P-u)/e+2:o=(u-f)/e+4,new _(Math.round(o*60),a,r,l.a)}static toRGBA(l){const{h:u,s:f,v:P,a:r}=l,h=P*f,e=h*(1-Math.abs(u/60%2-1)),a=P-h;let[o,s,n]=[0,0,0];return u<60?(o=h,s=e):u<120?(o=e,s=h):u<180?(s=h,n=e):u<240?(s=e,n=h):u<300?(o=e,n=h):u<=360&&(o=h,n=e),o=Math.round((o+a)*255),s=Math.round((s+a)*255),n=Math.round((n+a)*255),new O(o,s,n,r)}}t.$Ls=_;class D{static fromHex(l){return D.Format.CSS.parseHex(l)||D.red}static equals(l,u){return!l&&!u?!0:!l||!u?!1:l.equals(u)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:_.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof O)this.rgba=l;else if(l instanceof i)this.i=l,this.rgba=i.toRGBA(l);else if(l instanceof _)this.j=l,this.rgba=_.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&O.equals(this.rgba,l.rgba)&&i.equals(this.hsla,l.hsla)&&_.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=D.k(this.rgba.r),u=D.k(this.rgba.g),f=D.k(this.rgba.b),P=.2126*l+.7152*u+.0722*f;return y(P,4)}static k(l){const u=l/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(l){const u=this.getRelativeLuminance(),f=l.getRelativeLuminance();return u>f?(u+.05)/(f+.05):(f+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const u=this.getRelativeLuminance(),f=l.getRelativeLuminance();return u>f}isDarkerThan(l){const u=this.getRelativeLuminance(),f=l.getRelativeLuminance();return u<f}lighten(l){return new D(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new D(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:u,g:f,b:P,a:r}=this.rgba;return new D(new O(u,f,P,r*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const u=l.rgba,f=this.rgba.a,P=u.a,r=f+P*(1-f);if(r<1e-6)return D.transparent;const h=this.rgba.r*f/r+u.r*P*(1-f)/r,e=this.rgba.g*f/r+u.g*P*(1-f)/r,a=this.rgba.b*f/r+u.b*P*(1-f)/r;return new D(new O(h,e,a,r))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:u,g:f,b:P,a:r}=this.rgba;return new D(new O(l.rgba.r-r*(l.rgba.r-u),l.rgba.g-r*(l.rgba.g-f),l.rgba.b-r*(l.rgba.b-P),1))}flatten(...l){const u=l.reduceRight((f,P)=>D.o(P,f));return D.o(this,u)}static o(l,u){const f=1-l.rgba.a;return new D(new O(f*u.rgba.r+l.rgba.a*l.rgba.r,f*u.rgba.g+l.rgba.a*l.rgba.g,f*u.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(l,u,f){if(l.isLighterThan(u))return l;f=f||.5;const P=l.getRelativeLuminance(),r=u.getRelativeLuminance();return f=f*(r-P)/r,l.lighten(f)}static getDarkerColor(l,u,f){if(l.isDarkerThan(u))return l;f=f||.5;const P=l.getRelativeLuminance(),r=u.getRelativeLuminance();return f=f*(P-r)/P,l.darken(f)}static{this.white=new D(new O(255,255,255,1))}static{this.black=new D(new O(0,0,0,1))}static{this.red=new D(new O(255,0,0,1))}static{this.blue=new D(new O(0,0,255,1))}static{this.green=new D(new O(0,255,0,1))}static{this.cyan=new D(new O(0,255,255,1))}static{this.lightgrey=new D(new O(211,211,211,1))}static{this.transparent=new D(new O(0,0,0,0))}}t.$Ms=D,function(w){let l;(function(u){let f;(function(P){function r(c){return c.rgba.a===1?`rgb(${c.rgba.r}, ${c.rgba.g}, ${c.rgba.b})`:w.Format.CSS.formatRGBA(c)}P.formatRGB=r;function h(c){return`rgba(${c.rgba.r}, ${c.rgba.g}, ${c.rgba.b}, ${+c.rgba.a.toFixed(2)})`}P.formatRGBA=h;function e(c){return c.hsla.a===1?`hsl(${c.hsla.h}, ${(c.hsla.s*100).toFixed(2)}%, ${(c.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(c)}P.formatHSL=e;function a(c){return`hsla(${c.hsla.h}, ${(c.hsla.s*100).toFixed(2)}%, ${(c.hsla.l*100).toFixed(2)}%, ${c.hsla.a.toFixed(2)})`}P.formatHSLA=a;function o(c){const F=c.toString(16);return F.length!==2?"0"+F:F}function s(c){return`#${o(c.rgba.r)}${o(c.rgba.g)}${o(c.rgba.b)}`}P.formatHex=s;function n(c,F=!1){return F&&c.rgba.a===1?w.Format.CSS.formatHex(c):`#${o(c.rgba.r)}${o(c.rgba.g)}${o(c.rgba.b)}${o(Math.round(c.rgba.a*255))}`}P.formatHexA=n;function g(c){return c.isOpaque()?w.Format.CSS.formatHex(c):w.Format.CSS.formatRGBA(c)}P.format=g;function b(c){const F=c.length;if(F===0||c.charCodeAt(0)!==35)return null;if(F===7){const R=16*$(c.charCodeAt(1))+$(c.charCodeAt(2)),T=16*$(c.charCodeAt(3))+$(c.charCodeAt(4)),m=16*$(c.charCodeAt(5))+$(c.charCodeAt(6));return new w(new O(R,T,m,1))}if(F===9){const R=16*$(c.charCodeAt(1))+$(c.charCodeAt(2)),T=16*$(c.charCodeAt(3))+$(c.charCodeAt(4)),m=16*$(c.charCodeAt(5))+$(c.charCodeAt(6)),v=16*$(c.charCodeAt(7))+$(c.charCodeAt(8));return new w(new O(R,T,m,v/255))}if(F===4){const R=$(c.charCodeAt(1)),T=$(c.charCodeAt(2)),m=$(c.charCodeAt(3));return new w(new O(16*R+R,16*T+T,16*m+m))}if(F===5){const R=$(c.charCodeAt(1)),T=$(c.charCodeAt(2)),m=$(c.charCodeAt(3)),v=$(c.charCodeAt(4));return new w(new O(16*R+R,16*T+T,16*m+m,(16*v+v)/255))}return null}P.parseHex=b;function $(c){switch(c){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=u.CSS||(u.CSS={}))})(l=w.Format||(w.Format={}))}(D||(t.$Ms=D={}))}),define(be[25],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7g=t.$6g=t.$5g=void 0;function y(D){return(w,l,u)=>{let f=null,P=null;if(typeof u.value=="function"?(f="value",P=u.value):typeof u.get=="function"&&(f="get",P=u.get),!P)throw new Error("not supported");u[f]=D(P,l)}}function O(D,w,l){let u=null,f=null;if(typeof l.value=="function"?(u="value",f=l.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(u="get",f=l.get),!f)throw new Error("not supported");const P=`$memoize$${w}`;l[u]=function(...r){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,r)}),this[P]}}t.$5g=O;function i(D,w,l){return y((u,f)=>{const P=`$debounce$${f}`,r=`$debounce$result$${f}`;return function(...h){this[r]||(this[r]=l?l():void 0),clearTimeout(this[P]),w&&(this[r]=w(this[r],...h),h=[this[r]]),this[P]=setTimeout(()=>{u.apply(this,h),this[r]=l?l():void 0},D)}})}t.$6g=i;function _(D,w,l){return y((u,f)=>{const P=`$throttle$timer$${f}`,r=`$throttle$result$${f}`,h=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...a){if(this[r]||(this[r]=l?l():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),w&&(this[r]=w(this[r],...a)),this[e])return;const o=this[h]+D;o<=Date.now()?(this[h]=Date.now(),u.apply(this,[this[r]]),this[r]=l?l():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[h]=Date.now(),u.apply(this,[this[r]]),this[r]=l?l():void 0},o-Date.now()))}})}t.$7g=_}),define(be[72],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ls=void 0;class y{constructor(i,_,D,w){this.originalStart=i,this.originalLength=_,this.modifiedStart=D,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ls=y}),define(be[6],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class y{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?g.isErrorNoTelemetry(c)?new g(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(F=>{F(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}t.$U=y,t.$V=new y;function O($){t.$V.setUnexpectedErrorHandler($)}t.setUnexpectedErrorHandler=O;function i($){if(!$||typeof $!="object")return!1;const c=$;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}t.$X=i;function _($){u($)||t.$V.onUnexpectedError($)}t.$Y=_;function D($){u($)||t.$V.onUnexpectedExternalError($)}t.$Z=D;function w($){if($ instanceof Error){const{name:c,message:F}=$,R=$.stacktrace||$.stack;return{$isError:!0,name:c,message:F,stack:R,noTelemetry:g.isErrorNoTelemetry($)}}return $}t.$1=w;const l="Canceled";function u($){return $ instanceof f?!0:$ instanceof Error&&$.name===l&&$.message===l}t.$2=u;class f extends Error{constructor(){super(l),this.name=this.message}}t.$3=f;function P(){const $=new Error(l);return $.name=$.message,$}t.$4=P;function r($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}t.$5=r;function h($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}t.$6=h;class e extends TypeError{constructor(c){super(c?`${c} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$7=e;function a($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}t.$8=a;class o extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}t.$9=o;class s extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}t.$0=s;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=n;class g extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof g)return c;const F=new g;return F.message=c.message,F.stack=c.stack,F}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}t.$_=g;class b extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$ab=b}),define(be[11],pe([1,0,6,70]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.$5b=t.$4b=t.CompareResult=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.$Eb=t.$Db=t.top=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=t.$qb=void 0;function i(E,I=0){return E[E.length-(1+I)]}t.$qb=i;function _(E){if(E.length===0)throw new Error("Invalid tail call");return[E.slice(0,E.length-1),E[E.length-1]]}t.$rb=_;function D(E,I,N=(B,q)=>B===q){if(E===I)return!0;if(!E||!I||E.length!==I.length)return!1;for(let B=0,q=E.length;B<q;B++)if(!N(E[B],I[B]))return!1;return!0}t.$sb=D;function w(E,I){const N=E.length-1;I<N&&(E[I]=E[N]),E.pop()}t.$tb=w;function l(E,I,N){return u(E.length,B=>N(E[B],I))}t.$ub=l;function u(E,I){let N=0,B=E-1;for(;N<=B;){const q=(N+B)/2|0,L=I(q);if(L<0)N=q+1;else if(L>0)B=q-1;else return q}return-(N+1)}t.$vb=u;function f(E,I,N){if(E=E|0,E>=I.length)throw new TypeError("invalid index");const B=I[Math.floor(I.length*Math.random())],q=[],L=[],j=[];for(const S of I){const k=N(S,B);k<0?q.push(S):k>0?L.push(S):j.push(S)}return E<q.length?f(E,q,N):E<q.length+j.length?j[0]:f(E-(q.length+j.length),L,N)}t.$wb=f;function P(E,I){const N=[];let B;for(const q of E.slice(0).sort(I))!B||I(B[0],q)!==0?(B=[q],N.push(B)):B.push(q);return N}t.$xb=P;function*r(E,I){let N,B;for(const q of E)B!==void 0&&I(B,q)?N.push(q):(N&&(yield N),N=[q]),B=q;N&&(yield N)}t.$yb=r;function h(E,I){for(let N=0;N<=E.length;N++)I(N===0?void 0:E[N-1],N===E.length?void 0:E[N])}t.$zb=h;function e(E,I,N){const B=[];function q(S,k,W){if(k===0&&W.length===0)return;const K=B[B.length-1];K&&K.start+K.deleteCount===S?(K.deleteCount+=k,K.toInsert.push(...W)):B.push({start:S,deleteCount:k,toInsert:W})}let L=0,j=0;for(;;){if(L===E.length){q(L,0,I.slice(j));break}if(j===I.length){q(L,E.length-L,[]);break}const S=E[L],k=I[j],W=N(S,k);W===0?(L+=1,j+=1):W<0?(q(L,1,[]),L+=1):W>0&&(q(L,0,[k]),j+=1)}return B}t.$Ab=e;function a(E,I,N){const B=e(E,I,N),q=[],L=[];for(const j of B)q.push(...E.slice(j.start,j.start+j.deleteCount)),L.push(...j.toInsert);return{removed:q,added:L}}t.$Bb=a;function o(E,I,N){if(N===0)return[];const B=E.slice(0,N).sort(I);return n(E,I,B,N,E.length),B}t.top=o;function s(E,I,N,B,q){return N===0?Promise.resolve([]):new Promise((L,j)=>{(async()=>{const S=E.length,k=E.slice(0,N).sort(I);for(let W=N,K=Math.min(N+B,S);W<S;W=K,K=Math.min(K+B,S)){if(W>N&&await new Promise(te=>setTimeout(te)),q&&q.isCancellationRequested)throw new y.$3;n(E,I,k,W,K)}return k})().then(L,j)})}t.$Db=s;function n(E,I,N,B,q){for(const L=N.length;B<q;B++){const j=E[B];if(I(j,N[L-1])<0){N.pop();const S=(0,O.$ib)(N,k=>I(j,k)<0);N.splice(S,0,j)}}}function g(E){return E.filter(I=>!!I)}t.$Eb=g;function b(E){let I=0;for(let N=0;N<E.length;N++)E[N]&&(E[I]=E[N],I+=1);E.length=I}t.$Fb=b;function $(E,I,N){E.splice(N,0,E.splice(I,1)[0])}t.$Gb=$;function c(E){return!Array.isArray(E)||E.length===0}t.$Hb=c;function F(E){return Array.isArray(E)&&E.length>0}t.$Ib=F;function R(E,I=N=>N){const N=new Set;return E.filter(B=>{const q=I(B);return N.has(q)?!1:(N.add(q),!0)})}t.$Jb=R;function T(E){const I=new Set;return N=>{const B=E(N);return I.has(B)?!1:(I.add(B),!0)}}t.$Kb=T;function m(E,I){return E.length>0?E[0]:I}t.$Lb=m;function v(E,I){return E.length>0?E[E.length-1]:I}t.$Mb=v;function z(E,I,N=(B,q)=>B===q){let B=0;for(let q=0,L=Math.min(E.length,I.length);q<L&&N(E[q],I[q]);q++)B++;return B}t.$Nb=z;function U(E){return[].concat(...E)}t.$Ob=U;function M(E,I){let N=typeof I=="number"?E:0;typeof I=="number"?N=E:(N=0,I=E);const B=[];if(N<=I)for(let q=N;q<I;q++)B.push(q);else for(let q=N;q>I;q--)B.push(q);return B}t.$Pb=M;function A(E,I,N){return E.reduce((B,q)=>(B[I(q)]=N?N(q):q,B),Object.create(null))}t.$Qb=A;function H(E,I){return E.push(I),()=>Q(E,I)}t.$Rb=H;function Q(E,I){const N=E.indexOf(I);if(N>-1)return E.splice(N,1),I}t.$Sb=Q;function ie(E,I,N){const B=E.slice(0,I),q=E.slice(I);return B.concat(N,q)}t.$Tb=ie;function re(E,I){let N;if(typeof I=="number"){let B=I;N=()=>{const q=Math.sin(B++)*179426549;return q-Math.floor(q)}}else N=Math.random;for(let B=E.length-1;B>0;B-=1){const q=Math.floor(N()*(B+1)),L=E[B];E[B]=E[q],E[q]=L}}t.$Ub=re;function ue(E,I){const N=E.indexOf(I);N>-1&&(E.splice(N,1),E.unshift(I))}t.$Vb=ue;function he(E,I){const N=E.indexOf(I);N>-1&&(E.splice(N,1),E.push(I))}t.$Wb=he;function oe(E,I){for(const N of I)E.push(N)}t.$Xb=oe;function ge(E,I){return Array.isArray(E)?E.map(I):I(E)}t.$Yb=ge;function Ce(E){return Array.isArray(E)?E:[E]}t.$Zb=Ce;function Se(E){return E[Math.floor(Math.random()*E.length)]}t.$1b=Se;function Re(E,I,N){const B=ne(E,I),q=E.length,L=N.length;E.length=q+L;for(let j=q-1;j>=B;j--)E[j+L]=E[j];for(let j=0;j<L;j++)E[j+B]=N[j]}t.$2b=Re;function fe(E,I,N,B){const q=ne(E,I);let L=E.splice(q,N);return L===void 0&&(L=[]),Re(E,q,B),L}t.$3b=fe;function ne(E,I){return I<0?Math.max(I+E.length,0):Math.min(I,E.length)}var G;(function(E){function I(L){return L<0}E.isLessThan=I;function N(L){return L<=0}E.isLessThanOrEqual=N;function B(L){return L>0}E.isGreaterThan=B;function q(L){return L===0}E.isNeitherLessOrGreaterThan=q,E.greaterThan=1,E.lessThan=-1,E.neitherLessOrGreaterThan=0})(G||(t.CompareResult=G={}));function V(E,I){return(N,B)=>I(E(N),E(B))}t.$4b=V;function ee(...E){return(I,N)=>{for(const B of E){const q=B(I,N);if(!G.isNeitherLessOrGreaterThan(q))return q}return G.neitherLessOrGreaterThan}}t.$5b=ee;const Z=(E,I)=>E-I;t.$6b=Z;const C=(E,I)=>(0,t.$6b)(E?1:0,I?1:0);t.$7b=C;function x(E){return(I,N)=>-E(I,N)}t.$8b=x;class d{constructor(I){this.g=I,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(I){let N=this.c;for(;N<this.g.length&&I(this.g[N]);)N++;const B=N===this.c?null:this.g.slice(this.c,N);return this.c=N,B}takeFromEndWhile(I){let N=this.d;for(;N>=0&&I(this.g[N]);)N--;const B=N===this.d?null:this.g.slice(N+1,this.d+1);return this.d=N,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const I=this.g[this.c];return this.c++,I}removeLast(){const I=this.g[this.d];return this.d--,I}takeCount(I){const N=this.g.slice(this.c,this.c+I);return this.c+=I,N}}t.$9b=d;class p{static{this.empty=new p(I=>{})}constructor(I){this.iterate=I}forEach(I){this.iterate(N=>(I(N),!0))}toArray(){const I=[];return this.iterate(N=>(I.push(N),!0)),I}filter(I){return new p(N=>this.iterate(B=>I(B)?N(B):!0))}map(I){return new p(N=>this.iterate(B=>N(I(B))))}some(I){let N=!1;return this.iterate(B=>(N=I(B),!N)),N}findFirst(I){let N;return this.iterate(B=>I(B)?(N=B,!1):!0),N}findLast(I){let N;return this.iterate(B=>(I(B)&&(N=B),!0)),N}findLastMaxBy(I){let N,B=!0;return this.iterate(q=>((B||G.isGreaterThan(I(q,N)))&&(B=!1,N=q),!0)),N}}t.$0b=p}),define(be[73],pe([1,0,6]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xc=t.$wc=t.$vc=t.$uc=t.ok=void 0;function O(l,u){if(!l)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}t.ok=O;function i(l,u="Unreachable"){throw new Error(u)}t.$uc=i;function _(l){if(!l)throw new y.$ab("Assertion Failed")}t.$vc=_;function D(l){if(!l()){debugger;l(),(0,y.$Y)(new y.$ab("Assertion Failed"))}}t.$wc=D;function w(l,u){let f=0;for(;f<l.length-1;){const P=l[f],r=l[f+1];if(!u(P,r))return!1;f++}return!0}t.$xc=w}),define(be[42],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function y(O){const i=this;let _=!1,D;return function(){return _||(_=!0,D=O.apply(i,arguments)),D}}t.$bb=y}),define(be[74],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2L=t.$1L=void 0;class y{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$1L=y,t.$2L=new y("id#")}),define(be[26],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(O){function i(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}O.is=i;const _=Object.freeze([]);function D(){return _}O.empty=D;function*w(b){yield b}O.single=w;function l(b){return i(b)?b:w(b)}O.wrap=l;function u(b){return b||_}O.from=u;function f(b){return!b||b[Symbol.iterator]().next().done===!0}O.isEmpty=f;function P(b){return b[Symbol.iterator]().next().value}O.first=P;function r(b,$){for(const c of b)if($(c))return!0;return!1}O.some=r;function h(b,$){for(const c of b)if($(c))return c}O.find=h;function*e(b,$){for(const c of b)$(c)&&(yield c)}O.filter=e;function*a(b,$){let c=0;for(const F of b)yield $(F,c++)}O.map=a;function*o(...b){for(const $ of b)for(const c of $)yield c}O.concat=o;function s(b,$,c){let F=c;for(const R of b)F=$(F,R);return F}O.reduce=s;function*n(b,$,c=b.length){for($<0&&($+=b.length),c<0?c+=b.length:c>b.length&&(c=b.length);$<c;$++)yield b[$]}O.slice=n;function g(b,$=Number.POSITIVE_INFINITY){const c=[];if($===0)return[c,b];const F=b[Symbol.iterator]();for(let R=0;R<$;R++){const T=F.next();if(T.done)return[c,O.empty()];c.push(T.value)}return[c,{[Symbol.iterator](){return F}}]}O.consume=g})(y||(t.Iterable=y={}))}),define(be[43],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tq=t.KeyMod=t.KeyCodeUtils=t.$sq=t.$rq=t.$qq=t.$pq=t.$oq=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var O;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(O||(t.ScanCode=O={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,o){this._keyCodeToStr[a]=o,this._strToKeyCode[o.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const _=new i,D=new i,w=new i;t.$oq=new Array(230),t.$pq={};const l=[],u=Object.create(null),f=Object.create(null);t.$qq={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>u[e]||0,toString:e=>l[e]||"None"},t.$rq=[],t.$sq=[];for(let e=0;e<=193;e++)t.$rq[e]=-1;for(let e=0;e<=132;e++)t.$sq[e]=-1;(function(){const e="",a=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],s=[];for(const n of a){const[g,b,$,c,F,R,T,m,v]=n;if(s[b]||(s[b]=!0,l[b]=$,u[$]=b,f[$.toLowerCase()]=b,g&&(t.$rq[b]=c,c!==0&&c!==3&&c!==5&&c!==4&&c!==6&&c!==57&&(t.$sq[c]=b))),!o[c]){if(o[c]=!0,!F)throw new Error(`String representation missing for key code ${c} around scan code ${$}`);_.define(c,F),D.define(c,m||F),w.define(c,v||m||F)}R&&(t.$oq[R]=c),T&&(t.$pq[T]=c)}t.$sq[3]=46})();var P;(function(e){function a($){return _.keyCodeToStr($)}e.toString=a;function o($){return _.strToKeyCode($)}e.fromString=o;function s($){return D.keyCodeToStr($)}e.toUserSettingsUS=s;function n($){return w.keyCodeToStr($)}e.toUserSettingsGeneral=n;function g($){return D.strToKeyCode($)||w.strToKeyCode($)}e.fromUserSettings=g;function b($){if($>=98&&$<=113)return null;switch($){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return _.keyCodeToStr($)}e.toElectronAccelerator=b})(P||(t.KeyCodeUtils=P={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function h(e,a){const o=(a&65535)<<16>>>0;return(e|o)>>>0}t.$tq=h}),define(be[75],pe([1,0,6]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aq=t.$zq=t.$yq=t.$xq=t.$wq=t.$vq=t.$uq=void 0;var O;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(O||(O={}));function i(P,r){if(typeof P=="number"){if(P===0)return null;const h=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new l([_(h,r),_(e,r)]):new l([_(h,r)])}else{const h=[];for(let e=0;e<P.length;e++)h.push(_(P[e],r));return new l(h)}}t.$uq=i;function _(P,r){const h=!!(P&2048),e=!!(P&256),a=r===2?e:h,o=!!(P&1024),s=!!(P&512),n=r===2?h:e,g=P&255;return new D(a,o,s,n,g)}t.$vq=_;class D{constructor(r,h,e,a,o){this.ctrlKey=r,this.shiftKey=h,this.altKey=e,this.metaKey=a,this.keyCode=o}equals(r){return r instanceof D&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`K${r}${h}${e}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new l([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$wq=D;class w{constructor(r,h,e,a,o){this.ctrlKey=r,this.shiftKey=h,this.altKey=e,this.metaKey=a,this.scanCode=o}equals(r){return r instanceof w&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`S${r}${h}${e}${a}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$xq=w;class l{constructor(r){if(r.length===0)throw(0,y.$5)("chords");this.chords=r}getHashCode(){let r="";for(let h=0,e=this.chords.length;h<e;h++)h!==0&&(r+=";"),r+=this.chords[h].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(r.chords[h]))return!1;return!0}}t.$yq=l;class u{constructor(r,h,e,a,o,s){this.ctrlKey=r,this.shiftKey=h,this.altKey=e,this.metaKey=a,this.keyLabel=o,this.keyAriaLabel=s}}t.$zq=u;class f{}t.$Aq=f}),define(be[30],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class y{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=y}),define(be[2],pe([1,0,11,41,42,26]),function(le,t,y,O,i,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.$bc=t.$ac=t.$_b=t.$$b=void 0;const D=!1;let w=null;class l{constructor(){this.b=new Map}static{this.a=0}c(A){let H=this.b.get(A);return H||(H={parent:null,source:null,isSingleton:!1,value:A,idx:l.a++},this.b.set(A,H)),H}trackDisposable(A){const H=this.c(A);H.source||(H.source=new Error().stack)}setParent(A,H){const Q=this.c(A);Q.parent=H}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,H){const Q=H.get(A);if(Q)return Q;const ie=A.parent?this.f(this.c(A.parent),H):A;return H.set(A,ie),ie}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,Q])=>Q.source!==null&&!this.f(Q,A).isSingleton).map(([Q])=>Q).flat()}computeLeakingDisposables(A=10,H){let Q;if(H)Q=H;else{const oe=new Map,ge=[...this.b.values()].filter(Se=>Se.source!==null&&!this.f(Se,oe).isSingleton);if(ge.length===0)return;const Ce=new Set(ge.map(Se=>Se.value));if(Q=ge.filter(Se=>!(Se.parent&&Ce.has(Se.parent))),Q.length===0)throw new Error("There are cyclic diposable chains!")}if(!Q)return;function ie(oe){function ge(Se,Re){for(;Se.length>0&&Re.some(fe=>typeof fe=="string"?fe===Se[0]:Se[0].match(fe));)Se.shift()}const Ce=oe.source.split(`
`).map(Se=>Se.trim().replace("at ","")).filter(Se=>Se!=="");return ge(Ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Ce.reverse()}const re=new O.$L;for(const oe of Q){const ge=ie(oe);for(let Ce=0;Ce<=ge.length;Ce++)re.add(ge.slice(0,Ce).join(`
`),oe)}Q.sort((0,y.$4b)(oe=>oe.idx,y.$6b));let ue="",he=0;for(const oe of Q.slice(0,A)){he++;const ge=ie(oe),Ce=[];for(let Se=0;Se<ge.length;Se++){let Re=ge[Se];Re=`(shared with ${re.get(ge.slice(0,Se+1).join(`
`)).size}/${Q.length} leaks) at ${Re}`;const ne=re.get(ge.slice(0,Se).join(`
`)),G=(0,O.$I)([...ne].map(V=>ie(V)[Se]),V=>V);delete G[ge[Se]];for(const[V,ee]of Object.entries(G))Ce.unshift(`    - stacktraces of ${ee.length} other leaks continue with ${V}`);Ce.unshift(Re)}ue+=`


==================== Leaking disposable ${he}/${Q.length}: ${oe.value.constructor.name} ====================
${Ce.join(`
`)}
============================================================

`}return Q.length>A&&(ue+=`


... and ${Q.length-A} more leaking disposables

`),{leaks:Q,details:ue}}}t.$$b=l;function u(M){w=M}if(t.$_b=u,D){const M="__is_disposable_tracked__";u(new class{trackDisposable(A){const H=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[M]||console.log(H)},3e3)}setParent(A,H){if(A&&A!==$.None)try{A[M]=!0}catch{}}markAsDisposed(A){if(A&&A!==$.None)try{A[M]=!0}catch{}}markAsSingleton(A){}})}function f(M){return w?.trackDisposable(M),M}t.$ac=f;function P(M){w?.markAsDisposed(M)}t.$bc=P;function r(M,A){w?.setParent(M,A)}function h(M,A){if(w)for(const H of M)w.setParent(H,A)}function e(M){return w?.markAsSingleton(M),M}t.$cc=e;function a(M){return typeof M.dispose=="function"&&M.dispose.length===0}t.$dc=a;function o(M){if(_.Iterable.is(M)){const A=[];for(const H of M)if(H)try{H.dispose()}catch(Q){A.push(Q)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(M)?[]:M}else if(M)return M.dispose(),M}t.$ec=o;function s(M){for(const A of M)a(A)&&A.dispose();return[]}t.$fc=s;function n(...M){const A=g(()=>o(M));return h(M,A),A}t.$gc=n;function g(M){const A=f({dispose:(0,i.$bb)(()=>{P(A),M()})});return A}t.$hc=g;class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,f(this)}dispose(){this.g||(P(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return r(A,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}}t.$ic=b;class ${static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,f(this),r(this.q,this)}dispose(){P(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}t.$jc=$;class c{constructor(){this.b=!1,f(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&r(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,P(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&r(A,null),A}}t.$kc=c;class F{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$lc=F;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,f(this)}set(A){let H=A;return this.unset=()=>H=void 0,this.isset=()=>H!==void 0,this.dispose=()=>{H&&(H(),H=void 0,P(this))},this}}t.$mc=R;class T{constructor(){this.a=new Map}acquire(A,...H){let Q=this.a.get(A);Q||(Q={counter:0,object:this.b(A,...H)},this.a.set(A,Q));const{object:ie}=Q,re=(0,i.$bb)(()=>{--Q.counter===0&&(this.c(A,Q.object),this.a.delete(A))});return Q.counter++,{object:ie,dispose:re}}}t.$nc=T;class m{constructor(A){this.a=A}async acquire(A,...H){const Q=this.a.acquire(A,...H);try{return{object:await Q.object,dispose:()=>Q.dispose()}}catch(ie){throw Q.dispose(),ie}}}t.$oc=m;class v{constructor(A){this.object=A}dispose(){}}t.$pc=v;function z(M){const A=new b;try{M(A)}finally{A.dispose()}}t.$qc=z;class U{constructor(){this.a=new Map,this.b=!1,f(this)}dispose(){P(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,H,Q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Q||this.a.get(A)?.dispose(),this.a.set(A,H)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$rc=U}),define(be[44],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=void 0;class y{static{this.Undefined=new y(void 0)}constructor(_){this.element=_,this.next=y.Undefined,this.prev=y.Undefined}}class O{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let _=this.a;for(;_!==y.Undefined;){const D=_.next;_.prev=y.Undefined,_.next=y.Undefined,_=D}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(_){return this.d(_,!1)}push(_){return this.d(_,!0)}d(_,D){const w=new y(_);if(this.a===y.Undefined)this.a=w,this.b=w;else if(D){const u=this.b;this.b=w,w.prev=u,u.next=w}else{const u=this.a;this.a=w,w.next=u,u.prev=w}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(w))}}shift(){if(this.a!==y.Undefined){const _=this.a.element;return this.e(this.a),_}}pop(){if(this.b!==y.Undefined){const _=this.b.element;return this.e(this.b),_}}e(_){if(_.prev!==y.Undefined&&_.next!==y.Undefined){const D=_.prev;D.next=_.next,_.next.prev=D}else _.prev===y.Undefined&&_.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):_.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):_.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let _=this.a;for(;_!==y.Undefined;)yield _.element,_=_.next}}t.$sc=O}),define(be[76],pe([1,0]),function(le,t){"use strict";var y,O,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Di=t.$Ci=t.$Bi=t.$Ai=t.Touch=t.$zi=t.$yi=t.$xi=t.$wi=t.$vi=void 0;function _(o,s,n){let g=o.get(s);return g===void 0&&(g=n,o.set(s,g)),g}t.$vi=_;function D(o){const s=[];return o.forEach((n,g)=>{s.push(`${g} => ${n}`)}),`Map(${o.size}) {${s.join(", ")}}`}t.$wi=D;function w(o){const s=[];return o.forEach(n=>{s.push(n)}),`Set(${o.size}) {${s.join(", ")}}`}t.$xi=w;class l{constructor(s,n){this.uri=s,this.value=n}}class u{static{this.a=s=>s.toString()}constructor(s,n){this[y]="ResourceMap",s instanceof u?(this.b=new Map(s.b),this.c=n??u.a):(this.b=new Map,this.c=s??u.a)}set(s,n){return this.b.set(this.c(s),new l(s,n)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,n){typeof n<"u"&&(s=s.bind(n));for(const[g,b]of this.b)s(b.value,b.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}t.$yi=u;class f{constructor(s,n){this[O]="ResourceSet",!s||typeof s=="function"?this.a=new u(s):(this.a=new u(n),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,n){this.a.forEach((g,b)=>s.call(n,b,b,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$zi=f;var P;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(P||(t.Touch=P={}));class r{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,n=0){const g=this.a.get(s);if(g)return n!==0&&this.j(g,n),g.value}set(s,n,g=0){let b=this.a.get(s);if(b)b.value=n,g!==0&&this.j(b,g);else{switch(b={key:s,value:n,next:void 0,previous:void 0},g){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(s,b),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const n=this.a.get(s);if(n)return this.a.delete(s),this.i(n),this.d--,n.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,n){const g=this.e;let b=this.b;for(;b;){if(n?s.bind(n)(b.value,b.key,this):s(b.value,b.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const s=this,n=this.e;let g=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:g.key,done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return b}values(){const s=this,n=this.e;let g=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:g.value,done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return b}entries(){const s=this,n=this.e;let g=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:[g.key,g.value],done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return b}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let n=this.b,g=this.size;for(;n&&g>s;)this.a.delete(n.key),n=n.next,g--;this.b=n,this.d=g,n&&(n.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const n=s.next,g=s.previous;if(!n||!g)throw new Error("Invalid list");n.previous=g,g.next=n}s.next=void 0,s.previous=void 0,this.e++}j(s,n){if(!this.b||!this.c)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(s===this.b)return;const g=s.next,b=s.previous;s===this.c?(b.next=void 0,this.c=b):(g.previous=b,b.next=g),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(n===2){if(s===this.c)return;const g=s.next,b=s.previous;s===this.b?(g.previous=void 0,this.b=g):(g.previous=b,b.next=g),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((n,g)=>{s.push([g,n])}),s}fromJSON(s){this.clear();for(const[n,g]of s)this.set(n,g)}}t.$Ai=r;class h extends r{constructor(s,n=1){super(),this.k=s,this.l=Math.min(Math.max(0,n),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,n=2){return super.get(s,n)}peek(s){return super.get(s,0)}set(s,n){return super.set(s,n,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Bi=h;class e{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let n=this.a.get(s)||0;return n===0?!1:(n--,n===0?this.a.delete(s):this.a.set(s,n),!0)}has(s){return this.a.has(s)}}t.$Ci=e;class a{constructor(s){if(this.a=new Map,this.b=new Map,s)for(const[n,g]of s)this.set(n,g)}clear(){this.a.clear(),this.b.clear()}set(s,n){this.a.set(s,n),this.b.set(n,s)}get(s){return this.a.get(s)}getKey(s){return this.b.get(s)}delete(s){const n=this.a.get(s);return n===void 0?!1:(this.a.delete(s),this.b.delete(n),!0)}forEach(s,n){this.a.forEach((g,b)=>{s.call(n,g,b,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Di=a}),function(le,t){typeof define=="function"&&define.amd?define(be[77],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(le=typeof globalThis<"u"?globalThis:le||self,t(le.marked={}))}(this,function(le){"use strict";function t(N,B){for(var q=0;q<B.length;q++){var L=B[q];L.enumerable=L.enumerable||!1,L.configurable=!0,"value"in L&&(L.writable=!0),Object.defineProperty(N,L.key,L)}}function y(N,B,q){return B&&t(N.prototype,B),q&&t(N,q),Object.defineProperty(N,"prototype",{writable:!1}),N}function O(N,B){if(N){if(typeof N=="string")return i(N,B);var q=Object.prototype.toString.call(N).slice(8,-1);if(q==="Object"&&N.constructor&&(q=N.constructor.name),q==="Map"||q==="Set")return Array.from(N);if(q==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(q))return i(N,B)}}function i(N,B){(B==null||B>N.length)&&(B=N.length);for(var q=0,L=new Array(B);q<B;q++)L[q]=N[q];return L}function _(N,B){var q=typeof Symbol<"u"&&N[Symbol.iterator]||N["@@iterator"];if(q)return(q=q.call(N)).next.bind(q);if(Array.isArray(N)||(q=O(N))||B&&N&&typeof N.length=="number"){q&&(N=q);var L=0;return function(){return L>=N.length?{done:!0}:{done:!1,value:N[L++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=D();function w(N){le.defaults=N}var l=/[&<>"']/,u=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(B){return r[B]};function e(N,B){if(B){if(l.test(N))return N.replace(u,h)}else if(f.test(N))return N.replace(P,h);return N}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(N){return N.replace(a,function(B,q){return q=q.toLowerCase(),q==="colon"?":":q.charAt(0)==="#"?q.charAt(1)==="x"?String.fromCharCode(parseInt(q.substring(2),16)):String.fromCharCode(+q.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(N,B){N=typeof N=="string"?N:N.source,B=B||"";var q={replace:function(j,S){return S=S.source||S,S=S.replace(s,"$1"),N=N.replace(j,S),q},getRegex:function(){return new RegExp(N,B)}};return q}var g=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function $(N,B,q){if(N){var L;try{L=decodeURIComponent(o(q)).replace(g,"").toLowerCase()}catch{return null}if(L.indexOf("javascript:")===0||L.indexOf("vbscript:")===0||L.indexOf("data:")===0)return null}B&&!b.test(q)&&(q=m(B,q));try{q=encodeURI(q).replace(/%25/g,"%")}catch{return null}return q}var c={},F=/^[^:]+:\/*[^/]*$/,R=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(N,B){c[" "+N]||(F.test(N)?c[" "+N]=N+"/":c[" "+N]=M(N,"/",!0)),N=c[" "+N];var q=N.indexOf(":")===-1;return B.substring(0,2)==="//"?q?B:N.replace(R,"$1")+B:B.charAt(0)==="/"?q?B:N.replace(T,"$1")+B:N+B}var v={exec:function(){}};function z(N){for(var B=1,q,L;B<arguments.length;B++){q=arguments[B];for(L in q)Object.prototype.hasOwnProperty.call(q,L)&&(N[L]=q[L])}return N}function U(N,B){var q=N.replace(/\|/g,function(S,k,W){for(var K=!1,te=k;--te>=0&&W[te]==="\\";)K=!K;return K?"|":" |"}),L=q.split(/ \|/),j=0;if(L[0].trim()||L.shift(),L.length>0&&!L[L.length-1].trim()&&L.pop(),L.length>B)L.splice(B);else for(;L.length<B;)L.push("");for(;j<L.length;j++)L[j]=L[j].trim().replace(/\\\|/g,"|");return L}function M(N,B,q){var L=N.length;if(L===0)return"";for(var j=0;j<L;){var S=N.charAt(L-j-1);if(S===B&&!q)j++;else if(S!==B&&q)j++;else break}return N.slice(0,L-j)}function A(N,B){if(N.indexOf(B[1])===-1)return-1;for(var q=N.length,L=0,j=0;j<q;j++)if(N[j]==="\\")j++;else if(N[j]===B[0])L++;else if(N[j]===B[1]&&(L--,L<0))return j;return-1}function H(N){N&&N.sanitize&&!N.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Q(N,B){if(B<1)return"";for(var q="";B>1;)B&1&&(q+=N),B>>=1,N+=N;return q+N}function ie(N,B,q,L){var j=B.href,S=B.title?e(B.title):null,k=N[1].replace(/\\([\[\]])/g,"$1");if(N[0].charAt(0)!=="!"){L.state.inLink=!0;var W={type:"link",raw:q,href:j,title:S,text:k,tokens:L.inlineTokens(k)};return L.state.inLink=!1,W}return{type:"image",raw:q,href:j,title:S,text:e(k)}}function re(N,B){var q=N.match(/^(\s+)(?:```)/);if(q===null)return B;var L=q[1];return B.split(`
`).map(function(j){var S=j.match(/^\s+/);if(S===null)return j;var k=S[0];return k.length>=L.length?j.slice(L.length):j}).join(`
`)}var ue=function(){function N(q){this.options=q||le.defaults}var B=N.prototype;return B.space=function(L){var j=this.rules.block.newline.exec(L);if(j&&j[0].length>0)return{type:"space",raw:j[0]}},B.code=function(L){var j=this.rules.block.code.exec(L);if(j){var S=j[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:j[0],codeBlockStyle:"indented",text:this.options.pedantic?S:M(S,`
`)}}},B.fences=function(L){var j=this.rules.block.fences.exec(L);if(j){var S=j[0],k=re(S,j[3]||"");return{type:"code",raw:S,lang:j[2]?j[2].trim():j[2],text:k}}},B.heading=function(L){var j=this.rules.block.heading.exec(L);if(j){var S=j[2].trim();if(/#$/.test(S)){var k=M(S,"#");(this.options.pedantic||!k||/ $/.test(k))&&(S=k.trim())}return{type:"heading",raw:j[0],depth:j[1].length,text:S,tokens:this.lexer.inline(S)}}},B.hr=function(L){var j=this.rules.block.hr.exec(L);if(j)return{type:"hr",raw:j[0]}},B.blockquote=function(L){var j=this.rules.block.blockquote.exec(L);if(j){var S=j[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:j[0],tokens:this.lexer.blockTokens(S,[]),text:S}}},B.list=function(L){var j=this.rules.block.list.exec(L);if(j){var S,k,W,K,te,se,me,we,Ne,Ee,ve,Te,Pe=j[1].trim(),qe=Pe.length>1,je={type:"list",raw:"",ordered:qe,start:qe?+Pe.slice(0,-1):"",loose:!1,items:[]};Pe=qe?"\\d{1,9}\\"+Pe.slice(-1):"\\"+Pe,this.options.pedantic&&(Pe=qe?Pe:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");L&&(Te=!1,!(!(j=Ie.exec(L))||this.rules.block.hr.test(L)));){if(S=j[0],L=L.substring(S.length),we=j[2].split(`
`,1)[0],Ne=L.split(`
`,1)[0],this.options.pedantic?(K=2,ve=we.trimLeft()):(K=j[2].search(/[^ ]/),K=K>4?1:K,ve=we.slice(K),K+=j[1].length),se=!1,!we&&/^ *$/.test(Ne)&&(S+=Ne+`
`,L=L.substring(Ne.length+1),Te=!0),!Te)for(var Ge=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Y=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ae=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),$e=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");L&&(Ee=L.split(`
`,1)[0],we=Ee,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ae.test(we)||$e.test(we)||Ge.test(we)||Y.test(L)));){if(we.search(/[^ ]/)>=K||!we.trim())ve+=`
`+we.slice(K);else if(!se)ve+=`
`+we;else break;!se&&!we.trim()&&(se=!0),S+=Ee+`
`,L=L.substring(Ee.length+1)}je.loose||(me?je.loose=!0:/\n *\n *$/.test(S)&&(me=!0)),this.options.gfm&&(k=/^\[[ xX]\] /.exec(ve),k&&(W=k[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:S,task:!!k,checked:W,loose:!1,text:ve}),je.raw+=S}je.items[je.items.length-1].raw=S.trimRight(),je.items[je.items.length-1].text=ve.trimRight(),je.raw=je.raw.trimRight();var De=je.items.length;for(te=0;te<De;te++){this.lexer.state.top=!1,je.items[te].tokens=this.lexer.blockTokens(je.items[te].text,[]);var Oe=je.items[te].tokens.filter(function(ze){return ze.type==="space"}),Me=Oe.every(function(ze){for(var Qe=ze.raw.split(""),Ye=0,Ve=_(Qe),We;!(We=Ve()).done;){var et=We.value;if(et===`
`&&(Ye+=1),Ye>1)return!0}return!1});!je.loose&&Oe.length&&Me&&(je.loose=!0,je.items[te].loose=!0)}return je}},B.html=function(L){var j=this.rules.block.html.exec(L);if(j){var S={type:"html",raw:j[0],pre:!this.options.sanitizer&&(j[1]==="pre"||j[1]==="script"||j[1]==="style"),text:j[0]};if(this.options.sanitize){var k=this.options.sanitizer?this.options.sanitizer(j[0]):e(j[0]);S.type="paragraph",S.text=k,S.tokens=this.lexer.inline(k)}return S}},B.def=function(L){var j=this.rules.block.def.exec(L);if(j){j[3]&&(j[3]=j[3].substring(1,j[3].length-1));var S=j[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:S,raw:j[0],href:j[2],title:j[3]}}},B.table=function(L){var j=this.rules.block.table.exec(L);if(j){var S={type:"table",header:U(j[1]).map(function(me){return{text:me}}),align:j[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:j[3]&&j[3].trim()?j[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(S.header.length===S.align.length){S.raw=j[0];var k=S.align.length,W,K,te,se;for(W=0;W<k;W++)/^ *-+: *$/.test(S.align[W])?S.align[W]="right":/^ *:-+: *$/.test(S.align[W])?S.align[W]="center":/^ *:-+ *$/.test(S.align[W])?S.align[W]="left":S.align[W]=null;for(k=S.rows.length,W=0;W<k;W++)S.rows[W]=U(S.rows[W],S.header.length).map(function(me){return{text:me}});for(k=S.header.length,K=0;K<k;K++)S.header[K].tokens=this.lexer.inline(S.header[K].text);for(k=S.rows.length,K=0;K<k;K++)for(se=S.rows[K],te=0;te<se.length;te++)se[te].tokens=this.lexer.inline(se[te].text);return S}}},B.lheading=function(L){var j=this.rules.block.lheading.exec(L);if(j)return{type:"heading",raw:j[0],depth:j[2].charAt(0)==="="?1:2,text:j[1],tokens:this.lexer.inline(j[1])}},B.paragraph=function(L){var j=this.rules.block.paragraph.exec(L);if(j){var S=j[1].charAt(j[1].length-1)===`
`?j[1].slice(0,-1):j[1];return{type:"paragraph",raw:j[0],text:S,tokens:this.lexer.inline(S)}}},B.text=function(L){var j=this.rules.block.text.exec(L);if(j)return{type:"text",raw:j[0],text:j[0],tokens:this.lexer.inline(j[0])}},B.escape=function(L){var j=this.rules.inline.escape.exec(L);if(j)return{type:"escape",raw:j[0],text:e(j[1])}},B.tag=function(L){var j=this.rules.inline.tag.exec(L);if(j)return!this.lexer.state.inLink&&/^<a /i.test(j[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(j[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(j[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(j[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:j[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(j[0]):e(j[0]):j[0]}},B.link=function(L){var j=this.rules.inline.link.exec(L);if(j){var S=j[2].trim();if(!this.options.pedantic&&/^</.test(S)){if(!/>$/.test(S))return;var k=M(S.slice(0,-1),"\\");if((S.length-k.length)%2===0)return}else{var W=A(j[2],"()");if(W>-1){var K=j[0].indexOf("!")===0?5:4,te=K+j[1].length+W;j[2]=j[2].substring(0,W),j[0]=j[0].substring(0,te).trim(),j[3]=""}}var se=j[2],me="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);we&&(se=we[1],me=we[3])}else me=j[3]?j[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(S)?se=se.slice(1):se=se.slice(1,-1)),ie(j,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},j[0],this.lexer)}},B.reflink=function(L,j){var S;if((S=this.rules.inline.reflink.exec(L))||(S=this.rules.inline.nolink.exec(L))){var k=(S[2]||S[1]).replace(/\s+/g," ");if(k=j[k.toLowerCase()],!k||!k.href){var W=S[0].charAt(0);return{type:"text",raw:W,text:W}}return ie(S,k,S[0],this.lexer)}},B.emStrong=function(L,j,S){S===void 0&&(S="");var k=this.rules.inline.emStrong.lDelim.exec(L);if(k&&!(k[3]&&S.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=k[1]||k[2]||"";if(!W||W&&(S===""||this.rules.inline.punctuation.exec(S))){var K=k[0].length-1,te,se,me=K,we=0,Ne=k[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,j=j.slice(-1*L.length+K);(k=Ne.exec(j))!=null;)if(te=k[1]||k[2]||k[3]||k[4]||k[5]||k[6],!!te){if(se=te.length,k[3]||k[4]){me+=se;continue}else if((k[5]||k[6])&&K%3&&!((K+se)%3)){we+=se;continue}if(me-=se,!(me>0)){if(se=Math.min(se,se+me+we),Math.min(K,se)%2){var Ee=L.slice(1,K+k.index+se);return{type:"em",raw:L.slice(0,K+k.index+se+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ve=L.slice(2,K+k.index+se-1);return{type:"strong",raw:L.slice(0,K+k.index+se+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},B.codespan=function(L){var j=this.rules.inline.code.exec(L);if(j){var S=j[2].replace(/\n/g," "),k=/[^ ]/.test(S),W=/^ /.test(S)&&/ $/.test(S);return k&&W&&(S=S.substring(1,S.length-1)),S=e(S,!0),{type:"codespan",raw:j[0],text:S}}},B.br=function(L){var j=this.rules.inline.br.exec(L);if(j)return{type:"br",raw:j[0]}},B.del=function(L){var j=this.rules.inline.del.exec(L);if(j)return{type:"del",raw:j[0],text:j[2],tokens:this.lexer.inlineTokens(j[2])}},B.autolink=function(L,j){var S=this.rules.inline.autolink.exec(L);if(S){var k,W;return S[2]==="@"?(k=e(this.options.mangle?j(S[1]):S[1]),W="mailto:"+k):(k=e(S[1]),W=k),{type:"link",raw:S[0],text:k,href:W,tokens:[{type:"text",raw:k,text:k}]}}},B.url=function(L,j){var S;if(S=this.rules.inline.url.exec(L)){var k,W;if(S[2]==="@")k=e(this.options.mangle?j(S[0]):S[0]),W="mailto:"+k;else{var K;do K=S[0],S[0]=this.rules.inline._backpedal.exec(S[0])[0];while(K!==S[0]);k=e(S[0]),S[1]==="www."?W="http://"+k:W=k}return{type:"link",raw:S[0],text:k,href:W,tokens:[{type:"text",raw:k,text:k}]}}},B.inlineText=function(L,j){var S=this.rules.inline.text.exec(L);if(S){var k;return this.lexer.state.inRawBlock?k=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(S[0]):e(S[0]):S[0]:k=e(this.options.smartypants?j(S[0]):S[0]),{type:"text",raw:S[0],text:k}}},N}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=n(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=n(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=n(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=n(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=n(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=n(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=z({},he),he.gfm=z({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=n(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=n(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=z({},he.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(he._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",he._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",he._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=z({},oe),oe.pedantic=z({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=z({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=z({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(N){return N.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ce(N){var B="",q,L,j=N.length;for(q=0;q<j;q++)L=N.charCodeAt(q),Math.random()>.5&&(L="x"+L.toString(16)),B+="&#"+L+";";return B}var Se=function(){function N(q){this.tokens=[],this.tokens.links=Object.create(null),this.options=q||le.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var L={block:he.normal,inline:oe.normal};this.options.pedantic?(L.block=he.pedantic,L.inline=oe.pedantic):this.options.gfm&&(L.block=he.gfm,this.options.breaks?L.inline=oe.breaks:L.inline=oe.gfm),this.tokenizer.rules=L}N.lex=function(L,j){var S=new N(j);return S.lex(L)},N.lexInline=function(L,j){var S=new N(j);return S.inlineTokens(L)};var B=N.prototype;return B.lex=function(L){L=L.replace(/\r\n|\r/g,`
`),this.blockTokens(L,this.tokens);for(var j;j=this.inlineQueue.shift();)this.inlineTokens(j.src,j.tokens);return this.tokens},B.blockTokens=function(L,j){var S=this;j===void 0&&(j=[]),this.options.pedantic?L=L.replace(/\t/g,"    ").replace(/^ +$/gm,""):L=L.replace(/^( *)(\t+)/gm,function(me,we,Ne){return we+"    ".repeat(Ne.length)});for(var k,W,K,te;L;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(k=me.call({lexer:S},L,j))?(L=L.substring(k.raw.length),j.push(k),!0):!1}))){if(k=this.tokenizer.space(L)){L=L.substring(k.raw.length),k.raw.length===1&&j.length>0?j[j.length-1].raw+=`
`:j.push(k);continue}if(k=this.tokenizer.code(L)){L=L.substring(k.raw.length),W=j[j.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+k.raw,W.text+=`
`+k.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):j.push(k);continue}if(k=this.tokenizer.fences(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.heading(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.hr(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.blockquote(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.list(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.html(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.def(L)){L=L.substring(k.raw.length),W=j[j.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+k.raw,W.text+=`
`+k.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[k.tag]||(this.tokens.links[k.tag]={href:k.href,title:k.title});continue}if(k=this.tokenizer.table(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.lheading(L)){L=L.substring(k.raw.length),j.push(k);continue}if(K=L,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,we=L.slice(1),Ne=void 0;S.options.extensions.startBlock.forEach(function(Ee){Ne=Ee.call({lexer:this},we),typeof Ne=="number"&&Ne>=0&&(me=Math.min(me,Ne))}),me<1/0&&me>=0&&(K=L.substring(0,me+1))}(),this.state.top&&(k=this.tokenizer.paragraph(K))){W=j[j.length-1],te&&W.type==="paragraph"?(W.raw+=`
`+k.raw,W.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):j.push(k),te=K.length!==L.length,L=L.substring(k.raw.length);continue}if(k=this.tokenizer.text(L)){L=L.substring(k.raw.length),W=j[j.length-1],W&&W.type==="text"?(W.raw+=`
`+k.raw,W.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):j.push(k);continue}if(L){var se="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,j},B.inline=function(L,j){return j===void 0&&(j=[]),this.inlineQueue.push({src:L,tokens:j}),j},B.inlineTokens=function(L,j){var S=this;j===void 0&&(j=[]);var k,W,K,te=L,se,me,we;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)Ne.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,se.index)+"["+Q("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,se.index)+"["+Q("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,se.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;L;)if(me||(we=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(k=ve.call({lexer:S},L,j))?(L=L.substring(k.raw.length),j.push(k),!0):!1}))){if(k=this.tokenizer.escape(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.tag(L)){L=L.substring(k.raw.length),W=j[j.length-1],W&&k.type==="text"&&W.type==="text"?(W.raw+=k.raw,W.text+=k.text):j.push(k);continue}if(k=this.tokenizer.link(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.reflink(L,this.tokens.links)){L=L.substring(k.raw.length),W=j[j.length-1],W&&k.type==="text"&&W.type==="text"?(W.raw+=k.raw,W.text+=k.text):j.push(k);continue}if(k=this.tokenizer.emStrong(L,te,we)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.codespan(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.br(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.del(L)){L=L.substring(k.raw.length),j.push(k);continue}if(k=this.tokenizer.autolink(L,Ce)){L=L.substring(k.raw.length),j.push(k);continue}if(!this.state.inLink&&(k=this.tokenizer.url(L,Ce))){L=L.substring(k.raw.length),j.push(k);continue}if(K=L,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Te=L.slice(1),Pe=void 0;S.options.extensions.startInline.forEach(function(qe){Pe=qe.call({lexer:this},Te),typeof Pe=="number"&&Pe>=0&&(ve=Math.min(ve,Pe))}),ve<1/0&&ve>=0&&(K=L.substring(0,ve+1))}(),k=this.tokenizer.inlineText(K,ge)){L=L.substring(k.raw.length),k.raw.slice(-1)!=="_"&&(we=k.raw.slice(-1)),me=!0,W=j[j.length-1],W&&W.type==="text"?(W.raw+=k.raw,W.text+=k.text):j.push(k);continue}if(L){var Ee="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return j},y(N,null,[{key:"rules",get:function(){return{block:he,inline:oe}}}]),N}(),Re=function(){function N(q){this.options=q||le.defaults}var B=N.prototype;return B.code=function(L,j,S){var k=(j||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(L,k);W!=null&&W!==L&&(S=!0,L=W)}return L=L.replace(/\n$/,"")+`
`,k?'<pre><code class="'+this.options.langPrefix+e(k,!0)+'">'+(S?L:e(L,!0))+`</code></pre>
`:"<pre><code>"+(S?L:e(L,!0))+`</code></pre>
`},B.blockquote=function(L){return`<blockquote>
`+L+`</blockquote>
`},B.html=function(L){return L},B.heading=function(L,j,S,k){if(this.options.headerIds){var W=this.options.headerPrefix+k.slug(S);return"<h"+j+' id="'+W+'">'+L+"</h"+j+`>
`}return"<h"+j+">"+L+"</h"+j+`>
`},B.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},B.list=function(L,j,S){var k=j?"ol":"ul",W=j&&S!==1?' start="'+S+'"':"";return"<"+k+W+`>
`+L+"</"+k+`>
`},B.listitem=function(L){return"<li>"+L+`</li>
`},B.checkbox=function(L){return"<input "+(L?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},B.paragraph=function(L){return"<p>"+L+`</p>
`},B.table=function(L,j){return j&&(j="<tbody>"+j+"</tbody>"),`<table>
<thead>
`+L+`</thead>
`+j+`</table>
`},B.tablerow=function(L){return`<tr>
`+L+`</tr>
`},B.tablecell=function(L,j){var S=j.header?"th":"td",k=j.align?"<"+S+' align="'+j.align+'">':"<"+S+">";return k+L+("</"+S+`>
`)},B.strong=function(L){return"<strong>"+L+"</strong>"},B.em=function(L){return"<em>"+L+"</em>"},B.codespan=function(L){return"<code>"+L+"</code>"},B.br=function(){return this.options.xhtml?"<br/>":"<br>"},B.del=function(L){return"<del>"+L+"</del>"},B.link=function(L,j,S){if(L=$(this.options.sanitize,this.options.baseUrl,L),L===null)return S;var k='<a href="'+e(L)+'"';return j&&(k+=' title="'+j+'"'),k+=">"+S+"</a>",k},B.image=function(L,j,S){if(L=$(this.options.sanitize,this.options.baseUrl,L),L===null)return S;var k='<img src="'+L+'" alt="'+S+'"';return j&&(k+=' title="'+j+'"'),k+=this.options.xhtml?"/>":">",k},B.text=function(L){return L},N}(),fe=function(){function N(){}var B=N.prototype;return B.strong=function(L){return L},B.em=function(L){return L},B.codespan=function(L){return L},B.del=function(L){return L},B.html=function(L){return L},B.text=function(L){return L},B.link=function(L,j,S){return""+S},B.image=function(L,j,S){return""+S},B.br=function(){return""},N}(),ne=function(){function N(){this.seen={}}var B=N.prototype;return B.serialize=function(L){return L.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},B.getNextSafeSlug=function(L,j){var S=L,k=0;if(this.seen.hasOwnProperty(S)){k=this.seen[L];do k++,S=L+"-"+k;while(this.seen.hasOwnProperty(S))}return j||(this.seen[L]=k,this.seen[S]=0),S},B.slug=function(L,j){j===void 0&&(j={});var S=this.serialize(L);return this.getNextSafeSlug(S,j.dryrun)},N}(),G=function(){function N(q){this.options=q||le.defaults,this.options.renderer=this.options.renderer||new Re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new ne}N.parse=function(L,j){var S=new N(j);return S.parse(L)},N.parseInline=function(L,j){var S=new N(j);return S.parseInline(L)};var B=N.prototype;return B.parse=function(L,j){j===void 0&&(j=!0);var S="",k,W,K,te,se,me,we,Ne,Ee,ve,Te,Pe,qe,je,Ie,Ge,Y,ae,$e,De=L.length;for(k=0;k<De;k++){if(ve=L[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&($e=this.options.extensions.renderers[ve.type].call({parser:this},ve),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){S+=$e||"";continue}switch(ve.type){case"space":continue;case"hr":{S+=this.renderer.hr();continue}case"heading":{S+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,o(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{S+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ne="",we="",te=ve.header.length,W=0;W<te;W++)we+=this.renderer.tablecell(this.parseInline(ve.header[W].tokens),{header:!0,align:ve.align[W]});for(Ne+=this.renderer.tablerow(we),Ee="",te=ve.rows.length,W=0;W<te;W++){for(me=ve.rows[W],we="",se=me.length,K=0;K<se;K++)we+=this.renderer.tablecell(this.parseInline(me[K].tokens),{header:!1,align:ve.align[K]});Ee+=this.renderer.tablerow(we)}S+=this.renderer.table(Ne,Ee);continue}case"blockquote":{Ee=this.parse(ve.tokens),S+=this.renderer.blockquote(Ee);continue}case"list":{for(Te=ve.ordered,Pe=ve.start,qe=ve.loose,te=ve.items.length,Ee="",W=0;W<te;W++)Ie=ve.items[W],Ge=Ie.checked,Y=Ie.task,je="",Ie.task&&(ae=this.renderer.checkbox(Ge),qe?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=ae+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=ae+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:ae}):je+=ae),je+=this.parse(Ie.tokens,qe),Ee+=this.renderer.listitem(je,Y,Ge);S+=this.renderer.list(Ee,Te,Pe);continue}case"html":{S+=this.renderer.html(ve.text);continue}case"paragraph":{S+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ee=ve.tokens?this.parseInline(ve.tokens):ve.text;k+1<De&&L[k+1].type==="text";)ve=L[++k],Ee+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);S+=j?this.renderer.paragraph(Ee):Ee;continue}default:{var Oe='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return S},B.parseInline=function(L,j){j=j||this.renderer;var S="",k,W,K,te=L.length;for(k=0;k<te;k++){if(W=L[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(K=this.options.extensions.renderers[W.type].call({parser:this},W),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){S+=K||"";continue}switch(W.type){case"escape":{S+=j.text(W.text);break}case"html":{S+=j.html(W.text);break}case"link":{S+=j.link(W.href,W.title,this.parseInline(W.tokens,j));break}case"image":{S+=j.image(W.href,W.title,W.text);break}case"strong":{S+=j.strong(this.parseInline(W.tokens,j));break}case"em":{S+=j.em(this.parseInline(W.tokens,j));break}case"codespan":{S+=j.codespan(W.text);break}case"br":{S+=j.br();break}case"del":{S+=j.del(this.parseInline(W.tokens,j));break}case"text":{S+=j.text(W.text);break}default:{var se='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return S},N}();function V(N,B,q){if(typeof N>"u"||N===null)throw new Error("marked(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");if(typeof B=="function"&&(q=B,B=null),B=z({},V.defaults,B||{}),H(B),q){var L=B.highlight,j;try{j=Se.lex(N,B)}catch(te){return q(te)}var S=function(se){var me;if(!se)try{B.walkTokens&&V.walkTokens(j,B.walkTokens),me=G.parse(j,B)}catch(we){se=we}return B.highlight=L,se?q(se):q(null,me)};if(!L||L.length<3||(delete B.highlight,!j.length))return S();var k=0;V.walkTokens(j,function(te){te.type==="code"&&(k++,setTimeout(function(){L(te.text,te.lang,function(se,me){if(se)return S(se);me!=null&&me!==te.text&&(te.text=me,te.escaped=!0),k--,k===0&&S()})},0))}),k===0&&S();return}function W(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(te.message+"",!0)+"</pre>";throw te}try{var K=Se.lex(N,B);if(B.walkTokens){if(B.async)return Promise.all(V.walkTokens(K,B.walkTokens)).then(function(){return G.parse(K,B)}).catch(W);V.walkTokens(K,B.walkTokens)}return G.parse(K,B)}catch(te){W(te)}}V.options=V.setOptions=function(N){return z(V.defaults,N),w(V.defaults),V},V.getDefaults=D,V.defaults=le.defaults,V.use=function(){for(var N=arguments.length,B=new Array(N),q=0;q<N;q++)B[q]=arguments[q];var L=z.apply(void 0,[{}].concat(B)),j=V.defaults.extensions||{renderers:{},childTokens:{}},S;B.forEach(function(k){if(k.extensions&&(S=!0,k.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var te=j.renderers?j.renderers[K.name]:null;te?j.renderers[K.name]=function(){for(var se=arguments.length,me=new Array(se),we=0;we<se;we++)me[we]=arguments[we];var Ne=K.renderer.apply(this,me);return Ne===!1&&(Ne=te.apply(this,me)),Ne}:j.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");j[K.level]?j[K.level].unshift(K.tokenizer):j[K.level]=[K.tokenizer],K.start&&(K.level==="block"?j.startBlock?j.startBlock.push(K.start):j.startBlock=[K.start]:K.level==="inline"&&(j.startInline?j.startInline.push(K.start):j.startInline=[K.start]))}K.childTokens&&(j.childTokens[K.name]=K.childTokens)})),k.renderer&&function(){var K=V.defaults.renderer||new Re,te=function(we){var Ne=K[we];K[we]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Te=0;Te<Ee;Te++)ve[Te]=arguments[Te];var Pe=k.renderer[we].apply(K,ve);return Pe===!1&&(Pe=Ne.apply(K,ve)),Pe}};for(var se in k.renderer)te(se);L.renderer=K}(),k.tokenizer&&function(){var K=V.defaults.tokenizer||new ue,te=function(we){var Ne=K[we];K[we]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Te=0;Te<Ee;Te++)ve[Te]=arguments[Te];var Pe=k.tokenizer[we].apply(K,ve);return Pe===!1&&(Pe=Ne.apply(K,ve)),Pe}};for(var se in k.tokenizer)te(se);L.tokenizer=K}(),k.walkTokens){var W=V.defaults.walkTokens;L.walkTokens=function(K){var te=[];return te.push(k.walkTokens.call(this,K)),W&&(te=te.concat(W.call(this,K))),te}}S&&(L.extensions=j),V.setOptions(L)})},V.walkTokens=function(N,B){for(var q=[],L=function(){var W=S.value;switch(q=q.concat(B.call(V,W)),W.type){case"table":{for(var K=_(W.header),te;!(te=K()).done;){var se=te.value;q=q.concat(V.walkTokens(se.tokens,B))}for(var me=_(W.rows),we;!(we=me()).done;)for(var Ne=we.value,Ee=_(Ne),ve;!(ve=Ee()).done;){var Te=ve.value;q=q.concat(V.walkTokens(Te.tokens,B))}break}case"list":{q=q.concat(V.walkTokens(W.items,B));break}default:V.defaults.extensions&&V.defaults.extensions.childTokens&&V.defaults.extensions.childTokens[W.type]?V.defaults.extensions.childTokens[W.type].forEach(function(Pe){q=q.concat(V.walkTokens(W[Pe],B))}):W.tokens&&(q=q.concat(V.walkTokens(W.tokens,B)))}},j=_(N),S;!(S=j()).done;)L();return q},V.parseInline=function(N,B){if(typeof N>"u"||N===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");B=z({},V.defaults,B||{}),H(B);try{var q=Se.lexInline(N,B);return B.walkTokens&&V.walkTokens(q,B.walkTokens),G.parseInline(q,B)}catch(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(L.message+"",!0)+"</pre>";throw L}},V.Parser=G,V.parser=G.parse,V.Renderer=Re,V.TextRenderer=fe,V.Lexer=Se,V.lexer=Se.lex,V.Tokenizer=ue,V.Slugger=ne,V.parse=V;var ee=V.options,Z=V.setOptions,C=V.use,x=V.walkTokens,d=V.parseInline,p=V,E=G.parse,I=Se.lex;le.Lexer=Se,le.Parser=G,le.Renderer=Re,le.Slugger=ne,le.TextRenderer=fe,le.Tokenizer=ue,le.getDefaults=D,le.lexer=I,le.marked=V,le.options=ee,le.parse=p,le.parseInline=d,le.parser=E,le.setOptions=Z,le.use=C,le.walkTokens=x,Object.defineProperty(le,"__esModule",{value:!0})}),define(be[78],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=void 0;class y{constructor(i,_=0,D=i.length,w=_-1){this.a=i,this.b=_,this.c=D,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$gR=y}),define(be[79],pe([1,0,78]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=t.$hR=void 0;class O{constructor(D=[],w=10){this.h(D),this.b=w,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new y.$gR(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const w of D)this.a.add(w)}get j(){const D=[];return this.a.forEach(w=>D.push(w)),D}}t.$hR=O;class i{constructor(D,w=10){if(this.g=w,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let l=1;l<D.length;l++)this.add(D[l])}add(D){const w={value:D,previous:this.c,next:void 0};for(this.c.next=w,this.c=w,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const w=this.c.value;return this.a.delete(w),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),w}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let w=this.b;for(;w!==this.c;)w.value===D&&(w===this.b?(this.b=this.b.next,this.b.previous=void 0):(w.previous.next=w.next,w.next.previous=w.previous),this.f--),w=w.next}}t.$iR=i}),define(be[45],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kl=t.$Jl=t.$Il=t.rot=t.$Gl=void 0;function y(w,l,u){return Math.min(Math.max(w,l),u)}t.$Gl=y;function O(w,l){return(l+w%l)%l}t.rot=O;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Il=i;class _{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Jl=_;class D{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const u=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Kl=D}),define(be[46],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(O){function i(l,u){if(l.start>=u.end||u.start>=l.end)return{start:0,end:0};const f=Math.max(l.start,u.start),P=Math.min(l.end,u.end);return P-f<=0?{start:0,end:0}:{start:f,end:P}}O.intersect=i;function _(l){return l.end-l.start<=0}O.isEmpty=_;function D(l,u){return!_(i(l,u))}O.intersects=D;function w(l,u){const f=[],P={start:l.start,end:Math.min(u.start,l.end)},r={start:Math.max(u.end,l.start),end:l.end};return _(P)||f.push(P),_(r)||f.push(r),f}O.relativeComplement=w})(y||(t.Range=y={}))}),define(be[80],pe([1,0,46]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_P=t.$$P=t.$0P=t.$9P=void 0;function O(l,u){const f=[];for(const P of u){if(l.start>=P.range.end)continue;if(l.end<P.range.start)break;const r=y.Range.intersect(l,P.range);y.Range.isEmpty(r)||f.push({range:r,size:P.size})}return f}t.$9P=O;function i({start:l,end:u},f){return{start:l+f,end:u+f}}t.$0P=i;function _(l){const u=[];let f=null;for(const P of l){const r=P.range.start,h=P.range.end,e=P.size;if(f&&e===f.size){f.range.end=h;continue}f={range:{start:r,end:h},size:e},u.push(f)}return u}t.$$P=_;function D(...l){return _(l.reduce((u,f)=>u.concat(f),[]))}class w{get paddingTop(){return this.c}set paddingTop(u){this.b=this.b+u-this.c,this.c=u}constructor(u){this.a=[],this.b=0,this.c=0,this.c=u??0,this.b=this.c}splice(u,f,P=[]){const r=P.length-f,h=O({start:0,end:u},this.a),e=O({start:u+f,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:i(o.range,r),size:o.size})),a=P.map((o,s)=>({range:{start:u+s,end:u+s+1},size:o.size}));this.a=D(h,a,e),this.b=this.c+this.a.reduce((o,s)=>o+s.size*(s.range.end-s.range.start),0)}get count(){const u=this.a.length;return u?this.a[u-1].range.end:0}get size(){return this.b}indexAt(u){if(u<0)return-1;if(u<this.c)return 0;let f=0,P=this.c;for(const r of this.a){const h=r.range.end-r.range.start,e=P+h*r.size;if(u<e)return f+Math.floor((u-P)/r.size);f+=h,P=e}return f}indexAfter(u){return Math.min(this.indexAt(u)+1,this.count)}positionAt(u){if(u<0)return-1;let f=0,P=0;for(const r of this.a){const h=r.range.end-r.range.start,e=P+h;if(u<e)return this.c+f+(u-P)*r.size;f+=h*r.size,P=e}return-1}}t.$_P=w}),define(be[81],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(_){return new O(_)}constructor(_){this.c=y&&_===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ad=O}),define(be[3],pe([1,0,6,42,2,44,81]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nd=t.$md=t.$ld=t.$kd=t.$jd=t.$id=t.$hd=t.$gd=t.$fd=t.$ed=t.$dd=t.$cd=t.Event=void 0;const w=!1,l=!1;var u;(function(M){M.None=()=>i.$jc.None;function A(j){if(l){const{onDidAddListener:S}=j,k=e.create();let W=0;j.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),k.print()),S?.()}}}function H(j,S){return Re(j,()=>{},0,void 0,!0,void 0,S)}M.defer=H;function Q(j){return(S,k=null,W)=>{let K=!1,te;return te=j(se=>{if(!K)return te?te.dispose():K=!0,S.call(k,se)},null,W),K&&te.dispose(),te}}M.once=Q;function ie(j,S,k){return Ce((W,K=null,te)=>j(se=>W.call(K,S(se)),null,te),k)}M.map=ie;function re(j,S,k){return Ce((W,K=null,te)=>j(se=>{S(se),W.call(K,se)},null,te),k)}M.forEach=re;function ue(j,S,k){return Ce((W,K=null,te)=>j(se=>S(se)&&W.call(K,se),null,te),k)}M.filter=ue;function he(j){return j}M.signal=he;function oe(...j){return(S,k=null,W)=>{const K=(0,i.$gc)(...j.map(te=>te(se=>S.call(k,se))));return Se(K,W)}}M.any=oe;function ge(j,S,k,W){let K=k;return ie(j,te=>(K=S(K,te),K),W)}M.reduce=ge;function Ce(j,S){let k;const W={onWillAddFirstListener(){k=j(K.fire,K)},onDidRemoveLastListener(){k?.dispose()}};S||A(W);const K=new g(W);return S?.add(K),K.event}function Se(j,S){return S instanceof Array?S.push(j):S&&S.add(j),j}function Re(j,S,k=100,W=!1,K=!1,te,se){let me,we,Ne,Ee=0,ve;const Te={leakWarningThreshold:te,onWillAddFirstListener(){me=j(qe=>{Ee++,we=S(we,qe),W&&!Ne&&(Pe.fire(we),we=void 0),ve=()=>{const je=we;we=void 0,Ne=void 0,(!W||Ee>1)&&Pe.fire(je),Ee=0},typeof k=="number"?(clearTimeout(Ne),Ne=setTimeout(ve,k)):Ne===void 0&&(Ne=0,queueMicrotask(ve))})},onWillRemoveListener(){K&&Ee>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,me.dispose()}};se||A(Te);const Pe=new g(Te);return se?.add(Pe),Pe.event}M.debounce=Re;function fe(j,S=0,k){return M.debounce(j,(W,K)=>W?(W.push(K),W):[K],S,void 0,!0,void 0,k)}M.accumulate=fe;function ne(j,S=(W,K)=>W===K,k){let W=!0,K;return ue(j,te=>{const se=W||!S(te,K);return W=!1,K=te,se},k)}M.latch=ne;function G(j,S,k){return[M.filter(j,S,k),M.filter(j,W=>!S(W),k)]}M.split=G;function V(j,S=!1,k=[],W){let K=k.slice(),te=j(we=>{K?K.push(we):me.fire(we)});W&&W.add(te);const se=()=>{K?.forEach(we=>me.fire(we)),K=null},me=new g({onWillAddFirstListener(){te||(te=j(we=>me.fire(we)),W&&W.add(te))},onDidAddFirstListener(){K&&(S?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return W&&W.add(me),me.event}M.buffer=V;function ee(j,S){return(W,K,te)=>{const se=S(new C);return j(function(me){const we=se.evaluate(me);we!==Z&&W.call(K,we)},void 0,te)}}M.chain=ee;const Z=Symbol("HaltChainable");class C{constructor(){this.f=[]}map(S){return this.f.push(S),this}forEach(S){return this.f.push(k=>(S(k),k)),this}filter(S){return this.f.push(k=>S(k)?k:Z),this}reduce(S,k){let W=k;return this.f.push(K=>(W=S(W,K),W)),this}latch(S=(k,W)=>k===W){let k=!0,W;return this.f.push(K=>{const te=k||!S(K,W);return k=!1,W=K,te?K:Z}),this}evaluate(S){for(const k of this.f)if(S=k(S),S===Z)break;return S}}function x(j,S,k=W=>W){const W=(...me)=>se.fire(k(...me)),K=()=>j.on(S,W),te=()=>j.removeListener(S,W),se=new g({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}M.fromNodeEventEmitter=x;function d(j,S,k=W=>W){const W=(...me)=>se.fire(k(...me)),K=()=>j.addEventListener(S,W),te=()=>j.removeEventListener(S,W),se=new g({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}M.fromDOMEventEmitter=d;function p(j){return new Promise(S=>Q(j)(S))}M.toPromise=p;function E(j){const S=new g;return j.then(k=>{S.fire(k)},()=>{S.fire(void 0)}).finally(()=>{S.dispose()}),S.event}M.fromPromise=E;function I(j,S){return S(void 0),j(k=>S(k))}M.runAndSubscribe=I;function N(j,S){let k=null;function W(te){k?.dispose(),k=new i.$ic,S(te,k)}W(void 0);const K=j(te=>W(te));return(0,i.$hc)(()=>{K.dispose(),k?.dispose()})}M.runAndSubscribeWithStore=N;class B{constructor(S,k){this._observable=S,this.f=0,this.g=!1;const W={onWillAddFirstListener:()=>{S.addObserver(this)},onDidRemoveLastListener:()=>{S.removeObserver(this)}};k||A(W),this.emitter=new g(W),k&&k.add(this.emitter)}beginUpdate(S){this.f++}handlePossibleChange(S){}handleChange(S,k){this.g=!0}endUpdate(S){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function q(j,S){return new B(j,S).emitter.event}M.fromObservable=q;function L(j){return S=>{let k=0,W=!1;const K={beginUpdate(){k++},endUpdate(){k--,k===0&&(j.reportChanges(),W&&(W=!1,S()))},handlePossibleChange(){},handleChange(){W=!0}};return j.addObserver(K),j.reportChanges(),{dispose(){j.removeObserver(K)}}}}M.fromObservableLight=L})(u||(t.Event=u={}));class f{static{this.all=new Set}static{this.f=0}constructor(A){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${A}_${f.f++}`,f.all.add(this)}start(A){this.g=new D.$ad,this.listenerCount=A}stop(){if(this.g){const A=this.g.elapsed();this.durations.push(A),this.elapsedOverall+=A,this.invocationCount+=1,this.g=void 0}}}t.$cd=f;let P=-1;function r(M){const A=P;return P=M,{dispose(){P=A}}}t.$dd=r;class h{constructor(A,H=Math.random().toString(18).slice(2,5)){this.threshold=A,this.name=H,this.g=0}dispose(){this.f?.clear()}check(A,H){const Q=this.threshold;if(Q<=0||H<Q)return;this.f||(this.f=new Map);const ie=this.f.get(A.value)||0;if(this.f.set(A.value,ie+1),this.g-=1,this.g<=0){this.g=Q*.5;let re,ue=0;for(const[he,oe]of this.f)(!re||ue<oe)&&(re=he,ue=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${H} listeners already. MOST frequent listener (${ue}):`),console.warn(re)}return()=>{const re=this.f.get(A.value)||0;this.f.set(A.value,re-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(A){this.value=A}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let a=0;class o{constructor(A){this.value=A,this.id=a++}}const s=2,n=(M,A)=>{if(M instanceof o)A(M);else for(let H=0;H<M.length;H++){const Q=M[H];Q&&A(Q)}};class g{constructor(A){this.w=0,this.f=A,this.g=P>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new f(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const A=this.t;queueMicrotask(()=>{n(A,H=>H.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(A,H,Q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$jc.None;if(this.m)return i.$jc.None;H&&(A=A.bind(H));const ie=new o(A);let re,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ie.stack=e.create(),re=this.g.check(ie.stack,this.w+1)),w&&(ie.stack=ue??e.create()),this.t?this.t instanceof o?(this.u??=new $,this.t=[this.t,ie]):this.t.push(ie):(this.f?.onWillAddFirstListener?.(this),this.t=ie,this.f?.onDidAddFirstListener?.(this)),this.w++;const he=(0,i.$hc)(()=>{re?.(),this.x(ie)});return Q instanceof i.$ic?Q.add(he):Array.isArray(Q)&&Q.push(he),he},this.q}x(A){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const H=this.t,Q=H.indexOf(A);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,H[Q]=void 0;const ie=this.u.current===this;if(this.w*s<=H.length){let re=0;for(let ue=0;ue<H.length;ue++)H[ue]?H[re++]=H[ue]:ie&&(this.u.end--,re<this.u.i&&this.u.i--);H.length=re}}y(A,H){if(!A)return;const Q=this.f?.onListenerError||y.$Y;if(!Q){A.value(H);return}try{A.value(H)}catch(ie){Q(ie)}}z(A){const H=A.current.t;for(;A.i<A.end;)this.y(H[A.i++],A.value);A.reset()}fire(A){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,A);else{const H=this.u;H.enqueue(this,A,this.t.length),this.z(H)}this.j?.stop()}hasListeners(){return this.w>0}}t.$ed=g;const b=()=>new $;t.$fd=b;class ${constructor(){this.i=-1,this.end=0}enqueue(A,H,Q){this.i=0,this.end=Q,this.current=A,this.value=H}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends g{async fireAsync(A,H,Q){if(this.t)for(this.h||(this.h=new _.$sc),n(this.t,ie=>this.h.push([ie.value,A]));this.h.size>0&&!H.isCancellationRequested;){const[ie,re]=this.h.shift(),ue=[],he={...re,token:H,waitUntil:oe=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");Q&&(oe=Q(oe,ie)),ue.push(oe)}};try{ie(he)}catch(oe){(0,y.$Y)(oe);continue}Object.freeze(ue),await Promise.allSettled(ue).then(oe=>{for(const ge of oe)ge.status==="rejected"&&(0,y.$Y)(ge.reason)})}}}t.$gd=c;class F extends g{get isPaused(){return this.h!==0}constructor(A){super(A),this.h=0,this.s=new _.$sc,this.A=A?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const A=Array.from(this.s);this.s.clear(),super.fire(this.A(A))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(A){this.w&&(this.h!==0?this.s.push(A):super.fire(A))}}t.$hd=F;class R extends F{constructor(A){super(A),this.k=A.delay??100}fire(A){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(A)}}t.$id=R;class T extends g{constructor(A){super(A),this.h=[],this.k=A?.merge}fire(A){this.hasListeners()&&(this.h.push(A),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(H=>super.fire(H)),this.h=[]}))}}t.$jd=T;class m{constructor(){this.g=!1,this.h=[],this.f=new g({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(A){const H={event:A,listener:null};this.h.push(H),this.g&&this.m(H);const Q=()=>{this.g&&this.o(H);const ie=this.h.indexOf(H);this.h.splice(ie,1)};return(0,i.$hc)((0,O.$bb)(Q))}j(){this.g=!0,this.h.forEach(A=>this.m(A))}k(){this.g=!1,this.h.forEach(A=>this.o(A))}m(A){A.listener=A.event(H=>this.f.fire(H))}o(A){A.listener&&A.listener.dispose(),A.listener=null}dispose(){this.f.dispose()}}t.$kd=m;class v{constructor(A,H,Q,ie){this.f=new i.$ic;const re=this.f.add(new m),ue=this.f.add(new i.$rc);function he(oe){ue.set(oe,re.add(ie(oe)))}for(const oe of A)he(oe);this.f.add(H(oe=>{he(oe)})),this.f.add(Q(oe=>{ue.deleteAndDispose(oe)})),this.event=re.event}dispose(){this.f.dispose()}}t.$ld=v;class z{constructor(){this.f=[]}wrapEvent(A){return(H,Q,ie)=>A(re=>{const ue=this.f[this.f.length-1];ue?ue.push(()=>H.call(Q,re)):H.call(Q,re)},void 0,ie)}bufferEvents(A){const H=[];this.f.push(H);const Q=A();return this.f.pop(),H.forEach(ie=>ie()),Q}}t.$md=z;class U{constructor(){this.f=!1,this.g=u.None,this.h=i.$jc.None,this.j=new g({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(A){this.g=A,this.f&&(this.h.dispose(),this.h=A(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$nd=U}),define(be[16],pe([1,0,3,2]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7N=t.$6N=t.$5N=t.$4N=t.$3N=t.$2N=t.$1N=t.$ZN=t.$YN=t.$XN=t.$WN=t.$VN=t.$UN=t.$TN=t.$SN=t.$RN=t.$QN=t.$PN=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new y.$ed,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel(b){this.a!==b&&(this.a=b)}getZoomFactor(){return this.b}setZoomFactor(b){this.b=b}setFullscreen(b){this.c!==b&&(this.c=b,this.d.fire())}isFullscreen(){return this.c}}class _ extends O.$jc{constructor(){super(),this.a=this.B(new y.$ed),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(b){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),b&&this.a.fire()}}class D extends O.$jc{get value(){return this.b}constructor(){super(),this.a=this.B(new y.$ed),this.onDidChange=this.a.event,this.b=this.c();const b=this.B(new _);this.B(b.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const b=document.createElement("canvas").getContext("2d"),$=window.devicePixelRatio||1,c=b.webkitBackingStorePixelRatio||b.mozBackingStorePixelRatio||b.msBackingStorePixelRatio||b.oBackingStorePixelRatio||b.backingStorePixelRatio||1;return $/c}}class w{constructor(){this.a=null}b(){return this.a||(this.a=(0,O.$cc)(new D)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function l(g,b){typeof g=="string"&&(g=window.matchMedia(g)),g.addEventListener("change",b)}t.$PN=l,t.$QN=new w;function u(g){i.INSTANCE.setZoomLevel(g)}t.$RN=u;function f(){return i.INSTANCE.getZoomLevel()}t.$SN=f;function P(){return i.INSTANCE.getZoomFactor()}t.$TN=P;function r(g){i.INSTANCE.setZoomFactor(g)}t.$UN=r;function h(g){i.INSTANCE.setFullscreen(g)}t.$VN=h;function e(){return i.INSTANCE.isFullscreen()}t.$WN=e,t.$XN=i.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.$YN=a.indexOf("Firefox")>=0,t.$ZN=a.indexOf("AppleWebKit")>=0,t.$1N=a.indexOf("Chrome")>=0,t.$2N=!t.$1N&&a.indexOf("Safari")>=0,t.$3N=!t.$1N&&!t.$2N&&t.$ZN,t.$4N=a.indexOf("Electron/")>=0,t.$5N=a.indexOf("Android")>=0;let o=!1;if(window.matchMedia){const g=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),b=window.matchMedia("(display-mode: fullscreen)");o=g.matches,l(g,({matches:$})=>{o&&b.matches||(o=$)})}function s(){return o}t.$6N=s;function n(){return navigator?.windowControlsOverlay?.visible}t.$7N=n}),define(be[21],pe([1,0,3]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1P=void 0;class O{get event(){return this.a.event}constructor(_,D,w){const l=u=>this.a.fire(u);this.a=new y.$ed({onWillAddFirstListener:()=>_.addEventListener(D,l,w),onDidRemoveLastListener:()=>_.removeEventListener(D,l,w)})}dispose(){this.a.dispose()}}t.$1P=O}),define(be[27],pe([1,0,3]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$od=t.CancellationToken=void 0;const O=Object.freeze(function(w,l){const u=setTimeout(w.bind(l),0);return{dispose(){clearTimeout(u)}}});var i;(function(w){function l(u){return u===w.None||u===w.Cancelled||u instanceof _?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}w.isCancellationToken=l,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(i||(t.CancellationToken=i={}));class _{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new y.$ed),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new _),this.f}cancel(){this.f?this.f instanceof _&&this.f.cancel():this.f=i.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof _&&this.f.dispose():this.f=i.None}}t.$od=D}),define(be[82],pe([1,0,27]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=t.$he=t.$ge=void 0;class O{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new y.$od,l=this.b(w.token);return this.a={promise:l,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.$ge=O;class i{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const l=JSON.stringify(w);return this.b!==l&&(this.b=l,this.a=this.c(w)),this.a}}t.$he=i;class _{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const l=this.b(w);return this.a.set(w,l),l}}t.$ie=_}),define(be[47],pe([1,0,3,2]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nr=t.$Mr=t.$Lr=t.$Kr=t.ScrollbarVisibility=void 0;var i;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class _{constructor(e,a,o,s,n,g,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(a=a|0,o=o|0,s=s|0,n=n|0,g=g|0,b=b|0),this.rawScrollLeft=s,this.rawScrollTop=b,a<0&&(a=0),s+a>o&&(s=o-a),s<0&&(s=0),n<0&&(n=0),b+n>g&&(b=g-n),b<0&&(b=0),this.width=a,this.scrollWidth=o,this.scrollLeft=s,this.height=n,this.scrollHeight=g,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,a){return new _(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new _(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,a){const o=this.width!==e.width,s=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,g=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,$=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:a,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:s,scrollLeftChanged:n,heightChanged:g,scrollHeightChanged:b,scrollTopChanged:$}}}t.$Kr=_;class D extends O.$jc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new y.$ed),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new _(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,a){const o=this.g.withScrollDimensions(e,a);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const a=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(e,a){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let s;a?s=new f(this.h.from,o,this.h.startTime,this.h.duration):s=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=s}else{const o=this.g.withScrollPosition(e);this.h=f.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),a=this.g.withScrollPosition(e);if(this.n(a,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,a){const o=this.g;o.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(o,a)))}}t.$Lr=D;class w{constructor(e,a,o){this.scrollLeft=e,this.scrollTop=a,this.isDone=o}}t.$Mr=w;function l(h,e){const a=e-h;return function(o){return h+a*r(o)}}function u(h,e,a){return function(o){return o<a?h(o/a):e((o-a)/(1-a))}}class f{constructor(e,a,o,s){this.from=e,this.to=a,this.duration=s,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,a,o){if(Math.abs(e-a)>2.5*o){let n,g;return e<a?(n=e+.75*o,g=a-.75*o):(n=e-.75*o,g=a+.75*o),u(l(e,n),l(g,a),.33)}return l(e,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const a=(e-this.startTime)/this.duration;if(a<1){const o=this.c(a),s=this.d(a);return new w(o,s,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,a,o){return f.start(e,a,o)}static start(e,a,o){o=o+10;const s=Date.now()-10;return new f(e,a,s,o)}}t.$Nr=f;function P(h){return Math.pow(h,3)}function r(h){return 1-P(1-h)}}),define(be[83],pe([1,0,6,2]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=t.$pd=void 0;function i(b){const $=b;return $?typeof $.read=="function":!1}t.$pd=i;function _(b){const $=b;return $?[$.on,$.pause,$.resume,$.destroy].every(c=>typeof c=="function"):!1}t.$qd=_;function D(b){const $=b;return $?_($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}t.$rd=D;function w(b,$){return new l(b,$)}t.$sd=w;class l{constructor($,c){this.e=$,this.f=c,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(c=>this.d.push(c))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(c=>c($))}h($){this.c.error.length===0?(0,y.$Y)($):this.c.error.slice(0).forEach(c=>c($))}i(){this.c.end.slice(0).forEach($=>$())}on($,c){if(!this.a.destroyed)switch($){case"data":this.c.data.push(c),this.resume();break;case"end":this.c.end.push(c),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(c),this.a.flowing&&this.k();break}}removeListener($,c){if(this.a.destroyed)return;let F;switch($){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const R=F.indexOf(c);R>=0&&F.splice(R,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const c=[...this.d];this.d.length=0,c.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(b,$){const c=[];let F;for(;(F=b.read())!==null;)c.push(F);return $(c)}t.$td=u;function f(b,$,c){const F=[];let R;for(;(R=b.read())!==null&&F.length<c;)F.push(R);return R===null&&F.length>0?$(F):{read:()=>{if(F.length>0)return F.shift();if(typeof R<"u"){const T=R;return R=void 0,T}return b.read()}}}t.$ud=f;function P(b,$){return new Promise((c,F)=>{const R=[];r(b,{onData:T=>{$&&R.push(T)},onError:T=>{$?F(T):c(void 0)},onEnd:()=>{c($?$(R):void 0)}})})}t.$vd=P;function r(b,$,c){b.on("error",F=>{c?.isCancellationRequested||$.onError(F)}),b.on("end",()=>{c?.isCancellationRequested||$.onEnd()}),b.on("data",F=>{c?.isCancellationRequested||$.onData(F)})}t.$wd=r;function h(b,$){return new Promise((c,F)=>{const R=new O.$ic,T=[],m=U=>{if(T.push(U),T.length>$)return R.dispose(),b.pause(),c({stream:b,buffer:T,ended:!1})},v=U=>(R.dispose(),F(U)),z=()=>(R.dispose(),c({stream:b,buffer:T,ended:!0}));R.add((0,O.$hc)(()=>b.removeListener("error",v))),b.on("error",v),R.add((0,O.$hc)(()=>b.removeListener("end",z))),b.on("end",z),R.add((0,O.$hc)(()=>b.removeListener("data",m))),b.on("data",m)})}t.$xd=h;function e(b,$){const c=w($);return c.end(b),c}t.$yd=e;function a(){const b=w(()=>{throw new Error("not supported")});return b.end(),b}t.$zd=a;function o(b){let $=!1;return{read:()=>$?null:($=!0,b)}}t.$Ad=o;function s(b,$,c){const F=w(c);return r(b,{onData:R=>F.write($.data(R)),onError:R=>F.error($.error?$.error(R):R),onEnd:()=>F.end()}),F}t.$Bd=s;function n(b,$,c){let F=!1;return{read:()=>{const R=$.read();return F?R:(F=!0,R!==null?c([b,R]):b)}}}t.$Cd=n;function g(b,$,c){let F=!1;const R=w(c);return r($,{onData:T=>F?R.write(T):(F=!0,R.write(c([b,T]))),onError:T=>R.error(T),onEnd:()=>{F||(F=!0,R.write(b)),R.end()}}),R}t.$Dd=g}),define(be[31],pe([1,0,30,83]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=t.$Ed=void 0;const i=typeof Buffer<"u",_=new y.$T(()=>new Uint8Array(256));let D,w;class l{static alloc(H){return i?new l(Buffer.allocUnsafe(H)):new l(new Uint8Array(H))}static wrap(H){return i&&!Buffer.isBuffer(H)&&(H=Buffer.from(H.buffer,H.byteOffset,H.byteLength)),new l(H)}static fromString(H,Q){return!(Q?.dontUseNodeBuffer||!1)&&i?new l(Buffer.from(H)):(D||(D=new TextEncoder),new l(D.encode(H)))}static fromByteArray(H){const Q=l.alloc(H.length);for(let ie=0,re=H.length;ie<re;ie++)Q.buffer[ie]=H[ie];return Q}static concat(H,Q){if(typeof Q>"u"){Q=0;for(let ue=0,he=H.length;ue<he;ue++)Q+=H[ue].byteLength}const ie=l.alloc(Q);let re=0;for(let ue=0,he=H.length;ue<he;ue++){const oe=H[ue];ie.set(oe,re),re+=oe.byteLength}return ie}constructor(H){this.buffer=H,this.byteLength=this.buffer.byteLength}clone(){const H=l.alloc(this.byteLength);return H.set(this),H}toString(){return i?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(H,Q){return new l(this.buffer.subarray(H,Q))}set(H,Q){if(H instanceof l)this.buffer.set(H.buffer,Q);else if(H instanceof Uint8Array)this.buffer.set(H,Q);else if(H instanceof ArrayBuffer)this.buffer.set(new Uint8Array(H),Q);else if(ArrayBuffer.isView(H))this.buffer.set(new Uint8Array(H.buffer,H.byteOffset,H.byteLength),Q);else throw new Error("Unknown argument 'array'")}readUInt32BE(H){return r(this.buffer,H)}writeUInt32BE(H,Q){h(this.buffer,H,Q)}readUInt32LE(H){return e(this.buffer,H)}writeUInt32LE(H,Q){a(this.buffer,H,Q)}readUInt8(H){return o(this.buffer,H)}writeUInt8(H,Q){s(this.buffer,H,Q)}indexOf(H,Q=0){return u(this.buffer,H instanceof l?H.buffer:H,Q)}}t.$Ed=l;function u(A,H,Q=0){const ie=H.byteLength,re=A.byteLength;if(ie===0)return 0;if(ie===1)return A.indexOf(H[0]);if(ie>re-Q)return-1;const ue=_.value;ue.fill(H.length);for(let Ce=0;Ce<H.length;Ce++)ue[H[Ce]]=H.length-Ce-1;let he=Q+H.length-1,oe=he,ge=-1;for(;he<re;)if(A[he]===H[oe]){if(oe===0){ge=he;break}he--,oe--}else he+=Math.max(H.length-oe,ue[A[he]]),oe=H.length-1;return ge}t.$Fd=u;function f(A,H){return A[H+0]<<0>>>0|A[H+1]<<8>>>0}t.$Gd=f;function P(A,H,Q){A[Q+0]=H&255,H=H>>>8,A[Q+1]=H&255}t.$Hd=P;function r(A,H){return A[H]*2**24+A[H+1]*2**16+A[H+2]*2**8+A[H+3]}t.$Id=r;function h(A,H,Q){A[Q+3]=H,H=H>>>8,A[Q+2]=H,H=H>>>8,A[Q+1]=H,H=H>>>8,A[Q]=H}t.$Jd=h;function e(A,H){return A[H+0]<<0>>>0|A[H+1]<<8>>>0|A[H+2]<<16>>>0|A[H+3]<<24>>>0}t.$Kd=e;function a(A,H,Q){A[Q+0]=H&255,H=H>>>8,A[Q+1]=H&255,H=H>>>8,A[Q+2]=H&255,H=H>>>8,A[Q+3]=H&255}t.$Ld=a;function o(A,H){return A[H]}t.$Md=o;function s(A,H,Q){A[Q]=H}t.$Nd=s;function n(A){return O.$td(A,H=>l.concat(H))}t.$Od=n;function g(A){return O.$Ad(A)}t.$Pd=g;function b(A){return O.$vd(A,H=>l.concat(H))}t.$Qd=b;async function $(A){return A.ended?l.concat(A.buffer):l.concat([...A.buffer,await b(A.stream)])}t.$Rd=$;function c(A){return O.$yd(A,H=>l.concat(H))}t.$Sd=c;function F(A){return O.$Bd(A,{data:H=>typeof H=="string"?l.fromString(H):l.wrap(H)},H=>l.concat(H))}t.$Td=F;function R(A){return O.$sd(H=>l.concat(H),A)}t.$Ud=R;function T(A,H){return O.$Cd(A,H,Q=>l.concat(Q))}t.$Vd=T;function m(A,H){return O.$Dd(A,H,Q=>l.concat(Q))}t.$Wd=m;function v(A){let H=0,Q=0,ie=0;const re=new Uint8Array(Math.floor(A.length/4*3)),ue=oe=>{switch(Q){case 3:re[ie++]=H|oe,Q=0;break;case 2:re[ie++]=H|oe>>>2,H=oe<<6,Q=3;break;case 1:re[ie++]=H|oe>>>4,H=oe<<4,Q=2;break;default:H=oe<<2,Q=1}};for(let oe=0;oe<A.length;oe++){const ge=A.charCodeAt(oe);if(ge>=65&&ge<=90)ue(ge-65);else if(ge>=97&&ge<=122)ue(ge-97+26);else if(ge>=48&&ge<=57)ue(ge-48+52);else if(ge===43||ge===45)ue(62);else if(ge===47||ge===95)ue(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${A[oe]}`)}}const he=ie;for(;Q>0;)ue(0);return l.wrap(re).slice(0,he)}t.$Xd=v;const z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:A},H=!0,Q=!1){const ie=Q?U:z;let re="";const ue=A.byteLength%3;let he=0;for(;he<A.byteLength-ue;he+=3){const oe=A[he+0],ge=A[he+1],Ce=A[he+2];re+=ie[oe>>>2],re+=ie[(oe<<4|ge>>>4)&63],re+=ie[(ge<<2|Ce>>>6)&63],re+=ie[Ce&63]}if(ue===1){const oe=A[he+0];re+=ie[oe>>>2],re+=ie[oe<<4&63],H&&(re+="==")}else if(ue===2){const oe=A[he+0],ge=A[he+1];re+=ie[oe>>>2],re+=ie[(oe<<4|ge>>>4)&63],re+=ie[ge<<2&63],H&&(re+="=")}return re}t.$Yd=M}),define(be[12],pe([1,0,82,30]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hf=t.$gf=t.$ff=t.$ef=t.GraphemeBreakType=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=void 0;function i(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}t.$le=i;const _=/{(\d+)}/g;function D(Y,...ae){return ae.length===0?Y:Y.replace(_,function($e,De){const Oe=parseInt(De,10);return isNaN(Oe)||Oe<0||Oe>=ae.length?$e:ae[Oe]})}t.$me=D;const w=/{([^}]+)}/g;function l(Y,ae){return Y.replace(w,($e,De)=>ae[De]??$e)}t.$ne=l;function u(Y){return Y.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.$oe=u;function f(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$pe=f;function P(Y,ae){let $e=0;const De=ae.charCodeAt(0);for(let Oe=Y.length-1;Oe>=0;Oe--)Y.charCodeAt(Oe)===De&&$e++;return $e}t.$qe=P;function r(Y,ae,$e="\u2026"){return Y.length<=ae?Y:`${Y.substr(0,ae)}${$e}`}t.$re=r;function h(Y,ae=" "){const $e=e(Y,ae);return a($e,ae)}t.$se=h;function e(Y,ae){if(!Y||!ae)return Y;const $e=ae.length;if($e===0||Y.length===0)return Y;let De=0;for(;Y.indexOf(ae,De)===De;)De=De+$e;return Y.substring(De)}t.$te=e;function a(Y,ae){if(!Y||!ae)return Y;const $e=ae.length,De=Y.length;if($e===0||De===0)return Y;let Oe=De,Me=-1;for(;Me=Y.lastIndexOf(ae,Oe-1),!(Me===-1||Me+$e!==Oe);){if(Me===0)return"";Oe=Me}return Y.substring(0,Oe)}t.$ue=a;function o(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$ve=o;function s(Y){return Y.replace(/\*/g,"")}t.$we=s;function n(Y,ae,$e={}){if(!Y)throw new Error("Cannot create regex from empty string");ae||(Y=f(Y)),$e.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let De="";return $e.global&&(De+="g"),$e.matchCase||(De+="i"),$e.multiline&&(De+="m"),$e.unicode&&(De+="u"),new RegExp(Y,De)}t.$xe=n;function g(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}t.$ye=g;function b(Y){return Y.split(/\r\n|\r|\n/)}t.$ze=b;function $(Y){for(let ae=0,$e=Y.length;ae<$e;ae++){const De=Y.charCodeAt(ae);if(De!==32&&De!==9)return ae}return-1}t.$Ae=$;function c(Y,ae=0,$e=Y.length){for(let De=ae;De<$e;De++){const Oe=Y.charCodeAt(De);if(Oe!==32&&Oe!==9)return Y.substring(ae,De)}return Y.substring(ae,$e)}t.$Be=c;function F(Y,ae=Y.length-1){for(let $e=ae;$e>=0;$e--){const De=Y.charCodeAt($e);if(De!==32&&De!==9)return $e}return-1}t.$Ce=F;function R(Y,ae,$e){const De=[];let Oe=0;for(const Me of Y.matchAll(ae)){if(De.push(Y.slice(Oe,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Oe=Me.index+Me[0].length,De.push($e(Me[0],...Me.slice(1),Me.index,Y,Me.groups))}return De.push(Y.slice(Oe)),Promise.all(De).then(Me=>Me.join(""))}t.$De=R;function T(Y,ae){return Y<ae?-1:Y>ae?1:0}t.$Ee=T;function m(Y,ae,$e=0,De=Y.length,Oe=0,Me=ae.length){for(;$e<De&&Oe<Me;$e++,Oe++){const Ye=Y.charCodeAt($e),Ve=ae.charCodeAt(Oe);if(Ye<Ve)return-1;if(Ye>Ve)return 1}const ze=De-$e,Qe=Me-Oe;return ze<Qe?-1:ze>Qe?1:0}t.$Fe=m;function v(Y,ae){return z(Y,ae,0,Y.length,0,ae.length)}t.$Ge=v;function z(Y,ae,$e=0,De=Y.length,Oe=0,Me=ae.length){for(;$e<De&&Oe<Me;$e++,Oe++){let Ye=Y.charCodeAt($e),Ve=ae.charCodeAt(Oe);if(Ye===Ve)continue;if(Ye>=128||Ve>=128)return m(Y.toLowerCase(),ae.toLowerCase(),$e,De,Oe,Me);M(Ye)&&(Ye-=32),M(Ve)&&(Ve-=32);const We=Ye-Ve;if(We!==0)return We}const ze=De-$e,Qe=Me-Oe;return ze<Qe?-1:ze>Qe?1:0}t.$He=z;function U(Y){return Y>=48&&Y<=57}t.$Ie=U;function M(Y){return Y>=97&&Y<=122}t.$Je=M;function A(Y){return Y>=65&&Y<=90}t.$Ke=A;function H(Y,ae){return Y.length===ae.length&&z(Y,ae)===0}t.$Le=H;function Q(Y,ae){const $e=ae.length;return ae.length>Y.length?!1:z(Y,ae,0,$e)===0}t.$Me=Q;function ie(Y,ae){const $e=Math.min(Y.length,ae.length);let De;for(De=0;De<$e;De++)if(Y.charCodeAt(De)!==ae.charCodeAt(De))return De;return $e}t.$Ne=ie;function re(Y,ae){const $e=Math.min(Y.length,ae.length);let De;const Oe=Y.length-1,Me=ae.length-1;for(De=0;De<$e;De++)if(Y.charCodeAt(Oe-De)!==ae.charCodeAt(Me-De))return De;return $e}t.$Oe=re;function ue(Y){return 55296<=Y&&Y<=56319}t.$Pe=ue;function he(Y){return 56320<=Y&&Y<=57343}t.$Qe=he;function oe(Y,ae){return(Y-55296<<10)+(ae-56320)+65536}t.$Re=oe;function ge(Y,ae,$e){const De=Y.charCodeAt($e);if(ue(De)&&$e+1<ae){const Oe=Y.charCodeAt($e+1);if(he(Oe))return oe(De,Oe)}return De}t.$Se=ge;function Ce(Y,ae){const $e=Y.charCodeAt(ae-1);if(he($e)&&ae>1){const De=Y.charCodeAt(ae-2);if(ue(De))return oe(De,$e)}return $e}class Se{get offset(){return this.e}constructor(ae,$e=0){this.c=ae,this.d=ae.length,this.e=$e}setOffset(ae){this.e=ae}prevCodePoint(){const ae=Ce(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=ge(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}t.$Te=Se;class Re{get offset(){return this.c.offset}constructor(ae,$e=0){this.c=new Se(ae,$e)}nextGraphemeLength(){const ae=Ee.getInstance(),$e=this.c,De=$e.offset;let Oe=ae.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Me=$e.offset,ze=ae.getGraphemeBreakType($e.nextCodePoint());if(we(Oe,ze)){$e.setOffset(Me);break}Oe=ze}return $e.offset-De}prevGraphemeLength(){const ae=Ee.getInstance(),$e=this.c,De=$e.offset;let Oe=ae.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Me=$e.offset,ze=ae.getGraphemeBreakType($e.prevCodePoint());if(we(ze,Oe)){$e.setOffset(Me);break}Oe=ze}return De-$e.offset}eol(){return this.c.eol()}}t.$Ue=Re;function fe(Y,ae){return new Re(Y,ae).nextGraphemeLength()}t.$Ve=fe;function ne(Y,ae){return new Re(Y,ae).prevGraphemeLength()}t.$We=ne;function G(Y,ae){ae>0&&he(Y.charCodeAt(ae))&&ae--;const $e=ae+fe(Y,ae);return[$e-ne(Y,$e),$e]}t.$Xe=G;function V(Y){const ae=new Re(Y);let $e=0;for(;!ae.eol();)$e++,ae.nextGraphemeLength();return $e}t.$Ye=V;let ee;function Z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(Y){return ee||(ee=Z()),ee.test(Y)}t.$Ze=C;const x=/^[\t\n\r\x20-\x7E]*$/;function d(Y){return x.test(Y)}t.$1e=d,t.$2e=/[\u2028\u2029]/;function p(Y){return t.$2e.test(Y)}t.$3e=p;function E(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}t.$4e=E;function I(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}t.$5e=I;function N(Y,ae){if(Y.length<ae)return Y;const $e=/\b/g;let De=0;for(;$e.test(Y)&&!(Y.length-$e.lastIndex<ae);)De=$e.lastIndex,$e.lastIndex+=1;return Y.substring(De).replace(/^\s/,"")}t.$6e=N;const B=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,q=/\x1b\].*?\x07/g;function L(Y){return Y&&(Y=Y.replace(B,"").replace(q,"")),Y}t.$7e=L,t.$8e=String.fromCharCode(65279);function j(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}t.$9e=j;function S(Y){return j(Y)?Y.substr(1):Y}t.$0e=S;function k(Y,ae){if(!Y||!ae||Y.length<ae.length)return!1;const $e=ae.length,De=Y.toLowerCase();let Oe=0,Me=-1;for(;Oe<$e;){const ze=De.indexOf(ae[Oe],Me+1);if(ze<0)return!1;Me=ze,Oe++}return!0}t.$$e=k;function W(Y,ae=!1){return Y?(ae&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}t.$_e=W;function K(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}t.$af=K;function te(Y,ae=1){if(ae===0)return"";let $e=-1;do $e=Y.indexOf(`
`,$e+1),ae--;while(ae>0&&$e>=0);return $e===-1?Y:(Y[$e-1]==="\r"&&$e--,Y.substr(0,$e))}t.$bf=te;function se(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}t.$cf=se;function me(Y){return Ee.getInstance().getGraphemeBreakType(Y)}t.$df=me;function we(Y,ae){return Y===0?ae!==5&&ae!==7:Y===2&&ae===3?!1:Y===4||Y===2||Y===3||ae===4||ae===2||ae===3?!0:!(Y===8&&(ae===8||ae===9||ae===11||ae===12)||(Y===11||Y===9)&&(ae===9||ae===10)||(Y===12||Y===10)&&ae===10||ae===5||ae===13||ae===7||Y===1||Y===13&&ae===14||Y===6&&ae===6)}var Ne;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(t.GraphemeBreakType=Ne={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=ve()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const $e=this.d,De=$e.length/3;let Oe=1;for(;Oe<=De;)if(ae<$e[3*Oe])Oe=2*Oe;else if(ae>$e[3*Oe+1])Oe=2*Oe+1;else return $e[3*Oe+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(Y,ae){if(Y===0)return 0;const $e=Pe(Y,ae);if($e!==void 0)return $e;const De=new Se(ae,Y);return De.prevCodePoint(),De.offset}t.$ef=Te;function Pe(Y,ae){const $e=new Se(ae,Y);let De=$e.prevCodePoint();for(;qe(De)||De===65039||De===8419;){if($e.offset===0)return;De=$e.prevCodePoint()}if(!I(De))return;let Oe=$e.offset;return Oe>0&&$e.prevCodePoint()===8205&&(Oe=$e.offset),Oe}function qe(Y){return 127995<=Y&&Y<=127999}var je;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$ff="\xA0";class Ie{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$he(ae=>{function $e(We){const et=new Map;for(let it=0;it<We.length;it+=2)et.set(We[it],We[it+1]);return et}function De(We,et){const it=new Map(We);for(const[ft,ct]of et)it.set(ft,ct);return it}function Oe(We,et){if(!We)return et;const it=new Map;for(const[ft,ct]of We)et.has(ft)&&it.set(ft,ct);return it}const Me=this.c.value;let ze=ae.filter(We=>!We.startsWith("_")&&We in Me);ze.length===0&&(ze=["_default"]);let Qe;for(const We of ze){const et=$e(Me[We]);Qe=Oe(Qe,et)}const Ye=$e(Me._common),Ve=De(Ye,Qe);return new Ie(Ve)})}static getInstance(ae){return Ie.d.get(Array.from(ae))}static{this.e=new O.$T(()=>Object.keys(Ie.c.value).filter(ae=>!ae.startsWith("_")))}static getLocales(){return Ie.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$gf=Ie;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(ae){return Ge.e().has(ae)}static get codePoints(){return Ge.e()}}t.$hf=Ge}),define(be[32],pe([1,0,76,12]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.FuzzyScore=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.$Bj=t.$Aj=t.$zj=t.$yj=t.$xj=t.$wj=t.or=void 0;function i(...S){return function(k,W){for(let K=0,te=S.length;K<te;K++){const se=S[K](k,W);if(se)return se}return null}}t.or=i,t.$wj=_.bind(void 0,!1),t.$xj=_.bind(void 0,!0);function _(S,k,W){if(!W||W.length<k.length)return null;let K;return S?K=O.$Me(W,k):K=W.indexOf(k)===0,K?k.length>0?[{start:0,end:k.length}]:[]:null}function D(S,k){const W=k.toLowerCase().indexOf(S.toLowerCase());return W===-1?null:[{start:W,end:W+S.length}]}t.$yj=D;function w(S,k){return l(S.toLowerCase(),k.toLowerCase(),0,0)}t.$zj=w;function l(S,k,W,K){if(W===S.length)return[];if(K===k.length)return null;if(S[W]===k[K]){let te=null;return(te=l(S,k,W+1,K+1))?s({start:K,end:K+1},te):null}return l(S,k,W,K+1)}function u(S){return 97<=S&&S<=122}function f(S){return 65<=S&&S<=90}t.$Aj=f;function P(S){return 48<=S&&S<=57}function r(S){return S===32||S===9||S===10||S===13}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>h.add(S.charCodeAt(0)));function e(S){return r(S)||h.has(S)}function a(S,k){return S===k||e(S)&&e(k)}function o(S){return u(S)||f(S)||P(S)}function s(S,k){return k.length===0?k=[S]:S.end===k[0].start?k[0].start=S.start:k.unshift(S),k}function n(S,k){for(let W=k;W<S.length;W++){const K=S.charCodeAt(W);if(f(K)||P(K)||W>0&&!o(S.charCodeAt(W-1)))return W}return S.length}function g(S,k,W,K){if(W===S.length)return[];if(K===k.length)return null;if(S[W]!==k[K].toLowerCase())return null;{let te=null,se=K+1;for(te=g(S,k,W+1,K+1);!te&&(se=n(k,se))<k.length;)te=g(S,k,W+1,se),se++;return te===null?null:s({start:K,end:K+1},te)}}function b(S){let k=0,W=0,K=0,te=0,se=0;for(let ve=0;ve<S.length;ve++)se=S.charCodeAt(ve),f(se)&&k++,u(se)&&W++,o(se)&&K++,P(se)&&te++;const me=k/S.length,we=W/S.length,Ne=K/S.length,Ee=te/S.length;return{upperPercent:me,lowerPercent:we,alphaPercent:Ne,numericPercent:Ee}}function $(S){const{upperPercent:k,lowerPercent:W}=S;return W===0&&k>.6}function c(S){const{upperPercent:k,lowerPercent:W,alphaPercent:K,numericPercent:te}=S;return W>.2&&k<.8&&K>.6&&te<.2}function F(S){let k=0,W=0,K=0,te=0;for(let se=0;se<S.length;se++)K=S.charCodeAt(se),f(K)&&k++,u(K)&&W++,r(K)&&te++;return(k===0||W===0)&&te===0?S.length<=30:k<=5}function R(S,k){if(!k||(k=k.trim(),k.length===0)||!F(S)||k.length>60)return null;const W=b(k);if(!c(W)){if(!$(W))return null;k=k.toLowerCase()}let K=null,te=0;for(S=S.toLowerCase();te<k.length&&(K=g(S,k,0,te))===null;)te=n(k,te+1);return K}t.$Bj=R;function T(S,k,W=!1){if(!k||k.length===0)return null;let K=null,te=0;for(S=S.toLowerCase(),k=k.toLowerCase();te<k.length&&(K=m(S,k,0,te,W))===null;)te=v(k,te+1);return K}t.$Cj=T;function m(S,k,W,K,te){if(W===S.length)return[];if(K===k.length)return null;if(a(S.charCodeAt(W),k.charCodeAt(K))){let se=null,me=K+1;if(se=m(S,k,W+1,K+1,te),!te)for(;!se&&(me=v(k,me))<k.length;)se=m(S,k,W+1,me,te),me++;return se?S.charCodeAt(W)!==k.charCodeAt(K)?se:s({start:K,end:K+1},se):null}else return null}function v(S,k){for(let W=k;W<S.length;W++)if(e(S.charCodeAt(W))||W>0&&e(S.charCodeAt(W-1)))return W;return S.length}const z=i(t.$xj,R,D),U=i(t.$xj,R,w),M=new y.$Bi(1e4);function A(S,k,W=!1){if(typeof S!="string"||typeof k!="string")return null;let K=M.get(S);K||(K=new RegExp(O.$ve(S),"i"),M.set(S,K));const te=K.exec(k);return te?[{start:te.index,end:te.index+te[0].length}]:W?U(S,k):z(S,k)}t.$Dj=A;function H(S,k){const W=E(S,S.toLowerCase(),0,k,k.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?ie(W):null}t.$Ej=H;function Q(S,k,W,K,te,se){const me=Math.min(13,S.length);for(;W<me;W++){const we=E(S,k,W,K,te,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,se]}t.$Fj=Q;function ie(S){if(typeof S>"u")return[];const k=[],W=S[1];for(let K=S.length-1;K>1;K--){const te=S[K]+W,se=k[k.length-1];se&&se.end===te?se.end=te+1:k.push({start:te,end:te+1})}return k}t.$Gj=ie;const re=128;function ue(){const S=[],k=[];for(let W=0;W<=re;W++)k[W]=0;for(let W=0;W<=re;W++)S.push(k.slice(0));return S}function he(S){const k=[];for(let W=0;W<=S;W++)k[W]=0;return k}const oe=he(2*re),ge=he(2*re),Ce=ue(),Se=ue(),Re=ue(),fe=!1;function ne(S,k,W,K,te){function se(we,Ne,Ee=" "){for(;we.length<Ne;)we=Ee+we;return we}let me=` |   |${K.split("").map(we=>se(we,3)).join("|")}
`;for(let we=0;we<=W;we++)we===0?me+=" |":me+=`${k[we-1]}|`,me+=S[we].slice(0,te+1).map(Ne=>se(Ne.toString(),3)).join("|")+`
`;return me}function G(S,k,W,K){S=S.substr(k),W=W.substr(K),console.log(ne(Se,S,S.length,W,W.length)),console.log(ne(Re,S,S.length,W,W.length)),console.log(ne(Ce,S,S.length,W,W.length))}function V(S,k){if(k<0||k>=S.length)return!1;const W=S.codePointAt(k);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$5e(W)}}function ee(S,k){if(k<0||k>=S.length)return!1;switch(S.charCodeAt(k)){case 32:case 9:return!0;default:return!1}}function Z(S,k,W){return k[S]!==W[S]}function C(S,k,W,K,te,se,me=!1){for(;k<W&&te<se;)S[k]===K[te]&&(me&&(oe[k]=te),k+=1),te+=1;return k===W}t.$Hj=C;var x;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(x||(x={}));var d;(function(S){S.Default=[-100,0];function k(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}S.isDefault=k})(d||(t.FuzzyScore=d={}));class p{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(k,W){this.firstMatchCanBeWeak=k,this.boostFullMatch=W}}t.$Ij=p;function E(S,k,W,K,te,se,me=p.default){const we=S.length>re?re:S.length,Ne=K.length>re?re:K.length;if(W>=we||se>=Ne||we-W>Ne-se||!C(k,W,we,te,se,Ne,!0))return;I(we,Ne,W,se,k,te);let Ee=1,ve=1,Te=W,Pe=se;const qe=[!1];for(Ee=1,Te=W;Te<we;Ee++,Te++){const ae=oe[Te],$e=ge[Te],De=Te+1<we?ge[Te+1]:Ne;for(ve=ae-se+1,Pe=ae;Pe<De;ve++,Pe++){let Oe=Number.MIN_SAFE_INTEGER,Me=!1;Pe<=$e&&(Oe=N(S,k,Te,W,K,te,Pe,Ne,se,Ce[Ee-1][ve-1]===0,qe));let ze=0;Oe!==Number.MAX_SAFE_INTEGER&&(Me=!0,ze=Oe+Se[Ee-1][ve-1]);const Qe=Pe>ae,Ye=Qe?Se[Ee][ve-1]+(Ce[Ee][ve-1]>0?-5:0):0,Ve=Pe>ae+1&&Ce[Ee][ve-1]>0,We=Ve?Se[Ee][ve-2]+(Ce[Ee][ve-2]>0?-5:0):0;if(Ve&&(!Qe||We>=Ye)&&(!Me||We>=ze))Se[Ee][ve]=We,Re[Ee][ve]=3,Ce[Ee][ve]=0;else if(Qe&&(!Me||Ye>=ze))Se[Ee][ve]=Ye,Re[Ee][ve]=2,Ce[Ee][ve]=0;else if(Me)Se[Ee][ve]=ze,Re[Ee][ve]=1,Ce[Ee][ve]=Ce[Ee-1][ve-1]+1;else throw new Error("not possible")}}if(fe&&G(S,W,K,se),!qe[0]&&!me.firstMatchCanBeWeak)return;Ee--,ve--;const je=[Se[Ee][ve],se];let Ie=0,Ge=0;for(;Ee>=1;){let ae=ve;do{const $e=Re[Ee][ae];if($e===3)ae=ae-2;else if($e===2)ae=ae-1;else break}while(ae>=1);Ie>1&&k[W+Ee-1]===te[se+ve-1]&&!Z(ae+se-1,K,te)&&Ie+1>Ce[Ee][ae]&&(ae=ve),ae===ve?Ie++:Ie=1,Ge||(Ge=ae),Ee--,ve=ae-1,je.push(ve)}Ne===we&&me.boostFullMatch&&(je[0]+=2);const Y=Ge-we;return je[0]-=Y,je}t.$Jj=E;function I(S,k,W,K,te,se){let me=S-1,we=k-1;for(;me>=W&&we>=K;)te[me]===se[we]&&(ge[me]=we,me--),we--}function N(S,k,W,K,te,se,me,we,Ne,Ee,ve){if(k[W]!==se[me])return Number.MIN_SAFE_INTEGER;let Te=1,Pe=!1;return me===W-K?Te=S[W]===te[me]?7:5:Z(me,te,se)&&(me===0||!Z(me-1,te,se))?(Te=S[W]===te[me]?7:5,Pe=!0):V(se,me)&&(me===0||!V(se,me-1))?Te=5:(V(se,me-1)||ee(se,me-1))&&(Te=5,Pe=!0),Te>1&&W===K&&(ve[0]=!0),Pe||(Pe=Z(me,te,se)||V(se,me-1)||ee(se,me-1)),W===K?me>Ne&&(Te-=Pe?3:5):Ee?Te+=Pe?2:0:Te+=Pe?0:1,me+1===we&&(Te-=Pe?3:5),Te}function B(S,k,W,K,te,se,me){return L(S,k,W,K,te,se,!0,me)}t.$Kj=B;function q(S,k,W,K,te,se,me){return L(S,k,W,K,te,se,!1,me)}t.$Lj=q;function L(S,k,W,K,te,se,me,we){let Ne=E(S,k,W,K,te,se,we);if(Ne&&!me)return Ne;if(S.length>=3){const Ee=Math.min(7,S.length-1);for(let ve=W+1;ve<Ee;ve++){const Te=j(S,ve);if(Te){const Pe=E(Te,Te.toLowerCase(),W,K,te,se,we);Pe&&(Pe[0]-=3,(!Ne||Pe[0]>Ne[0])&&(Ne=Pe))}}}return Ne}function j(S,k){if(k+1>=S.length)return;const W=S[k],K=S[k+1];if(W!==K)return S.slice(0,k)+K+W+S.slice(k+2)}}),define(be[84],pe([1,0,12]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ui=t.$ti=t.$si=t.$ri=t.$qi=t.$pi=t.$oi=void 0;function O(s){return i(s,0)}t.$oi=O;function i(s,n){switch(typeof s){case"object":return s===null?_(349,n):Array.isArray(s)?l(s,n):u(s,n);case"string":return w(s,n);case"boolean":return D(s,n);case"number":return _(s,n);case"undefined":return _(937,n);default:return _(617,n)}}t.$pi=i;function _(s,n){return(n<<5)-n+s|0}t.$qi=_;function D(s,n){return _(s?433:863,n)}function w(s,n){n=_(149417,n);for(let g=0,b=s.length;g<b;g++)n=_(s.charCodeAt(g),n);return n}t.$ri=w;function l(s,n){return n=_(104579,n),s.reduce((g,b)=>i(b,g),n)}function u(s,n){return n=_(181387,n),Object.keys(s).sort().reduce((g,b)=>(g=w(b,g),i(s[b],g)),n)}class f{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$si=f;var P;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function r(s,n,g=32){const b=g-n,$=~((1<<b)-1);return(s<<n|($&s)>>>b)>>>0}function h(s,n=0,g=s.byteLength,b=0){for(let $=0;$<g;$++)s[n+$]=b}function e(s,n,g="0"){for(;s.length<n;)s=g+s;return s}function a(s,n=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(g=>g.toString(16).padStart(2,"0")).join(""):e((s>>>0).toString(16),n/4)}t.$ti=a;class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const g=n.length;if(g===0)return;const b=this.p;let $=this.r,c=this.u,F,R;for(c!==0?(F=c,R=-1,c=0):(F=n.charCodeAt(0),R=0);;){let T=F;if(y.$Pe(F))if(R+1<g){const m=n.charCodeAt(R+1);y.$Qe(m)?(R++,T=y.$Re(F,m)):T=65533}else{c=F;break}else y.$Qe(F)&&(T=65533);if($=this.w(b,$,T),R++,R<g)F=n.charCodeAt(R);else break}this.r=$,this.u=c}w(n,g,b){return b<128?n[g++]=b:b<2048?(n[g++]=192|(b&1984)>>>6,n[g++]=128|(b&63)>>>0):b<65536?(n[g++]=224|(b&61440)>>>12,n[g++]=128|(b&4032)>>>6,n[g++]=128|(b&63)>>>0):(n[g++]=240|(b&1835008)>>>18,n[g++]=128|(b&258048)>>>12,n[g++]=128|(b&4032)>>>6,n[g++]=128|(b&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=o.g,g=this.q;for(let z=0;z<64;z+=4)n.setUint32(z,g.getUint32(z,!1),!1);for(let z=64;z<320;z+=4)n.setUint32(z,r(n.getUint32(z-12,!1)^n.getUint32(z-32,!1)^n.getUint32(z-56,!1)^n.getUint32(z-64,!1),1),!1);let b=this.h,$=this.l,c=this.m,F=this.n,R=this.o,T,m,v;for(let z=0;z<80;z++)z<20?(T=$&c|~$&F,m=1518500249):z<40?(T=$^c^F,m=1859775393):z<60?(T=$&c|$&F|c&F,m=2400959708):(T=$^c^F,m=3395469782),v=r(b,5)+T+R+m+n.getUint32(z*4,!1)&4294967295,R=F,F=c,c=r($,30),$=b,b=v;this.h=this.h+b&4294967295,this.l=this.l+$&4294967295,this.m=this.m+c&4294967295,this.n=this.n+F&4294967295,this.o=this.o+R&4294967295}}t.$ui=o}),define(be[85],pe([1,0,72,84]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$os=t.$ns=t.$ms=void 0;class i{constructor(r){this.a=r}getElements(){const r=this.a,h=new Int32Array(r.length);for(let e=0,a=r.length;e<a;e++)h[e]=r.charCodeAt(e);return h}}t.$ms=i;function _(P,r,h){return new f(new i(P),new i(r)).ComputeDiff(h).changes}t.$ns=_;class D{static Assert(r,h){if(!r)throw new Error(h)}}class w{static Copy(r,h,e,a,o){for(let s=0;s<o;s++)e[a+s]=r[h+s]}static Copy2(r,h,e,a,o){for(let s=0;s<o;s++)e[a+s]=r[h+s]}}var l;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.$ls(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,h){this.b=Math.min(this.b,r),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(r,h){this.b=Math.min(this.b,r),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(r,h,e=null){this.a=e,this.b=r,this.c=h;const[a,o,s]=f.o(r),[n,g,b]=f.o(h);this.d=s&&b,this.e=a,this.f=o,this.g=n,this.h=g,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const h=r.getElements();if(f.n(h)){const e=new Int32Array(h.length);for(let a=0,o=h.length;a<o;a++)e[a]=(0,O.$ri)(h[a],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(r,h){return this.f[r]!==this.h[h]?!1:this.d?this.e[r]===this.g[h]:!0}q(r,h){if(!this.p(r,h))return!1;const e=f.r(this.b,r),a=f.r(this.c,h);return e===a}static r(r,h){return typeof r.getStrictElement=="function"?r.getStrictElement(h):null}s(r,h){return this.f[r]!==this.f[h]?!1:this.d?this.e[r]===this.e[h]:!0}u(r,h){return this.h[r]!==this.h[h]?!1:this.d?this.g[r]===this.g[h]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,h,e,a,o){const s=[!1];let n=this.w(r,h,e,a,s);return o&&(n=this.z(n)),{quitEarly:s[0],changes:n}}w(r,h,e,a,o){for(o[0]=!1;r<=h&&e<=a&&this.p(r,e);)r++,e++;for(;h>=r&&a>=e&&this.p(h,a);)h--,a--;if(r>h||e>a){let c;return e<=a?(D.Assert(r===h+1,"originalStart should only be one more than originalEnd"),c=[new y.$ls(r,0,e,a-e+1)]):r<=h?(D.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),c=[new y.$ls(r,h-r+1,e,0)]):(D.Assert(r===h+1,"originalStart should only be one more than originalEnd"),D.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),c=[]),c}const s=[0],n=[0],g=this.y(r,h,e,a,s,n,o),b=s[0],$=n[0];if(g!==null)return g;if(!o[0]){const c=this.w(r,b,e,$,o);let F=[];return o[0]?F=[new y.$ls(b+1,h-(b+1)+1,$+1,a-($+1)+1)]:F=this.w(b+1,h,$+1,a,o),this.H(c,F)}return[new y.$ls(r,h-r+1,e,a-e+1)]}x(r,h,e,a,o,s,n,g,b,$,c,F,R,T,m,v,z,U){let M=null,A=null,H=new u,Q=h,ie=e,re=R[0]-v[0]-a,ue=-1073741824,he=this.k.length-1;do{const oe=re+r;oe===Q||oe<ie&&b[oe-1]<b[oe+1]?(c=b[oe+1],T=c-re-a,c<ue&&H.MarkNextChange(),ue=c,H.AddModifiedElement(c+1,T),re=oe+1-r):(c=b[oe-1]+1,T=c-re-a,c<ue&&H.MarkNextChange(),ue=c-1,H.AddOriginalElement(c,T+1),re=oe-1-r),he>=0&&(b=this.k[he],r=b[0],Q=1,ie=b.length-1)}while(--he>=-1);if(M=H.getReverseChanges(),U[0]){let oe=R[0]+1,ge=v[0]+1;if(M!==null&&M.length>0){const Ce=M[M.length-1];oe=Math.max(oe,Ce.getOriginalEnd()),ge=Math.max(ge,Ce.getModifiedEnd())}A=[new y.$ls(oe,F-oe+1,ge,m-ge+1)]}else{H=new u,Q=s,ie=n,re=R[0]-v[0]-g,ue=1073741824,he=z?this.m.length-1:this.m.length-2;do{const oe=re+o;oe===Q||oe<ie&&$[oe-1]>=$[oe+1]?(c=$[oe+1]-1,T=c-re-g,c>ue&&H.MarkNextChange(),ue=c+1,H.AddOriginalElement(c+1,T+1),re=oe+1-o):(c=$[oe-1],T=c-re-g,c>ue&&H.MarkNextChange(),ue=c,H.AddModifiedElement(c+1,T+1),re=oe-1-o),he>=0&&($=this.m[he],o=$[0],Q=1,ie=$.length-1)}while(--he>=-1);A=H.getChanges()}return this.H(M,A)}y(r,h,e,a,o,s,n){let g=0,b=0,$=0,c=0,F=0,R=0;r--,e--,o[0]=0,s[0]=0,this.k=[],this.m=[];const T=h-r+(a-e),m=T+1,v=new Int32Array(m),z=new Int32Array(m),U=a-e,M=h-r,A=r-e,H=h-a,ie=(M-U)%2===0;v[U]=r,z[M]=h,n[0]=!1;for(let re=1;re<=T/2+1;re++){let ue=0,he=0;$=this.J(U-re,re,U,m),c=this.J(U+re,re,U,m);for(let ge=$;ge<=c;ge+=2){ge===$||ge<c&&v[ge-1]<v[ge+1]?g=v[ge+1]:g=v[ge-1]+1,b=g-(ge-U)-A;const Ce=g;for(;g<h&&b<a&&this.p(g+1,b+1);)g++,b++;if(v[ge]=g,g+b>ue+he&&(ue=g,he=b),!ie&&Math.abs(ge-M)<=re-1&&g>=z[ge])return o[0]=g,s[0]=b,Ce<=z[ge]&&1447>0&&re<=1447+1?this.x(U,$,c,A,M,F,R,H,v,z,g,h,o,b,a,s,ie,n):null}const oe=(ue-r+(he-e)-re)/2;if(this.a!==null&&!this.a(ue,oe))return n[0]=!0,o[0]=ue,s[0]=he,oe>0&&1447>0&&re<=1447+1?this.x(U,$,c,A,M,F,R,H,v,z,g,h,o,b,a,s,ie,n):(r++,e++,[new y.$ls(r,h-r+1,e,a-e+1)]);F=this.J(M-re,re,M,m),R=this.J(M+re,re,M,m);for(let ge=F;ge<=R;ge+=2){ge===F||ge<R&&z[ge-1]>=z[ge+1]?g=z[ge+1]-1:g=z[ge-1],b=g-(ge-M)-H;const Ce=g;for(;g>r&&b>e&&this.p(g,b);)g--,b--;if(z[ge]=g,ie&&Math.abs(ge-U)<=re&&g<=v[ge])return o[0]=g,s[0]=b,Ce>=v[ge]&&1447>0&&re<=1447+1?this.x(U,$,c,A,M,F,R,H,v,z,g,h,o,b,a,s,ie,n):null}if(re<=1447){let ge=new Int32Array(c-$+2);ge[0]=U-$+1,w.Copy2(v,$,ge,1,c-$+1),this.k.push(ge),ge=new Int32Array(R-F+2),ge[0]=M-F+1,w.Copy2(z,F,ge,1,R-F+1),this.m.push(ge)}}return this.x(U,$,c,A,M,F,R,H,v,z,g,h,o,b,a,s,ie,n)}z(r){for(let h=0;h<r.length;h++){const e=r[h],a=h<r.length-1?r[h+1].originalStart:this.f.length,o=h<r.length-1?r[h+1].modifiedStart:this.h.length,s=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<a&&e.modifiedStart+e.modifiedLength<o&&(!s||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const g=[null];if(h<r.length-1&&this.I(r[h],r[h+1],g)){r[h]=g[0],r.splice(h+1,1),h--;continue}}for(let h=r.length-1;h>=0;h--){const e=r[h];let a=0,o=0;if(h>0){const c=r[h-1];a=c.originalStart+c.originalLength,o=c.modifiedStart+c.modifiedLength}const s=e.originalLength>0,n=e.modifiedLength>0;let g=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let c=1;;c++){const F=e.originalStart-c,R=e.modifiedStart-c;if(F<a||R<o||s&&!this.s(F,F+e.originalLength)||n&&!this.u(R,R+e.modifiedLength))break;const m=(F===a&&R===o?5:0)+this.G(F,e.originalLength,R,e.modifiedLength);m>b&&(b=m,g=c)}e.originalStart-=g,e.modifiedStart-=g;const $=[null];if(h>0&&this.I(r[h-1],r[h],$)){r[h-1]=$[0],r.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=r.length;h<e;h++){const a=r[h-1],o=r[h],s=o.originalStart-a.originalStart-a.originalLength,n=a.originalStart,g=o.originalStart+o.originalLength,b=g-n,$=a.modifiedStart,c=o.modifiedStart+o.modifiedLength,F=c-$;if(s<5&&b<20&&F<20){const R=this.A(n,b,$,F,s);if(R){const[T,m]=R;(T!==a.originalStart+a.originalLength||m!==a.modifiedStart+a.modifiedLength)&&(a.originalLength=T-a.originalStart,a.modifiedLength=m-a.modifiedStart,o.originalStart=T+s,o.modifiedStart=m+s,o.originalLength=g-o.originalStart,o.modifiedLength=c-o.modifiedStart)}}}return r}A(r,h,e,a,o){if(h<o||a<o)return null;const s=r+h-o+1,n=e+a-o+1;let g=0,b=0,$=0;for(let c=r;c<s;c++)for(let F=e;F<n;F++){const R=this.B(c,F,o);R>0&&R>g&&(g=R,b=c,$=F)}return g>0?[b,$]:null}B(r,h,e){let a=0;for(let o=0;o<e;o++){if(!this.p(r+o,h+o))return 0;a+=this.e[r+o].length}return a}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,h){if(this.C(r)||this.C(r-1))return!0;if(h>0){const e=r+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,h){if(this.E(r)||this.E(r-1))return!0;if(h>0){const e=r+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,h,e,a){const o=this.D(r,h)?1:0,s=this.F(e,a)?1:0;return o+s}H(r,h){const e=[];if(r.length===0||h.length===0)return h.length>0?h:r;if(this.I(r[r.length-1],h[0],e)){const a=new Array(r.length+h.length-1);return w.Copy(r,0,a,0,r.length-1),a[r.length-1]=e[0],w.Copy(h,1,a,r.length,h.length-1),a}else{const a=new Array(r.length+h.length);return w.Copy(r,0,a,0,r.length),w.Copy(h,0,a,r.length,h.length),a}}I(r,h,e){if(D.Assert(r.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),D.Assert(r.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=h.originalStart||r.modifiedStart+r.modifiedLength>=h.modifiedStart){const a=r.originalStart;let o=r.originalLength;const s=r.modifiedStart;let n=r.modifiedLength;return r.originalStart+r.originalLength>=h.originalStart&&(o=h.originalStart+h.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=h.modifiedStart&&(n=h.modifiedStart+h.modifiedLength-r.modifiedStart),e[0]=new y.$ls(a,o,s,n),!0}else return e[0]=null,!1}J(r,h,e,a){if(r>=0&&r<a)return r;const o=e,s=a-e-1,n=h%2===0;if(r<0){const g=o%2===0;return n===g?0:1}else{const g=s%2===0;return n===g?a-1:a-2}}}t.$os=f}),define(be[48],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bd=void 0,t.$bd=Symbol("MicrotaskDelay")}),define(be[86],pe([1,0,11,12]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=void 0;class i{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const e=h.charCodeAt(0),a=this.b.charCodeAt(this.c);return e-a}value(){return this.b[this.c]}}t.$Ch=i;class _{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,O.$Fe)(h,this.b,0,h.length,this.c,this.d):(0,O.$He)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Dh=_;class D{constructor(h=!0,e=!0){this.f=h,this.g=e}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let e=h.length-1;e>=0;e--,this.c--){const a=this.b.charCodeAt(e);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,O.$Fe)(h,this.b,0,h.length,this.d,this.e):(0,O.$He)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Eh=D;var w;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(w||(w={}));class l{constructor(h,e){this.f=h,this.g=e,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,O.$Ge)(h,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Ge)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,O.$Ee)(h,this.c.query);if(this.d[this.e]===5)return(0,O.$Ee)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Fh=l;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(f||(f={}));class P{static forUris(h=()=>!1,e=()=>!1){return new P(new l(h,e))}static forPaths(h=!1){return new P(new D(void 0,!h))}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new _)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,e){if(e){const a=e.slice(0);(0,y.$Ub)(a);for(const o of a)this.set(o,h)}else{const a=h.slice(0);(0,y.$Ub)(a);for(const o of a)this.set(o[0],o[1])}}set(h,e){const a=this.b.reset(h);let o;this.c||(this.c=new u,this.c.segment=a.value());const s=[];for(o=this.c;;){const g=a.cmp(o.segment);if(g>0)o.left||(o.left=new u,o.left.segment=a.value()),s.push([-1,o]),o=o.left;else if(g<0)o.right||(o.right=new u,o.right.segment=a.value()),s.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new u,o.mid.segment=a.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=e,o.key=h;for(let g=s.length-1;g>=0;g--){const b=s[g][1];b.updateHeight();const $=b.balanceFactor();if($<-1||$>1){const c=s[g][0],F=s[g+1][0];if(c===1&&F===1)s[g][1]=b.rotateLeft();else if(c===-1&&F===-1)s[g][1]=b.rotateRight();else if(c===1&&F===-1)b.right=s[g+1][1]=s[g+1][1].rotateRight(),s[g][1]=b.rotateLeft();else if(c===-1&&F===1)b.left=s[g+1][1]=s[g+1][1].rotateLeft(),s[g][1]=b.rotateRight();else throw new Error;if(g>0)switch(s[g-1][0]){case-1:s[g-1][1].left=s[g][1];break;case 1:s[g-1][1].right=s[g][1];break;case 0:s[g-1][1].mid=s[g][1];break}else this.c=s[0][1]}}return n}get(h){return this.d(h)?.value}d(h){const e=this.b.reset(h);let a=this.c;for(;a;){const o=e.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(e.hasNext())e.next(),a=a.mid;else break}return a}has(h){const e=this.d(h);return!(e?.value===void 0&&e?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,e){const a=this.b.reset(h),o=[];let s=this.c;for(;s;){const n=a.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(a.hasNext())a.next(),o.push([0,s]),s=s.mid;else break}if(s){if(e?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:g,value:b,segment:$}=n;this.e(n.key,!1),s.key=g,s.value=b,s.segment=$}}else{const n=s.left??s.right;if(o.length>0){const[g,b]=o[o.length-1];switch(g){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const g=o[n][1];g.updateHeight();const b=g.balanceFactor();if(b>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),o[n][1]=g.rotateLeft()):b<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),o[n][1]=g.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const e=this.b.reset(h);let a=this.c,o;for(;a;){const s=e.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(e.hasNext())e.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(h){return this.g(h,!1)}g(h,e){const a=this.b.reset(h);let o=this.c;for(;o;){const s=a.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this.h(o.mid):e?o.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[e,a]of this)h(a,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const e=[];return this.j(h,e),e[Symbol.iterator]()}j(h,e){h&&(h.left&&this.j(h.left,e),h.value&&e.push([h.key,h.value]),h.mid&&this.j(h.mid,e),h.right&&this.j(h.right,e))}_isBalanced(){const h=e=>{if(!e)return!0;const a=e.balanceFactor();return a<-1||a>1?!1:h(e.left)&&h(e.right)};return h(this.c)}}t.$Gh=P}),define(be[7],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=void 0;function y($){return typeof $=="string"}t.$if=y;function O($){return Array.isArray($)&&$.every(c=>y(c))}t.$jf=O;function i($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}t.$kf=i;function _($){const c=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof c}t.$lf=_;function D($){return typeof $=="number"&&!isNaN($)}t.$mf=D;function w($){return!!$&&typeof $[Symbol.iterator]=="function"}t.$nf=w;function l($){return $===!0||$===!1}t.$of=l;function u($){return typeof $>"u"}t.$pf=u;function f($){return!P($)}t.$qf=f;function P($){return u($)||$===null}t.$rf=P;function r($,c){if(!$)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}t.$sf=r;function h($){if(P($))throw new Error("Assertion Failed: argument is undefined or null");return $}t.$tf=h;function e(...$){const c=[];for(let F=0;F<$.length;F++){const R=$[F];if(P(R))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);c.push(R)}return c}t.$uf=e;const a=Object.prototype.hasOwnProperty;function o($){if(!i($))return!1;for(const c in $)if(a.call($,c))return!1;return!0}t.$vf=o;function s($){return typeof $=="function"}t.$wf=s;function n(...$){return $.length>0&&$.every(s)}t.$xf=n;function g($,c){const F=Math.min($.length,c.length);for(let R=0;R<F;R++)b($[R],c[R])}t.$yf=g;function b($,c){if(y(c)){if(typeof $!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(s(c)){try{if($ instanceof c)return}catch{}if(!P($)&&$.constructor===c||c.length===1&&c.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$zf=b}),define(be[17],pe([1,0,7]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oj=t.$Nj=t.$Mj=void 0;const O=Object.create(null);function i(w,l){if((0,y.$if)(l)){const u=O[l];if(u===void 0)throw new Error(`${w} references an unknown codicon: ${l}`);l=u}return O[w]=l,{id:w}}function _(){return O}t.$Mj=_;function D(){return Object.values(t.$Oj)}t.$Nj=D,t.$Oj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(be[49],pe([1,0,7]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6m=t.$5m=t.$4m=t.$3m=t.$2m=t.$1m=t.$Zm=t.$Ym=t.$Xm=t.$Wm=t.$Vm=t.$Um=void 0;function O(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const n=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([g,b])=>{n[g]=b&&typeof b=="object"?O(b):b}),n}t.$Um=O;function i(s){if(!s||typeof s!="object")return s;const n=[s];for(;n.length>0;){const g=n.shift();Object.freeze(g);for(const b in g)if(_.call(g,b)){const $=g[b];typeof $=="object"&&!Object.isFrozen($)&&!(0,y.$lf)($)&&n.push($)}}return s}t.$Vm=i;const _=Object.prototype.hasOwnProperty;function D(s,n){return w(s,n,new Set)}t.$Wm=D;function w(s,n,g){if((0,y.$rf)(s))return s;const b=n(s);if(typeof b<"u")return b;if(Array.isArray(s)){const $=[];for(const c of s)$.push(w(c,n,g));return $}if((0,y.$kf)(s)){if(g.has(s))throw new Error("Cannot clone recursive data-structure");g.add(s);const $={};for(const c in s)_.call(s,c)&&($[c]=w(s[c],n,g));return g.delete(s),$}return s}function l(s,n,g=!0){return(0,y.$kf)(s)?((0,y.$kf)(n)&&Object.keys(n).forEach(b=>{b in s?g&&((0,y.$kf)(s[b])&&(0,y.$kf)(n[b])?l(s[b],n[b],g):s[b]=n[b]):s[b]=n[b]}),s):n}t.$Xm=l;function u(s,n){if(s===n)return!0;if(s==null||n===null||n===void 0||typeof s!=typeof n||typeof s!="object"||Array.isArray(s)!==Array.isArray(n))return!1;let g,b;if(Array.isArray(s)){if(s.length!==n.length)return!1;for(g=0;g<s.length;g++)if(!u(s[g],n[g]))return!1}else{const $=[];for(b in s)$.push(b);$.sort();const c=[];for(b in n)c.push(b);if(c.sort(),!u($,c))return!1;for(g=0;g<$.length;g++)if(!u(s[$[g]],n[$[g]]))return!1}return!0}t.$Ym=u;function f(s){const n=new Set;return JSON.stringify(s,(g,b)=>{if((0,y.$kf)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$Zm=f;function P(s,n){const g=Object.create(null);return!s||!n||Object.keys(n).forEach($=>{const c=s[$],F=n[$];u(c,F)||(g[$]=F)}),g}t.$1m=P;function r(s,n){const g=n.toLowerCase(),b=Object.keys(s).find($=>$.toLowerCase()===g);return b?s[b]:s[n]}t.$2m=r;function h(s,n){const g=Object.create(null);for(const[b,$]of Object.entries(s))n(b,$)&&(g[b]=$);return g}t.$3m=h;function e(s){let n=[];for(;Object.prototype!==s;)n=n.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return n}t.$4m=e;function a(s){const n=[];for(const g of e(s))typeof s[g]=="function"&&n.push(g);return n}t.$5m=a;function o(s,n){const g=$=>function(){const c=Array.prototype.slice.call(arguments,0);return n($,c)},b={};for(const $ of s)b[$]=g($);return b}t.$6m=o}),define(be[18],pe([1,0,17]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Pj=t.ThemeColor=void 0;var O;(function(D){function w(l){return l&&typeof l=="object"&&typeof l.id=="string"}D.isThemeColor=w})(O||(t.ThemeColor=O={}));function i(D){return{id:D}}t.$Pj=i;var _;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function l(n){const g=w.exec(n.id);if(!g)return l(y.$Oj.error);const[,b,$]=g,c=["codicon","codicon-"+b];return $&&c.push("codicon-modifier-"+$.substring(1)),c}D.asClassNameArray=l;function u(n){return l(n).join(" ")}D.asClassName=u;function f(n){return"."+l(n).join(".")}D.asCSSSelector=f;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}D.isThemeIcon=P;const r=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function h(n){const g=r.exec(n);if(!g)return;const[,b]=g;return{id:b}}D.fromString=h;function e(n){return{id:n}}D.fromId=e;function a(n,g){let b=n.id;const $=b.lastIndexOf("~");return $!==-1&&(b=b.substring(0,$)),g&&(b=`${b}~${g}`),{id:b}}D.modify=a;function o(n){const g=n.id.lastIndexOf("~");if(g!==-1)return n.id.substring(g+1)}D.getModifier=o;function s(n,g){return n.id===g.id&&n.color?.id===g.color?.id}D.isEqual=s})(_||(t.ThemeIcon=_={}))}),define(be[33],pe([1,0,32,12,18]),function(le,t,y,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=void 0;const _="$(",D=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${D.source}`,"g");function l(s){return s.replace(w,(n,g)=>g?n:`\\${n}`)}t.$Qj=l;const u=new RegExp(`\\\\${D.source}`,"g");function f(s){return s.replace(u,n=>`\\${n}`)}t.$Rj=f;const P=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function r(s){return s.indexOf(_)===-1?s:s.replace(P,(n,g,b,$)=>b?n:g||$||"")}t.$Sj=r;function h(s){return s?s.replace(/\$\((.*?)\)/g,(n,g)=>` ${g} `).trim():""}t.$Tj=h;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(s){e.lastIndex=0;let n="";const g=[];let b=0;for(;;){const $=e.lastIndex,c=e.exec(s),F=s.substring($,c?.index);if(F.length>0){n+=F;for(let R=0;R<F.length;R++)g.push(b)}if(!c)break;b+=c[0].length}return{text:n,iconOffsets:g}}t.$Uj=a;function o(s,n,g=!1){const{text:b,iconOffsets:$}=n;if(!$||$.length===0)return(0,y.$Dj)(s,b,g);const c=(0,O.$te)(b," "),F=b.length-c.length,R=(0,y.$Dj)(s,c,g);if(R)for(const T of R){const m=$[T.start+F]+F;T.start+=m,T.end+=m}return R}t.$Vj=o}),define(be[87],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IS=t.$HS=void 0,t.$HS="vscode:contextmenu",t.$IS="vscode:onCloseContextMenu"}),define(be[88],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PS=void 0;class y{constructor(i,_){this.a=i,this.onMessage=_}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$PS=y}),define(be[50],pe([8]),{}),define(be[89],pe([8]),{}),define(be[90],pe([8]),{}),define(be[91],pe([8]),{}),define(be[92],pe([1,0,90,91]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[93],pe([8]),{}),define(be[94],pe([8]),{}),define(be[95],pe([8]),{}),define(be[96],pe([8]),{}),define(be[97],pe([8]),{}),define(be[98],pe([8]),{}),define(be[99],pe([8]),{}),define(be[100],pe([8]),{}),define(be[101],pe([8]),{}),define(be[102],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[103],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[104],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[105],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[106],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[107],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[108],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[109],pe([13,10]),function(le,t){return le.create("vs/base/common/actions",t)}),define(be[34],pe([1,0,3,2,109]),function(le,t,y,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ki=t.$ji=t.$ii=t.$hi=t.$gi=t.$fi=void 0;class _ extends O.$jc{constructor(r,h="",e="",a=!0,o){super(),this.h=this.B(new y.$ed),this.onDidChange=this.h.event,this.w=!0,this.j=r,this.m=h,this.u=e,this.w=a,this.C=o}get id(){return this.j}get label(){return this.m}set label(r){this.D(r)}D(r){this.m!==r&&(this.m=r,this.h.fire({label:r}))}get tooltip(){return this.n||""}set tooltip(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.h.fire({tooltip:r}))}get class(){return this.u}set class(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.h.fire({class:r}))}get enabled(){return this.w}set enabled(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.h.fire({enabled:r}))}get checked(){return this.z}set checked(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.h.fire({checked:r}))}async run(r,h){this.C&&await this.C(r)}}t.$fi=_;class D extends O.$jc{constructor(){super(...arguments),this.f=this.B(new y.$ed),this.onWillRun=this.f.event,this.m=this.B(new y.$ed),this.onDidRun=this.m.event}async run(r,h){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.u(r,h)}catch(a){e=a}this.m.fire({action:r,error:e})}async u(r,h){await r.run(h)}}t.$gi=D;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let h=[];for(const e of r)e.length&&(h.length?h=[...h,new w,...e]:h=e);return h}static{this.ID="vs.actions.separator"}async run(){}}t.$hi=w;class l{get actions(){return this.a}constructor(r,h,e,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=h,this.class=a,this.a=e}async run(){}}t.$ii=l;class u extends _{static{this.ID="vs.actions.empty"}constructor(){super(u.ID,i.localize(0,null),void 0,!1)}}t.$ji=u;function f(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}t.$ki=f}),define(be[110],pe([13,10]),function(le,t){return le.create("vs/base/common/platform",t)}),define(be[5],pe([1,0,110]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let O=!1,i=!1,_=!1,D=!1,w=!1,l=!1,u=!1,f=!1,P=!1,r=!1,h,e=t.$f,a=t.$f,o,s;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?n=t.$g.vscode.process:typeof process<"u"&&(n=process);const g=typeof n?.versions?.electron=="string",b=g&&n?.type==="renderer";if(typeof navigator=="object"&&!b)s=navigator.userAgent,O=s.indexOf("Windows")>=0,i=s.indexOf("Macintosh")>=0,f=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=s.indexOf("Linux")>=0,r=s?.indexOf("Mobi")>=0,l=!0,h=y.getConfiguredDefaultLocale(y.localize(0,null))||t.$f,e=h,a=navigator.language;else if(typeof n=="object"){O=n.platform==="win32",i=n.platform==="darwin",_=n.platform==="linux",D=_&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,u=g,P=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.$f,e=t.$f;const U=n.env.VSCODE_NLS_CONFIG;if(U)try{const M=JSON.parse(U),A=M.availableLanguages["*"];h=M.locale,a=M.osLocale,e=A||t.$f,o=M._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var $;(function(U){U[U.Web=0]="Web",U[U.Mac=1]="Mac",U[U.Linux=2]="Linux",U[U.Windows=3]="Windows"})($||(t.Platform=$={}));function c(U){switch(U){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=c;let F=0;i?F=1:O?F=3:_&&(F=2),t.$i=O,t.$j=i,t.$k=_,t.$l=D,t.$m=w,t.$n=u,t.$o=l,t.$p=l&&typeof t.$g.importScripts=="function",t.$q=f,t.$r=r,t.$s=P,t.$t=F,t.$u=s,t.$v=e;var R;(function(U){function M(){return t.$v}U.value=M;function A(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}U.isDefaultVariant=A;function H(){return t.$v==="en"}U.isDefault=H})(R||(t.Language=R={})),t.$w=h,t.$x=a,t.$y=o,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const U=[];t.$g.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let H=0,Q=U.length;H<Q;H++){const ie=U[H];if(ie.id===A.data.vscodeScheduleAsyncWork){U.splice(H,1),ie.callback();return}}});let M=0;return A=>{const H=++M;U.push({id:H,callback:A}),t.$g.postMessage({vscodeScheduleAsyncWork:H},"*")}}return U=>setTimeout(U)})();var T;(function(U){U[U.Windows=1]="Windows",U[U.Macintosh=2]="Macintosh",U[U.Linux=3]="Linux"})(T||(t.OperatingSystem=T={})),t.OS=i||f?2:O?1:3;let m=!0,v=!1;function z(){if(!v){v=!0;const U=new Uint8Array(2);U[0]=1,U[1]=2,m=new Uint16Array(U.buffer)[0]===(2<<8)+1}return m}t.$C=z,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),define(be[111],pe([1,0,16,5]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8N=t.KeyboardSupport=void 0;var i;(function(_){_[_.Always=0]="Always",_[_.FullScreen=1]="FullScreen",_[_.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$8N={clipboard:{writeText:O.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:O.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>O.$m||y.$6N()?0:navigator.keyboard||y.$2N?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],pe([1,0,16,43,75,5]),function(le,t,y,O,i,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dO=t.$cO=t.$bO=void 0;function D(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return O.KeyCodeUtils.fromString(o)}const a=e.keyCode;if(a===3)return 7;if(y.$YN)switch(a){case 59:return 85;case 60:if(_.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(_.$j)return 57;break}else if(y.$ZN){if(_.$j&&a===93)return 57;if(!_.$j&&a===92)return 57}return O.$oq[a]||0}const w=_.$j?256:2048,l=512,u=1024,f=_.$j?2048:256;function P(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$bO=P;function r(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${O.KeyCodeUtils.toString(e.keyCode)}')`}t.$cO=r;class h{constructor(a){this._standardKeyboardEventBrand=!0;const o=a;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState("AltGraph"),this.keyCode=D(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(a){return this.a===a}c(){let a=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode);let o=0;return this.ctrlKey&&(o|=w),this.altKey&&(o|=l),this.shiftKey&&(o|=u),this.metaKey&&(o|=f),o|=a,o}d(){let a=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode),new i.$wq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,a)}}t.$dO=h}),define(be[19],pe([1,0,16,67,5]),function(le,t,y,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aO=t.$_N=t.$$N=void 0;class _{constructor(u){this.timestamp=Date.now(),this.browserEvent=u,this.leftButton=u.button===0,this.middleButton=u.button===1,this.rightButton=u.button===2,this.buttons=u.buttons,this.target=u.target,this.detail=u.detail||1,u.type==="dblclick"&&(this.detail=2),this.ctrlKey=u.ctrlKey,this.shiftKey=u.shiftKey,this.altKey=u.altKey,this.metaKey=u.metaKey,typeof u.pageX=="number"?(this.posx=u.pageX,this.posy=u.pageY):(this.posx=u.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=u.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=O.$9N.getPositionOfChildWindowRelativeToAncestorWindow(window,u.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$$N=_;class D extends _{constructor(u){super(u),this.dataTransfer=u.dataTransfer}}t.$_N=D;class w{constructor(u,f=0,P=0){if(this.browserEvent=u||null,this.target=u?u.target||u.targetNode||u.srcElement:null,this.deltaY=P,this.deltaX=f,u){const r=u,h=u;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof h.VERTICAL_AXIS<"u"&&h.axis===h.VERTICAL_AXIS)this.deltaY=-h.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?y.$YN&&!i.$j?this.deltaY=-u.deltaY/3:this.deltaY=-u.deltaY:this.deltaY=-u.deltaY/40}if(typeof r.wheelDeltaX<"u")y.$2N&&i.$i?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof h.HORIZONTAL_AXIS<"u"&&h.axis===h.HORIZONTAL_AXIS)this.deltaX=-u.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?y.$YN&&!i.$j?this.deltaX=-u.deltaX/3:this.deltaX=-u.deltaX:this.deltaX=-u.deltaX/40}this.deltaY===0&&this.deltaX===0&&u.wheelDelta&&(this.deltaY=u.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$aO=w}),define(be[112],pe([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.$2d=t.env=t.cwd=void 0;let O;if(typeof y.$g.vscode<"u"&&typeof y.$g.vscode.process<"u"){const i=y.$g.vscode.process;O={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return y.$i?"win32":y.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=O.cwd,t.env=O.env,t.$2d=O.platform,t.$3d=O.arch}),define(be[22],pe([1,0,112]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=t.sep=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=void 0;const O=65,i=97,_=90,D=122,w=46,l=47,u=92,f=58,P=63;class r extends Error{constructor(F,R,T){let m;typeof R=="string"&&R.indexOf("not ")===0?(m="must not be",R=R.replace(/^not /,"")):m="must be";const v=F.indexOf(".")!==-1?"property":"argument";let z=`The "${F}" ${v} ${m} of type ${R}`;z+=`. Received type ${typeof T}`,super(z),this.code="ERR_INVALID_ARG_TYPE"}}function h(c,F){if(c===null||typeof c!="object")throw new r(F,"Object",c)}function e(c,F){if(typeof c!="string")throw new r(F,"string",c)}const a=y.$2d==="win32";function o(c){return c===l||c===u}function s(c){return c===l}function n(c){return c>=O&&c<=_||c>=i&&c<=D}function g(c,F,R,T){let m="",v=0,z=-1,U=0,M=0;for(let A=0;A<=c.length;++A){if(A<c.length)M=c.charCodeAt(A);else{if(T(M))break;M=l}if(T(M)){if(!(z===A-1||U===1))if(U===2){if(m.length<2||v!==2||m.charCodeAt(m.length-1)!==w||m.charCodeAt(m.length-2)!==w){if(m.length>2){const H=m.lastIndexOf(R);H===-1?(m="",v=0):(m=m.slice(0,H),v=m.length-1-m.lastIndexOf(R)),z=A,U=0;continue}else if(m.length!==0){m="",v=0,z=A,U=0;continue}}F&&(m+=m.length>0?`${R}..`:"..",v=2)}else m.length>0?m+=`${R}${c.slice(z+1,A)}`:m=c.slice(z+1,A),v=A-z-1;z=A,U=0}else M===w&&U!==-1?++U:U=-1}return m}function b(c,F){h(F,"pathObject");const R=F.dir||F.root,T=F.base||`${F.name||""}${F.ext||""}`;return R?R===F.root?`${R}${T}`:`${R}${c}${T}`:T}t.$4d={resolve(...c){let F="",R="",T=!1;for(let m=c.length-1;m>=-1;m--){let v;if(m>=0){if(v=c[m],e(v,"path"),v.length===0)continue}else F.length===0?v=y.cwd():(v=y.env[`=${F}`]||y.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==F.toLowerCase()&&v.charCodeAt(2)===u)&&(v=`${F}\\`));const z=v.length;let U=0,M="",A=!1;const H=v.charCodeAt(0);if(z===1)o(H)&&(U=1,A=!0);else if(o(H))if(A=!0,o(v.charCodeAt(1))){let Q=2,ie=Q;for(;Q<z&&!o(v.charCodeAt(Q));)Q++;if(Q<z&&Q!==ie){const re=v.slice(ie,Q);for(ie=Q;Q<z&&o(v.charCodeAt(Q));)Q++;if(Q<z&&Q!==ie){for(ie=Q;Q<z&&!o(v.charCodeAt(Q));)Q++;(Q===z||Q!==ie)&&(M=`\\\\${re}\\${v.slice(ie,Q)}`,U=Q)}}}else U=1;else n(H)&&v.charCodeAt(1)===f&&(M=v.slice(0,2),U=2,z>2&&o(v.charCodeAt(2))&&(A=!0,U=3));if(M.length>0)if(F.length>0){if(M.toLowerCase()!==F.toLowerCase())continue}else F=M;if(T){if(F.length>0)break}else if(R=`${v.slice(U)}\\${R}`,T=A,A&&F.length>0)break}return R=g(R,!T,"\\",o),T?`${F}\\${R}`:`${F}${R}`||"."},normalize(c){e(c,"path");const F=c.length;if(F===0)return".";let R=0,T,m=!1;const v=c.charCodeAt(0);if(F===1)return s(v)?"\\":c;if(o(v))if(m=!0,o(c.charCodeAt(1))){let U=2,M=U;for(;U<F&&!o(c.charCodeAt(U));)U++;if(U<F&&U!==M){const A=c.slice(M,U);for(M=U;U<F&&o(c.charCodeAt(U));)U++;if(U<F&&U!==M){for(M=U;U<F&&!o(c.charCodeAt(U));)U++;if(U===F)return`\\\\${A}\\${c.slice(M)}\\`;U!==M&&(T=`\\\\${A}\\${c.slice(M,U)}`,R=U)}}}else R=1;else n(v)&&c.charCodeAt(1)===f&&(T=c.slice(0,2),R=2,F>2&&o(c.charCodeAt(2))&&(m=!0,R=3));let z=R<F?g(c.slice(R),!m,"\\",o):"";return z.length===0&&!m&&(z="."),z.length>0&&o(c.charCodeAt(F-1))&&(z+="\\"),T===void 0?m?`\\${z}`:z:m?`${T}\\${z}`:`${T}${z}`},isAbsolute(c){e(c,"path");const F=c.length;if(F===0)return!1;const R=c.charCodeAt(0);return o(R)||F>2&&n(R)&&c.charCodeAt(1)===f&&o(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let F,R;for(let v=0;v<c.length;++v){const z=c[v];e(z,"path"),z.length>0&&(F===void 0?F=R=z:F+=`\\${z}`)}if(F===void 0)return".";let T=!0,m=0;if(typeof R=="string"&&o(R.charCodeAt(0))){++m;const v=R.length;v>1&&o(R.charCodeAt(1))&&(++m,v>2&&(o(R.charCodeAt(2))?++m:T=!1))}if(T){for(;m<F.length&&o(F.charCodeAt(m));)m++;m>=2&&(F=`\\${F.slice(m)}`)}return t.$4d.normalize(F)},relative(c,F){if(e(c,"from"),e(F,"to"),c===F)return"";const R=t.$4d.resolve(c),T=t.$4d.resolve(F);if(R===T||(c=R.toLowerCase(),F=T.toLowerCase(),c===F))return"";let m=0;for(;m<c.length&&c.charCodeAt(m)===u;)m++;let v=c.length;for(;v-1>m&&c.charCodeAt(v-1)===u;)v--;const z=v-m;let U=0;for(;U<F.length&&F.charCodeAt(U)===u;)U++;let M=F.length;for(;M-1>U&&F.charCodeAt(M-1)===u;)M--;const A=M-U,H=z<A?z:A;let Q=-1,ie=0;for(;ie<H;ie++){const ue=c.charCodeAt(m+ie);if(ue!==F.charCodeAt(U+ie))break;ue===u&&(Q=ie)}if(ie!==H){if(Q===-1)return T}else{if(A>H){if(F.charCodeAt(U+ie)===u)return T.slice(U+ie+1);if(ie===2)return T.slice(U+ie)}z>H&&(c.charCodeAt(m+ie)===u?Q=ie:ie===2&&(Q=3)),Q===-1&&(Q=0)}let re="";for(ie=m+Q+1;ie<=v;++ie)(ie===v||c.charCodeAt(ie)===u)&&(re+=re.length===0?"..":"\\..");return U+=Q,re.length>0?`${re}${T.slice(U,M)}`:(T.charCodeAt(U)===u&&++U,T.slice(U,M))},toNamespacedPath(c){if(typeof c!="string"||c.length===0)return c;const F=t.$4d.resolve(c);if(F.length<=2)return c;if(F.charCodeAt(0)===u){if(F.charCodeAt(1)===u){const R=F.charCodeAt(2);if(R!==P&&R!==w)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(n(F.charCodeAt(0))&&F.charCodeAt(1)===f&&F.charCodeAt(2)===u)return`\\\\?\\${F}`;return c},dirname(c){e(c,"path");const F=c.length;if(F===0)return".";let R=-1,T=0;const m=c.charCodeAt(0);if(F===1)return o(m)?c:".";if(o(m)){if(R=T=1,o(c.charCodeAt(1))){let U=2,M=U;for(;U<F&&!o(c.charCodeAt(U));)U++;if(U<F&&U!==M){for(M=U;U<F&&o(c.charCodeAt(U));)U++;if(U<F&&U!==M){for(M=U;U<F&&!o(c.charCodeAt(U));)U++;if(U===F)return c;U!==M&&(R=T=U+1)}}}}else n(m)&&c.charCodeAt(1)===f&&(R=F>2&&o(c.charCodeAt(2))?3:2,T=R);let v=-1,z=!0;for(let U=F-1;U>=T;--U)if(o(c.charCodeAt(U))){if(!z){v=U;break}}else z=!1;if(v===-1){if(R===-1)return".";v=R}return c.slice(0,v)},basename(c,F){F!==void 0&&e(F,"ext"),e(c,"path");let R=0,T=-1,m=!0,v;if(c.length>=2&&n(c.charCodeAt(0))&&c.charCodeAt(1)===f&&(R=2),F!==void 0&&F.length>0&&F.length<=c.length){if(F===c)return"";let z=F.length-1,U=-1;for(v=c.length-1;v>=R;--v){const M=c.charCodeAt(v);if(o(M)){if(!m){R=v+1;break}}else U===-1&&(m=!1,U=v+1),z>=0&&(M===F.charCodeAt(z)?--z===-1&&(T=v):(z=-1,T=U))}return R===T?T=U:T===-1&&(T=c.length),c.slice(R,T)}for(v=c.length-1;v>=R;--v)if(o(c.charCodeAt(v))){if(!m){R=v+1;break}}else T===-1&&(m=!1,T=v+1);return T===-1?"":c.slice(R,T)},extname(c){e(c,"path");let F=0,R=-1,T=0,m=-1,v=!0,z=0;c.length>=2&&c.charCodeAt(1)===f&&n(c.charCodeAt(0))&&(F=T=2);for(let U=c.length-1;U>=F;--U){const M=c.charCodeAt(U);if(o(M)){if(!v){T=U+1;break}continue}m===-1&&(v=!1,m=U+1),M===w?R===-1?R=U:z!==1&&(z=1):R!==-1&&(z=-1)}return R===-1||m===-1||z===0||z===1&&R===m-1&&R===T+1?"":c.slice(R,m)},format:b.bind(null,"\\"),parse(c){e(c,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return F;const R=c.length;let T=0,m=c.charCodeAt(0);if(R===1)return o(m)?(F.root=F.dir=c,F):(F.base=F.name=c,F);if(o(m)){if(T=1,o(c.charCodeAt(1))){let Q=2,ie=Q;for(;Q<R&&!o(c.charCodeAt(Q));)Q++;if(Q<R&&Q!==ie){for(ie=Q;Q<R&&o(c.charCodeAt(Q));)Q++;if(Q<R&&Q!==ie){for(ie=Q;Q<R&&!o(c.charCodeAt(Q));)Q++;Q===R?T=Q:Q!==ie&&(T=Q+1)}}}}else if(n(m)&&c.charCodeAt(1)===f){if(R<=2)return F.root=F.dir=c,F;if(T=2,o(c.charCodeAt(2))){if(R===3)return F.root=F.dir=c,F;T=3}}T>0&&(F.root=c.slice(0,T));let v=-1,z=T,U=-1,M=!0,A=c.length-1,H=0;for(;A>=T;--A){if(m=c.charCodeAt(A),o(m)){if(!M){z=A+1;break}continue}U===-1&&(M=!1,U=A+1),m===w?v===-1?v=A:H!==1&&(H=1):v!==-1&&(H=-1)}return U!==-1&&(v===-1||H===0||H===1&&v===U-1&&v===z+1?F.base=F.name=c.slice(z,U):(F.name=c.slice(z,v),F.base=c.slice(z,U),F.ext=c.slice(v,U))),z>0&&z!==T?F.dir=c.slice(0,z-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(a){const c=/\\/g;return()=>{const F=y.cwd().replace(c,"/");return F.slice(F.indexOf("/"))}}return()=>y.cwd()})();t.$5d={resolve(...c){let F="",R=!1;for(let T=c.length-1;T>=-1&&!R;T--){const m=T>=0?c[T]:$();e(m,"path"),m.length!==0&&(F=`${m}/${F}`,R=m.charCodeAt(0)===l)}return F=g(F,!R,"/",s),R?`/${F}`:F.length>0?F:"."},normalize(c){if(e(c,"path"),c.length===0)return".";const F=c.charCodeAt(0)===l,R=c.charCodeAt(c.length-1)===l;return c=g(c,!F,"/",s),c.length===0?F?"/":R?"./":".":(R&&(c+="/"),F?`/${c}`:c)},isAbsolute(c){return e(c,"path"),c.length>0&&c.charCodeAt(0)===l},join(...c){if(c.length===0)return".";let F;for(let R=0;R<c.length;++R){const T=c[R];e(T,"path"),T.length>0&&(F===void 0?F=T:F+=`/${T}`)}return F===void 0?".":t.$5d.normalize(F)},relative(c,F){if(e(c,"from"),e(F,"to"),c===F||(c=t.$5d.resolve(c),F=t.$5d.resolve(F),c===F))return"";const R=1,T=c.length,m=T-R,v=1,z=F.length-v,U=m<z?m:z;let M=-1,A=0;for(;A<U;A++){const Q=c.charCodeAt(R+A);if(Q!==F.charCodeAt(v+A))break;Q===l&&(M=A)}if(A===U)if(z>U){if(F.charCodeAt(v+A)===l)return F.slice(v+A+1);if(A===0)return F.slice(v+A)}else m>U&&(c.charCodeAt(R+A)===l?M=A:A===0&&(M=0));let H="";for(A=R+M+1;A<=T;++A)(A===T||c.charCodeAt(A)===l)&&(H+=H.length===0?"..":"/..");return`${H}${F.slice(v+M)}`},toNamespacedPath(c){return c},dirname(c){if(e(c,"path"),c.length===0)return".";const F=c.charCodeAt(0)===l;let R=-1,T=!0;for(let m=c.length-1;m>=1;--m)if(c.charCodeAt(m)===l){if(!T){R=m;break}}else T=!1;return R===-1?F?"/":".":F&&R===1?"//":c.slice(0,R)},basename(c,F){F!==void 0&&e(F,"ext"),e(c,"path");let R=0,T=-1,m=!0,v;if(F!==void 0&&F.length>0&&F.length<=c.length){if(F===c)return"";let z=F.length-1,U=-1;for(v=c.length-1;v>=0;--v){const M=c.charCodeAt(v);if(M===l){if(!m){R=v+1;break}}else U===-1&&(m=!1,U=v+1),z>=0&&(M===F.charCodeAt(z)?--z===-1&&(T=v):(z=-1,T=U))}return R===T?T=U:T===-1&&(T=c.length),c.slice(R,T)}for(v=c.length-1;v>=0;--v)if(c.charCodeAt(v)===l){if(!m){R=v+1;break}}else T===-1&&(m=!1,T=v+1);return T===-1?"":c.slice(R,T)},extname(c){e(c,"path");let F=-1,R=0,T=-1,m=!0,v=0;for(let z=c.length-1;z>=0;--z){const U=c.charCodeAt(z);if(U===l){if(!m){R=z+1;break}continue}T===-1&&(m=!1,T=z+1),U===w?F===-1?F=z:v!==1&&(v=1):F!==-1&&(v=-1)}return F===-1||T===-1||v===0||v===1&&F===T-1&&F===R+1?"":c.slice(F,T)},format:b.bind(null,"/"),parse(c){e(c,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return F;const R=c.charCodeAt(0)===l;let T;R?(F.root="/",T=1):T=0;let m=-1,v=0,z=-1,U=!0,M=c.length-1,A=0;for(;M>=T;--M){const H=c.charCodeAt(M);if(H===l){if(!U){v=M+1;break}continue}z===-1&&(U=!1,z=M+1),H===w?m===-1?m=M:A!==1&&(A=1):m!==-1&&(A=-1)}if(z!==-1){const H=v===0&&R?1:v;m===-1||A===0||A===1&&m===z-1&&m===v+1?F.base=F.name=c.slice(H,z):(F.name=c.slice(H,m),F.base=c.slice(H,z),F.ext=c.slice(m,z))}return v>0?F.dir=c.slice(0,v-1):R&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$5d.win32=t.$4d.win32=t.$4d,t.$5d.posix=t.$4d.posix=t.$5d,t.$6d=a?t.$4d.normalize:t.$5d.normalize,t.$7d=a?t.$4d.isAbsolute:t.$5d.isAbsolute,t.$8d=a?t.$4d.join:t.$5d.join,t.$9d=a?t.$4d.resolve:t.$5d.resolve,t.$0d=a?t.$4d.relative:t.$5d.relative,t.$$d=a?t.$4d.dirname:t.$5d.dirname,t.$_d=a?t.$4d.basename:t.$5d.basename,t.$ae=a?t.$4d.extname:t.$5d.extname,t.$be=a?t.$4d.format:t.$5d.format,t.$ce=a?t.$4d.parse:t.$5d.parse,t.$de=a?t.$4d.toNamespacedPath:t.$5d.toNamespacedPath,t.sep=a?t.$4d.sep:t.$5d.sep,t.$fe=a?t.$4d.delimiter:t.$5d.delimiter}),define(be[113],pe([1,0,22,5,12,7]),function(le,t,y,O,i,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=void 0;function D(v){return v===47||v===92}t.$Af=D;function w(v){return v.replace(/[\\/]/g,y.$5d.sep)}t.$Bf=w;function l(v){return v.indexOf("/")===-1&&(v=w(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$Cf=l;function u(v,z=y.$5d.sep){if(!v)return"";const U=v.length,M=v.charCodeAt(0);if(D(M)){if(D(v.charCodeAt(1))&&!D(v.charCodeAt(2))){let H=3;const Q=H;for(;H<U&&!D(v.charCodeAt(H));H++);if(Q!==H&&!D(v.charCodeAt(H+1))){for(H+=1;H<U;H++)if(D(v.charCodeAt(H)))return v.slice(0,H+1).replace(/[\\/]/g,z)}}return z}else if(s(M)&&v.charCodeAt(1)===58)return D(v.charCodeAt(2))?v.slice(0,2)+z:v.slice(0,2);let A=v.indexOf("://");if(A!==-1){for(A+=3;A<U;A++)if(D(v.charCodeAt(A)))return v.slice(0,A+1)}return""}t.$Df=u;function f(v){if(!O.$i||!v||v.length<5)return!1;let z=v.charCodeAt(0);if(z!==92||(z=v.charCodeAt(1),z!==92))return!1;let U=2;const M=U;for(;U<v.length&&(z=v.charCodeAt(U),z!==92);U++);return!(M===U||(z=v.charCodeAt(U+1),isNaN(z)||z===92))}t.$Ef=f;const P=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,z=O.$i){const U=z?P:r;return!(!v||v.length===0||/^\s+$/.test(v)||(U.lastIndex=0,U.test(v))||z&&h.test(v)||v==="."||v===".."||z&&v[v.length-1]==="."||z&&v.length!==v.trim().length||v.length>255)}t.$Ff=e;function a(v,z,U){const M=v===z;return!U||M?M:!v||!z?!1:(0,i.$Le)(v,z)}t.$Gf=a;function o(v,z,U,M=y.sep){if(v===z)return!0;if(!v||!z||z.length>v.length)return!1;if(U){if(!(0,i.$Me)(v,z))return!1;if(z.length===v.length)return!0;let H=z.length;return z.charAt(z.length-1)===M&&H--,v.charAt(H)===M}return z.charAt(z.length-1)!==M&&(z+=M),v.indexOf(z)===0}t.$Hf=o;function s(v){return v>=65&&v<=90||v>=97&&v<=122}t.$If=s;function n(v,z){return O.$i&&v.endsWith(":")&&(v+=y.sep),(0,y.$7d)(v)||(v=(0,y.$8d)(z,v)),v=(0,y.$6d)(v),O.$i?(v=(0,i.$ue)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,i.$ue)(v,y.sep),v||(v=y.sep)),v}t.$Jf=n;function g(v){const z=(0,y.$6d)(v);return O.$i?v.length>3?!1:b(z)&&(v.length===2||z.charCodeAt(2)===92):z===y.$5d.sep}t.$Kf=g;function b(v,z=O.$i){return z?s(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$Lf=b;function $(v,z=O.$i){return b(v,z)?v[0]:void 0}t.$Mf=$;function c(v,z,U){return z.length>v.length?-1:v===z?0:(U&&(v=v.toLowerCase(),z=z.toLowerCase()),v.indexOf(z))}t.$Nf=c;function F(v){const z=v.split(":");let U,M,A;for(const H of z){const Q=Number(H);(0,_.$mf)(Q)?M===void 0?M=Q:A===void 0&&(A=Q):U=U?[U,H].join(":"):H}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:M!==void 0?M:void 0,column:A!==void 0?A:M!==void 0?1:void 0}}t.$Of=F;const R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",T="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(v,z,U=8){let M="";for(let H=0;H<U;H++){let Q;H===0&&O.$i&&!z&&(U===3||U===4)?Q=T:Q=R,M+=Q.charAt(Math.floor(Math.random()*Q.length))}let A;return z?A=`${z}-${M}`:A=M,v?(0,y.$8d)(v,A):A}t.$Pf=m}),define(be[114],pe([1,0,22]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jr=t.$Ir=t.$Hr=t.$Gr=t.$Fr=void 0,t.$Fr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function _(f){const P=(0,y.$ae)(f),r=O[P.toLowerCase()];return r!==void 0?r:D(f)}t.$Gr=_;function D(f){const P=(0,y.$ae)(f);return i[P.toLowerCase()]}t.$Hr=D;function w(f){for(const P in i)if(i[P]===f)return P}t.$Ir=w;const l=/^(.+)\/(.+?)(;.+)?$/;function u(f,P){const r=l.exec(f);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:P?void 0:f}t.$Jr=u}),define(be[15],pe([1,0,22,5]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sf=t.$Rf=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,_=/^\//,D=/^\/\//;function w(T,m){if(!T.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${T.authority}", path: "${T.path}", query: "${T.query}", fragment: "${T.fragment}"}`);if(T.scheme&&!i.test(T.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(T.path){if(T.authority){if(!_.test(T.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(T.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(T,m){return!T&&!m?"file":T}function u(T,m){switch(T){case"https":case"http":case"file":m?m[0]!==P&&(m=P+m):m=P;break}return m}const f="",P="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(m){return m instanceof h?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,v,z,U,M,A=!1){typeof m=="object"?(this.scheme=m.scheme||f,this.authority=m.authority||f,this.path=m.path||f,this.query=m.query||f,this.fragment=m.fragment||f):(this.scheme=l(m,A),this.authority=v||f,this.path=u(this.scheme,z||f),this.query=U||f,this.fragment=M||f,w(this,A))}get fsPath(){return b(this,!1)}with(m){if(!m)return this;let{scheme:v,authority:z,path:U,query:M,fragment:A}=m;return v===void 0?v=this.scheme:v===null&&(v=f),z===void 0?z=this.authority:z===null&&(z=f),U===void 0?U=this.path:U===null&&(U=f),M===void 0?M=this.query:M===null&&(M=f),A===void 0?A=this.fragment:A===null&&(A=f),v===this.scheme&&z===this.authority&&U===this.path&&M===this.query&&A===this.fragment?this:new o(v,z,U,M,A)}static parse(m,v=!1){const z=r.exec(m);return z?new o(z[2]||f,R(z[4]||f),R(z[5]||f),R(z[7]||f),R(z[9]||f),v):new o(f,f,f,f,f)}static file(m){let v=f;if(O.$i&&(m=m.replace(/\\/g,P)),m[0]===P&&m[1]===P){const z=m.indexOf(P,2);z===-1?(v=m.substring(2),m=P):(v=m.substring(2,z),m=m.substring(z)||P)}return new o("file",v,m,f,f)}static from(m,v){return new o(m.scheme,m.authority,m.path,m.query,m.fragment,v)}static joinPath(m,...v){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let z;return O.$i&&m.scheme==="file"?z=h.file(y.$4d.join(b(m,!0),...v)).path:z=y.$5d.join(m.path,...v),m.with({path:z})}toString(m=!1){return $(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof h)return m;{const v=new o(m);return v._formatted=m.external??null,v._fsPath=m._sep===a?m.fsPath??null:null,v}}else return m}}t.URI=h;function e(T){return!T||typeof T!="object"?!1:typeof T.scheme=="string"&&(typeof T.authority=="string"||typeof T.authority>"u")&&(typeof T.path=="string"||typeof T.path>"u")&&(typeof T.query=="string"||typeof T.query>"u")&&(typeof T.fragment=="string"||typeof T.fragment>"u")}t.$Rf=e;const a=O.$i?1:void 0;class o extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(m=!1){return m?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=a),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(T,m,v){let z,U=-1;for(let M=0;M<T.length;M++){const A=T.charCodeAt(M);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||m&&A===47||v&&A===91||v&&A===93||v&&A===58)U!==-1&&(z+=encodeURIComponent(T.substring(U,M)),U=-1),z!==void 0&&(z+=T.charAt(M));else{z===void 0&&(z=T.substr(0,M));const H=s[A];H!==void 0?(U!==-1&&(z+=encodeURIComponent(T.substring(U,M)),U=-1),z+=H):U===-1&&(U=M)}}return U!==-1&&(z+=encodeURIComponent(T.substring(U))),z!==void 0?z:T}function g(T){let m;for(let v=0;v<T.length;v++){const z=T.charCodeAt(v);z===35||z===63?(m===void 0&&(m=T.substr(0,v)),m+=s[z]):m!==void 0&&(m+=T[v])}return m!==void 0?m:T}function b(T,m){let v;return T.authority&&T.path.length>1&&T.scheme==="file"?v=`//${T.authority}${T.path}`:T.path.charCodeAt(0)===47&&(T.path.charCodeAt(1)>=65&&T.path.charCodeAt(1)<=90||T.path.charCodeAt(1)>=97&&T.path.charCodeAt(1)<=122)&&T.path.charCodeAt(2)===58?m?v=T.path.substr(1):v=T.path[1].toLowerCase()+T.path.substr(2):v=T.path,O.$i&&(v=v.replace(/\//g,"\\")),v}t.$Sf=b;function $(T,m){const v=m?g:n;let z="",{scheme:U,authority:M,path:A,query:H,fragment:Q}=T;if(U&&(z+=U,z+=":"),(M||U==="file")&&(z+=P,z+=P),M){let ie=M.indexOf("@");if(ie!==-1){const re=M.substr(0,ie);M=M.substr(ie+1),ie=re.lastIndexOf(":"),ie===-1?z+=v(re,!1,!1):(z+=v(re.substr(0,ie),!1,!1),z+=":",z+=v(re.substr(ie+1),!1,!0)),z+="@"}M=M.toLowerCase(),ie=M.lastIndexOf(":"),ie===-1?z+=v(M,!1,!0):(z+=v(M.substr(0,ie),!1,!0),z+=M.substr(ie))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const ie=A.charCodeAt(1);ie>=65&&ie<=90&&(A=`/${String.fromCharCode(ie+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const ie=A.charCodeAt(0);ie>=65&&ie<=90&&(A=`${String.fromCharCode(ie+32)}:${A.substr(2)}`)}z+=v(A,!0,!1)}return H&&(z+="?",z+=v(H,!1,!1)),Q&&(z+="#",z+=m?Q:n(Q,!1,!1)),z}function c(T){try{return decodeURIComponent(T)}catch{return T.length>3?T.substr(0,3)+c(T.substr(3)):T}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function R(T){return T.match(F)?T.replace(F,m=>c(m)):T}}),define(be[51],pe([1,0,31,15]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0g=t.$9g=t.$8g=void 0;function i(l){return JSON.stringify(l,D)}t.$8g=i;function _(l){let u=JSON.parse(l);return u=w(u),u}t.$9g=_;function D(l,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function w(l,u=0){if(!l||u>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return O.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof y.$Ed||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let f=0;f<l.length;++f)l[f]=w(l[f],u+1);else for(const f in l)Object.hasOwnProperty.call(l,f)&&(l[f]=w(l[f],u+1))}return l}t.$0g=w}),define(be[28],pe([1,0,6,5,15]),function(le,t,y,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.Schemas=void 0;var _;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(_||(t.Schemas=_={})),t.$Tf="vscode-tkn",t.$Uf="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${_.vscodeRemoteResource}`}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f){this.f=`${f}/${_.vscodeRemoteResource}`}set(f,P,r){this.a[f]=P,this.b[f]=r}setConnectionToken(f,P){this.c[f]=P}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(o){return y.$Y(o),f}const P=f.authority;let r=this.a[P];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const h=this.b[P],e=this.c[P];let a=`path=${encodeURIComponent(f.path)}`;return typeof e=="string"&&(a+=`&${t.$Uf}=${encodeURIComponent(e)}`),i.URI.from({scheme:O.$o?this.d:_.vscodeRemoteResource,authority:`${r}:${h}`,path:this.f,query:a})}}t.$Vf=new D,t.$Wf="vs/../../extensions",t.$Xf="vs/../../node_modules",t.$Yf="vs/../../node_modules.asar",t.$Zf="vs/../../node_modules.asar.unpacked";class w{static{this.a="vscode-app"}asBrowserUri(f){const P=this.b(f,le);return this.uriToBrowserUri(P)}uriToBrowserUri(f){return f.scheme===_.vscodeRemote?t.$Vf.rewrite(f):f.scheme===_.file&&(O.$m||O.$p&&O.$g.origin===`${_.vscodeFileResource}://${w.a}`)?f.with({scheme:_.vscodeFileResource,authority:f.authority||w.a,query:null,fragment:null}):f}asFileUri(f){const P=this.b(f,le);return this.uriToFileUri(P)}uriToFileUri(f){return f.scheme===_.vscodeFileResource?f.with({scheme:_.file,authority:f.authority!==w.a?f.authority:null,query:null,fragment:null}):f}b(f,P){return i.URI.isUri(f)?f:i.URI.parse(P.toUrl(f))}}t.$1f=new w;var l;(function(u){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(f.get("3"));const P="vscode-coi";function r(e){let a;typeof e=="string"?a=new URL(e).searchParams:e instanceof URL?a=e.searchParams:i.URI.isUri(e)&&(a=new URL(e.toString(!0)).searchParams);const o=a?.get(P);if(o)return f.get(o)}u.getHeadersFromQuery=r;function h(e,a,o){if(!globalThis.crossOriginIsolated)return;const s=a&&o?"3":o?"2":"1";e instanceof URLSearchParams?e.set(P,s):e[P]=s}u.addSearchParam=h})(l||(t.COI=l={}))}),define(be[35],pe([1,0,113,28,22,5,12,15]),function(le,t,y,O,i,_,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rg=t.DataUri=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=void 0;function l(h){return(0,w.$Sf)(h,!0)}t.$8f=l;class u{constructor(e){this.a=e}compare(e,a,o=!1){return e===a?0:(0,D.$Ee)(this.getComparisonKey(e,o),this.getComparisonKey(a,o))}isEqual(e,a,o=!1){return e===a?!0:!e||!a?!1:this.getComparisonKey(e,o)===this.getComparisonKey(a,o)}getComparisonKey(e,a=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,a,o=!1){if(e.scheme===a.scheme){if(e.scheme===O.Schemas.file)return y.$Hf(l(e),l(a),this.a(e))&&e.query===a.query&&(o||e.fragment===a.fragment);if((0,t.$mg)(e.authority,a.authority))return y.$Hf(e.path,a.path,this.a(e),"/")&&e.query===a.query&&(o||e.fragment===a.fragment)}return!1}joinPath(e,...a){return w.URI.joinPath(e,...a)}basenameOrAuthority(e){return(0,t.$eg)(e)||e.authority}basename(e){return i.$5d.basename(e.path)}extname(e){return i.$5d.extname(e.path)}dirname(e){if(e.path.length===0)return e;let a;return e.scheme===O.Schemas.file?a=w.URI.file(i.$$d(l(e))).path:(a=i.$5d.dirname(e.path),e.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),a="/")),e.with({path:a})}normalizePath(e){if(!e.path.length)return e;let a;return e.scheme===O.Schemas.file?a=w.URI.file(i.$6d(l(e))).path:a=i.$5d.normalize(e.path),e.with({path:a})}relativePath(e,a){if(e.scheme!==a.scheme||!(0,t.$mg)(e.authority,a.authority))return;if(e.scheme===O.Schemas.file){const n=i.$0d(l(e),l(a));return _.$i?y.$Bf(n):n}let o=e.path||"/";const s=a.path||"/";if(this.a(e)){let n=0;for(const g=Math.min(o.length,s.length);n<g&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return i.$5d.relative(o,s)}resolvePath(e,a){if(e.scheme===O.Schemas.file){const o=w.URI.file(i.$9d(l(e),a));return e.with({authority:o.authority,path:o.path})}return a=y.$Cf(a),e.with({path:i.$5d.resolve(e.path,a)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,a){return e===a||e!==void 0&&a!==void 0&&(0,D.$Le)(e,a)}hasTrailingPathSeparator(e,a=i.sep){if(e.scheme===O.Schemas.file){const o=l(e);return o.length>y.$Df(o).length&&o[o.length-1]===a}else{const o=e.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,a=i.sep){return(0,t.$ng)(e,a)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,a=i.sep){let o=!1;if(e.scheme===O.Schemas.file){const s=l(e);o=s!==void 0&&s.length===y.$Df(s).length&&s[s.length-1]===a}else{a="/";const s=e.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,t.$ng)(e,a)?e.with({path:e.path+"/"}):e}}t.$9f=u,t.$0f=new u(()=>!1),t.$$f=new u(h=>h.scheme===O.Schemas.file?!_.$k:!0),t.$_f=new u(h=>!0),t.$ag=t.$0f.isEqual.bind(t.$0f),t.$bg=t.$0f.isEqualOrParent.bind(t.$0f),t.$cg=t.$0f.getComparisonKey.bind(t.$0f),t.$dg=t.$0f.basenameOrAuthority.bind(t.$0f),t.$eg=t.$0f.basename.bind(t.$0f),t.$fg=t.$0f.extname.bind(t.$0f),t.$gg=t.$0f.dirname.bind(t.$0f),t.$hg=t.$0f.joinPath.bind(t.$0f),t.$ig=t.$0f.normalizePath.bind(t.$0f),t.$jg=t.$0f.relativePath.bind(t.$0f),t.$kg=t.$0f.resolvePath.bind(t.$0f),t.$lg=t.$0f.isAbsolutePath.bind(t.$0f),t.$mg=t.$0f.isEqualAuthority.bind(t.$0f),t.$ng=t.$0f.hasTrailingPathSeparator.bind(t.$0f),t.$og=t.$0f.removeTrailingPathSeparator.bind(t.$0f),t.$pg=t.$0f.addTrailingPathSeparator.bind(t.$0f);function f(h,e){const a=[];for(let o=0;o<h.length;o++){const s=e(h[o]);h.some((n,g)=>g===o?!1:(0,t.$bg)(s,e(n)))||a.push(h[o])}return a}t.$qg=f;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function e(a){const o=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(g=>{const[b,$]=g.split(":");b&&$&&o.set(b,$)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&o.set(h.META_DATA_MIME,n),o}h.parseMetaData=e})(P||(t.DataUri=P={}));function r(h,e,a){if(e){let o=h.path;return o&&o[0]!==i.$5d.sep&&(o=i.$5d.sep+o),h.with({scheme:a,authority:e,path:o})}return h.with({scheme:a})}t.$rg=r}),define(be[9],pe([1,0,27,6,3,2,35,5,48]),function(le,t,y,O,i,_,D,w,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4g=t.$3g=t.$2g=t.Promises=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=void 0;function u(d){return!!d&&typeof d.then=="function"}t.$sg=u;function f(d){const p=new y.$od,E=d(p.token),I=new Promise((N,B)=>{const q=p.token.onCancellationRequested(()=>{q.dispose(),p.dispose(),B(new O.$3)});Promise.resolve(E).then(L=>{q.dispose(),p.dispose(),N(L)},L=>{q.dispose(),p.dispose(),B(L)})});return new class{cancel(){p.cancel()}then(N,B){return I.then(N,B)}catch(N){return this.then(void 0,N)}finally(N){return I.finally(N)}}}t.$tg=f;function P(d,p,E){return new Promise((I,N)=>{const B=p.onCancellationRequested(()=>{B.dispose(),I(E)});d.then(I,N).finally(()=>B.dispose())})}t.$ug=P;function r(d,p){return new Promise((E,I)=>{const N=p.onCancellationRequested(()=>{N.dispose(),I(new O.$3)});d.then(E,I).finally(()=>N.dispose())})}t.$vg=r;async function h(d){let p=-1;const E=d.map((I,N)=>I.then(B=>(p=N,B)));try{return await Promise.race(E)}finally{d.forEach((I,N)=>{N!==p&&I.cancel()})}}t.$wg=h;function e(d,p,E){let I;const N=setTimeout(()=>{I?.(void 0),E?.()},p);return Promise.race([d.finally(()=>clearTimeout(N)),new Promise(B=>I=B)])}t.$xg=e;function a(d){return new Promise((p,E)=>{const I=d();u(I)?I.then(p,E):p(I)})}t.$yg=a;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const E=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(E,E).then(I)})}return new Promise((E,I)=>{this.b.then(E,I)})}return this.a=p(),new Promise((E,I)=>{this.a.then(N=>{this.a=null,E(N)},N=>{this.a=null,I(N)})})}dispose(){this.f=!0}}t.$zg=o;class s{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Ag=s;class n{constructor(){this.a=new Map}queue(p,E){const N=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(p)===N&&this.a.delete(p)});return this.a.set(p,N),N}}t.$Bg=n;const g=(d,p)=>{let E=!0;const I=setTimeout(()=>{E=!1,p()},d);return{isTriggered:()=>E,dispose:()=>{clearTimeout(I),E=!1}}},b=d=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,d())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class ${constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,E=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((N,B)=>{this.d=N,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=E===l.$bd?b(I):g(E,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Cg=$;class c{constructor(p){this.a=new $(p),this.b=new o}trigger(p,E){return this.a.trigger(()=>this.b.queue(p),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Dg=c;class F{constructor(){this.a=!1,this.b=new Promise((p,E)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Eg=F;class R extends F{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Fg=R;function T(d,p){return p?new Promise((E,I)=>{const N=setTimeout(()=>{B.dispose(),E()},d),B=p.onCancellationRequested(()=>{clearTimeout(N),B.dispose(),I(new O.$3)})}):f(E=>T(d,E))}t.$Gg=T;function m(d,p=0){const E=setTimeout(d,p);return(0,_.$hc)(()=>clearTimeout(E))}t.$Hg=m;function v(d){const p=[];let E=0;const I=d.length;function N(){return E<I?d[E++]():null}function B(q){q!=null&&p.push(q);const L=N();return L?L.then(B):Promise.resolve(p)}return Promise.resolve(null).then(B)}t.$Ig=v;function z(d,p=I=>!!I,E=null){let I=0;const N=d.length,B=()=>{if(I>=N)return Promise.resolve(E);const q=d[I++];return Promise.resolve(q()).then(j=>p(j)?Promise.resolve(j):B())};return B()}t.$Jg=z;function U(d,p=I=>!!I,E=null){if(d.length===0)return Promise.resolve(E);let I=d.length;const N=()=>{I=-1;for(const B of d)B.cancel?.()};return new Promise((B,q)=>{for(const L of d)L.then(j=>{--I>=0&&p(j)?(N(),B(j)):I===0&&B(E)}).catch(j=>{--I>=0&&(N(),q(j))})})}t.$Kg=U;class M{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((E,I)=>{this.f.push({factory:p,c:E,e:I}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const E=p.factory();E.then(p.c,p.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Lg=M;class A extends M{constructor(){super(1)}}t.$Mg=A;class H{constructor(){this.a=new Re,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$Ng=H;class Q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new G;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,E=D.$0f){const I=E.getComparisonKey(p);let N=this.a.get(I);if(!N){N=new A;const B=this.f++,q=i.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(I),this.h(),this.d?.deleteAndDispose(B),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new _.$rc),this.d.set(B,q),this.a.set(I,N)}return N}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Og=Q;class ie{constructor(p,E){this.a=-1,typeof p=="function"&&typeof E=="number"&&this.setIfNotSet(p,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},E)}setIfNotSet(p,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},E))}}t.$Pg=ie;class re{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(p,E){this.cancel(),this.a=setInterval(()=>{p()},E)}}t.$Qg=re;class ue{constructor(p,E){this.b=-1,this.a=p,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Rg=ue;class he{constructor(p,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=p,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Sg=he;class oe extends ue{constructor(p,E){super(p,E),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$Tg=oe;class ge extends _.$jc{constructor(p,E){super(),this.g=p,this.h=E,this.a=[],this.b=this.B(new _.$kc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of p)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Ug=ge,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$Vg=d=>{(0,w.$A)(()=>{if(p)return;const E=Date.now()+15;d(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$Vg=(d,p)=>{const E=requestIdleCallback(d,typeof p=="number"?{timeout:p}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(E))}}}}();class Ce{constructor(p){this.d=!1,this.a=()=>{try{this.f=p()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,t.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$Wg=Ce;async function Se(d,p,E){let I;for(let N=0;N<E;N++)try{return await d()}catch(B){I=B,await T(p)}throw I}t.$Xg=Se;class Re{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,E,I){return this.a={taskId:p,cancel:()=>I?.(),promise:E},E.then(()=>this.d(p),()=>this.d(p)),E}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let E,I;const N=new Promise((B,q)=>{E=B,I=q});this.b={run:p,promise:N,promiseResolve:E,promiseReject:I}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Yg=Re;class fe{constructor(p,E=()=>Date.now()){this.d=p,this.f=E,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$Zg=fe;var ne;(function(d){d[d.Resolved=0]="Resolved",d[d.Rejected=1]="Rejected"})(ne||(ne={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,E)=>{this.a=p,this.b=E})}complete(p){return new Promise(E=>{this.a(p),this.d={outcome:0,value:p},E()})}error(p){return new Promise(E=>{this.b(p),this.d={outcome:1,value:p},E()})}cancel(){return this.error(new O.$3)}}t.$1g=G;var V;(function(d){async function p(I){let N;const B=await Promise.all(I.map(q=>q.then(L=>L,L=>{N||(N=L)})));if(typeof N<"u")throw N;return B}d.settled=p;function E(I){return new Promise(async(N,B)=>{try{await I(N,B)}catch(q){B(q)}})}d.withAsyncBody=E})(V||(t.Promises=V={}));var ee;(function(d){d[d.Initial=0]="Initial",d[d.DoneOK=1]="DoneOK",d[d.DoneError=2]="DoneError"})(ee||(ee={}));class Z{static fromArray(p){return new Z(E=>{E.emitMany(p)})}static fromPromise(p){return new Z(async E=>{E.emitMany(await p)})}static fromPromises(p){return new Z(async E=>{await Promise.all(p.map(async I=>E.emitOne(await I)))})}static merge(p){return new Z(async E=>{await Promise.all(p.map(async I=>{for await(const N of I)E.emitOne(N)}))})}static{this.EMPTY=Z.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$ed,queueMicrotask(async()=>{const E={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(p(E)),this.j()}catch(I){this.k(I)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,E){return new Z(async I=>{for await(const N of p)I.emitOne(E(N))})}map(p){return Z.map(this,p)}static filter(p,E){return new Z(async I=>{for await(const N of p)E(N)&&I.emitOne(N)})}filter(p){return Z.filter(this,p)}static coalesce(p){return Z.filter(p,E=>!!E)}coalesce(){return Z.coalesce(this)}static async toPromise(p){const E=[];for await(const I of p)E.push(I);return E}toPromise(){return Z.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$2g=Z;class C extends Z{constructor(p,E){super(E),this.l=p}cancel(){this.l.cancel()}}t.$3g=C;function x(d){const p=new y.$od,E=d(p.token);return new C(p,async I=>{const N=p.token.onCancellationRequested(()=>{N.dispose(),p.dispose(),I.reject(new O.$3)});try{for await(const B of E){if(p.token.isCancellationRequested)return;I.emitOne(B)}N.dispose(),p.dispose()}catch(B){N.dispose(),p.dispose(),I.reject(B)}})}t.$4g=x}),define(be[4],pe([1,0,16,111,14,19,9,6,3,115,2,28,5,15]),function(le,t,y,O,i,_,D,w,l,u,f,P,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.DetectedFullscreenMode=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$=t.Namespace=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=t.$tO=t.$sO=t.$rO=t.$qO=t.$pO=t.$oO=t.$nO=t.$mO=t.$lO=t.$kO=t.$jO=t.$iO=t.$hO=t.$gO=t.$fO=t.$eO=void 0;function e(J){for(;J.firstChild;)J.firstChild.remove()}t.$eO=e;function a(J){return J?.isConnected??!1}t.$fO=a;class o{constructor(X,de,Ae,Fe){this.f=X,this.g=de,this.d=Ae,this.j=Fe||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function s(J,X,de,Ae){return new o(J,X,de,Ae)}t.$gO=s;function n(J){return function(X){return J(new _.$$N(X))}}function g(J){return function(X){return J(new i.$dO(X))}}const b=function(X,de,Ae,Fe){let _e=Ae;return de==="click"||de==="mousedown"?_e=n(Ae):(de==="keydown"||de==="keypress"||de==="keyup")&&(_e=g(Ae)),s(X,de,_e,Fe)};t.$hO=b;const $=function(X,de,Ae){const Fe=n(de);return F(X,Fe,Ae)};t.$iO=$;const c=function(X,de,Ae){const Fe=n(de);return T(X,Fe,Ae)};t.$jO=c;function F(J,X,de){return s(J,r.$q&&O.$8N.pointerEvents?t.$UO.POINTER_DOWN:t.$UO.MOUSE_DOWN,X,de)}t.$kO=F;function R(J,X,de){return s(J,r.$q&&O.$8N.pointerEvents?t.$UO.POINTER_MOVE:t.$UO.MOUSE_MOVE,X,de)}t.$lO=R;function T(J,X,de){return s(J,r.$q&&O.$8N.pointerEvents?t.$UO.POINTER_UP:t.$UO.MOUSE_UP,X,de)}t.$mO=T;class m{constructor(X,de=0){this.d=X,this.priority=de,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(X){(0,w.$Y)(X)}}static sort(X,de){return de.priority-X.priority}}(function(){let J=[],X=null,de=!1,Ae=!1;const Fe=()=>{for(de=!1,X=J,J=[],Ae=!0;X.length>0;)X.sort(m.sort),X.shift().execute();Ae=!1};t.$oO=(_e,He=0)=>{const Je=new m(_e,He);return J.push(Je),de||(de=!0,requestAnimationFrame(Fe)),Je},t.$nO=(_e,He)=>{if(Ae){const Je=new m(_e,He);return X.push(Je),Je}else return(0,t.$oO)(_e,He)}})();function v(J){return(0,t.$oO)(J,1e4)}t.$pO=v;function z(J){return(0,t.$oO)(J,-1e4)}t.$qO=z;const U=8,M=function(J,X){return X};class A extends f.$jc{constructor(X,de,Ae,Fe=M,_e=U){super();let He=null,Je=0;const at=this.B(new D.$Pg),Ze=()=>{Je=new Date().getTime(),Ae(He),He=null};this.B(s(X,de,pt=>{He=Fe(He,pt);const St=new Date().getTime()-Je;St>=_e?(at.cancel(),Ze()):at.setIfNotSet(Ze,_e-St)}))}}function H(J,X,de,Ae,Fe){return new A(J,X,de,Ae,Fe)}t.$rO=H;function Q(J){return document.defaultView.getComputedStyle(J,null)}t.$sO=Q;function ie(J){if(J!==document.body)return new ue(J.clientWidth,J.clientHeight);if(r.$q&&window.visualViewport)return new ue(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ue(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ue(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ue(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$tO=ie;class re{static d(X,de){return parseFloat(de)||0}static f(X,de,Ae){const Fe=Q(X),_e=Fe?Fe.getPropertyValue(de):"0";return re.d(X,_e)}static getBorderLeftWidth(X){return re.f(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return re.f(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return re.f(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return re.f(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return re.f(X,"padding-left","paddingLeft")}static getPaddingRight(X){return re.f(X,"padding-right","paddingRight")}static getPaddingTop(X){return re.f(X,"padding-top","paddingTop")}static getPaddingBottom(X){return re.f(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return re.f(X,"margin-left","marginLeft")}static getMarginTop(X){return re.f(X,"margin-top","marginTop")}static getMarginRight(X){return re.f(X,"margin-right","marginRight")}static getMarginBottom(X){return re.f(X,"margin-bottom","marginBottom")}}class ue{static{this.None=new ue(0,0)}constructor(X,de){this.width=X,this.height=de}with(X=this.width,de=this.height){return X!==this.width||de!==this.height?new ue(X,de):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof ue?X:new ue(X.width,X.height)}static equals(X,de){return X===de?!0:!X||!de?!1:X.width===de.width&&X.height===de.height}}t.$uO=ue;function he(J){let X=J.offsetParent,de=J.offsetTop,Ae=J.offsetLeft;for(;(J=J.parentNode)!==null&&J!==document.body&&J!==document.documentElement;){de-=J.scrollTop;const Fe=B(J)?null:Q(J);Fe&&(Ae-=Fe.direction!=="rtl"?J.scrollLeft:-J.scrollLeft),J===X&&(Ae+=re.getBorderLeftWidth(J),de+=re.getBorderTopWidth(J),de+=J.offsetTop,Ae+=J.offsetLeft,X=J.offsetParent)}return{left:Ae,top:de}}t.$vO=he;function oe(J,X,de){typeof X=="number"&&(J.style.width=`${X}px`),typeof de=="number"&&(J.style.height=`${de}px`)}t.$wO=oe;function ge(J,X,de,Ae,Fe,_e="absolute"){typeof X=="number"&&(J.style.top=`${X}px`),typeof de=="number"&&(J.style.right=`${de}px`),typeof Ae=="number"&&(J.style.bottom=`${Ae}px`),typeof Fe=="number"&&(J.style.left=`${Fe}px`),J.style.position=_e}t.$xO=ge;function Ce(J){const X=J.getBoundingClientRect();return{left:X.left+window.scrollX,top:X.top+window.scrollY,width:X.width,height:X.height}}t.$yO=Ce;function Se(J){let X=J,de=1;do{const Ae=Q(X).zoom;Ae!=null&&Ae!=="1"&&(de*=Ae),X=X.parentElement}while(X!==null&&X!==document.documentElement);return de}t.$zO=Se;function Re(J){const X=re.getMarginLeft(J)+re.getMarginRight(J);return J.offsetWidth+X}t.$AO=Re;function fe(J){const X=re.getBorderLeftWidth(J)+re.getBorderRightWidth(J),de=re.getPaddingLeft(J)+re.getPaddingRight(J);return J.offsetWidth-X-de}t.$BO=fe;function ne(J){const X=re.getMarginLeft(J)+re.getMarginRight(J);return J.scrollWidth+X}t.$CO=ne;function G(J){const X=re.getBorderTopWidth(J)+re.getBorderBottomWidth(J),de=re.getPaddingTop(J)+re.getPaddingBottom(J);return J.offsetHeight-X-de}t.$DO=G;function V(J){const X=re.getMarginTop(J)+re.getMarginBottom(J);return J.offsetHeight+X}t.$EO=V;function ee(J,X){if(J===null)return 0;const de=he(J),Ae=he(X);return de.left-Ae.left}function Z(J,X){const de=X.map(Fe=>Math.max(ne(Fe),Re(Fe))+ee(Fe,J)||0);return Math.max(...de)}t.$FO=Z;function C(J,X){for(;J;){if(J===X)return!0;J=J.parentNode}return!1}t.$GO=C;const x="parentFlowToElementId";function d(J,X){J.dataset[x]=X.id}t.$HO=d;function p(J){const X=J.dataset[x];return typeof X=="string"?document.getElementById(X):null}function E(J,X){let de=J;for(;de;){if(de===X)return!0;if(de instanceof HTMLElement){const Ae=p(de);if(Ae){de=Ae;continue}}de=de.parentNode}return!1}t.$IO=E;function I(J,X,de){for(;J&&J.nodeType===J.ELEMENT_NODE;){if(J.classList.contains(X))return J;if(de){if(typeof de=="string"){if(J.classList.contains(de))return null}else if(J===de)return null}J=J.parentNode}return null}t.$JO=I;function N(J,X,de){return!!I(J,X,de)}t.$KO=N;function B(J){return J&&!!J.host&&!!J.mode}t.$LO=B;function q(J){return!!L(J)}t.$MO=q;function L(J){for(;J.parentNode;){if(J===document.body)return null;J=J.parentNode}return B(J)?J:null}t.$NO=L;function j(){let J=document.activeElement;for(;J?.shadowRoot;)J=J.shadowRoot.activeElement;return J}t.$OO=j;function S(J=document.getElementsByTagName("head")[0],X){const de=document.createElement("style");return de.type="text/css",de.media="screen",X?.(de),J.appendChild(de),de}t.$PO=S;function k(J=document.getElementsByTagName("head")[0]){const X=document.createElement("meta");return J.appendChild(X),X}t.$QO=k;let W=null;function K(){return W||(W=S()),W}function te(J){return J?.sheet?.rules?J.sheet.rules:J?.sheet?.cssRules?J.sheet.cssRules:[]}function se(J,X,de=K()){!de||!X||de.sheet.insertRule(J+"{"+X+"}",0)}t.$RO=se;function me(J,X=K()){if(!X)return;const de=te(X),Ae=[];for(let Fe=0;Fe<de.length;Fe++)de[Fe].selectorText.indexOf(J)!==-1&&Ae.push(Fe);for(let Fe=Ae.length-1;Fe>=0;Fe--)X.sheet.deleteRule(Ae[Fe])}t.$SO=me;function we(J){return typeof HTMLElement=="object"?J instanceof HTMLElement:J&&typeof J=="object"&&J.nodeType===1&&typeof J.nodeName=="string"}t.$TO=we,t.$UO={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.$ZN?"webkitAnimationStart":"animationstart",ANIMATION_END:y.$ZN?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.$ZN?"webkitAnimationIteration":"animationiteration"};function Ne(J){const X=J;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.$VO=Ne,t.$WO={stop:(J,X)=>(J.preventDefault(),X&&J.stopPropagation(),J)};function Ee(J){const X=[];for(let de=0;J&&J.nodeType===J.ELEMENT_NODE;de++)X[de]=J.scrollTop,J=J.parentNode;return X}t.$XO=Ee;function ve(J,X){for(let de=0;J&&J.nodeType===J.ELEMENT_NODE;de++)J.scrollTop!==X[de]&&(J.scrollTop=X[de]),J=J.parentNode}t.$YO=ve;class Te extends f.$jc{static m(X){const de=L(X),Ae=de?de.activeElement:document.activeElement;return C(Ae,X)}constructor(X){super(),this.f=this.B(new l.$ed),this.onDidFocus=this.f.event,this.g=this.B(new l.$ed),this.onDidBlur=this.g.event;let de=Te.m(X),Ae=!1;const Fe=()=>{Ae=!1,de||(de=!0,this.f.fire())},_e=()=>{de&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,de=!1,this.g.fire())},0))};this.j=()=>{Te.m(X)!==de&&(de?_e():Fe())},this.B(s(X,t.$UO.FOCUS,Fe,!0)),this.B(s(X,t.$UO.BLUR,_e,!0)),X instanceof HTMLElement&&(this.B(s(X,t.$UO.FOCUS_IN,()=>this.j())),this.B(s(X,t.$UO.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Pe(J){return new Te(J)}t.$ZO=Pe;function qe(J,X){return J.after(X),X}t.$1O=qe;function je(J,...X){if(J.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}t.$2O=je;function Ie(J,X){return J.insertBefore(X,J.firstChild),X}t.$3O=Ie;function Ge(J,...X){J.innerText="",je(J,...X)}t.$4O=Ge;const Y=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var ae;(function(J){J.HTML="http://www.w3.org/1999/xhtml",J.SVG="http://www.w3.org/2000/svg"})(ae||(t.Namespace=ae={}));function $e(J,X,de,...Ae){const Fe=Y.exec(X);if(!Fe)throw new Error("Bad use of emmet");const _e=Fe[1]||"div";let He;return J!==ae.HTML?He=document.createElementNS(J,_e):He=document.createElement(_e),Fe[3]&&(He.id=Fe[3]),Fe[4]&&(He.className=Fe[4].replace(/\./g," ").trim()),de&&Object.entries(de).forEach(([Je,at])=>{typeof at>"u"||(/^on\w+$/.test(Je)?He[Je]=at:Je==="selected"?at&&He.setAttribute(Je,"true"):He.setAttribute(Je,at))}),He.append(...Ae),He}function De(J,X,...de){return $e(ae.HTML,J,X,...de)}t.$=De,De.SVG=function(J,X,...de){return $e(ae.SVG,J,X,...de)};function Oe(J,X){const de=[];return J.forEach((Ae,Fe)=>{Fe>0&&(X instanceof Node?de.push(X.cloneNode()):de.push(document.createTextNode(X))),de.push(Ae)}),de}t.$6O=Oe;function Me(J,...X){J?ze(...X):Qe(...X)}t.$7O=Me;function ze(...J){for(const X of J)X.style.display="",X.removeAttribute("aria-hidden")}t.$8O=ze;function Qe(...J){for(const X of J)X.style.display="none",X.setAttribute("aria-hidden","true")}t.$9O=Qe;function Ye(J,X){for(;J&&J.nodeType===J.ELEMENT_NODE;){if(J instanceof HTMLElement&&J.hasAttribute(X))return J;J=J.parentNode}return null}function Ve(J){!J||!J.hasAttribute("tabIndex")||(document.activeElement===J&&Ye(J.parentElement,"tabIndex")?.focus(),J.removeAttribute("tabindex"))}t.$0O=Ve;function We(J){return X=>{X.preventDefault(),X.stopPropagation(),J(X)}}t.$$O=We;function et(){return new Promise(J=>{document.readyState==="complete"||document&&document.body!==null?J(void 0):window.addEventListener("DOMContentLoaded",J,!1)})}t.$_O=et;function it(J){const X=window.devicePixelRatio*J;return Math.max(1,Math.floor(X))/window.devicePixelRatio}t.$aP=it;function ft(J){window.open(J,"_blank","noopener")}t.$bP=ft;const ct=780,ot=640;function yt(J){const X=Math.floor(window.screenLeft+window.innerWidth/2-ct/2),de=Math.floor(window.screenTop+window.innerHeight/2-ot/2);window.open(J,"_blank",`width=${ct},height=${ot},top=${de},left=${X}`)}t.$cP=yt;function Et(J,X=!0){const de=window.open();return de?(X&&(de.opener=null),de.location.href=J,!0):!1}t.$dP=Et;function At(J){const X=()=>{J(),de=(0,t.$oO)(X)};let de=(0,t.$oO)(X);return(0,f.$hc)(()=>de.dispose())}t.$eP=At,P.$Vf.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function kt(J){return J?`url('${P.$1f.uriToBrowserUri(J).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$fP=kt;function Rt(J){return`'${J.replace(/'/g,"%27")}'`}t.$gP=Rt;function Le(J,X){if(J!==void 0){const de=J.match(/^\s*var\((.+)\)$/);if(de){const Ae=de[1].split(",",2);return Ae.length===2&&(X=Le(Ae[1].trim(),X)),`var(${Ae[0]}, ${X})`}return J}return X}t.$hP=Le;function ce(J,X){let de;if(h.URI.isUri(J))de=J.toString(!0);else{const Fe=new Blob([J]);de=URL.createObjectURL(Fe),setTimeout(()=>URL.revokeObjectURL(de))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=X,Ae.href=de,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.$iP=ce;function ye(){return new Promise(J=>{const X=document.createElement("input");document.body.appendChild(X),X.type="file",X.multiple=!0,l.Event.once(l.Event.fromDOMEventEmitter(X,"input"))(()=>{J(X.files??void 0)}),X.click(),setTimeout(()=>document.body.removeChild(X))})}t.$jP=ye;var ke;(function(J){J[J.DOCUMENT=1]="DOCUMENT",J[J.BROWSER=2]="BROWSER"})(ke||(t.DetectedFullscreenMode=ke={}));function Ue(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:ke.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:ke.BROWSER,guess:!1}:(r.$j||r.$k)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:ke.BROWSER,guess:!0}:null}t.$kP=Ue;function Xe(J,X=!1){const de=document.createElement("a");return u.addHook("afterSanitizeAttributes",Ae=>{for(const Fe of["href","src"])if(Ae.hasAttribute(Fe)){const _e=Ae.getAttribute(Fe);if(Fe==="href"&&_e.startsWith("#"))continue;if(de.href=_e,!J.includes(de.protocol.replace(/:$/,""))){if(X&&Fe==="src"&&de.href.startsWith("data:"))continue;Ae.removeAttribute(Fe)}}}),(0,f.$hc)(()=>{u.removeHook("afterSanitizeAttributes")})}t.$lP=Xe;const nt=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.$mP=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const xe=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function lt(J,X){const de=Xe(nt);try{const Ae=u.sanitize(X,xe);J.innerHTML=Ae}finally{de.dispose()}}t.$nP=lt;function $t(J){const X=new Uint16Array(J.length);for(let Fe=0;Fe<X.length;Fe++)X[Fe]=J.charCodeAt(Fe);let de="";const Ae=new Uint8Array(X.buffer);for(let Fe=0;Fe<Ae.length;Fe++)de+=String.fromCharCode(Ae[Fe]);return de}function Ct(J){return btoa($t(J))}t.$oP=Ct;class dt extends l.$ed{constructor(){super(),this.s=new f.$ic,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(s(window,"keydown",X=>{if(X.defaultPrevented)return;const de=new i.$dO(X);if(!(de.keyCode===6&&X.repeat)){if(X.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(X.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(X.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(X.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(de.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=X.altKey,this.A.ctrlKey=X.ctrlKey,this.A.metaKey=X.metaKey,this.A.shiftKey=X.shiftKey,this.A.lastKeyPressed&&(this.A.event=X,this.fire(this.A))}},!0)),this.s.add(s(window,"keyup",X=>{X.defaultPrevented||(!X.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!X.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!X.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!X.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=X.altKey,this.A.ctrlKey=X.ctrlKey,this.A.metaKey=X.metaKey,this.A.shiftKey=X.shiftKey,this.A.lastKeyReleased&&(this.A.event=X,this.fire(this.A)))},!0)),this.s.add(s(document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mousemove",X=>{X.buttons&&(this.A.lastKeyPressed=void 0)},!0)),this.s.add(s(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.C(),this.fire(this.A)}C(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.B||(dt.B=new dt),dt.B}dispose(){super.dispose(),this.s.dispose()}}t.$pP=dt;function $i(J){const X=document.cookie.match("(^|[^;]+)\\s*"+J+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}t.$qP=$i;class pi extends f.$jc{constructor(X,de){super(),this.j=X,this.m=de,this.f=0,this.g=0,this.n()}n(){this.B(s(this.j,t.$UO.DRAG_ENTER,X=>{this.f++,this.g=X.timeStamp,this.m.onDragEnter(X)})),this.B(s(this.j,t.$UO.DRAG_OVER,X=>{X.preventDefault(),this.m.onDragOver?.(X,X.timeStamp-this.g)})),this.B(s(this.j,t.$UO.DRAG_LEAVE,X=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(X))})),this.B(s(this.j,t.$UO.DRAG_END,X=>{this.f=0,this.g=0,this.m.onDragEnd(X)})),this.B(s(this.j,t.$UO.DROP,X=>{this.f=0,this.g=0,this.m.onDrop(X)}))}}t.$rP=pi;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function vi(J,...X){let de,Ae;Array.isArray(X[0])?(de={},Ae=X[0]):(de=X[0]||{},Ae=X[1]);const Fe=wi.exec(J);if(!Fe||!Fe.groups)throw new Error("Bad use of h");const _e=Fe.groups.tag||"div",He=document.createElement(_e);Fe.groups.id&&(He.id=Fe.groups.id);const Je=[];if(Fe.groups.class)for(const Ze of Fe.groups.class.split("."))Ze!==""&&Je.push(Ze);if(de.className!==void 0)for(const Ze of de.className.split("."))Ze!==""&&Je.push(Ze);Je.length>0&&(He.className=Je.join(" "));const at={};if(Fe.groups.name&&(at[Fe.groups.name]=He),Ae)for(const Ze of Ae)Ze instanceof HTMLElement?He.appendChild(Ze):typeof Ze=="string"?He.append(Ze):"root"in Ze&&(Object.assign(at,Ze),He.appendChild(Ze.root));for(const[Ze,pt]of Object.entries(de))if(Ze!=="className")if(Ze==="style")for(const[St,Mt]of Object.entries(pt))He.style.setProperty(Gt(St),typeof Mt=="number"?Mt+"px":""+Mt);else Ze==="tabIndex"?He.tabIndex=pt:He.setAttribute(Gt(Ze),pt.toString());return at.root=He,at}t.h=vi;function Gt(J){return J.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(be[52],pe([1,0,4,2,114]),function(le,t,y,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vP=t.$uP=t.$tP=void 0;class _ extends O.$jc{constructor(l,u){super(),this.B((0,y.$gO)(l,"dragover",f=>{f.preventDefault(),this.a||(this.a=setTimeout(()=>{u(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this.B((0,y.$gO)(l,f,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$tP=_,t.$uP={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Fr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(w,l,u,f,P){const r=document.createElement("div");r.className=u,r.textContent=l,P&&(r.style.color=P),f&&(r.style.background=f),w.dataTransfer&&(document.body.appendChild(r),w.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.$vP=D}),define(be[53],pe([1,0,4]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZP=t.$YP=t.$XP=void 0;function O(r,h={}){const e=_(h);return e.textContent=r,e}t.$XP=O;function i(r,h={}){const e=_(h);return l(e,u(r,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),e}t.$YP=i;function _(r){const h=r.inline?"span":"div",e=document.createElement(h);return r.className&&(e.className=r.className),e}t.$ZP=_;class D{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(w||(w={}));function l(r,h,e,a){let o;if(h.type===2)o=document.createTextNode(h.content||"");else if(h.type===3)o=document.createElement("b");else if(h.type===4)o=document.createElement("i");else if(h.type===7&&a)o=document.createElement("code");else if(h.type===5&&e){const s=document.createElement("a");e.disposables.add(y.$hO(s,"click",n=>{e.callback(String(h.index),n)})),o=s}else h.type===8?o=document.createElement("br"):h.type===1&&(o=r);o&&r!==o&&r.appendChild(o),o&&Array.isArray(h.children)&&h.children.forEach(s=>{l(o,s,e,a)})}function u(r,h){const e={type:1,children:[]};let a=0,o=e;const s=[],n=new D(r);for(;!n.eos();){let g=n.next();const b=g==="\\"&&P(n.peek(),h)!==0;if(b&&(g=n.next()),!b&&f(g,h)&&g===n.peek()){n.advance(),o.type===2&&(o=s.pop());const $=P(g,h);if(o.type===$||o.type===5&&$===6)o=s.pop();else{const c={type:$,children:[]};$===5&&(c.index=a,a++),o.children.push(c),s.push(o),o=c}}else if(g===`
`)o.type===2&&(o=s.pop()),o.children.push({type:8});else if(o.type!==2){const $={type:2,content:g};o.children.push($),s.push(o),o=$}else o.content+=g}return o.type===2&&(o=s.pop()),s.length,e}function f(r,h){return P(r,h)!==0}function P(r,h){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define(be[54],pe([1,0,4,2]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zP=void 0;class i{constructor(){this.a=new O.$ic,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const l=this.c;this.c=null,D&&l&&l(w)}isMonitoring(){return!!this.b}startMonitoring(D,w,l,u,f){this.isMonitoring()&&this.stopMonitoring(!1),this.b=u,this.c=f;let P=D;try{D.setPointerCapture(w),this.a.add((0,O.$hc)(()=>{try{D.releasePointerCapture(w)}catch{}}))}catch{P=window}this.a.add(y.$gO(P,y.$UO.POINTER_MOVE,r=>{if(r.buttons!==l){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(y.$gO(P,y.$UO.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.$zP=i});var Ke=this&&this.__decorate||function(le,t,y,O){var i=arguments.length,_=i<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,y):O,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(le,t,y,O);else for(var w=le.length-1;w>=0;w--)(D=le[w])&&(_=(i<3?D(_):i>3?D(t,y,_):D(t,y))||_);return i>3&&_&&Object.defineProperty(t,y,_),_};define(be[23],pe([1,0,4,11,25,2,44]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wP=t.EventType=void 0;var w;(function(u){u.Tap="-monaco-gesturetap",u.Change="-monaco-gesturechange",u.Start="-monaco-gesturestart",u.End="-monaco-gesturesend",u.Contextmenu="-monaco-gesturecontextmenu"})(w||(t.EventType=w={}));class l extends _.$jc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new D.$sc,this.h=new D.$sc,this.m={},this.j=null,this.n=0,this.B(y.$gO(document,"touchstart",f=>this.s(f),{passive:!1})),this.B(y.$gO(document,"touchend",f=>this.u(f))),this.B(y.$gO(document,"touchmove",f=>this.D(f),{passive:!1}))}static addTarget(f){if(!l.isTouchDevice())return _.$jc.None;l.b||(l.b=(0,_.$cc)(new l));const P=l.b.g.push(f);return(0,_.$hc)(P)}static ignoreTarget(f){if(!l.isTouchDevice())return _.$jc.None;l.b||(l.b=(0,_.$cc)(new l));const P=l.b.h.push(f);return(0,_.$hc)(P)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(f){const P=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let r=0,h=f.targetTouches.length;r<h;r++){const e=f.targetTouches.item(r);this.m[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:P,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[P],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const a=this.w(w.Start,e.target);a.pageX=e.pageX,a.pageY=e.pageY,this.z(a)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}u(f){const P=Date.now(),r=Object.keys(this.m).length;for(let h=0,e=f.changedTouches.length;h<e;h++){const a=f.changedTouches.item(h);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const o=this.m[a.identifier],s=Date.now()-o.initialTimeStamp;if(s<l.c&&Math.abs(o.initialPageX-O.$qb(o.rollingPageX))<30&&Math.abs(o.initialPageY-O.$qb(o.rollingPageY))<30){const n=this.w(w.Tap,o.initialTarget);n.pageX=O.$qb(o.rollingPageX),n.pageY=O.$qb(o.rollingPageY),this.z(n)}else if(s>=l.c&&Math.abs(o.initialPageX-O.$qb(o.rollingPageX))<30&&Math.abs(o.initialPageY-O.$qb(o.rollingPageY))<30){const n=this.w(w.Contextmenu,o.initialTarget);n.pageX=O.$qb(o.rollingPageX),n.pageY=O.$qb(o.rollingPageY),this.z(n)}else if(r===1){const n=O.$qb(o.rollingPageX),g=O.$qb(o.rollingPageY),b=O.$qb(o.rollingTimestamps)-o.rollingTimestamps[0],$=n-o.rollingPageX[0],c=g-o.rollingPageY[0],F=[...this.g].filter(R=>o.initialTarget instanceof Node&&R.contains(o.initialTarget));this.C(F,P,Math.abs($)/b,$>0?1:-1,n,Math.abs(c)/b,c>0?1:-1,g)}this.z(this.w(w.End,o.initialTarget)),delete this.m[a.identifier]}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}w(f,P){const r=document.createEvent("CustomEvent");return r.initEvent(f,!1,!0),r.initialTarget=P,r.tapCount=0,r}z(f){if(f.type===w.Tap){const P=new Date().getTime();let r=0;P-this.n>l.r?r=1:r=2,this.n=P,f.tapCount=r}else(f.type===w.Change||f.type===w.Contextmenu)&&(this.n=0);if(f.initialTarget instanceof Node){for(const P of this.h)if(P.contains(f.initialTarget))return;for(const P of this.g)P.contains(f.initialTarget)&&(P.dispatchEvent(f),this.f=!0)}}C(f,P,r,h,e,a,o,s){this.j=y.$oO(()=>{const n=Date.now(),g=n-P;let b=0,$=0,c=!0;r+=l.a*g,a+=l.a*g,r>0&&(c=!1,b=h*r*g),a>0&&(c=!1,$=o*a*g);const F=this.w(w.Change);F.translationX=b,F.translationY=$,f.forEach(R=>R.dispatchEvent(F)),c||this.C(f,n,r,h,e+b,a,o,s+$)})}D(f){const P=Date.now();for(let r=0,h=f.changedTouches.length;r<h;r++){const e=f.changedTouches.item(r);if(!this.m.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const a=this.m[e.identifier],o=this.w(w.Change,a.initialTarget);o.translationX=e.pageX-O.$qb(a.rollingPageX),o.translationY=e.pageY-O.$qb(a.rollingPageY),o.pageX=e.pageX,o.pageY=e.pageY,this.z(o),a.rollingPageX.length>3&&(a.rollingPageX.shift(),a.rollingPageY.shift(),a.rollingTimestamps.shift()),a.rollingPageX.push(e.pageX),a.rollingPageY.push(e.pageY),a.rollingTimestamps.push(P)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}}t.$wP=l,Ke([i.$5g],l,"isTouchDevice",null)}),define(be[55],pe([1,0,4,89]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4P=t.$3P=t.$2P=void 0;const O=2e4;let i,_,D,w,l;function u(h){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),i.appendChild(o),o};_=e(),D=e();const a=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),i.appendChild(o),o};w=a(),l=a(),h.appendChild(i)}t.$2P=u;function f(h){i&&(_.textContent!==h?(y.$eO(D),r(_,h)):(y.$eO(_),r(D,h)))}t.$3P=f;function P(h){i&&(w.textContent!==h?(y.$eO(l),r(w,h)):(y.$eO(w),r(l,h)))}t.$4P=P;function r(h,e){y.$eO(h),e.length>O&&(e=e.substr(0,O)),h.textContent=e,h.style.visibility="hidden",h.style.visibility="visible"}}),define(be[116],pe([1,0,4,18]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qQ=t.$pQ=void 0;const i=new RegExp(`(\\\\)?\\$\\((${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?)\\)`,"g");function _(w){const l=new Array;let u,f=0,P=0;for(;(u=i.exec(w))!==null;){P=u.index||0,f<P&&l.push(w.substring(f,P)),f=(u.index||0)+u[0].length;const[,r,h]=u;l.push(r?`$(${h})`:D({id:h}))}return f<w.length&&l.push(w.substring(f)),l}t.$pQ=_;function D(w){const l=y.$("span");return l.classList.add(...O.ThemeIcon.asClassNameArray(w)),l}t.$qQ=D}),define(be[117],pe([1,0,4]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aQ=void 0;function O(_){try{_.parentElement?.removeChild(_)}catch{}}class i{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let w=this.h(D).pop(),l=!1;if(w)l=this.b.has(w.domNode),l&&this.b.delete(w.domNode);else{const u=(0,y.$)(".monaco-list-row"),P=this.i(D).renderTemplate(u);w={domNode:u,templateId:D,templateData:P}}return{row:w,isReusingConnectedDomNode:l}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const w of this.b)this.g(w);this.b.clear(),this.c=!1}}f(D){const{domNode:w,templateId:l}=D;w&&(this.c?this.b.add(w):this.g(w)),this.h(l).push(D)}g(D){D.classList.remove("scrolling"),O(D)}h(D){let w=this.a.get(D);return w||(w=[],this.a.set(D,w)),w}dispose(){this.a.forEach((D,w)=>{for(const l of D)this.i(w).disposeTemplate(l.templateData),l.templateData=null}),this.a.clear(),this.b.clear()}i(D){const w=this.d.get(D);if(!w)throw new Error(`No renderer found for ${D}`);return w}}t.$aQ=i}),define(be[118],pe([1,0,9,2]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EP=void 0;class i extends O.$jc{constructor(D,w,l){super(),this.a=D,this.b=w,this.c=l,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new y.$Pg)}setVisibility(D){this.a!==D&&(this.a=D,this.s())}setShouldBeVisible(D){this.g=D,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const D=this.r();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.j!==D&&(this.j=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(D){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}t.$EP=i}),define(be[119],pe([1,0,4,23,11,3,2,5]),function(le,t,y,O,i,_,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xQ=void 0;class l extends D.$jc{constructor(f,P,r,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new _.$ed),this.h=r,this.j(),this.setOptions(f,P)}j(){this.B(O.$wP.addTarget(this.a)),[O.EventType.Tap].forEach(f=>{this.B(y.$gO(this.a,f,P=>{this.a.focus()}))}),this.B(y.$hO(this.a,"click",f=>{y.$WO.stop(f,!0)})),this.B(y.$hO(this.a,"change",f=>{this.a.title=f.target.value,this.g.fire({index:f.target.selectedIndex,selected:f.target.value})})),this.B(y.$hO(this.a,"keydown",f=>{let P=!1;w.$j?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(P=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(P=!0),P&&f.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(f,P){(!this.c||!i.$sb(this.c,f))&&(this.c=f,this.a.options.length=0,this.c.forEach((r,h)=>{this.a.add(this.m(r.text,h,r.isDisabled))})),P!==void 0&&this.select(P)}select(f){this.c.length===0?this.f=0:f>=0&&f<this.c.length?this.f=f:f>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(f){this.b.ariaLabel=f,this.a.setAttribute("aria-label",f)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(f){this.a.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(f){this.h=f,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(f,P,r){const h=document.createElement("option");return h.value=f,h.text=f,h.disabled=!!r,h}}t.$xQ=l}),define(be[56],pe([1,0,24,11,9,48,85,3,26]),function(le,t,y,O,i,_,D,w,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4R=t.$3R=t.$2R=void 0;function u(h){return typeof h=="object"&&"visibility"in h&&"data"in h}t.$2R=u;function f(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}t.$3R=f;function P(h){return typeof h.collapsible=="boolean"}class r{constructor(e,a,o,s={}){this.o=e,this.p=a,this.rootRef=[],this.d=new w.$md,this.f=new w.$ed,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new w.$ed,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new w.$ed,this.onDidSplice=this.l.event,this.m=new i.$Cg(_.$bd),this.h=typeof s.collapseByDefault>"u"?!1:s.collapseByDefault,this.j=s.filter,this.k=typeof s.autoExpandSingleChildren>"u"?!1:s.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,a,o=l.Iterable.empty(),s={}){if(e.length===0)throw new y.$ZR(this.o,"Invalid tree location");s.diffIdentityProvider?this.q(s.diffIdentityProvider,e,a,o,s):this.s(e,a,o,s)}q(e,a,o,s=l.Iterable.empty(),n,g=n.diffDepth??0){const{parentNode:b}=this.G(a);if(!b.lastDiffIds)return this.s(a,o,s,n);const $=[...s],c=a[a.length-1],F=new D.$os({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,c),...$,...b.children.slice(c+o)].map(z=>e.getId(z.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return b.lastDiffIds=void 0,this.s(a,o,$,n);const R=a.slice(0,-1),T=(z,U,M)=>{if(g>0)for(let A=0;A<M;A++)z--,U--,this.q(e,[...R,z,0],Number.MAX_SAFE_INTEGER,$[U].children,n,g-1)};let m=Math.min(b.children.length,c+o),v=$.length;for(const z of F.changes.sort((U,M)=>M.originalStart-U.originalStart))T(m,v,m-(z.originalStart+z.originalLength)),m=z.originalStart,v=z.modifiedStart-c,this.s([...R,m],z.originalLength,l.Iterable.slice($,v,v+z.modifiedLength),n);T(m,v,m)}s(e,a,o=l.Iterable.empty(),{onDidCreateNode:s,onDidDeleteNode:n,diffIdentityProvider:g}){const{parentNode:b,listIndex:$,revealed:c,visible:F}=this.G(e),R=[],T=l.Iterable.map(o,ue=>this.w(ue,b,b.visible?1:0,c,R,s)),m=e[e.length-1],v=b.children.length>0;let z=0;for(let ue=m;ue>=0&&ue<b.children.length;ue--){const he=b.children[ue];if(he.visible){z=he.visibleChildIndex;break}}const U=[];let M=0,A=0;for(const ue of T)U.push(ue),A+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=z+M++);const H=(0,O.$3b)(b.children,m,a,U);g?b.lastDiffIds?(0,O.$3b)(b.lastDiffIds,m,a,U.map(ue=>g.getId(ue.element).toString())):b.lastDiffIds=b.children.map(ue=>g.getId(ue.element).toString()):b.lastDiffIds=void 0;let Q=0;for(const ue of H)ue.visible&&Q++;if(Q!==0)for(let ue=m+U.length;ue<b.children.length;ue++){const he=b.children[ue];he.visible&&(he.visibleChildIndex-=Q)}if(b.visibleChildrenCount+=M-Q,c&&F){const ue=H.reduce((he,oe)=>he+(oe.visible?oe.renderNodeCount:0),0);this.B(b,A-ue),this.p.splice($,ue,R)}if(H.length>0&&n){const ue=he=>{n(he),he.children.forEach(ue)};H.forEach(ue)}this.l.fire({insertedNodes:U,deletedNodes:H});const ie=b.children.length>0;v!==ie&&this.setCollapsible(e.slice(0,-1),ie);let re=b;for(;re;){if(re.visibility===2){this.m.trigger(()=>this.refilter());break}re=re.parent}}rerender(e){if(e.length===0)throw new y.$ZR(this.o,"Invalid tree location");const{node:a,listIndex:o,revealed:s}=this.F(e);a.visible&&s&&this.p.splice(o,1,[a])}updateElementHeight(e,a){if(e.length===0)throw new y.$ZR(this.o,"Invalid tree location");const{listIndex:o}=this.F(e);this.p.updateElementHeight(o,a)}has(e){return this.D(e)}getListIndex(e){const{listIndex:a,visible:o,revealed:s}=this.F(e);return o&&s?a:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,a){const o=this.E(e);typeof a>"u"&&(a=!o.collapsible);const s={collapsible:a};return this.d.bufferEvents(()=>this.t(e,s))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,a,o){const s=this.E(e);typeof a>"u"&&(a=!s.collapsed);const n={collapsed:a,recursive:o||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,a){const{node:o,listIndex:s,revealed:n}=this.F(e),g=this.u(o,s,n,a);if(o!==this.c&&this.k&&g&&!P(a)&&o.collapsible&&!o.collapsed&&!a.recursive){let b=-1;for(let $=0;$<o.children.length;$++)if(o.children[$].visible)if(b>-1){b=-1;break}else b=$;b>-1&&this.t([...e,b],a)}return g}u(e,a,o,s){const n=this.v(e,s,!1);if(!o||!e.visible||!n)return n;const g=e.renderNodeCount,b=this.x(e),$=g-(a===-1?0:1);return this.p.splice(a+1,$,b.slice(1)),n}v(e,a,o){let s;if(e===this.c?s=!1:(P(a)?(s=e.collapsible!==a.collapsible,e.collapsible=a.collapsible):e.collapsible?(s=e.collapsed!==a.collapsed,e.collapsed=a.collapsed):s=!1,s&&this.f.fire({node:e,deep:o})),!P(a)&&a.recursive)for(const n of e.children)s=this.v(n,a,!0)||s;return s}expandTo(e){this.d.bufferEvents(()=>{let a=this.E(e);for(;a.parent;)a=a.parent,e=e.slice(0,e.length-1),a.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,a=this.z(this.c);this.p.splice(0,e,a),this.m.cancel()}w(e,a,o,s,n,g){const b={parent:a,element:e.element,children:[],depth:a.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},$=this.C(b,o);b.visibility=$,s&&n.push(b);const c=e.children||l.Iterable.empty(),F=s&&$!==0&&!b.collapsed;let R=0,T=1;for(const m of c){const v=this.w(m,b,$,F,n,g);b.children.push(v),T+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=R++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=R,b.visible=$===2?R>0:$===1,b.visible?b.collapsed||(b.renderNodeCount=T):(b.renderNodeCount=0,s&&n.pop()),g?.(b),b}x(e){const a=e.renderNodeCount,o=[];return this.y(e,o),this.B(e.parent,o.length-a),o}y(e,a){if(e.visible===!1)return 0;if(a.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.y(o,a);return this.g.fire(e),e.renderNodeCount}z(e){const a=e.renderNodeCount,o=[];return this.A(e,e.visible?1:0,o),this.B(e.parent,o.length-a),o}A(e,a,o,s=!0){let n;if(e!==this.c){if(n=this.C(e,a),n===0)return e.visible=!1,e.renderNodeCount=0,!1;s&&o.push(e)}const g=o.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let $=0;for(const c of e.children)b=this.A(c,n,o,s&&!e.collapsed)||b,c.visible&&(c.visibleChildIndex=$++);e.visibleChildrenCount=$}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=o.length-g):(e.renderNodeCount=0,s&&o.pop()),this.g.fire(e),e.visible}B(e,a){if(a!==0)for(;e;)e.renderNodeCount+=a,this.g.fire(e),e=e.parent}C(e,a){const o=this.j?this.j.filter(e.element,a):1;return typeof o=="boolean"?(e.filterData=void 0,o?1:0):u(o)?(e.filterData=o.data,f(o.visibility)):(e.filterData=void 0,f(o))}D(e,a=this.c){if(!e||e.length===0)return!0;const[o,...s]=e;return o<0||o>a.children.length?!1:this.D(s,a.children[o])}E(e,a=this.c){if(!e||e.length===0)return a;const[o,...s]=e;if(o<0||o>a.children.length)throw new y.$ZR(this.o,"Invalid tree location");return this.E(s,a.children[o])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:a,listIndex:o,revealed:s,visible:n}=this.G(e),g=e[e.length-1];if(g<0||g>a.children.length)throw new y.$ZR(this.o,"Invalid tree location");const b=a.children[g];return{node:b,listIndex:o,revealed:s,visible:n&&b.visible}}G(e,a=this.c,o=0,s=!0,n=!0){const[g,...b]=e;if(g<0||g>a.children.length)throw new y.$ZR(this.o,"Invalid tree location");for(let $=0;$<g;$++)o+=a.children[$].renderNodeCount;return s=s&&!a.collapsed,n=n&&a.visible,b.length===0?{parentNode:a,listIndex:o,revealed:s,visible:n}:this.G(b,a.children[g],o+1,s,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const a=[];let o=e;for(;o.parent;)a.push(o.parent.children.indexOf(o)),o=o.parent;return a.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,O.$rb)(e)[0]}getFirstElementChild(e){const a=this.E(e);if(a.children.length!==0)return a.children[0].element}getLastElementAncestor(e=[]){const a=this.E(e);if(a.children.length!==0)return this.H(a)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$4R=r}),define(be[120],pe([1,0,56,24,26]),function(le,t,y,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0R=void 0;class _{get size(){return this.d.size}constructor(w,l,u={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new y.$4R(w,l,null,u),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,u.sorter&&(this.j={compare(f,P){return u.sorter.compare(f.element,P.element)}}),this.h=u.identityProvider}setChildren(w,l=i.Iterable.empty(),u={}){const f=this.o(w);this.l(f,this.m(l),u)}l(w,l=i.Iterable.empty(),u){const f=new Set,P=new Set,r=e=>{if(e.element===null)return;const a=e;if(f.add(a.element),this.d.set(a.element,a),this.h){const o=this.h.getId(a.element).toString();P.add(o),this.f.set(o,a)}u.onDidCreateNode?.(a)},h=e=>{if(e.element===null)return;const a=e;if(f.has(a.element)||this.d.delete(a.element),this.h){const o=this.h.getId(a.element).toString();P.has(o)||this.f.delete(o)}u.onDidDeleteNode?.(a)};this.c.splice([...w,0],Number.MAX_VALUE,l,{...u,onDidCreateNode:r,onDidDeleteNode:h})}m(w=i.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),i.Iterable.map(w,l=>{let u=this.d.get(l.element);if(!u&&this.h){const r=this.h.getId(l.element).toString();u=this.f.get(r)}if(!u){let r;return typeof l.collapsed>"u"?r=void 0:l.collapsed===O.ObjectTreeElementCollapseState.Collapsed||l.collapsed===O.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:l.collapsed===O.ObjectTreeElementCollapseState.Expanded||l.collapsed===O.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!l.collapsed,{...l,children:this.m(l.children),collapsed:r}}const f=typeof l.collapsible=="boolean"?l.collapsible:u.collapsible;let P;return typeof l.collapsed>"u"||l.collapsed===O.ObjectTreeElementCollapseState.PreserveOrCollapsed||l.collapsed===O.ObjectTreeElementCollapseState.PreserveOrExpanded?P=u.collapsed:l.collapsed===O.ObjectTreeElementCollapseState.Collapsed?P=!0:l.collapsed===O.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!l.collapsed,{...l,collapsible:f,collapsed:P,children:this.m(l.children)}})}rerender(w){const l=this.o(w);this.c.rerender(l)}updateElementHeight(w,l){const u=this.o(w);this.c.updateElementHeight(u,l)}resort(w=null,l=!0){if(!this.j)return;const u=this.o(w),f=this.c.getNode(u);this.l(u,this.n(f,l),{})}n(w,l,u=!0){let f=[...w.children];return(l||u)&&(f=f.sort(this.j.compare.bind(this.j))),i.Iterable.map(f,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,l,!1)}))}getFirstElementChild(w=null){const l=this.o(w);return this.c.getFirstElementChild(l)}getLastElementAncestor(w=null){const l=this.o(w);return this.c.getLastElementAncestor(l)}has(w){return this.d.has(w)}getListIndex(w){const l=this.o(w);return this.c.getListIndex(l)}getListRenderCount(w){const l=this.o(w);return this.c.getListRenderCount(l)}isCollapsible(w){const l=this.o(w);return this.c.isCollapsible(l)}setCollapsible(w,l){const u=this.o(w);return this.c.setCollapsible(u,l)}isCollapsed(w){const l=this.o(w);return this.c.isCollapsed(l)}setCollapsed(w,l,u){const f=this.o(w);return this.c.setCollapsed(f,l,u)}expandTo(w){const l=this.o(w);this.c.expandTo(l)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const l=this.d.get(w);if(!l)throw new O.$ZR(this.k,`Tree element not found: ${w}`);return l}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new O.$ZR(this.k,"Invalid getParentNodeLocation call");const l=this.d.get(w);if(!l)throw new O.$ZR(this.k,`Tree element not found: ${w}`);const u=this.c.getNodeLocation(l),f=this.c.getParentNodeLocation(u);return this.c.getNode(f).element}o(w){if(w===null)return[];const l=this.d.get(w);if(!l)throw new O.$ZR(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(l)}}t.$0R=_}),define(be[20],pe([1,0,4,14,19,23,2]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AP=void 0;class w extends D.$jc{f(u,f){this.B(y.$gO(u,y.$UO.CLICK,P=>f(new i.$$N(P))))}j(u,f){this.B(y.$gO(u,y.$UO.MOUSE_DOWN,P=>f(new i.$$N(P))))}m(u,f){this.B(y.$gO(u,y.$UO.MOUSE_OVER,P=>f(new i.$$N(P))))}u(u,f){this.B(y.$gO(u,y.$UO.MOUSE_LEAVE,P=>f(new i.$$N(P))))}z(u,f){this.B(y.$gO(u,y.$UO.KEY_DOWN,P=>f(new O.$dO(P))))}C(u,f){this.B(y.$gO(u,y.$UO.KEY_UP,P=>f(new O.$dO(P))))}D(u,f){this.B(y.$gO(u,y.$UO.INPUT,f))}F(u,f){this.B(y.$gO(u,y.$UO.BLUR,f))}G(u,f){this.B(y.$gO(u,y.$UO.FOCUS,f))}H(u,f){this.B(y.$gO(u,y.$UO.CHANGE,f))}I(u){return _.$wP.ignoreTarget(u)}}t.$AP=w}),define(be[36],pe([1,0,54,20,9,18,4]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CP=t.$BP=void 0,t.$BP=11;class w extends O.$AP{constructor(u){super(),this.a=u.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=u.bgWidth+"px",this.bgDomNode.style.height=u.bgHeight+"px",typeof u.top<"u"&&(this.bgDomNode.style.top="0px"),typeof u.left<"u"&&(this.bgDomNode.style.left="0px"),typeof u.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof u.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=u.className,this.domNode.classList.add(..._.ThemeIcon.asClassNameArray(u.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$BP+"px",this.domNode.style.height=t.$BP+"px",typeof u.top<"u"&&(this.domNode.style.top=u.top+"px"),typeof u.left<"u"&&(this.domNode.style.left=u.left+"px"),typeof u.bottom<"u"&&(this.domNode.style.bottom=u.bottom+"px"),typeof u.right<"u"&&(this.domNode.style.right=u.right+"px"),this.g=this.B(new y.$zP),this.B(D.$hO(this.bgDomNode,D.$UO.POINTER_DOWN,f=>this.h(f))),this.B(D.$hO(this.domNode,D.$UO.POINTER_DOWN,f=>this.h(f))),this.b=this.B(new i.$Qg),this.c=this.B(new i.$Pg)}h(u){if(!u.target||!(u.target instanceof Element))return;const f=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(f,200),this.g.startMonitoring(u.target,u.pointerId,u.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),u.preventDefault()}}t.$CP=w}),define(be[57],pe([1,0,4,39,54,36,118,20,5]),function(le,t,y,O,i,_,D,w,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FP=void 0;const u=140;class f extends w.$AP{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.n=this.B(new D.$EP(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$zP),this.s=!0,this.domNode=(0,O.$yP)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(y.$gO(this.domNode.domNode,y.$UO.POINTER_DOWN,h=>this.M(h)))}t(r){const h=this.B(new _.$CP(r));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}w(r,h,e,a){this.slider=(0,O.$yP)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(h),typeof e=="number"&&this.slider.setWidth(e),typeof a=="number"&&this.slider.setHeight(a),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(y.$gO(this.slider.domNode,y.$UO.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.O(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}y(r){return this.h.setVisibleSize(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(r){return this.h.setScrollSize(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(r){return this.h.setScrollPosition(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(r){r.target===this.domNode.domNode&&this.N(r)}delegatePointerDown(r){const h=this.domNode.domNode.getClientRects()[0].top,e=h+this.h.getSliderPosition(),a=h+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.U(r);e<=o&&o<=a?r.button===0&&(r.preventDefault(),this.O(r)):this.N(r)}N(r){let h,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")h=r.offsetX,e=r.offsetY;else{const o=y.$yO(this.domNode.domNode);h=r.pageX-o.left,e=r.pageY-o.top}const a=this.S(h,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(a):this.h.getDesiredScrollPositionFromOffset(a)),r.button===0&&(r.preventDefault(),this.O(r))}O(r){if(!r.target||!(r.target instanceof Element))return;const h=this.U(r),e=this.W(r),a=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(r.target,r.pointerId,r.buttons,o=>{const s=this.W(o),n=Math.abs(s-e);if(l.$i&&n>u){this.P(a.getScrollPosition());return}const b=this.U(o)-h;this.P(a.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(r){const h={};this.writeScrollPosition(h,r),this.b.setScrollPositionNow(h)}updateScrollbarSize(r){this.X(r),this.h.setScrollbarSize(r),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$FP=f}),define(be[121],pe([1,0,19,57,36,40,17]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GP=void 0;class w extends O.$FP{constructor(u,f,P){const r=u.getScrollDimensions(),h=u.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:P,scrollbarState:new _.$DP(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,r.width,r.scrollWidth,h.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:u,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-i.$BP)/2,a=(f.horizontalScrollbarSize-i.$BP)/2;this.t({className:"scra",icon:D.$Oj.scrollbarButtonLeft,top:a,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$aO(null,1,0))}),this.t({className:"scra",icon:D.$Oj.scrollbarButtonRight,top:a,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$aO(null,-1,0))})}this.w(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}R(u,f){this.slider.setWidth(u),this.slider.setLeft(f)}Q(u,f){this.domNode.setWidth(u),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(u){return this.s=this.J(u.scrollWidth)||this.s,this.s=this.L(u.scrollLeft)||this.s,this.s=this.y(u.width)||this.s,this.s}S(u,f){return u}U(u){return u.pageX}W(u){return u.pageY}X(u){this.slider.setHeight(u)}writeScrollPosition(u,f){u.scrollLeft=f}updateOptions(u){this.updateScrollbarSize(u.horizontal===2?0:u.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.n.setVisibility(u.horizontal),this.c=u.scrollByPage}}t.$GP=w}),define(be[122],pe([1,0,19,57,36,40,17]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HP=void 0;class w extends O.$FP{constructor(u,f,P){const r=u.getScrollDimensions(),h=u.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:P,scrollbarState:new _.$DP(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,r.height,r.scrollHeight,h.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:u,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-i.$BP)/2,a=(f.verticalScrollbarSize-i.$BP)/2;this.t({className:"scra",icon:D.$Oj.scrollbarButtonUp,top:e,left:a,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$aO(null,0,1))}),this.t({className:"scra",icon:D.$Oj.scrollbarButtonDown,top:void 0,left:a,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$aO(null,0,-1))})}this.w(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}R(u,f){this.slider.setHeight(u),this.slider.setTop(f)}Q(u,f){this.domNode.setWidth(f),this.domNode.setHeight(u),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(u){return this.s=this.J(u.scrollHeight)||this.s,this.s=this.L(u.scrollTop)||this.s,this.s=this.y(u.height)||this.s,this.s}S(u,f){return f}U(u){return u.pageY}W(u){return u.pageX}X(u){this.slider.setWidth(u)}writeScrollPosition(u,f){u.scrollTop=f}updateOptions(u){this.updateScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(u.vertical),this.c=u.scrollByPage}}t.$HP=w}),define(be[58],pe([1,0,16,4,39,19,121,122,20,9,3,2,5,47,96]),function(le,t,y,O,i,_,D,w,l,u,f,P,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=void 0;const e=500,a=50,o=!0;class s{constructor(T,m,v){this.timestamp=T,this.deltaX=m,this.deltaY=v,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let T=1,m=0,v=1,z=this.d;do{const U=z===this.c?T:Math.pow(2,-v);if(T-=U,m+=this.b[z].score*U,z===this.c)break;z=(this.a+z-1)%this.a,v++}while(!0);return m<=.5}acceptStandardWheelEvent(T){const m=window.devicePixelRatio/(0,y.$TN)();r.$i||r.$k?this.accept(Date.now(),T.deltaX/m,T.deltaY/m):this.accept(Date.now(),T.deltaX,T.deltaY)}accept(T,m,v){const z=new s(T,m,v);z.score=this.f(z),this.c===-1&&this.d===-1?(this.b[0]=z,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=z)}f(T){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let m=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(T.deltaX)||!this.g(T.deltaY))&&(m+=.25),Math.min(Math.max(m,0),1)}g(T){return Math.abs(Math.round(T)-T)<.01}}t.$IP=n;class g extends l.$AP{get options(){return this.a}constructor(T,m,v){super(),this.O=this.B(new f.$ed),this.onScroll=this.O.event,this.P=this.B(new f.$ed),this.onWillScroll=this.P.event,T.style.overflow="hidden",this.a=F(m),this.b=v,this.B(this.b.onScroll(U=>{this.P.fire(U),this.S(U),this.O.fire(U)}));const z={onMouseWheel:U=>this.R(U),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new w.$HP(this.b,this.a,z)),this.g=this.B(new D.$GP(this.b,this.a,z)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(T),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$yP)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$yP)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$yP)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,U=>this.Z(U)),this.u(this.t,U=>this.Y(U)),this.L=this.B(new u.$Pg),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,P.$ec)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this.c.delegatePointerDown(T)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(T){this.b.setScrollDimensions(T,!1)}updateClassName(T){this.a.className=T,r.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this.a.handleMouseWheel=T.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this.a.horizontal=T.horizontal),typeof T.vertical<"u"&&(this.a.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this.a.scrollByPage=T.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(T){this.N=T}delegateScrollFromMouseWheelEvent(T){this.R(new _.$aO(T))}Q(T){if(this.w.length>0!==T&&(this.w=(0,P.$ec)(this.w),T)){const v=z=>{this.R(new _.$aO(z))};this.w.push(O.$gO(this.t,O.$UO.MOUSE_WHEEL,v,{passive:!1}))}}R(T){if(T.browserEvent?.defaultPrevented)return;const m=n.INSTANCE;o&&m.acceptStandardWheelEvent(T);let v=!1;if(T.deltaY||T.deltaX){let U=T.deltaY*this.a.mouseWheelScrollSensitivity,M=T.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&M+U===0?M=U=0:Math.abs(U)>=Math.abs(M)?M=0:U=0),this.a.flipAxes&&([U,M]=[M,U]);const A=!r.$j&&T.browserEvent&&T.browserEvent.shiftKey;(this.a.scrollYToX||A)&&!M&&(M=U,U=0),T.browserEvent&&T.browserEvent.altKey&&(M=M*this.a.fastScrollSensitivity,U=U*this.a.fastScrollSensitivity);const H=this.b.getFutureScrollPosition();let Q={};if(U){const ie=a*U,re=H.scrollTop-(ie<0?Math.floor(ie):Math.ceil(ie));this.c.writeScrollPosition(Q,re)}if(M){const ie=a*M,re=H.scrollLeft-(ie<0?Math.floor(ie):Math.ceil(ie));this.g.writeScrollPosition(Q,re)}Q=this.b.validateScrollPosition(Q),(H.scrollLeft!==Q.scrollLeft||H.scrollTop!==Q.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&m.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Q):this.b.setScrollPositionNow(Q),v=!0)}let z=v;!z&&this.a.alwaysConsumeMouseWheel&&(z=!0),!z&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(z=!0),z&&(T.preventDefault(),T.stopPropagation())}S(T){this.M=this.g.onDidScroll(T)||this.M,this.M=this.c.onDidScroll(T)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const T=this.b.getCurrentScrollPosition(),m=T.scrollTop>0,v=T.scrollLeft>0,z=v?" left":"",U=m?" top":"",M=v||m?" top-left-corner":"";this.n.setClassName(`shadow${z}`),this.r.setClassName(`shadow${U}`),this.s.setClassName(`shadow${M}${U}${z}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(T){this.J=!1,this.ab()}Z(T){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$JP=g;class b extends g{constructor(T,m){m=m||{},m.mouseWheelSmoothScroll=!1;const v=new h.$Lr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:z=>O.$oO(z)});super(T,m,v),this.B(v)}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$KP=b;class $ extends g{constructor(T,m,v){super(T,m,v)}setScrollPosition(T){T.reuseAnimation?this.b.setScrollPositionSmooth(T,T.reuseAnimation):this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$LP=$;class c extends g{constructor(T,m){m=m||{},m.mouseWheelSmoothScroll=!1;const v=new h.$Lr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:z=>O.$oO(z)});super(T,m,v),this.B(v),this.cb=T,this.B(this.onScroll(z=>{z.scrollTopChanged&&(this.cb.scrollTop=z.scrollTop),z.scrollLeftChanged&&(this.cb.scrollLeft=z.scrollLeft)})),this.scanDomNode()}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$MP=c;function F(R){const T={lazyRender:typeof R.lazyRender<"u"?R.lazyRender:!1,className:typeof R.className<"u"?R.className:"",useShadows:typeof R.useShadows<"u"?R.useShadows:!0,handleMouseWheel:typeof R.handleMouseWheel<"u"?R.handleMouseWheel:!0,flipAxes:typeof R.flipAxes<"u"?R.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof R.consumeMouseWheelIfScrollbarIsNeeded<"u"?R.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof R.alwaysConsumeMouseWheel<"u"?R.alwaysConsumeMouseWheel:!1,scrollYToX:typeof R.scrollYToX<"u"?R.scrollYToX:!1,mouseWheelScrollSensitivity:typeof R.mouseWheelScrollSensitivity<"u"?R.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof R.fastScrollSensitivity<"u"?R.fastScrollSensitivity:5,scrollPredominantAxis:typeof R.scrollPredominantAxis<"u"?R.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof R.mouseWheelSmoothScroll<"u"?R.mouseWheelSmoothScroll:!0,arrowSize:typeof R.arrowSize<"u"?R.arrowSize:11,listenOnDomNode:typeof R.listenOnDomNode<"u"?R.listenOnDomNode:null,horizontal:typeof R.horizontal<"u"?R.horizontal:1,horizontalScrollbarSize:typeof R.horizontalScrollbarSize<"u"?R.horizontalScrollbarSize:10,horizontalSliderSize:typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:0,horizontalHasArrows:typeof R.horizontalHasArrows<"u"?R.horizontalHasArrows:!1,vertical:typeof R.vertical<"u"?R.vertical:1,verticalScrollbarSize:typeof R.verticalScrollbarSize<"u"?R.verticalScrollbarSize:10,verticalHasArrows:typeof R.verticalHasArrows<"u"?R.verticalHasArrows:!1,verticalSliderSize:typeof R.verticalSliderSize<"u"?R.verticalSliderSize:0,scrollByPage:typeof R.scrollByPage<"u"?R.scrollByPage:!1};return T.horizontalSliderSize=typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof R.verticalSliderSize<"u"?R.verticalSliderSize:T.verticalScrollbarSize,r.$j&&(T.className+=" mac"),T}}),define(be[59],pe([1,0,52,4,21,23,58,11,9,25,3,2,46,47,80,117,6]),function(le,t,y,O,i,_,D,w,l,u,f,P,r,h,e,a,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eQ=t.$dQ=t.$cQ=t.$bQ=void 0;const s={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(T){return[T]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class g{get context(){return this.d}set context(m){this.d=m}constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.$bQ=g;class b{constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.$cQ=b;class ${constructor(){this.types=[],this.files=[]}update(m){if(m.types&&this.types.splice(0,this.types.length,...m.types),m.files){this.files.splice(0,this.files.length);for(let v=0;v<m.files.length;v++){const z=m.files.item(v);z&&(z.size||z.type)&&this.files.push(z)}}}getData(){return{types:this.types,files:this.files}}}t.$dQ=$;function c(T,m){return Array.isArray(T)&&Array.isArray(m)?(0,w.$sb)(T,m):T===m}class F{constructor(m){m?.getSetSize?this.getSetSize=m.getSetSize.bind(m):this.getSetSize=(v,z,U)=>U,m?.getPosInSet?this.getPosInSet=m.getPosInSet.bind(m):this.getPosInSet=(v,z)=>z+1,m?.getRole?this.getRole=m.getRole.bind(m):this.getRole=v=>"listitem",m?.isChecked?this.isChecked=m.isChecked.bind(m):this.isChecked=v=>{}}}class R{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(m){if(m!==this.O){if(m&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=m,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const v of this.d)this.Y(v);this.V(),this.q.setScrollDimensions({width:(0,O.$BO)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(m,v,z,U=n){if(this.Q=v,this.domId=`list_id_${++R.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new l.$Cg(50),this.v=!1,this.x=P.$jc.None,this.y=0,this.G=!1,this.J=P.$jc.None,this.K=P.$jc.None,this.L=new P.$ic,this.M=new f.$ed,this.N=new f.$ed,this.onDidChangeContentHeight=f.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=f.Event.latch(this.N.event,void 0,this.L),this.O=!1,U.horizontalScrolling&&U.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$_P(U.paddingTop??0);for(const A of z)this.j.set(A.templateId,A);this.h=this.L.add(new a.$aQ(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof U.mouseSupport=="boolean"?U.mouseSupport:!0),this.O=U.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof U.paddingBottom>"u"?0:U.paddingBottom,this.D=new F(U.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(U.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(_.$wP.addTarget(this.o)),this.p=this.L.add(new h.$Lr({forceIntegerValues:!0,smoothScrollDuration:U.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:A=>(0,O.$oO)(A)})),this.q=this.L.add(new D.$LP(this.o,{alwaysConsumeMouseWheel:U.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:U.verticalScrollMode??n.verticalScrollMode,useShadows:U.useShadows??n.useShadows,mouseWheelScrollSensitivity:U.mouseWheelScrollSensitivity,fastScrollSensitivity:U.fastScrollSensitivity,scrollByPage:U.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),m.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,O.$gO)(this.o,_.EventType.Change,A=>this.hb(A))),this.L.add((0,O.$gO)(this.q.getDomNode(),"scroll",A=>A.target.scrollTop=0)),this.L.add((0,O.$gO)(this.domNode,"dragover",A=>this.jb(this.fb(A)))),this.L.add((0,O.$gO)(this.domNode,"drop",A=>this.lb(this.fb(A)))),this.L.add((0,O.$gO)(this.domNode,"dragleave",A=>this.kb(this.fb(A)))),this.L.add((0,O.$gO)(this.domNode,"dragend",A=>this.mb(A))),this.z=U.setRowLineHeight??n.setRowLineHeight,this.A=U.setRowHeight??n.setRowHeight,this.B=U.supportDynamicHeights??n.supportDynamicHeights,this.F=U.dnd??n.dnd,this.layout(U.initialSize?.height,U.initialSize?.width)}updateOptions(m){m.paddingBottom!==void 0&&(this.C=m.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),m.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(m.smoothScrolling?125:0),m.horizontalScrolling!==void 0&&(this.P=m.horizontalScrolling);let v;if(m.scrollByPage!==void 0&&(v={...v??{},scrollByPage:m.scrollByPage}),m.mouseWheelScrollSensitivity!==void 0&&(v={...v??{},mouseWheelScrollSensitivity:m.mouseWheelScrollSensitivity}),m.fastScrollSensitivity!==void 0&&(v={...v??{},fastScrollSensitivity:m.fastScrollSensitivity}),v&&this.q.updateOptions(v),m.paddingTop!==void 0&&m.paddingTop!==this.g.paddingTop){const z=this.sb(this.k,this.m),U=m.paddingTop-this.g.paddingTop;this.g.paddingTop=m.paddingTop,this.W(z,Math.max(0,this.k+U),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(m){this.q.delegateScrollFromMouseWheelEvent(m)}delegateVerticalScrollbarPointerDown(m){this.q.delegateVerticalScrollbarPointerDown(m)}updateElementHeight(m,v,z){if(m<0||m>=this.d.length)return;const U=this.d[m].size;if(typeof v>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[m].lastDynamicHeightWidth=void 0,v=U+this.ub(m)}if(U===v)return;const M=this.sb(this.k,this.m);let A=0;m<M.start||z!==null&&z>m&&z<=M.end?A=v-U:A=0,this.g.splice(m,1,[{size:v}]),this.d[m].size=v,this.W(M,Math.max(0,this.k+A),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(m,v,z=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(m,v,z)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(m,v,z=[]){const U=this.sb(this.k,this.m),M={start:m,end:m+v},A=r.Range.intersect(U,M),H=new Map;for(let ee=A.end-1;ee>=A.start;ee--){const Z=this.d[ee];if(Z.dragStartDisposable.dispose(),Z.checkedDisposable.dispose(),Z.row){let C=H.get(Z.templateId);C||(C=[],H.set(Z.templateId,C));const x=this.j.get(Z.templateId);x&&x.disposeElement&&x.disposeElement(Z.element,ee,Z.row.templateData,Z.size),C.push(Z.row)}Z.row=null}const Q={start:m+v,end:this.d.length},ie=r.Range.intersect(Q,U),re=r.Range.relativeComplement(Q,U),ue=z.map(ee=>({id:String(this.f++),element:ee,templateId:this.Q.getTemplateId(ee),size:this.Q.getHeight(ee),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(ee),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.$jc.None,checkedDisposable:P.$jc.None}));let he;m===0&&v>=this.d.length?(this.g=new e.$_P(this.g.paddingTop),this.g.splice(0,0,ue),he=this.d,this.d=ue):(this.g.splice(m,v,ue),he=this.d.splice(m,v,...ue));const oe=z.length-v,ge=this.sb(this.k,this.m),Ce=(0,e.$0P)(ie,oe),Se=r.Range.intersect(ge,Ce);for(let ee=Se.start;ee<Se.end;ee++)this.Z(this.d[ee],ee);const Re=r.Range.relativeComplement(Ce,ge);for(const ee of Re)for(let Z=ee.start;Z<ee.end;Z++)this.ab(Z);const fe=re.map(ee=>(0,e.$0P)(ee,oe)),G=[{start:m,end:m+z.length},...fe].map(ee=>r.Range.intersect(ge,ee)),V=this.vb(G);for(const ee of G)for(let Z=ee.start;Z<ee.end;Z++){const C=this.d[Z],d=H.get(C.templateId)?.pop();this.X(Z,V,d)}for(const ee of H.values())for(const Z of ee)this.h.release(Z);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),he.map(ee=>ee.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,O.$oO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let m=0;for(const v of this.d)typeof v.width<"u"&&(m=Math.max(m,v.width));this.E=m,this.q.setScrollDimensions({scrollWidth:m===0?0:m+10}),this.N.fire(this.E)}updateWidth(m){if(!this.P||typeof this.E>"u")return;const v=this.d[m];this.Y(v),typeof v.width<"u"&&v.width>this.E&&(this.E=v.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const m of this.d)m.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const m=this.sb(this.k,this.m),v=this.g.positionAt(m.start),z=this.g.positionAt(m.start+1);return z!==-1&&(z-v)/2+v<this.scrollTop?m.start+1:m.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(m){return this.d[m].element}indexOf(m){return this.d.findIndex(v=>v.element===m)}domElement(m){const v=this.d[m].row;return v&&v.domNode}elementHeight(m){return this.d[m].size}elementTop(m){return this.g.positionAt(m)}indexAt(m){return this.g.indexAt(m)}indexAfter(m){return this.g.indexAfter(m)}layout(m,v){const z={height:typeof m=="number"?m:(0,O.$DO)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,z.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(z),typeof v<"u"&&(this.n=v,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof v=="number"?v:(0,O.$BO)(this.domNode)})}W(m,v,z,U,M,A=!1){const H=this.sb(v,z),Q=r.Range.relativeComplement(H,m),ie=r.Range.relativeComplement(m,H),re=this.vb(Q);if(A){const ue=r.Range.intersect(m,H);for(let he=ue.start;he<ue.end;he++)this.Z(this.d[he],he)}this.h.transact(()=>{for(const ue of ie)for(let he=ue.start;he<ue.end;he++)this.ab(he);for(const ue of Q)for(let he=ue.start;he<ue.end;he++)this.X(he,re)}),U!==void 0&&(this.o.style.left=`-${U}px`),this.o.style.top=`-${v}px`,this.P&&M!==void 0&&(this.o.style.width=`${Math.max(M,this.n)}px`),this.k=v,this.m=z}X(m,v,z){const U=this.d[m];let M=!1;if(!U.row)if(z)U.row=z;else{const re=this.h.alloc(U.templateId);U.row=re.row,M=re.isReusingConnectedDomNode}const A=this.D.getRole(U.element)||"listitem";U.row.domNode.setAttribute("role",A);const H=this.D.isChecked(U.element);if(typeof H=="boolean")U.row.domNode.setAttribute("aria-checked",String(!!H));else if(H){const re=ue=>U.row.domNode.setAttribute("aria-checked",String(!!ue));re(H.value),U.checkedDisposable=H.onDidChange(re)}(M||!U.row.domNode.parentElement)&&(v?this.o.insertBefore(U.row.domNode,v):this.o.appendChild(U.row.domNode)),this.Z(U,m);const Q=this.j.get(U.templateId);if(!Q)throw new Error(`No renderer found for template id ${U.templateId}`);Q?.renderElement(U.element,m,U.row.templateData,U.size);const ie=this.F.getDragURI(U.element);U.dragStartDisposable.dispose(),U.row.domNode.draggable=!!ie,ie&&(U.dragStartDisposable=(0,O.$gO)(U.row.domNode,"dragstart",re=>this.ib(U.element,ie,re))),this.P&&(this.Y(U),this.U())}Y(m){if(!m.row||!m.row.domNode)return;m.row.domNode.style.width="fit-content",m.width=(0,O.$BO)(m.row.domNode);const v=window.getComputedStyle(m.row.domNode);v.paddingLeft&&(m.width+=parseFloat(v.paddingLeft)),v.paddingRight&&(m.width+=parseFloat(v.paddingRight)),m.row.domNode.style.width=""}Z(m,v){m.row.domNode.style.top=`${this.elementTop(v)}px`,this.A&&(m.row.domNode.style.height=`${m.size}px`),this.z&&(m.row.domNode.style.lineHeight=`${m.size}px`),m.row.domNode.setAttribute("data-index",`${v}`),m.row.domNode.setAttribute("data-last-element",v===this.length-1?"true":"false"),m.row.domNode.setAttribute("data-parity",v%2===0?"even":"odd"),m.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(m.element,v,this.length))),m.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(m.element,v))),m.row.domNode.setAttribute("id",this.getElementDomId(v)),m.row.domNode.classList.toggle("drop-target",m.dropTarget)}ab(m){const v=this.d[m];if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const z=this.j.get(v.templateId);z&&z.disposeElement&&z.disposeElement(v.element,m,v.row.templateData,v.size),this.h.release(v.row),v.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(m,v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:m,reuseAnimation:v})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(m){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:m})}get scrollTop(){return this.getScrollTop()}set scrollTop(m){this.setScrollTop(m)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return f.Event.map(this.L.add(new i.$1P(this.domNode,"click")).event,m=>this.bb(m),this.L)}get onMouseDblClick(){return f.Event.map(this.L.add(new i.$1P(this.domNode,"dblclick")).event,m=>this.bb(m),this.L)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.L.add(new i.$1P(this.domNode,"auxclick")).event,m=>this.bb(m),this.L),m=>m.browserEvent.button===1,this.L)}get onMouseUp(){return f.Event.map(this.L.add(new i.$1P(this.domNode,"mouseup")).event,m=>this.bb(m),this.L)}get onMouseDown(){return f.Event.map(this.L.add(new i.$1P(this.domNode,"mousedown")).event,m=>this.bb(m),this.L)}get onMouseOver(){return f.Event.map(this.L.add(new i.$1P(this.domNode,"mouseover")).event,m=>this.bb(m),this.L)}get onMouseMove(){return f.Event.map(this.L.add(new i.$1P(this.domNode,"mousemove")).event,m=>this.bb(m),this.L)}get onMouseOut(){return f.Event.map(this.L.add(new i.$1P(this.domNode,"mouseout")).event,m=>this.bb(m),this.L)}get onContextMenu(){return f.Event.any(f.Event.map(this.L.add(new i.$1P(this.domNode,"contextmenu")).event,m=>this.bb(m),this.L),f.Event.map(this.L.add(new i.$1P(this.domNode,_.EventType.Contextmenu)).event,m=>this.eb(m),this.L))}get onTouchStart(){return f.Event.map(this.L.add(new i.$1P(this.domNode,"touchstart")).event,m=>this.db(m),this.L)}get onTap(){return f.Event.map(this.L.add(new i.$1P(this.o,_.EventType.Tap)).event,m=>this.eb(m),this.L)}bb(m){const v=this.rb(m.target||null),z=typeof v>"u"?void 0:this.d[v],U=z&&z.element;return{browserEvent:m,index:v,element:U}}db(m){const v=this.rb(m.target||null),z=typeof v>"u"?void 0:this.d[v],U=z&&z.element;return{browserEvent:m,index:v,element:U}}eb(m){const v=this.rb(m.initialTarget||null),z=typeof v>"u"?void 0:this.d[v],U=z&&z.element;return{browserEvent:m,index:v,element:U}}fb(m){const v=this.rb(m.target||null),z=typeof v>"u"?void 0:this.d[v],U=z&&z.element;return{browserEvent:m,index:v,element:U}}gb(m){try{const v=this.sb(this.k,this.m);this.W(v,m.scrollTop,m.height,m.scrollLeft,m.scrollWidth),this.B&&this.tb(m.scrollTop,m.height,m.inSmoothScrolling)}catch(v){throw console.error("Got bad scroll event:",m),v}}hb(m){m.preventDefault(),m.stopPropagation(),this.scrollTop-=m.translationY}ib(m,v,z){if(!z.dataTransfer)return;const U=this.F.getDragElements(m);if(z.dataTransfer.effectAllowed="copyMove",z.dataTransfer.setData(y.$uP.TEXT,v),z.dataTransfer.setDragImage){let M;this.F.getDragLabel&&(M=this.F.getDragLabel(U,z)),typeof M>"u"&&(M=String(U.length));const A=(0,O.$)(".monaco-drag-image");A.textContent=M;const Q=(ie=>{for(;ie&&!ie.classList.contains("monaco-workbench");)ie=ie.parentElement;return ie||document.body})(this.domNode);Q.appendChild(A),z.dataTransfer.setDragImage(A,-10,-10),setTimeout(()=>Q.removeChild(A),0)}this.domNode.classList.add("dragging"),this.H=new g(U),s.CurrentDragAndDropData=new b(U),this.F.onDragStart?.(this.H,z)}jb(m){if(m.browserEvent.preventDefault(),this.K.dispose(),s.CurrentDragAndDropData&&s.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(m.browserEvent),!m.browserEvent.dataTransfer))return!1;if(!this.H)if(s.CurrentDragAndDropData)this.H=s.CurrentDragAndDropData;else{if(!m.browserEvent.dataTransfer.types)return!1;this.H=new $}const v=this.F.onDragOver(this.H,m.element,m.index,m.browserEvent);if(this.G=typeof v=="boolean"?v:v.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;m.browserEvent.dataTransfer.dropEffect=typeof v!="boolean"&&v.effect===0?"copy":"move";let z;if(typeof v!="boolean"&&v.feedback?z=v.feedback:typeof m.index>"u"?z=[-1]:z=[m.index],z=(0,w.$Jb)(z).filter(U=>U>=-1&&U<this.length).sort((U,M)=>U-M),z=z[0]===-1?[-1]:z,c(this.I,z))return!0;if(this.I=z,this.J.dispose(),z[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,P.$hc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const U of z){const M=this.d[U];M.dropTarget=!0,M.row?.domNode.classList.add("drop-target")}this.J=(0,P.$hc)(()=>{for(const U of z){const M=this.d[U];M.dropTarget=!1,M.row?.domNode.classList.remove("drop-target")}})}return!0}kb(m){this.K.dispose(),this.K=(0,l.$Hg)(()=>this.nb(),100),this.H&&this.F.onDragLeave?.(this.H,m.element,m.index,m.browserEvent)}lb(m){if(!this.G)return;const v=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,s.CurrentDragAndDropData=void 0,!(!v||!m.browserEvent.dataTransfer)&&(m.browserEvent.preventDefault(),v.update(m.browserEvent.dataTransfer),this.F.drop(v,m.element,m.index,m.browserEvent))}mb(m){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,s.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(m)}nb(){this.I=void 0,this.J.dispose(),this.J=P.$jc.None}ob(m){if(!this.w){const v=(0,O.$vO)(this.domNode).top;this.w=(0,O.$eP)(this.pb.bind(this,v))}this.x.dispose(),this.x=(0,l.$Hg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=m.pageY}pb(m){if(this.y===void 0)return;const v=this.y-m,z=this.renderHeight-35;v<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(v-35))):v>z&&(this.scrollTop+=Math.min(14,Math.floor(.3*(v-z))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(m){const v=this.q.getDomNode();let z=m;for(;z instanceof HTMLElement&&z!==this.o&&v.contains(z);){const U=z.getAttribute("data-index");if(U){const M=Number(U);if(!isNaN(M))return M}z=z.parentElement}}sb(m,v){return{start:this.g.indexAt(m),end:this.g.indexAfter(m+v-1)}}tb(m,v,z){const U=this.sb(m,v);let M,A;m===this.elementTop(U.start)?(M=U.start,A=0):U.end-U.start>1&&(M=U.start+1,A=this.elementTop(M)-m);let H=0;for(;;){const Q=this.sb(m,v);let ie=!1;for(let re=Q.start;re<Q.end;re++){const ue=this.ub(re);ue!==0&&this.g.splice(re,1,[this.d[re]]),H+=ue,ie=ie||ue!==0}if(!ie){H!==0&&this.S();const re=r.Range.relativeComplement(U,Q);for(const he of re)for(let oe=he.start;oe<he.end;oe++)this.d[oe].row&&this.ab(oe);const ue=r.Range.relativeComplement(Q,U);for(const he of ue)for(let oe=he.start;oe<he.end;oe++){const ge=oe+1,Ce=ge<this.d.length?this.d[ge].row:null,Se=Ce?Ce.domNode:null;this.X(oe,Se)}for(let he=Q.start;he<Q.end;he++)this.d[he].row&&this.Z(this.d[he],he);if(typeof M=="number"){const he=this.p.getFutureScrollPosition().scrollTop-m,oe=this.elementTop(M)-A+he;this.setScrollTop(oe,z)}this.M.fire(this.contentHeight);return}}}ub(m){const v=this.d[m];if(this.Q.getDynamicHeight){const A=this.Q.getDynamicHeight(v.element);if(A!==null){const H=v.size;return v.size=A,v.lastDynamicHeightWidth=this.n,A-H}}if(!v.hasDynamicHeight||v.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(v.element))return 0;const z=v.size;if(v.row)return v.row.domNode.style.height="",v.size=v.row.domNode.offsetHeight,v.lastDynamicHeightWidth=this.n,v.size-z;const{row:U}=this.h.alloc(v.templateId);U.domNode.style.height="",this.o.appendChild(U.domNode);const M=this.j.get(v.templateId);if(!M)throw new o.$ab("Missing renderer for templateId: "+v.templateId);return M.renderElement(v.element,m,U.templateData,void 0),v.size=U.domNode.offsetHeight,M.disposeElement?.(v.element,m,U.templateData,void 0),this.Q.setDynamicHeight?.(v.element,v.size),v.lastDynamicHeightWidth=this.n,this.o.removeChild(U.domNode),this.h.release(U),v.size-z}vb(m){const v=m[m.length-1];if(!v)return null;const z=this.d[v.end];return!z||!z.row?null:z.row.domNode}getElementDomId(m){return`${this.domId}_${m}`}dispose(){for(const m of this.d)if(m.dragStartDisposable.dispose(),m.checkedDisposable.dispose(),m.row){const v=this.j.get(m.row.templateId);v&&(v.disposeElement?.(m.element,-1,m.row.templateData,void 0),v.disposeTemplate(m.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,P.$ec)(this.L)}}t.$eQ=R,Ke([u.$5g],R.prototype,"onMouseClick",null),Ke([u.$5g],R.prototype,"onMouseDblClick",null),Ke([u.$5g],R.prototype,"onMouseMiddleClick",null),Ke([u.$5g],R.prototype,"onMouseUp",null),Ke([u.$5g],R.prototype,"onMouseDown",null),Ke([u.$5g],R.prototype,"onMouseOver",null),Ke([u.$5g],R.prototype,"onMouseMove",null),Ke([u.$5g],R.prototype,"onMouseOut",null),Ke([u.$5g],R.prototype,"onContextMenu",null),Ke([u.$5g],R.prototype,"onTouchStart",null),Ke([u.$5g],R.prototype,"onTap",null)}),define(be[37],pe([1,0,4,21,14,23,55,69,11,9,71,25,3,32,2,45,5,7,68,59,19,95]),function(le,t,y,O,i,_,D,w,l,u,f,P,r,h,e,a,o,s,n,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.TypeNavigationMode=t.$hQ=t.$gQ=t.$fQ=void 0;class ${constructor(C){this.d=C,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(C){return C}renderElement(C,x,d){const p=this.c.findIndex(E=>E.templateData===d);if(p>=0){const E=this.c[p];this.d.unrender(d),E.index=x}else{const E={index:x,templateData:d};this.c.push(E)}this.d.renderIndex(x,d)}splice(C,x,d){const p=[];for(const E of this.c)E.index<C?p.push(E):E.index>=C+x&&p.push({index:E.index+d-x,templateData:E.templateData});this.c=p}renderIndexes(C){for(const{index:x,templateData:d}of this.c)C.indexOf(x)>-1&&this.d.renderIndex(x,d)}disposeTemplate(C){const x=this.c.findIndex(d=>d.templateData===C);x<0||this.c.splice(x,1)}}class c{get name(){return this.h}get renderer(){return new $(this)}constructor(C){this.h=C,this.c=0,this.d=[],this.f=[],this.g=new r.$ed,this.onChange=this.g.event}splice(C,x,d){x=Math.max(0,Math.min(x,this.c-C));const p=d.length-x,E=C+x,I=[];let N=0;for(;N<this.f.length&&this.f[N]<C;)I.push(this.f[N++]);for(let q=0;q<d.length;q++)d[q]&&I.push(q+C);for(;N<this.f.length&&this.f[N]>=E;)I.push(this.f[N++]+p);const B=this.c+p;if(this.f.length>0&&I.length===0&&B>0){const q=this.f.find(L=>L>=C)??B-1;I.push(Math.min(q,B-1))}this.renderer.splice(C,x,d.length),this.k(I,I),this.c=B}renderIndex(C,x){x.classList.toggle(this.h,this.contains(C))}unrender(C){C.classList.remove(this.h)}set(C,x){return this.k(C,[...C].sort(fe),x)}k(C,x,d){const p=this.d,E=this.f;this.d=C,this.f=x;const I=Se(E,C);return this.renderer.renderIndexes(I),this.g.fire({indexes:C,browserEvent:d}),p}get(){return this.d}contains(C){return(0,l.$ub)(this.f,C,fe)>=0}dispose(){(0,e.$ec)(this.g)}}Ke([P.$5g],c.prototype,"renderer",null);class F extends c{constructor(C){super("selected"),this.l=C}renderIndex(C,x){super.renderIndex(C,x),this.l&&(this.contains(C)?x.setAttribute("aria-selected","true"):x.setAttribute("aria-selected","false"))}}class R{constructor(C,x,d){this.c=C,this.d=x,this.f=d}splice(C,x,d){if(!this.f)return this.c.splice(C,x,new Array(d.length).fill(!1));const p=this.c.get().map(N=>this.f.getId(this.d.element(N)).toString());if(p.length===0)return this.c.splice(C,x,new Array(d.length).fill(!1));const E=new Set(p),I=d.map(N=>E.has(this.f.getId(N).toString()));this.c.splice(C,x,I)}}function T(Z){return Z.tagName==="INPUT"||Z.tagName==="TEXTAREA"}t.$fQ=T;function m(Z){return Z.classList.contains("monaco-editor")?!0:Z.classList.contains("monaco-list")||!Z.parentElement?!1:m(Z.parentElement)}t.$gQ=m;function v(Z){return Z.tagName==="A"&&Z.classList.contains("monaco-button")||Z.tagName==="DIV"&&Z.classList.contains("monaco-button-dropdown")?!0:Z.classList.contains("monaco-list")||!Z.parentElement?!1:v(Z.parentElement)}t.$hQ=v;class z{get g(){return r.Event.chain(this.c.add(new O.$1P(this.k.domNode,"keydown")).event,C=>C.filter(x=>!T(x.target)).map(x=>new i.$dO(x)))}constructor(C,x,d){this.h=C,this.k=x,this.c=new e.$ic,this.d=new e.$ic,this.f=d.multipleSelectionSupport,this.c.add(this.g(p=>{switch(p.keyCode){case 3:return this.l(p);case 16:return this.o(p);case 18:return this.p(p);case 11:return this.q(p);case 12:return this.s(p);case 9:return this.u(p);case 31:this.f&&(o.$j?p.metaKey:p.ctrlKey)&&this.t(p)}}))}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.f=C.multipleSelectionSupport)}l(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection(this.h.getFocus(),C.browserEvent)}o(C){C.preventDefault(),C.stopPropagation(),this.h.focusPrevious(1,!1,C.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}p(C){C.preventDefault(),C.stopPropagation(),this.h.focusNext(1,!1,C.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}q(C){C.preventDefault(),C.stopPropagation(),this.h.focusPreviousPage(C.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}s(C){C.preventDefault(),C.stopPropagation(),this.h.focusNextPage(C.browserEvent);const x=this.h.getFocus()[0];this.h.setAnchor(x),this.h.reveal(x),this.k.domNode.focus()}t(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection((0,l.$Pb)(this.h.length),C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(C){this.h.getSelection().length&&(C.preventDefault(),C.stopPropagation(),this.h.setSelection([],C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ke([P.$5g],z.prototype,"g",null);var U;(function(Z){Z[Z.Automatic=0]="Automatic",Z[Z.Trigger=1]="Trigger"})(U||(t.TypeNavigationMode=U={}));var M;(function(Z){Z[Z.Idle=0]="Idle",Z[Z.Typing=1]="Typing"})(M||(M={})),t.$iQ=new class{mightProducePrintableCharacter(Z){return Z.ctrlKey||Z.metaKey||Z.altKey?!1:Z.keyCode>=31&&Z.keyCode<=56||Z.keyCode>=21&&Z.keyCode<=30||Z.keyCode>=98&&Z.keyCode<=107||Z.keyCode>=85&&Z.keyCode<=95}};class A{constructor(C,x,d,p,E){this.o=C,this.p=x,this.q=d,this.s=p,this.t=E,this.c=!1,this.d=M.Idle,this.f=U.Automatic,this.g=!1,this.h=-1,this.k=new e.$ic,this.l=new e.$ic,this.updateOptions(C.options)}updateOptions(C){C.typeNavigationEnabled??!0?this.u():this.v(),this.f=C.typeNavigationMode??U.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let C=!1;const x=r.Event.chain(this.k.add(new O.$1P(this.p.domNode,"keydown")).event,E=>E.filter(I=>!T(I.target)).filter(()=>this.f===U.Automatic||this.g).map(I=>new i.$dO(I)).filter(I=>C||this.s(I)).filter(I=>this.t.mightProducePrintableCharacter(I)).forEach(I=>y.$WO.stop(I,!0)).map(I=>I.browserEvent.key)),d=r.Event.debounce(x,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(x,d),(E,I)=>I===null?null:(E||"")+I,void 0,this.k)(this.x,this,this.k),d(this.w,this,this.k),x(()=>C=!0,void 0,this.k),d(()=>C=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const C=this.o.getFocus();if(C.length>0&&C[0]===this.h){const x=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(C[0]));x&&(0,D.$3P)(x)}this.h=-1}x(C){if(!C){this.d=M.Idle,this.g=!1;return}const x=this.o.getFocus(),d=x.length>0?x[0]:0,p=this.d===M.Idle?1:0;this.d=M.Typing;for(let E=0;E<this.o.length;E++){const I=(d+E+p)%this.o.length,N=this.q.getKeyboardNavigationLabel(this.p.element(I)),B=N&&N.toString();if(this.o.options.typeNavigationEnabled){if(typeof B<"u"){if((0,h.$xj)(C,B)){this.h=d,this.o.setFocus([I]),this.o.reveal(I);return}const q=(0,h.$Ej)(C,B);if(q&&q[0].end-q[0].start>1&&q.length===1){this.h=d,this.o.setFocus([I]),this.o.reveal(I);return}}}else if(typeof B>"u"||(0,h.$xj)(C,B)){this.h=d,this.o.setFocus([I]),this.o.reveal(I);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class H{constructor(C,x){this.d=C,this.f=x,this.c=new e.$ic;const d=r.Event.chain(this.c.add(new O.$1P(x.domNode,"keydown")).event,E=>E.filter(I=>!T(I.target)).map(I=>new i.$dO(I)));r.Event.chain(d,E=>E.filter(I=>I.keyCode===2&&!I.ctrlKey&&!I.metaKey&&!I.shiftKey&&!I.altKey))(this.g,this,this.c)}g(C){if(C.target!==this.f.domNode)return;const x=this.d.getFocus();if(x.length===0)return;const d=this.f.domElement(x[0]);if(!d)return;const p=d.querySelector("[tabIndex]");if(!p||!(p instanceof HTMLElement)||p.tabIndex===-1)return;const E=window.getComputedStyle(p);E.visibility==="hidden"||E.display==="none"||(C.preventDefault(),C.stopPropagation(),p.focus())}dispose(){this.c.dispose()}}function Q(Z){return o.$j?Z.browserEvent.metaKey:Z.browserEvent.ctrlKey}t.$jQ=Q;function ie(Z){return Z.browserEvent.shiftKey}t.$kQ=ie;function re(Z){return Z instanceof MouseEvent&&Z.button===2}const ue={isSelectionSingleChangeEvent:Q,isSelectionRangeChangeEvent:ie};class he{constructor(C){this.k=C,this.f=new e.$ic,this.g=new r.$ed,this.onPointer=this.g.event,C.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ue),this.d=typeof C.options.mouseSupport>"u"||!!C.options.mouseSupport,this.d&&(C.onMouseDown(this.s,this,this.f),C.onContextMenu(this.t,this,this.f),C.onMouseDblClick(this.v,this,this.f),C.onTouchStart(this.s,this,this.f),this.f.add(_.$wP.addTarget(C.getHTMLElement()))),r.Event.any(C.onMouseClick,C.onMouseMiddleClick,C.onTap)(this.u,this,this.f)}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.c=void 0,C.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ue))}o(C){return this.c?this.c.isSelectionSingleChangeEvent(C):!1}p(C){return this.c?this.c.isSelectionRangeChangeEvent(C):!1}q(C){return this.o(C)||this.p(C)}s(C){m(C.browserEvent.target)||document.activeElement!==C.browserEvent.target&&this.k.domFocus()}t(C){if(T(C.browserEvent.target)||m(C.browserEvent.target))return;const x=typeof C.index>"u"?[]:[C.index];this.k.setFocus(x,C.browserEvent)}u(C){if(!this.d||T(C.browserEvent.target)||m(C.browserEvent.target)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const x=C.index;if(typeof x>"u"){this.k.setFocus([],C.browserEvent),this.k.setSelection([],C.browserEvent),this.k.setAnchor(void 0);return}if(this.q(C))return this.w(C);this.k.setFocus([x],C.browserEvent),this.k.setAnchor(x),re(C.browserEvent)||this.k.setSelection([x],C.browserEvent),this.g.fire(C)}v(C){if(T(C.browserEvent.target)||m(C.browserEvent.target)||this.q(C)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const x=this.k.getFocus();this.k.setSelection(x,C.browserEvent)}w(C){const x=C.index;let d=this.k.getAnchor();if(this.p(C)){typeof d>"u"&&(d=this.k.getFocus()[0]??x,this.k.setAnchor(d));const p=Math.min(d,x),E=Math.max(d,x),I=(0,l.$Pb)(p,E+1),N=this.k.getSelection(),B=Ce(Se(N,[d]),d);if(B.length===0)return;const q=Se(I,Re(N,B));this.k.setSelection(q,C.browserEvent),this.k.setFocus([x],C.browserEvent)}else if(this.o(C)){const p=this.k.getSelection(),E=p.filter(I=>I!==x);this.k.setFocus([x]),this.k.setAnchor(x),p.length===E.length?this.k.setSelection([...E,x],C.browserEvent):this.k.setSelection(E,C.browserEvent)}}dispose(){this.f.dispose()}}t.$lQ=he;class oe{constructor(C,x){this.c=C,this.d=x}style(C){const x=this.d&&`.${this.d}`,d=[];C.listBackground&&d.push(`.monaco-list${x} .monaco-list-rows { background: ${C.listBackground}; }`),C.listFocusBackground&&(d.push(`.monaco-list${x}:focus .monaco-list-row.focused { background-color: ${C.listFocusBackground}; }`),d.push(`.monaco-list${x}:focus .monaco-list-row.focused:hover { background-color: ${C.listFocusBackground}; }`)),C.listFocusForeground&&d.push(`.monaco-list${x}:focus .monaco-list-row.focused { color: ${C.listFocusForeground}; }`),C.listActiveSelectionBackground&&(d.push(`.monaco-list${x}:focus .monaco-list-row.selected { background-color: ${C.listActiveSelectionBackground}; }`),d.push(`.monaco-list${x}:focus .monaco-list-row.selected:hover { background-color: ${C.listActiveSelectionBackground}; }`)),C.listActiveSelectionForeground&&d.push(`.monaco-list${x}:focus .monaco-list-row.selected { color: ${C.listActiveSelectionForeground}; }`),C.listActiveSelectionIconForeground&&d.push(`.monaco-list${x}:focus .monaco-list-row.selected .codicon { color: ${C.listActiveSelectionIconForeground}; }`),C.listFocusAndSelectionBackground&&d.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { background-color: ${C.listFocusAndSelectionBackground}; }
			`),C.listFocusAndSelectionForeground&&d.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { color: ${C.listFocusAndSelectionForeground}; }
			`),C.listInactiveFocusForeground&&(d.push(`.monaco-list${x} .monaco-list-row.focused { color:  ${C.listInactiveFocusForeground}; }`),d.push(`.monaco-list${x} .monaco-list-row.focused:hover { color:  ${C.listInactiveFocusForeground}; }`)),C.listInactiveSelectionIconForeground&&d.push(`.monaco-list${x} .monaco-list-row.focused .codicon { color:  ${C.listInactiveSelectionIconForeground}; }`),C.listInactiveFocusBackground&&(d.push(`.monaco-list${x} .monaco-list-row.focused { background-color:  ${C.listInactiveFocusBackground}; }`),d.push(`.monaco-list${x} .monaco-list-row.focused:hover { background-color:  ${C.listInactiveFocusBackground}; }`)),C.listInactiveSelectionBackground&&(d.push(`.monaco-list${x} .monaco-list-row.selected { background-color:  ${C.listInactiveSelectionBackground}; }`),d.push(`.monaco-list${x} .monaco-list-row.selected:hover { background-color:  ${C.listInactiveSelectionBackground}; }`)),C.listInactiveSelectionForeground&&d.push(`.monaco-list${x} .monaco-list-row.selected { color: ${C.listInactiveSelectionForeground}; }`),C.listHoverBackground&&d.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${C.listHoverBackground}; }`),C.listHoverForeground&&d.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${C.listHoverForeground}; }`);const p=(0,y.$hP)(C.listFocusAndSelectionOutline,(0,y.$hP)(C.listSelectionOutline,C.listFocusOutline??""));p&&d.push(`.monaco-list${x}:focus .monaco-list-row.focused.selected { outline: 1px solid ${p}; outline-offset: -1px;}`),C.listFocusOutline&&d.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${x}.last-focused .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
			`);const E=(0,y.$hP)(C.listSelectionOutline,C.listInactiveFocusOutline??"");E&&d.push(`.monaco-list${x} .monaco-list-row.focused.selected { outline: 1px dotted ${E}; outline-offset: -1px; }`),C.listSelectionOutline&&d.push(`.monaco-list${x} .monaco-list-row.selected { outline: 1px dotted ${C.listSelectionOutline}; outline-offset: -1px; }`),C.listInactiveFocusOutline&&d.push(`.monaco-list${x} .monaco-list-row.focused { outline: 1px dotted ${C.listInactiveFocusOutline}; outline-offset: -1px; }`),C.listHoverOutline&&d.push(`.monaco-list${x} .monaco-list-row:hover { outline: 1px dashed ${C.listHoverOutline}; outline-offset: -1px; }`),C.listDropBackground&&d.push(`
				.monaco-list${x}.drop-target,
				.monaco-list${x} .monaco-list-rows.drop-target,
				.monaco-list${x} .monaco-list-row.drop-target { background-color: ${C.listDropBackground} !important; color: inherit !important; }
			`),C.tableColumnsBorder&&d.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${C.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),C.tableOddRowsBackgroundColor&&d.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${C.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=d.join(`
`)}}t.$mQ=oe,t.$nQ={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:f.$Ms.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:f.$Ms.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:f.$Ms.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ge={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function Ce(Z,C){const x=Z.indexOf(C);if(x===-1)return[];const d=[];let p=x-1;for(;p>=0&&Z[p]===C-(x-p);)d.push(Z[p--]);for(d.reverse(),p=x;p<Z.length&&Z[p]===C+(p-x);)d.push(Z[p++]);return d}function Se(Z,C){const x=[];let d=0,p=0;for(;d<Z.length||p<C.length;)if(d>=Z.length)x.push(C[p++]);else if(p>=C.length)x.push(Z[d++]);else if(Z[d]===C[p]){x.push(Z[d]),d++,p++;continue}else Z[d]<C[p]?x.push(Z[d++]):x.push(C[p++]);return x}function Re(Z,C){const x=[];let d=0,p=0;for(;d<Z.length||p<C.length;)if(d>=Z.length)x.push(C[p++]);else if(p>=C.length)x.push(Z[d++]);else if(Z[d]===C[p]){d++,p++;continue}else Z[d]<C[p]?x.push(Z[d++]):p++;return x}const fe=(Z,C)=>Z-C;class ne{constructor(C,x){this.c=C,this.d=x}get templateId(){return this.c}renderTemplate(C){return this.d.map(x=>x.renderTemplate(C))}renderElement(C,x,d,p){let E=0;for(const I of this.d)I.renderElement(C,x,d[E++],p)}disposeElement(C,x,d,p){let E=0;for(const I of this.d)I.disposeElement?.(C,x,d[E],p),E+=1}disposeTemplate(C){let x=0;for(const d of this.d)d.disposeTemplate(C[x++])}}class G{constructor(C){this.c=C,this.templateId="a18n"}renderTemplate(C){return C}renderElement(C,x,d){const p=this.c.getAriaLabel(C);p?d.setAttribute("aria-label",p):d.removeAttribute("aria-label");const E=this.c.getAriaLevel&&this.c.getAriaLevel(C);typeof E=="number"?d.setAttribute("aria-level",`${E}`):d.removeAttribute("aria-level")}disposeTemplate(C){}}class V{constructor(C,x){this.c=C,this.d=x}getDragElements(C){const x=this.c.getSelectedElements();return x.indexOf(C)>-1?x:[C]}getDragURI(C){return this.d.getDragURI(C)}getDragLabel(C,x){if(this.d.getDragLabel)return this.d.getDragLabel(C,x)}onDragStart(C,x){this.d.onDragStart?.(C,x)}onDragOver(C,x,d,p){return this.d.onDragOver(C,x,d,p)}onDragLeave(C,x,d,p){this.d.onDragLeave?.(C,x,d,p)}onDragEnd(C){this.d.onDragEnd?.(C)}drop(C,x,d,p){this.d.drop(C,x,d,p)}}class ee{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),C=>this.G(C),this.y)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),C=>this.G(C),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let C=!1;const x=r.Event.chain(this.y.add(new O.$1P(this.k.domNode,"keydown")).event,E=>E.map(I=>new i.$dO(I)).filter(I=>C=I.keyCode===58||I.shiftKey&&I.keyCode===68).map(I=>y.$WO.stop(I,!0)).filter(()=>!1)),d=r.Event.chain(this.y.add(new O.$1P(this.k.domNode,"keyup")).event,E=>E.forEach(()=>C=!1).map(I=>new i.$dO(I)).filter(I=>I.keyCode===58||I.shiftKey&&I.keyCode===68).map(I=>y.$WO.stop(I,!0)).map(({browserEvent:I})=>{const N=this.getFocus(),B=N.length?N[0]:void 0,q=typeof B<"u"?this.k.element(B):void 0,L=typeof B<"u"?this.k.domElement(B):this.k.domNode;return{index:B,element:q,anchor:L,browserEvent:I}})),p=r.Event.chain(this.k.onContextMenu,E=>E.filter(I=>!C).map(({element:I,index:N,browserEvent:B})=>({element:I,index:N,anchor:new b.$$N(B),browserEvent:B})));return r.Event.any(x,d,p)}get onKeyDown(){return this.y.add(new O.$1P(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new O.$1P(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new O.$1P(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.y.add(new O.$1P(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.y.add(new O.$1P(this.k.domNode,"blur",!0)).event)}constructor(C,x,d,p,E=ge){this.A=C,this.B=E,this.c=new c("focused"),this.f=new c("anchor"),this.g=new r.$md,this.x="",this.y=new e.$ic,this.z=new r.$ed,this.onDidDispose=this.z.event;const I=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(I!=="listbox");const N=[this.c.renderer,this.d.renderer];this.u=E.accessibilityProvider,this.u&&(N.push(new G(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),p=p.map(q=>new ne(q.templateId,[...N,q]));const B={...E,dnd:E.dnd&&new V(this,E.dnd)};if(this.k=this.C(x,d,p,B),this.k.domNode.setAttribute("role",I),E.styleController)this.q=E.styleController(this.k.domId);else{const q=(0,y.$PO)(this.k.domNode);this.q=new oe(q,this.k.domId)}if(this.o=new w.$5P([new R(this.c,this.k,E.identityProvider),new R(this.d,this.k,E.identityProvider),new R(this.f,this.k,E.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new H(this,this.k)),(typeof E.keyboardSupport!="boolean"||E.keyboardSupport)&&(this.v=new z(this,this.k,E),this.y.add(this.v)),E.keyboardNavigationLabelProvider){const q=E.keyboardNavigationDelegate||t.$iQ;this.t=new A(this,this.k,E.keyboardNavigationLabelProvider,E.keyboardNavigationEventFilter??(()=>!0),q),this.y.add(this.t)}this.w=this.D(E),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(C,x,d,p){return new g.$eQ(C,x,d,p)}D(C){return new he(this)}updateOptions(C={}){this.B={...this.B,...C},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(C),this.v?.updateOptions(C),this.k.updateOptions(C)}get options(){return this.B}splice(C,x,d=[]){if(C<0||C>this.k.length)throw new n.$7P(this.A,`Invalid start index: ${C}`);if(x<0)throw new n.$7P(this.A,`Invalid delete count: ${x}`);x===0&&d.length===0||this.g.bufferEvents(()=>this.o.splice(C,x,d))}updateWidth(C){this.k.updateWidth(C)}updateElementHeight(C,x){this.k.updateElementHeight(C,x,null)}rerender(){this.k.rerender()}element(C){return this.k.element(C)}indexOf(C){return this.k.indexOf(C)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(C){this.k.setScrollTop(C)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(C){this.k.setScrollLeft(C)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(C){this.x=C,this.k.domNode.setAttribute("aria-label",C)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(C,x){this.k.layout(C,x)}triggerTypeNavigation(){this.t?.trigger()}setSelection(C,x){for(const d of C)if(d<0||d>=this.length)throw new n.$7P(this.A,`Invalid index ${d}`);this.d.set(C,x)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(C=>this.k.element(C))}setAnchor(C){if(typeof C>"u"){this.f.set([]);return}if(C<0||C>=this.length)throw new n.$7P(this.A,`Invalid index ${C}`);this.f.set([C])}getAnchor(){return(0,l.$Lb)(this.f.get(),void 0)}getAnchorElement(){const C=this.getAnchor();return typeof C>"u"?void 0:this.element(C)}setFocus(C,x){for(const d of C)if(d<0||d>=this.length)throw new n.$7P(this.A,`Invalid index ${d}`);this.c.set(C,x)}focusNext(C=1,x=!1,d,p){if(this.length===0)return;const E=this.c.get(),I=this.E(E.length>0?E[0]+C:0,x,p);I>-1&&this.setFocus([I],d)}focusPrevious(C=1,x=!1,d,p){if(this.length===0)return;const E=this.c.get(),I=this.F(E.length>0?E[0]-C:0,x,p);I>-1&&this.setFocus([I],d)}async focusNextPage(C,x){let d=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);d=d===0?0:d-1;const p=this.getFocus()[0];if(p!==d&&(p===void 0||d>p)){const E=this.F(d,!1,x);E>-1&&p!==E?this.setFocus([E],C):this.setFocus([d],C)}else{const E=this.k.getScrollTop();let I=E+this.k.renderHeight;d>p&&(I-=this.k.elementHeight(d)),this.k.setScrollTop(I),this.k.getScrollTop()!==E&&(this.setFocus([]),await(0,u.$Gg)(0),await this.focusNextPage(C,x))}}async focusPreviousPage(C,x){let d;const p=this.k.getScrollTop();p===0?d=this.k.indexAt(p):d=this.k.indexAfter(p-1);const E=this.getFocus()[0];if(E!==d&&(E===void 0||E>=d)){const I=this.E(d,!1,x);I>-1&&E!==I?this.setFocus([I],C):this.setFocus([d],C)}else{const I=p;this.k.setScrollTop(p-this.k.renderHeight),this.k.getScrollTop()!==I&&(this.setFocus([]),await(0,u.$Gg)(0),await this.focusPreviousPage(C,x))}}focusLast(C,x){if(this.length===0)return;const d=this.F(this.length-1,!1,x);d>-1&&this.setFocus([d],C)}focusFirst(C,x){this.focusNth(0,C,x)}focusNth(C,x,d){if(this.length===0)return;const p=this.E(C,!1,d);p>-1&&this.setFocus([p],x)}E(C,x=!1,d){for(let p=0;p<this.length;p++){if(C>=this.length&&!x)return-1;if(C=C%this.length,!d||d(this.element(C)))return C;C++}return-1}F(C,x=!1,d){for(let p=0;p<this.length;p++){if(C<0&&!x)return-1;if(C=(this.length+C%this.length)%this.length,!d||d(this.element(C)))return C;C--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(C=>this.k.element(C))}reveal(C,x){if(C<0||C>=this.length)throw new n.$7P(this.A,`Invalid index ${C}`);const d=this.k.getScrollTop(),p=this.k.elementTop(C),E=this.k.elementHeight(C);if((0,s.$mf)(x)){const I=E-this.k.renderHeight;this.k.setScrollTop(I*(0,a.$Gl)(x,0,1)+p)}else{const I=p+E,N=d+this.k.renderHeight;p<d&&I>=N||(p<d||I>=N&&E>=this.k.renderHeight?this.k.setScrollTop(p):I>=N&&this.k.setScrollTop(I-this.k.renderHeight))}}getRelativeTop(C){if(C<0||C>=this.length)throw new n.$7P(this.A,`Invalid index ${C}`);const x=this.k.getScrollTop(),d=this.k.elementTop(C),p=this.k.elementHeight(C);if(d<x||d+p>x+this.k.renderHeight)return null;const E=p-this.k.renderHeight;return Math.abs((x-d)/E)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(C){return this.k.getElementDomId(C)}style(C){this.q.style(C)}G({indexes:C,browserEvent:x}){return{indexes:C,elements:C.map(d=>this.k.element(d)),browserEvent:x}}H(){const C=this.c.get();this.k.domNode.classList.toggle("element-focused",C.length>0),this.I()}I(){const C=this.c.get();if(C.length>0){let x;this.u?.getActiveDescendantId&&(x=this.u.getActiveDescendantId(this.k.element(C[0]))),this.k.domNode.setAttribute("aria-activedescendant",x||this.k.getElementDomId(C[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const C=this.d.get();this.k.domNode.classList.toggle("selection-none",C.length===0),this.k.domNode.classList.toggle("selection-single",C.length===1),this.k.domNode.classList.toggle("selection-multiple",C.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$oQ=ee,Ke([P.$5g],ee.prototype,"onDidChangeFocus",null),Ke([P.$5g],ee.prototype,"onDidChangeSelection",null),Ke([P.$5g],ee.prototype,"onContextMenu",null),Ke([P.$5g],ee.prototype,"onKeyDown",null),Ke([P.$5g],ee.prototype,"onKeyUp",null),Ke([P.$5g],ee.prototype,"onKeyPress",null),Ke([P.$5g],ee.prototype,"onDidFocus",null),Ke([P.$5g],ee.prototype,"onDidBlur",null)}),define(be[60],pe([1,0,6,33,35,12,15]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(w||(t.MarkdownStringTextNewlineStyle=w={}));class l{constructor(s="",n=!1){if(this.value=s,typeof this.value!="string")throw(0,y.$5)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(s,n=0){return this.value+=r(this.supportThemeIcons?(0,O.$Qj)(s):s).replace(/([ \t]+)/g,(g,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,n){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(s,n,g){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(s),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(s,n){const g=new RegExp((0,_.$pe)(n),"g");return s.replace(g,(b,$)=>s.charAt($-1)!=="\\"?`\\${b}`:b)}}t.$Wj=l;function u(o){return f(o)?!o.value:Array.isArray(o)?o.every(u):!0}t.$Xj=u;function f(o){return o instanceof l?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}t.$Yj=f;function P(o,s){return o===s?!0:!o||!s?!1:o.value===s.value&&o.isTrusted===s.isTrusted&&o.supportThemeIcons===s.supportThemeIcons&&o.supportHtml===s.supportHtml&&(o.baseUri===s.baseUri||!!o.baseUri&&!!s.baseUri&&(0,i.$ag)(D.URI.from(o.baseUri),D.URI.from(s.baseUri)))}t.$Zj=P;function r(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$1j=r;function h(o){return o.replace(/"/g,"&quot;")}t.$2j=h;function e(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$3j=e;function a(o){const s=[],n=o.split("|").map(b=>b.trim());o=n[0];const g=n[1];if(g){const b=/height=(\d+)/.exec(g),$=/width=(\d+)/.exec(g),c=b?b[1]:"",F=$?$[1]:"",R=isFinite(parseInt(F)),T=isFinite(parseInt(c));R&&s.push(`width="${F}"`),T&&s.push(`height="${c}"`)}return{href:o,dimensions:s}}t.$4j=a}),define(be[123],pe([1,0,4,115,21,53,14,19,116,6,3,60,33,74,30,2,77,51,28,49,35,12,15]),function(le,t,y,O,i,_,D,w,l,u,f,P,r,h,e,a,o,s,n,g,b,$,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=t.$uQ=t.$tQ=t.$sQ=t.$rQ=void 0;const F=Object.freeze({image:(V,ee,Z)=>{let C=[],x=[];return V&&({href:V,dimensions:C}=(0,P.$4j)(V),x.push(`src="${(0,P.$2j)(V)}"`)),Z&&x.push(`alt="${(0,P.$2j)(Z)}"`),ee&&x.push(`title="${(0,P.$2j)(ee)}"`),C.length&&(x=x.concat(C)),"<img "+x.join(" ")+">"},paragraph:V=>`<p>${V}</p>`,link:(V,ee,Z)=>typeof V!="string"?"":(V===Z&&(Z=(0,P.$3j)(Z)),ee=typeof ee=="string"?(0,P.$2j)((0,P.$3j)(ee)):"",V=(0,P.$3j)(V),V=V.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${V}" title="${ee||V}">${Z}</a>`)});function R(V,ee={},Z={}){const C=new a.$ic;let x=!1;const d=(0,_.$ZP)(ee),p=function(k){let W;try{W=(0,s.$9g)(decodeURIComponent(k))}catch{}return W?(W=(0,g.$Wm)(W,K=>{if(V.uris&&V.uris[K])return c.URI.revive(V.uris[K])}),encodeURIComponent(JSON.stringify(W))):k},E=function(k,W){const K=V.uris&&V.uris[k];let te=c.URI.revive(K);return W?k.startsWith(n.Schemas.data+":")?k:(te||(te=c.URI.parse(k)),n.$1f.uriToBrowserUri(te).toString(!0)):!te||c.URI.parse(k).toString()===te.toString()?k:(te.query&&(te=te.with({query:p(te.query)})),te.toString())},I=new o.marked.Renderer;I.image=F.image,I.link=F.link,I.paragraph=F.paragraph;const N=[],B=[];if(ee.codeBlockRendererSync?I.code=(k,W)=>{const K=h.$2L.nextId(),te=ee.codeBlockRendererSync(T(W),k);return B.push([K,te]),`<div class="code" data-code="${K}">${(0,$.$oe)(k)}</div>`}:ee.codeBlockRenderer&&(I.code=(k,W)=>{const K=h.$2L.nextId(),te=ee.codeBlockRenderer(T(W),k);return N.push(te.then(se=>[K,se])),`<div class="code" data-code="${K}">${(0,$.$oe)(k)}</div>`}),ee.actionHandler){const k=function(te){let se=te.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let me=se.dataset.href;me&&(V.baseUri&&(me=m(c.URI.from(V.baseUri),me)),ee.actionHandler.callback(me,te))}catch(me){(0,u.$Y)(me)}finally{te.preventDefault()}},W=ee.actionHandler.disposables.add(new i.$1P(d,"click")),K=ee.actionHandler.disposables.add(new i.$1P(d,"auxclick"));ee.actionHandler.disposables.add(f.Event.any(W.event,K.event)(te=>{const se=new w.$$N(te);!se.leftButton&&!se.middleButton||k(se)})),ee.actionHandler.disposables.add(y.$gO(d,"keydown",te=>{const se=new D.$dO(te);!se.equals(10)&&!se.equals(3)||k(se)}))}V.supportHtml||(Z.sanitizer=k=>(V.isTrusted?k.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?k:"",Z.sanitize=!0,Z.silent=!0),Z.renderer=I;let q=V.value??"";q.length>1e5&&(q=`${q.substr(0,1e5)}\u2026`),V.supportThemeIcons&&(q=(0,r.$Rj)(q));let L;if(ee.fillInIncompleteTokens){const k={...o.marked.defaults,...Z},W=o.marked.lexer(q,k),K=re(W);L=o.marked.parser(K,k)}else L=o.marked.parse(q,Z);V.supportThemeIcons&&(L=(0,l.$pQ)(L).map(W=>typeof W=="string"?W:W.outerHTML).join(""));const S=new DOMParser().parseFromString(v(V,L),"text/html");if(S.body.querySelectorAll("img").forEach(k=>{const W=k.getAttribute("src");if(W){let K=W;try{V.baseUri&&(K=m(c.URI.from(V.baseUri),K))}catch{}k.src=E(K,!0)}}),S.body.querySelectorAll("a").forEach(k=>{const W=k.getAttribute("href");if(k.setAttribute("href",""),!W||/^data:|javascript:/i.test(W)||/^command:/i.test(W)&&!V.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(W))k.replaceWith(...k.childNodes);else{let K=E(W,!1);V.baseUri&&(K=m(c.URI.from(V.baseUri),W)),k.dataset.href=K}}),d.innerHTML=v(V,S.body.innerHTML),N.length>0)Promise.all(N).then(k=>{if(x)return;const W=new Map(k),K=d.querySelectorAll("div[data-code]");for(const te of K){const se=W.get(te.dataset.code??"");se&&y.$4O(te,se)}ee.asyncRenderCallback?.()});else if(B.length>0){const k=new Map(B),W=d.querySelectorAll("div[data-code]");for(const K of W){const te=k.get(K.dataset.code??"");te&&y.$4O(K,te)}}if(ee.asyncRenderCallback)for(const k of d.getElementsByTagName("img")){const W=C.add(y.$gO(k,"load",()=>{W.dispose(),ee.asyncRenderCallback()}))}return{element:d,dispose:()=>{x=!0,C.dispose()}}}t.$rQ=R;function T(V){if(!V)return"";const ee=V.split(/[\s+|:|,|\{|\?]/,1);return ee.length?ee[0]:V}function m(V,ee){return/^\w[\w\d+.-]*:/.test(ee)?ee:V.path.endsWith("/")?(0,b.$kg)(V,ee).toString():(0,b.$kg)((0,b.$gg)(V),ee).toString()}function v(V,ee){const{config:Z,allowedSchemes:C}=z(V);O.addHook("uponSanitizeAttribute",(d,p)=>{if(p.attrName==="style"||p.attrName==="class"){if(d.tagName==="SPAN"){if(p.attrName==="style"){p.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(p.attrValue);return}else if(p.attrName==="class"){p.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(p.attrValue);return}}p.keepAttr=!1;return}});const x=y.$lP(C);try{return O.sanitize(ee,{...Z,RETURN_TRUSTED_TYPE:!0})}finally{O.removeHook("uponSanitizeAttribute"),x.dispose()}}t.$sQ=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function z(V){const ee=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return V.isTrusted&&ee.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...y.$mP],ALLOWED_ATTR:t.$sQ,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ee}}function U(V){return typeof V=="string"?V:M(V)}t.$tQ=U;function M(V){let ee=V.value??"";ee.length>1e5&&(ee=`${ee.substr(0,1e5)}\u2026`);const Z=o.marked.parse(ee,{renderer:H.value}).replace(/&(#\d+|[a-zA-Z]+);/g,C=>A.get(C)??C);return v({isTrusted:!1},Z).toString()}t.$uQ=M;const A=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),H=new e.$T(()=>{const V=new o.marked.Renderer;return V.code=ee=>ee,V.blockquote=ee=>ee,V.html=ee=>"",V.heading=(ee,Z,C)=>ee+`
`,V.hr=()=>"",V.list=(ee,Z)=>ee,V.listitem=ee=>ee+`
`,V.paragraph=ee=>ee+`
`,V.table=(ee,Z)=>ee+Z+`
`,V.tablerow=ee=>ee,V.tablecell=(ee,Z)=>ee+" ",V.strong=ee=>ee,V.em=ee=>ee,V.codespan=ee=>ee,V.br=()=>`
`,V.del=ee=>ee,V.image=(ee,Z,C)=>"",V.text=ee=>ee,V.link=(ee,Z,C)=>C,V});function Q(V){let ee="";return V.forEach(Z=>{ee+=Z.raw}),ee}function ie(V){for(const ee of V.tokens)if(ee.type==="text"){const Z=ee.raw.split(`
`),C=Z[Z.length-1];if(C.includes("`"))return he(V);if(C.includes("**"))return Re(V);if(C.match(/\*\w/))return oe(V);if(C.match(/(^|\s)__\w/))return fe(V);if(C.match(/(^|\s)_\w/))return ge(V);if(C.match(/(^|\s)\[.*\]\(\w*/))return Ce(V);if(C.match(/(^|\s)\[\w/))return Se(V)}}function re(V){let ee,Z;for(ee=0;ee<V.length;ee++){const C=V[ee];if(C.type==="paragraph"&&C.raw.match(/(\n|^)```/)){Z=ue(V.slice(ee));break}if(C.type==="paragraph"&&C.raw.match(/(\n|^)\|/)){Z=G(V.slice(ee));break}if(ee===V.length-1&&C.type==="paragraph"){const x=ie(C);if(x){Z=[x];break}}}if(Z){const C=[...V.slice(0,ee),...Z];return C.links=V.links,C}return V}t.$vQ=re;function ue(V){const ee=Q(V);return o.marked.lexer(ee+"\n```")}function he(V){return ne(V,"`")}function oe(V){return ne(V,"*")}function ge(V){return ne(V,"_")}function Ce(V){return ne(V,")")}function Se(V){return ne(V,"](about:blank)")}function Re(V){return ne(V,"**")}function fe(V){return ne(V,"__")}function ne(V,ee){const Z=Q(Array.isArray(V)?V:[V]);return o.marked.lexer(Z+ee)[0]}function G(V){const ee=Q(V),Z=ee.split(`
`);let C,x=!1;for(let d=0;d<Z.length;d++){const p=Z[d].trim();if(typeof C>"u"&&p.match(/^\s*\|/)){const E=p.match(/(\|[^\|]+)(?=\||$)/g);E&&(C=E.length)}else if(typeof C=="number")if(p.match(/^\s*\|/)){if(d!==Z.length-1)return;x=!0}else return}if(typeof C=="number"&&C>0){const d=x?Z.slice(0,-1).join(`
`):ee,p=!!d.match(/\|\s*$/),E=d+(p?"":"|")+`
|${" --- |".repeat(C)}`;return o.marked.lexer(E)}}}),define(be[124],pe([1,0,4,9,27,60,33,2,7,105]),function(le,t,y,O,i,_,D,w,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RP=t.$QP=void 0;function f(h,e){(0,l.$if)(e)?h.title=(0,D.$Sj)(e):e?.markdownNotSupportedFallback?h.title=e.markdownNotSupportedFallback:h.removeAttribute("title")}t.$QP=f;class P{constructor(e,a,o){this.c=e,this.d=a,this.f=o}async update(e,a,o){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let s;if(e===void 0||(0,l.$if)(e)||e instanceof HTMLElement)s=e;else if(!(0,l.$wf)(e.markdown))s=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,u.localize)(0,null),a),this.b=new i.$od;const n=this.b.token;if(s=await e.markdown(n),s===void 0&&(s=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(s,a,o)}g(e,a,o){const s=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!s,...o};this.a=this.c.showHover(n,a)}s?.dispose()}h(e){return e?(0,_.$Yj)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(h,e,a,o){let s,n;const g=(R,T)=>{const m=n!==void 0;R&&(n?.dispose(),n=void 0),T&&(s?.dispose(),s=void 0),m&&h.onDidHideHover?.()},b=(R,T,m)=>new O.$Pg(async()=>{(!n||n.isDisposed)&&(n=new P(h,m||e,R>0),await n.update(a,T,o))},R),$=()=>{if(s)return;const R=new w.$ic,T=z=>g(!1,z.fromElement===e);R.add(y.$gO(e,y.$UO.MOUSE_LEAVE,T,!0));const m=()=>g(!0,!0);R.add(y.$gO(e,y.$UO.MOUSE_DOWN,m,!0));const v={targetElements:[e],dispose:()=>{}};if(h.placement===void 0||h.placement==="mouse"){const z=U=>{v.x=U.x+10,U.target instanceof HTMLElement&&U.target.classList.contains("action-label")&&g(!0,!0)};R.add(y.$gO(e,y.$UO.MOUSE_MOVE,z,!0))}R.add(b(h.delay,!1,v)),s=R},c=y.$gO(e,y.$UO.MOUSE_OVER,$,!0);return{show:R=>{g(!1,!0),b(0,R)},hide:()=>{g(!0,!0)},update:async(R,T)=>{a=R,await n?.update(a,void 0,T)},dispose:()=>{c.dispose(),g(!0,!0)}}}t.$RP=r}),define(be[125],pe([1,0,4,21,14,123,37,11,3,43,2,5,107,98]),function(le,t,y,O,i,_,D,w,l,u,f,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wQ=void 0;const h=y.$,e="selectOption.entry.template";class a{get templateId(){return e}renderTemplate(n){const g=Object.create(null);return g.root=n,g.text=y.$2O(n,h(".option-text")),g.detail=y.$2O(n,h(".option-detail")),g.decoratorRight=y.$2O(n,h(".option-decorator-right")),g}renderElement(n,g,b){const $=b,c=n.text,F=n.detail,R=n.decoratorRight,T=n.isDisabled;$.text.textContent=c,$.detail.textContent=F||"",$.decoratorRight.innerText=R||"",T?$.root.classList.add("option-disabled"):$.root.classList.remove("option-disabled")}disposeTemplate(n){}}class o extends f.$jc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,g,b,$,c){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=$,this.g=c||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=o.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new l.$ed,this.B(this.r),this.O(),this.N(b),this.n=g||0,n&&this.setOptions(n,g),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=y.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=y.$2O(this.w,h(".select-box-details-pane"));const g=y.$2O(this.w,h(".select-box-dropdown-container-width-control")),b=y.$2O(g,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",y.$2O(b,this.D),this.G=0,this.y=y.$PO(this.w),this.w.setAttribute("draggable","true"),this.B(y.$gO(this.w,y.$UO.DRAG_START,$=>{y.$WO.stop($,!0)}))}O(){this.B(y.$hO(this.h,"change",g=>{this.n=g.target.selectedIndex,this.r.fire({index:g.target.selectedIndex,selected:g.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(y.$gO(this.h,y.$UO.CLICK,g=>{y.$WO.stop(g),this.f?this.X(!0):this.W()})),this.B(y.$gO(this.h,y.$UO.MOUSE_DOWN,g=>{y.$WO.stop(g)}));let n;this.B(y.$gO(this.h,"touchstart",g=>{n=this.f})),this.B(y.$gO(this.h,"touchend",g=>{y.$WO.stop(g),n?this.X(!0):this.W()})),this.B(y.$gO(this.h,y.$UO.KEY_DOWN,g=>{const b=new i.$dO(g);let $=!1;P.$j?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&($=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&($=!0),$&&(this.W(),y.$WO.stop(g,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,g){w.$sb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,$)=>{this.h.add(this.U(b.text,$,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),g!==void 0&&(this.select(g),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",g=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=g,this.h.style.borderColor=b}S(){const n=this.s.selectBackground??"",g=y.$hP(this.s.selectListBackground,n);this.C.style.backgroundColor=g,this.I.style.backgroundColor=g;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,g,b){const $=document.createElement("option");return $.value=n,$.text=n,$.disabled=!!b,$}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,g){return n.appendChild(this.w),this.ab(g),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((g,b)=>{this.hb(b),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const g=y.$yO(this.h),b=getComputedStyle(this.h),$=parseFloat(b.getPropertyValue("--dropdown-padding-top"))+parseFloat(b.getPropertyValue("--dropdown-padding-bottom")),c=window.innerHeight-g.top-g.height-(this.g.minBottomMargin||0),F=g.top-o.b,R=this.h.offsetWidth,T=this.bb(this.D),m=Math.max(T,Math.round(R)).toString()+"px";this.w.style.width=m,this.z.getHTMLElement().style.height="",this.z.layout();let v=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const z=this.H?this.L:0,U=v+$+z,M=Math.floor((c-$-z)/this.getHeight()),A=Math.floor((F-$-z)/this.getHeight());if(n)return g.top+g.height>window.innerHeight-22||g.top<o.b||M<1&&A<1?!1:(M<o.c&&A>M&&this.m.length>M?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(g.top+g.height>window.innerHeight-22||g.top<o.b||this.G===0&&M<1||this.G===1&&A<1)return this.X(!0),!1;if(this.G===0){if(this.f&&M+A<1)return this.X(!0),!1;U>c&&(v=M*this.getHeight())}else U>F&&(v=A*this.getHeight());return this.z.layout(v),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=v+$+"px",this.w.style.height=""):this.w.style.height=v+$+"px",this.hb(this.n),this.w.style.width=m,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let g=0;if(n){let b=0,$=0;this.m.forEach((c,F)=>{const R=c.detail?c.detail.length:0,T=c.decoratorRight?c.decoratorRight.length:0,m=c.text.length+R+T;m>$&&(b=F,$=m)}),n.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),g=y.$AO(n)}return g}cb(n){if(this.z)return;this.C=y.$2O(n,h(".select-box-dropdown-list-container")),this.t=new a,this.z=new D.$oQ("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:$=>{let c=$.text;return $.detail&&(c+=`. ${$.detail}`),$.decoratorRight&&(c+=`. ${$.decoratorRight}`),$.description&&(c+=`. ${$.description}`),c},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>P.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const g=this.B(new O.$1P(this.C,"keydown")),b=l.Event.chain(g.event,$=>$.filter(()=>this.z.length>0).map(c=>new i.$dO(c)));this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===3))(this.jb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===2))(this.jb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===9))(this.ib,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===16))(this.lb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===18))(this.kb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===12))(this.nb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===11))(this.mb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===14))(this.ob,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===13))(this.pb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode>=21&&c.keyCode<=56||c.keyCode>=85&&c.keyCode<=113))(this.qb,this)),this.B(y.$gO(this.z.getHTMLElement(),y.$UO.POINTER_UP,$=>this.db($))),this.B(this.z.onMouseOver($=>typeof $.index<"u"&&this.z.setFocus([$.index]))),this.B(this.z.onDidChangeFocus($=>this.gb($))),this.B(y.$gO(this.w,y.$UO.FOCUS_OUT,$=>{!this.f||y.$GO($.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;y.$WO.stop(n);const g=n.target;if(!g||g.classList.contains("slider"))return;const b=g.closest(".monaco-list-row");if(!b)return;const $=Number(b.getAttribute("data-index")),c=b.classList.contains("option-disabled");$>=0&&$<this.m.length&&!c&&(this.n=$,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,g){const b=c=>{for(let F=0;F<c.childNodes.length;F++){const R=c.childNodes.item(F);(R.tagName&&R.tagName.toLowerCase())==="img"?c.removeChild(R):b(R)}},$=(0,_.$rQ)({value:n,supportThemeIcons:!0},{actionHandler:g});return $.element.classList.add("select-box-description-markdown"),b($.element),$.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const g=this.m[n],b=g?.description??"",$=g?.descriptionIsMarkdown??!1;if(b){if($){const c=g.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,c))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){y.$WO.stop(n),this.select(this.F),this.X(!0)}jb(n){y.$WO.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){y.$WO.stop(n,!0);const g=this.m[this.n+1].isDisabled;if(g&&this.m.length>this.n+2)this.n+=2;else{if(g)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(y.$WO.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){y.$WO.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){y.$WO.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){y.$WO.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){y.$WO.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const g=u.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let $=0;$<this.m.length-1;$++)if(b=($+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===g&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),y.$WO.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$wQ=o}),define(be[126],pe([1,0,37,125,119,20,5,97]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zQ=t.$yQ=void 0,t.$yQ={...y.$nQ,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class w extends _.$AP{constructor(u,f,P,r,h){super(),D.$j&&!h?.useCustomDrawn?this.a=new i.$xQ(u,f,r,h):this.a=new O.$wQ(u,f,P,r,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(u,f){this.a.setOptions(u,f)}select(u){this.a.select(u)}setAriaLabel(u){this.a.setAriaLabel(u)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(u){this.a.setFocusable(u)}render(u){this.a.render(u)}}t.$zQ=w}),define(be[61],pe([1,0,16,52,4,23,124,126,34,2,5,7,102,50]),function(le,t,y,O,i,_,D,w,l,u,f,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GQ=t.$FQ=t.$EQ=void 0;class h extends u.$jc{get action(){return this._action}constructor(s,n,g={}){super(),this.m=g,this._context=s||this,this._action=n,n instanceof l.$fi&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(s){s.enabled!==void 0&&this.u(),s.checked!==void 0&&this.G(),s.class!==void 0&&this.F(),s.label!==void 0&&(this.w(),this.C()),s.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new l.$gi)),this.j}set actionRunner(s){this.j=s}isEnabled(){return this._action.enabled}setActionContext(s){this._context=s}render(s){const n=this.element=s;this.B(_.$wP.addTarget(s));const g=this.m&&this.m.draggable;g&&(s.draggable=!0,y.$YN&&this.B((0,i.$gO)(s,i.$UO.DRAG_START,b=>b.dataTransfer?.setData(O.$uP.TEXT,this._action.label)))),this.B((0,i.$gO)(n,_.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$gO)(n,i.$UO.MOUSE_DOWN,b=>{g||i.$WO.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),f.$j&&this.B((0,i.$gO)(n,i.$UO.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$gO)(n,i.$UO.CLICK,b=>{i.$WO.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$gO)(n,i.$UO.DBLCLICK,b=>{i.$WO.stop(b,!0)})),[i.$UO.MOUSE_UP,i.$UO.MOUSE_OUT].forEach(b=>{this.B((0,i.$gO)(n,b,$=>{i.$WO.stop($),n.classList.remove("active")}))})}onClick(s,n=!1){i.$WO.stop(s,!0);const g=P.$rf(this._context)?this.m?.useEventAsContext?s:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,g)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(s){this.element&&(this.element.tabIndex=s?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const s=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(s):(this.f=(0,D.$RP)(this.m.hoverDelegate,this.element,s),this.q.add(this.f))):this.element.title=s}D(){if(this.element){const s=this.z()??"";this.element.setAttribute("aria-label",s)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$EQ=h;class e extends h{constructor(s,n,g){super(s,n,g),this.m=g,this.m.icon=g.icon!==void 0?g.icon:!1,this.m.label=g.label!==void 0?g.label:!0,this.J=""}render(s){super.render(s),this.element&&(this.H=(0,i.$2O)(this.element,(0,i.$)("a.action-label"))),this.H&&this.H.setAttribute("role",this.L()),this.m.label&&this.m.keybinding&&this.element&&((0,i.$2O)(this.element,(0,i.$)("span.keybinding")).textContent=this.m.keybinding),this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===l.$hi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(s){this.H&&(this.H.tabIndex=s?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let s=null;return this.action.tooltip?s=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(s=this.action.label,this.m.keybinding&&(s=r.localize(0,null,s,this.m.keybinding))),s??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const s=this.z()??"";this.H.setAttribute("aria-label",s)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$FQ=e;class a extends h{constructor(s,n,g,b,$,c,F){super(s,n),this.b=new w.$zQ(g,b,$,c,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(s,n){this.b.setOptions(s,n)}select(s){this.b.select(s)}g(){this.B(this.b.onDidSelect(s=>this.n(s.selected,s.index)))}n(s,n){this.actionRunner.run(this._action,this.r(s,n))}r(s,n){return s}setFocusable(s){this.b.setFocusable(s)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(s){this.b.render(s)}}t.$GQ=a}),define(be[62],pe([1,0,4,14,61,34,3,2,7,50]),function(le,t,y,O,i,_,D,w,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TP=t.$SP=t.ActionsOrientation=void 0;var u;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(u||(t.ActionsOrientation=u={}));class f extends w.$jc{constructor(h,e={}){super(),this.g=this.B(new w.$ic),this.r=this.B(new w.$rc),this.w=!1,this.y=!0,this.C=this.B(new D.$ed),this.onDidBlur=this.C.event,this.D=this.B(new D.$ed({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new D.$ed),this.onDidRun=this.G.event,this.H=this.B(new D.$ed),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new _.$gi,this.g.add(this.f)),this.g.add(this.f.onDidRun(s=>this.G.fire(s))),this.g.add(this.f.onWillRun(s=>this.H.fire(s))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let a,o;switch(this.m){case 0:a=[15],o=[17];break;case 1:a=[16],o=[18],this.domNode.className+=" vertical";break}this.B(y.$gO(this.domNode,y.$UO.KEY_DOWN,s=>{const n=new O.$dO(s);let g=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;a&&(n.equals(a[0])||n.equals(a[1]))?g=this.P():o&&(n.equals(o[0])||n.equals(o[1]))?g=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?g=this.M():n.equals(13)?g=this.N():n.equals(2)&&b instanceof i.$EQ&&b.trapsArrowNavigation?g=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:g=!1,g&&(n.preventDefault(),n.stopPropagation())})),this.B(y.$gO(this.domNode,y.$UO.KEY_UP,s=>{const n=new O.$dO(s);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(y.$ZO(this.domNode)),this.B(this.u.onDidBlur(()=>{(y.$OO()===this.domNode||!y.$GO(y.$OO(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),h.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(h){h?this.z.setAttribute("aria-label",h):this.z.removeAttribute("aria-label")}setFocusable(h){if(this.y=h,this.y){const e=this.viewItems.find(a=>a instanceof i.$EQ&&a.isEnabled());e instanceof i.$EQ&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$EQ&&e.setFocusable(!1)})}J(h){let e=!1;return this.n.keys.forEach(a=>{e=e||h.equals(a)}),e}L(){for(let h=0;h<this.z.children.length;h++){const e=this.z.children[h];if(y.$GO(y.$OO(),e)){this.t=h;break}}}get context(){return this.j}set context(h){this.j=h,this.viewItems.forEach(e=>e.setActionContext(h))}get actionRunner(){return this.f}set actionRunner(h){this.f=h,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=h)}getContainer(){return this.domNode}hasAction(h){return this.viewItems.findIndex(e=>e.action.id===h.id)!==-1}getAction(h){if(typeof h=="number")return this.viewItems[h]?.action;if(h instanceof HTMLElement){for(;h.parentElement!==this.z;){if(!h.parentElement)return;h=h.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===h)return this.viewItems[e].action}}push(h,e={}){const a=Array.isArray(h)?h:[h];let o=l.$mf(e.index)?e.index:null;a.forEach(s=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let g;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(g=this.b.actionViewItemProvider(s,b)),g||(g=new i.$FQ(this.context,s,b)),this.b.allowContextMenu||this.r.set(g,y.$gO(n,y.$UO.CONTEXT_MENU,$=>{y.$WO.stop($,!0)})),g.actionRunner=this.f,g.setActionContext(this.context),g.render(n),this.y&&g instanceof i.$EQ&&this.viewItems.length===0&&g.setFocusable(!0),o===null||o<0||o>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(g)):(this.z.insertBefore(n,this.z.children[o]),this.viewItems.splice(o,0,g),o++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientWidth}return 0}getHeight(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientHeight}return 0}pull(h){h>=0&&h<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[h]),this.r.deleteAndDispose(this.viewItems[h]),(0,w.$ec)(this.viewItems.splice(h,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,w.$ec)(this.viewItems),this.r.clearAndDisposeAll(),y.$eO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(h){let e=!1,a;if(h===void 0?e=!0:typeof h=="number"?a=h:typeof h=="boolean"&&(e=h),e&&typeof this.t>"u"){const o=this.viewItems.findIndex(s=>s.isEnabled());this.t=o===-1?void 0:o,this.Q(void 0,void 0,!0)}else a!==void 0&&(this.t=a),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(h){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let a;do{if(!h&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,a=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===_.$hi.ID));return this.Q(),!0}P(h){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let a;do{if(this.t=this.t-1,this.t<0){if(!h&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}a=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===_.$hi.ID));return this.Q(!0),!0}Q(h,e,a=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const o=this.t!==void 0&&this.viewItems[this.t];if(o){let s=!0;l.$wf(o.focus)||(s=!1),this.b.focusOnlyEnabledItems&&l.$wf(o.isEnabled)&&!o.isEnabled()&&(s=!1),o.action.id===_.$hi.ID&&(s=!1),s?(a||this.s!==this.t)&&(o.focus(h),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(h){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$EQ){const a=e._context===null||e._context===void 0?h:e._context;this.run(e._action,a)}}async run(h,e){await this.f.run(h,e)}dispose(){this.j=void 0,this.viewItems=(0,w.$ec)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$SP=f;function P(r){if(!r.length)return r;let h=-1;for(let a=0;a<r.length;a++)if(r[a].id!==_.$hi.ID){h=a;break}if(h===-1)return[];r=r.slice(h);for(let a=r.length-1;a>=0&&r[a].id===_.$hi.ID;a--)r.splice(a,1);let e=!1;for(let a=r.length-1;a>=0;a--){const o=r[a].id===_.$hi.ID;o&&!e?r.splice(a,1):o?o&&(e=!1):e=!0}return r}t.$TP=P}),define(be[63],pe([1,0,4,21,53,62,55,58,20,3,79,49,106,94]),function(le,t,y,O,i,_,D,w,l,u,f,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=t.$jR=t.MessageType=void 0;const h=y.$;var e;(function(s){s[s.INFO=1]="INFO",s[s.WARNING=2]="WARNING",s[s.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$jR={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class a extends l.$AP{constructor(n,g,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new u.$ed),this.onDidChange=this.O.event,this.P=this.B(new u.$ed),this.onDidHeightChange=this.P.event,this.a=g,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=y.$2O(n,h(".monaco-inputbox.idle"));const $=this.g.flexibleHeight?"textarea":"input",c=y.$2O(this.element,h(".ibwrapper"));if(this.b=y.$2O(c,h($+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=y.$2O(c,h("div.mirror")),this.y.innerText="\xA0",this.N=new w.$KP(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),y.$2O(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(T=>this.b.scrollTop=T.scrollTop));const F=this.B(new O.$1P(document,"selectionchange")),R=u.Event.filter(F.event,()=>document.getSelection()?.anchorNode===c);this.B(R(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new _.$SP(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:y.$EO(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return y.$AO(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let g=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,$=parseFloat(this.y.style.paddingRight||"")||0;g=b+$}this.b.style.width=n-g+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,g=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:g}),this.N.setScrollPosition({scrollTop:b})}showMessage(n,g){if(this.w==="open"&&(0,P.$Ym)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${y.$hP(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||g)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const g=this.g.inputBoxStyles;switch(n){case 1:return{border:g.inputValidationInfoBorder,background:g.inputValidationInfoBackground,foreground:g.inputValidationInfoForeground};case 2:return{border:g.inputValidationWarningBorder,background:g.inputValidationWarningBackground,foreground:g.inputValidationWarningForeground};default:return{border:g.inputValidationErrorBorder,background:g.inputValidationErrorBackground,foreground:g.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const g=()=>n.style.width=y.$AO(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:$=>{if(!this.h)return null;n=y.$2O($,h(".monaco-inputbox-container")),g();const c={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,i.$YP)(this.h.content,c):(0,i.$XP)(this.h.content,c);F.classList.add(this.U(this.h.type));const R=this.stylesForType(this.h.type);return F.style.backgroundColor=R.background??"",F.style.color=R.foreground??"",F.style.border=R.border?`1px solid ${R.border}`:"",y.$2O(n,F),null},onHide:()=>{this.w="closed"},layout:g});let b;this.h.type===3?b=r.localize(0,null,this.h.content):this.h.type===2?b=r.localize(1,null,this.h.content):b=r.localize(2,null,this.h.content),D.$3P(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.y.textContent=n+b:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,g=n.inputBackground??"",b=n.inputForeground??"",$=n.inputBorder??"";this.element.style.backgroundColor=g,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${y.$hP($,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=y.$EO(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const g=this.inputElement,b=g.selectionStart,$=g.selectionEnd,c=g.value;b!==null&&$!==null&&(this.value=c.substr(0,b)+n+c.substr($),g.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$kR=a;class o extends a{constructor(n,g,b){const $=r.localize(3,null),c=` or \u21C5 ${$}`,F=` (\u21C5 ${$})`;super(n,g,b),this.db=this.B(new u.$ed),this.onDidFocus=this.db.event,this.eb=this.B(new u.$ed),this.onDidBlur=this.eb.event,this.bb=new f.$hR(b.history,100);const R=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(c)&&!this.n.endsWith(F)&&this.bb.getHistory().length){const T=this.n.endsWith(")")?c:F,m=this.n+T;b.showPlaceholderOnFocus&&document.activeElement!==this.b?this.n=m:this.setPlaceHolder(m)}};this.cb=new MutationObserver((T,m)=>{T.forEach(v=>{v.target.textContent||R()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>R()),this.F(this.b,()=>{const T=m=>{if(this.n.endsWith(m)){const v=this.n.slice(0,this.n.length-m.length);return b.showPlaceholderOnFocus?this.n=v:this.setPlaceHolder(v),!0}else return!1};T(F)||T(c)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const g=this.getHistory();this.clearHistory(),n.forEach(b=>{this.bb.add(b)}),g.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",D.$4P(this.value?this.value:r.localize(4,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,D.$4P(this.value))}clearHistory(){this.bb.clear()}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$lR=o}),define(be[64],pe([1,0,61,20,17,18,3,99]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DQ=t.$CQ=t.$BQ=t.$AQ=void 0,t.$AQ={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends y.$EQ{constructor(P,r,h){super(P,r,h),this.a=this.B(new l({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:h.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:h.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:h.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(P){this.element=P,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(P){this.a.domNode.tabIndex=P?0:-1}}t.$BQ=w;class l extends O.$AP{constructor(P){super(),this.a=this.B(new D.$ed),this.onChange=this.a.event,this.b=this.B(new D.$ed),this.onKeyDown=this.b.event,this.c=P,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(..._.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,h=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),h.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,h=>{if(h.keyCode===10||h.keyCode===3){this.checked=!this.s,this.a.fire(!0),h.preventDefault(),h.stopPropagation();return}this.b.fire(h)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(P){this.s=P,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(P){this.g&&this.domNode.classList.remove(..._.ThemeIcon.asClassNameArray(this.g)),this.g=P,this.g&&this.domNode.classList.add(..._.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(P){this.domNode.title=P,this.domNode.setAttribute("aria-label",P)}}t.$CQ=l;class u extends O.$AP{constructor(P,r,h){super(),this.c=P,this.g=r,this.a=new l({title:this.c,isChecked:this.g,icon:i.$Oj.check,actionClassName:"monaco-checkbox",...t.$AQ}),this.domNode=this.a.domNode,this.b=h,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(P){this.a.checked=P,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$DQ=u}),define(be[127],pe([1,0,64,17,104]),function(le,t,y,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=t.$xR=t.$wR=void 0;const _=i.localize(0,null),D=i.localize(1,null),w=i.localize(2,null);class l extends y.$CQ{constructor(r){super({icon:O.$Oj.caseSensitive,title:_+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$wR=l;class u extends y.$CQ{constructor(r){super({icon:O.$Oj.wholeWord,title:D+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$xR=u;class f extends y.$CQ{constructor(r){super({icon:O.$Oj.regex,title:w+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$yR=f}),define(be[128],pe([1,0,4,127,63,20,3,103,2,93]),function(le,t,y,O,i,_,D,w,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zR=void 0;const u=w.localize(0,null);class f extends _.$AP{static{this.OPTION_CHANGE="optionChange"}constructor(r,h,e){super(),this.n=!0,this.s=!1,this.w=this.B(new l.$kc),this.N=[],this.O=this.B(new D.$ed),this.onDidOptionChange=this.O.event,this.P=this.B(new D.$ed),this.onKeyDown=this.P.event,this.Q=this.B(new D.$ed),this.onMouseDown=this.Q.event,this.R=this.B(new D.$ed),this.onInput=this.R.event,this.S=this.B(new D.$ed),this.onKeyUp=this.S.event,this.U=this.B(new D.$ed),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new D.$ed),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||u,this.h=!!e.showCommonFindToggles;const a=e.appendCaseSensitiveLabel||"",o=e.appendWholeWordsLabel||"",s=e.appendRegexLabel||"",n=e.history||[],g=!!e.flexibleHeight,b=!!e.flexibleWidth,$=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$lR(this.domNode,h,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:g,flexibleWidth:b,flexibleMaxHeight:$,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new O.$yR({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new O.$xR({appendTitle:o,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new O.$wR({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const c=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const R=c.indexOf(document.activeElement);if(R>=0){let T=-1;F.equals(17)?T=(R+1)%c.length:F.equals(15)&&(R===0?T=c.length-1:T=R-1),F.equals(9)?(c[R].blur(),this.inputBox.focus()):T>=0&&c[T].focus(),y.$WO.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),r?.appendChild(this.domNode),this.B(y.$gO(this.inputBox.inputElement,"compositionstart",c=>{this.s=!0})),this.B(y.$gO(this.inputBox.inputElement,"compositionend",c=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,c=>this.P.fire(c)),this.C(this.inputBox.inputElement,c=>this.S.fire(c)),this.D(this.inputBox.inputElement,c=>this.R.fire()),this.j(this.inputBox.inputElement,c=>this.Q.fire(c))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.X(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const r of this.N)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const r of this.N)r.disable()}setFocusInputOnOptionClick(r){this.n=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const h of this.N)h.domNode.remove();this.N=[],this.w.value=new l.$ic;for(const h of r??[])this.w.value.add(h),this.y.appendChild(h.domNode),this.w.value.add(h.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(h);this.N.length>0&&(this.y.style.display=""),this.X()}X(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((h,e)=>h+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(r){this.M&&(this.M.checked=r)}getWholeWords(){return this.L?.checked??!1}setWholeWords(r){this.L&&(this.L.checked=r)}getRegex(){return this.J?.checked??!1}setRegex(r){this.J&&(this.J.checked=r,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$zR=f}),define(be[129],pe([1,0,4,21,14,62,128,63,59,37,64,56,24,34,11,9,17,18,41,3,32,2,45,7,108,100]),function(le,t,y,O,i,_,D,w,l,u,f,P,r,h,e,a,o,s,n,g,b,$,c,F,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9R=t.TreeFindMatchType=t.TreeFindMode=t.$8R=t.$7R=t.RenderIndentGuides=t.$6R=t.$5R=void 0;class T extends l.$bQ{set context(d){this.c.context=d}get context(){return this.c.context}constructor(d){super(d.elements.map(p=>p.element)),this.c=d}}function m(x){return x instanceof l.$bQ?new T(x):x}class v{constructor(d,p){this.c=d,this.d=p,this.b=$.$jc.None}getDragURI(d){return this.d.getDragURI(d.element)}getDragLabel(d,p){if(this.d.getDragLabel)return this.d.getDragLabel(d.map(E=>E.element),p)}onDragStart(d,p){this.d.onDragStart?.(m(d),p)}onDragOver(d,p,E,I,N=!0){const B=this.d.onDragOver(m(d),p&&p.element,E,I),q=this.a!==p;if(q&&(this.b.dispose(),this.a=p),typeof p>"u")return B;if(q&&typeof B!="boolean"&&B.autoExpand&&(this.b=(0,a.$Hg)(()=>{const W=this.c(),K=W.getNodeLocation(p);W.isCollapsed(K)&&W.setCollapsed(K,!1),this.a=void 0},500)),typeof B=="boolean"||!B.accept||typeof B.bubble>"u"||B.feedback){if(!N){const W=typeof B=="boolean"?B:B.accept,K=typeof B=="boolean"?void 0:B.effect;return{accept:W,effect:K,feedback:[E]}}return B}if(B.bubble===1){const W=this.c(),K=W.getNodeLocation(p),te=W.getParentNodeLocation(K),se=W.getNode(te),me=te&&W.getListIndex(te);return this.onDragOver(d,se,me,I,!1)}const L=this.c(),j=L.getNodeLocation(p),S=L.getListIndex(j),k=L.getListRenderCount(j);return{...B,feedback:(0,e.$Pb)(S,S+k)}}drop(d,p,E,I){this.b.dispose(),this.a=void 0,this.d.drop(m(d),p&&p.element,E,I)}onDragEnd(d){this.d.onDragEnd?.(d)}}function z(x,d){return d&&{...d,identityProvider:d.identityProvider&&{getId(p){return d.identityProvider.getId(p.element)}},dnd:d.dnd&&new v(x,d.dnd),multipleSelectionController:d.multipleSelectionController&&{isSelectionSingleChangeEvent(p){return d.multipleSelectionController.isSelectionSingleChangeEvent({...p,element:p.element})},isSelectionRangeChangeEvent(p){return d.multipleSelectionController.isSelectionRangeChangeEvent({...p,element:p.element})}},accessibilityProvider:d.accessibilityProvider&&{...d.accessibilityProvider,getSetSize(p){const E=x(),I=E.getNodeLocation(p),N=E.getParentNodeLocation(I);return E.getNode(N).visibleChildrenCount},getPosInSet(p){return p.visibleChildIndex+1},isChecked:d.accessibilityProvider&&d.accessibilityProvider.isChecked?p=>d.accessibilityProvider.isChecked(p.element):void 0,getRole:d.accessibilityProvider&&d.accessibilityProvider.getRole?p=>d.accessibilityProvider.getRole(p.element):()=>"treeitem",getAriaLabel(p){return d.accessibilityProvider.getAriaLabel(p.element)},getWidgetAriaLabel(){return d.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:d.accessibilityProvider&&d.accessibilityProvider.getWidgetRole?()=>d.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:d.accessibilityProvider&&d.accessibilityProvider.getAriaLevel?p=>d.accessibilityProvider.getAriaLevel(p.element):p=>p.depth,getActiveDescendantId:d.accessibilityProvider.getActiveDescendantId&&(p=>d.accessibilityProvider.getActiveDescendantId(p.element))},keyboardNavigationLabelProvider:d.keyboardNavigationLabelProvider&&{...d.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(p){return d.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(p.element)}}}}class U{constructor(d){this.a=d}getHeight(d){return this.a.getHeight(d.element)}getTemplateId(d){return this.a.getTemplateId(d.element)}hasDynamicHeight(d){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(d.element)}setDynamicHeight(d,p){this.a.setDynamicHeight?.(d.element,p)}}t.$5R=U;class M{static lift(d){return d instanceof M?d:new M(d)}static empty(d=0){return new M({focus:[],selection:[],expanded:Object.create(null),scrollTop:d})}constructor(d){if(this.focus=new Set(d.focus),this.selection=new Set(d.selection),d.expanded instanceof Array){this.expanded=Object.create(null);for(const p of d.expanded)this.expanded[p]=1}else this.expanded=d.expanded;this.expanded=d.expanded,this.scrollTop=d.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$6R=M;var A;(function(x){x.None="none",x.OnHover="onHover",x.Always="always"})(A||(t.RenderIndentGuides=A={}));class H{get elements(){return this.b}constructor(d,p=[]){this.b=p,this.a=new $.$ic,this.onDidChange=g.Event.forEach(d,E=>this.b=E,this.a)}dispose(){this.a.dispose()}}class Q{static{this.a=8}constructor(d,p,E,I,N,B={}){this.o=d,this.p=p,this.q=I,this.s=N,this.b=new Map,this.c=new Map,this.d=Q.a,this.f=!1,this.g=!1,this.j=new Set,this.k=$.$jc.None,this.m=new $.$ic,this.templateId=d.templateId,this.updateOptions(B),g.Event.map(E,q=>q.node)(this.u,this,this.m),d.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(d={}){if(typeof d.indent<"u"){const p=(0,c.$Gl)(d.indent,0,40);if(p!==this.d){this.d=p;for(const[E,I]of this.c)this.v(E,I)}}if(typeof d.renderIndentGuides<"u"){const p=d.renderIndentGuides!==A.None;if(p!==this.g){this.g=p;for(const[E,I]of this.c)this.w(E,I);if(this.k.dispose(),p){const E=new $.$ic;this.q.onDidChange(this.x,this,E),this.k=E,this.x(this.q.elements)}}}typeof d.hideTwistiesOfChildlessElements<"u"&&(this.f=d.hideTwistiesOfChildlessElements)}renderTemplate(d){const p=(0,y.$2O)(d,(0,y.$)(".monaco-tl-row")),E=(0,y.$2O)(p,(0,y.$)(".monaco-tl-indent")),I=(0,y.$2O)(p,(0,y.$)(".monaco-tl-twistie")),N=(0,y.$2O)(p,(0,y.$)(".monaco-tl-contents")),B=this.o.renderTemplate(N);return{container:d,indent:E,twistie:I,indentGuidesDisposable:$.$jc.None,templateData:B}}renderElement(d,p,E,I){this.c.set(d,E),this.b.set(d.element,d),this.v(d,E),this.o.renderElement(d,p,E.templateData,I)}disposeElement(d,p,E,I){E.indentGuidesDisposable.dispose(),this.o.disposeElement?.(d,p,E.templateData,I),typeof I=="number"&&(this.c.delete(d),this.b.delete(d.element))}disposeTemplate(d){this.o.disposeTemplate(d.templateData)}t(d){const p=this.b.get(d);p&&this.u(p)}u(d){const p=this.c.get(d);p&&(this.x(this.q.elements),this.v(d,p))}v(d,p){const E=Q.a+(d.depth-1)*this.d;p.twistie.style.paddingLeft=`${E}px`,p.indent.style.width=`${E+this.d-16}px`,d.collapsible?p.container.setAttribute("aria-expanded",String(!d.collapsed)):p.container.removeAttribute("aria-expanded"),p.twistie.classList.remove(...s.ThemeIcon.asClassNameArray(o.$Oj.treeItemExpanded));let I=!1;this.o.renderTwistie&&(I=this.o.renderTwistie(d.element,p.twistie)),d.collapsible&&(!this.f||d.visibleChildrenCount>0)?(I||p.twistie.classList.add(...s.ThemeIcon.asClassNameArray(o.$Oj.treeItemExpanded)),p.twistie.classList.add("collapsible"),p.twistie.classList.toggle("collapsed",d.collapsed)):p.twistie.classList.remove("collapsible","collapsed"),this.w(d,p)}w(d,p){if((0,y.$eO)(p.indent),p.indentGuidesDisposable.dispose(),!this.g)return;const E=new $.$ic,I=this.p();for(;;){const N=I.getNodeLocation(d),B=I.getParentNodeLocation(N);if(!B)break;const q=I.getNode(B),L=(0,y.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(q)&&L.classList.add("active"),p.indent.childElementCount===0?p.indent.appendChild(L):p.indent.insertBefore(L,p.indent.firstElementChild),this.s.add(q,L),E.add((0,$.$hc)(()=>this.s.delete(q,L))),d=q}p.indentGuidesDisposable=E}x(d){if(!this.g)return;const p=new Set,E=this.p();d.forEach(I=>{const N=E.getNodeLocation(I);try{const B=E.getParentNodeLocation(N);I.collapsible&&I.children.length>0&&!I.collapsed?p.add(I):B&&p.add(E.getNode(B))}catch{}}),this.j.forEach(I=>{p.has(I)||this.s.forEach(I,N=>N.classList.remove("active"))}),p.forEach(I=>{this.j.has(I)||this.s.forEach(I,N=>N.classList.add("active"))}),this.j=p}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,$.$ec)(this.m)}}class ie{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(d){this.c=d,this.d=d.toLowerCase()}constructor(d,p,E){this.g=d,this.j=p,this.k=E,this.a=0,this.b=0,this.c="",this.d="",this.f=new $.$ic,d.onWillRefilter(this.m,this,this.f)}filter(d,p){let E=1;if(this.k){const B=this.k.filter(d,p);if(typeof B=="boolean"?E=B?1:0:(0,P.$2R)(B)?E=(0,P.$3R)(B.visibility):E=B,E===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:E};const I=this.j.getKeyboardNavigationLabel(d),N=Array.isArray(I)?I:[I];for(const B of N){const q=B&&B.toString();if(typeof q>"u")return{data:b.FuzzyScore.Default,visibility:E};let L;if(this.g.findMatchType===ge.Contiguous){const j=q.toLowerCase().indexOf(this.d);if(j>-1){L=[Number.MAX_SAFE_INTEGER,0];for(let S=this.d.length;S>0;S--)L.push(j+S-1)}}else L=(0,b.$Jj)(this.c,this.d,0,q,q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(L)return this.b++,N.length===1?{data:L,visibility:E}:{data:{label:q,score:L},visibility:E}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(d):2:{data:b.FuzzyScore.Default,visibility:E}}m(){this.a=0,this.b=0}dispose(){(0,$.$ec)(this.f)}}class re extends f.$CQ{constructor(d){super({icon:o.$Oj.listFilter,title:(0,R.localize)(0,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$7R=re;class ue extends f.$CQ{constructor(d){super({icon:o.$Oj.searchFuzzy,title:(0,R.localize)(1,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$8R=ue;const he={inputBoxStyles:w.$jR,toggleStyles:f.$AQ,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(x){x[x.Highlight=0]="Highlight",x[x.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var ge;(function(x){x[x.Fuzzy=0]="Fuzzy",x[x.Contiguous=1]="Contiguous"})(ge||(t.TreeFindMatchType=ge={}));class Ce extends $.$jc{set mode(d){this.b.checked=d===oe.Filter,this.f.inputBox.setPlaceHolder(d===oe.Filter?(0,R.localize)(2,null):(0,R.localize)(3,null))}set matchType(d){this.c.checked=d===ge.Fuzzy}get value(){return this.f.inputBox.value}set value(d){this.f.inputBox.value=d}constructor(d,p,E,I,N,B){super(),this.t=p,this.a=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new g.$ed,this.onDidDisable=this._onDidDisable.event,d.appendChild(this.a.root),this.B((0,$.$hc)(()=>d.removeChild(this.a.root)));const q=B?.styles??he;q.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=q.listFilterWidgetBackground),q.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${q.listFilterWidgetShadow}`),this.b=this.B(new re({...q.toggleStyles,isChecked:I===oe.Filter})),this.c=this.B(new ue({...q.toggleStyles,isChecked:N===ge.Fuzzy})),this.onDidChangeMode=g.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=g.Event.map(this.c.onChange,()=>this.c.checked?ge.Fuzzy:ge.Contiguous,this.q),this.f=this.B(new D.$zR(this.a.findInput,E,{label:(0,R.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:q.inputBoxStyles,toggleStyles:q.toggleStyles,history:B?.history})),this.g=this.B(new _.$SP(this.a.actionbar)),this.mode=I;const L=this.B(new O.$1P(this.f.inputBox.inputElement,"keydown")),j=g.Event.chain(L.event,K=>K.map(te=>new i.$dO(te)));this.B(j(K=>{if(K.equals(3)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(K.equals(18)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(K.equals(16)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const S=this.B(new h.$fi("close",(0,R.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(S,{icon:!0,label:!1});const k=this.B(new O.$1P(this.a.grab,"mousedown"));this.B(k.event(K=>{const te=new $.$ic,se=te.add(new O.$1P(window,"mousemove")),me=te.add(new O.$1P(window,"mouseup")),we=this.m,Ne=K.pageX,Ee=this.s,ve=K.pageY;this.a.grab.classList.add("grabbing");const Te=this.a.root.style.transition;this.a.root.style.transition="unset";const Pe=qe=>{const je=qe.pageX-Ne;this.m=we-je;const Ie=qe.pageY-ve;this.s=Ee+Ie,this.layout()};te.add(se.event(Pe)),te.add(me.event(qe=>{Pe(qe),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Te,te.dispose()}))}));const W=g.Event.chain(this.B(new O.$1P(this.a.grab,"keydown")).event,K=>K.map(te=>new i.$dO(te)));this.B(W(K=>{let te,se;if(K.keyCode===15?te=Number.POSITIVE_INFINITY:K.keyCode===17?te=0:K.keyCode===10&&(te=this.m===0?Number.POSITIVE_INFINITY:0),K.keyCode===16?se=0:K.keyCode===18&&(se=Number.POSITIVE_INFINITY),te!==void 0&&(K.preventDefault(),K.stopPropagation(),this.m=te,this.layout()),se!==void 0){K.preventDefault(),K.stopPropagation(),this.s=se;const me=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=me},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(d=this.j){this.j=d,this.m=(0,c.$Gl)(this.m,0,Math.max(0,d-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,c.$Gl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(d){this.f.showMessage(d)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,a.$Gg)(300),super.dispose()}}class Se{get pattern(){return this.b}get mode(){return this.d}set mode(d){d!==this.d&&(this.d=d,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(d))}get matchType(){return this.f}set matchType(d){d!==this.f&&(this.f=d,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(d))}constructor(d,p,E,I,N,B={}){this.t=d,this.u=E,this.v=I,this.w=N,this.x=B,this.b="",this.c="",this.j=0,this.k=new g.$ed,this.onDidChangeMode=this.k.event,this.m=new g.$ed,this.onDidChangeMatchType=this.m.event,this.o=new g.$ed,this.onDidChangePattern=this.o.event,this.p=new g.$ed,this.onDidChangeOpenState=this.p.event,this.q=new $.$ic,this.s=new $.$ic,this.d=d.options.defaultFindMode??oe.Highlight,this.f=d.options.defaultFindMatchType??ge.Fuzzy,p.onDidSplice(this.z,this,this.s)}updateOptions(d={}){d.defaultFindMode!==void 0&&(this.mode=d.defaultFindMode),d.defaultFindMatchType!==void 0&&(this.matchType=d.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ce(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(d=>this.mode=d,void 0,this.q),this.g.onDidChangeMatchType(d=>this.matchType=d,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new $.$ic,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(d){this.b=d,this.o.fire(d),this.v.pattern=d,this.t.refilter(),d&&this.t.focusNext(0,!0,void 0,E=>!b.FuzzyScore.isDefault(E.filterData));const p=this.t.getFocus();if(p.length>0){const E=p[0];this.t.getRelativeTop(E)===null&&this.t.reveal(E,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const d=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&d?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,R.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(d){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault(d.filterData)}layout(d){this.j=d,this.g?.layout(d)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Re(x){let d=r.TreeMouseEventTarget.Unknown;return(0,y.$KO)(x.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?d=r.TreeMouseEventTarget.Twistie:(0,y.$KO)(x.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?d=r.TreeMouseEventTarget.Element:(0,y.$KO)(x.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(d=r.TreeMouseEventTarget.Filter),{browserEvent:x.browserEvent,element:x.element?x.element.element:null,target:d}}function fe(x){return{element:x.element?x.element.element:null,browserEvent:x.browserEvent,anchor:x.anchor}}function ne(x,d){d(x),x.children.forEach(p=>ne(p,d))}class G{get f(){return this.d||(this.d=this.m()),this.d}constructor(d,p){this.g=d,this.j=p,this.a=[],this.c=new g.$ed,this.onDidChange=this.c.event}set(d,p){!p?.__forceEvent&&(0,e.$sb)(this.a,d)||this.k(d,!1,p)}k(d,p,E){if(this.a=[...d],this.b=void 0,this.d=void 0,!p){const I=this;this.c.fire({get elements(){return I.get()},browserEvent:E})}}get(){return this.b||(this.b=this.a.map(d=>d.element)),[...this.b]}getNodes(){return this.a}has(d){return this.f.has(d)}onDidModelSplice({insertedNodes:d,deletedNodes:p}){if(!this.j){const L=this.m(),j=S=>L.delete(S);p.forEach(S=>ne(S,j)),this.set([...L.values()]);return}const E=new Set,I=L=>E.add(this.j.getId(L.element).toString());p.forEach(L=>ne(L,I));const N=new Map,B=L=>N.set(this.j.getId(L.element).toString(),L);d.forEach(L=>ne(L,B));const q=[];for(const L of this.a){const j=this.j.getId(L.element).toString();if(!E.has(j))q.push(L);else{const k=N.get(j);k&&k.visible&&q.push(k)}}if(this.a.length>0&&q.length===0){const L=this.g();L&&q.push(L)}this.k(q,!0)}m(){const d=new Set;for(const p of this.a)d.add(p);return d}}class V extends u.$lQ{constructor(d,p){super(d),this.x=p}u(d){if((0,u.$hQ)(d.browserEvent.target)||(0,u.$fQ)(d.browserEvent.target)||(0,u.$gQ)(d.browserEvent.target)||d.browserEvent.isHandledByList)return;const p=d.element;if(!p)return super.u(d);if(this.p(d)||this.o(d))return super.u(d);const E=d.browserEvent.target,I=E.classList.contains("monaco-tl-twistie")||E.classList.contains("monaco-icon-label")&&E.classList.contains("folder-icon")&&d.browserEvent.offsetX<16;let N=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?N=this.x.expandOnlyOnTwistieClick(p.element):N=!!this.x.expandOnlyOnTwistieClick,N&&!I&&d.browserEvent.detail!==2)return super.u(d);if(!this.x.expandOnDoubleClick&&d.browserEvent.detail===2)return super.u(d);if(p.collapsible){const B=this.x.getNodeLocation(p),q=d.browserEvent.altKey;if(this.x.setFocus([B]),this.x.toggleCollapsed(B,q),N&&I){d.browserEvent.isHandledByList=!0;return}}super.u(d)}v(d){d.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||d.browserEvent.isHandledByList||super.v(d)}}class ee extends u.$oQ{constructor(d,p,E,I,N,B,q,L){super(d,p,E,I,L),this.p=N,this.s=B,this.K=q}D(d){return new V(this,d.tree)}splice(d,p,E=[]){if(super.splice(d,p,E),E.length===0)return;const I=[],N=[];let B;E.forEach((q,L)=>{this.p.has(q)&&I.push(d+L),this.s.has(q)&&N.push(d+L),this.K.has(q)&&(B=d+L)}),I.length>0&&super.setFocus((0,e.$Jb)([...super.getFocus(),...I])),N.length>0&&super.setSelection((0,e.$Jb)([...super.getSelection(),...N])),typeof B=="number"&&super.setAnchor(B)}setFocus(d,p,E=!1){super.setFocus(d,p),E||this.p.set(d.map(I=>this.element(I)),p)}setSelection(d,p,E=!1){super.setSelection(d,p),E||this.s.set(d.map(I=>this.element(I)),p)}setAnchor(d,p=!1){super.setAnchor(d),p||(typeof d>"u"?this.K.set([]):this.K.set([this.element(d)]))}}class Z{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return g.Event.map(this.j.onMouseClick,Re)}get onMouseDblClick(){return g.Event.filter(g.Event.map(this.j.onMouseDblClick,Re),d=>d.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return g.Event.map(this.j.onContextMenu,fe)}get onTap(){return g.Event.map(this.j.onTap,Re)}get onPointer(){return g.Event.map(this.j.onPointer,Re)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return g.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode(d){this.x&&(this.x.mode=d)}get findMatchType(){return this.x?.matchType??ge.Fuzzy}set findMatchType(d){this.x&&(this.x.matchType=d)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:g.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(d,p,E,I,N={}){this.D=d,this.E=N,this.w=new g.$md,this.onDidChangeFindOpenState=g.Event.None,this.A=new $.$ic,this.B=new g.$ed,this.onWillRefilter=this.B.event,this.C=new g.$ed,this.onDidUpdateOptions=this.C.event;const B=new U(E),q=new g.$nd,L=new g.$nd,j=this.A.add(new H(L.event)),S=new n.$L;this.k=I.map(se=>new Q(se,()=>this.o,q.event,j,S,N));for(const se of this.k)this.A.add(se);let k;N.keyboardNavigationLabelProvider&&(k=new ie(this,N.keyboardNavigationLabelProvider,N.filter),N={...N,filter:k},this.A.add(k)),this.p=new G(()=>this.j.getFocusedElements()[0],N.identityProvider),this.q=new G(()=>this.j.getSelectedElements()[0],N.identityProvider),this.u=new G(()=>this.j.getAnchorElement(),N.identityProvider),this.j=new ee(d,p,B,this.k,this.p,this.q,this.u,{...z(()=>this.o,N),tree:this}),this.o=this.I(d,this.j,N),q.input=this.o.onDidChangeCollapseState;const W=g.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);W(()=>null,null,this.A);const K=this.A.add(new g.$ed),te=this.A.add(new a.$Cg(0));if(this.A.add(g.Event.any(W,this.p.onDidChange,this.q.onDidChange)(()=>{te.trigger(()=>{const se=new Set;for(const me of this.p.getNodes())se.add(me);for(const me of this.q.getNodes())se.add(me);K.fire([...se.values()])})})),L.input=K.event,N.keyboardSupport!==!1){const se=g.Event.chain(this.j.onKeyDown,me=>me.filter(we=>!(0,u.$fQ)(we.target)).map(we=>new i.$dO(we)));g.Event.chain(se,me=>me.filter(we=>we.keyCode===15))(this.F,this,this.A),g.Event.chain(se,me=>me.filter(we=>we.keyCode===17))(this.G,this,this.A),g.Event.chain(se,me=>me.filter(we=>we.keyCode===10))(this.H,this,this.A)}if((N.findWidgetEnabled??!0)&&N.keyboardNavigationLabelProvider&&N.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Se(this,this.o,this.j,k,N.contextViewProvider,se),this.y=me=>this.x.shouldAllowFocus(me),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=g.Event.None,this.onDidChangeFindMatchType=g.Event.None;this.z=(0,y.$PO)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===A.Always)}updateOptions(d={}){this.E={...this.E,...d};for(const p of this.k)p.updateOptions(d);this.j.updateOptions(this.E),this.x?.updateOptions(d),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===A.Always)}get options(){return this.E}updateWidth(d){const p=this.o.getListIndex(d);p!==-1&&this.j.updateWidth(p)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(d){this.j.scrollTop=d}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(d){this.j.scrollLeft=d}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const d=this.j.firstVisibleIndex;return d<0||d>=this.j.length?void 0:this.j.element(d).element}get lastVisibleElement(){const d=this.j.lastVisibleIndex;return this.j.element(d).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(d){this.j.ariaLabel=d}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(d,p){this.j.layout(d,p),(0,F.$mf)(p)&&this.x?.layout(p)}style(d){const p=`.${this.j.domId}`,E=[];d.treeIndentGuidesStroke&&(E.push(`.monaco-list${p}:hover .monaco-tl-indent > .indent-guide, .monaco-list${p}.always .monaco-tl-indent > .indent-guide  { border-color: ${d.treeInactiveIndentGuidesStroke}; }`),E.push(`.monaco-list${p} .monaco-tl-indent > .indent-guide.active { border-color: ${d.treeIndentGuidesStroke}; }`)),this.z.textContent=E.join(`
`),this.j.style(d)}getParentElement(d){const p=this.o.getParentNodeLocation(d);return this.o.getNode(p).element}getFirstElementChild(d){return this.o.getFirstElementChild(d)}getNode(d){return this.o.getNode(d)}getNodeLocation(d){return this.o.getNodeLocation(d)}collapse(d,p=!1){return this.o.setCollapsed(d,!0,p)}expand(d,p=!1){return this.o.setCollapsed(d,!1,p)}toggleCollapsed(d,p=!1){return this.o.setCollapsed(d,void 0,p)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(d){return this.o.isCollapsible(d)}setCollapsible(d,p){return this.o.setCollapsible(d,p)}isCollapsed(d){return this.o.isCollapsed(d)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(d){if(typeof d>"u")return this.j.setAnchor(void 0);const p=this.o.getNode(d);this.u.set([p]);const E=this.o.getListIndex(d);E>-1&&this.j.setAnchor(E,!0)}getAnchor(){return(0,e.$Lb)(this.u.get(),void 0)}setSelection(d,p){const E=d.map(N=>this.o.getNode(N));this.q.set(E,p);const I=d.map(N=>this.o.getListIndex(N)).filter(N=>N>-1);this.j.setSelection(I,p,!0)}getSelection(){return this.q.get()}setFocus(d,p){const E=d.map(N=>this.o.getNode(N));this.p.set(E,p);const I=d.map(N=>this.o.getListIndex(N)).filter(N=>N>-1);this.j.setFocus(I,p,!0)}focusNext(d=1,p=!1,E,I=this.y){this.j.focusNext(d,p,E,I)}focusPrevious(d=1,p=!1,E,I=this.y){this.j.focusPrevious(d,p,E,I)}focusNextPage(d,p=this.y){return this.j.focusNextPage(d,p)}focusPreviousPage(d,p=this.y){return this.j.focusPreviousPage(d,p)}focusLast(d,p=this.y){this.j.focusLast(d,p)}focusFirst(d,p=this.y){this.j.focusFirst(d,p)}getFocus(){return this.p.get()}reveal(d,p){this.o.expandTo(d);const E=this.o.getListIndex(d);E!==-1&&this.j.reveal(E,p)}getRelativeTop(d){const p=this.o.getListIndex(d);return p===-1?null:this.j.getRelativeTop(p)}getViewState(d=this.options.identityProvider){if(!d)throw new r.$ZR(this.D,"Can't get tree view state without an identity provider");const p=B=>d.getId(B).toString(),E=M.empty(this.scrollTop);for(const B of this.getFocus())E.focus.add(p(B));for(const B of this.getSelection())E.selection.add(p(B));const I=this.o.getNode(),N=[I];for(;N.length>0;){const B=N.shift();B!==I&&B.collapsible&&(E.expanded[p(B.element)]=B.collapsed?0:1),N.push(...B.children)}return E}F(d){d.preventDefault(),d.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const E=p[0],I=this.o.getNodeLocation(E);if(!this.o.setCollapsed(I,!0)){const B=this.o.getParentNodeLocation(I);if(!B)return;const q=this.o.getListIndex(B);this.j.reveal(q),this.j.setFocus([q])}}G(d){d.preventDefault(),d.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const E=p[0],I=this.o.getNodeLocation(E);if(!this.o.setCollapsed(I,!1)){if(!E.children.some(L=>L.visible))return;const[B]=this.j.getFocus(),q=B+1;this.j.reveal(q),this.j.setFocus([q])}}H(d){d.preventDefault(),d.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const E=p[0],I=this.o.getNodeLocation(E),N=d.browserEvent.altKey;this.o.setCollapsed(I,void 0,N)}navigate(d){return new C(this.j,this.o,d)}dispose(){(0,$.$ec)(this.A),this.j.dispose()}}t.$9R=Z;class C{constructor(d,p,E){this.b=d,this.c=p,E?this.a=this.c.getListIndex(E):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[130],pe([1,0,129,120,24,26]),function(le,t,y,O,i,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hS=void 0;class D extends y.$9R{constructor(l,u,f,P,r,h={}){super(l,u,f,P,h),this.f=l,this.g=r,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(l,u){if(u&&!this.c)throw new i.$ZR(this.f,"Can't restore tree view state without an identity provider");if(this.b=l,!l){this.d.clear(),this.o.setChildren(null,_.Iterable.empty());return}if(!u){this.m(l);return}const f=[],P=[],r=e=>{const a=this.c.getId(e).toString();return!u.expanded[a]},h=e=>{const a=this.c.getId(e.element).toString();u.focus.has(a)&&f.push(e.element),u.selection.has(a)&&P.push(e.element)};this.m(l,r,h),this.setFocus(f),this.setSelection(P),u&&typeof u.scrollTop=="number"&&(this.scrollTop=u.scrollTop)}updateChildren(l=this.b){if(typeof this.b>"u")throw new i.$ZR(this.f,"Tree input not set");let u;this.c&&(u=f=>{const P=this.c.getId(f).toString(),r=this.d.get(P);if(r)return r.collapsed}),this.m(l,u)}resort(l=this.b,u=!0){this.o.resort(l===this.b?null:l,u)}refresh(l){if(l===void 0){this.j.rerender();return}this.o.rerender(l)}m(l,u,f){let P;if(this.c){const r=new Set,h=f;f=e=>{const a=this.c.getId(e.element).toString();r.add(a),this.d.set(a,e),h?.(e)},P=e=>{const a=this.c.getId(e.element).toString();r.has(a)||this.d.delete(a)}}this.o.setChildren(l===this.b?null:l,this.s(l,u).elements,{onDidCreateNode:f,onDidDeleteNode:P})}s(l,u){const f=[...this.g.getChildren(l)];return{elements:_.Iterable.map(f,r=>{const{elements:h,size:e}=this.s(r,u),a=this.g.hasChildren?this.g.hasChildren(r):void 0,o=e===0?void 0:u&&u(r);return{element:r,children:h,collapsible:a,collapsed:o}}),size:f.length}}I(l,u,f){return new O.$0R(l,u,f)}}t.$hS=D}),define(be[65],pe([1,0,11,9,31,27,25,6,3,2,51,12,7]),function(le,t,y,O,i,_,D,w,l,u,f,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jh=t.ProxyChannel=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.RequestInitiator=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=void 0;var h;(function(fe){fe[fe.Promise=100]="Promise",fe[fe.PromiseCancel=101]="PromiseCancel",fe[fe.EventListen=102]="EventListen",fe[fe.EventDispose=103]="EventDispose"})(h||(h={}));function e(fe){switch(fe){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(fe){fe[fe.Initialize=200]="Initialize",fe[fe.PromiseSuccess=201]="PromiseSuccess",fe[fe.PromiseError=202]="PromiseError",fe[fe.PromiseErrorObj=203]="PromiseErrorObj",fe[fe.EventFire=204]="EventFire"})(a||(a={}));function o(fe){switch(fe){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(fe){fe[fe.Uninitialized=0]="Uninitialized",fe[fe.Idle=1]="Idle"})(s||(s={}));function n(fe){let ne=0;for(let G=0;;G+=7){const V=fe.read(1);if(ne|=(V.buffer[0]&127)<<G,!(V.buffer[0]&128))return ne}}const g=R(0);function b(fe,ne){if(ne===0){fe.write(g);return}let G=0;for(let ee=ne;ee!==0;ee=ee>>>7)G++;const V=i.$Ed.alloc(G);for(let ee=0;ne!==0;ee++)V.buffer[ee]=ne&127,ne=ne>>>7,ne>0&&(V.buffer[ee]|=128);fe.write(V)}class ${constructor(ne){this.b=ne,this.a=0}read(ne){const G=this.b.slice(this.a,this.a+ne);return this.a+=G.byteLength,G}}t.$$g=$;class c{constructor(){this.a=[]}get buffer(){return i.$Ed.concat(this.a)}write(ne){this.a.push(ne)}}t.$_g=c;var F;(function(fe){fe[fe.Undefined=0]="Undefined",fe[fe.String=1]="String",fe[fe.Buffer=2]="Buffer",fe[fe.VSBuffer=3]="VSBuffer",fe[fe.Array=4]="Array",fe[fe.Object=5]="Object",fe[fe.Int=6]="Int"})(F||(F={}));function R(fe){const ne=i.$Ed.alloc(1);return ne.writeUInt8(fe,0),ne}const T={Undefined:R(F.Undefined),String:R(F.String),Buffer:R(F.Buffer),VSBuffer:R(F.VSBuffer),Array:R(F.Array),Object:R(F.Object),Uint:R(F.Int)},m=typeof Buffer<"u";function v(fe,ne){if(typeof ne>"u")fe.write(T.Undefined);else if(typeof ne=="string"){const G=i.$Ed.fromString(ne);fe.write(T.String),b(fe,G.byteLength),fe.write(G)}else if(m&&Buffer.isBuffer(ne)){const G=i.$Ed.wrap(ne);fe.write(T.Buffer),b(fe,G.byteLength),fe.write(G)}else if(ne instanceof i.$Ed)fe.write(T.VSBuffer),b(fe,ne.byteLength),fe.write(ne);else if(Array.isArray(ne)){fe.write(T.Array),b(fe,ne.length);for(const G of ne)v(fe,G)}else if(typeof ne=="number"&&(ne|0)===ne)fe.write(T.Uint),b(fe,ne);else{const G=i.$Ed.fromString(JSON.stringify(ne));fe.write(T.Object),b(fe,G.byteLength),fe.write(G)}}t.$ah=v;function z(fe){switch(fe.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return fe.read(n(fe)).toString();case F.Buffer:return fe.read(n(fe)).buffer;case F.VSBuffer:return fe.read(n(fe));case F.Array:{const G=n(fe),V=[];for(let ee=0;ee<G;ee++)V.push(z(fe));return V}case F.Object:return JSON.parse(fe.read(n(fe)).toString());case F.Int:return n(fe)}}t.$bh=z;class U{constructor(ne,G,V=null,ee=1e3){this.h=ne,this.j=G,this.k=V,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Z=>this.q(Z)),this.m({type:200})}registerChannel(ne,G){this.b.set(ne,G),setTimeout(()=>this.w(ne),0)}m(ne){switch(ne.type){case 200:{const G=this.o([ne.type]);this.k?.logOutgoing(G,0,1,o(ne.type));return}case 201:case 202:case 204:case 203:{const G=this.o([ne.type,ne.id],ne.data);this.k?.logOutgoing(G,ne.id,1,o(ne.type),ne.data);return}}}o(ne,G=void 0){const V=new c;return v(V,ne),v(V,G),this.p(V.buffer)}p(ne){try{return this.h.send(ne),ne.byteLength}catch{return 0}}q(ne){const G=new $(ne),V=z(G),ee=z(G),Z=V[0];switch(Z){case 100:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(Z)}: ${V[2]}.${V[3]}`,ee),this.s({type:Z,id:V[1],channelName:V[2],name:V[3],arg:ee});case 102:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(Z)}: ${V[2]}.${V[3]}`,ee),this.t({type:Z,id:V[1],channelName:V[2],name:V[3],arg:ee});case 101:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(Z)}`),this.u({type:Z,id:V[1]});case 103:return this.k?.logIncoming(ne.byteLength,V[1],1,`${e(Z)}`),this.u({type:Z,id:V[1]})}}s(ne){const G=this.b.get(ne.channelName);if(!G){this.v(ne);return}const V=new _.$od;let ee;try{ee=G.call(this.j,ne.name,ne.arg,V.token)}catch(x){ee=Promise.reject(x)}const Z=ne.id;ee.then(x=>{this.m({id:Z,data:x,type:201})},x=>{x instanceof Error?this.m({id:Z,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:Z,data:x,type:203})}).finally(()=>{C.dispose(),this.d.delete(ne.id)});const C=(0,u.$hc)(()=>V.cancel());this.d.set(ne.id,C)}t(ne){const G=this.b.get(ne.channelName);if(!G){this.v(ne);return}const V=ne.id,Z=G.listen(this.j,ne.name,ne.arg)(C=>this.m({id:V,data:C,type:204}));this.d.set(ne.id,Z)}u(ne){const G=this.d.get(ne.id);G&&(G.dispose(),this.d.delete(ne.id))}v(ne){let G=this.g.get(ne.channelName);G||(G=[],this.g.set(ne.channelName,G));const V=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.m({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);G.push({request:ne,timeoutTimer:V})}w(ne){const G=this.g.get(ne);if(G){for(const V of G)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(ne)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$ec)(this.d.values()),this.d.clear()}}t.$ch=U;var M;(function(fe){fe[fe.LocalSide=0]="LocalSide",fe[fe.OtherSide=1]="OtherSide"})(M||(t.RequestInitiator=M={}));class A{constructor(ne,G=null){this.l=ne,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$ed,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=G}getChannel(ne){const G=this;return{call(V,ee,Z){return G.a?Promise.reject(new w.$3):G.m(ne,V,ee,Z)},listen(V,ee){return G.a?l.Event.None:G.o(ne,V,ee)}}}m(ne,G,V,ee=_.CancellationToken.None){const Z=this.g++,x={id:Z,type:100,channelName:ne,name:G,arg:V};if(ee.isCancellationRequested)return Promise.reject(new w.$3);let d;return new Promise((E,I)=>{if(ee.isCancellationRequested)return I(new w.$3);const N=()=>{const j=S=>{switch(S.type){case 201:this.f.delete(Z),E(S.data);break;case 202:{this.f.delete(Z);const k=new Error(S.data.message);k.stack=Array.isArray(S.data.stack)?S.data.stack.join(`
`):S.data.stack,k.name=S.data.name,I(k);break}case 203:this.f.delete(Z),I(S.data);break}};this.f.set(Z,j),this.p(x)};let B=null;this.b===s.Idle?N():(B=(0,O.$tg)(j=>this.u()),B.then(()=>{B=null,N()}));const q=()=>{B?(B.cancel(),B=null):this.p({id:Z,type:101}),I(new w.$3)},L=ee.onCancellationRequested(q);d=(0,u.$gc)((0,u.$hc)(q),L),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(ne,G,V){const ee=this.g++,C={id:ee,type:102,channelName:ne,name:G,arg:V};let x=null;const d=new l.$ed({onWillAddFirstListener:()=>{x=(0,O.$tg)(E=>this.u()),x.then(()=>{x=null,this.d.add(d),this.p(C)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(d),this.p({id:ee,type:103}))}}),p=E=>d.fire(E.data);return this.f.set(ee,p),d.event}p(ne){switch(ne.type){case 100:case 102:{const G=this.q([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.j?.logOutgoing(G,ne.id,0,`${e(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const G=this.q([ne.type,ne.id]);this.j?.logOutgoing(G,ne.id,0,e(ne.type));return}}}q(ne,G=void 0){const V=new c;return v(V,ne),v(V,G),this.r(V.buffer)}r(ne){try{return this.l.send(ne),ne.byteLength}catch{return 0}}s(ne){const G=new $(ne),V=z(G),ee=z(G),Z=V[0];switch(Z){case 200:return this.j?.logIncoming(ne.byteLength,0,0,o(Z)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ne.byteLength,V[1],0,o(Z),ee),this.t({type:V[0],id:V[1],data:ee})}}t(ne){if(ne.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(ne.id)?.(ne)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$ec)(this.d.values()),this.d.clear()}}t.$dh=A,Ke([D.$5g],A.prototype,"onDidInitializePromise",null);class H{get connections(){const ne=[];return this.f.forEach(G=>ne.push(G)),ne}constructor(ne){this.a=new Map,this.f=new Set,this.g=new l.$ed,this.onDidAddConnection=this.g.event,this.h=new l.$ed,this.onDidRemoveConnection=this.h.event,this.j=new u.$ic,this.j.add(ne(({protocol:G,onDidClientDisconnect:V})=>{const ee=l.Event.once(G.onMessage);this.j.add(ee(Z=>{const C=new $(Z),x=z(C),d=new U(G,x),p=new A(G);this.a.forEach((I,N)=>d.registerChannel(N,I));const E={channelServer:d,channelClient:p,ctx:x};this.f.add(E),this.g.fire(E),this.j.add(V(()=>{d.dispose(),p.dispose(),this.f.delete(E),this.h.fire(E)}))}))}))}getChannel(ne,G){const V=this;return{call(ee,Z,C){let x;if((0,r.$wf)(G)){const p=(0,y.$1b)(V.connections.filter(G));x=p?Promise.resolve(p):l.Event.toPromise(l.Event.filter(V.onDidAddConnection,G))}else x=G.routeCall(V,ee,Z);const d=x.then(p=>p.channelClient.getChannel(ne));return ie(d).call(ee,Z,C)},listen(ee,Z){if((0,r.$wf)(G))return V.k(ne,G,ee,Z);const C=G.routeEvent(V,ee,Z).then(x=>x.channelClient.getChannel(ne));return ie(C).listen(ee,Z)}}}k(ne,G,V,ee){const Z=this;let C;const x=new l.$ed({onWillAddFirstListener:()=>{C=new u.$ic;const d=new l.$kd,p=new Map,E=N=>{const q=N.channelClient.getChannel(ne).listen(V,ee),L=d.add(q);p.set(N,L)},I=N=>{const B=p.get(N);B&&(B.dispose(),p.delete(N))};Z.connections.filter(G).forEach(E),l.Event.filter(Z.onDidAddConnection,G)(E,void 0,C),Z.onDidRemoveConnection(I,void 0,C),d.event(x.fire,x,C),C.add(d)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return x.event}registerChannel(ne,G){this.a.set(ne,G);for(const V of this.f)V.channelServer.registerChannel(ne,G)}dispose(){this.j.dispose();for(const ne of this.f)ne.channelClient.dispose(),ne.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$eh=H;class Q{constructor(ne,G,V=null){const ee=new c;v(ee,G),ne.send(ee.buffer),this.a=new A(ne,V),this.d=new U(ne,G,V)}getChannel(ne){return this.a.getChannel(ne)}registerChannel(ne,G){this.d.registerChannel(ne,G)}dispose(){this.a.dispose(),this.d.dispose()}}t.$fh=Q;function ie(fe){return{call(ne,G,V){return fe.then(ee=>ee.call(ne,G,V))},listen(ne,G){const V=new l.$nd;return fe.then(ee=>V.input=ee.listen(ne,G)),V.event}}}t.$gh=ie;function re(fe){let ne=!1;return{call(G,V,ee){return ne?fe.call(G,V,ee):(0,O.$Gg)(0).then(()=>ne=!0).then(()=>fe.call(G,V,ee))},listen(G,V){if(ne)return fe.listen(G,V);const ee=new l.$nd;return(0,O.$Gg)(0).then(()=>ne=!0).then(()=>ee.input=fe.listen(G,V)),ee.event}}}t.$hh=re;class ue{constructor(ne){this.a=ne}routeCall(ne){return this.b(ne)}routeEvent(ne){return this.b(ne)}async b(ne){for(const G of ne.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await l.Event.toPromise(ne.onDidAddConnection),await this.b(ne)}}t.$ih=ue;var he;(function(fe){function ne(Z,C,x){const d=Z,p=x&&x.disableMarshalling,E=new Map;for(const I in d)V(I)&&E.set(I,l.Event.buffer(d[I],!0,void 0,C));return new class{listen(I,N,B){const q=E.get(N);if(q)return q;if(ee(N)){const L=d[N];if(typeof L=="function")return L.call(d,B)}throw new w.$_(`Event not found: ${N}`)}call(I,N,B){const q=d[N];if(typeof q=="function"){if(!p&&Array.isArray(B))for(let L=0;L<B.length;L++)B[L]=(0,f.$0g)(B[L]);return q.apply(d,B)}throw new w.$_(`Method not found: ${N}`)}}}fe.fromService=ne;function G(Z,C){const x=C&&C.disableMarshalling;return new Proxy({},{get(d,p){if(typeof p=="string")return C?.properties?.has(p)?C.properties.get(p):ee(p)?function(E){return Z.listen(p,E)}:V(p)?Z.listen(p):async function(...E){let I;C&&!(0,r.$rf)(C.context)?I=[C.context,...E]:I=E;const N=await Z.call(p,I);return x?N:(0,f.$0g)(N)};throw new w.$_(`Property not found: ${String(p)}`)}})}fe.toService=G;function V(Z){return Z[0]==="o"&&Z[1]==="n"&&P.$Ke(Z.charCodeAt(2))}function ee(Z){return/^onDynamic/.test(Z)&&P.$Ke(Z.charCodeAt(9))}})(he||(t.ProxyChannel=he={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(fe){if(Array.isArray(fe))return fe;if(fe&&typeof fe=="object"&&typeof fe.toString=="function"){const ne=fe.toString();if(ne!=="[object Object]")return ne}return fe}function Ce(fe){return Array.isArray(fe)?fe.map(ge):ge(fe)}function Se(fe,ne,G,V,ee,Z,C){C=Ce(C);const x=oe[ee],d=x[V%x.length];let p=[`%c[${fe}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(Z)?(p=p.concat(C),p.push(")")):p.push(C),console.log.apply(console,p)}class Re{constructor(ne,G){this.d=ne,this.f=G,this.a=0,this.b=0}logOutgoing(ne,G,V,ee,Z){this.b+=ne,Se(this.d,this.b,ne,G,V,ee,Z)}logIncoming(ne,G,V,ee,Z){this.a+=ne,Se(this.f,this.a,ne,G,V,ee,Z)}}t.$jh=Re}),define(be[29],pe([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q=t.$P=t.$O=t.$N=t.$M=void 0,t.$M=y.$g.vscode.ipcRenderer,t.$N=y.$g.vscode.ipcMessagePort,t.$O=y.$g.vscode.webFrame,t.$P=y.$g.vscode.process,t.$Q=y.$g.vscode.context}),define(be[131],pe([1,0,87,29]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LS=void 0;let i=0;function _(w,l,u){const f=[],P=i++,r=`vscode:onContextMenu${P}`,h=(e,a,o)=>{f[a].click?.(o)};O.$M.once(r,h),O.$M.once(y.$IS,(e,a)=>{a===P&&(O.$M.removeListener(r,h),u?.())}),O.$M.send(y.$HS,P,w.map(e=>D(e,f)),r,l)}t.$LS=_;function D(w,l){const u={id:l.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return l.push(w),Array.isArray(w.submenu)&&(u.submenu=w.submenu.map(f=>D(f,l))),u}}),define(be[132],pe([1,0,31,3,65,88,29]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TS=void 0;class w extends i.$fh{static f(){const u=O.Event.fromNodeEventEmitter(D.$M,"vscode:message",(f,P)=>y.$Ed.wrap(P));return D.$M.send("vscode:hello"),new _.$PS(D.$M,u)}constructor(u){const f=w.f();super(f,u),this.b=f}dispose(){this.b.disconnect()}}t.$TS=w}),define(be[133],pe([13,10]),function(le,t){return le.create("vs/platform/files/common/files",t)}),define(be[134],pe([13,10]),function(le,t){return le.create("vs/platform/theme/common/iconRegistry",t)}),define(be[38],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bh=t.$Ah=t.$zh=t._util=void 0;var y;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function w(l){return l[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=w})(y||(t._util=y={})),t.$zh=i("instantiationService");function O(D,w,l){w[y.DI_TARGET]===w?w[y.DI_DEPENDENCIES].push({id:D,index:l}):(w[y.DI_DEPENDENCIES]=[{id:D,index:l}],w[y.DI_TARGET]=w)}function i(D){if(y.serviceIds.has(D))return y.serviceIds.get(D);const w=function(l,u,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(w,l,f)};return w.toString=()=>D,y.serviceIds.set(D,w),w}t.$Ah=i;function _(D){return D}t.$Bh=_}),define(be[135],pe([1,0,38]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hm=t.$gm=t.$fm=t.ID=void 0,t.ID="diagnosticsService",t.$fm=(0,y.$Ah)(t.ID);function O(_){return!!_.hostName&&!!_.errorMessage}t.$gm=O;class i{async getPerformanceInfo(D,w){return{}}async getSystemInfo(D,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,w){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}t.$hm=i}),define(be[136],pe([1,0,86,22,12,7,15,133,38,5,28]),function(le,t,y,O,i,_,D,w,l,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.FileKind=t.$vk=t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.$pk=t.FileOperationResult=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.FileChangeType=t.$jk=t.FileOperation=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.FileSystemProviderErrorCode=t.$ck=t.$bk=t.$ak=t.$_j=t.$$j=t.$0j=t.$9j=t.$8j=t.$7j=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$6j=t.$5j=void 0,t.$5j=(0,l.$Ah)("fileService");function P(G){return G.create===!0}t.$6j=P;var r;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(r||(t.FileType=r={}));var h;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(h||(t.FilePermission=h={}));var e;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function a(G){return!!(G.capabilities&2)}t.$7j=a;function o(G){return!!(G.capabilities&8)}t.$8j=o;function s(G){return!!(G.capabilities&131072)}t.$9j=s;function n(G){return!!(G.capabilities&4)}t.$0j=n;function g(G){return!!(G.capabilities&16)}t.$$j=g;function b(G){return a(G)?!!(G.capabilities&16384):!1}t.$_j=b;function $(G){return a(G)?!!(G.capabilities&32768):!1}t.$ak=$;function c(G){return!!(G.capabilities&65536)}t.$bk=c;function F(G){return!!(G.capabilities&2048)}t.$ck=F;var R;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(R||(t.FileSystemProviderErrorCode=R={}));class T extends Error{static create(V,ee){const Z=new T(V.toString(),ee);return z(Z,ee),Z}constructor(V,ee){super(V),this.code=ee}}t.$dk=T;function m(G,V){return T.create(G,V)}t.$ek=m;function v(G){return G||m((0,w.localize)(0,null),R.Unknown)}t.$fk=v;function z(G,V){return G.name=V?`${V} (FileSystemError)`:"FileSystemError",G}t.$gk=z;function U(G){if(!G)return R.Unknown;if(G instanceof T)return G.code;const V=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!V)return R.Unknown;switch(V[1]){case R.FileExists:return R.FileExists;case R.FileIsADirectory:return R.FileIsADirectory;case R.FileNotADirectory:return R.FileNotADirectory;case R.FileNotFound:return R.FileNotFound;case R.FileTooLarge:return R.FileTooLarge;case R.FileWriteLocked:return R.FileWriteLocked;case R.NoPermissions:return R.NoPermissions;case R.Unavailable:return R.Unavailable}return R.Unknown}t.$hk=U;function M(G){if(G instanceof ue)return G.fileOperationResult;switch(U(G)){case R.FileNotFound:return 1;case R.FileIsADirectory:return 0;case R.FileNotADirectory:return 9;case R.FileWriteLocked:return 5;case R.NoPermissions:return 6;case R.FileExists:return 4;case R.FileTooLarge:return 7;default:return 10}}t.$ik=M;var A;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(A||(t.FileOperation=A={}));class H{constructor(V,ee,Z){this.resource=V,this.operation=ee,this.target=Z}isOperation(V){return this.operation===V}}t.$jk=H;var Q;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(Q||(t.FileChangeType=Q={}));class ie{constructor(V,ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Z=new Map;for(const C of V){const x=Z.get(C.type);switch(x?x.push([C.resource,C]):Z.set(C.type,[[C.resource,C]]),C.type){case 1:this.rawAdded.push(C.resource);break;case 0:this.rawUpdated.push(C.resource);break;case 2:this.rawDeleted.push(C.resource);break}}for(const[C,x]of Z)switch(C){case 1:this.a=y.$Gh.forUris(()=>ee),this.a.fill(x);break;case 0:this.b=y.$Gh.forUris(()=>ee),this.b.fill(x);break;case 2:this.c=y.$Gh.forUris(()=>ee),this.c.fill(x);break}}contains(V,...ee){return this.d(V,{includeChildren:!1},...ee)}affects(V,...ee){return this.d(V,{includeChildren:!0},...ee)}d(V,ee,...Z){if(!V)return!1;const C=Z.length>0;return!!((!C||Z.includes(1))&&(this.a?.get(V)||ee.includeChildren&&this.a?.findSuperstr(V))||(!C||Z.includes(0))&&(this.b?.get(V)||ee.includeChildren&&this.b?.findSuperstr(V))||(!C||Z.includes(2))&&(this.c?.findSubstr(V)||ee.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.$kk=ie;function re(G,V,ee){return!G||!V||G===V||V.length>G.length?!1:(V.charAt(V.length-1)!==O.sep&&(V+=O.sep),ee?(0,i.$Me)(G,V):G.indexOf(V)===0)}t.$lk=re;class ue extends Error{constructor(V,ee,Z){super(V),this.fileOperationResult=ee,this.options=Z}}t.$mk=ue;class he extends ue{constructor(V,ee,Z,C){super(V,ee,C),this.fileOperationResult=ee,this.size=Z}}t.$nk=he;class oe extends ue{constructor(V,ee,Z){super(V,2,Z),this.stat=ee}}t.$ok=oe;var ge;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(t.FileOperationResult=ge={})),t.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$rk="files.associations",t.$sk="files.exclude",t.$tk="files.readonlyInclude",t.$uk="files.readonlyExclude",t.$vk="files.readonlyFromPermissions";var Ce;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ce||(t.FileKind=Ce={})),t.$wk="";function Se(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}t.$xk=Se;async function Re(G,V){if(!V.hasProvider(D.URI.from({scheme:G.scheme})))return new Promise(ee=>{const Z=V.onDidChangeFileSystemProviderRegistrations(C=>{C.scheme===G.scheme&&C.added&&(Z.dispose(),ee())})})}t.$yk=Re;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(V){return(0,_.$mf)(V)||(V=0),V<fe.KB?(0,w.localize)(1,null,V.toFixed(0)):V<fe.MB?(0,w.localize)(2,null,(V/fe.KB).toFixed(2)):V<fe.GB?(0,w.localize)(3,null,(V/fe.MB).toFixed(2)):V<fe.TB?(0,w.localize)(4,null,(V/fe.GB).toFixed(2)):(0,w.localize)(5,null,(V/fe.TB).toFixed(2))}}t.$zk=fe;function ne(G){const V=typeof G=="string"||G?.scheme===f.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===f.Schemas.file?1024*fe.MB:V?10*fe.MB:u.$o?50*fe.MB:1024*fe.MB}t.$Ak=ne}),define(be[137],pe([1,0,38]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$56b=t.$46b=void 0,t.$46b=(0,y.$Ah)("mainProcessService");class O{constructor(_,D){this.a=_,this.b=D}getChannel(_){return this.a.getChannel(_,this.b)}registerChannel(_,D){this.a.registerChannel(_,D)}}t.$56b=O}),define(be[138],pe([1,0,2,132]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$66b=void 0;class i extends y.$jc{constructor(D){super(),this.a=this.B(new O.$TS(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,w){this.a.registerChannel(D,w)}}t.$66b=i});var bi=this&&this.__param||function(le,t){return function(y,O){t(y,O,le)}};define(be[139],pe([1,0,65,137]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$76b=void 0;let i=class{constructor(D,w){return this.windowId=D,y.ProxyChannel.toService(w.getChannel("nativeHost"),{context:D,properties:(()=>{const l=new Map;return l.set("windowId",D),l})()})}};t.$76b=i,t.$76b=i=Ke([bi(1,O.$46b)],i)}),define(be[66],pe([1,0,73,7]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7m=void 0;class i{constructor(){this.a=new Map}add(D,w){y.ok(O.$if(D)),y.ok(O.$kf(w)),y.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,w)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}t.$7m=new i}),define(be[140],pe([1,0,3,66]),function(le,t,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8m=void 0,t.$8m={JSONContribution:"base.contributions.json"};function i(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class _{constructor(){this.b=new y.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,u){this.a[i(l)]=u,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}}const D=new _;O.$7m.add(t.$8m.JSONContribution,D)}),define(be[141],pe([1,0,9,17,18,3,7,15,134,140,66]),function(le,t,y,O,i,_,D,w,l,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bv=t.$av=t.$_u=t.$$u=t.$0u=t.$9u=t.$8u=t.$7u=t.IconFontDefinition=t.IconContribution=t.$6u=void 0,t.$6u={IconContribution:"base.contributions.icons"};var P;(function(b){function $(c,F){let R=c.defaults;for(;i.ThemeIcon.isThemeIcon(R);){const T=e.getIcon(R.id);if(!T)return;R=T.defaults}return R}b.getDefinition=$})(P||(t.IconContribution=P={}));var r;(function(b){function $(F){return{weight:F.weight,style:F.style,src:F.src.map(R=>({format:R.format,location:R.location.toString()}))}}b.toJSONObject=$;function c(F){const R=T=>(0,D.$if)(T)?T:void 0;if(F&&Array.isArray(F.src)&&F.src.every(T=>(0,D.$if)(T.format)&&(0,D.$if)(T.location)))return{weight:R(F.weight),style:R(F.style),src:F.src.map(T=>({format:T.format,location:w.URI.parse(T.location)}))}}b.fromJSONObject=c})(r||(t.IconFontDefinition=r={}));class h{constructor(){this.a=new _.$ed,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon($,c,F,R){const T=this.b[$];if(T){if(F&&!T.description){T.description=F,this.d.properties[$].markdownDescription=`${F} $(${$})`;const z=this.e.enum.indexOf($);z!==-1&&(this.e.enumDescriptions[z]=F),this.a.fire()}return T}const m={id:$,description:F,defaults:c,deprecationMessage:R};this.b[$]=m;const v={$ref:"#/definitions/icons"};return R&&(v.deprecationMessage=R),F&&(v.markdownDescription=`${F}: $(${$})`),this.d.properties[$]=v,this.e.enum.push($),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:$}}deregisterIcon($){delete this.b[$],delete this.d.properties[$];const c=this.e.enum.indexOf($);c!==-1&&(this.e.enum.splice(c,1),this.e.enumDescriptions.splice(c,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map($=>this.b[$])}getIcon($){return this.b[$]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont($,c){const F=this.f[$];return F||(this.f[$]=c,this.a.fire(),c)}deregisterIconFont($){delete this.f[$]}getIconFont($){return this.f[$]}toString(){const $=(T,m)=>T.id.localeCompare(m.id),c=T=>{for(;i.ThemeIcon.isThemeIcon(T.defaults);)T=this.b[T.defaults.id];return`codicon codicon-${T?T.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const R=Object.keys(this.b).map(T=>this.b[T]);for(const T of R.filter(m=>!!m.description).sort($))F.push(`|<i class="${c(T)}"></i>|${T.id}|${i.ThemeIcon.isThemeIcon(T.defaults)?T.defaults.id:T.id}|${T.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const T of R.filter(m=>!i.ThemeIcon.isThemeIcon(m.defaults)).sort($))F.push(`|<i class="${c(T)}"></i>|${T.id}|`);return F.join(`
`)}}const e=new h;f.$7m.add(t.$6u.IconContribution,e);function a(b,$,c,F){return e.registerIcon(b,$,c,F)}t.$7u=a;function o(){return e}t.$8u=o;function s(){const b=(0,O.$Mj)();for(const $ in b){const c="\\"+b[$].toString(16);e.registerIcon($,{fontCharacter:c})}}s(),t.$9u="vscode://schemas/icons";const n=f.$7m.as(u.$8m.JSONContribution);n.registerSchema(t.$9u,e.getIconSchema());const g=new y.$Rg(()=>n.notifySchemaChanged(t.$9u),200);e.onDidChange(()=>{g.isScheduled()||g.schedule()}),t.$0u=a("widget-close",O.$Oj.close,(0,l.localize)(2,null)),t.$$u=a("goto-previous-location",O.$Oj.arrowUp,(0,l.localize)(3,null)),t.$_u=a("goto-next-location",O.$Oj.arrowDown,(0,l.localize)(4,null)),t.$av=i.ThemeIcon.modify(O.$Oj.sync,"spin"),t.$bv=i.ThemeIcon.modify(O.$Oj.loading,"spin")}),define(be[142],pe([1,0,4,3,2,18,141]),function(le,t,y,O,i,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$izb=t.$hzb=void 0;function w(u){const f=new i.$ic,P=f.add(new O.$ed),r=(0,D.$8u)();return f.add(r.onDidChange(()=>P.fire())),u&&f.add(u.onDidProductIconThemeChange(()=>P.fire())),{dispose:()=>f.dispose(),onDidChange:P.event,getCSS(){const h=u?u.getProductIconTheme():new l,e={},a=s=>{const n=h.getIcon(s);if(!n)return;const g=n.font;return g?(e[g.id]=g.definition,`.codicon-${s.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,y.$gP)(g.id)}; }`):`.codicon-${s.id}:before { content: '${n.fontCharacter}'; }`},o=[];for(const s of r.getIcons()){const n=a(s);n&&o.push(n)}for(const s in e){const n=e[s],g=n.weight?`font-weight: ${n.weight};`:"",b=n.style?`font-style: ${n.style};`:"",$=n.src.map(c=>`${(0,y.$fP)(c.location)} format('${c.format}')`).join(", ");o.push(`@font-face { src: ${$}; font-family: ${(0,y.$gP)(s)};${g}${b} font-display: block; }`)}return o.join(`
`)}}}t.$hzb=w;class l{getIcon(f){const P=(0,D.$8u)();let r=f.defaults;for(;_.ThemeIcon.isThemeIcon(r);){const h=P.getIcon(r.id);if(!h)return;r=h.defaults}return r}}t.$izb=l}),define(be[143],pe([1,0,5]),function(le,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TD=t.$SD=t.$RD=t.$QD=t.$PD=t.$OD=t.$ND=t.$MD=void 0,t.$MD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(f){return!!f.workspaceUri}t.$ND=O;function i(f){return!!f.folderUri}t.$OD=i;function _(f){return!!f.fileUri}t.$PD=_;function D(f){const P=w(f),r=f.getValue("window.menuBarVisibility");return r==="default"||P==="native"&&r==="compact"||y.$j&&y.$m?"classic":r}t.$QD=D;function w(f){if(y.$o)return"custom";const P=f.getValue("window");if(P){if(y.$j&&P.nativeTabs===!0||y.$j&&P.nativeFullScreen===!1)return"native";const e=P.titleBarStyle;if(e==="native"||e==="custom")return e}return y.$k?"native":"custom"}t.$RD=w;function l(f){return!(!y.$i||y.$o||w(f)==="native")}t.$SD=l;function u(f=0){return Math.pow(1.2,f)}t.$TD=u}),define(be[144],pe([1,0,16,29,143]),function(le,t,y,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$6b=t.$06b=t.$96b=void 0;function _(l){O.$O.setZoomLevel(l),(0,y.$UN)((0,i.$TD)(l)),(0,y.$RN)(l)}t.$96b=_;function D(){_((0,y.$SN)()+1)}t.$06b=D;function w(){_((0,y.$SN)()-1)}t.$$6b=w}),define(be[145],pe([1,0,10,4,130,9,131,29,135,136,138,139,142,144,14,101,92]),function(le,t,y,O,i,_,D,w,l,u,f,P,r,h,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,o=/\s--inspect-port=(?<port>\d+)/;class s{getHeight(M){return 22}getTemplateId(M){return T(M)?"process":F(M)?"machine":(0,l.$gm)(M)?"error":R(M)?"header":""}}class n{hasChildren(M){return(0,l.$gm)(M)?!1:T(M)?!!M.children?.length:!0}getChildren(M){return T(M)?M.children?M.children:[]:(0,l.$gm)(M)?[]:R(M)?M.processRoots.length>1?M.processRoots:[M.processRoots[0].rootProcess]:F(M)?[M.rootProcess]:[M.processes]}}class g{constructor(){this.templateId="header"}renderTemplate(M){const A=(0,O.$2O)(M,(0,O.$)(".row")),H=(0,O.$2O)(A,(0,O.$)(".nameLabel")),Q=(0,O.$2O)(A,(0,O.$)(".cpu")),ie=(0,O.$2O)(A,(0,O.$)(".memory")),re=(0,O.$2O)(A,(0,O.$)(".pid"));return{name:H,CPU:Q,memory:ie,PID:re}}renderElement(M,A,H,Q){H.name.textContent=(0,y.localize)(0,null),H.CPU.textContent=(0,y.localize)(1,null),H.PID.textContent=(0,y.localize)(2,null),H.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(M){}}class b{constructor(){this.templateId="machine"}renderTemplate(M){const A=Object.create(null),H=(0,O.$2O)(M,(0,O.$)(".row"));return A.name=(0,O.$2O)(H,(0,O.$)(".nameLabel")),A}renderElement(M,A,H,Q){H.name.textContent=M.element.name}disposeTemplate(M){}}class ${constructor(){this.templateId="error"}renderTemplate(M){const A=Object.create(null),H=(0,O.$2O)(M,(0,O.$)(".row"));return A.name=(0,O.$2O)(H,(0,O.$)(".nameLabel")),A}renderElement(M,A,H,Q){H.name.textContent=M.element.errorMessage}disposeTemplate(M){}}class c{constructor(M,A,H){this.a=M,this.b=A,this.c=H,this.templateId="process"}renderTemplate(M){const A=(0,O.$2O)(M,(0,O.$)(".row")),H=(0,O.$2O)(A,(0,O.$)(".nameLabel")),Q=(0,O.$2O)(A,(0,O.$)(".cpu")),ie=(0,O.$2O)(A,(0,O.$)(".memory")),re=(0,O.$2O)(A,(0,O.$)(".pid"));return{name:H,CPU:Q,PID:re,memory:ie}}renderElement(M,A,H,Q){const{element:ie}=M,re=ie.pid.toFixed(0);let ue=ie.name;this.c.has(ie.pid)&&(ue=this.c.get(ie.pid)),H.name.textContent=ue,H.name.title=ie.cmd,H.CPU.textContent=ie.load.toFixed(0),H.PID.textContent=re,H.PID.parentElement.id=`pid-${re}`;const he=this.a==="win32"?ie.mem:this.b*(ie.mem/100);H.memory.textContent=(he/u.$zk.MB).toFixed(0)}disposeTemplate(M){}}function F(U){return!!U.name&&!!U.rootProcess}function R(U){return!!U.processRoots}function T(U){return!!U.pid}class m{constructor(M,A){this.f=A,this.b=new Map;const H=new f.$66b(M);this.c=new P.$76b(M,H),this.k(A.styles),this.g(A),w.$M.on("vscode:pidToNameResponse",(Q,ie)=>{this.b=new Map;for(const[re,ue]of ie)this.b.set(re,ue)}),w.$M.on("vscode:listProcessesResponse",async(Q,ie)=>{ie.forEach((re,ue)=>{T(re.rootProcess)&&(re.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ie}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ie),this.m(0)}),this.a=Date.now(),w.$M.send("vscode:pidToNameRequest"),w.$M.send("vscode:listProcesses")}g(M){document.onkeydown=A=>{const H=M.platform==="darwin"?A.metaKey:A.ctrlKey;H&&A.keyCode===87&&(A.stopPropagation(),A.preventDefault(),w.$M.send("vscode:closeProcessExplorer")),H&&A.keyCode===187&&(0,h.$06b)(),H&&A.keyCode===189&&(0,h.$$6b)()}}async h(M){const A=document.getElementById("process-list");if(!A)return;const{totalmem:H}=await this.c.getOSStatistics(),Q=[new c(this.f.platform,H,this.b),new g,new b,new $];this.d=new i.$hS("processExplorer",A,new s,Q,new n,{identityProvider:{getId:ie=>T(ie)?ie.pid.toString():(0,l.$gm)(ie)?ie.hostName:R(ie)?"processes":F(ie)?ie.name:"header"}}),this.d.setInput({processes:{processRoots:M}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ie=>{const re=new e.$dO(ie);if(re.keyCode===35&&re.altKey){const ue=this.n();Promise.all(ue.map(he=>this.c.killProcess(he,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ie=>{T(ie.element)&&this.l(ie.element,!0)}),A.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{A.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(M){const A=a.exec(M);return A&&A.groups.port!=="0"||M.indexOf("node ")>=0||M.indexOf("node.exe")>=0}j(M){const A={type:"node",request:"attach",name:`process ${M.pid}`};let H=a.exec(M.cmd);H?A.port=Number(H.groups.port):A.processId=String(M.pid),H=o.exec(M.cmd),H&&(A.port=Number(H.groups.port)),w.$M.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[A]})}k(M){const A=(0,O.$PO)(),H=[];M.listFocusBackground&&(H.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${M.listFocusBackground}; }`),H.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${M.listFocusBackground}; }`)),M.listFocusForeground&&H.push(`.monaco-list:focus .monaco-list-row.focused { color: ${M.listFocusForeground}; }`),M.listActiveSelectionBackground&&(H.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${M.listActiveSelectionBackground}; }`),H.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${M.listActiveSelectionBackground}; }`)),M.listActiveSelectionForeground&&H.push(`.monaco-list:focus .monaco-list-row.selected { color: ${M.listActiveSelectionForeground}; }`),M.listHoverBackground&&H.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${M.listHoverBackground}; }`),M.listHoverForeground&&H.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${M.listHoverForeground}; }`),M.listFocusOutline&&H.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${M.listFocusOutline}; outline-offset: -1px; }`),M.listHoverOutline&&H.push(`.monaco-list-row:hover { outline: 1px dashed ${M.listHoverOutline}; outline-offset: -1px; }`),M.scrollbarShadowColor&&H.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${M.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),M.scrollbarSliderBackgroundColor&&H.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${M.scrollbarSliderBackgroundColor};
				}
			`),M.scrollbarSliderHoverBackgroundColor&&H.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${M.scrollbarSliderHoverBackgroundColor};
				}
			`),M.scrollbarSliderActiveBackgroundColor&&H.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${M.scrollbarSliderActiveBackgroundColor};
				}
			`),A.textContent=H.join(`
`),M.color&&(document.body.style.color=M.color)}l(M,A){const H=[],Q=Number(M.pid);A&&(H.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.c.killProcess(Q,"SIGTERM")}}),H.push({label:(0,y.localize)(5,null),click:()=>{this.c.killProcess(Q,"SIGKILL")}}),H.push({type:"separator"})),H.push({label:(0,y.localize)(6,null),click:()=>{const ie=this.n();ie?.includes(Q)||(ie.length=0,ie.push(Q));const re=ie?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(re){const ue=re.map(he=>he.innerText).filter(he=>!!he);this.c.writeClipboardText(ue.join(`
`))}}}),H.push({label:(0,y.localize)(7,null),click:()=>{const ie=document.getElementById("process-list");ie&&this.c.writeClipboardText(ie.innerText)}}),M&&A&&this.i(M.cmd)&&(H.push({type:"separator"}),H.push({label:(0,y.localize)(8,null),click:()=>{this.j(M)}})),(0,D.$LS)(H)}m(M){setTimeout(()=>{const A=Date.now(),H=M+A-this.a;this.a=A,H>1e3?(w.$M.send("vscode:pidToNameRequest"),w.$M.send("vscode:listProcesses")):this.m(H)},200)}n(){return this.d?.getSelection()?.map(M=>{if(!(!M||!("pid"in M)))return M.pid}).filter(M=>!!M)}}function v(){const U=(0,O.$PO)();U.id="codiconStyles";const M=(0,r.$hzb)(void 0);function A(){U.textContent=M.getCSS()}const H=new _.$Rg(A,0);M.onDidChange(()=>H.schedule()),H.schedule()}function z(U){const M=U.data.platform==="win32"?"windows":U.data.platform==="linux"?"linux":"mac";document.body.classList.add(M),v(),(0,h.$96b)(U.data.zoomLevel),new m(U.windowId,U.data)}t.startup=z})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f36df69328ed10f76d4be03e8a82b61794b49711/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
