/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class L{static get(){const R=new Map,A=new Map,N=new Map,y=new Map;function u(d,v){d.has(v.detail)||d.set(v.detail,-v.timestamp)}function l(d,v){const w=d.get(v.detail);w&&(w>=0||d.set(v.detail,w+v.timestamp))}let O=[];typeof J=="function"&&typeof J.getStats=="function"&&(O=J.getStats().slice(0).sort((d,v)=>d.timestamp-v.timestamp));for(const d of O)switch(d.type){case 10:u(R,d);break;case 11:case 12:l(R,d);break;case 21:u(A,d);break;case 22:l(A,d);break;case 33:u(N,d);break;case 34:l(N,d);break;case 31:u(y,d);break;case 32:l(y,d);break}let S=0;N.forEach(d=>S+=d);function g(d){const v=[];return d.forEach((w,$)=>v.push([$,w])),v}return{amdLoad:g(R),amdInvoke:g(A),nodeRequire:g(N),nodeEval:g(y),nodeRequireTotal:S}}static toMarkdownTable(R,A){let N="";const y=[];return R.forEach((u,l)=>{y[l]=u.length}),A.forEach(u=>{u.forEach((l,O)=>{typeof l>"u"&&(l=u[O]="-");const S=l.toString().length;y[O]=Math.max(S,y[O])})}),R.forEach((u,l)=>{N+=`| ${u+" ".repeat(y[l]-u.toString().length)} `}),N+=`|
`,R.forEach((u,l)=>{N+=`| ${"-".repeat(y[l])} `}),N+=`|
`,A.forEach(u=>{u.forEach((l,O)=>{typeof l<"u"&&(N+=`| ${l+" ".repeat(y[O]-l.toString().length)} `)}),N+=`|
`}),N}}e.$S=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function L(N){return(y,u,l)=>{let O=null,S=null;if(typeof l.value=="function"?(O="value",S=l.value):typeof l.get=="function"&&(O="get",S=l.get),!S)throw new Error("not supported");l[O]=N(S,u)}}function D(N,y,u){let l=null,O=null;if(typeof u.value=="function"?(l="value",O=u.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(l="get",O=u.get),!O)throw new Error("not supported");const S=`$memoize$${y}`;u[l]=function(...g){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,g)}),this[S]}}e.$5g=D;function R(N,y,u){return L((l,O)=>{const S=`$debounce$${O}`,g=`$debounce$result$${O}`;return function(...d){this[g]||(this[g]=u?u():void 0),clearTimeout(this[S]),y&&(this[g]=y(this[g],...d),d=[this[g]]),this[S]=setTimeout(()=>{l.apply(this,d),this[g]=u?u():void 0},N)}})}e.$6g=R;function A(N,y,u){return L((l,O)=>{const S=`$throttle$timer$${O}`,g=`$throttle$result$${O}`,d=`$throttle$lastRun$${O}`,v=`$throttle$pending$${O}`;return function(...w){if(this[g]||(this[g]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[g]=y(this[g],...w)),this[v])return;const $=this[d]+N;$<=Date.now()?(this[d]=Date.now(),l.apply(this,[this[g]]),this[g]=u?u():void 0):(this[v]=!0,this[S]=setTimeout(()=>{this[v]=!1,this[d]=Date.now(),l.apply(this,[this[g]]),this[g]=u?u():void 0},$-Date.now()))}})}e.$7g=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xc=e.$wc=e.$vc=e.$uc=e.ok=void 0;function D(u,l){if(!u)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=D;function R(u,l="Unreachable"){throw new Error(l)}e.$uc=R;function A(u){if(!u)throw new L.$ab("Assertion Failed")}e.$vc=A;function N(u){if(!u()){debugger;u(),(0,L.$Y)(new L.$ab("Assertion Failed"))}}e.$wc=N;function y(u,l){let O=0;for(;O<u.length-1;){const S=u[O],g=u[O+1];if(!l(S,g))return!1;O++}return!0}e.$xc=y}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(t,a=!1){let i=0;const s=t.length;let n="",r=0,c=16,I=0;function P(te){let ae=0,le=0;for(;ae<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,ae++}return ae<te&&(le=-1),le}function E(te){i=te,n="",r=0,c=16,I=0}function j(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return I=3,t.substring(te,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;ae=i}else I=3;return t.substring(te,ae)}function H(){let te="",ae=i;for(;;){if(i>=s){te+=t.substring(ae,i),I=2;break}const le=t.charCodeAt(i);if(le===34){te+=t.substring(ae,i),i++;break}if(le===92){if(te+=t.substring(ae,i),i++,i>=s){I=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const B=P(4);B>=0?te+=String.fromCharCode(B):I=4;break}default:I=5}ae=i;continue}if(le>=0&&le<=31)if(u(le)){te+=t.substring(ae,i),I=2;break}else I=6;i++}return te}function K(){if(n="",I=0,r=i,i>=s)return r=s,c=17;let te=t.charCodeAt(i);if(y(te)){do i++,n+=String.fromCharCode(te),te=t.charCodeAt(i);while(y(te));return c=15}if(u(te))return i++,n+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),c=14;switch(te){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,n=H(),c=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!u(t.charCodeAt(i));)i++;return n=t.substring(ae,i),c=12}if(t.charCodeAt(i+1)===42){i+=2;const le=s-1;let ie=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,I=1),n=t.substring(ae,i),c=13}return n+=String.fromCharCode(te),i++,c=16}case 45:if(n+=String.fromCharCode(te),i++,i===s||!l(t.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=j(),c=11;default:for(;i<s&&_(te);)i++,te=t.charCodeAt(i);if(r!==i){switch(n=t.substring(r,i),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(te),i++,c=16}}function _(te){if(y(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=K();while(te>=12&&te<=15);return te}return{setPosition:E,getPosition:()=>i,scan:a?ue:K,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>I}}e.$Im=N;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function S(t,a){const i=[],s=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function I(P,E,j,H){r.value=P,r.offset=E,r.length=j,r.type=H,r.colonOffset=void 0,n=r}try{k(t,{onObjectBegin:(P,E)=>{if(a<=P)throw s;n=void 0,c=a>P,i.push("")},onObjectProperty:(P,E,j)=>{if(a<E||(I(P,E,j,"property"),i[i.length-1]=P,a<=E+j))throw s},onObjectEnd:(P,E)=>{if(a<=P)throw s;n=void 0,i.pop()},onArrayBegin:(P,E)=>{if(a<=P)throw s;n=void 0,i.push(0)},onArrayEnd:(P,E)=>{if(a<=P)throw s;n=void 0,i.pop()},onLiteralValue:(P,E,j)=>{if(a<E||(I(P,E,j,b(P)),a<=E+j))throw s},onSeparator:(P,E,j)=>{if(a<=E)throw s;if(P===":"&&n&&n.type==="property")n.colonOffset=E,c=!1,n=void 0;else if(P===","){const H=i[i.length-1];typeof H=="number"?i[i.length-1]=H+1:(c=!0,i[i.length-1]=""),n=void 0}}})}catch(P){if(P!==s)throw P}return{path:i,previousNode:n,isAtPropertyKey:c,matches:P=>{let E=0;for(let j=0;E<P.length&&j<i.length;j++)if(P[E]===i[j]||P[E]==="*")E++;else if(P[E]!=="**")return!1;return E===P.length}}}e.$Jm=S;function g(t,a=[],i=A.DEFAULT){let s=null,n=[];const r=[];function c(P){Array.isArray(n)?n.push(P):s!==null&&(n[s]=P)}return k(t,{onObjectBegin:()=>{const P={};c(P),r.push(n),n=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const P=[];c(P),r.push(n),n=P,s=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:c,onError:(P,E,j)=>{a.push({error:P,offset:E,length:j})}},i),n[0]}e.$Km=g;function d(t,a=[],i=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function r(P){return s.children.push(P),P}k(t,{onObjectBegin:P=>{s=r({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,E,j)=>{s=r({type:"property",offset:E,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:E,length:j,parent:s})},onObjectEnd:(P,E)=>{s.length=P+E-s.offset,s=s.parent,n(P+E)},onArrayBegin:(P,E)=>{s=r({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,E)=>{s.length=P+E-s.offset,s=s.parent,n(P+E)},onLiteralValue:(P,E,j)=>{r({type:b(P),offset:E,length:j,parent:s,value:P}),n(E+j)},onSeparator:(P,E,j)=>{s.type==="property"&&(P===":"?s.colonOffset=E:P===","&&n(E))},onError:(P,E,j)=>{a.push({error:P,offset:E,length:j})}},i);const I=s.children[0];return I&&delete I.parent,I}e.$Lm=d;function v(t,a){if(!t)return;let i=t;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===s){i=r.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.$Mm=v;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.$Nm=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const a=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(a[i.children[0].value]=$(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Om=$;function h(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.$Pm=h;function f(t,a,i=!1){if(h(t,a,i)){const s=t.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=a;n++){const r=f(s[n],a,i);if(r)return r}return t}}e.$Qm=f;function k(t,a,i=A.DEFAULT){const s=N(t,!1);function n(Y){return Y?()=>Y(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(Y){return Y?x=>Y(x,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=n(a.onObjectBegin),I=r(a.onObjectProperty),P=n(a.onObjectEnd),E=n(a.onArrayBegin),j=n(a.onArrayEnd),H=r(a.onLiteralValue),K=r(a.onSeparator),_=n(a.onComment),ue=r(a.onError),te=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function le(){for(;;){const Y=s.scan();switch(s.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Y){case 12:case 13:te?ie(10):_();break;case 16:ie(1);break;case 15:case 14:break;default:return Y}}}function ie(Y,x=[],F=[]){if(ue(Y),x.length+F.length>0){let z=s.getToken();for(;z!==17;){if(x.indexOf(z)!==-1){le();break}else if(F.indexOf(z)!==-1)break;z=le()}}}function B(Y){const x=s.getTokenValue();return Y?H(x):I(x),le(),!0}function G(){switch(s.getToken()){case 11:{let Y=0;try{Y=JSON.parse(s.getTokenValue()),typeof Y!="number"&&(ie(2),Y=0)}catch{ie(2)}H(Y);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return le(),!0}function T(){return s.getToken()!==10?(ie(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(K(":"),le(),X()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function U(){c(),le();let Y=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Y||ie(4,[],[]),K(","),le(),s.getToken()===2&&ae)break}else Y&&ie(6,[],[]);T()||ie(4,[],[2,5]),Y=!0}return P(),s.getToken()!==2?ie(7,[2],[]):le(),!0}function q(){E(),le();let Y=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Y||ie(4,[],[]),K(","),le(),s.getToken()===4&&ae)break}else Y&&ie(6,[],[]);X()||ie(4,[],[4,5]),Y=!0}return j(),s.getToken()!==4?ie(8,[4],[]):le(),!0}function X(){switch(s.getToken()){case 3:return q();case 1:return U();case 10:return B(!0);default:return G()}}return le(),s.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):X()?(s.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Rm=k;function p(t,a){const i=N(t),s=[];let n,r=0,c;do switch(c=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:r!==c&&s.push(t.substring(r,c)),a!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,a)),r=i.getPosition();break}while(n!==17);return s.join("")}e.$Sm=p;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=b}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.rot=e.$Gl=void 0;function L(y,u,l){return Math.min(Math.max(y,u),l)}e.$Gl=L;function D(y,u){return(u+y%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Il=R;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jl=A;class N{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const l=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Kl=N}),function(){function J(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function N(u){A.push(u,Date.now())}function y(){const u=[];for(let l=0;l<A.length;l+=2)u.push({name:A[l],startTime:A[l+1]});return u}return{mark:N,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(R+N.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(D,R,A){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:A})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var N in D)L.d(A,N,function(y){return D[y]}.bind(null,N));return A},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var R;e=J.exports=F,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],u=e.src=[],l=0,O=l++;u[O]="0|[1-9]\\d*";var S=l++;u[S]="[0-9]+";var g=l++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=l++;u[d]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var v=l++;u[v]="("+u[S]+")\\.("+u[S]+")\\.("+u[S]+")";var w=l++;u[w]="(?:"+u[O]+"|"+u[g]+")";var $=l++;u[$]="(?:"+u[S]+"|"+u[g]+")";var h=l++;u[h]="(?:-("+u[w]+"(?:\\."+u[w]+")*))";var f=l++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var k=l++;u[k]="[0-9A-Za-z-]+";var p=l++;u[p]="(?:\\+("+u[k]+"(?:\\."+u[k]+")*))";var b=l++,t="v?"+u[d]+u[h]+"?"+u[p]+"?";u[b]="^"+t+"$";var a="[v=\\s]*"+u[v]+u[f]+"?"+u[p]+"?",i=l++;u[i]="^"+a+"$";var s=l++;u[s]="((?:<|>)?=?)";var n=l++;u[n]=u[S]+"|x|X|\\*";var r=l++;u[r]=u[O]+"|x|X|\\*";var c=l++;u[c]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var I=l++;u[I]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var P=l++;u[P]="^"+u[s]+"\\s*"+u[c]+"$";var E=l++;u[E]="^"+u[s]+"\\s*"+u[I]+"$";var j=l++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=l++;u[H]="(?:~>?)";var K=l++;u[K]="(\\s*)"+u[H]+"\\s+",y[K]=new RegExp(u[K],"g");var _=l++;u[_]="^"+u[H]+u[c]+"$";var ue=l++;u[ue]="^"+u[H]+u[I]+"$";var te=l++;u[te]="(?:\\^)";var ae=l++;u[ae]="(\\s*)"+u[te]+"\\s+",y[ae]=new RegExp(u[ae],"g");var le=l++;u[le]="^"+u[te]+u[c]+"$";var ie=l++;u[ie]="^"+u[te]+u[I]+"$";var B=l++;u[B]="^"+u[s]+"\\s*("+a+")$|^$";var G=l++;u[G]="^"+u[s]+"\\s*("+t+")$|^$";var T=l++;u[T]="(\\s*)"+u[s]+"\\s*("+a+"|"+u[c]+")",y[T]=new RegExp(u[T],"g");var U=l++;u[U]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var q=l++;u[q]="^\\s*("+u[I]+")\\s+-\\s+("+u[I]+")\\s*$";var X=l++;u[X]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)R(Y,u[Y]),y[Y]||(y[Y]=new RegExp(u[Y]));function x(V,Q){if(V instanceof F)return V;if(typeof V!="string"||V.length>A||!(Q?y[i]:y[b]).test(V))return null;try{return new F(V,Q)}catch{return null}}function F(V,Q){if(V instanceof F){if(V.loose===Q)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(V,Q);R("SemVer",V,Q),this.loose=Q;var ee=V.trim().match(Q?y[i]:y[b]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<N)return ye}return me}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=x,e.valid=function(V,Q){var ee=x(V,Q);return ee?ee.version:null},e.clean=function(V,Q){var ee=x(V.trim().replace(/^[=v]+/,""),Q);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),o(this.major,V.major)||o(this.minor,V.minor)||o(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Q=0;do{var ee=this.prerelease[Q],me=V.prerelease[Q];if(R("prerelease compare",Q,ee,me),ee===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(ee===void 0)return-1;if(ee!==me)return o(ee,me)}while(++Q)},F.prototype.inc=function(V,Q){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Q,ee,me){typeof ee=="string"&&(me=ee,ee=void 0);try{return new F(V,ee).inc(Q,me).version}catch{return null}},e.diff=function(V,Q){if(Z(V,Q))return null;var ee=x(V),me=x(Q);if(ee.prerelease.length||me.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==me[ye])return ye},e.compareIdentifiers=o;var z=/^[0-9]+$/;function o(V,Q){var ee=z.test(V),me=z.test(Q);return ee&&me&&(V=+V,Q=+Q),ee&&!me?-1:me&&!ee?1:V<Q?-1:V>Q?1:0}function m(V,Q,ee){return new F(V,ee).compare(new F(Q,ee))}function M(V,Q,ee){return m(V,Q,ee)>0}function C(V,Q,ee){return m(V,Q,ee)<0}function Z(V,Q,ee){return m(V,Q,ee)===0}function W(V,Q,ee){return m(V,Q,ee)!==0}function ce(V,Q,ee){return m(V,Q,ee)>=0}function oe(V,Q,ee){return m(V,Q,ee)<=0}function pe(V,Q,ee,me){var ye;switch(Q){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=Z(V,ee,me);break;case"!=":ye=W(V,ee,me);break;case">":ye=M(V,ee,me);break;case">=":ye=ce(V,ee,me);break;case"<":ye=C(V,ee,me);break;case"<=":ye=oe(V,ee,me);break;default:throw new TypeError("Invalid operator: "+Q)}return ye}function de(V,Q){if(V instanceof de){if(V.loose===Q)return V;V=V.value}if(!(this instanceof de))return new de(V,Q);R("comparator",V,Q),this.loose=Q,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Q){return o(Q,V)},e.major=function(V,Q){return new F(V,Q).major},e.minor=function(V,Q){return new F(V,Q).minor},e.patch=function(V,Q){return new F(V,Q).patch},e.compare=m,e.compareLoose=function(V,Q){return m(V,Q,!0)},e.rcompare=function(V,Q,ee){return m(Q,V,ee)},e.sort=function(V,Q){return V.sort(function(ee,me){return e.compare(ee,me,Q)})},e.rsort=function(V,Q){return V.sort(function(ee,me){return e.rcompare(ee,me,Q)})},e.gt=M,e.lt=C,e.eq=Z,e.neq=W,e.gte=ce,e.lte=oe,e.cmp=pe,e.Comparator=de;var ge={};function fe(V,Q){if(V instanceof fe)return V.loose===Q?V:new fe(V.raw,Q);if(V instanceof de)return new fe(V.value,Q);if(!(this instanceof fe))return new fe(V,Q);if(this.loose=Q,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Q,ee,me,ye,je,Se,Le,Ie,Ae,Fe,Oe,Ne){return((Q=he(ee)?"":he(me)?">="+ee+".0.0":he(ye)?">="+ee+"."+me+".0":">="+Q)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Fe)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Fe+"-"+Oe:"<="+Le)).trim()}function be(V,Q){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Q))return!1;if(Q.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var me=V[ee].semver;if(me.major===Q.major&&me.minor===Q.minor&&me.patch===Q.patch)return!0}return!1}return!0}function ke(V,Q,ee){try{Q=new fe(Q,ee)}catch{return!1}return Q.test(V)}function Me(V,Q,ee,me){var ye,je,Se,Le,Ie;switch(V=new F(V,me),Q=new fe(Q,me),ee){case">":ye=M,je=oe,Se=C,Le=">",Ie=">=";break;case"<":ye=C,je=ce,Se=M,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,Q,me))return!1;for(var Ae=0;Ae<Q.set.length;++Ae){var Fe=Q.set[Ae],Oe=null,Ne=null;if(Fe.forEach(function(De){De.semver===ge&&(De=new de(">=0.0.0")),Oe=Oe||De,Ne=Ne||De,ye(De.semver,Oe.semver,me)?Oe=De:Se(De.semver,Ne.semver,me)&&(Ne=De)}),Oe.operator===Le||Oe.operator===Ie||(!Ne.operator||Ne.operator===Le)&&je(V,Ne.semver)||Ne.operator===Ie&&Se(V,Ne.semver))return!1}return!0}de.prototype.parse=function(V){var Q=this.loose?y[B]:y[G],ee=V.match(Q);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new F(V,this.loose)),pe(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Q){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Q),ke(this.value,ee,Q);if(V.operator==="")return ee=new fe(this.value,Q),ke(V.semver,ee,Q);var me=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),je=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=pe(this.semver,"<",V.semver,Q)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=pe(this.semver,">",V.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return me||ye||je&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Q=this.loose;V=V.trim(),R("range",V,Q);var ee=Q?y[q]:y[U];V=V.replace(ee,we),R("hyphen replace",V),V=V.replace(y[T],"$1$2$3"),R("comparator trim",V,y[T]),V=(V=(V=V.replace(y[K],"$1~")).replace(y[ae],"$1^")).split(/\s+/).join(" ");var me=Q?y[B]:y[G],ye=V.split(" ").map(function(je){return function(Se,Le){return R("comp",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Fe){return function(Oe,Ne){R("caret",Oe,Ne);var De=Ne?y[ie]:y[le];return Oe.replace(De,function(Ue,ve,Ee,Pe,Re){var ze;return R("caret",Oe,Ue,ve,Ee,Pe,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),R("caret",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Fe){return function(Oe,Ne){var De=Ne?y[ue]:y[_];return Oe.replace(De,function(Ue,ve,Ee,Pe,Re){var ze;return R("tilde",Oe,Ue,ve,Ee,Pe,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),R("tildes",Se),Se=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Fe){return function(Oe,Ne){Oe=Oe.trim();var De=Ne?y[E]:y[P];return Oe.replace(De,function(Ue,ve,Ee,Pe,Re,ze){R("xRange",Oe,Ue,ve,Ee,Pe,Re,ze);var Be=he(Ee),Ce=Be||he(Pe),Te=Ce||he(Re);return ve==="="&&Te&&(ve=""),Be?Ue=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(Pe=0),Te&&(Re=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,Pe=0,Re=0):Te&&(Pe=+Pe+1,Re=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:Pe=+Pe+1),Ue=ve+Ee+"."+Pe+"."+Re):Ce?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ue=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Ue),Ue})}(Fe,Ae)}).join(" ")}(Se,Le),R("xrange",Se),Se=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(y[X],"")}(Se,Le),R("stars",Se),Se}(je,Q)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(je){return!!je.match(me)})),ye=ye.map(function(je){return new de(je,Q)})},fe.prototype.intersects=function(V,Q){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(me){return V.set.some(function(ye){return ye.every(function(je){return me.intersects(je,Q)})})})})},e.toComparators=function(V,Q){return new fe(V,Q).set.map(function(ee){return ee.map(function(me){return me.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var Q=0;Q<this.set.length;Q++)if(be(this.set[Q],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,Q,ee){var me=null,ye=null;try{var je=new fe(Q,ee)}catch{return null}return V.forEach(function(Se){je.test(Se)&&(me&&ye.compare(Se)!==-1||(ye=new F(me=Se,ee)))}),me},e.minSatisfying=function(V,Q,ee){var me=null,ye=null;try{var je=new fe(Q,ee)}catch{return null}return V.forEach(function(Se){je.test(Se)&&(me&&ye.compare(Se)!==1||(ye=new F(me=Se,ee)))}),me},e.validRange=function(V,Q){try{return new fe(V,Q).range||"*"}catch{return null}},e.ltr=function(V,Q,ee){return Me(V,Q,"<",ee)},e.gtr=function(V,Q,ee){return Me(V,Q,">",ee)},e.outside=Me,e.prerelease=function(V,Q){var ee=x(V,Q);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Q,ee){return V=new fe(V,ee),Q=new fe(Q,ee),V.intersects(Q)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var Q=V.match(y[j]);return Q==null?null:x((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,R=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function y($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{D=typeof clearTimeout=="function"?clearTimeout:N}catch{D=N}})();var u,l=[],O=!1,S=-1;function g(){O&&u&&(O=!1,u.length?l=u.concat(l):S=-1,l.length&&d())}function d(){if(!O){var $=y(g);O=!0;for(var h=l.length;h;){for(u=l,l=[];++S<h;)u&&u[S].run();S=-1,h=l.length}u=null,O=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===N||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}($)}}function v($,h){this.fun=$,this.array=h}function w(){}R.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];l.push(new v($,h)),l.length!==1||O||y(d)},v.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=w,R.addListener=w,R.once=w,R.off=w,R.removeListener=w,R.removeAllListeners=w,R.emit=w,R.prependListener=w,R.prependOnceListener=w,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class D{constructor(y,u,l){this.level=y,this.key=u,this.value=l,this.forward=[]}}const R=void 0;class A{constructor(y,u=2**16){this.comparator=y,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R)}has(y){return!!A.g(this,y,this.comparator)}get(y){return A.g(this,y,this.comparator)?.value}set(y,u){return A.h(this,y,u,this.comparator)&&(this.f+=1),this}delete(y){const u=A.k(this,y,this.comparator);return u&&(this.f-=1),u}forEach(y,u){let l=this.e.forward[0];for(;l;)y.call(u,l.value,l.key,this),l=l.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this.e.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this.e.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this.e.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",u=this.e.forward[0];for(;u;)y+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return y}static g(y,u,l){let O=y.e;for(let S=y.d-1;S>=0;S--)for(;O.forward[S]&&l(O.forward[S].key,u)<0;)O=O.forward[S];if(O=O.forward[0],O&&l(O.key,u)===0)return O}static h(y,u,l,O){const S=[];let g=y.e;for(let d=y.d-1;d>=0;d--){for(;g.forward[d]&&O(g.forward[d].key,u)<0;)g=g.forward[d];S[d]=g}if(g=g.forward[0],g&&O(g.key,u)===0)return g.value=l,!1;{const d=A.j(y);if(d>y.d){for(let v=y.d;v<d;v++)S[v]=y.e;y.d=d}g=new D(d,u,l);for(let v=0;v<d;v++)g.forward[v]=S[v].forward[v],S[v].forward[v]=g;return!0}}static j(y,u=.5){let l=1;for(;Math.random()<u&&l<y.c;)l+=1;return l}static k(y,u,l){const O=[];let S=y.e;for(let g=y.d-1;g>=0;g--){for(;S.forward[g]&&l(S.forward[g].key,u)<0;)S=S.forward[g];O[g]=S}if(S=S.forward[0],!S||l(S.key,u)!==0)return!1;for(let g=0;g<y.d&&O[g].forward[g]===S;g++)O[g].forward[g]=S.forward[g];for(;y.d>0&&y.e.forward[y.d-1]===R;)y.d-=1;return!0}}e.$mr=A}),define(ne[41],re([0,1,9,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function R(p){const b=p;return b?typeof b.read=="function":!1}e.$pd=R;function A(p){const b=p;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.$qd=A;function N(p){const b=p;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.$rd=N;function y(p,b){return new u(p,b)}e.$sd=y;class u{constructor(b,t){this.e=b,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(t=>t(b))}h(b){this.c.error.length===0?(0,L.$Y)(b):this.c.error.slice(0).forEach(t=>t(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,t){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(b,t){if(this.a.destroyed)return;let a;switch(b){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(p,b){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return b(t)}e.$td=l;function O(p,b,t){const a=[];let i;for(;(i=p.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return p.read()}}}e.$ud=O;function S(p,b){return new Promise((t,a)=>{const i=[];g(p,{onData:s=>{b&&i.push(s)},onError:s=>{b?a(s):t(void 0)},onEnd:()=>{t(b?b(i):void 0)}})})}e.$vd=S;function g(p,b,t){p.on("error",a=>{t?.isCancellationRequested||b.onError(a)}),p.on("end",()=>{t?.isCancellationRequested||b.onEnd()}),p.on("data",a=>{t?.isCancellationRequested||b.onData(a)})}e.$wd=g;function d(p,b){return new Promise((t,a)=>{const i=new D.$ic,s=[],n=I=>{if(s.push(I),s.length>b)return i.dispose(),p.pause(),t({stream:p,buffer:s,ended:!1})},r=I=>(i.dispose(),a(I)),c=()=>(i.dispose(),t({stream:p,buffer:s,ended:!0}));i.add((0,D.$hc)(()=>p.removeListener("error",r))),p.on("error",r),i.add((0,D.$hc)(()=>p.removeListener("end",c))),p.on("end",c),i.add((0,D.$hc)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$xd=d;function v(p,b){const t=y(b);return t.end(p),t}e.$yd=v;function w(){const p=y(()=>{throw new Error("not supported")});return p.end(),p}e.$zd=w;function $(p){let b=!1;return{read:()=>b?null:(b=!0,p)}}e.$Ad=$;function h(p,b,t){const a=y(t);return g(p,{onData:i=>a.write(b.data(i)),onError:i=>a.error(b.error?b.error(i):i),onEnd:()=>a.end()}),a}e.$Bd=h;function f(p,b,t){let a=!1;return{read:()=>{const i=b.read();return a?i:(a=!0,i!==null?t([p,i]):p)}}}e.$Cd=f;function k(p,b,t){let a=!1;const i=y(t);return g(b,{onData:s=>a?i.write(s):(a=!0,i.write(t([p,s]))),onError:s=>i.error(s),onEnd:()=>{a||(a=!0,i.write(p)),i.end()}}),i}e.$Dd=k}),define(ne[14],re([0,1,164,41]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const R=typeof Buffer<"u",A=new L.$T(()=>new Uint8Array(256));let N,y;class u{static alloc(j){return R?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,H){return!(H?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(j)):(N||(N=new TextEncoder),new u(N.encode(j)))}static fromByteArray(j){const H=u.alloc(j.length);for(let K=0,_=j.length;K<_;K++)H.buffer[K]=j[K];return H}static concat(j,H){if(typeof H>"u"){H=0;for(let ue=0,te=j.length;ue<te;ue++)H+=j[ue].byteLength}const K=u.alloc(H);let _=0;for(let ue=0,te=j.length;ue<te;ue++){const ae=j[ue];K.set(ae,_),_+=ae.byteLength}return K}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(j,H){return new u(this.buffer.subarray(j,H))}set(j,H){if(j instanceof u)this.buffer.set(j.buffer,H);else if(j instanceof Uint8Array)this.buffer.set(j,H);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),H);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return g(this.buffer,j)}writeUInt32BE(j,H){d(this.buffer,j,H)}readUInt32LE(j){return v(this.buffer,j)}writeUInt32LE(j,H){w(this.buffer,j,H)}readUInt8(j){return $(this.buffer,j)}writeUInt8(j,H){h(this.buffer,j,H)}indexOf(j,H=0){return l(this.buffer,j instanceof u?j.buffer:j,H)}}e.$Ed=u;function l(E,j,H=0){const K=j.byteLength,_=E.byteLength;if(K===0)return 0;if(K===1)return E.indexOf(j[0]);if(K>_-H)return-1;const ue=A.value;ue.fill(j.length);for(let ie=0;ie<j.length;ie++)ue[j[ie]]=j.length-ie-1;let te=H+j.length-1,ae=te,le=-1;for(;te<_;)if(E[te]===j[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(j.length-ae,ue[E[te]]),ae=j.length-1;return le}e.$Fd=l;function O(E,j){return E[j+0]<<0>>>0|E[j+1]<<8>>>0}e.$Gd=O;function S(E,j,H){E[H+0]=j&255,j=j>>>8,E[H+1]=j&255}e.$Hd=S;function g(E,j){return E[j]*2**24+E[j+1]*2**16+E[j+2]*2**8+E[j+3]}e.$Id=g;function d(E,j,H){E[H+3]=j,j=j>>>8,E[H+2]=j,j=j>>>8,E[H+1]=j,j=j>>>8,E[H]=j}e.$Jd=d;function v(E,j){return E[j+0]<<0>>>0|E[j+1]<<8>>>0|E[j+2]<<16>>>0|E[j+3]<<24>>>0}e.$Kd=v;function w(E,j,H){E[H+0]=j&255,j=j>>>8,E[H+1]=j&255,j=j>>>8,E[H+2]=j&255,j=j>>>8,E[H+3]=j&255}e.$Ld=w;function $(E,j){return E[j]}e.$Md=$;function h(E,j,H){E[H]=j}e.$Nd=h;function f(E){return D.$td(E,j=>u.concat(j))}e.$Od=f;function k(E){return D.$Ad(E)}e.$Pd=k;function p(E){return D.$vd(E,j=>u.concat(j))}e.$Qd=p;async function b(E){return E.ended?u.concat(E.buffer):u.concat([...E.buffer,await p(E.stream)])}e.$Rd=b;function t(E){return D.$yd(E,j=>u.concat(j))}e.$Sd=t;function a(E){return D.$Bd(E,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$Td=a;function i(E){return D.$sd(j=>u.concat(j),E)}e.$Ud=i;function s(E,j){return D.$Cd(E,j,H=>u.concat(H))}e.$Vd=s;function n(E,j){return D.$Dd(E,j,H=>u.concat(H))}e.$Wd=n;function r(E){let j=0,H=0,K=0;const _=new Uint8Array(Math.floor(E.length/4*3)),ue=ae=>{switch(H){case 3:_[K++]=j|ae,H=0;break;case 2:_[K++]=j|ae>>>2,j=ae<<6,H=3;break;case 1:_[K++]=j|ae>>>4,j=ae<<4,H=2;break;default:j=ae<<2,H=1}};for(let ae=0;ae<E.length;ae++){const le=E.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ae]}`)}}const te=K;for(;H>0;)ue(0);return u.wrap(_).slice(0,te)}e.$Xd=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:E},j=!0,H=!1){const K=H?I:c;let _="";const ue=E.byteLength%3;let te=0;for(;te<E.byteLength-ue;te+=3){const ae=E[te+0],le=E[te+1],ie=E[te+2];_+=K[ae>>>2],_+=K[(ae<<4|le>>>4)&63],_+=K[(le<<2|ie>>>6)&63],_+=K[ie&63]}if(ue===1){const ae=E[te+0];_+=K[ae>>>2],_+=K[ae<<4&63],j&&(_+="==")}else if(ue===2){const ae=E[te+0],le=E[te+1];_+=K[ae>>>2],_+=K[(ae<<4|le>>>4)&63],_+=K[le<<2&63],j&&(_+="=")}return _}e.$Yd=P}),define(ne[42],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0;function D(h){return R(h,0)}e.$oi=D;function R(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):l(h,f);case"string":return y(h,f);case"boolean":return N(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$pi=R;function A(h,f){return(f<<5)-f+h|0}e.$qi=A;function N(h,f){return A(h?433:863,f)}function y(h,f){f=A(149417,f);for(let k=0,p=h.length;k<p;k++)f=A(h.charCodeAt(k),f);return f}e.$ri=y;function u(h,f){return f=A(104579,f),h.reduce((k,p)=>R(p,k),f)}function l(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((k,p)=>(k=y(p,k),R(h[p],k)),f)}class O{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=R(f,this.g),this.g}}e.$si=O;var S;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function g(h,f,k=32){const p=k-f,b=~((1<<p)-1);return(h<<f|(b&h)>>>p)>>>0}function d(h,f=0,k=h.byteLength,p=0){for(let b=0;b<k;b++)h[f+b]=p}function v(h,f,k="0"){for(;h.length<f;)h=k+h;return h}function w(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(k=>k.toString(16).padStart(2,"0")).join(""):v((h>>>0).toString(16),f/4)}e.$ti=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const k=f.length;if(k===0)return;const p=this.p;let b=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=f.charCodeAt(0),i=0);;){let s=a;if(L.$Pe(a))if(i+1<k){const n=f.charCodeAt(i+1);L.$Qe(n)?(i++,s=L.$Re(a,n)):s=65533}else{t=a;break}else L.$Qe(a)&&(s=65533);if(b=this.w(p,b,s),i++,i<k)a=f.charCodeAt(i);else break}this.r=b,this.u=t}w(f,k,p){return p<128?f[k++]=p:p<2048?(f[k++]=192|(p&1984)>>>6,f[k++]=128|(p&63)>>>0):p<65536?(f[k++]=224|(p&61440)>>>12,f[k++]=128|(p&4032)>>>6,f[k++]=128|(p&63)>>>0):(f[k++]=240|(p&1835008)>>>18,f[k++]=128|(p&258048)>>>12,f[k++]=128|(p&4032)>>>6,f[k++]=128|(p&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,k=this.q;for(let c=0;c<64;c+=4)f.setUint32(c,k.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)f.setUint32(c,g(f.getUint32(c-12,!1)^f.getUint32(c-32,!1)^f.getUint32(c-56,!1)^f.getUint32(c-64,!1),1),!1);let p=this.h,b=this.l,t=this.m,a=this.n,i=this.o,s,n,r;for(let c=0;c<80;c++)c<20?(s=b&t|~b&a,n=1518500249):c<40?(s=b^t^a,n=1859775393):c<60?(s=b&t|b&a|t&a,n=2400959708):(s=b^t^a,n=3395469782),r=g(p,5)+s+i+n+f.getUint32(c*4,!1)&4294967295,i=a,a=t,t=g(b,30),b=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+b&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.$ui=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const A="error",N="warning",y="warn",u="info",l="ignore";function O(g){return g?L.$Le(A,g)?R.Error:L.$Le(N,g)||L.$Le(y,g)?R.Warning:L.$Le(u,g)?R.Info:R.Ignore:R.Ignore}R.fromValue=O;function S(g){switch(g){case R.Error:return A;case R.Warning:return N;case R.Info:return u;default:return l}}R.toString=S}(D||(D={})),e.default=D}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([k,p])=>{f[k]=p&&typeof p=="object"?D(p):p}),f}e.$Um=D;function R(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const k=f.shift();Object.freeze(k);for(const p in k)if(A.call(k,p)){const b=k[p];typeof b=="object"&&!Object.isFrozen(b)&&!(0,L.$lf)(b)&&f.push(b)}}return h}e.$Vm=R;const A=Object.prototype.hasOwnProperty;function N(h,f){return y(h,f,new Set)}e.$Wm=N;function y(h,f,k){if((0,L.$rf)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const b=[];for(const t of h)b.push(y(t,f,k));return b}if((0,L.$kf)(h)){if(k.has(h))throw new Error("Cannot clone recursive data-structure");k.add(h);const b={};for(const t in h)A.call(h,t)&&(b[t]=y(h[t],f,k));return k.delete(h),b}return h}function u(h,f,k=!0){return(0,L.$kf)(h)?((0,L.$kf)(f)&&Object.keys(f).forEach(p=>{p in h?k&&((0,L.$kf)(h[p])&&(0,L.$kf)(f[p])?u(h[p],f[p],k):h[p]=f[p]):h[p]=f[p]}),h):f}e.$Xm=u;function l(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let k,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(k=0;k<h.length;k++)if(!l(h[k],f[k]))return!1}else{const b=[];for(p in h)b.push(p);b.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!l(b,t))return!1;for(k=0;k<b.length;k++)if(!l(h[b[k]],f[b[k]]))return!1}return!0}e.$Ym=l;function O(h){const f=new Set;return JSON.stringify(h,(k,p)=>{if((0,L.$kf)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$Zm=O;function S(h,f){const k=Object.create(null);return!h||!f||Object.keys(f).forEach(b=>{const t=h[b],a=f[b];l(t,a)||(k[b]=a)}),k}e.$1m=S;function g(h,f){const k=f.toLowerCase(),p=Object.keys(h).find(b=>b.toLowerCase()===k);return p?h[p]:h[f]}e.$2m=g;function d(h,f){const k=Object.create(null);for(const[p,b]of Object.entries(h))f(p,b)&&(k[p]=b);return k}e.$3m=d;function v(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$4m=v;function w(h){const f=[];for(const k of v(h))typeof h[k]=="function"&&f.push(k);return f}e.$5m=w;function $(h,f){const k=b=>function(){const t=Array.prototype.slice.call(arguments,0);return f(b,t)},p={};for(const b of h)p[b]=k(b);return p}e.$6m=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$2f=D,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let u=0;u<y.length;u++)y[u]=Math.floor(Math.random()*256);return y};const A=new Uint8Array(16),N=[];for(let y=0;y<256;y++)N.push(y.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,l="";return l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+="-",l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l+=N[A[u++]],l}}()}),define(ne[74],re([0,1,32]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(N){const y=N.replace(/\-/g,":").toLowerCase();return!D.has(y)}function A(){const N=(0,L.networkInterfaces)();for(const y in N){const u=N[y];if(u){for(const{mac:l}of u)if(R(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Fm=A}),define(ne[75],re([0,1,32,46,28,74]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Gm=new class{c(l){return this.a||(this.a=D.$Gh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,O=0;const S=(0,L.networkInterfaces)();for(const g in S){const d=S[g];if(d)for(const{mac:v,internal:w}of d)w||(O+=1,this.c(v.toUpperCase())&&(l+=1))}this.b=O>0?l/O:0}return this.b}};let N;async function y(l){return N||(N=(async()=>await u(l)||R.$3f())()),N}e.$Hm=y;async function u(l){try{const O=await new Promise((g,d)=>{J(["crypto"],g,d)}),S=(0,A.$Fm)();return O.createHash("sha256").update(S,"utf8").digest("hex")}catch(O){l(O);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const D=60,R=D*60,A=R*24,N=A*7,y=A*30,u=A*365;function l(S,g,d,v){typeof S!="number"&&(S=S.getTime());const w=Math.round((new Date().getTime()-S)/1e3);if(w<-30)return(0,L.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!v&&w<30)return(0,L.localize)(1,null);let $;return w<D?($=w,g?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):w<R?($=Math.floor(w/D),g?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):w<A?($=Math.floor(w/R),g?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):w<N?($=Math.floor(w/A),g?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):w<y?($=Math.floor(w/N),g?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):w<u?($=Math.floor(w/y),g?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(w/u),g?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$5l=l;function O(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=O}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[33],re([0,1,19,3,78]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function A(S,g){return g&&(S.stack||S.stacktrace)?R.localize(0,null,y(S),N(S.stack)||N(S.stacktrace)):y(S)}function N(S){return Array.isArray(S)?S.join(`
`):S}function y(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?R.localize(1,null,S.message):S.message||R.localize(2,null)}function u(S=null,g=!1){if(!S)return R.localize(3,null);if(Array.isArray(S)){const d=L.$Eb(S),v=u(d[0],g);return d.length>1?R.localize(4,null,v,d.length):v}if(D.$if(S))return S;if(S.detail){const d=S.detail;if(d.error)return A(d.error,g);if(d.exception)return A(d.exception,g)}return S.stack?A(S,g):S.message?S.message:R.localize(5,null)}e.$li=u;function l(S){const g=S;return g instanceof Error&&Array.isArray(g.actions)}e.$mi=l;function O(S,g){let d;return typeof S=="string"?d=new Error(S):d=S,d.actions=g,d}e.$ni=O}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$kp=D}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.TerminateResponseCode=e.Source=void 0;var D;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(y,...u){const l=u.reduce((g,d)=>(g[d]=!0,g),{}),O=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(g=>!l[g]).forEach(g=>{for(let d=0;d<O.length;d++)if(g.search(O[d])!==-1){delete y[g];break}})}e.$rl=A;function N(y){y&&(delete y.DEBUG,L.$j&&delete y.DYLD_LIBRARY_PATH,L.$k&&delete y.LD_PRELOAD)}e.$sl=N}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Np=e.$Mp=e.$Lp=void 0;function D(l){const O=l;return O&&typeof O.type=="string"&&typeof O.severity=="string"}e.$Lp=D;function R(l){const O=[];let S;try{const g=JSON.parse(l.arguments),d=g[g.length-1];d&&d.__$stack&&(g.pop(),S=d.__$stack),O.push(...g)}catch{O.push("Unable to log remote console arguments",l.arguments)}return{args:O,stack:S}}e.$Mp=R;function A(l){if(typeof l!="string")return A(R(l).stack);const O=l;if(O){const S=N(O),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$Np=A;function N(l){if(!l)return l;const O=l.indexOf(`
`);return O===-1?l:l.substring(0,O)}function y(l,O){const{args:S,stack:g}=R(l),d=typeof S[0]=="string"&&S.length===1;let v=N(g);v&&(v=`(${v.trim()})`);let w=[];if(typeof S[0]=="string"?v&&d?w=[`%c[${O}] %c${S[0]} %c${v}`,u("blue"),u(""),u("grey")]:w=[`%c[${O}] %c${S[0]}`,u("blue"),u(""),...S.slice(1)]:w=[`%c[${O}]%`,u("blue"),...S],v&&!d&&w.push(v),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,w)}e.log=y;function u(l){return`color: ${l}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function R(u){return JSON.stringify(u,N)}e.$8g=R;function A(u){let l=JSON.parse(u);return l=y(l),l}e.$9g=A;function N(u,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function y(u,l=0){if(!u||l>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof L.$Ed||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let O=0;O<u.length;++O)u[O]=y(u[O],l+1);else for(const O in u)Object.hasOwnProperty.call(u,O)&&(u[O]=y(u[O],l+1))}return u}e.$0g=y}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0C=void 0;class N{constructor(g,d,v){this.id=g,this.dependencies=d,this.callback=v}}class y{static{this.INSTANCE=new y}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,d,v)=>{typeof g!="string"&&(v=d,d=g,g=null),(typeof d!="object"||!Array.isArray(d))&&(v=d,d=null),this.c.push(new N(g,d,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const d=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!d)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(g){return new Promise((d,v)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const $=()=>{w.removeEventListener("load",h),w.removeEventListener("error",f)},h=k=>{$(),d(this.c.pop())},f=k=>{$(),v(k)};w.addEventListener("load",h),w.addEventListener("error",f),this.f&&(g=this.f.createScriptURL(g)),w.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(w)})}i(g){return new Promise((d,v)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),d(this.c.pop())}catch(w){v(w)}})}async j(g){try{const d=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(g).fsPath,h=d.readFileSync($).toString(),f=w.wrap(h.replace(/^#!.*/,""));return new v.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function O(S,g,d){if(L.$R){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[S]&&(S=l[S]);const v=`${S}/${g}`;if(u.has(v))return u.get(v);let w;if(/^\w[\w\d+.-]*:\/\//.test(v))w=v;else{const k=`${d&&!R.$o?D.$Yf:D.$Xf}/${v}`;w=D.$1f.asBrowserUri(k).toString(!0)}const $=y.INSTANCE.load(w);return u.set(v,$),$}else return await new Promise((v,w)=>{J([S],v,w)})}e.$0C=O}),define(ne[83],re([0,1,32,16,24]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=void 0;const A=/^\d+$/,N=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let O;process.env.PROCESSOR_ARCHITEW6432?O=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?O=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?O=1:O=0;class S{constructor(b,t,a){this.exePath=b,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:p=!1}={}){return p?l===0?process.env["ProgramFiles(x86)"]||null:O===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:b=!1}={}){const t=g({useAlternateBitness:p});if(!t)return null;const a=D.$8d(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(a))return null;let i=-1,s=null;for(const c of await R.Promises.readdir(a)){let I=-1;if(b){const E=c.indexOf("-");if(E<0)continue;const j=c.substring(0,E);if(!A.test(j)||c.substring(E+1)!=="preview")continue;I=parseInt(j,10)}else{if(!A.test(c))continue;I=parseInt(c,10)}if(I<=i)continue;const P=D.$8d(a,c,"pwsh.exe");await R.SymlinkSupport.existsFile(P)&&(s=P,i=I)}if(!s)return null;const n=t.includes("x86")?" (x86)":"",r=b?" Preview":"";return new S(s,`PowerShell${r}${n}`,!0)}async function v({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const b=D.$8d(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(b))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(b))if(t.test(i)){const s=D.$8d(b,i,"pwsh.exe");return new S(s,a)}return null}function w(){const p=D.$8d(L.homedir(),".dotnet","tools","pwsh.exe");return new S(p,".NET Core PowerShell Global Tool")}function $(){const p=D.$8d(process.env.windir,l===1&&O!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await v(),p&&(yield p),p=w(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await v({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$pl=f;async function k(){for await(const p of f())return p;return null}e.$ql=k}),define(ne[56],re([0,1,16,13,34,55,3,24]),function(J,e,L,D,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(S=R.env){return S.comspec||"cmd.exe"}e.$tl=u;function l(S){let g=[],d=!1;const v=function(w){if(d){g.push(w);return}(!S.send(w,h=>{if(h&&console.error(h),d=!1,g.length>0){const f=g.slice(0);g=[],f.forEach(k=>v(k))}})||D.$i)&&(d=!0)};return{send:v}}e.$ul=l;var O;(function(S){async function g(d,v,w){if(L.$7d(d))return d;if(v===void 0&&(v=R.cwd()),L.$$d(d)!=="."||(w===void 0&&N.$if(R.env.PATH)&&(w=R.env.PATH.split(L.$fe)),w===void 0||w.length===0))return L.$8d(v,d);async function h(f){if(await y.Promises.exists(f)){let k;try{k=await y.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(k=await y.Promises.lstat(f))}return k?!k.isDirectory():!1}return!1}for(const f of w){let k;if(L.$7d(f)?k=L.$8d(f,d):k=L.$8d(v,f,d),await h(k))return k;let p=k+".com";if(await h(p)||(p=k+".exe",await h(p)))return p}return L.$8d(v,d)}S.findExecutable=g})(O||(e.win32=O={}))}),define(ne[84],re([0,1,32,13,83,56]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=void 0;async function N(S,g){return S===1?D.$i?O():A.$tl(g):u(S,g)}e.$vl=N;let y=null;function u(S,g){if(D.$k&&S===2||D.$j&&S===3)return"/bin/bash";if(!y){let d;if(D.$i)d="/bin/bash";else{if(d=g.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let l=null;async function O(){return l||(l=(await(0,R.$ql)()).exePath),l}});var $e=this&&this.__decorate||function(J,e,L,D){var R=arguments.length,A=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,D);else for(var y=J.length-1;y>=0;y--)(N=J[y])&&(A=(R<3?N(A):R>3?N(e,L,A):N(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,D,R,A,N,y,u,l,O,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.ProxyChannel=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.RequestInitiator=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0;var d;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(d||(d={}));function v(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(w||(w={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let U=0;for(let q=0;;q+=7){const X=T.read(1);if(U|=(X.buffer[0]&127)<<q,!(X.buffer[0]&128))return U}}const k=i(0);function p(T,U){if(U===0){T.write(k);return}let q=0;for(let Y=U;Y!==0;Y=Y>>>7)q++;const X=R.$Ed.alloc(q);for(let Y=0;U!==0;Y++)X.buffer[Y]=U&127,U=U>>>7,U>0&&(X.buffer[Y]|=128);T.write(X)}class b{constructor(U){this.b=U,this.a=0}read(U){const q=this.b.slice(this.a,this.a+U);return this.a+=q.byteLength,q}}e.$$g=b;class t{constructor(){this.a=[]}get buffer(){return R.$Ed.concat(this.a)}write(U){this.a.push(U)}}e.$_g=t;var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(a||(a={}));function i(T){const U=R.$Ed.alloc(1);return U.writeUInt8(T,0),U}const s={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},n=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(s.Undefined);else if(typeof U=="string"){const q=R.$Ed.fromString(U);T.write(s.String),p(T,q.byteLength),T.write(q)}else if(n&&Buffer.isBuffer(U)){const q=R.$Ed.wrap(U);T.write(s.Buffer),p(T,q.byteLength),T.write(q)}else if(U instanceof R.$Ed)T.write(s.VSBuffer),p(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(s.Array),p(T,U.length);for(const q of U)r(T,q)}else if(typeof U=="number"&&(U|0)===U)T.write(s.Uint),p(T,U);else{const q=R.$Ed.fromString(JSON.stringify(U));T.write(s.Object),p(T,q.byteLength),T.write(q)}}e.$ah=r;function c(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(f(T)).toString();case a.Buffer:return T.read(f(T)).buffer;case a.VSBuffer:return T.read(f(T));case a.Array:{const q=f(T),X=[];for(let Y=0;Y<q;Y++)X.push(c(T));return X}case a.Object:return JSON.parse(T.read(f(T)).toString());case a.Int:return f(T)}}e.$bh=c;class I{constructor(U,q,X=null,Y=1e3){this.h=U,this.j=q,this.k=X,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(U,q){this.b.set(U,q),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const q=this.o([U.type]);this.k?.logOutgoing(q,0,1,$(U.type));return}case 201:case 202:case 204:case 203:{const q=this.o([U.type,U.id],U.data);this.k?.logOutgoing(q,U.id,1,$(U.type),U.data);return}}}o(U,q=void 0){const X=new t;return r(X,U),r(X,q),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const q=new b(U),X=c(q),Y=c(q),x=X[0];switch(x){case 100:return this.k?.logIncoming(U.byteLength,X[1],1,`${v(x)}: ${X[2]}.${X[3]}`,Y),this.s({type:x,id:X[1],channelName:X[2],name:X[3],arg:Y});case 102:return this.k?.logIncoming(U.byteLength,X[1],1,`${v(x)}: ${X[2]}.${X[3]}`,Y),this.t({type:x,id:X[1],channelName:X[2],name:X[3],arg:Y});case 101:return this.k?.logIncoming(U.byteLength,X[1],1,`${v(x)}`),this.u({type:x,id:X[1]});case 103:return this.k?.logIncoming(U.byteLength,X[1],1,`${v(x)}`),this.u({type:x,id:X[1]})}}s(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const X=new A.$od;let Y;try{Y=q.call(this.j,U.name,U.arg,X.token)}catch(z){Y=Promise.reject(z)}const x=U.id;Y.then(z=>{this.m({id:x,data:z,type:201})},z=>{z instanceof Error?this.m({id:x,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:x,data:z,type:203})}).finally(()=>{F.dispose(),this.d.delete(U.id)});const F=(0,l.$hc)(()=>X.cancel());this.d.set(U.id,F)}t(U){const q=this.b.get(U.channelName);if(!q){this.v(U);return}const X=U.id,x=q.listen(this.j,U.name,U.arg)(F=>this.m({id:X,data:F,type:204}));this.d.set(U.id,x)}u(U){const q=this.d.get(U.id);q&&(q.dispose(),this.d.delete(U.id))}v(U){let q=this.g.get(U.channelName);q||(q=[],this.g.set(U.channelName,q));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:U,timeoutTimer:X})}w(U){const q=this.g.get(U);if(q){for(const X of q)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$ec)(this.d.values()),this.d.clear()}}e.$ch=I;var P;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class E{constructor(U,q=null){this.l=U,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$ed,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=q}getChannel(U){const q=this;return{call(X,Y,x){return q.a?Promise.reject(new y.$3):q.m(U,X,Y,x)},listen(X,Y){return q.a?u.Event.None:q.o(U,X,Y)}}}m(U,q,X,Y=A.CancellationToken.None){const x=this.g++,z={id:x,type:100,channelName:U,name:q,arg:X};if(Y.isCancellationRequested)return Promise.reject(new y.$3);let o;return new Promise((M,C)=>{if(Y.isCancellationRequested)return C(new y.$3);const Z=()=>{const pe=de=>{switch(de.type){case 201:this.f.delete(x),M(de.data);break;case 202:{this.f.delete(x);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,C(ge);break}case 203:this.f.delete(x),C(de.data);break}};this.f.set(x,pe),this.p(z)};let W=null;this.b===h.Idle?Z():(W=(0,D.$tg)(pe=>this.u()),W.then(()=>{W=null,Z()}));const ce=()=>{W?(W.cancel(),W=null):this.p({id:x,type:101}),C(new y.$3)},oe=Y.onCancellationRequested(ce);o=(0,l.$gc)((0,l.$hc)(ce),oe),this.d.add(o)}).finally(()=>{o.dispose(),this.d.delete(o)})}o(U,q,X){const Y=this.g++,F={id:Y,type:102,channelName:U,name:q,arg:X};let z=null;const o=new u.$ed({onWillAddFirstListener:()=>{z=(0,D.$tg)(M=>this.u()),z.then(()=>{z=null,this.d.add(o),this.p(F)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(o),this.p({id:Y,type:103}))}}),m=M=>o.fire(M.data);return this.f.set(Y,m),o.event}p(U){switch(U.type){case 100:case 102:{const q=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(q,U.id,0,`${v(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const q=this.q([U.type,U.id]);this.j?.logOutgoing(q,U.id,0,v(U.type));return}}}q(U,q=void 0){const X=new t;return r(X,U),r(X,q),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const q=new b(U),X=c(q),Y=c(q),x=X[0];switch(x){case 200:return this.j?.logIncoming(U.byteLength,0,0,$(x)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,X[1],0,$(x),Y),this.t({type:X[0],id:X[1],data:Y})}}t(U){if(U.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$ec)(this.d.values()),this.d.clear()}}e.$dh=E,$e([N.$5g],E.prototype,"onDidInitializePromise",null);class j{get connections(){const U=[];return this.f.forEach(q=>U.push(q)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$ed,this.onDidAddConnection=this.g.event,this.h=new u.$ed,this.onDidRemoveConnection=this.h.event,this.j=new l.$ic,this.j.add(U(({protocol:q,onDidClientDisconnect:X})=>{const Y=u.Event.once(q.onMessage);this.j.add(Y(x=>{const F=new b(x),z=c(F),o=new I(q,z),m=new E(q);this.a.forEach((C,Z)=>o.registerChannel(Z,C));const M={channelServer:o,channelClient:m,ctx:z};this.f.add(M),this.g.fire(M),this.j.add(X(()=>{o.dispose(),m.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(U,q){const X=this;return{call(Y,x,F){let z;if((0,g.$wf)(q)){const m=(0,L.$1b)(X.connections.filter(q));z=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,q))}else z=q.routeCall(X,Y,x);const o=z.then(m=>m.channelClient.getChannel(U));return K(o).call(Y,x,F)},listen(Y,x){if((0,g.$wf)(q))return X.k(U,q,Y,x);const F=q.routeEvent(X,Y,x).then(z=>z.channelClient.getChannel(U));return K(F).listen(Y,x)}}}k(U,q,X,Y){const x=this;let F;const z=new u.$ed({onWillAddFirstListener:()=>{F=new l.$ic;const o=new u.$kd,m=new Map,M=Z=>{const ce=Z.channelClient.getChannel(U).listen(X,Y),oe=o.add(ce);m.set(Z,oe)},C=Z=>{const W=m.get(Z);W&&(W.dispose(),m.delete(Z))};x.connections.filter(q).forEach(M),u.Event.filter(x.onDidAddConnection,q)(M,void 0,F),x.onDidRemoveConnection(C,void 0,F),o.event(z.fire,z,F),F.add(o)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return z.event}registerChannel(U,q){this.a.set(U,q);for(const X of this.f)X.channelServer.registerChannel(U,q)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$eh=j;class H{constructor(U,q,X=null){const Y=new t;r(Y,q),U.send(Y.buffer),this.a=new E(U,X),this.d=new I(U,q,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,q){this.d.registerChannel(U,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fh=H;function K(T){return{call(U,q,X){return T.then(Y=>Y.call(U,q,X))},listen(U,q){const X=new u.$nd;return T.then(Y=>X.input=Y.listen(U,q)),X.event}}}e.$gh=K;function _(T){let U=!1;return{call(q,X,Y){return U?T.call(q,X,Y):(0,D.$Gg)(0).then(()=>U=!0).then(()=>T.call(q,X,Y))},listen(q,X){if(U)return T.listen(q,X);const Y=new u.$nd;return(0,D.$Gg)(0).then(()=>U=!0).then(()=>Y.input=T.listen(q,X)),Y.event}}}e.$hh=_;class ue{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const q of U.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$ih=ue;var te;(function(T){function U(x,F,z){const o=x,m=z&&z.disableMarshalling,M=new Map;for(const C in o)X(C)&&M.set(C,u.Event.buffer(o[C],!0,void 0,F));return new class{listen(C,Z,W){const ce=M.get(Z);if(ce)return ce;if(Y(Z)){const oe=o[Z];if(typeof oe=="function")return oe.call(o,W)}throw new y.$_(`Event not found: ${Z}`)}call(C,Z,W){const ce=o[Z];if(typeof ce=="function"){if(!m&&Array.isArray(W))for(let oe=0;oe<W.length;oe++)W[oe]=(0,O.$0g)(W[oe]);return ce.apply(o,W)}throw new y.$_(`Method not found: ${Z}`)}}}T.fromService=U;function q(x,F){const z=F&&F.disableMarshalling;return new Proxy({},{get(o,m){if(typeof m=="string")return F?.properties?.has(m)?F.properties.get(m):Y(m)?function(M){return x.listen(m,M)}:X(m)?x.listen(m):async function(...M){let C;F&&!(0,g.$rf)(F.context)?C=[F.context,...M]:C=M;const Z=await x.call(m,C);return z?Z:(0,O.$0g)(Z)};throw new y.$_(`Property not found: ${String(m)}`)}})}T.toService=q;function X(x){return x[0]==="o"&&x[1]==="n"&&S.$Ke(x.charCodeAt(2))}function Y(x){return/^onDynamic/.test(x)&&S.$Ke(x.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function B(T,U,q,X,Y,x,F){F=ie(F);const z=ae[Y],o=z[X%z.length];let m=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(x)?(m=m.concat(F),m.push(")")):m.push(F),console.log.apply(console,m)}class G{constructor(U,q){this.d=U,this.f=q,this.a=0,this.b=0}logOutgoing(U,q,X,Y,x){this.b+=U,B(this.d,this.b,U,q,X,Y,x)}logIncoming(U,q,X,Y,x){this.a+=U,B(this.f,this.a,U,q,X,Y,x)}}e.$jh=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class v extends d.$ch{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>R.$Ed.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Pp=v;class w{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$ed,this.onDidProcessExit=this.h.event;const k=f&&f.timeout?f.timeout:6e4;this.b=new D.$Cg(k),this.d=null,this.f=null}getChannel(h){const f=this;return{call(k,p,b){return f.k(h,k,p,b)},listen(k,p){return f.l(h,k,p)}}}k(h,f,k,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(y.$4());this.b.cancel();const b=this.n(h),t=(0,D.$tg)(s=>b.call(f,k,s)),a=p.onCancellationRequested(()=>t.cancel()),i=(0,l.$hc)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,k){if(!this.b)return u.Event.None;this.b.cancel();let p;const b=new u.$ed({onWillAddFirstListener:()=>{p=this.n(h).listen(f,k)(b.fire,b),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return b.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,O.$Um)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.$sl)(f.env),this.d=(0,L.fork)(this.i,h,f);const k=new u.$ed;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,N.$Lp)(n)){(0,N.log)(n,`IPC Library: ${this.j.serverName}`);return}k.fire(R.$Ed.wrap(Buffer.from(n,"base64")))});const b=this.j.useQueue?(0,S.$ul)(this.d):this.d,t=n=>this.d&&this.d.connected&&b.send(n.buffer.toString("base64")),a=k.event,i={send:t,onMessage:a};this.f=new d.$dh(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",s),this.c.forEach(c=>(0,l.$ec)(c)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Qp=w}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.StorageState=e.$Oo=e.StorageHint=void 0;var y;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(y||(e.StorageHint=y={}));function u(g){const d=g;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Oo=u;var l;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(l||(e.StorageState=l={}));class O extends R.$jc{static{this.a=100}constructor(d,v=Object.create(null)){super(),this.r=d,this.s=v,this.b=this.B(new D.$hd),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new L.$Dg(O.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((v,w)=>this.w(w,v)),d.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(d,v){if(this.c===l.Closed)return;let w=!1;(0,N.$rf)(v)?w=this.f.delete(d):this.f.get(d)!==v&&(this.f.set(d,v),w=!0),w&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==y.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,v){const w=this.f.get(d);return(0,N.$rf)(w)?v:w}getBoolean(d,v){const w=this.get(d);return(0,N.$rf)(w)?v:w==="true"}getNumber(d,v){const w=this.get(d);return(0,N.$rf)(w)?v:parseInt(w,10)}getObject(d,v){const w=this.get(d);return(0,N.$rf)(w)?v:(0,A.$9g)(w)}async set(d,v,w=!1){if(this.c===l.Closed)return;if((0,N.$rf)(v))return this.delete(d,w);const $=(0,N.$kf)(v)||Array.isArray(v)?(0,A.$8g)(v):String(v);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:w}),this.D()}async delete(d,v=!1){if(!(this.c===l.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:v}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===y.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===y.STORAGE_IN_MEMORY}}e.$Po=O;class S{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((v,w)=>this.a.set(w,v)),d.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Qo=S}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var R;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...l){switch(l.length){case 1:return(0,D.localize)(0,null,l[0]);case 2:return(0,D.localize)(1,null,l[0],l[1]);case 3:return(0,D.localize)(2,null,l[0],l[1],l[2]);default:return}}const N=(0,D.localize)(3,null),y=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,L.$6)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(O=>O.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const S=this.d,g=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:g};this.g.push({offset:S,lexeme:g,additionalInfo:O}),this.f.push(d)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const S=this.c.substring(this.d,this.e),g=u.b.get(S);g?this.k(g):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,S=!1,g=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(y);return}const v=this.c.charCodeAt(O);if(S)S=!1;else if(v===47&&!g){O++;break}else v===91?g=!0:v===92?S=!0:v===93&&(g=!1);O++}for(;O<this.c.length&&u.a.has(this.c.charCodeAt(O));)O++;this.e=O;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=u}),define(ne[109],re([0,1,77,52,15,16,34,17,11]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=void 0,e.$7l=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,A.$$d)(R.$1f.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$8d)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,y.$hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,y.$hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$8d)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.$hg)(u.URI.file((0,A.$8d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.$hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.$hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.$hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=N.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$8d)(d,"argv.json")):(0,y.$hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$8d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$9d)(d):(0,A.$6d)((0,A.$8d)(R.$1f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.$9d)(d)):u.URI.file((0,A.$8d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$9d)(d);const v=N.env.VSCODE_EXTENSIONS;if(v)return v;const w=N.env.VSCODE_PORTABLE;return w?(0,A.$8d)(w,"extensions"):(0,y.$hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?u.URI.parse(v):u.URI.file((0,A.$6d)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.$6d)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return O(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$7l.test(d))}get extensionLogLevel(){const d=[];for(const v of this.args.log||[]){const w=e.$7l.exec(v);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,y.$hg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=N.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$8d)(d,"policy.json")):(0,y.$hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,v,w){this.a=d,this.b=v,this.c=w,this.editSessionId=this.args.editSessionId}}e.$8l=l,$e([D.$5g],l.prototype,"appRoot",null),$e([D.$5g],l.prototype,"userHome",null),$e([D.$5g],l.prototype,"userDataPath",null),$e([D.$5g],l.prototype,"appSettingsHome",null),$e([D.$5g],l.prototype,"tmpDir",null),$e([D.$5g],l.prototype,"cacheHome",null),$e([D.$5g],l.prototype,"stateResource",null),$e([D.$5g],l.prototype,"userRoamingDataHome",null),$e([D.$5g],l.prototype,"userDataSyncHome",null),$e([D.$5g],l.prototype,"sync",null),$e([D.$5g],l.prototype,"machineSettingsResource",null),$e([D.$5g],l.prototype,"workspaceStorageHome",null),$e([D.$5g],l.prototype,"localHistoryHome",null),$e([D.$5g],l.prototype,"keyboardLayoutResource",null),$e([D.$5g],l.prototype,"argvResource",null),$e([D.$5g],l.prototype,"isExtensionDevelopment",null),$e([D.$5g],l.prototype,"untitledWorkspacesHome",null),$e([D.$5g],l.prototype,"builtinExtensionsPath",null),$e([D.$5g],l.prototype,"extensionsPath",null),$e([D.$5g],l.prototype,"extensionDevelopmentLocationURI",null),$e([D.$5g],l.prototype,"extensionDevelopmentKind",null),$e([D.$5g],l.prototype,"extensionTestsLocationURI",null),$e([D.$5g],l.prototype,"debugExtensionHost",null),$e([D.$5g],l.prototype,"logLevel",null),$e([D.$5g],l.prototype,"extensionLogLevel",null),$e([D.$5g],l.prototype,"serviceMachineIdResource",null),$e([D.$5g],l.prototype,"disableTelemetry",null),$e([D.$5g],l.prototype,"disableWorkspaceTrust",null),$e([D.$5g],l.prototype,"useInMemorySecretStorage",null),$e([D.$5g],l.prototype,"policyFile",null);function O(g,d){return S(g["inspect-extensions"],g["inspect-brk-extensions"],5870,d,g.debugId,g.extensionEnvironment)}e.$9l=O;function S(g,d,v,w,$,h){const k=Number(d||g)||(w?null:v),p=k?!!d:!1;let b;if(h)try{b=JSON.parse(h)}catch{}return{port:k,break:p,debugId:$,env:b}}e.$0l=S}),function(){"use strict";function J(e,L,D){function R(N,y){const u=A(N,y),l=[u];return e.isAbsolute(u)||l.unshift(D),e.resolve(...l)}function A(N,y){process.env.VSCODE_DEV&&(y="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,y);const O=N["user-data-dir"];if(O)return O;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(S,"AppData","Roaming")}break;case"darwin":l=e.join(L.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,y)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,32,34]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,32,109,110]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=void 0;class A extends D.$8l{constructor(l,O){super(l,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(l,O.nameShort)},O)}}e.$$l=A;function N(u,l){return(0,D.$0l)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,l,u.extensionEnvironment)}e.$_l=N;function y(u,l){return(0,D.$0l)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,l,u.extensionEnvironment)}e.$am=y}),define(ne[112],re([0,1,3,94]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;function R(N,y,u,l){try{A(N,y,u,l)}catch(O){N.error(O?.message??O)}return y}e.$lp=R;function A(N,y,u,l){const O=(S,g,d)=>{const v=S[g];if((0,L.$if)(v)){const w=v,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const h=w.substr(1,$-2);let f=u[h];f===void 0&&l&&(f=l[h]);const k=typeof f=="string"?f:f?.message,p=l?.[h],b=typeof p=="string"?p:p?.message;if(!k){b||N.warn(`[${y.name}]: ${(0,D.localize)(0,null,h)}`);return}if(d&&(g==="title"||g==="category")&&b&&b!==k){const t={value:k,original:b};S[g]=t}else S[g]=k}}else if((0,L.$kf)(v))for(const w in v)v.hasOwnProperty(w)&&(w==="commands"?O(v,w,!0):O(v,w,d));else if(Array.isArray(v))for(let w=0;w<v.length;w++)O(v,w,d)};for(const S in y)y.hasOwnProperty(S)&&O(y,S)}}),define(ne[48],re([0,1,17,54,98,43]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||N.test(h)}e.$Ao=u;function l(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(N);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Bo=l;function O(h){if(!h)return null;const f=h.majorBase,k=h.majorMustEqual,p=h.minorBase;let b=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(f===0||(b=!1),a=!1);let i=0;if(h.preRelease){const s=y.exec(h.preRelease);if(s){const[,n,r,c]=s;i=Date.UTC(Number(n),Number(r)-1,Number(c))}}return{majorBase:f,majorMustEqual:k,minorBase:p,minorMustEqual:b,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:i}}e.$Co=O;function S(h,f,k){let p;typeof h=="string"?p=O(l(h)):p=h;let b;f instanceof Date?b=f.getTime():typeof f=="string"&&(b=new Date(f).getTime());let t;if(typeof k=="string"?t=O(l(k)):t=k,!p||!t)return!1;const a=p.majorBase,i=p.minorBase,s=p.patchBase;let n=t.majorBase,r=t.minorBase,c=t.patchBase;const I=t.notBefore;let P=t.majorMustEqual,E=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?a>n?!0:a<n?!1:i>r?!0:i<r||b&&b<I?!1:s>=c:(a===1&&n===0&&(!P||!E||!j)&&(n=1,r=0,c=0,P=!0,E=!1,j=!1),a<n?!1:a>n?!P:i<r?!1:i>r?!E:s<c?!1:s>c?!j:!(b&&b<I))}e.$Do=S;function g(h,f,k,p,b){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([D.default.Error,R.localize(0,null)]),t;if(typeof p.name!="string")return t.push([D.default.Error,R.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([D.default.Error,R.localize(2,null,"version")]),t;if(!p.engines)return t.push([D.default.Error,R.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([D.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return t.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return t.push([D.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([D.default.Error,R.localize(9,null,"main")]),t;{const s=(0,L.$hg)(k,p.main);(0,L.$bg)(s,k)||t.push([D.default.Warning,R.localize(10,null,s.path,k.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([D.default.Error,R.localize(11,null,"browser")]),t;{const s=(0,L.$hg)(k,p.browser);(0,L.$bg)(s,k)||t.push([D.default.Warning,R.localize(12,null,s.path,k.path)])}}if(!A.valid(p.version))return t.push([D.default.Error,R.localize(13,null)]),t;const a=[];if(!d(h,f,p,b,a))for(const s of a)t.push([D.default.Error,s]);return t}e.$Eo=g;function d(h,f,k,p,b){return p||typeof k.main>"u"&&typeof k.browser>"u"?!0:w(h,f,k.engines.vscode,b)}e.$Fo=d;function v(h,f,k){return h==="*"||w(f,k,h)}e.$Go=v;function w(h,f,k,p=[]){const b=O(l(k));if(!b)return p.push(R.localize(14,null,k)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return p.push(R.localize(15,null,k)),!1}else if(!b.majorMustEqual)return p.push(R.localize(16,null,k)),!1;return S(h,f,b)?!0:(p.push(R.localize(17,null,h,k)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,k=h.length;f<k;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0;async function R(A,N,y){let u=y&&y.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const O=(await N.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$2f)(O)?O:null}catch{u=null}if(!u){u=(0,D.$3f)();try{await N.writeFile(A.serviceMachineIdResource,L.$Ed.fromString(u))}catch{}}return y?.store("storage.serviceMachineId",u,-1,1),u}e.$Zo=R}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class L{constructor(R,A=[],N=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$xh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.InstantiationType=void 0;const D=[];var R;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(y,u,l){u instanceof L.$xh||(u=new L.$xh(u,[],!!l)),D.push([y,u])}e.$kr=A;function N(){return D}e.$lr=N}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class L{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$2p=L;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const y=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(N);y.outgoing.set(u.key,u),u.incoming.set(y.key,y)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const y of this.a.values())y.outgoing.delete(N),y.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let y=this.a.get(N);return y||(y=new L(N,A),this.a.set(N,y)),y}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,y]of this.a)A.push(`${N}
	(-> incoming)[${[...y.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...y.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const y=new Set([A]),u=this.c(N,y);if(u)return u}}c(A,N){for(const[y,u]of A.outgoing){if(N.has(y))return[...N,y].join(" -> ");N.add(y);const l=this.c(u,N);if(l)return l;N.delete(y)}}}e.$3p=D}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,R.$Ah)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}e.$8h=A;function N(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}e.$9h=N;var y;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(y||(e.ConfigurationTarget=y={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=u;function l(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$$h=l;function O(h,f){const k=Object.create(null);for(const p in h)S(k,p,h[p],f);return k}e.$_h=O;function S(h,f,k,p){const b=f.split("."),t=b.pop();let a=h;for(let i=0;i<b.length;i++){const s=b[i];let n=a[s];switch(typeof n){case"undefined":n=a[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${b.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[t]=k}catch{p(`Ignoring ${f} as ${b.join(".")} is ${JSON.stringify(a)}`)}else p(`Ignoring ${f} as ${b.join(".")} is ${JSON.stringify(a)}`)}e.$ai=S;function g(h,f){const k=f.split(".");d(h,k)}e.$bi=g;function d(h,f){const k=f.shift();if(f.length===0){delete h[k];return}if(Object.keys(h).indexOf(k)!==-1){const p=h[k];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[k])}}function v(h,f,k){function p(a,i){let s=a;for(const n of i){if(typeof s!="object"||s===null)return;s=s[n]}return s}const b=f.split("."),t=p(h,b);return typeof t>"u"?k:t}e.$ci=v;function w(h,f,k){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$kf(h[p])&&L.$kf(f[p])?w(h[p],f[p],k):k&&(h[p]=f[p]):h[p]=f[p])})}e.$di=w;function $(h){return h.replace(/[\[\]]/g,"")}e.$ei=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,D,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$j),u.set("isLinux",L.$k),u.set("isWindows",L.$i),u.set("isWeb",L.$o),u.set("isMacNative",L.$j&&!L.$o),u.set("isEdge",L.$G),u.set("isFirefox",L.$E),u.set("isChrome",L.$D),u.set("isSafari",L.$F);function l(z,o){if(u.get(z)!==void 0)throw(0,y.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,o)}e.$Fi=l;const O=Object.prototype.hasOwnProperty;var S;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const g={regexParsingWithErrorRecovery:!0},d=(0,N.localize)(0,null),v=(0,N.localize)(1,null),w=(0,N.localize)(2,null),$=(0,N.localize)(3,null),h=(0,N.localize)(4,null),f=(0,N.localize)(5,null),k=(0,N.localize)(6,null),p=(0,N.localize)(7,null);class b{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(o=g){this.k=o,this.d=new R.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(o){if(o===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(o).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const M=this.D(),C=M.type===17?f:void 0;throw this.h.push({message:h,offset:M.offset,lexeme:R.$Ei.getLexeme(M),additionalInfo:C}),b.c}return m}catch(m){if(m!==b.c)throw m;return}}l(){return this.m()}m(){const o=[this.o()];for(;this.y(16);){const m=this.o();o.push(m)}return o.length===1?o[0]:t.or(...o)}o(){const o=[this.s()];for(;this.y(15);){const m=this.s();o.push(m)}return o.length===1?o[0]:t.and(...o)}s(){if(this.y(2)){const o=this.D();switch(o.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),H.create(o.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",o)}}return this.t()}t(){const o=this.D();switch(o.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=o.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const Z=C.lexeme,W=Z.lastIndexOf("/"),ce=W===Z.length-1?void 0:this.w(Z.substring(W+1));let oe;try{oe=new RegExp(Z.substring(1,W),ce)}catch{throw this.B("REGEX",C)}return le.create(m,oe)}switch(C.type){case 10:case 19:{const Z=[C.lexeme];this.z();let W=this.D(),ce=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;Z.push(R.$Ei.getLexeme(W)),this.z(),W=this.D()}const oe=Z.join(""),pe=oe.lastIndexOf("/"),de=pe===oe.length-1?void 0:this.w(oe.substring(pe+1));let ge;try{ge=new RegExp(oe.substring(1,pe),de)}catch{throw this.B("REGEX",C)}return t.regex(m,ge)}case 18:{const Z=C.lexeme;this.z();let W=null;if(!(0,D.$le)(Z)){const ce=Z.indexOf("/"),oe=Z.lastIndexOf("/");if(ce!==oe&&ce>=0){const pe=Z.slice(ce+1,oe),de=Z[oe+1]==="i"?"i":"";try{W=new RegExp(pe,de)}catch{throw this.B("REGEX",C)}}}if(W===null)throw this.B("REGEX",C);return le.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const C=this.u();return t.notIn(m,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return t.equals(m,C);switch(C){case"true":return t.has(m);case"false":return t.not(m);default:return t.equals(m,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return t.notEquals(m,C);switch(C){case"true":return t.not(m);case"false":return t.has(m);default:return t.notEquals(m,C)}}case 5:return this.z(),te.create(m,this.u());case 6:return this.z(),ae.create(m,this.u());case 7:return this.z(),_.create(m,this.u());case 8:return this.z(),ue.create(m,this.u());case 13:return this.z(),t.in(m,this.u());default:return t.has(m)}}case 20:throw this.h.push({message:k,offset:o.offset,lexeme:"",additionalInfo:p}),b.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const o=this.D();switch(o.type){case 17:case 18:return this.z(),o.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(o){return o.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(o){return this.C(o)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(o,m){if(this.C(o))return this.z();throw this.B(m,this.D())}B(o,m,M){const C=(0,N.localize)(8,null,o,R.$Ei.getLexeme(m)),Z=m.offset,W=R.$Ei.getLexeme(m);return this.h.push({message:C,offset:Z,lexeme:W,additionalInfo:M}),b.c}C(o){return this.D().type===o}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=b;class t{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(o){return c.create(o)}static equals(o,m){return I.create(o,m)}static notEquals(o,m){return j.create(o,m)}static regex(o,m){return le.create(o,m)}static in(o,m){return P.create(o,m)}static notIn(o,m){return E.create(o,m)}static not(o){return H.create(o)}static and(...o){return G.create(o,null,!0)}static or(...o){return T.create(o,null,!0)}static greater(o,m){return _.create(o,m)}static greaterEquals(o,m){return ue.create(o,m)}static smaller(o,m){return te.create(o,m)}static smallerEquals(o,m){return ae.create(o,m)}static{this.c=new b({regexParsingWithErrorRecovery:!1})}static deserialize(o){return o==null?void 0:this.c.parse(o)}}e.$Hi=t;function a(z){const o=new b({regexParsingWithErrorRecovery:!1});return z.map(m=>(o.parse(m),o.lexingErrors.length>0?o.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,N.localize)(9,null,M.additionalInfo):(0,N.localize)(10,null),offset:M.offset,length:M.lexeme.length})):o.parsingErrors.length>0?o.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.$Ii=a;function i(z,o){const m=z?z.substituteConstants():void 0,M=o?o.substituteConstants():void 0;return!m&&!M?!0:!m||!M?!1:m.equals(M)}e.$Ji=i;function s(z,o){return z.cmp(o)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return r.INSTANCE}}e.$Ki=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return n.INSTANCE}}e.$Li=r;class c{static create(o,m=null){const M=u.get(o);return typeof M=="boolean"?M?r.INSTANCE:n.INSTANCE:new c(o,m)}constructor(o,m){this.key=o,this.c=m,this.type=2}cmp(o){return o.type!==this.type?this.type-o.type:q(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}substituteConstants(){const o=u.get(this.key);return typeof o=="boolean"?o?r.INSTANCE:n.INSTANCE:this}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$Mi=c;class I{static create(o,m,M=null){if(typeof m=="boolean")return m?c.create(o,M):H.create(o,M);const C=u.get(o);return typeof C=="boolean"?m===(C?"true":"false")?r.INSTANCE:n.INSTANCE:new I(o,m,M)}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=4}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?r.INSTANCE:n.INSTANCE}return this}evaluate(o){return o.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(o){return o.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ni=I;class P{static create(o,m){return new P(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=10,this.c=null}cmp(o){return o.type!==this.type?this.type-o.type:X(this.d,this.f,o.d,o.f)}equals(o){return o.type===this.type?this.d===o.d&&this.f===o.f:!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.f),M=o.getValue(this.d);return Array.isArray(m)?m.includes(M):typeof M=="string"&&typeof m=="object"&&m!==null?O.call(m,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(o){return o.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Oi=P;class E{static create(o,m){return new E(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=11,this.c=P.create(o,m)}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(o){return o.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=E;class j{static create(o,m,M=null){if(typeof m=="boolean")return m?H.create(o,M):c.create(o,M);const C=u.get(o);return typeof C=="boolean"?m===(C?"true":"false")?n.INSTANCE:r.INSTANCE:new j(o,m,M)}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=5}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?n.INSTANCE:r.INSTANCE}return this}evaluate(o){return o.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(o){return o.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Qi=j;class H{static create(o,m=null){const M=u.get(o);return typeof M=="boolean"?M?n.INSTANCE:r.INSTANCE:new H(o,m)}constructor(o,m){this.c=o,this.d=m,this.type=3}cmp(o){return o.type!==this.type?this.type-o.type:q(this.c,o.c)}equals(o){return o.type===this.type?this.c===o.c:!1}substituteConstants(){const o=u.get(this.c);return typeof o=="boolean"?o?n.INSTANCE:r.INSTANCE:this}evaluate(o){return!o.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(o){return o.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.$Ri=H;function K(z,o){if(typeof z=="string"){const m=parseFloat(z);isNaN(m)||(z=m)}return typeof z=="string"||typeof z=="number"?o(z):n.INSTANCE}class _{static create(o,m,M=null){return K(m,C=>new _(o,C,M))}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=12}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Si=_;class ue{static create(o,m,M=null){return K(m,C=>new ue(o,C,M))}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=13}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Ti=ue;class te{static create(o,m,M=null){return K(m,C=>new te(o,C,M))}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=14}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Ui=te;class ae{static create(o,m,M=null){return K(m,C=>new ae(o,C,M))}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=15}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Vi=ae;class le{static create(o,m){return new le(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=7,this.c=null}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.d<o.d)return-1;if(this.d>o.d)return 1;const m=this.f?this.f.source:"",M=o.f?o.f.source:"";return m<M?-1:m>M?1:0}equals(o){if(o.type===this.type){const m=this.f?this.f.source:"",M=o.f?o.f.source:"";return this.d===o.d&&m===M}return!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const o=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${o}`}keys(){return[this.d]}map(o){return o.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Wi=le;class ie{static create(o){return new ie(o)}constructor(o){this.c=o,this.type=8}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(o){return new ie(this.c.map(o))}negate(){return this.c}}e.$Xi=ie;function B(z){let o=null;for(let m=0,M=z.length;m<M;m++){const C=z[m].substituteConstants();if(z[m]!==C&&o===null){o=[];for(let Z=0;Z<m;Z++)o[Z]=z[Z]}o!==null&&(o[m]=C)}return o===null?z:o}class G{static create(o,m,M){return G.d(o,m,M)}constructor(o,m){this.expr=o,this.c=m,this.type=6}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,M=this.expr.length;m<M;m++){const C=s(this.expr[m],o.expr[m]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=B(this.expr);return o===this.expr?this:G.create(o,this.c,!1)}evaluate(o){for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].evaluate(o))return!1;return!0}static d(o,m,M){const C=[];let Z=!1;for(const W of o)if(W){if(W.type===1){Z=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){C.push(...W.expr);continue}C.push(W)}if(C.length===0&&Z)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(s);for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];for(;C.length>1;){const W=C[C.length-1];if(W.type!==9)break;C.pop();const ce=C.pop(),oe=C.length===0,pe=T.create(W.expr.map(de=>G.create([de,ce],null,M)),null,oe);pe&&(C.push(pe),C.sort(s))}if(C.length===1)return C[0];if(M){for(let W=0;W<C.length;W++)for(let ce=W+1;ce<C.length;ce++)if(C[W].negate().equals(C[ce]))return n.INSTANCE;if(C.length===1)return C[0]}return new G(C,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new G(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());this.c=T.create(o,this,!0)}return this.c}}e.$Yi=G;class T{static create(o,m,M){return T.d(o,m,M)}constructor(o,m){this.expr=o,this.c=m,this.type=9}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,M=this.expr.length;m<M;m++){const C=s(this.expr[m],o.expr[m]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=B(this.expr);return o===this.expr?this:T.create(o,this.c,!1)}evaluate(o){for(let m=0,M=this.expr.length;m<M;m++)if(this.expr[m].evaluate(o))return!0;return!1}static d(o,m,M){let C=[],Z=!1;if(o){for(let W=0,ce=o.length;W<ce;W++){const oe=o[W];if(oe){if(oe.type===0){Z=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&Z)return n.INSTANCE;C.sort(s)}if(C.length!==0){if(C.length===1)return C[0];for(let W=1;W<C.length;W++)C[W-1].equals(C[W])&&(C.splice(W,1),W--);if(C.length===1)return C[0];if(M){for(let W=0;W<C.length;W++)for(let ce=W+1;ce<C.length;ce++)if(C[W].negate().equals(C[ce]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new T(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());for(;o.length>1;){const m=o.shift(),M=o.shift(),C=[];for(const Z of F(m))for(const W of F(M))C.push(G.create([Z,W],null,!1));o.unshift(T.create(C,null,!1))}this.c=T.create(o,this,!0)}return this.c}}e.$Zi=T;class U extends c{static{this.d=[]}static all(){return U.d.values()}constructor(o,m,M){super(o,null),this.f=m,typeof M=="object"?U.d.push({...M,key:o}):M!==!0&&U.d.push({key:o,description:M,type:m!=null?typeof m:void 0})}bindTo(o){return o.createKey(this.key,this.f)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(o){return I.create(this.key,o)}notEqualsTo(o){return j.create(this.key,o)}}e.$1i=U,e.$2i=(0,A.$Ah)("contextKeyService");function q(z,o){return z<o?-1:z>o?1:0}function X(z,o,m,M){return z<m?-1:z>m?1:o<M?-1:o>M?1:0}function Y(z,o){if(z.type===0||o.type===1)return!0;if(z.type===9)return o.type===9?x(z.expr,o.expr):!1;if(o.type===9){for(const m of o.expr)if(Y(z,m))return!0;return!1}if(z.type===6){if(o.type===6)return x(o.expr,z.expr);for(const m of z.expr)if(Y(m,o))return!0;return!1}return z.equals(o)}e.$3i=Y;function x(z,o){let m=0,M=0;for(;m<z.length&&M<o.length;){const C=z[m].cmp(o[M]);if(C<0)return!1;C===0&&m++,M++}return m===z.length}function F(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=void 0,e.$Cn=(0,L.$Ah)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,L.$Ah)("environmentService"),e.$Ih=(0,L.$Bh)(e.$Hh)}),define(ne[21],re([0,1,92,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=R;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=A;function N(f,k){switch(f){case 3:return k==="x64"?"win32-x64":k==="ia32"?"win32-ia32":k==="arm64"?"win32-arm64":"unknown";case 2:return k==="x64"?"linux-x64":k==="arm64"?"linux-arm64":k==="arm"?"linux-armhf":"unknown";case"alpine":return k==="x64"?"alpine-x64":k==="arm64"?"alpine-arm64":"unknown";case 1:return k==="x64"?"darwin-x64":k==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=N;function y(f,k){return k==="web"&&!f.includes("web")}e.$Un=y;function u(f,k,p){return y(k,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:l(p).includes(f)}e.$Vn=u;function l(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=l;function O(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$Xn=O;var S;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var g;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Yn=(0,D.$Ah)("extensionGalleryService");var w;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(k,p){super(k),this.code=p,this.name=p}}e.$Zn=h,e.$1n=(0,D.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,D.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,D.$Ah)("IExtensionTipsService"),e.$6n=(0,L.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=void 0,e.$5o=(0,L.$Ah)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,N)=>J(["node-vsce-sign"],async y=>A(y),N))),this.a}async verify(A,N,y){let u;try{u=await this.b()}catch{return!1}return u.verify(A,N,y)}}e.$6o=D}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function N(O,S,g,d,v,w){let $;try{await y(O,S,g,d,v,w)}catch(h){$=h}finally{$&&v.errorTransformer&&($=v.errorTransformer($)),typeof $<"u"&&g.error($),g.end()}}e.$Ap=N;async function y(O,S,g,d,v,w){u(w);const $=await O.open(S,{create:!1});try{u(w);let h=0,f=0,k=v&&typeof v.length=="number"?v.length:void 0,p=L.$Ed.alloc(Math.min(v.bufferSize,typeof k=="number"?k:v.bufferSize)),b=v&&typeof v.position=="number"?v.position:0,t=0;do f=await O.read($,b,p.buffer,t,p.byteLength-t),b+=f,t+=f,h+=f,typeof k=="number"&&(k-=f),t===p.byteLength&&(await g.write(d(p)),p=L.$Ed.alloc(Math.min(v.bufferSize,typeof k=="number"?k:v.bufferSize)),t=0);while(f>0&&(typeof k!="number"||k>0)&&u(w)&&l(h,v));if(t>0){let a=t;typeof k=="number"&&(a=Math.min(t,k)),g.write(d(p.slice(0,a)))}}catch(h){throw(0,A.$fk)(h)}finally{await O.close($)}}function u(O){if(O.isCancellationRequested)throw(0,D.$4)();return!0}function l(O,S){if(typeof S?.limits?.size=="number"&&O>S.limits.size)throw(0,A.$ek)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class y extends R.$jc{constructor(){super(...arguments),this.a=this.B(new L.$ed),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$ed),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(l){const O=this.j(l),S=O.filter(d=>{const v=this.c.get(d.path);return v?!(0,D.$uj)(v.request.excludes,d.excludes)||!(0,D.$uj)(v.request.includes,d.includes):!0}),g=Array.from(this.c.values()).filter(({request:d})=>!O.find(v=>v.path===d.path&&(0,D.$uj)(v.excludes,d.excludes)&&(0,D.$uj)(v.includes,d.includes))).map(({request:d})=>d.path);S.length&&this.m(`Request to start watching: ${S.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const d of g)this.h(d);for(const d of S)this.g(d)}g(l){const O=new N.$Wp(l,g=>this.a.fire(g),g=>this.b.fire(g),this.f),S={request:l,instance:O};this.c.set(l.path,S)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const O=this.c.get(l);O&&(this.c.delete(l),O.instance.dispose())}j(l){const O=new Map;for(const S of l){const g=A.$k?S.path:S.path.toLowerCase();O.set(g,S)}return Array.from(O.values())}async setVerboseLogging(l){this.f=l;for(const[,O]of this.c)O.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,O){return O?`[File Watcher (node.js)] ${l} (path: ${O.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Yp=y}),define(ne[118],re([0,1,62,117]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class R extends L.$Ep{constructor(N,y,u){super(N,y,u),this.s()}r(N){return N.add(new D.$Yp)}}e.$Zp=R}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class N extends A.$Fp{constructor(u,l,O){super(u,l,O),this.s()}r(u){const l=u.add(new R.$Qp(L.$1f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(l.onDidProcessExit(({code:O,signal:S})=>this.t(`terminated by itself with code ${O}, signal: ${S}`))),D.ProxyChannel.toService((0,D.$hh)(l.getChannel("watcher")))}}e.$Rp=N}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,N]of R)this.set(A,N)}set(R,A){const N=this.a.get(R);return this.a.set(R,A),N}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$yh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,D,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;const O=!1;class S extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class g{constructor($=new u.$yh,h=!1,f,k=O){this.f=$,this.g=h,this.h=f,this.i=k,this.o=new Set,this.f.set(y.$zh,this),this._globalGraph=k?f?._globalGraph??new N.$3p(p=>p):void 0}createChild($){return new g($,this.g,this,this.i)}invokeFunction($,...h){const f=v.traceInvocation(this.i,$);let k=!1;try{return $({get:b=>{if(k)throw(0,D.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(b,f);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...h)}finally{k=!0,f.stop()}}createInstance($,...h){let f,k;return $ instanceof A.$xh?(f=v.traceCreation(this.i,$.ctor),k=this.j($.ctor,$.staticArguments.concat(h),f)):(f=v.traceCreation(this.i,$),k=this.j($,h,f)),f.stop(),k}j($,h=[],f){const k=y._util.getServiceDependencies($).sort((t,a)=>t.index-a.index),p=[];for(const t of k){const a=this.m(t.id,f);a||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const b=k.length>0?k[0].index:h.length;if(h.length!==b){console.trace(`[createInstance] First service dependency of ${$.name} at position ${b+1} conflicts with ${h.length} static arguments`);const t=b-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,b)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof A.$xh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof A.$xh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const k=new N.$3p(t=>t.id.toString());let p=0;const b=[{id:$,desc:h,_trace:f}];for(;b.length;){const t=b.pop();if(k.lookupOrInsertNode(t),p++>1e3)throw new S(k);for(const a of y._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${$} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.$xh){const s={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};k.insertEdge(t,s),b.push(s)}}}for(;;){const t=k.roots();if(t.length===0){if(!k.isEmpty())throw new S(k);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.$xh){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}k.removeNode(a)}}return this.l($)}s($,h,f=[],k,p){if(this.f.get($)instanceof A.$xh)return this.t($,h,f,k,p);if(this.h)return this.h.s($,h,f,k,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],k,p){if(k){const b=new g(void 0,this.g,this,this.i);b.c=String($);const t=new Map,a=new L.$Wg(()=>{const i=b.j(h,f,p);for(const[s,n]of t){const r=i[s];if(typeof r=="function")for(const c of n)r.apply(i,c)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let c=t.get(s);return c||(c=new l.$sc,t.set(s,c)),(P,E,j)=>{const H=c.push([P,E,j]);return(0,R.$hc)(H)}}if(s in i)return i[s];const n=a.value;let r=n[s];return typeof r!="function"||(r=r.bind(n),i[s]=r),r},set(i,s,n){return a.value[s]=n,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$4p=g;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new v(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation($,h){return $?new v(1,h.name):v.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new v(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;v.f+=$;let h=!1;function f(p,b){const t=[],a=new Array(p+1).join("	");for(const[i,s,n]of b.h)if(s&&n){h=!0,t.push(`${a}CREATES -> ${i}`);const r=f(p+1,n);r&&t.push(r)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];($>2||h)&&v.all.add(k.join(`
`))}}e.$5p=v});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,D,R,A,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0;function u(O){return O.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$Fq=u,e.$Gq=(0,y.$Ah)("languagePackService");let l=class extends D.$jc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new L.$od;setTimeout(()=>S.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const v=g.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some($=>$.startsWith("lp-"))).map(w=>{const $=w.properties.localizedLanguages?.[0],h=u(w);return{...this.f(h,$,w),extensionId:w.identifier.id,galleryExtension:w}});return v.push(this.f("en","English")),v}f(S,g,d){const v=g??S;let w;if(v!==S&&(w=`(${S})`),S.toLowerCase()===R.$v.toLowerCase()&&(w??="",w+=(0,A.localize)(0,null)),d?.installCount){w??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),w+=` $(cloud-download) ${h}`}return{id:S,label:v,description:w}}};e.$Hq=l,e.$Hq=l=$e([se(0,N.$Yn)],l)}),define(ne[6],re([0,1,33,4,42,2,35,13,17,3,11,116,10]),function(J,e,L,D,R,A,N,y,u,l,O,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,g.$Ah)("logService"),e.$5i=(0,g.$Ah)("loggerService");function d(){return new Date().toISOString()}function v(P){return(0,l.$mf)(P)}e.$6i=v;var w;(function(P){P[P.Off=0]="Off",P[P.Trace=1]="Trace",P[P.Debug=2]="Debug",P[P.Info=3]="Info",P[P.Warning=4]="Warning",P[P.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$7i=w.Info;function $(P,E,j){switch(E){case w.Trace:P.trace(j);break;case w.Debug:P.debug(j);break;case w.Info:P.info(j);break;case w.Warning:P.warn(j);break;case w.Error:P.error(j);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function h(P,E=!1){let j="";for(let H=0;H<P.length;H++){let K=P[H];if(K instanceof Error&&(K=(0,L.$li)(K,E)),typeof K=="object")try{K=JSON.stringify(K)}catch{}j+=(H>0?" ":"")+K}return j}class f extends A.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new D.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$9i=f;class k extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...j){this.f(w.Trace)&&this.g(w.Trace,h([E,...j],!0))}debug(E,...j){this.f(w.Debug)&&this.g(w.Debug,h([E,...j]))}info(E,...j){this.f(w.Info)&&this.g(w.Info,h([E,...j]))}warn(E,...j){this.f(w.Warning)&&this.g(w.Warning,h([E,...j]))}error(E,...j){if(this.f(w.Error))if(E instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=E.stack,this.g(w.Error,h(H))}else this.g(w.Error,h([E,...j]))}flush(){}}e.$0i=k;class p extends f{constructor(E=e.$7i){super(),this.setLevel(E),this.g=!y.$i}trace(E,...j){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...j):console.log(`[main ${d()}]`,E,...j))}debug(E,...j){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...j):console.log(`[main ${d()}]`,E,...j))}info(E,...j){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...j):console.log(`[main ${d()}]`,E,...j))}warn(E,...j){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,E,...j):console.warn(`[main ${d()}]`,E,...j))}error(E,...j){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,E,...j):console.error(`[main ${d()}]`,E,...j))}dispose(){}flush(){}}e.$$i=p;class b extends f{constructor(E=e.$7i,j=!0){super(),this.g=j,this.setLevel(E)}trace(E,...j){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...j):console.log(E,...j))}debug(E,...j){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...j):console.log(E,...j))}info(E,...j){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...j):console.log(E,...j))}warn(E,...j){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...j):console.log(E,...j))}error(E,...j){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...j):console.error(E,...j))}dispose(){}flush(){}}e.$_i=b;class t extends f{constructor(E,j=e.$7i){super(),this.g=E,this.setLevel(j)}trace(E,...j){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...j])}debug(E,...j){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...j])}info(E,...j){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...j])}warn(E,...j){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...j])}error(E,...j){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...j])}h(E){return typeof E=="string"?E:(0,L.$li)(E,this.f(w.Trace))}dispose(){}flush(){}}e.$aj=t;class a extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const j of this.g)j.setLevel(E);super.setLevel(E)}trace(E,...j){for(const H of this.g)H.trace(E,...j)}debug(E,...j){for(const H of this.g)H.debug(E,...j)}info(E,...j){for(const H of this.g)H.info(E,...j)}warn(E,...j){for(const H of this.g)H.warn(E,...j)}error(E,...j){for(const H of this.g)H.error(E,...j)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$bj=a;class i extends A.$jc{constructor(E,j,H){if(super(),this.h=E,this.j=j,this.b=new N.$yi,this.c=this.B(new D.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$ed),this.onDidChangeVisibility=this.g.event,H)for(const K of H)this.b.set(K.resource,{logger:void 0,info:K})}m(E){return(0,l.$if)(E)?[...this.b.values()].find(j=>j.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,j){const H=this.n(E),K=(0,l.$if)(E)?E:j?.id??(0,R.$oi)(H.toString()).toString(16);let _=this.b.get(H)?.logger;const ue=j?.logLevel==="always"?w.Trace:j?.logLevel;_||(_=this.s(H,ue??this.getLogLevel(H)??this.h,{...j,id:K}));const te={logger:_,info:{resource:H,id:K,logLevel:ue,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(te.info),this.b.set(H,te),_}n(E){return(0,l.$if)(E)?(0,u.$hg)(this.j,`${E}.log`):E}setLogLevel(E,j){if(O.URI.isUri(E)){const H=E,K=j,_=this.b.get(H);_&&K!==_.info.logLevel&&(_.info.logLevel=K===this.h?void 0:K,_.logger?.setLevel(K),this.b.set(_.info.resource,_),this.f.fire([H,K]))}else{this.h=E;for(const[H,K]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&K.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,j){const H=this.m(E);H&&j!==!H.info.hidden&&(H.info.hidden=!j,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,j]))}getLogLevel(E){let j;return E&&(j=this.b.get(E)?.info.logLevel),j??this.h}registerLogger(E){const j=this.b.get(E.resource);j?j.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const j=this.b.get(E);j&&(j.logger&&j.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=i;class s{constructor(){this.onDidChangeLogLevel=new D.$ed().event}setLevel(E){}getLevel(){return w.Info}trace(E,...j){}debug(E,...j){}info(E,...j){}warn(E,...j){}error(E,...j){}critical(E,...j){}dispose(){}flush(){}}e.$dj=s;class n extends s{}e.$ej=n;function r(P){if(P.verbose)return w.Trace;if(typeof P.logLevel=="string"){const E=I(P.logLevel.toLowerCase());if(E!==void 0)return E}return e.$7i}e.$fj=r;function c(P){switch(P){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$gj=c;function I(P){switch(P){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$hj=I,e.$ij=new S.$1i("logLevel",c(w.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,D,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class O extends N.$jc{constructor(g,d){super(),this.a=g,this.b=d,this.c=this.B(new A.$ed),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ed),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Dg(0)),this.w=[],this.y=this.B(new D.$Dg(0))}watch(g,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(g,d):this.z(g,d)}n(g,d){const v={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,L.$Rb)(this.j,v);return this.r(),(0,N.$hc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,R.$Y)(g))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$Gp)(d)),d=>this.G(d),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const d of this.j)(0,u.$Cp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const d of this.j)(0,u.$Cp)(d)&&g.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,d){const v={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,L.$Rb)(this.w,v);return this.C(),(0,N.$hc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,R.$Y)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,u.$Gp)(g)),g=>this.G(g),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,y.$6d)(g.fsPath)}}e.$Kp=O}),define(ne[122],re([0,1,19,8,14,20,4,42,65,2,46,15,123,17,41,99,12,61,6,9]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;let p=class extends l.$jc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new N.$ed),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$ed),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$ed),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$ed),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$ed),this.onDidFilesChange=this.X.event,this.Y=this.B(new N.$ed),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new D.$Og)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new l.$ic;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(s=>this.X.fire(new $.$kk(s,!this.S(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(s=>this.Y.fire(new Error(s)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,l.$hc)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,l.$ec)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await D.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,d.$lg)(t))throw new $.$mk((0,w.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new k.$_;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async m(t){const a=await this.j(t);if((0,$.$0j)(a)||(0,$.$7j)(a)||(0,$.$$j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,$.$0j)(a)||(0,$.$7j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(i){throw(0,$.$hk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$mk((0,w.localize)(2,null,this.rb(t)),1):(0,$.$fk)(i)}}async s(t,a){const i=await this.j(t),s=this.S(i),n=a?.resolveTo,r=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,I=await i.stat(t);let P;return this.t(i,t,I,void 0,!!c,(E,j)=>(P||(P=O.$Gh.forUris(()=>!s),P.set(t,!0),n&&P.fill(!0,n)),P.get(E.resource)||P.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&r?j===1:!1))}async t(t,a,i,s,n,r){const{providerExtUri:c}=this.R(t),I={resource:a,name:c.basename(a),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$xk)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&r(I,s)){try{const P=await t.readdir(a),E=await D.Promises.settled(P.map(async([j,H])=>{try{const K=c.joinPath(a,j),_=n?await t.stat(K):{type:H};return await this.t(t,K,_,P.length,n,r)}catch(K){return this.b.trace(K),null}}));I.children=(0,L.$Eb)(E)}catch(P){this.b.trace(P),I.children=[]}return I}return I}async resolveAll(t){return D.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.t(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(i){return i}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new $.$mk((0,w.localize)(3,null,this.rb(t)),3,a)}async createFile(t,a=R.$Ed.fromString(""),i){await this.u(t,i);const s=await this.writeFile(t,a);return this.r.fire(new $.$jk(t,0,s)),s}async writeFile(t,a,i){const s=this.pb(await this.n(t),t),{providerExtUri:n}=this.R(s);try{await this.w(s,t,i)||await this.U(s,n.dirname(t));let c;if((0,$.$7j)(s)&&!(a instanceof R.$Ed))if((0,v.$qd)(a)){const I=await(0,v.$xd)(a,3);I.ended?c=R.$Ed.concat(I.buffer):c=I}else c=(0,v.$ud)(a,I=>R.$Ed.concat(I),3);else c=a;if(!(0,$.$0j)(s)||(0,$.$7j)(s)&&c instanceof R.$Ed)await this.gb(s,t,i,c);else{const I=c instanceof R.$Ed?(0,R.$Pd)(c):c;i?.atomic!==!1&&i?.atomic?.postfix?await this.bb(s,t,(0,d.$hg)((0,d.$gg)(t),`${(0,d.$eg)(t)}${i.atomic.postfix}`),i,I):await this.cb(s,t,i,I)}this.r.fire(new $.$jk(t,4))}catch(r){throw new $.$mk((0,w.localize)(4,null,this.rb(t),(0,$.$fk)(r).toString()),(0,$.$ik)(r),i)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,i){const s=!!i?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.rb(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.rb(a)));if(s)throw new Error((0,w.localize)(7,null,this.rb(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&$.FileType.Directory)throw new $.$mk((0,w.localize)(8,null,this.rb(a)),0,i);if(this.qb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$wk&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,$.$xk)({mtime:i.mtime,size:r.size}))throw new $.$mk((0,w.localize)(9,null),3,i);return r}async readFile(t,a,i){const s=await this.m(t);return a?.atomic?this.z(s,t,a,i):this.C(s,t,a,i)}async z(t,a,i,s){return new Promise((n,r)=>{this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{try{const c=await this.C(t,a,i,s);n(c)}catch(c){r(c)}})})}async C(t,a,i,s){const n=await this.D(t,a,{...i,preferUnbuffered:!0},s);return{...n,value:await(0,R.$Qd)(n.value)}}async readFileStream(t,a,i){const s=await this.m(t);return this.D(s,t,a,i)}async D(t,a,i,s){const n=new A.$od(s),r=this.J(a,i).then(I=>I,I=>{throw n.dispose(!0),I});let c;try{return typeof i?.etag=="string"&&i.etag!==$.$wk&&await r,i?.atomic&&(0,$.$_j)(t)||!((0,$.$0j)(t)||(0,$.$$j)(t))||(0,$.$7j)(t)&&i?.preferUnbuffered?c=this.I(t,a,i):(0,$.$$j)(t)?c=this.G(t,a,n.token,i):c=this.H(t,a,n.token,i),c.on("end",()=>n.dispose()),c.on("error",()=>n.dispose()),{...await r,value:c}}catch(I){throw c&&await(0,v.$vd)(c),this.F(I,a,i)}}F(t,a,i){const s=(0,w.localize)(10,null,this.rb(a),(0,$.$fk)(t).toString());return t instanceof $.$ok?new $.$ok(s,t.stat,i):t instanceof $.$nk?new $.$nk(s,t.fileOperationResult,t.size,t.options):new $.$mk(s,(0,$.$ik)(t),i)}G(t,a,i,s=Object.create(null)){const n=t.readFileStream(a,s,i);return(0,v.$Bd)(n,{data:r=>r instanceof R.$Ed?r:R.$Ed.wrap(r),error:r=>this.F(r,a,s)},r=>R.$Ed.concat(r))}H(t,a,i,s=Object.create(null)){const n=(0,R.$Ud)();return(0,h.$Ap)(t,a,n,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.F(r,a,s)},i),n}I(t,a,i){const s=(0,v.$sd)(n=>R.$Ed.concat(n));return(async()=>{try{let n;i?.atomic&&(0,$.$_j)(t)?n=await t.readFile(a,{atomic:!0}):n=await t.readFile(a),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.L(a,n.byteLength,i),s.end(R.$Ed.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async J(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new $.$mk((0,w.localize)(11,null,this.rb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==$.$wk&&a.etag===i.etag)throw new $.$ok((0,w.localize)(12,null),i,a);return this.L(t,i.size,a),i}L(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new $.$nk((0,w.localize)(13,null,this.rb(t)),7,a,i)}async canMove(t,a,i){return this.M(t,a,"move",i)}async canCopy(t,a,i){return this.M(t,a,"copy",i)}async M(t,a,i,s){if(t.toString()!==a.toString())try{const n=i==="move"?this.pb(await this.n(t),t):await this.m(t),r=this.pb(await this.n(a),a);await this.Q(n,t,r,a,i,s)}catch(n){return n}return!0}async move(t,a,i){const s=this.pb(await this.n(t),t),n=this.pb(await this.n(a),a),r=await this.N(s,t,n,a,"move",!!i),c=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$jk(t,r==="move"?2:3,c)),c}async copy(t,a,i){const s=await this.m(t),n=this.pb(await this.n(a),a),r=await this.N(s,t,n,a,"copy",!!i),c=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$jk(t,r==="copy"?3:2,c)),c}async N(t,a,i,s,n,r){if(a.toString()===s.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:I}=await this.Q(t,a,i,s,n,r);if(c&&!I&&r&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),n==="copy"){if(t===i&&(0,$.$8j)(t))await t.copy(a,s,{overwrite:r});else{const P=await this.resolve(a);P.isDirectory?await this.P(t,P,i,s):await this.O(t,a,i,s)}return n}else return t===i?(await t.rename(a,s,{overwrite:r}),n):(await this.N(t,a,i,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async O(t,a,i,s){if((0,$.$0j)(t)&&(0,$.$0j)(i))return this.ib(t,a,i,s);if((0,$.$0j)(t)&&(0,$.$7j)(i))return this.ob(t,a,i,s);if((0,$.$7j)(t)&&(0,$.$0j)(i))return this.mb(t,a,i,s);if((0,$.$7j)(t)&&(0,$.$7j)(i))return this.kb(t,a,i,s)}async P(t,a,i,s){await i.mkdir(s),Array.isArray(a.children)&&await D.Promises.settled(a.children.map(async n=>{const r=this.R(i).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),i,r):this.O(t,n.resource,i,r)}))}async Q(t,a,i,s,n,r){let c=!1;if(t===i){const{providerExtUri:P,isPathCaseSensitive:E}=this.R(t);if(E||(c=P.isEqual(a,s)),c&&n==="copy")throw new Error((0,w.localize)(14,null,this.rb(a),this.rb(s)));if(!c&&P.isEqualOrParent(s,a))throw new Error((0,w.localize)(15,null,this.rb(a),this.rb(s)))}const I=await this.exists(s);if(I&&!c){if(!r)throw new $.$mk((0,w.localize)(16,null,this.rb(a),this.rb(s)),4);if(t===i){const{providerExtUri:P}=this.R(t);if(P.isEqualOrParent(a,s))throw new Error((0,w.localize)(17,null,this.rb(a),this.rb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:c}}R(t){const a=this.S(t);return{providerExtUri:a?d.$0f:d.$_f,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.pb(await this.j(t),t);await this.U(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$jk(t,0,i)),i}async U(t,a){const i=[],{providerExtUri:s}=this.R(t);for(;!s.isEqual(a,s.dirname(a));)try{if(!((await t.stat(a)).type&$.FileType.Directory))throw new Error((0,w.localize)(18,null,this.rb(a)));break}catch(n){if((0,$.$hk)(n)!==$.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(s.basename(a)),a=s.dirname(a)}for(let n=i.length-1;n>=0;n--){a=s.joinPath(a,i[n]);try{await t.mkdir(a)}catch(r){if((0,$.$hk)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.W(t,a)}catch(i){return i}return!0}async W(t,a){const i=this.pb(await this.j(t),t),s=!!a?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,w.localize)(19,null,this.rb(t)));const n=a?.atomic;if(n&&!(i.capabilities&65536))throw new Error((0,w.localize)(20,null,this.rb(t)));if(s&&n)throw new Error((0,w.localize)(21,null,this.rb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.qb(t,r);else throw new $.$mk((0,w.localize)(22,null,this.rb(t)),1);if(!!!a?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,w.localize)(23,null,this.rb(t)))}return i}async del(t,a){const i=await this.W(t,a),s=!!a?.useTrash,n=!!a?.recursive,r=a?.atomic??!1;await i.delete(t,{recursive:n,useTrash:s,atomic:r}),this.r.fire(new $.$jk(t,1))}async cloneFile(t,a){const i=await this.j(t),s=this.pb(await this.n(a),a);if(i===s&&this.R(i).providerExtUri.isEqual(t,a))return;if(i===s&&(0,$.$9j)(i))return i.cloneFile(t,a);await this.U(s,this.R(s).providerExtUri.dirname(a));const n=this.ab.queueFor(t,this.R(i).providerExtUri);return i===s&&(0,$.$8j)(i)?n.queue(()=>i.copy(t,a,{overwrite:!0})):n.queue(()=>this.O(i,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new l.$ic;let s=!1,n=()=>{s=!0};return i.add((0,l.$hc)(()=>n())),(async()=>{try{const r=await this.$(t,a);s?(0,l.$ec)(r):n=()=>(0,l.$ec)(r)}catch(r){this.b.error(r)}})(),i}async $(t,a){const i=await this.j(t),s=(0,y.$oi)([this.R(i).providerExtUri.getComparisonKey(t),a]);let n=this.Z.get(s);return n||(n={count:0,disposable:i.watch(t,a)},this.Z.set(s,n)),n.count+=1,(0,l.$hc)(()=>{n&&(n.count--,n.count===0&&((0,l.$ec)(n.disposable),this.Z.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,l.$ec)(t.disposable);this.Z.clear()}async bb(t,a,i,s,n){await this.cb(t,i,s,n);try{await t.rename(i,a,{overwrite:!0})}catch(r){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async cb(t,a,i,s){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,v.$qd)(s)||(0,v.$rd)(s)?await this.db(t,n,s):await this.eb(t,n,s)}catch(r){throw(0,$.$fk)(r)}finally{await t.close(n)}})}async db(t,a,i){let s=0,n;if((0,v.$rd)(i)){if(i.buffer.length>0){const r=R.$Ed.concat(i.buffer);await this.fb(t,a,r,r.byteLength,s,0),s+=r.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((r,c)=>{(0,v.$wd)(n,{onData:async I=>{n.pause();try{await this.fb(t,a,I,I.byteLength,s,0)}catch(P){return c(P)}s+=I.byteLength,setTimeout(()=>n.resume())},onError:I=>c(I),onEnd:()=>r()})})}async eb(t,a,i){let s=0,n;for(;(n=i.read())!==null;)await this.fb(t,a,n,n.byteLength,s,0),s+=n.byteLength}async fb(t,a,i,s,n,r){let c=0;for(;c<s;){const I=await t.write(a,n+c,i.buffer,r+c,s-c);c+=I}}async gb(t,a,i,s){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(()=>this.hb(t,a,i,s))}async hb(t,a,i,s){let n;s instanceof R.$Ed?n=s:(0,v.$qd)(s)?n=await(0,R.$Qd)(s):(0,v.$rd)(s)?n=await(0,R.$Rd)(s):n=(0,R.$Od)(s),await t.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async ib(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.jb(t,a,i,s))}async jb(t,a,i,s){let n,r;try{n=await t.open(a,{create:!1}),r=await i.open(s,{create:!0,unlock:!1});const c=R.$Ed.alloc(this.a);let I=0,P=0,E=0;do E=await t.read(n,I,c.buffer,P,c.byteLength-P),await this.fb(i,r,c,E,I,P),I+=E,P+=E,P===c.byteLength&&(P=0);while(E>0)}catch(c){throw(0,$.$fk)(c)}finally{await D.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async kb(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.lb(t,a,i,s))}async lb(t,a,i,s){return i.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,a,i,s){return this.ab.queueFor(s,this.R(i).providerExtUri).queue(()=>this.nb(t,a,i,s))}async nb(t,a,i,s){const n=await i.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.fb(i,n,R.$Ed.wrap(r),r.byteLength,0,0)}catch(r){throw(0,$.$fk)(r)}finally{await i.close(n)}}async ob(t,a,i,s){const n=await(0,R.$Qd)(this.H(t,a,A.CancellationToken.None));await this.gb(i,s,void 0,n)}pb(t,a){if(t.capabilities&2048)throw new $.$mk((0,w.localize)(24,null,this.rb(a)),6);return t}qb(t,a){if((a.permissions??0)&$.FilePermission.Readonly)throw new $.$mk((0,w.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===S.Schemas.file?t.fsPath:t.toString(!0)}};e.$Bp=p,e.$Bp=p=$e([se(0,f.$4i)],p)}),define(ne[124],re([0,1,125,169,8,35,14,4,170,2,16,13,17,41,24,101,12,61,121,33,119,118]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f,k,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,k.$li)(a)}`)}})();class t extends f.$Kp{static{this.I=!1}constructor(i,s){super(i,s),this.onDidChangeCapabilities=y.Event.None,this.N=new A.$yi(n=>g.$$f.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(i){try{const{stat:s,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(i));return{type:this.M(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:$.FilePermission.Locked}}catch(s){throw this.eb(s)}}async L(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const s=await v.Promises.readdir(this.H(i),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async r=>{try{let c;r.isSymbolicLink()?c=(await this.stat((0,g.$hg)(i,r.name))).type:c=this.M(r),n.push([r.name,c])}catch(c){this.a.trace(c)}})),n}catch(s){throw this.eb(s)}}M(i,s){let n;return s?.dangling?n=$.FileType.Unknown:i.isFile()?n=$.FileType.File:i.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,s&&(n|=$.FileType.SymbolicLink),n}async O(i){const s=this.H(i);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let n;for(;n=this.N.get(i);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await n.wait();const r=new R.$Eg;return this.N.set(i,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,l.$hc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(i)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(i)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(i,s){let n;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(i)})`),n=await this.O(i));const r=this.H(i);return await v.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{n?.dispose()}}P(i){t.I&&this.a.trace(i)}readFileStream(i,s,n){const r=(0,d.$sd)(c=>N.$Ed.concat(c.map(I=>N.$Ed.wrap(I))).buffer);return(0,h.$Ap)(this,i,r,c=>c.buffer,{...s,bufferSize:256*1024},n),r}async writeFile(i,s,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(i,(0,g.$hg)((0,g.$gg)(i),`${(0,g.$eg)(i)}${n.atomic.postfix}`),s,n):this.R(i,s,n)}async Q(i,s,n,r){await this.R(s,n,r);try{await this.rename(s,i,{overwrite:!0})}catch(c){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}async R(i,s,n){let r;try{const c=this.H(i);if(!n.create||!n.overwrite){if(await v.Promises.exists(c)){if(!n.overwrite)throw(0,$.$ek)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$ek)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(c){throw await this.fb(i,c)}finally{typeof r=="number"&&await this.close(r)}}static{this.X=!0}static configureFlushOnWrite(i){t.X=i}async open(i,s){const n=this.H(i);let r;(0,$.$6j)(s)&&(r=await this.O(i));let c;try{if((0,$.$6j)(s)&&s.unlock)try{const{stat:P}=await v.SymlinkSupport.stat(n);P.mode&128||await v.Promises.chmod(n,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}let I;if((0,$.$6j)(s)){if(S.$i)try{await v.Promises.truncate(n,0),I="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}I||(I="w")}else I="r";c=await v.Promises.open(n,I)}catch(I){throw r?.dispose(),(0,$.$6j)(s)?await this.fb(i,I):this.eb(I)}if(this.S.set(c,0),(0,$.$6j)(s)&&this.W.set(c,i),r){const I=this.U.get(c);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${n})`),this.U.set(c,r),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${n})`),I.dispose())}return c}async close(i){const s=this.U.get(i);try{if(this.S.delete(i),this.W.delete(i)&&t.X)try{await v.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(i)}catch(n){throw this.eb(n)}finally{s&&(this.U.get(i)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.U.delete(i)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,n,r,c){const I=this.Y(i,s);let P=null;try{P=(await v.Promises.read(i,n,r,c,I)).bytesRead}catch(E){throw this.eb(E)}finally{this.Z(i,I,P)}return P}Y(i,s){return s===this.S.get(i)?null:s}Z(i,s,n){const r=this.S.get(i);typeof r=="number"&&(typeof s=="number"||(typeof n=="number"?this.S.set(i,r+n):this.S.delete(i)))}async write(i,s,n,r,c){return(0,R.$Xg)(()=>this.$(i,s,n,r,c),100,3)}async $(i,s,n,r,c){const I=this.Y(i,s);let P=null;try{P=(await v.Promises.write(i,n,r,c,I)).bytesWritten}catch(E){throw await this.fb(this.W.get(i),E)}finally{this.Z(i,I,P)}return P}async mkdir(i){try{await v.Promises.mkdir(this.H(i))}catch(s){throw this.eb(s)}}async delete(i,s){try{const n=this.H(i);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,O.$8d)((0,O.$$d)(n),`${(0,O.$_d)(n)}${s.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,r)}else try{await v.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let c=!1;try{const{stat:I,symbolicLink:P}=await v.SymlinkSupport.stat(n);c=I.isDirectory()&&!P}catch{}if(c)await v.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.eb(n)}}async rename(i,s,n){const r=this.H(i),c=this.H(s);if(r!==c)try{await this.ab(i,s,"move",n.overwrite),await v.Promises.rename(r,c)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(2,null,(0,O.$_d)(r),(0,O.$_d)((0,O.$$d)(c)),I.toString()))),this.eb(I)}}async copy(i,s,n){const r=this.H(i),c=this.H(s);if(r!==c)try{await this.ab(i,s,"copy",n.overwrite),await v.Promises.copy(r,c,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(3,null,(0,O.$_d)(r),(0,O.$_d)((0,O.$$d)(c)),I.toString()))),this.eb(I)}}async ab(i,s,n,r){const c=this.H(i),I=this.H(s);let P=!1;if(!!(this.capabilities&1024)||(P=(0,u.$Gf)(c,I,!0)),P){if(n==="copy")throw(0,$.$ek)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const j=await this.L(i);if(!j)throw(0,$.$ek)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(s);if(H){if(!r)throw(0,$.$ek)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);j.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,s){return this.bb(i,s,!1)}async bb(i,s,n){const r=this.H(i),c=this.H(s),I=!!(this.capabilities&1024);if((0,u.$Gf)(r,c,!I))return;const P=new l.$ic;try{const[E,j]=await Promise.all([this.O(i),this.O(s)]);P.add(E),P.add(j),n&&await v.Promises.mkdir((0,O.$$d)(c),{recursive:!0}),await v.Promises.copyFile(r,c)}catch(E){if(E.code==="ENOENT"&&!n)return this.bb(i,s,!0);throw this.eb(E)}finally{P.dispose()}}t(i,s,n){return new p.$Rp(r=>i(r),r=>s(r),n)}F(i,s,n){return new b.$Zp(r=>i(r),r=>s(r),n)}eb(i){if(i instanceof $.$dk)return i;let s=i,n;switch(i.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$ek)(s,n)}async fb(i,s){let n=this.eb(s);if(i&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await v.SymlinkSupport.stat(this.H(i));r.mode&128||(n=(0,$.$ek)(s,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$1p=t}),define(ne[126],re([0,1,2,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;class R extends L.$jc{constructor(N,y=[]){super(),this.a=new D.$bj([N,...y]),this.B(N.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...y){this.a.trace(N,...y)}debug(N,...y){this.a.debug(N,...y)}info(N,...y){this.a.info(N,...y)}warn(N,...y){this.a.warn(N,...y)}error(N,...y){this.a.error(N,...y)}flush(){this.a.flush()}}e.$gN=R}),define(ne[127],re([0,1,12,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;var R;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(R||(R={}));async function A(l,O,S,g,d){try{const v=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});v.setFlushOn(R.Trace);const w=await v.createAsyncRotatingLogger(l,O,S,g);return d?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(v){console.error(v)}return null}function N(l,O,S){switch(O){case D.LogLevel.Trace:l.trace(S);break;case D.LogLevel.Debug:l.debug(S);break;case D.LogLevel.Info:l.info(S);break;case D.LogLevel.Warning:l.warn(S);break;case D.LogLevel.Error:l.error(S);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function y(l,O){switch(O){case D.LogLevel.Trace:l.setLevel(R.Trace);break;case D.LogLevel.Debug:l.setLevel(R.Debug);break;case D.LogLevel.Info:l.setLevel(R.Info);break;case D.LogLevel.Warning:l.setLevel(R.Warning);break;case D.LogLevel.Error:l.setLevel(R.Error);break;case D.LogLevel.Off:l.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${O}`)}}class u extends D.$0i{constructor(O,S,g,d,v){super(),this.m=[],this.setLevel(v),this.n=this.s(O,S,g,d),this.B(this.onDidChangeLogLevel(w=>{this.r&&y(this.r,w)}))}async s(O,S,g,d){const v=g?6:1,w=30/v*L.$zk.MB,$=await A(O,S,w,v,d);if($){this.r=$,y(this.r,this.getLevel());for(const{level:h,message:f}of this.m)N(this.r,h,f);this.m=[]}}g(O,S){this.r?N(this.r,O,S):this.getLevel()<=O&&this.m.push({level:O,message:S})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$8M=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class A extends D.$cj{s(y,u,l){return new R.$8M((0,L.$3f)(),y.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,u)}}e.$9M=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=void 0,e.$9m=(0,A.$Ah)("policy");class N extends R.$jc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$ed),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const O=Object.keys(this.f).length;return this.f={...l,...this.f},O!==Object.keys(this.f).length&&await this.j(l),D.Iterable.reduce(this.g.entries(),(S,[g,d])=>({...S,[g]:d}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(l,[O,S])=>({...l,[O]:{definition:S,value:this.g.get(O)}}),{})}}e.$0m=N;class y{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$$m=y}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=void 0;function l(S,g){const d=[];for(const v of new Set(R.Iterable.concat(S.keys(),g.keys())))S.get(v)!==g.get(v)&&d.push(v);return d}let O=class extends u.$0m{constructor(g,d,v){super(),this.m=g,this.n=d,this.s=v,this.c=this.B(new L.$Dg(500));const w=D.Event.filter(d.onDidFilesChange,$=>$.affects(g));this.B(d.watch(g)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const d=await this.n.readFile(this.m),v=JSON.parse(d.value.toString());if(!(0,A.$kf)(v))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(v))this.f[w]&&g.set(w,v[w])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return g}async w(){const g=await this.u(),d=l(this.g,g);this.g=g,d.length>0&&this.h.fire(d)}};e.$26b=O,e.$26b=O=$e([se(1,N.$5j),se(2,y.$4i)],O)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=void 0;let y=class extends L.$0m{constructor(l,O){super(),this.m=l,this.n=O,this.a=new D.$zg,this.b=this.B(new A.$kc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((O,S)=>{try{this.b.value=(0,R.createWatcher)(this.n,l,g=>{this.t(g),O()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),S(g)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const O in l){const S=l[O];S===void 0?this.g.delete(O):this.g.set(O,S)}this.h.fire(Object.keys(l))}};e.$16b=y,e.$16b=y=$e([se(0,N.$4i)],y)}),define(ne[31],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,L.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class R{constructor(){this.a=new Map}add(N,y){L.ok(D.$if(N)),L.ok(D.$kf(y)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,y)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$7m=new R}),define(ne[131],re([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function R(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class A{constructor(){this.b=new L.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,l){this.a[R(u)]=l,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const N=new A;D.$7m.add(e.$8m.JSONContribution,N)}),define(ne[44],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var l;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$_m={Configuration:"base.contributions.configuration"};var O;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const S=u.$7m.as(y.$8m.JSONContribution);class g{constructor(){this.h=new Set,this.i=new D.$ed,this.onDidSchemaChange=this.i.event,this.j=new D.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),S.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),S.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),S.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:s,source:n}of t)for(const r in s)if(a.add(r),e.$jn.test(r)){const c=this.a.get(r),I=c?.valuesSources??new Map;if(n)for(const H of Object.keys(s[r]))I.set(H,n);const P={...c?.value||{},...s[r]};this.a.set(r,{source:n,value:P,valuesSources:I});const E=(0,N.$ei)(r),j={type:"object",default:P,description:A.localize(1,null,E),$ref:e.$gn,defaultDefaultValue:P,source:R.$if(n)?void 0:n,defaultValueSource:n};i.push(...w(r)),this.d[r]=j,this.b.properties[r]=j}else{this.a.set(r,{value:s[r],source:n});const c=this.d[r];c&&(this.w(r,c),this.r(r,c))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:s}of t)for(const n in i){const r=this.a.get(n),c=R.$if(s)?s:s?.id,I=R.$if(r?.source)?r?.source:r?.source?.id;if(c===I)if(a.add(n),this.a.delete(n),e.$jn.test(n))delete this.d[n],delete this.b.properties[n];else{const P=this.d[n];P&&(this.w(n,P),this.r(n,P))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,a){const i=s=>{if(s.properties)for(const n in s.properties){a.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,s.properties[n])}s.allOf?.forEach(n=>i(n))};for(const s of t){i(s);const n=this.c.indexOf(s);n!==-1&&this.c.splice(n,1)}}p(t,a=!0,i,s,n=3,r){n=R.$rf(t.scope)?n:t.scope;const c=t.properties;if(c)for(const P in c){const E=c[P];if(a&&k(P,E)){delete c[P];continue}if(E.source=i,E.defaultDefaultValue=c[P].default,this.w(P,E),e.$jn.test(P)?E.scope=void 0:(E.scope=R.$rf(E.scope)?n:E.scope,E.restricted=R.$rf(E.restricted)?!!s?.includes(P):E.restricted),c[P].hasOwnProperty("included")&&!c[P].included){this.f[P]=c[P],delete c[P];continue}else this.d[P]=c[P],c[P].policy?.name&&this.e.set(c[P].policy.name,P);!c[P].deprecationMessage&&c[P].markdownDeprecationMessage&&(c[P].deprecationMessage=c[P].markdownDeprecationMessage),r.add(P)}const I=t.allOf;if(I)for(const P of I)this.p(P,a,i,s,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const s=i.properties;if(s)for(const r in s)this.r(r,s[r]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$an.properties[t]=a,a.scope){case 1:e.$bn.properties[t]=a;break;case 2:e.$cn.properties[t]=a;break;case 6:e.$dn.properties[t]=a;break;case 3:e.$en.properties[t]=a;break;case 4:e.$fn.properties[t]=a;break;case 5:e.$fn.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$an.properties[t],a.scope){case 1:delete e.$bn.properties[t];break;case 2:delete e.$cn.properties[t];break;case 6:delete e.$dn.properties[t];break;case 3:delete e.$en.properties[t];break;case 4:case 5:delete e.$fn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$gn};this.w(a,i),e.$an.properties[a]=i,e.$bn.properties[a]=i,e.$cn.properties[a]=i,e.$dn.properties[a]=i,e.$en.properties[a]=i,e.$fn.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=t,e.$bn.patternProperties[e.$in]=t,e.$cn.patternProperties[e.$in]=t,e.$dn.patternProperties[e.$in]=t,e.$en.patternProperties[e.$in]=t,e.$fn.patternProperties[e.$in]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let s=i?.value,n=i?.source;R.$pf(s)&&(s=a.defaultDefaultValue,n=void 0),R.$pf(s)&&(s=h(a.type)),a.default=s,a.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",v=new RegExp(d,"g");e.$in=`^(${d})+$`,e.$jn=new RegExp(e.$in);function w(b){const t=[];if(e.$jn.test(b)){let a=v.exec(b);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=v.exec(b)}}return(0,L.$Jb)(t)}e.$kn=w;function $(b){return b.reduce((t,a)=>`${t}[${a}]`,"")}e.$ln=$;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=h;const f=new g;u.$7m.add(e.$_m.Configuration,f);function k(b,t){return b.trim()?e.$jn.test(b)?A.localize(7,null,b):f.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,b,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$nn=k;function p(){const b=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))b.push([a,t[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.$on=p}),define(ne[66],re([0,1,19,4,53,2,35,30,3,11,25,44,36]),function(J,e,L,D,R,A,N,y,u,l,O,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function d(a){return Object.isFrozen(a)?a:y.$Vm(a)}class v{constructor(i={},s=[],n=[],r){this.b=i,this.c=s,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof v)return s;const n=new w("");return n.parseRaw(s),n.configurationModel});this.f=i.reduce((s,n)=>n===s?n:s.merge(n),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,O.$ci)(this.contents,i):this.contents}inspect(i,s){const n=this.rawConfiguration.getValue(i),r=s?this.rawConfiguration.getOverrideValue(i,s):void 0,c=s?this.rawConfiguration.override(s).getValue(i):n;return{value:n,override:r,merged:c}}getOverrideValue(i,s){const n=this.i(s);return n?i?(0,O.$ci)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const n of this.overrides)n.identifiers.includes(i)&&s.push(...n.keys);return L.$Jb(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return L.$Jb(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=y.$Um(this.contents),n=y.$Um(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const I of i)if(c.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(s,I.contents);for(const P of I.overrides){const[E]=n.filter(j=>L.$sb(j.identifiers,P.identifiers));E?(this.h(E.contents,P.contents),E.keys.push(...P.keys),E.keys=L.$Jb(E.keys)):n.push(y.$Um(P))}for(const P of I.keys)r.indexOf(P)===-1&&r.push(P)}return new v(s,r,n,c.every(I=>I instanceof v)?void 0:c)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const n={};for(const r of L.$Jb([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[r];const I=s[r];I&&(typeof c=="object"&&typeof I=="object"?(c=y.$Um(c),this.h(c,I)):c=I),n[r]=c}return new v(n,this.keys,this.overrides)}h(i,s){for(const n of Object.keys(s)){if(n in i&&u.$kf(i[n])&&u.$kf(s[n])){this.h(i[n],s[n]);continue}i[n]=y.$Um(s[n])}}i(i){let s=null,n=null;const r=c=>{c&&(n?this.h(n,c):n=y.$Um(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===i?s=c.contents:c.identifiers.includes(i)&&r(c.contents);return r(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,O.$bi)(this.contents,i),S.$jn.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>L.$sb(n.identifiers,(0,S.$kn)(i))),1))}j(i,s,n){(0,O.$ai)(this.contents,i,s,r=>console.error(r)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),S.$jn.test(i)&&this.overrides.push({identifiers:(0,S.$kn)(i),keys:Object.keys(this.contents[i]),contents:(0,O.$_h)(this.contents[i],r=>console.error(r))})}}e.$pn=v;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!u.$rf(i)){const n=this.g(i);this.parseRaw(n,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:n,keys:r,overrides:c,restricted:I,hasExcludedProperties:P}=this.h(i,s);this.b=new v(n,r,c,P?[i]:void 0),this.c=I||[]}g(i){let s={},n=null,r=[];const c=[],I=[];function P(j){Array.isArray(r)?r.push(j):n!==null&&(r[n]=j)}const E={onObjectBegin:()=>{const j={};P(j),c.push(r),r=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const j=[];P(j),c.push(r),r=j,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:P,onError:(j,H,K)=>{I.push({error:j,offset:H,length:K})}};if(i)try{R.$Rm(i,E),s=r[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return s}h(i,s){const n=g.$7m.as(S.$_m.Configuration).getConfigurationProperties(),r=this.i(i,n,!0,s);i=r.raw;const c=(0,O.$_h)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),I=Object.keys(i),P=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:c,keys:I,overrides:P,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(i,s,n,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:c};const I={},P=[];for(const E in i)if(S.$jn.test(E)&&n){const j=this.i(i[E],s,!1,r);I[E]=j.raw,c=c||j.hasExcludedProperties,P.push(...j.restricted)}else{const j=s[E],H=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&P.push(E),!r.exclude?.includes(E)&&(r.include?.includes(E)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&j?.restricted))?I[E]=i[E]:c=!0}return{raw:I,restricted:P,hasExcludedProperties:c}}j(i,s){const n=[];for(const r of Object.keys(i))if(S.$jn.test(r)){const c={};for(const I in i[r])c[I]=i[r][I];n.push({identifiers:(0,S.$kn)(r),keys:Object.keys(c),contents:(0,O.$_h)(c,s)})}return n}}e.$qn=w;class $ extends A.$jc{constructor(i,s,n,r){super(),this.c=i,this.f=s,this.g=r,this.b=this.B(new D.$ed),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,c=>c.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&n.isEqual(c.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=$;class h{constructor(i,s,n,r,c,I,P,E,j,H,K,_,ue){this.a=i,this.b=s,this.c=n,this.overrideIdentifiers=r,this.d=c,this.f=I,this.g=P,this.h=E,this.i=j,this.j=H,this.k=K,this.l=_,this.m=ue}get value(){return d(this.c)}n(i,s,n){const r=i.inspect(s,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,s,n,r,c=new v,I=new v,P=new N.$yi,E=new v,j=new N.$yi){this.c=i,this.d=s,this.f=n,this.g=r,this.h=c,this.i=I,this.j=P,this.l=E,this.m=j,this.a=null,this.b=new N.$yi,this.n=null}getValue(i,s,n){return this.q(i,s,n).getValue(i)}updateValue(i,s,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new v,this.m.set(n.resource,r))):r=this.l,s===void 0?r.removeValue(i):r.setValue(i,s),n.resource||(this.a=null)}inspect(i,s,n){const r=this.q(i,s,n),c=this.u(s.resource,n),I=s.resource?this.m.get(s.resource)||this.l:this.l,P=new Set;for(const E of r.overrides)for(const j of E.identifiers)r.getOverrideValue(i,j)!==void 0&&P.add(j);return new h(i,s,r.getValue(i),P.size?[...P]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,c||void 0,I)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const n=[];if(!s){const{added:r,updated:c,removed:I}=b(this.c,i);s=[...r,...c,...I]}for(const r of s)for(const c of(0,S.$kn)(r)){const I=this.c.getKeysForOverrideIdentifier(c),P=i.getKeysForOverrideIdentifier(c),E=[...P.filter(j=>I.indexOf(j)===-1),...I.filter(j=>P.indexOf(j)===-1),...I.filter(j=>!y.$Ym(this.c.override(c).getValue(j),i.override(c).getValue(j)))];n.push([c,E])}return this.updateDefaultConfiguration(i),{keys:s,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:n,removed:r}=b(this.d,i),c=[...s,...n,...r];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=b(this.applicationConfiguration,i),I=[...s,...n,...r];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=b(this.localUserConfiguration,i),I=[...s,...n,...r];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=b(this.remoteUserConfiguration,i),I=[...s,...n,...r];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:n,removed:r,overrides:c}=b(this.workspaceConfiguration,i),I=[...s,...n,...r];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:c}}compareAndUpdateFolderConfiguration(i,s){const n=this.p.get(i),{added:r,updated:c,removed:I,overrides:P}=b(n,s),E=[...r,...c,...I];return(E.length||!n)&&this.updateFolderConfiguration(i,s),{keys:E,overrides:P}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:c,overrides:I}=b(s,void 0);return{keys:[...n,...r,...c],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,n){let r=this.r(s,n);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}r({resource:i},s){let n=this.s();if(s&&i){const r=s.getFolder(i);r&&(n=this.t(r.uri)||n);const c=this.m.get(i);c&&(n=n.merge(c))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const n=this.s(),r=this.j.get(i);r?(s=n.merge(r),this.b.set(i,s)):s=n}return s}u(i,s){if(s&&i){const n=s.getFolder(i);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:n,overrides:r,keys:c}=this.j.get(s);return i.push([s,{contents:n,overrides:r,keys:c}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(n=>i.add(n))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.i.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r))),[...s.values()]}static parse(i){const s=this.x(i.defaults),n=this.x(i.policy),r=this.x(i.application),c=this.x(i.user),I=this.x(i.workspace),P=i.folders.reduce((E,j)=>(E.set(l.URI.revive(j[0]),this.x(j[1])),E),new N.$yi);return new f(s,n,r,c,new v,I,P,new v,new N.$yi)}static x(i){return new v(i.contents,i.keys,i.overrides)}}e.$sn=f;function k(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,s=new Map;for(const r of a)r.keys.forEach(c=>i.add(c)),r.overrides.forEach(([c,I])=>{const P=(0,N.$vi)(s,c,new Set);I.forEach(E=>P.add(E))});const n=[];return s.forEach((r,c)=>n.push([c,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.$tn=k;class p{constructor(i,s,n,r){this.change=i,this.f=s,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of i.keys)this.affectedKeys.add(c);for(const[,c]of i.overrides)for(const I of c)this.affectedKeys.add(I);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,s){const n=this.a+i,r=this.d.indexOf(n);if(r<0)return!1;const c=r+n.length;if(c>=this.d.length)return!1;const I=this.d.charCodeAt(c);if(I!==this.b&&I!==this.c)return!1;if(s){const P=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,E=this.g.getValue(i,s,this.h);return!y.$Ym(P,E)}return!0}}e.$un=p;function b(a,i){const{added:s,removed:n,updated:r}=t(i?.rawConfiguration,a?.rawConfiguration),c=[],I=a?.getAllOverrideIdentifiers()||[],P=i?.getAllOverrideIdentifiers()||[];if(i){const E=P.filter(j=>!I.includes(j));for(const j of E)c.push([j,i.getKeysForOverrideIdentifier(j)])}if(a){const E=I.filter(j=>!P.includes(j));for(const j of E)c.push([j,a.getKeysForOverrideIdentifier(j)])}if(i&&a){for(const E of I)if(P.includes(E)){const j=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});c.push([E,[...j.added,...j.removed,...j.updated]])}}return{added:s,removed:n,updated:r,overrides:c}}function t(a,i){const s=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],n=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],r=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const I=(0,O.$ci)(i.contents,c),P=(0,O.$ci)(a.contents,c);y.$Ym(I,P)||r.push(c)}}return{added:s,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,44,6,38,36]),function(J,e,L,D,R,A,N,y,u,l,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=void 0;class g extends R.$jc{constructor(){super(...arguments),this.a=this.B(new D.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new y.$pn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$7m.as(u.$_m.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,S.$7m.as(u.$_m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new y.$pn;const $=S.$7m.as(u.$_m.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const k of $){const p=f[k],b=h[k];p!==void 0?this.b.addValue(k,p):b?this.b.addValue(k,b.default):this.b.removeValue(k)}}}e.$vn=g;class d{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new y.$pn}async initialize(){return this.configurationModel}}e.$wn=d;let v=class extends R.$jc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new D.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new y.$pn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],k=S.$7m.as(u.$_m.Configuration).getConfigurationProperties();for(const p of $){const b=k[p];if(!b){f.push(p);continue}if(b.policy){if(b.type!=="string"&&b.type!=="number"){this.g.warn(`Policy ${b.policy.name} has unsupported type ${b.type}`);continue}f.push(p),h[b.policy.name]={type:b.type}}}return(0,N.$vf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=S.$7m.as(u.$_m.Configuration).getPolicyConfigurations(),f=(0,L.$Eb)($.map(k=>h.get(k)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=S.$7m.as(u.$_m.Configuration).getConfigurationProperties(),k=[],p=this.b.isEmpty();for(const b of $){const t=f[b]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(p?a!==void 0:!(0,A.$Ym)(this.b.getValue(b),a))&&k.push([b,a])}else this.b.getValue(b)!==void 0&&k.push([b,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const b=this.b;this.b=new y.$pn;for(const t of b.keys)this.b.setValue(t,b.getValue(t));for(const[t,a]of k)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};e.$xn=v,e.$xn=v=$e([se(1,O.$9m),se(2,l.$4i)],v)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,D,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=void 0;class O extends R.$jc{constructor(g,d,v,w){super(),this.j=g,this.h=this.B(new D.$ed),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$vn),this.c=v instanceof l.$$m?new u.$wn:this.B(new u.$xn(this.b,v,w)),this.f=this.B(new y.$rn(this.j,{},A.$$f,d)),this.a=new y.$sn(this.b.configurationModel,this.c.configurationModel,new y.$pn,new y.$pn),this.g=this.B(new L.$Rg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,d,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new y.$sn(g,d,new y.$pn,v)}getConfigurationData(){return this.a.toData()}getValue(g,d){const v=typeof g=="string"?g:void 0,w=(0,N.$8h)(g)?g:(0,N.$8h)(d)?d:{};return this.a.getValue(v,w,void 0)}updateValue(g,d,v,w){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const d=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(v,d,2)}n(g,d){const v=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(g,d);this.s(w,v,7)}r(g){const d=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(g);this.s(v,d,7)}s(g,d,v){const w=new y.$un(g,{data:d},this.a);w.source=v,w.sourceConfig=this.t(v),this.h.fire(w)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$yn=O}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function D(l){return l.scheme===L.Schemas.vscodeRemote?l.authority:void 0}e.$Nk=D;function R(l){if(!l)return;const O=l.indexOf("+");return O<0?l:l.substr(0,O)}e.$Ok=R;function A(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$Pk=A;function N(l){const{host:O,port:S}=u(l);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:S}}e.$Qk=N;function y(l,O){let{host:S,port:g}=u(l);return typeof g>"u"&&(g=O),{host:S,port:g}}e.$Rk=y;function u(l){const O=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const S=l.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const g=l.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:l,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Sl=A,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(N||(e.ExtensionType=N={}));var y;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(y||(e.TargetPlatform=y={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,k=typeof h=="string"?h:h.value;return L.$Le(f,k)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Ul=u;class l{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$Vl=l;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=O;function S(w){return g(w)}e.$Xl=S;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Yl=g;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$Zl=d;function v(w,$){if($){const h=`onResolveRemoteAuthority:${(0,R.$Ok)($)}`;return!!w.activationEvents?.includes(h)}return!1}e.$1l=v,e.$2l=(0,D.$Ah)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;class A extends L.$jc{constructor(y,u,l,O,S){super(),this.a=y,this.b=u,this.c=l,this.f=S,this.B(O.onDidInstallExtensions(g=>this.g(g))),this.B(O.onDidUninstallExtension(g=>this.h(g)))}g(y){for(const u of y)u.local&&this.invalidate(u.profileLocation)}h(y){y.error||this.invalidate(y.profileLocation)}async invalidate(y){if(y)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,y)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(y){try{await this.b.del(this.c.extUri.joinPath(y.cacheHome,D.$Ol))}catch(u){(0,R.$ik)(u)!==1&&this.f.error(u)}}}e.$up=A}),define(ne[45],re([0,1,14,9,2,103,44,10,6,36]),function(J,e,L,D,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Ho=(0,y.$Ah)("requestService");class O{constructor(b){this.b=b}toJSON(){if(!this.a){const b=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?b[t]="*****":b[t]=this.b[t];this.a=b}return this.a}}class S extends R.$jc{constructor(b){super(),this.b=0,this.a=b.createLogger("network",{name:(0,A.localize)(0,null),when:u.$ij.isEqualTo((0,u.$gj)(u.LogLevel.Trace)).serialize()})}async c(b,t,a){const i=`${b} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new O(t.headers??{}));try{const s=await a();return this.a.trace(`${i} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${i} - error`,t.type,(0,D.$8)(s)),s}}}e.$Io=S;function g(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Jo=g;function d(p){return p.res.statusCode===204}async function v(p){return d(p)?null:(await(0,L.$Qd)(p.stream)).toString()}e.$Ko=v;async function w(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);return v(p)}e.$Lo=w;async function $(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,L.$Qd)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Mo=$;function h(p){k(p)}e.$No=h;let f;function k(p){const b=l.$7m.as(N.$_m.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},b.updateConfigurations({add:[f],remove:t?[t]:[]})}k(1)}),define(ne[135],re([0,1,20,15,12,45]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;let N=class{constructor(u,l){this.a=u,this.b=l}async download(u,l,O=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,l);return}const S={type:"GET",url:u.toString(!0)},g=await this.a.request(S,O);if(g.res.statusCode===200)await this.b.writeFile(l,g.stream);else{const d=await(0,A.$Lo)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${d}`)}}};e.$vN=N,e.$vN=N=$e([se(0,A.$Ho),se(1,R.$5j)],N)}),define(ne[136],re([0,1,137,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;function R(N,y){return N.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:N.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function A(N,y,u={}){const l=(0,L.parse)(N),O=u.proxyUrl||R(l,y);if(!O)return null;const S=(0,L.parse)(O);if(!/^https?:$/.test(S.protocol||""))return null;const g={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,D.$of)(u.strictSSL)?u.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((d,v)=>{J(["http-proxy-agent"],d,v)}))(g):new(await new Promise((d,v)=>{J(["https-proxy-agent"],d,v)}))(g)}e.$Lq=A}),define(ne[138],re([0,1,58,16,104,20,33,9,13,28,84,172,8,72]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0;let v;async function w(h,f,k,p){return k["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.$Fl)(p)&&!k["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.$Fl)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=g.Promises.withAsyncBody(async(b,t)=>{const a=new A.$od;let i=1e4;const s=h.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,d.$Gl)(s,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{b(await $(f,a.token))}catch(r){!(0,y.$2)(r)&&!a.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,N.$li)(r)))):b({})}finally{clearTimeout(n),a.dispose()}})),v)}e.$Ll=w;async function $(h,f){const k=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",k);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const b=(0,l.$3f)().replace(/-/g,"").substr(0,12),t=new RegExp(b+"({.*})"+b),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",a);const i=await(0,O.$vl)(u.OS,a);return h.trace("getUnixShellEnvironment#shell",i),new Promise((s,n)=>{if(f.isCancellationRequested)return n(new y.$3);const r=(0,D.$_d)(i);let c,I;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(c=`& '${process.execPath}' ${P} -p '''${b}'' + JSON.stringify(process.env) + ''${b}'''`,I=["-Login","-Command"]):r==="nu"?(c=`^'${process.execPath}' ${P} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,I=["-i","-l","-c"]):(c=`'${process.execPath}' ${P} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,r==="tcsh"||r==="csh"?I=["-ic"]:I=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),c);const E=(0,L.spawn)(i,[...I,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(E.kill(),n(new y.$3))),E.on("error",K=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,N.$li)(K)),n(K)});const j=[];E.stdout.on("data",K=>j.push(K));const H=[];E.stderr.on("data",K=>H.push(K)),E.on("close",(K,_)=>{const ue=Buffer.concat(j).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(H).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),K||_)return n(new Error((0,R.localize)(2,null,K,_)));const ae=t.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);k?ie.ELECTRON_RUN_AS_NODE=k:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),s(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,N.$li)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=void 0,e.$0M=(0,L.$Ah)("stateReadService"),e.$$M=(0,L.$Ah)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=e.$_M=e.SaveStrategy=void 0;var l;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class O extends R.$jc{constructor(v,w,$,h){super(),this.h=v,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new L.$Dg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,w){const $=this.a[v];return(0,A.$rf)($)?w:$}setItem(v,w){this.setItems([{key:v,data:w}])}setItems(v){let w=!1;for(const{key:$,data:h}of v)this.a[$]!==h&&((0,A.$rf)(h)?(0,A.$pf)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=h,w=!0));w&&this.r()}removeItem(v){(0,A.$pf)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,D.$Ed.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$_M=O;let S=class extends R.$jc{constructor(v,w,$,h){super(),this.a=this.B(new O(w.stateResource,v,$,h))}async init(){await this.a.init()}getItem(v,w){return this.a.getItem(v,w)}};e.$aN=S,e.$aN=S=$e([se(1,N.$Hh),se(2,u.$4i),se(3,y.$5j)],S);class g extends S{setItem(v,w){this.a.setItem(v,w)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$bN=g}),define(ne[69],re([0,1,13,34,28]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function A(u){if(L.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function N(u,l,O,S,g,d,v,w){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,R.$3f)()+Date.now(),$.commitHash=S,$.version=g,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$h)(L.$t),$["common.nodePlatform"]=D.$2d,$["common.nodeArch"]=O,$["common.product"]=w||"desktop",v&&($["common.msftInternal"]=v);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$l&&($["common.snap"]="true");const k=A(l);return k&&($["common.platformDetail"]=k),$}e.$9n=N;function y(u){const l=D.env.USERDNSDOMAIN;if(!l)return!1;const O=l.toLowerCase();return u.some(S=>O===S)}e.$0n=y}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,L.$Ah)("telemetryService"),e.$9k=(0,L.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$$n=l;class O{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=O,e.$ao=new O;class S{async publicLog(n,r,c){}async publicLogError(n,r,c){}}e.$bo=S,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function g(s,n){return R.Event.debounce(n.onDidChangeConfiguration,(c,I)=>{const P=c?new Set([...c.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:P}},1e3,!0)(c=>{c.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,A.$0h)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.$fo=g;function d(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry||n.extensionTestsLocationURI)}e.$go=d;function v(s,n){return!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$ho=v;function w(s){const n=s.getValue(u.$cl),r=s.getValue(u.$dl);if(s.getValue(u.$el)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=w;function $(s){const n={},r={},c={};k(s,c);for(let I in c){I=I.length>150?I.substr(I.length-149):I;const P=c[I];typeof P=="number"?r[I]=P:typeof P=="boolean"?r[I]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${P.length}`),n[I]=P.substring(0,8191)):typeof P<"u"&&P!==null&&(n[I]=P)}return{properties:n,measurements:r}}e.$jo=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(s){if(!s)return"none";const n=(0,N.$Ok)(s);return h.has(n)?n:"other"}e.$ko=f;function k(s,n,r=0,c){if(s)for(const I of Object.getOwnPropertyNames(s)){const P=s[I],E=c?c+I:I;Array.isArray(P)?n[E]=(0,L.$Zm)(P):P instanceof Date?n[E]=P.toISOString():(0,D.$kf)(P)?r<2?k(P,n,r+1,E+"."):n[E]=(0,L.$Zm)(P):n[E]=P}}function p(s,n){const r=s.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,y.$0n)(r)||c}e.$lo=p;function b(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$mo=b;function t(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const c=[];for(const j of n)for(;;){const H=j.exec(s);if(!H)break;c.push([H.index,j.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(r="";;){const j=P.exec(s);if(!j)break;const H=c.some(([K,_])=>j.index<_&&K<P.lastIndex);!I.test(j[0])&&!H&&(r+=s.substring(E,j.index)+"<REDACTED: user-file-path>",E=P.lastIndex)}return E<s.length&&(r+=s.substr(E)),r}function a(s){if(!s)return s;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function i(s,n){return(0,L.$Wm)(s,r=>{if(r instanceof l||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=t(c,n);for(const I of n)c=c.replace(I,"");return c=a(c),c}})}e.$no=i}),define(ne[27],re([0,1,29,21,37,13,11,9,34,39]),function(J,e,L,D,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function O(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,L.$Ge)(i.id,s.id)===0}e.$oo=O;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const n=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,n,r)}static parse(s){const n=S.exec(s);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?O(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$po=g;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(i){const s=d.exec(i);return s&&s[1]?[$(s[1]),s[2]]:[$(i),void 0]}e.$qo=v;function w(i,s){return`${i}.${s}`}e.$ro=w;function $(i){return i.toLowerCase()}e.$so=$;function h(i,s){return $(w(i??R.$Ql,s))}e.$to=h;function f(i,s){const n=[],r=c=>{for(const I of n)if(I.some(P=>O(s(P),s(c))))return I;return null};for(const c of i){const I=r(c);I?I.push(c):n.push([c])}return n}e.$uo=f;function k(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$vo=k;function p(i){return{id:new l.$$n(i.identifier.id),name:new l.$$n(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$wo=p,e.$xo=new R.$Ul("pprice.better-merge");function b(i,s){const n=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&n.every(I=>!O(I.identifier,{id:c}))){const I=i.filter(P=>O(P.identifier,{id:c}));I.length===1&&(n.push(I[0]),r.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$yo=b;async function t(i,s){if(!A.$k)return!1;let n;try{n=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,y.$8)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,s){const n=await t(i,s),r=(0,D.$Tn)(n?"alpine":A.$t,u.$3d);return s.debug("ComputeTargetPlatform:",r),r}e.$zo=a}),define(ne[140],re([0,1,20,9,15,17,43,11,93,21,27,37]),function(J,e,L,D,R,A,N,y,u,l,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=void 0;const g=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function v($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let w=class{constructor(h,f,k){this.a=h,this.b=f,this.d=k}get f(){}async listExtensions(h,f,k){let p=await this.b.getInstalled(1,k);const b=S.$Tl.map(a=>a.toLowerCase());if(f&&f!==""){if(b.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(s=>s.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),b.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(v(a.manifest,h)))}async installExtensions(h,f,k,p){const b=[];try{const t=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const a=[];let i=[];const s=(r,c,I)=>{i.push({id:r,version:c!=="prerelease"?c:void 0,installOptions:{...k,isBuiltin:I,installPreReleaseVersion:c==="prerelease"||k.installPreReleaseVersion}})};for(const r of h)if(r instanceof y.URI)a.push({vsix:r,installOptions:k});else{const[c,I]=(0,O.$qo)(r);s(c,I,!1)}for(const r of f)if(r instanceof y.URI)a.push({vsix:r,installOptions:{...k,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,I]=(0,O.$qo)(r);s(c,I,!0)}const n=await this.b.getInstalled(1,k.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:r,installOptions:c})=>{try{const I=await this.g(r,c,p,n);I&&t.push(I)}catch(I){this.a.error(I),b.push(r.toString())}})),i.length&&(i=i.filter(({id:r,version:c})=>{const I=n.find(P=>(0,O.$oo)(P.identifier,{id:r}));if(I){if(!p&&(!c||c==="prerelease"&&I.preRelease))return this.a.info((0,u.localize)(5,null,r,I.manifest.version,r)),!1;if(c&&I.manifest.version===c)return this.a.info((0,u.localize)(6,null,`${r}@${c}`)),!1}return!0}),i.length)){const r=await this.h(i);await Promise.all(i.map(async c=>{const I=r.get(c.id.toLowerCase());if(I)try{const P=await this.j(c,I,n);P&&t.push(P)}catch(P){this.a.error(P.message||P.stack||P),b.push(c.id)}else this.a.error(`${g(c.version?`${c.id}@${c.version}`:c.id)}
${d}`),b.push(c.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,D.$8)(t))),t}if(b.length)throw new Error((0,u.localize)(8,null,b.join(", ")))}async g(h,f,k,p){const b=await this.b.getManifest(h);if(!b)throw new Error("Invalid vsix");if(await this.l(b,k,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,A.$eg)(h))),b}catch(a){if((0,D.$2)(a))return this.a.info((0,u.localize)(10,null,(0,A.$eg)(h))),null;throw a}return null}async h(h){const f=new Map,k=h.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),b=[];for(const t of h)l.$Mn.test(t.id)&&b.push({...t,preRelease:k});if(b.length){const t=await this.d.getExtensions(b,{targetPlatform:p},L.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:h,version:f,installOptions:k},p,b){const t=await this.d.getManifest(p,L.CancellationToken.None);if(t&&!this.k(t))return null;const a=b.find(i=>(0,O.$oo)(i.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{k.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const i=await this.b.installFromGallery(p,{...k,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,i.manifest.version)),t}catch(i){if((0,D.$2)(i))return this.a.info((0,u.localize)(18,null,h)),null;throw i}}k(h){return!0}async l(h,f,k,p){if(!f){const b={id:(0,O.$to)(h.publisher,h.name)},t=p.find(a=>(0,O.$oo)(b,a.identifier)&&(0,N.gt)(a.manifest.version,h.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,k){const p=async t=>{if(t instanceof y.URI){const a=await this.b.getManifest(t);return v(a)}return t},b=[];for(const t of h){const a=await p(t),s=(await this.b.getInstalled(void 0,k)).filter(n=>(0,O.$oo)(n.identifier,{id:a}));if(!s.length)throw new Error(`${this.m(a)}
${d}`);if(s.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,a));return}if(!f&&s.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,a));return}this.a.info((0,u.localize)(22,null,a));for(const n of s)await this.b.uninstall(n,{profileLocation:k}),b.push(n);this.f?this.a.info((0,u.localize)(23,null,a,this.f)):this.a.info((0,u.localize)(24,null,a))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(k=>{f.forEach(p=>{if(p.identifier.id===k&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$7o=w,e.$7o=w=$e([se(1,l.$1n),se(2,l.$Yn)],w)}),define(ne[141],re([0,1,4,2,35,27,37]),function(J,e,L,D,R,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;class y extends D.$jc{constructor(l,O,S,g,d,v,w){super(),this.f=l,this.g=O,this.h=S,this.j=g,this.m=d,this.n=v,this.r=w,this.a=this.B(new L.$ed),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$rc),this.s().then(null,$=>w.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(l=>this.u(l.added))),this.B(this.j.onAddExtensions(l=>this.w(l))),this.B(this.j.onDidAddExtensions(l=>this.y(l))),this.B(this.j.onRemoveExtensions(l=>this.z(l))),this.B(this.j.onDidRemoveExtensions(l=>this.C(l))),this.B(this.n.onDidFilesChange(l=>this.D(l)))}async u(l){try{l.length&&await Promise.all(l.map(O=>(this.c.set(O.id,(0,D.$gc)(this.n.watch(this.m.extUri.dirname(O.extensionsResource)),this.n.watch(O.extensionsResource))),this.G(O.extensionsResource))))}catch(O){throw this.r.error(O),O}}async w(l){for(const O of l.extensions)this.I(this.L(O.identifier,O.version),l.profileLocation)}async y(l){for(const O of l.extensions){const S=this.L(O.identifier,O.version);l.error?this.J(S,l.profileLocation):this.I(S,l.profileLocation)}}async z(l){for(const O of l.extensions)this.J(this.L(O.identifier,O.version),l.profileLocation)}async C(l){const O=[],S=[];for(const g of l.extensions){const d=this.L(g.identifier,g.version);l.error?this.I(d,l.profileLocation):(this.J(d,l.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),S.push(this.f.scanInstalledExtensionAtLocation(g.location).then(v=>{v?O.push(v):this.r.info("Extension not found at the location",g.location.toString())},v=>this.r.error(v)))))}try{await Promise.all(S),O.length&&await this.H(O)}catch(g){this.r.error(g)}}D(l){for(const O of this.h.profiles)l.contains(O.extensionsResource,0,1)&&this.F(O.extensionsResource)}async F(l){const O=[],S=[],g=await this.j.scanProfileExtensions(l),d=new Set,v=new Set;for(const[w,$]of this.b)$.has(l)&&v.add(w);for(const w of g){const $=this.L(w.identifier,w.version);d.add($),v.has($)||(O.push(w.identifier),this.I($,l))}for(const w of v)if(!d.has(w)){const $=this.M(w);$&&(S.push($.identifier),this.J(w,l))}(O.length||S.length)&&this.a.fire({added:O.length?{extensions:O,profileLocation:l}:void 0,removed:S.length?{extensions:S,profileLocation:l}:void 0})}async G(l){const O=await this.j.scanProfileExtensions(l);for(const S of O)this.I(this.L(S.identifier,S.version),l)}async H(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}I(l,O){let S=this.b.get(l);S||this.b.set(l,S=new R.$zi(g=>this.m.extUri.getComparisonKey(g))),S.add(O)}J(l,O){const S=this.b.get(l);S&&S.delete(O),S?.size||this.b.delete(l)}L(l,O){return`${N.$Ul.toKey(l.id)}@${O}`}M(l){const[O,S]=(0,A.$qo)(l);return S?{identifier:{id:O},version:S}:void 0}}e.$vp=y}),define(ne[142],re([0,1,113,39]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0;async function R(A,N,y,u,l,O,S){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${N.nameShort})`};if((0,D.$go)(N,y)&&(0,D.$io)(u)===3){const d=await(0,L.$Zo)(y,l,O);g["X-Market-User-Id"]=d,g["VSCode-SessionId"]=S.machineId||d}return g}e.$1o=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let w=class extends d.$Hq{constructor(k,p,b,t){super(b),this.h=k,this.j=t,this.g=this.B(new $(p,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(k,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.j.warn(`No language pack found for ${p}`);return}const a=t.translations[k];return a?v.URI.file(a):void 0}async getInstalledLanguages(){const k=await this.g.getLanguagePacks(),p=Object.keys(k).map(b=>{const t=k[b];return{...this.f(b,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((b,t)=>b.label.localeCompare(t.label)),p}async m(k){k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",k.identifier.id),await this.update())}async n(k){const p=await this.g.getLanguagePacks();Object.keys(p).some(b=>p[b]&&p[b].extensions.some(t=>(0,S.$oo)(t.extensionIdentifier,k.identifier)))&&(this.j.info("Removing language packs from the extension",k.identifier.id),await this.update())}async update(){const[k,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),b=await this.g.update(p);return!(0,D.$sb)(Object.keys(k),Object.keys(b))}};e.$Iq=w,e.$Iq=w=$e([se(0,O.$1n),se(1,l.$Ih),se(2,O.$Yn),se(3,g.$4i)],w);let $=class extends A.$jc{constructor(k,p){super(),this.j=p,this.c={},this.f=(0,y.$8d)(k.userDataPath,"languagepacks.json"),this.g=new R.$Mg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(k){return this.s(p=>{Object.keys(p).forEach(b=>delete p[b]),this.m(p,...k)}).then(()=>this.c)}m(k,...p){for(const b of p)b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&this.n(k,b);Object.keys(k).forEach(b=>this.r(k[b]))}n(k,p){const b=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===N.Schemas.file&&h(a)){let i=k[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},k[a.languageId]=i);const s=i.extensions.filter(n=>(0,S.$oo)(n.extensionIdentifier,b))[0];s?s.version=p.manifest.version:i.extensions.push({extensionIdentifier:b,version:p.manifest.version});for(const n of a.translations)i.translations[n.id]=(0,y.$8d)(p.location.fsPath,n.path)}}r(k){if(k){const p=(0,L.createHash)("md5");for(const b of k.extensions)p.update(b.extensionIdentifier.uuid||b.extensionIdentifier.id).update(b.version);k.hash=p.digest("hex")}}s(k=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,b=>b.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(b)).then(b=>{try{return JSON.parse(b)}catch{return{}}}).then(b=>(p=k(b),b)).then(b=>{for(const a of Object.keys(b))b[a]||delete b[a];this.c=b,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>p,b=>this.j.error(b))})}};$=$e([se(0,l.$Ih),se(1,g.$4i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const k of f.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",y="https://mobile.events.data.microsoft.com/ping";async function u(O,S,g){const d=await(0,L.$0C)("@microsoft/1ds-core-js","dist/ms.core.js"),v=await(0,L.$0C)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new d.AppInsightsCore,$=new v.PostChannel,h={instrumentationKey:O,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(g){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[$.identifier]=f}return w.initialize(h,[]),w.addTelemetryInitializer(f=>{S&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),w}class l{constructor(S,g,d,v,w){this.e=S,this.f=g,this.g=d,this.h=w,this.c=N,this.d=y,this.g||(this.g={}),typeof v=="function"?this.a=v():this.a=v,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(g=>{S(g)},g=>{(0,D.$Y)(g),console.error(g)})}}log(S,g){if(!this.a)return;g=(0,R.$Xm)(g,this.g),g=(0,A.$jo)(g);const d=this.f+"/"+S;try{this.i(v=>{v.pluginVersionString=g?.properties.version??"Unknown",v.track({name:d,baseData:{name:d,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$6M=l}),define(ne[145],re([0,1,2,30,13,29,105,25,44,146,31,36,26,39]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,k){this.k=f,this.l=k,this.d={},this.i=new L.$ic,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$pe)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$pe)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(g.$cl)||p.affectsConfiguration(g.$el)||p.affectsConfiguration(g.$dl))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$io)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const k=f.usage?3:f.error?2:0;h=Math.min(h,k)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,k){this.g<f||(k=(0,D.$Xm)(k,this.d),k=(0,d.$no)(k,this.j),k=(0,D.$Xm)(k,this.c),this.b.forEach(p=>p.log(h,k)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Oq=v,e.$Oq=v=$e([se(1,y.$7h),se(2,O.$jj)],v);function w(){const $=(0,N.localize)(0,null,l.default.nameLong),h=l.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.$o?"":(0,N.localize)(3,null),k=(0,N.localize)(4,null),p=(0,N.localize)(5,null),b=(0,N.localize)(6,null),t=(0,N.localize)(7,null),a=`
|       | ${k} | ${p} | ${b} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}S.$7m.as(u.$_m.Configuration).registerConfiguration({id:g.$bl,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[g.$cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$7m.as(u.$_m.Configuration).registerConfiguration({id:g.$bl,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[g.$el]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,N.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,N.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${g.$cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0;async function N(O,S){const g=await S.request(O,D.CancellationToken.None),d=(await(0,L.$Qd)(g.stream)).toString(),v=g.res.statusCode??200;return{headers:g.res.headers,statusCode:v,responseData:d}}async function y(O){const S={method:O.type,headers:O.headers};return new Promise((d,v)=>{const w=R.request(O.url??"",S,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){v(h)})});w.write(O.data,$=>{$&&v($)}),w.end()})}async function u(O,S,g){const d=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),v={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:d};try{const w=O?await N(v,O):await y(v);g(w.statusCode,w.headers,w.responseData)}catch{g(0,{})}}class l extends A.$6M{constructor(S,g,d,v,w){const $={sendPOST:(h,f)=>{u(S,h,f)}};super(g,d,v,w,$)}}e.$7M=l}),define(ne[148],re([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=void 0;async function R(A,N){const y=Object.create(null),u=(O,S)=>{const g=JSON.parse(O);y[S]=g};if(N){const O=[],S=await D.Promises.readdir(N);for(const d of S)try{(await D.Promises.stat((0,L.$8d)(N,d))).isDirectory()&&O.push(d)}catch{}const g=[];for(const d of O)(await D.Promises.readdir((0,L.$8d)(N,d))).filter(w=>w==="telemetry.json").length===1&&g.push(d);for(const d of g){const v=(await D.Promises.readFile((0,L.$8d)(N,d,"telemetry.json"))).toString();u(v,d)}}let l=(await D.Promises.readFile((0,L.$8d)(A,"telemetry-core.json"))).toString();return u(l,"vscode-core"),l=(await D.Promises.readFile((0,L.$8d)(A,"telemetry-extensions.json"))).toString(),u(l,"vscode-extensions"),JSON.stringify(y,null,4)}e.$m7b=R}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=void 0;async function A(N,y){let u=N.getItem(R.$al);return(typeof u!="string"||L.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,D.$Hm)(y.error.bind(y))),u}e.$H6b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=void 0,e.$Bk=(0,L.$Ah)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class l{static{this._clock=0}constructor(g){this.uri=g,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let O=class{constructor(g){this.g=g,this.c=new u.$ic,this.f=2**16;const d=new Map,v=w=>{let $=d.get(w.scheme);return $===void 0&&($=g.hasProvider(w)&&!this.g.hasCapability(w,1024),d.set(w.scheme,$)),$};this.c.add(y.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new A.$9f(v),this.d=new N.$mr((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,A.$ig)(g));const d=this.d.get(g);return d?d.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new l(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((v,w)=>v[1].time<w[1].time?1:v[1].time>w[1].time?-1:0);l._clock=0,this.d.clear();const d=this.f*.5;for(let v=0;v<d;v++)this.d.set(g[v][0],g[v][1].touch())}};e.$nr=O,e.$nr=O=$e([se(0,R.$5j)],O),(0,D.$kr)(L.$Bk,O,1)}),define(ne[151],re([0,1,4,2,12,41,46,14,3]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;class l extends D.$jc{get capabilities(){return this.f.capabilities&-5}constructor(S,g,d,v){super(),this.c=S,this.f=g,this.g=d,this.h=v,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.$ed),this.onDidChangeFile=this.a.event,this.b=N.$Gh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(w=>this.j(w)))}watch(S,g){this.b.set(S,S);const d=this.f.watch(this.m(S),g);return(0,D.$hc)(()=>{this.b.delete(S),d.dispose()})}stat(S){return this.f.stat(this.m(S))}mkdir(S){return this.f.mkdir(this.m(S))}rename(S,g,d){return this.f.rename(this.m(S),this.m(g),d)}readFile(S){return this.f.readFile(this.m(S),{atomic:!0})}readFileStream(S,g,d){const v=(0,A.$sd)(w=>y.$Ed.concat(w.map($=>y.$Ed.wrap($))).buffer);return(async()=>{try{const w=await this.readFile(S);v.end(w)}catch(w){v.error(w),v.end()}})(),v}readdir(S){return this.f.readdir(this.m(S))}writeFile(S,g,d){return!(0,u.$kf)(d.atomic)&&(0,R.$ak)(this.f)&&(d={...d,atomic:{postfix:".vsctmp"}}),this.f.writeFile(this.m(S),g,d)}delete(S,g){return this.f.delete(this.m(S),g)}copy(S,g,d){if((0,R.$8j)(this.f))return this.f.copy(this.m(S),this.m(g),d);throw new Error("copy not supported")}j(S){const g=[];for(const d of S){if(d.resource.scheme!==this.c)continue;const v=this.n(d.resource);this.b.findSubstr(v)&&g.push({resource:v,type:d.type})}g.length&&(this.h.debug("User data changed"),this.a.fire(g))}m(S){return S.with({scheme:this.c})}n(S){return S.with({scheme:this.g})}}e.$36b=l}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,D,R,A,N,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,y.$Ah)("contextService");function l(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.$Kh=l;function O(s){return typeof s?.id=="string"&&!l(s)&&!g(s)}e.$Lh=O,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function S(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,D.$_d)(s)}:n?e.$Mh:e.$Nh;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Oh=S;function g(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.$Ph=g;function d(s){const n=s;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Qh=d;var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function w(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Rh=w;function $(s){const n=s;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Sh=$;class h{constructor(n,r,c,I,P){this.h=n,this.j=c,this.k=I,this.l=P,this.c=R.$Gh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$Gh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=h;class f{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$hg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=f;function k(s){return new f({uri:s,index:0,name:(0,A.$dg)(s)},{uri:s.toString()})}e.$Vh=k,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,L.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function p(s,n){return A.$$f.isEqualOrParent(s,n.untitledWorkspacesHome)}e.$1h=p;function b(s){let n;return N.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===u.Schemas.tmp}e.$2h=b,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$3h}e.$4h=t;function a(s,n){return!p(s,n)&&!b(s)}e.$5h=a;function i(s){return(typeof s=="string"?(0,D.$ae)(s):(0,A.$fg)(s))===e.$Xh}e.$6h=i}),define(ne[23],re([0,1,42,4,2,17,11,106,18,12,10,6,152,35,22,8,28,29,3]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.ProfileResourceType=void 0;var k;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(k||(e.ProfileResourceType=k={}));function p(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$Ck=p,e.$Dk=(0,O.$Ah)("IUserDataProfilesService");function b(s,n){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:N.URI.revive(s.location).with({scheme:n}),globalStorageHome:N.URI.revive(s.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(s.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(s.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(s.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(s.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(s.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(s.cacheHome).with({scheme:n}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Ek=b;function t(s,n,r,c,I,P){return{id:s,name:n,location:r,isDefault:!1,shortName:I?.shortName,globalStorageHome:P&&I?.useDefaultFlags?.globalState?P.globalStorageHome:(0,A.$hg)(r,"globalStorage"),settingsResource:P&&I?.useDefaultFlags?.settings?P.settingsResource:(0,A.$hg)(r,"settings.json"),keybindingsResource:P&&I?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,A.$hg)(r,"keybindings.json"),tasksResource:P&&I?.useDefaultFlags?.tasks?P.tasksResource:(0,A.$hg)(r,"tasks.json"),snippetsHome:P&&I?.useDefaultFlags?.snippets?P.snippetsHome:(0,A.$hg)(r,"snippets"),extensionsResource:P&&I?.useDefaultFlags?.extensions?P.extensionsResource:(0,A.$hg)(r,"extensions.json"),cacheHome:(0,A.$hg)(c,s),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$Fk=t;let a=class extends R.$jc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,c,I){super(),this.t=n,this.u=r,this.w=c,this.y=I,this.f=!0,this.h=this.B(new D.$ed),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$ed),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$ed),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$ed),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$yi,emptyWindows:new Map},this.profilesHome=(0,A.$hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const P of this.O()){if(!P.name||!(0,f.$if)(P.name)||!P.location){this.y.warn("Skipping the invalid stored profile",P.location||P.name);continue}r.push(t((0,A.$eg)(P.location),P.name,P.location,this.g,{shortName:P.shortName,useDefaultFlags:P.useDefaultFlags},n))}}catch(P){this.y.error(P)}const c=new d.$yi,I=new Map;if(r.length)try{const P=this.Q();if(P.workspaces)for(const[E,j]of Object.entries(P.workspaces)){const H=N.URI.parse(E),K=r.find(_=>_.id===j);K&&c.set(H,K)}if(P.emptyWindows)for(const[E,j]of Object.entries(P.emptyWindows)){const H=r.find(K=>K.id===j);H&&I.set(E,H)}}catch(P){this.y.error(P)}this.z={profiles:r,workspaces:c,emptyWindows:I}}return this.z}D(){const n=t("__default__profile__",(0,y.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",c=new RegExp(`${(0,h.$pe)(r)}\\s(\\d+)`);let I=0;for(const E of this.profiles){const j=c.exec(E.name),H=j?parseInt(j[1]):0;I=H>I?H:I}const P=`${r} ${I+1}`;return this.createProfile((0,L.$oi)((0,$.$3f)()).toString(16),P,{transient:!0},n)}async createNamedProfile(n,r,c){return this.createProfile((0,L.$oi)((0,$.$3f)()).toString(16),n,r,c)}async createProfile(n,r,c,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=await this.F(n,r,c);return I&&await this.setProfileForWorkspace(I,P),P}async F(n,r,c){if(!(0,f.$if)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(r);return I||(I=(async()=>{try{const P=this.profiles.find(H=>H.name===r||H.id===n);if(P)return P;const E=t(n,r,(0,A.$hg)(this.profilesHome,n),this.g,c,this.defaultProfile);await this.u.createFolder(E.location);const j=[];return this.j.fire({profile:E,join(H){j.push(H)}}),await w.Promises.settled(j),this.I([E],[],[]),E}finally{this.r.delete(r)}})(),this.r.set(r,I)),I}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(I=>I.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=t(c.id,r.name??c.name,c.location,this.g,{shortName:r.shortName??c.shortName,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.I([],[],[c]),c}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(I=>I.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this.m.fire({profile:r,join(I){c.push(I)}});try{await Promise.allSettled(c)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(I){(0,l.$ik)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(I=>I.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,c)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.w.extUri.isEqual(c.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return N.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,g.$Kh)(n)?n.uri:(0,g.$Ph)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,c){const I=[...this.profiles,...n],P=[];this.s.profiles=[];for(let E of I)E.isDefault||r.some(j=>E.id===j.id)||(E=c.find(j=>E.id===j.id)??E,E.isTransient?this.s.profiles.push(E):P.push({location:E.location,name:E.name,shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}));this.P(P),this.z=void 0,this.J(n,r,c)}J(n,r,c){this.h.fire({added:n,removed:r,updated:c,all:this.profiles})}L(n,r,c){c=r?.isTransient?!0:c,c||this.L(n,void 0,!0);const I=this.G(n),P=c?this.s:this.C;N.URI.isUri(I)?(P.workspaces.delete(I),r&&P.workspaces.set(I,r)):(P.emptyWindows.delete(I),r&&P.emptyWindows.set(I,r)),c||this.M()}M(){const n={};for(const[c,I]of this.C.workspaces.entries())n[c.toString()]=I.id;const r={};for(const[c,I]of this.C.emptyWindows.entries())r[c.toString()]=I.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},c=this.D();if(n.workspaces)for(const[P,E]of Object.entries(n.workspaces)){const j=N.URI.parse(E);r[P]=this.w.extUri.isEqual(j,c.location)?c.id:this.w.extUri.basename(j)}const I={};if(n.emptyWindows)for(const[P,E]of Object.entries(n.emptyWindows)){const j=N.URI.parse(E);I[P]=this.w.extUri.isEqual(j,c.location)?c.id:this.w.extUri.basename(j)}return{workspaces:r,emptyWindows:I}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Gk=a,e.$Gk=a=$e([se(0,u.$Hh),se(1,l.$5j),se(2,v.$Bk),se(3,S.$4i)],a);class i extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Hk=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,31,26,22,23]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=void 0;let p=class extends y.$jc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,c,I,P,E){super(),this.z=n,this.C=r,this.D=c,this.F=I,this.G=P,this.H=E,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$ed),this.s=this.B(new N.$ed),this.t=this.B(new N.$ed),this.u=this.B(new N.$ed),this.w=this.B(new N.$ed),this.y=[],this.B((0,y.$hc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(c=>(0,g.$Vn)(c,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const I=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:P})=>(0,d.$oo)(P,n.identifier));if(I?.local)return I?.local;throw I?.error?I.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(c){throw t(c)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new g.$Zn(S.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],c=[];await Promise.allSettled(n.map(async({extension:I,options:P})=>{try{const E=await this.O(I,!!P?.installGivenVersion,!!P?.installPreReleaseVersion);c.push({...E,options:P})}catch(E){r.push({identifier:I.identifier,operation:2,source:I,error:E})}})),c.length&&r.push(...await this.I(c));for(const I of r)I.error&&(this.F.error("Failed to install extension.",I.identifier.id),this.F.error(I.error),I.source&&!O.URI.isUri(I.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,d.$wo)(I.source),error:I.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,v.$Xl)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let c=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(c=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const I of this.H.profiles){const P=(await this.getInstalled(1,I.extensionsResource)).find(E=>(0,d.$oo)(E.identifier,n.identifier));P?this.w.fire(P):this.u.fire({identifier:n.identifier,profileLocation:I.extensionsResource})}return c}else{const c=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async c=>{try{const I=await this.J(c);r.push(...I)}catch(I){r.push({identifier:{id:(0,d.$to)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:I})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:c}){const I=c.isApplicationScoped||c.isBuiltin||(0,v.$Xl)(n),P={...c,installOnlyNewlyAddedFromExtensionPack:O.URI.isUri(r)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:I,profileLocation:I?this.H.defaultProfile.extensionsResource:c.profileLocation??this.Y()},E=te=>`${d.$po.create(te).toString()}${P.profileLocation?`-${P.profileLocation.toString()}`:""}`;if(!O.URI.isUri(r)){const te=this.j.get(E(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const j=[],H=[],K=[],_=this.Z(n,r,P);O.URI.isUri(r)||this.j.set(E(r),{task:_,waitingTasks:[]}),this.n.fire({identifier:_.identifier,source:r,profileLocation:P.profileLocation}),this.F.info("Installing extension:",_.identifier.id),j.push({task:_,manifest:n});let ue=!1;try{if(P.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const ae=await this.N(_.identifier,n,!!P.installOnlyNewlyAddedFromExtensionPack,!!P.installPreReleaseVersion,P.profileLocation),le=await this.getInstalled(void 0,P.profileLocation),ie={...P,donotIncludePackAndDependencies:!0,context:{...P.context,[g.$Qn]:!0}};for(const{gallery:B,manifest:G}of(0,L.$Jb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!G.extensionDependencies?.some(q=>(0,d.$oo)({id:q},_.identifier));const T=E(B),U=this.j.get(T);if(U){if(this.L(_,U.task)){const q=U.task.identifier;this.F.info("Waiting for already requested installing extension",q.id,_.identifier.id),U.waitingTasks.push(_),H.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,X=>X.some(Y=>(0,d.$oo)(Y.identifier,q)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",q.id,_.identifier.id),!X.find(x=>(0,d.$oo)(x.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!le.some(({identifier:q})=>(0,d.$oo)(q,B.identifier))){const q=this.Z(G,B,ie);this.j.set(T,{task:q,waitingTasks:[_]}),this.n.fire({identifier:q.identifier,source:B,profileLocation:P.profileLocation}),this.F.info("Installing extension:",q.identifier.id,_.identifier.id),j.push({task:q,manifest:G})}}}catch(ae){if(O.URI.isUri(_.source))(0,L.$Ib)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",_.identifier.id,ae.message),(0,L.$Ib)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",_.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),ae}const te=j.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(B=>te.has(B.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===_&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const B=new Date().getTime();try{const G=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(G,ie.source,P,R.CancellationToken.None))),!O.URI.isUri(ie.source)){const T=ie.operation===3,U=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(a(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$wo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-B,durationSinceUpdate:U}),u.$o&&ie.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}K.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw O.URI.isUri(ie.source)||a(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$wo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-B,error:G}),this.F.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return H.length&&await this.M(H),K.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),K}catch(te){if(j.forEach(({task:ae})=>ae.cancel()),K.length)try{const ae=await Promise.allSettled(K.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:P.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:B}=K[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",B.id):this.F.warn("Rollback: Error while uninstalling extension",B.id,(0,A.$8)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,A.$8)(ae),K.map(({identifier:le})=>le.id))}return j.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:P.context,profileLocation:P.profileLocation,error:te}))}finally{for(const{task:te}of j)te.source&&!O.URI.isUri(te.source)&&this.j.delete(E(te.source))}}L(n,r){for(const[,{task:c,waitingTasks:I}]of this.j.entries())if(c===n&&(I.includes(r)||I.some(P=>this.L(P,r)))||c===r&&I[0]&&!this.L(n,I[0]))return!1;return!0}async M(n){const r=[],c=[],I=await Promise.allSettled(n);for(const P of I)P.status==="fulfilled"?r.push(P.value):c.push(P.reason);if(c.length)throw b(c);return r}async N(n,r,c,I,P){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,P),j=[],H=[],K=async(_,ue)=>{j.push(_);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=c?E.find(ie=>(0,d.$oo)(ie.identifier,_)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(B=>(0,d.$oo)({id:B},{id:ie}))||ae.every(B=>!(0,d.$oo)({id:B},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>j.every(B=>!(0,d.$oo)(B,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(B=>({id:B,preRelease:I})),R.CancellationToken.None);for(const B of ie){if(j.find(U=>(0,d.$oo)(U,B.identifier)))continue;const G=te.some(U=>(0,d.$oo)({id:U},B.identifier));let T;try{T=await this.O(B,!1,I)}catch(U){if(G)throw U;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,A.$8)(U));continue}H.push({gallery:T.extension,manifest:T.manifest}),await K(T.extension.identifier,T.manifest)}}}};return await K(n,r),H}async O(n,r,c){let I;const P=await this.getExtensionsControlManifest();if(P.malicious.some(H=>(0,d.$oo)(n.identifier,H)))throw new g.$Zn(S.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const E=P.deprecated[n.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!I)throw new g.$Zn(S.localize(2,null,n.identifier.id,E.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new g.$Zn(S.localize(3,null,n.identifier.id,this.G.nameLong,(0,g.$Rn)(H)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.P(n,r,c),!I)throw!c&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new g.$Zn(S.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$Zn(S.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const j=await this.z.getManifest(I,R.CancellationToken.None);if(j===null)throw new g.$Zn(`Missing manifest for extension ${I.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(j.version!==I.version)throw new g.$Zn(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:j}}async P(n,r,c){const I=await this.getTargetPlatform();let P=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==c&&(P=(await this.z.getExtensions([{...n.identifier,preRelease:c}],{targetPlatform:I,compatible:!0},R.CancellationToken.None))[0]||null),!P&&await this.z.isExtensionCompatible(n,c,I)&&(P=n),P||(r?P=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:I,compatible:!0},R.CancellationToken.None))[0]||null:P=await this.z.getCompatibleExtension(n,c,I)),P}async Q(n,r){const c={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},I=_=>`${_.id.toLowerCase()}${c.versionOnly?`-${n.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,P=this.m.get(I(n.identifier));if(P)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),P.waitUntilTaskIsFinished();const E=_=>{const ue=this.$(_,c);return this.m.set(I(ue.extension.identifier),ue),c.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:c.profileLocation,applicationScoped:_.isApplicationScoped}),ue},j=(_,ue)=>{ue?c.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,ue.message):c.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$vo)(_),error:ue}),this.u.fire({identifier:_.identifier,error:ue?.code,profileLocation:c.profileLocation,applicationScoped:_.isApplicationScoped})},H=[],K=[];try{H.push(E(n));const _=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ue=this.U(n,_);for(const te of ue)this.m.has(I(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):H.push(E(te))}c.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(ue=>ue.extension),_,n),await this.M(H.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,c,R.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}j(ue.extension)}catch(te){const ae=te instanceof g.$Zn?te:new g.$Zn((0,A.$8)(te),g.ExtensionManagementErrorCode.Internal);throw j(ue.extension,ae),ae}finally{K.push(ue)}}))}catch(_){const ue=_ instanceof g.$Zn?_:new g.$Zn((0,A.$8)(_),g.ExtensionManagementErrorCode.Internal);for(const te of H){try{te.cancel()}catch{}K.includes(te)||j(te.extension,ue)}throw ue}finally{for(const _ of H)this.m.delete(I(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(n,r,c){for(const I of n){const P=this.W(I,r);if(P.length){const E=P.filter(j=>!n.some(H=>(0,d.$oo)(H.identifier,j.identifier)));if(E.length)throw new Error(this.S(I,E,c))}}}S(n,r,c){return c===n?r.length===1?S.localize(6,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,c=[]){if(c.indexOf(n)!==-1)return[];c.push(n);const I=n.manifest.extensionPack?n.manifest.extensionPack:[];if(I.length){const P=r.filter(j=>!j.isBuiltin&&I.some(H=>(0,d.$oo)({id:H},j.identifier))),E=[];for(const j of P)E.push(...this.U(j,r,c));return[...P,...E]}return[]}W(n,r){return r.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(I=>(0,d.$oo)({id:I},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$dp=p,e.$dp=p=$e([se(0,g.$Yn),se(1,h.$8k),se(2,f.$Bk),se(3,w.$4i),se(4,$.$jj),se(5,k.$Dk)],p);function b(s){const n=Array.isArray(s)?s:[s];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,c)=>new Error(`${r.message}${r.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.$ep=b;function t(s){if(s instanceof g.$Zn)return s;const n=new g.$Zn(s.message,g.ExtensionManagementErrorCode.Internal);return n.stack=s.stack,n}e.$fp=t;function a(s,n,{extensionData:r,verificationStatus:c,duration:I,error:P,durationSinceUpdate:E}){let j,H;(0,l.$qf)(c)&&(c===!0?c="Verified":(c===!1||(j=g.ExtensionManagementErrorCode.Signature,H=c),c="Unverified")),P&&(P instanceof g.$Zn?(j=P.code,P.code===g.ExtensionManagementErrorCode.Signature&&(H=P.message)):j=g.ExtensionManagementErrorCode.Internal),s.publicLog(n,{...r,verificationStatus:c,success:!P,duration:I,errorcode:j,errorcodeDetail:H,durationSinceUpdate:E})}class i{constructor(){this.d=new D.$Eg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$tg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$tg)(n=>new Promise((r,c)=>{const I=n.onCancellationRequested(()=>{I.dispose(),c(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$gp=i}),define(ne[40],re([0,1,8,14,2,4,35,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class k extends Error{constructor(i,s){super(i),this.code=s}}e.$hp=k,e.$ip=(0,S.$Ah)("IExtensionsProfileScannerService");let p=class extends R.$jc{constructor(i,s,n,r,c,I){super(),this.j=i,this.m=s,this.n=n,this.r=r,this.s=c,this.t=I,this.b=this.B(new A.$ed),this.onAddExtensions=this.b.event,this.c=this.B(new A.$ed),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$ed),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$ed),this.onDidRemoveExtensions=this.g.event,this.h=new N.$yi}scanProfileExtensions(i,s){return this.u(i,void 0,s)}async addExtensionsToProfile(i,s){const n=[],r=[];try{return await this.u(s,c=>{const I=[];for(const P of c)i.some(([E])=>(0,l.$oo)(E.identifier,P.identifier)&&E.manifest.version!==P.version)?n.push(P):I.push(P);for(const[P,E]of i){const j=I.findIndex(K=>(0,l.$oo)(K.identifier,P.identifier)&&K.version===P.manifest.version),H={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:E};j===-1?(r.push(H),I.push(H)):I.splice(j,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),n.length&&this.f.fire({extensions:n,profileLocation:s}),I}),r.length&&this.c.fire({extensions:r,profileLocation:s}),n.length&&this.g.fire({extensions:n,profileLocation:s}),r}catch(c){throw r.length&&this.c.fire({extensions:r,error:c,profileLocation:s}),n.length&&this.g.fire({extensions:n,error:c,profileLocation:s}),c}}async updateMetadata(i,s){const n=[];return await this.u(s,r=>{const c=[];for(const I of r){const P=i.find(([E])=>(0,l.$oo)(E.identifier,I.identifier)&&E.manifest.version===I.version);P&&(I.metadata={...I.metadata,...P[1]},n.push(I)),c.push(I)}return c}),n}async removeExtensionFromProfile(i,s){const n=[];try{await this.u(s,r=>{const c=[];for(const I of r)(0,l.$oo)(I.identifier,i.identifier)?n.push(I):c.push(I);return n.length&&this.f.fire({extensions:n,profileLocation:s}),c}),n.length&&this.g.fire({extensions:n,profileLocation:s})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:s}),r}}async u(i,s,n){return this.F(i).queue(async()=>{let r=[],c;try{const I=await this.m.readFile(i);c=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,O.$ik)(I)!==1)throw I;if(this.r.extUri.isEqual(i,this.n.defaultProfile.extensionsResource)&&(c=await this.D()),!c&&n?.bailOutWhenFileNotFound)throw new k((0,$.$8)(I),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.w(i);let I=!1;for(const P of c){b(P)||this.w(i);let E;if((0,w.$if)(P.relativeLocation)&&P.relativeLocation)E=this.z(P.relativeLocation);else if((0,w.$if)(P.location))E=this.z(P.location),I=!0,P.relativeLocation=P.location,P.location=E.toJSON();else{E=y.URI.revive(P.location);const j=this.y(E);j&&(I=!0,P.relativeLocation=j)}r.push({identifier:P.identifier,location:E,version:P.version,metadata:P.metadata})}I&&await this.m.writeFile(i,D.$Ed.fromString(JSON.stringify(c)))}if(s){r=s(r);const I=r.map(P=>({identifier:P.identifier,version:P.version,location:P.location.toJSON(),relativeLocation:this.y(P.location),metadata:P.metadata}));await this.m.writeFile(i,D.$Ed.fromString(JSON.stringify(I)))}return r})}w(i){const s=new k(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(i){return this.r.extUri.isEqual(this.r.extUri.dirname(i),this.j)?this.r.extUri.basename(i):void 0}z(i){return this.r.extUri.joinPath(this.j,i)}async D(){return this.C||(this.C=(async()=>{const i=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(i)).value.toString()}catch(c){if((0,O.$ik)(c)===1)return;throw c}this.t.info("Migrating extensions from old default profile location",i.toString());let r;try{const c=JSON.parse(n);Array.isArray(c)&&c.every(I=>b(I))?r=c:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.t.error(c)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$Ed.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",i.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(c){if((0,O.$ik)(c)===3)this.t.info("Migration from old default profile location to new location is done by another window",i.toString(),this.n.defaultProfile.extensionsResource.toString());else throw c}try{await this.m.del(i)}catch(c){(0,O.$ik)(c)!==1&&this.t.error(c)}try{await this.m.del(s)}catch(c){(0,O.$ik)(c)!==1&&this.t.error(c)}return r})()),this.C}F(i){let s=this.h.get(i);return s||(s=new L.$Mg,this.h.set(i,s)),s}};e.$jp=p,e.$jp=p=$e([se(1,O.$5j),se(2,d.$Dk),se(3,v.$Bk),se(4,h.$8k),se(5,g.$4i)],p);function b(a){return(0,w.$kf)(a)&&(0,u.$Xn)(a.identifier)&&(t(a.location)||(0,w.$if)(a.location)&&a.location)&&((0,w.$pf)(a.relativeLocation)||(0,w.$if)(a.relativeLocation))&&a.version&&(0,w.$if)(a.version)}function t(a){return a?(0,w.$if)(a.path)&&(0,w.$if)(a.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,43,54,3,11,95,18,27,37,48,12,10,6,31,4,47,40,23,22,112]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f,k,p,b,t,a,i,s,n,r,c,I,P,E,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.Translations=void 0;var H;(function(ie){function B(G,T){if(G===T)return!0;const U=Object.keys(G),q=new Set;for(const X of Object.keys(T))q.add(X);if(U.length!==q.size)return!1;for(const X of U){if(G[X]!==T[X])return!1;q.delete(X)}return q.size===0}ie.equals=B})(H||(e.Translations=H={})),e.$mp=(0,i.$Ah)("IExtensionsScannerService");let K=class extends l.$jc{constructor(B,G,T,U,q,X,Y,x,F,z,o,m){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=G,this.r=T,this.s=U,this.t=q,this.u=X,this.w=Y,this.y=x,this.z=F,this.C=z,this.D=o,this.F=m,this.g=this.B(new r.$ed),this.onDidChangeCache=this.g.event,this.h=(0,d.$hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$zo)(this.w,this.y)),this.G}async scanAllExtensions(B,G,T){const[U,q]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(G)]),X=T?await this.scanExtensionsUnderDevelopment(B,[...U,...q]):[];return this.L(U,q,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const G=[];G.push(this.M(!!B.useCache,B.language)),G.push(this.N(B.language,!!B.checkControlFile));const[T,U]=await Promise.all(G);return this.J([...T,...U],0,B,!1)}async scanUserExtensions(B){const G=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const T=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(G,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,T),q=B.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let X;try{X=await q.scanExtensions(U)}catch(Y){if(Y instanceof I.$hp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await q.scanExtensions(U);else throw Y}return X=await this.J(X,1,B,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(B,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===O.Schemas.file).map(async U=>{const q=await this.P(U,!1,1,!0,B.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(q)).map(Y=>(Y.type=G.find(x=>(0,p.$oo)(x.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,q)))}))).flat();return this.J(T,"development",B,!0)}return[]}async scanExistingExtension(B,G,T){const U=await this.P(B,!1,G,!0,T.language,!0,void 0),q=await this.n.scanExtension(U);return!q||!T.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(B,G,T){const U=await this.P(B,!1,G,!0,T.language,!0,void 0),q=await this.n.scanOneOrMultipleExtensions(U);return this.J(q,G,T,!0)}async scanMetadata(B){const G=(0,d.$hg)(B,"package.json"),T=(await this.w.readFile(G)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(B,G){const T=(0,d.$hg)(B,"package.json"),U=(await this.w.readFile(T)).value.toString(),q=JSON.parse(U);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,q.__metadata={...q.__metadata,...G},await this.w.writeFile((0,d.$hg)(B,"package.json"),A.$Ed.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof I.$hp&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Ed.fromString(JSON.stringify([])))}catch(G){(0,a.$ik)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$8)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,G,T,U){return T.includeAllVersions||(B=this.L(G===0?B:void 0,G===1?B:void 0,G==="development"?B:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(B=B.filter(q=>q.isValid)),B.sort((q,X)=>{const Y=S.$_d(q.location.fsPath),x=S.$_d(X.location.fsPath);return Y<x?-1:Y>x?1:0})}L(B,G,T,U,q){const X=(x,F,z)=>{if(x.isValid&&!F.isValid)return!1;if(x.isValid===F.isValid){if(q&&v.gt(x.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(v.eq(x.manifest.version,F.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===U)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${x.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${F.location.path}.`),!0},Y=new b.$Wl;return B?.forEach(x=>{const F=Y.get(x.identifier.id);(!F||X(F,x,!1))&&Y.set(x.identifier.id,x)}),G?.forEach(x=>{const F=Y.get(x.identifier.id);if(!F&&B&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!F||X(F,x,!1))&&Y.set(x.identifier.id,x)}),T?.forEach(x=>{const F=Y.get(x.identifier.id);(!F||X(F,x,!0))&&Y.set(x.identifier.id,x),Y.set(x.identifier.id,x)}),[...Y.values()]}async M(B,G){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),q=await(B&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",q.length),q}async N(B,G){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=G?await this.O():{},q=[],X=h.URI.file(S.$6d(S.$8d(O.$1f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of T){const F=U[x.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":q.push((0,d.$hg)(X,x.name));break;default:q.push(h.URI.file(F));break}}const Y=await Promise.all(q.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,B,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,L.$Eb)(Y)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,G,T,U,q,X,Y){const x=await this.f(q??g.$v),F=await this.Q(B),z=G&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,o=z?await this.Q(z):void 0;return new _(B,F,z,o,G,Y,T,U,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,q,x)}async Q(B){try{const G=await this.w.stat(B);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$np=K,e.$np=K=$e([se(4,P.$Dk),se(5,I.$ip),se(6,a.$5j),se(7,s.$4i),se(8,k.$Hh),se(9,n.$jj),se(10,E.$Bk),se(11,i.$zh)],K);class _{constructor(B,G,T,U,q,X,Y,x,F,z,o,m,M,C,Z){this.location=B,this.mtime=G,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=q,this.profileScanOptions=X,this.type=Y,this.excludeObsolete=x,this.validate=F,this.productVersion=z,this.productDate=o,this.productCommit=m,this.devMode=M,this.language=C,this.translations=Z}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,G){return(0,d.$ag)(B.location,G.location)&&B.mtime===G.mtime&&(0,d.$ag)(B.applicationExtensionslocation,G.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&B.profile===G.profile&&R.$Ym(B.profileScanOptions,G.profileScanOptions)&&B.type===G.type&&B.excludeObsolete===G.excludeObsolete&&B.validate===G.validate&&B.productVersion===G.productVersion&&B.productDate===G.productDate&&B.productCommit===G.productCommit&&B.devMode===G.devMode&&B.language===G.language&&H.equals(B.translations,G.translations)}}e.$op=_;let ue=class extends l.$jc{constructor(B,G,T,U,q){super(),this.f=B,this.g=G,this.h=T,this.j=U,this.m=q}async scanExtensions(B){const G=B.profile?await this.r(B):await this.n(B);let T={};if(B.excludeObsolete&&B.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,$.$vf)(T)?G:G.filter(U=>!T[p.$po.create(U).toString()])}async n(B){const G=await this.j.resolve(B.location);if(!G.children?.length)return[];const T=await Promise.all(G.children.map(async U=>{if(!U.isDirectory||B.type===1&&(0,d.$eg)(U.resource).indexOf(".")===0)return null;const q=new _(U.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(q)}));return(0,L.$Eb)(T).sort((U,q)=>U.location.path<q.location.path?-1:1)}async r(B){let G=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){G=G.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(B.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,B);G.push(...T)}return G}async s(B,G,T){const U=await this.g.scanProfileExtensions(B,T.profileScanOptions);if(!U.length)return[];const q=await Promise.all(U.map(async X=>{if(G(X)){const Y=new _(X.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,L.$Eb)(q)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,d.$hg)(B.location,"package.json"))){const G=await this.scanExtension(B);return G?[G]:[]}else return await this.scanExtensions(B)}catch(G){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,N.$8)(G)),[]}}async scanExtension(B,G){try{let T=await this.scanExtensionManifest(B.location);if(T){T.publisher||(T.publisher=b.$Ql),G=G??T.__metadata,delete T.__metadata;const U=(0,p.$to)(T.publisher,T.name),q=G?.id?{id:U,uuid:G.id}:{id:U},X=G?.isSystem?0:B.type,Y=X===0||!!G?.isBuiltin;T=await this.t(B.location,T,_.createNlsConfiguration(B));const x={type:X,identifier:q,manifest:T,location:B.location,isBuiltin:Y,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return B.validate?this.validate(x,B):x}}catch(T){B.type!==0&&this.m.error(T)}return null}validate(B,G){let T=!0;const U=(0,t.$Eo)(G.productVersion,G.productDate,G.location,B.manifest,B.isBuiltin);for(const[q,X]of U)q===w.default.Error&&(T=!1,this.m.error(this.z(G.location,X)));return B.isValid=T,B.validations=U,B}async scanExtensionManifest(B){const G=(0,d.$hg)(B,"package.json");let T;try{T=(await this.j.readFile(G)).value.toString()}catch(q){return(0,a.$ik)(q)!==1&&this.m.error(this.z(B,(0,f.localize)(0,null,G.path,q.message))),null}let U;try{U=JSON.parse(T)}catch{const X=[];(0,y.$Km)(T,X);for(const Y of X)this.m.error(this.z(B,(0,f.localize)(1,null,G.path,Y.offset,Y.length,(0,u.$kp)(Y.error))));return null}return(0,y.$Tm)(U)!=="object"?(this.m.error(this.z(B,(0,f.localize)(2,null,G.path))),null):U}async t(B,G,T){const U=await this.u(B,G,T);if(U)try{const q=[],X=await this.w(U.default,q);if(q.length>0)return q.forEach(x=>{this.m.error(this.z(B,(0,f.localize)(3,null,U.default?.path,(0,u.$kp)(x.error))))}),G;if((0,y.$Tm)(U)!=="object")return this.m.error(this.z(B,(0,f.localize)(4,null,U.default?.path))),G;const Y=U.values||Object.create(null);return(0,j.$lp)(this.m,G,Y,X)}catch{}return G}async u(B,G,T){const U=(0,d.$hg)(B,"package.nls.json"),q=(F,z)=>{z.forEach(o=>{this.m.error(this.z(B,(0,f.localize)(5,null,F?.path,(0,u.$kp)(o.error))))})},X=F=>{this.m.error(this.z(B,(0,f.localize)(6,null,F?.path)))},Y=`${G.publisher}.${G.name}`,x=T.translations[Y];if(x)try{const F=h.URI.file(x),z=(await this.j.readFile(F)).value.toString(),o=[],m=(0,y.$Km)(z,o);return o.length>0?(q(F,o),{values:void 0,default:U}):(0,y.$Tm)(m)!=="object"?(X(F),{values:void 0,default:U}):{values:m.contents?m.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let z;try{z=await this.y(B,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const o=(await this.j.readFile(z.localized)).value.toString(),m=[],M=(0,y.$Km)(o,m);return m.length>0?(q(z.localized,m),{values:void 0,default:z.original}):(0,y.$Tm)(M)!=="object"?(X(z.localized),{values:void 0,default:z.original}):{values:M,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(B,G){if(B)try{const T=(await this.j.readFile(B)).value.toString();return(0,y.$Km)(T,G)}catch{}}y(B,G){return new Promise((T,U)=>{const q=X=>{const Y=(0,d.$hg)(B,`package.nls.${X}.json`);this.j.exists(Y).then(x=>{x&&T({localized:Y,original:(0,d.$hg)(B,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?T({localized:(0,d.$hg)(B,"package.nls.json"),original:null}):(X=X.substring(0,F),q(X))})};if(G.devMode||G.pseudo||!G.language)return T({localized:(0,d.$hg)(B,"package.nls.json"),original:null});q(G.language)})}z(B,G){return`[${B.path}]: ${G}`}};ue=$e([se(1,I.$ip),se(2,E.$Bk),se(3,a.$5j),se(4,s.$4i)],ue);let te=class extends ue{constructor(B,G,T,U,q,X,Y){super(G,U,q,X,Y),this.G=B,this.H=T,this.D=this.B(new D.$Dg(3e3)),this.F=this.B(new r.$ed),this.onDidChangeCache=this.F.event}async scanExtensions(B){const G=this.M(B),T=await this.I(G);if(this.C=B,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),T.result.map(q=>(q.location=h.URI.revive(q.location),q));const U=await super.scanExtensions(B);return await this.J(G,{input:B,result:U}),U}async I(B){try{const G=await this.j.readFile(B),T=JSON.parse(G.value.toString());return{result:T.result,input:(0,c.$0g)(T.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",B.path,(0,N.$8)(G))}return null}async J(B,G){try{await this.j.writeFile(B,A.$Ed.fromString(JSON.stringify(G)))}catch(T){this.m.debug("Error while writing the extension cache file:",B.path,(0,N.$8)(T))}}async L(){if(!this.C)return;const B=this.M(this.C),G=await this.I(B);if(!G)return;const T=G.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$Ym(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(B),this.F.fire()}catch(q){this.m.error(q)}}M(B){const G=this.N(B);return this.h.extUri.joinPath(G.cacheHome,B.type===0?b.$Pl:b.$Ol)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(B.location,G.extensionsResource))??this.G:this.H.defaultProfile}};te=$e([se(2,P.$Dk),se(3,I.$ip),se(4,E.$Bk),se(5,a.$5j),se(6,s.$4i)],te);function ae(ie,B){const G=(0,p.$ro)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new b.$Ul(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:B,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$pp=ae;class le extends K{constructor(B,G,T,U,q,X,Y,x,F,z,o,m){super(B,G,(0,d.$hg)(T,".vscode-oss-dev","extensions","control.json"),U,q,X,Y,x,F,z,o,m),this.R=(async()=>{if(g.$y)try{const M=await this.w.readFile(h.URI.file(g.$y));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f(B){return this.R}}e.$qp=le}),define(ne[154],re([0,1,58,8,33,4,2,15,16,24,6,23]),function(J,e,L,D,R,A,N,y,u,l,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;let g=class extends N.$jc{constructor(v,w){super(),this.b=v,this.f=w,this.a=new D.$Lg(5)}async postUninstall(v){const w=this.g(v,"uninstall");w&&(this.f.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,v),this.f.info("Finished running post uninstall script",v.identifier.id,v.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",v.identifier.id,v.manifest.version),this.f.error($)}}));try{await l.Promises.rm(this.m(v))}catch($){this.f.error("Error while removing extension storage path",v.identifier.id),this.f.error($)}}g(v,w){const $=`vscode:${w}`;if(v.location.scheme===y.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[$]=="string"){const h=v.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(v.identifier.id,v.manifest.version,`${$} should be a node script`),null):{script:(0,u.$8d)(v.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(v,w,$,h,f){return new Promise((k,p)=>{const b=this.j(v,w,$,f);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?p(i):k(void 0)};b.on("error",i=>{a((0,R.$li)(i)||"Unknown")}),b.on("exit",(i,s)=>{a(i?`post-${w} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,b.kill(),p("timed out")},5e3))})}j(v,w,$,h){const f={silent:!0,execArgv:void 0},k=(0,L.fork)(v,[`--type=extension-post-${w}`,...$],f);k.stdout.setEncoding("utf8"),k.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(k.stdout,"data"),b=A.Event.fromNodeEventEmitter(k.stderr,"data");p(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,i)),b(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,i));const t=A.Event.any(A.Event.map(p,i=>({data:`%c${i}`,format:[""]})),A.Event.map(b,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),k}m(v){return(0,u.$8d)(this.b.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};e.$sp=g,e.$sp=g=$e([se(0,S.$Dk),se(1,O.$4i)],g)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,D,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;let O=class extends N.$jp{constructor(g,d,v,w,$,h){super(l.URI.file(g.extensionsPath),d,v,w,$,h)}};e.$fN=O,e.$fN=O=$e([se(0,u.$Ih),se(1,y.$5j),se(2,D.$Dk),se(3,R.$Bk),se(4,A.$8k),se(5,L.$4i)],O)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,31,22,23]),function(J,e,L,D,R,A,N,y,u,l,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=void 0;let g=class extends A.$qp{constructor(v,w,$,h,f,k,p,b){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,v.defaultProfile,v,w,$,h,f,k,p,b)}};e.$E6b=g,e.$E6b=g=$e([se(0,S.$Dk),se(1,R.$ip),se(2,N.$5j),se(3,u.$4i),se(4,D.$Ih),se(5,l.$jj),se(6,O.$Bk),se(7,y.$zh)],g)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,D,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$To=e.$So=e.$Ro=void 0,e.$Ro="__$__isNewStorageMarker",e.$So="__$__targetStorageMarker",e.$To=(0,u.$Ah)("storageService");var O;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(O||(e.WillSaveStateReason=O={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var g;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function d(f){const k=f.get(e.$So);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.$Uo=d;class v extends R.$jc{static{this.a=60*1e3}constructor(k={flushInterval:v.a}){super(),this.m=k,this.b=this.B(new D.$hd),this.c=this.B(new D.$hd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$ed),this.onWillSaveState=this.f.event,this.h=this.B(new L.$Rg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$kc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(k,p,b){return D.Event.filter(this.b.event,t=>t.scope===k&&(p===void 0||t.key===p),b)}n(){this.j.value=(0,L.$Vg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$ec)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(k,p){const{key:b,external:t}=p;if(b===e.$So){switch(k){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:b,target:this.J(k)[b],external:t})}w(k){this.f.fire({reason:k})}get(k,p,b){return this.P(p)?.get(k,b)}getBoolean(k,p,b){return this.P(p)?.getBoolean(k,b)}getNumber(k,p,b){return this.P(p)?.getNumber(k,b)}getObject(k,p,b){return this.P(p)?.getObject(k,b)}storeAll(k,p){this.y(()=>{for(const b of k)this.store(b.key,b.value,b.scope,b.target,p)})}store(k,p,b,t,a=!1){if((0,N.$rf)(p)){this.remove(k,b,a);return}this.y(()=>{this.z(k,b,t),this.P(b)?.set(k,p,a)})}remove(k,p,b=!1){this.y(()=>{this.z(k,p,void 0),this.P(p)?.delete(k,b)})}y(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,p){const b=[],t=this.J(k);for(const a of Object.keys(t))t[a]===p&&b.push(a);return b}z(k,p,b,t=!1){const a=this.J(p);typeof b=="number"?a[k]!==b&&(a[k]=b,this.P(p)?.set(e.$So,JSON.stringify(a),t)):typeof a[k]=="number"&&(delete a[k],this.P(p)?.set(e.$So,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(k){switch(k){case-1:return this.I;case 0:return this.G;default:return this.D}}L(k){const p=this.P(k);return p?d(p):Object.create(null)}isNew(k){return this.getBoolean(e.$Ro,k)===!0}async flush(k=O.NONE){this.f.fire({reason:k});const p=this.P(-1),b=this.P(0),t=this.P(1);switch(k){case O.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case O.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,b=this.P(1)?.items??new Map;return h(k,p,b,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(k){return await this.flush(),this.P(k)?.optimize()}async switch(k,p){return this.w(O.NONE),(0,l.$Ck)(k)?this.R(k,p):this.S(k,p)}M(k,p){return!(k.id===p.id||w(p)&&w(k))}N(k,p,b){this.y(()=>{const t=new Set;for(const[a,i]of k)t.add(a),p.get(a)!==i&&this.u(b,{key:a,external:!0});for(const[a]of p.items)t.has(a)||this.u(b,{key:a,external:!0})})}}e.$Vo=v;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Wo=w;class $ extends v{constructor(){super(),this.U=this.B(new y.$Po(new y.$Qo,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new y.$Po(new y.$Qo,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new y.$Po(new y.$Qo,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(k=>this.u(1,k))),this.B(this.W.onDidChangeStorage(k=>this.u(0,k))),this.B(this.U.onDidChangeStorage(k=>this.u(-1,k)))}P(k){switch(k){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(k){return!1}}e.$Xo=$;async function h(f,k,p,b,t,a){const i=H=>{try{return JSON.parse(H)}catch{return H}},s=new Map,n=new Map;f.forEach((H,K)=>{s.set(K,H),n.set(K,i(H))});const r=new Map,c=new Map;k.forEach((H,K)=>{r.set(K,H),c.set(K,i(H))});const I=new Map,P=new Map;p.forEach((H,K)=>{I.set(K,H),P.set(K,i(H))}),console.group(b!==t?`Storage: Application (path: ${b})`:`Storage: Application & Profile (path: ${b}, default profile)`);const E=[];if(s.forEach((H,K)=>{E.push({key:K,value:H})}),console.table(E),console.groupEnd(),console.log(n),b!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const H=[];r.forEach((K,_)=>{H.push({key:_,value:K})}),console.table(H),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${a})`);const j=[];I.forEach((H,K)=>{j.push({key:K,value:H})}),console.table(j),console.groupEnd(),console.log(P)}e.$Yo=h}),define(ne[158],re([0,1,19,20,9,13,34,3,11,25,18,21,27,48,12,6,31,45,142,157,26,175]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f,k,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=void 0;const t=A.$o?"web":(0,S.$Tn)(A.$t,N.$3d),a="X-Market-Search-Activity-Id";var i;(function(o){o[o.None=0]="None",o[o.IncludeVersions=1]="IncludeVersions",o[o.IncludeFiles=2]="IncludeFiles",o[o.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",o[o.IncludeSharedAccounts=8]="IncludeSharedAccounts",o[o.IncludeVersionProperties=16]="IncludeVersionProperties",o[o.ExcludeNonValidated=32]="ExcludeNonValidated",o[o.IncludeInstallationTargets=64]="IncludeInstallationTargets",o[o.IncludeAssetUri=128]="IncludeAssetUri",o[o.IncludeStatistics=256]="IncludeStatistics",o[o.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",o[o.Unpublished=4096]="Unpublished",o[o.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...o){return String(o.reduce((m,M)=>m|M,0))}var n;(function(o){o[o.Tag=1]="Tag",o[o.ExtensionId=4]="ExtensionId",o[o.Category=5]="Category",o[o.ExtensionName=7]="ExtensionName",o[o.Target=8]="Target",o[o.Featured=9]="Featured",o[o.SearchText=10]="SearchText",o[o.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(m=P){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,M=this.d.pageSize){return new E({...this.d,pageNumber:m,pageSize:M})}withFilter(m,...M){const C=[...this.d.criteria,...M.length?M.map(Z=>({filterType:m,value:Z})):[{filterType:m}]];return new E({...this.d,criteria:C})}withSortBy(m){return new E({...this.d,sortBy:m})}withSortOrder(m){return new E({...this.d,sortOrder:m})}withFlags(...m){return new E({...this.d,flags:m.reduce((M,C)=>M|C,0)})}withAssetTypes(...m){return new E({...this.d,assetTypes:m})}withSource(m){return new E({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:M,pageSize:C,sortBy:Z,sortOrder:W,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:m,pageNumber:M,pageSize:C,sortBy:Z,sortOrder:W}],assetTypes:oe,flags:ce}}get searchText(){const m=this.d.criteria.filter(M=>M.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(o,m){const M=(o||[]).filter(C=>C.statisticName===m)[0];return M?M.value:0}function H(o){const m="Microsoft.VisualStudio.Code.Translation.";return o.files.filter(C=>C.assetType.indexOf(m)===0).reduce((C,Z)=>{const W=ue(o,Z.assetType);return W&&C.push([Z.assetType.substring(m.length),W]),C},[])}function K(o){if(o.properties){const m=o.properties.filter(Z=>Z.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=m.filter(Z=>M.test(Z.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return ue(o,r.Repository)}function _(o){return{uri:`${o.fallbackAssetUri}/${r.VSIX}?redirect=true${o.targetPlatform?`&targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${r.VSIX}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}}function ue(o,m){return o.files.filter(C=>C.assetType===m)[0]?{uri:`${o.assetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}:null}function te(o,m){const M=o.properties?o.properties.filter(Z=>Z.key===m):[],C=M.length>0&&M[0].value;return C?C.split(",").map(Z=>(0,g.$so)(Z)):[]}function ae(o){const m=o.properties?o.properties.filter(M=>M.key===c.Engine):[];return m.length>0&&m[0].value||""}function le(o){const m=o.properties?o.properties.filter(M=>M.key===c.PreRelease):[];return m.length>0&&m[0].value==="true"}function ie(o){const m=o.properties?o.properties.filter(C=>C.key===c.LocalizedLanguages):[],M=m.length>0&&m[0].value||"";return M?M.split(","):[]}function B(o){return o.properties?.find(m=>m.key===c.SponsorLink)?.value}function G(o){return o.indexOf("preview")!==-1}function T(o){return o.targetPlatform?(0,S.$Sn)(o.targetPlatform):"undefined"}function U(o){const m=(0,L.$Jb)(o.versions.map(T)),M=!!o.tags?.includes(S.$Nn),C=m.indexOf("web");return M?C===-1&&m.push("web"):C!==-1&&m.splice(C,1),m}function q(o,m){const M=(0,S.$Wn)(m);for(let C=0;C<o.length;C++){const Z=o[C];if(Z.version===o[C-1]?.version){let W=C;const ce=T(Z);if(ce===m)for(;W>0&&o[W-1].version===Z.version;)W--;else if(M.includes(ce))for(;W>0&&o[W-1].version===Z.version&&T(o[W-1])!==m;)W--;W!==C&&(o.splice(C,1),o.splice(W,0,Z))}}return o}e.$2o=q;function X(o,m,M){o.telemetryData={index:m,querySource:M,queryActivityId:o.queryContext?.[a]}}function Y(o,m,M,C){const Z=o.versions[0],W={manifest:ue(m,r.Manifest),readme:ue(m,r.Details),changelog:ue(m,r.Changelog),license:ue(m,r.License),repository:K(m),download:_(m),icon:ue(m,r.Icon),signature:ue(m,r.Signature),coreTranslations:H(m)};return{identifier:{id:(0,g.$to)(o.publisher.publisherName,o.extensionName),uuid:o.extensionId},name:o.extensionName,version:m.version,displayName:o.displayName,publisherId:o.publisher.publisherId,publisher:o.publisher.publisherName,publisherDisplayName:o.publisher.displayName,publisherDomain:o.publisher.domain?{link:o.publisher.domain,verified:!!o.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(Z),description:o.shortDescription||"",installCount:j(o.statistics,"install"),rating:j(o.statistics,"averagerating"),ratingCount:j(o.statistics,"ratingcount"),categories:o.categories||[],tags:o.tags||[],releaseDate:Date.parse(o.releaseDate),lastUpdated:Date.parse(o.lastUpdated),allTargetPlatforms:M,assets:W,properties:{dependencies:te(m,c.Dependency),extensionPack:te(m,c.ExtensionPack),engine:ae(m),localizedLanguages:ie(m),targetPlatform:T(m),isPreReleaseVersion:le(m)},hasPreReleaseVersion:le(Z),hasReleaseVersion:!0,preview:G(o.flags),isSigned:!!W.signature,queryContext:C}}let x=class{constructor(m,M,C,Z,W,ce,oe,pe){this.k=M,this.l=C,this.n=Z,this.o=W,this.q=ce,this.u=oe,this.w=pe;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$1o)(oe.version,oe,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,M,C){const Z=D.CancellationToken.isCancellationToken(M)?{}:M,W=D.CancellationToken.isCancellationToken(M)?M:C,ce=[],oe=[],pe=[],de=[];let ge=!0;for(const we of m){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new E().withPage(1,m.length);oe.length&&(fe=fe.withFilter(n.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(n.ExtensionName,...ce)),(Z.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:he}=await this.z(fe,{targetPlatform:Z.targetPlatform??t,includePreRelease:pe,versions:de,compatible:!!Z.compatible},W);return Z.source&&he.forEach((we,be)=>X(we,be,Z.source)),he}async getCompatibleExtension(m,M,C){if((0,S.$Un)(m.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(m,M,C))return m;const Z=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(Z,{targetPlatform:C,compatible:!0,includePreRelease:M},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,M,C){if(!(0,S.$Vn)(m.properties.targetPlatform,m.allTargetPlatforms,C)||!M&&m.properties.isPreReleaseVersion)return!1;let Z=m.properties.engine;if(!Z){const W=await this.getManifest(m,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Z=W.engines.vscode}return(0,d.$Go)(Z,this.u.version,this.u.date)}async y(m,M,C,Z,W){if(!(0,S.$Vn)(T(m),Z,W)||M!=="any"&&le(m)!==(M==="prerelease"))return!1;if(C)try{const ce=await this.E(m);if(!(0,d.$Go)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,R.$8)(ce)),!1}return!0}async query(m,M){let C=m.text||"";const Z=m.pageSize??50;let W=new E().withPage(1,Z);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),W=W.withFilter(n.SearchText,C)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const ce=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,ke)=>X(be,(ge.pageNumber-1)*ge.pageSize+ke,m.source)),{extensions:he,total:we}},{extensions:oe,total:pe}=await ce(W,M),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$3;const{extensions:he}=await ce(W.withPage(ge+1),fe);return he};return{firstPage:oe,total:pe,pageSize:W.pageSize,getPage:de}}async z(m,M,C){const Z=m.flags;m.flags&i.IncludeLatestVersionOnly&&m.flags&i.IncludeVersions&&(m=m.withFlags(m.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(m.flags&i.IncludeLatestVersionOnly)&&!(m.flags&i.IncludeVersions)&&(m=m.withFlags(m.flags,i.IncludeLatestVersionOnly)),M.versions?.length&&(m=m.withFlags(m.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),m=m.withFlags(m.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:W,total:ce,context:oe}=await this.B(m,C);if(!(m.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,M,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,g.$to)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,y.$of)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Me=>(0,g.$oo)(Me,we))?.includePreRelease;if(M.compatible&&(0,S.$Un)(U(he),M.targetPlatform))continue;const ke=await this.A(he,M,oe);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new b.$ad,he=new E().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,M,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(m,M,C){const Z={id:(0,g.$to)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=M.versions?.find(de=>(0,g.$oo)(de,Z))?.version,ce=(0,y.$of)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(de=>(0,g.$oo)(de,Z))?.includePreRelease,oe=U(m),pe=q(m.versions,M.targetPlatform);if(M.compatible&&(0,S.$Un)(oe,M.targetPlatform))return null;for(let de=0;de<pe.length;de++){const ge=pe[de];if(!(W&&ge.version!==W)){if(await this.y(ge,ce?"any":"release",M.compatible,oe,M.targetPlatform))return Y(m,ge,oe,C);if(W&&ge.version===W)return null}}return W||M.compatible?null:Y(m,m.versions[0],oe)}async B(m,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,s(i.Unpublished));const C=await this.j,Z=JSON.stringify(m.raw),W={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},ce=new b.$ad;let oe,pe,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:W},M),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$Mo)(oe);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw pe=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Z.length),duration:ce.elapsed(),success:!!oe&&(0,h.$Jo)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:pe?(0,R.$2)(pe)?"canceled":(0,R.$8)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,M,C,Z){if(!this.isEnabled())return;const W=A.$o?this.x(`/itemName/${m}.${M}/version/${C}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${M}/${C}/stats?statType=${Z}`),ce=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:W,headers:pe},D.CancellationToken.None)}catch{}}async download(m,M,C){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Z=(0,g.$wo)(m),W=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),oe=C===2?"install":C===3?"update":"",pe=oe?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:m.assets.download,de=m.queryContext?.[a]?{[a]:m.queryContext[a]}:void 0,ge=await this.D(pe,de?{headers:de}:void 0);await this.q.writeFile(M,ge.stream),ce(new Date().getTime()-W)}async downloadSignatureArchive(m,M){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const C=await this.D(m.assets.signature);await this.q.writeFile(M,C.stream)}async getReadme(m,M){if(m.assets.readme){const C=await this.D(m.assets.readme,{},M);return await(0,h.$Lo)(C)||""}return""}async getManifest(m,M){if(m.assets.manifest){const C=await this.D(m.assets.manifest,{},M),Z=await(0,h.$Lo)(C);return Z?JSON.parse(Z):null}return null}async C(m,M){const C=ue(m,r.Manifest);if(!C)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},W=await this.D(C,{headers:Z});return await(0,h.$Mo)(W)}async getCoreTranslation(m,M){const C=m.assets.coreTranslations.filter(Z=>Z[0]===M.toUpperCase())[0];if(C){const Z=await this.D(C[1]),W=await(0,h.$Lo)(Z);return W?JSON.parse(W):null}return null}async getChangelog(m,M){if(m.assets.changelog){const C=await this.D(m.assets.changelog,{},M);return await(0,h.$Lo)(C)||""}return""}async getAllCompatibleVersions(m,M,C){let Z=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Z=Z.withFilter(n.ExtensionId,m.identifier.uuid):Z=Z.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(Z,D.CancellationToken.None);if(!W.length)return[];const ce=U(W[0]);if((0,S.$Un)(ce,C))return[];const oe=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,M?"any":"release",!0,ce,C)&&oe.push(ge)}catch{}}));const pe=[],de=new Set;for(const ge of q(oe,C))de.has(ge.version)||(de.add(ge.version),pe.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return pe}async D(m,M={},C=D.CancellationToken.None){const Z=await this.j,W={type:"GET"},ce={...Z,...M.headers||{}};M={...M,...W,headers:ce};const oe=m.uri,pe=m.fallbackUri,de={...M,url:oe};try{const ge=await this.k.request(de,C);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$Lo)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$2)(ge))throw ge;const fe=(0,R.$8)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...M,url:pe};return this.k.request(he,C)}}async E(m){let M=ae(m);if(!M){const C=await this.C(m,D.CancellationToken.None);if(!C)throw new Error("Manifest was not found");M=C.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,h.$Mo)(m),C=[],Z={},W=[];if(M){for(const ce of M.malicious)C.push({id:ce});if(M.migrateToPreRelease)for(const[ce,oe]of Object.entries(M.migrateToPreRelease))(!oe.engine||(0,d.$Go)(oe.engine,this.u.version,this.u.date))&&(Z[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ce,oe]of Object.entries(M.deprecated))oe&&(Z[ce.toLowerCase()]=(0,y.$of)(oe)?{}:oe);if(M.search)for(const ce of M.search)W.push(ce)}return{malicious:C,deprecated:Z,search:W}}};x=$e([se(1,h.$Ho),se(2,w.$4i),se(3,O.$Hh),se(4,p.$8k),se(5,v.$5j),se(6,$.$jj),se(7,l.$7h)],x);let F=class extends x{constructor(m,M,C,Z,W,ce,oe,pe){super(m,M,C,Z,W,ce,oe,pe)}};e.$3o=F,e.$3o=F=$e([se(0,k.$To),se(1,h.$Ho),se(2,w.$4i),se(3,O.$Hh),se(4,p.$8k),se(5,v.$5j),se(6,$.$jj),se(7,l.$7h)],F);let z=class extends x{constructor(m,M,C,Z,W,ce,oe){super(void 0,m,M,C,Z,W,ce,oe)}};e.$4o=z,e.$4o=z=$e([se(0,h.$Ho),se(1,w.$4i),se(2,O.$Hh),se(3,p.$8k),se(4,v.$5j),se(5,$.$jj),se(6,l.$7h)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,D,R,A,N,y,u,l,O){"use strict";var S,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=void 0;let d=class extends u.$Gk{static{S=this}static{this.a="profileAssociationsMigration"}constructor(h,f,k,p,b){super(k,p,f,b),this.U=h,this.W=k}O(){return this.U.getItem(S.b,[]).map(f=>({...f,location:(0,l.$if)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}Q(){const h=this.U.getItem(S.c,{});return this.U.getItem(S.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$cN=d,e.$cN=d=S=$e([se(0,N.$0M),se(1,y.$Bk),se(2,D.$Ih),se(3,R.$5j),se(4,A.$4i)],d);let v=g=class extends d{constructor(h,f,k,p,b){super(h,f,k,p,b),this.$=h}P(h){h.length?this.$.setItem(g.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(g.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(g.c,h):this.$.removeItem(g.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((b,{workspace:t,profile:a})=>(b[L.URI.revive(t).toString()]=L.URI.revive(a).toString(),b),{});this.$.setItem(g.c,{workspaces:p})}const k=super.Q();return this.$.getItem(g.a,!1)||(this.R(k),this.$.setItem(g.a,!0)),k}};e.$dN=v,e.$dN=v=g=$e([se(0,N.$$M),se(1,y.$Bk),se(2,D.$Ih),se(3,R.$5j),se(4,A.$4i)],v);let w=class extends v{constructor(h,f,k,p){super(new O.$bN(0,f,p,k),h,f,k,p)}async init(){return await this.$.init(),super.init()}};e.$eN=w,e.$eN=w=$e([se(0,y.$Bk),se(1,D.$Ih),se(2,R.$5j),se(3,A.$4i)],w)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,D,R,A,N,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.zip=e.$_o=e.$$o=void 0,e.$$o="end of central directory record signature not found";const O=new RegExp(e.$$o);class S extends Error{constructor(a,i){let s=i.message;switch(a){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=a,this.cause=i}}e.$_o=S;function g(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,s)=>i+s,a&61440)}function d(t){if(t instanceof S)return t;let a;return O.test(t.message)&&(a="CorruptZip"),new S(a,t)}function v(t,a,i,s,n,r){const c=R.$$d(a),I=R.$8d(s,c);if(!I.startsWith(s))return Promise.reject(new Error(y.localize(0,null,a)));const P=R.$8d(s,a);let E;return r.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(N.Promises.mkdir(I,{recursive:!0})).then(()=>new Promise((j,H)=>{if(!r.isCancellationRequested)try{E=(0,L.createWriteStream)(P,{mode:i}),E.once("close",()=>j()),E.once("error",H),t.once("error",H),t.pipe(E)}catch(K){H(K)}}))}function w(t,a,i,s){let n=(0,D.$tg)(()=>Promise.resolve()),r=0;const c=s.onCancellationRequested(()=>{n.cancel(),t.close()});return new Promise((I,P)=>{const E=new D.$Ag,j=H=>{H.isCancellationRequested||(r++,t.readEntry())};t.once("error",P),t.once("close",()=>n.then(()=>{s.isCancellationRequested||t.entryCount===r?I():P(new S("Incomplete",new Error(y.localize(1,null,r,t.entryCount))))},P)),t.readEntry(),t.on("entry",H=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(H.fileName)){j(s);return}const K=H.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(K)){const te=R.$8d(a,K);n=(0,D.$tg)(ae=>N.Promises.mkdir(te,{recursive:!0}).then(()=>j(ae)).then(void 0,P));return}const _=h(t,H),ue=g(H);n=(0,D.$tg)(te=>E.queue(()=>_.then(ae=>v(ae,K,ue,a,i,te).then(()=>j(te)))).then(null,P))})}).finally(()=>c.dispose())}function $(t,a=!1){return new Promise((i,s)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(n,r)=>{n?s(d(n)):i((0,A.$tf)(r))})})}function h(t,a){return new Promise((i,s)=>{t.openReadStream(a,(n,r)=>{n?s(d(n)):i((0,A.$tf)(r))})})}function f(t,a){return new Promise((i,s)=>{const n=new l.ZipFile;a.forEach(c=>{c.contents?n.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&n.addFile(c.localPath,c.path)}),n.end();const r=(0,L.createWriteStream)(t);n.outputStream.pipe(r),n.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>i(t))})}e.zip=f;function k(t,a,i={},s){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=$(t,!0);return i.overwrite&&(r=r.then(c=>N.Promises.rm(a).then(()=>c))),r.then(c=>w(c,a,{sourcePathRegex:n},s))}e.$bp=k;function p(t,a){return $(t).then(i=>new Promise((s,n)=>{i.on("entry",r=>{r.fileName===a&&h(i,r).then(c=>s(c),c=>n(c))}),i.once("close",()=>n(new Error(y.localize(2,null,a))))}))}function b(t,a){return p(t,a).then(i=>new Promise((s,n)=>{const r=[];i.once("error",n),i.on("data",c=>r.push(c)),i.on("end",()=>s(Buffer.concat(r)))}))}e.$cp=b}),define(ne[160],re([0,1,8,9,2,15,17,43,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;let p=class extends R.$jc{static{k=this}static{this.c=".sigzip"}constructor(t,a,i,s,n,r){super(),this.h=a,this.j=i,this.m=s,this.n=n,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,i){await this.g;const s=(0,N.$hg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,r=>this.j.download(t,r,a))}catch(r){throw new v.$Zn(r.message,v.ExtensionManagementErrorCode.Download)}let n=!1;if(i&&this.t(t)){const r=await this.u(t);try{n=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(c){const I=c;if(n=I.code,I.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${I.output}`),n===v.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===v.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new v.$Zn(S.$$o,v.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(c){this.r.error(c)}}}return n===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:s,verificationStatus:n}}t(t){if(!t.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,u.$of)(a)?a:!0}async u(t){await this.g;const a=(0,N.$hg)(this.extensionsDownloadDir,`${this.z(t)}${k.c}`);return await this.w(t,a,i=>this.j.downloadSignatureArchive(t,i)),a}async w(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await i(a);return}const s=(0,N.$hg)(this.extensionsDownloadDir,`.${(0,l.$3f)()}`);await this.h.exists(s)||await i(s);try{await O.Promises.rename(s.fsPath,a.fsPath,2*60*1e3)}catch(n){try{await this.h.del(s)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,D.$8)(n)}. Deleted the file from downloaded location`,s.path),n}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],s=[];for(const c of t.children)if(c.name.endsWith(k.c))s.push(c.resource);else{const I=w.$po.parse(c.name);I&&i.push([I,c])}const n=(0,w.$uo)(i,([c])=>c),r=[];for(const c of n)c.sort((I,P)=>y.rcompare(I[0].version,P[0].version)),a.push(...c.slice(1).map(I=>I[1].resource)),r.push(c[0][1]);r.sort((c,I)=>c.mtime-I.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(c=>c.resource)),a.push(...s),await L.Promises.settled(a.map(c=>(this.r.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(t){this.r.error(t)}}z(t){return this.f?w.$po.create(t).toString().toLowerCase():(0,l.$3f)()}};e.$rp=p,e.$rp=p=k=$e([se(0,d.$Ih),se(1,h.$5j),se(2,v.$Yn),se(3,g.$7h),se(4,$.$5o),se(5,f.$4i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;function R(A){return(0,L.$cp)(A,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$tp=R}),define(ne[162],re([0,1,8,14,20,33,9,4,42,2,35,15,16,17,43,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,31,26,22,23]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f,k,p,b,t,a,i,s,n,r,c,I,P,E,j,H,K,_,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$wp=(0,_.$Bh)(i.$1n);const B=".vsctmp";let G=class extends a.$dp{constructor(F,z,o,m,M,C,Z,W,ce,oe,pe,de){super(F,z,pe,o,oe,de),this.fb=M,this.gb=C,this.hb=Z,this.ib=ce,this.eb=new Map,this.rb=new O.$zi;const ge=this.B(W.createInstance(I.$sp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new E.$up(de,ce,pe,this,this.F)),this.db=this.B(W.createInstance(c.$rp));const fe=this.B(new j.$vp(this,this.fb,de,C,pe,ce,o));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$zo)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const z=await this.pb(F),o=await(0,k.zip)((0,d.$hg)(this.db.extensionsDownloadDir,(0,h.$3f)()).fsPath,z);return $.URI.file(o)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:z,cleanup:o}=await this.lb(F),m=g.$9d(z.fsPath);try{return await(0,P.$tp)(m)}finally{await o()}}getInstalled(F,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,z={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:o,cleanup:m}=await this.lb(F);try{const M=await(0,P.$tp)(g.$9d(o.fsPath)),C=(0,s.$to)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,H.$Go)(M.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const W=(await this.I([{manifest:M,extension:o,options:z}])).find(({identifier:ce})=>(0,s.$oo)(ce,{id:C}));if(W?.local)return W.local;throw W?.error?W.error:(0,a.$fp)(new Error(`Unknown error while installing extension ${C}`))}finally{await m()}}async installFromLocation(F,z){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const o=await this.bb.scanUserExtensionAtLocation(F);if(!o)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[o,void 0]],z),this.F.info("Successfully installed extension",o.identifier.id,z.toString()),o}async installExtensionsFromProfile(F,z,o){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,z.toString(),o.toString());const m=(await this.bb.scanExtensions(1,z)).filter(M=>F.some(C=>(0,s.$oo)(C,M.identifier)));if(m.length){const M=await Promise.all(m.map(C=>this.bb.scanMetadata(C,z)));await this.ub(m.map((C,Z)=>[C,M[Z]]),o),this.F.info("Successfully installed extensions",m.map(C=>C.identifier.id),o.toString())}return m}async updateMetadata(F,z,o=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.pinned=z.pinned||void 0,F=await this.bb.updateMetadata(F,z,o),this.cb.invalidate(o),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[o]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:z,compatible:!0},R.CancellationToken.None);if(!o)throw new Error(p.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(m){throw new Error(p.localize(3,null,(0,A.$li)(m)))}return this.installFromGallery(o)}ab(F,z,o,m){return this.bb.copyExtension(F,z,o,m)}copyExtensions(F,z){return this.bb.copyExtensions(F,z)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,z,o){const{location:m}=await this.db.download(F,z,!o);return m}async lb(F){if(F.scheme===S.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const z=(0,d.$hg)(this.db.extensionsDownloadDir,(0,h.$3f)());return await this.hb.download(F,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,z,o){if($.URI.isUri(z))return new X(F,z,o,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=s.$po.create(z).toString();let M=this.eb.get(m);return M||(this.eb.set(m,M=new q(F,z,o,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),M.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),M}$(F,z){return new Y(F,z.profileLocation,this.gb)}async pb(F){const z=async m=>{let M=await f.Promises.readdir(m);M=M.map(W=>g.$8d(m,W));const C=await Promise.all(M.map(W=>f.Promises.stat(W)));let Z=Promise.resolve([]);return C.forEach((W,ce)=>{const oe=M[ce];W.isFile()&&(Z=Z.then(pe=>[...pe,oe])),W.isDirectory()&&(Z=Z.then(pe=>z(oe).then(de=>[...pe,...de])))}),Z};return(await z(F.location.fsPath)).map(m=>({path:`extension/${g.$0d(F.location.fsPath,m)}`,localPath:m}))}async qb({added:F,removed:z}){if(z)for(const o of z.extensions)this.F.info("Extensions removed from another source",o.id,z.profileLocation.toString()),this.u.fire({identifier:o,profileLocation:z.profileLocation});if(F){const m=(await this.bb.scanExtensions(1,F.profileLocation)).filter(M=>F.extensions.some(C=>(0,s.$oo)(C,M.identifier)));this.s.fire(m.map(M=>(this.F.info("Extensions added from another source",M.identifier.id,F.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of F.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const o of F.rawAdded){if(this.rb.has(o)||!this.D.extUri.isEqual(this.D.extUri.dirname(o),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(o,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(o).startsWith(".")||!(await this.ib.stat(o)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(o);m&&m.installedTimestamp===void 0&&(this.rb.add(o),z.push(m))}z.length&&(await this.ub(z.map(o=>[o,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(o=>o.identifier.id)))}async ub(F,z){const o=F.map(m=>m[0]);await this.vb(o),await this.gb.addExtensionsToProfile(F,z),this.s.fire(o.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:z})))}async vb(F){const z=await this.bb.getUninstalledExtensions();for(const o of F){const m=s.$po.create(o);z[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$xp=G,e.$xp=G=$e([se(0,i.$Yn),se(1,ae.$8k),se(2,ue.$4i),se(3,t.$Ih),se(4,r.$mp),se(5,n.$ip),se(6,b.$Cn),se(7,_.$zh),se(8,K.$5j),se(9,te.$jj),se(10,le.$Bk),se(11,ie.$Dk)],G);let T=class extends l.$jc{constructor(F,z,o,m,M,C){super(),this.j=F,this.m=z,this.n=o,this.s=m,this.t=M,this.u=C,this.h=this.B(new y.$ed),this.onExtract=this.h.event,this.c=(0,d.$hg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$Mg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,z){const o={includeInvalid:!0,profileLocation:z};let m=[];return F===null||F===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},o,!1)):F===1&&m.push(...await this.n.scanUserExtensions(o)),m=F!==null?m.filter(M=>M.type===F):m,Promise.all(m.map(M=>this.F(M)))}async scanAllUserExtensions(F){const z=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(z.map(o=>this.F(o)))}async scanUserExtensionAtLocation(F){try{const z=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(F,z,o,m,M){const C=F.toString(),Z=$.URI.file(g.$8d(this.n.userExtensionsLocation.fsPath,`.${(0,h.$3f)()}`)),W=$.URI.file(g.$8d(this.n.userExtensionsLocation.fsPath,C));let ce=await this.m.exists(W);if(ce&&m){try{await this.y(F.id,W,"removeExisting")}catch{throw new i.$Zn(p.localize(4,null,W.fsPath,F.id),i.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${W.fsPath}`),await(0,k.$bp)(z,Z.fsPath,{sourcePath:"extension",overwrite:!0},M),this.u.info(`Extracted extension to ${W}:`,F.id)}catch(oe){let pe=i.ExtensionManagementErrorCode.Extract;throw oe instanceof k.$_o&&(oe.type==="CorruptZip"?pe=i.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(pe=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$Zn(oe.message,pe)}await this.n.updateMetadata(Z,o);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${W.fsPath}`),await this.C(Z.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,N.$8)(oe)}. Deleted from extracted location`,Z),oe}this.h.fire(W)}catch(oe){try{await this.m.del(Z,{recursive:!0})}catch{}throw oe}return this.D(W,1)}async scanMetadata(F,z){return z?(await this.w(F,z))?.metadata:this.n.scanMetadata(F.location)}async w(F,z){return(await this.s.scanProfileExtensions(z)).find(m=>(0,s.$oo)(m.identifier,F.identifier))}async updateMetadata(F,z,o){return o?await this.s.updateMetadata([[F,z]],o):await this.n.updateMetadata(F.location,z),this.D(F.location,F.type,o)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const z=F.map(o=>s.$po.create(o));await this.z(o=>z.forEach(m=>{o[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(F){await this.z(z=>delete z[F.toString()])}async removeExtension(F,z){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,z)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(z=>delete z[s.$po.create(F).toString()])}async copyExtension(F,z,o,m){const M=await this.w(F,z),C=await this.w(F,o);return m={...M?.metadata,...m},C?await this.s.updateMetadata([[F,{...C.metadata,...m}]],o):await this.s.addExtensionsToProfile([[F,m]],o),this.D(F.location,F.type,o)}async copyExtensions(F,z){const o=await this.scanExtensions(1,F),m=await Promise.all(o.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,F)]));await this.s.addExtensionsToProfile(m,z)}async y(F,z,o){this.u.trace(`Deleting ${o} extension from disk`,F,z.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$oi)((0,h.$3f)()).toString(16)}${B}`);await this.C(z.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${o} extension from disk`,F,z.fsPath)}async z(F){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,K.$ik)(m)!==1)throw m}let o={};if(z)try{o=JSON.parse(z)}catch{}return F&&(F(o),Object.keys(o).length?await this.m.writeFile(this.c,D.$Ed.fromString(JSON.stringify(o))):await this.m.del(this.c)),o})}async C(F,z){try{await f.Promises.rename(F,z,2*60*1e3)}catch(o){throw new i.$Zn(o.message||p.localize(5,null,F,z),o.code||i.ExtensionManagementErrorCode.Rename)}}async D(F,z,o){if(o){const M=(await this.n.scanUserExtensions({profileLocation:o})).find(C=>this.t.extUri.isEqual(C.location,F));if(M)return this.F(M)}else{const m=await this.n.scanExistingExtension(F,z,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(p.localize(6,null,F.path))}async F(F){const z=await this.m.resolve(F.location);let o,m;return z.children&&(o=z.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,m=z.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:o,changelogUrl:m,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),o=new Set;for(const M of z)F[s.$po.create(M).toString()]||o.add(M.identifier.id.toLowerCase());try{const M=(0,s.$uo)(z,C=>C.identifier);await L.Promises.settled(M.map(async C=>{const Z=C.sort((W,ce)=>v.rcompare(W.manifest.version,ce.manifest.version))[0];o.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(M){this.u.error(M)}const m=z.filter(M=>M.metadata&&F[s.$po.create(M).toString()]);await Promise.allSettled(m.map(M=>this.removeUninstalledExtension(M)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,K.$ik)(z)!==1&&this.u.error(z);return}if(F?.children)try{await Promise.allSettled(F.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(o){(0,K.$ik)(o)!==1&&this.u.error(o)}}}))}catch{}}};e.$yp=T,e.$yp=T=$e([se(1,K.$5j),se(2,r.$mp),se(3,n.$ip),se(4,le.$Bk),se(5,ue.$4i)],T);class U extends a.$gp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$pf)(this.options.operation)?this.l:this.options.operation}constructor(F,z,o,m,M,C,Z,W,ce){super(),this.identifier=F,this.source=z,this.options=o,this.m=m,this.n=M,this.o=C,this.p=Z,this.q=W,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[z,o]=await this.x(F);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,o]],this.j),z}async u({zipPath:F,key:z,metadata:o},m,M){let C=await this.v(z);return C||(this.s.trace("Extracting extension...",z.id),C=await this.m.extractUserExtension(z,F,o,m,M),this.s.info("Extracting extension completed.",z.id)),C}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(m=>s.$po.create(m).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class q extends U{constructor(F,z,o,m,M,C,Z,W,ce,oe){super(z.identifier,z,o,M,C,Z,W,ce,oe),this.y=z,this.z=m}async x(F){const o=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,s.$oo)(Z.identifier,this.y.identifier));o&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||o?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||o?.isMachineScoped,isBuiltin:this.options.isBuiltin||o?.isBuiltin,isSystem:o?.type===0?!0:void 0,updated:!!o,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$of)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:o?.preRelease)};if(o?.manifest.version===this.y.version)return[await this.m.updateMetadata(o,m),m];const{location:M,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(M.fsPath),[await this.u({zipPath:M.fsPath,key:s.$po.create(this.y),metadata:m},!1,F),m]}catch(Z){try{await this.z.delete(M)}catch(W){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,N.$8)(W))}throw Z}}async B(F){try{await(0,P.$tp)(F)}catch(z){throw new i.$Zn((0,a.$ep)(z).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$zp=q;class X extends U{constructor(F,z,o,m,M,C,Z,W,ce,oe){super({id:(0,s.$to)(F.publisher,F.name)},z,o,M,C,Z,W,ce,oe),this.y=F,this.z=z,this.A=m}async h(F){const z=await super.h(F);return this.D(z,F),z}async x(F){const z=new s.$po(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,s.$oo)(this.identifier,Z.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this.l=3,z.equals(new s.$po(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&v.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Z=await this.v(z);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$9d(this.z.fsPath),key:z,metadata:M},!0,F),M]}async D(F,z){try{let[o]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],z);if(o||([o]=await this.A.getExtensions([{id:F.identifier.id}],z)),o){const m={id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId,isPreReleaseVersion:o.properties.isPreReleaseVersion,preRelease:o.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,m,this.options.profileLocation)}}catch{}}}class Y extends a.$gp{constructor(F,z,o){super(),this.extension=F,this.j=z,this.k=o}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,45,136,178]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=void 0;let v=class extends S.$Io{constructor(f,k,p,b){super(b),this.m=f,this.n=k,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,k){const{f:p,g:b}=this;let t;try{t=await(0,l.$Ll)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$8)(s)))}const a={...process.env,...t},i=f.agent?f.agent:await(0,g.$Lq)(f.url||"",a,{proxyUrl:p,strictSSL:b});return f.agent=i,f.strictSSL=b,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,k))}async resolveProxy(f){}};e.$Mq=v,e.$Mq=v=$e([se(0,y.$7h),se(1,u.$Ih),se(2,O.$4i),se(3,O.$5i)],v);async function w(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,b)=>{J(["https"],p,b)}):await new Promise((p,b)=>{J(["http"],p,b)})).request}async function $(h,f){return D.Promises.withAsyncBody(async(k,p)=>{const b=(0,L.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await w(h),a={hostname:b.hostname,port:b.port?parseInt(b.port):b.protocol==="https:"?443:80,protocol:b.protocol,path:b.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,N.$of)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(a.auth=h.user+":"+h.password);const i=t(a,s=>{const n=(0,N.$mf)(h.followRedirects)?h.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)$({...h,url:s.headers.location,followRedirects:n-1},f).then(k,p);else{let r=s;!h.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,d.createGunzip)())),k({res:s,stream:(0,R.$Td)(r)})}});i.on("error",p),h.timeout&&i.setTimeout(h.timeout),h.isChromiumNetwork&&i.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&i.write(h.data),i.end(),f.onCancellationRequested(()=>{i.abort(),p(new A.$3)})})}e.$Nq=$}),define(ne[179],re([0,1,32,8,33,9,2,15,16,13,34,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,31,45,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,D,R,A,N,y,u,l,O,S,g,d,v,w,$,h,f,k,p,b,t,a,i,s,n,r,c,I,P,E,j,H,K,_,ue,te,ae,le,ie,B,G,T,U,q,X,Y,x,F,z,o,m,M,C,Z,W,ce,oe,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends N.$jc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(_.$4i),Me=be.get(r.$5j),V=be.get(h.$Ih),Q=be.get(m.$Dk);ke.info("CLI main",this.b),this.g(ke),await this.h(V,Me,Q,he),await Promise.all(we.map(ee=>{(0,D.$xg)(ee.flush(),1e3)}))})}async f(){const he=new j.$yh,we={_serviceBrand:void 0,...le.default};he.set(ie.$jj,we);const be=new f.$$l(this.b,we);he.set(h.$Ih,be),await Promise.all([be.appSettingsHome.with({scheme:y.Schemas.file}).fsPath,be.extensionsPath].map(De=>De?g.Promises.mkdir(De,{recursive:!0}):void 0));const ke=new ce.$9M((0,_.$fj)(be),be.logsHome);he.set(_.$5i,ke);const Me=this.B(ke.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];ke.getLogLevel()===_.LogLevel.Trace&&V.push(new _.$_i(ke.getLogLevel()));const Q=this.B(new W.$gN(Me,V));he.set(_.$4i,Q);const ee=this.B(new c.$Bp(Q));he.set(r.$5j,ee);const me=this.B(new I.$1p(Q));ee.registerProvider(y.Schemas.file,me),ee.registerProvider(y.Schemas.vscodeUserData,new pe.$36b(y.Schemas.file,me,y.Schemas.vscodeUserData,Q));const ye=new o.$nr(ee);he.set(z.$Bk,ye);const je=new T.$aN(1,be,Q,ee),Se=new M.$cN(je,ye,be,ee,Q);he.set(m.$Dk,Se);const Le=l.$i&&we.win32RegValueName?this.B(new ae.$16b(Q,we.win32RegValueName)):be.policyFile?this.B(new ue.$26b(be.policyFile,ee,Q)):new te.$$m;he.set(te.$9m,Le);const Ie=this.B(new v.$yn(Se.defaultProfile.settingsResource,ee,Le,Q));he.set(d.$7h,Ie),await Promise.all([je.init(),Ie.initialize()]);let Ae;try{Ae=await(0,C.$H6b)(je,Q)}catch(De){De.code!=="ENOENT"&&Q.error(De)}Se.init(),he.set(z.$Bk,new o.$nr(ee));const Fe=new G.$Mq(Ie,be,Q,ke);he.set(B.$Ho,Fe),he.set(w.$Cn,new P.$xh($.$vN,void 0,!0)),he.set(a.$ip,new P.$xh(Z.$fN,void 0,!0)),he.set(i.$mp,new P.$xh(n.$E6b,void 0,!0)),he.set(b.$5o,new P.$xh(b.$6o,void 0,!0)),he.set(s.$wp,new P.$xh(s.$xp,void 0,!0)),he.set(p.$Yn,new P.$xh(k.$4o,void 0,!0)),he.set(H.$Gq,new P.$xh(K.$Iq,void 0,!1));const Oe=[],Ne=(0,Y.$lo)(we,Ie);if((0,Y.$go)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new x.$7M(Fe,Ne,"monacoworkbench",null,we.aiConfig.ariaKey));const De={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,U.$9n)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,Ne),piiPaths:(0,Y.$mo)(be)};he.set(q.$8k,new P.$xh(X.$Oq,[De],!1))}else he.set(q.$8k,Y.$ao);return[new E.$4p(he),Oe]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$li)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$X)(we)||(0,A.$Y)(we)}),process.on("unhandledRejection",we=>(0,A.$Y)(we))}async h(he,we,be,ke){let Me;if(he.args.profile&&(Me=be.profiles.find(Q=>Q.name===he.args.profile),!Me))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Me??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(t.$7o,new _.$_i(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Q={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(t.$7o,new _.$_i(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Q,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(t.$7o,new _.$_i(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return ke.createInstance(t.$7o,new _.$_i(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$m7b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?S.URI.file((0,u.$7d)(we)?we:(0,u.$8d)((0,O.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f36df69328ed10f76d4be03e8a82b61794b49711/core/vs/code/node/cliProcessMain.js.map
