/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/nls","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/resources","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(te){for(var e=[],j=0,N=te.length;j<N;j++)e[j]=re[te[j]];return e};define(re[124],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class j{static get(){const D=new Map,A=new Map,O=new Map,R=new Map;function S(u,d){u.has(d.detail)||u.set(d.detail,-d.timestamp)}function $(u,d){const y=u.get(d.detail);y&&(y>=0||u.set(d.detail,y+d.timestamp))}let C=[];typeof te=="function"&&typeof te.getStats=="function"&&(C=te.getStats().slice(0).sort((u,d)=>u.timestamp-d.timestamp));for(const u of C)switch(u.type){case 10:S(D,u);break;case 11:case 12:$(D,u);break;case 21:S(A,u);break;case 22:$(A,u);break;case 33:S(O,u);break;case 34:$(O,u);break;case 31:S(R,u);break;case 32:$(R,u);break}let p=0;O.forEach(u=>p+=u);function g(u){const d=[];return u.forEach((y,f)=>d.push([f,y])),d}return{amdLoad:g(D),amdInvoke:g(A),nodeRequire:g(O),nodeEval:g(R),nodeRequireTotal:p}}static toMarkdownTable(D,A){let O="";const R=[];return D.forEach((S,$)=>{R[$]=S.length}),A.forEach(S=>{S.forEach(($,C)=>{typeof $>"u"&&($=S[C]="-");const p=$.toString().length;R[C]=Math.max(p,R[C])})}),D.forEach((S,$)=>{O+=`| ${S+" ".repeat(R[$]-S.toString().length)} `}),O+=`|
`,D.forEach((S,$)=>{O+=`| ${"-".repeat(R[$])} `}),O+=`|
`,A.forEach(S=>{S.forEach(($,C)=>{typeof $<"u"&&(O+=`| ${$+" ".repeat(R[C]-$.toString().length)} `)}),O+=`|
`}),O}}e.$S=j}),define(re[125],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function j(y,f,o){const h=N(y,f);if(h!==-1)return y[h]}e.$db=j;function N(y,f,o=y.length-1){for(let h=o;h>=0;h--){const b=y[h];if(f(b))return h}return-1}e.$eb=N;function D(y,f){const o=A(y,f);return o===-1?void 0:y[o]}e.$fb=D;function A(y,f,o=0,h=y.length){let b=o,w=h;for(;b<w;){const I=Math.floor((b+w)/2);f(y[I])?b=I+1:w=I}return b-1}e.$gb=A;function O(y,f){const o=R(y,f);return o===y.length?void 0:y[o]}e.$hb=O;function R(y,f,o=0,h=y.length){let b=o,w=h;for(;b<w;){const I=Math.floor((b+w)/2);f(y[I])?w=I:b=I+1}return b}e.$ib=R;function S(y,f,o=0,h=y.length){const b=R(y,f,o,h);return b===y.length?-1:b}e.$jb=S;class ${static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if($.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!f(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const o=A(this.e,f,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$kb=$;function C(y,f){if(y.length===0)return;let o=y[0];for(let h=1;h<y.length;h++){const b=y[h];f(b,o)>0&&(o=b)}return o}e.$lb=C;function p(y,f){if(y.length===0)return;let o=y[0];for(let h=1;h<y.length;h++){const b=y[h];f(b,o)>=0&&(o=b)}return o}e.$mb=p;function g(y,f){return C(y,(o,h)=>-f(o,h))}e.$nb=g;function u(y,f){if(y.length===0)return-1;let o=0;for(let h=1;h<y.length;h++){const b=y[h];f(b,y[o])>0&&(o=h)}return o}e.$ob=u;function d(y,f){for(const o of y){const h=f(o);if(h!==void 0)return h}}e.$pb=d}),define(re[126],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function j(O,R){const S=Object.create(null);for(const $ of O){const C=R($);let p=S[C];p||(p=S[C]=[]),p.push($)}return S}e.$I=j;function N(O,R){const S=[],$=[];for(const C of O)R.has(C)||S.push(C);for(const C of R)O.has(C)||$.push(C);return{removed:S,added:$}}e.$J=N;function D(O,R){const S=[],$=[];for(const[C,p]of O)R.has(C)||S.push(p);for(const[C,p]of R)O.has(C)||$.push(p);return{removed:S,added:$}}e.$K=D;class A{constructor(){this.a=new Map}add(R,S){let $=this.a.get(R);$||($=new Set,this.a.set(R,$)),$.add(S)}delete(R,S){const $=this.a.get(R);$&&($.delete(S),$.size===0&&this.a.delete(R))}forEach(R,S){const $=this.a.get(R);$&&$.forEach(S)}get(R){const S=this.a.get(R);return S||new Set}}e.$L=A}),define(re[83],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function j(O){return(R,S,$)=>{let C=null,p=null;if(typeof $.value=="function"?(C="value",p=$.value):typeof $.get=="function"&&(C="get",p=$.get),!p)throw new Error("not supported");$[C]=O(p,S)}}function N(O,R,S){let $=null,C=null;if(typeof S.value=="function"?($="value",C=S.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&($="get",C=S.get),!C)throw new Error("not supported");const p=`$memoize$${R}`;S[$]=function(...g){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,g)}),this[p]}}e.$5g=N;function D(O,R,S){return j(($,C)=>{const p=`$debounce$${C}`,g=`$debounce$result$${C}`;return function(...u){this[g]||(this[g]=S?S():void 0),clearTimeout(this[p]),R&&(this[g]=R(this[g],...u),u=[this[g]]),this[p]=setTimeout(()=>{$.apply(this,u),this[g]=S?S():void 0},O)}})}e.$6g=D;function A(O,R,S){return j(($,C)=>{const p=`$throttle$timer$${C}`,g=`$throttle$result$${C}`,u=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...y){if(this[g]||(this[g]=S?S():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...y)),this[d])return;const f=this[u]+O;f<=Date.now()?(this[u]=Date.now(),$.apply(this,[this[g]]),this[g]=S?S():void 0):(this[d]=!0,this[p]=setTimeout(()=>{this[d]=!1,this[u]=Date.now(),$.apply(this,[this[g]]),this[g]=S?S():void 0},f-Date.now()))}})}e.$7g=A}),define(re[8],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class j{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?b.isErrorNoTelemetry(t)?new b(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=j,e.$V=new j;function N(I){e.$V.setUnexpectedErrorHandler(I)}e.setUnexpectedErrorHandler=N;function D(I){if(!I||typeof I!="object")return!1;const t=I;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=D;function A(I){$(I)||e.$V.onUnexpectedError(I)}e.$Y=A;function O(I){$(I)||e.$V.onUnexpectedExternalError(I)}e.$Z=O;function R(I){if(I instanceof Error){const{name:t,message:c}=I,s=I.stacktrace||I.stack;return{$isError:!0,name:t,message:c,stack:s,noTelemetry:b.isErrorNoTelemetry(I)}}return I}e.$1=R;const S="Canceled";function $(I){return I instanceof C?!0:I instanceof Error&&I.name===S&&I.message===S}e.$2=$;class C extends Error{constructor(){super(S),this.name=this.message}}e.$3=C;function p(){const I=new Error(S);return I.name=I.message,I}e.$4=p;function g(I){return I?new Error(`Illegal argument: ${I}`):new Error("Illegal argument")}e.$5=g;function u(I){return I?new Error(`Illegal state: ${I}`):new Error("Illegal state")}e.$6=u;class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=d;function y(I){return I?I.message?I.message:I.stack?I.stack.split(`
`)[0]:String(I):"Error"}e.$8=y;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=f;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=o;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=h;class b extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof b)return t;const c=new b;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=b;class w extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$ab=w}),define(re[18],oe([0,1,8,125]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.$4b=e.CompareResult=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.top=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function D(F,M=0){return F[F.length-(1+M)]}e.$qb=D;function A(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$rb=A;function O(F,M,K=(_,ae)=>_===ae){if(F===M)return!0;if(!F||!M||F.length!==M.length)return!1;for(let _=0,ae=F.length;_<ae;_++)if(!K(F[_],M[_]))return!1;return!0}e.$sb=O;function R(F,M){const K=F.length-1;M<K&&(F[M]=F[K]),F.pop()}e.$tb=R;function S(F,M,K){return $(F.length,_=>K(F[_],M))}e.$ub=S;function $(F,M){let K=0,_=F-1;for(;K<=_;){const ae=(K+_)/2|0,he=M(ae);if(he<0)K=ae+1;else if(he>0)_=ae-1;else return ae}return-(K+1)}e.$vb=$;function C(F,M,K){if(F=F|0,F>=M.length)throw new TypeError("invalid index");const _=M[Math.floor(M.length*Math.random())],ae=[],he=[],fe=[];for(const le of M){const $e=K(le,_);$e<0?ae.push(le):$e>0?he.push(le):fe.push(le)}return F<ae.length?C(F,ae,K):F<ae.length+fe.length?fe[0]:C(F-(ae.length+fe.length),he,K)}e.$wb=C;function p(F,M){const K=[];let _;for(const ae of F.slice(0).sort(M))!_||M(_[0],ae)!==0?(_=[ae],K.push(_)):_.push(ae);return K}e.$xb=p;function*g(F,M){let K,_;for(const ae of F)_!==void 0&&M(_,ae)?K.push(ae):(K&&(yield K),K=[ae]),_=ae;K&&(yield K)}e.$yb=g;function u(F,M){for(let K=0;K<=F.length;K++)M(K===0?void 0:F[K-1],K===F.length?void 0:F[K])}e.$zb=u;function d(F,M,K){const _=[];function ae(le,$e,de){if($e===0&&de.length===0)return;const we=_[_.length-1];we&&we.start+we.deleteCount===le?(we.deleteCount+=$e,we.toInsert.push(...de)):_.push({start:le,deleteCount:$e,toInsert:de})}let he=0,fe=0;for(;;){if(he===F.length){ae(he,0,M.slice(fe));break}if(fe===M.length){ae(he,F.length-he,[]);break}const le=F[he],$e=M[fe],de=K(le,$e);de===0?(he+=1,fe+=1):de<0?(ae(he,1,[]),he+=1):de>0&&(ae(he,0,[$e]),fe+=1)}return _}e.$Ab=d;function y(F,M,K){const _=d(F,M,K),ae=[],he=[];for(const fe of _)ae.push(...F.slice(fe.start,fe.start+fe.deleteCount)),he.push(...fe.toInsert);return{removed:ae,added:he}}e.$Bb=y;function f(F,M,K){if(K===0)return[];const _=F.slice(0,K).sort(M);return h(F,M,_,K,F.length),_}e.top=f;function o(F,M,K,_,ae){return K===0?Promise.resolve([]):new Promise((he,fe)=>{(async()=>{const le=F.length,$e=F.slice(0,K).sort(M);for(let de=K,we=Math.min(K+_,le);de<le;de=we,we=Math.min(we+_,le)){if(de>K&&await new Promise(Ee=>setTimeout(Ee)),ae&&ae.isCancellationRequested)throw new j.$3;h(F,M,$e,de,we)}return $e})().then(he,fe)})}e.$Db=o;function h(F,M,K,_,ae){for(const he=K.length;_<ae;_++){const fe=F[_];if(M(fe,K[he-1])<0){K.pop();const le=(0,N.$ib)(K,$e=>M(fe,$e)<0);K.splice(le,0,fe)}}}function b(F){return F.filter(M=>!!M)}e.$Eb=b;function w(F){let M=0;for(let K=0;K<F.length;K++)F[K]&&(F[M]=F[K],M+=1);F.length=M}e.$Fb=w;function I(F,M,K){F.splice(K,0,F.splice(M,1)[0])}e.$Gb=I;function t(F){return!Array.isArray(F)||F.length===0}e.$Hb=t;function c(F){return Array.isArray(F)&&F.length>0}e.$Ib=c;function s(F,M=K=>K){const K=new Set;return F.filter(_=>{const ae=M(_);return K.has(ae)?!1:(K.add(ae),!0)})}e.$Jb=s;function n(F){const M=new Set;return K=>{const _=F(K);return M.has(_)?!1:(M.add(_),!0)}}e.$Kb=n;function i(F,M){return F.length>0?F[0]:M}e.$Lb=i;function r(F,M){return F.length>0?F[F.length-1]:M}e.$Mb=r;function l(F,M,K=(_,ae)=>_===ae){let _=0;for(let ae=0,he=Math.min(F.length,M.length);ae<he&&K(F[ae],M[ae]);ae++)_++;return _}e.$Nb=l;function E(F){return[].concat(...F)}e.$Ob=E;function m(F,M){let K=typeof M=="number"?F:0;typeof M=="number"?K=F:(K=0,M=F);const _=[];if(K<=M)for(let ae=K;ae<M;ae++)_.push(ae);else for(let ae=K;ae>M;ae--)_.push(ae);return _}e.$Pb=m;function a(F,M,K){return F.reduce((_,ae)=>(_[M(ae)]=K?K(ae):ae,_),Object.create(null))}e.$Qb=a;function v(F,M){return F.push(M),()=>L(F,M)}e.$Rb=v;function L(F,M){const K=F.indexOf(M);if(K>-1)return F.splice(K,1),M}e.$Sb=L;function T(F,M,K){const _=F.slice(0,M),ae=F.slice(M);return _.concat(K,ae)}e.$Tb=T;function z(F,M){let K;if(typeof M=="number"){let _=M;K=()=>{const ae=Math.sin(_++)*179426549;return ae-Math.floor(ae)}}else K=Math.random;for(let _=F.length-1;_>0;_-=1){const ae=Math.floor(K()*(_+1)),he=F[_];F[_]=F[ae],F[ae]=he}}e.$Ub=z;function U(F,M){const K=F.indexOf(M);K>-1&&(F.splice(K,1),F.unshift(M))}e.$Vb=U;function B(F,M){const K=F.indexOf(M);K>-1&&(F.splice(K,1),F.push(M))}e.$Wb=B;function Q(F,M){for(const K of M)F.push(K)}e.$Xb=Q;function J(F,M){return Array.isArray(F)?F.map(M):M(F)}e.$Yb=J;function x(F){return Array.isArray(F)?F:[F]}e.$Zb=x;function H(F){return F[Math.floor(Math.random()*F.length)]}e.$1b=H;function X(F,M,K){const _=W(F,M),ae=F.length,he=K.length;F.length=ae+he;for(let fe=ae-1;fe>=_;fe--)F[fe+he]=F[fe];for(let fe=0;fe<he;fe++)F[fe+_]=K[fe]}e.$2b=X;function G(F,M,K,_){const ae=W(F,M);let he=F.splice(ae,K);return he===void 0&&(he=[]),X(F,ae,_),he}e.$3b=G;function W(F,M){return M<0?Math.max(M+F.length,0):Math.min(M,F.length)}var V;(function(F){function M(he){return he<0}F.isLessThan=M;function K(he){return he<=0}F.isLessThanOrEqual=K;function _(he){return he>0}F.isGreaterThan=_;function ae(he){return he===0}F.isNeitherLessOrGreaterThan=ae,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function ee(F,M){return(K,_)=>M(F(K),F(_))}e.$4b=ee;function ne(...F){return(M,K)=>{for(const _ of F){const ae=_(M,K);if(!V.isNeitherLessOrGreaterThan(ae))return ae}return V.neitherLessOrGreaterThan}}e.$5b=ne;const se=(F,M)=>F-M;e.$6b=se;const Z=(F,M)=>(0,e.$6b)(F?1:0,M?1:0);e.$7b=Z;function q(F){return(M,K)=>-F(M,K)}e.$8b=q;class k{constructor(M){this.g=M,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(M){let K=this.c;for(;K<this.g.length&&M(this.g[K]);)K++;const _=K===this.c?null:this.g.slice(this.c,K);return this.c=K,_}takeFromEndWhile(M){let K=this.d;for(;K>=0&&M(this.g[K]);)K--;const _=K===this.d?null:this.g.slice(K+1,this.d+1);return this.d=K,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const M=this.g[this.c];return this.c++,M}removeLast(){const M=this.g[this.d];return this.d--,M}takeCount(M){const K=this.g.slice(this.c,this.c+M);return this.c+=M,K}}e.$9b=k;class P{static{this.empty=new P(M=>{})}constructor(M){this.iterate=M}forEach(M){this.iterate(K=>(M(K),!0))}toArray(){const M=[];return this.iterate(K=>(M.push(K),!0)),M}filter(M){return new P(K=>this.iterate(_=>M(_)?K(_):!0))}map(M){return new P(K=>this.iterate(_=>K(M(_))))}some(M){let K=!1;return this.iterate(_=>(K=M(_),!K)),K}findFirst(M){let K;return this.iterate(_=>M(_)?(K=_,!1):!0),K}findLast(M){let K;return this.iterate(_=>(M(_)&&(K=_),!0)),K}findLastMaxBy(M){let K,_=!0;return this.iterate(ae=>((_||V.isGreaterThan(M(ae,K)))&&(_=!1,K=ae),!0)),K}}e.$0b=P}),define(re[127],oe([0,1,8]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xc=e.$wc=e.$vc=e.$uc=e.ok=void 0;function N(S,$){if(!S)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=N;function D(S,$="Unreachable"){throw new Error($)}e.$uc=D;function A(S){if(!S)throw new j.$ab("Assertion Failed")}e.$vc=A;function O(S){if(!S()){debugger;S(),(0,j.$Y)(new j.$ab("Assertion Failed"))}}e.$wc=O;function R(S,$){let C=0;for(;C<S.length-1;){const p=S[C],g=S[C+1];if(!$(p,g))return!1;C++}return!0}e.$xc=R}),define(re[84],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function j(N){const D=this;let A=!1,O;return function(){return A||(A=!0,O=N.apply(D,arguments)),O}}e.$bb=j}),define(re[59],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var j;(function(N){function D(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}N.is=D;const A=Object.freeze([]);function O(){return A}N.empty=O;function*R(w){yield w}N.single=R;function S(w){return D(w)?w:R(w)}N.wrap=S;function $(w){return w||A}N.from=$;function C(w){return!w||w[Symbol.iterator]().next().done===!0}N.isEmpty=C;function p(w){return w[Symbol.iterator]().next().value}N.first=p;function g(w,I){for(const t of w)if(I(t))return!0;return!1}N.some=g;function u(w,I){for(const t of w)if(I(t))return t}N.find=u;function*d(w,I){for(const t of w)I(t)&&(yield t)}N.filter=d;function*y(w,I){let t=0;for(const c of w)yield I(c,t++)}N.map=y;function*f(...w){for(const I of w)for(const t of I)yield t}N.concat=f;function o(w,I,t){let c=t;for(const s of w)c=I(c,s);return c}N.reduce=o;function*h(w,I,t=w.length){for(I<0&&(I+=w.length),t<0?t+=w.length:t>w.length&&(t=w.length);I<t;I++)yield w[I]}N.slice=h;function b(w,I=Number.POSITIVE_INFINITY){const t=[];if(I===0)return[t,w];const c=w[Symbol.iterator]();for(let s=0;s<I;s++){const n=c.next();if(n.done)return[t,N.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return c}}]}N.consume=b})(j||(e.Iterable=j={}))}),define(re[34],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var j;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(j||(e.ScanError=j={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(t,c=!1){let s=0;const n=t.length;let i="",r=0,l=16,E=0;function m(B){let Q=0,J=0;for(;Q<B;){const x=t.charCodeAt(s);if(x>=48&&x<=57)J=J*16+x-48;else if(x>=65&&x<=70)J=J*16+x-65+10;else if(x>=97&&x<=102)J=J*16+x-97+10;else break;s++,Q++}return Q<B&&(J=-1),J}function a(B){s=B,i="",r=0,l=16,E=0}function v(){const B=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&$(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&$(t.charCodeAt(s)))for(s++;s<t.length&&$(t.charCodeAt(s));)s++;else return E=3,t.substring(B,s);let Q=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&$(t.charCodeAt(s))){for(s++;s<t.length&&$(t.charCodeAt(s));)s++;Q=s}else E=3;return t.substring(B,Q)}function L(){let B="",Q=s;for(;;){if(s>=n){B+=t.substring(Q,s),E=2;break}const J=t.charCodeAt(s);if(J===34){B+=t.substring(Q,s),s++;break}if(J===92){if(B+=t.substring(Q,s),s++,s>=n){E=2;break}switch(t.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const H=m(4);H>=0?B+=String.fromCharCode(H):E=4;break}default:E=5}Q=s;continue}if(J>=0&&J<=31)if(S(J)){B+=t.substring(Q,s),E=2;break}else E=6;s++}return B}function T(){if(i="",E=0,r=s,s>=n)return r=n,l=17;let B=t.charCodeAt(s);if(R(B)){do s++,i+=String.fromCharCode(B),B=t.charCodeAt(s);while(R(B));return l=15}if(S(B))return s++,i+=String.fromCharCode(B),B===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),l=14;switch(B){case 123:return s++,l=1;case 125:return s++,l=2;case 91:return s++,l=3;case 93:return s++,l=4;case 58:return s++,l=6;case 44:return s++,l=5;case 34:return s++,i=L(),l=10;case 47:{const Q=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!S(t.charCodeAt(s));)s++;return i=t.substring(Q,s),l=12}if(t.charCodeAt(s+1)===42){s+=2;const J=n-1;let x=!1;for(;s<J;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,x=!0;break}s++}return x||(s++,E=1),i=t.substring(Q,s),l=13}return i+=String.fromCharCode(B),s++,l=16}case 45:if(i+=String.fromCharCode(B),s++,s===n||!$(t.charCodeAt(s)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=v(),l=11;default:for(;s<n&&z(B);)s++,B=t.charCodeAt(s);if(r!==s){switch(i=t.substring(r,s),i){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return i+=String.fromCharCode(B),s++,l=16}}function z(B){if(R(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=T();while(B>=12&&B<=15);return B}return{setPosition:a,getPosition:()=>s,scan:c?U:T,getToken:()=>l,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>E}}e.$Im=O;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function p(t,c){const s=[],n=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function E(m,a,v,L){r.value=m,r.offset=a,r.length=v,r.type=L,r.colonOffset=void 0,i=r}try{b(t,{onObjectBegin:(m,a)=>{if(c<=m)throw n;i=void 0,l=c>m,s.push("")},onObjectProperty:(m,a,v)=>{if(c<a||(E(m,a,v,"property"),s[s.length-1]=m,c<=a+v))throw n},onObjectEnd:(m,a)=>{if(c<=m)throw n;i=void 0,s.pop()},onArrayBegin:(m,a)=>{if(c<=m)throw n;i=void 0,s.push(0)},onArrayEnd:(m,a)=>{if(c<=m)throw n;i=void 0,s.pop()},onLiteralValue:(m,a,v)=>{if(c<a||(E(m,a,v,I(m)),c<=a+v))throw n},onSeparator:(m,a,v)=>{if(c<=a)throw n;if(m===":"&&i&&i.type==="property")i.colonOffset=a,l=!1,i=void 0;else if(m===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(l=!0,s[s.length-1]=""),i=void 0}}})}catch(m){if(m!==n)throw m}return{path:s,previousNode:i,isAtPropertyKey:l,matches:m=>{let a=0;for(let v=0;a<m.length&&v<s.length;v++)if(m[a]===s[v]||m[a]==="*")a++;else if(m[a]!=="**")return!1;return a===m.length}}}e.$Jm=p;function g(t,c=[],s=A.DEFAULT){let n=null,i=[];const r=[];function l(m){Array.isArray(i)?i.push(m):n!==null&&(i[n]=m)}return b(t,{onObjectBegin:()=>{const m={};l(m),r.push(i),i=m,n=null},onObjectProperty:m=>{n=m},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const m=[];l(m),r.push(i),i=m,n=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:l,onError:(m,a,v)=>{c.push({error:m,offset:a,length:v})}},s),i[0]}e.$Km=g;function u(t,c=[],s=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(m){n.type==="property"&&(n.length=m-n.offset,n=n.parent)}function r(m){return n.children.push(m),m}b(t,{onObjectBegin:m=>{n=r({type:"object",offset:m,length:-1,parent:n,children:[]})},onObjectProperty:(m,a,v)=>{n=r({type:"property",offset:a,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:m,offset:a,length:v,parent:n})},onObjectEnd:(m,a)=>{n.length=m+a-n.offset,n=n.parent,i(m+a)},onArrayBegin:(m,a)=>{n=r({type:"array",offset:m,length:-1,parent:n,children:[]})},onArrayEnd:(m,a)=>{n.length=m+a-n.offset,n=n.parent,i(m+a)},onLiteralValue:(m,a,v)=>{r({type:I(m),offset:a,length:v,parent:n,value:m}),i(a+v)},onSeparator:(m,a,v)=>{n.type==="property"&&(m===":"?n.colonOffset=a:m===","&&i(a))},onError:(m,a,v)=>{c.push({error:m,offset:a,length:v})}},s);const E=n.children[0];return E&&delete E.parent,E}e.$Lm=u;function d(t,c){if(!t)return;let s=t;for(const n of c)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===n){s=r.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}e.$Mm=d;function y(t){if(!t.parent||!t.parent.children)return[];const c=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;c.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&c.push(s)}return c}e.$Nm=y;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const c=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(c[s.children[0].value]=f(n))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Om=f;function o(t,c,s=!1){return c>=t.offset&&c<t.offset+t.length||s&&c===t.offset+t.length}e.$Pm=o;function h(t,c,s=!1){if(o(t,c,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=c;i++){const r=h(n[i],c,s);if(r)return r}return t}}e.$Qm=h;function b(t,c,s=A.DEFAULT){const n=O(t,!1);function i(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(ne){return ne?se=>ne(se,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=i(c.onObjectBegin),E=r(c.onObjectProperty),m=i(c.onObjectEnd),a=i(c.onArrayBegin),v=i(c.onArrayEnd),L=r(c.onLiteralValue),T=r(c.onSeparator),z=i(c.onComment),U=r(c.onError),B=s&&s.disallowComments,Q=s&&s.allowTrailingComma;function J(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:B||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ne){case 12:case 13:B?x(10):z();break;case 16:x(1);break;case 15:case 14:break;default:return ne}}}function x(ne,se=[],Z=[]){if(U(ne),se.length+Z.length>0){let q=n.getToken();for(;q!==17;){if(se.indexOf(q)!==-1){J();break}else if(Z.indexOf(q)!==-1)break;q=J()}}}function H(ne){const se=n.getTokenValue();return ne?L(se):E(se),J(),!0}function X(){switch(n.getToken()){case 11:{let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(x(2),ne=0)}catch{x(2)}L(ne);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return J(),!0}function G(){return n.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),n.getToken()===6?(T(":"),J(),ee()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function W(){l(),J();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||x(4,[],[]),T(","),J(),n.getToken()===2&&Q)break}else ne&&x(6,[],[]);G()||x(4,[],[2,5]),ne=!0}return m(),n.getToken()!==2?x(7,[2],[]):J(),!0}function V(){a(),J();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||x(4,[],[]),T(","),J(),n.getToken()===4&&Q)break}else ne&&x(6,[],[]);ee()||x(4,[],[4,5]),ne=!0}return v(),n.getToken()!==4?x(8,[4],[]):J(),!0}function ee(){switch(n.getToken()){case 3:return V();case 1:return W();case 10:return H(!0);default:return X()}}return J(),n.getToken()===17?s.allowEmptyContent?!0:(x(4,[],[]),!1):ee()?(n.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$Rm=b;function w(t,c){const s=O(t),n=[];let i,r=0,l;do switch(l=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:r!==l&&n.push(t.substring(r,l)),c!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,c)),r=s.getPosition();break}while(i!==17);return n.join("")}e.$Sm=w;function I(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=I}),define(re[41],oe([0,1,34]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rS=e.$qS=e.$pS=e.$oS=void 0;function N($,C,p){let g,u,d,y,f;if(C){for(y=C.offset,f=y+C.length,d=y;d>0&&!S($,d-1);)d--;let l=f;for(;l<$.length&&!S($,l);)l++;u=$.substring(d,l),g=O(u,p)}else u=$,g=0,d=0,y=0,f=$.length;const o=R(p,$);let h=!1,b=0,w;p.insertSpaces?w=A(" ",p.tabSize||4):w="	";const I=(0,j.$Im)(u,!1);let t=!1;function c(){return o+A(w,g+b)}function s(){let l=I.scan();for(h=!1;l===15||l===14;)h=h||l===14,l=I.scan();return t=l===16||I.getTokenError()!==0,l}const n=[];function i(l,E,m){!t&&E<f&&m>y&&$.substring(E,m)!==l&&n.push({offset:E,length:m-E,content:l})}let r=s();if(r!==17){const l=I.getTokenOffset()+d,E=A(w,g);i(E,d,l)}for(;r!==17;){let l=I.getTokenOffset()+I.getTokenLength()+d,E=s(),m="";for(;!h&&(E===12||E===13);){const v=I.getTokenOffset()+d;i(" ",l,v),l=I.getTokenOffset()+I.getTokenLength()+d,m=E===12?c():"",E=s()}if(E===2)r!==1&&(b--,m=c());else if(E===4)r!==3&&(b--,m=c());else{switch(r){case 3:case 1:b++,m=c();break;case 5:case 12:m=c();break;case 13:h?m=c():m=" ";break;case 6:m=" ";break;case 10:if(E===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?m=" ":E!==5&&E!==17&&(t=!0);break;case 16:t=!0;break}h&&(E===12||E===13)&&(m=c())}const a=I.getTokenOffset()+d;i(m,l,a),r=E}return n}e.$oS=N;function D($,C){const p=JSON.stringify($,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?p.replace(/\r\n|\r|\n/g,C.eol):p}e.$pS=D;function A($,C){let p="";for(let g=0;g<C;g++)p+=$;return p}function O($,C){let p=0,g=0;const u=C.tabSize||4;for(;p<$.length;){const d=$.charAt(p);if(d===" ")g++;else if(d==="	")g+=u;else break;p++}return Math.floor(g/u)}function R($,C){for(let p=0;p<C.length;p++){const g=C.charAt(p);if(g==="\r")return p+1<C.length&&C.charAt(p+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return $&&$.eol||`
`}e.$qS=R;function S($,C){return`\r
`.indexOf($.charAt(C))!==-1}e.$rS=S}),define(re[85],oe([0,1,34,41]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wS=e.$vS=e.$uS=e.$tS=e.$sS=void 0;function D($,C,p){return A($,C,void 0,p)}e.$sS=D;function A($,C,p,g,u){const d=C.slice(),y=[],f=(0,j.$Lm)($,y);let o,h;for(;d.length>0&&(h=d.pop(),o=(0,j.$Mm)(f,d),o===void 0&&p!==void 0);)typeof h=="string"?p={[h]:p}:p=[p];if(o)if(o.type==="object"&&typeof h=="string"&&Array.isArray(o.children)){const b=(0,j.$Mm)(o,[h]);if(b!==void 0)if(p===void 0){if(!b.parent)throw new Error("Malformed AST");const w=o.children.indexOf(b.parent);let I,t=b.parent.offset+b.parent.length;if(w>0){const c=o.children[w-1];I=c.offset+c.length}else I=o.offset+1,o.children.length>1&&(t=o.children[1].offset);return O($,{offset:I,length:t-I,content:""},g)}else return O($,{offset:b.offset,length:b.length,content:JSON.stringify(p)},g);else{if(p===void 0)return[];const w=`${JSON.stringify(h)}: ${JSON.stringify(p)}`,I=u?u(o.children.map(c=>c.children[0].value)):o.children.length;let t;if(I>0){const c=o.children[I-1];t={offset:c.offset+c.length,length:0,content:","+w}}else o.children.length===0?t={offset:o.offset+1,length:0,content:w}:t={offset:o.offset+1,length:0,content:w+","};return O($,t,g)}}else if(o.type==="array"&&typeof h=="number"&&Array.isArray(o.children))if(p!==void 0){const b=`${JSON.stringify(p)}`;let w;if(o.children.length===0||h===0)w={offset:o.offset+1,length:0,content:o.children.length===0?b:b+","};else{const I=h===-1||h>o.children.length?o.children.length:h,t=o.children[I-1];w={offset:t.offset+t.length,length:0,content:","+b}}return O($,w,g)}else{const b=h,w=o.children[b];let I;if(o.children.length===1)I={offset:o.offset+1,length:o.length-2,content:""};else if(o.children.length-1===b){const t=o.children[b-1],c=t.offset+t.length,s=o.offset+o.length;I={offset:c,length:s-2-c,content:""}}else I={offset:w.offset,length:o.children[b+1].offset-w.offset,content:""};return O($,I,g)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${o.type}`);else{if(p===void 0)throw new Error("Can not delete in empty document");return O($,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(p)},g)}}e.$tS=A;function O($,C,p){let g=R($,C),u=C.offset,d=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;u>0&&!(0,N.$rS)(g,u-1);)u--;for(;d<g.length&&!(0,N.$rS)(g,d);)d++}const y=(0,N.$oS)(g,{offset:u,length:d-u},p);for(let o=y.length-1;o>=0;o--){const h=y[o];g=R(g,h),u=Math.min(u,h.offset),d=Math.max(d,h.offset+h.length),d+=h.content.length-h.length}const f=$.length-(g.length-d)-u;return[{offset:u,length:f,content:g.substring(u,d)}]}e.$uS=O;function R($,C){return $.substring(0,C.offset)+C.content+$.substring(C.offset+C.length)}e.$vS=R;function S($,C){const p=C.slice(0).sort((u,d)=>{const y=u.offset-d.offset;return y===0?u.length-d.length:y});let g=$.length;for(let u=p.length-1;u>=0;u--){const d=p[u];if(d.offset+d.length<=g)$=R($,d);else throw new Error("Overlapping edit");g=d.offset}return $}e.$wS=S}),define(re[86],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class j{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=j}),define(re[2],oe([0,1,18,126,84,59]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=void 0;const O=!1;let R=null;class S{constructor(){this.b=new Map}static{this.a=0}c(a){let v=this.b.get(a);return v||(v={parent:null,source:null,isSingleton:!1,value:a,idx:S.a++},this.b.set(a,v)),v}trackDisposable(a){const v=this.c(a);v.source||(v.source=new Error().stack)}setParent(a,v){const L=this.c(a);L.parent=v}markAsDisposed(a){this.b.delete(a)}markAsSingleton(a){this.c(a).isSingleton=!0}f(a,v){const L=v.get(a);if(L)return L;const T=a.parent?this.f(this.c(a.parent),v):a;return v.set(a,T),T}getTrackedDisposables(){const a=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,a).isSingleton).map(([L])=>L).flat()}computeLeakingDisposables(a=10,v){let L;if(v)L=v;else{const Q=new Map,J=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,Q).isSingleton);if(J.length===0)return;const x=new Set(J.map(H=>H.value));if(L=J.filter(H=>!(H.parent&&x.has(H.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function T(Q){function J(H,X){for(;H.length>0&&X.some(G=>typeof G=="string"?G===H[0]:H[0].match(G));)H.shift()}const x=Q.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return J(x,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),x.reverse()}const z=new N.$L;for(const Q of L){const J=T(Q);for(let x=0;x<=J.length;x++)z.add(J.slice(0,x).join(`
`),Q)}L.sort((0,j.$4b)(Q=>Q.idx,j.$6b));let U="",B=0;for(const Q of L.slice(0,a)){B++;const J=T(Q),x=[];for(let H=0;H<J.length;H++){let X=J[H];X=`(shared with ${z.get(J.slice(0,H+1).join(`
`)).size}/${L.length} leaks) at ${X}`;const W=z.get(J.slice(0,H).join(`
`)),V=(0,N.$I)([...W].map(ee=>T(ee)[H]),ee=>ee);delete V[J[H]];for(const[ee,ne]of Object.entries(V))x.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${ee}`);x.unshift(X)}U+=`


==================== Leaking disposable ${B}/${L.length}: ${Q.value.constructor.name} ====================
${x.join(`
`)}
============================================================

`}return L.length>a&&(U+=`


... and ${L.length-a} more leaking disposables

`),{leaks:L,details:U}}}e.$$b=S;function $(m){R=m}if(e.$_b=$,O){const m="__is_disposable_tracked__";$(new class{trackDisposable(a){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[m]||console.log(v)},3e3)}setParent(a,v){if(a&&a!==I.None)try{a[m]=!0}catch{}}markAsDisposed(a){if(a&&a!==I.None)try{a[m]=!0}catch{}}markAsSingleton(a){}})}function C(m){return R?.trackDisposable(m),m}e.$ac=C;function p(m){R?.markAsDisposed(m)}e.$bc=p;function g(m,a){R?.setParent(m,a)}function u(m,a){if(R)for(const v of m)R.setParent(v,a)}function d(m){return R?.markAsSingleton(m),m}e.$cc=d;function y(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.$dc=y;function f(m){if(A.Iterable.is(m)){const a=[];for(const v of m)if(v)try{v.dispose()}catch(L){a.push(L)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.$ec=f;function o(m){for(const a of m)y(a)&&a.dispose();return[]}e.$fc=o;function h(...m){const a=b(()=>f(m));return u(m,a),a}e.$gc=h;function b(m){const a=C({dispose:(0,D.$bb)(()=>{p(a),m()})});return a}e.$hc=b;class w{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return g(a,this),this.g?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(a),a}}e.$ic=w;class I{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new w,C(this),g(this.q,this)}dispose(){p(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.$jc=I;class t{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&g(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&g(a,null),a}}e.$kc=t;class c{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$lc=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(a){let v=a;return this.unset=()=>v=void 0,this.isset=()=>v!==void 0,this.dispose=()=>{v&&(v(),v=void 0,p(this))},this}}e.$mc=s;class n{constructor(){this.a=new Map}acquire(a,...v){let L=this.a.get(a);L||(L={counter:0,object:this.b(a,...v)},this.a.set(a,L));const{object:T}=L,z=(0,D.$bb)(()=>{--L.counter===0&&(this.c(a,L.object),this.a.delete(a))});return L.counter++,{object:T,dispose:z}}}e.$nc=n;class i{constructor(a){this.a=a}async acquire(a,...v){const L=this.a.acquire(a,...v);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(T){throw L.dispose(),T}}}e.$oc=i;class r{constructor(a){this.object=a}dispose(){}}e.$pc=r;function l(m){const a=new w;try{m(a)}finally{a.dispose()}}e.$qc=l;class E{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get size(){return this.a.size}get(a){return this.a.get(a)}set(a,v,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(a)?.dispose(),this.a.set(a,v)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$rc=E}),define(re[87],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=void 0;class j{static{this.Undefined=new j(void 0)}constructor(A){this.element=A,this.next=j.Undefined,this.prev=j.Undefined}}class N{constructor(){this.a=j.Undefined,this.b=j.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===j.Undefined}clear(){let A=this.a;for(;A!==j.Undefined;){const O=A.next;A.prev=j.Undefined,A.next=j.Undefined,A=O}this.a=j.Undefined,this.b=j.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const R=new j(A);if(this.a===j.Undefined)this.a=R,this.b=R;else if(O){const $=this.b;this.b=R,R.prev=$,$.next=R}else{const $=this.a;this.a=R,R.next=$,$.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==j.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==j.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==j.Undefined&&A.next!==j.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===j.Undefined&&A.next===j.Undefined?(this.a=j.Undefined,this.b=j.Undefined):A.next===j.Undefined?(this.b=this.b.prev,this.b.next=j.Undefined):A.prev===j.Undefined&&(this.a=this.a.next,this.a.prev=j.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==j.Undefined;)yield A.element,A=A.next}}e.$sc=N}),define(re[35],oe([0,1]),function(te,e){"use strict";var j,N,D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.Touch=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;function A(f,o,h){let b=f.get(o);return b===void 0&&(b=h,f.set(o,b)),b}e.$vi=A;function O(f){const o=[];return f.forEach((h,b)=>{o.push(`${b} => ${h}`)}),`Map(${f.size}) {${o.join(", ")}}`}e.$wi=O;function R(f){const o=[];return f.forEach(h=>{o.push(h)}),`Set(${f.size}) {${o.join(", ")}}`}e.$xi=R;class S{constructor(o,h){this.uri=o,this.value=h}}class ${static{this.a=o=>o.toString()}constructor(o,h){this[j]="ResourceMap",o instanceof $?(this.b=new Map(o.b),this.c=h??$.a):(this.b=new Map,this.c=o??$.a)}set(o,h){return this.b.set(this.c(o),new S(o,h)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,h){typeof h<"u"&&(o=o.bind(h));for(const[b,w]of this.b)o(w.value,w.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(j=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$yi=$;class C{constructor(o,h){this[N]="ResourceSet",!o||typeof o=="function"?this.a=new $(o):(this.a=new $(h),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,h){this.a.forEach((b,w)=>o.call(h,w,w,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zi=C;var p;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class g{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,h=0){const b=this.a.get(o);if(b)return h!==0&&this.j(b,h),b.value}set(o,h,b=0){let w=this.a.get(o);if(w)w.value=h,b!==0&&this.j(w,b);else{switch(w={key:o,value:h,next:void 0,previous:void 0},b){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(o,w),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const h=this.a.get(o);if(h)return this.a.delete(o),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,h){const b=this.e;let w=this.b;for(;w;){if(h?o.bind(h)(w.value,w.key,this):o(w.value,w.key,this),this.e!==b)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const o=this,h=this.e;let b=this.b;const w={[Symbol.iterator](){return w},next(){if(o.e!==h)throw new Error("LinkedMap got modified during iteration.");if(b){const I={value:b.key,done:!1};return b=b.next,I}else return{value:void 0,done:!0}}};return w}values(){const o=this,h=this.e;let b=this.b;const w={[Symbol.iterator](){return w},next(){if(o.e!==h)throw new Error("LinkedMap got modified during iteration.");if(b){const I={value:b.value,done:!1};return b=b.next,I}else return{value:void 0,done:!0}}};return w}entries(){const o=this,h=this.e;let b=this.b;const w={[Symbol.iterator](){return w},next(){if(o.e!==h)throw new Error("LinkedMap got modified during iteration.");if(b){const I={value:[b.key,b.value],done:!1};return b=b.next,I}else return{value:void 0,done:!0}}};return w}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let h=this.b,b=this.size;for(;h&&b>o;)this.a.delete(h.key),h=h.next,b--;this.b=h,this.d=b,h&&(h.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const h=o.next,b=o.previous;if(!h||!b)throw new Error("Invalid list");h.previous=b,b.next=h}o.next=void 0,o.previous=void 0,this.e++}j(o,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(o===this.b)return;const b=o.next,w=o.previous;o===this.c?(w.next=void 0,this.c=w):(b.previous=w,w.next=b),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(h===2){if(o===this.c)return;const b=o.next,w=o.previous;o===this.b?(b.previous=void 0,this.b=b):(b.previous=w,w.next=b),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((h,b)=>{o.push([b,h])}),o}fromJSON(o){this.clear();for(const[h,b]of o)this.set(h,b)}}e.$Ai=g;class u extends g{constructor(o,h=1){super(),this.k=o,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,h=2){return super.get(o,h)}peek(o){return super.get(o,0)}set(o,h){return super.set(o,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bi=u;class d{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let h=this.a.get(o)||0;return h===0?!1:(h--,h===0?this.a.delete(o):this.a.set(o,h),!0)}has(o){return this.a.has(o)}}e.$Ci=d;class y{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[h,b]of o)this.set(h,b)}clear(){this.a.clear(),this.b.clear()}set(o,h){this.a.set(o,h),this.b.set(h,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const h=this.a.get(o);return h===void 0?!1:(this.a.delete(o),this.b.delete(h),!0)}forEach(o,h){this.a.forEach((b,w)=>{o.call(h,b,w,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Di=y}),define(re[88],oe([0,1,35]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=e.$gl=void 0;const N=new j.$Bi(1e4);function D($){return S($,"NFC",N)}e.$gl=D;const A=new j.$Bi(1e4);function O($){return S($,"NFD",A)}e.$hl=O;const R=/[^\u0000-\u0080]/;function S($,C,p){if(!$)return $;const g=p.get($);if(g)return g;let u;return R.test($)?u=$.normalize(C):u=$,p.set($,u),u}e.$il=function(){const $=/[\u0300-\u036f]/g;return function(C){return O(C).replace($,"")}}()}),function(){function te(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function O(S){A.push(S,Date.now())}function R(){const S=[];for(let $=0;$<A.length;$+=2)S.push({name:A[$],startTime:A[$+1]});return S}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(D+O.startTime)});return A}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function j(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return j(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=j(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var j=e();for(var N in j)(typeof exports=="object"?exports:te)[N]=j[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function j(N){if(e[N])return e[N].exports;var D=e[N]={i:N,l:!1,exports:{}};return te[N].call(D.exports,D,D.exports,j),D.l=!0,D.exports}return j.m=te,j.c=e,j.d=function(N,D,A){j.o(N,D)||Object.defineProperty(N,D,{enumerable:!0,get:A})},j.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},j.t=function(N,D){if(1&D&&(N=j(N)),8&D||4&D&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(j.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&D&&typeof N!="string")for(var O in N)j.d(A,O,function(R){return N[R]}.bind(null,O));return A},j.n=function(N){var D=N&&N.__esModule?function(){return N.default}:function(){return N};return j.d(D,"a",D),D},j.o=function(N,D){return Object.prototype.hasOwnProperty.call(N,D)},j.p="",j(j.s=0)}([function(te,e,j){(function(N){var D;e=te.exports=Z,D=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],$=0,C=$++;S[C]="0|[1-9]\\d*";var p=$++;S[p]="[0-9]+";var g=$++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=$++;S[u]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var d=$++;S[d]="("+S[p]+")\\.("+S[p]+")\\.("+S[p]+")";var y=$++;S[y]="(?:"+S[C]+"|"+S[g]+")";var f=$++;S[f]="(?:"+S[p]+"|"+S[g]+")";var o=$++;S[o]="(?:-("+S[y]+"(?:\\."+S[y]+")*))";var h=$++;S[h]="(?:-?("+S[f]+"(?:\\."+S[f]+")*))";var b=$++;S[b]="[0-9A-Za-z-]+";var w=$++;S[w]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var I=$++,t="v?"+S[u]+S[o]+"?"+S[w]+"?";S[I]="^"+t+"$";var c="[v=\\s]*"+S[d]+S[h]+"?"+S[w]+"?",s=$++;S[s]="^"+c+"$";var n=$++;S[n]="((?:<|>)?=?)";var i=$++;S[i]=S[p]+"|x|X|\\*";var r=$++;S[r]=S[C]+"|x|X|\\*";var l=$++;S[l]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[o]+")?"+S[w]+"?)?)?";var E=$++;S[E]="[v=\\s]*("+S[i]+")(?:\\.("+S[i]+")(?:\\.("+S[i]+")(?:"+S[h]+")?"+S[w]+"?)?)?";var m=$++;S[m]="^"+S[n]+"\\s*"+S[l]+"$";var a=$++;S[a]="^"+S[n]+"\\s*"+S[E]+"$";var v=$++;S[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=$++;S[L]="(?:~>?)";var T=$++;S[T]="(\\s*)"+S[L]+"\\s+",R[T]=new RegExp(S[T],"g");var z=$++;S[z]="^"+S[L]+S[l]+"$";var U=$++;S[U]="^"+S[L]+S[E]+"$";var B=$++;S[B]="(?:\\^)";var Q=$++;S[Q]="(\\s*)"+S[B]+"\\s+",R[Q]=new RegExp(S[Q],"g");var J=$++;S[J]="^"+S[B]+S[l]+"$";var x=$++;S[x]="^"+S[B]+S[E]+"$";var H=$++;S[H]="^"+S[n]+"\\s*("+c+")$|^$";var X=$++;S[X]="^"+S[n]+"\\s*("+t+")$|^$";var G=$++;S[G]="(\\s*)"+S[n]+"\\s*("+c+"|"+S[l]+")",R[G]=new RegExp(S[G],"g");var W=$++;S[W]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var V=$++;S[V]="^\\s*("+S[E]+")\\s+-\\s+("+S[E]+")\\s*$";var ee=$++;S[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)D(ne,S[ne]),R[ne]||(R[ne]=new RegExp(S[ne]));function se(ce,ge){if(ce instanceof Z)return ce;if(typeof ce!="string"||ce.length>A||!(ge?R[s]:R[I]).test(ce))return null;try{return new Z(ce,ge)}catch{return null}}function Z(ce,ge){if(ce instanceof Z){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Z))return new Z(ce,ge);D("SemVer",ce,ge),this.loose=ge;var be=ce.trim().match(ge?R[s]:R[I]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Pe=+ke;if(Pe>=0&&Pe<O)return Pe}return ke}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=se,e.valid=function(ce,ge){var be=se(ce,ge);return be?be.version:null},e.clean=function(ce,ge){var be=se(ce.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof Z||(ce=new Z(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Z.prototype.compareMain=function(ce){return ce instanceof Z||(ce=new Z(ce,this.loose)),k(this.major,ce.major)||k(this.minor,ce.minor)||k(this.patch,ce.patch)},Z.prototype.comparePre=function(ce){if(ce instanceof Z||(ce=new Z(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],ke=ce.prerelease[ge];if(D("prerelease compare",ge,be,ke),be===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(be===void 0)return-1;if(be!==ke)return k(be,ke)}while(++ge)},Z.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,be,ke){typeof be=="string"&&(ke=be,be=void 0);try{return new Z(ce,be).inc(ge,ke).version}catch{return null}},e.diff=function(ce,ge){if(K(ce,ge))return null;var be=se(ce),ke=se(ge);if(be.prerelease.length||ke.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return Pe},e.compareIdentifiers=k;var q=/^[0-9]+$/;function k(ce,ge){var be=q.test(ce),ke=q.test(ge);return be&&ke&&(ce=+ce,ge=+ge),be&&!ke?-1:ke&&!be?1:ce<ge?-1:ce>ge?1:0}function P(ce,ge,be){return new Z(ce,be).compare(new Z(ge,be))}function F(ce,ge,be){return P(ce,ge,be)>0}function M(ce,ge,be){return P(ce,ge,be)<0}function K(ce,ge,be){return P(ce,ge,be)===0}function _(ce,ge,be){return P(ce,ge,be)!==0}function ae(ce,ge,be){return P(ce,ge,be)>=0}function he(ce,ge,be){return P(ce,ge,be)<=0}function fe(ce,ge,be,ke){var Pe;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce!==be;break;case"":case"=":case"==":Pe=K(ce,be,ke);break;case"!=":Pe=_(ce,be,ke);break;case">":Pe=F(ce,be,ke);break;case">=":Pe=ae(ce,be,ke);break;case"<":Pe=M(ce,be,ke);break;case"<=":Pe=he(ce,be,ke);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function le(ce,ge){if(ce instanceof le){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof le))return new le(ce,ge);D("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,ge){return k(ge,ce)},e.major=function(ce,ge){return new Z(ce,ge).major},e.minor=function(ce,ge){return new Z(ce,ge).minor},e.patch=function(ce,ge){return new Z(ce,ge).patch},e.compare=P,e.compareLoose=function(ce,ge){return P(ce,ge,!0)},e.rcompare=function(ce,ge,be){return P(ge,ce,be)},e.sort=function(ce,ge){return ce.sort(function(be,ke){return e.compare(be,ke,ge)})},e.rsort=function(ce,ge){return ce.sort(function(be,ke){return e.rcompare(be,ke,ge)})},e.gt=F,e.lt=M,e.eq=K,e.neq=_,e.gte=ae,e.lte=he,e.cmp=fe,e.Comparator=le;var $e={};function de(ce,ge){if(ce instanceof de)return ce.loose===ge?ce:new de(ce.raw,ge);if(ce instanceof le)return new de(ce.value,ge);if(!(this instanceof de))return new de(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function we(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ee(ce,ge,be,ke,Pe,ze,Oe,Ue,Te,ie,ue,me,pe){return((ge=we(be)?"":we(ke)?">="+be+".0.0":we(Pe)?">="+be+"."+ke+".0":">="+ge)+" "+(Ue=we(Te)?"":we(ie)?"<"+(+Te+1)+".0.0":we(ue)?"<"+Te+"."+(+ie+1)+".0":me?"<="+Te+"."+ie+"."+ue+"-"+me:"<="+Ue)).trim()}function je(ce,ge){for(var be=0;be<ce.length;be++)if(!ce[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ce.length;be++)if(D(ce[be].semver),ce[be].semver!==$e&&ce[be].semver.prerelease.length>0){var ke=ce[be].semver;if(ke.major===ge.major&&ke.minor===ge.minor&&ke.patch===ge.patch)return!0}return!1}return!0}function Le(ce,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ce)}function Me(ce,ge,be,ke){var Pe,ze,Oe,Ue,Te;switch(ce=new Z(ce,ke),ge=new de(ge,ke),be){case">":Pe=F,ze=he,Oe=M,Ue=">",Te=">=";break;case"<":Pe=M,ze=ae,Oe=F,Ue="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(ce,ge,ke))return!1;for(var ie=0;ie<ge.set.length;++ie){var ue=ge.set[ie],me=null,pe=null;if(ue.forEach(function(Se){Se.semver===$e&&(Se=new le(">=0.0.0")),me=me||Se,pe=pe||Se,Pe(Se.semver,me.semver,ke)?me=Se:Oe(Se.semver,pe.semver,ke)&&(pe=Se)}),me.operator===Ue||me.operator===Te||(!pe.operator||pe.operator===Ue)&&ze(ce,pe.semver)||pe.operator===Te&&Oe(ce,pe.semver))return!1}return!0}le.prototype.parse=function(ce){var ge=this.loose?R[H]:R[X],be=ce.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Z(be[2],this.loose):this.semver=$e},le.prototype.toString=function(){return this.value},le.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===$e||(typeof ce=="string"&&(ce=new Z(ce,this.loose)),fe(ce,this.operator,this.semver,this.loose))},le.prototype.intersects=function(ce,ge){if(!(ce instanceof le))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ce.value,ge),Le(this.value,be,ge);if(ce.operator==="")return be=new de(this.value,ge),Le(ce.semver,be,ge);var ke=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),ze=this.semver.version===ce.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ue=fe(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Te=fe(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return ke||Pe||ze&&Oe||Ue||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),D("range",ce,ge);var be=ge?R[V]:R[W];ce=ce.replace(be,Ee),D("hyphen replace",ce),ce=ce.replace(R[G],"$1$2$3"),D("comparator trim",ce,R[G]),ce=(ce=(ce=ce.replace(R[T],"$1~")).replace(R[Q],"$1^")).split(/\s+/).join(" ");var ke=ge?R[H]:R[X],Pe=ce.split(" ").map(function(ze){return function(Oe,Ue){return D("comp",Oe),Oe=function(Te,ie){return Te.trim().split(/\s+/).map(function(ue){return function(me,pe){D("caret",me,pe);var Se=pe?R[x]:R[J];return me.replace(Se,function(Re,Ce,Ie,De,Ae){var Ne;return D("caret",me,Re,Ce,Ie,De,Ae),we(Ce)?Ne="":we(Ie)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(De)?Ne=Ce==="0"?">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+".0 <"+(+Ce+1)+".0.0":Ae?(D("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ne=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+Ie+"."+(+De+1):">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+De+Ae+" <"+(+Ce+1)+".0.0"):(D("no pr"),Ne=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+Ie+"."+(+De+1):">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+De+" <"+(+Ce+1)+".0.0"),D("caret return",Ne),Ne})}(ue,ie)}).join(" ")}(Oe,Ue),D("caret",Oe),Oe=function(Te,ie){return Te.trim().split(/\s+/).map(function(ue){return function(me,pe){var Se=pe?R[U]:R[z];return me.replace(Se,function(Re,Ce,Ie,De,Ae){var Ne;return D("tilde",me,Re,Ce,Ie,De,Ae),we(Ce)?Ne="":we(Ie)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(De)?Ne=">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":Ae?(D("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ne=">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+(+Ie+1)+".0"):Ne=">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+(+Ie+1)+".0",D("tilde return",Ne),Ne})}(ue,ie)}).join(" ")}(Oe,Ue),D("tildes",Oe),Oe=function(Te,ie){return D("replaceXRanges",Te,ie),Te.split(/\s+/).map(function(ue){return function(me,pe){me=me.trim();var Se=pe?R[a]:R[m];return me.replace(Se,function(Re,Ce,Ie,De,Ae,Ne){D("xRange",me,Re,Ce,Ie,De,Ae,Ne);var Be=we(Ie),qe=Be||we(De),Ve=qe||we(Ae);return Ce==="="&&Ve&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(qe&&(De=0),Ve&&(Ae=0),Ce===">"?(Ce=">=",qe?(Ie=+Ie+1,De=0,Ae=0):Ve&&(De=+De+1,Ae=0)):Ce==="<="&&(Ce="<",qe?Ie=+Ie+1:De=+De+1),Re=Ce+Ie+"."+De+"."+Ae):qe?Re=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Ve&&(Re=">="+Ie+"."+De+".0 <"+Ie+"."+(+De+1)+".0"),D("xRange return",Re),Re})}(ue,ie)}).join(" ")}(Oe,Ue),D("xrange",Oe),Oe=function(Te,ie){return D("replaceStars",Te,ie),Te.trim().replace(R[ee],"")}(Oe,Ue),D("stars",Oe),Oe}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(ke)})),Pe=Pe.map(function(ze){return new le(ze,ge)})},de.prototype.intersects=function(ce,ge){if(!(ce instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ke){return ce.set.some(function(Pe){return Pe.every(function(ze){return ke.intersects(ze,ge)})})})})},e.toComparators=function(ce,ge){return new de(ce,ge).set.map(function(be){return be.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Z(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(je(this.set[ge],ce))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(ce,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(Oe){ze.test(Oe)&&(ke&&Pe.compare(Oe)!==-1||(Pe=new Z(ke=Oe,be)))}),ke},e.minSatisfying=function(ce,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(Oe){ze.test(Oe)&&(ke&&Pe.compare(Oe)!==1||(Pe=new Z(ke=Oe,be)))}),ke},e.validRange=function(ce,ge){try{return new de(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,be){return Me(ce,ge,"<",be)},e.gtr=function(ce,ge,be){return Me(ce,ge,">",be)},e.outside=Me,e.prerelease=function(ce,ge){var be=se(ce,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,ge,be){return ce=new de(ce,be),ge=new de(ge,be),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof Z)return ce;if(typeof ce!="string")return null;var ge=ce.match(R[v]);return ge==null?null:se((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,j(1))},function(te,e){var j,N,D=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(f){if(j===setTimeout)return setTimeout(f,0);if((j===A||!j)&&setTimeout)return j=setTimeout,setTimeout(f,0);try{return j(f,0)}catch{try{return j.call(null,f,0)}catch{return j.call(this,f,0)}}}(function(){try{j=typeof setTimeout=="function"?setTimeout:A}catch{j=A}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var S,$=[],C=!1,p=-1;function g(){C&&S&&(C=!1,S.length?$=S.concat($):p=-1,$.length&&u())}function u(){if(!C){var f=R(g);C=!0;for(var o=$.length;o;){for(S=$,$=[];++p<o;)S&&S[p].run();p=-1,o=$.length}S=null,C=!1,function(h){if(N===clearTimeout)return clearTimeout(h);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(h);try{N(h)}catch{try{return N.call(null,h)}catch{return N.call(this,h)}}}(f)}}function d(f,o){this.fun=f,this.array=o}function y(){}D.nextTick=function(f){var o=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)o[h-1]=arguments[h];$.push(new d(f,o)),$.length!==1||C||R(u)},d.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(re[128],oe([0,1]),function(te,e){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class N{constructor(R,S,$){this.level=R,this.key=S,this.value=$,this.forward=[]}}const D=void 0;class A{constructor(R,S=2**16){this.comparator=R,this[j]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new N(this.c,D,D)}get size(){return this.f}clear(){this.e=new N(this.c,D,D)}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,S){return A.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=A.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let $=this.e.forward[0];for(;$;)R.call(S,$.value,$.key,this),$=$.forward[0]}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,$){let C=R.e;for(let p=R.d-1;p>=0;p--)for(;C.forward[p]&&$(C.forward[p].key,S)<0;)C=C.forward[p];if(C=C.forward[0],C&&$(C.key,S)===0)return C}static h(R,S,$,C){const p=[];let g=R.e;for(let u=R.d-1;u>=0;u--){for(;g.forward[u]&&C(g.forward[u].key,S)<0;)g=g.forward[u];p[u]=g}if(g=g.forward[0],g&&C(g.key,S)===0)return g.value=$,!1;{const u=A.j(R);if(u>R.d){for(let d=R.d;d<u;d++)p[d]=R.e;R.d=u}g=new N(u,S,$);for(let d=0;d<u;d++)g.forward[d]=p[d].forward[d],p[d].forward[d]=g;return!0}}static j(R,S=.5){let $=1;for(;Math.random()<S&&$<R.c;)$+=1;return $}static k(R,S,$){const C=[];let p=R.e;for(let g=R.d-1;g>=0;g--){for(;p.forward[g]&&$(p.forward[g].key,S)<0;)p=p.forward[g];C[g]=p}if(p=p.forward[0],!p||$(p.key,S)!==0)return!1;for(let g=0;g<R.d&&C[g].forward[g]===p;g++)C[g].forward[g]=p.forward[g];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.$mr=A}),define(re[60],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0;const j=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=j&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ad=N}),define(re[3],oe([0,1,8,84,2,87,60]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.Event=void 0;const R=!1,S=!1;var $;(function(m){m.None=()=>D.$jc.None;function a(fe){if(S){const{onDidAddListener:le}=fe,$e=d.create();let de=0;fe.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function v(fe,le){return X(fe,()=>{},0,void 0,!0,void 0,le)}m.defer=v;function L(fe){return(le,$e=null,de)=>{let we=!1,Ee;return Ee=fe(je=>{if(!we)return Ee?Ee.dispose():we=!0,le.call($e,je)},null,de),we&&Ee.dispose(),Ee}}m.once=L;function T(fe,le,$e){return x((de,we=null,Ee)=>fe(je=>de.call(we,le(je)),null,Ee),$e)}m.map=T;function z(fe,le,$e){return x((de,we=null,Ee)=>fe(je=>{le(je),de.call(we,je)},null,Ee),$e)}m.forEach=z;function U(fe,le,$e){return x((de,we=null,Ee)=>fe(je=>le(je)&&de.call(we,je),null,Ee),$e)}m.filter=U;function B(fe){return fe}m.signal=B;function Q(...fe){return(le,$e=null,de)=>{const we=(0,D.$gc)(...fe.map(Ee=>Ee(je=>le.call($e,je))));return H(we,de)}}m.any=Q;function J(fe,le,$e,de){let we=$e;return T(fe,Ee=>(we=le(we,Ee),we),de)}m.reduce=J;function x(fe,le){let $e;const de={onWillAddFirstListener(){$e=fe(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};le||a(de);const we=new b(de);return le?.add(we),we.event}function H(fe,le){return le instanceof Array?le.push(fe):le&&le.add(fe),fe}function X(fe,le,$e=100,de=!1,we=!1,Ee,je){let Le,Me,ce,ge=0,be;const ke={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=fe(ze=>{ge++,Me=le(Me,ze),de&&!ce&&(Pe.fire(Me),Me=void 0),be=()=>{const Oe=Me;Me=void 0,ce=void 0,(!de||ge>1)&&Pe.fire(Oe),ge=0},typeof $e=="number"?(clearTimeout(ce),ce=setTimeout(be,$e)):ce===void 0&&(ce=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Le.dispose()}};je||a(ke);const Pe=new b(ke);return je?.add(Pe),Pe.event}m.debounce=X;function G(fe,le=0,$e){return m.debounce(fe,(de,we)=>de?(de.push(we),de):[we],le,void 0,!0,void 0,$e)}m.accumulate=G;function W(fe,le=(de,we)=>de===we,$e){let de=!0,we;return U(fe,Ee=>{const je=de||!le(Ee,we);return de=!1,we=Ee,je},$e)}m.latch=W;function V(fe,le,$e){return[m.filter(fe,le,$e),m.filter(fe,de=>!le(de),$e)]}m.split=V;function ee(fe,le=!1,$e=[],de){let we=$e.slice(),Ee=fe(Me=>{we?we.push(Me):Le.fire(Me)});de&&de.add(Ee);const je=()=>{we?.forEach(Me=>Le.fire(Me)),we=null},Le=new b({onWillAddFirstListener(){Ee||(Ee=fe(Me=>Le.fire(Me)),de&&de.add(Ee))},onDidAddFirstListener(){we&&(le?setTimeout(je):je())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Le),Le.event}m.buffer=ee;function ne(fe,le){return(de,we,Ee)=>{const je=le(new Z);return fe(function(Le){const Me=je.evaluate(Le);Me!==se&&de.call(we,Me)},void 0,Ee)}}m.chain=ne;const se=Symbol("HaltChainable");class Z{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:se),this}reduce(le,$e){let de=$e;return this.f.push(we=>(de=le(de,we),de)),this}latch(le=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const Ee=$e||!le(we,de);return $e=!1,de=we,Ee?we:se}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===se)break;return le}}function q(fe,le,$e=de=>de){const de=(...Le)=>je.fire($e(...Le)),we=()=>fe.on(le,de),Ee=()=>fe.removeListener(le,de),je=new b({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return je.event}m.fromNodeEventEmitter=q;function k(fe,le,$e=de=>de){const de=(...Le)=>je.fire($e(...Le)),we=()=>fe.addEventListener(le,de),Ee=()=>fe.removeEventListener(le,de),je=new b({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return je.event}m.fromDOMEventEmitter=k;function P(fe){return new Promise(le=>L(fe)(le))}m.toPromise=P;function F(fe){const le=new b;return fe.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}m.fromPromise=F;function M(fe,le){return le(void 0),fe($e=>le($e))}m.runAndSubscribe=M;function K(fe,le){let $e=null;function de(Ee){$e?.dispose(),$e=new D.$ic,le(Ee,$e)}de(void 0);const we=fe(Ee=>de(Ee));return(0,D.$hc)(()=>{we.dispose(),$e?.dispose()})}m.runAndSubscribeWithStore=K;class _{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||a(de),this.emitter=new b(de),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ae(fe,le){return new _(fe,le).emitter.event}m.fromObservable=ae;function he(fe){return le=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(fe.reportChanges(),de&&(de=!1,le()))},handlePossibleChange(){},handleChange(){de=!0}};return fe.addObserver(we),fe.reportChanges(),{dispose(){fe.removeObserver(we)}}}}m.fromObservableLight=he})($||(e.Event=$={}));class C{static{this.all=new Set}static{this.f=0}constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C.f++}`,C.all.add(this)}start(a){this.g=new O.$ad,this.listenerCount=a}stop(){if(this.g){const a=this.g.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.g=void 0}}}e.$cd=C;let p=-1;function g(m){const a=p;return p=m,{dispose(){p=a}}}e.$dd=g;class u{constructor(a,v=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=v,this.g=0}dispose(){this.f?.clear()}check(a,v){const L=this.threshold;if(L<=0||v<L)return;this.f||(this.f=new Map);const T=this.f.get(a.value)||0;if(this.f.set(a.value,T+1),this.g-=1,this.g<=0){this.g=L*.5;let z,U=0;for(const[B,Q]of this.f)(!z||U<Q)&&(z=B,U=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${U}):`),console.warn(z)}return()=>{const z=this.f.get(a.value)||0;this.f.set(a.value,z-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class f{constructor(a){this.value=a,this.id=y++}}const o=2,h=(m,a)=>{if(m instanceof f)a(m);else for(let v=0;v<m.length;v++){const L=m[v];L&&a(L)}};class b{constructor(a){this.w=0,this.f=a,this.g=p>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const a=this.t;queueMicrotask(()=>{h(a,v=>v.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(a,v,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.$jc.None;if(this.m)return D.$jc.None;v&&(a=a.bind(v));const T=new f(a);let z,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=d.create(),z=this.g.check(T.stack,this.w+1)),R&&(T.stack=U??d.create()),this.t?this.t instanceof f?(this.u??=new I,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const B=(0,D.$hc)(()=>{z?.(),this.x(T)});return L instanceof D.$ic?L.add(B):Array.isArray(L)&&L.push(B),B},this.q}x(a){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const v=this.t,L=v.indexOf(a);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,v[L]=void 0;const T=this.u.current===this;if(this.w*o<=v.length){let z=0;for(let U=0;U<v.length;U++)v[U]?v[z++]=v[U]:T&&(this.u.end--,z<this.u.i&&this.u.i--);v.length=z}}y(a,v){if(!a)return;const L=this.f?.onListenerError||j.$Y;if(!L){a.value(v);return}try{a.value(v)}catch(T){L(T)}}z(a){const v=a.current.t;for(;a.i<a.end;)this.y(v[a.i++],a.value);a.reset()}fire(a){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,a);else{const v=this.u;v.enqueue(this,a,this.t.length),this.z(v)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ed=b;const w=()=>new I;e.$fd=w;class I{constructor(){this.i=-1,this.end=0}enqueue(a,v,L){this.i=0,this.end=L,this.current=a,this.value=v}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends b{async fireAsync(a,v,L){if(this.t)for(this.h||(this.h=new A.$sc),h(this.t,T=>this.h.push([T.value,a]));this.h.size>0&&!v.isCancellationRequested;){const[T,z]=this.h.shift(),U=[],B={...z,token:v,waitUntil:Q=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");L&&(Q=L(Q,T)),U.push(Q)}};try{T(B)}catch(Q){(0,j.$Y)(Q);continue}Object.freeze(U),await Promise.allSettled(U).then(Q=>{for(const J of Q)J.status==="rejected"&&(0,j.$Y)(J.reason)})}}}e.$gd=t;class c extends b{get isPaused(){return this.h!==0}constructor(a){super(a),this.h=0,this.s=new A.$sc,this.A=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.A(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.w&&(this.h!==0?this.s.push(a):super.fire(a))}}e.$hd=c;class s extends c{constructor(a){super(a),this.k=a.delay??100}fire(a){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(a)}}e.$id=s;class n extends b{constructor(a){super(a),this.h=[],this.k=a?.merge}fire(a){this.hasListeners()&&(this.h.push(a),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(v=>super.fire(v)),this.h=[]}))}}e.$jd=n;class i{constructor(){this.g=!1,this.h=[],this.f=new b({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(a){const v={event:a,listener:null};this.h.push(v),this.g&&this.m(v);const L=()=>{this.g&&this.o(v);const T=this.h.indexOf(v);this.h.splice(T,1)};return(0,D.$hc)((0,N.$bb)(L))}j(){this.g=!0,this.h.forEach(a=>this.m(a))}k(){this.g=!1,this.h.forEach(a=>this.o(a))}m(a){a.listener=a.event(v=>this.f.fire(v))}o(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.f.dispose()}}e.$kd=i;class r{constructor(a,v,L,T){this.f=new D.$ic;const z=this.f.add(new i),U=this.f.add(new D.$rc);function B(Q){U.set(Q,z.add(T(Q)))}for(const Q of a)B(Q);this.f.add(v(Q=>{B(Q)})),this.f.add(L(Q=>{U.deleteAndDispose(Q)})),this.event=z.event}dispose(){this.f.dispose()}}e.$ld=r;class l{constructor(){this.f=[]}wrapEvent(a){return(v,L,T)=>a(z=>{const U=this.f[this.f.length-1];U?U.push(()=>v.call(L,z)):v.call(L,z)},void 0,T)}bufferEvents(a){const v=[];this.f.push(v);const L=a();return this.f.pop(),v.forEach(T=>T()),L}}e.$md=l;class E{constructor(){this.f=!1,this.g=$.None,this.h=D.$jc.None,this.j=new b({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(a){this.g=a,this.f&&(this.h.dispose(),this.h=a(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$nd=E}),define(re[26],oe([0,1,3]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.CancellationToken=void 0;const N=Object.freeze(function(R,S){const $=setTimeout(R.bind(S),0);return{dispose(){clearTimeout($)}}});var D;(function(R){function S($){return $===R.None||$===R.Cancelled||$ instanceof A?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:j.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(D||(e.CancellationToken=D={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new j.$ed),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=D.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=D.None}}e.$od=O}),define(re[129],oe([0,1,26]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new j.$od,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$ge=N;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$he=D;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$ie=A}),define(re[42],oe([0,1,8,2]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function D(w){const I=w;return I?typeof I.read=="function":!1}e.$pd=D;function A(w){const I=w;return I?[I.on,I.pause,I.resume,I.destroy].every(t=>typeof t=="function"):!1}e.$qd=A;function O(w){const I=w;return I?A(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.$rd=O;function R(w,I){return new S(w,I)}e.$sd=R;class S{constructor(I,t){this.e=I,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(t=>t(I))}h(I){this.c.error.length===0?(0,j.$Y)(I):this.c.error.slice(0).forEach(t=>t(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,t){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(I,t){if(this.a.destroyed)return;let c;switch(I){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const s=c.indexOf(t);s>=0&&c.splice(s,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(w,I){const t=[];let c;for(;(c=w.read())!==null;)t.push(c);return I(t)}e.$td=$;function C(w,I,t){const c=[];let s;for(;(s=w.read())!==null&&c.length<t;)c.push(s);return s===null&&c.length>0?I(c):{read:()=>{if(c.length>0)return c.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return w.read()}}}e.$ud=C;function p(w,I){return new Promise((t,c)=>{const s=[];g(w,{onData:n=>{I&&s.push(n)},onError:n=>{I?c(n):t(void 0)},onEnd:()=>{t(I?I(s):void 0)}})})}e.$vd=p;function g(w,I,t){w.on("error",c=>{t?.isCancellationRequested||I.onError(c)}),w.on("end",()=>{t?.isCancellationRequested||I.onEnd()}),w.on("data",c=>{t?.isCancellationRequested||I.onData(c)})}e.$wd=g;function u(w,I){return new Promise((t,c)=>{const s=new N.$ic,n=[],i=E=>{if(n.push(E),n.length>I)return s.dispose(),w.pause(),t({stream:w,buffer:n,ended:!1})},r=E=>(s.dispose(),c(E)),l=()=>(s.dispose(),t({stream:w,buffer:n,ended:!0}));s.add((0,N.$hc)(()=>w.removeListener("error",r))),w.on("error",r),s.add((0,N.$hc)(()=>w.removeListener("end",l))),w.on("end",l),s.add((0,N.$hc)(()=>w.removeListener("data",i))),w.on("data",i)})}e.$xd=u;function d(w,I){const t=R(I);return t.end(w),t}e.$yd=d;function y(){const w=R(()=>{throw new Error("not supported")});return w.end(),w}e.$zd=y;function f(w){let I=!1;return{read:()=>I?null:(I=!0,w)}}e.$Ad=f;function o(w,I,t){const c=R(t);return g(w,{onData:s=>c.write(I.data(s)),onError:s=>c.error(I.error?I.error(s):s),onEnd:()=>c.end()}),c}e.$Bd=o;function h(w,I,t){let c=!1;return{read:()=>{const s=I.read();return c?s:(c=!0,s!==null?t([w,s]):w)}}}e.$Cd=h;function b(w,I,t){let c=!1;const s=R(t);return g(I,{onData:n=>c?s.write(n):(c=!0,s.write(t([w,n]))),onError:n=>s.error(n),onEnd:()=>{c||(c=!0,s.write(w)),s.end()}}),s}e.$Dd=b}),define(re[14],oe([0,1,86,42]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const D=typeof Buffer<"u",A=new j.$T(()=>new Uint8Array(256));let O,R;class S{static alloc(v){return D?new S(Buffer.allocUnsafe(v)):new S(new Uint8Array(v))}static wrap(v){return D&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new S(v)}static fromString(v,L){return!(L?.dontUseNodeBuffer||!1)&&D?new S(Buffer.from(v)):(O||(O=new TextEncoder),new S(O.encode(v)))}static fromByteArray(v){const L=S.alloc(v.length);for(let T=0,z=v.length;T<z;T++)L.buffer[T]=v[T];return L}static concat(v,L){if(typeof L>"u"){L=0;for(let U=0,B=v.length;U<B;U++)L+=v[U].byteLength}const T=S.alloc(L);let z=0;for(let U=0,B=v.length;U<B;U++){const Q=v[U];T.set(Q,z),z+=Q.byteLength}return T}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=S.alloc(this.byteLength);return v.set(this),v}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(v,L){return new S(this.buffer.subarray(v,L))}set(v,L){if(v instanceof S)this.buffer.set(v.buffer,L);else if(v instanceof Uint8Array)this.buffer.set(v,L);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),L);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return g(this.buffer,v)}writeUInt32BE(v,L){u(this.buffer,v,L)}readUInt32LE(v){return d(this.buffer,v)}writeUInt32LE(v,L){y(this.buffer,v,L)}readUInt8(v){return f(this.buffer,v)}writeUInt8(v,L){o(this.buffer,v,L)}indexOf(v,L=0){return $(this.buffer,v instanceof S?v.buffer:v,L)}}e.$Ed=S;function $(a,v,L=0){const T=v.byteLength,z=a.byteLength;if(T===0)return 0;if(T===1)return a.indexOf(v[0]);if(T>z-L)return-1;const U=A.value;U.fill(v.length);for(let x=0;x<v.length;x++)U[v[x]]=v.length-x-1;let B=L+v.length-1,Q=B,J=-1;for(;B<z;)if(a[B]===v[Q]){if(Q===0){J=B;break}B--,Q--}else B+=Math.max(v.length-Q,U[a[B]]),Q=v.length-1;return J}e.$Fd=$;function C(a,v){return a[v+0]<<0>>>0|a[v+1]<<8>>>0}e.$Gd=C;function p(a,v,L){a[L+0]=v&255,v=v>>>8,a[L+1]=v&255}e.$Hd=p;function g(a,v){return a[v]*2**24+a[v+1]*2**16+a[v+2]*2**8+a[v+3]}e.$Id=g;function u(a,v,L){a[L+3]=v,v=v>>>8,a[L+2]=v,v=v>>>8,a[L+1]=v,v=v>>>8,a[L]=v}e.$Jd=u;function d(a,v){return a[v+0]<<0>>>0|a[v+1]<<8>>>0|a[v+2]<<16>>>0|a[v+3]<<24>>>0}e.$Kd=d;function y(a,v,L){a[L+0]=v&255,v=v>>>8,a[L+1]=v&255,v=v>>>8,a[L+2]=v&255,v=v>>>8,a[L+3]=v&255}e.$Ld=y;function f(a,v){return a[v]}e.$Md=f;function o(a,v,L){a[L]=v}e.$Nd=o;function h(a){return N.$td(a,v=>S.concat(v))}e.$Od=h;function b(a){return N.$Ad(a)}e.$Pd=b;function w(a){return N.$vd(a,v=>S.concat(v))}e.$Qd=w;async function I(a){return a.ended?S.concat(a.buffer):S.concat([...a.buffer,await w(a.stream)])}e.$Rd=I;function t(a){return N.$yd(a,v=>S.concat(v))}e.$Sd=t;function c(a){return N.$Bd(a,{data:v=>typeof v=="string"?S.fromString(v):S.wrap(v)},v=>S.concat(v))}e.$Td=c;function s(a){return N.$sd(v=>S.concat(v),a)}e.$Ud=s;function n(a,v){return N.$Cd(a,v,L=>S.concat(L))}e.$Vd=n;function i(a,v){return N.$Dd(a,v,L=>S.concat(L))}e.$Wd=i;function r(a){let v=0,L=0,T=0;const z=new Uint8Array(Math.floor(a.length/4*3)),U=Q=>{switch(L){case 3:z[T++]=v|Q,L=0;break;case 2:z[T++]=v|Q>>>2,v=Q<<6,L=3;break;case 1:z[T++]=v|Q>>>4,v=Q<<4,L=2;break;default:v=Q<<2,L=1}};for(let Q=0;Q<a.length;Q++){const J=a.charCodeAt(Q);if(J>=65&&J<=90)U(J-65);else if(J>=97&&J<=122)U(J-97+26);else if(J>=48&&J<=57)U(J-48+52);else if(J===43||J===45)U(62);else if(J===47||J===95)U(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${a[Q]}`)}}const B=T;for(;L>0;)U(0);return S.wrap(z).slice(0,B)}e.$Xd=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:a},v=!0,L=!1){const T=L?E:l;let z="";const U=a.byteLength%3;let B=0;for(;B<a.byteLength-U;B+=3){const Q=a[B+0],J=a[B+1],x=a[B+2];z+=T[Q>>>2],z+=T[(Q<<4|J>>>4)&63],z+=T[(J<<2|x>>>6)&63],z+=T[x&63]}if(U===1){const Q=a[B+0];z+=T[Q>>>2],z+=T[Q<<4&63],v&&(z+="==")}else if(U===2){const Q=a[B+0],J=a[B+1];z+=T[Q>>>2],z+=T[(Q<<4|J>>>4)&63],z+=T[J<<2&63],v&&(z+="=")}return z}e.$Yd=m}),define(re[28],oe([0,1,129,86]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hf=e.$gf=e.$ff=e.$ef=e.GraphemeBreakType=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function D(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$le=D;const A=/{(\d+)}/g;function O(ie,...ue){return ue.length===0?ie:ie.replace(A,function(me,pe){const Se=parseInt(pe,10);return isNaN(Se)||Se<0||Se>=ue.length?me:ue[Se]})}e.$me=O;const R=/{([^}]+)}/g;function S(ie,ue){return ie.replace(R,(me,pe)=>ue[pe]??me)}e.$ne=S;function $(ie){return ie.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.$oe=$;function C(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pe=C;function p(ie,ue){let me=0;const pe=ue.charCodeAt(0);for(let Se=ie.length-1;Se>=0;Se--)ie.charCodeAt(Se)===pe&&me++;return me}e.$qe=p;function g(ie,ue,me="\u2026"){return ie.length<=ue?ie:`${ie.substr(0,ue)}${me}`}e.$re=g;function u(ie,ue=" "){const me=d(ie,ue);return y(me,ue)}e.$se=u;function d(ie,ue){if(!ie||!ue)return ie;const me=ue.length;if(me===0||ie.length===0)return ie;let pe=0;for(;ie.indexOf(ue,pe)===pe;)pe=pe+me;return ie.substring(pe)}e.$te=d;function y(ie,ue){if(!ie||!ue)return ie;const me=ue.length,pe=ie.length;if(me===0||pe===0)return ie;let Se=pe,Re=-1;for(;Re=ie.lastIndexOf(ue,Se-1),!(Re===-1||Re+me!==Se);){if(Re===0)return"";Se=Re}return ie.substring(0,Se)}e.$ue=y;function f(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$ve=f;function o(ie){return ie.replace(/\*/g,"")}e.$we=o;function h(ie,ue,me={}){if(!ie)throw new Error("Cannot create regex from empty string");ue||(ie=C(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(ie,pe)}e.$xe=h;function b(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$ye=b;function w(ie){return ie.split(/\r\n|\r|\n/)}e.$ze=w;function I(ie){for(let ue=0,me=ie.length;ue<me;ue++){const pe=ie.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.$Ae=I;function t(ie,ue=0,me=ie.length){for(let pe=ue;pe<me;pe++){const Se=ie.charCodeAt(pe);if(Se!==32&&Se!==9)return ie.substring(ue,pe)}return ie.substring(ue,me)}e.$Be=t;function c(ie,ue=ie.length-1){for(let me=ue;me>=0;me--){const pe=ie.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Ce=c;function s(ie,ue,me){const pe=[];let Se=0;for(const Re of ie.matchAll(ue)){if(pe.push(ie.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return pe.push(ie.slice(Se)),Promise.all(pe).then(Re=>Re.join(""))}e.$De=s;function n(ie,ue){return ie<ue?-1:ie>ue?1:0}e.$Ee=n;function i(ie,ue,me=0,pe=ie.length,Se=0,Re=ue.length){for(;me<pe&&Se<Re;me++,Se++){const De=ie.charCodeAt(me),Ae=ue.charCodeAt(Se);if(De<Ae)return-1;if(De>Ae)return 1}const Ce=pe-me,Ie=Re-Se;return Ce<Ie?-1:Ce>Ie?1:0}e.$Fe=i;function r(ie,ue){return l(ie,ue,0,ie.length,0,ue.length)}e.$Ge=r;function l(ie,ue,me=0,pe=ie.length,Se=0,Re=ue.length){for(;me<pe&&Se<Re;me++,Se++){let De=ie.charCodeAt(me),Ae=ue.charCodeAt(Se);if(De===Ae)continue;if(De>=128||Ae>=128)return i(ie.toLowerCase(),ue.toLowerCase(),me,pe,Se,Re);m(De)&&(De-=32),m(Ae)&&(Ae-=32);const Ne=De-Ae;if(Ne!==0)return Ne}const Ce=pe-me,Ie=Re-Se;return Ce<Ie?-1:Ce>Ie?1:0}e.$He=l;function E(ie){return ie>=48&&ie<=57}e.$Ie=E;function m(ie){return ie>=97&&ie<=122}e.$Je=m;function a(ie){return ie>=65&&ie<=90}e.$Ke=a;function v(ie,ue){return ie.length===ue.length&&l(ie,ue)===0}e.$Le=v;function L(ie,ue){const me=ue.length;return ue.length>ie.length?!1:l(ie,ue,0,me)===0}e.$Me=L;function T(ie,ue){const me=Math.min(ie.length,ue.length);let pe;for(pe=0;pe<me;pe++)if(ie.charCodeAt(pe)!==ue.charCodeAt(pe))return pe;return me}e.$Ne=T;function z(ie,ue){const me=Math.min(ie.length,ue.length);let pe;const Se=ie.length-1,Re=ue.length-1;for(pe=0;pe<me;pe++)if(ie.charCodeAt(Se-pe)!==ue.charCodeAt(Re-pe))return pe;return me}e.$Oe=z;function U(ie){return 55296<=ie&&ie<=56319}e.$Pe=U;function B(ie){return 56320<=ie&&ie<=57343}e.$Qe=B;function Q(ie,ue){return(ie-55296<<10)+(ue-56320)+65536}e.$Re=Q;function J(ie,ue,me){const pe=ie.charCodeAt(me);if(U(pe)&&me+1<ue){const Se=ie.charCodeAt(me+1);if(B(Se))return Q(pe,Se)}return pe}e.$Se=J;function x(ie,ue){const me=ie.charCodeAt(ue-1);if(B(me)&&ue>1){const pe=ie.charCodeAt(ue-2);if(U(pe))return Q(pe,me)}return me}class H{get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=x(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=J(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.$Te=H;class X{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new H(ue,me)}nextGraphemeLength(){const ue=ge.getInstance(),me=this.c,pe=me.offset;let Se=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=ue.getGraphemeBreakType(me.nextCodePoint());if(Me(Se,Ce)){me.setOffset(Re);break}Se=Ce}return me.offset-pe}prevGraphemeLength(){const ue=ge.getInstance(),me=this.c,pe=me.offset;let Se=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=ue.getGraphemeBreakType(me.prevCodePoint());if(Me(Ce,Se)){me.setOffset(Re);break}Se=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$Ue=X;function G(ie,ue){return new X(ie,ue).nextGraphemeLength()}e.$Ve=G;function W(ie,ue){return new X(ie,ue).prevGraphemeLength()}e.$We=W;function V(ie,ue){ue>0&&B(ie.charCodeAt(ue))&&ue--;const me=ue+G(ie,ue);return[me-W(ie,me),me]}e.$Xe=V;function ee(ie){const ue=new X(ie);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.$Ye=ee;let ne;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Z(ie){return ne||(ne=se()),ne.test(ie)}e.$Ze=Z;const q=/^[\t\n\r\x20-\x7E]*$/;function k(ie){return q.test(ie)}e.$1e=k,e.$2e=/[\u2028\u2029]/;function P(ie){return e.$2e.test(ie)}e.$3e=P;function F(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$4e=F;function M(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$5e=M;function K(ie,ue){if(ie.length<ue)return ie;const me=/\b/g;let pe=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<ue);)pe=me.lastIndex,me.lastIndex+=1;return ie.substring(pe).replace(/^\s/,"")}e.$6e=K;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function he(ie){return ie&&(ie=ie.replace(_,"").replace(ae,"")),ie}e.$7e=he,e.$8e=String.fromCharCode(65279);function fe(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$9e=fe;function le(ie){return fe(ie)?ie.substr(1):ie}e.$0e=le;function $e(ie,ue){if(!ie||!ue||ie.length<ue.length)return!1;const me=ue.length,pe=ie.toLowerCase();let Se=0,Re=-1;for(;Se<me;){const Ce=pe.indexOf(ue[Se],Re+1);if(Ce<0)return!1;Re=Ce,Se++}return!0}e.$$e=$e;function de(ie,ue=!1){return ie?(ue&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$_e=de;function we(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$af=we;function Ee(ie,ue=1){if(ue===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.$bf=Ee;function je(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$cf=je;function Le(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.$df=Le;function Me(ie,ue){return ie===0?ue!==5&&ue!==7:ie===2&&ue===3?!1:ie===4||ie===2||ie===3||ue===4||ue===2||ue===3?!0:!(ie===8&&(ue===8||ue===9||ue===11||ue===12)||(ie===11||ie===9)&&(ue===9||ue===10)||(ie===12||ie===10)&&ue===10||ue===5||ue===13||ue===7||ie===1||ie===13&&ue===14||ie===6&&ue===6)}var ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,pe=me.length/3;let Se=1;for(;Se<=pe;)if(ue<me[3*Se])Se=2*Se;else if(ue>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(ie,ue){if(ie===0)return 0;const me=Pe(ie,ue);if(me!==void 0)return me;const pe=new H(ue,ie);return pe.prevCodePoint(),pe.offset}e.$ef=ke;function Pe(ie,ue){const me=new H(ue,ie);let pe=me.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!M(pe))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function ze(ie){return 127995<=ie&&ie<=127999}var Oe;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$ff="\xA0";class Ue{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new j.$he(ue=>{function me(Ne){const Be=new Map;for(let qe=0;qe<Ne.length;qe+=2)Be.set(Ne[qe],Ne[qe+1]);return Be}function pe(Ne,Be){const qe=new Map(Ne);for(const[Ve,xe]of Be)qe.set(Ve,xe);return qe}function Se(Ne,Be){if(!Ne)return Be;const qe=new Map;for(const[Ve,xe]of Ne)Be.has(Ve)&&qe.set(Ve,xe);return qe}const Re=this.c.value;let Ce=ue.filter(Ne=>!Ne.startsWith("_")&&Ne in Re);Ce.length===0&&(Ce=["_default"]);let Ie;for(const Ne of Ce){const Be=me(Re[Ne]);Ie=Se(Ie,Be)}const De=me(Re._common),Ae=pe(De,Ie);return new Ue(Ae)})}static getInstance(ue){return Ue.d.get(Array.from(ue))}static{this.e=new N.$T(()=>Object.keys(Ue.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$gf=Ue;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(ue){return Te.e().has(ue)}static get codePoints(){return Te.e()}}e.$hf=Te}),define(re[51],oe([0,1,28]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0;function N(o){return D(o,0)}e.$oi=N;function D(o,h){switch(typeof o){case"object":return o===null?A(349,h):Array.isArray(o)?S(o,h):$(o,h);case"string":return R(o,h);case"boolean":return O(o,h);case"number":return A(o,h);case"undefined":return A(937,h);default:return A(617,h)}}e.$pi=D;function A(o,h){return(h<<5)-h+o|0}e.$qi=A;function O(o,h){return A(o?433:863,h)}function R(o,h){h=A(149417,h);for(let b=0,w=o.length;b<w;b++)h=A(o.charCodeAt(b),h);return h}e.$ri=R;function S(o,h){return h=A(104579,h),o.reduce((b,w)=>D(w,b),h)}function $(o,h){return h=A(181387,h),Object.keys(o).sort().reduce((b,w)=>(b=R(w,b),D(o[w],b)),h)}class C{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=D(h,this.g),this.g}}e.$si=C;var p;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function g(o,h,b=32){const w=b-h,I=~((1<<w)-1);return(o<<h|(I&o)>>>w)>>>0}function u(o,h=0,b=o.byteLength,w=0){for(let I=0;I<b;I++)o[h+I]=w}function d(o,h,b="0"){for(;o.length<h;)o=b+o;return o}function y(o,h=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(b=>b.toString(16).padStart(2,"0")).join(""):d((o>>>0).toString(16),h/4)}e.$ti=y;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const b=h.length;if(b===0)return;const w=this.p;let I=this.r,t=this.u,c,s;for(t!==0?(c=t,s=-1,t=0):(c=h.charCodeAt(0),s=0);;){let n=c;if(j.$Pe(c))if(s+1<b){const i=h.charCodeAt(s+1);j.$Qe(i)?(s++,n=j.$Re(c,i)):n=65533}else{t=c;break}else j.$Qe(c)&&(n=65533);if(I=this.w(w,I,n),s++,s<b)c=h.charCodeAt(s);else break}this.r=I,this.u=t}w(h,b,w){return w<128?h[b++]=w:w<2048?(h[b++]=192|(w&1984)>>>6,h[b++]=128|(w&63)>>>0):w<65536?(h[b++]=224|(w&61440)>>>12,h[b++]=128|(w&4032)>>>6,h[b++]=128|(w&63)>>>0):(h[b++]=240|(w&1835008)>>>18,h[b++]=128|(w&258048)>>>12,h[b++]=128|(w&4032)>>>6,h[b++]=128|(w&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=f.g,b=this.q;for(let l=0;l<64;l+=4)h.setUint32(l,b.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)h.setUint32(l,g(h.getUint32(l-12,!1)^h.getUint32(l-32,!1)^h.getUint32(l-56,!1)^h.getUint32(l-64,!1),1),!1);let w=this.h,I=this.l,t=this.m,c=this.n,s=this.o,n,i,r;for(let l=0;l<80;l++)l<20?(n=I&t|~I&c,i=1518500249):l<40?(n=I^t^c,i=1859775393):l<60?(n=I&t|I&c|t&c,i=2400959708):(n=I^t^c,i=3395469782),r=g(w,5)+n+s+i+h.getUint32(l*4,!1)&4294967295,s=c,c=t,t=g(I,30),I=w,w=r;this.h=this.h+w&4294967295,this.l=this.l+I&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+s&4294967295}}e.$ui=f}),define(re[89],oe([0,1,28]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(N||(N={})),function(D){const A="error",O="warning",R="warn",S="info",$="ignore";function C(g){return g?j.$Le(A,g)?D.Error:j.$Le(O,g)||j.$Le(R,g)?D.Warning:j.$Le(S,g)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function p(g){switch(g){case D.Error:return A;case D.Warning:return O;case D.Info:return S;default:return $}}D.toString=p}(N||(N={})),e.default=N}),define(re[130],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(re[47],oe([0,1,18,28]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class D{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const d=u.charCodeAt(0),y=this.b.charCodeAt(this.c);return d-y}value(){return this.b[this.c]}}e.$Ch=D;class A{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,N.$Fe)(u,this.b,0,u.length,this.c,this.d):(0,N.$He)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Dh=A;class O{constructor(u=!0,d=!0){this.f=u,this.g=d}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let d=u.length-1;d>=0;d--,this.c--){const y=this.b.charCodeAt(d);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,N.$Fe)(u,this.b,0,u.length,this.d,this.e):(0,N.$He)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Eh=O;var R;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(u,d){this.f=u,this.g=d,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,N.$Ge)(u,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Ge)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,N.$Ee)(u,this.c.query);if(this.d[this.e]===5)return(0,N.$Ee)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fh=S;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(C||(C={}));class p{static forUris(u=()=>!1,d=()=>!1){return new p(new S(u,d))}static forPaths(u=!1){return new p(new O(void 0,!u))}static forStrings(){return new p(new D)}static forConfigKeys(){return new p(new A)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,d){if(d){const y=d.slice(0);(0,j.$Ub)(y);for(const f of y)this.set(f,u)}else{const y=u.slice(0);(0,j.$Ub)(y);for(const f of y)this.set(f[0],f[1])}}set(u,d){const y=this.b.reset(u);let f;this.c||(this.c=new $,this.c.segment=y.value());const o=[];for(f=this.c;;){const b=y.cmp(f.segment);if(b>0)f.left||(f.left=new $,f.left.segment=y.value()),o.push([-1,f]),f=f.left;else if(b<0)f.right||(f.right=new $,f.right.segment=y.value()),o.push([1,f]),f=f.right;else if(y.hasNext())y.next(),f.mid||(f.mid=new $,f.mid.segment=y.value()),o.push([0,f]),f=f.mid;else break}const h=f.value;f.value=d,f.key=u;for(let b=o.length-1;b>=0;b--){const w=o[b][1];w.updateHeight();const I=w.balanceFactor();if(I<-1||I>1){const t=o[b][0],c=o[b+1][0];if(t===1&&c===1)o[b][1]=w.rotateLeft();else if(t===-1&&c===-1)o[b][1]=w.rotateRight();else if(t===1&&c===-1)w.right=o[b+1][1]=o[b+1][1].rotateRight(),o[b][1]=w.rotateLeft();else if(t===-1&&c===1)w.left=o[b+1][1]=o[b+1][1].rotateLeft(),o[b][1]=w.rotateRight();else throw new Error;if(b>0)switch(o[b-1][0]){case-1:o[b-1][1].left=o[b][1];break;case 1:o[b-1][1].right=o[b][1];break;case 0:o[b-1][1].mid=o[b][1];break}else this.c=o[0][1]}}return h}get(u){return this.d(u)?.value}d(u){const d=this.b.reset(u);let y=this.c;for(;y;){const f=d.cmp(y.segment);if(f>0)y=y.left;else if(f<0)y=y.right;else if(d.hasNext())d.next(),y=y.mid;else break}return y}has(u){const d=this.d(u);return!(d?.value===void 0&&d?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,d){const y=this.b.reset(u),f=[];let o=this.c;for(;o;){const h=y.cmp(o.segment);if(h>0)f.push([-1,o]),o=o.left;else if(h<0)f.push([1,o]),o=o.right;else if(y.hasNext())y.next(),f.push([0,o]),o=o.mid;else break}if(o){if(d?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const h=this.f(o.right);if(h.key){const{key:b,value:w,segment:I}=h;this.e(h.key,!1),o.key=b,o.value=w,o.segment=I}}else{const h=o.left??o.right;if(f.length>0){const[b,w]=f[f.length-1];switch(b){case-1:w.left=h;break;case 0:w.mid=h;break;case 1:w.right=h;break}}else this.c=h}for(let h=f.length-1;h>=0;h--){const b=f[h][1];b.updateHeight();const w=b.balanceFactor();if(w>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),f[h][1]=b.rotateLeft()):w<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),f[h][1]=b.rotateRight()),h>0)switch(f[h-1][0]){case-1:f[h-1][1].left=f[h][1];break;case 1:f[h-1][1].right=f[h][1];break;case 0:f[h-1][1].mid=f[h][1];break}else this.c=f[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const d=this.b.reset(u);let y=this.c,f;for(;y;){const o=d.cmp(y.segment);if(o>0)y=y.left;else if(o<0)y=y.right;else if(d.hasNext())d.next(),f=y.value||f,y=y.mid;else break}return y&&y.value||f}findSuperstr(u){return this.g(u,!1)}g(u,d){const y=this.b.reset(u);let f=this.c;for(;f;){const o=y.cmp(f.segment);if(o>0)f=f.left;else if(o<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else return f.mid?this.h(f.mid):d?f.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[d,y]of this)u(y,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const d=[];return this.j(u,d),d[Symbol.iterator]()}j(u,d){u&&(u.left&&this.j(u.left,d),u.value&&d.push([u.key,u.value]),u.mid&&this.j(u.mid,d),u.right&&this.j(u.right,d))}_isBalanced(){const u=d=>{if(!d)return!0;const y=d.balanceFactor();return y<-1||y>1?!1:u(d.left)&&u(d.right)};return u(this.c)}}e.$Gh=p}),define(re[9],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=void 0;function j(I){return typeof I=="string"}e.$if=j;function N(I){return Array.isArray(I)&&I.every(t=>j(t))}e.$jf=N;function D(I){return typeof I=="object"&&I!==null&&!Array.isArray(I)&&!(I instanceof RegExp)&&!(I instanceof Date)}e.$kf=D;function A(I){const t=Object.getPrototypeOf(Uint8Array);return typeof I=="object"&&I instanceof t}e.$lf=A;function O(I){return typeof I=="number"&&!isNaN(I)}e.$mf=O;function R(I){return!!I&&typeof I[Symbol.iterator]=="function"}e.$nf=R;function S(I){return I===!0||I===!1}e.$of=S;function $(I){return typeof I>"u"}e.$pf=$;function C(I){return!p(I)}e.$qf=C;function p(I){return $(I)||I===null}e.$rf=p;function g(I,t){if(!I)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$sf=g;function u(I){if(p(I))throw new Error("Assertion Failed: argument is undefined or null");return I}e.$tf=u;function d(...I){const t=[];for(let c=0;c<I.length;c++){const s=I[c];if(p(s))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(s)}return t}e.$uf=d;const y=Object.prototype.hasOwnProperty;function f(I){if(!D(I))return!1;for(const t in I)if(y.call(I,t))return!1;return!0}e.$vf=f;function o(I){return typeof I=="function"}e.$wf=o;function h(...I){return I.length>0&&I.every(o)}e.$xf=h;function b(I,t){const c=Math.min(I.length,t.length);for(let s=0;s<c;s++)w(I[s],t[s])}e.$yf=b;function w(I,t){if(j(t)){if(typeof I!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(I instanceof t)return}catch{}if(!p(I)&&I.constructor===t||t.length===1&&t.call(void 0,I)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$zf=w}),define(re[30],oe([0,1,9]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=void 0;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const h=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([b,w])=>{h[b]=w&&typeof w=="object"?N(w):w}),h}e.$Um=N;function D(o){if(!o||typeof o!="object")return o;const h=[o];for(;h.length>0;){const b=h.shift();Object.freeze(b);for(const w in b)if(A.call(b,w)){const I=b[w];typeof I=="object"&&!Object.isFrozen(I)&&!(0,j.$lf)(I)&&h.push(I)}}return o}e.$Vm=D;const A=Object.prototype.hasOwnProperty;function O(o,h){return R(o,h,new Set)}e.$Wm=O;function R(o,h,b){if((0,j.$rf)(o))return o;const w=h(o);if(typeof w<"u")return w;if(Array.isArray(o)){const I=[];for(const t of o)I.push(R(t,h,b));return I}if((0,j.$kf)(o)){if(b.has(o))throw new Error("Cannot clone recursive data-structure");b.add(o);const I={};for(const t in o)A.call(o,t)&&(I[t]=R(o[t],h,b));return b.delete(o),I}return o}function S(o,h,b=!0){return(0,j.$kf)(o)?((0,j.$kf)(h)&&Object.keys(h).forEach(w=>{w in o?b&&((0,j.$kf)(o[w])&&(0,j.$kf)(h[w])?S(o[w],h[w],b):o[w]=h[w]):o[w]=h[w]}),o):h}e.$Xm=S;function $(o,h){if(o===h)return!0;if(o==null||h===null||h===void 0||typeof o!=typeof h||typeof o!="object"||Array.isArray(o)!==Array.isArray(h))return!1;let b,w;if(Array.isArray(o)){if(o.length!==h.length)return!1;for(b=0;b<o.length;b++)if(!$(o[b],h[b]))return!1}else{const I=[];for(w in o)I.push(w);I.sort();const t=[];for(w in h)t.push(w);if(t.sort(),!$(I,t))return!1;for(b=0;b<I.length;b++)if(!$(o[I[b]],h[I[b]]))return!1}return!0}e.$Ym=$;function C(o){const h=new Set;return JSON.stringify(o,(b,w)=>{if((0,j.$kf)(w)||Array.isArray(w)){if(h.has(w))return"[Circular]";h.add(w)}return w})}e.$Zm=C;function p(o,h){const b=Object.create(null);return!o||!h||Object.keys(h).forEach(I=>{const t=o[I],c=h[I];$(t,c)||(b[I]=c)}),b}e.$1m=p;function g(o,h){const b=h.toLowerCase(),w=Object.keys(o).find(I=>I.toLowerCase()===b);return w?o[w]:o[h]}e.$2m=g;function u(o,h){const b=Object.create(null);for(const[w,I]of Object.entries(o))h(w,I)&&(b[w]=I);return b}e.$3m=u;function d(o){let h=[];for(;Object.prototype!==o;)h=h.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return h}e.$4m=d;function y(o){const h=[];for(const b of d(o))typeof o[b]=="function"&&h.push(b);return h}e.$5m=y;function f(o,h){const b=I=>function(){const t=Array.prototype.slice.call(arguments,0);return h(I,t)},w={};for(const I of o)w[I]=b(I);return w}e.$6m=f}),define(re[32],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const j=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(D){return j.test(D)}e.$2f=N,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,$="";return $+=O[A[S++]],$+=O[A[S++]],$+=O[A[S++]],$+=O[A[S++]],$+="-",$+=O[A[S++]],$+=O[A[S++]],$+="-",$+=O[A[S++]],$+=O[A[S++]],$+="-",$+=O[A[S++]],$+=O[A[S++]],$+="-",$+=O[A[S++]],$+=O[A[S++]],$+=O[A[S++]],$+=O[A[S++]],$+=O[A[S++]],$+=O[A[S++]],$}}()}),define(re[131],oe([0,1,36]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(O){const R=O.replace(/\-/g,":").toLowerCase();return!N.has(R)}function A(){const O=(0,j.networkInterfaces)();for(const R in O){const S=O[R];if(S){for(const{mac:$}of S)if(D($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Fm=A}),define(re[132],oe([0,1,36,47,32,131]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Gm=new class{c($){return this.a||(this.a=N.$Gh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,C=0;const p=(0,j.networkInterfaces)();for(const g in p){const u=p[g];if(u)for(const{mac:d,internal:y}of u)y||(C+=1,this.c(d.toUpperCase())&&($+=1))}this.b=C>0?$/C:0}return this.b}};let O;async function R($){return O||(O=(async()=>await S($)||D.$3f())()),O}e.$Hm=R;async function S($){try{const C=await new Promise((g,u)=>{te(["crypto"],g,u)}),p=(0,A.$Fm)();return C.createHash("sha256").update(p,"utf8").digest("hex")}catch(C){$(C);return}}}),define(re[133],oe([0,1,268,14]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FS=void 0;class D extends j.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,S){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let $=0;for(;$<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,$):(0,N.$Fd)(this.a,this.b,$);if(C===-1)break;this.push(this.a.slice($,C+this.c)),$=C+this.c}this.a=$===this.a.length?void 0:this.a.slice($),S()}_flush(O){this.a&&this.push(this.a),O()}}e.$FS=D}),define(re[134],oe([0,1,61]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=void 0;function N(R,S,$,C=1){let p=!1;return new Promise(g=>{const u=setTimeout(()=>{if(!p)return p=!0,g(0)},$);D(R,S,C,d=>{if(!p)return p=!0,clearTimeout(u),g(d)})})}e.$5f=N;function D(R,S,$,C){if(S===0)return C(0);const p=new j.Socket;p.once("connect",()=>(O(p),D(R+$,S-1,$,C))),p.once("data",()=>{}),p.once("error",g=>(O(p),g.code!=="ECONNREFUSED"?D(R+$,S-1,$,C):C(R))),p.connect(R,"127.0.0.1")}e.$6f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,S,$,C="127.0.0.1"){let p=!1,g,u=1;const d=j.createServer({pauseOnConnect:!0});function y(f,o){p||(p=!0,d.removeAllListeners(),d.close(),g&&clearTimeout(g),o(f))}return new Promise(f=>{g=setTimeout(()=>{y(0,f)},$),d.on("listening",()=>{y(R,f)}),d.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&u<S?(R++,u++,d.listen(R,C)):y(0,f)}),d.on("close",()=>{y(0,f)}),d.listen(R,C)})}e.$7f=A;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(re[135],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VS=void 0;function j(N){return!!N.parentPort}e.$VS=j}),define(re[136],oe([12,10]),function(te,e){return te.create("vs/base/common/date",e)}),define(re[62],oe([0,1,136]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const N=60,D=N*60,A=D*24,O=A*7,R=A*30,S=A*365;function $(p,g,u,d){typeof p!="number"&&(p=p.getTime());const y=Math.round((new Date().getTime()-p)/1e3);if(y<-30)return(0,j.localize)(0,null,$(new Date().getTime()+y*1e3,!1));if(!d&&y<30)return(0,j.localize)(1,null);let f;return y<N?(f=y,g?f===1?u?(0,j.localize)(2,null,f):(0,j.localize)(3,null,f):u?(0,j.localize)(4,null,f):(0,j.localize)(5,null,f):f===1?u?(0,j.localize)(6,null,f):(0,j.localize)(7,null,f):u?(0,j.localize)(8,null,f):(0,j.localize)(9,null,f)):y<D?(f=Math.floor(y/N),g?f===1?u?(0,j.localize)(10,null,f):(0,j.localize)(11,null,f):u?(0,j.localize)(12,null,f):(0,j.localize)(13,null,f):f===1?u?(0,j.localize)(14,null,f):(0,j.localize)(15,null,f):u?(0,j.localize)(16,null,f):(0,j.localize)(17,null,f)):y<A?(f=Math.floor(y/D),g?f===1?u?(0,j.localize)(18,null,f):(0,j.localize)(19,null,f):u?(0,j.localize)(20,null,f):(0,j.localize)(21,null,f):f===1?u?(0,j.localize)(22,null,f):(0,j.localize)(23,null,f):u?(0,j.localize)(24,null,f):(0,j.localize)(25,null,f)):y<O?(f=Math.floor(y/A),g?f===1?(0,j.localize)(26,null,f):(0,j.localize)(27,null,f):f===1?(0,j.localize)(28,null,f):(0,j.localize)(29,null,f)):y<R?(f=Math.floor(y/O),g?f===1?u?(0,j.localize)(30,null,f):(0,j.localize)(31,null,f):u?(0,j.localize)(32,null,f):(0,j.localize)(33,null,f):f===1?u?(0,j.localize)(34,null,f):(0,j.localize)(35,null,f):u?(0,j.localize)(36,null,f):(0,j.localize)(37,null,f)):y<S?(f=Math.floor(y/R),g?f===1?u?(0,j.localize)(38,null,f):(0,j.localize)(39,null,f):u?(0,j.localize)(40,null,f):(0,j.localize)(41,null,f):f===1?u?(0,j.localize)(42,null,f):(0,j.localize)(43,null,f):u?(0,j.localize)(44,null,f):(0,j.localize)(45,null,f)):(f=Math.floor(y/S),g?f===1?u?(0,j.localize)(46,null,f):(0,j.localize)(47,null,f):u?(0,j.localize)(48,null,f):(0,j.localize)(49,null,f):f===1?u?(0,j.localize)(50,null,f):(0,j.localize)(51,null,f):u?(0,j.localize)(52,null,f):(0,j.localize)(53,null,f))}e.$5l=$;function C(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=C}),define(re[137],oe([12,10]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,18,9,137]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function A(p,g){return g&&(p.stack||p.stacktrace)?D.localize(0,null,R(p),O(p.stack)||O(p.stacktrace)):R(p)}function O(p){return Array.isArray(p)?p.join(`
`):p}function R(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?D.localize(1,null,p.message):p.message||D.localize(2,null)}function S(p=null,g=!1){if(!p)return D.localize(3,null);if(Array.isArray(p)){const u=j.$Eb(p),d=S(u[0],g);return u.length>1?D.localize(4,null,d,u.length):d}if(N.$if(p))return p;if(p.detail){const u=p.detail;if(u.error)return A(u.error,g);if(u.exception)return A(u.exception,g)}return p.stack?A(p,g):p.message?p.message:D.localize(5,null)}e.$li=S;function $(p){const g=p;return g instanceof Error&&Array.isArray(g.actions)}e.$mi=$;function C(p,g){let u;return typeof p=="string"?u=new Error(p):u=p,u.actions=g,u}e.$ni=C}),define(re[138],oe([12,10]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(re[139],oe([0,1,138]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;function N(D){switch(D){case 1:return(0,j.localize)(0,null);case 2:return(0,j.localize)(1,null);case 3:return(0,j.localize)(2,null);case 4:return(0,j.localize)(3,null);case 5:return(0,j.localize)(4,null);case 6:return(0,j.localize)(5,null);case 7:return(0,j.localize)(6,null);case 8:return(0,j.localize)(7,null);case 9:return(0,j.localize)(8,null);default:return""}}e.$kp=N}),define(re[140],oe([12,10]),function(te,e){return te.create("vs/base/common/platform",e)}),define(re[6],oe([0,1,140]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let N=!1,D=!1,A=!1,O=!1,R=!1,S=!1,$=!1,C=!1,p=!1,g=!1,u,d=e.$f,y=e.$f,f,o;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?h=e.$g.vscode.process:typeof process<"u"&&(h=process);const b=typeof h?.versions?.electron=="string",w=b&&h?.type==="renderer";if(typeof navigator=="object"&&!w)o=navigator.userAgent,N=o.indexOf("Windows")>=0,D=o.indexOf("Macintosh")>=0,C=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=o.indexOf("Linux")>=0,g=o?.indexOf("Mobi")>=0,S=!0,u=j.getConfiguredDefaultLocale(j.localize(0,null))||e.$f,d=u,y=navigator.language;else if(typeof h=="object"){N=h.platform==="win32",D=h.platform==="darwin",A=h.platform==="linux",O=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,$=b,p=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$f,d=e.$f;const E=h.env.VSCODE_NLS_CONFIG;if(E)try{const m=JSON.parse(E),a=m.availableLanguages["*"];u=m.locale,y=m.osLocale,d=a||e.$f,f=m._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var I;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(I||(e.Platform=I={}));function t(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let c=0;D?c=1:N?c=3:A&&(c=2),e.$i=N,e.$j=D,e.$k=A,e.$l=O,e.$m=R,e.$n=$,e.$o=S,e.$p=S&&typeof e.$g.importScripts=="function",e.$q=C,e.$r=g,e.$s=p,e.$t=c,e.$u=o,e.$v=d;var s;(function(E){function m(){return e.$v}E.value=m;function a(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}E.isDefaultVariant=a;function v(){return e.$v==="en"}E.isDefault=v})(s||(e.Language=s={})),e.$w=u,e.$x=y,e.$y=f,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const E=[];e.$g.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let v=0,L=E.length;v<L;v++){const T=E[v];if(T.id===a.data.vscodeScheduleAsyncWork){E.splice(v,1),T.callback();return}}});let m=0;return a=>{const v=++m;E.push({id:v,callback:a}),e.$g.postMessage({vscodeScheduleAsyncWork:v},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=D||C?2:N?1:3;let i=!0,r=!1;function l(){if(!r){r=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,i=new Uint16Array(E.buffer)[0]===(2<<8)+1}return i}e.$C=l,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(re[37],oe([0,1,6]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.$2d=e.env=e.cwd=void 0;let N;if(typeof j.$g.vscode<"u"&&typeof j.$g.vscode.process<"u"){const D=j.$g.vscode.process;N={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return j.$i?"win32":j.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$2d=N.platform,e.$3d=N.arch}),define(re[15],oe([0,1,37]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.sep=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;const N=65,D=97,A=90,O=122,R=46,S=47,$=92,C=58,p=63;class g extends Error{constructor(c,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const r=c.indexOf(".")!==-1?"property":"argument";let l=`The "${c}" ${r} ${i} of type ${s}`;l+=`. Received type ${typeof n}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,c){if(t===null||typeof t!="object")throw new g(c,"Object",t)}function d(t,c){if(typeof t!="string")throw new g(c,"string",t)}const y=j.$2d==="win32";function f(t){return t===S||t===$}function o(t){return t===S}function h(t){return t>=N&&t<=A||t>=D&&t<=O}function b(t,c,s,n){let i="",r=0,l=-1,E=0,m=0;for(let a=0;a<=t.length;++a){if(a<t.length)m=t.charCodeAt(a);else{if(n(m))break;m=S}if(n(m)){if(!(l===a-1||E===1))if(E===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==R||i.charCodeAt(i.length-2)!==R){if(i.length>2){const v=i.lastIndexOf(s);v===-1?(i="",r=0):(i=i.slice(0,v),r=i.length-1-i.lastIndexOf(s)),l=a,E=0;continue}else if(i.length!==0){i="",r=0,l=a,E=0;continue}}c&&(i+=i.length>0?`${s}..`:"..",r=2)}else i.length>0?i+=`${s}${t.slice(l+1,a)}`:i=t.slice(l+1,a),r=a-l-1;l=a,E=0}else m===R&&E!==-1?++E:E=-1}return i}function w(t,c){u(c,"pathObject");const s=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return s?s===c.root?`${s}${n}`:`${s}${t}${n}`:n}e.$4d={resolve(...t){let c="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],d(r,"path"),r.length===0)continue}else c.length===0?r=j.cwd():(r=j.env[`=${c}`]||j.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===$)&&(r=`${c}\\`));const l=r.length;let E=0,m="",a=!1;const v=r.charCodeAt(0);if(l===1)f(v)&&(E=1,a=!0);else if(f(v))if(a=!0,f(r.charCodeAt(1))){let L=2,T=L;for(;L<l&&!f(r.charCodeAt(L));)L++;if(L<l&&L!==T){const z=r.slice(T,L);for(T=L;L<l&&f(r.charCodeAt(L));)L++;if(L<l&&L!==T){for(T=L;L<l&&!f(r.charCodeAt(L));)L++;(L===l||L!==T)&&(m=`\\\\${z}\\${r.slice(T,L)}`,E=L)}}}else E=1;else h(v)&&r.charCodeAt(1)===C&&(m=r.slice(0,2),E=2,l>2&&f(r.charCodeAt(2))&&(a=!0,E=3));if(m.length>0)if(c.length>0){if(m.toLowerCase()!==c.toLowerCase())continue}else c=m;if(n){if(c.length>0)break}else if(s=`${r.slice(E)}\\${s}`,n=a,a&&c.length>0)break}return s=b(s,!n,"\\",f),n?`${c}\\${s}`:`${c}${s}`||"."},normalize(t){d(t,"path");const c=t.length;if(c===0)return".";let s=0,n,i=!1;const r=t.charCodeAt(0);if(c===1)return o(r)?"\\":t;if(f(r))if(i=!0,f(t.charCodeAt(1))){let E=2,m=E;for(;E<c&&!f(t.charCodeAt(E));)E++;if(E<c&&E!==m){const a=t.slice(m,E);for(m=E;E<c&&f(t.charCodeAt(E));)E++;if(E<c&&E!==m){for(m=E;E<c&&!f(t.charCodeAt(E));)E++;if(E===c)return`\\\\${a}\\${t.slice(m)}\\`;E!==m&&(n=`\\\\${a}\\${t.slice(m,E)}`,s=E)}}}else s=1;else h(r)&&t.charCodeAt(1)===C&&(n=t.slice(0,2),s=2,c>2&&f(t.charCodeAt(2))&&(i=!0,s=3));let l=s<c?b(t.slice(s),!i,"\\",f):"";return l.length===0&&!i&&(l="."),l.length>0&&f(t.charCodeAt(c-1))&&(l+="\\"),n===void 0?i?`\\${l}`:l:i?`${n}\\${l}`:`${n}${l}`},isAbsolute(t){d(t,"path");const c=t.length;if(c===0)return!1;const s=t.charCodeAt(0);return f(s)||c>2&&h(s)&&t.charCodeAt(1)===C&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,s;for(let r=0;r<t.length;++r){const l=t[r];d(l,"path"),l.length>0&&(c===void 0?c=s=l:c+=`\\${l}`)}if(c===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++i;const r=s.length;r>1&&f(s.charCodeAt(1))&&(++i,r>2&&(f(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<c.length&&f(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.$4d.normalize(c)},relative(t,c){if(d(t,"from"),d(c,"to"),t===c)return"";const s=e.$4d.resolve(t),n=e.$4d.resolve(c);if(s===n||(t=s.toLowerCase(),c=n.toLowerCase(),t===c))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===$;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===$;)r--;const l=r-i;let E=0;for(;E<c.length&&c.charCodeAt(E)===$;)E++;let m=c.length;for(;m-1>E&&c.charCodeAt(m-1)===$;)m--;const a=m-E,v=l<a?l:a;let L=-1,T=0;for(;T<v;T++){const U=t.charCodeAt(i+T);if(U!==c.charCodeAt(E+T))break;U===$&&(L=T)}if(T!==v){if(L===-1)return n}else{if(a>v){if(c.charCodeAt(E+T)===$)return n.slice(E+T+1);if(T===2)return n.slice(E+T)}l>v&&(t.charCodeAt(i+T)===$?L=T:T===2&&(L=3)),L===-1&&(L=0)}let z="";for(T=i+L+1;T<=r;++T)(T===r||t.charCodeAt(T)===$)&&(z+=z.length===0?"..":"\\..");return E+=L,z.length>0?`${z}${n.slice(E,m)}`:(n.charCodeAt(E)===$&&++E,n.slice(E,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$4d.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===$){if(c.charCodeAt(1)===$){const s=c.charCodeAt(2);if(s!==p&&s!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(h(c.charCodeAt(0))&&c.charCodeAt(1)===C&&c.charCodeAt(2)===$)return`\\\\?\\${c}`;return t},dirname(t){d(t,"path");const c=t.length;if(c===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(c===1)return f(i)?t:".";if(f(i)){if(s=n=1,f(t.charCodeAt(1))){let E=2,m=E;for(;E<c&&!f(t.charCodeAt(E));)E++;if(E<c&&E!==m){for(m=E;E<c&&f(t.charCodeAt(E));)E++;if(E<c&&E!==m){for(m=E;E<c&&!f(t.charCodeAt(E));)E++;if(E===c)return t;E!==m&&(s=n=E+1)}}}}else h(i)&&t.charCodeAt(1)===C&&(s=c>2&&f(t.charCodeAt(2))?3:2,n=s);let r=-1,l=!0;for(let E=c-1;E>=n;--E)if(f(t.charCodeAt(E))){if(!l){r=E;break}}else l=!1;if(r===-1){if(s===-1)return".";r=s}return t.slice(0,r)},basename(t,c){c!==void 0&&d(c,"ext"),d(t,"path");let s=0,n=-1,i=!0,r;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(s=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let l=c.length-1,E=-1;for(r=t.length-1;r>=s;--r){const m=t.charCodeAt(r);if(f(m)){if(!i){s=r+1;break}}else E===-1&&(i=!1,E=r+1),l>=0&&(m===c.charCodeAt(l)?--l===-1&&(n=r):(l=-1,n=E))}return s===n?n=E:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=s;--r)if(f(t.charCodeAt(r))){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){d(t,"path");let c=0,s=-1,n=0,i=-1,r=!0,l=0;t.length>=2&&t.charCodeAt(1)===C&&h(t.charCodeAt(0))&&(c=n=2);for(let E=t.length-1;E>=c;--E){const m=t.charCodeAt(E);if(f(m)){if(!r){n=E+1;break}continue}i===-1&&(r=!1,i=E+1),m===R?s===-1?s=E:l!==1&&(l=1):s!==-1&&(l=-1)}return s===-1||i===-1||l===0||l===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:w.bind(null,"\\"),parse(t){d(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return f(i)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(f(i)){if(n=1,f(t.charCodeAt(1))){let L=2,T=L;for(;L<s&&!f(t.charCodeAt(L));)L++;if(L<s&&L!==T){for(T=L;L<s&&f(t.charCodeAt(L));)L++;if(L<s&&L!==T){for(T=L;L<s&&!f(t.charCodeAt(L));)L++;L===s?n=L:L!==T&&(n=L+1)}}}}else if(h(i)&&t.charCodeAt(1)===C){if(s<=2)return c.root=c.dir=t,c;if(n=2,f(t.charCodeAt(2))){if(s===3)return c.root=c.dir=t,c;n=3}}n>0&&(c.root=t.slice(0,n));let r=-1,l=n,E=-1,m=!0,a=t.length-1,v=0;for(;a>=n;--a){if(i=t.charCodeAt(a),f(i)){if(!m){l=a+1;break}continue}E===-1&&(m=!1,E=a+1),i===R?r===-1?r=a:v!==1&&(v=1):r!==-1&&(v=-1)}return E!==-1&&(r===-1||v===0||v===1&&r===E-1&&r===l+1?c.base=c.name=t.slice(l,E):(c.name=t.slice(l,r),c.base=t.slice(l,E),c.ext=t.slice(r,E))),l>0&&l!==n?c.dir=t.slice(0,l-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(y){const t=/\\/g;return()=>{const c=j.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>j.cwd()})();e.$5d={resolve(...t){let c="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:I();d(i,"path"),i.length!==0&&(c=`${i}/${c}`,s=i.charCodeAt(0)===S)}return c=b(c,!s,"/",o),s?`/${c}`:c.length>0?c:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===S,s=t.charCodeAt(t.length-1)===S;return t=b(t,!c,"/",o),t.length===0?c?"/":s?"./":".":(s&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let c;for(let s=0;s<t.length;++s){const n=t[s];d(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.$5d.normalize(c)},relative(t,c){if(d(t,"from"),d(c,"to"),t===c||(t=e.$5d.resolve(t),c=e.$5d.resolve(c),t===c))return"";const s=1,n=t.length,i=n-s,r=1,l=c.length-r,E=i<l?i:l;let m=-1,a=0;for(;a<E;a++){const L=t.charCodeAt(s+a);if(L!==c.charCodeAt(r+a))break;L===S&&(m=a)}if(a===E)if(l>E){if(c.charCodeAt(r+a)===S)return c.slice(r+a+1);if(a===0)return c.slice(r+a)}else i>E&&(t.charCodeAt(s+a)===S?m=a:a===0&&(m=0));let v="";for(a=s+m+1;a<=n;++a)(a===n||t.charCodeAt(a)===S)&&(v+=v.length===0?"..":"/..");return`${v}${c.slice(r+m)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===S;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===S){if(!n){s=i;break}}else n=!1;return s===-1?c?"/":".":c&&s===1?"//":t.slice(0,s)},basename(t,c){c!==void 0&&d(c,"ext"),d(t,"path");let s=0,n=-1,i=!0,r;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let l=c.length-1,E=-1;for(r=t.length-1;r>=0;--r){const m=t.charCodeAt(r);if(m===S){if(!i){s=r+1;break}}else E===-1&&(i=!1,E=r+1),l>=0&&(m===c.charCodeAt(l)?--l===-1&&(n=r):(l=-1,n=E))}return s===n?n=E:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===S){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){d(t,"path");let c=-1,s=0,n=-1,i=!0,r=0;for(let l=t.length-1;l>=0;--l){const E=t.charCodeAt(l);if(E===S){if(!i){s=l+1;break}continue}n===-1&&(i=!1,n=l+1),E===R?c===-1?c=l:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||n===-1||r===0||r===1&&c===n-1&&c===s+1?"":t.slice(c,n)},format:w.bind(null,"/"),parse(t){d(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const s=t.charCodeAt(0)===S;let n;s?(c.root="/",n=1):n=0;let i=-1,r=0,l=-1,E=!0,m=t.length-1,a=0;for(;m>=n;--m){const v=t.charCodeAt(m);if(v===S){if(!E){r=m+1;break}continue}l===-1&&(E=!1,l=m+1),v===R?i===-1?i=m:a!==1&&(a=1):i!==-1&&(a=-1)}if(l!==-1){const v=r===0&&s?1:r;i===-1||a===0||a===1&&i===l-1&&i===r+1?c.base=c.name=t.slice(v,l):(c.name=t.slice(v,i),c.base=t.slice(v,l),c.ext=t.slice(i,l))}return r>0?c.dir=t.slice(0,r-1):s&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$5d.win32=e.$4d.win32=e.$4d,e.$5d.posix=e.$4d.posix=e.$5d,e.$6d=y?e.$4d.normalize:e.$5d.normalize,e.$7d=y?e.$4d.isAbsolute:e.$5d.isAbsolute,e.$8d=y?e.$4d.join:e.$5d.join,e.$9d=y?e.$4d.resolve:e.$5d.resolve,e.$0d=y?e.$4d.relative:e.$5d.relative,e.$$d=y?e.$4d.dirname:e.$5d.dirname,e.$_d=y?e.$4d.basename:e.$5d.basename,e.$ae=y?e.$4d.extname:e.$5d.extname,e.$be=y?e.$4d.format:e.$5d.format,e.$ce=y?e.$4d.parse:e.$5d.parse,e.$de=y?e.$4d.toNamespacedPath:e.$5d.toNamespacedPath,e.sep=y?e.$4d.sep:e.$5d.sep,e.$fe=y?e.$4d.delimiter:e.$5d.delimiter}),define(re[48],oe([0,1,15,6,28,9]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function O(r){return r===47||r===92}e.$Af=O;function R(r){return r.replace(/[\\/]/g,j.$5d.sep)}e.$Bf=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Cf=S;function $(r,l=j.$5d.sep){if(!r)return"";const E=r.length,m=r.charCodeAt(0);if(O(m)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let v=3;const L=v;for(;v<E&&!O(r.charCodeAt(v));v++);if(L!==v&&!O(r.charCodeAt(v+1))){for(v+=1;v<E;v++)if(O(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,l)}}return l}else if(o(m)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let a=r.indexOf("://");if(a!==-1){for(a+=3;a<E;a++)if(O(r.charCodeAt(a)))return r.slice(0,a+1)}return""}e.$Df=$;function C(r){if(!N.$i||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let E=2;const m=E;for(;E<r.length&&(l=r.charCodeAt(E),l!==92);E++);return!(m===E||(l=r.charCodeAt(E+1),isNaN(l)||l===92))}e.$Ef=C;const p=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,l=N.$i){const E=l?p:g;return!(!r||r.length===0||/^\s+$/.test(r)||(E.lastIndex=0,E.test(r))||l&&u.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.$Ff=d;function y(r,l,E){const m=r===l;return!E||m?m:!r||!l?!1:(0,D.$Le)(r,l)}e.$Gf=y;function f(r,l,E,m=j.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(E){if(!(0,D.$Me)(r,l))return!1;if(l.length===r.length)return!0;let v=l.length;return l.charAt(l.length-1)===m&&v--,r.charAt(v)===m}return l.charAt(l.length-1)!==m&&(l+=m),r.indexOf(l)===0}e.$Hf=f;function o(r){return r>=65&&r<=90||r>=97&&r<=122}e.$If=o;function h(r,l){return N.$i&&r.endsWith(":")&&(r+=j.sep),(0,j.$7d)(r)||(r=(0,j.$8d)(l,r)),r=(0,j.$6d)(r),N.$i?(r=(0,D.$ue)(r,j.sep),r.endsWith(":")&&(r+=j.sep)):(r=(0,D.$ue)(r,j.sep),r||(r=j.sep)),r}e.$Jf=h;function b(r){const l=(0,j.$6d)(r);return N.$i?r.length>3?!1:w(l)&&(r.length===2||l.charCodeAt(2)===92):l===j.$5d.sep}e.$Kf=b;function w(r,l=N.$i){return l?o(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Lf=w;function I(r,l=N.$i){return w(r,l)?r[0]:void 0}e.$Mf=I;function t(r,l,E){return l.length>r.length?-1:r===l?0:(E&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.$Nf=t;function c(r){const l=r.split(":");let E,m,a;for(const v of l){const L=Number(v);(0,A.$mf)(L)?m===void 0?m=L:a===void 0&&(a=L):E=E?[E,v].join(":"):v}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:m!==void 0?m:void 0,column:a!==void 0?a:m!==void 0?1:void 0}}e.$Of=c;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,l,E=8){let m="";for(let v=0;v<E;v++){let L;v===0&&N.$i&&!l&&(E===3||E===4)?L=n:L=s,m+=L.charAt(Math.floor(Math.random()*L.length))}let a;return l?a=`${l}-${m}`:a=m,r?(0,j.$8d)(r,a):a}e.$Pf=i}),define(re[141],oe([0,1,15]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=e.$Fr=void 0,e.$Fr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const p=(0,j.$ae)(C),g=N[p.toLowerCase()];return g!==void 0?g:O(C)}e.$Gr=A;function O(C){const p=(0,j.$ae)(C);return D[p.toLowerCase()]}e.$Hr=O;function R(C){for(const p in D)if(D[p]===C)return p}e.$Ir=R;const S=/^(.+)\/(.+?)(;.+)?$/;function $(C,p){const g=S.exec(C);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:p?void 0:C}e.$Jr=$}),define(re[90],oe([0,1,6]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.TerminateResponseCode=e.Source=void 0;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function A(R,...S){const $=S.reduce((g,u)=>(g[u]=!0,g),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!$[g]).forEach(g=>{for(let u=0;u<C.length;u++)if(g.search(C[u])!==-1){delete R[g];break}})}e.$rl=A;function O(R){R&&(delete R.DEBUG,j.$j&&delete R.DYLD_LIBRARY_PATH,j.$k&&delete R.LD_PRELOAD)}e.$sl=O}),define(re[11],oe([0,1,15,6]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function R(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,i){return!n&&!i?"file":n}function $(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==p&&(i=p+i):i=p;break}return i}const C="",p="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(i){return i instanceof u?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,l,E,m,a=!1){typeof i=="object"?(this.scheme=i.scheme||C,this.authority=i.authority||C,this.path=i.path||C,this.query=i.query||C,this.fragment=i.fragment||C):(this.scheme=S(i,a),this.authority=r||C,this.path=$(this.scheme,l||C),this.query=E||C,this.fragment=m||C,R(this,a))}get fsPath(){return w(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:l,path:E,query:m,fragment:a}=i;return r===void 0?r=this.scheme:r===null&&(r=C),l===void 0?l=this.authority:l===null&&(l=C),E===void 0?E=this.path:E===null&&(E=C),m===void 0?m=this.query:m===null&&(m=C),a===void 0?a=this.fragment:a===null&&(a=C),r===this.scheme&&l===this.authority&&E===this.path&&m===this.query&&a===this.fragment?this:new f(r,l,E,m,a)}static parse(i,r=!1){const l=g.exec(i);return l?new f(l[2]||C,s(l[4]||C),s(l[5]||C),s(l[7]||C),s(l[9]||C),r):new f(C,C,C,C,C)}static file(i){let r=C;if(N.$i&&(i=i.replace(/\\/g,p)),i[0]===p&&i[1]===p){const l=i.indexOf(p,2);l===-1?(r=i.substring(2),i=p):(r=i.substring(2,l),i=i.substring(l)||p)}return new f("file",r,i,C,C)}static from(i,r){return new f(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return N.$i&&i.scheme==="file"?l=u.file(j.$4d.join(w(i,!0),...r)).path:l=j.$5d.join(i.path,...r),i.with({path:l})}toString(i=!1){return I(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof u)return i;{const r=new f(i);return r._formatted=i.external??null,r._fsPath=i._sep===y?i.fsPath??null:null,r}}else return i}}e.URI=u;function d(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Rf=d;const y=N.$i?1:void 0;class f extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(i=!1){return i?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=y),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(n,i,r){let l,E=-1;for(let m=0;m<n.length;m++){const a=n.charCodeAt(m);if(a>=97&&a<=122||a>=65&&a<=90||a>=48&&a<=57||a===45||a===46||a===95||a===126||i&&a===47||r&&a===91||r&&a===93||r&&a===58)E!==-1&&(l+=encodeURIComponent(n.substring(E,m)),E=-1),l!==void 0&&(l+=n.charAt(m));else{l===void 0&&(l=n.substr(0,m));const v=o[a];v!==void 0?(E!==-1&&(l+=encodeURIComponent(n.substring(E,m)),E=-1),l+=v):E===-1&&(E=m)}}return E!==-1&&(l+=encodeURIComponent(n.substring(E))),l!==void 0?l:n}function b(n){let i;for(let r=0;r<n.length;r++){const l=n.charCodeAt(r);l===35||l===63?(i===void 0&&(i=n.substr(0,r)),i+=o[l]):i!==void 0&&(i+=n[r])}return i!==void 0?i:n}function w(n,i){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$Sf=w;function I(n,i){const r=i?b:h;let l="",{scheme:E,authority:m,path:a,query:v,fragment:L}=n;if(E&&(l+=E,l+=":"),(m||E==="file")&&(l+=p,l+=p),m){let T=m.indexOf("@");if(T!==-1){const z=m.substr(0,T);m=m.substr(T+1),T=z.lastIndexOf(":"),T===-1?l+=r(z,!1,!1):(l+=r(z.substr(0,T),!1,!1),l+=":",l+=r(z.substr(T+1),!1,!0)),l+="@"}m=m.toLowerCase(),T=m.lastIndexOf(":"),T===-1?l+=r(m,!1,!0):(l+=r(m.substr(0,T),!1,!0),l+=m.substr(T))}if(a){if(a.length>=3&&a.charCodeAt(0)===47&&a.charCodeAt(2)===58){const T=a.charCodeAt(1);T>=65&&T<=90&&(a=`/${String.fromCharCode(T+32)}:${a.substr(3)}`)}else if(a.length>=2&&a.charCodeAt(1)===58){const T=a.charCodeAt(0);T>=65&&T<=90&&(a=`${String.fromCharCode(T+32)}:${a.substr(2)}`)}l+=r(a,!0,!1)}return v&&(l+="?",l+=r(v,!1,!1)),L&&(l+="#",l+=i?L:h(L,!1,!1)),l}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(c)?n.replace(c,i=>t(i)):n}}),define(re[142],oe([0,1,11]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Np=e.$Mp=e.$Lp=void 0;function N($){const C=$;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Lp=N;function D($){const C=[];let p;try{const g=JSON.parse($.arguments),u=g[g.length-1];u&&u.__$stack&&(g.pop(),p=u.__$stack),C.push(...g)}catch{C.push("Unable to log remote console arguments",$.arguments)}return{args:C,stack:p}}e.$Mp=D;function A($){if(typeof $!="string")return A(D($).stack);const C=$;if(C){const p=O(C),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(g&&g.length===4)return{uri:j.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$Np=A;function O($){if(!$)return $;const C=$.indexOf(`
`);return C===-1?$:$.substring(0,C)}function R($,C){const{args:p,stack:g}=D($),u=typeof p[0]=="string"&&p.length===1;let d=O(g);d&&(d=`(${d.trim()})`);let y=[];if(typeof p[0]=="string"?d&&u?y=[`%c[${C}] %c${p[0]} %c${d}`,S("blue"),S(""),S("grey")]:y=[`%c[${C}] %c${p[0]}`,S("blue"),S(""),...p.slice(1)]:y=[`%c[${C}]%`,S("blue"),...p],d&&!u&&y.push(d),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,y)}e.log=R;function S($){return`color: ${$}`}}),define(re[63],oe([0,1,14,11]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function D(S){return JSON.stringify(S,O)}e.$8g=D;function A(S){let $=JSON.parse(S);return $=R($),$}e.$9g=A;function O(S,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function R(S,$=0){if(!S||$>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return N.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof j.$Ed||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=R(S[C],$+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=R(S[C],$+1))}return S}e.$0g=R}),define(re[23],oe([0,1,8,6,11]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var A;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${A.vscodeRemoteResource}`}set(C,p,g){this.a[C]=p,this.b[C]=g}setConnectionToken(C,p){this.c[C]=p}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(f){return j.$Y(f),C}const p=C.authority;let g=this.a[p];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const u=this.b[p],d=this.c[p];let y=`path=${encodeURIComponent(C.path)}`;return typeof d=="string"&&(y+=`&${e.$Uf}=${encodeURIComponent(d)}`),D.URI.from({scheme:N.$o?this.d:A.vscodeRemoteResource,authority:`${g}:${u}`,path:this.f,query:y})}}e.$Vf=new O,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class R{static{this.a="vscode-app"}asBrowserUri(C){const p=this.b(C,te);return this.uriToBrowserUri(p)}uriToBrowserUri(C){return C.scheme===A.vscodeRemote?e.$Vf.rewrite(C):C.scheme===A.file&&(N.$m||N.$p&&N.$g.origin===`${A.vscodeFileResource}://${R.a}`)?C.with({scheme:A.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const p=this.b(C,te);return this.uriToFileUri(p)}uriToFileUri(C){return C.scheme===A.vscodeFileResource?C.with({scheme:A.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,p){return D.URI.isUri(C)?C:D.URI.parse(p.toUrl(C))}}e.$1f=new R;var S;(function($){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(C.get("3"));const p="vscode-coi";function g(d){let y;typeof d=="string"?y=new URL(d).searchParams:d instanceof URL?y=d.searchParams:D.URI.isUri(d)&&(y=new URL(d.toString(!0)).searchParams);const f=y?.get(p);if(f)return C.get(f)}$.getHeadersFromQuery=g;function u(d,y,f){if(!globalThis.crossOriginIsolated)return;const o=y&&f?"3":f?"2":"1";d instanceof URLSearchParams?d.set(p,o):d[p]=o}$.addSearchParam=u})(S||(e.COI=S={}))}),define(re[143],oe([0,1,124,23,6,11]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0C=void 0;class O{constructor(g,u,d){this.id=g,this.dependencies=u,this.callback=d}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,u,d)=>{typeof g!="string"&&(d=u,u=g,g=null),(typeof u!="object"||!Array.isArray(u))&&(d=u,u=null),this.c.push(new O(g,u,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const u=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!u)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(g){return new Promise((u,d)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const f=()=>{y.removeEventListener("load",o),y.removeEventListener("error",h)},o=b=>{f(),u(this.c.pop())},h=b=>{f(),d(b)};y.addEventListener("load",o),y.addEventListener("error",h),this.f&&(g=this.f.createScriptURL(g)),y.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(y)})}i(g){return new Promise((u,d)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),u(this.c.pop())}catch(y){d(y)}})}async j(g){try{const u=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,f=A.URI.parse(g).fsPath,o=u.readFileSync(f).toString(),h=y.wrap(o.replace(/^#!.*/,""));return new d.Script(h).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const S=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function C(p,g,u){if(j.$R){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[p]&&(p=$[p]);const d=`${p}/${g}`;if(S.has(d))return S.get(d);let y;if(/^\w[\w\d+.-]*:\/\//.test(d))y=d;else{const b=`${u&&!D.$o?N.$Yf:N.$Xf}/${d}`;y=N.$1f.asBrowserUri(b).toString(!0)}const f=R.INSTANCE.load(y);return S.set(d,f),f}else return await new Promise((d,y)=>{te([p],d,y)})}e.$0C=C}),define(re[22],oe([0,1,48,23,15,6,28,11]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function S(u){return(0,R.$Sf)(u,!0)}e.$8f=S;class ${constructor(d){this.a=d}compare(d,y,f=!1){return d===y?0:(0,O.$Ee)(this.getComparisonKey(d,f),this.getComparisonKey(y,f))}isEqual(d,y,f=!1){return d===y?!0:!d||!y?!1:this.getComparisonKey(d,f)===this.getComparisonKey(y,f)}getComparisonKey(d,y=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,y,f=!1){if(d.scheme===y.scheme){if(d.scheme===N.Schemas.file)return j.$Hf(S(d),S(y),this.a(d))&&d.query===y.query&&(f||d.fragment===y.fragment);if((0,e.$mg)(d.authority,y.authority))return j.$Hf(d.path,y.path,this.a(d),"/")&&d.query===y.query&&(f||d.fragment===y.fragment)}return!1}joinPath(d,...y){return R.URI.joinPath(d,...y)}basenameOrAuthority(d){return(0,e.$eg)(d)||d.authority}basename(d){return D.$5d.basename(d.path)}extname(d){return D.$5d.extname(d.path)}dirname(d){if(d.path.length===0)return d;let y;return d.scheme===N.Schemas.file?y=R.URI.file(D.$$d(S(d))).path:(y=D.$5d.dirname(d.path),d.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),y="/")),d.with({path:y})}normalizePath(d){if(!d.path.length)return d;let y;return d.scheme===N.Schemas.file?y=R.URI.file(D.$6d(S(d))).path:y=D.$5d.normalize(d.path),d.with({path:y})}relativePath(d,y){if(d.scheme!==y.scheme||!(0,e.$mg)(d.authority,y.authority))return;if(d.scheme===N.Schemas.file){const h=D.$0d(S(d),S(y));return A.$i?j.$Bf(h):h}let f=d.path||"/";const o=y.path||"/";if(this.a(d)){let h=0;for(const b=Math.min(f.length,o.length);h<b&&!(f.charCodeAt(h)!==o.charCodeAt(h)&&f.charAt(h).toLowerCase()!==o.charAt(h).toLowerCase());h++);f=o.substr(0,h)+f.substr(h)}return D.$5d.relative(f,o)}resolvePath(d,y){if(d.scheme===N.Schemas.file){const f=R.URI.file(D.$9d(S(d),y));return d.with({authority:f.authority,path:f.path})}return y=j.$Cf(y),d.with({path:D.$5d.resolve(d.path,y)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,y){return d===y||d!==void 0&&y!==void 0&&(0,O.$Le)(d,y)}hasTrailingPathSeparator(d,y=D.sep){if(d.scheme===N.Schemas.file){const f=S(d);return f.length>j.$Df(f).length&&f[f.length-1]===y}else{const f=d.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,y=D.sep){return(0,e.$ng)(d,y)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,y=D.sep){let f=!1;if(d.scheme===N.Schemas.file){const o=S(d);f=o!==void 0&&o.length===j.$Df(o).length&&o[o.length-1]===y}else{y="/";const o=d.path;f=o.length===1&&o.charCodeAt(o.length-1)===47}return!f&&!(0,e.$ng)(d,y)?d.with({path:d.path+"/"}):d}}e.$9f=$,e.$0f=new $(()=>!1),e.$$f=new $(u=>u.scheme===N.Schemas.file?!A.$k:!0),e.$_f=new $(u=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function C(u,d){const y=[];for(let f=0;f<u.length;f++){const o=d(u[f]);u.some((h,b)=>b===f?!1:(0,e.$bg)(o,d(h)))||y.push(u[f])}return y}e.$qg=C;var p;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function d(y){const f=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(b=>{const[w,I]=b.split(":");w&&I&&f.set(w,I)});const h=y.path.substring(0,y.path.indexOf(";"));return h&&f.set(u.META_DATA_MIME,h),f}u.parseMetaData=d})(p||(e.DataUri=p={}));function g(u,d,y){if(d){let f=u.path;return f&&f[0]!==D.$5d.sep&&(f=D.$5d.sep+f),u.with({scheme:y,authority:d,path:f})}return u.with({scheme:y})}e.$rg=g}),define(re[5],oe([0,1,26,8,3,2,22,6,130]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function $(k){return!!k&&typeof k.then=="function"}e.$sg=$;function C(k){const P=new j.$od,F=k(P.token),M=new Promise((K,_)=>{const ae=P.token.onCancellationRequested(()=>{ae.dispose(),P.dispose(),_(new N.$3)});Promise.resolve(F).then(he=>{ae.dispose(),P.dispose(),K(he)},he=>{ae.dispose(),P.dispose(),_(he)})});return new class{cancel(){P.cancel()}then(K,_){return M.then(K,_)}catch(K){return this.then(void 0,K)}finally(K){return M.finally(K)}}}e.$tg=C;function p(k,P,F){return new Promise((M,K)=>{const _=P.onCancellationRequested(()=>{_.dispose(),M(F)});k.then(M,K).finally(()=>_.dispose())})}e.$ug=p;function g(k,P){return new Promise((F,M)=>{const K=P.onCancellationRequested(()=>{K.dispose(),M(new N.$3)});k.then(F,M).finally(()=>K.dispose())})}e.$vg=g;async function u(k){let P=-1;const F=k.map((M,K)=>M.then(_=>(P=K,_)));try{return await Promise.race(F)}finally{k.forEach((M,K)=>{K!==P&&M.cancel()})}}e.$wg=u;function d(k,P,F){let M;const K=setTimeout(()=>{M?.(void 0),F?.()},P);return Promise.race([k.finally(()=>clearTimeout(K)),new Promise(_=>M=_)])}e.$xg=d;function y(k){return new Promise((P,F)=>{const M=k();$(M)?M.then(P,F):P(M)})}e.$yg=y;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(P){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=P,!this.b){const F=()=>{if(this.b=null,this.f)return;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(F,F).then(M)})}return new Promise((F,M)=>{this.b.then(F,M)})}return this.a=P(),new Promise((F,M)=>{this.a.then(K=>{this.a=null,F(K)},K=>{this.a=null,M(K)})})}dispose(){this.f=!0}}e.$zg=f;class o{constructor(){this.a=Promise.resolve(null)}queue(P){return this.a=this.a.then(()=>P(),()=>P())}}e.$Ag=o;class h{constructor(){this.a=new Map}queue(P,F){const K=(this.a.get(P)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(P)===K&&this.a.delete(P)});return this.a.set(P,K),K}}e.$Bg=h;const b=(k,P)=>{let F=!0;const M=setTimeout(()=>{F=!1,P()},k);return{isTriggered:()=>F,dispose:()=>{clearTimeout(M),F=!1}}},w=k=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,k())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};class I{constructor(P){this.defaultDelay=P,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(P,F=this.defaultDelay){this.g=P,this.h(),this.b||(this.b=new Promise((K,_)=>{this.d=K,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const K=this.g;return this.g=null,K()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=F===S.$bd?w(M):b(F,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=I;class t{constructor(P){this.a=new I(P),this.b=new f}trigger(P,F){return this.a.trigger(()=>this.b.queue(P),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=t;class c{constructor(){this.a=!1,this.b=new Promise((P,F)=>{this.d=P})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=c;class s extends c{constructor(P){super(),this.f=setTimeout(()=>this.open(),P)}open(){clearTimeout(this.f),super.open()}}e.$Fg=s;function n(k,P){return P?new Promise((F,M)=>{const K=setTimeout(()=>{_.dispose(),F()},k),_=P.onCancellationRequested(()=>{clearTimeout(K),_.dispose(),M(new N.$3)})}):C(F=>n(k,F))}e.$Gg=n;function i(k,P=0){const F=setTimeout(k,P);return(0,A.$hc)(()=>clearTimeout(F))}e.$Hg=i;function r(k){const P=[];let F=0;const M=k.length;function K(){return F<M?k[F++]():null}function _(ae){ae!=null&&P.push(ae);const he=K();return he?he.then(_):Promise.resolve(P)}return Promise.resolve(null).then(_)}e.$Ig=r;function l(k,P=M=>!!M,F=null){let M=0;const K=k.length,_=()=>{if(M>=K)return Promise.resolve(F);const ae=k[M++];return Promise.resolve(ae()).then(fe=>P(fe)?Promise.resolve(fe):_())};return _()}e.$Jg=l;function E(k,P=M=>!!M,F=null){if(k.length===0)return Promise.resolve(F);let M=k.length;const K=()=>{M=-1;for(const _ of k)_.cancel?.()};return new Promise((_,ae)=>{for(const he of k)he.then(fe=>{--M>=0&&P(fe)?(K(),_(fe)):M===0&&_(F)}).catch(fe=>{--M>=0&&(K(),ae(fe))})})}e.$Kg=E;class m{constructor(P){this.a=0,this.d=P,this.f=[],this.b=0,this.g=new D.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(P){return this.a++,new Promise((F,M)=>{this.f.push({factory:P,c:F,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const P=this.f.shift();this.b++;const F=P.factory();F.then(P.c,P.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=m;class a extends m{constructor(){super(1)}}e.$Mg=a;class v{constructor(){this.a=new X,this.b=0}queue(P){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,P())):this.a.run(this.b++,P())}}e.$Ng=v;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const P=new V;return this.b.add(P),P.p}g(){for(const[,P]of this.a)if(P.size>0)return!1;return!0}queueFor(P,F=O.$0f){const M=F.getComparisonKey(P);let K=this.a.get(M);if(!K){K=new a;const _=this.f++,ae=D.Event.once(K.onDrained)(()=>{K?.dispose(),this.a.delete(M),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$rc),this.d.set(_,ae),this.a.set(M,K)}return K}h(){this.g()&&this.j()}j(){for(const P of this.b)P.complete();this.b.clear()}dispose(){for(const[,P]of this.a)P.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=L;class T{constructor(P,F){this.a=-1,typeof P=="function"&&typeof F=="number"&&this.setIfNotSet(P,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(P,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,P()},F)}setIfNotSet(P,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,P()},F))}}e.$Pg=T;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(P,F){this.cancel(),this.a=setInterval(()=>{P()},F)}}e.$Qg=z;class U{constructor(P,F){this.b=-1,this.a=P,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(P=this.d){this.cancel(),this.b=setTimeout(this.f,P)}get delay(){return this.d}set delay(P){this.d=P}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=U;class B{constructor(P,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=P,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(P=this.b){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(P/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=B;class Q extends U{constructor(P,F){super(P,F),this.j=[]}work(P){this.j.push(P),this.isScheduled()||this.schedule()}h(){const P=this.j;this.j=[],this.a?.(P)}dispose(){this.j=[],super.dispose()}}e.$Tg=Q;class J extends A.$jc{constructor(P,F){super(),this.g=P,this.h=F,this.a=[],this.b=this.B(new A.$kc),this.f=!1}get pending(){return this.a.length}work(P){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+P.length>this.g.maxBufferedWork)return!1}else if(this.pending+P.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of P)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=k=>{(0,R.$A)(()=>{if(P)return;const F=Date.now()+15;k(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:e.$Vg=(k,P)=>{const F=requestIdleCallback(k,typeof P=="number"?{timeout:P}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(F))}}}}();class x{constructor(P){this.d=!1,this.a=()=>{try{this.f=P()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=x;async function H(k,P,F){let M;for(let K=0;K<F;K++)try{return await k()}catch(_){M=_,await n(P)}throw M}e.$Xg=H;class X{isRunning(P){return typeof P=="number"?this.a?.taskId===P:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(P,F,M){return this.a={taskId:P,cancel:()=>M?.(),promise:F},F.then(()=>this.d(P),()=>this.d(P)),F}d(P){this.a&&P===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const P=this.b;this.b=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}queue(P){if(this.b)this.b.run=P;else{let F,M;const K=new Promise((_,ae)=>{F=_,M=ae});this.b={run:P,promise:K,promiseResolve:F,promiseReject:M}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=X;class G{constructor(P,F=()=>Date.now()){this.d=P,this.f=F,this.a=0,this.b=0}increment(){const P=this.f();return P-this.a>this.d&&(this.a=P,this.b=0),this.b++,this.b}}e.$Zg=G;var W;(function(k){k[k.Resolved=0]="Resolved",k[k.Rejected=1]="Rejected"})(W||(W={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((P,F)=>{this.a=P,this.b=F})}complete(P){return new Promise(F=>{this.a(P),this.d={outcome:0,value:P},F()})}error(P){return new Promise(F=>{this.b(P),this.d={outcome:1,value:P},F()})}cancel(){return this.error(new N.$3)}}e.$1g=V;var ee;(function(k){async function P(M){let K;const _=await Promise.all(M.map(ae=>ae.then(he=>he,he=>{K||(K=he)})));if(typeof K<"u")throw K;return _}k.settled=P;function F(M){return new Promise(async(K,_)=>{try{await M(K,_)}catch(ae){_(ae)}})}k.withAsyncBody=F})(ee||(e.Promises=ee={}));var ne;(function(k){k[k.Initial=0]="Initial",k[k.DoneOK=1]="DoneOK",k[k.DoneError=2]="DoneError"})(ne||(ne={}));class se{static fromArray(P){return new se(F=>{F.emitMany(P)})}static fromPromise(P){return new se(async F=>{F.emitMany(await P)})}static fromPromises(P){return new se(async F=>{await Promise.all(P.map(async M=>F.emitOne(await M)))})}static merge(P){return new se(async F=>{await Promise.all(P.map(async M=>{for await(const K of M)F.emitOne(K)}))})}static{this.EMPTY=se.fromArray([])}constructor(P){this.a=0,this.b=[],this.d=null,this.f=new D.$ed,queueMicrotask(async()=>{const F={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(P(F)),this.j()}catch(M){this.k(M)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(P<this.b.length)return{done:!1,value:this.b[P++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(P,F){return new se(async M=>{for await(const K of P)M.emitOne(F(K))})}map(P){return se.map(this,P)}static filter(P,F){return new se(async M=>{for await(const K of P)F(K)&&M.emitOne(K)})}filter(P){return se.filter(this,P)}static coalesce(P){return se.filter(P,F=>!!F)}coalesce(){return se.coalesce(this)}static async toPromise(P){const F=[];for await(const M of P)F.push(M);return F}toPromise(){return se.toPromise(this)}g(P){this.a===0&&(this.b.push(P),this.f.fire())}h(P){this.a===0&&(this.b=this.b.concat(P),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(P){this.a===0&&(this.a=2,this.d=P,this.f.fire())}}e.$2g=se;class Z extends se{constructor(P,F){super(F),this.l=P}cancel(){this.l.cancel()}}e.$3g=Z;function q(k){const P=new j.$od,F=k(P.token);return new Z(P,async M=>{const K=P.token.onCancellationRequested(()=>{K.dispose(),P.dispose(),M.reject(new N.$3)});try{for await(const _ of F){if(P.token.isCancellationRequested)return;M.emitOne(_)}K.dispose(),P.dispose()}catch(_){K.dispose(),P.dispose(),M.reject(_)}})}e.$4g=q}),define(re[91],oe([0,1,18,5,48,35,15,6,28]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0;function $(){return Object.create(null)}e.$lj=$,e.$mj="**",e.$nj="/";const C="[/\\\\]",p="[^/\\\\]",g=/\//g;function u(X,G){switch(X){case 0:return"";case 1:return`${p}*?`;default:return`(?:${C}|${p}+${C}${G?`|${C}${p}+`:""})*?`}}function d(X,G){if(!X)return[];const W=[];let V=!1,ee=!1,ne="";for(const se of X){switch(se){case G:if(!V&&!ee){W.push(ne),ne="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=se}return ne&&W.push(ne),W}e.$oj=d;function y(X){if(!X)return"";let G="";const W=d(X,e.$nj);if(W.every(V=>V===e.$mj))G=".*";else{let V=!1;W.forEach((ee,ne)=>{if(ee===e.$mj){if(V)return;G+=u(2,ne===W.length-1)}else{let se=!1,Z="",q=!1,k="";for(const P of ee){if(P!=="}"&&se){Z+=P;continue}if(q&&(P!=="]"||!k)){let F;P==="-"?F=P:(P==="^"||P==="!")&&!k?F="^":P===e.$nj?F="":F=(0,S.$pe)(P),k+=F;continue}switch(P){case"{":se=!0;continue;case"[":q=!0;continue;case"}":{const M=`(?:${d(Z,",").map(K=>y(K)).join("|")})`;G+=M,se=!1,Z="";break}case"]":{G+="["+k+"]",q=!1,k="";break}case"?":G+=p;continue;case"*":G+=u(1);continue;default:G+=(0,S.$pe)(P)}}ne<W.length-1&&(W[ne+1]!==e.$mj||ne+2<W.length)&&(G+=C)}V=ee===e.$mj})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Bi(1e4),c=function(){return!1},s=function(){return null};function n(X,G){if(!X)return s;let W;typeof X!="string"?W=X.pattern:W=X,W=W.trim();const V=`${W}_${!!G.trimForExclusions}`;let ee=t.get(V);if(ee)return i(ee,X);let ne;return f.test(W)?ee=l(W.substr(4),W):(ne=o.exec(r(W,G)))?ee=E(ne[1],W):(G.trimForExclusions?b:h).test(W)?ee=m(W,G):(ne=w.exec(r(W,G)))?ee=a(ne[1].substr(1),W,!0):(ne=I.exec(r(W,G)))?ee=a(ne[1],W,!1):ee=v(W),t.set(V,ee),i(ee,X)}function i(X,G){if(typeof G=="string")return X;const W=function(V,ee){return(0,D.$Hf)(V,G.base,!R.$k)?X((0,S.$te)(V.substr(G.base.length),O.sep),ee):null};return W.allBasenames=X.allBasenames,W.allPaths=X.allPaths,W.basenames=X.basenames,W.patterns=X.patterns,W}function r(X,G){return G.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function l(X,G){return function(W,V){return typeof W=="string"&&W.endsWith(X)?G:null}}function E(X,G){const W=`/${X}`,V=`\\${X}`,ee=function(se,Z){return typeof se!="string"?null:Z?Z===X?G:null:se===X||se.endsWith(W)||se.endsWith(V)?G:null},ne=[X];return ee.basenames=ne,ee.patterns=[G],ee.allBasenames=ne,ee}function m(X,G){const W=x(X.slice(1,-1).split(",").map(Z=>n(Z,G)).filter(Z=>Z!==s),X),V=W.length;if(!V)return s;if(V===1)return W[0];const ee=function(Z,q){for(let k=0,P=W.length;k<P;k++)if(W[k](Z,q))return X;return null},ne=W.find(Z=>!!Z.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const se=W.reduce((Z,q)=>q.allPaths?Z.concat(q.allPaths):Z,[]);return se.length&&(ee.allPaths=se),ee}function a(X,G,W){const V=O.sep===O.$5d.sep,ee=V?X:X.replace(g,O.sep),ne=O.sep+ee,se=O.$5d.sep+X;let Z;return W?Z=function(q,k){return typeof q=="string"&&(q===ee||q.endsWith(ne)||!V&&(q===X||q.endsWith(se)))?G:null}:Z=function(q,k){return typeof q=="string"&&(q===ee||!V&&q===X)?G:null},Z.allPaths=[(W?"*/":"./")+X],Z}function v(X){try{const G=new RegExp(`^${y(X)}$`);return function(W){return G.lastIndex=0,typeof W=="string"&&G.test(W)?X:null}}catch{return s}}function L(X,G,W){return!X||typeof G!="string"?!1:T(X)(G,void 0,W)}e.$pj=L;function T(X,G={}){if(!X)return c;if(typeof X=="string"||z(X)){const W=n(X,G);if(W===s)return c;const V=function(ee,ne){return!!W(ee,ne)};return W.allBasenames&&(V.allBasenames=W.allBasenames),W.allPaths&&(V.allPaths=W.allPaths),V}return Q(X,G)}e.$qj=T;function z(X){const G=X;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$rj=z;function U(X){return X.allBasenames||[]}e.$sj=U;function B(X){return X.allPaths||[]}e.$tj=B;function Q(X,G){const W=x(Object.getOwnPropertyNames(X).map(Z=>J(Z,X[Z],G)).filter(Z=>Z!==s)),V=W.length;if(!V)return s;if(!W.some(Z=>!!Z.requiresSiblings)){if(V===1)return W[0];const Z=function(P,F){let M;for(let K=0,_=W.length;K<_;K++){const ae=W[K](P,F);if(typeof ae=="string")return ae;(0,N.$sg)(ae)&&(M||(M=[]),M.push(ae))}return M?(async()=>{for(const K of M){const _=await K;if(typeof _=="string")return _}return null})():null},q=W.find(P=>!!P.allBasenames);q&&(Z.allBasenames=q.allBasenames);const k=W.reduce((P,F)=>F.allPaths?P.concat(F.allPaths):P,[]);return k.length&&(Z.allPaths=k),Z}const ee=function(Z,q,k){let P,F;for(let M=0,K=W.length;M<K;M++){const _=W[M];_.requiresSiblings&&k&&(q||(q=(0,O.$_d)(Z)),P||(P=q.substr(0,q.length-(0,O.$ae)(Z).length)));const ae=_(Z,q,P,k);if(typeof ae=="string")return ae;(0,N.$sg)(ae)&&(F||(F=[]),F.push(ae))}return F?(async()=>{for(const M of F){const K=await M;if(typeof K=="string")return K}return null})():null},ne=W.find(Z=>!!Z.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const se=W.reduce((Z,q)=>q.allPaths?Z.concat(q.allPaths):Z,[]);return se.length&&(ee.allPaths=se),ee}function J(X,G,W){if(G===!1)return s;const V=n(X,W);if(V===s)return s;if(typeof G=="boolean")return V;if(G){const ee=G.when;if(typeof ee=="string"){const ne=(se,Z,q,k)=>{if(!k||!V(se,Z))return null;const P=ee.replace("$(basename)",()=>q),F=k(P);return(0,N.$sg)(F)?F.then(M=>M?X:null):F?X:null};return ne.requiresSiblings=!0,ne}}return V}function x(X,G){const W=X.filter(Z=>!!Z.basenames);if(W.length<2)return X;const V=W.reduce((Z,q)=>{const k=q.basenames;return k?Z.concat(k):Z},[]);let ee;if(G){ee=[];for(let Z=0,q=V.length;Z<q;Z++)ee.push(G)}else ee=W.reduce((Z,q)=>{const k=q.patterns;return k?Z.concat(k):Z},[]);const ne=function(Z,q){if(typeof Z!="string")return null;if(!q){let P;for(P=Z.length;P>0;P--){const F=Z.charCodeAt(P-1);if(F===47||F===92)break}q=Z.substr(P)}const k=V.indexOf(q);return k!==-1?ee[k]:null};ne.basenames=V,ne.patterns=ee,ne.allBasenames=V;const se=X.filter(Z=>!Z.basenames);return se.push(ne),se}function H(X,G){return(0,j.$sb)(X,G,(W,V)=>typeof W=="string"&&typeof V=="string"?W===V:typeof W!="string"&&typeof V!="string"?W.base===V.base&&W.pattern===V.pattern:!1)}e.$uj=H}),define(re[92],oe([0,1,14,11]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0;function D(p){return p.toJSON()}class A{constructor(g){this.a=g}transformIncoming(g){const u=this.a.transformIncoming(g);return u===g?g:D(N.URI.from(u))}transformOutgoing(g){const u=this.a.transformOutgoing(g);return u===g?g:D(N.URI.from(u))}transformOutgoingURI(g){const u=this.a.transformOutgoing(g);return u===g?g:N.URI.from(u)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.$Am=A,e.$Bm=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function O(p,g,u){if(!p||u>200)return null;if(typeof p=="object"){if(p instanceof N.URI)return g.transformOutgoing(p);for(const d in p)if(Object.hasOwnProperty.call(p,d)){const y=O(p[d],g,u+1);y!==null&&(p[d]=y)}}return null}function R(p,g){const u=O(p,g,0);return u===null?p:u}e.$Cm=R;function S(p,g,u,d){if(!p||d>200)return null;if(typeof p=="object"){if(p.$mid===1)return u?N.URI.revive(g.transformIncoming(p)):g.transformIncoming(p);if(p instanceof j.$Ed)return null;for(const y in p)if(Object.hasOwnProperty.call(p,y)){const f=S(p[y],g,u,d+1);f!==null&&(p[y]=f)}}return null}function $(p,g){const u=S(p,g,!1,0);return u===null?p:u}e.$Dm=$;function C(p,g){const u=S(p,g,!0,0);return u===null?p:u}e.$Em=C}),define(re[31],oe([0,1,52,36,269,5,48,88,15,6,22,11]),function(te,e,j,N,D,A,O,R,S,$,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function u(J,x=g.UNLINK,H){if((0,O.$Kf)(J))throw new Error("rimraf - will refuse to recursively delete root");return x===g.UNLINK?y(J):d(J,H)}async function d(J,x=(0,O.$Pf)((0,N.tmpdir)())){try{try{await j.promises.rename(J,x)}catch(H){return H.code==="ENOENT"?void 0:y(J)}y(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function y(J){return(0,D.promisify)(j.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function f(J){if((0,O.$Kf)(J))throw new Error("rimraf - will refuse to recursively delete root");j.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function o(J,x){return w(await(x?h(J):(0,D.promisify)(j.readdir)(J)))}async function h(J){try{return await(0,D.promisify)(j.readdir)(J,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const x=[],H=await o(J);for(const X of H){let G=!1,W=!1,V=!1;try{const ee=await e.Promises.lstat((0,S.$8d)(J,X));G=ee.isFile(),W=ee.isDirectory(),V=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}x.push({name:X,isFile:()=>G,isDirectory:()=>W,isSymbolicLink:()=>V})}return x}function b(J){return w(j.readdirSync(J))}e.readdirSync=b;function w(J){return J.map(x=>typeof x=="string"?$.$j?(0,R.$gl)(x):x:(x.name=$.$j?(0,R.$gl)(x.name):x.name,x))}async function I(J){const x=await o(J),H=[];for(const X of x)await c.existsDirectory((0,S.$8d)(J,X))&&H.push(X);return H}function t(J,x=1e3){return new Promise(H=>{let X=!1;const G=setInterval(()=>{X||(X=!0,j.access(J,W=>{X=!1,W&&(clearInterval(G),H(void 0))}))},x)})}e.whenDeleted=t;var c;(function(J){async function x(G){let W;try{if(W=await e.Promises.lstat(G),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if($.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ee}throw V}}J.stat=x;async function H(G){try{const{stat:W,symbolicLink:V}=await J.stat(G);return W.isFile()&&V?.dangling!==!0}catch{}return!1}J.existsFile=H;async function X(G){try{const{stat:W,symbolicLink:V}=await J.stat(G);return W.isDirectory()&&V?.dangling!==!0}catch{}return!1}J.existsDirectory=X})(c||(e.SymlinkSupport=c={}));const s=new A.$Og;function n(J,x,H){return s.queueFor(p.URI.file(J),C.$$f).queue(()=>{const X=m(H);return new Promise((G,W)=>l(J,x,X,V=>V?W(V):G()))})}let i=!0;function r(J){i=J}e.configureFlushOnWrite=r;function l(J,x,H,X){if(!i)return j.writeFile(J,x,{mode:H.mode,flag:H.flag},X);j.open(J,H.flag,H.mode,(G,W)=>{if(G)return X(G);j.writeFile(W,x,V=>{if(V)return j.close(W,()=>X(V));j.fdatasync(W,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),j.close(W,ne=>X(ne))))})})}function E(J,x,H){const X=m(H);if(!i)return j.writeFileSync(J,x,{mode:X.mode,flag:X.flag});const G=j.openSync(J,X.flag,X.mode);try{j.writeFileSync(G,x);try{j.fdatasyncSync(G)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{j.closeSync(G)}}e.writeFileSync=E;function m(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function a(J,x,H=6e4){if(J!==x)try{$.$i&&typeof H=="number"?await v(J,x,Date.now(),H):await(0,D.promisify)(j.rename)(J,x)}catch(X){if(J.toLowerCase()!==x.toLowerCase()&&X.code==="EXDEV"||J.endsWith("."))await L(J,x,{preserveSymlinks:!1}),await u(J,g.MOVE);else throw X}}async function v(J,x,H,X,G=0){try{return await(0,D.promisify)(j.rename)(J,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=X)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${W}`),W;if(G===0){let V=!1;try{const{stat:ee}=await c.stat(x);ee.isFile()||(V=!0)}catch{}if(V)throw W}return await(0,A.$Gg)(Math.min(100,G*10)),v(J,x,H,X,G+1)}}async function L(J,x,H){return z(J,x,{root:{source:J,target:x},options:H,handledSourcePaths:new Set})}const T=511;async function z(J,x,H){if(H.handledSourcePaths.has(J))return;H.handledSourcePaths.add(J);const{stat:X,symbolicLink:G}=await c.stat(J);if(G){if(H.options.preserveSymlinks)try{return await Q(J,x,H)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(G.dangling)return}return X.isDirectory()?U(J,x,X.mode&T,H):B(J,x,X.mode&T)}async function U(J,x,H,X){await e.Promises.mkdir(x,{recursive:!0,mode:H});const G=await o(J);for(const W of G)await z((0,S.$8d)(J,W),(0,S.$8d)(x,W),X)}async function B(J,x,H){await e.Promises.copyFile(J,x),await e.Promises.chmod(x,H)}async function Q(J,x,H){let X=await e.Promises.readlink(J);(0,O.$Hf)(X,H.root.source,!$.$k)&&(X=(0,S.$8d)(H.root.target,X.substr(H.root.source.length+1))),await e.Promises.symlink(X,x)}e.Promises=new class{get access(){return(0,D.promisify)(j.access)}get stat(){return(0,D.promisify)(j.stat)}get lstat(){return(0,D.promisify)(j.lstat)}get utimes(){return(0,D.promisify)(j.utimes)}get read(){return(J,x,H,X,G)=>new Promise((W,V)=>{j.read(J,x,H,X,G,(ee,ne,se)=>ee?V(ee):W({bytesRead:ne,buffer:se}))})}get readFile(){return(0,D.promisify)(j.readFile)}get write(){return(J,x,H,X,G)=>new Promise((W,V)=>{j.write(J,x,H,X,G,(ee,ne,se)=>ee?V(ee):W({bytesWritten:ne,buffer:se}))})}get appendFile(){return(0,D.promisify)(j.appendFile)}get fdatasync(){return(0,D.promisify)(j.fdatasync)}get truncate(){return(0,D.promisify)(j.truncate)}get copyFile(){return(0,D.promisify)(j.copyFile)}get open(){return(0,D.promisify)(j.open)}get close(){return(0,D.promisify)(j.close)}get symlink(){return(0,D.promisify)(j.symlink)}get readlink(){return(0,D.promisify)(j.readlink)}get chmod(){return(0,D.promisify)(j.chmod)}get mkdir(){return(0,D.promisify)(j.mkdir)}get unlink(){return(0,D.promisify)(j.unlink)}get rmdir(){return(0,D.promisify)(j.rmdir)}get realpath(){return(0,D.promisify)(j.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return I}get writeFile(){return n}get rm(){return u}get rename(){return a}get copy(){return L}}}),define(re[144],oe([0,1,52,15,6,28,31]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function R(g){if(D.$k)return g;const u=(0,N.$$d)(g);if(g===u)return g;const d=((0,N.$_d)(g)||g).toLowerCase();try{const f=(0,O.readdirSync)(u).filter(o=>o.toLowerCase()===d);if(f.length===1){const o=R(u);if(o)return(0,N.$8d)(o,f[0])}else if(f.length>1){const o=f.indexOf(d);if(o>=0){const h=R(u);if(h)return(0,N.$8d)(h,f[o])}}}catch{}return null}e.$Sp=R;async function S(g){if(D.$k)return g;const u=(0,N.$$d)(g);if(g===u)return g;const d=((0,N.$_d)(g)||g).toLowerCase();try{const f=(await O.Promises.readdir(u)).filter(o=>o.toLowerCase()===d);if(f.length===1){const o=await S(u);if(o)return(0,N.$8d)(o,f[0])}else if(f.length>1){const o=f.indexOf(d);if(o>=0){const h=await S(u);if(h)return(0,N.$8d)(h,f[o])}}}catch{}return null}e.$Tp=S;async function $(g){try{return await O.Promises.realpath(g)}catch{const d=p(g);return await O.Promises.access(d,j.constants.R_OK),d}}e.$Up=$;function C(g){try{return j.realpathSync(g)}catch{const d=p(g);return j.accessSync(d,j.constants.R_OK),d}}e.$Vp=C;function p(g){return(0,A.$ue)((0,N.$6d)(g),N.sep)}}),define(re[145],oe([0,1,15,6,37,90,9,31]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(p=D.env){return p.comspec||"cmd.exe"}e.$tl=S;function $(p){let g=[],u=!1;const d=function(y){if(u){g.push(y);return}(!p.send(y,o=>{if(o&&console.error(o),u=!1,g.length>0){const h=g.slice(0);g=[],h.forEach(b=>d(b))}})||N.$i)&&(u=!0)};return{send:d}}e.$ul=$;var C;(function(p){async function g(u,d,y){if(j.$7d(u))return u;if(d===void 0&&(d=D.cwd()),j.$$d(u)!=="."||(y===void 0&&O.$if(D.env.PATH)&&(y=D.env.PATH.split(j.$fe)),y===void 0||y.length===0))return j.$8d(d,u);async function o(h){if(await R.Promises.exists(h)){let b;try{b=await R.Promises.stat(h)}catch(w){w.message.startsWith("EACCES")&&(b=await R.Promises.lstat(h))}return b?!b.isDirectory():!1}return!1}for(const h of y){let b;if(j.$7d(h)?b=j.$8d(h,u):b=j.$8d(d,h,u),await o(b))return b;let w=b+".com";if(await o(w)||(w=b+".exe",await o(w)))return w}return j.$8d(d,u)}p.findExecutable=g})(C||(e.win32=C={}))}),define(re[146],oe([0,1,64,23]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;function D(O){return new Promise((R,S)=>{let $;const C=new Map;function p(u,d,y,f,o){const h=C.get(d);if(u===O||h){const b={name:g(y),cmd:y,pid:u,ppid:d,load:f,mem:o};C.set(u,b),u===O&&($=b),h&&(h.children||(h.children=[]),h.children.push(b),h.children.length>1&&(h.children=h.children.sort((w,I)=>w.pid-I.pid)))}}function g(u){const d=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,f=/--crashes-directory/i,o=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,b=/--type=([a-zA-Z-]+)/;if(f.exec(u))return"electron-crash-reporter";if(o.exec(u))return"winpty-agent";if(h.exec(u))return"conpty-agent";let w=b.exec(u);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?d.exec(u)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const I=/[a-zA-Z-]+\.js/g;let t="";do w=I.exec(u),w&&(t+=w+" ");while(w);return t&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${t})`:y.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,y)=>{te(["@vscode/windows-process-tree"],d,y)}).then(d=>{d.getProcessList(O,y=>{if(!y){S(new Error(`Root process ${O} not found`));return}d.getProcessCpuUsage(y,f=>{const o=new Map;f.forEach(h=>{const b=u(h.commandLine||"");o.set(h.pid,{name:g(b),cmd:b,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),$=o.get(O),$?(o.forEach(h=>{const b=o.get(h.ppid);b&&(b.children||(b.children=[]),b.children.push(h))}),o.forEach(h=>{h.children&&(h.children=h.children.sort((b,w)=>b.pid-w.pid))}),R($)):S(new Error(`Root process ${O} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let u=function(){let d=[$];const y=[];for(;d.length;){const o=d.shift();o&&(y.push(o.pid),o.children&&(d=d.concat(o.children)))}let f=JSON.stringify(N.$1f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+y.join(" "),(0,j.exec)(f,{},(o,h,b)=>{if(o||b)S(o||new Error(b.toString()));else{const w=h.toString().split(`
`);for(let I=0;I<y.length;I++){const t=C.get(y[I]);t.load=parseFloat(w[I])}if(!$){S(new Error(`Root process ${O} not found`));return}R($)}})};(0,j.exec)("which ps",{},(d,y,f)=>{if(d||f)if(process.platform!=="linux")S(d||new Error(f.toString()));else{const o=JSON.stringify(N.$1f.asFileUri("vs/base/node/ps.sh").fsPath);(0,j.exec)(o,{},(h,b,w)=>{h||w?S(h||new Error(w.toString())):(A(b,p),u())})}else{const o=y.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,j.exec)(`${o} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,w,I)=>{b||I&&!I.includes("screen size is bogus")?S(b||new Error(I.toString())):(A(w,p),process.platform==="linux"?u():$?R($):S(new Error(`Root process ${O} not found`)))})}})}})}e.$qr=D;function A(O,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=O.toString().split(`
`);for(const C of $){const p=S.exec(C.trim());p&&p.length===6&&R(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}});var ye=this&&this.__decorate||function(te,e,j,N){var D=arguments.length,A=D<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,j):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,j,N);else for(var R=te.length-1;R>=0;R--)(O=te[R])&&(A=(D<3?O(A):D>3?O(e,j,A):O(e,j))||A);return D>3&&A&&Object.defineProperty(e,j,A),A};define(re[43],oe([0,1,18,5,14,26,83,8,3,2,63,28,9]),function(te,e,j,N,D,A,O,R,S,$,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.ProxyChannel=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.RequestInitiator=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0;var u;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(u||(u={}));function d(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(y||(y={}));function f(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(o||(o={}));function h(G){let W=0;for(let V=0;;V+=7){const ee=G.read(1);if(W|=(ee.buffer[0]&127)<<V,!(ee.buffer[0]&128))return W}}const b=s(0);function w(G,W){if(W===0){G.write(b);return}let V=0;for(let ne=W;ne!==0;ne=ne>>>7)V++;const ee=D.$Ed.alloc(V);for(let ne=0;W!==0;ne++)ee.buffer[ne]=W&127,W=W>>>7,W>0&&(ee.buffer[ne]|=128);G.write(ee)}class I{constructor(W){this.b=W,this.a=0}read(W){const V=this.b.slice(this.a,this.a+W);return this.a+=V.byteLength,V}}e.$$g=I;class t{constructor(){this.a=[]}get buffer(){return D.$Ed.concat(this.a)}write(W){this.a.push(W)}}e.$_g=t;var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(c||(c={}));function s(G){const W=D.$Ed.alloc(1);return W.writeUInt8(G,0),W}const n={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object),Uint:s(c.Int)},i=typeof Buffer<"u";function r(G,W){if(typeof W>"u")G.write(n.Undefined);else if(typeof W=="string"){const V=D.$Ed.fromString(W);G.write(n.String),w(G,V.byteLength),G.write(V)}else if(i&&Buffer.isBuffer(W)){const V=D.$Ed.wrap(W);G.write(n.Buffer),w(G,V.byteLength),G.write(V)}else if(W instanceof D.$Ed)G.write(n.VSBuffer),w(G,W.byteLength),G.write(W);else if(Array.isArray(W)){G.write(n.Array),w(G,W.length);for(const V of W)r(G,V)}else if(typeof W=="number"&&(W|0)===W)G.write(n.Uint),w(G,W);else{const V=D.$Ed.fromString(JSON.stringify(W));G.write(n.Object),w(G,V.byteLength),G.write(V)}}e.$ah=r;function l(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(h(G)).toString();case c.Buffer:return G.read(h(G)).buffer;case c.VSBuffer:return G.read(h(G));case c.Array:{const V=h(G),ee=[];for(let ne=0;ne<V;ne++)ee.push(l(G));return ee}case c.Object:return JSON.parse(G.read(h(G)).toString());case c.Int:return h(G)}}e.$bh=l;class E{constructor(W,V,ee=null,ne=1e3){this.h=W,this.j=V,this.k=ee,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(W,V){this.b.set(W,V),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const V=this.o([W.type]);this.k?.logOutgoing(V,0,1,f(W.type));return}case 201:case 202:case 204:case 203:{const V=this.o([W.type,W.id],W.data);this.k?.logOutgoing(V,W.id,1,f(W.type),W.data);return}}}o(W,V=void 0){const ee=new t;return r(ee,W),r(ee,V),this.p(ee.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const V=new I(W),ee=l(V),ne=l(V),se=ee[0];switch(se){case 100:return this.k?.logIncoming(W.byteLength,ee[1],1,`${d(se)}: ${ee[2]}.${ee[3]}`,ne),this.s({type:se,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.k?.logIncoming(W.byteLength,ee[1],1,`${d(se)}: ${ee[2]}.${ee[3]}`,ne),this.t({type:se,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.k?.logIncoming(W.byteLength,ee[1],1,`${d(se)}`),this.u({type:se,id:ee[1]});case 103:return this.k?.logIncoming(W.byteLength,ee[1],1,`${d(se)}`),this.u({type:se,id:ee[1]})}}s(W){const V=this.b.get(W.channelName);if(!V){this.v(W);return}const ee=new A.$od;let ne;try{ne=V.call(this.j,W.name,W.arg,ee.token)}catch(q){ne=Promise.reject(q)}const se=W.id;ne.then(q=>{this.m({id:se,data:q,type:201})},q=>{q instanceof Error?this.m({id:se,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:se,data:q,type:203})}).finally(()=>{Z.dispose(),this.d.delete(W.id)});const Z=(0,$.$hc)(()=>ee.cancel());this.d.set(W.id,Z)}t(W){const V=this.b.get(W.channelName);if(!V){this.v(W);return}const ee=W.id,se=V.listen(this.j,W.name,W.arg)(Z=>this.m({id:ee,data:Z,type:204}));this.d.set(W.id,se)}u(W){const V=this.d.get(W.id);V&&(V.dispose(),this.d.delete(W.id))}v(W){let V=this.g.get(W.channelName);V||(V=[],this.g.set(W.channelName,V));const ee=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:W,timeoutTimer:ee})}w(W){const V=this.g.get(W);if(V){for(const ee of V)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$ec)(this.d.values()),this.d.clear()}}e.$ch=E;var m;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class a{constructor(W,V=null){this.l=W,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$ed,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=V}getChannel(W){const V=this;return{call(ee,ne,se){return V.a?Promise.reject(new R.$3):V.m(W,ee,ne,se)},listen(ee,ne){return V.a?S.Event.None:V.o(W,ee,ne)}}}m(W,V,ee,ne=A.CancellationToken.None){const se=this.g++,q={id:se,type:100,channelName:W,name:V,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new R.$3);let k;return new Promise((F,M)=>{if(ne.isCancellationRequested)return M(new R.$3);const K=()=>{const fe=le=>{switch(le.type){case 201:this.f.delete(se),F(le.data);break;case 202:{this.f.delete(se);const $e=new Error(le.data.message);$e.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,$e.name=le.data.name,M($e);break}case 203:this.f.delete(se),M(le.data);break}};this.f.set(se,fe),this.p(q)};let _=null;this.b===o.Idle?K():(_=(0,N.$tg)(fe=>this.u()),_.then(()=>{_=null,K()}));const ae=()=>{_?(_.cancel(),_=null):this.p({id:se,type:101}),M(new R.$3)},he=ne.onCancellationRequested(ae);k=(0,$.$gc)((0,$.$hc)(ae),he),this.d.add(k)}).finally(()=>{k.dispose(),this.d.delete(k)})}o(W,V,ee){const ne=this.g++,Z={id:ne,type:102,channelName:W,name:V,arg:ee};let q=null;const k=new S.$ed({onWillAddFirstListener:()=>{q=(0,N.$tg)(F=>this.u()),q.then(()=>{q=null,this.d.add(k),this.p(Z)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(k),this.p({id:ne,type:103}))}}),P=F=>k.fire(F.data);return this.f.set(ne,P),k.event}p(W){switch(W.type){case 100:case 102:{const V=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(V,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const V=this.q([W.type,W.id]);this.j?.logOutgoing(V,W.id,0,d(W.type));return}}}q(W,V=void 0){const ee=new t;return r(ee,W),r(ee,V),this.r(ee.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const V=new I(W),ee=l(V),ne=l(V),se=ee[0];switch(se){case 200:return this.j?.logIncoming(W.byteLength,0,0,f(se)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ee[1],0,f(se),ne),this.t({type:ee[0],id:ee[1],data:ne})}}t(W){if(W.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$ec)(this.d.values()),this.d.clear()}}e.$dh=a,ye([O.$5g],a.prototype,"onDidInitializePromise",null);class v{get connections(){const W=[];return this.f.forEach(V=>W.push(V)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new S.$ed,this.onDidAddConnection=this.g.event,this.h=new S.$ed,this.onDidRemoveConnection=this.h.event,this.j=new $.$ic,this.j.add(W(({protocol:V,onDidClientDisconnect:ee})=>{const ne=S.Event.once(V.onMessage);this.j.add(ne(se=>{const Z=new I(se),q=l(Z),k=new E(V,q),P=new a(V);this.a.forEach((M,K)=>k.registerChannel(K,M));const F={channelServer:k,channelClient:P,ctx:q};this.f.add(F),this.g.fire(F),this.j.add(ee(()=>{k.dispose(),P.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(W,V){const ee=this;return{call(ne,se,Z){let q;if((0,g.$wf)(V)){const P=(0,j.$1b)(ee.connections.filter(V));q=P?Promise.resolve(P):S.Event.toPromise(S.Event.filter(ee.onDidAddConnection,V))}else q=V.routeCall(ee,ne,se);const k=q.then(P=>P.channelClient.getChannel(W));return T(k).call(ne,se,Z)},listen(ne,se){if((0,g.$wf)(V))return ee.k(W,V,ne,se);const Z=V.routeEvent(ee,ne,se).then(q=>q.channelClient.getChannel(W));return T(Z).listen(ne,se)}}}k(W,V,ee,ne){const se=this;let Z;const q=new S.$ed({onWillAddFirstListener:()=>{Z=new $.$ic;const k=new S.$kd,P=new Map,F=K=>{const ae=K.channelClient.getChannel(W).listen(ee,ne),he=k.add(ae);P.set(K,he)},M=K=>{const _=P.get(K);_&&(_.dispose(),P.delete(K))};se.connections.filter(V).forEach(F),S.Event.filter(se.onDidAddConnection,V)(F,void 0,Z),se.onDidRemoveConnection(M,void 0,Z),k.event(q.fire,q,Z),Z.add(k)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return q.event}registerChannel(W,V){this.a.set(W,V);for(const ee of this.f)ee.channelServer.registerChannel(W,V)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$eh=v;class L{constructor(W,V,ee=null){const ne=new t;r(ne,V),W.send(ne.buffer),this.a=new a(W,ee),this.d=new E(W,V,ee)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,V){this.d.registerChannel(W,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fh=L;function T(G){return{call(W,V,ee){return G.then(ne=>ne.call(W,V,ee))},listen(W,V){const ee=new S.$nd;return G.then(ne=>ee.input=ne.listen(W,V)),ee.event}}}e.$gh=T;function z(G){let W=!1;return{call(V,ee,ne){return W?G.call(V,ee,ne):(0,N.$Gg)(0).then(()=>W=!0).then(()=>G.call(V,ee,ne))},listen(V,ee){if(W)return G.listen(V,ee);const ne=new S.$nd;return(0,N.$Gg)(0).then(()=>W=!0).then(()=>ne.input=G.listen(V,ee)),ne.event}}}e.$hh=z;class U{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const V of W.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await S.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$ih=U;var B;(function(G){function W(se,Z,q){const k=se,P=q&&q.disableMarshalling,F=new Map;for(const M in k)ee(M)&&F.set(M,S.Event.buffer(k[M],!0,void 0,Z));return new class{listen(M,K,_){const ae=F.get(K);if(ae)return ae;if(ne(K)){const he=k[K];if(typeof he=="function")return he.call(k,_)}throw new R.$_(`Event not found: ${K}`)}call(M,K,_){const ae=k[K];if(typeof ae=="function"){if(!P&&Array.isArray(_))for(let he=0;he<_.length;he++)_[he]=(0,C.$0g)(_[he]);return ae.apply(k,_)}throw new R.$_(`Method not found: ${K}`)}}}G.fromService=W;function V(se,Z){const q=Z&&Z.disableMarshalling;return new Proxy({},{get(k,P){if(typeof P=="string")return Z?.properties?.has(P)?Z.properties.get(P):ne(P)?function(F){return se.listen(P,F)}:ee(P)?se.listen(P):async function(...F){let M;Z&&!(0,g.$rf)(Z.context)?M=[Z.context,...F]:M=F;const K=await se.call(P,M);return q?K:(0,C.$0g)(K)};throw new R.$_(`Property not found: ${String(P)}`)}})}G.toService=V;function ee(se){return se[0]==="o"&&se[1]==="n"&&p.$Ke(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&p.$Ke(se.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const W=G.toString();if(W!=="[object Object]")return W}return G}function x(G){return Array.isArray(G)?G.map(J):J(G)}function H(G,W,V,ee,ne,se,Z){Z=x(Z);const q=Q[ne],k=q[ee%q.length];let P=[`%c[${G}]%c[${String(W).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(se)?(P=P.concat(Z),P.push(")")):P.push(Z),console.log.apply(console,P)}class X{constructor(W,V){this.d=W,this.f=V,this.a=0,this.b=0}logOutgoing(W,V,ee,ne,se){this.b+=W,H(this.d,this.b,W,V,ee,ne,se)}logIncoming(W,V,ee,ne,se){this.a+=W,H(this.f,this.a,W,V,ee,ne,se)}}e.$jh=X}),define(re[65],oe([0,1,14,3,2,43]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.ProtocolConstants=e.$kh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let r=0;function l(m,a){if(!i.has(m)){const v=String(++r);i.set(m,v)}return i.get(m)}function E(m,a,v,L){if(!n.enableDiagnostics)return;const T=l(m,a);if(L instanceof j.$Ed||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const z=j.$Ed.alloc(L.byteLength);z.set(L),n.records.push({timestamp:Date.now(),id:T,label:a,type:v,buff:z})}else n.records.push({timestamp:Date.now(),id:T,label:a,type:v,data:L})}n.traceSocketEvent=E})(R||(e.SocketDiagnostics=R={}));var S;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let $=null;function C(){return $||($=j.$Ed.alloc(0)),$}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,r){if(i===0)return C();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const a=this.a[0];return r&&(this.a.shift(),this.b-=i),a}if(this.a[0].byteLength>i){const a=this.a[0].slice(0,i);return r&&(this.a[0]=this.a[0].slice(i),this.b-=i),a}const l=j.$Ed.alloc(i);let E=0,m=0;for(;i>0;){const a=this.a[m];if(a.byteLength>i){const v=a.slice(0,i);l.set(v,E),E+=i,r&&(this.a[m]=a.slice(i),this.b-=i),i-=i}else l.set(a,E),E+=a.byteLength,r?(this.a.shift(),this.b-=a.byteLength):m++,i-=a.byteLength}return l}}e.$kh=p;var g;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(g||(g={}));function u(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class y{constructor(i,r,l,E){this.type=i,this.id=r,this.ack=l,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends D.$jc{constructor(i){super(),this.f=this.B(new N.$ed),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new p,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const l=this.g.messageType,E=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(l,E,m,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=j.$Ed.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(r,i.data)}g(i,r){const l=this.f===0;return this.d.push(i,r),this.f+=i.byteLength+r.byteLength,l}h(){const i=j.$Ed.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,r){this.g(i,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class h extends D.$jc{constructor(i){super(),this.f=new N.$ed,this.onMessage=this.f.event,this.g=new N.$ed,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new o(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new y(1,0,0,i))}}e.$lh=h;class b extends A.$fh{static fromSocket(i,r){return new b(new h(i),r)}get onDidDispose(){return this.b.onDidDispose}constructor(i,r,l=null){super(i,r,l),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$mh=b;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$ed({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$nh=w;class I{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,r=this.a;for(;r;)r=r.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let r=0,l=this.a;for(;l;)i[r++]=l.data,l=l.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const r=new I(i);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const i=Date.now();for(let r=0;r<c.a;r++)this.c[r]=i-1e3*r;setInterval(()=>{for(let r=c.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),r=(1+c.a)*1e3;let l=0;for(let E=0;E<c.a;E++)i-this.c[E]<=r&&l++;return 1-l/c.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new w,this.onControlMessage=this.u.event,this.v=new w,this.onMessage=this.v.event,this.w=new w,this.onDidDispose=this.w.event,this.x=new w,this.onSocketClose=this.x.event,this.y=new w,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??c.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new D.$ic,this.o=i.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new y(5,0,0,C());this.p.write(i),this.p.flush()}sendPause(){const i=new y(7,0,0,C());this.p.write(i)}sendResume(){const i=new y(8,0,0,C());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,r){this.a=!0,this.r.dispose(),this.r=new D.$ic,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new y(3,0,this.h,C());this.p.write(i);const r=this.b.toArray();for(let l=0,E=r.length;l<E;l++)this.p.write(r[l]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const r=this.b.peek();if(r&&r.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,C())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let l=0,E=r.length;l<E;l++)this.p.write(r[l]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const r=++this.c;this.h=this.g;const l=new y(1,r,this.h,i);this.b.push(l),this.a||(this.p.write(l),this.B())}sendControl(i){const r=new y(2,0,0,i);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),r=Date.now()-i.writtenTime,l=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(r>=2e4&&l>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:l});return}const m=Math.max(2e4-r,2e4-l,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new y(3,0,this.h,C());this.p.write(i)}D(){this.h=this.g;const i=new y(9,0,this.h,C());this.p.write(i)}}e.$oh=s}),define(re[93],oe([0,1,64,5,14,26,142,8,3,2,30,145,90,43]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class d extends u.$ch{constructor(o){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",h=>D.$Ed.wrap(Buffer.from(h,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Pp=d;class y{constructor(o,h){this.i=o,this.j=h,this.c=new Set,this.g=new Map,this.h=new S.$ed,this.onDidProcessExit=this.h.event;const b=h&&h.timeout?h.timeout:6e4;this.b=new N.$Cg(b),this.d=null,this.f=null}getChannel(o){const h=this;return{call(b,w,I){return h.k(o,b,w,I)},listen(b,w){return h.l(o,b,w)}}}k(o,h,b,w=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(R.$4());this.b.cancel();const I=this.n(o),t=(0,N.$tg)(n=>I.call(h,b,n)),c=w.onCancellationRequested(()=>t.cancel()),s=(0,$.$hc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{c.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,h,b){if(!this.b)return S.Event.None;this.b.cancel();let w;const I=new S.$ed({onWillAddFirstListener:()=>{w=this.n(o).listen(h,b)(I.fire,I),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,C.$Um)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,g.$sl)(h.env),this.d=(0,j.fork)(this.i,o,h);const b=new S.$ed;S.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,O.$Lp)(i)){(0,O.log)(i,`IPC Library: ${this.j.serverName}`);return}b.fire(D.$Ed.wrap(Buffer.from(i,"base64")))});const I=this.j.useQueue?(0,p.$ul)(this.d):this.d,t=i=>this.d&&this.d.connected&&I.send(i.buffer.toString("base64")),c=b.event,s={send:t,onMessage:c};this.f=new u.$dh(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,$.$ec)(l)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(o){let h=this.g.get(o);return h||(h=this.m.getChannel(o),this.g.set(o,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Qp=y}),define(re[147],oe([0,1,135,14,43,3,9,18]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XS=e.$WS=void 0;class S{constructor(g){this.a=g,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",u=>N.$Ed.wrap(u.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}class $ extends D.$eh{static b(g){(0,O.$sf)((0,j.$VS)(process),"Electron Utility Process");const u=new A.$ed;return process.parentPort.on("message",d=>{if(g?.handledClientConnection(d))return;const y=(0,R.$Lb)(d.ports);y&&u.fire(y)}),A.Event.map(u.event,d=>({protocol:new S(d),onDidClientDisconnect:A.Event.fromNodeEventEmitter(d,"close")}))}constructor(g){super($.b(g))}}e.$WS=$;function C(p,g,u){const d=y=>{y.data===g&&(p.removeListener("message",d),u())};p.on("message",d)}e.$XS=C}),define(re[66],oe([0,1,5,3,2,63,9]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.StorageState=e.$Oo=e.StorageHint=void 0;var R;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(g){const u=g;return u?.changed instanceof Map||u?.deleted instanceof Set}e.$Oo=S;var $;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})($||(e.StorageState=$={}));class C extends D.$jc{static{this.a=100}constructor(u,d=Object.create(null)){super(),this.r=u,this.s=d,this.b=this.B(new N.$hd),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new j.$Dg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(u=>this.u(u)))}u(u){this.b.pause();try{u.changed?.forEach((d,y)=>this.w(y,d)),u.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(u,d){if(this.c===$.Closed)return;let y=!1;(0,O.$rf)(d)?y=this.f.delete(u):this.f.get(u)!==d&&(this.f.set(u,d),y=!0),y&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(u,d){const y=this.f.get(u);return(0,O.$rf)(y)?d:y}getBoolean(u,d){const y=this.get(u);return(0,O.$rf)(y)?d:y==="true"}getNumber(u,d){const y=this.get(u);return(0,O.$rf)(y)?d:parseInt(y,10)}getObject(u,d){const y=this.get(u);return(0,O.$rf)(y)?d:(0,A.$9g)(y)}async set(u,d,y=!1){if(this.c===$.Closed)return;if((0,O.$rf)(d))return this.delete(u,y);const f=(0,O.$kf)(d)||Array.isArray(d)?(0,A.$8g)(d):String(d);if(this.f.get(u)!==f)return this.f.set(u,f),this.j.set(u,f),this.h.delete(u),this.b.fire({key:u,external:y}),this.D()}async delete(u,d=!1){if(!(this.c===$.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:d}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(u).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(u){if(this.z)return this.D(u)}async D(u){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),u)}async whenFlushed(){if(this.z)return new Promise(u=>this.n.push(u))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Po=C;class p{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((d,y)=>this.a.set(y,d)),u.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$Qo=p}),define(re[148],oe([12,10]),function(te,e){return te.create("vs/base/node/zip",e)}),define(re[149],oe([12,10]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[150],oe([12,10]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(re[151],oe([12,10]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(re[152],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[153],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[154],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[155],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[156],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[157],oe([12,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[158],oe([12,10]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[159],oe([12,10]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(re[160],oe([12,10]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(re[161],oe([12,10]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(re[162],oe([12,10]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[163],oe([12,10]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[164],oe([12,10]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(re[165],oe([12,10]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(re[166],oe([12,10]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(re[167],oe([12,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(re[168],oe([12,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[169],oe([12,10]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[170],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[171],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[172],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[173],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[174],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[175],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(re[176],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[177],oe([12,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[178],oe([12,10]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(re[179],oe([0,1,8,151]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var D;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...$){switch($.length){case 1:return(0,N.localize)(0,null,$[0]);case 2:return(0,N.localize)(1,null,$[0],$[1]);case 3:return(0,N.localize)(2,null,$[0],$[1],$[2]);default:return}}const O=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,j.$6)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const p=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:p})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const p=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:p})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const p=this.d,g=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:g};this.g.push({offset:p,lexeme:g,additionalInfo:C}),this.f.push(u)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const p=this.c.substring(this.d,this.e),g=S.b.get(p);g?this.k(g):this.f.push({type:17,lexeme:p,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,p=!1,g=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const d=this.c.charCodeAt(C);if(p)p=!1;else if(d===47&&!g){C++;break}else d===91?g=!0:d===92?p=!0:d===93&&(g=!1);C++}for(;C<this.c.length&&S.a.has(this.c.charCodeAt(C));)C++;this.e=C;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=S}),define(re[180],oe([0,1,62,83,23,15,37,22,11]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=void 0,e.$7l=/^([^.]+\..+):(.+)$/;class ${get appRoot(){return(0,A.$$d)(D.$1f.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,A.$8d)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,j.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$8d)(this.userDataPath,"logs",u)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$hg)(S.URI.file((0,A.$8d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=O.env.VSCODE_PORTABLE;return u?S.URI.file((0,A.$8d)(u,"argv.json")):(0,R.$hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,A.$8d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,A.$9d)(u):(0,A.$6d)((0,A.$8d)(D.$1f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?S.URI.file((0,A.$9d)(u)):S.URI.file((0,A.$8d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,A.$9d)(u);const d=O.env.VSCODE_EXTENSIONS;if(d)return d;const y=O.env.VSCODE_PORTABLE;return y?(0,A.$8d)(y,"extensions"):(0,R.$hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(d=>/^[^:/?#]+?:\/\//.test(d)?S.URI.parse(d):S.URI.file((0,A.$6d)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?S.URI.parse(u):S.URI.file((0,A.$6d)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$7l.test(u))}get extensionLogLevel(){const u=[];for(const d of this.args.log||[]){const y=e.$7l.exec(d);y&&y[1]&&y[2]&&u.push([y[1],y[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,R.$hg)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=O.env.VSCODE_PORTABLE;return u?S.URI.file((0,A.$8d)(u,"policy.json")):(0,R.$hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,d,y){this.a=u,this.b=d,this.c=y,this.editSessionId=this.args.editSessionId}}e.$8l=$,ye([N.$5g],$.prototype,"appRoot",null),ye([N.$5g],$.prototype,"userHome",null),ye([N.$5g],$.prototype,"userDataPath",null),ye([N.$5g],$.prototype,"appSettingsHome",null),ye([N.$5g],$.prototype,"tmpDir",null),ye([N.$5g],$.prototype,"cacheHome",null),ye([N.$5g],$.prototype,"stateResource",null),ye([N.$5g],$.prototype,"userRoamingDataHome",null),ye([N.$5g],$.prototype,"userDataSyncHome",null),ye([N.$5g],$.prototype,"sync",null),ye([N.$5g],$.prototype,"machineSettingsResource",null),ye([N.$5g],$.prototype,"workspaceStorageHome",null),ye([N.$5g],$.prototype,"localHistoryHome",null),ye([N.$5g],$.prototype,"keyboardLayoutResource",null),ye([N.$5g],$.prototype,"argvResource",null),ye([N.$5g],$.prototype,"isExtensionDevelopment",null),ye([N.$5g],$.prototype,"untitledWorkspacesHome",null),ye([N.$5g],$.prototype,"builtinExtensionsPath",null),ye([N.$5g],$.prototype,"extensionsPath",null),ye([N.$5g],$.prototype,"extensionDevelopmentLocationURI",null),ye([N.$5g],$.prototype,"extensionDevelopmentKind",null),ye([N.$5g],$.prototype,"extensionTestsLocationURI",null),ye([N.$5g],$.prototype,"debugExtensionHost",null),ye([N.$5g],$.prototype,"logLevel",null),ye([N.$5g],$.prototype,"extensionLogLevel",null),ye([N.$5g],$.prototype,"serviceMachineIdResource",null),ye([N.$5g],$.prototype,"disableTelemetry",null),ye([N.$5g],$.prototype,"disableWorkspaceTrust",null),ye([N.$5g],$.prototype,"useInMemorySecretStorage",null),ye([N.$5g],$.prototype,"policyFile",null);function C(g,u){return p(g["inspect-extensions"],g["inspect-brk-extensions"],5870,u,g.debugId,g.extensionEnvironment)}e.$9l=C;function p(g,u,d,y,f,o){const b=Number(u||g)||(y?null:d),w=b?!!u:!1;let I;if(o)try{I=JSON.parse(o)}catch{}return{port:b,break:w,debugId:f,env:I}}e.$0l=p}),function(){"use strict";function te(e,j,N){function D(O,R){const S=A(O,R),$=[S];return e.isAbsolute(S)||$.unshift(N),e.resolve(...$)}function A(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(p,"AppData","Roaming")}break;case"darwin":$=e.join(j.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(j.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,R)}return{getUserDataPath:D}}if(typeof define=="function")define(re[181],oe([270,36,37]),function(e,j,N){return te(e,j,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),j=require("os");module.exports=te(e,j,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[182],oe([0,1,36,180,181]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=void 0;class A extends N.$8l{constructor($,C){super($,{homeDir:(0,j.homedir)(),tmpDir:(0,j.tmpdir)(),userDataDir:(0,D.getUserDataPath)($,C.nameShort)},C)}}e.$$l=A;function O(S,$){return(0,N.$0l)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,$,S.extensionEnvironment)}e.$_l=O;function R(S,$){return(0,N.$0l)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,$,S.extensionEnvironment)}e.$am=R}),define(re[183],oe([0,1,9,154]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;function D(O,R,S,$){try{A(O,R,S,$)}catch(C){O.error(C?.message??C)}return R}e.$lp=D;function A(O,R,S,$){const C=(p,g,u)=>{const d=p[g];if((0,j.$if)(d)){const y=d,f=y.length;if(f>1&&y[0]==="%"&&y[f-1]==="%"){const o=y.substr(1,f-2);let h=S[o];h===void 0&&$&&(h=$[o]);const b=typeof h=="string"?h:h?.message,w=$?.[o],I=typeof w=="string"?w:w?.message;if(!b){I||O.warn(`[${R.name}]: ${(0,N.localize)(0,null,o)}`);return}if(u&&(g==="title"||g==="category")&&I&&I!==b){const t={value:b,original:I};p[g]=t}else p[g]=b}}else if((0,j.$kf)(d))for(const y in d)d.hasOwnProperty(y)&&(y==="commands"?C(d,y,!0):C(d,y,u));else if(Array.isArray(d))for(let y=0;y<d.length;y++)C(d,y,u)};for(const p in R)R.hasOwnProperty(p)&&C(R,p)}}),define(re[184],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=e.$W7b=void 0;class j{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$W7b=j;class N{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$X7b=N}),define(re[67],oe([0,1,22,89,158,53]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(o){return o=o.trim(),o==="*"||O.test(o)}e.$Ao=S;function $(o){if(!S(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=o.match(O);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Bo=$;function C(o){if(!o)return null;const h=o.majorBase,b=o.majorMustEqual,w=o.minorBase;let I=o.minorMustEqual;const t=o.patchBase;let c=o.patchMustEqual;o.hasCaret&&(h===0||(I=!1),c=!1);let s=0;if(o.preRelease){const n=R.exec(o.preRelease);if(n){const[,i,r,l]=n;s=Date.UTC(Number(i),Number(r)-1,Number(l))}}return{majorBase:h,majorMustEqual:b,minorBase:w,minorMustEqual:I,patchBase:t,patchMustEqual:c,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$Co=C;function p(o,h,b){let w;typeof o=="string"?w=C($(o)):w=o;let I;h instanceof Date?I=h.getTime():typeof h=="string"&&(I=new Date(h).getTime());let t;if(typeof b=="string"?t=C($(b)):t=b,!w||!t)return!1;const c=w.majorBase,s=w.minorBase,n=w.patchBase;let i=t.majorBase,r=t.minorBase,l=t.patchBase;const E=t.notBefore;let m=t.majorMustEqual,a=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?c>i?!0:c<i?!1:s>r?!0:s<r||I&&I<E?!1:n>=l:(c===1&&i===0&&(!m||!a||!v)&&(i=1,r=0,l=0,m=!0,a=!1,v=!1),c<i?!1:c>i?!m:s<r?!1:s>r?!a:n<l?!1:n>l?!v:!(I&&I<E))}e.$Do=p;function g(o,h,b,w,I){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([N.default.Error,D.localize(0,null)]),t;if(typeof w.name!="string")return t.push([N.default.Error,D.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([N.default.Error,D.localize(2,null,"version")]),t;if(!w.engines)return t.push([N.default.Error,D.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([N.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!f(w.extensionDependencies))return t.push([N.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!f(w.activationEvents))return t.push([N.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([N.default.Error,D.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([N.default.Warning,D.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([N.default.Error,D.localize(9,null,"main")]),t;{const n=(0,j.$hg)(b,w.main);(0,j.$bg)(n,b)||t.push([N.default.Warning,D.localize(10,null,n.path,b.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([N.default.Error,D.localize(11,null,"browser")]),t;{const n=(0,j.$hg)(b,w.browser);(0,j.$bg)(n,b)||t.push([N.default.Warning,D.localize(12,null,n.path,b.path)])}}if(!A.valid(w.version))return t.push([N.default.Error,D.localize(13,null)]),t;const c=[];if(!u(o,h,w,I,c))for(const n of c)t.push([N.default.Error,n]);return t}e.$Eo=g;function u(o,h,b,w,I){return w||typeof b.main>"u"&&typeof b.browser>"u"?!0:y(o,h,b.engines.vscode,I)}e.$Fo=u;function d(o,h,b){return o==="*"||y(h,b,o)}e.$Go=d;function y(o,h,b,w=[]){const I=C($(b));if(!I)return w.push(D.localize(14,null,b)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return w.push(D.localize(15,null,b)),!1}else if(!I.majorMustEqual)return w.push(D.localize(16,null,b)),!1;return p(o,h,I)?!0:(w.push(D.localize(17,null,o,b)),!1)}function f(o){if(!Array.isArray(o))return!1;for(let h=0,b=o.length;h<b;h++)if(typeof o[h]!="string")return!1;return!0}}),define(re[44],oe([0,1,14,32]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0;async function D(A,O,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const C=(await O.readFile(A.serviceMachineIdResource)).value.toString();S=(0,N.$2f)(C)?C:null}catch{S=null}if(!S){S=(0,N.$3f)();try{await O.writeFile(A.serviceMachineIdResource,j.$Ed.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}e.$Zo=D}),define(re[68],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class j{constructor(D,A=[],O=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$xh=j}),define(re[185],oe([0,1,68]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.InstantiationType=void 0;const N=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function A(R,S,$){S instanceof j.$xh||(S=new j.$xh(S,[],!!$)),N.push([R,S])}e.$kr=A;function O(){return N}e.$lr=O}),define(re[186],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class j{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$2p=j;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const R=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(O);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let R=this.a.get(O);return R||(R=new j(O,A),this.a.set(O,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,R]of this.a)A.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const R=new Set([A]),S=this.c(O,R);if(S)return S}}c(A,O){for(const[R,S]of A.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const $=this.c(S,O);if($)return $;O.delete(R)}}}e.$3p=N}),define(re[4],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e._util=void 0;var j;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(j||(e._util=j={})),e.$zh=D("instantiationService");function N(O,R,S){R[j.DI_TARGET]===R?R[j.DI_DEPENDENCIES].push({id:O,index:S}):(R[j.DI_DEPENDENCIES]=[{id:O,index:S}],R[j.DI_TARGET]=R)}function D(O){if(j.serviceIds.has(O))return j.serviceIds.get(O);const R=function(S,$,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,S,C)};return R.toString=()=>O,j.serviceIds.set(O,R),R}e.$Ah=D;function A(O){return O}e.$Bh=A}),define(re[187],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0,e.$t7b=(0,j.$Ah)("checksumService")}),define(re[19],oe([0,1,9,11,4]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,D.$Ah)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}e.$8h=A;function O(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}e.$9h=O;var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=S;function $(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$$h=$;function C(o,h){const b=Object.create(null);for(const w in o)p(b,w,o[w],h);return b}e.$_h=C;function p(o,h,b,w){const I=h.split("."),t=I.pop();let c=o;for(let s=0;s<I.length;s++){const n=I[s];let i=c[n];switch(typeof i){case"undefined":i=c[n]=Object.create(null);break;case"object":break;default:w(`Ignoring ${h} as ${I.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}c=i}if(typeof c=="object"&&c!==null)try{c[t]=b}catch{w(`Ignoring ${h} as ${I.join(".")} is ${JSON.stringify(c)}`)}else w(`Ignoring ${h} as ${I.join(".")} is ${JSON.stringify(c)}`)}e.$ai=p;function g(o,h){const b=h.split(".");u(o,b)}e.$bi=g;function u(o,h){const b=h.shift();if(h.length===0){delete o[b];return}if(Object.keys(o).indexOf(b)!==-1){const w=o[b];typeof w=="object"&&!Array.isArray(w)&&(u(w,h),Object.keys(w).length===0&&delete o[b])}}function d(o,h,b){function w(c,s){let n=c;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const I=h.split("."),t=w(o,I);return typeof t>"u"?b:t}e.$ci=d;function y(o,h,b){Object.keys(h).forEach(w=>{w!=="__proto__"&&(w in o?j.$kf(o[w])&&j.$kf(h[w])?y(o[w],h[w],b):b&&(o[w]=h[w]):o[w]=h[w])})}e.$di=y;function f(o){return o.replace(/[\[\]]/g,"")}e.$ei=f}),define(re[94],oe([0,1,6,28,179,4,150,8]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",j.$j),S.set("isLinux",j.$k),S.set("isWindows",j.$i),S.set("isWeb",j.$o),S.set("isMacNative",j.$j&&!j.$o),S.set("isEdge",j.$G),S.set("isFirefox",j.$E),S.set("isChrome",j.$D),S.set("isSafari",j.$F);function $(q,k){if(S.get(q)!==void 0)throw(0,R.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(q,k)}e.$Fi=$;const C=Object.prototype.hasOwnProperty;var p;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const g={regexParsingWithErrorRecovery:!0},u=(0,O.localize)(0,null),d=(0,O.localize)(1,null),y=(0,O.localize)(2,null),f=(0,O.localize)(3,null),o=(0,O.localize)(4,null),h=(0,O.localize)(5,null),b=(0,O.localize)(6,null),w=(0,O.localize)(7,null);class I{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(k=g){this.k=k,this.d=new D.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(k){if(k===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(k).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const F=this.D(),M=F.type===17?h:void 0;throw this.h.push({message:o,offset:F.offset,lexeme:D.$Ei.getLexeme(F),additionalInfo:M}),I.c}return P}catch(P){if(P!==I.c)throw P;return}}l(){return this.m()}m(){const k=[this.o()];for(;this.y(16);){const P=this.o();k.push(P)}return k.length===1?k[0]:t.or(...k)}o(){const k=[this.s()];for(;this.y(15);){const P=this.s();k.push(P)}return k.length===1?k[0]:t.and(...k)}s(){if(this.y(2)){const k=this.D();switch(k.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,f),P?.negate()}case 17:return this.z(),L.create(k.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",k)}}return this.t()}t(){const k=this.D();switch(k.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const P=this.l();return this.A(1,f),P}case 17:{const P=k.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const K=M.lexeme,_=K.lastIndexOf("/"),ae=_===K.length-1?void 0:this.w(K.substring(_+1));let he;try{he=new RegExp(K.substring(1,_),ae)}catch{throw this.B("REGEX",M)}return J.create(P,he)}switch(M.type){case 10:case 19:{const K=[M.lexeme];this.z();let _=this.D(),ae=0;for(let de=0;de<M.lexeme.length;de++)M.lexeme.charCodeAt(de)===40?ae++:M.lexeme.charCodeAt(de)===41&&ae--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let de=0;de<_.lexeme.length;de++)_.lexeme.charCodeAt(de)===40?ae++:M.lexeme.charCodeAt(de)===41&&ae--}if(ae<0)break;K.push(D.$Ei.getLexeme(_)),this.z(),_=this.D()}const he=K.join(""),fe=he.lastIndexOf("/"),le=fe===he.length-1?void 0:this.w(he.substring(fe+1));let $e;try{$e=new RegExp(he.substring(1,fe),le)}catch{throw this.B("REGEX",M)}return t.regex(P,$e)}case 18:{const K=M.lexeme;this.z();let _=null;if(!(0,N.$le)(K)){const ae=K.indexOf("/"),he=K.lastIndexOf("/");if(ae!==he&&ae>=0){const fe=K.slice(ae+1,he),le=K[he+1]==="i"?"i":"";try{_=new RegExp(fe,le)}catch{throw this.B("REGEX",M)}}}if(_===null)throw this.B("REGEX",M);return J.create(P,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const M=this.u();return t.notIn(P,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return t.equals(P,M);switch(M){case"true":return t.has(P);case"false":return t.not(P);default:return t.equals(P,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return t.notEquals(P,M);switch(M){case"true":return t.not(P);case"false":return t.has(P);default:return t.notEquals(P,M)}}case 5:return this.z(),B.create(P,this.u());case 6:return this.z(),Q.create(P,this.u());case 7:return this.z(),z.create(P,this.u());case 8:return this.z(),U.create(P,this.u());case 13:return this.z(),t.in(P,this.u());default:return t.has(P)}}case 20:throw this.h.push({message:b,offset:k.offset,lexeme:"",additionalInfo:w}),I.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const k=this.D();switch(k.type){case 17:case 18:return this.z(),k.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(k){return k.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(k){return this.C(k)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(k,P){if(this.C(k))return this.z();throw this.B(P,this.D())}B(k,P,F){const M=(0,O.localize)(8,null,k,D.$Ei.getLexeme(P)),K=P.offset,_=D.$Ei.getLexeme(P);return this.h.push({message:M,offset:K,lexeme:_,additionalInfo:F}),I.c}C(k){return this.D().type===k}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=I;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(k){return l.create(k)}static equals(k,P){return E.create(k,P)}static notEquals(k,P){return v.create(k,P)}static regex(k,P){return J.create(k,P)}static in(k,P){return m.create(k,P)}static notIn(k,P){return a.create(k,P)}static not(k){return L.create(k)}static and(...k){return X.create(k,null,!0)}static or(...k){return G.create(k,null,!0)}static greater(k,P){return z.create(k,P)}static greaterEquals(k,P){return U.create(k,P)}static smaller(k,P){return B.create(k,P)}static smallerEquals(k,P){return Q.create(k,P)}static{this.c=new I({regexParsingWithErrorRecovery:!1})}static deserialize(k){return k==null?void 0:this.c.parse(k)}}e.$Hi=t;function c(q){const k=new I({regexParsingWithErrorRecovery:!1});return q.map(P=>(k.parse(P),k.lexingErrors.length>0?k.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,O.localize)(9,null,F.additionalInfo):(0,O.localize)(10,null),offset:F.offset,length:F.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$Ii=c;function s(q,k){const P=q?q.substituteConstants():void 0,F=k?k.substituteConstants():void 0;return!P&&!F?!0:!P||!F?!1:P.equals(F)}e.$Ji=s;function n(q,k){return q.cmp(k)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return r.INSTANCE}}e.$Ki=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return i.INSTANCE}}e.$Li=r;class l{static create(k,P=null){const F=S.get(k);return typeof F=="boolean"?F?r.INSTANCE:i.INSTANCE:new l(k,P)}constructor(k,P){this.key=k,this.c=P,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:V(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=S.get(this.key);return typeof k=="boolean"?k?r.INSTANCE:i.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Mi=l;class E{static create(k,P,F=null){if(typeof P=="boolean")return P?l.create(k,F):L.create(k,F);const M=S.get(k);return typeof M=="boolean"?P===(M?"true":"false")?r.INSTANCE:i.INSTANCE:new E(k,P,F)}constructor(k,P,F){this.c=k,this.d=P,this.f=F,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=S.get(this.c);if(typeof k=="boolean"){const P=k?"true":"false";return this.d===P?r.INSTANCE:i.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ni=E;class m{static create(k,P){return new m(k,P)}constructor(k,P){this.d=k,this.f=P,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const P=k.getValue(this.f),F=k.getValue(this.d);return Array.isArray(P)?P.includes(F):typeof F=="string"&&typeof P=="object"&&P!==null?C.call(P,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=a.create(this.d,this.f)),this.c}}e.$Oi=m;class a{static create(k,P){return new a(k,P)}constructor(k,P){this.d=k,this.f=P,this.type=11,this.c=m.create(k,P)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=a;class v{static create(k,P,F=null){if(typeof P=="boolean")return P?L.create(k,F):l.create(k,F);const M=S.get(k);return typeof M=="boolean"?P===(M?"true":"false")?i.INSTANCE:r.INSTANCE:new v(k,P,F)}constructor(k,P,F){this.c=k,this.d=P,this.f=F,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=S.get(this.c);if(typeof k=="boolean"){const P=k?"true":"false";return this.d===P?i.INSTANCE:r.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Qi=v;class L{static create(k,P=null){const F=S.get(k);return typeof F=="boolean"?F?i.INSTANCE:r.INSTANCE:new L(k,P)}constructor(k,P){this.c=k,this.d=P,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:V(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=S.get(this.c);return typeof k=="boolean"?k?i.INSTANCE:r.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Ri=L;function T(q,k){if(typeof q=="string"){const P=parseFloat(q);isNaN(P)||(q=P)}return typeof q=="string"||typeof q=="number"?k(q):i.INSTANCE}class z{static create(k,P,F=null){return T(P,M=>new z(k,M,F))}constructor(k,P,F){this.c=k,this.d=P,this.f=F,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Si=z;class U{static create(k,P,F=null){return T(P,M=>new U(k,M,F))}constructor(k,P,F){this.c=k,this.d=P,this.f=F,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ti=U;class B{static create(k,P,F=null){return T(P,M=>new B(k,M,F))}constructor(k,P,F){this.c=k,this.d=P,this.f=F,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ui=B;class Q{static create(k,P,F=null){return T(P,M=>new Q(k,M,F))}constructor(k,P,F){this.c=k,this.d=P,this.f=F,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:ee(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Vi=Q;class J{static create(k,P){return new J(k,P)}constructor(k,P){this.d=k,this.f=P,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const P=this.f?this.f.source:"",F=k.f?k.f.source:"";return P<F?-1:P>F?1:0}equals(k){if(k.type===this.type){const P=this.f?this.f.source:"",F=k.f?k.f.source:"";return this.d===k.d&&P===F}return!1}substituteConstants(){return this}evaluate(k){const P=k.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$Wi=J;class x{static create(k){return new x(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(k){return new x(this.c.map(k))}negate(){return this.c}}e.$Xi=x;function H(q){let k=null;for(let P=0,F=q.length;P<F;P++){const M=q[P].substituteConstants();if(q[P]!==M&&k===null){k=[];for(let K=0;K<P;K++)k[K]=q[K]}k!==null&&(k[P]=M)}return k===null?q:k}class X{static create(k,P,F){return X.d(k,P,F)}constructor(k,P){this.expr=k,this.c=P,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const M=n(this.expr[P],k.expr[P]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(k.expr[P]))return!1;return!0}return!1}substituteConstants(){const k=H(this.expr);return k===this.expr?this:X.create(k,this.c,!1)}evaluate(k){for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].evaluate(k))return!1;return!0}static d(k,P,F){const M=[];let K=!1;for(const _ of k)if(_){if(_.type===1){K=!0;continue}if(_.type===0)return i.INSTANCE;if(_.type===6){M.push(..._.expr);continue}M.push(_)}if(M.length===0&&K)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let _=1;_<M.length;_++)M[_-1].equals(M[_])&&(M.splice(_,1),_--);if(M.length===1)return M[0];for(;M.length>1;){const _=M[M.length-1];if(_.type!==9)break;M.pop();const ae=M.pop(),he=M.length===0,fe=G.create(_.expr.map(le=>X.create([le,ae],null,F)),null,he);fe&&(M.push(fe),M.sort(n))}if(M.length===1)return M[0];if(F){for(let _=0;_<M.length;_++)for(let ae=_+1;ae<M.length;ae++)if(M[_].negate().equals(M[ae]))return i.INSTANCE;if(M.length===1)return M[0]}return new X(M,P)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const P of this.expr)k.push(...P.keys());return k}map(k){return new X(this.expr.map(P=>P.map(k)),null)}negate(){if(!this.c){const k=[];for(const P of this.expr)k.push(P.negate());this.c=G.create(k,this,!0)}return this.c}}e.$Yi=X;class G{static create(k,P,F){return G.d(k,P,F)}constructor(k,P){this.expr=k,this.c=P,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const M=n(this.expr[P],k.expr[P]);if(M!==0)return M}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(k.expr[P]))return!1;return!0}return!1}substituteConstants(){const k=H(this.expr);return k===this.expr?this:G.create(k,this.c,!1)}evaluate(k){for(let P=0,F=this.expr.length;P<F;P++)if(this.expr[P].evaluate(k))return!0;return!1}static d(k,P,F){let M=[],K=!1;if(k){for(let _=0,ae=k.length;_<ae;_++){const he=k[_];if(he){if(he.type===0){K=!0;continue}if(he.type===1)return r.INSTANCE;if(he.type===9){M=M.concat(he.expr);continue}M.push(he)}}if(M.length===0&&K)return i.INSTANCE;M.sort(n)}if(M.length!==0){if(M.length===1)return M[0];for(let _=1;_<M.length;_++)M[_-1].equals(M[_])&&(M.splice(_,1),_--);if(M.length===1)return M[0];if(F){for(let _=0;_<M.length;_++)for(let ae=_+1;ae<M.length;ae++)if(M[_].negate().equals(M[ae]))return r.INSTANCE;if(M.length===1)return M[0]}return new G(M,P)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const P of this.expr)k.push(...P.keys());return k}map(k){return new G(this.expr.map(P=>P.map(k)),null)}negate(){if(!this.c){const k=[];for(const P of this.expr)k.push(P.negate());for(;k.length>1;){const P=k.shift(),F=k.shift(),M=[];for(const K of Z(P))for(const _ of Z(F))M.push(X.create([K,_],null,!1));k.unshift(G.create(M,null,!1))}this.c=G.create(k,this,!0)}return this.c}}e.$Zi=G;class W extends l{static{this.d=[]}static all(){return W.d.values()}constructor(k,P,F){super(k,null),this.f=P,typeof F=="object"?W.d.push({...F,key:k}):F!==!0&&W.d.push({key:k,description:F,type:P!=null?typeof P:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return E.create(this.key,k)}notEqualsTo(k){return v.create(this.key,k)}}e.$1i=W,e.$2i=(0,A.$Ah)("contextKeyService");function V(q,k){return q<k?-1:q>k?1:0}function ee(q,k,P,F){return q<P?-1:q>P?1:k<F?-1:k>F?1:0}function ne(q,k){if(q.type===0||k.type===1)return!0;if(q.type===9)return k.type===9?se(q.expr,k.expr):!1;if(k.type===9){for(const P of k.expr)if(ne(q,P))return!0;return!1}if(q.type===6){if(k.type===6)return se(k.expr,q.expr);for(const P of q.expr)if(ne(P,k))return!0;return!1}return q.equals(k)}e.$3i=ne;function se(q,k){let P=0,F=0;for(;P<q.length&&F<k.length;){const M=q[P].cmp(k[F]);if(M<0)return!1;M===0&&P++,F++}return P===q.length}function Z(q){return q.type===9?q.expr:[q]}}),define(re[95],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=e.ID=void 0,e.ID="diagnosticsService",e.$fm=(0,j.$Ah)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}e.$gm=N;class D{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$hm=D}),define(re[96],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=void 0,e.$Cn=(0,j.$Ah)("downloadService")}),define(re[16],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,j.$Ah)("environmentService"),e.$Ih=(0,j.$Bh)(e.$Hh)}),define(re[29],oe([0,1,153,4]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function D(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=D;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=A;function O(h,b){switch(h){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=O;function R(h,b){return b==="web"&&!h.includes("web")}e.$Un=R;function S(h,b,w){return R(b,w)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===w?!0:$(w).includes(h)}e.$Vn=S;function $(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=$;function C(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$Xn=C;var p;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var g;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var u;(function(h){h.Install="install",h.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var d;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$Yn=(0,N.$Ah)("extensionGalleryService");var y;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var f;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class o extends Error{constructor(b,w){super(b),this.code=w,this.name=w}}e.$Zn=o,e.$1n=(0,N.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,N.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,N.$Ah)("IExtensionTipsService"),e.$6n=(0,j.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,j.localize)(1,null),original:"Preferences"}}),define(re[188],oe([0,1,3,2,30,11,92,29]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=void 0;function S(f,o){return f?A.URI.revive(o?o.transformIncoming(f):f):void 0}function $(f,o){return o?o.transformOutgoingURI(f):f}function C(f,o){o=o||O.$Bm;const h=f.manifest;return{...(0,O.$Em)({...f,manifest:void 0},o),manifest:h}}function p(f,o){return f?.profileLocation?(0,O.$Em)(f,o??O.$Bm):f}function g(f,o){return o?(0,D.$Wm)(f,h=>h instanceof A.URI?o.transformOutgoingURI(h):void 0):f}class u{constructor(o,h){this.a=o,this.b=h,this.onInstallExtension=j.Event.buffer(o.onInstallExtension,!0),this.onDidInstallExtensions=j.Event.buffer(o.onDidInstallExtensions,!0),this.onUninstallExtension=j.Event.buffer(o.onUninstallExtension,!0),this.onDidUninstallExtension=j.Event.buffer(o.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=j.Event.buffer(o.onDidUpdateExtensionMetadata,!0)}listen(o,h){const b=this.b(o);switch(h){case"onInstallExtension":return j.Event.map(this.onInstallExtension,w=>({...w,profileLocation:w.profileLocation?$(w.profileLocation,b):w.profileLocation}));case"onDidInstallExtensions":return j.Event.map(this.onDidInstallExtensions,w=>w.map(I=>({...I,local:I.local?g(I.local,b):I.local,profileLocation:I.profileLocation?$(I.profileLocation,b):I.profileLocation})));case"onUninstallExtension":return j.Event.map(this.onUninstallExtension,w=>({...w,profileLocation:w.profileLocation?$(w.profileLocation,b):w.profileLocation}));case"onDidUninstallExtension":return j.Event.map(this.onDidUninstallExtension,w=>({...w,profileLocation:w.profileLocation?$(w.profileLocation,b):w.profileLocation}));case"onDidUpdateExtensionMetadata":return j.Event.map(this.onDidUpdateExtensionMetadata,w=>g(w,b))}throw new Error("Invalid listen")}async call(o,h,b){const w=this.b(o);switch(h){case"zip":{const I=C(b[0],w),t=await this.a.zip(I);return $(t,w)}case"unzip":return this.a.unzip(S(b[0],w));case"install":return this.a.install(S(b[0],w),p(b[1],w));case"installFromLocation":return this.a.installFromLocation(S(b[0],w),S(b[1],w));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(b[0],S(b[1],w),S(b[2],w));case"getManifest":return this.a.getManifest(S(b[0],w));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(b[0]);case"installFromGallery":return this.a.installFromGallery(b[0],p(b[1],w));case"installGalleryExtensions":{const I=b[0];return this.a.installGalleryExtensions(I.map(({extension:t,options:c})=>({extension:t,options:p(c,w)??{}})))}case"uninstall":return this.a.uninstall(C(b[0],w),p(b[1],w));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(b[0],w));case"getInstalled":return(await this.a.getInstalled(b[0],S(b[1],w))).map(t=>g(t,w));case"toggleAppliationScope":{const I=await this.a.toggleAppliationScope(C(b[0],w),S(b[1],w));return g(I,w)}case"copyExtensions":return this.a.copyExtensions(S(b[0],w),S(b[1],w));case"updateMetadata":{const I=await this.a.updateMetadata(C(b[0],w),b[1],S(b[2],w));return g(I,w)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(b[0],b[1],b[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$8o=u;class d extends N.$jc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(o){super(),this.m=o,this.c=this.B(new j.$ed),this.f=this.B(new j.$ed),this.g=this.B(new j.$ed),this.h=this.B(new j.$ed),this.j=this.B(new j.$ed),this.B(this.m.listen("onInstallExtension")(h=>this.n(this.c,{...h,source:this.r(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(h=>this.n(this.f,h.map(b=>({...b,local:b.local?C(b.local,null):b.local,source:this.r(b.source)?A.URI.revive(b.source):b.source,profileLocation:A.URI.revive(b.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(h=>this.n(this.g,{...h,profileLocation:A.URI.revive(h.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(h=>this.n(this.h,{...h,profileLocation:A.URI.revive(h.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(h=>this.j.fire(C(h,null))))}n(o,h){o.fire(h)}r(o){return o?typeof o.path=="string"&&typeof o.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(o){const h=await this.getTargetPlatform();return o.allTargetPlatforms.some(b=>(0,R.$Vn)(b,o.allTargetPlatforms,h))}zip(o){return Promise.resolve(this.m.call("zip",[o]).then(h=>A.URI.revive(h)))}unzip(o){return Promise.resolve(this.m.call("unzip",[o]))}install(o,h){return Promise.resolve(this.m.call("install",[o,h])).then(b=>C(b,null))}installFromLocation(o,h){return Promise.resolve(this.m.call("installFromLocation",[o,h])).then(b=>C(b,null))}async installExtensionsFromProfile(o,h,b){return(await this.m.call("installExtensionsFromProfile",[o,h,b])).map(I=>C(I,null))}getManifest(o){return Promise.resolve(this.m.call("getManifest",[o]))}installFromGallery(o,h){return Promise.resolve(this.m.call("installFromGallery",[o,h])).then(b=>C(b,null))}async installGalleryExtensions(o){return(await this.m.call("installGalleryExtensions",[o])).map(b=>({...b,local:b.local?C(b.local,null):b.local,source:this.r(b.source)?A.URI.revive(b.source):b.source,profileLocation:A.URI.revive(b.profileLocation)}))}uninstall(o,h){return Promise.resolve(this.m.call("uninstall",[o,h]))}reinstallFromGallery(o){return Promise.resolve(this.m.call("reinstallFromGallery",[o])).then(h=>C(h,null))}getInstalled(o=null,h){return Promise.resolve(this.m.call("getInstalled",[o,h])).then(b=>b.map(w=>C(w,null)))}updateMetadata(o,h,b){return Promise.resolve(this.m.call("updateMetadata",[o,h,b])).then(w=>C(w,null))}toggleAppliationScope(o,h){return this.m.call("toggleAppliationScope",[o,h]).then(b=>C(b,null))}copyExtensions(o,h){return this.m.call("copyExtensions",[o,h])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(o,h,b){const w=await this.m.call("download",[o,h,b]);return A.URI.revive(w)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$9o=d;class y{constructor(o){this.a=o}listen(o,h){throw new Error("Invalid listen")}call(o,h,b){switch(h){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$0o=y}),define(re[97],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=void 0,e.$5o=(0,j.$Ah)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,O)=>te(["node-vsce-sign"],async R=>A(R),O))),this.a}async verify(A,O,R){let S;try{S=await this.b()}catch{return!1}return S.verify(A,O,R)}}e.$6o=N}),define(re[98],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uUb=e.RecommendationsNotificationResult=e.$tUb=e.RecommendationSource=void 0;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function D(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$tUb=D;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$uUb=(0,j.$Ah)("IExtensionRecommendationNotificationService")}),define(re[13],oe([0,1,47,15,28,9,11,160,4,6,23]),function(te,e,j,N,D,A,O,R,S,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileKind=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileOperationResult=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileChangeType=e.$jk=e.FileOperation=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileSystemProviderErrorCode=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$6j=e.$5j=void 0,e.$5j=(0,S.$Ah)("fileService");function p(V){return V.create===!0}e.$6j=p;var g;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var u;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var d;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function y(V){return!!(V.capabilities&2)}e.$7j=y;function f(V){return!!(V.capabilities&8)}e.$8j=f;function o(V){return!!(V.capabilities&131072)}e.$9j=o;function h(V){return!!(V.capabilities&4)}e.$0j=h;function b(V){return!!(V.capabilities&16)}e.$$j=b;function w(V){return y(V)?!!(V.capabilities&16384):!1}e.$_j=w;function I(V){return y(V)?!!(V.capabilities&32768):!1}e.$ak=I;function t(V){return!!(V.capabilities&65536)}e.$bk=t;function c(V){return!!(V.capabilities&2048)}e.$ck=c;var s;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create(ee,ne){const se=new n(ee.toString(),ne);return l(se,ne),se}constructor(ee,ne){super(ee),this.code=ne}}e.$dk=n;function i(V,ee){return n.create(V,ee)}e.$ek=i;function r(V){return V||i((0,R.localize)(0,null),s.Unknown)}e.$fk=r;function l(V,ee){return V.name=ee?`${ee} (FileSystemError)`:"FileSystemError",V}e.$gk=l;function E(V){if(!V)return s.Unknown;if(V instanceof n)return V.code;const ee=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!ee)return s.Unknown;switch(ee[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$hk=E;function m(V){if(V instanceof U)return V.fileOperationResult;switch(E(V)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$ik=m;var a;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(a||(e.FileOperation=a={}));class v{constructor(ee,ne,se){this.resource=ee,this.operation=ne,this.target=se}isOperation(ee){return this.operation===ee}}e.$jk=v;var L;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class T{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const Z of ee){const q=se.get(Z.type);switch(q?q.push([Z.resource,Z]):se.set(Z.type,[[Z.resource,Z]]),Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}}for(const[Z,q]of se)switch(Z){case 1:this.a=j.$Gh.forUris(()=>ne),this.a.fill(q);break;case 0:this.b=j.$Gh.forUris(()=>ne),this.b.fill(q);break;case 2:this.c=j.$Gh.forUris(()=>ne),this.c.fill(q);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...se){if(!ee)return!1;const Z=se.length>0;return!!((!Z||se.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!Z||se.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!Z||se.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$kk=T;function z(V,ee,ne){return!V||!ee||V===ee||ee.length>V.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,D.$Me)(V,ee):V.indexOf(ee)===0)}e.$lk=z;class U extends Error{constructor(ee,ne,se){super(ee),this.fileOperationResult=ne,this.options=se}}e.$mk=U;class B extends U{constructor(ee,ne,se,Z){super(ee,ne,Z),this.fileOperationResult=ne,this.size=se}}e.$nk=B;class Q extends U{constructor(ee,ne,se){super(ee,2,se),this.stat=ne}}e.$ok=Q;var J;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$rk="files.associations",e.$sk="files.exclude",e.$tk="files.readonlyInclude",e.$uk="files.readonlyExclude",e.$vk="files.readonlyFromPermissions";var x;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(x||(e.FileKind=x={})),e.$wk="";function H(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$xk=H;async function X(V,ee){if(!ee.hasProvider(O.URI.from({scheme:V.scheme})))return new Promise(ne=>{const se=ee.onDidChangeFileSystemProviderRegistrations(Z=>{Z.scheme===V.scheme&&Z.added&&(se.dispose(),ne())})})}e.$yk=X;class G{static{this.KB=1024}static{this.MB=G.KB*G.KB}static{this.GB=G.MB*G.KB}static{this.TB=G.GB*G.KB}static formatSize(ee){return(0,A.$mf)(ee)||(ee=0),ee<G.KB?(0,R.localize)(1,null,ee.toFixed(0)):ee<G.MB?(0,R.localize)(2,null,(ee/G.KB).toFixed(2)):ee<G.GB?(0,R.localize)(3,null,(ee/G.MB).toFixed(2)):ee<G.TB?(0,R.localize)(4,null,(ee/G.GB).toFixed(2)):(0,R.localize)(5,null,(ee/G.TB).toFixed(2))}}e.$zk=G;function W(V){const ee=typeof V=="string"||V?.scheme===C.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===C.Schemas.file?1024*G.MB:ee?10*G.MB:$.$o?50*G.MB:1024*G.MB}e.$Ak=W});var Y=this&&this.__param||function(te,e){return function(j,N){e(j,N,te)}};define(re[189],oe([0,1,69,42,13]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise(($,C)=>{const p=(0,j.createHash)("md5");(0,N.$wd)(S,{onData:g=>p.update(g.buffer),onError:g=>C(g),onEnd:()=>$(p.digest("base64").replace(/=+$/,""))})})}};e.$u7b=A,e.$u7b=A=ye([Y(0,D.$5j)],A)}),define(re[190],oe([0,1,14,38,8,3,2,42,11,32,13]),function(te,e,j,N,D,A,O,R,S,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=void 0,e.$1M="localFilesystem";class p extends O.$jc{constructor(u,d){super(),this.a=u,this.b=d,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$ed),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$ed),this.onDidWatchError=this.g.event,this.h=(0,$.$3f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,d){const{buffer:y}=await this.a.call("readFile",[u,d]);return y}readFileStream(u,d,y){const f=(0,R.$sd)(h=>j.$Ed.concat(h.map(b=>j.$Ed.wrap(b))).buffer),o=new O.$ic;return o.add(this.a.listen("readFileStream",[u,d])(h=>{if(h instanceof j.$Ed)f.write(h.buffer);else{if(h==="end")f.end();else{let b;if(h instanceof Error)b=h;else{const w=h;b=(0,C.$ek)(w.message??(0,N.$li)(w),w.code??C.FileSystemProviderErrorCode.Unknown)}f.error(b),f.end()}o.dispose()}})),o.add(y.onCancellationRequested(()=>{f.error((0,D.$4)()),f.end(),o.dispose()})),f}writeFile(u,d,y){return this.a.call("writeFile",[u,j.$Ed.wrap(d),y])}open(u,d){return this.a.call("open",[u,d])}close(u){return this.a.call("close",[u])}async read(u,d,y,f,o){const[h,b]=await this.a.call("read",[u,d,o]);return y.set(h.buffer.slice(0,b),f),b}write(u,d,y,f,o){return this.a.call("write",[u,d,j.$Ed.wrap(y),f,o])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,d){return this.a.call("delete",[u,d])}rename(u,d,y){return this.a.call("rename",[u,d,y])}copy(u,d,y){return this.a.call("copy",[u,d,y])}cloneFile(u,d){return this.a.call("cloneFile",[u,d])}j(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const d=u;this.f.fire(d.map(y=>({resource:S.URI.revive(y.resource),type:y.type})))}else{const d=u;this.g.fire(d)}}))}watch(u,d){const y=(0,$.$3f)();return this.a.call("watch",[this.h,y,u,d]),(0,O.$hc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$2M=p}),define(re[99],oe([0,1,14,8,161,13]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function O(C,p,g,u,d,y){let f;try{await R(C,p,g,u,d,y)}catch(o){f=o}finally{f&&d.errorTransformer&&(f=d.errorTransformer(f)),typeof f<"u"&&g.error(f),g.end()}}e.$Ap=O;async function R(C,p,g,u,d,y){S(y);const f=await C.open(p,{create:!1});try{S(y);let o=0,h=0,b=d&&typeof d.length=="number"?d.length:void 0,w=j.$Ed.alloc(Math.min(d.bufferSize,typeof b=="number"?b:d.bufferSize)),I=d&&typeof d.position=="number"?d.position:0,t=0;do h=await C.read(f,I,w.buffer,t,w.byteLength-t),I+=h,t+=h,o+=h,typeof b=="number"&&(b-=h),t===w.byteLength&&(await g.write(u(w)),w=j.$Ed.alloc(Math.min(d.bufferSize,typeof b=="number"?b:d.bufferSize)),t=0);while(h>0&&(typeof b!="number"||b>0)&&S(y)&&$(o,d));if(t>0){let c=t;typeof b=="number"&&(c=Math.min(t,b)),g.write(u(w.slice(0,c)))}}catch(o){throw(0,A.$fk)(o)}finally{await C.close(f)}}function S(C){if(C.isCancellationRequested)throw(0,N.$4)();return!0}function $(C,p){if(typeof p?.limits?.size=="number"&&C>p.limits.size)throw(0,A.$ek)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[54],oe([0,1,91,2,15,6,11,13]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=void 0;function S(o){return o.recursive===!0}e.$Cp=S;class $ extends N.$jc{static{this.a=5}constructor(h,b,w,I){super(),this.h=h,this.j=b,this.m=w,this.n=I,this.c=this.B(new N.$kc),this.f=void 0,this.g=0}s(){const h=new N.$ic;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(b=>this.h(b))),h.add(this.b.onDidLogMessage(b=>this.j(b))),h.add(this.b.onDidError(b=>this.t(b)))}t(h){this.n.restartOnError?this.g<$.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Dp=$;class C extends ${constructor(h,b,w){super(h,b,w,{type:"node.js",restartOnError:!1})}}e.$Ep=C;class p extends ${constructor(h,b,w){super(h,b,w,{type:"universal",restartOnError:!0})}}e.$Fp=p;function g(o){return o.map(h=>({type:h.type,resource:O.URI.file(h.path)}))}e.$Gp=g;function u(o){const h=new f;for(const b of o)h.processEvent(b);return h.coalesce()}e.$Hp=u;function d(o,h){return typeof h=="string"&&!h.startsWith(j.$mj)&&!(0,D.$7d)(h)?{base:o,pattern:h}:h}e.$Ip=d;function y(o,h){const b=[];for(const w of h)b.push((0,j.$qj)(d(o,w)));return b}e.$Jp=y;class f{constructor(){this.a=new Set,this.b=new Map}c(h){return A.$k?h.path:h.path.toLowerCase()}processEvent(h){const b=this.b.get(this.c(h));let w=!1;if(b){const I=b.type,t=h.type;b.path!==h.path&&(h.type===2||h.type===1)?w=!0:I===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(b)):I===2&&t===1?b.type=0:I===1&&t===0||(b.type=t)}else w=!0;w&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],b=[];return Array.from(this.a).filter(w=>w.type!==2?(h.push(w),!1):!0).sort((w,I)=>w.path.length-I.path.length).filter(w=>b.some(I=>(0,R.$lk)(w.path,I,!A.$k))?!1:(b.push(w.path),!0)).concat(h)}}}),define(re[191],oe([0,1,52,5,26,48,2,88,15,6,144,31,54]),function(te,e,j,N,D,A,O,R,S,$,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;class u extends O.$jc{static{this.a=100}static{this.b=75}constructor(f,o,h,b){super(),this.m=f,this.n=o,this.r=h,this.s=b,this.c=this.B(new N.$Ug({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.n(w))),this.f=this.B(new N.$Tg(w=>this.z(w),u.b)),this.g=(0,g.$Jp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$Jp)(this.m.path,this.m.includes):void 0,this.j=new D.$od,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const o=await p.Promises.stat(f);this.B(await this.w(f,o.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let o=f.path;try{o=await p.Promises.realpath(f.path),f.path===o&&(o=await(0,C.$Tp)(f.path)??f.path),f.path!==o&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${o})`)}catch{}return o}async w(f,o){if($.$j&&(0,A.$Hf)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$jc.None;const h=new D.$od(this.j.token),b=new O.$ic;try{const w=(0,S.$_d)(f),I=(0,j.watch)(f);b.add((0,O.$hc)(()=>{I.removeAllListeners(),I.close()})),this.G(`Started watching: '${f}'`);const t=new Set;if(o)try{for(const s of await p.Promises.readdir(f))t.add(s)}catch(s){this.D(s)}const c=new Map;b.add((0,O.$hc)(()=>{for(const[,s]of c)s.dispose();c.clear()})),I.on("error",(s,n)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${s}, ${n})`),this.dispose()}),I.on("change",(s,n)=>{if(h.token.isCancellationRequested)return;this.G(`[raw] ["${s}"] ${n}`);let i="";if(n&&(i=n.toString(),$.$j&&(i=(0,R.$gl)(i))),!(!i||s!=="change"&&s!=="rename"))if(o)if(s==="rename"){c.get(i)?.dispose();const r=setTimeout(async()=>{if(c.delete(i),i===w&&!await p.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.C((0,S.$8d)(f,i));if(h.token.isCancellationRequested)return;let E;l?t.has(i)?E=0:(E=1,t.add(i)):(t.delete(i),E=2),this.y({path:(0,S.$8d)(this.m.path,i),type:E})},u.a);c.set(i,(0,O.$hc)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.y({path:(0,S.$8d)(this.m.path,i),type:r})}else if(s==="rename"||i!==w){const r=setTimeout(async()=>{const l=await p.Promises.exists(f);h.token.isCancellationRequested||(l?(this.y({path:this.m.path,type:0},!0),b.add(await this.w(f,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},u.a);b.clear(),b.add((0,O.$hc)(()=>clearTimeout(r)))}else this.y({path:this.m.path,type:0},!0)})}catch(w){await p.Promises.exists(f)&&!h.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${w.toString()})`)}return(0,O.$hc)(()=>{h.dispose(!0),b.dispose()})}y(f,o=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!o&&this.g.some(h=>h(f.path))?this.s&&this.G(` >> ignored (excluded) ${f.path}`):!o&&this.h&&this.h.length>0&&!this.h.some(h=>h(f.path))?this.s&&this.G(` >> ignored (not included) ${f.path}`):this.f.work(f))}z(f){const o=(0,g.$Hp)(f);if(o.length>0){if(this.s)for(const b of o)this.G(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.c.work(o)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if($.$k)return p.Promises.exists(f);try{const o=(0,S.$_d)(f);return(await p.Promises.readdir((0,S.$$d)(f))).some(b=>b===o)}catch(o){return this.G(o),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Wp=u;async function d(y,f,o,h,b=512){const w=await p.Promises.open(y,"r"),I=Buffer.allocUnsafe(b),t=new D.$od(h);let c,s=!1;const n={path:y,excludes:[],recursive:!1},i=new u(n,r=>{(async()=>{for(const{type:l}of r)if(l===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:E}=await p.Promises.read(w,I,0,b,null);if(!E||t.token.isCancellationRequested)break;f(I.slice(0,E))}}catch(E){c=new Error(E),t.dispose(!0)}finally{s=!1}}})()});return await i.ready,o(),new Promise((r,l)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await p.Promises.close(w)}catch(E){c=new Error(E)}c?l(c):r()})})}e.$Xp=d}),define(re[192],oe([0,1,3,91,2,6,191]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class R extends D.$jc{constructor(){super(...arguments),this.a=this.B(new j.$ed),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$ed),this.onDidLogMessage=this.b.event,this.onDidError=j.Event.None,this.c=new Map,this.f=!1}async watch($){const C=this.j($),p=C.filter(u=>{const d=this.c.get(u.path);return d?!(0,N.$uj)(d.request.excludes,u.excludes)||!(0,N.$uj)(d.request.includes,u.includes):!0}),g=Array.from(this.c.values()).filter(({request:u})=>!C.find(d=>d.path===u.path&&(0,N.$uj)(d.excludes,u.excludes)&&(0,N.$uj)(d.includes,u.includes))).map(({request:u})=>u.path);p.length&&this.m(`Request to start watching: ${p.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const u of g)this.h(u);for(const u of p)this.g(u)}g($){const C=new O.$Wp($,g=>this.a.fire(g),g=>this.b.fire(g),this.f),p={request:$,instance:C};this.c.set($.path,p)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const C=this.c.get($);C&&(this.c.delete($),C.instance.dispose())}j($){const C=new Map;for(const p of $){const g=A.$k?p.path:p.path.toLowerCase();C.set(g,p)}return Array.from(C.values())}async setVerboseLogging($){this.f=$;for(const[,C]of this.c)C.instance.setVerboseLogging($)}m($){this.f&&this.b.fire({type:"trace",message:this.n($)})}n($,C){return C?`[File Watcher (node.js)] ${$} (path: ${C.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$Yp=R}),define(re[193],oe([0,1,54,192]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class D extends j.$Ep{constructor(O,R,S){super(O,R,S),this.s()}r(O){return O.add(new N.$Yp)}}e.$Zp=D}),define(re[194],oe([0,1,23,43,93,54]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class O extends A.$Fp{constructor(S,$,C){super(S,$,C),this.s()}r(S){const $=S.add(new D.$Qp(j.$1f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add($.onDidProcessExit(({code:C,signal:p})=>this.t(`terminated by itself with code ${C}, signal: ${p}`))),N.ProxyChannel.toService((0,N.$hh)($.getChannel("watcher")))}}e.$Rp=O}),define(re[70],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class j{constructor(...D){this.a=new Map;for(const[A,O]of D)this.set(A,O)}set(D,A){const O=this.a.get(D);return this.a.set(D,A),O}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$yh=j}),define(re[195],oe([0,1,5,8,2,68,186,4,70,87]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;const C=!1;class p extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class g{constructor(f=new S.$yh,o=!1,h,b=C){this.f=f,this.g=o,this.h=h,this.i=b,this.o=new Set,this.f.set(R.$zh,this),this._globalGraph=b?h?._globalGraph??new O.$3p(w=>w):void 0}createChild(f){return new g(f,this.g,this,this.i)}invokeFunction(f,...o){const h=d.traceInvocation(this.i,f);let b=!1;try{return f({get:I=>{if(b)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(I,h);if(!t)throw new Error(`[invokeFunction] unknown service '${I}'`);return t}},...o)}finally{b=!0,h.stop()}}createInstance(f,...o){let h,b;return f instanceof A.$xh?(h=d.traceCreation(this.i,f.ctor),b=this.j(f.ctor,f.staticArguments.concat(o),h)):(h=d.traceCreation(this.i,f),b=this.j(f,o,h)),h.stop(),b}j(f,o=[],h){const b=R._util.getServiceDependencies(f).sort((t,c)=>t.index-c.index),w=[];for(const t of b){const c=this.m(t.id,h);c||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(c)}const I=b.length>0?b[0].index:o.length;if(o.length!==I){console.trace(`[createInstance] First service dependency of ${f.name} at position ${I+1} conflicts with ${o.length} static arguments`);const t=I-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,I)}return Reflect.construct(f,o.concat(w))}k(f,o){if(this.f.get(f)instanceof A.$xh)this.f.set(f,o);else if(this.h)this.h.k(f,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const o=this.f.get(f);return!o&&this.h?this.h.l(f):o}m(f,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const h=this.l(f);return h instanceof A.$xh?this.q(f,h,o.branch(f,!0)):(o.branch(f,!1),h)}q(f,o,h){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,o,h)}finally{this.o.delete(f)}}r(f,o,h){const b=new O.$3p(t=>t.id.toString());let w=0;const I=[{id:f,desc:o,_trace:h}];for(;I.length;){const t=I.pop();if(b.lookupOrInsertNode(t),w++>1e3)throw new p(b);for(const c of R._util.getServiceDependencies(t.desc.ctor)){const s=this.l(c.id);if(s||this.u(`[createInstance] ${f} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),s instanceof A.$xh){const n={id:c.id,desc:s,_trace:t._trace.branch(c.id,!0)};b.insertEdge(t,n),I.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new p(b);break}for(const{data:c}of t){if(this.l(c.id)instanceof A.$xh){const n=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,n)}b.removeNode(c)}}return this.l(f)}s(f,o,h=[],b,w){if(this.f.get(f)instanceof A.$xh)return this.t(f,o,h,b,w);if(this.h)return this.h.s(f,o,h,b,w);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(f,o,h=[],b,w){if(b){const I=new g(void 0,this.g,this,this.i);I.c=String(f);const t=new Map,c=new j.$Wg(()=>{const s=I.j(o,h,w);for(const[n,i]of t){const r=s[n];if(typeof r=="function")for(const l of i)r.apply(s,l)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!c.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=t.get(n);return l||(l=new $.$sc,t.set(n,l)),(m,a,v)=>{const L=l.push([m,a,v]);return(0,D.$hc)(L)}}if(n in s)return s[n];const i=c.value;let r=i[n];return typeof r!="function"||(r=r.bind(i),s[n]=r),r},set(s,n,i){return c.value[n]=i,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,h,w)}u(f,o){if(o&&console.warn(f),this.g)throw new Error(f)}}e.$4p=g;var u;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(u||(u={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,o){return f?new d(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(f,o){return f?new d(1,o.name):d.c}static{this.f=0}constructor(f,o){this.type=f,this.name=o,this.g=Date.now(),this.h=[]}branch(f,o){const h=new d(3,f.toString());return this.h.push([f,o,h]),h}stop(){const f=Date.now()-this.g;d.f+=f;let o=!1;function h(w,I){const t=[],c=new Array(w+1).join("	");for(const[s,n,i]of I.h)if(n&&i){o=!0,t.push(`${c}CREATES -> ${s}`);const r=h(w+1,i);r&&t.push(r)}else t.push(`${c}uses -> ${s}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(f>2||o)&&d.all.add(b.join(`
`))}}e.$5p=d}),define(re[71],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=void 0,e.$46b=(0,j.$Ah)("mainProcessService");class N{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.$56b=N}),define(re[72],oe([0,1,26,2,6,163,29,4]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0;function S(C){return C.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.$Fq=S,e.$Gq=(0,R.$Ah)("languagePackService");let $=class extends N.$jc{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new j.$od;setTimeout(()=>p.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const d=g.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(f=>f.startsWith("lp-"))).map(y=>{const f=y.properties.localizedLanguages?.[0],o=S(y);return{...this.f(o,f,y),extensionId:y.identifier.id,galleryExtension:y}});return d.push(this.f("en","English")),d}f(p,g,u){const d=g??p;let y;if(d!==p&&(y=`(${p})`),p.toLowerCase()===D.$v.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),u?.installCount){y??="";const f=u.installCount;let o;f>1e6?o=`${Math.floor(f/1e5)/10}M`:f>1e3?o=`${Math.floor(f/1e3)}K`:o=String(f),y+=` $(cloud-download) ${o}`}return{id:p,label:d,description:y}}};e.$Hq=$,e.$Hq=$=ye([Y(0,O.$Yn)],$)}),define(re[196],oe([0,1,2,72]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;let D=class extends j.$jc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$q7b=D,e.$q7b=D=ye([Y(0,N.$Gq)],D)}),define(re[7],oe([0,1,38,3,51,2,35,6,22,9,11,94,4]),function(te,e,j,N,D,A,O,R,S,$,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,g.$Ah)("logService"),e.$5i=(0,g.$Ah)("loggerService");function u(){return new Date().toISOString()}function d(m){return(0,$.$mf)(m)}e.$6i=d;var y;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$7i=y.Info;function f(m,a,v){switch(a){case y.Trace:m.trace(v);break;case y.Debug:m.debug(v);break;case y.Info:m.info(v);break;case y.Warning:m.warn(v);break;case y.Error:m.error(v);break;case y.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=f;function o(m,a=!1){let v="";for(let L=0;L<m.length;L++){let T=m[L];if(T instanceof Error&&(T=(0,j.$li)(T,a)),typeof T=="object")try{T=JSON.stringify(T)}catch{}v+=(L>0?" ":"")+T}return v}class h extends A.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new N.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==y.Off&&this.b<=a}}e.$9i=h;class b extends h{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...v){this.f(y.Trace)&&this.g(y.Trace,o([a,...v],!0))}debug(a,...v){this.f(y.Debug)&&this.g(y.Debug,o([a,...v]))}info(a,...v){this.f(y.Info)&&this.g(y.Info,o([a,...v]))}warn(a,...v){this.f(y.Warning)&&this.g(y.Warning,o([a,...v]))}error(a,...v){if(this.f(y.Error))if(a instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=a.stack,this.g(y.Error,o(L))}else this.g(y.Error,o([a,...v]))}flush(){}}e.$0i=b;class w extends h{constructor(a=e.$7i){super(),this.setLevel(a),this.g=!R.$i}trace(a,...v){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...v):console.log(`[main ${u()}]`,a,...v))}debug(a,...v){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...v):console.log(`[main ${u()}]`,a,...v))}info(a,...v){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...v):console.log(`[main ${u()}]`,a,...v))}warn(a,...v){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,a,...v):console.warn(`[main ${u()}]`,a,...v))}error(a,...v){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,a,...v):console.error(`[main ${u()}]`,a,...v))}dispose(){}flush(){}}e.$$i=w;class I extends h{constructor(a=e.$7i,v=!0){super(),this.g=v,this.setLevel(a)}trace(a,...v){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",a,...v):console.log(a,...v))}debug(a,...v){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",a,...v):console.log(a,...v))}info(a,...v){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",a,...v):console.log(a,...v))}warn(a,...v){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",a,...v):console.log(a,...v))}error(a,...v){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",a,...v):console.error(a,...v))}dispose(){}flush(){}}e.$_i=I;class t extends h{constructor(a,v=e.$7i){super(),this.g=a,this.setLevel(v)}trace(a,...v){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(a),...v])}debug(a,...v){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(a),...v])}info(a,...v){this.f(y.Info)&&this.g.log(y.Info,[this.h(a),...v])}warn(a,...v){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(a),...v])}error(a,...v){this.f(y.Error)&&this.g.log(y.Error,[this.h(a),...v])}h(a){return typeof a=="string"?a:(0,j.$li)(a,this.f(y.Trace))}dispose(){}flush(){}}e.$aj=t;class c extends h{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const v of this.g)v.setLevel(a);super.setLevel(a)}trace(a,...v){for(const L of this.g)L.trace(a,...v)}debug(a,...v){for(const L of this.g)L.debug(a,...v)}info(a,...v){for(const L of this.g)L.info(a,...v)}warn(a,...v){for(const L of this.g)L.warn(a,...v)}error(a,...v){for(const L of this.g)L.error(a,...v)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.$bj=c;class s extends A.$jc{constructor(a,v,L){if(super(),this.h=a,this.j=v,this.b=new O.$yi,this.c=this.B(new N.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$ed),this.onDidChangeVisibility=this.g.event,L)for(const T of L)this.b.set(T.resource,{logger:void 0,info:T})}m(a){return(0,$.$if)(a)?[...this.b.values()].find(v=>v.info.id===a):this.b.get(a)}getLogger(a){return this.m(a)?.logger}createLogger(a,v){const L=this.n(a),T=(0,$.$if)(a)?a:v?.id??(0,D.$oi)(L.toString()).toString(16);let z=this.b.get(L)?.logger;const U=v?.logLevel==="always"?y.Trace:v?.logLevel;z||(z=this.s(L,U??this.getLogLevel(L)??this.h,{...v,id:T}));const B={logger:z,info:{resource:L,id:T,logLevel:U,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(B.info),this.b.set(L,B),z}n(a){return(0,$.$if)(a)?(0,S.$hg)(this.j,`${a}.log`):a}setLogLevel(a,v){if(C.URI.isUri(a)){const L=a,T=v,z=this.b.get(L);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([L,T]))}else{this.h=a;for(const[L,T]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(a,v){const L=this.m(a);L&&v!==!L.info.hidden&&(L.info.hidden=!v,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,v]))}getLogLevel(a){let v;return a&&(v=this.b.get(a)?.info.logLevel),v??this.h}registerLogger(a){const v=this.b.get(a.resource);v?v.info.hidden!==a.hidden&&this.setVisibility(a.resource,!a.hidden):(this.b.set(a.resource,{info:a,logger:void 0}),this.c.fire({added:[a],removed:[]}))}deregisterLogger(a){const v=this.b.get(a);v&&(v.logger&&v.logger.dispose(),this.b.delete(a),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const a of this.b.values())yield a.info}getRegisteredLogger(a){return this.b.get(a)?.info}dispose(){this.b.forEach(a=>a.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=s;class n{constructor(){this.onDidChangeLogLevel=new N.$ed().event}setLevel(a){}getLevel(){return y.Info}trace(a,...v){}debug(a,...v){}info(a,...v){}warn(a,...v){}error(a,...v){}critical(a,...v){}dispose(){}flush(){}}e.$dj=n;class i extends n{}e.$ej=i;function r(m){if(m.verbose)return y.Trace;if(typeof m.logLevel=="string"){const a=E(m.logLevel.toLowerCase());if(a!==void 0)return a}return e.$7i}e.$fj=r;function l(m){switch(m){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$gj=l;function E(m){switch(m){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$hj=E,e.$ij=new p.$1i("logLevel",l(y.Info))}),define(re[197],oe([0,1,5,8,2,23,15,22,31,16,7]),function(te,e,j,N,D,A,O,R,S,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=void 0;let p=class extends D.$jc{constructor(u,d){super(),this.a=u,this.b=d,this.B(new j.$Rg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const u=(0,R.$eg)(this.a.logsHome),d=(0,R.$gg)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,o=(await S.Promises.readdir(d)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==u),h=o.slice(0,Math.max(0,o.length-9));h.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(b=>S.Promises.rm((0,O.$8d)(d,b)))))}catch(u){(0,N.$Y)(u)}}};e.$r7b=p,e.$r7b=p=ye([Y(0,$.$Hh),Y(1,C.$4i)],p)}),define(re[198],oe([0,1,18,5,8,3,2,15,54,7]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class C extends O.$jc{constructor(g,u){super(),this.a=g,this.b=u,this.c=this.B(new A.$ed),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ed),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Dg(0)),this.w=[],this.y=this.B(new N.$Dg(0))}watch(g,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(g,u):this.z(g,u)}n(g,u){const d={path:this.H(g),excludes:u.excludes,includes:u.includes,recursive:u.recursive},y=(0,j.$Rb)(this.j,d);return this.r(),(0,O.$hc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,D.$Y)(g))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,S.$Gp)(u)),u=>this.G(u),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const u of this.j)(0,S.$Cp)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const u of this.j)(0,S.$Cp)(u)&&g.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,u){const d={path:this.H(g),excludes:u.excludes,includes:u.includes,recursive:!1},y=(0,j.$Rb)(this.w,d);return this.C(),(0,O.$hc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,D.$Y)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,S.$Gp)(g)),g=>this.G(g),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,R.$6d)(g.fsPath)}}e.$Kp=C}),define(re[199],oe([0,1,18,5,14,26,3,51,59,2,47,23,100,22,42,159,13,99,7,8]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;let w=class extends $.$jc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new O.$ed),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$ed),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$ed),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$ed),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$ed),this.onDidFilesChange=this.X.event,this.Y=this.B(new O.$ed),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new N.$Og)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const s=new $.$ic;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),s.add(c.onDidChangeFile(n=>this.X.fire(new f.$kk(n,!this.S(c))))),typeof c.onDidWatchError=="function"&&s.add(c.onDidWatchError(n=>this.Y.fire(new Error(n)))),s.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,$.$hc)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,$.$ec)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(s){c.push(s)}}),!this.h.has(t)&&await N.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&c)}listCapabilities(){return S.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,u.$lg)(t))throw new f.$mk((0,y.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const s=new b.$_;throw s.message=(0,y.localize)(1,null,t.toString()),s}return c}async m(t){const c=await this.j(t);if((0,f.$0j)(c)||(0,f.$7j)(c)||(0,f.$$j)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const c=await this.j(t);if((0,f.$0j)(c)||(0,f.$7j)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.s(t,c)}catch(s){throw(0,f.$hk)(s)===f.FileSystemProviderErrorCode.FileNotFound?new f.$mk((0,y.localize)(2,null,this.rb(t)),1):(0,f.$fk)(s)}}async s(t,c){const s=await this.j(t),n=this.S(s),i=c?.resolveTo,r=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,E=await s.stat(t);let m;return this.t(s,t,E,void 0,!!l,(a,v)=>(m||(m=C.$Gh.forUris(()=>!n),m.set(t,!0),i&&m.fill(!0,i)),m.get(a.resource)||m.findSuperstr(a.resource.with({query:null,fragment:null}))?!0:a.isDirectory&&r?v===1:!1))}async t(t,c,s,n,i,r){const{providerExtUri:l}=this.R(t),E={resource:c,name:l.basename(c),isFile:(s.type&f.FileType.File)!==0,isDirectory:(s.type&f.FileType.Directory)!==0,isSymbolicLink:(s.type&f.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&f.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&f.FilePermission.Locked),etag:(0,f.$xk)({mtime:s.mtime,size:s.size}),children:void 0};if(E.isDirectory&&r(E,n)){try{const m=await t.readdir(c),a=await N.Promises.settled(m.map(async([v,L])=>{try{const T=l.joinPath(c,v),z=i?await t.stat(T):{type:L};return await this.t(t,T,z,m.length,i,r)}catch(T){return this.b.trace(T),null}}));E.children=(0,j.$Eb)(a)}catch(m){this.b.trace(m),E.children=[]}return E}return E}async resolveAll(t){return N.Promises.settled(t.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),s=await c.stat(t);return this.t(c,t,s,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.u(t,c)}catch(s){return s}return!0}async u(t,c){if(!c?.overwrite&&await this.exists(t))throw new f.$mk((0,y.localize)(3,null,this.rb(t)),3,c)}async createFile(t,c=D.$Ed.fromString(""),s){await this.u(t,s);const n=await this.writeFile(t,c);return this.r.fire(new f.$jk(t,0,n)),n}async writeFile(t,c,s){const n=this.pb(await this.n(t),t),{providerExtUri:i}=this.R(n);try{await this.w(n,t,s)||await this.U(n,i.dirname(t));let l;if((0,f.$7j)(n)&&!(c instanceof D.$Ed))if((0,d.$qd)(c)){const E=await(0,d.$xd)(c,3);E.ended?l=D.$Ed.concat(E.buffer):l=E}else l=(0,d.$ud)(c,E=>D.$Ed.concat(E),3);else l=c;if(!(0,f.$0j)(n)||(0,f.$7j)(n)&&l instanceof D.$Ed)await this.gb(n,t,s,l);else{const E=l instanceof D.$Ed?(0,D.$Pd)(l):l;s?.atomic!==!1&&s?.atomic?.postfix?await this.bb(n,t,(0,u.$hg)((0,u.$gg)(t),`${(0,u.$eg)(t)}${s.atomic.postfix}`),s,E):await this.cb(n,t,s,E)}this.r.fire(new f.$jk(t,4))}catch(r){throw new f.$mk((0,y.localize)(4,null,this.rb(t),(0,f.$fk)(r).toString()),(0,f.$ik)(r),s)}return this.resolve(t,{resolveMetadata:!0})}async w(t,c,s){const n=!!s?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.rb(c)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,y.localize)(6,null,this.rb(c)));if(n)throw new Error((0,y.localize)(7,null,this.rb(c)))}let r;try{r=await t.stat(c)}catch{return}if(r.type&f.FileType.Directory)throw new f.$mk((0,y.localize)(8,null,this.rb(c)),0,s);if(this.qb(c,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==f.$wk&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,f.$xk)({mtime:s.mtime,size:r.size}))throw new f.$mk((0,y.localize)(9,null),3,s);return r}async readFile(t,c,s){const n=await this.m(t);return c?.atomic?this.z(n,t,c,s):this.C(n,t,c,s)}async z(t,c,s,n){return new Promise((i,r)=>{this.ab.queueFor(c,this.R(t).providerExtUri).queue(async()=>{try{const l=await this.C(t,c,s,n);i(l)}catch(l){r(l)}})})}async C(t,c,s,n){const i=await this.D(t,c,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,D.$Qd)(i.value)}}async readFileStream(t,c,s){const n=await this.m(t);return this.D(n,t,c,s)}async D(t,c,s,n){const i=new A.$od(n),r=this.J(c,s).then(E=>E,E=>{throw i.dispose(!0),E});let l;try{return typeof s?.etag=="string"&&s.etag!==f.$wk&&await r,s?.atomic&&(0,f.$_j)(t)||!((0,f.$0j)(t)||(0,f.$$j)(t))||(0,f.$7j)(t)&&s?.preferUnbuffered?l=this.I(t,c,s):(0,f.$$j)(t)?l=this.G(t,c,i.token,s):l=this.H(t,c,i.token,s),l.on("end",()=>i.dispose()),l.on("error",()=>i.dispose()),{...await r,value:l}}catch(E){throw l&&await(0,d.$vd)(l),this.F(E,c,s)}}F(t,c,s){const n=(0,y.localize)(10,null,this.rb(c),(0,f.$fk)(t).toString());return t instanceof f.$ok?new f.$ok(n,t.stat,s):t instanceof f.$nk?new f.$nk(n,t.fileOperationResult,t.size,t.options):new f.$mk(n,(0,f.$ik)(t),s)}G(t,c,s,n=Object.create(null)){const i=t.readFileStream(c,n,s);return(0,d.$Bd)(i,{data:r=>r instanceof D.$Ed?r:D.$Ed.wrap(r),error:r=>this.F(r,c,n)},r=>D.$Ed.concat(r))}H(t,c,s,n=Object.create(null)){const i=(0,D.$Ud)();return(0,o.$Ap)(t,c,i,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>this.F(r,c,n)},s),i}I(t,c,s){const n=(0,d.$sd)(i=>D.$Ed.concat(i));return(async()=>{try{let i;s?.atomic&&(0,f.$_j)(t)?i=await t.readFile(c,{atomic:!0}):i=await t.readFile(c),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.L(c,i.byteLength,s),n.end(D.$Ed.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async J(t,c){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new f.$mk((0,y.localize)(11,null,this.rb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==f.$wk&&c.etag===s.etag)throw new f.$ok((0,y.localize)(12,null),s,c);return this.L(t,s.size,c),s}L(t,c,s){if(typeof s?.limits?.size=="number"&&c>s.limits.size)throw new f.$nk((0,y.localize)(13,null,this.rb(t)),7,c,s)}async canMove(t,c,s){return this.M(t,c,"move",s)}async canCopy(t,c,s){return this.M(t,c,"copy",s)}async M(t,c,s,n){if(t.toString()!==c.toString())try{const i=s==="move"?this.pb(await this.n(t),t):await this.m(t),r=this.pb(await this.n(c),c);await this.Q(i,t,r,c,s,n)}catch(i){return i}return!0}async move(t,c,s){const n=this.pb(await this.n(t),t),i=this.pb(await this.n(c),c),r=await this.N(n,t,i,c,"move",!!s),l=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new f.$jk(t,r==="move"?2:3,l)),l}async copy(t,c,s){const n=await this.m(t),i=this.pb(await this.n(c),c),r=await this.N(n,t,i,c,"copy",!!s),l=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new f.$jk(t,r==="copy"?3:2,l)),l}async N(t,c,s,n,i,r){if(c.toString()===n.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:E}=await this.Q(t,c,s,n,i,r);if(l&&!E&&r&&await this.del(n,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(n)),i==="copy"){if(t===s&&(0,f.$8j)(t))await t.copy(c,n,{overwrite:r});else{const m=await this.resolve(c);m.isDirectory?await this.P(t,m,s,n):await this.O(t,c,s,n)}return i}else return t===s?(await t.rename(c,n,{overwrite:r}),i):(await this.N(t,c,s,n,"copy",r),await this.del(c,{recursive:!0}),"copy")}async O(t,c,s,n){if((0,f.$0j)(t)&&(0,f.$0j)(s))return this.ib(t,c,s,n);if((0,f.$0j)(t)&&(0,f.$7j)(s))return this.ob(t,c,s,n);if((0,f.$7j)(t)&&(0,f.$0j)(s))return this.mb(t,c,s,n);if((0,f.$7j)(t)&&(0,f.$7j)(s))return this.kb(t,c,s,n)}async P(t,c,s,n){await s.mkdir(n),Array.isArray(c.children)&&await N.Promises.settled(c.children.map(async i=>{const r=this.R(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.P(t,await this.resolve(i.resource),s,r):this.O(t,i.resource,s,r)}))}async Q(t,c,s,n,i,r){let l=!1;if(t===s){const{providerExtUri:m,isPathCaseSensitive:a}=this.R(t);if(a||(l=m.isEqual(c,n)),l&&i==="copy")throw new Error((0,y.localize)(14,null,this.rb(c),this.rb(n)));if(!l&&m.isEqualOrParent(n,c))throw new Error((0,y.localize)(15,null,this.rb(c),this.rb(n)))}const E=await this.exists(n);if(E&&!l){if(!r)throw new f.$mk((0,y.localize)(16,null,this.rb(c),this.rb(n)),4);if(t===s){const{providerExtUri:m}=this.R(t);if(m.isEqualOrParent(c,n))throw new Error((0,y.localize)(17,null,this.rb(c),this.rb(n)))}}return{exists:E,isSameResourceWithDifferentPathCase:l}}R(t){const c=this.S(t);return{providerExtUri:c?u.$0f:u.$_f,isPathCaseSensitive:c}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.pb(await this.j(t),t);await this.U(c,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new f.$jk(t,0,s)),s}async U(t,c){const s=[],{providerExtUri:n}=this.R(t);for(;!n.isEqual(c,n.dirname(c));)try{if(!((await t.stat(c)).type&f.FileType.Directory))throw new Error((0,y.localize)(18,null,this.rb(c)));break}catch(i){if((0,f.$hk)(i)!==f.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(c)),c=n.dirname(c)}for(let i=s.length-1;i>=0;i--){c=n.joinPath(c,s[i]);try{await t.mkdir(c)}catch(r){if((0,f.$hk)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,c){try{await this.W(t,c)}catch(s){return s}return!0}async W(t,c){const s=this.pb(await this.j(t),t),n=!!c?.useTrash;if(n&&!(s.capabilities&4096))throw new Error((0,y.localize)(19,null,this.rb(t)));const i=c?.atomic;if(i&&!(s.capabilities&65536))throw new Error((0,y.localize)(20,null,this.rb(t)));if(n&&i)throw new Error((0,y.localize)(21,null,this.rb(t)));let r;try{r=await s.stat(t)}catch{}if(r)this.qb(t,r);else throw new f.$mk((0,y.localize)(22,null,this.rb(t)),1);if(!!!c?.recursive){const E=await this.resolve(t);if(E.isDirectory&&Array.isArray(E.children)&&E.children.length>0)throw new Error((0,y.localize)(23,null,this.rb(t)))}return s}async del(t,c){const s=await this.W(t,c),n=!!c?.useTrash,i=!!c?.recursive,r=c?.atomic??!1;await s.delete(t,{recursive:i,useTrash:n,atomic:r}),this.r.fire(new f.$jk(t,1))}async cloneFile(t,c){const s=await this.j(t),n=this.pb(await this.n(c),c);if(s===n&&this.R(s).providerExtUri.isEqual(t,c))return;if(s===n&&(0,f.$9j)(s))return s.cloneFile(t,c);await this.U(n,this.R(n).providerExtUri.dirname(c));const i=this.ab.queueFor(t,this.R(s).providerExtUri);return s===n&&(0,f.$8j)(s)?i.queue(()=>s.copy(t,c,{overwrite:!0})):i.queue(()=>this.O(s,t,n,c))}watch(t,c={recursive:!1,excludes:[]}){const s=new $.$ic;let n=!1,i=()=>{n=!0};return s.add((0,$.$hc)(()=>i())),(async()=>{try{const r=await this.$(t,c);n?(0,$.$ec)(r):i=()=>(0,$.$ec)(r)}catch(r){this.b.error(r)}})(),s}async $(t,c){const s=await this.j(t),n=(0,R.$oi)([this.R(s).providerExtUri.getComparisonKey(t),c]);let i=this.Z.get(n);return i||(i={count:0,disposable:s.watch(t,c)},this.Z.set(n,i)),i.count+=1,(0,$.$hc)(()=>{i&&(i.count--,i.count===0&&((0,$.$ec)(i.disposable),this.Z.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,$.$ec)(t.disposable);this.Z.clear()}async bb(t,c,s,n,i){await this.cb(t,s,n,i);try{await t.rename(s,c,{overwrite:!0})}catch(r){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async cb(t,c,s,n){return this.ab.queueFor(c,this.R(t).providerExtUri).queue(async()=>{const i=await t.open(c,{create:!0,unlock:s?.unlock??!1});try{(0,d.$qd)(n)||(0,d.$rd)(n)?await this.db(t,i,n):await this.eb(t,i,n)}catch(r){throw(0,f.$fk)(r)}finally{await t.close(i)}})}async db(t,c,s){let n=0,i;if((0,d.$rd)(s)){if(s.buffer.length>0){const r=D.$Ed.concat(s.buffer);await this.fb(t,c,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((r,l)=>{(0,d.$wd)(i,{onData:async E=>{i.pause();try{await this.fb(t,c,E,E.byteLength,n,0)}catch(m){return l(m)}n+=E.byteLength,setTimeout(()=>i.resume())},onError:E=>l(E),onEnd:()=>r()})})}async eb(t,c,s){let n=0,i;for(;(i=s.read())!==null;)await this.fb(t,c,i,i.byteLength,n,0),n+=i.byteLength}async fb(t,c,s,n,i,r){let l=0;for(;l<n;){const E=await t.write(c,i+l,s.buffer,r+l,n-l);l+=E}}async gb(t,c,s,n){return this.ab.queueFor(c,this.R(t).providerExtUri).queue(()=>this.hb(t,c,s,n))}async hb(t,c,s,n){let i;n instanceof D.$Ed?i=n:(0,d.$qd)(n)?i=await(0,D.$Qd)(n):(0,d.$rd)(n)?i=await(0,D.$Rd)(n):i=(0,D.$Od)(n),await t.writeFile(c,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async ib(t,c,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.jb(t,c,s,n))}async jb(t,c,s,n){let i,r;try{i=await t.open(c,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const l=D.$Ed.alloc(this.a);let E=0,m=0,a=0;do a=await t.read(i,E,l.buffer,m,l.byteLength-m),await this.fb(s,r,l,a,E,m),E+=a,m+=a,m===l.byteLength&&(m=0);while(a>0)}catch(l){throw(0,f.$fk)(l)}finally{await N.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async kb(t,c,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.lb(t,c,s,n))}async lb(t,c,s,n){return s.writeFile(n,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,c,s,n){return this.ab.queueFor(n,this.R(s).providerExtUri).queue(()=>this.nb(t,c,s,n))}async nb(t,c,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(c);await this.fb(s,i,D.$Ed.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.$fk)(r)}finally{await s.close(i)}}async ob(t,c,s,n){const i=await(0,D.$Qd)(this.H(t,c,A.CancellationToken.None));await this.gb(s,n,void 0,i)}pb(t,c){if(t.capabilities&2048)throw new f.$mk((0,y.localize)(24,null,this.rb(c)),6);return t}qb(t,c){if((c.permissions??0)&f.FilePermission.Readonly)throw new f.$mk((0,y.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};e.$Bp=w,e.$Bp=w=ye([Y(0,h.$4i)],w)}),define(re[200],oe([0,1,52,271,5,35,14,3,48,2,15,6,22,42,31,162,13,99,198,38,194,193]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0,(()=>{try{(0,N.gracefulify)(j)}catch(c){console.error(`Error enabling graceful-fs: ${(0,b.$li)(c)}`)}})();class t extends h.$Kp{static{this.I=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=R.Event.None,this.N=new A.$yi(i=>g.$$f.getComparisonKey(i)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,p.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:n,symbolicLink:i}=await d.SymlinkSupport.stat(this.H(s));return{type:this.M(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:f.FilePermission.Locked}}catch(n){throw this.eb(n)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await d.Promises.readdir(this.H(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,g.$hg)(s,r.name))).type:l=this.M(r),i.push([r.name,l])}catch(l){this.a.trace(l)}})),i}catch(n){throw this.eb(n)}}M(s,n){let i;return n?.dangling?i=f.FileType.Unknown:s.isFile()?i=f.FileType.File:s.isDirectory()?i=f.FileType.Directory:i=f.FileType.Unknown,n&&(i|=f.FileType.SymbolicLink),i}async O(s){const n=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const r=new D.$Eg;return this.N.set(s,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,$.$hc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(s)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),i=await this.O(s));const r=this.H(s);return await d.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{i?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,n,i){const r=(0,u.$sd)(l=>O.$Ed.concat(l.map(E=>O.$Ed.wrap(E))).buffer);return(0,o.$Ap)(this,s,r,l=>l.buffer,{...n,bufferSize:256*1024},i),r}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.Q(s,(0,g.$hg)((0,g.$gg)(s),`${(0,g.$eg)(s)}${i.atomic.postfix}`),n,i):this.R(s,n,i)}async Q(s,n,i,r){await this.R(n,i,r);try{await this.rename(n,s,{overwrite:!0})}catch(l){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async R(s,n,i){let r;try{const l=this.H(s);if(!i.create||!i.overwrite){if(await d.Promises.exists(l)){if(!i.overwrite)throw(0,f.$ek)((0,y.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,f.$ek)((0,y.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(s,{create:!0,unlock:i.unlock}),await this.write(r,0,n,0,n.byteLength)}catch(l){throw await this.fb(s,l)}finally{typeof r=="number"&&await this.close(r)}}static{this.X=!0}static configureFlushOnWrite(s){t.X=s}async open(s,n){const i=this.H(s);let r;(0,f.$6j)(n)&&(r=await this.O(s));let l;try{if((0,f.$6j)(n)&&n.unlock)try{const{stat:m}=await d.SymlinkSupport.stat(i);m.mode&128||await d.Promises.chmod(i,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let E;if((0,f.$6j)(n)){if(p.$i)try{await d.Promises.truncate(i,0),E="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}E||(E="w")}else E="r";l=await d.Promises.open(i,E)}catch(E){throw r?.dispose(),(0,f.$6j)(n)?await this.fb(s,E):this.eb(E)}if(this.S.set(l,0),(0,f.$6j)(n)&&this.W.set(l,s),r){const E=this.U.get(l);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${i})`),this.U.set(l,r),E&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${i})`),E.dispose())}return l}async close(s){const n=this.U.get(s);try{if(this.S.delete(s),this.W.delete(s)&&t.X)try{await d.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await d.Promises.close(s)}catch(i){throw this.eb(i)}finally{n&&(this.U.get(s)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.U.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,r,l){const E=this.Y(s,n);let m=null;try{m=(await d.Promises.read(s,i,r,l,E)).bytesRead}catch(a){throw this.eb(a)}finally{this.Z(s,E,m)}return m}Y(s,n){return n===this.S.get(s)?null:n}Z(s,n,i){const r=this.S.get(s);typeof r=="number"&&(typeof n=="number"||(typeof i=="number"?this.S.set(s,r+i):this.S.delete(s)))}async write(s,n,i,r,l){return(0,D.$Xg)(()=>this.$(s,n,i,r,l),100,3)}async $(s,n,i,r,l){const E=this.Y(s,n);let m=null;try{m=(await d.Promises.write(s,i,r,l,E)).bytesWritten}catch(a){throw await this.fb(this.W.get(s),a)}finally{this.Z(s,E,m)}return m}async mkdir(s){try{await d.Promises.mkdir(this.H(s))}catch(n){throw this.eb(n)}}async delete(s,n){try{const i=this.H(s);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,C.$8d)((0,C.$$d)(i),`${(0,C.$_d)(i)}${n.atomic.postfix}`)),await d.Promises.rm(i,d.RimRafMode.MOVE,r)}else try{await d.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:E,symbolicLink:m}=await d.SymlinkSupport.stat(i);l=E.isDirectory()&&!m}catch{}if(l)await d.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.eb(i)}}async rename(s,n,i){const r=this.H(s),l=this.H(n);if(r!==l)try{await this.ab(s,n,"move",i.overwrite),await d.Promises.rename(r,l)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,y.localize)(2,null,(0,C.$_d)(r),(0,C.$_d)((0,C.$$d)(l)),E.toString()))),this.eb(E)}}async copy(s,n,i){const r=this.H(s),l=this.H(n);if(r!==l)try{await this.ab(s,n,"copy",i.overwrite),await d.Promises.copy(r,l,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,y.localize)(3,null,(0,C.$_d)(r),(0,C.$_d)((0,C.$$d)(l)),E.toString()))),this.eb(E)}}async ab(s,n,i,r){const l=this.H(s),E=this.H(n);let m=!1;if(!!(this.capabilities&1024)||(m=(0,S.$Gf)(l,E,!0)),m){if(i==="copy")throw(0,f.$ek)((0,y.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const v=await this.L(s);if(!v)throw(0,f.$ek)((0,y.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(n);if(L){if(!r)throw(0,f.$ek)((0,y.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);v.type&f.FileType.File&&L.type&f.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.bb(s,n,!1)}async bb(s,n,i){const r=this.H(s),l=this.H(n),E=!!(this.capabilities&1024);if((0,S.$Gf)(r,l,!E))return;const m=new $.$ic;try{const[a,v]=await Promise.all([this.O(s),this.O(n)]);m.add(a),m.add(v),i&&await d.Promises.mkdir((0,C.$$d)(l),{recursive:!0}),await d.Promises.copyFile(r,l)}catch(a){if(a.code==="ENOENT"&&!i)return this.bb(s,n,!0);throw this.eb(a)}finally{m.dispose()}}t(s,n,i){return new w.$Rp(r=>s(r),r=>n(r),i)}F(s,n,i){return new I.$Zp(r=>s(r),r=>n(r),i)}eb(s){if(s instanceof f.$dk)return s;let n=s,i;switch(s.code){case"ENOENT":i=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=f.FileSystemProviderErrorCode.Unknown;break;default:i=f.FileSystemProviderErrorCode.Unknown}return(0,f.$ek)(n,i)}async fb(s,n){let i=this.eb(n);if(s&&i.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.H(s));r.mode&128||(i=(0,f.$ek)(n,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$1p=t}),define(re[101],oe([0,1,3,2,4,7]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=e.$T7b=void 0,e.$T7b=(0,D.$Ah)("sharedProcessLifecycleService");let O=class extends N.$jc{constructor(S){super(),this.b=S,this.a=this.B(new j.$ed),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$U7b=O,e.$U7b=O=ye([Y(0,A.$4i)],O)}),define(re[201],oe([0,1,11,3,7,2]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0;class O extends D.$cj{constructor(p,g,u,d,y){super(g,u,d),this.r=p,this.t=y,this.B(y.listen("onDidChangeLogLevel",p)(f=>{(0,D.$6i)(f)?super.setLogLevel(f):super.setLogLevel(j.URI.revive(f[0]),f[1])})),this.B(y.listen("onDidChangeVisibility",p)(([f,o])=>super.setVisibility(j.URI.revive(f),o))),this.B(y.listen("onDidChangeLoggers",p)(({added:f,removed:o})=>{for(const h of f)super.registerLogger({...h,resource:j.URI.revive(h.resource)});for(const h of o)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new D.$aj({log:(p,g)=>{this.t.call("consoleLog",[p,g])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,g){super.setLogLevel(p,g),this.t.call("setLogLevel",[p,g])}setVisibility(p,g){super.setVisibility(p,g),this.t.call("setVisibility",[this.n(p),g])}s(p,g,u){return new R(this.t,p,g,u,this.r)}static setLogLevel(p,g,u){return p.call("setLogLevel",[g,u])}}e.$Yq=O;class R extends D.$0i{constructor(p,g,u,d,y){super(d?.logLevel==="always"),this.r=p,this.s=g,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[g,d,y]).then(()=>{this.u(this.n),this.m=!0})}g(p,g){const u=[[p,g]];this.m?this.u(u):this.n.push(...u)}u(p){this.r.call("log",[this.s,p])}}class S{constructor(p,g){this.a=p,this.b=g}listen(p,g){const u=this.b(p);switch(g){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(y=>this.c(y,u)),removed:[...d.removed].map(y=>this.c(y,u))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,d=>[u.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,d=>(0,D.$6i)(d)?d:[u.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${g}`)}async call(p,g,u){const d=this.b(p);switch(g){case"setLogLevel":return(0,D.$6i)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(j.URI.revive(d.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,d)))}throw new Error(`Call not found: ${g}`)}c(p,g){return{...p,resource:g.transformOutgoingURI(p.resource)}}}e.$Zq=S;class $ extends A.$jc{constructor(p,g){super(),g.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(u=>g.call("setLogLevel",[u]))),g.call("getRegisteredLoggers").then(u=>{for(const d of u)p.registerLogger({...d,resource:j.URI.revive(d.resource)})}),this.B(g.listen("onDidChangeVisibility")(([u,d])=>p.setVisibility(j.URI.revive(u),d))),this.B(g.listen("onDidChangeLoggers")(({added:u,removed:d})=>{for(const y of u)p.registerLogger({...y,resource:j.URI.revive(y.resource)});for(const y of d)p.deregisterLogger(y.resource)}))}}e.$1q=$}),define(re[202],oe([0,1,2,7]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;class D extends j.$jc{constructor(O,R=[]){super(),this.a=new N.$bj([O,...R]),this.B(O.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$gN=D}),define(re[55],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M5b=void 0,e.$M5b=(0,j.$Ah)("nativeHostService")}),define(re[56],oe([0,1,3,59,2,4]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=void 0,e.$9m=(0,A.$Ah)("policy");class O extends D.$jc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new j.$ed),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const C=Object.keys(this.f).length;return this.f={...$,...this.f},C!==Object.keys(this.f).length&&await this.j($),N.Iterable.reduce(this.g.entries(),(p,[g,u])=>({...p,[g]:u}),{})}getPolicyValue($){return this.g.get($)}serialize(){return N.Iterable.reduce(Object.entries(this.f),($,[C,p])=>({...$,[C]:{definition:p,value:this.g.get(C)}}),{})}}e.$0m=O;class R{constructor(){this.onDidChange=j.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$$m=R}),define(re[203],oe([0,1,3,2,56]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=e.$C6b=void 0;class A{constructor(S){this.b=S,this.a=new N.$ic}listen(S,$){switch($){case"onDidChange":return j.Event.map(this.b.onDidChange,C=>C.reduce((p,g)=>({...p,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${$}`)}call(S,$,C){switch($){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${$}`)}dispose(){this.a.dispose()}}e.$C6b=A;class O extends D.$0m{constructor(S,$){super(),this.a=$;for(const C in S){const{definition:p,value:g}=S[C];this.f[C]=p,g!==void 0&&this.g.set(C,g)}this.a.listen("onDidChange")(C=>{for(const p in C){const g=C[p];g===null?this.g.delete(p):this.g.set(p,g)}this.h.fire(Object.keys(C))})}async j(S){const $=await this.a.call("updatePolicyDefinitions",S);for(const C in $)this.g.set(C,$[C])}}e.$D6b=O}),define(re[102],oe([0,1,6,37]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof j.$g.vscode<"u"&&typeof j.$g.vscode.context<"u"){const A=j.$g.vscode.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:A.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(re[24],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,j.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"}),define(re[204],oe([0,1,5,8,2,15,31,7,24]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=void 0;let $=class extends D.$jc{constructor(p,g,u){super(),this.b=g,this.c=u,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,p&&this.B(new j.$Rg(()=>{this.f(p)},3e4)).schedule()}async f(p){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),u=(0,A.$$d)(p),d=(0,A.$_d)(p),y=await O.Promises.readdir(u);await Promise.all(y.map(async f=>{if(f===d)return;const o=(0,A.$8d)(u,f),h=await O.Promises.stat(o);if(h.isDirectory()&&g-h.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),O.Promises.rm(o)}))}catch(g){(0,N.$Y)(g)}}};e.$o7b=$,e.$o7b=$=ye([Y(1,S.$jj),Y(2,R.$4i)],$)}),define(re[205],oe([0,1,5,8,2,15,31,16,7,24]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;let C=class extends D.$jc{constructor(g,u,d){super(),this.b=g,this.c=u,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new j.$Rg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),u=JSON.parse(await O.Promises.readFile((0,A.$8d)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const h of Object.keys(u)){const b=u[h];g[`${b.hash}.${h}`]=!0}const d=(0,A.$8d)(this.b.userDataPath,"clp");if(!await O.Promises.exists(d))return;const f=await O.Promises.readdir(d);for(const h of f){if(g[h]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${h}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${h}`),await O.Promises.rm((0,A.$8d)(d,h))}const o=Date.now();for(const h of Object.keys(g)){const b=(0,A.$8d)(d,h),w=await O.Promises.readdir(b);for(const I of w){if(I==="tcf.json")continue;const t=(0,A.$8d)(b,I),c=await O.Promises.stat(t);c.isDirectory()&&o-c.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$8d)(h,I)}`),await O.Promises.rm(t))}}}catch(g){(0,N.$Y)(g)}}};e.$p7b=C,e.$p7b=C=ye([Y(0,R.$Ih),Y(1,S.$4i),Y(2,$.$jj)],C)}),define(re[206],oe([0,1,15,4]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$zF=void 0,e.$zF=(0,N.$Ah)("IV8InspectProfilingService");var D;(function(A){function O(S){return!!(S.samples&&S.timeDeltas)}A.isValidProfile=O;function R(S,$="noAbsolutePaths"){for(const C of S.nodes)C.callFrame&&C.callFrame.url&&((0,j.$7d)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,j.$8d)($,(0,j.$_d)(C.callFrame.url)));return S}A.rewriteAbsolutePaths=R})(D||(e.Utils=D={}))}),define(re[207],oe([0,1,32]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J7b=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise(($,C)=>{te(["v8-inspect-profiler"],$,C)})).startProfiling({port:A.port,checkForPaused:!0}),S=(0,j.$3f)();return this.a.set(S,R),S}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const R=await O.stop();return this.a.delete(A),R.profile}}e.$J7b=N}),define(re[40],oe([0,1,127,9]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class D{constructor(){this.a=new Map}add(O,R){j.ok(N.$if(O)),j.ok(N.$kf(R)),j.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$7m=new D}),define(re[103],oe([0,1,3,40]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new j.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,$){this.a[D(S)]=$,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;N.$7m.add(e.$8m.JSONContribution,O)}),define(re[49],oe([0,1,18,3,9,149,19,103,40]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var $;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$_m={Configuration:"base.contributions.configuration"};var C;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const p=S.$7m.as(R.$8m.JSONContribution);class g{constructor(){this.h=new Set,this.i=new N.$ed,this.onDidSchemaChange=this.i.event,this.j=new N.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const s=new Set;this.n(t,c,s),p.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const c=new Set;this.o(t,c),p.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const s=new Set;this.o(c,s),this.n(t,!1,s),p.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const s=[];for(const{overrides:n,source:i}of t)for(const r in n)if(c.add(r),e.$jn.test(r)){const l=this.a.get(r),E=l?.valuesSources??new Map;if(i)for(const L of Object.keys(n[r]))E.set(L,i);const m={...l?.value||{},...n[r]};this.a.set(r,{source:i,value:m,valuesSources:E});const a=(0,O.$ei)(r),v={type:"object",default:m,description:A.localize(1,null,a),$ref:e.$gn,defaultDefaultValue:m,source:D.$if(i)?void 0:i,defaultValueSource:i};s.push(...y(r)),this.d[r]=v,this.b.properties[r]=v}else{this.a.set(r,{value:n[r],source:i});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(s)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:s,source:n}of t)for(const i in s){const r=this.a.get(i),l=D.$if(n)?n:n?.id,E=D.$if(r?.source)?r?.source:r?.source?.id;if(l===E)if(c.add(i),this.a.delete(i),e.$jn.test(i))delete this.d[i],delete this.b.properties[i];else{const m=this.d[i];m&&(this.w(i,m),this.r(i,m))}}this.u()}deltaConfiguration(t){let c=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,s){t.forEach(n=>{this.p(n,c,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,c){const s=n=>{if(n.properties)for(const i in n.properties){c.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,c=!0,s,n,i=3,r){i=D.$rf(t.scope)?i:t.scope;const l=t.properties;if(l)for(const m in l){const a=l[m];if(c&&b(m,a)){delete l[m];continue}if(a.source=s,a.defaultDefaultValue=l[m].default,this.w(m,a),e.$jn.test(m)?a.scope=void 0:(a.scope=D.$rf(a.scope)?i:a.scope,a.restricted=D.$rf(a.restricted)?!!n?.includes(m):a.restricted),l[m].hasOwnProperty("included")&&!l[m].included){this.f[m]=l[m],delete l[m];continue}else this.d[m]=l[m],l[m].policy?.name&&this.e.set(l[m].policy.name,m);!l[m].deprecationMessage&&l[m].markdownDeprecationMessage&&(l[m].deprecationMessage=l[m].markdownDeprecationMessage),r.add(m)}const E=t.allOf;if(E)for(const m of E)this.p(m,c,s,n,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=s=>{const n=s.properties;if(n)for(const r in n)this.r(r,n[r]);s.allOf?.forEach(c)};c(t)}r(t,c){switch(e.$an.properties[t]=c,c.scope){case 1:e.$bn.properties[t]=c;break;case 2:e.$cn.properties[t]=c;break;case 6:e.$dn.properties[t]=c;break;case 3:e.$en.properties[t]=c;break;case 4:e.$fn.properties[t]=c;break;case 5:e.$fn.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.$an.properties[t],c.scope){case 1:delete e.$bn.properties[t];break;case 2:delete e.$cn.properties[t];break;case 6:delete e.$dn.properties[t];break;case 3:delete e.$en.properties[t];break;case 4:case 5:delete e.$fn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$gn};this.w(c,s),e.$an.properties[c]=s,e.$bn.properties[c]=s,e.$cn.properties[c]=s,e.$dn.properties[c]=s,e.$en.properties[c]=s,e.$fn.properties[c]=s}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=t,e.$bn.patternProperties[e.$in]=t,e.$cn.patternProperties[e.$in]=t,e.$dn.patternProperties[e.$in]=t,e.$en.patternProperties[e.$in]=t,e.$fn.patternProperties[e.$in]=t,this.i.fire()}w(t,c){const s=this.a.get(t);let n=s?.value,i=s?.source;D.$pf(n)&&(n=c.defaultDefaultValue,i=void 0),D.$pf(n)&&(n=o(c.type)),c.default=n,c.defaultValueSource=i}}const u="\\[([^\\]]+)\\]",d=new RegExp(u,"g");e.$in=`^(${u})+$`,e.$jn=new RegExp(e.$in);function y(I){const t=[];if(e.$jn.test(I)){let c=d.exec(I);for(;c?.length;){const s=c[1].trim();s&&t.push(s),c=d.exec(I)}}return(0,j.$Jb)(t)}e.$kn=y;function f(I){return I.reduce((t,c)=>`${t}[${c}]`,"")}e.$ln=f;function o(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=o;const h=new g;S.$7m.add(e.$_m.Configuration,h);function b(I,t){return I.trim()?e.$jn.test(I)?A.localize(7,null,I):h.getConfigurationProperties()[I]!==void 0?A.localize(8,null,I):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,I,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$nn=b;function w(){const I=[],t=h.getConfigurationProperties();for(const c of Object.keys(t))I.push([c,t[c].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.$on=w}),define(re[73],oe([0,1,18,3,34,2,35,30,9,11,19,49,40]),function(te,e,j,N,D,A,O,R,S,$,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function u(c){return Object.isFrozen(c)?c:R.$Vm(c)}class d{constructor(s={},n=[],i=[],r){this.b=s,this.c=n,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof d)return n;const i=new y("");return i.parseRaw(n),i.configurationModel});this.f=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,C.$ci)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,l=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:r,merged:l}}getOverrideValue(s,n){const i=this.i(n);return i?s?(0,C.$ci)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return j.$Jb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return j.$Jb(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=R.$Um(this.contents),i=R.$Um(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const E of s)if(l.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(n,E.contents);for(const m of E.overrides){const[a]=i.filter(v=>j.$sb(v.identifiers,m.identifiers));a?(this.h(a.contents,m.contents),a.keys.push(...m.keys),a.keys=j.$Jb(a.keys)):i.push(R.$Um(m))}for(const m of E.keys)r.indexOf(m)===-1&&r.push(m)}return new d(n,r,i,l.every(E=>E instanceof d)?void 0:l)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of j.$Jb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r];const E=n[r];E&&(typeof l=="object"&&typeof E=="object"?(l=R.$Um(l),this.h(l,E)):l=E),i[r]=l}return new d(i,this.keys,this.overrides)}h(s,n){for(const i of Object.keys(n)){if(i in s&&S.$kf(s[i])&&S.$kf(n[i])){this.h(s[i],n[i]);continue}s[i]=R.$Um(n[i])}}i(s){let n=null,i=null;const r=l=>{l&&(i?this.h(i,l):i=R.$Um(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===s?n=l.contents:l.identifiers.includes(s)&&r(l.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,C.$bi)(this.contents,s),p.$jn.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>j.$sb(i.identifiers,(0,p.$kn)(s))),1))}j(s,n,i){(0,C.$ai)(this.contents,s,n,r=>console.error(r)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),p.$jn.test(s)&&this.overrides.push({identifiers:(0,p.$kn)(s),keys:Object.keys(this.contents[s]),contents:(0,C.$_h)(this.contents[s],r=>console.error(r))})}}e.$pn=d;class y{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!S.$rf(s)){const i=this.g(s);this.parseRaw(i,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:i,keys:r,overrides:l,restricted:E,hasExcludedProperties:m}=this.h(s,n);this.b=new d(i,r,l,m?[s]:void 0),this.c=E||[]}g(s){let n={},i=null,r=[];const l=[],E=[];function m(v){Array.isArray(r)?r.push(v):i!==null&&(r[i]=v)}const a={onObjectBegin:()=>{const v={};m(v),l.push(r),r=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const v=[];m(v),l.push(r),r=v,i=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:m,onError:(v,L,T)=>{E.push({error:v,offset:L,length:T})}};if(s)try{D.$Rm(s,a),n=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return n}h(s,n){const i=g.$7m.as(p.$_m.Configuration).getConfigurationProperties(),r=this.i(s,i,!0,n);s=r.raw;const l=(0,C.$_h)(s,a=>console.error(`Conflict in settings file ${this.f}: ${a}`)),E=Object.keys(s),m=this.j(s,a=>console.error(`Conflict in settings file ${this.f}: ${a}`));return{contents:l,keys:E,overrides:m,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(s,n,i,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:l};const E={},m=[];for(const a in s)if(p.$jn.test(a)&&i){const v=this.i(s[a],n,!1,r);E[a]=v.raw,l=l||v.hasExcludedProperties,m.push(...v.restricted)}else{const v=n[a],L=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&m.push(a),!r.exclude?.includes(a)&&(r.include?.includes(a)||(L===void 0||r.scopes===void 0||r.scopes.includes(L))&&!(r.skipRestricted&&v?.restricted))?E[a]=s[a]:l=!0}return{raw:E,restricted:m,hasExcludedProperties:l}}j(s,n){const i=[];for(const r of Object.keys(s))if(p.$jn.test(r)){const l={};for(const E in s[r])l[E]=s[r][E];i.push({identifiers:(0,p.$kn)(r),keys:Object.keys(l),contents:(0,C.$_h)(l,n)})}return i}}e.$qn=y;class f extends A.$jc{constructor(s,n,i,r){super(),this.c=s,this.f=n,this.g=r,this.b=this.B(new N.$ed),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&i.isEqual(l.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=f;class o{constructor(s,n,i,r,l,E,m,a,v,L,T,z,U){this.a=s,this.b=n,this.c=i,this.overrideIdentifiers=r,this.d=l,this.f=E,this.g=m,this.h=a,this.i=v,this.j=L,this.k=T,this.l=z,this.m=U}get value(){return u(this.c)}n(s,n,i){const r=s.inspect(n,i);return{get value(){return u(r.value)},get override(){return u(r.override)},get merged(){return u(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(s,n,i,r,l=new d,E=new d,m=new O.$yi,a=new d,v=new O.$yi){this.c=s,this.d=n,this.f=i,this.g=r,this.h=l,this.i=E,this.j=m,this.l=a,this.m=v,this.a=null,this.b=new O.$yi,this.n=null}getValue(s,n,i){return this.q(s,n,i).getValue(s)}updateValue(s,n,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new d,this.m.set(i.resource,r))):r=this.l,n===void 0?r.removeValue(s):r.setValue(s,n),i.resource||(this.a=null)}inspect(s,n,i){const r=this.q(s,n,i),l=this.u(n.resource,i),E=n.resource?this.m.get(n.resource)||this.l:this.l,m=new Set;for(const a of r.overrides)for(const v of a.identifiers)r.getOverrideValue(s,v)!==void 0&&m.add(v);return new o(s,n,r.getValue(s),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,l||void 0,E)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:r,updated:l,removed:E}=I(this.c,s);n=[...r,...l,...E]}for(const r of n)for(const l of(0,p.$kn)(r)){const E=this.c.getKeysForOverrideIdentifier(l),m=s.getKeysForOverrideIdentifier(l),a=[...m.filter(v=>E.indexOf(v)===-1),...E.filter(v=>m.indexOf(v)===-1),...E.filter(v=>!R.$Ym(this.c.override(l).getValue(v),s.override(l).getValue(v)))];i.push([l,a])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:r}=I(this.d,s),l=[...n,...i,...r];return l.length&&this.updatePolicyConfiguration(s),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:r,overrides:l}=I(this.applicationConfiguration,s),E=[...n,...i,...r];return E.length&&this.updateApplicationConfiguration(s),{keys:E,overrides:l}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:l}=I(this.localUserConfiguration,s),E=[...n,...i,...r];return E.length&&this.updateLocalUserConfiguration(s),{keys:E,overrides:l}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:l}=I(this.remoteUserConfiguration,s),E=[...n,...i,...r];return E.length&&this.updateRemoteUserConfiguration(s),{keys:E,overrides:l}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:r,overrides:l}=I(this.workspaceConfiguration,s),E=[...n,...i,...r];return E.length&&this.updateWorkspaceConfiguration(s),{keys:E,overrides:l}}compareAndUpdateFolderConfiguration(s,n){const i=this.p.get(s),{added:r,updated:l,removed:E,overrides:m}=I(i,n),a=[...r,...l,...E];return(a.length||!i)&&this.updateFolderConfiguration(s,n),{keys:a,overrides:m}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:r,removed:l,overrides:E}=I(n,void 0);return{keys:[...i,...r,...l],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,i){let r=this.r(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}r({resource:s},n){let i=this.s();if(n&&s){const r=n.getFolder(s);r&&(i=this.t(r.uri)||i);const l=this.m.get(s);l&&(i=i.merge(l))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const i=this.s(),r=this.j.get(s);r?(n=i.merge(r),this.b.set(s,n)):n=i}return n}u(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:i,overrides:r,keys:l}=this.j.get(n);return s.push([n,{contents:i,overrides:r,keys:l}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.x(s.defaults),i=this.x(s.policy),r=this.x(s.application),l=this.x(s.user),E=this.x(s.workspace),m=s.folders.reduce((a,v)=>(a.set($.URI.revive(v[0]),this.x(v[1])),a),new O.$yi);return new h(n,i,r,l,new d,E,m,new d,new O.$yi)}static x(s){return new d(s.contents,s.keys,s.overrides)}}e.$sn=h;function b(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const s=new Set,n=new Map;for(const r of c)r.keys.forEach(l=>s.add(l)),r.overrides.forEach(([l,E])=>{const m=(0,O.$vi)(n,l,new Set);E.forEach(a=>m.add(a))});const i=[];return n.forEach((r,l)=>i.push([l,[...r.values()]])),{keys:[...s.values()],overrides:i}}e.$tn=b;class w{constructor(s,n,i,r){this.change=s,this.f=n,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of s.keys)this.affectedKeys.add(l);for(const[,l]of s.overrides)for(const E of l)this.affectedKeys.add(E);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(s,n){const i=this.a+s,r=this.d.indexOf(i);if(r<0)return!1;const l=r+i.length;if(l>=this.d.length)return!1;const E=this.d.charCodeAt(l);if(E!==this.b&&E!==this.c)return!1;if(n){const m=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,a=this.g.getValue(s,n,this.h);return!R.$Ym(m,a)}return!0}}e.$un=w;function I(c,s){const{added:n,removed:i,updated:r}=t(s?.rawConfiguration,c?.rawConfiguration),l=[],E=c?.getAllOverrideIdentifiers()||[],m=s?.getAllOverrideIdentifiers()||[];if(s){const a=m.filter(v=>!E.includes(v));for(const v of a)l.push([v,s.getKeysForOverrideIdentifier(v)])}if(c){const a=E.filter(v=>!m.includes(v));for(const v of a)l.push([v,c.getKeysForOverrideIdentifier(v)])}if(s&&c){for(const a of E)if(m.includes(a)){const v=t({contents:c.getOverrideValue(void 0,a)||{},keys:c.getKeysForOverrideIdentifier(a)},{contents:s.getOverrideValue(void 0,a)||{},keys:s.getKeysForOverrideIdentifier(a)});l.push([a,[...v.added,...v.removed,...v.updated]])}}return{added:n,removed:i,updated:r,overrides:l}}function t(c,s){const n=c?s?c.keys.filter(l=>s.keys.indexOf(l)===-1):[...c.keys]:[],i=s?c?s.keys.filter(l=>c.keys.indexOf(l)===-1):[...s.keys]:[],r=[];if(c&&s){for(const l of s.keys)if(c.keys.indexOf(l)!==-1){const E=(0,C.$ci)(s.contents,l),m=(0,C.$ci)(c.contents,l);R.$Ym(E,m)||r.push(l)}}return{added:n,removed:i,updated:r}}}),define(re[208],oe([0,1,18,3,2,30,9,73,49,7,56,40]),function(te,e,j,N,D,A,O,R,S,$,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=void 0;class g extends D.$jc{constructor(){super(...arguments),this.a=this.B(new N.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new R.$pn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.$7m.as(S.$_m.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:o})=>this.c(Array.from(f),o))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(f,o){this.h(f,p.$7m.as(S.$_m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}g(){this.b=new R.$pn;const f=p.$7m.as(S.$_m.Configuration).getConfigurationProperties();this.h(Object.keys(f),f)}h(f,o){const h=this.f();for(const b of f){const w=h[b],I=o[b];w!==void 0?this.b.addValue(b,w):I?this.b.addValue(b,I.default):this.b.removeValue(b)}}}e.$vn=g;class u{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$pn}async initialize(){return this.configurationModel}}e.$wn=u;let d=class extends D.$jc{get configurationModel(){return this.b}constructor(f,o,h){super(),this.c=f,this.f=o,this.g=h,this.a=this.B(new N.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new R.$pn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.j(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.m(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const o={},h=[],b=p.$7m.as(S.$_m.Configuration).getConfigurationProperties();for(const w of f){const I=b[w];if(!I){h.push(w);continue}if(I.policy){if(I.type!=="string"&&I.type!=="number"){this.g.warn(`Policy ${I.policy.name} has unsupported type ${I.type}`);continue}h.push(w),o[I.policy.name]={type:I.type}}}return(0,O.$vf)(o)||await this.f.updatePolicyDefinitions(o),h}j(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const o=p.$7m.as(S.$_m.Configuration).getPolicyConfigurations(),h=(0,j.$Eb)(f.map(b=>o.get(b)));this.m(h,!0)}m(f,o){this.g.trace("PolicyConfiguration#update",f);const h=p.$7m.as(S.$_m.Configuration).getConfigurationProperties(),b=[],w=this.b.isEmpty();for(const I of f){const t=h[I]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(w?c!==void 0:!(0,A.$Ym)(this.b.getValue(I),c))&&b.push([I,c])}else this.b.getValue(I)!==void 0&&b.push([I,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const I=this.b;this.b=new R.$pn;for(const t of I.keys)this.b.setValue(t,I.getValue(t));for(const[t,c]of b)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);o&&this.a.fire(this.b)}}};e.$xn=d,e.$xn=d=ye([Y(1,C.$9m),Y(2,$.$4i)],d)}),define(re[209],oe([0,1,5,3,2,22,19,73,208,56]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=void 0;class C extends D.$jc{constructor(g,u,d,y){super(),this.j=g,this.h=this.B(new N.$ed),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$vn),this.c=d instanceof $.$$m?new S.$wn:this.B(new S.$xn(this.b,d,y)),this.f=this.B(new R.$rn(this.j,{},A.$$f,u)),this.a=new R.$sn(this.b.configurationModel,this.c.configurationModel,new R.$pn,new R.$pn),this.g=this.B(new j.$Rg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:o})=>this.n(f,o))),this.B(this.c.onDidChangeConfiguration(f=>this.r(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,u,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$sn(g,u,new R.$pn,d)}getConfigurationData(){return this.a.toData()}getValue(g,u){const d=typeof g=="string"?g:void 0,y=(0,O.$8h)(g)?g:(0,O.$8h)(u)?u:{};return this.a.getValue(d,y,void 0)}updateValue(g,u,d,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const u=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(d,u,2)}n(g,u){const d=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(g,u);this.s(y,d,7)}r(g){const u=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(g);this.s(d,u,7)}s(g,u,d){const y=new R.$un(g,{data:u},this.a);y.source=d,y.sourceConfig=this.t(d),this.h.fire(y)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$yn=C}),define(re[210],oe([0,1,14,3,2,65]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkb=e.$lkb=e.$kkb=e.$jkb=void 0;const O=($,C,p)=>{const g=new Uint8Array(16);for(let y=0;y<16;y++)g[y]=Math.round(Math.random()*256);const u=(0,j.$Yd)(j.$Ed.wrap(g));return[`GET ws://localhost${$}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`].join(`\r
`)+`\r
\r
`};e.$jkb=O,e.$kkb=j.$Ed.fromString(`\r
\r
`);async function R($,C,p,g,u){$.write(j.$Ed.fromString((0,e.$jkb)(C,p,g)));const d=new D.$ic;try{return await new Promise((y,f)=>{let o;d.add($.onData(h=>{o?o=j.$Ed.concat([o,h],o.byteLength+h.byteLength):o=h;const b=o.indexOf(e.$kkb);if(b===-1)return;y($),$.pauseData();const w=o.slice(b+e.$kkb.byteLength);w.byteLength&&u.onData.fire(w)})),d.add($.onClose(h=>f(h??new Error("socket closed")))),d.add($.onEnd(()=>f(new Error("socket ended"))))})}catch(y){throw $.dispose(),y}finally{d.dispose()}}e.$lkb=R;class S extends D.$jc{constructor(C,p){super(),this.g=C,this.a=this.B(new N.$hd),this.onData=(...g)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...g)),this.b=this.B(new N.$ed),this.onDidDispose=this.b.event,this.f=!1,this.B(p.onData),this.B(p.onData.event(g=>this.a.fire(g))),this.onClose=this.B(p.onClose).event,this.onEnd=this.B(p.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,p){A.SocketDiagnostics.traceSocketEvent(this,this.g,C,p)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$mkb=S}),define(re[211],oe([0,1,8,4]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.RemoteAuthorityResolverErrorCode=e.$Kk=e.$Jk=e.RemoteConnectionType=e.$Ik=void 0,e.$Ik=(0,N.$Ah)("remoteAuthorityResolverService");var D;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class A{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.$Jk=A;class O{constructor(p,g){this.host=p,this.port=g,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Kk=O;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends j.$_{static isNotAvailable(p){return p instanceof S&&p._code===R.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof S&&p._code===R.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof S&&p._code===R.NoResolverFound}static isInvalidAuthority(p){return p instanceof S&&p._code===R.InvalidAuthority}static isHandled(p){return p instanceof S&&p.isHandled}constructor(p,g=R.Unknown,u){super(p),this._message=p,this._code=g,this._detail=u,this.isHandled=g===R.NotAvailable&&u===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Lk=S;function $(C){const p=C.indexOf("+");return p===-1?C:C.substring(0,p)}e.$Mk=$}),define(re[74],oe([0,1,23]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function N($){return $.scheme===j.Schemas.vscodeRemote?$.authority:void 0}e.$Nk=N;function D($){if(!$)return;const C=$.indexOf("+");return C<0?$:$.substr(0,C)}e.$Ok=D;function A($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Pk=A;function O($){const{host:C,port:p}=S($);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:p}}e.$Qk=O;function R($,C){let{host:p,port:g}=S($);return typeof g>"u"&&(g=C),{host:p,port:g}}e.$Rk=R;function S($){const C=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const p=$.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const g=$.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:$,port:void 0}}}),define(re[45],oe([0,1,28,4,74]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Sl=A,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f>"u"||f===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){const h=typeof f=="string"?f:f.value,b=typeof o=="string"?o:o.value;return j.$Le(h,b)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Ul=S;class ${get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const o of f)this.add(o)}add(f){this.c.add(S.toKey(f))}delete(f){return this.c.delete(S.toKey(f))}has(f){return this.c.has(S.toKey(f))}}e.$Vl=$;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(S.toKey(f))}get(f){return this.c.get(S.toKey(f))}has(f){return this.c.has(S.toKey(f))}set(f,o){this.c.set(S.toKey(f),o)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=C;function p(y){return g(y)}e.$Xl=p;function g(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$Yl=g;function u(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$Zl=u;function d(y,f){if(f){const o=`onResolveRemoteAuthority:${(0,D.$Ok)(f)}`;return!!y.activationEvents?.includes(o)}return!1}e.$1l=d,e.$2l=(0,N.$Ah)("IBuiltinExtensionsScannerService")}),define(re[212],oe([0,1,2,45,13]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;class A extends j.$jc{constructor(R,S,$,C,p){super(),this.a=R,this.b=S,this.c=$,this.f=p,this.B(C.onDidInstallExtensions(g=>this.g(g))),this.B(C.onDidUninstallExtension(g=>this.h(g)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$Ol))}catch(S){(0,D.$ik)(S)!==1&&this.f.error(S)}}}e.$up=A}),define(re[213],oe([0,1,5,14,26,8,3,2,100,60,32,65,211,74]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.PersistentConnectionEventType=e.$Yk=e.$Xk=e.$Wk=e.ConnectionType=void 0;const d=30*1e3;var y;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function f(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(q){const k=new D.$od;return setTimeout(()=>k.cancel(),q),k.token}function h(q,k){if(q.isCancellationRequested||k.isCancellationRequested)return D.CancellationToken.Cancelled;const P=new D.$od;return q.onCancellationRequested(()=>P.cancel()),k.onCancellationRequested(()=>P.cancel()),P.token}class b{get didTimeout(){return this.c==="timedout"}constructor(k){this.c="pending",this.d=new R.$ic,this.promise=new Promise((P,F)=>{this.f=P,this.g=F}),k.isCancellationRequested?this.h():this.d.add(k.onCancellationRequested(()=>this.h()))}registerDisposable(k){this.c==="pending"?this.d.add(k):k.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const k=new Error("Time limit reached");return k.code="ETIMEDOUT",k.syscall="connect",k}resolve(k){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(k))}reject(k){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(k))}}function w(q,k){const P=new b(k);return P.registerDisposable(q.onControlMessage(F=>{const M=JSON.parse(F.toString()),K=W(M);K?P.reject(K):P.resolve(M)})),P.promise}function I(q,k,P,F,M,K,_,ae){const he=new b(ae),fe=$.$ad.create(!1);return q.info(`Creating a socket (${_})...`),S.mark(`code/willCreateSocket/${K}`),k.connect(P,F,M,_).then(le=>{he.didTimeout?(S.mark(`code/didCreateSocketError/${K}`),q.info(`Creating a socket (${_}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(S.mark(`code/didCreateSocketOK/${K}`),q.info(`Creating a socket (${_}) was successful after ${fe.elapsed()} ms.`),he.resolve(le))},le=>{S.mark(`code/didCreateSocketError/${K}`),q.info(`Creating a socket (${_}) returned an error after ${fe.elapsed()} ms.`),q.error(le),he.reject(le)}),he.promise}function t(q,k){const P=new b(k);return q.then(F=>{P.didTimeout||P.resolve(F)},F=>{P.didTimeout||P.reject(F)}),P.promise}async function c(q,k,P,F){const M=se(q,k);q.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let K;try{K=await I(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,u.$Pk)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,f(k),`renderer-${f(k)}-${q.reconnectionToken}`,F)}catch(le){throw q.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),q.logService.error(le),le}q.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let _,ae;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(K,null),_=q.reconnectionProtocol,ae=!1):(_=new p.$oh({socket:K}),ae=!0),q.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const he=await t(q.signService.createNewMessage((0,C.$3f)()),F),fe={type:"auth",auth:q.connectionToken||"00000000000000000000",data:he.data};_.sendControl(N.$Ed.fromString(JSON.stringify(fe)));try{const le=await w(_,h(F,o(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(q.logService.trace(`${M} 4/6. received SignRequest control message.`),!await t(q.signService.validate(he,le.signedData),F)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await t(q.signService.sign(le.data),F),we={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:k};return P&&(we.args=P),q.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(N.$Ed.fromString(JSON.stringify(we))),{protocol:_,ownsProtocol:ae}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(q.logService.error(`${M} the handshake timed out. Error:`),q.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${M} received error control message when negotiating connection. Error:`),q.logService.error(le)),ae&&G(_),le}}async function s(q,k,P,F){const M=Date.now(),K=se(q,k),{protocol:_,ownsProtocol:ae}=await c(q,k,P,F),he=new b(F);return he.registerDisposable(_.onControlMessage(fe=>{const le=JSON.parse(fe.toString()),$e=W(le);$e?(q.logService.error(`${K} received error control message when negotiating connection. Error:`),q.logService.error($e),ae&&G(_),he.reject($e)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${Z(M)}!`),he.resolve({protocol:_,firstMessage:le}))})),he.promise}async function n(q,k){const{protocol:P}=await s(q,1,void 0,k);return{protocol:P}}async function i(q,k,P){const{protocol:F,firstMessage:M}=await s(q,2,k,P),K=M&&M.debugPort;return{protocol:F,debugPort:K}}async function r(q,k,P){const F=Date.now(),M=se(q,3),{protocol:K}=await c(q,3,k,P);return q.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${Z(F)}!`),K}async function l(q,k,P){const{connectTo:F,connectionToken:M}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:F,connectionToken:M,reconnectionToken:k,reconnectionProtocol:P,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function E(q,k,P){return a(q,async F=>{const{protocol:M}=await n(F,D.CancellationToken.None);return new H(q,k,P,F.reconnectionToken,M)})}e.$Wk=E;async function m(q,k){return a(q,async P=>{const{protocol:F,debugPort:M}=await i(P,k,D.CancellationToken.None);return new X(q,k,P.reconnectionToken,F,M)})}e.$Xk=m;async function a(q,k){for(let F=1;;F++)try{const M=(0,C.$3f)(),K=await l(q,M,null);return await k(K)}catch(M){if(F<5)q.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(M);else throw q.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(M),x.triggerPermanentFailure(0,0,g.$Lk.isHandled(M)),M}}async function v(q,k,P){const F=await l(q,(0,C.$3f)(),null);return await r(F,{host:k,port:P},D.CancellationToken.None)}e.$Yk=v;function L(q){return(0,j.$tg)(k=>new Promise((P,F)=>{const M=setTimeout(P,q*1e3);k.onCancellationRequested(()=>{clearTimeout(M),P()})}))}var T;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class z{constructor(k,P){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.type=0}}e.$Zk=z;class U{constructor(k,P,F,M){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.durationSeconds=F,this.c=M,this.type=1}skipWait(){this.c.cancel()}}e.$1k=U;class B{constructor(k,P,F){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.attempt=F,this.type=2}}e.$2k=B;class Q{constructor(k,P,F){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.attempt=F,this.type=4}}e.$3k=Q;class J{constructor(k,P,F,M){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.attempt=F,this.handled=M,this.type=3}}e.$4k=J;class x extends R.$jc{static triggerPermanentFailure(k,P,F){this._permanentFailure=!0,this.f=k,this.g=P,this.h=F,this.j.forEach(M=>M.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(k=>k.y())}static debugPauseSocketWriting(){this.j.forEach(k=>k.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(k,P,F,M,K){super(),this.t=k,this.u=P,this.reconnectionToken=F,this.protocol=M,this.w=K,this.m=this.B(new O.$ed),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Q(this.reconnectionToken,0,0)),this.B(M.onSocketClose(_=>{const ae=ne(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ae} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ae} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ae} received socket close event.`),this.y()})),this.B(M.onSocketTimeout(_=>{const ae=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ae} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$hc)(()=>{const _=x.j.indexOf(this);_>=0&&x.j.splice(_,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const k=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${k} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const P=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const M=F<P.length?P[F]:P[P.length-1];try{if(M>0){const _=L(M);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,_)),this.u.logService.info(`${k} waiting for ${M} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${k} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.u.logService.info(`${k} resolving connection...`);const K=await l(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${k} connecting to ${K.connectTo}...`),await this.G(K,o(d)),this.u.logService.info(`${k} reconnected!`),this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${k} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.u.logService.error(`${k} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(g.$Lk.isTemporarilyNotAvailable(K)){this.u.logService.info(`${k} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${k} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,A.$2)(K)){this.u.logService.info(`${k} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof g.$Lk){this.u.logService.error(`${k} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,g.$Lk.isHandled(K));break}this.u.logService.error(`${k} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.n&&!this.s)}C(k,P,F){this.w?x.triggerPermanentFailure(k,P,F):this.D(k,P,F)}D(k,P,F){this.m.fire(new J(this.reconnectionToken,k,P,F)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5k=x;class H extends x{constructor(k,P,F,M,K){super(1,k,M,K,!0),this.client=this.B(new p.$mh(K,{remoteAuthority:P,clientId:F},k.ipcLogger))}async G(k,P){await n(k,P)}}e.$6k=H;class X extends x{constructor(k,P,F,M,K){super(2,k,F,M,!1),this.H=P,this.debugPort=K}async G(k,P){await i(k,this.H,P)}}e.$7k=X;function G(q){try{q.acceptDisconnect();const k=q.getSocket();q.dispose(),k.dispose()}catch(k){(0,A.$Y)(k)}}function W(q){if(q&&q.type==="error"){const k=new Error(`Connection error: ${q.reason}`);return k.code="VSCODE_CONNECTION_ERROR",k}return null}function V(q,k){for(;q.length<k;)q+=" ";return q}function ee(q,k){return`[remote-connection][${V(f(q),13)}][${k.substr(0,5)}\u2026]`}function ne(q,k,P){return`${ee(q,k)}[${P?"reconnect":"initial"}]`}function se(q,k){return`${ne(k,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function Z(q){return`${Date.now()-q} ms`}}),define(re[104],oe([0,1,2,4]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=void 0,e.$Sk=(0,N.$Ah)("remoteSocketFactoryService");class D{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,j.$hc)(()=>{const S=this.a[O]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[O]?.splice(S,1)})}b(O){return(this.a[O.type]||[]).find(S=>S.supports(O))}connect(O,R,S,$){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,R,S,$)}}e.$Tk=D}),define(re[214],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=e.$G7b=void 0,e.$G7b=(0,j.$Ah)("sharedProcessTunnelService"),e.$H7b="sharedProcessTunnel"}),define(re[105],oe([0,1,4,164]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=e.$Q7b=e.$P7b=e.$O7b=e.$N7b=e.TunnelStates=e.$M7b=e.$L7b=void 0,e.$L7b=(0,j.$Ah)("IRemoteTunnelService"),e.$M7b={active:!1};var D;(function(A){A.disconnected=O=>({type:"disconnected",onTokenFailed:O}),A.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),A.connecting=O=>({type:"connecting",progress:O}),A.uninitialized={type:"uninitialized"}})(D||(e.TunnelStates=D={})),e.$N7b="remote.tunnels.access",e.$O7b=e.$N7b+".hostNameOverride",e.$P7b=e.$N7b+".preventSleep",e.$Q7b="remoteTunnelService",e.$R7b=(0,N.localize)(0,null)}),define(re[57],oe([0,1,14,8,2,166,49,4,7,40]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Ho=(0,R.$Ah)("requestService");class C{constructor(I){this.b=I}toJSON(){if(!this.a){const I=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?I[t]="*****":I[t]=this.b[t];this.a=I}return this.a}}class p extends D.$jc{constructor(I){super(),this.b=0,this.a=I.createLogger("network",{name:(0,A.localize)(0,null),when:S.$ij.isEqualTo((0,S.$gj)(S.LogLevel.Trace)).serialize()})}async c(I,t,c){const s=`${I} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new C(t.headers??{}));try{const n=await c();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,N.$8)(n)),n}}}e.$Io=p;function g(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.$Jo=g;function u(w){return w.res.statusCode===204}async function d(w){return u(w)?null:(await(0,j.$Qd)(w.stream)).toString()}e.$Ko=d;async function y(w){if(!g(w))throw new Error("Server returned "+w.res.statusCode);return d(w)}e.$Lo=y;async function f(w){if(!g(w))throw new Error("Server returned "+w.res.statusCode);if(u(w))return null;const t=(await(0,j.$Qd)(w.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}e.$Mo=f;function o(w){b(w)}e.$No=o;let h;function b(w){const I=$.$7m.as(O.$_m.Configuration),t=h;h={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},I.updateConfigurations({add:[h],remove:t?[t]:[]})}b(1)}),define(re[215],oe([0,1,26,23,13,57]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;let O=class{constructor(S,$){this.a=S,this.b=$}async download(S,$,C=j.CancellationToken.None){if(S.scheme===N.Schemas.file||S.scheme===N.Schemas.vscodeRemote){await this.b.copy(S,$);return}const p={type:"GET",url:S.toString(!0)},g=await this.a.request(p,C);if(g.res.statusCode===200)await this.b.writeFile($,g.stream);else{const u=await(0,A.$Lo)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${u}`)}}};e.$vN=O,e.$vN=O=ye([Y(0,A.$Ho),Y(1,D.$5j)],O)}),define(re[216],oe([0,1,14,26]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class D{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,$,C=N.CancellationToken.None){switch(S){case"request":return this.a.request($[0],C).then(async({res:p,stream:g})=>{const u=await(0,j.$Qd)(g);return[{statusCode:p.statusCode,headers:p.headers},u]});case"resolveProxy":return this.a.resolveProxy($[0])}throw new Error("Invalid call")}}e.$Jq=D;class A{constructor(R){this.a=R}async request(R,S){const[$,C]=await this.a.call("request",[R],S);return{res:$,stream:(0,j.$Sd)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Kq=A}),define(re[217],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=e.$a6b=e.$_5b=void 0,e.$_5b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$a6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$b6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[218],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c2b=void 0;class j{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(D){try{const A=await this.c();if(A){const O=String(j.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,A){if(!D.id)return!0;const O=this.b.get(D.id);if(!O)return!1;this.b.delete(D.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(D){try{return await this.d(D)}catch{}return D}}e.$c2b=j}),define(re[106],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=void 0,e.$Uk="signService",e.$Vk=(0,j.$Ah)(e.$Uk)}),define(re[219],oe([0,1,218]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=void 0;class N extends j.$c2b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>te(["vsda"],A,O))}}e.$Z6b=N}),define(re[75],oe([0,1,3,2]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yzb=e.$Xzb=e.$Wzb=e.$Vzb=void 0;class D extends N.$jc{constructor(p,g,u){super(),this.a=p,this.b=g,this.c=u}async getItems(){const p={profile:this.b,workspace:this.c},g=await this.a.call("getItems",p);return new Map(g)}updateItems(p){const g={profile:this.b,workspace:this.c};return p.insert&&(g.insert=Array.from(p.insert.entries())),p.delete&&(g.delete=Array.from(p.delete.values())),this.a.call("updateItems",g)}optimize(){const p={profile:this.b,workspace:this.c};return this.a.call("optimize",p)}}class A extends D{constructor(p,g){super(p,g,void 0),this.f=this.B(new j.$ed),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(p=>this.h(p)))}h(p){(Array.isArray(p.changed)||Array.isArray(p.deleted))&&this.f.fire({changed:p.changed?new Map(p.changed):void 0,deleted:p.deleted?new Set(p.deleted):void 0})}}class O extends A{constructor(p){super(p,void 0)}async close(){this.dispose()}}e.$Vzb=O;class R extends A{constructor(p,g){super(p,g)}async close(){this.dispose()}}e.$Wzb=R;class S extends D{constructor(p,g){super(p,void 0,g),this.onDidChangeItemsExternal=j.Event.None}async close(){this.dispose()}}e.$Xzb=S;class ${constructor(p){this.a=p}isUsed(p){const g={payload:p,profile:void 0,workspace:void 0};return this.a.call("isUsed",g)}}e.$Yzb=$}),define(re[107],oe([0,1,6,37,32]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function A(S){if(j.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function O(S,$,C,p,g,u,d,y){const f=Object.create(null);f["common.machineId"]=u,f.sessionID=(0,D.$3f)()+Date.now(),f.commitHash=p,f.version=g,f["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,j.$h)(j.$t),f["common.nodePlatform"]=N.$2d,f["common.nodeArch"]=C,f["common.product"]=y||"desktop",d&&(f["common.msftInternal"]=d);let o=0;const h=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),j.$l&&(f["common.snap"]="true");const b=A($);return b&&(f["common.platformDetail"]=b),f}e.$9n=O;function R(S){const $=N.env.USERDNSDOMAIN;if(!$)return!1;const C=$.toLowerCase();return S.some(p=>C===p)}e.$0n=R}),define(re[21],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,j.$Ah)("telemetryService"),e.$9k=(0,j.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(re[220],oe([0,1,36,5,34,23,15,6,11,132,31,146,95,13,24,21]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=e.$rr=void 0;const f=new Map;async function o(t,c){const s=`${t}::${c.join(":")}`,n=f.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,l=new Map,E=2e4;function m(v,L,T,z){const U=L.substring(v.length+1);return N.Promises.withAsyncBody(async B=>{let Q;try{Q=await C.Promises.readdir(L,{withFileTypes:!0})}catch{B();return}if(z.count>=E){z.count+=Q.length,z.maxReached=!0,B();return}let J=Q.length;if(J===0){B();return}let x=Q;z.count+Q.length>E&&(z.maxReached=!0,J=E-z.count,x=Q.slice(0,J)),z.count+=Q.length;for(const H of x)if(H.isDirectory()){if(T.includes(H.name)||await m(v,(0,O.$8d)(L,H.name),T,z),--J===0){B();return}}else{const X=H.name.lastIndexOf(".");if(X>=0){const G=H.name.substring(X+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of i)G.relativePathPattern?.test(U)!==!1&&G.filePattern.test(H.name)&&l.set(G.tag,(l.get(G.tag)??0)+1);if(--J===0){B();return}}})}const a=N.Promises.withAsyncBody(async v=>{const L={count:0,maxReached:!1};await m(t,t,c,L);const T=await w(t);v({configFiles:h(l),fileTypes:h(r),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:T})});return f.set(s,a),a}e.$rr=o;function h(t){return Array.from(t.entries(),([c,s])=>({name:c,count:s})).sort((c,s)=>s.count-c.count)}function b(){const t={os:`${j.type()} ${j.arch()} ${j.release()}`,memory:`${(j.totalmem()/u.$zk.GB).toFixed(2)}GB (${(j.freemem()/u.$zk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$Gm.value()*100)}%`},c=j.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.$sr=b;async function w(t){try{const c=new Map,s=(0,O.$8d)(t,".vscode","launch.json"),n=await C.Promises.readFile(s),i=[],r=(0,D.$Km)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,D.$Tm)(r)==="object"&&r.configurations)for(const l of r.configurations){const E=l.type;E&&(c.has(E)?c.set(E,c.get(E)+1):c.set(E,1))}return h(c)}catch{return[]}}e.$tr=w;let I=class{constructor(c,s){this.c=c,this.d=s}f(c){const s=[];return s.push(`OS Version:       ${c.os}`),s.push(`CPUs:             ${c.cpus}`),s.push(`Memory (System):  ${c.memory}`),s.push(`VM:               ${c.vmHint}`),s.join(`
`)}g(c){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${j.type()} ${j.arch()} ${j.release()}`);const n=j.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(j.totalmem()/u.$zk.GB).toFixed(2)}GB (${(j.freemem()/u.$zk.GB).toFixed(2)}GB free)`),R.$i||s.push(`Load (avg):       ${j.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round($.$Gm.value()*100)}%`),s.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${c.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(c,s){return Promise.all([(0,p.$qr)(c.mainPID),this.k(c)]).then(async n=>{let[i,r]=n,l=this.m(c,i);return s.forEach(E=>{if((0,g.$gm)(E))l+=`
${E.errorMessage}`,r+=`
${E.errorMessage}`;else if(l+=`

Remote: ${E.hostName}`,E.processes&&(l+=`
${this.m(c,E.processes)}`),E.workspaceMetadata){r+=`
|  Remote: ${E.hostName}`;for(const m of Object.keys(E.workspaceMetadata)){const a=E.workspaceMetadata[m];let v=`${a.fileCount} files`;a.maxFilesReached&&(v=`more than ${v}`),r+=`|    Folder (${m}): ${v}`,r+=this.h(a)}}}),{processInfo:l,workspaceInfo:r}})}async getSystemInfo(c,s){const{memory:n,vmHint:i,os:r,cpus:l}=b(),E={os:r,memory:n,cpus:l,vmHint:i,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:s};return R.$i||(E.load=`${j.loadavg().map(m=>Math.round(m)).join(", ")}`),R.$k&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(c,s){const n=[];return(0,p.$qr)(c.mainPID).then(async i=>(n.push(""),n.push(this.g(c)),n.push(""),n.push(this.m(c,i)),c.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(c))),s.forEach(r=>{if((0,g.$gm)(r))n.push(`
${r.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${r.hostName}`),n.push(this.f(r.machineInfo)),r.processes&&n.push(this.m(c,r.processes)),r.workspaceMetadata)for(const l of Object.keys(r.workspaceMetadata)){const E=r.workspaceMetadata[l];let m=`${E.fileCount} files`;E.maxFilesReached&&(m=`more than ${m}`),n.push(`Folder (${l}): ${m}`),n.push(this.h(E))}}),n.push(""),n.push(""),n.join(`
`)))}h(c){const s=[];let i=0;const r=(a,v)=>{const L=` ${a}(${v})`;i+L.length>60?(s.push(l),l="|                 ",i=l.length):i+=L.length,l+=L};let l="|      File types:";const E=10,m=c.fileTypes.length>E?E:c.fileTypes.length;for(let a=0;a<m;a++){const v=c.fileTypes[a];r(v.name,v.count)}if(s.push(l),c.configFiles.length>=0&&(l="|      Conf files:",i=0,c.configFiles.forEach(a=>{r(a.name,a.count)}),s.push(l)),c.launchConfigFiles.length>0){let a="|      Launch Configs:";c.launchConfigFiles.forEach(v=>{const L=v.count>1?` ${v.name}(${v.count})`:` ${v.name}`;a+=L}),s.push(a)}return s.join(`
`)}j(c){const s=Math.max(...Object.keys(c).map(n=>n.length));return Object.keys(c).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${c[n]}`).join(`
                  `)}k(c){const s=[],n=[];return c.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const l=S.URI.revive(r);if(l.scheme===A.Schemas.file){const E=l.fsPath;n.push(o(E,["node_modules",".git"]).then(m=>{let a=`${m.fileCount} files`;m.maxFilesReached&&(a=`more than ${a}`),s.push(`|    Folder (${(0,O.$_d)(E)}): ${a}`),s.push(this.h(m))}).catch(m=>{s.push(`|      Error: Unable to collect workspace stats for folder ${E} (${m.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(c,s){const n=new Map;c.windows.forEach(r=>n.set(r.pid,`window [${r.id}] (${r.title})`)),c.pidToNames.forEach(({pid:r,name:l})=>n.set(r,l));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.n(c.mainPID,n,i,s,0),i.join(`
`)}n(c,s,n,i,r){const l=r===0;let E;l?E=i.pid===c?`${this.d.applicationName} main`:"remote agent":s.has(i.pid)?E=s.get(i.pid):E=`${"  ".repeat(r)} ${i.name}`;const m=process.platform==="win32"?i.mem:j.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(m/u.$zk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(i.children)&&i.children.forEach(a=>this.n(c,s,n,a,r+1))}async getWorkspaceFileExtensions(c){const s=new Set;for(const{uri:n}of c.folders){const i=S.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const r=i.fsPath;try{(await o(r,["node_modules",".git"])).fileTypes.forEach(E=>s.add(E.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(c){for(const{uri:s}of c.folders){const n=S.URI.revive(s);if(n.scheme!==A.Schemas.file)continue;const i=n.fsPath;try{const r=await o(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),r.fileTypes.forEach(l=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:l.name,count:l.count})}),r.launchConfigFiles.forEach(l=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:l.name,count:l.count})}),r.configFiles.forEach(l=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};e.$ur=I,e.$ur=I=ye([Y(0,y.$8k),Y(1,d.$jj)],I)}),define(re[108],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=e.$e6b=void 0;class j{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:R,data:S}){return this.b.forEach($=>$.log(R,S)),Promise.resolve(null)}}e.$e6b=j;class N{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$f6b=N}),define(re[46],oe([0,1,30,9,3,19,74,107,21]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class ${constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$$n=$;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=C,e.$ao=new C;class p{async publicLog(i,r,l){}async publicLogError(i,r,l){}}e.$bo=p,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function g(n,i){return D.Event.debounce(i.onDidChangeConfiguration,(l,E)=>{const m=l?new Set([...l.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:m}},1e3,!0)(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.$0h)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$fo=g;function u(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.$go=u;function d(n,i){return!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$ho=d;function y(n){const i=n.getValue(S.$cl),r=n.getValue(S.$dl);if(n.getValue(S.$el)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=y;function f(n){const i={},r={},l={};b(n,l);for(let E in l){E=E.length>150?E.substr(E.length-149):E;const m=l[E];typeof m=="number"?r[E]=m:typeof m=="boolean"?r[E]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${m.length}`),i[E]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(i[E]=m)}return{properties:i,measurements:r}}e.$jo=f;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(n){if(!n)return"none";const i=(0,O.$Ok)(n);return o.has(i)?i:"other"}e.$ko=h;function b(n,i,r=0,l){if(n)for(const E of Object.getOwnPropertyNames(n)){const m=n[E],a=l?l+E:E;Array.isArray(m)?i[a]=(0,j.$Zm)(m):m instanceof Date?i[a]=m.toISOString():(0,N.$kf)(m)?r<2?b(m,i,r+1,a+"."):i[a]=(0,j.$Zm)(m):i[a]=m}}function w(n,i){const r=n.msftInternalDomains||[],l=i.getValue("telemetry.internalTesting");return(0,R.$0n)(r)||l}e.$lo=w;function I(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$mo=I;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const l=[];for(const v of i)for(;;){const L=v.exec(n);if(!L)break;l.push([L.index,v.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(r="";;){const v=m.exec(n);if(!v)break;const L=l.some(([T,z])=>v.index<z&&T<m.lastIndex);!E.test(v[0])&&!L&&(r+=n.substring(a,v.index)+"<REDACTED: user-file-path>",a=m.lastIndex)}return a<n.length&&(r+=n.substr(a)),r}function c(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function s(n,i){return(0,j.$Wm)(n,r=>{if(r instanceof $||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=t(l,i);for(const E of i)l=l.replace(E,"");return l=c(l),l}})}e.$no=s}),define(re[33],oe([0,1,28,29,45,6,11,8,37,46]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function C(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,j.$Ge)(s.id,n.id)===0}e.$oo=C;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,i,r)}static parse(n){const i=p.exec(n);return i&&i[1]&&i[2]?new g({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?C(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$po=g;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(s){const n=u.exec(s);return n&&n[1]?[f(n[1]),n[2]]:[f(s),void 0]}e.$qo=d;function y(s,n){return`${s}.${n}`}e.$ro=y;function f(s){return s.toLowerCase()}e.$so=f;function o(s,n){return f(y(s??D.$Ql,n))}e.$to=o;function h(s,n){const i=[],r=l=>{for(const E of i)if(E.some(m=>C(n(m),n(l))))return E;return null};for(const l of s){const E=r(l);E?E.push(l):i.push([l])}return i}e.$uo=h;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$vo=b;function w(s){return{id:new $.$$n(s.identifier.id),name:new $.$$n(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$wo=w,e.$xo=new D.$Ul("pprice.better-merge");function I(s,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&i.every(E=>!C(E.identifier,{id:l}))){const E=s.filter(m=>C(m.identifier,{id:l}));E.length===1&&(i.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$yo=I;async function t(s,n){if(!A.$k)return!1;let i;try{i=(await s.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,R.$8)(l))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(s,n){const i=await t(s,n),r=(0,N.$Tn)(i?"alpine":A.$t,S.$3d);return n.debug("ComputeTargetPlatform:",r),r}e.$zo=c}),define(re[221],oe([0,1,18,2,22,11,13,24,5,3,15,6,37,33]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h4b=e.$g4b=void 0;let d=class extends N.$jc{constructor(b,w){super(),this.b=b,this.c=w,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,I])=>this.a.set(I.configPath,I))}getConfigBasedTips(b){return this.f(b)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(b){const w=[];for(const[I,t]of this.a)if(!(t.configScheme&&t.configScheme!==b.scheme))try{const c=(await this.b.readFile((0,D.$hg)(b,I))).value.toString();for(const[s,n]of Object.entries(t.recommendations))(!n.contentPattern||new RegExp(n.contentPattern,"mig").test(c))&&w.push({extensionId:s,extensionName:n.name,configName:t.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})}catch{}return w}};e.$g4b=d,e.$g4b=d=ye([Y(0,O.$5j),Y(1,R.$jj)],d);const y="extensionTips/promptedExecutableTips",f="extensionTips/lastPromptedMediumImpExeTime";class o extends d{constructor(b,w,I,t,c,s,n,i){super(n,i),this.r=b,this.s=w,this.t=I,this.u=t,this.w=c,this.z=s,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,l])=>{const E=[],m=[],a=[];Object.entries(l.recommendations).forEach(([v,L])=>{L.important?l.important?E.push({extensionId:v,extensionName:L.name,isExtensionPack:!!L.isExtensionPack}):m.push({extensionId:v,extensionName:L.name,isExtensionPack:!!L.isExtensionPack}):a.push({extensionId:v,extensionName:L.name,isExtensionPack:!!L.isExtensionPack})}),E.length&&this.g.set(r,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:E}),m.length&&this.h.set(r,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:m}),a.length&&this.j.set(r,{exeFriendlyName:l.friendlyName,windowsPath:l.windowsPath,recommendations:a})}),this.B((0,S.$Hg)(async()=>{await this.C(),this.F(),this.G()},3e3))}async getImportantExecutableBasedTips(){const b=await this.O(this.g),w=await this.O(this.h);return[...b,...w]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const b=await this.O(this.g),w=await this.O(this.h),I=await this.u.getInstalled();this.m=this.D(b,I),this.n=this.D(w,I)}D(b,w){const I=new Map;b.forEach(i=>I.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:c}=this.N([...I.keys()],w);for(const i of t){const r=I.get(i);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of c){const r=I.get(i);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const s=this.L(),n=new Map;for(const i of c){const r=I.get(i);if(r&&(!s[r.exeName]||!s[r.exeName].includes(r.extensionId))){let l=n.get(r.exeName);l||(l=[],n.set(r.exeName,l)),l.push(r)}}return n}F(){if(this.m.size===0)return;const[b,w]=[...this.m.entries()][0];this.H(w).then(I=>{switch(I){case"reacted":this.M(w[0].exeName,w);break;case"ignored":this.m.delete(b);break;case"incompatibleWindow":{const t=$.Event.once($.Event.latch($.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B((0,S.$Hg)(()=>{t.dispose(),this.F()},36e5));break}}})}G(){if(this.n.size===0)return;const b=this.I(),w=Date.now()-b,I=7*24*60*60*1e3;if(w<I){const s=this.B((0,S.$Hg)(()=>{s.dispose(),this.G()},I-w));return}const[t,c]=[...this.n.entries()][0];this.H(c).then(s=>{switch(s){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(c[0].exeName,c);const n=this.B((0,S.$Hg)(()=>{n.dispose(),this.G()},I));break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const n=$.Event.once($.Event.latch($.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(n(()=>this.G()));break}case"toomany":{const n=this.B((0,S.$Hg)(()=>{n.dispose(),this.G()},36e5));break}}})}async H(b){const w=await this.u.getInstalled(1),I=b.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(c=>w.every(s=>!(0,u.$oo)(s.identifier,{id:c})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:I,source:3,name:b[0].exeFriendlyName,searchValue:`@exe:"${b[0].exeName}"`})}I(){let b=this.w.getNumber(f,-1);return b||(b=Date.now(),this.J(b)),b}J(b){this.w.store(f,b,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(b,w){const I=this.L();I[b]=w.map(({extensionId:t})=>t.toLowerCase()),this.w.store(y,JSON.stringify(I),-1,0)}N(b,w){const I=[],t=[],c=w.reduce((s,n)=>(s.add(n.identifier.id.toLowerCase()),s),new Set);return b.forEach(s=>{c.has(s.toLowerCase())?I.push(s):t.push(s)}),{installed:I,uninstalled:t}}async O(b){const w=[],I=new Map;for(const t of b.keys()){const c=b.get(t);if(!c||!(0,j.$Ib)(c.recommendations))continue;const s=[];p.$i?c.windowsPath&&s.push(c.windowsPath.replace("%USERPROFILE%",()=>g.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>g.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>g.env.ProgramFiles).replace("%APPDATA%",()=>g.env.APPDATA).replace("%WINDIR%",()=>g.env.WINDIR)):(s.push((0,C.$8d)("/usr/local/bin",t)),s.push((0,C.$8d)("/usr/bin",t)),s.push((0,C.$8d)(this.r.fsPath,t)));for(const n of s){let i=I.get(n);if(i===void 0&&(i=await this.b.exists(A.URI.file(n)),I.set(n,i)),i)for(const{extensionId:r,extensionName:l,isExtensionPack:E,whenNotInstalled:m}of c.recommendations)w.push({extensionId:r,extensionName:l,isExtensionPack:E,exeName:t,exeFriendlyName:c.exeFriendlyName,windowsPath:c.windowsPath,whenNotInstalled:m})}}return w}}e.$h4b=o}),define(re[222],oe([0,1,26,33]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KUb=void 0;async function D(A,O,R,S,$){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const p=await A.getInstalled(1);for(const[g,u]of Object.entries(C.deprecated)){if(!u?.extension)continue;const{id:d,autoMigrate:y,preRelease:f}=u.extension;if(!y)continue;const o=p.find(b=>(0,N.$oo)(b.identifier,{id:g}));if(!o)continue;const h=(await O.getExtensions([{id:d,preRelease:f}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},j.CancellationToken.None))[0];if(!h){$.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{$.info(`Migrating '${o.identifier.id}' extension to '${d}' extension...`);const b=!S.getDisabledExtensions().some(I=>(0,N.$oo)(I,o.identifier));await A.uninstall(o),$.info(`Uninstalled the unsupported extension '${o.identifier.id}'`);let w=p.find(I=>(0,N.$oo)(I.identifier,{id:d}));(!w||!w.isPreReleaseVersion&&b)&&(w=await A.installFromGallery(h,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4}),$.info(`Installed the pre-release extension '${w.identifier.id}'`),b||(await S.disableExtension(w.identifier),$.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${o.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,N.$ro)(o.manifest.publisher,o.manifest.name),(0,N.$ro)(w.manifest.publisher,w.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${o.identifier.id}' extension to '${d}' extension.`)}catch(b){$.error(b)}}}catch(C){$.error(C)}}e.$KUb=D}),define(re[223],oe([0,1,3,2,35,33,45]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;class R extends N.$jc{constructor($,C,p,g,u,d,y){super(),this.f=$,this.g=C,this.h=p,this.j=g,this.m=u,this.n=d,this.r=y,this.a=this.B(new j.$ed),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$rc),this.s().then(null,f=>y.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(C=>(this.c.set(C.id,(0,N.$gc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w($){for(const C of $.extensions)this.I(this.L(C.identifier,C.version),$.profileLocation)}async y($){for(const C of $.extensions){const p=this.L(C.identifier,C.version);$.error?this.J(p,$.profileLocation):this.I(p,$.profileLocation)}}async z($){for(const C of $.extensions)this.J(this.L(C.identifier,C.version),$.profileLocation)}async C($){const C=[],p=[];for(const g of $.extensions){const u=this.L(g.identifier,g.version);$.error?this.I(u,$.profileLocation):(this.J(u,$.profileLocation),this.b.has(u)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),p.push(this.f.scanInstalledExtensionAtLocation(g.location).then(d=>{d?C.push(d):this.r.info("Extension not found at the location",g.location.toString())},d=>this.r.error(d)))))}try{await Promise.all(p),C.length&&await this.H(C)}catch(g){this.r.error(g)}}D($){for(const C of this.h.profiles)$.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F($){const C=[],p=[],g=await this.j.scanProfileExtensions($),u=new Set,d=new Set;for(const[y,f]of this.b)f.has($)&&d.add(y);for(const y of g){const f=this.L(y.identifier,y.version);u.add(f),d.has(f)||(C.push(y.identifier),this.I(f,$))}for(const y of d)if(!u.has(y)){const f=this.M(y);f&&(p.push(f.identifier),this.J(y,$))}(C.length||p.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:$}:void 0,removed:p.length?{extensions:p,profileLocation:$}:void 0})}async G($){const C=await this.j.scanProfileExtensions($);for(const p of C)this.I(this.L(p.identifier,p.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(p=>!this.b.has(this.L(p.identifier,p.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,C){let p=this.b.get($);p||this.b.set($,p=new D.$zi(g=>this.m.extUri.getComparisonKey(g))),p.add(C)}J($,C){const p=this.b.get($);p&&p.delete(C),p?.size||this.b.delete($)}L($,C){return`${O.$Ul.toKey($.id)}@${C}`}M($){const[C,p]=(0,A.$qo)($);return p?{identifier:{id:C},version:p}:void 0}}e.$vp=R}),define(re[224],oe([0,1,44,46]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0;async function D(A,O,R,S,$,C,p){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,N.$go)(O,R)&&(0,N.$io)(S)===3){const u=await(0,j.$Zo)(R,$,C);g["X-Market-User-Id"]=u,g["VSCode-SessionId"]=p.machineId||u}return g}e.$1o=D}),define(re[225],oe([0,1,69,18,5,2,23,15,31,16,29,33,7,72,11]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let y=class extends u.$Hq{constructor(b,w,I,t){super(I),this.h=b,this.j=t,this.g=this.B(new f(w,t)),this.h.registerParticipant({postInstall:async c=>this.m(c),postUninstall:async c=>this.n(c)})}async getBuiltInExtensionTranslationsUri(b,w){const t=(await this.g.getLanguagePacks())[w];if(!t){this.j.warn(`No language pack found for ${w}`);return}const c=t.translations[b];return c?d.URI.file(c):void 0}async getInstalledLanguages(){const b=await this.g.getLanguagePacks(),w=Object.keys(b).map(I=>{const t=b[I];return{...this.f(I,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return w.push(this.f("en","English")),w.sort((I,t)=>I.label.localeCompare(t.label)),w}async m(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",b.identifier.id),await this.update())}async n(b){const w=await this.g.getLanguagePacks();Object.keys(w).some(I=>w[I]&&w[I].extensions.some(t=>(0,p.$oo)(t.extensionIdentifier,b.identifier)))&&(this.j.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,w]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),I=await this.g.update(w);return!(0,N.$sb)(Object.keys(b),Object.keys(I))}};e.$Iq=y,e.$Iq=y=ye([Y(0,C.$1n),Y(1,$.$Ih),Y(2,C.$Yn),Y(3,g.$4i)],y);let f=class extends A.$jc{constructor(b,w){super(),this.j=w,this.c={},this.f=(0,R.$8d)(b.userDataPath,"languagepacks.json"),this.g=new D.$Mg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(b){return this.s(w=>{Object.keys(w).forEach(I=>delete w[I]),this.m(w,...b)}).then(()=>this.c)}m(b,...w){for(const I of w)I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&this.n(b,I);Object.keys(b).forEach(I=>this.r(b[I]))}n(b,w){const I=w.identifier,t=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const c of t)if(w.location.scheme===O.Schemas.file&&o(c)){let s=b[c.languageId];s||(s={hash:"",extensions:[],translations:{},label:c.localizedLanguageName??c.languageName},b[c.languageId]=s);const n=s.extensions.filter(i=>(0,p.$oo)(i.extensionIdentifier,I))[0];n?n.version=w.manifest.version:s.extensions.push({extensionIdentifier:I,version:w.manifest.version});for(const i of c.translations)s.translations[i.id]=(0,R.$8d)(w.location.fsPath,i.path)}}r(b){if(b){const w=(0,j.createHash)("md5");for(const I of b.extensions)w.update(I.extensionIdentifier.uuid||I.extensionIdentifier.id).update(I.version);b.hash=w.digest("hex")}}s(b=()=>null){return this.g.queue(()=>{let w=null;return S.Promises.readFile(this.f,"utf8").then(void 0,I=>I.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(I)).then(I=>{try{return JSON.parse(I)}catch{return{}}}).then(I=>(w=b(I),I)).then(I=>{for(const c of Object.keys(I))I[c]||delete I[c];this.c=I,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),S.Promises.writeFile(this.f,t)}).then(()=>w,I=>this.j.error(I))})}};f=ye([Y(0,$.$Ih),Y(1,g.$4i)],f);function o(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const b of h.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(re[226],oe([0,1,143,8,30,46]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(C,p,g){const u=await(0,j.$0C)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,j.$0C)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new u.AppInsightsCore,f=new d.PostChannel,o={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(g){o.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:g};o.extensionConfig[f.identifier]=h}return y.initialize(o,[]),y.addTelemetryInitializer(h=>{p&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),y}class ${constructor(p,g,u,d,y){this.e=p,this.f=g,this.g=u,this.h=y,this.c=O,this.d=R,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(p){if(this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(g=>{p(g)},g=>{(0,N.$Y)(g),console.error(g)})}}log(p,g){if(!this.a)return;g=(0,D.$Xm)(g,this.g),g=(0,A.$jo)(g);const u=this.f+"/"+p;try{this.i(d=>{d.pluginVersionString=g?.properties.version??"Unknown",d.track({name:u,baseData:{name:u,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.$6M=$}),define(re[109],oe([0,1,2,167,16,7,24,46]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H3b=void 0;let S=class extends j.$jc{constructor(C,p,g,u,d=""){super(),this.b=d;const y=p.getLogger(R.$co);if(y)this.a=this.B(y);else{const o=(0,R.$ho)(u,g)?" (Not Sent)":"",h=()=>(0,R.$go)(u,g)&&C.getLevel()===A.LogLevel.Trace;this.a=this.B(p.createLogger(R.$co,{name:(0,N.localize)(0,null,o),hidden:!h()})),this.B(C.onDidChangeLogLevel(()=>p.setVisibility(R.$co,h()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,p){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$jo)(p))}};e.$H3b=S,e.$H3b=S=ye([Y(0,A.$4i),Y(1,A.$5i),Y(2,D.$Hh),Y(3,O.$jj)],S)}),define(re[110],oe([0,1,2,30,6,28,168,19,49,102,24,40,21,46]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(o,h,b){this.k=h,this.l=b,this.d={},this.i=new j.$ic,this.j=[],this.b=o.appenders,this.c=o.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=o.piiPaths||[],this.g=3,this.h=!!o.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,A.$pe)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$pe)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(g.$cl)||w.affectsConfiguration(g.$el)||w.affectsConfiguration(g.$dl))&&this.m()}))}setExperimentProperty(o,h){this.d[o]=h}m(){let o=(0,u.$io)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const b=h.usage?3:h.error?2:0;o=Math.min(o,b)}this.g=o}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(o,h,b){this.g<h||(b=(0,N.$Xm)(b,this.d),b=(0,u.$no)(b,this.j),b=(0,N.$Xm)(b,this.c),this.b.forEach(w=>w.log(o,b)))}publicLog(o,h){this.n(o,3,h)}publicLog2(o,h){this.publicLog(o,h)}publicLogError(o,h){this.h&&this.n(o,2,h)}publicLogError2(o,h){this.publicLogError(o,h)}};e.$Oq=d,e.$Oq=d=ye([Y(1,R.$7h),Y(2,C.$jj)],d);function y(){const f=(0,O.localize)(0,null,$.default.nameLong),o=$.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=D.$o?"":(0,O.localize)(3,null),b=(0,O.localize)(4,null),w=(0,O.localize)(5,null),I=(0,O.localize)(6,null),t=(0,O.localize)(7,null),c=`
|       | ${b} | ${w} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,O.localize)(8,null);return`
${f} ${o} ${h}

&nbsp;

${t}
${c}

&nbsp;

${s}
`}p.$7m.as(S.$_m.Configuration).registerConfiguration({id:g.$bl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[g.$cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.$7m.as(S.$_m.Configuration).registerConfiguration({id:g.$bl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[g.$el]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,O.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,O.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${g.$cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[227],oe([0,1,14,26,272,226]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0;async function O(C,p){const g=await p.request(C,N.CancellationToken.None),u=(await(0,j.$Qd)(g.stream)).toString(),d=g.res.statusCode??200;return{headers:g.res.headers,statusCode:d,responseData:u}}async function R(C){const p={method:C.type,headers:C.headers};return new Promise((u,d)=>{const y=D.request(C.url??"",p,f=>{f.on("data",function(o){u({headers:f.headers,statusCode:f.statusCode??200,responseData:o.toString()})}),f.on("error",function(o){d(o)})});y.write(C.data,f=>{f&&d(f)}),y.end()})}async function S(C,p,g){const u=typeof p.data=="string"?p.data:new TextDecoder().decode(p.data),d={type:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data).toString()},url:p.urlString,data:u};try{const y=C?await O(d,C):await R(d);g(y.statusCode,y.headers,y.responseData)}catch{g(0,{})}}class $ extends A.$6M{constructor(p,g,u,d,y){const f={sendPOST:(o,h)=>{S(p,o,h)}};super(g,u,d,y,f)}}e.$7M=$}),define(re[228],oe([0,1,23,93,19,16,7,24,21,108,109,110]),function(te,e,j,N,D,A,O,R,S,$,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;let g=class{constructor(d,y,f,o,h,b){this.b=d,this.c=y,this.d=f,this.e=o,this.f=h,this.g=b,this.a=new Map}h(d){if(!this.a.has(d.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const f=[d.id,JSON.stringify(y),d.aiKey],h=new N.$Qp(j.$1f.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=[new $.$f6b(h),new C.$H3b(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new p.$Oq({appenders:b,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}publicLog(d,y,f){this.h(d).publicLog(y,f)}publicLogError(d,y,f){this.h(d).publicLogError(y,f)}};e.$v7b=g,e.$v7b=g=ye([Y(0,D.$7h),Y(1,S.$8k),Y(2,O.$4i),Y(3,O.$5i),Y(4,A.$Hh),Y(5,R.$jj)],g)}),define(re[76],oe([0,1,3,19,4,7]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.ProvidedOnAutoForward=e.$Vz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Uz=e.$Tz=void 0,e.$Tz=(0,D.$Ah)("tunnelService"),e.$Uz=(0,D.$Ah)("sharedTunnelsService");var O;(function(f){f.Http="http",f.Https="https"})(O||(e.TunnelProtocol=O={}));var R;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(R||(e.TunnelPrivacyId=R={}));function S(f){return!!f.forwardPort}e.$Vz=S;var $;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function C(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(o)return{address:o[1],port:+o[2]}}e.$Wz=C,e.$Xz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(f){return e.$Xz.indexOf(f)>=0}e.$Yz=p,e.$Zz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(f){return e.$Zz.indexOf(f)>=0}e.$1z=g;function u(f,o,h,b){if(h===1)return!1;if(h===2&&g(o)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(w?.length===4&&parseInt(w[1])>=18)return!1}return f<1024}e.$2z=u;class d{constructor(o,h,b){this.remoteAddress=o,this.localAddress=h,this.b=b,this.a=new j.$ed,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$3z=d;let y=class{constructor(o,h){this.j=o,this.k=h,this.a=new j.$ed,this.onTunnelOpened=this.a.event,this.b=new j.$ed,this.onTunnelClosed=this.b.event,this.c=new j.$ed,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],h=Array.from(this.e.values());for(const b of h){const w=Array.from(b.values());for(const I of w){const t=await I.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:h}of o.values())await h.then(b=>typeof b!="string"?b?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,h,b,w,I){this.p(o,h,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:h,localAddress:b,privacy:w,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,h){(g(o)||p(o))&&(o=e.$Xz[0]);const b=this.r(o,h);if(b)return++b.refcount,b.value}openTunnel(o,h,b,w,I,t=!1,c,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${b} on local port ${I}.`);const n=this.f??o;if(!n)return;if(h||(h="localhost"),w||(w=this.l),this.f&&this.i.has(b)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.s(n,h,b,w,I,t,c,s);return i?i.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,b),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,b);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.n(r);return(r.tunnelRemoteHost!==h||r.tunnelRemotePort!==b)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&r.privacy!==c&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(l),l}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const h=this.e.get(o.tunnelRemoteHost);if(h){const b=h.get(o.tunnelRemotePort);b&&(b.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,b))}}}}async o(o,h,b){if(b.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${h}.`);const w=b.value.then(async I=>{I&&typeof I!="string"&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(h),w}}async closeTunnel(o,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${h} `);const b=this.e.get(o);if(b&&b.has(h)){const w=b.get(h);w.refcount=0,await this.o(o,h,w)}}p(o,h,b){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(h,{refcount:1,value:b})}async q(o,h){const b=this.e.get(o);if(b){const w=b.get(h),I=w?await w.value:void 0;(!I||typeof I=="string")&&b.delete(h),b.size===0&&this.e.delete(o)}}r(o,h){const b=[o];p(o)?(b.push(...e.$Xz),b.push(...e.$Zz)):g(o)&&b.push(...e.$Zz);const w=b.map(I=>this.e.get(I));for(const I of w){const t=I?.get(h);if(t)return t}}canTunnel(o){return!!C(o)}t(o,h,b,w,I,t,c){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${b} on local port ${w}.`);const s=b;this.i.add(s);const n=w===void 0?b:w,i={elevationRequired:I?this.isPortPrivileged(n):!1},r={remoteAddress:{host:h,port:b},localAddressPort:w,privacy:t,public:t?t!==R.Private:void 0,protocol:c},l=o.forwardPort(r,i);return l?(this.p(h,b,l),l.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),l}};e.$4z=y,e.$4z=y=ye([Y(0,A.$4i),Y(1,N.$7h)],y)}),define(re[229],oe([0,1,7,76,2,8,5]),function(te,e,j,N,D,A,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=void 0;class S extends D.$jc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$1g),this.b.p)}setAddress(p){this.a=p,this.b&&(this.b.complete(p),this.b=null)}setTunnel(p){this.B(p)}}let $=class extends D.$jc{static{R=this}static{this.a=0}constructor(p,g){super(),this.f=p,this.g=g,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(p=>p.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(p,g,u,d,y,f,o){const h=new S,b=await Promise.resolve(this.f.openTunnel(p,h,u,d,y,f,o));if(!b||typeof b=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${u}:${d} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this.c.has(g))throw this.c.delete(g),h.dispose(),await b.dispose(),(0,A.$4)();return h.setTunnel(b),this.b.set(g,h),this.g.info(`[SharedProcessTunnelService] Created tunnel ${g}: ${b.localAddress} (local) to ${u}:${d} (remote).`),{tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress}}async setAddress(p,g){const u=this.b.get(p);u&&u.setAddress(g)}async destroyTunnel(p){const g=this.b.get(p);if(g){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${p}.`),this.b.delete(p),await g.dispose();return}this.c.add(p)}};e.$I7b=$,e.$I7b=$=R=ye([Y(0,N.$Uz),Y(1,j.$4i)],$)}),define(re[27],oe([0,1,4]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=void 0,e.$Bk=(0,j.$Ah)("IUriIdentityService")}),define(re[230],oe([0,1,27,185,13,22,128,3,2]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class ${static{this._clock=0}constructor(g){this.uri=g,this.time=$._clock++}touch(){return this.time=$._clock++,this}}let C=class{constructor(g){this.g=g,this.c=new S.$ic,this.f=2**16;const u=new Map,d=y=>{let f=u.get(y.scheme);return f===void 0&&(f=g.hasProvider(y)&&!this.g.hasCapability(y,1024),u.set(y.scheme,f)),f};this.c.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(y=>{u.delete(y.scheme)})),this.extUri=new A.$9f(d),this.d=new O.$mr((y,f)=>this.extUri.compare(y,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,A.$ig)(g));const u=this.d.get(g);return u?u.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new $(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((d,y)=>d[1].time<y[1].time?1:d[1].time>y[1].time?-1:0);$._clock=0,this.d.clear();const u=this.f*.5;for(let d=0;d<u;d++)this.d.set(g[d][0],g[d][1].touch())}};e.$nr=C,e.$nr=C=ye([Y(0,D.$5j)],C),(0,N.$kr)(j.$Bk,C,1)}),define(re[231],oe([0,1,3,2,13,42,47,14,9]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;class $ extends N.$jc{get capabilities(){return this.f.capabilities&-5}constructor(p,g,u,d){super(),this.c=p,this.f=g,this.g=u,this.h=d,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new j.$ed),this.onDidChangeFile=this.a.event,this.b=O.$Gh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(y=>this.j(y)))}watch(p,g){this.b.set(p,p);const u=this.f.watch(this.m(p),g);return(0,N.$hc)(()=>{this.b.delete(p),u.dispose()})}stat(p){return this.f.stat(this.m(p))}mkdir(p){return this.f.mkdir(this.m(p))}rename(p,g,u){return this.f.rename(this.m(p),this.m(g),u)}readFile(p){return this.f.readFile(this.m(p),{atomic:!0})}readFileStream(p,g,u){const d=(0,A.$sd)(y=>R.$Ed.concat(y.map(f=>R.$Ed.wrap(f))).buffer);return(async()=>{try{const y=await this.readFile(p);d.end(y)}catch(y){d.error(y),d.end()}})(),d}readdir(p){return this.f.readdir(this.m(p))}writeFile(p,g,u){return!(0,S.$kf)(u.atomic)&&(0,D.$ak)(this.f)&&(u={...u,atomic:{postfix:".vsctmp"}}),this.f.writeFile(this.m(p),g,u)}delete(p,g){return this.f.delete(this.m(p),g)}copy(p,g,u){if((0,D.$8j)(this.f))return this.f.copy(this.m(p),this.m(g),u);throw new Error("copy not supported")}j(p){const g=[];for(const u of p){if(u.resource.scheme!==this.c)continue;const d=this.n(u.resource);this.b.findSubstr(d)&&g.push({resource:d,type:u.type})}g.length&&(this.h.debug("User data changed"),this.a.fire(g))}m(p){return p.with({scheme:this.c})}n(p){return p.with({scheme:this.g})}}e.$36b=$}),define(re[77],oe([0,1,85]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Czb=e.$Bzb=e.edit=void 0;function N(O,R,S,$){const C=(0,j.$tS)(O,R,S,$)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=N;function D(O,R,S){let $=S;for(;$>=0;){if(O.charAt($)===R.charAt(R.length-1)&&R.length===1)return $+1;if($--,R.length===2&&$>=0&&O.charAt($)===R.charAt(0))return $+2}return 0}e.$Bzb=D;function A(O,R,S){let $=S;for(;$>=0;)if(O.charAt($)===R.charAt(R.length-1)&&R.length===1||($++,R.length===2&&$>=0&&O.charAt($)===R.charAt(1)))return $;return O.length-1}e.$Czb=A}),define(re[232],oe([0,1,30,53,9]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q2b=void 0;function A(u,d,y,f,o,h){const b=[],w=[],I=[];if(!d){const B=u.filter(({identifier:Q})=>o.every(J=>J.toLowerCase()!==Q.id.toLowerCase()));return{local:{added:b,removed:w,updated:I},remote:B.length>0?{added:B,updated:[],removed:[],all:B}:null}}u=u.map(p),d=d.map(p),y=y?y.map(p):null;const t=new Map,c=B=>{B.uuid&&t.set(B.id.toLowerCase(),B.uuid)};u.forEach(({identifier:B})=>c(B)),d.forEach(({identifier:B})=>c(B)),y?.forEach(({identifier:B})=>c(B));const s=B=>{const Q=B.identifier.uuid||t.get(B.identifier.id.toLowerCase());return Q?`uuid:${Q}`:`id:${B.identifier.id.toLowerCase()}`},n=(B,Q)=>(B.set(s(Q),Q),B),i=u.reduce(n,new Map),r=d.reduce(n,new Map),l=d.reduce((B,Q)=>n(B,(0,j.$Um)(Q)),new Map),E=y?y.reduce(n,new Map):null,m=f.reduce(n,new Map),a=o.reduce((B,Q)=>{const J=t.get(Q.toLowerCase());return B.add(J?`uuid:${J}`:`id:${Q.toLowerCase()}`)},new Set),v=h?h.reduce((B,{id:Q,uuid:J})=>(J=J??t.get(Q.toLowerCase()),B.add(J?`uuid:${J}`:`id:${Q.toLowerCase()}`)),new Set):null,L=O(i,r,a,!1);if(L.added.size>0||L.removed.size>0||L.updated.size>0){const B=O(E,i,a,!1),Q=O(E,r,a,!0),J=(x,H,X,G)=>{let W,V,ee;return H.installed?(W=G.pinned,ee=G.preRelease,W&&(V=G.version)):(W=X.pinned,ee=X.preRelease,W&&(V=X.version)),W===void 0&&(W=H.pinned,W&&(V=H.version)),ee===void 0&&(ee=H.preRelease),{...G,installed:H.installed||X.installed,pinned:W,preRelease:ee,version:V??(X.version&&(!H.installed||N.gt(X.version,H.version))?X.version:H.version),state:S(H,X,E?.get(x))}};for(const x of Q.removed.values()){const H=i.get(x);if(!H)continue;const X=(0,D.$tf)(E?.get(x)),G=v&&!v.has(x)&&X.installed;H.installed&&G?w.push(H.identifier):l.set(x,H)}for(const x of Q.added.values()){const H=(0,D.$tf)(r.get(x)),X=i.get(x);if(X){if(L.updated.has(x)){const G=J(x,X,H,H);R(X,H,!1,!1)||I.push(g(G,x)),l.set(x,G)}}else H.installed&&b.push(g(H,x))}for(const x of Q.updated.values()){const H=(0,D.$tf)(r.get(x)),X=(0,D.$tf)(E?.get(x)),G=i.get(x);if(G)if(v&&!v.has(x)&&X.installed&&G.installed&&!H.installed)w.push(G.identifier);else{const V=J(x,G,H,H);I.push(g(V,x)),l.set(x,V)}else H.installed&&b.push(g(H,x))}for(const x of B.added.values())Q.added.has(x)||l.set(x,(0,D.$tf)(i.get(x)));for(const x of B.updated.values()){if(Q.removed.has(x)||Q.updated.has(x))continue;const H=(0,D.$tf)(i.get(x)),X=(0,D.$tf)(r.get(x));l.set(x,J(x,H,X,H))}for(const x of B.removed.values())Q.updated.has(x)||Q.removed.has(x)||m.has(x)||(0,D.$tf)(r.get(x)).installed&&v&&(v.has(x)||!(0,D.$tf)(E?.get(x)).installed||l.delete(x))}const T=[],z=O(r,l,new Set,!0),U=z.added.size>0||z.updated.size>0||z.removed.size>0;return U&&l.forEach((B,Q)=>T.push(g(B,Q))),{local:{added:b,removed:w,updated:I},remote:U?{added:[...z.added].map(B=>l.get(B)),updated:[...z.updated].map(B=>l.get(B)),removed:[...z.removed].map(B=>r.get(B)),all:T}:null}}e.$q2b=A;function O(u,d,y,f){const o=u?[...u.keys()].filter(t=>!y.has(t)):[],h=[...d.keys()].filter(t=>!y.has(t)),b=h.filter(t=>!o.includes(t)).reduce((t,c)=>(t.add(c),t),new Set),w=o.filter(t=>!h.includes(t)).reduce((t,c)=>(t.add(c),t),new Set),I=new Set;for(const t of o){if(w.has(t))continue;const c=u.get(t),s=d.get(t);(!s||!R(c,s,f,!0))&&I.add(t)}return{added:b,removed:w,updated:I}}function R(u,d,y,f){return!(u.disabled!==d.disabled||!!u.isApplicationScoped!=!!d.isApplicationScoped||f&&u.installed!==d.installed||u.installed&&d.installed&&(u.preRelease!==d.preRelease||u.pinned!==d.pinned||d.pinned&&u.version!==d.version)||!C(u.state,d.state)||y&&u.version!==d.version)}function S(u,d,y){const f=u.state,o=d.state,h=y?.state;if(!d.version||f&&N.gt(u.version,d.version))return f;if(o&&N.gt(d.version,u.version)||!f)return o;if(!o)return f;const b=(0,j.$Um)(f),w=h?$(h,o):{added:Object.keys(o).reduce((t,c)=>(t.add(c),t),new Set),removed:new Set,updated:new Set},I=h?$(h,f):{added:Object.keys(f).reduce((t,c)=>(t.add(c),t),new Set),removed:new Set,updated:new Set};for(const t of[...w.added.values(),...w.updated.values()])b[t]=o[t];for(const t of w.removed.values())I.updated.has(t)||delete b[t];return b}function $(u,d){const y=Object.keys(u),f=Object.keys(d),o=f.filter(w=>!y.includes(w)).reduce((w,I)=>(w.add(I),w),new Set),h=y.filter(w=>!f.includes(w)).reduce((w,I)=>(w.add(I),w),new Set),b=new Set;for(const w of y){if(h.has(w))continue;const I=u[w],t=d[w];(0,j.$Ym)(I,t)||b.add(w)}return{added:o,removed:h,updated:b}}function C(u={},d={}){const{added:y,removed:f,updated:o}=$(u,d);return y.size===0&&f.size===0&&o.size===0}function p(u){return{...u,disabled:!!u.disabled,installed:!!u.installed}}function g(u,d){const y={...u,identifier:{id:u.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!u.preRelease,pinned:!!u.pinned};return u.disabled||delete y.disabled,u.installed||delete y.installed,u.state||delete y.state,u.isApplicationScoped||delete y.isApplicationScoped,y}}),define(re[111],oe([0,1,18,19,4]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zBb=e.$yBb=void 0,e.$yBb=(0,D.$Ah)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let $=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return $=$.filter(C=>C!==R&&C!==`-${R}`),S&&$.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",$.length?$:void 0,2)}updateSynchronizedExtensions(R,S){let $=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return $=$.filter(C=>C!==R&&C!==`-${R}`),S&&$.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",$.length?$:void 0,2)}getIgnoredExtensions(R){const S=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),$=this.b().map(g=>g.toLowerCase()),C=[],p=[];if(Array.isArray($))for(const g of $)g.startsWith("-")?p.push(g.substring(1)):C.push(g);return(0,j.$Jb)([...S,...C].filter(g=>!p.includes(g)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$zBb=A,e.$zBb=A=ye([Y(0,N.$7h)],A)}),define(re[233],oe([0,1,18,34,30,94,77]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w2b=void 0;function R(w){return(0,N.$Km)(w)||[]}async function S(w,I,t,c,s){const n=R(w),i=R(I),r=t?R(t):null,l=[...n,...i,...r||[]].map(J=>J.key),E=await s.resolveUserBindings(l),m=C(n,i,r,E);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:w,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:w,hasChanges:!0,hasConflicts:!1};const a=g(n),v=g(i),L=r?g(r):null,T=d(a,v,E),z=L?d(L,a,E):{added:[...a.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},U=L?d(L,v,E):{added:[...v.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},B=$(T,z,U);let Q=w;for(const J of B.removed.values())B.conflicts.has(J)||(Q=h(Q,J,c));for(const J of B.added.values()){if(B.conflicts.has(J))continue;const x=v.get(J);if(x.some(H=>H.command!==`-${J}`&&m.conflicts.has(E[H.key]))){B.conflicts.add(J);continue}Q=o(Q,x,c)}for(const J of B.updated.values()){if(B.conflicts.has(J))continue;const x=v.get(J);if(x.some(H=>H.command!==`-${J}`&&m.conflicts.has(E[H.key]))){B.conflicts.add(J);continue}Q=b(Q,J,x,c)}return{mergeContent:Q,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.$w2b=S;function $(w,I,t){const c=new Set,s=new Set,n=new Set,i=new Set;for(const r of I.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(I.updated.has(r)?i.add(r):s.add(r));for(const r of I.added.values())i.has(r)||t.added.has(r)&&w.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(I.added.has(r)?w.updated.has(r)&&i.add(r):c.add(r));for(const r of I.updated.values())i.has(r)||t.updated.has(r)&&w.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(I.updated.has(r)?w.updated.has(r)&&i.add(r):n.add(r));return{added:c,removed:s,updated:n,conflicts:i}}function C(w,I,t,c){const s=new Set,n=p(w,c),i=p(I,c),r=t?p(t,c):null,l=u(n,i);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const E=r?u(r,n):{added:[...n.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const m=r?u(r,i):{added:[...i.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:a,removed:v,updated:L,conflicts:T}=$(l,E,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:a,removed:v,updated:L,conflicts:T}}function p(w,I){const t=new Map;for(const c of w){const s=I[c.key];let n=t.get(s);n||(n=[],t.set(s,n)),n.push(c)}return t}function g(w){const I=new Map;for(const t of w){const c=t.command[0]==="-"?t.command.substring(1):t.command;let s=I.get(c);s||(s=[],I.set(c,s)),s.push(t)}return I}function u(w,I){const t=[...w.keys()],c=[...I.keys()],s=c.filter(r=>!t.includes(r)).reduce((r,l)=>(r.add(l),r),new Set),n=t.filter(r=>!c.includes(r)).reduce((r,l)=>(r.add(l),r),new Set),i=new Set;for(const r of t){if(n.has(r))continue;const l=w.get(r).map(m=>({...m,key:r})),E=I.get(r).map(m=>({...m,key:r}));(0,j.$sb)(l,E,(m,a)=>f(m,a))||i.add(r)}return{added:s,removed:n,updated:i}}function d(w,I,t){const c=[...w.keys()],s=[...I.keys()],n=s.filter(l=>!c.includes(l)).reduce((l,E)=>(l.add(E),l),new Set),i=c.filter(l=>!s.includes(l)).reduce((l,E)=>(l.add(E),l),new Set),r=new Set;for(const l of c){if(i.has(l))continue;const E=w.get(l).map(a=>({...a,key:t[a.key]})),m=I.get(l).map(a=>({...a,key:t[a.key]}));y(E,m)||r.add(l)}return{added:n,removed:i,updated:r}}function y(w,I){return!(!(0,j.$sb)(w.filter(({command:t})=>t[0]!=="-"),I.filter(({command:t})=>t[0]!=="-"),(t,c)=>f(t,c))||!(0,j.$sb)(w.filter(({command:t})=>t[0]==="-"),I.filter(({command:t})=>t[0]==="-"),(t,c)=>f(t,c)))}function f(w,I){if(w.command!==I.command||w.key!==I.key)return!1;const t=A.$Hi.deserialize(w.when),c=A.$Hi.deserialize(I.when);return!(t&&!c||!t&&c||t&&c&&!t.equals(c)||!D.$Ym(w.args,I.args))}function o(w,I,t){for(const c of I)w=O.edit(w,[-1],c,t);return w}function h(w,I,t){const c=R(w);for(let s=c.length-1;s>=0;s--)(c[s].command===I||c[s].command===`-${I}`)&&(w=O.edit(w,[s],void 0,t));return w}function b(w,I,t,c){const s=R(w),n=s.findIndex(i=>i.command===I||i.command===`-${I}`);for(let i=s.length-1;i>=0;i--)(s[i].command===I||s[i].command===`-${I}`)&&(w=O.edit(w,[i],void 0,c));for(let i=t.length-1;i>=0;i--)w=O.edit(w,[n],t[i],c);return w}}),define(re[234],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E2b=e.$D2b=void 0;function j(A,O,R){const S={},$={},C=new Set;if(!O)return{local:{added:S,updated:$,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const p=N(A,O);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{local:{added:S,updated:$,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=N(R,A),u=N(R,O),d={},y={},f=new Set,o=new Set;for(const h of g.removed.values())u.updated.has(h)?S[h]=O[h]:f.add(h);for(const h of u.removed.values())o.has(h)||(g.updated.has(h)?o.add(h):C.add(h));for(const h of g.updated.values())o.has(h)||(u.updated.has(h)?p.updated.has(h)&&o.add(h):y[h]=A[h]);for(const h of u.updated.values())o.has(h)||(g.updated.has(h)?p.updated.has(h)&&o.add(h):A[h]!==void 0&&($[h]=O[h]));for(const h of g.added.values())o.has(h)||(u.added.has(h)?p.updated.has(h)&&o.add(h):d[h]=A[h]);for(const h of u.added.values())o.has(h)||(g.added.has(h)?p.updated.has(h)&&o.add(h):S[h]=O[h]);return{local:{added:S,removed:[...C.values()],updated:$},remote:{added:d,removed:[...f.values()],updated:y},conflicts:[...o.values()]}}e.$D2b=j;function N(A,O){const R=A?Object.keys(A):[],S=O?Object.keys(O):[],$=S.filter(g=>!R.includes(g)).reduce((g,u)=>(g.add(u),g),new Set),C=R.filter(g=>!S.includes(g)).reduce((g,u)=>(g.add(u),g),new Set),p=new Set;for(const g of R){if(C.has(g))continue;const u=A[g],d=O[g];u!==d&&p.add(g)}return{added:$,removed:C,updated:p}}function D(A,O){const{added:R,removed:S,updated:$}=N(A,O);return R.size===0&&S.size===0&&$.size===0}e.$E2b=D}),define(re[235],oe([0,1,30]),function(te,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k4b=void 0;function N(A,O,R,S){const $={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const g=A.filter(({id:u})=>!S.includes(u));return g.length?C.added=g:C=null,{local:$,remote:C}}const p=D(A,O,S);if(p.added.length>0||p.removed.length>0||p.updated.length>0){const g=D(R,A,S),u=D(R,O,S);for(const d of u.removed){const y=A.find(f=>f.id===d);y&&$.removed.push(y)}for(const d of u.added){const y=O.find(f=>f.id===d);g.added.includes(d)?p.updated.includes(d)&&$.updated.push(y):$.added.push(y)}for(const d of u.updated)$.updated.push(O.find(y=>y.id===d));for(const d of g.added)u.added.includes(d)||C.added.push(A.find(y=>y.id===d));for(const d of g.updated)u.removed.includes(d)||u.updated.includes(d)||C.updated.push(A.find(y=>y.id===d));for(const d of g.removed){const y=O.find(f=>f.id===d);y&&C.removed.push(y)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:$,remote:C}}e.$k4b=N;function D(A,O,R){A=A?A.filter(({id:u})=>!R.includes(u)):[],O=O.filter(({id:u})=>!R.includes(u));const S=A.map(({id:u})=>u),$=O.map(({id:u})=>u),C=$.filter(u=>!S.includes(u)),p=S.filter(u=>!$.includes(u)),g=[];for(const{id:u,name:d,shortName:y,useDefaultFlags:f}of A){if(p.includes(u))continue;const o=O.find(h=>h.id===u);(!o||o.name!==d||o.shortName!==y||!(0,j.$Ym)(o.useDefaultFlags,f))&&g.push(u)}return{added:C,removed:p,updated:g}}}),define(re[25],oe([0,1,18,9,174,49,29,4,103,40]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgb=e.$Ggb=e.$Fgb=e.$Egb=e.$Dgb=e.$Cgb=e.$Bgb=e.$Agb=e.$zgb=e.$ygb=e.$xgb=e.MergeState=e.Change=e.SyncStatus=e.$wgb=e.$vgb=e.$ugb=e.UserDataSyncErrorCode=e.$tgb=e.$sgb=e.$rgb=e.$qgb=e.$pgb=e.$ogb=e.$ngb=e.$mgb=e.$lgb=e.SyncResource=e.$kgb=e.$jgb=e.$igb=e.$hgb=e.$ggb=e.$fgb=void 0;function C(){const i=$.$7m.as(A.$_m.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.$fgb=C;function p(){const i=$.$7m.as(A.$_m.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(m=>!!i[m].ignoreSync),l=Object.keys(i).filter(m=>i[m].scope===2||i[m].scope===6),E=C();return(0,j.$Jb)([...r,...l,...E])}e.$ggb=p,e.$hgb="settingsSync",e.$igb="settingsSync.keybindingsPerPlatform";function g(){const i="vscode://schemas/ignoredSettings",r=$.$7m.as(A.$_m.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.$igb]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:O.$Ln,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=$.$7m.as(S.$8m.JSONContribution),E=()=>{const m=C(),a=p(),v=Object.keys(A.$an.properties).filter(z=>!a.includes(z)),L=a.filter(z=>!m.includes(z)),T={items:{type:"string",enum:[...v,...L.map(z=>`-${z}`)]}};l.registerSchema(i,T)};return r.onDidUpdateConfiguration(()=>E())}e.$jgb=g;function u(i){return i&&(0,N.$kf)(i)&&(0,N.$if)(i.id)&&Array.isArray(i.scopes)}e.$kgb=u;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(d||(e.SyncResource=d={})),e.$lgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(i,...r){return i?[i,...r]:r}e.$mgb=y;function f(i,r,l,E){return E.joinPath(l.userDataSyncHome,...y(i,r,`lastSync${r}.json`))}e.$ngb=f,e.$ogb=(0,R.$Ah)("IUserDataSyncStoreManagementService"),e.$pgb=(0,R.$Ah)("IUserDataSyncStoreService"),e.$qgb=(0,R.$Ah)("IUserDataSyncBackupStoreService"),e.$rgb="x-operation-id",e.$sgb="X-Execution-Id";function o(i){const r={};return r[e.$sgb]=i,r}e.$tgb=o;var h;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(h||(e.UserDataSyncErrorCode=h={}));class b extends Error{constructor(r,l,E,m){super(r),this.code=l,this.resource=E,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$ugb=b;class w extends b{constructor(r,l,E,m,a){super(r,E,void 0,a),this.url=l,this.serverCode=m}}e.$vgb=w;class I extends b{constructor(r,l){super(r,l)}}e.$wgb=I,function(i){function r(l){if(l instanceof i)return l;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(E&&E[1]){const m=E[2]==="unknown"?void 0:E[2],a=E[3]==="unknown"?void 0:E[3];return new i(l.message,E[1],m,a)}return new i(l.message,"Unknown")}i.toUserDataSyncError=r}(b||(e.$ugb=b={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var c;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(c||(e.Change=c={}));var s;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(s||(e.MergeState=s={})),e.$xgb="sync.store.url.type";function n(i){return`sync.enable.${i}`}e.$ygb=n,e.$zgb=(0,R.$Ah)("IUserDataSyncEnablementService"),e.$Agb=(0,R.$Ah)("IUserDataSyncService"),e.$Bgb=(0,R.$Ah)("IUserDataSyncResourceProviderService"),e.$Cgb=(0,R.$Ah)("IUserDataAutoSyncService"),e.$Dgb=(0,R.$Ah)("IUserDataSyncUtilService"),e.$Egb=(0,R.$Ah)("IUserDataSyncLogService"),e.$Fgb="userDataSync",e.$Ggb="vscode-userdata-sync",e.$Hgb="preview"}),define(re[236],oe([0,1,30,25]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UAb=void 0;function D(O,R,S,$,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const p=A(O,R);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=S?A(S,R):{added:Object.keys(R).reduce((h,b)=>(h.add(b),h),new Set),removed:new Set,updated:new Set},u=S?A(S,O):{added:Object.keys(O).reduce((h,b)=>(h.add(b),h),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},y=j.$Um(R),f=!S;for(const h of u.added.values())h!==N.$xgb&&f&&g.added.has(h)||(y[h]=O[h]);for(const h of u.updated.values())y[h]=O[h];for(const h of u.removed.values())$.unregistered.includes(h)||delete y[h];for(const h of g.added.values()){const b=R[h];if($.machine.includes(h)){C.info(`GlobalState: Skipped adding ${h} in local storage because it is declared as machine scoped.`);continue}if(S&&u.added.has(h))continue;const w=O[h];w&&w.value===b.value||h===N.$xgb&&f&&u.added.has(h)||(w?d.updated[h]=b:d.added[h]=b)}for(const h of g.updated.values()){const b=R[h];if($.machine.includes(h)){C.info(`GlobalState: Skipped updating ${h} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(h)||u.removed.has(h))continue;const w=O[h];w&&w.value===b.value||(d.updated[h]=b)}for(const h of g.removed.values()){if($.machine.includes(h)){C.trace(`GlobalState: Skipped removing ${h} in local storage because it is declared as machine scoped.`);continue}u.updated.has(h)||u.removed.has(h)||d.removed.push(h)}const o=A(R,y);return{local:d,remote:{added:[...o.added],updated:[...o.updated],removed:[...o.removed],all:o.added.size===0&&o.removed.size===0&&o.updated.size===0?null:y}}}e.$UAb=D;function A(O,R){const S=Object.keys(O),$=Object.keys(R),C=$.filter(u=>!S.includes(u)).reduce((u,d)=>(u.add(d),u),new Set),p=S.filter(u=>!$.includes(u)).reduce((u,d)=>(u.add(d),u),new Set),g=new Set;for(const u of S){if(p.has(u))continue;const d=O[u],y=R[u];j.$Ym(d,y)||g.add(u)}return{added:C,removed:p,updated:g}}}),define(re[237],oe([0,1,18,34,85,41,30,77,25]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Izb=e.$Hzb=e.$Gzb=e.$Fzb=e.$Ezb=e.$Dzb=void 0;function $(l,E,m){let a=[];m?a=p(m):a=C(E);const v=[],L=[...(0,S.$fgb)()];if(Array.isArray(a))for(const T of a)T.startsWith("-")?L.push(T.substring(1)):v.push(T);return(0,j.$Jb)([...l,...v].filter(T=>!L.includes(T)))}e.$Dzb=$;function C(l){let E=l.inspect("settingsSync.ignoredSettings").userValue;return E!==void 0||(E=l.inspect("sync.ignoredSettings").userValue,E!==void 0)?E:l.getValue("settingsSync.ignoredSettings")||[]}function p(l){const E=(0,N.$Km)(l);return E?E["settingsSync.ignoredSettings"]||E["sync.ignoredSettings"]||[]:[]}function g(l,E){const m=(0,N.$Km)(l)||{};let a="{}";for(const v of Object.keys(m)){const L=(0,D.$tS)(a,[v],m[v],E);a=(0,D.$wS)(a,L)}return a}e.$Ezb=g;function u(l,E,m,a){if(m.length){const v=r(E),L=(0,N.$Km)(E)||{},T=(0,N.$Km)(l);if(!T)return l;const z=[];for(const U of m){const B=L[U],Q=T[U];B===void 0?l=R.edit(l,[U],void 0,a):Q!==void 0?l=R.edit(l,[U],B,a):z.push(t(U,v))}z.sort((U,B)=>U.startOffset-B.startOffset),z.forEach(U=>l=h(U.setting.key,E,l,a))}return l}e.$Fzb=u;function d(l,E,m,a,v,L){const T=u(l,E,a,L),z=m!==T,U=m!==E;if(!z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(U&&!z)return{conflictsSettings:[],localContent:u(E,l,a,L),remoteContent:null,hasConflicts:!1};if(m===null&&f(l)){const P=y(l,E,a)?null:u(E,l,a,L);return{conflictsSettings:[],localContent:P,remoteContent:null,hasConflicts:!1}}let B=l,Q=E;const J=(0,N.$Km)(l),x=(0,N.$Km)(E),H=m?(0,N.$Km)(m):null,X=a.reduce((P,F)=>(P.add(F),P),new Set),G=o(J,x,X),W=o(H,J,X),V=o(H,x,X),ee=new Map,ne=new Set,se=P=>{ne.add(P);const F=v.filter(({key:M})=>M===P)[0];F?(B=R.edit(B,[P],F.value,L),Q=R.edit(Q,[P],F.value,L)):ee.set(P,{key:P,localValue:J[P],remoteValue:x[P]})};for(const P of W.removed.values())V.updated.has(P)?se(P):Q=R.edit(Q,[P],void 0,L);for(const P of V.removed.values())ne.has(P)||(W.updated.has(P)?se(P):B=R.edit(B,[P],void 0,L));for(const P of W.updated.values())ne.has(P)||(V.updated.has(P)?G.updated.has(P)&&se(P):Q=R.edit(Q,[P],J[P],L));for(const P of V.updated.values())ne.has(P)||(W.updated.has(P)?G.updated.has(P)&&se(P):B=R.edit(B,[P],x[P],L));for(const P of W.added.values())ne.has(P)||(V.added.has(P)?G.updated.has(P)&&se(P):Q=h(P,B,Q,L));for(const P of V.added.values())ne.has(P)||(W.added.has(P)?G.updated.has(P)&&se(P):B=h(P,Q,B,L));const Z=ee.size>0||!y(B,Q,a),q=Z||!y(B,l,[]),k=Z||!y(Q,E,[]);return{localContent:q?B:null,remoteContent:k?Q:null,conflictsSettings:[...ee.values()],hasConflicts:Z}}e.$Gzb=d;function y(l,E,m){if(l===E)return!0;const a=(0,N.$Km)(l),v=(0,N.$Km)(E),L=m.reduce((U,B)=>(U.add(B),U),new Set),T=r(l).filter(U=>!(U.setting&&L.has(U.setting.key))),z=r(E).filter(U=>!(U.setting&&L.has(U.setting.key)));if(T.length!==z.length)return!1;for(let U=0;U<T.length;U++){const B=T[U],Q=z[U];if(B.setting&&Q.setting){if(B.setting.key!==Q.setting.key||!O.$Ym(a[B.setting.key],v[B.setting.key]))return!1}else if(!B.setting&&!Q.setting){if(B.value!==Q.value)return!1}else return!1}return!0}function f(l){return l?r(l).length===0:!0}e.$Hzb=f;function o(l,E,m){const a=l?Object.keys(l).filter(U=>!m.has(U)):[],v=Object.keys(E).filter(U=>!m.has(U)),L=v.filter(U=>!a.includes(U)).reduce((U,B)=>(U.add(B),U),new Set),T=a.filter(U=>!v.includes(U)).reduce((U,B)=>(U.add(B),U),new Set),z=new Set;if(l)for(const U of a){if(T.has(U))continue;const B=l[U],Q=E[U];O.$Ym(B,Q)||z.add(U)}return{added:L,removed:T,updated:z}}function h(l,E,m,a){const v=(0,N.$Km)(E),L=r(E),T=r(m),z=b(l,L,T);return w(m,l,v[l],z,T,a)}e.$Izb=h;function b(l,E,m){const a=E.findIndex(L=>L.setting?.key===l),v=E[a-1];if(v){if(v.setting){const T=t(v.setting.key,m);if(T)return{index:m.indexOf(T),insertAfter:!0}}else{const T=c(a,E);if(T){const z=t(T.setting.key,m);if(z){const U=s(m.indexOf(z),m),B=n(E,T,E[a]);if(U){const Q=n(m,z,U),J=i(B,Q);return J?{index:m.indexOf(J),insertAfter:!0}:{index:m.indexOf(U),insertAfter:!1}}else{const Q=n(m,z,m[m.length-1]),J=i(B,Q);return J?{index:m.indexOf(J),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const L=E[a+1];if(L)if(L.setting){const T=t(L.setting.key,m);if(T)return{index:m.indexOf(T),insertAfter:!1}}else{const T=s(a,E);if(T){const z=t(T.setting.key,m);if(z){const U=c(m.indexOf(z),m),B=n(E,E[a],T);if(U){const Q=n(m,U,z),J=i(B.reverse(),Q.reverse());return J?{index:m.indexOf(J),insertAfter:!1}:{index:m.indexOf(U),insertAfter:!0}}else{const Q=n(m,m[0],z),J=i(B.reverse(),Q.reverse());return J?{index:m.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function w(l,E,m,a,v,L){let T;return a.index===-1?T=(0,D.$tS)(l,[E],m,L):T=I(l,E,m,a,v,L).map(z=>(0,D.$uS)(l,z,L)[0]),(0,D.$wS)(l,T)}function I(l,E,m,a,v,L){const T=`${JSON.stringify(E)}: ${JSON.stringify(m)}`,z=(0,A.$qS)(L,l),U=v[a.index];if(a.insertAfter){const B=[];if(U.setting)B.push({offset:U.endOffset,length:0,content:","+T});else{const Q=s(a.index,v),J=c(a.index,v),x=J?.setting?.commaOffset;J&&x===void 0&&B.push({offset:J.endOffset,length:0,content:","});const H=x!==void 0&&x>U.endOffset;B.push({offset:H?x+1:U.endOffset,length:0,content:Q?z+T+",":z+T})}return B}else{if(U.setting)return[{offset:U.startOffset,length:0,content:T+","}];const B=(v[a.index-1]&&!v[a.index-1].setting?z:"")+T+(s(a.index,v)?",":"")+z;return[{offset:U.startOffset,length:0,content:B}]}}function t(l,E){return E.filter(m=>m.setting?.key===l)[0]}function c(l,E){for(let m=l-1;m>=0;m--)if(E[m].setting)return E[m]}function s(l,E){for(let m=l+1;m<E.length;m++)if(E[m].setting)return E[m]}function n(l,E,m){const a=l.indexOf(E),v=l.indexOf(m);return l.filter((L,T)=>a<T&&T<v)}function i(l,E){if(l.length&&E.length){let m=0;for(;m<E.length&&m<l.length;m++)if(l[m].value!==E[m].value)return E[m-1];return E[m-1]}}function r(l){const E=[];let m=-1,a,v;const L={onObjectBegin:T=>{m++},onObjectProperty:(T,z,U)=>{m===0&&(a=z,v=T)},onObjectEnd:(T,z)=>{m--,m===0&&E.push({startOffset:a,endOffset:T+z,value:l.substring(a,T+z),setting:{key:v,commaOffset:void 0}})},onArrayBegin:(T,z)=>{m++},onArrayEnd:(T,z)=>{m--,m===0&&E.push({startOffset:a,endOffset:T+z,value:l.substring(a,T+z),setting:{key:v,commaOffset:void 0}})},onLiteralValue:(T,z,U)=>{m===0&&E.push({startOffset:a,endOffset:z+U,value:l.substring(a,z+U),setting:{key:v,commaOffset:void 0}})},onSeparator:(T,z,U)=>{if(m===0&&T===","){let B=E.length-1;for(;B>=0&&!E[B].setting;B--);const Q=E[B];Q&&E.splice(B,1,{startOffset:Q.startOffset,endOffset:Q.endOffset,value:Q.value,setting:{key:Q.setting.key,commaOffset:z}})}},onComment:(T,z)=>{m===0&&E.push({startOffset:T,endOffset:T+z,value:l.substring(T,T+z)})}};return(0,N.$Rm)(l,L),E}}),define(re[78],oe([0,1,3,2,4,25]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ozb=e.$nzb=void 0,e.$nzb=(0,D.$Ah)("IUserDataSyncAccountService");let O=class extends N.$jc{get account(){return this.a}constructor(S,$){super(),this.g=S,this.h=$,this.b=this.B(new j.$ed),this.onDidChangeAccount=this.b.event,this.c=this.B(new j.$ed),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$ozb=O,e.$ozb=O=ye([Y(0,A.$pgb),Y(1,A.$Egb)],O)}),define(re[238],oe([0,1,2,11]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=e.$B7b=e.$A7b=e.$z7b=e.$y7b=e.$x7b=e.$w7b=void 0;class D{constructor(g){this.a=g}listen(g,u){switch(u){case"onError":return this.a.onError}throw new Error(`Event not found: ${u}`)}call(g,u,d){switch(u){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.$w7b=D;class A{constructor(g){this.a=g}listen(g,u){throw new Error(`Event not found: ${u}`)}call(g,u,d){switch(u){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(d[0]))}throw new Error("Invalid call")}}e.$x7b=A;class O{constructor(g){this.a=g}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.a.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.a.call("resolveFormattingOptions",[g])}}e.$y7b=O;class R{constructor(g){this.a=g}listen(g,u){switch(u){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${u}`)}async call(g,u,d){switch(u){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.$z7b=R;class S{constructor(g){this.a=g}listen(g,u){switch(u){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${u}`)}call(g,u,d){switch(u){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.$A7b=S;class ${constructor(g){this.a=g}listen(g,u){switch(u){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${u}`)}call(g,u,d){switch(u){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$B7b=$;class C extends j.$jc{constructor(g){super(),this.a=g,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.a.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.a.call("getPreviousUserDataSyncStore");return this.b(g)}b(g){return{url:N.URI.revive(g.url),type:g.type,defaultUrl:N.URI.revive(g.defaultUrl),insidersUrl:N.URI.revive(g.insidersUrl),stableUrl:N.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.$C7b=C}),define(re[239],oe([0,1,175,7,25]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ABb=void 0;let A=class extends N.$9i{constructor(R){super(),this.g=this.B(R.createLogger(D.$Fgb,{name:(0,j.localize)(0,null)}))}trace(R,...S){this.g.trace(R,...S)}debug(R,...S){this.g.debug(R,...S)}info(R,...S){this.g.info(R,...S)}warn(R,...S){this.g.warn(R,...S)}error(R,...S){this.g.error(R,...S)}flush(){this.g.flush()}};e.$ABb=A,e.$ABb=A=ye([Y(0,N.$5i)],A)}),define(re[112],oe([0,1,7,4,24]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=e.$37b=void 0,e.$37b=(0,N.$Ah)("voiceRecognitionService");let A=class{constructor(R,S){this.a=R,this.b=S}async transcribe(R,S){this.a.info(`[voice] transcribe(${R.length}): Begin`);const $=process.env.VSCODE_VOICE_MODULE_PATH;if(!$||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${R.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const C=Date.now();this.a.info(`[voice] transcribe(${R.length}): Getting module from ${$}`);try{const p=te.__$__nodeRequire($),g=new AbortController;S.onCancellationRequested(()=>g.abort());const u=await p.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:R},{language:"en",suppressNonSpeechTokens:!0,signal:g.signal});return this.a.info(`[voice] transcribe(${R.length}): End (text: "${u}", took: ${Date.now()-C}ms)`),u}catch(p){throw this.a.error(`[voice] transcribe(${R.length}): Failed (error: "${p}", took: ${Date.now()-C}ms)`),p}}};e.$47b=A,e.$47b=A=ye([Y(0,j.$4i),Y(1,D.$jj)],A)}),define(re[240],oe([0,1,2,112,7,26,5]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=void 0;let R=class extends j.$jc{constructor(C,p,g){super(),this.a=C,this.b=p,this.c=g,this.f()}f(){this.B(this.a(C=>{this.B(new S(C,this.b,this.c))}))}};e.$57b=R,e.$57b=R=ye([Y(1,N.$37b),Y(2,D.$4i)],R);class S extends j.$jc{static{this.a=30*16e3*16*1/8}constructor(C,p,g){super(),this.f=C,this.g=p,this.h=g,this.b=new O.$Ng,this.c=void 0,this.j()}j(){this.h.info("[voice] transcriber: new connection");const C=new A.$od;this.B((0,j.$hc)(()=>C.dispose(!0)));const p=g=>this.m(g,C.token);this.f.on("message",p),this.B((0,j.$hc)(()=>this.f.off("message",p))),this.f.start(),this.B((0,j.$hc)(()=>this.f.close())),this.f.on("close",()=>{this.h.info("[voice] transcriber: closed connection"),C.dispose(!0)})}async m(C,p){if(!Array.isArray(C.data))return;const g=[];for(const d of C.data)d instanceof Float32Array&&g.push(d);const u=this.r(this.c?[this.c,...g]:g);if(u.length>S.a){this.h.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.c=u,this.b.queue(()=>this.n(p))}async n(C){if(C.isCancellationRequested)return;const p=this.c?.slice(0);if(!p)return;const g=await this.g.transcribe(p,C);C.isCancellationRequested||this.f.postMessage(g)}r(C){const p=new Float32Array(C.reduce((u,d)=>u+d.length,0));let g=0;for(const u of C)p.set(u,g),g+=u.length;return p}}}),define(re[241],oe([0,1,5,3,2]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;class A extends D.$jc{constructor({onDidOpenWindow:R,onDidFocusWindow:S,getActiveWindowId:$}){super(),this.a=this.B(new D.$ic),N.Event.latch(N.Event.any(R,S))(this.f,this,this.a),this.b=(0,j.$tg)(()=>$()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$A6b=A}),define(re[113],oe([0,1,178,15,47,22,11,4,23]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,R.$Ah)("contextService");function $(n){const i=n;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}e.$Kh=$;function C(n){return typeof n?.id=="string"&&!$(n)&&!g(n)}e.$Lh=C,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function p(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,N.$_d)(n)}:i?e.$Mh:e.$Nh;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Oh=p;function g(n){const i=n;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}e.$Ph=g;function u(n){const i=n;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$Qh=u;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function y(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$Rh=y;function f(n){const i=n;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$Sh=f;class o{constructor(i,r,l,E,m){this.h=i,this.j=l,this.k=E,this.l=m,this.c=D.$Gh.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=D.$Gh.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=o;class h{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.$hg)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=h;function b(n){return new h({uri:n,index:0,name:(0,A.$dg)(n)},{uri:n.toString()})}e.$Vh=b,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,j.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function w(n,i){return A.$$f.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$1h=w;function I(n){let i;return O.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===S.Schemas.tmp}e.$2h=I,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$3h}e.$4h=t;function c(n,i){return!w(n,i)&&!I(n)}e.$5h=c;function s(n){return(typeof n=="string"?(0,N.$ae)(n):(0,A.$fg)(n))===e.$Xh}e.$6h=s}),define(re[17],oe([0,1,51,3,2,22,11,169,16,13,4,7,113,35,27,5,32,28,9]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.ProfileResourceType=void 0;var b;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(b||(e.ProfileResourceType=b={}));function w(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.$Ck=w,e.$Dk=(0,C.$Ah)("IUserDataProfilesService");function I(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:O.URI.revive(n.location).with({scheme:i}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:O.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Ek=I;function t(n,i,r,l,E,m){return{id:n,name:i,location:r,isDefault:!1,shortName:E?.shortName,globalStorageHome:m&&E?.useDefaultFlags?.globalState?m.globalStorageHome:(0,A.$hg)(r,"globalStorage"),settingsResource:m&&E?.useDefaultFlags?.settings?m.settingsResource:(0,A.$hg)(r,"settings.json"),keybindingsResource:m&&E?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,A.$hg)(r,"keybindings.json"),tasksResource:m&&E?.useDefaultFlags?.tasks?m.tasksResource:(0,A.$hg)(r,"tasks.json"),snippetsHome:m&&E?.useDefaultFlags?.snippets?m.snippetsHome:(0,A.$hg)(r,"snippets"),extensionsResource:m&&E?.useDefaultFlags?.extensions?m.extensionsResource:(0,A.$hg)(r,"extensions.json"),cacheHome:(0,A.$hg)(l,n),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}e.$Fk=t;let c=class extends D.$jc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,r,l,E){super(),this.t=i,this.u=r,this.w=l,this.y=E,this.f=!0,this.h=this.B(new N.$ed),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$ed),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$ed),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$ed),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new u.$yi,emptyWindows:new Map},this.profilesHome=(0,A.$hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),r=[i];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,h.$if)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}r.push(t((0,A.$eg)(m.location),m.name,m.location,this.g,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags},i))}}catch(m){this.y.error(m)}const l=new u.$yi,E=new Map;if(r.length)try{const m=this.Q();if(m.workspaces)for(const[a,v]of Object.entries(m.workspaces)){const L=O.URI.parse(a),T=r.find(z=>z.id===v);T&&l.set(L,T)}if(m.emptyWindows)for(const[a,v]of Object.entries(m.emptyWindows)){const L=r.find(T=>T.id===v);L&&E.set(a,L)}}catch(m){this.y.error(m)}this.z={profiles:r,workspaces:l,emptyWindows:E}}return this.z}D(){const i=t("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",l=new RegExp(`${(0,o.$pe)(r)}\\s(\\d+)`);let E=0;for(const a of this.profiles){const v=l.exec(a.name),L=v?parseInt(v[1]):0;E=L>E?L:E}const m=`${r} ${E+1}`;return this.createProfile((0,j.$oi)((0,f.$3f)()).toString(16),m,{transient:!0},i)}async createNamedProfile(i,r,l){return this.createProfile((0,j.$oi)((0,f.$3f)()).toString(16),i,r,l)}async createProfile(i,r,l,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(i,r,l);return E&&await this.setProfileForWorkspace(E,m),m}async F(i,r,l){if(!(0,h.$if)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(r);return E||(E=(async()=>{try{const m=this.profiles.find(L=>L.name===r||L.id===i);if(m)return m;const a=t(i,r,(0,A.$hg)(this.profilesHome,i),this.g,l,this.defaultProfile);await this.u.createFolder(a.location);const v=[];return this.j.fire({profile:a,join(L){v.push(L)}}),await y.Promises.settled(v),this.I([a],[],[]),a}finally{this.r.delete(r)}})(),this.r.set(r,E)),E}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(E=>E.id===i.id);if(!l)throw new Error(`Profile '${i.name}' does not exist`);return l=t(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const l=[];this.m.fire({profile:r,join(E){l.push(E)}});try{await Promise.allSettled(l)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(E){(0,$.$ik)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(E=>E.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(i,l)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.G(i);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(i){return(0,g.$Kh)(i)?i.uri:(0,g.$Ph)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,i.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,i.location)))}I(i,r,l){const E=[...this.profiles,...i],m=[];this.s.profiles=[];for(let a of E)a.isDefault||r.some(v=>a.id===v.id)||(a=l.find(v=>a.id===v.id)??a,a.isTransient?this.s.profiles.push(a):m.push({location:a.location,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags}));this.P(m),this.z=void 0,this.J(i,r,l)}J(i,r,l){this.h.fire({added:i,removed:r,updated:l,all:this.profiles})}L(i,r,l){l=r?.isTransient?!0:l,l||this.L(i,void 0,!0);const E=this.G(i),m=l?this.s:this.C;O.URI.isUri(E)?(m.workspaces.delete(E),r&&m.workspaces.set(E,r)):(m.emptyWindows.delete(E),r&&m.emptyWindows.set(E,r)),l||this.M()}M(){const i={};for(const[l,E]of this.C.workspaces.entries())i[l.toString()]=E.id;const r={};for(const[l,E]of this.C.emptyWindows.entries())r[l.toString()]=E.id;this.R({workspaces:i,emptyWindows:r}),this.z=void 0}N(i){const r={},l=this.D();if(i.workspaces)for(const[m,a]of Object.entries(i.workspaces)){const v=O.URI.parse(a);r[m]=this.w.extUri.isEqual(v,l.location)?l.id:this.w.extUri.basename(v)}const E={};if(i.emptyWindows)for(const[m,a]of Object.entries(i.emptyWindows)){const v=O.URI.parse(a);E[m]=this.w.extUri.isEqual(v,l.location)?l.id:this.w.extUri.basename(v)}return{workspaces:r,emptyWindows:E}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Gk=c,e.$Gk=c=ye([Y(0,S.$Hh),Y(1,$.$5j),Y(2,d.$Bk),Y(3,p.$4i)],c);class s extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Hk=s}),define(re[242],oe([0,1,5,2,17]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=void 0;let A=class extends N.$jc{constructor(R){super(),this.B(new j.$Rg(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$K7b=A,e.$K7b=A=ye([Y(0,D.$Dk)],A)}),define(re[243],oe([0,1,18,5,26,8,3,2,6,9,11,152,29,33,45,7,24,21,27,17]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=void 0;let w=class extends R.$jc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,r,l,E,m,a){super(),this.z=i,this.C=r,this.D=l,this.F=E,this.G=m,this.H=a,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$ed),this.s=this.B(new O.$ed),this.t=this.B(new O.$ed),this.u=this.B(new O.$ed),this.w=this.B(new O.$ed),this.y=[],this.B((0,R.$hc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(l=>(0,g.$Vn)(l,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const E=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:m})=>(0,u.$oo)(m,i.identifier));if(E?.local)return E?.local;throw E?.error?E.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(l){throw t(l)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new g.$Zn(p.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(i.map(async({extension:E,options:m})=>{try{const a=await this.O(E,!!m?.installGivenVersion,!!m?.installPreReleaseVersion);l.push({...a,options:m})}catch(a){r.push({identifier:E.identifier,operation:2,source:E,error:a})}})),l.length&&r.push(...await this.I(l));for(const E of r)E.error&&(this.F.error("Failed to install extension.",E.identifier.id),this.F.error(E.error),E.source&&!C.URI.isUri(E.source)&&c(this.C,"extensionGallery:install",{extensionData:(0,u.$wo)(E.source),error:E.error}));return r}async uninstall(i,r={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.Q(i,r)}async toggleAppliationScope(i,r){if((0,d.$Xl)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let l=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(i,this.H.defaultProfile.extensionsResource,r));for(const E of this.H.profiles){const m=(await this.getInstalled(1,E.extensionsResource)).find(a=>(0,u.$oo)(a.identifier,i.identifier));m?this.w.fire(m):this.u.fire({identifier:i.identifier,profileLocation:E.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(i,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.X(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const r=[];return await Promise.allSettled(i.map(async l=>{try{const E=await this.J(l);r.push(...E)}catch(E){r.push({identifier:{id:(0,u.$to)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:E})}})),this.s.fire(r),r}async J({manifest:i,extension:r,options:l}){const E=l.isApplicationScoped||l.isBuiltin||(0,d.$Xl)(i),m={...l,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:E,profileLocation:E?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},a=B=>`${u.$po.create(B).toString()}${m.profileLocation?`-${m.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const B=this.j.get(a(r));if(B)return this.F.info("Extensions is already requested to install",r.identifier.id),await B.task.waitUntilTaskIsFinished(),[]}const v=[],L=[],T=[],z=this.Z(i,r,m);C.URI.isUri(r)||this.j.set(a(r),{task:z,waitingTasks:[]}),this.n.fire({identifier:z.identifier,source:r,profileLocation:m.profileLocation}),this.F.info("Installing extension:",z.identifier.id),v.push({task:z,manifest:i});let U=!1;try{if(m.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const Q=await this.N(z.identifier,i,!!m.installOnlyNewlyAddedFromExtensionPack,!!m.installPreReleaseVersion,m.profileLocation),J=await this.getInstalled(void 0,m.profileLocation),x={...m,donotIncludePackAndDependencies:!0,context:{...m.context,[g.$Qn]:!0}};for(const{gallery:H,manifest:X}of(0,j.$Jb)(Q,({gallery:G})=>G.identifier.id)){U=U||!!X.extensionDependencies?.some(V=>(0,u.$oo)({id:V},z.identifier));const G=a(H),W=this.j.get(G);if(W){if(this.L(z,W.task)){const V=W.task.identifier;this.F.info("Waiting for already requested installing extension",V.id,z.identifier.id),W.waitingTasks.push(z),L.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ne=>(0,u.$oo)(ne.identifier,V)))).then(ee=>{if(this.F.info("Finished waiting for already requested installing extension",V.id,z.identifier.id),!ee.find(se=>(0,u.$oo)(se.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!J.some(({identifier:V})=>(0,u.$oo)(V,H.identifier))){const V=this.Z(X,H,x);this.j.set(G,{task:V,waitingTasks:[z]}),this.n.fire({identifier:V.identifier,source:H,profileLocation:m.profileLocation}),this.F.info("Installing extension:",V.identifier.id,z.identifier.id),v.push({task:V,manifest:X})}}}catch(Q){if(C.URI.isUri(z.source))(0,j.$Ib)(i.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",z.identifier.id,Q.message),(0,j.$Ib)(i.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",z.identifier.id,Q.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),Q}const B=v.reduce((Q,{task:J,manifest:x})=>(Q.set(J.identifier.id.toLowerCase(),{task:J,manifest:x}),Q),new Map);for(;B.size;){let Q;const J=[...B.values()].filter(({manifest:x})=>!x.extensionDependencies?.some(H=>B.has(H.toLowerCase())));J.length?Q=B.size===1?J:J.filter(({task:x})=>!(x===z&&!U)):(this.F.info("Found extensions with circular dependencies",J.map(({task:x})=>x.identifier.id)),Q=[...B.values()]),await this.M(Q.map(async({task:x})=>{const H=new Date().getTime();try{const X=await x.run();if(await this.M(this.y.map(G=>G.postInstall(X,x.source,m,D.CancellationToken.None))),!C.URI.isUri(x.source)){const G=x.operation===3,W=G?void 0:(new Date().getTime()-x.source.lastUpdated)/1e3;if(c(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$wo)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:W}),S.$o&&x.operation!==3)try{await this.z.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}T.push({local:X,identifier:x.identifier,operation:x.operation,source:x.source,context:x.options.context,profileLocation:x.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw C.URI.isUri(x.source)||c(this.C,x.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$wo)(x.source),verificationStatus:x.verificationStatus,duration:new Date().getTime()-H,error:X}),this.F.error("Error while installing the extension:",x.identifier.id),X}finally{B.delete(x.identifier.id.toLowerCase())}}))}return L.length&&await this.M(L),T.forEach(({identifier:Q})=>this.F.info("Extension installed successfully:",Q.id)),T}catch(B){if(v.forEach(({task:Q})=>Q.cancel()),T.length)try{const Q=await Promise.allSettled(T.map(({local:J})=>this.$(J,{versionOnly:!0,profileLocation:m.profileLocation}).run()));for(let J=0;J<Q.length;J++){const x=Q[J],{identifier:H}=T[J];x.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",H.id):this.F.warn("Rollback: Error while uninstalling extension",H.id,(0,A.$8)(x.reason))}}catch(Q){this.F.warn("Error while rolling back extensions",(0,A.$8)(Q),T.map(({identifier:J})=>J.id))}return v.map(({task:Q})=>({identifier:Q.identifier,operation:2,source:Q.source,context:m.context,profileLocation:m.profileLocation,error:B}))}finally{for(const{task:B}of v)B.source&&!C.URI.isUri(B.source)&&this.j.delete(a(B.source))}}L(i,r){for(const[,{task:l,waitingTasks:E}]of this.j.entries())if(l===i&&(E.includes(r)||E.some(m=>this.L(m,r)))||l===r&&E[0]&&!this.L(i,E[0]))return!1;return!0}async M(i){const r=[],l=[],E=await Promise.allSettled(i);for(const m of E)m.status==="fulfilled"?r.push(m.value):l.push(m.reason);if(l.length)throw I(l);return r}async N(i,r,l,E,m){if(!this.z.isEnabled())return[];const a=await this.getInstalled(void 0,m),v=[],L=[],T=async(z,U)=>{v.push(z);const B=U.extensionDependencies||[],Q=[...B];if(U.extensionPack){const J=l?a.find(x=>(0,u.$oo)(x.identifier,z)):void 0;for(const x of U.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(H=>(0,u.$oo)({id:H},{id:x}))||Q.every(H=>!(0,u.$oo)({id:H},{id:x}))&&Q.push(x)}if(Q.length){const J=Q.filter(x=>v.every(H=>!(0,u.$oo)(H,{id:x})));if(J.length){const x=await this.z.getExtensions(J.map(H=>({id:H,preRelease:E})),D.CancellationToken.None);for(const H of x){if(v.find(W=>(0,u.$oo)(W,H.identifier)))continue;const X=B.some(W=>(0,u.$oo)({id:W},H.identifier));let G;try{G=await this.O(H,!1,E)}catch(W){if(X)throw W;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,A.$8)(W));continue}L.push({gallery:G.extension,manifest:G.manifest}),await T(G.extension.identifier,G.manifest)}}}};return await T(i,r),L}async O(i,r,l){let E;const m=await this.getExtensionsControlManifest();if(m.malicious.some(L=>(0,u.$oo)(i.identifier,L)))throw new g.$Zn(p.localize(1,null,i.identifier.id),g.ExtensionManagementErrorCode.Malicious);const a=m.deprecated[i.identifier.id.toLowerCase()];if(a?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${a.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:a.extension.id,preRelease:a.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!E)throw new g.$Zn(p.localize(2,null,i.identifier.id,a.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const L=await this.getTargetPlatform();throw new g.$Zn(p.localize(3,null,i.identifier.id,this.G.nameLong,(0,g.$Rn)(L)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.P(i,r,l),!E)throw!l&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],D.CancellationToken.None))[0]?new g.$Zn(p.localize(4,null,i.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$Zn(p.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const v=await this.z.getManifest(E,D.CancellationToken.None);if(v===null)throw new g.$Zn(`Missing manifest for extension ${E.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(v.version!==E.version)throw new g.$Zn(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:v}}async P(i,r,l){const E=await this.getTargetPlatform();let m=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==l&&(m=(await this.z.getExtensions([{...i.identifier,preRelease:l}],{targetPlatform:E,compatible:!0},D.CancellationToken.None))[0]||null),!m&&await this.z.isExtensionCompatible(i,l,E)&&(m=i),m||(r?m=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:E,compatible:!0},D.CancellationToken.None))[0]||null:m=await this.z.getCompatibleExtension(i,l,E)),m}async Q(i,r){const l={...r,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},E=z=>`${z.id.toLowerCase()}${l.versionOnly?`-${i.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,m=this.m.get(E(i.identifier));if(m)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),m.waitUntilTaskIsFinished();const a=z=>{const U=this.$(z,l);return this.m.set(E(U.extension.identifier),U),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${z.identifier.id}@${z.manifest.version}`),this.t.fire({identifier:z.identifier,profileLocation:l.profileLocation,applicationScoped:z.isApplicationScoped}),U},v=(z,U)=>{U?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,l.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${z.identifier.id}@${z.manifest.version}`,U.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${z.identifier.id}@${z.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${z.identifier.id}@${z.manifest.version}`),c(this.C,"extensionGallery:uninstall",{extensionData:(0,u.$vo)(z),error:U}),this.u.fire({identifier:z.identifier,error:U?.code,profileLocation:l.profileLocation,applicationScoped:z.isApplicationScoped})},L=[],T=[];try{L.push(a(i));const z=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const U=this.U(i,z);for(const B of U)this.m.has(E(B.identifier))?this.F.info("Extensions is already requested to uninstall",B.identifier.id):L.push(a(B))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.R(L.map(U=>U.extension),z,i),await this.M(L.map(async U=>{try{if(await U.run(),await this.M(this.y.map(B=>B.postUninstall(U.extension,l,D.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}v(U.extension)}catch(B){const Q=B instanceof g.$Zn?B:new g.$Zn((0,A.$8)(B),g.ExtensionManagementErrorCode.Internal);throw v(U.extension,Q),Q}finally{T.push(U)}}))}catch(z){const U=z instanceof g.$Zn?z:new g.$Zn((0,A.$8)(z),g.ExtensionManagementErrorCode.Internal);for(const B of L){try{B.cancel()}catch{}T.includes(B)||v(B.extension,U)}throw U}finally{for(const z of L)this.m.delete(E(z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",z.extension.identifier.id)}}R(i,r,l){for(const E of i){const m=this.W(E,r);if(m.length){const a=m.filter(v=>!i.some(L=>(0,u.$oo)(L.identifier,v.identifier)));if(a.length)throw new Error(this.S(E,a,l))}}}S(i,r,l){return l===i?r.length===1?p.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?p.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):p.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?p.localize(9,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?p.localize(10,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):p.localize(11,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(i,r,l=[]){if(l.indexOf(i)!==-1)return[];l.push(i);const E=i.manifest.extensionPack?i.manifest.extensionPack:[];if(E.length){const m=r.filter(v=>!v.isBuiltin&&E.some(L=>(0,u.$oo)({id:L},v.identifier))),a=[];for(const v of m)a.push(...this.U(v,r,l));return[...m,...a]}return[]}W(i,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(E=>(0,u.$oo)({id:E},i.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const i=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$dp=w,e.$dp=w=ye([Y(0,g.$Yn),Y(1,o.$8k),Y(2,h.$Bk),Y(3,y.$4i),Y(4,f.$jj),Y(5,b.$Dk)],w);function I(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$ep=I;function t(n){if(n instanceof g.$Zn)return n;const i=new g.$Zn(n.message,g.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.$fp=t;function c(n,i,{extensionData:r,verificationStatus:l,duration:E,error:m,durationSinceUpdate:a}){let v,L;(0,$.$qf)(l)&&(l===!0?l="Verified":(l===!1||(v=g.ExtensionManagementErrorCode.Signature,L=l),l="Unverified")),m&&(m instanceof g.$Zn?(v=m.code,m.code===g.ExtensionManagementErrorCode.Signature&&(L=m.message)):v=g.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:l,success:!m,duration:E,errorcode:v,errorcodeDetail:L,durationSinceUpdate:a})}class s{constructor(){this.d=new N.$Eg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$tg)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$tg)(i=>new Promise((r,l)=>{const E=i.onCancellationRequested(()=>{E.dispose(),l(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$gp=s}),define(re[50],oe([0,1,5,14,2,3,35,11,29,33,13,4,7,17,27,9,8,21]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class b extends Error{constructor(s,n){super(s),this.code=n}}e.$hp=b,e.$ip=(0,p.$Ah)("IExtensionsProfileScannerService");let w=class extends D.$jc{constructor(s,n,i,r,l,E){super(),this.j=s,this.m=n,this.n=i,this.r=r,this.s=l,this.t=E,this.b=this.B(new A.$ed),this.onAddExtensions=this.b.event,this.c=this.B(new A.$ed),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$ed),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$ed),this.onDidRemoveExtensions=this.g.event,this.h=new O.$yi}scanProfileExtensions(s,n){return this.u(s,void 0,n)}async addExtensionsToProfile(s,n){const i=[],r=[];try{return await this.u(n,l=>{const E=[];for(const m of l)s.some(([a])=>(0,$.$oo)(a.identifier,m.identifier)&&a.manifest.version!==m.version)?i.push(m):E.push(m);for(const[m,a]of s){const v=E.findIndex(T=>(0,$.$oo)(T.identifier,m.identifier)&&T.version===m.manifest.version),L={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:a};v===-1?(r.push(L),E.push(L)):E.splice(v,1,L)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),E}),r.length&&this.c.fire({extensions:r,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:l,profileLocation:n}),l}}async updateMetadata(s,n){const i=[];return await this.u(n,r=>{const l=[];for(const E of r){const m=s.find(([a])=>(0,$.$oo)(a.identifier,E.identifier)&&a.manifest.version===E.version);m&&(E.metadata={...E.metadata,...m[1]},i.push(E)),l.push(E)}return l}),i}async removeExtensionFromProfile(s,n){const i=[];try{await this.u(n,r=>{const l=[];for(const E of r)(0,$.$oo)(E.identifier,s.identifier)?i.push(E):l.push(E);return i.length&&this.f.fire({extensions:i,profileLocation:n}),l}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:n}),r}}async u(s,n,i){return this.F(s).queue(async()=>{let r=[],l;try{const E=await this.m.readFile(s);l=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,C.$ik)(E)!==1)throw E;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&i?.bailOutWhenFileNotFound)throw new b((0,f.$8)(E),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(s);let E=!1;for(const m of l){I(m)||this.w(s);let a;if((0,y.$if)(m.relativeLocation)&&m.relativeLocation)a=this.z(m.relativeLocation);else if((0,y.$if)(m.location))a=this.z(m.location),E=!0,m.relativeLocation=m.location,m.location=a.toJSON();else{a=R.URI.revive(m.location);const v=this.y(a);v&&(E=!0,m.relativeLocation=v)}r.push({identifier:m.identifier,location:a,version:m.version,metadata:m.metadata})}E&&await this.m.writeFile(s,N.$Ed.fromString(JSON.stringify(l)))}if(n){r=n(r);const E=r.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.y(m.location),metadata:m.metadata}));await this.m.writeFile(s,N.$Ed.fromString(JSON.stringify(E)))}return r})}w(s){const n=new b(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(s)).value.toString()}catch(l){if((0,C.$ik)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const l=JSON.parse(i);Array.isArray(l)&&l.every(E=>I(E))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Ed.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,C.$ik)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(s)}catch(l){(0,C.$ik)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,C.$ik)(l)!==1&&this.t.error(l)}return r})()),this.C}F(s){let n=this.h.get(s);return n||(n=new j.$Mg,this.h.set(s,n)),n}};e.$jp=w,e.$jp=w=ye([Y(1,C.$5j),Y(2,u.$Dk),Y(3,d.$Bk),Y(4,o.$8k),Y(5,g.$4i)],w);function I(c){return(0,y.$kf)(c)&&(0,S.$Xn)(c.identifier)&&(t(c.location)||(0,y.$if)(c.location)&&c.location)&&((0,y.$pf)(c.relativeLocation)||(0,y.$if)(c.relativeLocation))&&c.version&&(0,y.$if)(c.version)}function t(c){return c?(0,y.$if)(c.path)&&(0,y.$if)(c.scheme):!1}}),define(re[79],oe([0,1,18,5,30,14,8,34,139,2,23,15,6,22,53,89,9,11,155,16,33,45,67,13,4,7,24,3,63,50,17,27,183]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I,t,c,s,n,i,r,l,E,m,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.Translations=void 0;var L;(function(x){function H(X,G){if(X===G)return!0;const W=Object.keys(X),V=new Set;for(const ee of Object.keys(G))V.add(ee);if(W.length!==V.size)return!1;for(const ee of W){if(X[ee]!==G[ee])return!1;V.delete(ee)}return V.size===0}x.equals=H})(L||(e.Translations=L={})),e.$mp=(0,s.$Ah)("IExtensionsScannerService");let T=class extends $.$jc{constructor(H,X,G,W,V,ee,ne,se,Z,q,k,P){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=X,this.r=G,this.s=W,this.t=V,this.u=ee,this.w=ne,this.y=se,this.z=Z,this.C=q,this.D=k,this.F=P,this.g=this.B(new r.$ed),this.onDidChangeCache=this.g.event,this.h=(0,u.$hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,w.$zo)(this.w,this.y)),this.G}async scanAllExtensions(H,X,G){const[W,V]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(X)]),ee=G?await this.scanExtensionsUnderDevelopment(H,[...W,...V]):[];return this.L(W,V,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const X=[];X.push(this.M(!!H.useCache,H.language)),X.push(this.N(H.language,!!H.checkControlFile));const[G,W]=await Promise.all(X);return this.J([...G,...W],0,H,!1)}async scanUserExtensions(H){const X=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const G=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(X,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,G),V=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ee;try{ee=await V.scanExtensions(W)}catch(ne){if(ne instanceof E.$hp&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ee=await V.scanExtensions(W);else throw ne}return ee=await this.J(ee,1,H,!0),this.y.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(H,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===C.Schemas.file).map(async W=>{const V=await this.P(W,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(V)).map(ne=>(ne.type=X.find(se=>(0,w.$oo)(se.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,V)))}))).flat();return this.J(G,"development",H,!0)}return[]}async scanExistingExtension(H,X,G){const W=await this.P(H,!1,X,!0,G.language,!0,void 0),V=await this.n.scanExtension(W);return!V||!G.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(H,X,G){const W=await this.P(H,!1,X,!0,G.language,!0,void 0),V=await this.n.scanOneOrMultipleExtensions(W);return this.J(V,X,G,!0)}async scanMetadata(H){const X=(0,u.$hg)(H,"package.json"),G=(await this.w.readFile(X)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(H,X){const G=(0,u.$hg)(H,"package.json"),W=(await this.w.readFile(G)).value.toString(),V=JSON.parse(W);X.isMachineScoped=X.isMachineScoped||void 0,X.isBuiltin=X.isBuiltin||void 0,V.__metadata={...V.__metadata,...X},await this.w.writeFile((0,u.$hg)(H,"package.json"),A.$Ed.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof E.$hp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Ed.fromString(JSON.stringify([])))}catch(X){(0,c.$ik)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$8)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,X,G,W){return G.includeAllVersions||(H=this.L(X===0?H:void 0,X===1?H:void 0,X==="development"?H:void 0,await this.getTargetPlatform(),W)),G.includeInvalid||(H=H.filter(V=>V.isValid)),H.sort((V,ee)=>{const ne=p.$_d(V.location.fsPath),se=p.$_d(ee.location.fsPath);return ne<se?-1:ne>se?1:0})}L(H,X,G,W,V){const ee=(se,Z,q)=>{if(se.isValid&&!Z.isValid)return!1;if(se.isValid===Z.isValid){if(V&&d.gt(se.manifest.version,Z.manifest.version))return this.y.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(d.eq(se.manifest.version,Z.manifest.version)){if(se.type===0)return this.y.debug(`Skipping extension ${Z.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===W)return this.y.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${se.location.path} with ${Z.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${Z.location.path}.`),!0},ne=new I.$Wl;return H?.forEach(se=>{const Z=ne.get(se.identifier.id);(!Z||ee(Z,se,!1))&&ne.set(se.identifier.id,se)}),X?.forEach(se=>{const Z=ne.get(se.identifier.id);if(!Z&&H&&se.type===0){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!Z||ee(Z,se,!1))&&ne.set(se.identifier.id,se)}),G?.forEach(se=>{const Z=ne.get(se.identifier.id);(!Z||ee(Z,se,!0))&&ne.set(se.identifier.id,se),ne.set(se.identifier.id,se)}),[...ne.values()]}async M(H,X){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),V=await(H&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",V.length),V}async N(H,X){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const W=X?await this.O():{},V=[],ee=o.URI.file(p.$6d(p.$8d(C.$1f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of G){const Z=W[se.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":V.push((0,u.$hg)(ee,se.name));break;default:V.push(o.URI.file(Z));break}}const ne=await Promise.all(V.map(async se=>this.n.scanExtension(await this.P(se,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,j.$Eb)(ne)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,X,G,W,V,ee,ne){const se=await this.f(V??g.$v),Z=await this.Q(H),q=X&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,k=q?await this.Q(q):void 0;return new z(H,Z,q,k,X,ne,G,W,ee,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,V,se)}async Q(H){try{const X=await this.w.stat(H);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$np=T,e.$np=T=ye([Y(4,m.$Dk),Y(5,E.$ip),Y(6,c.$5j),Y(7,n.$4i),Y(8,b.$Hh),Y(9,i.$jj),Y(10,a.$Bk),Y(11,s.$zh)],T);class z{constructor(H,X,G,W,V,ee,ne,se,Z,q,k,P,F,M,K){this.location=H,this.mtime=X,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=W,this.profile=V,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=se,this.validate=Z,this.productVersion=q,this.productDate=k,this.productCommit=P,this.devMode=F,this.language=M,this.translations=K}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,X){return(0,u.$ag)(H.location,X.location)&&H.mtime===X.mtime&&(0,u.$ag)(H.applicationExtensionslocation,X.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&H.profile===X.profile&&D.$Ym(H.profileScanOptions,X.profileScanOptions)&&H.type===X.type&&H.excludeObsolete===X.excludeObsolete&&H.validate===X.validate&&H.productVersion===X.productVersion&&H.productDate===X.productDate&&H.productCommit===X.productCommit&&H.devMode===X.devMode&&H.language===X.language&&L.equals(H.translations,X.translations)}}e.$op=z;let U=class extends $.$jc{constructor(H,X,G,W,V){super(),this.f=H,this.g=X,this.h=G,this.j=W,this.m=V}async scanExtensions(H){const X=H.profile?await this.r(H):await this.n(H);let G={};if(H.excludeObsolete&&H.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(W)}catch{}return(0,f.$vf)(G)?X:X.filter(W=>!G[w.$po.create(W).toString()])}async n(H){const X=await this.j.resolve(H.location);if(!X.children?.length)return[];const G=await Promise.all(X.children.map(async W=>{if(!W.isDirectory||H.type===1&&(0,u.$eg)(W.resource).indexOf(".")===0)return null;const V=new z(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(V)}));return(0,j.$Eb)(G).sort((W,V)=>W.location.path<V.location.path?-1:1)}async r(H){let X=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){X=X.filter(W=>!W.metadata?.isApplicationScoped);const G=await this.s(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);X.push(...G)}return X}async s(H,X,G){const W=await this.g.scanProfileExtensions(H,G.profileScanOptions);if(!W.length)return[];const V=await Promise.all(W.map(async ee=>{if(X(ee)){const ne=new z(ee.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,j.$Eb)(V)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,u.$hg)(H.location,"package.json"))){const X=await this.scanExtension(H);return X?[X]:[]}else return await this.scanExtensions(H)}catch(X){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,O.$8)(X)),[]}}async scanExtension(H,X){try{let G=await this.scanExtensionManifest(H.location);if(G){G.publisher||(G.publisher=I.$Ql),X=X??G.__metadata,delete G.__metadata;const W=(0,w.$to)(G.publisher,G.name),V=X?.id?{id:W,uuid:X.id}:{id:W},ee=X?.isSystem?0:H.type,ne=ee===0||!!X?.isBuiltin;G=await this.t(H.location,G,z.createNlsConfiguration(H));const se={type:ee,identifier:V,manifest:G,location:H.location,isBuiltin:ne,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return H.validate?this.validate(se,H):se}}catch(G){H.type!==0&&this.m.error(G)}return null}validate(H,X){let G=!0;const W=(0,t.$Eo)(X.productVersion,X.productDate,X.location,H.manifest,H.isBuiltin);for(const[V,ee]of W)V===y.default.Error&&(G=!1,this.m.error(this.z(X.location,ee)));return H.isValid=G,H.validations=W,H}async scanExtensionManifest(H){const X=(0,u.$hg)(H,"package.json");let G;try{G=(await this.j.readFile(X)).value.toString()}catch(V){return(0,c.$ik)(V)!==1&&this.m.error(this.z(H,(0,h.localize)(0,null,X.path,V.message))),null}let W;try{W=JSON.parse(G)}catch{const ee=[];(0,R.$Km)(G,ee);for(const ne of ee)this.m.error(this.z(H,(0,h.localize)(1,null,X.path,ne.offset,ne.length,(0,S.$kp)(ne.error))));return null}return(0,R.$Tm)(W)!=="object"?(this.m.error(this.z(H,(0,h.localize)(2,null,X.path))),null):W}async t(H,X,G){const W=await this.u(H,X,G);if(W)try{const V=[],ee=await this.w(W.default,V);if(V.length>0)return V.forEach(se=>{this.m.error(this.z(H,(0,h.localize)(3,null,W.default?.path,(0,S.$kp)(se.error))))}),X;if((0,R.$Tm)(W)!=="object")return this.m.error(this.z(H,(0,h.localize)(4,null,W.default?.path))),X;const ne=W.values||Object.create(null);return(0,v.$lp)(this.m,X,ne,ee)}catch{}return X}async u(H,X,G){const W=(0,u.$hg)(H,"package.nls.json"),V=(Z,q)=>{q.forEach(k=>{this.m.error(this.z(H,(0,h.localize)(5,null,Z?.path,(0,S.$kp)(k.error))))})},ee=Z=>{this.m.error(this.z(H,(0,h.localize)(6,null,Z?.path)))},ne=`${X.publisher}.${X.name}`,se=G.translations[ne];if(se)try{const Z=o.URI.file(se),q=(await this.j.readFile(Z)).value.toString(),k=[],P=(0,R.$Km)(q,k);return k.length>0?(V(Z,k),{values:void 0,default:W}):(0,R.$Tm)(P)!=="object"?(ee(Z),{values:void 0,default:W}):{values:P.contents?P.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let q;try{q=await this.y(H,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const k=(await this.j.readFile(q.localized)).value.toString(),P=[],F=(0,R.$Km)(k,P);return P.length>0?(V(q.localized,P),{values:void 0,default:q.original}):(0,R.$Tm)(F)!=="object"?(ee(q.localized),{values:void 0,default:q.original}):{values:F,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(H,X){if(H)try{const G=(await this.j.readFile(H)).value.toString();return(0,R.$Km)(G,X)}catch{}}y(H,X){return new Promise((G,W)=>{const V=ee=>{const ne=(0,u.$hg)(H,`package.nls.${ee}.json`);this.j.exists(ne).then(se=>{se&&G({localized:ne,original:(0,u.$hg)(H,"package.nls.json")});const Z=ee.lastIndexOf("-");Z===-1?G({localized:(0,u.$hg)(H,"package.nls.json"),original:null}):(ee=ee.substring(0,Z),V(ee))})};if(X.devMode||X.pseudo||!X.language)return G({localized:(0,u.$hg)(H,"package.nls.json"),original:null});V(X.language)})}z(H,X){return`[${H.path}]: ${X}`}};U=ye([Y(1,E.$ip),Y(2,a.$Bk),Y(3,c.$5j),Y(4,n.$4i)],U);let B=class extends U{constructor(H,X,G,W,V,ee,ne){super(X,W,V,ee,ne),this.G=H,this.H=G,this.D=this.B(new N.$Dg(3e3)),this.F=this.B(new r.$ed),this.onDidChangeCache=this.F.event}async scanExtensions(H){const X=this.M(H),G=await this.I(X);if(this.C=H,G&&G.input&&z.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),G.result.map(V=>(V.location=o.URI.revive(V.location),V));const W=await super.scanExtensions(H);return await this.J(X,{input:H,result:W}),W}async I(H){try{const X=await this.j.readFile(H),G=JSON.parse(X.value.toString());return{result:G.result,input:(0,l.$0g)(G.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",H.path,(0,O.$8)(X))}return null}async J(H,X){try{await this.j.writeFile(H,A.$Ed.fromString(JSON.stringify(X)))}catch(G){this.m.debug("Error while writing the extension cache file:",H.path,(0,O.$8)(G))}}async L(){if(!this.C)return;const H=this.M(this.C),X=await this.I(H);if(!X)return;const G=X.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!D.$Ym(W,G))try{this.m.info("Invalidating Cache",G,W),await this.j.del(H),this.F.fire()}catch(V){this.m.error(V)}}M(H){const X=this.N(H);return this.h.extUri.joinPath(X.cacheHome,H.type===0?I.$Pl:I.$Ol)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(H.location,X.extensionsResource))??this.G:this.H.defaultProfile}};B=ye([Y(2,m.$Dk),Y(3,E.$ip),Y(4,a.$Bk),Y(5,c.$5j),Y(6,n.$4i)],B);function Q(x,H){const X=(0,w.$ro)(x.manifest.publisher,x.manifest.name);return{id:X,identifier:new I.$Ul(X),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$pp=Q;class J extends T{constructor(H,X,G,W,V,ee,ne,se,Z,q,k,P){super(H,X,(0,u.$hg)(G,".vscode-oss-dev","extensions","control.json"),W,V,ee,ne,se,Z,q,k,P),this.R=(async()=>{if(g.$y)try{const F=await this.w.readFile(o.URI.file(g.$y));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$qp=J}),define(re[244],oe([0,1,64,5,38,3,2,23,15,31,7,17]),function(te,e,j,N,D,A,O,R,S,$,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;let g=class extends O.$jc{constructor(d,y){super(),this.b=d,this.f=y,this.a=new N.$Lg(5)}async postUninstall(d){const y=this.g(d,"uninstall");y&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(f){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(f)}}));try{await $.Promises.rm(this.m(d))}catch(f){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(f)}}g(d,y){const f=`vscode:${y}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[f]=="string"){const o=d.manifest.scripts[f].split(" ");return o.length<2||o[0]!=="node"||!o[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${f} should be a node script`),null):{script:(0,S.$8d)(d.location.fsPath,o[1]),args:o.slice(2)||[]}}return null}h(d,y,f,o,h){return new Promise((b,w)=>{const I=this.j(d,y,f,h);let t;const c=s=>{t&&(clearTimeout(t),t=null),s?w(s):b(void 0)};I.on("error",s=>{c((0,D.$li)(s)||"Unknown")}),I.on("exit",(s,n)=>{c(s?`post-${y} process exited with code ${s}`:void 0)}),o&&(t=setTimeout(()=>{t=null,I.kill(),w("timed out")},5e3))})}j(d,y,f,o){const h={silent:!0,execArgv:void 0},b=(0,j.fork)(d,[`--type=extension-post-${y}`,...f],h);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const w=A.Event.fromNodeEventEmitter(b.stdout,"data"),I=A.Event.fromNodeEventEmitter(b.stderr,"data");w(s=>this.f.info(o.identifier.id,o.manifest.version,`post-${y}`,s)),I(s=>this.f.error(o.identifier.id,o.manifest.version,`post-${y}`,s));const t=A.Event.any(A.Event.map(w,s=>({data:`%c${s}`,format:[""]})),A.Event.map(I,s=>({data:`%c${s}`,format:["color: red"]})));return A.Event.debounce(t,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100)(s=>{console.group(o.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),b}m(d){return(0,S.$8d)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$sp=g,e.$sp=g=ye([Y(0,p.$Dk),Y(1,C.$4i)],g)}),define(re[245],oe([0,1,7,17,27,21,50,13,16,11]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;let C=class extends O.$jp{constructor(g,u,d,y,f,o){super($.URI.file(g.extensionsPath),u,d,y,f,o)}};e.$fN=C,e.$fN=C=ye([Y(0,S.$Ih),Y(1,R.$5j),Y(2,N.$Dk),Y(3,D.$Bk),Y(4,A.$8k),Y(5,j.$4i)],C)}),define(re[246],oe([0,1,11,16,50,79,13,4,7,24,27,17]),function(te,e,j,N,D,A,O,R,S,$,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=void 0;let g=class extends A.$qp{constructor(d,y,f,o,h,b,w,I){super(j.URI.file(h.builtinExtensionsPath),j.URI.file(h.extensionsPath),h.userHome,d.defaultProfile,d,y,f,o,h,b,w,I)}};e.$E6b=g,e.$E6b=g=ye([Y(0,p.$Dk),Y(1,D.$ip),Y(2,O.$5j),Y(3,S.$4i),Y(4,N.$Ih),Y(5,$.$jj),Y(6,C.$Bk),Y(7,R.$zh)],g)}),define(re[20],oe([0,1,5,3,2,100,9,66,4,17]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$To=e.$So=e.$Ro=void 0,e.$Ro="__$__isNewStorageMarker",e.$So="__$__targetStorageMarker",e.$To=(0,S.$Ah)("storageService");var C;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var p;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var g;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function u(h){const b=h.get(e.$So);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.$Uo=u;class d extends D.$jc{static{this.a=60*1e3}constructor(b={flushInterval:d.a}){super(),this.m=b,this.b=this.B(new N.$hd),this.c=this.B(new N.$hd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ed),this.onWillSaveState=this.f.event,this.h=this.B(new j.$Rg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$kc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(b,w,I){return N.Event.filter(this.b.event,t=>t.scope===b&&(w===void 0||t.key===w),I)}n(){this.j.value=(0,j.$Vg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$ec)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(b,w){const{key:I,external:t}=w;if(I===e.$So){switch(b){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:I,target:this.J(b)[I],external:t})}w(b){this.f.fire({reason:b})}get(b,w,I){return this.P(w)?.get(b,I)}getBoolean(b,w,I){return this.P(w)?.getBoolean(b,I)}getNumber(b,w,I){return this.P(w)?.getNumber(b,I)}getObject(b,w,I){return this.P(w)?.getObject(b,I)}storeAll(b,w){this.y(()=>{for(const I of b)this.store(I.key,I.value,I.scope,I.target,w)})}store(b,w,I,t,c=!1){if((0,O.$rf)(w)){this.remove(b,I,c);return}this.y(()=>{this.z(b,I,t),this.P(I)?.set(b,w,c)})}remove(b,w,I=!1){this.y(()=>{this.z(b,w,void 0),this.P(w)?.delete(b,I)})}y(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,w){const I=[],t=this.J(b);for(const c of Object.keys(t))t[c]===w&&I.push(c);return I}z(b,w,I,t=!1){const c=this.J(w);typeof I=="number"?c[b]!==I&&(c[b]=I,this.P(w)?.set(e.$So,JSON.stringify(c),t)):typeof c[b]=="number"&&(delete c[b],this.P(w)?.set(e.$So,JSON.stringify(c),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(b){switch(b){case-1:return this.I;case 0:return this.G;default:return this.D}}L(b){const w=this.P(b);return w?u(w):Object.create(null)}isNew(b){return this.getBoolean(e.$Ro,b)===!0}async flush(b=C.NONE){this.f.fire({reason:b});const w=this.P(-1),I=this.P(0),t=this.P(1);switch(b){case C.NONE:await j.Promises.settled([w?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await j.Promises.settled([w?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.P(-1)?.items??new Map,w=this.P(0)?.items??new Map,I=this.P(1)?.items??new Map;return o(b,w,I,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(b){return await this.flush(),this.P(b)?.optimize()}async switch(b,w){return this.w(C.NONE),(0,$.$Ck)(b)?this.R(b,w):this.S(b,w)}M(b,w){return!(b.id===w.id||y(w)&&y(b))}N(b,w,I){this.y(()=>{const t=new Set;for(const[c,s]of b)t.add(c),w.get(c)!==s&&this.u(I,{key:c,external:!0});for(const[c]of w.items)t.has(c)||this.u(I,{key:c,external:!0})})}}e.$Vo=d;function y(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$Wo=y;class f extends d{constructor(){super(),this.U=this.B(new R.$Po(new R.$Qo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Po(new R.$Qo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Po(new R.$Qo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(b=>this.u(1,b))),this.B(this.W.onDidChangeStorage(b=>this.u(0,b))),this.B(this.U.onDidChangeStorage(b=>this.u(-1,b)))}P(b){switch(b){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(b){return!1}}e.$Xo=f;async function o(h,b,w,I,t,c){const s=L=>{try{return JSON.parse(L)}catch{return L}},n=new Map,i=new Map;h.forEach((L,T)=>{n.set(T,L),i.set(T,s(L))});const r=new Map,l=new Map;b.forEach((L,T)=>{r.set(T,L),l.set(T,s(L))});const E=new Map,m=new Map;w.forEach((L,T)=>{E.set(T,L),m.set(T,s(L))}),console.group(I!==t?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const a=[];if(n.forEach((L,T)=>{a.push({key:T,value:L})}),console.table(a),console.groupEnd(),console.log(i),I!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];r.forEach((T,z)=>{L.push({key:z,value:T})}),console.table(L),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${c})`);const v=[];E.forEach((L,T)=>{v.push({key:T,value:L})}),console.table(v),console.groupEnd(),console.log(m)}e.$Yo=o}),define(re[114],oe([0,1,3,2,9,29,33,20]),function(te,e,j,N,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mzb=e.$lzb=void 0;let S=class extends N.$jc{constructor(p,g){super(),this.a=new j.$ed,this.onDidChangeEnablement=this.a.event,this.b=this.B(new $(p)),this.B(this.b.onDidChange(u=>this.a.fire({extensions:u,source:"storage"}))),this.B(g.onDidInstallExtensions(u=>u.forEach(({local:d,operation:y})=>{d&&y===4&&this.f(d.identifier)})))}async enableExtension(p,g){return this.f(p)?(this.a.fire({extensions:[p],source:g}),!0):!1}async disableExtension(p,g){return this.c(p)?(this.a.fire({extensions:[p],source:g}),!0):!1}getDisabledExtensions(){return this.h(A.$2n)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(p){const g=this.getDisabledExtensions();return g.every(u=>!(0,O.$oo)(u,p))?(g.push(p),this.g(g),!0):!1}f(p){const g=this.getDisabledExtensions();for(let u=0;u<g.length;u++){const d=g[u];if((0,O.$oo)(d,p))return g.splice(u,1),this.g(g),!0}return!1}g(p){this.j(A.$2n,p)}h(p){return this.b.get(p,0)}j(p,g){this.b.set(p,g,0)}};e.$lzb=S,e.$lzb=S=ye([Y(0,R.$To),Y(1,A.$1n)],S);class $ extends N.$jc{constructor(p){super(),this.c=p,this.a=Object.create(null),this.b=this.B(new j.$ed),this.onDidChange=this.b.event,this.B(p.onDidChangeValue(0,void 0,this.B(new N.$ic))(g=>this.f(g)))}get(p,g){let u;return g===0?((0,D.$rf)(this.a[p])&&(this.a[p]=this.g(p,g)),u=this.a[p]):u=this.g(p,g),JSON.parse(u)}set(p,g,u){const d=JSON.stringify(g.map(({id:f,uuid:o})=>({id:f,uuid:o})));this.g(p,u)!==d&&(u===0&&(g.length?this.a[p]=d:delete this.a[p]),this.h(p,g.length?d:void 0,u))}f(p){if(!(0,D.$rf)(this.a[p.key])&&this.g(p.key,p.scope)!==this.a[p.key]){const u=this.get(p.key,p.scope);delete this.a[p.key];const d=this.get(p.key,p.scope),y=u.filter(o=>!d.some(h=>(0,O.$oo)(o,h))),f=d.filter(o=>!u.some(h=>(0,O.$oo)(h,o)));(y.length||f.length)&&this.b.fire([...y,...f])}}g(p,g){return this.c.get(p,g,"[]")}h(p,g,u){g?this.c.store(p,g,u,1):this.c.remove(p,u)}}e.$mzb=$}),define(re[247],oe([0,1,18,26,8,6,37,9,11,19,16,29,33,67,13,7,24,57,224,20,21,60]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=void 0;const t=A.$o?"web":(0,p.$Tn)(A.$t,O.$3d),c="X-Market-Search-Activity-Id";var s;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function n(...k){return String(k.reduce((P,F)=>P|F,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class a{constructor(P=m){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,F=this.d.pageSize){return new a({...this.d,pageNumber:P,pageSize:F})}withFilter(P,...F){const M=[...this.d.criteria,...F.length?F.map(K=>({filterType:P,value:K})):[{filterType:P}]];return new a({...this.d,criteria:M})}withSortBy(P){return new a({...this.d,sortBy:P})}withSortOrder(P){return new a({...this.d,sortOrder:P})}withFlags(...P){return new a({...this.d,flags:P.reduce((F,M)=>F|M,0)})}withAssetTypes(...P){return new a({...this.d,assetTypes:P})}withSource(P){return new a({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:F,pageSize:M,sortBy:K,sortOrder:_,flags:ae,assetTypes:he}=this.d;return{filters:[{criteria:P,pageNumber:F,pageSize:M,sortBy:K,sortOrder:_}],assetTypes:he,flags:ae}}get searchText(){const P=this.d.criteria.filter(F=>F.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(k,P){const F=(k||[]).filter(M=>M.statisticName===P)[0];return F?F.value:0}function L(k){const P="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(M=>M.assetType.indexOf(P)===0).reduce((M,K)=>{const _=U(k,K.assetType);return _&&M.push([K.assetType.substring(P.length),_]),M},[])}function T(k){if(k.properties){const P=k.properties.filter(K=>K.key===r.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=P.filter(K=>F.test(K.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return U(k,r.Repository)}function z(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function U(k,P){return k.files.filter(M=>M.assetType===P)[0]?{uri:`${k.assetUri}/${P}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${P}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function B(k,P){const F=k.properties?k.properties.filter(K=>K.key===P):[],M=F.length>0&&F[0].value;return M?M.split(",").map(K=>(0,g.$so)(K)):[]}function Q(k){const P=k.properties?k.properties.filter(F=>F.key===l.Engine):[];return P.length>0&&P[0].value||""}function J(k){const P=k.properties?k.properties.filter(F=>F.key===l.PreRelease):[];return P.length>0&&P[0].value==="true"}function x(k){const P=k.properties?k.properties.filter(M=>M.key===l.LocalizedLanguages):[],F=P.length>0&&P[0].value||"";return F?F.split(","):[]}function H(k){return k.properties?.find(P=>P.key===l.SponsorLink)?.value}function X(k){return k.indexOf("preview")!==-1}function G(k){return k.targetPlatform?(0,p.$Sn)(k.targetPlatform):"undefined"}function W(k){const P=(0,j.$Jb)(k.versions.map(G)),F=!!k.tags?.includes(p.$Nn),M=P.indexOf("web");return F?M===-1&&P.push("web"):M!==-1&&P.splice(M,1),P}function V(k,P){const F=(0,p.$Wn)(P);for(let M=0;M<k.length;M++){const K=k[M];if(K.version===k[M-1]?.version){let _=M;const ae=G(K);if(ae===P)for(;_>0&&k[_-1].version===K.version;)_--;else if(F.includes(ae))for(;_>0&&k[_-1].version===K.version&&G(k[_-1])!==P;)_--;_!==M&&(k.splice(M,1),k.splice(_,0,K))}}return k}e.$2o=V;function ee(k,P,F){k.telemetryData={index:P,querySource:F,queryActivityId:k.queryContext?.[c]}}function ne(k,P,F,M){const K=k.versions[0],_={manifest:U(P,r.Manifest),readme:U(P,r.Details),changelog:U(P,r.Changelog),license:U(P,r.License),repository:T(P),download:z(P),icon:U(P,r.Icon),signature:U(P,r.Signature),coreTranslations:L(P)};return{identifier:{id:(0,g.$to)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:P.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(K),description:k.shortDescription||"",installCount:v(k.statistics,"install"),rating:v(k.statistics,"averagerating"),ratingCount:v(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:F,assets:_,properties:{dependencies:B(P,l.Dependency),extensionPack:B(P,l.ExtensionPack),engine:Q(P),localizedLanguages:x(P),targetPlatform:G(P),isPreReleaseVersion:J(P)},hasPreReleaseVersion:J(K),hasReleaseVersion:!0,preview:X(k.flags),isSigned:!!_.signature,queryContext:M}}let se=class{constructor(P,F,M,K,_,ae,he,fe){this.k=F,this.l=M,this.n=K,this.o=_,this.q=ae,this.u=he,this.w=fe;const le=he.extensionsGallery,$e=le?.servicePPEUrl&&fe.getValue("_extensionsGallery.enablePPE");this.d=$e?le.servicePPEUrl:le?.serviceUrl,this.g=$e?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,h.$1o)(he.version,he,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,F,M){const K=N.CancellationToken.isCancellationToken(F)?{}:F,_=N.CancellationToken.isCancellationToken(F)?F:M,ae=[],he=[],fe=[],le=[];let $e=!0;for(const Ee of P){Ee.uuid?he.push(Ee.uuid):ae.push(Ee.id);const je=!!(Ee.version||Ee.preRelease);fe.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:je}),Ee.version&&le.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),$e=$e&&!!Ee.hasPreRelease&&!je}if(!he.length&&!ae.length)return[];let de=new a().withPage(1,P.length);he.length&&(de=de.withFilter(i.ExtensionId,...he)),ae.length&&(de=de.withFilter(i.ExtensionName,...ae)),(K.queryAllVersions||$e)&&(de=de.withFlags(de.flags,s.IncludeVersions)),K.source&&(de=de.withSource(K.source));const{extensions:we}=await this.z(de,{targetPlatform:K.targetPlatform??t,includePreRelease:fe,versions:le,compatible:!!K.compatible},_);return K.source&&we.forEach((Ee,je)=>ee(Ee,je,K.source)),we}async getCompatibleExtension(P,F,M){if((0,p.$Un)(P.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(P,F,M))return P;const K=new a().withFlags(s.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:_}=await this.z(K,{targetPlatform:M,compatible:!0,includePreRelease:F},N.CancellationToken.None);return _[0]||null}async isExtensionCompatible(P,F,M){if(!(0,p.$Vn)(P.properties.targetPlatform,P.allTargetPlatforms,M)||!F&&P.properties.isPreReleaseVersion)return!1;let K=P.properties.engine;if(!K){const _=await this.getManifest(P,N.CancellationToken.None);if(!_)throw new Error("Manifest was not found");K=_.engines.vscode}return(0,u.$Go)(K,this.u.version,this.u.date)}async y(P,F,M,K,_){if(!(0,p.$Vn)(G(P),K,_)||F!=="any"&&J(P)!==(F==="prerelease"))return!1;if(M)try{const ae=await this.E(P);if(!(0,u.$Go)(ae,this.u.version,this.u.date))return!1}catch(ae){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,D.$8)(ae)),!1}return!0}async query(P,F){let M=P.text||"";const K=P.pageSize??50;let _=new a().withPage(1,K);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(_=_.withFilter(i.Category,we||de),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(_=_.withFilter(i.Tag,we||de),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),_=_.withFilter(i.SearchText,M)),_=_.withSortBy(0)):P.ids?_=_.withFilter(i.ExtensionId,...P.ids):P.names?_=_.withFilter(i.ExtensionName,...P.names):_=_.withSortBy(4),typeof P.sortBy=="number"&&(_=_.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(_=_.withSortOrder(P.sortOrder)),P.source&&(_=_.withSource(P.source));const ae=async($e,de)=>{const{extensions:we,total:Ee}=await this.z($e,{targetPlatform:t,compatible:!1,includePreRelease:!!P.includePreRelease},de);return we.forEach((je,Le)=>ee(je,($e.pageNumber-1)*$e.pageSize+Le,P.source)),{extensions:we,total:Ee}},{extensions:he,total:fe}=await ae(_,F),le=async($e,de)=>{if(de.isCancellationRequested)throw new D.$3;const{extensions:we}=await ae(_.withPage($e+1),de);return we};return{firstPage:he,total:fe,pageSize:_.pageSize,getPage:le}}async z(P,F,M){const K=P.flags;P.flags&s.IncludeLatestVersionOnly&&P.flags&s.IncludeVersions&&(P=P.withFlags(P.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(P.flags&s.IncludeLatestVersionOnly)&&!(P.flags&s.IncludeVersions)&&(P=P.withFlags(P.flags,s.IncludeLatestVersionOnly)),F.versions?.length&&(P=P.withFlags(P.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),P=P.withFlags(P.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:_,total:ae,context:he}=await this.B(P,M);if(!(P.flags&s.IncludeLatestVersionOnly)){const de=[];for(const we of _){const Ee=await this.A(we,F,he);Ee&&de.push(Ee)}return{extensions:de,total:ae}}const le=[],$e=new Map;for(let de=0;de<_.length;de++){const we=_[de],Ee={id:(0,g.$to)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},je=(0,R.$of)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Me=>(0,g.$oo)(Me,Ee))?.includePreRelease;if(F.compatible&&(0,p.$Un)(W(we),F.targetPlatform))continue;const Le=await this.A(we,F,he);!Le||Le.properties.isPreReleaseVersion&&(!je||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==F.targetPlatform&&Le.hasPreReleaseVersion?$e.set(we.extensionId,de):le.push([de,Le])}if($e.size){const de=new I.$ad,we=new a().withFlags(K&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,$e.size).withFilter(i.ExtensionId,...$e.keys()),{extensions:Ee}=await this.z(we,F,M);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const je of Ee){const Le=$e.get(je.identifier.uuid);le.push([Le,je])}}return{extensions:le.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:ae}}async A(P,F,M){const K={id:(0,g.$to)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},_=F.versions?.find(le=>(0,g.$oo)(le,K))?.version,ae=(0,R.$of)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(le=>(0,g.$oo)(le,K))?.includePreRelease,he=W(P),fe=V(P.versions,F.targetPlatform);if(F.compatible&&(0,p.$Un)(he,F.targetPlatform))return null;for(let le=0;le<fe.length;le++){const $e=fe[le];if(!(_&&$e.version!==_)){if(await this.y($e,ae?"any":"release",F.compatible,he,F.targetPlatform))return ne(P,$e,he,M);if(_&&$e.version===_)return null}}return _||F.compatible?null:ne(P,P.versions[0],he)}async B(P,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,s.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(s.Unpublished));const M=await this.j,K=JSON.stringify(P.raw),_={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},ae=new I.$ad;let he,fe,le=0;try{if(he=await this.k.request({type:"POST",url:this.g&&P.criteria.some(de=>de.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:K,headers:_},F),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:le};const $e=await(0,o.$Mo)(he);if($e){const de=$e.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(je=>je.metadataType==="ResultCount")[0];return le=Ee&&Ee.metadataItems.filter(je=>je.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le,context:{[c]:he.res.headers.activityid}}}return{galleryExtensions:[],total:le}}catch($e){throw fe=$e,$e}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(K.length),duration:ae.elapsed(),success:!!he&&(0,o.$Jo)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:fe?(0,D.$2)(fe)?"canceled":(0,D.$8)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(P,F,M,K){if(!this.isEnabled())return;const _=A.$o?this.x(`/itemName/${P}.${F}/version/${M}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${F}/${M}/stats?statType=${K}`),ae=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:_,headers:fe},N.CancellationToken.None)}catch{}}async download(P,F,M){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const K=(0,g.$wo)(P),_=new Date().getTime(),ae=de=>this.o.publicLog("galleryService:downloadVSIX",{...K,duration:de}),he=M===2?"install":M===3?"update":"",fe=he?{uri:`${P.assets.download.uri}${S.URI.parse(P.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${P.assets.download.fallbackUri}${S.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:P.assets.download,le=P.queryContext?.[c]?{[c]:P.queryContext[c]}:void 0,$e=await this.D(fe,le?{headers:le}:void 0);await this.q.writeFile(F,$e.stream),ae(new Date().getTime()-_)}async downloadSignatureArchive(P,F){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const M=await this.D(P.assets.signature);await this.q.writeFile(F,M.stream)}async getReadme(P,F){if(P.assets.readme){const M=await this.D(P.assets.readme,{},F);return await(0,o.$Lo)(M)||""}return""}async getManifest(P,F){if(P.assets.manifest){const M=await this.D(P.assets.manifest,{},F),K=await(0,o.$Lo)(M);return K?JSON.parse(K):null}return null}async C(P,F){const M=U(P,r.Manifest);if(!M)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},_=await this.D(M,{headers:K});return await(0,o.$Mo)(_)}async getCoreTranslation(P,F){const M=P.assets.coreTranslations.filter(K=>K[0]===F.toUpperCase())[0];if(M){const K=await this.D(M[1]),_=await(0,o.$Lo)(K);return _?JSON.parse(_):null}return null}async getChangelog(P,F){if(P.assets.changelog){const M=await this.D(P.assets.changelog,{},F);return await(0,o.$Lo)(M)||""}return""}async getAllCompatibleVersions(P,F,M){let K=new a().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?K=K.withFilter(i.ExtensionId,P.identifier.uuid):K=K.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:_}=await this.B(K,N.CancellationToken.None);if(!_.length)return[];const ae=W(_[0]);if((0,p.$Un)(ae,M))return[];const he=[];await Promise.all(_[0].versions.map(async $e=>{try{await this.y($e,F?"any":"release",!0,ae,M)&&he.push($e)}catch{}}));const fe=[],le=new Set;for(const $e of V(he,M))le.has($e.version)||(le.add($e.version),fe.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:J($e)}));return fe}async D(P,F={},M=N.CancellationToken.None){const K=await this.j,_={type:"GET"},ae={...K,...F.headers||{}};F={...F,..._,headers:ae};const he=P.uri,fe=P.fallbackUri,le={...F,url:he};try{const $e=await this.k.request(le,M);if($e.res.statusCode===200)return $e;const de=await(0,o.$Lo)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,D.$2)($e))throw $e;const de=(0,D.$8)($e);this.o.publicLog2("galleryService:cdnFallback",{url:he,message:de});const we={...F,url:fe};return this.k.request(we,M)}}async E(P){let F=Q(P);if(!F){const M=await this.C(P,N.CancellationToken.None);if(!M)throw new Error("Manifest was not found");F=M.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const P=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,o.$Mo)(P),M=[],K={},_=[];if(F){for(const ae of F.malicious)M.push({id:ae});if(F.migrateToPreRelease)for(const[ae,he]of Object.entries(F.migrateToPreRelease))(!he.engine||(0,u.$Go)(he.engine,this.u.version,this.u.date))&&(K[ae.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[ae,he]of Object.entries(F.deprecated))he&&(K[ae.toLowerCase()]=(0,R.$of)(he)?{}:he);if(F.search)for(const ae of F.search)_.push(ae)}return{malicious:M,deprecated:K,search:_}}};se=ye([Y(1,o.$Ho),Y(2,y.$4i),Y(3,C.$Hh),Y(4,w.$8k),Y(5,d.$5j),Y(6,f.$jj),Y(7,$.$7h)],se);let Z=class extends se{constructor(P,F,M,K,_,ae,he,fe){super(P,F,M,K,_,ae,he,fe)}};e.$3o=Z,e.$3o=Z=ye([Y(0,b.$To),Y(1,o.$Ho),Y(2,y.$4i),Y(3,C.$Hh),Y(4,w.$8k),Y(5,d.$5j),Y(6,f.$jj),Y(7,$.$7h)],Z);let q=class extends se{constructor(P,F,M,K,_,ae,he){super(void 0,P,F,M,K,_,ae,he)}};e.$4o=q,e.$4o=q=ye([Y(0,o.$Ho),Y(1,y.$4i),Y(2,C.$Hh),Y(3,w.$8k),Y(4,d.$5j),Y(5,f.$jj),Y(6,$.$7h)],q)}),define(re[80],oe([0,1,4,3,2,20,33,24,18,7,9]),function(te,e,j,N,D,A,O,R,S,$,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rz=e.$Qz=void 0,e.$Qz=(0,j.$Ah)("IExtensionStorageService");const g=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let u=class extends D.$jc{static{p=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,O.$so)(y.id)}@${y.version}`}static c(y){const f=g.exec(y);if(f&&f[1])return{id:f[1],version:f[2]}}static async removeOutdatedExtensionVersions(y,f){const o=await y.getInstalled(),h=[];for(const[b,w]of p.f(f)){const I=o.find(t=>(0,O.$oo)(t.identifier,{id:b}))?.manifest.version;for(const t of w)I!==t&&h.push(p.b({id:b,version:t}))}for(const b of h)f.remove(b,0)}static f(y){const f=new Map,o=y.keys(0,1);for(const h of o){const b=p.c(h);if(b){let w=f.get(b.id.toLowerCase());w||f.set(b.id.toLowerCase(),w=[]),w.push(b.version)}}return f}constructor(y,f,o){super(),this.j=y,this.m=f,this.n=o,this.g=this.B(new N.$ed),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=p.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new D.$ic))(h=>this.r(h)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const f=p.c(y.key);if(f){if(this.j.get(y.key,0)===void 0)this.h.delete(f.id.toLowerCase());else{let o=this.h.get(f.id.toLowerCase());o||this.h.set(f.id.toLowerCase(),o=[]),o.push(f.version),this.g.fire()}return}}s(y){if((0,C.$if)(y))return y;const f=y.manifest?y.manifest.publisher:y.publisher,o=y.manifest?y.manifest.name:y.name;return(0,O.$ro)(f,o)}getExtensionState(y,f){const o=this.s(y),h=this.getExtensionStateRaw(y,f);if(h)try{return JSON.parse(h)}catch(b){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${o}, global: ${f}): ${b}`)}}getExtensionStateRaw(y,f){const o=this.s(y),h=this.j.get(o,f?0:1);return h&&h?.length>p.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${o}, global: ${f}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState(y,f,o){const h=this.s(y);f===void 0?this.j.remove(h,o?0:1):this.j.store(h,JSON.stringify(f),o?0:1,1)}setKeysForSync(y,f){this.j.store(p.b(y),JSON.stringify(f),0,1)}getKeysForSync(y){const f=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],o=this.j.get(p.b(y),0),h=o?JSON.parse(o):void 0;return h&&f?(0,S.$Jb)([...h,...f]):h||f}addToMigrationList(y,f){if(y!==f){const o=this.t.filter(h=>!h.includes(y)&&!h.includes(f));o.push([y,f]),this.t=o}}getSourceExtensionToMigrate(y){const f=this.t.find(([,o])=>y===o);return f?f[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const f=JSON.parse(y);if(Array.isArray(f))return f}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Rz=u,e.$Rz=u=p=ye([Y(0,A.$To),Y(1,R.$jj),Y(2,$.$4i)],u)}),define(re[248],oe([0,1,29,13,24,16,98,55,20,21,221]),function(te,e,j,N,D,A,O,R,S,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7b=void 0;let p=class extends C.$h4b{constructor(u,d,y,f,o,h,b,w){super(u.userHome,o,d,y,f,h,b,w)}};e.$Z7b=p,e.$Z7b=p=ye([Y(0,A.$Ih),Y(1,$.$8k),Y(2,j.$1n),Y(3,S.$To),Y(4,R.$M5b),Y(5,O.$uUb),Y(6,N.$5j),Y(7,D.$jj)],p)}),define(re[249],oe([0,1,105,3,21,16,2,7,15,64,24,6,5,101,19,165,36,20,9,133,22]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=void 0;const I=[j.$O7b,j.$P7b],t="remoteTunnelSession",c="remoteTunnelIsService";let s=class extends O.$jc{constructor(l,E,m,a,v,L,T){super(),this.y=l,this.z=E,this.C=m,this.D=L,this.F=T,this.f=new N.$ed,this.onDidTokenFailed=this.f.event,this.g=new N.$ed,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$ed,this.onDidChangeMode=this.h.event,this.n=j.$M7b,this.w=!1,this.I=(z,U)=>{U?this.j.error(z):this.j.info(z)},this.j=this.B(a.createLogger((0,w.$hg)(m.logsHome,`${j.$Q7b}.log`),{id:j.$Q7b,name:j.$R7b})),this.t=new g.$Cg(100),this.B(this.j.onDidChangeLogLevel(z=>this.j.info("Log level changed to "+(0,R.$gj)(z)))),this.B(v.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(L.onDidChangeConfiguration(z=>{I.some(U=>z.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=j.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(l){this.s=l,this.g.fire(l)}H(l){i(this.n,l)||(this.n=l,this.S(l),this.h.fire(this.n),l.active?(this.j.info(`Session updated: ${l.session.accountLabel} (${l.session.providerId}) (service=${l.asService})`),l.session.token&&this.j.info(`Session token updated: ${l.session.accountLabel} (${l.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(l){if(this.w)return this.s;this.w=!0,this.H(l);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}J(){if(!this.u){let l;p.$j?l=this.C.appRoot:l=(0,S.$$d)((0,S.$$d)(this.C.appRoot)),this.u=(0,S.$8d)(l,"bin",`${this.z.tunnelApplicationName}${p.$i?".exe":""}`)}return this.u}async startTunnel(l){if(i(this.n,l)&&this.s.type!=="disconnected")return this.s;this.H(l);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const l=this.n.asService;this.H(j.$M7b);try{l&&this.O("uninstallService",["service","uninstall"])}catch(E){this.j.error(E)}try{await this.O("stop",["kill"])}catch(E){this.j.error(E)}this.G(j.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let l="",E=!1;const m=(U,B)=>{B?this.j.error(U):l+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(j.TunnelStates.connecting((0,y.localize)(0,null)))},a=this.O("status",["status"],m);this.r=a;try{if(await a,this.r!==a)return;const U=JSON.parse(l.trim().split(`
`).find(B=>B.startsWith("{")));if(E=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(j.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(j.TunnelStates.disconnected());return}finally{this.r===a&&(this.r=void 0)}const v=this.n.active?this.n.session:void 0;if(v&&v.token){const U=v.token;this.G(j.TunnelStates.connecting((0,y.localize)(1,null,v.accountLabel,v.providerId)));const B=(J,x)=>{J=J.replaceAll(U,"*".repeat(4)),m(J,x)},Q=this.O("login",["user","login","--provider",v.providerId,"--access-token",U,"--log",(0,R.$gj)(this.j.getLevel())],B);this.r=Q;try{if(await Q,this.r!==Q)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(v),this.G(j.TunnelStates.disconnected(v));return}}const L=this.Q();L?this.G(j.TunnelStates.connecting((0,y.localize)(2,null,L))):this.G(j.TunnelStates.connecting((0,y.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,R.$gj)(this.j.getLevel())];L?T.push("--name",L):T.push("--random-name");let z=!1;return this.n.active&&this.n.asService&&!E&&(z=await this.M(T)===!1),this.N(v,T,z)}async M(l){let E;try{E=await this.O("serviceInstall",["service","install",...l])}catch(m){this.j.error(m),E=1}if(E!==0){const m=(0,y.localize)(4,null);return this.j.warn(m),this.G(j.TunnelStates.connecting(m)),!1}return!0}async N(l,E,m){E.push("--parent-process-id",String(process.pid)),this.P()&&E.push("--no-sleep");let a=!1;const v=this.O("tunnel",E,(L,T)=>{T?this.j.error(L):this.j.info(L),L.includes("Connected to an existing tunnel process")&&(a=!0);const z=L.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(z){const U={link:z[1],domain:z[2],tunnelName:z[4],isAttached:a};this.G(j.TunnelStates.connected(U,m))}else L.match(/error refreshing token/)&&(v.cancel(),this.f.fire(l),this.G(j.TunnelStates.disconnected(l)))});this.r=v,v.finally(()=>{v===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=j.$M7b,this.G(j.TunnelStates.disconnected()))})}O(l,E,m=this.I){return(0,g.$tg)(a=>new Promise((v,L)=>{a.isCancellationRequested&&v(-1);let T;const z=["ignore","pipe","pipe"];if(a.onCancellationRequested(()=>{T&&(this.j.info(`${l} terminating(${T.pid})`),T.kill())}),!this.C.isBuilt)m(`Building tunnel CLI from sources and run
`,!1),m(`${l} Spawning: cargo run -- tunnel ${E.join(" ")}
`,!1),T=(0,$.spawn)("cargo",["run","--","tunnel",...E],{cwd:(0,S.$8d)(this.C.appRoot,"cli"),stdio:z});else{m(`Running tunnel CLI
`,!1);const U=this.J();m(`${l} Spawning: ${U} tunnel ${E.join(" ")}
`,!1),T=(0,$.spawn)(U,["tunnel",...E],{cwd:(0,f.homedir)(),stdio:z})}T.stdout.pipe(new b.$FS(`
`)).on("data",U=>{if(T){const B=U.toString();m(B,!1)}}),T.stderr.pipe(new b.$FS(`
`)).on("data",U=>{if(T){const B=U.toString();m(B,!0)}}),T.on("exit",U=>{T&&(m(`${l} exit(${T.pid}): + ${U} `,!1),T=void 0,v(U||0))}),T.on("error",U=>{T&&(m(`${l} error(${T.pid}): + ${U} `,!0),T=void 0,L())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(j.$P7b)}Q(){let l=this.D.getValue(j.$O7b)||(0,f.hostname)();return l=l.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),l||void 0}R(){try{const l=this.F.get(t,-1),E=this.F.getBoolean(c,-1,!1);if(l){const m=JSON.parse(l);if(m&&(0,h.$if)(m.accountLabel)&&(0,h.$if)(m.sessionId)&&(0,h.$if)(m.providerId))return{active:!0,session:m,asService:E};this.j.error("Problems restoring session from storage, invalid format",m)}}catch(l){this.j.error("Problems restoring session from storage",l)}return j.$M7b}S(l){if(l.active){const E={providerId:l.session.providerId,sessionId:l.session.sessionId,accountLabel:l.session.accountLabel};this.F.store(t,JSON.stringify(E),-1,1),this.F.store(c,l.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(c,-1)}};e.$V7b=s,e.$V7b=s=ye([Y(0,D.$8k),Y(1,C.$jj),Y(2,A.$Ih),Y(3,R.$5i),Y(4,u.$T7b),Y(5,d.$7h),Y(6,o.$To)],s);function n(r,l){return r&&l?r.sessionId===l.sessionId&&r.providerId===l.providerId&&r.token===l.token:r===l}const i=(r,l)=>r.active!==l.active?!1:r.active&&l.active?r.asService===l.asService&&n(r.session,l.session):!0}),define(re[250],oe([0,1,5,2,23,22,66,20,75,17]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=void 0;class C extends R.$Vo{constructor(g,u,d,y){super(),this.bb=g,this.cb=u,this.db=d,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$ic),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$ic),this.ab=this.hb(this.bb)}fb(){const g=this.B(new S.$Vzb(this.db.getChannel("storage"))),u=this.B(new O.$Po(g));return this.B(u.onDidChangeStorage(d=>this.u(-1,d))),u}gb(g){this.X.clear(),this.W=g;let u;if((0,R.$Wo)(g))u=this.U;else{const d=this.X.add(new S.$Wzb(this.db.getChannel("storage"),g));u=this.X.add(new O.$Po(d))}return this.X.add(u.onDidChangeStorage(d=>this.u(0,d))),u}hb(g){this.$.clear(),this.Z=g?.id;let u;if(g){const d=this.$.add(new S.$Xzb(this.db.getChannel("storage"),g));u=this.$.add(new O.$Po(d)),this.$.add(u.onDidChangeStorage(y=>this.u(1,y)))}return u}async O(){await j.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(g){switch(g){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(g){switch(g){case-1:return this.s.globalStorageHome.with({scheme:D.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:D.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$hg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:D.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await j.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(g){if(!this.M(this.W,g))return;const u=this.Y,d=u.items;u!==this.U&&await u.close(),this.Y=this.gb(g),await this.Y.init(),this.N(d,this.Y,0)}async S(g,u){const d=this.ab,y=d?.items??new Map;await d?.close(),this.ab=this.hb(g),await this.ab.init(),this.N(y,this.ab,1)}hasScope(g){return(0,$.$Ck)(g)?this.W.id===g.id:this.Z===g.id}}e.$17b=C}),define(re[251],oe([0,1,3,2,17,92]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=void 0;class O{constructor($,C){this.a=$,this.b=C}listen($,C){const p=this.b($);switch(C){case"onDidChangeProfiles":return j.Event.map(this.a.onDidChangeProfiles,g=>({all:g.all.map(u=>(0,A.$Cm)({...u},p)),added:g.added.map(u=>(0,A.$Cm)({...u},p)),removed:g.removed.map(u=>(0,A.$Cm)({...u},p)),updated:g.updated.map(u=>(0,A.$Cm)({...u},p))}))}throw new Error(`Invalid listen ${C}`)}async call($,C,p){const g=this.b($);switch(C){case"createProfile":{const u=await this.a.createProfile(p[0],p[1],p[2]);return(0,A.$Cm)({...u},g)}case"updateProfile":{let u=(0,D.$Ek)((0,A.$Dm)(p[0],g),this.a.profilesHome.scheme);return u=await this.a.updateProfile(u,p[1]),(0,A.$Cm)({...u},g)}case"removeProfile":{const u=(0,D.$Ek)((0,A.$Dm)(p[0],g),this.a.profilesHome.scheme);return this.a.removeProfile(u)}}throw new Error(`Invalid call ${C}`)}}e.$mN=O;class R extends N.$jc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,C,p){super(),this.profilesHome=C,this.f=p,this.a=[],this.b=this.B(new j.$ed),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(g=>(0,D.$Ek)(g,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(g=>{const u=g.added.map(f=>(0,D.$Ek)(f,this.profilesHome.scheme)),d=g.removed.map(f=>(0,D.$Ek)(f,this.profilesHome.scheme)),y=g.updated.map(f=>(0,D.$Ek)(f,this.profilesHome.scheme));this.a=g.all.map(f=>(0,D.$Ek)(f,this.profilesHome.scheme)),this.b.fire({added:u,removed:d,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,C,p){const g=await this.f.call("createNamedProfile",[$,C,p]);return(0,D.$Ek)(g,this.profilesHome.scheme)}async createProfile($,C,p,g){const u=await this.f.call("createProfile",[$,C,p,g]);return(0,D.$Ek)(u,this.profilesHome.scheme)}async createTransientProfile($){const C=await this.f.call("createTransientProfile",[$]);return(0,D.$Ek)(C,this.profilesHome.scheme)}async setProfileForWorkspace($,C){await this.f.call("setProfileForWorkspace",[$,C])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,C){const p=await this.f.call("updateProfile",[$,C]);return(0,D.$Ek)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$nN=R}),define(re[58],oe([0,1,2,66,4,20,3,75,17]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2zb=e.$1zb=e.$Zzb=void 0,e.$Zzb=(0,D.$Ah)("IUserDataProfileStorageService");let $=class extends j.$jc{constructor(u){super(),this.a=u}async readStorageData(u){return this.withProfileScopedStorageService(u,async d=>this.b(d))}async updateStorageData(u,d,y){return this.withProfileScopedStorageService(u,async f=>this.c(f,d,y))}async withProfileScopedStorageService(u,d){if(this.a.hasScope(u))return d(this.a);const y=await this.g(u),f=new p(y);try{await f.initialize();const o=await d(f);return await f.flush(),o}finally{f.dispose(),await this.f(y)}}b(u){const d=new Map,y=f=>{for(const o of u.keys(0,f))d.set(o,{value:u.get(o,0),target:f})};return y(0),y(1),d}c(u,d,y){u.storeAll(Array.from(d.entries()).map(([f,o])=>({key:f,value:o,scope:0,target:y})),!0)}async f(u){try{await u.close()}finally{(0,j.$dc)(u)&&u.dispose()}}};e.$1zb=$,e.$1zb=$=ye([Y(0,A.$To)],$);class C extends ${constructor(u,d,y,f){super(y),this.j=u;const o=u.getChannel("profileStorageListener"),h=this.B(new j.$kc);this.h=this.B(new O.$ed({onWillAddFirstListener:()=>{h.value=o.listen("onDidChange")(b=>{f.trace("profile storage changes",b),this.h.fire({targetChanges:b.targetChanges.map(w=>(0,S.$Ek)(w,d.profilesHome.scheme)),valueChanges:b.valueChanges.map(w=>({...w,profile:(0,S.$Ek)(w.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>h.value=void 0})),this.onDidChange=this.h.event}async g(u){const d=this.j.getChannel("storage");return(0,A.$Wo)(u)?new R.$Vzb(d):new R.$Wzb(d,u)}}e.$2zb=C;class p extends A.$Vo{constructor(u){super({flushInterval:100}),this.s=this.B(new N.$Po(u))}O(){return this.s.init()}P(u){return u===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(re[252],oe([0,1,20,7,17,71,58]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;let R=class extends O.$2zb{constructor($,C,p,g){super($,C,p,g)}};e.$F7b=R,e.$F7b=R=ye([Y(0,A.$46b),Y(1,D.$Dk),Y(2,j.$To),Y(3,N.$4i)],R)}),define(re[39],oe([0,1,18,5,14,26,3,34,2,28,9,170,19,16,13,7,44,20,21,27,25,17]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TAb=e.$SAb=e.$RAb=e.$QAb=e.$PAb=e.$OAb=e.$NAb=void 0;function t(E){return!!(E&&E.ref!==void 0&&typeof E.ref=="string"&&E.ref!==""&&E.syncData!==void 0&&(E.syncData===null||c(E.syncData)))}e.$NAb=t;function c(E){return!!(E&&E.version!==void 0&&typeof E.version=="number"&&E.content!==void 0&&typeof E.content=="string"&&(Object.keys(E).length===2||Object.keys(E).length===3&&E.machineId!==void 0&&typeof E.machineId=="string"))}e.$OAb=c;function s(E,m){return`${(0,$.$af)(E)}${m.isDefault?"":` (${m.name})`}`}e.$PAb=s;let n=class extends S.$jc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(m,a,v,L,T,z,U,B,Q,J,x,H){super(),this.syncResource=m,this.collection=a,this.G=v,this.H=L,this.I=T,this.J=z,this.L=U,this.M=B,this.N=Q,this.O=J,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$ed),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$ed),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Dg(50)),this.w=this.B(new O.$ed),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=s(m.syncResource,m.profile),this.h=H.extUri,this.f=this.h.joinPath(L.userDataSyncHome,...(0,w.$mgb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.g=this.h.joinPath(this.f,w.$Hgb),this.y=(0,w.$ngb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,L,this.h),this.j=(0,f.$Zo)(L,v,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const m=await this.c;this.c=null;const a=await this.Y(m.remoteUserData,m.lastSyncUserData,!0,this.ob());this.S(a)}else{this.O.trace(`${this.D}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.ub(m):!0)&&this.w.fire()}}S(m){this.m!==m&&(this.m=m,this.n.fire(m))}async sync(m,a={}){await this.U(m,!0,this.ob(),a)}async preview(m,a,v={}){return this.U(m,!1,a,v)}async apply(m,a={}){try{this.F={...a};const v=await this.ab(m);return this.S(v),this.c}finally{this.F={}}}async U(m,a,v,L){try{if(this.F={...L},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let T="idle";try{const z=await this.getLastSyncUserData(),U=await this.X(m,z);return T=await this.Y(U,z,a,v),T==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(m){const a=this.kb(m);if(!a)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const v=await this.getLastSyncUserData(),L=await this.X(null,v),T=await this.W(L),z=await this.qb({ref:L.ref,syncData:a},v,T,this.ob(),A.CancellationToken.None),U=[];for(const B of z){const Q=await this.sb(B,B.remoteResource,void 0,A.CancellationToken.None),{remoteChange:J}=await this.sb(B,B.previewResource,B.remoteContent,A.CancellationToken.None);U.push([B,{...Q,remoteChange:J!==0?J:2}])}await this.tb(L,v,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(m){const a=await this.j;return!!m.syncData?.machineId&&m.syncData.machineId===a}async X(m,a){if(a){const v=m?m[this.resource]:void 0;if(a.ref===v||v===void 0&&a.syncData===null)return a}return this.getRemoteUserData(a)}async Y(m,a,v,L){if(m.syncData&&m.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new w.$ugb((0,p.localize)(0,null,this.resource,this.pb,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(m,a,v,L)}catch(T){if(T instanceof w.$ugb)switch(T.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(m,a,v,L);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),a=await this.getLastSyncUserData(),this.Y(m,a,v,L)}throw T}}async Z(m,a,v,L){try{const T=await this.W(m),z=!T&&a===null&&this.gb()!==void 0,U=v&&!z;this.c||(this.c=(0,N.$tg)(Q=>this.eb(m,a,T,U,L,Q)));let B=await this.c;if(v&&z){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Q of B.resourcePreviews)B=await this.accept(Q.remoteResource)||B}return this.cb(B.resourcePreviews),B.resourcePreviews.some(({mergeState:Q})=>Q==="conflict")?"hasConflicts":v?await this.ab(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(m){return await this.$(m,async a=>{const v=await this.rb(a,A.CancellationToken.None);await this.G.writeFile(a.previewResource,D.$Ed.fromString(v?.content||""));const L=v&&!v.hasConflicts?await this.sb(a,a.previewResource,void 0,A.CancellationToken.None):void 0;return a.acceptResult=L,a.mergeState=v.hasConflicts?"conflict":L?"accepted":"preview",a.localChange=L?L.localChange:v.localChange,a.remoteChange=L?L.remoteChange:v.remoteChange,a}),this.c}async accept(m,a){return await this.$(m,async v=>{const L=await this.sb(v,m,a,A.CancellationToken.None);return v.acceptResult=L,v.mergeState="accepted",v.localChange=L.localChange,v.remoteChange=L.remoteChange,v}),this.c}async discard(m){return await this.$(m,async a=>{const v=await this.rb(a,A.CancellationToken.None);return await this.G.writeFile(a.previewResource,D.$Ed.fromString(v.content||"")),a.acceptResult=void 0,a.mergeState="preview",a.localChange=v.localChange,a.remoteChange=v.remoteChange,a}),this.c}async $(m,a){if(!this.c)return;let v=await this.c;const L=v.resourcePreviews.findIndex(({localResource:T,remoteResource:z,previewResource:U})=>this.h.isEqual(T,m)||this.h.isEqual(z,m)||this.h.isEqual(U,m));L!==-1&&(this.c=(0,N.$tg)(async T=>{const z=[...v.resourcePreviews];return z[L]=await a(z[L]),{...v,resourcePreviews:z}}),v=await this.c,this.cb(v.resourcePreviews),v.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(m){if(!this.c)return"idle";const a=await this.c;return a.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":a.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.tb(a.remoteUserData,a.lastSyncUserData,a.resourcePreviews.map(v=>[v,v.acceptResult]),m),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(m){const a=m.filter(({mergeState:v})=>v==="conflict");(0,j.$sb)(this.s,a,(v,L)=>this.h.isEqual(v.previewResource,L.previewResource))||(this.s=a,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async db(m){const a=this.c?await this.c:null;if(a)for(const v of a.resourcePreviews){if(this.h.isEqual(v.acceptedResource,m))return v.acceptResult?v.acceptResult.content:null;if(this.h.isEqual(v.remoteResource,m))return v.remoteContent;if(this.h.isEqual(v.localResource,m))return v.localContent;if(this.h.isEqual(v.baseResource,m))return v.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(m){(0,d.$ik)(m)!==1&&this.O.error(m)}}async eb(m,a,v,L,T,z){const U=await this.qb(m,a,v,T,z),B=[];for(const Q of U){const J=Q.previewResource.with({scheme:w.$Ggb,authority:"accepted"});if(Q.localChange===0&&Q.remoteChange===0)B.push({...Q,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=L?await this.rb(Q,z):void 0;if(z.isCancellationRequested)break;await this.G.writeFile(Q.previewResource,D.$Ed.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Q,Q.previewResource,void 0,z):void 0;B.push({...Q,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Q.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Q.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:a,resourcePreviews:B,isLastSyncFromCurrentMachine:v}}async getLastSyncUserData(){let m=this.gb();if(m||(m=await this.jb()),!m)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const a=JSON.parse(m),v=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!a.version&&!!v&&a.version!==v,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${a.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;let L,T=1;for(;L===void 0&&T++<6;)try{const z=await this.hb();z&&(z.ref===a.ref?L=z.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(z){if(z instanceof d.$mk&&z.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(z instanceof w.$ugb)throw z;this.O.error(z,T)}}if(L===void 0)try{const z=await this.J.resolveResourceContent(this.resource,a.ref,this.collection,this.F);L=z===null?null:this.kb(z),await this.ib({ref:a.ref,syncData:L})}catch(z){if(z instanceof w.$ugb&&z.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw z}return L===void 0?null:{...a,syncData:L}}async fb(m,a={}){if(a.ref||a.version)throw new Error("Cannot have core properties as additional");const v=this.M.getResourceSyncStateVersion(this.resource),L={ref:m.ref,version:v,...a};this.I.store(this.z,JSON.stringify(L),-1,1),await this.ib(m)}gb(){return this.I.get(this.z,-1)}async hb(){const m=(await this.G.readFile(this.y)).value.toString();try{const a=m?JSON.parse(m):void 0;if(t(a))return a}catch(a){this.O.error(a)}}async ib(m){await this.G.writeFile(this.y,D.$Ed.fromString(JSON.stringify(m)))}async jb(){try{const m=await this.G.readFile(this.y),a=JSON.parse(m.value.toString());await this.G.del(this.y),a.ref&&a.content!==void 0?(this.I.store(this.z,JSON.stringify({...a,content:void 0}),-1,1),await this.ib({ref:a.ref,syncData:a.content===null?null:JSON.parse(a.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,a)}catch(m){m instanceof d.$mk&&m.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(m)}return this.I.get(this.z,-1)}async getRemoteUserData(m){const{ref:a,content:v}=await this.lb(m);let L=null;return v!==null&&(L=this.kb(v)),{ref:a,syncData:L}}kb(m){try{const a=JSON.parse(m);if(c(a))return a}catch(a){this.O.error(a)}throw new w.$ugb((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(m){const a=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.J.readResource(this.resource,a,this.collection,this.F)}async mb(m,a){const v=await this.j,L={version:this.pb,machineId:v,content:m};try{return a=await this.J.writeResource(this.resource,JSON.stringify(L),a,this.collection,this.F),{ref:a,syncData:L}}catch(T){throw T instanceof w.$ugb&&T.code==="TooLarge"&&(T=new w.$ugb(T.message,T.code,this.resource)),T}}async nb(m){const a={version:this.pb,content:m};return this.L.backup(this.syncResource.profile,this.resource,JSON.stringify(a))}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(w.$hgb)}};e.$QAb=n,e.$QAb=n=ye([Y(2,d.$5j),Y(3,u.$Hh),Y(4,o.$To),Y(5,w.$pgb),Y(6,w.$qgb),Y(7,w.$zgb),Y(8,h.$8k),Y(9,w.$Egb),Y(10,g.$7h),Y(11,b.$Bk)],n);let i=class extends n{constructor(m,a,v,L,T,z,U,B,Q,J,x,H,X){super(a,v,L,T,z,U,B,Q,J,x,H,X),this.r=m,this.B(this.G.watch(this.h.dirname(m))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(m,a,v){try{a?await this.G.writeFile(this.r,D.$Ed.fromString(m),v?void 0:a):await this.G.createFile(this.r,D.$Ed.fromString(m),{overwrite:v})}catch(L){throw L instanceof d.$mk&&L.fileOperationResult===1||L instanceof d.$mk&&L.fileOperationResult===3?new w.$ugb(L.message,"LocalPreconditionFailed"):L}}async xb(){try{await this.G.del(this.r)}catch(m){if(!(m instanceof d.$mk&&m.fileOperationResult===1))throw m}}yb(m){m.contains(this.r)&&this.Q()}};e.$RAb=i,e.$RAb=i=ye([Y(3,d.$5j),Y(4,u.$Hh),Y(5,o.$To),Y(6,w.$pgb),Y(7,w.$qgb),Y(8,w.$zgb),Y(9,h.$8k),Y(10,w.$Egb),Y(11,g.$7h),Y(12,b.$Bk)],i);let r=class extends i{constructor(m,a,v,L,T,z,U,B,Q,J,x,H,X,G){super(m,a,v,L,T,z,U,B,Q,J,x,X,G),this.zb=H,this.Bb=void 0}Ab(m,a){const v=[],L=(0,R.$Km)(m,v,{allowEmptyContent:!0,allowTrailingComma:!0});return v.length>0||!(0,C.$pf)(L)&&a!==Array.isArray(L)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$SAb=r,e.$SAb=r=ye([Y(3,d.$5j),Y(4,u.$Hh),Y(5,o.$To),Y(6,w.$pgb),Y(7,w.$qgb),Y(8,w.$zgb),Y(9,h.$8k),Y(10,w.$Egb),Y(11,w.$Dgb),Y(12,g.$7h),Y(13,b.$Bk)],r);let l=class{constructor(m,a,v,L,T,z,U){this.resource=m,this.g=a,this.h=v,this.j=L,this.k=T,this.l=z,this.d=U.extUri,this.f=(0,w.$ngb)(void 0,this.resource,v,this.d)}async initialize({ref:m,content:a}){if(!a){this.j.info("Remote content does not exist.",this.resource);return}const v=this.m(a);if(v)try{await this.o({ref:m,syncData:v})}catch(L){this.j.error(L)}}m(m){try{const a=JSON.parse(m);if(c(a))return a}catch(a){this.j.error(a)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(m,a={}){if(a.ref||a.version)throw new Error("Cannot have core properties as additional");const v={ref:m.ref,version:void 0,...a};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(v),-1,1),await this.k.writeFile(this.f,D.$Ed.fromString(JSON.stringify(m)))}};e.$TAb=l,e.$TAb=l=ye([Y(1,I.$Dk),Y(2,u.$Hh),Y(3,y.$4i),Y(4,d.$5j),Y(5,o.$To),Y(6,b.$Bk)],l)}),define(re[115],oe([0,1,5,26,8,3,41,2,28,19,16,114,29,33,80,45,13,4,70,7,20,21,27,17,39,232,111,25,58]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I,t,c,s,n,i,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v2b=e.$u2b=e.$t2b=e.$s2b=e.$r2b=void 0;async function E(z,U){const B=JSON.parse(z.content);if(z.version===1||z.version===2){const Q=(await U.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of B)z.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),z.version===2&&Q.every(x=>!(0,u.$oo)(x.identifier,J.identifier))&&(J.installed=!0)}return B}function m(z){return JSON.parse(z.content)}e.$r2b=m;function a(z,U){return z.sort((B,Q)=>!B.identifier.uuid&&Q.identifier.uuid?-1:B.identifier.uuid&&!Q.identifier.uuid?1:(0,S.$Ee)(B.identifier.id,Q.identifier.id)),U?(0,O.$pS)(z,{}):JSON.stringify(z)}e.$s2b=a;let v=class extends s.$QAb{constructor(U,B,Q,J,x,H,X,G,W,V,ee,ne,se,Z,q,k,P){super({syncResource:"extensions",profile:U},B,J,Q,x,H,X,ne,se,V,ee,q),this.Cb=G,this.Db=W,this.Eb=P,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Ggb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Ggb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Ggb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Ggb,authority:"accepted"}),this.Bb=this.Eb.createInstance(L),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,F=>F.some(({local:M})=>!!M)),A.Event.filter(this.Cb.onDidUninstallExtension,F=>!F.error),A.Event.filter(k.onDidChange,F=>F.valueChanges.some(({profile:M,changes:K})=>this.syncResource.profile.id===M.id&&K.some(_=>_.key===g.$2n))),Z.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,B){const Q=U.syncData?await E(U.syncData,this.Cb):null,J=B?.skippedExtensions??[],x=B?.builtinExtensions??null,H=B?.syncData?await E(B.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);Q?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:V}=(0,n.$q2b)(X,Q,H,J,G,x),ee={local:W,remote:V,content:this.Hb(X,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:V!==null?2:0},ne=this.Ob(X,!1);return[{skippedExtensions:J,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):ne,localResource:this.yb,localContent:ne,localExtensions:X,remoteResource:this.zb,remoteExtensions:Q,remoteContent:Q?this.Ob(Q,!1):null,previewResource:this.wb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.Ab}]}async ub(U){const B=U.syncData?await E(U.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,n.$q2b)(Q,B,B,U.skippedExtensions||[],J,U.builtinExtensions||[]);return x!==null}Hb(U,B,Q,J){const x=[...B,...Q],H=new Set,X=G=>{H.add(G.id.toLowerCase()),G.uuid&&H.add(G.uuid)};x.forEach(({identifier:G})=>X(G)),J.forEach(X);for(const G of U)H.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&H.has(G.identifier.uuid)||x.push(G);return this.Ob(x,!1)}async rb(U,B){return{...U.previewResult,hasConflicts:!1}}async sb(U,B,Q,J){if(this.h.isEqual(B,this.yb))return this.Kb(U);if(this.h.isEqual(B,this.zb))return this.Lb(U);if(this.h.isEqual(B,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Kb(U){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.Db.getIgnoredExtensions(B),J=(0,n.$q2b)(U.localExtensions,null,null,U.skippedExtensions,Q,U.builtinExtensions),{local:x,remote:H}=J;return{content:U.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(U){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Q=this.Db.getIgnoredExtensions(B),J=U.remoteContent?JSON.parse(U.remoteContent):null;if(J!==null){const x=(0,n.$q2b)(U.localExtensions,J,U.localExtensions,[],Q,U.builtinExtensions),{local:H,remote:X}=x;return{content:U.remoteContent,local:H,remote:X,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,B,Q,J){let{skippedExtensions:x,builtinExtensions:H,localExtensions:X}=Q[0][0];const{local:G,remote:W,localChange:V,remoteChange:ee}=Q[0][1];if(V===0&&ee===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),V!==0&&(await this.nb(JSON.stringify(X)),x=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const ne=JSON.stringify(W.all);U=await this.mb(ne,J?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(se=>se.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(se=>se.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(se=>se.identifier.id))}.`:""}`)}B?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(X,H),await this.fb(U,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ne=>ne.identifier.id))}.`:""}`))}Nb(U,B){const Q=new Set,J=[];for(const x of U)Q.add(x.identifier.id.toLowerCase()),x.installed||J.push(x.identifier);if(B)for(const x of B)Q.has(x.id.toLowerCase())||J.push(x);return J}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const B=await this.db(U);return B&&this.Ob(JSON.parse(B),!0)}return null}Ob(U,B){return a(U,B)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};e.$t2b=v,e.$t2b=v=ye([Y(2,C.$Hh),Y(3,f.$5j),Y(4,w.$To),Y(5,r.$pgb),Y(6,r.$qgb),Y(7,g.$1n),Y(8,i.$yBb),Y(9,r.$Egb),Y(10,$.$7h),Y(11,r.$zgb),Y(12,I.$8k),Y(13,d.$Qz),Y(14,t.$Bk),Y(15,l.$Zzb),Y(16,o.$zh)],v);let L=class{constructor(U,B,Q,J,x,H){this.a=U,this.b=B,this.c=Q,this.d=J,this.f=x,this.g=H}async getLocalExtensions(U){const B=await this.a.getInstalled(void 0,U.extensionsResource),Q=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(U,async(x,H)=>{const X=x.getDisabledExtensions();return B.map(G=>{const{identifier:W,isBuiltin:V,manifest:ee,preRelease:ne,pinned:se,isApplicationScoped:Z}=G,q={identifier:W,preRelease:ne,version:ee.version,pinned:!!se};Z&&!(0,y.$Xl)(ee)&&(q.isApplicationScoped=Z),X.some(k=>(0,u.$oo)(k,W))&&(q.disabled=!0),V||(q.installed=!0);try{const k=H.getKeysForSync({id:W.id,version:ee.version});if(k){const P=H.getExtensionState(G,!0)||{};q.state=Object.keys(P).reduce((F,M)=>(k.includes(M)&&(F[M]=P[M]),F),{})}}catch(k){this.g.info(`${(0,s.$PAb)("extensions",U)}: Error while parsing extension state`,(0,D.$8)(k))}return q})}),ignoredExtensions:Q}}async updateLocalExtensions(U,B,Q,J,x){const H=(0,s.$PAb)("extensions",x),X=[],G=new Map,W=[],V=[],ee=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||Q.length)&&await this.j(x,async(Z,q)=>{await j.Promises.settled([...U,...Q].map(async k=>{const P=ee.find(K=>(0,u.$oo)(K.identifier,k.identifier));if(P&&P.isBuiltin){k.state&&P.manifest.version===k.version&&this.h(k.state,P,P.manifest.version,q),Z.getDisabledExtensions().some(_=>(0,u.$oo)(_,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${H}: Disabling extension...`,k.identifier.id),await Z.disableExtension(k.identifier),this.g.info(`${H}: Disabled extension`,k.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,k.identifier.id),await Z.enableExtension(k.identifier),this.g.info(`${H}: Enabled extension`,k.identifier.id))),W.push(k.identifier);return}const F=k.pinned?k.version:void 0,M=(await this.c.getExtensions([{...k.identifier,version:F,preRelease:F?void 0:k.preRelease}],N.CancellationToken.None))[0];if(k.state&&(P?P.manifest.version===k.version:M)&&this.h(k.state,P||M,P?.manifest.version,q),M)try{Z.getDisabledExtensions().some(_=>(0,u.$oo)(_,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${H}: Disabling extension...`,k.identifier.id,M.version),await Z.disableExtension(M.identifier),this.g.info(`${H}: Disabled extension`,k.identifier.id,M.version)):(this.g.trace(`${H}: Enabling extension...`,k.identifier.id,M.version),await Z.enableExtension(M.identifier),this.g.info(`${H}: Enabled extension`,k.identifier.id,M.version))),(!P||P.preRelease!==k.preRelease||P.pinned!==k.pinned||F&&P.manifest.version!==F)&&(await this.a.canInstall(M)?(X.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:k.pinned&&!!k.version,installPreReleaseVersion:k.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:k.isApplicationScoped,context:{[g.$On]:!0,[g.$Pn]:!0}}}),G.set(M.identifier.id.toLowerCase(),k)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),V.push(k)))}catch(K){V.push(k),this.g.error(K),this.g.info(`${H}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else V.push(k),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}))}),B.length){const Z=ee.filter(({identifier:q,isBuiltin:k})=>!k&&B.some(P=>(0,u.$oo)(q,P)));await j.Promises.settled(Z.map(async q=>{this.g.trace(`${H}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,q.identifier.id),W.push(q.identifier)}))}const ne=await this.a.installGalleryExtensions(X);for(const{identifier:Z,local:q,error:k,source:P}of ne){const F=P;if(q)this.g.info(`${H}: Installed extension.`,Z.id,F.version),W.push(Z);else{const M=G.get(Z.id.toLowerCase());M&&(V.push(M),this.g.info(`${H}: Skipped synchronizing extension`,F.displayName||F.identifier.id)),k instanceof g.$Zn&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(k.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,F.displayName||F.identifier.id):k&&this.g.error(k)}}const se=[];for(const Z of J)W.some(q=>(0,u.$oo)(q,Z.identifier))||se.push(Z);for(const Z of V)se.some(q=>(0,u.$oo)(q.identifier,Z.identifier))||se.push(Z);return se}h(U,B,Q,J){const x=J.getExtensionState(B,!0)||{},H=Q?J.getKeysForSync({id:B.identifier.id,version:Q}):void 0;H?H.forEach(X=>{x[X]=U[X]}):Object.keys(U).forEach(X=>x[X]=U[X]),J.setExtensionState(B,x,!0)}async j(U,B){return this.b.withProfileScopedStorageService(U,async Q=>{const J=new R.$ic,x=this.f.createChild(new h.$yh([w.$To,Q])),H=J.add(x.createInstance(p.$lzb)),X=J.add(x.createInstance(d.$Rz));try{return await B(H,X)}finally{J.dispose()}})}};e.$u2b=L,e.$u2b=L=ye([Y(0,g.$1n),Y(1,l.$Zzb),Y(2,g.$Yn),Y(3,i.$yBb),Y(4,o.$zh),Y(5,r.$Egb)],L);let T=class extends s.$TAb{constructor(U,B,Q,J,x,H,X,G){super("extensions",J,x,H,Q,X,G),this.p=U,this.q=B}async t(U){return U.syncData?await E(U.syncData,this.p):null}u(U,B){const Q=[],J=[],x=[];for(const H of U){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const X=B.find(G=>(0,u.$oo)(G.identifier,H.identifier));X?(Q.push(X),H.disabled&&x.push(H.identifier)):H.installed&&(J.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Q,newExtensions:J,disabledExtensions:x,remoteExtensions:U}}};e.$v2b=T,e.$v2b=T=ye([Y(0,g.$1n),Y(1,i.$yBb),Y(2,f.$5j),Y(3,c.$Dk),Y(4,C.$Hh),Y(5,b.$4i),Y(6,w.$To),Y(7,t.$Bk)],T)}),define(re[116],oe([0,1,14,8,3,34,41,6,32,19,16,13,7,44,20,21,27,39,77,236,25,17,58,4]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZAb=e.$YAb=e.$XAb=e.$WAb=e.$VAb=void 0;const s="globalState.argv.",n=["locale"];function i(v,L){const T=v.storage?Object.keys(v.storage).sort():[],z={};return T.forEach(U=>z[U]=v.storage[U]),v.storage=z,L?(0,O.$pS)(v,{}):JSON.stringify(v)}e.$VAb=i;const r=1;let l=class extends o.$QAb{constructor(L,T,z,U,B,Q,J,x,H,X,G,W,V,ee){super({syncResource:"globalState",profile:L},T,U,x,W,B,Q,H,X,J,G,V),this.Bb=z,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:w.$Ggb,authority:"base"}),this.xb=this.vb.with({scheme:w.$Ggb,authority:"local"}),this.yb=this.vb.with({scheme:w.$Ggb,authority:"remote"}),this.zb=this.vb.with({scheme:w.$Ggb,authority:"accepted"}),this.Ab=ee.createInstance(E),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(D.Event.any(D.Event.filter(U.onDidFilesChange,ne=>ne.contains(this.H.argvResource)),D.Event.filter(z.onDidChange,ne=>!!(ne.targetChanges.some(se=>this.syncResource.profile.id===se.id)||ne.valueChanges.some(({profile:se,changes:Z})=>this.syncResource.profile.id===se.id&&Z.some(q=>q.target===0)))))(()=>this.Q()))}async qb(L,T,z){const U=L.syncData?JSON.parse(L.syncData.content):null;T=T===null&&z?L:T;const B=T&&T.syncData?JSON.parse(T.syncData.content):null,Q=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(B),{local:x,remote:H}=(0,b.$UAb)(Q.storage,U?U.storage:null,B?B.storage:null,J,this.O),X={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},G=i(Q,!1);return[{baseResource:this.wb,baseContent:B?i(B,!1):G,localResource:this.xb,localContent:G,localUserData:Q,remoteResource:this.yb,remoteContent:U?i(U,!1):null,previewResource:this.vb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(L){const T=L.syncData?JSON.parse(L.syncData.content):null;if(T===null)return!0;const z=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(T),{remote:B}=(0,b.$UAb)(z.storage,T.storage,T.storage,U,this.O);return B.all!==null}async rb(L,T){return{...L.previewResult,hasConflicts:!1}}async sb(L,T,z,U){if(this.h.isEqual(T,this.xb))return this.Gb(L);if(this.h.isEqual(T,this.yb))return this.Hb(L);if(this.h.isEqual(T,this.vb))return L.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(L){return{content:L.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(L.localUserData.storage),removed:[],updated:[],all:L.localUserData.storage},localChange:0,remoteChange:2}}async Hb(L){if(L.remoteContent!==null){const T=JSON.parse(L.remoteContent),{local:z,remote:U}=(0,b.$UAb)(L.localUserData.storage,T.storage,null,L.storageKeys,this.O);return{content:L.remoteContent,local:z,remote:U,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:L.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(L,T,z,U){const{localUserData:B}=z[0][0],{local:Q,remote:J,localChange:x,remoteChange:H}=z[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(B)),await this.Ab.writeLocalGlobalState(Q,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const X=JSON.stringify({storage:J.all});L=await this.mb(X,U?null:L.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}T?.ref!==L.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(L),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(L){if(this.h.isEqual(this.yb,L)||this.h.isEqual(this.wb,L)||this.h.isEqual(this.xb,L)||this.h.isEqual(this.zb,L)){const T=await this.db(L);return T&&i(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:L}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(L).length>1||L[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(L){const T=await this.Bb.readStorageData(this.syncResource.profile),z=[],U=[];for(const[J,x]of T)x.target===0?z.push(J):x.target===1&&U.push(J);const B=[...z,...U],Q=L?.storage?Object.keys(L.storage).filter(J=>!J.startsWith(s)&&!B.includes(J)&&T.get(J)!==void 0):[];if(!R.$o){const J=[...w.$lgb.map(x=>(0,w.$ygb)(x)),w.$xgb];Q.push(...J),U.push(...J)}return{user:z,machine:U,unregistered:Q}}};e.$WAb=l,e.$WAb=l=ye([Y(2,t.$Zzb),Y(3,p.$5j),Y(4,w.$pgb),Y(5,w.$qgb),Y(6,w.$Egb),Y(7,C.$Hh),Y(8,w.$zgb),Y(9,y.$8k),Y(10,$.$7h),Y(11,d.$To),Y(12,f.$Bk),Y(13,c.$zh)],l);let E=class{constructor(L,T,z,U){this.a=L,this.b=T,this.c=z,this.d=U}async getLocalGlobalState(L){const T={};if(L.isDefault){const U=await this.f(),B=(0,A.$Km)(U);for(const Q of n)B[Q]!==void 0&&(T[`${s}${Q}`]={version:1,value:B[Q]})}const z=await this.c.readStorageData(L);for(const[U,B]of z)B.value&&B.target===0&&(T[U]={version:1,value:B.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const L=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),L.value.toString()}catch(L){this.d.debug((0,N.$8)(L))}return"{}"}async writeLocalGlobalState({added:L,removed:T,updated:z},U){const B=(0,o.$PAb)("globalState",U),Q={},J=new Map,x=await this.c.readStorageData(U),H=(X,G)=>{for(const W of X){if(W.startsWith(s)){Q[W.substring(s.length)]=G?G[W].value:void 0;continue}if(G){const V=G[W];V.value!==x.get(W)?.value&&J.set(W,V.value)}else x.get(W)!==void 0&&J.set(W,void 0)}};if(H(Object.keys(L),L),H(Object.keys(z),z),H(T),Object.keys(Q).length){this.d.trace(`${B}: Updating locale...`);const X=await this.f();let G=X;for(const W of Object.keys(Q))G=(0,h.edit)(G,[W],Q[W],{});X!==G&&(this.d.trace(`${B}: Updating locale...`),await this.a.writeFile(this.b.argvResource,j.$Ed.fromString(G)),this.d.info(`${B}: Updated locale.`)),this.d.info(`${B}: Updated locale`)}J.size&&(this.d.trace(`${B}: Updating global state...`),await this.c.updateStorageData(U,J,0),this.d.info(`${B}: Updated global state`,[...J.keys()]))}};e.$XAb=E,e.$XAb=E=ye([Y(0,p.$5j),Y(1,C.$Hh),Y(2,t.$Zzb),Y(3,w.$Egb)],E);let m=class extends o.$TAb{constructor(L,T,z,U,B,Q){super("globalState",z,U,B,T,L,Q)}async o(L){const T=L.syncData?JSON.parse(L.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const z={},U={};for(const B of Object.keys(T.storage))B.startsWith(s)?z[B.substring(s.length)]=T.storage[B].value:this.l.get(B,0)===void 0&&(U[B]=T.storage[B].value);if(Object.keys(z).length){let B="{}";try{B=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Q of Object.keys(z))B=(0,h.edit)(B,[Q],z[Q],{});await this.k.writeFile(this.h.argvResource,j.$Ed.fromString(B))}if(Object.keys(U).length){const B=[];for(const Q of Object.keys(U))B.push({key:Q,value:U[Q],scope:0,target:0});this.l.storeAll(B,!0)}}};e.$YAb=m,e.$YAb=m=ye([Y(0,d.$To),Y(1,p.$5j),Y(2,I.$Dk),Y(3,C.$Hh),Y(4,w.$Egb),Y(5,f.$Bk)],m);let a=class{constructor(L,T,z,U,B){this.a=L,this.b=T,this.c=z,this.d=U,this.f=B}getSyncStoreType(L){return this.h(L)?.storage[w.$xgb]?.value}async sync(L){const T=(0,w.$tgb)((0,S.$3f)());try{return await this.g(L,T)}catch(z){if(z instanceof w.$ugb)switch(z.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(L,T)}throw z}}async g(L,T){const z=await this.a.readResource("globalState",null,void 0,T),U=this.h(z)||{storage:{}};U.storage[w.$xgb]={value:L,version:r};const B=await(0,u.$Zo)(this.c,this.d,this.b),Q={version:r,machineId:B,content:i(U,!1)};await this.a.writeResource("globalState",JSON.stringify(Q),z.ref,void 0,T)}h({content:L}){if(!L)return null;const T=JSON.parse(L);if((0,o.$OAb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$ZAb=a,e.$ZAb=a=ye([Y(1,d.$To),Y(2,C.$Hh),Y(3,p.$5j),Y(4,g.$4i)],a)}),define(re[117],oe([0,1,18,14,3,34,6,9,171,19,16,13,20,21,27,17,39,233,25]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z2b=e.$y2b=e.$x2b=void 0;function b(t,c,s){try{const n=JSON.parse(t);if(!c)return(0,R.$pf)(n.all)?null:n.all;switch(O.OS){case 2:return(0,R.$pf)(n.mac)?null:n.mac;case 3:return(0,R.$pf)(n.linux)?null:n.linux;case 1:return(0,R.$pf)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}e.$x2b=b;let w=class extends f.$SAb{constructor(c,s,n,i,r,l,E,m,a,v,L,T,z){super(c.keybindingsResource,{syncResource:"keybindings",profile:c},s,m,a,v,n,i,E,T,r,L,l,z),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:h.$Ggb,authority:"base"}),this.Gb=this.Eb.with({scheme:h.$Ggb,authority:"local"}),this.Hb=this.Eb.with({scheme:h.$Ggb,authority:"remote"}),this.Ib=this.Eb.with({scheme:h.$Ggb,authority:"accepted"}),this.B(D.Event.filter(l.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(c,s,n,i){const r=c.syncData?b(c.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;s=s===null&&n?c:s;const l=s?this.Ob(s):null,E=await this.vb(),m=await this.Cb();let a=null,v=!1,L=!1,T=!1;if(r){let B=E?E.value.toString():"[]";if(B=B||"[]",this.Ab(B,!0))throw new h.$ugb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!l||l!==B||l!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Q=await(0,o.$w2b)(B,r,l,m,this.zb);Q.hasChanges&&(a=Q.mergeContent,T=Q.hasConflicts,v=T||Q.mergeContent!==B,L=T||Q.mergeContent!==r)}}else E&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),a=E.value.toString(),L=!0);const z={content:T?l:a,localChange:v?E?2:1:0,remoteChange:L?2:0,hasConflicts:T},U=E?E.value.toString():null;return[{fileContent:E,baseResource:this.Fb,baseContent:l,localResource:this.Gb,localContent:U,localChange:z.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:z.remoteChange,previewResource:this.Eb,previewResult:z,acceptedResource:this.Ib}]}async ub(c){const s=this.Ob(c);if(s===null)return!0;const n=await this.vb(),i=n?n.value.toString():"",r=await this.Cb(),l=await(0,o.$w2b)(i||"[]",s,s,r,this.zb);return l.hasConflicts||l.mergeContent!==s}async rb(c,s){return c.previewResult}async sb(c,s,n,i){if(this.h.isEqual(s,this.Gb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(s,this.Hb))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(s,this.Eb))return n===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(c,s,n,i){const{fileContent:r}=n[0][0];let{content:l,localChange:E,remoteChange:m}=n[0][1];if(E===0&&m===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.Ab(l,!0)))throw new h.$ugb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(E!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(l||"[]",r,i),this.O.info(`${this.D}: Updated local keybindings`)),m!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const a=this.Pb(l||"[]",c.syncData?.content);c=await this.mb(a,i?null:c.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}s?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(c,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.vb();if(c){const s=(0,A.$Km)(c.value.toString());if((0,j.$Ib)(s))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.Hb,c)||this.h.isEqual(this.Fb,c)||this.h.isEqual(this.Gb,c)||this.h.isEqual(this.Ib,c)?this.db(c):null}Ob(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.Qb()?null:b(c.syncData.content,this.Qb(),this.O)}Pb(c,s){let n={};try{n=JSON.parse(s||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete n.all:n.all=c,O.OS){case 2:n.mac=c;break;case 3:n.linux=c;break;case 1:n.windows=c;break}return JSON.stringify(n)}Qb(){return!!this.P.getValue(h.$igb)}};e.$y2b=w,e.$y2b=w=ye([Y(2,h.$pgb),Y(3,h.$qgb),Y(4,h.$Egb),Y(5,$.$7h),Y(6,h.$zgb),Y(7,p.$5j),Y(8,C.$Hh),Y(9,g.$To),Y(10,h.$Dgb),Y(11,u.$8k),Y(12,d.$Bk)],w);let I=class extends f.$TAb{constructor(c,s,n,i,r,l){super("keybindings",s,n,i,c,r,l)}async o(c){const s=c.syncData?this.p(c.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Ed.fromString(s)),await this.n(c)}async i(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,A.$Km)(c.value.toString());return!(0,j.$Ib)(s)}catch(c){return c.fileOperationResult===1}}p(c){try{return b(c,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$z2b=I,e.$z2b=I=ye([Y(0,p.$5j),Y(1,y.$Dk),Y(2,C.$Hh),Y(3,h.$Egb),Y(4,g.$To),Y(5,d.$Bk)],I)}),define(re[118],oe([0,1,14,3,172,19,73,16,29,13,20,21,27,17,39,237,25]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C2b=e.$B2b=e.$A2b=void 0;function o(I){return I&&I.settings&&typeof I.settings=="string"&&Object.keys(I).length===1}function h(I){const t=JSON.parse(I);return o(t)?t:{settings:I}}e.$A2b=h;let b=class extends d.$SAb{constructor(t,c,s,n,i,r,l,E,m,a,v,L,T,z){super(t.settingsResource,{syncResource:"settings",profile:t},c,s,n,i,r,l,v,L,E,m,a,z),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:f.$Ggb,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.$Ggb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.$Ggb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.$Ggb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const c=await this.getLastSyncUserData(),s=await this.X(t,c),n=this.Lb(s),i=new O.$qn(f.$hgb);return n?.settings&&i.parse(n.settings),i.configurationModel.getValue(f.$hgb)||{}}async qb(t,c,s){const n=await this.vb(),i=await this.Cb(),r=this.Lb(t);c=c===null&&s?t:c;const l=c?this.Lb(c):null,E=await this.Pb();let m=null,a=!1,v=!1,L=!1;if(r){let B=n?n.value.toString().trim():"{}";B=B||"{}",this.Qb(B),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Q=(0,y.$Gzb)(B,r.settings,l?l.settings:null,E,[],i);m=Q.localContent||Q.remoteContent,a=Q.localContent!==null,v=Q.remoteContent!==null,L=Q.hasConflicts}else n&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),m=n.value.toString().trim()||"{}",this.Qb(m),v=!0);const T=n?n.value.toString():null,z=l?.settings??null,U={content:L?z:m,localChange:a?2:0,remoteChange:v?2:0,hasConflicts:L};return[{fileContent:n,baseResource:this.baseResource,baseContent:z,localResource:this.localResource,localContent:T,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(t){const c=this.Lb(t);if(c===null)return!0;const s=await this.vb(),n=s?s.value.toString().trim():"",i=await this.Pb(),r=await this.Cb();return(0,y.$Gzb)(n||"{}",c.settings,c.settings,i,[],r).remoteContent!==null}async rb(t,c){const s=await this.Cb(),n=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,y.$Fzb)(t.previewResult.content,"{}",n,s):null}}async sb(t,c,s,n){const i=await this.Cb(),r=await this.Pb();if(this.h.isEqual(c,this.localResource))return{content:t.fileContent?(0,y.$Fzb)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(c,this.remoteResource))return{content:t.remoteContent!==null?(0,y.$Fzb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(c,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,y.$Fzb)(s,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(t,c,s,n){const{fileContent:i}=s[0][0];let{content:r,localChange:l,remoteChange:E}=s[0][1];if(l===0&&E===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),l!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(r,i,n),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),E!==0){const m=await this.Cb(),a=this.Lb(t),v=await this.Pb(r);r=(0,y.$Fzb)(r,a?a.settings:"{}",v,m),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(r)),n?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}c?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,y.$Hzb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let c=await super.db(t);if(c){const s=await this.Cb(),n=await this.Pb();c=(0,y.$Fzb)(c,"{}",n,s)}return c}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return h(t)}catch(c){this.O.error(c)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const s=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,n=>n.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,n=>!n.error))(()=>{s.dispose(),this.Ob=void 0}))}const c=await this.Ob;return(0,y.$Dzb)(c,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new f.$ugb((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$B2b=b,e.$B2b=b=ye([Y(2,$.$5j),Y(3,R.$Hh),Y(4,C.$To),Y(5,f.$pgb),Y(6,f.$qgb),Y(7,f.$Egb),Y(8,f.$Dgb),Y(9,A.$7h),Y(10,f.$zgb),Y(11,p.$8k),Y(12,S.$1n),Y(13,g.$Bk)],b);let w=class extends d.$TAb{constructor(t,c,s,n,i,r){super("settings",c,s,n,t,i,r)}async o(t){const c=t.syncData?this.p(t.syncData.content):null;if(!c){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,j.$Ed.fromString(c.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$Hzb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return h(t)}catch(c){this.j.error(c)}return null}};e.$C2b=w,e.$C2b=w=ye([Y(0,$.$5j),Y(1,u.$Dk),Y(2,R.$Hh),Y(3,f.$Egb),Y(4,C.$To),Y(5,g.$Bk)],w)}),define(re[119],oe([0,1,14,3,30,19,16,13,20,21,27,17,39,234,25]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H2b=e.$G2b=e.$F2b=void 0;function y(h){return JSON.parse(h.content)}e.$F2b=y;let f=class extends g.$QAb{constructor(b,w,I,t,c,s,n,i,r,l,E,m){super({syncResource:"snippets",profile:b},w,t,I,c,s,n,l,E,i,r,m),this.pb=1,this.vb=b.snippetsHome,this.B(this.G.watch(I.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,a=>a.affects(this.vb))(()=>this.Q()))}async qb(b,w,I){const t=await this.Hb(),c=this.Gb(t),s=b.syncData?this.Fb(b.syncData):null;w=w===null&&I?b:w;const n=w&&w.syncData?this.Fb(w.syncData):null;s?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,u.$D2b)(c,s,n);return this.Bb(i,t,s||{},n||{})}async ub(b){const w=b.syncData?this.Fb(b.syncData):null;if(w===null)return!0;const I=await this.Hb(),t=this.Gb(I),c=(0,u.$D2b)(t,w,w);return Object.keys(c.remote.added).length>0||Object.keys(c.remote.updated).length>0||c.remote.removed.length>0||c.conflicts.length>0}async rb(b,w){return b.previewResult}async sb(b,w,I,t){if(this.h.isEqualOrParent(w,this.g.with({scheme:d.$Ggb,authority:"local"})))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:b.fileContent?b.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(w,this.g.with({scheme:d.$Ggb,authority:"remote"})))return{content:b.remoteContent,localChange:b.remoteContent!==null?b.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(w,this.g))return I===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:I,localChange:I===null?b.fileContent!==null?3:0:2,remoteChange:I===null?b.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(b,w,I,t){const c=I.map(([s,n])=>({...s,acceptResult:n}));c.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),c.some(({localChange:s})=>s!==0)&&(await this.Cb(c),await this.Db(c,t)),c.some(({remoteChange:s})=>s!==0)&&(b=await this.Eb(c,b,t)),w?.ref!==b.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(b),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:s}of c)try{await this.G.del(s)}catch{}}Bb(b,w,I,t){const c=new Map;for(const s of Object.keys(b.local.added)){const n={content:b.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"accepted"})})}for(const s of Object.keys(b.local.updated)){const n={content:b.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=w[s]?w[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"local"}),fileContent:w[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"accepted"})})}for(const s of b.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=w[s]?w[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"local"}),fileContent:w[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"accepted"})})}for(const s of Object.keys(b.remote.added)){const n={content:b.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=w[s]?w[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"local"}),fileContent:w[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"accepted"})})}for(const s of Object.keys(b.remote.updated)){const n={content:b.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=w[s]?w[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"local"}),fileContent:w[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"accepted"})})}for(const s of b.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"accepted"})})}for(const s of b.conflicts){const n={content:t[s]??null,hasConflicts:!0,localChange:w[s]?2:1,remoteChange:I[s]?2:1},i=w[s]?w[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"local"}),fileContent:w[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"accepted"})})}for(const s of Object.keys(w))if(!c.has(s)){const n={content:w[s]?w[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=w[s]?w[s].value.toString():null;c.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"local"}),fileContent:w[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$Ggb,authority:"accepted"})})}return[...c.values()]}async resolveContent(b){return this.h.isEqualOrParent(b,this.g.with({scheme:d.$Ggb,authority:"remote"}))||this.h.isEqualOrParent(b,this.g.with({scheme:d.$Ggb,authority:"local"}))||this.h.isEqualOrParent(b,this.g.with({scheme:d.$Ggb,authority:"base"}))||this.h.isEqualOrParent(b,this.g.with({scheme:d.$Ggb,authority:"accepted"}))?this.db(b):null}async hasLocalData(){try{const b=await this.Hb();if(Object.keys(b).length)return!0}catch{}return!1}async Cb(b){const w={};for(const I of b)I.fileContent&&(w[this.h.basename(I.localResource)]=I.fileContent);await this.nb(JSON.stringify(this.Gb(w)))}async Db(b,w){for(const{fileContent:I,acceptResult:t,localResource:c,remoteResource:s,localChange:n}of b)if(n!==0){const i=s?this.h.basename(s):this.h.basename(c),r=this.h.joinPath(this.vb,i);n===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):n===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,j.$Ed.fromString(t.content),{overwrite:w}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,j.$Ed.fromString(t.content),w?void 0:I),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(b,w,I){const t=w.syncData?this.Fb(w.syncData):{},c=(0,D.$Um)(t);for(const{acceptResult:s,localResource:n,remoteResource:i,remoteChange:r}of b)if(r!==0){const l=n?this.h.basename(n):this.h.basename(i);r===3?delete c[l]:c[l]=s.content}return(0,u.$E2b)(t,c)||(this.O.trace(`${this.D}: Updating remote snippets...`),w=await this.mb(JSON.stringify(c),I?null:w.ref),this.O.info(`${this.D}: Updated remote snippets`)),w}Fb(b){return y(b)}Gb(b){const w={};for(const I of Object.keys(b))w[I]=b[I].value.toString();return w}async Hb(){const b={};let w;try{w=await this.G.resolve(this.vb)}catch(I){if(I instanceof R.$mk&&I.fileOperationResult===1)return b;throw I}for(const I of w.children||[]){const t=I.resource,c=this.h.extname(t);if(c===".json"||c===".code-snippets"){const s=this.h.relativePath(this.vb,t),n=await this.G.readFile(t);b[s]=n}}return b}};e.$G2b=f,e.$G2b=f=ye([Y(2,O.$Hh),Y(3,R.$5j),Y(4,S.$To),Y(5,d.$pgb),Y(6,d.$qgb),Y(7,d.$Egb),Y(8,A.$7h),Y(9,d.$zgb),Y(10,$.$8k),Y(11,C.$Bk)],f);let o=class extends g.$TAb{constructor(b,w,I,t,c,s){super("snippets",w,I,t,b,c,s)}async o(b){const w=b.syncData?JSON.parse(b.syncData.content):null;if(!w){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(w)){const c=w[t];if(c){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(s,j.$Ed.fromString(c)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(b)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(b){return b.fileOperationResult===1}}};e.$H2b=o,e.$H2b=o=ye([Y(0,R.$5j),Y(1,p.$Dk),Y(2,O.$Hh),Y(3,d.$Egb),Y(4,S.$To),Y(5,C.$Bk)],o)}),define(re[120],oe([0,1,14,19,16,13,20,21,27,17,39,25]),function(te,e,j,N,D,A,O,R,S,$,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K2b=e.$J2b=e.$I2b=void 0;function g(f,o){try{return JSON.parse(f).tasks??null}catch(h){return o.error(h),null}}e.$I2b=g;let u=class extends C.$RAb{constructor(o,h,b,w,I,t,c,s,n,i,r,l){super(o.tasksResource,{syncResource:"tasks",profile:o},h,s,n,i,b,w,c,r,I,t,l),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:p.$Ggb,authority:"base"}),this.Cb=this.Ab.with({scheme:p.$Ggb,authority:"local"}),this.Db=this.Ab.with({scheme:p.$Ggb,authority:"remote"}),this.Eb=this.Ab.with({scheme:p.$Ggb,authority:"accepted"})}async qb(o,h,b,w){const I=o.syncData?g(o.syncData.content,this.O):null;h=h===null&&b?o:h;const t=h?.syncData?g(h.syncData.content,this.O):null,c=await this.vb();let s=null,n=!1,i=!1,r=!1;if(o.syncData){const m=c?c.value.toString():null;if(!t||t!==m||t!==I){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const a=y(m,I,t);s=a.content,r=a.hasConflicts,n=a.hasLocalChanged,i=a.hasRemoteChanged}}else c&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=c.value.toString(),i=!0);const l={content:r?t:s,localChange:n?c?2:1:0,remoteChange:i?2:0,hasConflicts:r},E=c?c.value.toString():null;return[{fileContent:c,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:E,localChange:l.localChange,remoteResource:this.Db,remoteContent:I,remoteChange:l.remoteChange,previewResource:this.Ab,previewResult:l,acceptedResource:this.Eb}]}async ub(o){const h=o?.syncData?g(o.syncData.content,this.O):null;if(h===null)return!0;const b=await this.vb(),w=b?b.value.toString():null,I=y(w,h,h);return I.hasLocalChanged||I.hasRemoteChanged}async rb(o,h){return o.previewResult}async sb(o,h,b,w){if(this.h.isEqual(h,this.Cb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(h,this.Db))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(h,this.Ab))return b===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:b,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async tb(o,h,b,w){const{fileContent:I}=b[0][0],{content:t,localChange:c,remoteChange:s}=b[0][1];if(c===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),c!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),I&&await this.nb(JSON.stringify(this.Kb(I.value.toString()))),t?await this.wb(t,I,w):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),s!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const n=JSON.stringify(this.Kb(t));o=await this.mb(n,w?null:o.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}h?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(o),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(o){return this.h.isEqual(this.Db,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Eb,o)?this.db(o):null}Kb(o){return o?{tasks:o}:{}}};e.$J2b=u,e.$J2b=u=ye([Y(2,p.$pgb),Y(3,p.$qgb),Y(4,p.$Egb),Y(5,N.$7h),Y(6,p.$zgb),Y(7,A.$5j),Y(8,D.$Hh),Y(9,O.$To),Y(10,R.$8k),Y(11,S.$Bk)],u);let d=class extends C.$TAb{constructor(o,h,b,w,I,t){super("tasks",h,b,w,o,I,t),this.c=this.g.defaultProfile.tasksResource}async o(o){const h=o.syncData?g(o.syncData.content,this.j):null;if(!h){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,j.$Ed.fromString(h)),await this.n(o)}async p(){return this.k.exists(this.c)}};e.$K2b=d,e.$K2b=d=ye([Y(0,A.$5j),Y(1,$.$Dk),Y(2,D.$Hh),Y(3,p.$Egb),Y(4,O.$To),Y(5,S.$Bk)],d);function y(f,o,h){if(f===null&&o===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===o)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const b=h!==f,w=h!==o;return!b&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:b&&!w?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!b?{content:o,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[121],oe([0,1,41,19,16,13,20,21,27,17,39,235,25]),function(te,e,j,N,D,A,O,R,S,$,C,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=e.$m4b=e.$l4b=void 0;let u=class extends C.$QAb{constructor(o,h,b,w,I,t,c,s,n,i,r,l,E){super({syncResource:"profiles",profile:o},h,w,I,t,c,s,r,l,n,i,E),this.vb=b,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.$Ggb,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.$Ggb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.$Ggb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.$Ggb,authority:"accepted"}),this.B(b.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const o=await this.getLastSyncUserData();return o?.syncData?y(o.syncData):null}async getRemoteSyncedProfiles(o){const h=await this.getLastSyncUserData(),b=await this.X(o,h);return b?.syncData?y(b.syncData):null}async qb(o,h,b){if(!this.vb.isEnabled())throw new g.$ugb("Cannot sync profiles because they are disabled","LocalError");const w=o.syncData?y(o.syncData):null,I=h?.syncData?y(h.syncData):null,t=this.Db(),{local:c,remote:s}=(0,p.$k4b)(t,w,I,[]),n={local:c,remote:s,content:I?this.Eb(I):null,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:s!==null?2:0},i=d(t,!1);return[{baseResource:this.baseResource,baseContent:I?this.Eb(I):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:w?this.Eb(w):null,remoteProfiles:w,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async ub(o){const h=o?.syncData?y(o.syncData):null,b=this.Db(),{remote:w}=(0,p.$k4b)(b,h,h,[]);return!!w?.added.length||!!w?.removed.length||!!w?.updated.length}async rb(o,h){return{...o.previewResult,hasConflicts:!1}}async sb(o,h,b,w){if(this.h.isEqual(h,this.localResource))return this.Ab(o);if(this.h.isEqual(h,this.remoteResource))return this.Bb(o);if(this.h.isEqual(h,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async Ab(o){const h=this.Db(),b=(0,p.$k4b)(h,null,null,[]),{local:w,remote:I}=b;return{content:o.localContent,local:w,remote:I,localChange:w.added.length>0||w.removed.length>0||w.updated.length>0?2:0,remoteChange:I!==null?2:0}}async Bb(o){const h=o.remoteContent?JSON.parse(o.remoteContent):null,b=[],w=[];for(const I of this.Db()){const t=h?.find(c=>c.id===I.id);t&&(b.push({id:I.id,name:I.name,collection:t.collection}),w.push(I))}if(h!==null){const I=(0,p.$k4b)(w,h,b,[]),{local:t,remote:c}=I;return{content:o.remoteContent,local:t,remote:c,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:c!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(o,h,b,w){const{local:I,remote:t,localChange:c,remoteChange:s}=b[0][1];c===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const n=b[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new g.$ugb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(c!==0){await this.nb(d(this.Db(),!1));const i=[];for(const r of I.added)i.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of I.removed)i.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of I.updated){const l=this.vb.profiles.find(E=>E.id===r.id);l?i.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(l,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(s!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],r=n.length+(t?.added.length??0)<=20;if(r)for(const l of t?.added||[]){const E=await this.J.createCollection(this.F);i.push(E),n.push({id:l.id,name:l.name,collection:E,shortName:l.shortName,useDefaultFlags:l.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const l of t?.removed||[])n.splice(n.findIndex(({id:E})=>l.id===E),1);for(const l of t?.updated||[]){const E=n.find(({id:m})=>l.id===m);E&&n.splice(n.indexOf(E),1,{...E,id:l.id,name:l.name,shortName:l.shortName,useDefaultFlags:l.useDefaultFlags})}try{o=await this.updateRemoteProfiles(n,w?null:o.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(l=>l.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(l=>l.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(l=>l.name))}.`:""}`)}catch(l){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const E of i)await this.J.deleteCollection(E,this.F)}throw l}for(const l of t?.removed||[])await this.J.deleteCollection(l.collection,this.F)}h?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(o),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(o,h){return this.mb(this.Eb(o),h)}async hasLocalData(){return this.Db().length>0}async resolveContent(o){if(this.h.isEqual(this.remoteResource,o)||this.h.isEqual(this.baseResource,o)||this.h.isEqual(this.localResource,o)||this.h.isEqual(this.acceptedResource,o)){const h=await this.db(o);return h&&(0,j.$pS)(JSON.parse(h),{})}return null}Db(){return this.vb.profiles.filter(o=>!o.isDefault&&!o.isTransient)}Eb(o){return JSON.stringify([...o].sort((h,b)=>h.name.localeCompare(b.name)))}};e.$l4b=u,e.$l4b=u=ye([Y(2,$.$Dk),Y(3,A.$5j),Y(4,D.$Hh),Y(5,O.$To),Y(6,g.$pgb),Y(7,g.$qgb),Y(8,g.$Egb),Y(9,N.$7h),Y(10,g.$zgb),Y(11,R.$8k),Y(12,S.$Bk)],u);function d(f,o){const h=[...f].sort((b,w)=>b.name.localeCompare(w.name)).map(b=>({id:b.id,name:b.name}));return o?(0,j.$pS)(h,{}):JSON.stringify(h)}e.$m4b=d;function y(f){return JSON.parse(f.content)}e.$n4b=y}),define(re[253],oe([0,1,5,14,62,2,22,19,16,13,17,25]),function(te,e,j,N,D,A,O,R,S,$,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j4b=void 0;let g=class extends A.$jc{constructor(d,y,f,o,h){super(),this.a=d,this.b=y,this.c=f,this.f=o,this.g=h,this.h()}async h(){for(const y of this.g.profiles)for(const f of p.$lgb)try{await this.m(this.j(y,f))}catch(o){this.f.error(o)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,$.$ik)(y)!==1&&this.f.error(y);return}if(d.children){for(const y of d.children)if(y.isDirectory&&!this.g.profiles.some(f=>f.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(f){this.f.error(f)}}}async getAllRefs(d,y){const f=this.j(d,y);try{const o=await this.b.resolve(f);if(o.children)return o.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.n(b)}))}catch(o){if((0,$.$ik)(o)!==1)throw o}return[]}async resolveContent(d,y,f){const o=this.j(d,y),h=(0,O.$hg)(o,f);try{return(await this.b.readFile(h)).value.toString()}catch(b){return this.f.error(b),null}}async backup(d,y,f){const o=this.j(d,y),h=(0,O.$hg)(o,`${(0,D.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(h,N.$Ed.fromString(f))}catch(b){this.f.error(b)}try{this.m(o)}catch{}}j(d,y){return(0,O.$hg)(this.a.userDataSyncHome,...d.isDefault?[y]:[d.id,y])}async m(d){try{try{if(!await this.b.exists(d))return}catch{return}const y=await this.b.resolve(d);if(y.children){const f=y.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort(),o=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let h=f.filter(w=>Date.now()-this.n(w)>o);const b=f.length-h.length;b<10&&(h=h.slice(10-b)),await j.Promises.settled(h.map(async w=>{this.f.info("Deleting from backup",w.resource.path),await this.b.del(w.resource)}))}}catch(y){this.f.error(y)}}n(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};e.$j4b=g,e.$j4b=g=ye([Y(0,S.$Hh),Y(1,$.$5j),Y(2,R.$7h),Y(3,p.$Egb),Y(4,C.$Dk)],g)}),define(re[254],oe([0,1,3,2,6,16,20,21,25]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=void 0;const $="sync.enable";let C=class extends N.$jc{constructor(g,u,d,y){super(),this.c=g,this.f=u,this.g=d,this.h=y,this.a=new j.$ed,this.onDidChangeEnablement=this.a.event,this.b=new j.$ed,this.onDidChangeResourceEnablement=this.b.event,this.B(g.onDidChangeValue(-1,void 0,this.B(new N.$ic))(f=>this.m(f)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean($,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.f.publicLog2($,{enabled:g}),this.c.store($,g,-1,1))}isResourceEnabled(g){return this.c.getBoolean((0,S.$ygb)(g),-1,!0)}setResourceEnablement(g,u){if(this.isResourceEnabled(g)!==u){const d=(0,S.$ygb)(g);this.j(d,u)}}getResourceSyncStateVersion(g){}j(g,u){this.c.store(g,u,-1,D.$o?0:1)}m(g){if($===g.key){this.a.fire(this.isEnabled());return}const u=S.$lgb.filter(d=>(0,S.$ygb)(d)===g.key)[0];if(u){this.b.fire([u,this.isResourceEnabled(u)]);return}}};e.$$3b=C,e.$$3b=C=ye([Y(0,O.$To),Y(1,R.$8k),Y(2,A.$Hh),Y(3,S.$ogb)],C)}),define(re[81],oe([0,1,3,2,6,28,176,16,13,4,24,44,20,25]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$kZb=e.$jZb=e.$iZb=void 0,e.$iZb=(0,$.$Ah)("IUserDataSyncMachinesService");const y="sync.currentMachineName",f="Safari",o="Chrome",h="Edge",b="Firefox",w="Android";function I(s){switch(s){case f:case o:case h:case b:case w:case(0,D.$h)(0):return!0}return!1}e.$jZb=I;function t(){return D.$F?f:D.$D?o:D.$G?h:D.$E?b:D.$H?w:(0,D.$h)(D.$o?0:D.$t)}let c=class extends N.$jc{static{d=this}static{this.a=1}static{this.b="machines"}constructor(n,i,r,l,E,m){super(),this.h=r,this.j=l,this.m=E,this.n=m,this.c=this.B(new j.$ed),this.onDidChange=this.c.event,this.g=null,this.f=(0,p.$Zo)(n,i,r)}async getMachines(n){const i=await this.f;return(await this.s(n)).machines.map(l=>({...l,isCurrent:l.id===i}))}async addCurrentMachine(n){const i=await this.f,r=await this.s(n);r.machines.some(({id:l})=>l===i)||(r.machines.push({id:i,name:this.r(r.machines),platform:t()}),await this.t(r))}async removeCurrentMachine(n){const i=await this.f,r=await this.s(n),l=r.machines.filter(({id:E})=>E!==i);l.length!==r.machines.length&&(r.machines=l,await this.t(r))}async renameMachine(n,i,r){const l=await this.s(r),E=l.machines.find(({id:m})=>m===n);if(E){E.name=i,await this.t(l);const m=await this.f;n===m&&this.h.store(y,i,-1,1)}}async setEnablements(n){const i=await this.s();for(const[r,l]of n){const E=i.machines.find(m=>m.id===r);E&&(E.disabled=l?void 0:!0)}await this.t(i)}r(n){const i=this.h.get(y,-1);if(i)return i;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,l=new RegExp(`${(0,A.$pe)(r)}\\s#(\\d+)`);let E=0;for(const m of n){const a=l.exec(m.name),v=a?parseInt(a[1]):0;E=v>E?v:E}return`${r} #${E+1}`}async s(n){this.g=await this.u(n);const i=this.w(this.g);if(i.version!==d.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return i}async t(n){const i=JSON.stringify(n),r=await this.j.writeResource(d.b,i,this.g?.ref||null);this.g={ref:r,content:i},this.c.fire()}async u(n){if(this.g){const i=n&&n.latest?n.latest[d.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(d.b,this.g)}w(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(i){this.m.error(i)}return{version:d.a,machines:[]}}};e.$kZb=c,e.$kZb=c=d=ye([Y(0,R.$Hh),Y(1,S.$5j),Y(2,g.$To),Y(3,u.$pgb),Y(4,u.$Egb),Y(5,C.$jj)],c)}),define(re[255],oe([0,1,5,62,38,8,3,2,6,22,11,173,24,20,21,25,78,81]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p4b=void 0;const h="sync.disableMachineEventually",b="sync.sessionId",w="sync.storeUrl",I="sync.productQuality";let t=class extends R.$jc{get n(){const n=this.H.get(w,-1);return n?C.URI.parse(n):void 0}set n(n){n?this.H.store(w,n.toString(),-1,1):this.H.remove(w,-1)}get s(){return this.H.get(I,-1)}set s(n){n?this.H.store(I,n,-1,1):this.H.remove(I,-1)}constructor(n,i,r,l,E,m,a,v,L,T){super(),this.u=i,this.w=r,this.y=l,this.z=E,this.C=m,this.D=a,this.F=v,this.G=L,this.H=T,this.a=this.B(new R.$kc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$ed),this.onError=this.h.event,this.S=[],this.f=this.B(new j.$Dg(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=n.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,$.$ag)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(a.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(E.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:n,message:i}=this.L();n?this.a.value===void 0&&(this.a.value=new c(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$6l)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(n,i,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(b,-1),n?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(l){if(this.C.error(l),i)this.M(!1);else throw l}}M(n){this.y.isEnabled()!==n&&(this.y.setEnablement(n),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(n){if(!n){this.b=0;return}const i=y.$ugb.toUserDataSyncError(n);i instanceof y.$wgb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?S.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(h,!0,-1,1),await(0,j.$Gg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(h,-1,!1)}R(){this.H.remove(h,-1)}async triggerSync(n,i,r){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...n),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const l=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:l}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$p4b=t,e.$p4b=t=ye([Y(0,g.$jj),Y(1,y.$ogb),Y(2,y.$pgb),Y(3,y.$zgb),Y(4,y.$Agb),Y(5,y.$Egb),Y(6,f.$nzb),Y(7,d.$8k),Y(8,o.$iZb),Y(9,u.$To)],t);class c extends R.$jc{static{this.a="Interval"}constructor(n,i,r,l,E,m,a,v,L){super(),this.m=n,this.n=i,this.r=r,this.s=l,this.u=E,this.w=m,this.y=a,this.z=v,this.C=L,this.b=this.B(new R.$kc),this.c=this.B(new O.$ed),this.onDidStartSync=this.c.event,this.f=this.B(new O.$ed),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$hc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(c.a,!1)}D(){this.b.value=(0,j.$Hg)(()=>this.sync(c.a,!1),this.n)}sync(n,i){const r=(0,j.$tg)(async l=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(E){if((0,A.$2)(E))return}return this.H(n,i,l)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,$.$ag)(this.m,this.r.userDataSyncStore?.url)}async G(){const n=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!n&&(!(0,$.$ag)(i.defaultUrl,n.defaultUrl)||!(0,$.$ag)(i.insidersUrl,n.insidersUrl)||!(0,$.$ag)(i.stableUrl,n.stableUrl))}async H(n,i,r){this.y.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let l;try{await this.I(i,r)}catch(E){if(this.y.error(E),l=E,y.$ugb.toUserDataSyncError(E).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,r),l=void 0}catch(m){this.y.error(m),l=m}}this.f.fire(l)}async I(n,i){if(this.h=await this.u.createSyncTask(this.g,n),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$wgb((0,p.localize)(0,null),"DefaultServiceChanged"):new y.$wgb((0,p.localize)(1,null),"ServiceChanged"):new y.$wgb((0,p.localize)(2,null),"TurnedOff");const r=this.C.get(b,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$wgb((0,p.localize)(3,null),"DefaultServiceChanged"):new y.$wgb((0,p.localize)(4,null),"ServiceChanged"):new y.$wgb((0,p.localize)(5,null),"SessionExpired");const l=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const E=l.find(a=>a.isCurrent);if(E?.disabled)throw new y.$wgb((0,p.localize)(6,null),"TurnedOff");const m=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-m}),this.g===null)try{this.g=await this.s.manifest(null)}catch(a){throw new y.$wgb((0,D.$li)(a),a instanceof y.$ugb?a.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(b,this.g.session,-1,1),!i.isCancellationRequested&&(E||await this.w.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}}),define(re[256],oe([0,1,11,177,16,13,44,20,27,25,17,39,119,118,117,19,120,115,116,4,121,41]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$14b=void 0;let c=class{static{t=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,i,r,l,E,m,a,v,L,T){this.e=n,this.f=i,this.g=r,this.h=E,this.i=m,this.j=a,this.k=v,this.l=L,this.m=T,this.d=l.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource("profiles",null,void 0);if(n.content){const i=this.K(n.content,"profiles");return(0,w.$n4b)(i)}return[]}async getRemoteSyncResourceHandles(n,i){return(await this.e.getAllResourceRefs(n,i?.collection)).map(({created:l,ref:E})=>({created:l,uri:this.I({remote:!0,syncResource:n,profile:i?.id??this.k.defaultProfile.id,collection:i?.collection,ref:E,node:void 0})}))}async getLocalSyncResourceHandles(n,i){return(await this.f.getAllRefs(i,n)).map(({created:l,ref:E})=>({created:l,uri:this.I({remote:!1,syncResource:n,profile:i.id,collection:void 0,ref:E,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const i=this.J(n),r=i?this.k.profiles.find(l=>l.id===i.profile):void 0;return i&&r?{profile:r,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:n}){const i=this.J(n);if(!i)return[];const r=this.k.profiles.find(l=>l.id===i.profile);switch(i.syncResource){case"settings":return this.r(n,r);case"keybindings":return this.t(n,r);case"tasks":return this.v(n,r);case"snippets":return this.x(n,r);case"globalState":return this.C(n,r);case"extensions":return this.z(n,r);case"profiles":return this.F(n,r);case"workspaceState":return[]}}async getMachineId({uri:n}){const i=this.J(n);if(i){if(i.remote){if(i.ref){const{content:r}=await this.L(i.syncResource,i.ref,i.collection);if(r)return this.K(r,i.syncResource)?.machineId}return}return(0,O.$Zo)(this.h,this.j,this.i)}}async resolveContent(n){const i=this.J(n);if(!i||i.node===t.a)return null;if(i.ref){const r=await this.n(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&r?this.o(i.syncResource,r,i.node):r}return!i.remote&&!i.node?this.q(i.syncResource,i.profile):null}async n(n,i,r,l,E){if(n){const{content:a}=await this.L(i,E,l);return a}const m=this.k.profiles.find(a=>a.id===r);return m?this.f.resolveContent(m,i,E):null}o(n,i,r){const l=this.K(i,n);switch(n){case"settings":return this.s(l,r);case"keybindings":return this.u(l,r);case"tasks":return this.w(l,r);case"snippets":return this.y(l,r);case"globalState":return this.D(l,r);case"extensions":return this.A(l,r);case"profiles":return this.G(l,r);case"workspaceState":return null}}async q(n,i){const r=this.k.profiles.find(l=>l.id===i);if(!r)return null;switch(n){case"globalState":return this.E(r);case"extensions":return this.B(r);case"profiles":return this.H(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}r(n,i){const r=this.d.joinPath(n,"settings.json"),l=i?i.settingsResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:l}]}s(n,i){switch(i){case"settings.json":return(0,u.$A2b)(n.content).settings}return null}t(n,i){const r=this.d.joinPath(n,"keybindings.json"),l=i?i.keybindingsResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:l}]}u(n,i){switch(i){case"keybindings.json":return(0,d.$x2b)(n.content,!!this.l.getValue($.$igb),this.g)}return null}v(n,i){const r=this.d.joinPath(n,"tasks.json"),l=i?i.tasksResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:l}]}w(n,i){switch(i){case"tasks.json":return(0,f.$I2b)(n.content,this.g)}return null}async x(n,i){const r=await this.resolveContent(n);if(r){const l=this.K(r,"snippets");if(l){const E=(0,g.$F2b)(l),m=[];for(const a of Object.keys(E)){const v=this.d.joinPath(n,a),L=i?this.d.joinPath(i.snippetsHome,a):this.d.joinPath(n,t.a);m.push({resource:v,comparableResource:L})}return m}}return[]}y(n,i){return(0,g.$F2b)(n)[i]||null}z(n,i){const r=this.d.joinPath(n,"extensions.json"),l=i?this.I({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:r,comparableResource:l}]}A(n,i){switch(i){case"extensions.json":return(0,o.$s2b)((0,o.$r2b)(n),!0)}return null}async B(n){const{localExtensions:i}=await this.m.createInstance(o.$u2b).getLocalExtensions(n);return(0,o.$s2b)(i,!0)}C(n,i){const r=this.d.joinPath(n,"globalState.json"),l=i?this.I({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:r,comparableResource:l}]}D(n,i){switch(i){case"globalState.json":return(0,h.$VAb)(JSON.parse(n.content),!0)}return null}async E(n){const i=await this.m.createInstance(h.$XAb).getLocalGlobalState(n);return(0,h.$VAb)(i,!0)}F(n,i){const r=this.d.joinPath(n,"profiles.json"),l=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:l}]}G(n,i){switch(i){case"profiles.json":return(0,I.$pS)(JSON.parse(n.content),{})}return null}async H(n){return(0,w.$m4b)(this.k.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}I(n){const i=n.remote?t.b:t.c,r=[n.syncResource,n.profile];return n.collection&&r.push(`collection:${n.collection}`),n.ref&&r.push(`ref:${n.ref}`),n.node&&r.push(n.node),this.d.joinPath(j.URI.from({scheme:$.$Ggb,authority:i,path:"/"}),...r)}J(n){if(n.scheme!==$.$Ggb||n.authority!==t.c&&n.authority!==t.b)return;const i=[];for(;n.path!=="/";)i.unshift(this.d.basename(n)),n=this.d.dirname(n);if(i.length<2)return;const r=n.authority===t.b,l=i.shift(),E=i.shift();let m,a,v;for(;i.length;){const L=i.shift();L.startsWith("collection:")?m=L.substring(11):L.startsWith("ref:")?a=L.substring(4):v=L}return{remote:r,syncResource:l,profile:E,collection:m,ref:a,node:v}}K(n,i){try{const r=JSON.parse(n);if((0,p.$OAb)(r))return r}catch(r){this.g.error(r)}throw new $.$ugb((0,N.localize)(0,null),"IncompatibleRemoteContent",i)}async L(n,i,r){const l=await this.e.resolveResourceContent(n,i,r);return{ref:i,content:l}}};e.$14b=c,e.$14b=c=t=ye([Y(0,$.$pgb),Y(1,$.$qgb),Y(2,$.$Egb),Y(3,S.$Bk),Y(4,D.$Hh),Y(5,R.$To),Y(6,A.$5j),Y(7,C.$Dk),Y(8,y.$7h),Y(9,b.$zh)],c)}),define(re[257],oe([0,1,18,5,26,38,3,2,22,9,32,19,29,4,20,21,17,115,116,117,118,119,120,121,25]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I,t,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o4b=void 0;const n="sync.lastSyncTime";let i=class extends R.$jc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(a,v,L,T,z,U,B,Q,J){super(),this.C=a,this.D=v,this.F=L,this.G=T,this.H=z,this.I=U,this.J=B,this.L=Q,this.M=J,this.f="uninitialized",this.g=this.B(new O.$ed),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$ed),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$ed),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$ed),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$ed),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$ed),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$ed),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=v.userDataSyncStore?"idle":"uninitialized",this.t=this.I.getNumber(n,-1,void 0),this.B((0,R.$hc)(()=>this.$()))}async createSyncTask(a,v){this.ab(),this.G.info("Sync started.");const L=new Date().getTime(),T=(0,C.$3f)();try{const Q=(0,s.$tgb)(T);v&&(Q["Cache-Control"]="no-cache"),a=await this.C.manifest(a,Q)}catch(Q){const J=s.$ugb.toUserDataSyncError(Q);throw E(J,T,this.D,this.H),J}const z=!1,U=this;let B;return{manifest:a,async run(){if(z)throw new Error("Can run a task only once");B=(0,N.$tg)(Q=>U.N(a,!1,T,Q)),await B.finally(()=>B=void 0),U.G.info(`Sync done. Took ${new Date().getTime()-L}ms`),U.Y()},stop(){return B?.cancel(),U.R()}}}async createManualSyncTask(){if(this.ab(),this.J.isEnabled())throw new s.$ugb("Cannot start manual sync when sync is enabled","LocalError");this.G.info("Sync started.");const a=new Date().getTime(),v=(0,C.$3f)(),L=(0,s.$tgb)(v);let T;try{T=await this.C.manifest(null,L)}catch(B){const Q=s.$ugb.toUserDataSyncError(B);throw E(Q,v,this.D,this.H),Q}await this.resetLocal();const z=this,U=new D.$od;return{id:v,async merge(){return z.N(T,!0,v,U.token)},async apply(){try{try{await z.P(T,v,U.token)}catch(B){if(s.$ugb.toUserDataSyncError(B).code==="MethodNotFound")z.G.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.G.info("Applying manual sync again..."),await z.P(T,v,U.token);else throw B}}catch(B){throw z.G.error(B),B}z.G.info(`Sync done. Took ${new Date().getTime()-a}ms`),z.Y()},async stop(){U.cancel(),await z.R(),await z.resetLocal()}}}async N(a,v,L,T){this.n=[];try{this.status!=="hasConflicts"&&this.W("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.L.defaultProfile,void 0);this.n.push(...await this.Q(z,a,v,L,T));const U=z.enabled.find(B=>B.resource==="profiles");if(U){const B=await U.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.O(B,a,v,L,T)}}finally{this.r.fire(this.n)}}async O(a,v,L,T,z){for(const U of a){if(z.isCancellationRequested)return;const B=this.L.profiles.find(J=>J.id===U.id);if(!B){this.G.error(`Profile with id:${U.id} and name: ${U.name} does not exist locally to sync.`);continue}this.G.info("Syncing profile.",U.name);const Q=this.getOrCreateActiveProfileSynchronizer(B,U);this.n.push(...await this.Q(Q,v,L,T,z))}for(const[U,B]of this.z.entries())this.L.profiles.some(Q=>Q.id===B[0].profile.id)||(B[1].dispose(),this.z.delete(U))}async P(a,v,L){const T=this.Z();for(const J of T){if(L.isCancellationRequested)return;await J.apply(v,L)}const z=T.find(J=>J.profile.isDefault);if(!z)return;const U=z.enabled.find(J=>J.resource==="profiles");if(!U)return;const Q=(await U.getRemoteSyncedProfiles(a?.latest??null)||[]).filter(J=>T.every(x=>x.profile.id!==J.id));Q.length&&await this.O(Q,a,!1,v,L)}async Q(a,v,L,T,z){return(await a.sync(v,L,T,z)).map(([B,Q])=>({profile:a.profile,syncResource:B,error:Q}))}async R(){this.status!=="idle"&&await Promise.allSettled(this.Z().map(a=>a.stop()))}async resolveContent(a){const v=await this.M.resolveContent(a);if(v)return v;for(const L of this.Z())for(const T of L.enabled){const z=await T.resolveContent(a);if(z)return z}return null}async replace(a){this.ab();const v=this.M.resolveUserDataSyncResource(a);if(!v)return;const L=await this.resolveContent(a.uri);L&&await this.S(v.profile,async T=>{if(v.syncResource===T.resource)return await T.replace(L),!0})}async accept(a,v,L,T){this.ab(),await this.S(a.profile,async z=>{if(a.syncResource===z.resource)return await z.accept(v,L),T&&await z.apply((0,$.$of)(T)?!1:T.force,(0,s.$tgb)((0,C.$3f)())),!0})}getRemoteProfiles(){return this.M.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(a,v){return this.M.getRemoteSyncResourceHandles(a,v)}async getLocalSyncResourceHandles(a,v){return this.M.getLocalSyncResourceHandles(a,v??this.L.defaultProfile)}async getAssociatedResources(a){return this.M.getAssociatedResources(a)}async getMachineId(a){return this.M.getMachineId(a)}async hasLocalData(){return!!await this.S(this.L.defaultProfile,async v=>{if(v.resource!=="globalState"&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.S(this.L.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.ab(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.ab();try{await this.C.clear(),this.G.info("Cleared data on server")}catch(a){this.G.error(a)}this.y.fire()}async resetLocal(){this.ab(),this.t=void 0,this.I.remove(n,-1);for(const[a]of this.z.values())try{await a.resetLocal()}catch(v){this.G.error(v)}this.$(),this.w.fire(),this.G.info("Did reset the local sync state.")}async cleanUpRemoteData(){const a=await this.M.getRemoteSyncedProfiles(),v=a.map(U=>U.collection),L=await this.C.getAllCollections(),T=L.filter(U=>!v.includes(U));T.length&&(this.G.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(U=>this.C.deleteCollection(U))),this.G.info("Deleted redundant collections on server"));const z=a.filter(U=>L.includes(U.collection));if(z.length!==a.length){const U=this.F.createInstance(c.$l4b,this.L.defaultProfile,void 0);try{this.G.info("Resetting the last synced state of profiles"),await U.resetLocal(),this.G.info("Did reset the last synced state of profiles"),this.G.info("Updating remote profiles with invalid collections on server"),await U.updateRemoteProfiles(z,null),this.G.info("Updated remote profiles on server")}finally{U.dispose()}}}async S(a,v){const L=new R.$ic;try{const T=this.z.get(a.id);if(T){const J=await this.U(T[0],v,L);return(0,$.$pf)(J)?null:J}if(a.isDefault){const J=L.add(this.F.createInstance(r,a,void 0)),x=await this.U(J,v,L);return(0,$.$pf)(x)?null:x}if(this.L.isEnabled())return null;const z=L.add(this.F.createInstance(c.$l4b,a,void 0)),U=await this.C.manifest(null),Q=(await z.getRemoteSyncedProfiles(U?.latest??null)||[]).find(J=>J.id===a.id);if(Q){const J=L.add(this.F.createInstance(r,a,Q.collection)),x=await this.U(J,v,L);return(0,$.$pf)(x)?null:x}return null}finally{L.dispose()}}async U(a,v,L){const T=[...a.enabled,...a.disabled.reduce((z,U)=>(U!=="workspaceState"&&z.push(L.add(a.createSynchronizer(U))),z),[])];for(const z of T){const U=await v(z);if(!(0,$.$pf)(U))return U}}W(a){const v=this.f;this.f!==a&&(this.f=a,this.g.fire(a),v==="hasConflicts"&&this.Y())}X(){const a=this.Z().map(v=>v.conflicts).flat();(0,j.$sb)(this.j,a,(v,L)=>v.profile.id===L.profile.id&&v.syncResource===L.syncResource&&(0,j.$sb)(v.conflicts,L.conflicts,(T,z)=>(0,S.$ag)(T.previewResource,z.previewResource)))||(this.j=a,this.m.fire(a))}Y(){this.status==="idle"&&(this.t=new Date().getTime(),this.I.store(n,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(a,v){let L=this.z.get(a.id);if(L&&L[0].collection!==v?.collection&&(this.G.error("Profile synchronizer collection does not match with the remote sync profile collection"),L[1].dispose(),L=void 0,this.z.delete(a.id)),!L){const T=new R.$ic,z=T.add(this.F.createInstance(r,a,v?.collection));T.add(z.onDidChangeStatus(U=>this.W(U))),T.add(z.onDidChangeConflicts(U=>this.X())),T.add(z.onDidChangeLocal(U=>this.h.fire(U))),this.z.set(a.id,L=[z,T])}return L[0]}Z(){const a=[];for(const[v]of this.z.values())a.push(v);return a}$(){this.z.forEach(([,a])=>a.dispose()),this.z.clear()}ab(){if(!this.D.userDataSyncStore)throw new Error("Not enabled")}};e.$o4b=i,e.$o4b=i=ye([Y(0,s.$pgb),Y(1,s.$ogb),Y(2,u.$zh),Y(3,s.$Egb),Y(4,y.$8k),Y(5,d.$To),Y(6,s.$zgb),Y(7,f.$Dk),Y(8,s.$Bgb)],i);let r=class extends R.$jc{get enabled(){return this.f.sort((a,v)=>a[1]-v[1]).map(([a])=>a)}get disabled(){return s.$lgb.filter(a=>!this.r.isResourceEnabled(a))}get status(){return this.g}get conflicts(){return this.m}constructor(a,v,L,T,z,U,B,Q,J,x){super(),this.profile=a,this.collection=v,this.r=L,this.t=T,this.u=z,this.w=U,this.y=B,this.z=Q,this.C=J,this.D=x,this.f=[],this.g="idle",this.h=this.B(new O.$ed),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$ed),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$ed),this.onDidChangeConflicts=this.n.event,this.B(L.onDidChangeResourceEnablement(([H,X])=>this.F(H,X))),this.B((0,R.$hc)(()=>this.f.splice(0,this.f.length).forEach(([,,H])=>H.dispose())));for(const H of s.$lgb)L.isResourceEnabled(H)&&this.G(H)}F(a,v){v?this.G(a):this.H(a)}G(a){if(this.f.some(([z])=>z.resource===a))return;if(a==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(a==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||a==="workspaceState")return;if(a!=="profiles"&&this.profile.useDefaultFlags?.[a]){this.z.debug(`Skipping syncing ${a} in ${this.profile.name} because it is already synced by default profile`);return}const v=new R.$ic,L=v.add(this.createSynchronizer(a));v.add(L.onDidChangeStatus(()=>this.L())),v.add(L.onDidChangeConflicts(()=>this.M())),v.add(L.onDidChangeLocal(()=>this.j.fire(a)));const T=this.N(a);this.f.push([L,T,v])}H(a){const v=this.f.findIndex(([L])=>L.resource===a);if(v!==-1){const[[L,,T]]=this.f.splice(v,1);T.dispose(),this.L(),Promise.allSettled([L.stop(),L.resetLocal()]).then(null,z=>this.z.error(z))}}createSynchronizer(a){switch(a){case"settings":return this.t.createInstance(w.$B2b,this.profile,this.collection);case"keybindings":return this.t.createInstance(b.$y2b,this.profile,this.collection);case"snippets":return this.t.createInstance(I.$G2b,this.profile,this.collection);case"tasks":return this.t.createInstance(t.$J2b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$WAb,this.profile,this.collection);case"extensions":return this.t.createInstance(o.$t2b,this.profile,this.collection);case"profiles":return this.t.createInstance(c.$l4b,this.profile,this.collection)}}async sync(a,v,L,T){if(T.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const U=[],B=(0,s.$tgb)(L),Q=(this.collection?a?.collections?.[this.collection]?.latest:a?.latest)??null,J=v?await this.I(Q):{};for(const x of z){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(x.resource))return[];try{if(v){const H=await x.preview(Q,J,B);if(H)for(const X of H.resourcePreviews)(X.localChange!==0||X.remoteChange!==0)&&X.mergeState==="preview"&&await x.merge(X.previewResource)}else await x.sync(Q,B)}catch(H){const X=s.$ugb.toUserDataSyncError(H);if(E(X,L,this.w,this.y),l(H))throw X;this.z.error(H),this.z.error(`${x.resource}: ${(0,A.$li)(H)}`),U.push([x.resource,X])}}return U}finally{this.L()}}async apply(a,v){const L=(0,s.$tgb)(a);for(const T of this.enabled){if(v.isCancellationRequested)return;try{await T.apply(!1,L)}catch(z){const U=s.$ugb.toUserDataSyncError(z);if(E(U,a,this.w,this.y),l(z))throw U;this.z.error(z),this.z.error(`${T.resource}: ${(0,A.$li)(z)}`)}}}async stop(){for(const a of this.enabled)try{a.status!=="idle"&&await a.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const a of this.enabled)try{await a.resetLocal()}catch(v){this.z.error(`${a.resource}: ${(0,A.$li)(v)}`),this.z.error(v)}}async I(a){if(!this.profile.isDefault)return{};const v=this.D.getValue(s.$hgb),L=this.enabled.find(T=>T instanceof w.$B2b);if(L){const T=await L.getRemoteUserDataSyncConfiguration(a);return{...v,...T}}return v}J(a){this.g!==a&&(this.g=a,this.h.fire(a))}L(){return this.M(),this.enabled.some(a=>a.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(a=>a.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const a=this.enabled.filter(v=>v.status==="hasConflicts").filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,j.$sb)(this.m,a,(v,L)=>v.syncResource===L.syncResource&&(0,j.$sb)(v.conflicts,L.conflicts,(T,z)=>(0,S.$ag)(T.previewResource,z.previewResource)))||(this.m=a,this.n.fire(a))}N(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};r=ye([Y(2,s.$zgb),Y(3,u.$zh),Y(4,g.$Yn),Y(5,s.$ogb),Y(6,y.$8k),Y(7,s.$Egb),Y(8,f.$Dk),Y(9,p.$7h)],r);function l(m){if(m instanceof s.$ugb)switch(m.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function E(m,a,v,L){L.publicLog2("sync/error",{code:m.code,serverCode:m instanceof s.$vgb?String(m.serverCode):void 0,url:m instanceof s.$vgb?m.url:void 0,resource:m.resource,executionId:a,service:v.userDataSyncStore.url.toString()})}}),define(re[258],oe([0,1,3,2,11,17,25]),function(te,e,j,N,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=e.$D7b=void 0;function R(g,u){return{...g,profile:(0,A.$Ek)(g.profile,u.profilesHome.scheme)}}function S(g){return{created:g.created,uri:D.URI.revive(g.uri)}}class ${constructor(u,d,y){this.c=u,this.d=d,this.f=y,this.a=new Map,this.b=new j.$ed}listen(u,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(u,d,y){try{return await this.g(u,d,y)}catch(f){throw this.f.error(f),f}}async g(u,d,y){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),D.URI.revive(y[1]),y[2],y[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(y[0],y[1]?(0,A.$Ek)(y[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(y[0],y[1]);case"replace":return this.c.replace(S(y[0]));case"getAssociatedResources":return this.c.getAssociatedResources(S(y[0]));case"getMachineId":return this.c.getMachineId(S(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const f=d.substring(11),o=y[0],h=this.h(o);switch(y=y.slice(1),f){case"merge":return h.merge();case"apply":return h.apply().then(()=>this.a.delete(this.j(h.id)));case"stop":return h.stop().finally(()=>this.a.delete(this.j(h.id)))}}throw new Error("Invalid call")}h(u){const d=this.a.get(this.j(u));if(!d)throw new Error(`Manual sync taks not found: ${u}`);return d}async i(){const u=await this.c.createManualSyncTask();return this.a.set(this.j(u.id),u),u.id}j(u){return`manualSyncTask-${u}`}}e.$D7b=$;let C=class extends N.$jc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(u,d){super(),this.n=d,this.b="uninitialized",this.c=this.B(new j.$ed),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new j.$ed),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new j.$ed),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new j.$ed),this.onSyncErrors=this.m.event,this.a={call(y,f,o){return u.call(y,f,o).then(null,h=>{throw O.$ugb.toUserDataSyncError(h)})},listen(y,f){return u.listen(y,f)}},this.a.call("_getInitialData").then(([y,f,o])=>{this.s(y),this.t(f),o&&this.u(o),this.B(this.a.listen("onDidChangeStatus")(h=>this.s(h))),this.B(this.a.listen("onDidChangeLastSyncTime")(h=>this.u(h)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(f=>({...f,error:O.$ugb.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const u=await this.a.call("createManualSyncTask"),d=this;return new p(u,{async call(f,o,h){return d.a.call(`manualSync/${f}`,[u,...Array.isArray(o)?o:[o]],h)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(u,d,y,f){return this.a.call("accept",[u,d,y,f])}resolveContent(u){return this.a.call("resolveContent",[u])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(u,d){return(await this.a.call("getLocalSyncResourceHandles",[u,d])).map(({created:f,uri:o})=>({created:f,uri:D.URI.revive(o)}))}async getRemoteSyncResourceHandles(u,d){return(await this.a.call("getRemoteSyncResourceHandles",[u,d])).map(({created:f,uri:o})=>({created:f,uri:D.URI.revive(o)}))}async getAssociatedResources(u){return(await this.a.call("getAssociatedResources",[u])).map(({resource:y,comparableResource:f})=>({resource:D.URI.revive(y),comparableResource:D.URI.revive(f)}))}getMachineId(u){return this.a.call("getMachineId",[u])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(u){return this.a.call("replace",[u])}async s(u){this.b=u,this.c.fire(u)}async t(u){this.f=u.map(d=>({syncResource:d.syncResource,profile:(0,A.$Ek)(d.profile,this.n.profilesHome.scheme),conflicts:d.conflicts.map(y=>({...y,baseResource:D.URI.revive(y.baseResource),localResource:D.URI.revive(y.localResource),remoteResource:D.URI.revive(y.remoteResource),previewResource:D.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(u){this.h!==u&&(this.h=u,this.j.fire(u))}};e.$E7b=C,e.$E7b=C=ye([Y(1,A.$Dk)],C);class p extends N.$jc{constructor(u,d){super(),this.id=u,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[259],oe([0,1,5,26,8,3,2,141,6,22,9,11,32,19,16,13,24,57,44,20,25]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MAb=e.$LAb=e.$KAb=e.$JAb=e.$IAb=void 0;const I="configurationSync.store",t="sync.previous.store",c="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",i=100,r=1e3*60*5;let l=class extends O.$jc{get userDataSyncStore(){return this.b}get c(){return this.h.get(w.$xgb,-1)}set c(T){this.h.store(w.$xgb,T,-1,S.$o?0:1)}constructor(T,z,U){super(),this.f=T,this.g=z,this.h=U,this.a=this.B(new A.$ed),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const B=this.B(new O.$ic);this.B(A.Event.filter(U.onDidChangeValue(-1,w.$xgb,B),()=>this.c!==this.userDataSyncStore?.type,B)(()=>this.j()))}j(){this.b=this.m(this.f[I]),this.a.fire()}m(T){if(T&&(T=S.$o&&T.web?{...T,...T.web}:T,(0,C.$if)(T.url)&&(0,C.$kf)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(z=>Array.isArray(T.authenticationProviders[z].scopes)))){const z=T,U=!!z.canSwitch,B=z.url===z.insidersUrl?"insiders":"stable",Q=(U?this.c:void 0)||B,J=Q==="insiders"?z.insidersUrl:Q==="stable"?z.stableUrl:z.url;return{url:p.URI.parse(J),type:Q,defaultType:B,defaultUrl:p.URI.parse(z.url),stableUrl:p.URI.parse(z.stableUrl),insidersUrl:p.URI.parse(z.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(z.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:z.authenticationProviders[H].scopes}),x),[])}}}};e.$IAb=l,e.$IAb=l=ye([Y(0,f.$jj),Y(1,u.$7h),Y(2,b.$To)],l);let E=class extends l{constructor(T,z,U){super(T,z,U);const B=this.h.get(t,-1);B&&(this.n=JSON.parse(B));const Q=this.f[I];Q?this.h.store(t,JSON.stringify(Q),-1,1):this.h.remove(t,-1)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$JAb=E,e.$JAb=E=ye([Y(0,f.$jj),Y(1,u.$7h),Y(2,b.$To)],E);let m=class extends O.$jc{get donotMakeRequestsUntil(){return this.j}constructor(T,z,U,B,Q,J,x){super(),this.n=U,this.r=B,this.s=x,this.g=this.B(new A.$ed),this.onTokenFailed=this.g.event,this.h=this.B(new A.$ed),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$ed),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,h.$Zo)(Q,J,x).then(H=>{const X={"X-Client-Name":`${z.applicationName}${S.$o?"-web":""}`,"X-Client-Version":z.version};return z.commit&&(X["X-Client-Commit"]=z.commit),X}),this.f=new v(i,r,this.n,this.r),this.u(),this.B((0,O.$hc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,z){this.b={token:T,type:z}}t(T){this.a=T?(0,$.$hg)(T,"v1"):void 0}u(){const T=this.s.getNumber(c,-1);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(c,this.j.getTime(),-1,1),this.w=(0,j.$tg)(z=>(0,j.$Gg)(this.j.getTime()-Date.now(),z).then(()=>this.y(void 0))),this.w.then(null,z=>null)):this.s.remove(c,-1),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,$.$hg)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const U=await this.D(z,{type:"GET",headers:T},[],N.CancellationToken.None);return(await(0,o.$Mo)(U))?.map(({id:B})=>B)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,$.$hg)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.$Fr.text;const U=await this.D(z,{type:"POST",headers:T},[],N.CancellationToken.None),B=await(0,o.$Lo)(U);if(!B)throw new w.$vgb("Server did not return the collection id",z,"NoCollection",U.res.statusCode,U.res.headers[w.$rgb]);return B}async deleteCollection(T,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=T?(0,$.$hg)(this.a,"collection",T).toString():(0,$.$hg)(this.a,"collection").toString();z={...z},await this.D(U,{type:"DELETE",headers:z},[],N.CancellationToken.None)}async getAllResourceRefs(T,z){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,z,T),B={},Q=await this.D(U.toString(),{type:"GET",headers:B},[],N.CancellationToken.None);return(await(0,o.$Mo)(Q)||[]).map(({url:x,created:H})=>({ref:(0,$.$jg)(U,U.with({path:x})),created:H*1e3}))}async resolveResourceContent(T,z,U,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=(0,$.$hg)(this.z(this.a,U,T),z).toString();B={...B},B["Cache-Control"]="no-cache";const J=await this.D(Q,{type:"GET",headers:B},[],N.CancellationToken.None);return await(0,o.$Lo)(J)}async deleteResource(T,z,U){if(!this.a)throw new Error("No settings sync store url configured.");const B=z!==null?(0,$.$hg)(this.z(this.a,U,T),z).toString():this.z(this.a,U,T).toString(),Q={};await this.D(B,{type:"DELETE",headers:Q},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,$.$hg)(this.a,"resource").toString(),z={"Content-Type":R.$Fr.text};await this.D(T,{type:"DELETE",headers:z},[],N.CancellationToken.None)}async readResource(T,z,U,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=(0,$.$hg)(this.z(this.a,U,T),"latest").toString();B={...B},B["Cache-Control"]="no-cache",z&&(B["If-None-Match"]=z.ref);const J=await this.D(Q,{type:"GET",headers:B},[304],N.CancellationToken.None);let x=null;if(J.res.statusCode===304&&(x=z),x===null){const H=J.res.headers.etag;if(!H)throw new w.$vgb("Server did not return the ref",Q,"NoRef",J.res.statusCode,J.res.headers[w.$rgb]);const X=await(0,o.$Lo)(J);if(!X&&J.res.statusCode===304)throw new w.$vgb("Empty response",Q,"EmptyResponse",J.res.statusCode,J.res.headers[w.$rgb]);x={ref:H,content:X}}return x}async writeResource(T,z,U,B,Q={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,B,T).toString();Q={...Q},Q["Content-Type"]=R.$Fr.text,U&&(Q["If-Match"]=U);const x=await this.D(J,{type:"POST",data:z,headers:Q},[],N.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new w.$vgb("Server did not return the ref",J,"NoRef",x.res.statusCode,x.res.headers[w.$rgb]);return H}async manifest(T,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,$.$hg)(this.a,"manifest").toString();z={...z},z["Content-Type"]="application/json",T&&(z["If-None-Match"]=T.ref);const B=await this.D(U,{type:"GET",headers:z},[304],N.CancellationToken.None);let Q=null;if(B.res.statusCode===304&&(Q=T),!Q){const x=B.res.headers.etag;if(!x)throw new w.$vgb("Server did not return the ref",U,"NoRef",B.res.statusCode,B.res.headers[w.$rgb]);const H=await(0,o.$Lo)(B);if(!H&&B.res.statusCode===304)throw new w.$vgb("Empty response",U,"EmptyResponse",B.res.statusCode,B.res.headers[w.$rgb]);H&&(Q={...JSON.parse(H),ref:x})}const J=this.s.get(s,-1);return J&&Q&&J!==Q.session&&this.C(),Q===null&&J&&this.C(),Q&&this.s.store(s,Q.session,-1,1),Q}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}z(T,z,U){return z?(0,$.$hg)(T,"collection",z,"resource",U):(0,$.$hg)(T,"resource",U)}C(){this.s.remove(s,-1),this.s.remove(n,-1)}async D(T,z,U,B){if(!this.b)throw new w.$vgb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new w.$vgb(`${z.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Q=await this.c;z.headers={...z.headers||{},...Q,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(z.headers),this.r.trace("Sending request to server",{url:T,type:z.type,headers:{...z.headers,authorization:void 0}});let J;try{J=await this.f.request(T,z,B)}catch(W){if(!(W instanceof w.$vgb)){let V="RequestFailed";const ee=(0,D.$8)(W).toLowerCase();ee.includes("xhr timeout")?V="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?V="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":ee.includes("headers must be an object")?V="RequestHeadersNotObject":(0,D.$2)(W)&&(V="RequestCanceled"),W=new w.$vgb(`Connection refused for the request '${T}'.`,T,V,void 0,void 0)}throw this.r.info("Request failed",T),W}const x=J.res.headers[w.$rgb],H={url:T,status:J.res.statusCode,"execution-id":z.headers[w.$sgb],"operation-id":x},X=(0,o.$Jo)(J)||J.res.statusCode&&U.includes(J.res.statusCode);let G="";if(X?this.r.trace("Request succeeded",H):(G=await(0,o.$Ko)(J)||"",this.r.info("Request failed",H,G)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new w.$vgb(`${z.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",J.res.statusCode,x);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new w.$vgb(`${z.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",J.res.statusCode,x)}if(this.h.fire(),J.res.statusCode===404)throw new w.$vgb(`${z.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",J.res.statusCode,x);if(J.res.statusCode===405)throw new w.$vgb(`${z.type} request '${T}' failed because the requested endpoint is not found (405). ${G}`,T,"MethodNotFound",J.res.statusCode,x);if(J.res.statusCode===409)throw new w.$vgb(`${z.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",J.res.statusCode,x);if(J.res.statusCode===410)throw new w.$vgb(`${z.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",J.res.statusCode,x);if(J.res.statusCode===412)throw new w.$vgb(`${z.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",J.res.statusCode,x);if(J.res.statusCode===413)throw new w.$vgb(`${z.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",J.res.statusCode,x);if(J.res.statusCode===426)throw new w.$vgb(`${z.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",J.res.statusCode,x);if(J.res.statusCode===429){const W=J.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new w.$vgb(`${z.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",J.res.statusCode,x)):new w.$vgb(`${z.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",J.res.statusCode,x)}if(!X)throw new w.$vgb("Server returned "+J.res.statusCode,T,"Unknown",J.res.statusCode,x);return J}F(T){let z=this.s.get(n,-1);z===void 0&&(z=(0,g.$3f)(),this.s.store(n,z,-1,1)),T["X-Machine-Session-Id"]=z;const U=this.s.get(s,-1);U!==void 0&&(T["X-User-Session-Id"]=U)}};e.$KAb=m,e.$KAb=m=ye([Y(1,f.$jj),Y(2,o.$Ho),Y(3,w.$Egb),Y(4,d.$Hh),Y(5,y.$5j),Y(6,b.$To)],m);let a=class extends m{constructor(T,z,U,B,Q,J,x){super(T.userDataSyncStore?.url,z,U,B,Q,J,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$LAb=a,e.$LAb=a=ye([Y(0,w.$ogb),Y(1,f.$jj),Y(2,o.$Ho),Y(3,w.$Egb),Y(4,d.$Hh),Y(5,y.$5j),Y(6,b.$To)],a);class v{constructor(T,z,U,B){this.c=T,this.d=z,this.f=U,this.g=B,this.a=[],this.b=void 0}request(T,z,U){if(this.h()&&this.i(),z.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new w.$vgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(z,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$MAb=v}),define(re[260],oe([0,1,3,55,24,20,21,255,25,78,81]),function(te,e,j,N,D,A,O,R,S,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;let p=class extends R.$p4b{constructor(u,d,y,f,o,h,b,w,I,t,c){super(u,d,y,f,o,b,w,I,t,c),this.B(j.Event.debounce(j.Event.any(j.Event.map(h.onDidFocusWindow,()=>"windowFocus"),j.Event.map(h.onDidOpenWindow,()=>"windowOpen")),(s,n)=>s?[...s,n]:[n],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$Y7b=p,e.$Y7b=p=ye([Y(0,D.$jj),Y(1,S.$ogb),Y(2,S.$pgb),Y(3,S.$zgb),Y(4,S.$Agb),Y(5,N.$M5b),Y(6,S.$Egb),Y(7,$.$nzb),Y(8,O.$8k),Y(9,C.$iZb),Y(10,A.$To)],p)}),define(re[261],oe([0,1,69,23,6,22]),function(te,e,j,N,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o5b=e.$n5b=e.$m5b=e.$l5b=void 0,e.$l5b=128/4;function O($){function C(){let p=$.scheme===N.Schemas.file?(0,A.$8f)($):$.toString();return D.$k||(p=p.toLowerCase()),(0,j.createHash)("md5").update(p).digest("hex")}return{id:C(),configPath:$}}e.$m5b=O;function R($,C){function p(){if($.scheme!==N.Schemas.file)return(0,j.createHash)("md5").update($.toString()).digest("hex");if(!C)return;let u;return D.$k?u=C.ino:D.$j?u=C.birthtime.getTime():D.$i&&(typeof C.birthtimeMs=="number"?u=Math.floor(C.birthtimeMs):u=C.birthtime.getTime()),(0,j.createHash)("md5").update($.fsPath).update(u?String(u):"").digest("hex")}const g=p();if(typeof g=="string")return{id:g,uri:$}}e.$n5b=R;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$o5b=S}),define(re[262],oe([0,1,5,8,2,15,31,16,7,75,113,261,55,71,23]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=void 0;let y=class extends D.$jc{constructor(o,h,b,w){super(),this.a=o,this.b=h,this.c=b,this.f=w,this.B(new j.$Rg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const o=this.a.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,h=await O.Promises.readdir(o),b=new $.$Yzb(this.f.getChannel("storage"));await Promise.all(h.map(async w=>{const I=(0,A.$8d)(o,w);w.length===p.$l5b||w===C.$Mh.id||(await this.c.getWindows()).some(s=>s.workspace?.id===w)||await b.isUsed(I)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${w} as it seems to be an unused empty workspace.`),await O.Promises.rm(I))}))}catch(o){(0,N.$Y)(o)}}};e.$s7b=y,e.$s7b=y=ye([Y(0,R.$Ih),Y(1,S.$4i),Y(2,g.$M5b),Y(3,u.$46b)],y)}),define(re[82],oe([0,1,52,5,15,9,31,148,273,274]),function(te,e,j,N,D,A,O,R,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.zip=e.$_o=e.$$o=void 0,e.$$o="end of central directory record signature not found";const C=new RegExp(e.$$o);class p extends Error{constructor(c,s){let n=s.message;switch(c){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=c,this.cause=s}}e.$_o=p;function g(t){const c=t.externalFileAttributes>>16||33188;return[448,56,7].map(s=>c&s).reduce((s,n)=>s+n,c&61440)}function u(t){if(t instanceof p)return t;let c;return C.test(t.message)&&(c="CorruptZip"),new p(c,t)}function d(t,c,s,n,i,r){const l=D.$$d(c),E=D.$8d(n,l);if(!E.startsWith(n))return Promise.reject(new Error(R.localize(0,null,c)));const m=D.$8d(n,c);let a;return r.onCancellationRequested(()=>{a?.destroy()}),Promise.resolve(O.Promises.mkdir(E,{recursive:!0})).then(()=>new Promise((v,L)=>{if(!r.isCancellationRequested)try{a=(0,j.createWriteStream)(m,{mode:s}),a.once("close",()=>v()),a.once("error",L),t.once("error",L),t.pipe(a)}catch(T){L(T)}}))}function y(t,c,s,n){let i=(0,N.$tg)(()=>Promise.resolve()),r=0;const l=n.onCancellationRequested(()=>{i.cancel(),t.close()});return new Promise((E,m)=>{const a=new N.$Ag,v=L=>{L.isCancellationRequested||(r++,t.readEntry())};t.once("error",m),t.once("close",()=>i.then(()=>{n.isCancellationRequested||t.entryCount===r?E():m(new p("Incomplete",new Error(R.localize(1,null,r,t.entryCount))))},m)),t.readEntry(),t.on("entry",L=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(L.fileName)){v(n);return}const T=L.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(T)){const B=D.$8d(c,T);i=(0,N.$tg)(Q=>O.Promises.mkdir(B,{recursive:!0}).then(()=>v(Q)).then(void 0,m));return}const z=o(t,L),U=g(L);i=(0,N.$tg)(B=>a.queue(()=>z.then(Q=>d(Q,T,U,c,s,B).then(()=>v(B)))).then(null,m))})}).finally(()=>l.dispose())}function f(t,c=!1){return new Promise((s,n)=>{(0,S.open)(t,c?{lazyEntries:!0}:void 0,(i,r)=>{i?n(u(i)):s((0,A.$tf)(r))})})}function o(t,c){return new Promise((s,n)=>{t.openReadStream(c,(i,r)=>{i?n(u(i)):s((0,A.$tf)(r))})})}function h(t,c){return new Promise((s,n)=>{const i=new $.ZipFile;c.forEach(l=>{l.contents?i.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&i.addFile(l.localPath,l.path)}),i.end();const r=(0,j.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>s(t))})}e.zip=h;function b(t,c,s={},n){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=f(t,!0);return s.overwrite&&(r=r.then(l=>O.Promises.rm(c).then(()=>l))),r.then(l=>y(l,c,{sourcePathRegex:i},n))}e.$bp=b;function w(t,c){return f(t).then(s=>new Promise((n,i)=>{s.on("entry",r=>{r.fileName===c&&o(s,r).then(l=>n(l),l=>i(l))}),s.once("close",()=>i(new Error(R.localize(2,null,c))))}))}function I(t,c){return w(t,c).then(s=>new Promise((n,i)=>{const r=[];s.once("error",i),s.on("data",l=>r.push(l)),s.on("end",()=>n(Buffer.concat(r)))}))}e.$cp=I}),define(re[263],oe([0,1,5,8,2,23,22,53,9,32,31,82,19,16,29,33,97,13,7]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;let w=class extends D.$jc{static{b=this}static{this.c=".sigzip"}constructor(t,c,s,n,i,r){super(),this.h=c,this.j=s,this.m=n,this.n=i,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,c,s){await this.g;const n=(0,O.$hg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,n,r=>this.j.download(t,r,c))}catch(r){throw new d.$Zn(r.message,d.ExtensionManagementErrorCode.Download)}let i=!1;if(s&&this.t(t)){const r=await this.u(t);try{i=await this.n.verify(n.fsPath,r.fsPath,this.r.getLevel()===h.LogLevel.Trace)}catch(l){const E=l;if(i=E.code,E.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${E.output}`),i===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new d.$Zn(p.$$o,d.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return i===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:n,verificationStatus:i}}t(t){if(!t.isSigned)return!1;const c=this.m.getValue("extensions.verifySignature");return(0,S.$of)(c)?c:!0}async u(t){await this.g;const c=(0,O.$hg)(this.extensionsDownloadDir,`${this.z(t)}${b.c}`);return await this.w(t,c,s=>this.j.downloadSignatureArchive(t,s)),c}async w(t,c,s){if(await this.h.exists(c))return;if(c.scheme!==A.Schemas.file){await s(c);return}const n=(0,O.$hg)(this.extensionsDownloadDir,`.${(0,$.$3f)()}`);await this.h.exists(n)||await s(n);try{await C.Promises.rename(n.fsPath,c.fsPath,2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,c.path);else throw this.r.info(`Rename failed because of ${(0,N.$8)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const c=[],s=[],n=[];for(const l of t.children)if(l.name.endsWith(b.c))n.push(l.resource);else{const E=y.$po.parse(l.name);E&&s.push([E,l])}const i=(0,y.$uo)(s,([l])=>l),r=[];for(const l of i)l.sort((E,m)=>R.rcompare(E[0].version,m[0].version)),c.push(...l.slice(1).map(E=>E[1].resource)),r.push(l[0][1]);r.sort((l,E)=>l.mtime-E.mtime),c.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),c.push(...n),await j.Promises.settled(c.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.r.error(t)}}z(t){return this.f?y.$po.create(t).toString().toLowerCase():(0,$.$3f)()}};e.$rp=w,e.$rp=w=b=ye([Y(0,u.$Ih),Y(1,o.$5j),Y(2,d.$Yn),Y(3,g.$7h),Y(4,f.$5o),Y(5,h.$4i)],w)}),define(re[264],oe([0,1,82,157]),function(te,e,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;function D(A){return(0,j.$cp)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$tp=D}),define(re[122],oe([0,1,5,14,26,38,8,3,51,2,35,23,15,22,53,9,11,32,31,82,156,96,16,243,29,33,50,79,263,244,264,212,223,67,13,4,7,24,21,27,17]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I,t,c,s,n,i,r,l,E,m,a,v,L,T,z,U,B,Q,J,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$wp=(0,z.$Bh)(s.$1n);const H=".vsctmp";let X=class extends c.$dp{constructor(Z,q,k,P,F,M,K,_,ae,he,fe,le){super(Z,q,fe,k,he,le),this.fb=F,this.gb=M,this.hb=K,this.ib=ae,this.eb=new Map,this.rb=new C.$zi;const $e=this.B(_.createInstance(E.$sp));this.bb=this.B(_.createInstance(G,we=>$e.postUninstall(we))),this.cb=this.B(new a.$up(le,ae,fe,this,this.F)),this.db=this.B(_.createInstance(l.$rp));const de=this.B(new v.$vp(this,this.fb,le,M,fe,ae,k));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$zo)(this.ib,this.F)),this.jb}async zip(Z){this.F.trace("ExtensionManagementService#zip",Z.identifier.id);const q=await this.pb(Z),k=await(0,b.zip)((0,u.$hg)(this.db.extensionsDownloadDir,(0,o.$3f)()).fsPath,q);return f.URI.file(k)}async unzip(Z){return this.F.trace("ExtensionManagementService#unzip",Z.toString()),(await this.install(Z)).identifier}async getManifest(Z){const{location:q,cleanup:k}=await this.lb(Z),P=g.$9d(q.fsPath);try{return await(0,m.$tp)(P)}finally{await k()}}getInstalled(Z,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Z??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Z){return this.bb.scanUserExtensionAtLocation(Z)}async install(Z,q={}){this.F.trace("ExtensionManagementService#install",Z.toString());const{location:k,cleanup:P}=await this.lb(Z);try{const F=await(0,m.$tp)(g.$9d(k.fsPath)),M=(0,n.$to)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,L.$Go)(F.engines.vscode,this.G.version,this.G.date))throw new Error(w.localize(0,null,M,this.G.version));const _=(await this.I([{manifest:F,extension:k,options:q}])).find(({identifier:ae})=>(0,n.$oo)(ae,{id:M}));if(_?.local)return _.local;throw _?.error?_.error:(0,c.$fp)(new Error(`Unknown error while installing extension ${M}`))}finally{await P()}}async installFromLocation(Z,q){this.F.trace("ExtensionManagementService#installFromLocation",Z.toString());const k=await this.bb.scanUserExtensionAtLocation(Z);if(!k)throw new Error(`Cannot find a valid extension from the location ${Z.toString()}`);return await this.ub([[k,void 0]],q),this.F.info("Successfully installed extension",k.identifier.id,q.toString()),k}async installExtensionsFromProfile(Z,q,k){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Z,q.toString(),k.toString());const P=(await this.bb.scanExtensions(1,q)).filter(F=>Z.some(M=>(0,n.$oo)(M,F.identifier)));if(P.length){const F=await Promise.all(P.map(M=>this.bb.scanMetadata(M,q)));await this.ub(P.map((M,K)=>[M,F[K]]),k),this.F.info("Successfully installed extensions",P.map(M=>M.identifier.id),k.toString())}return P}async updateMetadata(Z,q,k=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Z.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.pinned=q.pinned||void 0,Z=await this.bb.updateMetadata(Z,q,k),this.cb.invalidate(k),this.w.fire(Z),Z}async reinstallFromGallery(Z){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Z.identifier.id),!this.z.isEnabled())throw new Error(w.localize(1,null));const q=await this.getTargetPlatform(),[k]=await this.z.getExtensions([{...Z.identifier,preRelease:Z.preRelease}],{targetPlatform:q,compatible:!0},D.CancellationToken.None);if(!k)throw new Error(w.localize(2,null));await this.bb.setUninstalled(Z);try{await this.bb.removeUninstalledExtension(Z)}catch(P){throw new Error(w.localize(3,null,(0,A.$li)(P)))}return this.installFromGallery(k)}ab(Z,q,k,P){return this.bb.copyExtension(Z,q,k,P)}copyExtensions(Z,q){return this.bb.copyExtensions(Z,q)}markAsUninstalled(...Z){return this.bb.setUninstalled(...Z)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Z){this.F.error(Z)}}async download(Z,q,k){const{location:P}=await this.db.download(Z,q,!k);return P}async lb(Z){if(Z.scheme===p.Schemas.file)return{location:Z,async cleanup(){}};this.F.trace("Downloading extension from",Z.toString());const q=(0,u.$hg)(this.db.extensionsDownloadDir,(0,o.$3f)());return await this.hb.download(Z,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(P){this.F.error(P)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Z,q,k){if(f.URI.isUri(q))return new ee(Z,q,k,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const P=n.$po.create(q).toString();let F=this.eb.get(P);return F||(this.eb.set(P,F=new V(Z,q,k,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),F.waitUntilTaskIsFinished().finally(()=>this.eb.delete(P))),F}$(Z,q){return new ne(Z,q.profileLocation,this.gb)}async pb(Z){const q=async P=>{let F=await h.Promises.readdir(P);F=F.map(_=>g.$8d(P,_));const M=await Promise.all(F.map(_=>h.Promises.stat(_)));let K=Promise.resolve([]);return M.forEach((_,ae)=>{const he=F[ae];_.isFile()&&(K=K.then(fe=>[...fe,he])),_.isDirectory()&&(K=K.then(fe=>q(he).then(le=>[...fe,...le])))}),K};return(await q(Z.location.fsPath)).map(P=>({path:`extension/${g.$0d(Z.location.fsPath,P)}`,localPath:P}))}async qb({added:Z,removed:q}){if(q)for(const k of q.extensions)this.F.info("Extensions removed from another source",k.id,q.profileLocation.toString()),this.u.fire({identifier:k,profileLocation:q.profileLocation});if(Z){const P=(await this.bb.scanExtensions(1,Z.profileLocation)).filter(F=>Z.extensions.some(M=>(0,n.$oo)(M,F.identifier)));this.s.fire(P.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,Z.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:Z.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const Z=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of Z.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(Z){if(!Z.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const k of Z.rawAdded){if(this.rb.has(k)||!this.D.extUri.isEqual(this.D.extUri.dirname(k),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(k,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(k).startsWith(".")||!(await this.ib.stat(k)).isDirectory)continue;const P=await this.bb.scanUserExtensionAtLocation(k);P&&P.installedTimestamp===void 0&&(this.rb.add(k),q.push(P))}q.length&&(await this.ub(q.map(k=>[k,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(k=>k.identifier.id)))}async ub(Z,q){const k=Z.map(P=>P[0]);await this.vb(k),await this.gb.addExtensionsToProfile(Z,q),this.s.fire(k.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:q})))}async vb(Z){const q=await this.bb.getUninstalledExtensions();for(const k of Z){const P=n.$po.create(k);q[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.bb.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$xp=X,e.$xp=X=ye([Y(0,s.$Yn),Y(1,Q.$8k),Y(2,U.$4i),Y(3,t.$Ih),Y(4,r.$mp),Y(5,i.$ip),Y(6,I.$Cn),Y(7,z.$zh),Y(8,T.$5j),Y(9,B.$jj),Y(10,J.$Bk),Y(11,x.$Dk)],X);let G=class extends $.$jc{constructor(Z,q,k,P,F,M){super(),this.j=Z,this.m=q,this.n=k,this.s=P,this.t=F,this.u=M,this.h=this.B(new R.$ed),this.onExtract=this.h.event,this.c=(0,u.$hg)(this.n.userExtensionsLocation,".obsolete"),this.g=new j.$Mg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Z,q){const k={includeInvalid:!0,profileLocation:q};let P=[];return Z===null||Z===0?P.push(...await this.n.scanAllExtensions({includeInvalid:!0},k,!1)):Z===1&&P.push(...await this.n.scanUserExtensions(k)),P=Z!==null?P.filter(F=>F.type===Z):P,Promise.all(P.map(F=>this.F(F)))}async scanAllUserExtensions(Z){const q=await this.n.scanUserExtensions({includeAllVersions:!Z,includeInvalid:!0});return Promise.all(q.map(k=>this.F(k)))}async scanUserExtensionAtLocation(Z){try{const q=await this.n.scanExistingExtension(Z,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(Z,q,k,P,F){const M=Z.toString(),K=f.URI.file(g.$8d(this.n.userExtensionsLocation.fsPath,`.${(0,o.$3f)()}`)),_=f.URI.file(g.$8d(this.n.userExtensionsLocation.fsPath,M));let ae=await this.m.exists(_);if(ae&&P){try{await this.y(Z.id,_,"removeExisting")}catch{throw new s.$Zn(w.localize(4,null,_.fsPath,Z.id),s.ExtensionManagementErrorCode.Delete)}ae=!1}if(!ae)try{try{this.u.trace(`Started extracting the extension from ${q} to ${_.fsPath}`),await(0,b.$bp)(q,K.fsPath,{sourcePath:"extension",overwrite:!0},F),this.u.info(`Extracted extension to ${_}:`,Z.id)}catch(he){let fe=s.ExtensionManagementErrorCode.Extract;throw he instanceof b.$_o&&(he.type==="CorruptZip"?fe=s.ExtensionManagementErrorCode.CorruptZip:he.type==="Incomplete"&&(fe=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$Zn(he.message,fe)}await this.n.updateMetadata(K,k);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${_.fsPath}`),await this.C(K.fsPath,_.fsPath),this.u.info("Renamed to",_.fsPath)}catch(he){if(he.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Z.id);else throw this.u.info(`Rename failed because of ${(0,O.$8)(he)}. Deleted from extracted location`,K),he}this.h.fire(_)}catch(he){try{await this.m.del(K,{recursive:!0})}catch{}throw he}return this.D(_,1)}async scanMetadata(Z,q){return q?(await this.w(Z,q))?.metadata:this.n.scanMetadata(Z.location)}async w(Z,q){return(await this.s.scanProfileExtensions(q)).find(P=>(0,n.$oo)(P.identifier,Z.identifier))}async updateMetadata(Z,q,k){return k?await this.s.updateMetadata([[Z,q]],k):await this.n.updateMetadata(Z.location,q),this.D(Z.location,Z.type,k)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Z){const q=Z.map(k=>n.$po.create(k));await this.z(k=>q.forEach(P=>{k[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(Z){await this.z(q=>delete q[Z.toString()])}async removeExtension(Z,q){if(this.t.extUri.isEqualOrParent(Z.location,this.n.userExtensionsLocation))return this.y(Z.identifier.id,Z.location,q)}async removeUninstalledExtension(Z){await this.removeExtension(Z,"uninstalled"),await this.z(q=>delete q[n.$po.create(Z).toString()])}async copyExtension(Z,q,k,P){const F=await this.w(Z,q),M=await this.w(Z,k);return P={...F?.metadata,...P},M?await this.s.updateMetadata([[Z,{...M.metadata,...P}]],k):await this.s.addExtensionsToProfile([[Z,P]],k),this.D(Z.location,Z.type,k)}async copyExtensions(Z,q){const k=await this.scanExtensions(1,Z),P=await Promise.all(k.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,Z)]));await this.s.addExtensionsToProfile(P,q)}async y(Z,q,k){this.u.trace(`Deleting ${k} extension from disk`,Z,q.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,S.$oi)((0,o.$3f)()).toString(16)}${H}`);await this.C(q.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${k} extension from disk`,Z,q.fsPath)}async z(Z){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,T.$ik)(P)!==1)throw P}let k={};if(q)try{k=JSON.parse(q)}catch{}return Z&&(Z(k),Object.keys(k).length?await this.m.writeFile(this.c,N.$Ed.fromString(JSON.stringify(k))):await this.m.del(this.c)),k})}async C(Z,q){try{await h.Promises.rename(Z,q,2*60*1e3)}catch(k){throw new s.$Zn(k.message||w.localize(5,null,Z,q),k.code||s.ExtensionManagementErrorCode.Rename)}}async D(Z,q,k){if(k){const F=(await this.n.scanUserExtensions({profileLocation:k})).find(M=>this.t.extUri.isEqual(M.location,Z));if(F)return this.F(F)}else{const P=await this.n.scanExistingExtension(Z,q,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(w.localize(6,null,Z.path))}async F(Z){const q=await this.m.resolve(Z.location);let k,P;return q.children&&(k=q.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,P=q.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:Z.identifier,type:Z.type,isBuiltin:Z.isBuiltin||!!Z.metadata?.isBuiltin,location:Z.location,manifest:Z.manifest,targetPlatform:Z.targetPlatform,validations:Z.validations,isValid:Z.isValid,readmeUrl:k,changelogUrl:P,publisherDisplayName:Z.metadata?.publisherDisplayName||null,publisherId:Z.metadata?.publisherId||null,isApplicationScoped:!!Z.metadata?.isApplicationScoped,isMachineScoped:!!Z.metadata?.isMachineScoped,isPreReleaseVersion:!!Z.metadata?.isPreReleaseVersion,preRelease:!!Z.metadata?.preRelease,installedTimestamp:Z.metadata?.installedTimestamp,updated:!!Z.metadata?.updated,pinned:!!Z.metadata?.pinned}}async G(){const Z=await this.getUninstalledExtensions();if(Object.keys(Z).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Z));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const F of q)Z[n.$po.create(F).toString()]||k.add(F.identifier.id.toLowerCase());try{const F=(0,n.$uo)(q,M=>M.identifier);await j.Promises.settled(F.map(async M=>{const K=M.sort((_,ae)=>d.rcompare(_.manifest.version,ae.manifest.version))[0];k.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(F){this.u.error(F)}const P=q.filter(F=>F.metadata&&Z[n.$po.create(F).toString()]);await Promise.allSettled(P.map(F=>this.removeUninstalledExtension(F)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Z;try{Z=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,T.$ik)(q)!==1&&this.u.error(q);return}if(Z?.children)try{await Promise.allSettled(Z.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(k){(0,T.$ik)(k)!==1&&this.u.error(k)}}}))}catch{}}};e.$yp=G,e.$yp=G=ye([Y(1,T.$5j),Y(2,r.$mp),Y(3,i.$ip),Y(4,J.$Bk),Y(5,U.$4i)],G);class W extends c.$gp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$pf)(this.options.operation)?this.l:this.options.operation}constructor(Z,q,k,P,F,M,K,_,ae){super(),this.identifier=Z,this.source=q,this.options=k,this.m=P,this.n=F,this.o=M,this.p=K,this.q=_,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Z){const[q,k]=await this.x(Z);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,k]],this.j),q}async u({zipPath:Z,key:q,metadata:k},P,F){let M=await this.v(q);return M||(this.s.trace("Extracting extension...",q.id),M=await this.m.extractUserExtension(q,Z,k,P,F),this.s.info("Extracting extension completed.",q.id)),M}async v(Z){return await this.w(Z)?(this.s.trace("Removing the extension from uninstalled list:",Z.id),await this.m.setInstalled(Z),this.s.info("Removed the extension from uninstalled list:",Z.id),(await this.m.scanAllUserExtensions(!0)).find(P=>n.$po.create(P).equals(Z))):void 0}async w(Z){return!!(await this.m.getUninstalledExtensions())[Z.toString()]}}class V extends W{constructor(Z,q,k,P,F,M,K,_,ae,he){super(q.identifier,q,k,F,M,K,_,ae,he),this.y=q,this.z=P}async x(Z){const k=(await this.m.scanExtensions(null,this.options.profileLocation)).find(K=>(0,n.$oo)(K.identifier,this.y.identifier));k&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$of)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.y.version)return[await this.m.updateMetadata(k,P),P];const{location:F,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(F.fsPath),[await this.u({zipPath:F.fsPath,key:n.$po.create(this.y),metadata:P},!1,Z),P]}catch(K){try{await this.z.delete(F)}catch(_){this.s.warn("Error while deleting the downloaded file",F.toString(),(0,O.$8)(_))}throw K}}async B(Z){try{await(0,m.$tp)(Z)}catch(q){throw new s.$Zn((0,c.$ep)(q).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$zp=V;class ee extends W{constructor(Z,q,k,P,F,M,K,_,ae,he){super({id:(0,n.$to)(Z.publisher,Z.name)},q,k,F,M,K,_,ae,he),this.y=Z,this.z=q,this.A=P}async h(Z){const q=await super.h(Z);return this.D(q,Z),q}async x(Z){const q=new n.$po(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation)).find(K=>(0,n.$oo)(this.identifier,K.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(P)if(this.l=3,q.equals(new n.$po(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(w.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const K=await this.v(q);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(w.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$9d(this.z.fsPath),key:q,metadata:F},!0,Z),F]}async D(Z,q){try{let[k]=await this.A.getExtensions([{id:Z.identifier.id,version:Z.manifest.version}],q);if(k||([k]=await this.A.getExtensions([{id:Z.identifier.id}],q)),k){const P={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Z,P,this.options.profileLocation)}}catch{}}}class ne extends c.$gp{constructor(Z,q,k){super(),this.extension=Z,this.j=q,this.k=k}async h(Z){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[265],oe([0,1,2,29,80,222,122,7,20]),function(te,e,j,N,D,A,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=void 0;let $=class extends j.$jc{constructor(p,g,u,d,y,f){super(),p.cleanUp(),(0,A.$KUb)(p,g,u,d,f),D.$Rz.removeOutdatedExtensionVersions(p,y)}};e.$S7b=$,e.$S7b=$=ye([Y(0,O.$wp),Y(1,N.$Yn),Y(2,D.$Qz),Y(3,N.$4n),Y(4,S.$To),Y(5,R.$4i)],$)}),define(re[123],oe([0,1,69,61,36,275,14,8,3,2,15,6,32,43,65]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class y{traceSocketEvent(a,v){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,v)}constructor(a,v=""){this.f=!0,this.debugLabel=v,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,R.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const v=L=>{this.traceSocketEvent("read",L),a(O.$Ed.wrap(L))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(a){const v=L=>{a({type:0,hadError:L,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(a){const v=()=>{a()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,R.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,R.$Y)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$ph=y;var f;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var o;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(o||(o={}));class h extends $.$jc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,v){this.socket.traceSocketEvent(a,v)}constructor(a,v,L,T){super(),this.f=this.B(new S.$ed),this.g=this.B(new S.$ed),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:L?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new b(this,v,L,T,this.f,(z,U)=>this.m(z,U))),this.B(this.a.onError(z=>{console.error(z),(0,R.$Y)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new d.$kh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){let v=0;for(;v<a.byteLength;)this.a.writeMessage(a.slice(v,Math.min(v+262144,a.byteLength))),v+=262144}m(a,v){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let L=2;a.byteLength<126?L+=0:a.byteLength<2**16?L+=2:L+=8;const T=O.$Ed.alloc(L);if(v?T.writeUInt8(194,0):T.writeUInt8(130,0),a.byteLength<126)T.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){T.writeUInt8(126,1);let z=1;T.writeUInt8(a.byteLength>>>8&255,++z),T.writeUInt8(a.byteLength>>>0&255,++z)}else{T.writeUInt8(127,1);let z=1;T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(a.byteLength>>>24&255,++z),T.writeUInt8(a.byteLength>>>16&255,++z),T.writeUInt8(a.byteLength>>>8&255,++z),T.writeUInt8(a.byteLength>>>0&255,++z)}this.socket.write(O.$Ed.concat([T,a]))}end(){this.h=!0,this.socket.end()}n(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const v=this.b.peek(this.j.readLen),L=v.readUInt8(0),T=(L&128)>>>7,z=(L&64)>>>6,U=v.readUInt8(1),B=(U&128)>>>7,Q=U&127;this.j.state=2,this.j.readLen=2+(B?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const v=this.b.read(this.j.readLen),L=v.readUInt8(1),T=(L&128)>>>7;let z=L&127,U=1;z===126?z=v.readUInt8(++U)*2**8+v.readUInt8(++U):z===127&&(z=v.readUInt8(++U)*0+v.readUInt8(++U)*0+v.readUInt8(++U)*0+v.readUInt8(++U)*0+v.readUInt8(++U)*2**24+v.readUInt8(++U)*2**16+v.readUInt8(++U)*2**8+v.readUInt8(++U));let B=0;T&&(B=v.readUInt8(++U)*2**24+v.readUInt8(++U)*2**16+v.readUInt8(++U)*2**8+v.readUInt8(++U)),this.j.state=3,this.j.readLen=z,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const v=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),t(v,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(v,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qh=h;class b extends $.$jc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Ed.alloc(0)}constructor(a,v,L,T,z,U){super(),this.n=a,this.r=z,this.s=U,this.a=this.B(new S.$ed),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$ed),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$ed),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new w(this.n,T,L,{windowBits:15})),this.f=this.B(new I(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const v=await this.w(this.f,a);this.s(v,!0)}else this.s(a,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(a,v){return new Promise((L,T)=>{a.write(v),a.flush(z=>L(z))})}acceptFrame(a,v,L){this.h.push({data:a,isCompressed:v,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const v=await this.C(this.b,a.data,a.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(a.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(a,v,L){return new Promise((T,z)=>{a.write(v),L&&a.write(O.$Ed.fromByteArray([0,0,255,255])),a.flush(U=>T(U))})}}class w extends $.$jc{get recordedInflateBytes(){return this.j?O.$Ed.concat(this.f):O.$Ed.alloc(0)}constructor(a,v,L,T){super(),this.h=a,this.j=v,this.a=this.B(new S.$ed),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(T),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(O.$Ed.wrap(z))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const v=O.$Ed.concat(this.g);this.g.length=0,a(v)})}}class I extends $.$jc{constructor(a,v){super(),this.g=a,this.a=this.B(new S.$ed),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(O.$Ed.wrap(L))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let v=O.$Ed.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),a(v)})}}function t(m,a){if(a===0)return;const v=m.byteLength>>>2;for(let Q=0;Q<v;Q++){const J=m.readUInt32BE(Q*4);m.writeUInt32BE(J^a,Q*4)}const L=v*4,T=m.byteLength-L,z=a>>>24&255,U=a>>>16&255,B=a>>>8&255;T>=1&&m.writeUInt8(m.readUInt8(L)^z,L),T>=2&&m.writeUInt8(m.readUInt8(L+1)^U,L+1),T>=3&&m.writeUInt8(m.readUInt8(L+2)^B,L+2)}e.$rh=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function s(){const m=(0,g.$3f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const a=process.platform!=="darwin"&&e.$rh?e.$rh:(0,D.tmpdir)(),v=(0,C.$8d)(a,`vscode-ipc-${m}.sock`);return i(v),v}e.$sh=s;function n(m,a,v){const L=(0,j.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${v}-${a}-sock`;const T=v.substr(0,4),z=a.substr(0,6),U=L.substr(0,8);let B;return process.platform!=="darwin"&&e.$rh&&!process.env.VSCODE_PORTABLE?B=(0,C.$8d)(e.$rh,`vscode-${U}-${T}-${z}.sock`):B=(0,C.$8d)(m,`${T}-${z}.sock`),i(B),B}e.$th=n;function i(m){const a=c[p.$t];typeof a=="number"&&m.length>=a&&console.warn(`WARNING: IPC handle "${m}" is longer than ${a} chars, try a shorter --user-data-dir`)}class r extends u.$eh{static b(a){const v=S.Event.fromNodeEventEmitter(a,"connection");return S.Event.map(v,L=>({protocol:new d.$lh(new y(L,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(L,"close"))}))}constructor(a){super(r.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$uh=r;function l(m){return new Promise((a,v)=>{const L=(0,N.createServer)();L.on("error",v),L.listen(m,()=>{L.removeListener("error",v),a(new r(L))})})}e.$vh=l;function E(m,a){return new Promise((v,L)=>{const T=(0,N.createConnection)(m,()=>{T.removeListener("error",L),v(d.$mh.fromSocket(new y(T,`ipc-client${a}`),a))});T.once("error",L)})}e.$wh=E}),define(re[266],oe([0,1,61,123,210]),function(te,e,j,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0,e.$27b=new class{supports(A){return!0}connect({host:A,port:O},R,S,$){return new Promise((C,p)=>{const g=j.createConnection({host:A,port:O},()=>{g.removeListener("error",p),g.write((0,D.$jkb)(R,S,$));const u=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",u),C(new N.$ph(g,$)))};g.on("data",u)});g.setNoDelay(!0),g.once("error",p)})}}}),define(re[267],oe([0,1,61,36,134,123,5,2,6,19,7,24,213,104,106,76,14]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=e.$W6b=e.$V6b=e.$U6b=void 0;async function o(t,c,s,n,i){let r;for(let l=3;l&&(r?.dispose(),r=await new h(t,c,s,n,i).waitForReady(),!(i&&D.$6f[i]||!D.$6f[r.tunnelLocalPort]));l--);return r}class h extends R.$jc{constructor(c,s,n,i,r){super(),this.m=s,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=j.createServer(),this.c=new O.$Eg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=l=>this.r(l),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,s=(0,y.$1z)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,D.$7f)(c,2,1e3,s),i=null;return this.b.listen(n,this.m),await this.c.wait(),i=this.b.address(),i||(n=0,this.b.listen(n,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(c){c.pause();const s=(0,y.$Yz)(this.tunnelRemoteHost)||(0,y.$1z)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,g.$Yk)(this.a,s,this.tunnelRemotePort),i=n.getSocket(),r=n.readEntireBuffer();n.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),i.end()}),c.on("close",()=>i.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),i instanceof A.$ph?i.socket.destroy():i.end()}),i instanceof A.$ph?this.t(c,i):this.s(c,i),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),i.end()})}s(c,s){s.onClose(()=>c.destroy()),s.onEnd(()=>c.end()),s.onData(n=>c.write(n.buffer)),c.on("data",n=>s.write(f.$Ed.wrap(n))),c.resume()}t(c,s){const n=s.socket;n.on("end",()=>c.end()),n.on("close",()=>c.end()),n.on("error",()=>{c.destroy()}),n.pipe(c),c.pipe(n)}}e.$U6b=h;let b=class extends y.$4z{constructor(c,s,n,i,r){super(s,r),this.u=c,this.v=n,this.w=i}isPortPrivileged(c){return(0,y.$2z)(c,this.l,S.OS,N.release())}s(c,s,n,i,r,l,E,m){const a=this.r(s,n);if(a)return++a.refcount,a.value;if((0,y.$Vz)(c))return this.t(c,s,n,r,l,E,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${r}.`);const v={commit:this.w.commit,quality:this.w.quality,addressProvider:c,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=o(v,i,s,n,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,n,L),L}}};e.$V6b=b,e.$V6b=b=ye([Y(0,u.$Sk),Y(1,C.$4i),Y(2,d.$Vk),Y(3,p.$jj),Y(4,$.$7h)],b);let w=class extends b{constructor(c,s,n,i,r){super(c,s,n,i,r)}};e.$W6b=w,e.$W6b=w=ye([Y(0,u.$Sk),Y(1,C.$4i),Y(2,d.$Vk),Y(3,p.$jj),Y(4,$.$7h)],w);let I=class extends R.$jc{constructor(c,s,n,i,r){super(),this.b=c,this.c=s,this.f=n,this.g=i,this.h=r,this.a=new Map}async openTunnel(c,s,n,i,r,l,E,m,a){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${i} on local port ${l}.`),!this.a.has(c)){const v=new w(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(c,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(s,n,i,r,l,E,m,a)}};e.$X6b=I,e.$X6b=I=ye([Y(0,u.$Sk),Y(1,C.$4i),Y(2,p.$jj),Y(3,d.$Vk),Y(4,$.$7h)],I)}),define(re[276],oe([0,1,36,38,8,2,23,11,18,3,43,147,204,205,196,197,262,187,189,19,209,95,220,96,215,16,114,247,29,97,188,122,98,13,199,200,68,4,195,70,72,225,7,201,102,24,57,20,107,21,108,109,110,46,228,80,111,25,78,253,238,239,81,254,257,258,259,58,252,241,106,219,76,267,214,229,27,230,6,231,190,207,206,79,246,17,50,203,56,251,227,242,105,256,265,10,202,101,249,245,216,184,55,260,248,71,250,104,266,182,112,240,217]),function(te,e,j,N,D,A,O,R,S,$,C,p,g,u,d,y,f,o,h,b,w,I,t,c,s,n,i,r,l,E,m,a,v,L,T,z,U,B,Q,J,x,H,X,G,W,V,ee,ne,se,Z,q,k,P,F,M,K,_,ae,he,fe,le,$e,de,we,Ee,je,Le,Me,ce,ge,be,ke,Pe,ze,Oe,Ue,Te,ie,ue,me,pe,Se,Re,Ce,Ie,De,Ae,Ne,Be,qe,Ve,xe,ut,vt,Et,St,kt,ft,Ct,Pt,Rt,It,jt,Ot,Dt,dt,At,gt,Lt,Nt,$t,Ft,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends A.$jc{constructor(ve){super(),this.f=ve,this.a=this.B(new p.$WS(this)),this.b=void 0,this.c=this.B(new $.$ed),this.g()}g(){let ve=!1;const Fe=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Fe),(0,p.$XS)(process.parentPort,tt.$_5b.exit,Fe)}async init(){const ve=await this.h();(0,ae.$jgb)(),ve.invokeFunction(Fe=>{const Ke=Fe.get(X.$4i);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Fe),this.m(Ke)}),this.B((0,A.$gc)(ve.createInstance(g.$o7b,this.f.codeCachePath),ve.createInstance(u.$p7b),ve.createInstance(f.$s7b),ve.createInstance(y.$r7b),ve.createInstance(d.$q7b),ve.createInstance(Et.$S7b),ve.createInstance(xe.$K7b),ve.createInstance(Ft.$57b,this.c.event)))}async h(){const ve=new J.$yh,Fe={_serviceBrand:void 0,...W.default};ve.set(V.$jj,Fe);const Ke=new C.$ih(We=>We==="main"),He=new dt.$56b(this.a,Ke);ve.set(dt.$46b,He);const nt=this.f.policiesData?new Ne.$D6b(this.f.policiesData,He.getChannel("policy")):new Be.$$m;ve.set(Be.$9m,nt);const Ge=new Nt.$$l(this.f.args,Fe);ve.set(n.$Ih,Ge);const Xe=new G.$Yq(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(We=>({...We,resource:R.URI.revive(We.resource)})),He.getChannel("logger"));ve.set(X.$5i,Xe);const st=this.B(Xe.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),at=this.B(new X.$_i(st.getLevel())),Je=this.B(new kt.$gN(st,[at]));ve.set(X.$4i,Je),this.b=this.B(new ft.$U7b(Je)),ve.set(ft.$T7b,this.b);const Ze=this.B(new T.$Bp(Je));ve.set(L.$5j,Ze);const ct=this.B(new z.$1p(Je));Ze.registerProvider(O.Schemas.file,ct);const lt=this.B(new me.$36b(O.Schemas.file,this.B(new pe.$2M(He.getChannel(pe.$1M),{pathCaseSensitive:ue.$k})),O.Schemas.vscodeUserData,Je));Ze.registerProvider(O.Schemas.vscodeUserData,lt);const Qe=this.B(new qe.$nN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));ve.set(De.$Dk,Qe);const Ye=this.B(new w.$yn(Qe.defaultProfile.settingsResource,Ze,nt,Je));ve.set(b.$7h,Ye);const _e=new At.$17b(void 0,{defaultProfile:Qe.defaultProfile,currentProfile:Qe.defaultProfile},He,Ge);ve.set(ne.$To,_e),this.B((0,A.$hc)(()=>_e.flush())),await Promise.all([Ye.initialize(),_e.initialize()]);const ht=new ie.$nr(Ze);ve.set(Te.$Bk,ht);const bt=new Rt.$Kq(He.getChannel("request"));ve.set(ee.$Ho,bt),ve.set(o.$t7b,new U.$xh(h.$u7b,void 0,!1)),ve.set(Re.$zF,new U.$xh(Se.$J7b,void 0,!1));const wt=C.ProxyChannel.toService(He.getChannel("nativeHost"));ve.set(jt.$M5b,wt),ve.set(c.$Cn,new U.$xh(s.$vN,void 0,!0));const Mt=this.B(new ge.$A6b(wt)),zt=new C.$ih(We=>Mt.getActiveClientId().then(ot=>We===ot));ve.set(v.$uUb,new It.$W7b(this.a.getChannel("extensionRecommendationNotification",zt)));let rt;const et=[],yt=(0,F.$lo)(Fe,Ye);if((0,F.$go)(Fe,Ge)){const We=new k.$H3b(Je,Xe,Ge,Fe);if(et.push(We),Fe.aiConfig?.ariaKey){const ot=new Ve.$7M(bt,yt,"monacoworkbench",null,Fe.aiConfig.ariaKey);this.B((0,A.$hc)(()=>ot.flush())),et.push(ot)}rt=new P.$Oq({appenders:et,commonProperties:(0,se.$9n)((0,j.release)(),(0,j.hostname)(),process.arch,Fe.commit,Fe.version,this.f.machineId,yt),sendErrorTelemetry:!0,piiPaths:(0,F.$mo)(Ge)},Ye,Fe)}else{rt=F.$ao;const We=F.$eo;et.push(We)}this.a.registerChannel("telemetryAppender",new q.$e6b(et)),ve.set(Z.$8k,rt);const Ut=new M.$v7b(Ye,rt,Je,Xe,Ge,Fe);ve.set(Z.$9k,Ut),ve.set(Ae.$ip,new U.$xh(Pt.$fN,void 0,!0)),ve.set(Ce.$mp,new U.$xh(Ie.$E6b,void 0,!0)),ve.set(E.$5o,new U.$xh(E.$6o,void 0,!0)),ve.set(a.$wp,new U.$xh(a.$xp,void 0,!0)),ve.set(l.$Yn,new U.$xh(r.$3o,void 0,!0)),ve.set(l.$5n,new U.$xh(Dt.$Z7b,void 0,!1)),ve.set(x.$Gq,new U.$xh(H.$Iq,void 0,!1)),ve.set(I.$fm,new U.$xh(t.$ur,void 0,!1)),ve.set(he.$nzb,new U.$xh(he.$ozb,void 0,!0)),ve.set(ae.$Egb,new U.$xh($e.$ABb,void 0,!0)),ve.set(ae.$Dgb,new le.$y7b(this.a.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ve.set(l.$4n,new U.$xh(i.$lzb,void 0,!1)),ve.set(_.$yBb,new U.$xh(_.$zBb,void 0,!0)),ve.set(K.$Qz,new U.$xh(K.$Rz)),ve.set(ae.$ogb,new U.$xh(Le.$JAb,void 0,!0)),ve.set(ae.$pgb,new U.$xh(Le.$LAb,void 0,!0)),ve.set(de.$iZb,new U.$xh(de.$kZb,void 0,!0)),ve.set(ae.$qgb,new U.$xh(fe.$j4b,void 0,!1)),ve.set(ae.$zgb,new U.$xh(we.$$3b,void 0,!0)),ve.set(ae.$Agb,new U.$xh(Ee.$o4b,void 0,!1)),ve.set(Me.$Zzb,new U.$xh(ce.$F7b,void 0,!0)),ve.set(ae.$Bgb,new U.$xh(vt.$14b,void 0,!0)),ve.set(be.$Vk,new U.$xh(ke.$Z6b,void 0,!1));const pt=new gt.$Tk;return ve.set(gt.$Sk,pt),pt.register(0,Lt.$27b),ve.set(Pe.$Uz,new U.$xh(ze.$X6b)),ve.set(Oe.$G7b,new U.$xh(Ue.$I7b)),ve.set(ut.$L7b,new U.$xh(Ct.$V7b)),ve.set($t.$37b,new U.$xh($t.$47b)),new Q.$4p(ve)}j(ve){const Fe=this.B(new A.$ic),Ke=new m.$8o(ve.get(l.$1n),()=>null);this.a.registerChannel("extensions",Ke);const He=C.ProxyChannel.fromService(ve.get(x.$Gq),Fe);this.a.registerChannel("languagePacks",He);const nt=C.ProxyChannel.fromService(ve.get(I.$fm),Fe);this.a.registerChannel("diagnostics",nt);const Ge=new m.$0o(ve.get(l.$5n));this.a.registerChannel("extensionTipsService",Ge);const Xe=C.ProxyChannel.fromService(ve.get(o.$t7b),Fe);this.a.registerChannel("checksum",Xe);const st=C.ProxyChannel.fromService(ve.get(Re.$zF),Fe);this.a.registerChannel("v8InspectProfiling",st);const at=new le.$z7b(ve.get(de.$iZb));this.a.registerChannel("userDataSyncMachines",at);const Je=C.ProxyChannel.fromService(ve.get(Z.$9k),Fe);this.a.registerChannel("customEndpointTelemetry",Je);const Ze=new le.$A7b(ve.get(he.$nzb));this.a.registerChannel("userDataSyncAccount",Ze);const ct=new le.$B7b(ve.get(ae.$ogb));this.a.registerChannel("userDataSyncStoreManagement",ct);const lt=new je.$D7b(ve.get(ae.$Agb),ve.get(De.$Dk),ve.get(X.$4i));this.a.registerChannel("userDataSync",lt);const Qe=this.B(ve.get(B.$zh).createInstance(Ot.$Y7b)),Ye=new le.$w7b(Qe);this.a.registerChannel("userDataAutoSync",Ye);const _e=C.ProxyChannel.fromService(ve.get(Oe.$G7b),Fe);this.a.registerChannel(Oe.$H7b,_e);const ht=C.ProxyChannel.fromService(ve.get(ut.$L7b),Fe);this.a.registerChannel("remoteTunnel",ht)}m(ve){process.on("uncaughtException",Fe=>(0,D.$Y)(Fe)),process.on("unhandledRejection",Fe=>(0,D.$Y)(Fe)),(0,D.setUnexpectedErrorHandler)(Fe=>{const Ke=(0,N.$li)(Fe,!0);Ke&&ve.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}handledClientConnection(ve){if(ve.data!==tt.$b6b.response)return!1;const Fe=(0,S.$Lb)(ve.ports);return Fe?(this.c.fire(Fe),!0):!1}}async function mt(it){const ve=new Tt(it);process.parentPort.postMessage(tt.$_5b.ipcReady),await ve.init(),process.parentPort.postMessage(tt.$_5b.initDone)}e.main=mt,process.parentPort.once("message",it=>{mt(it.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f36df69328ed10f76d4be03e8a82b61794b49711/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
