/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],C=0,F=$e.length;C<F;C++)e[C]=De[$e[C]];return e};define(De[156],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class C{static get(){const f=new Map,L=new Map,R=new Map,m=new Map;function S(k,D){k.has(D.detail)||k.set(D.detail,-D.timestamp)}function b(k,D){const v=k.get(D.detail);v&&(v>=0||k.set(D.detail,v+D.timestamp))}let P=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(P=$e.getStats().slice(0).sort((k,D)=>k.timestamp-D.timestamp));for(const k of P)switch(k.type){case 10:S(f,k);break;case 11:case 12:b(f,k);break;case 21:S(L,k);break;case 22:b(L,k);break;case 33:S(R,k);break;case 34:b(R,k);break;case 31:S(m,k);break;case 32:b(m,k);break}let I=0;R.forEach(k=>I+=k);function p(k){const D=[];return k.forEach((v,r)=>D.push([r,v])),D}return{amdLoad:p(f),amdInvoke:p(L),nodeRequire:p(R),nodeEval:p(m),nodeRequireTotal:I}}static toMarkdownTable(f,L){let R="";const m=[];return f.forEach((S,b)=>{m[b]=S.length}),L.forEach(S=>{S.forEach((b,P)=>{typeof b>"u"&&(b=S[P]="-");const I=b.toString().length;m[P]=Math.max(I,m[P])})}),f.forEach((S,b)=>{R+=`| ${S+" ".repeat(m[b]-S.toString().length)} `}),R+=`|
`,f.forEach((S,b)=>{R+=`| ${"-".repeat(m[b])} `}),R+=`|
`,L.forEach(S=>{S.forEach((b,P)=>{typeof b<"u"&&(R+=`| ${b+" ".repeat(m[P]-b.toString().length)} `)}),R+=`|
`}),R}}e.$S=C}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function C(v,r,i){const s=F(v,r);if(s!==-1)return v[s]}e.$db=C;function F(v,r,i=v.length-1){for(let s=i;s>=0;s--){const d=v[s];if(r(d))return s}return-1}e.$eb=F;function f(v,r){const i=L(v,r);return i===-1?void 0:v[i]}e.$fb=f;function L(v,r,i=0,s=v.length){let d=i,$=s;for(;d<$;){const g=Math.floor((d+$)/2);r(v[g])?d=g+1:$=g}return d-1}e.$gb=L;function R(v,r){const i=m(v,r);return i===v.length?void 0:v[i]}e.$hb=R;function m(v,r,i=0,s=v.length){let d=i,$=s;for(;d<$;){const g=Math.floor((d+$)/2);r(v[g])?$=g:d=g+1}return d}e.$ib=m;function S(v,r,i=0,s=v.length){const d=m(v,r,i,s);return d===v.length?-1:d}e.$jb=S;class b{static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if(b.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!r(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const i=L(this.e,r,this.c);return this.c=i+1,i===-1?void 0:this.e[i]}}e.$kb=b;function P(v,r){if(v.length===0)return;let i=v[0];for(let s=1;s<v.length;s++){const d=v[s];r(d,i)>0&&(i=d)}return i}e.$lb=P;function I(v,r){if(v.length===0)return;let i=v[0];for(let s=1;s<v.length;s++){const d=v[s];r(d,i)>=0&&(i=d)}return i}e.$mb=I;function p(v,r){return P(v,(i,s)=>-r(i,s))}e.$nb=p;function k(v,r){if(v.length===0)return-1;let i=0;for(let s=1;s<v.length;s++){const d=v[s];r(d,v[i])>0&&(i=s)}return i}e.$ob=k;function D(v,r){for(const i of v){const s=r(i);if(s!==void 0)return s}}e.$pb=D}),define(De[56],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function C(R,m){const S=Object.create(null);for(const b of R){const P=m(b);let I=S[P];I||(I=S[P]=[]),I.push(b)}return S}e.$I=C;function F(R,m){const S=[],b=[];for(const P of R)m.has(P)||S.push(P);for(const P of m)R.has(P)||b.push(P);return{removed:S,added:b}}e.$J=F;function f(R,m){const S=[],b=[];for(const[P,I]of R)m.has(P)||S.push(I);for(const[P,I]of m)R.has(P)||b.push(I);return{removed:S,added:b}}e.$K=f;class L{constructor(){this.a=new Map}add(m,S){let b=this.a.get(m);b||(b=new Set,this.a.set(m,b)),b.add(S)}delete(m,S){const b=this.a.get(m);b&&(b.delete(S),b.size===0&&this.a.delete(m))}forEach(m,S){const b=this.a.get(m);b&&b.forEach(S)}get(m){const S=this.a.get(m);return S||new Set}}e.$L=L}),define(De[57],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function C(R){return(m,S,b)=>{let P=null,I=null;if(typeof b.value=="function"?(P="value",I=b.value):typeof b.get=="function"&&(P="get",I=b.get),!I)throw new Error("not supported");b[P]=R(I,S)}}function F(R,m,S){let b=null,P=null;if(typeof S.value=="function"?(b="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(b="get",P=S.get),!P)throw new Error("not supported");const I=`$memoize$${m}`;S[b]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[I]}}e.$5g=F;function f(R,m,S){return C((b,P)=>{const I=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(...k){this[p]||(this[p]=S?S():void 0),clearTimeout(this[I]),m&&(this[p]=m(this[p],...k),k=[this[p]]),this[I]=setTimeout(()=>{b.apply(this,k),this[p]=S?S():void 0},R)}})}e.$6g=f;function L(R,m,S){return C((b,P)=>{const I=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,k=`$throttle$lastRun$${P}`,D=`$throttle$pending$${P}`;return function(...v){if(this[p]||(this[p]=S?S():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),m&&(this[p]=m(this[p],...v)),this[D])return;const r=this[k]+R;r<=Date.now()?(this[k]=Date.now(),b.apply(this,[this[p]]),this[p]=S?S():void 0):(this[D]=!0,this[I]=setTimeout(()=>{this[D]=!1,this[k]=Date.now(),b.apply(this,[this[p]]),this[p]=S?S():void 0},r-Date.now()))}})}e.$7g=L}),define(De[8],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=C,e.$V=new C;function F(g){e.$V.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=F;function f(g){if(!g||typeof g!="object")return!1;const t=g;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=f;function L(g){b(g)||e.$V.onUnexpectedError(g)}e.$Y=L;function R(g){b(g)||e.$V.onUnexpectedExternalError(g)}e.$Z=R;function m(g){if(g instanceof Error){const{name:t,message:o}=g,a=g.stacktrace||g.stack;return{$isError:!0,name:t,message:o,stack:a,noTelemetry:d.isErrorNoTelemetry(g)}}return g}e.$1=m;const S="Canceled";function b(g){return g instanceof P?!0:g instanceof Error&&g.name===S&&g.message===S}e.$2=b;class P extends Error{constructor(){super(S),this.name=this.message}}e.$3=P;function I(){const g=new Error(S);return g.name=g.message,g}e.$4=I;function p(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.$5=p;function k(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.$6=k;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=D;function v(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.$8=v;class r extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=r;class i extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=i;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=s;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const o=new d;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=d;class $ extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$ab=$}),define(De[19],Ce([1,0,8,118]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.$4b=e.CompareResult=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.top=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function f(Y,se=0){return Y[Y.length-(1+se)]}e.$qb=f;function L(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.$rb=L;function R(Y,se,re=(le,Ee)=>le===Ee){if(Y===se)return!0;if(!Y||!se||Y.length!==se.length)return!1;for(let le=0,Ee=Y.length;le<Ee;le++)if(!re(Y[le],se[le]))return!1;return!0}e.$sb=R;function m(Y,se){const re=Y.length-1;se<re&&(Y[se]=Y[re]),Y.pop()}e.$tb=m;function S(Y,se,re){return b(Y.length,le=>re(Y[le],se))}e.$ub=S;function b(Y,se){let re=0,le=Y-1;for(;re<=le;){const Ee=(re+le)/2|0,he=se(Ee);if(he<0)re=Ee+1;else if(he>0)le=Ee-1;else return Ee}return-(re+1)}e.$vb=b;function P(Y,se,re){if(Y=Y|0,Y>=se.length)throw new TypeError("invalid index");const le=se[Math.floor(se.length*Math.random())],Ee=[],he=[],fe=[];for(const te of se){const ue=re(te,le);ue<0?Ee.push(te):ue>0?he.push(te):fe.push(te)}return Y<Ee.length?P(Y,Ee,re):Y<Ee.length+fe.length?fe[0]:P(Y-(Ee.length+fe.length),he,re)}e.$wb=P;function I(Y,se){const re=[];let le;for(const Ee of Y.slice(0).sort(se))!le||se(le[0],Ee)!==0?(le=[Ee],re.push(le)):le.push(Ee);return re}e.$xb=I;function*p(Y,se){let re,le;for(const Ee of Y)le!==void 0&&se(le,Ee)?re.push(Ee):(re&&(yield re),re=[Ee]),le=Ee;re&&(yield re)}e.$yb=p;function k(Y,se){for(let re=0;re<=Y.length;re++)se(re===0?void 0:Y[re-1],re===Y.length?void 0:Y[re])}e.$zb=k;function D(Y,se,re){const le=[];function Ee(te,ue,be){if(ue===0&&be.length===0)return;const Pe=le[le.length-1];Pe&&Pe.start+Pe.deleteCount===te?(Pe.deleteCount+=ue,Pe.toInsert.push(...be)):le.push({start:te,deleteCount:ue,toInsert:be})}let he=0,fe=0;for(;;){if(he===Y.length){Ee(he,0,se.slice(fe));break}if(fe===se.length){Ee(he,Y.length-he,[]);break}const te=Y[he],ue=se[fe],be=re(te,ue);be===0?(he+=1,fe+=1):be<0?(Ee(he,1,[]),he+=1):be>0&&(Ee(he,0,[ue]),fe+=1)}return le}e.$Ab=D;function v(Y,se,re){const le=D(Y,se,re),Ee=[],he=[];for(const fe of le)Ee.push(...Y.slice(fe.start,fe.start+fe.deleteCount)),he.push(...fe.toInsert);return{removed:Ee,added:he}}e.$Bb=v;function r(Y,se,re){if(re===0)return[];const le=Y.slice(0,re).sort(se);return s(Y,se,le,re,Y.length),le}e.top=r;function i(Y,se,re,le,Ee){return re===0?Promise.resolve([]):new Promise((he,fe)=>{(async()=>{const te=Y.length,ue=Y.slice(0,re).sort(se);for(let be=re,Pe=Math.min(re+le,te);be<te;be=Pe,Pe=Math.min(Pe+le,te)){if(be>re&&await new Promise(B=>setTimeout(B)),Ee&&Ee.isCancellationRequested)throw new C.$3;s(Y,se,ue,be,Pe)}return ue})().then(he,fe)})}e.$Db=i;function s(Y,se,re,le,Ee){for(const he=re.length;le<Ee;le++){const fe=Y[le];if(se(fe,re[he-1])<0){re.pop();const te=(0,F.$ib)(re,ue=>se(fe,ue)<0);re.splice(te,0,fe)}}}function d(Y){return Y.filter(se=>!!se)}e.$Eb=d;function $(Y){let se=0;for(let re=0;re<Y.length;re++)Y[re]&&(Y[se]=Y[re],se+=1);Y.length=se}e.$Fb=$;function g(Y,se,re){Y.splice(re,0,Y.splice(se,1)[0])}e.$Gb=g;function t(Y){return!Array.isArray(Y)||Y.length===0}e.$Hb=t;function o(Y){return Array.isArray(Y)&&Y.length>0}e.$Ib=o;function a(Y,se=re=>re){const re=new Set;return Y.filter(le=>{const Ee=se(le);return re.has(Ee)?!1:(re.add(Ee),!0)})}e.$Jb=a;function n(Y){const se=new Set;return re=>{const le=Y(re);return se.has(le)?!1:(se.add(le),!0)}}e.$Kb=n;function c(Y,se){return Y.length>0?Y[0]:se}e.$Lb=c;function h(Y,se){return Y.length>0?Y[Y.length-1]:se}e.$Mb=h;function E(Y,se,re=(le,Ee)=>le===Ee){let le=0;for(let Ee=0,he=Math.min(Y.length,se.length);Ee<he&&re(Y[Ee],se[Ee]);Ee++)le++;return le}e.$Nb=E;function y(Y){return[].concat(...Y)}e.$Ob=y;function u(Y,se){let re=typeof se=="number"?Y:0;typeof se=="number"?re=Y:(re=0,se=Y);const le=[];if(re<=se)for(let Ee=re;Ee<se;Ee++)le.push(Ee);else for(let Ee=re;Ee>se;Ee--)le.push(Ee);return le}e.$Pb=u;function l(Y,se,re){return Y.reduce((le,Ee)=>(le[se(Ee)]=re?re(Ee):Ee,le),Object.create(null))}e.$Qb=l;function w(Y,se){return Y.push(se),()=>A(Y,se)}e.$Rb=w;function A(Y,se){const re=Y.indexOf(se);if(re>-1)return Y.splice(re,1),se}e.$Sb=A;function O(Y,se,re){const le=Y.slice(0,se),Ee=Y.slice(se);return le.concat(re,Ee)}e.$Tb=O;function N(Y,se){let re;if(typeof se=="number"){let le=se;re=()=>{const Ee=Math.sin(le++)*179426549;return Ee-Math.floor(Ee)}}else re=Math.random;for(let le=Y.length-1;le>0;le-=1){const Ee=Math.floor(re()*(le+1)),he=Y[le];Y[le]=Y[Ee],Y[Ee]=he}}e.$Ub=N;function T(Y,se){const re=Y.indexOf(se);re>-1&&(Y.splice(re,1),Y.unshift(se))}e.$Vb=T;function j(Y,se){const re=Y.indexOf(se);re>-1&&(Y.splice(re,1),Y.push(se))}e.$Wb=j;function z(Y,se){for(const re of se)Y.push(re)}e.$Xb=z;function M(Y,se){return Array.isArray(Y)?Y.map(se):se(Y)}e.$Yb=M;function H(Y){return Array.isArray(Y)?Y:[Y]}e.$Zb=H;function q(Y){return Y[Math.floor(Math.random()*Y.length)]}e.$1b=q;function me(Y,se,re){const le=Q(Y,se),Ee=Y.length,he=re.length;Y.length=Ee+he;for(let fe=Ee-1;fe>=le;fe--)Y[fe+he]=Y[fe];for(let fe=0;fe<he;fe++)Y[fe+le]=re[fe]}e.$2b=me;function x(Y,se,re,le){const Ee=Q(Y,se);let he=Y.splice(Ee,re);return he===void 0&&(he=[]),me(Y,Ee,le),he}e.$3b=x;function Q(Y,se){return se<0?Math.max(se+Y.length,0):Math.min(se,Y.length)}var V;(function(Y){function se(he){return he<0}Y.isLessThan=se;function re(he){return he<=0}Y.isLessThanOrEqual=re;function le(he){return he>0}Y.isGreaterThan=le;function Ee(he){return he===0}Y.isNeitherLessOrGreaterThan=Ee,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function _(Y,se){return(re,le)=>se(Y(re),Y(le))}e.$4b=_;function ge(...Y){return(se,re)=>{for(const le of Y){const Ee=le(se,re);if(!V.isNeitherLessOrGreaterThan(Ee))return Ee}return V.neitherLessOrGreaterThan}}e.$5b=ge;const ce=(Y,se)=>Y-se;e.$6b=ce;const we=(Y,se)=>(0,e.$6b)(Y?1:0,se?1:0);e.$7b=we;function G(Y){return(se,re)=>-Y(se,re)}e.$8b=G;class U{constructor(se){this.g=se,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(se){let re=this.c;for(;re<this.g.length&&se(this.g[re]);)re++;const le=re===this.c?null:this.g.slice(this.c,re);return this.c=re,le}takeFromEndWhile(se){let re=this.d;for(;re>=0&&se(this.g[re]);)re--;const le=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const se=this.g[this.c];return this.c++,se}removeLast(){const se=this.g[this.d];return this.d--,se}takeCount(se){const re=this.g.slice(this.c,this.c+se);return this.c+=se,re}}e.$9b=U;class K{static{this.empty=new K(se=>{})}constructor(se){this.iterate=se}forEach(se){this.iterate(re=>(se(re),!0))}toArray(){const se=[];return this.iterate(re=>(se.push(re),!0)),se}filter(se){return new K(re=>this.iterate(le=>se(le)?re(le):!0))}map(se){return new K(re=>this.iterate(le=>re(se(le))))}some(se){let re=!1;return this.iterate(le=>(re=se(le),!re)),re}findFirst(se){let re;return this.iterate(le=>se(le)?(re=le,!1):!0),re}findLast(se){let re;return this.iterate(le=>(se(le)&&(re=le),!0)),re}findLastMaxBy(se){let re,le=!0;return this.iterate(Ee=>((le||V.isGreaterThan(se(Ee,re)))&&(le=!1,re=Ee),!0)),re}}e.$0b=K}),define(De[58],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xc=e.$wc=e.$vc=e.$uc=e.ok=void 0;function F(S,b){if(!S)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=F;function f(S,b="Unreachable"){throw new Error(b)}e.$uc=f;function L(S){if(!S)throw new C.$ab("Assertion Failed")}e.$vc=L;function R(S){if(!S()){debugger;S(),(0,C.$Y)(new C.$ab("Assertion Failed"))}}e.$wc=R;function m(S,b){let P=0;for(;P<S.length-1;){const I=S[P],p=S[P+1];if(!b(I,p))return!1;P++}return!0}e.$xc=m}),define(De[74],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function C(F){const f=this;let L=!1,R;return function(){return L||(L=!0,R=F.apply(f,arguments)),R}}e.$bb=C}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=void 0;class C{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$1L=C,e.$2L=new C("id#")}),define(De[50],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(F){function f($){return $&&typeof $=="object"&&typeof $[Symbol.iterator]=="function"}F.is=f;const L=Object.freeze([]);function R(){return L}F.empty=R;function*m($){yield $}F.single=m;function S($){return f($)?$:m($)}F.wrap=S;function b($){return $||L}F.from=b;function P($){return!$||$[Symbol.iterator]().next().done===!0}F.isEmpty=P;function I($){return $[Symbol.iterator]().next().value}F.first=I;function p($,g){for(const t of $)if(g(t))return!0;return!1}F.some=p;function k($,g){for(const t of $)if(g(t))return t}F.find=k;function*D($,g){for(const t of $)g(t)&&(yield t)}F.filter=D;function*v($,g){let t=0;for(const o of $)yield g(o,t++)}F.map=v;function*r(...$){for(const g of $)for(const t of g)yield t}F.concat=r;function i($,g,t){let o=t;for(const a of $)o=g(o,a);return o}F.reduce=i;function*s($,g,t=$.length){for(g<0&&(g+=$.length),t<0?t+=$.length:t>$.length&&(t=$.length);g<t;g++)yield $[g]}F.slice=s;function d($,g=Number.POSITIVE_INFINITY){const t=[];if(g===0)return[t,$];const o=$[Symbol.iterator]();for(let a=0;a<g;a++){const n=o.next();if(n.done)return[t,F.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return o}}]}F.consume=d})(C||(e.Iterable=C={}))}),define(De[157],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,o=!1){let a=0;const n=t.length;let c="",h=0,E=16,y=0;function u(j){let z=0,M=0;for(;z<j;){const H=t.charCodeAt(a);if(H>=48&&H<=57)M=M*16+H-48;else if(H>=65&&H<=70)M=M*16+H-65+10;else if(H>=97&&H<=102)M=M*16+H-97+10;else break;a++,z++}return z<j&&(M=-1),M}function l(j){a=j,c="",h=0,E=16,y=0}function w(){const j=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&b(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&b(t.charCodeAt(a)))for(a++;a<t.length&&b(t.charCodeAt(a));)a++;else return y=3,t.substring(j,a);let z=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&b(t.charCodeAt(a))){for(a++;a<t.length&&b(t.charCodeAt(a));)a++;z=a}else y=3;return t.substring(j,z)}function A(){let j="",z=a;for(;;){if(a>=n){j+=t.substring(z,a),y=2;break}const M=t.charCodeAt(a);if(M===34){j+=t.substring(z,a),a++;break}if(M===92){if(j+=t.substring(z,a),a++,a>=n){y=2;break}switch(t.charCodeAt(a++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const q=u(4);q>=0?j+=String.fromCharCode(q):y=4;break}default:y=5}z=a;continue}if(M>=0&&M<=31)if(S(M)){j+=t.substring(z,a),y=2;break}else y=6;a++}return j}function O(){if(c="",y=0,h=a,a>=n)return h=n,E=17;let j=t.charCodeAt(a);if(m(j)){do a++,c+=String.fromCharCode(j),j=t.charCodeAt(a);while(m(j));return E=15}if(S(j))return a++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),E=14;switch(j){case 123:return a++,E=1;case 125:return a++,E=2;case 91:return a++,E=3;case 93:return a++,E=4;case 58:return a++,E=6;case 44:return a++,E=5;case 34:return a++,c=A(),E=10;case 47:{const z=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<n&&!S(t.charCodeAt(a));)a++;return c=t.substring(z,a),E=12}if(t.charCodeAt(a+1)===42){a+=2;const M=n-1;let H=!1;for(;a<M;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,H=!0;break}a++}return H||(a++,y=1),c=t.substring(z,a),E=13}return c+=String.fromCharCode(j),a++,E=16}case 45:if(c+=String.fromCharCode(j),a++,a===n||!b(t.charCodeAt(a)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=w(),E=11;default:for(;a<n&&N(j);)a++,j=t.charCodeAt(a);if(h!==a){switch(c=t.substring(h,a),c){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return c+=String.fromCharCode(j),a++,E=16}}function N(j){if(m(j)||S(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let j;do j=O();while(j>=12&&j<=15);return j}return{setPosition:l,getPosition:()=>a,scan:o?T:O,getToken:()=>E,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>a-h,getTokenError:()=>y}}e.$Im=R;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function I(t,o){const a=[],n=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function y(u,l,w,A){h.value=u,h.offset=l,h.length=w,h.type=A,h.colonOffset=void 0,c=h}try{d(t,{onObjectBegin:(u,l)=>{if(o<=u)throw n;c=void 0,E=o>u,a.push("")},onObjectProperty:(u,l,w)=>{if(o<l||(y(u,l,w,"property"),a[a.length-1]=u,o<=l+w))throw n},onObjectEnd:(u,l)=>{if(o<=u)throw n;c=void 0,a.pop()},onArrayBegin:(u,l)=>{if(o<=u)throw n;c=void 0,a.push(0)},onArrayEnd:(u,l)=>{if(o<=u)throw n;c=void 0,a.pop()},onLiteralValue:(u,l,w)=>{if(o<l||(y(u,l,w,g(u)),o<=l+w))throw n},onSeparator:(u,l,w)=>{if(o<=l)throw n;if(u===":"&&c&&c.type==="property")c.colonOffset=l,E=!1,c=void 0;else if(u===","){const A=a[a.length-1];typeof A=="number"?a[a.length-1]=A+1:(E=!0,a[a.length-1]=""),c=void 0}}})}catch(u){if(u!==n)throw u}return{path:a,previousNode:c,isAtPropertyKey:E,matches:u=>{let l=0;for(let w=0;l<u.length&&w<a.length;w++)if(u[l]===a[w]||u[l]==="*")l++;else if(u[l]!=="**")return!1;return l===u.length}}}e.$Jm=I;function p(t,o=[],a=L.DEFAULT){let n=null,c=[];const h=[];function E(u){Array.isArray(c)?c.push(u):n!==null&&(c[n]=u)}return d(t,{onObjectBegin:()=>{const u={};E(u),h.push(c),c=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const u=[];E(u),h.push(c),c=u,n=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:E,onError:(u,l,w)=>{o.push({error:u,offset:l,length:w})}},a),c[0]}e.$Km=p;function k(t,o=[],a=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function h(u){return n.children.push(u),u}d(t,{onObjectBegin:u=>{n=h({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,l,w)=>{n=h({type:"property",offset:l,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:l,length:w,parent:n})},onObjectEnd:(u,l)=>{n.length=u+l-n.offset,n=n.parent,c(u+l)},onArrayBegin:(u,l)=>{n=h({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,l)=>{n.length=u+l-n.offset,n=n.parent,c(u+l)},onLiteralValue:(u,l,w)=>{h({type:g(u),offset:l,length:w,parent:n,value:u}),c(l+w)},onSeparator:(u,l,w)=>{n.type==="property"&&(u===":"?n.colonOffset=l:u===","&&c(l))},onError:(u,l,w)=>{o.push({error:u,offset:l,length:w})}},a);const y=n.children[0];return y&&delete y.parent,y}e.$Lm=k;function D(t,o){if(!t)return;let a=t;for(const n of o)if(typeof n=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const h of a.children)if(Array.isArray(h.children)&&h.children[0].value===n){a=h.children[1],c=!0;break}if(!c)return}else{const c=n;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.$Mm=D;function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;o.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&o.push(a)}return o}e.$Nm=v;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const o=Object.create(null);for(const a of t.children){const n=a.children[1];n&&(o[a.children[0].value]=r(n))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Om=r;function i(t,o,a=!1){return o>=t.offset&&o<t.offset+t.length||a&&o===t.offset+t.length}e.$Pm=i;function s(t,o,a=!1){if(i(t,o,a)){const n=t.children;if(Array.isArray(n))for(let c=0;c<n.length&&n[c].offset<=o;c++){const h=s(n[c],o,a);if(h)return h}return t}}e.$Qm=s;function d(t,o,a=L.DEFAULT){const n=R(t,!1);function c(ge){return ge?()=>ge(n.getTokenOffset(),n.getTokenLength()):()=>!0}function h(ge){return ge?ce=>ge(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const E=c(o.onObjectBegin),y=h(o.onObjectProperty),u=c(o.onObjectEnd),l=c(o.onArrayBegin),w=c(o.onArrayEnd),A=h(o.onLiteralValue),O=h(o.onSeparator),N=c(o.onComment),T=h(o.onError),j=a&&a.disallowComments,z=a&&a.allowTrailingComma;function M(){for(;;){const ge=n.scan();switch(n.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:j||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ge){case 12:case 13:j?H(10):N();break;case 16:H(1);break;case 15:case 14:break;default:return ge}}}function H(ge,ce=[],we=[]){if(T(ge),ce.length+we.length>0){let G=n.getToken();for(;G!==17;){if(ce.indexOf(G)!==-1){M();break}else if(we.indexOf(G)!==-1)break;G=M()}}}function q(ge){const ce=n.getTokenValue();return ge?A(ce):y(ce),M(),!0}function me(){switch(n.getToken()){case 11:{let ge=0;try{ge=JSON.parse(n.getTokenValue()),typeof ge!="number"&&(H(2),ge=0)}catch{H(2)}A(ge);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return M(),!0}function x(){return n.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(O(":"),M(),_()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Q(){E(),M();let ge=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ge||H(4,[],[]),O(","),M(),n.getToken()===2&&z)break}else ge&&H(6,[],[]);x()||H(4,[],[2,5]),ge=!0}return u(),n.getToken()!==2?H(7,[2],[]):M(),!0}function V(){l(),M();let ge=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ge||H(4,[],[]),O(","),M(),n.getToken()===4&&z)break}else ge&&H(6,[],[]);_()||H(4,[],[4,5]),ge=!0}return w(),n.getToken()!==4?H(8,[4],[]):M(),!0}function _(){switch(n.getToken()){case 3:return V();case 1:return Q();case 10:return q(!0);default:return me()}}return M(),n.getToken()===17?a.allowEmptyContent?!0:(H(4,[],[]),!1):_()?(n.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.$Rm=d;function $(t,o){const a=R(t),n=[];let c,h=0,E;do switch(E=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:h!==E&&n.push(t.substring(h,E)),o!==void 0&&n.push(a.getTokenValue().replace(/[^\r\n]/g,o)),h=a.getPosition();break}while(c!==17);return n.join("")}e.$Sm=$;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=g}),define(De[59],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class C{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=C}),define(De[3],Ce([1,0,19,56,74,50]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=void 0;const R=!1;let m=null;class S{constructor(){this.b=new Map}static{this.a=0}c(l){let w=this.b.get(l);return w||(w={parent:null,source:null,isSingleton:!1,value:l,idx:S.a++},this.b.set(l,w)),w}trackDisposable(l){const w=this.c(l);w.source||(w.source=new Error().stack)}setParent(l,w){const A=this.c(l);A.parent=w}markAsDisposed(l){this.b.delete(l)}markAsSingleton(l){this.c(l).isSingleton=!0}f(l,w){const A=w.get(l);if(A)return A;const O=l.parent?this.f(this.c(l.parent),w):l;return w.set(l,O),O}getTrackedDisposables(){const l=new Map;return[...this.b.entries()].filter(([,A])=>A.source!==null&&!this.f(A,l).isSingleton).map(([A])=>A).flat()}computeLeakingDisposables(l=10,w){let A;if(w)A=w;else{const z=new Map,M=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,z).isSingleton);if(M.length===0)return;const H=new Set(M.map(q=>q.value));if(A=M.filter(q=>!(q.parent&&H.has(q.parent))),A.length===0)throw new Error("There are cyclic diposable chains!")}if(!A)return;function O(z){function M(q,me){for(;q.length>0&&me.some(x=>typeof x=="string"?x===q[0]:q[0].match(x));)q.shift()}const H=z.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return M(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const N=new F.$L;for(const z of A){const M=O(z);for(let H=0;H<=M.length;H++)N.add(M.slice(0,H).join(`
`),z)}A.sort((0,C.$4b)(z=>z.idx,C.$6b));let T="",j=0;for(const z of A.slice(0,l)){j++;const M=O(z),H=[];for(let q=0;q<M.length;q++){let me=M[q];me=`(shared with ${N.get(M.slice(0,q+1).join(`
`)).size}/${A.length} leaks) at ${me}`;const Q=N.get(M.slice(0,q).join(`
`)),V=(0,F.$I)([...Q].map(_=>O(_)[q]),_=>_);delete V[M[q]];for(const[_,ge]of Object.entries(V))H.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${_}`);H.unshift(me)}T+=`


==================== Leaking disposable ${j}/${A.length}: ${z.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return A.length>l&&(T+=`


... and ${A.length-l} more leaking disposables

`),{leaks:A,details:T}}}e.$$b=S;function b(u){m=u}if(e.$_b=b,R){const u="__is_disposable_tracked__";b(new class{trackDisposable(l){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[u]||console.log(w)},3e3)}setParent(l,w){if(l&&l!==g.None)try{l[u]=!0}catch{}}markAsDisposed(l){if(l&&l!==g.None)try{l[u]=!0}catch{}}markAsSingleton(l){}})}function P(u){return m?.trackDisposable(u),u}e.$ac=P;function I(u){m?.markAsDisposed(u)}e.$bc=I;function p(u,l){m?.setParent(u,l)}function k(u,l){if(m)for(const w of u)m.setParent(w,l)}function D(u){return m?.markAsSingleton(u),u}e.$cc=D;function v(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.$dc=v;function r(u){if(L.Iterable.is(u)){const l=[];for(const w of u)if(w)try{w.dispose()}catch(A){l.push(A)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.$ec=r;function i(u){for(const l of u)v(l)&&l.dispose();return[]}e.$fc=i;function s(...u){const l=d(()=>r(u));return k(u,l),l}e.$gc=s;function d(u){const l=P({dispose:(0,f.$bb)(()=>{I(l),u()})});return l}e.$hc=d;class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(I(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{r(this.f)}finally{this.f.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return p(l,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(l),l}}e.$ic=$;class g{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,P(this),p(this.q,this)}dispose(){I(this),this.q.dispose()}B(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(l)}}e.$jc=g;class t{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(l){this.b||l===this.a||(this.a?.dispose(),l&&p(l,this),this.a=l)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const l=this.a;return this.a=void 0,l&&p(l,null),l}}e.$kc=t;class o{constructor(l){this.b=l,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$lc=o;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(l){let w=l;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,I(this))},this}}e.$mc=a;class n{constructor(){this.a=new Map}acquire(l,...w){let A=this.a.get(l);A||(A={counter:0,object:this.b(l,...w)},this.a.set(l,A));const{object:O}=A,N=(0,f.$bb)(()=>{--A.counter===0&&(this.c(l,A.object),this.a.delete(l))});return A.counter++,{object:O,dispose:N}}}e.$nc=n;class c{constructor(l){this.a=l}async acquire(l,...w){const A=this.a.acquire(l,...w);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(O){throw A.dispose(),O}}}e.$oc=c;class h{constructor(l){this.object=l}dispose(){}}e.$pc=h;function E(u){const l=new $;try{u(l)}finally{l.dispose()}}e.$qc=E;class y{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{r(this.a.values())}finally{this.a.clear()}}has(l){return this.a.has(l)}get size(){return this.a.size}get(l){return this.a.get(l)}set(l,w,A=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this.a.get(l)?.dispose(),this.a.set(l,w)}deleteAndDispose(l){this.a.get(l)?.dispose(),this.a.delete(l)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$rc=y}),define(De[75],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=void 0;class C{static{this.Undefined=new C(void 0)}constructor(L){this.element=L,this.next=C.Undefined,this.prev=C.Undefined}}class F{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let L=this.a;for(;L!==C.Undefined;){const R=L.next;L.prev=C.Undefined,L.next=C.Undefined,L=R}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const m=new C(L);if(this.a===C.Undefined)this.a=m,this.b=m;else if(R){const b=this.b;this.b=m,m.prev=b,b.next=m}else{const b=this.a;this.a=m,m.next=b,b.prev=m}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(m))}}shift(){if(this.a!==C.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==C.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==C.Undefined&&L.next!==C.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===C.Undefined&&L.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):L.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):L.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==C.Undefined;)yield L.element,L=L.next}}e.$sc=F}),define(De[28],Ce([1,0]),function($e,e){"use strict";var C,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.Touch=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;function L(r,i,s){let d=r.get(i);return d===void 0&&(d=s,r.set(i,d)),d}e.$vi=L;function R(r){const i=[];return r.forEach((s,d)=>{i.push(`${d} => ${s}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.$wi=R;function m(r){const i=[];return r.forEach(s=>{i.push(s)}),`Set(${r.size}) {${i.join(", ")}}`}e.$xi=m;class S{constructor(i,s){this.uri=i,this.value=s}}class b{static{this.a=i=>i.toString()}constructor(i,s){this[C]="ResourceMap",i instanceof b?(this.b=new Map(i.b),this.c=s??b.a):(this.b=new Map,this.c=i??b.a)}set(i,s){return this.b.set(this.c(i),new S(i,s)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[d,$]of this.b)i($.value,$.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$yi=b;class P{constructor(i,s){this[F]="ResourceSet",!i||typeof i=="function"?this.a=new b(i):(this.a=new b(s),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,s){this.a.forEach((d,$)=>i.call(s,$,$,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zi=P;var I;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class p{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,s=0){const d=this.a.get(i);if(d)return s!==0&&this.j(d,s),d.value}set(i,s,d=0){let $=this.a.get(i);if($)$.value=s,d!==0&&this.j($,d);else{switch($={key:i,value:s,next:void 0,previous:void 0},d){case 0:this.h($);break;case 1:this.g($);break;case 2:this.h($);break;default:this.h($);break}this.a.set(i,$),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this.a.get(i);if(s)return this.a.delete(i),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,s){const d=this.e;let $=this.b;for(;$;){if(s?i.bind(s)($.value,$.key,this):i($.value,$.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");$=$.next}}keys(){const i=this,s=this.e;let d=this.b;const $={[Symbol.iterator](){return $},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.key,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return $}values(){const i=this,s=this.e;let d=this.b;const $={[Symbol.iterator](){return $},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.value,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return $}entries(){const i=this,s=this.e;let d=this.b;const $={[Symbol.iterator](){return $},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:[d.key,d.value],done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return $}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.b,d=this.size;for(;s&&d>i;)this.a.delete(s.key),s=s.next,d--;this.b=s,this.d=d,s&&(s.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const s=i.next,d=i.previous;if(!s||!d)throw new Error("Invalid list");s.previous=d,d.next=s}i.next=void 0,i.previous=void 0,this.e++}j(i,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this.b)return;const d=i.next,$=i.previous;i===this.c?($.next=void 0,this.c=$):(d.previous=$,$.next=d),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(s===2){if(i===this.c)return;const d=i.next,$=i.previous;i===this.b?(d.previous=void 0,this.b=d):(d.previous=$,$.next=d),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((s,d)=>{i.push([d,s])}),i}fromJSON(i){this.clear();for(const[s,d]of i)this.set(s,d)}}e.$Ai=p;class k extends p{constructor(i,s=1){super(),this.k=i,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bi=k;class D{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let s=this.a.get(i)||0;return s===0?!1:(s--,s===0?this.a.delete(i):this.a.set(i,s),!0)}has(i){return this.a.has(i)}}e.$Ci=D;class v{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[s,d]of i)this.set(s,d)}clear(){this.a.clear(),this.b.clear()}set(i,s){this.a.set(i,s),this.b.set(s,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const s=this.a.get(i);return s===void 0?!1:(this.a.delete(i),this.b.delete(s),!0)}forEach(i,s){this.a.forEach((d,$)=>{i.call(s,d,$,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Di=v}),function($e,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(re,le){for(var Ee=0;Ee<le.length;Ee++){var he=le[Ee];he.enumerable=he.enumerable||!1,he.configurable=!0,"value"in he&&(he.writable=!0),Object.defineProperty(re,he.key,he)}}function C(re,le,Ee){return le&&e(re.prototype,le),Ee&&e(re,Ee),Object.defineProperty(re,"prototype",{writable:!1}),re}function F(re,le){if(re){if(typeof re=="string")return f(re,le);var Ee=Object.prototype.toString.call(re).slice(8,-1);if(Ee==="Object"&&re.constructor&&(Ee=re.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(re);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return f(re,le)}}function f(re,le){(le==null||le>re.length)&&(le=re.length);for(var Ee=0,he=new Array(le);Ee<le;Ee++)he[Ee]=re[Ee];return he}function L(re,le){var Ee=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(Ee)return(Ee=Ee.call(re)).next.bind(Ee);if(Array.isArray(re)||(Ee=F(re))||le&&re&&typeof re.length=="number"){Ee&&(re=Ee);var he=0;return function(){return he>=re.length?{done:!0}:{done:!1,value:re[he++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=R();function m(re){$e.defaults=re}var S=/[&<>"']/,b=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(le){return p[le]};function D(re,le){if(le){if(S.test(re))return re.replace(b,k)}else if(P.test(re))return re.replace(I,k);return re}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(re){return re.replace(v,function(le,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var i=/(^|[^\[])\^/g;function s(re,le){re=typeof re=="string"?re:re.source,le=le||"";var Ee={replace:function(fe,te){return te=te.source||te,te=te.replace(i,"$1"),re=re.replace(fe,te),Ee},getRegex:function(){return new RegExp(re,le)}};return Ee}var d=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(re,le,Ee){if(re){var he;try{he=decodeURIComponent(r(Ee)).replace(d,"").toLowerCase()}catch{return null}if(he.indexOf("javascript:")===0||he.indexOf("vbscript:")===0||he.indexOf("data:")===0)return null}le&&!$.test(Ee)&&(Ee=c(le,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},o=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(re,le){t[" "+re]||(o.test(re)?t[" "+re]=re+"/":t[" "+re]=u(re,"/",!0)),re=t[" "+re];var Ee=re.indexOf(":")===-1;return le.substring(0,2)==="//"?Ee?le:re.replace(a,"$1")+le:le.charAt(0)==="/"?Ee?le:re.replace(n,"$1")+le:re+le}var h={exec:function(){}};function E(re){for(var le=1,Ee,he;le<arguments.length;le++){Ee=arguments[le];for(he in Ee)Object.prototype.hasOwnProperty.call(Ee,he)&&(re[he]=Ee[he])}return re}function y(re,le){var Ee=re.replace(/\|/g,function(te,ue,be){for(var Pe=!1,B=ue;--B>=0&&be[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),he=Ee.split(/ \|/),fe=0;if(he[0].trim()||he.shift(),he.length>0&&!he[he.length-1].trim()&&he.pop(),he.length>le)he.splice(le);else for(;he.length<le;)he.push("");for(;fe<he.length;fe++)he[fe]=he[fe].trim().replace(/\\\|/g,"|");return he}function u(re,le,Ee){var he=re.length;if(he===0)return"";for(var fe=0;fe<he;){var te=re.charAt(he-fe-1);if(te===le&&!Ee)fe++;else if(te!==le&&Ee)fe++;else break}return re.slice(0,he-fe)}function l(re,le){if(re.indexOf(le[1])===-1)return-1;for(var Ee=re.length,he=0,fe=0;fe<Ee;fe++)if(re[fe]==="\\")fe++;else if(re[fe]===le[0])he++;else if(re[fe]===le[1]&&(he--,he<0))return fe;return-1}function w(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(re,le){if(le<1)return"";for(var Ee="";le>1;)le&1&&(Ee+=re),le>>=1,re+=re;return Ee+re}function O(re,le,Ee,he){var fe=le.href,te=le.title?D(le.title):null,ue=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){he.state.inLink=!0;var be={type:"link",raw:Ee,href:fe,title:te,text:ue,tokens:he.inlineTokens(ue)};return he.state.inLink=!1,be}return{type:"image",raw:Ee,href:fe,title:te,text:D(ue)}}function N(re,le){var Ee=re.match(/^(\s+)(?:```)/);if(Ee===null)return le;var he=Ee[1];return le.split(`
`).map(function(fe){var te=fe.match(/^\s+/);if(te===null)return fe;var ue=te[0];return ue.length>=he.length?fe.slice(he.length):fe}).join(`
`)}var T=function(){function re(Ee){this.options=Ee||$e.defaults}var le=re.prototype;return le.space=function(he){var fe=this.rules.block.newline.exec(he);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},le.code=function(he){var fe=this.rules.block.code.exec(he);if(fe){var te=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?te:u(te,`
`)}}},le.fences=function(he){var fe=this.rules.block.fences.exec(he);if(fe){var te=fe[0],ue=N(te,fe[3]||"");return{type:"code",raw:te,lang:fe[2]?fe[2].trim():fe[2],text:ue}}},le.heading=function(he){var fe=this.rules.block.heading.exec(he);if(fe){var te=fe[2].trim();if(/#$/.test(te)){var ue=u(te,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(te=ue.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:te,tokens:this.lexer.inline(te)}}},le.hr=function(he){var fe=this.rules.block.hr.exec(he);if(fe)return{type:"hr",raw:fe[0]}},le.blockquote=function(he){var fe=this.rules.block.blockquote.exec(he);if(fe){var te=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},le.list=function(he){var fe=this.rules.block.list.exec(he);if(fe){var te,ue,be,Pe,B,X,ee,ne,Z,de,ye,je,We=fe[1].trim(),xe=We.length>1,Qe={type:"list",raw:"",ordered:xe,start:xe?+We.slice(0,-1):"",loose:!1,items:[]};We=xe?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=xe?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");he&&(je=!1,!(!(fe=it.exec(he))||this.rules.block.hr.test(he)));){if(te=fe[0],he=he.substring(te.length),ne=fe[2].split(`
`,1)[0],Z=he.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=ne.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=ne.slice(Pe),Pe+=fe[1].length),X=!1,!ne&&/^ *$/.test(Z)&&(te+=Z+`
`,he=he.substring(Z.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");he&&(de=he.split(`
`,1)[0],ne=de,this.options.pedantic&&(ne=ne.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(ne)||Ve.test(ne)||et.test(ne)||Ae.test(he)));){if(ne.search(/[^ ]/)>=Pe||!ne.trim())ye+=`
`+ne.slice(Pe);else if(!X)ye+=`
`+ne;else break;!X&&!ne.trim()&&(X=!0),te+=de+`
`,he=he.substring(de.length+1)}Qe.loose||(ee?Qe.loose=!0:/\n *\n *$/.test(te)&&(ee=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(ye),ue&&(be=ue[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:te,task:!!ue,checked:be,loose:!1,text:ye}),Qe.raw+=te}Qe.items[Qe.items.length-1].raw=te.trimRight(),Qe.items[Qe.items.length-1].text=ye.trimRight(),Qe.raw=Qe.raw.trimRight();var Le=Qe.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Qe.items[B].tokens=this.lexer.blockTokens(Qe.items[B].text,[]);var Xe=Qe.items[B].tokens.filter(function(oe){return oe.type==="space"}),ae=Xe.every(function(oe){for(var Ie=oe.raw.split(""),qe=0,ze=L(Ie),Ze;!(Ze=ze()).done;){var nt=Ze.value;if(nt===`
`&&(qe+=1),qe>1)return!0}return!1});!Qe.loose&&Xe.length&&ae&&(Qe.loose=!0,Qe.items[B].loose=!0)}return Qe}},le.html=function(he){var fe=this.rules.block.html.exec(he);if(fe){var te={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(fe[0]):D(fe[0]);te.type="paragraph",te.text=ue,te.tokens=this.lexer.inline(ue)}return te}},le.def=function(he){var fe=this.rules.block.def.exec(he);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var te=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:fe[0],href:fe[2],title:fe[3]}}},le.table=function(he){var fe=this.rules.block.table.exec(he);if(fe){var te={type:"table",header:y(fe[1]).map(function(ee){return{text:ee}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=fe[0];var ue=te.align.length,be,Pe,B,X;for(be=0;be<ue;be++)/^ *-+: *$/.test(te.align[be])?te.align[be]="right":/^ *:-+: *$/.test(te.align[be])?te.align[be]="center":/^ *:-+ *$/.test(te.align[be])?te.align[be]="left":te.align[be]=null;for(ue=te.rows.length,be=0;be<ue;be++)te.rows[be]=y(te.rows[be],te.header.length).map(function(ee){return{text:ee}});for(ue=te.header.length,Pe=0;Pe<ue;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(ue=te.rows.length,Pe=0;Pe<ue;Pe++)for(X=te.rows[Pe],B=0;B<X.length;B++)X[B].tokens=this.lexer.inline(X[B].text);return te}}},le.lheading=function(he){var fe=this.rules.block.lheading.exec(he);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},le.paragraph=function(he){var fe=this.rules.block.paragraph.exec(he);if(fe){var te=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:te,tokens:this.lexer.inline(te)}}},le.text=function(he){var fe=this.rules.block.text.exec(he);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},le.escape=function(he){var fe=this.rules.inline.escape.exec(he);if(fe)return{type:"escape",raw:fe[0],text:D(fe[1])}},le.tag=function(he){var fe=this.rules.inline.tag.exec(he);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):D(fe[0]):fe[0]}},le.link=function(he){var fe=this.rules.inline.link.exec(he);if(fe){var te=fe[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var ue=u(te.slice(0,-1),"\\");if((te.length-ue.length)%2===0)return}else{var be=l(fe[2],"()");if(be>-1){var Pe=fe[0].indexOf("!")===0?5:4,B=Pe+fe[1].length+be;fe[2]=fe[2].substring(0,be),fe[0]=fe[0].substring(0,B).trim(),fe[3]=""}}var X=fe[2],ee="";if(this.options.pedantic){var ne=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);ne&&(X=ne[1],ee=ne[3])}else ee=fe[3]?fe[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(te)?X=X.slice(1):X=X.slice(1,-1)),O(fe,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:ee&&ee.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},le.reflink=function(he,fe){var te;if((te=this.rules.inline.reflink.exec(he))||(te=this.rules.inline.nolink.exec(he))){var ue=(te[2]||te[1]).replace(/\s+/g," ");if(ue=fe[ue.toLowerCase()],!ue||!ue.href){var be=te[0].charAt(0);return{type:"text",raw:be,text:be}}return O(te,ue,te[0],this.lexer)}},le.emStrong=function(he,fe,te){te===void 0&&(te="");var ue=this.rules.inline.emStrong.lDelim.exec(he);if(ue&&!(ue[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=ue[1]||ue[2]||"";if(!be||be&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=ue[0].length-1,B,X,ee=Pe,ne=0,Z=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,fe=fe.slice(-1*he.length+Pe);(ue=Z.exec(fe))!=null;)if(B=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!B){if(X=B.length,ue[3]||ue[4]){ee+=X;continue}else if((ue[5]||ue[6])&&Pe%3&&!((Pe+X)%3)){ne+=X;continue}if(ee-=X,!(ee>0)){if(X=Math.min(X,X+ee+ne),Math.min(Pe,X)%2){var de=he.slice(1,Pe+ue.index+X);return{type:"em",raw:he.slice(0,Pe+ue.index+X+1),text:de,tokens:this.lexer.inlineTokens(de)}}var ye=he.slice(2,Pe+ue.index+X-1);return{type:"strong",raw:he.slice(0,Pe+ue.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(he){var fe=this.rules.inline.code.exec(he);if(fe){var te=fe[2].replace(/\n/g," "),ue=/[^ ]/.test(te),be=/^ /.test(te)&&/ $/.test(te);return ue&&be&&(te=te.substring(1,te.length-1)),te=D(te,!0),{type:"codespan",raw:fe[0],text:te}}},le.br=function(he){var fe=this.rules.inline.br.exec(he);if(fe)return{type:"br",raw:fe[0]}},le.del=function(he){var fe=this.rules.inline.del.exec(he);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},le.autolink=function(he,fe){var te=this.rules.inline.autolink.exec(he);if(te){var ue,be;return te[2]==="@"?(ue=D(this.options.mangle?fe(te[1]):te[1]),be="mailto:"+ue):(ue=D(te[1]),be=ue),{type:"link",raw:te[0],text:ue,href:be,tokens:[{type:"text",raw:ue,text:ue}]}}},le.url=function(he,fe){var te;if(te=this.rules.inline.url.exec(he)){var ue,be;if(te[2]==="@")ue=D(this.options.mangle?fe(te[0]):te[0]),be="mailto:"+ue;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);ue=D(te[0]),te[1]==="www."?be="http://"+ue:be=ue}return{type:"link",raw:te[0],text:ue,href:be,tokens:[{type:"text",raw:ue,text:ue}]}}},le.inlineText=function(he,fe){var te=this.rules.inline.text.exec(he);if(te){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):D(te[0]):te[0]:ue=D(this.options.smartypants?fe(te[0]):te[0]),{type:"text",raw:te[0],text:ue}}},re}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=s(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=s(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=s(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=s(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=s(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=s(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=E({},j),j.gfm=E({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=s(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=s(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=E({},j.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:s(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=s(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=s(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=s(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=s(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=s(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=s(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=s(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=s(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=s(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=s(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=s(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=E({},z),z.pedantic=E({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=E({},z.normal,{escape:s(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=s(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=E({},z.gfm,{br:s(z.br).replace("{2,}","*").getRegex(),text:s(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(re){var le="",Ee,he,fe=re.length;for(Ee=0;Ee<fe;Ee++)he=re.charCodeAt(Ee),Math.random()>.5&&(he="x"+he.toString(16)),le+="&#"+he+";";return le}var q=function(){function re(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||$e.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var he={block:j.normal,inline:z.normal};this.options.pedantic?(he.block=j.pedantic,he.inline=z.pedantic):this.options.gfm&&(he.block=j.gfm,this.options.breaks?he.inline=z.breaks:he.inline=z.gfm),this.tokenizer.rules=he}re.lex=function(he,fe){var te=new re(fe);return te.lex(he)},re.lexInline=function(he,fe){var te=new re(fe);return te.inlineTokens(he)};var le=re.prototype;return le.lex=function(he){he=he.replace(/\r\n|\r/g,`
`),this.blockTokens(he,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},le.blockTokens=function(he,fe){var te=this;fe===void 0&&(fe=[]),this.options.pedantic?he=he.replace(/\t/g,"    ").replace(/^ +$/gm,""):he=he.replace(/^( *)(\t+)/gm,function(ee,ne,Z){return ne+"    ".repeat(Z.length)});for(var ue,be,Pe,B;he;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ee){return(ue=ee.call({lexer:te},he,fe))?(he=he.substring(ue.raw.length),fe.push(ue),!0):!1}))){if(ue=this.tokenizer.space(he)){he=he.substring(ue.raw.length),ue.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(ue);continue}if(ue=this.tokenizer.code(he)){he=he.substring(ue.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+ue.raw,be.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(ue);continue}if(ue=this.tokenizer.fences(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.heading(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.hr(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.blockquote(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.list(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.html(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.def(he)){he=he.substring(ue.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+ue.raw,be.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.lheading(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(Pe=he,this.options.extensions&&this.options.extensions.startBlock&&function(){var ee=1/0,ne=he.slice(1),Z=void 0;te.options.extensions.startBlock.forEach(function(de){Z=de.call({lexer:this},ne),typeof Z=="number"&&Z>=0&&(ee=Math.min(ee,Z))}),ee<1/0&&ee>=0&&(Pe=he.substring(0,ee+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(Pe))){be=fe[fe.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+ue.raw,be.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(ue),B=Pe.length!==he.length,he=he.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(he)){he=he.substring(ue.raw.length),be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=`
`+ue.raw,be.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(ue);continue}if(he){var X="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,fe},le.inline=function(he,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:he,tokens:fe}),fe},le.inlineTokens=function(he,fe){var te=this;fe===void 0&&(fe=[]);var ue,be,Pe,B=he,X,ee,ne;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Z.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,X.index)+"["+A("a",X[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,X.index)+"["+A("a",X[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,X.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;he;)if(ee||(ne=""),ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ue=ye.call({lexer:te},he,fe))?(he=he.substring(ue.raw.length),fe.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.tag(he)){he=he.substring(ue.raw.length),be=fe[fe.length-1],be&&ue.type==="text"&&be.type==="text"?(be.raw+=ue.raw,be.text+=ue.text):fe.push(ue);continue}if(ue=this.tokenizer.link(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.reflink(he,this.tokens.links)){he=he.substring(ue.raw.length),be=fe[fe.length-1],be&&ue.type==="text"&&be.type==="text"?(be.raw+=ue.raw,be.text+=ue.text):fe.push(ue);continue}if(ue=this.tokenizer.emStrong(he,B,ne)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.codespan(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.br(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.del(he)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.autolink(he,H)){he=he.substring(ue.raw.length),fe.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(he,H))){he=he.substring(ue.raw.length),fe.push(ue);continue}if(Pe=he,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=he.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(xe){We=xe.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=he.substring(0,ye+1))}(),ue=this.tokenizer.inlineText(Pe,M)){he=he.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(ne=ue.raw.slice(-1)),ee=!0,be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=ue.raw,be.text+=ue.text):fe.push(ue);continue}if(he){var de="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return fe},C(re,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),re}(),me=function(){function re(Ee){this.options=Ee||$e.defaults}var le=re.prototype;return le.code=function(he,fe,te){var ue=(fe||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(he,ue);be!=null&&be!==he&&(te=!0,he=be)}return he=he.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+D(ue,!0)+'">'+(te?he:D(he,!0))+`</code></pre>
`:"<pre><code>"+(te?he:D(he,!0))+`</code></pre>
`},le.blockquote=function(he){return`<blockquote>
`+he+`</blockquote>
`},le.html=function(he){return he},le.heading=function(he,fe,te,ue){if(this.options.headerIds){var be=this.options.headerPrefix+ue.slug(te);return"<h"+fe+' id="'+be+'">'+he+"</h"+fe+`>
`}return"<h"+fe+">"+he+"</h"+fe+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(he,fe,te){var ue=fe?"ol":"ul",be=fe&&te!==1?' start="'+te+'"':"";return"<"+ue+be+`>
`+he+"</"+ue+`>
`},le.listitem=function(he){return"<li>"+he+`</li>
`},le.checkbox=function(he){return"<input "+(he?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(he){return"<p>"+he+`</p>
`},le.table=function(he,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+he+`</thead>
`+fe+`</table>
`},le.tablerow=function(he){return`<tr>
`+he+`</tr>
`},le.tablecell=function(he,fe){var te=fe.header?"th":"td",ue=fe.align?"<"+te+' align="'+fe.align+'">':"<"+te+">";return ue+he+("</"+te+`>
`)},le.strong=function(he){return"<strong>"+he+"</strong>"},le.em=function(he){return"<em>"+he+"</em>"},le.codespan=function(he){return"<code>"+he+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(he){return"<del>"+he+"</del>"},le.link=function(he,fe,te){if(he=g(this.options.sanitize,this.options.baseUrl,he),he===null)return te;var ue='<a href="'+D(he)+'"';return fe&&(ue+=' title="'+fe+'"'),ue+=">"+te+"</a>",ue},le.image=function(he,fe,te){if(he=g(this.options.sanitize,this.options.baseUrl,he),he===null)return te;var ue='<img src="'+he+'" alt="'+te+'"';return fe&&(ue+=' title="'+fe+'"'),ue+=this.options.xhtml?"/>":">",ue},le.text=function(he){return he},re}(),x=function(){function re(){}var le=re.prototype;return le.strong=function(he){return he},le.em=function(he){return he},le.codespan=function(he){return he},le.del=function(he){return he},le.html=function(he){return he},le.text=function(he){return he},le.link=function(he,fe,te){return""+te},le.image=function(he,fe,te){return""+te},le.br=function(){return""},re}(),Q=function(){function re(){this.seen={}}var le=re.prototype;return le.serialize=function(he){return he.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(he,fe){var te=he,ue=0;if(this.seen.hasOwnProperty(te)){ue=this.seen[he];do ue++,te=he+"-"+ue;while(this.seen.hasOwnProperty(te))}return fe||(this.seen[he]=ue,this.seen[te]=0),te},le.slug=function(he,fe){fe===void 0&&(fe={});var te=this.serialize(he);return this.getNextSafeSlug(te,fe.dryrun)},re}(),V=function(){function re(Ee){this.options=Ee||$e.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Q}re.parse=function(he,fe){var te=new re(fe);return te.parse(he)},re.parseInline=function(he,fe){var te=new re(fe);return te.parseInline(he)};var le=re.prototype;return le.parse=function(he,fe){fe===void 0&&(fe=!0);var te="",ue,be,Pe,B,X,ee,ne,Z,de,ye,je,We,xe,Qe,it,et,Ae,Oe,Ve,Le=he.length;for(ue=0;ue<Le;ue++){if(ye=he[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){te+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,r(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Z="",ne="",B=ye.header.length,be=0;be<B;be++)ne+=this.renderer.tablecell(this.parseInline(ye.header[be].tokens),{header:!0,align:ye.align[be]});for(Z+=this.renderer.tablerow(ne),de="",B=ye.rows.length,be=0;be<B;be++){for(ee=ye.rows[be],ne="",X=ee.length,Pe=0;Pe<X;Pe++)ne+=this.renderer.tablecell(this.parseInline(ee[Pe].tokens),{header:!1,align:ye.align[Pe]});de+=this.renderer.tablerow(ne)}te+=this.renderer.table(Z,de);continue}case"blockquote":{de=this.parse(ye.tokens),te+=this.renderer.blockquote(de);continue}case"list":{for(je=ye.ordered,We=ye.start,xe=ye.loose,B=ye.items.length,de="",be=0;be<B;be++)it=ye.items[be],et=it.checked,Ae=it.task,Qe="",it.task&&(Oe=this.renderer.checkbox(et),xe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Oe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Oe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Oe}):Qe+=Oe),Qe+=this.parse(it.tokens,xe),de+=this.renderer.listitem(Qe,Ae,et);te+=this.renderer.list(de,je,We);continue}case"html":{te+=this.renderer.html(ye.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(de=ye.tokens?this.parseInline(ye.tokens):ye.text;ue+1<Le&&he[ue+1].type==="text";)ye=he[++ue],de+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);te+=fe?this.renderer.paragraph(de):de;continue}default:{var Xe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return te},le.parseInline=function(he,fe){fe=fe||this.renderer;var te="",ue,be,Pe,B=he.length;for(ue=0;ue<B;ue++){if(be=he[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){te+=Pe||"";continue}switch(be.type){case"escape":{te+=fe.text(be.text);break}case"html":{te+=fe.html(be.text);break}case"link":{te+=fe.link(be.href,be.title,this.parseInline(be.tokens,fe));break}case"image":{te+=fe.image(be.href,be.title,be.text);break}case"strong":{te+=fe.strong(this.parseInline(be.tokens,fe));break}case"em":{te+=fe.em(this.parseInline(be.tokens,fe));break}case"codespan":{te+=fe.codespan(be.text);break}case"br":{te+=fe.br();break}case"del":{te+=fe.del(this.parseInline(be.tokens,fe));break}case"text":{te+=fe.text(be.text);break}default:{var X='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return te},re}();function _(re,le,Ee){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof le=="function"&&(Ee=le,le=null),le=E({},_.defaults,le||{}),w(le),Ee){var he=le.highlight,fe;try{fe=q.lex(re,le)}catch(B){return Ee(B)}var te=function(X){var ee;if(!X)try{le.walkTokens&&_.walkTokens(fe,le.walkTokens),ee=V.parse(fe,le)}catch(ne){X=ne}return le.highlight=he,X?Ee(X):Ee(null,ee)};if(!he||he.length<3||(delete le.highlight,!fe.length))return te();var ue=0;_.walkTokens(fe,function(B){B.type==="code"&&(ue++,setTimeout(function(){he(B.text,B.lang,function(X,ee){if(X)return te(X);ee!=null&&ee!==B.text&&(B.text=ee,B.escaped=!0),ue--,ue===0&&te()})},0))}),ue===0&&te();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+D(B.message+"",!0)+"</pre>";throw B}try{var Pe=q.lex(re,le);if(le.walkTokens){if(le.async)return Promise.all(_.walkTokens(Pe,le.walkTokens)).then(function(){return V.parse(Pe,le)}).catch(be);_.walkTokens(Pe,le.walkTokens)}return V.parse(Pe,le)}catch(B){be(B)}}_.options=_.setOptions=function(re){return E(_.defaults,re),m(_.defaults),_},_.getDefaults=R,_.defaults=$e.defaults,_.use=function(){for(var re=arguments.length,le=new Array(re),Ee=0;Ee<re;Ee++)le[Ee]=arguments[Ee];var he=E.apply(void 0,[{}].concat(le)),fe=_.defaults.extensions||{renderers:{},childTokens:{}},te;le.forEach(function(ue){if(ue.extensions&&(te=!0,ue.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=fe.renderers?fe.renderers[Pe.name]:null;B?fe.renderers[Pe.name]=function(){for(var X=arguments.length,ee=new Array(X),ne=0;ne<X;ne++)ee[ne]=arguments[ne];var Z=Pe.renderer.apply(this,ee);return Z===!1&&(Z=B.apply(this,ee)),Z}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),ue.renderer&&function(){var Pe=_.defaults.renderer||new me,B=function(ne){var Z=Pe[ne];Pe[ne]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=ue.renderer[ne].apply(Pe,ye);return We===!1&&(We=Z.apply(Pe,ye)),We}};for(var X in ue.renderer)B(X);he.renderer=Pe}(),ue.tokenizer&&function(){var Pe=_.defaults.tokenizer||new T,B=function(ne){var Z=Pe[ne];Pe[ne]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=ue.tokenizer[ne].apply(Pe,ye);return We===!1&&(We=Z.apply(Pe,ye)),We}};for(var X in ue.tokenizer)B(X);he.tokenizer=Pe}(),ue.walkTokens){var be=_.defaults.walkTokens;he.walkTokens=function(Pe){var B=[];return B.push(ue.walkTokens.call(this,Pe)),be&&(B=B.concat(be.call(this,Pe))),B}}te&&(he.extensions=fe),_.setOptions(he)})},_.walkTokens=function(re,le){for(var Ee=[],he=function(){var be=te.value;switch(Ee=Ee.concat(le.call(_,be)),be.type){case"table":{for(var Pe=L(be.header),B;!(B=Pe()).done;){var X=B.value;Ee=Ee.concat(_.walkTokens(X.tokens,le))}for(var ee=L(be.rows),ne;!(ne=ee()).done;)for(var Z=ne.value,de=L(Z),ye;!(ye=de()).done;){var je=ye.value;Ee=Ee.concat(_.walkTokens(je.tokens,le))}break}case"list":{Ee=Ee.concat(_.walkTokens(be.items,le));break}default:_.defaults.extensions&&_.defaults.extensions.childTokens&&_.defaults.extensions.childTokens[be.type]?_.defaults.extensions.childTokens[be.type].forEach(function(We){Ee=Ee.concat(_.walkTokens(be[We],le))}):be.tokens&&(Ee=Ee.concat(_.walkTokens(be.tokens,le)))}},fe=L(re),te;!(te=fe()).done;)he();return Ee},_.parseInline=function(re,le){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");le=E({},_.defaults,le||{}),w(le);try{var Ee=q.lexInline(re,le);return le.walkTokens&&_.walkTokens(Ee,le.walkTokens),V.parseInline(Ee,le)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+D(he.message+"",!0)+"</pre>";throw he}},_.Parser=V,_.parser=V.parse,_.Renderer=me,_.TextRenderer=x,_.Lexer=q,_.lexer=q.lex,_.Tokenizer=T,_.Slugger=Q,_.parse=_;var ge=_.options,ce=_.setOptions,we=_.use,G=_.walkTokens,U=_.parseInline,K=_,Y=V.parse,se=q.lex;$e.Lexer=q,$e.Parser=V,$e.Renderer=me,$e.Slugger=Q,$e.TextRenderer=x,$e.Tokenizer=T,$e.getDefaults=R,$e.lexer=se,$e.marked=_,$e.options=ge,$e.parse=K,$e.parseInline=U,$e.parser=Y,$e.setOptions=ce,$e.use=we,$e.walkTokens=G,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[76],Ce([1,0,28]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=e.$gl=void 0;const F=new C.$Bi(1e4);function f(b){return S(b,"NFC",F)}e.$gl=f;const L=new C.$Bi(1e4);function R(b){return S(b,"NFD",L)}e.$hl=R;const m=/[^\u0000-\u0080]/;function S(b,P,I){if(!b)return b;const p=I.get(b);if(p)return p;let k;return m.test(b)?k=b.normalize(P):k=b,I.set(b,k),k}e.$il=function(){const b=/[\u0300-\u036f]/g;return function(P){return R(P).replace(b,"")}}()}),define(De[120],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.rot=e.$Gl=void 0;function C(m,S,b){return Math.min(Math.max(m,S),b)}e.$Gl=C;function F(m,S){return(S+m%S)%S}e.rot=F;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Il=f;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jl=L;class R{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const b=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Kl=R}),function(){function $e(f){const L=[];typeof f=="number"&&L.push("code/timeOrigin",f);function R(S){L.push(S,Date.now())}function m(){const S=[];for(let b=0;b<L.length;b+=2)S.push({name:L[b],startTime:L[b+1]});return S}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(f+R.startTime)});return L}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function C(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=C(F))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var F in C)(typeof exports=="object"?exports:$e)[F]=C[F]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function C(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return $e[F].call(f.exports,f,f.exports,C),f.l=!0,f.exports}return C.m=$e,C.c=e,C.d=function(F,f,L){C.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:L})},C.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},C.t=function(F,f){if(1&f&&(F=C(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(C.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var R in F)C.d(L,R,function(m){return F[m]}.bind(null,R));return L},C.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return C.d(f,"a",f),f},C.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},C.p="",C(C.s=0)}([function($e,e,C){(function(F){var f;e=$e.exports=we,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],S=e.src=[],b=0,P=b++;S[P]="0|[1-9]\\d*";var I=b++;S[I]="[0-9]+";var p=b++;S[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=b++;S[k]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var D=b++;S[D]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var v=b++;S[v]="(?:"+S[P]+"|"+S[p]+")";var r=b++;S[r]="(?:"+S[I]+"|"+S[p]+")";var i=b++;S[i]="(?:-("+S[v]+"(?:\\."+S[v]+")*))";var s=b++;S[s]="(?:-?("+S[r]+"(?:\\."+S[r]+")*))";var d=b++;S[d]="[0-9A-Za-z-]+";var $=b++;S[$]="(?:\\+("+S[d]+"(?:\\."+S[d]+")*))";var g=b++,t="v?"+S[k]+S[i]+"?"+S[$]+"?";S[g]="^"+t+"$";var o="[v=\\s]*"+S[D]+S[s]+"?"+S[$]+"?",a=b++;S[a]="^"+o+"$";var n=b++;S[n]="((?:<|>)?=?)";var c=b++;S[c]=S[I]+"|x|X|\\*";var h=b++;S[h]=S[P]+"|x|X|\\*";var E=b++;S[E]="[v=\\s]*("+S[h]+")(?:\\.("+S[h]+")(?:\\.("+S[h]+")(?:"+S[i]+")?"+S[$]+"?)?)?";var y=b++;S[y]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[s]+")?"+S[$]+"?)?)?";var u=b++;S[u]="^"+S[n]+"\\s*"+S[E]+"$";var l=b++;S[l]="^"+S[n]+"\\s*"+S[y]+"$";var w=b++;S[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=b++;S[A]="(?:~>?)";var O=b++;S[O]="(\\s*)"+S[A]+"\\s+",m[O]=new RegExp(S[O],"g");var N=b++;S[N]="^"+S[A]+S[E]+"$";var T=b++;S[T]="^"+S[A]+S[y]+"$";var j=b++;S[j]="(?:\\^)";var z=b++;S[z]="(\\s*)"+S[j]+"\\s+",m[z]=new RegExp(S[z],"g");var M=b++;S[M]="^"+S[j]+S[E]+"$";var H=b++;S[H]="^"+S[j]+S[y]+"$";var q=b++;S[q]="^"+S[n]+"\\s*("+o+")$|^$";var me=b++;S[me]="^"+S[n]+"\\s*("+t+")$|^$";var x=b++;S[x]="(\\s*)"+S[n]+"\\s*("+o+"|"+S[E]+")",m[x]=new RegExp(S[x],"g");var Q=b++;S[Q]="^\\s*("+S[E]+")\\s+-\\s+("+S[E]+")\\s*$";var V=b++;S[V]="^\\s*("+S[y]+")\\s+-\\s+("+S[y]+")\\s*$";var _=b++;S[_]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)f(ge,S[ge]),m[ge]||(m[ge]=new RegExp(S[ge]));function ce(Z,de){if(Z instanceof we)return Z;if(typeof Z!="string"||Z.length>L||!(de?m[a]:m[g]).test(Z))return null;try{return new we(Z,de)}catch{return null}}function we(Z,de){if(Z instanceof we){if(Z.loose===de)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof we))return new we(Z,de);f("SemVer",Z,de),this.loose=de;var ye=Z.trim().match(de?m[a]:m[g]);if(!ye)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<R)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Z,de){var ye=ce(Z,de);return ye?ye.version:null},e.clean=function(Z,de){var ye=ce(Z.trim().replace(/^[=v]+/,""),de);return ye?ye.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(Z){return f("SemVer.compare",this.version,this.loose,Z),Z instanceof we||(Z=new we(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},we.prototype.compareMain=function(Z){return Z instanceof we||(Z=new we(Z,this.loose)),U(this.major,Z.major)||U(this.minor,Z.minor)||U(this.patch,Z.patch)},we.prototype.comparePre=function(Z){if(Z instanceof we||(Z=new we(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var de=0;do{var ye=this.prerelease[de],je=Z.prerelease[de];if(f("prerelease compare",de,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++de)},we.prototype.inc=function(Z,de){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,de,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new we(Z,ye).inc(de,je).version}catch{return null}},e.diff=function(Z,de){if(re(Z,de))return null;var ye=ce(Z),je=ce(de);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var G=/^[0-9]+$/;function U(Z,de){var ye=G.test(Z),je=G.test(de);return ye&&je&&(Z=+Z,de=+de),ye&&!je?-1:je&&!ye?1:Z<de?-1:Z>de?1:0}function K(Z,de,ye){return new we(Z,ye).compare(new we(de,ye))}function Y(Z,de,ye){return K(Z,de,ye)>0}function se(Z,de,ye){return K(Z,de,ye)<0}function re(Z,de,ye){return K(Z,de,ye)===0}function le(Z,de,ye){return K(Z,de,ye)!==0}function Ee(Z,de,ye){return K(Z,de,ye)>=0}function he(Z,de,ye){return K(Z,de,ye)<=0}function fe(Z,de,ye,je){var We;switch(de){case"===":typeof Z=="object"&&(Z=Z.version),typeof ye=="object"&&(ye=ye.version),We=Z===ye;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ye=="object"&&(ye=ye.version),We=Z!==ye;break;case"":case"=":case"==":We=re(Z,ye,je);break;case"!=":We=le(Z,ye,je);break;case">":We=Y(Z,ye,je);break;case">=":We=Ee(Z,ye,je);break;case"<":We=se(Z,ye,je);break;case"<=":We=he(Z,ye,je);break;default:throw new TypeError("Invalid operator: "+de)}return We}function te(Z,de){if(Z instanceof te){if(Z.loose===de)return Z;Z=Z.value}if(!(this instanceof te))return new te(Z,de);f("comparator",Z,de),this.loose=de,this.parse(Z),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(Z,de){return U(de,Z)},e.major=function(Z,de){return new we(Z,de).major},e.minor=function(Z,de){return new we(Z,de).minor},e.patch=function(Z,de){return new we(Z,de).patch},e.compare=K,e.compareLoose=function(Z,de){return K(Z,de,!0)},e.rcompare=function(Z,de,ye){return K(de,Z,ye)},e.sort=function(Z,de){return Z.sort(function(ye,je){return e.compare(ye,je,de)})},e.rsort=function(Z,de){return Z.sort(function(ye,je){return e.rcompare(ye,je,de)})},e.gt=Y,e.lt=se,e.eq=re,e.neq=le,e.gte=Ee,e.lte=he,e.cmp=fe,e.Comparator=te;var ue={};function be(Z,de){if(Z instanceof be)return Z.loose===de?Z:new be(Z.raw,de);if(Z instanceof te)return new be(Z.value,de);if(!(this instanceof be))return new be(Z,de);if(this.loose=de,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Pe(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function B(Z,de,ye,je,We,xe,Qe,it,et,Ae,Oe,Ve,Le){return((de=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+de)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Oe)?"<"+et+"."+(+Ae+1)+".0":Ve?"<="+et+"."+Ae+"."+Oe+"-"+Ve:"<="+it)).trim()}function X(Z,de){for(var ye=0;ye<Z.length;ye++)if(!Z[ye].test(de))return!1;if(de.prerelease.length){for(ye=0;ye<Z.length;ye++)if(f(Z[ye].semver),Z[ye].semver!==ue&&Z[ye].semver.prerelease.length>0){var je=Z[ye].semver;if(je.major===de.major&&je.minor===de.minor&&je.patch===de.patch)return!0}return!1}return!0}function ee(Z,de,ye){try{de=new be(de,ye)}catch{return!1}return de.test(Z)}function ne(Z,de,ye,je){var We,xe,Qe,it,et;switch(Z=new we(Z,je),de=new be(de,je),ye){case">":We=Y,xe=he,Qe=se,it=">",et=">=";break;case"<":We=se,xe=Ee,Qe=Y,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ee(Z,de,je))return!1;for(var Ae=0;Ae<de.set.length;++Ae){var Oe=de.set[Ae],Ve=null,Le=null;if(Oe.forEach(function(Xe){Xe.semver===ue&&(Xe=new te(">=0.0.0")),Ve=Ve||Xe,Le=Le||Xe,We(Xe.semver,Ve.semver,je)?Ve=Xe:Qe(Xe.semver,Le.semver,je)&&(Le=Xe)}),Ve.operator===it||Ve.operator===et||(!Le.operator||Le.operator===it)&&xe(Z,Le.semver)||Le.operator===et&&Qe(Z,Le.semver))return!1}return!0}te.prototype.parse=function(Z){var de=this.loose?m[q]:m[me],ye=Z.match(de);if(!ye)throw new TypeError("Invalid comparator: "+Z);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new we(ye[2],this.loose):this.semver=ue},te.prototype.toString=function(){return this.value},te.prototype.test=function(Z){return f("Comparator.test",Z,this.loose),this.semver===ue||(typeof Z=="string"&&(Z=new we(Z,this.loose)),fe(Z,this.operator,this.semver,this.loose))},te.prototype.intersects=function(Z,de){if(!(Z instanceof te))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new be(Z.value,de),ee(this.value,ye,de);if(Z.operator==="")return ye=new be(this.value,de),ee(Z.semver,ye,de);var je=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),xe=this.semver.version===Z.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),it=fe(this.semver,"<",Z.semver,de)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),et=fe(this.semver,">",Z.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return je||We||xe&&Qe||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Z){var de=this.loose;Z=Z.trim(),f("range",Z,de);var ye=de?m[V]:m[Q];Z=Z.replace(ye,B),f("hyphen replace",Z),Z=Z.replace(m[x],"$1$2$3"),f("comparator trim",Z,m[x]),Z=(Z=(Z=Z.replace(m[O],"$1~")).replace(m[z],"$1^")).split(/\s+/).join(" ");var je=de?m[q]:m[me],We=Z.split(" ").map(function(xe){return function(Qe,it){return f("comp",Qe),Qe=function(et,Ae){return et.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){f("caret",Ve,Le);var Xe=Le?m[H]:m[M];return Ve.replace(Xe,function(ae,oe,Ie,qe,ze){var Ze;return f("caret",Ve,ae,oe,Ie,qe,ze),Pe(oe)?Ze="":Pe(Ie)?Ze=">="+oe+".0.0 <"+(+oe+1)+".0.0":Pe(qe)?Ze=oe==="0"?">="+oe+"."+Ie+".0 <"+oe+"."+(+Ie+1)+".0":">="+oe+"."+Ie+".0 <"+(+oe+1)+".0.0":ze?(f("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ze=oe==="0"?Ie==="0"?">="+oe+"."+Ie+"."+qe+ze+" <"+oe+"."+Ie+"."+(+qe+1):">="+oe+"."+Ie+"."+qe+ze+" <"+oe+"."+(+Ie+1)+".0":">="+oe+"."+Ie+"."+qe+ze+" <"+(+oe+1)+".0.0"):(f("no pr"),Ze=oe==="0"?Ie==="0"?">="+oe+"."+Ie+"."+qe+" <"+oe+"."+Ie+"."+(+qe+1):">="+oe+"."+Ie+"."+qe+" <"+oe+"."+(+Ie+1)+".0":">="+oe+"."+Ie+"."+qe+" <"+(+oe+1)+".0.0"),f("caret return",Ze),Ze})}(Oe,Ae)}).join(" ")}(Qe,it),f("caret",Qe),Qe=function(et,Ae){return et.trim().split(/\s+/).map(function(Oe){return function(Ve,Le){var Xe=Le?m[T]:m[N];return Ve.replace(Xe,function(ae,oe,Ie,qe,ze){var Ze;return f("tilde",Ve,ae,oe,Ie,qe,ze),Pe(oe)?Ze="":Pe(Ie)?Ze=">="+oe+".0.0 <"+(+oe+1)+".0.0":Pe(qe)?Ze=">="+oe+"."+Ie+".0 <"+oe+"."+(+Ie+1)+".0":ze?(f("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ze=">="+oe+"."+Ie+"."+qe+ze+" <"+oe+"."+(+Ie+1)+".0"):Ze=">="+oe+"."+Ie+"."+qe+" <"+oe+"."+(+Ie+1)+".0",f("tilde return",Ze),Ze})}(Oe,Ae)}).join(" ")}(Qe,it),f("tildes",Qe),Qe=function(et,Ae){return f("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Oe){return function(Ve,Le){Ve=Ve.trim();var Xe=Le?m[l]:m[u];return Ve.replace(Xe,function(ae,oe,Ie,qe,ze,Ze){f("xRange",Ve,ae,oe,Ie,qe,ze,Ze);var nt=Pe(Ie),ot=nt||Pe(qe),bt=ot||Pe(ze);return oe==="="&&bt&&(oe=""),nt?ae=oe===">"||oe==="<"?"<0.0.0":"*":oe&&bt?(ot&&(qe=0),bt&&(ze=0),oe===">"?(oe=">=",ot?(Ie=+Ie+1,qe=0,ze=0):bt&&(qe=+qe+1,ze=0)):oe==="<="&&(oe="<",ot?Ie=+Ie+1:qe=+qe+1),ae=oe+Ie+"."+qe+"."+ze):ot?ae=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(ae=">="+Ie+"."+qe+".0 <"+Ie+"."+(+qe+1)+".0"),f("xRange return",ae),ae})}(Oe,Ae)}).join(" ")}(Qe,it),f("xrange",Qe),Qe=function(et,Ae){return f("replaceStars",et,Ae),et.trim().replace(m[_],"")}(Qe,it),f("stars",Qe),Qe}(xe,de)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(xe){return!!xe.match(je)})),We=We.map(function(xe){return new te(xe,de)})},be.prototype.intersects=function(Z,de){if(!(Z instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return Z.set.some(function(We){return We.every(function(xe){return je.intersects(xe,de)})})})})},e.toComparators=function(Z,de){return new be(Z,de).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new we(Z,this.loose));for(var de=0;de<this.set.length;de++)if(X(this.set[de],Z))return!0;return!1},e.satisfies=ee,e.maxSatisfying=function(Z,de,ye){var je=null,We=null;try{var xe=new be(de,ye)}catch{return null}return Z.forEach(function(Qe){xe.test(Qe)&&(je&&We.compare(Qe)!==-1||(We=new we(je=Qe,ye)))}),je},e.minSatisfying=function(Z,de,ye){var je=null,We=null;try{var xe=new be(de,ye)}catch{return null}return Z.forEach(function(Qe){xe.test(Qe)&&(je&&We.compare(Qe)!==1||(We=new we(je=Qe,ye)))}),je},e.validRange=function(Z,de){try{return new be(Z,de).range||"*"}catch{return null}},e.ltr=function(Z,de,ye){return ne(Z,de,"<",ye)},e.gtr=function(Z,de,ye){return ne(Z,de,">",ye)},e.outside=ne,e.prerelease=function(Z,de){var ye=ce(Z,de);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Z,de,ye){return Z=new be(Z,ye),de=new be(de,ye),Z.intersects(de)},e.coerce=function(Z){if(Z instanceof we)return Z;if(typeof Z!="string")return null;var de=Z.match(m[w]);return de==null?null:ce((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,C(1))},function($e,e){var C,F,f=$e.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(r){if(C===setTimeout)return setTimeout(r,0);if((C===L||!C)&&setTimeout)return C=setTimeout,setTimeout(r,0);try{return C(r,0)}catch{try{return C.call(null,r,0)}catch{return C.call(this,r,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:L}catch{C=L}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var S,b=[],P=!1,I=-1;function p(){P&&S&&(P=!1,S.length?b=S.concat(b):I=-1,b.length&&k())}function k(){if(!P){var r=m(p);P=!0;for(var i=b.length;i;){for(S=b,b=[];++I<i;)S&&S[I].run();I=-1,i=b.length}S=null,P=!1,function(s){if(F===clearTimeout)return clearTimeout(s);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(s);try{F(s)}catch{try{return F.call(null,s)}catch{return F.call(this,s)}}}(r)}}function D(r,i){this.fun=r,this.array=i}function v(){}f.nextTick=function(r){var i=new Array(arguments.length-1);if(arguments.length>1)for(var s=1;s<arguments.length;s++)i[s-1]=arguments[s];b.push(new D(r,i)),b.length!==1||P||m(k)},D.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=v,f.addListener=v,f.once=v,f.off=v,f.removeListener=v,f.removeAllListeners=v,f.emit=v,f.prependListener=v,f.prependOnceListener=v,f.listeners=function(r){return[]},f.binding=function(r){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(r){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(De[37],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=C&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ad=F}),define(De[4],Ce([1,0,8,74,3,75,37]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.Event=void 0;const m=!1,S=!1;var b;(function(u){u.None=()=>f.$jc.None;function l(fe){if(S){const{onDidAddListener:te}=fe,ue=D.create();let be=0;fe.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),te?.()}}}function w(fe,te){return me(fe,()=>{},0,void 0,!0,void 0,te)}u.defer=w;function A(fe){return(te,ue=null,be)=>{let Pe=!1,B;return B=fe(X=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(ue,X)},null,be),Pe&&B.dispose(),B}}u.once=A;function O(fe,te,ue){return H((be,Pe=null,B)=>fe(X=>be.call(Pe,te(X)),null,B),ue)}u.map=O;function N(fe,te,ue){return H((be,Pe=null,B)=>fe(X=>{te(X),be.call(Pe,X)},null,B),ue)}u.forEach=N;function T(fe,te,ue){return H((be,Pe=null,B)=>fe(X=>te(X)&&be.call(Pe,X),null,B),ue)}u.filter=T;function j(fe){return fe}u.signal=j;function z(...fe){return(te,ue=null,be)=>{const Pe=(0,f.$gc)(...fe.map(B=>B(X=>te.call(ue,X))));return q(Pe,be)}}u.any=z;function M(fe,te,ue,be){let Pe=ue;return O(fe,B=>(Pe=te(Pe,B),Pe),be)}u.reduce=M;function H(fe,te){let ue;const be={onWillAddFirstListener(){ue=fe(Pe.fire,Pe)},onDidRemoveLastListener(){ue?.dispose()}};te||l(be);const Pe=new d(be);return te?.add(Pe),Pe.event}function q(fe,te){return te instanceof Array?te.push(fe):te&&te.add(fe),fe}function me(fe,te,ue=100,be=!1,Pe=!1,B,X){let ee,ne,Z,de=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){ee=fe(xe=>{de++,ne=te(ne,xe),be&&!Z&&(We.fire(ne),ne=void 0),ye=()=>{const Qe=ne;ne=void 0,Z=void 0,(!be||de>1)&&We.fire(Qe),de=0},typeof ue=="number"?(clearTimeout(Z),Z=setTimeout(ye,ue)):Z===void 0&&(Z=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&de>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,ee.dispose()}};X||l(je);const We=new d(je);return X?.add(We),We.event}u.debounce=me;function x(fe,te=0,ue){return u.debounce(fe,(be,Pe)=>be?(be.push(Pe),be):[Pe],te,void 0,!0,void 0,ue)}u.accumulate=x;function Q(fe,te=(be,Pe)=>be===Pe,ue){let be=!0,Pe;return T(fe,B=>{const X=be||!te(B,Pe);return be=!1,Pe=B,X},ue)}u.latch=Q;function V(fe,te,ue){return[u.filter(fe,te,ue),u.filter(fe,be=>!te(be),ue)]}u.split=V;function _(fe,te=!1,ue=[],be){let Pe=ue.slice(),B=fe(ne=>{Pe?Pe.push(ne):ee.fire(ne)});be&&be.add(B);const X=()=>{Pe?.forEach(ne=>ee.fire(ne)),Pe=null},ee=new d({onWillAddFirstListener(){B||(B=fe(ne=>ee.fire(ne)),be&&be.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(X):X())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(ee),ee.event}u.buffer=_;function ge(fe,te){return(be,Pe,B)=>{const X=te(new we);return fe(function(ee){const ne=X.evaluate(ee);ne!==ce&&be.call(Pe,ne)},void 0,B)}}u.chain=ge;const ce=Symbol("HaltChainable");class we{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(ue=>(te(ue),ue)),this}filter(te){return this.f.push(ue=>te(ue)?ue:ce),this}reduce(te,ue){let be=ue;return this.f.push(Pe=>(be=te(be,Pe),be)),this}latch(te=(ue,be)=>ue===be){let ue=!0,be;return this.f.push(Pe=>{const B=ue||!te(Pe,be);return ue=!1,be=Pe,B?Pe:ce}),this}evaluate(te){for(const ue of this.f)if(te=ue(te),te===ce)break;return te}}function G(fe,te,ue=be=>be){const be=(...ee)=>X.fire(ue(...ee)),Pe=()=>fe.on(te,be),B=()=>fe.removeListener(te,be),X=new d({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return X.event}u.fromNodeEventEmitter=G;function U(fe,te,ue=be=>be){const be=(...ee)=>X.fire(ue(...ee)),Pe=()=>fe.addEventListener(te,be),B=()=>fe.removeEventListener(te,be),X=new d({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return X.event}u.fromDOMEventEmitter=U;function K(fe){return new Promise(te=>A(fe)(te))}u.toPromise=K;function Y(fe){const te=new d;return fe.then(ue=>{te.fire(ue)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}u.fromPromise=Y;function se(fe,te){return te(void 0),fe(ue=>te(ue))}u.runAndSubscribe=se;function re(fe,te){let ue=null;function be(B){ue?.dispose(),ue=new f.$ic,te(B,ue)}be(void 0);const Pe=fe(B=>be(B));return(0,f.$hc)(()=>{Pe.dispose(),ue?.dispose()})}u.runAndSubscribeWithStore=re;class le{constructor(te,ue){this._observable=te,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ue||l(be),this.emitter=new d(be),ue&&ue.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,ue){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(fe,te){return new le(fe,te).emitter.event}u.fromObservable=Ee;function he(fe){return te=>{let ue=0,be=!1;const Pe={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(fe.reportChanges(),be&&(be=!1,te()))},handlePossibleChange(){},handleChange(){be=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}u.fromObservableLight=he})(b||(e.Event=b={}));class P{static{this.all=new Set}static{this.f=0}constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${P.f++}`,P.all.add(this)}start(l){this.g=new R.$ad,this.listenerCount=l}stop(){if(this.g){const l=this.g.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.g=void 0}}}e.$cd=P;let I=-1;function p(u){const l=I;return I=u,{dispose(){I=l}}}e.$dd=p;class k{constructor(l,w=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=w,this.g=0}dispose(){this.f?.clear()}check(l,w){const A=this.threshold;if(A<=0||w<A)return;this.f||(this.f=new Map);const O=this.f.get(l.value)||0;if(this.f.set(l.value,O+1),this.g-=1,this.g<=0){this.g=A*.5;let N,T=0;for(const[j,z]of this.f)(!N||T<z)&&(N=j,T=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${T}):`),console.warn(N)}return()=>{const N=this.f.get(l.value)||0;this.f.set(l.value,N-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class r{constructor(l){this.value=l,this.id=v++}}const i=2,s=(u,l)=>{if(u instanceof r)l(u);else for(let w=0;w<u.length;w++){const A=u[w];A&&l(A)}};class d{constructor(l){this.w=0,this.f=l,this.g=I>0||this.f?.leakWarningThreshold?new k(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const l=this.t;queueMicrotask(()=>{s(l,w=>w.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(l,w,A)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$jc.None;if(this.m)return f.$jc.None;w&&(l=l.bind(w));const O=new r(l);let N,T;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=D.create(),N=this.g.check(O.stack,this.w+1)),m&&(O.stack=T??D.create()),this.t?this.t instanceof r?(this.u??=new g,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,f.$hc)(()=>{N?.(),this.x(O)});return A instanceof f.$ic?A.add(j):Array.isArray(A)&&A.push(j),j},this.q}x(l){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const w=this.t,A=w.indexOf(l);if(A===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,w[A]=void 0;const O=this.u.current===this;if(this.w*i<=w.length){let N=0;for(let T=0;T<w.length;T++)w[T]?w[N++]=w[T]:O&&(this.u.end--,N<this.u.i&&this.u.i--);w.length=N}}y(l,w){if(!l)return;const A=this.f?.onListenerError||C.$Y;if(!A){l.value(w);return}try{l.value(w)}catch(O){A(O)}}z(l){const w=l.current.t;for(;l.i<l.end;)this.y(w[l.i++],l.value);l.reset()}fire(l){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof r)this.y(this.t,l);else{const w=this.u;w.enqueue(this,l,this.t.length),this.z(w)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ed=d;const $=()=>new g;e.$fd=$;class g{constructor(){this.i=-1,this.end=0}enqueue(l,w,A){this.i=0,this.end=A,this.current=l,this.value=w}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends d{async fireAsync(l,w,A){if(this.t)for(this.h||(this.h=new L.$sc),s(this.t,O=>this.h.push([O.value,l]));this.h.size>0&&!w.isCancellationRequested;){const[O,N]=this.h.shift(),T=[],j={...N,token:w,waitUntil:z=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");A&&(z=A(z,O)),T.push(z)}};try{O(j)}catch(z){(0,C.$Y)(z);continue}Object.freeze(T),await Promise.allSettled(T).then(z=>{for(const M of z)M.status==="rejected"&&(0,C.$Y)(M.reason)})}}}e.$gd=t;class o extends d{get isPaused(){return this.h!==0}constructor(l){super(l),this.h=0,this.s=new L.$sc,this.A=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.A(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.w&&(this.h!==0?this.s.push(l):super.fire(l))}}e.$hd=o;class a extends o{constructor(l){super(l),this.k=l.delay??100}fire(l){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(l)}}e.$id=a;class n extends d{constructor(l){super(l),this.h=[],this.k=l?.merge}fire(l){this.hasListeners()&&(this.h.push(l),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(w=>super.fire(w)),this.h=[]}))}}e.$jd=n;class c{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(l){const w={event:l,listener:null};this.h.push(w),this.g&&this.m(w);const A=()=>{this.g&&this.o(w);const O=this.h.indexOf(w);this.h.splice(O,1)};return(0,f.$hc)((0,F.$bb)(A))}j(){this.g=!0,this.h.forEach(l=>this.m(l))}k(){this.g=!1,this.h.forEach(l=>this.o(l))}m(l){l.listener=l.event(w=>this.f.fire(w))}o(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.f.dispose()}}e.$kd=c;class h{constructor(l,w,A,O){this.f=new f.$ic;const N=this.f.add(new c),T=this.f.add(new f.$rc);function j(z){T.set(z,N.add(O(z)))}for(const z of l)j(z);this.f.add(w(z=>{j(z)})),this.f.add(A(z=>{T.deleteAndDispose(z)})),this.event=N.event}dispose(){this.f.dispose()}}e.$ld=h;class E{constructor(){this.f=[]}wrapEvent(l){return(w,A,O)=>l(N=>{const T=this.f[this.f.length-1];T?T.push(()=>w.call(A,N)):w.call(A,N)},void 0,O)}bufferEvents(l){const w=[];this.f.push(w);const A=l();return this.f.pop(),w.forEach(O=>O()),A}}e.$md=E;class y{constructor(){this.f=!1,this.g=b.None,this.h=f.$jc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(l){this.g=l,this.f&&(this.h.dispose(),this.h=l(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$nd=y}),define(De[21],Ce([1,0,4]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.CancellationToken=void 0;const F=Object.freeze(function(m,S){const b=setTimeout(m.bind(S),0);return{dispose(){clearTimeout(b)}}});var f;(function(m){function S(b){return b===m.None||b===m.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}m.isCancellationToken=S,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new C.$ed),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=f.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=f.None}}e.$od=R}),define(De[159],Ce([1,0,21]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=void 0;class F{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new C.$od,S=this.b(m.token);return this.a={promise:S,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$ge=F;class f{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const S=JSON.stringify(m);return this.b!==S&&(this.b=S,this.a=this.c(m)),this.a}}e.$he=f;class L{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const S=this.b(m);return this.a.set(m,S),S}}e.$ie=L}),define(De[97],Ce([1,0,8,3]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function f($){const g=$;return g?typeof g.read=="function":!1}e.$pd=f;function L($){const g=$;return g?[g.on,g.pause,g.resume,g.destroy].every(t=>typeof t=="function"):!1}e.$qd=L;function R($){const g=$;return g?L(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$rd=R;function m($,g){return new S($,g)}e.$sd=m;class S{constructor(g,t){this.e=g,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(t=>t(g))}h(g){this.c.error.length===0?(0,C.$Y)(g):this.c.error.slice(0).forEach(t=>t(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,t){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(g,t){if(this.a.destroyed)return;let o;switch(g){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const a=o.indexOf(t);a>=0&&o.splice(a,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b($,g){const t=[];let o;for(;(o=$.read())!==null;)t.push(o);return g(t)}e.$td=b;function P($,g,t){const o=[];let a;for(;(a=$.read())!==null&&o.length<t;)o.push(a);return a===null&&o.length>0?g(o):{read:()=>{if(o.length>0)return o.shift();if(typeof a<"u"){const n=a;return a=void 0,n}return $.read()}}}e.$ud=P;function I($,g){return new Promise((t,o)=>{const a=[];p($,{onData:n=>{g&&a.push(n)},onError:n=>{g?o(n):t(void 0)},onEnd:()=>{t(g?g(a):void 0)}})})}e.$vd=I;function p($,g,t){$.on("error",o=>{t?.isCancellationRequested||g.onError(o)}),$.on("end",()=>{t?.isCancellationRequested||g.onEnd()}),$.on("data",o=>{t?.isCancellationRequested||g.onData(o)})}e.$wd=p;function k($,g){return new Promise((t,o)=>{const a=new F.$ic,n=[],c=y=>{if(n.push(y),n.length>g)return a.dispose(),$.pause(),t({stream:$,buffer:n,ended:!1})},h=y=>(a.dispose(),o(y)),E=()=>(a.dispose(),t({stream:$,buffer:n,ended:!0}));a.add((0,F.$hc)(()=>$.removeListener("error",h))),$.on("error",h),a.add((0,F.$hc)(()=>$.removeListener("end",E))),$.on("end",E),a.add((0,F.$hc)(()=>$.removeListener("data",c))),$.on("data",c)})}e.$xd=k;function D($,g){const t=m(g);return t.end($),t}e.$yd=D;function v(){const $=m(()=>{throw new Error("not supported")});return $.end(),$}e.$zd=v;function r($){let g=!1;return{read:()=>g?null:(g=!0,$)}}e.$Ad=r;function i($,g,t){const o=m(t);return p($,{onData:a=>o.write(g.data(a)),onError:a=>o.error(g.error?g.error(a):a),onEnd:()=>o.end()}),o}e.$Bd=i;function s($,g,t){let o=!1;return{read:()=>{const a=g.read();return o?a:(o=!0,a!==null?t([$,a]):$)}}}e.$Cd=s;function d($,g,t){let o=!1;const a=m(t);return p(g,{onData:n=>o?a.write(n):(o=!0,a.write(t([$,n]))),onError:n=>a.error(n),onEnd:()=>{o||(o=!0,a.write($)),a.end()}}),a}e.$Dd=d}),define(De[22],Ce([1,0,59,97]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const f=typeof Buffer<"u",L=new C.$T(()=>new Uint8Array(256));let R,m;class S{static alloc(w){return f?new S(Buffer.allocUnsafe(w)):new S(new Uint8Array(w))}static wrap(w){return f&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new S(w)}static fromString(w,A){return!(A?.dontUseNodeBuffer||!1)&&f?new S(Buffer.from(w)):(R||(R=new TextEncoder),new S(R.encode(w)))}static fromByteArray(w){const A=S.alloc(w.length);for(let O=0,N=w.length;O<N;O++)A.buffer[O]=w[O];return A}static concat(w,A){if(typeof A>"u"){A=0;for(let T=0,j=w.length;T<j;T++)A+=w[T].byteLength}const O=S.alloc(A);let N=0;for(let T=0,j=w.length;T<j;T++){const z=w[T];O.set(z,N),N+=z.byteLength}return O}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=S.alloc(this.byteLength);return w.set(this),w}toString(){return f?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,A){return new S(this.buffer.subarray(w,A))}set(w,A){if(w instanceof S)this.buffer.set(w.buffer,A);else if(w instanceof Uint8Array)this.buffer.set(w,A);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),A);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return p(this.buffer,w)}writeUInt32BE(w,A){k(this.buffer,w,A)}readUInt32LE(w){return D(this.buffer,w)}writeUInt32LE(w,A){v(this.buffer,w,A)}readUInt8(w){return r(this.buffer,w)}writeUInt8(w,A){i(this.buffer,w,A)}indexOf(w,A=0){return b(this.buffer,w instanceof S?w.buffer:w,A)}}e.$Ed=S;function b(l,w,A=0){const O=w.byteLength,N=l.byteLength;if(O===0)return 0;if(O===1)return l.indexOf(w[0]);if(O>N-A)return-1;const T=L.value;T.fill(w.length);for(let H=0;H<w.length;H++)T[w[H]]=w.length-H-1;let j=A+w.length-1,z=j,M=-1;for(;j<N;)if(l[j]===w[z]){if(z===0){M=j;break}j--,z--}else j+=Math.max(w.length-z,T[l[j]]),z=w.length-1;return M}e.$Fd=b;function P(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0}e.$Gd=P;function I(l,w,A){l[A+0]=w&255,w=w>>>8,l[A+1]=w&255}e.$Hd=I;function p(l,w){return l[w]*2**24+l[w+1]*2**16+l[w+2]*2**8+l[w+3]}e.$Id=p;function k(l,w,A){l[A+3]=w,w=w>>>8,l[A+2]=w,w=w>>>8,l[A+1]=w,w=w>>>8,l[A]=w}e.$Jd=k;function D(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0|l[w+2]<<16>>>0|l[w+3]<<24>>>0}e.$Kd=D;function v(l,w,A){l[A+0]=w&255,w=w>>>8,l[A+1]=w&255,w=w>>>8,l[A+2]=w&255,w=w>>>8,l[A+3]=w&255}e.$Ld=v;function r(l,w){return l[w]}e.$Md=r;function i(l,w,A){l[A]=w}e.$Nd=i;function s(l){return F.$td(l,w=>S.concat(w))}e.$Od=s;function d(l){return F.$Ad(l)}e.$Pd=d;function $(l){return F.$vd(l,w=>S.concat(w))}e.$Qd=$;async function g(l){return l.ended?S.concat(l.buffer):S.concat([...l.buffer,await $(l.stream)])}e.$Rd=g;function t(l){return F.$yd(l,w=>S.concat(w))}e.$Sd=t;function o(l){return F.$Bd(l,{data:w=>typeof w=="string"?S.fromString(w):S.wrap(w)},w=>S.concat(w))}e.$Td=o;function a(l){return F.$sd(w=>S.concat(w),l)}e.$Ud=a;function n(l,w){return F.$Cd(l,w,A=>S.concat(A))}e.$Vd=n;function c(l,w){return F.$Dd(l,w,A=>S.concat(A))}e.$Wd=c;function h(l){let w=0,A=0,O=0;const N=new Uint8Array(Math.floor(l.length/4*3)),T=z=>{switch(A){case 3:N[O++]=w|z,A=0;break;case 2:N[O++]=w|z>>>2,w=z<<6,A=3;break;case 1:N[O++]=w|z>>>4,w=z<<4,A=2;break;default:w=z<<2,A=1}};for(let z=0;z<l.length;z++){const M=l.charCodeAt(z);if(M>=65&&M<=90)T(M-65);else if(M>=97&&M<=122)T(M-97+26);else if(M>=48&&M<=57)T(M-48+52);else if(M===43||M===45)T(62);else if(M===47||M===95)T(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${l[z]}`)}}const j=O;for(;A>0;)T(0);return S.wrap(N).slice(0,j)}e.$Xd=h;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:l},w=!0,A=!1){const O=A?y:E;let N="";const T=l.byteLength%3;let j=0;for(;j<l.byteLength-T;j+=3){const z=l[j+0],M=l[j+1],H=l[j+2];N+=O[z>>>2],N+=O[(z<<4|M>>>4)&63],N+=O[(M<<2|H>>>6)&63],N+=O[H&63]}if(T===1){const z=l[j+0];N+=O[z>>>2],N+=O[z<<4&63],w&&(N+="==")}else if(T===2){const z=l[j+0],M=l[j+1];N+=O[z>>>2],N+=O[(z<<4|M>>>4)&63],N+=O[M<<2&63],w&&(N+="=")}return N}e.$Yd=u}),define(De[15],Ce([1,0,159,59]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hf=e.$gf=e.$ff=e.$ef=e.GraphemeBreakType=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$le=f;const L=/{(\d+)}/g;function R(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(L,function(Ve,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Oe.length?Ve:Oe[Xe]})}e.$me=R;const m=/{([^}]+)}/g;function S(Ae,Oe){return Ae.replace(m,(Ve,Le)=>Oe[Le]??Ve)}e.$ne=S;function b(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$oe=b;function P(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pe=P;function I(Ae,Oe){let Ve=0;const Le=Oe.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Le&&Ve++;return Ve}e.$qe=I;function p(Ae,Oe,Ve="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${Ve}`}e.$re=p;function k(Ae,Oe=" "){const Ve=D(Ae,Oe);return v(Ve,Oe)}e.$se=k;function D(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length;if(Ve===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Oe,Le)===Le;)Le=Le+Ve;return Ae.substring(Le)}e.$te=D;function v(Ae,Oe){if(!Ae||!Oe)return Ae;const Ve=Oe.length,Le=Ae.length;if(Ve===0||Le===0)return Ae;let Xe=Le,ae=-1;for(;ae=Ae.lastIndexOf(Oe,Xe-1),!(ae===-1||ae+Ve!==Xe);){if(ae===0)return"";Xe=ae}return Ae.substring(0,Xe)}e.$ue=v;function r(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$ve=r;function i(Ae){return Ae.replace(/\*/g,"")}e.$we=i;function s(Ae,Oe,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=P(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return Ve.global&&(Le+="g"),Ve.matchCase||(Le+="i"),Ve.multiline&&(Le+="m"),Ve.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$xe=s;function d(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$ye=d;function $(Ae){return Ae.split(/\r\n|\r|\n/)}e.$ze=$;function g(Ae){for(let Oe=0,Ve=Ae.length;Oe<Ve;Oe++){const Le=Ae.charCodeAt(Oe);if(Le!==32&&Le!==9)return Oe}return-1}e.$Ae=g;function t(Ae,Oe=0,Ve=Ae.length){for(let Le=Oe;Le<Ve;Le++){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Ae.substring(Oe,Le)}return Ae.substring(Oe,Ve)}e.$Be=t;function o(Ae,Oe=Ae.length-1){for(let Ve=Oe;Ve>=0;Ve--){const Le=Ae.charCodeAt(Ve);if(Le!==32&&Le!==9)return Ve}return-1}e.$Ce=o;function a(Ae,Oe,Ve){const Le=[];let Xe=0;for(const ae of Ae.matchAll(Oe)){if(Le.push(Ae.slice(Xe,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Xe=ae.index+ae[0].length,Le.push(Ve(ae[0],...ae.slice(1),ae.index,Ae,ae.groups))}return Le.push(Ae.slice(Xe)),Promise.all(Le).then(ae=>ae.join(""))}e.$De=a;function n(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Ee=n;function c(Ae,Oe,Ve=0,Le=Ae.length,Xe=0,ae=Oe.length){for(;Ve<Le&&Xe<ae;Ve++,Xe++){const qe=Ae.charCodeAt(Ve),ze=Oe.charCodeAt(Xe);if(qe<ze)return-1;if(qe>ze)return 1}const oe=Le-Ve,Ie=ae-Xe;return oe<Ie?-1:oe>Ie?1:0}e.$Fe=c;function h(Ae,Oe){return E(Ae,Oe,0,Ae.length,0,Oe.length)}e.$Ge=h;function E(Ae,Oe,Ve=0,Le=Ae.length,Xe=0,ae=Oe.length){for(;Ve<Le&&Xe<ae;Ve++,Xe++){let qe=Ae.charCodeAt(Ve),ze=Oe.charCodeAt(Xe);if(qe===ze)continue;if(qe>=128||ze>=128)return c(Ae.toLowerCase(),Oe.toLowerCase(),Ve,Le,Xe,ae);u(qe)&&(qe-=32),u(ze)&&(ze-=32);const Ze=qe-ze;if(Ze!==0)return Ze}const oe=Le-Ve,Ie=ae-Xe;return oe<Ie?-1:oe>Ie?1:0}e.$He=E;function y(Ae){return Ae>=48&&Ae<=57}e.$Ie=y;function u(Ae){return Ae>=97&&Ae<=122}e.$Je=u;function l(Ae){return Ae>=65&&Ae<=90}e.$Ke=l;function w(Ae,Oe){return Ae.length===Oe.length&&E(Ae,Oe)===0}e.$Le=w;function A(Ae,Oe){const Ve=Oe.length;return Oe.length>Ae.length?!1:E(Ae,Oe,0,Ve)===0}e.$Me=A;function O(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Le)!==Oe.charCodeAt(Le))return Le;return Ve}e.$Ne=O;function N(Ae,Oe){const Ve=Math.min(Ae.length,Oe.length);let Le;const Xe=Ae.length-1,ae=Oe.length-1;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Xe-Le)!==Oe.charCodeAt(ae-Le))return Le;return Ve}e.$Oe=N;function T(Ae){return 55296<=Ae&&Ae<=56319}e.$Pe=T;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$Qe=j;function z(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$Re=z;function M(Ae,Oe,Ve){const Le=Ae.charCodeAt(Ve);if(T(Le)&&Ve+1<Oe){const Xe=Ae.charCodeAt(Ve+1);if(j(Xe))return z(Le,Xe)}return Le}e.$Se=M;function H(Ae,Oe){const Ve=Ae.charCodeAt(Oe-1);if(j(Ve)&&Oe>1){const Le=Ae.charCodeAt(Oe-2);if(T(Le))return z(Le,Ve)}return Ve}class q{get offset(){return this.e}constructor(Oe,Ve=0){this.c=Oe,this.d=Oe.length,this.e=Ve}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=H(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=M(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$Te=q;class me{get offset(){return this.c.offset}constructor(Oe,Ve=0){this.c=new q(Oe,Ve)}nextGraphemeLength(){const Oe=de.getInstance(),Ve=this.c,Le=Ve.offset;let Xe=Oe.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const ae=Ve.offset,oe=Oe.getGraphemeBreakType(Ve.nextCodePoint());if(ne(Xe,oe)){Ve.setOffset(ae);break}Xe=oe}return Ve.offset-Le}prevGraphemeLength(){const Oe=de.getInstance(),Ve=this.c,Le=Ve.offset;let Xe=Oe.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const ae=Ve.offset,oe=Oe.getGraphemeBreakType(Ve.prevCodePoint());if(ne(oe,Xe)){Ve.setOffset(ae);break}Xe=oe}return Le-Ve.offset}eol(){return this.c.eol()}}e.$Ue=me;function x(Ae,Oe){return new me(Ae,Oe).nextGraphemeLength()}e.$Ve=x;function Q(Ae,Oe){return new me(Ae,Oe).prevGraphemeLength()}e.$We=Q;function V(Ae,Oe){Oe>0&&j(Ae.charCodeAt(Oe))&&Oe--;const Ve=Oe+x(Ae,Oe);return[Ve-Q(Ae,Ve),Ve]}e.$Xe=V;function _(Ae){const Oe=new me(Ae);let Ve=0;for(;!Oe.eol();)Ve++,Oe.nextGraphemeLength();return Ve}e.$Ye=_;let ge;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(Ae){return ge||(ge=ce()),ge.test(Ae)}e.$Ze=we;const G=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return G.test(Ae)}e.$1e=U,e.$2e=/[\u2028\u2029]/;function K(Ae){return e.$2e.test(Ae)}e.$3e=K;function Y(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$4e=Y;function se(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$5e=se;function re(Ae,Oe){if(Ae.length<Oe)return Ae;const Ve=/\b/g;let Le=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Oe);)Le=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$6e=re;const le=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function he(Ae){return Ae&&(Ae=Ae.replace(le,"").replace(Ee,"")),Ae}e.$7e=he,e.$8e=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$9e=fe;function te(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$0e=te;function ue(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const Ve=Oe.length,Le=Ae.toLowerCase();let Xe=0,ae=-1;for(;Xe<Ve;){const oe=Le.indexOf(Oe[Xe],ae+1);if(oe<0)return!1;ae=oe,Xe++}return!0}e.$$e=ue;function be(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$_e=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$af=Pe;function B(Ae,Oe=1){if(Oe===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Oe--;while(Oe>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$bf=B;function X(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$cf=X;function ee(Ae){return de.getInstance().getGraphemeBreakType(Ae)}e.$df=ee;function ne(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var Z;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class de{static{this.c=null}static getInstance(){return de.c||(de.c=new de),de.c}constructor(){this.d=ye()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const Ve=this.d,Le=Ve.length/3;let Xe=1;for(;Xe<=Le;)if(Oe<Ve[3*Xe])Xe=2*Xe;else if(Oe>Ve[3*Xe+1])Xe=2*Xe+1;else return Ve[3*Xe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Oe){if(Ae===0)return 0;const Ve=We(Ae,Oe);if(Ve!==void 0)return Ve;const Le=new q(Oe,Ae);return Le.prevCodePoint(),Le.offset}e.$ef=je;function We(Ae,Oe){const Ve=new q(Oe,Ae);let Le=Ve.prevCodePoint();for(;xe(Le)||Le===65039||Le===8419;){if(Ve.offset===0)return;Le=Ve.prevCodePoint()}if(!se(Le))return;let Xe=Ve.offset;return Xe>0&&Ve.prevCodePoint()===8205&&(Xe=Ve.offset),Xe}function xe(Ae){return 127995<=Ae&&Ae<=127999}var Qe;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$ff="\xA0";class it{static{this.c=new F.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$he(Oe=>{function Ve(Ze){const nt=new Map;for(let ot=0;ot<Ze.length;ot+=2)nt.set(Ze[ot],Ze[ot+1]);return nt}function Le(Ze,nt){const ot=new Map(Ze);for(const[bt,Dt]of nt)ot.set(bt,Dt);return ot}function Xe(Ze,nt){if(!Ze)return nt;const ot=new Map;for(const[bt,Dt]of Ze)nt.has(bt)&&ot.set(bt,Dt);return ot}const ae=this.c.value;let oe=Oe.filter(Ze=>!Ze.startsWith("_")&&Ze in ae);oe.length===0&&(oe=["_default"]);let Ie;for(const Ze of oe){const nt=Ve(ae[Ze]);Ie=Xe(Ie,nt)}const qe=Ve(ae._common),ze=Le(qe,Ie);return new it(ze)})}static getInstance(Oe){return it.d.get(Array.from(Oe))}static{this.e=new F.$T(()=>Object.keys(it.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$gf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Oe){return et.e().has(Oe)}static get codePoints(){return et.e()}}e.$hf=et}),define(De[121],Ce([1,0,28,15]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.FuzzyScore=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.or=void 0;function f(...te){return function(ue,be){for(let Pe=0,B=te.length;Pe<B;Pe++){const X=te[Pe](ue,be);if(X)return X}return null}}e.or=f,e.$wj=L.bind(void 0,!1),e.$xj=L.bind(void 0,!0);function L(te,ue,be){if(!be||be.length<ue.length)return null;let Pe;return te?Pe=F.$Me(be,ue):Pe=be.indexOf(ue)===0,Pe?ue.length>0?[{start:0,end:ue.length}]:[]:null}function R(te,ue){const be=ue.toLowerCase().indexOf(te.toLowerCase());return be===-1?null:[{start:be,end:be+te.length}]}e.$yj=R;function m(te,ue){return S(te.toLowerCase(),ue.toLowerCase(),0,0)}e.$zj=m;function S(te,ue,be,Pe){if(be===te.length)return[];if(Pe===ue.length)return null;if(te[be]===ue[Pe]){let B=null;return(B=S(te,ue,be+1,Pe+1))?i({start:Pe,end:Pe+1},B):null}return S(te,ue,be,Pe+1)}function b(te){return 97<=te&&te<=122}function P(te){return 65<=te&&te<=90}e.$Aj=P;function I(te){return 48<=te&&te<=57}function p(te){return te===32||te===9||te===10||te===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>k.add(te.charCodeAt(0)));function D(te){return p(te)||k.has(te)}function v(te,ue){return te===ue||D(te)&&D(ue)}function r(te){return b(te)||P(te)||I(te)}function i(te,ue){return ue.length===0?ue=[te]:te.end===ue[0].start?ue[0].start=te.start:ue.unshift(te),ue}function s(te,ue){for(let be=ue;be<te.length;be++){const Pe=te.charCodeAt(be);if(P(Pe)||I(Pe)||be>0&&!r(te.charCodeAt(be-1)))return be}return te.length}function d(te,ue,be,Pe){if(be===te.length)return[];if(Pe===ue.length)return null;if(te[be]!==ue[Pe].toLowerCase())return null;{let B=null,X=Pe+1;for(B=d(te,ue,be+1,Pe+1);!B&&(X=s(ue,X))<ue.length;)B=d(te,ue,be+1,X),X++;return B===null?null:i({start:Pe,end:Pe+1},B)}}function $(te){let ue=0,be=0,Pe=0,B=0,X=0;for(let ye=0;ye<te.length;ye++)X=te.charCodeAt(ye),P(X)&&ue++,b(X)&&be++,r(X)&&Pe++,I(X)&&B++;const ee=ue/te.length,ne=be/te.length,Z=Pe/te.length,de=B/te.length;return{upperPercent:ee,lowerPercent:ne,alphaPercent:Z,numericPercent:de}}function g(te){const{upperPercent:ue,lowerPercent:be}=te;return be===0&&ue>.6}function t(te){const{upperPercent:ue,lowerPercent:be,alphaPercent:Pe,numericPercent:B}=te;return be>.2&&ue<.8&&Pe>.6&&B<.2}function o(te){let ue=0,be=0,Pe=0,B=0;for(let X=0;X<te.length;X++)Pe=te.charCodeAt(X),P(Pe)&&ue++,b(Pe)&&be++,p(Pe)&&B++;return(ue===0||be===0)&&B===0?te.length<=30:ue<=5}function a(te,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!o(te)||ue.length>60)return null;const be=$(ue);if(!t(be)){if(!g(be))return null;ue=ue.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<ue.length&&(Pe=d(te,ue,0,B))===null;)B=s(ue,B+1);return Pe}e.$Bj=a;function n(te,ue,be=!1){if(!ue||ue.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),ue=ue.toLowerCase();B<ue.length&&(Pe=c(te,ue,0,B,be))===null;)B=h(ue,B+1);return Pe}e.$Cj=n;function c(te,ue,be,Pe,B){if(be===te.length)return[];if(Pe===ue.length)return null;if(v(te.charCodeAt(be),ue.charCodeAt(Pe))){let X=null,ee=Pe+1;if(X=c(te,ue,be+1,Pe+1,B),!B)for(;!X&&(ee=h(ue,ee))<ue.length;)X=c(te,ue,be+1,ee,B),ee++;return X?te.charCodeAt(be)!==ue.charCodeAt(Pe)?X:i({start:Pe,end:Pe+1},X):null}else return null}function h(te,ue){for(let be=ue;be<te.length;be++)if(D(te.charCodeAt(be))||be>0&&D(te.charCodeAt(be-1)))return be;return te.length}const E=f(e.$xj,a,R),y=f(e.$xj,a,m),u=new C.$Bi(1e4);function l(te,ue,be=!1){if(typeof te!="string"||typeof ue!="string")return null;let Pe=u.get(te);Pe||(Pe=new RegExp(F.$ve(te),"i"),u.set(te,Pe));const B=Pe.exec(ue);return B?[{start:B.index,end:B.index+B[0].length}]:be?y(te,ue):E(te,ue)}e.$Dj=l;function w(te,ue){const be=Y(te,te.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?O(be):null}e.$Ej=w;function A(te,ue,be,Pe,B,X){const ee=Math.min(13,te.length);for(;be<ee;be++){const ne=Y(te,ue,be,Pe,B,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,X]}e.$Fj=A;function O(te){if(typeof te>"u")return[];const ue=[],be=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+be,X=ue[ue.length-1];X&&X.end===B?X.end=B+1:ue.push({start:B,end:B+1})}return ue}e.$Gj=O;const N=128;function T(){const te=[],ue=[];for(let be=0;be<=N;be++)ue[be]=0;for(let be=0;be<=N;be++)te.push(ue.slice(0));return te}function j(te){const ue=[];for(let be=0;be<=te;be++)ue[be]=0;return ue}const z=j(2*N),M=j(2*N),H=T(),q=T(),me=T(),x=!1;function Q(te,ue,be,Pe,B){function X(ne,Z,de=" "){for(;ne.length<Z;)ne=de+ne;return ne}let ee=` |   |${Pe.split("").map(ne=>X(ne,3)).join("|")}
`;for(let ne=0;ne<=be;ne++)ne===0?ee+=" |":ee+=`${ue[ne-1]}|`,ee+=te[ne].slice(0,B+1).map(Z=>X(Z.toString(),3)).join("|")+`
`;return ee}function V(te,ue,be,Pe){te=te.substr(ue),be=be.substr(Pe),console.log(Q(q,te,te.length,be,be.length)),console.log(Q(me,te,te.length,be,be.length)),console.log(Q(H,te,te.length,be,be.length))}function _(te,ue){if(ue<0||ue>=te.length)return!1;const be=te.codePointAt(ue);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$5e(be)}}function ge(te,ue){if(ue<0||ue>=te.length)return!1;switch(te.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function ce(te,ue,be){return ue[te]!==be[te]}function we(te,ue,be,Pe,B,X,ee=!1){for(;ue<be&&B<X;)te[ue]===Pe[B]&&(ee&&(z[ue]=B),ue+=1),B+=1;return ue===be}e.$Hj=we;var G;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(G||(G={}));var U;(function(te){te.Default=[-100,0];function ue(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}te.isDefault=ue})(U||(e.FuzzyScore=U={}));class K{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ue,be){this.firstMatchCanBeWeak=ue,this.boostFullMatch=be}}e.$Ij=K;function Y(te,ue,be,Pe,B,X,ee=K.default){const ne=te.length>N?N:te.length,Z=Pe.length>N?N:Pe.length;if(be>=ne||X>=Z||ne-be>Z-X||!we(ue,be,ne,B,X,Z,!0))return;se(ne,Z,be,X,ue,B);let de=1,ye=1,je=be,We=X;const xe=[!1];for(de=1,je=be;je<ne;de++,je++){const Oe=z[je],Ve=M[je],Le=je+1<ne?M[je+1]:Z;for(ye=Oe-X+1,We=Oe;We<Le;ye++,We++){let Xe=Number.MIN_SAFE_INTEGER,ae=!1;We<=Ve&&(Xe=re(te,ue,je,be,Pe,B,We,Z,X,H[de-1][ye-1]===0,xe));let oe=0;Xe!==Number.MAX_SAFE_INTEGER&&(ae=!0,oe=Xe+q[de-1][ye-1]);const Ie=We>Oe,qe=Ie?q[de][ye-1]+(H[de][ye-1]>0?-5:0):0,ze=We>Oe+1&&H[de][ye-1]>0,Ze=ze?q[de][ye-2]+(H[de][ye-2]>0?-5:0):0;if(ze&&(!Ie||Ze>=qe)&&(!ae||Ze>=oe))q[de][ye]=Ze,me[de][ye]=3,H[de][ye]=0;else if(Ie&&(!ae||qe>=oe))q[de][ye]=qe,me[de][ye]=2,H[de][ye]=0;else if(ae)q[de][ye]=oe,me[de][ye]=1,H[de][ye]=H[de-1][ye-1]+1;else throw new Error("not possible")}}if(x&&V(te,be,Pe,X),!xe[0]&&!ee.firstMatchCanBeWeak)return;de--,ye--;const Qe=[q[de][ye],X];let it=0,et=0;for(;de>=1;){let Oe=ye;do{const Ve=me[de][Oe];if(Ve===3)Oe=Oe-2;else if(Ve===2)Oe=Oe-1;else break}while(Oe>=1);it>1&&ue[be+de-1]===B[X+ye-1]&&!ce(Oe+X-1,Pe,B)&&it+1>H[de][Oe]&&(Oe=ye),Oe===ye?it++:it=1,et||(et=Oe),de--,ye=Oe-1,Qe.push(ye)}Z===ne&&ee.boostFullMatch&&(Qe[0]+=2);const Ae=et-ne;return Qe[0]-=Ae,Qe}e.$Jj=Y;function se(te,ue,be,Pe,B,X){let ee=te-1,ne=ue-1;for(;ee>=be&&ne>=Pe;)B[ee]===X[ne]&&(M[ee]=ne,ee--),ne--}function re(te,ue,be,Pe,B,X,ee,ne,Z,de,ye){if(ue[be]!==X[ee])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return ee===be-Pe?je=te[be]===B[ee]?7:5:ce(ee,B,X)&&(ee===0||!ce(ee-1,B,X))?(je=te[be]===B[ee]?7:5,We=!0):_(X,ee)&&(ee===0||!_(X,ee-1))?je=5:(_(X,ee-1)||ge(X,ee-1))&&(je=5,We=!0),je>1&&be===Pe&&(ye[0]=!0),We||(We=ce(ee,B,X)||_(X,ee-1)||ge(X,ee-1)),be===Pe?ee>Z&&(je-=We?3:5):de?je+=We?2:0:je+=We?0:1,ee+1===ne&&(je-=We?3:5),je}function le(te,ue,be,Pe,B,X,ee){return he(te,ue,be,Pe,B,X,!0,ee)}e.$Kj=le;function Ee(te,ue,be,Pe,B,X,ee){return he(te,ue,be,Pe,B,X,!1,ee)}e.$Lj=Ee;function he(te,ue,be,Pe,B,X,ee,ne){let Z=Y(te,ue,be,Pe,B,X,ne);if(Z&&!ee)return Z;if(te.length>=3){const de=Math.min(7,te.length-1);for(let ye=be+1;ye<de;ye++){const je=fe(te,ye);if(je){const We=Y(je,je.toLowerCase(),be,Pe,B,X,ne);We&&(We[0]-=3,(!Z||We[0]>Z[0])&&(Z=We))}}}return Z}function fe(te,ue){if(ue+1>=te.length)return;const be=te[ue],Pe=te[ue+1];if(be!==Pe)return te.slice(0,ue)+Pe+be+te.slice(ue+2)}}),define(De[51],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0;function F(i){return f(i,0)}e.$oi=F;function f(i,s){switch(typeof i){case"object":return i===null?L(349,s):Array.isArray(i)?S(i,s):b(i,s);case"string":return m(i,s);case"boolean":return R(i,s);case"number":return L(i,s);case"undefined":return L(937,s);default:return L(617,s)}}e.$pi=f;function L(i,s){return(s<<5)-s+i|0}e.$qi=L;function R(i,s){return L(i?433:863,s)}function m(i,s){s=L(149417,s);for(let d=0,$=i.length;d<$;d++)s=L(i.charCodeAt(d),s);return s}e.$ri=m;function S(i,s){return s=L(104579,s),i.reduce((d,$)=>f($,d),s)}function b(i,s){return s=L(181387,s),Object.keys(i).sort().reduce((d,$)=>(d=m($,d),f(i[$],d)),s)}class P{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=f(s,this.g),this.g}}e.$si=P;var I;(function(i){i[i.BLOCK_SIZE=64]="BLOCK_SIZE",i[i.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(i,s,d=32){const $=d-s,g=~((1<<$)-1);return(i<<s|(g&i)>>>$)>>>0}function k(i,s=0,d=i.byteLength,$=0){for(let g=0;g<d;g++)i[s+g]=$}function D(i,s,d="0"){for(;i.length<s;)i=d+i;return i}function v(i,s=32){return i instanceof ArrayBuffer?Array.from(new Uint8Array(i)).map(d=>d.toString(16).padStart(2,"0")).join(""):D((i>>>0).toString(16),s/4)}e.$ti=v;class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const d=s.length;if(d===0)return;const $=this.p;let g=this.r,t=this.u,o,a;for(t!==0?(o=t,a=-1,t=0):(o=s.charCodeAt(0),a=0);;){let n=o;if(C.$Pe(o))if(a+1<d){const c=s.charCodeAt(a+1);C.$Qe(c)?(a++,n=C.$Re(o,c)):n=65533}else{t=o;break}else C.$Qe(o)&&(n=65533);if(g=this.w($,g,n),a++,a<d)o=s.charCodeAt(a);else break}this.r=g,this.u=t}w(s,d,$){return $<128?s[d++]=$:$<2048?(s[d++]=192|($&1984)>>>6,s[d++]=128|($&63)>>>0):$<65536?(s[d++]=224|($&61440)>>>12,s[d++]=128|($&4032)>>>6,s[d++]=128|($&63)>>>0):(s[d++]=240|($&1835008)>>>18,s[d++]=128|($&258048)>>>12,s[d++]=128|($&4032)>>>6,s[d++]=128|($&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=r.g,d=this.q;for(let E=0;E<64;E+=4)s.setUint32(E,d.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)s.setUint32(E,p(s.getUint32(E-12,!1)^s.getUint32(E-32,!1)^s.getUint32(E-56,!1)^s.getUint32(E-64,!1),1),!1);let $=this.h,g=this.l,t=this.m,o=this.n,a=this.o,n,c,h;for(let E=0;E<80;E++)E<20?(n=g&t|~g&o,c=1518500249):E<40?(n=g^t^o,c=1859775393):E<60?(n=g&t|g&o|t&o,c=2400959708):(n=g^t^o,c=3395469782),h=p($,5)+n+a+c+s.getUint32(E*4,!1)&4294967295,a=o,o=t,t=p(g,30),g=$,$=h;this.h=this.h+$&4294967295,this.l=this.l+g&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+a&4294967295}}e.$ui=r}),define(De[38],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const L="error",R="warning",m="warn",S="info",b="ignore";function P(p){return p?C.$Le(L,p)?f.Error:C.$Le(R,p)||C.$Le(m,p)?f.Warning:C.$Le(S,p)?f.Info:f.Ignore:f.Ignore}f.fromValue=P;function I(p){switch(p){case f.Error:return L;case f.Warning:return R;case f.Info:return S;default:return b}}f.toString=I}(F||(F={})),e.default=F}),define(De[160],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(De[77],Ce([1,0,19,15]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class f{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const D=k.charCodeAt(0),v=this.b.charCodeAt(this.c);return D-v}value(){return this.b[this.c]}}e.$Ch=f;class L{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,F.$Fe)(k,this.b,0,k.length,this.c,this.d):(0,F.$He)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Dh=L;class R{constructor(k=!0,D=!0){this.f=k,this.g=D}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let D=k.length-1;D>=0;D--,this.c--){const v=this.b.charCodeAt(D);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,F.$Fe)(k,this.b,0,k.length,this.d,this.e):(0,F.$He)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Eh=R;var m;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(m||(m={}));class S{constructor(k,D){this.f=k,this.g=D,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,F.$Ge)(k,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Ge)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,F.$Ee)(k,this.c.query);if(this.d[this.e]===5)return(0,F.$Ee)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fh=S;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(P||(P={}));class I{static forUris(k=()=>!1,D=()=>!1){return new I(new S(k,D))}static forPaths(k=!1){return new I(new R(void 0,!k))}static forStrings(){return new I(new f)}static forConfigKeys(){return new I(new L)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,D){if(D){const v=D.slice(0);(0,C.$Ub)(v);for(const r of v)this.set(r,k)}else{const v=k.slice(0);(0,C.$Ub)(v);for(const r of v)this.set(r[0],r[1])}}set(k,D){const v=this.b.reset(k);let r;this.c||(this.c=new b,this.c.segment=v.value());const i=[];for(r=this.c;;){const d=v.cmp(r.segment);if(d>0)r.left||(r.left=new b,r.left.segment=v.value()),i.push([-1,r]),r=r.left;else if(d<0)r.right||(r.right=new b,r.right.segment=v.value()),i.push([1,r]),r=r.right;else if(v.hasNext())v.next(),r.mid||(r.mid=new b,r.mid.segment=v.value()),i.push([0,r]),r=r.mid;else break}const s=r.value;r.value=D,r.key=k;for(let d=i.length-1;d>=0;d--){const $=i[d][1];$.updateHeight();const g=$.balanceFactor();if(g<-1||g>1){const t=i[d][0],o=i[d+1][0];if(t===1&&o===1)i[d][1]=$.rotateLeft();else if(t===-1&&o===-1)i[d][1]=$.rotateRight();else if(t===1&&o===-1)$.right=i[d+1][1]=i[d+1][1].rotateRight(),i[d][1]=$.rotateLeft();else if(t===-1&&o===1)$.left=i[d+1][1]=i[d+1][1].rotateLeft(),i[d][1]=$.rotateRight();else throw new Error;if(d>0)switch(i[d-1][0]){case-1:i[d-1][1].left=i[d][1];break;case 1:i[d-1][1].right=i[d][1];break;case 0:i[d-1][1].mid=i[d][1];break}else this.c=i[0][1]}}return s}get(k){return this.d(k)?.value}d(k){const D=this.b.reset(k);let v=this.c;for(;v;){const r=D.cmp(v.segment);if(r>0)v=v.left;else if(r<0)v=v.right;else if(D.hasNext())D.next(),v=v.mid;else break}return v}has(k){const D=this.d(k);return!(D?.value===void 0&&D?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,D){const v=this.b.reset(k),r=[];let i=this.c;for(;i;){const s=v.cmp(i.segment);if(s>0)r.push([-1,i]),i=i.left;else if(s<0)r.push([1,i]),i=i.right;else if(v.hasNext())v.next(),r.push([0,i]),i=i.mid;else break}if(i){if(D?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const s=this.f(i.right);if(s.key){const{key:d,value:$,segment:g}=s;this.e(s.key,!1),i.key=d,i.value=$,i.segment=g}}else{const s=i.left??i.right;if(r.length>0){const[d,$]=r[r.length-1];switch(d){case-1:$.left=s;break;case 0:$.mid=s;break;case 1:$.right=s;break}}else this.c=s}for(let s=r.length-1;s>=0;s--){const d=r[s][1];d.updateHeight();const $=d.balanceFactor();if($>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),r[s][1]=d.rotateLeft()):$<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),r[s][1]=d.rotateRight()),s>0)switch(r[s-1][0]){case-1:r[s-1][1].left=r[s][1];break;case 1:r[s-1][1].right=r[s][1];break;case 0:r[s-1][1].mid=r[s][1];break}else this.c=r[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const D=this.b.reset(k);let v=this.c,r;for(;v;){const i=D.cmp(v.segment);if(i>0)v=v.left;else if(i<0)v=v.right;else if(D.hasNext())D.next(),r=v.value||r,v=v.mid;else break}return v&&v.value||r}findSuperstr(k){return this.g(k,!1)}g(k,D){const v=this.b.reset(k);let r=this.c;for(;r;){const i=v.cmp(r.segment);if(i>0)r=r.left;else if(i<0)r=r.right;else if(v.hasNext())v.next(),r=r.mid;else return r.mid?this.h(r.mid):D?r.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[D,v]of this)k(v,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const D=[];return this.j(k,D),D[Symbol.iterator]()}j(k,D){k&&(k.left&&this.j(k.left,D),k.value&&D.push([k.key,k.value]),k.mid&&this.j(k.mid,D),k.right&&this.j(k.right,D))}_isBalanced(){const k=D=>{if(!D)return!0;const v=D.balanceFactor();return v<-1||v>1?!1:k(D.left)&&k(D.right)};return k(this.c)}}e.$Gh=I}),define(De[18],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=void 0;function C(g){return typeof g=="string"}e.$if=C;function F(g){return Array.isArray(g)&&g.every(t=>C(t))}e.$jf=F;function f(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.$kf=f;function L(g){const t=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof t}e.$lf=L;function R(g){return typeof g=="number"&&!isNaN(g)}e.$mf=R;function m(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.$nf=m;function S(g){return g===!0||g===!1}e.$of=S;function b(g){return typeof g>"u"}e.$pf=b;function P(g){return!I(g)}e.$qf=P;function I(g){return b(g)||g===null}e.$rf=I;function p(g,t){if(!g)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$sf=p;function k(g){if(I(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.$tf=k;function D(...g){const t=[];for(let o=0;o<g.length;o++){const a=g[o];if(I(a))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(a)}return t}e.$uf=D;const v=Object.prototype.hasOwnProperty;function r(g){if(!f(g))return!1;for(const t in g)if(v.call(g,t))return!1;return!0}e.$vf=r;function i(g){return typeof g=="function"}e.$wf=i;function s(...g){return g.length>0&&g.every(i)}e.$xf=s;function d(g,t){const o=Math.min(g.length,t.length);for(let a=0;a<o;a++)$(g[a],t[a])}e.$yf=d;function $(g,t){if(C(t)){if(typeof g!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(i(t)){try{if(g instanceof t)return}catch{}if(!I(g)&&g.constructor===t||t.length===1&&t.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$zf=$}),define(De[78],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=void 0;const F=Object.create(null);function f(m,S){if((0,C.$if)(S)){const b=F[S];if(b===void 0)throw new Error(`${m} references an unknown codicon: ${S}`);S=b}return F[m]=S,{id:m}}function L(){return F}e.$Mj=L;function R(){return Object.values(e.$Oj)}e.$Nj=R,e.$Oj={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package_:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=void 0;function F(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const s=Array.isArray(i)?[]:{};return Object.entries(i).forEach(([d,$])=>{s[d]=$&&typeof $=="object"?F($):$}),s}e.$Um=F;function f(i){if(!i||typeof i!="object")return i;const s=[i];for(;s.length>0;){const d=s.shift();Object.freeze(d);for(const $ in d)if(L.call(d,$)){const g=d[$];typeof g=="object"&&!Object.isFrozen(g)&&!(0,C.$lf)(g)&&s.push(g)}}return i}e.$Vm=f;const L=Object.prototype.hasOwnProperty;function R(i,s){return m(i,s,new Set)}e.$Wm=R;function m(i,s,d){if((0,C.$rf)(i))return i;const $=s(i);if(typeof $<"u")return $;if(Array.isArray(i)){const g=[];for(const t of i)g.push(m(t,s,d));return g}if((0,C.$kf)(i)){if(d.has(i))throw new Error("Cannot clone recursive data-structure");d.add(i);const g={};for(const t in i)L.call(i,t)&&(g[t]=m(i[t],s,d));return d.delete(i),g}return i}function S(i,s,d=!0){return(0,C.$kf)(i)?((0,C.$kf)(s)&&Object.keys(s).forEach($=>{$ in i?d&&((0,C.$kf)(i[$])&&(0,C.$kf)(s[$])?S(i[$],s[$],d):i[$]=s[$]):i[$]=s[$]}),i):s}e.$Xm=S;function b(i,s){if(i===s)return!0;if(i==null||s===null||s===void 0||typeof i!=typeof s||typeof i!="object"||Array.isArray(i)!==Array.isArray(s))return!1;let d,$;if(Array.isArray(i)){if(i.length!==s.length)return!1;for(d=0;d<i.length;d++)if(!b(i[d],s[d]))return!1}else{const g=[];for($ in i)g.push($);g.sort();const t=[];for($ in s)t.push($);if(t.sort(),!b(g,t))return!1;for(d=0;d<g.length;d++)if(!b(i[g[d]],s[g[d]]))return!1}return!0}e.$Ym=b;function P(i){const s=new Set;return JSON.stringify(i,(d,$)=>{if((0,C.$kf)($)||Array.isArray($)){if(s.has($))return"[Circular]";s.add($)}return $})}e.$Zm=P;function I(i,s){const d=Object.create(null);return!i||!s||Object.keys(s).forEach(g=>{const t=i[g],o=s[g];b(t,o)||(d[g]=o)}),d}e.$1m=I;function p(i,s){const d=s.toLowerCase(),$=Object.keys(i).find(g=>g.toLowerCase()===d);return $?i[$]:i[s]}e.$2m=p;function k(i,s){const d=Object.create(null);for(const[$,g]of Object.entries(i))s($,g)&&(d[$]=g);return d}e.$3m=k;function D(i){let s=[];for(;Object.prototype!==i;)s=s.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return s}e.$4m=D;function v(i){const s=[];for(const d of D(i))typeof i[d]=="function"&&s.push(d);return s}e.$5m=v;function r(i,s){const d=g=>function(){const t=Array.prototype.slice.call(arguments,0);return s(g,t)},$={};for(const g of i)$[g]=d(g);return $}e.$6m=r}),define(De[60],Ce([1,0,78]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Pj=e.ThemeColor=void 0;var F;(function(R){function m(S){return S&&typeof S=="object"&&typeof S.id=="string"}R.isThemeColor=m})(F||(e.ThemeColor=F={}));function f(R){return{id:R}}e.$Pj=f;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function S(s){const d=m.exec(s.id);if(!d)return S(C.$Oj.error);const[,$,g]=d,t=["codicon","codicon-"+$];return g&&t.push("codicon-modifier-"+g.substring(1)),t}R.asClassNameArray=S;function b(s){return S(s).join(" ")}R.asClassName=b;function P(s){return"."+S(s).join(".")}R.asCSSSelector=P;function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||F.isThemeColor(s.color))}R.isThemeIcon=I;const p=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function k(s){const d=p.exec(s);if(!d)return;const[,$]=d;return{id:$}}R.fromString=k;function D(s){return{id:s}}R.fromId=D;function v(s,d){let $=s.id;const g=$.lastIndexOf("~");return g!==-1&&($=$.substring(0,g)),d&&($=`${$}~${d}`),{id:$}}R.modify=v;function r(s){const d=s.id.lastIndexOf("~");if(d!==-1)return s.id.substring(d+1)}R.getModifier=r;function i(s,d){return s.id===d.id&&s.color?.id===d.color?.id}R.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(De[161],Ce([1,0,121,15,60]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=void 0;const L="$(",R=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function S(i){return i.replace(m,(s,d)=>d?s:`\\${s}`)}e.$Qj=S;const b=new RegExp(`\\\\${R.source}`,"g");function P(i){return i.replace(b,s=>`\\${s}`)}e.$Rj=P;const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function p(i){return i.indexOf(L)===-1?i:i.replace(I,(s,d,$,g)=>$?s:d||g||"")}e.$Sj=p;function k(i){return i?i.replace(/\$\((.*?)\)/g,(s,d)=>` ${d} `).trim():""}e.$Tj=k;const D=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function v(i){D.lastIndex=0;let s="";const d=[];let $=0;for(;;){const g=D.lastIndex,t=D.exec(i),o=i.substring(g,t?.index);if(o.length>0){s+=o;for(let a=0;a<o.length;a++)d.push($)}if(!t)break;$+=t[0].length}return{text:s,iconOffsets:d}}e.$Uj=v;function r(i,s,d=!1){const{text:$,iconOffsets:g}=s;if(!g||g.length===0)return(0,C.$Dj)(i,$,d);const t=(0,F.$te)($," "),o=$.length-t.length,a=(0,C.$Dj)(i,t,d);if(a)for(const n of a){const c=g[n.start+o]+o;n.start+=c,n.end+=c}return a}e.$Vj=r}),define(De[122],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=e.$je=e.Constants=void 0;var C;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function F(L){return L<0?0:L>255?255:L|0}e.$je=F;function f(L){return L<0?0:L>4294967295?4294967295:L|0}e.$ke=f}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return C.test(f)}e.$2f=F,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(m){for(let S=0;S<m.length;S++)m[S]=Math.floor(Math.random()*256);return m};const L=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){f(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,b="";return b+=R[L[S++]],b+=R[L[S++]],b+=R[L[S++]],b+=R[L[S++]],b+="-",b+=R[L[S++]],b+=R[L[S++]],b+="-",b+=R[L[S++]],b+=R[L[S++]],b+="-",b+=R[L[S++]],b+=R[L[S++]],b+="-",b+=R[L[S++]],b+=R[L[S++]],b+=R[L[S++]],b+=R[L[S++]],b+=R[L[S++]],b+=R[L[S++]],b}}()}),define(De[162],Ce([1,0,19,50,31]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=e.$Qs=e.$Ps=e.$Os=e.$Ns=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Ns=L;function R(I,p,k){const D={id:(0,f.$3f)(),name:I,uri:p,data:k};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$Os=R;class m{constructor(){this.a=new Map}get size(){let p=0;for(const k of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const k=[...this.a.keys()];return F.Iterable.some(this,([D,v])=>v.asFile())&&k.push("files"),P(S(p),k)}get(p){return this.a.get(this.b(p))?.[0]}append(p,k){const D=this.a.get(p);D?D.push(k):this.a.set(this.b(p),[k])}replace(p,k){this.a.set(this.b(p),[k])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,k]of this.a)for(const D of k)yield[p,D]}b(p){return S(p)}}e.$Ps=m;function S(I){return I.toLowerCase()}function b(I,p){return P(S(I),p.map(S))}e.$Qs=b;function P(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const k=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[D,v,r]=k;return r==="*"?p.some(i=>i.startsWith(v+"/")):!1}e.$Rs=Object.freeze({create:I=>(0,C.$Jb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Rs.split(I).filter(p=>!p.startsWith("#"))})}),define(De[163],Ce([1,0,61]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=void 0;function F(m,S,b,P=1){let I=!1;return new Promise(p=>{const k=setTimeout(()=>{if(!I)return I=!0,p(0)},b);f(m,S,P,D=>{if(!I)return I=!0,clearTimeout(k),p(D)})})}e.$5f=F;function f(m,S,b,P){if(S===0)return P(0);const I=new C.Socket;I.once("connect",()=>(R(I),f(m+b,S-1,b,P))),I.once("data",()=>{}),I.once("error",p=>(R(I),p.code!=="ECONNREFUSED"?f(m+b,S-1,b,P):P(m))),I.connect(m,"127.0.0.1")}e.$6f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(m,S,b,P="127.0.0.1"){let I=!1,p,k=1;const D=C.createServer({pauseOnConnect:!0});function v(r,i){I||(I=!0,D.removeAllListeners(),D.close(),p&&clearTimeout(p),i(r))}return new Promise(r=>{p=setTimeout(()=>{v(0,r)},b),D.on("listening",()=>{v(m,r)}),D.on("error",i=>{i&&(i.code==="EADDRINUSE"||i.code==="EACCES")&&k<S?(m++,k++,D.listen(m,P)):v(0,r)}),D.on("close",()=>{v(0,r)}),D.listen(m,P)})}e.$7f=L;function R(m){try{m.removeAllListeners("connect"),m.removeAllListeners("error"),m.end(),m.destroy(),m.unref()}catch(S){console.error(S)}}}),define(De[123],Ce([1,0,122]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=e.$Fs=void 0;class F{constructor(m){const S=(0,C.$je)(m);this.c=S,this.a=F.d(S),this.b=new Map}static d(m){const S=new Uint8Array(256);return S.fill(m),S}set(m,S){const b=(0,C.$je)(S);m>=0&&m<256?this.a[m]=b:this.b.set(m,b)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Fs=F;var f;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(f||(f={}));class L{constructor(){this.a=new F(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$Gs=L}),define(De[62],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class C{constructor(f,L){this.lineNumber=f,this.column=L}with(f=this.lineNumber,L=this.column){return f===this.lineNumber&&L===this.column?this:new C(f,L)}delta(f=0,L=0){return this.with(this.lineNumber+f,this.column+L)}equals(f){return C.equals(this,f)}static equals(f,L){return!f&&!L?!0:!!f&&!!L&&f.lineNumber===L.lineNumber&&f.column===L.column}isBefore(f){return C.isBefore(this,f)}static isBefore(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<L.column}isBeforeOrEqual(f){return C.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,L){return f.lineNumber<L.lineNumber?!0:L.lineNumber<f.lineNumber?!1:f.column<=L.column}static compare(f,L){const R=f.lineNumber|0,m=L.lineNumber|0;if(R===m){const S=f.column|0,b=L.column|0;return S-b}return R-m}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new C(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$hs=C}),define(De[34],Ce([1,0,62]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class F{constructor(L,R,m,S){L>m||L===m&&R>S?(this.startLineNumber=m,this.startColumn=S,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=m,this.endColumn=S)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,R){let m,S,b,P;return R.startLineNumber<L.startLineNumber?(m=R.startLineNumber,S=R.startColumn):R.startLineNumber===L.startLineNumber?(m=R.startLineNumber,S=Math.min(R.startColumn,L.startColumn)):(m=L.startLineNumber,S=L.startColumn),R.endLineNumber>L.endLineNumber?(b=R.endLineNumber,P=R.endColumn):R.endLineNumber===L.endLineNumber?(b=R.endLineNumber,P=Math.max(R.endColumn,L.endColumn)):(b=L.endLineNumber,P=L.endColumn),new F(m,S,b,P)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,R){let m=L.startLineNumber,S=L.startColumn,b=L.endLineNumber,P=L.endColumn;const I=R.startLineNumber,p=R.startColumn,k=R.endLineNumber,D=R.endColumn;return m<I?(m=I,S=p):m===I&&(S=Math.max(S,p)),b>k?(b=k,P=D):b===k&&(P=Math.min(P,D)),m>b||m===b&&S>P?null:new F(m,S,b,P)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new C.$hs(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new C.$hs(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new F(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new F(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new F(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const b=L.startLineNumber|0,P=R.startLineNumber|0;if(b===P){const I=L.startColumn|0,p=R.startColumn|0;if(I===p){const k=L.endLineNumber|0,D=R.endLineNumber|0;if(k===D){const v=L.endColumn|0,r=R.endColumn|0;return v-r}return k-D}return I-p}return b-P}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$is=F}),define(De[164],Ce([1,0,34]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class F{static insert(L,R){return{range:new C.$is(L.lineNumber,L.column,L.lineNumber,L.column),text:R,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,R){return{range:L,text:R}}static replaceMove(L,R){return{range:L,text:R,forceMoveMarkers:!0}}}e.$js=F}),define(De[165],Ce([1,0,62,34]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.SelectionDirection=void 0;var f;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class L extends F.$is{constructor(m,S,b,P){super(m,S,b,P),this.selectionStartLineNumber=m,this.selectionStartColumn=S,this.positionLineNumber=b,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return L.selectionsEqual(this,m)}static selectionsEqual(m,S){return m.selectionStartLineNumber===S.selectionStartLineNumber&&m.selectionStartColumn===S.selectionStartColumn&&m.positionLineNumber===S.positionLineNumber&&m.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,S){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,m,S):new L(m,S,this.startLineNumber,this.startColumn)}getPosition(){return new C.$hs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$hs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,S){return this.getDirection()===0?new L(m,S,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,m,S)}static fromPositions(m,S=m){return new L(m.lineNumber,m.column,S.lineNumber,S.column)}static fromRange(m,S){return S===0?new L(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new L(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new L(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,S){if(m&&!S||!m&&S)return!1;if(!m&&!S)return!0;if(m.length!==S.length)return!1;for(let b=0,P=m.length;b<P;b++)if(!this.selectionsEqual(m[b],S[b]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,S,b,P,I){return I===0?new L(m,S,b,P):new L(b,P,m,S)}}e.$ks=L}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0,e.$Sr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=e.$Hs=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends C.$Fs{constructor(m){super(0);for(let S=0,b=m.length;S<b;S++)this.set(m.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.$Hs=f;function L(R){const m={};return S=>(m.hasOwnProperty(S)||(m[S]=R(S)),m[S])}e.$Is=L(R=>new f(R))}),define(De[124],Ce([1,0,50,3,75]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0,e.$Tr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$Tr)I.indexOf(k)>=0||(p+="\\"+k);return p+="\\s]+)",new RegExp(p,"g")}e.$Ur=L();function R(I){let p=e.$Ur;if(I&&I instanceof RegExp)if(I.global)p=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),p=new RegExp(I.source,k)}return p.lastIndex=0,p}e.$Vr=R;const m=new f.$sc;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(I){const p=m.unshift(I);return(0,F.$hc)(p)}e.$Wr=S;function b(I,p,k,D,v){if(v||(v=C.Iterable.first(m)),k.length>v.maxLen){let $=I-v.maxLen/2;return $<0?$=0:D+=$,k=k.substring($,I+v.maxLen/2),b(I,p,k,D,v)}const r=Date.now(),i=I-1-D;let s=-1,d=null;for(let $=1;!(Date.now()-r>=v.timeBudget);$++){const g=i-v.windowSize*$;p.lastIndex=Math.max(0,g);const t=P(p,k,i,s);if(!t&&d||(d=t,g<=0))break;s=g}if(d){const $={word:d[0],startColumn:D+1+d.index,endColumn:D+1+d.index+d[0].length};return p.lastIndex=0,$}return null}e.$Xr=b;function P(I,p,k,D){let v;for(;v=I.exec(p);){const r=v.index||0;if(r<=k&&I.lastIndex>=k)return v;if(D>0&&r>D)return null}return null}}),define(De[168],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.IndentAction=void 0;var C;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class F{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let S=0,b=m.notIn.length;S<b;S++)switch(m.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,S){if(m.getTokenCount()===0)return!0;const b=m.findTokenIndexAtOffset(S-2),P=m.getStandardTokenType(b);return this.isOK(P)}g(m,S){for(let b=m;b<=S;b++){const P=String.fromCharCode(b);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$et=F;class f{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of m)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.$ft=f;function L(R,m,S){R.has(m)?R.get(m).push(S):R.set(m,[S])}}),define(De[169],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pY=e.$oY=e.$nY=e.State=void 0;var F;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(D,v,r){const i=new Uint8Array(D*v);for(let s=0,d=D*v;s<d;s++)i[s]=r;this.a=i,this.rows=D,this.cols=v}get(D,v){return this.a[D*this.cols+v]}set(D,v,r){this.a[D*this.cols+v]=r}}class L{constructor(D){let v=0,r=0;for(let s=0,d=D.length;s<d;s++){const[$,g,t]=D[s];g>v&&(v=g),$>r&&(r=$),t>r&&(r=t)}v++,r++;const i=new f(r,v,0);for(let s=0,d=D.length;s<d;s++){const[$,g,t]=D[s];i.set($,g,t)}this.a=i,this.b=v}nextState(D,v){return v<0||v>=this.b?0:this.a.get(D,v)}}e.$nY=L;let R=null;function m(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var S;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let b=null;function P(){if(b===null){b=new C.$Fs(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<k.length;v++)b.set(k.charCodeAt(v),1);const D=".,;:";for(let v=0;v<D.length;v++)b.set(D.charCodeAt(v),2)}return b}class I{static a(D,v,r,i,s){let d=s-1;do{const $=v.charCodeAt(d);if(D.get($)!==2)break;d--}while(d>i);if(i>0){const $=v.charCodeAt(i-1),g=v.charCodeAt(d);($===40&&g===41||$===91&&g===93||$===123&&g===125)&&d--}return{range:{startLineNumber:r,startColumn:i+1,endLineNumber:r,endColumn:d+2},url:v.substring(i,d+1)}}static computeLinks(D,v=m()){const r=P(),i=[];for(let s=1,d=D.getLineCount();s<=d;s++){const $=D.getLineContent(s),g=$.length;let t=0,o=0,a=0,n=1,c=!1,h=!1,E=!1,y=!1;for(;t<g;){let u=!1;const l=$.charCodeAt(t);if(n===13){let w;switch(l){case 40:c=!0,w=0;break;case 41:w=c?0:1;break;case 91:E=!0,h=!0,w=0;break;case 93:E=!1,w=h?0:1;break;case 123:y=!0,w=0;break;case 125:w=y?0:1;break;case 39:case 34:case 96:a===l?w=1:a===39||a===34||a===96?w=0:w=1;break;case 42:w=a===42?1:0;break;case 124:w=a===124?1:0;break;case 32:w=E?0:1;break;default:w=r.get(l)}w===1&&(i.push(I.a(r,$,s,o,t)),u=!0)}else if(n===12){let w;l===91?(h=!0,w=0):w=r.get(l),w===1?u=!0:n=13}else n=v.nextState(n,l),n===0&&(u=!0);u&&(n=1,c=!1,h=!1,y=!1,o=t+1,a=l),t++}n===13&&i.push(I.a(r,$,s,o,g))}return i}}e.$oY=I;function p(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:I.computeLinks(k)}e.$pY=p}),define(De[125],Ce([1,0,23]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eu=e.$Du=e.$Cu=e.$Bu=e.ModelConstants=e.PositionAffinity=e.$Au=e.TrackedRangeStickiness=e.$zu=e.$yu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function($){$[$.Left=1]="Left",$[$.Center=2]="Center",$[$.Right=4]="Right",$[$.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var L;(function($){$[$.Inline=1]="Inline",$[$.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function($){$[$.Both=0]="Both",$[$.Right=1]="Right",$[$.Left=2]="Left",$[$.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var m;(function($){$[$.TextDefined=0]="TextDefined",$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var S;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var b;(function($){$[$.LF=0]="LF",$[$.CRLF=1]="CRLF"})(b||(e.EndOfLineSequence=b={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),g.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,g.indentSize|0),this.a=!1),this.insertSpaces=!!g.insertSpaces,this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=!!g.trimAutoWhitespace,this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.a===g.a&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,C.$Ym)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.$yu=P;class I{constructor(g,t){this._findMatchBrand=void 0,this.range=g,this.matches=t}}e.$zu=I;var p;(function($){$[$.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",$[$.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",$[$.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",$[$.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function k($){return $&&typeof $.read=="function"}e.$Au=k;var D;(function($){$[$.Left=0]="Left",$[$.Right=1]="Right",$[$.None=2]="None",$[$.LeftOfInjectedText=3]="LeftOfInjectedText",$[$.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var v;(function($){$[$.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(e.ModelConstants=v={}));class r{constructor(g,t,o,a,n,c){this.identifier=g,this.range=t,this.text=o,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=n,this._isTracked=c}}e.$Bu=r;class i{constructor(g,t,o){this.regex=g,this.wordSeparators=t,this.simpleSearch=o}}e.$Cu=i;class s{constructor(g,t,o){this.reverseEdits=g,this.changes=t,this.trimAutoWhitespaceLineNumbers=o}}e.$Du=s;function d($){return!$.isTooLargeForSyncing()&&!$.isForSimpleWidget}e.$Eu=d}),define(De[170],Ce([1,0,19,122]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ju=e.$Iu=e.$Hu=void 0;class f{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,b){S=(0,F.$ke)(S);const P=this.a,I=this.b,p=b.length;return p===0?!1:(this.a=new Uint32Array(P.length+p),this.a.set(P.subarray(0,S),0),this.a.set(P.subarray(S),S+p),this.a.set(b,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(S,b){return S=(0,F.$ke)(S),b=(0,F.$ke)(b),this.a[S]===b?!1:(this.a[S]=b,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,b){S=(0,F.$ke)(S),b=(0,F.$ke)(b);const P=this.a,I=this.b;if(S>=P.length)return!1;const p=P.length-S;return b>=p&&(b=p),b===0?!1:(this.a=new Uint32Array(P.length-b),this.a.set(P.subarray(0,S),0),this.a.set(P.subarray(S+b),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,F.$ke)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let b=this.c[0]+1;b===0&&(this.b[0]=this.a[0],b++),S>=this.a.length&&(S=this.a.length-1);for(let P=b;P<=S;P++)this.b[P]=this.b[P-1]+this.a[P];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let b=0,P=this.a.length-1,I=0,p=0,k=0;for(;b<=P;)if(I=b+(P-b)/2|0,p=this.b[I],k=p-this.a[I],S<k)P=I-1;else if(S>=p)b=I+1;else break;return new R(I,S-k)}}e.$Hu=f;class L{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const b=this.e[S],P=b>0?this.d[b-1]:0;return new R(b,S-P)}removeValues(S,b){this.a.splice(S,b),this.f(S)}insertValues(S,b){this.a=(0,C.$Tb)(this.a,S,b),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,b=this.a.length;S<b;S++){const P=this.a[S],I=S>0?this.d[S-1]:0;this.d[S]=I+P;for(let p=0;p<P;p++)this.e[I+p]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,b){this.a[S]!==b&&(this.a[S]=b,this.f(S))}}e.$Iu=L;class R{constructor(S,b){this.index=S,this.remainder=b,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=b}}e.$Ju=R}),define(De[171],Ce([1,0,15,62,170]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ku=void 0;class L{constructor(m,S,b,P){this.d=m,this.f=S,this.g=b,this.h=P,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const S=m.changes;for(const b of S)this.o(b.range),this.p(new F.$hs(b.range.startLineNumber,b.range.startColumn),b.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,S=this.f.length,b=new Uint32Array(S);for(let P=0;P<S;P++)b[P]=this.f[P].length+m;this.j=new f.$Hu(b)}}n(m,S){this.f[m]=S,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,S){if(S.length===0)return;const b=(0,C.$ze)(S);if(b.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]+this.f[m.lineNumber-1].substring(m.column-1));return}b[b.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]);const P=new Uint32Array(b.length-1);for(let I=1;I<b.length;I++)this.f.splice(m.lineNumber+I-1,0,b[I]),P[I-1]=b[I].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,P)}}e.$Ku=L}),define(De[172],Ce([1,0,15,167,62,34,125]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jC=e.$iC=e.$hC=e.$gC=e.$fC=e.$eC=void 0;const m=999;class S{constructor(s,d,$,g){this.searchString=s,this.isRegex=d,this.matchCase=$,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=b(this.searchString):s=this.searchString.indexOf(`
`)>=0;let d=null;try{d=C.$xe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch{return null}if(!d)return null;let $=!this.isRegex&&!s;return $&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&($=this.matchCase),new R.$Cu(d,this.wordSeparators?(0,F.$Is)(this.wordSeparators):null,$?this.searchString:null)}}e.$eC=S;function b(i){if(!i||i.length===0)return!1;for(let s=0,d=i.length;s<d;s++){const $=i.charCodeAt(s);if($===10)return!0;if($===92){if(s++,s>=d)break;const g=i.charCodeAt(s);if(g===110||g===114||g===87)return!0}}return!1}e.$fC=b;function P(i,s,d){if(!d)return new R.$zu(i,null);const $=[];for(let g=0,t=s.length;g<t;g++)$[g]=s[g];return new R.$zu(i,$)}e.$gC=P;class I{constructor(s){const d=[];let $=0;for(let g=0,t=s.length;g<t;g++)s.charCodeAt(g)===10&&(d[$++]=g);this.a=d}findLineFeedCountBeforeOffset(s){const d=this.a;let $=0,g=d.length-1;if(g===-1||s<=d[0])return 0;for(;$<g;){const t=$+((g-$)/2>>0);d[t]>=s?g=t-1:d[t+1]>=s?($=t,g=t):$=t+1}return $+1}}class p{static findMatches(s,d,$,g,t){const o=d.parseSearchRequest();return o?o.regex.multiline?this.b(s,$,new r(o.wordSeparators,o.regex),g,t):this.c(s,$,o,g,t):[]}static a(s,d,$,g,t,o){let a,n=0;g?(n=g.findLineFeedCountBeforeOffset(t),a=d+t+n):a=d+t;let c;if(g){const u=g.findLineFeedCountBeforeOffset(t+o.length)-n;c=a+o.length+u}else c=a+o.length;const h=s.getPositionAt(a),E=s.getPositionAt(c);return new L.$is(h.lineNumber,h.column,E.lineNumber,E.column)}static b(s,d,$,g,t){const o=s.getOffsetAt(d.getStartPosition()),a=s.getValueInRange(d,1),n=s.getEOL()===`\r
`?new I(a):null,c=[];let h=0,E;for($.reset(0);E=$.next(a);)if(c[h++]=P(this.a(s,o,a,n,E.index,E[0]),E,g),h>=t)return c;return c}static c(s,d,$,g,t){const o=[];let a=0;if(d.startLineNumber===d.endLineNumber){const c=s.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return a=this.d($,c,d.startLineNumber,d.startColumn-1,a,o,g,t),o}const n=s.getLineContent(d.startLineNumber).substring(d.startColumn-1);a=this.d($,n,d.startLineNumber,d.startColumn-1,a,o,g,t);for(let c=d.startLineNumber+1;c<d.endLineNumber&&a<t;c++)a=this.d($,s.getLineContent(c),c,0,a,o,g,t);if(a<t){const c=s.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);a=this.d($,c,d.endLineNumber,0,a,o,g,t)}return o}static d(s,d,$,g,t,o,a,n){const c=s.wordSeparators;if(!a&&s.simpleSearch){const y=s.simpleSearch,u=y.length,l=d.length;let w=-u;for(;(w=d.indexOf(y,w+u))!==-1;)if((!c||v(c,d,l,w,u))&&(o[t++]=new R.$zu(new L.$is($,w+1+g,$,w+1+u+g),null),t>=n))return t;return t}const h=new r(s.wordSeparators,s.regex);let E;h.reset(0);do if(E=h.next(d),E&&(o[t++]=P(new L.$is($,E.index+1+g,$,E.index+1+E[0].length+g),E,a),t>=n))return t;while(E);return t}static findNextMatch(s,d,$,g){const t=d.parseSearchRequest();if(!t)return null;const o=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.e(s,$,o,g):this.f(s,$,o,g)}static e(s,d,$,g){const t=new f.$hs(d.lineNumber,1),o=s.getOffsetAt(t),a=s.getLineCount(),n=s.getValueInRange(new L.$is(t.lineNumber,t.column,a,s.getLineMaxColumn(a)),1),c=s.getEOL()===`\r
`?new I(n):null;$.reset(d.column-1);const h=$.next(n);return h?P(this.a(s,o,n,c,h.index,h[0]),h,g):d.lineNumber!==1||d.column!==1?this.e(s,new f.$hs(1,1),$,g):null}static f(s,d,$,g){const t=s.getLineCount(),o=d.lineNumber,a=s.getLineContent(o),n=this.g($,a,o,d.column,g);if(n)return n;for(let c=1;c<=t;c++){const h=(o+c-1)%t,E=s.getLineContent(h+1),y=this.g($,E,h+1,1,g);if(y)return y}return null}static g(s,d,$,g,t){s.reset(g-1);const o=s.next(d);return o?P(new L.$is($,o.index+1,$,o.index+1+o[0].length),o,t):null}static findPreviousMatch(s,d,$,g){const t=d.parseSearchRequest();if(!t)return null;const o=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.h(s,$,o,g):this.j(s,$,o,g)}static h(s,d,$,g){const t=this.b(s,new L.$is(1,1,d.lineNumber,d.column),$,g,10*m);if(t.length>0)return t[t.length-1];const o=s.getLineCount();return d.lineNumber!==o||d.column!==s.getLineMaxColumn(o)?this.h(s,new f.$hs(o,s.getLineMaxColumn(o)),$,g):null}static j(s,d,$,g){const t=s.getLineCount(),o=d.lineNumber,a=s.getLineContent(o).substring(0,d.column-1),n=this.k($,a,o,g);if(n)return n;for(let c=1;c<=t;c++){const h=(t+o-c-1)%t,E=s.getLineContent(h+1),y=this.k($,E,h+1,g);if(y)return y}return null}static k(s,d,$,g){let t=null,o;for(s.reset(0);o=s.next(d);)t=P(new L.$is($,o.index+1,$,o.index+1+o[0].length),o,g);return t}}e.$hC=p;function k(i,s,d,$,g){if($===0)return!0;const t=s.charCodeAt($-1);if(i.get(t)!==0||t===13||t===10)return!0;if(g>0){const o=s.charCodeAt($);if(i.get(o)!==0)return!0}return!1}function D(i,s,d,$,g){if($+g===d)return!0;const t=s.charCodeAt($+g);if(i.get(t)!==0||t===13||t===10)return!0;if(g>0){const o=s.charCodeAt($+g-1);if(i.get(o)!==0)return!0}return!1}function v(i,s,d,$,g){return k(i,s,d,$,g)&&D(i,s,d,$,g)}e.$iC=v;class r{constructor(s,d){this._wordSeparators=s,this.a=d,this.b=-1,this.c=0}reset(s){this.a.lastIndex=s,this.b=-1,this.c=0}next(s){const d=s.length;let $;do{if(this.b+this.c===d||($=this.a.exec(s),!$))return null;const g=$.index,t=$[0].length;if(g===this.b&&t===this.c){if(t===0){C.$Se(s,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=t,!this._wordSeparators||v(this._wordSeparators,s,d,g,t))return $}while($);return null}}e.$jC=r}),define(De[173],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7=e.$_6=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$_6=C;class F{constructor(L){this.identifier=L}}e.$a7=F}),define(De[174],Ce([1,0,4,3]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$ed,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,S){return this.a.set(m,S),this.handleChange([m]),(0,F.$hc)(()=>{this.a.get(m)===S&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,S){this.b.get(m)?.dispose();const b=new L(this,m,S);return this.b.set(m,b),(0,F.$hc)(()=>{const P=this.b.get(m);!P||P!==b||(this.b.delete(m),P.dispose())})}async getOrCreate(m){const S=this.get(m);if(S)return S;const b=this.b.get(m);return!b||b.isResolved?null:(await b.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const b=this.b.get(m);return!!(!b||b.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ts=f;class L extends F.$jc{get isResolved(){return this.c}constructor(m,S,b){super(),this.f=m,this.g=S,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(De[175],Ce([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=void 0;class L extends F.$jc{constructor(p,k="",D="",v=!0,r){super(),this.h=this.B(new C.$ed),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=k,this.u=D,this.w=v,this.C=r}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,k){this.C&&await this.C(p)}}e.$fi=L;class R extends F.$jc{constructor(){super(...arguments),this.f=this.B(new C.$ed),this.onWillRun=this.f.event,this.m=this.B(new C.$ed),this.onDidRun=this.m.event}async run(p,k){if(!p.enabled)return;this.f.fire({action:p});let D;try{await this.u(p,k)}catch(v){D=v}this.m.fire({action:p,error:D})}async u(p,k){await p.run(k)}}e.$gi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let k=[];for(const D of p)D.length&&(k.length?k=[...k,new m,...D]:k=D);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$hi=m;class S{get actions(){return this.a}constructor(p,k,D,v){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=k,this.class=v,this.a=D}async run(){}}e.$ii=S;class b extends L{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,f.localize(0,null),void 0,!1)}}e.$ji=b;function P(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.$ki=P}),define(De[177],Ce([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const F=60,f=F*60,L=f*24,R=L*7,m=L*30,S=L*365;function b(I,p,k,D){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,C.localize)(0,null,b(new Date().getTime()+v*1e3,!1));if(!D&&v<30)return(0,C.localize)(1,null);let r;return v<F?(r=v,p?r===1?k?(0,C.localize)(2,null,r):(0,C.localize)(3,null,r):k?(0,C.localize)(4,null,r):(0,C.localize)(5,null,r):r===1?k?(0,C.localize)(6,null,r):(0,C.localize)(7,null,r):k?(0,C.localize)(8,null,r):(0,C.localize)(9,null,r)):v<f?(r=Math.floor(v/F),p?r===1?k?(0,C.localize)(10,null,r):(0,C.localize)(11,null,r):k?(0,C.localize)(12,null,r):(0,C.localize)(13,null,r):r===1?k?(0,C.localize)(14,null,r):(0,C.localize)(15,null,r):k?(0,C.localize)(16,null,r):(0,C.localize)(17,null,r)):v<L?(r=Math.floor(v/f),p?r===1?k?(0,C.localize)(18,null,r):(0,C.localize)(19,null,r):k?(0,C.localize)(20,null,r):(0,C.localize)(21,null,r):r===1?k?(0,C.localize)(22,null,r):(0,C.localize)(23,null,r):k?(0,C.localize)(24,null,r):(0,C.localize)(25,null,r)):v<R?(r=Math.floor(v/L),p?r===1?(0,C.localize)(26,null,r):(0,C.localize)(27,null,r):r===1?(0,C.localize)(28,null,r):(0,C.localize)(29,null,r)):v<m?(r=Math.floor(v/R),p?r===1?k?(0,C.localize)(30,null,r):(0,C.localize)(31,null,r):k?(0,C.localize)(32,null,r):(0,C.localize)(33,null,r):r===1?k?(0,C.localize)(34,null,r):(0,C.localize)(35,null,r):k?(0,C.localize)(36,null,r):(0,C.localize)(37,null,r)):v<S?(r=Math.floor(v/m),p?r===1?k?(0,C.localize)(38,null,r):(0,C.localize)(39,null,r):k?(0,C.localize)(40,null,r):(0,C.localize)(41,null,r):r===1?k?(0,C.localize)(42,null,r):(0,C.localize)(43,null,r):k?(0,C.localize)(44,null,r):(0,C.localize)(45,null,r)):(r=Math.floor(v/S),p?r===1?k?(0,C.localize)(46,null,r):(0,C.localize)(47,null,r):k?(0,C.localize)(48,null,r):(0,C.localize)(49,null,r):r===1?k?(0,C.localize)(50,null,r):(0,C.localize)(51,null,r):k?(0,C.localize)(52,null,r):(0,C.localize)(53,null,r))}e.$5l=b;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=P}),define(De[179],Ce([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[46],Ce([1,0,19,18,179]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function L(I,p){return p&&(I.stack||I.stacktrace)?f.localize(0,null,m(I),R(I.stack)||R(I.stacktrace)):m(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function m(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?f.localize(1,null,I.message):I.message||f.localize(2,null)}function S(I=null,p=!1){if(!I)return f.localize(3,null);if(Array.isArray(I)){const k=C.$Eb(I),D=S(k[0],p);return k.length>1?f.localize(4,null,D,k.length):D}if(F.$if(I))return I;if(I.detail){const k=I.detail;if(k.error)return L(k.error,p);if(k.exception)return L(k.exception,p)}return I.stack?L(I,p):I.message?I.message:f.localize(5,null)}e.$li=S;function b(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}e.$mi=b;function P(I,p){let k;return typeof I=="string"?k=new Error(I):k=I,k.actions=p,k}e.$ni=P}),define(De[180],Ce([9,10]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let F=!1,f=!1,L=!1,R=!1,m=!1,S=!1,b=!1,P=!1,I=!1,p=!1,k,D=e.$f,v=e.$f,r,i;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?s=e.$g.vscode.process:typeof process<"u"&&(s=process);const d=typeof s?.versions?.electron=="string",$=d&&s?.type==="renderer";if(typeof navigator=="object"&&!$)i=navigator.userAgent,F=i.indexOf("Windows")>=0,f=i.indexOf("Macintosh")>=0,P=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=i.indexOf("Linux")>=0,p=i?.indexOf("Mobi")>=0,S=!0,k=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$f,D=k,v=navigator.language;else if(typeof s=="object"){F=s.platform==="win32",f=s.platform==="darwin",L=s.platform==="linux",R=L&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,b=d,I=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$f,D=e.$f;const y=s.env.VSCODE_NLS_CONFIG;if(y)try{const u=JSON.parse(y),l=u.availableLanguages["*"];k=u.locale,v=u.osLocale,D=l||e.$f,r=u._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var g;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(g||(e.Platform=g={}));function t(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let o=0;f?o=1:F?o=3:L&&(o=2),e.$i=F,e.$j=f,e.$k=L,e.$l=R,e.$m=m,e.$n=b,e.$o=S,e.$p=S&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=p,e.$s=I,e.$t=o,e.$u=i,e.$v=D;var a;(function(y){function u(){return e.$v}y.value=u;function l(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}y.isDefaultVariant=l;function w(){return e.$v==="en"}y.isDefault=w})(a||(e.Language=a={})),e.$w=k,e.$x=v,e.$y=r,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const y=[];e.$g.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let w=0,A=y.length;w<A;w++){const O=y[w];if(O.id===l.data.vscodeScheduleAsyncWork){y.splice(w,1),O.callback();return}}});let u=0;return l=>{const w=++u;y.push({id:w,callback:l}),e.$g.postMessage({vscodeScheduleAsyncWork:w},"*")}}return y=>setTimeout(y)})();var n;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=f||P?2:F?1:3;let c=!0,h=!1;function E(){if(!h){h=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,c=new Uint16Array(y.buffer)[0]===(2<<8)+1}return c}e.$C=E,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(De[47],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.$2d=e.env=e.cwd=void 0;let F;if(typeof C.$g.vscode<"u"&&typeof C.$g.vscode.process<"u"){const f=C.$g.vscode.process;F={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return C.$i?"win32":C.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$2d=F.platform,e.$3d=F.arch}),define(De[16],Ce([1,0,47]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.sep=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;const F=65,f=97,L=90,R=122,m=46,S=47,b=92,P=58,I=63;class p extends Error{constructor(o,a,n){let c;typeof a=="string"&&a.indexOf("not ")===0?(c="must not be",a=a.replace(/^not /,"")):c="must be";const h=o.indexOf(".")!==-1?"property":"argument";let E=`The "${o}" ${h} ${c} of type ${a}`;E+=`. Received type ${typeof n}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,o){if(t===null||typeof t!="object")throw new p(o,"Object",t)}function D(t,o){if(typeof t!="string")throw new p(o,"string",t)}const v=C.$2d==="win32";function r(t){return t===S||t===b}function i(t){return t===S}function s(t){return t>=F&&t<=L||t>=f&&t<=R}function d(t,o,a,n){let c="",h=0,E=-1,y=0,u=0;for(let l=0;l<=t.length;++l){if(l<t.length)u=t.charCodeAt(l);else{if(n(u))break;u=S}if(n(u)){if(!(E===l-1||y===1))if(y===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==m||c.charCodeAt(c.length-2)!==m){if(c.length>2){const w=c.lastIndexOf(a);w===-1?(c="",h=0):(c=c.slice(0,w),h=c.length-1-c.lastIndexOf(a)),E=l,y=0;continue}else if(c.length!==0){c="",h=0,E=l,y=0;continue}}o&&(c+=c.length>0?`${a}..`:"..",h=2)}else c.length>0?c+=`${a}${t.slice(E+1,l)}`:c=t.slice(E+1,l),h=l-E-1;E=l,y=0}else u===m&&y!==-1?++y:y=-1}return c}function $(t,o){k(o,"pathObject");const a=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${n}`:`${a}${t}${n}`:n}e.$4d={resolve(...t){let o="",a="",n=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],D(h,"path"),h.length===0)continue}else o.length===0?h=C.cwd():(h=C.env[`=${o}`]||C.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==o.toLowerCase()&&h.charCodeAt(2)===b)&&(h=`${o}\\`));const E=h.length;let y=0,u="",l=!1;const w=h.charCodeAt(0);if(E===1)r(w)&&(y=1,l=!0);else if(r(w))if(l=!0,r(h.charCodeAt(1))){let A=2,O=A;for(;A<E&&!r(h.charCodeAt(A));)A++;if(A<E&&A!==O){const N=h.slice(O,A);for(O=A;A<E&&r(h.charCodeAt(A));)A++;if(A<E&&A!==O){for(O=A;A<E&&!r(h.charCodeAt(A));)A++;(A===E||A!==O)&&(u=`\\\\${N}\\${h.slice(O,A)}`,y=A)}}}else y=1;else s(w)&&h.charCodeAt(1)===P&&(u=h.slice(0,2),y=2,E>2&&r(h.charCodeAt(2))&&(l=!0,y=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(n){if(o.length>0)break}else if(a=`${h.slice(y)}\\${a}`,n=l,l&&o.length>0)break}return a=d(a,!n,"\\",r),n?`${o}\\${a}`:`${o}${a}`||"."},normalize(t){D(t,"path");const o=t.length;if(o===0)return".";let a=0,n,c=!1;const h=t.charCodeAt(0);if(o===1)return i(h)?"\\":t;if(r(h))if(c=!0,r(t.charCodeAt(1))){let y=2,u=y;for(;y<o&&!r(t.charCodeAt(y));)y++;if(y<o&&y!==u){const l=t.slice(u,y);for(u=y;y<o&&r(t.charCodeAt(y));)y++;if(y<o&&y!==u){for(u=y;y<o&&!r(t.charCodeAt(y));)y++;if(y===o)return`\\\\${l}\\${t.slice(u)}\\`;y!==u&&(n=`\\\\${l}\\${t.slice(u,y)}`,a=y)}}}else a=1;else s(h)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),a=2,o>2&&r(t.charCodeAt(2))&&(c=!0,a=3));let E=a<o?d(t.slice(a),!c,"\\",r):"";return E.length===0&&!c&&(E="."),E.length>0&&r(t.charCodeAt(o-1))&&(E+="\\"),n===void 0?c?`\\${E}`:E:c?`${n}\\${E}`:`${n}${E}`},isAbsolute(t){D(t,"path");const o=t.length;if(o===0)return!1;const a=t.charCodeAt(0);return r(a)||o>2&&s(a)&&t.charCodeAt(1)===P&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,a;for(let h=0;h<t.length;++h){const E=t[h];D(E,"path"),E.length>0&&(o===void 0?o=a=E:o+=`\\${E}`)}if(o===void 0)return".";let n=!0,c=0;if(typeof a=="string"&&r(a.charCodeAt(0))){++c;const h=a.length;h>1&&r(a.charCodeAt(1))&&(++c,h>2&&(r(a.charCodeAt(2))?++c:n=!1))}if(n){for(;c<o.length&&r(o.charCodeAt(c));)c++;c>=2&&(o=`\\${o.slice(c)}`)}return e.$4d.normalize(o)},relative(t,o){if(D(t,"from"),D(o,"to"),t===o)return"";const a=e.$4d.resolve(t),n=e.$4d.resolve(o);if(a===n||(t=a.toLowerCase(),o=n.toLowerCase(),t===o))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===b;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===b;)h--;const E=h-c;let y=0;for(;y<o.length&&o.charCodeAt(y)===b;)y++;let u=o.length;for(;u-1>y&&o.charCodeAt(u-1)===b;)u--;const l=u-y,w=E<l?E:l;let A=-1,O=0;for(;O<w;O++){const T=t.charCodeAt(c+O);if(T!==o.charCodeAt(y+O))break;T===b&&(A=O)}if(O!==w){if(A===-1)return n}else{if(l>w){if(o.charCodeAt(y+O)===b)return n.slice(y+O+1);if(O===2)return n.slice(y+O)}E>w&&(t.charCodeAt(c+O)===b?A=O:O===2&&(A=3)),A===-1&&(A=0)}let N="";for(O=c+A+1;O<=h;++O)(O===h||t.charCodeAt(O)===b)&&(N+=N.length===0?"..":"\\..");return y+=A,N.length>0?`${N}${n.slice(y,u)}`:(n.charCodeAt(y)===b&&++y,n.slice(y,u))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$4d.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const a=o.charCodeAt(2);if(a!==I&&a!==m)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(s(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return t},dirname(t){D(t,"path");const o=t.length;if(o===0)return".";let a=-1,n=0;const c=t.charCodeAt(0);if(o===1)return r(c)?t:".";if(r(c)){if(a=n=1,r(t.charCodeAt(1))){let y=2,u=y;for(;y<o&&!r(t.charCodeAt(y));)y++;if(y<o&&y!==u){for(u=y;y<o&&r(t.charCodeAt(y));)y++;if(y<o&&y!==u){for(u=y;y<o&&!r(t.charCodeAt(y));)y++;if(y===o)return t;y!==u&&(a=n=y+1)}}}}else s(c)&&t.charCodeAt(1)===P&&(a=o>2&&r(t.charCodeAt(2))?3:2,n=a);let h=-1,E=!0;for(let y=o-1;y>=n;--y)if(r(t.charCodeAt(y))){if(!E){h=y;break}}else E=!1;if(h===-1){if(a===-1)return".";h=a}return t.slice(0,h)},basename(t,o){o!==void 0&&D(o,"ext"),D(t,"path");let a=0,n=-1,c=!0,h;if(t.length>=2&&s(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(a=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let E=o.length-1,y=-1;for(h=t.length-1;h>=a;--h){const u=t.charCodeAt(h);if(r(u)){if(!c){a=h+1;break}}else y===-1&&(c=!1,y=h+1),E>=0&&(u===o.charCodeAt(E)?--E===-1&&(n=h):(E=-1,n=y))}return a===n?n=y:n===-1&&(n=t.length),t.slice(a,n)}for(h=t.length-1;h>=a;--h)if(r(t.charCodeAt(h))){if(!c){a=h+1;break}}else n===-1&&(c=!1,n=h+1);return n===-1?"":t.slice(a,n)},extname(t){D(t,"path");let o=0,a=-1,n=0,c=-1,h=!0,E=0;t.length>=2&&t.charCodeAt(1)===P&&s(t.charCodeAt(0))&&(o=n=2);for(let y=t.length-1;y>=o;--y){const u=t.charCodeAt(y);if(r(u)){if(!h){n=y+1;break}continue}c===-1&&(h=!1,c=y+1),u===m?a===-1?a=y:E!==1&&(E=1):a!==-1&&(E=-1)}return a===-1||c===-1||E===0||E===1&&a===c-1&&a===n+1?"":t.slice(a,c)},format:$.bind(null,"\\"),parse(t){D(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const a=t.length;let n=0,c=t.charCodeAt(0);if(a===1)return r(c)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(r(c)){if(n=1,r(t.charCodeAt(1))){let A=2,O=A;for(;A<a&&!r(t.charCodeAt(A));)A++;if(A<a&&A!==O){for(O=A;A<a&&r(t.charCodeAt(A));)A++;if(A<a&&A!==O){for(O=A;A<a&&!r(t.charCodeAt(A));)A++;A===a?n=A:A!==O&&(n=A+1)}}}}else if(s(c)&&t.charCodeAt(1)===P){if(a<=2)return o.root=o.dir=t,o;if(n=2,r(t.charCodeAt(2))){if(a===3)return o.root=o.dir=t,o;n=3}}n>0&&(o.root=t.slice(0,n));let h=-1,E=n,y=-1,u=!0,l=t.length-1,w=0;for(;l>=n;--l){if(c=t.charCodeAt(l),r(c)){if(!u){E=l+1;break}continue}y===-1&&(u=!1,y=l+1),c===m?h===-1?h=l:w!==1&&(w=1):h!==-1&&(w=-1)}return y!==-1&&(h===-1||w===0||w===1&&h===y-1&&h===E+1?o.base=o.name=t.slice(E,y):(o.name=t.slice(E,h),o.base=t.slice(E,y),o.ext=t.slice(h,y))),E>0&&E!==n?o.dir=t.slice(0,E-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(v){const t=/\\/g;return()=>{const o=C.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>C.cwd()})();e.$5d={resolve(...t){let o="",a=!1;for(let n=t.length-1;n>=-1&&!a;n--){const c=n>=0?t[n]:g();D(c,"path"),c.length!==0&&(o=`${c}/${o}`,a=c.charCodeAt(0)===S)}return o=d(o,!a,"/",i),a?`/${o}`:o.length>0?o:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S,a=t.charCodeAt(t.length-1)===S;return t=d(t,!o,"/",i),t.length===0?o?"/":a?"./":".":(a&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let o;for(let a=0;a<t.length;++a){const n=t[a];D(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.$5d.normalize(o)},relative(t,o){if(D(t,"from"),D(o,"to"),t===o||(t=e.$5d.resolve(t),o=e.$5d.resolve(o),t===o))return"";const a=1,n=t.length,c=n-a,h=1,E=o.length-h,y=c<E?c:E;let u=-1,l=0;for(;l<y;l++){const A=t.charCodeAt(a+l);if(A!==o.charCodeAt(h+l))break;A===S&&(u=l)}if(l===y)if(E>y){if(o.charCodeAt(h+l)===S)return o.slice(h+l+1);if(l===0)return o.slice(h+l)}else c>y&&(t.charCodeAt(a+l)===S?u=l:l===0&&(u=0));let w="";for(l=a+u+1;l<=n;++l)(l===n||t.charCodeAt(l)===S)&&(w+=w.length===0?"..":"/..");return`${w}${o.slice(h+u)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S;let a=-1,n=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===S){if(!n){a=c;break}}else n=!1;return a===-1?o?"/":".":o&&a===1?"//":t.slice(0,a)},basename(t,o){o!==void 0&&D(o,"ext"),D(t,"path");let a=0,n=-1,c=!0,h;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let E=o.length-1,y=-1;for(h=t.length-1;h>=0;--h){const u=t.charCodeAt(h);if(u===S){if(!c){a=h+1;break}}else y===-1&&(c=!1,y=h+1),E>=0&&(u===o.charCodeAt(E)?--E===-1&&(n=h):(E=-1,n=y))}return a===n?n=y:n===-1&&(n=t.length),t.slice(a,n)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===S){if(!c){a=h+1;break}}else n===-1&&(c=!1,n=h+1);return n===-1?"":t.slice(a,n)},extname(t){D(t,"path");let o=-1,a=0,n=-1,c=!0,h=0;for(let E=t.length-1;E>=0;--E){const y=t.charCodeAt(E);if(y===S){if(!c){a=E+1;break}continue}n===-1&&(c=!1,n=E+1),y===m?o===-1?o=E:h!==1&&(h=1):o!==-1&&(h=-1)}return o===-1||n===-1||h===0||h===1&&o===n-1&&o===a+1?"":t.slice(o,n)},format:$.bind(null,"/"),parse(t){D(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const a=t.charCodeAt(0)===S;let n;a?(o.root="/",n=1):n=0;let c=-1,h=0,E=-1,y=!0,u=t.length-1,l=0;for(;u>=n;--u){const w=t.charCodeAt(u);if(w===S){if(!y){h=u+1;break}continue}E===-1&&(y=!1,E=u+1),w===m?c===-1?c=u:l!==1&&(l=1):c!==-1&&(l=-1)}if(E!==-1){const w=h===0&&a?1:h;c===-1||l===0||l===1&&c===E-1&&c===h+1?o.base=o.name=t.slice(w,E):(o.name=t.slice(w,c),o.base=t.slice(w,E),o.ext=t.slice(c,E))}return h>0?o.dir=t.slice(0,h-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$5d.win32=e.$4d.win32=e.$4d,e.$5d.posix=e.$4d.posix=e.$5d,e.$6d=v?e.$4d.normalize:e.$5d.normalize,e.$7d=v?e.$4d.isAbsolute:e.$5d.isAbsolute,e.$8d=v?e.$4d.join:e.$5d.join,e.$9d=v?e.$4d.resolve:e.$5d.resolve,e.$0d=v?e.$4d.relative:e.$5d.relative,e.$$d=v?e.$4d.dirname:e.$5d.dirname,e.$_d=v?e.$4d.basename:e.$5d.basename,e.$ae=v?e.$4d.extname:e.$5d.extname,e.$be=v?e.$4d.format:e.$5d.format,e.$ce=v?e.$4d.parse:e.$5d.parse,e.$de=v?e.$4d.toNamespacedPath:e.$5d.toNamespacedPath,e.sep=v?e.$4d.sep:e.$5d.sep,e.$fe=v?e.$4d.delimiter:e.$5d.delimiter}),define(De[126],Ce([1,0,59,16]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=void 0;const f=new C.$T(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),L=new C.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new C.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(y,u,l=!1){const w=y||"",A=u||"",O=f.value.collator.compare(w,A);return f.value.collatorIsNumeric&&O===0&&w!==A?w<A?-1:1:O}e.$8p=m;function S(y,u){const l=L.value.collator;return y=y||"",u=u||"",$(l,y,u)}e.$9p=S;function b(y,u){const l=L.value.collator;return y=y||"",u=u||"",a(y,u)||$(l,y,u)}e.$0p=b;function P(y,u){const l=L.value.collator;return y=y||"",u=u||"",o(y,u)||$(l,y,u)}e.$$p=P;function I(y,u){return y=y||"",u=u||"",y===u?0:y<u?-1:1}e.$_p=I;function p(y,u){const[l,w]=s(y),[A,O]=s(u);let N=f.value.collator.compare(w,O);if(N===0){if(f.value.collatorIsNumeric&&w!==O)return w<O?-1:1;if(N=f.value.collator.compare(l,A),f.value.collatorIsNumeric&&N===0&&l!==A)return l<A?-1:1}return N}e.$aq=p;function k(y,u){y=y||"",u=u||"";const l=d(y),w=d(u),A=L.value.collator,O=R.value.collator;return $(O,l,w)||$(A,y,u)}e.$bq=k;function D(y,u){y=y||"",u=u||"";const l=d(y),w=d(u),A=L.value.collator,O=R.value.collator;return $(O,l,w)||a(y,u)||$(A,y,u)}e.$cq=D;function v(y,u){y=y||"",u=u||"";const l=d(y),w=d(u),A=L.value.collator,O=R.value.collator;return $(O,l,w)||o(y,u)||$(A,y,u)}e.$dq=v;function r(y,u){y=y||"",u=u||"";const l=d(y).toLowerCase(),w=d(u).toLowerCase();return l!==w?l<w?-1:1:y!==u?y<u?-1:1:0}e.$eq=r;const i=/^(.*?)(\.([^.]*))?$/;function s(y,u=!1){const l=y?i.exec(y):[];let w=[l&&l[1]||"",l&&l[3]||""];return u&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function d(y){const u=y?i.exec(y):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function $(y,u,l){const w=y.compare(u,l);return w!==0?w:u.length!==l.length?u.length<l.length?-1:1:0}function g(y){const u=y.charAt(0);return u.toLocaleUpperCase()!==u}function t(y){const u=y.charAt(0);return u.toLocaleLowerCase()!==u}function o(y,u){return g(y)&&t(u)?-1:t(y)&&g(u)?1:0}function a(y,u){return t(y)&&g(u)?-1:g(y)&&t(u)?1:0}function n(y,u,l=!1){return l||(y=y&&y.toLowerCase(),u=u&&u.toLowerCase()),y===u?0:y<u?-1:1}function c(y,u,l=!1){const w=y.split(F.sep),A=u.split(F.sep),O=w.length-1,N=A.length-1;let T,j;for(let z=0;;z++){if(T=O===z,j=N===z,T&&j)return m(w[z],A[z],l);if(T)return-1;if(j)return 1;const M=n(w[z],A[z],l);if(M!==0)return M}}e.$fq=c;function h(y,u,l){const w=y.toLowerCase(),A=u.toLowerCase(),O=E(y,u,l);if(O)return O;const N=w.endsWith(l),T=A.endsWith(l);if(N!==T)return N?-1:1;const j=m(w,A);return j!==0?j:w.localeCompare(A)}e.$gq=h;function E(y,u,l){const w=y.toLowerCase(),A=u.toLowerCase(),O=w.startsWith(l),N=A.startsWith(l);if(O!==N)return O?-1:1;if(O&&N){if(w.length<A.length)return-1;if(w.length>A.length)return 1}return 0}e.$hq=E}),define(De[32],Ce([1,0,16,12,15,18]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function R(h){return h===47||h===92}e.$Af=R;function m(h){return h.replace(/[\\/]/g,C.$5d.sep)}e.$Bf=m;function S(h){return h.indexOf("/")===-1&&(h=m(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Cf=S;function b(h,E=C.$5d.sep){if(!h)return"";const y=h.length,u=h.charCodeAt(0);if(R(u)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let w=3;const A=w;for(;w<y&&!R(h.charCodeAt(w));w++);if(A!==w&&!R(h.charCodeAt(w+1))){for(w+=1;w<y;w++)if(R(h.charCodeAt(w)))return h.slice(0,w+1).replace(/[\\/]/g,E)}}return E}else if(i(u)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+E:h.slice(0,2);let l=h.indexOf("://");if(l!==-1){for(l+=3;l<y;l++)if(R(h.charCodeAt(l)))return h.slice(0,l+1)}return""}e.$Df=b;function P(h){if(!F.$i||!h||h.length<5)return!1;let E=h.charCodeAt(0);if(E!==92||(E=h.charCodeAt(1),E!==92))return!1;let y=2;const u=y;for(;y<h.length&&(E=h.charCodeAt(y),E!==92);y++);return!(u===y||(E=h.charCodeAt(y+1),isNaN(E)||E===92))}e.$Ef=P;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(h,E=F.$i){const y=E?I:p;return!(!h||h.length===0||/^\s+$/.test(h)||(y.lastIndex=0,y.test(h))||E&&k.test(h)||h==="."||h===".."||E&&h[h.length-1]==="."||E&&h.length!==h.trim().length||h.length>255)}e.$Ff=D;function v(h,E,y){const u=h===E;return!y||u?u:!h||!E?!1:(0,f.$Le)(h,E)}e.$Gf=v;function r(h,E,y,u=C.sep){if(h===E)return!0;if(!h||!E||E.length>h.length)return!1;if(y){if(!(0,f.$Me)(h,E))return!1;if(E.length===h.length)return!0;let w=E.length;return E.charAt(E.length-1)===u&&w--,h.charAt(w)===u}return E.charAt(E.length-1)!==u&&(E+=u),h.indexOf(E)===0}e.$Hf=r;function i(h){return h>=65&&h<=90||h>=97&&h<=122}e.$If=i;function s(h,E){return F.$i&&h.endsWith(":")&&(h+=C.sep),(0,C.$7d)(h)||(h=(0,C.$8d)(E,h)),h=(0,C.$6d)(h),F.$i?(h=(0,f.$ue)(h,C.sep),h.endsWith(":")&&(h+=C.sep)):(h=(0,f.$ue)(h,C.sep),h||(h=C.sep)),h}e.$Jf=s;function d(h){const E=(0,C.$6d)(h);return F.$i?h.length>3?!1:$(E)&&(h.length===2||E.charCodeAt(2)===92):E===C.$5d.sep}e.$Kf=d;function $(h,E=F.$i){return E?i(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$Lf=$;function g(h,E=F.$i){return $(h,E)?h[0]:void 0}e.$Mf=g;function t(h,E,y){return E.length>h.length?-1:h===E?0:(y&&(h=h.toLowerCase(),E=E.toLowerCase()),h.indexOf(E))}e.$Nf=t;function o(h){const E=h.split(":");let y,u,l;for(const w of E){const A=Number(w);(0,L.$mf)(A)?u===void 0?u=A:l===void 0&&(l=A):y=y?[y,w].join(":"):w}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:u!==void 0?u:void 0,column:l!==void 0?l:u!==void 0?1:void 0}}e.$Of=o;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,E,y=8){let u="";for(let w=0;w<y;w++){let A;w===0&&F.$i&&!E&&(y===3||y===4)?A=n:A=a,u+=A.charAt(Math.floor(Math.random()*A.length))}let l;return E?l=`${E}-${u}`:l=u,h?(0,C.$8d)(h,l):l}e.$Pf=c}),define(De[127],Ce([1,0,126,121,51,16,12,15]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=void 0;const S=0,b=[S,[]];function P(H,q,me,x){if(!H||!q)return b;const Q=H.length,V=q.length;if(Q<V)return b;const _=H.toLowerCase();return I(q,me,V,H,_,Q,x)}e.$iq=P;function I(H,q,me,x,Q,V,_){const ge=[],ce=[];for(let K=0;K<me;K++){const Y=K*V,se=Y-V,re=K>0,le=H[K],Ee=q[K];for(let he=0;he<V;he++){const fe=he>0,te=Y+he,ue=te-1,be=se+he-1,Pe=fe?ge[ue]:0,B=re&&fe?ge[be]:0,X=re&&fe?ce[be]:0;let ee;!B&&re?ee=0:ee=p(le,Ee,x,Q,he,X),ee&&B+ee>=Pe&&(_||re||Q.startsWith(q,he))?(ce[te]=X+1,ge[te]=B+ee):(ce[te]=S,ge[te]=Pe)}}const we=[];let G=me-1,U=V-1;for(;G>=0&&U>=0;){const K=G*V+U;ce[K]===S||(we.push(U),G--),U--}return[ge[me*V-1],we.reverse()]}function p(H,q,me,x,Q,V){let _=0;if(!k(q,x[Q]))return _;if(_+=1,V>0&&(_+=V*5),H===me[Q]&&(_+=1),Q===0)_+=8;else{const ge=D(me.charCodeAt(Q-1));ge?_+=ge:(0,F.$Aj)(me.charCodeAt(Q))&&V===0&&(_+=2)}return _}function k(H,q){return H===q?!0:H==="/"||H==="\\"?q==="/"||q==="\\":!1}function D(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function r(H,q,me=0,x=0){const Q=q;return Q.values&&Q.values.length>1?i(H,Q.values,me,x):s(H,q,me,x)}e.$jq=r;function i(H,q,me,x){let Q=0;const V=[];for(const _ of q){const[ge,ce]=s(H,_,me,x);if(typeof ge!="number")return v;Q+=ge,V.push(...ce)}return[Q,y(V)]}function s(H,q,me,x){const Q=(0,F.$Jj)(q.original,q.originalLowercase,me,H,H.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,F.$Gj)(Q)]:v}const d=Object.freeze({score:0}),$=1<<18,g=1<<17,t=1<<16;function o(H,q,me,x){const Q=x.values?x.values:[x];return(0,f.$oi)({[x.normalized]:{values:Q.map(_=>({value:_.normalized,expectContiguousMatch:_.expectContiguousMatch})),label:H,description:q,allowNonContiguousMatches:me}})}function a(H,q,me,x,Q){if(!H||!q.normalized)return d;const V=x.getItemLabel(H);if(!V)return d;const _=x.getItemDescription(H),ge=o(V,_,me,q),ce=Q[ge];if(ce)return ce;const we=n(V,_,x.getItemPath(H),q,me);return Q[ge]=we,we}e.$kq=a;function n(H,q,me,x,Q){const V=!me||!x.containsPathSeparator;return me&&(R.$k?x.pathNormalized===me:(0,m.$Le)(x.pathNormalized,me))?{score:$,labelMatch:[{start:0,end:H.length}],descriptionMatch:q?[{start:0,end:q.length}]:void 0}:x.values&&x.values.length>1?c(H,q,me,x.values,V,Q):h(H,q,me,x,V,Q)}function c(H,q,me,x,Q,V){let _=0;const ge=[],ce=[];for(const we of x){const{score:G,labelMatch:U,descriptionMatch:K}=h(H,q,me,we,Q,V);if(G===S)return d;_+=G,U&&ge.push(...U),K&&ce.push(...K)}return{score:_,labelMatch:y(ge),descriptionMatch:y(ce)}}function h(H,q,me,x,Q,V){if(Q||!q){const[_,ge]=P(H,x.normalized,x.normalizedLowercase,V&&!x.expectContiguousMatch);if(_){const ce=(0,F.$xj)(x.normalized,H);let we;if(ce){we=g;const G=Math.round(x.normalized.length/H.length*100);we+=G}else we=t;return{score:we+_,labelMatch:ce||E(ge)}}}if(q){let _=q;me&&(_=`${q}${L.sep}`);const ge=_.length,ce=`${_}${H}`,[we,G]=P(ce,x.normalized,x.normalizedLowercase,V&&!x.expectContiguousMatch);if(we){const U=E(G),K=[],Y=[];return U.forEach(se=>{se.start<ge&&se.end>ge?(K.push({start:0,end:se.end-ge}),Y.push({start:se.start,end:ge})):se.start>=ge?K.push({start:se.start-ge,end:se.end-ge}):Y.push(se)}),{score:we,labelMatch:K,descriptionMatch:Y}}}return d}function E(H){const q=[];if(!H)return q;let me;for(const x of H)me&&me.end===x?me.end+=1:(me={start:x,end:x+1},q.push(me));return q}function y(H){const q=H.sort((Q,V)=>Q.start-V.start),me=[];let x;for(const Q of q)!x||!u(x,Q)?(x=Q,me.push(Q)):(x.start=Math.min(x.start,Q.start),x.end=Math.max(x.end,Q.end));return me}function u(H,q){return!(H.end<q.start||q.end<H.start)}function l(H,q,me,x,Q,V){const _=a(H,me,x,Q,V),ge=a(q,me,x,Q,V),ce=_.score,we=ge.score;if((ce===$||we===$)&&ce!==we)return ce===$?-1:1;if(ce>t||we>t){if(ce!==we)return ce>we?-1:1;if(ce<g&&we<g){const le=A(_.labelMatch,ge.labelMatch);if(le!==0)return le}const se=Q.getItemLabel(H)||"",re=Q.getItemLabel(q)||"";if(se.length!==re.length)return se.length-re.length}if(ce!==we)return ce>we?-1:1;const G=Array.isArray(_.labelMatch)&&_.labelMatch.length>0,U=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(G&&!U)return-1;if(U&&!G)return 1;const K=w(H,_,Q),Y=w(q,ge,Q);return K&&Y&&K!==Y?Y>K?-1:1:O(H,q,me,Q)}e.$lq=l;function w(H,q,me){let x=-1,Q=-1;if(q.descriptionMatch&&q.descriptionMatch.length?x=q.descriptionMatch[0].start:q.labelMatch&&q.labelMatch.length&&(x=q.labelMatch[0].start),q.labelMatch&&q.labelMatch.length){if(Q=q.labelMatch[q.labelMatch.length-1].end,q.descriptionMatch&&q.descriptionMatch.length){const V=me.getItemDescription(H);V&&(Q+=V.length)}}else q.descriptionMatch&&q.descriptionMatch.length&&(Q=q.descriptionMatch[q.descriptionMatch.length-1].end);return Q-x}function A(H,q){if(!H&&!q||(!H||!H.length)&&(!q||!q.length))return 0;if(!q||!q.length)return-1;if(!H||!H.length)return 1;const me=H[0].start,Q=H[H.length-1].end-me,V=q[0].start,ge=q[q.length-1].end-V;return Q===ge?0:ge<Q?1:-1}function O(H,q,me,x){const Q=x.getItemLabel(H)||"",V=x.getItemLabel(q)||"",_=x.getItemDescription(H),ge=x.getItemDescription(q),ce=Q.length+(_?_.length:0),we=V.length+(ge?ge.length:0);if(ce!==we)return ce-we;const G=x.getItemPath(H),U=x.getItemPath(q);return G&&U&&G.length!==U.length?G.length-U.length:Q!==V?(0,C.$gq)(Q,V,me.normalized):_&&ge&&_!==ge?(0,C.$gq)(_,ge,me.normalized):G&&U&&G!==U?(0,C.$gq)(G,U,me.normalized):0}function N(H){return H.startsWith('"')&&H.endsWith('"')}const T=" ";function j(H){typeof H!="string"&&(H="");const q=H.toLowerCase(),{pathNormalized:me,normalized:x,normalizedLowercase:Q}=z(H),V=me.indexOf(L.sep)>=0,_=N(H);let ge;const ce=H.split(T);if(ce.length>1)for(const we of ce){const G=N(we),{pathNormalized:U,normalized:K,normalizedLowercase:Y}=z(we);K&&(ge||(ge=[]),ge.push({original:we,originalLowercase:we.toLowerCase(),pathNormalized:U,normalized:K,normalizedLowercase:Y,expectContiguousMatch:G}))}return{original:H,originalLowercase:q,pathNormalized:me,normalized:x,normalizedLowercase:Q,values:ge,containsPathSeparator:V,expectContiguousMatch:_}}e.$mq=j;function z(H){let q;R.$i?q=H.replace(/\//g,L.sep):q=H.replace(/\\/g,L.sep);const me=(0,m.$we)(q).replace(/\s|"/g,"");return{pathNormalized:q,normalized:me,normalizedLowercase:me.toLowerCase()}}function M(H){return Array.isArray(H)?j(H.map(q=>q.original).join(T)):j(H.original)}e.$nq=M}),define(De[98],Ce([1,0,16]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=e.$Fr=void 0,e.$Fr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const I=(0,C.$ae)(P),p=F[I.toLowerCase()];return p!==void 0?p:R(P)}e.$Gr=L;function R(P){const I=(0,C.$ae)(P);return f[I.toLowerCase()]}e.$Hr=R;function m(P){for(const I in f)if(f[I]===P)return I}e.$Ir=m;const S=/^(.+)\/(.+?)(;.+)?$/;function b(P,I){const p=S.exec(P);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:P}e.$Jr=b}),define(De[99],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.TerminateResponseCode=e.Source=void 0;var F;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function L(m,...S){const b=S.reduce((p,k)=>(p[k]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter(p=>!b[p]).forEach(p=>{for(let k=0;k<P.length;k++)if(p.search(P[k])!==-1){delete m[p];break}})}e.$rl=L;function R(m){m&&(delete m.DEBUG,C.$j&&delete m.DYLD_LIBRARY_PATH,C.$k&&delete m.LD_PRELOAD)}e.$sl=R}),define(De[2],Ce([1,0,16,12]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function m(n,c){if(!n.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!f.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,c){return!n&&!c?"file":n}function b(n,c){switch(n){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const P="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(c){return c instanceof k?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,E,y,u,l=!1){typeof c=="object"?(this.scheme=c.scheme||P,this.authority=c.authority||P,this.path=c.path||P,this.query=c.query||P,this.fragment=c.fragment||P):(this.scheme=S(c,l),this.authority=h||P,this.path=b(this.scheme,E||P),this.query=y||P,this.fragment=u||P,m(this,l))}get fsPath(){return $(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:E,path:y,query:u,fragment:l}=c;return h===void 0?h=this.scheme:h===null&&(h=P),E===void 0?E=this.authority:E===null&&(E=P),y===void 0?y=this.path:y===null&&(y=P),u===void 0?u=this.query:u===null&&(u=P),l===void 0?l=this.fragment:l===null&&(l=P),h===this.scheme&&E===this.authority&&y===this.path&&u===this.query&&l===this.fragment?this:new r(h,E,y,u,l)}static parse(c,h=!1){const E=p.exec(c);return E?new r(E[2]||P,a(E[4]||P),a(E[5]||P),a(E[7]||P),a(E[9]||P),h):new r(P,P,P,P,P)}static file(c){let h=P;if(F.$i&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const E=c.indexOf(I,2);E===-1?(h=c.substring(2),c=I):(h=c.substring(2,E),c=c.substring(E)||I)}return new r("file",h,c,P,P)}static from(c,h){return new r(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return F.$i&&c.scheme==="file"?E=k.file(C.$4d.join($(c,!0),...h)).path:E=C.$5d.join(c.path,...h),c.with({path:E})}toString(c=!1){return g(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof k)return c;{const h=new r(c);return h._formatted=c.external??null,h._fsPath=c._sep===v?c.fsPath??null:null,h}}else return c}}e.URI=k;function D(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Rf=D;const v=F.$i?1:void 0;class r extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(c=!1){return c?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=v),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const i={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(n,c,h){let E,y=-1;for(let u=0;u<n.length;u++){const l=n.charCodeAt(u);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||c&&l===47||h&&l===91||h&&l===93||h&&l===58)y!==-1&&(E+=encodeURIComponent(n.substring(y,u)),y=-1),E!==void 0&&(E+=n.charAt(u));else{E===void 0&&(E=n.substr(0,u));const w=i[l];w!==void 0?(y!==-1&&(E+=encodeURIComponent(n.substring(y,u)),y=-1),E+=w):y===-1&&(y=u)}}return y!==-1&&(E+=encodeURIComponent(n.substring(y))),E!==void 0?E:n}function d(n){let c;for(let h=0;h<n.length;h++){const E=n.charCodeAt(h);E===35||E===63?(c===void 0&&(c=n.substr(0,h)),c+=i[E]):c!==void 0&&(c+=n[h])}return c!==void 0?c:n}function $(n,c){let h;return n.authority&&n.path.length>1&&n.scheme==="file"?h=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?c?h=n.path.substr(1):h=n.path[1].toLowerCase()+n.path.substr(2):h=n.path,F.$i&&(h=h.replace(/\//g,"\\")),h}e.$Sf=$;function g(n,c){const h=c?d:s;let E="",{scheme:y,authority:u,path:l,query:w,fragment:A}=n;if(y&&(E+=y,E+=":"),(u||y==="file")&&(E+=I,E+=I),u){let O=u.indexOf("@");if(O!==-1){const N=u.substr(0,O);u=u.substr(O+1),O=N.lastIndexOf(":"),O===-1?E+=h(N,!1,!1):(E+=h(N.substr(0,O),!1,!1),E+=":",E+=h(N.substr(O+1),!1,!0)),E+="@"}u=u.toLowerCase(),O=u.lastIndexOf(":"),O===-1?E+=h(u,!1,!0):(E+=h(u.substr(0,O),!1,!0),E+=u.substr(O))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const O=l.charCodeAt(1);O>=65&&O<=90&&(l=`/${String.fromCharCode(O+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const O=l.charCodeAt(0);O>=65&&O<=90&&(l=`${String.fromCharCode(O+32)}:${l.substr(2)}`)}E+=h(l,!0,!1)}return w&&(E+="?",E+=h(w,!1,!1)),A&&(E+="#",E+=c?A:s(A,!1,!1)),E}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(o)?n.replace(o,c=>t(c)):n}}),define(De[181],Ce([1,0,2]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Np=e.$Mp=e.$Lp=void 0;function F(b){const P=b;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Lp=F;function f(b){const P=[];let I;try{const p=JSON.parse(b.arguments),k=p[p.length-1];k&&k.__$stack&&(p.pop(),I=k.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",b.arguments)}return{args:P,stack:I}}e.$Mp=f;function L(b){if(typeof b!="string")return L(f(b).stack);const P=b;if(P){const I=R(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:C.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Np=L;function R(b){if(!b)return b;const P=b.indexOf(`
`);return P===-1?b:b.substring(0,P)}function m(b,P){const{args:I,stack:p}=f(b),k=typeof I[0]=="string"&&I.length===1;let D=R(p);D&&(D=`(${D.trim()})`);let v=[];if(typeof I[0]=="string"?D&&k?v=[`%c[${P}] %c${I[0]} %c${D}`,S("blue"),S(""),S("grey")]:v=[`%c[${P}] %c${I[0]}`,S("blue"),S(""),...I.slice(1)]:v=[`%c[${P}]%`,S("blue"),...I],D&&!k&&v.push(D),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,v)}e.log=m;function S(b){return`color: ${b}`}}),define(De[63],Ce([1,0,22,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function f(S){return JSON.stringify(S,R)}e.$8g=f;function L(S){let b=JSON.parse(S);return b=m(b),b}e.$9g=L;function R(S,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function m(S,b=0){if(!S||b>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return F.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof C.$Ed||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=m(S[P],b+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=m(S[P],b+1))}return S}e.$0g=m}),define(De[17],Ce([1,0,8,12,2]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var L;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,I,p){this.a[P]=I,this.b[P]=p}setConnectionToken(P,I){this.c[P]=I}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(r){return C.$Y(r),P}const I=P.authority;let p=this.a[I];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const k=this.b[I],D=this.c[I];let v=`path=${encodeURIComponent(P.path)}`;return typeof D=="string"&&(v+=`&${e.$Uf}=${encodeURIComponent(D)}`),f.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${p}:${k}`,path:this.f,query:v})}}e.$Vf=new R,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class m{static{this.a="vscode-app"}asBrowserUri(P){const I=this.b(P,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Vf.rewrite(P):P.scheme===L.file&&(F.$m||F.$p&&F.$g.origin===`${L.vscodeFileResource}://${m.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||m.a,query:null,fragment:null}):P}asFileUri(P){const I=this.b(P,$e);return this.uriToFileUri(I)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==m.a?P.authority:null,query:null,fragment:null}):P}b(P,I){return f.URI.isUri(P)?P:f.URI.parse(I.toUrl(P))}}e.$1f=new m;var S;(function(b){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(P.get("3"));const I="vscode-coi";function p(D){let v;typeof D=="string"?v=new URL(D).searchParams:D instanceof URL?v=D.searchParams:f.URI.isUri(D)&&(v=new URL(D.toString(!0)).searchParams);const r=v?.get(I);if(r)return P.get(r)}b.getHeadersFromQuery=p;function k(D,v,r){if(!globalThis.crossOriginIsolated)return;const i=v&&r?"3":r?"2":"1";D instanceof URLSearchParams?D.set(I,i):D[I]=i}b.addSearchParam=k})(S||(e.COI=S={}))}),define(De[182],Ce([1,0,156,17,12,2]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0C=void 0;class R{constructor(p,k,D){this.id=p,this.dependencies=k,this.callback=D}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,k,D)=>{typeof p!="string"&&(D=k,k=p,p=null),(typeof k!="object"||!Array.isArray(k))&&(D=k,k=null),this.c.push(new R(p,k,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const k=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!k)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(p){return new Promise((k,D)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const r=()=>{v.removeEventListener("load",i),v.removeEventListener("error",s)},i=d=>{r(),k(this.c.pop())},s=d=>{r(),D(d)};v.addEventListener("load",i),v.addEventListener("error",s),this.f&&(p=this.f.createScriptURL(p)),v.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(v)})}i(p){return new Promise((k,D)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),k(this.c.pop())}catch(v){D(v)}})}async j(p){try{const k=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,r=L.URI.parse(p).fsPath,i=k.readFileSync(r).toString(),s=v.wrap(i.replace(/^#!.*/,""));return new D.Script(s).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const S=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function P(I,p,k){if(C.$R){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[I]&&(I=b[I]);const D=`${I}/${p}`;if(S.has(D))return S.get(D);let v;if(/^\w[\w\d+.-]*:\/\//.test(D))v=D;else{const d=`${k&&!f.$o?F.$Yf:F.$Xf}/${D}`;v=F.$1f.asBrowserUri(d).toString(!0)}const r=m.INSTANCE.load(v);return S.set(D,r),r}else return await new Promise((D,v)=>{$e([I],D,v)})}e.$0C=P}),define(De[24],Ce([1,0,32,17,16,12,15,2]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function S(k){return(0,m.$Sf)(k,!0)}e.$8f=S;class b{constructor(D){this.a=D}compare(D,v,r=!1){return D===v?0:(0,R.$Ee)(this.getComparisonKey(D,r),this.getComparisonKey(v,r))}isEqual(D,v,r=!1){return D===v?!0:!D||!v?!1:this.getComparisonKey(D,r)===this.getComparisonKey(v,r)}getComparisonKey(D,v=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,v,r=!1){if(D.scheme===v.scheme){if(D.scheme===F.Schemas.file)return C.$Hf(S(D),S(v),this.a(D))&&D.query===v.query&&(r||D.fragment===v.fragment);if((0,e.$mg)(D.authority,v.authority))return C.$Hf(D.path,v.path,this.a(D),"/")&&D.query===v.query&&(r||D.fragment===v.fragment)}return!1}joinPath(D,...v){return m.URI.joinPath(D,...v)}basenameOrAuthority(D){return(0,e.$eg)(D)||D.authority}basename(D){return f.$5d.basename(D.path)}extname(D){return f.$5d.extname(D.path)}dirname(D){if(D.path.length===0)return D;let v;return D.scheme===F.Schemas.file?v=m.URI.file(f.$$d(S(D))).path:(v=f.$5d.dirname(D.path),D.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),v="/")),D.with({path:v})}normalizePath(D){if(!D.path.length)return D;let v;return D.scheme===F.Schemas.file?v=m.URI.file(f.$6d(S(D))).path:v=f.$5d.normalize(D.path),D.with({path:v})}relativePath(D,v){if(D.scheme!==v.scheme||!(0,e.$mg)(D.authority,v.authority))return;if(D.scheme===F.Schemas.file){const s=f.$0d(S(D),S(v));return L.$i?C.$Bf(s):s}let r=D.path||"/";const i=v.path||"/";if(this.a(D)){let s=0;for(const d=Math.min(r.length,i.length);s<d&&!(r.charCodeAt(s)!==i.charCodeAt(s)&&r.charAt(s).toLowerCase()!==i.charAt(s).toLowerCase());s++);r=i.substr(0,s)+r.substr(s)}return f.$5d.relative(r,i)}resolvePath(D,v){if(D.scheme===F.Schemas.file){const r=m.URI.file(f.$9d(S(D),v));return D.with({authority:r.authority,path:r.path})}return v=C.$Cf(v),D.with({path:f.$5d.resolve(D.path,v)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,v){return D===v||D!==void 0&&v!==void 0&&(0,R.$Le)(D,v)}hasTrailingPathSeparator(D,v=f.sep){if(D.scheme===F.Schemas.file){const r=S(D);return r.length>C.$Df(r).length&&r[r.length-1]===v}else{const r=D.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,v=f.sep){return(0,e.$ng)(D,v)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,v=f.sep){let r=!1;if(D.scheme===F.Schemas.file){const i=S(D);r=i!==void 0&&i.length===C.$Df(i).length&&i[i.length-1]===v}else{v="/";const i=D.path;r=i.length===1&&i.charCodeAt(i.length-1)===47}return!r&&!(0,e.$ng)(D,v)?D.with({path:D.path+"/"}):D}}e.$9f=b,e.$0f=new b(()=>!1),e.$$f=new b(k=>k.scheme===F.Schemas.file?!L.$k:!0),e.$_f=new b(k=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function P(k,D){const v=[];for(let r=0;r<k.length;r++){const i=D(k[r]);k.some((s,d)=>d===r?!1:(0,e.$bg)(i,D(s)))||v.push(k[r])}return v}e.$qg=P;var I;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function D(v){const r=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(d=>{const[$,g]=d.split(":");$&&g&&r.set($,g)});const s=v.path.substring(0,v.path.indexOf(";"));return s&&r.set(k.META_DATA_MIME,s),r}k.parseMetaData=D})(I||(e.DataUri=I={}));function p(k,D,v){if(D){let r=k.path;return r&&r[0]!==f.$5d.sep&&(r=f.$5d.sep+r),k.with({scheme:v,authority:D,path:r})}return k.with({scheme:v})}e.$rg=p}),define(De[11],Ce([1,0,21,8,4,3,24,12,160]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function b(U){return!!U&&typeof U.then=="function"}e.$sg=b;function P(U){const K=new C.$od,Y=U(K.token),se=new Promise((re,le)=>{const Ee=K.token.onCancellationRequested(()=>{Ee.dispose(),K.dispose(),le(new F.$3)});Promise.resolve(Y).then(he=>{Ee.dispose(),K.dispose(),re(he)},he=>{Ee.dispose(),K.dispose(),le(he)})});return new class{cancel(){K.cancel()}then(re,le){return se.then(re,le)}catch(re){return this.then(void 0,re)}finally(re){return se.finally(re)}}}e.$tg=P;function I(U,K,Y){return new Promise((se,re)=>{const le=K.onCancellationRequested(()=>{le.dispose(),se(Y)});U.then(se,re).finally(()=>le.dispose())})}e.$ug=I;function p(U,K){return new Promise((Y,se)=>{const re=K.onCancellationRequested(()=>{re.dispose(),se(new F.$3)});U.then(Y,se).finally(()=>re.dispose())})}e.$vg=p;async function k(U){let K=-1;const Y=U.map((se,re)=>se.then(le=>(K=re,le)));try{return await Promise.race(Y)}finally{U.forEach((se,re)=>{re!==K&&se.cancel()})}}e.$wg=k;function D(U,K,Y){let se;const re=setTimeout(()=>{se?.(void 0),Y?.()},K);return Promise.race([U.finally(()=>clearTimeout(re)),new Promise(le=>se=le)])}e.$xg=D;function v(U){return new Promise((K,Y)=>{const se=U();b(se)?se.then(K,Y):K(se)})}e.$yg=v;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const Y=()=>{if(this.b=null,this.f)return;const se=this.queue(this.d);return this.d=null,se};this.b=new Promise(se=>{this.a.then(Y,Y).then(se)})}return new Promise((Y,se)=>{this.b.then(Y,se)})}return this.a=K(),new Promise((Y,se)=>{this.a.then(re=>{this.a=null,Y(re)},re=>{this.a=null,se(re)})})}dispose(){this.f=!0}}e.$zg=r;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$Ag=i;class s{constructor(){this.a=new Map}queue(K,Y){const re=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(K)===re&&this.a.delete(K)});return this.a.set(K,re),re}}e.$Bg=s;const d=(U,K)=>{let Y=!0;const se=setTimeout(()=>{Y=!1,K()},U);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(se),Y=!1}}},$=U=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,U())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class g{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,Y=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((re,le)=>{this.d=re,this.f=le}).then(()=>{if(this.b=null,this.d=null,this.g){const re=this.g;return this.g=null,re()}}));const se=()=>{this.a=null,this.d?.(null)};return this.a=Y===S.$bd?$(se):d(Y,se),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=g;class t{constructor(K){this.a=new g(K),this.b=new r}trigger(K,Y){return this.a.trigger(()=>this.b.queue(K),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=t;class o{constructor(){this.a=!1,this.b=new Promise((K,Y)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=o;class a extends o{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$Fg=a;function n(U,K){return K?new Promise((Y,se)=>{const re=setTimeout(()=>{le.dispose(),Y()},U),le=K.onCancellationRequested(()=>{clearTimeout(re),le.dispose(),se(new F.$3)})}):P(Y=>n(U,Y))}e.$Gg=n;function c(U,K=0){const Y=setTimeout(U,K);return(0,L.$hc)(()=>clearTimeout(Y))}e.$Hg=c;function h(U){const K=[];let Y=0;const se=U.length;function re(){return Y<se?U[Y++]():null}function le(Ee){Ee!=null&&K.push(Ee);const he=re();return he?he.then(le):Promise.resolve(K)}return Promise.resolve(null).then(le)}e.$Ig=h;function E(U,K=se=>!!se,Y=null){let se=0;const re=U.length,le=()=>{if(se>=re)return Promise.resolve(Y);const Ee=U[se++];return Promise.resolve(Ee()).then(fe=>K(fe)?Promise.resolve(fe):le())};return le()}e.$Jg=E;function y(U,K=se=>!!se,Y=null){if(U.length===0)return Promise.resolve(Y);let se=U.length;const re=()=>{se=-1;for(const le of U)le.cancel?.()};return new Promise((le,Ee)=>{for(const he of U)he.then(fe=>{--se>=0&&K(fe)?(re(),le(fe)):se===0&&le(Y)}).catch(fe=>{--se>=0&&(re(),Ee(fe))})})}e.$Kg=y;class u{constructor(K){this.a=0,this.d=K,this.f=[],this.b=0,this.g=new f.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(K){return this.a++,new Promise((Y,se)=>{this.f.push({factory:K,c:Y,e:se}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const K=this.f.shift();this.b++;const Y=K.factory();Y.then(K.c,K.e),Y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=u;class l extends u{constructor(){super(1)}}e.$Mg=l;class w{constructor(){this.a=new me,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$Ng=w;class A{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new V;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueFor(K,Y=R.$0f){const se=Y.getComparisonKey(K);let re=this.a.get(se);if(!re){re=new l;const le=this.f++,Ee=f.Event.once(re.onDrained)(()=>{re?.dispose(),this.a.delete(se),this.h(),this.d?.deleteAndDispose(le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$rc),this.d.set(le,Ee),this.a.set(se,re)}return re}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=A;class O{constructor(K,Y){this.a=-1,typeof K=="function"&&typeof Y=="number"&&this.setIfNotSet(K,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},Y)}setIfNotSet(K,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},Y))}}e.$Pg=O;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(K,Y){this.cancel(),this.a=setInterval(()=>{K()},Y)}}e.$Qg=N;class T{constructor(K,Y){this.b=-1,this.a=K,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=T;class j{constructor(K,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=K,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=j;class z extends T{constructor(K,Y){super(K,Y),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$Tg=z;class M extends L.$jc{constructor(K,Y){super(),this.g=K,this.h=Y,this.a=[],this.b=this.B(new L.$kc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of K)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new T(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=U=>{(0,m.$A)(()=>{if(K)return;const Y=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.$Vg=(U,K)=>{const Y=requestIdleCallback(U,typeof K=="number"?{timeout:K}:void 0);let se=!1;return{dispose(){se||(se=!0,cancelIdleCallback(Y))}}}}();class H{constructor(K){this.d=!1,this.a=()=>{try{this.f=K()}catch(Y){this.g=Y}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=H;async function q(U,K,Y){let se;for(let re=0;re<Y;re++)try{return await U()}catch(le){se=le,await n(K)}throw se}e.$Xg=q;class me{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,Y,se){return this.a={taskId:K,cancel:()=>se?.(),promise:Y},Y.then(()=>this.d(K),()=>this.d(K)),Y}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{let Y,se;const re=new Promise((le,Ee)=>{Y=le,se=Ee});this.b={run:K,promise:re,promiseResolve:Y,promiseReject:se}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=me;class x{constructor(K,Y=()=>Date.now()){this.d=K,this.f=Y,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Zg=x;var Q;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(Q||(Q={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,Y)=>{this.a=K,this.b=Y})}complete(K){return new Promise(Y=>{this.a(K),this.d={outcome:0,value:K},Y()})}error(K){return new Promise(Y=>{this.b(K),this.d={outcome:1,value:K},Y()})}cancel(){return this.error(new F.$3)}}e.$1g=V;var _;(function(U){async function K(se){let re;const le=await Promise.all(se.map(Ee=>Ee.then(he=>he,he=>{re||(re=he)})));if(typeof re<"u")throw re;return le}U.settled=K;function Y(se){return new Promise(async(re,le)=>{try{await se(re,le)}catch(Ee){le(Ee)}})}U.withAsyncBody=Y})(_||(e.Promises=_={}));var ge;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(ge||(ge={}));class ce{static fromArray(K){return new ce(Y=>{Y.emitMany(K)})}static fromPromise(K){return new ce(async Y=>{Y.emitMany(await K)})}static fromPromises(K){return new ce(async Y=>{await Promise.all(K.map(async se=>Y.emitOne(await se)))})}static merge(K){return new ce(async Y=>{await Promise.all(K.map(async se=>{for await(const re of se)Y.emitOne(re)}))})}static{this.EMPTY=ce.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new f.$ed,queueMicrotask(async()=>{const Y={emitOne:se=>this.g(se),emitMany:se=>this.h(se),reject:se=>this.k(se)};try{await Promise.resolve(K(Y)),this.j()}catch(se){this.k(se)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(K,Y){return new ce(async se=>{for await(const re of K)se.emitOne(Y(re))})}map(K){return ce.map(this,K)}static filter(K,Y){return new ce(async se=>{for await(const re of K)Y(re)&&se.emitOne(re)})}filter(K){return ce.filter(this,K)}static coalesce(K){return ce.filter(K,Y=>!!Y)}coalesce(){return ce.coalesce(this)}static async toPromise(K){const Y=[];for await(const se of K)Y.push(se);return Y}toPromise(){return ce.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$2g=ce;class we extends ce{constructor(K,Y){super(Y),this.l=K}cancel(){this.l.cancel()}}e.$3g=we;function G(U){const K=new C.$od,Y=U(K.token);return new we(K,async se=>{const re=K.token.onCancellationRequested(()=>{re.dispose(),K.dispose(),se.reject(new F.$3)});try{for await(const le of Y){if(K.token.isCancellationRequested)return;se.emitOne(le)}re.dispose(),K.dispose()}catch(le){re.dispose(),K.dispose(),se.reject(le)}})}e.$4g=G}),define(De[35],Ce([1,0,19,11,32,28,16,12,15]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0;function b(){return Object.create(null)}e.$lj=b,e.$mj="**",e.$nj="/";const P="[/\\\\]",I="[^/\\\\]",p=/\//g;function k(me,x){switch(me){case 0:return"";case 1:return`${I}*?`;default:return`(?:${P}|${I}+${P}${x?`|${P}${I}+`:""})*?`}}function D(me,x){if(!me)return[];const Q=[];let V=!1,_=!1,ge="";for(const ce of me){switch(ce){case x:if(!V&&!_){Q.push(ge),ge="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":_=!0;break;case"]":_=!1;break}ge+=ce}return ge&&Q.push(ge),Q}e.$oj=D;function v(me){if(!me)return"";let x="";const Q=D(me,e.$nj);if(Q.every(V=>V===e.$mj))x=".*";else{let V=!1;Q.forEach((_,ge)=>{if(_===e.$mj){if(V)return;x+=k(2,ge===Q.length-1)}else{let ce=!1,we="",G=!1,U="";for(const K of _){if(K!=="}"&&ce){we+=K;continue}if(G&&(K!=="]"||!U)){let Y;K==="-"?Y=K:(K==="^"||K==="!")&&!U?Y="^":K===e.$nj?Y="":Y=(0,S.$pe)(K),U+=Y;continue}switch(K){case"{":ce=!0;continue;case"[":G=!0;continue;case"}":{const se=`(?:${D(we,",").map(re=>v(re)).join("|")})`;x+=se,ce=!1,we="";break}case"]":{x+="["+U+"]",G=!1,U="";break}case"?":x+=I;continue;case"*":x+=k(1);continue;default:x+=(0,S.$pe)(K)}}ge<Q.length-1&&(Q[ge+1]!==e.$mj||ge+2<Q.length)&&(x+=P)}V=_===e.$mj})}return x}const r=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,s=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Bi(1e4),o=function(){return!1},a=function(){return null};function n(me,x){if(!me)return a;let Q;typeof me!="string"?Q=me.pattern:Q=me,Q=Q.trim();const V=`${Q}_${!!x.trimForExclusions}`;let _=t.get(V);if(_)return c(_,me);let ge;return r.test(Q)?_=E(Q.substr(4),Q):(ge=i.exec(h(Q,x)))?_=y(ge[1],Q):(x.trimForExclusions?d:s).test(Q)?_=u(Q,x):(ge=$.exec(h(Q,x)))?_=l(ge[1].substr(1),Q,!0):(ge=g.exec(h(Q,x)))?_=l(ge[1],Q,!1):_=w(Q),t.set(V,_),c(_,me)}function c(me,x){if(typeof x=="string")return me;const Q=function(V,_){return(0,f.$Hf)(V,x.base,!m.$k)?me((0,S.$te)(V.substr(x.base.length),R.sep),_):null};return Q.allBasenames=me.allBasenames,Q.allPaths=me.allPaths,Q.basenames=me.basenames,Q.patterns=me.patterns,Q}function h(me,x){return x.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function E(me,x){return function(Q,V){return typeof Q=="string"&&Q.endsWith(me)?x:null}}function y(me,x){const Q=`/${me}`,V=`\\${me}`,_=function(ce,we){return typeof ce!="string"?null:we?we===me?x:null:ce===me||ce.endsWith(Q)||ce.endsWith(V)?x:null},ge=[me];return _.basenames=ge,_.patterns=[x],_.allBasenames=ge,_}function u(me,x){const Q=H(me.slice(1,-1).split(",").map(we=>n(we,x)).filter(we=>we!==a),me),V=Q.length;if(!V)return a;if(V===1)return Q[0];const _=function(we,G){for(let U=0,K=Q.length;U<K;U++)if(Q[U](we,G))return me;return null},ge=Q.find(we=>!!we.allBasenames);ge&&(_.allBasenames=ge.allBasenames);const ce=Q.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return ce.length&&(_.allPaths=ce),_}function l(me,x,Q){const V=R.sep===R.$5d.sep,_=V?me:me.replace(p,R.sep),ge=R.sep+_,ce=R.$5d.sep+me;let we;return Q?we=function(G,U){return typeof G=="string"&&(G===_||G.endsWith(ge)||!V&&(G===me||G.endsWith(ce)))?x:null}:we=function(G,U){return typeof G=="string"&&(G===_||!V&&G===me)?x:null},we.allPaths=[(Q?"*/":"./")+me],we}function w(me){try{const x=new RegExp(`^${v(me)}$`);return function(Q){return x.lastIndex=0,typeof Q=="string"&&x.test(Q)?me:null}}catch{return a}}function A(me,x,Q){return!me||typeof x!="string"?!1:O(me)(x,void 0,Q)}e.$pj=A;function O(me,x={}){if(!me)return o;if(typeof me=="string"||N(me)){const Q=n(me,x);if(Q===a)return o;const V=function(_,ge){return!!Q(_,ge)};return Q.allBasenames&&(V.allBasenames=Q.allBasenames),Q.allPaths&&(V.allPaths=Q.allPaths),V}return z(me,x)}e.$qj=O;function N(me){const x=me;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$rj=N;function T(me){return me.allBasenames||[]}e.$sj=T;function j(me){return me.allPaths||[]}e.$tj=j;function z(me,x){const Q=H(Object.getOwnPropertyNames(me).map(we=>M(we,me[we],x)).filter(we=>we!==a)),V=Q.length;if(!V)return a;if(!Q.some(we=>!!we.requiresSiblings)){if(V===1)return Q[0];const we=function(K,Y){let se;for(let re=0,le=Q.length;re<le;re++){const Ee=Q[re](K,Y);if(typeof Ee=="string")return Ee;(0,F.$sg)(Ee)&&(se||(se=[]),se.push(Ee))}return se?(async()=>{for(const re of se){const le=await re;if(typeof le=="string")return le}return null})():null},G=Q.find(K=>!!K.allBasenames);G&&(we.allBasenames=G.allBasenames);const U=Q.reduce((K,Y)=>Y.allPaths?K.concat(Y.allPaths):K,[]);return U.length&&(we.allPaths=U),we}const _=function(we,G,U){let K,Y;for(let se=0,re=Q.length;se<re;se++){const le=Q[se];le.requiresSiblings&&U&&(G||(G=(0,R.$_d)(we)),K||(K=G.substr(0,G.length-(0,R.$ae)(we).length)));const Ee=le(we,G,K,U);if(typeof Ee=="string")return Ee;(0,F.$sg)(Ee)&&(Y||(Y=[]),Y.push(Ee))}return Y?(async()=>{for(const se of Y){const re=await se;if(typeof re=="string")return re}return null})():null},ge=Q.find(we=>!!we.allBasenames);ge&&(_.allBasenames=ge.allBasenames);const ce=Q.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return ce.length&&(_.allPaths=ce),_}function M(me,x,Q){if(x===!1)return a;const V=n(me,Q);if(V===a)return a;if(typeof x=="boolean")return V;if(x){const _=x.when;if(typeof _=="string"){const ge=(ce,we,G,U)=>{if(!U||!V(ce,we))return null;const K=_.replace("$(basename)",()=>G),Y=U(K);return(0,F.$sg)(Y)?Y.then(se=>se?me:null):Y?me:null};return ge.requiresSiblings=!0,ge}}return V}function H(me,x){const Q=me.filter(we=>!!we.basenames);if(Q.length<2)return me;const V=Q.reduce((we,G)=>{const U=G.basenames;return U?we.concat(U):we},[]);let _;if(x){_=[];for(let we=0,G=V.length;we<G;we++)_.push(x)}else _=Q.reduce((we,G)=>{const U=G.patterns;return U?we.concat(U):we},[]);const ge=function(we,G){if(typeof we!="string")return null;if(!G){let K;for(K=we.length;K>0;K--){const Y=we.charCodeAt(K-1);if(Y===47||Y===92)break}G=we.substr(K)}const U=V.indexOf(G);return U!==-1?_[U]:null};ge.basenames=V,ge.patterns=_,ge.allBasenames=V;const ce=me.filter(we=>!we.basenames);return ce.push(ge),ce}function q(me,x){return(0,C.$sb)(me,x,(Q,V)=>typeof Q=="string"&&typeof V=="string"?Q===V:typeof Q!="string"&&typeof V!="string"?Q.base===V.base&&Q.pattern===V.pattern:!1)}e.$uj=q}),define(De[79],Ce([1,0,8,161,24,15,2]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class S{constructor(i="",s=!1){if(this.value=i,typeof this.value!="string")throw(0,C.$5)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(i,s=0){return this.value+=p(this.supportThemeIcons?(0,F.$Qj)(i):i).replace(/([ \t]+)/g,(d,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,s){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(i,s,d){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(i),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(i,s){const d=new RegExp((0,L.$pe)(s),"g");return i.replace(d,($,g)=>i.charAt(g-1)!=="\\"?`\\${$}`:$)}}e.$Wj=S;function b(r){return P(r)?!r.value:Array.isArray(r)?r.every(b):!0}e.$Xj=b;function P(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$Yj=P;function I(r,i){return r===i?!0:!r||!i?!1:r.value===i.value&&r.isTrusted===i.isTrusted&&r.supportThemeIcons===i.supportThemeIcons&&r.supportHtml===i.supportHtml&&(r.baseUri===i.baseUri||!!r.baseUri&&!!i.baseUri&&(0,f.$ag)(R.URI.from(r.baseUri),R.URI.from(i.baseUri)))}e.$Zj=I;function p(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$1j=p;function k(r){return r.replace(/"/g,"&quot;")}e.$2j=k;function D(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$3j=D;function v(r){const i=[],s=r.split("|").map($=>$.trim());r=s[0];const d=s[1];if(d){const $=/height=(\d+)/.exec(d),g=/width=(\d+)/.exec(d),t=$?$[1]:"",o=g?g[1]:"",a=isFinite(parseInt(o)),n=isFinite(parseInt(t));a&&i.push(`width="${o}"`),n&&i.push(`height="${t}"`)}return{href:r,dimensions:i}}e.$4j=v}),define(De[100],Ce([1,0,19,32,16,12,24,15]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=e.$bA=void 0;function S(n,c){const{os:h,tildify:E,relative:y}=c;if(y){const w=b(n,y,h);if(typeof w=="string")return w}let u=n.fsPath;if(h===1&&!L.$i?u=u.replace(/\//g,"\\"):h!==1&&L.$i&&(u=u.replace(/\\/g,"/")),h!==1&&E?.userHome){const w=E.userHome.fsPath;let A;n.scheme!==E.userHome.scheme&&n.path.startsWith(f.$5d.sep)?A=E.userHome.with({path:n.path}).fsPath:A=n.fsPath,u=p(A,w,h)}return(h===1?f.$4d:f.$5d).normalize(P(u,h===1))}e.$bA=S;function b(n,c,h){const E=h===1?f.$4d:f.$5d,y=h===3?R.$0f:R.$_f,u=c.getWorkspace(),l=(0,C.$Lb)(u.folders);if(!l)return;n.scheme!==l.uri.scheme&&n.path.startsWith(f.$5d.sep)&&(n=l.uri.with({path:n.path}));const w=c.getWorkspaceFolder(n);if(!w)return;let A;if(y.isEqual(w.uri,n)?A="":A=y.relativePath(w.uri,n)??"",A&&(A=E.normalize(A)),u.folders.length>1&&!c.noPrefix){const O=w.name?w.name:y.basenameOrAuthority(w.uri);A=A?`${O} \u2022 ${A}`:O}return A}function P(n,c=L.$i){return(0,F.$Lf)(n,c)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$cA=P;let I=Object.create(null);function p(n,c,h=L.OS){if(h===1||!n||!c)return n;let E=I.original===c?I.normalized:void 0;E||(E=c,L.$i&&(E=(0,F.$Bf)(E)),E=`${(0,m.$ue)(E,f.$5d.sep)}${f.$5d.sep}`,I={original:c,normalized:E});let y=n;return L.$i&&(y=(0,F.$Bf)(y)),(h===3?y.startsWith(E):(0,m.$Me)(y,E))?`~/${y.substr(E.length)}`:n}e.$dA=p;function k(n,c){return n.replace(/^~($|\/|\\)/,`${c}$1`)}e.$eA=k;const D="\u2026",v="\\\\",r="~";function i(n,c=f.sep){const h=new Array(n.length);let E=!1;for(let y=0;y<n.length;y++){const u=n[y];if(u===""){h[y]=`.${c}`;continue}if(!u){h[y]=u;continue}E=!0;let l="",w=u;w.indexOf(v)===0?(l=w.substr(0,w.indexOf(v)+v.length),w=w.substr(w.indexOf(v)+v.length)):w.indexOf(c)===0?(l=w.substr(0,w.indexOf(c)+c.length),w=w.substr(w.indexOf(c)+c.length)):w.indexOf(r)===0&&(l=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length));const A=w.split(c);for(let O=1;E&&O<=A.length;O++)for(let N=A.length-O;E&&N>=0;N--){E=!1;let T=A.slice(N,N+O).join(c);for(let j=0;!E&&j<n.length;j++)if(j!==y&&n[j]&&n[j].indexOf(T)>-1){const z=N+O===A.length,M=N>0&&n[j].indexOf(c)>-1?c+T:T,H=n[j].endsWith(M);E=!z||H}if(!E){let j="";(A[0].endsWith(":")||l!=="")&&(N===1&&(N=0,O++,T=A[0]+c+T),N>0&&(j=A[0]+c),j=l+j),N>0&&(j=j+D+c),j=j+T,N+O<A.length&&(j=j+c+D),h[y]=j}}E&&(h[y]=u)}return h}e.$fA=i;var s;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function d(n,c=Object.create(null)){const h=[];let E=!1,y="";for(const u of n)if(u==="$"||E&&u==="{")y&&h.push({value:y,type:s.TEXT}),y="",E=!0;else if(u==="}"&&E){const l=c[y];if(typeof l=="string")l.length&&h.push({value:l,type:s.VARIABLE});else if(l){const w=h[h.length-1];(!w||w.type!==s.SEPARATOR)&&h.push({value:l.label,type:s.SEPARATOR})}y="",E=!1}else y+=u;return y&&!E&&h.push({value:y,type:s.TEXT}),h.filter((u,l)=>{if(u.type===s.SEPARATOR){const w=h[l-1],A=h[l+1];return[w,A].every(O=>O&&(O.type===s.VARIABLE||O.type===s.TEXT)&&O.value.length>0)}return!0}).map(u=>u.value).join("")}e.$gA=d;function $(n,c){return L.$j||c?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$hA=$;function g(n,c){return L.$j||c?n.replace(/\(&&\w\)|&&/g,""):L.$i?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$iA=g;function t(n){return n.replace(/&/g,"&&")}e.$jA=t;function o(n){if(n.endsWith("]")){const c=n.lastIndexOf(" [",n.length-2);if(c!==-1){const h=a(n.substring(0,c));return{name:h.name,parentPath:h.parentPath+n.substring(c)}}}return a(n)}e.$kA=o;function a(n){const c=n.indexOf("/")!==-1?f.$5d:f.$4d,h=c.basename(n),E=c.dirname(n);return h.length?{name:h,parentPath:E}:{name:E,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0;function f(I){return I.toJSON()}class L{constructor(p){this.a=p}transformIncoming(p){const k=this.a.transformIncoming(p);return k===p?p:f(F.URI.from(k))}transformOutgoing(p){const k=this.a.transformOutgoing(p);return k===p?p:f(F.URI.from(k))}transformOutgoingURI(p){const k=this.a.transformOutgoing(p);return k===p?p:F.URI.from(k)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Am=L,e.$Bm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,p,k){if(!I||k>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return p.transformOutgoing(I);for(const D in I)if(Object.hasOwnProperty.call(I,D)){const v=R(I[D],p,k+1);v!==null&&(I[D]=v)}}return null}function m(I,p){const k=R(I,p,0);return k===null?I:k}e.$Cm=m;function S(I,p,k,D){if(!I||D>200)return null;if(typeof I=="object"){if(I.$mid===1)return k?F.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof C.$Ed)return null;for(const v in I)if(Object.hasOwnProperty.call(I,v)){const r=S(I[v],p,k,D+1);r!==null&&(I[v]=r)}}return null}function b(I,p){const k=S(I,p,!1,0);return k===null?I:k}e.$Dm=b;function P(I,p){const k=S(I,p,!0,0);return k===null?I:k}e.$Em=P}),define(De[29],Ce([1,0,52,64,370,11,32,76,16,12,24,2]),function($e,e,C,F,f,L,R,m,S,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function k(M,H=p.UNLINK,q){if((0,R.$Kf)(M))throw new Error("rimraf - will refuse to recursively delete root");return H===p.UNLINK?v(M):D(M,q)}async function D(M,H=(0,R.$Pf)((0,F.tmpdir)())){try{try{await C.promises.rename(M,H)}catch(q){return q.code==="ENOENT"?void 0:v(M)}v(H).catch(q=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function v(M){return(0,f.promisify)(C.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function r(M){if((0,R.$Kf)(M))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function i(M,H){return $(await(H?s(M):(0,f.promisify)(C.readdir)(M)))}async function s(M){try{return await(0,f.promisify)(C.readdir)(M,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const H=[],q=await i(M);for(const me of q){let x=!1,Q=!1,V=!1;try{const _=await e.Promises.lstat((0,S.$8d)(M,me));x=_.isFile(),Q=_.isDirectory(),V=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}H.push({name:me,isFile:()=>x,isDirectory:()=>Q,isSymbolicLink:()=>V})}return H}function d(M){return $(C.readdirSync(M))}e.readdirSync=d;function $(M){return M.map(H=>typeof H=="string"?b.$j?(0,m.$gl)(H):H:(H.name=b.$j?(0,m.$gl)(H.name):H.name,H))}async function g(M){const H=await i(M),q=[];for(const me of H)await o.existsDirectory((0,S.$8d)(M,me))&&q.push(me);return q}function t(M,H=1e3){return new Promise(q=>{let me=!1;const x=setInterval(()=>{me||(me=!0,C.access(M,Q=>{me=!1,Q&&(clearInterval(x),q(void 0))}))},H)})}e.whenDeleted=t;var o;(function(M){async function H(x){let Q;try{if(Q=await e.Promises.lstat(x),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(b.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw _}throw V}}M.stat=H;async function q(x){try{const{stat:Q,symbolicLink:V}=await M.stat(x);return Q.isFile()&&V?.dangling!==!0}catch{}return!1}M.existsFile=q;async function me(x){try{const{stat:Q,symbolicLink:V}=await M.stat(x);return Q.isDirectory()&&V?.dangling!==!0}catch{}return!1}M.existsDirectory=me})(o||(e.SymlinkSupport=o={}));const a=new L.$Og;function n(M,H,q){return a.queueFor(I.URI.file(M),P.$$f).queue(()=>{const me=u(q);return new Promise((x,Q)=>E(M,H,me,V=>V?Q(V):x()))})}let c=!0;function h(M){c=M}e.configureFlushOnWrite=h;function E(M,H,q,me){if(!c)return C.writeFile(M,H,{mode:q.mode,flag:q.flag},me);C.open(M,q.flag,q.mode,(x,Q)=>{if(x)return me(x);C.writeFile(Q,H,V=>{if(V)return C.close(Q,()=>me(V));C.fdatasync(Q,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),h(!1)),C.close(Q,ge=>me(ge))))})})}function y(M,H,q){const me=u(q);if(!c)return C.writeFileSync(M,H,{mode:me.mode,flag:me.flag});const x=C.openSync(M,me.flag,me.mode);try{C.writeFileSync(x,H);try{C.fdatasyncSync(x)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),h(!1)}}finally{C.closeSync(x)}}e.writeFileSync=y;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function l(M,H,q=6e4){if(M!==H)try{b.$i&&typeof q=="number"?await w(M,H,Date.now(),q):await(0,f.promisify)(C.rename)(M,H)}catch(me){if(M.toLowerCase()!==H.toLowerCase()&&me.code==="EXDEV"||M.endsWith("."))await A(M,H,{preserveSymlinks:!1}),await k(M,p.MOVE);else throw me}}async function w(M,H,q,me,x=0){try{return await(0,f.promisify)(C.rename)(M,H)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-q>=me)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Q}`),Q;if(x===0){let V=!1;try{const{stat:_}=await o.stat(H);_.isFile()||(V=!0)}catch{}if(V)throw Q}return await(0,L.$Gg)(Math.min(100,x*10)),w(M,H,q,me,x+1)}}async function A(M,H,q){return N(M,H,{root:{source:M,target:H},options:q,handledSourcePaths:new Set})}const O=511;async function N(M,H,q){if(q.handledSourcePaths.has(M))return;q.handledSourcePaths.add(M);const{stat:me,symbolicLink:x}=await o.stat(M);if(x){if(q.options.preserveSymlinks)try{return await z(M,H,q)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(x.dangling)return}return me.isDirectory()?T(M,H,me.mode&O,q):j(M,H,me.mode&O)}async function T(M,H,q,me){await e.Promises.mkdir(H,{recursive:!0,mode:q});const x=await i(M);for(const Q of x)await N((0,S.$8d)(M,Q),(0,S.$8d)(H,Q),me)}async function j(M,H,q){await e.Promises.copyFile(M,H),await e.Promises.chmod(H,q)}async function z(M,H,q){let me=await e.Promises.readlink(M);(0,R.$Hf)(me,q.root.source,!b.$k)&&(me=(0,S.$8d)(q.root.target,me.substr(q.root.source.length+1))),await e.Promises.symlink(me,H)}e.Promises=new class{get access(){return(0,f.promisify)(C.access)}get stat(){return(0,f.promisify)(C.stat)}get lstat(){return(0,f.promisify)(C.lstat)}get utimes(){return(0,f.promisify)(C.utimes)}get read(){return(M,H,q,me,x)=>new Promise((Q,V)=>{C.read(M,H,q,me,x,(_,ge,ce)=>_?V(_):Q({bytesRead:ge,buffer:ce}))})}get readFile(){return(0,f.promisify)(C.readFile)}get write(){return(M,H,q,me,x)=>new Promise((Q,V)=>{C.write(M,H,q,me,x,(_,ge,ce)=>_?V(_):Q({bytesWritten:ge,buffer:ce}))})}get appendFile(){return(0,f.promisify)(C.appendFile)}get fdatasync(){return(0,f.promisify)(C.fdatasync)}get truncate(){return(0,f.promisify)(C.truncate)}get copyFile(){return(0,f.promisify)(C.copyFile)}get open(){return(0,f.promisify)(C.open)}get close(){return(0,f.promisify)(C.close)}get symlink(){return(0,f.promisify)(C.symlink)}get readlink(){return(0,f.promisify)(C.readlink)}get chmod(){return(0,f.promisify)(C.chmod)}get mkdir(){return(0,f.promisify)(C.mkdir)}get unlink(){return(0,f.promisify)(C.unlink)}get rmdir(){return(0,f.promisify)(C.rmdir)}get realpath(){return(0,f.promisify)(C.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return i}get readDirsInDir(){return g}get writeFile(){return n}get rm(){return k}get rename(){return l}get copy(){return A}}}),define(De[101],Ce([1,0,52,16,12,15,29]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function m(p){if(f.$k)return p;const k=(0,F.$$d)(p);if(p===k)return p;const D=((0,F.$_d)(p)||p).toLowerCase();try{const r=(0,R.readdirSync)(k).filter(i=>i.toLowerCase()===D);if(r.length===1){const i=m(k);if(i)return(0,F.$8d)(i,r[0])}else if(r.length>1){const i=r.indexOf(D);if(i>=0){const s=m(k);if(s)return(0,F.$8d)(s,r[i])}}}catch{}return null}e.$Sp=m;async function S(p){if(f.$k)return p;const k=(0,F.$$d)(p);if(p===k)return p;const D=((0,F.$_d)(p)||p).toLowerCase();try{const r=(await R.Promises.readdir(k)).filter(i=>i.toLowerCase()===D);if(r.length===1){const i=await S(k);if(i)return(0,F.$8d)(i,r[0])}else if(r.length>1){const i=r.indexOf(D);if(i>=0){const s=await S(k);if(s)return(0,F.$8d)(s,r[i])}}}catch{}return null}e.$Tp=S;async function b(p){try{return await R.Promises.realpath(p)}catch{const D=I(p);return await R.Promises.access(D,C.constants.R_OK),D}}e.$Up=b;function P(p){try{return C.realpathSync(p)}catch{const D=I(p);return C.accessSync(D,C.constants.R_OK),D}}e.$Vp=P;function I(p){return(0,L.$ue)((0,F.$6d)(p),F.sep)}}),define(De[102],Ce([1,0,16,12,47,99,18,29]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function S(I=f.env){return I.comspec||"cmd.exe"}e.$tl=S;function b(I){let p=[],k=!1;const D=function(v){if(k){p.push(v);return}(!I.send(v,i=>{if(i&&console.error(i),k=!1,p.length>0){const s=p.slice(0);p=[],s.forEach(d=>D(d))}})||F.$i)&&(k=!0)};return{send:D}}e.$ul=b;var P;(function(I){async function p(k,D,v){if(C.$7d(k))return k;if(D===void 0&&(D=f.cwd()),C.$$d(k)!=="."||(v===void 0&&R.$if(f.env.PATH)&&(v=f.env.PATH.split(C.$fe)),v===void 0||v.length===0))return C.$8d(D,k);async function i(s){if(await m.Promises.exists(s)){let d;try{d=await m.Promises.stat(s)}catch($){$.message.startsWith("EACCES")&&(d=await m.Promises.lstat(s))}return d?!d.isDirectory():!1}return!1}for(const s of v){let d;if(C.$7d(s)?d=C.$8d(s,k):d=C.$8d(D,s,k),await i(d))return d;let $=d+".com";if(await i($)||($=d+".exe",await i($)))return $}return C.$8d(D,k)}I.findExecutable=p})(P||(e.win32=P={}))});var Ke=this&&this.__decorate||function($e,e,C,F){var f=arguments.length,L=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,C):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($e,e,C,F);else for(var m=$e.length-1;m>=0;m--)(R=$e[m])&&(L=(f<3?R(L):f>3?R(e,C,L):R(e,C))||L);return f>3&&L&&Object.defineProperty(e,C,L),L};define(De[80],Ce([1,0,19,11,22,21,57,8,4,3,63,15,18]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.ProxyChannel=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.RequestInitiator=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0;var k;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(k||(k={}));function D(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v||(v={}));function r(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var i;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(i||(i={}));function s(x){let Q=0;for(let V=0;;V+=7){const _=x.read(1);if(Q|=(_.buffer[0]&127)<<V,!(_.buffer[0]&128))return Q}}const d=a(0);function $(x,Q){if(Q===0){x.write(d);return}let V=0;for(let ge=Q;ge!==0;ge=ge>>>7)V++;const _=f.$Ed.alloc(V);for(let ge=0;Q!==0;ge++)_.buffer[ge]=Q&127,Q=Q>>>7,Q>0&&(_.buffer[ge]|=128);x.write(_)}class g{constructor(Q){this.b=Q,this.a=0}read(Q){const V=this.b.slice(this.a,this.a+Q);return this.a+=V.byteLength,V}}e.$$g=g;class t{constructor(){this.a=[]}get buffer(){return f.$Ed.concat(this.a)}write(Q){this.a.push(Q)}}e.$_g=t;var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(o||(o={}));function a(x){const Q=f.$Ed.alloc(1);return Q.writeUInt8(x,0),Q}const n={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object),Uint:a(o.Int)},c=typeof Buffer<"u";function h(x,Q){if(typeof Q>"u")x.write(n.Undefined);else if(typeof Q=="string"){const V=f.$Ed.fromString(Q);x.write(n.String),$(x,V.byteLength),x.write(V)}else if(c&&Buffer.isBuffer(Q)){const V=f.$Ed.wrap(Q);x.write(n.Buffer),$(x,V.byteLength),x.write(V)}else if(Q instanceof f.$Ed)x.write(n.VSBuffer),$(x,Q.byteLength),x.write(Q);else if(Array.isArray(Q)){x.write(n.Array),$(x,Q.length);for(const V of Q)h(x,V)}else if(typeof Q=="number"&&(Q|0)===Q)x.write(n.Uint),$(x,Q);else{const V=f.$Ed.fromString(JSON.stringify(Q));x.write(n.Object),$(x,V.byteLength),x.write(V)}}e.$ah=h;function E(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(s(x)).toString();case o.Buffer:return x.read(s(x)).buffer;case o.VSBuffer:return x.read(s(x));case o.Array:{const V=s(x),_=[];for(let ge=0;ge<V;ge++)_.push(E(x));return _}case o.Object:return JSON.parse(x.read(s(x)).toString());case o.Int:return s(x)}}e.$bh=E;class y{constructor(Q,V,_=null,ge=1e3){this.h=Q,this.j=V,this.k=_,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(Q,V){this.b.set(Q,V),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const V=this.o([Q.type]);this.k?.logOutgoing(V,0,1,r(Q.type));return}case 201:case 202:case 204:case 203:{const V=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(V,Q.id,1,r(Q.type),Q.data);return}}}o(Q,V=void 0){const _=new t;return h(_,Q),h(_,V),this.p(_.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const V=new g(Q),_=E(V),ge=E(V),ce=_[0];switch(ce){case 100:return this.k?.logIncoming(Q.byteLength,_[1],1,`${D(ce)}: ${_[2]}.${_[3]}`,ge),this.s({type:ce,id:_[1],channelName:_[2],name:_[3],arg:ge});case 102:return this.k?.logIncoming(Q.byteLength,_[1],1,`${D(ce)}: ${_[2]}.${_[3]}`,ge),this.t({type:ce,id:_[1],channelName:_[2],name:_[3],arg:ge});case 101:return this.k?.logIncoming(Q.byteLength,_[1],1,`${D(ce)}`),this.u({type:ce,id:_[1]});case 103:return this.k?.logIncoming(Q.byteLength,_[1],1,`${D(ce)}`),this.u({type:ce,id:_[1]})}}s(Q){const V=this.b.get(Q.channelName);if(!V){this.v(Q);return}const _=new L.$od;let ge;try{ge=V.call(this.j,Q.name,Q.arg,_.token)}catch(G){ge=Promise.reject(G)}const ce=Q.id;ge.then(G=>{this.m({id:ce,data:G,type:201})},G=>{G instanceof Error?this.m({id:ce,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:ce,data:G,type:203})}).finally(()=>{we.dispose(),this.d.delete(Q.id)});const we=(0,b.$hc)(()=>_.cancel());this.d.set(Q.id,we)}t(Q){const V=this.b.get(Q.channelName);if(!V){this.v(Q);return}const _=Q.id,ce=V.listen(this.j,Q.name,Q.arg)(we=>this.m({id:_,data:we,type:204}));this.d.set(Q.id,ce)}u(Q){const V=this.d.get(Q.id);V&&(V.dispose(),this.d.delete(Q.id))}v(Q){let V=this.g.get(Q.channelName);V||(V=[],this.g.set(Q.channelName,V));const _=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:Q,timeoutTimer:_})}w(Q){const V=this.g.get(Q);if(V){for(const _ of V)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$ec)(this.d.values()),this.d.clear()}}e.$ch=y;var u;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));class l{constructor(Q,V=null){this.l=Q,this.a=!1,this.b=i.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$ed,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=V}getChannel(Q){const V=this;return{call(_,ge,ce){return V.a?Promise.reject(new m.$3):V.m(Q,_,ge,ce)},listen(_,ge){return V.a?S.Event.None:V.o(Q,_,ge)}}}m(Q,V,_,ge=L.CancellationToken.None){const ce=this.g++,G={id:ce,type:100,channelName:Q,name:V,arg:_};if(ge.isCancellationRequested)return Promise.reject(new m.$3);let U;return new Promise((Y,se)=>{if(ge.isCancellationRequested)return se(new m.$3);const re=()=>{const fe=te=>{switch(te.type){case 201:this.f.delete(ce),Y(te.data);break;case 202:{this.f.delete(ce);const ue=new Error(te.data.message);ue.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,ue.name=te.data.name,se(ue);break}case 203:this.f.delete(ce),se(te.data);break}};this.f.set(ce,fe),this.p(G)};let le=null;this.b===i.Idle?re():(le=(0,F.$tg)(fe=>this.u()),le.then(()=>{le=null,re()}));const Ee=()=>{le?(le.cancel(),le=null):this.p({id:ce,type:101}),se(new m.$3)},he=ge.onCancellationRequested(Ee);U=(0,b.$gc)((0,b.$hc)(Ee),he),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Q,V,_){const ge=this.g++,we={id:ge,type:102,channelName:Q,name:V,arg:_};let G=null;const U=new S.$ed({onWillAddFirstListener:()=>{G=(0,F.$tg)(Y=>this.u()),G.then(()=>{G=null,this.d.add(U),this.p(we)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(U),this.p({id:ge,type:103}))}}),K=Y=>U.fire(Y.data);return this.f.set(ge,K),U.event}p(Q){switch(Q.type){case 100:case 102:{const V=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(V,Q.id,0,`${D(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const V=this.q([Q.type,Q.id]);this.j?.logOutgoing(V,Q.id,0,D(Q.type));return}}}q(Q,V=void 0){const _=new t;return h(_,Q),h(_,V),this.r(_.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const V=new g(Q),_=E(V),ge=E(V),ce=_[0];switch(ce){case 200:return this.j?.logIncoming(Q.byteLength,0,0,r(ce)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,_[1],0,r(ce),ge),this.t({type:_[0],id:_[1],data:ge})}}t(Q){if(Q.type===200){this.b=i.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===i.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$ec)(this.d.values()),this.d.clear()}}e.$dh=l,Ke([R.$5g],l.prototype,"onDidInitializePromise",null);class w{get connections(){const Q=[];return this.f.forEach(V=>Q.push(V)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new S.$ed,this.onDidAddConnection=this.g.event,this.h=new S.$ed,this.onDidRemoveConnection=this.h.event,this.j=new b.$ic,this.j.add(Q(({protocol:V,onDidClientDisconnect:_})=>{const ge=S.Event.once(V.onMessage);this.j.add(ge(ce=>{const we=new g(ce),G=E(we),U=new y(V,G),K=new l(V);this.a.forEach((se,re)=>U.registerChannel(re,se));const Y={channelServer:U,channelClient:K,ctx:G};this.f.add(Y),this.g.fire(Y),this.j.add(_(()=>{U.dispose(),K.dispose(),this.f.delete(Y),this.h.fire(Y)}))}))}))}getChannel(Q,V){const _=this;return{call(ge,ce,we){let G;if((0,p.$wf)(V)){const K=(0,C.$1b)(_.connections.filter(V));G=K?Promise.resolve(K):S.Event.toPromise(S.Event.filter(_.onDidAddConnection,V))}else G=V.routeCall(_,ge,ce);const U=G.then(K=>K.channelClient.getChannel(Q));return O(U).call(ge,ce,we)},listen(ge,ce){if((0,p.$wf)(V))return _.k(Q,V,ge,ce);const we=V.routeEvent(_,ge,ce).then(G=>G.channelClient.getChannel(Q));return O(we).listen(ge,ce)}}}k(Q,V,_,ge){const ce=this;let we;const G=new S.$ed({onWillAddFirstListener:()=>{we=new b.$ic;const U=new S.$kd,K=new Map,Y=re=>{const Ee=re.channelClient.getChannel(Q).listen(_,ge),he=U.add(Ee);K.set(re,he)},se=re=>{const le=K.get(re);le&&(le.dispose(),K.delete(re))};ce.connections.filter(V).forEach(Y),S.Event.filter(ce.onDidAddConnection,V)(Y,void 0,we),ce.onDidRemoveConnection(se,void 0,we),U.event(G.fire,G,we),we.add(U)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return G.event}registerChannel(Q,V){this.a.set(Q,V);for(const _ of this.f)_.channelServer.registerChannel(Q,V)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$eh=w;class A{constructor(Q,V,_=null){const ge=new t;h(ge,V),Q.send(ge.buffer),this.a=new l(Q,_),this.d=new y(Q,V,_)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,V){this.d.registerChannel(Q,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fh=A;function O(x){return{call(Q,V,_){return x.then(ge=>ge.call(Q,V,_))},listen(Q,V){const _=new S.$nd;return x.then(ge=>_.input=ge.listen(Q,V)),_.event}}}e.$gh=O;function N(x){let Q=!1;return{call(V,_,ge){return Q?x.call(V,_,ge):(0,F.$Gg)(0).then(()=>Q=!0).then(()=>x.call(V,_,ge))},listen(V,_){if(Q)return x.listen(V,_);const ge=new S.$nd;return(0,F.$Gg)(0).then(()=>Q=!0).then(()=>ge.input=x.listen(V,_)),ge.event}}}e.$hh=N;class T{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const V of Q.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await S.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$ih=T;var j;(function(x){function Q(ce,we,G){const U=ce,K=G&&G.disableMarshalling,Y=new Map;for(const se in U)_(se)&&Y.set(se,S.Event.buffer(U[se],!0,void 0,we));return new class{listen(se,re,le){const Ee=Y.get(re);if(Ee)return Ee;if(ge(re)){const he=U[re];if(typeof he=="function")return he.call(U,le)}throw new m.$_(`Event not found: ${re}`)}call(se,re,le){const Ee=U[re];if(typeof Ee=="function"){if(!K&&Array.isArray(le))for(let he=0;he<le.length;he++)le[he]=(0,P.$0g)(le[he]);return Ee.apply(U,le)}throw new m.$_(`Method not found: ${re}`)}}}x.fromService=Q;function V(ce,we){const G=we&&we.disableMarshalling;return new Proxy({},{get(U,K){if(typeof K=="string")return we?.properties?.has(K)?we.properties.get(K):ge(K)?function(Y){return ce.listen(K,Y)}:_(K)?ce.listen(K):async function(...Y){let se;we&&!(0,p.$rf)(we.context)?se=[we.context,...Y]:se=Y;const re=await ce.call(K,se);return G?re:(0,P.$0g)(re)};throw new m.$_(`Property not found: ${String(K)}`)}})}x.toService=V;function _(ce){return ce[0]==="o"&&ce[1]==="n"&&I.$Ke(ce.charCodeAt(2))}function ge(ce){return/^onDynamic/.test(ce)&&I.$Ke(ce.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Q=x.toString();if(Q!=="[object Object]")return Q}return x}function H(x){return Array.isArray(x)?x.map(M):M(x)}function q(x,Q,V,_,ge,ce,we){we=H(we);const G=z[ge],U=G[_%G.length];let K=[`%c[${x}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ce)?(K=K.concat(we),K.push(")")):K.push(we),console.log.apply(console,K)}class me{constructor(Q,V){this.d=Q,this.f=V,this.a=0,this.b=0}logOutgoing(Q,V,_,ge,ce){this.b+=Q,q(this.d,this.b,Q,V,_,ge,ce)}logIncoming(Q,V,_,ge,ce){this.a+=Q,q(this.f,this.a,Q,V,_,ge,ce)}}e.$jh=me}),define(De[81],Ce([1,0,22,4,3,80]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.ProtocolConstants=e.$kh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var m;(function(n){n.enableDiagnostics=!1,n.records=[];const c=new WeakMap;let h=0;function E(u,l){if(!c.has(u)){const w=String(++h);c.set(u,w)}return c.get(u)}function y(u,l,w,A){if(!n.enableDiagnostics)return;const O=E(u,l);if(A instanceof C.$Ed||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const N=C.$Ed.alloc(A.byteLength);N.set(A),n.records.push({timestamp:Date.now(),id:O,label:l,type:w,buff:N})}else n.records.push({timestamp:Date.now(),id:O,label:l,type:w,data:A})}n.traceSocketEvent=y})(m||(e.SocketDiagnostics=m={}));var S;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let b=null;function P(){return b||(b=C.$Ed.alloc(0)),b}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return P();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const l=this.a[0];return h&&(this.a.shift(),this.b-=c),l}if(this.a[0].byteLength>c){const l=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),l}const E=C.$Ed.alloc(c);let y=0,u=0;for(;c>0;){const l=this.a[u];if(l.byteLength>c){const w=l.slice(0,c);E.set(w,y),y+=c,h&&(this.a[u]=l.slice(c),this.b-=c),c-=c}else E.set(l,y),y+=l.byteLength,h?(this.a.shift(),this.b-=l.byteLength):u++,c-=l.byteLength}return E}}e.$kh=I;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function k(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class v{constructor(c,h,E,y){this.type=c,this.id=h,this.ack=E,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class r extends f.$jc{constructor(c){super(),this.f=this.B(new F.$ed),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new I,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const E=this.g.messageType,y=this.g.id,u=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new v(E,y,u,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class i{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=C.$Ed.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const E=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,E}h(){const c=C.$Ed.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class s extends f.$jc{constructor(c){super(),this.f=new F.$ed,this.onMessage=this.f.event,this.g=new F.$ed,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new i(this.a)),this.c=this.B(new r(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new v(1,0,0,c))}}e.$lh=s;class d extends L.$fh{static fromSocket(c,h){return new d(new s(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,E=null){super(c,h,E),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$mh=d;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$ed({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$nh=$;class g{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,E=this.a;for(;E;)c[h++]=E.data,E=E.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new g(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<o.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=o.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+o.a)*1e3;let E=0;for(let y=0;y<o.a;y++)c-this.c[y]<=h&&E++;return 1-E/o.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??o.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$ic,this.o=c.socket,this.p=this.r.add(new i(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new v(5,0,0,P());this.p.write(c),this.p.flush()}sendPause(){const c=new v(7,0,0,P());this.p.write(c)}sendResume(){const c=new v(8,0,0,P());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new f.$ic,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new i(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(E=>this.z(E))),this.r.add(this.o.onClose(E=>this.x.fire(E))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new v(3,0,this.h,P());this.p.write(c);const h=this.b.toArray();for(let E=0,y=h.length;E<y;E++)this.p.write(h[E]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new v(6,0,0,P())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let E=0,y=h.length;E<y;E++)this.p.write(h[E]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const E=new v(1,h,this.h,c);this.b.push(E),this.a||(this.p.write(E),this.B())}sendControl(c){const h=new v(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,E=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(h>=2e4&&E>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:E});return}const u=Math.max(2e4-h,2e4-E,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},u)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new v(3,0,this.h,P());this.p.write(c)}D(){this.h=this.g;const c=new v(9,0,this.h,P());this.p.write(c)}}e.$oh=a}),define(De[183],Ce([1,0,48,11,22,21,181,8,4,3,23,102,99,80]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class D extends k.$ch{constructor(i){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",s=>f.$Ed.wrap(Buffer.from(s,"base64")))},i),process.once("disconnect",()=>this.dispose())}}e.$Pp=D;class v{constructor(i,s){this.i=i,this.j=s,this.c=new Set,this.g=new Map,this.h=new S.$ed,this.onDidProcessExit=this.h.event;const d=s&&s.timeout?s.timeout:6e4;this.b=new F.$Cg(d),this.d=null,this.f=null}getChannel(i){const s=this;return{call(d,$,g){return s.k(i,d,$,g)},listen(d,$){return s.l(i,d,$)}}}k(i,s,d,$=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(m.$4());this.b.cancel();const g=this.n(i),t=(0,F.$tg)(n=>g.call(s,d,n)),o=$.onCancellationRequested(()=>t.cancel()),a=(0,b.$hc)(()=>t.cancel());return this.c.add(a),t.finally(()=>{o.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(i,s,d){if(!this.b)return S.Event.None;this.b.cancel();let $;const g=new S.$ed({onWillAddFirstListener:()=>{$=this.n(i).listen(s,d)(g.fire,g),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const i=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,P.$Um)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,p.$sl)(s.env),this.d=(0,C.fork)(this.i,i,s);const d=new S.$ed;S.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,R.$Lp)(c)){(0,R.log)(c,`IPC Library: ${this.j.serverName}`);return}d.fire(f.$Ed.wrap(Buffer.from(c,"base64")))});const g=this.j.useQueue?(0,I.$ul)(this.d):this.d,t=c=>this.d&&this.d.connected&&g.send(c.buffer.toString("base64")),o=d.event,a={send:t,onMessage:o};this.f=new k.$dh(a);const n=()=>this.o();process.once("exit",n),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,h)=>{process.removeListener("exit",n),this.c.forEach(E=>(0,b.$ec)(E)),this.c.clear(),c!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:h})})}return this.f}n(i){let s=this.g.get(i);return s||(s=this.m.getChannel(i),this.g.set(i,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Qp=v}),define(De[184],Ce([1,0,11,4,3,63,18]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.StorageState=e.$Oo=e.StorageHint=void 0;var m;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(m||(e.StorageHint=m={}));function S(p){const k=p;return k?.changed instanceof Map||k?.deleted instanceof Set}e.$Oo=S;var b;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(b||(e.StorageState=b={}));class P extends f.$jc{static{this.a=100}constructor(k,D=Object.create(null)){super(),this.r=k,this.s=D,this.b=this.B(new F.$hd),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new C.$Dg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((D,v)=>this.w(v,D)),k.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(k,D){if(this.c===b.Closed)return;let v=!1;(0,R.$rf)(D)?v=this.f.delete(k):this.f.get(k)!==D&&(this.f.set(k,D),v=!0),v&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==m.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,D){const v=this.f.get(k);return(0,R.$rf)(v)?D:v}getBoolean(k,D){const v=this.get(k);return(0,R.$rf)(v)?D:v==="true"}getNumber(k,D){const v=this.get(k);return(0,R.$rf)(v)?D:parseInt(v,10)}getObject(k,D){const v=this.get(k);return(0,R.$rf)(v)?D:(0,L.$9g)(v)}async set(k,D,v=!1){if(this.c===b.Closed)return;if((0,R.$rf)(D))return this.delete(k,v);const r=(0,R.$kf)(D)||Array.isArray(D)?(0,L.$8g)(D):String(D);if(this.f.get(k)!==r)return this.f.set(k,r),this.j.set(k,r),this.h.delete(k),this.b.fire({key:k,external:v}),this.D()}async delete(k,D=!1){if(!(this.c===b.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:D}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(this.z)return this.D(k)}async D(k){return this.s.hint===m.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===m.STORAGE_IN_MEMORY}}e.$Po=P;class I{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((D,v)=>this.a.set(v,D)),k.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$Qo=I}),define(De[185],Ce([1,0,35,16]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=void 0;function f(L,R,m,S,b,P){if(Array.isArray(L)){let I=0;for(const p of L){const k=f(p,R,m,S,b,P);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof L=="string")return S?L==="*"?5:L===m?10:0:0;if(L){const{language:I,pattern:p,scheme:k,hasAccessToAllModels:D,notebookType:v}=L;if(!S&&!D)return 0;v&&b&&(R=b);let r=0;if(k)if(k===R.scheme)r=10;else if(k==="*")r=5;else return 0;if(I)if(I===m)r=10;else if(I==="*")r=Math.max(r,5);else return 0;if(v)if(v===P)r=10;else if(v==="*"&&P!==void 0)r=Math.max(r,5);else return 0;if(p){let i;if(typeof p=="string"?i=p:i={...p,base:(0,F.$6d)(p.base)},i===R.fsPath||(0,C.$pj)(i,R.fsPath))r=10;else return 0}return r}else return 0}}e.$_E=f}),define(De[129],Ce([1,0,22,12]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0=e.$j0=void 0;var f;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(f||(f={}));function L(I){for(let p=0,k=I.length;p<k;p+=4){const D=I[p+0],v=I[p+1],r=I[p+2],i=I[p+3];I[p+0]=i,I[p+1]=r,I[p+2]=v,I[p+3]=D}}function R(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$C()||L(p),C.$Ed.wrap(p)}function m(I){const p=I.buffer;if(F.$C()||L(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const k=new Uint8Array(p.byteLength);return k.set(p),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function S(I){const p=new Uint32Array(b(I));let k=0;if(p[k++]=I.id,I.type==="full")p[k++]=1,p[k++]=I.data.length,p.set(I.data,k),k+=I.data.length;else{p[k++]=2,p[k++]=I.deltas.length;for(const D of I.deltas)p[k++]=D.start,p[k++]=D.deleteCount,D.data?(p[k++]=D.data.length,p.set(D.data,k),k+=D.data.length):p[k++]=0}return R(p)}e.$j0=S;function b(I){let p=0;if(p+=1+1,I.type==="full")p+=1+I.data.length;else{p+=1,p+=(1+1+1)*I.deltas.length;for(const k of I.deltas)k.data&&(p+=k.data.length)}return p}function P(I){const p=m(I);let k=0;const D=p[k++];if(p[k++]===1){const s=p[k++],d=p.subarray(k,k+s);return k+=s,{id:D,type:"full",data:d}}const r=p[k++],i=[];for(let s=0;s<r;s++){const d=p[k++],$=p[k++],g=p[k++];let t;g>0&&(t=p.subarray(k,k+g),k+=g),i[s]={start:d,deleteCount:$,data:t}}return{id:D,type:"delta",deltas:i}}e.$k0=P}),define(De[186],Ce([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,23,12,166,124,186]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(oe){this.c=oe}hasChanged(oe){return this.c[oe]}}e.ConfigurationChangedEvent=b;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class I{constructor(oe,Ie,qe,ze){this.id=oe,this.name=Ie,this.defaultValue=qe,this.schema=ze}applyUpdate(oe,Ie){return k(oe,Ie)}compute(oe,Ie,qe){return qe}}class p{constructor(oe,Ie){this.newValue=oe,this.didChange=Ie}}e.ApplyUpdateResult=p;function k(ae,oe){if(typeof ae!="object"||typeof oe!="object"||!ae||!oe)return new p(oe,ae!==oe);if(Array.isArray(ae)||Array.isArray(oe)){const qe=Array.isArray(ae)&&Array.isArray(oe)&&C.$sb(ae,oe);return new p(oe,!qe)}let Ie=!1;for(const qe in oe)if(oe.hasOwnProperty(qe)){const ze=k(ae[qe],oe[qe]);ze.didChange&&(ae[qe]=ze.newValue,Ie=!0)}return new p(ae,Ie)}class D{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Ie){return k(oe,Ie)}validate(oe){return this.defaultValue}}class v{constructor(oe,Ie,qe,ze){this.id=oe,this.name=Ie,this.defaultValue=qe,this.schema=ze}applyUpdate(oe,Ie){return k(oe,Ie)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Ie,qe){return qe}}function r(ae,oe){return typeof ae>"u"?oe:ae==="false"?!1:!!ae}e.boolean=r;class i extends v{constructor(oe,Ie,qe,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=qe),super(oe,Ie,qe,ze)}validate(oe){return r(oe,this.defaultValue)}}function s(ae,oe,Ie,qe){if(typeof ae>"u")return oe;let ze=parseInt(ae,10);return isNaN(ze)?oe:(ze=Math.max(Ie,ze),ze=Math.min(qe,ze),ze|0)}e.clampedInt=s;class d extends v{static clampedInt(oe,Ie,qe,ze){return s(oe,Ie,qe,ze)}constructor(oe,Ie,qe,ze,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=qe,nt.minimum=ze,nt.maximum=Ze),super(oe,Ie,qe,nt),this.minimum=ze,this.maximum=Ze}validate(oe){return d.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function $(ae,oe,Ie,qe){if(typeof ae>"u")return oe;const ze=g.float(ae,oe);return g.clamp(ze,Ie,qe)}e.clampedFloat=$;class g extends v{static clamp(oe,Ie,qe){return oe<Ie?Ie:oe>qe?qe:oe}static float(oe,Ie){if(typeof oe=="number")return oe;if(typeof oe>"u")return Ie;const qe=parseFloat(oe);return isNaN(qe)?Ie:qe}constructor(oe,Ie,qe,ze,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=qe),super(oe,Ie,qe,Ze),this.validationFn=ze}validate(oe){return this.validationFn(g.float(oe,this.defaultValue))}}class t extends v{static string(oe,Ie){return typeof oe!="string"?Ie:oe}constructor(oe,Ie,qe,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=qe),super(oe,Ie,qe,ze)}validate(oe){return t.string(oe,this.defaultValue)}}function o(ae,oe,Ie,qe){return typeof ae!="string"?oe:qe&&ae in qe?qe[ae]:Ie.indexOf(ae)===-1?oe:ae}e.stringSet=o;class a extends v{constructor(oe,Ie,qe,ze,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=ze,Ze.default=qe),super(oe,Ie,qe,Ze),this.c=ze}validate(oe){return o(oe,this.defaultValue,this.c)}}class n extends I{constructor(oe,Ie,qe,ze,Ze,nt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Ze,ot.default=ze),super(oe,Ie,qe,ot),this.c=Ze,this.d=nt}validate(oe){return typeof oe!="string"?this.defaultValue:this.c.indexOf(oe)===-1?this.defaultValue:this.d(oe)}}function c(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Ie,qe){return qe===0?oe.accessibilitySupport:qe}}class E extends I{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:m.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{insertSpace:r(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function u(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(l||(e.TextEditorCursorStyle=l={}));function w(ae){switch(ae){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function A(ae){switch(ae){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class O extends D{constructor(){super(140)}compute(oe,Ie,qe){const ze=["monaco-editor"];return Ie.get(39)&&ze.push(Ie.get(39)),oe.extraEditorClassName&&ze.push(oe.extraEditorClassName),Ie.get(73)==="default"?ze.push("mouse-default"):Ie.get(73)==="copy"&&ze.push("mouse-copy"),Ie.get(110)&&ze.push("showUnused"),Ie.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class N extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(oe,Ie,qe){return qe&&oe.emptySelectionClipboard}}class T extends I{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:m.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:m.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{cursorMoveOnType:r(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":o(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":o(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(Ie.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?j.OFF:oe==="true"?j.ON:oe:oe?j.ON:j.OFF}}e.EditorFontLigatures=j;class z extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?z.OFF:oe==="true"?z.TRANSLATE:oe:oe?z.TRANSLATE:z.OFF}compute(oe,Ie,qe){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class M extends D{constructor(){super(50)}compute(oe,Ie,qe){return oe.fontInfo}}class H extends v{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(oe){const Ie=g.float(oe,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(Ie,6,100)}compute(oe,Ie,qe){return oe.fontInfo.fontSize}}class q extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.d,maximum:q.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(d.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,q.d,q.e))}}class me extends I{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:qe,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:qe,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:qe,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:qe,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:qe,description:m.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{multiple:o(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??o(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??o(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??o(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??o(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??o(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends I{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:m.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),delay:d.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:r(Ie.sticky,this.defaultValue.sticky),hidingDelay:d.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:r(Ie.above,this.defaultValue.above)}}}var Q;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class V extends D{constructor(){super(143)}compute(oe,Ie,qe){return V.computeLayout(Ie,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const Ie=oe.height/oe.lineHeight,qe=Math.floor(oe.paddingTop/oe.lineHeight);let ze=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(ze=Math.max(ze,Ie-1));const Ze=(qe+oe.viewLineCount+ze)/(oe.pixelRatio*oe.height),nt=Math.floor(oe.viewLineCount/Ze);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:ze,desiredRatio:Ze,minimapLineCount:nt}}static c(oe,Ie){const qe=oe.outerWidth,ze=oe.outerHeight,Ze=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const nt=Ie.stableMinimapLayoutInput,ot=nt&&oe.outerHeight===nt.outerHeight&&oe.lineHeight===nt.lineHeight&&oe.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&oe.pixelRatio===nt.pixelRatio&&oe.scrollBeyondLastLine===nt.scrollBeyondLastLine&&oe.paddingTop===nt.paddingTop&&oe.paddingBottom===nt.paddingBottom&&oe.minimap.enabled===nt.minimap.enabled&&oe.minimap.side===nt.minimap.side&&oe.minimap.size===nt.minimap.size&&oe.minimap.showSlider===nt.minimap.showSlider&&oe.minimap.renderCharacters===nt.minimap.renderCharacters&&oe.minimap.maxColumn===nt.minimap.maxColumn&&oe.minimap.scale===nt.minimap.scale&&oe.verticalScrollbarWidth===nt.verticalScrollbarWidth&&oe.isViewportWrapping===nt.isViewportWrapping,bt=oe.lineHeight,Dt=oe.typicalHalfwidthCharacterWidth,Xt=oe.scrollBeyondLastLine,Vt=oe.minimap.renderCharacters;let vt=Ze>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const Ft=oe.minimap.maxColumn,Ot=oe.minimap.size,Kt=oe.minimap.side,At=oe.verticalScrollbarWidth,Rt=oe.viewLineCount,Nt=oe.remainingWidth,Ut=oe.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Ze*ze);const ct=Bt/Ze;let lt=!1,Jt=!1,Pt=qt*vt,kt=vt/Ze,dt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:Se,extraLinesBeyondLastLine:ie,desiredRatio:Me,minimapLineCount:He}=V.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Xt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:ze,lineHeight:bt,pixelRatio:Ze});if(Rt/He>1)lt=!0,Jt=!0,vt=1,Pt=1,kt=vt/Ze;else{let Je=!1,rt=vt+1;if(Ot==="fit"){const pt=Math.ceil((Se+Rt+ie)*Pt);Ut&&ot&&Nt<=Ie.stableFitRemainingWidth?(Je=!0,rt=Ie.stableFitMaxMinimapScale):Je=pt>Bt}if(Ot==="fill"||Je){lt=!0;const pt=vt;Pt=Math.min(bt*Ze,Math.max(1,Math.floor(1/Me))),Ut&&ot&&Nt<=Ie.stableFitRemainingWidth&&(rt=Ie.stableFitMaxMinimapScale),vt=Math.min(rt,Math.max(1,Math.floor(Pt/qt))),vt>pt&&(dt=Math.min(2,vt/pt)),kt=vt/Ze/dt,Bt=Math.ceil(Math.max(Fe,Se+Rt+ie)*Pt),Ut?(Ie.stableMinimapLayoutInput=oe,Ie.stableFitRemainingWidth=Nt,Ie.stableFitMaxMinimapScale=vt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Ct=Math.floor(Ft*kt),Mt=Math.min(Ct,Math.max(0,Math.floor((Nt-At-2)*kt/(Dt+kt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Ze*Mt);const Ge=Et/Ze;Et=Math.floor(Et*dt);const jt=Vt?1:2,Te=Kt==="left"?0:qe-Mt-At;return{renderMinimap:jt,minimapLeft:Te,minimapWidth:Mt,minimapHeightIsEditorHeight:lt,minimapIsSampling:Jt,minimapScale:vt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:Ge,minimapCanvasOuterHeight:ct}}static computeLayout(oe,Ie){const qe=Ie.outerWidth|0,ze=Ie.outerHeight|0,Ze=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Dt=Ie.pixelRatio,Xt=Ie.viewLineCount,Vt=oe.get(135),vt=Vt==="inherit"?oe.get(134):Vt,Ft=vt==="inherit"?oe.get(130):vt,Ot=oe.get(133),Kt=Ie.isDominatedByLongLines,At=oe.get(57),Rt=oe.get(67).renderType!==0,Nt=oe.get(68),Ut=oe.get(104),qt=oe.get(83),Bt=oe.get(72),ct=oe.get(102),lt=ct.verticalScrollbarSize,Jt=ct.verticalHasArrows,Pt=ct.arrowSize,kt=ct.horizontalScrollbarSize,dt=oe.get(43),Ct=oe.get(109)!=="never";let Mt=oe.get(65);dt&&Ct&&(Mt+=16);let Et=0;if(Rt){const ft=Math.max(nt,Nt);Et=Math.round(ft*bt)}let Ge=0;At&&(Ge=Ze*Ie.glyphMarginDecorationLaneCount);let jt=0,Te=jt+Ge,Fe=Te+Et,Se=Fe+Mt;const ie=qe-Ge-Et-Mt;let Me=!1,He=!1,_e=-1;vt==="inherit"&&Kt?(Me=!0,He=!0):Ft==="on"||Ft==="bounded"?He=!0:Ft==="wordWrapColumn"&&(_e=Ot);const Je=V.c({outerWidth:qe,outerHeight:ze,lineHeight:Ze,typicalHalfwidthCharacterWidth:ot,pixelRatio:Dt,scrollBeyondLastLine:Ut,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:lt,viewLineCount:Xt,remainingWidth:ie,isViewportWrapping:He},Ie.memory||new P);Je.renderMinimap!==0&&Je.minimapLeft===0&&(jt+=Je.minimapWidth,Te+=Je.minimapWidth,Fe+=Je.minimapWidth,Se+=Je.minimapWidth);const rt=ie-Je.minimapWidth,pt=Math.max(1,Math.floor((rt-lt-2)/ot)),wt=Jt?Pt:0;return He&&(_e=Math.max(1,pt),Ft==="bounded"&&(_e=Math.min(_e,Ot))),{width:qe,height:ze,glyphMarginLeft:jt,glyphMarginWidth:Ge,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Te,lineNumbersWidth:Et,decorationsLeft:Fe,decorationsWidth:Mt,contentLeft:Se,contentWidth:rt,minimap:Je,viewportColumn:pt,isWordWrapMinified:Me,isViewportWrapping:He,wrappingColumn:_e,verticalScrollbarWidth:lt,horizontalScrollbarHeight:kt,overviewRuler:{top:wt,width:lt,height:ze-2*wt,right:0}}}}e.EditorLayoutInfoComputer=V;class _ extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(oe){return o(oe,"simple",["simple","advanced"])}compute(oe,Ie,qe){return Ie.get(2)===2?"advanced":qe}}class ge extends I{constructor(){const oe={enabled:!0};super(64,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:m.localize(50,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:r(oe.enabled,this.defaultValue.enabled)}}}class ce extends I{constructor(){const oe={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:m.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:10,description:m.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:m.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:m.localize(54,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),maxLineCount:d.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:o(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:r(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends I{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:m.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(56,null),m.localize(57,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(58,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:m.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:m.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:m.localize(62,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:o(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:d.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:r(Ie.padding,this.defaultValue.padding)}}}class G extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):d.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,Ie,qe){return qe<0?d.clampedInt(-qe*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class U extends g{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>g.clamp(oe,0,150),{markdownDescription:m.localize(63,null)})}compute(oe,Ie,qe){return oe.fontInfo.lineHeight}}class K extends I{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:m.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:m.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:oe.size,description:m.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:m.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:m.localize(71,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:m.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:m.localize(74,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),autohide:r(Ie.autohide,this.defaultValue.autohide),size:o(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(Ie.side,this.defaultValue.side,["right","left"]),showSlider:o(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(Ie.scale,1,1,3),maxColumn:d.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(ae){return ae==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class se extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(76,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{top:d.clampedInt(Ie.top,0,0,1e3),bottom:d.clampedInt(Ie.bottom,0,0,1e3)}}}class re extends I{constructor(){const oe={enabled:!0,cycle:!0};super(85,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:m.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:m.localize(78,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),cycle:r(Ie.cycle,this.defaultValue.cycle)}}}class le extends D{constructor(){super(141)}compute(oe,Ie,qe){return oe.pixelRatio}}class Ee extends I{constructor(){const oe={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(79,null),m.localize(80,null),m.localize(81,null)]}];super(88,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:oe.strings,description:m.localize(82,null)},comments:{anyOf:Ie,default:oe.comments,description:m.localize(83,null)},other:{anyOf:Ie,default:oe.other,description:m.localize(84,null)}},default:oe,markdownDescription:m.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const Dt=oe?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:ze}=oe,Ze=["on","inline","off"];let nt,ot,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=o(Ie,this.defaultValue.other,Ze),typeof qe=="boolean"?ot=qe?"on":"off":ot=o(qe,this.defaultValue.comments,Ze),typeof ze=="boolean"?bt=ze?"on":"off":bt=o(ze,this.defaultValue.strings,Ze),{other:nt,comments:ot,strings:bt}}}var he;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(he||(e.RenderLineNumbersType=he={}));class fe extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(86,null),m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:"on",description:m.localize(90,null)})}validate(oe){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Ie=4,qe=oe):oe==="interval"?Ie=3:oe==="relative"?Ie=2:oe==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function te(ae){const oe=ae.get(97);return oe==="editable"?ae.get(90):oe!=="on"}e.filterValidationDecorations=te;class ue extends I{constructor(){const oe=[],Ie={type:"number",description:m.localize(91,null)};super(101,"rulers",oe,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:m.localize(92,null),format:"color-hex"}}}]},default:oe,description:m.localize(93,null)})}validate(oe){if(Array.isArray(oe)){const Ie=[];for(const qe of oe)if(typeof qe=="number")Ie.push({column:d.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const ze=qe;Ie.push({column:d.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ie.sort((qe,ze)=>qe.column-ze.column),Ie}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Pe(ae,oe){if(typeof ae!="string")return oe;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:"auto",description:m.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:m.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:m.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:m.localize(104,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe,qe=d.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=d.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:r(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:d.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:d.clampedInt(Ie.verticalSliderSize,ze,0,1e3),scrollByPage:r(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends I{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:m.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:m.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:m.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:m.localize(111,null)}})}applyUpdate(oe,Ie){let qe=!1;Ie.allowedCharacters&&oe&&(F.$Ym(oe.allowedCharacters,Ie.allowedCharacters)||(oe={...oe,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&oe&&(F.$Ym(oe.allowedLocales,Ie.allowedLocales)||(oe={...oe,allowedLocales:Ie.allowedLocales},qe=!0));const ze=super.applyUpdate(oe,Ie);return qe?new p(ze.newValue,!0):ze}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{nonBasicASCII:de(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(oe.allowedLocales,this.defaultValue.allowedLocales)}}c(oe,Ie){if(typeof oe!="object"||!oe)return Ie;const qe={};for(const[ze,Ze]of Object.entries(oe))Ze===!0&&(qe[ze]=!0);return qe}}class ee extends I{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:m.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(113,null),m.localize(114,null)],description:m.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:m.localize(116,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),mode:o(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:o(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:r(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ne extends I{constructor(){const oe={enabled:L.$Sr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Sr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:m.localize(118,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends I{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(119,null),m.localize(120,null),m.localize(121,null)],default:oe.bracketPairs,description:m.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(123,null),m.localize(124,null),m.localize(125,null)],default:oe.bracketPairsHorizontal,description:m.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:m.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:m.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:oe.highlightActiveIndentation,description:m.localize(132,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{bracketPairs:de(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ae,oe,Ie){const qe=Ie.indexOf(ae);return qe===-1?oe:Ie[qe]}class ye extends I{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(133,null),m.localize(134,null)],default:oe.insertMode,description:m.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:m.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:m.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:m.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null),m.localize(142,null)],default:oe.selectionMode,markdownDescription:m.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:m.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:m.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:m.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:m.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:m.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{insertMode:o(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:o(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:r(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:r(Ie.preview,this.defaultValue.preview),previewMode:o(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(Ie.showMethods,this.defaultValue.showMethods),showFunctions:r(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:r(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(Ie.showFields,this.defaultValue.showFields),showVariables:r(Ie.showVariables,this.defaultValue.showVariables),showClasses:r(Ie.showClasses,this.defaultValue.showClasses),showStructs:r(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:r(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:r(Ie.showModules,this.defaultValue.showModules),showProperties:r(Ie.showProperties,this.defaultValue.showProperties),showEvents:r(Ie.showEvents,this.defaultValue.showEvents),showOperators:r(Ie.showOperators,this.defaultValue.showOperators),showUnits:r(Ie.showUnits,this.defaultValue.showUnits),showValues:r(Ie.showValues,this.defaultValue.showValues),showConstants:r(Ie.showConstants,this.defaultValue.showConstants),showEnums:r(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:r(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(Ie.showKeywords,this.defaultValue.showKeywords),showWords:r(Ie.showWords,this.defaultValue.showWords),showColors:r(Ie.showColors,this.defaultValue.showColors),showFiles:r(Ie.showFiles,this.defaultValue.showFiles),showReferences:r(Ie.showReferences,this.defaultValue.showReferences),showFolders:r(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:r(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:r(Ie.showUsers,this.defaultValue.showUsers),showIssues:r(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(182,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class xe extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(183,null),m.localize(184,null),m.localize(185,null),m.localize(186,null)],description:m.localize(187,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Ie,qe){return Ie.get(2)===2?0:qe}}class Qe extends D{constructor(){super(144)}compute(oe,Ie,qe){const ze=Ie.get(143);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class it extends I{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(190,null),m.localize(191,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),showDropSelector:o(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(194,null),m.localize(195,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),showPasteSelector:o(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?Oe:f.$k?Ve:Ae,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Xe;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.letterSpacing=63]="letterSpacing",ae[ae.lightbulb=64]="lightbulb",ae[ae.lineDecorationsWidth=65]="lineDecorationsWidth",ae[ae.lineHeight=66]="lineHeight",ae[ae.lineNumbers=67]="lineNumbers",ae[ae.lineNumbersMinChars=68]="lineNumbersMinChars",ae[ae.linkedEditing=69]="linkedEditing",ae[ae.links=70]="links",ae[ae.matchBrackets=71]="matchBrackets",ae[ae.minimap=72]="minimap",ae[ae.mouseStyle=73]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=75]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=77]="multiCursorModifier",ae[ae.multiCursorPaste=78]="multiCursorPaste",ae[ae.multiCursorLimit=79]="multiCursorLimit",ae[ae.occurrencesHighlight=80]="occurrencesHighlight",ae[ae.overviewRulerBorder=81]="overviewRulerBorder",ae[ae.overviewRulerLanes=82]="overviewRulerLanes",ae[ae.padding=83]="padding",ae[ae.pasteAs=84]="pasteAs",ae[ae.parameterHints=85]="parameterHints",ae[ae.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=88]="quickSuggestions",ae[ae.quickSuggestionsDelay=89]="quickSuggestionsDelay",ae[ae.readOnly=90]="readOnly",ae[ae.readOnlyMessage=91]="readOnlyMessage",ae[ae.renameOnType=92]="renameOnType",ae[ae.renderControlCharacters=93]="renderControlCharacters",ae[ae.renderFinalNewline=94]="renderFinalNewline",ae[ae.renderLineHighlight=95]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=97]="renderValidationDecorations",ae[ae.renderWhitespace=98]="renderWhitespace",ae[ae.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ae[ae.roundedSelection=100]="roundedSelection",ae[ae.rulers=101]="rulers",ae[ae.scrollbar=102]="scrollbar",ae[ae.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=104]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=105]="scrollPredominantAxis",ae[ae.selectionClipboard=106]="selectionClipboard",ae[ae.selectionHighlight=107]="selectionHighlight",ae[ae.selectOnLineNumbers=108]="selectOnLineNumbers",ae[ae.showFoldingControls=109]="showFoldingControls",ae[ae.showUnused=110]="showUnused",ae[ae.snippetSuggestions=111]="snippetSuggestions",ae[ae.smartSelect=112]="smartSelect",ae[ae.smoothScrolling=113]="smoothScrolling",ae[ae.stickyScroll=114]="stickyScroll",ae[ae.stickyTabStops=115]="stickyTabStops",ae[ae.stopRenderingLineAfter=116]="stopRenderingLineAfter",ae[ae.suggest=117]="suggest",ae[ae.suggestFontSize=118]="suggestFontSize",ae[ae.suggestLineHeight=119]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ae[ae.suggestSelection=121]="suggestSelection",ae[ae.tabCompletion=122]="tabCompletion",ae[ae.tabIndex=123]="tabIndex",ae[ae.unicodeHighlighting=124]="unicodeHighlighting",ae[ae.unusualLineTerminators=125]="unusualLineTerminators",ae[ae.useShadowDOM=126]="useShadowDOM",ae[ae.useTabStops=127]="useTabStops",ae[ae.wordBreak=128]="wordBreak",ae[ae.wordSeparators=129]="wordSeparators",ae[ae.wordWrap=130]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=133]="wordWrapColumn",ae[ae.wordWrapOverride1=134]="wordWrapOverride1",ae[ae.wordWrapOverride2=135]="wordWrapOverride2",ae[ae.wrappingIndent=136]="wrappingIndent",ae[ae.wrappingStrategy=137]="wrappingStrategy",ae[ae.showDeprecated=138]="showDeprecated",ae[ae.inlayHints=139]="inlayHints",ae[ae.editorClassName=140]="editorClassName",ae[ae.pixelRatio=141]="pixelRatio",ae[ae.tabFocusMode=142]="tabFocusMode",ae[ae.layoutInfo=143]="layoutInfo",ae[ae.wrappingInfo=144]="wrappingInfo",ae[ae.defaultColorDecorators=145]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(196,null)})),acceptSuggestionOnEnter:Le(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(197,null),""],markdownDescription:m.localize(198,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new d(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",m.localize(200,null))),ariaRequired:Le(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(202,null),m.localize(203,null),""],description:m.localize(204,null)})),autoClosingComments:Le(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(205,null),m.localize(206,null),""],description:m.localize(207,null)})),autoClosingDelete:Le(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(208,null),""],description:m.localize(209,null)})),autoClosingOvertype:Le(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(210,null),""],description:m.localize(211,null)})),autoClosingQuotes:Le(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(212,null),m.localize(213,null),""],description:m.localize(214,null)})),autoIndent:Le(new n(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[m.localize(215,null),m.localize(216,null),m.localize(217,null),m.localize(218,null),m.localize(219,null)],description:m.localize(220,null)})),automaticLayout:Le(new i(13,"automaticLayout",!1)),autoSurround:Le(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),""],description:m.localize(224,null)})),bracketPairColorization:Le(new ne),bracketPairGuides:Le(new Z),stickyTabStops:Le(new i(115,"stickyTabStops",!1,{description:m.localize(225,null)})),codeLens:Le(new i(17,"codeLens",!0,{description:m.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:m.localize(227,null)})),codeLensFontSize:Le(new d(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(228,null)})),colorDecorators:Le(new i(20,"colorDecorators",!0,{description:m.localize(229,null)})),colorDecoratorActivatedOn:Le(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),colorDecoratorsLimit:Le(new d(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(234,null)})),columnSelection:Le(new i(22,"columnSelection",!1,{description:m.localize(235,null)})),comments:Le(new E),contextmenu:Le(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new i(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(236,null)})),cursorBlinking:Le(new n(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:m.localize(237,null)})),cursorSmoothCaretAnimation:Le(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(238,null),m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),cursorStyle:Le(new n(28,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:m.localize(242,null)})),cursorSurroundingLines:Le(new d(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(243,null)})),cursorSurroundingLinesStyle:Le(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(244,null),m.localize(245,null)],markdownDescription:m.localize(246,null)})),cursorWidth:Le(new d(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(247,null)})),disableLayerHinting:Le(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new i(34,"domReadOnly",!1)),dragAndDrop:Le(new i(35,"dragAndDrop",!0,{description:m.localize(248,null)})),emptySelectionClipboard:Le(new N),dropIntoEditor:Le(new it),stickyScroll:Le(new ce),experimentalWhitespaceRendering:Le(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(249,null),m.localize(250,null),m.localize(251,null)],description:m.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new g(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:m.localize(253,null)})),find:Le(new T),fixedOverflowWidgets:Le(new i(42,"fixedOverflowWidgets",!1)),folding:Le(new i(43,"folding",!0,{description:m.localize(254,null)})),foldingStrategy:Le(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),foldingHighlight:Le(new i(45,"foldingHighlight",!0,{description:m.localize(258,null)})),foldingImportsByDefault:Le(new i(46,"foldingImportsByDefault",!1,{description:m.localize(259,null)})),foldingMaximumRegions:Le(new d(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(262,null)})),fontInfo:Le(new M),fontLigatures2:Le(new j),fontSize:Le(new H),fontWeight:Le(new q),fontVariations:Le(new z),formatOnPaste:Le(new i(55,"formatOnPaste",!1,{description:m.localize(263,null)})),formatOnType:Le(new i(56,"formatOnType",!1,{description:m.localize(264,null)})),glyphMargin:Le(new i(57,"glyphMargin",!0,{description:m.localize(265,null)})),gotoLocation:Le(new me),hideCursorInOverviewRuler:Le(new i(59,"hideCursorInOverviewRuler",!1,{description:m.localize(266,null)})),hover:Le(new x),inDiffEditor:Le(new i(61,"inDiffEditor",!1)),letterSpacing:Le(new g(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>g.clamp(ae,-5,20),{description:m.localize(267,null)})),lightbulb:Le(new ge),lineDecorationsWidth:Le(new G),lineHeight:Le(new U),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new d(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new i(69,"linkedEditing",!1,{description:m.localize(268,null)})),links:Le(new i(70,"links",!0,{description:m.localize(269,null)})),matchBrackets:Le(new a(71,"matchBrackets","always",["always","near","never"],{description:m.localize(270,null)})),minimap:Le(new K),mouseStyle:Le(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new g(74,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:m.localize(271,null)})),mouseWheelZoom:Le(new i(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(272,null)})),multiCursorMergeOverlapping:Le(new i(76,"multiCursorMergeOverlapping",!0,{description:m.localize(273,null)})),multiCursorModifier:Le(new n(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[m.localize(274,null),m.localize(275,null)],markdownDescription:m.localize(276,null)})),multiCursorPaste:Le(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(277,null),m.localize(278,null)],markdownDescription:m.localize(279,null)})),multiCursorLimit:Le(new d(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(280,null)})),occurrencesHighlight:Le(new i(80,"occurrencesHighlight",!0,{description:m.localize(281,null)})),overviewRulerBorder:Le(new i(81,"overviewRulerBorder",!0,{description:m.localize(282,null)})),overviewRulerLanes:Le(new d(82,"overviewRulerLanes",3,0,3)),padding:Le(new se),pasteAs:Le(new et),parameterHints:Le(new re),peekWidgetDefaultFocus:Le(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(283,null),m.localize(284,null)],description:m.localize(285,null)})),definitionLinkOpensInPeek:Le(new i(87,"definitionLinkOpensInPeek",!1,{description:m.localize(286,null)})),quickSuggestions:Le(new Ee),quickSuggestionsDelay:Le(new d(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(287,null)})),readOnly:Le(new i(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new i(92,"renameOnType",!1,{description:m.localize(288,null),markdownDeprecationMessage:m.localize(289,null)})),renderControlCharacters:Le(new i(93,"renderControlCharacters",!0,{description:m.localize(290,null),restricted:!0})),renderFinalNewline:Le(new a(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(291,null)})),renderLineHighlight:Le(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(292,null)],description:m.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(294,null)})),renderValidationDecorations:Le(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(295,null),m.localize(296,null),m.localize(297,null),""],description:m.localize(298,null)})),revealHorizontalRightPadding:Le(new d(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new i(100,"roundedSelection",!0,{description:m.localize(299,null)})),rulers:Le(new ue),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new d(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(300,null)})),scrollBeyondLastLine:Le(new i(104,"scrollBeyondLastLine",!0,{description:m.localize(301,null)})),scrollPredominantAxis:Le(new i(105,"scrollPredominantAxis",!0,{description:m.localize(302,null)})),selectionClipboard:Le(new i(106,"selectionClipboard",!0,{description:m.localize(303,null),included:f.$k})),selectionHighlight:Le(new i(107,"selectionHighlight",!0,{description:m.localize(304,null)})),selectOnLineNumbers:Le(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(305,null),m.localize(306,null),m.localize(307,null)],description:m.localize(308,null)})),showUnused:Le(new i(110,"showUnused",!0,{description:m.localize(309,null)})),showDeprecated:Le(new i(138,"showDeprecated",!0,{description:m.localize(310,null)})),inlayHints:Le(new we),snippetSuggestions:Le(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(311,null),m.localize(312,null),m.localize(313,null),m.localize(314,null)],description:m.localize(315,null)})),smartSelect:Le(new je),smoothScrolling:Le(new i(113,"smoothScrolling",!1,{description:m.localize(316,null)})),stopRenderingLineAfter:Le(new d(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new ee),inlineCompletionsAccessibilityVerbose:Le(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(317,null)})),suggestFontSize:Le(new d(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new d(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new i(120,"suggestOnTriggerCharacters",!0,{description:m.localize(320,null)})),suggestSelection:Le(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),tabCompletion:Le(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(325,null),m.localize(326,null),m.localize(327,null)],description:m.localize(328,null)})),tabIndex:Le(new d(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new X),unusualLineTerminators:Le(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),useShadowDOM:Le(new i(126,"useShadowDOM",!0)),useTabStops:Le(new i(127,"useTabStops",!0,{description:m.localize(333,null)})),wordBreak:Le(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(334,null),m.localize(335,null)],description:m.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",R.$Tr,{description:m.localize(337,null)})),wordWrap:Le(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null),m.localize(341,null)],description:m.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new d(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(343,null)})),wordWrapOverride1:Le(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new O),defaultColorDecorators:Le(new i(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(344,null)})),pixelRatio:Le(new le),tabFocusMode:Le(new i(142,"tabFocusMode",!1,{markdownDescription:m.localize(345,null)})),layoutInfo:Le(new V),wrappingInfo:Le(new Qe),wrappingIndent:Le(new xe),wrappingStrategy:Le(new _)}}),define(De[187],Ce([9,10]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[82],Ce([1,0,78,2,164,34,174,187]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$_s=e.$$s=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$0s=e.$9s=e.SymbolKinds=e.SymbolTag=e.$8s=e.$7s=e.SymbolKind=e.$6s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$5s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$4s=e.$3s=e.$2s=void 0;class S{constructor(j,z,M){this.offset=j,this.type=z,this.language=M,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$2s=S;class b{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}e.$3s=b;class P{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}e.$4s=P;var I;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var p;(function(T){const j=new Map;j.set(0,C.$Oj.symbolMethod),j.set(1,C.$Oj.symbolFunction),j.set(2,C.$Oj.symbolConstructor),j.set(3,C.$Oj.symbolField),j.set(4,C.$Oj.symbolVariable),j.set(5,C.$Oj.symbolClass),j.set(6,C.$Oj.symbolStruct),j.set(7,C.$Oj.symbolInterface),j.set(8,C.$Oj.symbolModule),j.set(9,C.$Oj.symbolProperty),j.set(10,C.$Oj.symbolEvent),j.set(11,C.$Oj.symbolOperator),j.set(12,C.$Oj.symbolUnit),j.set(13,C.$Oj.symbolValue),j.set(15,C.$Oj.symbolEnum),j.set(14,C.$Oj.symbolConstant),j.set(15,C.$Oj.symbolEnum),j.set(16,C.$Oj.symbolEnumMember),j.set(17,C.$Oj.symbolKeyword),j.set(27,C.$Oj.symbolSnippet),j.set(18,C.$Oj.symbolText),j.set(19,C.$Oj.symbolColor),j.set(20,C.$Oj.symbolFile),j.set(21,C.$Oj.symbolReference),j.set(22,C.$Oj.symbolCustomColor),j.set(23,C.$Oj.symbolFolder),j.set(24,C.$Oj.symbolTypeParameter),j.set(25,C.$Oj.account),j.set(26,C.$Oj.issues);function z(q){let me=j.get(q);return me||(console.info("No codicon found for CompletionItemKind "+q),me=C.$Oj.symbolProperty),me}T.toIcon=z;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function H(q,me){let x=M.get(q);return typeof x>"u"&&!me&&(x=9),x}T.fromString=H})(p||(e.CompletionItemKinds=p={}));var k;(function(T){T[T.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var D;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var v;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(e.CompletionTriggerKind=v={}));var r;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(r||(e.InlineCompletionTriggerKind=r={}));class i{constructor(j,z,M,H){this.range=j,this.text=z,this.completionKind=M,this.isSnippetText=H}equals(j){return L.$is.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$5s=i;var s;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var d;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(d||(e.SignatureHelpTriggerKind=d={}));var $;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})($||(e.DocumentHighlightKind=$={}));function g(T){return T&&F.URI.isUri(T.uri)&&L.$is.isIRange(T.range)&&(L.$is.isIRange(T.originSelectionRange)||L.$is.isIRange(T.targetSelectionRange))}e.$6s=g;var t;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$7s={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function o(T,j){return(0,m.localize)(26,null,T,e.$7s[j])}e.$8s=o;var a;(function(T){T[T.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var n;(function(T){const j=new Map;j.set(0,C.$Oj.symbolFile),j.set(1,C.$Oj.symbolModule),j.set(2,C.$Oj.symbolNamespace),j.set(3,C.$Oj.symbolPackage),j.set(4,C.$Oj.symbolClass),j.set(5,C.$Oj.symbolMethod),j.set(6,C.$Oj.symbolProperty),j.set(7,C.$Oj.symbolField),j.set(8,C.$Oj.symbolConstructor),j.set(9,C.$Oj.symbolEnum),j.set(10,C.$Oj.symbolInterface),j.set(11,C.$Oj.symbolFunction),j.set(12,C.$Oj.symbolVariable),j.set(13,C.$Oj.symbolConstant),j.set(14,C.$Oj.symbolString),j.set(15,C.$Oj.symbolNumber),j.set(16,C.$Oj.symbolBoolean),j.set(17,C.$Oj.symbolArray),j.set(18,C.$Oj.symbolObject),j.set(19,C.$Oj.symbolKey),j.set(20,C.$Oj.symbolNull),j.set(21,C.$Oj.symbolEnumMember),j.set(22,C.$Oj.symbolStruct),j.set(23,C.$Oj.symbolEvent),j.set(24,C.$Oj.symbolOperator),j.set(25,C.$Oj.symbolTypeParameter);function z(M){let H=j.get(M);return H||(console.info("No codicon found for SymbolKind "+M),H=C.$Oj.symbolProperty),H}T.toIcon=z})(n||(e.SymbolKinds=n={}));class c{static asEditOperation(j){return f.$js.replace(L.$is.lift(j.range),j.text)}}e.$9s=c;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(j){switch(j){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(j)}constructor(j){this.value=j}}e.$0s=h;var E;(function(T){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}T.is=j})(E||(e.Command=E={}));var y;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var u;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(u||(e.CommentThreadState=u={}));var l;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var w;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(w||(e.CommentState=w={}));var A;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(A||(e.InlayHintKind=A={}));class O{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$$s=O,e.$_s=new R.$Ts;var N;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(De[188],Ce([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([9,10]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([9,10]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[196],Ce([9,10]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[197],Ce([9,10]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([9,10]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[204],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[205],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[206],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[207],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[208],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[209],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[210],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[211],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[212],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[213],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[214],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[215],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[216],Ce([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[217],Ce([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[218],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[219],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[220],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[221],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[222],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[223],Ce([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[224],Ce([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[225],Ce([9,10]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[226],Ce([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[227],Ce([1,0,8,190]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var f;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(f||(e.TokenType=f={}));function L(...b){switch(b.length){case 1:return(0,F.localize)(0,null,b[0]);case 2:return(0,F.localize)(1,null,b[0],b[1]);case 3:return(0,F.localize)(2,null,b[0],b[1],b[2]);default:return}}const R=(0,F.localize)(3,null),m=(0,F.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,C.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,p=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:P}),this.f.push(k)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),p=S.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,p=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(m);return}const D=this.c.charCodeAt(P);if(I)I=!1;else if(D===47&&!p){P++;break}else D===91?p=!0:D===92?I=!0:D===93&&(p=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=S}),define(De[228],Ce([1,0,24,38,193,371]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function S(i){return i=i.trim(),i==="*"||R.test(i)}e.$Ao=S;function b(i){if(!S(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=i.match(R);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}e.$Bo=b;function P(i){if(!i)return null;const s=i.majorBase,d=i.majorMustEqual,$=i.minorBase;let g=i.minorMustEqual;const t=i.patchBase;let o=i.patchMustEqual;i.hasCaret&&(s===0||(g=!1),o=!1);let a=0;if(i.preRelease){const n=m.exec(i.preRelease);if(n){const[,c,h,E]=n;a=Date.UTC(Number(c),Number(h)-1,Number(E))}}return{majorBase:s,majorMustEqual:d,minorBase:$,minorMustEqual:g,patchBase:t,patchMustEqual:o,isMinimum:i.hasGreaterEquals,notBefore:a}}e.$Co=P;function I(i,s,d){let $;typeof i=="string"?$=P(b(i)):$=i;let g;s instanceof Date?g=s.getTime():typeof s=="string"&&(g=new Date(s).getTime());let t;if(typeof d=="string"?t=P(b(d)):t=d,!$||!t)return!1;const o=$.majorBase,a=$.minorBase,n=$.patchBase;let c=t.majorBase,h=t.minorBase,E=t.patchBase;const y=t.notBefore;let u=t.majorMustEqual,l=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?o>c?!0:o<c?!1:a>h?!0:a<h||g&&g<y?!1:n>=E:(o===1&&c===0&&(!u||!l||!w)&&(c=1,h=0,E=0,u=!0,l=!1,w=!1),o<c?!1:o>c?!u:a<h?!1:a>h?!l:n<E?!1:n>E?!w:!(g&&g<y))}e.$Do=I;function p(i,s,d,$,g){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof $.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!$.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!r($.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!r($.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const n=(0,C.$hg)(d,$.main);(0,C.$bg)(n,d)||t.push([F.default.Warning,f.localize(10,null,n.path,d.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const n=(0,C.$hg)(d,$.browser);(0,C.$bg)(n,d)||t.push([F.default.Warning,f.localize(12,null,n.path,d.path)])}}if(!L.valid($.version))return t.push([F.default.Error,f.localize(13,null)]),t;const o=[];if(!k(i,s,$,g,o))for(const n of o)t.push([F.default.Error,n]);return t}e.$Eo=p;function k(i,s,d,$,g){return $||typeof d.main>"u"&&typeof d.browser>"u"?!0:v(i,s,d.engines.vscode,g)}e.$Fo=k;function D(i,s,d){return i==="*"||v(s,d,i)}e.$Go=D;function v(i,s,d,$=[]){const g=P(b(d));if(!g)return $.push(f.localize(14,null,d)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return $.push(f.localize(15,null,d)),!1}else if(!g.majorMustEqual)return $.push(f.localize(16,null,d)),!1;return I(i,s,g)?!0:($.push(f.localize(17,null,i,d)),!1)}function r(i){if(!Array.isArray(i))return!1;for(let s=0,d=i.length;s<d;s++)if(typeof i[s]!="string")return!1;return!0}}),define(De[103],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class C{constructor(f,L=[],R=!1){this.ctor=f,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$xh=C}),define(De[104],Ce([1,0,103]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.InstantiationType=void 0;const F=[];var f;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function L(m,S,b){S instanceof C.$xh||(S=new C.$xh(S,[],!!b)),F.push([m,S])}e.$kr=L;function R(){return F}e.$lr=R}),define(De[229],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class C{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$2p=C;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const m=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(R);m.outgoing.set(S.key,S),S.incoming.set(m.key,m)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let m=this.a.get(R);return m||(m=new C(R,L),this.a.set(R,m)),m}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,m]of this.a)L.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const m=new Set([L]),S=this.c(R,m);if(S)return S}}c(L,R){for(const[m,S]of L.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const b=this.c(S,R);if(b)return b;R.delete(m)}}}e.$3p=F}),define(De[5],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e._util=void 0;var C;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(S){return S[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(C||(e._util=C={})),e.$zh=f("instantiationService");function F(R,m,S){m[C.DI_TARGET]===m?m[C.DI_DEPENDENCIES].push({id:R,index:S}):(m[C.DI_DEPENDENCIES]=[{id:R,index:S}],m[C.DI_TARGET]=m)}function f(R){if(C.serviceIds.has(R))return C.serviceIds.get(R);const m=function(S,b,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(m,S,P)};return m.toString=()=>R,C.serviceIds.set(R,m),m}e.$Ah=f;function L(R){return R}e.$Bh=L}),define(De[49],Ce([1,0,18,2,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,f.$Ah)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof F.URI)}e.$8h=L;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof F.URI)}e.$9h=R;var m;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function S(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=S;function b(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$$h=b;function P(i,s){const d=Object.create(null);for(const $ in i)I(d,$,i[$],s);return d}e.$_h=P;function I(i,s,d,$){const g=s.split("."),t=g.pop();let o=i;for(let a=0;a<g.length;a++){const n=g[a];let c=o[n];switch(typeof c){case"undefined":c=o[n]=Object.create(null);break;case"object":break;default:$(`Ignoring ${s} as ${g.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}o=c}if(typeof o=="object"&&o!==null)try{o[t]=d}catch{$(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(o)}`)}else $(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(o)}`)}e.$ai=I;function p(i,s){const d=s.split(".");k(i,d)}e.$bi=p;function k(i,s){const d=s.shift();if(s.length===0){delete i[d];return}if(Object.keys(i).indexOf(d)!==-1){const $=i[d];typeof $=="object"&&!Array.isArray($)&&(k($,s),Object.keys($).length===0&&delete i[d])}}function D(i,s,d){function $(o,a){let n=o;for(const c of a){if(typeof n!="object"||n===null)return;n=n[c]}return n}const g=s.split("."),t=$(i,g);return typeof t>"u"?d:t}e.$ci=D;function v(i,s,d){Object.keys(s).forEach($=>{$!=="__proto__"&&($ in i?C.$kf(i[$])&&C.$kf(s[$])?v(i[$],s[$],d):d&&(i[$]=s[$]):i[$]=s[$])})}e.$di=v;function r(i){return i.replace(/[\[\]]/g,"")}e.$ei=r}),define(De[41],Ce([1,0,12,15,227,5,189,8]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",C.$j),S.set("isLinux",C.$k),S.set("isWindows",C.$i),S.set("isWeb",C.$o),S.set("isMacNative",C.$j&&!C.$o),S.set("isEdge",C.$G),S.set("isFirefox",C.$E),S.set("isChrome",C.$D),S.set("isSafari",C.$F);function b(G,U){if(S.get(G)!==void 0)throw(0,m.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(G,U)}e.$Fi=b;const P=Object.prototype.hasOwnProperty;var I;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},k=(0,R.localize)(0,null),D=(0,R.localize)(1,null),v=(0,R.localize)(2,null),r=(0,R.localize)(3,null),i=(0,R.localize)(4,null),s=(0,R.localize)(5,null),d=(0,R.localize)(6,null),$=(0,R.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new f.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const K=this.l();if(!this.E()){const Y=this.D(),se=Y.type===17?s:void 0;throw this.h.push({message:i,offset:Y.offset,lexeme:f.$Ei.getLexeme(Y),additionalInfo:se}),g.c}return K}catch(K){if(K!==g.c)throw K;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const K=this.o();U.push(K)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const K=this.s();U.push(K)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const K=this.l();return this.A(1,r),K?.negate()}case 17:return this.z(),A.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const K=this.l();return this.A(1,r),K}case 17:{const K=U.lexeme;if(this.z(),this.y(9)){const se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),se.type!==10)throw this.B("REGEX",se);const re=se.lexeme,le=re.lastIndexOf("/"),Ee=le===re.length-1?void 0:this.w(re.substring(le+1));let he;try{he=new RegExp(re.substring(1,le),Ee)}catch{throw this.B("REGEX",se)}return M.create(K,he)}switch(se.type){case 10:case 19:{const re=[se.lexeme];this.z();let le=this.D(),Ee=0;for(let be=0;be<se.lexeme.length;be++)se.lexeme.charCodeAt(be)===40?Ee++:se.lexeme.charCodeAt(be)===41&&Ee--;for(;!this.E()&&le.type!==15&&le.type!==16;){switch(le.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let be=0;be<le.lexeme.length;be++)le.lexeme.charCodeAt(be)===40?Ee++:se.lexeme.charCodeAt(be)===41&&Ee--}if(Ee<0)break;re.push(f.$Ei.getLexeme(le)),this.z(),le=this.D()}const he=re.join(""),fe=he.lastIndexOf("/"),te=fe===he.length-1?void 0:this.w(he.substring(fe+1));let ue;try{ue=new RegExp(he.substring(1,fe),te)}catch{throw this.B("REGEX",se)}return t.regex(K,ue)}case 18:{const re=se.lexeme;this.z();let le=null;if(!(0,F.$le)(re)){const Ee=re.indexOf("/"),he=re.lastIndexOf("/");if(Ee!==he&&Ee>=0){const fe=re.slice(Ee+1,he),te=re[he+1]==="i"?"i":"";try{le=new RegExp(fe,te)}catch{throw this.B("REGEX",se)}}}if(le===null)throw this.B("REGEX",se);return M.create(K,le)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const se=this.u();return t.notIn(K,se)}switch(this.D().type){case 3:{this.z();const se=this.u();if(this.x().type===18)return t.equals(K,se);switch(se){case"true":return t.has(K);case"false":return t.not(K);default:return t.equals(K,se)}}case 4:{this.z();const se=this.u();if(this.x().type===18)return t.notEquals(K,se);switch(se){case"true":return t.not(K);case"false":return t.has(K);default:return t.notEquals(K,se)}}case 5:return this.z(),j.create(K,this.u());case 6:return this.z(),z.create(K,this.u());case 7:return this.z(),N.create(K,this.u());case 8:return this.z(),T.create(K,this.u());case 13:return this.z(),t.in(K,this.u());default:return t.has(K)}}case 20:throw this.h.push({message:d,offset:U.offset,lexeme:"",additionalInfo:$}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,K){if(this.C(U))return this.z();throw this.B(K,this.D())}B(U,K,Y){const se=(0,R.localize)(8,null,U,f.$Ei.getLexeme(K)),re=K.offset,le=f.$Ei.getLexeme(K);return this.h.push({message:se,offset:re,lexeme:le,additionalInfo:Y}),g.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=g;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(U){return E.create(U)}static equals(U,K){return y.create(U,K)}static notEquals(U,K){return w.create(U,K)}static regex(U,K){return M.create(U,K)}static in(U,K){return u.create(U,K)}static notIn(U,K){return l.create(U,K)}static not(U){return A.create(U)}static and(...U){return me.create(U,null,!0)}static or(...U){return x.create(U,null,!0)}static greater(U,K){return N.create(U,K)}static greaterEquals(U,K){return T.create(U,K)}static smaller(U,K){return j.create(U,K)}static smallerEquals(U,K){return z.create(U,K)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Hi=t;function o(G){const U=new g({regexParsingWithErrorRecovery:!1});return G.map(K=>(U.parse(K),U.lexingErrors.length>0?U.lexingErrors.map(Y=>({errorMessage:Y.additionalInfo?(0,R.localize)(9,null,Y.additionalInfo):(0,R.localize)(10,null),offset:Y.offset,length:Y.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(Y=>({errorMessage:Y.additionalInfo?`${Y.message}. ${Y.additionalInfo}`:Y.message,offset:Y.offset,length:Y.lexeme.length})):[]))}e.$Ii=o;function a(G,U){const K=G?G.substituteConstants():void 0,Y=U?U.substituteConstants():void 0;return!K&&!Y?!0:!K||!Y?!1:K.equals(Y)}e.$Ji=a;function n(G,U){return G.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Ki=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$Li=h;class E{static create(U,K=null){const Y=S.get(U);return typeof Y=="boolean"?Y?h.INSTANCE:c.INSTANCE:new E(U,K)}constructor(U,K){this.key=U,this.c=K,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:V(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=S.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$Mi=E;class y{static create(U,K,Y=null){if(typeof K=="boolean")return K?E.create(U,Y):A.create(U,Y);const se=S.get(U);return typeof se=="boolean"?K===(se?"true":"false")?h.INSTANCE:c.INSTANCE:new y(U,K,Y)}constructor(U,K,Y){this.c=U,this.d=K,this.f=Y,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=S.get(this.c);if(typeof U=="boolean"){const K=U?"true":"false";return this.d===K?h.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Ni=y;class u{static create(U,K){return new u(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:_(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const K=U.getValue(this.f),Y=U.getValue(this.d);return Array.isArray(K)?K.includes(Y):typeof Y=="string"&&typeof K=="object"&&K!==null?P.call(K,Y):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Oi=u;class l{static create(U,K){return new l(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=11,this.c=u.create(U,K)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=l;class w{static create(U,K,Y=null){if(typeof K=="boolean")return K?A.create(U,Y):E.create(U,Y);const se=S.get(U);return typeof se=="boolean"?K===(se?"true":"false")?c.INSTANCE:h.INSTANCE:new w(U,K,Y)}constructor(U,K,Y){this.c=U,this.d=K,this.f=Y,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=S.get(this.c);if(typeof U=="boolean"){const K=U?"true":"false";return this.d===K?c.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Qi=w;class A{static create(U,K=null){const Y=S.get(U);return typeof Y=="boolean"?Y?c.INSTANCE:h.INSTANCE:new A(U,K)}constructor(U,K){this.c=U,this.d=K,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:V(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=S.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$Ri=A;function O(G,U){if(typeof G=="string"){const K=parseFloat(G);isNaN(K)||(G=K)}return typeof G=="string"||typeof G=="number"?U(G):c.INSTANCE}class N{static create(U,K,Y=null){return O(K,se=>new N(U,se,Y))}constructor(U,K,Y){this.c=U,this.d=K,this.f=Y,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Si=N;class T{static create(U,K,Y=null){return O(K,se=>new T(U,se,Y))}constructor(U,K,Y){this.c=U,this.d=K,this.f=Y,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ti=T;class j{static create(U,K,Y=null){return O(K,se=>new j(U,se,Y))}constructor(U,K,Y){this.c=U,this.d=K,this.f=Y,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Ui=j;class z{static create(U,K,Y=null){return O(K,se=>new z(U,se,Y))}constructor(U,K,Y){this.c=U,this.d=K,this.f=Y,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Vi=z;class M{static create(U,K){return new M(U,K)}constructor(U,K){this.d=U,this.f=K,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const K=this.f?this.f.source:"",Y=U.f?U.f.source:"";return K<Y?-1:K>Y?1:0}equals(U){if(U.type===this.type){const K=this.f?this.f.source:"",Y=U.f?U.f.source:"";return this.d===U.d&&K===Y}return!1}substituteConstants(){return this}evaluate(U){const K=U.getValue(this.d);return this.f?this.f.test(K):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Wi=M;class H{static create(U){return new H(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new H(this.c.map(U))}negate(){return this.c}}e.$Xi=H;function q(G){let U=null;for(let K=0,Y=G.length;K<Y;K++){const se=G[K].substituteConstants();if(G[K]!==se&&U===null){U=[];for(let re=0;re<K;re++)U[re]=G[re]}U!==null&&(U[K]=se)}return U===null?G:U}class me{static create(U,K,Y){return me.d(U,K,Y)}constructor(U,K){this.expr=U,this.c=K,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let K=0,Y=this.expr.length;K<Y;K++){const se=n(this.expr[K],U.expr[K]);if(se!==0)return se}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let K=0,Y=this.expr.length;K<Y;K++)if(!this.expr[K].equals(U.expr[K]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:me.create(U,this.c,!1)}evaluate(U){for(let K=0,Y=this.expr.length;K<Y;K++)if(!this.expr[K].evaluate(U))return!1;return!0}static d(U,K,Y){const se=[];let re=!1;for(const le of U)if(le){if(le.type===1){re=!0;continue}if(le.type===0)return c.INSTANCE;if(le.type===6){se.push(...le.expr);continue}se.push(le)}if(se.length===0&&re)return h.INSTANCE;if(se.length!==0){if(se.length===1)return se[0];se.sort(n);for(let le=1;le<se.length;le++)se[le-1].equals(se[le])&&(se.splice(le,1),le--);if(se.length===1)return se[0];for(;se.length>1;){const le=se[se.length-1];if(le.type!==9)break;se.pop();const Ee=se.pop(),he=se.length===0,fe=x.create(le.expr.map(te=>me.create([te,Ee],null,Y)),null,he);fe&&(se.push(fe),se.sort(n))}if(se.length===1)return se[0];if(Y){for(let le=0;le<se.length;le++)for(let Ee=le+1;Ee<se.length;Ee++)if(se[le].negate().equals(se[Ee]))return c.INSTANCE;if(se.length===1)return se[0]}return new me(se,K)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const K of this.expr)U.push(...K.keys());return U}map(U){return new me(this.expr.map(K=>K.map(U)),null)}negate(){if(!this.c){const U=[];for(const K of this.expr)U.push(K.negate());this.c=x.create(U,this,!0)}return this.c}}e.$Yi=me;class x{static create(U,K,Y){return x.d(U,K,Y)}constructor(U,K){this.expr=U,this.c=K,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let K=0,Y=this.expr.length;K<Y;K++){const se=n(this.expr[K],U.expr[K]);if(se!==0)return se}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let K=0,Y=this.expr.length;K<Y;K++)if(!this.expr[K].equals(U.expr[K]))return!1;return!0}return!1}substituteConstants(){const U=q(this.expr);return U===this.expr?this:x.create(U,this.c,!1)}evaluate(U){for(let K=0,Y=this.expr.length;K<Y;K++)if(this.expr[K].evaluate(U))return!0;return!1}static d(U,K,Y){let se=[],re=!1;if(U){for(let le=0,Ee=U.length;le<Ee;le++){const he=U[le];if(he){if(he.type===0){re=!0;continue}if(he.type===1)return h.INSTANCE;if(he.type===9){se=se.concat(he.expr);continue}se.push(he)}}if(se.length===0&&re)return c.INSTANCE;se.sort(n)}if(se.length!==0){if(se.length===1)return se[0];for(let le=1;le<se.length;le++)se[le-1].equals(se[le])&&(se.splice(le,1),le--);if(se.length===1)return se[0];if(Y){for(let le=0;le<se.length;le++)for(let Ee=le+1;Ee<se.length;Ee++)if(se[le].negate().equals(se[Ee]))return h.INSTANCE;if(se.length===1)return se[0]}return new x(se,K)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const K of this.expr)U.push(...K.keys());return U}map(U){return new x(this.expr.map(K=>K.map(U)),null)}negate(){if(!this.c){const U=[];for(const K of this.expr)U.push(K.negate());for(;U.length>1;){const K=U.shift(),Y=U.shift(),se=[];for(const re of we(K))for(const le of we(Y))se.push(me.create([re,le],null,!1));U.unshift(x.create(se,null,!1))}this.c=x.create(U,this,!0)}return this.c}}e.$Zi=x;class Q extends E{static{this.d=[]}static all(){return Q.d.values()}constructor(U,K,Y){super(U,null),this.f=K,typeof Y=="object"?Q.d.push({...Y,key:U}):Y!==!0&&Q.d.push({key:U,description:Y,type:K!=null?typeof K:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return y.create(this.key,U)}notEqualsTo(U){return w.create(this.key,U)}}e.$1i=Q,e.$2i=(0,L.$Ah)("contextKeyService");function V(G,U){return G<U?-1:G>U?1:0}function _(G,U,K,Y){return G<K?-1:G>K?1:U<Y?-1:U>Y?1:0}function ge(G,U){if(G.type===0||U.type===1)return!0;if(G.type===9)return U.type===9?ce(G.expr,U.expr):!1;if(U.type===9){for(const K of U.expr)if(ge(G,K))return!0;return!1}if(G.type===6){if(U.type===6)return ce(U.expr,G.expr);for(const K of G.expr)if(ge(K,U))return!0;return!1}return G.equals(U)}e.$3i=ge;function ce(G,U){let K=0,Y=0;for(;K<G.length&&Y<U.length;){const se=G[K].cmp(U[Y]);if(se<0)return!1;se===0&&K++,Y++}return K===G.length}function we(G){return G.type===9?G.expr:[G]}}),define(De[230],Ce([1,0,24,38,191,5,100,12,23]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pA=e.$oA=e.ConfirmResult=e.$nA=e.$mA=e.$lA=void 0,e.$lA=(0,L.$Ah)("dialogService");var b;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(b||(b={}));class P{a(r){return this.d(r,b.Confirmation)}b(r){return this.d(r,b.Prompt)}c(r){return this.d(r,b.Input)}d(r,i){const s=[];switch(i){case b.Confirmation:{const d=r;d.primaryButton?s.push(d.primaryButton):s.push((0,f.localize)(0,null)),d.cancelButton?s.push(d.cancelButton):s.push((0,f.localize)(1,null));break}case b.Prompt:{const d=r;Array.isArray(d.buttons)&&d.buttons.length>0&&s.push(...d.buttons.map($=>$.label)),d.cancelButton&&(d.cancelButton===!0?s.push((0,f.localize)(2,null)):typeof d.cancelButton=="string"?s.push(d.cancelButton):d.cancelButton.label?s.push(d.cancelButton.label):s.push((0,f.localize)(3,null))),s.length===0&&s.push((0,f.localize)(4,null));break}case b.Input:{const d=r;d.primaryButton?s.push(d.primaryButton):s.push((0,f.localize)(5,null)),d.cancelButton?s.push(d.cancelButton):s.push((0,f.localize)(6,null));break}}return s}e(r){if(typeof r=="string")return r;if(typeof r=="number")return r===F.default.Info?"info":r===F.default.Error?"error":r===F.default.Warning?"warning":"none"}async f(r,i,s){const d=[...r.buttons??[]];return r.cancelButton&&typeof r.cancelButton!="string"&&typeof r.cancelButton!="boolean"&&d.push(r.cancelButton),{result:await d[i]?.run({checkboxChecked:s}),checkboxChecked:s}}}e.$mA=P,e.$nA=(0,L.$Ah)("fileDialogService");var I;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function k(v){const r=[];return r.push(...v.slice(0,p).map(i=>typeof i=="string"?i:(0,C.$eg)(i))),v.length>p&&(v.length-p===1?r.push((0,f.localize)(7,null)):r.push((0,f.localize)(8,null,v.length-p))),r.push(""),r.join(`
`)}e.$oA=k;function D(v,r){const i=(0,S.$Um)(v);let s=(i.buttons??[]).map(t=>(0,R.$iA)(t)),d=(v.buttons||[]).map((t,o)=>o),$=0,g=i.cancelId??s.length-1;if(s.length>1){const t=typeof g=="number"?s[g]:void 0;if(m.$k||m.$j){if(typeof t=="string"&&s.length>1&&g!==1){s.splice(g,1),s.splice(1,0,t);const o=d[g];d.splice(g,1),d.splice(1,0,o),g=1}m.$k&&s.length>1&&(s=s.reverse(),d=d.reverse(),$=s.length-1,typeof t=="string"&&(g=$-1))}else if(m.$i&&typeof t=="string"&&s.length>1&&g!==s.length-1){s.splice(g,1),s.push(t);const o=d[g];d.splice(g,1),d.push(o),g=s.length-1}}return i.buttons=s,i.defaultId=$,i.cancelId=g,i.noLink=!0,i.title=i.title||r.nameLong,{options:i,buttonIndeces:d}}e.$pA=D}),define(De[131],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,C.$Ah)("environmentService"),e.$Ih=(0,C.$Bh)(e.$Hh)}),define(De[132],Ce([1,0,192,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function f(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=f;function L(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=L;function R(s,d){switch(s){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=R;function m(s,d){return d==="web"&&!s.includes("web")}e.$Un=m;function S(s,d,$){return m(d,$)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===$?!0:b($).includes(s)}e.$Vn=S;function b(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=b;function P(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$Xn=P;var I;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var p;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var k;(function(s){s.Install="install",s.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var D;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.$Yn=(0,F.$Ah)("extensionGalleryService");var v;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var r;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class i extends Error{constructor(d,$){super(d),this.code=$,this.name=$}}e.$Zn=i,e.$1n=(0,F.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,F.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,F.$Ah)("IExtensionTipsService"),e.$6n=(0,C.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,C.localize)(1,null),original:"Preferences"}}),define(De[231],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YWb=e.$XWb=e.$WWb=void 0,e.$WWb=(0,C.$Ah)("externalTerminal"),e.$XWb="Terminal.app",e.$YWb=(0,C.$Ah)("externalTerminal")}),define(De[232],Ce([1,0,48,17,16,12,99,29,102,194,231]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K5b=e.$J5b=e.$I5b=void 0;const I=b.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends p{static{this.b="cmd.exe"}openTerminal($,g){return this.spawnTerminal(C,$,S.$tl(),g)}spawnTerminal($,g,t,o){const a=g.windowsExec||k.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const n=f.$_d(a,".exe").toLowerCase();if(n==="cmder")return $.spawn(a,o?[o]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return a.indexOf(" ")>=0&&c.push('""'),c.push(a),n==="wt"&&c.push("-d ."),new Promise((h,E)=>{const y=r(process),u=$.spawn(t,c,{cwd:o,env:y});u.on("error",E),u.on("exit",()=>h())})}runInTerminal($,g,t,o,a){const n="windowsExec"in a&&a.windowsExec?a.windowsExec:k.getDefaultTerminalWindows();return new Promise((c,h)=>{const E=`"${g} - ${I}"`,y=`""${t.join('" "')}" & pause"`,u=Object.assign({},r(process),o);Object.keys(u).filter(N=>u[N]===null).forEach(N=>delete u[N]);const l={cwd:g,env:u,windowsVerbatimArguments:!0};let w,A;f.$_d(n,".exe")==="wt"?(w=n,A=["-d",".",k.b,"/c",y]):(w=k.b,A=["/c","start",E,"/wait",n,"/c",y]),C.spawn(w,A,l).on("error",N=>{h(i(N))}),c(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const $=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${$?"Sysnative":"System32"}\\cmd.exe`}return k.d}}e.$I5b=k;class D extends p{static{this.b="/usr/bin/osascript"}openTerminal($,g){return this.spawnTerminal(C,$,g)}runInTerminal($,g,t,o,a){const n=a.osxExec||P.$XWb;return new Promise((c,h)=>{if(n===P.$XWb||n==="iTerm.app"){const E=n===P.$XWb?"TerminalHelper":"iTermHelper",u=[F.$1f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",$||I,"-w",g];for(const A of t)u.push("-a"),u.push(A);if(o){const A=Object.assign({},r(process),o);for(const O in A){const N=A[O];N===null?(u.push("-u"),u.push(O)):(u.push("-e"),u.push(`${O}=${N}`))}}let l="";const w=C.spawn(D.b,u);w.on("error",A=>{h(i(A))}),w.stderr.on("data",A=>{l+=A.toString()}),w.on("exit",A=>{if(A===0)c(void 0);else if(l){const O=l.split(`
`,1);h(new Error(O[0]))}else h(new Error(b.localize(1,null,E,A)))})}else h(new Error(b.localize(2,null,n)))})}spawnTerminal($,g,t){const o=g.osxExec||P.$XWb;return new Promise((a,n)=>{const c=["-a",o];t&&c.push(t);const h=r(process),E=$.spawn("/usr/bin/open",c,{cwd:t,env:h});E.on("error",n),E.on("exit",()=>a())})}}e.$J5b=D;class v extends p{static{this.b=b.localize(3,null)}openTerminal($,g){return this.spawnTerminal(C,$,g)}runInTerminal($,g,t,o,a){const n=a.linuxExec?Promise.resolve(a.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((c,h)=>{const E=[];n.then(y=>{y.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const u=`${s(t)}; echo; read -p "${v.b}" -n1;`;E.push(`''${u}''`);const l=Object.assign({},r(process),o);Object.keys(l).filter(N=>l[N]===null).forEach(N=>delete l[N]);const w={cwd:g,env:l};let A="";const O=C.spawn(y,E,w);O.on("error",N=>{h(i(N))}),O.stderr.on("data",N=>{A+=N.toString()}),O.on("exit",N=>{if(N===0)c(void 0);else if(A){const T=A.split(`
`,1);h(new Error(T[0]))}else h(new Error(b.localize(4,null,y,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!L.$k)v.d=Promise.resolve("xterm");else{const $=await m.Promises.exists("/etc/debian_version");v.d=new Promise(g=>{$?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return v.d}spawnTerminal($,g,t){const o=g.linuxExec?Promise.resolve(g.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,n)=>{o.then(c=>{const h=r(process),E=$.spawn(c,[],{cwd:t,env:h});E.on("error",n),E.on("exit",()=>a())})})}}e.$K5b=v;function r(d){const $={...d.env};return(0,R.$rl)($),$}function i(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(b.localize(5,null,d.path)):d}function s(d){let $="";for(const g of d)g.indexOf(" ")>=0?$+='"'+g+'"':$+=g,$+=" ";return $}}),define(De[30],Ce([1,0,77,16,15,18,2,195,5,12,17]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileKind=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileOperationResult=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileChangeType=e.$jk=e.FileOperation=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileSystemProviderErrorCode=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$6j=e.$5j=void 0,e.$5j=(0,S.$Ah)("fileService");function I(V){return V.create===!0}e.$6j=I;var p;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var k;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(k||(e.FilePermission=k={}));var D;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(D||(e.FileSystemProviderCapabilities=D={}));function v(V){return!!(V.capabilities&2)}e.$7j=v;function r(V){return!!(V.capabilities&8)}e.$8j=r;function i(V){return!!(V.capabilities&131072)}e.$9j=i;function s(V){return!!(V.capabilities&4)}e.$0j=s;function d(V){return!!(V.capabilities&16)}e.$$j=d;function $(V){return v(V)?!!(V.capabilities&16384):!1}e.$_j=$;function g(V){return v(V)?!!(V.capabilities&32768):!1}e.$ak=g;function t(V){return!!(V.capabilities&65536)}e.$bk=t;function o(V){return!!(V.capabilities&2048)}e.$ck=o;var a;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class n extends Error{static create(_,ge){const ce=new n(_.toString(),ge);return E(ce,ge),ce}constructor(_,ge){super(_),this.code=ge}}e.$dk=n;function c(V,_){return n.create(V,_)}e.$ek=c;function h(V){return V||c((0,m.localize)(0,null),a.Unknown)}e.$fk=h;function E(V,_){return V.name=_?`${_} (FileSystemError)`:"FileSystemError",V}e.$gk=E;function y(V){if(!V)return a.Unknown;if(V instanceof n)return V.code;const _=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!_)return a.Unknown;switch(_[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$hk=y;function u(V){if(V instanceof T)return V.fileOperationResult;switch(y(V)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$ik=u;var l;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class w{constructor(_,ge,ce){this.resource=_,this.operation=ge,this.target=ce}isOperation(_){return this.operation===_}}e.$jk=w;var A;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class O{constructor(_,ge){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const we of _){const G=ce.get(we.type);switch(G?G.push([we.resource,we]):ce.set(we.type,[[we.resource,we]]),we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}}for(const[we,G]of ce)switch(we){case 1:this.a=C.$Gh.forUris(()=>ge),this.a.fill(G);break;case 0:this.b=C.$Gh.forUris(()=>ge),this.b.fill(G);break;case 2:this.c=C.$Gh.forUris(()=>ge),this.c.fill(G);break}}contains(_,...ge){return this.d(_,{includeChildren:!1},...ge)}affects(_,...ge){return this.d(_,{includeChildren:!0},...ge)}d(_,ge,...ce){if(!_)return!1;const we=ce.length>0;return!!((!we||ce.includes(1))&&(this.a?.get(_)||ge.includeChildren&&this.a?.findSuperstr(_))||(!we||ce.includes(0))&&(this.b?.get(_)||ge.includeChildren&&this.b?.findSuperstr(_))||(!we||ce.includes(2))&&(this.c?.findSubstr(_)||ge.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$kk=O;function N(V,_,ge){return!V||!_||V===_||_.length>V.length?!1:(_.charAt(_.length-1)!==F.sep&&(_+=F.sep),ge?(0,f.$Me)(V,_):V.indexOf(_)===0)}e.$lk=N;class T extends Error{constructor(_,ge,ce){super(_),this.fileOperationResult=ge,this.options=ce}}e.$mk=T;class j extends T{constructor(_,ge,ce,we){super(_,ge,we),this.fileOperationResult=ge,this.size=ce}}e.$nk=j;class z extends T{constructor(_,ge,ce){super(_,2,ce),this.stat=ge}}e.$ok=z;var M;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(M||(e.FileOperationResult=M={})),e.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$rk="files.associations",e.$sk="files.exclude",e.$tk="files.readonlyInclude",e.$uk="files.readonlyExclude",e.$vk="files.readonlyFromPermissions";var H;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$wk="";function q(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$xk=q;async function me(V,_){if(!_.hasProvider(R.URI.from({scheme:V.scheme})))return new Promise(ge=>{const ce=_.onDidChangeFileSystemProviderRegistrations(we=>{we.scheme===V.scheme&&we.added&&(ce.dispose(),ge())})})}e.$yk=me;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(_){return(0,L.$mf)(_)||(_=0),_<x.KB?(0,m.localize)(1,null,_.toFixed(0)):_<x.MB?(0,m.localize)(2,null,(_/x.KB).toFixed(2)):_<x.GB?(0,m.localize)(3,null,(_/x.MB).toFixed(2)):_<x.TB?(0,m.localize)(4,null,(_/x.GB).toFixed(2)):(0,m.localize)(5,null,(_/x.TB).toFixed(2))}}e.$zk=x;function Q(V){const _=typeof V=="string"||V?.scheme===P.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===P.Schemas.file?1024*x.MB:_?10*x.MB:b.$o?50*x.MB:1024*x.MB}e.$Ak=Q}),define(De[233],Ce([1,0,22,8,196,30]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function R(P,I,p,k,D,v){let r;try{await m(P,I,p,k,D,v)}catch(i){r=i}finally{r&&D.errorTransformer&&(r=D.errorTransformer(r)),typeof r<"u"&&p.error(r),p.end()}}e.$Ap=R;async function m(P,I,p,k,D,v){S(v);const r=await P.open(I,{create:!1});try{S(v);let i=0,s=0,d=D&&typeof D.length=="number"?D.length:void 0,$=C.$Ed.alloc(Math.min(D.bufferSize,typeof d=="number"?d:D.bufferSize)),g=D&&typeof D.position=="number"?D.position:0,t=0;do s=await P.read(r,g,$.buffer,t,$.byteLength-t),g+=s,t+=s,i+=s,typeof d=="number"&&(d-=s),t===$.byteLength&&(await p.write(k($)),$=C.$Ed.alloc(Math.min(D.bufferSize,typeof d=="number"?d:D.bufferSize)),t=0);while(s>0&&(typeof d!="number"||d>0)&&S(v)&&b(i,D));if(t>0){let o=t;typeof d=="number"&&(o=Math.min(t,d)),p.write(k($.slice(0,o)))}}catch(i){throw(0,L.$fk)(i)}finally{await P.close(r)}}function S(P){if(P.isCancellationRequested)throw(0,F.$4)();return!0}function b(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,L.$ek)((0,f.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[83],Ce([1,0,35,3,16,12,2,30]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=void 0;function S(i){return i.recursive===!0}e.$Cp=S;class b extends F.$jc{static{this.a=5}constructor(s,d,$,g){super(),this.h=s,this.j=d,this.m=$,this.n=g,this.c=this.B(new F.$kc),this.f=void 0,this.g=0}s(){const s=new F.$ic;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(d=>this.h(d))),s.add(this.b.onDidLogMessage(d=>this.j(d))),s.add(this.b.onDidError(d=>this.t(d)))}t(s){this.n.restartOnError?this.g<b.a&&this.f?(this.w(`restarting watcher after error: ${s}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${s}`):this.w(s)}u(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}w(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}y(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Dp=b;class P extends b{constructor(s,d,$){super(s,d,$,{type:"node.js",restartOnError:!1})}}e.$Ep=P;class I extends b{constructor(s,d,$){super(s,d,$,{type:"universal",restartOnError:!0})}}e.$Fp=I;function p(i){return i.map(s=>({type:s.type,resource:R.URI.file(s.path)}))}e.$Gp=p;function k(i){const s=new r;for(const d of i)s.processEvent(d);return s.coalesce()}e.$Hp=k;function D(i,s){return typeof s=="string"&&!s.startsWith(C.$mj)&&!(0,f.$7d)(s)?{base:i,pattern:s}:s}e.$Ip=D;function v(i,s){const d=[];for(const $ of s)d.push((0,C.$qj)(D(i,$)));return d}e.$Jp=v;class r{constructor(){this.a=new Set,this.b=new Map}c(s){return L.$k?s.path:s.path.toLowerCase()}processEvent(s){const d=this.b.get(this.c(s));let $=!1;if(d){const g=d.type,t=s.type;d.path!==s.path&&(s.type===2||s.type===1)?$=!0:g===1&&t===2?(this.b.delete(this.c(s)),this.a.delete(d)):g===2&&t===1?d.type=0:g===1&&t===0||(d.type=t)}else $=!0;$&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],d=[];return Array.from(this.a).filter($=>$.type!==2?(s.push($),!1):!0).sort(($,g)=>$.path.length-g.path.length).filter($=>d.some(g=>(0,m.$lk)($.path,g,!L.$k))?!1:(d.push($.path),!0)).concat(s)}}}),define(De[234],Ce([1,0,52,11,21,32,3,76,16,12,101,29,83]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;class k extends R.$jc{static{this.a=100}static{this.b=75}constructor(r,i,s,d){super(),this.m=r,this.n=i,this.r=s,this.s=d,this.c=this.B(new F.$Ug({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},$=>this.n($))),this.f=this.B(new F.$Tg($=>this.z($),k.b)),this.g=(0,p.$Jp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,p.$Jp)(this.m.path,this.m.includes):void 0,this.j=new f.$od,this.ready=this.t()}async t(){try{const r=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const i=await I.Promises.stat(r);this.B(await this.w(r,i.isDirectory()))}catch(r){r.code!=="ENOENT"?this.D(r):this.G(r)}}async u(r){let i=r.path;try{i=await I.Promises.realpath(r.path),r.path===i&&(i=await(0,P.$Tp)(r.path)??r.path),r.path!==i&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${i})`)}catch{}return i}async w(r,i){if(b.$j&&(0,L.$Hf)(r,"/Volumes/",!0))return this.D(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$jc.None;const s=new f.$od(this.j.token),d=new R.$ic;try{const $=(0,S.$_d)(r),g=(0,C.watch)(r);d.add((0,R.$hc)(()=>{g.removeAllListeners(),g.close()})),this.G(`Started watching: '${r}'`);const t=new Set;if(i)try{for(const a of await I.Promises.readdir(r))t.add(a)}catch(a){this.D(a)}const o=new Map;d.add((0,R.$hc)(()=>{for(const[,a]of o)a.dispose();o.clear()})),g.on("error",(a,n)=>{this.D(`Failed to watch ${r} for changes using fs.watch() (${a}, ${n})`),this.dispose()}),g.on("change",(a,n)=>{if(s.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${n}`);let c="";if(n&&(c=n.toString(),b.$j&&(c=(0,m.$gl)(c))),!(!c||a!=="change"&&a!=="rename"))if(i)if(a==="rename"){o.get(c)?.dispose();const h=setTimeout(async()=>{if(o.delete(c),c===$&&!await I.Promises.exists(r)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,S.$8d)(r,c));if(s.token.isCancellationRequested)return;let y;E?t.has(c)?y=0:(y=1,t.add(c)):(t.delete(c),y=2),this.y({path:(0,S.$8d)(this.m.path,c),type:y})},k.a);o.set(c,(0,R.$hc)(()=>clearTimeout(h)))}else{let h;t.has(c)?h=0:(h=1,t.add(c)),this.y({path:(0,S.$8d)(this.m.path,c),type:h})}else if(a==="rename"||c!==$){const h=setTimeout(async()=>{const E=await I.Promises.exists(r);s.token.isCancellationRequested||(E?(this.y({path:this.m.path,type:0},!0),d.add(await this.w(r,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},k.a);d.clear(),d.add((0,R.$hc)(()=>clearTimeout(h)))}else this.y({path:this.m.path,type:0},!0)})}catch($){await I.Promises.exists(r)&&!s.token.isCancellationRequested&&this.D(`Failed to watch ${r} for changes using fs.watch() (${$.toString()})`)}return(0,R.$hc)(()=>{s.dispose(!0),d.dispose()})}y(r,i=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!i&&this.g.some(s=>s(r.path))?this.s&&this.G(` >> ignored (excluded) ${r.path}`):!i&&this.h&&this.h.length>0&&!this.h.some(s=>s(r.path))?this.s&&this.G(` >> ignored (not included) ${r.path}`):this.f.work(r))}z(r){const i=(0,p.$Hp)(r);if(i.length>0){if(this.s)for(const d of i)this.G(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work(i)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(r){if(b.$k)return I.Promises.exists(r);try{const i=(0,S.$_d)(r);return(await I.Promises.readdir((0,S.$$d)(r))).some(d=>d===i)}catch(i){return this.G(i),!1}}setVerboseLogging(r){this.s=r}D(r){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}F(r){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}G(r){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Wp=k;async function D(v,r,i,s,d=512){const $=await I.Promises.open(v,"r"),g=Buffer.allocUnsafe(d),t=new f.$od(s);let o,a=!1;const n={path:v,excludes:[],recursive:!1},c=new k(n,h=>{(async()=>{for(const{type:E}of h)if(E===0){if(a)return;a=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:y}=await I.Promises.read($,g,0,d,null);if(!y||t.token.isCancellationRequested)break;r(g.slice(0,y))}}catch(y){o=new Error(y),t.dispose(!0)}finally{a=!1}}})()});return await c.ready,i(),new Promise((h,E)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await I.Promises.close($)}catch(y){o=new Error(y)}o?E(o):h()})})}e.$Xp=D}),define(De[235],Ce([1,0,4,35,3,12,234]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class m extends f.$jc{constructor(){super(...arguments),this.a=this.B(new C.$ed),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$ed),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(b){const P=this.j(b),I=P.filter(k=>{const D=this.c.get(k.path);return D?!(0,F.$uj)(D.request.excludes,k.excludes)||!(0,F.$uj)(D.request.includes,k.includes):!0}),p=Array.from(this.c.values()).filter(({request:k})=>!P.find(D=>D.path===k.path&&(0,F.$uj)(D.excludes,k.excludes)&&(0,F.$uj)(D.includes,k.includes))).map(({request:k})=>k.path);I.length&&this.m(`Request to start watching: ${I.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const k of p)this.h(k);for(const k of I)this.g(k)}g(b){const P=new R.$Wp(b,p=>this.a.fire(p),p=>this.b.fire(p),this.f),I={request:b,instance:P};this.c.set(b.path,I)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const P=this.c.get(b);P&&(this.c.delete(b),P.instance.dispose())}j(b){const P=new Map;for(const I of b){const p=L.$k?I.path:I.path.toLowerCase();P.set(p,I)}return Array.from(P.values())}async setVerboseLogging(b){this.f=b;for(const[,P]of this.c)P.instance.setVerboseLogging(b)}m(b){this.f&&this.b.fire({type:"trace",message:this.n(b)})}n(b,P){return P?`[File Watcher (node.js)] ${b} (path: ${P.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$Yp=m}),define(De[236],Ce([1,0,83,235]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class f extends C.$Ep{constructor(R,m,S){super(R,m,S),this.s()}r(R){return R.add(new F.$Yp)}}e.$Zp=f}),define(De[237],Ce([1,0,17,80,183,83]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class R extends L.$Fp{constructor(S,b,P){super(S,b,P),this.s()}r(S){const b=S.add(new f.$Qp(C.$1f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(b.onDidProcessExit(({code:P,signal:I})=>this.t(`terminated by itself with code ${P}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$hh)(b.getChannel("watcher")))}}e.$Rp=R}),define(De[105],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class C{constructor(...f){this.a=new Map;for(const[L,R]of f)this.set(L,R)}set(f,L){const R=this.a.get(f);return this.a.set(f,L),R}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$yh=C}),define(De[238],Ce([1,0,11,8,3,103,229,5,105,75]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;const P=!1;class I extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class p{constructor(r=new S.$yh,i=!1,s,d=P){this.f=r,this.g=i,this.h=s,this.i=d,this.o=new Set,this.f.set(m.$zh,this),this._globalGraph=d?s?._globalGraph??new R.$3p($=>$):void 0}createChild(r){return new p(r,this.g,this,this.i)}invokeFunction(r,...i){const s=D.traceInvocation(this.i,r);let d=!1;try{return r({get:g=>{if(d)throw(0,F.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(g,s);if(!t)throw new Error(`[invokeFunction] unknown service '${g}'`);return t}},...i)}finally{d=!0,s.stop()}}createInstance(r,...i){let s,d;return r instanceof L.$xh?(s=D.traceCreation(this.i,r.ctor),d=this.j(r.ctor,r.staticArguments.concat(i),s)):(s=D.traceCreation(this.i,r),d=this.j(r,i,s)),s.stop(),d}j(r,i=[],s){const d=m._util.getServiceDependencies(r).sort((t,o)=>t.index-o.index),$=[];for(const t of d){const o=this.m(t.id,s);o||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(o)}const g=d.length>0?d[0].index:i.length;if(i.length!==g){console.trace(`[createInstance] First service dependency of ${r.name} at position ${g+1} conflicts with ${i.length} static arguments`);const t=g-i.length;t>0?i=i.concat(new Array(t)):i=i.slice(0,g)}return Reflect.construct(r,i.concat($))}k(r,i){if(this.f.get(r)instanceof L.$xh)this.f.set(r,i);else if(this.h)this.h.k(r,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const i=this.f.get(r);return!i&&this.h?this.h.l(r):i}m(r,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const s=this.l(r);return s instanceof L.$xh?this.q(r,s,i.branch(r,!0)):(i.branch(r,!1),s)}q(r,i,s){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,i,s)}finally{this.o.delete(r)}}r(r,i,s){const d=new R.$3p(t=>t.id.toString());let $=0;const g=[{id:r,desc:i,_trace:s}];for(;g.length;){const t=g.pop();if(d.lookupOrInsertNode(t),$++>1e3)throw new I(d);for(const o of m._util.getServiceDependencies(t.desc.ctor)){const a=this.l(o.id);if(a||this.u(`[createInstance] ${r} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),a instanceof L.$xh){const n={id:o.id,desc:a,_trace:t._trace.branch(o.id,!0)};d.insertEdge(t,n),g.push(n)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new I(d);break}for(const{data:o}of t){if(this.l(o.id)instanceof L.$xh){const n=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,n)}d.removeNode(o)}}return this.l(r)}s(r,i,s=[],d,$){if(this.f.get(r)instanceof L.$xh)return this.t(r,i,s,d,$);if(this.h)return this.h.s(r,i,s,d,$);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(r,i,s=[],d,$){if(d){const g=new p(void 0,this.g,this,this.i);g.c=String(r);const t=new Map,o=new C.$Wg(()=>{const a=g.j(i,s,$);for(const[n,c]of t){const h=a[n];if(typeof h=="function")for(const E of c)h.apply(a,E)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let E=t.get(n);return E||(E=new b.$sc,t.set(n,E)),(u,l,w)=>{const A=E.push([u,l,w]);return(0,f.$hc)(A)}}if(n in a)return a[n];const c=o.value;let h=c[n];return typeof h!="function"||(h=h.bind(c),a[n]=h),h},set(a,n,c){return o.value[n]=c,!0},getPrototypeOf(a){return i.prototype}})}else return this.j(i,s,$)}u(r,i){if(i&&console.warn(r),this.g)throw new Error(r)}}e.$4p=p;var k;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(k||(k={}));class D{static{this.all=new Set}static{this.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,i){return r?new D(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(r,i){return r?new D(1,i.name):D.c}static{this.f=0}constructor(r,i){this.type=r,this.name=i,this.g=Date.now(),this.h=[]}branch(r,i){const s=new D(3,r.toString());return this.h.push([r,i,s]),s}stop(){const r=Date.now()-this.g;D.f+=r;let i=!1;function s($,g){const t=[],o=new Array($+1).join("	");for(const[a,n,c]of g.h)if(n&&c){i=!0,t.push(`${o}CREATES -> ${a}`);const h=s($+1,c);h&&t.push(h)}else t.push(`${o}uses -> ${a}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${s(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(r>2||i)&&D.all.add(d.join(`
`))}}e.$5p=D}),define(De[14],Ce([1,0,46,4,51,3,28,12,24,18,2,41,5]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,p.$Ah)("logService"),e.$5i=(0,p.$Ah)("loggerService");function k(){return new Date().toISOString()}function D(u){return(0,b.$mf)(u)}e.$6i=D;var v;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$7i=v.Info;function r(u,l,w){switch(l){case v.Trace:u.trace(w);break;case v.Debug:u.debug(w);break;case v.Info:u.info(w);break;case v.Warning:u.warn(w);break;case v.Error:u.error(w);break;case v.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=r;function i(u,l=!1){let w="";for(let A=0;A<u.length;A++){let O=u[A];if(O instanceof Error&&(O=(0,C.$li)(O,l)),typeof O=="object")try{O=JSON.stringify(O)}catch{}w+=(A>0?" ":"")+O}return w}class s extends L.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new F.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==v.Off&&this.b<=l}}e.$9i=s;class d extends s{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...w){this.f(v.Trace)&&this.g(v.Trace,i([l,...w],!0))}debug(l,...w){this.f(v.Debug)&&this.g(v.Debug,i([l,...w]))}info(l,...w){this.f(v.Info)&&this.g(v.Info,i([l,...w]))}warn(l,...w){this.f(v.Warning)&&this.g(v.Warning,i([l,...w]))}error(l,...w){if(this.f(v.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.g(v.Error,i(A))}else this.g(v.Error,i([l,...w]))}flush(){}}e.$0i=d;class $ extends s{constructor(l=e.$7i){super(),this.setLevel(l),this.g=!m.$i}trace(l,...w){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,l,...w):console.log(`[main ${k()}]`,l,...w))}debug(l,...w){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,l,...w):console.log(`[main ${k()}]`,l,...w))}info(l,...w){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,l,...w):console.log(`[main ${k()}]`,l,...w))}warn(l,...w){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,l,...w):console.warn(`[main ${k()}]`,l,...w))}error(l,...w){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,l,...w):console.error(`[main ${k()}]`,l,...w))}dispose(){}flush(){}}e.$$i=$;class g extends s{constructor(l=e.$7i,w=!0){super(),this.g=w,this.setLevel(l)}trace(l,...w){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...w):console.log(l,...w))}debug(l,...w){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...w):console.log(l,...w))}info(l,...w){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...w):console.log(l,...w))}warn(l,...w){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...w):console.log(l,...w))}error(l,...w){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...w):console.error(l,...w))}dispose(){}flush(){}}e.$_i=g;class t extends s{constructor(l,w=e.$7i){super(),this.g=l,this.setLevel(w)}trace(l,...w){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(l),...w])}debug(l,...w){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(l),...w])}info(l,...w){this.f(v.Info)&&this.g.log(v.Info,[this.h(l),...w])}warn(l,...w){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(l),...w])}error(l,...w){this.f(v.Error)&&this.g.log(v.Error,[this.h(l),...w])}h(l){return typeof l=="string"?l:(0,C.$li)(l,this.f(v.Trace))}dispose(){}flush(){}}e.$aj=t;class o extends s{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const w of this.g)w.setLevel(l);super.setLevel(l)}trace(l,...w){for(const A of this.g)A.trace(l,...w)}debug(l,...w){for(const A of this.g)A.debug(l,...w)}info(l,...w){for(const A of this.g)A.info(l,...w)}warn(l,...w){for(const A of this.g)A.warn(l,...w)}error(l,...w){for(const A of this.g)A.error(l,...w)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$bj=o;class a extends L.$jc{constructor(l,w,A){if(super(),this.h=l,this.j=w,this.b=new R.$yi,this.c=this.B(new F.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$ed),this.onDidChangeVisibility=this.g.event,A)for(const O of A)this.b.set(O.resource,{logger:void 0,info:O})}m(l){return(0,b.$if)(l)?[...this.b.values()].find(w=>w.info.id===l):this.b.get(l)}getLogger(l){return this.m(l)?.logger}createLogger(l,w){const A=this.n(l),O=(0,b.$if)(l)?l:w?.id??(0,f.$oi)(A.toString()).toString(16);let N=this.b.get(A)?.logger;const T=w?.logLevel==="always"?v.Trace:w?.logLevel;N||(N=this.s(A,T??this.getLogLevel(A)??this.h,{...w,id:O}));const j={logger:N,info:{resource:A,id:O,logLevel:T,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(j.info),this.b.set(A,j),N}n(l){return(0,b.$if)(l)?(0,S.$hg)(this.j,`${l}.log`):l}setLogLevel(l,w){if(P.URI.isUri(l)){const A=l,O=w,N=this.b.get(A);N&&O!==N.info.logLevel&&(N.info.logLevel=O===this.h?void 0:O,N.logger?.setLevel(O),this.b.set(N.info.resource,N),this.f.fire([A,O]))}else{this.h=l;for(const[A,O]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,w){const A=this.m(l);A&&w!==!A.info.hidden&&(A.info.hidden=!w,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,w]))}getLogLevel(l){let w;return l&&(w=this.b.get(l)?.info.logLevel),w??this.h}registerLogger(l){const w=this.b.get(l.resource);w?w.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const w=this.b.get(l);w&&(w.logger&&w.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=a;class n{constructor(){this.onDidChangeLogLevel=new F.$ed().event}setLevel(l){}getLevel(){return v.Info}trace(l,...w){}debug(l,...w){}info(l,...w){}warn(l,...w){}error(l,...w){}critical(l,...w){}dispose(){}flush(){}}e.$dj=n;class c extends n{}e.$ej=c;function h(u){if(u.verbose)return v.Trace;if(typeof u.logLevel=="string"){const l=y(u.logLevel.toLowerCase());if(l!==void 0)return l}return e.$7i}e.$fj=h;function E(u){switch(u){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$gj=E;function y(u){switch(u){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$hj=y,e.$ij=new I.$1i("logLevel",E(v.Info))}),define(De[239],Ce([1,0,19,11,8,4,3,16,83,14]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class P extends R.$jc{constructor(p,k){super(),this.a=p,this.b=k,this.c=this.B(new L.$ed),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$ed),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Dg(0)),this.w=[],this.y=this.B(new F.$Dg(0))}watch(p,k){return k.recursive||this.b?.watcher?.forceUniversal?this.n(p,k):this.z(p,k)}n(p,k){const D={path:this.H(p),excludes:k.excludes,includes:k.includes,recursive:k.recursive},v=(0,C.$Rb)(this.j,D);return this.r(),(0,R.$hc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,f.$Y)(p))}s(){this.h||(this.h=this.B(this.t(k=>this.c.fire((0,S.$Gp)(k)),k=>this.G(k),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const k of this.j)(0,S.$Cp)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const k of this.j)(0,S.$Cp)(k)&&p.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,k){const D={path:this.H(p),excludes:k.excludes,includes:k.includes,recursive:!1},v=(0,C.$Rb)(this.w,D);return this.C(),(0,R.$hc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,f.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,S.$Gp)(p)),p=>this.G(p),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,m.$6d)(p.fsPath)}}e.$Kp=P}),define(De[240],Ce([1,0,52,372,11,28,22,4,32,3,16,12,24,97,29,197,30,233,239,46,237,236]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0,(()=>{try{(0,F.gracefulify)(C)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$li)(o)}`)}})();class t extends s.$Kp{static{this.I=!1}constructor(a,n){super(a,n),this.onDidChangeCapabilities=m.Event.None,this.N=new L.$yi(c=>p.$$f.getComparisonKey(c)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(a){try{const{stat:n,symbolicLink:c}=await D.SymlinkSupport.stat(this.H(a));return{type:this.M(n,c),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:r.FilePermission.Locked}}catch(n){throw this.eb(n)}}async L(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const n=await D.Promises.readdir(this.H(a),{withFileTypes:!0}),c=[];return await Promise.all(n.map(async h=>{try{let E;h.isSymbolicLink()?E=(await this.stat((0,p.$hg)(a,h.name))).type:E=this.M(h),c.push([h.name,E])}catch(E){this.a.trace(E)}})),c}catch(n){throw this.eb(n)}}M(a,n){let c;return n?.dangling?c=r.FileType.Unknown:a.isFile()?c=r.FileType.File:a.isDirectory()?c=r.FileType.Directory:c=r.FileType.Unknown,n&&(c|=r.FileType.SymbolicLink),c}async O(a){const n=this.H(a);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let c;for(;c=this.N.get(a);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await c.wait();const h=new f.$Eg;return this.N.set(a,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.$hc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(a)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(a)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),h.open()})}async readFile(a,n){let c;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(a)})`),c=await this.O(a));const h=this.H(a);return await D.Promises.readFile(h)}catch(h){throw this.eb(h)}finally{c?.dispose()}}P(a){t.I&&this.a.trace(a)}readFileStream(a,n,c){const h=(0,k.$sd)(E=>R.$Ed.concat(E.map(y=>R.$Ed.wrap(y))).buffer);return(0,i.$Ap)(this,a,h,E=>E.buffer,{...n,bufferSize:256*1024},c),h}async writeFile(a,n,c){return c?.atomic!==!1&&c?.atomic?.postfix?this.Q(a,(0,p.$hg)((0,p.$gg)(a),`${(0,p.$eg)(a)}${c.atomic.postfix}`),n,c):this.R(a,n,c)}async Q(a,n,c,h){await this.R(n,c,h);try{await this.rename(n,a,{overwrite:!0})}catch(E){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}async R(a,n,c){let h;try{const E=this.H(a);if(!c.create||!c.overwrite){if(await D.Promises.exists(E)){if(!c.overwrite)throw(0,r.$ek)((0,v.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,r.$ek)((0,v.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(a,{create:!0,unlock:c.unlock}),await this.write(h,0,n,0,n.byteLength)}catch(E){throw await this.fb(a,E)}finally{typeof h=="number"&&await this.close(h)}}static{this.X=!0}static configureFlushOnWrite(a){t.X=a}async open(a,n){const c=this.H(a);let h;(0,r.$6j)(n)&&(h=await this.O(a));let E;try{if((0,r.$6j)(n)&&n.unlock)try{const{stat:u}=await D.SymlinkSupport.stat(c);u.mode&128||await D.Promises.chmod(c,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let y;if((0,r.$6j)(n)){if(I.$i)try{await D.Promises.truncate(c,0),y="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}y||(y="w")}else y="r";E=await D.Promises.open(c,y)}catch(y){throw h?.dispose(),(0,r.$6j)(n)?await this.fb(a,y):this.eb(y)}if(this.S.set(E,0),(0,r.$6j)(n)&&this.W.set(E,a),h){const y=this.U.get(E);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${c})`),this.U.set(E,h),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${c})`),y.dispose())}return E}async close(a){const n=this.U.get(a);try{if(this.S.delete(a),this.W.delete(a)&&t.X)try{await D.Promises.fdatasync(a)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await D.Promises.close(a)}catch(c){throw this.eb(c)}finally{n&&(this.U.get(a)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.U.delete(a)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),n.dispose())}}async read(a,n,c,h,E){const y=this.Y(a,n);let u=null;try{u=(await D.Promises.read(a,c,h,E,y)).bytesRead}catch(l){throw this.eb(l)}finally{this.Z(a,y,u)}return u}Y(a,n){return n===this.S.get(a)?null:n}Z(a,n,c){const h=this.S.get(a);typeof h=="number"&&(typeof n=="number"||(typeof c=="number"?this.S.set(a,h+c):this.S.delete(a)))}async write(a,n,c,h,E){return(0,f.$Xg)(()=>this.$(a,n,c,h,E),100,3)}async $(a,n,c,h,E){const y=this.Y(a,n);let u=null;try{u=(await D.Promises.write(a,c,h,E,y)).bytesWritten}catch(l){throw await this.fb(this.W.get(a),l)}finally{this.Z(a,y,u)}return u}async mkdir(a){try{await D.Promises.mkdir(this.H(a))}catch(n){throw this.eb(n)}}async delete(a,n){try{const c=this.H(a);if(n.recursive){let h;n?.atomic!==!1&&n.atomic.postfix&&(h=(0,P.$8d)((0,P.$$d)(c),`${(0,P.$_d)(c)}${n.atomic.postfix}`)),await D.Promises.rm(c,D.RimRafMode.MOVE,h)}else try{await D.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let E=!1;try{const{stat:y,symbolicLink:u}=await D.SymlinkSupport.stat(c);E=y.isDirectory()&&!u}catch{}if(E)await D.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.eb(c)}}async rename(a,n,c){const h=this.H(a),E=this.H(n);if(h!==E)try{await this.ab(a,n,"move",c.overwrite),await D.Promises.rename(h,E)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,v.localize)(2,null,(0,P.$_d)(h),(0,P.$_d)((0,P.$$d)(E)),y.toString()))),this.eb(y)}}async copy(a,n,c){const h=this.H(a),E=this.H(n);if(h!==E)try{await this.ab(a,n,"copy",c.overwrite),await D.Promises.copy(h,E,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,v.localize)(3,null,(0,P.$_d)(h),(0,P.$_d)((0,P.$$d)(E)),y.toString()))),this.eb(y)}}async ab(a,n,c,h){const E=this.H(a),y=this.H(n);let u=!1;if(!!(this.capabilities&1024)||(u=(0,S.$Gf)(E,y,!0)),u){if(c==="copy")throw(0,r.$ek)((0,v.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const w=await this.L(a);if(!w)throw(0,r.$ek)((0,v.localize)(5,null),r.FileSystemProviderErrorCode.FileNotFound);const A=await this.L(n);if(A){if(!h)throw(0,r.$ek)((0,v.localize)(6,null),r.FileSystemProviderErrorCode.FileExists);w.type&r.FileType.File&&A.type&r.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,n){return this.bb(a,n,!1)}async bb(a,n,c){const h=this.H(a),E=this.H(n),y=!!(this.capabilities&1024);if((0,S.$Gf)(h,E,!y))return;const u=new b.$ic;try{const[l,w]=await Promise.all([this.O(a),this.O(n)]);u.add(l),u.add(w),c&&await D.Promises.mkdir((0,P.$$d)(E),{recursive:!0}),await D.Promises.copyFile(h,E)}catch(l){if(l.code==="ENOENT"&&!c)return this.bb(a,n,!0);throw this.eb(l)}finally{u.dispose()}}t(a,n,c){return new $.$Rp(h=>a(h),h=>n(h),c)}F(a,n,c){return new g.$Zp(h=>a(h),h=>n(h),c)}eb(a){if(a instanceof r.$dk)return a;let n=a,c;switch(a.code){case"ENOENT":c=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=r.FileSystemProviderErrorCode.Unknown;break;default:c=r.FileSystemProviderErrorCode.Unknown}return(0,r.$ek)(n,c)}async fb(a,n){let c=this.eb(n);if(a&&c.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await D.SymlinkSupport.stat(this.H(a));h.mode&128||(c=(0,r.$ek)(n,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$1p=t}),define(De[241],Ce([1,0,3,14]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;class f extends C.$jc{constructor(R,m=[]){super(),this.a=new F.$bj([R,...m]),this.B(R.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$gN=f}),define(De[242],Ce([1,0,30,14]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;var f;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(f||(f={}));async function L(b,P,I,p,k){try{const D=await new Promise((r,i)=>{$e(["@vscode/spdlog"],r,i)});D.setFlushOn(f.Trace);const v=await D.createAsyncRotatingLogger(b,P,I,p);return k?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(D){console.error(D)}return null}function R(b,P,I){switch(P){case F.LogLevel.Trace:b.trace(I);break;case F.LogLevel.Debug:b.debug(I);break;case F.LogLevel.Info:b.info(I);break;case F.LogLevel.Warning:b.warn(I);break;case F.LogLevel.Error:b.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function m(b,P){switch(P){case F.LogLevel.Trace:b.setLevel(f.Trace);break;case F.LogLevel.Debug:b.setLevel(f.Debug);break;case F.LogLevel.Info:b.setLevel(f.Info);break;case F.LogLevel.Warning:b.setLevel(f.Warning);break;case F.LogLevel.Error:b.setLevel(f.Error);break;case F.LogLevel.Off:b.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class S extends F.$0i{constructor(P,I,p,k,D){super(),this.m=[],this.setLevel(D),this.n=this.s(P,I,p,k),this.B(this.onDidChangeLogLevel(v=>{this.r&&m(this.r,v)}))}async s(P,I,p,k){const D=p?6:1,v=30/D*C.$zk.MB,r=await L(P,I,v,D,k);if(r){this.r=r,m(this.r,this.getLevel());for(const{level:i,message:s}of this.m)R(this.r,i,s);this.m=[]}}g(P,I){this.r?R(this.r,P,I):this.getLevel()<=P&&this.m.push({level:P,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$8M=S}),define(De[133],Ce([1,0,38,198,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(S){function b(D,v){return v-D}S.compare=b;const P=Object.create(null);P[S.Error]=(0,F.localize)(0,null),P[S.Warning]=(0,F.localize)(1,null),P[S.Info]=(0,F.localize)(2,null);function I(D){return P[D]||""}S.toString=I;function p(D){switch(D){case C.default.Error:return S.Error;case C.default.Warning:return S.Warning;case C.default.Info:return S.Info;case C.default.Ignore:return S.Hint}}S.fromSeverity=p;function k(D){switch(D){case S.Error:return C.default.Error;case S.Warning:return C.default.Warning;case S.Info:return C.default.Info;case S.Hint:return C.default.Ignore}}S.toSeverity=k}(R||(e.MarkerSeverity=R={}));var m;(function(S){const b="";function P(p){return I(p,!0)}S.makeKey=P;function I(p,k){const D=[b];return p.source?D.push(p.source.replace("\xA6","\\\xA6")):D.push(b),p.code?typeof p.code=="string"?D.push(p.code.replace("\xA6","\\\xA6")):D.push(p.code.value.replace("\xA6","\\\xA6")):D.push(b),p.severity!==void 0&&p.severity!==null?D.push(R.toString(p.severity)):D.push(b),p.message&&k?D.push(p.message.replace("\xA6","\\\xA6")):D.push(b),p.startLineNumber!==void 0&&p.startLineNumber!==null?D.push(p.startLineNumber.toString()):D.push(b),p.startColumn!==void 0&&p.startColumn!==null?D.push(p.startColumn.toString()):D.push(b),p.endLineNumber!==void 0&&p.endLineNumber!==null?D.push(p.endLineNumber.toString()):D.push(b),p.endColumn!==void 0&&p.endColumn!==null?D.push(p.endColumn.toString()):D.push(b),D.push(b),D.join("\xA6")}S.makeKeyOptionalMessage=I})(m||(e.IMarkerData=m={})),e.$1s=(0,f.$Ah)("markerService")}),define(De[243],Ce([1,0,4,38,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Wu=e.Severity=void 0,e.Severity=F.default,e.$Wu=(0,f.$Ah)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var m;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class S{constructor(){this.progress=new b,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Xu=S;class b{infinite(){}done(){}total(I){}worked(I){}}e.$Yu=b}),define(De[134],Ce([1,0,15,2,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GT=e.$FT=e.$ET=e.$DT=e.$CT=void 0,e.$CT=(0,f.$Ah)("openerService");function L(b,P){return F.URI.isUri(b)?(0,C.$Le)(b.scheme,P):(0,C.$Me)(b,P+":")}e.$DT=L;function R(b,...P){return P.some(I=>L(b,I))}e.$ET=R;function m(b,P){return b.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$FT=m;function S(b){let P;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(b.fragment);return I&&(P={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},b=b.with({fragment:""})),{selection:P,uri:b}}e.$GT=S}),define(De[244],Ce([1,0,12,47]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let f;if(typeof C.$g.vscode<"u"&&typeof C.$g.vscode.context<"u"){const L=C.$g.vscode.context.configuration();if(L)f=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(f=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(f,{nameShort:`${f.nameShort} Dev`,nameLong:`${f.nameLong} Dev`,dataFolderName:`${f.dataFolderName}-dev`,serverDataFolderName:f.serverDataFolderName?`${f.serverDataFolderName}-dev`:void 0}),!f.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(f,{version:L.version})}}else f={},Object.keys(f).length===0&&Object.assign(f,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=f}),define(De[135],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,C.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(C,F){e(C,F,$e)}};define(De[84],Ce([1,0,11,21,3,5]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.$3u=e.$2u=e.$1u=e.ProgressLocation=e.$Zu=void 0,e.$Zu=(0,L.$Ah)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$1u=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,p){this.c=I,this.report=p?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const p=this.c(this.a);this.b=Promise.resolve(p).finally(()=>this.b=void 0)})}}e.$2u=m;let S=class extends f.$jc{constructor(I,p){super(),this.a=new C.$1g,p.withProgress(I,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,f.$hc)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$3u=S,e.$3u=S=Ke([Be(1,e.$Zu)],S);class b extends f.$jc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new f.$ic)}start(I){this.stop();const p=++this.a,k=new F.$od;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,f.$hc)(()=>clearTimeout(this.f))),this.b.add((0,f.$hc)(()=>k.cancel())),this.b.add((0,f.$hc)(()=>this.c?this.c.done():void 0)),{id:p,token:k.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$4u=b,e.$5u=(0,L.$Ah)("editorProgressService")}),define(De[42],Ce([1,0,58,18]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class f{constructor(){this.a=new Map}add(R,m){C.ok(F.$if(R)),C.ok(F.$kf(m)),C.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$7m=new f}),define(De[106],Ce([1,0,4,42]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function f(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class L{constructor(){this.b=new C.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,b){this.a[f(S)]=b,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;F.$7m.add(e.$8m.JSONContribution,R)}),define(De[136],Ce([1,0,19,4,18,188,49,106,42]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var b;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$_m={Configuration:"base.contributions.configuration"};var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const I=S.$7m.as(m.$8m.JSONContribution);class p{constructor(){this.h=new Set,this.i=new F.$ed,this.onDidSchemaChange=this.i.event,this.j=new F.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const a=new Set;this.n(t,o,a),I.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const o=new Set;this.o(t,o),I.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const a=new Set;this.o(o,a),this.n(t,!1,a),I.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const a=[];for(const{overrides:n,source:c}of t)for(const h in n)if(o.add(h),e.$jn.test(h)){const E=this.a.get(h),y=E?.valuesSources??new Map;if(c)for(const A of Object.keys(n[h]))y.set(A,c);const u={...E?.value||{},...n[h]};this.a.set(h,{source:c,value:u,valuesSources:y});const l=(0,R.$ei)(h),w={type:"object",default:u,description:L.localize(1,null,l),$ref:e.$gn,defaultDefaultValue:u,source:f.$if(c)?void 0:c,defaultValueSource:c};a.push(...v(h)),this.d[h]=w,this.b.properties[h]=w}else{this.a.set(h,{value:n[h],source:c});const E=this.d[h];E&&(this.w(h,E),this.r(h,E))}this.m(a)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:a,source:n}of t)for(const c in a){const h=this.a.get(c),E=f.$if(n)?n:n?.id,y=f.$if(h?.source)?h?.source:h?.source?.id;if(E===y)if(o.add(c),this.a.delete(c),e.$jn.test(c))delete this.d[c],delete this.b.properties[c];else{const u=this.d[c];u&&(this.w(c,u),this.r(c,u))}}this.u()}deltaConfiguration(t){let o=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,a){t.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,a),this.c.push(n),this.q(n)})}o(t,o){const a=n=>{if(n.properties)for(const c in n.properties){o.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,n.properties[c])}n.allOf?.forEach(c=>a(c))};for(const n of t){a(n);const c=this.c.indexOf(n);c!==-1&&this.c.splice(c,1)}}p(t,o=!0,a,n,c=3,h){c=f.$rf(t.scope)?c:t.scope;const E=t.properties;if(E)for(const u in E){const l=E[u];if(o&&d(u,l)){delete E[u];continue}if(l.source=a,l.defaultDefaultValue=E[u].default,this.w(u,l),e.$jn.test(u)?l.scope=void 0:(l.scope=f.$rf(l.scope)?c:l.scope,l.restricted=f.$rf(l.restricted)?!!n?.includes(u):l.restricted),E[u].hasOwnProperty("included")&&!E[u].included){this.f[u]=E[u],delete E[u];continue}else this.d[u]=E[u],E[u].policy?.name&&this.e.set(E[u].policy.name,u);!E[u].deprecationMessage&&E[u].markdownDeprecationMessage&&(E[u].deprecationMessage=E[u].markdownDeprecationMessage),h.add(u)}const y=t.allOf;if(y)for(const u of y)this.p(u,o,a,n,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=a=>{const n=a.properties;if(n)for(const h in n)this.r(h,n[h]);a.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$an.properties[t]=o,o.scope){case 1:e.$bn.properties[t]=o;break;case 2:e.$cn.properties[t]=o;break;case 6:e.$dn.properties[t]=o;break;case 3:e.$en.properties[t]=o;break;case 4:e.$fn.properties[t]=o;break;case 5:e.$fn.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$an.properties[t],o.scope){case 1:delete e.$bn.properties[t];break;case 2:delete e.$cn.properties[t];break;case 6:delete e.$dn.properties[t];break;case 3:delete e.$en.properties[t];break;case 4:case 5:delete e.$fn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$gn};this.w(o,a),e.$an.properties[o]=a,e.$bn.properties[o]=a,e.$cn.properties[o]=a,e.$dn.properties[o]=a,e.$en.properties[o]=a,e.$fn.properties[o]=a}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=t,e.$bn.patternProperties[e.$in]=t,e.$cn.patternProperties[e.$in]=t,e.$dn.patternProperties[e.$in]=t,e.$en.patternProperties[e.$in]=t,e.$fn.patternProperties[e.$in]=t,this.i.fire()}w(t,o){const a=this.a.get(t);let n=a?.value,c=a?.source;f.$pf(n)&&(n=o.defaultDefaultValue,c=void 0),f.$pf(n)&&(n=i(o.type)),o.default=n,o.defaultValueSource=c}}const k="\\[([^\\]]+)\\]",D=new RegExp(k,"g");e.$in=`^(${k})+$`,e.$jn=new RegExp(e.$in);function v(g){const t=[];if(e.$jn.test(g)){let o=D.exec(g);for(;o?.length;){const a=o[1].trim();a&&t.push(a),o=D.exec(g)}}return(0,C.$Jb)(t)}e.$kn=v;function r(g){return g.reduce((t,o)=>`${t}[${o}]`,"")}e.$ln=r;function i(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=i;const s=new p;S.$7m.add(e.$_m.Configuration,s);function d(g,t){return g.trim()?e.$jn.test(g)?L.localize(7,null,g):s.getConfigurationProperties()[g]!==void 0?L.localize(8,null,g):t.policy?.name&&s.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,g,t.policy?.name,s.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$nn=d;function $(){const g=[],t=s.getConfigurationProperties();for(const o of Object.keys(t))g.push([o,t[o].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$on=$}),define(De[245],Ce([1,0,19,4,157,3,28,23,18,2,49,136,42]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function k(o){return Object.isFrozen(o)?o:m.$Vm(o)}class D{constructor(a={},n=[],c=[],h){this.b=a,this.c=n,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(n=>{if(n instanceof D)return n;const c=new v("");return c.parseRaw(n),c.configurationModel});this.f=a.reduce((n,c)=>c===n?c:n.merge(c),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,P.$ci)(this.contents,a):this.contents}inspect(a,n){const c=this.rawConfiguration.getValue(a),h=n?this.rawConfiguration.getOverrideValue(a,n):void 0,E=n?this.rawConfiguration.override(n).getValue(a):c;return{value:c,override:h,merged:E}}getOverrideValue(a,n){const c=this.i(n);return c?a?(0,P.$ci)(c,a):c:void 0}getKeysForOverrideIdentifier(a){const n=[];for(const c of this.overrides)c.identifiers.includes(a)&&n.push(...c.keys);return C.$Jb(n)}getAllOverrideIdentifiers(){const a=[];for(const n of this.overrides)a.push(...n.identifiers);return C.$Jb(a)}override(a){let n=this.a.get(a);return n||(n=this.g(a),this.a.set(a,n)),n}merge(...a){const n=m.$Um(this.contents),c=m.$Um(this.overrides),h=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const y of a)if(E.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.h(n,y.contents);for(const u of y.overrides){const[l]=c.filter(w=>C.$sb(w.identifiers,u.identifiers));l?(this.h(l.contents,u.contents),l.keys.push(...u.keys),l.keys=C.$Jb(l.keys)):c.push(m.$Um(u))}for(const u of y.keys)h.indexOf(u)===-1&&h.push(u)}return new D(n,h,c,E.every(y=>y instanceof D)?void 0:E)}g(a){const n=this.i(a);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const c={};for(const h of C.$Jb([...Object.keys(this.contents),...Object.keys(n)])){let E=this.contents[h];const y=n[h];y&&(typeof E=="object"&&typeof y=="object"?(E=m.$Um(E),this.h(E,y)):E=y),c[h]=E}return new D(c,this.keys,this.overrides)}h(a,n){for(const c of Object.keys(n)){if(c in a&&S.$kf(a[c])&&S.$kf(n[c])){this.h(a[c],n[c]);continue}a[c]=m.$Um(n[c])}}i(a){let n=null,c=null;const h=E=>{E&&(c?this.h(c,E):c=m.$Um(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===a?n=E.contents:E.identifiers.includes(a)&&h(E.contents);return h(n),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,n){this.j(a,n,!0)}setValue(a,n){this.j(a,n,!1)}removeValue(a){const n=this.keys.indexOf(a);n!==-1&&(this.keys.splice(n,1),(0,P.$bi)(this.contents,a),I.$jn.test(a)&&this.overrides.splice(this.overrides.findIndex(c=>C.$sb(c.identifiers,(0,I.$kn)(a))),1))}j(a,n,c){(0,P.$ai)(this.contents,a,n,h=>console.error(h)),c=c||this.keys.indexOf(a)===-1,c&&this.keys.push(a),I.$jn.test(a)&&this.overrides.push({identifiers:(0,I.$kn)(a),keys:Object.keys(this.contents[a]),contents:(0,P.$_h)(this.contents[a],h=>console.error(h))})}}e.$pn=D;class v{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,n){if(!S.$rf(a)){const c=this.g(a);this.parseRaw(c,n)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,n){this.a=a;const{contents:c,keys:h,overrides:E,restricted:y,hasExcludedProperties:u}=this.h(a,n);this.b=new D(c,h,E,u?[a]:void 0),this.c=y||[]}g(a){let n={},c=null,h=[];const E=[],y=[];function u(w){Array.isArray(h)?h.push(w):c!==null&&(h[c]=w)}const l={onObjectBegin:()=>{const w={};u(w),E.push(h),h=w,c=null},onObjectProperty:w=>{c=w},onObjectEnd:()=>{h=E.pop()},onArrayBegin:()=>{const w=[];u(w),E.push(h),h=w,c=null},onArrayEnd:()=>{h=E.pop()},onLiteralValue:u,onError:(w,A,O)=>{y.push({error:w,offset:A,length:O})}};if(a)try{f.$Rm(a,l),n=h[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return n}h(a,n){const c=p.$7m.as(I.$_m.Configuration).getConfigurationProperties(),h=this.i(a,c,!0,n);a=h.raw;const E=(0,P.$_h)(a,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),y=Object.keys(a),u=this.j(a,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:E,keys:y,overrides:u,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(a,n,c,h){let E=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:E};const y={},u=[];for(const l in a)if(I.$jn.test(l)&&c){const w=this.i(a[l],n,!1,h);y[l]=w.raw,E=E||w.hasExcludedProperties,u.push(...w.restricted)}else{const w=n[l],A=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&u.push(l),!h.exclude?.includes(l)&&(h.include?.includes(l)||(A===void 0||h.scopes===void 0||h.scopes.includes(A))&&!(h.skipRestricted&&w?.restricted))?y[l]=a[l]:E=!0}return{raw:y,restricted:u,hasExcludedProperties:E}}j(a,n){const c=[];for(const h of Object.keys(a))if(I.$jn.test(h)){const E={};for(const y in a[h])E[y]=a[h][y];c.push({identifiers:(0,I.$kn)(h),keys:Object.keys(E),contents:(0,P.$_h)(E,n)})}return c}}e.$qn=v;class r extends L.$jc{constructor(a,n,c,h){super(),this.c=a,this.f=n,this.g=h,this.b=this.B(new F.$ed),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&c.isEqual(E.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=r;class i{constructor(a,n,c,h,E,y,u,l,w,A,O,N,T){this.a=a,this.b=n,this.c=c,this.overrideIdentifiers=h,this.d=E,this.f=y,this.g=u,this.h=l,this.i=w,this.j=A,this.k=O,this.l=N,this.m=T}get value(){return k(this.c)}n(a,n,c){const h=a.inspect(n,c);return{get value(){return k(h.value)},get override(){return k(h.override)},get merged(){return k(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class s{constructor(a,n,c,h,E=new D,y=new D,u=new R.$yi,l=new D,w=new R.$yi){this.c=a,this.d=n,this.f=c,this.g=h,this.h=E,this.i=y,this.j=u,this.l=l,this.m=w,this.a=null,this.b=new R.$yi,this.n=null}getValue(a,n,c){return this.q(a,n,c).getValue(a)}updateValue(a,n,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new D,this.m.set(c.resource,h))):h=this.l,n===void 0?h.removeValue(a):h.setValue(a,n),c.resource||(this.a=null)}inspect(a,n,c){const h=this.q(a,n,c),E=this.u(n.resource,c),y=n.resource?this.m.get(n.resource)||this.l:this.l,u=new Set;for(const l of h.overrides)for(const w of l.identifiers)h.getOverrideValue(a,w)!==void 0&&u.add(w);return new i(a,n,h.getValue(a),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,E||void 0,y)}keys(a){const n=this.u(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,n){this.j.set(a,n),this.b.delete(a)}deleteFolderConfiguration(a){this.p.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,n){const c=[];if(!n){const{added:h,updated:E,removed:y}=g(this.c,a);n=[...h,...E,...y]}for(const h of n)for(const E of(0,I.$kn)(h)){const y=this.c.getKeysForOverrideIdentifier(E),u=a.getKeysForOverrideIdentifier(E),l=[...u.filter(w=>y.indexOf(w)===-1),...y.filter(w=>u.indexOf(w)===-1),...y.filter(w=>!m.$Ym(this.c.override(E).getValue(w),a.override(E).getValue(w)))];c.push([E,l])}return this.updateDefaultConfiguration(a),{keys:n,overrides:c}}compareAndUpdatePolicyConfiguration(a){const{added:n,updated:c,removed:h}=g(this.d,a),E=[...n,...c,...h];return E.length&&this.updatePolicyConfiguration(a),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:n,updated:c,removed:h,overrides:E}=g(this.applicationConfiguration,a),y=[...n,...c,...h];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:E}}compareAndUpdateLocalUserConfiguration(a){const{added:n,updated:c,removed:h,overrides:E}=g(this.localUserConfiguration,a),y=[...n,...c,...h];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:E}}compareAndUpdateRemoteUserConfiguration(a){const{added:n,updated:c,removed:h,overrides:E}=g(this.remoteUserConfiguration,a),y=[...n,...c,...h];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:E}}compareAndUpdateWorkspaceConfiguration(a){const{added:n,updated:c,removed:h,overrides:E}=g(this.workspaceConfiguration,a),y=[...n,...c,...h];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:E}}compareAndUpdateFolderConfiguration(a,n){const c=this.p.get(a),{added:h,updated:E,removed:y,overrides:u}=g(c,n),l=[...h,...E,...y];return(l.length||!c)&&this.updateFolderConfiguration(a,n),{keys:l,overrides:u}}compareAndDeleteFolderConfiguration(a){const n=this.p.get(a);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:c,updated:h,removed:E,overrides:y}=g(n,void 0);return{keys:[...c,...h,...E],overrides:y}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(a,n,c){let h=this.r(n,c);return n.overrideIdentifier&&(h=h.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(h=h.merge(this.d)),h}r({resource:a},n){let c=this.s();if(n&&a){const h=n.getFolder(a);h&&(c=this.t(h.uri)||c);const E=this.m.get(a);E&&(c=c.merge(E))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(a){let n=this.b.get(a);if(!n){const c=this.s(),h=this.j.get(a);h?(n=c.merge(h),this.b.set(a,n)):n=c}return n}u(a,n){if(n&&a){const c=n.getFolder(a);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,n)=>{const{contents:c,overrides:h,keys:E}=this.j.get(n);return a.push([n,{contents:c,overrides:h,keys:E}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(n=>a.add(n)),this.userConfiguration.keys.forEach(n=>a.add(n)),this.i.keys.forEach(n=>a.add(n)),this.j.forEach(n=>n.keys.forEach(c=>a.add(c))),[...a.values()]}v(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>a.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>a.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>a.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(c=>a.add(c))),[...a.values()]}w(a){const n=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(c=>n.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(c=>n.add(c)),this.i.getKeysForOverrideIdentifier(a).forEach(c=>n.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(a).forEach(h=>n.add(h))),[...n.values()]}static parse(a){const n=this.x(a.defaults),c=this.x(a.policy),h=this.x(a.application),E=this.x(a.user),y=this.x(a.workspace),u=a.folders.reduce((l,w)=>(l.set(b.URI.revive(w[0]),this.x(w[1])),l),new R.$yi);return new s(n,c,h,E,new D,y,u,new D,new R.$yi)}static x(a){return new D(a.contents,a.keys,a.overrides)}}e.$sn=s;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const a=new Set,n=new Map;for(const h of o)h.keys.forEach(E=>a.add(E)),h.overrides.forEach(([E,y])=>{const u=(0,R.$vi)(n,E,new Set);y.forEach(l=>u.add(l))});const c=[];return n.forEach((h,E)=>c.push([E,[...h.values()]])),{keys:[...a.values()],overrides:c}}e.$tn=d;class ${constructor(a,n,c,h){this.change=a,this.f=n,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const E of a.keys)this.affectedKeys.add(E);for(const[,E]of a.overrides)for(const y of E)this.affectedKeys.add(y);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=s.parse(this.f.data)),this.i}affectsConfiguration(a,n){const c=this.a+a,h=this.d.indexOf(c);if(h<0)return!1;const E=h+c.length;if(E>=this.d.length)return!1;const y=this.d.charCodeAt(E);if(y!==this.b&&y!==this.c)return!1;if(n){const u=this.previousConfiguration?this.previousConfiguration.getValue(a,n,this.f?.workspace):void 0,l=this.g.getValue(a,n,this.h);return!m.$Ym(u,l)}return!0}}e.$un=$;function g(o,a){const{added:n,removed:c,updated:h}=t(a?.rawConfiguration,o?.rawConfiguration),E=[],y=o?.getAllOverrideIdentifiers()||[],u=a?.getAllOverrideIdentifiers()||[];if(a){const l=u.filter(w=>!y.includes(w));for(const w of l)E.push([w,a.getKeysForOverrideIdentifier(w)])}if(o){const l=y.filter(w=>!u.includes(w));for(const w of l)E.push([w,o.getKeysForOverrideIdentifier(w)])}if(a&&o){for(const l of y)if(u.includes(l)){const w=t({contents:o.getOverrideValue(void 0,l)||{},keys:o.getKeysForOverrideIdentifier(l)},{contents:a.getOverrideValue(void 0,l)||{},keys:a.getKeysForOverrideIdentifier(l)});E.push([l,[...w.added,...w.removed,...w.updated]])}}return{added:n,removed:c,updated:h,overrides:E}}function t(o,a){const n=o?a?o.keys.filter(E=>a.keys.indexOf(E)===-1):[...o.keys]:[],c=a?o?a.keys.filter(E=>o.keys.indexOf(E)===-1):[...a.keys]:[],h=[];if(o&&a){for(const E of a.keys)if(o.keys.indexOf(E)!==-1){const y=(0,P.$ci)(a.contents,E),u=(0,P.$ci)(o.contents,E);m.$Ym(y,u)||h.push(E)}}return{added:n,removed:c,updated:h}}}),define(De[246],Ce([1,0,22,4,3,81]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkb=e.$lkb=e.$kkb=e.$jkb=void 0;const R=(b,P,I)=>{const p=new Uint8Array(16);for(let v=0;v<16;v++)p[v]=Math.round(Math.random()*256);const k=(0,C.$Yd)(C.$Ed.wrap(p));return[`GET ws://localhost${b}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$jkb=R,e.$kkb=C.$Ed.fromString(`\r
\r
`);async function m(b,P,I,p,k){b.write(C.$Ed.fromString((0,e.$jkb)(P,I,p)));const D=new f.$ic;try{return await new Promise((v,r)=>{let i;D.add(b.onData(s=>{i?i=C.$Ed.concat([i,s],i.byteLength+s.byteLength):i=s;const d=i.indexOf(e.$kkb);if(d===-1)return;v(b),b.pauseData();const $=i.slice(d+e.$kkb.byteLength);$.byteLength&&k.onData.fire($)})),D.add(b.onClose(s=>r(s??new Error("socket closed")))),D.add(b.onEnd(()=>r(new Error("socket ended"))))})}catch(v){throw b.dispose(),v}finally{D.dispose()}}e.$lkb=m;class S extends f.$jc{constructor(P,I){super(),this.g=P,this.a=this.B(new F.$hd),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new F.$ed),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,P,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$mkb=S}),define(De[65],Ce([1,0,8,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.RemoteAuthorityResolverErrorCode=e.$Kk=e.$Jk=e.RemoteConnectionType=e.$Ik=void 0,e.$Ik=(0,F.$Ah)("remoteAuthorityResolverService");var f;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Jk=L;class R{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Kk=R;var m;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class S extends C.$_{static isNotAvailable(I){return I instanceof S&&I._code===m.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof S&&I._code===m.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof S&&I._code===m.NoResolverFound}static isInvalidAuthority(I){return I instanceof S&&I._code===m.InvalidAuthority}static isHandled(I){return I instanceof S&&I.isHandled}constructor(I,p=m.Unknown,k){super(I),this._message=I,this._code=p,this._detail=k,this.isHandled=p===m.NotAvailable&&k===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Lk=S;function b(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.$Mk=b}),define(De[66],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function F(b){return b.scheme===C.Schemas.vscodeRemote?b.authority:void 0}e.$Nk=F;function f(b){if(!b)return;const P=b.indexOf("+");return P<0?b:b.substr(0,P)}e.$Ok=f;function L(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Pk=L;function R(b){const{host:P,port:I}=S(b);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:I}}e.$Qk=R;function m(b,P){let{host:I,port:p}=S(b);return typeof p>"u"&&(p=P),{host:I,port:p}}e.$Rk=m;function S(b){const P=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const p=b.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:b,port:void 0}}}),define(De[25],Ce([1,0,15,5,66]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function L(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Sl=L,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class S{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,i){if(typeof r>"u"||r===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof r=="string"||typeof i=="string"){const s=typeof r=="string"?r:r.value,d=typeof i=="string"?i:i.value;return C.$Le(s,d)}return r._lower===i._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Ul=S;class b{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const i of r)this.add(i)}add(r){this.c.add(S.toKey(r))}delete(r){return this.c.delete(S.toKey(r))}has(r){return this.c.has(S.toKey(r))}}e.$Vl=b;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(S.toKey(r))}get(r){return this.c.get(S.toKey(r))}has(r){return this.c.has(S.toKey(r))}set(r,i){this.c.set(S.toKey(r),i)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=P;function I(v){return p(v)}e.$Xl=I;function p(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Yl=p;function k(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$Zl=k;function D(v,r){if(r){const i=`onResolveRemoteAuthority:${(0,f.$Ok)(r)}`;return!!v.activationEvents?.includes(i)}return!1}e.$1l=D,e.$2l=(0,F.$Ah)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,8,25]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const S of R){const b=this.readActivationEvents(S);b.length>0&&(m[F.$Ul.toKey(S.identifier)]=b)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return m;for(const S in R.contributes){const b=this.a.get(S);if(!b)continue;const P=R.contributes[S],I=Array.isArray(P)?P:[P];try{b(I,m)}catch(p){(0,C.$Y)(p)}}return m}}e.$xF=f,e.$yF=new f}),define(De[247],Ce([1,0,11,22,21,8,4,3,53,37,31,81,65,66]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.PersistentConnectionEventType=e.$Yk=e.$Xk=e.$Wk=e.ConnectionType=void 0;const D=30*1e3;var v;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function r(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function i(G){const U=new f.$od;return setTimeout(()=>U.cancel(),G),U.token}function s(G,U){if(G.isCancellationRequested||U.isCancellationRequested)return f.CancellationToken.Cancelled;const K=new f.$od;return G.onCancellationRequested(()=>K.cancel()),U.onCancellationRequested(()=>K.cancel()),K.token}class d{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new m.$ic,this.promise=new Promise((K,Y)=>{this.f=K,this.g=Y}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function $(G,U){const K=new d(U);return K.registerDisposable(G.onControlMessage(Y=>{const se=JSON.parse(Y.toString()),re=Q(se);re?K.reject(re):K.resolve(se)})),K.promise}function g(G,U,K,Y,se,re,le,Ee){const he=new d(Ee),fe=b.$ad.create(!1);return G.info(`Creating a socket (${le})...`),S.mark(`code/willCreateSocket/${re}`),U.connect(K,Y,se,le).then(te=>{he.didTimeout?(S.mark(`code/didCreateSocketError/${re}`),G.info(`Creating a socket (${le}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(S.mark(`code/didCreateSocketOK/${re}`),G.info(`Creating a socket (${le}) was successful after ${fe.elapsed()} ms.`),he.resolve(te))},te=>{S.mark(`code/didCreateSocketError/${re}`),G.info(`Creating a socket (${le}) returned an error after ${fe.elapsed()} ms.`),G.error(te),he.reject(te)}),he.promise}function t(G,U){const K=new d(U);return G.then(Y=>{K.didTimeout||K.resolve(Y)},Y=>{K.didTimeout||K.reject(Y)}),K.promise}async function o(G,U,K,Y){const se=ce(G,U);G.logService.trace(`${se} 1/6. invoking socketFactory.connect().`);let re;try{re=await g(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,k.$Pk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,r(U),`renderer-${r(U)}-${G.reconnectionToken}`,Y)}catch(te){throw G.logService.error(`${se} socketFactory.connect() failed or timed out. Error:`),G.logService.error(te),te}G.logService.trace(`${se} 2/6. socketFactory.connect() was successful.`);let le,Ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(re,null),le=G.reconnectionProtocol,Ee=!1):(le=new I.$oh({socket:re}),Ee=!0),G.logService.trace(`${se} 3/6. sending AuthRequest control message.`);const he=await t(G.signService.createNewMessage((0,P.$3f)()),Y),fe={type:"auth",auth:G.connectionToken||"00000000000000000000",data:he.data};le.sendControl(F.$Ed.fromString(JSON.stringify(fe)));try{const te=await $(le,s(Y,i(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(G.logService.trace(`${se} 4/6. received SignRequest control message.`),!await t(G.signService.validate(he,te.signedData),Y)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(G.signService.sign(te.data),Y),Pe={type:"connectionType",commit:G.commit,signedData:be,desiredConnectionType:U};return K&&(Pe.args=K),G.logService.trace(`${se} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(F.$Ed.fromString(JSON.stringify(Pe))),{protocol:le,ownsProtocol:Ee}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(G.logService.error(`${se} the handshake timed out. Error:`),G.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${se} received error control message when negotiating connection. Error:`),G.logService.error(te)),Ee&&x(le),te}}async function a(G,U,K,Y){const se=Date.now(),re=ce(G,U),{protocol:le,ownsProtocol:Ee}=await o(G,U,K,Y),he=new d(Y);return he.registerDisposable(le.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),ue=Q(te);ue?(G.logService.error(`${re} received error control message when negotiating connection. Error:`),G.logService.error(ue),Ee&&x(le),he.reject(ue)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${re} 6/6. handshake finished, connection is up and running after ${we(se)}!`),he.resolve({protocol:le,firstMessage:te}))})),he.promise}async function n(G,U){const{protocol:K}=await a(G,1,void 0,U);return{protocol:K}}async function c(G,U,K){const{protocol:Y,firstMessage:se}=await a(G,2,U,K),re=se&&se.debugPort;return{protocol:Y,debugPort:re}}async function h(G,U,K){const Y=Date.now(),se=ce(G,3),{protocol:re}=await o(G,3,U,K);return G.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${we(Y)}!`),re}async function E(G,U,K){const{connectTo:Y,connectionToken:se}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:Y,connectionToken:se,reconnectionToken:U,reconnectionProtocol:K,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function y(G,U,K){return l(G,async Y=>{const{protocol:se}=await n(Y,f.CancellationToken.None);return new q(G,U,K,Y.reconnectionToken,se)})}e.$Wk=y;async function u(G,U){return l(G,async K=>{const{protocol:Y,debugPort:se}=await c(K,U,f.CancellationToken.None);return new me(G,U,K.reconnectionToken,Y,se)})}e.$Xk=u;async function l(G,U){for(let Y=1;;Y++)try{const se=(0,P.$3f)(),re=await E(G,se,null);return await U(re)}catch(se){if(Y<5)G.logService.error(`[remote-connection][attempt ${Y}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(se);else throw G.logService.error(`[remote-connection][attempt ${Y}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(se),H.triggerPermanentFailure(0,0,p.$Lk.isHandled(se)),se}}async function w(G,U,K){const Y=await E(G,(0,P.$3f)(),null);return await h(Y,{host:U,port:K},f.CancellationToken.None)}e.$Yk=w;function A(G){return(0,C.$tg)(U=>new Promise((K,Y)=>{const se=setTimeout(K,G*1e3);U.onCancellationRequested(()=>{clearTimeout(se),K()})}))}var O;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class N{constructor(U,K){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.type=0}}e.$Zk=N;class T{constructor(U,K,Y,se){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.durationSeconds=Y,this.c=se,this.type=1}skipWait(){this.c.cancel()}}e.$1k=T;class j{constructor(U,K,Y){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=Y,this.type=2}}e.$2k=j;class z{constructor(U,K,Y){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=Y,this.type=4}}e.$3k=z;class M{constructor(U,K,Y,se){this.reconnectionToken=U,this.millisSinceLastIncomingData=K,this.attempt=Y,this.handled=se,this.type=3}}e.$4k=M;class H extends m.$jc{static triggerPermanentFailure(U,K,Y){this._permanentFailure=!0,this.f=U,this.g=K,this.h=Y,this.j.forEach(se=>se.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||H._permanentFailure}constructor(U,K,Y,se,re){super(),this.t=U,this.u=K,this.reconnectionToken=Y,this.protocol=se,this.w=re,this.m=this.B(new R.$ed),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(se.onSocketClose(le=>{const Ee=ge(this.t,this.reconnectionToken,!0);le?le.type===0?(this.u.logService.info(`${Ee} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${Ee} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${Ee} received socket close event.`),this.y()})),this.B(se.onSocketTimeout(le=>{const Ee=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),H.j.push(this),this.B((0,m.$hc)(()=>{const le=H.j.indexOf(this);le>=0&&H.j.splice(le,1)})),this.n&&this.D(H.f,H.g,H.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let Y=-1;do{Y++;const se=Y<K.length?K[Y]:K[K.length-1];try{if(se>0){const le=A(se);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se,le)),this.u.logService.info(`${U} waiting for ${se} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1)),this.u.logService.info(`${U} resolving connection...`);const re=await E(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${re.connectTo}...`),await this.G(re,i(D)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1));break}catch(re){if(re.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(Y>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(p.$Lk.isTemporarilyNotAvailable(re)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if((re.code==="ETIMEDOUT"||re.code==="ENETUNREACH"||re.code==="ECONNREFUSED"||re.code==="ECONNRESET")&&re.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if((0,L.$2)(re)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(re);continue}if(re instanceof p.$Lk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,p.$Lk.isHandled(re));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(re),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}}while(!this.n&&!this.s)}C(U,K,Y){this.w?H.triggerPermanentFailure(U,K,Y):this.D(U,K,Y)}D(U,K,Y){this.m.fire(new M(this.reconnectionToken,U,K,Y)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5k=H;class q extends H{constructor(U,K,Y,se,re){super(1,U,se,re,!0),this.client=this.B(new I.$mh(re,{remoteAuthority:K,clientId:Y},U.ipcLogger))}async G(U,K){await n(U,K)}}e.$6k=q;class me extends H{constructor(U,K,Y,se,re){super(2,U,Y,se,!1),this.H=K,this.debugPort=re}async G(U,K){await c(U,this.H,K)}}e.$7k=me;function x(G){try{G.acceptDisconnect();const U=G.getSocket();G.dispose(),U.dispose()}catch(U){(0,L.$Y)(U)}}function Q(G){if(G&&G.type==="error"){const U=new Error(`Connection error: ${G.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function V(G,U){for(;G.length<U;)G+=" ";return G}function _(G,U){return`[remote-connection][${V(r(G),13)}][${U.substr(0,5)}\u2026]`}function ge(G,U,K){return`${_(G,U)}[${K?"reconnect":"initial"}]`}function ce(G,U){return`${ge(U,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function we(G){return`${Date.now()-G} ms`}}),define(De[248],Ce([1,0,3,5]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=void 0,e.$Sk=(0,F.$Ah)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(R,m){return this.a[R]??=[],this.a[R].push(m),(0,C.$hc)(()=>{const S=this.a[R]?.indexOf(m);typeof S=="number"&&S>=0&&this.a[R]?.splice(S,1)})}b(R){return(this.a[R.type]||[]).find(S=>S.supports(R))}connect(R,m,S,b){const P=this.b(R);if(!P)throw new Error(`No socket factory found for ${R}`);return P.connect(R,m,S,b)}}e.$Tk=f}),define(De[249],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c2b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const L=await this.c();if(L){const R=String(C.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,L){if(!f.id)return!0;const R=this.b.get(f.id);if(!R)return!1;this.b.delete(f.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$c2b=C}),define(De[107],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=void 0,e.$Uk="signService",e.$Vk=(0,C.$Ah)(e.$Uk)}),define(De[138],Ce([1,0,249]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=void 0;class F extends C.$c2b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(R=>new R.signer().sign(L))}h(){return new Promise((L,R)=>$e(["vsda"],L,R))}}e.$Z6b=F}),define(De[250],Ce([1,0,12,47,31]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function L(S){if(C.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function R(S,b,P,I,p,k,D,v){const r=Object.create(null);r["common.machineId"]=k,r.sessionID=(0,f.$3f)()+Date.now(),r.commitHash=I,r.version=p,r["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,C.$h)(C.$t),r["common.nodePlatform"]=F.$2d,r["common.nodeArch"]=P,r["common.product"]=v||"desktop",D&&(r["common.msftInternal"]=D);let i=0;const s=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(r["common.snap"]="true");const d=L(b);return d&&(r["common.platformDetail"]=d),r}e.$9n=R;function m(S){const b=F.env.USERDNSDOMAIN;if(!b)return!1;const P=b.toLowerCase();return S.some(I=>P===I)}e.$0n=m}),define(De[251],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,C.$Ah)("telemetryService"),e.$9k=(0,C.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(De[85],Ce([1,0,23,18,4,49,66,250,251]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class b{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$$n=b;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=P,e.$ao=new P;class I{async publicLog(c,h,E){}async publicLogError(c,h,E){}}e.$bo=I,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function p(n,c){return f.Event.debounce(c.onDidChangeConfiguration,(E,y)=>{const u=E?new Set([...E.affectedKeys,...y.affectedKeys]):y.affectedKeys;return{...y,affectedKeys:u}},1e3,!0)(E=>{E.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,L.$0h)(E.source),configurationKeys:Array.from(E.affectedKeys)})})}e.$fo=p;function k(n,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!n.enableTelemetry||c.extensionTestsLocationURI)}e.$go=k;function D(n,c){return!(c.isBuilt||c.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$ho=D;function v(n){const c=n.getValue(S.$cl),h=n.getValue(S.$dl);if(n.getValue(S.$el)===!1||h===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=v;function r(n){const c={},h={},E={};d(n,E);for(let y in E){y=y.length>150?y.substr(y.length-149):y;const u=E[y];typeof u=="number"?h[y]=u:typeof u=="boolean"?h[y]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${u.length}`),c[y]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(c[y]=u)}return{properties:c,measurements:h}}e.$jo=r;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(n){if(!n)return"none";const c=(0,R.$Ok)(n);return i.has(c)?c:"other"}e.$ko=s;function d(n,c,h=0,E){if(n)for(const y of Object.getOwnPropertyNames(n)){const u=n[y],l=E?E+y:y;Array.isArray(u)?c[l]=(0,C.$Zm)(u):u instanceof Date?c[l]=u.toISOString():(0,F.$kf)(u)?h<2?d(u,c,h+1,l+"."):c[l]=(0,C.$Zm)(u):c[l]=u}}function $(n,c){const h=n.msftInternalDomains||[],E=c.getValue("telemetry.internalTesting");return(0,m.$0n)(h)||E}e.$lo=$;function g(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$mo=g;function t(n,c){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let h=n;const E=[];for(const w of c)for(;;){const A=w.exec(n);if(!A)break;E.push([A.index,w.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(h="";;){const w=u.exec(n);if(!w)break;const A=E.some(([O,N])=>w.index<N&&O<u.lastIndex);!y.test(w[0])&&!A&&(h+=n.substring(l,w.index)+"<REDACTED: user-file-path>",l=u.lastIndex)}return l<n.length&&(h+=n.substr(l)),h}function o(n){if(!n)return n;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of c)if(h.regex.test(n))return`<REDACTED: ${h.label}>`;return n}function a(n,c){return(0,C.$Wm)(n,h=>{if(h instanceof b||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let E=h.replaceAll("%20"," ");E=t(E,c);for(const y of c)E=E.replace(y,"");return E=o(E),E}})}e.$no=a}),define(De[252],Ce([1,0,15,132,25,12,2,8,47,85]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function P(a,n){return a.uuid&&n.uuid?a.uuid===n.uuid:a.id===n.id?!0:(0,C.$Ge)(a.id,n.id)===0}e.$oo=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(n){const c=n.manifest?n.manifest.version:n.version,h=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new p(n.identifier,c,h)}static parse(n){const c=I.exec(n);return c&&c[1]&&c[2]?new p({id:c[1]},c[2],c[4]||void 0):null}constructor(n,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof p?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$po=p;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(a){const n=k.exec(a);return n&&n[1]?[r(n[1]),n[2]]:[r(a),void 0]}e.$qo=D;function v(a,n){return`${a}.${n}`}e.$ro=v;function r(a){return a.toLowerCase()}e.$so=r;function i(a,n){return r(v(a??f.$Ql,n))}e.$to=i;function s(a,n){const c=[],h=E=>{for(const y of c)if(y.some(u=>P(n(u),n(E))))return y;return null};for(const E of a){const y=h(E);y?y.push(E):c.push([E])}return c}e.$uo=s;function d(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$vo=d;function $(a){return{id:new b.$$n(a.identifier.id),name:new b.$$n(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$wo=$,e.$xo=new f.$Ul("pprice.better-merge");function g(a,n){const c=[],h=n.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const E=h.shift();if(E&&c.every(y=>!P(y.identifier,{id:E}))){const y=a.filter(u=>P(u.identifier,{id:E}));y.length===1&&(c.push(y[0]),h.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$yo=g;async function t(a,n){if(!L.$k)return!1;let c;try{c=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){n.debug("Error while getting the os-release file.",(0,m.$8)(E))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(a,n){const c=await t(a,n),h=(0,F.$Tn)(c?"alpine":L.$t,S.$3d);return n.debug("ComputeTargetPlatform:",h),h}e.$zo=o}),define(De[253],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.$ar=e.$_q=e.$$q=void 0;function C(S){return[...S.entries()]}e.$$q=C;function F(S){return S?[...S.entries()]:[]}e.$_q=F;function f(S){return new Map(S)}e.$ar=f;function L(S){return new Map(S??[])}e.$br=L;function R(S){return Array.from(S.entries()).map(b=>[b[0],C(b[1].map),F(b[1].descriptionMap)])}e.$cr=R;function m(S){return new Map(S.map(b=>[b[0],{map:f(b[1]),descriptionMap:L(b[2])}]))}e.$dr=m}),define(De[254],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckb=void 0;class C{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,L,R=5){const m=L(S=>{const b=typeof S=="string"?S:S.data;let P=this.a.get(f);if(P){P.data.push(b);return}const I=setTimeout(()=>this.flushBuffer(f),R);P={data:[b],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(f),m.dispose()}},this.a.set(f,P)});return m}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const L=this.a.get(f);L&&(this.a.delete(f),this.b(f,L.data.join("")))}}e.$Ckb=C}),define(De[255],Ce([1,0,11,78,60,4,18,2,199,106,42]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.IconFontDefinition=e.IconContribution=e.$6u=void 0,e.$6u={IconContribution:"base.contributions.icons"};var I;(function($){function g(t,o){let a=t.defaults;for(;f.ThemeIcon.isThemeIcon(a);){const n=D.getIcon(a.id);if(!n)return;a=n.defaults}return a}$.getDefinition=g})(I||(e.IconContribution=I={}));var p;(function($){function g(o){return{weight:o.weight,style:o.style,src:o.src.map(a=>({format:a.format,location:a.location.toString()}))}}$.toJSONObject=g;function t(o){const a=n=>(0,R.$if)(n)?n:void 0;if(o&&Array.isArray(o.src)&&o.src.every(n=>(0,R.$if)(n.format)&&(0,R.$if)(n.location)))return{weight:a(o.weight),style:a(o.style),src:o.src.map(n=>({format:n.format,location:m.URI.parse(n.location)}))}}$.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class k{constructor(){this.a=new L.$ed,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,t,o,a){const n=this.b[g];if(n){if(o&&!n.description){n.description=o,this.d.properties[g].markdownDescription=`${o} $(${g})`;const E=this.e.enum.indexOf(g);E!==-1&&(this.e.enumDescriptions[E]=o),this.a.fire()}return n}const c={id:g,description:o,defaults:t,deprecationMessage:a};this.b[g]=c;const h={$ref:"#/definitions/icons"};return a&&(h.deprecationMessage=a),o&&(h.markdownDescription=`${o}: $(${g})`),this.d.properties[g]=h,this.e.enum.push(g),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const t=this.e.enum.indexOf(g);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,t){const o=this.f[g];return o||(this.f[g]=t,this.a.fire(),t)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(n,c)=>n.id.localeCompare(c.id),t=n=>{for(;f.ThemeIcon.isThemeIcon(n.defaults);)n=this.b[n.defaults.id];return`codicon codicon-${n?n.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(n=>this.b[n]);for(const n of a.filter(c=>!!c.description).sort(g))o.push(`|<i class="${t(n)}"></i>|${n.id}|${f.ThemeIcon.isThemeIcon(n.defaults)?n.defaults.id:n.id}|${n.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const n of a.filter(c=>!f.ThemeIcon.isThemeIcon(c.defaults)).sort(g))o.push(`|<i class="${t(n)}"></i>|${n.id}|`);return o.join(`
`)}}const D=new k;P.$7m.add(e.$6u.IconContribution,D);function v($,g,t,o){return D.registerIcon($,g,t,o)}e.$7u=v;function r(){return D}e.$8u=r;function i(){const $=(0,F.$Mj)();for(const g in $){const t="\\"+$[g].toString(16);D.registerIcon(g,{fontCharacter:t})}}i(),e.$9u="vscode://schemas/icons";const s=P.$7m.as(b.$8m.JSONContribution);s.registerSchema(e.$9u,D.getIconSchema());const d=new C.$Rg(()=>s.notifySchemaChanged(e.$9u),200);D.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.$0u=v("widget-close",F.$Oj.close,(0,S.localize)(2,null)),e.$$u=v("goto-previous-location",F.$Oj.arrowUp,(0,S.localize)(3,null)),e.$_u=v("goto-next-location",F.$Oj.arrowDown,(0,S.localize)(4,null)),e.$av=f.ThemeIcon.modify(F.$Oj.sync,"spin"),e.$bv=f.ThemeIcon.modify(F.$Oj.loading,"spin")}),define(De[86],Ce([1,0,4,49,5,14]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.ProvidedOnAutoForward=e.$Vz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Uz=e.$Tz=void 0,e.$Tz=(0,f.$Ah)("tunnelService"),e.$Uz=(0,f.$Ah)("sharedTunnelsService");var R;(function(r){r.Http="http",r.Https="https"})(R||(e.TunnelProtocol=R={}));var m;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(m||(e.TunnelPrivacyId=m={}));function S(r){return!!r.forwardPort}e.$Vz=S;var b;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function P(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(i)return{address:i[1],port:+i[2]}}e.$Wz=P,e.$Xz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(r){return e.$Xz.indexOf(r)>=0}e.$Yz=I,e.$Zz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(r){return e.$Zz.indexOf(r)>=0}e.$1z=p;function k(r,i,s,d){if(s===1)return!1;if(s===2&&p(i)){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if($?.length===4&&parseInt($[1])>=18)return!1}return r<1024}e.$2z=k;class D{constructor(i,s,d){this.remoteAddress=i,this.localAddress=s,this.b=d,this.a=new C.$ed,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$3z=D;let v=class{constructor(i,s){this.j=i,this.k=s,this.a=new C.$ed,this.onTunnelOpened=this.a.event,this.b=new C.$ed,this.onTunnelClosed=this.b.event,this.c=new C.$ed,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],s=Array.from(this.e.values());for(const d of s){const $=Array.from(d.values());for(const g of $){const t=await g.value;t&&typeof t!="string"&&i.push(t)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:s}of i.values())await s.then(d=>typeof d!="string"?d?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,s,d,$,g){this.p(i,s,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:s,localAddress:d,privacy:$,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,s){(p(i)||I(i))&&(i=e.$Xz[0]);const d=this.r(i,s);if(d)return++d.refcount,d.value}openTunnel(i,s,d,$,g,t=!1,o,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${d} on local port ${g}.`);const n=this.f??i;if(!n)return;if(s||(s="localhost"),$||($=this.l),this.f&&this.i.has(d)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(n,s,d,$,g,t,o,a);return c?c.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(s,d),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(s,d);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.n(h);return(h.tunnelRemoteHost!==s||h.tunnelRemotePort!==d)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&h.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const s=this.e.get(i.tunnelRemoteHost);if(s){const d=s.get(i.tunnelRemotePort);d&&(d.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,d))}}}}async o(i,s,d){if(d.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${s}.`);const $=d.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(s),$}}async closeTunnel(i,s){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${s} `);const d=this.e.get(i);if(d&&d.has(s)){const $=d.get(s);$.refcount=0,await this.o(i,s,$)}}p(i,s,d){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(s,{refcount:1,value:d})}async q(i,s){const d=this.e.get(i);if(d){const $=d.get(s),g=$?await $.value:void 0;(!g||typeof g=="string")&&d.delete(s),d.size===0&&this.e.delete(i)}}r(i,s){const d=[i];I(i)?(d.push(...e.$Xz),d.push(...e.$Zz)):p(i)&&d.push(...e.$Zz);const $=d.map(g=>this.e.get(g));for(const g of $){const t=g?.get(s);if(t)return t}}canTunnel(i){return!!P(i)}t(i,s,d,$,g,t,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${d} on local port ${$}.`);const a=d;this.i.add(a);const n=$===void 0?d:$,c={elevationRequired:g?this.isPortPrivileged(n):!1},h={remoteAddress:{host:s,port:d},localAddressPort:$,privacy:t,public:t?t!==m.Private:void 0,protocol:o},E=i.forwardPort(h,c);return E?(this.p(s,d,E),E.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),E}};e.$4z=v,e.$4z=v=Ke([Be(0,L.$4i),Be(1,F.$7h)],v)}),define(De[256],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=void 0,e.$Bk=(0,C.$Ah)("IUriIdentityService")}),define(De[257],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$5z=void 0,e.$5z=(0,C.$Ah)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(De[258],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=void 0;function F(S){return S.scheme!==C.Schemas.file&&S.scheme!==C.Schemas.vscodeRemote}e.$kJ=F;function f(S){if(S.folders.length)return S.folders.every(b=>F(b.uri))?S.folders[0].uri:void 0;if(S.configuration&&F(S.configuration))return S.configuration}e.$lJ=f;function L(S){return f(S)?.scheme}e.$mJ=L;function R(S){return f(S)?.authority}e.$nJ=R;function m(S){return f(S)!==void 0}e.$oJ=m}),define(De[43],Ce([1,0,201,16,77,24,2,5,17]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,m.$Ah)("contextService");function b(n){const c=n;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}e.$Kh=b;function P(n){return typeof n?.id=="string"&&!b(n)&&!p(n)}e.$Lh=P,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function I(n,c){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,F.$_d)(n)}:c?e.$Mh:e.$Nh;const h=n;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$Oh=I;function p(n){const c=n;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}e.$Ph=p;function k(n){const c=n;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const h=n;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(n?.id)return{id:n.id}}e.$Qh=k;var D;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function v(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$Rh=v;function r(n){const c=n;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$Sh=r;class i{constructor(c,h,E,y,u){this.h=c,this.j=E,this.k=y,this.l=u,this.c=f.$Gh.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=f.$Gh.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=i;class s{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,L.$hg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=s;function d(n){return new s({uri:n,index:0,name:(0,L.$dg)(n)},{uri:n.toString()})}e.$Vh=d,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,C.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function $(n,c){return L.$$f.isEqualOrParent(n,c.untitledWorkspacesHome)}e.$1h=$;function g(n){let c;return R.URI.isUri(n)?c=n:c=n.configuration,c?.scheme===S.Schemas.tmp}e.$2h=g,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$3h}e.$4h=t;function o(n,c){return!$(n,c)&&!g(n)}e.$5h=o;function a(n){return(typeof n=="string"?(0,F.$ae)(n):(0,L.$fg)(n))===e.$Xh}e.$6h=a}),define(De[259],Ce([1,0,51,4,3,24,2,200,131,30,5,14,43,28,256,11,31,15,18]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.ProfileResourceType=void 0;var d;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function $(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Ck=$,e.$Dk=(0,P.$Ah)("IUserDataProfilesService");function g(n,c){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:R.URI.revive(n.location).with({scheme:c}),globalStorageHome:R.URI.revive(n.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(n.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(n.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(n.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(n.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(n.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(n.cacheHome).with({scheme:c}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Ek=g;function t(n,c,h,E,y,u){return{id:n,name:c,location:h,isDefault:!1,shortName:y?.shortName,globalStorageHome:u&&y?.useDefaultFlags?.globalState?u.globalStorageHome:(0,L.$hg)(h,"globalStorage"),settingsResource:u&&y?.useDefaultFlags?.settings?u.settingsResource:(0,L.$hg)(h,"settings.json"),keybindingsResource:u&&y?.useDefaultFlags?.keybindings?u.keybindingsResource:(0,L.$hg)(h,"keybindings.json"),tasksResource:u&&y?.useDefaultFlags?.tasks?u.tasksResource:(0,L.$hg)(h,"tasks.json"),snippetsHome:u&&y?.useDefaultFlags?.snippets?u.snippetsHome:(0,L.$hg)(h,"snippets"),extensionsResource:u&&y?.useDefaultFlags?.extensions?u.extensionsResource:(0,L.$hg)(h,"extensions.json"),cacheHome:(0,L.$hg)(E,n),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}e.$Fk=t;let o=class extends f.$jc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,E,y){super(),this.t=c,this.u=h,this.w=E,this.y=y,this.f=!0,this.h=this.B(new F.$ed),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$ed),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$ed),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$ed),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new k.$yi,emptyWindows:new Map},this.profilesHome=(0,L.$hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const u of this.O()){if(!u.name||!(0,s.$if)(u.name)||!u.location){this.y.warn("Skipping the invalid stored profile",u.location||u.name);continue}h.push(t((0,L.$eg)(u.location),u.name,u.location,this.g,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags},c))}}catch(u){this.y.error(u)}const E=new k.$yi,y=new Map;if(h.length)try{const u=this.Q();if(u.workspaces)for(const[l,w]of Object.entries(u.workspaces)){const A=R.URI.parse(l),O=h.find(N=>N.id===w);O&&E.set(A,O)}if(u.emptyWindows)for(const[l,w]of Object.entries(u.emptyWindows)){const A=h.find(O=>O.id===w);A&&y.set(l,A)}}catch(u){this.y.error(u)}this.z={profiles:h,workspaces:E,emptyWindows:y}}return this.z}D(){const c=t("__default__profile__",(0,m.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",E=new RegExp(`${(0,i.$pe)(h)}\\s(\\d+)`);let y=0;for(const l of this.profiles){const w=E.exec(l.name),A=w?parseInt(w[1]):0;y=A>y?A:y}const u=`${h} ${y+1}`;return this.createProfile((0,C.$oi)((0,r.$3f)()).toString(16),u,{transient:!0},c)}async createNamedProfile(c,h,E){return this.createProfile((0,C.$oi)((0,r.$3f)()).toString(16),c,h,E)}async createProfile(c,h,E,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=await this.F(c,h,E);return y&&await this.setProfileForWorkspace(y,u),u}async F(c,h,E){if(!(0,s.$if)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(h);return y||(y=(async()=>{try{const u=this.profiles.find(A=>A.name===h||A.id===c);if(u)return u;const l=t(c,h,(0,L.$hg)(this.profilesHome,c),this.g,E,this.defaultProfile);await this.u.createFolder(l.location);const w=[];return this.j.fire({profile:l,join(A){w.push(A)}}),await v.Promises.settled(w),this.I([l],[],[]),l}finally{this.r.delete(h)}})(),this.r.set(h,y)),y}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(y=>y.id===c.id);if(!E)throw new Error(`Profile '${c.name}' does not exist`);return E=t(E.id,h.name??E.name,E.location,this.g,{shortName:h.shortName??E.shortName,transient:h.transient??E.isTransient,useDefaultFlags:h.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(y=>y.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const E=[];this.m.fire({profile:h,join(y){E.push(y)}});try{await Promise.allSettled(E)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(y){(0,b.$ik)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(y=>y.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,E)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,p.$Kh)(c)?c.uri:(0,p.$Ph)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,E){const y=[...this.profiles,...c],u=[];this.s.profiles=[];for(let l of y)l.isDefault||h.some(w=>l.id===w.id)||(l=E.find(w=>l.id===w.id)??l,l.isTransient?this.s.profiles.push(l):u.push({location:l.location,name:l.name,shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}));this.P(u),this.z=void 0,this.J(c,h,E)}J(c,h,E){this.h.fire({added:c,removed:h,updated:E,all:this.profiles})}L(c,h,E){E=h?.isTransient?!0:E,E||this.L(c,void 0,!0);const y=this.G(c),u=E?this.s:this.C;R.URI.isUri(y)?(u.workspaces.delete(y),h&&u.workspaces.set(y,h)):(u.emptyWindows.delete(y),h&&u.emptyWindows.set(y,h)),E||this.M()}M(){const c={};for(const[E,y]of this.C.workspaces.entries())c[E.toString()]=y.id;const h={};for(const[E,y]of this.C.emptyWindows.entries())h[E.toString()]=y.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},E=this.D();if(c.workspaces)for(const[u,l]of Object.entries(c.workspaces)){const w=R.URI.parse(l);h[u]=this.w.extUri.isEqual(w,E.location)?E.id:this.w.extUri.basename(w)}const y={};if(c.emptyWindows)for(const[u,l]of Object.entries(c.emptyWindows)){const w=R.URI.parse(l);y[u]=this.w.extUri.isEqual(w,E.location)?E.id:this.w.extUri.basename(w)}return{workspaces:h,emptyWindows:y}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Gk=o,e.$Gk=o=Ke([Be(0,S.$Hh),Be(1,b.$5j),Be(2,D.$Bk),Be(3,I.$4i)],o);class a extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Hk=a}),define(De[260],Ce([1,0,11,4,3,53,18,184,5,259]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$To=e.$So=e.$Ro=void 0,e.$Ro="__$__isNewStorageMarker",e.$So="__$__targetStorageMarker",e.$To=(0,S.$Ah)("storageService");var P;(function(s){s[s.NONE=0]="NONE",s[s.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var I;(function(s){s[s.APPLICATION=-1]="APPLICATION",s[s.PROFILE=0]="PROFILE",s[s.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(s){s[s.USER=0]="USER",s[s.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function k(s){const d=s.get(e.$So);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$Uo=k;class D extends f.$jc{static{this.a=60*1e3}constructor(d={flushInterval:D.a}){super(),this.m=d,this.b=this.B(new F.$hd),this.c=this.B(new F.$hd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$ed),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Rg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$kc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,$,g){return F.Event.filter(this.b.event,t=>t.scope===d&&($===void 0||t.key===$),g)}n(){this.j.value=(0,C.$Vg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$ec)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,$){const{key:g,external:t}=$;if(g===e.$So){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:g,target:this.J(d)[g],external:t})}w(d){this.f.fire({reason:d})}get(d,$,g){return this.P($)?.get(d,g)}getBoolean(d,$,g){return this.P($)?.getBoolean(d,g)}getNumber(d,$,g){return this.P($)?.getNumber(d,g)}getObject(d,$,g){return this.P($)?.getObject(d,g)}storeAll(d,$){this.y(()=>{for(const g of d)this.store(g.key,g.value,g.scope,g.target,$)})}store(d,$,g,t,o=!1){if((0,R.$rf)($)){this.remove(d,g,o);return}this.y(()=>{this.z(d,g,t),this.P(g)?.set(d,$,o)})}remove(d,$,g=!1){this.y(()=>{this.z(d,$,void 0),this.P($)?.delete(d,g)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,$){const g=[],t=this.J(d);for(const o of Object.keys(t))t[o]===$&&g.push(o);return g}z(d,$,g,t=!1){const o=this.J($);typeof g=="number"?o[d]!==g&&(o[d]=g,this.P($)?.set(e.$So,JSON.stringify(o),t)):typeof o[d]=="number"&&(delete o[d],this.P($)?.set(e.$So,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const $=this.P(d);return $?k($):Object.create(null)}isNew(d){return this.getBoolean(e.$Ro,d)===!0}async flush(d=P.NONE){this.f.fire({reason:d});const $=this.P(-1),g=this.P(0),t=this.P(1);switch(d){case P.NONE:await C.Promises.settled([$?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await C.Promises.settled([$?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return i(d,$,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,$){return this.w(P.NONE),(0,b.$Ck)(d)?this.R(d,$):this.S(d,$)}M(d,$){return!(d.id===$.id||v($)&&v(d))}N(d,$,g){this.y(()=>{const t=new Set;for(const[o,a]of d)t.add(o),$.get(o)!==a&&this.u(g,{key:o,external:!0});for(const[o]of $.items)t.has(o)||this.u(g,{key:o,external:!0})})}}e.$Vo=D;function v(s){return s.isDefault||!!s.useDefaultFlags?.globalState}e.$Wo=v;class r extends D{constructor(){super(),this.U=this.B(new m.$Po(new m.$Qo,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new m.$Po(new m.$Qo,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new m.$Po(new m.$Qo,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$Xo=r;async function i(s,d,$,g,t,o){const a=A=>{try{return JSON.parse(A)}catch{return A}},n=new Map,c=new Map;s.forEach((A,O)=>{n.set(O,A),c.set(O,a(A))});const h=new Map,E=new Map;d.forEach((A,O)=>{h.set(O,A),E.set(O,a(A))});const y=new Map,u=new Map;$.forEach((A,O)=>{y.set(O,A),u.set(O,a(A))}),console.group(g!==t?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const l=[];if(n.forEach((A,O)=>{l.push({key:O,value:A})}),console.table(l),console.groupEnd(),console.log(c),g!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];h.forEach((O,N)=>{A.push({key:N,value:O})}),console.table(A),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${o})`);const w=[];y.forEach((A,O)=>{w.push({key:O,value:A})}),console.table(w),console.groupEnd(),console.log(u)}e.$Yo=i}),define(De[87],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class C{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const L=this.c++;return this.b.set(L,f),this.e(),L}get(f,L){return this.b.has(f)?this.b.get(f)[L]:void 0}delete(f){this.b.delete(f),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Iac=C}),define(De[54],Ce([1,0,17,24,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=e.$Kac=void 0;class L{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new F.$9f(m=>{const S=this.b.get(m.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(m,S){S===null?this.b.delete(m.scheme):this.b.set(m.scheme,S)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Kac=L,e.$Lac=(0,f.$Ah)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=void 0,e.$_L=(0,C.$Ah)("IExtHostInitDataService")}),define(De[261],Ce([1,0,206,14,241,26]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;let R=class extends f.$gN{constructor(S,b,P){const I=P.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",p=P.remote.isRemote?(0,C.localize)(0,null):S?(0,C.localize)(1,null):(0,C.localize)(2,null);super(b.createLogger(I,{name:p}))}};e.$Rcc=R,e.$Rcc=R=Ke([Be(1,F.$5i),Be(2,L.$_L)],R)}),define(De[262],Ce([1,0,11]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=e.$bbc=void 0;class F{constructor(R,m,S){this.h=new Map,this.a=R,this.b=m,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new C.$Rg(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of b.values())P.complete()}catch(P){for(const I of b.values())I.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let S=this.f[R];return typeof S>"u"&&(S=m),S}update(R,m){this.f[R]=m;const S=this.h.get(R);if(S!==void 0)return S.p;const b=new C.$1g;return this.h.set(R,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$bbc=F;class f extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$cbc=f}),define(De[263],Ce([1,0,4,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class f{constructor(R){this.c=R,this.a=new C.$ed,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$ed,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,S,b){const I=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(m.value,S,b);this.b.fire(I)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$Acc=f}),define(De[20],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=void 0,e.$VL=(0,C.$Ah)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$WL=F}),define(De[264],Ce([1,0,25,4]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=void 0;class f{#e;constructor(R,m){this.b=new F.$ed,this.onDidChange=this.b.event,this.a=C.$Ul.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(S=>{S.extensionId===this.a&&this.b.fire({key:S.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$nbc=f}),define(De[67],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=void 0,e.$Vac=(0,C.$Ah)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Wac=F}),define(De[265],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybb=e.$Xbb=void 0;class F{constructor(){this.buffers=[]}add(S){let b=this.buffers.indexOf(S);return b<0&&(b=this.buffers.length,this.buffers.push(S)),b}}function f(m,S){if(S.serializeBuffersForPostMessage){const b=new F,I=JSON.stringify(m,(k,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(D)};if(ArrayBuffer.isView(D)){const v=L(D);if(v)return{$$vscode_array_buffer_reference$$:!0,index:b.add(D.buffer),view:{type:v,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),p=b.buffers.map(k=>{const D=new Uint8Array(k);return C.$Ed.wrap(D)});return{message:I,buffers:p}}else return{message:JSON.stringify(m),buffers:[]}}e.$Xbb=f;function L(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,S){const b=S.map(p=>{const k=new ArrayBuffer(p.byteLength);return new Uint8Array(k).set(p.buffer),k}),P=S.length?(p,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const D=k,{index:v}=D,r=b[v];if(D.view)switch(D.view.type){case 1:return new Int8Array(r,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return k}:void 0;return{message:JSON.parse(m,P),arrayBuffers:b}}e.$Ybb=R}),define(De[266],Ce([1,0,267,373,374,61,2,375]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;const S=!1;function b(s,d,$,g,t,o){const a=o.environment.useHostProxy,n=typeof a=="boolean"?a:!o.remote.isRemote,c={resolveProxy:y=>s.resolveProxy(y),lookupProxyAuthorization:v.bind(void 0,g,t,d,{},o.remote.isRemote),getProxyURL:()=>d.getConfiguration("http").get("proxy"),getProxySupport:()=>d.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>I(d),getSystemCertificatesV2:()=>p(d),log:(y,u,...l)=>{switch(y){case m.LogLevel.Trace:g.trace(u,...l);break;case m.LogLevel.Debug:g.debug(u,...l);break;case m.LogLevel.Info:g.info(u,...l);break;case m.LogLevel.Warning:g.warn(u,...l);break;case m.LogLevel.Error:g.error(u,...l);break;case m.LogLevel.Critical:g.error(u,...l);break;case m.LogLevel.Off:break;default:w(y,u,l);break}function w(A,O,...N){g.error("Unknown log level",A),g.error(O,...N)}},getLogLevel:()=>g.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:n,addCertificates:[],env:process.env},h=(0,m.createProxyResolver)(c),E=P(c,h);return D($,E)}e.$ndc=b;function P(s,d){return{http:Object.assign(C,(0,m.createHttpPatch)(s,C,d)),https:Object.assign(F,(0,m.createHttpPatch)(s,F,d)),net:Object.assign(L,(0,m.createNetPatch)(s,L)),tls:Object.assign(f,(0,m.createTlsPatch)(s,f))}}function I(s){const d=s.getConfiguration("http");return!d.get("experimental.systemCertificatesV2",S)&&!!d.get("systemCertificates")}function p(s){const d=s.getConfiguration("http");return!!d.get("experimental.systemCertificatesV2",S)&&!!d.get("systemCertificates")}const k=new Map;function D(s,d){return s.getExtensionPathIndex().then($=>{const g=globalThis._VSCODE_NODE_MODULES.module,t=g._load;g._load=function(a,n,c){if(a==="net")return d.net;if(a==="tls")return d.tls;if(a!=="http"&&a!=="https")return t.apply(this,arguments);const h=$.findSubstr(R.URI.file(n.filename));let E=k.get(h);if(E||k.set(h,E={}),!E[a]){const y=d[a];E[a]={...y}}return E[a]}})}async function v(s,d,$,g,t,o,a,n){const c=g[o];a&&(g[o]=a),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${o}`,`proxyAuthenticate:${a}`,`proxyAuthenticateCache:${c}`);const h=a||c,E=Array.isArray(h)?h:typeof h=="string"?[h]:[];if(i(d,E,t),E.some(y=>/^(Negotiate|Kerberos)( |$)/i.test(y))&&!n.kerberosRequested)try{n.kerberosRequested=!0;const y=await new Promise((O,N)=>{$e(["kerberos"],O,N)}),u=new URL(o),l=$.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${u.hostname}`:`HTTP@${u.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${o}`,`spn:${l}`),"Negotiate "+await(await y.initializeClient(l)).step("")}catch(y){s.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",y)}}let r=!1;function i(s,d,$){r||!d.length||(r=!0,s.$publicLog2("proxyAuthenticationRequest",{authenticationType:d.map(g=>g.split(" ")[0]).join(","),extensionHostType:$?"remote":"local"}))}}),define(De[268],Ce([1,0,128]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;function F(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function f(L){return new C.$Am(F(L))}e.$or=f}),define(De[139],Ce([1,0,216,18,2,3,5,42,30,17,46,176,38]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=e.$2E=e.EditorsOrder=e.$1E=e.CloseDirection=e.$ZE=e.$YE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.EditorInputCapabilities=e.$PE=e.SaveReason=e.Verbosity=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var k;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var D;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function v(ce){const we=ce;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.$IE=v;function r(ce,we,G){for(const U of G.visibleEditorPanes)if(U.group.id===we&&ce.matches(U.input))return U.getViewState()}e.$JE=r;function i(ce){if(h(ce))return!1;const we=ce;return f.URI.isUri(we?.resource)}e.$KE=i;function s(ce){if(h(ce))return!1;const we=ce;return we?.original!==void 0&&we.modified!==void 0}e.$LE=s;function d(ce){if(h(ce)||s(ce))return!1;const we=ce;return we?.primary!==void 0&&we.secondary!==void 0}e.$ME=d;function $(ce){if(h(ce))return!1;const we=ce;return we?we.resource===void 0||we.resource.scheme===b.Schemas.untitled||we.forceUntitled===!0:!1}e.$NE=$;function g(ce){if(h(ce))return!1;const we=ce;return f.URI.isUri(we?.base?.resource)&&f.URI.isUri(we?.input1?.resource)&&f.URI.isUri(we?.input2?.resource)&&f.URI.isUri(we?.result?.resource)}e.$OE=g;var t;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var o;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class a{constructor(){this.a=new Map}registerSource(we,G){let U=this.a.get(we);return U||(U={source:we,label:G},this.a.set(we,U)),U.source}getSourceLabel(we){return this.a.get(we)?.label??we}}e.$PE=new a;var n;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(n||(e.EditorInputCapabilities=n={}));class c extends L.$jc{}e.$QE=c;function h(ce){return ce instanceof c}e.$RE=h;function E(ce){const we=ce;return f.URI.isUri(we?.preferredResource)}function y(ce){const we=ce;return h(we?.primary)&&h(we?.secondary)}e.$SE=y;function u(ce){const we=ce;return h(we?.modified)&&h(we?.original)}e.$TE=u;function l(ce,we,G,U,K){return ge(U,[(0,I.$ki)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const Y={...G,limits:{size:Number.MAX_VALUE}};ce.openEditor(we,Y)}}),(0,I.$ki)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>K.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$UE=l;function w(ce){return h(ce?.editor)}e.$VE=w;function A(ce){const we=ce;return w(ce)&&we?.group!==void 0}e.$WE=A;function O(ce){const we=ce;return typeof we?.groupId=="number"&&h(we.editor)}e.$XE=O;var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var T;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var j;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class z{getOriginalUri(we,G){if(!we)return;if(g(we))return e.$ZE.getOriginalUri(we.result,G);if(G?.supportSideBySide){const{primary:K,secondary:Y}=this.a(we);if(K&&Y){if(G?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(Y,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getOriginalUri(K,{filterByScheme:G.filterByScheme})??this.getOriginalUri(Y,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===j.PRIMARY?K:Y}}if(s(we)||d(we)||g(we))return;const U=E(we)?we.preferredResource:we.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}a(we){return y(we)||d(we)?{primary:we.primary,secondary:we.secondary}:u(we)||s(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,G){if(!we)return;if(g(we))return e.$ZE.getCanonicalUri(we.result,G);if(G?.supportSideBySide){const{primary:K,secondary:Y}=this.a(we);if(K&&Y){if(G?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(Y,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getCanonicalUri(K,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(Y,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===j.PRIMARY?K:Y}}if(s(we)||d(we)||g(we))return;const U=we.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}b(we,G){if(Array.isArray(G)){if(G.some(U=>we.scheme===U))return we}else if(G===we.scheme)return we}}var M;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(M||(e.EditorCloseMethod=M={}));function H(ce,we,G,U){if(!ce.isSticky(we))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return G===M.MOUSE||G===M.KEYBOARD;case"mouse":return G===M.MOUSE;case"keyboard":return G===M.KEYBOARD}return!1}e.$YE=H,e.$ZE=new z;var q;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class me{constructor(){this.c=new Map,this.d=new Map}start(we){const G=this.a=we.get(R.$zh);for(const[U,K]of this.c)this.e(U,K,G);this.c.clear()}e(we,G,U){const K=U.createInstance(G);this.d.set(we,K)}registerFileEditorFactory(we){if(this.b)throw new Error("Can only register one file editor factory.");this.b=we}getFileEditorFactory(){return(0,F.$tf)(this.b)}registerEditorSerializer(we,G){if(this.c.has(we)||this.d.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.a?this.e(we,G,this.a):this.c.set(we,G),(0,L.$hc)(()=>{this.c.delete(we),this.d.delete(we)})}getEditorSerializer(we){return this.d.get(typeof we=="string"?we:we.typeId)}}m.$7m.add(e.$DE.EditorFactory,new me);async function x(ce,we,G){return!ce||!ce.length?[]:await Promise.all(ce.map(async U=>{const K=f.URI.revive(U.fileUri);if(!K){G.info("Cannot resolve the path because it is not valid.",U);return}if(!await we.canHandleResource(K)){G.info("Cannot resolve the path because it cannot be handled",U);return}let se=U.exists,re=U.type;if(typeof se!="boolean"||typeof re!="number")try{re=(await we.stat(K)).isDirectory?S.FileType.Directory:S.FileType.Unknown,se=!0}catch(Ee){G.error(Ee),se=!1}if(!se&&U.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",U);return}if(re===S.FileType.Directory){G.info("Cannot resolve the path because it is a directory",U);return}const le={...U.options,pinned:!0};return se?{resource:K,options:le}:{resource:K,options:le,forceUntitled:!0}}))}e.$1E=x;var Q;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function V(ce){const we=ce;if(!we)return!1;const G=we;if(G.modified)return V(G.modified);const U=we;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$2E=V;function _(ce){return(0,P.$mi)(ce)}e.$3E=_;function ge(ce,we,G){const U=(0,P.$ni)(ce,we);return U.forceMessage=G?.forceMessage,U.forceSeverity=G?.forceSeverity,U.allowDialog=G?.allowDialog,U}e.$4E=ge}),define(De[269],Ce([1,0,4,217,5,3,28,42,19,56,23,78,255]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$E=e.$0E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$9E=e.$8E=e.ViewContentGroups=e.$7E=e.$6E=e.ViewContainerLocation=e.Extensions=e.$5E=void 0,e.$5E=(0,p.$7u)("default-view-icon",I.$Oj.window,(0,F.localize)(0,null));var k;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(k||(e.Extensions=k={}));var D;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel",a[a.AuxiliaryBar=2]="AuxiliaryBar"})(D||(e.ViewContainerLocation=D={})),e.$6E=[0,1,2];function v(a){switch(a){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$7E=v;class r extends L.$jc{constructor(){super(...arguments),this.c=this.B(new C.$ed),this.onDidRegister=this.c.event,this.f=this.B(new C.$ed),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.$Ob)([...this.g.values()])}registerViewContainer(n,c,h){const E=this.get(n.id);if(E)return E;const y=n;return y.openCommandActionDescriptor=h?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,R.$vi)(this.g,c,[]).push(y),h?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:c}),y}deregisterViewContainer(n){for(const c of this.g.keys()){const h=this.g.get(c),E=h?.indexOf(n);if(E!==-1){h?.splice(E,1),h.length===0&&this.g.delete(c),this.f.fire({viewContainer:n,viewContainerLocation:c});return}}}get(n){return this.all.filter(c=>c.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(h=>h?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(c=>this.getViewContainerLocation(c)===n)}}m.$7m.add(k.ViewContainersRegistry,new r);var i;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(i||(e.ViewContentGroups=i={}));function s(a,n){const c=a.group??i.More,h=n.group??i.More;return c!==h?c.localeCompare(h):(a.order??5)-(n.order??5)}class d extends L.$jc{constructor(){super(...arguments),this.c=this.B(new C.$ed),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$ed),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$ed),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$ed),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new b.$L}registerViews(n,c){this.registerViews2([{views:n,viewContainer:c}])}registerViews2(n){n.forEach(({views:c,viewContainer:h})=>this.r(c,h)),this.c.fire(n)}deregisterViews(n,c){const h=this.s(n,c);h.length&&this.f.fire({views:h,viewContainer:c})}moveViews(n,c){for(const h of this.m.keys())if(h!==c){const E=this.s(n,h);E.length&&(this.r(E,c),this.g.fire({views:E,from:h,to:c}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const c of this.j){const h=(this.m.get(c)||[]).filter(E=>E.id===n)[0];if(h)return h}return null}getViewContainer(n){for(const c of this.j)if((this.m.get(c)||[]).filter(E=>E.id===n)[0])return c;return null}registerViewWelcomeContent(n,c){return this.n.add(n,c),this.h.fire(n),(0,L.$hc)(()=>{this.n.delete(n,c),this.h.fire(n)})}registerViewWelcomeContent2(n,c){const h=new Map;for(const[E,y]of c)this.n.add(n,y),h.set(E,(0,L.$hc)(()=>{this.n.delete(n,y),this.h.fire(n)}));return this.h.fire(n),h}getViewWelcomeContent(n){const c=[];return this.n.forEach(n,h=>c.push(h)),c.sort(s)}r(n,c){let h=this.m.get(c);h||(h=[],this.m.set(c,h),this.j.push(c));for(const E of n){if(this.getView(E.id)!==null)throw new Error((0,F.localize)(1,null,E.id));h.push(E)}}s(n,c){const h=this.m.get(c);if(!h)return[];const E=[],y=[];for(const u of h)n.includes(u)?E.push(u):y.push(u);return E.length&&(y.length?this.m.set(c,y):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),E}}m.$7m.add(k.ViewsRegistry,new d),e.$8E=(0,f.$Ah)("viewsService"),e.$9E=(0,f.$Ah)("viewDescriptorService");var $;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})($||(e.ViewVisibilityState=$={}));var g;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(g||(e.TreeItemCollapsibleState=g={}));class t{constructor(n,c){this.c=!1,this.d=!1,(0,P.$Xm)(this,n),this.d=!!c,this.resolve=async h=>{if(c&&!this.c){const E=await c(h);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}h.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$0E=t;class o extends Error{constructor(n){super((0,F.localize)(2,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$$E=o}),define(De[140],Ce([1,0,4,11,218]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new C.$ed,this.n=new C.$ed,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,S,b,P){const I={command:m};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.s("request",I),typeof P=="number"){const p=setTimeout(()=>{clearTimeout(p);const k=this.f.get(I.seq);if(k){this.f.delete(I.seq);const D={type:"response",seq:0,request_seq:I.seq,success:!1,command:m,message:(0,f.localize)(0,null,P,m)};k(D)}},P)}return b&&this.f.set(I.seq,b),I.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,S){return m.type!=="event"||S.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,F.$Gg)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const S=m,b=this.f.get(S.request_seq);b&&(this.f.delete(S.request_seq),b(S));break}}}}s(m,S){S.type=m,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((S,b)=>m.set(b,S)),await(0,F.$Gg)(500),m.forEach((S,b)=>{S({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$rcb=L}),define(De[270],Ce([1,0,219,41,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$kH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$jH=e.MemoryRangeType=e.$iH=e.State=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=void 0,e.$gG="workbench.view.debug",e.$hG="workbench.debug.variablesView",e.$iG="workbench.debug.watchExpressionsView",e.$jG="workbench.debug.callStackView",e.$kG="workbench.debug.loadedScriptsView",e.$lG="workbench.debug.breakPointsView",e.$mG="workbench.debug.disassemblyView",e.$nG="workbench.panel.repl",e.$oG="workbench.panel.repl.view",e.$pG=new F.$1i("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$qG=new F.$1i("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$rG=new F.$1i("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$sG="debugUx",e.$tG=new F.$1i(e.$sG,"default",{type:"string",description:C.localize(3,null)}),e.$uG=new F.$1i("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$vG=new F.$1i("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$wG=new F.$1i("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$xG=new F.$1i("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$yG=new F.$1i("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$zG=new F.$1i("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$AG=new F.$1i("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$BG=new F.$1i("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$CG=new F.$1i("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$DG=new F.$1i("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$EG=new F.$1i("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$FG=new F.$1i("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$GG=new F.$1i("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$HG=new F.$1i("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$IG=new F.$1i("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$JG=new F.$1i("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$KG=new F.$1i("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$LG=new F.$1i("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$MG=new F.$1i("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$NG=new F.$1i("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$OG=new F.$1i("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$PG=new F.$1i("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$QG=new F.$1i("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$RG=new F.$1i("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$SG=new F.$1i("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$TG=new F.$1i("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$UG=new F.$1i("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$VG=new F.$1i("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$WG=new F.$1i("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$XG=new F.$1i("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$YG=new F.$1i("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$ZG=new F.$1i("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$1G=new F.$1i("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$2G=new F.$1i("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$3G=new F.$1i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$4G=new F.$1i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$5G=new F.$1i("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$6G=new F.$1i("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$7G=new F.$1i("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$8G=new F.$1i("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$9G=new F.$1i("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$0G=new F.$1i("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$$G=new F.$1i("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$_G=new F.$1i("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$aH=new F.$1i("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$bH=new F.$1i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$cH=new F.$1i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const L=p=>C.localize(51,null,p);e.$dH=L,e.$eH="editor.contrib.debug",e.$fH="editor.contrib.breakpoint",e.$gH="debug",e.$hH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var R;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(R||(e.State=R={}));function m(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$iH=m;var S;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$jH="vscode-debug-memory";var b;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var P;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$kH=(0,f.$Ah)("debugService");var I;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[271],Ce([1,0,15,2,16,23,17,34,21,19]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0;const P=/{([^}]+)}/g;function I(y,u,l){return y.replace(P,function(w,A){return u&&A.length>0&&A[0]!=="_"?w:l&&l.hasOwnProperty(A)?l[A]:w})}e.$fF=I;function p(y){const u={};for(const l of Object.keys(y))l.startsWith("!")||(u[l]=y[l]);return u}e.$gF=p;function k(y){return y.configuration.request==="attach"&&!D(y)&&(!y.parentSession||k(y.parentSession))}e.$hF=k;function D(y){let u=y.configuration.type;if(u)return u==="vslsShare"&&(u=y.configuration.adapterProxy.configuration.type),(0,C.$Le)(u,"extensionhost")||(0,C.$Le)(u,"pwa-extensionhost")?y:y.parentSession?D(y.parentSession):void 0}e.$iF=D;function v(y){return y.type&&(y.label||y.program||y.runtime)}e.$jF=v;function r(y,u,l){let w,A=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=O.exec(y);){const T=N.index+1,j=T+N[0].length;if(T<=u&&j>=l){w=N[0],A=T;break}}if(w){const T=/\w+/g;let j=null;for(;(j=T.exec(w))&&!(j.index+1+A+j[0].length>=l););j&&(w=w.substring(0,T.lastIndex))}return w?{start:A,end:A+w.length-1}:{start:0,end:0}}e.$kF=r;async function i(y,u,l,w){if(y.evaluatableExpressionProvider.has(u)){const A=y.evaluatableExpressionProvider.ordered(u),O=(0,b.$Eb)(await Promise.all(A.map(async N=>{try{return await N.provideEvaluatableExpression(u,l,w??S.CancellationToken.None)}catch{return}})));if(O.length>0){let N=O[0].expression;const T=O[0].range;return N||(N=u.getLineContent(l.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:N}}}else{const A=u.getLineContent(l.lineNumber),{start:O,end:N}=r(A,l.column,l.column),T=A.substring(O-1,N);return{matchingExpression:T,range:new m.$is(l.lineNumber,O,l.lineNumber,O+T.length)}}return null}e.$lF=i;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(y){return!!(y&&y.match(s))}e.$mF=d;function $(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(d(y.path))return F.URI.parse(y.path);if((0,f.$7d)(y.path))return F.URI.file(y.path)}return y.path}function g(y){if(typeof y.path=="object"){const u=F.URI.revive(y.path);if(u)return u.scheme===R.Schemas.file?u.fsPath:u.toString()}return y.path}function t(y,u){const l=u?$:g,w=(0,L.$Um)(y);return a(w,(A,O)=>{A&&O&&(O.path=l(O))}),w}e.$nF=t;function o(y,u){const l=u?$:g,w=(0,L.$Um)(y);return a(w,(A,O)=>{!A&&O&&(O.path=l(O))}),w}e.$oF=o;function a(y,u){switch(y.type){case"event":{const l=y;switch(l.event){case"output":u(!1,l.body.source);break;case"loadedSource":u(!1,l.body.source);break;case"breakpoint":u(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=y;switch(l.command){case"setBreakpoints":u(!0,l.arguments.source);break;case"breakpointLocations":u(!0,l.arguments.source);break;case"source":u(!0,l.arguments.source);break;case"gotoTargets":u(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(w=>u(!1,w));break;default:break}break}case"response":{const l=y;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(w=>u(!1,w.source));break;case"loadedSources":l.body.sources.forEach(w=>u(!1,w));break;case"scopes":l.body.scopes.forEach(w=>u(!1,w.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(w=>u(!1,w.source));break;case"setBreakpoints":l.body.breakpoints.forEach(w=>u(!1,w.source));break;case"disassemble":l.body?.instructions.forEach(A=>u(!1,A.location));break;default:break}break}}}function n(y){return y.filter(u=>!u.presentation?.hidden).sort((u,l)=>u.presentation?l.presentation?u.presentation.group?l.presentation.group?u.presentation.group!==l.presentation.group?u.presentation.group.localeCompare(l.presentation.group):c(u.presentation.order,l.presentation.order):-1:l.presentation.group?1:c(u.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.$pF=n;function c(y,u){return typeof y!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:y-u}async function h(y,u){const l=y.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(l!=="none"&&(await u.saveAll(),l==="allEditorsInActiveGroup")){const w=u.activeEditorPane;w&&w.input.resource?.scheme===R.Schemas.untitled&&await u.save({editor:w.input,groupId:w.group.id})}await y.reloadConfiguration()}e.$qF=h;const E=(y,u)=>!y||!u?y===u:y.name===u.name&&y.path===u.path&&y.sourceReference===u.sourceReference;e.$rF=E}),define(De[272],Ce([1,0,48,61,23,16,12,15,29,220,140]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=e.$Zcc=e.$Ycc=e.$Xcc=void 0;class I extends P.$rcb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(i,s){this.p=s,this.r=Buffer.allocUnsafe(0),this.t=-1,i.on("data",d=>this.w(d))}sendMessage(i){if(this.p){const s=JSON.stringify(i);this.p.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${I.a}${s}`,"utf8")}}w(i){for(this.r=Buffer.concat([this.r,i]);;){if(this.t>=0){if(this.r.length>=this.t){const s=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(d){this.m.fire(new Error((d.message||d)+`
`+s))}continue}}else{const s=this.r.indexOf(I.a);if(s!==-1){const $=this.r.toString("utf8",0,s).split(I.b);for(const g of $){const t=g.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(s+I.a.length);continue}}break}}}e.$Xcc=I;class p extends I{startSession(){return new Promise((i,s)=>{let d=!1;this.x=this.y(()=>{this.v(this.x,this.x),i(),d=!0}),this.x.on("close",()=>{d?this.m.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.x.on("error",$=>{d?this.m.fire($):s($)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Ycc=p;class k extends p{constructor(i){super(),this.z=i}y(i){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",i)}}e.$Zcc=k;class D extends p{constructor(i){super(),this.z=i}y(i){return F.createConnection(this.z.path,i)}}e.$1cc=D;class v extends I{constructor(i,s){super(),this.y=i,this.z=s}async startSession(){const i=this.y.command,s=this.y.args,d=this.y.options||{};try{if(i)if(L.$7d(i)){if(!await S.Promises.exists(i))throw new Error(b.localize(0,null,i))}else i.indexOf("/")<0&&i.indexOf("\\")<0;else throw new Error(b.localize(1,null,this.z));let $=process.env;if(d.env&&Object.keys(d.env).length>0&&($=f.$Xm(f.$Um(process.env),d.env)),i==="node")if(Array.isArray(s)&&s.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:$,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(t.cwd=d.cwd);const o=C.fork(s[0],s.slice(1),t);if(!o.pid)throw new Error(b.localize(2,null,s[0]));this.x=o}else throw new Error(b.localize(3,null));else{const g={env:$};d.cwd&&(g.cwd=d.cwd),this.x=C.spawn(i,s,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,t)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch($){this.m.fire($)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((i,s)=>{const d=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function($,g,t){if($)return s($)});d.on("exit",i),d.on("error",s)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(i,s){if(!i)return;const d=Object.create(null);i.runtime&&(i.runtime.indexOf("./")===0?d.runtime=L.$8d(s,i.runtime):d.runtime=i.runtime),i.runtimeArgs&&(d.runtimeArgs=i.runtimeArgs),i.program&&(L.$7d(i.program)?d.program=i.program:d.program=L.$8d(s,i.program)),i.args&&(d.args=i.args);const $=i;return $.win&&(d.win=v.A($.win,s)),$.winx86&&(d.winx86=v.A($.winx86,s)),$.windows&&(d.windows=v.A($.windows,s)),$.osx&&(d.osx=v.A($.osx,s)),$.linux&&(d.linux=v.A($.linux,s)),d}static platformAdapterExecutable(i,s){let d=Object.create(null);s=s.toLowerCase();for(const n of i)if(n.contributes){const c=n.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&m.$Le(h.type,s)).forEach(h=>{const E=v.A(h,n.extensionLocation.fsPath);d=f.$Xm(d,E,n.isBuiltin)})}let $;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?$=d.winx86||d.win||d.windows:R.$i?$=d.win||d.windows:R.$j?$=d.osx:R.$k&&($=d.linux),$=$||d;const g=$.program||d.program,t=$.args||d.args,o=$.runtime||d.runtime,a=$.runtimeArgs||d.runtimeArgs;if(o)return{type:"executable",command:o,args:(a||[]).concat(typeof g=="string"?[g]:[]).concat(t||[])};if(g)return{type:"executable",command:g,args:t||[]}}}e.$2cc=v}),define(De[273],Ce([1,0,48,32,12]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=e.$3cc=void 0;function L(b,P){return new Promise((I,p)=>{let k="";const D=C.spawn(b,P);D.pid&&D.stdout.on("data",v=>{k+=v.toString()}),D.on("error",v=>{p(v)}),D.on("close",v=>{I(k)})})}async function R(b){if(b)if(f.$i){const P=await new Promise((I,p)=>{$e(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{P.getProcessTree(b,p=>{I(!!p&&p.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(b)]).then(P=>{const I=P.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},P=>!0);return Promise.resolve(!0)}e.$3cc=R;var m;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(m||(m={}));function S(b,P,I,p,k){b=b.trim().toLowerCase();let D;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?D=1:b.indexOf("cmd.exe")>=0?D=0:b.indexOf("bash")>=0?D=2:f.$i?D=0:D=2;let v,r=" ";switch(D){case 1:if(v=i=>(i=i.replace(/\'/g,"''"),i.length>0&&i.charAt(i.length-1)==="\\"?`'${i}\\'`:`'${i}'`),p){const i=(0,F.$Mf)(p);i&&(r+=`${i}:; `),r+=`cd ${v(p)}; `}if(k)for(const i in k){const s=k[i];s===null?r+=`Remove-Item env:${i}; `:r+=`\${env:${i}}='${s}'; `}if(P.length>0){const i=P.shift(),s=I?i:v(i);r+=s[0]==="'"?`& ${s} `:`${s} `;for(const d of P)r+=d==="<"||d===">"||I?d:v(d),r+=" "}break;case 0:if(v=i=>(i=i.replace(/\"/g,'""'),i=i.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(s=>i.includes(s))||i.length===0?`"${i}"`:i),p){const i=(0,F.$Mf)(p);i&&(r+=`${i}: && `),r+=`cd ${v(p)} && `}if(k){r+='cmd /C "';for(const i in k){let s=k[i];s===null?r+=`set "${i}=" && `:(s=s.replace(/[&^|<>]/g,d=>`^${d}`),r+=`set "${i}=${s}" && `)}}for(const i of P)r+=i==="<"||i===">"||I?i:v(i),r+=" ";k&&(r+='"');break;case 2:{v=s=>(s=s.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),s.length===0?'""':s);const i=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(p&&(r+=`cd ${v(p)} ; `),k){r+="/usr/bin/env";for(const s in k){const d=k[s];d===null?r+=` -u ${i(s)}`:r+=` ${i(`${s}=${d}`)}`}r+=" "}for(const s of P)r+=s==="<"||s===">"||I?s:v(s),r+=" ";break}}return r}e.$4cc=S}),define(De[108],Ce([1,0,22,35,50,98,17,16,12,41]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3H=e.$2H=e.$1H=e.$ZH=e.CellStatusbarAlignment=e.$YH=e.$XH=e.$WH=e.NotebookEditorPriority=e.$VH=e.$UH=e.$TH=e.$SH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$RH=e.$QH=e.$PH=e.$OH=e.CellKind=e.$NH=e.$MH=e.$LH=void 0,e.$LH="workbench.editor.notebook",e.$MH="workbench.editor.notebookTextDiffEditor",e.$NH="workbench.editor.interactive";var P;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(P||(e.CellKind=P={})),e.$OH=["application/json","application/javascript","text/html","image/svg+xml",L.$Fr.latex,L.$Fr.markdown,"image/png","image/jpeg",L.$Fr.text],e.$PH=[L.$Fr.latex,L.$Fr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Fr.text],e.$QH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$RH="_notAvailable";var I;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var p;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var k;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var D;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var v;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(v||(e.RendererMessagingSpec=v={}));var r;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var i;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var s;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(s||(e.CellEditType=s={}));var d;(function(M){M.scheme=R.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${H.join("")}]+`),me=7;function x(we,G){const U=G.toString(me),Y=`${U.length<H.length?H[U.length-1]:"z"}${U}s${(0,C.$Yd)(C.$Ed.fromString(we.scheme),!0,!0)}`;return we.with({scheme:M.scheme,fragment:Y})}M.generate=x;function Q(we){if(we.scheme!==M.scheme)return;const G=we.fragment.indexOf("s");if(G<0)return;const U=parseInt(we.fragment.substring(0,G).replace(q,""),me),K=(0,C.$Xd)(we.fragment.substring(G+1)).toString();if(!isNaN(U))return{handle:U,notebook:we.with({scheme:K,fragment:null})}}M.parse=Q;function V(we,G){return we.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${we.scheme!==R.Schemas.file?we.scheme:""}`})}M.generateCellOutputUri=V;function _(we){if(we.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!G)return;const U=G[1]&&G[1]!==""?G[1]:void 0,K=G[2];return{outputId:U,notebook:we.with({scheme:K||R.Schemas.file,fragment:null})}}M.parseCellOutputUri=_;function ge(we,G,U){return M.generate(we,G).with({scheme:U})}M.generateCellPropertyUri=ge;function ce(we,G){if(we.scheme===G)return M.parse(we.with({scheme:M.scheme}))}M.parseCellPropertyUri=ce})(d||(e.CellUri=d={}));const $=M=>S.$i?M.replace(/\//g,"\\"):M;class g{constructor(H=[],q=e.$OH){this.e=q,this.d=[...new Set(H)].map(me=>({pattern:me,matches:F.$qj($(me))}))}sort(H){const q=new Map(f.Iterable.map(H,x=>[x,$(x)]));let me=[];for(const{matches:x}of this.d)for(const[Q,V]of q)if(x(V)){me.push(Q),q.delete(Q);break}return q.size&&(me=me.concat([...q.keys()].sort((x,Q)=>this.e.indexOf(x)-this.e.indexOf(Q)))),me}prioritize(H,q){const me=this.f(H);if(me===-1){this.d.unshift({pattern:H,matches:F.$qj($(H))});return}const x=new Set(q.map(V=>this.f(V,me)));x.delete(-1);const Q=Array.from(x).sort();this.d.splice(me+1,0,...Q.map(V=>this.d[V]));for(let V=Q.length-1;V>=0;V--)this.d.splice(Q[V],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,q=this.d.length){const me=$(H);for(let x=0;x<q;x++)if(this.d[x].matches(me))return x;return-1}}e.$SH=g;function t(M,H,q,me=(x,Q)=>x===Q){const x=[];function Q(ge,ce,we){if(ce===0&&we.length===0)return;const G=x[x.length-1];G&&G.start+G.deleteCount===ge?(G.deleteCount+=ce,G.toInsert.push(...we)):x.push({start:ge,deleteCount:ce,toInsert:we})}let V=0,_=0;for(;;){if(V===M.length){Q(V,0,H.slice(_));break}if(_===H.length){Q(V,M.length-V,[]);break}const ge=M[V],ce=H[_];if(me(ge,ce)){V+=1,_+=1;continue}q(ce)?(Q(V,1,[]),V+=1):(Q(V,0,[ce]),_+=1)}return x}e.$TH=t,e.$UH=new b.$1i("notebookEditorCursorAtBoundary","none"),e.$VH=new b.$1i("notebookEditorCursorAtLineBoundary","none");var o;(function(M){M.default="default",M.option="option"})(o||(e.NotebookEditorPriority=o={}));function a(M){const H=M;return!!((typeof H.include=="string"||F.$rj(H.include))&&(typeof H.exclude=="string"||F.$rj(H.exclude)))}e.$WH=a;function n(M,H,q){if(Array.isArray(M.viewType)&&M.viewType.indexOf(H)>=0||M.viewType===H)return!0;if(M.filenamePattern){const me=a(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,x=a(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(F.$pj(me,(0,m.$_d)(q.fsPath).toLowerCase()))return!(x&&F.$pj(x,(0,m.$_d)(q.fsPath).toLowerCase()))}return!1}e.$XH=n,e.$YH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var c;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class h{static{this.d="notebook/"}static create(H){return`${h.d}${H}`}static parse(H){if(H.startsWith(h.d))return H.substring(h.d.length)}}e.$ZH=h;function E(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.$1H=E;const y=new TextDecoder;function u(M){const H=[];let q=!1;for(const V of M)(H.length===0||q)&&(H.push(V),q=!0);let me=A(H);const x=C.$Ed.concat(H.map(V=>C.$Ed.wrap(V))),Q=z(x);return me=me||Q.byteLength!==x.byteLength,{data:Q,didCompression:me}}e.$2H=u,e.$3H=`${String.fromCharCode(27)}[A`;const l=e.$3H.split("").map(M=>M.charCodeAt(0)),w=10;function A(M){let H=!1;return M.forEach((q,me)=>{if(me===0||q.length<e.$3H.length)return;const x=M[me-1],Q=q.subarray(0,e.$3H.length);if(Q[0]===l[0]&&Q[1]===l[1]&&Q[2]===l[2]){const V=x.lastIndexOf(w);if(V===-1)return;H=!0,M[me-1]=x.subarray(0,V),M[me]=q.subarray(e.$3H.length)}}),H}function O(M){let H=M;do M=H,H=M.replace(/[^\n]\x08/gm,"");while(H.length<M.length);return M}function N(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const H=M.match(/^(.*)\r+/m)[1];let q=M.match(/\r+(.*)$/m)[1];q=q+H.slice(q.length,H.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return M}const T="\b".charCodeAt(0),j="\r".charCodeAt(0);function z(M){return!M.buffer.includes(T)&&!M.buffer.includes(j)?M:C.$Ed.fromString(N(O(y.decode(M.buffer))))}}),define(De[7],Ce([1,0,19,8,79,28,98,15,18,2,31,25,30,65,108]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D){"use strict";var v,r,i,s,d,$,g,t,o,a,n,c,h,E,y,u,l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$KL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.TestRunProfileKind=e.TestResultState=e.$rL=e.$qL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$pL=e.$oL=e.$nL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$mL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.ColorThemeKind=e.$gL=e.$fL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$eL=e.DebugConsoleMode=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$$K=e.$0K=e.FileChangeType=e.$9K=e.$8K=e.$7K=e.$6K=e.InlineCompletionTriggerKind=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.ConfigurationTarget=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$IK=e.ViewBadge=e.ProgressLocation=e.$HK=e.$GK=e.TaskScope=e.ShellQuoting=e.$FK=e.$EK=e.$DK=e.TaskPanelKind=e.TaskRevealKind=e.$CK=e.TerminalLocation=e.$BK=e.$AK=e.$zK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$yK=e.$xK=e.$wK=e.$vK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$uK=e.StatusBarAlignment=e.ViewColumn=e.$tK=e.$sK=e.$rK=e.$qK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$pK=e.$oK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.LanguageStatusSeverity=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.CodeActionTriggerKind=e.$bK=e.$aK=e.SymbolTag=e.SymbolKind=e.$_J=e.DocumentHighlightKind=e.$$J=e.$0J=e.$9J=e.$8J=e.DiagnosticSeverity=e.DiagnosticTag=e.$7J=e.$6J=e.FileEditType=e.$5J=e.$4J=e.$3J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function A(J){return Object.assign(J,{apply:function(...ve){if(ve.length===0)return Reflect.construct(J,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(J,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(J,[]);{const[Re,...Ye]=ve;return Reflect.construct(J,Ye,Re.constructor)}}})}var O;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var N;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let T=v=class{static from(...W){let ve=W;return new v(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$VJ=T,e.$VJ=T=v=Ke([A],T);let j=r=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Ye=W[Re];Ye.isBefore(ve)&&(ve=Ye)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Ye=W[Re];Ye.isAfter(ve)&&(ve=Ye)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof r)return!0;const{line:ve,character:Re}=W;return typeof ve=="number"&&typeof Re=="number"}static of(W){if(W instanceof r)return W;if(this.isPosition(W))return new r(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,F.$5)("line must be non-negative");if(ve<0)throw(0,F.$5)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,F.$5)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ve===0?this:new r(this.line+Re,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,F.$5)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Re===this.line&&ve===this.character?this:new r(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$WJ=j,e.$WJ=j=r=Ke([A],j);let z=i=class{static isRange(W){return W instanceof i?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Re,Ye){let tt,at;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ye=="number"?(tt=new j(W,ve),at=new j(Re,Ye)):j.isPosition(W)&&j.isPosition(ve)&&(tt=j.of(W),at=j.of(ve)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=j.Max(W.start,this.c),Re=j.Min(W.end,this.e);if(!ve.isAfter(Re))return new i(ve,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=j.Min(W.start,this.c),Re=j.Max(W.end,this.end);return new i(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,F.$5)();let Re;return W?j.isPosition(W)?Re=W:(Re=W.start||this.start,ve=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new i(Re,ve)}toJSON(){return[this.start,this.end]}};e.$XJ=z,e.$XJ=z=i=Ke([A],z);let M=s=class extends z{static isSelection(W){return W instanceof s?!0:W?z.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Re,Ye){let tt,at;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ye=="number"?(tt=new j(W,ve),at=new j(Re,Ye)):j.isPosition(W)&&j.isPosition(ve)&&(tt=j.of(W),at=j.of(ve)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$YJ=M,e.$YJ=M=s=Ke([A],M);const H=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,F.$5)("connectionToken")};class q{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Re){if(typeof W!="string"||W.length===0)throw(0,F.$5)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,F.$5)("port");typeof Re<"u"&&H(Re),this.host=W,this.port=Math.round(ve),this.connectionToken=Re}}e.$ZJ=q;class me{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&H(ve)}}e.$1J=me;class x extends Error{static NotAvailable(W,ve){return new x(W,k.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new x(W,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=k.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,x.prototype)}}e.$2J=x;var Q;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var V;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let _=d=class{static isTextEdit(W){return W instanceof d?!0:W?z.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new d(W,ve)}static insert(W,ve){return d.replace(new z(W,W),ve)}static delete(W){return d.replace(W,"")}static setEndOfLine(W){const ve=new d(new z(new j(0,0),new j(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!z.isRange(W))throw(0,F.$5)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$5)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$5)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$3J=_,e.$3J=_=d=Ke([A],_);let ge=$=class{static isNotebookCellEdit(W){return W instanceof $?!0:W?Zt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new $(W,ve)}static insertCells(W,ve){return new $(new Zt(W,W),ve)}static deleteCells(W){return new $(W,[])}static updateCellMetadata(W,ve){const Re=new $(new Zt(W,W),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(W){const ve=new $(new Zt(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$4J=ge,e.$4J=ge=$=Ke([A],ge);class ce{static isSnippetTextEdit(W){return W instanceof ce?!0:W?z.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,ve){return new ce(W,ve)}static insert(W,ve){return ce.replace(new z(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$5J=ce;var we;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Re,Ye){this.c.push({_type:1,from:W,to:ve,options:Re,metadata:Ye})}createFile(W,ve,Re){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Re})}deleteFile(W,ve,Re){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Re})}e(W,ve,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Re,Ye){const tt=ve.start,at=ve.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Ye})}g(W,ve,Re,Ye){this.c.push({_type:3,metadata:Ye,uri:W,edit:{editType:3,index:ve,metadata:Re}})}replace(W,ve,Re,Ye){this.c.push({_type:2,uri:W,edit:new _(ve,Re),metadata:Ye})}insert(W,ve,Re,Ye){this.replace(W,new z(ve,ve),Re,Ye)}delete(W,ve,Re){this.replace(W,ve,"",Re)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Re of ve){if(!Re)continue;let Ye,tt;Array.isArray(Re)?(Ye=Re[0],tt=Re[1]):Ye=Re,ge.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(W,Ye.range.start,Ye.newCellMetadata,tt):Ye.newNotebookMetadata?this.e(W,Ye.newNotebookMetadata,tt):this.f(W,Ye.range,Ye.newCells,tt):ce.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:W,range:Ye.range,edit:Ye.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Ye,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Ye=this.c[Re];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Fb)(this.c)}}get(W){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ve.push(Re.edit);return ve}entries(){const W=new L.$yi;for(const ve of this.c)if(ve._type===2){let Re=W.get(ve.uri);Re||(Re=[ve.uri,[]],W.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$6J=G,e.$6J=G=Ke([A],G);let U=g=class{static isSnippetString(W){return W instanceof g?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=g.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Re=new g;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=g.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Re=W.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Re=new g;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$7J=U,e.$7J=U=g=Ke([A],U);var K;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(K||(e.DiagnosticTag=K={}));var Y;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(Y||(e.DiagnosticSeverity=Y={}));let se=t=class{static isLocation(W){return W instanceof t?!0:W?z.isRange(W.range)&&b.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(z.isRange(ve))this.range=z.of(ve);else if(j.isPosition(ve))this.range=new z(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$8J=se,e.$8J=se=t=Ke([A],se);let re=class{static is(W){return W?typeof W.message=="string"&&W.location&&z.isRange(W.location.range)&&b.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$9J=re,e.$9J=re=Ke([A],re);let le=class{constructor(W,ve,Re=Y.Error){if(!z.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Re}toJSON(){return{severity:Y[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,C.$sb)(W.tags,ve.tags)&&(0,C.$sb)(W.relatedInformation,ve.relatedInformation,re.isEqual)}};e.$0J=le,e.$0J=le=Ke([A],le);let Ee=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$$J=Ee,e.$$J=Ee=Ke([A],Ee);var he;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(he||(e.DocumentHighlightKind=he={}));let fe=class{constructor(W,ve=he.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:he[this.kind]}}};e.$_J=fe,e.$_J=fe=Ke([A],fe);var te;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var ue;(function(J){J[J.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let be=o=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Re,Ye,tt){this.name=W,this.kind=ve,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Ye instanceof se?this.location=Ye:Re instanceof z&&(this.location=new se(Ye,Re)),o.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$aK=be,e.$aK=be=o=Ke([A],be);let Pe=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(a.validate)}constructor(W,ve,Re,Ye,tt){this.name=W,this.detail=ve,this.kind=Re,this.range=Ye,this.selectionRange=tt,this.children=[],a.validate(this)}};e.$bK=Pe,e.$bK=Pe=a=Ke([A],Pe);var B;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let X=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$cK=X,e.$cK=X=Ke([A],X);let ee=class{static{n=this}static{this.c="."}constructor(W){this.value=W}append(W){return new n(this.value?this.value+n.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+n.c)}};e.$dK=ee,e.$dK=ee=n=Ke([A],ee);class ne extends ee{constructor(W){super(W),this.value=W}}e.$eK=ne,ee.Empty=new ee(""),ee.QuickFix=ee.Empty.append("quickfix"),ee.Refactor=ee.Empty.append("refactor"),ee.RefactorExtract=ee.Refactor.append("extract"),ee.RefactorInline=ee.Refactor.append("inline"),ee.RefactorMove=ee.Refactor.append("move"),ee.RefactorRewrite=ee.Refactor.append("rewrite"),ee.Source=ee.Empty.append("source"),ee.SourceOrganizeImports=ee.Source.append("organizeImports"),ee.SourceFixAll=ee.Source.append("fixAll"),ee.Notebook=ee.Empty.append("notebook");let Z=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$fK=Z,e.$fK=Z=Ke([A],Z);class de{constructor(W,ve,Re,Ye,tt,at){this.kind=W,this.name=ve,this.detail=Re,this.uri=Ye,this.range=tt,this.selectionRange=at}}e.$gK=de;class ye{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$hK=ye;class je{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$iK=je;var We;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(We||(e.LanguageStatusSeverity=We={}));let xe=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$jK=xe,e.$jK=xe=Ke([A],xe);let Qe=c=class{#e;static isMarkdownString(W){return W instanceof c?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new f.$Wj(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$kK=Qe,e.$kK=Qe=c=Ke([A],Qe);let it=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$lK=it,e.$lK=it=Ke([A],it);let et=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$mK=et,e.$mK=et=Ke([A],et);let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$nK=Ae,e.$nK=Ae=Ke([A],Ae);var Oe;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(Oe||(e.SignatureHelpTriggerKind=Oe={}));var Ve;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Ve||(e.InlayHintKind=Ve={}));let Le=class{constructor(W){this.value=W}};e.$oK=Le,e.$oK=Le=Ke([A],Le);let Xe=class{constructor(W,ve,Re){this.position=W,this.label=ve,this.kind=Re}};e.$pK=Xe,e.$pK=Xe=Ke([A],Xe);var ae;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ae||(e.CompletionTriggerKind=ae={}));var oe;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(oe||(e.CompletionItemKind=oe={}));var Ie;(function(J){J[J.Deprecated=1]="Deprecated"})(Ie||(e.CompletionItemTag=Ie={}));let qe=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$qK=qe,e.$qK=qe=Ke([A],qe);let ze=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$rK=ze,e.$rK=ze=Ke([A],ze);let Ze=class{constructor(W,ve,Re){this.insertText=W,this.range=ve,this.command=Re}};e.$sK=Ze,e.$sK=Ze=Ke([A],Ze);let nt=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$tK=nt,e.$tK=nt=Ke([A],nt);var ot;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var bt;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(bt||(e.StatusBarAlignment=bt={}));function Dt(J,W){return`${I.$Ul.toKey(J)}.${W}`}e.$uK=Dt;var Xt;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(Xt||(e.TextEditorLineNumbersStyle=Xt={}));var Vt;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var vt;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(vt||(e.TextEditorRevealType=vt={}));var Ft;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(Ft||(e.TextEditorSelectionChangeKind=Ft={}));var Ot;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(Ot||(e.TextDocumentChangeReason=Ot={}));var Kt;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(J){function W(ve){switch(ve){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(Ft||(e.TextEditorSelectionChangeKind=Ft={}));let At=class{constructor(W,ve){if(ve&&!b.URI.isUri(ve))throw(0,F.$5)("target");if(!z.isRange(W)||W.isEmpty)throw(0,F.$5)("range");this.range=W,this.target=ve}};e.$vK=At,e.$vK=At=Ke([A],At);let Rt=class{constructor(W,ve,Re,Ye){this.red=W,this.green=ve,this.blue=Re,this.alpha=Ye}};e.$wK=Rt,e.$wK=Rt=Ke([A],Rt);let Nt=class{constructor(W,ve){if(ve&&!(ve instanceof Rt))throw(0,F.$5)("color");if(!z.isRange(W)||W.isEmpty)throw(0,F.$5)("range");this.range=W,this.color=ve}};e.$xK=Nt,e.$xK=Nt=Ke([A],Nt);let Ut=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$5)("label");this.label=W}};e.$yK=Ut,e.$yK=Ut=Ke([A],Ut);var qt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var ct;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class lt{constructor(W,ve,Re){if(this.startIndex=W,this.length=ve,this.tooltip=Re,typeof W!="number"||W<0)throw(0,F.$5)("startIndex");if(typeof ve!="number"||ve<1)throw(0,F.$5)("length");if(Re!==void 0&&typeof Re!="string")throw(0,F.$5)("tooltip")}}e.$zK=lt;class Jt{constructor(W){this.uri=W}}e.$AK=Jt;class Pt{constructor(W){this.terminalCommand=W}}e.$BK=Pt;var kt;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$5)("options")}}e.$CK=dt;var Ct;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var Mt;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(Mt||(e.TaskPanelKind=Mt={}));let Et=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,F.$5)("name");this.c=W}get id(){return this.c}};e.$DK=Et,e.$DK=Et=h=Ke([A],Et);function Ge(J){let W="";for(let ve=0;ve<J.length;ve++)W+=J[ve].replace(/,/g,",,")+",";return W}let jt=class{constructor(W,ve,Re){if(typeof W!="string")throw(0,F.$5)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$5)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return Ge(W)}};e.$EK=jt,e.$EK=jt=Ke([A],jt);let Te=class{constructor(W,ve,Re){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,F.$5)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$5)("command");this.e=W,this.f=ve,this.g=Re}else{if(typeof W!="string")throw(0,F.$5)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$5)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$5)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return Ge(W)}};e.$FK=Te,e.$FK=Te=Ke([A],Te);var Fe;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(Fe||(e.ShellQuoting=Fe={}));var Se;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Se||(e.TaskScope=Se={}));class ie{constructor(W){this.c=W}computeId(){return"customExecution"+(0,P.$3f)()}set callback(W){this.c=W}get callback(){return this.c}}e.$GK=ie;let Me=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Re,Ye,tt,at){this.j=!1,this.k=this.definition=W;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Ye,ht=tt,this.j=!0):ve===Se.Global||ve===Se.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Ye,this.execution=tt,ht=at):(this.target=ve,this.m=this.name=Re,this.t=this.source=Ye,this.execution=tt,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof jt?this.k={type:E.e,id:this.n.computeId()}:this.n instanceof Te?this.k={type:E.f,id:this.n.computeId()}:this.n instanceof ie?this.k={type:E.c,id:this.n.computeId()}:this.k={type:E.g,id:(0,P.$3f)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$5)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$5)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const ve=this.k.type;(E.g===ve||E.e===ve||E.f===ve||E.c===ve)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$5)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};e.$HK=Me,e.$HK=Me=E=Ke([A],Me);var He;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(He||(e.ProgressLocation=He={}));var _e;(function(J){function W(ve){const Re=ve;return(0,S.$mf)(Re.value)?Re.tooltip&&!(0,S.$if)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}J.isViewBadge=W})(_e||(e.ViewBadge=_e={}));let Je=y=class{static isTreeItem(W,ve){const Re=W;if(Re.checkboxState!==void 0){const Ye=(0,S.$mf)(Re.checkboxState)?Re.checkboxState:(0,S.$kf)(Re.checkboxState)&&(0,S.$mf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,S.$mf)(Re.checkboxState)&&(0,S.$kf)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==pt.Checked&&Ye!==pt.Unchecked||tt!==void 0&&!(0,S.$if)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof y)return!0;if(Re.label!==void 0&&!(0,S.$if)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,S.$if)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,S.$if)(Re.iconPath)&&!b.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,S.$if)(Re.iconPath.id))){const Ye=Re.iconPath;if(!Ye||!(0,S.$if)(Ye.light)&&!b.URI.isUri(Ye.light)&&!(0,S.$if)(Ye.dark)&&!b.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,S.$if)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!b.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,S.$if)(Re.tooltip)&&!(Re.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<rt.None&&Re.collapsibleState>rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,S.$if)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ve=rt.None){this.collapsibleState=ve,b.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$IK=Je,e.$IK=Je=y=Ke([A],Je);var rt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(rt||(e.TreeItemCollapsibleState=rt={}));var pt;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$JK=wt,e.$JK=wt=Ke([A],wt);class ft extends wt{}e.$KK=ft;class gt extends ft{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$LK=gt;class mt{constructor(W,ve,Re,Ye){this.name=W,this.uri=ve,this._itemId=Re,this.c=Ye}data(){return this.c()}}e.$MK=mt;let gi=class{#e=new Map;constructor(W){for(const[ve,Re]of W??[]){const Ye=this.#e.get(this.#t(ve));Ye?Ye.push(Re):this.#e.set(this.#t(ve),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Re,Ye]of this.#e)for(const tt of Ye)W.call(ve,tt,Re,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Re of ve)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$NK=gi,e.$NK=gi=Ke([A],gi);let Ht=class{constructor(W){this.insertText=W}};e.$OK=Ht,e.$OK=Ht=Ke([A],Ht);let Ei=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$PK=Ei,e.$PK=Ei=Ke([A],Ei);let Wt=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$QK=Wt,e.$QK=Wt=Ke([A],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(W){this.id=W}};e.$RK=mi,e.$RK=mi=Ke([A],mi);var It;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let ki=class{get base(){return this.c}set base(W){this.c=W,this.e=b.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!b.URI.isUri(W)&&!b.URI.isUri(W.uri)))throw(0,F.$5)("base");if(typeof ve!="string")throw(0,F.$5)("pattern");typeof W=="string"?this.baseUri=b.URI.file(W):b.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$SK=ki,e.$SK=ki=Ke([A],ki);const Vi=new WeakMap;function St(J,W){Vi.set(J,W)}e.$TK=St;let ti=class{constructor(W,ve,Re,Ye){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$3f)()),this.c}};e.$UK=ti,e.$UK=ti=Ke([A],ti);let $i=class extends ti{constructor(W,ve,Re,Ye,tt){if(super(ve,Re,Ye,tt),W===null)throw(0,F.$5)("location");this.location=W}};e.$VK=$i,e.$VK=$i=Ke([A],$i);let si=class extends ti{constructor(W,ve,Re,Ye,tt){super(ve,Re,Ye,tt),this.functionName=W}};e.$WK=si,e.$WK=si=Ke([A],si);let Si=class extends ti{constructor(W,ve,Re,Ye,tt,at,ht){if(super(Ye,tt,at,ht),!ve)throw(0,F.$5)("dataId");this.label=W,this.dataId=ve,this.canPersist=Re}};e.$XK=Si,e.$XK=Si=Ke([A],Si);let Di=class{constructor(W,ve,Re){this.command=W,this.args=ve||[],this.options=Re}};e.$YK=Di,e.$YK=Di=Ke([A],Di);let Lt=class{constructor(W,ve){this.port=W,this.host=ve}};e.$ZK=Lt,e.$ZK=Lt=Ke([A],Lt);let bi=class{constructor(W){this.path=W}};e.$1K=bi,e.$1K=bi=Ke([A],bi);let Ci=class{constructor(W){this.implementation=W}};e.$2K=Ci,e.$2K=Ci=Ke([A],Ci);let oi=class{constructor(W,ve,Re){this.session=W,this.threadId=ve,this.frameId=Re}};e.$3K=oi,e.$3K=oi=Ke([A],oi);let ai=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$4K=ai,e.$4K=ai=Ke([A],ai);let ut=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$5K=ut,e.$5K=ut=Ke([A],ut);var qi;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Qt=class{constructor(W,ve){this.range=W,this.text=ve}};e.$6K=Qt,e.$6K=Qt=Ke([A],Qt);let ii=class{constructor(W,ve,Re=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$7K=ii,e.$7K=ii=Ke([A],ii);let pi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$8K=pi,e.$8K=pi=Ke([A],pi);let Ii=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$9K=Ii,e.$9K=Ii=Ke([A],Ii);var Hi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Pi=u=class extends Error{static FileExists(W){return new u(W,p.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(W){return new u(W,p.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(W){return new u(W,p.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(W){return new u(W,p.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(W){return new u(W,p.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(W){return new u(W,p.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(W,ve=p.FileSystemProviderErrorCode.Unknown,Re){super(b.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,p.$gk)(this,ve),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$0K=Pi,e.$0K=Pi=u=Ke([A],Pi);let wi=class{constructor(W,ve,Re){this.start=W,this.end=ve,this.kind=Re}};e.$$K=wi,e.$$K=wi=Ke([A],wi);var Ki;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(Ki||(e.FoldingRangeKind=Ki={}));var Ai;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Ji;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var vi;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Ri{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$_K=Ri;function cn(J){return typeof J>"u"||(0,S.$jf)(J)}class Li{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Re=W.tokenTypes.length;ve<Re;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Re=W.tokenModifiers.length;ve<Re;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Re,Ye,tt){if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ye=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,ve,Re,Ye,tt);if(z.isRange(W)&&typeof ve=="string"&&cn(Re))return this.m(W,ve,Re);throw(0,F.$5)()}m(W,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Ye=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,ht=this.j.get(ve);let zt=0;if(Re)for(const Yt of Re){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Yt);zt|=1<<_t>>>0}this.n(Ye,tt,at,ht,zt)}n(W,ve,Re,Ye,tt){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const zt=this.g.length/5|0;let Yt=0,_t=0;for(let ei=0;ei<zt;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Yt,Bi+=_t):ri+=Yt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Yt=ri,_t=Bi}}let at=W,ht=ve;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Ye,this.g[this.h++]=tt,this.c=W,this.e=ve}static o(W){const ve=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)ve[ht]=ht;ve.sort((ht,zt)=>{const Yt=W[5*ht],_t=W[5*zt];if(Yt===_t){const ei=W[5*ht+1],ri=W[5*zt+1];return ei-ri}return Yt-_t});const Ye=new Uint32Array(W.length);let tt=0,at=0;for(let ht=0;ht<Re;ht++){const zt=5*ve[ht],Yt=W[zt+0],_t=W[zt+1],ei=W[zt+2],ri=W[zt+3],Bi=W[zt+4],vn=Yt-tt,Ln=vn===0?_t-at:_t,Wi=5*ht;Ye[Wi+0]=vn,Ye[Wi+1]=Ln,Ye[Wi+2]=ei,Ye[Wi+3]=ri,Ye[Wi+4]=Bi,tt=Yt,at=_t}return Ye}build(W){return this.f?new ni(new Uint32Array(this.g),W):new ni(Li.o(this.g),W)}}e.$aL=Li;class ni{constructor(W,ve){this.resultId=ve,this.data=W}}e.$bL=ni;class un{constructor(W,ve,Re){this.start=W,this.deleteCount=ve,this.data=Re}}e.$cL=un;class ln{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$dL=ln;var Gi;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$eL=fi,e.$eL=fi=Ke([A],fi);var Yi;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Xi;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var ui;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Qi{static validate(W){if(typeof W.badge=="string"){let ve=(0,m.$Ve)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,m.$Ve)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Wt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Re){this.badge=W,this.tooltip=ve,this.color=Re}}e.$fL=Qi;let Ti=class{constructor(W){this.kind=W}};e.$gL=Ti,e.$gL=Ti=Ke([A],Ti);var Zi;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(Zi||(e.ColorThemeKind=Zi={}));class Zt{static isNotebookRange(W){return W instanceof Zt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,F.$5)("start must be positive");if(ve<0)throw(0,F.$5)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Re=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Re=W.end),ve===this.c&&Re===this.e?this:new Zt(ve,Re)}}e.$hL=Zt;class yi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>yi.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Re,Ye,tt,at,ht){this.kind=W,this.value=ve,this.languageId=Re,this.mime=Ye,this.outputs=tt??[],this.metadata=at,this.executionSummary=ht,yi.validate(this)}}e.$iL=yi;class hn{constructor(W){this.cells=W}}e.$jL=hn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Gt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Gt(W,ve)}static#e=new TextEncoder;static text(W,ve=R.$Fr.text){const Re=Gt.#e.encode(String(W));return new Gt(Re,ve)}static json(W,ve="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Gt.text(Re,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Re=(0,R.$Jr)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$kL=Gt;class li{static isNotebookCellOutput(W){return W instanceof li?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Re=new Set,Ye=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],ht=(0,R.$Jr)(at.mime);if(!Re.has(ht)||(0,D.$1H)(ht)){Re.add(ht);continue}Ye.add(tt),ve&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ye.size===0?W:W.filter((tt,at)=>!Ye.has(at))}constructor(W,ve,Re){this.items=li.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,P.$3f)(),this.metadata=ve??Re)}}e.$lL=li;var Fi;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(Fi||(e.NotebookCellKind=Fi={}));var Ue;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(Ue||(e.NotebookCellExecutionState=Ue={}));var xt;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(xt||(e.NotebookCellStatusBarAlignment=xt={}));var Mi;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Mi||(e.NotebookEditorRevealType=Mi={}));class $t{constructor(W,ve){this.text=W,this.alignment=ve}}e.$mL=$t;var xi;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(W,ve=[]){this.uri=W,this.provides=(0,C.$Zb)(ve)}}e.$nL=en;class dn{constructor(W){this.label=W}}e.$oL=dn;let hi=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$pL=hi,e.$pL=hi=Ke([A],hi);var tn;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$qL=sn;class fn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$rL=fn;var on;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(W=void 0,ve=void 0,Re=void 0,Ye=!1){this.include=W,this.exclude=ve,this.profile=Re,this.continuous=Ye}};e.$sL=Oi,e.$sL=Oi=Ke([A],Oi);let Ni=l=class{static diff(W,ve,Re){const Ye=new l(W);return Ye.expectedOutput=ve,Ye.actualOutput=Re,Ye}constructor(W){this.message=W}};e.$tL=Ni,e.$tL=Ni=l=Ke([A],Ni);let ji=class{constructor(W){this.id=W}};e.$uL=ji,e.$uL=ji=Ke([A],ji);let di=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$vL=di,e.$vL=di=Ke([A],di);let zi=w=class{static fromDetails(W,ve){const Re=new di(0,0),Ye=new di(0,0),tt=new di(0,0);for(const ht of ve)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const zt of ht.branches)Ye.total+=1,Ye.covered+=zt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const at=new w(W,Re,Ye.total>0?Ye:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=ve,at}constructor(W,ve,Re,Ye){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Ye}};e.$wL=zi,e.$wL=zi=w=Ke([A],zi);let Ui=class{constructor(W,ve,Re=[]){this.executionCount=W,this.location=ve,this.branches=Re}};e.$xL=Ui,e.$xL=Ui=Ke([A],Ui);let pe=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$yL=pe,e.$yL=pe=Ke([A],pe);let ke=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$zL=ke,e.$zL=ke=Ke([A],ke);var Ne;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(Ne||(e.ExternalUriOpenerPriority=Ne={}));var st;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var yt;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Tt{constructor(W,ve,Re,Ye,tt,at){this.kind=W,this.name=ve,this.detail=Re,this.uri=Ye,this.range=tt,this.selectionRange=at}}e.$AL=Tt;class yn{constructor(W){this.uri=W}}e.$BL=yn;class En{constructor(W,ve){this.original=W,this.modified=ve}}e.$CL=En;class kn{constructor(W,ve,Re,Ye){this.base=W,this.input1=ve,this.input2=Re,this.result=Ye}}e.$DL=kn;class Sn{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$EL=Sn;class Dn{constructor(W){this.viewType=W}}e.$FL=Dn;class Cn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$GL=Cn;class In{constructor(W,ve,Re){this.original=W,this.modified=ve,this.notebookType=Re}}e.$HL=In;class Pn{constructor(){}}e.$IL=Pn;class An{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$JL=An;var gn;(function(J){J[J.Up=1]="Up",J[J.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var bn;(function(J){J[J.System=0]="System",J[J.User=1]="User",J[J.Assistant=2]="Assistant",J[J.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var pn;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class Rn{constructor(W,ve){this.role=W,this.content=ve}}e.$KL=Rn;var wn;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(wn||(e.RelatedInformationType=wn={}))}),define(De[141],Ce([1,0,58,17,15,171,124,7,19]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=e.$YL=e.$XL=void 0;const b=new Map;function P(D,v){v?b.set(D,v):b.delete(D)}e.$XL=P;function I(D){return b.get(D)}class p extends L.$Ku{constructor(v,r,i,s,d,$,g,t){super(r,i,s,d),this.c=v,this.m=$,this.q=g,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(v){return(0,S.$sb)(this.f,v)}get document(){if(!this.a){const v=this;this.a={get uri(){return v.d},get fileName(){return v.d.fsPath},get isUntitled(){return v.d.scheme===F.Schemas.untitled},get languageId(){return v.m},get version(){return v.h},get isClosed(){return v.b},get isDirty(){return v.q},save(){return v.r()},getText(r){return r?v.s(r):v.getText()},get eol(){return v.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return v.f.length},lineAt(r){return v.t(r)},offsetAt(r){return v.u(r)},positionAt(r){return v.v(r)},validateRange(r){return v.w(r)},validatePosition(r){return v.x(r)},getWordRangeAtPosition(r,i){return v.y(r,i)}}}return Object.freeze(this.a)}_acceptLanguageId(v){(0,C.ok)(!this.b),this.m=v}_acceptIsDirty(v){(0,C.ok)(!this.b),this.q=v}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(v){const r=this.w(v);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const i=this.g,s=r.start.line,d=r.end.line,$=[];$.push(this.f[s].substring(r.start.character));for(let g=s+1;g<d;g++)$.push(this.f[g]);return $.push(this.f[d].substring(0,r.end.character)),$.join(i)}t(v){let r;if(v instanceof m.$WJ?r=v.line:typeof v=="number"&&(r=v),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new k(r,this.f[r],r===this.f.length-1)}u(v){return v=this.x(v),this.l(),this.j.getPrefixSum(v.line-1)+v.character}v(v){v=Math.floor(v),v=Math.max(0,v),this.l();const r=this.j.getIndexOf(v),i=this.f[r.index].length;return new m.$WJ(r.index,Math.min(r.remainder,i))}w(v){if(!(v instanceof m.$XJ))throw new Error("Invalid argument");const r=this.x(v.start),i=this.x(v.end);return r===v.start&&i===v.end?v:new m.$XJ(r.line,r.character,i.line,i.character)}x(v){if(!(v instanceof m.$WJ))throw new Error("Invalid argument");if(this.f.length===0)return v.with(0,0);let{line:r,character:i}=v,s=!1;if(r<0)r=0,i=0,s=!0;else if(r>=this.f.length)r=this.f.length-1,i=this.f[r].length,s=!0;else{const d=this.f[r].length;i<0?(i=0,s=!0):i>d&&(i=d,s=!0)}return s?new m.$WJ(r,i):v}y(v,r){const i=this.x(v);if(!r)r=I(this.m);else if((0,f.$ye)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const s=(0,R.$Xr)(i.character+1,(0,R.$Vr)(r),this.f[i.line],0);if(s)return new m.$XJ(i.line,s.startColumn-1,i.line,s.endColumn-1)}}e.$YL=p;class k{constructor(v,r,i){this.a=v,this.b=r,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$XJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$XJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$ZL=k}),define(De[274],Ce([1,0,7,20,4]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;let L=class{constructor(m){this.a=new C.$gL(C.ColorThemeKind.Dark),this.b=new f.$ed}get activeColorTheme(){return this.a}$onColorThemeChange(m){let S;switch(m){case"light":S=C.ColorThemeKind.Light;break;case"hcDark":S=C.ColorThemeKind.HighContrast;break;case"hcLight":S=C.ColorThemeKind.HighContrastLight;break;default:S=C.ColorThemeKind.Dark}this.a=new C.$gL(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$jcc=L,e.$jcc=L=Ke([Be(0,F.$VL)],L)}),define(De[275],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$5H=(0,C.$Ah)("INotebookExecutionService")}),define(De[68],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(L){L.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(R,m,S=R.parent){if(R._isRoot)return new f([m]);const b=[R.id];for(let P=S;P&&P.id!==m;P=P.parent)b.push(P.id);return b.push(m),new f(b.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new f(R.split("\0"))}static join(R,m){return new f([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:f.isChild(R,m)?2:f.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new f(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new f(this.path,R)}compare(R){if(typeof R=="string")return f.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$GI=f}),define(De[88],Ce([1,0,2,34,68]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$MI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$LI=e.$KI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$JI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$II=e.$HI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(y){y[y.Run=1]="Run",y[y.Debug=2]="Debug",y[y.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var m;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable",y[y.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$HI=[2,4,8,16,32,64];const S=y=>"runId"in y;e.$II=S;var b;(function(y){y.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),y.deserialize=u=>({range:F.$is.lift(u.range),uri:C.URI.revive(u.uri)})})(b||(e.IRichLocation=b={}));var P;(function(y){y[y.Error=0]="Error",y[y.Output=1]="Output"})(P||(e.TestMessageType=P={}));var I;(function(y){y.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&b.serialize(u.location)}),y.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&b.deserialize(u.location)})})(I||(e.ITestErrorMessage=I={}));const p=(y,u)=>`${u?"s":"e"}${y}`;e.$JI=p;var k;(function(y){y.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&b.serialize(u.location)}),y.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&b.deserialize(u.location)})})(k||(e.ITestOutputMessage=k={}));var D;(function(y){y.serialize=u=>u.type===0?I.serialize(u):k.serialize(u),y.deserialize=u=>u.type===0?I.deserialize(u):k.deserialize(u)})(D||(e.ITestMessage=D={}));var v;(function(y){y.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),y.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(D.serialize)}),y.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(D.deserialize)})})(v||(e.ITestTaskState=v={}));const r="\0",i=(y,u)=>y+r+u;e.$KI=i;const s=y=>{const u=y.indexOf(r);return{ctrlId:y.slice(0,u),tagId:y.slice(u+1)}};e.$LI=s;var d;(function(y){y.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),y.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?C.URI.revive(u.uri):void 0,range:u.range?F.$is.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(d||(e.ITestItem=d={}));var $;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})($||(e.TestItemExpandState=$={}));var g;(function(y){y.serialize=u=>({expand:u.expand,item:d.serialize(u.item)}),y.deserialize=u=>({controllerId:f.$GI.root(u.item.extId),expand:u.expand,item:d.deserialize(u.item)})})(g||(e.InternalTestItem=g={}));var t;(function(y){y.serialize=u=>{let l;return u.item&&(l={},u.item.label!==void 0&&(l.label=u.item.label),u.item.tags!==void 0&&(l.tags=u.item.tags),u.item.busy!==void 0&&(l.busy=u.item.busy),u.item.uri!==void 0&&(l.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(l.range=u.item.range?.toJSON()),u.item.description!==void 0&&(l.description=u.item.description),u.item.error!==void 0&&(l.error=u.item.error),u.item.sortText!==void 0&&(l.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:l}},y.deserialize=u=>{let l;return u.item&&(l={},u.item.label!==void 0&&(l.label=u.item.label),u.item.tags!==void 0&&(l.tags=u.item.tags),u.item.busy!==void 0&&(l.busy=u.item.busy),u.item.range!==void 0&&(l.range=u.item.range?F.$is.lift(u.item.range):null),u.item.description!==void 0&&(l.description=u.item.description),u.item.error!==void 0&&(l.error=u.item.error),u.item.sortText!==void 0&&(l.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:l}}})(t||(e.ITestItemUpdate=t={}));const o=(y,u)=>{u.expand!==void 0&&(y.expand=u.expand),u.item!==void 0&&(y.item=y.item?Object.assign(y.item,u.item):u.item)};e.$MI=o;var a;(function(y){y.serializeWithoutMessages=u=>({...g.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(v.serializeWithoutMessages)}),y.serialize=u=>({...g.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(v.serialize)}),y.deserialize=u=>({...g.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(v.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var n;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(n||(e.DetailType=n={}));var c;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.DocumentSynced=2]="DocumentSynced",y[y.Remove=3]="Remove",y[y.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",y[y.Retire=5]="Retire",y[y.AddTag=6]="AddTag",y[y.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var h;(function(y){y.deserialize=u=>u.op===0?{op:u.op,item:g.deserialize(u.item)}:u.op===1?{op:u.op,item:t.deserialize(u.item)}:u.op===2?{op:u.op,uri:C.URI.revive(u.uri),docv:u.docv}:u,y.serialize=u=>u.op===0?{op:u.op,item:g.serialize(u.item)}:u.op===1?{op:u.op,item:t.serialize(u.item)}:u})(h||(e.TestsDiffOp=h={}));class E{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const l=this.p();for(const w of u)switch(w.op){case 0:this.k(g.deserialize(w.item),l);break;case 1:this.l(t.deserialize(w.item),l);break;case 3:this.m(w.itemId,l);break;case 5:this.o(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.d.set(w.tag.id,w.tag);break;case 7:this.d.delete(w.id);break}l.complete?.()}k(u,l){const w=f.$GI.parentId(u.item.extId)?.toString();let A;if(!w)A=this.q(u),this.g.add(A),this.f.set(u.item.extId,A);else if(this.f.has(w)){const O=this.f.get(w);O.children.add(u.item.extId),A=this.q(u,O),this.f.set(u.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return l.add?.(A),u.expand===2&&this.h++,A}l(u,l){const w=this.f.get(u.extId);if(w)return u.expand!==void 0&&(w.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$MI)(w,u),l.update?.(w),w}m(u,l){const w=this.f.get(u);if(!w)return;const A=f.$GI.parentId(w.item.extId)?.toString();A?this.f.get(A).children.delete(w.item.extId):this.g.delete(w);const O=[[u]];for(;O.length;)for(const N of O.pop()){const T=this.f.get(N);T&&(O.push(T.children),this.f.delete(N),l.remove?.(T,T!==w),T.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$NI=E}),define(De[109],Ce([1,0,11,4,3,58,88,68]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.TestItemEventOp=void 0;var S;(function(s){s[s.Upsert=0]="Upsert",s[s.SetTags=1]="SetTags",s[s.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",s[s.RemoveChild=3]="RemoveChild",s[s.SetProp=4]="SetProp",s[s.Bulk=5]="Bulk",s[s.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const b=(s,d)=>s===d,I=Object.entries({range:(s,d)=>s===d?!0:!s||!d?!1:s.equalsRange(d),busy:b,label:b,description:b,error:b,sortText:b,tags:(s,d)=>!(s.length!==d.length||s.some($=>!d.includes($)))}),p=(s,d)=>{let $;for(const[g,t]of I)t(s[g],d[g])||($?$[g]=d[g]:$={[g]:d[g]});return $};class k extends f.$jc{get root(){return this.s.root}constructor(d){super(),this.s=d,this.f=this.B(new C.$Rg(()=>this.flushDiff(),200)),this.g=this.B(new F.$ed),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(d){this.h=d;for(const $ of this.tree.values())this.I($)}get resolveHandler(){return this.h}collectDiff(){const d=this.m;return this.m=[],d}pushDiff(d){switch(d.op){case 2:{for(const $ of this.m)if($.op===2&&$.uri===d.uri){$.docv=d.docv;return}break}case 1:{const $=this.m[this.m.length-1];if($){if($.op===1&&$.item.extId===d.item.extId){(0,R.$MI)($.item,d.item);return}if($.op===0&&$.item.item.extId===d.item.extId){(0,R.$MI)($.item,d.item);return}}break}}this.m.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,$){const g=this.tree.get(d);if(g){if((g.expandLevels===void 0||$>g.expandLevels)&&(g.expandLevels=$),g.expand===1){const t=this.L(g);return t.isOpen()?this.J(g,$-1):t.wait().then(()=>this.J(g,$-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.J(g,$-1)):this.J(g,$-1)}}dispose(){for(const d of this.tree.values())this.s.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(d,$){switch($.op){case 3:this.N(m.$GI.joinToString(d.fullId,$.id));break;case 0:this.y($.item,d);break;case 5:for(const g of $.ops)this.u(d,g);break;case 1:this.z($.new,$.old,d.fullId.toString());break;case 2:this.I(d);break;case 4:this.pushDiff({op:1,item:{extId:d.fullId.toString(),item:$.update}});break;case 6:this.w(d.actual.uri);break;default:(0,L.$uc)($)}}w(d){d&&this.pushDiff({op:2,uri:d,docv:this.s.getDocumentVersion(d)})}y(d,$){const g=m.$GI.fromExtHostTestItem(d,this.root.id,$?.actual),t=this.s.getApiFor(d);t.parent&&t.parent!==$?.actual&&this.s.getChildren(t.parent).delete(d.id);let o=this.tree.get(g.toString());if(!o){o={fullId:g,actual:d,expandLevels:$?.expandLevels?$.expandLevels-1:void 0,expand:0},d.tags.forEach(this.C,this),this.tree.set(o.fullId.toString(),o),this.F(d,$),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:o.expand,item:this.s.toITestItem(d)}}),this.H(d,o,$);return}if(o.actual===d){this.G(d,o,$);return}if(o.actual.uri?.toString()!==d.uri?.toString())return this.N(g.toString()),this.y(d,$);const a=this.s.getChildren(o.actual),n=o.actual,c=p(this.s.toITestItem(n),this.s.toITestItem(d));this.s.getApiFor(n).listener=void 0,o.actual=d,o.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(d.tags,n.tags,g.toString()),delete c.tags),this.u(o,{op:4,update:c})),this.H(d,o,$);for(const[h,E]of a)this.s.getChildren(d).get(E.id)||this.N(m.$GI.joinToString(g,E.id));this.w(o.actual.uri)}z(d,$,g){const t=new Set($.map(o=>o.id));for(const o of d)t.delete(o.id)||this.C(o);this.pushDiff({op:1,item:{extId:g,item:{tags:d.map(o=>(0,R.$KI)(this.s.controllerId,o.id))}}}),t.forEach(this.D,this)}C(d){const $=this.j.get(d.id);$?$.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$KI)(this.s.controllerId,d.id)}}))}D(d){const $=this.j.get(d);$&&!--$.refCount&&(this.j.delete(d),this.pushDiff({op:7,id:(0,R.$KI)(this.s.controllerId,d)}))}F(d,$){this.s.getApiFor(d).parent=$&&$.actual!==this.root?$.actual:void 0}G(d,$,g){this.F(d,g);const t=this.s.getApiFor(d);t.parent=g?.actual,t.listener=o=>this.u($,o),this.I($)}H(d,$,g){this.G(d,$,g);for(const[t,o]of this.s.getChildren(d))this.y(o,$)}I(d){let $;this.h?d.resolveBarrier?$=d.resolveBarrier.isOpen()?3:2:$=d.actual.canResolveChildren?1:0:$=0,$!==d.expand&&(d.expand=$,this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:$}}),$===1&&d.expandLevels!==void 0&&this.L(d))}J(d,$){if($<0)return;const g=[];for(const[t,o]of this.s.getChildren(d.actual)){const a=this.expand(m.$GI.joinToString(d.fullId,o.id),$);(0,C.$sg)(a)&&g.push(a)}if(g.length)return Promise.all(g).then(()=>{})}L(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const o=new C.$Eg;return o.open(),o}d.expand=2,this.M(d);const $=d.resolveBarrier=new C.$Eg,g=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,o)};let t;try{t=this.h(d.actual===this.root?void 0:d.actual)}catch(o){g(o)}return(0,C.$sg)(t)?t.catch(g).then(()=>{$.open(),this.I(d)}):($.open(),this.I(d)),d.resolveBarrier}M(d){this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:d.expand}})}N(d){const $=this.tree.get(d);if(!$)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:d});const g=[$];for(;g.length;){const t=g.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.D(o.id);this.tree.delete(t.fullId.toString());for(const[o,a]of this.s.getChildren(t.actual))g.push(this.tree.get(m.$GI.joinToString(t.fullId,a.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.$LL=k;class D extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.$ML=D;class v extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$NL=v;class r extends Error{constructor(d,$,g){super(`TestItem with ID "${d}" is from controller "${$}" and cannot be added as a child of an item from controller "${g}".`)}}e.$OL=r;const i=(s,d,$)=>{let g=new Map;return{get size(){return g.size},forEach(t,o){for(const a of g.values())t.call(o,a,this)},[Symbol.iterator](){return g.entries()},replace(t){const o=new Map,a=new Set(g.keys()),n={op:5,ops:[]};for(const c of t){if(!(c instanceof $))throw new v(c.id);const h=d(c).controllerId;if(h!==s.controllerId)throw new r(c.id,h,s.controllerId);if(o.has(c.id))throw new D(c.id);o.set(c.id,c),a.delete(c.id),n.ops.push({op:0,item:c})}for(const c of a.keys())n.ops.push({op:3,id:c});s.listener?.(n),g=o},add(t){if(!(t instanceof $))throw new v(t.id);g.set(t.id,t),s.listener?.({op:0,item:t})},delete(t){g.delete(t)&&s.listener?.({op:3,id:t})},get(t){return g.get(t)},toJSON(){return Array.from(g.values())}}};e.$PL=i}),define(De[142],Ce([1,0,109]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$QL=void 0;const F=new WeakMap,f=(R,m)=>{const S={controllerId:m};return F.set(R,S),S};e.$QL=f;const L=R=>{const m=F.get(R);if(!m)throw new C.$NL(R?.id||"<unknown>");return m};e.$RL=L}),define(De[110],Ce([1,0,17,2]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lob=e.$Kob=e.$Job=e.$Iob=e.$Hob=void 0,e.$Hob="vscode-cdn.net",e.$Iob=`vscode-resource.${e.$Hob}`,e.$Job=`'self' https://*.${e.$Hob}`;function f(m,S){return m.scheme===C.Schemas.http||m.scheme===C.Schemas.https?m:(S&&S.authority&&S.isRemote&&m.scheme===C.Schemas.file&&(m=F.URI.from({scheme:C.Schemas.vscodeRemote,authority:S.authority,path:m.path})),F.URI.from({scheme:C.Schemas.https,authority:`${m.scheme}+${L(m.authority)}.${e.$Iob}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Kob=f;function L(m){return m.replace(/./g,S=>{const b=S.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?S:"-"+b.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(S,b)=>String.fromCharCode(parseInt(b,16)))}e.$Lob=R}),define(De[276],Ce([1,0,4,3,110]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;class L{constructor(m,S,b){this.d=m,this.e=S,this.f=b,this.a=0,this.b=new F.$ic,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const P=S.getVisibleTextEditors();for(const I of this.c.values())P.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,S,b,P,I){let p;for(const d of this.e.getVisibleTextEditors(!0))if(d.value===m){p=d;break}if(!p)throw new Error("not a visible editor");const k=this,D=this.a++,v=new C.$ed,r=new C.$ed,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(d){return(0,f.$Kob)(d,k.f)}get cspSource(){return f.$Job}set options(d){this.b=d,k.d.$setOptions(D,d)}get options(){return this.b}set html(d){this.a=d,k.d.$setHtml(D,d)}get html(){return this.a}get onDidReceiveMessage(){return v.event}postMessage(d){return k.d.$postMessage(D,d)}},s=new class{constructor(){this.editor=m,this.line=S,this.height=b,this.webview=i,this.onDidDispose=r.event}dispose(){k.c.has(D)&&(k.c.delete(D),k.d.$disposeEditorInset(D),r.fire(),r.dispose(),v.dispose())}};return this.d.$createEditorInset(D,p.id,p.value.document.uri,S+1,b,P||{},I.identifier,I.extensionLocation),this.c.set(D,{editor:m,inset:s,onDidReceiveMessage:v}),s}$onDidDispose(m){const S=this.c.get(m);S&&S.inset.dispose()}$onDidReceiveMessage(m,S){this.c.get(m)?.onDidReceiveMessage.fire(S)}}e.$Tbc=L}),define(De[277],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.VariableKind=e.$HM=void 0,e.$HM=(0,C.$Ah)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class f extends Error{constructor(R,m){super(m),this.variable=R}}e.$IM=f}),define(De[278],Ce([1,0,16,47,18,23,12,100,223,277,15]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,D,v,r){this.h=new Map,this.a=k,this.b=D,this.g=v,r&&(this.c=r.then(i=>this.i(i)))}i(k){if(R.$i){const D=Object.create(null);return Object.keys(k).forEach(v=>{D[v.toLowerCase()]=k[v]}),D}return k}resolveWithEnvironment(k,D,v){return this.l({env:this.i(k),userHome:void 0},D?D.uri:void 0,v)}async resolveAsync(k,D){const v={env:await this.c,userHome:await this.g};return this.l(v,k?k.uri:void 0,D)}async j(k,D,v,r){const i=L.$Um(D);R.$i&&i.windows?Object.keys(i.windows).forEach(d=>i[d]=i.windows[d]):R.$j&&i.osx?Object.keys(i.osx).forEach(d=>i[d]=i.osx[d]):R.$k&&i.linux&&Object.keys(i.linux).forEach(d=>i[d]=i.linux[d]),delete i.windows,delete i.osx,delete i.linux;const s={env:await this.c,userHome:await this.g};return this.l(s,k?k.uri:void 0,i,v,r)}async resolveAnyAsync(k,D,v){return this.j(k,D,v)}async resolveAnyMap(k,D,v){const r=new Map;return{newConfig:await this.j(k,D,v,r),resolvedVariables:r}}resolveWithInteractionReplace(k,D,v,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,D,v,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,D){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,D)}async l(k,D,v,r,i){if(f.$if(v))return this.m(k,D,v,r,i);if(Array.isArray(v))return Promise.all(v.map(s=>this.l(k,D,s,r,i)));if(f.$kf(v)){const s=Object.create(null),d=await Promise.all(Object.keys(v).map(async $=>[await this.m(k,D,$,r,i),await this.l(k,D,v[$],r,i)]));for(const[$,g]of d)s[$]=g;return s}return v}m(k,D,v,r,i){return(0,P.$De)(v,I.VARIABLE_REGEXP,async(s,d)=>{if(d.includes(I.VARIABLE_LHS))return s;let $=await this.o(k,s,d,D,r);return i?.set(d,$),$!==s&&f.$if($)&&$.match(I.VARIABLE_REGEXP)&&($=await this.m(k,D,$,r,i)),$})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,D,v,r,i){let s;const d=v.split(":");d.length>1&&(v=d[0],s=d[1]);const $=o=>{const a=this.a.getFilePath();if(a)return(0,m.$cA)(a);throw new b.$IM(o,(0,S.localize)(0,null,D))},g=o=>{const a=$(o);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,m.$cA)(n)}throw new b.$IM(o,(0,S.localize)(1,null,D,C.$_d(a)))},t=o=>{if(s){const a=this.a.getFolderUri(s);if(a)return a;throw new b.$IM(o,(0,S.localize)(2,null,D,s))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new b.$IM(o,(0,S.localize)(3,null,D)):new b.$IM(o,(0,S.localize)(4,null,D))};switch(v){case"env":if(s){if(k.env){const o=k.env[R.$i?s.toLowerCase():s];if(f.$if(o))return o}return""}throw new b.$IM(b.VariableKind.Env,(0,S.localize)(5,null,D));case"config":if(s){const o=this.a.getConfigurationValue(r,s);if(f.$rf(o))throw new b.$IM(b.VariableKind.Config,(0,S.localize)(6,null,D,s));if(f.$kf(o))throw new b.$IM(b.VariableKind.Config,(0,S.localize)(7,null,D,s));return o}throw new b.$IM(b.VariableKind.Config,(0,S.localize)(8,null,D));case"command":return this.p(b.VariableKind.Command,D,s,i,"command");case"input":return this.p(b.VariableKind.Input,D,s,i,"input");case"extensionInstallFolder":if(s){const o=await this.a.getExtension(s);if(!o)throw new b.$IM(b.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,D,s));return this.n(o.extensionLocation)}throw new b.$IM(b.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,D));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,m.$cA)(this.n(t(b.VariableKind.WorkspaceFolder)));case"cwd":return r||s?(0,m.$cA)(this.n(t(b.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$cA)(C.$_d(this.n(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new b.$IM(b.VariableKind.UserHome,(0,S.localize)(11,null,D))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new b.$IM(b.VariableKind.LineNumber,(0,S.localize)(12,null,D))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new b.$IM(b.VariableKind.SelectedText,(0,S.localize)(13,null,D))}case"file":return $(b.VariableKind.File);case"fileWorkspaceFolder":return g(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||s?C.$0d(this.n(t(b.VariableKind.RelativeFile)),$(b.VariableKind.RelativeFile)):$(b.VariableKind.RelativeFile);case"relativeFileDirname":{const o=C.$$d($(b.VariableKind.RelativeFileDirname));if(r||s){const a=C.$0d(this.n(t(b.VariableKind.RelativeFileDirname)),o);return a.length===0?".":a}return o}case"fileDirname":return C.$$d($(b.VariableKind.FileDirname));case"fileExtname":return C.$ae($(b.VariableKind.FileExtname));case"fileBasename":return C.$_d($(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=C.$_d($(b.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-C.$ae(o).length)}case"fileDirnameBasename":return C.$_d(C.$$d($(b.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||D}case"execInstallFolder":{const o=this.a.getAppRoot();return o||D}case"pathSeparator":return C.sep;default:try{const o=s?`${v}:${s}`:v;return this.p(b.VariableKind.Unknown,D,o,i,void 0)}catch{return D}}}}p(k,D,v,r,i){if(v&&r){const s=i===void 0?r[v]:r[i+":"+v];if(typeof s=="string")return s;throw new b.$IM(k,(0,S.localize)(14,null,D))}return D}}e.$WM=I}),define(De[143],Ce([1,0,5,139]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=e.$4C=e.OpenEditorContext=e.GroupsOrder=e.$3C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$2C=void 0,e.$2C=(0,C.$Ah)("editorGroupsService");var f;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var L;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var S;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function b(D){const v=D;return(0,F.$RE)(v?.editor)&&(0,F.$RE)(v?.replacement)}e.$3C=b;var P;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var I;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(D){const v=D;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.$4C=p;function k(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$5C=k}),define(De[279],Ce([1,0,5,143]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9C=e.$8C=e.$7C=e.$6C=void 0,e.$6C=(0,C.$Ah)("editorService"),e.$7C=-1,e.$8C=-2;function f(L){const R=L;return typeof L=="number"||(0,F.$4C)(R)}e.$9C=f}),define(De[13],Ce([1,0,19,22,162,74,79,28,158,63,98,23,18,2,34,82,133,142,139,108,68,88,279,7]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$UL=e.$TL=e.MarkdownString=e.$SL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Te){function Fe(ie){const{selectionStartLineNumber:Me,selectionStartColumn:He,positionLineNumber:_e,positionColumn:Je}=ie,rt=new o.$WJ(Me-1,He-1),pt=new o.$WJ(_e-1,Je-1);return new o.$YJ(rt,pt)}Te.to=Fe;function Se(ie){const{anchor:Me,active:He}=ie;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Te.from=Se})(a||(e.Selection=a={}));var n;(function(Te){function Fe(ie){if(!ie)return;const{start:Me,end:He}=ie;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Te.from=Fe;function Se(ie){if(!ie)return;const{startLineNumber:Me,startColumn:He,endLineNumber:_e,endColumn:Je}=ie;return new o.$XJ(Me-1,He-1,_e-1,Je-1)}Te.to=Se})(n||(e.Range=n={}));var c;(function(Te){function Fe(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Te.to=Fe})(c||(e.TokenType=c={}));var h;(function(Te){function Fe(ie){return new o.$WJ(ie.lineNumber-1,ie.column-1)}Te.to=Fe;function Se(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Te.from=Se})(h||(e.Position=h={}));var E;(function(Te){function Fe(Me,He,_e){return(0,C.$Eb)((0,C.$Zb)(Me).map(Je=>Se(Je,He,_e)))}Te.from=Fe;function Se(Me,He,_e){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:_e?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:ie(Me.scheme,He),pattern:Xe.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:_e?.isBuiltin}}function ie(Me,He){return He&&typeof Me=="string"?He.transformOutgoingScheme(Me):Me}})(E||(e.DocumentSelector=E={}));var y;(function(Te){function Fe(ie){switch(ie){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Te.from=Fe;function Se(ie){switch(ie){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Te.to=Se})(y||(e.DiagnosticTag=y={}));var u;(function(Te){function Fe(ie){let Me;return ie.code&&((0,p.$if)(ie.code)||(0,p.$mf)(ie.code)?Me=String(ie.code):Me={value:String(ie.code.value),target:ie.code.target}),{...n.from(ie.range),message:ie.message,source:ie.source,code:Me,severity:w.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(l.from),tags:Array.isArray(ie.tags)?(0,C.$Eb)(ie.tags.map(y.from)):void 0}}Te.from=Fe;function Se(ie){const Me=new o.$0J(n.to(ie),ie.message,w.to(ie.severity));return Me.source=ie.source,Me.code=(0,p.$if)(ie.code)?ie.code:ie.code?.value,Me.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(l.to),Me.tags=ie.tags&&(0,C.$Eb)(ie.tags.map(y.to)),Me}Te.to=Se})(u||(e.Diagnostic=u={}));var l;(function(Te){function Fe(ie){return{...n.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Te.from=Fe;function Se(ie){return new o.$9J(new o.$8J(ie.resource,n.to(ie)),ie.message)}Te.to=Se})(l||(e.DiagnosticRelatedInformation=l={}));var w;(function(Te){function Fe(ie){switch(ie){case o.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Te.from=Fe;function Se(ie){switch(ie){case r.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Te.to=Se})(w||(e.DiagnosticSeverity=w={}));var A;(function(Te){function Fe(ie){return typeof ie=="number"&&ie>=o.ViewColumn.One?ie-1:ie===o.ViewColumn.Beside?t.$8C:t.$7C}Te.from=Fe;function Se(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Se})(A||(e.ViewColumn=A={}));function O(Te){return typeof Te.range<"u"}function N(Te){return Te.length===0?!0:!!O(Te[0])}e.$SL=N;var T;(function(Te){function Fe(Je){return Je.map(Te.from)}Te.fromMany=Fe;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ie(Je){let rt;if(Se(Je)){const{language:gt,value:mt}=Je;rt={value:"```"+gt+`
`+mt+"\n```\n"}}else o.$kK.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?rt={value:Je}:rt={value:""};const pt=Object.create(null);rt.uris=pt;const wt=gt=>{try{let mt=k.URI.parse(gt,!0);mt=mt.with({query:Me(mt.query,pt)}),pt[gt]=mt}catch{}return""},ft=new S.marked.Renderer;return ft.link=wt,ft.image=gt=>typeof gt=="string"?wt(R.$4j(gt).href):"",(0,S.marked)(rt.value,{renderer:ft}),rt}Te.from=ie;function Me(Je,rt){if(!Je)return Je;let pt;try{pt=(0,b.$9g)(Je)}catch{}if(!pt)return Je;let wt=!1;return pt=(0,I.$Wm)(pt,ft=>{if(k.URI.isUri(ft)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[gt]=ft,wt=!0,gt}else return}),wt?JSON.stringify(pt):Je}function He(Je){const rt=new o.$kK(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt.supportHtml=Je.supportHtml,rt.baseUri=Je.baseUri?k.URI.from(Je.baseUri):void 0,rt}Te.to=He;function _e(Je){if(Je)return typeof Je=="string"?Je:Te.from(Je)}Te.fromStrict=_e})(T||(e.MarkdownString=T={}));function j(Te){return N(Te)?Te.map(Fe=>({range:n.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?T.fromMany(Fe.hoverMessage):Fe.hoverMessage?T.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Te.map(Fe=>({range:n.from(Fe)}))}e.$TL=j;function z(Te){return typeof Te>"u"?Te:typeof Te=="string"?k.URI.file(Te):Te}e.$UL=z;var M;(function(Te){function Fe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?z(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Te.from=Fe})(M||(e.ThemableDecorationAttachmentRenderOptions=M={}));var H;(function(Te){function Fe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?M.from(Se.before):void 0,after:Se.after?M.from(Se.after):void 0}}Te.from=Fe})(H||(e.ThemableDecorationRenderOptions=H={}));var q;(function(Te){function Fe(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Fe})(q||(e.DecorationRangeBehavior=q={}));var me;(function(Te){function Fe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?q.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?H.from(Se.light):void 0,dark:Se.dark?H.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?M.from(Se.before):void 0,after:Se.after?M.from(Se.after):void 0}}Te.from=Fe})(me||(e.DecorationRenderOptions=me={}));var x;(function(Te){function Fe(ie){return{text:ie.newText,eol:ie.newEol&&et.from(ie.newEol),range:n.from(ie.range)}}Te.from=Fe;function Se(ie){const Me=new o.$3J(n.to(ie.range),ie.text);return Me.newEol=typeof ie.eol>"u"?void 0:et.to(ie.eol),Me}Te.to=Se})(x||(e.TextEdit=x={}));var Q;(function(Te){function Fe(ie,Me){const He={edits:[]};if(ie instanceof o.$6J){const _e=new m.$zi;for(const Je of ie._allEntries())Je._type===1&&k.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of ie._allEntries())if(Je._type===1){let rt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?rt={type:"base64",value:(0,F.$Yd)(F.$Ed.wrap(Je.options.contents))}:rt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:rt},metadata:Je.metadata})}else Je._type===2?He.edits.push({resource:Je.uri,textEdit:x.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Me?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?He.edits.push({resource:Je.uri,textEdit:{range:n.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Me?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return He}Te.from=Fe;function Se(ie){const Me=new o.$6J,He=new m.$yi;for(const _e of ie.edits)if(_e.textEdit){const Je=_e,rt=k.URI.revive(Je.resource),pt=n.to(Je.textEdit.range),wt=Je.textEdit.text,ft=Je.textEdit.insertAsSnippet;let gt;ft?gt=o.$5J.replace(pt,new o.$7J(wt)):gt=o.$3J.replace(pt,wt);const mt=He.get(rt);mt?mt.push(gt):He.set(rt,[gt])}else Me.renameFile(k.URI.revive(_e.oldResource),k.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of He)Me.set(_e,Je);return Me}Te.to=Se})(Q||(e.WorkspaceEdit=Q={}));var V;(function(Te){const Fe=Object.create(null);Fe[o.SymbolKind.File]=0,Fe[o.SymbolKind.Module]=1,Fe[o.SymbolKind.Namespace]=2,Fe[o.SymbolKind.Package]=3,Fe[o.SymbolKind.Class]=4,Fe[o.SymbolKind.Method]=5,Fe[o.SymbolKind.Property]=6,Fe[o.SymbolKind.Field]=7,Fe[o.SymbolKind.Constructor]=8,Fe[o.SymbolKind.Enum]=9,Fe[o.SymbolKind.Interface]=10,Fe[o.SymbolKind.Function]=11,Fe[o.SymbolKind.Variable]=12,Fe[o.SymbolKind.Constant]=13,Fe[o.SymbolKind.String]=14,Fe[o.SymbolKind.Number]=15,Fe[o.SymbolKind.Boolean]=16,Fe[o.SymbolKind.Array]=17,Fe[o.SymbolKind.Object]=18,Fe[o.SymbolKind.Key]=19,Fe[o.SymbolKind.Null]=20,Fe[o.SymbolKind.EnumMember]=21,Fe[o.SymbolKind.Struct]=22,Fe[o.SymbolKind.Event]=23,Fe[o.SymbolKind.Operator]=24,Fe[o.SymbolKind.TypeParameter]=25;function Se(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Te.from=Se;function ie(Me){for(const He in Fe)if(Fe[He]===Me)return Number(He);return o.SymbolKind.Property}Te.to=ie})(V||(e.SymbolKind=V={}));var _;(function(Te){function Fe(ie){switch(ie){case o.SymbolTag.Deprecated:return 1}}Te.from=Fe;function Se(ie){switch(ie){case 1:return o.SymbolTag.Deprecated}}Te.to=Se})(_||(e.SymbolTag=_={}));var ge;(function(Te){function Fe(ie){return{name:ie.name,kind:V.from(ie.kind),tags:ie.tags&&ie.tags.map(_.from),containerName:ie.containerName,location:K.from(ie.location)}}Te.from=Fe;function Se(ie){const Me=new o.$aK(ie.name,V.to(ie.kind),ie.containerName,K.to(ie.location));return Me.tags=ie.tags&&ie.tags.map(_.to),Me}Te.to=Se})(ge||(e.WorkspaceSymbol=ge={}));var ce;(function(Te){function Fe(ie){const Me={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:n.from(ie.range),selectionRange:n.from(ie.selectionRange),kind:V.from(ie.kind),tags:ie.tags?.map(_.from)??[]};return ie.children&&(Me.children=ie.children.map(Fe)),Me}Te.from=Fe;function Se(ie){const Me=new o.$bK(ie.name,ie.detail,V.to(ie.kind),n.to(ie.range),n.to(ie.selectionRange));return(0,C.$Ib)(ie.tags)&&(Me.tags=ie.tags.map(_.to)),ie.children&&(Me.children=ie.children.map(Se)),Me}Te.to=Se})(ce||(e.DocumentSymbol=ce={}));var we;(function(Te){function Fe(ie){const Me=new o.$gK(V.to(ie.kind),ie.name,ie.detail||"",k.URI.revive(ie.uri),n.to(ie.range),n.to(ie.selectionRange));return Me._sessionId=ie._sessionId,Me._itemId=ie._itemId,Me}Te.to=Fe;function Se(ie,Me,He){if(Me=Me??ie._sessionId,He=He??ie._itemId,Me===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:He,name:ie.name,detail:ie.detail,kind:V.from(ie.kind),uri:ie.uri,range:n.from(ie.range),selectionRange:n.from(ie.selectionRange),tags:ie.tags?.map(_.from)}}Te.from=Se})(we||(e.CallHierarchyItem=we={}));var G;(function(Te){function Fe(Se){return new o.$hK(we.to(Se.from),Se.fromRanges.map(ie=>n.to(ie)))}Te.to=Fe})(G||(e.CallHierarchyIncomingCall=G={}));var U;(function(Te){function Fe(Se){return new o.$iK(we.to(Se.to),Se.fromRanges.map(ie=>n.to(ie)))}Te.to=Fe})(U||(e.CallHierarchyOutgoingCall=U={}));var K;(function(Te){function Fe(ie){return{range:ie.range&&n.from(ie.range),uri:ie.uri}}Te.from=Fe;function Se(ie){return new o.$8J(k.URI.revive(ie.uri),n.to(ie.range))}Te.to=Se})(K||(e.location=K={}));var Y;(function(Te){function Fe(ie){const Me=ie,He=ie;return{originSelectionRange:Me.originSelectionRange?n.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:He.uri,range:n.from(Me.targetRange?Me.targetRange:He.range),targetSelectionRange:Me.targetSelectionRange?n.from(Me.targetSelectionRange):void 0}}Te.from=Fe;function Se(ie){return{targetUri:k.URI.revive(ie.uri),targetRange:n.to(ie.range),targetSelectionRange:ie.targetSelectionRange?n.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?n.to(ie.originSelectionRange):void 0}}Te.to=Se})(Y||(e.DefinitionLink=Y={}));var se;(function(Te){function Fe(ie){return{range:n.from(ie.range),contents:T.fromMany(ie.contents)}}Te.from=Fe;function Se(ie){return new o.$$J(ie.contents.map(T.to),n.to(ie.range))}Te.to=Se})(se||(e.Hover=se={}));var re;(function(Te){function Fe(ie){return{range:n.from(ie.range),expression:ie.expression}}Te.from=Fe;function Se(ie){return new o.$5K(n.to(ie.range),ie.expression)}Te.to=Se})(re||(e.EvaluatableExpression=re={}));var le;(function(Te){function Fe(ie){if(ie instanceof o.$6K)return{type:"text",range:n.from(ie.range),text:ie.text};if(ie instanceof o.$7K)return{type:"variable",range:n.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof o.$8K)return{type:"expression",range:n.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Fe;function Se(ie){switch(ie.type){case"text":return{range:n.to(ie.range),text:ie.text};case"variable":return{range:n.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:n.to(ie.range),expression:ie.expression}}}Te.to=Se})(le||(e.InlineValue=le={}));var Ee;(function(Te){function Fe(ie){return{frameId:ie.frameId,stoppedLocation:n.from(ie.stoppedLocation)}}Te.from=Fe;function Se(ie){return new o.$9K(ie.frameId,n.to(ie.stoppedLocation))}Te.to=Se})(Ee||(e.InlineValueContext=Ee={}));var he;(function(Te){function Fe(ie){return{range:n.from(ie.range),kind:ie.kind}}Te.from=Fe;function Se(ie){return new o.$_J(n.to(ie.range),ie.kind)}Te.to=Se})(he||(e.DocumentHighlight=he={}));var fe;(function(Te){function Fe(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Te.to=Fe})(fe||(e.CompletionTriggerKind=fe={}));var te;(function(Te){function Fe(Se){return{triggerKind:fe.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Te.to=Fe})(te||(e.CompletionContext=te={}));var ue;(function(Te){function Fe(ie){switch(ie){case o.CompletionItemTag.Deprecated:return 1}}Te.from=Fe;function Se(ie){switch(ie){case 1:return o.CompletionItemTag.Deprecated}}Te.to=Se})(ue||(e.CompletionItemTag=ue={}));var be;(function(Te){const Fe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se(He){return Fe.get(He)??9}Te.from=Se;const ie=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Me(He){return ie.get(He)??o.CompletionItemKind.Property}Te.to=Me})(be||(e.CompletionItemKind=be={}));var Pe;(function(Te){function Fe(Se,ie){const Me=new o.$qK(Se.label);return Me.insertText=Se.insertText,Me.kind=be.to(Se.kind),Me.tags=Se.tags?.map(ue.to),Me.detail=Se.detail,Me.documentation=R.$Yj(Se.documentation)?T.to(Se.documentation):Se.documentation,Me.sortText=Se.sortText,Me.filterText=Se.filterText,Me.preselect=Se.preselect,Me.commitCharacters=Se.commitCharacters,D.$is.isIRange(Se.range)?Me.range=n.to(Se.range):typeof Se.range=="object"&&(Me.range={inserting:n.to(Se.range.insert),replacing:n.to(Se.range.replace)}),Me.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Me.insertText=new o.$7J(Se.insertText):(Me.insertText=Se.insertText,Me.textEdit=Me.range instanceof o.$XJ?new o.$3J(Me.range,Me.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Me.additionalTextEdits=Se.additionalTextEdits.map(He=>x.to(He))),Me.command=ie&&Se.command?ie.fromInternal(Se.command):void 0,Me}Te.to=Fe})(Pe||(e.CompletionItem=Pe={}));var B;(function(Te){function Fe(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:T.fromStrict(ie.documentation)}}Te.from=Fe;function Se(ie){return{label:ie.label,documentation:R.$Yj(ie.documentation)?T.to(ie.documentation):ie.documentation}}Te.to=Se})(B||(e.ParameterInformation=B={}));var X;(function(Te){function Fe(ie){return{label:ie.label,documentation:T.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(B.from):[],activeParameter:ie.activeParameter}}Te.from=Fe;function Se(ie){return{label:ie.label,documentation:R.$Yj(ie.documentation)?T.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(B.to):[],activeParameter:ie.activeParameter}}Te.to=Se})(X||(e.SignatureInformation=X={}));var ee;(function(Te){function Fe(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(X.from):[]}}Te.from=Fe;function Se(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(X.to):[]}}Te.to=Se})(ee||(e.SignatureHelp=ee={}));var ne;(function(Te){function Fe(Se,ie){const Me=new o.$pK(h.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(Z.to.bind(void 0,Se)),ie.kind&&de.to(ie.kind));return Me.textEdits=ie.textEdits&&ie.textEdits.map(x.to),Me.tooltip=R.$Yj(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,Me.paddingLeft=ie.paddingLeft,Me.paddingRight=ie.paddingRight,Me}Te.to=Fe})(ne||(e.InlayHint=ne={}));var Z;(function(Te){function Fe(Se,ie){const Me=new o.$oK(ie.label);return Me.tooltip=R.$Yj(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,v.Command.is(ie.command)&&(Me.command=Se.fromInternal(ie.command)),ie.location&&(Me.location=K.to(ie.location)),Me}Te.to=Fe})(Z||(e.InlayHintLabelPart=Z={}));var de;(function(Te){function Fe(ie){return ie}Te.from=Fe;function Se(ie){return ie}Te.to=Se})(de||(e.InlayHintKind=de={}));var ye;(function(Te){function Fe(ie){return{range:n.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Te.from=Fe;function Se(ie){let Me;if(ie.url)try{Me=typeof ie.url=="string"?k.URI.parse(ie.url,!0):k.URI.revive(ie.url)}catch{}return new o.$vK(n.to(ie.range),Me)}Te.to=Se})(ye||(e.DocumentLink=ye={}));var je;(function(Te){function Fe(ie){const Me=new o.$yK(ie.label);return ie.textEdit&&(Me.textEdit=x.to(ie.textEdit)),ie.additionalTextEdits&&(Me.additionalTextEdits=ie.additionalTextEdits.map(He=>x.to(He))),Me}Te.to=Fe;function Se(ie){return{label:ie.label,textEdit:ie.textEdit?x.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Me=>x.from(Me)):void 0}}Te.from=Se})(je||(e.ColorPresentation=je={}));var We;(function(Te){function Fe(ie){return new o.$wK(ie[0],ie[1],ie[2],ie[3])}Te.to=Fe;function Se(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Te.from=Se})(We||(e.Color=We={}));var xe;(function(Te){function Fe(ie){return{range:n.from(ie.range)}}Te.from=Fe;function Se(ie){return new o.$fK(n.to(ie.range))}Te.to=Se})(xe||(e.SelectionRange=xe={}));var Qe;(function(Te){function Fe(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Te.to=Fe})(Qe||(e.TextDocumentSaveReason=Qe={}));var it;(function(Te){function Fe(ie){switch(ie){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Fe;function Se(ie){switch(ie){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Te.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Te){function Fe(ie){if(ie===o.EndOfLine.CRLF)return 1;if(ie===o.EndOfLine.LF)return 0}Te.from=Fe;function Se(ie){if(ie===1)return o.EndOfLine.CRLF;if(ie===0)return o.EndOfLine.LF}Te.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Te){function Fe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Fe})(Ae||(e.ProgressLocation=Ae={}));var Oe;(function(Te){function Fe(ie){const Me={start:ie.start+1,end:ie.end+1};return ie.kind&&(Me.kind=Ve.from(ie.kind)),Me}Te.from=Fe;function Se(ie){const Me={start:ie.start-1,end:ie.end-1};return ie.kind&&(Me.kind=Ve.to(ie.kind)),Me}Te.to=Se})(Oe||(e.FoldingRange=Oe={}));var Ve;(function(Te){function Fe(ie){if(ie)switch(ie){case o.FoldingRangeKind.Comment:return v.$0s.Comment;case o.FoldingRangeKind.Imports:return v.$0s.Imports;case o.FoldingRangeKind.Region:return v.$0s.Region}}Te.from=Fe;function Se(ie){if(ie)switch(ie.value){case v.$0s.Comment.value:return o.FoldingRangeKind.Comment;case v.$0s.Imports.value:return o.FoldingRangeKind.Imports;case v.$0s.Region.value:return o.FoldingRangeKind.Region}}Te.to=Se})(Ve||(e.FoldingRangeKind=Ve={}));var Le;(function(Te){function Fe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?n.from(Se.selection):void 0,override:typeof Se.override=="boolean"?s.$EE.id:void 0}}Te.from=Fe})(Le||(e.TextEditorOpenOptions=Le={}));var Xe;(function(Te){function Fe(He){return He instanceof o.$SK?He.toJSON():typeof He=="string"?He:Se(He)||ie(He)?new o.$SK(He.baseUri??He.base,He.pattern).toJSON():He}Te.from=Fe;function Se(He){const _e=He;return _e?k.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ie(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Me(He){return typeof He=="string"?He:new o.$SK(k.URI.revive(He.baseUri),He.pattern)}Te.to=Me})(Xe||(e.GlobPattern=Xe={}));var ae;(function(Te){function Fe(Se){if(Se){if(Array.isArray(Se))return Se.map(Fe);if(typeof Se=="string")return Se;{const ie=Se;return{language:ie.language,scheme:ie.scheme,pattern:Xe.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Te.from=Fe})(ae||(e.LanguageSelector=ae={}));var oe;(function(Te){function Fe(ie){return!!ie&&typeof ie=="object"&&"selections"in ie&&Array.isArray(ie.selections)&&ie.selections.every(Me=>Me instanceof o.$YJ)&&"related"in ie&&Array.isArray(ie.related)&&ie.related.every(Me=>Me&&typeof Me=="object"&&k.URI.isUri(Me.uri)&&Me.range instanceof o.$XJ)}Te.is=Fe;function Se(ie){return{selections:ie.selections.map(Me=>a.from(Me)),related:ie.related.map(Me=>({uri:k.URI.from(Me.uri),range:n.from(Me.range)}))}}Te.from=Se})(oe||(e.MappedEditsContext=oe={}));var Ie;(function(Te){function Fe(ie){return{start:ie.start,end:ie.end}}Te.from=Fe;function Se(ie){return new o.$hL(ie.start,ie.end)}Te.to=Se})(Ie||(e.NotebookRange=Ie={}));var qe;(function(Te){function Fe(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Te.to=Fe;function Se(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Te.from=Se})(qe||(e.NotebookCellExecutionSummary=qe={}));var ze;(function(Te){function Fe(Se){if(Se===d.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===d.NotebookCellExecutionState.Pending)return;if(Se===d.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Te.to=Fe})(ze||(e.NotebookCellExecutionState=ze={}));var Ze;(function(Te){function Fe(ie){switch(ie){case o.NotebookCellKind.Markup:return d.CellKind.Markup;case o.NotebookCellKind.Code:default:return d.CellKind.Code}}Te.from=Fe;function Se(ie){switch(ie){case d.CellKind.Markup:return o.NotebookCellKind.Markup;case d.CellKind.Code:default:return o.NotebookCellKind.Code}}Te.to=Se})(Ze||(e.NotebookCellKind=Ze={}));var nt;(function(Te){function Fe(ie){const Me={metadata:ie.metadata??Object.create(null),cells:[]};for(const He of ie.cells)o.$iL.validate(He),Me.cells.push(ot.from(He));return Me}Te.from=Fe;function Se(ie){const Me=new o.$jL(ie.cells.map(ot.to));return(0,p.$vf)(ie.metadata)||(Me.metadata=ie.metadata),Me}Te.to=Se})(nt||(e.NotebookData=nt={}));var ot;(function(Te){function Fe(ie){return{cellKind:Ze.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:qe.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Dt.from):[]}}Te.from=Fe;function Se(ie){return new o.$iL(Ze.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Dt.to):void 0,ie.metadata,ie.internalMetadata?qe.to(ie.internalMetadata):void 0)}Te.to=Se})(ot||(e.NotebookCellData=ot={}));var bt;(function(Te){function Fe(ie){return{mime:ie.mime,valueBytes:F.$Ed.wrap(ie.data)}}Te.from=Fe;function Se(ie){return new o.$kL(ie.valueBytes.buffer,ie.mime)}Te.to=Se})(bt||(e.NotebookCellOutputItem=bt={}));var Dt;(function(Te){function Fe(ie){return{outputId:ie.id,items:ie.items.map(bt.from),metadata:ie.metadata}}Te.from=Fe;function Se(ie){const Me=ie.items.map(bt.to);return new o.$lL(Me,ie.outputId,ie.metadata)}Te.to=Se})(Dt||(e.NotebookCellOutput=Dt={}));var Xt;(function(Te){function Fe(Me){return ie(Me)?{include:Xe.from(Me.include)??void 0,exclude:Xe.from(Me.exclude)??void 0}:Xe.from(Me)??void 0}Te.from=Fe;function Se(Me){return ie(Me)?{include:Xe.to(Me.include),exclude:Xe.to(Me.exclude)}:Xe.to(Me)}Te.to=Se;function ie(Me){const He=Me;return He?!(0,p.$rf)(He.include)&&!(0,p.$rf)(He.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Vt;(function(Te){function Fe(Se,ie,Me){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(He,Me),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Te.from=Fe})(Vt||(e.NotebookStatusBarItem=Vt={}));var vt;(function(Te){function Fe(Se,ie,Me){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ie.toInternal(He,Me),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Te.from=Fe})(vt||(e.NotebookKernelSourceAction=vt={}));var Ft;(function(Te){function Fe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Te.from=Fe})(Ft||(e.NotebookDocumentContentOptions=Ft={}));var Ot;(function(Te){function Fe(ie){return{uri:ie.uri,provides:ie.provides}}Te.from=Fe;function Se(ie){return new o.$nL(k.URI.revive(ie.uri),ie.provides)}Te.to=Se})(Ot||(e.NotebookRendererScript=Ot={}));var Kt;(function(Te){function Fe(ie){return{message:T.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:n.from(ie.location.range),uri:ie.location.uri}}}Te.from=Fe;function Se(ie){const Me=new o.$tL(typeof ie.message=="string"?ie.message:T.to(ie.message));return Me.actualOutput=ie.actual,Me.expectedOutput=ie.expected,Me.contextValue=ie.contextValue,Me.location=ie.location?K.to(ie.location):void 0,Me}Te.to=Se})(Kt||(e.TestMessage=Kt={}));var At;(function(Te){Te.namespace=g.$KI,Te.denamespace=g.$LI})(At||(e.TestTag=At={}));var Rt;(function(Te){function Fe(ie){const Me=(0,i.$RL)(ie).controllerId;return{extId:$.$GI.fromExtHostTestItem(ie,Me).toString(),label:ie.label,uri:k.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(He=>At.namespace(Me,He.id)),range:D.$is.lift(n.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&T.fromStrict(ie.error)||null}}Te.from=Fe;function Se(ie){return{parent:void 0,error:void 0,id:$.$GI.fromString(ie.extId).localId,label:ie.label,uri:k.URI.revive(ie.uri),tags:(ie.tags||[]).map(Me=>{const{tagId:He}=At.denamespace(Me);return new o.$uL(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:n.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Te.toPlain=Se})(Rt||(e.TestItem=Rt={})),function(Te){function Fe(ie){return{id:ie.id}}Te.from=Fe;function Se(ie){return new o.$uL(ie.id)}Te.to=Se}(At||(e.TestTag=At={}));var Nt;(function(Te){const Fe=(ie,Me)=>{const He=[];for(const[Je,rt]of Me)$.$GI.compare(rt.item.extId,Je)===2&&(Me.delete(Je),He.push(rt));const _e={...Rt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(rt=>rt.type===0).map(Kt.to)})),children:He.map(Je=>Fe(Je,Me))};for(const Je of _e.children)Je.parent=_e;return _e};function Se(ie){const Me=[],He=new Map;for(const _e of ie.items){He.set(_e.item.extId,_e);const Je=$.$GI.root(_e.item.extId);ie.request.targets.some(rt=>rt.controllerId===Je&&rt.testIds.includes(_e.item.extId))&&Me.push(_e)}return{completedAt:ie.completedAt,results:Me.map(_e=>Fe(_e,He))}}Te.to=Se})(Nt||(e.TestResults=Nt={}));var Ut;(function(Te){function Fe(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?h.from(He):n.from(He)}function ie(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Te.fromDetailed=ie;function Me(He){return{uri:He.uri,statement:Fe(He.statementCoverage),branch:He.branchCoverage&&Fe(He.branchCoverage),function:He.functionCoverage&&Fe(He.functionCoverage),details:He.detailedCoverage?.map(ie)}}Te.fromFile=Me})(Ut||(e.TestCoverage=Ut={}));var qt;(function(Te){function Fe(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Te.to=Fe})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Te){function Fe(ie){const Me=new o.$AL(V.to(ie.kind),ie.name,ie.detail||"",k.URI.revive(ie.uri),n.to(ie.range),n.to(ie.selectionRange));return Me._sessionId=ie._sessionId,Me._itemId=ie._itemId,Me}Te.to=Fe;function Se(ie,Me,He){if(Me=Me??ie._sessionId,He=He??ie._itemId,Me===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:He,kind:V.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:n.from(ie.range),selectionRange:n.from(ie.selectionRange),tags:ie.tags?.map(_.from)}}Te.from=Se})(Bt||(e.TypeHierarchyItem=Bt={}));var ct;(function(Te){function Fe(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Te.from=Fe})(ct||(e.ViewBadge=ct={}));var lt;(function(Te){function Fe(He,_e,Je){const rt=_e.fileData;return rt?new o.$LK(new o.$MK(rt.name,k.URI.revive(rt.uri),rt.id,(0,L.$bb)(()=>Je(rt.id)))):He===P.$Fr.uriList&&_e.uriListData?new o.$KK(Me(_e.uriListData)):new o.$KK(_e.asString)}Te.to=Fe;async function Se(He,_e){const Je=await _e.asString();if(He===P.$Fr.uriList)return{asString:Je,fileData:void 0,uriListData:ie(Je)};const rt=_e.asFile();return{asString:Je,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Te.from=Se;function ie(He){return f.$Rs.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return k.URI.parse(_e)}catch{}return _e})}function Me(He){return f.$Rs.create(He.map(_e=>typeof _e=="string"?_e:k.URI.revive(_e)))}})(lt||(e.DataTransferItem=lt={}));var Jt;(function(Te){function Fe(ie,Me){const He=ie.items.map(([_e,Je])=>[_e,lt.to(_e,Je,Me)]);return new o.$NK(He)}Te.toDataTransfer=Fe;async function Se(ie){const Me={items:[]},He=[];for(const[_e,Je]of ie)He.push((async()=>{Me.items.push([_e,await lt.from(_e,Je)])})());return await Promise.all(He),Me}Te.from=Se})(Jt||(e.DataTransfer=Jt={}));var Pt;(function(Te){function Fe(ie){return{message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Te.to=Fe;function Se(ie){return{kind:"reply",message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Te.from=Se})(Pt||(e.ChatReplyFollowup=Pt={}));var kt;(function(Te){function Fe(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:Pt.from(Se)}Te.from=Fe})(kt||(e.ChatFollowup=kt={}));var dt;(function(Te){function Fe(ie){const Me=new o.$KL(Ct.to(ie.role),ie.content);return Me.name=ie.name,Me}Te.to=Fe;function Se(ie){return{role:Ct.from(ie.role),content:ie.content,name:ie.name}}Te.from=Se})(dt||(e.ChatMessage=dt={}));var Ct;(function(Te){function Fe(ie){switch(ie){case 0:return o.ChatMessageRole.System;case 1:return o.ChatMessageRole.User;case 2:return o.ChatMessageRole.Assistant;case 3:return o.ChatMessageRole.Function}}Te.to=Fe;function Se(ie){switch(ie){case o.ChatMessageRole.System:return 0;case o.ChatMessageRole.Assistant:return 2;case o.ChatMessageRole.Function:return 3;case o.ChatMessageRole.User:default:return 1}}Te.from=Se})(Ct||(e.ChatMessageRole=Ct={}));var Mt;(function(Te){function Fe(ie){return{level:Et.to(ie.level),value:ie.value,description:ie.description}}Te.to=Fe;function Se(ie){return{level:Et.from(ie.level),value:ie.value,description:ie.description}}Te.from=Se})(Mt||(e.ChatVariable=Mt={}));var Et;(function(Te){function Fe(ie){switch(ie){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}Te.to=Fe;function Se(ie){switch(ie){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}Te.from=Se})(Et||(e.ChatVariableLevel=Et={}));var Ge;(function(Te){function Fe(Se){switch(Se){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted}}Te.to=Fe})(Ge||(e.InteractiveEditorResponseFeedbackKind=Ge={}));var jt;(function(Te){function Fe(Se,ie,Me){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ie.toInternal(Se,Me)}Te.from=Fe})(jt||(e.TerminalQuickFix=jt={}))}),define(De[280],Ce([1,0,2,8,7,13,75]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0;class m{constructor(b,P,I,p={timeout:1500,errors:3}){this.c=b,this.d=P,this.f=I,this.g=p,this.a=new R.$sc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(P,I,p)=>{const D={dispose:this.a.push([P,I,b])};return Array.isArray(p)&&p.push(D),D}}async $participateInSave(b,P){const I=C.URI.revive(b);let p=!1;const k=setTimeout(()=>p=!0,this.g.timeout),D=[];try{for(const v of[...this.a]){if(p)break;const r=this.d.getDocument(I),i=await this.h(v,{document:r,reason:L.TextDocumentSaveReason.to(P)});D.push(i)}}finally{clearTimeout(k)}return D}h([b,P,I],p){const k=this.b.get(b);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(I,b,P,p).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const v=this.b.get(b);this.b.set(b,v?v+1:1),typeof v=="number"&&v>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,P,I,p){const k=[],D=Date.now(),{document:v,reason:r}=p,{version:i}=v,s=Object.freeze({document:v,reason:r,waitUntil(d){if(Object.isFrozen(k))throw(0,F.$6)("waitUntil can not be called async");k.push(Promise.resolve(d))}});try{P.apply(I,[s])}catch(d){return Promise.reject(d)}return Object.freeze(k),new Promise((d,$)=>{const g=setTimeout(()=>$(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(g),d(t)}).catch(t=>{clearTimeout(g),$(t)})}).then(d=>{const $={edits:[]};for(const g of d)if(Array.isArray(g)&&g.every(t=>t instanceof f.$3J))for(const{newText:t,newEol:o,range:a}of g)$.edits.push({resource:v.uri,versionId:void 0,textEdit:{range:a&&L.Range.from(a),text:t,eol:o&&L.EndOfLine.from(o)}});if($.edits.length!==0)return i===v.version?this.f.$tryApplyWorkspaceEdit($):Promise.reject(new Error("concurrent_edits"))})}}e.$5ac=m}),define(De[281],Ce([1,0,17,2,13,7,108]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0;class m{constructor(I,p,k,D){this.start=I,this.deletedCount=p,this.deletedItems=k,this.items=D}asApiEvent(){return{range:new L.$hL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(I,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,p,k){this.notebook=I,this.h=p,this.j=k,this.handle=k.handle,this.uri=F.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(f.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(D){I.g=D},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(k)}return this.f}setOutputs(I){this.a=I.map(f.NotebookCellOutput.to)}setOutputItems(I,p,k){const D=k.map(f.NotebookCellOutputItem.to),v=this.a.find(r=>r.id===I);if(v&&(p||(v.items.length=0),v.items.push(...D),v.items.length>1&&v.items.every(r=>R.$1H(r.mime)))){const r=new Map,i=[];v.items.forEach(s=>{let d;r.has(s.mime)?d=r.get(s.mime):(d=[],r.set(s.mime,d),i.push(s.mime)),d.push(s.data)}),v.items.length=0,i.forEach(s=>{const d=R.$2H(r.get(s));v.items.push({mime:s,data:d.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$fcc=S;class b{static{this.a=0}constructor(I,p,k,D,v){this.k=I,this.l=p,this.m=k,this.uri=D,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=v.viewType,this.f=Object.freeze(v.metadata??Object.create(null)),this.r([[0,0,v.cells]],!0,void 0),this.g=v.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(k){return k=I.n(k),I.b[k].apiCell},getCells(k){return(k?I.p(k):I.b).map(v=>v.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,k){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:k});const D={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},v=[];for(const i of I.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,D.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,D.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),v.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),v.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),v.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),v.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),v.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const r=new Map;for(let i=0;i<v.length;i++){const s=v[i],d=r.get(s.cell);if(d===void 0){const $=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...s});r.set(s.cell,$-1)}else D.cellChanges[d]={...D.cellChanges[d],...s}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,k=I.end|0;return p<0&&(p=0),k>this.b.length&&(k=this.b.length),I.with({start:p,end:k})}p(I){I=this.o(I);const p=[];for(let k=I.start;k<I.end;k++)p.push(this.b[k]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,k){if(this.j)return;const D=[],v=[],r=[];if(I.reverse().forEach(i=>{const d=i[2].map(t=>{const o=new S(this,this.l,t);return p||v.push(S.asModelAddData(this.apiNotebook,t)),o}),$=new m(i[0],i[1],[],d),g=this.b.splice(i[0],i[1],...d);for(const t of g)r.push(t.uri),$.deletedItems.push(t.apiCell);D.push($)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:r}),k)for(const i of D)k.push(i.asApiEvent())}s(I,p,k,D){const v=this.b.splice(I,p);this.b.splice(k,0,...v);const r=[new m(I,p,v.map(i=>i.apiCell),[]),new m(k,0,[],v)];for(const i of r)D.push(i.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,k,D){this.b[I].setOutputItems(p,k,D)}v(I,p){const k=this.b[I];k.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(k.uri,p)}w(I,p){const k=this.b[I];k.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$gcc=b}),define(De[282],Ce([1,0,4,2,13,7]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class R{constructor(S,b,P,I={timeout:1500,errors:3}){this.b=S,this.c=b,this.d=P,this.f=I,this.a=new C.$gd}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(b,P,I)=>{const p=function(D){b.call(P,D)};return p.extension=S,this.a.event(p,void 0,I)}}async $participateInSave(S,b,P){const I=F.URI.revive(S),p=this.c.getNotebookDocument(I);if(!p)throw new Error("Unable to resolve notebook document");const k=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:f.TextDocumentSaveReason.to(b)},P,async(v,r)=>{const i=Date.now(),s=await await Promise.resolve(v);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!P.isCancellationRequested&&s&&(s instanceof L.$6J?k.push(s):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(k.length===0)return!0;const D={edits:[]};for(const v of k){const{edits:r}=f.WorkspaceEdit.from(v);D.edits=D.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$Gcc=R}),define(De[144],Ce([1,0,8,13,7]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,S,b,P,I,p){this.id=m,this.f=S,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=P,this.c=p}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(S){this.selections=[S]},get selections(){return m.a},set selections(S){if(!Array.isArray(S)||!S.every(f.$hL.isNotebookRange))throw(0,C.$5)("selections");m.a=S,m.g(S)},get visibleRanges(){return m.b},revealRange(S,b){m.f.$tryRevealRange(m.id,F.NotebookRange.from(S),b??f.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(F.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$hcc=L}),define(De[283],Ce([1,0,8,4,14,13]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;let R=class{constructor(S,b){this.c=S,this.d=b,this.a=new F.$ed({onListenerError:C.$Z}),this.b=new F.$ed({onListenerError:C.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(S,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,b);const P=this.d.getEditorById(S);b.visibleRanges&&P._acceptVisibleRanges(b.visibleRanges.ranges.map(L.NotebookRange.to)),b.selections&&P._acceptSelections(b.selections.selections.map(L.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const b in S)this.d.getEditorById(b)._acceptViewColumn(L.ViewColumn.to(S[b]))}};e.$zcc=R,e.$zcc=R=Ke([Be(0,f.$4i)],R)}),define(De[284],Ce([1,0,13,84,208,21,57,8]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=void 0;class S{constructor(p){this.b=0,this.c=new Map,this.a=p}async withProgress(p,k,D){const v=this.b++,{title:r,location:i,cancellable:s}=k,d={label:(0,f.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this.a.$startProgress(v,{location:C.ProgressLocation.from(i),title:r,source:d,cancellable:s},p.isUnderDevelopment?void 0:p.identifier.value).catch(m.$Z),this.d(v,D,!!s)}d(p,k,D){let v;D&&(v=new L.$od,this.c.set(p,v));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),v?.dispose()};let i;try{i=k(new P(this.a,p),D&&v?v.token:L.CancellationToken.None)}catch(s){throw r(p),s}return i.then(s=>r(p),s=>r(p)),i}$acceptProgressCanceled(p){const k=this.c.get(p);k&&(k.cancel(),this.c.delete(p))}}e.$Dbc=S;function b(I,p){return I.message=p.message,typeof p.increment=="number"&&(typeof I.increment=="number"?I.increment+=p.increment:I.increment=p.increment),I}class P extends F.$2u{constructor(p,k){super(D=>this.throttledReport(D)),this.f=p,this.g=k}throttledReport(p){this.f.$progressReport(this.g,p)}}Ke([(0,R.$7g)(100,(I,p)=>b(I,p),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(De[145],Ce([1,0,34,142,68,109,88,13,2]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=e.$9L=e.$8L=void 0;const b=(d,$,g,t)=>{let o=$;return{enumerable:!0,configurable:!1,get(){return o},set(a){if(!g(o,a)){const n=o;o=a,d.listener?.(t(a,n))}}}},P=(d,$)=>d===$,I={range:(d,$)=>d===$?!0:!d||!$?!1:d.isEqual($),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(d,$)=>!(d.length!==$.length||d.some(g=>!$.find(t=>g.id===t.id)))},p=d=>$=>({op:4,update:d($)}),k=(d,$)=>({range:(()=>{let g;const t=p(o=>({range:C.$is.lift(m.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return g},set(o){d.listener?.({op:6}),I.range(g,o)||(g=o,d.listener?.(t(o)))}}})(),label:b(d,$,I.label,p(g=>({label:g}))),description:b(d,void 0,I.description,p(g=>({description:g}))),sortText:b(d,void 0,I.sortText,p(g=>({sortText:g}))),canResolveChildren:b(d,!1,I.canResolveChildren,g=>({op:2,state:g})),busy:b(d,!1,I.busy,p(g=>({busy:g}))),error:b(d,void 0,I.error,p(g=>({error:m.MarkdownString.fromStrict(g)||null}))),tags:b(d,[],I.tags,(g,t)=>({op:1,new:g.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),D=d=>{const $=f.$GI.fromString(d.extId),g=new r($.controllerId,$.localId,d.label,S.URI.revive(d.uri)||void 0);return g.range=m.Range.to(d.range||void 0),g.description=d.description||void 0,g.sortText=d.sortText||void 0,g.tags=d.tags.map(t=>m.TestTag.to({id:(0,R.$LI)(t).tagId})),g},v=d=>{let $;for(const g of d.tests){const t=D(g.item);(0,F.$RL)(t).parent=$,$=t}return $};e.$8L=v;class r{constructor($,g,t,o){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const a=(0,F.$QL)(this,$);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof i?void 0:a.parent}},children:{value:(0,L.$PL)(a,F.$RL,r),enumerable:!0,writable:!1},...k(a,t)})}}e.$9L=r;class i extends r{constructor($,g){super($,$,g,void 0),this._isRoot=!0}}e.$0L=i;class s extends L.$LL{constructor($,g,t){super({controllerId:$,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:F.$RL,getChildren:o=>o.children,root:new i($,g),toITestItem:m.TestItem.from})}}e.$$L=s}),define(De[146],Ce([1,0,58,8,119,13,7]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=e.$3L=void 0;class m{static{this.c=new f.$1L("TextEditorDecorationType")}constructor(p,k,D){const v=m.c.nextId();p.$registerTextEditorDecorationType(k.identifier,v,L.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:v,dispose(){p.$removeTextEditorDecorationType(v)}})}}e.$3L=m;class S{constructor(p,k){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,k){this.k();let D=null;if(p instanceof R.$WJ)D=new R.$XJ(p,p);else if(p instanceof R.$XJ)D=p;else throw new Error("Unrecognized location");this.l(D,k,!1)}insert(p,k){this.k(),this.l(new R.$XJ(p,p),k,!0)}delete(p){this.k();let k=null;if(p instanceof R.$XJ)k=p;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(p,k,D){const v=this.c.validateRange(p);this.g.push({range:v,text:k,forceMoveMarkers:D})}setEndOfLine(p){if(this.k(),p!==R.EndOfLine.LF&&p!==R.EndOfLine.CRLF)throw(0,F.$5)("endOfLine");this.h=p}}class b{constructor(p,k,D,v){this.c=p,this.d=k,this._accept(D),this.e=v;const r=this;this.value={get tabSize(){return r.f},set tabSize(i){r.m(i)},get indentSize(){return r.g},set indentSize(i){r.o(i)},get insertSpaces(){return r.h},set insertSpaces(i){r.q(i)},get cursorStyle(){return r.j},set cursorStyle(i){r.s(i)},get lineNumbers(){return r.k},set lineNumbers(i){r.t(i)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.insertSpaces,this.j=p.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(p.lineNumbers)}l(p){if(p==="auto")return"auto";if(typeof p=="number"){const k=Math.floor(p);return k>0?k:null}if(typeof p=="string"){const k=parseInt(p,10);return isNaN(k)?null:k>0?k:null}return null}m(p){const k=this.l(p);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const k=Math.floor(p);return k>0?k:null}if(typeof p=="string"){const k=parseInt(p,10);return isNaN(k)?null:k>0?k:null}return null}o(p){const k=this.n(p);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p(p){return p==="auto"?"auto":p==="false"?!1:!!p}q(p){const k=this.p(p);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s(p){this.j!==p&&(this.j=p,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}t(p){this.k!==p&&(this.k=p,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(p)})))}assign(p){const k={};let D=!1;if(typeof p.tabSize<"u"){const v=this.l(p.tabSize);v==="auto"?(D=!0,k.tabSize=v):typeof v=="number"&&this.f!==v&&(this.f=v,D=!0,k.tabSize=v)}if(typeof p.indentSize<"u"){const v=this.n(p.indentSize);v==="tabSize"?(D=!0,k.indentSize=v):typeof v=="number"&&this.g!==v&&(this.g=v,D=!0,k.indentSize=v)}if(typeof p.insertSpaces<"u"){const v=this.p(p.insertSpaces);v==="auto"?(D=!0,k.insertSpaces=v):this.h!==v&&(this.h=v,D=!0,k.insertSpaces=v)}typeof p.cursorStyle<"u"&&this.j!==p.cursorStyle&&(this.j=p.cursorStyle,D=!0,k.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.k!==p.lineNumbers&&(this.k=p.lineNumbers,D=!0,k.lineNumbers=L.TextEditorLineNumbersStyle.from(p.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u(p,k){k.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(D)})}}e.$4L=b;class P{constructor(p,k,D,v,r,i,s,d){this.id=p,this.j=k,this.k=D,this.g=!1,this.h=new Set,this.c=r,this.d=new b(this.j,this.id,i,D),this.e=s,this.f=d;const $=this;this.value=Object.freeze({get document(){return v.value},set document(g){throw new F.$7("document")},get selection(){return $.c&&$.c[0]},set selection(g){if(!(g instanceof R.$YJ))throw(0,F.$5)("selection");$.c=[g],$.l()},get selections(){return $.c},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof R.$YJ)))throw(0,F.$5)("selections");$.c=g,$.l()},get visibleRanges(){return $.e},set visibleRanges(g){throw new F.$7("visibleRanges")},get options(){return $.d.value},set options(g){$.g||$.d.assign(g)},get viewColumn(){return $.f},set viewColumn(g){throw new F.$7("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if($.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(v.value,t);return g(o),$.m(o)},insertSnippet(g,t,o={undoStopBefore:!0,undoStopAfter:!0}){if($.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=$.c.map(n=>L.Range.from(n));else if(t instanceof R.$WJ){const{lineNumber:n,column:c}=L.Position.from(t);a=[{startLineNumber:n,startColumn:c,endLineNumber:n,endColumn:c}]}else if(t instanceof R.$XJ)a=[L.Range.from(t)];else{a=[];for(const n of t)if(n instanceof R.$XJ)a.push(L.Range.from(n));else{const{lineNumber:c,column:h}=L.Position.from(n);a.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return k.$tryInsertSnippet(p,v.value.version,g.value,a,o)},setDecorations(g,t){const o=t.length===0;o&&!$.h.has(g.key)||(o?$.h.delete(g.key):$.h.add(g.key),$.n(()=>{if(L.$SL(t))return k.$trySetDecorations(p,g.key,L.$TL(t));{const a=new Array(4*t.length);for(let n=0,c=t.length;n<c;n++){const h=t[n];a[4*n]=h.start.line+1,a[4*n+1]=h.start.character+1,a[4*n+2]=h.end.line+1,a[4*n+3]=h.end.character+1}return k.$trySetDecorationsFast(p,g.key,a)}}))},revealRange(g,t){$.n(()=>k.$tryRevealRange(p,L.Range.from(g),t||R.TextEditorRevealType.Default))},show(g){k.$tryShowEditor(p,L.ViewColumn.from(g))},hide(){k.$tryHideEditor(p)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,C.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,C.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,C.ok)(!this.g),this.f=p}_acceptSelections(p){(0,C.ok)(!this.g),this.c=p}async l(){const p=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const k=p.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const D=k.edits.map(r=>r.range);D.sort((r,i)=>r.end.line===i.end.line?r.end.character===i.end.character?r.start.line===i.start.line?r.start.character-i.start.character:r.start.line-i.start.line:r.end.character-i.end.character:r.end.line-i.end.line);for(let r=0,i=D.length-1;r<i;r++){const s=D[r].end;if(D[r+1].start.isBefore(s))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=k.edits.map(r=>({range:L.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,v,{setEndOfLine:typeof k.setEndOfLine=="number"?L.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$5L=P}),define(De[147],Ce([1,0,5,131]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=void 0,e.$$I=(0,C.$Bh)(F.$Hh)}),define(De[148],Ce([1,0,25,4,16,3]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g3b=e.$f3b=e.$e3b=e.$d3b=e.$c3b=void 0;class R{constructor(r){this.removedDueToLooping=r}}e.$c3b=R;class m{static isHostExtension(r,i,s){if(i.getExtensionDescription(r))return!1;const d=s.getExtensionDescription(r);return d?!!((d.main||d.browser)&&d.api==="none"):!1}constructor(r,i){this.h=r,this.c=new F.$ed,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(k),this.e=new C.$Wl,this.f=[],this.g=new Map;for(const r of this.d){if(this.e.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.e.set(r.identifier,r),this.f.push(r);const i=this.h.readActivationEvents(r);if(Array.isArray(i))for(let s of i)s==="onUri"&&(s=`onUri:${C.$Ul.toKey(r.identifier)}`),this.g.has(s)||this.g.set(s,[]),this.g.get(s).push(r)}}set(r){this.d=r,this.j(),this.c.fire(void 0)}deltaExtensions(r,i){this.d=D(this.d,i),this.d=this.d.concat(r);const s=m.k(this.d);return this.d=D(this.d,s.map(d=>d.identifier)),this.j(),this.c.fire(void 0),new R(s)}static k(r){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,o){this.addNode(t),this.addNode(o),this.c.has(t)?this.c.get(t).push(o):this.c.set(t,[o])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,o){const a=i.getArcs(t);for(let n=0;n<a.length;n++)if(!o.has(a[n]))return!1;return!0}getNodes(){return this.e}},s=new C.$Wl;for(const t of r)if(s.set(t.identifier,t),t.extensionDependencies)for(const o of t.extensionDependencies)i.addArc(C.$Ul.toKey(t.identifier),C.$Ul.toKey(o));const d=new Set;i.getNodes().filter(t=>i.getArcs(t).length===0).forEach(t=>d.add(t));const $=i.getNodes().filter(t=>!d.has(t));let g;do{g=!1;for(let t=0;t<$.length;t++){const o=$[t];i.hasOnlyGoodArcs(o,d)&&($.splice(t,1),t--,d.add(o),g=!0)}}while(g);return $.map(t=>s.get(t))}containsActivationEvent(r){return this.g.has(r)}containsExtension(r){return this.e.has(r)}getExtensionDescriptionsForActivationEvent(r){const i=this.g.get(r);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(r){const i=this.e.get(r);return i||void 0}getExtensionDescriptionByUUID(r){for(const i of this.f)if(i.uuid===r)return i}getExtensionDescriptionByIdOrUUID(r,i){return this.getExtensionDescription(r)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$d3b=m,e.$e3b={readActivationEvents:v=>v.activationEvents};class S{constructor(r){this.d=new I,this.c=new m(r,[])}async acquireLock(r){const i=await this.d.acquire(r);return new b(this,i)}deltaExtensions(r,i,s){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,i){return this.c.getExtensionDescriptionByIdOrUUID(r,i)}}e.$f3b=S;class b extends L.$jc{constructor(r,i){super(),this.f=r,this.c=!1,this.B(i)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$g3b=b;class P{constructor(r){this.name=r,this.promise=new Promise((i,s)=>{this.c=i})}resolve(r){this.c(r)}}class I{constructor(){this.c=[],this.d=!1}async acquire(r){const i=new P(r);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),d=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};r.resolve((0,L.$hc)(d))}}var p;(function(v){v[v.Builtin=0]="Builtin",v[v.User=1]="User",v[v.Dev=2]="Dev"})(p||(p={}));function k(v,r){const i=v.isBuiltin?0:v.isUnderDevelopment?2:1,s=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(i!==s)return i-s;const d=f.$5d.basename(v.extensionLocation.path),$=f.$5d.basename(r.extensionLocation.path);return d<$?-1:d>$?1:0}function D(v,r){const i=new C.$Vl(r);return v.filter(s=>!i.has(s.identifier))}}),define(De[285],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.ExtHostConnectionType=void 0;var C;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$mm=F;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[f.ENV_KEY]="1"}}e.$nm=f;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$om=L;function R(P){delete P[F.ENV_KEY],delete P[f.ENV_KEY],delete P[L.ENV_KEY]}function m(P,I){R(I),P.serialize(I)}e.$pm=m;function S(P){if(P[F.ENV_KEY])return b(P,new F(P[F.ENV_KEY]));if(P[f.ENV_KEY])return b(P,new f);if(P[L.ENV_KEY])return b(P,new L);throw new Error("No connection information defined in environment!")}e.$qm=S;function b(P,I){return R(P),I}}),define(De[111],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$4l=e.$3l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var L;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(b){const P=C.$Ed.alloc(1);switch(b){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$3l=R;function m(b,P){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$4l=m;var S;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(De[89],Ce([1,0,5,4,14,26,111,66,85,23,2,3,210]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=e.$bM=e.$aM=void 0;let k=class extends I.$jc{constructor(i,s){super(),this.s=i,this.t=s,this.a=this.B(new F.$ed),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$ed),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=s.createLogger(this.m,{id:S.$do,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(s.onDidChangeLogLevel(d=>{(0,f.$6i)(d)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,s,d){const $=this.getTelemetryDetails(),g=new D(s,d,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}),t=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...t,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(i,s,d){this.f=i,this.g=s,this.c=d??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const s=Object.create(null);switch(s["common.extname"]=`${i.publisher}.${i.name}`,s["common.extversion"]=i.version,s["common.vscodemachineid"]=this.s.telemetryInfo.machineId,s["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,s["common.vscodeversion"]=this.s.version,s["common.isnewappinstall"]=v(this.s.telemetryInfo.firstSessionDate),s["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:s["common.uikind"]="web";break;case R.UIKind.Desktop:s["common.uikind"]="desktop";break;default:s["common.uikind"]="unknown"}return s["common.remotename"]=(0,m.$Ok)((0,S.$ko)(this.s.remote.authority)),s}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const s=this.getTelemetryDetails();this.r.forEach((d,$)=>{const g=d.filter(t=>!t.isDisposed);g.length===0?this.r.delete($):this.r.set($,g)}),this.r.forEach(d=>{for(const $ of d)$.updateTelemetryEnablements(s.isUsageEnabled,s.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,s){const $=this.r.get(i.value)?.filter(t=>!t.isDisposed);if(!$)return this.r.delete(i.value),!1;let g=!1;for(const t of $)t.ignoreUnhandledExtHostErrors||(t.logError(s),g=!0);return g}};e.$aM=k,e.$aM=k=Ke([Be(0,L.$_L),Be(1,f.$5i)],k);class D{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,s,d,$,g,t,o){this.g=d,this.h=$,this.i=g,this.j=t,this.a=new F.$ed,this.ignoreUnhandledExtHostErrors=s?.ignoreUnhandledErrors??!1,this.b=s?.ignoreBuiltInCommonProperties??!1,this.c=s?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(i,s){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:s},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let s="properties"in i?i.properties??{}:i;return s=(0,S.$no)(s,[]),this.c&&(s=(0,b.$Xm)(s,this.c)),this.b||(s=(0,b.$Xm)(s,this.j)),"properties"in i?i.properties=s:i=s,i}k(i,s){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f?.sendEventData(i,s),this.h.trace(i,s))}logUsage(i,s){this.d.isUsageEnabled&&this.k(i,s)}logError(i,s){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,s);else{const d={name:i.name,message:i.message,stack:i.stack,cause:i.cause},$=(0,S.$no)(d,[]),g=new Error($.message,{cause:$.cause});g.stack=$.stack,g.name=$.name,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f.sendErrorData(g,s),this.h.trace("exception",s)}}get apiTelemetryLogger(){if(!this.e){const i=this,s={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(s)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$bM=D;function v(r){const i=Date.now()-new Date(r).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$cM=v,e.$dM=(0,C.$Ah)("IExtHostTelemetry")}),define(De[27],Ce([1,0,4,2,252,137,25,5]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.$QF=e.ActivationKind=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.ExtensionHostStartup=e.$KF=e.$JF=e.$IF=e.$HF=void 0,e.$HF=Object.freeze({identifier:new R.$Ul("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$IF="extensions.webWorker",e.$JF=(0,m.$Ah)("extensionService");class S{constructor(g){this.dependency=g}}e.$KF=S;var b;(function($){$[$.EagerAutoStart=1]="EagerAutoStart",$[$.EagerManualStart=2]="EagerManualStart",$[$.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.$yF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(g,t){const o=[],a=[],n=[],c=[],h=I(this.c),E=I(g),y=(O,N)=>O.extensionLocation.toString()===N.extensionLocation.toString()||O.isBuiltin===N.isBuiltin||O.isUserBuiltin===N.isUserBuiltin||O.isUnderDevelopment===N.isUnderDevelopment;for(const O of this.c){const N=E.get(O.identifier);if(!N){o.push(O.identifier),h.delete(O.identifier);continue}if(!y(O,N)){o.push(O.identifier),h.delete(O.identifier);continue}}for(const O of g){const N=h.get(O.identifier);if(!N){a.push(O);continue}if(!y(N,O)){o.push(N.identifier),h.delete(N.identifier);continue}}const u=new R.$Vl(this.d),l=new R.$Vl(t);for(const O of this.d)l.has(O)||n.push(O);for(const O of t)u.has(O)||c.push(O);const w=L.$yF.createActivationEventsMap(a),A={toRemove:o,toAdd:a,addActivationEvents:w,myToRemove:n,myToAdd:c};return this.delta(A),A}delta(g){const{toRemove:t,toAdd:o,myToRemove:a,myToAdd:n}=g,c=new R.$Vl(t),h=new R.$Vl(a);for(let E=0;E<this.c.length;E++)c.has(this.c[E].identifier)&&(this.c.splice(E,1),E--);for(let E=0;E<this.d.length;E++)h.has(this.d[E])&&(this.d.splice(E,1),E--);for(const E of o)this.c.push(E);for(const E of n)this.d.push(E)}containsExtension(g){for(const t of this.d)if(R.$Ul.equals(t,g))return!0;return!1}}e.$LF=P;function I($){const g=new R.$Wl;for(const t of $)g.set(t.identifier,t);return g}function p($,g){return $.enabledApiProposals?$.enabledApiProposals.includes(g):!1}e.$MF=p;function k($,g){if(!p($,g))throw new Error(`Extension '${$.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${$.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${$.identifier.value}`)}e.$NF=k;class D{constructor(g,t,o,a){this.codeLoadingTime=g,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=a}}e.$OF=D;class v{constructor(g,t){this.description=g,this.value=t}}e.$PF=v;var r;(function($){$[$.Normal=0]="Normal",$[$.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function i($){return{type:$.isBuiltin?0:1,isBuiltin:$.isBuiltin||$.isUserBuiltin,identifier:{id:(0,f.$to)($.publisher,$.name),uuid:$.uuid},manifest:$,location:$.extensionLocation,targetPlatform:$.targetPlatform,validations:[],isValid:!0}}e.$QF=i;function s($,g){return{identifier:new R.$Ul((0,f.$ro)($.manifest.publisher,$.manifest.name)),isBuiltin:$.type===0,isUserBuiltin:$.type===1&&$.isBuiltin,isUnderDevelopment:!!g,extensionLocation:$.location,...$.manifest,uuid:$.identifier.uuid,targetPlatform:$.targetPlatform}}e.$RF=s;class d{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(g,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$SF=d}),define(De[286],Ce([1,0,8,148,25,27,14,11]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=e.$0ac=e.$9ac=e.$8ac=e.$7ac=e.$6ac=void 0;class S{static{this.NONE=new S(!1,-1,-1,-1)}constructor(i,s,d,$){this.startup=i,this.codeLoadingTime=s,this.activateCallTime=d,this.activateResolvedTime=$}}e.$6ac=S;class b{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,s){return i===-1||s===-1?-1:s-i}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$7ac=b;class P{constructor(i,s,d,$,g,t){this.activationFailed=i,this.activationFailedError=s,this.activationTimes=d,this.module=$,this.exports=g,this.subscriptions=t}}e.$8ac=P;class I extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9ac=I;class p extends P{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0ac=p;class k extends P{constructor(i){super(!0,i,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(i,s,d,$){this.g=$,this.a=i,this.b=s,this.c=d,this.d=new f.$Wl,this.f=Object.create(null)}dispose(){for(const[i,s]of this.d)s.dispose()}async waitForActivatingExtensions(){const i=[];for(const[s,d]of this.d)i.push(d.wait());await Promise.all(i)}isActivated(i){const s=this.d.get(i);return!!(s&&s.value)}getActivatedExtension(i){const s=this.d.get(i);if(!s||!s.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return s.value}async activateByEvent(i,s){if(this.f[i])return;const d=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(d.map($=>({id:$.identifier,reason:{startup:s,extensionId:$.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,s){const d=this.a.getExtensionDescription(i);if(!d)throw new Error(`Extension '${i}' is not known`);return this.h([{id:d.identifier,reason:s}])}async h(i){const s=i.filter(d=>!this.isActivated(d.id)).map(d=>this.j(d));await Promise.all(s.map(d=>d.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const s=this.a.getExtensionDescription(i.id);if(!s){const g=new Error(`Cannot activate unknown extension '${i.id.value}'`),t=this.k(i,null,[],new k(g));return this.c.onExtensionActivationError(i.id,g,new L.$KF(i.id.value)),t}const d=[],$=typeof s.extensionDependencies>"u"?[]:s.extensionDependencies;for(const g of $){if(this.m(g))continue;const t=this.d.get(g);if(t){d.push(t);continue}if(this.l(g)){d.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:i.reason}));continue}const o=this.a.getExtensionDescription(g);if(o){if(!o.main&&!o.browser)continue;d.push(this.j({id:o.identifier,reason:i.reason}));continue}const a=s.displayName||s.identifier.value,n=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${g}'`),c=this.k(i,s.displayName,[],new k(n));return this.c.onExtensionActivationError(s.identifier,n,new L.$KF(g)),c}return this.k(i,s.displayName,d,null)}k(i,s,d,$){const g=new v(i.id,s,i.reason,d,$,this.c,this.g);return this.d.set(i.id,g),g}l(i){return F.$d3b.isHostExtension(i,this.a,this.b)}m(i){const s=this.b.getExtensionDescription(i);return s?!s.main&&!s.browser:!1}};e.$$ac=D,e.$$ac=D=Ke([Be(3,R.$4i)],D);let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,s,d,$,g,t,o){this.c=i,this.d=s,this.f=d,this.g=$,this.h=g,this.j=t,this.k=o,this.a=new m.$Eg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const s=this.g[i];if(s.value&&!s.value.activationFailed){this.g.splice(i,1),i--;continue}if(s.value&&s.value.activationFailed){const d=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${s.friendlyName}' failed to activate`);d.detail=s.value.activationFailedError,this.h=new k(d),this.j.onExtensionActivationError(this.c,d,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const s=new Error;if(i&&i.name&&(s.name=i.name),i&&i.message?s.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:s.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(s.stack=i.stack),this.h=new k(s),this.b&&C.$2(i))return;this.j.onExtensionActivationError(this.c,s,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};v=Ke([Be(6,R.$4i)],v)}),define(De[287],Ce([1,0,212,24,2,4,3,269,11,7,18,19,13,79,21,173,27]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;function i($,g){if((0,P.$if)($))return{label:$};if($&&typeof $=="object"&&typeof $.label=="string"){let t;return Array.isArray($.highlights)&&(t=$.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),t=t.length?t:void 0),{label:$.label,highlights:t}}}class s extends R.$jc{constructor(g,t,o){super(),this.f=g,this.g=t,this.h=o,this.a=new Map,this.b=new v.$_6;function a(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:n=>a(n)?this.r(n):Array.isArray(n)&&n.length>0?n.map(c=>a(c)?this.r(c):c):n})}registerTreeDataProvider(g,t,o){const a=this.createTreeView(g,{treeDataProvider:t},o);return{dispose:()=>a.dispose()}}createTreeView(g,t,o){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],n=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,E=this.m(g,t,o),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:n,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(g,y),l={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,r.$NF)(o,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,r.$NF)(o,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(w){(0,k.$Yj)(w)&&(0,r.$NF)(o,"treeViewMarkdownMessage"),E.message=w},get title(){return E.title},set title(w){E.title=w},get description(){return E.description},set description(w){E.description=w},get badge(){return E.badge},set badge(w){w!==void 0&&b.ViewBadge.isViewBadge(w)?E.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(E.badge=void 0)},reveal:(w,A)=>E.reveal(w,A),dispose:async()=>{await u,this.a.delete(g),E.dispose()}};return this.B(l),l}$getChildren(g,t){const o=this.a.get(g);return o?o.getChildren(t):Promise.reject(new m.$$E(g))}async $handleDrop(g,t,o,a,n,c,h,E){const y=this.a.get(g);if(!y)return Promise.reject(new m.$$E(g));const u=p.DataTransfer.toDataTransfer(o,async l=>(await this.f.$resolveDropFileData(g,t,l)).buffer);return h===g&&E&&await this.j(u,y,E,n,c),y.onDrop(u,a,n)}async j(g,t,o,a,n){const c=this.b.removeDragOperationTransfer(n);if(c)(await c)?.forEach((h,E)=>{h&&g.set(E,h)});else if(n&&t.handleDrag){const h=t.handleDrag(o,g,a);this.b.addDragOperationTransfer(n,h),await h}return g}async $handleDrag(g,t,o,a){const n=this.a.get(g);if(!n)return Promise.reject(new m.$$E(g));const c=await this.j(new b.$NK,n,t,a,o);if(!(!c||a.isCancellationRequested))return p.DataTransfer.from(c)}async $hasResolve(g){const t=this.a.get(g);if(!t)throw new m.$$E(g);return t.hasResolve}$resolve(g,t,o){const a=this.a.get(g);if(!a)throw new m.$$E(g);return a.resolveTreeItem(t,o)}$setExpanded(g,t,o){const a=this.a.get(g);if(!a)throw new m.$$E(g);a.setExpanded(t,o)}$setSelectionAndFocus(g,t,o){const a=this.a.get(g);if(!a)throw new m.$$E(g);a.setSelectionAndFocus(t,o)}$setVisible(g,t){const o=this.a.get(g);if(!o){if(!t)return;throw new m.$$E(g)}o.setVisible(t)}$changeCheckboxState(g,t){const o=this.a.get(g);if(!o)throw new m.$$E(g);o.setCheckboxState(t)}m(g,t,o){const a=this.B(new d(g,t,this.f,this.g.converter,this.h,o));return this.a.set(g,a),a}r(g){const t=this.a.get(g.$treeViewId);return t&&"$treeItemHandle"in g?t.getExtensionElement(g.$treeItemHandle):t&&"$focusedTreeItem"in g&&g.$focusedTreeItem?t.focusedElement:null}}e.$Kbc=s;class d extends R.$jc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(g=>this.getExtensionElement(g)).filter(g=>!(0,P.$rf)(g))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(g,t,o,a,n,c){if(super(),this.I=g,this.J=o,this.L=a,this.M=n,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$ed),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$ed),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$ed),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$ed),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$ed),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$ed),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$ed),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$od,c.contributes&&c.contributes.views)for(const u in c.contributes.views)for(const l of c.contributes.views[u])l.id===g&&(this.P=l.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let h,E;const y=L.Event.debounce(this.F.event,(u,l)=>(u||(u={message:!1,elements:[]}),l.element!==!1&&(h||(h=new Promise(w=>E=w),this.G=this.G.then(()=>h)),Array.isArray(l.element)?u.elements.push(...l.element):u.elements.push(l.element)),l.message&&(u.message=!0),u),200,!0);this.B(y(({message:u,elements:l})=>{l.length&&(this.H=this.H.then(()=>{const w=E;return h=null,this.$(l).then(()=>w())})),u&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(g){const t=g?this.getExtensionElement(g):void 0;if(g&&!t)return this.M.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let o=this.X(g);return o||(o=await this.Y(t)),o?o.map(a=>a.item):void 0}getExtensionElement(g){return this.j.get(g)}reveal(g,t){t=t||{select:!0,focus:!1};const o=(0,P.$rf)(t.select)?!0:t.select,a=(0,P.$rf)(t.focus)?!1:t.focus,n=(0,P.$rf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.G.then(()=>this.S(g)).then(c=>this.W(g,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(E=>E.item)},{select:o,focus:a,expand:n})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:o,focus:a,expand:n})}get message(){return this.O}set message(g){this.O=g,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(g){this.P=g,this.J.$setTitle(this.I,g,this.Q)}get description(){return this.Q}set description(g){this.Q=g,this.J.$setTitle(this.I,this.P,g)}get badge(){return this.R}set badge(g){this.R?.value===g?.value&&this.R?.tooltip===g?.tooltip||(this.R=p.ViewBadge.from(g),this.J.$setBadge(this.I,g))}setExpanded(g,t){const o=this.getExtensionElement(g);o&&(t?this.u.fire(Object.freeze({element:o})):this.w.fire(Object.freeze({element:o})))}setSelectionAndFocus(g,t){const o=!(0,I.$sb)(this.s,g);this.s=g;const a=this.t!==t;this.t=t,o&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(g){g!==this.r&&(this.r=g,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(g){const t=(await Promise.all(g.map(async o=>{const a=this.getExtensionElement(o.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:o.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);t.forEach(o=>{o.treeItem.checkboxState=o.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(o=>[o.extensionItem,o.newState])})}async handleDrag(g,t,o){const a=[];for(const n of g){const c=this.getExtensionElement(n);c&&a.push(c)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,o),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,t,o){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,S.$yg)(()=>this.g?.handleDrop?this.g.handleDrop(a,g,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,t){if(!this.f.resolveTreeItem)return;const o=this.j.get(g);if(o){const a=this.m.get(o);if(a){const n=await this.f.resolveTreeItem(a.extensionItem,o,t)??a.extensionItem;return this.hb(n),a.item.tooltip=this.eb(n.tooltip),a.item.command=this.fb(a.disposableStore,n.command),a.item}}}S(g){return this.U(g).then(t=>t?this.S(t).then(o=>this.W(t,o[o.length-1]).then(a=>(o.push(a),o))):Promise.resolve([]))}U(g){const t=this.m.get(g);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,S.$yg)(()=>this.f.getParent(g))}W(g,t){const o=this.m.get(g);return o?Promise.resolve(o):(0,S.$yg)(()=>this.f.getTreeItem(g)).then(a=>this.kb(g,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const n=this.getExtensionElement(a);if(n){const c=this.m.get(n);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(g){if(g){let t;if(typeof g=="string"){const o=this.getExtensionElement(g);t=o?this.m.get(o):void 0}else t=g;return t&&t.children||void 0}return this.h}async Y(g){this.rb(g);const t=new D.$od(this.Z.token);try{const o=g?this.m.get(g):void 0,a=await this.f.getChildren(g);if(t.token.isCancellationRequested)return;const n=await Promise.all((0,I.$Eb)(a||[]).map(async c=>{const h=await this.f.getTreeItem(c);return h&&!t.token.isCancellationRequested?this.db(c,h,o):null}));return t.token.isCancellationRequested?void 0:(0,I.$Eb)(n)}finally{t.dispose()}}$(g){if(g.some(o=>!o))return this.Z.dispose(!0),this.Z=new D.$od,this.tb(),this.J.$refresh(this.I);{const o=this.ab(g);if(o.length)return this.bb(o)}return Promise.resolve(void 0)}ab(g){const t=new Set,o=g.map(n=>this.m.get(n));for(const n of o)if(n&&!t.has(n.item.handle)){let c=n;for(;c&&c.parent&&o.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(n.item.handle)}const a=[];return t.forEach(n=>{const c=this.j.get(n);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&a.push(n)}}),a}bb(g){const t={};return Promise.all(g.map(o=>this.cb(o).then(a=>{a&&(t[o]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(g){const t=this.getExtensionElement(g);if(t){const o=this.m.get(t);if(o)return this.rb(t),(0,S.$yg)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const n=this.ib(t,a,o.parent);return this.pb(t,n,o,o.parent),o.dispose(),n}return null})}return Promise.resolve(null)}db(g,t,o){const a=this.ib(g,t,o);if(t.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(g,a),this.qb(a,o),a}eb(g){return b.$kK.isMarkdownString(g)?p.MarkdownString.from(g):g}fb(g,t){return t?{...this.L.toInternal(t,g),originalId:t.command}:void 0}gb(g){if(g.checkboxState===void 0)return;let t,o,a;return typeof g.checkboxState=="number"?t=g.checkboxState:(t=g.checkboxState.state,o=g.checkboxState.tooltip,a=g.checkboxState.accessibilityInformation),{isChecked:t===b.TreeItemCheckboxState.Checked,tooltip:o,accessibilityInformation:a}}hb(g){if(!b.$IK.isTreeItem(g,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(g,t,o){this.hb(t);const a=this.B(new R.$ic),n=this.kb(g,t,o),c=this.lb(t);return{item:{handle:n,parentHandle:o?o.item.handle:void 0,label:i(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,P.$rf)(t.collapsibleState)?b.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:o,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(g){return g.iconPath instanceof b.$QK?g.iconPath:void 0}kb(g,{id:t,label:o,resourceUri:a},n,c){if(t)return`${d.b}/${t}`;const h=i(o,this.N),E=n?n.item.handle:d.a;let y=h?h.label:a?(0,F.$eg)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const u=this.m.has(g)?this.m.get(g).item.handle:void 0,l=this.X(n)||[];let w,A=0;do{if(w=`${E}/${A}:${y}`,c||!this.j.has(w)||u===w)break;A++}while(A<=l.length);return w}lb(g){if(g.iconPath&&!(g.iconPath instanceof b.$QK))return typeof g.iconPath=="string"||f.URI.isUri(g.iconPath)?this.nb(g.iconPath):this.nb(g.iconPath.light)}mb(g){if(g.iconPath&&!(g.iconPath instanceof b.$QK)&&g.iconPath.dark)return this.nb(g.iconPath.dark)}nb(g){return f.URI.isUri(g)?g:f.URI.file(g)}ob(g,t){this.j.set(t.item.handle,g),this.m.set(g,t)}pb(g,t,o,a){this.j.delete(t.item.handle),this.m.delete(g),t.item.handle!==o.item.handle&&this.j.delete(o.item.handle),this.ob(g,t);const n=this.X(a)||[],c=n.filter(h=>h.item.handle===o.item.handle)[0];c&&n.splice(n.indexOf(c),1,t)}qb(g,t){t?(t.children||(t.children=[]),t.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}rb(g){if(g){const t=this.m.get(g);if(t){if(t.children)for(const o of t.children){const a=this.j.get(o.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(g){const t=this.m.get(g);if(t){if(t.children)for(const o of t.children){const a=this.j.get(o.item.handle);a&&this.sb(a)}this.m.delete(g),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(g=>g.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[288],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[289],Ce([1,0,224,8,38,132,106,42,25,288,135,137]),function($e,e,C,F,f,L,R,m,S,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const p=m.$7m.as(R.$8m.JSONContribution);class k{constructor(g,t,o){this.a=g,this.b=t,this.c=o}d(g,t){this.a({type:g,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(f.default.Error,g)}warn(g){this.d(f.default.Warning,g)}info(g){this.d(f.default.Info,g)}}e.$TF=k;class D{static a(g){const t=new S.$Vl;for(let o=0,a=g.length;o<a;o++)t.add(g[o].description.identifier);return t}static compute(g,t){if(!g||!g.length)return new D(t,[]);if(!t||!t.length)return new D([],g);const o=this.a(g),a=this.a(t),n=t.filter(h=>!o.has(h.description.identifier)),c=g.filter(h=>!a.has(h.description.identifier));return new D(n,c)}constructor(g,t){this.added=g,this.removed=t}}e.$UF=D;class v{constructor(g,t){this.name=g,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=D.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,F.$Y)(g)}}}e.$VF=v;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$WF={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.$Tl},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Ln}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Ln}},extensionKind:{description:C.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class s{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const t=new v(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,t),g.activationEventsGenerator&&I.$yF.register(g.extensionPoint,g.activationEventsGenerator),e.$WF.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,p.registerSchema(i,e.$WF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$XF=s;const d={ExtensionsRegistry:"ExtensionsRegistry"};m.$7m.add(d.ExtensionsRegistry,new s),e.$YF=m.$7m.as(d.ExtensionsRegistry),p.registerSchema(i,e.$WF),p.registerSchema(P.$kj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(De[290],Ce([1,0,221,18,23,289,41,4]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var b;(function(p){function k(D,v,r){if(!D)return;const i=F.$if(D.type)?D.type:void 0;if(!i||i.length===0){r.error(C.localize(3,null));return}const s=[];if(Array.isArray(D.required))for(const d of D.required)F.$if(d)&&s.push(d);return{extensionId:v.value,taskType:i,required:s,properties:D.properties?f.$Um(D.properties):{},when:D.when?R.$Hi.deserialize(D.when):void 0}}p.from=k})(b||(b={}));const P=L.$YF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,k)=>{for(const D of p)D.type&&k.push(`onTaskType:${D.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:S}});class I{constructor(){this.d=new m.$ed,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,D)=>{P.setHandler((v,r)=>{this.c=void 0;try{for(const i of r.removed){const s=i.value;for(const d of s)this.a&&d.type&&this.a[d.type]&&delete this.a[d.type]}for(const i of r.added){const s=i.value;for(const d of s){const $=b.from(d,i.description.identifier,i.collector);$&&(this.a[$.taskType]=$)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const D of this.all()){const v={type:"object",additionalProperties:!1};D.required.length>0&&(v.required=D.required.slice(0)),D.properties!==void 0?v.properties=f.$Um(D.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[D.taskType]},k.push(v)}this.c={oneOf:k}}return this.c}}e.$8F=new I}),define(De[291],Ce([1,0,222,18,24,23,41,290]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$fG=e.JsonSchemaVersion=e.ExecutionEngine=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$_F=e.ShellQuoting=e.$$F=e.$0F=e.$9F=void 0,e.$9F="settings",e.$0F=new R.$1i("taskRunning",!1,C.localize(0,null)),e.$$F={value:C.localize(1,null),original:"Tasks"};var S;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.$_F="$customized",function(z){function M(H){if(!H)return z.Strong;switch(H.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=M}(S||(e.ShellQuoting=S={}));var b;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var P;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(P||(e.RevealKind=P={})),function(z){function M(H){switch(H.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=M}(P||(e.RevealKind=P={}));var I;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(z){function M(H){switch(H.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=M}(I||(e.RevealProblemKind=I={}));var p;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(p||(e.PanelKind=p={})),function(z){function M(H){switch(H.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=M}(p||(e.PanelKind=p={}));var k;(function(z){z.defaults={echo:!0,reveal:P.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var D;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(z){function M(q){switch(q.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=M;function H(q){switch(q){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=H}(D||(e.RuntimeType=D={}));var v;(function(z){function M(H){return F.$if(H)?H:H.value}z.value=M})(v||(e.CommandString=v={}));var r;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function M(q){return q===z.Clean._id||q===z.Build._id||q===z.Rebuild._id||q===z.Test._id}z.is=M;function H(q){if(q!==void 0)return F.$if(q)?M(q)?{_id:q,isDefault:!1}:void 0:q}z.from=H})(r||(e.TaskGroup=r={}));var i;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var s;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function M(H){switch(H){case z.User:return 2;case z.WorkspaceFile:return 5;default:return 6}}z.toConfigurationTarget=M})(s||(e.TaskSourceKind=s={}));var d;(function(z){z.parallel="parallel",z.sequence="sequence"})(d||(e.DependsOrder=d={}));var $;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})($||(e.RunOnOptions=$={}));var g;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:$.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class t{constructor(M,H,q,me,x,Q){this._label="",this._id=M,H&&(this._label=H),q&&(this.type=q),this.runOptions=me,this.configurationProperties=x,this._source=Q}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,H=!1){if(M===void 0)return!1;if(F.$if(M))return M===this._label||M===this.configurationProperties.identifier||H&&M===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.$aG=t;class o extends t{constructor(M,H,q,me,x,Q,V,_){super(M,q,void 0,V,_,H),this.command={},this._source=H,this.hasDefinedMatchers=Q,x&&(this.command=x)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case D.Shell:H="shell";break;case D.Process:H="process";break;case D.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(M){return M instanceof o}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===s.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let H=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(H+=this._source.kind);const q={type:e.$_F,folder:M,id:H};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new o(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$bG=o;class a extends t{constructor(M,H,q,me,x,Q,V){super(M,q,me,Q,V,H),this._source=H,this.configures=x}static is(M){return M instanceof a}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===s.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let H=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(H+=this._source.kind);const q={type:e.$_F,folder:M,id:H};return JSON.stringify(q)}}e.$cG=a;class n extends t{constructor(M,H,q,me,x,Q,V,_,ge){super(M,q,me,_,ge,H),this.defines=x,this.hasDefinedMatchers=V,this.command=Q,this.icon=ge.icon,this.hide=ge.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof n}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new n(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$dG=n;class c extends t{constructor(M,H,q,me,x,Q){super(M,q,me,x,Q,H),this._source=H}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new c(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.$eG=c;var h;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(z){z._default=z.Terminal}(h||(e.ExecutionEngine=h={}));var E;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class y{constructor(M){this.c=new Map;for(let H=0;H<M.length;H++)this.c.set(M[H].uri.toString(),H)}compare(M,H){const q=M.getWorkspaceFolder(),me=H.getWorkspaceFolder();if(q&&me){let x=this.c.get(q.uri.toString());x=x===void 0?0:x+1;let Q=this.c.get(me.uri.toString());return Q=Q===void 0?0:Q+1,x===Q?M._label.localeCompare(H._label):x-Q}else return!q&&me?-1:q&&!me?1:0}}e.$fG=y;var u;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})(u||(e.TaskEventKind=u={}));var l;(function(z){z.SingleRun="singleRun",z.Background="background"})(l||(e.TaskRunType=l={}));var w;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var A;(function(z){function M(_){return{taskId:_._id,taskName:_.configurationProperties.name,runType:_.configurationProperties.isBackground?"background":"singleRun",group:_.configurationProperties.group,__task:_}}function H(_,ge,ce){return{...M(_),kind:"start",terminalId:ge,resolvedVariables:ce}}z.start=H;function q(_,ge,ce){return{...M(_),kind:"processStarted",terminalId:ge,processId:ce}}z.processStarted=q;function me(_,ge,ce){return{...M(_),kind:"processEnded",terminalId:ge,exitCode:ce}}z.processEnded=me;function x(_,ge,ce){return{...M(_),kind:"terminated",exitReason:ce,terminalId:ge}}z.terminated=x;function Q(_,ge,ce){return{...M(ge),kind:_,terminalId:ce}}z.general=Q;function V(){return{kind:"changed"}}z.changed=V})(A||(e.TaskEvent=A={}));var O;(function(z){function M(q){const me=Object.keys(q).sort();let x="";for(const Q of me){let V=q[Q];V instanceof Object?V=M(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),x+=Q+","+V+","}return x}function H(q){const x={_key:M(q),type:q.taskType};return Object.assign(x,q),x}z.create=H})(O||(e.KeyedTaskIdentifier=O={}));var N;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var T;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var j;(function(z){function M(H,q){const me=m.$8F.get(H.type);if(me===void 0){const _=L.$Um(H);return delete _._key,O.create(_)}const x=Object.create(null);x.type=me.taskType;const Q=new Set;me.required.forEach(_=>Q.add(_));const V=me.properties;for(const _ of Object.keys(V)){const ge=H[_];if(ge!=null)x[_]=ge;else if(Q.has(_)){const ce=V[_];if(ce.default!==void 0)x[_]=L.$Um(ce.default);else switch(ce.type){case"boolean":x[_]=!1;break;case"number":case"integer":x[_]=0;break;case"string":x[_]="";break;default:q.error(C.localize(2,null,JSON.stringify(H,void 0,0),_));return}}}return O.create(x)}z.createTaskIdentifier=M})(j||(e.TaskDefinition=j={}))}),define(De[292],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i3b=e.$h3b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,C.$Y)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$h3b=F;class f extends F{constructor(){super(),this.h=!0,this.i=new C.$3}}e.$i3b=f}),define(De[69],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aA=e.$_z=e.$$z=e.$0z=void 0;class C{static{this.count=0}constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++C.count}}e.$0z=C;const F=[];function f(m){const S=new C(m);return F[S.nid]=S,S}e.$$z=f;function L(m){return F[m].sid}e.$_z=L;class R{constructor(S){this.value=S}}e.$aA=R}),define(De[6],Ce([1,0,69]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.$TJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$SJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(v){v[v.UnknownInput=0]="UnknownInput",v[v.TextInput=1]="TextInput",v[v.TextDiffInput=2]="TextDiffInput",v[v.TextMergeInput=3]="TextMergeInput",v[v.NotebookInput=4]="NotebookInput",v[v.NotebookDiffInput=5]="NotebookDiffInput",v[v.CustomEditorInput=6]="CustomEditorInput",v[v.WebviewEditorInput=7]="WebviewEditorInput",v[v.TerminalEditorInput=8]="TerminalEditorInput",v[v.InteractiveEditorInput=9]="InteractiveEditorInput"})(f||(e.TabInputKind=f={}));var L;(function(v){v[v.TAB_OPEN=0]="TAB_OPEN",v[v.TAB_CLOSE=1]="TAB_CLOSE",v[v.TAB_UPDATE=2]="TAB_UPDATE",v[v.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var S;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var b;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var P;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class I{static{this.a=0}static mixin(r){return r._id=I.a++,r}}e.$SJ=I;var p;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.kindModifier="m",v.commandIdent="n",v.commandId="o",v.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var k;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var D;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$TJ={MainThreadAuthentication:(0,C.$$z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$$z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$$z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,C.$$z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,C.$$z)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$$z)("MainThreadClipboard"),MainThreadCommands:(0,C.$$z)("MainThreadCommands"),MainThreadComments:(0,C.$$z)("MainThreadComments"),MainThreadConfiguration:(0,C.$$z)("MainThreadConfiguration"),MainThreadConsole:(0,C.$$z)("MainThreadConsole"),MainThreadDebugService:(0,C.$$z)("MainThreadDebugService"),MainThreadDecorations:(0,C.$$z)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$$z)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$$z)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$$z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$$z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$$z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$$z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$$z)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$$z)("MainThreadErrors"),MainThreadTreeViews:(0,C.$$z)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$$z)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$$z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$$z)("MainThreadLanguages"),MainThreadLogger:(0,C.$$z)("MainThreadLogger"),MainThreadMessageService:(0,C.$$z)("MainThreadMessageService"),MainThreadOutputService:(0,C.$$z)("MainThreadOutputService"),MainThreadProgress:(0,C.$$z)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$$z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$$z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$$z)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$$z)("MainThreadSecretState"),MainThreadStorage:(0,C.$$z)("MainThreadStorage"),MainThreadTelemetry:(0,C.$$z)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$$z)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$$z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$$z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$$z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$$z)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$$z)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$$z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$$z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$$z)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$$z)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.$$z)("MainThreadExtensionService"),MainThreadSCM:(0,C.$$z)("MainThreadSCM"),MainThreadSearch:(0,C.$$z)("MainThreadSearch"),MainThreadShare:(0,C.$$z)("MainThreadShare"),MainThreadTask:(0,C.$$z)("MainThreadTask"),MainThreadWindow:(0,C.$$z)("MainThreadWindow"),MainThreadLabelService:(0,C.$$z)("MainThreadLabelService"),MainThreadNotebook:(0,C.$$z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$$z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$$z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$$z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$$z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$$z)("MainThreadInteractive"),MainThreadChat:(0,C.$$z)("MainThreadChat"),MainThreadInlineChat:(0,C.$$z)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$$z)("MainThreadTheming"),MainThreadTunnelService:(0,C.$$z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$$z)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$$z)("MainThreadTimeline"),MainThreadTesting:(0,C.$$z)("MainThreadTesting"),MainThreadLocalization:(0,C.$$z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$$z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$$z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$$z)("MainThreadIssueReporter")},e.$UJ={ExtHostCommands:(0,C.$$z)("ExtHostCommands"),ExtHostConfiguration:(0,C.$$z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$$z)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$$z)("ExtHostDebugService"),ExtHostDecorations:(0,C.$$z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$$z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$$z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$$z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$$z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$$z)("ExtHostEditors"),ExtHostTreeViews:(0,C.$$z)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$$z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$$z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$$z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$$z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$$z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$$z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$$z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$$z)("ExtHostStatusBar"),ExtHostShare:(0,C.$$z)("ExtHostShare"),ExtHostExtensionService:(0,C.$$z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$$z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$$z)("ExtHostTerminalService"),ExtHostSCM:(0,C.$$z)("ExtHostSCM"),ExtHostSearch:(0,C.$$z)("ExtHostSearch"),ExtHostTask:(0,C.$$z)("ExtHostTask"),ExtHostWorkspace:(0,C.$$z)("ExtHostWorkspace"),ExtHostWindow:(0,C.$$z)("ExtHostWindow"),ExtHostWebviews:(0,C.$$z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$$z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$$z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$$z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$$z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$$z)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$$z)("ExtHostProgress"),ExtHostComments:(0,C.$$z)("ExtHostComments"),ExtHostSecretState:(0,C.$$z)("ExtHostSecretState"),ExtHostStorage:(0,C.$$z)("ExtHostStorage"),ExtHostUrls:(0,C.$$z)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$$z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$$z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$$z)("ExtHostOutputService"),ExtHosLabelService:(0,C.$$z)("ExtHostLabelService"),ExtHostNotebook:(0,C.$$z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$$z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$$z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$$z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$$z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$$z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$$z)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$$z)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$$z)("ExtHostChat"),ExtHostChatSlashCommands:(0,C.$$z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,C.$$z)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$$z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,C.$$z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$$z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$$z)("ExtHostTheming"),ExtHostTunnelService:(0,C.$$z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$$z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$$z)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$$z)("ExtHostTimeline"),ExtHostTesting:(0,C.$$z)("ExtHostTesting"),ExtHostTelemetry:(0,C.$$z)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$$z)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$$z)("ExtHostIssueReporter")}}),define(De[293],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$TJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,S){if(this.a.size===0)throw new Error("No related information providers registered");const b=this.a.get(R);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation(m,S)??[]}getRelatedInformation(R,m,S){return this.c.$getAiRelatedInformation(m,S)}registerRelatedInformationProvider(R,m,S){const b=this.b;return this.b++,this.a.set(b,S),this.c.$registerAiRelatedInformationProvider(b,m),new F.$VJ(()=>{this.c.$unregisterAiRelatedInformationProvider(b),this.a.delete(b)})}}e.$Mcc=f}),define(De[90],Ce([1,0,5,14,6,20]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=e.$Pac=e.$Oac=void 0,e.$Oac=(0,C.$Ah)("IExtHostApiDeprecationService");let R=class{constructor(S,b){this.c=b,this.a=new Set,this.b=S.getProxy(f.$TJ.MainThreadTelemetry)}report(S,b,P){const I=this.d(S,b);this.a.has(I)||(this.a.add(I),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:S}))}d(S,b){return`${S}-${b.identifier.value}`}};e.$Pac=R,e.$Pac=R=Ke([Be(0,L.$VL),Be(1,F.$4i)],R),e.$Qac=Object.freeze(new class{report(m,S,b){}})}),define(De[294],Ce([1,0,4,6,7,25]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class R{constructor(b){this.b=new Map,this.c=[],this.d=new C.$ed,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=b.getProxy(F.$TJ.MainThreadAuthentication)}$setProviders(b){return this.c=b,Promise.resolve()}async getSession(b,P,I,p={}){const k=L.$Ul.toKey(b.identifier),D=[...I].sort().join(" ");return await this.f.getOrCreate(`${k} ${P} ${D}`,async()=>{await this.a.$ensureProvider(P);const v=b.displayName||b.name;return this.a.$getSession(P,I,k,v,p)})}async getSessions(b,P,I){const p=L.$Ul.toKey(b.identifier),k=[...I].sort().join(" ");return await this.g.getOrCreate(`${p} ${k}`,async()=>{await this.a.$ensureProvider(P);const D=b.displayName||b.name;return this.a.$getSessions(P,I,p,D)})}async removeSession(b,P){const I=this.b.get(b);return I?I.provider.removeSession(P):this.a.$removeSession(b,P)}registerAuthenticationProvider(b,P,I,p){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:P,provider:I,options:p??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===b)||this.c.push({id:b,label:P});const k=I.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(b,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(b,P,p?.supportsMultipleAccounts??!1),new f.$VJ(()=>{k.dispose(),this.b.delete(b);const D=this.c.findIndex(v=>v.id===b);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,P,I){const p=this.b.get(b);if(p)return Promise.resolve(p.provider.createSession(P,I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,P){const I=this.b.get(b);if(I)return Promise.resolve(I.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,P){const I=this.b.get(b);if(I)return Promise.resolve(I.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,P){return this.d.fire({provider:{id:b,label:P}}),Promise.resolve()}}e.$kcc=R;class m{constructor(){this.a=new Map}getOrCreate(b,P){const I=this.a.get(b);if(I)return I;const p=P().finally(()=>this.a.delete(b));return this.a.set(b,p),p}}}),define(De[295],Ce([1,0,6,20,13]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;let L=class{constructor(m,S){this.a=m.getProxy(C.$TJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>S.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,S,b){const P=f.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,b?.isRefactoring??!1)}};e.$qcc=L,e.$qcc=L=Ke([Be(0,F.$VL)],L)}),define(De[296],Ce([1,0,11,4,50,3,37,202,6,13]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class P{static{this.a=0}constructor(k,D){this.extension=k,this.provider=D,this.handle=P.a++}}class I{static{this.a=0}constructor(k,D){this.h=D,this.b=new Map,this.d=new Map,this.e=new F.$ed,this.onDidPerformUserAction=this.e.event,this.g=k.getProxy(S.$TJ.MainThreadChat)}registerChatProvider(k,D,v){const r=new P(k,v);return this.b.set(r.handle,r),this.g.$registerChatProvider(r.handle,D),(0,L.$hc)(()=>{this.g.$unregisterChatProvider(r.handle),this.b.delete(r.handle)})}transferChatSession(k,D){const v=f.Iterable.find(this.d.keys(),r=>this.d.get(r)===k)??0;typeof v=="number"&&this.g.$transferChatSession(v,D)}addChatRequest(k){this.g.$addRequest(k)}sendInteractiveRequestToProvider(k,D){this.g.$sendRequestToProvider(k,D)}async $prepareChat(k,D,v){const r=this.b.get(k);if(!r)return;const i=await r.provider.prepareSession(D,v);if(!i)return;const s=I.a++;return this.d.set(s,i),{id:s,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(k,D,v,r){const i=this.b.get(k);if(!i)return;const s=this.d.get(D);if(!s||!i.provider.resolveRequest)return;const d=await i.provider.resolveRequest(s,v,r);if(d)return{message:typeof d.message=="string"?d.message:b.ChatReplyFollowup.from(d.message)}}async $provideWelcomeMessage(k,D){const v=this.b.get(k);if(!v||!v.provider.provideWelcomeMessage)return;const r=await v.provider.provideWelcomeMessage(D);if(r)return r.map(i=>typeof i=="string"?i:i.map(s=>b.ChatReplyFollowup.from(s)))}async $provideFollowups(k,D,v){const r=this.b.get(k);if(!r)return;const i=this.d.get(D);return!i||!r.provider.provideFollowups?void 0:(await r.provider.provideFollowups(i,v))?.map(d=>b.ChatFollowup.from(d))}$removeRequest(k,D,v){const r=this.b.get(k);if(!r)return;const i=this.d.get(D);i&&r.provider.removeRequest&&r.provider.removeRequest(i,v)}async $provideReply(k,D,v,r){const i=this.b.get(k);if(!i)return;const s=this.d.get(D);if(!s)return;const d={session:s,message:typeof v.message=="string"?v.message:b.ChatReplyFollowup.to(v.message),variables:{}};if(v.variables)for(const n of Object.keys(v.variables))d.variables[n]=v.variables[n].map(b.ChatVariable.to);const $=R.$ad.create(!1);let g;const t={report:n=>{if(!r.isCancellationRequested)if(typeof g>"u"&&(g=$.elapsed()),"responseId"in n)this.g.$acceptResponseProgress(k,D,{requestId:n.responseId});else if("placeholder"in n&&"resolvedContent"in n){const c=Promise.all([this.g.$acceptResponseProgress(k,D,{placeholder:n.placeholder}),n.resolvedContent]);(0,C.$ug)(c,r).then(h=>{if(!h)return;const[E,y]=h;this.g.$acceptResponseProgress(k,D,y,E??void 0)})}else"content"in n?this.g.$acceptResponseProgress(k,D,{content:typeof n.content=="string"?n.content:b.MarkdownString.from(n.content)}):this.g.$acceptResponseProgress(k,D,n)}};let o;try{o=await i.provider.provideResponseWithProgress(d,t,r),o||(o={errorDetails:{message:(0,m.localize)(0,null)}})}catch(n){o={errorDetails:{message:(0,m.localize)(1,null,n.message),responseIsIncomplete:!0}},this.h.error(n)}try{if(s.saveState&&this.d.has(D)){const n=s.saveState();this.g.$acceptChatState(D,n)}}catch(n){this.h.warn(n)}const a={firstProgress:g??0,totalElapsed:$.elapsed()};return{errorDetails:o.errorDetails,timings:a}}async $provideSlashCommands(k,D,v){const r=this.b.get(k);if(!r)return;const i=this.d.get(D);return!i||!r.provider.provideSlashCommands?void 0:(await r.provider.provideSlashCommands(i,v))?.map(d=>({...d,kind:b.CompletionItemKind.from(d.kind)}))}$releaseSession(k){this.d.delete(k)}async $onDidPerformUserAction(k){this.e.fire(k)}}e.$Ecc=I}),define(De[297],Ce([1,0,3,6,13,84,25]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class m{static{this.a=1}constructor(b,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new R.$Wl,this.b=b.getProxy(F.$TJ.MainThreadChatProvider)}registerProvider(b,P,I,p){const k=m.a++;return this.c.set(k,{extension:b,provider:I}),this.b.$registerProvider(k,P,{extension:b,displayName:p.name??b.value}),(0,C.$hc)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}async $provideChatResponse(b,P,I,p,k){const D=this.c.get(b);if(!D)return;const v=new L.$2u(async r=>{if(k.isCancellationRequested){this.d.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:r.index,part:r.part})},{async:!0});return D.provider.provideChatResponse(I.map(f.ChatMessage.to),p,v,k)}allowListExtensionWhile(b,P){this.f.set(b,P),P.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,P){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(b)},async makeRequest(p,k,D,v){if(!I.f.has(b))throw new Error("Access to chat has been revoked");const r=Math.random()*1e6|0;I.e.set(r,D);try{await I.b.$fetchResponse(b,P,r,p.map(f.ChatMessage.from),k,v)}finally{I.e.delete(r)}}}}async $handleResponseFragment(b,P){this.e.get(b)?.report(P)}}e.$Jcc=m}),define(De[298],Ce([1,0,3,6,7,13,84,11]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class S{static{this.a=0}constructor(I,p,k){this.d=p,this.e=k,this.b=new Map,this.c=I.getProxy(F.$TJ.MainThreadChatSlashCommands)}registerCommand(I,p,k,D){const v=S.a++;return this.b.set(v,{extension:I,command:k}),this.c.$registerCommand(v,p,D.description),(0,C.$hc)(()=>{this.c.$unregisterCommand(v),this.b.delete(v)})}async $executeCommand(I,p,k,D,v){const r=this.b.get(I);if(!r){this.e.warn(`[CHAT](${I}) CANNOT execute command because the command is not registered`);return}let i=!1;function s(){if(i)throw new Error("Only valid while executing the command")}const d=new m.$1g;v.onCancellationRequested(()=>d.complete()),setTimeout(()=>d.complete(),3*1e3),this.d.allowListExtensionWhile(r.extension,d.p);const $=r.command({role:f.ChatMessageRole.User,content:k},{history:D.history.map(L.ChatMessage.to)},new R.$2u(g=>{s(),this.c.$handleProgressChunk(p,{content:b(g.message)?g.message:g.message.value})}),v);try{return await(0,m.$ug)(Promise.resolve($).then(g=>{if(g&&"followUp"in g)return{followUp:g?.followUp?.map(o=>L.ChatFollowup.from(o))}}),v)}finally{i=!0,d.complete()}}}e.$Kcc=S;function b(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(De[299],Ce([1,0,3,6,8,13]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class R{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(F.$TJ.MainThreadChatVariables)}async $resolveVariable(S,b,P){const I=this.b.get(S);if(I)try{const p=await I.resolver.resolve(I.data.name,{message:b},P);if(p)return p.map(L.ChatVariable.from)}catch(p){(0,f.$Z)(p)}}registerVariableResolver(S,b,P,I){const p=R.a++;return this.b.set(p,{extension:S.identifier,data:{name:b,description:P},resolver:I}),this.c.$registerVariable(p,{name:b,description:P}),(0,C.$hc)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$Lcc=R}),define(De[300],Ce([1,0,6]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=void 0;class F{constructor(L){const R=L.getProxy(C.$TJ.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$Tac=F}),define(De[33],Ce([1,0,18,7,13,23,6,19,14,63,34,62,2,3,5,20,145,22,69,46,37,85,89]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=void 0;let o=class{#e;#t;#i;constructor(y,u,l){this.b=new Map,this.c=new Map,this.#e=y.getProxy(R.$TJ.MainThreadCommands),this.d=u,this.#i=l,this.#t=y.getProxy(R.$TJ.MainThreadTelemetry),this.converter=new a(this,w=>{const A=this.c.get(w);return A?.result===c.Void?A:void 0},u),this.f=[{processArgument(w){return(0,b.$0g)(w)}},{processArgument(w){return(0,L.$Wm)(w,function(A){if(P.$is.isIRange(A))return f.Range.to(A);if(I.$hs.isIPosition(A))return f.Position.to(A);if(P.$is.isIRange(A.range)&&p.URI.isUri(A.uri))return f.location.to(A);if(A instanceof i.$Ed)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(y){this.f.push(y)}registerApiCommand(y){const u=this.registerCommand(!1,y.id,async(...l)=>{const w=y.args.map((O,N)=>{if(!O.validate(l[N]))throw new Error(`Invalid argument '${O.name}' when running '${y.id}', received: ${l[N]}`);return O.convert(l[N])}),A=await this.executeCommand(y.internalId,...w);return y.result.convert(A,l,this.converter)},void 0,{description:y.description,args:y.args,returns:y.result.description});return this.c.set(y.id,y),new F.$VJ(()=>{u.dispose(),this.c.delete(y.id)})}registerCommand(y,u,l,w,A,O){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:l,thisArg:w,description:A,extension:O}),y&&this.#e.$registerCommand(u),new F.$VJ(()=>{this.b.delete(u)&&y&&this.#e.$unregisterCommand(u)})}executeCommand(y,...u){return this.d.trace("ExtHostCommands#executeCommand",y),this.g(y,u,!0)}async g(y,u,l){if(this.b.has(y))return this.#e.$fireCommandActivationEvent(y),this.h(y,u,!1);{let w=!1;const A=(0,L.$Wm)(u,function(O){if(O instanceof F.$WJ)return f.Position.from(O);if(O instanceof F.$XJ)return f.Range.from(O);if(O instanceof F.$8J)return f.location.from(O);if(F.$hL.isNotebookRange(O))return f.NotebookRange.from(O);if(O instanceof ArrayBuffer)return w=!0,i.$Ed.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return w=!0,i.$Ed.wrap(O);if(O instanceof i.$Ed)return w=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(y,w?new s.$aA(A):A,l);return(0,b.$0g)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(y,u,!1);throw O}}}async h(y,u,l){const w=this.b.get(y);if(!w)throw new Error("Unknown command");const{callback:A,thisArg:O,description:N}=w;if(N)for(let j=0;j<N.args.length;j++)try{(0,C.$zf)(u[j],N.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${y}' failed. Illegal argument '${N.args[j].name}' - ${N.args[j].description}`)}const T=$.$ad.create();try{return await A.apply(O,u)}catch(j){if(y===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...u);z&&(y=z.command)}if(this.d.error(j,y,w.extension?.identifier),!l)throw j;if(w.extension?.identifier){const z=this.#i.onExtensionError(w.extension.identifier,j);this.d.trace("forwarded error to extension?",z,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.$li)(j)),this.id=y,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,y,T.elapsed())}}j(y,u,l){y.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:y.extension.identifier.value,id:new g.$$n(u),duration:l})}$executeContributedCommand(y,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",y);const l=this.b.get(y);return l?(u=u.map(w=>this.f.reduce((A,O)=>O.processArgument(A,l.extension?.identifier),w)),this.h(y,u,!0)):Promise.reject(new Error(`Contributed command '${y}' does not exist.`))}getCommands(y=!1){return this.d.trace("ExtHostCommands#getCommands",y),this.#e.$getCommands().then(u=>(y&&(u=u.filter(l=>l[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const y=Object.create(null);for(const[u,l]of this.b){const{description:w}=l;w&&(y[u]=w)}return Promise.resolve(y)}};e.$eM=o,e.$eM=o=Ke([Be(0,v.$VL),Be(1,S.$4i),Be(2,t.$dM)],o),e.$fM=(0,D.$Ah)("IExtHostCommands");class a{constructor(y,u,l){this.d=y,this.f=u,this.g=l,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(y,u){if(!y)return;const l={$ident:void 0,id:y.command,title:y.title,tooltip:y.tooltip};if(!y.command)return l;const w=this.f(y.command);if(w)l.id=w.internalId,l.arguments=w.args.map((A,O)=>A.convert(y.arguments&&y.arguments[O]));else if((0,m.$Ib)(y.arguments)){const A=`${y.command}/${++this.c}`;this.b.set(A,y),u.add((0,k.$hc)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),l.$ident=A,l.id=this.delegatingCommandId,l.arguments=[A],this.g.trace("CommandsConverter#CREATE",y.command,A)}return l}fromInternal(y){return typeof y.$ident=="string"?this.b.get(y.$ident):{command:y.id,title:y.title,arguments:y.arguments}}getActualCommand(...y){return this.b.get(y[0])}h(...y){const u=this.getActualCommand(...y);return this.g.trace("CommandsConverter#EXECUTE",y[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${y[0]}`)}}e.$gM=a;class n{static{this.Uri=new n("uri","Uri of a text document",y=>p.URI.isUri(y),y=>y)}static{this.Position=new n("position","A position in a text document",y=>F.$WJ.isPosition(y),f.Position.from)}static{this.Range=new n("range","A range in a text document",y=>F.$XJ.isRange(y),f.Range.from)}static{this.Selection=new n("selection","A selection in a text document",y=>F.$YJ.isSelection(y),f.Selection.from)}static{this.Number=new n("number","",y=>typeof y=="number",y=>y)}static{this.String=new n("string","",y=>typeof y=="string",y=>y)}static{this.StringArray=n.Arr(n.String)}static Arr(y){return new n(`${y.name}_array`,`Array of ${y.name}, ${y.description}`,u=>Array.isArray(u)&&u.every(l=>y.validate(l)),u=>u.map(l=>y.convert(l)))}static{this.CallHierarchyItem=new n("item","A call hierarchy item",y=>y instanceof F.$gK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new n("item","A type hierarchy item",y=>y instanceof F.$AL,f.TypeHierarchyItem.from)}static{this.TestItem=new n("testItem","A VS Code TestItem",y=>y instanceof r.$9L,f.TestItem.from)}constructor(y,u,l,w){this.name=y,this.description=u,this.validate=l,this.convert=w}optional(){return new n(this.name,`(optional) ${this.description}`,y=>y==null||this.validate(y),y=>y===void 0?void 0:y===null?null:this.convert(y))}with(y,u){return new n(y??this.name,u??this.description,this.validate,this.convert)}}e.$hM=n;class c{static{this.Void=new c("no result",y=>y)}constructor(y,u){this.description=y,this.convert=u}}e.$iM=c;class h{constructor(y,u,l,w,A){this.id=y,this.internalId=u,this.description=l,this.args=w,this.result=A}}e.$jM=h}),define(De[301],Ce([1,0,19,17,2,82,129,41,134,33,13,7]),function($e,e,C,F,f,L,R,m,S,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;const p=[new b.$jM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of DocumentHighlight-instances.",D(P.DocumentHighlight.to))),new b.$jM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$hM.Uri],new b.$iM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,i)=>{if((0,C.$Hb)(r))return;class s extends I.$aK{static to($){const g=new s($.name,P.SymbolKind.to($.kind),$.containerName||"",new I.$8J(i[0],P.Range.to($.range)));return g.detail=$.detail,g.range=g.location.range,g.selectionRange=P.Range.to($.selectionRange),g.children=$.children?$.children.map(s.to):[],g}}return r.map(s.to)})),new b.$jM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$hM.Uri,new b.$hM("options","Formatting options",r=>!0,r=>r)],new b.$iM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new b.$jM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$hM.Uri,b.$hM.Range,new b.$hM("options","Formatting options",r=>!0,r=>r)],new b.$iM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new b.$jM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$hM.Uri,b.$hM.Position,new b.$hM("ch","Trigger character",r=>typeof r=="string",r=>r),new b.$hM("options","Formatting options",r=>!0,r=>r)],new b.$iM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new b.$jM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$jM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$jM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$jM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$jM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of Location-instances.",D(P.location.to))),new b.$jM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of Hover-instances.",D(P.Hover.to))),new b.$jM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$hM.Uri,new b.$hM("position","A position in a text document",r=>Array.isArray(r)&&r.every(i=>I.$WJ.isPosition(i)),r=>r.map(P.Position.from))],new b.$iM("A promise that resolves to an array of ranges.",r=>r.map(i=>{let s;for(const d of i.reverse())s=new I.$fK(P.Range.to(d),s);return s}))),new b.$jM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$hM.String.with("query","Search string")],new b.$iM("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(P.WorkspaceSymbol.to))),new b.$jM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(P.CallHierarchyItem.to))),new b.$jM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$hM.CallHierarchyItem],new b.$iM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(P.CallHierarchyIncomingCall.to))),new b.$jM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$hM.CallHierarchyItem],new b.$iM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(P.CallHierarchyOutgoingCall.to))),new b.$jM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:P.Range.to(r.range),placeholder:r.text}})),new b.$jM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$hM.Uri,b.$hM.Position,b.$hM.String.with("newName","The new symbol name")],new b.$iM("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return P.WorkspaceEdit.to(r)}})),new b.$jM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$hM.Uri,b.$hM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$iM("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(P.DocumentLink.to))),new b.$jM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$hM.Uri],new b.$iM("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$_K(r.tokenTypes,r.tokenModifiers)})),new b.$jM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$hM.Uri],new b.$iM("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const i=(0,R.$k0)(r);if(i.type==="full")return new I.$bL(i.data,void 0)})),new b.$jM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$hM.Uri,b.$hM.Range.optional()],new b.$iM("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$_K(r.tokenTypes,r.tokenModifiers)})),new b.$jM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$hM.Uri,b.$hM.Range],new b.$iM("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const i=(0,R.$k0)(r);if(i.type==="full")return new I.$bL(i.data,void 0)})),new b.$jM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$hM.Uri,b.$hM.Position,b.$hM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$hM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$iM("A promise that resolves to a CompletionList-instance.",(r,i,s)=>{if(!r)return new I.$rK([]);const d=r.suggestions.map($=>P.CompletionItem.to($,s));return new I.$rK(d,r.incomplete)})),new b.$jM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$hM.Uri,b.$hM.Position,b.$hM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$iM("A promise that resolves to SignatureHelp.",r=>{if(r)return P.SignatureHelp.to(r)})),new b.$jM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$hM.Uri,b.$hM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$iM("A promise that resolves to an array of CodeLens-instances.",(r,i,s)=>D(d=>new I.$jK(P.Range.to(d.range),d.command&&s.fromInternal(d.command)))(r))),new b.$jM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$hM.Uri,new b.$hM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$XJ.isRange(r),r=>I.$YJ.isSelection(r)?P.Selection.from(r):P.Range.from(r)),b.$hM.String.with("kind","Code action kind to return code actions for").optional(),b.$hM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$iM("A promise that resolves to an array of Command-instances.",(r,i,s)=>D(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(d.command)}else{const $=new I.$cK(d.title,d.kind?new I.$dK(d.kind):void 0);return d.edit&&($.edit=P.WorkspaceEdit.to(d.edit)),d.command&&($.command=s.fromInternal(d.command)),$.isPreferred=d.isPreferred,$}})(r))),new b.$jM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$hM.Uri],new b.$iM("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(i=>new I.$xK(P.Range.to(i.range),P.Color.to(i.color))):[])),new b.$jM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$hM("color","The color to show and insert",r=>r instanceof I.$wK,P.Color.from),new b.$hM("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:P.Range.from(r.range)}))],new b.$iM("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(P.ColorPresentation.to):[])),new b.$jM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$hM.Uri,b.$hM.Range],new b.$iM("A promise that resolves to an array of Inlay objects",(r,i,s)=>r.map(P.InlayHint.to.bind(void 0,s)))),new b.$jM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$hM.Uri],new b.$iM("A promise that resolves to an array of FoldingRange objects",(r,i)=>{if(r)return r.map(P.FoldingRange.to)})),new b.$jM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$iM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new b.$jM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$hM.Uri,b.$hM.Range,new b.$hM("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$XJ,r=>P.InlineValueContext.from(r))],new b.$iM("A promise that resolves to an array of InlineValue objects",r=>r.map(P.InlineValue.to))),new b.$jM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$hM("uriOrString","Uri-instance or string (only http/https)",r=>f.URI.isUri(r)||typeof r=="string"&&(0,S.$ET)(r,F.Schemas.http,F.Schemas.https),r=>r),new b.$hM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[P.ViewColumn.from(r),void 0]:[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)])).optional(),b.$hM.String.with("label","").optional()],b.$iM.Void),new b.$jM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$hM.Uri.with("resource","Resource to open"),b.$hM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new b.$hM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[P.ViewColumn.from(r),void 0]:[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)])).optional()],b.$iM.Void),new b.$jM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$hM.Uri.with("left","Left-hand side resource of the diff editor"),b.$hM.Uri.with("right","Right-hand side resource of the diff editor"),b.$hM.String.with("title","Human readable title for the diff editor").optional(),new b.$hM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)]).optional()],b.$iM.Void),new b.$jM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$hM.Uri,b.$hM.Position],new b.$iM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new b.$jM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$hM.TypeHierarchyItem],new b.$iM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new b.$jM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$hM.TypeHierarchyItem],new b.$iM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new b.$jM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$hM.TestItem],b.$iM.Void),new b.$jM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$hM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$iM.Void),new b.$jM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$hM.String.with("name","The context key name"),new b.$hM("value","The context key value",()=>!0,r=>r)],b.$iM.Void),new b.$jM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$hM.Uri,b.$hM.StringArray,new b.$hM("MappedEditsContext","Mapped Edits Context",r=>P.MappedEditsContext.is(r),r=>P.MappedEditsContext.from(r))],new b.$iM("A promise that resolves to a workspace edit or null",r=>r?P.WorkspaceEdit.to(r):null))];class k{static register(i){p.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",m.$Ii)}}e.$Sac=k;function D(r){return i=>{if(Array.isArray(i))return i.map(r)}}function v(r){if(!Array.isArray(r))return;const i=[];for(const s of r)L.$6s(s)?i.push(P.DefinitionLink.to(s)):i.push(P.location.to(s));return i}}),define(De[302],Ce([1,0,11,57,4,3,2,82,25,13,7,6,27]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0;function k(D,v,r){const i=D.getProxy(I.$TJ.MainThreadComments);class s{static{this.a=0}constructor(){this.b=new Map,this.c=new S.$Wl,v.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const E=this.b.get(h.handle);return E?E.value:h}else if(h&&h.$mid===7){const E=this.b.get(h.commentControlHandle);if(!E)return h;const y=E.getCommentThread(h.commentThreadHandle);return y?y.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const y=E.getCommentThread(h.thread.commentThreadHandle);return y?h.$mid===8?y.value:{thread:y.value,text:h.text}:h}else if(h&&h.$mid===10){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const y=E.getCommentThread(h.thread.commentThreadHandle);if(!y)return h;const u=h.commentUniqueId,l=y.getCommentByUniqueId(u);return l||h}else if(h&&h.$mid===11){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const y=E.getCommentThread(h.thread.commentThreadHandle);if(!y)return h;const u=h.text,l=h.commentUniqueId,w=y.getCommentByUniqueId(l);return w?(typeof w.body=="string"?w.body=u:w.body=new P.$kK(u),w):h}return h}})}createCommentController(h,E,y){const u=s.a++,l=new $(h,u,E,y);this.b.set(l.handle,l);const w=this.c.get(h.identifier)||[];return w.push(l),this.c.set(h.identifier,w),l.value}$createCommentThreadTemplate(h,E,y){const u=this.b.get(h);u&&u.$createCommentThreadTemplate(E,y)}async $updateCommentThreadTemplate(h,E,y){const u=this.b.get(h);u&&u.$updateCommentThreadTemplate(E,y)}$deleteCommentThread(h,E){this.b.get(h)?.$deleteCommentThread(E)}$provideCommentingRanges(h,E,y){const u=this.b.get(h);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const l=r.getDocument(R.URI.revive(E));return(0,C.$yg)(async()=>{const w=await u.commentingRangeProvider.provideCommentingRanges(l,y);let A;return Array.isArray(w)?A={ranges:w,fileComments:!1}:w?A={ranges:w.ranges||[],fileComments:w.fileComments||!1}:A=w??void 0,A}).then(w=>{let A;return w&&(A={ranges:w.ranges.map(O=>b.Range.from(O)),fileComments:w.fileComments}),A})}$toggleReaction(h,E,y,u,l){const w=this.b.get(h);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,C.$yg)(()=>{const A=w.getCommentThread(E);if(A){const O=A.getCommentByUniqueId(u.uniqueIdInThread);if(w!==void 0&&O&&w.reactionHandler)return w.reactionHandler(O,o(l))}return Promise.resolve(void 0)})}}class d{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,E,y,u,l,w,A,O){this.m=E,this.n=y,this.o=u,this.p=l,this.q=w,this.extensionDescription=A,this.r=O,this.handle=d.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$ed,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$kc,this.l.value=new L.$ic,this.n===void 0&&(this.n=`${h}.${this.handle}`),i.$createCommentThread(E,this.handle,this.n,this.o,b.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{i.$deleteCommentThread(E,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(T){N.range=T},get comments(){return N.comments},set comments(T){N.comments=T},get collapsibleState(){return N.collapsibleState},set collapsibleState(T){N.collapsibleState=T},get canReply(){return N.canReply},set canReply(T){N.canReply=T},get contextValue(){return N.contextValue},set contextValue(T){N.contextValue=T},get label(){return N.label},set label(T){N.label=T},get state(){return N.state},set state(T){N.state=T},dispose:()=>{N.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$ic);const h=y=>Object.prototype.hasOwnProperty.call(this.b,y),E={};h("range")&&(E.range=b.Range.from(this.p)),h("label")&&(E.label=this.label),h("contextValue")&&(E.contextValue=this.contextValue??null),h("comments")&&(E.comments=this.q.map(y=>g(this,y,this.k,this.extensionDescription))),h("collapsibleState")&&(E.collapseState=a(this.g)),h("canReply")&&(E.canReply=this.canReply),h("state")&&(E.state=n(this.h)),h("isTemplate")&&(E.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(h){for(const E of this.k){const y=E[0],u=E[1];if(h===u)return y}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Ke([(0,F.$6g)(100)],d.prototype,"eventuallyUpdateCommentThread",null);class ${get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,E,y,u){this.f=h,this.g=E,this.h=y,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,y,u);const l=this;this.value=Object.freeze({id:l.id,label:l.label,get options(){return l.options},set options(w){l.options=w},get commentingRangeProvider(){return l.commentingRangeProvider},set commentingRangeProvider(w){l.commentingRangeProvider=w},get reactionHandler(){return l.reactionHandler},set reactionHandler(w){l.reactionHandler=w},createCommentThread(w,A,O){return l.createCommentThread(w,A,O).value},dispose:()=>{l.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(h,E,y){E===void 0&&(0,p.$NF)(this.f,"fileComments");const u=new d(this.id,this.handle,void 0,h,E,y,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(h,E){const y=new d(this.id,this.handle,void 0,R.URI.revive(h),b.Range.to(E),[],this.f,!0);return y.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(y.handle,y),y}$updateCommentThreadTemplate(h,E){const y=this.a.get(h);y&&(y.range=b.Range.to(E))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function g(c,h,E,y){let u=E.get(h);return u||(u=++c.commentHandle,E.set(h,u)),h.state!==void 0&&(0,p.$NF)(y,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:u,body:typeof h.body=="string"?h.body:b.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(l=>t(l)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?b.$UL(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function o(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case P.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function n(c){if(c!==void 0)switch(c){case P.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new s}e.$Uac=k}),define(De[303],Ce([1,0,23,6,26,20]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;let R=class{constructor(P,I){this.a=P.getProxy(F.$TJ.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,I){const p=this,k=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){p.e(P,I,k,arguments)}})}e(P,I,p,k){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:S(k,this.b)}),this.c&&this.f(P,p,k)}};e.$Qcc=R,e.$Qcc=R=Ke([Be(0,L.$VL),Be(1,f.$_L)],R);const m=1e5;function S(b,P){const I=[];if(b.length)for(let p=0;p<b.length;p++){let k=b[p];if(typeof k>"u")k="undefined";else if(k instanceof Error){const D=k;D.stack?k=D.stack:k=D.toString()}I.push(k)}if(P){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,C.$Zm)(I);return p.length>m?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,14,19,15,16,27]),function($e,e,C,F,f,L,R,m,S,b,P,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=void 0;let k=class{static{p=this}static{this.c=0}static{this.d=250}constructor(v,r){this.h=r,this.f=new Map,this.g=v.getProxy(F.$TJ.MainThreadDecorations)}registerFileDecorationProvider(v,r){const i=p.c++;this.f.set(i,{provider:v,extensionDescription:r}),this.g.$registerDecorationProvider(i,r.identifier.value);const s=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(d=>{if(!d){this.g.$onDidChange(i,null);return}const $=(0,S.$Zb)(d);if($.length<=p.d){this.g.$onDidChange(i,$);return}this.h.warn("[Decorations] CAPPING events from decorations provider",r.identifier.value,$.length);const g=$.map(a=>({uri:a,rank:(0,b.$qe)(a.path,"/")})),t=(0,S.$xb)(g,(a,n)=>a.rank-n.rank||(0,b.$Ee)(a.uri.path,n.uri.path)),o=[];e:for(const a of t){let n;for(const c of a){const h=(0,P.$$d)(c.uri.path);if(n!==h&&(n=h,o.push(c.uri)>=p.d))break e}}this.g.$onDidChange(i,o)});return new f.$VJ(()=>{s?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(v,r,i){if(!this.f.has(v))return Object.create(null);const s=Object.create(null),{provider:d,extensionDescription:$}=this.f.get(v);return await Promise.all(r.map(async g=>{try{const{uri:t,id:o}=g,a=await Promise.resolve(d.provideFileDecoration(C.URI.revive(t),i));if(!a)return;try{f.$fL.validate(a),a.badge&&typeof a.badge!="string"&&(0,I.$NF)($,"codiconDecoration"),s[o]=[a.propagate,a.tooltip,a.badge,a.color]}catch(n){this.h.warn(`INVALID decoration from extension '${$.identifier.value}': ${n}`)}}catch(t){this.h.error(t)}})),s}};e.$Vbc=k,e.$Vbc=k=p=Ke([Be(0,R.$VL),Be(1,m.$4i)],k),e.$Wbc=(0,L.$Ah)("IExtHostDecorations")}),define(De[304],Ce([1,0,203,133,2,6,7,13,4,14,28,54]),function($e,e,C,F,f,L,R,m,S,b,P,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=e.$Mac=void 0;class k{#e;#t;#i;constructor(r,i,s,d,$,g,t,o){this.d=r,this.e=i,this.f=s,this.g=d,this.h=$,this.c=!1,this.f=Math.max(d,s),this.#i=new P.$yi(a=>g.getComparisonKey(a)),this.#e=t,this.#t=o}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(r,i){if(!r){this.clear();return}this.j();let s=[];if(f.URI.isUri(r)){if(!i){this.delete(r);return}this.#i.set(r,i.slice()),s=[r]}else if(Array.isArray(r)){s=[];let g;r=[...r].sort(k.k);for(const t of r){const[o,a]=t;if((!g||o.toString()!==g.toString())&&(g&&this.#i.get(g).length===0&&this.#i.delete(g),g=o,s.push(o),this.#i.set(o,[])),a)this.#i.get(o)?.push(...a);else{const n=this.#i.get(o);n&&(n.length=0)}}}if(this.#t.fire(s),!this.#e)return;const d=[];let $=0;for(const g of s){let t=[];const o=this.#i.get(g);if(o)if(o.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const c of o)if(c.severity===a[n]&&t.push({...m.Diagnostic.from(c),modelVersionId:this.h(g)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,C.localize)(0,null,o.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=o.map(a=>({...m.Diagnostic.from(a),modelVersionId:this.h(g)}));if(d.push([g,t]),$+=t.length,$>this.f)break}this.#e.$changeMany(this.e,d)}delete(r){this.j(),this.#t.fire([r]),this.#i.delete(r),this.#e?.$changeMany(this.e,[[r,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(r,i){this.j();for(const[s,d]of this)r.call(i,s,d,this)}*[Symbol.iterator](){this.j();for(const r of this.#i.keys())yield[r,this.get(r)]}get(r){this.j();const i=this.#i.get(r);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(r){return this.j(),Array.isArray(this.#i.get(r))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(r,i){return r[0].toString()<i[0].toString()?-1:r[0].toString()>i[0].toString()?1:0}}e.$Mac=k;let D=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(r){const i=new P.$yi;for(const s of r)i.set(s,s);return{uris:Object.freeze(Array.from(i.values()))}}constructor(r,i,s,d){this.j=i,this.k=s,this.l=d,this.g=new Map,this.h=new S.$id({merge:$=>$.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.h.event,p._mapper),this.f=r.getProxy(L.$TJ.MainThreadDiagnostics)}createDiagnosticCollection(r,i){const{g:s,f:d,h:$,j:g,k:t,l:o}=this,a=new class{$changeMany(h,E){d.$changeMany(h,E),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,h,E.length===0?"CLEARING":E)}$clear(h){d.$clear(h),g.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,h)}dispose(){d.dispose()}};let n;if(!i)i="_generated_diagnostic_collection_name_#"+p.c++,n=i;else if(!s.has(i))n=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do n=i+p.c++;while(s.has(n))}return new class extends k{constructor(){super(i,n,p.e,p.d,h=>o.getDocument(h)?.version,t.extUri,a,$),s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(r){if(r)return this.m(r);{const i=new Map,s=[];for(const d of this.g.values())d.forEach(($,g)=>{let t=i.get($.toString());typeof t>"u"&&(t=s.length,i.set($.toString(),t),s.push([$,[]])),s[t][1]=s[t][1].concat(...g)});return s}}m(r){let i=[];for(const s of this.g.values())s.has(r)&&(i=i.concat(s.get(r)));return i}$acceptMarkersChange(r){if(!this.n){const i="_generated_mirror",s=new k(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,d=>{},this.k.extUri,void 0,this.h);this.g.set(i,s),this.n=s}for(const[i,s]of r)this.n.set(f.URI.revive(i),s.map(m.Diagnostic.to))}};e.$Nac=D,e.$Nac=D=p=Ke([Be(1,b.$4i),Be(2,I.$Lac)],D)}),define(De[305],Ce([1,0,2,6,27]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=void 0;class L{constructor(m){this.a=m.getProxy(F.$TJ.MainThreadDialogs)}showOpenDialog(m,S){return S?.allowUIResources&&(0,f.$NF)(m,"showLocal"),this.a.$showOpenDialog(S).then(b=>b?b.map(P=>C.URI.revive(P)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(S=>S?C.URI.revive(S):void 0)}}e.$3ac=L}),define(De[306],Ce([1,0,8,2,7,6,17,21,15]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=void 0;class b{static{this.a=0}constructor(I,p,k){this.d=p,this.e=k,this.b=new Map,this.c=I.getProxy(L.$TJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const k=b.a++;this.b.set(k,p),this.c.$registerTextContentProvider(k,I);let D;return typeof p.onDidChange=="function"&&(D=p.onDidChange(v=>{if(v.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this.d.getDocument(v)&&this.$provideTextDocumentContent(k,v).then(r=>{if(!r&&typeof r!="string")return;const i=this.d.getDocument(v);if(!i)return;const s=(0,S.$ze)(r);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(v,r)},C.$Y)})),new f.$VJ(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(I,p){const k=this.b.get(I);return k?Promise.resolve(k.provideTextDocumentContent(F.URI.revive(p),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$4ac=b}),define(De[307],Ce([1,0,4,3,2,6,141,13,18,23,7,8]),function($e,e,C,F,f,L,R,m,S,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;class p{constructor(D,v){this.a=new C.$ed({onListenerError:I.$Z}),this.b=new C.$ed({onListenerError:I.$Z}),this.c=new C.$ed({onListenerError:I.$Z}),this.d=new C.$ed({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$ic,this.h=new Map,this.f=D.getProxy(L.$TJ.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(r=>{for(const i of r)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const i of r)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const v=this.g.getDocument(D);if(v)return v}getDocument(D){const v=this.getDocumentData(D);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return v.document}ensureDocumentData(D){const v=this.g.getDocument(D);if(v)return Promise.resolve(v);let r=this.h.get(D.toString());return r||(r=this.f.$tryOpenDocument(D).then(i=>{this.h.delete(D.toString());const s=f.URI.revive(i);return(0,S.$tf)(this.g.getDocument(s))},i=>(this.h.delete(D.toString()),Promise.reject(i))),this.h.set(D.toString(),r)),r}createDocumentData(D){return this.f.$tryCreateDocument(D).then(v=>f.URI.revive(v))}$acceptModelLanguageChanged(D,v){const r=f.URI.revive(D),i=this.g.getDocument(r);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(v),this.a.fire(i.document)}$acceptModelSaved(D){const v=f.URI.revive(D),r=this.g.getDocument(v);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(D,v){const r=f.URI.revive(D),i=this.g.getDocument(r);if(!i)throw new Error("unknown document");i._acceptIsDirty(v),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,v,r){const i=f.URI.revive(D),s=this.g.getDocument(i);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(v);let d;v.isUndoing?d=P.TextDocumentChangeReason.Undo:v.isRedoing&&(d=P.TextDocumentChangeReason.Redo),this.c.fire((0,b.$Vm)({document:s.document,contentChanges:v.changes.map($=>({range:m.Range.to($.range),rangeOffset:$.rangeOffset,rangeLength:$.rangeLength,text:$.text})),reason:d}))}setWordDefinitionFor(D,v){(0,R.$XL)(D,v)}}e.$Jac=p}),define(De[70],Ce([1,0,58,4,3,2,5,6,141,20,146,13,14,28,17,50,59]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=void 0;class i{constructor($){this.value=$,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let s=class{constructor($,g){this.h=$,this.i=g,this.a=null,this.b=new Map,this.c=new k.$yi,this.d=new F.$ed,this.e=new F.$ed,this.f=new F.$ed,this.g=new F.$ed,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta($){this.acceptDocumentsAndEditorsDelta($)}acceptDocumentsAndEditorsDelta($){const g=[],t=[],o=[];if($.removedDocuments)for(const a of $.removedDocuments){const n=L.URI.revive(a),c=this.c.get(n);c?.unref()&&(this.c.delete(n),g.push(c.value))}if($.addedDocuments)for(const a of $.addedDocuments){const n=L.URI.revive(a.uri);let c=this.c.get(n);if(c&&n.scheme!==D.Schemas.vscodeNotebookCell&&n.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);c||(c=new i(new S.$YL(this.h.getProxy(m.$TJ.MainThreadDocuments),n,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(n,c),t.push(c.value)),c.ref()}if($.removedEditors)for(const a of $.removedEditors){const n=this.b.get(a);this.b.delete(a),n&&o.push(n)}if($.addedEditors)for(const a of $.addedEditors){const n=L.URI.revive(a.documentUri);C.ok(this.c.has(n),`document '${n}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(n).value,h=new P.$5L(a.id,this.h.getProxy(m.$TJ.MainThreadTextEditors),this.i,new r.$T(()=>c.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(E=>I.Range.to(E)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,h)}$.newActiveEditor!==void 0&&(C.ok($.newActiveEditor===null||this.b.has($.newActiveEditor),`active editor '${$.newActiveEditor}' does not exist`),this.a=$.newActiveEditor),(0,f.$ec)(g),(0,f.$ec)(o),$.removedDocuments&&this.e.fire(g),$.addedDocuments&&this.d.fire(t),($.removedEditors||$.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),$.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument($){return this.c.get($)?.value}allDocuments(){return v.Iterable.map(this.c.values(),$=>$.value)}getEditor($){return this.b.get($)}activeEditor($){if(!this.a)return;const g=this.b.get(this.a);return $?g:g?.value}allEditors(){return[...this.b.values()]}};e.$6L=s,e.$6L=s=Ke([Be(0,b.$VL),Be(1,p.$4i)],s),e.$7L=(0,R.$Ah)("IExtHostDocumentsAndEditors")}),define(De[71],Ce([1,0,13,6,2,4,5,7,20,18,56]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=void 0,e.$1bc=(0,R.$Ah)("IExtHostEditorTabs");class I{constructor(r,i,s){this.e=s,this.d=i,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,i={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$BL(f.URI.revive(this.b.input.uri));case 2:return new m.$CL(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified));case 3:return new m.$DL(f.URI.revive(this.b.input.base),f.URI.revive(this.b.input.input1),f.URI.revive(this.b.input.input2),f.URI.revive(this.b.input.result));case 6:return new m.$EL(f.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$FL(this.b.input.viewType);case 4:return new m.$GL(f.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$HL(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$IL;case 9:return new m.$JL(f.URI.revive(this.b.input.uri),f.URI.revive(this.b.input.inputBoxUri));default:return}}}class p{constructor(r,i){this.c=[],this.d="",this.b=r,this.e=i;for(const s of r.tabs)s.isActive&&(this.d=s.id),this.c.push(new I(s,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,i={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return C.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(s=>s.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(s=>s.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const s=new I(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,s),r.tabDto.isActive&&(this.d=s.tabId),s}else if(r.kind===1){const s=this.c.splice(r.index,1)[0];if(!s)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return s.tabId===this.d&&(this.d=""),s}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const s=this.c.splice(r.oldIndex,1)[0];if(!s)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,s),s}const i=this.c.find(s=>s.tabId===r.tabDto.id);if(!i)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(r.tabDto),i}activeTabId(){return this.d}}let k=class{constructor(r){this.b=new L.$ed,this.c=new L.$ed,this.e=[],this.a=r.getProxy(F.$TJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,i={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(s=>s.apiObject))},get activeTabGroup(){const s=r.d;return(0,b.$tf)(r.e.find($=>$.groupId===s)?.apiObject)},close:async(s,d)=>{const $=Array.isArray(s)?s:[s];return $.length?D($[0])?this.j($,d):this.i($,d):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(r){const i=new Set(this.e.map(a=>a.groupId)),s=new Set(r.map(a=>a.groupId)),d=(0,P.$J)(i,s),$=this.e.filter(a=>d.removed.includes(a.groupId)).map(a=>a.apiObject),g=[],t=[];this.e=r.map(a=>{const n=new p(a,()=>this.d);return d.added.includes(n.groupId)?g.push(n.apiObject):t.push(n.apiObject),n});const o=(0,b.$tf)(r.find(a=>a.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:g,closed:$,changed:t}))}$acceptTabGroupUpdate(r){const i=this.e.find(s=>s.groupId===r.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const i=this.e.find(d=>d.groupId===r.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const s=i.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[s.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[s.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[s.apiObject]}));return}}g(r){for(const i of this.e)for(const s of i.tabs)if(s.apiObject===r)return s}h(r){return this.e.find(i=>i.apiObject===r)}async i(r,i){const s=[];for(const d of r){const $=this.g(d);if(!$)throw new Error("Tab close: Invalid tab not found!");s.push($.tabId)}return this.a.$closeTab(s,i)}async j(r,i){const s=[];for(const d of r){const $=this.h(d);if(!$)throw new Error("Group close: Invalid group not found!");s.push($.groupId)}return this.a.$closeGroup(s,i)}};e.$2bc=k,e.$2bc=k=Ke([Be(0,S.$VL)],k);function D(v){return v.tabs!==void 0}}),define(De[308],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$TJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,S){if(this.a.size===0)throw new Error("No embedding vector providers registered");const b=this.a.get(R);if(!b)throw new Error("Embedding vector provider not found");const P=await b.provideEmbeddingVector(m,S);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(R,m,S){const b=this.b;return this.b++,this.a.set(b,S),this.c.$registerAiEmbeddingVectorProvider(m,b),new F.$VJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider(b),this.a.delete(b)})}}e.$Ncc=f}),define(De[309],Ce([1,0,2,6,3,7,13,169,15,22,27,79]),function($e,e,C,F,f,L,R,m,S,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class p{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const r=this.a.indexOf(v);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),r=[];let i,s,d=14,$=14;for(const g of v){let t=i?(0,S.$Ne)(i,g):0;for(t===0?s=1:s=$;t<g.length;t++)t+1===g.length?(d=$,$=9):$+=1,r.push([s,g.toUpperCase().charCodeAt(t),$]),r.push([s,g.toLowerCase().charCodeAt(t),$]),s=$;i=g,$=d}r.push([9,58,10]),r.push([10,47,12]),this.b=new m.$nY(r)}}provideDocumentLinks(v){this.c();const r=[],i=m.$oY.computeLinks({getLineContent(s){return v.lineAt(s-1).text},getLineCount(){return v.lineCount}},this.b);for(const s of i){const d=R.DocumentLink.to(s);d.target&&r.push(d)}return r}}class k{constructor(v,r){this.i=r,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(F.$TJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,r,i,s={}){if(k.j(i),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const d=this.h++;this.b.add(r),this.d.add(r),this.c.set(d,i);let $=2;s.isCaseSensitive&&($+=1024),s.isReadonly&&($+=2048),typeof i.copy=="function"&&($+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$NF)(v,"fsChunks"),$+=4);let g;s.isReadonly&&(0,I.$Yj)(s.isReadonly)&&((0,P.$NF)(v,"readonlyMessage"),g={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(d,r,$,g).catch(o=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${r}`),console.error(o)});const t=i.onDidChangeFile(o=>{const a=[];for(const n of o){const{uri:c,type:h}=n;if(c.scheme!==r)continue;let E;switch(h){case L.FileChangeType.Changed:E=0;break;case L.FileChangeType.Created:E=1;break;case L.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:c,type:E})}this.a.$onFileSystemChange(d,a)});return(0,f.$hc)(()=>{t.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(d),this.a.$unregisterProvider(d)})}static j(v){if(!v)throw new Error("MISSING provider");if(typeof v.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof v.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof v.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof v.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof v.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof v.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof v.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof v.rename!="function")throw new Error("Provider does NOT implement rename")}static k(v){const{type:r,ctime:i,mtime:s,size:d,permissions:$}=v;return{type:r,ctime:i,mtime:s,size:d,permissions:$}}$stat(v,r){return Promise.resolve(this.l(v).stat(C.URI.revive(r))).then(i=>k.k(i))}$readdir(v,r){return Promise.resolve(this.l(v).readDirectory(C.URI.revive(r)))}$readFile(v,r){return Promise.resolve(this.l(v).readFile(C.URI.revive(r))).then(i=>b.$Ed.wrap(i))}$writeFile(v,r,i,s){return Promise.resolve(this.l(v).writeFile(C.URI.revive(r),i.buffer,s))}$delete(v,r,i){return Promise.resolve(this.l(v).delete(C.URI.revive(r),i))}$rename(v,r,i,s){return Promise.resolve(this.l(v).rename(C.URI.revive(r),C.URI.revive(i),s))}$copy(v,r,i,s){const d=this.l(v);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(C.URI.revive(r),C.URI.revive(i),s))}$mkdir(v,r){return Promise.resolve(this.l(v).createDirectory(C.URI.revive(r)))}$watch(v,r,i,s){const d=this.l(v).watch(C.URI.revive(i),s);this.f.set(r,d)}$unwatch(v,r){const i=this.f.get(r);i&&(i.dispose(),this.f.delete(r))}$open(v,r,i){const s=this.l(v);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(C.URI.revive(r),i))}$close(v,r){const i=this.l(v);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(r))}$read(v,r,i,s){const d=this.l(v);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const $=b.$Ed.alloc(s);return Promise.resolve(d.read(r,i,$.buffer,0,s)).then(g=>$.slice(0,g))}$write(v,r,i,s){const d=this.l(v);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(r,i,s.buffer,0,s.byteLength))}l(v){const r=this.c.get(v);if(!r){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return r}}e.$xbc=k}),define(De[72],Ce([1,0,6,30,7,22,5,20,54,3,11,24,17]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=e.$dbc=void 0;let D=k=class{constructor(r,i){this.b=new Map,this.c=new P.$Og,this.a=r.getProxy(C.$TJ.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(d){try{let $;const g=s.b.get(d.scheme);return g?(await s.a.$ensureActivation(d.scheme),$=await g.impl.stat(d)):$=await s.a.$stat(d),{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===F.FilePermission.Readonly?1:void 0}}catch($){k.e($)}},async readDirectory(d){try{const $=s.b.get(d.scheme);return $?(await s.a.$ensureActivation(d.scheme),(await $.impl.readDirectory(d)).slice()):await s.a.$readdir(d)}catch($){return k.e($)}},async createDirectory(d){try{const $=s.b.get(d.scheme);return $&&!$.isReadonly?(await s.a.$ensureActivation(d.scheme),await s.d($.impl,$.extUri,d)):await s.a.$mkdir(d)}catch($){return k.e($)}},async readFile(d){try{const $=s.b.get(d.scheme);return $?(await s.a.$ensureActivation(d.scheme),(await $.impl.readFile(d)).slice()):(await s.a.$readFile(d)).buffer}catch($){return k.e($)}},async writeFile(d,$){try{const g=s.b.get(d.scheme);return g&&!g.isReadonly?(await s.a.$ensureActivation(d.scheme),await s.d(g.impl,g.extUri,g.extUri.dirname(d)),await s.c.queueFor(d).queue(()=>Promise.resolve(g.impl.writeFile(d,$,{create:!0,overwrite:!0})))):await s.a.$writeFile(d,L.$Ed.wrap($))}catch(g){return k.e(g)}},async delete(d,$){try{const g=s.b.get(d.scheme);return g&&!g.isReadonly?(await s.a.$ensureActivation(d.scheme),await g.impl.delete(d,{recursive:!1,...$})):await s.a.$delete(d,{recursive:!1,useTrash:!1,atomic:!1,...$})}catch(g){return k.e(g)}},async rename(d,$,g){try{return await s.a.$rename(d,$,{overwrite:!1,...g})}catch(t){return k.e(t)}},async copy(d,$,g){try{return await s.a.$copy(d,$,{overwrite:!1,...g})}catch(t){return k.e(t)}},isWritableFileSystem(d){const $=i.getCapabilities(d);if(typeof $=="number")return!($&2048)}})}async d(r,i,s){const d=[];for(;!i.isEqual(s,i.dirname(s));)try{if(!((await r.stat(s)).type&F.FileType.Directory))throw f.$0K.FileExists(`Unable to create folder '${s.scheme===p.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch($){if(F.$hk($)!==F.FileSystemProviderErrorCode.FileNotFound)throw $;d.push(i.basename(s)),s=i.dirname(s)}for(let $=d.length-1;$>=0;$--){s=i.joinPath(s,d[$]);try{await r.createDirectory(s)}catch(g){if(F.$hk(g)!==F.FileSystemProviderErrorCode.FileExists)throw g}}}static e(r){if(r instanceof f.$0K)throw r;if(r instanceof F.$dk)switch(r.code){case F.FileSystemProviderErrorCode.FileExists:throw f.$0K.FileExists(r.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$0K.FileNotFound(r.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$0K.FileNotADirectory(r.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$0K.FileIsADirectory(r.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$0K.NoPermissions(r.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$0K.Unavailable(r.message);default:throw new f.$0K(r.message,r.name)}if(!(r instanceof Error))throw new f.$0K(String(r));if(r.name==="ENOPRO"||r.message.includes("ENOPRO"))throw f.$0K.Unavailable(r.message);switch(r.name){case F.FileSystemProviderErrorCode.FileExists:throw f.$0K.FileExists(r.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$0K.FileNotFound(r.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$0K.FileNotADirectory(r.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$0K.FileIsADirectory(r.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$0K.NoPermissions(r.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$0K.Unavailable(r.message);default:throw new f.$0K(r.message,r.name)}}addFileSystemProvider(r,i,s){return this.b.set(r,{impl:i,extUri:s?.isCaseSensitive?I.$0f:I.$_f,isReadonly:!!s?.isReadonly}),(0,b.$hc)(()=>this.b.delete(r))}getFileSystemProviderExtUri(r){return this.b.get(r)?.extUri??I.$0f}};e.$dbc=D,e.$dbc=D=k=Ke([Be(0,m.$VL),Be(1,S.$Lac)],D),e.$ebc=(0,R.$Ah)("IExtHostConsumerFileSystem")}),define(De[310],Ce([1,0,4,35,2,6,13,7]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;class S{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,p,k,D,v,r,i,s){this.a=new C.$ed,this.b=new C.$ed,this.c=new C.$ed;const d=this.h(I,k,v);this.g=0,r&&(this.g+=1),i&&(this.g+=2),s&&(this.g+=4);const $=(0,F.$qj)(v),g=typeof v=="string",t=D(o=>{if(!r)for(const a of o.created){const n=f.URI.revive(a);$(n.fsPath)&&(!g||p.getWorkspaceFolder(n))&&this.a.fire(n)}if(!i)for(const a of o.changed){const n=f.URI.revive(a);$(n.fsPath)&&(!g||p.getWorkspaceFolder(n))&&this.b.fire(n)}if(!s)for(const a of o.deleted){const n=f.URI.revive(a);$(n.fsPath)&&(!g||p.getWorkspaceFolder(n))&&this.c.fire(n)}});this.d=m.$VJ.from(d,this.a,this.b,this.c,t)}h(I,p,k){const D=m.$VJ.from();if(typeof k=="string")return D;const v=I.getProxy(L.$TJ.MainThreadFileSystem);let r=!1;(k.pattern.includes(F.$mj)||k.pattern.includes(F.$nj))&&(r=!0);const i=Math.random();return v.$watch(p.identifier.value,i,k.baseUri,{recursive:r,excludes:[]}),m.$VJ.from({dispose:()=>v.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class b{constructor(I,p,k){this.j=I,this.k=p,this.l=k,this.a=new C.$ed,this.b=new C.$ed,this.c=new C.$ed,this.d=new C.$ed,this.g=new C.$gd,this.h=new C.$gd,this.i=new C.$gd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,p,k,D,v,r){return new S(this.j,I,p,this.a.event,R.GlobPattern.from(k),D,v,r)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,p){switch(I){case 2:this.b.fire(Object.freeze({files:p.map(k=>({oldUri:f.URI.revive(k.source),newUri:f.URI.revive(k.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(k=>f.URI.revive(k.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(k=>f.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,p){return(k,D,v)=>{const r=function(s){k.call(D,s)};return r.extension=I,p.event(r,void 0,v)}}async $onWillRunFileOperation(I,p,k,D){switch(I){case 2:return await this.n(this.g,{files:p.map(v=>({oldUri:f.URI.revive(v.source),newUri:f.URI.revive(v.target)}))},k,D);case 1:return await this.n(this.i,{files:p.map(v=>f.URI.revive(v.target))},k,D);case 0:case 3:return await this.n(this.h,{files:p.map(v=>f.URI.revive(v.target))},k,D)}}async n(I,p,k,D){const v=new Set,r=[];if(await I.fireAsync(p,D,async(s,d)=>{const $=Date.now(),g=await Promise.resolve(s);g instanceof m.$6J&&(r.push([d.extension,g]),v.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-$>k&&this.k.warn("SLOW file-participant",d.extension.identifier)}),D.isCancellationRequested||r.length===0)return;const i={edits:[]};for(const[,s]of r){const{edits:d}=R.WorkspaceEdit.from(s,{getTextDocumentVersion:$=>this.l.getDocument($)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(d)}return{edit:i,extensionNames:Array.from(v)}}}e.$ybc=b}),define(De[311],Ce([1,0,3,2,6,13,7,33]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;class S{static{this.a=0}constructor(p,k){this.extension=p,this.provider=k,this.handle=S.a++}}class b{constructor(p){this.session=p,this.responses=[]}}class P{static{this.a=0}constructor(p,k,D,v){this.f=D,this.g=v,this.b=new Map,this.d=new Map,this.e=p.getProxy(f.$TJ.MainThreadInlineChat),k.registerApiCommand(new m.$jM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$hM("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?L.Range.from(r.initialRange):void 0,initialSelection:r.initialSelection?L.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?L.Position.from(r.position):void 0}})],m.$iM.Void))}registerProvider(p,k,D){const v=new S(p,k);return this.b.set(v.handle,v),this.e.$registerInteractiveEditorProvider(v.handle,D.label,p.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,C.$hc)(()=>{this.e.$unregisterInteractiveEditorProvider(v.handle),this.b.delete(v.handle)})}async $prepareSession(p,k,D,v){const r=this.b.get(p);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(k)),s=L.Selection.to(D),d=await r.provider.prepareInteractiveEditorSession({document:i,selection:s},v);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(s))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const $=P.a++;return this.d.set($,new b(d)),{id:$,placeholder:d.placeholder,slashCommands:d.slashCommands?.map(g=>({command:g.command,detail:g.detail,refer:g.refer,executeImmediately:g.executeImmediately})),wholeRange:L.Range.from(d.wholeRange),message:d.message}}async $provideResponse(p,k,D,v){const r=this.b.get(p);if(!r)return;const i=this.d.get(k.id);if(!i)return;const s={session:i.session,prompt:D.prompt,selection:L.Selection.to(D.selection),wholeRange:L.Range.to(D.wholeRange),attempt:D.attempt,live:D.live};let d=!1;const $={report:o=>{if(!D.live)throw new Error("Progress reporting is only supported for live sessions");d||v.isCancellationRequested||!o.message&&!o.edits||this.e.$handleProgressChunk(D.requestId,{message:o.message,edits:o.edits?.map(L.TextEdit.from)})}},g=typeof r.provider.provideInteractiveEditorResponse2=="function"?r.provider.provideInteractiveEditorResponse2(s,$,v):r.provider.provideInteractiveEditorResponse(s.session,s,$,v);Promise.resolve(g).finally(()=>d=!0);const t=await g;if(t){const o=i.responses.push(t)-1,a={wholeRange:L.Range.from(t.wholeRange),placeholder:t.placeholder};if(P.h(t))return{...a,id:o,type:"message",message:L.MarkdownString.from(t.contents)};const{edits:n}=t;if(n instanceof R.$6J)return{...a,id:o,type:"bulkEdit",edits:L.WorkspaceEdit.from(n)};if(Array.isArray(n))return{...a,id:o,type:"editorEdit",edits:n.map(L.TextEdit.from)}}}$handleFeedback(p,k,D,v){const r=this.b.get(p),i=this.d.get(k),s=i?.responses[D];if(r&&s){const d=L.InteractiveEditorResponseFeedbackKind.to(v);r.provider.handleInteractiveEditorResponseFeedback?.(i.session,s,d)}}$releaseSession(p,k){const D=this.d.get(k),v=this.b.get(p);D&&v&&v.provider.releaseInteractiveEditorSession?.(D.session),this.d.delete(k)}static h(p){return typeof p=="object"&&typeof p.contents=="object"}}e.$Fcc=P}),define(De[312],Ce([1,0,2,33]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class f{constructor(R,m,S,b,P){this.a=m,this.b=S,this.c=b;const I=new F.$jM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$hM("showOptions","Show Options",p=>!0,p=>p),new F.$hM("resource","Interactive resource Uri",p=>!0,p=>p),new F.$hM("controllerId","Notebook controller Id",p=>!0,p=>p),new F.$hM("title","Interactive editor title",p=>!0,p=>p)],new F.$iM("Notebook and input URI",p=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const k=this.a.getEditorById(p.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri),notebookEditor:k.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(R,m,S,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:S,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Bcc=f}),define(De[313],Ce([1,0,6,7]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class f{constructor(R){this.a=new Map,this.b=R.getProxy(C.$TJ.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const S=this.a.get(R);if(!S)throw new Error("Issue request handler not found");const b=await S.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}registerIssueUriRequestHandler(R,m){const S=R.identifier.value;return this.a.set(S,m),this.b.$registerIssueUriRequestHandler(S),new F.$VJ(()=>{this.b.$unregisterIssueUriRequestHandler(S),this.a.delete(S)})}}e.$Hcc=f}),define(De[314],Ce([1,0,3,6]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class f{constructor(R){this.b=0,this.a=R.getProxy(F.$TJ.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,C.$hc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Ubc=f}),define(De[315],Ce([1,0,2,23,13,7,82,6,15,34,19,18,165,21,25,3,129,119,87,37,8,11,27,205]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;class a{constructor(B,X){this.d=B,this.e=X}async provideDocumentSymbols(B,X){const ee=this.d.getDocument(B),ne=await this.e.provideDocumentSymbols(ee,X);if(!(0,P.$Hb)(ne))return ne[0]instanceof L.$bK?ne.map(f.DocumentSymbol.from):a.f(ne)}static f(B){B=B.slice(0).sort((ne,Z)=>{let de=ne.location.range.start.compareTo(Z.location.range.start);return de===0&&(de=Z.location.range.end.compareTo(ne.location.range.end)),de});const X=[],ee=[];for(const ne of B){const Z={name:ne.name||"!!MISSING: name!!",kind:f.SymbolKind.from(ne.kind),tags:ne.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:ne.containerName,range:f.Range.from(ne.location.range),selectionRange:f.Range.from(ne.location.range),children:[]};for(;;){if(ee.length===0){ee.push(Z),X.push(Z);break}const de=ee[ee.length-1];if(b.$is.containsRange(de.range,Z.range)&&!b.$is.equalsRange(de.range,Z.range)){de.children?.push(Z),ee.push(Z);break}ee.pop()}}return X}}class n{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,X,ee){this.g=B,this.h=X,this.j=ee,this.e=new s.$Iac("CodeLens"),this.f=new Map}async provideCodeLenses(B,X){const ee=this.g.getDocument(B),ne=await this.j.provideCodeLenses(ee,X);if(!ne||X.isCancellationRequested)return;const Z=this.e.add(ne),de=new v.$ic;this.f.set(Z,de);const ye={cacheId:Z,lenses:[]};for(let je=0;je<ne.length;je++)ye.lenses.push({cacheId:[Z,je],range:f.Range.from(ne[je].range),command:this.h.toInternal(ne[je].command,de)});return ye}async resolveCodeLens(B,X){const ee=B.cacheId&&this.e.get(...B.cacheId);if(!ee)return;let ne;if(typeof this.j.resolveCodeLens!="function"||ee.isResolved?ne=ee:ne=await this.j.resolveCodeLens(ee,X),ne||(ne=ee),X.isCancellationRequested)return;const Z=B.cacheId&&this.f.get(B.cacheId[0]);if(Z)return B.command=this.h.toInternal(ne.command??n.d,Z),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function c(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class h{constructor(B,X){this.d=B,this.e=X}async provideDefinition(B,X,ee){const ne=this.d.getDocument(B),Z=f.Position.to(X),de=await this.e.provideDefinition(ne,Z,ee);return c(de)}}class E{constructor(B,X){this.d=B,this.e=X}async provideDeclaration(B,X,ee){const ne=this.d.getDocument(B),Z=f.Position.to(X),de=await this.e.provideDeclaration(ne,Z,ee);return c(de)}}class y{constructor(B,X){this.d=B,this.e=X}async provideImplementation(B,X,ee){const ne=this.d.getDocument(B),Z=f.Position.to(X),de=await this.e.provideImplementation(ne,Z,ee);return c(de)}}class u{constructor(B,X){this.d=B,this.e=X}async provideTypeDefinition(B,X,ee){const ne=this.d.getDocument(B),Z=f.Position.to(X),de=await this.e.provideTypeDefinition(ne,Z,ee);return c(de)}}class l{constructor(B,X){this.d=B,this.e=X}async provideHover(B,X,ee){const ne=this.d.getDocument(B),Z=f.Position.to(X),de=await this.e.provideHover(ne,Z,ee);if(!(!de||(0,P.$Hb)(de.contents)))return de.range||(de.range=ne.getWordRangeAtPosition(Z)),de.range||(de.range=new L.$XJ(Z,Z)),f.Hover.from(de)}}class w{constructor(B,X){this.d=B,this.e=X}async provideEvaluatableExpression(B,X,ee){const ne=this.d.getDocument(B),Z=f.Position.to(X),de=await this.e.provideEvaluatableExpression(ne,Z,ee);if(de)return f.EvaluatableExpression.from(de)}}class A{constructor(B,X){this.d=B,this.e=X}async provideInlineValues(B,X,ee,ne){const Z=this.d.getDocument(B),de=await this.e.provideInlineValues(Z,f.Range.to(X),f.InlineValueContext.to(ee),ne);if(Array.isArray(de))return de.map(ye=>f.InlineValue.from(ye))}}class O{constructor(B,X){this.d=B,this.e=X}async provideDocumentHighlights(B,X,ee){const ne=this.d.getDocument(B),Z=f.Position.to(X),de=await this.e.provideDocumentHighlights(ne,Z,ee);if(Array.isArray(de))return de.map(f.DocumentHighlight.from)}}class N{constructor(B,X){this.d=B,this.e=X}async provideLinkedEditingRanges(B,X,ee){const ne=this.d.getDocument(B),Z=f.Position.to(X),de=await this.e.provideLinkedEditingRanges(ne,Z,ee);if(de&&Array.isArray(de.ranges))return{ranges:(0,P.$Eb)(de.ranges.map(f.Range.from)),wordPattern:de.wordPattern}}}class T{constructor(B,X){this.d=B,this.e=X}async provideReferences(B,X,ee,ne){const Z=this.d.getDocument(B),de=f.Position.to(X),ye=await this.e.provideReferences(Z,de,ee,ne);if(Array.isArray(ye))return ye.map(f.location.from)}}class j{static{this.d=1e3}constructor(B,X,ee,ne,Z,de,ye){this.h=B,this.j=X,this.k=ee,this.l=ne,this.m=Z,this.n=de,this.o=ye,this.e=new s.$Iac("CodeAction"),this.f=new Map,this.g=new L.$dK("notebook")}async provideCodeActions(B,X,ee,ne){const Z=this.h.getDocument(B),de=p.$ks.isISelection(X)?f.Selection.to(X):f.Range.to(X),ye=[];for(const et of this.k.getDiagnostics(B))if(de.intersection(et.range)&&ye.push(et)>j.d)break;const je={diagnostics:ye,only:ee.only?new L.$dK(ee.only):void 0,triggerKind:f.CodeActionTriggerKind.to(ee.trigger)},We=await this.l.provideCodeActions(Z,de,je,ne);if(!(0,P.$Ib)(We)||ne.isCancellationRequested)return;const xe=this.e.add(We),Qe=new v.$ic;this.f.set(xe,Qe);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];if(Ae)if(j.p(Ae))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.j.toInternal(Ae,Qe)});else{if(je.triggerKind!==L.CodeActionTriggerKind.Invoke&&Ae.kind&&this.g.contains(Ae.kind))continue;je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[xe,et],title:Ae.title,command:Ae.command&&this.j.toInternal(Ae.command,Qe),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,disabled:Ae.disabled?.reason})}}return{cacheId:xe,actions:it}}async resolveCodeAction(B,X){const[ee,ne]=B,Z=this.e.get(ee,ne);if(!Z||j.p(Z))return{};if(!this.l.resolveCodeAction)return{};const de=await this.l.resolveCodeAction(Z,X)??Z;let ye;de.edit&&(ye=f.WorkspaceEdit.from(de.edit,void 0));let je;if(de.command){const We=this.f.get(ee);We&&(je=this.j.toInternal(de.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static p(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{static toInternalProviderId(B,X){return B+"."+X}constructor(B,X,ee,ne,Z){this.d=B,this.e=X,this.f=ee,this.g=ne,this.h=Z}async prepareDocumentPaste(B,X,ee,ne){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(B),de=X.map(We=>f.Range.to(We)),ye=f.DataTransfer.toDataTransfer(ee,()=>{throw new $.$9});if(await this.f.prepareDocumentPaste(Z,de,ye,ne),ne.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof L.$KK));return f.DataTransfer.from(je)}async providePasteEdits(B,X,ee,ne,Z){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(X),ye=ee.map(xe=>f.Range.to(xe)),je=f.DataTransfer.toDataTransfer(ne,async xe=>(await this.d.$resolvePasteFileData(this.g,B,xe)).buffer),We=await this.f.provideDocumentPasteEdits(de,ye,je,Z);if(We)return{label:We.label??(0,o.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:z.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class M{constructor(B,X){this.d=B,this.e=X}async provideDocumentFormattingEdits(B,X,ee){const ne=this.d.getDocument(B),Z=await this.e.provideDocumentFormattingEdits(ne,X,ee);if(Array.isArray(Z))return Z.map(f.TextEdit.from)}}class H{constructor(B,X){this.d=B,this.e=X}async provideDocumentRangeFormattingEdits(B,X,ee,ne){const Z=this.d.getDocument(B),de=f.Range.to(X),ye=await this.e.provideDocumentRangeFormattingEdits(Z,de,ee,ne);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,X,ee,ne){(0,I.$sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(B),de=X.map(f.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Z,de,ee,ne);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}}class q{constructor(B,X){this.d=B,this.e=X,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,X,ee,ne,Z){const de=this.d.getDocument(B),ye=f.Position.to(X),je=await this.e.provideOnTypeFormattingEdits(de,ye,ee,ne,Z);if(Array.isArray(je))return je.map(f.TextEdit.from)}}class me{constructor(B,X){this.e=B,this.f=X,this.d=new s.$Iac("WorkspaceSymbols")}async provideWorkspaceSymbols(B,X){const ee=await this.e.provideWorkspaceSymbols(B,X);if(!(0,P.$Ib)(ee))return{symbols:[]};const ne=this.d.add(ee),Z={cacheId:ne,symbols:[]};for(let de=0;de<ee.length;de++){const ye=ee[de];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Z.symbols.push({...f.WorkspaceSymbol.from(ye),cacheId:[ne,de]})}return Z}async resolveWorkspaceSymbol(B,X){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ee=this.d.get(...B.cacheId);if(ee){const ne=await this.e.resolveWorkspaceSymbol(ee,X);return ne&&(0,F.$Xm)(B,f.WorkspaceSymbol.from(ne),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class x{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,X,ee){this.d=B,this.e=X,this.f=ee}async provideRenameEdits(B,X,ee,ne){const Z=this.d.getDocument(B),de=f.Position.to(X);try{const ye=await this.e.provideRenameEdits(Z,de,ee,ne);return ye?f.WorkspaceEdit.from(ye):void 0}catch(ye){const je=x.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,X,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const ne=this.d.getDocument(B),Z=f.Position.to(X);try{const de=await this.e.prepareRename(ne,Z,ee);let ye,je;if(L.$XJ.isRange(de)?(ye=de,je=ne.getText(de)):(0,I.$kf)(de)&&(ye=de.range,je=de.placeholder),!ye||!je)return;if(ye.start.line>Z.line||ye.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(ye),text:je}}catch(de){const ye=x.g(de);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Q{constructor(B,X){this.resultId=B,this.tokens=X}}class V{constructor(B,X){this.f=B,this.g=X,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,X,ee){const ne=this.f.getDocument(B),Z=X!==0?this.d.get(X):null;let de=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(ne,Z.resultId,ee):await this.g.provideDocumentSemanticTokens(ne,ee);return Z&&this.d.delete(X),de?(de=V.h(de),this.o(V.n(Z,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return V.j(B)?V.k(B)?B:new L.$bL(new Uint32Array(B.data),B.resultId):V.l(B)?V.m(B)?B:new L.$dL(B.edits.map(X=>new L.$cL(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const X of B.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static n(B,X){if(!V.j(X)||!B||!B.tokens)return X;const ee=B.tokens,ne=ee.length,Z=X.data,de=Z.length;let ye=0;const je=Math.min(ne,de);for(;ye<je&&ee[ye]===Z[ye];)ye++;if(ye===ne&&ye===de)return new L.$dL([],X.resultId);let We=0;const xe=je-ye;for(;We<xe&&ee[ne-We-1]===Z[de-We-1];)We++;return new L.$dL([{start:ye,deleteCount:ne-ye-We,data:Z.subarray(ye,de-We)}],X.resultId)}o(B,X){if(V.j(B)){const ee=this.e++;return this.d.set(ee,new Q(B.resultId,B.data)),(0,r.$j0)({id:ee,type:"full",data:B.data})}if(V.l(B)){const ee=this.e++;return V.j(X)?this.d.set(ee,new Q(X.resultId,X.data)):this.d.set(ee,new Q(B.resultId)),(0,r.$j0)({id:ee,type:"delta",deltas:(B.edits||[]).map(ne=>({start:ne.start,deleteCount:ne.deleteCount,data:ne.data}))})}return null}}class _{constructor(B,X){this.d=B,this.e=X}async provideDocumentRangeSemanticTokens(B,X,ee){const ne=this.d.getDocument(B),Z=await this.e.provideDocumentRangeSemanticTokens(ne,f.Range.to(X),ee);return Z?this.f(Z):null}f(B){return(0,r.$j0)({id:0,type:"full",data:B.data})}}class ge{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,X,ee,ne,Z){this.f=B,this.g=X,this.h=ee,this.j=ne,this.k=Z,this.d=new s.$Iac("CompletionItem"),this.e=new Map}async provideCompletionItems(B,X,ee,ne){const Z=this.f.getDocument(B),de=f.Position.to(X),ye=Z.getWordRangeAtPosition(de)||new L.$XJ(de,de),je=ye.with({end:de}),We=new d.$ad,xe=await this.h.provideCompletionItems(Z,de,ne,f.CompletionContext.to(ee));if(!xe||ne.isCancellationRequested)return;const Qe=Array.isArray(xe)?new L.$rK(xe):xe,it=ge.supportsResolving(this.h)?this.d.add(Qe.items):this.d.add([]),et=new v.$ic;this.e.set(it,et);const Ae=[],Oe={x:it,b:Ae,a:{replace:f.Range.from(ye),insert:f.Range.from(je)},c:Qe.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Qe.items.length;Ve++){const Le=Qe.items[Ve],Xe=this.l(Le,[it,Ve],je,ye);Ae.push(Xe)}return Oe}async resolveCompletionItem(B,X){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...B);if(!ee)return;const ne=this.l(ee,B),Z=await this.h.resolveCompletionItem(ee,X);if(!Z)return;const de=this.l(Z,B);return(ne.h!==de.h||ne.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(ne.n!==de.n||ne.o!==de.o||!(0,F.$Ym)(ne.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...ne,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,X,ee,ne){const Z=this.e.get(X[0]);if(!Z)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,Z),ye={x:X,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof L.$7J&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),L.$XJ.isRange(je)?ye.j=f.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!ne?.isEqual(je.replacing))&&(ye.j={insert:f.Range.from(je.inserting),replace:f.Range.from(je.replacing)}),ye}}class ce{async provideInlineCompletions(B,X,ee,ne){}disposeCompletions(B){}handleDidShowCompletionItem(B,X,ee){}handlePartialAccept(B,X,ee){}}class we extends ce{constructor(B,X,ee,ne){super(),this.f=B,this.g=X,this.h=ee,this.j=ne,this.d=new G,this.e=(0,t.$MF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$MF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,X,ee,ne){const Z=this.g.getDocument(B),de=f.Position.to(X),ye=await this.h.provideInlineCompletionItems(Z,de,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:f.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},ne);if(!ye||ne.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],xe=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Qe;return{pid:this.d.createReferenceId({dispose(){Qe?.dispose()},items:je}),items:je.map((et,Ae)=>{let Oe;et.command&&(Qe||(Qe=new v.$ic),Oe=this.j.toInternal(et.command,Qe));const Ve=et.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:et.filterText,range:et.range?f.Range.from(et.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Qe||(Qe=new v.$ic),this.j.toInternal(et,Qe))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,X,ee){const ne=this.d.get(B)?.items[X];ne&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(ne,ee)}handlePartialAccept(B,X,ee){const ne=this.d.get(B)?.items[X];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(ne,ee)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const X=this.e++;return this.d.set(X,B),X}disposeReferenceId(B){const X=this.d.get(B);return this.d.delete(B),X}get(B){return this.d.get(B)}}class U{constructor(B,X){this.e=B,this.f=X,this.d=new s.$Iac("SignatureHelp")}async provideSignatureHelp(B,X,ee,ne){const Z=this.e.getDocument(B),de=f.Position.to(X),ye=this.g(ee),je=await this.f.provideSignatureHelp(Z,de,ne,ye);if(je){const We=this.d.add([je]);return{...f.SignatureHelp.from(je),id:We}}}g(B){let X;if(B.activeSignatureHelp){const ee=f.SignatureHelp.to(B.activeSignatureHelp),ne=this.d.get(B.activeSignatureHelp.id,0);ne?(X=ne,X.activeSignature=ee.activeSignature,X.activeParameter=ee.activeParameter):X=ee}return{...B,activeSignatureHelp:X}}releaseSignatureHelp(B){this.d.delete(B)}}class K{constructor(B,X,ee,ne,Z){this.f=B,this.g=X,this.h=ee,this.j=ne,this.k=Z,this.d=new s.$Iac("InlayHints"),this.e=new Map}async provideInlayHints(B,X,ee){const ne=this.f.getDocument(B),Z=f.Range.to(X),de=await this.h.provideInlayHints(ne,Z,ee);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${X}`);return}if(ee.isCancellationRequested)return;const ye=this.d.add(de);this.e.set(ye,new v.$ic);const je={hints:[],cacheId:ye};for(let We=0;We<de.length;We++)this.l(de[We],Z)&&je.hints.push(this.m(de[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${X}`),je}async resolveInlayHint(B,X){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...B);if(!ee)return;const ne=await this.h.resolveInlayHint(ee,X);if(ne&&this.l(ne))return this.m(ne,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,X){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(X&&!X.contains(B.position))}m(B,X){const ee=this.e.get(X[0]);if(!ee)throw Error("DisposableStore is missing...");const ne={label:"",cacheId:X,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?ne.label=B.label:ne.label=B.label.map(Z=>{const de={label:Z.value};return de.tooltip=f.MarkdownString.fromStrict(Z.tooltip),L.$8J.isLocation(Z.location)&&(de.location=f.location.from(Z.location)),Z.command&&(de.command=this.g.toInternal(Z.command,ee)),de}),ne}}class Y{constructor(B,X){this.e=B,this.f=X,this.d=new s.$Iac("DocumentLink")}async provideLinks(B,X){const ee=this.e.getDocument(B),ne=await this.f.provideDocumentLinks(ee,X);if(!(!Array.isArray(ne)||ne.length===0)&&!X.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:ne.filter(Y.g).map(f.DocumentLink.from)};{const Z=this.d.add(ne),de={links:[],cacheId:Z};for(let ye=0;ye<ne.length;ye++){if(!Y.g(ne[ye]))continue;const je=f.DocumentLink.from(ne[ye]);je.cacheId=[Z,ye],de.links.push(je)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,X){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...B);if(!ee)return;const ne=await this.f.resolveDocumentLink(ee,X);if(!(!ne||!Y.g(ne)))return f.DocumentLink.from(ne)}releaseLinks(B){this.d.delete(B)}}class se{constructor(B,X){this.d=B,this.e=X}async provideColors(B,X){const ee=this.d.getDocument(B),ne=await this.e.provideDocumentColors(ee,X);return Array.isArray(ne)?ne.map(de=>({color:f.Color.from(de.color),range:f.Range.from(de.range)})):[]}async provideColorPresentations(B,X,ee){const ne=this.d.getDocument(B),Z=f.Range.to(X.range),de=f.Color.to(X.color),ye=await this.e.provideColorPresentations(de,{document:ne,range:Z},ee);if(Array.isArray(ye))return ye.map(f.ColorPresentation.from)}}class re{constructor(B,X){this.d=B,this.e=X}async provideFoldingRanges(B,X,ee){const ne=this.d.getDocument(B),Z=await this.e.provideFoldingRanges(ne,X,ee);if(Array.isArray(Z))return Z.map(f.FoldingRange.from)}}class le{constructor(B,X,ee){this.d=B,this.e=X,this.f=ee}async provideSelectionRanges(B,X,ee){const ne=this.d.getDocument(B),Z=X.map(f.Position.to),de=await this.e.provideSelectionRanges(ne,Z,ee);if(!(0,P.$Ib)(de))return[];if(de.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<Z.length;je++){const We=[];ye.push(We);let xe=Z[je],Qe=de[je];for(;;){if(!Qe.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Qe)),!Qe.parent)break;xe=Qe.range,Qe=Qe.parent}}return ye}}class Ee{constructor(B,X){this.f=B,this.g=X,this.d=new i.$1L(""),this.e=new Map}async prepareSession(B,X,ee){const ne=this.f.getDocument(B),Z=f.Position.to(X),de=await this.g.prepareCallHierarchy(ne,Z,ee);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideCallsTo(B,X,ee){const ne=this.j(B,X);if(!ne)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(ne,ee);if(Z)return Z.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(ye=>f.Range.from(ye))}))}async provideCallsFrom(B,X,ee){const ne=this.j(B,X);if(!ne)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(ne,ee);if(Z)return Z.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(ye=>f.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,X){const ee=this.e.get(B),ne=f.CallHierarchyItem.from(X,B,ee.size.toString(36));return ee.set(ne._itemId,X),ne}j(B,X){return this.e.get(B)?.get(X)}}class he{constructor(B,X){this.f=B,this.g=X,this.d=new i.$1L(""),this.e=new Map}async prepareSession(B,X,ee){const ne=this.f.getDocument(B),Z=f.Position.to(X),de=await this.g.prepareTypeHierarchy(ne,Z,ee);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideSupertypes(B,X,ee){const ne=this.j(B,X);if(!ne)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(ne,ee);if(Z)return Z.map(de=>this.h(B,de))}async provideSubtypes(B,X,ee){const ne=this.j(B,X);if(!ne)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(ne,ee);if(Z)return Z.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,X){const ee=this.e.get(B),ne=f.TypeHierarchyItem.from(X,B,ee.size.toString(36));return ee.set(ne._itemId,X),ne}j(B,X){return this.e.get(B)?.get(X)}}class fe{static toInternalProviderId(B,X){return B+"."+X}constructor(B,X,ee,ne,Z){this.d=B,this.e=X,this.f=ee,this.g=ne,this.h=Z}async provideDocumentOnDropEdits(B,X,ee,ne,Z){const de=this.e.getDocument(X),ye=f.Position.to(ee),je=f.DataTransfer.toDataTransfer(ne,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,xe)).buffer),We=await this.f.provideDocumentDropEdits(de,ye,je,Z);if(We)return{label:We.label??(0,o.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:fe.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,X){this.d=B,this.e=X}async provideMappedEdits(B,X,ee,ne){const Z=C.URI.revive(B),de=this.d.getDocument(Z),ye={selections:ee.selections.map(We=>f.Selection.to(We)),related:ee.related.map(We=>({uri:C.URI.revive(We.uri),range:f.Range.to(We.range)}))},je=await this.e.provideMappedEdits(de,X,ye,ne);return je?f.WorkspaceEdit.from(je):null}}class ue{constructor(B,X){this.adapter=B,this.extension=X}}class be{static{this.d=0}constructor(B,X,ee,ne,Z,de,ye,je){this.g=X,this.h=ee,this.j=ne,this.k=Z,this.l=de,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(m.$TJ.MainThreadLanguageFeatures)}o(B,X){return f.DocumentSelector.from(B,this.g,X)}p(B){return new L.$VJ(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async t(B,X,ee,ne,Z,de=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof X))return ne;const je=Date.now();de||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const We=ee(ye.adapter,ye.extension);return Promise.resolve(We).catch(xe=>{(0,$.$2)(xe)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(ye.extension.identifier,xe))}).finally(()=>{de||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),k.CancellationToken.isCancellationToken(Z)?(0,g.$vg)(We,Z):We}u(B,X){const ee=this.q();return this.f.set(ee,new ue(B,X)),ee}static w(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,X,ee,ne){const Z=this.u(new a(this.h,ee),B),de=ne&&ne.label||be.w(B);return this.e.$registerDocumentSymbolProvider(Z,this.o(X,B),de),this.p(Z)}$provideDocumentSymbols(B,X,ee){return this.t(B,a,ne=>ne.provideDocumentSymbols(C.URI.revive(X),ee),void 0,ee)}registerCodeLensProvider(B,X,ee){const ne=this.q(),Z=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(ne,new ue(new n(this.h,this.j.converter,ee),B)),this.e.$registerCodeLensSupport(ne,this.o(X,B),Z);let de=this.p(ne);if(Z!==void 0){const ye=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Z));de=L.$VJ.from(de,ye)}return de}$provideCodeLenses(B,X,ee){return this.t(B,n,ne=>ne.provideCodeLenses(C.URI.revive(X),ee),void 0,ee)}$resolveCodeLens(B,X,ee){return this.t(B,n,ne=>ne.resolveCodeLens(X,ee),void 0,void 0)}$releaseCodeLenses(B,X){this.t(B,n,ee=>Promise.resolve(ee.releaseCodeLenses(X)),void 0,void 0)}registerDefinitionProvider(B,X,ee){const ne=this.u(new h(this.h,ee),B);return this.e.$registerDefinitionSupport(ne,this.o(X,B)),this.p(ne)}$provideDefinition(B,X,ee,ne){return this.t(B,h,Z=>Z.provideDefinition(C.URI.revive(X),ee,ne),[],ne)}registerDeclarationProvider(B,X,ee){const ne=this.u(new E(this.h,ee),B);return this.e.$registerDeclarationSupport(ne,this.o(X,B)),this.p(ne)}$provideDeclaration(B,X,ee,ne){return this.t(B,E,Z=>Z.provideDeclaration(C.URI.revive(X),ee,ne),[],ne)}registerImplementationProvider(B,X,ee){const ne=this.u(new y(this.h,ee),B);return this.e.$registerImplementationSupport(ne,this.o(X,B)),this.p(ne)}$provideImplementation(B,X,ee,ne){return this.t(B,y,Z=>Z.provideImplementation(C.URI.revive(X),ee,ne),[],ne)}registerTypeDefinitionProvider(B,X,ee){const ne=this.u(new u(this.h,ee),B);return this.e.$registerTypeDefinitionSupport(ne,this.o(X,B)),this.p(ne)}$provideTypeDefinition(B,X,ee,ne){return this.t(B,u,Z=>Z.provideTypeDefinition(C.URI.revive(X),ee,ne),[],ne)}registerHoverProvider(B,X,ee,ne){const Z=this.u(new l(this.h,ee),B);return this.e.$registerHoverProvider(Z,this.o(X,B)),this.p(Z)}$provideHover(B,X,ee,ne){return this.t(B,l,Z=>Z.provideHover(C.URI.revive(X),ee,ne),void 0,ne)}registerEvaluatableExpressionProvider(B,X,ee,ne){const Z=this.u(new w(this.h,ee),B);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(X,B)),this.p(Z)}$provideEvaluatableExpression(B,X,ee,ne){return this.t(B,w,Z=>Z.provideEvaluatableExpression(C.URI.revive(X),ee,ne),void 0,ne)}registerInlineValuesProvider(B,X,ee,ne){const Z=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,de=this.u(new A(this.h,ee),B);this.e.$registerInlineValuesProvider(de,this.o(X,B),Z);let ye=this.p(de);if(Z!==void 0){const je=ee.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));ye=L.$VJ.from(ye,je)}return ye}$provideInlineValues(B,X,ee,ne,Z){return this.t(B,A,de=>de.provideInlineValues(C.URI.revive(X),ee,ne,Z),void 0,Z)}registerDocumentHighlightProvider(B,X,ee){const ne=this.u(new O(this.h,ee),B);return this.e.$registerDocumentHighlightProvider(ne,this.o(X,B)),this.p(ne)}$provideDocumentHighlights(B,X,ee,ne){return this.t(B,O,Z=>Z.provideDocumentHighlights(C.URI.revive(X),ee,ne),void 0,ne)}registerLinkedEditingRangeProvider(B,X,ee){const ne=this.u(new N(this.h,ee),B);return this.e.$registerLinkedEditingRangeProvider(ne,this.o(X,B)),this.p(ne)}$provideLinkedEditingRanges(B,X,ee,ne){return this.t(B,N,async Z=>{const de=await Z.provideLinkedEditingRanges(C.URI.revive(X),ee,ne);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?be.y(de.wordPattern):void 0}},void 0,ne)}registerReferenceProvider(B,X,ee){const ne=this.u(new T(this.h,ee),B);return this.e.$registerReferenceSupport(ne,this.o(X,B)),this.p(ne)}$provideReferences(B,X,ee,ne,Z){return this.t(B,T,de=>de.provideReferences(C.URI.revive(X),ee,ne,Z),void 0,Z)}registerCodeActionProvider(B,X,ee,ne){const Z=new v.$ic,de=this.u(new j(this.h,this.j.converter,this.k,ee,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(X,B),{providedKinds:ne?.providedCodeActionKinds?.map(ye=>ye.value),documentation:ne?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Z)}))},be.w(B),!!ee.resolveCodeAction),Z.add(this.p(de)),Z}$provideCodeActions(B,X,ee,ne,Z){return this.t(B,j,de=>de.provideCodeActions(C.URI.revive(X),ee,ne,Z),void 0,Z)}$resolveCodeAction(B,X,ee){return this.t(B,j,ne=>ne.resolveCodeAction(X,ee),{},void 0)}$releaseCodeActions(B,X){this.t(B,j,ee=>Promise.resolve(ee.releaseCodeActions(X)),void 0,void 0)}registerDocumentFormattingEditProvider(B,X,ee){const ne=this.u(new M(this.h,ee),B);return this.e.$registerDocumentFormattingSupport(ne,this.o(X,B),B.identifier,B.displayName||B.name),this.p(ne)}$provideDocumentFormattingEdits(B,X,ee,ne){return this.t(B,M,Z=>Z.provideDocumentFormattingEdits(C.URI.revive(X),ee,ne),void 0,ne)}registerDocumentRangeFormattingEditProvider(B,X,ee){const ne=typeof ee.provideDocumentRangesFormattingEdits=="function",Z=this.u(new H(this.h,ee),B);return this.e.$registerRangeFormattingSupport(Z,this.o(X,B),B.identifier,B.displayName||B.name,ne),this.p(Z)}$provideDocumentRangeFormattingEdits(B,X,ee,ne,Z){return this.t(B,H,de=>de.provideDocumentRangeFormattingEdits(C.URI.revive(X),ee,ne,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(B,X,ee,ne,Z){return this.t(B,H,de=>de.provideDocumentRangesFormattingEdits(C.URI.revive(X),ee,ne,Z),void 0,Z)}registerOnTypeFormattingEditProvider(B,X,ee,ne){const Z=this.u(new q(this.h,ee),B);return this.e.$registerOnTypeFormattingSupport(Z,this.o(X,B),ne,B.identifier),this.p(Z)}$provideOnTypeFormattingEdits(B,X,ee,ne,Z,de){return this.t(B,q,ye=>ye.provideOnTypeFormattingEdits(C.URI.revive(X),ee,ne,Z,de),void 0,de)}registerWorkspaceSymbolProvider(B,X){const ee=this.u(new me(X,this.l),B);return this.e.$registerNavigateTypeSupport(ee,typeof X.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(B,X,ee){return this.t(B,me,ne=>ne.provideWorkspaceSymbols(X,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(B,X,ee){return this.t(B,me,ne=>ne.resolveWorkspaceSymbol(X,ee),void 0,void 0)}$releaseWorkspaceSymbols(B,X){this.t(B,me,ee=>ee.releaseWorkspaceSymbols(X),void 0,void 0)}registerRenameProvider(B,X,ee){const ne=this.u(new x(this.h,ee,this.l),B);return this.e.$registerRenameSupport(ne,this.o(X,B),x.supportsResolving(ee)),this.p(ne)}$provideRenameEdits(B,X,ee,ne,Z){return this.t(B,x,de=>de.provideRenameEdits(C.URI.revive(X),ee,ne,Z),void 0,Z)}$resolveRenameLocation(B,X,ee,ne){return this.t(B,x,Z=>Z.resolveRenameLocation(C.URI.revive(X),ee,ne),void 0,ne)}registerDocumentSemanticTokensProvider(B,X,ee,ne){const Z=this.u(new V(this.h,ee),B),de=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(X,B),ne,de);let ye=this.p(Z);if(de){const je=ee.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(de));ye=L.$VJ.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,X,ee,ne){return this.t(B,V,Z=>Z.provideDocumentSemanticTokens(C.URI.revive(X),ee,ne),null,ne)}$releaseDocumentSemanticTokens(B,X){this.t(B,V,ee=>ee.releaseDocumentSemanticColoring(X),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,X,ee,ne){const Z=this.u(new _(this.h,ee),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(X,B),ne),this.p(Z)}$provideDocumentRangeSemanticTokens(B,X,ee,ne){return this.t(B,_,Z=>Z.provideDocumentRangeSemanticTokens(C.URI.revive(X),ee,ne),null,ne)}registerCompletionItemProvider(B,X,ee,ne){const Z=this.u(new ge(this.h,this.j.converter,ee,this.m,B),B);return this.e.$registerCompletionsProvider(Z,this.o(X,B),ne,ge.supportsResolving(ee),B.identifier),this.p(Z)}$provideCompletionItems(B,X,ee,ne,Z){return this.t(B,ge,de=>de.provideCompletionItems(C.URI.revive(X),ee,ne,Z),void 0,Z)}$resolveCompletionItem(B,X,ee){return this.t(B,ge,ne=>ne.resolveCompletionItem(X,ee),void 0,ee)}$releaseCompletionItems(B,X){this.t(B,ge,ee=>ee.releaseCompletionItems(X),void 0,void 0)}registerInlineCompletionsProvider(B,X,ee,ne){const Z=new we(B,this.h,ee,this.j.converter),de=this.u(Z,B);return this.e.$registerInlineCompletionsSupport(de,this.o(X,B),Z.supportsHandleEvents,D.$Ul.toKey(B.identifier.value),ne?.yieldTo?.map(ye=>D.$Ul.toKey(ye))||[]),this.p(de)}$provideInlineCompletions(B,X,ee,ne,Z){return this.t(B,ce,de=>de.provideInlineCompletions(C.URI.revive(X),ee,ne,Z),void 0,Z)}$handleInlineCompletionDidShow(B,X,ee,ne){this.t(B,ce,async Z=>{Z.handleDidShowCompletionItem(X,ee,ne)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,X,ee,ne){this.t(B,ce,async Z=>{Z.handlePartialAccept(X,ee,ne)},void 0,void 0)}$freeInlineCompletionsList(B,X){this.t(B,ce,async ee=>{ee.disposeCompletions(X)},void 0,void 0)}registerSignatureHelpProvider(B,X,ee,ne){const Z=Array.isArray(ne)?{triggerCharacters:ne,retriggerCharacters:[]}:ne,de=this.u(new U(this.h,ee),B);return this.e.$registerSignatureHelpProvider(de,this.o(X,B),Z),this.p(de)}$provideSignatureHelp(B,X,ee,ne,Z){return this.t(B,U,de=>de.provideSignatureHelp(C.URI.revive(X),ee,ne,Z),void 0,Z)}$releaseSignatureHelp(B,X){this.t(B,U,ee=>ee.releaseSignatureHelp(X),void 0,void 0)}registerInlayHintsProvider(B,X,ee){const ne=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.u(new K(this.h,this.j.converter,ee,this.l,B),B);this.e.$registerInlayHintsProvider(Z,this.o(X,B),typeof ee.resolveInlayHint=="function",ne,be.w(B));let de=this.p(Z);if(ne!==void 0){const ye=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(ne));de=L.$VJ.from(de,ye)}return de}$provideInlayHints(B,X,ee,ne){return this.t(B,K,Z=>Z.provideInlayHints(C.URI.revive(X),ee,ne),void 0,ne)}$resolveInlayHint(B,X,ee){return this.t(B,K,ne=>ne.resolveInlayHint(X,ee),void 0,ee)}$releaseInlayHints(B,X){this.t(B,K,ee=>ee.releaseHints(X),void 0,void 0)}registerDocumentLinkProvider(B,X,ee){const ne=this.u(new Y(this.h,ee),B);return this.e.$registerDocumentLinkProvider(ne,this.o(X,B),typeof ee.resolveDocumentLink=="function"),this.p(ne)}$provideDocumentLinks(B,X,ee){return this.t(B,Y,ne=>ne.provideLinks(C.URI.revive(X),ee),void 0,ee,X.scheme==="output")}$resolveDocumentLink(B,X,ee){return this.t(B,Y,ne=>ne.resolveLink(X,ee),void 0,void 0,!0)}$releaseDocumentLinks(B,X){this.t(B,Y,ee=>ee.releaseLinks(X),void 0,void 0,!0)}registerColorProvider(B,X,ee){const ne=this.u(new se(this.h,ee),B);return this.e.$registerDocumentColorProvider(ne,this.o(X,B)),this.p(ne)}$provideDocumentColors(B,X,ee){return this.t(B,se,ne=>ne.provideColors(C.URI.revive(X),ee),[],ee)}$provideColorPresentations(B,X,ee,ne){return this.t(B,se,Z=>Z.provideColorPresentations(C.URI.revive(X),ee,ne),void 0,ne)}registerFoldingRangeProvider(B,X,ee){const ne=this.q(),Z=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(ne,new ue(new re(this.h,ee),B)),this.e.$registerFoldingRangeProvider(ne,this.o(X,B),B.identifier,Z);let de=this.p(ne);if(Z!==void 0){const ye=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));de=L.$VJ.from(de,ye)}return de}$provideFoldingRanges(B,X,ee,ne){return this.t(B,re,Z=>Z.provideFoldingRanges(C.URI.revive(X),ee,ne),void 0,ne)}registerSelectionRangeProvider(B,X,ee){const ne=this.u(new le(this.h,ee,this.l),B);return this.e.$registerSelectionRangeProvider(ne,this.o(X,B)),this.p(ne)}$provideSelectionRanges(B,X,ee,ne){return this.t(B,le,Z=>Z.provideSelectionRanges(C.URI.revive(X),ee,ne),[],ne)}registerCallHierarchyProvider(B,X,ee){const ne=this.u(new Ee(this.h,ee),B);return this.e.$registerCallHierarchyProvider(ne,this.o(X,B)),this.p(ne)}$prepareCallHierarchy(B,X,ee,ne){return this.t(B,Ee,Z=>Promise.resolve(Z.prepareSession(C.URI.revive(X),ee,ne)),void 0,ne)}$provideCallHierarchyIncomingCalls(B,X,ee,ne){return this.t(B,Ee,Z=>Z.provideCallsTo(X,ee,ne),void 0,ne)}$provideCallHierarchyOutgoingCalls(B,X,ee,ne){return this.t(B,Ee,Z=>Z.provideCallsFrom(X,ee,ne),void 0,ne)}$releaseCallHierarchy(B,X){this.t(B,Ee,ee=>Promise.resolve(ee.releaseSession(X)),void 0,void 0)}registerTypeHierarchyProvider(B,X,ee){const ne=this.u(new he(this.h,ee),B);return this.e.$registerTypeHierarchyProvider(ne,this.o(X,B)),this.p(ne)}$prepareTypeHierarchy(B,X,ee,ne){return this.t(B,he,Z=>Promise.resolve(Z.prepareSession(C.URI.revive(X),ee,ne)),void 0,ne)}$provideTypeHierarchySupertypes(B,X,ee,ne){return this.t(B,he,Z=>Z.provideSupertypes(X,ee,ne),void 0,ne)}$provideTypeHierarchySubtypes(B,X,ee,ne){return this.t(B,he,Z=>Z.provideSubtypes(X,ee,ne),void 0,ne)}$releaseTypeHierarchy(B,X){this.t(B,he,ee=>Promise.resolve(ee.releaseSession(X)),void 0,void 0)}registerDocumentOnDropEditProvider(B,X,ee,ne){const Z=this.q();this.f.set(Z,new ue(new fe(this.e,this.h,ee,Z,B),B));const de=(0,t.$MF)(B,"dropMetadata")&&ne?fe.toInternalProviderId(B.identifier.value,ne.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(X,B),de,(0,t.$MF)(B,"dropMetadata")?ne:void 0),this.p(Z)}$provideDocumentOnDropEdits(B,X,ee,ne,Z,de){return this.t(B,fe,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(X,C.URI.revive(ee),ne,Z,de)),void 0,void 0)}registerMappedEditsProvider(B,X,ee){const ne=this.u(new te(this.h,ee),B);return this.e.$registerMappedEditsProvider(ne,this.o(X,B)),this.p(ne)}$provideMappedEdits(B,X,ee,ne,Z){return this.t(B,te,de=>Promise.resolve(de.provideMappedEdits(X,ee,ne,Z)),null,Z)}registerDocumentPasteEditProvider(B,X,ee,ne){const Z=this.q();this.f.set(Z,new ue(new z(this.e,this.h,ee,Z,B),B));const de=z.toInternalProviderId(B.identifier.value,ne.id);return this.e.$registerPasteEditProvider(Z,this.o(X,B),de,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:ne.copyMimeTypes,pasteMimeTypes:ne.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(B,X,ee,ne,Z){return this.t(B,z,de=>de.prepareDocumentPaste(C.URI.revive(X),ee,ne,Z),void 0,Z)}$providePasteEdits(B,X,ee,ne,Z,de){return this.t(B,z,ye=>ye.providePasteEdits(X,C.URI.revive(ee),ne,Z,de),void 0,de)}static y(B){return{pattern:B.source,flags:B.flags}}static z(B){return{decreaseIndentPattern:be.y(B.decreaseIndentPattern),increaseIndentPattern:be.y(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.y(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.y(B.unIndentedLinePattern):void 0}}static B(B){return{beforeText:be.y(B.beforeText),afterText:B.afterText?be.y(B.afterText):void 0,previousLineText:B.previousLineText?be.y(B.previousLineText):void 0,action:B.action}}static C(B){return B.map(be.B)}setLanguageConfiguration(B,X,ee){const{wordPattern:ne}=ee;if(ne&&(0,S.$ye)(ne))throw new Error(`Invalid language configuration: wordPattern '${ne}' is not allowed to match the empty string.`);ne?this.h.setWordDefinitionFor(X,ne):this.h.setWordDefinitionFor(X,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use."),ee.autoClosingPairs&&(0,t.$NF)(B,"languageConfigurationAutoClosingPairs");const Z=this.q(),de={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?be.y(ee.wordPattern):void 0,indentationRules:ee.indentationRules?be.z(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?be.C(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs};return this.e.$setLanguageConfiguration(Z,X,de),this.p(Z)}$setWordDefinitions(B){for(const X of B)this.h.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.$Rac=be}),define(De[316],Ce([1,0,6,13,7,38,11,3]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=void 0;class S{constructor(P,I,p,k){this.c=I,this.d=p,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(C.$TJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,I){await this.a.$changeLanguage(P,I);const p=this.c.getDocumentData(P);if(!p)throw new Error(`document '${P.toString()}' NOT found`);return p.document}async tokenAtPosition(P,I){const p=P.version,k=F.Position.from(I),D=await this.a.$tokensAtPosition(P.uri,k),v={type:f.StandardTokenType.Other,range:P.getWordRangeAtPosition(I)??new f.$XJ(I.line,I.character,I.line,I.character)};if(!D)return v;const r={range:F.Range.to(D.range),type:F.TokenType.to(D.type)};return!r.range.contains(I)||p!==P.version?v:r}createLanguageStatusItem(P,I,p){const k=this.f++,D=this.a,v=this.g,r=`${P.identifier.value}/${I}`;if(v.has(r))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);v.add(r);const i={selector:p,id:I,name:P.displayName??P.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let s;const d=new m.$ic,$=()=>{if(s?.dispose(),!v.has(r)){console.warn(`LanguageStatusItem (${I}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}s=(0,R.$Hg)(()=>{d.clear(),this.a.$setLanguageStatus(k,{id:r,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?L.default.Error:i.severity===f.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,d),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},g={dispose(){d.dispose(),s?.dispose(),D.$removeLanguageStatus(k),v.delete(r)},get id(){return i.id},get name(){return i.name},set name(t){i.name=t,$()},get selector(){return i.selector},set selector(t){i.selector=t,$()},get text(){return i.text},set text(t){i.text=t,$()},get detail(){return i.detail},set detail(t){i.detail=t,$()},get severity(){return i.severity},set severity(t){i.severity=t,$()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(t){i.accessibilityInformation=t,$()},get command(){return i.command},set command(t){i.command=t,$()},get busy(){return i.busy},set busy(t){i.busy=t,$()}};return $(),g}}e.$zbc=S}),define(De[112],Ce([1,0,12,15,2,5,14,6,26,20]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=void 0;let P=class{constructor(p,k,D){this.f=D,this.d=new Map,this.a=k.getProxy(m.$TJ.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===C.$f}getMessage(p,k){const{message:D,args:v,comment:r}=k;if(this.c)return(0,F.$ne)(D,v??{});let i=D;r&&r.length>0&&(i+=`/${Array.isArray(r)?r.join(""):r}`);const s=this.d.get(p)?.contents[i];return s||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,F.$ne)(s??D,v??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let k;const D=await this.g(p);if(!D){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const v=await this.a.$fetchBundleContents(D),r=JSON.parse(v);k=p.isBuiltin?r.contents?.bundle:r}catch(v){this.f.error(`Failed to load translations for ${p.identifier.value} from ${D}: ${v.message}`);return}k&&this.d.set(p.identifier.value,{contents:k,uri:D})}async g(p){if(p.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return f.URI.revive(k)}return p.l10n?f.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$obc=P,e.$obc=P=Ke([Be(0,S.$_L),Be(1,b.$VL),Be(2,R.$4i)],P),e.$pbc=(0,L.$Ah)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,14,6,26,20,2,63]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;let S=class extends C.$cj{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(k=>(0,m.$0g)(k))),this.r=I.getProxy(F.$TJ.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(R.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,k){return new b(this.r,I,p,k)}};e.$Pcc=S,e.$Pcc=S=Ke([Be(0,L.$VL),Be(1,f.$_L)],S);class b extends C.$0i{constructor(I,p,k,D){super(D?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(p,D).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const k=[[I,p]];this.m?this.u(k):this.n.push(...k)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0,e.$qbc=(0,F.$Ah)("IExtHostManagedSockets");let m=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$TJ.MainThreadManagedSockets)}setFactory(I,p){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new S(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,k=await this.c.makeConnection(),D=new f.$ic;return this.d.set(p,new b(p,k,D)),D.add((0,f.$hc)(()=>this.d.delete(p))),D.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),D.dispose()})),D.add(k.onDidClose(v=>{this.a.$onDidManagedSocketClose(p,v?.stack??v?.message),D.dispose()})),D.add(k.onDidReceiveMessage(v=>this.a.$onDidManagedSocketHaveData(p,R.$Ed.wrap(v)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$rbc=m,e.$rbc=m=Ke([Be(0,L.$VL)],m);class S{constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class b extends f.$jc{constructor(I,p,k){super(),this.socketId=I,this.actual=p,this.B(k)}}}),define(De[317],Ce([1,0,6,14,27]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;function L(m){return m&&m.title}let R=class{constructor(S,b){this.b=b,this.a=S.getProxy(C.$TJ.MainThreadMessageService)}showMessage(S,b,P,I,p){const k={source:{identifier:S.identifier,label:S.displayName||S.name}};let D;typeof I=="string"||L(I)?D=[I,...p]:(k.modal=I?.modal,k.useCustom=I?.useCustom,k.detail=I?.detail,D=p),k.useCustom&&(0,f.$NF)(S,"resolvers");const v=[];for(let r=0;r<D.length;r++){const i=D[r];if(typeof i=="string")v.push({title:i,handle:r,isCloseAffordance:!1});else if(typeof i=="object"){const{title:s,isCloseAffordance:d}=i;v.push({title:s,isCloseAffordance:!!d,handle:r})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(b,P,k,v).then(r=>{if(typeof r=="number")return D[r]})}};e.$Abc=R,e.$Abc=R=Ke([Be(1,F.$4i)],R)}),define(De[318],Ce([1,0,207,22,4,3,28,15,18,2,30,87,6,33,13,7,69,281,144,8,23,17]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,n,c,h,E){this.q=c,this.r=h,this.s=E,this.f=new Map,this.g=new R.$yi,this.h=new Map,this.j=new f.$ed({onListenerError:d.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$ed({onListenerError:d.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$ed({onListenerError:d.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$ed({onListenerError:d.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Iac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=a.getProxy(p.$TJ.MainThreadNotebook),this.c=a.getProxy(p.$TJ.MainThreadNotebookDocuments),this.d=a.getProxy(p.$TJ.MainThreadNotebookEditors),this.i=n.converter,n.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const u=y.notebookEditor?.notebookUri,l=y.cell.handle,A=this.g.get(u)?.getCell(l);if(A)return A.apiCell}if(y&&y.$mid===14){const u=y.uri,l=this.g.get(u);if(l)return l.apiNotebook}return y}}),t.A(n)}getEditorById(a){const n=this.h.get(a);if(!n)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return n}getIdByEditor(a){for(const[n,c]of this.h)if(c.apiEditor===a)return n}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,n){const c=this.g.get(a);if(!c&&!n)throw new Error(`NO notebook document for '${a}'`);return c}static t(a,n){if(!n)return;const c=n.filenamePattern.map(h=>D.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(n.filenamePattern&&!c){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:n.displayName,filenamePattern:c,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,n,c){const h=t.a++,E=typeof c.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(h,c),this.b.$registerNotebookCellStatusBarItemProvider(h,E,n);let y;return E!==void 0&&(y=c.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(E))),new v.$VJ(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,E),y?.dispose()})}async createNotebookDocument(a){const n=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&D.NotebookData.from(a.content)});return b.URI.revive(n)}async openNotebookDocument(a){const n=this.g.get(a);if(n)return n.apiNotebook;const c=await this.c.$tryOpenNotebook(a),h=this.g.get(b.URI.revive(c));return(0,S.$tf)(h?.apiNotebook)}async showNotebookDocument(a,n){b.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let c;typeof n=="object"?c={position:D.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(D.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:c={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,c),E=h&&this.h.get(h)?.apiEditor;if(E)return E;throw h?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,n,c,h){const E=this.f.get(a),y=b.URI.revive(n),u=this.g.get(y);if(!u||!E)return;const l=u.getCellFromIndex(c);if(!l)return;const w=await E.provideCellStatusBarItems(l.apiCell,h);if(!w)return;const A=new L.$ic,O=this.p.add([A]),T=(Array.isArray(w)?w:[w]).map(j=>D.NotebookStatusBarItem.from(j,this.i,A));return{cacheId:O,items:T}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,n,c,h,E){if((0,m.$le)(n))throw new Error("viewType cannot be empty or just whitespace");const y=this.u++;return this.w.set(y,{viewType:n,serializer:c,options:h}),this.b.$registerNotebookSerializer(y,{id:a.identifier,location:a.extensionLocation},n,D.NotebookDocumentContentOptions.from(h),t.t(a,E)),(0,L.$hc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(a,n,c){const h=this.w.get(a);if(!h)throw new Error("NO serializer found");const E=await h.serializer.deserializeNotebook(n.buffer,c);return new r.$aA(D.NotebookData.from(E))}async $notebookToData(a,n,c){const h=this.w.get(a);if(!h)throw new Error("NO serializer found");const E=await h.serializer.serializeNotebook(D.NotebookData.to(n.value),c);return F.$Ed.wrap(E)}async $saveNotebook(a,n,c,h,E){const y=b.URI.revive(n),u=this.w.get(a);if(!u)throw new Error("NO serializer found");const l=this.g.get(y);if(!l)throw new Error("Document NOT found");if(l.versionId!==c)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new P.$mk((0,C.localize)(0,null,this.y(y)),6);await this.x(y,h);const w={metadata:(0,$.$3m)(l.apiNotebook.metadata,j=>!(u.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of l.apiNotebook.getCells()){const z=new v.$iL(j.kind,j.document.getText(),j.document.languageId,j.mime,u.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);z.metadata=(0,$.$3m)(j.metadata,M=>!(u.options?.transientCellMetadata??{})[M]),w.cells.push(z)}const A=await u.serializer.serializeNotebook(w,E);await this.s.value.writeFile(y,A);const O=this.s.getFileSystemProviderExtUri(y.scheme),N=await this.s.value.stat(y);return{name:O.basename(y),isFile:(N.type&P.FileType.File)!==0,isDirectory:(N.type&P.FileType.Directory)!==0,isSymbolicLink:(N.type&P.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((N.permissions??0)&P.FilePermission.Locked),etag:P.$xk({mtime:N.mtime,size:N.size}),children:void 0}}async x(a,n){const c=await this.s.value.stat(a);if(typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==P.$wk&&typeof c.mtime=="number"&&typeof c.size=="number"&&n.mtime<c.mtime&&n.etag!==P.$xk({mtime:n.mtime,size:c.size}))throw new P.$mk((0,C.localize)(1,null),3,n)}y(a){return a.scheme===g.Schemas.file?a.fsPath:a.toString()}z(a,n,c){if(this.h.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const h=new s.$hcc(n,this.d,a,c.visibleRanges.map(D.NotebookRange.to),c.selections.map(D.NotebookRange.to),typeof c.viewColumn=="number"?D.ViewColumn.to(c.viewColumn):void 0);this.h.set(n,h)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const c of a.value.removedDocuments){const h=b.URI.revive(c),E=this.g.get(h);E&&(E.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(E.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===h.toString()&&this.h.delete(y.id)}if(a.value.addedDocuments){const c=[];for(const h of a.value.addedDocuments){const E=b.URI.revive(h.uri);if(this.g.has(E))throw new Error(`adding EXISTING notebook ${E} `);const y=new i.$gcc(this.c,this.q,this.r,E,h);c.push(...h.cells.map(u=>i.$fcc.asModelAddData(y.apiNotebook,u))),this.g.get(E)?.dispose(),this.g.set(E,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this.m.fire(y.apiNotebook)}}if(a.value.addedEditors)for(const c of a.value.addedEditors){if(this.h.has(c.id))return;const h=b.URI.revive(c.documentUri),E=this.g.get(h);E&&this.z(E,c.id,c)}const n=[];if(a.value.removedEditors)for(const c of a.value.removedEditors){const h=this.h.get(c);h&&(this.h.delete(c),this.k?.id===h.id&&(this.k=void 0),n.push(h))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const c=new Set;this.l.forEach(h=>c.add(h.id));for(const h of this.h.values()){const E=c.has(h.id);h._acceptVisibility(E)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(a){const n=k.$hM.String.with("notebookType","A notebook type"),c=new k.$jM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new k.$hM("data","Bytes to convert to data",E=>E instanceof Uint8Array,E=>F.$Ed.wrap(E))],new k.$iM("Notebook Data",E=>D.NotebookData.to(E.value))),h=new k.$jM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new k.$hM("NotebookData","Notebook data to convert to bytes",E=>!0,E=>new r.$aA(D.NotebookData.from(E)))],new k.$iM("Bytes",E=>E.buffer));a.registerApiCommand(c),a.registerApiCommand(h)}}e.$icc=t}),define(De[319],Ce([1,0,19,11,21,4,3,28,2,25,14,87,6,33,13,7,110,275,27,69]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;let $=class{constructor(E,y,u,l,w){this.m=y,this.n=u,this.o=l,this.q=w,this.b=new m.$yi,this.c=new m.$yi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$Iac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$ed,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=E.getProxy(p.$TJ.MainThreadNotebookKernels);const A=new k.$jM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.$hM("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const N=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:N}}else if(O&&"notebookEditor"in O){const N=this.n.getIdByEditor(O.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return O})],k.$iM.Void);this.o.registerApiCommand(A)}createNotebookController(E,y,u,l,w,A){for(const ge of this.j.values())if(ge.controller.id===y&&b.$Ul.equals(E.identifier,ge.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const O=this.k++,N=this;this.q.trace(`NotebookController[${O}], CREATED by ${E.identifier.value}, ${y}`);const T=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${E.identifier}'`);let j=!1;const z=new L.$ed,M=new L.$ed,H={id:c(E.identifier,y),notebookType:u,extensionId:E.identifier,extensionLocation:E.extensionLocation,label:l||E.identifier.value,preloads:A?A.map(D.NotebookRendererScript.from):[]};let q=w??T,me;this.a.$addKernel(O,H).catch(ge=>{console.log(ge),j=!0});let x=0;const Q=()=>{if(j)return;const ge=++x;Promise.resolve().then(()=>{ge===x&&this.a.$updateKernel(O,H)})},V=new m.$yi,_={get id(){return y},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return H.label},set label(ge){H.label=ge??E.displayName??E.name,Q()},get detail(){return H.detail??""},set detail(ge){H.detail=ge,Q()},get description(){return H.description??""},set description(ge){H.description=ge,Q()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(ge){H.supportedLanguages=ge,Q()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){H.supportsExecutionOrder=ge,Q()},get rendererScripts(){return H.preloads?H.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ge){q=ge??T},get interruptHandler(){return me},set interruptHandler(ge){me=ge,H.supportsInterrupt=!!ge,Q()},createNotebookCellExecution(ge){if(j)throw new Error("notebook controller is DISPOSED");if(!V.has(ge.notebook.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return N._createNotebookCellExecution(ge,c(E.identifier,this.id))},createNotebookExecution(ge){if((0,s.$NF)(E,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!V.has(ge.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return N._createNotebookExecution(ge,c(E.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${O}], DISPOSED`),j=!0,this.j.delete(O),z.dispose(),M.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(ge,ce){ce===v.NotebookControllerAffinity2.Hidden&&(0,s.$NF)(E,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(O,ge.uri,ce)},onDidReceiveMessage:M.event,postMessage(ge,ce){return(0,s.$NF)(E,"notebookMessaging"),N.a.$postMessage(O,ce&&N.n.getIdByEditor(ce),ge)},asWebviewUri(ge){return(0,s.$NF)(E,"notebookMessaging"),(0,r.$Kob)(ge,N.m.remote)}};return this.j.set(O,{extensionId:E.identifier,controller:_,onDidReceiveMessage:M,onDidChangeSelection:z,associatedNotebooks:V}),_}getIdByController(E){for(const[y,u]of this.j)if(u.controller===E)return c(u.extensionId,E.id);return null}createNotebookControllerDetectionTask(E,y){const u=this.f++,l=this;this.q.trace(`NotebookControllerDetectionTask[${u}], CREATED by ${E.identifier.value}`),this.a.$addKernelDetectionTask(u,y);const w={dispose:()=>{this.e.delete(u),l.a.$removeKernelDetectionTask(u)}};return this.e.set(u,w),w}registerKernelSourceActionProvider(E,y,u){const l=this.h++,w=typeof u.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,A=this;this.g.set(l,u),this.q.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${E.identifier.value}`),this.a.$addKernelSourceActionProvider(l,l,y);let O;return w!==void 0&&(O=u.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(l),A.a.$removeKernelSourceActionProvider(l,l),O?.dispose()}}}async $provideKernelSourceActions(E,y){const u=this.g.get(E);if(u){const l=new R.$ic;return this.i.add([l]),(await u.provideNotebookKernelSourceActions(y)??[]).map(A=>D.NotebookKernelSourceAction.from(A,this.o.converter,l))}return[]}$acceptNotebookAssociation(E,y,u){const l=this.j.get(E);if(l){const w=this.n.getNotebookDocument(S.URI.revive(y));u?l.associatedNotebooks.set(w.uri,!0):l.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${E}] ASSOCIATE notebook`,w.uri.toString(),u),l.onDidChangeSelection.fire({selected:u,notebook:w.apiNotebook})}}async $executeCells(E,y,u){const l=this.j.get(E);if(!l)return;const w=this.n.getNotebookDocument(S.URI.revive(y)),A=[];for(const O of u){const N=w.getCell(O);N&&A.push(N.apiCell)}try{this.q.trace(`NotebookController[${E}] EXECUTE cells`,w.uri.toString(),A.length),await l.controller.executeHandler.call(l.controller,A,w.apiNotebook,l.controller)}catch(O){this.q.error(`NotebookController[${E}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(E,y,u){const l=this.j.get(E);if(!l)return;const w=this.n.getNotebookDocument(S.URI.revive(y));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,w.apiNotebook);else for(const A of u){const O=w.getCell(A);O&&this.b.get(O.uri)?.cancel()}if(l.controller.interruptHandler){const A=this.c.get(w.uri);u.length&&Array.isArray(A)&&A.length&&A.forEach(O=>O.dispose())}}$acceptKernelMessageFromRenderer(E,y,u){const l=this.j.get(E);if(!l)return;const w=this.n.getEditorById(y);l.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:u}))}$cellExecutionChanged(E,y,u){const w=this.n.getNotebookDocument(S.URI.revive(E)).getCell(y);if(w){const A=u?D.NotebookCellExecutionState.to(u):v.NotebookCellExecutionState.Idle;A!==void 0&&this.l.fire({cell:w.apiCell,state:A})}}_createNotebookCellExecution(E,y){if(E.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.n.getNotebookDocument(E.notebook.uri).getCellFromApiCell(E);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const w=new t(y,l,this.a);this.b.set(l.uri,w);const A=w.onDidChangeState(()=>{w.state===g.Resolved&&(w.dispose(),A.dispose(),this.b.delete(l.uri))});return w.asApiObject()}_createNotebookExecution(E,y){const u=this.n.getNotebookDocument(E.uri),l=E.getCells().find(O=>{const N=u.getCellFromApiCell(O);return N&&this.b.has(N.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this.c.has(u.uri))throw new Error(`duplicate notebook execution for ${u.uri}`);const w=new a(y,u,this.a),A=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),A.dispose(),this.c.delete(u.uri))});return this.c.set(u.uri,[w,A]),w.asApiObject()}};e.$wcc=$,e.$wcc=$=Ke([Be(4,P.$4i)],$);var g;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(g||(g={}));class t extends R.$jc{static{this.a=0}get state(){return this.f}constructor(E,y,u){super(),this.m=y,this.n=u,this.b=t.a++,this.c=new L.$ed,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new f.$od),this.h=new n(10,l=>this.s(l)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,E,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(E){await this.h.addItem(E)}async s(E){const y=Array.isArray(E)?E:[E];return this.n.$updateExecution(this.b,new d.$aA(y))}t(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(E){let y=this.m;if(E&&(y=this.m.notebook.getCellFromApiCell(E)),!y)throw new Error("INVALID cell");return y.handle}y(E){return E.map(y=>{const u=v.$lL.ensureUniqueMimeTypes(y.items,!0);return u===y.items?D.NotebookCellOutput.from(y):D.NotebookCellOutput.from({items:u,id:y.id,metadata:y.metadata})})}async z(E,y,u){const l=this.w(y),w=this.y((0,C.$Zb)(E));return this.r({editType:i.CellExecutionUpdateType.Output,cellHandle:l,append:u,outputs:w})}async C(E,y,u){return E=v.$lL.ensureUniqueMimeTypes((0,C.$Zb)(E),!0),this.r({editType:i.CellExecutionUpdateType.OutputItems,items:E.map(D.NotebookCellOutputItem.from),outputId:y.id,append:u})}asApiObject(){const E=this;return Object.freeze({get token(){return E.g.token},get cell(){return E.m.apiCell},get executionOrder(){return E.j},set executionOrder(u){E.j=u,E.s([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:E.j}])},start(u){if(E.f===g.Resolved||E.f===g.Started)throw new Error("Cannot call start again");E.f=g.Started,E.c.fire(),E.s({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,l){if(E.f===g.Resolved)throw new Error("Cannot call resolve twice");E.f=g.Resolved,E.c.fire(),E.h.flush(),E.n.$completeExecution(E.b,new d.$aA({runEndTime:l,lastRunSuccess:u}))},clearOutput(u){return E.t(),E.z([],u,!1)},appendOutput(u,l){return E.t(),E.z(u,l,!0)},replaceOutput(u,l){return E.t(),E.z(u,l,!1)},appendOutputItems(u,l){return E.t(),E.C(u,l,!0)},replaceOutputItems(u,l){return E.t(),E.C(u,l,!1)}})}}var o;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(o||(o={}));class a extends R.$jc{static{this.a=0}get state(){return this.f}constructor(E,y,u){super(),this.h=y,this.j=u,this.b=a.a++,this.c=new L.$ed,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new f.$od),this.j.$createNotebookExecution(this.b,E,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===o.Resolved||this.f===o.Started)throw new Error("Cannot call start again");this.f=o.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===o.Resolved)throw new Error("Cannot call resolve twice");this.f=o.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class n{constructor(E,y){this.e=E,this.f=y,this.a=[],this.b=Date.now()}addItem(E){return this.a.push(E),this.c||(this.c=new F.$1g,this.b=Date.now(),(0,F.$Gg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const E=this.c;this.c=void 0;const y=this.a;return this.a=[],this.f(y).finally(()=>E.complete())}}function c(h,E){return`${h.value}/${E}`}e.$xcc=c}),define(De[320],Ce([1,0,4,6,144]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class L{constructor(m,S){this.c=S,this.a=new Map,this.b=m.getProxy(F.$TJ.MainThreadNotebookRenderers)}$postRendererMessage(m,S,b){const P=this.c.getEditorById(m);this.a.get(S)?.fire({editor:P.apiEditor,message:b})}createRendererMessaging(m,S){if(!m.contributes?.notebookRenderer?.some(P=>P.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(P,I,p)=>this.d(S).event(P,I,p),postMessage:(P,I)=>{f.$hcc.apiEditorsToExtHost.has(P)&&([P,I]=[I,P]);const p=I&&f.$hcc.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,S,P)}}}d(m){let S=this.a.get(m);return S||(S=new C.$ed({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(m)}}),this.a.set(m,S),S)}}e.$ycc=L}),define(De[321],Ce([1,0,3,18,2,27,6]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class m{constructor(b){this.b=new Map,this.a=b.getProxy(R.$TJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(b,P,I){if((0,L.$NF)(b,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,I),this.a.$registerProfileContentHandler(P,I.name,I.description,b.identifier.value),(0,C.$hc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(b,P,I,p){const k=this.b.get(b);if(!k)throw new Error(`Unknown handler with id: ${b}`);return k.saveProfile(P,I,p)}async $readProfile(b,P,I){const p=this.b.get(b);if(!p)throw new Error(`Unknown handler with id: ${b}`);return p.readProfile((0,F.$if)(P)?P:f.URI.revive(P),I)}}e.$Ccc=m}),define(De[322],Ce([1,0,2,6,11,13]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class R{static{this.a=0}constructor(S,b){this.d=b,this.c=new Map,this.b=S.getProxy(F.$TJ.MainThreadQuickDiff)}$provideOriginalResource(S,b,P){const I=C.URI.revive(b),p=this.c.get(S);return p?(0,f.$yg)(()=>p.provideOriginalResource(I,P)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(S,b,P,I){const p=R.a++;return this.c.set(p,b),this.b.$registerQuickDiffProvider(p,L.DocumentSelector.from(S,this.d),P,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Dcc=R}),define(De[323],Ce([1,0,21,4,3,6,2,7,8,19,38,60,27,13]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;function D(v,r,i){const s=v.getProxy(L.$TJ.MainThreadQuickOpen);class d{constructor(E,y){this.e=new Map,this.f=0,this.a=E,this.b=y}showQuickPick(E,y,u,l=C.CancellationToken.None){this.c=void 0;const w=Promise.resolve(y),A=++this.f,O=s.$show(A,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},l),N={},T=O.then(()=>N);return Promise.race([T,w]).then(j=>{if(j===N)return;const z=(0,p.$MF)(E,"quickPickItemTooltip");return w.then(M=>{const H=[];for(let q=0;q<M.length;q++){const me=M[q];if(typeof me=="string")H.push({label:me,handle:q});else if(me.kind===m.QuickPickItemKind.Separator)H.push({type:"separator",label:me.label});else{me.tooltip&&!z&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const x=me.iconPath?a(me.iconPath):void 0;H.push({label:me.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:z?k.MarkdownString.fromStrict(me.tooltip):void 0,handle:q})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=q=>{u.onDidSelectItem(M[q])}),s.$setItems(A,H),O.then(q=>{if(typeof q=="number")return M[q];if(Array.isArray(q))return q.map(me=>M[me])})})}).then(void 0,j=>{if(!(0,S.$2)(j))return s.$setError(A,j),Promise.reject(j)})}$onItemSelected(E){this.c?.(E)}showInput(E,y=C.CancellationToken.None){return this.d=E?.validateInput,s.$input(E,typeof this.d=="function",y).then(void 0,u=>{if(!(0,S.$2)(u))return Promise.reject(u)})}async $validateInput(E){if(!this.d)return;const y=await this.d(E);if(!y||typeof y=="string")return y;let u;switch(y.severity){case m.InputBoxValidationSeverity.Info:u=P.default.Info;break;case m.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case m.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=y.message?P.default.Error:P.default.Ignore;break}return{content:y.message,severity:u}}async showWorkspaceFolderPick(E,y=C.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!u)return;const l=await this.a.getWorkspaceFolders2();if(l)return l.find(w=>w.uri.toString()===u.uri.toString())}createQuickPick(E){const y=new n(E,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(E){const y=new c(E,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(E,y){this.e.get(E)?._fireDidChangeValue(y)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,y){const u=this.e.get(E);u instanceof n&&u._fireDidChangeActive(y)}$onDidChangeSelection(E,y){const u=this.e.get(E);u instanceof n&&u._fireDidChangeSelection(y)}$onDidTriggerButton(E,y){this.e.get(E)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(E,y,u){const l=this.e.get(E);l instanceof n&&l._fireDidTriggerItemButton(y,u)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class ${static{this.a=1}constructor(E,y){this.x=E,this.y=y,this._id=n.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$ed,this.q=new F.$ed,this.r=new F.$ed,this.s=new F.$ed,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){this.n=E.slice(),this.o.clear(),E.forEach((y,u)=>{const l=y===m.$eL.Back?-1:u;this.o.set(l,y)}),this.z({buttons:E.map((y,u)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===m.$eL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const y=this.o.get(E);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$ec)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(E){if(!this.v){for(const y of Object.keys(E)){const u=E[y];this.u[y]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}function g(h){if(h instanceof m.$QK)return{id:h.id};const E=o(h),y=t(h);return{dark:typeof E=="string"?R.URI.file(E):E,light:typeof y=="string"?R.URI.file(y):y}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function o(h){return typeof h=="object"&&"dark"in h?h.dark:h}function a(h){const E=g(h);let y,u;return"id"in E?u=I.ThemeIcon.asClassName(E):y=E,{iconPath:y,iconClass:u}}class n extends ${constructor(E,y){super(E.identifier,y),this.O=E,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$ed,this.L=[],this.M=new F.$ed,this.N=new F.$ed,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((l,w)=>{this.C.set(w,l),this.D.set(l,w)});const y=(0,p.$MF)(this.O,"quickPickItemTooltip"),u=[];for(let l=0;l<E.length;l++){const w=E[l];if(w.kind===m.QuickPickItemKind.Separator)u.push({type:"separator",label:w.label});else{w.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=w.iconPath?a(w.iconPath):void 0;u.push({handle:l,label:w.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:y?k.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((O,N)=>({...a(O.iconPath),tooltip:O.tooltip,handle:N}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(E){const y=(0,b.$Eb)(E.map(u=>this.C.get(u)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(E){const y=(0,b.$Eb)(E.map(u=>this.C.get(u)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(E,y){const u=this.C.get(E);if(!u||!u.buttons||!u.buttons.length)return;const l=u.buttons[y];l&&this.N.fire({button:l,item:u})}}class c extends ${constructor(E,y){super(E.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:P.default.Error}):this.z({validationMessage:E.message,severity:E.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new d(r,i)}e.$Ebc=D}),define(De[324],Ce([1,0,2,4,57,3,11,6,19,126,14,25,60,13,27,17]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.$Fbc=void 0;function i(y){if(y)return typeof y.iconPath=="string"?C.URI.file(y.iconPath):C.URI.isUri(y.iconPath)||p.ThemeIcon.isThemeIcon(y.iconPath)?y.iconPath:void 0}function s(y,u){if(!y.iconPath&&!u.iconPath)return 0;if(y.iconPath){if(!u.iconPath)return 1}else return-1;const l=typeof y.iconPath=="string"?y.iconPath:C.URI.isUri(y.iconPath)?y.iconPath.fsPath:y.iconPath.id,w=typeof u.iconPath=="string"?u.iconPath:C.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,b.$fq)(l,w)}function d(y,u){let l=0;if(y.strikeThrough!==u.strikeThrough)return y.strikeThrough?1:-1;if(y.faded!==u.faded)return y.faded?1:-1;if(y.tooltip!==u.tooltip)return(y.tooltip||"").localeCompare(u.tooltip||"");if(l=s(y,u),l!==0)return l;if(y.light&&u.light)l=s(y.light,u.light);else{if(y.light)return 1;if(u.light)return-1}if(l!==0)return l;if(y.dark&&u.dark)l=s(y.dark,u.dark);else{if(y.dark)return 1;if(u.dark)return-1}return l}function $(y,u){if(y.command!==u.command)return y.command<u.command?-1:1;if(y.title!==u.title)return y.title<u.title?-1:1;if(y.tooltip!==u.tooltip){if(y.tooltip!==void 0&&u.tooltip!==void 0)return y.tooltip<u.tooltip?-1:1;if(y.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(y.arguments===u.arguments)return 0;if(y.arguments)if(u.arguments){if(y.arguments.length!==u.arguments.length)return y.arguments.length-u.arguments.length}else return 1;else return-1;for(let l=0;l<y.arguments.length;l++){const w=y.arguments[l],A=u.arguments[l];if(w!==A)return w<A?-1:1}return 0}function g(y,u){let l=(0,b.$fq)(y.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(l!==0)return l;if(y.command&&u.command)l=$(y.command,u.command);else{if(y.command)return 1;if(u.command)return-1}if(l!==0)return l;if(y.decorations&&u.decorations)l=d(y.decorations,u.decorations);else{if(y.decorations)return 1;if(u.decorations)return-1}return l}function t(y,u){for(let l=0;l<y.length;l++)if(y[l]!==u[l])return!1;return!0}function o(y,u){return y.command===u.command&&y.title===u.title&&y.tooltip===u.tooltip&&(y.arguments&&u.arguments?t(y.arguments,u.arguments):y.arguments===u.arguments)}function a(y,u){return(0,S.$sb)(y,u,o)}class n{#e;#t;get value(){return this.d}set value(u){u=u??"",this.#e.$setInputBoxValue(this.l,u),this.n(u)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(u){this.#e.$setInputBoxPlaceholder(this.l,u),this.f=u}get validateInput(){return(0,D.$NF)(this.k,"scmValidation"),this.g}set validateInput(u){if((0,D.$NF)(this.k,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=u,this.#e.$setValidationProviderIsEnabled(this.l,!!u)}get enabled(){return this.h}set enabled(u){u=!!u,this.h!==u&&(this.h=u,this.#e.$setInputBoxEnablement(this.l,u))}get visible(){return this.j}set visible(u){u=!!u,this.j!==u&&(this.j=u,this.#e.$setInputBoxVisibility(this.l,u))}get document(){return(0,D.$NF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(u,l,w,A,O){this.k=u,this.l=A,this.m=O,this.d="",this.e=new F.$ed,this.f="",this.h=!0,this.j=!0,this.#t=l,this.#e=w}showValidationMessage(u,l){(0,D.$NF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,u,l)}$onInputBoxValueChange(u){this.n(u)}n(u){this.d=u,this.e.fire(u)}}e.$Fbc=n;class c{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(u){this.v=u,this.q.$updateGroupLabel(this.t,this.handle,u)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(u){this.p=u,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(u){this.f=[...u],this.k.fire()}constructor(u,l,w,A,O){this.q=u,this.s=l,this.t=w,this.u=A,this.v=O,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$ed,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$ed,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(u){return this.g.get(u)}$executeResourceCommand(u,l){const w=this.h.get(u);return w?(0,R.$yg)(()=>this.s.executeCommand(w.command,...w.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this.f].sort(g),w=(0,S.$Ab)(this.o,u,g).map(N=>{const T=N.toInsert.map(j=>{const z=this.e++;this.g.set(z,j);const M=j.resourceUri;let H;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const G=new L.$ic;H=this.s.converter.toInternal(j.command,G),this.j.set(z,G)}else this.h.set(z,j.command);const q=i(j.decorations),me=j.decorations&&i(j.decorations.light)||q,x=j.decorations&&i(j.decorations.dark)||q,Q=[me,x],V=j.decorations&&j.decorations.tooltip||"",_=j.decorations&&!!j.decorations.strikeThrough,ge=j.decorations&&!!j.decorations.faded,ce=j.contextValue||"";return{rawResource:[z,M,Q,V,_,ge,ce,H],handle:z}});return{start:N.start,deleteCount:N.deleteCount,toInsert:T}}),A=w.map(({start:N,deleteCount:T,toInsert:j})=>[N,T,j.map(z=>z.rawResource)]),O=w.reverse();for(const{start:N,deleteCount:T,toInsert:j}of O){const z=j.map(H=>H.handle),M=this.n.splice(N,T,...z);for(const H of M)this.g.delete(H),this.h.delete(H),this.j.get(H)?.dispose(),this.j.delete(H)}return this.o=u,A}dispose(){this.l=!0,this.m.fire()}}class h{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(u){this.g!==u&&(this.g=u,this.#e.$updateSourceControl(this.t,{count:u}))}get quickDiffProvider(){return this.h}set quickDiffProvider(u){this.h=u;let l;(0,D.$MF)(this.u,"quickDiffProvider")&&(l=u?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!u,quickDiffLabel:l})}get commitTemplate(){return this.j}set commitTemplate(u){u!==this.j&&(this.j=u,this.#e.$updateSourceControl(this.t,{commitTemplate:u}))}get acceptInputCommand(){return this.l}set acceptInputCommand(u){this.k.value=new L.$ic,this.l=u;const l=this.v.converter.toInternal(u,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:l})}get actionButton(){return(0,D.$NF)(this.u,"scmActionButton"),this.n}set actionButton(u){(0,D.$NF)(this.u,"scmActionButton"),this.m.value=new L.$ic,this.n=u;const l=u!==void 0?{command:this.v.converter.toInternal(u.command,this.m.value),secondaryCommands:u.secondaryCommands?.map(w=>w.map(A=>this.v.converter.toInternal(A,this.m.value))),description:u.description,enabled:u.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:l??null})}get statusBarCommands(){return this.p}set statusBarCommands(u){if(this.p&&u&&a(this.p,u))return;this.o.value=new L.$ic,this.p=u;const l=(u||[]).map(w=>this.v.converter.toInternal(w,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:l})}get selected(){return this.q}constructor(u,l,w,A,O,N,T){this.u=u,this.v=A,this.w=O,this.x=N,this.y=T,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$kc,this.l=void 0,this.m=new L.$kc,this.o=new L.$kc,this.p=void 0,this.q=!1,this.s=new F.$ed,this.onDidChangeSelection=this.s.event,this.t=h.d++,this.z=new Map,this.A=new Set,this.#e=w;const j=C.URI.from({scheme:v.Schemas.vscodeSourceControl,path:`${O}/scm${this.t}/input`,query:T?`rootUri=${encodeURIComponent(T.toString())}`:void 0});this.f=new n(u,l,this.#e,this.t,j),this.#e.$registerSourceControl(this.t,O,N,T,j)}createResourceGroup(u,l){const w=new c(this.#e,this.v,this.t,u,l),A=F.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,A),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const u=[],l=[];for(const[w,A]of this.z){A.dispose();const O=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});F.Event.once(w.onDidDispose)(()=>{this.A.delete(w),O.dispose(),this.e.delete(w.handle),this.#e.$unregisterGroup(this.t,w.handle)}),u.push([w.handle,w.id,w.label,w.features]);const N=w._takeResourceStateSnapshot();N.length>0&&l.push([w.handle,N]),this.e.set(w.handle,w)}this.#e.$registerGroups(this.t,u,l),this.z.clear()}eventuallyUpdateResourceStates(){const u=[];this.A.forEach(l=>{const w=l._takeResourceStateSnapshot();w.length!==0&&u.push([l.handle,w])}),u.length>0&&this.#e.$spliceResourceStates(this.t,u),this.A.clear()}getResourceGroup(u){return this.e.get(u)}setSelectionState(u){this.q=u,this.s.fire(u)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(u=>u.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,f.$6g)(100)],h.prototype,"eventuallyAddResourceGroups",null),Ke([(0,f.$6g)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(u,l,w,A){this.l=l,this.m=w,this.n=A,this.g=new Map,this.h=new I.$Wl,this.j=new F.$ed,this.e=u.getProxy(m.$TJ.MainThreadSCM),this.f=u.getProxy(m.$TJ.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const N=this.g.get(O.sourceControlHandle);if(!N)return O;const T=N.getResourceGroup(O.groupHandle);return T?T.getResourceState(O.handle):O}else if(O&&O.$mid===4){const N=this.g.get(O.sourceControlHandle);return N?N.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const N=this.g.get(O.handle);return N||O}return O}})}createSourceControl(u,l,w,A){this.n.trace("ExtHostSCM#createSourceControl",u.identifier.value,l,w,A),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const O=r.d++,N=new h(u,this.m,this.e,this.l,l,w,A);this.g.set(O,N);const T=this.h.get(u.identifier)||[];return T.push(N),this.h.set(u.identifier,T),N}getLastInputBox(u){this.n.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const l=this.h.get(u.identifier),w=l&&l[l.length-1];return w&&w.inputBox}$provideOriginalResource(u,l,w){const A=C.URI.revive(l);this.n.trace("ExtHostSCM#$provideOriginalResource",u,A.toString());const O=this.g.get(u);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$yg)(()=>O.quickDiffProvider.provideOriginalResource(A,w)).then(N=>N||null)}$onInputBoxValueChange(u,l){this.n.trace("ExtHostSCM#$onInputBoxValueChange",u);const w=this.g.get(u);return w&&w.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(u,l,w,A){this.n.trace("ExtHostSCM#$executeResourceCommand",u,l,w);const O=this.g.get(u);if(!O)return Promise.resolve(void 0);const N=O.getResourceGroup(l);return N?N.$executeResourceCommand(w,A):Promise.resolve(void 0)}$validateInput(u,l,w){this.n.trace("ExtHostSCM#$validateInput",u);const A=this.g.get(u);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,R.$yg)(()=>A.inputBox.validateInput(l,w)).then(O=>{if(!O)return Promise.resolve(void 0);const N=k.MarkdownString.fromStrict(O.message);return N?Promise.resolve([N,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this.g.get(u)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=u,Promise.resolve(void 0)}};e.$Gbc=E,e.$Gbc=E=r=Ke([Be(3,P.$4i)],E)}),define(De[114],Ce([1,0,6,4,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=e.$lbc=void 0;class L{constructor(m){this.b=new F.$ed,this.onDidChangePassword=this.b.event,this.a=m.getProxy(C.$TJ.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,S){return this.a.$getPassword(m,S)}store(m,S,b){return this.a.$setPassword(m,S,b)}delete(m,S){return this.a.$deletePassword(m,S)}}e.$lbc=L,e.$mbc=(0,f.$Ah)("IExtHostSecretState")}),define(De[325],Ce([1,0,6,13,2]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class L{static{this.a=0}constructor(m,S){this.d=S,this.c=new Map,this.b=m.getProxy(C.$TJ.MainThreadShare)}async $provideShare(m,S,b){return await this.c.get(m)?.provideShare({selection:F.Range.to(S.selection),resourceUri:f.URI.revive(S.resourceUri)},b)??void 0}registerShareProvider(m,S){const b=L.a++;return this.c.set(b,S),this.b.$registerShareProvider(b,F.DocumentSelector.from(m,this.d),S.id,S.label,S.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$Icc=L}),define(De[326],Ce([1,0,7,6,209,3,13,18]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=void 0;class S{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$RK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$RK("statusBarItem.warningForeground")]])}#e;#t;constructor(p,k,D,v,r,i=C.StatusBarAlignment.Left,s){if(this.i=!1,this.k="",this.q=new L.$ic,this.#e=p,this.#t=k,r&&v){this.c=(0,C.$uK)(v.identifier,r);const d=D.get(this.c);d&&(i=d.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,s=d.priority,this.j=!0,this.name=d.name,this.text=d.text,this.tooltip=d.tooltip,this.command=d.command,this.accessibilityInformation=d.accessibilityInformation)}else this.c=String(S.a++);this.e=v,this.f=r,this.g=i,this.h=this.u(s)}u(p){if((0,m.$mf)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!S.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new L.$ic,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let k;this.m?k=this.m:k=(0,f.localize)(0,null,this.e.displayName||this.e.name);let D=this.n;this.o&&(D=S.b.get(this.o.id));const v=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,k,this.k,v,this.r?.internal,D,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Hbc=S;class b{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const k={message:p};return this.b.unshift(k),this.c(),new C.$VJ(()=>{const D=this.b.indexOf(k);D>=0&&(this.b.splice(D,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(p,k){this.e=new Map,this.a=p.getProxy(F.$TJ.MainThreadStatusBar),this.b=k,this.c=new b(this)}$acceptStaticEntries(p){for(const k of p)this.e.set(k.entryId,k)}createStatusBarEntry(p,k,D,v){return new S(this.a,this.b,this.e,p,k,D,v)}setStatusBarMessage(p,k){const D=this.c.setMessage(p);let v;return typeof k=="number"?v=setTimeout(()=>D.dispose(),k):typeof k<"u"&&k.then(()=>D.dispose(),()=>D.dispose()),new C.$VJ(()=>{D.dispose(),clearTimeout(v)})}}e.$Ibc=P}),define(De[115],Ce([1,0,6,4,5]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=e.$_ac=void 0;class L{constructor(m,S){this.c=S,this.b=new F.$ed,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(C.$TJ.MainThreadStorage)}registerExtensionStorageKeysToSync(m,S){this.a.$registerExtensionStorageKeysToSync(m,S)}async initializeExtensionStorage(m,S,b){const P=await this.a.$initializeExtensionStorage(m,S);let I;return P&&(I=this.d(m,S,P)),I||b}setValue(m,S,b){return this.a.$setValue(m,S,b)}$acceptValue(m,S,b){const P=this.d(m,S,b);P&&this.b.fire({shared:m,key:S,value:P})}d(m,S,b){try{return JSON.parse(b)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${m}): ${P}`)}}}e.$_ac=L,e.$abc=(0,f.$Ah)("IExtHostStorage")}),define(De[91],Ce([1,0,5,26,14,72,2]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=void 0,e.$fbc=(0,C.$Ah)("IExtensionStoragePaths");let m=class{constructor(b,P,I){this.d=P,this.f=I,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(b){return R.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,P=await this.g(b);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(R.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(b){if(this.c)return R.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return R.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$gbc=m,e.$gbc=m=Ke([Be(0,F.$_L),Be(1,f.$4i),Be(2,L.$ebc)],m)}),define(De[44],Ce([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,60,11,13,33]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=e.$ibc=e.$hbc=void 0,e.$hbc=(0,f.$Ah)("IExtHostTerminalService");class d{constructor(u,l,w,A){this.k=u,this._id=l,this.l=w,this.m=A,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(N=>this.f=N);const O=this;this.value={get name(){return O.m||""},get processId(){return O.b},get creationOptions(){return O.l},get exitStatus(){return O.h},get state(){return O.i},get selection(){return O.j},sendText(N,T=!0){O.o(),O.k.$sendText(O._id,N,T)},show(N){O.o(),O.k.$show(O._id,N)},hide(){O.o(),O.k.$hide(O._id)},dispose(){O.a||(O.a=!0,O.k.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(u,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:c(u.iconPath)??void 0,color:v.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:l?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:l?.useShellEnvironment??void 0,location:l?.location||this.n(u.location,l?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,l,w,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:w,color:v.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.n(u,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(u,l){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.m=u}setExitStatus(u,l){this.h=Object.freeze({code:u,reason:l})}setDimensions(u,l){return u===this.d&&l===this.g||u===0||l===0?!1:(this.d=u,this.g=l,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(u){this.j=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(l=>{l!==u&&(this.b=Promise.resolve(u))})}}e.$ibc=d;class ${get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new C.$ed,this.onProcessData=this.a.event,this.b=new C.$ed,this.d=new C.$ed,this.onDidChangeProperty=this.d.event,this.f=new C.$ed,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,l){this.g.setDimensions?.({columns:u,rows:l})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let g=1,t=class extends m.$jc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,l,w){super(),this.Q=l,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$kc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$ed,this.onDidCloseTerminal=this.H.event,this.I=new C.$ed,this.onDidOpenTerminal=this.I.event,this.J=new C.$ed,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$ed,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$ed,this.onDidChangeTerminalState=this.M.event,this.N=new C.$ed,this.onDidChangeShell=this.N.event,this.O=new C.$ed({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$ed({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(F.$TJ.MainThreadTerminalService),this.y=new D.$Ckb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.B({dispose:()=>{for(const[A,O]of this.g)O.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,l){const w=new d(this.a,(0,k.$3f)(),u,u.name),A=new $(u.pty);return w.createExtensionTerminal(u.location,this.R(u,l).resolvedExtHostIdentifier,c(u.iconPath),h(u.color)).then(O=>{const N=this.S(O,A);this.h[O]=N}),this.f.push(w),w.value}R(u,l){if(l=l||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const w=u.location.parentTerminal;if(w){const A=this.f.find(O=>O.value===w);A&&(l.resolvedExtHostIdentifier=A._id)}}else u.location&&typeof u.location!="object"?l.location=u.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(u,l){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const A=new $(l),O=this.S(u,A);this.h[u]=O}async $acceptActiveTerminalChanged(u){const l=this.b;if(u===null){this.b=void 0,l!==this.b&&this.J.fire(this.b);return}const w=this.W(u);w&&(this.b=w,l!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,l){const w=this.W(u);w&&this.O.fire({terminal:w.value,data:l})}async $acceptTerminalDimensions(u,l,w){const A=this.W(u);A&&A.setDimensions(l,w)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(u,l){const w=this.W(u);w&&this.P.fire({terminal:w.value,...l})}async $acceptTerminalMaximumDimensions(u,l,w){this.g.get(u)?.resize(l,w)}async $acceptTerminalTitleChange(u,l){const w=this.W(u);w&&(w.name=l)}async $acceptTerminalClosed(u,l,w){const A=this.Y(this.f,u);if(A!==null){const O=this.f.splice(A,1)[0];O.setExitStatus(l,w),this.H.fire(O.value)}}$acceptTerminalOpened(u,l,w,A){if(l){const T=this.Y(this.f,l);if(T!==null){this.f[T]._id=u,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const O={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},N=new d(this.a,u,O,w);this.f.push(N),this.I.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(u,l){this.W(u)?._setProcessId(l)}async $startExtensionTerminal(u,l){const w=this.W(u);if(!w)return{message:(0,b.localize)(0,null,u)};w.isOpen||await new Promise(O=>{const N=this.onDidOpenTerminal(async T=>{T===w.value&&(N.dispose(),O())})});const A=this.g.get(u);A?A.startSendingEvents(l):this.j[u]={initialDimensions:l}}S(u,l){const w=new m.$ic;w.add(l.onProcessReady(O=>this.a.$sendProcessReady(u,O.pid,O.cwd,O.windowsPty))),w.add(l.onDidChangeProperty(O=>this.a.$sendProcessProperty(u,O))),this.y.startBuffering(u,l.onProcessData),w.add(l.onProcessExit(O=>this.U(u,O))),this.g.set(u,l);const A=this.j[u];return A&&l instanceof $&&(l.startSendingEvents(A.initialDimensions),delete this.j[u]),w}$acceptProcessAckDataEvent(u,l){this.g.get(u)?.acknowledgeDataEvent(l)}$acceptProcessInput(u,l){this.g.get(u)?.input(l)}$acceptTerminalInteraction(u){const l=this.W(u);l?.setInteractedWith()&&this.M.fire(l.value)}$acceptTerminalSelection(u,l){this.W(u)?.setSelection(l)}$acceptProcessResize(u,l,w){try{this.g.get(u)?.resize(l,w)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(u,l){this.g.get(u)?.shutdown(l)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(l=>this.a.$sendProcessProperty(u,{type:"cwd",value:l}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new S.$VJ(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,l,w){if(this.C.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.C.set(l,w),this.a.$registerProfileProvider(l,u.identifier.value),new S.$VJ(()=>{this.C.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(u,l,w){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,w),this.a.$registerQuickFixProvider(u,l),new S.$VJ(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,l){const w=new p.$od().token;if(w.isCancellationRequested)return;const A=this.D.get(u);if(!A)return;const O=await A.provideTerminalQuickFixes(l,w);if(O===null||Array.isArray(O)&&O.length===0)return;const N=new m.$ic;if(this.w.value=N,!Array.isArray(O))return O?i.TerminalQuickFix.from(O,this.Q.converter,N):void 0;const T=[];for(const j of O){const z=i.TerminalQuickFix.from(j,this.Q.converter,N);z&&T.push(z)}return T}async $createContributedProfileTerminal(u,l){const w=new p.$od().token;let A=await this.C.get(u)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,l);return}this.createTerminalFromOptions(A.options,l)}}async $provideLinks(u,l){const w=this.W(u);if(!w)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const O=new p.$od;this.G.set(u,O);const N=[],T={terminal:w.value,line:l},j=[];for(const H of this.z)j.push(r.Promises.withAsyncBody(async q=>{O.token.onCancellationRequested(()=>q({provider:H,links:[]}));const me=await H.provideTerminalLinks(T,O.token)||[];O.token.isCancellationRequested||q({provider:H,links:me})}));const z=await Promise.all(j);if(O.token.isCancellationRequested)return[];const M=new Map;for(const H of z)H&&H.links.length>0&&N.push(...H.links.map(q=>{const me={id:g++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return M.set(me.id,{provider:H.provider,link:q}),me}));return this.F.set(u,M),N}$activateLink(u,l){const w=this.F.get(u)?.get(l);w&&w.provider.handleTerminalLink(w.link)}U(u,l){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const w=this.h[u];w&&(w.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,l)}W(u){return this.X(this.f,u)}X(u,l){const w=this.Y(u,l);return w!==null?u[w]:null}Y(u,l){const w=u.findIndex(A=>A._id===l);return w===-1?null:w}getEnvironmentVariableCollection(u){let l=this.n.get(u.identifier.value);return l||(l=new o,this.$(u.identifier.value,l)),l.getScopedEnvironmentVariableCollection(void 0)}Z(u,l){const w=(0,I.$$q)(l.map),A=(0,I.$_q)(l.descriptionMap);this.a.$setEnvironmentVariableCollection(u,l.persistent,w.length===0?void 0:w,A)}$initEnvironmentVariableCollections(u){u.forEach(l=>{const w=l[0],A=new o(l[1]);this.$(w,A)})}$acceptDefaultProfile(u,l){const w=this.s;this.s=u,this.u=l,w?.path!==u.path&&this.N.fire(u.path)}$(u,l){this.n.set(u,l),l.onDidChangeCollection(()=>{this.Z(u,l)})}};e.$jbc=t,e.$jbc=t=Ke([Be(1,s.$fM),Be(2,R.$VL)],t);class o{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$ed,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const l=this.h(u);let w=this.a.get(l);return w||(w=new a(this,u),this.a.set(l,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(u,l,w,A){this.f(u,{value:l,type:S.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:A})}append(u,l,w,A){this.f(u,{value:l,type:S.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:A})}prepend(u,l,w,A){this.f(u,{value:l,type:S.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:A})}f(u,l){if(l.options&&l.options.applyAtProcessCreation===!1&&!l.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(u,l.scope),A=this.map.get(w),O=l.options?{applyAtProcessCreation:l.options.applyAtProcessCreation??!1,applyAtShellIntegration:l.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==l.value||A.type!==l.type||A.options?.applyAtProcessCreation!==O.applyAtProcessCreation||A.options?.applyAtShellIntegration!==O.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index){const N=this.g(u,l.scope),T={variable:u,...l,options:O};this.map.set(N,T),this.d.fire()}}get(u,l){const w=this.g(u,l),A=this.map.get(w);return A?E(A):void 0}g(u,l){const w=this.h(l);return w.length?`${u}:::${w}`:u}h(u){return this.i(u?.workspaceFolder)??""}i(u){return u?u.uri.toString():void 0}getVariableMap(u){const l=new Map;for(const[w,A]of this.map)this.h(A.scope)===this.h(u)&&l.set(A.variable,E(A));return l}delete(u,l){const w=this.g(u,l);this.map.delete(w),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[l,w]of this.map)w.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(l);this.j(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,l){const w=this.h(l),A=this.descriptionMap.get(w);if(!A||A.description!==u){let O;typeof u=="string"?O=u:O=u?.value.split(`

`)[0];const N={description:O,scope:l};this.descriptionMap.set(w,N),this.d.fire()}}getDescription(u){const l=this.h(u);return this.descriptionMap.get(l)?.description}j(u){const l=this.h(u);this.descriptionMap.delete(l)}}class a{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,l){this.b=u,this.d=l,this.a=new C.$ed}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,l,w){this.b.replace(u,l,w,this.d)}append(u,l,w){this.b.append(u,l,w,this.d)}prepend(u,l,w){this.b.prepend(u,l,w,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,l){this.b.getVariableMap(this.d).forEach((w,A)=>u.call(l,A,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let n=class extends t{constructor(u,l){super(!1,u,l)}createTerminal(u,l,w){throw new P.$0}createTerminalFromOptions(u,l){throw new P.$0}};e.$kbc=n,e.$kbc=n=Ke([Be(0,s.$fM),Be(1,R.$VL)],n);function c(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function h(y){return v.ThemeColor.isThemeColor(y)?y:void 0}function E(y){const u={...y};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(De[327],Ce([1,0,118,11,22,21,4,74,51,3,23,18,31,6,20,145,13,7,68,109,88,27]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=e.$scc=e.$rcc=void 0;let t=class{constructor(T,j,z){this.k=z,this.d=new R.$ed,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=T.getProxy(k.$TJ.MainThreadTesting),this.j=new w(this.g),this.h=new c(this.g),j.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 15:{const H=M,q=H.tests[H.tests.length-1].item.extId;return this.f.get(s.$GI.root(q))?.collection.tree.get(q)?.actual??(0,v.$8L)(M)}case 17:{const{extId:H,message:q}=M;return{test:this.f.get(s.$GI.root(H))?.collection.tree.get(H)?.actual,message:r.TestMessage.to(q)}}default:return M}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await j.executeCommand("_testing.getExplorerSelection"),H=q=>{const me=this.f.get(s.$GI.root(q));if(me)return s.$GI.isRoot(q)?me.controller:me.collection.tree.get(q)?.actual};return{include:M?.include.map(H).filter(I.$qf)||[],exclude:M?.exclude.map(H).filter(I.$qf)||[]}})}createTestController(T,j,z,M){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const H=new b.$ic,q=H.add(new v.$$L(j,z,this.k));q.root.label=z;const me=new Map,x=this.g,Q={items:q.root.children,get label(){return z},set label(_){z=_,q.root.label=_,x.$updateController(j,{label:z})},get refreshHandler(){return M},set refreshHandler(_){M=_,x.$updateController(j,{canRefresh:!!_})},get id(){return j},createRunProfile:(_,ge,ce,we,G,U)=>{let K=(0,S.$oi)(_);for(;me.has(K);)K++;return new A(this.g,me,j,K,_,ge,ce,we,G,U)},createTestItem(_,ge,ce){return new v.$9L(j,_,ge,ce)},createTestRun:(_,ge,ce=!0)=>this.h.createTestRun(T,j,q,_,ge,ce),invalidateTestResults:_=>{if(_===void 0)this.g.$markTestRetired(void 0);else{const ge=_ instanceof Array?_:[_];this.g.$markTestRetired(ge.map(ce=>s.$GI.fromExtHostTestItem(ce,j).toString()))}},set resolveHandler(_){q.resolveHandler=_},get resolveHandler(){return q.resolveHandler},dispose:()=>{H.dispose()}};x.$registerTestController(j,z,!!M),H.add((0,b.$hc)(()=>x.$unregisterTestController(j)));const V={controller:Q,collection:q,profiles:me,extension:T};return this.f.set(j,V),H.add((0,b.$hc)(()=>this.f.delete(j))),H.add(q.onDidGenerateDiff(_=>x.$publishDiff(j,_.map($.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.j.checkout()}async runTests(T,j=L.CancellationToken.None){const z=h(T);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.f.get(z.controllerId);if(!M)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(H=>s.$GI.fromExtHostTestItem(H,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:O[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:T.exclude?.map(H=>H.id)},j)}$syncTests(){for(const{collection:T}of this.f.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,j,z){return(0,C.$pb)(this.h.trackers,H=>H.id===T?H.getCoverage(j):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(T,j,z,M){return(0,C.$pb)(this.h.trackers,q=>q.id===T?q.getCoverage(j):void 0)?.resolveFileCoverage(z,M)??Promise.resolve([])}$configureRunProfile(T,j){this.f.get(T)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(T,j){await this.f.get(T)?.controller.refreshHandler?.(j)}$publishTestResults(T){this.results=Object.freeze(T.map(j=>(0,P.$Vm)(r.TestResults.to(j))).concat(this.results).sort((j,z)=>z.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(T,j){const z=this.f.get(s.$GI.fromString(T).controllerId)?.collection;z&&(await z.expand(T,j<0?1/0:j),z.flushDiff())}$acceptDiff(T){this.j.applyDiff(T.map($.TestsDiffOp.deserialize))}async $runControllerTests(T,j){return Promise.all(T.map(z=>this.l(z,!1,j)))}async $startContinuousRun(T,j){const z=new L.$od(j),M=await Promise.all(T.map(H=>this.l(H,!0,z.token)));return!j.isCancellationRequested&&!M.some(H=>H.error)&&await new Promise(H=>j.onCancellationRequested(H)),z.dispose(!0),M}async l(T,j,z){const M=this.f.get(T.controllerId);if(!M)return{};const{collection:H,profiles:q,extension:me}=M,x=q.get(T.profileId);if(!x)return{};const Q=T.testIds.map(ce=>H.tree.get(ce)).filter(I.$qf),V=T.excludeExtIds.map(ce=>M.collection.tree.get(ce)).filter(I.$qf).filter(ce=>Q.some(we=>we.fullId.compare(ce.fullId)===2));if(!Q.length)return{};const _=new i.$sL(Q.some(ce=>ce.actual instanceof v.$0L)?void 0:Q.map(ce=>ce.actual),V.map(ce=>ce.actual),x,j),ge=(0,$.$II)(T)&&this.h.prepareForMainThreadTestRun(_,E.fromInternal(T,M.collection),me,z);try{return await x.runHandler(_,z),{}}catch(ce){return{error:String(ce)}}finally{ge&&(ge.hasRunningTasks&&!z.isCancellationRequested&&await R.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.h.cancelAllRuns():this.h.cancelRunById(T)}};e.$rcc=t,e.$rcc=t=Ke([Be(0,D.$VL)],t);const o=1e4;var a;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(a||(a={}));class n extends b.$jc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(T,j,z,M){super(),this.s=T,this.u=j,this.w=z,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$ed),this.onEnd=this.m.event,this.j=this.B(new L.$od(M));const H=this.B(new F.$Rg(()=>this.y(),o));this.B(this.j.token.onCancellationRequested(()=>H.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(T){return this.g.get(T)?.coverage}createRun(T){const j=this.s.id,z=this.s.controllerId,M=(0,p.$3f)(),H=new y(this.u,j,M),q=V=>(_,...ge)=>{if(x){console.warn(`Setting the state of test "${_.id}" is a no-op after the run ends.`);return}this.s.isIncluded(_)&&(this.C(_),V(_,...ge))},me=(V,_)=>{const ge=_ instanceof Array?_.map(r.TestMessage.from):[r.TestMessage.from(_)];if(ge.some(ce=>ce.contextValue!==void 0)&&(0,g.$NF)(this.w,"testMessageContextValue"),V.uri&&V.range){const ce={range:r.Range.from(V.range),uri:V.uri};for(const we of ge)we.location=we.location||ce}this.u.$appendTestMessagesInRun(j,M,s.$GI.fromExtHostTestItem(V,z).toString(),ge)};let x=!1;const Q={isPersisted:this.s.isPersisted,token:this.j.token,name:T,get coverageProvider(){return H.coverageProvider},set coverageProvider(V){H.coverageProvider=V},enqueued:q(V=>{this.u.$updateTestStateInRun(j,M,s.$GI.fromExtHostTestItem(V,z).toString(),1)}),skipped:q(V=>{this.u.$updateTestStateInRun(j,M,s.$GI.fromExtHostTestItem(V,z).toString(),5)}),started:q(V=>{this.u.$updateTestStateInRun(j,M,s.$GI.fromExtHostTestItem(V,z).toString(),2)}),errored:q((V,_,ge)=>{me(V,_),this.u.$updateTestStateInRun(j,M,s.$GI.fromExtHostTestItem(V,z).toString(),6,ge)}),failed:q((V,_,ge)=>{me(V,_),this.u.$updateTestStateInRun(j,M,s.$GI.fromExtHostTestItem(V,z).toString(),4,ge)}),passed:q((V,_)=>{this.u.$updateTestStateInRun(j,M,s.$GI.fromExtHostTestItem(V,this.s.controllerId).toString(),3,_)}),appendOutput:(V,_,ge)=>{x||(ge&&(this.s.isIncluded(ge)?this.C(ge):ge=void 0),this.u.$appendOutputToRun(j,M,f.$Ed.fromString(V),_&&r.location.from(_),ge&&s.$GI.fromExtHostTestItem(ge,z).toString()))},end:()=>{x||(x=!0,this.u.$finishedTestRunTask(j,M),this.g.delete(M),this.g.size||this.z())}};return this.g.set(M,{run:Q,coverage:H}),this.u.$startedTestRunTask(j,{id:M,name:T,running:!0}),Q}y(){for(const{run:T}of this.g.values())T.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(T){if(!(T instanceof v.$9L))throw new d.$NL(T.id);if(this.h.has(s.$GI.fromExtHostTestItem(T,this.s.controllerId).toString()))return;const j=[],z=this.s.colllection.root;for(;;){const M=r.TestItem.from(T);if(j.unshift(M),this.h.has(M.extId)||(this.h.add(M.extId),T===z))break;T=T.parent||z}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class c{get trackers(){return this.d.values()}constructor(T){this.f=T,this.d=new Map}prepareForMainThreadTestRun(T,j,z,M){return this.g(T,j,z,M)}cancelRunById(T){for(const j of this.d.values())if(j.id===T){j.cancel();return}}cancelAllRuns(){for(const T of this.d.values())T.cancel()}createTestRun(T,j,z,M,H,q){const me=this.d.get(M);if(me)return me.createRun(H);const x=E.fromPublic(j,z,M,q),Q=h(M);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!M.continuous,profile:Q&&{group:O[Q.kind],id:Q.profileId},exclude:M.exclude?.map(_=>s.$GI.fromExtHostTestItem(_,z.root.id).toString())??[],id:x.id,include:M.include?.map(_=>s.$GI.fromExtHostTestItem(_,z.root.id).toString())??[z.root.id],persist:q});const V=this.g(M,x,T);return R.Event.once(V.onEnd)(()=>{this.f.$finishedExtensionTestRun(x.id),V.dispose()}),V.createRun(H)}g(T,j,z,M){const H=new n(j,this.f,z,M);return this.d.set(T,H),R.Event.once(H.onEnd)(()=>this.d.delete(T)),H}}e.$scc=c;const h=N=>{if(N.profile){if(!(N.profile instanceof A))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class E{static fromPublic(T,j,z,M){return new E(T,(0,p.$3f)(),z.include?.map(H=>s.$GI.fromExtHostTestItem(H,T).toString())??[T],z.exclude?.map(H=>s.$GI.fromExtHostTestItem(H,T).toString())??[],M,j)}static fromInternal(T,j){return new E(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,j)}constructor(T,j,z,M,H,q){this.controllerId=T,this.id=j,this.isPersisted=H,this.colllection=q,this.d=z.map(me=>me+"\0"),this.f=M.map(me=>me+"\0")}isIncluded(T){const j=s.$GI.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const z of this.f)if(j===z||j.startsWith(z))return!1;for(const z of this.d)if(j===z||j.startsWith(z))return!0;return!1}}e.$tcc=E;class y{set coverageProvider(T){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");T&&(this.d=T,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(T,j,z){this.g=T,this.h=j,this.j=z}async provideFileCoverage(T){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(T))());try{return(await this.f)?.map(r.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(T,j){const z=await this.f;let M=z?.[T];return!this.d||!z||!M?[]:(M.detailedCoverage||(M=z[T]=await this.d.resolveFileCoverage?.(M,j)??M),M.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.d.add(T)}update(T){Object.assign(T.revived,r.TestItem.toPlain(T.item)),this.d.has(T)||this.f.add(T)}remove(T){if(this.d.has(T)){this.d.delete(T);return}this.f.delete(T);const j=s.$GI.parentId(T.item.extId);if(j&&this.h.has(j.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{d:T,f:j,g:z}=this;return{get added(){return[...T].map(M=>M.revived)},get updated(){return[...j].map(M=>M.revived)},get removed(){return[...z].map(M=>M.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class l extends $.$NI{constructor(){super(...arguments),this.s=new R.$ed,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}q(T,j){return{...T,revived:r.TestItem.toPlain(T.item),depth:j?j.depth+1:0,children:new Set}}p(){return new u(this.s)}}class w{constructor(T){this.f=T}checkout(){this.d||(this.d=this.g());const T=this.d;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(j=>j.revived)},dispose:(0,m.$bb)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(T){return this.d?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.d?.tests.apply(T)}g(){const T=new l;return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}class A{#e;#t;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(T){T!==this.h&&(this.h=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.g}set isDefault(T){T!==this.g&&(this.g=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?r.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.d}set configureHandler(T){T!==this.d&&(this.d=T,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,j,z,M,H,q,me,x=!1,Q=void 0,V=!1){this.controllerId=z,this.profileId=M,this.f=H,this.kind=q,this.runHandler=me,this.g=x,this._tag=Q,this.h=V,this.#e=T,this.#t=j,j.set(M,this);const _=O[q];if(typeof _!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);this.#e.$publishTestRunProfile({profileId:M,controllerId:z,tag:Q?r.TestTag.namespace(this.controllerId,Q.id):null,label:H,group:_,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:V})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$ucc=A;const O={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(De[328],Ce([1,0,19,8,4,6,146,13,7]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class b{constructor(I,p){this.i=p,this.a=new f.$ed({onListenerError:F.$Z}),this.b=new f.$ed({onListenerError:F.$Z}),this.c=new f.$ed({onListenerError:F.$Z}),this.d=new f.$ed({onListenerError:F.$Z}),this.f=new f.$ed({onListenerError:F.$Z}),this.g=new f.$ed({onListenerError:F.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$TJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(k=>this.g.fire(k)),this.i.onDidChangeActiveTextEditor(k=>this.f.fire(k))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const p=this.i.allEditors();return I?p:p.map(k=>k.value)}async showTextDocument(I,p,k){let D;typeof p=="number"?D={position:m.ViewColumn.from(p),preserveFocus:k}:typeof p=="object"?D={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?m.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:D={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(I.uri,D),r=v&&this.i.getEditor(v);if(r)return r.value;throw v?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,p){return new R.$3L(this.h,I,p).value}$acceptEditorPropertiesChanged(I,p){const k=this.i.getEditor(I);if(!k)throw new Error("unknown text editor");if(p.options&&k._acceptOptions(p.options),p.selections){const D=p.selections.selections.map(m.Selection.to);k._acceptSelections(D)}if(p.visibleRanges){const D=C.$Eb(p.visibleRanges.map(m.Range.to));k._acceptVisibleRanges(D)}if(p.options&&this.b.fire({textEditor:k.value,options:{...p.options,lineNumbers:m.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const D=S.TextEditorSelectionChangeKind.fromValue(p.selections.source),v=p.selections.selections.map(m.Selection.to);this.a.fire({textEditor:k.value,selections:v,kind:D})}if(p.visibleRanges){const D=C.$Eb(p.visibleRanges.map(m.Range.to));this.c.fire({textEditor:k.value,visibleRanges:D})}}$acceptEditorPositionData(I){for(const p in I){const k=this.i.getEditor(p);if(!k)throw new Error("Unknown text editor");const D=m.ViewColumn.to(I[p]);k.value.viewColumn!==D&&(k._acceptViewColumn(D),this.d.fire({textEditor:k.value,viewColumn:D}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$Jbc=b}),define(De[329],Ce([1,0,2,5,6,3,7,13,25,18]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0,e.$lcc=(0,F.$Ah)("IExtHostTimeline");class P{constructor(k,D){this.b=new Map,this.c=new Map,this.a=k.getProxy(f.$TJ.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(v,r)=>{if(v&&v.$mid===12)if(this.b.get(v.source)&&S.$Ul.equals(r,this.b.get(v.source)?.extension)){const i=v.uri===void 0?void 0:C.URI.revive(v.uri);return this.c.get(v.source)?.get(I(i))?.get(v.handle)}else return;return v}})}async $getTimeline(k,D,v,r){return this.b.get(k)?.provider.provideTimeline(C.URI.revive(D),v,r)}registerTimelineProvider(k,D,v,r){const i=new L.$ic,s=this.d(D.id,r,i).bind(this);let d;D.onDidChange&&(d=D.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:D.id}),this));const $=this.c;return this.f({...D,scheme:k,onDidChange:void 0,async provideTimeline(g,t,o){t?.resetCache&&(i.clear(),$.get(D.id)?.clear());const a=await D.provideTimeline(g,t,o);if(a==null)return;const n=s(g,t);return{...a,source:D.id,items:a.items.map(n)}},dispose(){for(const g of $.values())g.get(D.id)?.clear();d?.dispose(),i.dispose()}},v)}d(k,D,v){return(r,i)=>{let s;if(i?.cacheResults){let d=this.c.get(k);d===void 0&&(d=new Map,this.c.set(k,d));const $=I(r);s=d.get($),s===void 0&&(s=new Map,d.set($,s))}return d=>{const{iconPath:$,...g}=d,t=`${k}|${d.id??d.timestamp}`;s?.set(t,d);let o,a,n;d.iconPath&&($ instanceof R.$QK?n={id:$.id,color:$.color}:C.URI.isUri($)?(o=$,a=$):{light:o,dark:a}=$);let c;return R.$kK.isMarkdownString(g.tooltip)?c=m.MarkdownString.from(g.tooltip):(0,b.$if)(g.tooltip)?c=g.tooltip:R.$kK.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=m.MarkdownString.from(g.detail)):(0,b.$if)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=g.detail),{...g,id:g.id??void 0,handle:t,source:k,command:d.command?D.toInternal(d.command,v):void 0,icon:o,iconDark:a,themeIcon:n,tooltip:c,accessibilityInformation:d.accessibilityInformation}}}}f(k,D){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:D}),(0,L.$hc)(()=>{for(const r of this.c.values())r.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$mcc=P;function I(p){return p?.toString()}}),define(De[73],Ce([1,0,21,4,3,213,5,14,86,6,26,20,7]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsb=e.$csb=e.TunnelDtoConverter=void 0;class k extends S.$3z{}var D;(function(r){function i(d){return{remoteAddress:d.remoteAddress,localAddress:d.localAddress,public:!!d.public,privacy:d.privacy??(d.public?S.TunnelPrivacyId.Public:S.TunnelPrivacyId.Private),protocol:d.protocol}}r.fromApiTunnel=i;function s(d){return{remoteAddress:{host:d.tunnelRemoteHost,port:d.tunnelRemotePort},localAddress:d.localAddress,public:d.privacy!==S.TunnelPrivacyId.ConstantPrivate&&d.privacy!==S.TunnelPrivacyId.ConstantPrivate,privacy:d.privacy,protocol:d.protocol}}r.fromServiceTunnel=s})(D||(e.TunnelDtoConverter=D={})),e.$csb=(0,R.$Ah)("IExtHostTunnelService");let v=class extends f.$jc{constructor(i,s,d){super(),this.s=d,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$ed,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(b.$TJ.MainThreadTunnelService)}async openTunnel(i,s){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${s.remoteAddress.host}:${s.remoteAddress.port}.`);const d=await this.a.$openTunnel(s,i.displayName);if(d){const $=new k(d.remoteAddress,d.localAddress,()=>this.a.$closeTunnel(d.remoteAddress));return this.B($),$}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,s){const d=this.u();return this.r.set(d,{selector:i,provider:s}),this.a.$registerPortsAttributesProvider(i,d),new p.$VJ(()=>{this.r.delete(d),this.a.$unregisterPortsAttributesProvider(d)})}async $providePortAttributes(i,s,d,$,g){const t=[];for(const a of i){const n=this.r.get(a);if(!n)return[];t.push(...await Promise.all(s.map(async c=>{let h;try{h=await n.provider.providePortAttributes({port:c,pid:d,commandLine:$},g)}catch{h=await n.provider.providePortAttributes(c,d,$,g)}return{providedAttributes:h,port:c}})))}const o=t.filter(a=>!!a.providedAttributes);return o.length>0?o.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,s){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async($,g)=>await i.provideTunnel($,g,new C.$od().token)??void 0;const d=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,privacyOptions:s.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(d),Promise.resolve((0,f.$hc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,s){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const d=i.tunnelFactory??(s?this.w(s):void 0);if(d){this.b=d;let $=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&$.length===0&&($=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const g=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:$}:void 0;this.a.$setTunnelProvider(g)}}else this.b=void 0;return(0,f.$hc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,s){if(this.g.has(i.host)){const d=this.g.get(i.host);d.has(i.port)&&(s&&d.get(i.port).disposeListener.dispose(),await d.get(i.port).tunnel.dispose(),d.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,s){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const d=this.b(i,s);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),d!==void 0){const $=await d;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),$===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const g=this.B($.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel($.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:$,disposeListener:g}),D.fromApiTunnel($)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(d){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),d instanceof Error)return d.message}}async $applyCandidateFilter(i){const s=await Promise.all(i.map($=>this.f($.host,$.port,$.detail??""))),d=i.filter(($,g)=>s[g]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map($=>$.port).join(", ")} to ${d.map($=>$.port).join(", ")}`),d}};e.$dsb=v,e.$dsb=v=Ke([Be(0,I.$VL),Be(1,P.$_L),Be(2,m.$4i)],v)}),define(De[330],Ce([1,0,3,17,2,6]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(S){this.c=new Map,this.b=S.getProxy(L.$TJ.MainThreadUriOpeners)}registerExternalUriOpener(S,b,P,I){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const p=I.schemes.find(k=>!R.a.has(k));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(b,P),this.b.$registerUriOpener(b,I.schemes,S,I.label),(0,C.$hc)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(S,b,P){const I=this.c.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const p=f.URI.revive(b);return I.canOpenExternalUri(p,P)}async $openUri(S,b,P){const I=this.c.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(f.URI.revive(b.resolvedUri),{sourceUri:f.URI.revive(b.sourceUri)},P)}}e.$vcc=R}),define(De[331],Ce([1,0,6,2,3,8,25]),function($e,e,C,F,f,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=void 0;class m{static{this.a=0}constructor(b){this.c=new R.$Vl,this.d=new Map,this.b=b.getProxy(C.$TJ.MainThreadUrls)}registerUriHandler(b,P){const I=b.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=m.a++;return this.c.add(I),this.d.set(p,P),this.b.$registerUriHandler(p,I,b.displayName||b.name),(0,f.$hc)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(b,P){const I=this.d.get(b);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(P))}catch(p){(0,L.$Y)(p)}return Promise.resolve(void 0)}async createAppUri(b){return F.URI.revive(await this.b.$createAppUri(b))}}e.$Lbc=m}),define(De[92],Ce([1,0,4,3,17,23,2,228,265,110,6]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=e.$Obc=e.$Nbc=e.$Mbc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor($,g,t,o,a,n,c){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$ed,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$ed,this._onDidDispose=this.#h.event,this.#e=$,this.#t=g,this.#r=t,this.#l=o,this.#u=a,this.#n=n,this.#c=p(n),this.#d=k(n),this.#i=c}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri($){return this.#a=!0,(0,b.$Kob)($,this.#l)}get cspSource(){const $=this.#n.extensionLocation;if($.scheme===f.Schemas.https||$.scheme===f.Schemas.http){let g=$.toString();return g.endsWith("/")||(g+="/"),g+" "+b.$Job}return b.$Job}get html(){return this.a(),this.#s}set html($){this.a(),this.#s!==$&&(this.#s=$,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test($)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b($)))}get options(){return this.a(),this.#r}set options($){this.a(),L.$Ym(this.#r,$)||this.#t.$setOptions(this.#e,r(this.#n,this.#u,$)),this.#r=$}async postMessage($){if(this.#o)return!1;const g=(0,S.$Xbb)($,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,g.message,...g.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b($){if(!this.#d)return $;const g=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return $.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(o,a,n,c,h,E)=>{const y=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),u=(0,b.$Kob)(y,{isRemote:g,authority:t}).toString();return`${a}${u}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(o,a,n,c,h,E)=>{const y=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),u=(0,b.$Kob)(y,{isRemote:g,authority:t}).toString();return`${a}${u}${E}`})}}e.$Mbc=I;function p(d){try{const $=(0,m.$Co)((0,m.$Bo)(d.engines.vscode));return!!$&&$.majorBase>=1&&$.minorBase>=57}catch{return!1}}e.$Nbc=p;function k(d){try{const $=(0,m.$Co)((0,m.$Bo)(d.engines.vscode));return $?$.majorBase<1||$.majorBase===1&&$.minorBase<60:!1}catch{return!1}}class D extends F.$jc{constructor($,g,t,o,a){super(),this.c=g,this.f=t,this.g=o,this.h=a,this.b=new Map,this.a=$.getProxy(P.$TJ.MainThreadWebviews)}dispose(){super.dispose();for(const $ of this.b.values())$.dispose();this.b.clear()}$onMessage($,g,t){const o=this.j($);if(o){const{message:a}=(0,S.$Ybb)(g,t.value);o._onMessageEmitter.fire(a)}}$onMissingCsp($,g){this.g.warn(`${g} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview($,g,t){const o=new I($,this.a,i(g),this.c,this.f,t,this.h);this.b.set($,o);const a=o._onDidDispose(()=>{a.dispose(),this.deleteWebview($)});return o}deleteWebview($){this.b.delete($)}j($){return this.b.get($)}}e.$Obc=D;function v(d){return{id:d.identifier,location:d.extensionLocation}}e.$Pbc=v;function r(d,$,g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots||s(d,$)}}e.$Qbc=r;function i(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map($=>R.URI.from($))}}function s(d,$){return[...($?.getWorkspaceFolders()||[]).map(g=>g.uri),d.extensionLocation]}}),define(De[332],Ce([1,0,21,51,3,17,24,2,13,92,87,6,7]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class k{constructor(o,a){this.document=o,this.b=a,this.a=1,this.c=new P.$Iac("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,a){await this.f(o).undo(),a||this.disposeBackup()}async redo(o,a){await this.f(o).redo(),a||this.disposeBackup()}disposeEdits(o){for(const a of o)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=g(this.document.uri)+this.a++;return(0,R.$hg)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const a=this.c.get(o,0);if(!a)throw new Error("No edit found");return a}}class D{constructor(){this.a=new Map}get(o,a){return this.a.get(this.b(o,a))}add(o,a,n){const c=this.b(o,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${o} resource:${a.uri}`);const h=new k(a,n);return this.a.set(c,h),h}delete(o,a){const n=this.b(o,a.uri);this.a.delete(n)}b(o,a){return`${o}@@@${a}`}}var v;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(v||(v={}));class r{constructor(){this.a=new Map}addTextProvider(o,a,n){return this.b(0,o,a,n)}addCustomProvider(o,a,n){return this.b(1,o,a,n)}get(o){return this.a.get(o)}b(o,a,n,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:o,extension:n,provider:c}),new p.$VJ(()=>this.a.delete(a))}}class i{constructor(o,a,n,c,h){this.d=a,this.f=n,this.g=c,this.h=h,this.b=new r,this.c=new D,this.a=o.getProxy(I.$TJ.MainThreadCustomEditors)}registerCustomEditorProvider(o,a,n,c){const h=new f.$ic;return d(n)?(h.add(this.b.addTextProvider(a,o,n)),this.a.$registerTextEditorProvider((0,b.$Pbc)(o),a,c.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,b.$Nbc)(o))):(h.add(this.b.addCustomProvider(a,o,n)),s(n)&&h.add(n.onDidChangeCustomDocument(E=>{const y=this.i(a,E.document.uri);if($(E)){const u=y.addEdit(E);this.a.$onDidEdit(E.document.uri,a,u,E.label)}else this.a.$onContentChange(E.document.uri,a)})),this.a.$registerCustomEditorProvider((0,b.$Pbc)(o),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,b.$Nbc)(o))),p.$VJ.from(h,new p.$VJ(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(o,a,n,c,h){const E=this.b.get(a);if(!E)throw new Error(`No provider found for '${a}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=m.URI.revive(o),u=await E.provider.openCustomDocument(y,{backupId:n,untitledDocumentData:c?.buffer},h);let l;return s(E.provider)&&this.f&&(l=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(a,u,l),{editable:s(E.provider)}}async $disposeCustomDocument(o,a){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=m.URI.revive(o),{document:h}=this.i(a,c);this.c.delete(a,h),h.dispose()}async $resolveCustomEditor(o,a,n,c,h,E){const y=this.b.get(n);if(!y)throw new Error(`No provider found for '${n}'`);const u=S.ViewColumn.to(h),l=this.g.createNewWebview(a,c.contentOptions,y.extension),w=this.h.createNewWebviewPanel(a,n,c.title,u,c.options,l,c.active),A=m.URI.revive(o);switch(y.type){case 1:{const{document:O}=this.i(n,A);return y.provider.resolveCustomEditor(O,w,E)}case 0:{const O=this.d.getDocument(A);return y.provider.resolveCustomTextEditor(O,w,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,a,n){this.i(a,o).disposeEdits(n)}async $onMoveCustomEditor(o,a,n){const c=this.b.get(n);if(!c)throw new Error(`No provider found for '${n}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const h=this.h.getWebviewPanel(o);if(!h)throw new Error("No webview found");const E=m.URI.revive(a),y=this.d.getDocument(E);await c.provider.moveCustomTextEditor(y,h,C.CancellationToken.None)}async $undo(o,a,n,c){return this.i(a,o).undo(n,c)}async $redo(o,a,n,c){return this.i(a,o).redo(n,c)}async $revert(o,a,n){const c=this.i(a,o);await this.j(a).revertCustomDocument(c.document,n),c.disposeBackup()}async $onSave(o,a,n){const c=this.i(a,o);await this.j(a).saveCustomDocument(c.document,n),c.disposeBackup()}async $onSaveAs(o,a,n,c){const h=this.i(a,o);return this.j(a).saveCustomDocumentAs(h.document,m.URI.revive(n),c)}async $backup(o,a,n){const c=this.i(a,o),E=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},n);return c.updateBackup(E),E.id}i(o,a){const n=this.c.get(o,m.URI.revive(a));if(!n)throw new Error("No custom document found");return n}j(o){const n=this.b.get(o)?.provider;if(!n||!s(n))throw new Error("Custom document is not editable");return n}}e.$pcc=i;function s(t){return!!t.onDidChangeCustomDocument}function d(t){return typeof t.resolveCustomTextEditor=="function"}function $(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function g(t){const o=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$oi)(o)+""}}),define(De[333],Ce([1,0,4,3,2,31,13,92,6,7]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class P extends F.$jc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(D,v,r,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$ed),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$ed),this.onDidChangeViewState=this.#h.event,this.#e=D,this.#t=v,this.#l=r,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(D){this.c(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.c(),this.#s}set iconPath(D){this.c(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,f.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(D,v){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:R.ViewColumn.from(D),preserveFocus:!!v})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends F.$jc{static c(){return(0,L.$3f)()}constructor(D,v,r){super(),this.j=v,this.m=r,this.g=new Map,this.h=new Map,this.f=D.getProxy(S.$TJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(D=>D.dispose()),this.g.clear()}createWebviewPanel(D,v,r,i,s={}){const d=typeof i=="object"?i.viewColumn:i,$={viewColumn:R.ViewColumn.from(d),preserveFocus:typeof i=="object"&&!!i.preserveFocus},g=(0,m.$Nbc)(D),t=I.c();this.f.$createWebviewPanel((0,m.$Pbc)(D),t,v,{title:r,panelOptions:p(s),webviewOptions:(0,m.$Qbc)(D,this.m,s),serializeBuffersForPostMessage:g},$);const o=this.j.createNewWebview(t,s,D);return this.createNewWebviewPanel(t,v,r,d,s,o,!0)}$onDidChangeWebviewPanelViewStates(D){const v=Object.keys(D);v.sort((r,i)=>{const s=D[r],d=D[i];return s.active?1:d.active?-1:+s.visible-+d.visible});for(const r of v){const i=this.getWebviewPanel(r);if(!i)continue;const s=D[r];i._updateViewState({active:s.active,visible:s.visible,viewColumn:R.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.g.delete(D),this.j.deleteWebview(D)}registerWebviewPanelSerializer(D,v,r){if(this.h.has(v))throw new Error(`Serializer for '${v}' already registered`);return this.h.set(v,{serializer:r,extension:D}),this.f.$registerSerializer(v,{serializeBuffersForPostMessage:(0,m.$Nbc)(D)}),new b.$VJ(()=>{this.h.delete(v),this.f.$unregisterSerializer(v)})}async $deserializeWebviewPanel(D,v,r,i){const s=this.h.get(v);if(!s)throw new Error(`No serializer found for '${v}'`);const{serializer:d,extension:$}=s,g=this.j.createNewWebview(D,r.webviewOptions,$),t=this.createNewWebviewPanel(D,v,r.title,i,r.panelOptions,g,r.active);await d.deserializeWebviewPanel(t,r.state)}createNewWebviewPanel(D,v,r,i,s,d,$){const g=new P(D,this.f,d,{viewType:v,title:r,viewColumn:i,panelOptions:s,active:$});return this.g.set(D,g),g}getWebviewPanel(D){return this.g.get(D)}}e.$occ=I;function p(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(De[334],Ce([1,0,4,3,92,13,6,7]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class S extends F.$jc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,p,k,D,v,r){super(),this.#u=!1,this.#a=this.B(new C.$ed),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$ed),this.onDidDispose=this.#c.event,this.#i=k,this.#s=D,this.#e=I,this.#t=p,this.#l=v,this.#n=r}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class b{constructor(I,p){this.d=p,this.b=new Map,this.c=new Map,this.a=I.getProxy(R.$TJ.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,k,D){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:k,extension:I}),this.a.$registerWebviewViewProvider((0,f.$Pbc)(I),p,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$Nbc)(I)}),new m.$VJ(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,k,D,v){const r=this.b.get(p);if(!r)throw new Error(`No view provider found for '${p}'`);const{provider:i,extension:s}=r,d=this.d.createNewWebview(I,{},s),$=new S(I,this.a,p,k,d,!0);this.c.set(I,$),await i.resolveWebviewView($,{state:D},v)}async $onDidChangeWebviewViewVisibility(I,p){this.e(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.e(I);this.c.delete(I),p.dispose(),this.d.deleteWebview(I)}e(I){const p=this.c.get(I);if(!p)throw new Error("No webview found");return p}}e.$ncc=b}),define(De[151],Ce([1,0,4,6,2,17,15,5,20,27]),function($e,e,C,F,f,L,R,m,S,b){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=e.$Rbc=void 0;let I=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(k){const D=this.d;return{get focused(){return D.focused},get active(){return(0,b.$NF)(k,"windowActivity"),D.active}}}constructor(k){this.c=new C.$ed,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=k.getProxy(F.$TJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:v})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,D){D!==this.d[k]&&(this.d={...this.d,[k]:D},this.c.fire(this.d))}openUri(k,D){let v;if(typeof k=="string"){v=k;try{k=f.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,R.$le)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,v,D)}async asExternalUri(k,D){if((0,R.$le)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(k,D);return f.URI.from(v)}};e.$Rbc=I,e.$Rbc=I=P=Ke([Be(0,S.$VL)],I),e.$Sbc=(0,m.$Ah)("IExtHostWindow")}),define(De[335],Ce([1,0,303,26,20]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;const L=1024*1024;let R=class extends C.$Qcc{constructor(S,b){super(S,b),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,b,P){const I=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),b.apply(console,P),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,b){const P=process[S],I=P.write;let p="";Object.defineProperty(P,"write",{set:()=>{},get:()=>(k,D,v)=>{if(!this.g){p+=k.toString(D);const r=p.length>L?p.length:p.lastIndexOf(`
`);r!==-1&&(console[b](p.slice(0,r)),p=p.slice(r+1))}I.call(P,k,D,v)}})}};e.$pdc=R,e.$pdc=R=Ke([Be(0,f.$VL),Be(1,F.$_L)],R)}),define(De[336],Ce([1,0,72,17,14,240,30,12]),function($e,e,C,F,f,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;let S=class{constructor(I,p){I.addFileSystemProvider(F.Schemas.file,new b(p),{isCaseSensitive:m.$k})}};e.$qdc=S,e.$qdc=S=Ke([Be(0,C.$ebc),Be(1,f.$4i)],S);class b{constructor(I){this.b=I,this.a=new L.$1p(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,k){return this.a.writeFile(I,p,{...k,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,k){return this.a.rename(I,p,k)}copy(I,p,k){return this.a.copy(I,p,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(De[337],Ce([1,0,16,64,31,33,3,6,2,20]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;let P=class extends R.$jc{constructor(p,k){super();const D=p.getProxy(m.$TJ.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async v=>{const r=S.URI.file((0,C.$8d)((0,F.tmpdir)(),(0,f.$3f)()));return await D.$download(v,r),r})}};e.$odc=P,e.$odc=P=Ke([Be(0,b.$VL),Be(1,L.$fM)],P)}),define(De[338],Ce([1,0,150,17,242,31]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class R extends C.$Pcc{s(S,b,P){return S.scheme===F.Schemas.file?new f.$8M(P?.name||(0,L.$3f)(),S.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,b):super.s(S,b,P)}registerLogger(S){super.registerLogger(S),this.r.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this.r.$deregisterLogger(S)}}e.$Bdc=R}),define(De[339],Ce([1,0,52,16,2,91,3,17,11,29]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class P extends L.$gbc{constructor(){super(...arguments),this.i=null}async g(t){const o=await super.g(t);if(o.scheme!==m.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const a=o.fsPath;let n=0;do{let c;n===0?c=a:c=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${n}`:`${a}-${n}`,await I(c);const h=F.$8d(c,"vscode.lock"),E=await v(this.d,h,!1);if(E)return this.i=E,process.on("exit",()=>{E.dispose()}),f.URI.file(c);n++}while(n<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Adc=P;async function I(g){try{await b.Promises.stat(g);return}catch{}try{await b.Promises.mkdir(g,{recursive:!0})}catch{}}const p=1e3,k=10*60*1e3;class D extends R.$jc{constructor(t,o){super(),this.b=t,this.c=o,this.a=this.B(new S.$Qg),this.a.cancelAndSet(async()=>{const a=await r(t,o);(!a||a.pid!==process.pid)&&(t.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await b.Promises.utimes(o,new Date,new Date)}catch(n){t.error(n),t.info(`Lock '${o}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+t};await b.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function v(g,t,o){try{const n={pid:process.pid,willReleaseAt:0};await b.Promises.writeFile(t,JSON.stringify(n),{flag:"wx"})}catch(n){g.error(n)}const a=await r(g,t);return!a||a.pid!==process.pid?o?(g.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),d(g,t)):(g.info(`Lock '${t}': Lock acquired.`),new D(g,t))}async function r(g,t){let o;try{o=await b.Promises.readFile(t)}catch(a){return g.error(a),null}try{return JSON.parse(String(o))}catch(a){return g.error(a),null}}async function i(g,t){let o;try{o=await b.Promises.stat(t)}catch(a){return g.error(a),0}return o.mtime.getTime()}function s(g){try{return process.kill(g,0),!0}catch{return!1}}async function d(g,t){const o=await r(g,t);if(!o)return g.info(`Lock '${t}': Could not read pid of lock holder.`),$(g,t);if(o.willReleaseAt){let E=o.willReleaseAt-Date.now();if(E<5e3){for(E>0?g.info(`Lock '${t}': The lockfile is scheduled to be released in ${E} ms.`):g.info(`Lock '${t}': The lockfile is scheduled to have been released.`);E>0;){if(await(0,S.$Gg)(Math.min(100,E)),await i(g,t)===0)return $(g,t);E=o.willReleaseAt-Date.now()}return $(g,t)}}if(!s(o.pid))return g.info(`Lock '${t}': The pid ${o.pid} appears to be gone.`),$(g,t);const a=await i(g,t),n=Date.now()-a;if(n<=k)return g.info(`Lock '${t}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;g.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,S.$Gg)(2e3);const c=await i(g,t),h=Date.now()-c;return h<=k?(g.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(g.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),$(g,t))}async function $(g,t){g.info(`Lock '${t}': Deleting a stale lock.`);try{await b.Promises.unlink(t)}catch{}return v(g,t,!0)}}),define(De[340],Ce([1,0,31,20,44,33]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;let R=class extends f.$jbc{constructor(S,b){super(!0,S,b)}createTerminal(S,b,P){return this.createTerminalFromOptions({name:S,shellPath:b,shellArgs:P})}createTerminalFromOptions(S,b){const P=new f.$ibc(this.a,(0,C.$3f)(),S,S.name);return this.f.push(P),P.create(S,this.R(S,b)),P.value}};e.$Vcc=R,e.$Vcc=R=Ke([Be(0,L.$fM),Be(1,F.$VL)],R)}),define(De[341],Ce([1,0,11,22,21,8,4,3,128,292,69]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$l3b=e.ResponsiveState=e.RequestInitiator=e.$k3b=e.$j3b=void 0;function p(w,A){try{return JSON.stringify(w,A)}catch{return"null"}}const k="$$ref$$",D={[k]:-1};class v{constructor(A,O){this.jsonString=A,this.referencedBuffers=O}}function r(w,A=null,O=!1){const N=[];return{jsonString:(O?p:JSON.stringify)(w,(j,z)=>{if(typeof z>"u")return D;if(typeof z=="object"){if(z instanceof F.$Ed){const M=N.push(z)-1;return{[k]:M}}if(A)return A(j,z)}return z}),referencedBuffers:N}}e.$j3b=r;function i(w,A,O){return JSON.parse(w,(N,T)=>{if(T){const j=T[k];if(typeof j=="number")return A[j];if(O&&T.$mid===1)return O.transformIncoming(T)}return T})}e.$k3b=i;function s(w,A){return JSON.stringify(w,A)}function d(w){return w?(A,O)=>O&&O.$mid===1?w.transformOutgoing(O):O:null}var $;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));var g;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(g||(e.ResponsiveState=g={}));const t=()=>{},o=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class n extends m.$jc{static{I=o}static{this.a=3*1e3}constructor(A,O=null,N=null){super(),this[I]=!0,this.b=this.B(new R.$ed),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=O,this.g=N,this.h=d(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,j=P.$0z.count;T<j;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$Rg(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const O=this.w[A];delete this.w[A],O.resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+n.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+n.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,S.$Dm)(A,this.g):A}getProxy(A){const{nid:O,sid:N}=A;return this.s[O]||(this.s[O]=this.J(O,N)),this.s[O]}J(A,O){const N={get:(T,j)=>(typeof j=="string"&&!T[j]&&j.charCodeAt(0)===36&&(T[j]=(...z)=>this.U(A,j,z)),j===a?O:T[j])};return new Proxy(Object.create(null),N)}set(A,O){return this.m[A.nid]=O,O}assertRegistered(A){for(let O=0,N=A.length;O<N;O++){const T=A[O];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(A){if(this.j)return;const O=A.byteLength,N=h.read(A,0),T=N.readUInt8(),j=N.readUInt32();switch(T){case 1:case 2:{let{rpcId:z,method:M,args:H}=y.deserializeRequestJSONArgs(N);this.g&&(H=(0,S.$Dm)(H,this.g)),this.M(O,j,z,M,H,T===2);break}case 3:case 4:{let{rpcId:z,method:M,args:H}=y.deserializeRequestMixedArgs(N);this.g&&(H=(0,S.$Dm)(H,this.g)),this.M(O,j,z,M,H,T===4);break}case 5:{this.f?.logIncoming(O,j,0,"ack"),this.G(j);break}case 6:{this.N(O,j);break}case 7:{this.O(O,j,void 0);break}case 9:{let z=y.deserializeReplyOKJSON(N);this.g&&(z=(0,S.$Dm)(z,this.g)),this.O(O,j,z);break}case 10:{const z=y.deserializeReplyOKJSONWithBuffers(N,this.g);this.O(O,j,z);break}case 8:{const z=y.deserializeReplyOKVSBuffer(N);this.O(O,j,z);break}case 11:{let z=y.deserializeReplyErrError(N);this.g&&(z=(0,S.$Dm)(z,this.g)),this.P(O,j,z);break}case 12:{this.P(O,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,O,N,T,j,z){this.f?.logIncoming(A,O,1,`receiveRequest ${(0,P.$_z)(N)}.${T}(`,j);const M=String(O);let H,q;if(z){const x=new f.$od;j.push(x.token),H=this.Q(N,T,j),q=()=>x.cancel()}else H=this.Q(N,T,j),q=t;this.u[M]=q;const me=y.serializeAcknowledged(O);this.f?.logOutgoing(me.byteLength,O,1,"ack"),this.c.send(me),H.then(x=>{delete this.u[M];const Q=y.serializeReplyOK(O,x,this.h);this.f?.logOutgoing(Q.byteLength,O,1,"reply:",x),this.c.send(Q)},x=>{delete this.u[M];const Q=y.serializeReplyErr(O,x);this.f?.logOutgoing(Q.byteLength,O,1,"replyErr:",x),this.c.send(Q)})}N(A,O){this.f?.logIncoming(A,O,1,"receiveCancel");const N=String(O);this.u[N]?.()}O(A,O,N){this.f?.logIncoming(A,O,0,"receiveReply:",N);const T=String(O);if(!this.w.hasOwnProperty(T))return;const j=this.w[T];delete this.w[T],j.resolveOk(N)}P(A,O,N){this.f?.logIncoming(A,O,0,"receiveReplyErr:",N);const T=String(O);if(!this.w.hasOwnProperty(T))return;const j=this.w[T];delete this.w[T];let z;N&&(N.$isError?(z=new Error,z.name=N.name,z.message=N.message,z.stack=N.stack):z=N),j.resolveErr(z)}Q(A,O,N){try{return Promise.resolve(this.S(A,O,N))}catch(T){return Promise.reject(T)}}S(A,O,N){const T=this.m[A];if(!T)throw new Error("Unknown actor "+(0,P.$_z)(A));const j=T[O];if(typeof j!="function")throw new Error("Unknown method "+O+" on actor "+(0,P.$_z)(A));return j.apply(T,N)}U(A,O,N){if(this.j)return new b.$i3b;let T=null;if(N.length>0&&f.CancellationToken.isCancellationToken(N[N.length-1])&&(T=N.pop()),T&&T.isCancellationRequested)return Promise.reject(L.$4());const j=y.serializeRequestArguments(N,this.h),z=++this.t,M=String(z),H=new b.$h3b,q=new m.$ic;T&&q.add(T.onCancellationRequested(()=>{const x=y.serializeCancel(z);this.f?.logOutgoing(x.byteLength,z,0,"cancel"),this.c.send(y.serializeCancel(z))})),this.w[M]=new c(H,q),this.F(z);const me=y.serializeRequest(z,A,O,j,!!T);return this.f?.logOutgoing(me.byteLength,z,0,`request: ${(0,P.$_z)(A)}.${O}(`,N),this.c.send(me),H}}e.$l3b=n;class c{constructor(A,O){this.a=A,this.b=O}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class h{static alloc(A,O,N){const T=new h(F.$Ed.alloc(N+1+4),0);return T.writeUInt8(A),T.writeUInt32(O),T}static read(A,O){return new h(A,O)}get buffer(){return this.a}constructor(A,O){this.a=A,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const N=this.a.slice(this.b,this.b+A).toString();return this.b+=A,N}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+A).toString();return this.b+=A,N}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+A);return this.b+=A,O}static sizeMixedArray(A){let O=0;O+=1;for(let N=0,T=A.length;N<T;N++){const j=A[N];switch(O+=1,j.type){case 1:O+=this.sizeLongString(j.value);break;case 2:O+=this.sizeVSBuffer(j.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(j.value);for(let z=0;z<j.buffers.length;++z)O+=this.sizeVSBuffer(j.buffers[z]);break;case 4:break}}return O}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let O=0,N=A.length;O<N;O++){const T=A[O];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let j=0;j<T.buffers.length;++j)this.writeBuffer(T.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const O=new Array(A);for(let N=0;N<A;N++)switch(this.readUInt8()){case 1:O[N]=this.readLongString();break;case 2:O[N]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),z=this.readLongString(),M=[];for(let H=0;H<j;++H)M.push(this.readVSBuffer());O[N]=new P.$aA(i(z,M,null));break}case 4:O[N]=void 0;break}return O}}var E;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(E||(E={}));class y{static a(A){for(let O=0,N=A.length;O<N;O++)if(A[O]instanceof F.$Ed||A[O]instanceof P.$aA||typeof A[O]>"u")return!0;return!1}static serializeRequestArguments(A,O){if(this.a(A)){const N=[];for(let T=0,j=A.length;T<j;T++){const z=A[T];if(z instanceof F.$Ed)N[T]={type:2,value:z};else if(typeof z>"u")N[T]={type:4};else if(z instanceof P.$aA){const{jsonString:M,referencedBuffers:H}=r(z.value,O);N[T]={type:3,value:F.$Ed.fromString(M),buffers:H}}else N[T]={type:1,value:F.$Ed.fromString(s(z,O))}}return{type:1,args:N}}return{type:0,args:s(A,O)}}static serializeRequest(A,O,N,T,j){switch(T.type){case 0:return this.b(A,O,N,T.args,j);case 1:return this.c(A,O,N,T.args,j)}}static b(A,O,N,T,j){const z=F.$Ed.fromString(N),M=F.$Ed.fromString(T);let H=0;H+=h.sizeUInt8(),H+=h.sizeShortString(z),H+=h.sizeLongString(M);const q=h.alloc(j?2:1,A,H);return q.writeUInt8(O),q.writeShortString(z),q.writeLongString(M),q.buffer}static deserializeRequestJSONArgs(A){const O=A.readUInt8(),N=A.readShortString(),T=A.readLongString();return{rpcId:O,method:N,args:JSON.parse(T)}}static c(A,O,N,T,j){const z=F.$Ed.fromString(N);let M=0;M+=h.sizeUInt8(),M+=h.sizeShortString(z),M+=h.sizeMixedArray(T);const H=h.alloc(j?4:3,A,M);return H.writeUInt8(O),H.writeShortString(z),H.writeMixedArray(T),H.buffer}static deserializeRequestMixedArgs(A){const O=A.readUInt8(),N=A.readShortString(),T=A.readMixedArray(),j=new Array(T.length);for(let z=0,M=T.length;z<M;z++){const H=T[z];typeof H=="string"?j[z]=JSON.parse(H):j[z]=H}return{rpcId:O,method:N,args:j}}static serializeAcknowledged(A){return h.alloc(5,A,0).buffer}static serializeCancel(A){return h.alloc(6,A,0).buffer}static serializeReplyOK(A,O,N){if(typeof O>"u")return this.d(A);if(O instanceof F.$Ed)return this.e(A,O);if(O instanceof P.$aA){const{jsonString:T,referencedBuffers:j}=r(O.value,N,!0);return this.g(A,T,j)}else return this.f(A,p(O,N))}static d(A){return h.alloc(7,A,0).buffer}static e(A,O){let N=0;N+=h.sizeVSBuffer(O);const T=h.alloc(8,A,N);return T.writeVSBuffer(O),T.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,O){const N=F.$Ed.fromString(O);let T=0;T+=h.sizeLongString(N);const j=h.alloc(9,A,T);return j.writeLongString(N),j.buffer}static g(A,O,N){const T=F.$Ed.fromString(O);let j=0;j+=h.sizeUInt32,j+=h.sizeLongString(T);for(const M of N)j+=h.sizeVSBuffer(M);const z=h.alloc(10,A,j);z.writeUInt32(N.length),z.writeLongString(T);for(const M of N)z.writeBuffer(M);return z.buffer}static deserializeReplyOKJSON(A){const O=A.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(A,O){const N=A.readUInt32(),T=A.readLongString(),j=[];for(let z=0;z<N;++z)j.push(A.readVSBuffer());return new P.$aA(i(T,j,O))}static serializeReplyErr(A,O){const N=O?p(L.$1(O),null):void 0;if(typeof N!="string")return this.h(A);const T=F.$Ed.fromString(N);let j=0;j+=h.sizeLongString(T);const z=h.alloc(11,A,j);return z.writeLongString(T),z.buffer}static deserializeReplyErrError(A){const O=A.readLongString();return JSON.parse(O)}static h(A){return h.alloc(12,A,0).buffer}}var u;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var l;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(l||(l={}))}),define(De[342],Ce([1,0,4,42,41,5]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=e.$9I=e.OutputChannelUpdateMode=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=void 0,e.$XI="text/x-code-output",e.$YI="output",e.$ZI="Log",e.$1I="text/x-code-log-output",e.$2I="log",e.$3I="log",e.$4I="workbench.panel.output",e.$5I=new f.$1i("inOutput",!1),e.$6I=new f.$1i("activeLogOutput",!1),e.$7I=new f.$1i("outputView.scrollLock",!1),e.$8I=(0,L.$Ah)("outputService");var R;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$9I={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new C.$ed,this.onDidRegisterChannel=this.b.event,this.c=new C.$ed,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(P=>b.push(P)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}F.$7m.add(e.$9I.OutputChannels,new m),e.$0I=new f.$1i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,14,342,72,26,54,178,22,18,30,4,3]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0;class i extends R.$0i{get disposed(){return this.n}constructor(g,t,o,a,n){super(),this.id=g,this.name=t,this.r=o,this.s=a,this.extension=n,this.m=0,this.n=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,g)}replace(g){const t=this.m;this.info(g),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(g,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof g=="boolean"?g:t))}hide(){this.s.$close(this.id)}g(g,t){this.m+=p.$Ed.fromString(t).byteLength,(0,R.log)(this.r,g,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class s extends i{appendLine(g){this.append(g)}}let d=class{constructor(g,t,o,a,n,c){this.i=t,this.j=o,this.k=a,this.l=n,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(C.$TJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[t,o]of this.g)o.visible=t===this.h}createOutputChannel(g,t,o){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,n=(0,k.$if)(t)?t:void 0;if((0,k.$if)(n)&&!n.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([y])=>L.$Ul.equals(o.identifier,y))?.[1];h&&(c=(0,R.$hj)(h));const E=a?this.o(g,c,o):this.n(g,n,o);return E.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(g,c??this.m.getLevel(),E):this.q(g,E)}async n(g,t,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,n=this.k.extUri.joinPath(a,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(n,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(g,n,t,o.identifier.value);return new i(h,g,c,this.a,o)}async o(g,t,o){const a=await this.p(o),n=g.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(a,`${n}.log`),h=`${o.identifier.value}.${n}`,E=this.l.createLogger(c,{id:h,name:g,logLevel:t,extensionId:o.identifier.value});return new s(h,g,E,this.a,o)}p(g){let t=this.d.get(g.identifier.value);if(!t){const o=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(o)}catch(a){if((0,D.$hk)(a)!==D.FileSystemProviderErrorCode.FileExists)throw a}return o})())}return t}q(g,t){let o=!1;const a=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return g},append(n){a(),t.then(c=>c.append(n))},appendLine(n){a(),t.then(c=>c.appendLine(n))},clear(){a(),t.then(n=>n.clear())},replace(n){a(),t.then(c=>c.replace(n))},show(n,c){a(),t.then(h=>h.show(n,c))},hide(){a(),t.then(n=>n.hide())},dispose(){o=!0,t.then(n=>n.dispose())}}}r(g,t,o){const a=new r.$ic,n=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new v.$ed);function h(E){t=E,c.fire(E)}return o.then(E=>{a.add(E),E.logLevel!==t&&h(E.logLevel),a.add(E.onDidChangeLogLevel(y=>h(y)))}),{...this.q(g,o),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(E,...y){n(),o.then(u=>u.trace(E,...y))},debug(E,...y){n(),o.then(u=>u.debug(E,...y))},info(E,...y){n(),o.then(u=>u.info(E,...y))},warn(E,...y){n(),o.then(u=>u.warn(E,...y))},error(E,...y){n(),o.then(u=>u.error(E,...y))},dispose(){a.dispose()}}}};e.$Bbc=d,e.$Bbc=d=Ke([Be(0,f.$VL),Be(1,b.$_L),Be(2,S.$ebc),Be(3,P.$Lac),Be(4,R.$5i),Be(5,R.$4i)],d),e.$Cbc=(0,F.$Ah)("IExtHostOutputService")}),define(De[343],Ce([1,0,5,11]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=void 0,e.$im=(0,C.$Ah)("remoteAgentService"),e.$jm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let L=1/0;for(let m=0;m<this.maxSampleCount;m++){const S=await f.getRoundTripTime();if(S===void 0)return;L=Math.min(L,S/2),await(0,F.$Gg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((m,S)=>m+S,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((m,S)=>m+S,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[344],Ce([1,0,32,17,16,12,24,2,5,258,43,147,343]),function($e,e,C,F,f,L,R,m,S,b,P,I,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.$pJ=void 0,e.$pJ=(0,S.$Ah)("pathService");let D=k=class{constructor(r,i,s,d){this.d=r,this.e=i,this.f=s,this.g=d,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const $=await this.e.getEnvironment();return this.c=$?.userHome??r})()}hasValidBasename(r,i,s){return typeof i=="string"||typeof i>"u"?this.a.then(d=>this.h(r,d,i)):this.h(r,i,s)}h(r,i,s){return r.scheme===F.Schemas.file||r.scheme===F.Schemas.vscodeRemote?(0,C.$Ff)(s??(0,R.$eg)(r),i===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(r,i){if(r.remoteAuthority)return F.Schemas.vscodeRemote;const s=(0,b.$mJ)(i.getWorkspace());if(s)return s;const d=i.getWorkspace().folders[0];if(d)return d.uri.scheme;const $=i.getWorkspace().configuration;return $?$.scheme:F.Schemas.file}userHome(r){return r?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(r=>r===1?f.$4d:f.$5d)}async fileURI(r){let i="";if(await this.a===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const d=r.indexOf("/",2);d===-1?(i=r.substring(2),r="/"):(i=r.substring(2,d),r=r.substring(d)||"/")}return m.URI.from({scheme:F.Schemas.file,authority:i,path:r,query:"",fragment:""})}};e.$qJ=D,e.$qJ=D=k=Ke([Be(1,p.$im),Be(2,I.$$I),Be(3,P.$Jh)],D)}),define(De[345],Ce([1,0,225,19,57,4,51,3,2,49,230,14,65,260,86,43,147,27,21,18,23,41]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.$iJ=e.$hJ=e.OnPortForward=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.TunnelSource=e.TunnelCloseReason=e.$bJ=e.$aJ=e.$_I=void 0;const t=10*1e3,o="remote.tunnels.toRestore";e.$_I="onTunnel",e.$aJ=new g.$1i("forwardedPortsViewEnabled",!1,C.localize(0,null));function a(O){const N=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.$bJ=a;var n;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(n||(e.TunnelCloseReason=n={}));var c;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$cJ={source:c.User,description:C.localize(1,null)},e.$dJ={source:c.Auto,description:C.localize(2,null)};function h(O,N,T){const j=O.get(y(N,T));if(j)return j;if((0,D.$Yz)(N))for(const z of D.$Xz){const M=y(z,T);if(O.has(M))return O.get(M)}else if((0,D.$1z)(N))for(const z of D.$Zz){const M=y(z,T);if(O.has(M))return O.get(M)}}e.$eJ=h;function E(O,N,T){const j=h(O,N,T);if(j)return j;const z=(0,D.$1z)(N)?"localhost":(0,D.$Yz)(N)?"0.0.0.0":void 0;if(z)return h(O,z,T)}e.$fJ=E;function y(O,N){return O+":"+N}e.$gJ=y;var u;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(u||(e.OnPortForward=u={}));function l(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}e.$hJ=l;class w extends m.$jc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.r=N,this.j=[],this.n=new L.$ed,this.onDidChangeAttributes=this.n.event,this.B(N.onDidChangeConfiguration(T=>{(T.affectsConfiguration(w.c)||T.affectsConfiguration(w.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(N,T,j){let z=this.w(N,T,j,this.j,0);const M={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const H=this.j[z];H.key===N?(M.onAutoForward=H.onAutoForward??M.onAutoForward,M.elevateIfNeeded=H.elevateIfNeeded!==void 0?H.elevateIfNeeded:M.elevateIfNeeded,M.label=H.label??M.label,M.requireLocalPort=H.requireLocalPort,M.protocol=H.protocol):(M.onAutoForward=M.onAutoForward??H.onAutoForward,M.elevateIfNeeded=M.elevateIfNeeded!==void 0?M.elevateIfNeeded:H.elevateIfNeeded,M.label=M.label??H.label,M.requireLocalPort=M.requireLocalPort!==void 0?M.requireLocalPort:void 0,M.protocol=M.protocol??H.protocol),z=this.w(N,T,j,this.j,z+1)}return M.onAutoForward!==void 0||M.elevateIfNeeded!==void 0||M.label!==void 0||M.requireLocalPort!==void 0||M.protocol!==void 0?M:this.C()}t(N){return N.start!==void 0&&N.end!==void 0}u(N){return N.host!==void 0&&N.port!==void 0&&(0,d.$if)(N.host)&&(0,d.$mf)(N.port)}w(N,T,j,z,M){if(M>=z.length)return-1;const H=!(0,D.$Yz)(T)&&!(0,D.$1z)(T),me=z.slice(M).findIndex(x=>(0,d.$mf)(x.key)?H?!1:x.key===N:this.t(x.key)?H?!1:N>=x.key.start&&N<=x.key.end:this.u(x.key)?N===x.key.port&&T===x.key.host:j?x.key.test(j):!1);return me>=0?me+M:-1}y(){const N=this.r.getValue(w.c);if(!N||!(0,d.$kf)(N))return[];const T=[];for(const z in N){if(z===void 0)continue;const M=N[z];let H;if(Number(z))H=Number(z);else if((0,d.$if)(z))if(w.g.test(z)){const q=z.match(w.g);H={start:Number(q[1]),end:Number(q[2])}}else if(w.h.test(z)){const q=z.match(w.h);H={host:q[1],port:Number(q[2])}}else{let q;try{q=RegExp(z)}catch{}q&&(H=q)}H&&T.push({key:H,elevateIfNeeded:M.elevateIfNeeded,onAutoForward:M.onAutoForward,label:M.label,requireLocalPort:M.requireLocalPort,protocol:M.protocol})}const j=this.r.getValue(w.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(T)}z(N){function T(j,z){return(0,d.$mf)(j.key)?j.key:z.t(j.key)?j.key.start:z.u(j.key)?j.key.port:Number.MAX_VALUE}return N.sort((j,z)=>T(j,this)-T(z,this))}C(){return this.m}static providedActionToAction(N){switch(N){case D.ProvidedOnAutoForward.Notify:return u.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return u.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return u.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return u.OpenPreview;case D.ProvidedOnAutoForward.Silent:return u.Silent;case D.ProvidedOnAutoForward.Ignore:return u.Ignore;default:return}}async addAttributes(N,T,j){const M=this.r.inspect(w.c).userRemoteValue;let H;!M||!(0,d.$kf)(M)?H={}:H=(0,$.$Um)(M),H[`${N}`]||(H[`${N}`]={});for(const q in T)H[`${N}`][q]=T[q];return this.r.updateValue(w.c,H,j)}}e.$iJ=w;let A=class extends m.$jc{constructor(N,T,j,z,M,H,q,me,x,Q){super(),this.H=N,this.I=T,this.J=j,this.L=z,this.M=M,this.N=H,this.O=q,this.P=me,this.Q=x,this.R=Q,this.c=new Map,this.g=new L.$ed,this.onForwardPort=this.g.event,this.h=new L.$ed,this.onClosePort=this.h.event,this.j=new L.$ed,this.onPortName=this.j.event,this.n=new L.$ed,this.onCandidatesChanged=this.n.event,this.t=new L.$ed,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$ed,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new w(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async V=>{const _=await this.getAttributes(V.map(ge=>({port:ge.tunnelRemotePort,host:ge.tunnelRemoteHost})));for(const ge of V)if(ge.localAddress){const ce=y(ge.tunnelRemoteHost,ge.tunnelRemotePort),we=E(this.m??new Map,ge.tunnelRemoteHost,ge.tunnelRemotePort);this.forwarded.set(ce,{remotePort:ge.tunnelRemotePort,remoteHost:ge.tunnelRemoteHost,localAddress:ge.localAddress,protocol:_?.get(ge.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(ge.localAddress,_?.get(ge.tunnelRemotePort)),localPort:ge.tunnelLocalPort,runningProcess:we?.detail,hasRunningProcess:!!we,pid:we?.pid,privacy:ge.privacy,source:e.$cJ}),this.f.set(ce,ge)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async V=>{const _=y(V.tunnelRemoteHost,V.tunnelRemotePort);if(!E(this.forwarded,V.tunnelRemoteHost,V.tunnelRemotePort)&&!E(this.detected,V.tunnelRemoteHost,V.tunnelRemotePort)&&!E(this.c,V.tunnelRemoteHost,V.tunnelRemotePort)&&V.localAddress){const ge=E(this.m??new Map,V.tunnelRemoteHost,V.tunnelRemotePort),ce=(await this.getAttributes([{port:V.tunnelRemotePort,host:V.tunnelRemoteHost}]))?.get(V.tunnelRemotePort);this.forwarded.set(_,{remoteHost:V.tunnelRemoteHost,remotePort:V.tunnelRemotePort,localAddress:V.localAddress,protocol:ce?.protocol??D.TunnelProtocol.Http,localUri:await this.X(V.localAddress,ce),localPort:V.tunnelLocalPort,closeable:!0,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:V.privacy,source:e.$cJ})}await this.$(),this.f.set(_,V),this.g.fire(this.forwarded.get(_))})),this.B(this.H.onTunnelClosed(V=>this.W(V,n.Other))),this.U()}S(){return this.Q.extensions.find(N=>N.activationEvents?.includes(e.$_I))?(this.R.createKey(e.$aJ.key,!0),!0):!1}U(){if(this.S())return;const N=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&N.dispose()}))}async W(N,T){const j=y(N.host,N.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(N))}X(N,T){if(N.startsWith("http"))return S.URI.parse(N);const j=T?.protocol??"http";return S.URI.parse(`${j}://${N}`)}async Y(){const N=this.N.getWorkspace(),T=N.configuration?(0,R.$oi)(N.configuration.path):N.folders.length>0?(0,R.$oi)(N.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${o}.${this.L.remoteAuthority}.${T}`}async Z(){const N=this.I.get(o,1);if(N)return this.I.remove(o,1),await this.$(),N;const T=await this.Y();if(T)return this.I.get(T,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=await this.s;if(N&&N!==this.y){const T=JSON.parse(N)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${T.map(j=>j.remotePort).join(", ")}`);for(const j of T){const z=E(this.detected,j.remoteHost,j.remotePort);j.source.source!==c.Extension&&!z||j.source.source===c.Extension&&z?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===c.Extension&&!z&&this.D.set(y(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const N=await this.Y();this.w=this.B(new m.$ic),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async T=>{T.key===N&&(this.s=Promise.resolve(this.I.get(N,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=JSON.stringify(Array.from(this.forwarded.values()));if(N!==this.y){this.y=N;const T=await this.Y();T&&this.I.store(T,this.y,0,0)}}}async bb(N,T,j){if(!N.tunnelLocalPort||!j?.requireLocalPort||N.tunnelLocalPort===T)return;const z=new Date;if(this.ab.getTime()+t>z.getTime())return;this.ab=z;const M=C.localize(3,null,T,N.tunnelRemotePort,N.tunnelLocalPort);return this.P.info(M)}async forward(N,T){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(N,T)}async cb(N,T){await this.Q.activateByEvent(e.$_I);const j=E(this.forwarded,N.remote.host,N.remote.port);T=T??(T!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const z=N.local!==void 0?N.local:N.remote.port;let M;if(j)return this.eb(j,N,T);{const H=this.L.remoteAuthority,q=H?{getAddress:async()=>(await this.M.resolveAuthority(H)).authority}:void 0,me=y(N.remote.host,N.remote.port);this.c.set(me,!0),N=this.db(me,N);const x=await this.H.openTunnel(q,N.remote.host,N.remote.port,void 0,z,N.elevateIfNeeded?N.elevateIfNeeded:T?.elevateIfNeeded,N.privacy,T?.protocol);if(typeof x=="string")M=x;else if(x&&x.localAddress){const Q=E(this.m??new Map,N.remote.host,N.remote.port),V=x.protocol?x.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:T?.protocol??D.TunnelProtocol.Http,_={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:T?.label??N.name,closeable:!0,localAddress:x.localAddress,protocol:V,localUri:await this.X(x.localAddress,T),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:N.source??e.$cJ,privacy:x.privacy};return this.forwarded.set(me,_),this.f.set(me,x),this.c.delete(me),await this.$(),await this.bb(x,z,T),this.g.fire(_),x}this.c.delete(me)}return M}db(N,T){const j=this.D.has(N)?this.D:this.F.has(N)?this.F:void 0;if(j){const z=j.get(N);j.delete(N),z&&(T.name=z.name??T.name,T.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??T.local,T.privacy=z.privacy??T.privacy)}return T}async eb(N,T,j){const z=j?.label??T.name;let M;(function(q){q[q.None=0]="None",q[q.Fire=1]="Fire",q[q.Reopen=2]="Reopen"})(M||(M={}));let H=M.None;switch(z!==N.name&&(N.name=z,H=M.Fire),(j?.protocol||N.protocol!==D.TunnelProtocol.Http)&&j?.protocol!==N.protocol&&(T.source=N.source,H=M.Reopen),T.privacy&&N.privacy!==T.privacy&&(H=M.Reopen),H){case M.Fire:{this.g.fire();break}case M.Reopen:await this.close(N.remoteHost,N.remotePort,n.User),await this.cb(T,j)}return E(this.f,T.remote.host,T.remote.port)}async name(N,T,j){const z=E(this.forwarded,N,T),M=y(N,T);if(z){z.name=j,await this.$(),this.j.fire({host:N,port:T});return}else this.detected.has(M)&&(this.detected.get(M).name=j,this.j.fire({host:N,port:T}))}async close(N,T,j){const z=y(N,T),M=this.forwarded.get(z);return j===n.AutoForwardEnd&&M&&M.source.source===c.Auto&&this.F.set(z,{local:M.localPort,name:M.name,privacy:M.privacy}),await this.H.closeTunnel(N,T),this.W({host:N,port:T},j)}address(N,T){const j=y(N,T);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(N){if(N)for(const T of N){const j=E(this.m??new Map,T.remoteAddress.host,T.remoteAddress.port),z=typeof T.localAddress=="string"?T.localAddress:y(T.localAddress.host,T.localAddress.port);this.detected.set(y(T.remoteAddress.host,T.remoteAddress.port),{remoteHost:T.remoteAddress.host,remotePort:T.remoteAddress.port,localAddress:z,protocol:D.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(T.remoteAddress.host,T.remoteAddress.port,z,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(N){this.r=N}async setCandidates(N){let T=N;this.r&&(T=await this.r(N));const j=this.fb(T);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(z=>z.port).join(", ")}`),this.n.fire(j)}fb(N){const T=this.m??new Map,j=new Map;return this.m=j,N.forEach(z=>{const M=y(z.host,z.port);j.set(M,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),T.has(M)&&T.delete(M);const H=E(this.forwarded,z.host,z.port);H&&(H.runningProcess=z.detail,H.hasRunningProcess=!0,H.pid=z.pid)}),T.forEach((z,M)=>{const H=a(M);if(!H)return;const q=E(this.forwarded,H.host,H.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0);const me=E(this.detected,H.host,H.port);me&&(me.runningProcess=void 0,me.hasRunningProcess=!1,me.pid=void 0)}),T}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const N=Array.from(this.forwarded.values()),T=await this.getAttributes(N.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(T)for(const j of N){const z=T.get(j.remotePort);(z?.protocol||j.protocol!==D.TunnelProtocol.Http)&&z?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},z),z&&z.label&&z.label!==j.name&&await this.name(j.remoteHost,j.remotePort,z.label)}}async getAttributes(N,T=!0){const j=new Map,z=new Map;N.forEach(x=>{const Q=E(this.m??new Map,D.$Xz[0],x.port)??x;if(Q){j.set(x.port,Q);const V=l(Q)?Q.pid:void 0;z.has(V)||z.set(V,[]),z.get(V)?.push(x.port)}});const M=new Map;if(N.forEach(x=>{const Q=this.configPortsAttributes.getAttributes(x.port,x.host,j.get(x.port)?.detail);Q&&M.set(x.port,Q)}),this.G.length===0||!T)return M.size>0?M:void 0;const H=await Promise.all((0,F.$Ob)(this.G.map(x=>Array.from(z.entries()).map(Q=>{const V=Q[1],_=j.get(V[0]);return x.providePortAttributes(V,_?.pid,_?.detail,new s.$od().token)})))),q=new Map;if(H.forEach(x=>x.forEach(Q=>{Q&&q.set(Q.port,Q)})),!M&&!q)return;const me=new Map;return N.forEach(x=>{const Q=M.get(x.port),V=q.get(x.port);me.set(x.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??w.providedActionToAction(V?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),me}addAttributesProvider(N){this.G.push(N)}};e.$jJ=A,Ke([(0,f.$6g)(1e3)],A.prototype,"$",null),e.$jJ=A=Ke([Be(0,D.$Tz),Be(1,k.$To),Be(2,b.$7h),Be(3,r.$$I),Be(4,p.$Ik),Be(5,v.$Jh),Be(6,I.$4i),Be(7,P.$lA),Be(8,i.$JF),Be(9,g.$2i)],A)}),define(De[93],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$_H=e.$$H=void 0;class C{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new C(0,0)}with(R){return new C(0,0)}}e.$$H=C;class F{constructor(R,m,S,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(R,m),this.end=new C(S,b)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$_H=F;var f;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(De[36],Ce([1,0,19,35,23,32,15,5,16,8,93,11]),function($e,e,C,F,f,L,R,m,S,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.SearchErrorCode=e.$oI=e.$nI=e.SearchSortOrder=e.ViewMode=e.$mI=e.$lI=e.$kI=e.$jI=e.SearchCompletionExitCode=e.$iI=e.$hI=e.$gI=e.QueryType=e.SearchProviderType=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$aI="workbench.view.search",e.$bI="workbench.panel.search",e.$cI="workbench.view.search",e.$dI="search-result",e.$eI="search.exclude";const p="\u27EA ",k=" characters skipped \u27EB",D=(p.length+k.length+5)*2;e.$fI=(0,m.$Ah)("searchService");var v;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(v||(e.SearchProviderType=v={}));var r;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(r||(e.QueryType=r={}));function i(V){return!!V.preview}e.$gI=i;function s(V){return!!V.resource}e.$hI=s;function d(V){return!!V.message}e.$iI=d;var $;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})($||(e.SearchCompletionExitCode=$={}));class g{constructor(_){this.resource=_,this.results=[]}}e.$jI=g;class t{constructor(_,ge,ce,we){this.ranges=ge,this.webviewIndex=we;const G=Array.isArray(ge)?ge:[ge];if(ce&&ce.matchLines===1&&o(G)){_=(0,R.$bf)(_,ce.matchLines);let U="",K=0,Y=0;const se=Math.floor(ce.charsPerLine/5),re=[];for(const le of G){const Ee=Math.max(le.startColumn-se,0),he=le.startColumn+ce.charsPerLine;if(Ee>Y+se+D){const fe=p+(Ee-Y)+k;U+=fe+_.slice(Ee,he),K+=Ee-(Y+fe.length)}else U+=_.slice(Y,he);re.push(new n(0,le.startColumn-K,le.endColumn-K)),Y=he}this.preview={text:U,matches:Array.isArray(this.ranges)?re:re[0]}}else{const U=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:_,matches:(0,C.$Yb)(ge,K=>new a(K.startLineNumber-U,K.startColumn,K.endLineNumber-U,K.endColumn))}}}}e.$kI=t;function o(V){const _=V[0].startLineNumber;for(const ge of V)if(ge.startLineNumber!==_||ge.endLineNumber!==_)return!1;return!0}class a{constructor(_,ge,ce,we){this.startLineNumber=_,this.startColumn=ge,this.endLineNumber=ce,this.endColumn=we}}e.$lI=a;class n extends a{constructor(_,ge,ce){super(_,ge,_,ce)}}e.$mI=n;var c;(function(V){V.List="list",V.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function E(V,_=!0){const ge=V&&V.files&&V.files.exclude,ce=_&&V&&V.search&&V.search.exclude;if(!ge&&!ce)return;if(!ge||!ce)return ge||ce;let we=Object.create(null);return we=f.$Xm(we,f.$Um(ge)),we=f.$Xm(we,f.$Um(ce),!0),we}e.$nI=E;function y(V,_){return V.excludePattern&&F.$pj(V.excludePattern,_)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&F.$pj(V.includePattern,_)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(ge=>{const ce=ge.folder.fsPath;if(L.$Hf(_,ce)){const we=S.$0d(ce,_);return!ge.includePattern||!!F.$pj(ge.includePattern,we)}else return!1}):!1:!0}e.$oI=y;var u;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class l extends Error{constructor(_,ge){super(_),this.code=ge}}e.$pI=l;function w(V){const _=V.message;if((0,b.$2)(V))return new l(_,u.canceled);try{const ge=JSON.parse(_);return new l(ge.message,ge.code)}catch{return new l(_,u.other)}}e.$qI=w;function A(V){const _={message:V.message,code:V.code};return new Error(JSON.stringify(_))}e.$rI=A;function O(V){return V.type==="error"?!0:V.type==="success"}e.$sI=O;function N(V){return V.type==="success"}e.$tI=N;function T(V){return!!V.path}e.$uI=T;function j(V,_){const ge=V.searchPath?V.searchPath:V.relativePath;return(0,R.$$e)(ge,_)}e.$vI=j;class z{constructor(_){this.path=_,this.results=[]}addMatch(_){this.results.push(_)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$wI=z;function M(V,_){const ge={...V||{},..._||{}};return Object.keys(ge).filter(ce=>{const we=ge[ce];return typeof we=="boolean"&&we})}e.$xI=M;class H{constructor(_,ge){this.c=null,this.a={..._.excludePattern||{},...ge.excludePattern||{}},this.b=F.$qj(this.a);let ce=_.includePattern;ge.includePattern&&(ce?ce={...ce,...ge.includePattern}:ce=ge.includePattern),ce&&(this.c=F.$qj(ce))}matchesExcludesSync(_,ge,ce){return!!(this.b&&this.b(_,ge,ce))}includedInQuerySync(_,ge,ce){return!(this.b&&this.b(_,ge,ce)||this.c&&!this.c(_,ge,ce))}includedInQuery(_,ge,ce){const we=this.b(_,ge,ce),G=()=>this.c?!!this.c(_,ge,ce):!0;return(0,I.$sg)(we)?we.then(U=>U?!1:G()):G()}hasSiblingExcludeClauses(){return q(this.a)}}e.$yI=H;function q(V){for(const _ in V)if(typeof V[_]!="boolean")return!0;return!1}function me(V){if(!V)return;let _;return ge=>(_||(_=(V()||Promise.resolve([])).then(ce=>ce?Q(ce):{})),_.then(ce=>!!ce[ge]))}e.$zI=me;function x(V){if(!V)return;let _;return ge=>{if(!_){const ce=V();_=ce?Q(ce):{}}return!!_[ge]}}e.$AI=x;function Q(V){const _={};for(const ge of V)_[ge]=!0;return _}}),define(De[39],Ce([1,0,19,11,21,4,3,77,17,120,24,15,2,214,5,14,243,43,54,26,20,13,7,67,36,6]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g,t,o,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.$Xac=void 0;function c(O,N,T){return new P.$9f(j=>u(j,T)).isEqual(O,N)}function h(O,N,T){return c(O.uri,N.uri,T)?0:(0,I.$Ee)(O.uri.toString(),N.uri.toString())}function E(O,N,T){return O.index!==N.index?O.index<N.index?-1:1:c(O.uri,N.uri,T)?(0,I.$Ee)(O.name,N.name):(0,I.$Ee)(O.uri.toString(),N.uri.toString())}function y(O,N,T,j){const z=O.slice(0).sort((H,q)=>T(H,q,j)),M=N.slice(0).sort((H,q)=>T(H,q,j));return(0,C.$Bb)(z,M,(H,q)=>T(H,q,j))}function u(O,N){const T=N.getCapabilities(O.scheme);return!(T&&T&1024)}class l extends i.$Th{static toExtHostWorkspace(N,T,j,z){if(!N)return{workspace:null,added:[],removed:[]};const{id:M,name:H,folders:q,configuration:me,transient:x,isUntitled:Q}=N,V=[],_=T;T?q.forEach((G,U)=>{const K=p.URI.revive(G.uri),Y=l.o(j||T,K,z);Y?(Y.name=G.name,Y.index=G.index,V.push(Y)):V.push({uri:K,name:G.name,index:U})}):V.push(...q.map(({uri:G,name:U,index:K})=>({uri:p.URI.revive(G),name:U,index:K}))),V.sort((G,U)=>G.index<U.index?-1:1);const ge=new l(M,H,V,!!x,me?p.URI.revive(me):null,!!Q,G=>u(G,z)),{added:ce,removed:we}=y(_?_.workspaceFolders:[],ge.workspaceFolders,h,z);return{workspace:ge,added:ce,removed:we}}static o(N,T,j){for(let z=0;z<N.folders.length;z++){const M=N.workspaceFolders[z];if(c(M.uri,T,j))return M}}constructor(N,T,j,z,M,H,q){super(N,j.map(me=>new i.$Uh(me)),z,M,q),this.t=T,this.u=H,this.q=[],this.s=m.$Gh.forUris(q),j.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,T){return T&&this.s.get(N)&&(N=(0,P.$gg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let w=class{constructor(N,T,j,z,M){this.c=new L.$ed,this.onDidChangeWorkspace=this.c.event,this.g=new L.$ed,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$gd,this.B=new Map,this.h=z,this.s=j,this.t=M,this.j=new b.$Il,this.k=new F.$Eg,this.o=N.getProxy(n.$TJ.MainThreadWorkspace),this.q=N.getProxy(n.$TJ.MainThreadMessageService);const H=T.workspace;this.l=H?new l(H.id,H.name,[],!!H.transient,H.configuration?p.URI.revive(H.configuration):null,!!H.isUntitled,q=>u(q,j)):void 0}$initializeWorkspace(N,T){this.v=T,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:S.Schemas.untitled,path:(0,P.$eg)((0,P.$gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,T,j,...z){const M=[];if(Array.isArray(z)&&z.forEach(Q=>{p.URI.isUri(Q.uri)&&!M.some(V=>c(V.uri,Q.uri,this.s))&&M.push({uri:Q.uri,name:Q.name||(0,P.$dg)(Q.uri)})}),this.n||[T,j].some(Q=>typeof Q!="number"||Q<0)||j===0&&M.length===0)return!1;const H=this.x?this.x.workspaceFolders:[];if(T+j>H.length)return!1;const q=H.slice(0);q.splice(T,j,...M.map(Q=>({uri:Q.uri,name:Q.name||(0,P.$dg)(Q.uri),index:void 0})));for(let Q=0;Q<q.length;Q++){const V=q[Q];if(q.some((_,ge)=>ge!==Q&&c(V.uri,_.uri,this.s)))return!1}q.forEach((Q,V)=>Q.index=V);const{added:me,removed:x}=y(H,q,E,this.s);if(me.length===0&&x.length===0)return!1;if(this.o){const Q=N.displayName||N.name;this.o.$updateWorkspaceFolders(Q,T,j,M).then(void 0,V=>{this.n=void 0;const _={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(r.Severity.Error,(0,k.localize)(0,null,Q,V.toString()),_,[])})}return this.y(q),!0}getWorkspaceFolder(N,T){if(this.x)return this.x.getWorkspaceFolder(N,T)}async getWorkspaceFolder2(N,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,T)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,T){let j,z="";if(typeof N=="string"?(j=p.URI.file(N),z=N):typeof N<"u"&&(j=N,z=N.fsPath),!j)return z;const M=this.getWorkspaceFolder(j,!0);if(!M)return z;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let H=(0,P.$jg)(M.uri,j);return T&&M.name&&(H=`${M.name}/${H}`),H}y(N){this.x&&(this.n=l.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:T,added:j,removed:z}=l.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:z}))}findFiles(N,T,j,z,M=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let H;if(T===null?H=!1:T&&(typeof T=="string"?H=T:H=T.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:q,folder:me}=A(g.GlobPattern.from(N));return this.o.$startFileSearch(q??null,me??null,H??null,j??null,M).then(x=>Array.isArray(x)?x.map(Q=>p.URI.revive(Q)):[])}async findTextInFiles(N,T,j,z,M=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const H=this.j.getNext(),q=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:me,folder:x}=A(g.GlobPattern.from(T.include)),Q=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,V={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:q,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:me,excludePattern:Q},_=!1;if(this.u[H]=ge=>{if(_)return;const ce=p.URI.revive(ge.resource);ge.results.forEach(we=>{(0,a.$gI)(we)?j({uri:ce,preview:{text:we.preview.text,matches:(0,C.$Yb)(we.preview.matches,G=>new t.$XJ(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,C.$Yb)(we.ranges,G=>new t.$XJ(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):j({uri:ce,text:we.text,lineNumber:we.lineNumber})})},M.isCancellationRequested)return{};try{const ge=await this.o.$startTextSearch(N,x??null,V,H,M);return delete this.u[H],ge||{}}catch(ge){throw delete this.u[H],ge}}$handleTextSearchResult(N,T){this.u[T]?.(N)}async save(N){const T=await this.o.$save(N,{saveAs:!1});return p.URI.revive(T)}async saveAs(N){const T=await this.o.$save(N,{saveAs:!0});return p.URI.revive(T)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,T){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,T);const j=this.t.transformOutgoingScheme(N),z=this.z++;return this.o.$registerEditSessionIdentityProvider(z,j),(0,R.$hc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(N,T){this.h.info("Getting edit session identifier for workspaceFolder",N);const j=await this.resolveWorkspaceFolder(p.URI.revive(N));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const M=await z.provideEditSessionIdentity(j,T);if(this.h.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(N,T,j,z){this.h.info("Getting edit session identifier for workspaceFolder",N);const M=await this.resolveWorkspaceFolder(p.URI.revive(N));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const H=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!H),!H)return;const q=await H.provideEditSessionIdentityMatch?.(T,j,z);if(this.h.info("Provider returned edit session identifier match result: ",q),!!q)return q}getOnWillCreateEditSessionIdentityEvent(N){return(T,j,z)=>{const M=function(q){T.call(j,q)};return M.extension=N,this.A.event(M,void 0,z)}}async $onWillCreateEditSessionIdentity(N,T,j){const z=await this.resolveWorkspaceFolder(p.URI.revive(N));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:z},T,async(M,H)=>{const q=Date.now();await Promise.resolve(M),Date.now()-q>j&&this.h.warn("SLOW edit session create-participant",H.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(N,T){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,T);const j=this.t.transformOutgoingScheme(N),z=this.z++;return this.o.$registerCanonicalUriProvider(z,j),(0,R.$hc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(N,T,j){const z=this.B.get(N.scheme);if(!z)return;const M=await z.provideCanonicalUri?.(p.URI.revive(N),T,j);if(M)return M}async $provideCanonicalUri(N,T,j){return this.provideCanonicalUri(p.URI.revive(N),{targetScheme:T},j)}};e.$Xac=w,e.$Xac=w=Ke([Be(0,$.$VL),Be(1,d.$_L),Be(2,s.$Lac),Be(3,v.$4i),Be(4,o.$Vac)],w),e.$Yac=(0,D.$Ah)("IExtHostWorkspace");function A(O){let N,T;return O&&(typeof O=="string"?N=O:(N=O.pattern,T=p.URI.revive(O.baseUri))),{includePattern:N,folder:T}}}),define(De[40],Ce([1,0,23,4,39,6,7,245,136,18,11,5,20,14,2]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=e.$1ac=e.$Zac=void 0;function v(o,a){if(a){const n=a.split(".");let c=o;for(let h=0;c&&h<n.length;h++)c=c[n[h]];return c}}function r(o){return o instanceof D.URI}function i(o){return o&&o.uri instanceof D.URI&&o.languageId&&typeof o.languageId=="string"}function s(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function d(o){return o&&o.uri instanceof D.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function $(o){if(r(o))return{resource:o};if(i(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(s(o))return{overrideIdentifier:o.languageId};if(d(o))return{resource:o.uri};if(o===null)return{resource:null}}let g=class{constructor(a,n,c){this.a=a.getProxy(L.$TJ.MainThreadConfiguration),this.c=n,this.b=c,this.d=new P.$Eg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,n){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,n))}};e.$Zac=g,e.$Zac=g=Ke([Be(0,p.$VL),Be(1,f.$Yac),Be(2,k.$4i)],g);class t{constructor(a,n,c,h){this.a=new F.$ed,this.b=a,this.f=h,this.c=n,this.e=m.$sn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,n){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$sn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(n,c))}getConfiguration(a,n,c){const h=$(n)||{},E=this.g(a?v(this.e.getValue(void 0,h,this.c.workspace),a):this.e.getValue(void 0,h,this.c.workspace));a&&this.h(a,h,c?.identifier);function y(l){if(l==null)return null;if(typeof l=="boolean")return l?2:5;switch(l){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(l){return typeof v(E,l)<"u"},get:(l,w)=>{this.h(a?`${a}.${l}`:l,h,c?.identifier);let A=v(E,l);if(typeof A>"u")A=w;else{let O;const N=(T,j)=>{if((0,b.$kf)(T)){let z;const M=()=>{O=O||(0,C.$Um)(E),z=z||v(O,j)};return new Proxy(T,{get:(H,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return M(),()=>z;if(O)return z=z||v(O,j),z[q];const me=H[q];return typeof q=="string"?N(me,`${j}.${q}`):me},set:(H,q,me)=>(M(),z&&(z[q]=me),!0),deleteProperty:(H,q)=>(M(),z&&delete z[q],!0),defineProperty:(H,q,me)=>(M(),z&&Object.defineProperty(z,q,me),!0)})}return Array.isArray(T)?(0,C.$Um)(T):T};A=N(A,l)}return A},update:(l,w,A,O)=>{l=a?`${a}.${l}`:l;const N=y(A);return w!==void 0?this.b.$updateConfigurationOption(N,l,w,h,O):this.b.$removeConfigurationOption(N,l,h,O)},inspect:l=>{l=a?`${a}.${l}`:l;const w=this.e.inspect(l,h,this.c.workspace);if(w)return{key:l,defaultValue:(0,C.$Um)(w.policy?.value??w.default?.value),globalValue:(0,C.$Um)(w.user?.value??w.application?.value),workspaceValue:(0,C.$Um)(w.workspace?.value),workspaceFolderValue:(0,C.$Um)(w.workspaceFolder?.value),defaultLanguageValue:(0,C.$Um)(w.default?.override),globalLanguageValue:(0,C.$Um)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,C.$Um)(w.workspace?.override),workspaceFolderLanguageValue:(0,C.$Um)(w.workspaceFolder?.override),languageIds:(0,C.$Um)(w.overrideIdentifiers)}}};return typeof E=="object"&&(0,C.$Xm)(u,E,!1),Object.freeze(u)}g(a){const n=c=>(0,b.$kf)(c)?new Proxy(c,{get:(h,E)=>n(h[E]),set:(h,E,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(h,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(h,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return n(a)}h(a,n,c){const h=S.$jn.test(a)?4:this.d.get(a),E=c?`[${c.value}] `:"";if(h===4){typeof n?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){n?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,n){const c=new m.$un(a,n,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,E)=>c.affectsConfiguration(h,$(E))})}k(a){return a.reduce((n,c)=>(n.set(c[0],c[1]),n),new Map)}}e.$1ac=t,e.$2ac=(0,I.$Ah)("IExtHostConfiguration")}),define(De[94],Ce([1,0,2,11,4,6,7,39,70,40,21,44,20,26,5,17,12,14,90,291,8]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=e.$Xbc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var g;(function(N){function T(z){if(z!=null)return z}N.from=T;function j(z){if(z!=null)return z}N.to=j})(g||(g={}));var t;(function(N){function T(z){if(z!=null)return z}N.from=T;function j(z){if(z!=null)return z}N.to=j})(t||(t={}));var o;(function(N){function T(z){if(z!=null)return z}N.from=T;function j(z){if(z!=null)return z}N.to=j})(o||(o={}));var a;(function(N){function T(M){if(M){const H=M;return H&&!!H.process}else return!1}N.is=T;function j(M){if(M==null)return;const H={process:M.process,args:M.args};return M.options&&(H.options=o.from(M.options)),H}N.from=j;function z(M){if(M!=null)return new R.$EK(M.process,M.args,M.options)}N.to=z})(a||(a={}));var n;(function(N){function T(z){if(z!=null)return z}N.from=T;function j(z){if(z!=null)return z}N.to=j})(n||(n={}));var c;(function(N){function T(M){if(M){const H=M;return H&&(!!H.commandLine||!!H.command)}else return!1}N.is=T;function j(M){if(M==null)return;const H={};return M.commandLine!==void 0?H.commandLine=M.commandLine:(H.command=M.command,H.args=M.args),M.options&&(H.options=n.from(M.options)),H}N.from=j;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new R.$FK(M.commandLine,M.options):new R.$FK(M.command,M.args?M.args:[],M.options)}N.to=z})(c||(c={}));var h;(function(N){function T(M){if(M){const H=M;return H&&H.customExecution==="customExecution"}else return!1}N.is=T;function j(M){return{customExecution:"customExecution"}}N.from=j;function z(M,H){return H.get(M)}N.to=z})(h||(e.CustomExecutionDTO=h={}));var E;(function(N){function T(j,z){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=d.$9F),{id:j._id,workspaceFolder:M}}N.from=T})(E||(e.TaskHandleDTO=E={}));var y;(function(N){function T(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=T})(y||(y={}));var u;(function(N){function T(M,H){if(M==null)return[];const q=[];for(const me of M){const x=j(me,H);x&&q.push(x)}return q}N.fromMany=T;function j(M,H){if(M==null)return;let q;M.execution instanceof R.$EK?q=a.from(M.execution):M.execution instanceof R.$FK?q=c.from(M.execution):M.execution&&M.execution instanceof R.$GK&&(q=h.from(M.execution));const me=g.from(M.definition);let x;return M.scope?typeof M.scope=="number"?x=M.scope:x=M.scope.uri:x=R.TaskScope.Workspace,!me||!x?void 0:{_id:M._id,definition:me,name:M.name,source:{extensionId:H.identifier.value,label:M.source,scope:x},execution:q,isBackground:M.isBackground,group:y.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=j;async function z(M,H,q){if(M==null)return;let me;a.is(M.execution)?me=a.to(M.execution):c.is(M.execution)?me=c.to(M.execution):h.is(M.execution)&&(me=h.to(M._id,q));const x=g.to(M.definition);let Q;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Q=M.source.scope:Q=await H.resolveWorkspaceFolder(C.URI.revive(M.source.scope)):Q=R.TaskScope.Workspace),!x||!Q)return;const V=new R.$HK(x,Q,M.name,M.source.label,me,M.problemMatchers);return M.isBackground!==void 0&&(V.isBackground=M.isBackground),M.group!==void 0&&(V.group=R.$DK.from(M.group._id),V.group&&M.group.isDefault&&(V.group=new R.$DK(V.group.id,V.group.label),M.group.isDefault===!0&&(V.group.isDefault=M.group.isDefault))),M.presentationOptions&&(V.presentationOptions=t.to(M.presentationOptions)),M._id&&(V._id=M._id),M.detail&&(V.detail=M.detail),V}N.to=z})(u||(e.TaskDTO=u={}));var l;(function(N){function T(z){return z}N.from=T;function j(z){if(z)return Object.assign(Object.create(null),z)}N.to=j})(l||(l={}));class w{#e;constructor(T,j,z){this._id=j,this.a=z,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let A=class{constructor(T,j,z,M,H,q,me,x){this.q=new f.$ed,this.r=new f.$ed,this.s=new f.$ed,this.t=new f.$ed,this.a=T.getProxy(L.$TJ.MainThreadTask),this.b=z,this.c=M,this.d=H,this.e=q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,j,z){if(!z)return new R.$VJ(()=>{});const M=this.w();return this.j.set(M,{type:j,provider:z,extension:T}),this.a.$registerTaskProvider(M,j),new R.$VJ(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(T,j){this.a.$registerTaskSystem(T,j)}fetchTasks(T){return this.a.$fetchTasks(l.from(T)).then(async j=>{const z=[];for(const M of j){const H=await u.to(M,this.b,this.m);H&&z.push(H)}return z})}get taskExecutions(){const T=[];return this.k.forEach(j=>T.push(j)),T}terminateTask(T){if(!(T instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,j,z){const M=this.m.get(T.id);M&&(this.o.set(T.id,M),this.e.attachPtyToTerminal(j,await M.callback(z))),this.p=T.id,this.q.fire({execution:await this.y(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){const j=await this.y(T);this.l.delete(T.id),this.k.delete(T.id),this.A(T),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const j=await this.y(T.id);this.s.fire({execution:j,processId:T.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(T){const j=await this.y(T.id);this.t.fire({execution:j,exitCode:T.exitCode})}$provideTasks(T,j){const z=this.j.get(T);if(!z)return Promise.reject(new Error("no handler found"));const M=[],H=(0,F.$yg)(()=>z.provider.provideTasks(P.CancellationToken.None)).then(q=>this.u(j,M,z,q));return new Promise(q=>{H.then(me=>{Promise.all(M).then(()=>{q(me)})})})}async $resolveTask(T,j){const z=this.j.get(T);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await u.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const H=await z.provider.resolveTask(M,P.CancellationToken.None);if(!H)return;this.z(H,z);const q=u.from(H,z.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(q.execution)&&await this.x(q,H,!0),await this.v(q)}w(){return this.h++}async x(T,j,z){const M=await this.a.$createTaskId(T);!z&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async y(T,j){if(typeof T=="string"){const H=this.l.get(T);if(!H)throw new $.$_("Unexpected: The specified task is missing an execution");return H}const z=this.l.get(T.id);if(z)return z;const M=new Promise((H,q)=>{function me(x,Q,V){V?H(new w(x,Q.id,V)):q("Unexpected: Task does not exist.")}j?me(this,T,j):u.to(T.task,this.b,this.m).then(x=>me(this,T,x))});return this.l.set(T.id,M),M.then(H=>(this.k.set(T.id,H),H),H=>Promise.reject(H))}z(T,j){T._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const z=this.n.values();let M=z.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=z.next()}};e.$Xbc=A,e.$Xbc=A=Ke([Be(0,p.$VL),Be(1,k.$_L),Be(2,m.$Yac),Be(3,S.$7L),Be(4,b.$2ac),Be(5,I.$hbc),Be(6,i.$4i),Be(7,s.$Oac)],A);let O=class extends A{constructor(T,j,z,M,H,q,me,x){super(T,j,z,M,H,q,me,x),this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(T,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=u.from(j,T);if(z===void 0)throw new Error("Task is not valid");if(h.is(z.execution))await this.x(z,j,!1);else throw new $.$0;const M=await this.y(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(H=>{throw new Error(H)}),M}u(T,j,z,M){const H=[];if(M)for(const q of M){this.z(q,z),(!q.definition||!T[q.definition.type])&&this.f.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const me=u.from(q,z.extension);me&&h.is(me.execution)?(H.push(me),j.push(this.x(me,q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:z.extension}}async v(T){if(h.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,j,z){}};e.$Ybc=O,e.$Ybc=O=Ke([Be(0,p.$VL),Be(1,k.$_L),Be(2,m.$Yac),Be(3,S.$7L),Be(4,b.$2ac),Be(5,I.$hbc),Be(6,i.$4i),Be(7,s.$Oac)],O),e.$Zbc=(0,D.$Ah)("IExtHostTask")}),define(De[346],Ce([1,0,16,21,46,35,24,37,36]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;class b{constructor(p,k,D){this.k=p,this.l=k,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&L.$qj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&L.$qj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const k=this.k.folderQueries||[];return new Promise((D,v)=>{const r=i=>{this.f++,p(i)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const s=i.toString(),d=C.$_d(s);this.j&&this.j(s,d)||this.v(r,{base:i,basename:d})}),Promise.all(k.map(i=>this.p(i,r))).then(i=>{D({limitHit:this.e,stats:i[0]||void 0})},i=>{v(new Error((0,f.$li)(i)))})})}async p(p,k){const D=new F.$od,v=this.q(p),r=this.r(),i=new S.$yI(this.k,p),s=!i.hasSiblingExcludeClauses();let d;try{this.h.add(D),d=m.$ad.create();const $=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},v,D.token),g=d.elapsed(),t=m.$ad.create();return this.g&&!this.e||($&&$.forEach(o=>{const a=C.$5d.relative(p.folder.path,o.path);if(s){const n=C.$_d(o.path);this.v(k,{base:p.folder,relativePath:a,basename:n});return}this.s(r,p.folder,a,k)}),this.g&&!this.e)?null:(this.u(r,i,k),{providerTime:g,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(p){const k=(0,S.$xI)(this.k.includePattern,p.includePattern),D=(0,S.$xI)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:D,includes:k,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},k,D,v){if(D===this.a){const i=C.$_d(this.a);this.v(v,{base:k,relativePath:this.a,basename:i})}function r(i){const s=C.$_d(i),d=C.$$d(i);let $=p[d];$||($=p[d]=[],r(d)),$.push({base:k,relativePath:i,basename:s})}r(D)}u({rootEntries:p,pathToEntries:k},D,v){const r=this,i=this.a;function s(d){const $=(0,S.$AI)(()=>d.map(g=>g.basename));for(let g=0,t=d.length;g<t;g++){const o=d[g],{relativePath:a,basename:n}=o;if(D.matchesExcludesSync(a,n,i!==n?$:void 0))continue;const c=k[a];if(c)s(c);else{if(a===i)continue;r.v(v,o)}if(r.e)break}}s(p)}v(p,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(k))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,k,D,v){const r=this.c(p.cacheKey),i=new b(p,k,r&&r.token);let s=0;const d=$=>{s+=$.length,D($.map(g=>this.d(g)))};return this.e(i,P.a,d,v).then($=>({limitHit:$.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:s,detailStats:$.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new F.$od),this.b.get(p)}d(p){return p.relativePath?{resource:R.$hg(p.base,p.relativePath)}:{resource:p.base}}e(p,k,D,v){const r=v.onCancellationRequested(()=>{p.cancel()}),i=d=>{d&&(s.push(d),k>0&&s.length>=k&&(D(s),s=[]))};let s=[];return p.search(i).then(d=>(s.length&&D(s),r.dispose(),d),d=>(s.length&&D(s),r.dispose(),Promise.reject(d)))}}e.$0bc=P}),define(De[347],Ce([1,0,19,56,35,100,28,17,16,24,15,18,2,172,226,49,14,43,143,344,36]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=void 0;let g=class{constructor(l,w,A,O,N){this.a=l,this.b=w,this.c=A,this.d=O,this.e=N}text(l,w,A={}){l=this.f(l,A);const O=this.a.getValue(),N=w&&w.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(w?.map(i.$Vh),A),type:2,contentPattern:l,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(l,w){const A=this.a.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const O={...l,wordSeparators:A.editor.wordSeparators};return this.j(l,w)&&(O.isCaseSensitive=!0),this.k(l)&&(O.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),O}file(l,w={}){return{...this.h(l,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(l,w){return l?(l=Array.isArray(l)?l.map(c):c(l),w?this.parseSearchPaths(l):{pattern:o(...Array.isArray(l)?l:[l])}):{}}h(l=[],w={}){const A=this.g(w.includePattern,w.expandPatterns),O=this.g(w.excludePattern,w.expandPatterns),N=l.length>1,T=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(M=>this.q(M,w,O)):l.map(M=>this.r(M,w,O,N))).filter(M=>!!M),j={_reason:w._reason,folderQueries:T,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:O.pattern,includePattern:A.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const M=C.$Eb(C.$Ob(this.c.groups.map(me=>me.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const H=M.filter(me=>(0,$.$oI)(j,me.fsPath)),q=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(q)),{...j,...q}}const z=w.extraFileResources&&w.extraFileResources.filter(M=>(0,$.$oI)(j,M.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(l){const w=[],A=new R.$yi,O={};let N=!1;return l.forEach(T=>{if(T.scheme===m.Schemas.walkThrough)return;if((0,b.$lg)(T)){const z=this.b.getWorkspaceFolder(T)?.uri??T.with({path:S.$$d(T.fsPath)});let M=A.get(z);M||(N=!0,M={folder:z,includePattern:{}},w.push(M),A.set(z,M));const H=S.$0d(z.fsPath,T.fsPath);(0,I.$tf)(M.includePattern)[H.replace(/\\/g,"/")]=!0}else T.fsPath&&(N=!0,O[T.fsPath]=!0)}),{folderQueries:w,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(l,w){if(w.isSmartCase){if(l.isRegExp){if(P.$_e(l.pattern,!0))return!0}else if(P.$_e(l.pattern))return!0}return!!l.isCaseSensitive}k(l){return l.isMultiline||l.isRegExp&&(0,k.$fC)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const w=q=>S.$7d(q)||/^\.\.?([\/\\]|$)/.test(q),O=(Array.isArray(l)?l:a(l)).map(q=>{const me=this.e.resolvedUserHome;return me?(0,L.$eA)(q,me.scheme===m.Schemas.file?me.fsPath:me.path):q}),N=F.$I(O,q=>w(q)?"searchPaths":"exprSegments"),T=(N.exprSegments||[]).map(q=>P.$ue(q,"/")).map(q=>P.$ue(q,"\\")).map(q=>(q[0]==="."&&(q="*"+q),n(q))),j={},z=this.m(N.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const M=C.$Ob(T),H=o(...M);return H&&(j.pattern=H),j}l(l,w){return w.disregardExcludeSettings?void 0:(0,$.$nI)(l,!w.disregardSearchExcludeSettings)}m(l){if(!l||!l.length)return[];const w=l.flatMap(O=>{let{pathPortion:N,globPortion:T}=t(O);return T&&(T=h(T)),this.n(N).flatMap(z=>this.o(z,T))}),A=new Map;return w.forEach(O=>{const N=O.searchPath.toString(),T=A.get(N);T?O.pattern&&(T.pattern=T.pattern||{},T.pattern[O.pattern]=!0):A.set(N,{searchPath:O.searchPath,pattern:O.pattern?o(O.pattern):void 0})}),Array.from(A.values())}n(l){if(S.$7d(l)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:l})}]:[{searchPath:p.URI.file(S.$6d(l))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(l=c(l),l.startsWith("../")||l===".."){const O=S.$5d.resolve(w.path,l);return[{searchPath:w.with({path:O})}]}const A=h(l);return[{searchPath:w,pattern:A}]}else{if(l==="./"||l===".\\")return[];{const w=l.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(N=>{const T=w.match(new RegExp(`^${P.$pe(N.name)}(?:/(.*)|$)`));return T?{match:T,folder:N}:null}).filter(I.$qf);if(O.length)return O.map(N=>{const T=N.match[1];return{searchPath:N.folder.uri,pattern:T&&h(T)}});{const N=l.match(/\.[\/\\](.+)[\/\\]?/),T=N?N[1]:l,j=D.localize(0,null,T);throw new Error(j)}}}}o(l,w){const A=l.pattern&&w?`${l.pattern}/${w}`:l.pattern||w,O=[{searchPath:l.searchPath,pattern:A}];return A&&!A.endsWith("**")&&O.push({searchPath:l.searchPath,pattern:A+"/**"}),O}q(l,w,A){const O=this.r((0,i.$Vh)(l.searchPath),w,A,!1);return O?{...O,includePattern:l.pattern}:null}r(l,w,A,O){let N;const T=p.URI.isUri(l)?l:l.uri;if(A.searchPaths){const q=A.searchPaths.filter(me=>(0,b.$ag)(me.searchPath,T))[0];if(q&&!q.pattern)return null;q&&(N=q.pattern)}const j=this.a.getValue({resource:T}),M={...this.l(j,w)||{},...N||{}},H=p.URI.isUri(l)?(0,b.$eg)(l):l.name;return{folder:T,folderName:O?H:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!j.search.followSymlinks}}};e.$rJ=g,e.$rJ=g=Ke([Be(0,v.$7h),Be(1,i.$Jh),Be(2,s.$2C),Be(3,r.$4i),Be(4,d.$pJ)],g);function t(u){const l=u.match(/[\*\{\}\(\)\[\]\?]/);if(l){const w=l.index,A=u.substr(0,w).match(/[/|\\][^/\\]*$/);if(A){let O=u.substr(0,A.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:u.substr((A.index||0)+1)}}}return{pathPortion:u}}function o(...u){return u.length?u.reduce((l,w)=>(l[w]=!0,l),Object.create(null)):void 0}function a(u){return f.$oj(u,",").map(l=>l.trim()).filter(l=>!!l.length)}function n(u){return[`**/${u}/**`,`**/${u}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function c(u){return u.replace(/\\/g,"/")}function h(u){return c(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(u){return u.replace(/([?*[\]])/g,"[$1]")}function y(u,l){u=C.$Jb(u,O=>O.toString());const w=[],A=l.getWorkspace();return u&&u.forEach(O=>{let N;if(l.getWorkbenchState()===2)N=(0,b.$jg)(A.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const T=l.getWorkspaceFolder(O);if(T){const j=T.name;if(A.folders.filter(M=>M.name===j).length===1){const M=(0,b.$jg)(T.uri,O);M===""?N=`./${T.name}`:N=`./${T.name}/${M}`}else N=O.fsPath}}N&&w.push(E(N))}),w}e.$sJ=y}),define(De[348],Ce([1,0,24,2,21,8,5,347,36,43]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klb=e.$jlb=void 0;const P=7e3;function I(v,r){const i=r.activationEvents;if(!i)return Promise.resolve(void 0);const s=[],d=[];for(const n of i)if(/^workspaceContains:/.test(n)){const c=n.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||v.forceUsingSearch?d.push(c):s.push(c)}if(s.length===0&&d.length===0)return Promise.resolve(void 0);let $;const g=new Promise((n,c)=>{$=n}),t=n=>$({activationEvent:n}),o=Promise.all(s.map(n=>p(v,n,t))).then(()=>{}),a=k(v,r.identifier,d,t);return Promise.all([o,a]).then(()=>{$(void 0)}),g}e.$jlb=I;async function p(v,r,i){for(const s of v.folders)if(await v.exists(C.$hg(F.URI.revive(s),r))){i(`workspaceContains:${r}`);return}}async function k(v,r,i,s){if(i.length===0)return Promise.resolve(void 0);const d=new f.$od,$=v.checkExists(v.folders,i,d.token),g=setTimeout(async()=>{d.cancel(),v.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let t=!1;try{t=await $}catch(o){L.$2(o)||L.$Y(o)}d.dispose(),clearTimeout(g),t&&s(`workspaceContains:${i.join(",")}`)}function D(v,r,i,s){const d=v.get(R.$zh),$=v.get(S.$fI),t=d.createInstance(m.$rJ).file(r.map(o=>(0,b.$Vh)(F.URI.revive(o))),{_reason:"checkExists",includePattern:i,exists:!0});return $.fileSearch(t,s).then(o=>!!o.limitHit,o=>L.$2(o)?!1:Promise.reject(o))}e.$klb=D}),define(De[45],Ce([1,0,204,16,53,24,11,3,77,2,14,6,40,286,115,39,27,148,8,25,22,262,7,65,5,26,91,20,105,73,44,4,348,114,264,17,112,37,12,113]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g,t,o,a,n,c,h,E,y,u,l,w,A,O,N,T,j,z,M){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=e.$vbc=e.$ubc=e.$tbc=e.$sbc=void 0,e.$sbc=(0,a.$Ah)("IHostUtils");let q=H=class extends m.$jc{constructor(G,U,K,Y,se,re,le,Ee,he,fe,te,ue){super(),this.X=ue,this.a=this.B(new l.$ed),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=K,this.f=le,this.j=Y,this.m=se,this.s=re,this.t=he,this.u=fe,this.w=te,this.y=this.g.getProxy(I.$TJ.MainThreadWorkspace),this.z=this.g.getProxy(I.$TJ.MainThreadTelemetry),this.C=this.g.getProxy(I.$TJ.MainThreadExtensionService),this.D=new R.$Eg,this.F=new R.$Eg,this.G=new R.$Eg,this.H=new R.$Eg,this.I=new ce(this.f.activationEvents),this.L=new i.$d3b(this.I,this.f.allExtensions);const be=new d.$Vl(this.f.myExtensions);this.J=new i.$d3b(this.I,_(this.L,be)),z.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new D.$_ac(this.g,this.s),this.N=new A.$lbc(this.g),this.O=Ee,this.h=G.createChild(new E.$yh([D.$abc,this.M],[A.$mbc,this.N])),this.P=this.B(new k.$$ac(this.J,this.L,{onExtensionActivationError:(Pe,B,X)=>{this.C.$onExtensionActivationError(Pe,s.$1(B),X)},actualActivateExtension:async(Pe,B)=>{if(i.$d3b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new k.$0ac;const X=this.J.getExtensionDescription(Pe);return this.db(X,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){s.$Y(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this.cb(se))}catch{}await Promise.all(G)}terminate(G,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),s.setUnexpectedErrorHandler(Y=>{this.s.error(Y)}),this.g.dispose();const K=this.Y();Promise.race([(0,R.$Gg)(5e3),K]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const U=await this.C.$getExtension(G);return U&&{...U,identifier:new d.$Ul(U.identifier.value),extensionLocation:b.URI.revive(U.extensionLocation)}}Z(G,U){return this.P.activateByEvent(G,U)}$(G,U){return this.P.activateById(G,U)}activateByIdWithErrors(G,U){return this.$(G,U).then(()=>{const K=this.P.getActivatedExtension(G);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===N.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(G.fsPath);return b.URI.file(U)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new ge(G))),this.Q}async bb(G){const U=S.$Gh.forUris(K=>L.$$f.ignorePathCasing(K));return await Promise.all(G.map(async K=>{if(this.ub(K)){const Y=await this.ab(K.extensionLocation);U.set(Y,K)}})),U}cb(G){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return U;const K=this.P.getActivatedExtension(G);if(!K)return U;try{typeof K.module.deactivate=="function"&&(U=Promise.resolve(K.module.deactivate()).then(void 0,Y=>(this.s.error(Y),Promise.resolve(void 0))))}catch(Y){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(Y)}try{(0,m.$ec)(K.subscriptions)}catch(Y){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(Y)}return U}async db(G,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,U).then(K=>{const Y=K.activationTimes;return this.C.$onDidActivateExtension(G.identifier,Y.codeLoadingTime,Y.activateCallTime,Y.activateResolvedTime,U),this.eb(G,U,"success",Y),K},K=>{throw this.eb(G,U,"failure"),K})}eb(G,U,K,Y){const se=x(G,U);this.z.$publicLog2("extensionActivationTimes",{...se,...Y||{},outcome:K})}fb(G,U){const K=x(G,U);this.z.$publicLog2("activatePlugin",K);const Y=this.ub(G);if(!Y)return Promise.resolve(new k.$9ac(k.$6ac.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${G.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const se=new k.$7ac(U.startup);return Promise.all([this.vb(G,(0,L.$hg)(G.extensionLocation,Y),se),this.gb(G)]).then(re=>(f.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),H.hb(this.s,G.identifier,re[0],re[1],se))).then(re=>(f.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),re))}gb(G){const U=new g.$cbc(G,this.M),K=new g.$bbc(G.identifier.value,!1,this.M),Y=new O.$nbc(G,this.N),se=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([U.whenReady,K.whenReady,this.O.whenReady]).then(()=>{const le=this;let Ee,he;const fe=(0,r.$MF)(G,"ipc")?this.f.messagePorts?.get(d.$Ul.toKey(G.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:K,secrets:Y,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(te){return F.$8d(G.extensionLocation.fsPath,te)},get storagePath(){return le.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return le.O.globalValue(G).fsPath},get logPath(){return F.$8d(le.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return b.URI.joinPath(le.f.logsLocation,G.identifier.value)},get storageUri(){return le.O.workspaceValue(G)},get globalStorageUri(){return le.O.globalValue(G)},get extensionMode(){return se},get extension(){return Ee===void 0&&(Ee=new V(le,G.identifier,G,re,!1)),Ee},get extensionRuntime(){return(0,r.$NF)(G,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!he){if(!fe)return;const te=l.Event.buffer(l.Event.fromDOMEventEmitter(fe,"message",ue=>ue.data));fe.start(),he={onDidReceiveMessage:te,postMessage:fe.postMessage.bind(fe)}}return he}})})}static hb(G,U,K,Y,se){return K=K||{activate:void 0,deactivate:void 0},this.ib(G,U,K,Y,se).then(re=>new k.$8ac(!1,null,se.build(),K,re,Y.subscriptions))}static ib(G,U,K,Y,se){if(typeof K.activate=="function")try{se.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${U.value}`);const re=typeof global=="object"?global:self,le=K.activate.apply(re,[Y]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(le).then(Ee=>(se.activateResolveStop(),Ee))}catch(re){return Promise.reject(re)}else return Promise.resolve(K)}jb(G,U){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:U}).then(void 0,K=>{this.s.error(K)})}kb(G,U=0){const Y=Date.now();(0,z.$A)(()=>{for(let se=U;se<G.length;se+=1){const re=G[se];for(const le of re.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-Y>50){this.kb(G,se);break}else this.jb(re,le)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(G=>{const U=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),K=this.J.getAllExtensionDescriptions();if(U)this.kb(K);else for(const Y of K)if(Y.activationEvents)for(const se of Y.activationEvents)se==="onStartupFinished"&&this.jb(Y,se)})}mb(){const G=this.Z("*",!0).then(void 0,re=>{this.s.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.nb(re.added)));const U=this.j.workspace?this.j.workspace.folders:[],K=this.nb(U),Y=this.pb(),se=Promise.all([Y,G,K]).then(()=>{});return Promise.race([se,(0,R.$Gg)(1e4)]).then(()=>{this.lb()}),se}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(G,U))).then(()=>{})}async ob(G,U){if(this.isActivated(U.identifier))return;const K=!this.f.remote.isRemote&&!!this.f.remote.authority,Y={logService:this.s,folders:G.map(re=>re.uri),forceUsingSearch:K||!this.c.fsExists,exists:re=>this.c.fsExists(re.fsPath),checkExists:(re,le,Ee)=>this.y.$checkExists(re,le,Ee)},se=await(0,w.$jlb)(Y,U);if(se)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:se.activationEvent}).then(void 0,re=>this.s.error(re))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:U}=this.f.environment;if(!G||!U)throw new Error(C.localize(0,null));const K=await this.vb(null,U,new k.$7ac(!1));if(!K||typeof K.run!="function")throw new Error(C.localize(1,null,U.toString()));return new Promise((Y,se)=>{const re=(he,fe)=>{he?se(he):Y(typeof fe=="number"&&fe>0?1:0)},le=(0,L.$8f)(U),Ee=K.run(le,re);Ee&&Ee.then&&Ee.then(()=>{Y(0)}).catch(he=>{se(he instanceof Error&&he.stack?he.stack:String(he))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Gg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,U){return this.R[G]=U,(0,m.$hc)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:U}=await this.sb(G);return U?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const U=G.indexOf("+");if(U===-1)throw new t.$2J("Not an authority that can be resolved!",o.RemoteAuthorityResolverErrorCode.InvalidAuthority);const K=G.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this.R[K]}}async $resolveAuthority(G,U){const K=j.$ad.create(!1),Y=()=>`[resolveAuthority(${(0,o.$Mk)(G)},${U})][${K.elapsed()}ms] `,se=ne=>this.s.info(`${Y()}${ne}`),re=ne=>this.s.warn(`${Y()}${ne}`),le=(ne,Z=void 0)=>this.s.error(`${Y()}${ne}`,Z),Ee=ne=>{if(ne instanceof t.$2J)return{type:"error",error:{code:ne._code,message:ne._message,detail:ne._detail}};throw ne},he=async ne=>{se(`activating resolver for ${ne}...`);const{resolver:Z,authorityPrefix:de}=await this.sb(ne);if(!Z)throw le(`no resolver for ${de}`),new t.$2J(`No remote extension installed to resolve ${de}.`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:de,remoteAuthority:ne}},fe=G.split(/@|%40/g).reverse();se(`activating remote resolvers ${fe.join(" -> ")}`);let te;try{te=await Promise.all(fe.map(he)).catch(async ne=>{if(!(ne instanceof t.$2J)||ne._code!==o.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ne;return re(`resolving nested authorities failed: ${ne.message}`),[await he(G)]})}catch(ne){return Ee(ne)}const ue=new R.$Qg;ue.cancelAndSet(()=>se("waiting..."),1e3);let be,Pe;for(const[ne,{authorityPrefix:Z,resolver:de,remoteAuthority:ye}]of te.entries())try{if(ne===te.length-1)se("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${Z}`),be=await de.resolve(ye,{resolveAttempt:U,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${Z}`),se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(de,t.$1J.isManagedResolvedAuthority(be)?be:void 0));else{if(se(`invoking resolveExecServer() for ${ye}`),f.mark(`code/extHost/willResolveExecServer/${Z}`),Pe=await de.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$2J(`Exec server was not available for ${ye}`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(je){return f.mark(`code/extHost/didResolveAuthorityError/${Z}`),le("returned an error",je),ue.dispose(),Ee(je)}ue.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},X={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};se(`returned ${t.$1J.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let ee;if(t.$1J.isManagedResolvedAuthority(be)){const ne=U;this.X.setFactory(ne,be.makeConnection),ee={authority:G,connectTo:new o.$Jk(ne),connectionToken:be.connectionToken}}else ee={authority:G,connectTo:new o.$Kk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:ee,options:X,tunnelInformation:B}}}async $getCanonicalURI(G,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,o.$Mk)(G)})`);const{resolver:K}=await this.sb(G);if(!K)return null;const Y=b.URI.revive(U);if(typeof K.getCanonicalURI>"u")return Y;const se=await(0,R.$yg)(()=>K.getCanonicalURI(Y));return se||Y}$startExtensionHost(G){G.toAdd.forEach(Y=>Y.extensionLocation=b.URI.revive(Y.extensionLocation));const{globalRegistry:U,myExtensions:K}=me(this.I,this.L,this.J,G);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(K),z.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(G,U){return U===1?this.D.wait().then(K=>this.Z(G,!1)):this.G.wait().then(K=>this.Z(G,!1))}async $activate(G,U){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,U),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(re=>re.extensionLocation=b.URI.revive(re.extensionLocation));const{globalRegistry:U,myExtensions:K}=me(this.I,this.L,this.J,G),Y=await this.bb(K);return(await this.getExtensionPathIndex()).setSearchTree(Y),this.L.set(U.getAllExtensionDescriptions()),this.J.set(K),z.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const U=$.$Ed.alloc(G),K=Math.random()%256;for(let Y=0;Y<G;Y++)U.writeUInt8(K,Y);return U}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$tbc=q,e.$tbc=q=H=Ke([Be(0,a.$zh),Be(1,e.$sbc),Be(2,h.$VL),Be(3,v.$Yac),Be(4,p.$2ac),Be(5,P.$4i),Be(6,n.$_L),Be(7,c.$fbc),Be(8,y.$csb),Be(9,u.$hbc),Be(10,T.$pbc),Be(11,M.$qbc)],q);function me(we,G,U,K){we.addActivationEvents(K.addActivationEvents);const Y=new i.$d3b(we,G.getAllExtensionDescriptions());Y.deltaExtensions(K.toAdd,K.toRemove);const se=new d.$Vl(U.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of K.myToRemove)se.delete(le);for(const le of K.myToAdd)se.add(le);const re=_(Y,se);return{globalRegistry:Y,myExtensions:re}}function x(we,G){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function Q(we){return we.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$ubc=(0,a.$Ah)("IExtHostExtensionService");class V{#e;#t;#i;constructor(G,U,K,Y,se){this.#e=G,this.#t=U,this.#i=K.identifier,this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=F.$6d((0,L.$8f)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=Y,this.isFromDifferentExtensionHost=se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$vbc=V;function _(we,G){return we.getAllExtensionDescriptions().filter(U=>G.has(U.identifier))}class ge{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$wbc=ge;class ce{constructor(G){this.a=new d.$Wl,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)}addActivationEvents(G){for(const U of Object.keys(G))this.a.set(U,G[U])}}}),define(De[349],Ce([1,0,53,2,6,40,27,25,20,26,5,45,14,15]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;let v=class{constructor($,g,t,o,a,n,c){this.c=$,this.d=g,this.e=t,this.f=o,this.g=a,this.h=n,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const $=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const g=await this.g.getExtensionPathIndex();this.register(new i(this.c,g,this.d,$,this.i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(s,g,this.h.environment.appUriScheme))}register($){if("nodeModuleName"in $)if(Array.isArray($.nodeModuleName))for(const g of $.nodeModuleName)this.a.set(g,$);else this.a.set($.nodeModuleName,$);typeof $.alternativeModuleName=="function"&&this.b.push(g=>$.alternativeModuleName(g))}};e.$Scc=v,e.$Scc=v=Ke([Be(2,P.$zh),Be(3,L.$2ac),Be(4,I.$ubc),Be(5,b.$_L),Be(6,p.$4i)],v);let r=class{static{D=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor($){if($.environment.appRoot&&D.a.size){const g=(0,k.$pe)(this.c($.environment.appRoot.fsPath)),t="[a-z0-9_.-]",o=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${g}/${a}\\/)(${o})(.*)$`,"i")}}alternativeModuleName($){if(!this.b)return;const g=this.b.exec(this.c($));if(!g)return;const[,t,o,a]=g,n=D.a.get(o);if(n!==void 0)return console.warn(`${o} as been renamed to ${n}, please update your imports`),t+n+a}c($){return $.replace(/\\/g,"/")}};r=D=Ke([Be(0,b.$_L)],r);class i{constructor($,g,t,o,a){this.c=$,this.d=g,this.e=t,this.f=o,this.g=a,this.nodeModuleName="vscode",this.a=new m.$Wl}load($,g){const t=this.d.findSubstr(g);if(t){let o=this.a.get(t.identifier);return o||(o=this.c(t,this.e,this.f),this.a.set(t.identifier,o)),o}if(!this.b){let o="";this.d.forEach((a,n)=>o+=`	${n} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${g}. These are the extension path mappings: 
${o}`),this.b=this.c(R.$HF,this.e,this.f)}return this.b}}let s=class{constructor($,g,t){this.e=$,this.f=g,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$TJ.MainThreadTelemetry);const o=t.getProxy(f.$TJ.MainThreadWindow);this.c=(a,n)=>{const c=F.URI.parse(a);return n?this.g(a,n):c.scheme==="http"||c.scheme==="https"?o.$openUri(c,a,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?o.$openUri(c,a,{}):this.g(a,n)}}load($,g,t){const o=this.e.findSubstr(g);return o&&(this.a=o.identifier.value,this.h()),this.b=t($),this.c}g($,g){return this.i(),this.b($,g)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};s=Ke([Be(2,S.$VL)],s)}),define(De[55],Ce([1,0,59,3,16,47,5,70,71,45,7,39,278,40]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0,e.$3bc=(0,R.$Ah)("IExtHostVariableResolverProvider");class D extends p.$WM{constructor(i,s,d,$,g,t,o){function a(){if(d){const n=d.activeEditor();if(n)return n.document.uri;const c=$.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof P.$CL||c.input instanceof P.$HL)return c.input.modified;if(c.input instanceof P.$BL||c.input instanceof P.$GL||c.input instanceof P.$EL)return c.input.uri}}}super({getFolderUri:n=>{const c=t.folders.filter(h=>h.name===n);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,c)=>g.getConfiguration(void 0,n).get(c),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=a();if(n)return f.$6d(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(s){const n=a();if(n){const c=s.getWorkspaceFolder(n);if(c)return f.$6d(c.uri.fsPath)}}},getSelectedText:()=>{if(d){const n=d.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(d){const n=d.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>i.getExtension(n)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(L.env))}}let v=class extends F.$jc{constructor(i,s,d,$,g){super(),this.b=i,this.c=s,this.g=d,this.h=$,this.j=g,this.a=new C.$T(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async n=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$4bc=v,e.$4bc=v=Ke([Be(0,b.$ubc),Be(1,I.$Yac),Be(2,m.$7L),Be(3,k.$2ac),Be(4,S.$1bc)],v)}),define(De[95],Ce([1,0,11,4,2,5,6,71,45,20,7,39,140,271,40,55]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.$8bc=e.$7bc=e.$6bc=e.$5bc=void 0,e.$5bc=(0,L.$Ah)("IExtHostDebugService");let r=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(o,a,n,c,h,E){this.E=a,this.F=n,this.G=c,this.H=h,this.I=E,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$ed,this.n=new F.$ed,this.o=new F.$ed,this.u=new F.$ed,this.k=o.getProxy(R.$TJ.MainThreadDebugService),this.y=new F.$ed,this.A=new F.$ed,this.v=new s(this.k),this.w=new Map,this.F.getExtensionRegistry().then(y=>{y.onDidChange(u=>{this.J(y)}),this.J(y)})}asDebugSourceUri(o,a){const n=o;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let c=`debug:${encodeURIComponent(n.path||"")}`,h="?";return a&&(c+=`${h}session=${encodeURIComponent(a.id)}`,h="&"),c+=`${h}ref=${n.sourceReference}`,f.URI.parse(c)}else{if(n.path)return f.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(o){const a=[];for(const n of o.getAllExtensionDescriptions())if(n.contributes){const c=n.contributes.debuggers;if(c&&c.length>0)for(const h of c)(0,k.$jF)(h)&&a.push(h.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const o=[];return this.w.forEach(a=>o.push(a)),o}addBreakpoints(o){const a=o.filter(h=>{const E=h.id;return this.w.has(E)?!1:(this.w.set(E,h),!0)});this.U(a,[],[]);const n=[],c=new Map;for(const h of a)if(h instanceof P.$VK){let E=c.get(h.location.uri.toString());E||(E={type:"sourceMulti",uri:h.location.uri,lines:[]},c.set(h.location.uri.toString(),E),n.push(E)),E.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof P.$WK&&n.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(n)}removeBreakpoints(o){const a=o.filter(E=>this.w.delete(E.id));this.U([],a,[]);const n=a.filter(E=>E instanceof P.$VK).map(E=>E.id),c=a.filter(E=>E instanceof P.$WK).map(E=>E.id),h=a.filter(E=>E instanceof P.$XK).map(E=>E.id);return this.k.$unregisterBreakpoints(n,c,h)}startDebugging(o,a,n){return this.k.$startDebugging(o?o.uri:void 0,a,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(o){return this.k.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,a,n){if(!a)return new P.$VJ(()=>{});const c=this.d++;return this.f.push({type:o,handle:c,provider:a}),this.k.$registerDebugConfigurationProvider(o,n,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,c),new P.$VJ(()=>{this.f=this.f.filter(h=>h.provider!==a),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(o,a,n){if(!n)return new P.$VJ(()=>{});if(!this.Q(o,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:a,handle:c,factory:n}),this.k.$registerDebugAdapterDescriptorFactory(a,c),new P.$VJ(()=>{this.h=this.h.filter(h=>h.factory!==n),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(o,a){if(!a)return new P.$VJ(()=>{});const n=this.i++;return this.j.push({type:o,handle:n,factory:a}),new P.$VJ(()=>{this.j=this.j.filter(c=>c.factory!==a)})}async $runInTerminal(o,a){return Promise.resolve(void 0)}async $substituteVariables(o,a){let n;const c=await this.W(o);return c&&(n={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(n,a)}K(o,a){if(o.type==="implementation")return new $(o.implementation)}L(){}async $startDASession(o,a){const n=this,c=await this.V(a);return this.S(this.N(c.type),c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const E=this.M(h),y=this.K(E,c);if(!y)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const u=y;return this.B.set(o,u),this.R(c).then(l=>(l&&this.C.set(o,l),u.onMessage(async w=>{if(w.type==="request"&&w.command==="handshake"){const A=w,O={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const N=await this.D.sign(A.arguments.value);O.body={signature:N},u.sendResponse(O)}else throw new Error("no signer")}catch(N){O.success=!1,O.message=N.message,u.sendResponse(O)}}else l&&l.onDidSendMessage&&l.onDidSendMessage(w),w=(0,k.$oF)(w,!0),n.k.$acceptDAMessage(o,w)}),u.onError(w=>{l&&l.onError&&l.onError(w),this.k.$acceptDAError(o,w.name,w.message,w.stack)}),u.onExit(w=>{l&&l.onExit&&l.onExit(w??void 0,void 0),this.k.$acceptDAExit(o,w??void 0,void 0)}),l&&l.onWillStartSession&&l.onWillStartSession(),u.startSession()))})}$sendDAMessage(o,a){a=(0,k.$nF)(a,!1);const n=this.C.get(o);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(a),this.B.get(o)?.sendMessage(a)}$stopDASession(o){const a=this.C.get(o);this.C.delete(o),a&&a.onWillStopSession&&a.onWillStopSession();const n=this.B.get(o);return this.B.delete(o),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const a=[],n=[],c=[];if(o.added)for(const h of o.added){const E=h.id;if(E&&!this.w.has(E)){let y;if(h.type==="function")y=new P.$WK(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")y=new P.$XK(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const u=f.URI.revive(h.uri);y=new P.$VK(new P.$8J(u,new P.$WJ(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,P.$TK)(y,E),this.w.set(E,y),a.push(y)}}if(o.removed)for(const h of o.removed){const E=this.w.get(h);E&&(this.w.delete(h),n.push(E))}if(o.changed){for(const h of o.changed)if(h.id){const E=this.w.get(h.id);if(E){if(E instanceof P.$WK&&h.type==="function"){const y=E;y.enabled=h.enabled,y.condition=h.condition,y.hitCondition=h.hitCondition,y.logMessage=h.logMessage,y.functionName=h.functionName}else if(E instanceof P.$VK&&h.type==="source"){const y=E;y.enabled=h.enabled,y.condition=h.condition,y.hitCondition=h.hitCondition,y.logMessage=h.logMessage,y.location=new P.$8J(f.URI.revive(h.uri),new P.$WJ(h.line,h.character))}c.push(E)}}}this.U(a,n,c)}async $acceptStackFrameFocus(o){let a;const n=o.sessionId?await this.V(o.sessionId):void 0;if(!n)throw new Error("no DebugSession found for debug focus context");o.kind==="thread"?a=new P.$4K(n,o.threadId):a=new P.$3K(n,o.threadId,o.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(o,a,n){return(0,C.$yg)(async()=>{const c=this.P(o);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(a);return c.provideDebugConfigurations(h,n)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(o,a,n,c){return(0,C.$yg)(async()=>{const h=this.P(o);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.W(a);return h.resolveDebugConfiguration(E,n,c)})}$resolveDebugConfigurationWithSubstitutedVariables(o,a,n,c){return(0,C.$yg)(async()=>{const h=this.P(o);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.W(a);return h.resolveDebugConfigurationWithSubstitutedVariables(E,n,c)})}async $provideDebugAdapter(o,a){const n=this.O(o);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(a);return this.S(n,c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(o){const a=await this.V(o);this.m.fire(a)}async $acceptDebugSessionTerminated(o){const a=await this.V(o);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(o){this.q=o?await this.V(o):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(o,a){(await this.V(o))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(o,a){const c={session:await this.V(o),event:a.event,body:a.body};this.u.fire(c)}M(o){if(o instanceof P.$YK)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof P.$ZK)return{type:"server",port:o.port,host:o.host};if(o instanceof P.$1K)return{type:"pipeServer",path:o.path};if(o instanceof P.$2K)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}N(o){const a=this.h.filter(n=>n.type===o);if(a.length>0)return a[0].factory}O(o){const a=this.h.filter(n=>n.handle===o);if(a.length>0)return a[0].factory}P(o){const a=this.f.filter(n=>n.handle===o);if(a.length>0)return a[0].provider}Q(o,a){if(o.contributes){const n=o.contributes.debuggers;if(n&&n.length>0){for(const c of n)if(c.label&&c.type&&c.type===a)return!0}}return!1}R(o){const n=o.configuration.type,c=this.j.filter(h=>h.type===n||h.type==="*").map(h=>(0,C.$yg)(()=>h.factory.createDebugAdapterTracker(o)).then(E=>E,E=>null));return Promise.race([Promise.all(c).then(h=>{const E=h.filter(y=>!!y);if(E.length>0)return new d(E)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(o,a){const n=a.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new P.$ZK(n));if(o){const h=await this.F.getExtensionRegistry();return(0,C.$yg)(()=>o.createDebugAdapterDescriptor(a,this.T(a,h))).then(E=>{if(E)return E})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,c))}T(o,a){}U(o,a,n){(o.length>0||a.length>0||n.length>0)&&this.y.fire(Object.freeze({added:o,removed:a,changed:n}))}async V(o){if(o)if(typeof o=="string"){const a=this.l.get(o);if(a)return a}else{let a=this.l.get(o.id);if(!a){const n=await this.W(o.folderUri),c=o.parent?this.l.get(o.parent):void 0;a=new i(this.k,o.id,o.type,o.name,n,o.configuration,c),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(o){if(o){const a=f.URI.revive(o);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$6bc=r,e.$6bc=r=Ke([Be(0,b.$VL),Be(1,I.$Yac),Be(2,S.$ubc),Be(3,D.$2ac),Be(4,m.$1bc),Be(5,v.$3bc)],r);class i{constructor(o,a,n,c,h,E,y){this.d=o,this.f=a,this.g=n,this.h=c,this.i=h,this.j=E,this.k=y}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(o){this.h=o,this.d.$setDebugSessionName(this.f,o)}get parentSession(){return this.k}_acceptNameChanged(o){this.h=o}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(o,a){return this.d.$customDebugAdapterRequest(this.f,o,a)}getDebugProtocolBreakpoint(o){return this.d.$getDebugProtocolBreakpoint(this.f,o.id)}}e.$7bc=i;class s{constructor(o){this.value=Object.freeze({append(a){o.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$8bc=s;class d{constructor(o){this.d=o}onWillStartSession(){this.d.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(o):void 0)}onWillStopSession(){this.d.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.d.forEach(a=>a.onError?a.onError(o):void 0)}onExit(o,a){this.d.forEach(n=>n.onExit?n.onExit(o,a):void 0)}}class $ extends p.$rcb{constructor(o){super(),this.h=o,o.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.h.handleMessage(o)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let g=class extends r{constructor(o,a,n,c,h,E){super(o,a,n,c,h,E)}};e.$9bc=g,e.$9bc=g=Ke([Be(0,b.$VL),Be(1,I.$Yac),Be(2,S.$ubc),Be(3,D.$2ac),Be(4,m.$1bc),Be(5,v.$3bc)],g)}),define(De[350],Ce([1,0,8,53,2,6,341,14,104,105,26,238,20,67,45,89]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=e.$Tcc=void 0;class r{static async installEarlyHandler(d){Error.stackTraceLimit=100;const $=d.get(m.$4i),t=d.get(p.$VL).getProxy(L.$TJ.MainThreadErrors);C.setUnexpectedErrorHandler(o=>{$.error(o);const a=C.$1(o);t.$onUnexpectedError(a)})}static async installFullHandler(d){const $=d.get(m.$4i),g=d.get(p.$VL),t=d.get(D.$ubc),o=d.get(v.$dM),a=g.getProxy(L.$TJ.MainThreadExtensionService),n=g.getProxy(L.$TJ.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function E(l,w){if(h.has(l))return h.get(l).stack;let A="",O,N;for(const j of w)A+=`
	at ${j.toString()}`,N=j.getFileName(),!O&&N&&(O=c.findSubstr(f.URI.file(N)));const T=`${l.name||"Error"}: ${l.message||""}${A}`;return h.set(l,{extensionIdentifier:O?.identifier,stack:T}),T}const y=Symbol("prepareStackTrace wrapped");let u=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(l){if(l===E||!l||l[y]){u=l||E;return}u=function(w,A){return E(w,A),l.call(Error,w,A)},Object.assign(u,{[y]:!0})}}),C.setUnexpectedErrorHandler(l=>{$.error(l);const w=C.$1(l),A=h.get(l);if(!A?.extensionIdentifier){n.$onUnexpectedError(w);return}a.$onExtensionRuntimeError(A.extensionIdentifier,w);const O=o.onExtensionError(A.extensionIdentifier,l);$.trace("forwarded error to extension?",O,A)})}}e.$Tcc=r;class i{constructor(d,$,g,t,o){this.a=g,this.b=new R.$l3b(d,null,t),$=i.e($,this.b);const a=new b.$yh(...(0,S.$lr)());a.set(P.$_L,{_serviceBrand:void 0,...$,messagePorts:o}),a.set(p.$VL,new p.$WL(this.b)),a.set(k.$Vac,new k.$Wac(t)),a.set(D.$sbc,g);const n=new I.$4p(a,!0);n.invokeFunction(r.installEarlyHandler),this.d=n.invokeFunction(c=>c.get(m.$4i)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",$),this.c=n.invokeFunction(c=>c.get(D.$ubc)),this.c.initialize(),n.invokeFunction(r.installFullHandler)}async asBrowserUri(d){const $=this.b.getProxy(L.$TJ.MainThreadExtensionService);return f.URI.revive(await $.$asBrowserUri(d))}terminate(d){this.c.terminate(d)}static e(d,$){d.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive($.transformIncomingURIs(t.extensionLocation))}),d.environment.appRoot=f.URI.revive($.transformIncomingURIs(d.environment.appRoot));const g=d.environment.extensionDevelopmentLocationURI;return g&&(d.environment.extensionDevelopmentLocationURI=g.map(t=>f.URI.revive($.transformIncomingURIs(t)))),d.environment.extensionTestsLocationURI=f.URI.revive($.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=f.URI.revive($.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=f.URI.revive($.transformIncomingURIs(d.environment.workspaceStorageHome)),d.environment.extensionTelemetryLogResource=f.URI.revive($.transformIncomingURIs(d.environment.extensionTelemetryLogResource)),d.nlsBaseUrl=f.URI.revive($.transformIncomingURIs(d.nlsBaseUrl)),d.logsLocation=f.URI.revive($.transformIncomingURIs(d.logsLocation)),d.workspace=$.transformIncomingURIs(d.workspace),d}}e.$Ucc=i}),define(De[351],Ce([1,0,11,12,215,232,138,95,71,45,20,44,7,55,39,272,273,40]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;let s=class extends m.$6bc{constructor(o,a,n,c,h,E,y){super(o,a,n,c,E,y),this.Z=h,this.X=new g}K(o,a){switch(o.type){case"server":return new v.$Zcc(o);case"pipeServer":return new v.$1cc(o);case"executable":return new v.$2cc(o,a.type)}return super.K(o,a)}T(o,a){const n=v.$2cc.platformAdapterExecutable(a.getAllExtensionDescriptions(),o.type);if(n)return new p.$YK(n.command,n.args,n.options)}L(){return new R.$Z6b}async $runInTerminal(o,a){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(T=>{this.X.onTerminalClosed(T)}));const n=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),E=o.title||f.localize(0,null),y=JSON.stringify({shell:c,shellArgs:h});let u=await this.X.checkout(y,E),l,w=!1;if(u)l=o.cwd;else{const T={shellPath:c,shellArgs:h,cwd:o.cwd,name:E,iconPath:new p.$QK("debug")};w=!0,u=this.Z.createTerminalFromOptions(T,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(u,y)}u.show(!0);const A=await u.processId;w?await new Promise(T=>setTimeout(T,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?u.sendText("cls"):c.indexOf("bash")>=0?u.sendText("clear"):F.$i?u.sendText("cls"):u.sendText("clear"));const O=(0,r.$4cc)(c,o.args,!!o.argsCanBeInterpretedByShell,l,o.env);u.sendText(O);const N=this.onDidTerminateDebugSession(T=>{T.id===a&&(this.X.free(u),N.dispose())});return A}else if(o.kind==="external")return $(o,await this.G.getConfigProvider());return super.$runInTerminal(o,a)}};e.$5cc=s,e.$5cc=s=Ke([Be(0,P.$VL),Be(1,D.$Yac),Be(2,b.$ubc),Be(3,i.$2ac),Be(4,I.$hbc),Be(5,S.$1bc),Be(6,k.$3bc)],s);let d;function $(t,o){if(!d)if(F.$i)d=new L.$I5b;else if(F.$j)d=new L.$J5b;else if(F.$k)d=new L.$K5b;else throw new Error("external terminals not supported on this platform");const a=o.getConfiguration("terminal");return d.runInTerminal(t.title,t.cwd,t.args,t.env||{},a.external||{})}class g{constructor(){this.b=new Map}static{this.a=1e3}async checkout(o,a){const c=[...this.b.entries()].map(([h,E])=>(0,C.$tg)(async y=>{if(h.name!==a||E.lastUsedAt!==-1&&await(0,r.$3cc)(await h.processId))return null;const u=Date.now();return E.lastUsedAt+g.a>u||y.isCancellationRequested||E.config!==o?null:(E.lastUsedAt=u,h)}));return await(0,C.$Kg)(c,h=>!!h)}insert(o,a){this.b.set(o,{lastUsedAt:Date.now(),config:a})}free(o){const a=this.b.get(o);a&&(a.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}}),define(De[352],Ce([1,0,16,2,102,39,70,40,43,44,20,26,94,17,14,90,24,64,55]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;let d=class extends p.$Xbc{constructor(g,t,o,a,n,c,h,E,y){super(g,t,o,a,n,c,h,E),this.B=o,this.C=y,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,t){const o=t;if(!t.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const a=p.TaskHandleDTO.from(o,this.B),n=await this.a.$getTaskExecution(a);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(n,t);return this.a.$executeTask(a).catch(()=>{}),c}else{const a=p.TaskDTO.from(t,g);if(a===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(a.execution)&&await this.x(a,t,!1);const n=await this.y(await this.a.$getTaskExecution(a),t);return this.a.$executeTask(a).catch(()=>{}),n}}u(g,t,o,a){const n=[];if(a)for(const c of a){this.z(c,o),(!c.definition||!g[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=p.TaskDTO.from(c,o.extension);h&&(n.push(h),p.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,c,!0)))}return{tasks:n,extension:o.extension}}async v(g){return g}async F(g){let t=g&&g.length>0?g[0]:void 0;if(!t){const o=F.URI.file((0,i.homedir)());t=new S.$Uh({uri:o,name:r.$eg(o),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,t){const o=F.URI.revive(g),a={process:void 0,variables:Object.create(null)},n=await this.b.resolveWorkspaceFolder(o),c=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),E=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const y of t.variables)a.variables[y]=await h.resolveAsync(E,y);if(t.process!==void 0){let y;if(t.process.path!==void 0){y=t.process.path.split(C.$fe);for(let u=0;u<y.length;u++)y[u]=await h.resolveAsync(E,y[u])}a.process=await f.win32.findExecutable(await h.resolveAsync(E,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(E,t.process.cwd):void 0,y)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(g,t,o){return f.win32.findExecutable(g,t,o)}};e.$Wcc=d,e.$Wcc=d=Ke([Be(0,P.$VL),Be(1,I.$_L),Be(2,L.$Yac),Be(3,R.$7L),Be(4,m.$2ac),Be(5,b.$hbc),Be(6,D.$4i),Be(7,v.$Oac),Be(8,s.$3bc)],d)}),define(De[353],Ce([1,0,64,55]),function($e,e,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class f extends F.$4bc{m(){return(0,C.homedir)()}}e.$Cdc=f}),define(De[153],Ce([1,0,19,11,21,46,17,16,24,2,36]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=e.$_bc=e.$$bc=void 0;class I{constructor(s,d,$,g){this.d=s,this.e=d,this.f=$,this.g=g,this.a=null,this.b=!1,this.c=0}search(s,d){const $=this.d.folderQueries||[],g=new f.$od(d);return new Promise((t,o)=>{this.a=new k(s);let a=!1;const n=(c,h)=>{if(!a&&!this.b){const E=this.h(c);v(c)&&typeof this.d.maxResults=="number"&&this.c+E>this.d.maxResults&&(this.b=!0,a=!0,g.cancel(),c=this.j(c,this.d.maxResults-this.c));const y=this.h(c);this.c+=y,(y>0||!v(c))&&this.a.add(c,h)}};Promise.all($.map((c,h)=>this.k(c,E=>n(E,h),g.token))).then(c=>{g.dispose(),this.a.flush();const h=c.some(E=>!!E&&!!E.limitHit);t({limitHit:this.b||h,messages:(0,C.$Ob)(c.map(E=>E?.message?Array.isArray(E.message)?E.message:[E.message]:[])),stats:{type:this.g}})},c=>{g.dispose();const h=(0,L.$li)(c);o(new Error(h))})})}h(s){return v(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}j(s,d){const $=Array.isArray(s.ranges)?s.ranges:[s.ranges],g=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:$.slice(0,d),preview:{matches:g.slice(0,d),text:s.preview.text},uri:s.uri}}async k(s,d,$){const g=new P.$yI(this.d,s),t=[],o={report:c=>{if(!this.l(c))return;const h=s.folder.scheme===R.Schemas.file?(0,P.$zI)(()=>this.f.readdir(S.$gg(c.uri))):void 0,E=S.$jg(s.folder,c.uri);if(E){const y=g.includedInQuery(E,m.$_d(E),h);(0,F.$sg)(y)?t.push(y.then(u=>{u&&d(c)})):y&&d(c)}}},a=this.n(s),n=await this.e.provideTextSearchResults(p(this.d.contentPattern),a,o,$);return t.length&&await Promise.all(t),n}l(s){if(v(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(s){const d=(0,P.$xI)(this.d.includePattern,s.includePattern),$=(0,P.$xI)(this.d.excludePattern,s.excludePattern),g={folder:b.URI.from(s.folder),excludes:$,includes:d,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.f.toCanonicalName(s.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.$$bc=I;function p(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class k{constructor(s){this.e=s,this.b=-1,this.d=null,this.a=new r(512,d=>this.g(d))}add(s,d){this.d&&(this.b!==d||!S.$ag(this.c,s.uri))&&(this.f(),this.d=null),this.d||(this.b=d,this.d={resource:s.uri,results:[]}),this.d.results.push(D(s))}f(){const s=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,s)}flush(){this.f(),this.a.flush()}g(s){this.e(s)}}e.$_bc=k;function D(i){return v(i)?{preview:{matches:(0,C.$Yb)(i.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:i.preview.text},ranges:(0,C.$Yb)(i.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function v(i){return!!i.preview}e.$acc=v;class r{static{this.a=4e3}static{this.b=50}constructor(s,d){this.g=s,this.h=d,this.c=0,this.d=[],this.e=0}addItem(s,d){s&&this.j(s,d)}addItems(s,d){s&&this.k(s,d)}j(s,d){this.d.push(s),this.e+=d,this.l()}k(s,d){this.d=this.d.concat(s),this.e+=d,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$bcc=r}),define(De[96],Ce([1,0,3,6,5,346,20,67,14,2,153]),function($e,e,C,F,f,L,R,m,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=e.$ccc=void 0,e.$ccc=(0,f.$Ah)("IExtHostSearch");let I=class{constructor(v,r,i){this.k=v,this.l=r,this.n=i,this.c=this.k.getProxy(F.$TJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$0bc}o(v){return this.l.transformOutgoingScheme(v)}registerTextSearchProvider(v,r){if(this.g.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this.g.add(v);const i=this.d++;return this.e.set(i,r),this.c.$registerTextSearchProvider(i,this.o(v)),(0,C.$hc)(()=>{this.g.delete(v),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(v,r){if(this.i.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this.i.add(v);const i=this.d++;return this.h.set(i,r),this.c.$registerFileSearchProvider(i,this.o(v)),(0,C.$hc)(()=>{this.i.delete(v),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(v,r,i,s){const d=p(i),$=this.h.get(v);if($)return this.j.fileSearch(d,$,g=>{this.c.$handleFileMatch(v,r,g.map(t=>t.resource))},s);throw new Error("unknown provider: "+v)}$clearCache(v){return this.j.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,r,i,s){const d=this.e.get(v);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const $=p(i);return this.q($,d).search(t=>this.c.$handleTextMatch(v,r,t),s)}$enableExtensionHostSearch(){}q(v,r){return new P.$$bc(v,r,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$dcc=I,e.$dcc=I=Ke([Be(0,R.$VL),Be(1,m.$Vac),Be(2,S.$4i)],I);function p(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(k),extraFileResources:D.extraFileResources&&D.extraFileResources.map(v=>b.URI.revive(v))}}e.$ecc=p;function k(D){return{...D,folder:b.URI.revive(D.folder)}}}),define(De[354],Ce([1,0,21,8,4,38,2,130,125,168,185,30,6,111,301,300,33,302,40,304,305,306,280,307,70,45,309,310,315,316,317,152,284,323,324,326,115,44,328,287,13,7,85,331,92,151,39,25,276,314,66,149,94,95,96,14,67,20,26,318,274,73,90,294,329,91,72,334,332,333,295,54,327,330,114,71,89,319,93,320,17,134,283,263,312,3,27,270,112,257,321,322,296,311,282,313,113,325,297,298,299,293,308]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g,t,o,a,n,c,h,E,y,u,l,w,A,O,N,T,j,z,M,H,q,me,x,Q,V,_,ge,ce,we,G,U,K,Y,se,re,le,Ee,he,fe,te,ue,be,Pe,B,X,ee,ne,Z,de,ye,je,We,xe,Qe,it,et,Ae,Oe,Ve,Le,Xe,ae,oe,Ie,qe,ze,Ze,nt,ot,bt,Dt,Xt,Vt,vt,Ft,Ot,Kt,At,Rt,Nt,Ut,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;function Bt(ct){const lt=ct.get(he.$_L),Jt=ct.get(je.$Lac),Pt=ct.get(ee.$ebc),kt=ct.get(n.$ubc),dt=ct.get(_.$Yac),Ct=ct.get(et.$dM),Mt=ct.get(s.$2ac),Et=ct.get(le.$Vac),Ge=ct.get(Ee.$VL),jt=ct.get(T.$abc),Te=ct.get(X.$fbc),Fe=ct.get(re.$5i),Se=ct.get(re.$4i),ie=ct.get(ue.$csb),Me=ct.get(be.$Oac),He=ct.get(V.$Sbc),_e=ct.get(Qe.$mbc),Je=ct.get(it.$1bc),rt=ct.get(Ot.$qbc);Ge.set(p.$UJ.ExtHostFileSystemInfo,Jt),Ge.set(p.$UJ.ExtHostLogLevelServiceShape,Fe),Ge.set(p.$UJ.ExtHostWorkspace,dt),Ge.set(p.$UJ.ExtHostConfiguration,Mt),Ge.set(p.$UJ.ExtHostExtensionService,kt),Ge.set(p.$UJ.ExtHostStorage,jt),Ge.set(p.$UJ.ExtHostTunnelService,ie),Ge.set(p.$UJ.ExtHostWindow,He),Ge.set(p.$UJ.ExtHostSecretState,_e),Ge.set(p.$UJ.ExtHostTelemetry,Ct),Ge.set(p.$UJ.ExtHostEditorTabs,Je),Ge.set(p.$UJ.ExtHostManagedSockets,rt);const pt=Ge.set(p.$UJ.ExtHostDecorations,ct.get(U.$Wbc)),wt=Ge.set(p.$UJ.ExtHostDocumentsAndEditors,ct.get(a.$7L)),ft=Ge.set(p.$UJ.ExtHostCommands,ct.get(r.$fM)),gt=Ge.set(p.$UJ.ExtHostTerminalService,ct.get(j.$hbc)),mt=Ge.set(p.$UJ.ExtHostDebugService,ct.get(Y.$5bc)),gi=Ge.set(p.$UJ.ExtHostSearch,ct.get(se.$ccc)),Ht=Ge.set(p.$UJ.ExtHostTask,ct.get(K.$Zbc)),Ei=Ge.set(p.$UJ.ExtHostOutputService,ct.get(l.$Cbc)),Wt=Ge.set(p.$UJ.ExtHostLocalization,ct.get(nt.$pbc)),mi=Ge.set(p.$UJ.ExtHostUrls,new x.$Lbc(Ge)),It=Ge.set(p.$UJ.ExtHostDocuments,new o.$Jac(Ge,wt)),ki=Ge.set(p.$UJ.ExtHostDocumentContentProviders,new g.$4ac(Ge,wt,Se)),Vi=Ge.set(p.$UJ.ExtHostDocumentSaveParticipant,new t.$5ac(Se,It,Ge.getProxy(p.$TJ.MainThreadBulkEdits))),St=Ge.set(p.$UJ.ExtHostNotebook,new fe.$icc(Ge,ft,wt,It,Pt)),ti=Ge.set(p.$UJ.ExtHostNotebookDocuments,new oe.$Acc(St)),$i=Ge.set(p.$UJ.ExtHostNotebookEditors,new ae.$zcc(Se,St)),si=Ge.set(p.$UJ.ExtHostNotebookKernels,new Ae.$wcc(Ge,lt,St,ft,Se)),Si=Ge.set(p.$UJ.ExtHostNotebookRenderers,new Ve.$ycc(Ge,St)),Di=Ge.set(p.$UJ.ExtHostNotebookDocumentSaveParticipant,new vt.$Gcc(Se,St,Ge.getProxy(p.$TJ.MainThreadBulkEdits))),Lt=Ge.set(p.$UJ.ExtHostEditors,new z.$Jbc(Ge,wt)),bi=Ge.set(p.$UJ.ExtHostTreeViews,new M.$Kbc(Ge.getProxy(p.$TJ.MainThreadTreeViews),ft,Se)),Ci=Ge.set(p.$UJ.ExtHostEditorInsets,new ce.$Tbc(Ge.getProxy(p.$TJ.MainThreadEditorInsets),Lt,lt.remote)),oi=Ge.set(p.$UJ.ExtHostDiagnostics,new d.$Nac(Ge,Se,Jt,wt)),ai=Ge.set(p.$UJ.ExtHostLanguages,new y.$zbc(Ge,It,ft.converter,Et)),ut=Ge.set(p.$UJ.ExtHostLanguageFeatures,new E.$Rac(Ge,Et,It,ft,oi,Se,Me,Ct)),qi=Ge.set(p.$UJ.ExtHostFileSystem,new c.$xbc(Ge,ut)),Qt=Ge.set(p.$UJ.ExtHostFileSystemEventService,new h.$ybc(Ge,Se,wt)),ii=Ge.set(p.$UJ.ExtHostQuickOpen,(0,A.$Ebc)(Ge,dt,ft)),pi=Ge.set(p.$UJ.ExtHostSCM,new O.$Gbc(Ge,ft,It,Se)),Ii=Ge.set(p.$UJ.ExtHostQuickDiff,new Dt.$Dcc(Ge,Et)),Hi=Ge.set(p.$UJ.ExtHostShare,new Kt.$Icc(Ge,Et)),Pi=Ge.set(p.$UJ.ExtHostComments,(0,i.$Uac)(Ge,ft,It)),wi=Ge.set(p.$UJ.ExtHostProgress,new w.$Dbc(Ge.getProxy(p.$TJ.MainThreadProgress))),Ki=Ge.set(p.$UJ.ExtHosLabelService,new we.$Ubc(Ge)),Ai=Ge.set(p.$UJ.ExtHostTheming,new te.$jcc(Ge)),ci=Ge.set(p.$UJ.ExtHostAuthentication,new Pe.$kcc(Ge)),Ji=Ge.set(p.$UJ.ExtHostTimeline,new B.$mcc(Ge,ft)),vi=Ge.set(p.$UJ.ExtHostWebviews,new Q.$Obc(Ge,lt.remote,dt,Se,Me)),Ri=Ge.set(p.$UJ.ExtHostWebviewPanels,new de.$occ(Ge,vi,dt)),cn=Ge.set(p.$UJ.ExtHostCustomEditors,new Z.$pcc(Ge,It,Te,vi,Ri)),Li=Ge.set(p.$UJ.ExtHostWebviewViews,new ne.$ncc(Ge,vi)),ni=Ge.set(p.$UJ.ExtHostTesting,new We.$rcc(Ge,ft,wt)),un=Ge.set(p.$UJ.ExtHostUriOpeners,new xe.$vcc(Ge)),ln=Ge.set(p.$UJ.ExtHostProfileContentHandlers,new bt.$Ccc(Ge));Ge.set(p.$UJ.ExtHostInteractive,new Ie.$Bcc(Ge,St,wt,ft,Se));const Gi=Ge.set(p.$UJ.ExtHostInlineChat,new Vt.$Fcc(Ge,ft,It,Se)),fi=Ge.set(p.$UJ.ExtHostChatProvider,new At.$Jcc(Ge,Se)),Yi=Ge.set(p.$UJ.ExtHostChatSlashCommands,new Rt.$Kcc(Ge,fi,Se)),Xi=Ge.set(p.$UJ.ExtHostChatVariables,new Nt.$Lcc(Ge)),ui=Ge.set(p.$UJ.ExtHostChat,new Xt.$Ecc(Ge,Se)),Qi=Ge.set(p.$UJ.ExtHostAiRelatedInformation,new Ut.$Mcc(Ge)),Ti=Ge.set(p.$UJ.ExtHostAiEmbeddingVector,new qt.$Ncc(Ge)),Zi=Ge.set(p.$UJ.ExtHostIssueReporter,new Ft.$Hcc(Ge)),Zt=Ge.set(p.$UJ.ExtHostStatusBar,new N.$Ibc(Ge,ft.converter)),yi=Object.values(p.$UJ);Ge.assertRegistered(yi);const hn=new ye.$qcc(Ge,wt),Gt=new v.$Tac(Ge),li=new u.$Abc(Ge,Se),Fi=new $.$3ac(Ge);return D.$Sac.register(ft),function(Ue,xt,Mi){const $t=function(){let pe=!Ue.isUnderDevelopment;function ke(){pe||(Se.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")ke();else{const yt=st;typeof yt.scheme>"u"&&ke(),typeof yt.exclusive=="boolean"&&(0,ze.$NF)(Ue,"documentFiltersExclusive")}return st}}(),xi={getSession(pe,ke,Ne){return ci.getSession(Ue,pe,ke,Ne)},getSessions(pe,ke){return(0,ze.$NF)(Ue,"authGetSessions"),ci.getSessions(Ue,pe,ke)},async hasSession(pe,ke){return(0,ze.$NF)(Ue,"authSession"),!!await ci.getSession(Ue,pe,ke,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(pe,ke,Ne,st){return ci.registerAuthenticationProvider(pe,ke,Ne,st)}},_i={registerCommand(pe,ke,Ne){return ft.registerCommand(!0,pe,ke,Ne,void 0,Ue)},registerTextEditorCommand(pe,ke,Ne){return ft.registerCommand(!0,pe,(...st)=>{const yt=Lt.getActiveTextEditor();if(!yt){Se.warn("Cannot execute "+pe+" because there is no active text editor.");return}return yt.edit(Tt=>{ke.apply(Ne,[yt,Tt,...st])}).then(Tt=>{Tt||Se.warn("Edits from command "+pe+" were not applied.")},Tt=>{Se.warn("An error occurred while running command "+pe,Tt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(pe,ke,Ne)=>((0,ze.$NF)(Ue,"diffCommand"),ft.registerCommand(!0,pe,async(...st)=>{const yt=wt.activeEditor(!0);if(!yt){Se.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Tt=await Lt.getDiffInformation(yt.id);ke.apply(Ne,[Tt,...st])},void 0,void 0,Ue)),executeCommand(pe,...ke){return ft.executeCommand(pe,...ke)},getCommands(pe=!1){return ft.getCommands(pe)}},en={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$NF)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$NF)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$cM)(lt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,ke){return et.$bM.validateSender(pe),Ct.instantiateLogger(Ue,pe,ke)},openExternal(pe,ke){return He.openUri(pe,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===lt.environment.appUriScheme)return mi.createAppUri(pe);try{return await He.asExternalUri(pe,{allowTunneling:!!lt.remote.authority})}catch(ke){if((0,Xe.$DT)(pe,Le.Schemas.http)||(0,Xe.$DT)(pe,Le.Schemas.https))return pe;throw ke}},get remoteName(){return(0,G.$Ok)(lt.remote.authority)},get remoteAuthority(){return(0,ze.$NF)(Ue,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,ze.$NF)(Ue,"handleIssueUri"),Zi.registerIssueUriRequestHandler(Ue,pe)},get appQuality(){return(0,ze.$NF)(Ue,"resolvers"),lt.quality},get appCommit(){return(0,ze.$NF)(Ue,"resolvers"),lt.commit}};lt.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(pe,ke,Ne){return ni.createTestController(Ue,pe,ke,Ne)},createTestObserver(){return(0,ze.$NF)(Ue,"testObserver"),ni.createTestObserver()},runTests(pe){return(0,ze.$NF)(Ue,"testObserver"),ni.runTests(pe)},get onDidChangeTestResults(){return(0,ze.$NF)(Ue,"testObserver"),ni.onResultsChanged},get testResults(){return(0,ze.$NF)(Ue,"testObserver"),ni.results}},hi=lt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,tn={getExtension(pe,ke){(0,ze.$MF)(Ue,"extensionsAny")||(ke=!1);const Ne=xt.mine.getExtensionDescription(pe);if(Ne)return new n.$vbc(kt,Ue.identifier,Ne,hi,!1);if(ke){const st=xt.all.getExtensionDescription(pe);if(st)return new n.$vbc(kt,Ue.identifier,st,hi,!0)}},get all(){const pe=[];for(const ke of xt.mine.getAllExtensionDescriptions())pe.push(new n.$vbc(kt,Ue.identifier,ke,hi,!1));return pe},get allAcrossExtensionHosts(){(0,ze.$NF)(Ue,"extensionsAny");const pe=new ge.$Vl(xt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ke=[];for(const Ne of xt.all.getAllExtensionDescriptions()){const st=!pe.has(Ne.identifier);ke.push(new n.$vbc(kt,Ue.identifier,Ne,hi,st))}return ke},get onDidChange(){return(0,ze.$MF)(Ue,"extensionsAny")?f.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},nn={createDiagnosticCollection(pe){return oi.createDiagnosticCollection(Ue.identifier,pe)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:pe=>oi.getDiagnostics(pe),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(pe,ke){return ai.changeLanguage(pe.uri,ke)},match(pe,ke){const Ne=It.getDocumentData(ke.uri)?.notebook;return(0,P.$_E)(H.LanguageSelector.from(pe),ke.uri,ke.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(pe,ke,Ne){return ut.registerCodeActionProvider(Ue,$t(pe),ke,Ne)},registerDocumentPasteEditProvider(pe,ke,Ne){return(0,ze.$NF)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,$t(pe),ke,Ne)},registerCodeLensProvider(pe,ke){return ut.registerCodeLensProvider(Ue,$t(pe),ke)},registerDefinitionProvider(pe,ke){return ut.registerDefinitionProvider(Ue,$t(pe),ke)},registerDeclarationProvider(pe,ke){return ut.registerDeclarationProvider(Ue,$t(pe),ke)},registerImplementationProvider(pe,ke){return ut.registerImplementationProvider(Ue,$t(pe),ke)},registerTypeDefinitionProvider(pe,ke){return ut.registerTypeDefinitionProvider(Ue,$t(pe),ke)},registerHoverProvider(pe,ke){return ut.registerHoverProvider(Ue,$t(pe),ke,Ue.identifier)},registerEvaluatableExpressionProvider(pe,ke){return ut.registerEvaluatableExpressionProvider(Ue,$t(pe),ke,Ue.identifier)},registerInlineValuesProvider(pe,ke){return ut.registerInlineValuesProvider(Ue,$t(pe),ke,Ue.identifier)},registerDocumentHighlightProvider(pe,ke){return ut.registerDocumentHighlightProvider(Ue,$t(pe),ke)},registerLinkedEditingRangeProvider(pe,ke){return ut.registerLinkedEditingRangeProvider(Ue,$t(pe),ke)},registerReferenceProvider(pe,ke){return ut.registerReferenceProvider(Ue,$t(pe),ke)},registerRenameProvider(pe,ke){return ut.registerRenameProvider(Ue,$t(pe),ke)},registerDocumentSymbolProvider(pe,ke,Ne){return ut.registerDocumentSymbolProvider(Ue,$t(pe),ke,Ne)},registerWorkspaceSymbolProvider(pe){return ut.registerWorkspaceSymbolProvider(Ue,pe)},registerDocumentFormattingEditProvider(pe,ke){return ut.registerDocumentFormattingEditProvider(Ue,$t(pe),ke)},registerDocumentRangeFormattingEditProvider(pe,ke){return ut.registerDocumentRangeFormattingEditProvider(Ue,$t(pe),ke)},registerOnTypeFormattingEditProvider(pe,ke,Ne,...st){return ut.registerOnTypeFormattingEditProvider(Ue,$t(pe),ke,[Ne].concat(st))},registerDocumentSemanticTokensProvider(pe,ke,Ne){return ut.registerDocumentSemanticTokensProvider(Ue,$t(pe),ke,Ne)},registerDocumentRangeSemanticTokensProvider(pe,ke,Ne){return ut.registerDocumentRangeSemanticTokensProvider(Ue,$t(pe),ke,Ne)},registerSignatureHelpProvider(pe,ke,Ne,...st){return typeof Ne=="object"?ut.registerSignatureHelpProvider(Ue,$t(pe),ke,Ne):ut.registerSignatureHelpProvider(Ue,$t(pe),ke,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(pe,ke,...Ne){return ut.registerCompletionItemProvider(Ue,$t(pe),ke,Ne)},registerInlineCompletionItemProvider(pe,ke,Ne){return ke.handleDidShowCompletionItem&&(0,ze.$NF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,ze.$NF)(Ue,"inlineCompletionsAdditions"),Ne&&(0,ze.$NF)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,$t(pe),ke,Ne)},registerDocumentLinkProvider(pe,ke){return ut.registerDocumentLinkProvider(Ue,$t(pe),ke)},registerColorProvider(pe,ke){return ut.registerColorProvider(Ue,$t(pe),ke)},registerFoldingRangeProvider(pe,ke){return ut.registerFoldingRangeProvider(Ue,$t(pe),ke)},registerSelectionRangeProvider(pe,ke){return ut.registerSelectionRangeProvider(Ue,pe,ke)},registerCallHierarchyProvider(pe,ke){return ut.registerCallHierarchyProvider(Ue,pe,ke)},registerTypeHierarchyProvider(pe,ke){return ut.registerTypeHierarchyProvider(Ue,pe,ke)},setLanguageConfiguration:(pe,ke)=>ut.setLanguageConfiguration(Ue,pe,ke),getTokenInformationAtPosition(pe,ke){return(0,ze.$NF)(Ue,"tokenInformation"),ai.tokenAtPosition(pe,ke)},registerInlayHintsProvider(pe,ke){return ut.registerInlayHintsProvider(Ue,pe,ke)},createLanguageStatusItem(pe,ke){return ai.createLanguageStatusItem(Ue,pe,ke)},registerDocumentDropEditProvider(pe,ke,Ne){return ut.registerDocumentOnDropEditProvider(Ue,pe,ke,(0,ze.$MF)(Ue,"dropMetadata")?Ne:void 0)}},rn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(pe,ke,Ne){const st=await(R.URI.isUri(pe)?Promise.resolve(sn.openTextDocument(pe)):Promise.resolve(pe));return Lt.showTextDocument(st,ke,Ne)},createTextEditorDecorationType(pe){return Lt.createTextEditorDecorationType(Ue,pe)},onDidChangeActiveTextEditor(pe,ke,Ne){return Lt.onDidChangeActiveTextEditor(pe,ke,Ne)},onDidChangeVisibleTextEditors(pe,ke,Ne){return Lt.onDidChangeVisibleTextEditors(pe,ke,Ne)},onDidChangeTextEditorSelection(pe,ke,Ne){return Lt.onDidChangeTextEditorSelection(pe,ke,Ne)},onDidChangeTextEditorOptions(pe,ke,Ne){return Lt.onDidChangeTextEditorOptions(pe,ke,Ne)},onDidChangeTextEditorVisibleRanges(pe,ke,Ne){return Lt.onDidChangeTextEditorVisibleRanges(pe,ke,Ne)},onDidChangeTextEditorViewColumn(pe,ke,Ne){return Lt.onDidChangeTextEditorViewColumn(pe,ke,Ne)},onDidCloseTerminal(pe,ke,Ne){return gt.onDidCloseTerminal(pe,ke,Ne)},onDidOpenTerminal(pe,ke,Ne){return gt.onDidOpenTerminal(pe,ke,Ne)},onDidChangeActiveTerminal(pe,ke,Ne){return gt.onDidChangeActiveTerminal(pe,ke,Ne)},onDidChangeTerminalDimensions(pe,ke,Ne){return(0,ze.$NF)(Ue,"terminalDimensions"),gt.onDidChangeTerminalDimensions(pe,ke,Ne)},onDidChangeTerminalState(pe,ke,Ne){return gt.onDidChangeTerminalState(pe,ke,Ne)},onDidWriteTerminalData(pe,ke,Ne){return(0,ze.$NF)(Ue,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(pe,ke,Ne)},onDidExecuteTerminalCommand(pe,ke,Ne){return(0,ze.$NF)(Ue,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(pe,ke,Ne)},get state(){return He.getState(Ue)},onDidChangeWindowState(pe,ke,Ne){return He.onDidChangeWindowState(pe,ke,Ne)},showInformationMessage(pe,...ke){return li.showMessage(Ue,L.default.Info,pe,ke[0],ke.slice(1))},showWarningMessage(pe,...ke){return li.showMessage(Ue,L.default.Warning,pe,ke[0],ke.slice(1))},showErrorMessage(pe,...ke){return li.showMessage(Ue,L.default.Error,pe,ke[0],ke.slice(1))},showQuickPick(pe,ke,Ne){return ii.showQuickPick(Ue,pe,ke,Ne)},showWorkspaceFolderPick(pe){return ii.showWorkspaceFolderPick(pe)},showInputBox(pe,ke){return ii.showInput(pe,ke)},showOpenDialog(pe){return Fi.showOpenDialog(Ue,pe)},showSaveDialog(pe){return Fi.showSaveDialog(pe)},createStatusBarItem(pe,ke,Ne){let st,yt,Tt;return typeof pe=="string"?(st=pe,yt=ke,Tt=Ne):(yt=pe,Tt=ke),Zt.createStatusBarEntry(Ue,st,yt,Tt)},setStatusBarMessage(pe,ke){return Zt.setStatusBarMessage(pe,ke)},withScmProgress(pe){return Me.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),wi.withProgress(Ue,{location:q.ProgressLocation.SourceControl},(ke,Ne)=>pe({report(st){}}))},withProgress(pe,ke){return wi.withProgress(Ue,pe,ke)},createOutputChannel(pe,ke){return Ei.createOutputChannel(pe,ke,Ue)},createWebviewPanel(pe,ke,Ne,st){return Ri.createWebviewPanel(Ue,pe,ke,Ne,st)},createWebviewTextEditorInset(pe,ke,Ne,st){return(0,ze.$NF)(Ue,"editorInsets"),Ci.createWebviewEditorInset(pe,ke,Ne,st,Ue)},createTerminal(pe,ke,Ne){return typeof pe=="object"?"pty"in pe?gt.createExtensionTerminal(pe):gt.createTerminalFromOptions(pe):gt.createTerminal(pe,ke,Ne)},registerTerminalLinkProvider(pe){return gt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,ke){return gt.registerProfileProvider(Ue,pe,ke)},registerTerminalQuickFixProvider(pe,ke){return(0,ze.$NF)(Ue,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(pe,Ue.identifier.value,ke)},registerTreeDataProvider(pe,ke){return bi.registerTreeDataProvider(pe,ke,Ue)},createTreeView(pe,ke){return bi.createTreeView(pe,ke,Ue)},registerWebviewPanelSerializer:(pe,ke)=>Ri.registerWebviewPanelSerializer(Ue,pe,ke),registerCustomEditorProvider:(pe,ke,Ne={})=>cn.registerCustomEditorProvider(Ue,pe,ke,Ne),registerFileDecorationProvider(pe){return pt.registerFileDecorationProvider(pe,Ue)},registerUriHandler(pe){return mi.registerUriHandler(Ue,pe)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(pe,ke,Ne){return Ai.onDidChangeActiveColorTheme(pe,ke,Ne)},registerWebviewViewProvider(pe,ke,Ne){return Li.registerWebviewViewProvider(Ue,pe,ke,Ne?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,ke,Ne){return St.onDidChangeActiveNotebookEditor(pe,ke,Ne)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,ke,Ne){return $i.onDidChangeNotebookEditorSelection(pe,ke,Ne)},onDidChangeNotebookEditorVisibleRanges(pe,ke,Ne){return $i.onDidChangeNotebookEditorVisibleRanges(pe,ke,Ne)},showNotebookDocument(pe,ke){return St.showNotebookDocument(pe,ke)},registerExternalUriOpener(pe,ke,Ne){return(0,ze.$NF)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,pe,ke,Ne)},registerProfileContentHandler(pe,ke){return(0,ze.$NF)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,pe,ke)},registerQuickDiffProvider(pe,ke,Ne,st){return(0,ze.$NF)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider($t(pe),ke,Ne,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(pe,ke){return(0,ze.$NF)(Ue,"shareProvider"),Hi.registerShareProvider($t(pe),ke)}},sn={get rootPath(){return Me.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(pe){throw new F.$7("rootPath")},getWorkspaceFolder(pe){return dt.getWorkspaceFolder(pe)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(pe){throw new F.$7("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(pe){throw new F.$7("workspaceFile")},updateWorkspaceFolders:(pe,ke,...Ne)=>dt.updateWorkspaceFolders(Ue,pe,ke||0,...Ne),onDidChangeWorkspaceFolders:function(pe,ke,Ne){return dt.onDidChangeWorkspace(pe,ke,Ne)},asRelativePath:(pe,ke)=>dt.getRelativePath(pe,ke),findFiles:(pe,ke,Ne,st)=>dt.findFiles(pe,ke,Ne,Ue.identifier,st),findTextInFiles:(pe,ke,Ne,st)=>{(0,ze.$NF)(Ue,"findTextInFiles");let yt,Tt;return typeof ke=="object"?(yt=ke,Tt=Ne):(yt={},Tt=ke,st=Ne),dt.findTextInFiles(pe,yt||{},Tt,Ue.identifier,st)},save:pe=>((0,ze.$NF)(Ue,"saveEditor"),dt.save(pe)),saveAs:pe=>((0,ze.$NF)(Ue,"saveEditor"),dt.saveAs(pe)),saveAll:pe=>dt.saveAll(pe),applyEdit(pe,ke){return hn.applyWorkspaceEdit(pe,Ue,ke)},createFileSystemWatcher:(pe,ke,Ne,st)=>Qt.createFileSystemWatcher(dt,Ue,pe,ke,Ne,st),get textDocuments(){return It.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new F.$7("textDocuments")},openTextDocument(pe){let ke;const Ne=pe;if(typeof pe=="string")ke=Promise.resolve(R.URI.file(pe));else if(R.URI.isUri(pe))ke=Promise.resolve(pe);else if(!Ne||typeof Ne=="object")ke=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(pe,ke,Ne)=>It.onDidAddDocument(pe,ke,Ne),onDidCloseTextDocument:(pe,ke,Ne)=>It.onDidRemoveDocument(pe,ke,Ne),onDidChangeTextDocument:(pe,ke,Ne)=>It.onDidChangeDocument(pe,ke,Ne),onDidSaveTextDocument:(pe,ke,Ne)=>It.onDidSaveDocument(pe,ke,Ne),onWillSaveTextDocument:(pe,ke,Ne)=>Vi.getOnWillSaveTextDocumentEvent(Ue)(pe,ke,Ne),get notebookDocuments(){return St.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,ke){let Ne;if(R.URI.isUri(pe))Ne=pe,await St.openNotebookDocument(pe);else if(typeof pe=="string")Ne=R.URI.revive(await St.createNotebookDocument({viewType:pe,content:ke}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(pe,ke,Ne){return ti.onDidSaveNotebookDocument(pe,ke,Ne)},onDidChangeNotebookDocument(pe,ke,Ne){return ti.onDidChangeNotebookDocument(pe,ke,Ne)},onWillSaveNotebookDocument(pe,ke,Ne){return Di.getOnWillSaveNotebookDocumentEvent(Ue)(pe,ke,Ne)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(pe,ke,Ne,st){return St.registerNotebookSerializer(Ue,pe,ke,Ne,(0,ze.$MF)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(pe,ke,Ne)=>Mi.onDidChangeConfiguration(pe,ke,Ne),getConfiguration(pe,ke){return ke=arguments.length===1?void 0:ke,Mi.getConfiguration(pe,ke,Ue)},registerTextDocumentContentProvider(pe,ke){return ki.registerTextDocumentContentProvider(pe,ke)},registerTaskProvider:(pe,ke)=>(Me.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Ue,pe,ke)),registerFileSystemProvider(pe,ke,Ne){return(0,qe.$gc)(qi.registerFileSystemProvider(Ue,pe,ke,Ne),Pt.addFileSystemProvider(pe,ke,Ne))},get fs(){return Pt.value},registerFileSearchProvider:(pe,ke)=>((0,ze.$NF)(Ue,"fileSearchProvider"),gi.registerFileSearchProvider(pe,ke)),registerTextSearchProvider:(pe,ke)=>((0,ze.$NF)(Ue,"textSearchProvider"),gi.registerTextSearchProvider(pe,ke)),registerRemoteAuthorityResolver:(pe,ke)=>((0,ze.$NF)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(pe,ke)),registerResourceLabelFormatter:pe=>((0,ze.$NF)(Ue,"resolvers"),Ki.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,ze.$NF)(Ue,"resolvers"),kt.getRemoteExecServer(pe)),onDidCreateFiles:(pe,ke,Ne)=>Qt.onDidCreateFile(pe,ke,Ne),onDidDeleteFiles:(pe,ke,Ne)=>Qt.onDidDeleteFile(pe,ke,Ne),onDidRenameFiles:(pe,ke,Ne)=>Qt.onDidRenameFile(pe,ke,Ne),onWillCreateFiles:(pe,ke,Ne)=>Qt.getOnWillCreateFileEvent(Ue)(pe,ke,Ne),onWillDeleteFiles:(pe,ke,Ne)=>Qt.getOnWillDeleteFileEvent(Ue)(pe,ke,Ne),onWillRenameFiles:(pe,ke,Ne)=>Qt.getOnWillRenameFileEvent(Ue)(pe,ke,Ne),openTunnel:pe=>((0,ze.$NF)(Ue,"tunnels"),ie.openTunnel(Ue,pe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,ze.$NF)(Ue,"tunnels"),ie.getTunnels()},onDidChangeTunnels:(pe,ke,Ne)=>((0,ze.$NF)(Ue,"tunnels"),ie.onDidChangeTunnels(pe,ke,Ne)),registerPortAttributesProvider:(pe,ke)=>((0,ze.$NF)(Ue,"portsAttributes"),ie.registerPortsAttributesProvider(pe,ke)),registerTunnelProvider:(pe,ke)=>((0,ze.$NF)(Ue,"tunnelFactory"),ie.registerTunnelProvider(pe,ke)),registerTimelineProvider:(pe,ke)=>((0,ze.$NF)(Ue,"timeline"),Ji.registerTimelineProvider(pe,ke,Ue.identifier,ft.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:pe=>((0,ze.$NF)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,ke,Ne)=>dt.onDidGrantWorkspaceTrust(pe,ke,Ne),registerEditSessionIdentityProvider:(pe,ke)=>((0,ze.$NF)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(pe,ke)),onWillCreateEditSessionIdentity:(pe,ke,Ne)=>((0,ze.$NF)(Ue,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ue)(pe,ke,Ne)),registerCanonicalUriProvider:(pe,ke)=>((0,ze.$NF)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider(pe,ke)),getCanonicalUri:(pe,ke,Ne)=>((0,ze.$NF)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri(pe,ke,Ne))},fn={get inputBox(){return Me.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Ue)},createSourceControl(pe,ke,Ne){return pi.createSourceControl(Ue,pe,ke,Ne)}},on={createCommentController(pe,ke){return Pi.createCommentController(Ue,pe,ke)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(pe,ke,Ne){return mt.onDidStartDebugSession(pe,ke,Ne)},onDidTerminateDebugSession(pe,ke,Ne){return mt.onDidTerminateDebugSession(pe,ke,Ne)},onDidChangeActiveDebugSession(pe,ke,Ne){return mt.onDidChangeActiveDebugSession(pe,ke,Ne)},onDidReceiveDebugSessionCustomEvent(pe,ke,Ne){return mt.onDidReceiveDebugSessionCustomEvent(pe,ke,Ne)},onDidChangeBreakpoints(pe,ke,Ne){return mt.onDidChangeBreakpoints(pe,ke,Ne)},onDidChangeStackFrameFocus(pe,ke,Ne){return(0,ze.$NF)(Ue,"debugFocus"),mt.onDidChangeStackFrameFocus(pe,ke,Ne)},registerDebugConfigurationProvider(pe,ke,Ne){return mt.registerDebugConfigurationProvider(pe,ke,Ne||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,ke){return mt.registerDebugAdapterDescriptorFactory(Ue,pe,ke)},registerDebugAdapterTrackerFactory(pe,ke){return mt.registerDebugAdapterTrackerFactory(pe,ke)},startDebugging(pe,ke,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?mt.startDebugging(pe,ke,{parentSession:Ne}):mt.startDebugging(pe,ke,Ne||{})},stopDebugging(pe){return mt.stopDebugging(pe)},addBreakpoints(pe){return mt.addBreakpoints(pe)},removeBreakpoints(pe){return mt.removeBreakpoints(pe)},asDebugSourceUri(pe,ke){return mt.asDebugSourceUri(pe,ke)}},Oi={registerTaskProvider:(pe,ke)=>Ht.registerTaskProvider(Ue,pe,ke),fetchTasks:pe=>Ht.fetchTasks(pe),executeTask:pe=>Ht.executeTask(Ue,pe),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(pe,ke,Ne)=>Ht.onDidStartTask(pe,ke,Ne),onDidEndTask:(pe,ke,Ne)=>Ht.onDidEndTask(pe,ke,Ne),onDidStartTaskProcess:(pe,ke,Ne)=>Ht.onDidStartTaskProcess(pe,ke,Ne),onDidEndTaskProcess:(pe,ke,Ne)=>Ht.onDidEndTaskProcess(pe,ke,Ne)},Ni={createNotebookController(pe,ke,Ne,st,yt){return si.createNotebookController(Ue,pe,ke,Ne,st,(0,ze.$MF)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,ke)=>St.registerNotebookCellStatusBarItemProvider(Ue,pe,ke),createRendererMessaging(pe){return Si.createRendererMessaging(Ue,pe)},createNotebookControllerDetectionTask(pe){return(0,ze.$NF)(Ue,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ue,pe)},registerKernelSourceActionProvider(pe,ke){return(0,ze.$NF)(Ue,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ue,pe,ke)},onDidChangeNotebookCellExecutionState(pe,ke,Ne){return(0,ze.$NF)(Ue,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(pe,ke,Ne)}},ji={t(...pe){if(typeof pe[0]=="string"){const ke=pe.shift(),Ne=!pe||typeof pe[0]!="object"?pe:pe[0];return Wt.getMessage(Ue.identifier.value,{message:ke,args:Ne})}return Wt.getMessage(Ue.identifier.value,pe[0])},get bundle(){return Wt.getBundle(Ue.identifier.value)},get uri(){return Wt.getBundleUri(Ue.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(pe,ke){return(0,ze.$NF)(Ue,"interactive"),Gi.registerProvider(Ue,pe,ke={label:pe.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(pe,ke){return(0,ze.$NF)(Ue,"interactive"),ui.registerChatProvider(Ue,pe,ke)},addInteractiveRequest(pe){return(0,ze.$NF)(Ue,"interactive"),ui.addChatRequest(pe)},sendInteractiveRequestToProvider(pe,ke){return(0,ze.$NF)(Ue,"interactive"),ui.sendInteractiveRequestToProvider(pe,ke)},get onDidPerformUserAction(){return(0,ze.$NF)(Ue,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(pe,ke){return(0,ze.$NF)(Ue,"interactive"),ui.transferChatSession(pe,ke)}},zi={getRelatedInformation(pe,ke){return(0,ze.$NF)(Ue,"aiRelatedInformation"),Qi.getRelatedInformation(Ue,pe,ke)},registerRelatedInformationProvider(pe,ke){return(0,ze.$NF)(Ue,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Ue,pe,ke)},registerEmbeddingVectorProvider(pe,ke){return(0,ze.$NF)(Ue,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(Ue,pe,ke)}},Ui={registerChatResponseProvider(pe,ke,Ne){return(0,ze.$NF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,pe,ke,Ne)},registerSlashCommand(pe,ke,Ne){return(0,ze.$NF)(Ue,"chatSlashCommands"),Yi.registerCommand(Ue.identifier,pe,ke,Ne??{description:""})},requestChatAccess(pe){return(0,ze.$NF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,pe)},registerVariable(pe,ke,Ne){return(0,ze.$NF)(Ue,"chatVariables"),Xi.registerVariableResolver(Ue,pe,ke,Ne)},registerMappedEditsProvider(pe,ke){return(0,ze.$NF)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,pe,ke)}};return{version:lt.version,ai:zi,authentication:xi,commands:_i,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:ji,languages:nn,notebooks:Ni,scm:fn,tasks:Oi,tests:dn,window:rn,workspace:sn,Breakpoint:q.$UK,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatMessage:q.$KL,ChatMessageRole:q.ChatMessageRole,ChatVariableLevel:q.ChatVariableLevel,CallHierarchyIncomingCall:q.$hK,CallHierarchyItem:q.$gK,CallHierarchyOutgoingCall:q.$iK,CancellationError:F.$3,CancellationTokenSource:C.$od,CandidatePortSource:p.CandidatePortSource,CodeAction:q.$cK,CodeActionKind:q.$dK,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$jK,Color:q.$wK,ColorInformation:q.$xK,ColorPresentation:q.$yK,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.$qK,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$rK,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$GK,DebugAdapterExecutable:q.$YK,DebugAdapterInlineImplementation:q.$2K,DebugAdapterNamedPipeServer:q.$1K,DebugAdapterServer:q.$ZK,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$0J,DiagnosticRelatedInformation:q.$9J,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$VJ,DocumentHighlight:q.$_J,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.$vK,DocumentSymbol:q.$bK,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$5K,InlineValueText:q.$6K,InlineValueVariableLookup:q.$7K,InlineValueEvaluatableExpression:q.$8K,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:f.$ed,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$fL,FileDecoration2:q.$fL,FileSystemError:q.$0K,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:q.$$K,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$WK,InlineCompletionItem:q.$sK,InlineCompletionList:q.$tK,Hover:q.$$J,IndentAction:b.IndentAction,Location:q.$8J,MarkdownString:q.$kK,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:q.$lK,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$WJ,ProcessExecution:q.$EK,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.$eL,Range:q.$XJ,RelativePattern:q.$SK,Selection:q.$YJ,SelectionRange:q.$fK,SemanticTokens:q.$bL,SemanticTokensBuilder:q.$aL,SemanticTokensEdit:q.$cL,SemanticTokensEdits:q.$dL,SemanticTokensLegend:q.$_K,ShellExecution:q.$FK,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$nK,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$mK,SnippetString:q.$7J,SourceBreakpoint:q.$VK,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$aK,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$HK,TaskGroup:q.$DK,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$zK,TerminalQuickFixExecuteTerminalCommand:q.$BK,TerminalQuickFixOpener:q.$AK,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$CK,TerminalExitReason:q.TerminalExitReason,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$3J,SnippetTextEdit:q.$5J,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$RK,ThemeIcon:q.$QK,TreeItem:q.$IK,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$AL,UIKind:k.UIKind,Uri:R.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$6J,DocumentDropEdit:q.$OK,DocumentPasteEdit:q.$PK,InlayHint:q.$pK,InlayHintLabelPart:q.$oK,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$2J,ResolvedAuthority:q.$ZJ,ManagedResolvedAuthority:q.$1J,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$pL,NotebookRange:q.$hL,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$iL,NotebookData:q.$jL,NotebookRendererScript:q.$nL,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$lL,NotebookCellOutputItem:q.$kL,NotebookCellStatusBarItem:q.$mL,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$4J,NotebookKernelSourceAction:q.$oL,PortAttributes:q.$rL,LinkedEditingRanges:q.$qL,TestResultState:q.TestResultState,TestRunRequest:q.$sL,TestMessage:q.$tL,TestMessage2:q.$tL,TestTag:q.$uL,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:q.$NK,DataTransferItem:q.$JK,CoveredCount:q.$vL,FileCoverage:q.$wL,StatementCoverage:q.$xL,BranchCoverage:q.$yL,FunctionCoverage:q.$zL,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$BL,TabInputTextDiff:q.$CL,TabInputTextMerge:q.$DL,TabInputCustom:q.$EL,TabInputNotebook:q.$GL,TabInputNotebookDiff:q.$HL,TabInputWebview:q.$FL,TabInputTerminal:q.$IL,TabInputInteractiveWindow:q.$JL,TelemetryTrustedValue:me.$$n,LogLevel:re.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:q.$3K,ThreadFocus:q.$4K,NotebookCodeActionKind:q.$eK,RelatedInformationType:q.RelatedInformationType}}}e.$Occ=Bt}),define(De[355],Ce([1,0,104,152,39,149,40,33,70,44,94,95,96,115,73,90,151,72,54,114,89,71,150,14,55,112,113]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g,t,o,a,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$kr)(n.$pbc,n.$obc,1),(0,C.$kr)(o.$5i,t.$Pcc,1),(0,C.$kr)(v.$Oac,v.$Pac,1),(0,C.$kr)(m.$fM,m.$eM,0),(0,C.$kr)(R.$2ac,R.$Zac,0),(0,C.$kr)(i.$ebc,i.$dbc,0),(0,C.$kr)(I.$5bc,I.$9bc,0),(0,C.$kr)(L.$Wbc,L.$Vbc,0),(0,C.$kr)(S.$7L,S.$6L,0),(0,C.$kr)(c.$qbc,c.$rbc,0),(0,C.$kr)(s.$Lac,s.$Kac,0),(0,C.$kr)(F.$Cbc,F.$Bbc,1),(0,C.$kr)(p.$ccc,p.$dcc,0),(0,C.$kr)(k.$abc,k.$_ac,0),(0,C.$kr)(P.$Zbc,P.$Ybc,0),(0,C.$kr)(b.$hbc,b.$kbc,0),(0,C.$kr)(D.$csb,D.$dsb,0),(0,C.$kr)(r.$Sbc,r.$Rbc,0),(0,C.$kr)(f.$Yac,f.$Xac,0),(0,C.$kr)(d.$mbc,d.$lbc,0),(0,C.$kr)($.$dM,$.$aM,0),(0,C.$kr)(g.$1bc,g.$2bc,0),(0,C.$kr)(a.$3bc,a.$4bc,0)}),define(De[116],Ce([1,0,19,14,36,93]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=e.$6cc=void 0;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$6cc=R;function m(I,p,k,D){const v=(0,C.$Yb)(k,S),r=new f.$kI(p,v,D),i=r.preview.matches;return{ranges:(0,C.$Yb)(v,b),uri:I,preview:{text:r.preview.text,matches:(0,C.$Yb)(i,b)}}}e.$7cc=m;function S(I){return new f.$lI(I.start.line,I.start.character,I.end.line,I.end.character)}function b(I){return new L.$_H(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let P=class{constructor(p,k){this.a=p,this.b=k}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$8cc=P,e.$8cc=P=Ke([Be(1,F.$4i)],P)}),define(De[356],Ce([1,0,48,16,76,32,12,15,116,357]),function($e,e,C,F,f,L,R,m,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=e.$9cc=void 0;const P=b.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(d,$,g,t){const o=p(d,$,g,t),a=$.folder.fsPath;return{cmd:C.spawn(P,o.args,{cwd:a}),rgDiskPath:P,siblingClauses:o.siblingClauses,rgArgs:o,cwd:a}}e.$9cc=I;function p(d,$,g,t){const o=["--files","--hidden","--case-sensitive","--no-require-git"];D([$],g,!1).forEach(n=>{const c=(0,S.$6cc)(n);if(o.push("-g",c),R.$j){const h=(0,f.$hl)(c);h!==c&&o.push("-g",h)}});const a=k([$],t,void 0,!1);return a.globArgs.forEach(n=>{const c=`!${(0,S.$6cc)(n)}`;if(o.push("-g",c),R.$j){const h=(0,f.$hl)(c);h!==c&&o.push("-g",h)}}),$.disregardIgnoreFiles!==!1?o.push("--no-ignore"):$.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),$.ignoreSymlinks||o.push("--follow"),d.exists&&o.push("--quiet"),o.push("--no-config"),$.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:a.siblingClauses}}function k(d,$,g,t=!0){const o=[];let a={};return d.forEach(n=>{const c=Object.assign({},n.excludePattern||{},$||{}),h=v(c,t?n.folder.fsPath:void 0,g);o.push(...h.globArgs),h.siblingClauses&&(a=Object.assign(a,h.siblingClauses))}),{globArgs:o,siblingClauses:a}}function D(d,$,g=!0){const t=[];return d.forEach(o=>{const a=Object.assign({},$||{},o.includePattern||{}),n=v(a,g?o.folder.fsPath:void 0);t.push(...n.globArgs)}),t}function v(d,$,g){const t=[],o={};return Object.keys(d).forEach(a=>{if(g&&g.has(a)||!a)return;const n=d[a];a=i($?r($,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof n=="boolean"&&n?(a.startsWith("\\\\")&&(a+="**"),t.push(s(a))):n&&n.when&&(o[a]=n)}),{globArgs:t,siblingClauses:o}}function r(d,$){return F.$7d($)?$:F.$8d(d,$)}e.$0cc=r;function i(d){return d=m.$ue(d,"\\"),m.$ue(d,"/")}function s(d){return L.$Df(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.$$cc=s}),define(De[358],Ce([1,0,48,52,16,359,19,46,35,76,32,12,37,15,18,29,36,356,127]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0;const d=new Set;process.on("exit",()=>{d.forEach(a=>a())});class ${constructor(n){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=n,this.b=n.filePattern||"",this.d=n.includePattern&&S.$qj(n.includePattern),this.f=n.maxResults||null,this.g=!!n.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,s.$mq)(this.b).normalizedLowercase),this.u=n.excludePattern&&S.$qj(n.excludePattern),this.t=new Map,n.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),E=c.folder.fsPath;n.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==E).forEach(y=>{(0,P.$Hf)(y,E)&&(h[f.$0d(E,y)]=!0)}),this.t.set(E,new t(h,E))})}cancel(){this.l=!0,d.forEach(n=>n())}walk(n,c,h,E,y){if(this.m=p.$ad.create(!1),this.l)return y(null,this.j);c.forEach(u=>{const l=f.$_d(u.fsPath);this.u&&this.u(u.fsPath,l)||this.J(h,{relativePath:u.fsPath,searchPath:void 0})}),this.r=p.$ad.create(!1),this.w(n,(u,l)=>{this.x(this.y,this,u,h,E,w=>{if(w){const A=(0,m.$li)(w);console.error(A),this.q.push(A),l(w,void 0)}else l(null,void 0)})},(u,l)=>{this.m.stop();const w=u?R.$Eb(u)[0]:null;y(w,this.j)})}w(n,c,h){const E=new Array(n.length),y=new Array(n.length);let u=!1,l=0;if(n.length===0)return h(null,[]);n.forEach((w,A)=>{c(w,(O,N)=>{if(O?(u=!0,E[A]=null,y[A]=O):(E[A]=N,y[A]=null),++l===n.length)return h(u?y:null,E)})})}x(n,c,...h){try{n.apply(c,h)}catch(E){h[h.length-1](E)}}y(n,c,h,E){const y=n.folder.fsPath,u=I.$j,l=()=>T&&T.kill();d.add(l);let w=H=>{d.delete(l),w=()=>{},E(H)},A="";const O=this.D(),N=(0,i.$9cc)(this.a,n,this.a.includePattern,this.t.get(n.folder.fsPath).expression),T=N.cmd,j=!Object.keys(N.siblingClauses).length,z=N.rgArgs.args.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");let M=`${N.rgDiskPath} ${z}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),h({message:M}),this.s=0,this.z(T,"utf8",h,(H,q,me)=>{if(H){w(H);return}if(this.j){w();return}const Q=(A+(u?b.$gl(q||""):q)).split(`
`);if(me){const V=Q.length;Q[V-1]=Q[V-1].trim(),Q[V-1]||Q.pop()}else A=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=Q.length,j){for(const V of Q)if(this.J(c,{base:y,relativePath:V,searchPath:this.N(n,V)}),this.j){l();break}(me||this.j)&&w();return}this.G(n,O,y,Q,c),me&&(this.H(O,y,c),w())})}spawnFindCmd(n){const c=this.t.get(n.folder.fsPath),h=c.getBasenameTerms(),E=c.getPathTerms(),y=["-L","."];if(h.length||E.length){y.push("-not","(","(");for(const u of h)y.push("-name",u),y.push("-o");for(const u of E)y.push("-path",u),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),C.spawn("find",y,{cwd:n.folder.fsPath})}readStdout(n,c,h){let E="";this.z(n,c,()=>{},(y,u,l)=>{if(y){h(y);return}E+=u,l&&h(null,E)})}z(n,c,h,E){let y=(w,A,O)=>{(w||O)&&(y=()=>{},this.r?.stop()),E(w,A,O)},u=!1;n.stdout?(this.A(n.stdout,c,y),n.stdout.once("data",()=>u=!0)):h({message:"stdout is null"});let l;n.stderr?l=this.B(n.stderr):h({message:"stderr is null"}),n.on("error",w=>{y(w)}),n.on("close",w=>{let A;!u&&(A=this.C(l,c))&&o(A)?y(new Error(`command failed with error code ${w}: ${this.C(l,c)}`)):(this.g&&w===0&&(this.j=!0),y(null,"",!0))})}A(n,c,h){const E=new L.StringDecoder(c);return n.on("data",y=>{h(null,E.write(y))}),E}B(n){const c=[];return n.on("data",h=>{c.push(h)}),c}C(n,c){const h=new L.StringDecoder(c);return n.map(E=>h.write(E)).join("")}D(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}G(n,{pathToEntries:c},h,E,y){E.indexOf(this.b)!==-1&&this.J(y,{base:h,relativePath:this.b,searchPath:this.N(n,this.b)});const u=l=>{const w=f.$_d(l),A=f.$$d(l);let O=c[A];O||(O=c[A]=[],u(A)),O.push({base:h,relativePath:l,basename:w,searchPath:this.N(n,l)})};E.forEach(u)}H({rootEntries:n,pathToEntries:c},h,E){const y=this,u=this.t.get(h),l=this.b;function w(A){y.o++;const O=(0,r.$AI)(()=>A.map(N=>N.basename));for(let N=0,T=A.length;N<T;N++){const j=A[N],{relativePath:z,basename:M}=j;if(u.test(z,M,l!==M?O:void 0))continue;const H=c[z];if(H)w(H);else{if(y.p++,z===l)continue;y.J(E,j)}if(y.j)break}}w(n)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(n,c,h,E,y){const u=n.folder,l=(0,r.$AI)(()=>h);this.w(h,(w,A)=>{if(this.l||this.j)return A(null);const O=c?[c,w].join(f.sep):w;if(this.t.get(n.folder.fsPath).test(O,w,this.a.filePattern!==w?l:void 0))return A(null);const N=[u.fsPath,O].join(f.sep);F.lstat(N,(T,j)=>{if(T||this.l||this.j)return A(null);this.L(N,j,(z,M)=>z||this.l||this.j?A(null):M.isDirectory()?(this.o++,this.M(N,j,(H,q)=>H||this.l||this.j||(q=q||"",this.v[q])?A(null):(this.v[q]=!0,v.Promises.readdir(N).then(me=>{if(this.l||this.j)return A(null);this.I(n,O,me,E,x=>A(x||null))},me=>{A(null)})))):(this.p++,O===this.b||this.h&&D.$mf(M.size)&&M.size>this.h||this.J(E,{base:u.fsPath,relativePath:O,searchPath:this.N(n,O)}),A(null,void 0)))})},w=>{const A=w&&R.$Eb(w);return y(A&&A.length>0?A[0]:void 0)})}J(n,c){this.K(c)&&(!this.d||this.d(c.relativePath,f.$_d(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||n(c))}K(n){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,r.$vI)(n,this.c)}return!0}L(n,c,h){return c.isSymbolicLink()?F.stat(n,h):h(null,c)}M(n,c,h){return c.isSymbolicLink()?F.realpath(n,(E,y)=>E?h(E):h(null,y)):h(null,n)}N(n,c){return n.folderName?f.$8d(n.folderName,c):c}}e.$_cc=$;class g{constructor(n){this.a=n.folderQueries,this.b=n.extraFileResources||[],this.c=new $(n)}search(n,c,h){this.c.walk(this.a,this.b,n,c,(E,y)=>{h(E,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$adc=g;class t{constructor(n,c){this.expression=n,this.c=c,this.d(n)}d(n){let c,h;Object.keys(n).filter(E=>n[E]).forEach(E=>{f.$7d(E)?(c=c||S.$lj(),c[E]=n[E]):(h=h||S.$lj(),h[E]=n[E])}),this.a=c&&S.$qj(c,{trimForExclusions:!0}),this.b=h&&S.$qj(h,{trimForExclusions:!0})}test(n,c,h){return this.b&&this.b(n,c,h)||this.a&&this.a(f.$8d(this.c,n),c,h)}getBasenameTerms(){const n=[];return this.a&&n.push(...S.$sj(this.a)),this.b&&n.push(...S.$sj(this.b)),n}getPathTerms(){const n=[];return this.a&&n.push(...S.$tj(this.a)),this.b&&n.push(...S.$tj(this.b)),n}}function o(a){const n=a.trim().split(`
`),c=n[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return k.$af(n[n.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(De[360],Ce([1,0,97,22,182,21]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=e.DecodeStreamErrorKind=e.$fD=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=void 0,e.$$C="utf8",e.$_C="utf8bom",e.$aD="utf16be",e.$bD="utf16le";function R(c){return[e.$$C,e.$_C,e.$aD,e.$bD].some(h=>h===c)}e.$cD=R,e.$dD=[254,255],e.$eD=[255,254],e.$fD=[239,187,191];const m=512,S=512,b=512*8,P=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(h,E){super(h),this.decodeStreamErrorKind=E}}e.$gD=p;class k{static async create(h){let E;if(h!==e.$$C)E=(await(0,f.$0C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(i(h));else{const y=new TextDecoder;E={write(u){return y.decode(u,{stream:!0})},end(){return y.decode()}}}return new k(E)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function D(c,h){const E=h.minBytesRequiredForDetection??h.guessEncoding?b:S;return new Promise((y,u)=>{const l=(0,C.$sd)(j=>j.join("")),w=[];let A=0,O;const N=new L.$od,T=async()=>{try{const j=await n({buffer:F.$Ed.concat(w),bytesRead:A},h.guessEncoding);if(j.seemsBinary&&h.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);j.encoding=await h.overwriteEncoding(j.encoding),O=await k.create(j.encoding);const z=O.write(F.$Ed.concat(w).buffer);l.write(z),w.length=0,A=0,y({stream:l,detected:j})}catch(j){N.cancel(),l.destroy(),u(j)}};(0,C.$wd)(c,{onData:async j=>{O?l.write(O.write(j.buffer)):(w.push(j),A+=j.byteLength,A>=E&&(c.pause(),await T(),setTimeout(()=>c.resume())))},onError:j=>l.error(j),onEnd:async()=>{O||await T(),l.end(O?.end())}},N.token)})}e.$hD=D;async function v(c,h,E){const u=(await(0,f.$0C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(i(h),E);let l=!1,w=!1;return{read(){if(w)return null;const A=c.read();if(typeof A!="string"){if(w=!0,!l&&E?.addBOM)switch(h){case e.$$C:case e.$_C:return F.$Ed.wrap(Uint8Array.from(e.$fD));case e.$aD:return F.$Ed.wrap(Uint8Array.from(e.$dD));case e.$bD:return F.$Ed.wrap(Uint8Array.from(e.$eD))}const O=u.end();return O&&O.length>0?(l=!0,F.$Ed.wrap(O)):null}return l=!0,F.$Ed.wrap(u.write(A))}}}e.$iD=v;async function r(c){return(await(0,f.$0C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(i(c))}e.$jD=r;function i(c){return c===e.$_C||c===null?e.$$C:c}e.$kD=i;function s(c,h){if(!c||h<e.$dD.length)return null;const E=c.readUInt8(0),y=c.readUInt8(1);if(E===e.$dD[0]&&y===e.$dD[1])return e.$aD;if(E===e.$eD[0]&&y===e.$eD[1])return e.$bD;if(h<e.$fD.length)return null;const u=c.readUInt8(2);return E===e.$fD[0]&&y===e.$fD[1]&&u===e.$fD[2]?e.$_C:null}e.$lD=s;const d=["ascii","utf-16","utf-32"];async function $(c){const h=await(0,f.$0C)("jschardet","dist/jschardet.min.js"),E=c.slice(0,P),y=o(E.buffer),u=h.detect(y);if(!u||!u.encoding)return null;const l=u.encoding.toLowerCase();return 0<=d.indexOf(l)?null:t(u.encoding)}const g={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[h]||h}function o(c){let h="";for(let E=0;E<c.length;E++)h+=String.fromCharCode(c[E]);return h}function a(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}e.$mD=a;function n({buffer:c,bytesRead:h},E){let y=s(c,h),u=!1;if(y!==e.$aD&&y!==e.$bD&&c){let l=!0,w=!0,A=!1;for(let O=0;O<h&&O<m;O++){const N=O%2===1,T=c.readUInt8(O)===0;if(T&&(A=!0),l&&(N&&!T||!N&&T)&&(l=!1),w&&(N&&T||!N&&!T)&&(w=!1),T&&!l&&!w)break}A&&(l?y=e.$bD:w?y=e.$aD:u=!0)}return E&&!u&&!y&&c?$(c.slice(0,h)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:u,encoding:y}}e.$nD=n,e.$oD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,360,29,153]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class L extends f.$$bc{constructor(m,S,b=F,P="searchProcess"){super(m,S,{readdir:I=>b.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$mD)(I)},P)}}e.$idc=L}),define(De[155],Ce([1,0,48,376,359,19,56,35,16,15,2,36,93,377,357,116]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=e.$fdc=e.$edc=e.$ddc=e.$cdc=e.$bdc=void 0;const r=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class i{constructor(w){this.a=w}provideTextSearchResults(w,A,O,N){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...A,folder:A.folder.toString()})}`),new Promise((T,j)=>{N.onCancellationRequested(()=>V());const z=o(w,A),M=A.folder.fsPath,H=z.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.a.appendLine(`${r} ${H}
 - cwd: ${M}`);let q=C.spawn(r,z,{cwd:M});q.on("error",G=>{console.error(G),this.a.appendLine("Error: "+(G&&G.message)),j((0,I.$rI)(new I.$pI(G&&G.message,I.SearchErrorCode.rgProcessError)))});let me=!1;const x=new $(A.maxResults,M,A.previewOptions);x.on("result",G=>{me=!0,ge="",O.report(G)});let Q=!1;const V=()=>{Q=!0,q?.kill(),x?.cancel()};let _=!1;x.on("hitLimit",()=>{_=!0,V()});let ge="";q.stdout.on("data",G=>{x.handleData(G),me||(ge+=G)});let ce=!1;q.stdout.once("data",()=>ce=!0);let we="";q.stderr.on("data",G=>{const U=G.toString();this.a.appendLine(U),we.length+U.length<1e6&&(we+=U)}),q.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(me?"Got result from parser":"No result from parser"),ge&&this.a.appendLine(`Got data without result: ${ge}`),this.a.appendLine(""),Q)T({limitHit:_});else{x.flush(),q=null;let G;we&&!ce&&(G=s(we))?j((0,I.$rI)(new I.$pI(G.message,G.code))):T({limitHit:_})}})})}}e.$bdc=i;function s(l){const w=l.split(`
`),A=w[0].trim();if(w.some(N=>N.startsWith("regex parse error")))return new I.$pI(d(w),I.SearchErrorCode.regexParseError);const O=A.match(/grep config error: unknown encoding: (.*)/);if(O)return new I.$pI(`Unknown encoding: ${O[1]}`,I.SearchErrorCode.unknownEncoding);if(A.startsWith("error parsing glob"))return new I.$pI(A.charAt(0).toUpperCase()+A.substr(1),I.SearchErrorCode.globParseError);if(A.startsWith("the literal"))return new I.$pI(A.charAt(0).toUpperCase()+A.substr(1),I.SearchErrorCode.invalidLiteral);if(A.startsWith("PCRE2: error compiling pattern"))return new I.$pI(A,I.SearchErrorCode.regexParseError)}function d(l){const w=["Regex parse error"],A=l.filter(O=>O.startsWith("PCRE2:"));if(A.length>=1){const O=A[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const N=O.split(":")[1];w.push(":"+N)}}return w.join("")}class $ extends F.EventEmitter{constructor(w,A,O){super(),this.g=w,this.h=A,this.j=O,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,A){return super.on(w,A),this}handleData(w){if(this.b)return;const A=typeof w=="string"?w:this.d.write(w);this.k(A)}k(w){let A=w.indexOf(`
`);const O=this.a+w;if(A>=0)A+=this.a.length;else{this.a=O;return}let N=0;for(;A>=0;)this.m(O.substring(N,A).trim()),N=A+1,A=O.indexOf(`
`,N);this.a=O.substring(N)}m(w){if(this.b||!w)return;let A;try{A=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(A.type==="match"){const O=g(A.data.path),N=P.URI.file(S.$8d(this.h,O)),T=this.n(A.data,N);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(A.type==="context"){const O=g(A.data.path),N=P.URI.file(S.$8d(this.h,O));this.o(A.data,N).forEach(j=>this.p(j))}}n(w,A){const O=w.line_number-1,N=g(w.lines),T=Buffer.from(N);let j=0,z=0,M=O;w.submatches.length===0&&w.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const H=(0,L.$Eb)(w.submatches.map((q,me)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const x=g(q.match),Q=T.slice(j,q.start).toString(),V=t(Q),_=V.numLines>0?V.lastLineLength:V.lastLineLength+z,ge=t(x),ce=V.numLines+M,we=ge.numLines+ce,G=ge.numLines>0?ge.lastLineLength:ge.lastLineLength+_;return j=q.end,z=G,M=we,new p.$_H(ce,_,we,G)}));return(0,v.$7cc)(A,N,H,this.j)}o(w,A){const O=g(w.lines),N=w.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((T,j)=>({text:T,uri:A,lineNumber:N+j}))}p(w){this.emit("result",w)}}e.$cdc=$;function g(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function t(l){const w=/\n/g;let A=0,O=-1,N;for(;N=w.exec(l);)A++,O=N.index;const T=O>=0?l.length-O-1:l.length;return{numLines:A,lastLineLength:T}}function o(l,w){const A=["--hidden","--no-require-git"];A.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:N}=(0,R.$I)(w.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const j=new Set;N.forEach(z=>{j.add(z)}),A.push("-g","!*"),j.forEach(z=>{a(z).map(v.$6cc).forEach(M=>{A.push("-g",M)})})}O&&O.length&&O.forEach(j=>{A.push("-g",j)}),w.excludes.map(v.$6cc).forEach(j=>A.push("-g",`!${j}`)),w.maxFileSize&&A.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||A.push("--no-ignore-parent"):A.push("--no-ignore"),w.followSymlinks&&A.push("--follow"),w.encoding&&w.encoding!=="utf8"&&A.push("--encoding",w.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,b.$pe)(l.pattern),l.isRegExp=!0),w.usePCRE2&&A.push("--pcre2"),A.push("--crlf"),l.isRegExp&&(l.pattern=n(l.pattern),A.push("--engine","auto"));let T;if(l.isWordMatch){const z=(0,b.$xe)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");A.push("--regexp",z)}else if(l.isRegExp){let j=h(l.pattern);j=E(j),A.push("--regexp",j)}else T=l.pattern,A.push("--fixed-strings");return A.push("--no-config"),w.useGlobalIgnoreFiles||A.push("--no-ignore-global"),A.push("--json"),l.isMultiline&&A.push("--multiline"),w.beforeContext&&A.push("--before-context",w.beforeContext+""),w.afterContext&&A.push("--after-context",w.afterContext+""),A.push("--"),T&&A.push(T),A.push("."),A}e.$ddc=o;function a(l){return u(l).flatMap(A=>{const O=(0,m.$oj)(A,"/");return O.map((N,T)=>O.slice(0,T+1).join("/"))})}function n(l){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(w);)l=l.replace(w,"$1\\x{$2}");const A=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(A);)l=l.replace(A,"$1\\x{$2}");return l}e.$edc=n;const c=l=>l.type==="Assertion"&&l.kind==="lookbehind";function h(l){let w;try{w=new k.RegExpParser().parsePattern(l)}catch{return l}let A="",O=0;const N=(z,M,H)=>{A+=l.slice(O,z)+H,O=M},T=[];return new k.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const M=T[0];if(!M)N(z.start,z.end,"\\r?\\n");else if(!T.some(c))if(M.type==="CharacterClass")if(M.negate){const H=l.slice(M.start+2,z.start)+l.slice(z.end,M.end-1);M.parent?.type==="Quantifier"?N(M.start,M.end,H?`[^${H}]`:"."):N(M.start,M.end,"(?!\\r?\\n"+(H?`|[${H}]`:"")+")")}else{const H=l.slice(M.start+1,z.start)+l.slice(z.end,M.end-1);N(M.start,M.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else M.type==="Quantifier"&&N(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){T.unshift(z)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(z){T.unshift(z)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(z){T.unshift(z)},onCharacterClassLeave(){T.shift()},onAssertionEnter(z){c(z)&&T.push(z)},onAssertionLeave(z){T[0]===z&&T.shift()}}).visit(w),A+=l.slice(O),A}e.$fdc=h;function E(l){return l.replace(/\n/g,"\\r?\\n")}e.$gdc=E;function y(l){let w=!1,A=!1,O="",N="";for(let T=0;T<l.length;T++){const j=l[T];switch(j){case"\\":A?(w?N+="\\"+j:O+="\\"+j,A=!1):A=!0;break;case"{":if(A)w?N+=j:O+=j,A=!1;else{if(w)return{strInBraces:O+"{"+N+"{"+l.substring(T+1)};w=!0}break;case"}":if(A)w?N+=j:O+=j,A=!1;else{if(w)return{fixedStart:O,strInBraces:N,fixedEnd:l.substring(T+1)};O+=j}break;default:w?N+=(A?"\\":"")+j:O+=(A?"\\":"")+j,A=!1;break}}return{strInBraces:O+(w?"{"+N:"")}}function u(l){const{fixedStart:w,strInBraces:A,fixedEnd:O}=y(l);if(w===void 0||O===void 0)return[A];let N=(0,m.$oj)(A,",");N.length||(N=[""]);const T=u(O);return N.flatMap(j=>{const z=w+j;return T.map(M=>z+M)})}e.$hdc=u}),define(De[361],Ce([1,0,21,155,84,17]),function($e,e,C,F,f,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class R{constructor(b){this.b=b,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(b,P,I,p){const k=new F.$bdc(this.b);if(P.folder.scheme===L.Schemas.vscodeUserData){const D={...P,folder:P.folder.with({scheme:L.Schemas.file})},v=new f.$2u(r=>I.report({...r,uri:r.uri.with({scheme:P.folder.scheme})}));return this.c(p,r=>k.provideTextSearchResults(b,D,v,r))}else return this.c(p,D=>k.provideTextSearchResults(b,P,I,D))}async c(b,P){const I=m(b);this.a.add(I);const p=await P(I.token);return this.a.delete(I),p}d(){this.a.forEach(b=>b.cancel())}}e.$ldc=R;function m(S){const b=new C.$od;return S.onCancellationRequested(()=>b.cancel()),b}}),define(De[362],Ce([1,0,29,155,154]),function($e,e,C,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class L{constructor(S){this.a=S}search(S,b,P){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(k){P({message:k})}},p=new f.$idc(this.a,new F.$bdc(I),C);return new Promise((k,D)=>p.search(v=>{b(v.map(R))},S).then(v=>k({limitHit:v.limitHit,type:"success",stats:v.stats}),D))}}e.$jdc=L;function R(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((S,b)=>{if(b.ranges){const P=b;return S+(Array.isArray(P.ranges)?P.ranges.length:1)}else return S+1},0)}}}),define(De[363],Ce([1,0,19,11,8,4,127,16,37,2,30,36,358,362]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;class D{static{this.a=512}constructor($="searchProcess"){this.d=$,this.b=Object.create(null)}fileSearch($){let g;const t=i($),o=new L.$ed({onDidAddFirstListener:()=>{g=(0,F.$tg)(a=>this.doFileSearchWithEngine(p.$adc,t,n=>o.fire(n),a)),g.then(a=>o.fire(a),a=>o.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return o.event}textSearch($){let g;const t=i($),o=new L.$ed({onDidAddFirstListener:()=>{g=(0,F.$tg)(a=>this.f(t,n=>o.fire(n),a)),g.then(a=>o.fire(a),a=>o.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return o.event}f($,g,t){return $.maxFileSize=this.g().maxFileSize,new k.$jdc($).search(t,g,g)}g(){return{maxFileSize:process.arch==="ia32"?300*P.$zk.MB:16*P.$zk.GB}}doFileSearch($,g,t){return this.doFileSearchWithEngine(p.$adc,$,g,t)}doFileSearchWithEngine($,g,t,o,a=D.a){let n=0;const c=E=>{Array.isArray(E)?(n+=E.length,t(E.map(y=>this.h(y)))):E.relativePath?(n++,t(this.h(E))):t(E)};if(g.sortByScore){let E=this.l(g,c,o);if(!E){const y=g.maxResults?Object.assign({},g,{maxResults:null}):g,u=new $(y);E=this.j(u,g,t,c,o)}return new Promise((y,u)=>{E.then(([l,w])=>{const A=w.map(O=>this.h(O));this.o(A,t,a),y(l)},u)})}const h=new $(g);return this.r(h,c,a,o).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:this.d,fromCache:!1,resultCount:n,sortingTime:void 0}}))}h($){return{path:$.base?(0,m.$8d)($.base,$.relativePath):$.relativePath}}j($,g,t,o,a){const n=new L.$ed;let c=(0,F.$tg)(E=>{let y=[];const u=l=>{Array.isArray(l)?y=l:(o(l),n.fire(l))};return this.r($,u,-1,E).then(l=>[l,y])}),h;if(g.cacheKey){h=this.k(g.cacheKey);const E={promise:c,event:n.event,resolved:!1};h.resultsToSearchCache[g.filePattern||""]=E,c.then(()=>{E.resolved=!0},y=>{delete h.resultsToSearchCache[g.filePattern||""]}),c=this.s(c)}return c.then(([E,y])=>{const u=h?h.scorerCache:Object.create(null),l=(typeof g.maxResults!="number"||g.maxResults>0)&&S.$ad.create(!1);return this.n(g,y,u,a).then(w=>{const A=l?l.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:A,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:w.length},messages:E.messages,limitHit:E.limitHit||typeof g.maxResults=="number"&&y.length>g.maxResults},w]})})}k($){const g=this.b[$];return g||(this.b[$]=new v)}l($,g,t){const o=$.cacheKey&&this.b[$.cacheKey];if(!o)return;const a=this.q(o,$.filePattern||"",g,t);if(a)return a.then(([n,c,h])=>{const E=S.$ad.create(!1);return this.n($,c,o.scorerCache,t).then(y=>{const u=E.elapsed(),l={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:u};return[{type:"success",limitHit:n.limitHit||typeof $.maxResults=="number"&&c.length>$.maxResults,stats:l},y]})})}n($,g,t,o){const a=(0,R.$mq)($.filePattern||""),n=(h,E)=>(0,R.$lq)(h,E,a,!0,r,t),c=typeof $.maxResults=="number"?$.maxResults:Number.MAX_VALUE;return C.$Db(g,n,c,1e4,o)}o($,g,t){if(t&&t>0)for(let o=0;o<$.length;o+=t)g($.slice(o,o+t));else g($)}q($,g,t,o){const a=S.$ad.create(!1),n=g.indexOf(m.sep)>=0;let c;for(const u in $.resultsToSearchCache)if(g.startsWith(u)){if(n&&u.indexOf(m.sep)<0&&u!=="")continue;const l=$.resultsToSearchCache[u];c={promise:this.s(l.promise),event:l.event,resolved:l.resolved};break}if(!c)return null;const h=a.elapsed(),E=S.$ad.create(!1),y=c.event(t);return o&&o.onCancellationRequested(()=>{y.dispose()}),c.promise.then(([u,l])=>{if(o&&o.isCancellationRequested)throw(0,f.$4)();const w=[],A=(0,R.$mq)(g).normalizedLowercase;for(const O of l)(0,I.$vI)(O,A)&&w.push(O);return[u,w,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:E.elapsed(),cacheEntryCount:l.length}]})}r($,g,t,o){return new Promise((a,n)=>{let c=[];o?.onCancellationRequested(()=>$.cancel()),$.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(g(c),c=[])):g(h))},h=>{g(h)},(h,E)=>{c.length&&g(c),h?n(h):a(E)})})}clearCache($){return delete this.b[$],Promise.resolve(void 0)}s($){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,t){return $.then(g,t)}catch(g){return this.then(void 0,g)}finally(g){return $.finally(g)}}}}e.$kdc=D;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const r=new class{getItemLabel(d){return(0,m.$_d)(d.relativePath)}getItemDescription(d){return(0,m.$$d)(d.relativePath)}getItemPath(d){return d.relativePath}};function i(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(s),extraFileResources:d.extraFileResources&&d.extraFileResources.map($=>b.URI.revive($))}}function s(d){return{...d,folder:b.URI.revive(d.folder)}}}),define(De[364],Ce([1,0,3,17,2,29,14,26,20,96,67,36,363,361,116,154]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;let r=class extends b.$dcc{constructor(s,d,$,g){super(s,$,g),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new C.$ic;const t=new D.$8cc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new k.$ldc(t))),d.remote.isRemote&&d.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const s=new D.$8cc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new k.$ldc(s))),this.x.add(this.z(F.Schemas.file,new p.$kdc("fileSearchProvider")))}z(s,d){const $=this.d++;return this.v=d,this.t=$,this.c.$registerFileSearchProvider($,this.o(s)),(0,C.$hc)(()=>{this.v=null,this.c.$unregisterProvider($)})}$provideFileSearchResults(s,d,$,g){const t=(0,b.$ecc)($);return s===this.t?this.A(s,d,t,g):super.$provideFileSearchResults(s,d,$,g)}A(s,d,$,g){const t=o=>{if((0,I.$uI)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(s,d,o.map(a=>f.URI.file(a.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch($,t,g)}$clearCache(s){return this.v?.clearCache(s),super.$clearCache(s)}q(s,d){return new v.$idc(s,d,void 0,"textSearchProvider")}};e.$mdc=r,e.$mdc=r=Ke([Be(0,S.$VL),Be(1,m.$_L),Be(2,P.$Vac),Be(3,R.$4i)],r)}),define(De[117],Ce([1,0,378,61,64,379,22,8,4,3,16,12,31,80,81]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class v{traceSocketEvent(l,w){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,w)}constructor(l,w=""){this.f=!0,this.debugLabel=w,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,m.$Y)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const w=A=>{this.traceSocketEvent("read",A),l(R.$Ed.wrap(A))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(l){const w=A=>{l({type:0,hadError:A,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(l){const w=()=>{l()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$ph=v;var r;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize",u[u.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var i;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(i||(i={}));class s extends b.$jc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,w){this.socket.traceSocketEvent(l,w)}constructor(l,w,A,O){super(),this.f=this.B(new S.$ed),this.g=this.B(new S.$ed),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:A?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new d(this,w,A,O,this.f,(N,T)=>this.m(N,T))),this.B(this.a.onError(N=>{console.error(N),(0,m.$Y)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new D.$kh,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let w=0;for(;w<l.byteLength;)this.a.writeMessage(l.slice(w,Math.min(w+262144,l.byteLength))),w+=262144}m(l,w){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let A=2;l.byteLength<126?A+=0:l.byteLength<2**16?A+=2:A+=8;const O=R.$Ed.alloc(A);if(w?O.writeUInt8(194,0):O.writeUInt8(130,0),l.byteLength<126)O.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(l.byteLength>>>8&255,++N),O.writeUInt8(l.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(l.byteLength>>>24&255,++N),O.writeUInt8(l.byteLength>>>16&255,++N),O.writeUInt8(l.byteLength>>>8&255,++N),O.writeUInt8(l.byteLength>>>0&255,++N)}this.socket.write(R.$Ed.concat([O,l]))}end(){this.h=!0,this.socket.end()}n(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),A=w.readUInt8(0),O=(A&128)>>>7,N=(A&64)>>>6,T=w.readUInt8(1),j=(T&128)>>>7,z=T&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(z===126?2:0)+(z===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),A=w.readUInt8(1),O=(A&128)>>>7;let N=A&127,T=1;N===126?N=w.readUInt8(++T)*2**8+w.readUInt8(++T):N===127&&(N=w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*2**24+w.readUInt8(++T)*2**16+w.readUInt8(++T)*2**8+w.readUInt8(++T));let j=0;O&&(j=w.readUInt8(++T)*2**24+w.readUInt8(++T)*2**16+w.readUInt8(++T)*2**8+w.readUInt8(++T)),this.j.state=3,this.j.readLen=N,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),t(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(w,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qh=s;class d extends b.$jc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Ed.alloc(0)}constructor(l,w,A,O,N,T){super(),this.n=l,this.r=N,this.s=T,this.a=this.B(new S.$ed),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$ed),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$ed),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,w?(this.b=this.B(new $(this.n,O,A,{windowBits:15})),this.f=this.B(new g(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(l){this.g.push(l),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const l=this.g.shift();if(this.f){const w=await this.w(this.f,l);this.s(w,!0)}else this.s(l,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(l,w){return new Promise((A,O)=>{l.write(w),l.flush(N=>A(N))})}acceptFrame(l,w,A){this.h.push({data:l,isCompressed:w,isLastFrameOfMessage:A}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const w=await this.C(this.b,l.data,l.isLastFrameOfMessage);this.r.fire(w)}else this.r.fire(l.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(l,w,A){return new Promise((O,N)=>{l.write(w),A&&l.write(R.$Ed.fromByteArray([0,0,255,255])),l.flush(T=>O(T))})}}class $ extends b.$jc{get recordedInflateBytes(){return this.j?R.$Ed.concat(this.f):R.$Ed.alloc(0)}constructor(l,w,A,O){super(),this.h=l,this.j=w,this.a=this.B(new S.$ed),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(O),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(R.$Ed.wrap(N))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=R.$Ed.concat(this.g);this.g.length=0,l(w)})}}class g extends b.$jc{constructor(l,w){super(),this.g=l,this.a=this.B(new S.$ed),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(R.$Ed.wrap(A))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=R.$Ed.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),l(w)})}}function t(u,l){if(l===0)return;const w=u.byteLength>>>2;for(let z=0;z<w;z++){const M=u.readUInt32BE(z*4);u.writeUInt32BE(M^l,z*4)}const A=w*4,O=u.byteLength-A,N=l>>>24&255,T=l>>>16&255,j=l>>>8&255;O>=1&&u.writeUInt8(u.readUInt8(A)^N,A),O>=2&&u.writeUInt8(u.readUInt8(A+1)^T,A+1),O>=3&&u.writeUInt8(u.readUInt8(A+2)^j,A+2)}e.$rh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function a(){const u=(0,p.$3f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;const l=process.platform!=="darwin"&&e.$rh?e.$rh:(0,f.tmpdir)(),w=(0,P.$8d)(l,`vscode-ipc-${u}.sock`);return c(w),w}e.$sh=a;function n(u,l,w){const A=(0,C.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${w}-${l}-sock`;const O=w.substr(0,4),N=l.substr(0,6),T=A.substr(0,8);let j;return process.platform!=="darwin"&&e.$rh&&!process.env.VSCODE_PORTABLE?j=(0,P.$8d)(e.$rh,`vscode-${T}-${O}-${N}.sock`):j=(0,P.$8d)(u,`${O}-${N}.sock`),c(j),j}e.$th=n;function c(u){const l=o[I.$t];typeof l=="number"&&u.length>=l&&console.warn(`WARNING: IPC handle "${u}" is longer than ${l} chars, try a shorter --user-data-dir`)}class h extends k.$eh{static b(l){const w=S.Event.fromNodeEventEmitter(l,"connection");return S.Event.map(w,A=>({protocol:new D.$lh(new v(A,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(A,"close"))}))}constructor(l){super(h.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$uh=h;function E(u){return new Promise((l,w)=>{const A=(0,F.createServer)();A.on("error",w),A.listen(u,()=>{A.removeListener("error",w),l(new h(A))})})}e.$vh=E;function y(u,l){return new Promise((w,A)=>{const O=(0,F.createConnection)(u,()=>{O.removeListener("error",A),w(D.$mh.fromSocket(new v(O,`ipc-client${l}`),l))});O.once("error",A)})}e.$wh=y}),define(De[365],Ce([1,0,61,64,163,117,11,3,12,49,14,135,247,248,107,86,22]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=e.$W6b=e.$V6b=e.$U6b=void 0;async function i(t,o,a,n,c){let h;for(let E=3;E&&(h?.dispose(),h=await new s(t,o,a,n,c).waitForReady(),!(c&&f.$6f[c]||!f.$6f[h.tunnelLocalPort]));E--);return h}class s extends m.$jc{constructor(o,a,n,c,h){super(),this.m=a,this.n=h,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=C.createServer(),this.c=new R.$Eg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=E=>this.r(E),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,a=(0,v.$1z)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,f.$7f)(o,2,1e3,a),c=null;return this.b.listen(n,this.m),await this.c.wait(),c=this.b.address(),c||(n=0,this.b.listen(n,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(o){o.pause();const a=(0,v.$Yz)(this.tunnelRemoteHost)||(0,v.$1z)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,p.$Yk)(this.a,a,this.tunnelRemotePort),c=n.getSocket(),h=n.readEntireBuffer();n.dispose(),h.byteLength>0&&o.write(h.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),c.end()}),o.on("close",()=>c.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),c instanceof L.$ph?c.socket.destroy():c.end()}),c instanceof L.$ph?this.t(o,c):this.s(o,c),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),c.end()})}s(o,a){a.onClose(()=>o.destroy()),a.onEnd(()=>o.end()),a.onData(n=>o.write(n.buffer)),o.on("data",n=>a.write(r.$Ed.wrap(n))),o.resume()}t(o,a){const n=a.socket;n.on("end",()=>o.end()),n.on("close",()=>o.end()),n.on("error",()=>{o.destroy()}),n.pipe(o),o.pipe(n)}}e.$U6b=s;let d=class extends v.$4z{constructor(o,a,n,c,h){super(a,h),this.u=o,this.v=n,this.w=c}isPortPrivileged(o){return(0,v.$2z)(o,this.l,S.OS,F.release())}s(o,a,n,c,h,E,y,u){const l=this.r(a,n);if(l)return++l.refcount,l.value;if((0,v.$Vz)(o))return this.t(o,a,n,h,E,y,u);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${n} on local port ${h}.`);const w={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},A=i(w,c,a,n,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(a,n,A),A}}};e.$V6b=d,e.$V6b=d=Ke([Be(0,k.$Sk),Be(1,P.$4i),Be(2,D.$Vk),Be(3,I.$jj),Be(4,b.$7h)],d);let $=class extends d{constructor(o,a,n,c,h){super(o,a,n,c,h)}};e.$W6b=$,e.$W6b=$=Ke([Be(0,k.$Sk),Be(1,P.$4i),Be(2,D.$Vk),Be(3,I.$jj),Be(4,b.$7h)],$);let g=class extends m.$jc{constructor(o,a,n,c,h){super(),this.b=o,this.c=a,this.f=n,this.g=c,this.h=h,this.a=new Map}async openTunnel(o,a,n,c,h,E,y,u,l){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${c} on local port ${E}.`),!this.a.has(o)){const w=new $(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(o,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(a,n,c,h,E,y,u,l)}};e.$X6b=g,e.$X6b=g=Ke([Be(0,k.$Sk),Be(1,P.$4i),Be(2,I.$jj),Be(3,D.$Vk),Be(4,b.$7h)],g)}),define(De[366],Ce([1,0,117,267,52,33,2,14,43]),function($e,e,C,F,f,L,R,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=void 0;class b{constructor(p,k,D){this.b=p,this.c=k,this.f=D,this.a=F.createServer((v,r)=>this.h(v,r)),this.g().catch(v=>(k.error(v),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,k){const D=(r,i)=>{k.writeHead(r,{"content-type":"application/json"}),k.end(JSON.stringify(i||null),s=>s&&this.c.error(s))},v=[];p.setEncoding("utf8"),p.on("data",r=>v.push(r)),p.on("end",async()=>{try{const r=JSON.parse(v.join(""));let i;switch(r.type){case"open":i=await this.i(r);break;case"openExternal":i=await this.j(r);break;case"status":i=await this.l(r);break;case"extensionManagement":i=await this.k(r);break;default:D(404,`Unknown message type: ${r.type}`);break}D(200,i)}catch(r){const i=r instanceof Error?r.message:JSON.stringify(r);D(500,i),this.c.error("Error while processing pipe request",r)}})}async i(p){const{fileURIs:k,folderURIs:D,forceNewWindow:v,diffMode:r,mergeMode:i,addMode:s,forceReuseWindow:d,gotoLineMode:$,waitMarkerFilePath:g,remoteAuthority:t}=p,o=[];if(Array.isArray(D))for(const h of D)try{o.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(k))for(const h of k)try{(0,S.$6h)(h)?o.push({workspaceUri:R.URI.parse(h)}):o.push({fileUri:R.URI.parse(h)})}catch{}const a=g?R.URI.file(g):void 0,c={forceNewWindow:v,diffMode:r,mergeMode:i,addMode:s,gotoLineMode:$,forceReuseWindow:d,preferNewWindow:!d&&!a&&!s,waitMarkerFileURI:a,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",o,c)}async j(p){for(const k of p.uris){const D=R.URI.parse(k),v=D.scheme==="file"?D:k;await this.b.executeCommand("_remoteCLI.openExternal",v)}}async k(p){const k=v=>v?.map(r=>/\.vsix$/i.test(r)?R.URI.parse(r):r),D={list:p.list,install:k(p.install),uninstall:k(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$kM=b;let P=class extends b{constructor(p,k){super(p,k,(0,C.$sh)())}};e.$lM=P,e.$lM=P=Ke([Be(0,L.$fM),Be(1,m.$4i)],P)}),define(De[367],Ce([1,0,53,354,349,266,45,337,2,17,7,366,101,335,336]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class v extends f.$Scc{j(){const s=this,d=globalThis._VSCODE_NODE_MODULES.module,$=d._load;d._load=function(a,n,c){return a=t(a),s.a.has(a)?s.a.get(a).load(a,S.URI.file((0,p.$Vp)(n.filename)),h=>$.apply(this,[h,n,c])):$.apply(this,arguments)};const g=d._resolveLookupPaths;d._resolveLookupPaths=(o,a)=>g.call(this,t(o),a);const t=o=>{for(const a of s.b){const n=a(o);if(n){o=n;break}}return o}}}class r extends R.$tbc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async tb(){this.h.createInstance(k.$pdc);const s=this.h.invokeFunction(F.$Occ);if(this.h.createInstance(m.$odc),this.f.remote.isRemote&&this.f.remote.authority){const g=this.h.createInstance(I.$lM);process.env.VSCODE_IPC_HOOK_CLI=g.ipcHandlePath}this.h.createInstance(D.$qdc),await this.h.createInstance(v,s,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const $=await this.m.getConfigProvider();await(0,L.$ndc)(this.j,$,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(s){return s.main}async vb(s,d,$){if(d.scheme!==b.Schemas.file)throw new Error(`Cannot load URI: '${d}', must be of file-scheme`);let g=null;$.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${d.toString(!0)}`),this.s.flush();const t=s?.identifier.value;s&&await this.w.initializeLocalizedMessages(s);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),g=$e.__$__nodeRequire(d.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),$.codeLoadingStop()}return g}async $setRemoteEnvironment(s){if(this.f.remote.isRemote)for(const d in s){const $=s[d];$===null?delete process.env[d]:process.env[d]=$}}}e.$rdc=r}),define(De[368],Ce([1,0,48,22,4,3,120,12,24,2,29,14,246,65,107,86,365,26,20,73,345]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=e.$xdc=e.$wdc=e.$vdc=e.$udc=e.$tdc=e.$sdc=void 0;function g(l){const w=l.trim().split(`
`),A=[];return w.forEach(N=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);T&&T.length>=3&&A.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),A.reduce((N,T)=>(N[T.socket]=T,N),{})}e.$sdc=g;function t(...l){const w=[].concat(...l.map(a));return[...new Map(w.filter(A=>A.st==="0A").map(A=>{const O=A.local_address.split(":");return{socket:parseInt(A.inode,10),ip:o(O[0]),port:parseInt(O[1],16)}}).map(A=>[A.ip+":"+A.port,A])).values()]}e.$tdc=t;function o(l){let w="";if(l.length===8)for(let A=l.length-2;A>=0;A-=2)w+=parseInt(l.substr(A,2),16),A!==0&&(w+=".");else for(let A=0;A<l.length;A+=8){const O=l.substring(A,A+8);let N="";for(let T=8;T>=2;T-=2)N+=O.substring(T-2,T),(T===6||T===2)&&(N=parseInt(N,16).toString(16),w+=`${N}`,N="",A+T!==l.length-6&&(w+=":"))}return w}e.$udc=o;function a(l){const w=l.trim().split(`
`),A=w.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return w.map(N=>N.trim().split(/\s+/).reduce((T,j,z)=>(T[A[z]||z]=j,T),{}))}e.$vdc=a;function n(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/server-main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function c(l){const w=l.trim().split(`
`),A=[];return w.forEach(O=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);N&&N.length>=4&&A.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),A}e.$wdc=c;async function h(l,w,A){const O=A.reduce((T,j)=>(T[j.pid]=j,T),{}),N=[];return l.forEach(({socket:T,ip:j,port:z})=>{const M=w[T]?w[T].pid:void 0,H=M?O[M]?.cmd:void 0;M&&H&&!n(H)&&N.push({host:j,port:z,detail:H,pid:M})}),N}e.$xdc=h;function E(l,w,A){const O=new Map,N=c(w);for(const T of l){const j=A.get(T.port);if(j){O.set(T.port,j);continue}const z=N.find(M=>M.cmd.includes(`${T.port}`));if(z){let M=z,H;do H=N.find(q=>q.ppid===M.pid),H&&(M=H);while(H);O.set(T.port,{host:T.ip,port:T.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else O.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return O}e.$ydc=E;let y=class extends d.$dsb{constructor(w,A,O,N){super(w,A,O),this.D=A,this.F=N,this.y=void 0,this.z=new Map,this.C=!1,m.$k&&A.remote.isRemote&&A.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(w){if(w&&this.C)return;this.C=w;let A;this.y&&(A=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new R.$Jl;let N=0;for(;this.C;){const T=new Date().getTime(),j=(await this.I()).filter(H=>(0,v.$Yz)(H.host)||(0,v.$1z)(H.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(H=>H.port).join(", ")}`);const z=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),N++>3&&O.update(z),(!A||JSON.stringify(A)!==JSON.stringify(j))&&(A=j,await this.a.$onFoundNewCandidates(A));const M=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(H=>setTimeout(()=>H(),M))}}G(w){return Math.max(w*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(w=>w.port).join(", ")}`)}async I(){let w="",A="";try{w=await P.Promises.readFile("/proc/net/tcp","utf8"),A=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(w,A),N=await new Promise(x=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,V,_)=>{x(V)})}),T=g(N),j=await P.Promises.readdir("/proc"),z=[];for(const x of j)try{const Q=Number(x),V=S.$hg(b.URI.file("/proc"),x);if((await P.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(Q)){const ge=await P.Promises.readlink(S.$hg(V,"cwd").fsPath),ce=await P.Promises.readFile(S.$hg(V,"cmdline").fsPath,"utf8");z.push({pid:Q,cwd:ge,cmd:ce})}}catch{}const M=[],H=O.filter(x=>{const Q=T[x.socket];return Q||M.push(x),Q}),q=h(H,T,z);let me;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const x=await new Promise(Q=>{(0,C.exec)("ps -F -A -l | grep root",(V,_,ge)=>{Q(_)})});this.z=E(M,x,this.z),me=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${me.map(Q=>Q.port).join(", ")}`)}return q.then(x=>me?x.concat(me):x)}w(w){return async A=>{const O=new r.$U6b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,j,z,M){const H=await w.makeConnection();return u.connect(H,j,z,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$Jk(0),connectionToken:w.connectionToken})}},signService:this.F},"localhost",A.remoteAddress.host||"localhost",A.remoteAddress.port,A.localAddressPort);await O.waitForReady();const N=new f.$ed;return{localAddress:(0,$.$bJ)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{O.dispose(),N.fire(),N.dispose()}}}}};e.$zdc=y,e.$zdc=y=Ke([Be(0,s.$VL),Be(1,i.$_L),Be(2,I.$4i),Be(3,D.$Vk)],y);class u extends p.$mkb{static connect(w,A,O,N){const T=new L.$ic,j={onClose:T.add(new f.$ed),onData:T.add(new f.$ed),onEnd:T.add(new f.$ed)};T.add(w.onDidReceiveMessage(M=>j.onData.fire(F.$Ed.wrap(M)))),T.add(w.onDidEnd(()=>j.onEnd.fire())),T.add(w.onDidClose(M=>j.onClose.fire({type:0,error:M,hadError:!!M})));const z=new u(w,N,j);return z.B(T),(0,p.$lkb)(z,A,O,N,j)}constructor(w,A,O){super(A,O),this.n=w}write(w){this.n.send(w.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[369],Ce([1,0,104,340,352,351,364,367,368,95,45,96,94,44,73,91,339,338,14,353,55,261,103,107,138]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i,s,d,$,g,t,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$kr)(P.$ubc,m.$rdc,0),(0,C.$kr)(s.$5i,i.$Bdc,1),(0,C.$kr)(s.$4i,new t.$xh(g.$Rcc,[!1],!0)),(0,C.$kr)(o.$Vk,a.$Z6b,1),(0,C.$kr)(v.$fbc,r.$Adc,0),(0,C.$kr)(b.$5bc,L.$5cc,0),(0,C.$kr)(I.$ccc,R.$mdc,0),(0,C.$kr)(p.$Zbc,f.$Wcc,0),(0,C.$kr)(k.$hbc,F.$Vcc,0),(0,C.$kr)(D.$csb,S.$zdc,0),(0,C.$kr)($.$3bc,d.$Cdc,0)}),define(De[380],Ce([1,0,61,381,53,8,81,117,244,111,350,22,29,101,11,130,268,285,355,369]),function($e,e,C,F,f,L,R,m,S,b,P,I,p,k,D,v,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const s=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,h=c._load;c._load=function(E){if(E==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const d=process.exit.bind(process);function $(c){process.exit=function(h){if(c)d(h);else{const E=new Error("An extension called process.exit() and this was prevented.");console.warn(E.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(c){d()};function t(){const c=(0,i.$qm)(process.env);if(c.type===3)return new Promise((h,E)=>{const y=u=>{const l=u[0],w=new R.$nh;l.on("message",A=>w.fire(I.$Ed.wrap(A.data))),l.on("close",()=>{g("renderer closed the MessagePort")}),l.start(),h({onMessage:w.event,send:A=>l.postMessage(A.buffer)})};process.parentPort.on("message",u=>y(u.ports))});if(c.type===2)return new Promise((h,E)=>{let y=null;const u=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),l=108e5,w=3e5,A=new D.$Sg(()=>g("renderer disconnected for too long (1)"),l),O=new D.$Sg(()=>g("renderer disconnected for too long (2)"),w);process.on("message",(T,j)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const z=I.$Ed.wrap(Buffer.from(T.initialDataChunk,"base64"));let M;if(T.skipWebSocketFrames)M=new m.$ph(j,"extHost-socket");else{const H=I.$Ed.wrap(Buffer.from(T.inflateBytes,"base64"));M=new m.$qh(new m.$ph(j,"extHost-socket"),T.permessageDeflate,H,!1)}y?(A.cancel(),O.cancel(),y.beginAcceptReconnection(M,z),y.endAcceptReconnection(),y.sendResume()):(clearTimeout(u),y=new R.$oh({socket:M,initialChunk:z}),y.sendResume(),y.onDidDispose(()=>g("renderer disconnected")),h(y),y.onSocketClose(()=>{A.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;A.isScheduled()&&O.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const h=c.pipeName;return new Promise((E,y)=>{const u=C.createConnection(h,()=>{u.removeListener("error",y);const l=new R.$oh({socket:new m.$ph(u,"extHost-renderer")});l.sendResume(),E(l)});u.once("error",y),u.on("close",()=>{g("renderer closed the socket")})})}}async function o(){const c=await t();return new class{constructor(){this.a=new R.$nh,this.onMessage=this.a.event,this.b=!1,c.onMessage(h=>{(0,b.$4l)(h,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||c.send(h)}async drain(){if(c.drain)return c.drain()}}}function a(c){return new Promise(h=>{const E=c.onMessage(y=>{E.dispose();const u=JSON.parse(y.toString()),l=u.commit,w=S.default.commit;if(l&&w&&l!==w&&d(55),u.parentPid){let A=0;setInterval(function(){try{process.kill(u.parentPid,0),A=0}catch(N){N&&N.code==="EPERM"?(A++,A>=3&&g(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):g(`parent process ${u.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(u.parentPid)}catch(N){(0,L.$Y)(N)}}c.send((0,b.$3l)(0)),h({protocol:c,initData:u})});c.send((0,b.$3l)(1))})}async function n(){const c=[];process.on("unhandledRejection",(A,O)=>{c.push(O),setTimeout(()=>{const N=c.indexOf(O);N>=0&&O.catch(T=>{c.splice(N,1),(0,L.$2)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),A&&(0,L.$Y)(A))})},1e3)}),process.on("rejectionHandled",A=>{const O=c.indexOf(A);O>=0&&c.splice(O,1)}),process.on("uncaughtException",function(A){(0,L.$X)(A)||(0,L.$Y)(A)}),f.mark("code/extHost/willConnectToRenderer");const h=await o();f.mark("code/extHost/didConnectToRenderer");const E=await a(h);f.mark("code/extHost/didWaitForInitData");const{initData:y}=E;$(!!y.environment.extensionTestsLocationURI),y.environment.useHostProxy=s.useHostProxy!==void 0?s.useHostProxy!=="false":void 0,y.environment.skipWorkspaceStorageLock=(0,v.boolean)(s.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(O){d(O)}fsExists(O){return p.Promises.exists(O)}fsRealpath(O){return(0,k.$Up)(O)}};let l=null;y.remote.authority&&s.transformURIs&&(l=(0,r.$or)(y.remote.authority));const w=new P.$Ucc(E.protocol,y,u,l);g=A=>w.terminate(A)}n().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f36df69328ed10f76d4be03e8a82b61794b49711/core/vs/workbench/api/node/extensionHostProcess.js.map
