/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],w=0,T=be.length;w<T;w++)e[w]=Ae[be[w]];return e};define(Ae[64],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function w(A){return(l,S,f)=>{let P=null,k=null;if(typeof f.value=="function"?(P="value",k=f.value):typeof f.get=="function"&&(P="get",k=f.get),!k)throw new Error("not supported");f[P]=A(k,S)}}function T(A,l,S){let f=null,P=null;if(typeof S.value=="function"?(f="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(f="get",P=S.get),!P)throw new Error("not supported");const k=`$memoize$${l}`;S[f]=function(...u){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[k]}}e.$5g=T;function C(A,l,S){return w((f,P)=>{const k=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...p){this[u]||(this[u]=S?S():void 0),clearTimeout(this[k]),l&&(this[u]=l(this[u],...p),p=[this[u]]),this[k]=setTimeout(()=>{f.apply(this,p),this[u]=S?S():void 0},A)}})}e.$6g=C;function L(A,l,S){return w((f,P)=>{const k=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...h){if(this[u]||(this[u]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),l&&(this[u]=l(this[u],...h)),this[m])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),f.apply(this,[this[u]]),this[u]=S?S():void 0):(this[m]=!0,this[k]=setTimeout(()=>{this[m]=!1,this[p]=Date.now(),f.apply(this,[this[u]]),this[u]=S?S():void 0},t-Date.now()))}})}e.$7g=L}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$1L=w,e.$2L=new w("id#")}),define(Ae[116],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var T;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(n,a=!1){let s=0;const o=n.length;let y="",$=0,I=16,E=0;function r(W){let N=0,z=0;for(;N<W;){const ee=n.charCodeAt(s);if(ee>=48&&ee<=57)z=z*16+ee-48;else if(ee>=65&&ee<=70)z=z*16+ee-65+10;else if(ee>=97&&ee<=102)z=z*16+ee-97+10;else break;s++,N++}return N<W&&(z=-1),z}function d(W){s=W,y="",$=0,I=16,E=0}function v(){const W=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&f(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&f(n.charCodeAt(s)))for(s++;s<n.length&&f(n.charCodeAt(s));)s++;else return E=3,n.substring(W,s);let N=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&f(n.charCodeAt(s))){for(s++;s<n.length&&f(n.charCodeAt(s));)s++;N=s}else E=3;return n.substring(W,N)}function R(){let W="",N=s;for(;;){if(s>=o){W+=n.substring(N,s),E=2;break}const z=n.charCodeAt(s);if(z===34){W+=n.substring(N,s),s++;break}if(z===92){if(W+=n.substring(N,s),s++,s>=o){E=2;break}switch(n.charCodeAt(s++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const X=r(4);X>=0?W+=String.fromCharCode(X):E=4;break}default:E=5}N=s;continue}if(z>=0&&z<=31)if(S(z)){W+=n.substring(N,s),E=2;break}else E=6;s++}return W}function B(){if(y="",E=0,$=s,s>=o)return $=o,I=17;let W=n.charCodeAt(s);if(l(W)){do s++,y+=String.fromCharCode(W),W=n.charCodeAt(s);while(l(W));return I=15}if(S(W))return s++,y+=String.fromCharCode(W),W===13&&n.charCodeAt(s)===10&&(s++,y+=`
`),I=14;switch(W){case 123:return s++,I=1;case 125:return s++,I=2;case 91:return s++,I=3;case 93:return s++,I=4;case 58:return s++,I=6;case 44:return s++,I=5;case 34:return s++,y=R(),I=10;case 47:{const N=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!S(n.charCodeAt(s));)s++;return y=n.substring(N,s),I=12}if(n.charCodeAt(s+1)===42){s+=2;const z=o-1;let ee=!1;for(;s<z;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,ee=!0;break}s++}return ee||(s++,E=1),y=n.substring(N,s),I=13}return y+=String.fromCharCode(W),s++,I=16}case 45:if(y+=String.fromCharCode(W),s++,s===o||!f(n.charCodeAt(s)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=v(),I=11;default:for(;s<o&&V(W);)s++,W=n.charCodeAt(s);if($!==s){switch(y=n.substring($,s),y){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return y+=String.fromCharCode(W),s++,I=16}}function V(W){if(l(W)||S(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let W;do W=B();while(W>=12&&W<=15);return W}return{setPosition:d,getPosition:()=>s,scan:a?j:B,getToken:()=>I,getTokenValue:()=>y,getTokenOffset:()=>$,getTokenLength:()=>s-$,getTokenError:()=>E}}e.$Im=A;function l(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function S(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function k(n,a){const s=[],o=new Object;let y;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function E(r,d,v,R){$.value=r,$.offset=d,$.length=v,$.type=R,$.colonOffset=void 0,y=$}try{g(n,{onObjectBegin:(r,d)=>{if(a<=r)throw o;y=void 0,I=a>r,s.push("")},onObjectProperty:(r,d,v)=>{if(a<d||(E(r,d,v,"property"),s[s.length-1]=r,a<=d+v))throw o},onObjectEnd:(r,d)=>{if(a<=r)throw o;y=void 0,s.pop()},onArrayBegin:(r,d)=>{if(a<=r)throw o;y=void 0,s.push(0)},onArrayEnd:(r,d)=>{if(a<=r)throw o;y=void 0,s.pop()},onLiteralValue:(r,d,v)=>{if(a<d||(E(r,d,v,b(r)),a<=d+v))throw o},onSeparator:(r,d,v)=>{if(a<=d)throw o;if(r===":"&&y&&y.type==="property")y.colonOffset=d,I=!1,y=void 0;else if(r===","){const R=s[s.length-1];typeof R=="number"?s[s.length-1]=R+1:(I=!0,s[s.length-1]=""),y=void 0}}})}catch(r){if(r!==o)throw r}return{path:s,previousNode:y,isAtPropertyKey:I,matches:r=>{let d=0;for(let v=0;d<r.length&&v<s.length;v++)if(r[d]===s[v]||r[d]==="*")d++;else if(r[d]!=="**")return!1;return d===r.length}}}e.$Jm=k;function u(n,a=[],s=L.DEFAULT){let o=null,y=[];const $=[];function I(r){Array.isArray(y)?y.push(r):o!==null&&(y[o]=r)}return g(n,{onObjectBegin:()=>{const r={};I(r),$.push(y),y=r,o=null},onObjectProperty:r=>{o=r},onObjectEnd:()=>{y=$.pop()},onArrayBegin:()=>{const r=[];I(r),$.push(y),y=r,o=null},onArrayEnd:()=>{y=$.pop()},onLiteralValue:I,onError:(r,d,v)=>{a.push({error:r,offset:d,length:v})}},s),y[0]}e.$Km=u;function p(n,a=[],s=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(r){o.type==="property"&&(o.length=r-o.offset,o=o.parent)}function $(r){return o.children.push(r),r}g(n,{onObjectBegin:r=>{o=$({type:"object",offset:r,length:-1,parent:o,children:[]})},onObjectProperty:(r,d,v)=>{o=$({type:"property",offset:d,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:r,offset:d,length:v,parent:o})},onObjectEnd:(r,d)=>{o.length=r+d-o.offset,o=o.parent,y(r+d)},onArrayBegin:(r,d)=>{o=$({type:"array",offset:r,length:-1,parent:o,children:[]})},onArrayEnd:(r,d)=>{o.length=r+d-o.offset,o=o.parent,y(r+d)},onLiteralValue:(r,d,v)=>{$({type:b(r),offset:d,length:v,parent:o,value:r}),y(d+v)},onSeparator:(r,d,v)=>{o.type==="property"&&(r===":"?o.colonOffset=d:r===","&&y(d))},onError:(r,d,v)=>{a.push({error:r,offset:d,length:v})}},s);const E=o.children[0];return E&&delete E.parent,E}e.$Lm=p;function m(n,a){if(!n)return;let s=n;for(const o of a)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let y=!1;for(const $ of s.children)if(Array.isArray($.children)&&$.children[0].value===o){s=$.children[1],y=!0;break}if(!y)return}else{const y=o;if(s.type!=="array"||y<0||!Array.isArray(s.children)||y>=s.children.length)return;s=s.children[y]}return s}e.$Mm=m;function h(n){if(!n.parent||!n.parent.children)return[];const a=h(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;a.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&a.push(s)}return a}e.$Nm=h;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const a=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(a[s.children[0].value]=t(o))}return a}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$Om=t;function i(n,a,s=!1){return a>=n.offset&&a<n.offset+n.length||s&&a===n.offset+n.length}e.$Pm=i;function c(n,a,s=!1){if(i(n,a,s)){const o=n.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=a;y++){const $=c(o[y],a,s);if($)return $}return n}}e.$Qm=c;function g(n,a,s=L.DEFAULT){const o=A(n,!1);function y(ye){return ye?()=>ye(o.getTokenOffset(),o.getTokenLength()):()=>!0}function $(ye){return ye?ce=>ye(ce,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=y(a.onObjectBegin),E=$(a.onObjectProperty),r=y(a.onObjectEnd),d=y(a.onArrayBegin),v=y(a.onArrayEnd),R=$(a.onLiteralValue),B=$(a.onSeparator),V=y(a.onComment),j=$(a.onError),W=s&&s.disallowComments,N=s&&s.allowTrailingComma;function z(){for(;;){const ye=o.scan();switch(o.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:W||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(ye){case 12:case 13:W?ee(10):V();break;case 16:ee(1);break;case 15:case 14:break;default:return ye}}}function ee(ye,ce=[],$e=[]){if(j(ye),ce.length+$e.length>0){let ie=o.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){z();break}else if($e.indexOf(ie)!==-1)break;ie=z()}}}function X(ye){const ce=o.getTokenValue();return ye?R(ce):E(ce),z(),!0}function Ee(){switch(o.getToken()){case 11:{let ye=0;try{ye=JSON.parse(o.getTokenValue()),typeof ye!="number"&&(ee(2),ye=0)}catch{ee(2)}R(ye);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return z(),!0}function De(){return o.getToken()!==10?(ee(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(B(":"),z(),ue()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){I(),z();let ye=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ye||ee(4,[],[]),B(","),z(),o.getToken()===2&&N)break}else ye&&ee(6,[],[]);De()||ee(4,[],[2,5]),ye=!0}return r(),o.getToken()!==2?ee(7,[2],[]):z(),!0}function Z(){d(),z();let ye=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ye||ee(4,[],[]),B(","),z(),o.getToken()===4&&N)break}else ye&&ee(6,[],[]);ue()||ee(4,[],[4,5]),ye=!0}return v(),o.getToken()!==4?ee(8,[4],[]):z(),!0}function ue(){switch(o.getToken()){case 3:return Z();case 1:return Pe();case 10:return X(!0);default:return Ee()}}return z(),o.getToken()===17?s.allowEmptyContent?!0:(ee(4,[],[]),!1):ue()?(o.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Rm=g;function D(n,a){const s=A(n),o=[];let y,$=0,I;do switch(I=s.getPosition(),y=s.scan(),y){case 12:case 13:case 17:$!==I&&o.push(n.substring($,I)),a!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,a)),$=s.getPosition();break}while(y!==17);return o.join("")}e.$Sm=D;function b(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=b}),define(Ae[28],Re([1,0]),function(be,e){"use strict";var w,T,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.Touch=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;function L(t,i,c){let g=t.get(i);return g===void 0&&(g=c,t.set(i,g)),g}e.$vi=L;function A(t){const i=[];return t.forEach((c,g)=>{i.push(`${g} => ${c}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.$wi=A;function l(t){const i=[];return t.forEach(c=>{i.push(c)}),`Set(${t.size}) {${i.join(", ")}}`}e.$xi=l;class S{constructor(i,c){this.uri=i,this.value=c}}class f{static{this.a=i=>i.toString()}constructor(i,c){this[w]="ResourceMap",i instanceof f?(this.b=new Map(i.b),this.c=c??f.a):(this.b=new Map,this.c=i??f.a)}set(i,c){return this.b.set(this.c(i),new S(i,c)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,c){typeof c<"u"&&(i=i.bind(c));for(const[g,D]of this.b)i(D.value,D.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$yi=f;class P{constructor(i,c){this[T]="ResourceSet",!i||typeof i=="function"?this.a=new f(i):(this.a=new f(c),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,c){this.a.forEach((g,D)=>i.call(c,D,D,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zi=P;var k;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class u{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,c=0){const g=this.a.get(i);if(g)return c!==0&&this.j(g,c),g.value}set(i,c,g=0){let D=this.a.get(i);if(D)D.value=c,g!==0&&this.j(D,g);else{switch(D={key:i,value:c,next:void 0,previous:void 0},g){case 0:this.h(D);break;case 1:this.g(D);break;case 2:this.h(D);break;default:this.h(D);break}this.a.set(i,D),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const c=this.a.get(i);if(c)return this.a.delete(i),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,c){const g=this.e;let D=this.b;for(;D;){if(c?i.bind(c)(D.value,D.key,this):i(D.value,D.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");D=D.next}}keys(){const i=this,c=this.e;let g=this.b;const D={[Symbol.iterator](){return D},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:g.key,done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return D}values(){const i=this,c=this.e;let g=this.b;const D={[Symbol.iterator](){return D},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:g.value,done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return D}entries(){const i=this,c=this.e;let g=this.b;const D={[Symbol.iterator](){return D},next(){if(i.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:[g.key,g.value],done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return D}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let c=this.b,g=this.size;for(;c&&g>i;)this.a.delete(c.key),c=c.next,g--;this.b=c,this.d=g,c&&(c.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const c=i.next,g=i.previous;if(!c||!g)throw new Error("Invalid list");c.previous=g,g.next=c}i.next=void 0,i.previous=void 0,this.e++}j(i,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(i===this.b)return;const g=i.next,D=i.previous;i===this.c?(D.next=void 0,this.c=D):(g.previous=D,D.next=g),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(c===2){if(i===this.c)return;const g=i.next,D=i.previous;i===this.b?(g.previous=void 0,this.b=g):(g.previous=D,D.next=g),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((c,g)=>{i.push([g,c])}),i}fromJSON(i){this.clear();for(const[c,g]of i)this.set(c,g)}}e.$Ai=u;class p extends u{constructor(i,c=1){super(),this.k=i,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,c=2){return super.get(i,c)}peek(i){return super.get(i,0)}set(i,c){return super.set(i,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bi=p;class m{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let c=this.a.get(i)||0;return c===0?!1:(c--,c===0?this.a.delete(i):this.a.set(i,c),!0)}has(i){return this.a.has(i)}}e.$Ci=m;class h{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[c,g]of i)this.set(c,g)}clear(){this.a.clear(),this.b.clear()}set(i,c){this.a.set(i,c),this.b.set(c,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const c=this.a.get(i);return c===void 0?!1:(this.a.delete(i),this.b.delete(c),!0)}forEach(i,c){this.a.forEach((g,D)=>{i.call(c,g,D,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Di=h}),function(be,e){typeof define=="function"&&define.amd?define(Ae[117],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,me){for(var ke=0;ke<me.length;ke++){var se=me[ke];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(ve,se.key,se)}}function w(ve,me,ke){return me&&e(ve.prototype,me),ke&&e(ve,ke),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function T(ve,me){if(ve){if(typeof ve=="string")return C(ve,me);var ke=Object.prototype.toString.call(ve).slice(8,-1);if(ke==="Object"&&ve.constructor&&(ke=ve.constructor.name),ke==="Map"||ke==="Set")return Array.from(ve);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return C(ve,me)}}function C(ve,me){(me==null||me>ve.length)&&(me=ve.length);for(var ke=0,se=new Array(me);ke<me;ke++)se[ke]=ve[ke];return se}function L(ve,me){var ke=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(ke)return(ke=ke.call(ve)).next.bind(ke);if(Array.isArray(ve)||(ke=T(ve))||me&&ve&&typeof ve.length=="number"){ke&&(ve=ke);var se=0;return function(){return se>=ve.length?{done:!0}:{done:!1,value:ve[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function l(ve){be.defaults=ve}var S=/[&<>"']/,f=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(me){return u[me]};function m(ve,me){if(me){if(S.test(ve))return ve.replace(f,p)}else if(P.test(ve))return ve.replace(k,p);return ve}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(h,function(me,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(ve,me){ve=typeof ve=="string"?ve:ve.source,me=me||"";var ke={replace:function(he,re){return re=re.source||re,re=re.replace(i,"$1"),ve=ve.replace(he,re),ke},getRegex:function(){return new RegExp(ve,me)}};return ke}var g=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(ve,me,ke){if(ve){var se;try{se=decodeURIComponent(t(ke)).replace(g,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}me&&!D.test(ke)&&(ke=y(me,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var n={},a=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ve,me){n[" "+ve]||(a.test(ve)?n[" "+ve]=ve+"/":n[" "+ve]=r(ve,"/",!0)),ve=n[" "+ve];var ke=ve.indexOf(":")===-1;return me.substring(0,2)==="//"?ke?me:ve.replace(s,"$1")+me:me.charAt(0)==="/"?ke?me:ve.replace(o,"$1")+me:ve+me}var $={exec:function(){}};function I(ve){for(var me=1,ke,se;me<arguments.length;me++){ke=arguments[me];for(se in ke)Object.prototype.hasOwnProperty.call(ke,se)&&(ve[se]=ke[se])}return ve}function E(ve,me){var ke=ve.replace(/\|/g,function(re,oe,fe){for(var Ie=!1,F=oe;--F>=0&&fe[F]==="\\";)Ie=!Ie;return Ie?"|":" |"}),se=ke.split(/ \|/),he=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>me)se.splice(me);else for(;se.length<me;)se.push("");for(;he<se.length;he++)se[he]=se[he].trim().replace(/\\\|/g,"|");return se}function r(ve,me,ke){var se=ve.length;if(se===0)return"";for(var he=0;he<se;){var re=ve.charAt(se-he-1);if(re===me&&!ke)he++;else if(re!==me&&ke)he++;else break}return ve.slice(0,se-he)}function d(ve,me){if(ve.indexOf(me[1])===-1)return-1;for(var ke=ve.length,se=0,he=0;he<ke;he++)if(ve[he]==="\\")he++;else if(ve[he]===me[0])se++;else if(ve[he]===me[1]&&(se--,se<0))return he;return-1}function v(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ve,me){if(me<1)return"";for(var ke="";me>1;)me&1&&(ke+=ve),me>>=1,ve+=ve;return ke+ve}function B(ve,me,ke,se){var he=me.href,re=me.title?m(me.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){se.state.inLink=!0;var fe={type:"link",raw:ke,href:he,title:re,text:oe,tokens:se.inlineTokens(oe)};return se.state.inLink=!1,fe}return{type:"image",raw:ke,href:he,title:re,text:m(oe)}}function V(ve,me){var ke=ve.match(/^(\s+)(?:```)/);if(ke===null)return me;var se=ke[1];return me.split(`
`).map(function(he){var re=he.match(/^\s+/);if(re===null)return he;var oe=re[0];return oe.length>=se.length?he.slice(se.length):he}).join(`
`)}var j=function(){function ve(ke){this.options=ke||be.defaults}var me=ve.prototype;return me.space=function(se){var he=this.rules.block.newline.exec(se);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},me.code=function(se){var he=this.rules.block.code.exec(se);if(he){var re=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?re:r(re,`
`)}}},me.fences=function(se){var he=this.rules.block.fences.exec(se);if(he){var re=he[0],oe=V(re,he[3]||"");return{type:"code",raw:re,lang:he[2]?he[2].trim():he[2],text:oe}}},me.heading=function(se){var he=this.rules.block.heading.exec(se);if(he){var re=he[2].trim();if(/#$/.test(re)){var oe=r(re,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(re=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:re,tokens:this.lexer.inline(re)}}},me.hr=function(se){var he=this.rules.block.hr.exec(se);if(he)return{type:"hr",raw:he[0]}},me.blockquote=function(se){var he=this.rules.block.blockquote.exec(se);if(he){var re=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},me.list=function(se){var he=this.rules.block.list.exec(se);if(he){var re,oe,fe,Ie,F,K,G,Q,J,x,ae,Le,Ue=he[1].trim(),Qe=Ue.length>1,He={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Le=!1,!(!(he=et.exec(se))||this.rules.block.hr.test(se)));){if(re=he[0],se=se.substring(re.length),Q=he[2].split(`
`,1)[0],J=se.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Q.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Q.slice(Ie),Ie+=he[1].length),K=!1,!Q&&/^ *$/.test(J)&&(re+=J+`
`,se=se.substring(J.length+1),Le=!0),!Le)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");se&&(x=se.split(`
`,1)[0],Q=x,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Ze.test(Q)||_e.test(se)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ae+=`
`+Q.slice(Ie);else if(!K)ae+=`
`+Q;else break;!K&&!Q.trim()&&(K=!0),re+=x+`
`,se=se.substring(x.length+1)}He.loose||(G?He.loose=!0:/\n *\n *$/.test(re)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(fe=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:re,task:!!oe,checked:fe,loose:!1,text:ae}),He.raw+=re}He.items[He.items.length-1].raw=re.trimRight(),He.items[He.items.length-1].text=ae.trimRight(),He.raw=He.raw.trimRight();var Oe=He.items.length;for(F=0;F<Oe;F++){this.lexer.state.top=!1,He.items[F].tokens=this.lexer.blockTokens(He.items[F].text,[]);var st=He.items[F].tokens.filter(function(Y){return Y.type==="space"}),_=st.every(function(Y){for(var pe=Y.raw.split(""),je=0,ze=L(pe),Ye;!(Ye=ze()).done;){var nt=Ye.value;if(nt===`
`&&(je+=1),je>1)return!0}return!1});!He.loose&&st.length&&_&&(He.loose=!0,He.items[F].loose=!0)}return He}},me.html=function(se){var he=this.rules.block.html.exec(se);if(he){var re={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]);re.type="paragraph",re.text=oe,re.tokens=this.lexer.inline(oe)}return re}},me.def=function(se){var he=this.rules.block.def.exec(se);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var re=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:he[0],href:he[2],title:he[3]}}},me.table=function(se){var he=this.rules.block.table.exec(se);if(he){var re={type:"table",header:E(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=he[0];var oe=re.align.length,fe,Ie,F,K;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(re.align[fe])?re.align[fe]="right":/^ *:-+: *$/.test(re.align[fe])?re.align[fe]="center":/^ *:-+ *$/.test(re.align[fe])?re.align[fe]="left":re.align[fe]=null;for(oe=re.rows.length,fe=0;fe<oe;fe++)re.rows[fe]=E(re.rows[fe],re.header.length).map(function(G){return{text:G}});for(oe=re.header.length,Ie=0;Ie<oe;Ie++)re.header[Ie].tokens=this.lexer.inline(re.header[Ie].text);for(oe=re.rows.length,Ie=0;Ie<oe;Ie++)for(K=re.rows[Ie],F=0;F<K.length;F++)K[F].tokens=this.lexer.inline(K[F].text);return re}}},me.lheading=function(se){var he=this.rules.block.lheading.exec(se);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},me.paragraph=function(se){var he=this.rules.block.paragraph.exec(se);if(he){var re=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:re,tokens:this.lexer.inline(re)}}},me.text=function(se){var he=this.rules.block.text.exec(se);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},me.escape=function(se){var he=this.rules.inline.escape.exec(se);if(he)return{type:"escape",raw:he[0],text:m(he[1])}},me.tag=function(se){var he=this.rules.inline.tag.exec(se);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]):he[0]}},me.link=function(se){var he=this.rules.inline.link.exec(se);if(he){var re=he[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var oe=r(re.slice(0,-1),"\\");if((re.length-oe.length)%2===0)return}else{var fe=d(he[2],"()");if(fe>-1){var Ie=he[0].indexOf("!")===0?5:4,F=Ie+he[1].length+fe;he[2]=he[2].substring(0,fe),he[0]=he[0].substring(0,F).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);Q&&(K=Q[1],G=Q[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(re)?K=K.slice(1):K=K.slice(1,-1)),B(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},me.reflink=function(se,he){var re;if((re=this.rules.inline.reflink.exec(se))||(re=this.rules.inline.nolink.exec(se))){var oe=(re[2]||re[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var fe=re[0].charAt(0);return{type:"text",raw:fe,text:fe}}return B(re,oe,re[0],this.lexer)}},me.emStrong=function(se,he,re){re===void 0&&(re="");var oe=this.rules.inline.emStrong.lDelim.exec(se);if(oe&&!(oe[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(re===""||this.rules.inline.punctuation.exec(re))){var Ie=oe[0].length-1,F,K,G=Ie,Q=0,J=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,he=he.slice(-1*se.length+Ie);(oe=J.exec(he))!=null;)if(F=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!F){if(K=F.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){Q+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+Q),Math.min(Ie,K)%2){var x=se.slice(1,Ie+oe.index+K);return{type:"em",raw:se.slice(0,Ie+oe.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ae=se.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:se.slice(0,Ie+oe.index+K+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},me.codespan=function(se){var he=this.rules.inline.code.exec(se);if(he){var re=he[2].replace(/\n/g," "),oe=/[^ ]/.test(re),fe=/^ /.test(re)&&/ $/.test(re);return oe&&fe&&(re=re.substring(1,re.length-1)),re=m(re,!0),{type:"codespan",raw:he[0],text:re}}},me.br=function(se){var he=this.rules.inline.br.exec(se);if(he)return{type:"br",raw:he[0]}},me.del=function(se){var he=this.rules.inline.del.exec(se);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},me.autolink=function(se,he){var re=this.rules.inline.autolink.exec(se);if(re){var oe,fe;return re[2]==="@"?(oe=m(this.options.mangle?he(re[1]):re[1]),fe="mailto:"+oe):(oe=m(re[1]),fe=oe),{type:"link",raw:re[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},me.url=function(se,he){var re;if(re=this.rules.inline.url.exec(se)){var oe,fe;if(re[2]==="@")oe=m(this.options.mangle?he(re[0]):re[0]),fe="mailto:"+oe;else{var Ie;do Ie=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(Ie!==re[0]);oe=m(re[0]),re[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:re[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},me.inlineText=function(se,he){var re=this.rules.inline.text.exec(se);if(re){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):m(re[0]):re[0]:oe=m(this.options.smartypants?he(re[0]):re[0]),{type:"text",raw:re[0],text:oe}}},ve}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=c(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=c(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=c(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=c(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=c(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=I({},W),W.gfm=I({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=c(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=I({},W.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:c(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=c(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=c(W._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=c(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=c(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=c(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=c(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=c(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=c(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=c(N.reflink).replace("label",N._label).replace("ref",W._label).getRegex(),N.nolink=c(N.nolink).replace("ref",W._label).getRegex(),N.reflinkSearch=c(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=I({},N),N.pedantic=I({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=I({},N.normal,{escape:c(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=c(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=I({},N.gfm,{br:c(N.br).replace("{2,}","*").getRegex(),text:c(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(ve){var me="",ke,se,he=ve.length;for(ke=0;ke<he;ke++)se=ve.charCodeAt(ke),Math.random()>.5&&(se="x"+se.toString(16)),me+="&#"+se+";";return me}var X=function(){function ve(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||be.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:W.normal,inline:N.normal};this.options.pedantic?(se.block=W.pedantic,se.inline=N.pedantic):this.options.gfm&&(se.block=W.gfm,this.options.breaks?se.inline=N.breaks:se.inline=N.gfm),this.tokenizer.rules=se}ve.lex=function(se,he){var re=new ve(he);return re.lex(se)},ve.lexInline=function(se,he){var re=new ve(he);return re.inlineTokens(se)};var me=ve.prototype;return me.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},me.blockTokens=function(se,he){var re=this;he===void 0&&(he=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(G,Q,J){return Q+"    ".repeat(J.length)});for(var oe,fe,Ie,F;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:re},se,he))?(se=se.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(se)){se=se.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(se)){se=se.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(oe=this.tokenizer.fences(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(se)){se=se.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(Ie=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=se.slice(1),J=void 0;re.options.extensions.startBlock.forEach(function(x){J=x.call({lexer:this},Q),typeof J=="number"&&J>=0&&(G=Math.min(G,J))}),G<1/0&&G>=0&&(Ie=se.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){fe=he[he.length-1],F&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe),F=Ie.length!==se.length,se=se.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(se)){se=se.substring(oe.raw.length),fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(se){var K="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},me.inline=function(se,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:se,tokens:he}),he},me.inlineTokens=function(se,he){var re=this;he===void 0&&(he=[]);var oe,fe,Ie,F=se,K,G,Q;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)J.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,K.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:re},se,he))?(se=se.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(se)){se=se.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(se,F,Q)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(se)){se=se.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(se,ee)){se=se.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(se,ee))){se=se.substring(oe.raw.length),he.push(oe);continue}if(Ie=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Le=se.slice(1),Ue=void 0;re.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Le),typeof Ue=="number"&&Ue>=0&&(ae=Math.min(ae,Ue))}),ae<1/0&&ae>=0&&(Ie=se.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,z)){se=se.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),G=!0,fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(se){var x="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},w(ve,null,[{key:"rules",get:function(){return{block:W,inline:N}}}]),ve}(),Ee=function(){function ve(ke){this.options=ke||be.defaults}var me=ve.prototype;return me.code=function(se,he,re){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(se,oe);fe!=null&&fe!==se&&(re=!0,se=fe)}return se=se.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+m(oe,!0)+'">'+(re?se:m(se,!0))+`</code></pre>
`:"<pre><code>"+(re?se:m(se,!0))+`</code></pre>
`},me.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},me.html=function(se){return se},me.heading=function(se,he,re,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(re);return"<h"+he+' id="'+fe+'">'+se+"</h"+he+`>
`}return"<h"+he+">"+se+"</h"+he+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(se,he,re){var oe=he?"ol":"ul",fe=he&&re!==1?' start="'+re+'"':"";return"<"+oe+fe+`>
`+se+"</"+oe+`>
`},me.listitem=function(se){return"<li>"+se+`</li>
`},me.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(se){return"<p>"+se+`</p>
`},me.table=function(se,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+he+`</table>
`},me.tablerow=function(se){return`<tr>
`+se+`</tr>
`},me.tablecell=function(se,he){var re=he.header?"th":"td",oe=he.align?"<"+re+' align="'+he.align+'">':"<"+re+">";return oe+se+("</"+re+`>
`)},me.strong=function(se){return"<strong>"+se+"</strong>"},me.em=function(se){return"<em>"+se+"</em>"},me.codespan=function(se){return"<code>"+se+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(se){return"<del>"+se+"</del>"},me.link=function(se,he,re){if(se=b(this.options.sanitize,this.options.baseUrl,se),se===null)return re;var oe='<a href="'+m(se)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+re+"</a>",oe},me.image=function(se,he,re){if(se=b(this.options.sanitize,this.options.baseUrl,se),se===null)return re;var oe='<img src="'+se+'" alt="'+re+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},me.text=function(se){return se},ve}(),De=function(){function ve(){}var me=ve.prototype;return me.strong=function(se){return se},me.em=function(se){return se},me.codespan=function(se){return se},me.del=function(se){return se},me.html=function(se){return se},me.text=function(se){return se},me.link=function(se,he,re){return""+re},me.image=function(se,he,re){return""+re},me.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var me=ve.prototype;return me.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(se,he){var re=se,oe=0;if(this.seen.hasOwnProperty(re)){oe=this.seen[se];do oe++,re=se+"-"+oe;while(this.seen.hasOwnProperty(re))}return he||(this.seen[se]=oe,this.seen[re]=0),re},me.slug=function(se,he){he===void 0&&(he={});var re=this.serialize(se);return this.getNextSafeSlug(re,he.dryrun)},ve}(),Z=function(){function ve(ke){this.options=ke||be.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Pe}ve.parse=function(se,he){var re=new ve(he);return re.parse(se)},ve.parseInline=function(se,he){var re=new ve(he);return re.parseInline(se)};var me=ve.prototype;return me.parse=function(se,he){he===void 0&&(he=!0);var re="",oe,fe,Ie,F,K,G,Q,J,x,ae,Le,Ue,Qe,He,et,Ze,_e,it,tt,Oe=se.length;for(oe=0;oe<Oe;oe++){if(ae=se[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){re+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(J="",Q="",F=ae.header.length,fe=0;fe<F;fe++)Q+=this.renderer.tablecell(this.parseInline(ae.header[fe].tokens),{header:!0,align:ae.align[fe]});for(J+=this.renderer.tablerow(Q),x="",F=ae.rows.length,fe=0;fe<F;fe++){for(G=ae.rows[fe],Q="",K=G.length,Ie=0;Ie<K;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ae.align[Ie]});x+=this.renderer.tablerow(Q)}re+=this.renderer.table(J,x);continue}case"blockquote":{x=this.parse(ae.tokens),re+=this.renderer.blockquote(x);continue}case"list":{for(Le=ae.ordered,Ue=ae.start,Qe=ae.loose,F=ae.items.length,x="",fe=0;fe<F;fe++)et=ae.items[fe],Ze=et.checked,_e=et.task,He="",et.task&&(it=this.renderer.checkbox(Ze),Qe?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(et.tokens,Qe),x+=this.renderer.listitem(He,_e,Ze);re+=this.renderer.list(x,Le,Ue);continue}case"html":{re+=this.renderer.html(ae.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(x=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<Oe&&se[oe+1].type==="text";)ae=se[++oe],x+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);re+=he?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return re},me.parseInline=function(se,he){he=he||this.renderer;var re="",oe,fe,Ie,F=se.length;for(oe=0;oe<F;oe++){if(fe=se[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){re+=Ie||"";continue}switch(fe.type){case"escape":{re+=he.text(fe.text);break}case"html":{re+=he.html(fe.text);break}case"link":{re+=he.link(fe.href,fe.title,this.parseInline(fe.tokens,he));break}case"image":{re+=he.image(fe.href,fe.title,fe.text);break}case"strong":{re+=he.strong(this.parseInline(fe.tokens,he));break}case"em":{re+=he.em(this.parseInline(fe.tokens,he));break}case"codespan":{re+=he.codespan(fe.text);break}case"br":{re+=he.br();break}case"del":{re+=he.del(this.parseInline(fe.tokens,he));break}case"text":{re+=he.text(fe.text);break}default:{var K='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return re},ve}();function ue(ve,me,ke){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof me=="function"&&(ke=me,me=null),me=I({},ue.defaults,me||{}),v(me),ke){var se=me.highlight,he;try{he=X.lex(ve,me)}catch(F){return ke(F)}var re=function(K){var G;if(!K)try{me.walkTokens&&ue.walkTokens(he,me.walkTokens),G=Z.parse(he,me)}catch(Q){K=Q}return me.highlight=se,K?ke(K):ke(null,G)};if(!se||se.length<3||(delete me.highlight,!he.length))return re();var oe=0;ue.walkTokens(he,function(F){F.type==="code"&&(oe++,setTimeout(function(){se(F.text,F.lang,function(K,G){if(K)return re(K);G!=null&&G!==F.text&&(F.text=G,F.escaped=!0),oe--,oe===0&&re()})},0))}),oe===0&&re();return}function fe(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+m(F.message+"",!0)+"</pre>";throw F}try{var Ie=X.lex(ve,me);if(me.walkTokens){if(me.async)return Promise.all(ue.walkTokens(Ie,me.walkTokens)).then(function(){return Z.parse(Ie,me)}).catch(fe);ue.walkTokens(Ie,me.walkTokens)}return Z.parse(Ie,me)}catch(F){fe(F)}}ue.options=ue.setOptions=function(ve){return I(ue.defaults,ve),l(ue.defaults),ue},ue.getDefaults=A,ue.defaults=be.defaults,ue.use=function(){for(var ve=arguments.length,me=new Array(ve),ke=0;ke<ve;ke++)me[ke]=arguments[ke];var se=I.apply(void 0,[{}].concat(me)),he=ue.defaults.extensions||{renderers:{},childTokens:{}},re;me.forEach(function(oe){if(oe.extensions&&(re=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var F=he.renderers?he.renderers[Ie.name]:null;F?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),Q=0;Q<K;Q++)G[Q]=arguments[Q];var J=Ie.renderer.apply(this,G);return J===!1&&(J=F.apply(this,G)),J}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ue.defaults.renderer||new Ee,F=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Le=0;Le<x;Le++)ae[Le]=arguments[Le];var Ue=oe.renderer[Q].apply(Ie,ae);return Ue===!1&&(Ue=J.apply(Ie,ae)),Ue}};for(var K in oe.renderer)F(K);se.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ue.defaults.tokenizer||new j,F=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Le=0;Le<x;Le++)ae[Le]=arguments[Le];var Ue=oe.tokenizer[Q].apply(Ie,ae);return Ue===!1&&(Ue=J.apply(Ie,ae)),Ue}};for(var K in oe.tokenizer)F(K);se.tokenizer=Ie}(),oe.walkTokens){var fe=ue.defaults.walkTokens;se.walkTokens=function(Ie){var F=[];return F.push(oe.walkTokens.call(this,Ie)),fe&&(F=F.concat(fe.call(this,Ie))),F}}re&&(se.extensions=he),ue.setOptions(se)})},ue.walkTokens=function(ve,me){for(var ke=[],se=function(){var fe=re.value;switch(ke=ke.concat(me.call(ue,fe)),fe.type){case"table":{for(var Ie=L(fe.header),F;!(F=Ie()).done;){var K=F.value;ke=ke.concat(ue.walkTokens(K.tokens,me))}for(var G=L(fe.rows),Q;!(Q=G()).done;)for(var J=Q.value,x=L(J),ae;!(ae=x()).done;){var Le=ae.value;ke=ke.concat(ue.walkTokens(Le.tokens,me))}break}case"list":{ke=ke.concat(ue.walkTokens(fe.items,me));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[fe.type]?ue.defaults.extensions.childTokens[fe.type].forEach(function(Ue){ke=ke.concat(ue.walkTokens(fe[Ue],me))}):fe.tokens&&(ke=ke.concat(ue.walkTokens(fe.tokens,me)))}},he=L(ve),re;!(re=he()).done;)se();return ke},ue.parseInline=function(ve,me){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");me=I({},ue.defaults,me||{}),v(me);try{var ke=X.lexInline(ve,me);return me.walkTokens&&ue.walkTokens(ke,me.walkTokens),Z.parseInline(ke,me)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+m(se.message+"",!0)+"</pre>";throw se}},ue.Parser=Z,ue.parser=Z.parse,ue.Renderer=Ee,ue.TextRenderer=De,ue.Lexer=X,ue.lexer=X.lex,ue.Tokenizer=j,ue.Slugger=Pe,ue.parse=ue;var ye=ue.options,ce=ue.setOptions,$e=ue.use,ie=ue.walkTokens,O=ue.parseInline,q=ue,le=Z.parse,we=X.lex;be.Lexer=X,be.Parser=Z,be.Renderer=Ee,be.Slugger=Pe,be.TextRenderer=De,be.Tokenizer=j,be.getDefaults=A,be.lexer=we,be.marked=ue,be.options=ye,be.parse=q,be.parseInline=O,be.parser=le,be.setOptions=ce,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[118],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.rot=e.$Gl=void 0;function w(l,S,f){return Math.min(Math.max(l,S),f)}e.$Gl=w;function T(l,S){return(S+l%S)%S}e.rot=T;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Il=C;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jl=L;class A{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const f=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Kl=A}),function(){function be(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function A(S){L.push(S,Date.now())}function l(){const S=[];for(let f=0;f<L.length;f+=2)S.push({name:L[f],startTime:L[f+1]});return S}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(C+A.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=w(T))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var T in w)(typeof exports=="object"?exports:be)[T]=w[T]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return be[T].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=be,w.c=e,w.d=function(T,C,L){w.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:L})},w.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},w.t=function(T,C){if(1&C&&(T=w(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(w.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var A in T)w.d(L,A,function(l){return T[l]}.bind(null,A));return L},w.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return w.d(C,"a",C),C},w.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},w.p="",w(w.s=0)}([function(be,e,w){(function(T){var C;e=be.exports=$e,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],S=e.src=[],f=0,P=f++;S[P]="0|[1-9]\\d*";var k=f++;S[k]="[0-9]+";var u=f++;S[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=f++;S[p]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var m=f++;S[m]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var h=f++;S[h]="(?:"+S[P]+"|"+S[u]+")";var t=f++;S[t]="(?:"+S[k]+"|"+S[u]+")";var i=f++;S[i]="(?:-("+S[h]+"(?:\\."+S[h]+")*))";var c=f++;S[c]="(?:-?("+S[t]+"(?:\\."+S[t]+")*))";var g=f++;S[g]="[0-9A-Za-z-]+";var D=f++;S[D]="(?:\\+("+S[g]+"(?:\\."+S[g]+")*))";var b=f++,n="v?"+S[p]+S[i]+"?"+S[D]+"?";S[b]="^"+n+"$";var a="[v=\\s]*"+S[m]+S[c]+"?"+S[D]+"?",s=f++;S[s]="^"+a+"$";var o=f++;S[o]="((?:<|>)?=?)";var y=f++;S[y]=S[k]+"|x|X|\\*";var $=f++;S[$]=S[P]+"|x|X|\\*";var I=f++;S[I]="[v=\\s]*("+S[$]+")(?:\\.("+S[$]+")(?:\\.("+S[$]+")(?:"+S[i]+")?"+S[D]+"?)?)?";var E=f++;S[E]="[v=\\s]*("+S[y]+")(?:\\.("+S[y]+")(?:\\.("+S[y]+")(?:"+S[c]+")?"+S[D]+"?)?)?";var r=f++;S[r]="^"+S[o]+"\\s*"+S[I]+"$";var d=f++;S[d]="^"+S[o]+"\\s*"+S[E]+"$";var v=f++;S[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=f++;S[R]="(?:~>?)";var B=f++;S[B]="(\\s*)"+S[R]+"\\s+",l[B]=new RegExp(S[B],"g");var V=f++;S[V]="^"+S[R]+S[I]+"$";var j=f++;S[j]="^"+S[R]+S[E]+"$";var W=f++;S[W]="(?:\\^)";var N=f++;S[N]="(\\s*)"+S[W]+"\\s+",l[N]=new RegExp(S[N],"g");var z=f++;S[z]="^"+S[W]+S[I]+"$";var ee=f++;S[ee]="^"+S[W]+S[E]+"$";var X=f++;S[X]="^"+S[o]+"\\s*("+a+")$|^$";var Ee=f++;S[Ee]="^"+S[o]+"\\s*("+n+")$|^$";var De=f++;S[De]="(\\s*)"+S[o]+"\\s*("+a+"|"+S[I]+")",l[De]=new RegExp(S[De],"g");var Pe=f++;S[Pe]="^\\s*("+S[I]+")\\s+-\\s+("+S[I]+")\\s*$";var Z=f++;S[Z]="^\\s*("+S[E]+")\\s+-\\s+("+S[E]+")\\s*$";var ue=f++;S[ue]="(<|>)?=?\\s*\\*";for(var ye=0;ye<35;ye++)C(ye,S[ye]),l[ye]||(l[ye]=new RegExp(S[ye]));function ce(J,x){if(J instanceof $e)return J;if(typeof J!="string"||J.length>L||!(x?l[s]:l[b]).test(J))return null;try{return new $e(J,x)}catch{return null}}function $e(J,x){if(J instanceof $e){if(J.loose===x)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof $e))return new $e(J,x);C("SemVer",J,x),this.loose=x;var ae=J.trim().match(x?l[s]:l[b]);if(!ae)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var Ue=+Le;if(Ue>=0&&Ue<A)return Ue}return Le}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(J,x){var ae=ce(J,x);return ae?ae.version:null},e.clean=function(J,x){var ae=ce(J.trim().replace(/^[=v]+/,""),x);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(J){return C("SemVer.compare",this.version,this.loose,J),J instanceof $e||(J=new $e(J,this.loose)),this.compareMain(J)||this.comparePre(J)},$e.prototype.compareMain=function(J){return J instanceof $e||(J=new $e(J,this.loose)),O(this.major,J.major)||O(this.minor,J.minor)||O(this.patch,J.patch)},$e.prototype.comparePre=function(J){if(J instanceof $e||(J=new $e(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var x=0;do{var ae=this.prerelease[x],Le=J.prerelease[x];if(C("prerelease compare",x,ae,Le),ae===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ae===void 0)return-1;if(ae!==Le)return O(ae,Le)}while(++x)},$e.prototype.inc=function(J,x){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,x,ae,Le){typeof ae=="string"&&(Le=ae,ae=void 0);try{return new $e(J,ae).inc(x,Le).version}catch{return null}},e.diff=function(J,x){if(ve(J,x))return null;var ae=ce(J),Le=ce(x);if(ae.prerelease.length||Le.prerelease.length){for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Le[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Le[Ue])return Ue},e.compareIdentifiers=O;var ie=/^[0-9]+$/;function O(J,x){var ae=ie.test(J),Le=ie.test(x);return ae&&Le&&(J=+J,x=+x),ae&&!Le?-1:Le&&!ae?1:J<x?-1:J>x?1:0}function q(J,x,ae){return new $e(J,ae).compare(new $e(x,ae))}function le(J,x,ae){return q(J,x,ae)>0}function we(J,x,ae){return q(J,x,ae)<0}function ve(J,x,ae){return q(J,x,ae)===0}function me(J,x,ae){return q(J,x,ae)!==0}function ke(J,x,ae){return q(J,x,ae)>=0}function se(J,x,ae){return q(J,x,ae)<=0}function he(J,x,ae,Le){var Ue;switch(x){case"===":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),Ue=J===ae;break;case"!==":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),Ue=J!==ae;break;case"":case"=":case"==":Ue=ve(J,ae,Le);break;case"!=":Ue=me(J,ae,Le);break;case">":Ue=le(J,ae,Le);break;case">=":Ue=ke(J,ae,Le);break;case"<":Ue=we(J,ae,Le);break;case"<=":Ue=se(J,ae,Le);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function re(J,x){if(J instanceof re){if(J.loose===x)return J;J=J.value}if(!(this instanceof re))return new re(J,x);C("comparator",J,x),this.loose=x,this.parse(J),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(J,x){return O(x,J)},e.major=function(J,x){return new $e(J,x).major},e.minor=function(J,x){return new $e(J,x).minor},e.patch=function(J,x){return new $e(J,x).patch},e.compare=q,e.compareLoose=function(J,x){return q(J,x,!0)},e.rcompare=function(J,x,ae){return q(x,J,ae)},e.sort=function(J,x){return J.sort(function(ae,Le){return e.compare(ae,Le,x)})},e.rsort=function(J,x){return J.sort(function(ae,Le){return e.rcompare(ae,Le,x)})},e.gt=le,e.lt=we,e.eq=ve,e.neq=me,e.gte=ke,e.lte=se,e.cmp=he,e.Comparator=re;var oe={};function fe(J,x){if(J instanceof fe)return J.loose===x?J:new fe(J.raw,x);if(J instanceof re)return new fe(J.value,x);if(!(this instanceof fe))return new fe(J,x);if(this.loose=x,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function F(J,x,ae,Le,Ue,Qe,He,et,Ze,_e,it,tt,Oe){return((x=Ie(ae)?"":Ie(Le)?">="+ae+".0.0":Ie(Ue)?">="+ae+"."+Le+".0":">="+x)+" "+(et=Ie(Ze)?"":Ie(_e)?"<"+(+Ze+1)+".0.0":Ie(it)?"<"+Ze+"."+(+_e+1)+".0":tt?"<="+Ze+"."+_e+"."+it+"-"+tt:"<="+et)).trim()}function K(J,x){for(var ae=0;ae<J.length;ae++)if(!J[ae].test(x))return!1;if(x.prerelease.length){for(ae=0;ae<J.length;ae++)if(C(J[ae].semver),J[ae].semver!==oe&&J[ae].semver.prerelease.length>0){var Le=J[ae].semver;if(Le.major===x.major&&Le.minor===x.minor&&Le.patch===x.patch)return!0}return!1}return!0}function G(J,x,ae){try{x=new fe(x,ae)}catch{return!1}return x.test(J)}function Q(J,x,ae,Le){var Ue,Qe,He,et,Ze;switch(J=new $e(J,Le),x=new fe(x,Le),ae){case">":Ue=le,Qe=se,He=we,et=">",Ze=">=";break;case"<":Ue=we,Qe=ke,He=le,et="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(J,x,Le))return!1;for(var _e=0;_e<x.set.length;++_e){var it=x.set[_e],tt=null,Oe=null;if(it.forEach(function(st){st.semver===oe&&(st=new re(">=0.0.0")),tt=tt||st,Oe=Oe||st,Ue(st.semver,tt.semver,Le)?tt=st:He(st.semver,Oe.semver,Le)&&(Oe=st)}),tt.operator===et||tt.operator===Ze||(!Oe.operator||Oe.operator===et)&&Qe(J,Oe.semver)||Oe.operator===Ze&&He(J,Oe.semver))return!1}return!0}re.prototype.parse=function(J){var x=this.loose?l[X]:l[Ee],ae=J.match(x);if(!ae)throw new TypeError("Invalid comparator: "+J);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},re.prototype.toString=function(){return this.value},re.prototype.test=function(J){return C("Comparator.test",J,this.loose),this.semver===oe||(typeof J=="string"&&(J=new $e(J,this.loose)),he(J,this.operator,this.semver,this.loose))},re.prototype.intersects=function(J,x){if(!(J instanceof re))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new fe(J.value,x),G(this.value,ae,x);if(J.operator==="")return ae=new fe(this.value,x),G(J.semver,ae,x);var Le=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Qe=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),et=he(this.semver,"<",J.semver,x)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ze=he(this.semver,">",J.semver,x)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Le||Ue||Qe&&He||et||Ze},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(J){var x=this.loose;J=J.trim(),C("range",J,x);var ae=x?l[Z]:l[Pe];J=J.replace(ae,F),C("hyphen replace",J),J=J.replace(l[De],"$1$2$3"),C("comparator trim",J,l[De]),J=(J=(J=J.replace(l[B],"$1~")).replace(l[N],"$1^")).split(/\s+/).join(" ");var Le=x?l[X]:l[Ee],Ue=J.split(" ").map(function(Qe){return function(He,et){return C("comp",He),He=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(it){return function(tt,Oe){C("caret",tt,Oe);var st=Oe?l[ee]:l[z];return tt.replace(st,function(_,Y,pe,je,ze){var Ye;return C("caret",tt,_,Y,pe,je,ze),Ie(Y)?Ye="":Ie(pe)?Ye=">="+Y+".0.0 <"+(+Y+1)+".0.0":Ie(je)?Ye=Y==="0"?">="+Y+"."+pe+".0 <"+Y+"."+(+pe+1)+".0":">="+Y+"."+pe+".0 <"+(+Y+1)+".0.0":ze?(C("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ye=Y==="0"?pe==="0"?">="+Y+"."+pe+"."+je+ze+" <"+Y+"."+pe+"."+(+je+1):">="+Y+"."+pe+"."+je+ze+" <"+Y+"."+(+pe+1)+".0":">="+Y+"."+pe+"."+je+ze+" <"+(+Y+1)+".0.0"):(C("no pr"),Ye=Y==="0"?pe==="0"?">="+Y+"."+pe+"."+je+" <"+Y+"."+pe+"."+(+je+1):">="+Y+"."+pe+"."+je+" <"+Y+"."+(+pe+1)+".0":">="+Y+"."+pe+"."+je+" <"+(+Y+1)+".0.0"),C("caret return",Ye),Ye})}(it,_e)}).join(" ")}(He,et),C("caret",He),He=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(it){return function(tt,Oe){var st=Oe?l[j]:l[V];return tt.replace(st,function(_,Y,pe,je,ze){var Ye;return C("tilde",tt,_,Y,pe,je,ze),Ie(Y)?Ye="":Ie(pe)?Ye=">="+Y+".0.0 <"+(+Y+1)+".0.0":Ie(je)?Ye=">="+Y+"."+pe+".0 <"+Y+"."+(+pe+1)+".0":ze?(C("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ye=">="+Y+"."+pe+"."+je+ze+" <"+Y+"."+(+pe+1)+".0"):Ye=">="+Y+"."+pe+"."+je+" <"+Y+"."+(+pe+1)+".0",C("tilde return",Ye),Ye})}(it,_e)}).join(" ")}(He,et),C("tildes",He),He=function(Ze,_e){return C("replaceXRanges",Ze,_e),Ze.split(/\s+/).map(function(it){return function(tt,Oe){tt=tt.trim();var st=Oe?l[d]:l[r];return tt.replace(st,function(_,Y,pe,je,ze,Ye){C("xRange",tt,_,Y,pe,je,ze,Ye);var nt=Ie(pe),gt=nt||Ie(je),vt=gt||Ie(ze);return Y==="="&&vt&&(Y=""),nt?_=Y===">"||Y==="<"?"<0.0.0":"*":Y&&vt?(gt&&(je=0),vt&&(ze=0),Y===">"?(Y=">=",gt?(pe=+pe+1,je=0,ze=0):vt&&(je=+je+1,ze=0)):Y==="<="&&(Y="<",gt?pe=+pe+1:je=+je+1),_=Y+pe+"."+je+"."+ze):gt?_=">="+pe+".0.0 <"+(+pe+1)+".0.0":vt&&(_=">="+pe+"."+je+".0 <"+pe+"."+(+je+1)+".0"),C("xRange return",_),_})}(it,_e)}).join(" ")}(He,et),C("xrange",He),He=function(Ze,_e){return C("replaceStars",Ze,_e),Ze.trim().replace(l[ue],"")}(He,et),C("stars",He),He}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Le)})),Ue=Ue.map(function(Qe){return new re(Qe,x)})},fe.prototype.intersects=function(J,x){if(!(J instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Le){return J.set.some(function(Ue){return Ue.every(function(Qe){return Le.intersects(Qe,x)})})})})},e.toComparators=function(J,x){return new fe(J,x).set.map(function(ae){return ae.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new $e(J,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],J))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(J,x,ae){var Le=null,Ue=null;try{var Qe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Le&&Ue.compare(He)!==-1||(Ue=new $e(Le=He,ae)))}),Le},e.minSatisfying=function(J,x,ae){var Le=null,Ue=null;try{var Qe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Le&&Ue.compare(He)!==1||(Ue=new $e(Le=He,ae)))}),Le},e.validRange=function(J,x){try{return new fe(J,x).range||"*"}catch{return null}},e.ltr=function(J,x,ae){return Q(J,x,"<",ae)},e.gtr=function(J,x,ae){return Q(J,x,">",ae)},e.outside=Q,e.prerelease=function(J,x){var ae=ce(J,x);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(J,x,ae){return J=new fe(J,ae),x=new fe(x,ae),J.intersects(x)},e.coerce=function(J){if(J instanceof $e)return J;if(typeof J!="string")return null;var x=J.match(l[v]);return x==null?null:ce((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,w(1))},function(be,e){var w,T,C=be.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(w===setTimeout)return setTimeout(t,0);if((w===L||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:L}catch{w=L}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var S,f=[],P=!1,k=-1;function u(){P&&S&&(P=!1,S.length?f=S.concat(f):k=-1,f.length&&p())}function p(){if(!P){var t=l(u);P=!0;for(var i=f.length;i;){for(S=f,f=[];++k<i;)S&&S[k].run();k=-1,i=f.length}S=null,P=!1,function(c){if(T===clearTimeout)return clearTimeout(c);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(c);try{T(c)}catch{try{return T.call(null,c)}catch{return T.call(this,c)}}}(t)}}function m(t,i){this.fun=t,this.array=i}function h(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];f.push(new m(t,i)),f.length!==1||P||l(p)},m.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=h,C.addListener=h,C.once=h,C.off=h,C.removeListener=h,C.removeAllListeners=h,C.emit=h,C.prependListener=h,C.prependOnceListener=h,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[119],Re([1,0,9,6]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function C(D){const b=D;return b?typeof b.read=="function":!1}e.$pd=C;function L(D){const b=D;return b?[b.on,b.pause,b.resume,b.destroy].every(n=>typeof n=="function"):!1}e.$qd=L;function A(D){const b=D;return b?L(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.$rd=A;function l(D,b){return new S(D,b)}e.$sd=l;class S{constructor(b,n){this.e=b,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(n=>n(b))}h(b){this.c.error.length===0?(0,w.$Y)(b):this.c.error.slice(0).forEach(n=>n(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,n){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(b,n){if(this.a.destroyed)return;let a;switch(b){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const s=a.indexOf(n);s>=0&&a.splice(s,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(D,b){const n=[];let a;for(;(a=D.read())!==null;)n.push(a);return b(n)}e.$td=f;function P(D,b,n){const a=[];let s;for(;(s=D.read())!==null&&a.length<n;)a.push(s);return s===null&&a.length>0?b(a):{read:()=>{if(a.length>0)return a.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return D.read()}}}e.$ud=P;function k(D,b){return new Promise((n,a)=>{const s=[];u(D,{onData:o=>{b&&s.push(o)},onError:o=>{b?a(o):n(void 0)},onEnd:()=>{n(b?b(s):void 0)}})})}e.$vd=k;function u(D,b,n){D.on("error",a=>{n?.isCancellationRequested||b.onError(a)}),D.on("end",()=>{n?.isCancellationRequested||b.onEnd()}),D.on("data",a=>{n?.isCancellationRequested||b.onData(a)})}e.$wd=u;function p(D,b){return new Promise((n,a)=>{const s=new T.$ic,o=[],y=E=>{if(o.push(E),o.length>b)return s.dispose(),D.pause(),n({stream:D,buffer:o,ended:!1})},$=E=>(s.dispose(),a(E)),I=()=>(s.dispose(),n({stream:D,buffer:o,ended:!0}));s.add((0,T.$hc)(()=>D.removeListener("error",$))),D.on("error",$),s.add((0,T.$hc)(()=>D.removeListener("end",I))),D.on("end",I),s.add((0,T.$hc)(()=>D.removeListener("data",y))),D.on("data",y)})}e.$xd=p;function m(D,b){const n=l(b);return n.end(D),n}e.$yd=m;function h(){const D=l(()=>{throw new Error("not supported")});return D.end(),D}e.$zd=h;function t(D){let b=!1;return{read:()=>b?null:(b=!0,D)}}e.$Ad=t;function i(D,b,n){const a=l(n);return u(D,{onData:s=>a.write(b.data(s)),onError:s=>a.error(b.error?b.error(s):s),onEnd:()=>a.end()}),a}e.$Bd=i;function c(D,b,n){let a=!1;return{read:()=>{const s=b.read();return a?s:(a=!0,s!==null?n([D,s]):D)}}}e.$Cd=c;function g(D,b,n){let a=!1;const s=l(n);return u(b,{onData:o=>a?s.write(o):(a=!0,s.write(n([D,o]))),onError:o=>s.error(o),onEnd:()=>{a||(a=!0,s.write(D)),s.end()}}),s}e.$Dd=g}),define(Ae[25],Re([1,0,65,119]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const C=typeof Buffer<"u",L=new w.$T(()=>new Uint8Array(256));let A,l;class S{static alloc(v){return C?new S(Buffer.allocUnsafe(v)):new S(new Uint8Array(v))}static wrap(v){return C&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new S(v)}static fromString(v,R){return!(R?.dontUseNodeBuffer||!1)&&C?new S(Buffer.from(v)):(A||(A=new TextEncoder),new S(A.encode(v)))}static fromByteArray(v){const R=S.alloc(v.length);for(let B=0,V=v.length;B<V;B++)R.buffer[B]=v[B];return R}static concat(v,R){if(typeof R>"u"){R=0;for(let j=0,W=v.length;j<W;j++)R+=v[j].byteLength}const B=S.alloc(R);let V=0;for(let j=0,W=v.length;j<W;j++){const N=v[j];B.set(N,V),V+=N.byteLength}return B}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=S.alloc(this.byteLength);return v.set(this),v}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(v,R){return new S(this.buffer.subarray(v,R))}set(v,R){if(v instanceof S)this.buffer.set(v.buffer,R);else if(v instanceof Uint8Array)this.buffer.set(v,R);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),R);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return u(this.buffer,v)}writeUInt32BE(v,R){p(this.buffer,v,R)}readUInt32LE(v){return m(this.buffer,v)}writeUInt32LE(v,R){h(this.buffer,v,R)}readUInt8(v){return t(this.buffer,v)}writeUInt8(v,R){i(this.buffer,v,R)}indexOf(v,R=0){return f(this.buffer,v instanceof S?v.buffer:v,R)}}e.$Ed=S;function f(d,v,R=0){const B=v.byteLength,V=d.byteLength;if(B===0)return 0;if(B===1)return d.indexOf(v[0]);if(B>V-R)return-1;const j=L.value;j.fill(v.length);for(let ee=0;ee<v.length;ee++)j[v[ee]]=v.length-ee-1;let W=R+v.length-1,N=W,z=-1;for(;W<V;)if(d[W]===v[N]){if(N===0){z=W;break}W--,N--}else W+=Math.max(v.length-N,j[d[W]]),N=v.length-1;return z}e.$Fd=f;function P(d,v){return d[v+0]<<0>>>0|d[v+1]<<8>>>0}e.$Gd=P;function k(d,v,R){d[R+0]=v&255,v=v>>>8,d[R+1]=v&255}e.$Hd=k;function u(d,v){return d[v]*2**24+d[v+1]*2**16+d[v+2]*2**8+d[v+3]}e.$Id=u;function p(d,v,R){d[R+3]=v,v=v>>>8,d[R+2]=v,v=v>>>8,d[R+1]=v,v=v>>>8,d[R]=v}e.$Jd=p;function m(d,v){return d[v+0]<<0>>>0|d[v+1]<<8>>>0|d[v+2]<<16>>>0|d[v+3]<<24>>>0}e.$Kd=m;function h(d,v,R){d[R+0]=v&255,v=v>>>8,d[R+1]=v&255,v=v>>>8,d[R+2]=v&255,v=v>>>8,d[R+3]=v&255}e.$Ld=h;function t(d,v){return d[v]}e.$Md=t;function i(d,v,R){d[R]=v}e.$Nd=i;function c(d){return T.$td(d,v=>S.concat(v))}e.$Od=c;function g(d){return T.$Ad(d)}e.$Pd=g;function D(d){return T.$vd(d,v=>S.concat(v))}e.$Qd=D;async function b(d){return d.ended?S.concat(d.buffer):S.concat([...d.buffer,await D(d.stream)])}e.$Rd=b;function n(d){return T.$yd(d,v=>S.concat(v))}e.$Sd=n;function a(d){return T.$Bd(d,{data:v=>typeof v=="string"?S.fromString(v):S.wrap(v)},v=>S.concat(v))}e.$Td=a;function s(d){return T.$sd(v=>S.concat(v),d)}e.$Ud=s;function o(d,v){return T.$Cd(d,v,R=>S.concat(R))}e.$Vd=o;function y(d,v){return T.$Dd(d,v,R=>S.concat(R))}e.$Wd=y;function $(d){let v=0,R=0,B=0;const V=new Uint8Array(Math.floor(d.length/4*3)),j=N=>{switch(R){case 3:V[B++]=v|N,R=0;break;case 2:V[B++]=v|N>>>2,v=N<<6,R=3;break;case 1:V[B++]=v|N>>>4,v=N<<4,R=2;break;default:v=N<<2,R=1}};for(let N=0;N<d.length;N++){const z=d.charCodeAt(N);if(z>=65&&z<=90)j(z-65);else if(z>=97&&z<=122)j(z-97+26);else if(z>=48&&z<=57)j(z-48+52);else if(z===43||z===45)j(62);else if(z===47||z===95)j(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${d[N]}`)}}const W=B;for(;R>0;)j(0);return S.wrap(V).slice(0,W)}e.$Xd=$;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:d},v=!0,R=!1){const B=R?E:I;let V="";const j=d.byteLength%3;let W=0;for(;W<d.byteLength-j;W+=3){const N=d[W+0],z=d[W+1],ee=d[W+2];V+=B[N>>>2],V+=B[(N<<4|z>>>4)&63],V+=B[(z<<2|ee>>>6)&63],V+=B[ee&63]}if(j===1){const N=d[W+0];V+=B[N>>>2],V+=B[N<<4&63],v&&(V+="==")}else if(j===2){const N=d[W+0],z=d[W+1];V+=B[N>>>2],V+=B[(N<<4|z>>>4)&63],V+=B[z<<2&63],v&&(V+="=")}return V}e.$Yd=r}),define(Ae[120],Re([1,0,28,15]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.FuzzyScore=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.or=void 0;function C(...re){return function(oe,fe){for(let Ie=0,F=re.length;Ie<F;Ie++){const K=re[Ie](oe,fe);if(K)return K}return null}}e.or=C,e.$wj=L.bind(void 0,!1),e.$xj=L.bind(void 0,!0);function L(re,oe,fe){if(!fe||fe.length<oe.length)return null;let Ie;return re?Ie=T.$Me(fe,oe):Ie=fe.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(re,oe){const fe=oe.toLowerCase().indexOf(re.toLowerCase());return fe===-1?null:[{start:fe,end:fe+re.length}]}e.$yj=A;function l(re,oe){return S(re.toLowerCase(),oe.toLowerCase(),0,0)}e.$zj=l;function S(re,oe,fe,Ie){if(fe===re.length)return[];if(Ie===oe.length)return null;if(re[fe]===oe[Ie]){let F=null;return(F=S(re,oe,fe+1,Ie+1))?i({start:Ie,end:Ie+1},F):null}return S(re,oe,fe,Ie+1)}function f(re){return 97<=re&&re<=122}function P(re){return 65<=re&&re<=90}e.$Aj=P;function k(re){return 48<=re&&re<=57}function u(re){return re===32||re===9||re===10||re===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>p.add(re.charCodeAt(0)));function m(re){return u(re)||p.has(re)}function h(re,oe){return re===oe||m(re)&&m(oe)}function t(re){return f(re)||P(re)||k(re)}function i(re,oe){return oe.length===0?oe=[re]:re.end===oe[0].start?oe[0].start=re.start:oe.unshift(re),oe}function c(re,oe){for(let fe=oe;fe<re.length;fe++){const Ie=re.charCodeAt(fe);if(P(Ie)||k(Ie)||fe>0&&!t(re.charCodeAt(fe-1)))return fe}return re.length}function g(re,oe,fe,Ie){if(fe===re.length)return[];if(Ie===oe.length)return null;if(re[fe]!==oe[Ie].toLowerCase())return null;{let F=null,K=Ie+1;for(F=g(re,oe,fe+1,Ie+1);!F&&(K=c(oe,K))<oe.length;)F=g(re,oe,fe+1,K),K++;return F===null?null:i({start:Ie,end:Ie+1},F)}}function D(re){let oe=0,fe=0,Ie=0,F=0,K=0;for(let ae=0;ae<re.length;ae++)K=re.charCodeAt(ae),P(K)&&oe++,f(K)&&fe++,t(K)&&Ie++,k(K)&&F++;const G=oe/re.length,Q=fe/re.length,J=Ie/re.length,x=F/re.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:J,numericPercent:x}}function b(re){const{upperPercent:oe,lowerPercent:fe}=re;return fe===0&&oe>.6}function n(re){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ie,numericPercent:F}=re;return fe>.2&&oe<.8&&Ie>.6&&F<.2}function a(re){let oe=0,fe=0,Ie=0,F=0;for(let K=0;K<re.length;K++)Ie=re.charCodeAt(K),P(Ie)&&oe++,f(Ie)&&fe++,u(Ie)&&F++;return(oe===0||fe===0)&&F===0?re.length<=30:oe<=5}function s(re,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!a(re)||oe.length>60)return null;const fe=D(oe);if(!n(fe)){if(!b(fe))return null;oe=oe.toLowerCase()}let Ie=null,F=0;for(re=re.toLowerCase();F<oe.length&&(Ie=g(re,oe,0,F))===null;)F=c(oe,F+1);return Ie}e.$Bj=s;function o(re,oe,fe=!1){if(!oe||oe.length===0)return null;let Ie=null,F=0;for(re=re.toLowerCase(),oe=oe.toLowerCase();F<oe.length&&(Ie=y(re,oe,0,F,fe))===null;)F=$(oe,F+1);return Ie}e.$Cj=o;function y(re,oe,fe,Ie,F){if(fe===re.length)return[];if(Ie===oe.length)return null;if(h(re.charCodeAt(fe),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=y(re,oe,fe+1,Ie+1,F),!F)for(;!K&&(G=$(oe,G))<oe.length;)K=y(re,oe,fe+1,G,F),G++;return K?re.charCodeAt(fe)!==oe.charCodeAt(Ie)?K:i({start:Ie,end:Ie+1},K):null}else return null}function $(re,oe){for(let fe=oe;fe<re.length;fe++)if(m(re.charCodeAt(fe))||fe>0&&m(re.charCodeAt(fe-1)))return fe;return re.length}const I=C(e.$xj,s,A),E=C(e.$xj,s,l),r=new w.$Bi(1e4);function d(re,oe,fe=!1){if(typeof re!="string"||typeof oe!="string")return null;let Ie=r.get(re);Ie||(Ie=new RegExp(T.$ve(re),"i"),r.set(re,Ie));const F=Ie.exec(oe);return F?[{start:F.index,end:F.index+F[0].length}]:fe?E(re,oe):I(re,oe)}e.$Dj=d;function v(re,oe){const fe=le(re,re.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?B(fe):null}e.$Ej=v;function R(re,oe,fe,Ie,F,K){const G=Math.min(13,re.length);for(;fe<G;fe++){const Q=le(re,oe,fe,Ie,F,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,K]}e.$Fj=R;function B(re){if(typeof re>"u")return[];const oe=[],fe=re[1];for(let Ie=re.length-1;Ie>1;Ie--){const F=re[Ie]+fe,K=oe[oe.length-1];K&&K.end===F?K.end=F+1:oe.push({start:F,end:F+1})}return oe}e.$Gj=B;const V=128;function j(){const re=[],oe=[];for(let fe=0;fe<=V;fe++)oe[fe]=0;for(let fe=0;fe<=V;fe++)re.push(oe.slice(0));return re}function W(re){const oe=[];for(let fe=0;fe<=re;fe++)oe[fe]=0;return oe}const N=W(2*V),z=W(2*V),ee=j(),X=j(),Ee=j(),De=!1;function Pe(re,oe,fe,Ie,F){function K(Q,J,x=" "){for(;Q.length<J;)Q=x+Q;return Q}let G=` |   |${Ie.split("").map(Q=>K(Q,3)).join("|")}
`;for(let Q=0;Q<=fe;Q++)Q===0?G+=" |":G+=`${oe[Q-1]}|`,G+=re[Q].slice(0,F+1).map(J=>K(J.toString(),3)).join("|")+`
`;return G}function Z(re,oe,fe,Ie){re=re.substr(oe),fe=fe.substr(Ie),console.log(Pe(X,re,re.length,fe,fe.length)),console.log(Pe(Ee,re,re.length,fe,fe.length)),console.log(Pe(ee,re,re.length,fe,fe.length))}function ue(re,oe){if(oe<0||oe>=re.length)return!1;const fe=re.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$5e(fe)}}function ye(re,oe){if(oe<0||oe>=re.length)return!1;switch(re.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(re,oe,fe){return oe[re]!==fe[re]}function $e(re,oe,fe,Ie,F,K,G=!1){for(;oe<fe&&F<K;)re[oe]===Ie[F]&&(G&&(N[oe]=F),oe+=1),F+=1;return oe===fe}e.$Hj=$e;var ie;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var O;(function(re){re.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}re.isDefault=oe})(O||(e.FuzzyScore=O={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.$Ij=q;function le(re,oe,fe,Ie,F,K,G=q.default){const Q=re.length>V?V:re.length,J=Ie.length>V?V:Ie.length;if(fe>=Q||K>=J||Q-fe>J-K||!$e(oe,fe,Q,F,K,J,!0))return;we(Q,J,fe,K,oe,F);let x=1,ae=1,Le=fe,Ue=K;const Qe=[!1];for(x=1,Le=fe;Le<Q;x++,Le++){const it=N[Le],tt=z[Le],Oe=Le+1<Q?z[Le+1]:J;for(ae=it-K+1,Ue=it;Ue<Oe;ae++,Ue++){let st=Number.MIN_SAFE_INTEGER,_=!1;Ue<=tt&&(st=ve(re,oe,Le,fe,Ie,F,Ue,J,K,ee[x-1][ae-1]===0,Qe));let Y=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,Y=st+X[x-1][ae-1]);const pe=Ue>it,je=pe?X[x][ae-1]+(ee[x][ae-1]>0?-5:0):0,ze=Ue>it+1&&ee[x][ae-1]>0,Ye=ze?X[x][ae-2]+(ee[x][ae-2]>0?-5:0):0;if(ze&&(!pe||Ye>=je)&&(!_||Ye>=Y))X[x][ae]=Ye,Ee[x][ae]=3,ee[x][ae]=0;else if(pe&&(!_||je>=Y))X[x][ae]=je,Ee[x][ae]=2,ee[x][ae]=0;else if(_)X[x][ae]=Y,Ee[x][ae]=1,ee[x][ae]=ee[x-1][ae-1]+1;else throw new Error("not possible")}}if(De&&Z(re,fe,Ie,K),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ae--;const He=[X[x][ae],K];let et=0,Ze=0;for(;x>=1;){let it=ae;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&oe[fe+x-1]===F[K+ae-1]&&!ce(it+K-1,Ie,F)&&et+1>ee[x][it]&&(it=ae),it===ae?et++:et=1,Ze||(Ze=it),x--,ae=it-1,He.push(ae)}J===Q&&G.boostFullMatch&&(He[0]+=2);const _e=Ze-Q;return He[0]-=_e,He}e.$Jj=le;function we(re,oe,fe,Ie,F,K){let G=re-1,Q=oe-1;for(;G>=fe&&Q>=Ie;)F[G]===K[Q]&&(z[G]=Q,G--),Q--}function ve(re,oe,fe,Ie,F,K,G,Q,J,x,ae){if(oe[fe]!==K[G])return Number.MIN_SAFE_INTEGER;let Le=1,Ue=!1;return G===fe-Ie?Le=re[fe]===F[G]?7:5:ce(G,F,K)&&(G===0||!ce(G-1,F,K))?(Le=re[fe]===F[G]?7:5,Ue=!0):ue(K,G)&&(G===0||!ue(K,G-1))?Le=5:(ue(K,G-1)||ye(K,G-1))&&(Le=5,Ue=!0),Le>1&&fe===Ie&&(ae[0]=!0),Ue||(Ue=ce(G,F,K)||ue(K,G-1)||ye(K,G-1)),fe===Ie?G>J&&(Le-=Ue?3:5):x?Le+=Ue?2:0:Le+=Ue?0:1,G+1===Q&&(Le-=Ue?3:5),Le}function me(re,oe,fe,Ie,F,K,G){return se(re,oe,fe,Ie,F,K,!0,G)}e.$Kj=me;function ke(re,oe,fe,Ie,F,K,G){return se(re,oe,fe,Ie,F,K,!1,G)}e.$Lj=ke;function se(re,oe,fe,Ie,F,K,G,Q){let J=le(re,oe,fe,Ie,F,K,Q);if(J&&!G)return J;if(re.length>=3){const x=Math.min(7,re.length-1);for(let ae=fe+1;ae<x;ae++){const Le=he(re,ae);if(Le){const Ue=le(Le,Le.toLowerCase(),fe,Ie,F,K,Q);Ue&&(Ue[0]-=3,(!J||Ue[0]>J[0])&&(J=Ue))}}}return J}function he(re,oe){if(oe+1>=re.length)return;const fe=re[oe],Ie=re[oe+1];if(fe!==Ie)return re.slice(0,oe)+Ie+fe+re.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const L="error",A="warning",l="warn",S="info",f="ignore";function P(u){return u?w.$Le(L,u)?C.Error:w.$Le(A,u)||w.$Le(l,u)?C.Warning:w.$Le(S,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function k(u){switch(u){case C.Error:return L;case C.Warning:return A;case C.Info:return S;default:return f}}C.toString=k}(T||(T={})),e.default=T}),define(Ae[121],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const m=p.charCodeAt(0),h=this.b.charCodeAt(this.c);return m-h}value(){return this.b[this.c]}}e.$Ch=C;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$Fe)(p,this.b,0,p.length,this.c,this.d):(0,T.$He)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Dh=L;class A{constructor(p=!0,m=!0){this.f=p,this.g=m}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let m=p.length-1;m>=0;m--,this.c--){const h=this.b.charCodeAt(m);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$Fe)(p,this.b,0,p.length,this.d,this.e):(0,T.$He)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Eh=A;var l;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(l||(l={}));class S{constructor(p,m){this.f=p,this.g=m,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$Ge)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Ge)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$Ee)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$Ee)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fh=S;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class k{static forUris(p=()=>!1,m=()=>!1){return new k(new S(p,m))}static forPaths(p=!1){return new k(new A(void 0,!p))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,m){if(m){const h=m.slice(0);(0,w.$Ub)(h);for(const t of h)this.set(t,p)}else{const h=p.slice(0);(0,w.$Ub)(h);for(const t of h)this.set(t[0],t[1])}}set(p,m){const h=this.b.reset(p);let t;this.c||(this.c=new f,this.c.segment=h.value());const i=[];for(t=this.c;;){const g=h.cmp(t.segment);if(g>0)t.left||(t.left=new f,t.left.segment=h.value()),i.push([-1,t]),t=t.left;else if(g<0)t.right||(t.right=new f,t.right.segment=h.value()),i.push([1,t]),t=t.right;else if(h.hasNext())h.next(),t.mid||(t.mid=new f,t.mid.segment=h.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=m,t.key=p;for(let g=i.length-1;g>=0;g--){const D=i[g][1];D.updateHeight();const b=D.balanceFactor();if(b<-1||b>1){const n=i[g][0],a=i[g+1][0];if(n===1&&a===1)i[g][1]=D.rotateLeft();else if(n===-1&&a===-1)i[g][1]=D.rotateRight();else if(n===1&&a===-1)D.right=i[g+1][1]=i[g+1][1].rotateRight(),i[g][1]=D.rotateLeft();else if(n===-1&&a===1)D.left=i[g+1][1]=i[g+1][1].rotateLeft(),i[g][1]=D.rotateRight();else throw new Error;if(g>0)switch(i[g-1][0]){case-1:i[g-1][1].left=i[g][1];break;case 1:i[g-1][1].right=i[g][1];break;case 0:i[g-1][1].mid=i[g][1];break}else this.c=i[0][1]}}return c}get(p){return this.d(p)?.value}d(p){const m=this.b.reset(p);let h=this.c;for(;h;){const t=m.cmp(h.segment);if(t>0)h=h.left;else if(t<0)h=h.right;else if(m.hasNext())m.next(),h=h.mid;else break}return h}has(p){const m=this.d(p);return!(m?.value===void 0&&m?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,m){const h=this.b.reset(p),t=[];let i=this.c;for(;i;){const c=h.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(h.hasNext())h.next(),t.push([0,i]),i=i.mid;else break}if(i){if(m?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:g,value:D,segment:b}=c;this.e(c.key,!1),i.key=g,i.value=D,i.segment=b}}else{const c=i.left??i.right;if(t.length>0){const[g,D]=t[t.length-1];switch(g){case-1:D.left=c;break;case 0:D.mid=c;break;case 1:D.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const g=t[c][1];g.updateHeight();const D=g.balanceFactor();if(D>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),t[c][1]=g.rotateLeft()):D<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),t[c][1]=g.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const m=this.b.reset(p);let h=this.c,t;for(;h;){const i=m.cmp(h.segment);if(i>0)h=h.left;else if(i<0)h=h.right;else if(m.hasNext())m.next(),t=h.value||t,h=h.mid;else break}return h&&h.value||t}findSuperstr(p){return this.g(p,!1)}g(p,m){const h=this.b.reset(p);let t=this.c;for(;t;){const i=h.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(h.hasNext())h.next(),t=t.mid;else return t.mid?this.h(t.mid):m?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[m,h]of this)p(h,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const m=[];return this.j(p,m),m[Symbol.iterator]()}j(p,m){p&&(p.left&&this.j(p.left,m),p.value&&m.push([p.key,p.value]),p.mid&&this.j(p.mid,m),p.right&&this.j(p.right,m))}_isBalanced(){const p=m=>{if(!m)return!0;const h=m.balanceFactor();return h<-1||h>1?!1:p(m.left)&&p(m.right)};return p(this.c)}}e.$Gh=k}),define(Ae[40],Re([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Pj=e.ThemeColor=void 0;var T;(function(A){function l(S){return S&&typeof S=="object"&&typeof S.id=="string"}A.isThemeColor=l})(T||(e.ThemeColor=T={}));function C(A){return{id:A}}e.$Pj=C;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function S(c){const g=l.exec(c.id);if(!g)return S(w.$Oj.error);const[,D,b]=g,n=["codicon","codicon-"+D];return b&&n.push("codicon-modifier-"+b.substring(1)),n}A.asClassNameArray=S;function f(c){return S(c).join(" ")}A.asClassName=f;function P(c){return"."+S(c).join(".")}A.asCSSSelector=P;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||T.isThemeColor(c.color))}A.isThemeIcon=k;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(c){const g=u.exec(c);if(!g)return;const[,D]=g;return{id:D}}A.fromString=p;function m(c){return{id:c}}A.fromId=m;function h(c,g){let D=c.id;const b=D.lastIndexOf("~");return b!==-1&&(D=D.substring(0,b)),g&&(D=`${D}~${g}`),{id:D}}A.modify=h;function t(c){const g=c.id.lastIndexOf("~");if(g!==-1)return c.id.substring(g+1)}A.getModifier=t;function i(c,g){return c.id===g.id&&c.color?.id===g.color?.id}A.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Ae[122],Re([1,0,120,15,40]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=void 0;const L="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function S(i){return i.replace(l,(c,g)=>g?c:`\\${c}`)}e.$Qj=S;const f=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace(f,c=>`\\${c}`)}e.$Rj=P;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(L)===-1?i:i.replace(k,(c,g,D,b)=>D?c:g||b||"")}e.$Sj=u;function p(i){return i?i.replace(/\$\((.*?)\)/g,(c,g)=>` ${g} `).trim():""}e.$Tj=p;const m=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(i){m.lastIndex=0;let c="";const g=[];let D=0;for(;;){const b=m.lastIndex,n=m.exec(i),a=i.substring(b,n?.index);if(a.length>0){c+=a;for(let s=0;s<a.length;s++)g.push(D)}if(!n)break;D+=n[0].length}return{text:c,iconOffsets:g}}e.$Uj=h;function t(i,c,g=!1){const{text:D,iconOffsets:b}=c;if(!b||b.length===0)return(0,w.$Dj)(i,D,g);const n=(0,T.$te)(D," "),a=D.length-n.length,s=(0,w.$Dj)(i,n,g);if(s)for(const o of s){const y=b[o.start+a]+a;o.start+=y,o.end+=y}return s}e.$Vj=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return w.test(C)}e.$2f=T,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let S=0;S<l.length;S++)l[S]=Math.floor(Math.random()*256);return l};const L=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,f="";return f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+="-",f+=A[L[S++]],f+=A[L[S++]],f+="-",f+=A[L[S++]],f+=A[L[S++]],f+="-",f+=A[L[S++]],f+=A[L[S++]],f+="-",f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f+=A[L[S++]],f}}()}),define(Ae[123],Re([1,0,18,66,36]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=e.$Qs=e.$Ps=e.$Os=e.$Ns=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Ns=L;function A(k,u,p){const m={id:(0,C.$3f)(),name:k,uri:u,data:p};return{asString:async()=>"",asFile:()=>m,value:void 0}}e.$Os=A;class l{constructor(){this.a=new Map}get size(){let u=0;for(const p of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const p=[...this.a.keys()];return T.Iterable.some(this,([m,h])=>h.asFile())&&p.push("files"),P(S(u),p)}get(u){return this.a.get(this.b(u))?.[0]}append(u,p){const m=this.a.get(u);m?m.push(p):this.a.set(this.b(u),[p])}replace(u,p){this.a.set(this.b(u),[p])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,p]of this.a)for(const m of p)yield[u,m]}b(u){return S(u)}}e.$Ps=l;function S(k){return k.toLowerCase()}function f(k,u){return P(S(k),u.map(S))}e.$Qs=f;function P(k,u){if(k==="*/*")return u.length>0;if(u.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[m,h,t]=p;return t==="*"?u.some(i=>i.startsWith(h+"/")):!1}e.$Rs=Object.freeze({create:k=>(0,w.$Jb)(k.map(u=>u.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Rs.split(k).filter(u=>!u.startsWith("#"))})}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0,e.$Sr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class T{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let S=0,f=l.notIn.length;S<f;S++)switch(l.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,S){if(l.getTokenCount()===0)return!0;const f=l.findTokenIndexAtOffset(S-2),P=l.getStandardTokenType(f);return this.isOK(P)}g(l,S){for(let f=l;f<=S;f++){const P=String.fromCharCode(f);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$et=T;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of l)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.$ft=C;function L(A,l,S){A.has(l)?A.get(l).push(S):A.set(l,[S])}}),define(Ae[126],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7=e.$_6=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$_6=w;class T{constructor(L){this.identifier=L}}e.$a7=T}),define(Ae[127],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[128],Re([1,0,5,6,127]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=void 0;class L extends T.$jc{constructor(u,p="",m="",h=!0,t){super(),this.h=this.B(new w.$ed),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=p,this.u=m,this.w=h,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,p){this.C&&await this.C(u)}}e.$fi=L;class A extends T.$jc{constructor(){super(...arguments),this.f=this.B(new w.$ed),this.onWillRun=this.f.event,this.m=this.B(new w.$ed),this.onDidRun=this.m.event}async run(u,p){if(!u.enabled)return;this.f.fire({action:u});let m;try{await this.u(u,p)}catch(h){m=h}this.m.fire({action:u,error:m})}async u(u,p){await u.run(p)}}e.$gi=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let p=[];for(const m of u)m.length&&(p.length?p=[...p,new l,...m]:p=m);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$hi=l;class S{get actions(){return this.a}constructor(u,p,m,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=p,this.class=h,this.a=m}async run(){}}e.$ii=S;class f extends L{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,C.localize(0,null),void 0,!1)}}e.$ji=f;function P(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.$ki=P}),define(Ae[129],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[130],Re([1,0,129]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const T=60,C=T*60,L=C*24,A=L*7,l=L*30,S=L*365;function f(k,u,p,m){typeof k!="number"&&(k=k.getTime());const h=Math.round((new Date().getTime()-k)/1e3);if(h<-30)return(0,w.localize)(0,null,f(new Date().getTime()+h*1e3,!1));if(!m&&h<30)return(0,w.localize)(1,null);let t;return h<T?(t=h,u?t===1?p?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):p?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?p?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):p?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):h<C?(t=Math.floor(h/T),u?t===1?p?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):p?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?p?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):p?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):h<L?(t=Math.floor(h/C),u?t===1?p?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):p?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?p?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):p?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):h<A?(t=Math.floor(h/L),u?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):h<l?(t=Math.floor(h/A),u?t===1?p?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):p?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?p?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):p?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):h<S?(t=Math.floor(h/l),u?t===1?p?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):p?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?p?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):p?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(h/S),u?t===1?p?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):p?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?p?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):p?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$5l=f;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=P}),define(Ae[131],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,131]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function L(k,u){return u&&(k.stack||k.stacktrace)?C.localize(0,null,l(k),A(k.stack)||A(k.stacktrace)):l(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function l(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function S(k=null,u=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const p=w.$Eb(k),m=S(p[0],u);return p.length>1?C.localize(4,null,m,p.length):m}if(T.$if(k))return k;if(k.detail){const p=k.detail;if(p.error)return L(p.error,u);if(p.exception)return L(p.exception,u)}return k.stack?L(k,u):k.message?k.message:C.localize(5,null)}e.$li=S;function f(k){const u=k;return u instanceof Error&&Array.isArray(u.actions)}e.$mi=f;function P(k,u){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=u,p}e.$ni=P}),define(Ae[132],Re([1,0,65,19]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=void 0;const C=new w.$T(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),L=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(E,r,d=!1){const v=E||"",R=r||"",B=C.value.collator.compare(v,R);return C.value.collatorIsNumeric&&B===0&&v!==R?v<R?-1:1:B}e.$8p=l;function S(E,r){const d=L.value.collator;return E=E||"",r=r||"",D(d,E,r)}e.$9p=S;function f(E,r){const d=L.value.collator;return E=E||"",r=r||"",s(E,r)||D(d,E,r)}e.$0p=f;function P(E,r){const d=L.value.collator;return E=E||"",r=r||"",a(E,r)||D(d,E,r)}e.$$p=P;function k(E,r){return E=E||"",r=r||"",E===r?0:E<r?-1:1}e.$_p=k;function u(E,r){const[d,v]=c(E),[R,B]=c(r);let V=C.value.collator.compare(v,B);if(V===0){if(C.value.collatorIsNumeric&&v!==B)return v<B?-1:1;if(V=C.value.collator.compare(d,R),C.value.collatorIsNumeric&&V===0&&d!==R)return d<R?-1:1}return V}e.$aq=u;function p(E,r){E=E||"",r=r||"";const d=g(E),v=g(r),R=L.value.collator,B=A.value.collator;return D(B,d,v)||D(R,E,r)}e.$bq=p;function m(E,r){E=E||"",r=r||"";const d=g(E),v=g(r),R=L.value.collator,B=A.value.collator;return D(B,d,v)||s(E,r)||D(R,E,r)}e.$cq=m;function h(E,r){E=E||"",r=r||"";const d=g(E),v=g(r),R=L.value.collator,B=A.value.collator;return D(B,d,v)||a(E,r)||D(R,E,r)}e.$dq=h;function t(E,r){E=E||"",r=r||"";const d=g(E).toLowerCase(),v=g(r).toLowerCase();return d!==v?d<v?-1:1:E!==r?E<r?-1:1:0}e.$eq=t;const i=/^(.*?)(\.([^.]*))?$/;function c(E,r=!1){const d=E?i.exec(E):[];let v=[d&&d[1]||"",d&&d[3]||""];return r&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function g(E){const r=E?i.exec(E):[];return r&&r[1]&&r[1].charAt(0)!=="."&&r[3]||""}function D(E,r,d){const v=E.compare(r,d);return v!==0?v:r.length!==d.length?r.length<d.length?-1:1:0}function b(E){const r=E.charAt(0);return r.toLocaleUpperCase()!==r}function n(E){const r=E.charAt(0);return r.toLocaleLowerCase()!==r}function a(E,r){return b(E)&&n(r)?-1:n(E)&&b(r)?1:0}function s(E,r){return n(E)&&b(r)?-1:b(E)&&n(r)?1:0}function o(E,r,d=!1){return d||(E=E&&E.toLowerCase(),r=r&&r.toLowerCase()),E===r?0:E<r?-1:1}function y(E,r,d=!1){const v=E.split(T.sep),R=r.split(T.sep),B=v.length-1,V=R.length-1;let j,W;for(let N=0;;N++){if(j=B===N,W=V===N,j&&W)return l(v[N],R[N],d);if(j)return-1;if(W)return 1;const z=o(v[N],R[N],d);if(z!==0)return z}}e.$fq=y;function $(E,r,d){const v=E.toLowerCase(),R=r.toLowerCase(),B=I(E,r,d);if(B)return B;const V=v.endsWith(d),j=R.endsWith(d);if(V!==j)return V?-1:1;const W=l(v,R);return W!==0?W:v.localeCompare(R)}e.$gq=$;function I(E,r,d){const v=E.toLowerCase(),R=r.toLowerCase(),B=v.startsWith(d),V=R.startsWith(d);if(B!==V)return B?-1:1;if(B&&V){if(v.length<R.length)return-1;if(v.length>R.length)return 1}return 0}e.$hq=I}),define(Ae[42],Re([1,0,19,22,15,16]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function A($){return $===47||$===92}e.$Af=A;function l($){return $.replace(/[\\/]/g,w.$5d.sep)}e.$Bf=l;function S($){return $.indexOf("/")===-1&&($=l($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Cf=S;function f($,I=w.$5d.sep){if(!$)return"";const E=$.length,r=$.charCodeAt(0);if(A(r)){if(A($.charCodeAt(1))&&!A($.charCodeAt(2))){let v=3;const R=v;for(;v<E&&!A($.charCodeAt(v));v++);if(R!==v&&!A($.charCodeAt(v+1))){for(v+=1;v<E;v++)if(A($.charCodeAt(v)))return $.slice(0,v+1).replace(/[\\/]/g,I)}}return I}else if(i(r)&&$.charCodeAt(1)===58)return A($.charCodeAt(2))?$.slice(0,2)+I:$.slice(0,2);let d=$.indexOf("://");if(d!==-1){for(d+=3;d<E;d++)if(A($.charCodeAt(d)))return $.slice(0,d+1)}return""}e.$Df=f;function P($){if(!T.$i||!$||$.length<5)return!1;let I=$.charCodeAt(0);if(I!==92||(I=$.charCodeAt(1),I!==92))return!1;let E=2;const r=E;for(;E<$.length&&(I=$.charCodeAt(E),I!==92);E++);return!(r===E||(I=$.charCodeAt(E+1),isNaN(I)||I===92))}e.$Ef=P;const k=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m($,I=T.$i){const E=I?k:u;return!(!$||$.length===0||/^\s+$/.test($)||(E.lastIndex=0,E.test($))||I&&p.test($)||$==="."||$===".."||I&&$[$.length-1]==="."||I&&$.length!==$.trim().length||$.length>255)}e.$Ff=m;function h($,I,E){const r=$===I;return!E||r?r:!$||!I?!1:(0,C.$Le)($,I)}e.$Gf=h;function t($,I,E,r=w.sep){if($===I)return!0;if(!$||!I||I.length>$.length)return!1;if(E){if(!(0,C.$Me)($,I))return!1;if(I.length===$.length)return!0;let v=I.length;return I.charAt(I.length-1)===r&&v--,$.charAt(v)===r}return I.charAt(I.length-1)!==r&&(I+=r),$.indexOf(I)===0}e.$Hf=t;function i($){return $>=65&&$<=90||$>=97&&$<=122}e.$If=i;function c($,I){return T.$i&&$.endsWith(":")&&($+=w.sep),(0,w.$7d)($)||($=(0,w.$8d)(I,$)),$=(0,w.$6d)($),T.$i?($=(0,C.$ue)($,w.sep),$.endsWith(":")&&($+=w.sep)):($=(0,C.$ue)($,w.sep),$||($=w.sep)),$}e.$Jf=c;function g($){const I=(0,w.$6d)($);return T.$i?$.length>3?!1:D(I)&&($.length===2||I.charCodeAt(2)===92):I===w.$5d.sep}e.$Kf=g;function D($,I=T.$i){return I?i($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$Lf=D;function b($,I=T.$i){return D($,I)?$[0]:void 0}e.$Mf=b;function n($,I,E){return I.length>$.length?-1:$===I?0:(E&&($=$.toLowerCase(),I=I.toLowerCase()),$.indexOf(I))}e.$Nf=n;function a($){const I=$.split(":");let E,r,d;for(const v of I){const R=Number(v);(0,L.$mf)(R)?r===void 0?r=R:d===void 0&&(d=R):E=E?[E,v].join(":"):v}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:r!==void 0?r:void 0,column:d!==void 0?d:r!==void 0?1:void 0}}e.$Of=a;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y($,I,E=8){let r="";for(let v=0;v<E;v++){let R;v===0&&T.$i&&!I&&(E===3||E===4)?R=o:R=s,r+=R.charAt(Math.floor(Math.random()*R.length))}let d;return I?d=`${I}-${r}`:d=r,$?(0,w.$8d)($,d):d}e.$Pf=y}),define(Ae[67],Re([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=e.$Fr=void 0,e.$Fr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const k=(0,w.$ae)(P),u=T[k.toLowerCase()];return u!==void 0?u:A(P)}e.$Gr=L;function A(P){const k=(0,w.$ae)(P);return C[k.toLowerCase()]}e.$Hr=A;function l(P){for(const k in C)if(C[k]===P)return k}e.$Ir=l;const S=/^(.+)\/(.+?)(;.+)?$/;function f(P,k){const u=S.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:k?void 0:P}e.$Jr=f}),define(Ae[68],Re([1,0,25,2]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function C(S){return JSON.stringify(S,A)}e.$8g=C;function L(S){let f=JSON.parse(S);return f=l(f),f}e.$9g=L;function A(S,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function l(S,f=0){if(!S||f>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return T.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof w.$Ed||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=l(S[P],f+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=l(S[P],f+1))}return S}e.$0g=l}),define(Ae[12],Re([1,0,9,22,2]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var L;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,k,u){this.a[P]=k,this.b[P]=u}setConnectionToken(P,k){this.c[P]=k}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return w.$Y(t),P}const k=P.authority;let u=this.a[k];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const p=this.b[k],m=this.c[k];let h=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(h+=`&${e.$Uf}=${encodeURIComponent(m)}`),C.URI.from({scheme:T.$o?this.d:L.vscodeRemoteResource,authority:`${u}:${p}`,path:this.f,query:h})}}e.$Vf=new A,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(P){const k=this.b(P,be);return this.uriToBrowserUri(k)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Vf.rewrite(P):P.scheme===L.file&&(T.$m||T.$p&&T.$g.origin===`${L.vscodeFileResource}://${l.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||l.a,query:null,fragment:null}):P}asFileUri(P){const k=this.b(P,be);return this.uriToFileUri(k)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==l.a?P.authority:null,query:null,fragment:null}):P}b(P,k){return C.URI.isUri(P)?P:C.URI.parse(k.toUrl(P))}}e.$1f=new l;var S;(function(f){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(P.get("3"));const k="vscode-coi";function u(m){let h;typeof m=="string"?h=new URL(m).searchParams:m instanceof URL?h=m.searchParams:C.URI.isUri(m)&&(h=new URL(m.toString(!0)).searchParams);const t=h?.get(k);if(t)return P.get(t)}f.getHeadersFromQuery=u;function p(m,h,t){if(!globalThis.crossOriginIsolated)return;const i=h&&t?"3":t?"2":"1";m instanceof URLSearchParams?m.set(k,i):m[k]=i}f.addSearchParam=p})(S||(e.COI=S={}))}),define(Ae[23],Re([1,0,42,12,19,22,15,2]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function S(p){return(0,l.$Sf)(p,!0)}e.$8f=S;class f{constructor(m){this.a=m}compare(m,h,t=!1){return m===h?0:(0,A.$Ee)(this.getComparisonKey(m,t),this.getComparisonKey(h,t))}isEqual(m,h,t=!1){return m===h?!0:!m||!h?!1:this.getComparisonKey(m,t)===this.getComparisonKey(h,t)}getComparisonKey(m,h=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,h,t=!1){if(m.scheme===h.scheme){if(m.scheme===T.Schemas.file)return w.$Hf(S(m),S(h),this.a(m))&&m.query===h.query&&(t||m.fragment===h.fragment);if((0,e.$mg)(m.authority,h.authority))return w.$Hf(m.path,h.path,this.a(m),"/")&&m.query===h.query&&(t||m.fragment===h.fragment)}return!1}joinPath(m,...h){return l.URI.joinPath(m,...h)}basenameOrAuthority(m){return(0,e.$eg)(m)||m.authority}basename(m){return C.$5d.basename(m.path)}extname(m){return C.$5d.extname(m.path)}dirname(m){if(m.path.length===0)return m;let h;return m.scheme===T.Schemas.file?h=l.URI.file(C.$$d(S(m))).path:(h=C.$5d.dirname(m.path),m.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),h="/")),m.with({path:h})}normalizePath(m){if(!m.path.length)return m;let h;return m.scheme===T.Schemas.file?h=l.URI.file(C.$6d(S(m))).path:h=C.$5d.normalize(m.path),m.with({path:h})}relativePath(m,h){if(m.scheme!==h.scheme||!(0,e.$mg)(m.authority,h.authority))return;if(m.scheme===T.Schemas.file){const c=C.$0d(S(m),S(h));return L.$i?w.$Bf(c):c}let t=m.path||"/";const i=h.path||"/";if(this.a(m)){let c=0;for(const g=Math.min(t.length,i.length);c<g&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return C.$5d.relative(t,i)}resolvePath(m,h){if(m.scheme===T.Schemas.file){const t=l.URI.file(C.$9d(S(m),h));return m.with({authority:t.authority,path:t.path})}return h=w.$Cf(h),m.with({path:C.$5d.resolve(m.path,h)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,h){return m===h||m!==void 0&&h!==void 0&&(0,A.$Le)(m,h)}hasTrailingPathSeparator(m,h=C.sep){if(m.scheme===T.Schemas.file){const t=S(m);return t.length>w.$Df(t).length&&t[t.length-1]===h}else{const t=m.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,h=C.sep){return(0,e.$ng)(m,h)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,h=C.sep){let t=!1;if(m.scheme===T.Schemas.file){const i=S(m);t=i!==void 0&&i.length===w.$Df(i).length&&i[i.length-1]===h}else{h="/";const i=m.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$ng)(m,h)?m.with({path:m.path+"/"}):m}}e.$9f=f,e.$0f=new f(()=>!1),e.$$f=new f(p=>p.scheme===T.Schemas.file?!L.$k:!0),e.$_f=new f(p=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function P(p,m){const h=[];for(let t=0;t<p.length;t++){const i=m(p[t]);p.some((c,g)=>g===t?!1:(0,e.$bg)(i,m(c)))||h.push(p[t])}return h}e.$qg=P;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function m(h){const t=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(g=>{const[D,b]=g.split(":");D&&b&&t.set(D,b)});const c=h.path.substring(0,h.path.indexOf(";"));return c&&t.set(p.META_DATA_MIME,c),t}p.parseMetaData=m})(k||(e.DataUri=k={}));function u(p,m,h){if(m){let t=p.path;return t&&t[0]!==C.$5d.sep&&(t=C.$5d.sep+t),p.with({scheme:h,authority:m,path:t})}return p.with({scheme:h})}e.$rg=u}),define(Ae[13],Re([1,0,21,9,5,6,23,22,121]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function f(O){return!!O&&typeof O.then=="function"}e.$sg=f;function P(O){const q=new w.$od,le=O(q.token),we=new Promise((ve,me)=>{const ke=q.token.onCancellationRequested(()=>{ke.dispose(),q.dispose(),me(new T.$3)});Promise.resolve(le).then(se=>{ke.dispose(),q.dispose(),ve(se)},se=>{ke.dispose(),q.dispose(),me(se)})});return new class{cancel(){q.cancel()}then(ve,me){return we.then(ve,me)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$tg=P;function k(O,q,le){return new Promise((we,ve)=>{const me=q.onCancellationRequested(()=>{me.dispose(),we(le)});O.then(we,ve).finally(()=>me.dispose())})}e.$ug=k;function u(O,q){return new Promise((le,we)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),we(new T.$3)});O.then(le,we).finally(()=>ve.dispose())})}e.$vg=u;async function p(O){let q=-1;const le=O.map((we,ve)=>we.then(me=>(q=ve,me)));try{return await Promise.race(le)}finally{O.forEach((we,ve)=>{ve!==q&&we.cancel()})}}e.$wg=p;function m(O,q,le){let we;const ve=setTimeout(()=>{we?.(void 0),le?.()},q);return Promise.race([O.finally(()=>clearTimeout(ve)),new Promise(me=>we=me)])}e.$xg=m;function h(O){return new Promise((q,le)=>{const we=O();f(we)?we.then(q,le):q(we)})}e.$yg=h;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const le=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(le,le).then(we)})}return new Promise((le,we)=>{this.b.then(le,we)})}return this.a=q(),new Promise((le,we)=>{this.a.then(ve=>{this.a=null,le(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$zg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Ag=i;class c{constructor(){this.a=new Map}queue(q,le){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$Bg=c;const g=(O,q)=>{let le=!0;const we=setTimeout(()=>{le=!1,q()},O);return{isTriggered:()=>le,dispose:()=>{clearTimeout(we),le=!1}}},D=O=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,O())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class b{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,le=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,me)=>{this.d=ve,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=le===S.$bd?D(we):g(le,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=b;class n{constructor(q){this.a=new b(q),this.b=new t}trigger(q,le){return this.a.trigger(()=>this.b.queue(q),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=n;class a{constructor(){this.a=!1,this.b=new Promise((q,le)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=a;class s extends a{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Fg=s;function o(O,q){return q?new Promise((le,we)=>{const ve=setTimeout(()=>{me.dispose(),le()},O),me=q.onCancellationRequested(()=>{clearTimeout(ve),me.dispose(),we(new T.$3)})}):P(le=>o(O,le))}e.$Gg=o;function y(O,q=0){const le=setTimeout(O,q);return(0,L.$hc)(()=>clearTimeout(le))}e.$Hg=y;function $(O){const q=[];let le=0;const we=O.length;function ve(){return le<we?O[le++]():null}function me(ke){ke!=null&&q.push(ke);const se=ve();return se?se.then(me):Promise.resolve(q)}return Promise.resolve(null).then(me)}e.$Ig=$;function I(O,q=we=>!!we,le=null){let we=0;const ve=O.length,me=()=>{if(we>=ve)return Promise.resolve(le);const ke=O[we++];return Promise.resolve(ke()).then(he=>q(he)?Promise.resolve(he):me())};return me()}e.$Jg=I;function E(O,q=we=>!!we,le=null){if(O.length===0)return Promise.resolve(le);let we=O.length;const ve=()=>{we=-1;for(const me of O)me.cancel?.()};return new Promise((me,ke)=>{for(const se of O)se.then(he=>{--we>=0&&q(he)?(ve(),me(he)):we===0&&me(le)}).catch(he=>{--we>=0&&(ve(),ke(he))})})}e.$Kg=E;class r{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((le,we)=>{this.f.push({factory:q,c:le,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const le=q.factory();le.then(q.c,q.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=r;class d extends r{constructor(){super(1)}}e.$Mg=d;class v{constructor(){this.a=new Ee,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Ng=v;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new Z;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,le=A.$0f){const we=le.getComparisonKey(q);let ve=this.a.get(we);if(!ve){ve=new d;const me=this.f++,ke=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$rc),this.d.set(me,ke),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=R;class B{constructor(q,le){this.a=-1,typeof q=="function"&&typeof le=="number"&&this.setIfNotSet(q,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},le)}setIfNotSet(q,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},le))}}e.$Pg=B;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setInterval(()=>{q()},le)}}e.$Qg=V;class j{constructor(q,le){this.b=-1,this.a=q,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=j;class W{constructor(q,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=q,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=W;class N extends j{constructor(q,le){super(q,le),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Tg=N;class z extends L.$jc{constructor(q,le){super(),this.g=q,this.h=le,this.a=[],this.b=this.B(new L.$kc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of q)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=O=>{(0,l.$A)(()=>{if(q)return;const le=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$Vg=(O,q)=>{const le=requestIdleCallback(O,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(le))}}}}();class ee{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=ee;async function X(O,q,le){let we;for(let ve=0;ve<le;ve++)try{return await O()}catch(me){we=me,await o(q)}throw we}e.$Xg=X;class Ee{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,le,we){return this.a={taskId:q,cancel:()=>we?.(),promise:le},le.then(()=>this.d(q),()=>this.d(q)),le}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let le,we;const ve=new Promise((me,ke)=>{le=me,we=ke});this.b={run:q,promise:ve,promiseResolve:le,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=Ee;class De{constructor(q,le=()=>Date.now()){this.d=q,this.f=le,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Zg=De;var Pe;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Pe||(Pe={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,le)=>{this.a=q,this.b=le})}complete(q){return new Promise(le=>{this.a(q),this.d={outcome:0,value:q},le()})}error(q){return new Promise(le=>{this.b(q),this.d={outcome:1,value:q},le()})}cancel(){return this.error(new T.$3)}}e.$1g=Z;var ue;(function(O){async function q(we){let ve;const me=await Promise.all(we.map(ke=>ke.then(se=>se,se=>{ve||(ve=se)})));if(typeof ve<"u")throw ve;return me}O.settled=q;function le(we){return new Promise(async(ve,me)=>{try{await we(ve,me)}catch(ke){me(ke)}})}O.withAsyncBody=le})(ue||(e.Promises=ue={}));var ye;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(ye||(ye={}));class ce{static fromArray(q){return new ce(le=>{le.emitMany(q)})}static fromPromise(q){return new ce(async le=>{le.emitMany(await q)})}static fromPromises(q){return new ce(async le=>{await Promise.all(q.map(async we=>le.emitOne(await we)))})}static merge(q){return new ce(async le=>{await Promise.all(q.map(async we=>{for await(const ve of we)le.emitOne(ve)}))})}static{this.EMPTY=ce.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$ed,queueMicrotask(async()=>{const le={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(le)),this.j()}catch(we){this.k(we)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,le){return new ce(async we=>{for await(const ve of q)we.emitOne(le(ve))})}map(q){return ce.map(this,q)}static filter(q,le){return new ce(async we=>{for await(const ve of q)le(ve)&&we.emitOne(ve)})}filter(q){return ce.filter(this,q)}static coalesce(q){return ce.filter(q,le=>!!le)}coalesce(){return ce.coalesce(this)}static async toPromise(q){const le=[];for await(const we of q)le.push(we);return le}toPromise(){return ce.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$2g=ce;class $e extends ce{constructor(q,le){super(le),this.l=q}cancel(){this.l.cancel()}}e.$3g=$e;function ie(O){const q=new w.$od,le=O(q.token);return new $e(q,async we=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),we.reject(new T.$3)});try{for await(const me of le){if(q.token.isCancellationRequested)return;we.emitOne(me)}ve.dispose(),q.dispose()}catch(me){ve.dispose(),q.dispose(),we.reject(me)}})}e.$4g=ie}),define(Ae[37],Re([1,0,18,13,42,28,19,22,15]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0;function f(){return Object.create(null)}e.$lj=f,e.$mj="**",e.$nj="/";const P="[/\\\\]",k="[^/\\\\]",u=/\//g;function p(Ee,De){switch(Ee){case 0:return"";case 1:return`${k}*?`;default:return`(?:${P}|${k}+${P}${De?`|${P}${k}+`:""})*?`}}function m(Ee,De){if(!Ee)return[];const Pe=[];let Z=!1,ue=!1,ye="";for(const ce of Ee){switch(ce){case De:if(!Z&&!ue){Pe.push(ye),ye="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ye+=ce}return ye&&Pe.push(ye),Pe}e.$oj=m;function h(Ee){if(!Ee)return"";let De="";const Pe=m(Ee,e.$nj);if(Pe.every(Z=>Z===e.$mj))De=".*";else{let Z=!1;Pe.forEach((ue,ye)=>{if(ue===e.$mj){if(Z)return;De+=p(2,ye===Pe.length-1)}else{let ce=!1,$e="",ie=!1,O="";for(const q of ue){if(q!=="}"&&ce){$e+=q;continue}if(ie&&(q!=="]"||!O)){let le;q==="-"?le=q:(q==="^"||q==="!")&&!O?le="^":q===e.$nj?le="":le=(0,S.$pe)(q),O+=le;continue}switch(q){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${m($e,",").map(ve=>h(ve)).join("|")})`;De+=we,ce=!1,$e="";break}case"]":{De+="["+O+"]",ie=!1,O="";break}case"?":De+=k;continue;case"*":De+=p(1);continue;default:De+=(0,S.$pe)(q)}}ye<Pe.length-1&&(Pe[ye+1]!==e.$mj||ye+2<Pe.length)&&(De+=P)}Z=ue===e.$mj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Bi(1e4),a=function(){return!1},s=function(){return null};function o(Ee,De){if(!Ee)return s;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const Z=`${Pe}_${!!De.trimForExclusions}`;let ue=n.get(Z);if(ue)return y(ue,Ee);let ye;return t.test(Pe)?ue=I(Pe.substr(4),Pe):(ye=i.exec($(Pe,De)))?ue=E(ye[1],Pe):(De.trimForExclusions?g:c).test(Pe)?ue=r(Pe,De):(ye=D.exec($(Pe,De)))?ue=d(ye[1].substr(1),Pe,!0):(ye=b.exec($(Pe,De)))?ue=d(ye[1],Pe,!1):ue=v(Pe),n.set(Z,ue),y(ue,Ee)}function y(Ee,De){if(typeof De=="string")return Ee;const Pe=function(Z,ue){return(0,C.$Hf)(Z,De.base,!l.$k)?Ee((0,S.$te)(Z.substr(De.base.length),A.sep),ue):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function $(Ee,De){return De.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,De){return function(Pe,Z){return typeof Pe=="string"&&Pe.endsWith(Ee)?De:null}}function E(Ee,De){const Pe=`/${Ee}`,Z=`\\${Ee}`,ue=function(ce,$e){return typeof ce!="string"?null:$e?$e===Ee?De:null:ce===Ee||ce.endsWith(Pe)||ce.endsWith(Z)?De:null},ye=[Ee];return ue.basenames=ye,ue.patterns=[De],ue.allBasenames=ye,ue}function r(Ee,De){const Pe=ee(Ee.slice(1,-1).split(",").map($e=>o($e,De)).filter($e=>$e!==s),Ee),Z=Pe.length;if(!Z)return s;if(Z===1)return Pe[0];const ue=function($e,ie){for(let O=0,q=Pe.length;O<q;O++)if(Pe[O]($e,ie))return Ee;return null},ye=Pe.find($e=>!!$e.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(ue.allPaths=ce),ue}function d(Ee,De,Pe){const Z=A.sep===A.$5d.sep,ue=Z?Ee:Ee.replace(u,A.sep),ye=A.sep+ue,ce=A.$5d.sep+Ee;let $e;return Pe?$e=function(ie,O){return typeof ie=="string"&&(ie===ue||ie.endsWith(ye)||!Z&&(ie===Ee||ie.endsWith(ce)))?De:null}:$e=function(ie,O){return typeof ie=="string"&&(ie===ue||!Z&&ie===Ee)?De:null},$e.allPaths=[(Pe?"*/":"./")+Ee],$e}function v(Ee){try{const De=new RegExp(`^${h(Ee)}$`);return function(Pe){return De.lastIndex=0,typeof Pe=="string"&&De.test(Pe)?Ee:null}}catch{return s}}function R(Ee,De,Pe){return!Ee||typeof De!="string"?!1:B(Ee)(De,void 0,Pe)}e.$pj=R;function B(Ee,De={}){if(!Ee)return a;if(typeof Ee=="string"||V(Ee)){const Pe=o(Ee,De);if(Pe===s)return a;const Z=function(ue,ye){return!!Pe(ue,ye)};return Pe.allBasenames&&(Z.allBasenames=Pe.allBasenames),Pe.allPaths&&(Z.allPaths=Pe.allPaths),Z}return N(Ee,De)}e.$qj=B;function V(Ee){const De=Ee;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$rj=V;function j(Ee){return Ee.allBasenames||[]}e.$sj=j;function W(Ee){return Ee.allPaths||[]}e.$tj=W;function N(Ee,De){const Pe=ee(Object.getOwnPropertyNames(Ee).map($e=>z($e,Ee[$e],De)).filter($e=>$e!==s)),Z=Pe.length;if(!Z)return s;if(!Pe.some($e=>!!$e.requiresSiblings)){if(Z===1)return Pe[0];const $e=function(q,le){let we;for(let ve=0,me=Pe.length;ve<me;ve++){const ke=Pe[ve](q,le);if(typeof ke=="string")return ke;(0,T.$sg)(ke)&&(we||(we=[]),we.push(ke))}return we?(async()=>{for(const ve of we){const me=await ve;if(typeof me=="string")return me}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const O=Pe.reduce((q,le)=>le.allPaths?q.concat(le.allPaths):q,[]);return O.length&&($e.allPaths=O),$e}const ue=function($e,ie,O){let q,le;for(let we=0,ve=Pe.length;we<ve;we++){const me=Pe[we];me.requiresSiblings&&O&&(ie||(ie=(0,A.$_d)($e)),q||(q=ie.substr(0,ie.length-(0,A.$ae)($e).length)));const ke=me($e,ie,q,O);if(typeof ke=="string")return ke;(0,T.$sg)(ke)&&(le||(le=[]),le.push(ke))}return le?(async()=>{for(const we of le){const ve=await we;if(typeof ve=="string")return ve}return null})():null},ye=Pe.find($e=>!!$e.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(ue.allPaths=ce),ue}function z(Ee,De,Pe){if(De===!1)return s;const Z=o(Ee,Pe);if(Z===s)return s;if(typeof De=="boolean")return Z;if(De){const ue=De.when;if(typeof ue=="string"){const ye=(ce,$e,ie,O)=>{if(!O||!Z(ce,$e))return null;const q=ue.replace("$(basename)",()=>ie),le=O(q);return(0,T.$sg)(le)?le.then(we=>we?Ee:null):le?Ee:null};return ye.requiresSiblings=!0,ye}}return Z}function ee(Ee,De){const Pe=Ee.filter($e=>!!$e.basenames);if(Pe.length<2)return Ee;const Z=Pe.reduce(($e,ie)=>{const O=ie.basenames;return O?$e.concat(O):$e},[]);let ue;if(De){ue=[];for(let $e=0,ie=Z.length;$e<ie;$e++)ue.push(De)}else ue=Pe.reduce(($e,ie)=>{const O=ie.patterns;return O?$e.concat(O):$e},[]);const ye=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const le=$e.charCodeAt(q-1);if(le===47||le===92)break}ie=$e.substr(q)}const O=Z.indexOf(ie);return O!==-1?ue[O]:null};ye.basenames=Z,ye.patterns=ue,ye.allBasenames=Z;const ce=Ee.filter($e=>!$e.basenames);return ce.push(ye),ce}function X(Ee,De){return(0,w.$sb)(Ee,De,(Pe,Z)=>typeof Pe=="string"&&typeof Z=="string"?Pe===Z:typeof Pe!="string"&&typeof Z!="string"?Pe.base===Z.base&&Pe.pattern===Z.pattern:!1)}e.$uj=X}),define(Ae[49],Re([1,0,9,122,23,15,2]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class S{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,w.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=u(this.supportThemeIcons?(0,T.$Qj)(i):i).replace(/([ \t]+)/g,(g,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,g){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(i,c){const g=new RegExp((0,L.$pe)(c),"g");return i.replace(g,(D,b)=>i.charAt(b-1)!=="\\"?`\\${D}`:D)}}e.$Wj=S;function f(t){return P(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$Xj=f;function P(t){return t instanceof S?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Yj=P;function k(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$ag)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$Zj=k;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$1j=u;function p(t){return t.replace(/"/g,"&quot;")}e.$2j=p;function m(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$3j=m;function h(t){const i=[],c=t.split("|").map(D=>D.trim());t=c[0];const g=c[1];if(g){const D=/height=(\d+)/.exec(g),b=/width=(\d+)/.exec(g),n=D?D[1]:"",a=b?b[1]:"",s=isFinite(parseInt(a)),o=isFinite(parseInt(n));s&&i.push(`width="${a}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$4j=h}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=e.$bA=void 0;function S(o,y){const{os:$,tildify:I,relative:E}=y;if(E){const v=f(o,E,$);if(typeof v=="string")return v}let r=o.fsPath;if($===1&&!L.$i?r=r.replace(/\//g,"\\"):$!==1&&L.$i&&(r=r.replace(/\\/g,"/")),$!==1&&I?.userHome){const v=I.userHome.fsPath;let R;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$5d.sep)?R=I.userHome.with({path:o.path}).fsPath:R=o.fsPath,r=u(R,v,$)}return($===1?C.$4d:C.$5d).normalize(P(r,$===1))}e.$bA=S;function f(o,y,$){const I=$===1?C.$4d:C.$5d,E=$===3?A.$0f:A.$_f,r=y.getWorkspace(),d=(0,w.$Lb)(r.folders);if(!d)return;o.scheme!==d.uri.scheme&&o.path.startsWith(C.$5d.sep)&&(o=d.uri.with({path:o.path}));const v=y.getWorkspaceFolder(o);if(!v)return;let R;if(E.isEqual(v.uri,o)?R="":R=E.relativePath(v.uri,o)??"",R&&(R=I.normalize(R)),r.folders.length>1&&!y.noPrefix){const B=v.name?v.name:E.basenameOrAuthority(v.uri);R=R?`${B} \u2022 ${R}`:B}return R}function P(o,y=L.$i){return(0,T.$Lf)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$cA=P;let k=Object.create(null);function u(o,y,$=L.OS){if($===1||!o||!y)return o;let I=k.original===y?k.normalized:void 0;I||(I=y,L.$i&&(I=(0,T.$Bf)(I)),I=`${(0,l.$ue)(I,C.$5d.sep)}${C.$5d.sep}`,k={original:y,normalized:I});let E=o;return L.$i&&(E=(0,T.$Bf)(E)),($===3?E.startsWith(I):(0,l.$Me)(E,I))?`~/${E.substr(I.length)}`:o}e.$dA=u;function p(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$eA=p;const m="\u2026",h="\\\\",t="~";function i(o,y=C.sep){const $=new Array(o.length);let I=!1;for(let E=0;E<o.length;E++){const r=o[E];if(r===""){$[E]=`.${y}`;continue}if(!r){$[E]=r;continue}I=!0;let d="",v=r;v.indexOf(h)===0?(d=v.substr(0,v.indexOf(h)+h.length),v=v.substr(v.indexOf(h)+h.length)):v.indexOf(y)===0?(d=v.substr(0,v.indexOf(y)+y.length),v=v.substr(v.indexOf(y)+y.length)):v.indexOf(t)===0&&(d=v.substr(0,v.indexOf(t)+t.length),v=v.substr(v.indexOf(t)+t.length));const R=v.split(y);for(let B=1;I&&B<=R.length;B++)for(let V=R.length-B;I&&V>=0;V--){I=!1;let j=R.slice(V,V+B).join(y);for(let W=0;!I&&W<o.length;W++)if(W!==E&&o[W]&&o[W].indexOf(j)>-1){const N=V+B===R.length,z=V>0&&o[W].indexOf(y)>-1?y+j:j,ee=o[W].endsWith(z);I=!N||ee}if(!I){let W="";(R[0].endsWith(":")||d!=="")&&(V===1&&(V=0,B++,j=R[0]+y+j),V>0&&(W=R[0]+y),W=d+W),V>0&&(W=W+m+y),W=W+j,V+B<R.length&&(W=W+y+m),$[E]=W}}I&&($[E]=r)}return $}e.$fA=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function g(o,y=Object.create(null)){const $=[];let I=!1,E="";for(const r of o)if(r==="$"||I&&r==="{")E&&$.push({value:E,type:c.TEXT}),E="",I=!0;else if(r==="}"&&I){const d=y[E];if(typeof d=="string")d.length&&$.push({value:d,type:c.VARIABLE});else if(d){const v=$[$.length-1];(!v||v.type!==c.SEPARATOR)&&$.push({value:d.label,type:c.SEPARATOR})}E="",I=!1}else E+=r;return E&&!I&&$.push({value:E,type:c.TEXT}),$.filter((r,d)=>{if(r.type===c.SEPARATOR){const v=$[d-1],R=$[d+1];return[v,R].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(r=>r.value).join("")}e.$gA=g;function D(o,y){return L.$j||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):o.replace(/&&|&/g,$=>$==="&"?"&&":"&")}e.$hA=D;function b(o,y){return L.$j||y?o.replace(/\(&&\w\)|&&/g,""):L.$i?o.replace(/&&|&/g,$=>$==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$iA=b;function n(o){return o.replace(/&/g,"&&")}e.$jA=n;function a(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const $=s(o.substring(0,y));return{name:$.name,parentPath:$.parentPath+o.substring(y)}}}return s(o)}e.$kA=a;function s(o){const y=o.indexOf("/")!==-1?C.$5d:C.$4d,$=y.basename(o),I=y.dirname(o);return $.length?{name:$,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[133],Re([1,0,25,2]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0;function C(k){return k.toJSON()}class L{constructor(u){this.a=u}transformIncoming(u){const p=this.a.transformIncoming(u);return p===u?u:C(T.URI.from(p))}transformOutgoing(u){const p=this.a.transformOutgoing(u);return p===u?u:C(T.URI.from(p))}transformOutgoingURI(u){const p=this.a.transformOutgoing(u);return p===u?u:T.URI.from(p)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Am=L,e.$Bm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,u,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof T.URI)return u.transformOutgoing(k);for(const m in k)if(Object.hasOwnProperty.call(k,m)){const h=A(k[m],u,p+1);h!==null&&(k[m]=h)}}return null}function l(k,u){const p=A(k,u,0);return p===null?k:p}e.$Cm=l;function S(k,u,p,m){if(!k||m>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?T.URI.revive(u.transformIncoming(k)):u.transformIncoming(k);if(k instanceof w.$Ed)return null;for(const h in k)if(Object.hasOwnProperty.call(k,h)){const t=S(k[h],u,p,m+1);t!==null&&(k[h]=t)}}return null}function f(k,u){const p=S(k,u,!1,0);return p===null?k:p}e.$Dm=f;function P(k,u){const p=S(k,u,!0,0);return p===null?k:p}e.$Em=P}),define(Ae[134],Re([1,0,37,19]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=void 0;function C(L,A,l,S,f,P){if(Array.isArray(L)){let k=0;for(const u of L){const p=C(u,A,l,S,f,P);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof L=="string")return S?L==="*"?5:L===l?10:0:0;if(L){const{language:k,pattern:u,scheme:p,hasAccessToAllModels:m,notebookType:h}=L;if(!S&&!m)return 0;h&&f&&(A=f);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(k)if(k===l)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(h)if(h===P)t=10;else if(h==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,T.$6d)(u.base)},i===A.fsPath||(0,w.$pj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$_E=C}),define(Ae[91],Re([1,0,25,22]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0=e.$j0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function L(k){for(let u=0,p=k.length;u<p;u+=4){const m=k[u+0],h=k[u+1],t=k[u+2],i=k[u+3];k[u+0]=i,k[u+1]=t,k[u+2]=h,k[u+3]=m}}function A(k){const u=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return T.$C()||L(u),w.$Ed.wrap(u)}function l(k){const u=k.buffer;if(T.$C()||L(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const p=new Uint8Array(u.byteLength);return p.set(u),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function S(k){const u=new Uint32Array(f(k));let p=0;if(u[p++]=k.id,k.type==="full")u[p++]=1,u[p++]=k.data.length,u.set(k.data,p),p+=k.data.length;else{u[p++]=2,u[p++]=k.deltas.length;for(const m of k.deltas)u[p++]=m.start,u[p++]=m.deleteCount,m.data?(u[p++]=m.data.length,u.set(m.data,p),p+=m.data.length):u[p++]=0}return A(u)}e.$j0=S;function f(k){let u=0;if(u+=1+1,k.type==="full")u+=1+k.data.length;else{u+=1,u+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(u+=p.data.length)}return u}function P(k){const u=l(k);let p=0;const m=u[p++];if(u[p++]===1){const c=u[p++],g=u.subarray(p,p+c);return p+=c,{id:m,type:"full",data:g}}const t=u[p++],i=[];for(let c=0;c<t;c++){const g=u[p++],D=u[p++],b=u[p++];let n;b>0&&(n=u.subarray(p,p+b),p+=b),i[c]={start:g,deleteCount:D,data:n}}return{id:m,type:"delta",deltas:i}}e.$k0=P}),define(Ae[135],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[136],Re([1,0,18,24,22,124,137,135]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=f;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class k{constructor(Y,pe,je,ze){this.id=Y,this.name=pe,this.defaultValue=je,this.schema=ze}applyUpdate(Y,pe){return p(Y,pe)}compute(Y,pe,je){return je}}class u{constructor(Y,pe){this.newValue=Y,this.didChange=pe}}e.ApplyUpdateResult=u;function p(_,Y){if(typeof _!="object"||typeof Y!="object"||!_||!Y)return new u(Y,_!==Y);if(Array.isArray(_)||Array.isArray(Y)){const je=Array.isArray(_)&&Array.isArray(Y)&&w.$sb(_,Y);return new u(Y,!je)}let pe=!1;for(const je in Y)if(Y.hasOwnProperty(je)){const ze=p(_[je],Y[je]);ze.didChange&&(_[je]=ze.newValue,pe=!0)}return new u(_,pe)}class m{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,pe){return p(Y,pe)}validate(Y){return this.defaultValue}}class h{constructor(Y,pe,je,ze){this.id=Y,this.name=pe,this.defaultValue=je,this.schema=ze}applyUpdate(Y,pe){return p(Y,pe)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,pe,je){return je}}function t(_,Y){return typeof _>"u"?Y:_==="false"?!1:!!_}e.boolean=t;class i extends h{constructor(Y,pe,je,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=je),super(Y,pe,je,ze)}validate(Y){return t(Y,this.defaultValue)}}function c(_,Y,pe,je){if(typeof _>"u")return Y;let ze=parseInt(_,10);return isNaN(ze)?Y:(ze=Math.max(pe,ze),ze=Math.min(je,ze),ze|0)}e.clampedInt=c;class g extends h{static clampedInt(Y,pe,je,ze){return c(Y,pe,je,ze)}constructor(Y,pe,je,ze,Ye,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=je,nt.minimum=ze,nt.maximum=Ye),super(Y,pe,je,nt),this.minimum=ze,this.maximum=Ye}validate(Y){return g.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function D(_,Y,pe,je){if(typeof _>"u")return Y;const ze=b.float(_,Y);return b.clamp(ze,pe,je)}e.clampedFloat=D;class b extends h{static clamp(Y,pe,je){return Y<pe?pe:Y>je?je:Y}static float(Y,pe){if(typeof Y=="number")return Y;if(typeof Y>"u")return pe;const je=parseFloat(Y);return isNaN(je)?pe:je}constructor(Y,pe,je,ze,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=je),super(Y,pe,je,Ye),this.validationFn=ze}validate(Y){return this.validationFn(b.float(Y,this.defaultValue))}}class n extends h{static string(Y,pe){return typeof Y!="string"?pe:Y}constructor(Y,pe,je,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=je),super(Y,pe,je,ze)}validate(Y){return n.string(Y,this.defaultValue)}}function a(_,Y,pe,je){return typeof _!="string"?Y:je&&_ in je?je[_]:pe.indexOf(_)===-1?Y:_}e.stringSet=a;class s extends h{constructor(Y,pe,je,ze,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=ze,Ye.default=je),super(Y,pe,je,Ye),this.c=ze}validate(Y){return a(Y,this.defaultValue,this.c)}}class o extends k{constructor(Y,pe,je,ze,Ye,nt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Ye,gt.default=ze),super(Y,pe,je,gt),this.c=Ye,this.d=nt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function y(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,pe,je){return je===0?Y.accessibilitySupport:je}}class I extends k{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function r(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(d||(e.TextEditorCursorStyle=d={}));function v(_){switch(_){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function R(_){switch(_){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class B extends m{constructor(){super(140)}compute(Y,pe,je){const ze=["monaco-editor"];return pe.get(39)&&ze.push(pe.get(39)),Y.extraEditorClassName&&ze.push(Y.extraEditorClassName),pe.get(73)==="default"?ze.push("mouse-default"):pe.get(73)==="copy"&&ze.push("mouse-copy"),pe.get(110)&&ze.push("showUnused"),pe.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class V extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Y,pe,je){return je&&Y.emptySelectionClipboard}}class j extends k{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:l.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:l.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":a(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":a(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class W extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?W.OFF:Y==="true"?W.ON:Y:Y?W.ON:W.OFF}}e.EditorFontLigatures=W;class N extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?N.OFF:Y==="true"?N.TRANSLATE:Y:Y?N.TRANSLATE:N.OFF}compute(Y,pe,je){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class z extends m{constructor(){super(50)}compute(Y,pe,je){return Y.fontInfo}}class ee extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Y){const pe=b.float(Y,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:b.clamp(pe,6,100)}compute(Y,pe,je){return Y.fontInfo.fontSize}}class X extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(g.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class Ee extends k{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:je,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:je,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:je,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:je,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:je,description:l.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{multiple:a(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??a(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??a(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??a(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??a(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??a(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends k{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:l.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:g.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class Z extends m{constructor(){super(143)}compute(Y,pe,je){return Z.computeLayout(pe,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const pe=Y.height/Y.lineHeight,je=Math.floor(Y.paddingTop/Y.lineHeight);let ze=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(ze=Math.max(ze,pe-1));const Ye=(je+Y.viewLineCount+ze)/(Y.pixelRatio*Y.height),nt=Math.floor(Y.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:ze,desiredRatio:Ye,minimapLineCount:nt}}static c(Y,pe){const je=Y.outerWidth,ze=Y.outerHeight,Ye=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const nt=pe.stableMinimapLayoutInput,gt=nt&&Y.outerHeight===nt.outerHeight&&Y.lineHeight===nt.lineHeight&&Y.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===nt.pixelRatio&&Y.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Y.paddingTop===nt.paddingTop&&Y.paddingBottom===nt.paddingBottom&&Y.minimap.enabled===nt.minimap.enabled&&Y.minimap.side===nt.minimap.side&&Y.minimap.size===nt.minimap.size&&Y.minimap.showSlider===nt.minimap.showSlider&&Y.minimap.renderCharacters===nt.minimap.renderCharacters&&Y.minimap.maxColumn===nt.minimap.maxColumn&&Y.minimap.scale===nt.minimap.scale&&Y.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Y.isViewportWrapping===nt.isViewportWrapping,vt=Y.lineHeight,Ft=Y.typicalHalfwidthCharacterWidth,Yt=Y.scrollBeyondLastLine,Vt=Y.minimap.renderCharacters;let wt=Ye>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Mt=Y.minimap.maxColumn,Nt=Y.minimap.size,Jt=Y.minimap.side,Pt=Y.verticalScrollbarWidth,At=Y.viewLineCount,zt=Y.remainingWidth,jt=Y.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Ye*ze);const at=Bt/Ye;let ut=!1,Ht=!1,Ct=qt*wt,Dt=wt/Ye,ht=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Te,extraLinesBeforeFirstLine:ge,extraLinesBeyondLastLine:H,desiredRatio:Fe,minimapLineCount:Be}=Z.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Yt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:ze,lineHeight:vt,pixelRatio:Ye});if(At/Be>1)ut=!0,Ht=!0,wt=1,Ct=1,Dt=wt/Ye;else{let We=!1,xe=wt+1;if(Nt==="fit"){const pt=Math.ceil((ge+At+H)*Ct);jt&&gt&&zt<=pe.stableFitRemainingWidth?(We=!0,xe=pe.stableFitMaxMinimapScale):We=pt>Bt}if(Nt==="fill"||We){ut=!0;const pt=wt;Ct=Math.min(vt*Ye,Math.max(1,Math.floor(1/Fe))),jt&&gt&&zt<=pe.stableFitRemainingWidth&&(xe=pe.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(Ct/qt))),wt>pt&&(ht=Math.min(2,wt/pt)),Dt=wt/Ye/ht,Bt=Math.ceil(Math.max(Te,ge+At+H)*Ct),jt?(pe.stableMinimapLayoutInput=Y,pe.stableFitRemainingWidth=zt,pe.stableFitMaxMinimapScale=wt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const St=Math.floor(Mt*Dt),Lt=Math.min(St,Math.max(0,Math.floor((zt-Pt-2)*Dt/(Ft+Dt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Ye*Lt);const qe=Et/Ye;Et=Math.floor(Et*ht);const Ot=Vt?1:2,Ce=Jt==="left"?0:je-Lt-Pt;return{renderMinimap:Ot,minimapLeft:Ce,minimapWidth:Lt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ht,minimapScale:wt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(Y,pe){const je=pe.outerWidth|0,ze=pe.outerHeight|0,Ye=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,gt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,Ft=pe.pixelRatio,Yt=pe.viewLineCount,Vt=Y.get(135),wt=Vt==="inherit"?Y.get(134):Vt,Mt=wt==="inherit"?Y.get(130):wt,Nt=Y.get(133),Jt=pe.isDominatedByLongLines,Pt=Y.get(57),At=Y.get(67).renderType!==0,zt=Y.get(68),jt=Y.get(104),qt=Y.get(83),Bt=Y.get(72),at=Y.get(102),ut=at.verticalScrollbarSize,Ht=at.verticalHasArrows,Ct=at.arrowSize,Dt=at.horizontalScrollbarSize,ht=Y.get(43),St=Y.get(109)!=="never";let Lt=Y.get(65);ht&&St&&(Lt+=16);let Et=0;if(At){const dt=Math.max(nt,zt);Et=Math.round(dt*vt)}let qe=0;Pt&&(qe=Ye*pe.glyphMarginDecorationLaneCount);let Ot=0,Ce=Ot+qe,Te=Ce+Et,ge=Te+Lt;const H=je-qe-Et-Lt;let Fe=!1,Be=!1,Ge=-1;wt==="inherit"&&Jt?(Fe=!0,Be=!0):Mt==="on"||Mt==="bounded"?Be=!0:Mt==="wordWrapColumn"&&(Ge=Nt);const We=Z.c({outerWidth:je,outerHeight:ze,lineHeight:Ye,typicalHalfwidthCharacterWidth:gt,pixelRatio:Ft,scrollBeyondLastLine:jt,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:ut,viewLineCount:Yt,remainingWidth:H,isViewportWrapping:Be},pe.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Ot+=We.minimapWidth,Ce+=We.minimapWidth,Te+=We.minimapWidth,ge+=We.minimapWidth);const xe=H-We.minimapWidth,pt=Math.max(1,Math.floor((xe-ut-2)/gt)),bt=Ht?Ct:0;return Be&&(Ge=Math.max(1,pt),Mt==="bounded"&&(Ge=Math.min(Ge,Nt))),{width:je,height:ze,glyphMarginLeft:Ot,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ce,lineNumbersWidth:Et,decorationsLeft:Te,decorationsWidth:Lt,contentLeft:ge,contentWidth:xe,minimap:We,viewportColumn:pt,isWordWrapMinified:Fe,isViewportWrapping:Be,wrappingColumn:Ge,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Dt,overviewRuler:{top:bt,width:ut,height:ze-2*bt,right:0}}}}e.EditorLayoutInfoComputer=Z;class ue extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Y){return a(Y,"simple",["simple","advanced"])}compute(Y,pe,je){return pe.get(2)===2?"advanced":je}}class ye extends k{constructor(){const Y={enabled:!0};super(64,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:l.localize(50,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class ce extends k{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:l.localize(54,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends k{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:l.localize(62,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:a(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):g.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,pe,je){return je<0?g.clampedInt(-je*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class O extends b{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>b.clamp(Y,0,150),{markdownDescription:l.localize(63,null)})}compute(Y,pe,je){return Y.fontInfo.lineHeight}}class q extends k{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Y.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:l.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:a(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(pe.side,this.defaultValue.side,["right","left"]),showSlider:a(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(pe.scale,1,1,3),maxColumn:g.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class we extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{top:g.clampedInt(pe.top,0,0,1e3),bottom:g.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends k{constructor(){const Y={enabled:!0,cycle:!0};super(85,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:l.localize(78,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class me extends m{constructor(){super(141)}compute(Y,pe,je){return Y.pixelRatio}}class ke extends k{constructor(){const Y={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Y.strings,description:l.localize(82,null)},comments:{anyOf:pe,default:Y.comments,description:l.localize(83,null)},other:{anyOf:pe,default:Y.other,description:l.localize(84,null)}},default:Y,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Ft=Y?"on":"off";return{comments:Ft,strings:Ft,other:Ft}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:pe,comments:je,strings:ze}=Y,Ye=["on","inline","off"];let nt,gt,vt;return typeof pe=="boolean"?nt=pe?"on":"off":nt=a(pe,this.defaultValue.other,Ye),typeof je=="boolean"?gt=je?"on":"off":gt=a(je,this.defaultValue.comments,Ye),typeof ze=="boolean"?vt=ze?"on":"off":vt=a(ze,this.defaultValue.strings,Ye),{other:nt,comments:gt,strings:vt}}}var se;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class he extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Y){let pe=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(pe=4,je=Y):Y==="interval"?pe=3:Y==="relative"?pe=2:Y==="on"?pe=1:pe=0),{renderType:pe,renderFn:je}}}function re(_){const Y=_.get(97);return Y==="editable"?_.get(90):Y!=="on"}e.filterValidationDecorations=re;class oe extends k{constructor(){const Y=[],pe={type:"number",description:l.localize(91,null)};super(101,"rulers",Y,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Y,description:l.localize(93,null)})}validate(Y){if(Array.isArray(Y)){const pe=[];for(const je of Y)if(typeof je=="number")pe.push({column:g.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const ze=je;pe.push({column:g.clampedInt(ze.column,0,0,1e4),color:ze.color})}return pe.sort((je,ze)=>je.column-ze.column),pe}return this.defaultValue}}class fe extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function Ie(_,Y){if(typeof _!="string")return Y;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:l.localize(104,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y,je=g.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=g.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:g.clampedInt(pe.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:g.clampedInt(pe.verticalSliderSize,ze,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Y,pe){let je=!1;pe.allowedCharacters&&Y&&(T.$Ym(Y.allowedCharacters,pe.allowedCharacters)||(Y={...Y,allowedCharacters:pe.allowedCharacters},je=!0)),pe.allowedLocales&&Y&&(T.$Ym(Y.allowedLocales,pe.allowedLocales)||(Y={...Y,allowedLocales:pe.allowedLocales},je=!0));const ze=super.applyUpdate(Y,pe);return je?new u(ze.newValue,!0):ze}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,pe){if(typeof Y!="object"||!Y)return pe;const je={};for(const[ze,Ye]of Object.entries(Y))Ye===!0&&(je[ze]=!0);return je}}class G extends k{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:l.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:a(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends k{constructor(){const Y={enabled:L.$Sr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Sr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends k{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Y.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Y.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Y.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,Y,pe){const je=pe.indexOf(_);return je===-1?Y:pe[je]}class ae extends k{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Y.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Y.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertMode:a(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:a(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Le extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,pe,je){return pe.get(2)===2?0:je}}class He extends m{constructor(){super(144)}compute(Y,pe,je){const ze=pe.get(143);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class et extends k{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:a(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ze extends k{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:a(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:_e,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:Oe(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:Oe(new $),accessibilityPageSize:Oe(new g(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:Oe(new n(4,"ariaLabel",l.localize(200,null))),ariaRequired:Oe(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Oe(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:Oe(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:Oe(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:Oe(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:Oe(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:Oe(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:Oe(new i(13,"automaticLayout",!1)),autoSurround:Oe(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:Oe(new Q),bracketPairGuides:Oe(new J),stickyTabStops:Oe(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:Oe(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:Oe(new n(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:Oe(new g(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:Oe(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:Oe(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:Oe(new g(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:Oe(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:Oe(new I),contextmenu:Oe(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:Oe(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:Oe(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:Oe(new o(28,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:l.localize(242,null)})),cursorSurroundingLines:Oe(new g(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:Oe(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:Oe(new g(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:Oe(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new i(34,"domReadOnly",!1)),dragAndDrop:Oe(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:Oe(new V),dropIntoEditor:Oe(new et),stickyScroll:Oe(new ce),experimentalWhitespaceRendering:Oe(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:Oe(new n(39,"extraEditorClassName","")),fastScrollSensitivity:Oe(new b(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:l.localize(253,null)})),find:Oe(new j),fixedOverflowWidgets:Oe(new i(42,"fixedOverflowWidgets",!1)),folding:Oe(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:Oe(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:Oe(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:Oe(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:Oe(new g(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:Oe(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:Oe(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:Oe(new z),fontLigatures2:Oe(new W),fontSize:Oe(new ee),fontWeight:Oe(new X),fontVariations:Oe(new N),formatOnPaste:Oe(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:Oe(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:Oe(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:Oe(new Ee),hideCursorInOverviewRuler:Oe(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:Oe(new De),inDiffEditor:Oe(new i(61,"inDiffEditor",!1)),letterSpacing:Oe(new b(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>b.clamp(_,-5,20),{description:l.localize(267,null)})),lightbulb:Oe(new ye),lineDecorationsWidth:Oe(new ie),lineHeight:Oe(new O),lineNumbers:Oe(new he),lineNumbersMinChars:Oe(new g(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:Oe(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:Oe(new s(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:Oe(new q),mouseStyle:Oe(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new b(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:Oe(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:Oe(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:Oe(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:Oe(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:Oe(new g(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:Oe(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:Oe(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:Oe(new g(82,"overviewRulerLanes",3,0,3)),padding:Oe(new we),pasteAs:Oe(new Ze),parameterHints:Oe(new ve),peekWidgetDefaultFocus:Oe(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:Oe(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:Oe(new ke),quickSuggestionsDelay:Oe(new g(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:Oe(new i(90,"readOnly",!1)),readOnlyMessage:Oe(new fe),renameOnType:Oe(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:Oe(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:Oe(new s(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:Oe(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Oe(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:Oe(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:Oe(new g(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:Oe(new oe),scrollbar:Oe(new F),scrollBeyondLastColumn:Oe(new g(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:Oe(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:Oe(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:Oe(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$k})),selectionHighlight:Oe(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:Oe(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:Oe(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:Oe(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:Oe(new $e),snippetSuggestions:Oe(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:Oe(new Le),smoothScrolling:Oe(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:Oe(new g(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new ae),inlineSuggest:Oe(new G),inlineCompletionsAccessibilityVerbose:Oe(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:Oe(new g(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new g(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:Oe(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:Oe(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:Oe(new g(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new K),unusualLineTerminators:Oe(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:Oe(new i(126,"useShadowDOM",!0)),useTabStops:Oe(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:Oe(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:Oe(new n(129,"wordSeparators",A.$Tr,{description:l.localize(337,null)})),wordWrap:Oe(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:Oe(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new g(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:Oe(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new B),defaultColorDecorators:Oe(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:Oe(new me),tabFocusMode:Oe(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:Oe(new Z),wrappingInfo:Oe(new He),wrappingIndent:Oe(new Qe),wrappingStrategy:Oe(new ue)}}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[168],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[169],Re([1,0,9,140]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var C;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(C||(e.TokenType=C={}));function L(...f){switch(f.length){case 1:return(0,T.localize)(0,null,f[0]);case 2:return(0,T.localize)(1,null,f[0],f[1]);case 3:return(0,T.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,T.localize)(3,null),l=(0,T.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const k=this.d,u=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:u};this.g.push({offset:k,lexeme:u,additionalInfo:P}),this.f.push(p)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const k=this.c.substring(this.d,this.e),u=S.b.get(k);u?this.k(u):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,k=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(l);return}const m=this.c.charCodeAt(P);if(k)k=!1;else if(m===47&&!u){P++;break}else m===91?u=!0:m===92?k=!0:m===93&&(u=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=S}),define(Ae[170],Re([1,0,23,29,142,276]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function S(i){return i=i.trim(),i==="*"||A.test(i)}e.$Ao=S;function f(i){if(!S(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Bo=f;function P(i){if(!i)return null;const c=i.majorBase,g=i.majorMustEqual,D=i.minorBase;let b=i.minorMustEqual;const n=i.patchBase;let a=i.patchMustEqual;i.hasCaret&&(c===0||(b=!1),a=!1);let s=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,y,$,I]=o;s=Date.UTC(Number(y),Number($)-1,Number(I))}}return{majorBase:c,majorMustEqual:g,minorBase:D,minorMustEqual:b,patchBase:n,patchMustEqual:a,isMinimum:i.hasGreaterEquals,notBefore:s}}e.$Co=P;function k(i,c,g){let D;typeof i=="string"?D=P(f(i)):D=i;let b;c instanceof Date?b=c.getTime():typeof c=="string"&&(b=new Date(c).getTime());let n;if(typeof g=="string"?n=P(f(g)):n=g,!D||!n)return!1;const a=D.majorBase,s=D.minorBase,o=D.patchBase;let y=n.majorBase,$=n.minorBase,I=n.patchBase;const E=n.notBefore;let r=n.majorMustEqual,d=n.minorMustEqual,v=n.patchMustEqual;return n.isMinimum?a>y?!0:a<y?!1:s>$?!0:s<$||b&&b<E?!1:o>=I:(a===1&&y===0&&(!r||!d||!v)&&(y=1,$=0,I=0,r=!0,d=!1,v=!1),a<y?!1:a>y?!r:s<$?!1:s>$?!d:o<I?!1:o>I?!v:!(b&&b<E))}e.$Do=k;function u(i,c,g,D,b){const n=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return n.push([T.default.Error,C.localize(0,null)]),n;if(typeof D.name!="string")return n.push([T.default.Error,C.localize(1,null,"name")]),n;if(typeof D.version!="string")return n.push([T.default.Error,C.localize(2,null,"version")]),n;if(!D.engines)return n.push([T.default.Error,C.localize(3,null,"engines")]),n;if(typeof D.engines.vscode!="string")return n.push([T.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof D.extensionDependencies<"u"&&!t(D.extensionDependencies))return n.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof D.activationEvents<"u"){if(!t(D.activationEvents))return n.push([T.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof D.main>"u"&&typeof D.browser>"u")return n.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),n}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&n.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return n.push([T.default.Error,C.localize(9,null,"main")]),n;{const o=(0,w.$hg)(g,D.main);(0,w.$bg)(o,g)||n.push([T.default.Warning,C.localize(10,null,o.path,g.path)])}}if(typeof D.browser<"u"){if(typeof D.browser!="string")return n.push([T.default.Error,C.localize(11,null,"browser")]),n;{const o=(0,w.$hg)(g,D.browser);(0,w.$bg)(o,g)||n.push([T.default.Warning,C.localize(12,null,o.path,g.path)])}}if(!L.valid(D.version))return n.push([T.default.Error,C.localize(13,null)]),n;const a=[];if(!p(i,c,D,b,a))for(const o of a)n.push([T.default.Error,o]);return n}e.$Eo=u;function p(i,c,g,D,b){return D||typeof g.main>"u"&&typeof g.browser>"u"?!0:h(i,c,g.engines.vscode,b)}e.$Fo=p;function m(i,c,g){return i==="*"||h(c,g,i)}e.$Go=m;function h(i,c,g,D=[]){const b=P(f(g));if(!b)return D.push(C.localize(14,null,g)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return D.push(C.localize(15,null,g)),!1}else if(!b.majorMustEqual)return D.push(C.localize(16,null,g)),!1;return k(i,c,b)?!0:(D.push(C.localize(17,null,i,g)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,g=i.length;c<g;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class w{constructor(C,L=[],A=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$xh=w}),define(Ae[70],Re([1,0,69]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.InstantiationType=void 0;const T=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L(l,S,f){S instanceof w.$xh||(S=new w.$xh(S,[],!!f)),T.push([l,S])}e.$kr=L;function A(){return T}e.$lr=A}),define(Ae[171],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class w{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$2p=w;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const l=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(A);l.outgoing.set(S.key,S),S.incoming.set(l.key,l)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let l=this.a.get(A);return l||(l=new w(A,L),this.a.set(A,l)),l}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,l]of this.a)L.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const l=new Set([L]),S=this.c(A,l);if(S)return S}}c(L,A){for(const[l,S]of L.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const f=this.c(S,A);if(f)return f;A.delete(l)}}}e.$3p=T}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(S){return S[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(w||(e._util=w={})),e.$zh=C("instantiationService");function T(A,l,S){l[w.DI_TARGET]===l?l[w.DI_DEPENDENCIES].push({id:A,index:S}):(l[w.DI_DEPENDENCIES]=[{id:A,index:S}],l[w.DI_TARGET]=l)}function C(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const l=function(S,f,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(l,S,P)};return l.toString=()=>A,w.serviceIds.set(A,l),l}e.$Ah=C;function L(A){return A}e.$Bh=L}),define(Ae[43],Re([1,0,16,2,4]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,C.$Ah)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.$8h=L;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof T.URI)}e.$9h=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function S(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=S;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$$h=f;function P(i,c){const g=Object.create(null);for(const D in i)k(g,D,i[D],c);return g}e.$_h=P;function k(i,c,g,D){const b=c.split("."),n=b.pop();let a=i;for(let s=0;s<b.length;s++){const o=b[s];let y=a[o];switch(typeof y){case"undefined":y=a[o]=Object.create(null);break;case"object":break;default:D(`Ignoring ${c} as ${b.slice(0,s+1).join(".")} is ${JSON.stringify(y)}`);return}a=y}if(typeof a=="object"&&a!==null)try{a[n]=g}catch{D(`Ignoring ${c} as ${b.join(".")} is ${JSON.stringify(a)}`)}else D(`Ignoring ${c} as ${b.join(".")} is ${JSON.stringify(a)}`)}e.$ai=k;function u(i,c){const g=c.split(".");p(i,g)}e.$bi=u;function p(i,c){const g=c.shift();if(c.length===0){delete i[g];return}if(Object.keys(i).indexOf(g)!==-1){const D=i[g];typeof D=="object"&&!Array.isArray(D)&&(p(D,c),Object.keys(D).length===0&&delete i[g])}}function m(i,c,g){function D(a,s){let o=a;for(const y of s){if(typeof o!="object"||o===null)return;o=o[y]}return o}const b=c.split("."),n=D(i,b);return typeof n>"u"?g:n}e.$ci=m;function h(i,c,g){Object.keys(c).forEach(D=>{D!=="__proto__"&&(D in i?w.$kf(i[D])&&w.$kf(c[D])?h(i[D],c[D],g):g&&(i[D]=c[D]):i[D]=c[D])})}e.$di=h;function t(i){return i.replace(/[\[\]]/g,"")}e.$ei=t}),define(Ae[32],Re([1,0,22,15,169,4,139,9]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",w.$j),S.set("isLinux",w.$k),S.set("isWindows",w.$i),S.set("isWeb",w.$o),S.set("isMacNative",w.$j&&!w.$o),S.set("isEdge",w.$G),S.set("isFirefox",w.$E),S.set("isChrome",w.$D),S.set("isSafari",w.$F);function f(ie,O){if(S.get(ie)!==void 0)throw(0,l.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(ie,O)}e.$Fi=f;const P=Object.prototype.hasOwnProperty;var k;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const u={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),m=(0,A.localize)(1,null),h=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),g=(0,A.localize)(6,null),D=(0,A.localize)(7,null);class b{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=u){this.k=O,this.d=new C.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const le=this.D(),we=le.type===17?c:void 0;throw this.h.push({message:i,offset:le.offset,lexeme:C.$Ei.getLexeme(le),additionalInfo:we}),b.c}return q}catch(q){if(q!==b.c)throw q;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const q=this.o();O.push(q)}return O.length===1?O[0]:n.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const q=this.s();O.push(q)}return O.length===1?O[0]:n.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,t),q?.negate()}case 17:return this.z(),R.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const q=this.l();return this.A(1,t),q}case 17:{const q=O.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,me=ve.lastIndexOf("/"),ke=me===ve.length-1?void 0:this.w(ve.substring(me+1));let se;try{se=new RegExp(ve.substring(1,me),ke)}catch{throw this.B("REGEX",we)}return z.create(q,se)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let me=this.D(),ke=0;for(let fe=0;fe<we.lexeme.length;fe++)we.lexeme.charCodeAt(fe)===40?ke++:we.lexeme.charCodeAt(fe)===41&&ke--;for(;!this.E()&&me.type!==15&&me.type!==16;){switch(me.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let fe=0;fe<me.lexeme.length;fe++)me.lexeme.charCodeAt(fe)===40?ke++:we.lexeme.charCodeAt(fe)===41&&ke--}if(ke<0)break;ve.push(C.$Ei.getLexeme(me)),this.z(),me=this.D()}const se=ve.join(""),he=se.lastIndexOf("/"),re=he===se.length-1?void 0:this.w(se.substring(he+1));let oe;try{oe=new RegExp(se.substring(1,he),re)}catch{throw this.B("REGEX",we)}return n.regex(q,oe)}case 18:{const ve=we.lexeme;this.z();let me=null;if(!(0,T.$le)(ve)){const ke=ve.indexOf("/"),se=ve.lastIndexOf("/");if(ke!==se&&ke>=0){const he=ve.slice(ke+1,se),re=ve[se+1]==="i"?"i":"";try{me=new RegExp(he,re)}catch{throw this.B("REGEX",we)}}}if(me===null)throw this.B("REGEX",we);return z.create(q,me)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const we=this.u();return n.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return n.equals(q,we);switch(we){case"true":return n.has(q);case"false":return n.not(q);default:return n.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return n.notEquals(q,we);switch(we){case"true":return n.not(q);case"false":return n.has(q);default:return n.notEquals(q,we)}}case 5:return this.z(),W.create(q,this.u());case 6:return this.z(),N.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),j.create(q,this.u());case 13:return this.z(),n.in(q,this.u());default:return n.has(q)}}case 20:throw this.h.push({message:g,offset:O.offset,lexeme:"",additionalInfo:D}),b.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,q){if(this.C(O))return this.z();throw this.B(q,this.D())}B(O,q,le){const we=(0,A.localize)(8,null,O,C.$Ei.getLexeme(q)),ve=q.offset,me=C.$Ei.getLexeme(q);return this.h.push({message:we,offset:ve,lexeme:me,additionalInfo:le}),b.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=b;class n{static false(){return y.INSTANCE}static true(){return $.INSTANCE}static has(O){return I.create(O)}static equals(O,q){return E.create(O,q)}static notEquals(O,q){return v.create(O,q)}static regex(O,q){return z.create(O,q)}static in(O,q){return r.create(O,q)}static notIn(O,q){return d.create(O,q)}static not(O){return R.create(O)}static and(...O){return Ee.create(O,null,!0)}static or(...O){return De.create(O,null,!0)}static greater(O,q){return V.create(O,q)}static greaterEquals(O,q){return j.create(O,q)}static smaller(O,q){return W.create(O,q)}static smallerEquals(O,q){return N.create(O,q)}static{this.c=new b({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Hi=n;function a(ie){const O=new b({regexParsingWithErrorRecovery:!1});return ie.map(q=>(O.parse(q),O.lexingErrors.length>0?O.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,A.localize)(9,null,le.additionalInfo):(0,A.localize)(10,null),offset:le.offset,length:le.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.$Ii=a;function s(ie,O){const q=ie?ie.substituteConstants():void 0,le=O?O.substituteConstants():void 0;return!q&&!le?!0:!q||!le?!1:q.equals(le)}e.$Ji=s;function o(ie,O){return ie.cmp(O)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return $.INSTANCE}}e.$Ki=y;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return y.INSTANCE}}e.$Li=$;class I{static create(O,q=null){const le=S.get(O);return typeof le=="boolean"?le?$.INSTANCE:y.INSTANCE:new I(O,q)}constructor(O,q){this.key=O,this.c=q,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:Z(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=S.get(this.key);return typeof O=="boolean"?O?$.INSTANCE:y.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Mi=I;class E{static create(O,q,le=null){if(typeof q=="boolean")return q?I.create(O,le):R.create(O,le);const we=S.get(O);return typeof we=="boolean"?q===(we?"true":"false")?$.INSTANCE:y.INSTANCE:new E(O,q,le)}constructor(O,q,le){this.c=O,this.d=q,this.f=le,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=S.get(this.c);if(typeof O=="boolean"){const q=O?"true":"false";return this.d===q?$.INSTANCE:y.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ni=E;class r{static create(O,q){return new r(O,q)}constructor(O,q){this.d=O,this.f=q,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const q=O.getValue(this.f),le=O.getValue(this.d);return Array.isArray(q)?q.includes(le):typeof le=="string"&&typeof q=="object"&&q!==null?P.call(q,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.$Oi=r;class d{static create(O,q){return new d(O,q)}constructor(O,q){this.d=O,this.f=q,this.type=11,this.c=r.create(O,q)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=d;class v{static create(O,q,le=null){if(typeof q=="boolean")return q?R.create(O,le):I.create(O,le);const we=S.get(O);return typeof we=="boolean"?q===(we?"true":"false")?y.INSTANCE:$.INSTANCE:new v(O,q,le)}constructor(O,q,le){this.c=O,this.d=q,this.f=le,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=S.get(this.c);if(typeof O=="boolean"){const q=O?"true":"false";return this.d===q?y.INSTANCE:$.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Qi=v;class R{static create(O,q=null){const le=S.get(O);return typeof le=="boolean"?le?y.INSTANCE:$.INSTANCE:new R(O,q)}constructor(O,q){this.c=O,this.d=q,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:Z(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=S.get(this.c);return typeof O=="boolean"?O?y.INSTANCE:$.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Ri=R;function B(ie,O){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?O(ie):y.INSTANCE}class V{static create(O,q,le=null){return B(q,we=>new V(O,we,le))}constructor(O,q,le){this.c=O,this.d=q,this.f=le,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Si=V;class j{static create(O,q,le=null){return B(q,we=>new j(O,we,le))}constructor(O,q,le){this.c=O,this.d=q,this.f=le,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ti=j;class W{static create(O,q,le=null){return B(q,we=>new W(O,we,le))}constructor(O,q,le){this.c=O,this.d=q,this.f=le,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ui=W;class N{static create(O,q,le=null){return B(q,we=>new N(O,we,le))}constructor(O,q,le){this.c=O,this.d=q,this.f=le,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:ue(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Vi=N;class z{static create(O,q){return new z(O,q)}constructor(O,q){this.d=O,this.f=q,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const q=this.f?this.f.source:"",le=O.f?O.f.source:"";return q<le?-1:q>le?1:0}equals(O){if(O.type===this.type){const q=this.f?this.f.source:"",le=O.f?O.f.source:"";return this.d===O.d&&q===le}return!1}substituteConstants(){return this}evaluate(O){const q=O.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Wi=z;class ee{static create(O){return new ee(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ee(this.c.map(O))}negate(){return this.c}}e.$Xi=ee;function X(ie){let O=null;for(let q=0,le=ie.length;q<le;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&O===null){O=[];for(let ve=0;ve<q;ve++)O[ve]=ie[ve]}O!==null&&(O[q]=we)}return O===null?ie:O}class Ee{static create(O,q,le){return Ee.d(O,q,le)}constructor(O,q){this.expr=O,this.c=q,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=o(this.expr[q],O.expr[q]);if(we!==0)return we}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(O.expr[q]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:Ee.create(O,this.c,!1)}evaluate(O){for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].evaluate(O))return!1;return!0}static d(O,q,le){const we=[];let ve=!1;for(const me of O)if(me){if(me.type===1){ve=!0;continue}if(me.type===0)return y.INSTANCE;if(me.type===6){we.push(...me.expr);continue}we.push(me)}if(we.length===0&&ve)return $.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];for(;we.length>1;){const me=we[we.length-1];if(me.type!==9)break;we.pop();const ke=we.pop(),se=we.length===0,he=De.create(me.expr.map(re=>Ee.create([re,ke],null,le)),null,se);he&&(we.push(he),we.sort(o))}if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let ke=me+1;ke<we.length;ke++)if(we[me].negate().equals(we[ke]))return y.INSTANCE;if(we.length===1)return we[0]}return new Ee(we,q)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const q of this.expr)O.push(...q.keys());return O}map(O){return new Ee(this.expr.map(q=>q.map(O)),null)}negate(){if(!this.c){const O=[];for(const q of this.expr)O.push(q.negate());this.c=De.create(O,this,!0)}return this.c}}e.$Yi=Ee;class De{static create(O,q,le){return De.d(O,q,le)}constructor(O,q){this.expr=O,this.c=q,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=o(this.expr[q],O.expr[q]);if(we!==0)return we}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(O.expr[q]))return!1;return!0}return!1}substituteConstants(){const O=X(this.expr);return O===this.expr?this:De.create(O,this.c,!1)}evaluate(O){for(let q=0,le=this.expr.length;q<le;q++)if(this.expr[q].evaluate(O))return!0;return!1}static d(O,q,le){let we=[],ve=!1;if(O){for(let me=0,ke=O.length;me<ke;me++){const se=O[me];if(se){if(se.type===0){ve=!0;continue}if(se.type===1)return $.INSTANCE;if(se.type===9){we=we.concat(se.expr);continue}we.push(se)}}if(we.length===0&&ve)return y.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let ke=me+1;ke<we.length;ke++)if(we[me].negate().equals(we[ke]))return $.INSTANCE;if(we.length===1)return we[0]}return new De(we,q)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const q of this.expr)O.push(...q.keys());return O}map(O){return new De(this.expr.map(q=>q.map(O)),null)}negate(){if(!this.c){const O=[];for(const q of this.expr)O.push(q.negate());for(;O.length>1;){const q=O.shift(),le=O.shift(),we=[];for(const ve of $e(q))for(const me of $e(le))we.push(Ee.create([ve,me],null,!1));O.unshift(De.create(we,null,!1))}this.c=De.create(O,this,!0)}return this.c}}e.$Zi=De;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(O,q,le){super(O,null),this.f=q,typeof le=="object"?Pe.d.push({...le,key:O}):le!==!0&&Pe.d.push({key:O,description:le,type:q!=null?typeof q:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return E.create(this.key,O)}notEqualsTo(O){return v.create(this.key,O)}}e.$1i=Pe,e.$2i=(0,L.$Ah)("contextKeyService");function Z(ie,O){return ie<O?-1:ie>O?1:0}function ue(ie,O,q,le){return ie<q?-1:ie>q?1:O<le?-1:O>le?1:0}function ye(ie,O){if(ie.type===0||O.type===1)return!0;if(ie.type===9)return O.type===9?ce(ie.expr,O.expr):!1;if(O.type===9){for(const q of O.expr)if(ye(ie,q))return!0;return!1}if(ie.type===6){if(O.type===6)return ce(O.expr,ie.expr);for(const q of ie.expr)if(ye(q,O))return!0;return!1}return ie.equals(O)}e.$3i=ye;function ce(ie,O){let q=0,le=0;for(;q<ie.length&&le<O.length;){const we=ie[q].cmp(O[le]);if(we<0)return!1;we===0&&q++,le++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[172],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,w.$Ah)("environmentService"),e.$Ih=(0,w.$Bh)(e.$Hh)}),define(Ae[92],Re([1,0,141,4]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=C;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=L;function A(c,g){switch(c){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=A;function l(c,g){return g==="web"&&!c.includes("web")}e.$Un=l;function S(c,g,D){return l(g,D)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===D?!0:f(D).includes(c)}e.$Vn=S;function f(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=f;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Xn=P;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var u;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var p;(function(c){c.Install="install",c.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var m;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$Yn=(0,T.$Ah)("extensionGalleryService");var h;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(h||(e.ExtensionManagementErrorCode=h={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(g,D){super(g),this.code=D,this.name=D}}e.$Zn=i,e.$1n=(0,T.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,T.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,T.$Ah)("IExtensionTipsService"),e.$6n=(0,w.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,16,2,143,4,22,12]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileKind=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileOperationResult=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileChangeType=e.$jk=e.FileOperation=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileSystemProviderErrorCode=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$6j=e.$5j=void 0,e.$5j=(0,S.$Ah)("fileService");function k(Z){return Z.create===!0}e.$6j=k;var u;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var p;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var m;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function h(Z){return!!(Z.capabilities&2)}e.$7j=h;function t(Z){return!!(Z.capabilities&8)}e.$8j=t;function i(Z){return!!(Z.capabilities&131072)}e.$9j=i;function c(Z){return!!(Z.capabilities&4)}e.$0j=c;function g(Z){return!!(Z.capabilities&16)}e.$$j=g;function D(Z){return h(Z)?!!(Z.capabilities&16384):!1}e.$_j=D;function b(Z){return h(Z)?!!(Z.capabilities&32768):!1}e.$ak=b;function n(Z){return!!(Z.capabilities&65536)}e.$bk=n;function a(Z){return!!(Z.capabilities&2048)}e.$ck=a;var s;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class o extends Error{static create(ue,ye){const ce=new o(ue.toString(),ye);return I(ce,ye),ce}constructor(ue,ye){super(ue),this.code=ye}}e.$dk=o;function y(Z,ue){return o.create(Z,ue)}e.$ek=y;function $(Z){return Z||y((0,l.localize)(0,null),s.Unknown)}e.$fk=$;function I(Z,ue){return Z.name=ue?`${ue} (FileSystemError)`:"FileSystemError",Z}e.$gk=I;function E(Z){if(!Z)return s.Unknown;if(Z instanceof o)return Z.code;const ue=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!ue)return s.Unknown;switch(ue[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$hk=E;function r(Z){if(Z instanceof j)return Z.fileOperationResult;switch(E(Z)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$ik=r;var d;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class v{constructor(ue,ye,ce){this.resource=ue,this.operation=ye,this.target=ce}isOperation(ue){return this.operation===ue}}e.$jk=v;var R;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class B{constructor(ue,ye){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const $e of ue){const ie=ce.get($e.type);switch(ie?ie.push([$e.resource,$e]):ce.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ce)switch($e){case 1:this.a=w.$Gh.forUris(()=>ye),this.a.fill(ie);break;case 0:this.b=w.$Gh.forUris(()=>ye),this.b.fill(ie);break;case 2:this.c=w.$Gh.forUris(()=>ye),this.c.fill(ie);break}}contains(ue,...ye){return this.d(ue,{includeChildren:!1},...ye)}affects(ue,...ye){return this.d(ue,{includeChildren:!0},...ye)}d(ue,ye,...ce){if(!ue)return!1;const $e=ce.length>0;return!!((!$e||ce.includes(1))&&(this.a?.get(ue)||ye.includeChildren&&this.a?.findSuperstr(ue))||(!$e||ce.includes(0))&&(this.b?.get(ue)||ye.includeChildren&&this.b?.findSuperstr(ue))||(!$e||ce.includes(2))&&(this.c?.findSubstr(ue)||ye.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$kk=B;function V(Z,ue,ye){return!Z||!ue||Z===ue||ue.length>Z.length?!1:(ue.charAt(ue.length-1)!==T.sep&&(ue+=T.sep),ye?(0,C.$Me)(Z,ue):Z.indexOf(ue)===0)}e.$lk=V;class j extends Error{constructor(ue,ye,ce){super(ue),this.fileOperationResult=ye,this.options=ce}}e.$mk=j;class W extends j{constructor(ue,ye,ce,$e){super(ue,ye,$e),this.fileOperationResult=ye,this.size=ce}}e.$nk=W;class N extends j{constructor(ue,ye,ce){super(ue,2,ce),this.stat=ye}}e.$ok=N;var z;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$rk="files.associations",e.$sk="files.exclude",e.$tk="files.readonlyInclude",e.$uk="files.readonlyExclude",e.$vk="files.readonlyFromPermissions";var ee;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$wk="";function X(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$xk=X;async function Ee(Z,ue){if(!ue.hasProvider(A.URI.from({scheme:Z.scheme})))return new Promise(ye=>{const ce=ue.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===Z.scheme&&$e.added&&(ce.dispose(),ye())})})}e.$yk=Ee;class De{static{this.KB=1024}static{this.MB=De.KB*De.KB}static{this.GB=De.MB*De.KB}static{this.TB=De.GB*De.KB}static formatSize(ue){return(0,L.$mf)(ue)||(ue=0),ue<De.KB?(0,l.localize)(1,null,ue.toFixed(0)):ue<De.MB?(0,l.localize)(2,null,(ue/De.KB).toFixed(2)):ue<De.GB?(0,l.localize)(3,null,(ue/De.MB).toFixed(2)):ue<De.TB?(0,l.localize)(4,null,(ue/De.GB).toFixed(2)):(0,l.localize)(5,null,(ue/De.TB).toFixed(2))}}e.$zk=De;function Pe(Z){const ue=typeof Z=="string"||Z?.scheme===P.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===P.Schemas.file?1024*De.MB:ue?10*De.MB:f.$o?50*De.MB:1024*De.MB}e.$Ak=Pe}),define(Ae[71],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class w{constructor(...C){this.a=new Map;for(const[L,A]of C)this.set(L,A)}set(C,L){const A=this.a.get(C);return this.a.set(C,L),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$yh=w}),define(Ae[173],Re([1,0,13,9,6,69,171,4,71,174]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;const P=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new S.$yh,i=!1,c,g=P){this.f=t,this.g=i,this.h=c,this.i=g,this.o=new Set,this.f.set(l.$zh,this),this._globalGraph=g?c?._globalGraph??new A.$3p(D=>D):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const c=m.traceInvocation(this.i,t);let g=!1;try{return t({get:b=>{if(g)throw(0,T.$6)("service accessor is only valid during the invocation of its target method");const n=this.m(b,c);if(!n)throw new Error(`[invokeFunction] unknown service '${b}'`);return n}},...i)}finally{g=!0,c.stop()}}createInstance(t,...i){let c,g;return t instanceof L.$xh?(c=m.traceCreation(this.i,t.ctor),g=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=m.traceCreation(this.i,t),g=this.j(t,i,c)),c.stop(),g}j(t,i=[],c){const g=l._util.getServiceDependencies(t).sort((n,a)=>n.index-a.index),D=[];for(const n of g){const a=this.m(n.id,c);a||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),D.push(a)}const b=g.length>0?g[0].index:i.length;if(i.length!==b){console.trace(`[createInstance] First service dependency of ${t.name} at position ${b+1} conflicts with ${i.length} static arguments`);const n=b-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,b)}return Reflect.construct(t,i.concat(D))}k(t,i){if(this.f.get(t)instanceof L.$xh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof L.$xh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const g=new A.$3p(n=>n.id.toString());let D=0;const b=[{id:t,desc:i,_trace:c}];for(;b.length;){const n=b.pop();if(g.lookupOrInsertNode(n),D++>1e3)throw new k(g);for(const a of l._util.getServiceDependencies(n.desc.ctor)){const s=this.l(a.id);if(s||this.u(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(a.id)),s instanceof L.$xh){const o={id:a.id,desc:s,_trace:n._trace.branch(a.id,!0)};g.insertEdge(n,o),b.push(o)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new k(g);break}for(const{data:a}of n){if(this.l(a.id)instanceof L.$xh){const o=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,o)}g.removeNode(a)}}return this.l(t)}s(t,i,c=[],g,D){if(this.f.get(t)instanceof L.$xh)return this.t(t,i,c,g,D);if(this.h)return this.h.s(t,i,c,g,D);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],g,D){if(g){const b=new u(void 0,this.g,this,this.i);b.c=String(t);const n=new Map,a=new w.$Wg(()=>{const s=b.j(i,c,D);for(const[o,y]of n){const $=s[o];if(typeof $=="function")for(const I of y)$.apply(s,I)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!a.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=n.get(o);return I||(I=new f.$sc,n.set(o,I)),(r,d,v)=>{const R=I.push([r,d,v]);return(0,C.$hc)(R)}}if(o in s)return s[o];const y=a.value;let $=y[o];return typeof $!="function"||($=$.bind(y),s[o]=$),$},set(s,o,y){return a.value[o]=y,!0},getPrototypeOf(s){return i.prototype}})}else return this.j(i,c,D)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$4p=u;var p;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(p||(p={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new m(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(t,i){return t?new m(1,i.name):m.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new m(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;m.f+=t;let i=!1;function c(D,b){const n=[],a=new Array(D+1).join("	");for(const[s,o,y]of b.h)if(o&&y){i=!0,n.push(`${a}CREATES -> ${s}`);const $=c(D+1,y);$&&n.push($)}else n.push(`${a}uses -> ${s}`);return n.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(t>2||i)&&m.all.add(g.join(`
`))}}e.$5p=m}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,u.$Ah)("logService"),e.$5i=(0,u.$Ah)("loggerService");function p(){return new Date().toISOString()}function m(r){return(0,f.$mf)(r)}e.$6i=m;var h;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$7i=h.Info;function t(r,d,v){switch(d){case h.Trace:r.trace(v);break;case h.Debug:r.debug(v);break;case h.Info:r.info(v);break;case h.Warning:r.warn(v);break;case h.Error:r.error(v);break;case h.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=t;function i(r,d=!1){let v="";for(let R=0;R<r.length;R++){let B=r[R];if(B instanceof Error&&(B=(0,w.$li)(B,d)),typeof B=="object")try{B=JSON.stringify(B)}catch{}v+=(R>0?" ":"")+B}return v}class c extends L.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new T.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==h.Off&&this.b<=d}}e.$9i=c;class g extends c{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...v){this.f(h.Trace)&&this.g(h.Trace,i([d,...v],!0))}debug(d,...v){this.f(h.Debug)&&this.g(h.Debug,i([d,...v]))}info(d,...v){this.f(h.Info)&&this.g(h.Info,i([d,...v]))}warn(d,...v){this.f(h.Warning)&&this.g(h.Warning,i([d,...v]))}error(d,...v){if(this.f(h.Error))if(d instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=d.stack,this.g(h.Error,i(R))}else this.g(h.Error,i([d,...v]))}flush(){}}e.$0i=g;class D extends c{constructor(d=e.$7i){super(),this.setLevel(d),this.g=!l.$i}trace(d,...v){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...v):console.log(`[main ${p()}]`,d,...v))}debug(d,...v){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...v):console.log(`[main ${p()}]`,d,...v))}info(d,...v){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...v):console.log(`[main ${p()}]`,d,...v))}warn(d,...v){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,d,...v):console.warn(`[main ${p()}]`,d,...v))}error(d,...v){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,d,...v):console.error(`[main ${p()}]`,d,...v))}dispose(){}flush(){}}e.$$i=D;class b extends c{constructor(d=e.$7i,v=!0){super(),this.g=v,this.setLevel(d)}trace(d,...v){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...v):console.log(d,...v))}debug(d,...v){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...v):console.log(d,...v))}info(d,...v){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...v):console.log(d,...v))}warn(d,...v){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...v):console.log(d,...v))}error(d,...v){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...v):console.error(d,...v))}dispose(){}flush(){}}e.$_i=b;class n extends c{constructor(d,v=e.$7i){super(),this.g=d,this.setLevel(v)}trace(d,...v){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(d),...v])}debug(d,...v){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(d),...v])}info(d,...v){this.f(h.Info)&&this.g.log(h.Info,[this.h(d),...v])}warn(d,...v){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(d),...v])}error(d,...v){this.f(h.Error)&&this.g.log(h.Error,[this.h(d),...v])}h(d){return typeof d=="string"?d:(0,w.$li)(d,this.f(h.Trace))}dispose(){}flush(){}}e.$aj=n;class a extends c{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const v of this.g)v.setLevel(d);super.setLevel(d)}trace(d,...v){for(const R of this.g)R.trace(d,...v)}debug(d,...v){for(const R of this.g)R.debug(d,...v)}info(d,...v){for(const R of this.g)R.info(d,...v)}warn(d,...v){for(const R of this.g)R.warn(d,...v)}error(d,...v){for(const R of this.g)R.error(d,...v)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.$bj=a;class s extends L.$jc{constructor(d,v,R){if(super(),this.h=d,this.j=v,this.b=new A.$yi,this.c=this.B(new T.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$ed),this.onDidChangeVisibility=this.g.event,R)for(const B of R)this.b.set(B.resource,{logger:void 0,info:B})}m(d){return(0,f.$if)(d)?[...this.b.values()].find(v=>v.info.id===d):this.b.get(d)}getLogger(d){return this.m(d)?.logger}createLogger(d,v){const R=this.n(d),B=(0,f.$if)(d)?d:v?.id??(0,C.$oi)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const j=v?.logLevel==="always"?h.Trace:v?.logLevel;V||(V=this.s(R,j??this.getLogLevel(R)??this.h,{...v,id:B}));const W={logger:V,info:{resource:R,id:B,logLevel:j,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(W.info),this.b.set(R,W),V}n(d){return(0,f.$if)(d)?(0,S.$hg)(this.j,`${d}.log`):d}setLogLevel(d,v){if(P.URI.isUri(d)){const R=d,B=v,V=this.b.get(R);V&&B!==V.info.logLevel&&(V.info.logLevel=B===this.h?void 0:B,V.logger?.setLevel(B),this.b.set(V.info.resource,V),this.f.fire([R,B]))}else{this.h=d;for(const[R,B]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,v){const R=this.m(d);R&&v!==!R.info.hidden&&(R.info.hidden=!v,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,v]))}getLogLevel(d){let v;return d&&(v=this.b.get(d)?.info.logLevel),v??this.h}registerLogger(d){const v=this.b.get(d.resource);v?v.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const v=this.b.get(d);v&&(v.logger&&v.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=s;class o{constructor(){this.onDidChangeLogLevel=new T.$ed().event}setLevel(d){}getLevel(){return h.Info}trace(d,...v){}debug(d,...v){}info(d,...v){}warn(d,...v){}error(d,...v){}critical(d,...v){}dispose(){}flush(){}}e.$dj=o;class y extends o{}e.$ej=y;function $(r){if(r.verbose)return h.Trace;if(typeof r.logLevel=="string"){const d=E(r.logLevel.toLowerCase());if(d!==void 0)return d}return e.$7i}e.$fj=$;function I(r){switch(r){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.$gj=I;function E(r){switch(r){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$hj=E,e.$ij=new k.$1i("logLevel",I(h.Info))}),define(Ae[175],Re([1,0,6,14]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;class C extends w.$jc{constructor(A,l=[]){super(),this.a=new T.$bj([A,...l]),this.B(A.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$gN=C}),define(Ae[94],Re([1,0,29,144,4]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(S){function f(m,h){return h-m}S.compare=f;const P=Object.create(null);P[S.Error]=(0,T.localize)(0,null),P[S.Warning]=(0,T.localize)(1,null),P[S.Info]=(0,T.localize)(2,null);function k(m){return P[m]||""}S.toString=k;function u(m){switch(m){case w.default.Error:return S.Error;case w.default.Warning:return S.Warning;case w.default.Info:return S.Info;case w.default.Ignore:return S.Hint}}S.fromSeverity=u;function p(m){switch(m){case S.Error:return w.default.Error;case S.Warning:return w.default.Warning;case S.Info:return w.default.Info;case S.Hint:return w.default.Ignore}}S.toSeverity=p}(A||(e.MarkerSeverity=A={}));var l;(function(S){const f="";function P(u){return k(u,!0)}S.makeKey=P;function k(u,p){const m=[f];return u.source?m.push(u.source.replace("\xA6","\\\xA6")):m.push(f),u.code?typeof u.code=="string"?m.push(u.code.replace("\xA6","\\\xA6")):m.push(u.code.value.replace("\xA6","\\\xA6")):m.push(f),u.severity!==void 0&&u.severity!==null?m.push(A.toString(u.severity)):m.push(f),u.message&&p?m.push(u.message.replace("\xA6","\\\xA6")):m.push(f),u.startLineNumber!==void 0&&u.startLineNumber!==null?m.push(u.startLineNumber.toString()):m.push(f),u.startColumn!==void 0&&u.startColumn!==null?m.push(u.startColumn.toString()):m.push(f),u.endLineNumber!==void 0&&u.endLineNumber!==null?m.push(u.endLineNumber.toString()):m.push(f),u.endColumn!==void 0&&u.endColumn!==null?m.push(u.endColumn.toString()):m.push(f),m.push(f),m.join("\xA6")}S.makeKeyOptionalMessage=k})(l||(e.IMarkerData=l={})),e.$1s=(0,C.$Ah)("markerService")}),define(Ae[176],Re([1,0,5,29,4]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Wu=e.Severity=void 0,e.Severity=T.default,e.$Wu=(0,C.$Ah)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class S{constructor(){this.progress=new f,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$Xu=S;class f{infinite(){}done(){}total(k){}worked(k){}}e.$Yu=f}),define(Ae[95],Re([1,0,15,2,4]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GT=e.$FT=e.$ET=e.$DT=e.$CT=void 0,e.$CT=(0,C.$Ah)("openerService");function L(f,P){return T.URI.isUri(f)?(0,w.$Le)(f.scheme,P):(0,w.$Me)(f,P+":")}e.$DT=L;function A(f,...P){return P.some(k=>L(f,k))}e.$ET=A;function l(f,P){return f.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$FT=l;function S(f){let P;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return k&&(P={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},f=f.with({fragment:""})),{selection:P,uri:f}}e.$GT=S}),define(Ae[177],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,w.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,w,T){var C=arguments.length,L=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,w):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(be,e,w,T);else for(var l=be.length-1;l>=0;l--)(A=be[l])&&(L=(C<3?A(L):C>3?A(e,w,L):A(e,w))||L);return C>3&&L&&Object.defineProperty(e,w,L),L},Ve=this&&this.__param||function(be,e){return function(w,T){e(w,T,be)}};define(Ae[72],Re([1,0,13,21,6,4]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.$3u=e.$2u=e.$1u=e.ProgressLocation=e.$Zu=void 0,e.$Zu=(0,L.$Ah)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$1u=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(k,u){this.c=k,this.report=u?.async?this.e.bind(this):this.d.bind(this)}d(k){this.a=k,this.c(this.a)}e(k){Promise.resolve(this.b).finally(()=>{this.a=k;const u=this.c(this.a);this.b=Promise.resolve(u).finally(()=>this.b=void 0)})}}e.$2u=l;let S=class extends C.$jc{constructor(k,u){super(),this.a=new w.$1g,u.withProgress(k,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$hc)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$3u=S,e.$3u=S=Ke([Ve(1,e.$Zu)],S);class f extends C.$jc{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new C.$ic)}start(k){this.stop();const u=++this.a,p=new T.$od;return this.f=setTimeout(()=>{u===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,C.$hc)(()=>clearTimeout(this.f))),this.b.add((0,C.$hc)(()=>p.cancel())),this.b.add((0,C.$hc)(()=>this.c?this.c.done():void 0)),{id:u,token:p.token,stop:()=>this.h(u),isCurrent:()=>this.a===u}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$4u=f,e.$5u=(0,L.$Ah)("editorProgressService")}),define(Ae[30],Re([1,0,50,16]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class C{constructor(){this.a=new Map}add(A,l){w.ok(T.$if(A)),w.ok(T.$kf(l)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$7m=new C}),define(Ae[73],Re([1,0,5,30]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class L{constructor(){this.b=new w.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,f){this.a[C(S)]=f,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;T.$7m.add(e.$8m.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,138,43,73,30]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var f;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$_m={Configuration:"base.contributions.configuration"};var P;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const k=S.$7m.as(l.$8m.JSONContribution);class u{constructor(){this.h=new Set,this.i=new T.$ed,this.onDidSchemaChange=this.i.event,this.j=new T.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(n,a=!0){this.registerConfigurations([n],a)}registerConfigurations(n,a=!0){const s=new Set;this.n(n,a,s),k.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const a=new Set;this.o(n,a),k.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:n,remove:a}){const s=new Set;this.o(a,s),this.n(n,!1,s),k.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const a=new Set;this.k(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(n,a){const s=[];for(const{overrides:o,source:y}of n)for(const $ in o)if(a.add($),e.$jn.test($)){const I=this.a.get($),E=I?.valuesSources??new Map;if(y)for(const R of Object.keys(o[$]))E.set(R,y);const r={...I?.value||{},...o[$]};this.a.set($,{source:y,value:r,valuesSources:E});const d=(0,A.$ei)($),v={type:"object",default:r,description:L.localize(1,null,d),$ref:e.$gn,defaultDefaultValue:r,source:C.$if(y)?void 0:y,defaultValueSource:y};s.push(...h($)),this.d[$]=v,this.b.properties[$]=v}else{this.a.set($,{value:o[$],source:y});const I=this.d[$];I&&(this.w($,I),this.r($,I))}this.m(s)}deregisterDefaultConfigurations(n){const a=new Set;this.l(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(n,a){for(const{overrides:s,source:o}of n)for(const y in s){const $=this.a.get(y),I=C.$if(o)?o:o?.id,E=C.$if($?.source)?$?.source:$?.source?.id;if(I===E)if(a.add(y),this.a.delete(y),e.$jn.test(y))delete this.d[y],delete this.b.properties[y];else{const r=this.d[y];r&&(this.w(y,r),this.r(y,r))}}this.u()}deltaConfiguration(n){let a=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),a=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),a=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const a of n)this.h.add(a);this.u()}n(n,a,s){n.forEach(o=>{this.p(o,a,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(n,a){const s=o=>{if(o.properties)for(const y in o.properties){a.add(y);const $=this.d[y];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>s(y))};for(const o of n){s(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(n,a=!0,s,o,y=3,$){y=C.$rf(n.scope)?y:n.scope;const I=n.properties;if(I)for(const r in I){const d=I[r];if(a&&g(r,d)){delete I[r];continue}if(d.source=s,d.defaultDefaultValue=I[r].default,this.w(r,d),e.$jn.test(r)?d.scope=void 0:(d.scope=C.$rf(d.scope)?y:d.scope,d.restricted=C.$rf(d.restricted)?!!o?.includes(r):d.restricted),I[r].hasOwnProperty("included")&&!I[r].included){this.f[r]=I[r],delete I[r];continue}else this.d[r]=I[r],I[r].policy?.name&&this.e.set(I[r].policy.name,r);!I[r].deprecationMessage&&I[r].markdownDeprecationMessage&&(I[r].deprecationMessage=I[r].markdownDeprecationMessage),$.add(r)}const E=n.allOf;if(E)for(const r of E)this.p(r,a,s,o,y,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const a=s=>{const o=s.properties;if(o)for(const $ in o)this.r($,o[$]);s.allOf?.forEach(a)};a(n)}r(n,a){switch(e.$an.properties[n]=a,a.scope){case 1:e.$bn.properties[n]=a;break;case 2:e.$cn.properties[n]=a;break;case 6:e.$dn.properties[n]=a;break;case 3:e.$en.properties[n]=a;break;case 4:e.$fn.properties[n]=a;break;case 5:e.$fn.properties[n]=a,this.g.properties[n]=a;break}}s(n,a){switch(delete e.$an.properties[n],a.scope){case 1:delete e.$bn.properties[n];break;case 2:delete e.$cn.properties[n];break;case 6:delete e.$dn.properties[n];break;case 3:delete e.$en.properties[n];break;case 4:case 5:delete e.$fn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const a=`[${n}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$gn};this.w(a,s),e.$an.properties[a]=s,e.$bn.properties[a]=s,e.$cn.properties[a]=s,e.$dn.properties[a]=s,e.$en.properties[a]=s,e.$fn.properties[a]=s}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=n,e.$bn.patternProperties[e.$in]=n,e.$cn.patternProperties[e.$in]=n,e.$dn.patternProperties[e.$in]=n,e.$en.patternProperties[e.$in]=n,e.$fn.patternProperties[e.$in]=n,this.i.fire()}w(n,a){const s=this.a.get(n);let o=s?.value,y=s?.source;C.$pf(o)&&(o=a.defaultDefaultValue,y=void 0),C.$pf(o)&&(o=i(a.type)),a.default=o,a.defaultValueSource=y}}const p="\\[([^\\]]+)\\]",m=new RegExp(p,"g");e.$in=`^(${p})+$`,e.$jn=new RegExp(e.$in);function h(b){const n=[];if(e.$jn.test(b)){let a=m.exec(b);for(;a?.length;){const s=a[1].trim();s&&n.push(s),a=m.exec(b)}}return(0,w.$Jb)(n)}e.$kn=h;function t(b){return b.reduce((n,a)=>`${n}[${a}]`,"")}e.$ln=t;function i(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=i;const c=new u;S.$7m.add(e.$_m.Configuration,c);function g(b,n){return b.trim()?e.$jn.test(b)?L.localize(7,null,b):c.getConfigurationProperties()[b]!==void 0?L.localize(8,null,b):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,b,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.$nn=g;function D(){const b=[],n=c.getConfigurationProperties();for(const a of Object.keys(n))b.push([a,n[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.$on=D}),define(Ae[178],Re([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function p(a){return Object.isFrozen(a)?a:l.$Vm(a)}class m{constructor(s={},o=[],y=[],$){this.b=s,this.c=o,this.d=y,this.raw=$,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof m)return o;const y=new h("");return y.parseRaw(o),y.configurationModel});this.f=s.reduce((o,y)=>y===o?y:o.merge(y),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,P.$ci)(this.contents,s):this.contents}inspect(s,o){const y=this.rawConfiguration.getValue(s),$=o?this.rawConfiguration.getOverrideValue(s,o):void 0,I=o?this.rawConfiguration.override(o).getValue(s):y;return{value:y,override:$,merged:I}}getOverrideValue(s,o){const y=this.i(o);return y?s?(0,P.$ci)(y,s):y:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const y of this.overrides)y.identifiers.includes(s)&&o.push(...y.keys);return w.$Jb(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return w.$Jb(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=l.$Um(this.contents),y=l.$Um(this.overrides),$=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const E of s)if(I.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(o,E.contents);for(const r of E.overrides){const[d]=y.filter(v=>w.$sb(v.identifiers,r.identifiers));d?(this.h(d.contents,r.contents),d.keys.push(...r.keys),d.keys=w.$Jb(d.keys)):y.push(l.$Um(r))}for(const r of E.keys)$.indexOf(r)===-1&&$.push(r)}return new m(o,$,y,I.every(E=>E instanceof m)?void 0:I)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const $ of w.$Jb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[$];const E=o[$];E&&(typeof I=="object"&&typeof E=="object"?(I=l.$Um(I),this.h(I,E)):I=E),y[$]=I}return new m(y,this.keys,this.overrides)}h(s,o){for(const y of Object.keys(o)){if(y in s&&S.$kf(s[y])&&S.$kf(o[y])){this.h(s[y],o[y]);continue}s[y]=l.$Um(o[y])}}i(s){let o=null,y=null;const $=I=>{I&&(y?this.h(y,I):y=l.$Um(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===s?o=I.contents:I.identifiers.includes(s)&&$(I.contents);return $(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,P.$bi)(this.contents,s),k.$jn.test(s)&&this.overrides.splice(this.overrides.findIndex(y=>w.$sb(y.identifiers,(0,k.$kn)(s))),1))}j(s,o,y){(0,P.$ai)(this.contents,s,o,$=>console.error($)),y=y||this.keys.indexOf(s)===-1,y&&this.keys.push(s),k.$jn.test(s)&&this.overrides.push({identifiers:(0,k.$kn)(s),keys:Object.keys(this.contents[s]),contents:(0,P.$_h)(this.contents[s],$=>console.error($))})}}e.$pn=m;class h{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!S.$rf(s)){const y=this.g(s);this.parseRaw(y,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:y,keys:$,overrides:I,restricted:E,hasExcludedProperties:r}=this.h(s,o);this.b=new m(y,$,I,r?[s]:void 0),this.c=E||[]}g(s){let o={},y=null,$=[];const I=[],E=[];function r(v){Array.isArray($)?$.push(v):y!==null&&($[y]=v)}const d={onObjectBegin:()=>{const v={};r(v),I.push($),$=v,y=null},onObjectProperty:v=>{y=v},onObjectEnd:()=>{$=I.pop()},onArrayBegin:()=>{const v=[];r(v),I.push($),$=v,y=null},onArrayEnd:()=>{$=I.pop()},onLiteralValue:r,onError:(v,R,B)=>{E.push({error:v,offset:R,length:B})}};if(s)try{C.$Rm(s,d),o=$[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return o}h(s,o){const y=u.$7m.as(k.$_m.Configuration).getConfigurationProperties(),$=this.i(s,y,!0,o);s=$.raw;const I=(0,P.$_h)(s,d=>console.error(`Conflict in settings file ${this.f}: ${d}`)),E=Object.keys(s),r=this.j(s,d=>console.error(`Conflict in settings file ${this.f}: ${d}`));return{contents:I,keys:E,overrides:r,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}i(s,o,y,$){let I=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:I};const E={},r=[];for(const d in s)if(k.$jn.test(d)&&y){const v=this.i(s[d],o,!1,$);E[d]=v.raw,I=I||v.hasExcludedProperties,r.push(...v.restricted)}else{const v=o[d],R=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&r.push(d),!$.exclude?.includes(d)&&($.include?.includes(d)||(R===void 0||$.scopes===void 0||$.scopes.includes(R))&&!($.skipRestricted&&v?.restricted))?E[d]=s[d]:I=!0}return{raw:E,restricted:r,hasExcludedProperties:I}}j(s,o){const y=[];for(const $ of Object.keys(s))if(k.$jn.test($)){const I={};for(const E in s[$])I[E]=s[$][E];y.push({identifiers:(0,k.$kn)($),keys:Object.keys(I),contents:(0,P.$_h)(I,o)})}return y}}e.$qn=h;class t extends L.$jc{constructor(s,o,y,$){super(),this.c=s,this.f=o,this.g=$,this.b=this.B(new T.$ed),this.onDidChange=this.b.event,this.a=new h(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&y.isEqual(I.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=t;class i{constructor(s,o,y,$,I,E,r,d,v,R,B,V,j){this.a=s,this.b=o,this.c=y,this.overrideIdentifiers=$,this.d=I,this.f=E,this.g=r,this.h=d,this.i=v,this.j=R,this.k=B,this.l=V,this.m=j}get value(){return p(this.c)}n(s,o,y){const $=s.inspect(o,y);return{get value(){return p($.value)},get override(){return p($.override)},get merged(){return p($.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,o,y,$,I=new m,E=new m,r=new A.$yi,d=new m,v=new A.$yi){this.c=s,this.d=o,this.f=y,this.g=$,this.h=I,this.i=E,this.j=r,this.l=d,this.m=v,this.a=null,this.b=new A.$yi,this.n=null}getValue(s,o,y){return this.q(s,o,y).getValue(s)}updateValue(s,o,y={}){let $;y.resource?($=this.m.get(y.resource),$||($=new m,this.m.set(y.resource,$))):$=this.l,o===void 0?$.removeValue(s):$.setValue(s,o),y.resource||(this.a=null)}inspect(s,o,y){const $=this.q(s,o,y),I=this.u(o.resource,y),E=o.resource?this.m.get(o.resource)||this.l:this.l,r=new Set;for(const d of $.overrides)for(const v of d.identifiers)$.getOverrideValue(s,v)!==void 0&&r.add(v);return new i(s,o,$.getValue(s),r.size?[...r]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,I||void 0,E)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const y=[];if(!o){const{added:$,updated:I,removed:E}=b(this.c,s);o=[...$,...I,...E]}for(const $ of o)for(const I of(0,k.$kn)($)){const E=this.c.getKeysForOverrideIdentifier(I),r=s.getKeysForOverrideIdentifier(I),d=[...r.filter(v=>E.indexOf(v)===-1),...E.filter(v=>r.indexOf(v)===-1),...E.filter(v=>!l.$Ym(this.c.override(I).getValue(v),s.override(I).getValue(v)))];y.push([I,d])}return this.updateDefaultConfiguration(s),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:y,removed:$}=b(this.d,s),I=[...o,...y,...$];return I.length&&this.updatePolicyConfiguration(s),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:y,removed:$,overrides:I}=b(this.applicationConfiguration,s),E=[...o,...y,...$];return E.length&&this.updateApplicationConfiguration(s),{keys:E,overrides:I}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:y,removed:$,overrides:I}=b(this.localUserConfiguration,s),E=[...o,...y,...$];return E.length&&this.updateLocalUserConfiguration(s),{keys:E,overrides:I}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:y,removed:$,overrides:I}=b(this.remoteUserConfiguration,s),E=[...o,...y,...$];return E.length&&this.updateRemoteUserConfiguration(s),{keys:E,overrides:I}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:y,removed:$,overrides:I}=b(this.workspaceConfiguration,s),E=[...o,...y,...$];return E.length&&this.updateWorkspaceConfiguration(s),{keys:E,overrides:I}}compareAndUpdateFolderConfiguration(s,o){const y=this.p.get(s),{added:$,updated:I,removed:E,overrides:r}=b(y,o),d=[...$,...I,...E];return(d.length||!y)&&this.updateFolderConfiguration(s,o),{keys:d,overrides:r}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:y,updated:$,removed:I,overrides:E}=b(o,void 0);return{keys:[...y,...$,...I],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,y){let $=this.r(o,y);return o.overrideIdentifier&&($=$.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&($=$.merge(this.d)),$}r({resource:s},o){let y=this.s();if(o&&s){const $=o.getFolder(s);$&&(y=this.t($.uri)||y);const I=this.m.get(s);I&&(y=y.merge(I))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const y=this.s(),$=this.j.get(s);$?(o=y.merge($),this.b.set(s,o)):o=y}return o}u(s,o){if(o&&s){const y=o.getFolder(s);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:y,overrides:$,keys:I}=this.j.get(o);return s.push([o,{contents:y,overrides:$,keys:I}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach(y=>s.add(y))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>s.add(y))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(s).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(s).forEach($=>o.add($))),[...o.values()]}static parse(s){const o=this.x(s.defaults),y=this.x(s.policy),$=this.x(s.application),I=this.x(s.user),E=this.x(s.workspace),r=s.folders.reduce((d,v)=>(d.set(f.URI.revive(v[0]),this.x(v[1])),d),new A.$yi);return new c(o,y,$,I,new m,E,r,new m,new A.$yi)}static x(s){return new m(s.contents,s.keys,s.overrides)}}e.$sn=c;function g(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const s=new Set,o=new Map;for(const $ of a)$.keys.forEach(I=>s.add(I)),$.overrides.forEach(([I,E])=>{const r=(0,A.$vi)(o,I,new Set);E.forEach(d=>r.add(d))});const y=[];return o.forEach(($,I)=>y.push([I,[...$.values()]])),{keys:[...s.values()],overrides:y}}e.$tn=g;class D{constructor(s,o,y,$){this.change=s,this.f=o,this.g=y,this.h=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of s.keys)this.affectedKeys.add(I);for(const[,I]of s.overrides)for(const E of I)this.affectedKeys.add(E);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,o){const y=this.a+s,$=this.d.indexOf(y);if($<0)return!1;const I=$+y.length;if(I>=this.d.length)return!1;const E=this.d.charCodeAt(I);if(E!==this.b&&E!==this.c)return!1;if(o){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,d=this.g.getValue(s,o,this.h);return!l.$Ym(r,d)}return!0}}e.$un=D;function b(a,s){const{added:o,removed:y,updated:$}=n(s?.rawConfiguration,a?.rawConfiguration),I=[],E=a?.getAllOverrideIdentifiers()||[],r=s?.getAllOverrideIdentifiers()||[];if(s){const d=r.filter(v=>!E.includes(v));for(const v of d)I.push([v,s.getKeysForOverrideIdentifier(v)])}if(a){const d=E.filter(v=>!r.includes(v));for(const v of d)I.push([v,a.getKeysForOverrideIdentifier(v)])}if(s&&a){for(const d of E)if(r.includes(d)){const v=n({contents:a.getOverrideValue(void 0,d)||{},keys:a.getKeysForOverrideIdentifier(d)},{contents:s.getOverrideValue(void 0,d)||{},keys:s.getKeysForOverrideIdentifier(d)});I.push([d,[...v.added,...v.removed,...v.updated]])}}return{added:o,removed:y,updated:$,overrides:I}}function n(a,s){const o=a?s?a.keys.filter(I=>s.keys.indexOf(I)===-1):[...a.keys]:[],y=s?a?s.keys.filter(I=>a.keys.indexOf(I)===-1):[...s.keys]:[],$=[];if(a&&s){for(const I of s.keys)if(a.keys.indexOf(I)!==-1){const E=(0,P.$ci)(s.contents,I),r=(0,P.$ci)(a.contents,I);l.$Ym(E,r)||$.push(I)}}return{added:o,removed:y,updated:$}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.RemoteAuthorityResolverErrorCode=e.$Kk=e.$Jk=e.RemoteConnectionType=e.$Ik=void 0,e.$Ik=(0,T.$Ah)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Jk=L;class A{constructor(k,u){this.host=k,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Kk=A;var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class S extends w.$_{static isNotAvailable(k){return k instanceof S&&k._code===l.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===l.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===l.NoResolverFound}static isInvalidAuthority(k){return k instanceof S&&k._code===l.InvalidAuthority}static isHandled(k){return k instanceof S&&k.isHandled}constructor(k,u=l.Unknown,p){super(k),this._message=k,this._code=u,this._detail=p,this.isHandled=u===l.NotAvailable&&p===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Lk=S;function f(P){const k=P.indexOf("+");return k===-1?P:P.substring(0,k)}e.$Mk=f}),define(Ae[51],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function T(f){return f.scheme===w.Schemas.vscodeRemote?f.authority:void 0}e.$Nk=T;function C(f){if(!f)return;const P=f.indexOf("+");return P<0?f:f.substr(0,P)}e.$Ok=C;function L(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Pk=L;function A(f){const{host:P,port:k}=S(f);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:k}}e.$Qk=A;function l(f,P){let{host:k,port:u}=S(f);return typeof u>"u"&&(u=P),{host:k,port:u}}e.$Rk=l;function S(f){const P=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const k=f.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const u=f.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:f,port:void 0}}}),define(Ae[20],Re([1,0,15,4,51]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Sl=L,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class S{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,g=typeof i=="string"?i:i.value;return w.$Le(c,g)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Ul=S;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(S.toKey(t))}delete(t){return this.c.delete(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}}e.$Vl=f;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(S.toKey(t))}get(t){return this.c.get(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}set(t,i){this.c.set(S.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=P;function k(h){return u(h)}e.$Xl=k;function u(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.$Yl=u;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.$Zl=p;function m(h,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Ok)(t)}`;return!!h.activationEvents?.includes(i)}return!1}e.$1l=m,e.$2l=(0,T.$Ah)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const S of A){const f=this.readActivationEvents(S);f.length>0&&(l[T.$Ul.toKey(S.identifier)]=f)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const S in A.contributes){const f=this.a.get(S);if(!f)continue;const P=A.contributes[S],k=Array.isArray(P)?P:[P];try{f(k,l)}catch(u){(0,w.$Y)(u)}}return l}}e.$xF=C,e.$yF=new C}),define(Ae[179],Re([1,0,22,74,36]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function L(S){if(w.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function A(S,f,P,k,u,p,m,h){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$3f)()+Date.now(),t.commitHash=k,t.version=u,t["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$h)(w.$t),t["common.nodePlatform"]=T.$2d,t["common.nodeArch"]=P,t["common.product"]=h||"desktop",m&&(t["common.msftInternal"]=m);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$l&&(t["common.snap"]="true");const g=L(f);return g&&(t["common.platformDetail"]=g),t}e.$9n=A;function l(S){const f=T.env.USERDNSDOMAIN;if(!f)return!1;const P=f.toLowerCase();return S.some(k=>P===k)}e.$0n=l}),define(Ae[180],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,w.$Ah)("telemetryService"),e.$9k=(0,w.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[52],Re([1,0,24,16,5,43,51,179,180]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class f{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$$n=f;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=P,e.$ao=new P;class k{async publicLog(y,$,I){}async publicLogError(y,$,I){}}e.$bo=k,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function u(o,y){return C.Event.debounce(y.onDidChangeConfiguration,(I,E)=>{const r=I?new Set([...I.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:r}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.$0h)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$fo=u;function p(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry||y.extensionTestsLocationURI)}e.$go=p;function m(o,y){return!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$ho=m;function h(o){const y=o.getValue(S.$cl),$=o.getValue(S.$dl);if(o.getValue(S.$el)===!1||$===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=h;function t(o){const y={},$={},I={};g(o,I);for(let E in I){E=E.length>150?E.substr(E.length-149):E;const r=I[E];typeof r=="number"?$[E]=r:typeof r=="boolean"?$[E]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${r.length}`),y[E]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(y[E]=r)}return{properties:y,measurements:$}}e.$jo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const y=(0,A.$Ok)(o);return i.has(y)?y:"other"}e.$ko=c;function g(o,y,$=0,I){if(o)for(const E of Object.getOwnPropertyNames(o)){const r=o[E],d=I?I+E:E;Array.isArray(r)?y[d]=(0,w.$Zm)(r):r instanceof Date?y[d]=r.toISOString():(0,T.$kf)(r)?$<2?g(r,y,$+1,d+"."):y[d]=(0,w.$Zm)(r):y[d]=r}}function D(o,y){const $=o.msftInternalDomains||[],I=y.getValue("telemetry.internalTesting");return(0,l.$0n)($)||I}e.$lo=D;function b(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$mo=b;function n(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let $=o;const I=[];for(const v of y)for(;;){const R=v.exec(o);if(!R)break;I.push([R.index,v.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for($="";;){const v=r.exec(o);if(!v)break;const R=I.some(([B,V])=>v.index<V&&B<r.lastIndex);!E.test(v[0])&&!R&&($+=o.substring(d,v.index)+"<REDACTED: user-file-path>",d=r.lastIndex)}return d<o.length&&($+=o.substr(d)),$}function a(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const $ of y)if($.regex.test(o))return`<REDACTED: ${$.label}>`;return o}function s(o,y){return(0,w.$Wm)(o,$=>{if($ instanceof f||Object.hasOwnProperty.call($,"isTrustedTelemetryValue"))return $.value;if(typeof $=="string"){let I=$.replaceAll("%20"," ");I=n(I,y);for(const E of y)I=I.replace(E,"");return I=a(I),I}})}e.$no=s}),define(Ae[181],Re([1,0,15,92,20,22,2,9,74,52]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function P(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,w.$Ge)(s.id,o.id)===0}e.$oo=P;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(o){const y=o.manifest?o.manifest.version:o.version,$=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new u(o.identifier,y,$)}static parse(o){const y=k.exec(o);return y&&y[1]&&y[2]?new u({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,$="undefined"){this.version=y,this.targetPlatform=$,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof u?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$po=u;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(s){const o=p.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.$qo=m;function h(s,o){return`${s}.${o}`}e.$ro=h;function t(s){return s.toLowerCase()}e.$so=t;function i(s,o){return t(h(s??C.$Ql,o))}e.$to=i;function c(s,o){const y=[],$=I=>{for(const E of y)if(E.some(r=>P(o(r),o(I))))return E;return null};for(const I of s){const E=$(I);E?E.push(I):y.push([I])}return y}e.$uo=c;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$vo=g;function D(s){return{id:new f.$$n(s.identifier.id),name:new f.$$n(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$wo=D,e.$xo=new C.$Ul("pprice.better-merge");function b(s,o){const y=[],$=o.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const I=$.shift();if(I&&y.every(E=>!P(E.identifier,{id:I}))){const E=s.filter(r=>P(r.identifier,{id:I}));E.length===1&&(y.push(E[0]),$.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$yo=b;async function n(s,o){if(!L.$k)return!1;let y;try{y=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$8)(I))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(s,o){const y=await n(s,o),$=(0,T.$Tn)(y?"alpine":L.$t,S.$3d);return o.debug("ComputeTargetPlatform:",$),$}e.$zo=a}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.$ar=e.$_q=e.$$q=void 0;function w(S){return[...S.entries()]}e.$$q=w;function T(S){return S?[...S.entries()]:[]}e.$_q=T;function C(S){return new Map(S)}e.$ar=C;function L(S){return new Map(S??[])}e.$br=L;function A(S){return Array.from(S.entries()).map(f=>[f[0],w(f[1].map),T(f[1].descriptionMap)])}e.$cr=A;function l(S){return new Map(S.map(f=>[f[0],{map:C(f[1]),descriptionMap:L(f[2])}]))}e.$dr=l}),define(Ae[183],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,L,A=5){const l=L(S=>{const f=typeof S=="string"?S:S.data;let P=this.a.get(C);if(P){P.data.push(f);return}const k=setTimeout(()=>this.flushBuffer(C),A);P={data:[f],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),l.dispose()}},this.a.set(C,P)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const L=this.a.get(C);L&&(this.a.delete(C),this.b(C,L.data.join("")))}}e.$Ckb=w}),define(Ae[184],Re([1,0,13,89,40,5,16,2,145,73,30]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.IconFontDefinition=e.IconContribution=e.$6u=void 0,e.$6u={IconContribution:"base.contributions.icons"};var k;(function(D){function b(n,a){let s=n.defaults;for(;C.ThemeIcon.isThemeIcon(s);){const o=m.getIcon(s.id);if(!o)return;s=o.defaults}return s}D.getDefinition=b})(k||(e.IconContribution=k={}));var u;(function(D){function b(a){return{weight:a.weight,style:a.style,src:a.src.map(s=>({format:s.format,location:s.location.toString()}))}}D.toJSONObject=b;function n(a){const s=o=>(0,A.$if)(o)?o:void 0;if(a&&Array.isArray(a.src)&&a.src.every(o=>(0,A.$if)(o.format)&&(0,A.$if)(o.location)))return{weight:s(a.weight),style:s(a.style),src:a.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}D.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class p{constructor(){this.a=new L.$ed,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,n,a,s){const o=this.b[b];if(o){if(a&&!o.description){o.description=a,this.d.properties[b].markdownDescription=`${a} $(${b})`;const I=this.e.enum.indexOf(b);I!==-1&&(this.e.enumDescriptions[I]=a),this.a.fire()}return o}const y={id:b,description:a,defaults:n,deprecationMessage:s};this.b[b]=y;const $={$ref:"#/definitions/icons"};return s&&($.deprecationMessage=s),a&&($.markdownDescription=`${a}: $(${b})`),this.d.properties[b]=$,this.e.enum.push(b),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const n=this.e.enum.indexOf(b);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,n){const a=this.f[b];return a||(this.f[b]=n,this.a.fire(),n)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(o,y)=>o.id.localeCompare(y.id),n=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(y=>!!y.description).sort(b))a.push(`|<i class="${n(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const o of s.filter(y=>!C.ThemeIcon.isThemeIcon(y.defaults)).sort(b))a.push(`|<i class="${n(o)}"></i>|${o.id}|`);return a.join(`
`)}}const m=new p;P.$7m.add(e.$6u.IconContribution,m);function h(D,b,n,a){return m.registerIcon(D,b,n,a)}e.$7u=h;function t(){return m}e.$8u=t;function i(){const D=(0,T.$Mj)();for(const b in D){const n="\\"+D[b].toString(16);m.registerIcon(b,{fontCharacter:n})}}i(),e.$9u="vscode://schemas/icons";const c=P.$7m.as(f.$8m.JSONContribution);c.registerSchema(e.$9u,m.getIconSchema());const g=new w.$Rg(()=>c.notifySchemaChanged(e.$9u),200);m.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.$0u=h("widget-close",T.$Oj.close,(0,S.localize)(2,null)),e.$$u=h("goto-previous-location",T.$Oj.arrowUp,(0,S.localize)(3,null)),e.$_u=h("goto-next-location",T.$Oj.arrowDown,(0,S.localize)(4,null)),e.$av=C.ThemeIcon.modify(T.$Oj.sync,"spin"),e.$bv=C.ThemeIcon.modify(T.$Oj.loading,"spin")}),define(Ae[185],Re([1,0,5,43,4,14]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.ProvidedOnAutoForward=e.$Vz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Uz=e.$Tz=void 0,e.$Tz=(0,C.$Ah)("tunnelService"),e.$Uz=(0,C.$Ah)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function S(t){return!!t.forwardPort}e.$Vz=S;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$Wz=P,e.$Xz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$Xz.indexOf(t)>=0}e.$Yz=k,e.$Zz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$Zz.indexOf(t)>=0}e.$1z=u;function p(t,i,c,g){if(c===1)return!1;if(c===2&&u(i)){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(D?.length===4&&parseInt(D[1])>=18)return!1}return t<1024}e.$2z=p;class m{constructor(i,c,g){this.remoteAddress=i,this.localAddress=c,this.b=g,this.a=new w.$ed,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$3z=m;let h=class{constructor(i,c){this.j=i,this.k=c,this.a=new w.$ed,this.onTunnelOpened=this.a.event,this.b=new w.$ed,this.onTunnelClosed=this.b.event,this.c=new w.$ed,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const g of c){const D=Array.from(g.values());for(const b of D){const n=await b.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(g=>typeof g!="string"?g?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,g,D,b){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:g,privacy:D,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(u(i)||k(i))&&(i=e.$Xz[0]);const g=this.r(i,c);if(g)return++g.refcount,g.value}openTunnel(i,c,g,D,b,n=!1,a,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${g} on local port ${b}.`);const o=this.f??i;if(!o)return;if(c||(c="localhost"),D||(D=this.l),this.f&&this.i.has(g)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,c,g,D,b,n,a,s);return y?y.then($=>{if($){if(typeof $=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,g),$}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,g);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n($);return($.tunnelRemoteHost!==c||$.tunnelRemotePort!==g)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&$.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const g=c.get(i.tunnelRemotePort);g&&(g.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,g))}}}}async o(i,c,g){if(g.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const D=g.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),D}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const g=this.e.get(i);if(g&&g.has(c)){const D=g.get(c);D.refcount=0,await this.o(i,c,D)}}p(i,c,g){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:g})}async q(i,c){const g=this.e.get(i);if(g){const D=g.get(c),b=D?await D.value:void 0;(!b||typeof b=="string")&&g.delete(c),g.size===0&&this.e.delete(i)}}r(i,c){const g=[i];k(i)?(g.push(...e.$Xz),g.push(...e.$Zz)):u(i)&&g.push(...e.$Zz);const D=g.map(b=>this.e.get(b));for(const b of D){const n=b?.get(c);if(n)return n}}canTunnel(i){return!!P(i)}t(i,c,g,D,b,n,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${g} on local port ${D}.`);const s=g;this.i.add(s);const o=D===void 0?g:D,y={elevationRequired:b?this.isPortPrivileged(o):!1},$={remoteAddress:{host:c,port:g},localAddressPort:D,privacy:n,public:n?n!==l.Private:void 0,protocol:a},I=i.forwardPort($,y);return I?(this.p(c,g,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),I}};e.$4z=h,e.$4z=h=Ke([Ve(0,L.$4i),Ve(1,T.$7h)],h)}),define(Ae[186],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$5z=void 0,e.$5z=(0,w.$Ah)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Ae[187],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=void 0;function T(S){return S.scheme!==w.Schemas.file&&S.scheme!==w.Schemas.vscodeRemote}e.$kJ=T;function C(S){if(S.folders.length)return S.folders.every(f=>T(f.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.$lJ=C;function L(S){return C(S)?.scheme}e.$mJ=L;function A(S){return C(S)?.authority}e.$nJ=A;function l(S){return C(S)!==void 0}e.$oJ=l}),define(Ae[53],Re([1,0,146,19,48,23,2,4,12]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,l.$Ah)("contextService");function f(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.uri)}e.$Kh=f;function P(o){return typeof o?.id=="string"&&!f(o)&&!u(o)}e.$Lh=P,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function k(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,T.$_d)(o)}:y?e.$Mh:e.$Nh;const $=o;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}e.$Oh=k;function u(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.configPath)}e.$Ph=u;function p(o){const y=o;if(y?.uri)return{id:y.id,uri:A.URI.revive(y.uri)};const $=o;if($?.configPath)return{id:$.id,configPath:A.URI.revive($.configPath)};if(o?.id)return{id:o.id}}e.$Qh=p;var m;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function h(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$Rh=h;function t(o){const y=o;return!!(y&&typeof y=="object"&&A.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$Sh=t;class i{constructor(y,$,I,E,r){this.h=y,this.j=I,this.k=E,this.l=r,this.c=C.$Gh.forUris(this.l,()=>!0),this.folders=$}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=C.$Gh.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=i;class c{constructor(y,$){this.raw=$,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,L.$hg)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=c;function g(o){return new c({uri:o,index:0,name:(0,L.$dg)(o)},{uri:o.toString()})}e.$Vh=g,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,w.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function D(o,y){return L.$$f.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$1h=D;function b(o){let y;return A.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===S.Schemas.tmp}e.$2h=b,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$3h}e.$4h=n;function a(o,y){return!D(o,y)&&!b(o)}e.$5h=a;function s(o){return(typeof o=="string"?(0,T.$ae)(o):(0,L.$fg)(o))===e.$Xh}e.$6h=s}),define(Ae[54],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const L=this.c++;return this.b.set(L,C),this.e(),L}get(C,L){return this.b.has(C)?this.b.get(C)[L]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Iac=w}),define(Ae[39],Re([1,0,12,23,4]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=e.$Kac=void 0;class L{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new T.$9f(l=>{const S=this.b.get(l.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(l,S){S===null?this.b.delete(l.scheme):this.b.set(l.scheme,S)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$Kac=L,e.$Lac=(0,C.$Ah)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=void 0,e.$_L=(0,w.$Ah)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,151,14,175,27]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;let A=class extends C.$gN{constructor(S,f,P){const k=P.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",u=P.remote.isRemote?(0,w.localize)(0,null):S?(0,w.localize)(1,null):(0,w.localize)(2,null);super(f.createLogger(k,{name:u}))}};e.$Rcc=A,e.$Rcc=A=Ke([Ve(1,T.$5i),Ve(2,L.$_L)],A)}),define(Ae[189],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=e.$bbc=void 0;class T{constructor(A,l,S){this.h=new Map,this.a=A,this.b=l,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new w.$Rg(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of f.values())P.complete()}catch(P){for(const k of f.values())k.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let S=this.f[A];return typeof S>"u"&&(S=l),S}update(A,l){this.f[A]=l;const S=this.h.get(A);if(S!==void 0)return S.p;const f=new w.$1g;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$bbc=T;class C extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$cbc=C}),define(Ae[190],Re([1,0,5,2]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class C{constructor(A){this.c=A,this.a=new w.$ed,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$ed,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,S,f){const k=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(l.value,S,f);this.b.fire(k)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$Acc=C}),define(Ae[17],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=void 0,e.$VL=(0,w.$Ah)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$WL=T}),define(Ae[191],Re([1,0,20,5]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=void 0;class C{#e;constructor(A,l){this.b=new T.$ed,this.onDidChange=this.b.event,this.a=w.$Ul.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(S=>{S.extensionId===this.a&&this.b.fire({key:S.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$nbc=C}),define(Ae[55],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=void 0,e.$Vac=(0,w.$Ah)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Wac=T}),define(Ae[192],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybb=e.$Xbb=void 0;class T{constructor(){this.buffers=[]}add(S){let f=this.buffers.indexOf(S);return f<0&&(f=this.buffers.length,this.buffers.push(S)),f}}function C(l,S){if(S.serializeBuffersForPostMessage){const f=new T,k=JSON.stringify(l,(p,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add(m)};if(ArrayBuffer.isView(m)){const h=L(m);if(h)return{$$vscode_array_buffer_reference$$:!0,index:f.add(m.buffer),view:{type:h,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),u=f.buffers.map(p=>{const m=new Uint8Array(p);return w.$Ed.wrap(m)});return{message:k,buffers:u}}else return{message:JSON.stringify(l),buffers:[]}}e.$Xbb=C;function L(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,S){const f=S.map(u=>{const p=new ArrayBuffer(u.byteLength);return new Uint8Array(p).set(u.buffer),p}),P=S.length?(u,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const m=p,{index:h}=m,t=f[h];if(m.view)switch(m.view.type){case 1:return new Int8Array(t,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(l,P),arrayBuffers:f}}e.$Ybb=A}),define(Ae[99],Re([1,0,160,16,2,6,4,30,38,12,41,128,29]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=e.$2E=e.EditorsOrder=e.$1E=e.CloseDirection=e.$ZE=e.$YE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.EditorInputCapabilities=e.$PE=e.SaveReason=e.Verbosity=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var p;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var m;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function h(ce){const $e=ce;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$IE=h;function t(ce,$e,ie){for(const O of ie.visibleEditorPanes)if(O.group.id===$e&&ce.matches(O.input))return O.getViewState()}e.$JE=t;function i(ce){if($(ce))return!1;const $e=ce;return C.URI.isUri($e?.resource)}e.$KE=i;function c(ce){if($(ce))return!1;const $e=ce;return $e?.original!==void 0&&$e.modified!==void 0}e.$LE=c;function g(ce){if($(ce)||c(ce))return!1;const $e=ce;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$ME=g;function D(ce){if($(ce))return!1;const $e=ce;return $e?$e.resource===void 0||$e.resource.scheme===f.Schemas.untitled||$e.forceUntitled===!0:!1}e.$NE=D;function b(ce){if($(ce))return!1;const $e=ce;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$OE=b;var n;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var a;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class s{constructor(){this.a=new Map}registerSource($e,ie){let O=this.a.get($e);return O||(O={source:$e,label:ie},this.a.set($e,O)),O.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$PE=new s;var o;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends L.$jc{}e.$QE=y;function $(ce){return ce instanceof y}e.$RE=$;function I(ce){const $e=ce;return C.URI.isUri($e?.preferredResource)}function E(ce){const $e=ce;return $($e?.primary)&&$($e?.secondary)}e.$SE=E;function r(ce){const $e=ce;return $($e?.modified)&&$($e?.original)}e.$TE=r;function d(ce,$e,ie,O,q){return ye(O,[(0,k.$ki)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const le={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor($e,le)}}),(0,k.$ki)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$UE=d;function v(ce){return $(ce?.editor)}e.$VE=v;function R(ce){const $e=ce;return v(ce)&&$e?.group!==void 0}e.$WE=R;function B(ce){const $e=ce;return typeof $e?.groupId=="number"&&$($e.editor)}e.$XE=B;var V;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var j;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var W;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class N{getOriginalUri($e,ie){if(!$e)return;if(b($e))return e.$ZE.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:le}}if(c($e)||g($e)||b($e))return;const O=I($e)?$e.preferredResource:$e.resource;return!O||!ie||!ie.filterByScheme?O:this.b(O,ie.filterByScheme)}a($e){return E($e)||g($e)?{primary:$e.primary,secondary:$e.secondary}:r($e)||c($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if(b($e))return e.$ZE.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:le}}if(c($e)||g($e)||b($e))return;const O=$e.resource;return!O||!ie||!ie.filterByScheme?O:this.b(O,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(O=>$e.scheme===O))return $e}else if(ie===$e.scheme)return $e}}var z;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function ee(ce,$e,ie,O){if(!ce.isSticky($e))return!1;switch(O.preventPinnedEditorClose){case"keyboardAndMouse":return ie===z.MOUSE||ie===z.KEYBOARD;case"mouse":return ie===z.MOUSE;case"keyboard":return ie===z.KEYBOARD}return!1}e.$YE=ee,e.$ZE=new N;var X;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$zh);for(const[O,q]of this.c)this.e(O,q,ie);this.c.clear()}e($e,ie,O){const q=O.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,T.$tf)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,L.$hc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}l.$7m.add(e.$DE.EditorFactory,new Ee);async function De(ce,$e,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async O=>{const q=C.URI.revive(O.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",O);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",O);return}let we=O.exists,ve=O.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(q)).isDirectory?S.FileType.Directory:S.FileType.Unknown,we=!0}catch(ke){ie.error(ke),we=!1}if(!we&&O.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",O);return}if(ve===S.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",O);return}const me={...O.options,pinned:!0};return we?{resource:q,options:me}:{resource:q,options:me,forceUntitled:!0}}))}e.$1E=De;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function Z(ce){const $e=ce;if(!$e)return!1;const ie=$e;if(ie.modified)return Z(ie.modified);const O=$e;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.$2E=Z;function ue(ce){return(0,P.$mi)(ce)}e.$3E=ue;function ye(ce,$e,ie){const O=(0,P.$ni)(ce,$e);return O.forceMessage=ie?.forceMessage,O.forceSeverity=ie?.forceSeverity,O.allowDialog=ie?.allowDialog,O}e.$4E=ye}),define(Ae[193],Re([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$E=e.$0E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$9E=e.$8E=e.ViewContentGroups=e.$7E=e.$6E=e.ViewContainerLocation=e.Extensions=e.$5E=void 0,e.$5E=(0,u.$7u)("default-view-icon",k.$Oj.window,(0,T.localize)(0,null));var p;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var m;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(m||(e.ViewContainerLocation=m={})),e.$6E=[0,1,2];function h(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$7E=h;class t extends L.$jc{constructor(){super(...arguments),this.c=this.B(new w.$ed),this.onDidRegister=this.c.event,this.f=this.B(new w.$ed),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.$Ob)([...this.g.values()])}registerViewContainer(o,y,$){const I=this.get(o.id);if(I)return I;const E=o;return E.openCommandActionDescriptor=$?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$vi)(this.g,y,[]).push(E),$?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:y}),E}deregisterViewContainer(o){for(const y of this.g.keys()){const $=this.g.get(y),I=$?.indexOf(o);if(I!==-1){$?.splice(I,1),$.length===0&&this.g.delete(y),this.f.fire({viewContainer:o,viewContainerLocation:y});return}}}get(o){return this.all.filter(y=>y.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(y=>this.getViewContainers(y).filter($=>$?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(y=>this.getViewContainerLocation(y)===o)}}l.$7m.add(p.ViewContainersRegistry,new t);var i;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(i||(e.ViewContentGroups=i={}));function c(s,o){const y=s.group??i.More,$=o.group??i.More;return y!==$?y.localeCompare($):(s.order??5)-(o.order??5)}class g extends L.$jc{constructor(){super(...arguments),this.c=this.B(new w.$ed),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$ed),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$ed),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$ed),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new f.$L}registerViews(o,y){this.registerViews2([{views:o,viewContainer:y}])}registerViews2(o){o.forEach(({views:y,viewContainer:$})=>this.r(y,$)),this.c.fire(o)}deregisterViews(o,y){const $=this.s(o,y);$.length&&this.f.fire({views:$,viewContainer:y})}moveViews(o,y){for(const $ of this.m.keys())if($!==y){const I=this.s(o,$);I.length&&(this.r(I,y),this.g.fire({views:I,from:$,to:y}))}}getViews(o){return this.m.get(o)||[]}getView(o){for(const y of this.j){const $=(this.m.get(y)||[]).filter(I=>I.id===o)[0];if($)return $}return null}getViewContainer(o){for(const y of this.j)if((this.m.get(y)||[]).filter(I=>I.id===o)[0])return y;return null}registerViewWelcomeContent(o,y){return this.n.add(o,y),this.h.fire(o),(0,L.$hc)(()=>{this.n.delete(o,y),this.h.fire(o)})}registerViewWelcomeContent2(o,y){const $=new Map;for(const[I,E]of y)this.n.add(o,E),$.set(I,(0,L.$hc)(()=>{this.n.delete(o,E),this.h.fire(o)}));return this.h.fire(o),$}getViewWelcomeContent(o){const y=[];return this.n.forEach(o,$=>y.push($)),y.sort(c)}r(o,y){let $=this.m.get(y);$||($=[],this.m.set(y,$),this.j.push(y));for(const I of o){if(this.getView(I.id)!==null)throw new Error((0,T.localize)(1,null,I.id));$.push(I)}}s(o,y){const $=this.m.get(y);if(!$)return[];const I=[],E=[];for(const r of $)o.includes(r)?I.push(r):E.push(r);return I.length&&(E.length?this.m.set(y,E):(this.m.delete(y),this.j.splice(this.j.indexOf(y),1))),I}}l.$7m.add(p.ViewsRegistry,new g),e.$8E=(0,C.$Ah)("viewsService"),e.$9E=(0,C.$Ah)("viewDescriptorService");var D;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(D||(e.ViewVisibilityState=D={}));var b;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(b||(e.TreeItemCollapsibleState=b={}));class n{constructor(o,y){this.c=!1,this.d=!1,(0,P.$Xm)(this,o),this.d=!!y,this.resolve=async $=>{if(y&&!this.c){const I=await y($);I&&(this.tooltip=this.tooltip??I.tooltip,this.command=this.command??I.command)}$.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$0E=n;class a extends Error{constructor(o){super((0,T.localize)(2,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$$E=a}),define(Ae[194],Re([1,0,5,13,162]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new w.$ed,this.n=new w.$ed,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,S,f,P){const k={command:l};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.s("request",k),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const m={type:"response",seq:0,request_seq:k.seq,success:!1,command:l,message:(0,C.localize)(0,null,P,l)};p(m)}},P)}return f&&this.f.set(k.seq,f),k.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,S){return l.type!=="event"||S.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,T.$Gg)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const S=l,f=this.f.get(S.request_seq);f&&(this.f.delete(S.request_seq),f(S));break}}}}s(l,S){S.type=l,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((S,f)=>l.set(f,S)),await(0,T.$Gg)(500),l.forEach((S,f)=>{S({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$rcb=L}),define(Ae[195],Re([1,0,163,32,4]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$kH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$jH=e.MemoryRangeType=e.$iH=e.State=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=void 0,e.$gG="workbench.view.debug",e.$hG="workbench.debug.variablesView",e.$iG="workbench.debug.watchExpressionsView",e.$jG="workbench.debug.callStackView",e.$kG="workbench.debug.loadedScriptsView",e.$lG="workbench.debug.breakPointsView",e.$mG="workbench.debug.disassemblyView",e.$nG="workbench.panel.repl",e.$oG="workbench.panel.repl.view",e.$pG=new T.$1i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$qG=new T.$1i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$rG=new T.$1i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$sG="debugUx",e.$tG=new T.$1i(e.$sG,"default",{type:"string",description:w.localize(3,null)}),e.$uG=new T.$1i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$vG=new T.$1i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$wG=new T.$1i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$xG=new T.$1i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$yG=new T.$1i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$zG=new T.$1i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$AG=new T.$1i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$BG=new T.$1i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$CG=new T.$1i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$DG=new T.$1i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$EG=new T.$1i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$FG=new T.$1i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$GG=new T.$1i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$HG=new T.$1i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$IG=new T.$1i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$JG=new T.$1i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$KG=new T.$1i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$LG=new T.$1i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$MG=new T.$1i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$NG=new T.$1i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$OG=new T.$1i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$PG=new T.$1i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$QG=new T.$1i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$RG=new T.$1i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$SG=new T.$1i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$TG=new T.$1i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$UG=new T.$1i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$VG=new T.$1i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$WG=new T.$1i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$XG=new T.$1i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$YG=new T.$1i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$ZG=new T.$1i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$1G=new T.$1i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$2G=new T.$1i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$3G=new T.$1i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$4G=new T.$1i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$5G=new T.$1i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$6G=new T.$1i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$7G=new T.$1i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$8G=new T.$1i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$9G=new T.$1i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$0G=new T.$1i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$$G=new T.$1i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$_G=new T.$1i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$aH=new T.$1i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$bH=new T.$1i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$cH=new T.$1i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const L=u=>w.localize(51,null,u);e.$dH=L,e.$eH="editor.contrib.debug",e.$fH="editor.contrib.breakpoint",e.$gH="debug",e.$hH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function l(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$iH=l;var S;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$jH="vscode-debug-memory";var f;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$kH=(0,C.$Ah)("debugService");var k;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[196],Re([1,0,15,2,19,24,12,44,21,18]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0;const P=/{([^}]+)}/g;function k(E,r,d){return E.replace(P,function(v,R){return r&&R.length>0&&R[0]!=="_"?v:d&&d.hasOwnProperty(R)?d[R]:v})}e.$fF=k;function u(E){const r={};for(const d of Object.keys(E))d.startsWith("!")||(r[d]=E[d]);return r}e.$gF=u;function p(E){return E.configuration.request==="attach"&&!m(E)&&(!E.parentSession||p(E.parentSession))}e.$hF=p;function m(E){let r=E.configuration.type;if(r)return r==="vslsShare"&&(r=E.configuration.adapterProxy.configuration.type),(0,w.$Le)(r,"extensionhost")||(0,w.$Le)(r,"pwa-extensionhost")?E:E.parentSession?m(E.parentSession):void 0}e.$iF=m;function h(E){return E.type&&(E.label||E.program||E.runtime)}e.$jF=h;function t(E,r,d){let v,R=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=B.exec(E);){const j=V.index+1,W=j+V[0].length;if(j<=r&&W>=d){v=V[0],R=j;break}}if(v){const j=/\w+/g;let W=null;for(;(W=j.exec(v))&&!(W.index+1+R+W[0].length>=d););W&&(v=v.substring(0,j.lastIndex))}return v?{start:R,end:R+v.length-1}:{start:0,end:0}}e.$kF=t;async function i(E,r,d,v){if(E.evaluatableExpressionProvider.has(r)){const R=E.evaluatableExpressionProvider.ordered(r),B=(0,f.$Eb)(await Promise.all(R.map(async V=>{try{return await V.provideEvaluatableExpression(r,d,v??S.CancellationToken.None)}catch{return}})));if(B.length>0){let V=B[0].expression;const j=B[0].range;return V||(V=r.getLineContent(d.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:V}}}else{const R=r.getLineContent(d.lineNumber),{start:B,end:V}=t(R,d.column,d.column),j=R.substring(B-1,V);return{matchingExpression:j,range:new l.$is(d.lineNumber,B,d.lineNumber,B+j.length)}}return null}e.$lF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(E){return!!(E&&E.match(c))}e.$mF=g;function D(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(g(E.path))return T.URI.parse(E.path);if((0,C.$7d)(E.path))return T.URI.file(E.path)}return E.path}function b(E){if(typeof E.path=="object"){const r=T.URI.revive(E.path);if(r)return r.scheme===A.Schemas.file?r.fsPath:r.toString()}return E.path}function n(E,r){const d=r?D:b,v=(0,L.$Um)(E);return s(v,(R,B)=>{R&&B&&(B.path=d(B))}),v}e.$nF=n;function a(E,r){const d=r?D:b,v=(0,L.$Um)(E);return s(v,(R,B)=>{!R&&B&&(B.path=d(B))}),v}e.$oF=a;function s(E,r){switch(E.type){case"event":{const d=E;switch(d.event){case"output":r(!1,d.body.source);break;case"loadedSource":r(!1,d.body.source);break;case"breakpoint":r(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=E;switch(d.command){case"setBreakpoints":r(!0,d.arguments.source);break;case"breakpointLocations":r(!0,d.arguments.source);break;case"source":r(!0,d.arguments.source);break;case"gotoTargets":r(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(v=>r(!1,v));break;default:break}break}case"response":{const d=E;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(v=>r(!1,v.source));break;case"loadedSources":d.body.sources.forEach(v=>r(!1,v));break;case"scopes":d.body.scopes.forEach(v=>r(!1,v.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(v=>r(!1,v.source));break;case"setBreakpoints":d.body.breakpoints.forEach(v=>r(!1,v.source));break;case"disassemble":d.body?.instructions.forEach(R=>r(!1,R.location));break;default:break}break}}}function o(E){return E.filter(r=>!r.presentation?.hidden).sort((r,d)=>r.presentation?d.presentation?r.presentation.group?d.presentation.group?r.presentation.group!==d.presentation.group?r.presentation.group.localeCompare(d.presentation.group):y(r.presentation.order,d.presentation.order):-1:d.presentation.group?1:y(r.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.$pF=o;function y(E,r){return typeof E!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:E-r}async function $(E,r){const d=E.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(d!=="none"&&(await r.saveAll(),d==="allEditorsInActiveGroup")){const v=r.activeEditorPane;v&&v.input.resource?.scheme===A.Schemas.untitled&&await r.save({editor:v.input,groupId:v.group.id})}await E.reloadConfiguration()}e.$qF=$;const I=(E,r)=>!E||!r?E===r:E.name===r.name&&E.path===r.path&&E.sourceReference===r.sourceReference;e.$rF=I}),define(Ae[75],Re([1,0,25,37,66,67,12,19,22,32]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3H=e.$2H=e.$1H=e.$ZH=e.CellStatusbarAlignment=e.$YH=e.$XH=e.$WH=e.NotebookEditorPriority=e.$VH=e.$UH=e.$TH=e.$SH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$RH=e.$QH=e.$PH=e.$OH=e.CellKind=e.$NH=e.$MH=e.$LH=void 0,e.$LH="workbench.editor.notebook",e.$MH="workbench.editor.notebookTextDiffEditor",e.$NH="workbench.editor.interactive";var P;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(P||(e.CellKind=P={})),e.$OH=["application/json","application/javascript","text/html","image/svg+xml",L.$Fr.latex,L.$Fr.markdown,"image/png","image/jpeg",L.$Fr.text],e.$PH=[L.$Fr.latex,L.$Fr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Fr.text],e.$QH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$RH="_notAvailable";var k;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var u;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var p;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var m;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(m||(e.NotebookRendererMatch=m={}));var h;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(h||(e.RendererMessagingSpec=h={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var g;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ee.join("")}]+`),Ee=7;function De($e,ie){const O=ie.toString(Ee),le=`${O.length<ee.length?ee[O.length-1]:"z"}${O}s${(0,w.$Yd)(w.$Ed.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:z.scheme,fragment:le})}z.generate=De;function Pe($e){if($e.scheme!==z.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const O=parseInt($e.fragment.substring(0,ie).replace(X,""),Ee),q=(0,w.$Xd)($e.fragment.substring(ie+1)).toString();if(!isNaN(O))return{handle:O,notebook:$e.with({scheme:q,fragment:null})}}z.parse=Pe;function Z($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}z.generateCellOutputUri=Z;function ue($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const O=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:O,notebook:$e.with({scheme:q||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=ue;function ye($e,ie,O){return z.generate($e,ie).with({scheme:O})}z.generateCellPropertyUri=ye;function ce($e,ie){if($e.scheme===ie)return z.parse($e.with({scheme:z.scheme}))}z.parseCellPropertyUri=ce})(g||(e.CellUri=g={}));const D=z=>S.$i?z.replace(/\//g,"\\"):z;class b{constructor(ee=[],X=e.$OH){this.e=X,this.d=[...new Set(ee)].map(Ee=>({pattern:Ee,matches:T.$qj(D(Ee))}))}sort(ee){const X=new Map(C.Iterable.map(ee,De=>[De,D(De)]));let Ee=[];for(const{matches:De}of this.d)for(const[Pe,Z]of X)if(De(Z)){Ee.push(Pe),X.delete(Pe);break}return X.size&&(Ee=Ee.concat([...X.keys()].sort((De,Pe)=>this.e.indexOf(De)-this.e.indexOf(Pe)))),Ee}prioritize(ee,X){const Ee=this.f(ee);if(Ee===-1){this.d.unshift({pattern:ee,matches:T.$qj(D(ee))});return}const De=new Set(X.map(Z=>this.f(Z,Ee)));De.delete(-1);const Pe=Array.from(De).sort();this.d.splice(Ee+1,0,...Pe.map(Z=>this.d[Z]));for(let Z=Pe.length-1;Z>=0;Z--)this.d.splice(Pe[Z],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,X=this.d.length){const Ee=D(ee);for(let De=0;De<X;De++)if(this.d[De].matches(Ee))return De;return-1}}e.$SH=b;function n(z,ee,X,Ee=(De,Pe)=>De===Pe){const De=[];function Pe(ye,ce,$e){if(ce===0&&$e.length===0)return;const ie=De[De.length-1];ie&&ie.start+ie.deleteCount===ye?(ie.deleteCount+=ce,ie.toInsert.push(...$e)):De.push({start:ye,deleteCount:ce,toInsert:$e})}let Z=0,ue=0;for(;;){if(Z===z.length){Pe(Z,0,ee.slice(ue));break}if(ue===ee.length){Pe(Z,z.length-Z,[]);break}const ye=z[Z],ce=ee[ue];if(Ee(ye,ce)){Z+=1,ue+=1;continue}X(ce)?(Pe(Z,1,[]),Z+=1):(Pe(Z,0,[ce]),ue+=1)}return De}e.$TH=n,e.$UH=new f.$1i("notebookEditorCursorAtBoundary","none"),e.$VH=new f.$1i("notebookEditorCursorAtLineBoundary","none");var a;(function(z){z.default="default",z.option="option"})(a||(e.NotebookEditorPriority=a={}));function s(z){const ee=z;return!!((typeof ee.include=="string"||T.$rj(ee.include))&&(typeof ee.exclude=="string"||T.$rj(ee.exclude)))}e.$WH=s;function o(z,ee,X){if(Array.isArray(z.viewType)&&z.viewType.indexOf(ee)>=0||z.viewType===ee)return!0;if(z.filenamePattern){const Ee=s(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,De=s(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(T.$pj(Ee,(0,l.$_d)(X.fsPath).toLowerCase()))return!(De&&T.$pj(De,(0,l.$_d)(X.fsPath).toLowerCase()))}return!1}e.$XH=o,e.$YH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var y;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class ${static{this.d="notebook/"}static create(ee){return`${$.d}${ee}`}static parse(ee){if(ee.startsWith($.d))return ee.substring($.d.length)}}e.$ZH=$;function I(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$1H=I;const E=new TextDecoder;function r(z){const ee=[];let X=!1;for(const Z of z)(ee.length===0||X)&&(ee.push(Z),X=!0);let Ee=R(ee);const De=w.$Ed.concat(ee.map(Z=>w.$Ed.wrap(Z))),Pe=N(De);return Ee=Ee||Pe.byteLength!==De.byteLength,{data:Pe,didCompression:Ee}}e.$2H=r,e.$3H=`${String.fromCharCode(27)}[A`;const d=e.$3H.split("").map(z=>z.charCodeAt(0)),v=10;function R(z){let ee=!1;return z.forEach((X,Ee)=>{if(Ee===0||X.length<e.$3H.length)return;const De=z[Ee-1],Pe=X.subarray(0,e.$3H.length);if(Pe[0]===d[0]&&Pe[1]===d[1]&&Pe[2]===d[2]){const Z=De.lastIndexOf(v);if(Z===-1)return;ee=!0,z[Ee-1]=De.subarray(0,Z),z[Ee]=X.subarray(e.$3H.length)}}),ee}function B(z){let ee=z;do z=ee,ee=z.replace(/[^\n]\x08/gm,"");while(ee.length<z.length);return z}function V(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const ee=z.match(/^(.*)\r+/m)[1];let X=z.match(/\r+(.*)$/m)[1];X=X+ee.slice(X.length,ee.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return z}const j="\b".charCodeAt(0),W="\r".charCodeAt(0);function N(z){return!z.buffer.includes(j)&&!z.buffer.includes(W)?z:w.$Ed.fromString(V(B(E.decode(z.buffer))))}}),define(Ae[7],Re([1,0,18,9,49,28,67,15,16,2,36,20,38,97,75]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m){"use strict";var h,t,i,c,g,D,b,n,a,s,o,y,$,I,E,r,d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$KL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.TestRunProfileKind=e.TestResultState=e.$rL=e.$qL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$pL=e.$oL=e.$nL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$mL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.ColorThemeKind=e.$gL=e.$fL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$eL=e.DebugConsoleMode=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$$K=e.$0K=e.FileChangeType=e.$9K=e.$8K=e.$7K=e.$6K=e.InlineCompletionTriggerKind=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.ConfigurationTarget=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$IK=e.ViewBadge=e.ProgressLocation=e.$HK=e.$GK=e.TaskScope=e.ShellQuoting=e.$FK=e.$EK=e.$DK=e.TaskPanelKind=e.TaskRevealKind=e.$CK=e.TerminalLocation=e.$BK=e.$AK=e.$zK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$yK=e.$xK=e.$wK=e.$vK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$uK=e.StatusBarAlignment=e.ViewColumn=e.$tK=e.$sK=e.$rK=e.$qK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$pK=e.$oK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.LanguageStatusSeverity=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.CodeActionTriggerKind=e.$bK=e.$aK=e.SymbolTag=e.SymbolKind=e.$_J=e.DocumentHighlightKind=e.$$J=e.$0J=e.$9J=e.$8J=e.DiagnosticSeverity=e.DiagnosticTag=e.$7J=e.$6J=e.FileEditType=e.$5J=e.$4J=e.$3J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(U){return Object.assign(U,{apply:function(...ne){if(ne.length===0)return Reflect.construct(U,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(U,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(U,[]);{const[Se,...Je]=ne;return Reflect.construct(U,Je,Se.constructor)}}})}var B;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var V;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let j=h=class{static from(...M){let ne=M;return new h(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$VJ=j,e.$VJ=j=h=Ke([R],j);let W=t=class{static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Se=1;Se<M.length;Se++){const Je=M[Se];Je.isBefore(ne)&&(ne=Je)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Se=1;Se<M.length;Se++){const Je=M[Se];Je.isAfter(ne)&&(ne=Je)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof t)return!0;const{line:ne,character:Se}=M;return typeof ne=="number"&&typeof Se=="number"}static of(M){if(M instanceof t)return M;if(this.isPosition(M))return new t(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,ne){if(M<0)throw(0,T.$5)("line must be non-negative");if(ne<0)throw(0,T.$5)("character must be non-negative");this.c=M,this.e=ne}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,T.$5)();let Se;return typeof M>"u"?Se=0:typeof M=="number"?Se=M:(Se=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),Se===0&&ne===0?this:new t(this.line+Se,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,T.$5)();let Se;return typeof M>"u"?Se=this.line:typeof M=="number"?Se=M:(Se=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),Se===this.line&&ne===this.character?this:new t(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$WJ=W,e.$WJ=W=t=Ke([R],W);let N=i=class{static isRange(M){return M instanceof i?!0:M?W.isPosition(M.start)&&W.isPosition(M.end):!1}static of(M){if(M instanceof i)return M;if(this.isRange(M))return new i(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,ne,Se,Je){let Xe,ot;if(typeof M=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(Xe=new W(M,ne),ot=new W(Se,Je)):W.isPosition(M)&&W.isPosition(ne)&&(Xe=W.of(M),ot=W.of(ne)),!Xe||!ot)throw new Error("Invalid arguments");Xe.isBefore(ot)?(this.c=Xe,this.e=ot):(this.c=ot,this.e=Xe)}contains(M){return i.isRange(M)?this.contains(M.start)&&this.contains(M.end):W.isPosition(M)?!(W.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const ne=W.Max(M.start,this.c),Se=W.Min(M.end,this.e);if(!ne.isAfter(Se))return new i(ne,Se)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=W.Min(M.start,this.c),Se=W.Max(M.end,this.end);return new i(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,T.$5)();let Se;return M?W.isPosition(M)?Se=M:(Se=M.start||this.start,ne=M.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new i(Se,ne)}toJSON(){return[this.start,this.end]}};e.$XJ=N,e.$XJ=N=i=Ke([R],N);let z=c=class extends N{static isSelection(M){return M instanceof c?!0:M?N.isRange(M)&&W.isPosition(M.anchor)&&W.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,ne,Se,Je){let Xe,ot;if(typeof M=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(Xe=new W(M,ne),ot=new W(Se,Je)):W.isPosition(M)&&W.isPosition(ne)&&(Xe=W.of(M),ot=W.of(ne)),!Xe||!ot)throw new Error("Invalid arguments");super(Xe,ot),this.f=Xe,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$YJ=z,e.$YJ=z=c=Ke([R],z);const ee=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,T.$5)("connectionToken")};class X{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ne,Se){if(typeof M!="string"||M.length===0)throw(0,T.$5)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,T.$5)("port");typeof Se<"u"&&ee(Se),this.host=M,this.port=Math.round(ne),this.connectionToken=Se}}e.$ZJ=X;class Ee{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ne){this.makeConnection=M,this.connectionToken=ne,typeof ne<"u"&&ee(ne)}}e.$1J=Ee;class De extends Error{static NotAvailable(M,ne){return new De(M,p.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new De(M,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,ne=p.RemoteAuthorityResolverErrorCode.Unknown,Se){super(M),this._message=M,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$2J=De;var Pe;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var Z;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let ue=g=class{static isTextEdit(M){return M instanceof g?!0:M?N.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new g(M,ne)}static insert(M,ne){return g.replace(new N(M,M),ne)}static delete(M){return g.replace(M,"")}static setEndOfLine(M){const ne=new g(new N(new W(0,0),new W(0,0)),"");return ne.newEol=M,ne}get range(){return this.c}set range(M){if(M&&!N.isRange(M))throw(0,T.$5)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,T.$5)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,T.$5)("newEol");this.f=M}constructor(M,ne){this.c=M,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$3J=ue,e.$3J=ue=g=Ke([R],ue);let ye=D=class{static isNotebookCellEdit(M){return M instanceof D?!0:M?Zt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ne){return new D(M,ne)}static insertCells(M,ne){return new D(new Zt(M,M),ne)}static deleteCells(M){return new D(M,[])}static updateCellMetadata(M,ne){const Se=new D(new Zt(M,M),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(M){const ne=new D(new Zt(0,0),[]);return ne.newNotebookMetadata=M,ne}constructor(M,ne){this.range=M,this.newCells=ne}};e.$4J=ye,e.$4J=ye=D=Ke([R],ye);class ce{static isSnippetTextEdit(M){return M instanceof ce?!0:M?N.isRange(M.range)&&O.isSnippetString(M.snippet):!1}static replace(M,ne){return new ce(M,ne)}static insert(M,ne){return ce.replace(new N(M,M),ne)}constructor(M,ne){this.range=M,this.snippet=ne}}e.$5J=ce;var $e;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,ne,Se,Je){this.c.push({_type:1,from:M,to:ne,options:Se,metadata:Je})}createFile(M,ne,Se){this.c.push({_type:1,from:void 0,to:M,options:ne,metadata:Se})}deleteFile(M,ne,Se){this.c.push({_type:1,from:M,to:void 0,options:ne,metadata:Se})}e(M,ne,Se){this.c.push({_type:3,metadata:Se,uri:M,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(M,ne,Se,Je){const Xe=ne.start,ot=ne.end;(Xe!==ot||Se.length>0)&&this.c.push({_type:5,uri:M,index:Xe,count:ot-Xe,cells:Se,metadata:Je})}g(M,ne,Se,Je){this.c.push({_type:3,metadata:Je,uri:M,edit:{editType:3,index:ne,metadata:Se}})}replace(M,ne,Se,Je){this.c.push({_type:2,uri:M,edit:new ue(ne,Se),metadata:Je})}insert(M,ne,Se,Je){this.replace(M,new N(ne,ne),Se,Je)}delete(M,ne,Se){this.replace(M,ne,"",Se)}has(M){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const Se of ne){if(!Se)continue;let Je,Xe;Array.isArray(Se)?(Je=Se[0],Xe=Se[1]):Je=Se,ye.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(M,Je.range.start,Je.newCellMetadata,Xe):Je.newNotebookMetadata?this.e(M,Je.newNotebookMetadata,Xe):this.f(M,Je.range,Je.newCells,Xe):ce.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:M,range:Je.range,edit:Je.snippet,metadata:Xe}):this.c.push({_type:2,uri:M,edit:Je,metadata:Xe})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===M.toString()&&(this.c[Se]=void 0);break}}(0,w.$Fb)(this.c)}}get(M){const ne=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===M.toString()&&ne.push(Se.edit);return ne}entries(){const M=new L.$yi;for(const ne of this.c)if(ne._type===2){let Se=M.get(ne.uri);Se||(Se=[ne.uri,[]],M.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$6J=ie,e.$6J=ie=Ke([R],ie);let O=b=class{static isSnippetString(M){return M instanceof b?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=b.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this.e++){if(typeof M=="function"){const Se=new b;Se.e=this.e,M(Se),this.e=Se.e,M=Se.value}else M=b.c(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this.e++){const Se=M.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const Se=new b;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$7J=O,e.$7J=O=b=Ke([R],O);var q;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var le;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let we=n=class{static isLocation(M){return M instanceof n?!0:M?N.isRange(M.range)&&f.URI.isUri(M.uri):!1}constructor(M,ne){if(this.uri=M,ne)if(N.isRange(ne))this.range=N.of(ne);else if(W.isPosition(ne))this.range=new N(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$8J=we,e.$8J=we=n=Ke([R],we);let ve=class{static is(M){return M?typeof M.message=="string"&&M.location&&N.isRange(M.location.range)&&f.URI.isUri(M.location.uri):!1}constructor(M,ne){this.location=M,this.message=ne}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};e.$9J=ve,e.$9J=ve=Ke([R],ve);let me=class{constructor(M,ne,Se=le.Error){if(!N.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=Se}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,w.$sb)(M.tags,ne.tags)&&(0,w.$sb)(M.relatedInformation,ne.relatedInformation,ve.isEqual)}};e.$0J=me,e.$0J=me=Ke([R],me);let ke=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ne}};e.$$J=ke,e.$$J=ke=Ke([R],ke);var se;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let he=class{constructor(M,ne=se.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$_J=he,e.$_J=he=Ke([R],he);var re;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(re||(e.SymbolKind=re={}));var oe;(function(U){U[U.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=a=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,ne,Se,Je,Xe){this.name=M,this.kind=ne,this.containerName=Xe,typeof Se=="string"&&(this.containerName=Se),Je instanceof we?this.location=Je:Se instanceof N&&(this.location=new we(Je,Se)),a.validate(this)}toJSON(){return{name:this.name,kind:re[this.kind],location:this.location,containerName:this.containerName}}};e.$aK=fe,e.$aK=fe=a=Ke([R],fe);let Ie=s=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(s.validate)}constructor(M,ne,Se,Je,Xe){this.name=M,this.detail=ne,this.kind=Se,this.range=Je,this.selectionRange=Xe,this.children=[],s.validate(this)}};e.$bK=Ie,e.$bK=Ie=s=Ke([R],Ie);var F;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(F||(e.CodeActionTriggerKind=F={}));let K=class{constructor(M,ne){this.title=M,this.kind=ne}};e.$cK=K,e.$cK=K=Ke([R],K);let G=class{static{o=this}static{this.c="."}constructor(M){this.value=M}append(M){return new o(this.value?this.value+o.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+o.c)}};e.$dK=G,e.$dK=G=o=Ke([R],G);class Q extends G{constructor(M){super(M),this.value=M}}e.$eK=Q,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$fK=J,e.$fK=J=Ke([R],J);class x{constructor(M,ne,Se,Je,Xe,ot){this.kind=M,this.name=ne,this.detail=Se,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$gK=x;class ae{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.$hK=ae;class Le{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.$iK=Le;var Ue;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let Qe=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};e.$jK=Qe,e.$jK=Qe=Ke([R],Qe);let He=y=class{#e;static isMarkdownString(M){return M instanceof y?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,ne=!1){this.#e=new C.$Wj(M,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,ne){return this.#e.appendCodeblock(ne??"",M),this}};e.$kK=He,e.$kK=He=y=Ke([R],He);let et=class{constructor(M,ne){this.label=M,this.documentation=ne}};e.$lK=et,e.$lK=et=Ke([R],et);let Ze=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};e.$mK=Ze,e.$mK=Ze=Ke([R],Ze);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$nK=_e,e.$nK=_e=Ke([R],_e);var it;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var tt;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Oe=class{constructor(M){this.value=M}};e.$oK=Oe,e.$oK=Oe=Ke([R],Oe);let st=class{constructor(M,ne,Se){this.position=M,this.label=ne,this.kind=Se}};e.$pK=st,e.$pK=st=Ke([R],st);var _;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(e.CompletionTriggerKind=_={}));var Y;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var pe;(function(U){U[U.Deprecated=1]="Deprecated"})(pe||(e.CompletionItemTag=pe={}));let je=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$qK=je,e.$qK=je=Ke([R],je);let ze=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};e.$rK=ze,e.$rK=ze=Ke([R],ze);let Ye=class{constructor(M,ne,Se){this.insertText=M,this.range=ne,this.command=Se}};e.$sK=Ye,e.$sK=Ye=Ke([R],Ye);let nt=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$tK=nt,e.$tK=nt=Ke([R],nt);var gt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(gt||(e.ViewColumn=gt={}));var vt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Ft(U,M){return`${k.$Ul.toKey(U)}.${M}`}e.$uK=Ft;var Yt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Yt||(e.TextEditorLineNumbersStyle=Yt={}));var Vt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var wt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Mt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Mt||(e.TextEditorSelectionChangeKind=Mt={}));var Nt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Nt||(e.TextDocumentChangeReason=Nt={}));var Jt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(U){function M(ne){switch(ne){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=M}(Mt||(e.TextEditorSelectionChangeKind=Mt={}));let Pt=class{constructor(M,ne){if(ne&&!f.URI.isUri(ne))throw(0,T.$5)("target");if(!N.isRange(M)||M.isEmpty)throw(0,T.$5)("range");this.range=M,this.target=ne}};e.$vK=Pt,e.$vK=Pt=Ke([R],Pt);let At=class{constructor(M,ne,Se,Je){this.red=M,this.green=ne,this.blue=Se,this.alpha=Je}};e.$wK=At,e.$wK=At=Ke([R],At);let zt=class{constructor(M,ne){if(ne&&!(ne instanceof At))throw(0,T.$5)("color");if(!N.isRange(M)||M.isEmpty)throw(0,T.$5)("range");this.range=M,this.color=ne}};e.$xK=zt,e.$xK=zt=Ke([R],zt);let jt=class{constructor(M){if(!M||typeof M!="string")throw(0,T.$5)("label");this.label=M}};e.$yK=jt,e.$yK=jt=Ke([R],jt);var qt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var at;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(M,ne,Se){if(this.startIndex=M,this.length=ne,this.tooltip=Se,typeof M!="number"||M<0)throw(0,T.$5)("startIndex");if(typeof ne!="number"||ne<1)throw(0,T.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,T.$5)("tooltip")}}e.$zK=ut;class Ht{constructor(M){this.uri=M}}e.$AK=Ht;class Ct{constructor(M){this.terminalCommand=M}}e.$BK=Ct;var Dt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class ht{constructor(M){if(this.options=M,typeof M!="object")throw(0,T.$5)("options")}}e.$CK=ht;var St;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var Lt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Lt||(e.TaskPanelKind=Lt={}));let Et=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(M){switch(M){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(M,ne){if(this.label=ne,typeof M!="string"||typeof ne!="string")throw(0,T.$5)("name");this.c=M}get id(){return this.c}};e.$DK=Et,e.$DK=Et=$=Ke([R],Et);function qe(U){let M="";for(let ne=0;ne<U.length;ne++)M+=U[ne].replace(/,/g,",,")+",";return M}let Ot=class{constructor(M,ne,Se){if(typeof M!="string")throw(0,T.$5)("process");this.e=[],this.c=M,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,T.$5)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)M.push(ne);return qe(M)}};e.$EK=Ot,e.$EK=Ot=Ke([R],Ot);let Ce=class{constructor(M,ne,Se){if(this.f=[],Array.isArray(ne)){if(!M)throw(0,T.$5)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,T.$5)("command");this.e=M,this.f=ne,this.g=Se}else{if(typeof M!="string")throw(0,T.$5)("commandLine");this.c=M,this.g=ne}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,T.$5)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,T.$5)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)M.push(typeof ne=="string"?ne:ne.value);return qe(M)}};e.$FK=Ce,e.$FK=Ce=Ke([R],Ce);var Te;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Te||(e.ShellQuoting=Te={}));var ge;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(ge||(e.TaskScope=ge={}));class H{constructor(M){this.c=M}computeId(){return"customExecution"+(0,P.$3f)()}set callback(M){this.c=M}get callback(){return this.c}}e.$GK=H;let Fe=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(M,ne,Se,Je,Xe,ot){this.j=!1,this.k=this.definition=M;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=Se,this.execution=Je,lt=Xe,this.j=!0):ne===ge.Global||ne===ge.Workspace?(this.target=ne,this.m=this.name=Se,this.t=this.source=Je,this.execution=Xe,lt=ot):(this.target=ne,this.m=this.name=Se,this.t=this.source=Je,this.execution=Xe,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(M){this.h=M}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Ot?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof H?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,P.$3f)()}}get definition(){return this.k}set definition(M){if(M==null)throw(0,T.$5)("Kind can't be undefined or null");this.y(),this.k=M}get scope(){return this.l}set target(M){this.y(),this.l=M}get name(){return this.m}set name(M){if(typeof M!="string")throw(0,T.$5)("name");this.y(),this.m=M}get execution(){return this.n}set execution(M){M===null&&(M=void 0),this.y(),this.n=M;const ne=this.k.type;(I.g===ne||I.e===ne||I.f===ne||I.c===ne)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(M){if(Array.isArray(M))this.y(),this.o=M,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.y(),this.r=M}get source(){return this.t}set source(M){if(typeof M!="string"||M.length===0)throw(0,T.$5)("source must be a string of length > 0");this.y(),this.t=M}get group(){return this.u}set group(M){M===null&&(M=void 0),this.y(),this.u=M}get detail(){return this.x}set detail(M){M===null&&(M=void 0),this.x=M}get presentationOptions(){return this.v}set presentationOptions(M){M==null&&(M=Object.create(null)),this.y(),this.v=M}get runOptions(){return this.w}set runOptions(M){M==null&&(M=Object.create(null)),this.y(),this.w=M}};e.$HK=Fe,e.$HK=Fe=I=Ke([R],Fe);var Be;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Be||(e.ProgressLocation=Be={}));var Ge;(function(U){function M(ne){const Se=ne;return(0,S.$mf)(Se.value)?Se.tooltip&&!(0,S.$if)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=M})(Ge||(e.ViewBadge=Ge={}));let We=E=class{static isTreeItem(M,ne){const Se=M;if(Se.checkboxState!==void 0){const Je=(0,S.$mf)(Se.checkboxState)?Se.checkboxState:(0,S.$kf)(Se.checkboxState)&&(0,S.$mf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Xe=!(0,S.$mf)(Se.checkboxState)&&(0,S.$kf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==pt.Checked&&Je!==pt.Unchecked||Xe!==void 0&&!(0,S.$if)(Xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(M instanceof E)return!0;if(Se.label!==void 0&&!(0,S.$if)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,S.$if)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,S.$if)(Se.iconPath)&&!f.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,S.$if)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,S.$if)(Je.light)&&!f.URI.isUri(Je.light)&&!(0,S.$if)(Je.dark)&&!f.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,S.$if)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!f.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,S.$if)(Se.tooltip)&&!(Se.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<xe.None&&Se.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,S.$if)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(M,ne=xe.None){this.collapsibleState=ne,f.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$IK=We,e.$IK=We=E=Ke([R],We);var xe;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var pt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$JK=bt,e.$JK=bt=Ke([R],bt);class dt extends bt{}e.$KK=dt;class ft extends dt{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.$LK=ft;class mt{constructor(M,ne,Se,Je){this.name=M,this.uri=ne,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$MK=mt;let gi=class{#e=new Map;constructor(M){for(const[ne,Se]of M??[]){const Je=this.#e.get(this.#t(ne));Je?Je.push(Se):this.#e.set(this.#t(ne),[Se])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,ne){this.#e.set(this.#t(M),[ne])}forEach(M,ne){for(const[Se,Je]of this.#e)for(const Xe of Je)M.call(ne,Xe,Se,this)}*[Symbol.iterator](){for(const[M,ne]of this.#e)for(const Se of ne)yield[M,Se]}#t(M){return M.toLowerCase()}};e.$NK=gi,e.$NK=gi=Ke([R],gi);let Kt=class{constructor(M){this.insertText=M}};e.$OK=Kt,e.$OK=Kt=Ke([R],Kt);let Ei=class{constructor(M,ne){this.label=ne,this.insertText=M}};e.$PK=Ei,e.$PK=Ei=Ke([R],Ei);let Wt=class{constructor(M,ne){this.id=M,this.color=ne}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$QK=Wt,e.$QK=Wt=Ke([R],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(M){this.id=M}};e.$RK=mi,e.$RK=mi=Ke([R],mi);var It;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let Di=class{get base(){return this.c}set base(M){this.c=M,this.e=f.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,ne){if(typeof M!="string"&&(!M||!f.URI.isUri(M)&&!f.URI.isUri(M.uri)))throw(0,T.$5)("base");if(typeof ne!="string")throw(0,T.$5)("pattern");typeof M=="string"?this.baseUri=f.URI.file(M):f.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$SK=Di,e.$SK=Di=Ke([R],Di);const Vi=new WeakMap;function kt(U,M){Vi.set(U,M)}e.$TK=kt;let ti=class{constructor(M,ne,Se,Je){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$3f)()),this.c}};e.$UK=ti,e.$UK=ti=Ke([R],ti);let $i=class extends ti{constructor(M,ne,Se,Je,Xe){if(super(ne,Se,Je,Xe),M===null)throw(0,T.$5)("location");this.location=M}};e.$VK=$i,e.$VK=$i=Ke([R],$i);let si=class extends ti{constructor(M,ne,Se,Je,Xe){super(ne,Se,Je,Xe),this.functionName=M}};e.$WK=si,e.$WK=si=Ke([R],si);let ki=class extends ti{constructor(M,ne,Se,Je,Xe,ot,lt){if(super(Je,Xe,ot,lt),!ne)throw(0,T.$5)("dataId");this.label=M,this.dataId=ne,this.canPersist=Se}};e.$XK=ki,e.$XK=ki=Ke([R],ki);let Si=class{constructor(M,ne,Se){this.command=M,this.args=ne||[],this.options=Se}};e.$YK=Si,e.$YK=Si=Ke([R],Si);let Rt=class{constructor(M,ne){this.port=M,this.host=ne}};e.$ZK=Rt,e.$ZK=Rt=Ke([R],Rt);let pi=class{constructor(M){this.path=M}};e.$1K=pi,e.$1K=pi=Ke([R],pi);let Ii=class{constructor(M){this.implementation=M}};e.$2K=Ii,e.$2K=Ii=Ke([R],Ii);let oi=class{constructor(M,ne,Se){this.session=M,this.threadId=ne,this.frameId=Se}};e.$3K=oi,e.$3K=oi=Ke([R],oi);let ai=class{constructor(M,ne){this.session=M,this.threadId=ne}};e.$4K=ai,e.$4K=ai=Ke([R],ai);let ct=class{constructor(M,ne){this.range=M,this.expression=ne}};e.$5K=ct,e.$5K=ct=Ke([R],ct);var qi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Xt=class{constructor(M,ne){this.range=M,this.text=ne}};e.$6K=Xt,e.$6K=Xt=Ke([R],Xt);let ii=class{constructor(M,ne,Se=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$7K=ii,e.$7K=ii=Ke([R],ii);let bi=class{constructor(M,ne){this.range=M,this.expression=ne}};e.$8K=bi,e.$8K=bi=Ke([R],bi);let Ci=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};e.$9K=Ci,e.$9K=Ci=Ke([R],Ci);var Ki;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=r=class extends Error{static FileExists(M){return new r(M,u.FileSystemProviderErrorCode.FileExists,r.FileExists)}static FileNotFound(M){return new r(M,u.FileSystemProviderErrorCode.FileNotFound,r.FileNotFound)}static FileNotADirectory(M){return new r(M,u.FileSystemProviderErrorCode.FileNotADirectory,r.FileNotADirectory)}static FileIsADirectory(M){return new r(M,u.FileSystemProviderErrorCode.FileIsADirectory,r.FileIsADirectory)}static NoPermissions(M){return new r(M,u.FileSystemProviderErrorCode.NoPermissions,r.NoPermissions)}static Unavailable(M){return new r(M,u.FileSystemProviderErrorCode.Unavailable,r.Unavailable)}constructor(M,ne=u.FileSystemProviderErrorCode.Unknown,Se){super(f.URI.isUri(M)?M.toString(!0):M),this.code=Se?.name??"Unknown",(0,u.$gk)(this,ne),Object.setPrototypeOf(this,r.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$0K=Pi,e.$0K=Pi=r=Ke([R],Pi);let vi=class{constructor(M,ne,Se){this.start=M,this.end=ne,this.kind=Se}};e.$$K=vi,e.$$K=vi=Ke([R],vi);var Ji;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Hi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Hi||(e.CommentState=Hi={}));var wi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.$_K=Ri;function cn(U){return typeof U>"u"||(0,S.$jf)(U)}class Ti{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,M){this.l=!0;for(let ne=0,Se=M.tokenTypes.length;ne<Se;ne++)this.j.set(M.tokenTypes[ne],ne);for(let ne=0,Se=M.tokenModifiers.length;ne<Se;ne++)this.k.set(M.tokenModifiers[ne],ne)}}push(M,ne,Se,Je,Xe){if(typeof M=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.n(M,ne,Se,Je,Xe);if(N.isRange(M)&&typeof ne=="string"&&cn(Se))return this.m(M,ne,Se);throw(0,T.$5)()}m(M,ne,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const Je=M.start.line,Xe=M.start.character,ot=M.end.character-M.start.character,lt=this.j.get(ne);let Ut=0;if(Se)for(const Qt of Se){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Qt);Ut|=1<<xt>>>0}this.n(Je,Xe,ot,lt,Ut)}n(M,ne,Se,Je,Xe){if(this.f&&(M<this.c||M===this.c&&ne<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Qt=0,xt=0;for(let ei=0;ei<Ut;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Qt,Bi+=xt):ri+=Qt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Qt=ri,xt=Bi}}let ot=M,lt=ne;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Xe,this.c=M,this.e=ne}static o(M){const ne=[],Se=M.length/5|0;for(let lt=0;lt<Se;lt++)ne[lt]=lt;ne.sort((lt,Ut)=>{const Qt=M[5*lt],xt=M[5*Ut];if(Qt===xt){const ei=M[5*lt+1],ri=M[5*Ut+1];return ei-ri}return Qt-xt});const Je=new Uint32Array(M.length);let Xe=0,ot=0;for(let lt=0;lt<Se;lt++){const Ut=5*ne[lt],Qt=M[Ut+0],xt=M[Ut+1],ei=M[Ut+2],ri=M[Ut+3],Bi=M[Ut+4],wn=Qt-Xe,Tn=wn===0?xt-ot:xt,Wi=5*lt;Je[Wi+0]=wn,Je[Wi+1]=Tn,Je[Wi+2]=ei,Je[Wi+3]=ri,Je[Wi+4]=Bi,Xe=Qt,ot=xt}return Je}build(M){return this.f?new ni(new Uint32Array(this.g),M):new ni(Ti.o(this.g),M)}}e.$aL=Ti;class ni{constructor(M,ne){this.resultId=ne,this.data=M}}e.$bL=ni;class un{constructor(M,ne,Se){this.start=M,this.deleteCount=ne,this.data=Se}}e.$cL=un;class ln{constructor(M,ne){this.resultId=ne,this.edits=M}}e.$dL=ln;var Gi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$eL=fi,e.$eL=fi=Ke([R],fi);var Qi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Yi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var ui;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Xi{static validate(M){if(typeof M.badge=="string"){let ne=(0,l.$Ve)(M.badge,0);if(ne<M.badge.length&&(ne+=(0,l.$Ve)(M.badge,ne)),M.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Wt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,ne,Se){this.badge=M,this.tooltip=ne,this.color=Se}}e.$fL=Xi;let Fi=class{constructor(M){this.kind=M}};e.$gL=Fi,e.$gL=Fi=Ke([R],Fi);var Zi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Zi||(e.ColorThemeKind=Zi={}));class Zt{static isNotebookRange(M){return M instanceof Zt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,ne){if(M<0)throw(0,T.$5)("start must be positive");if(ne<0)throw(0,T.$5)("end must be positive");M<=ne?(this.c=M,this.e=ne):(this.c=ne,this.e=M)}with(M){let ne=this.c,Se=this.e;return M.start!==void 0&&(ne=M.start),M.end!==void 0&&(Se=M.end),ne===this.c&&Se===this.e?this:new Zt(ne,Se)}}e.$hL=Zt;class yi{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ne=>yi.isNotebookCellData(ne))}static isNotebookCellData(M){return!0}constructor(M,ne,Se,Je,Xe,ot,lt){this.kind=M,this.value=ne,this.languageId=Se,this.mime=Je,this.outputs=Xe??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$iL=yi;class hn{constructor(M){this.cells=M}}e.$jL=hn;class Gt{static isNotebookCellOutputItem(M){return M instanceof Gt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ne={name:M.name,message:M.message,stack:M.stack};return Gt.json(ne,"application/vnd.code.notebook.error")}static stdout(M){return Gt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Gt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ne="application/octet-stream"){return new Gt(M,ne)}static#e=new TextEncoder;static text(M,ne=A.$Fr.text){const Se=Gt.#e.encode(String(M));return new Gt(Se,ne)}static json(M,ne="text/x-json"){const Se=JSON.stringify(M,void 0,"	");return Gt.text(Se,ne)}constructor(M,ne){this.data=M,this.mime=ne;const Se=(0,A.$Jr)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$kL=Gt;class li{static isNotebookCellOutput(M){return M instanceof li?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,ne=!1){const Se=new Set,Je=new Set;for(let Xe=0;Xe<M.length;Xe++){const ot=M[Xe],lt=(0,A.$Jr)(ot.mime);if(!Se.has(lt)||(0,m.$1H)(lt)){Se.add(lt);continue}Je.add(Xe),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?M:M.filter((Xe,ot)=>!Je.has(ot))}constructor(M,ne,Se){this.items=li.ensureUniqueMimeTypes(M,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,P.$3f)(),this.metadata=ne??Se)}}e.$lL=li;var Mi;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Mi||(e.NotebookCellKind=Mi={}));var Ne;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Ne||(e.NotebookCellExecutionState=Ne={}));var _t;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Li;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Li||(e.NotebookEditorRevealType=Li={}));class $t{constructor(M,ne){this.text=M,this.alignment=ne}}e.$mL=$t;var _i;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(_i||(e.NotebookControllerAffinity=_i={}));var xi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class en{constructor(M,ne=[]){this.uri=M,this.provides=(0,w.$Zb)(ne)}}e.$nL=en;class dn{constructor(M){this.label=M}}e.$oL=dn;let hi=class{constructor(M,ne){this.label=M,this.timestamp=ne}};e.$pL=hi,e.$pL=hi=Ke([R],hi);var tn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.$qL=sn;class fn{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$rL=fn;var on;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(M=void 0,ne=void 0,Se=void 0,Je=!1){this.include=M,this.exclude=ne,this.profile=Se,this.continuous=Je}};e.$sL=Ni,e.$sL=Ni=Ke([R],Ni);let zi=d=class{static diff(M,ne,Se){const Je=new d(M);return Je.expectedOutput=ne,Je.actualOutput=Se,Je}constructor(M){this.message=M}};e.$tL=zi,e.$tL=zi=d=Ke([R],zi);let Oi=class{constructor(M){this.id=M}};e.$uL=Oi,e.$uL=Oi=Ke([R],Oi);let di=class{constructor(M,ne){this.covered=M,this.total=ne}};e.$vL=di,e.$vL=di=Ke([R],di);let Ui=v=class{static fromDetails(M,ne){const Se=new di(0,0),Je=new di(0,0),Xe=new di(0,0);for(const lt of ne)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)Je.total+=1,Je.covered+=Ut.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=lt.executionCount>0?1:0;const ot=new v(M,Se,Je.total>0?Je:void 0,Xe.total>0?Xe:void 0);return ot.detailedCoverage=ne,ot}constructor(M,ne,Se,Je){this.uri=M,this.statementCoverage=ne,this.branchCoverage=Se,this.functionCoverage=Je}};e.$wL=Ui,e.$wL=Ui=v=Ke([R],Ui);let ji=class{constructor(M,ne,Se=[]){this.executionCount=M,this.location=ne,this.branches=Se}};e.$xL=ji,e.$xL=ji=Ke([R],ji);let te=class{constructor(M,ne){this.executionCount=M,this.location=ne}};e.$yL=te,e.$yL=te=Ke([R],te);let de=class{constructor(M,ne){this.executionCount=M,this.location=ne}};e.$zL=de,e.$zL=de=Ke([R],de);var Me;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Me||(e.ExternalUriOpenerPriority=Me={}));var rt;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var yt;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Tt{constructor(M,ne,Se,Je,Xe,ot){this.kind=M,this.name=ne,this.detail=Se,this.uri=Je,this.range=Xe,this.selectionRange=ot}}e.$AL=Tt;class yn{constructor(M){this.uri=M}}e.$BL=yn;class En{constructor(M,ne){this.original=M,this.modified=ne}}e.$CL=En;class Dn{constructor(M,ne,Se,Je){this.base=M,this.input1=ne,this.input2=Se,this.result=Je}}e.$DL=Dn;class kn{constructor(M,ne){this.uri=M,this.viewType=ne}}e.$EL=kn;class Sn{constructor(M){this.viewType=M}}e.$FL=Sn;class In{constructor(M,ne){this.uri=M,this.notebookType=ne}}e.$GL=In;class Cn{constructor(M,ne,Se){this.original=M,this.modified=ne,this.notebookType=Se}}e.$HL=Cn;class Pn{constructor(){}}e.$IL=Pn;class An{constructor(M,ne){this.uri=M,this.inputBoxUri=ne}}e.$JL=An;var gn;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var bn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Rn{constructor(M,ne){this.role=M,this.content=ne}}e.$KL=Rn;var vn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(Ae[101],Re([1,0,50,12,15,277,137,7,18]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=e.$YL=e.$XL=void 0;const f=new Map;function P(m,h){h?f.set(m,h):f.delete(m)}e.$XL=P;function k(m){return f.get(m)}class u extends L.$Ku{constructor(h,t,i,c,g,D,b,n){super(t,i,c,g),this.c=h,this.m=D,this.q=b,this.notebook=n,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,S.$sb)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===T.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(t){return t?h.s(t):h.getText()},get eol(){return h.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(t){return h.t(t)},offsetAt(t){return h.u(t)},positionAt(t){return h.v(t)},validateRange(t){return h.w(t)},validatePosition(t){return h.x(t)},getWordRangeAtPosition(t,i){return h.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,w.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,w.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const t=this.w(h);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,g=t.end.line,D=[];D.push(this.f[c].substring(t.start.character));for(let b=c+1;b<g;b++)D.push(this.f[b]);return D.push(this.f[g].substring(0,t.end.character)),D.join(i)}t(h){let t;if(h instanceof l.$WJ?t=h.line:typeof h=="number"&&(t=h),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const t=this.j.getIndexOf(h),i=this.f[t.index].length;return new l.$WJ(t.index,Math.min(t.remainder,i))}w(h){if(!(h instanceof l.$XJ))throw new Error("Invalid argument");const t=this.x(h.start),i=this.x(h.end);return t===h.start&&i===h.end?h:new l.$XJ(t.line,t.character,i.line,i.character)}x(h){if(!(h instanceof l.$WJ))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:t,character:i}=h,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const g=this.f[t].length;i<0?(i=0,c=!0):i>g&&(i=g,c=!0)}return c?new l.$WJ(t,i):h}y(h,t){const i=this.x(h);if(!t)t=k(this.m);else if((0,C.$ye)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$Xr)(i.character+1,(0,A.$Vr)(t),this.f[i.line],0);if(c)return new l.$XJ(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$YL=u;class p{constructor(h,t,i){this.a=h,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$XJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$XJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$ZL=p}),define(Ae[197],Re([1,0,7,17,5]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;let L=class{constructor(l){this.a=new w.$gL(w.ColorThemeKind.Dark),this.b=new C.$ed}get activeColorTheme(){return this.a}$onColorThemeChange(l){let S;switch(l){case"light":S=w.ColorThemeKind.Light;break;case"hcDark":S=w.ColorThemeKind.HighContrast;break;case"hcLight":S=w.ColorThemeKind.HighContrastLight;break;default:S=w.ColorThemeKind.Dark}this.a=new w.$gL(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$jcc=L,e.$jcc=L=Ke([Ve(0,T.$VL)],L)}),define(Ae[198],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$5H=(0,w.$Ah)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(L){L.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class C{static fromExtHostTestItem(A,l,S=A.parent){if(A._isRoot)return new C([l]);const f=[A.id];for(let P=S;P&&P.id!==l;P=P.parent)f.push(P.id);return f.push(l),new C(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$GI=C}),define(Ae[56],Re([1,0,2,44,45]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$MI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$LI=e.$KI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$JI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$II=e.$HI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(E){E[E.Run=1]="Run",E[E.Debug=2]="Debug",E[E.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable",E[E.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$HI=[2,4,8,16,32,64];const S=E=>"runId"in E;e.$II=S;var f;(function(E){E.serialize=r=>({range:r.range.toJSON(),uri:r.uri.toJSON()}),E.deserialize=r=>({range:T.$is.lift(r.range),uri:w.URI.revive(r.uri)})})(f||(e.IRichLocation=f={}));var P;(function(E){E[E.Error=0]="Error",E[E.Output=1]="Output"})(P||(e.TestMessageType=P={}));var k;(function(E){E.serialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,contextValue:r.contextValue,location:r.location&&f.serialize(r.location)}),E.deserialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,contextValue:r.contextValue,location:r.location&&f.deserialize(r.location)})})(k||(e.ITestErrorMessage=k={}));const u=(E,r)=>`${r?"s":"e"}${E}`;e.$JI=u;var p;(function(E){E.serialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&f.serialize(r.location)}),E.deserialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&f.deserialize(r.location)})})(p||(e.ITestOutputMessage=p={}));var m;(function(E){E.serialize=r=>r.type===0?k.serialize(r):p.serialize(r),E.deserialize=r=>r.type===0?k.deserialize(r):p.deserialize(r)})(m||(e.ITestMessage=m={}));var h;(function(E){E.serializeWithoutMessages=r=>({state:r.state,duration:r.duration,messages:[]}),E.serialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(m.serialize)}),E.deserialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(m.deserialize)})})(h||(e.ITestTaskState=h={}));const t="\0",i=(E,r)=>E+t+r;e.$KI=i;const c=E=>{const r=E.indexOf(t);return{ctrlId:E.slice(0,r),tagId:E.slice(r+1)}};e.$LI=c;var g;(function(E){E.serialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?.toJSON(),range:r.range?.toJSON()||null,description:r.description,error:r.error,sortText:r.sortText}),E.deserialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?w.URI.revive(r.uri):void 0,range:r.range?T.$is.lift(r.range):null,description:r.description,error:r.error,sortText:r.sortText})})(g||(e.ITestItem=g={}));var D;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(D||(e.TestItemExpandState=D={}));var b;(function(E){E.serialize=r=>({expand:r.expand,item:g.serialize(r.item)}),E.deserialize=r=>({controllerId:C.$GI.root(r.item.extId),expand:r.expand,item:g.deserialize(r.item)})})(b||(e.InternalTestItem=b={}));var n;(function(E){E.serialize=r=>{let d;return r.item&&(d={},r.item.label!==void 0&&(d.label=r.item.label),r.item.tags!==void 0&&(d.tags=r.item.tags),r.item.busy!==void 0&&(d.busy=r.item.busy),r.item.uri!==void 0&&(d.uri=r.item.uri?.toJSON()),r.item.range!==void 0&&(d.range=r.item.range?.toJSON()),r.item.description!==void 0&&(d.description=r.item.description),r.item.error!==void 0&&(d.error=r.item.error),r.item.sortText!==void 0&&(d.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:d}},E.deserialize=r=>{let d;return r.item&&(d={},r.item.label!==void 0&&(d.label=r.item.label),r.item.tags!==void 0&&(d.tags=r.item.tags),r.item.busy!==void 0&&(d.busy=r.item.busy),r.item.range!==void 0&&(d.range=r.item.range?T.$is.lift(r.item.range):null),r.item.description!==void 0&&(d.description=r.item.description),r.item.error!==void 0&&(d.error=r.item.error),r.item.sortText!==void 0&&(d.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:d}}})(n||(e.ITestItemUpdate=n={}));const a=(E,r)=>{r.expand!==void 0&&(E.expand=r.expand),r.item!==void 0&&(E.item=E.item?Object.assign(E.item,r.item):r.item)};e.$MI=a;var s;(function(E){E.serializeWithoutMessages=r=>({...b.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(h.serializeWithoutMessages)}),E.serialize=r=>({...b.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(h.serialize)}),E.deserialize=r=>({...b.deserialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(h.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.DocumentSynced=2]="DocumentSynced",E[E.Remove=3]="Remove",E[E.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",E[E.Retire=5]="Retire",E[E.AddTag=6]="AddTag",E[E.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var $;(function(E){E.deserialize=r=>r.op===0?{op:r.op,item:b.deserialize(r.item)}:r.op===1?{op:r.op,item:n.deserialize(r.item)}:r.op===2?{op:r.op,uri:w.URI.revive(r.uri),docv:r.docv}:r,E.serialize=r=>r.op===0?{op:r.op,item:b.serialize(r.item)}:r.op===1?{op:r.op,item:n.serialize(r.item)}:r})($||(e.TestsDiffOp=$={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(r){const d=this.p();for(const v of r)switch(v.op){case 0:this.k(b.deserialize(v.item),d);break;case 1:this.l(n.deserialize(v.item),d);break;case 3:this.m(v.itemId,d);break;case 5:this.o(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this.d.set(v.tag.id,v.tag);break;case 7:this.d.delete(v.id);break}d.complete?.()}k(r,d){const v=C.$GI.parentId(r.item.extId)?.toString();let R;if(!v)R=this.q(r),this.g.add(R),this.f.set(r.item.extId,R);else if(this.f.has(v)){const B=this.f.get(v);B.children.add(r.item.extId),R=this.q(r,B),this.f.set(r.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(r)}`);return}return d.add?.(R),r.expand===2&&this.h++,R}l(r,d){const v=this.f.get(r.extId);if(v)return r.expand!==void 0&&(v.expand===2&&this.h--,r.expand===2&&this.h++),(0,e.$MI)(v,r),d.update?.(v),v}m(r,d){const v=this.f.get(r);if(!v)return;const R=C.$GI.parentId(v.item.extId)?.toString();R?this.f.get(R).children.delete(v.item.extId):this.g.delete(v);const B=[[r]];for(;B.length;)for(const V of B.pop()){const j=this.f.get(V);j&&(B.push(j.children),this.f.delete(V),d.remove?.(j,j!==v),j.expand===2&&this.h--)}}o(r){}updatePendingRoots(r){this.j+=r}p(){return{}}}e.$NI=I}),define(Ae[76],Re([1,0,13,5,6,50,56,45]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.TestItemEventOp=void 0;var S;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const f=(c,g)=>c===g,k=Object.entries({range:(c,g)=>c===g?!0:!c||!g?!1:c.equalsRange(g),busy:f,label:f,description:f,error:f,sortText:f,tags:(c,g)=>!(c.length!==g.length||c.some(D=>!g.includes(D)))}),u=(c,g)=>{let D;for(const[b,n]of k)n(c[b],g[b])||(D?D[b]=g[b]:D={[b]:g[b]});return D};class p extends C.$jc{get root(){return this.s.root}constructor(g){super(),this.s=g,this.f=this.B(new w.$Rg(()=>this.flushDiff(),200)),this.g=this.B(new T.$ed),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(g){this.h=g;for(const D of this.tree.values())this.I(D)}get resolveHandler(){return this.h}collectDiff(){const g=this.m;return this.m=[],g}pushDiff(g){switch(g.op){case 2:{for(const D of this.m)if(D.op===2&&D.uri===g.uri){D.docv=g.docv;return}break}case 1:{const D=this.m[this.m.length-1];if(D){if(D.op===1&&D.item.extId===g.item.extId){(0,A.$MI)(D.item,g.item);return}if(D.op===0&&D.item.item.extId===g.item.extId){(0,A.$MI)(D.item,g.item);return}}break}}this.m.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,D){const b=this.tree.get(g);if(b){if((b.expandLevels===void 0||D>b.expandLevels)&&(b.expandLevels=D),b.expand===1){const n=this.L(b);return n.isOpen()?this.J(b,D-1):n.wait().then(()=>this.J(b,D-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.J(b,D-1)):this.J(b,D-1)}}dispose(){for(const g of this.tree.values())this.s.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(g,D){switch(D.op){case 3:this.N(l.$GI.joinToString(g.fullId,D.id));break;case 0:this.y(D.item,g);break;case 5:for(const b of D.ops)this.u(g,b);break;case 1:this.z(D.new,D.old,g.fullId.toString());break;case 2:this.I(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:D.update}});break;case 6:this.w(g.actual.uri);break;default:(0,L.$uc)(D)}}w(g){g&&this.pushDiff({op:2,uri:g,docv:this.s.getDocumentVersion(g)})}y(g,D){const b=l.$GI.fromExtHostTestItem(g,this.root.id,D?.actual),n=this.s.getApiFor(g);n.parent&&n.parent!==D?.actual&&this.s.getChildren(n.parent).delete(g.id);let a=this.tree.get(b.toString());if(!a){a={fullId:b,actual:g,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},g.tags.forEach(this.C,this),this.tree.set(a.fullId.toString(),a),this.F(g,D),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:a.expand,item:this.s.toITestItem(g)}}),this.H(g,a,D);return}if(a.actual===g){this.G(g,a,D);return}if(a.actual.uri?.toString()!==g.uri?.toString())return this.N(b.toString()),this.y(g,D);const s=this.s.getChildren(a.actual),o=a.actual,y=u(this.s.toITestItem(o),this.s.toITestItem(g));this.s.getApiFor(o).listener=void 0,a.actual=g,a.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(g.tags,o.tags,b.toString()),delete y.tags),this.u(a,{op:4,update:y})),this.H(g,a,D);for(const[$,I]of s)this.s.getChildren(g).get(I.id)||this.N(l.$GI.joinToString(b,I.id));this.w(a.actual.uri)}z(g,D,b){const n=new Set(D.map(a=>a.id));for(const a of g)n.delete(a.id)||this.C(a);this.pushDiff({op:1,item:{extId:b,item:{tags:g.map(a=>(0,A.$KI)(this.s.controllerId,a.id))}}}),n.forEach(this.D,this)}C(g){const D=this.j.get(g.id);D?D.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$KI)(this.s.controllerId,g.id)}}))}D(g){const D=this.j.get(g);D&&!--D.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,A.$KI)(this.s.controllerId,g)}))}F(g,D){this.s.getApiFor(g).parent=D&&D.actual!==this.root?D.actual:void 0}G(g,D,b){this.F(g,b);const n=this.s.getApiFor(g);n.parent=b?.actual,n.listener=a=>this.u(D,a),this.I(D)}H(g,D,b){this.G(g,D,b);for(const[n,a]of this.s.getChildren(g))this.y(a,D)}I(g){let D;this.h?g.resolveBarrier?D=g.resolveBarrier.isOpen()?3:2:D=g.actual.canResolveChildren?1:0:D=0,D!==g.expand&&(g.expand=D,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:D}}),D===1&&g.expandLevels!==void 0&&this.L(g))}J(g,D){if(D<0)return;const b=[];for(const[n,a]of this.s.getChildren(g.actual)){const s=this.expand(l.$GI.joinToString(g.fullId,a.id),D);(0,w.$sg)(s)&&b.push(s)}if(b.length)return Promise.all(b).then(()=>{})}L(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const a=new w.$Eg;return a.open(),a}g.expand=2,this.M(g);const D=g.resolveBarrier=new w.$Eg,b=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,a)};let n;try{n=this.h(g.actual===this.root?void 0:g.actual)}catch(a){b(a)}return(0,w.$sg)(n)?n.catch(b).then(()=>{D.open(),this.I(g)}):(D.open(),this.I(g)),g.resolveBarrier}M(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}N(g){const D=this.tree.get(g);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const b=[D];for(;b.length;){const n=b.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const a of n.actual.tags)this.D(a.id);this.tree.delete(n.fullId.toString());for(const[a,s]of this.s.getChildren(n.actual))b.push(this.tree.get(l.$GI.joinToString(n.fullId,s.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.$LL=p;class m extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.$ML=m;class h extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$NL=h;class t extends Error{constructor(g,D,b){super(`TestItem with ID "${g}" is from controller "${D}" and cannot be added as a child of an item from controller "${b}".`)}}e.$OL=t;const i=(c,g,D)=>{let b=new Map;return{get size(){return b.size},forEach(n,a){for(const s of b.values())n.call(a,s,this)},[Symbol.iterator](){return b.entries()},replace(n){const a=new Map,s=new Set(b.keys()),o={op:5,ops:[]};for(const y of n){if(!(y instanceof D))throw new h(y.id);const $=g(y).controllerId;if($!==c.controllerId)throw new t(y.id,$,c.controllerId);if(a.has(y.id))throw new m(y.id);a.set(y.id,y),s.delete(y.id),o.ops.push({op:0,item:y})}for(const y of s.keys())o.ops.push({op:3,id:y});c.listener?.(o),b=a},add(n){if(!(n instanceof D))throw new h(n.id);b.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){b.delete(n)&&c.listener?.({op:3,id:n})},get(n){return b.get(n)},toJSON(){return Array.from(b.values())}}};e.$PL=i}),define(Ae[102],Re([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$QL=void 0;const T=new WeakMap,C=(A,l)=>{const S={controllerId:l};return T.set(A,S),S};e.$QL=C;const L=A=>{const l=T.get(A);if(!l)throw new w.$NL(A?.id||"<unknown>");return l};e.$RL=L}),define(Ae[77],Re([1,0,12,2]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lob=e.$Kob=e.$Job=e.$Iob=e.$Hob=void 0,e.$Hob="vscode-cdn.net",e.$Iob=`vscode-resource.${e.$Hob}`,e.$Job=`'self' https://*.${e.$Hob}`;function C(l,S){return l.scheme===w.Schemas.http||l.scheme===w.Schemas.https?l:(S&&S.authority&&S.isRemote&&l.scheme===w.Schemas.file&&(l=T.URI.from({scheme:w.Schemas.vscodeRemote,authority:S.authority,path:l.path})),T.URI.from({scheme:w.Schemas.https,authority:`${l.scheme}+${L(l.authority)}.${e.$Iob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$Kob=C;function L(l){return l.replace(/./g,S=>{const f=S.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?S:"-"+f.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(S,f)=>String.fromCharCode(parseInt(f,16)))}e.$Lob=A}),define(Ae[199],Re([1,0,5,6,77]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;class L{constructor(l,S,f){this.d=l,this.e=S,this.f=f,this.a=0,this.b=new T.$ic,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const P=S.getVisibleTextEditors();for(const k of this.c.values())P.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,S,f,P,k){let u;for(const g of this.e.getVisibleTextEditors(!0))if(g.value===l){u=g;break}if(!u)throw new Error("not a visible editor");const p=this,m=this.a++,h=new w.$ed,t=new w.$ed,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(g){return(0,C.$Kob)(g,p.f)}get cspSource(){return C.$Job}set options(g){this.b=g,p.d.$setOptions(m,g)}get options(){return this.b}set html(g){this.a=g,p.d.$setHtml(m,g)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(g){return p.d.$postMessage(m,g)}},c=new class{constructor(){this.editor=l,this.line=S,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){p.c.has(m)&&(p.c.delete(m),p.d.$disposeEditorInset(m),t.fire(),t.dispose(),h.dispose())}};return this.d.$createEditorInset(m,u.id,u.value.document.uri,S+1,f,P||{},k.identifier,k.extensionLocation),this.c.set(m,{editor:l,inset:c,onDidReceiveMessage:h}),c}$onDidDispose(l){const S=this.c.get(l);S&&S.inset.dispose()}$onDidReceiveMessage(l,S){this.c.get(l)?.onDidReceiveMessage.fire(S)}}e.$Tbc=L}),define(Ae[200],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.VariableKind=e.$HM=void 0,e.$HM=(0,w.$Ah)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$IM=C}),define(Ae[201],Re([1,0,19,74,16,24,22,90,166,200,15]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,m,h,t){this.h=new Map,this.a=p,this.b=m,this.g=h,t&&(this.c=t.then(i=>this.i(i)))}i(p){if(A.$i){const m=Object.create(null);return Object.keys(p).forEach(h=>{m[h.toLowerCase()]=p[h]}),m}return p}resolveWithEnvironment(p,m,h){return this.l({env:this.i(p),userHome:void 0},m?m.uri:void 0,h)}async resolveAsync(p,m){const h={env:await this.c,userHome:await this.g};return this.l(h,p?p.uri:void 0,m)}async j(p,m,h,t){const i=L.$Um(m);A.$i&&i.windows?Object.keys(i.windows).forEach(g=>i[g]=i.windows[g]):A.$j&&i.osx?Object.keys(i.osx).forEach(g=>i[g]=i.osx[g]):A.$k&&i.linux&&Object.keys(i.linux).forEach(g=>i[g]=i.linux[g]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,p?p.uri:void 0,i,h,t)}async resolveAnyAsync(p,m,h){return this.j(p,m,h)}async resolveAnyMap(p,m,h){const t=new Map;return{newConfig:await this.j(p,m,h,t),resolvedVariables:t}}resolveWithInteractionReplace(p,m,h,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,m,h,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,m){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,m)}async l(p,m,h,t,i){if(C.$if(h))return this.m(p,m,h,t,i);if(Array.isArray(h))return Promise.all(h.map(c=>this.l(p,m,c,t,i)));if(C.$kf(h)){const c=Object.create(null),g=await Promise.all(Object.keys(h).map(async D=>[await this.m(p,m,D,t,i),await this.l(p,m,h[D],t,i)]));for(const[D,b]of g)c[D]=b;return c}return h}m(p,m,h,t,i){return(0,P.$De)(h,k.VARIABLE_REGEXP,async(c,g)=>{if(g.includes(k.VARIABLE_LHS))return c;let D=await this.o(p,c,g,m,t);return i?.set(g,D),D!==c&&C.$if(D)&&D.match(k.VARIABLE_REGEXP)&&(D=await this.m(p,m,D,t,i)),D})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,m,h,t,i){let c;const g=h.split(":");g.length>1&&(h=g[0],c=g[1]);const D=a=>{const s=this.a.getFilePath();if(s)return(0,l.$cA)(s);throw new f.$IM(a,(0,S.localize)(0,null,m))},b=a=>{const s=D(a);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$cA)(o)}throw new f.$IM(a,(0,S.localize)(1,null,m,w.$_d(s)))},n=a=>{if(c){const s=this.a.getFolderUri(c);if(s)return s;throw new f.$IM(a,(0,S.localize)(2,null,m,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$IM(a,(0,S.localize)(3,null,m)):new f.$IM(a,(0,S.localize)(4,null,m))};switch(h){case"env":if(c){if(p.env){const a=p.env[A.$i?c.toLowerCase():c];if(C.$if(a))return a}return""}throw new f.$IM(f.VariableKind.Env,(0,S.localize)(5,null,m));case"config":if(c){const a=this.a.getConfigurationValue(t,c);if(C.$rf(a))throw new f.$IM(f.VariableKind.Config,(0,S.localize)(6,null,m,c));if(C.$kf(a))throw new f.$IM(f.VariableKind.Config,(0,S.localize)(7,null,m,c));return a}throw new f.$IM(f.VariableKind.Config,(0,S.localize)(8,null,m));case"command":return this.p(f.VariableKind.Command,m,c,i,"command");case"input":return this.p(f.VariableKind.Input,m,c,i,"input");case"extensionInstallFolder":if(c){const a=await this.a.getExtension(c);if(!a)throw new f.$IM(f.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,m,c));return this.n(a.extensionLocation)}throw new f.$IM(f.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,m));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,l.$cA)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,l.$cA)(this.n(n(f.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$cA)(w.$_d(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new f.$IM(f.VariableKind.UserHome,(0,S.localize)(11,null,m))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new f.$IM(f.VariableKind.LineNumber,(0,S.localize)(12,null,m))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new f.$IM(f.VariableKind.SelectedText,(0,S.localize)(13,null,m))}case"file":return D(f.VariableKind.File);case"fileWorkspaceFolder":return b(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?w.$0d(this.n(n(f.VariableKind.RelativeFile)),D(f.VariableKind.RelativeFile)):D(f.VariableKind.RelativeFile);case"relativeFileDirname":{const a=w.$$d(D(f.VariableKind.RelativeFileDirname));if(t||c){const s=w.$0d(this.n(n(f.VariableKind.RelativeFileDirname)),a);return s.length===0?".":s}return a}case"fileDirname":return w.$$d(D(f.VariableKind.FileDirname));case"fileExtname":return w.$ae(D(f.VariableKind.FileExtname));case"fileBasename":return w.$_d(D(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=w.$_d(D(f.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-w.$ae(a).length)}case"fileDirnameBasename":return w.$_d(w.$$d(D(f.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||m}case"execInstallFolder":{const a=this.a.getAppRoot();return a||m}case"pathSeparator":return w.sep;default:try{const a=c?`${h}:${c}`:h;return this.p(f.VariableKind.Unknown,m,a,i,void 0)}catch{return m}}}}p(p,m,h,t,i){if(h&&t){const c=i===void 0?t[h]:t[i+":"+h];if(typeof c=="string")return c;throw new f.$IM(p,(0,S.localize)(14,null,m))}return m}}e.$WM=k}),define(Ae[103],Re([1,0,4,99]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=e.$4C=e.OpenEditorContext=e.GroupsOrder=e.$3C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$2C=void 0,e.$2C=(0,w.$Ah)("editorGroupsService");var C;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var L;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var S;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function f(m){const h=m;return(0,T.$RE)(h?.editor)&&(0,T.$RE)(h?.replacement)}e.$3C=f;var P;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var k;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function u(m){const h=m;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.$4C=u;function p(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$5C=p}),define(Ae[202],Re([1,0,4,103]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9C=e.$8C=e.$7C=e.$6C=void 0,e.$6C=(0,w.$Ah)("editorService"),e.$7C=-1,e.$8C=-2;function C(L){const A=L;return typeof L=="number"||(0,T.$4C)(A)}e.$9C=C}),define(Ae[8],Re([1,0,18,25,123,203,49,28,117,68,67,24,16,2,44,78,94,102,99,75,45,56,202,7]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$UL=e.$TL=e.MarkdownString=e.$SL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ce){function Te(H){const{selectionStartLineNumber:Fe,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:We}=H,xe=new a.$WJ(Fe-1,Be-1),pt=new a.$WJ(Ge-1,We-1);return new a.$YJ(xe,pt)}Ce.to=Te;function ge(H){const{anchor:Fe,active:Be}=H;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=ge})(s||(e.Selection=s={}));var o;(function(Ce){function Te(H){if(!H)return;const{start:Fe,end:Be}=H;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Te;function ge(H){if(!H)return;const{startLineNumber:Fe,startColumn:Be,endLineNumber:Ge,endColumn:We}=H;return new a.$XJ(Fe-1,Be-1,Ge-1,We-1)}Ce.to=ge})(o||(e.Range=o={}));var y;(function(Ce){function Te(ge){switch(ge){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ce.to=Te})(y||(e.TokenType=y={}));var $;(function(Ce){function Te(H){return new a.$WJ(H.lineNumber-1,H.column-1)}Ce.to=Te;function ge(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=ge})($||(e.Position=$={}));var I;(function(Ce){function Te(Fe,Be,Ge){return(0,w.$Eb)((0,w.$Zb)(Fe).map(We=>ge(We,Be,Ge)))}Ce.from=Te;function ge(Fe,Be,Ge){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ge?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:H(Fe.scheme,Be),pattern:st.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ge?.isBuiltin}}function H(Fe,Be){return Be&&typeof Fe=="string"?Be.transformOutgoingScheme(Fe):Fe}})(I||(e.DocumentSelector=I={}));var E;(function(Ce){function Te(H){switch(H){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ce.from=Te;function ge(H){switch(H){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(E||(e.DiagnosticTag=E={}));var r;(function(Ce){function Te(H){let Fe;return H.code&&((0,u.$if)(H.code)||(0,u.$mf)(H.code)?Fe=String(H.code):Fe={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Fe,severity:v.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(d.from),tags:Array.isArray(H.tags)?(0,w.$Eb)(H.tags.map(E.from)):void 0}}Ce.from=Te;function ge(H){const Fe=new a.$0J(o.to(H),H.message,v.to(H.severity));return Fe.source=H.source,Fe.code=(0,u.$if)(H.code)?H.code:H.code?.value,Fe.relatedInformation=H.relatedInformation&&H.relatedInformation.map(d.to),Fe.tags=H.tags&&(0,w.$Eb)(H.tags.map(E.to)),Fe}Ce.to=ge})(r||(e.Diagnostic=r={}));var d;(function(Ce){function Te(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Te;function ge(H){return new a.$9J(new a.$8J(H.resource,o.to(H)),H.message)}Ce.to=ge})(d||(e.DiagnosticRelatedInformation=d={}));var v;(function(Ce){function Te(H){switch(H){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Te;function ge(H){switch(H){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ce.to=ge})(v||(e.DiagnosticSeverity=v={}));var R;(function(Ce){function Te(H){return typeof H=="number"&&H>=a.ViewColumn.One?H-1:H===a.ViewColumn.Beside?n.$8C:n.$7C}Ce.from=Te;function ge(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(R||(e.ViewColumn=R={}));function B(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!B(Ce[0])}e.$SL=V;var j;(function(Ce){function Te(We){return We.map(Ce.from)}Ce.fromMany=Te;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let xe;if(ge(We)){const{language:ft,value:mt}=We;xe={value:"```"+ft+`
`+mt+"\n```\n"}}else a.$kK.isMarkdownString(We)?xe={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?xe={value:We}:xe={value:""};const pt=Object.create(null);xe.uris=pt;const bt=ft=>{try{let mt=p.URI.parse(ft,!0);mt=mt.with({query:Fe(mt.query,pt)}),pt[ft]=mt}catch{}return""},dt=new S.marked.Renderer;return dt.link=bt,dt.image=ft=>typeof ft=="string"?bt(A.$4j(ft).href):"",(0,S.marked)(xe.value,{renderer:dt}),xe}Ce.from=H;function Fe(We,xe){if(!We)return We;let pt;try{pt=(0,f.$9g)(We)}catch{}if(!pt)return We;let bt=!1;return pt=(0,k.$Wm)(pt,dt=>{if(p.URI.isUri(dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[ft]=dt,bt=!0,ft}else return}),bt?JSON.stringify(pt):We}function Be(We){const xe=new a.$kK(We.value,We.supportThemeIcons);return xe.isTrusted=We.isTrusted,xe.supportHtml=We.supportHtml,xe.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,xe}Ce.to=Be;function Ge(We){if(We)return typeof We=="string"?We:Ce.from(We)}Ce.fromStrict=Ge})(j||(e.MarkdownString=j={}));function W(Ce){return V(Ce)?Ce.map(Te=>({range:o.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?j.fromMany(Te.hoverMessage):Te.hoverMessage?j.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Ce.map(Te=>({range:o.from(Te)}))}e.$TL=W;function N(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$UL=N;var z;(function(Ce){function Te(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?N(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Te})(z||(e.ThemableDecorationAttachmentRenderOptions=z={}));var ee;(function(Ce){function Te(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?N(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?z.from(ge.before):void 0,after:ge.after?z.from(ge.after):void 0}}Ce.from=Te})(ee||(e.ThemableDecorationRenderOptions=ee={}));var X;(function(Ce){function Te(ge){if(typeof ge>"u")return ge;switch(ge){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Te})(X||(e.DecorationRangeBehavior=X={}));var Ee;(function(Ce){function Te(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?X.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ee.from(ge.light):void 0,dark:ge.dark?ee.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?N(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?z.from(ge.before):void 0,after:ge.after?z.from(ge.after):void 0}}Ce.from=Te})(Ee||(e.DecorationRenderOptions=Ee={}));var De;(function(Ce){function Te(H){return{text:H.newText,eol:H.newEol&&Ze.from(H.newEol),range:o.from(H.range)}}Ce.from=Te;function ge(H){const Fe=new a.$3J(o.to(H.range),H.text);return Fe.newEol=typeof H.eol>"u"?void 0:Ze.to(H.eol),Fe}Ce.to=ge})(De||(e.TextEdit=De={}));var Pe;(function(Ce){function Te(H,Fe){const Be={edits:[]};if(H instanceof a.$6J){const Ge=new l.$zi;for(const We of H._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of H._allEntries())if(We._type===1){let xe;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?xe={type:"base64",value:(0,T.$Yd)(T.$Ed.wrap(We.options.contents))}:xe={type:"dataTransferItem",id:We.options.contents._itemId}),Be.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:xe},metadata:We.metadata})}else We._type===2?Be.edits.push({resource:We.uri,textEdit:De.from(We.edit),versionId:Ge.has(We.uri)?void 0:Fe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Be.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Fe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Be.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Be.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(gt.from)}})}return Be}Ce.from=Te;function ge(H){const Fe=new a.$6J,Be=new l.$yi;for(const Ge of H.edits)if(Ge.textEdit){const We=Ge,xe=p.URI.revive(We.resource),pt=o.to(We.textEdit.range),bt=We.textEdit.text,dt=We.textEdit.insertAsSnippet;let ft;dt?ft=a.$5J.replace(pt,new a.$7J(bt)):ft=a.$3J.replace(pt,bt);const mt=Be.get(xe);mt?mt.push(ft):Be.set(xe,[ft])}else Fe.renameFile(p.URI.revive(Ge.oldResource),p.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of Be)Fe.set(Ge,We);return Fe}Ce.to=ge})(Pe||(e.WorkspaceEdit=Pe={}));var Z;(function(Ce){const Te=Object.create(null);Te[a.SymbolKind.File]=0,Te[a.SymbolKind.Module]=1,Te[a.SymbolKind.Namespace]=2,Te[a.SymbolKind.Package]=3,Te[a.SymbolKind.Class]=4,Te[a.SymbolKind.Method]=5,Te[a.SymbolKind.Property]=6,Te[a.SymbolKind.Field]=7,Te[a.SymbolKind.Constructor]=8,Te[a.SymbolKind.Enum]=9,Te[a.SymbolKind.Interface]=10,Te[a.SymbolKind.Function]=11,Te[a.SymbolKind.Variable]=12,Te[a.SymbolKind.Constant]=13,Te[a.SymbolKind.String]=14,Te[a.SymbolKind.Number]=15,Te[a.SymbolKind.Boolean]=16,Te[a.SymbolKind.Array]=17,Te[a.SymbolKind.Object]=18,Te[a.SymbolKind.Key]=19,Te[a.SymbolKind.Null]=20,Te[a.SymbolKind.EnumMember]=21,Te[a.SymbolKind.Struct]=22,Te[a.SymbolKind.Event]=23,Te[a.SymbolKind.Operator]=24,Te[a.SymbolKind.TypeParameter]=25;function ge(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Ce.from=ge;function H(Fe){for(const Be in Te)if(Te[Be]===Fe)return Number(Be);return a.SymbolKind.Property}Ce.to=H})(Z||(e.SymbolKind=Z={}));var ue;(function(Ce){function Te(H){switch(H){case a.SymbolTag.Deprecated:return 1}}Ce.from=Te;function ge(H){switch(H){case 1:return a.SymbolTag.Deprecated}}Ce.to=ge})(ue||(e.SymbolTag=ue={}));var ye;(function(Ce){function Te(H){return{name:H.name,kind:Z.from(H.kind),tags:H.tags&&H.tags.map(ue.from),containerName:H.containerName,location:q.from(H.location)}}Ce.from=Te;function ge(H){const Fe=new a.$aK(H.name,Z.to(H.kind),H.containerName,q.to(H.location));return Fe.tags=H.tags&&H.tags.map(ue.to),Fe}Ce.to=ge})(ye||(e.WorkspaceSymbol=ye={}));var ce;(function(Ce){function Te(H){const Fe={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:Z.from(H.kind),tags:H.tags?.map(ue.from)??[]};return H.children&&(Fe.children=H.children.map(Te)),Fe}Ce.from=Te;function ge(H){const Fe=new a.$bK(H.name,H.detail,Z.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,w.$Ib)(H.tags)&&(Fe.tags=H.tags.map(ue.to)),H.children&&(Fe.children=H.children.map(ge)),Fe}Ce.to=ge})(ce||(e.DocumentSymbol=ce={}));var $e;(function(Ce){function Te(H){const Fe=new a.$gK(Z.to(H.kind),H.name,H.detail||"",p.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}Ce.to=Te;function ge(H,Fe,Be){if(Fe=Fe??H._sessionId,Be=Be??H._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,name:H.name,detail:H.detail,kind:Z.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ce.from=ge})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Te(ge){return new a.$hK($e.to(ge.from),ge.fromRanges.map(H=>o.to(H)))}Ce.to=Te})(ie||(e.CallHierarchyIncomingCall=ie={}));var O;(function(Ce){function Te(ge){return new a.$iK($e.to(ge.to),ge.fromRanges.map(H=>o.to(H)))}Ce.to=Te})(O||(e.CallHierarchyOutgoingCall=O={}));var q;(function(Ce){function Te(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Ce.from=Te;function ge(H){return new a.$8J(p.URI.revive(H.uri),o.to(H.range))}Ce.to=ge})(q||(e.location=q={}));var le;(function(Ce){function Te(H){const Fe=H,Be=H;return{originSelectionRange:Fe.originSelectionRange?o.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Be.uri,range:o.from(Fe.targetRange?Fe.targetRange:Be.range),targetSelectionRange:Fe.targetSelectionRange?o.from(Fe.targetSelectionRange):void 0}}Ce.from=Te;function ge(H){return{targetUri:p.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Ce.to=ge})(le||(e.DefinitionLink=le={}));var we;(function(Ce){function Te(H){return{range:o.from(H.range),contents:j.fromMany(H.contents)}}Ce.from=Te;function ge(H){return new a.$$J(H.contents.map(j.to),o.to(H.range))}Ce.to=ge})(we||(e.Hover=we={}));var ve;(function(Ce){function Te(H){return{range:o.from(H.range),expression:H.expression}}Ce.from=Te;function ge(H){return new a.$5K(o.to(H.range),H.expression)}Ce.to=ge})(ve||(e.EvaluatableExpression=ve={}));var me;(function(Ce){function Te(H){if(H instanceof a.$6K)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof a.$7K)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof a.$8K)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Te;function ge(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Ce.to=ge})(me||(e.InlineValue=me={}));var ke;(function(Ce){function Te(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Ce.from=Te;function ge(H){return new a.$9K(H.frameId,o.to(H.stoppedLocation))}Ce.to=ge})(ke||(e.InlineValueContext=ke={}));var se;(function(Ce){function Te(H){return{range:o.from(H.range),kind:H.kind}}Ce.from=Te;function ge(H){return new a.$_J(o.to(H.range),H.kind)}Ce.to=ge})(se||(e.DocumentHighlight=se={}));var he;(function(Ce){function Te(ge){switch(ge){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ce.to=Te})(he||(e.CompletionTriggerKind=he={}));var re;(function(Ce){function Te(ge){return{triggerKind:he.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Te})(re||(e.CompletionContext=re={}));var oe;(function(Ce){function Te(H){switch(H){case a.CompletionItemTag.Deprecated:return 1}}Ce.from=Te;function ge(H){switch(H){case 1:return a.CompletionItemTag.Deprecated}}Ce.to=ge})(oe||(e.CompletionItemTag=oe={}));var fe;(function(Ce){const Te=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ge(Be){return Te.get(Be)??9}Ce.from=ge;const H=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(Be){return H.get(Be)??a.CompletionItemKind.Property}Ce.to=Fe})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(Ce){function Te(ge,H){const Fe=new a.$qK(ge.label);return Fe.insertText=ge.insertText,Fe.kind=fe.to(ge.kind),Fe.tags=ge.tags?.map(oe.to),Fe.detail=ge.detail,Fe.documentation=A.$Yj(ge.documentation)?j.to(ge.documentation):ge.documentation,Fe.sortText=ge.sortText,Fe.filterText=ge.filterText,Fe.preselect=ge.preselect,Fe.commitCharacters=ge.commitCharacters,m.$is.isIRange(ge.range)?Fe.range=o.to(ge.range):typeof ge.range=="object"&&(Fe.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Fe.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Fe.insertText=new a.$7J(ge.insertText):(Fe.insertText=ge.insertText,Fe.textEdit=Fe.range instanceof a.$XJ?new a.$3J(Fe.range,Fe.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ge.additionalTextEdits.map(Be=>De.to(Be))),Fe.command=H&&ge.command?H.fromInternal(ge.command):void 0,Fe}Ce.to=Te})(Ie||(e.CompletionItem=Ie={}));var F;(function(Ce){function Te(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:j.fromStrict(H.documentation)}}Ce.from=Te;function ge(H){return{label:H.label,documentation:A.$Yj(H.documentation)?j.to(H.documentation):H.documentation}}Ce.to=ge})(F||(e.ParameterInformation=F={}));var K;(function(Ce){function Te(H){return{label:H.label,documentation:j.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(F.from):[],activeParameter:H.activeParameter}}Ce.from=Te;function ge(H){return{label:H.label,documentation:A.$Yj(H.documentation)?j.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(F.to):[],activeParameter:H.activeParameter}}Ce.to=ge})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Te(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.from):[]}}Ce.from=Te;function ge(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.to):[]}}Ce.to=ge})(G||(e.SignatureHelp=G={}));var Q;(function(Ce){function Te(ge,H){const Fe=new a.$pK($.to(H.position),typeof H.label=="string"?H.label:H.label.map(J.to.bind(void 0,ge)),H.kind&&x.to(H.kind));return Fe.textEdits=H.textEdits&&H.textEdits.map(De.to),Fe.tooltip=A.$Yj(H.tooltip)?j.to(H.tooltip):H.tooltip,Fe.paddingLeft=H.paddingLeft,Fe.paddingRight=H.paddingRight,Fe}Ce.to=Te})(Q||(e.InlayHint=Q={}));var J;(function(Ce){function Te(ge,H){const Fe=new a.$oK(H.label);return Fe.tooltip=A.$Yj(H.tooltip)?j.to(H.tooltip):H.tooltip,h.Command.is(H.command)&&(Fe.command=ge.fromInternal(H.command)),H.location&&(Fe.location=q.to(H.location)),Fe}Ce.to=Te})(J||(e.InlayHintLabelPart=J={}));var x;(function(Ce){function Te(H){return H}Ce.from=Te;function ge(H){return H}Ce.to=ge})(x||(e.InlayHintKind=x={}));var ae;(function(Ce){function Te(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Te;function ge(H){let Fe;if(H.url)try{Fe=typeof H.url=="string"?p.URI.parse(H.url,!0):p.URI.revive(H.url)}catch{}return new a.$vK(o.to(H.range),Fe)}Ce.to=ge})(ae||(e.DocumentLink=ae={}));var Le;(function(Ce){function Te(H){const Fe=new a.$yK(H.label);return H.textEdit&&(Fe.textEdit=De.to(H.textEdit)),H.additionalTextEdits&&(Fe.additionalTextEdits=H.additionalTextEdits.map(Be=>De.to(Be))),Fe}Ce.to=Te;function ge(H){return{label:H.label,textEdit:H.textEdit?De.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Fe=>De.from(Fe)):void 0}}Ce.from=ge})(Le||(e.ColorPresentation=Le={}));var Ue;(function(Ce){function Te(H){return new a.$wK(H[0],H[1],H[2],H[3])}Ce.to=Te;function ge(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=ge})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Te(H){return{range:o.from(H.range)}}Ce.from=Te;function ge(H){return new a.$fK(o.to(H.range))}Ce.to=ge})(Qe||(e.SelectionRange=Qe={}));var He;(function(Ce){function Te(ge){switch(ge){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ce.to=Te})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Ce){function Te(H){switch(H){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Te;function ge(H){switch(H){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ce.to=ge})(et||(e.TextEditorLineNumbersStyle=et={}));var Ze;(function(Ce){function Te(H){if(H===a.EndOfLine.CRLF)return 1;if(H===a.EndOfLine.LF)return 0}Ce.from=Te;function ge(H){if(H===1)return a.EndOfLine.CRLF;if(H===0)return a.EndOfLine.LF}Ce.to=ge})(Ze||(e.EndOfLine=Ze={}));var _e;(function(Ce){function Te(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Te})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Te(H){const Fe={start:H.start+1,end:H.end+1};return H.kind&&(Fe.kind=tt.from(H.kind)),Fe}Ce.from=Te;function ge(H){const Fe={start:H.start-1,end:H.end-1};return H.kind&&(Fe.kind=tt.to(H.kind)),Fe}Ce.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Te(H){if(H)switch(H){case a.FoldingRangeKind.Comment:return h.$0s.Comment;case a.FoldingRangeKind.Imports:return h.$0s.Imports;case a.FoldingRangeKind.Region:return h.$0s.Region}}Ce.from=Te;function ge(H){if(H)switch(H.value){case h.$0s.Comment.value:return a.FoldingRangeKind.Comment;case h.$0s.Imports.value:return a.FoldingRangeKind.Imports;case h.$0s.Region.value:return a.FoldingRangeKind.Region}}Ce.to=ge})(tt||(e.FoldingRangeKind=tt={}));var Oe;(function(Ce){function Te(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.$EE.id:void 0}}Ce.from=Te})(Oe||(e.TextEditorOpenOptions=Oe={}));var st;(function(Ce){function Te(Be){return Be instanceof a.$SK?Be.toJSON():typeof Be=="string"?Be:ge(Be)||H(Be)?new a.$SK(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Te;function ge(Be){const Ge=Be;return Ge?p.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function H(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Fe(Be){return typeof Be=="string"?Be:new a.$SK(p.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Fe})(st||(e.GlobPattern=st={}));var _;(function(Ce){function Te(ge){if(ge){if(Array.isArray(ge))return ge.map(Te);if(typeof ge=="string")return ge;{const H=ge;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Te})(_||(e.LanguageSelector=_={}));var Y;(function(Ce){function Te(H){return!!H&&typeof H=="object"&&"selections"in H&&Array.isArray(H.selections)&&H.selections.every(Fe=>Fe instanceof a.$YJ)&&"related"in H&&Array.isArray(H.related)&&H.related.every(Fe=>Fe&&typeof Fe=="object"&&p.URI.isUri(Fe.uri)&&Fe.range instanceof a.$XJ)}Ce.is=Te;function ge(H){return{selections:H.selections.map(Fe=>s.from(Fe)),related:H.related.map(Fe=>({uri:p.URI.from(Fe.uri),range:o.from(Fe.range)}))}}Ce.from=ge})(Y||(e.MappedEditsContext=Y={}));var pe;(function(Ce){function Te(H){return{start:H.start,end:H.end}}Ce.from=Te;function ge(H){return new a.$hL(H.start,H.end)}Ce.to=ge})(pe||(e.NotebookRange=pe={}));var je;(function(Ce){function Te(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Te;function ge(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=ge})(je||(e.NotebookCellExecutionSummary=je={}));var ze;(function(Ce){function Te(ge){if(ge===g.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ge===g.NotebookCellExecutionState.Pending)return;if(ge===g.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Te})(ze||(e.NotebookCellExecutionState=ze={}));var Ye;(function(Ce){function Te(H){switch(H){case a.NotebookCellKind.Markup:return g.CellKind.Markup;case a.NotebookCellKind.Code:default:return g.CellKind.Code}}Ce.from=Te;function ge(H){switch(H){case g.CellKind.Markup:return a.NotebookCellKind.Markup;case g.CellKind.Code:default:return a.NotebookCellKind.Code}}Ce.to=ge})(Ye||(e.NotebookCellKind=Ye={}));var nt;(function(Ce){function Te(H){const Fe={metadata:H.metadata??Object.create(null),cells:[]};for(const Be of H.cells)a.$iL.validate(Be),Fe.cells.push(gt.from(Be));return Fe}Ce.from=Te;function ge(H){const Fe=new a.$jL(H.cells.map(gt.to));return(0,u.$vf)(H.metadata)||(Fe.metadata=H.metadata),Fe}Ce.to=ge})(nt||(e.NotebookData=nt={}));var gt;(function(Ce){function Te(H){return{cellKind:Ye.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:je.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ft.from):[]}}Ce.from=Te;function ge(H){return new a.$iL(Ye.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ft.to):void 0,H.metadata,H.internalMetadata?je.to(H.internalMetadata):void 0)}Ce.to=ge})(gt||(e.NotebookCellData=gt={}));var vt;(function(Ce){function Te(H){return{mime:H.mime,valueBytes:T.$Ed.wrap(H.data)}}Ce.from=Te;function ge(H){return new a.$kL(H.valueBytes.buffer,H.mime)}Ce.to=ge})(vt||(e.NotebookCellOutputItem=vt={}));var Ft;(function(Ce){function Te(H){return{outputId:H.id,items:H.items.map(vt.from),metadata:H.metadata}}Ce.from=Te;function ge(H){const Fe=H.items.map(vt.to);return new a.$lL(Fe,H.outputId,H.metadata)}Ce.to=ge})(Ft||(e.NotebookCellOutput=Ft={}));var Yt;(function(Ce){function Te(Fe){return H(Fe)?{include:st.from(Fe.include)??void 0,exclude:st.from(Fe.exclude)??void 0}:st.from(Fe)??void 0}Ce.from=Te;function ge(Fe){return H(Fe)?{include:st.to(Fe.include),exclude:st.to(Fe.exclude)}:st.to(Fe)}Ce.to=ge;function H(Fe){const Be=Fe;return Be?!(0,u.$rf)(Be.include)&&!(0,u.$rf)(Be.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Vt;(function(Ce){function Te(ge,H,Fe){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Be,Fe),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Te})(Vt||(e.NotebookStatusBarItem=Vt={}));var wt;(function(Ce){function Te(ge,H,Fe){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:H.toInternal(Be,Fe),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Te})(wt||(e.NotebookKernelSourceAction=wt={}));var Mt;(function(Ce){function Te(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Te})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var Nt;(function(Ce){function Te(H){return{uri:H.uri,provides:H.provides}}Ce.from=Te;function ge(H){return new a.$nL(p.URI.revive(H.uri),H.provides)}Ce.to=ge})(Nt||(e.NotebookRendererScript=Nt={}));var Jt;(function(Ce){function Te(H){return{message:j.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Ce.from=Te;function ge(H){const Fe=new a.$tL(typeof H.message=="string"?H.message:j.to(H.message));return Fe.actualOutput=H.actual,Fe.expectedOutput=H.expected,Fe.contextValue=H.contextValue,Fe.location=H.location?q.to(H.location):void 0,Fe}Ce.to=ge})(Jt||(e.TestMessage=Jt={}));var Pt;(function(Ce){Ce.namespace=b.$KI,Ce.denamespace=b.$LI})(Pt||(e.TestTag=Pt={}));var At;(function(Ce){function Te(H){const Fe=(0,i.$RL)(H).controllerId;return{extId:D.$GI.fromExtHostTestItem(H,Fe).toString(),label:H.label,uri:p.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Be=>Pt.namespace(Fe,Be.id)),range:m.$is.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&j.fromStrict(H.error)||null}}Ce.from=Te;function ge(H){return{parent:void 0,error:void 0,id:D.$GI.fromString(H.extId).localId,label:H.label,uri:p.URI.revive(H.uri),tags:(H.tags||[]).map(Fe=>{const{tagId:Be}=Pt.denamespace(Fe);return new a.$uL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=ge})(At||(e.TestItem=At={})),function(Ce){function Te(H){return{id:H.id}}Ce.from=Te;function ge(H){return new a.$uL(H.id)}Ce.to=ge}(Pt||(e.TestTag=Pt={}));var zt;(function(Ce){const Te=(H,Fe)=>{const Be=[];for(const[We,xe]of Fe)D.$GI.compare(xe.item.extId,We)===2&&(Fe.delete(We),Be.push(xe));const Ge={...At.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(xe=>xe.type===0).map(Jt.to)})),children:Be.map(We=>Te(We,Fe))};for(const We of Ge.children)We.parent=Ge;return Ge};function ge(H){const Fe=[],Be=new Map;for(const Ge of H.items){Be.set(Ge.item.extId,Ge);const We=D.$GI.root(Ge.item.extId);H.request.targets.some(xe=>xe.controllerId===We&&xe.testIds.includes(Ge.item.extId))&&Fe.push(Ge)}return{completedAt:H.completedAt,results:Fe.map(Ge=>Te(Ge,Be))}}Ce.to=ge})(zt||(e.TestResults=zt={}));var jt;(function(Ce){function Te(Be){return{covered:Be.covered,total:Be.covered}}function ge(Be){return"line"in Be?$.from(Be):o.from(Be)}function H(Be){return"branches"in Be?{count:Be.executionCount,location:ge(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ge(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:ge(Be.location)}}Ce.fromDetailed=H;function Fe(Be){return{uri:Be.uri,statement:Te(Be.statementCoverage),branch:Be.branchCoverage&&Te(Be.branchCoverage),function:Be.functionCoverage&&Te(Be.functionCoverage),details:Be.detailedCoverage?.map(H)}}Ce.fromFile=Fe})(jt||(e.TestCoverage=jt={}));var qt;(function(Ce){function Te(ge){switch(ge){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ce.to=Te})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Ce){function Te(H){const Fe=new a.$AL(Z.to(H.kind),H.name,H.detail||"",p.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}Ce.to=Te;function ge(H,Fe,Be){if(Fe=Fe??H._sessionId,Be=Be??H._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,kind:Z.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ce.from=ge})(Bt||(e.TypeHierarchyItem=Bt={}));var at;(function(Ce){function Te(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Te})(at||(e.ViewBadge=at={}));var ut;(function(Ce){function Te(Be,Ge,We){const xe=Ge.fileData;return xe?new a.$LK(new a.$MK(xe.name,p.URI.revive(xe.uri),xe.id,(0,L.$bb)(()=>We(xe.id)))):Be===P.$Fr.uriList&&Ge.uriListData?new a.$KK(Fe(Ge.uriListData)):new a.$KK(Ge.asString)}Ce.to=Te;async function ge(Be,Ge){const We=await Ge.asString();if(Be===P.$Fr.uriList)return{asString:We,fileData:void 0,uriListData:H(We)};const xe=Ge.asFile();return{asString:We,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}Ce.from=ge;function H(Be){return C.$Rs.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return p.URI.parse(Ge)}catch{}return Ge})}function Fe(Be){return C.$Rs.create(Be.map(Ge=>typeof Ge=="string"?Ge:p.URI.revive(Ge)))}})(ut||(e.DataTransferItem=ut={}));var Ht;(function(Ce){function Te(H,Fe){const Be=H.items.map(([Ge,We])=>[Ge,ut.to(Ge,We,Fe)]);return new a.$NK(Be)}Ce.toDataTransfer=Te;async function ge(H){const Fe={items:[]},Be=[];for(const[Ge,We]of H)Be.push((async()=>{Fe.items.push([Ge,await ut.from(Ge,We)])})());return await Promise.all(Be),Fe}Ce.from=ge})(Ht||(e.DataTransfer=Ht={}));var Ct;(function(Ce){function Te(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Te;function ge(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=ge})(Ct||(e.ChatReplyFollowup=Ct={}));var Dt;(function(Ce){function Te(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Ct.from(ge)}Ce.from=Te})(Dt||(e.ChatFollowup=Dt={}));var ht;(function(Ce){function Te(H){const Fe=new a.$KL(St.to(H.role),H.content);return Fe.name=H.name,Fe}Ce.to=Te;function ge(H){return{role:St.from(H.role),content:H.content,name:H.name}}Ce.from=ge})(ht||(e.ChatMessage=ht={}));var St;(function(Ce){function Te(H){switch(H){case 0:return a.ChatMessageRole.System;case 1:return a.ChatMessageRole.User;case 2:return a.ChatMessageRole.Assistant;case 3:return a.ChatMessageRole.Function}}Ce.to=Te;function ge(H){switch(H){case a.ChatMessageRole.System:return 0;case a.ChatMessageRole.Assistant:return 2;case a.ChatMessageRole.Function:return 3;case a.ChatMessageRole.User:default:return 1}}Ce.from=ge})(St||(e.ChatMessageRole=St={}));var Lt;(function(Ce){function Te(H){return{level:Et.to(H.level),value:H.value,description:H.description}}Ce.to=Te;function ge(H){return{level:Et.from(H.level),value:H.value,description:H.description}}Ce.from=ge})(Lt||(e.ChatVariable=Lt={}));var Et;(function(Ce){function Te(H){switch(H){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}Ce.to=Te;function ge(H){switch(H){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}Ce.from=ge})(Et||(e.ChatVariableLevel=Et={}));var qe;(function(Ce){function Te(ge){switch(ge){case 1:return a.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return a.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return a.InteractiveEditorResponseFeedbackKind.Undone;case 3:return a.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Te})(qe||(e.InteractiveEditorResponseFeedbackKind=qe={}));var Ot;(function(Ce){function Te(ge,H,Fe){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:H.toInternal(ge,Fe)}Ce.from=Te})(Ot||(e.TerminalQuickFix=Ot={}))}),define(Ae[204],Re([1,0,2,9,7,8,174]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0;class l{constructor(f,P,k,u={timeout:1500,errors:3}){this.c=f,this.d=P,this.f=k,this.g=u,this.a=new A.$sc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(P,k,u)=>{const m={dispose:this.a.push([P,k,f])};return Array.isArray(u)&&u.push(m),m}}async $participateInSave(f,P){const k=w.URI.revive(f);let u=!1;const p=setTimeout(()=>u=!0,this.g.timeout),m=[];try{for(const h of[...this.a]){if(u)break;const t=this.d.getDocument(k),i=await this.h(h,{document:t,reason:L.TextDocumentSaveReason.to(P)});m.push(i)}}finally{clearTimeout(p)}return m}h([f,P,k],u){const p=this.b.get(f);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,f,P,u).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const h=this.b.get(f);this.b.set(f,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,P,k,u){const p=[],m=Date.now(),{document:h,reason:t}=u,{version:i}=h,c=Object.freeze({document:h,reason:t,waitUntil(g){if(Object.isFrozen(p))throw(0,T.$6)("waitUntil can not be called async");p.push(Promise.resolve(g))}});try{P.apply(k,[c])}catch(g){return Promise.reject(g)}return Object.freeze(p),new Promise((g,D)=>{const b=setTimeout(()=>D(new Error("timeout")),this.g.timeout);return Promise.all(p).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(b),g(n)}).catch(n=>{clearTimeout(b),D(n)})}).then(g=>{const D={edits:[]};for(const b of g)if(Array.isArray(b)&&b.every(n=>n instanceof C.$3J))for(const{newText:n,newEol:a,range:s}of b)D.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:n,eol:a&&L.EndOfLine.from(a)}});if(D.edits.length!==0)return i===h.version?this.f.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.$5ac=l}),define(Ae[205],Re([1,0,12,2,8,7,75]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0;class l{constructor(k,u,p,m){this.start=k,this.deletedCount=u,this.deletedItems=p,this.items=m}asApiEvent(){return{range:new L.$hL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(k,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,u,p){this.notebook=k,this.h=u,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return k.g},set mime(m){k.g=m},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,u,p){const m=p.map(C.NotebookCellOutputItem.to),h=this.a.find(t=>t.id===k);if(h&&(u||(h.items.length=0),h.items.push(...m),h.items.length>1&&h.items.every(t=>A.$1H(t.mime)))){const t=new Map,i=[];h.items.forEach(c=>{let g;t.has(c.mime)?g=t.get(c.mime):(g=[],t.set(c.mime,g),i.push(c.mime)),g.push(c.data)}),h.items.length=0,i.forEach(c=>{const g=A.$2H(t.get(c));h.items.push({mime:c,data:g.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$fcc=S;class f{static{this.a=0}constructor(k,u,p,m,h){this.k=k,this.l=u,this.m=p,this.uri=m,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,u={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===w.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(h=>h.apiCell)},save(){return k.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,u,p){this.g=k.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:p});const m={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},h=[];for(const i of k.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,m.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,m.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),h.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),h.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),h.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),h.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),h.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<h.length;i++){const c=h[i],g=t.get(c.cell);if(g===void 0){const D=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,D-1)}else m.cellChanges[g]={...m.cellChanges[g],...c}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let u=k.start|0,p=k.end|0;return u<0&&(u=0),p>this.b.length&&(p=this.b.length),k.with({start:u,end:p})}p(k){k=this.o(k);const u=[];for(let p=k.start;p<k.end;p++)u.push(this.b[p]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,u,p){if(this.j)return;const m=[],h=[],t=[];if(k.reverse().forEach(i=>{const g=i[2].map(n=>{const a=new S(this,this.l,n);return u||h.push(S.asModelAddData(this.apiNotebook,n)),a}),D=new l(i[0],i[1],[],g),b=this.b.splice(i[0],i[1],...g);for(const n of b)t.push(n.uri),D.deletedItems.push(n.apiCell);m.push(D)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:t}),p)for(const i of m)p.push(i.asApiEvent())}s(k,u,p,m){const h=this.b.splice(k,u);this.b.splice(p,0,...h);const t=[new l(k,u,h.map(i=>i.apiCell),[]),new l(p,0,[],h)];for(const i of t)m.push(i.asApiEvent())}t(k,u){this.b[k].setOutputs(u)}u(k,u,p,m){this.b[k].setOutputItems(u,p,m)}v(k,u){const p=this.b[k];p.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(p.uri,u)}w(k,u){const p=this.b[k];p.apiCell.mime=u}x(k,u){this.b[k].setMetadata(u)}y(k,u){this.b[k].setInternalMetadata(u)}getCellFromApiCell(k){return this.b.find(u=>u.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(u=>u.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$gcc=f}),define(Ae[206],Re([1,0,5,2,8,7]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class A{constructor(S,f,P,k={timeout:1500,errors:3}){this.b=S,this.c=f,this.d=P,this.f=k,this.a=new w.$gd}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(f,P,k)=>{const u=function(m){f.call(P,m)};return u.extension=S,this.a.event(u,void 0,k)}}async $participateInSave(S,f,P){const k=T.URI.revive(S),u=this.c.getNotebookDocument(k);if(!u)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:C.TextDocumentSaveReason.to(f)},P,async(h,t)=>{const i=Date.now(),c=await await Promise.resolve(h);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof L.$6J?p.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(p.length===0)return!0;const m={edits:[]};for(const h of p){const{edits:t}=C.WorkspaceEdit.from(h);m.edits=m.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(m)}}e.$Gcc=A}),define(Ae[104],Re([1,0,9,8,7]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,S,f,P,k,u){this.id=l,this.f=S,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=P,this.c=u}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(S){this.selections=[S]},get selections(){return l.a},set selections(S){if(!Array.isArray(S)||!S.every(C.$hL.isNotebookRange))throw(0,w.$5)("selections");l.a=S,l.g(S)},get visibleRanges(){return l.b},revealRange(S,f){l.f.$tryRevealRange(l.id,T.NotebookRange.from(S),f??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(T.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$hcc=L}),define(Ae[207],Re([1,0,9,5,14,8]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;let A=class{constructor(S,f){this.c=S,this.d=f,this.a=new T.$ed({onListenerError:w.$Z}),this.b=new T.$ed({onListenerError:w.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(S,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,f);const P=this.d.getEditorById(S);f.visibleRanges&&P._acceptVisibleRanges(f.visibleRanges.ranges.map(L.NotebookRange.to)),f.selections&&P._acceptSelections(f.selections.selections.map(L.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const f in S)this.d.getEditorById(f)._acceptViewColumn(L.ViewColumn.to(S[f]))}};e.$zcc=A,e.$zcc=A=Ke([Ve(0,C.$4i)],A)}),define(Ae[208],Re([1,0,8,72,153,21,64,9]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=void 0;class S{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,p,m){const h=this.b++,{title:t,location:i,cancellable:c}=p,g={label:(0,C.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(h,{location:w.ProgressLocation.from(i),title:t,source:g,cancellable:c},u.isUnderDevelopment?void 0:u.identifier.value).catch(l.$Z),this.d(h,m,!!c)}d(u,p,m){let h;m&&(h=new L.$od,this.c.set(u,h));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),h?.dispose()};let i;try{i=p(new P(this.a,u),m&&h?h.token:L.CancellationToken.None)}catch(c){throw t(u),c}return i.then(c=>t(u),c=>t(u)),i}$acceptProgressCanceled(u){const p=this.c.get(u);p&&(p.cancel(),this.c.delete(u))}}e.$Dbc=S;function f(k,u){return k.message=u.message,typeof u.increment=="number"&&(typeof k.increment=="number"?k.increment+=u.increment:k.increment=u.increment),k}class P extends T.$2u{constructor(u,p){super(m=>this.throttledReport(m)),this.f=u,this.g=p}throttledReport(u){this.f.$progressReport(this.g,u)}}Ke([(0,A.$7g)(100,(k,u)=>f(k,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,44,102,45,76,56,8,2]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=e.$9L=e.$8L=void 0;const f=(g,D,b,n)=>{let a=D;return{enumerable:!0,configurable:!1,get(){return a},set(s){if(!b(a,s)){const o=a;a=s,g.listener?.(n(s,o))}}}},P=(g,D)=>g===D,k={range:(g,D)=>g===D?!0:!g||!D?!1:g.isEqual(D),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(g,D)=>!(g.length!==D.length||g.some(b=>!D.find(n=>b.id===n.id)))},u=g=>D=>({op:4,update:g(D)}),p=(g,D)=>({range:(()=>{let b;const n=u(a=>({range:w.$is.lift(l.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return b},set(a){g.listener?.({op:6}),k.range(b,a)||(b=a,g.listener?.(n(a)))}}})(),label:f(g,D,k.label,u(b=>({label:b}))),description:f(g,void 0,k.description,u(b=>({description:b}))),sortText:f(g,void 0,k.sortText,u(b=>({sortText:b}))),canResolveChildren:f(g,!1,k.canResolveChildren,b=>({op:2,state:b})),busy:f(g,!1,k.busy,u(b=>({busy:b}))),error:f(g,void 0,k.error,u(b=>({error:l.MarkdownString.fromStrict(b)||null}))),tags:f(g,[],k.tags,(b,n)=>({op:1,new:b.map(l.TestTag.from),old:n.map(l.TestTag.from)}))}),m=g=>{const D=C.$GI.fromString(g.extId),b=new t(D.controllerId,D.localId,g.label,S.URI.revive(g.uri)||void 0);return b.range=l.Range.to(g.range||void 0),b.description=g.description||void 0,b.sortText=g.sortText||void 0,b.tags=g.tags.map(n=>l.TestTag.to({id:(0,A.$LI)(n).tagId})),b},h=g=>{let D;for(const b of g.tests){const n=m(b.item);(0,T.$RL)(n).parent=D,D=n}return D};e.$8L=h;class t{constructor(D,b,n,a){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const s=(0,T.$QL)(this,D);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,L.$PL)(s,T.$RL,t),enumerable:!0,writable:!1},...p(s,n)})}}e.$9L=t;class i extends t{constructor(D,b){super(D,D,b,void 0),this._isRoot=!0}}e.$0L=i;class c extends L.$LL{constructor(D,b,n){super({controllerId:D,getDocumentVersion:a=>a&&n.getDocument(a)?.version,getApiFor:T.$RL,getChildren:a=>a.children,root:new i(D,b),toITestItem:l.TestItem.from})}}e.$$L=c}),define(Ae[106],Re([1,0,50,9,88,8,7]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=e.$3L=void 0;class l{static{this.c=new C.$1L("TextEditorDecorationType")}constructor(u,p,m){const h=l.c.nextId();u.$registerTextEditorDecorationType(p.identifier,h,L.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:h,dispose(){u.$removeTextEditorDecorationType(h)}})}}e.$3L=l;class S{constructor(u,p){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,p){this.k();let m=null;if(u instanceof A.$WJ)m=new A.$XJ(u,u);else if(u instanceof A.$XJ)m=u;else throw new Error("Unrecognized location");this.l(m,p,!1)}insert(u,p){this.k(),this.l(new A.$XJ(u,u),p,!0)}delete(u){this.k();let p=null;if(u instanceof A.$XJ)p=u;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(u,p,m){const h=this.c.validateRange(u);this.g.push({range:h,text:p,forceMoveMarkers:m})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,T.$5)("endOfLine");this.h=u}}class f{constructor(u,p,m,h){this.c=u,this.d=p,this._accept(m),this.e=h;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}m(u){const p=this.l(u);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}o(u){const p=this.n(u);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const p=this.p(u);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(u)})))}assign(u){const p={};let m=!1;if(typeof u.tabSize<"u"){const h=this.l(u.tabSize);h==="auto"?(m=!0,p.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,m=!0,p.tabSize=h)}if(typeof u.indentSize<"u"){const h=this.n(u.indentSize);h==="tabSize"?(m=!0,p.indentSize=h):typeof h=="number"&&this.g!==h&&(this.g=h,m=!0,p.indentSize=h)}if(typeof u.insertSpaces<"u"){const h=this.p(u.insertSpaces);h==="auto"?(m=!0,p.insertSpaces=h):this.h!==h&&(this.h=h,m=!0,p.insertSpaces=h)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,m=!0,p.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,m=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(u.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(u,p){p.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(m)})}}e.$4L=f;class P{constructor(u,p,m,h,t,i,c,g){this.id=u,this.j=p,this.k=m,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,m),this.e=c,this.f=g;const D=this;this.value=Object.freeze({get document(){return h.value},set document(b){throw new T.$7("document")},get selection(){return D.c&&D.c[0]},set selection(b){if(!(b instanceof A.$YJ))throw(0,T.$5)("selection");D.c=[b],D.l()},get selections(){return D.c},set selections(b){if(!Array.isArray(b)||b.some(n=>!(n instanceof A.$YJ)))throw(0,T.$5)("selections");D.c=b,D.l()},get visibleRanges(){return D.e},set visibleRanges(b){throw new T.$7("visibleRanges")},get options(){return D.d.value},set options(b){D.g||D.d.assign(b)},get viewColumn(){return D.f},set viewColumn(b){throw new T.$7("viewColumn")},edit(b,n={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new S(h.value,n);return b(a),D.m(a)},insertSnippet(b,n,a={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=D.c.map(o=>L.Range.from(o));else if(n instanceof A.$WJ){const{lineNumber:o,column:y}=L.Position.from(n);s=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(n instanceof A.$XJ)s=[L.Range.from(n)];else{s=[];for(const o of n)if(o instanceof A.$XJ)s.push(L.Range.from(o));else{const{lineNumber:y,column:$}=L.Position.from(o);s.push({startLineNumber:y,startColumn:$,endLineNumber:y,endColumn:$})}}return p.$tryInsertSnippet(u,h.value.version,b.value,s,a)},setDecorations(b,n){const a=n.length===0;a&&!D.h.has(b.key)||(a?D.h.delete(b.key):D.h.add(b.key),D.n(()=>{if(L.$SL(n))return p.$trySetDecorations(u,b.key,L.$TL(n));{const s=new Array(4*n.length);for(let o=0,y=n.length;o<y;o++){const $=n[o];s[4*o]=$.start.line+1,s[4*o+1]=$.start.character+1,s[4*o+2]=$.end.line+1,s[4*o+3]=$.end.character+1}return p.$trySetDecorationsFast(u,b.key,s)}}))},revealRange(b,n){D.n(()=>p.$tryRevealRange(u,L.Range.from(b),n||A.TextEditorRevealType.Default))},show(b){p.$tryShowEditor(u,L.ViewColumn.from(b))},hide(){p.$tryHideEditor(u)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,w.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,w.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,w.ok)(!this.g),this.f=u}_acceptSelections(u){(0,w.ok)(!this.g),this.c=u}async l(){const u=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const p=u.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const m=p.edits.map(t=>t.range);m.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=m.length-1;t<i;t++){const c=m[t].end;if(m[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=p.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,h,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$5L=P}),define(Ae[209],Re([1,0,4,172]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=void 0,e.$$I=(0,w.$Bh)(T.$Hh)}),define(Ae[107],Re([1,0,20,5,19,6]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g3b=e.$f3b=e.$e3b=e.$d3b=e.$c3b=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.$c3b=A;class l{static isHostExtension(t,i,c){if(i.getExtensionDescription(t))return!1;const g=c.getExtensionDescription(t);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(t,i){this.h=t,this.c=new T.$ed,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(p),this.e=new w.$Wl,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const i=this.h.readActivationEvents(t);if(Array.isArray(i))for(let c of i)c==="onUri"&&(c=`onUri:${w.$Ul.toKey(t.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,i){this.d=m(this.d,i),this.d=this.d.concat(t);const c=l.k(this.d);return this.d=m(this.d,c.map(g=>g.identifier)),this.j(),this.c.fire(void 0),new A(c)}static k(t){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,a){this.addNode(n),this.addNode(a),this.c.has(n)?this.c.get(n).push(a):this.c.set(n,[a])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,a){const s=i.getArcs(n);for(let o=0;o<s.length;o++)if(!a.has(s[o]))return!1;return!0}getNodes(){return this.e}},c=new w.$Wl;for(const n of t)if(c.set(n.identifier,n),n.extensionDependencies)for(const a of n.extensionDependencies)i.addArc(w.$Ul.toKey(n.identifier),w.$Ul.toKey(a));const g=new Set;i.getNodes().filter(n=>i.getArcs(n).length===0).forEach(n=>g.add(n));const D=i.getNodes().filter(n=>!g.has(n));let b;do{b=!1;for(let n=0;n<D.length;n++){const a=D[n];i.hasOnlyGoodArcs(a,g)&&(D.splice(n,1),n--,g.add(a),b=!0)}}while(b);return D.map(n=>c.get(n))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this.g.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const i=this.e.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this.f)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$d3b=l,e.$e3b={readActivationEvents:h=>h.activationEvents};class S{constructor(t){this.d=new k,this.c=new l(t,[])}async acquireLock(t){const i=await this.d.acquire(t);return new f(this,i)}deltaExtensions(t,i,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this.c.getExtensionDescriptionByIdOrUUID(t,i)}}e.$f3b=S;class f extends L.$jc{constructor(t,i){super(),this.f=t,this.c=!1,this.B(i)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$g3b=f;class P{constructor(t){this.name=t,this.promise=new Promise((i,c)=>{this.c=i})}resolve(t){this.c(t)}}class k{constructor(){this.c=[],this.d=!1}async acquire(t){const i=new P(t);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),g=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};t.resolve((0,L.$hc)(g))}}var u;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})(u||(u={}));function p(h,t){const i=h.isBuiltin?0:h.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==c)return i-c;const g=C.$5d.basename(h.extensionLocation.path),D=C.$5d.basename(t.extensionLocation.path);return g<D?-1:g>D?1:0}function m(h,t){const i=new w.$Vl(t);return h.filter(c=>!i.has(c.identifier))}}),define(Ae[79],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$4l=e.$3l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(T||(e.UIKind=T={}));var C;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var L;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(f){const P=w.$Ed.alloc(1);switch(f){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$3l=A;function l(f,P){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$4l=l;var S;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(Ae[57],Re([1,0,4,5,14,27,79,51,52,24,2,6,155]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=e.$bM=e.$aM=void 0;let p=class extends k.$jc{constructor(i,c){super(),this.s=i,this.t=c,this.a=this.B(new T.$ed),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$ed),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:S.$do,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(g=>{(0,C.$6i)(g)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,g){const D=this.getTelemetryDetails(),b=new m(c,g,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,b]),b.apiTelemetryLogger}$initializeTelemetryLevel(i,c,g){this.f=i,this.g=c,this.c=g??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,l.$Ok)((0,S.$ko)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.r.forEach((g,D)=>{const b=g.filter(n=>!n.isDisposed);b.length===0?this.r.delete(D):this.r.set(D,b)}),this.r.forEach(g=>{for(const D of g)D.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,c){const D=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!D)return this.r.delete(i.value),!1;let b=!1;for(const n of D)n.ignoreUnhandledExtHostErrors||(n.logError(c),b=!0);return b}};e.$aM=p,e.$aM=p=Ke([Ve(0,L.$_L),Ve(1,C.$5i)],p);class m{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,g,D,b,n,a){this.g=g,this.h=D,this.i=b,this.j=n,this.a=new T.$ed,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,S.$no)(c,[]),this.c&&(c=(0,f.$Xm)(c,this.c)),this.b||(c=(0,f.$Xm)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const g={name:i.name,message:i.message,stack:i.stack,cause:i.cause},D=(0,S.$no)(g,[]),b=new Error(D.message,{cause:D.cause});b.stack=D.stack,b.name=D.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(b,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$bM=m;function h(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$cM=h,e.$dM=(0,w.$Ah)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,181,98,20,4]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.$QF=e.ActivationKind=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.ExtensionHostStartup=e.$KF=e.$JF=e.$IF=e.$HF=void 0,e.$HF=Object.freeze({identifier:new A.$Ul("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$IF="extensions.webWorker",e.$JF=(0,l.$Ah)("extensionService");class S{constructor(b){this.dependency=b}}e.$KF=S;var f;(function(D){D[D.EagerAutoStart=1]="EagerAutoStart",D[D.EagerManualStart=2]="EagerManualStart",D[D.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.$yF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(b,n){const a=[],s=[],o=[],y=[],$=k(this.c),I=k(b),E=(B,V)=>B.extensionLocation.toString()===V.extensionLocation.toString()||B.isBuiltin===V.isBuiltin||B.isUserBuiltin===V.isUserBuiltin||B.isUnderDevelopment===V.isUnderDevelopment;for(const B of this.c){const V=I.get(B.identifier);if(!V){a.push(B.identifier),$.delete(B.identifier);continue}if(!E(B,V)){a.push(B.identifier),$.delete(B.identifier);continue}}for(const B of b){const V=$.get(B.identifier);if(!V){s.push(B);continue}if(!E(V,B)){a.push(V.identifier),$.delete(V.identifier);continue}}const r=new A.$Vl(this.d),d=new A.$Vl(n);for(const B of this.d)d.has(B)||o.push(B);for(const B of n)r.has(B)||y.push(B);const v=L.$yF.createActivationEventsMap(s),R={toRemove:a,toAdd:s,addActivationEvents:v,myToRemove:o,myToAdd:y};return this.delta(R),R}delta(b){const{toRemove:n,toAdd:a,myToRemove:s,myToAdd:o}=b,y=new A.$Vl(n),$=new A.$Vl(s);for(let I=0;I<this.c.length;I++)y.has(this.c[I].identifier)&&(this.c.splice(I,1),I--);for(let I=0;I<this.d.length;I++)$.has(this.d[I])&&(this.d.splice(I,1),I--);for(const I of a)this.c.push(I);for(const I of o)this.d.push(I)}containsExtension(b){for(const n of this.d)if(A.$Ul.equals(n,b))return!0;return!1}}e.$LF=P;function k(D){const b=new A.$Wl;for(const n of D)b.set(n.identifier,n);return b}function u(D,b){return D.enabledApiProposals?D.enabledApiProposals.includes(b):!1}e.$MF=u;function p(D,b){if(!u(D,b))throw new Error(`Extension '${D.identifier.value}' CANNOT use API proposal: ${b}.
Its package.json#enabledApiProposals-property declares: ${D.enabledApiProposals?.join(", ")??"[]"} but NOT ${b}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${D.identifier.value}`)}e.$NF=p;class m{constructor(b,n,a,s){this.codeLoadingTime=b,this.activateCallTime=n,this.activateResolvedTime=a,this.activationReason=s}}e.$OF=m;class h{constructor(b,n){this.description=b,this.value=n}}e.$PF=h;var t;(function(D){D[D.Normal=0]="Normal",D[D.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(D){return{type:D.isBuiltin?0:1,isBuiltin:D.isBuiltin||D.isUserBuiltin,identifier:{id:(0,C.$to)(D.publisher,D.name),uuid:D.uuid},manifest:D,location:D.extensionLocation,targetPlatform:D.targetPlatform,validations:[],isValid:!0}}e.$QF=i;function c(D,b){return{identifier:new A.$Ul((0,C.$ro)(D.manifest.publisher,D.manifest.name)),isBuiltin:D.type===0,isUserBuiltin:D.type===1&&D.isBuiltin,isUnderDevelopment:!!b,extensionLocation:D.location,...D.manifest,uuid:D.identifier.uuid,targetPlatform:D.targetPlatform}}e.$RF=c;class g{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(b){return Promise.resolve(void 0)}activationEventIsDone(b){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(b,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$SF=g}),define(Ae[210],Re([1,0,9,107,20,26,14,13]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=e.$0ac=e.$9ac=e.$8ac=e.$7ac=e.$6ac=void 0;class S{static{this.NONE=new S(!1,-1,-1,-1)}constructor(i,c,g,D){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=g,this.activateResolvedTime=D}}e.$6ac=S;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$7ac=f;class P{constructor(i,c,g,D,b,n){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=g,this.module=D,this.exports=b,this.subscriptions=n}}e.$8ac=P;class k extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9ac=k;class u extends P{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0ac=u;class p extends P{constructor(i){super(!0,i,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(i,c,g,D){this.g=D,this.a=i,this.b=c,this.c=g,this.d=new C.$Wl,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,g]of this.d)i.push(g.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const g=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(g.map(D=>({id:D.identifier,reason:{startup:c,extensionId:D.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const g=this.a.getExtensionDescription(i);if(!g)throw new Error(`Extension '${i}' is not known`);return this.h([{id:g.identifier,reason:c}])}async h(i){const c=i.filter(g=>!this.isActivated(g.id)).map(g=>this.j(g));await Promise.all(c.map(g=>g.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const b=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new p(b));return this.c.onExtensionActivationError(i.id,b,new L.$KF(i.id.value)),n}const g=[],D=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const b of D){if(this.m(b))continue;const n=this.d.get(b);if(n){g.push(n);continue}if(this.l(b)){g.push(this.j({id:this.b.getExtensionDescription(b).identifier,reason:i.reason}));continue}const a=this.a.getExtensionDescription(b);if(a){if(!a.main&&!a.browser)continue;g.push(this.j({id:a.identifier,reason:i.reason}));continue}const s=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${b}'`),y=this.k(i,c.displayName,[],new p(o));return this.c.onExtensionActivationError(c.identifier,o,new L.$KF(b)),y}return this.k(i,c.displayName,g,null)}k(i,c,g,D){const b=new h(i.id,c,i.reason,g,D,this.c,this.g);return this.d.set(i.id,b),b}l(i){return T.$d3b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$$ac=m,e.$$ac=m=Ke([Ve(3,A.$4i)],m);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,g,D,b,n,a){this.c=i,this.d=c,this.f=g,this.g=D,this.h=b,this.j=n,this.k=a,this.a=new l.$Eg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);g.detail=c.value.activationFailedError,this.h=new p(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new p(c),this.b&&w.$2(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};h=Ke([Ve(6,A.$4i)],h)}),define(Ae[211],Re([1,0,157,23,2,5,6,193,13,7,16,18,8,49,21,126,26]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;function i(D,b){if((0,P.$if)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let n;return Array.isArray(D.highlights)&&(n=D.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),n=n.length?n:void 0),{label:D.label,highlights:n}}}class c extends A.$jc{constructor(b,n,a){super(),this.f=b,this.g=n,this.h=a,this.a=new Map,this.b=new h.$_6;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>s(y)?this.r(y):y):o})}registerTreeDataProvider(b,n,a){const s=this.createTreeView(b,{treeDataProvider:n},a);return{dispose:()=>s.dispose()}}createTreeView(b,n,a){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],y=!!n.dragAndDropController?.handleDrag,$=!!n.dragAndDropController?.handleDrop,I=this.m(b,n,a),E={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:$,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},r=this.f.$registerTreeViewDataProvider(b,E),d={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$NF)(a,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$NF)(a,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(v){(0,p.$Yj)(v)&&(0,t.$NF)(a,"treeViewMarkdownMessage"),I.message=v},get title(){return I.title},set title(v){I.title=v},get description(){return I.description},set description(v){I.description=v},get badge(){return I.badge},set badge(v){v!==void 0&&f.ViewBadge.isViewBadge(v)?I.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(I.badge=void 0)},reveal:(v,R)=>I.reveal(v,R),dispose:async()=>{await r,this.a.delete(b),I.dispose()}};return this.B(d),d}$getChildren(b,n){const a=this.a.get(b);return a?a.getChildren(n):Promise.reject(new l.$$E(b))}async $handleDrop(b,n,a,s,o,y,$,I){const E=this.a.get(b);if(!E)return Promise.reject(new l.$$E(b));const r=u.DataTransfer.toDataTransfer(a,async d=>(await this.f.$resolveDropFileData(b,n,d)).buffer);return $===b&&I&&await this.j(r,E,I,o,y),E.onDrop(r,s,o)}async j(b,n,a,s,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach(($,I)=>{$&&b.set(I,$)});else if(o&&n.handleDrag){const $=n.handleDrag(a,b,s);this.b.addDragOperationTransfer(o,$),await $}return b}async $handleDrag(b,n,a,s){const o=this.a.get(b);if(!o)return Promise.reject(new l.$$E(b));const y=await this.j(new f.$NK,o,n,s,a);if(!(!y||s.isCancellationRequested))return u.DataTransfer.from(y)}async $hasResolve(b){const n=this.a.get(b);if(!n)throw new l.$$E(b);return n.hasResolve}$resolve(b,n,a){const s=this.a.get(b);if(!s)throw new l.$$E(b);return s.resolveTreeItem(n,a)}$setExpanded(b,n,a){const s=this.a.get(b);if(!s)throw new l.$$E(b);s.setExpanded(n,a)}$setSelectionAndFocus(b,n,a){const s=this.a.get(b);if(!s)throw new l.$$E(b);s.setSelectionAndFocus(n,a)}$setVisible(b,n){const a=this.a.get(b);if(!a){if(!n)return;throw new l.$$E(b)}a.setVisible(n)}$changeCheckboxState(b,n){const a=this.a.get(b);if(!a)throw new l.$$E(b);a.setCheckboxState(n)}m(b,n,a){const s=this.B(new g(b,n,this.f,this.g.converter,this.h,a));return this.a.set(b,s),s}r(b){const n=this.a.get(b.$treeViewId);return n&&"$treeItemHandle"in b?n.getExtensionElement(b.$treeItemHandle):n&&"$focusedTreeItem"in b&&b.$focusedTreeItem?n.focusedElement:null}}e.$Kbc=c;class g extends A.$jc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(b=>this.getExtensionElement(b)).filter(b=>!(0,P.$rf)(b))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(b,n,a,s,o,y){if(super(),this.I=b,this.J=a,this.L=s,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$ed),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$ed),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$ed),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$ed),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$ed),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$ed),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$ed),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$od,y.contributes&&y.contributes.views)for(const r in y.contributes.views)for(const d of y.contributes.views[r])d.id===b&&(this.P=d.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(r=>this.F.fire({message:!1,element:r})));let $,I;const E=L.Event.debounce(this.F.event,(r,d)=>(r||(r={message:!1,elements:[]}),d.element!==!1&&($||($=new Promise(v=>I=v),this.G=this.G.then(()=>$)),Array.isArray(d.element)?r.elements.push(...d.element):r.elements.push(d.element)),d.message&&(r.message=!0),r),200,!0);this.B(E(({message:r,elements:d})=>{d.length&&(this.H=this.H.then(()=>{const v=I;return $=null,this.$(d).then(()=>v())})),r&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(b){const n=b?this.getExtensionElement(b):void 0;if(b&&!n)return this.M.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let a=this.X(b);return a||(a=await this.Y(n)),a?a.map(s=>s.item):void 0}getExtensionElement(b){return this.j.get(b)}reveal(b,n){n=n||{select:!0,focus:!1};const a=(0,P.$rf)(n.select)?!0:n.select,s=(0,P.$rf)(n.focus)?!1:n.focus,o=(0,P.$rf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.G.then(()=>this.S(b)).then(y=>this.W(b,y[y.length-1]).then($=>this.J.$reveal(this.I,{item:$.item,parentChain:y.map(I=>I.item)},{select:a,focus:s,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:a,focus:s,expand:o})}get message(){return this.O}set message(b){this.O=b,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(b){this.P=b,this.J.$setTitle(this.I,b,this.Q)}get description(){return this.Q}set description(b){this.Q=b,this.J.$setTitle(this.I,this.P,b)}get badge(){return this.R}set badge(b){this.R?.value===b?.value&&this.R?.tooltip===b?.tooltip||(this.R=u.ViewBadge.from(b),this.J.$setBadge(this.I,b))}setExpanded(b,n){const a=this.getExtensionElement(b);a&&(n?this.u.fire(Object.freeze({element:a})):this.w.fire(Object.freeze({element:a})))}setSelectionAndFocus(b,n){const a=!(0,k.$sb)(this.s,b);this.s=b;const s=this.t!==n;this.t=n,a&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(b){b!==this.r&&(this.r=b,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(b){const n=(await Promise.all(b.map(async a=>{const s=this.getExtensionElement(a.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:a.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);n.forEach(a=>{a.treeItem.checkboxState=a.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(a=>[a.extensionItem,a.newState])})}async handleDrag(b,n,a){const s=[];for(const o of b){const y=this.getExtensionElement(o);y&&s.push(y)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,n,a),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(b,n,a){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.g?.handleDrop))return(0,S.$yg)(()=>this.g?.handleDrop?this.g.handleDrop(s,b,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(b,n){if(!this.f.resolveTreeItem)return;const a=this.j.get(b);if(a){const s=this.m.get(a);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,a,n)??s.extensionItem;return this.hb(o),s.item.tooltip=this.eb(o.tooltip),s.item.command=this.fb(s.disposableStore,o.command),s.item}}}S(b){return this.U(b).then(n=>n?this.S(n).then(a=>this.W(n,a[a.length-1]).then(s=>(a.push(s),a))):Promise.resolve([]))}U(b){const n=this.m.get(b);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,S.$yg)(()=>this.f.getParent(b))}W(b,n){const a=this.m.get(b);return a?Promise.resolve(a):(0,S.$yg)(()=>this.f.getTreeItem(b)).then(s=>this.kb(b,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(b){if(b){let n;if(typeof b=="string"){const a=this.getExtensionElement(b);n=a?this.m.get(a):void 0}else n=b;return n&&n.children||void 0}return this.h}async Y(b){this.rb(b);const n=new m.$od(this.Z.token);try{const a=b?this.m.get(b):void 0,s=await this.f.getChildren(b);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Eb)(s||[]).map(async y=>{const $=await this.f.getTreeItem(y);return $&&!n.token.isCancellationRequested?this.db(y,$,a):null}));return n.token.isCancellationRequested?void 0:(0,k.$Eb)(o)}finally{n.dispose()}}$(b){if(b.some(a=>!a))return this.Z.dispose(!0),this.Z=new m.$od,this.tb(),this.J.$refresh(this.I);{const a=this.ab(b);if(a.length)return this.bb(a)}return Promise.resolve(void 0)}ab(b){const n=new Set,a=b.map(o=>this.m.get(o));for(const o of a)if(o&&!n.has(o.item.handle)){let y=o;for(;y&&y.parent&&a.findIndex($=>y&&y.parent&&$&&$.item.handle===y.parent.item.handle)===-1;){const $=this.j.get(y.parent.item.handle);y=$?this.m.get($):void 0}y&&!y.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const y=this.j.get(o);if(y){const $=this.m.get(y);$&&(!$.parent||!n.has($.parent.item.handle))&&s.push(o)}}),s}bb(b){const n={};return Promise.all(b.map(a=>this.cb(a).then(s=>{s&&(n[a]=s.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(b){const n=this.getExtensionElement(b);if(n){const a=this.m.get(n);if(a)return this.rb(n),(0,S.$yg)(()=>this.f.getTreeItem(n)).then(s=>{if(s){const o=this.ib(n,s,a.parent);return this.pb(n,o,a,a.parent),a.dispose(),o}return null})}return Promise.resolve(null)}db(b,n,a){const s=this.ib(b,n,a);if(n.id&&this.j.has(s.item.handle))throw new Error((0,w.localize)(0,null,n.id));return this.ob(b,s),this.qb(s,a),s}eb(b){return f.$kK.isMarkdownString(b)?u.MarkdownString.from(b):b}fb(b,n){return n?{...this.L.toInternal(n,b),originalId:n.command}:void 0}gb(b){if(b.checkboxState===void 0)return;let n,a,s;return typeof b.checkboxState=="number"?n=b.checkboxState:(n=b.checkboxState.state,a=b.checkboxState.tooltip,s=b.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:s}}hb(b){if(!f.$IK.isTreeItem(b,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(b,n,a){this.hb(n);const s=this.B(new A.$ic),o=this.kb(b,n,a),y=this.lb(n);return{item:{handle:o,parentHandle:a?a.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(s,n.command),contextValue:n.contextValue,icon:y,iconDark:this.mb(n)||y,themeIcon:this.jb(n),collapsibleState:(0,P.$rf)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:a,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(b){return b.iconPath instanceof f.$QK?b.iconPath:void 0}kb(b,{id:n,label:a,resourceUri:s},o,y){if(n)return`${g.b}/${n}`;const $=i(a,this.N),I=o?o.item.handle:g.a;let E=$?$.label:s?(0,T.$eg)(s):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const r=this.m.has(b)?this.m.get(b).item.handle:void 0,d=this.X(o)||[];let v,R=0;do{if(v=`${I}/${R}:${E}`,y||!this.j.has(v)||r===v)break;R++}while(R<=d.length);return v}lb(b){if(b.iconPath&&!(b.iconPath instanceof f.$QK))return typeof b.iconPath=="string"||C.URI.isUri(b.iconPath)?this.nb(b.iconPath):this.nb(b.iconPath.light)}mb(b){if(b.iconPath&&!(b.iconPath instanceof f.$QK)&&b.iconPath.dark)return this.nb(b.iconPath.dark)}nb(b){return C.URI.isUri(b)?b:C.URI.file(b)}ob(b,n){this.j.set(n.item.handle,b),this.m.set(b,n)}pb(b,n,a,s){this.j.delete(n.item.handle),this.m.delete(b),n.item.handle!==a.item.handle&&this.j.delete(a.item.handle),this.ob(b,n);const o=this.X(s)||[],y=o.filter($=>$.item.handle===a.item.handle)[0];y&&o.splice(o.indexOf(y),1,n)}qb(b,n){n?(n.children||(n.children=[]),n.children.push(b)):(this.h||(this.h=[]),this.h.push(b))}rb(b){if(b){const n=this.m.get(b);if(n){if(n.children)for(const a of n.children){const s=this.j.get(a.item.handle);s&&this.sb(s)}n.children=void 0}}else this.tb()}sb(b){const n=this.m.get(b);if(n){if(n.children)for(const a of n.children){const s=this.j.get(a.item.handle);s&&this.sb(s)}this.m.delete(b),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(b=>b.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[212],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,167,9,29,92,73,30,20,212,177,98]),function(be,e,w,T,C,L,A,l,S,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const u=l.$7m.as(A.$8m.JSONContribution);class p{constructor(b,n,a){this.a=b,this.b=n,this.c=a}d(b,n){this.a({type:b,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(C.default.Error,b)}warn(b){this.d(C.default.Warning,b)}info(b){this.d(C.default.Info,b)}}e.$TF=p;class m{static a(b){const n=new S.$Vl;for(let a=0,s=b.length;a<s;a++)n.add(b[a].description.identifier);return n}static compute(b,n){if(!b||!b.length)return new m(n,[]);if(!n||!n.length)return new m([],b);const a=this.a(b),s=this.a(n),o=n.filter($=>!a.has($.description.identifier)),y=b.filter($=>!s.has($.description.identifier));return new m(o,y)}constructor(b,n){this.added=b,this.removed=n}}e.$UF=m;class h{constructor(b,n){this.name=b,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=m.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,T.$Y)(b)}}}e.$VF=h;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$WF={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.$Tl},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Ln}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Ln}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const n=new h(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,n),b.activationEventsGenerator&&k.$yF.register(b.extensionPoint,b.activationEventsGenerator),e.$WF.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,u.registerSchema(i,e.$WF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$XF=c;const g={ExtensionsRegistry:"ExtensionsRegistry"};l.$7m.add(g.ExtensionsRegistry,new c),e.$YF=l.$7m.as(g.ExtensionsRegistry),u.registerSchema(i,e.$WF),u.registerSchema(P.$kj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,164,16,24,213,32,5]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var f;(function(u){function p(m,h,t){if(!m)return;const i=T.$if(m.type)?m.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const c=[];if(Array.isArray(m.required))for(const g of m.required)T.$if(g)&&c.push(g);return{extensionId:h.value,taskType:i,required:c,properties:m.properties?C.$Um(m.properties):{},when:m.when?A.$Hi.deserialize(m.when):void 0}}u.from=p})(f||(f={}));const P=L.$YF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,p)=>{for(const m of u)m.type&&p.push(`onTaskType:${m.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:S}});class k{constructor(){this.d=new l.$ed,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,m)=>{P.setHandler((h,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const g of c)this.a&&g.type&&this.a[g.type]&&delete this.a[g.type]}for(const i of t.added){const c=i.value;for(const g of c){const D=f.from(g,i.description.identifier,i.collector);D&&(this.a[D.taskType]=D)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const m of this.all()){const h={type:"object",additionalProperties:!1};m.required.length>0&&(h.required=m.required.slice(0)),m.properties!==void 0?h.properties=C.$Um(m.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[m.taskType]},p.push(h)}this.c={oneOf:p}}return this.c}}e.$8F=new k}),define(Ae[215],Re([1,0,165,16,23,24,32,214]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$fG=e.JsonSchemaVersion=e.ExecutionEngine=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$_F=e.ShellQuoting=e.$$F=e.$0F=e.$9F=void 0,e.$9F="settings",e.$0F=new A.$1i("taskRunning",!1,w.localize(0,null)),e.$$F={value:w.localize(1,null),original:"Tasks"};var S;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.$_F="$customized",function(N){function z(ee){if(!ee)return N.Strong;switch(ee.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=z}(S||(e.ShellQuoting=S={}));var f;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var P;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(P||(e.RevealKind=P={})),function(N){function z(ee){switch(ee.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=z}(P||(e.RevealKind=P={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(N){function z(ee){switch(ee.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=z}(k||(e.RevealProblemKind=k={}));var u;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(u||(e.PanelKind=u={})),function(N){function z(ee){switch(ee.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=z}(u||(e.PanelKind=u={}));var p;(function(N){N.defaults={echo:!0,reveal:P.Always,revealProblems:k.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var m;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(N){function z(X){switch(X.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=z;function ee(X){switch(X){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=ee}(m||(e.RuntimeType=m={}));var h;(function(N){function z(ee){return T.$if(ee)?ee:ee.value}N.value=z})(h||(e.CommandString=h={}));var t;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function z(X){return X===N.Clean._id||X===N.Build._id||X===N.Rebuild._id||X===N.Test._id}N.is=z;function ee(X){if(X!==void 0)return T.$if(X)?z(X)?{_id:X,isDefault:!1}:void 0:X}N.from=ee})(t||(e.TaskGroup=t={}));var i;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function z(ee){switch(ee){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=z})(c||(e.TaskSourceKind=c={}));var g;(function(N){N.parallel="parallel",N.sequence="sequence"})(g||(e.DependsOrder=g={}));var D;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(D||(e.RunOnOptions=D={}));var b;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(b||(e.RunOptions=b={}));class n{constructor(z,ee,X,Ee,De,Pe){this._label="",this._id=z,ee&&(this._label=ee),X&&(this.type=X),this.runOptions=Ee,this.configurationProperties=De,this._source=Pe}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,ee=!1){if(z===void 0)return!1;if(T.$if(z))return z===this._label||z===this.configurationProperties.identifier||ee&&z===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$aG=n;class a extends n{constructor(z,ee,X,Ee,De,Pe,Z,ue){super(z,X,void 0,Z,ue,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,De&&(this.command=De)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case m.Shell:ee="shell";break;case m.Process:ee="process";break;case m.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(z){return z instanceof a}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const X={type:e.$_F,folder:z,id:ee};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new a(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$bG=a;class s extends n{constructor(z,ee,X,Ee,De,Pe,Z){super(z,X,Ee,Pe,Z,ee),this._source=ee,this.configures=De}static is(z){return z instanceof s}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const X={type:e.$_F,folder:z,id:ee};return JSON.stringify(X)}}e.$cG=s;class o extends n{constructor(z,ee,X,Ee,De,Pe,Z,ue,ye){super(z,X,Ee,ue,ye,ee),this.defines=De,this.hasDefinedMatchers=Z,this.command=Pe,this.icon=ye.icon,this.hide=ye.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof o}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new o(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$dG=o;class y extends n{constructor(z,ee,X,Ee,De,Pe){super(z,X,Ee,De,Pe,ee),this._source=ee}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new y(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$eG=y;var $;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(N){N._default=N.Terminal}($||(e.ExecutionEngine=$={}));var I;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class E{constructor(z){this.c=new Map;for(let ee=0;ee<z.length;ee++)this.c.set(z[ee].uri.toString(),ee)}compare(z,ee){const X=z.getWorkspaceFolder(),Ee=ee.getWorkspaceFolder();if(X&&Ee){let De=this.c.get(X.uri.toString());De=De===void 0?0:De+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,De===Pe?z._label.localeCompare(ee._label):De-Pe}else return!X&&Ee?-1:X&&!Ee?1:0}}e.$fG=E;var r;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(r||(e.TaskEventKind=r={}));var d;(function(N){N.SingleRun="singleRun",N.Background="background"})(d||(e.TaskRunType=d={}));var v;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var R;(function(N){function z(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function ee(ue,ye,ce){return{...z(ue),kind:"start",terminalId:ye,resolvedVariables:ce}}N.start=ee;function X(ue,ye,ce){return{...z(ue),kind:"processStarted",terminalId:ye,processId:ce}}N.processStarted=X;function Ee(ue,ye,ce){return{...z(ue),kind:"processEnded",terminalId:ye,exitCode:ce}}N.processEnded=Ee;function De(ue,ye,ce){return{...z(ue),kind:"terminated",exitReason:ce,terminalId:ye}}N.terminated=De;function Pe(ue,ye,ce){return{...z(ye),kind:ue,terminalId:ce}}N.general=Pe;function Z(){return{kind:"changed"}}N.changed=Z})(R||(e.TaskEvent=R={}));var B;(function(N){function z(X){const Ee=Object.keys(X).sort();let De="";for(const Pe of Ee){let Z=X[Pe];Z instanceof Object?Z=z(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),De+=Pe+","+Z+","}return De}function ee(X){const De={_key:z(X),type:X.taskType};return Object.assign(De,X),De}N.create=ee})(B||(e.KeyedTaskIdentifier=B={}));var V;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var j;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var W;(function(N){function z(ee,X){const Ee=l.$8F.get(ee.type);if(Ee===void 0){const ue=L.$Um(ee);return delete ue._key,B.create(ue)}const De=Object.create(null);De.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(ue=>Pe.add(ue));const Z=Ee.properties;for(const ue of Object.keys(Z)){const ye=ee[ue];if(ye!=null)De[ue]=ye;else if(Pe.has(ue)){const ce=Z[ue];if(ce.default!==void 0)De[ue]=L.$Um(ce.default);else switch(ce.type){case"boolean":De[ue]=!1;break;case"number":case"integer":De[ue]=0;break;case"string":De[ue]="";break;default:X.error(w.localize(2,null,JSON.stringify(ee,void 0,0),ue));return}}}return B.create(De)}N.createTaskIdentifier=z})(W||(e.TaskDefinition=W={}))}),define(Ae[216],Re([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i3b=e.$h3b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$Y)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$h3b=T;class C extends T{constructor(){super(),this.h=!0,this.i=new w.$3}}e.$i3b=C}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aA=e.$_z=e.$$z=e.$0z=void 0;class w{static{this.count=0}constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++w.count}}e.$0z=w;const T=[];function C(l){const S=new w(l);return T[S.nid]=S,S}e.$$z=C;function L(l){return T[l].sid}e.$_z=L;class A{constructor(S){this.value=S}}e.$aA=A}),define(Ae[3],Re([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.$TJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$SJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var C;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var L;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var S;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var f;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var P;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$SJ=k;var u;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var p;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var m;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$TJ={MainThreadAuthentication:(0,w.$$z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$$z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$$z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,w.$$z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,w.$$z)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$$z)("MainThreadClipboard"),MainThreadCommands:(0,w.$$z)("MainThreadCommands"),MainThreadComments:(0,w.$$z)("MainThreadComments"),MainThreadConfiguration:(0,w.$$z)("MainThreadConfiguration"),MainThreadConsole:(0,w.$$z)("MainThreadConsole"),MainThreadDebugService:(0,w.$$z)("MainThreadDebugService"),MainThreadDecorations:(0,w.$$z)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$$z)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$$z)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$$z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$$z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$$z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$$z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$$z)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$$z)("MainThreadErrors"),MainThreadTreeViews:(0,w.$$z)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$$z)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$$z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$$z)("MainThreadLanguages"),MainThreadLogger:(0,w.$$z)("MainThreadLogger"),MainThreadMessageService:(0,w.$$z)("MainThreadMessageService"),MainThreadOutputService:(0,w.$$z)("MainThreadOutputService"),MainThreadProgress:(0,w.$$z)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$$z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$$z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$$z)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$$z)("MainThreadSecretState"),MainThreadStorage:(0,w.$$z)("MainThreadStorage"),MainThreadTelemetry:(0,w.$$z)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$$z)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$$z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$$z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$$z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$$z)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$$z)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$$z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$$z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$$z)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$$z)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$$z)("MainThreadExtensionService"),MainThreadSCM:(0,w.$$z)("MainThreadSCM"),MainThreadSearch:(0,w.$$z)("MainThreadSearch"),MainThreadShare:(0,w.$$z)("MainThreadShare"),MainThreadTask:(0,w.$$z)("MainThreadTask"),MainThreadWindow:(0,w.$$z)("MainThreadWindow"),MainThreadLabelService:(0,w.$$z)("MainThreadLabelService"),MainThreadNotebook:(0,w.$$z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$$z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$$z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$$z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$$z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$$z)("MainThreadInteractive"),MainThreadChat:(0,w.$$z)("MainThreadChat"),MainThreadInlineChat:(0,w.$$z)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$$z)("MainThreadTheming"),MainThreadTunnelService:(0,w.$$z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$$z)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$$z)("MainThreadTimeline"),MainThreadTesting:(0,w.$$z)("MainThreadTesting"),MainThreadLocalization:(0,w.$$z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$$z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$$z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$$z)("MainThreadIssueReporter")},e.$UJ={ExtHostCommands:(0,w.$$z)("ExtHostCommands"),ExtHostConfiguration:(0,w.$$z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$$z)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$$z)("ExtHostDebugService"),ExtHostDecorations:(0,w.$$z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$$z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$$z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$$z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$$z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$$z)("ExtHostEditors"),ExtHostTreeViews:(0,w.$$z)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$$z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$$z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$$z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$$z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$$z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$$z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$$z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$$z)("ExtHostStatusBar"),ExtHostShare:(0,w.$$z)("ExtHostShare"),ExtHostExtensionService:(0,w.$$z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$$z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$$z)("ExtHostTerminalService"),ExtHostSCM:(0,w.$$z)("ExtHostSCM"),ExtHostSearch:(0,w.$$z)("ExtHostSearch"),ExtHostTask:(0,w.$$z)("ExtHostTask"),ExtHostWorkspace:(0,w.$$z)("ExtHostWorkspace"),ExtHostWindow:(0,w.$$z)("ExtHostWindow"),ExtHostWebviews:(0,w.$$z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$$z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$$z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$$z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$$z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$$z)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$$z)("ExtHostProgress"),ExtHostComments:(0,w.$$z)("ExtHostComments"),ExtHostSecretState:(0,w.$$z)("ExtHostSecretState"),ExtHostStorage:(0,w.$$z)("ExtHostStorage"),ExtHostUrls:(0,w.$$z)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$$z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$$z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$$z)("ExtHostOutputService"),ExtHosLabelService:(0,w.$$z)("ExtHostLabelService"),ExtHostNotebook:(0,w.$$z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$$z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$$z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$$z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$$z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$$z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$$z)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$$z)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$$z)("ExtHostChat"),ExtHostChatSlashCommands:(0,w.$$z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,w.$$z)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$$z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$$z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$$z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$$z)("ExtHostTheming"),ExtHostTunnelService:(0,w.$$z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$$z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$$z)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$$z)("ExtHostTimeline"),ExtHostTesting:(0,w.$$z)("ExtHostTesting"),ExtHostTelemetry:(0,w.$$z)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$$z)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$$z)("ExtHostIssueReporter")}}),define(Ae[217],Re([1,0,3,7]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$TJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,S){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(l,S)??[]}getRelatedInformation(A,l,S){return this.c.$getAiRelatedInformation(l,S)}registerRelatedInformationProvider(A,l,S){const f=this.b;return this.b++,this.a.set(f,S),this.c.$registerAiRelatedInformationProvider(f,l),new T.$VJ(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$Mcc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=e.$Pac=e.$Oac=void 0,e.$Oac=(0,w.$Ah)("IExtHostApiDeprecationService");let A=class{constructor(S,f){this.c=f,this.a=new Set,this.b=S.getProxy(C.$TJ.MainThreadTelemetry)}report(S,f,P){const k=this.d(S,f);this.a.has(k)||(this.a.add(k),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:S}))}d(S,f){return`${S}-${f.identifier.value}`}};e.$Pac=A,e.$Pac=A=Ke([Ve(0,L.$VL),Ve(1,T.$4i)],A),e.$Qac=Object.freeze(new class{report(l,S,f){}})}),define(Ae[218],Re([1,0,5,3,7,20]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new w.$ed,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=f.getProxy(T.$TJ.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,P,k,u={}){const p=L.$Ul.toKey(f.identifier),m=[...k].sort().join(" ");return await this.f.getOrCreate(`${p} ${P} ${m}`,async()=>{await this.a.$ensureProvider(P);const h=f.displayName||f.name;return this.a.$getSession(P,k,p,h,u)})}async getSessions(f,P,k){const u=L.$Ul.toKey(f.identifier),p=[...k].sort().join(" ");return await this.g.getOrCreate(`${u} ${p}`,async()=>{await this.a.$ensureProvider(P);const m=f.displayName||f.name;return this.a.$getSessions(P,k,u,m)})}async removeSession(f,P){const k=this.b.get(f);return k?k.provider.removeSession(P):this.a.$removeSession(f,P)}registerAuthenticationProvider(f,P,k,u){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:P,provider:k,options:u??{supportsMultipleAccounts:!1}}),this.c.find(m=>m.id===f)||this.c.push({id:f,label:P});const p=k.onDidChangeSessions(m=>{this.a.$sendDidChangeSessions(f,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this.a.$registerAuthenticationProvider(f,P,u?.supportsMultipleAccounts??!1),new C.$VJ(()=>{p.dispose(),this.b.delete(f);const m=this.c.findIndex(h=>h.id===f);m>-1&&this.c.splice(m),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,P,k){const u=this.b.get(f);if(u)return Promise.resolve(u.provider.createSession(P,k));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,P){const k=this.b.get(f);if(k)return Promise.resolve(k.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,P){const k=this.b.get(f);if(k)return Promise.resolve(k.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,P){return this.d.fire({provider:{id:f,label:P}}),Promise.resolve()}}e.$kcc=A;class l{constructor(){this.a=new Map}getOrCreate(f,P){const k=this.a.get(f);if(k)return k;const u=P().finally(()=>this.a.delete(f));return this.a.set(f,u),u}}}),define(Ae[219],Re([1,0,3,17,8]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;let L=class{constructor(l,S){this.a=l.getProxy(w.$TJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>S.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,S,f){const P=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,f?.isRefactoring??!1)}};e.$qcc=L,e.$qcc=L=Ke([Ve(0,T.$VL)],L)}),define(Ae[220],Re([1,0,13,5,66,6,58,147,3,8]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class P{static{this.a=0}constructor(p,m){this.extension=p,this.provider=m,this.handle=P.a++}}class k{static{this.a=0}constructor(p,m){this.h=m,this.b=new Map,this.d=new Map,this.e=new T.$ed,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(S.$TJ.MainThreadChat)}registerChatProvider(p,m,h){const t=new P(p,h);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,m),(0,L.$hc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,m){const h=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof h=="number"&&this.g.$transferChatSession(h,m)}addChatRequest(p){this.g.$addRequest(p)}sendInteractiveRequestToProvider(p,m){this.g.$sendRequestToProvider(p,m)}async $prepareChat(p,m,h){const t=this.b.get(p);if(!t)return;const i=await t.provider.prepareSession(m,h);if(!i)return;const c=k.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(p,m,h,t){const i=this.b.get(p);if(!i)return;const c=this.d.get(m);if(!c||!i.provider.resolveRequest)return;const g=await i.provider.resolveRequest(c,h,t);if(g)return{message:typeof g.message=="string"?g.message:f.ChatReplyFollowup.from(g.message)}}async $provideWelcomeMessage(p,m){const h=this.b.get(p);if(!h||!h.provider.provideWelcomeMessage)return;const t=await h.provider.provideWelcomeMessage(m);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>f.ChatReplyFollowup.from(c)))}async $provideFollowups(p,m,h){const t=this.b.get(p);if(!t)return;const i=this.d.get(m);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,h))?.map(g=>f.ChatFollowup.from(g))}$removeRequest(p,m,h){const t=this.b.get(p);if(!t)return;const i=this.d.get(m);i&&t.provider.removeRequest&&t.provider.removeRequest(i,h)}async $provideReply(p,m,h,t){const i=this.b.get(p);if(!i)return;const c=this.d.get(m);if(!c)return;const g={session:c,message:typeof h.message=="string"?h.message:f.ChatReplyFollowup.to(h.message),variables:{}};if(h.variables)for(const o of Object.keys(h.variables))g.variables[o]=h.variables[o].map(f.ChatVariable.to);const D=A.$ad.create(!1);let b;const n={report:o=>{if(!t.isCancellationRequested)if(typeof b>"u"&&(b=D.elapsed()),"responseId"in o)this.g.$acceptResponseProgress(p,m,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const y=Promise.all([this.g.$acceptResponseProgress(p,m,{placeholder:o.placeholder}),o.resolvedContent]);(0,w.$ug)(y,t).then($=>{if(!$)return;const[I,E]=$;this.g.$acceptResponseProgress(p,m,E,I??void 0)})}else"content"in o?this.g.$acceptResponseProgress(p,m,{content:typeof o.content=="string"?o.content:f.MarkdownString.from(o.content)}):this.g.$acceptResponseProgress(p,m,o)}};let a;try{a=await i.provider.provideResponseWithProgress(g,n,t),a||(a={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){a={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has(m)){const o=c.saveState();this.g.$acceptChatState(m,o)}}catch(o){this.h.warn(o)}const s={firstProgress:b??0,totalElapsed:D.elapsed()};return{errorDetails:a.errorDetails,timings:s}}async $provideSlashCommands(p,m,h){const t=this.b.get(p);if(!t)return;const i=this.d.get(m);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,h))?.map(g=>({...g,kind:f.CompletionItemKind.from(g.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$Ecc=k}),define(Ae[221],Re([1,0,6,3,8,72,20]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class l{static{this.a=1}constructor(f,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Wl,this.b=f.getProxy(T.$TJ.MainThreadChatProvider)}registerProvider(f,P,k,u){const p=l.a++;return this.c.set(p,{extension:f,provider:k}),this.b.$registerProvider(p,P,{extension:f,displayName:u.name??f.value}),(0,w.$hc)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(f,P,k,u,p){const m=this.c.get(f);if(!m)return;const h=new L.$2u(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${m.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return m.provider.provideChatResponse(k.map(C.ChatMessage.to),u,h,p)}allowListExtensionWhile(f,P){this.f.set(f,P),P.finally(()=>this.f.delete(f))}async requestChatResponseProvider(f,P){if(!this.f.has(f))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k.f.has(f)},async makeRequest(u,p,m,h){if(!k.f.has(f))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;k.e.set(t,m);try{await k.b.$fetchResponse(f,P,t,u.map(C.ChatMessage.from),p,h)}finally{k.e.delete(t)}}}}async $handleResponseFragment(f,P){this.e.get(f)?.report(P)}}e.$Jcc=l}),define(Ae[222],Re([1,0,6,3,7,8,72,13]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class S{static{this.a=0}constructor(k,u,p){this.d=u,this.e=p,this.b=new Map,this.c=k.getProxy(T.$TJ.MainThreadChatSlashCommands)}registerCommand(k,u,p,m){const h=S.a++;return this.b.set(h,{extension:k,command:p}),this.c.$registerCommand(h,u,m.description),(0,w.$hc)(()=>{this.c.$unregisterCommand(h),this.b.delete(h)})}async $executeCommand(k,u,p,m,h){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT execute command because the command is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const g=new l.$1g;h.onCancellationRequested(()=>g.complete()),setTimeout(()=>g.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,g.p);const D=t.command({role:C.ChatMessageRole.User,content:p},{history:m.history.map(L.ChatMessage.to)},new A.$2u(b=>{c(),this.c.$handleProgressChunk(u,{content:f(b.message)?b.message:b.message.value})}),h);try{return await(0,l.$ug)(Promise.resolve(D).then(b=>{if(b&&"followUp"in b)return{followUp:b?.followUp?.map(a=>L.ChatFollowup.from(a))}}),h)}finally{i=!0,g.complete()}}}e.$Kcc=S;function f(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[223],Re([1,0,6,3,9,8]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class A{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(T.$TJ.MainThreadChatVariables)}async $resolveVariable(S,f,P){const k=this.b.get(S);if(k)try{const u=await k.resolver.resolve(k.data.name,{message:f},P);if(u)return u.map(L.ChatVariable.from)}catch(u){(0,C.$Z)(u)}}registerVariableResolver(S,f,P,k){const u=A.a++;return this.b.set(u,{extension:S.identifier,data:{name:f,description:P},resolver:k}),this.c.$registerVariable(u,{name:f,description:P}),(0,w.$hc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$Lcc=A}),define(Ae[224],Re([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=void 0;class T{constructor(L){const A=L.getProxy(w.$TJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$Tac=T}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,68,44,278,2,6,4,17,105,25,46,41,58,52,57]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=void 0;let a=class{#e;#t;#i;constructor(E,r,d){this.b=new Map,this.c=new Map,this.#e=E.getProxy(A.$TJ.MainThreadCommands),this.d=r,this.#i=d,this.#t=E.getProxy(A.$TJ.MainThreadTelemetry),this.converter=new s(this,v=>{const R=this.c.get(v);return R?.result===y.Void?R:void 0},r),this.f=[{processArgument(v){return(0,f.$0g)(v)}},{processArgument(v){return(0,L.$Wm)(v,function(R){if(P.$is.isIRange(R))return C.Range.to(R);if(k.$hs.isIPosition(R))return C.Position.to(R);if(P.$is.isIRange(R.range)&&u.URI.isUri(R.uri))return C.location.to(R);if(R instanceof i.$Ed)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(E){this.f.push(E)}registerApiCommand(E){const r=this.registerCommand(!1,E.id,async(...d)=>{const v=E.args.map((B,V)=>{if(!B.validate(d[V]))throw new Error(`Invalid argument '${B.name}' when running '${E.id}', received: ${d[V]}`);return B.convert(d[V])}),R=await this.executeCommand(E.internalId,...v);return E.result.convert(R,d,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this.c.set(E.id,E),new T.$VJ(()=>{r.dispose(),this.c.delete(E.id)})}registerCommand(E,r,d,v,R,B){if(this.d.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this.b.has(r))throw new Error(`command '${r}' already exists`);return this.b.set(r,{callback:d,thisArg:v,description:R,extension:B}),E&&this.#e.$registerCommand(r),new T.$VJ(()=>{this.b.delete(r)&&E&&this.#e.$unregisterCommand(r)})}executeCommand(E,...r){return this.d.trace("ExtHostCommands#executeCommand",E),this.g(E,r,!0)}async g(E,r,d){if(this.b.has(E))return this.#e.$fireCommandActivationEvent(E),this.h(E,r,!1);{let v=!1;const R=(0,L.$Wm)(r,function(B){if(B instanceof T.$WJ)return C.Position.from(B);if(B instanceof T.$XJ)return C.Range.from(B);if(B instanceof T.$8J)return C.location.from(B);if(T.$hL.isNotebookRange(B))return C.NotebookRange.from(B);if(B instanceof ArrayBuffer)return v=!0,i.$Ed.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return v=!0,i.$Ed.wrap(B);if(B instanceof i.$Ed)return v=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(E,v?new c.$aA(R):R,d);return(0,f.$0g)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(E,r,!1);throw B}}}async h(E,r,d){const v=this.b.get(E);if(!v)throw new Error("Unknown command");const{callback:R,thisArg:B,description:V}=v;if(V)for(let W=0;W<V.args.length;W++)try{(0,w.$zf)(r[W],V.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${V.args[W].name}' - ${V.args[W].description}`)}const j=D.$ad.create();try{return await R.apply(B,r)}catch(W){if(E===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...r);N&&(E=N.command)}if(this.d.error(W,E,v.extension?.identifier),!d)throw W;if(v.extension?.identifier){const N=this.#i.onExtensionError(v.extension.identifier,W);this.d.trace("forwarded error to extension?",N,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.$li)(W)),this.id=E,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,E,j.elapsed())}}j(E,r,d){E.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new b.$$n(r),duration:d})}$executeContributedCommand(E,...r){this.d.trace("ExtHostCommands#$executeContributedCommand",E);const d=this.b.get(E);return d?(r=r.map(v=>this.f.reduce((R,B)=>B.processArgument(R,d.extension?.identifier),v)),this.h(E,r,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this.d.trace("ExtHostCommands#getCommands",E),this.#e.$getCommands().then(r=>(E&&(r=r.filter(d=>d[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const E=Object.create(null);for(const[r,d]of this.b){const{description:v}=d;v&&(E[r]=v)}return Promise.resolve(E)}};e.$eM=a,e.$eM=a=Ke([Ve(0,h.$VL),Ve(1,S.$4i),Ve(2,n.$dM)],a),e.$fM=(0,m.$Ah)("IExtHostCommands");class s{constructor(E,r,d){this.d=E,this.f=r,this.g=d,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(E,r){if(!E)return;const d={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return d;const v=this.f(E.command);if(v)d.id=v.internalId,d.arguments=v.args.map((R,B)=>R.convert(E.arguments&&E.arguments[B]));else if((0,l.$Ib)(E.arguments)){const R=`${E.command}/${++this.c}`;this.b.set(R,E),r.add((0,p.$hc)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),d.$ident=R,d.id=this.delegatingCommandId,d.arguments=[R],this.g.trace("CommandsConverter#CREATE",E.command,R)}return d}fromInternal(E){return typeof E.$ident=="string"?this.b.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this.b.get(E[0])}h(...E){const r=this.getActualCommand(...E);return this.g.trace("CommandsConverter#EXECUTE",E[0],r?r.command:"MISSING"),r?this.d.executeCommand(r.command,...r.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.$gM=s;class o{static{this.Uri=new o("uri","Uri of a text document",E=>u.URI.isUri(E),E=>E)}static{this.Position=new o("position","A position in a text document",E=>T.$WJ.isPosition(E),C.Position.from)}static{this.Range=new o("range","A range in a text document",E=>T.$XJ.isRange(E),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",E=>T.$YJ.isSelection(E),C.Selection.from)}static{this.Number=new o("number","",E=>typeof E=="number",E=>E)}static{this.String=new o("string","",E=>typeof E=="string",E=>E)}static{this.StringArray=o.Arr(o.String)}static Arr(E){return new o(`${E.name}_array`,`Array of ${E.name}, ${E.description}`,r=>Array.isArray(r)&&r.every(d=>E.validate(d)),r=>r.map(d=>E.convert(d)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",E=>E instanceof T.$gK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",E=>E instanceof T.$AL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",E=>E instanceof t.$9L,C.TestItem.from)}constructor(E,r,d,v){this.name=E,this.description=r,this.validate=d,this.convert=v}optional(){return new o(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,r){return new o(E??this.name,r??this.description,this.validate,this.convert)}}e.$hM=o;class y{static{this.Void=new y("no result",E=>E)}constructor(E,r){this.description=E,this.convert=r}}e.$iM=y;class ${constructor(E,r,d,v,R){this.id=E,this.internalId=r,this.description=d,this.args=v,this.result=R}}e.$jM=$}),define(Ae[225],Re([1,0,18,12,2,78,91,32,95,31,8,7]),function(be,e,w,T,C,L,A,l,S,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;const u=[new f.$jM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of DocumentHighlight-instances.",m(P.DocumentHighlight.to))),new f.$jM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$hM.Uri],new f.$iM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.$Hb)(t))return;class c extends k.$aK{static to(D){const b=new c(D.name,P.SymbolKind.to(D.kind),D.containerName||"",new k.$8J(i[0],P.Range.to(D.range)));return b.detail=D.detail,b.range=b.location.range,b.selectionRange=P.Range.to(D.selectionRange),b.children=D.children?D.children.map(c.to):[],b}}return t.map(c.to)})),new f.$jM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$hM.Uri,new f.$hM("options","Formatting options",t=>!0,t=>t)],new f.$iM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new f.$jM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$hM.Uri,f.$hM.Range,new f.$hM("options","Formatting options",t=>!0,t=>t)],new f.$iM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new f.$jM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$hM.Uri,f.$hM.Position,new f.$hM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$hM("options","Formatting options",t=>!0,t=>t)],new f.$iM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new f.$jM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$jM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$jM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$jM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$jM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of Location-instances.",m(P.location.to))),new f.$jM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of Hover-instances.",m(P.Hover.to))),new f.$jM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$hM.Uri,new f.$hM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>k.$WJ.isPosition(i)),t=>t.map(P.Position.from))],new f.$iM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const g of i.reverse())c=new k.$fK(P.Range.to(g),c);return c}))),new f.$jM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$hM.String.with("query","Search string")],new f.$iM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new f.$jM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new f.$jM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$hM.CallHierarchyItem],new f.$iM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new f.$jM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$hM.CallHierarchyItem],new f.$iM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new f.$jM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new f.$jM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$hM.Uri,f.$hM.Position,f.$hM.String.with("newName","The new symbol name")],new f.$iM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new f.$jM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$hM.Uri,f.$hM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$iM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new f.$jM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$hM.Uri],new f.$iM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$_K(t.tokenTypes,t.tokenModifiers)})),new f.$jM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$hM.Uri],new f.$iM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$k0)(t);if(i.type==="full")return new k.$bL(i.data,void 0)})),new f.$jM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$hM.Uri,f.$hM.Range.optional()],new f.$iM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$_K(t.tokenTypes,t.tokenModifiers)})),new f.$jM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$hM.Uri,f.$hM.Range],new f.$iM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$k0)(t);if(i.type==="full")return new k.$bL(i.data,void 0)})),new f.$jM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$hM.Uri,f.$hM.Position,f.$hM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$hM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$iM("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new k.$rK([]);const g=t.suggestions.map(D=>P.CompletionItem.to(D,c));return new k.$rK(g,t.incomplete)})),new f.$jM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$hM.Uri,f.$hM.Position,f.$hM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$iM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new f.$jM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$hM.Uri,f.$hM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$iM("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>m(g=>new k.$jK(P.Range.to(g.range),g.command&&c.fromInternal(g.command)))(t))),new f.$jM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$hM.Uri,new f.$hM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$XJ.isRange(t),t=>k.$YJ.isSelection(t)?P.Selection.from(t):P.Range.from(t)),f.$hM.String.with("kind","Code action kind to return code actions for").optional(),f.$hM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$iM("A promise that resolves to an array of Command-instances.",(t,i,c)=>m(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(g.command)}else{const D=new k.$cK(g.title,g.kind?new k.$dK(g.kind):void 0);return g.edit&&(D.edit=P.WorkspaceEdit.to(g.edit)),g.command&&(D.command=c.fromInternal(g.command)),D.isPreferred=g.isPreferred,D}})(t))),new f.$jM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$hM.Uri],new f.$iM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new k.$xK(P.Range.to(i.range),P.Color.to(i.color))):[])),new f.$jM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$hM("color","The color to show and insert",t=>t instanceof k.$wK,P.Color.from),new f.$hM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new f.$iM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new f.$jM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$hM.Uri,f.$hM.Range],new f.$iM("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new f.$jM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$hM.Uri],new f.$iM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new f.$jM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$iM("A promise that resolves to an array of NotebookContentProvider static info objects.",m(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new f.$jM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$hM.Uri,f.$hM.Range,new f.$hM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$XJ,t=>P.InlineValueContext.from(t))],new f.$iM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new f.$jM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$hM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,S.$ET)(t,T.Schemas.http,T.Schemas.https),t=>t),new f.$hM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),f.$hM.String.with("label","").optional()],f.$iM.Void),new f.$jM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$hM.Uri.with("resource","Resource to open"),f.$hM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new f.$hM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],f.$iM.Void),new f.$jM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$hM.Uri.with("left","Left-hand side resource of the diff editor"),f.$hM.Uri.with("right","Right-hand side resource of the diff editor"),f.$hM.String.with("title","Human readable title for the diff editor").optional(),new f.$hM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],f.$iM.Void),new f.$jM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$hM.Uri,f.$hM.Position],new f.$iM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$jM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$hM.TypeHierarchyItem],new f.$iM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$jM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$hM.TypeHierarchyItem],new f.$iM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$jM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$hM.TestItem],f.$iM.Void),new f.$jM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$hM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$iM.Void),new f.$jM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$hM.String.with("name","The context key name"),new f.$hM("value","The context key value",()=>!0,t=>t)],f.$iM.Void),new f.$jM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$hM.Uri,f.$hM.StringArray,new f.$hM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new f.$iM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class p{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Ii)}}e.$Sac=p;function m(t){return i=>{if(Array.isArray(i))return i.map(t)}}function h(t){if(!Array.isArray(t))return;const i=[];for(const c of t)L.$6s(c)?i.push(P.DefinitionLink.to(c)):i.push(P.location.to(c));return i}}),define(Ae[226],Re([1,0,13,64,5,6,2,78,20,8,7,3,26]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0;function p(m,h,t){const i=m.getProxy(k.$TJ.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new S.$Wl,h.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===6){const I=this.b.get($.handle);return I?I.value:$}else if($&&$.$mid===7){const I=this.b.get($.commentControlHandle);if(!I)return $;const E=I.getCommentThread($.commentThreadHandle);return E?E.value:$}else if($&&($.$mid===9||$.$mid===8)){const I=this.b.get($.thread.commentControlHandle);if(!I)return $;const E=I.getCommentThread($.thread.commentThreadHandle);return E?$.$mid===8?E.value:{thread:E.value,text:$.text}:$}else if($&&$.$mid===10){const I=this.b.get($.thread.commentControlHandle);if(!I)return $;const E=I.getCommentThread($.thread.commentThreadHandle);if(!E)return $;const r=$.commentUniqueId,d=E.getCommentByUniqueId(r);return d||$}else if($&&$.$mid===11){const I=this.b.get($.thread.commentControlHandle);if(!I)return $;const E=I.getCommentThread($.thread.commentThreadHandle);if(!E)return $;const r=$.text,d=$.commentUniqueId,v=E.getCommentByUniqueId(d);return v?(typeof v.body=="string"?v.body=r:v.body=new P.$kK(r),v):$}return $}})}createCommentController($,I,E){const r=c.a++,d=new D($,r,I,E);this.b.set(d.handle,d);const v=this.c.get($.identifier)||[];return v.push(d),this.c.set($.identifier,v),d.value}$createCommentThreadTemplate($,I,E){const r=this.b.get($);r&&r.$createCommentThreadTemplate(I,E)}async $updateCommentThreadTemplate($,I,E){const r=this.b.get($);r&&r.$updateCommentThreadTemplate(I,E)}$deleteCommentThread($,I){this.b.get($)?.$deleteCommentThread(I)}$provideCommentingRanges($,I,E){const r=this.b.get($);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const d=t.getDocument(A.URI.revive(I));return(0,w.$yg)(async()=>{const v=await r.commentingRangeProvider.provideCommentingRanges(d,E);let R;return Array.isArray(v)?R={ranges:v,fileComments:!1}:v?R={ranges:v.ranges||[],fileComments:v.fileComments||!1}:R=v??void 0,R}).then(v=>{let R;return v&&(R={ranges:v.ranges.map(B=>f.Range.from(B)),fileComments:v.fileComments}),R})}$toggleReaction($,I,E,r,d){const v=this.b.get($);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,w.$yg)(()=>{const R=v.getCommentThread(I);if(R){const B=R.getCommentByUniqueId(r.uniqueIdInThread);if(v!==void 0&&B&&v.reactionHandler)return v.reactionHandler(B,a(d))}return Promise.resolve(void 0)})}}class g{static{this.a=0}set threadId($){this.n=$}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range($){($===void 0!=(this.p===void 0)||!$||!this.p||!$.isEqual(this.p))&&(this.p=$,this.b.range=$,this.c.fire())}get range(){return this.p}set canReply($){this.d!==$&&(this.d=$,this.b.canReply=$,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label($){this.e=$,this.b.label=$,this.c.fire()}get contextValue(){return this.f}set contextValue($){this.f=$,this.b.contextValue=$,this.c.fire()}get comments(){return this.q}set comments($){this.q=$,this.b.comments=$,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState($){this.g=$,this.b.collapsibleState=$,this.c.fire()}get state(){return this.h}set state($){this.h=$,this.b.state=$,this.c.fire()}get isDisposed(){return this.j}constructor($,I,E,r,d,v,R,B){this.m=I,this.n=E,this.o=r,this.p=d,this.q=v,this.extensionDescription=R,this.r=B,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$ed,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$kc,this.l.value=new L.$ic,this.n===void 0&&(this.n=`${$}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,f.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(j){V.range=j},get comments(){return V.comments},set comments(j){V.comments=j},get collapsibleState(){return V.collapsibleState},set collapsibleState(j){V.collapsibleState=j},get canReply(){return V.canReply},set canReply(j){V.canReply=j},get contextValue(){return V.contextValue},set contextValue(j){V.contextValue=j},get label(){return V.label},set label(j){V.label=j},get state(){return V.state},set state(j){V.state=j},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$ic);const $=E=>Object.prototype.hasOwnProperty.call(this.b,E),I={};$("range")&&(I.range=f.Range.from(this.p)),$("label")&&(I.label=this.label),$("contextValue")&&(I.contextValue=this.contextValue??null),$("comments")&&(I.comments=this.q.map(E=>b(this,E,this.k,this.extensionDescription))),$("collapsibleState")&&(I.collapseState=s(this.g)),$("canReply")&&(I.canReply=this.canReply),$("state")&&(I.state=o(this.h)),$("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId($){for(const I of this.k){const E=I[0],r=I[1];if($===r)return E}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach($=>$.dispose())}}Ke([(0,T.$6g)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class D{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider($){this.b=$,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler($){this.c=$,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!$})}get options(){return this.d}set options($){this.d=$,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor($,I,E,r){this.f=$,this.g=I,this.h=E,this.i=r,this.a=new Map,i.$registerCommentController(this.handle,E,r);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(v){d.options=v},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(v){d.commentingRangeProvider=v},get reactionHandler(){return d.reactionHandler},set reactionHandler(v){d.reactionHandler=v},createCommentThread(v,R,B){return d.createCommentThread(v,R,B).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread($,I,E){I===void 0&&(0,u.$NF)(this.f,"fileComments");const r=new g(this.id,this.handle,void 0,$,I,E,this.f,!1);return this.a.set(r.handle,r),r}$createCommentThreadTemplate($,I){const E=new g(this.id,this.handle,void 0,A.URI.revive($),f.Range.to(I),[],this.f,!0);return E.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate($,I){const E=this.a.get($);E&&(E.range=f.Range.to(I))}$deleteCommentThread($){this.a.get($)?.dispose(),this.a.delete($)}getCommentThread($){return this.a.get($)}dispose(){this.a.forEach($=>{$.dispose()}),this.e.forEach($=>$.dispose())}}function b(y,$,I,E){let r=I.get($);return r||(r=++y.commentHandle,I.set($,r)),$.state!==void 0&&(0,u.$NF)(E,"commentsDraftState"),{mode:$.mode,contextValue:$.contextValue,uniqueIdInThread:r,body:typeof $.body=="string"?$.body:f.MarkdownString.from($.body),userName:$.author.name,userIconPath:$.author.iconPath,label:$.label,commentReactions:$.reactions?$.reactions.map(d=>n(d)):void 0,state:$.state,timestamp:$.timestamp?.toJSON()}}function n(y){return{label:y.label,iconPath:y.iconPath?f.$UL(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function a(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?A.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function s(y){if(y!==void 0)switch(y){case P.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case P.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new c}e.$Uac=p}),define(Ae[227],Re([1,0,24,3,27,17]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;let A=class{constructor(P,k){this.a=P.getProxy(T.$TJ.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,k){const u=this,p=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,k,p,arguments)}})}e(P,k,u,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:S(p,this.b)}),this.c&&this.f(P,u,p)}};e.$Qcc=A,e.$Qcc=A=Ke([Ve(0,L.$VL),Ve(1,C.$_L)],A);const l=1e5;function S(f,P){const k=[];if(f.length)for(let u=0;u<f.length;u++){let p=f[u];if(typeof p>"u")p="undefined";else if(p instanceof Error){const m=p;m.stack?p=m.stack:p=m.toString()}k.push(p)}if(P){const u=new Error().stack;u&&k.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,w.$Zm)(k);return u.length>l?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ae[108],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,T,C,L,A,l,S,f,P,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=void 0;let p=class{static{u=this}static{this.c=0}static{this.d=250}constructor(h,t){this.h=t,this.f=new Map,this.g=h.getProxy(T.$TJ.MainThreadDecorations)}registerFileDecorationProvider(h,t){const i=u.c++;this.f.set(i,{provider:h,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(i,null);return}const D=(0,S.$Zb)(g);if(D.length<=u.d){this.g.$onDidChange(i,D);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,D.length);const b=D.map(s=>({uri:s,rank:(0,f.$qe)(s.path,"/")})),n=(0,S.$xb)(b,(s,o)=>s.rank-o.rank||(0,f.$Ee)(s.uri.path,o.uri.path)),a=[];e:for(const s of n){let o;for(const y of s){const $=(0,P.$$d)(y.uri.path);if(o!==$&&(o=$,a.push(y.uri)>=u.d))break e}}this.g.$onDidChange(i,a)});return new C.$VJ(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(h,t,i){if(!this.f.has(h))return Object.create(null);const c=Object.create(null),{provider:g,extensionDescription:D}=this.f.get(h);return await Promise.all(t.map(async b=>{try{const{uri:n,id:a}=b,s=await Promise.resolve(g.provideFileDecoration(w.URI.revive(n),i));if(!s)return;try{C.$fL.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.$NF)(D,"codiconDecoration"),c[a]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${D.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),c}};e.$Vbc=p,e.$Vbc=p=u=Ke([Ve(0,A.$VL),Ve(1,l.$4i)],p),e.$Wbc=(0,L.$Ah)("IExtHostDecorations")}),define(Ae[228],Re([1,0,148,94,2,3,7,8,5,14,28,39]),function(be,e,w,T,C,L,A,l,S,f,P,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=e.$Mac=void 0;class p{#e;#t;#i;constructor(t,i,c,g,D,b,n,a){this.d=t,this.e=i,this.f=c,this.g=g,this.h=D,this.c=!1,this.f=Math.max(g,c),this.#i=new P.$yi(s=>b.getComparisonKey(s)),this.#e=n,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let b;t=[...t].sort(p.k);for(const n of t){const[a,s]=n;if((!b||a.toString()!==b.toString())&&(b&&this.#i.get(b).length===0&&this.#i.delete(b),b=a,c.push(a),this.#i.set(a,[])),s)this.#i.get(a)?.push(...s);else{const o=this.#i.get(a);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const g=[];let D=0;for(const b of c){let n=[];const a=this.#i.get(b);if(a)if(a.length>this.g){n=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const y of a)if(y.severity===s[o]&&n.push({...l.Diagnostic.from(y),modelVersionId:this.h(b)})===this.g)break e;n.push({severity:T.MarkerSeverity.Info,message:(0,w.localize)(0,null,a.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=a.map(s=>({...l.Diagnostic.from(s),modelVersionId:this.h(b)}));if(g.push([b,n]),D+=n.length,D>this.f)break}this.#e.$changeMany(this.e,g)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,g]of this)t.call(i,c,g,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Mac=p;let m=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new P.$yi;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,g){this.j=i,this.k=c,this.l=g,this.g=new Map,this.h=new S.$id({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.h.event,u._mapper),this.f=t.getProxy(L.$TJ.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:g,h:D,j:b,k:n,l:a}=this,s=new class{$changeMany($,I){g.$changeMany($,I),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,$,I.length===0?"CLEARING":I)}$clear($){g.$clear($),b.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,$)}dispose(){g.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,o=i;else if(!c.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+u.c++;while(c.has(o))}return new class extends p{constructor(){super(i,o,u.e,u.d,$=>a.getDocument($)?.version,n.extUri,s,D),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const g of this.g.values())g.forEach((D,b)=>{let n=i.get(D.toString());typeof n>"u"&&(n=c.length,i.set(D.toString(),n),c.push([D,[]])),c[n][1]=c[n][1].concat(...b)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new p(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,g=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(C.URI.revive(i),c.map(l.Diagnostic.to))}};e.$Nac=m,e.$Nac=m=u=Ke([Ve(1,f.$4i),Ve(2,k.$Lac)],m)}),define(Ae[229],Re([1,0,2,3,26]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=void 0;class L{constructor(l){this.a=l.getProxy(T.$TJ.MainThreadDialogs)}showOpenDialog(l,S){return S?.allowUIResources&&(0,C.$NF)(l,"showLocal"),this.a.$showOpenDialog(S).then(f=>f?f.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(S=>S?w.URI.revive(S):void 0)}}e.$3ac=L}),define(Ae[230],Re([1,0,9,2,7,3,12,21,15]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=void 0;class f{static{this.a=0}constructor(k,u,p){this.d=u,this.e=p,this.b=new Map,this.c=k.getProxy(L.$TJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,u){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=f.a++;this.b.set(p,u),this.c.$registerTextContentProvider(p,k);let m;return typeof u.onDidChange=="function"&&(m=u.onDidChange(h=>{if(h.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this.d.getDocument(h)&&this.$provideTextDocumentContent(p,h).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(h);if(!i)return;const c=(0,S.$ze)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(h,t)},w.$Y)})),new C.$VJ(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(k,u){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(u),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$4ac=f}),define(Ae[231],Re([1,0,5,6,2,3,101,8,16,24,7,9]),function(be,e,w,T,C,L,A,l,S,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;class u{constructor(m,h){this.a=new w.$ed({onListenerError:k.$Z}),this.b=new w.$ed({onListenerError:k.$Z}),this.c=new w.$ed({onListenerError:k.$Z}),this.d=new w.$ed({onListenerError:k.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$ic,this.h=new Map,this.f=m.getProxy(L.$TJ.MainThreadDocuments),this.g=h,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(m){if(!m)return;const h=this.g.getDocument(m);if(h)return h}getDocument(m){const h=this.getDocumentData(m);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return h.document}ensureDocumentData(m){const h=this.g.getDocument(m);if(h)return Promise.resolve(h);let t=this.h.get(m.toString());return t||(t=this.f.$tryOpenDocument(m).then(i=>{this.h.delete(m.toString());const c=C.URI.revive(i);return(0,S.$tf)(this.g.getDocument(c))},i=>(this.h.delete(m.toString()),Promise.reject(i))),this.h.set(m.toString(),t)),t}createDocumentData(m){return this.f.$tryCreateDocument(m).then(h=>C.URI.revive(h))}$acceptModelLanguageChanged(m,h){const t=C.URI.revive(m),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(h),this.a.fire(i.document)}$acceptModelSaved(m){const h=C.URI.revive(m),t=this.g.getDocument(h);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(m,h){const t=C.URI.revive(m),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(h),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,h,t){const i=C.URI.revive(m),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(h);let g;h.isUndoing?g=P.TextDocumentChangeReason.Undo:h.isRedoing&&(g=P.TextDocumentChangeReason.Redo),this.c.fire((0,f.$Vm)({document:c.document,contentChanges:h.changes.map(D=>({range:l.Range.to(D.range),rangeOffset:D.rangeOffset,rangeLength:D.rangeLength,text:D.text})),reason:g}))}setWordDefinitionFor(m,h){(0,A.$XL)(m,h)}}e.$Jac=u}),define(Ae[59],Re([1,0,50,5,6,2,4,3,101,17,106,8,14,28,12,66,65]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=void 0;class i{constructor(D){this.value=D,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(D,b){this.h=D,this.i=b,this.a=null,this.b=new Map,this.c=new p.$yi,this.d=new T.$ed,this.e=new T.$ed,this.f=new T.$ed,this.g=new T.$ed,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const b=[],n=[],a=[];if(D.removedDocuments)for(const s of D.removedDocuments){const o=L.URI.revive(s),y=this.c.get(o);y?.unref()&&(this.c.delete(o),b.push(y.value))}if(D.addedDocuments)for(const s of D.addedDocuments){const o=L.URI.revive(s.uri);let y=this.c.get(o);if(y&&o.scheme!==m.Schemas.vscodeNotebookCell&&o.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new i(new S.$YL(this.h.getProxy(l.$TJ.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,y),n.push(y.value)),y.ref()}if(D.removedEditors)for(const s of D.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&a.push(o)}if(D.addedEditors)for(const s of D.addedEditors){const o=L.URI.revive(s.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const y=this.c.get(o).value,$=new P.$5L(s.id,this.h.getProxy(l.$TJ.MainThreadTextEditors),this.i,new t.$T(()=>y.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(I=>k.Range.to(I)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,$)}D.newActiveEditor!==void 0&&(w.ok(D.newActiveEditor===null||this.b.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this.a=D.newActiveEditor),(0,C.$ec)(b),(0,C.$ec)(a),D.removedDocuments&&this.e.fire(b),D.addedDocuments&&this.d.fire(n),(D.removedEditors||D.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),D.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(D){return this.c.get(D)?.value}allDocuments(){return h.Iterable.map(this.c.values(),D=>D.value)}getEditor(D){return this.b.get(D)}activeEditor(D){if(!this.a)return;const b=this.b.get(this.a);return D?b:b?.value}allEditors(){return[...this.b.values()]}};e.$6L=c,e.$6L=c=Ke([Ve(0,f.$VL),Ve(1,u.$4i)],c),e.$7L=(0,A.$Ah)("IExtHostDocumentsAndEditors")}),define(Ae[60],Re([1,0,8,3,2,5,4,7,17,16,100]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=void 0,e.$1bc=(0,A.$Ah)("IExtHostEditorTabs");class k{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$BL(C.URI.revive(this.b.input.uri));case 2:return new l.$CL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$DL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$EL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$FL(this.b.input.viewType);case 4:return new l.$GL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$HL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$IL;case 9:return new l.$JL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new L.$ed,this.c=new L.$ed,this.e=[],this.a=t.getProxy(T.$TJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,f.$tf)(t.e.find(D=>D.groupId===c)?.apiObject)},close:async(c,g)=>{const D=Array.isArray(c)?c:[c];return D.length?m(D[0])?this.j(D,g):this.i(D,g):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(s=>s.groupId)),c=new Set(t.map(s=>s.groupId)),g=(0,P.$J)(i,c),D=this.e.filter(s=>g.removed.includes(s.groupId)).map(s=>s.apiObject),b=[],n=[];this.e=t.map(s=>{const o=new u(s,()=>this.d);return g.added.includes(o.groupId)?b.push(o.apiObject):n.push(o.apiObject),o});const a=(0,f.$tf)(t.find(s=>s.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:b,closed:D,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(g=>g.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const g of t){const D=this.g(g);if(!D)throw new Error("Tab close: Invalid tab not found!");c.push(D.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const g of t){const D=this.h(g);if(!D)throw new Error("Group close: Invalid group not found!");c.push(D.groupId)}return this.a.$closeGroup(c,i)}};e.$2bc=p,e.$2bc=p=Ke([Ve(0,S.$VL)],p);function m(h){return h.tabs!==void 0}}),define(Ae[232],Re([1,0,3,7]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$TJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,S){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const P=await f.provideEmbeddingVector(l,S);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,l,S){const f=this.b;return this.b++,this.a.set(f,S),this.c.$registerAiEmbeddingVectorProvider(l,f),new T.$VJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$Ncc=C}),define(Ae[233],Re([1,0,2,3,6,7,8,279,15,25,26,49]),function(be,e,w,T,C,L,A,l,S,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class u{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const t=this.a.indexOf(h);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),t=[];let i,c,g=14,D=14;for(const b of h){let n=i?(0,S.$Ne)(i,b):0;for(n===0?c=1:c=D;n<b.length;n++)n+1===b.length?(g=D,D=9):D+=1,t.push([c,b.toUpperCase().charCodeAt(n),D]),t.push([c,b.toLowerCase().charCodeAt(n),D]),c=D;i=b,D=g}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$nY(t)}}provideDocumentLinks(h){this.c();const t=[],i=l.$oY.computeLinks({getLineContent(c){return h.lineAt(c-1).text},getLineCount(){return h.lineCount}},this.b);for(const c of i){const g=A.DocumentLink.to(c);g.target&&t.push(g)}return t}}class p{constructor(h,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(T.$TJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,t,i,c={}){if(p.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const g=this.h++;this.b.add(t),this.d.add(t),this.c.set(g,i);let D=2;c.isCaseSensitive&&(D+=1024),c.isReadonly&&(D+=2048),typeof i.copy=="function"&&(D+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$NF)(h,"fsChunks"),D+=4);let b;c.isReadonly&&(0,k.$Yj)(c.isReadonly)&&((0,P.$NF)(h,"readonlyMessage"),b={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(g,t,D,b).catch(a=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${t}`),console.error(a)});const n=i.onDidChangeFile(a=>{const s=[];for(const o of a){const{uri:y,type:$}=o;if(y.scheme!==t)continue;let I;switch($){case L.FileChangeType.Changed:I=0;break;case L.FileChangeType.Created:I=1;break;case L.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:y,type:I})}this.a.$onFileSystemChange(g,s)});return(0,C.$hc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:t,ctime:i,mtime:c,size:g,permissions:D}=h;return{type:t,ctime:i,mtime:c,size:g,permissions:D}}$stat(h,t){return Promise.resolve(this.l(h).stat(w.URI.revive(t))).then(i=>p.k(i))}$readdir(h,t){return Promise.resolve(this.l(h).readDirectory(w.URI.revive(t)))}$readFile(h,t){return Promise.resolve(this.l(h).readFile(w.URI.revive(t))).then(i=>f.$Ed.wrap(i))}$writeFile(h,t,i,c){return Promise.resolve(this.l(h).writeFile(w.URI.revive(t),i.buffer,c))}$delete(h,t,i){return Promise.resolve(this.l(h).delete(w.URI.revive(t),i))}$rename(h,t,i,c){return Promise.resolve(this.l(h).rename(w.URI.revive(t),w.URI.revive(i),c))}$copy(h,t,i,c){const g=this.l(h);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(w.URI.revive(t),w.URI.revive(i),c))}$mkdir(h,t){return Promise.resolve(this.l(h).createDirectory(w.URI.revive(t)))}$watch(h,t,i,c){const g=this.l(h).watch(w.URI.revive(i),c);this.f.set(t,g)}$unwatch(h,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(h,t,i){const c=this.l(h);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(w.URI.revive(t),i))}$close(h,t){const i=this.l(h);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(h,t,i,c){const g=this.l(h);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const D=f.$Ed.alloc(c);return Promise.resolve(g.read(t,i,D.buffer,0,c)).then(b=>D.slice(0,b))}$write(h,t,i,c){const g=this.l(h);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(t,i,c.buffer,0,c.byteLength))}l(h){const t=this.c.get(h);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$xbc=p}),define(Ae[61],Re([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=e.$dbc=void 0;let m=p=class{constructor(t,i){this.b=new Map,this.c=new P.$Og,this.a=t.getProxy(w.$TJ.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(g){try{let D;const b=c.b.get(g.scheme);return b?(await c.a.$ensureActivation(g.scheme),D=await b.impl.stat(g)):D=await c.a.$stat(g),{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions===T.FilePermission.Readonly?1:void 0}}catch(D){p.e(D)}},async readDirectory(g){try{const D=c.b.get(g.scheme);return D?(await c.a.$ensureActivation(g.scheme),(await D.impl.readDirectory(g)).slice()):await c.a.$readdir(g)}catch(D){return p.e(D)}},async createDirectory(g){try{const D=c.b.get(g.scheme);return D&&!D.isReadonly?(await c.a.$ensureActivation(g.scheme),await c.d(D.impl,D.extUri,g)):await c.a.$mkdir(g)}catch(D){return p.e(D)}},async readFile(g){try{const D=c.b.get(g.scheme);return D?(await c.a.$ensureActivation(g.scheme),(await D.impl.readFile(g)).slice()):(await c.a.$readFile(g)).buffer}catch(D){return p.e(D)}},async writeFile(g,D){try{const b=c.b.get(g.scheme);return b&&!b.isReadonly?(await c.a.$ensureActivation(g.scheme),await c.d(b.impl,b.extUri,b.extUri.dirname(g)),await c.c.queueFor(g).queue(()=>Promise.resolve(b.impl.writeFile(g,D,{create:!0,overwrite:!0})))):await c.a.$writeFile(g,L.$Ed.wrap(D))}catch(b){return p.e(b)}},async delete(g,D){try{const b=c.b.get(g.scheme);return b&&!b.isReadonly?(await c.a.$ensureActivation(g.scheme),await b.impl.delete(g,{recursive:!1,...D})):await c.a.$delete(g,{recursive:!1,useTrash:!1,atomic:!1,...D})}catch(b){return p.e(b)}},async rename(g,D,b){try{return await c.a.$rename(g,D,{overwrite:!1,...b})}catch(n){return p.e(n)}},async copy(g,D,b){try{return await c.a.$copy(g,D,{overwrite:!1,...b})}catch(n){return p.e(n)}},isWritableFileSystem(g){const D=i.getCapabilities(g);if(typeof D=="number")return!(D&2048)}})}async d(t,i,c){const g=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&T.FileType.Directory))throw C.$0K.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(D){if(T.$hk(D)!==T.FileSystemProviderErrorCode.FileNotFound)throw D;g.push(i.basename(c)),c=i.dirname(c)}for(let D=g.length-1;D>=0;D--){c=i.joinPath(c,g[D]);try{await t.createDirectory(c)}catch(b){if(T.$hk(b)!==T.FileSystemProviderErrorCode.FileExists)throw b}}}static e(t){if(t instanceof C.$0K)throw t;if(t instanceof T.$dk)switch(t.code){case T.FileSystemProviderErrorCode.FileExists:throw C.$0K.FileExists(t.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$0K.FileNotFound(t.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$0K.FileNotADirectory(t.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$0K.FileIsADirectory(t.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$0K.NoPermissions(t.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$0K.Unavailable(t.message);default:throw new C.$0K(t.message,t.name)}if(!(t instanceof Error))throw new C.$0K(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$0K.Unavailable(t.message);switch(t.name){case T.FileSystemProviderErrorCode.FileExists:throw C.$0K.FileExists(t.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$0K.FileNotFound(t.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$0K.FileNotADirectory(t.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$0K.FileIsADirectory(t.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$0K.NoPermissions(t.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$0K.Unavailable(t.message);default:throw new C.$0K(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?k.$0f:k.$_f,isReadonly:!!c?.isReadonly}),(0,f.$hc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$0f}};e.$dbc=m,e.$dbc=m=p=Ke([Ve(0,l.$VL),Ve(1,S.$Lac)],m),e.$ebc=(0,A.$Ah)("IExtHostConsumerFileSystem")}),define(Ae[234],Re([1,0,5,37,2,3,8,7]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;class S{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(k,u,p,m,h,t,i,c){this.a=new w.$ed,this.b=new w.$ed,this.c=new w.$ed;const g=this.h(k,p,h);this.g=0,t&&(this.g+=1),i&&(this.g+=2),c&&(this.g+=4);const D=(0,T.$qj)(h),b=typeof h=="string",n=m(a=>{if(!t)for(const s of a.created){const o=C.URI.revive(s);D(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.a.fire(o)}if(!i)for(const s of a.changed){const o=C.URI.revive(s);D(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.b.fire(o)}if(!c)for(const s of a.deleted){const o=C.URI.revive(s);D(o.fsPath)&&(!b||u.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=l.$VJ.from(g,this.a,this.b,this.c,n)}h(k,u,p){const m=l.$VJ.from();if(typeof p=="string")return m;const h=k.getProxy(L.$TJ.MainThreadFileSystem);let t=!1;(p.pattern.includes(T.$mj)||p.pattern.includes(T.$nj))&&(t=!0);const i=Math.random();return h.$watch(u.identifier.value,i,p.baseUri,{recursive:t,excludes:[]}),l.$VJ.from({dispose:()=>h.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class f{constructor(k,u,p){this.j=k,this.k=u,this.l=p,this.a=new w.$ed,this.b=new w.$ed,this.c=new w.$ed,this.d=new w.$ed,this.g=new w.$gd,this.h=new w.$gd,this.i=new w.$gd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,u,p,m,h,t){return new S(this.j,k,u,this.a.event,A.GlobPattern.from(p),m,h,t)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,u){switch(k){case 2:this.b.fire(Object.freeze({files:u.map(p=>({oldUri:C.URI.revive(p.source),newUri:C.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:u.map(p=>C.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:u.map(p=>C.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,u){return(p,m,h)=>{const t=function(c){p.call(m,c)};return t.extension=k,u.event(t,void 0,h)}}async $onWillRunFileOperation(k,u,p,m){switch(k){case 2:return await this.n(this.g,{files:u.map(h=>({oldUri:C.URI.revive(h.source),newUri:C.URI.revive(h.target)}))},p,m);case 1:return await this.n(this.i,{files:u.map(h=>C.URI.revive(h.target))},p,m);case 0:case 3:return await this.n(this.h,{files:u.map(h=>C.URI.revive(h.target))},p,m)}}async n(k,u,p,m){const h=new Set,t=[];if(await k.fireAsync(u,m,async(c,g)=>{const D=Date.now(),b=await Promise.resolve(c);b instanceof l.$6J&&(t.push([g.extension,b]),h.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-D>p&&this.k.warn("SLOW file-participant",g.extension.identifier)}),m.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,c]of t){const{edits:g}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:D=>this.l.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(g)}return{edit:i,extensionNames:Array.from(h)}}}e.$ybc=f}),define(Ae[235],Re([1,0,6,2,3,8,7,31]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;class S{static{this.a=0}constructor(u,p){this.extension=u,this.provider=p,this.handle=S.a++}}class f{constructor(u){this.session=u,this.responses=[]}}class P{static{this.a=0}constructor(u,p,m,h){this.f=m,this.g=h,this.b=new Map,this.d=new Map,this.e=u.getProxy(C.$TJ.MainThreadInlineChat),p.registerApiCommand(new l.$jM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$hM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?L.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?L.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?L.Position.from(t.position):void 0}})],l.$iM.Void))}registerProvider(u,p,m){const h=new S(u,p);return this.b.set(h.handle,h),this.e.$registerInteractiveEditorProvider(h.handle,m.label,u.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,w.$hc)(()=>{this.e.$unregisterInteractiveEditorProvider(h.handle),this.b.delete(h.handle)})}async $prepareSession(u,p,m,h){const t=this.b.get(u);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(p)),c=L.Selection.to(m),g=await t.provider.prepareInteractiveEditorSession({document:i,selection:c},h);if(!g)return;if(g.wholeRange&&!g.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const D=P.a++;return this.d.set(D,new f(g)),{id:D,placeholder:g.placeholder,slashCommands:g.slashCommands?.map(b=>({command:b.command,detail:b.detail,refer:b.refer,executeImmediately:b.executeImmediately})),wholeRange:L.Range.from(g.wholeRange),message:g.message}}async $provideResponse(u,p,m,h){const t=this.b.get(u);if(!t)return;const i=this.d.get(p.id);if(!i)return;const c={session:i.session,prompt:m.prompt,selection:L.Selection.to(m.selection),wholeRange:L.Range.to(m.wholeRange),attempt:m.attempt,live:m.live};let g=!1;const D={report:a=>{if(!m.live)throw new Error("Progress reporting is only supported for live sessions");g||h.isCancellationRequested||!a.message&&!a.edits||this.e.$handleProgressChunk(m.requestId,{message:a.message,edits:a.edits?.map(L.TextEdit.from)})}},b=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(c,D,h):t.provider.provideInteractiveEditorResponse(c.session,c,D,h);Promise.resolve(b).finally(()=>g=!0);const n=await b;if(n){const a=i.responses.push(n)-1,s={wholeRange:L.Range.from(n.wholeRange),placeholder:n.placeholder};if(P.h(n))return{...s,id:a,type:"message",message:L.MarkdownString.from(n.contents)};const{edits:o}=n;if(o instanceof A.$6J)return{...s,id:a,type:"bulkEdit",edits:L.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...s,id:a,type:"editorEdit",edits:o.map(L.TextEdit.from)}}}$handleFeedback(u,p,m,h){const t=this.b.get(u),i=this.d.get(p),c=i?.responses[m];if(t&&c){const g=L.InteractiveEditorResponseFeedbackKind.to(h);t.provider.handleInteractiveEditorResponseFeedback?.(i.session,c,g)}}$releaseSession(u,p){const m=this.d.get(p),h=this.b.get(u);m&&h&&h.provider.releaseInteractiveEditorSession?.(m.session),this.d.delete(p)}static h(u){return typeof u=="object"&&typeof u.contents=="object"}}e.$Fcc=P}),define(Ae[236],Re([1,0,2,31]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class C{constructor(A,l,S,f,P){this.a=l,this.b=S,this.c=f;const k=new T.$jM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$hM("showOptions","Show Options",u=>!0,u=>u),new T.$hM("resource","Interactive resource Uri",u=>!0,u=>u),new T.$hM("controllerId","Notebook controller Id",u=>!0,u=>u),new T.$hM("title","Interactive editor title",u=>!0,u=>u)],new T.$iM("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const p=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri),notebookEditor:p.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,l,S,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:S,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Bcc=C}),define(Ae[237],Re([1,0,3,7]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(w.$TJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const S=this.a.get(A);if(!S)throw new Error("Issue request handler not found");const f=await S.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}registerIssueUriRequestHandler(A,l){const S=A.identifier.value;return this.a.set(S,l),this.b.$registerIssueUriRequestHandler(S),new T.$VJ(()=>{this.b.$unregisterIssueUriRequestHandler(S),this.a.delete(S)})}}e.$Hcc=C}),define(Ae[238],Re([1,0,6,3]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(T.$TJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,w.$hc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$Ubc=C}),define(Ae[239],Re([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,54,58,9,13,26,150]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;class s{constructor(F,K){this.d=F,this.e=K}async provideDocumentSymbols(F,K){const G=this.d.getDocument(F),Q=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Hb)(Q))return Q[0]instanceof L.$bK?Q.map(C.DocumentSymbol.from):s.f(Q)}static f(F){F=F.slice(0).sort((Q,J)=>{let x=Q.location.range.start.compareTo(J.location.range.start);return x===0&&(x=J.location.range.end.compareTo(Q.location.range.end)),x});const K=[],G=[];for(const Q of F){const J={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(J),K.push(J);break}const x=G[G.length-1];if(f.$is.containsRange(x.range,J.range)&&!f.$is.equalsRange(x.range,J.range)){x.children?.push(J),G.push(J);break}G.pop()}}return K}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,K,G){this.g=F,this.h=K,this.j=G,this.e=new c.$Iac("CodeLens"),this.f=new Map}async provideCodeLenses(F,K){const G=this.g.getDocument(F),Q=await this.j.provideCodeLenses(G,K);if(!Q||K.isCancellationRequested)return;const J=this.e.add(Q),x=new h.$ic;this.f.set(J,x);const ae={cacheId:J,lenses:[]};for(let Le=0;Le<Q.length;Le++)ae.lenses.push({cacheId:[J,Le],range:C.Range.from(Q[Le].range),command:this.h.toInternal(Q[Le].command,x)});return ae}async resolveCodeLens(F,K){const G=F.cacheId&&this.e.get(...F.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,K),Q||(Q=G),K.isCancellationRequested)return;const J=F.cacheId&&this.f.get(F.cacheId[0]);if(J)return F.command=this.h.toInternal(Q.command??o.d,J),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function y(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class ${constructor(F,K){this.d=F,this.e=K}async provideDefinition(F,K,G){const Q=this.d.getDocument(F),J=C.Position.to(K),x=await this.e.provideDefinition(Q,J,G);return y(x)}}class I{constructor(F,K){this.d=F,this.e=K}async provideDeclaration(F,K,G){const Q=this.d.getDocument(F),J=C.Position.to(K),x=await this.e.provideDeclaration(Q,J,G);return y(x)}}class E{constructor(F,K){this.d=F,this.e=K}async provideImplementation(F,K,G){const Q=this.d.getDocument(F),J=C.Position.to(K),x=await this.e.provideImplementation(Q,J,G);return y(x)}}class r{constructor(F,K){this.d=F,this.e=K}async provideTypeDefinition(F,K,G){const Q=this.d.getDocument(F),J=C.Position.to(K),x=await this.e.provideTypeDefinition(Q,J,G);return y(x)}}class d{constructor(F,K){this.d=F,this.e=K}async provideHover(F,K,G){const Q=this.d.getDocument(F),J=C.Position.to(K),x=await this.e.provideHover(Q,J,G);if(!(!x||(0,P.$Hb)(x.contents)))return x.range||(x.range=Q.getWordRangeAtPosition(J)),x.range||(x.range=new L.$XJ(J,J)),C.Hover.from(x)}}class v{constructor(F,K){this.d=F,this.e=K}async provideEvaluatableExpression(F,K,G){const Q=this.d.getDocument(F),J=C.Position.to(K),x=await this.e.provideEvaluatableExpression(Q,J,G);if(x)return C.EvaluatableExpression.from(x)}}class R{constructor(F,K){this.d=F,this.e=K}async provideInlineValues(F,K,G,Q){const J=this.d.getDocument(F),x=await this.e.provideInlineValues(J,C.Range.to(K),C.InlineValueContext.to(G),Q);if(Array.isArray(x))return x.map(ae=>C.InlineValue.from(ae))}}class B{constructor(F,K){this.d=F,this.e=K}async provideDocumentHighlights(F,K,G){const Q=this.d.getDocument(F),J=C.Position.to(K),x=await this.e.provideDocumentHighlights(Q,J,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class V{constructor(F,K){this.d=F,this.e=K}async provideLinkedEditingRanges(F,K,G){const Q=this.d.getDocument(F),J=C.Position.to(K),x=await this.e.provideLinkedEditingRanges(Q,J,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Eb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class j{constructor(F,K){this.d=F,this.e=K}async provideReferences(F,K,G,Q){const J=this.d.getDocument(F),x=C.Position.to(K),ae=await this.e.provideReferences(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.location.from)}}class W{static{this.d=1e3}constructor(F,K,G,Q,J,x,ae){this.h=F,this.j=K,this.k=G,this.l=Q,this.m=J,this.n=x,this.o=ae,this.e=new c.$Iac("CodeAction"),this.f=new Map,this.g=new L.$dK("notebook")}async provideCodeActions(F,K,G,Q){const J=this.h.getDocument(F),x=u.$ks.isISelection(K)?C.Selection.to(K):C.Range.to(K),ae=[];for(const Ze of this.k.getDiagnostics(F))if(x.intersection(Ze.range)&&ae.push(Ze)>W.d)break;const Le={diagnostics:ae,only:G.only?new L.$dK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.l.provideCodeActions(J,x,Le,Q);if(!(0,P.$Ib)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),He=new h.$ic;this.f.set(Qe,He);const et=[];for(let Ze=0;Ze<Ue.length;Ze++){const _e=Ue[Ze];if(_e)if(W.p(_e))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this.j.toInternal(_e,He)});else{if(Le.triggerKind!==L.CodeActionTriggerKind.Invoke&&_e.kind&&this.g.contains(_e.kind))continue;Le.only&&(_e.kind?Le.only.contains(_e.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Qe,Ze],title:_e.title,command:_e.command&&this.j.toInternal(_e.command,He),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})}}return{cacheId:Qe,actions:et}}async resolveCodeAction(F,K){const[G,Q]=F,J=this.e.get(G,Q);if(!J||W.p(J))return{};if(!this.l.resolveCodeAction)return{};const x=await this.l.resolveCodeAction(J,K)??J;let ae;x.edit&&(ae=C.WorkspaceEdit.from(x.edit,void 0));let Le;if(x.command){const Ue=this.f.get(G);Ue&&(Le=this.j.toInternal(x.command,Ue))}return{edit:ae,command:Le}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static p(F){return typeof F.command=="string"&&typeof F.title=="string"}}class N{static toInternalProviderId(F,K){return F+"."+K}constructor(F,K,G,Q,J){this.d=F,this.e=K,this.f=G,this.g=Q,this.h=J}async prepareDocumentPaste(F,K,G,Q){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(F),x=K.map(Ue=>C.Range.to(Ue)),ae=C.DataTransfer.toDataTransfer(G,()=>{throw new D.$9});if(await this.f.prepareDocumentPaste(J,x,ae,Q),Q.isCancellationRequested)return;const Le=Array.from(ae).filter(([,Ue])=>!(Ue instanceof L.$KK));return C.DataTransfer.from(Le)}async providePasteEdits(F,K,G,Q,J){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ae=G.map(Qe=>C.Range.to(Qe)),Le=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ae,Le,J);if(Ue)return{label:Ue.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:N.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class z{constructor(F,K){this.d=F,this.e=K}async provideDocumentFormattingEdits(F,K,G){const Q=this.d.getDocument(F),J=await this.e.provideDocumentFormattingEdits(Q,K,G);if(Array.isArray(J))return J.map(C.TextEdit.from)}}class ee{constructor(F,K){this.d=F,this.e=K}async provideDocumentRangeFormattingEdits(F,K,G,Q){const J=this.d.getDocument(F),x=C.Range.to(K),ae=await this.e.provideDocumentRangeFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,K,G,Q){(0,k.$sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(F),x=K.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class X{constructor(F,K){this.d=F,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,K,G,Q,J){const x=this.d.getDocument(F),ae=C.Position.to(K),Le=await this.e.provideOnTypeFormattingEdits(x,ae,G,Q,J);if(Array.isArray(Le))return Le.map(C.TextEdit.from)}}class Ee{constructor(F,K){this.e=F,this.f=K,this.d=new c.$Iac("WorkspaceSymbols")}async provideWorkspaceSymbols(F,K){const G=await this.e.provideWorkspaceSymbols(F,K);if(!(0,P.$Ib)(G))return{symbols:[]};const Q=this.d.add(G),J={cacheId:Q,symbols:[]};for(let x=0;x<G.length;x++){const ae=G[x];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}J.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Q,x]})}return J}async resolveWorkspaceSymbol(F,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this.d.get(...F.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,K);return Q&&(0,T.$Xm)(F,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class De{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,K,G){this.d=F,this.e=K,this.f=G}async provideRenameEdits(F,K,G,Q){const J=this.d.getDocument(F),x=C.Position.to(K);try{const ae=await this.e.provideRenameEdits(J,x,G,Q);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Le=De.g(ae);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(F,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(F),J=C.Position.to(K);try{const x=await this.e.prepareRename(Q,J,G);let ae,Le;if(L.$XJ.isRange(x)?(ae=x,Le=Q.getText(x)):(0,k.$kf)(x)&&(ae=x.range,Le=x.placeholder),!ae||!Le)return;if(ae.start.line>J.line||ae.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Le}}catch(x){const ae=De.g(x);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Pe{constructor(F,K){this.resultId=F,this.tokens=K}}class Z{constructor(F,K){this.f=F,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,K,G){const Q=this.f.getDocument(F),J=K!==0?this.d.get(K):null;let x=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,J.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return J&&this.d.delete(K),x?(x=Z.h(x),this.o(Z.n(J,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return Z.j(F)?Z.k(F)?F:new L.$bL(new Uint32Array(F.data),F.resultId):Z.l(F)?Z.m(F)?F:new L.$dL(F.edits.map(K=>new L.$cL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const K of F.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(F,K){if(!Z.j(K)||!F||!F.tokens)return K;const G=F.tokens,Q=G.length,J=K.data,x=J.length;let ae=0;const Le=Math.min(Q,x);for(;ae<Le&&G[ae]===J[ae];)ae++;if(ae===Q&&ae===x)return new L.$dL([],K.resultId);let Ue=0;const Qe=Le-ae;for(;Ue<Qe&&G[Q-Ue-1]===J[x-Ue-1];)Ue++;return new L.$dL([{start:ae,deleteCount:Q-ae-Ue,data:J.subarray(ae,x-Ue)}],K.resultId)}o(F,K){if(Z.j(F)){const G=this.e++;return this.d.set(G,new Pe(F.resultId,F.data)),(0,t.$j0)({id:G,type:"full",data:F.data})}if(Z.l(F)){const G=this.e++;return Z.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(F.resultId)),(0,t.$j0)({id:G,type:"delta",deltas:(F.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class ue{constructor(F,K){this.d=F,this.e=K}async provideDocumentRangeSemanticTokens(F,K,G){const Q=this.d.getDocument(F),J=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(K),G);return J?this.f(J):null}f(F){return(0,t.$j0)({id:0,type:"full",data:F.data})}}class ye{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,K,G,Q,J){this.f=F,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new c.$Iac("CompletionItem"),this.e=new Map}async provideCompletionItems(F,K,G,Q){const J=this.f.getDocument(F),x=C.Position.to(K),ae=J.getWordRangeAtPosition(x)||new L.$XJ(x,x),Le=ae.with({end:x}),Ue=new g.$ad,Qe=await this.h.provideCompletionItems(J,x,Q,C.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const He=Array.isArray(Qe)?new L.$rK(Qe):Qe,et=ye.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Ze=new h.$ic;this.e.set(et,Ze);const _e=[],it={x:et,b:_e,a:{replace:C.Range.from(ae),insert:C.Range.from(Le)},c:He.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<He.items.length;tt++){const Oe=He.items[tt],st=this.l(Oe,[et,tt],Le,ae);_e.push(st)}return it}async resolveCompletionItem(F,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...F);if(!G)return;const Q=this.l(G,F),J=await this.h.resolveCompletionItem(G,K);if(!J)return;const x=this.l(J,F);return(Q.h!==x.h||Q.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==x.n||Q.o!==x.o||!(0,T.$Ym)(Q.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,K,G,Q){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,J),ae={x:K,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=F.textEdit.newText):typeof F.insertText=="string"?ae.h=F.insertText:F.insertText instanceof L.$7J&&(ae.h=F.insertText.value,ae.i|=4);let Le;return F.textEdit?Le=F.textEdit.range:F.range&&(Le=F.range),L.$XJ.isRange(Le)?ae.j=C.Range.from(Le):Le&&(!G?.isEqual(Le.inserting)||!Q?.isEqual(Le.replacing))&&(ae.j={insert:C.Range.from(Le.inserting),replace:C.Range.from(Le.replacing)}),ae}}class ce{async provideInlineCompletions(F,K,G,Q){}disposeCompletions(F){}handleDidShowCompletionItem(F,K,G){}handlePartialAccept(F,K,G){}}class $e extends ce{constructor(F,K,G,Q){super(),this.f=F,this.g=K,this.h=G,this.j=Q,this.d=new ie,this.e=(0,n.$MF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$MF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,K,G,Q){const J=this.g.getDocument(F),x=C.Position.to(K),ae=await this.h.provideInlineCompletionItems(J,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ae||Q.isCancellationRequested)return;const Le=Array.isArray(ae)?ae:ae.items,Ue=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Qe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Le}),items:Le.map((Ze,_e)=>{let it;Ze.command&&(He||(He=new h.$ic),it=this.j.toInternal(Ze.command,He));const tt=Ze.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Ze.completeBracketPairs:!1}}),commands:Ue.map(Ze=>(He||(He=new h.$ic),this.j.toInternal(Ze,He))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,K,G){const Q=this.d.get(F)?.items[K];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(F,K,G){const Q=this.d.get(F)?.items[K];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const K=this.e++;return this.d.set(K,F),K}disposeReferenceId(F){const K=this.d.get(F);return this.d.delete(F),K}get(F){return this.d.get(F)}}class O{constructor(F,K){this.e=F,this.f=K,this.d=new c.$Iac("SignatureHelp")}async provideSignatureHelp(F,K,G,Q){const J=this.e.getDocument(F),x=C.Position.to(K),ae=this.g(G),Le=await this.f.provideSignatureHelp(J,x,Q,ae);if(Le){const Ue=this.d.add([Le]);return{...C.SignatureHelp.from(Le),id:Ue}}}g(F){let K;if(F.activeSignatureHelp){const G=C.SignatureHelp.to(F.activeSignatureHelp),Q=this.d.get(F.activeSignatureHelp.id,0);Q?(K=Q,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...F,activeSignatureHelp:K}}releaseSignatureHelp(F){this.d.delete(F)}}class q{constructor(F,K,G,Q,J){this.f=F,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new c.$Iac("InlayHints"),this.e=new Map}async provideInlayHints(F,K,G){const Q=this.f.getDocument(F),J=C.Range.to(K),x=await this.h.provideInlayHints(Q,J,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ae=this.d.add(x);this.e.set(ae,new h.$ic);const Le={hints:[],cacheId:ae};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],J)&&Le.hints.push(this.m(x[Ue],[ae,Ue]));return this.j.trace(`[InlayHints] ${Le.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Le}async resolveInlayHint(F,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...F);if(!G)return;const Q=await this.h.resolveInlayHint(G,K);if(Q&&this.l(Q))return this.m(Q,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,K){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(K&&!K.contains(F.position))}m(F,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?Q.label=F.label:Q.label=F.label.map(J=>{const x={label:J.value};return x.tooltip=C.MarkdownString.fromStrict(J.tooltip),L.$8J.isLocation(J.location)&&(x.location=C.location.from(J.location)),J.command&&(x.command=this.g.toInternal(J.command,G)),x}),Q}}class le{constructor(F,K){this.e=F,this.f=K,this.d=new c.$Iac("DocumentLink")}async provideLinks(F,K){const G=this.e.getDocument(F),Q=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(Q)||Q.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(le.g).map(C.DocumentLink.from)};{const J=this.d.add(Q),x={links:[],cacheId:J};for(let ae=0;ae<Q.length;ae++){if(!le.g(Q[ae]))continue;const Le=C.DocumentLink.from(Q[ae]);Le.cacheId=[J,ae],x.links.push(Le)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...F);if(!G)return;const Q=await this.f.resolveDocumentLink(G,K);if(!(!Q||!le.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(F){this.d.delete(F)}}class we{constructor(F,K){this.d=F,this.e=K}async provideColors(F,K){const G=this.d.getDocument(F),Q=await this.e.provideDocumentColors(G,K);return Array.isArray(Q)?Q.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(F,K,G){const Q=this.d.getDocument(F),J=C.Range.to(K.range),x=C.Color.to(K.color),ae=await this.e.provideColorPresentations(x,{document:Q,range:J},G);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class ve{constructor(F,K){this.d=F,this.e=K}async provideFoldingRanges(F,K,G){const Q=this.d.getDocument(F),J=await this.e.provideFoldingRanges(Q,K,G);if(Array.isArray(J))return J.map(C.FoldingRange.from)}}class me{constructor(F,K,G){this.d=F,this.e=K,this.f=G}async provideSelectionRanges(F,K,G){const Q=this.d.getDocument(F),J=K.map(C.Position.to),x=await this.e.provideSelectionRanges(Q,J,G);if(!(0,P.$Ib)(x))return[];if(x.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Le=0;Le<J.length;Le++){const Ue=[];ae.push(Ue);let Qe=J[Le],He=x[Le];for(;;){if(!He.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(He)),!He.parent)break;Qe=He.range,He=He.parent}}return ae}}class ke{constructor(F,K){this.f=F,this.g=K,this.d=new i.$1L(""),this.e=new Map}async prepareSession(F,K,G){const Q=this.f.getDocument(F),J=C.Position.to(K),x=await this.g.prepareCallHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Le=>this.h(ae,Le)):[this.h(ae,x)]}async provideCallsTo(F,K,G){const Q=this.j(F,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(J)return J.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(F,K,G){const Q=this.j(F,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(J)return J.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(F){this.e.delete(F)}h(F,K){const G=this.e.get(F),Q=C.CallHierarchyItem.from(K,F,G.size.toString(36));return G.set(Q._itemId,K),Q}j(F,K){return this.e.get(F)?.get(K)}}class se{constructor(F,K){this.f=F,this.g=K,this.d=new i.$1L(""),this.e=new Map}async prepareSession(F,K,G){const Q=this.f.getDocument(F),J=C.Position.to(K),x=await this.g.prepareTypeHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Le=>this.h(ae,Le)):[this.h(ae,x)]}async provideSupertypes(F,K,G){const Q=this.j(F,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(Q,G);if(J)return J.map(x=>this.h(F,x))}async provideSubtypes(F,K,G){const Q=this.j(F,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(Q,G);if(J)return J.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,K){const G=this.e.get(F),Q=C.TypeHierarchyItem.from(K,F,G.size.toString(36));return G.set(Q._itemId,K),Q}j(F,K){return this.e.get(F)?.get(K)}}class he{static toInternalProviderId(F,K){return F+"."+K}constructor(F,K,G,Q,J){this.d=F,this.e=K,this.f=G,this.g=Q,this.h=J}async provideDocumentOnDropEdits(F,K,G,Q,J){const x=this.e.getDocument(K),ae=C.Position.to(G),Le=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ae,Le,J);if(Ue)return{label:Ue.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class re{constructor(F,K){this.d=F,this.e=K}async provideMappedEdits(F,K,G,Q){const J=w.URI.revive(F),x=this.d.getDocument(J),ae={selections:G.selections.map(Ue=>C.Selection.to(Ue)),related:G.related.map(Ue=>({uri:w.URI.revive(Ue.uri),range:C.Range.to(Ue.range)}))},Le=await this.e.provideMappedEdits(x,K,ae,Q);return Le?C.WorkspaceEdit.from(Le):null}}class oe{constructor(F,K){this.adapter=F,this.extension=K}}class fe{static{this.d=0}constructor(F,K,G,Q,J,x,ae,Le){this.g=K,this.h=G,this.j=Q,this.k=J,this.l=x,this.m=ae,this.n=Le,this.f=new Map,this.e=F.getProxy(l.$TJ.MainThreadLanguageFeatures)}o(F,K){return C.DocumentSelector.from(F,this.g,K)}p(F){return new L.$VJ(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return fe.d++}async t(F,K,G,Q,J,x=!1){const ae=this.f.get(F);if(!ae||!(ae.adapter instanceof K))return Q;const Le=Date.now();x||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ae.adapter,ae.extension);return Promise.resolve(Ue).catch(Qe=>{(0,D.$2)(Qe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ae.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Le}ms`)}),p.CancellationToken.isCancellationToken(J)?(0,b.$vg)(Ue,J):Ue}u(F,K){const G=this.q();return this.f.set(G,new oe(F,K)),G}static w(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,K,G,Q){const J=this.u(new s(this.h,G),F),x=Q&&Q.label||fe.w(F);return this.e.$registerDocumentSymbolProvider(J,this.o(K,F),x),this.p(J)}$provideDocumentSymbols(F,K,G){return this.t(F,s,Q=>Q.provideDocumentSymbols(w.URI.revive(K),G),void 0,G)}registerCodeLensProvider(F,K,G){const Q=this.q(),J=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new o(this.h,this.j.converter,G),F)),this.e.$registerCodeLensSupport(Q,this.o(K,F),J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeCodeLenses(Le=>this.e.$emitCodeLensEvent(J));x=L.$VJ.from(x,ae)}return x}$provideCodeLenses(F,K,G){return this.t(F,o,Q=>Q.provideCodeLenses(w.URI.revive(K),G),void 0,G)}$resolveCodeLens(F,K,G){return this.t(F,o,Q=>Q.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(F,K){this.t(F,o,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(F,K,G){const Q=this.u(new $(this.h,G),F);return this.e.$registerDefinitionSupport(Q,this.o(K,F)),this.p(Q)}$provideDefinition(F,K,G,Q){return this.t(F,$,J=>J.provideDefinition(w.URI.revive(K),G,Q),[],Q)}registerDeclarationProvider(F,K,G){const Q=this.u(new I(this.h,G),F);return this.e.$registerDeclarationSupport(Q,this.o(K,F)),this.p(Q)}$provideDeclaration(F,K,G,Q){return this.t(F,I,J=>J.provideDeclaration(w.URI.revive(K),G,Q),[],Q)}registerImplementationProvider(F,K,G){const Q=this.u(new E(this.h,G),F);return this.e.$registerImplementationSupport(Q,this.o(K,F)),this.p(Q)}$provideImplementation(F,K,G,Q){return this.t(F,E,J=>J.provideImplementation(w.URI.revive(K),G,Q),[],Q)}registerTypeDefinitionProvider(F,K,G){const Q=this.u(new r(this.h,G),F);return this.e.$registerTypeDefinitionSupport(Q,this.o(K,F)),this.p(Q)}$provideTypeDefinition(F,K,G,Q){return this.t(F,r,J=>J.provideTypeDefinition(w.URI.revive(K),G,Q),[],Q)}registerHoverProvider(F,K,G,Q){const J=this.u(new d(this.h,G),F);return this.e.$registerHoverProvider(J,this.o(K,F)),this.p(J)}$provideHover(F,K,G,Q){return this.t(F,d,J=>J.provideHover(w.URI.revive(K),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(F,K,G,Q){const J=this.u(new v(this.h,G),F);return this.e.$registerEvaluatableExpressionProvider(J,this.o(K,F)),this.p(J)}$provideEvaluatableExpression(F,K,G,Q){return this.t(F,v,J=>J.provideEvaluatableExpression(w.URI.revive(K),G,Q),void 0,Q)}registerInlineValuesProvider(F,K,G,Q){const J=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.u(new R(this.h,G),F);this.e.$registerInlineValuesProvider(x,this.o(K,F),J);let ae=this.p(x);if(J!==void 0){const Le=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(J));ae=L.$VJ.from(ae,Le)}return ae}$provideInlineValues(F,K,G,Q,J){return this.t(F,R,x=>x.provideInlineValues(w.URI.revive(K),G,Q,J),void 0,J)}registerDocumentHighlightProvider(F,K,G){const Q=this.u(new B(this.h,G),F);return this.e.$registerDocumentHighlightProvider(Q,this.o(K,F)),this.p(Q)}$provideDocumentHighlights(F,K,G,Q){return this.t(F,B,J=>J.provideDocumentHighlights(w.URI.revive(K),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(F,K,G){const Q=this.u(new V(this.h,G),F);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(K,F)),this.p(Q)}$provideLinkedEditingRanges(F,K,G,Q){return this.t(F,V,async J=>{const x=await J.provideLinkedEditingRanges(w.URI.revive(K),G,Q);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.y(x.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(F,K,G){const Q=this.u(new j(this.h,G),F);return this.e.$registerReferenceSupport(Q,this.o(K,F)),this.p(Q)}$provideReferences(F,K,G,Q,J){return this.t(F,j,x=>x.provideReferences(w.URI.revive(K),G,Q,J),void 0,J)}registerCodeActionProvider(F,K,G,Q){const J=new h.$ic,x=this.u(new W(this.h,this.j.converter,this.k,G,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(K,F),{providedKinds:Q?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Q?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,J)}))},fe.w(F),!!G.resolveCodeAction),J.add(this.p(x)),J}$provideCodeActions(F,K,G,Q,J){return this.t(F,W,x=>x.provideCodeActions(w.URI.revive(K),G,Q,J),void 0,J)}$resolveCodeAction(F,K,G){return this.t(F,W,Q=>Q.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(F,K){this.t(F,W,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(F,K,G){const Q=this.u(new z(this.h,G),F);return this.e.$registerDocumentFormattingSupport(Q,this.o(K,F),F.identifier,F.displayName||F.name),this.p(Q)}$provideDocumentFormattingEdits(F,K,G,Q){return this.t(F,z,J=>J.provideDocumentFormattingEdits(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(F,K,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",J=this.u(new ee(this.h,G),F);return this.e.$registerRangeFormattingSupport(J,this.o(K,F),F.identifier,F.displayName||F.name,Q),this.p(J)}$provideDocumentRangeFormattingEdits(F,K,G,Q,J){return this.t(F,ee,x=>x.provideDocumentRangeFormattingEdits(w.URI.revive(K),G,Q,J),void 0,J)}$provideDocumentRangesFormattingEdits(F,K,G,Q,J){return this.t(F,ee,x=>x.provideDocumentRangesFormattingEdits(w.URI.revive(K),G,Q,J),void 0,J)}registerOnTypeFormattingEditProvider(F,K,G,Q){const J=this.u(new X(this.h,G),F);return this.e.$registerOnTypeFormattingSupport(J,this.o(K,F),Q,F.identifier),this.p(J)}$provideOnTypeFormattingEdits(F,K,G,Q,J,x){return this.t(F,X,ae=>ae.provideOnTypeFormattingEdits(w.URI.revive(K),G,Q,J,x),void 0,x)}registerWorkspaceSymbolProvider(F,K){const G=this.u(new Ee(K,this.l),F);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(F,K,G){return this.t(F,Ee,Q=>Q.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,K,G){return this.t(F,Ee,Q=>Q.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(F,K){this.t(F,Ee,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(F,K,G){const Q=this.u(new De(this.h,G,this.l),F);return this.e.$registerRenameSupport(Q,this.o(K,F),De.supportsResolving(G)),this.p(Q)}$provideRenameEdits(F,K,G,Q,J){return this.t(F,De,x=>x.provideRenameEdits(w.URI.revive(K),G,Q,J),void 0,J)}$resolveRenameLocation(F,K,G,Q){return this.t(F,De,J=>J.resolveRenameLocation(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(F,K,G,Q){const J=this.u(new Z(this.h,G),F),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(K,F),Q,x);let ae=this.p(J);if(x){const Le=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ae=L.$VJ.from(ae,Le)}return ae}$provideDocumentSemanticTokens(F,K,G,Q){return this.t(F,Z,J=>J.provideDocumentSemanticTokens(w.URI.revive(K),G,Q),null,Q)}$releaseDocumentSemanticTokens(F,K){this.t(F,Z,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,K,G,Q){const J=this.u(new ue(this.h,G),F);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(K,F),Q),this.p(J)}$provideDocumentRangeSemanticTokens(F,K,G,Q){return this.t(F,ue,J=>J.provideDocumentRangeSemanticTokens(w.URI.revive(K),G,Q),null,Q)}registerCompletionItemProvider(F,K,G,Q){const J=this.u(new ye(this.h,this.j.converter,G,this.m,F),F);return this.e.$registerCompletionsProvider(J,this.o(K,F),Q,ye.supportsResolving(G),F.identifier),this.p(J)}$provideCompletionItems(F,K,G,Q,J){return this.t(F,ye,x=>x.provideCompletionItems(w.URI.revive(K),G,Q,J),void 0,J)}$resolveCompletionItem(F,K,G){return this.t(F,ye,Q=>Q.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(F,K){this.t(F,ye,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(F,K,G,Q){const J=new $e(F,this.h,G,this.j.converter),x=this.u(J,F);return this.e.$registerInlineCompletionsSupport(x,this.o(K,F),J.supportsHandleEvents,m.$Ul.toKey(F.identifier.value),Q?.yieldTo?.map(ae=>m.$Ul.toKey(ae))||[]),this.p(x)}$provideInlineCompletions(F,K,G,Q,J){return this.t(F,ce,x=>x.provideInlineCompletions(w.URI.revive(K),G,Q,J),void 0,J)}$handleInlineCompletionDidShow(F,K,G,Q){this.t(F,ce,async J=>{J.handleDidShowCompletionItem(K,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,K,G,Q){this.t(F,ce,async J=>{J.handlePartialAccept(K,G,Q)},void 0,void 0)}$freeInlineCompletionsList(F,K){this.t(F,ce,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(F,K,G,Q){const J=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,x=this.u(new O(this.h,G),F);return this.e.$registerSignatureHelpProvider(x,this.o(K,F),J),this.p(x)}$provideSignatureHelp(F,K,G,Q,J){return this.t(F,O,x=>x.provideSignatureHelp(w.URI.revive(K),G,Q,J),void 0,J)}$releaseSignatureHelp(F,K){this.t(F,O,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(F,K,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,J=this.u(new q(this.h,this.j.converter,G,this.l,F),F);this.e.$registerInlayHintsProvider(J,this.o(K,F),typeof G.resolveInlayHint=="function",Q,fe.w(F));let x=this.p(J);if(Q!==void 0){const ae=G.onDidChangeInlayHints(Le=>this.e.$emitInlayHintsEvent(Q));x=L.$VJ.from(x,ae)}return x}$provideInlayHints(F,K,G,Q){return this.t(F,q,J=>J.provideInlayHints(w.URI.revive(K),G,Q),void 0,Q)}$resolveInlayHint(F,K,G){return this.t(F,q,Q=>Q.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(F,K){this.t(F,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(F,K,G){const Q=this.u(new le(this.h,G),F);return this.e.$registerDocumentLinkProvider(Q,this.o(K,F),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(F,K,G){return this.t(F,le,Q=>Q.provideLinks(w.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(F,K,G){return this.t(F,le,Q=>Q.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(F,K){this.t(F,le,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(F,K,G){const Q=this.u(new we(this.h,G),F);return this.e.$registerDocumentColorProvider(Q,this.o(K,F)),this.p(Q)}$provideDocumentColors(F,K,G){return this.t(F,we,Q=>Q.provideColors(w.URI.revive(K),G),[],G)}$provideColorPresentations(F,K,G,Q){return this.t(F,we,J=>J.provideColorPresentations(w.URI.revive(K),G,Q),void 0,Q)}registerFoldingRangeProvider(F,K,G){const Q=this.q(),J=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new ve(this.h,G),F)),this.e.$registerFoldingRangeProvider(Q,this.o(K,F),F.identifier,J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));x=L.$VJ.from(x,ae)}return x}$provideFoldingRanges(F,K,G,Q){return this.t(F,ve,J=>J.provideFoldingRanges(w.URI.revive(K),G,Q),void 0,Q)}registerSelectionRangeProvider(F,K,G){const Q=this.u(new me(this.h,G,this.l),F);return this.e.$registerSelectionRangeProvider(Q,this.o(K,F)),this.p(Q)}$provideSelectionRanges(F,K,G,Q){return this.t(F,me,J=>J.provideSelectionRanges(w.URI.revive(K),G,Q),[],Q)}registerCallHierarchyProvider(F,K,G){const Q=this.u(new ke(this.h,G),F);return this.e.$registerCallHierarchyProvider(Q,this.o(K,F)),this.p(Q)}$prepareCallHierarchy(F,K,G,Q){return this.t(F,ke,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(F,K,G,Q){return this.t(F,ke,J=>J.provideCallsTo(K,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(F,K,G,Q){return this.t(F,ke,J=>J.provideCallsFrom(K,G,Q),void 0,Q)}$releaseCallHierarchy(F,K){this.t(F,ke,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(F,K,G){const Q=this.u(new se(this.h,G),F);return this.e.$registerTypeHierarchyProvider(Q,this.o(K,F)),this.p(Q)}$prepareTypeHierarchy(F,K,G,Q){return this.t(F,se,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(F,K,G,Q){return this.t(F,se,J=>J.provideSupertypes(K,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(F,K,G,Q){return this.t(F,se,J=>J.provideSubtypes(K,G,Q),void 0,Q)}$releaseTypeHierarchy(F,K){this.t(F,se,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(F,K,G,Q){const J=this.q();this.f.set(J,new oe(new he(this.e,this.h,G,J,F),F));const x=(0,n.$MF)(F,"dropMetadata")&&Q?he.toInternalProviderId(F.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(K,F),x,(0,n.$MF)(F,"dropMetadata")?Q:void 0),this.p(J)}$provideDocumentOnDropEdits(F,K,G,Q,J,x){return this.t(F,he,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(K,w.URI.revive(G),Q,J,x)),void 0,void 0)}registerMappedEditsProvider(F,K,G){const Q=this.u(new re(this.h,G),F);return this.e.$registerMappedEditsProvider(Q,this.o(K,F)),this.p(Q)}$provideMappedEdits(F,K,G,Q,J){return this.t(F,re,x=>Promise.resolve(x.provideMappedEdits(K,G,Q,J)),null,J)}registerDocumentPasteEditProvider(F,K,G,Q){const J=this.q();this.f.set(J,new oe(new N(this.e,this.h,G,J,F),F));const x=N.toInternalProviderId(F.identifier.value,Q.id);return this.e.$registerPasteEditProvider(J,this.o(K,F),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(F,K,G,Q,J){return this.t(F,N,x=>x.prepareDocumentPaste(w.URI.revive(K),G,Q,J),void 0,J)}$providePasteEdits(F,K,G,Q,J,x){return this.t(F,N,ae=>ae.providePasteEdits(K,w.URI.revive(G),Q,J,x),void 0,x)}static y(F){return{pattern:F.source,flags:F.flags}}static z(F){return{decreaseIndentPattern:fe.y(F.decreaseIndentPattern),increaseIndentPattern:fe.y(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?fe.y(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?fe.y(F.unIndentedLinePattern):void 0}}static B(F){return{beforeText:fe.y(F.beforeText),afterText:F.afterText?fe.y(F.afterText):void 0,previousLineText:F.previousLineText?fe.y(F.previousLineText):void 0,action:F.action}}static C(F){return F.map(fe.B)}setLanguageConfiguration(F,K,G){const{wordPattern:Q}=G;if(Q&&(0,S.$ye)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(K,Q):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use."),G.autoClosingPairs&&(0,n.$NF)(F,"languageConfigurationAutoClosingPairs");const J=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.y(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs};return this.e.$setLanguageConfiguration(J,K,x),this.p(J)}$setWordDefinitions(F){for(const K of F)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Rac=fe}),define(Ae[240],Re([1,0,3,8,7,29,13,6]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=void 0;class S{constructor(P,k,u,p){this.c=k,this.d=u,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(w.$TJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,k){await this.a.$changeLanguage(P,k);const u=this.c.getDocumentData(P);if(!u)throw new Error(`document '${P.toString()}' NOT found`);return u.document}async tokenAtPosition(P,k){const u=P.version,p=T.Position.from(k),m=await this.a.$tokensAtPosition(P.uri,p),h={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(k)??new C.$XJ(k.line,k.character,k.line,k.character)};if(!m)return h;const t={range:T.Range.to(m.range),type:T.TokenType.to(m.type)};return!t.range.contains(k)||u!==P.version?h:t}createLanguageStatusItem(P,k,u){const p=this.f++,m=this.a,h=this.g,t=`${P.identifier.value}/${k}`;if(h.has(t))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);h.add(t);const i={selector:u,id:k,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const g=new l.$ic,D=()=>{if(c?.dispose(),!h.has(t)){console.warn(`LanguageStatusItem (${k}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Hg)(()=>{g.clear(),this.a.$setLanguageStatus(p,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===C.LanguageStatusSeverity.Error?L.default.Error:i.severity===C.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,g),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},b={dispose(){g.dispose(),c?.dispose(),m.$removeLanguageStatus(p),h.delete(t)},get id(){return i.id},get name(){return i.name},set name(n){i.name=n,D()},get selector(){return i.selector},set selector(n){i.selector=n,D()},get text(){return i.text},set text(n){i.text=n,D()},get detail(){return i.detail},set detail(n){i.detail=n,D()},get severity(){return i.severity},set severity(n){i.severity=n,D()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(n){i.accessibilityInformation=n,D()},get command(){return i.command},set command(n){i.command=n,D()},get busy(){return i.busy},set busy(n){i.busy=n,D()}};return D(),b}}e.$zbc=S}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=void 0;let P=class{constructor(u,p,m){this.f=m,this.d=new Map,this.a=p.getProxy(l.$TJ.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===w.$f}getMessage(u,p){const{message:m,args:h,comment:t}=p;if(this.c)return(0,T.$ne)(m,h??{});let i=m;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(u)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,T.$ne)(c??m,h??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let p;const m=await this.g(u);if(!m){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(m),t=JSON.parse(h);p=u.isBuiltin?t.contents?.bundle:t}catch(h){this.f.error(`Failed to load translations for ${u.identifier.value} from ${m}: ${h.message}`);return}p&&this.d.set(u.identifier.value,{contents:p,uri:m})}async g(u){if(u.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(p)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$obc=P,e.$obc=P=Ke([Ve(0,S.$_L),Ve(1,f.$VL),Ve(2,A.$4i)],P),e.$pbc=(0,L.$Ah)("IExtHostLocalizationService")}),define(Ae[241],Re([1,0,14,3,27,17,2,68]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;let S=class extends w.$cj{constructor(k,u){super(u.logLevel,u.logsLocation,u.loggers.map(p=>(0,l.$0g)(p))),this.r=k.getProxy(T.$TJ.MainThreadLogger)}$setLogLevel(k,u){u?this.setLogLevel(A.URI.revive(u),k):this.setLogLevel(k)}setVisibility(k,u){super.setVisibility(k,u),this.r.$setVisibility(k,u)}s(k,u,p){return new f(this.r,k,u,p)}};e.$Pcc=S,e.$Pcc=S=Ke([Ve(0,L.$VL),Ve(1,C.$_L)],S);class f extends w.$0i{constructor(k,u,p,m){super(m?.logLevel==="always"),this.r=k,this.s=u,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(u,m).then(()=>{this.u(this.n),this.m=!0})}g(k,u){const p=[[k,u]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0,e.$qbc=(0,T.$Ah)("IExtHostManagedSockets");let l=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(w.$TJ.MainThreadManagedSockets)}setFactory(k,u){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new S(k,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const u=++this.b,p=await this.c.makeConnection(),m=new C.$ic;return this.d.set(u,new f(u,p,m)),m.add((0,C.$hc)(()=>this.d.delete(u))),m.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),m.dispose()})),m.add(p.onDidClose(h=>{this.a.$onDidManagedSocketClose(u,h?.stack??h?.message),m.dispose()})),m.add(p.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(u,A.$Ed.wrap(h)))),u}$remoteSocketWrite(k,u){this.d.get(k)?.actual.send(u.buffer)}$remoteSocketEnd(k){const u=this.d.get(k);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$rbc=l,e.$rbc=l=Ke([Ve(0,L.$VL)],l);class S{constructor(k,u){this.socketFactoryId=k,this.makeConnection=u}}class f extends C.$jc{constructor(k,u,p){super(),this.socketId=k,this.actual=u,this.B(p)}}}),define(Ae[242],Re([1,0,3,14,26]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;function L(l){return l&&l.title}let A=class{constructor(S,f){this.b=f,this.a=S.getProxy(w.$TJ.MainThreadMessageService)}showMessage(S,f,P,k,u){const p={source:{identifier:S.identifier,label:S.displayName||S.name}};let m;typeof k=="string"||L(k)?m=[k,...u]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,m=u),p.useCustom&&(0,C.$NF)(S,"resolvers");const h=[];for(let t=0;t<m.length;t++){const i=m[t];if(typeof i=="string")h.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:g}=i;h.push({title:c,isCloseAffordance:!!g,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,P,p,h).then(t=>{if(typeof t=="number")return m[t]})}};e.$Abc=A,e.$Abc=A=Ke([Ve(1,T.$4i)],A)}),define(Ae[243],Re([1,0,152,25,5,6,28,15,16,2,38,54,3,31,8,7,46,205,104,9,24,12]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,o,y,$,I){this.q=y,this.r=$,this.s=I,this.f=new Map,this.g=new A.$yi,this.h=new Map,this.j=new C.$ed({onListenerError:g.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$ed({onListenerError:g.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$ed({onListenerError:g.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$ed({onListenerError:g.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Iac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(u.$TJ.MainThreadNotebook),this.c=s.getProxy(u.$TJ.MainThreadNotebookDocuments),this.d=s.getProxy(u.$TJ.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const r=E.notebookEditor?.notebookUri,d=E.cell.handle,R=this.g.get(r)?.getCell(d);if(R)return R.apiCell}if(E&&E.$mid===14){const r=E.uri,d=this.g.get(r);if(d)return d.apiNotebook}return E}}),n.A(o)}getEditorById(s){const o=this.h.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(s){for(const[o,y]of this.h)if(y.apiEditor===s)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,o){const y=this.g.get(s);if(!y&&!o)throw new Error(`NO notebook document for '${s}'`);return y}static t(s,o){if(!o)return;const y=o.filenamePattern.map($=>m.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,y){const $=n.a++,I=typeof y.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set($,y),this.b.$registerNotebookCellStatusBarItemProvider($,I,o);let E;return I!==void 0&&(E=y.onDidChangeCellStatusBarItems(r=>this.b.$emitCellStatusBarEvent(I))),new h.$VJ(()=>{this.f.delete($),this.b.$unregisterNotebookCellStatusBarItemProvider($,I),E?.dispose()})}async createNotebookDocument(s){const o=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&m.NotebookData.from(s.content)});return f.URI.revive(o)}async openNotebookDocument(s){const o=this.g.get(s);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(s),$=this.g.get(f.URI.revive(y));return(0,S.$tf)($?.apiNotebook)}async showNotebookDocument(s,o){f.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let y;typeof o=="object"?y={position:m.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(m.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const $=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,y),I=$&&this.h.get($)?.apiEditor;if(I)return I;throw $?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,y,$){const I=this.f.get(s),E=f.URI.revive(o),r=this.g.get(E);if(!r||!I)return;const d=r.getCellFromIndex(y);if(!d)return;const v=await I.provideCellStatusBarItems(d.apiCell,$);if(!v)return;const R=new L.$ic,B=this.p.add([R]),j=(Array.isArray(v)?v:[v]).map(W=>m.NotebookStatusBarItem.from(W,this.i,R));return{cacheId:B,items:j}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,o,y,$,I){if((0,l.$le)(o))throw new Error("viewType cannot be empty or just whitespace");const E=this.u++;return this.w.set(E,{viewType:o,serializer:y,options:$}),this.b.$registerNotebookSerializer(E,{id:s.identifier,location:s.extensionLocation},o,m.NotebookDocumentContentOptions.from($),n.t(s,I)),(0,L.$hc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(s,o,y){const $=this.w.get(s);if(!$)throw new Error("NO serializer found");const I=await $.serializer.deserializeNotebook(o.buffer,y);return new t.$aA(m.NotebookData.from(I))}async $notebookToData(s,o,y){const $=this.w.get(s);if(!$)throw new Error("NO serializer found");const I=await $.serializer.serializeNotebook(m.NotebookData.to(o.value),y);return T.$Ed.wrap(I)}async $saveNotebook(s,o,y,$,I){const E=f.URI.revive(o),r=this.w.get(s);if(!r)throw new Error("NO serializer found");const d=this.g.get(E);if(!d)throw new Error("Document NOT found");if(d.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new P.$mk((0,w.localize)(0,null,this.y(E)),6);await this.x(E,$);const v={metadata:(0,D.$3m)(d.apiNotebook.metadata,W=>!(r.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of d.apiNotebook.getCells()){const N=new h.$iL(W.kind,W.document.getText(),W.document.languageId,W.mime,r.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);N.metadata=(0,D.$3m)(W.metadata,z=>!(r.options?.transientCellMetadata??{})[z]),v.cells.push(N)}const R=await r.serializer.serializeNotebook(v,I);await this.s.value.writeFile(E,R);const B=this.s.getFileSystemProviderExtUri(E.scheme),V=await this.s.value.stat(E);return{name:B.basename(E),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$xk({mtime:V.mtime,size:V.size}),children:void 0}}async x(s,o){const y=await this.s.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$wk&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==P.$xk({mtime:o.mtime,size:y.size}))throw new P.$mk((0,w.localize)(1,null),3,o)}y(s){return s.scheme===b.Schemas.file?s.fsPath:s.toString()}z(s,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const $=new c.$hcc(o,this.d,s,y.visibleRanges.map(m.NotebookRange.to),y.selections.map(m.NotebookRange.to),typeof y.viewColumn=="number"?m.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,$)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const y of s.value.removedDocuments){const $=f.URI.revive(y),I=this.g.get($);I&&(I.dispose(),this.g.delete($),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(I.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===$.toString()&&this.h.delete(E.id)}if(s.value.addedDocuments){const y=[];for(const $ of s.value.addedDocuments){const I=f.URI.revive($.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const E=new i.$gcc(this.c,this.q,this.r,I,$);y.push(...$.cells.map(r=>i.$fcc.asModelAddData(E.apiNotebook,r))),this.g.get(I)?.dispose(),this.g.set(I,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(E.apiNotebook)}}if(s.value.addedEditors)for(const y of s.value.addedEditors){if(this.h.has(y.id))return;const $=f.URI.revive(y.documentUri),I=this.g.get($);I&&this.z(I,y.id,y)}const o=[];if(s.value.removedEditors)for(const y of s.value.removedEditors){const $=this.h.get(y);$&&(this.h.delete(y),this.k?.id===$.id&&(this.k=void 0),o.push($))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map($=>this.h.get($)).filter($=>!!$);const y=new Set;this.l.forEach($=>y.add($.id));for(const $ of this.h.values()){const I=y.has($.id);$._acceptVisibility(I)}this.l=[...this.h.values()].map($=>$).filter($=>$.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const o=p.$hM.String.with("notebookType","A notebook type"),y=new p.$jM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$hM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>T.$Ed.wrap(I))],new p.$iM("Notebook Data",I=>m.NotebookData.to(I.value))),$=new p.$jM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$hM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$aA(m.NotebookData.from(I)))],new p.$iM("Bytes",I=>I.buffer));s.registerApiCommand(y),s.registerApiCommand($)}}e.$icc=n}),define(Ae[244],Re([1,0,18,13,21,5,6,28,2,20,14,54,3,31,8,7,77,198,26,46]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=void 0;let D=class{constructor(I,E,r,d,v){this.m=E,this.n=r,this.o=d,this.q=v,this.b=new l.$yi,this.c=new l.$yi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new k.$Iac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$ed,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=I.getProxy(u.$TJ.MainThreadNotebookKernels);const R=new p.$jM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$hM("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const V=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:V}}else if(B&&"notebookEditor"in B){const V=this.n.getIdByEditor(B.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return B})],p.$iM.Void);this.o.registerApiCommand(R)}createNotebookController(I,E,r,d,v,R){for(const ye of this.j.values())if(ye.controller.id===E&&f.$Ul.equals(I.identifier,ye.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const B=this.k++,V=this;this.q.trace(`NotebookController[${B}], CREATED by ${I.identifier.value}, ${E}`);const j=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${I.identifier}'`);let W=!1;const N=new L.$ed,z=new L.$ed,ee={id:y(I.identifier,E),notebookType:r,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:d||I.identifier.value,preloads:R?R.map(m.NotebookRendererScript.from):[]};let X=v??j,Ee;this.a.$addKernel(B,ee).catch(ye=>{console.log(ye),W=!0});let De=0;const Pe=()=>{if(W)return;const ye=++De;Promise.resolve().then(()=>{ye===De&&this.a.$updateKernel(B,ee)})},Z=new l.$yi,ue={get id(){return E},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return ee.label},set label(ye){ee.label=ye??I.displayName??I.name,Pe()},get detail(){return ee.detail??""},set detail(ye){ee.detail=ye,Pe()},get description(){return ee.description??""},set description(ye){ee.description=ye,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(ye){ee.supportedLanguages=ye,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(ye){ee.supportsExecutionOrder=ye,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(ye){X=ye??j},get interruptHandler(){return Ee},set interruptHandler(ye){Ee=ye,ee.supportsInterrupt=!!ye,Pe()},createNotebookCellExecution(ye){if(W)throw new Error("notebook controller is DISPOSED");if(!Z.has(ye.notebook.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.notebook.uri.toString()}`);return V._createNotebookCellExecution(ye,y(I.identifier,this.id))},createNotebookExecution(ye){if((0,c.$NF)(I,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!Z.has(ye.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.uri.toString()}`);return V._createNotebookExecution(ye,y(I.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${B}], DISPOSED`),W=!0,this.j.delete(B),N.dispose(),z.dispose(),this.a.$removeKernel(B))},updateNotebookAffinity(ye,ce){ce===h.NotebookControllerAffinity2.Hidden&&(0,c.$NF)(I,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(B,ye.uri,ce)},onDidReceiveMessage:z.event,postMessage(ye,ce){return(0,c.$NF)(I,"notebookMessaging"),V.a.$postMessage(B,ce&&V.n.getIdByEditor(ce),ye)},asWebviewUri(ye){return(0,c.$NF)(I,"notebookMessaging"),(0,t.$Kob)(ye,V.m.remote)}};return this.j.set(B,{extensionId:I.identifier,controller:ue,onDidReceiveMessage:z,onDidChangeSelection:N,associatedNotebooks:Z}),ue}getIdByController(I){for(const[E,r]of this.j)if(r.controller===I)return y(r.extensionId,I.id);return null}createNotebookControllerDetectionTask(I,E){const r=this.f++,d=this;this.q.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${I.identifier.value}`),this.a.$addKernelDetectionTask(r,E);const v={dispose:()=>{this.e.delete(r),d.a.$removeKernelDetectionTask(r)}};return this.e.set(r,v),v}registerKernelSourceActionProvider(I,E,r){const d=this.h++,v=typeof r.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,R=this;this.g.set(d,r),this.q.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${I.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,E);let B;return v!==void 0&&(B=r.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.g.delete(d),R.a.$removeKernelSourceActionProvider(d,d),B?.dispose()}}}async $provideKernelSourceActions(I,E){const r=this.g.get(I);if(r){const d=new A.$ic;return this.i.add([d]),(await r.provideNotebookKernelSourceActions(E)??[]).map(R=>m.NotebookKernelSourceAction.from(R,this.o.converter,d))}return[]}$acceptNotebookAssociation(I,E,r){const d=this.j.get(I);if(d){const v=this.n.getNotebookDocument(S.URI.revive(E));r?d.associatedNotebooks.set(v.uri,!0):d.associatedNotebooks.delete(v.uri),this.q.trace(`NotebookController[${I}] ASSOCIATE notebook`,v.uri.toString(),r),d.onDidChangeSelection.fire({selected:r,notebook:v.apiNotebook})}}async $executeCells(I,E,r){const d=this.j.get(I);if(!d)return;const v=this.n.getNotebookDocument(S.URI.revive(E)),R=[];for(const B of r){const V=v.getCell(B);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${I}] EXECUTE cells`,v.uri.toString(),R.length),await d.controller.executeHandler.call(d.controller,R,v.apiNotebook,d.controller)}catch(B){this.q.error(`NotebookController[${I}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(I,E,r){const d=this.j.get(I);if(!d)return;const v=this.n.getNotebookDocument(S.URI.revive(E));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,v.apiNotebook);else for(const R of r){const B=v.getCell(R);B&&this.b.get(B.uri)?.cancel()}if(d.controller.interruptHandler){const R=this.c.get(v.uri);r.length&&Array.isArray(R)&&R.length&&R.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(I,E,r){const d=this.j.get(I);if(!d)return;const v=this.n.getEditorById(E);d.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:r}))}$cellExecutionChanged(I,E,r){const v=this.n.getNotebookDocument(S.URI.revive(I)).getCell(E);if(v){const R=r?m.NotebookCellExecutionState.to(r):h.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:v.apiCell,state:R})}}_createNotebookCellExecution(I,E){if(I.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.n.getNotebookDocument(I.notebook.uri).getCellFromApiCell(I);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const v=new n(E,d,this.a);this.b.set(d.uri,v);const R=v.onDidChangeState(()=>{v.state===b.Resolved&&(v.dispose(),R.dispose(),this.b.delete(d.uri))});return v.asApiObject()}_createNotebookExecution(I,E){const r=this.n.getNotebookDocument(I.uri),d=I.getCells().find(B=>{const V=r.getCellFromApiCell(B);return V&&this.b.has(V.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(r.uri))throw new Error(`duplicate notebook execution for ${r.uri}`);const v=new s(E,r,this.a),R=v.onDidChangeState(()=>{v.state===a.Resolved&&(v.dispose(),R.dispose(),this.c.delete(r.uri))});return this.c.set(r.uri,[v,R]),v.asApiObject()}};e.$wcc=D,e.$wcc=D=Ke([Ve(4,P.$4i)],D);var b;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(b||(b={}));class n extends A.$jc{static{this.a=0}get state(){return this.f}constructor(I,E,r){super(),this.m=E,this.n=r,this.b=n.a++,this.c=new L.$ed,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new C.$od),this.h=new o(10,d=>this.s(d)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,I,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(I){await this.h.addItem(I)}async s(I){const E=Array.isArray(I)?I:[I];return this.n.$updateExecution(this.b,new g.$aA(E))}t(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(I){let E=this.m;if(I&&(E=this.m.notebook.getCellFromApiCell(I)),!E)throw new Error("INVALID cell");return E.handle}y(I){return I.map(E=>{const r=h.$lL.ensureUniqueMimeTypes(E.items,!0);return r===E.items?m.NotebookCellOutput.from(E):m.NotebookCellOutput.from({items:r,id:E.id,metadata:E.metadata})})}async z(I,E,r){const d=this.w(E),v=this.y((0,w.$Zb)(I));return this.r({editType:i.CellExecutionUpdateType.Output,cellHandle:d,append:r,outputs:v})}async C(I,E,r){return I=h.$lL.ensureUniqueMimeTypes((0,w.$Zb)(I),!0),this.r({editType:i.CellExecutionUpdateType.OutputItems,items:I.map(m.NotebookCellOutputItem.from),outputId:E.id,append:r})}asApiObject(){const I=this;return Object.freeze({get token(){return I.g.token},get cell(){return I.m.apiCell},get executionOrder(){return I.j},set executionOrder(r){I.j=r,I.s([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:I.j}])},start(r){if(I.f===b.Resolved||I.f===b.Started)throw new Error("Cannot call start again");I.f=b.Started,I.c.fire(),I.s({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,d){if(I.f===b.Resolved)throw new Error("Cannot call resolve twice");I.f=b.Resolved,I.c.fire(),I.h.flush(),I.n.$completeExecution(I.b,new g.$aA({runEndTime:d,lastRunSuccess:r}))},clearOutput(r){return I.t(),I.z([],r,!1)},appendOutput(r,d){return I.t(),I.z(r,d,!0)},replaceOutput(r,d){return I.t(),I.z(r,d,!1)},appendOutputItems(r,d){return I.t(),I.C(r,d,!0)},replaceOutputItems(r,d){return I.t(),I.C(r,d,!1)}})}}var a;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(a||(a={}));class s extends A.$jc{static{this.a=0}get state(){return this.f}constructor(I,E,r){super(),this.h=E,this.j=r,this.b=s.a++,this.c=new L.$ed,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new C.$od),this.j.$createNotebookExecution(this.b,I,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(I,E){this.e=I,this.f=E,this.a=[],this.b=Date.now()}addItem(I){return this.a.push(I),this.c||(this.c=new T.$1g,this.b=Date.now(),(0,T.$Gg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const I=this.c;this.c=void 0;const E=this.a;return this.a=[],this.f(E).finally(()=>I.complete())}}function y($,I){return`${$.value}/${I}`}e.$xcc=y}),define(Ae[245],Re([1,0,5,3,104]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class L{constructor(l,S){this.c=S,this.a=new Map,this.b=l.getProxy(T.$TJ.MainThreadNotebookRenderers)}$postRendererMessage(l,S,f){const P=this.c.getEditorById(l);this.a.get(S)?.fire({editor:P.apiEditor,message:f})}createRendererMessaging(l,S){if(!l.contributes?.notebookRenderer?.some(P=>P.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(P,k,u)=>this.d(S).event(P,k,u),postMessage:(P,k)=>{C.$hcc.apiEditorsToExtHost.has(P)&&([P,k]=[k,P]);const u=k&&C.$hcc.apiEditorsToExtHost.get(k);return this.b.$postMessage(u?.id,S,P)}}}d(l){let S=this.a.get(l);return S||(S=new w.$ed({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(l)}}),this.a.set(l,S),S)}}e.$ycc=L}),define(Ae[246],Re([1,0,6,16,2,26,3]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class l{constructor(f){this.b=new Map,this.a=f.getProxy(A.$TJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,P,k){if((0,L.$NF)(f,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,k),this.a.$registerProfileContentHandler(P,k.name,k.description,f.identifier.value),(0,w.$hc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(f,P,k,u){const p=this.b.get(f);if(!p)throw new Error(`Unknown handler with id: ${f}`);return p.saveProfile(P,k,u)}async $readProfile(f,P,k){const u=this.b.get(f);if(!u)throw new Error(`Unknown handler with id: ${f}`);return u.readProfile((0,T.$if)(P)?P:C.URI.revive(P),k)}}e.$Ccc=l}),define(Ae[247],Re([1,0,2,3,13,8]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class A{static{this.a=0}constructor(S,f){this.d=f,this.c=new Map,this.b=S.getProxy(T.$TJ.MainThreadQuickDiff)}$provideOriginalResource(S,f,P){const k=w.URI.revive(f),u=this.c.get(S);return u?(0,C.$yg)(()=>u.provideOriginalResource(k,P)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(S,f,P,k){const u=A.a++;return this.c.set(u,f),this.b.$registerQuickDiffProvider(u,L.DocumentSelector.from(S,this.d),P,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Dcc=A}),define(Ae[248],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;function m(h,t,i){const c=h.getProxy(L.$TJ.MainThreadQuickOpen);class g{constructor(I,E){this.e=new Map,this.f=0,this.a=I,this.b=E}showQuickPick(I,E,r,d=w.CancellationToken.None){this.c=void 0;const v=Promise.resolve(E),R=++this.f,B=c.$show(R,{title:r?.title,placeHolder:r?.placeHolder,matchOnDescription:r?.matchOnDescription,matchOnDetail:r?.matchOnDetail,ignoreFocusLost:r?.ignoreFocusOut,canPickMany:r?.canPickMany},d),V={},j=B.then(()=>V);return Promise.race([j,v]).then(W=>{if(W===V)return;const N=(0,u.$MF)(I,"quickPickItemTooltip");return v.then(z=>{const ee=[];for(let X=0;X<z.length;X++){const Ee=z[X];if(typeof Ee=="string")ee.push({label:Ee,handle:X});else if(Ee.kind===l.QuickPickItemKind.Separator)ee.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!N&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const De=Ee.iconPath?s(Ee.iconPath):void 0;ee.push({label:Ee.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:N?p.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:X})}}return r&&typeof r.onDidSelectItem=="function"&&(this.c=X=>{r.onDidSelectItem(z[X])}),c.$setItems(R,ee),B.then(X=>{if(typeof X=="number")return z[X];if(Array.isArray(X))return X.map(Ee=>z[Ee])})})}).then(void 0,W=>{if(!(0,S.$2)(W))return c.$setError(R,W),Promise.reject(W)})}$onItemSelected(I){this.c?.(I)}showInput(I,E=w.CancellationToken.None){return this.d=I?.validateInput,c.$input(I,typeof this.d=="function",E).then(void 0,r=>{if(!(0,S.$2)(r))return Promise.reject(r)})}async $validateInput(I){if(!this.d)return;const E=await this.d(I);if(!E||typeof E=="string")return E;let r;switch(E.severity){case l.InputBoxValidationSeverity.Info:r=P.default.Info;break;case l.InputBoxValidationSeverity.Warning:r=P.default.Warning;break;case l.InputBoxValidationSeverity.Error:r=P.default.Error;break;default:r=E.message?P.default.Error:P.default.Ignore;break}return{content:E.message,severity:r}}async showWorkspaceFolderPick(I,E=w.CancellationToken.None){const r=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!r)return;const d=await this.a.getWorkspaceFolders2();if(d)return d.find(v=>v.uri.toString()===r.uri.toString())}createQuickPick(I){const E=new o(I,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(I){const E=new y(I,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(I,E){this.e.get(I)?._fireDidChangeValue(E)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,E){const r=this.e.get(I);r instanceof o&&r._fireDidChangeActive(E)}$onDidChangeSelection(I,E){const r=this.e.get(I);r instanceof o&&r._fireDidChangeSelection(E)}$onDidTriggerButton(I,E){this.e.get(I)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(I,E,r){const d=this.e.get(I);d instanceof o&&d._fireDidTriggerItemButton(E,r)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class D{static{this.a=1}constructor(I,E){this.x=I,this.y=E,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$ed,this.q=new T.$ed,this.r=new T.$ed,this.s=new T.$ed,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((E,r)=>{const d=E===l.$eL.Back?-1:r;this.o.set(d,E)}),this.z({buttons:I.map((E,r)=>({...s(E.iconPath),tooltip:E.tooltip,handle:E===l.$eL.Back?-1:r}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const E=this.o.get(I);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$ec)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(I){if(!this.v){for(const E of Object.keys(I)){const r=I[E];this.u[E]=r===void 0?null:r}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function b($){if($ instanceof l.$QK)return{id:$.id};const I=a($),E=n($);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof E=="string"?A.URI.file(E):E}}function n($){return typeof $=="object"&&"light"in $?$.light:$}function a($){return typeof $=="object"&&"dark"in $?$.dark:$}function s($){const I=b($);let E,r;return"id"in I?r=k.ThemeIcon.asClassName(I):E=I,{iconPath:E,iconClass:r}}class o extends D{constructor(I,E){super(I.identifier,E),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$ed,this.L=[],this.M=new T.$ed,this.N=new T.$ed,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((d,v)=>{this.C.set(v,d),this.D.set(d,v)});const E=(0,u.$MF)(this.O,"quickPickItemTooltip"),r=[];for(let d=0;d<I.length;d++){const v=I[d];if(v.kind===l.QuickPickItemKind.Separator)r.push({type:"separator",label:v.label});else{v.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=v.iconPath?s(v.iconPath):void 0;r.push({handle:d,label:v.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:E?p.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((B,V)=>({...s(B.iconPath),tooltip:B.tooltip,handle:V}))})}}this.z({items:r})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(I){const E=(0,f.$Eb)(I.map(r=>this.C.get(r)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(I){const E=(0,f.$Eb)(I.map(r=>this.C.get(r)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(I,E){const r=this.C.get(I);if(!r||!r.buttons||!r.buttons.length)return;const d=r.buttons[E];d&&this.N.fire({button:d,item:r})}}class y extends D{constructor(I,E){super(I.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:P.default.Error}):this.z({validationMessage:I.message,severity:I.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new g(t,i)}e.$Ebc=m}),define(Ae[249],Re([1,0,2,5,64,6,13,3,18,132,14,20,40,8,26,12]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.$Fbc=void 0;function i(E){if(E)return typeof E.iconPath=="string"?w.URI.file(E.iconPath):w.URI.isUri(E.iconPath)||u.ThemeIcon.isThemeIcon(E.iconPath)?E.iconPath:void 0}function c(E,r){if(!E.iconPath&&!r.iconPath)return 0;if(E.iconPath){if(!r.iconPath)return 1}else return-1;const d=typeof E.iconPath=="string"?E.iconPath:w.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id,v=typeof r.iconPath=="string"?r.iconPath:w.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id;return(0,f.$fq)(d,v)}function g(E,r){let d=0;if(E.strikeThrough!==r.strikeThrough)return E.strikeThrough?1:-1;if(E.faded!==r.faded)return E.faded?1:-1;if(E.tooltip!==r.tooltip)return(E.tooltip||"").localeCompare(r.tooltip||"");if(d=c(E,r),d!==0)return d;if(E.light&&r.light)d=c(E.light,r.light);else{if(E.light)return 1;if(r.light)return-1}if(d!==0)return d;if(E.dark&&r.dark)d=c(E.dark,r.dark);else{if(E.dark)return 1;if(r.dark)return-1}return d}function D(E,r){if(E.command!==r.command)return E.command<r.command?-1:1;if(E.title!==r.title)return E.title<r.title?-1:1;if(E.tooltip!==r.tooltip){if(E.tooltip!==void 0&&r.tooltip!==void 0)return E.tooltip<r.tooltip?-1:1;if(E.tooltip!==void 0)return 1;if(r.tooltip!==void 0)return-1}if(E.arguments===r.arguments)return 0;if(E.arguments)if(r.arguments){if(E.arguments.length!==r.arguments.length)return E.arguments.length-r.arguments.length}else return 1;else return-1;for(let d=0;d<E.arguments.length;d++){const v=E.arguments[d],R=r.arguments[d];if(v!==R)return v<R?-1:1}return 0}function b(E,r){let d=(0,f.$fq)(E.resourceUri.fsPath,r.resourceUri.fsPath,!0);if(d!==0)return d;if(E.command&&r.command)d=D(E.command,r.command);else{if(E.command)return 1;if(r.command)return-1}if(d!==0)return d;if(E.decorations&&r.decorations)d=g(E.decorations,r.decorations);else{if(E.decorations)return 1;if(r.decorations)return-1}return d}function n(E,r){for(let d=0;d<E.length;d++)if(E[d]!==r[d])return!1;return!0}function a(E,r){return E.command===r.command&&E.title===r.title&&E.tooltip===r.tooltip&&(E.arguments&&r.arguments?n(E.arguments,r.arguments):E.arguments===r.arguments)}function s(E,r){return(0,S.$sb)(E,r,a)}class o{#e;#t;get value(){return this.d}set value(r){r=r??"",this.#e.$setInputBoxValue(this.l,r),this.n(r)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(r){this.#e.$setInputBoxPlaceholder(this.l,r),this.f=r}get validateInput(){return(0,m.$NF)(this.k,"scmValidation"),this.g}set validateInput(r){if((0,m.$NF)(this.k,"scmValidation"),r&&typeof r!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=r,this.#e.$setValidationProviderIsEnabled(this.l,!!r)}get enabled(){return this.h}set enabled(r){r=!!r,this.h!==r&&(this.h=r,this.#e.$setInputBoxEnablement(this.l,r))}get visible(){return this.j}set visible(r){r=!!r,this.j!==r&&(this.j=r,this.#e.$setInputBoxVisibility(this.l,r))}get document(){return(0,m.$NF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(r,d,v,R,B){this.k=r,this.l=R,this.m=B,this.d="",this.e=new T.$ed,this.f="",this.h=!0,this.j=!0,this.#t=d,this.#e=v}showValidationMessage(r,d){(0,m.$NF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,r,d)}$onInputBoxValueChange(r){this.n(r)}n(r){this.d=r,this.e.fire(r)}}e.$Fbc=o;class y{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(r){this.v=r,this.q.$updateGroupLabel(this.t,this.handle,r)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(r){this.p=r,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(r){this.f=[...r],this.k.fire()}constructor(r,d,v,R,B){this.q=r,this.s=d,this.t=v,this.u=R,this.v=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$ed,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$ed,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=y.d++}getResourceState(r){return this.g.get(r)}$executeResourceCommand(r,d){const v=this.h.get(r);return v?(0,A.$yg)(()=>this.s.executeCommand(v.command,...v.arguments||[],d)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const r=[...this.f].sort(b),v=(0,S.$Ab)(this.o,r,b).map(V=>{const j=V.toInsert.map(W=>{const N=this.e++;this.g.set(N,W);const z=W.resourceUri;let ee;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const ie=new L.$ic;ee=this.s.converter.toInternal(W.command,ie),this.j.set(N,ie)}else this.h.set(N,W.command);const X=i(W.decorations),Ee=W.decorations&&i(W.decorations.light)||X,De=W.decorations&&i(W.decorations.dark)||X,Pe=[Ee,De],Z=W.decorations&&W.decorations.tooltip||"",ue=W.decorations&&!!W.decorations.strikeThrough,ye=W.decorations&&!!W.decorations.faded,ce=W.contextValue||"";return{rawResource:[N,z,Pe,Z,ue,ye,ce,ee],handle:N}});return{start:V.start,deleteCount:V.deleteCount,toInsert:j}}),R=v.map(({start:V,deleteCount:j,toInsert:W})=>[V,j,W.map(N=>N.rawResource)]),B=v.reverse();for(const{start:V,deleteCount:j,toInsert:W}of B){const N=W.map(ee=>ee.handle),z=this.n.splice(V,j,...N);for(const ee of z)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=r,R}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(r){this.g!==r&&(this.g=r,this.#e.$updateSourceControl(this.t,{count:r}))}get quickDiffProvider(){return this.h}set quickDiffProvider(r){this.h=r;let d;(0,m.$MF)(this.u,"quickDiffProvider")&&(d=r?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!r,quickDiffLabel:d})}get commitTemplate(){return this.j}set commitTemplate(r){r!==this.j&&(this.j=r,this.#e.$updateSourceControl(this.t,{commitTemplate:r}))}get acceptInputCommand(){return this.l}set acceptInputCommand(r){this.k.value=new L.$ic,this.l=r;const d=this.v.converter.toInternal(r,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:d})}get actionButton(){return(0,m.$NF)(this.u,"scmActionButton"),this.n}set actionButton(r){(0,m.$NF)(this.u,"scmActionButton"),this.m.value=new L.$ic,this.n=r;const d=r!==void 0?{command:this.v.converter.toInternal(r.command,this.m.value),secondaryCommands:r.secondaryCommands?.map(v=>v.map(R=>this.v.converter.toInternal(R,this.m.value))),description:r.description,enabled:r.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:d??null})}get statusBarCommands(){return this.p}set statusBarCommands(r){if(this.p&&r&&s(this.p,r))return;this.o.value=new L.$ic,this.p=r;const d=(r||[]).map(v=>this.v.converter.toInternal(v,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:d})}get selected(){return this.q}constructor(r,d,v,R,B,V,j){this.u=r,this.v=R,this.w=B,this.x=V,this.y=j,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$kc,this.l=void 0,this.m=new L.$kc,this.o=new L.$kc,this.p=void 0,this.q=!1,this.s=new T.$ed,this.onDidChangeSelection=this.s.event,this.t=$.d++,this.z=new Map,this.A=new Set,this.#e=v;const W=w.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${B}/scm${this.t}/input`,query:j?`rootUri=${encodeURIComponent(j.toString())}`:void 0});this.f=new o(r,d,this.#e,this.t,W),this.#e.$registerSourceControl(this.t,B,V,j,W)}createResourceGroup(r,d){const v=new y(this.#e,this.v,this.t,r,d),R=T.Event.once(v.onDidDispose)(()=>this.z.delete(v));return this.z.set(v,R),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const r=[],d=[];for(const[v,R]of this.z){R.dispose();const B=v.onDidUpdateResourceStates(()=>{this.A.add(v),this.eventuallyUpdateResourceStates()});T.Event.once(v.onDidDispose)(()=>{this.A.delete(v),B.dispose(),this.e.delete(v.handle),this.#e.$unregisterGroup(this.t,v.handle)}),r.push([v.handle,v.id,v.label,v.features]);const V=v._takeResourceStateSnapshot();V.length>0&&d.push([v.handle,V]),this.e.set(v.handle,v)}this.#e.$registerGroups(this.t,r,d),this.z.clear()}eventuallyUpdateResourceStates(){const r=[];this.A.forEach(d=>{const v=d._takeResourceStateSnapshot();v.length!==0&&r.push([d.handle,v])}),r.length>0&&this.#e.$spliceResourceStates(this.t,r),this.A.clear()}getResourceGroup(r){return this.e.get(r)}setSelectionState(r){this.q=r,this.s.fire(r)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(r=>r.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,C.$6g)(100)],$.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$6g)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let I=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(r,d,v,R){this.l=d,this.m=v,this.n=R,this.g=new Map,this.h=new k.$Wl,this.j=new T.$ed,this.e=r.getProxy(l.$TJ.MainThreadSCM),this.f=r.getProxy(l.$TJ.MainThreadTelemetry),d.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===3){const V=this.g.get(B.sourceControlHandle);if(!V)return B;const j=V.getResourceGroup(B.groupHandle);return j?j.getResourceState(B.handle):B}else if(B&&B.$mid===4){const V=this.g.get(B.sourceControlHandle);return V?V.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===5){const V=this.g.get(B.handle);return V||B}return B}})}createSourceControl(r,d,v,R){this.n.trace("ExtHostSCM#createSourceControl",r.identifier.value,d,v,R),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:r.identifier.value});const B=t.d++,V=new $(r,this.m,this.e,this.l,d,v,R);this.g.set(B,V);const j=this.h.get(r.identifier)||[];return j.push(V),this.h.set(r.identifier,j),V}getLastInputBox(r){this.n.trace("ExtHostSCM#getLastInputBox",r.identifier.value);const d=this.h.get(r.identifier),v=d&&d[d.length-1];return v&&v.inputBox}$provideOriginalResource(r,d,v){const R=w.URI.revive(d);this.n.trace("ExtHostSCM#$provideOriginalResource",r,R.toString());const B=this.g.get(r);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$yg)(()=>B.quickDiffProvider.provideOriginalResource(R,v)).then(V=>V||null)}$onInputBoxValueChange(r,d){this.n.trace("ExtHostSCM#$onInputBoxValueChange",r);const v=this.g.get(r);return v&&v.inputBox.$onInputBoxValueChange(d),Promise.resolve(void 0)}$executeResourceCommand(r,d,v,R){this.n.trace("ExtHostSCM#$executeResourceCommand",r,d,v);const B=this.g.get(r);if(!B)return Promise.resolve(void 0);const V=B.getResourceGroup(d);return V?V.$executeResourceCommand(v,R):Promise.resolve(void 0)}$validateInput(r,d,v){this.n.trace("ExtHostSCM#$validateInput",r);const R=this.g.get(r);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,A.$yg)(()=>R.inputBox.validateInput(d,v)).then(B=>{if(!B)return Promise.resolve(void 0);const V=p.MarkdownString.fromStrict(B.message);return V?Promise.resolve([V,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(r){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",r),r!==void 0&&this.g.get(r)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=r,Promise.resolve(void 0)}};e.$Gbc=I,e.$Gbc=I=t=Ke([Ve(3,P.$4i)],I)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=e.$lbc=void 0;class L{constructor(l){this.b=new T.$ed,this.onDidChangePassword=this.b.event,this.a=l.getProxy(w.$TJ.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,S){return this.a.$getPassword(l,S)}store(l,S,f){return this.a.$setPassword(l,S,f)}delete(l,S){return this.a.$deletePassword(l,S)}}e.$lbc=L,e.$mbc=(0,C.$Ah)("IExtHostSecretState")}),define(Ae[250],Re([1,0,3,8,2]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class L{static{this.a=0}constructor(l,S){this.d=S,this.c=new Map,this.b=l.getProxy(w.$TJ.MainThreadShare)}async $provideShare(l,S,f){return await this.c.get(l)?.provideShare({selection:T.Range.to(S.selection),resourceUri:C.URI.revive(S.resourceUri)},f)??void 0}registerShareProvider(l,S){const f=L.a++;return this.c.set(f,S),this.b.$registerShareProvider(f,T.DocumentSelector.from(l,this.d),S.id,S.label,S.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$Icc=L}),define(Ae[251],Re([1,0,7,3,154,6,8,16]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=void 0;class S{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$RK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$RK("statusBarItem.warningForeground")]])}#e;#t;constructor(u,p,m,h,t,i=w.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new L.$ic,this.#e=u,this.#t=p,t&&h){this.c=(0,w.$uK)(h.identifier,t);const g=m.get(this.c);g&&(i=g.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,c=g.priority,this.j=!0,this.name=g.name,this.text=g.text,this.tooltip=g.tooltip,this.command=g.command,this.accessibilityInformation=g.accessibilityInformation)}else this.c=String(S.a++);this.e=h,this.f=t,this.g=i,this.h=this.u(c)}u(u){if((0,l.$mf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!S.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new L.$ic,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=S.b.get(this.o.id));const h=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,p,this.k,h,this.r?.internal,m,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Hbc=S;class f{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const p={message:u};return this.b.unshift(p),this.c(),new w.$VJ(()=>{const m=this.b.indexOf(p);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,p){this.e=new Map,this.a=u.getProxy(T.$TJ.MainThreadStatusBar),this.b=p,this.c=new f(this)}$acceptStaticEntries(u){for(const p of u)this.e.set(p.entryId,p)}createStatusBarEntry(u,p,m,h){return new S(this.a,this.b,this.e,u,p,m,h)}setStatusBarMessage(u,p){const m=this.c.setMessage(u);let h;return typeof p=="number"?h=setTimeout(()=>m.dispose(),p):typeof p<"u"&&p.then(()=>m.dispose(),()=>m.dispose()),new w.$VJ(()=>{m.dispose(),clearTimeout(h)})}}e.$Ibc=P}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=e.$_ac=void 0;class L{constructor(l,S){this.c=S,this.b=new T.$ed,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(w.$TJ.MainThreadStorage)}registerExtensionStorageKeysToSync(l,S){this.a.$registerExtensionStorageKeysToSync(l,S)}async initializeExtensionStorage(l,S,f){const P=await this.a.$initializeExtensionStorage(l,S);let k;return P&&(k=this.d(l,S,P)),k||f}setValue(l,S,f){return this.a.$setValue(l,S,f)}$acceptValue(l,S,f){const P=this.d(l,S,f);P&&this.b.fire({shared:l,key:S,value:P})}d(l,S,f){try{return JSON.parse(f)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${l}): ${P}`)}}}e.$_ac=L,e.$abc=(0,C.$Ah)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,61,2]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=void 0,e.$fbc=(0,w.$Ah)("IExtensionStoragePaths");let l=class{constructor(f,P,k){this.d=P,this.f=k,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,P=await this.g(f);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$gbc=l,e.$gbc=l=Ke([Ve(0,T.$_L),Ve(1,C.$4i),Ve(2,L.$ebc)],l)}),define(Ae[62],Re([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,13,8,31]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=e.$ibc=e.$hbc=void 0,e.$hbc=(0,C.$Ah)("IExtHostTerminalService");class g{constructor(r,d,v,R){this.k=r,this._id=d,this.l=v,this.m=R,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const B=this;this.value={get name(){return B.m||""},get processId(){return B.b},get creationOptions(){return B.l},get exitStatus(){return B.h},get state(){return B.i},get selection(){return B.j},sendText(V,j=!0){B.o(),B.k.$sendText(B._id,V,j)},show(V){B.o(),B.k.$show(B._id,V)},hide(){B.o(),B.k.$hide(B._id)},dispose(){B.a||(B.a=!0,B.k.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(r,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:r.shellPath??void 0,shellArgs:r.shellArgs??void 0,cwd:r.cwd??void 0,env:r.env??void 0,icon:y(r.iconPath)??void 0,color:h.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:r.message??void 0,strictEnv:r.strictEnv??void 0,hideFromUser:r.hideFromUser??void 0,isFeatureTerminal:d?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:d?.useShellEnvironment??void 0,location:d?.location||this.n(r.location,d?.resolvedExtHostIdentifier),isTransient:r.isTransient??void 0})}async createExtensionTerminal(r,d,v,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:v,color:h.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.n(r,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,d){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in r?{viewColumn:i.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,d){this.h=Object.freeze({code:r,reason:d})}setDimensions(r,d){return r===this.d&&d===this.g||r===0||d===0?!1:(this.d=r,this.g=d,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(r){this.j=r}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(d=>{d!==r&&(this.b=Promise.resolve(r))})}}e.$ibc=g;class D{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new w.$ed,this.onProcessData=this.a.event,this.b=new w.$ed,this.d=new w.$ed,this.onDidChangeProperty=this.d.event,this.f=new w.$ed,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${d}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,d){this.g.setDimensions?.({columns:r,rows:d})}clearBuffer(){}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(r){this.g.onDidWrite(d=>this.a.fire(d)),this.g.onDidClose?.((d=void 0)=>{this.f.fire(d===void 0?void 0:d)}),this.g.onDidOverrideDimensions?.(d=>{d&&this.d.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this.g.onDidChangeName?.(d=>{this.d.fire({type:"title",value:d})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let b=1,n=class extends l.$jc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}constructor(r,d,v){super(),this.Q=d,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$kc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$ed,this.onDidCloseTerminal=this.H.event,this.I=new w.$ed,this.onDidOpenTerminal=this.I.event,this.J=new w.$ed,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$ed,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$ed,this.onDidChangeTerminalState=this.M.event,this.N=new w.$ed,this.onDidChangeShell=this.N.event,this.O=new w.$ed({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$ed({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=v.getProxy(T.$TJ.MainThreadTerminalService),this.y=new m.$Ckb(this.a.$sendProcessData),this.a.$registerProcessSupport(r),this.B({dispose:()=>{for(const[R,B]of this.g)B.shutdown(!0)}})}getDefaultShell(r){return(r?this.u:this.s)?.path||""}getDefaultShellArgs(r){return(r?this.u:this.s)?.args||[]}createExtensionTerminal(r,d){const v=new g(this.a,(0,p.$3f)(),r,r.name),R=new D(r.pty);return v.createExtensionTerminal(r.location,this.R(r,d).resolvedExtHostIdentifier,y(r.iconPath),$(r.color)).then(B=>{const V=this.S(B,R);this.h[B]=V}),this.f.push(v),v.value}R(r,d){if(d=d||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const v=r.location.parentTerminal;if(v){const R=this.f.find(B=>B.value===v);R&&(d.resolvedExtHostIdentifier=R._id)}}else r.location&&typeof r.location!="object"?d.location=r.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(r,d){if(!this.W(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const R=new D(d),B=this.S(r,R);this.h[r]=B}async $acceptActiveTerminalChanged(r){const d=this.b;if(r===null){this.b=void 0,d!==this.b&&this.J.fire(this.b);return}const v=this.W(r);v&&(this.b=v,d!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(r,d){const v=this.W(r);v&&this.O.fire({terminal:v.value,data:d})}async $acceptTerminalDimensions(r,d,v){const R=this.W(r);R&&R.setDimensions(d,v)&&this.L.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(r,d){const v=this.W(r);v&&this.P.fire({terminal:v.value,...d})}async $acceptTerminalMaximumDimensions(r,d,v){this.g.get(r)?.resize(d,v)}async $acceptTerminalTitleChange(r,d){const v=this.W(r);v&&(v.name=d)}async $acceptTerminalClosed(r,d,v){const R=this.Y(this.f,r);if(R!==null){const B=this.f.splice(R,1)[0];B.setExitStatus(d,v),this.H.fire(B.value)}}$acceptTerminalOpened(r,d,v,R){if(d){const j=this.Y(this.f,d);if(j!==null){this.f[j]._id=r,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const B={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:L.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new g(this.a,r,B,v);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(r,d){this.W(r)?._setProcessId(d)}async $startExtensionTerminal(r,d){const v=this.W(r);if(!v)return{message:(0,f.localize)(0,null,r)};v.isOpen||await new Promise(B=>{const V=this.onDidOpenTerminal(async j=>{j===v.value&&(V.dispose(),B())})});const R=this.g.get(r);R?R.startSendingEvents(d):this.j[r]={initialDimensions:d}}S(r,d){const v=new l.$ic;v.add(d.onProcessReady(B=>this.a.$sendProcessReady(r,B.pid,B.cwd,B.windowsPty))),v.add(d.onDidChangeProperty(B=>this.a.$sendProcessProperty(r,B))),this.y.startBuffering(r,d.onProcessData),v.add(d.onProcessExit(B=>this.U(r,B))),this.g.set(r,d);const R=this.j[r];return R&&d instanceof D&&(d.startSendingEvents(R.initialDimensions),delete this.j[r]),v}$acceptProcessAckDataEvent(r,d){this.g.get(r)?.acknowledgeDataEvent(d)}$acceptProcessInput(r,d){this.g.get(r)?.input(d)}$acceptTerminalInteraction(r){const d=this.W(r);d?.setInteractedWith()&&this.M.fire(d.value)}$acceptTerminalSelection(r,d){this.W(r)?.setSelection(d)}$acceptProcessResize(r,d,v){try{this.g.get(r)?.resize(d,v)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(r,d){this.g.get(r)?.shutdown(d)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(d=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(d=>this.a.$sendProcessProperty(r,{type:"cwd",value:d}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.z.add(r),this.z.size===1&&this.a.$startLinkProvider(),new S.$VJ(()=>{this.z.delete(r),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,d,v){if(this.C.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this.C.set(d,v),this.a.$registerProfileProvider(d,r.identifier.value),new S.$VJ(()=>{this.C.delete(d),this.a.$unregisterProfileProvider(d)})}registerTerminalQuickFixProvider(r,d,v){if(this.D.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.D.set(r,v),this.a.$registerQuickFixProvider(r,d),new S.$VJ(()=>{this.D.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,d){const v=new u.$od().token;if(v.isCancellationRequested)return;const R=this.D.get(r);if(!R)return;const B=await R.provideTerminalQuickFixes(d,v);if(B===null||Array.isArray(B)&&B.length===0)return;const V=new l.$ic;if(this.w.value=V,!Array.isArray(B))return B?i.TerminalQuickFix.from(B,this.Q.converter,V):void 0;const j=[];for(const W of B){const N=i.TerminalQuickFix.from(W,this.Q.converter,V);N&&j.push(N)}return j}async $createContributedProfileTerminal(r,d){const v=new u.$od().token;let R=await this.C.get(r)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,d);return}this.createTerminalFromOptions(R.options,d)}}async $provideLinks(r,d){const v=this.W(r);if(!v)return[];this.F.delete(r),this.G.get(r)?.dispose(!0);const B=new u.$od;this.G.set(r,B);const V=[],j={terminal:v.value,line:d},W=[];for(const ee of this.z)W.push(t.Promises.withAsyncBody(async X=>{B.token.onCancellationRequested(()=>X({provider:ee,links:[]}));const Ee=await ee.provideTerminalLinks(j,B.token)||[];B.token.isCancellationRequested||X({provider:ee,links:Ee})}));const N=await Promise.all(W);if(B.token.isCancellationRequested)return[];const z=new Map;for(const ee of N)ee&&ee.links.length>0&&V.push(...ee.links.map(X=>{const Ee={id:b++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return z.set(Ee.id,{provider:ee.provider,link:X}),Ee}));return this.F.set(r,z),V}$activateLink(r,d){const v=this.F.get(r)?.get(d);v&&v.provider.handleTerminalLink(v.link)}U(r,d){this.y.stopBuffering(r),this.g.delete(r),delete this.j[r];const v=this.h[r];v&&(v.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,d)}W(r){return this.X(this.f,r)}X(r,d){const v=this.Y(r,d);return v!==null?r[v]:null}Y(r,d){const v=r.findIndex(R=>R._id===d);return v===-1?null:v}getEnvironmentVariableCollection(r){let d=this.n.get(r.identifier.value);return d||(d=new a,this.$(r.identifier.value,d)),d.getScopedEnvironmentVariableCollection(void 0)}Z(r,d){const v=(0,k.$$q)(d.map),R=(0,k.$_q)(d.descriptionMap);this.a.$setEnvironmentVariableCollection(r,d.persistent,v.length===0?void 0:v,R)}$initEnvironmentVariableCollections(r){r.forEach(d=>{const v=d[0],R=new a(d[1]);this.$(v,R)})}$acceptDefaultProfile(r,d){const v=this.s;this.s=r,this.u=d,v?.path!==r.path&&this.N.fire(r.path)}$(r,d){this.n.set(r,d),d.onDidChangeCollection(()=>{this.Z(r,d)})}};e.$jbc=n,e.$jbc=n=Ke([Ve(1,c.$fM),Ve(2,A.$VL)],n);class a{get persistent(){return this.b}set persistent(r){this.b=r,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(r){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$ed,this.map=new Map(r)}getScopedEnvironmentVariableCollection(r){const d=this.h(r);let v=this.a.get(d);return v||(v=new s(this,r),this.a.set(d,v),v.onDidChangeCollection(()=>this.d.fire())),v}replace(r,d,v,R){this.f(r,{value:d,type:S.EnvironmentVariableMutatorType.Replace,options:v??{applyAtProcessCreation:!0},scope:R})}append(r,d,v,R){this.f(r,{value:d,type:S.EnvironmentVariableMutatorType.Append,options:v??{applyAtProcessCreation:!0},scope:R})}prepend(r,d,v,R){this.f(r,{value:d,type:S.EnvironmentVariableMutatorType.Prepend,options:v??{applyAtProcessCreation:!0},scope:R})}f(r,d){if(d.options&&d.options.applyAtProcessCreation===!1&&!d.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const v=this.g(r,d.scope),R=this.map.get(v),B=d.options?{applyAtProcessCreation:d.options.applyAtProcessCreation??!1,applyAtShellIntegration:d.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==d.value||R.type!==d.type||R.options?.applyAtProcessCreation!==B.applyAtProcessCreation||R.options?.applyAtShellIntegration!==B.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index){const V=this.g(r,d.scope),j={variable:r,...d,options:B};this.map.set(V,j),this.d.fire()}}get(r,d){const v=this.g(r,d),R=this.map.get(v);return R?I(R):void 0}g(r,d){const v=this.h(d);return v.length?`${r}:::${v}`:r}h(r){return this.i(r?.workspaceFolder)??""}i(r){return r?r.uri.toString():void 0}getVariableMap(r){const d=new Map;for(const[v,R]of this.map)this.h(R.scope)===this.h(r)&&d.set(R.variable,I(R));return d}delete(r,d){const v=this.g(r,d);this.map.delete(v),this.d.fire()}clear(r){if(r?.workspaceFolder){for(const[d,v]of this.map)v.scope?.workspaceFolder?.index===r.workspaceFolder.index&&this.map.delete(d);this.j(r)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(r,d){const v=this.h(d),R=this.descriptionMap.get(v);if(!R||R.description!==r){let B;typeof r=="string"?B=r:B=r?.value.split(`

`)[0];const V={description:B,scope:d};this.descriptionMap.set(v,V),this.d.fire()}}getDescription(r){const d=this.h(r);return this.descriptionMap.get(d)?.description}j(r){const d=this.h(r);this.descriptionMap.delete(d)}}class s{get persistent(){return this.b.persistent}set persistent(r){this.b.persistent=r}get onDidChangeCollection(){return this.a&&this.a.event}constructor(r,d){this.b=r,this.d=d,this.a=new w.$ed}getScoped(r){return this.b.getScopedEnvironmentVariableCollection(r)}replace(r,d,v){this.b.replace(r,d,v,this.d)}append(r,d,v){this.b.append(r,d,v,this.d)}prepend(r,d,v){this.b.prepend(r,d,v,this.d)}get(r){return this.b.get(r,this.d)}forEach(r,d){this.b.getVariableMap(this.d).forEach((v,R)=>r.call(d,R,v,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(r){this.b.delete(r,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(r){this.b.setDescription(r,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(r,d){super(!1,r,d)}createTerminal(r,d,v){throw new P.$0}createTerminalFromOptions(r,d){throw new P.$0}};e.$kbc=o,e.$kbc=o=Ke([Ve(0,c.$fM),Ve(1,A.$VL)],o);function y(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function $(E){return h.ThemeColor.isThemeColor(E)?E:void 0}function I(E){const r={...E};return delete r.scope,r.options=r.options??void 0,delete r.variable,r}}),define(Ae[252],Re([1,0,281,13,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,56,26]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=e.$scc=e.$rcc=void 0;let n=class{constructor(j,W,N){this.k=N,this.d=new A.$ed,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=j.getProxy(p.$TJ.MainThreadTesting),this.j=new v(this.g),this.h=new y(this.g),W.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 15:{const ee=z,X=ee.tests[ee.tests.length-1].item.extId;return this.f.get(c.$GI.root(X))?.collection.tree.get(X)?.actual??(0,h.$8L)(z)}case 17:{const{extId:ee,message:X}=z;return{test:this.f.get(c.$GI.root(ee))?.collection.tree.get(ee)?.actual,message:t.TestMessage.to(X)}}default:return z}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await W.executeCommand("_testing.getExplorerSelection"),ee=X=>{const Ee=this.f.get(c.$GI.root(X));if(Ee)return c.$GI.isRoot(X)?Ee.controller:Ee.collection.tree.get(X)?.actual};return{include:z?.include.map(ee).filter(k.$qf)||[],exclude:z?.exclude.map(ee).filter(k.$qf)||[]}})}createTestController(j,W,N,z){if(this.f.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const ee=new f.$ic,X=ee.add(new h.$$L(W,N,this.k));X.root.label=N;const Ee=new Map,De=this.g,Pe={items:X.root.children,get label(){return N},set label(ue){N=ue,X.root.label=ue,De.$updateController(W,{label:N})},get refreshHandler(){return z},set refreshHandler(ue){z=ue,De.$updateController(W,{canRefresh:!!ue})},get id(){return W},createRunProfile:(ue,ye,ce,$e,ie,O)=>{let q=(0,S.$oi)(ue);for(;Ee.has(q);)q++;return new R(this.g,Ee,W,q,ue,ye,ce,$e,ie,O)},createTestItem(ue,ye,ce){return new h.$9L(W,ue,ye,ce)},createTestRun:(ue,ye,ce=!0)=>this.h.createTestRun(j,W,X,ue,ye,ce),invalidateTestResults:ue=>{if(ue===void 0)this.g.$markTestRetired(void 0);else{const ye=ue instanceof Array?ue:[ue];this.g.$markTestRetired(ye.map(ce=>c.$GI.fromExtHostTestItem(ce,W).toString()))}},set resolveHandler(ue){X.resolveHandler=ue},get resolveHandler(){return X.resolveHandler},dispose:()=>{ee.dispose()}};De.$registerTestController(W,N,!!z),ee.add((0,f.$hc)(()=>De.$unregisterTestController(W)));const Z={controller:Pe,collection:X,profiles:Ee,extension:j};return this.f.set(W,Z),ee.add((0,f.$hc)(()=>this.f.delete(W))),ee.add(X.onDidGenerateDiff(ue=>De.$publishDiff(W,ue.map(D.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(j,W=L.CancellationToken.None){const N=$(j);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.f.get(N.controllerId);if(!z)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(ee=>c.$GI.fromExtHostTestItem(ee,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:B[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:j.exclude?.map(ee=>ee.id)},W)}$syncTests(){for(const{collection:j}of this.f.values())j.flushDiff();return Promise.resolve()}$provideFileCoverage(j,W,N){return(0,w.$pb)(this.h.trackers,ee=>ee.id===j?ee.getCoverage(W):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(j,W,N,z){return(0,w.$pb)(this.h.trackers,X=>X.id===j?X.getCoverage(W):void 0)?.resolveFileCoverage(N,z)??Promise.resolve([])}$configureRunProfile(j,W){this.f.get(j)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(j,W){await this.f.get(j)?.controller.refreshHandler?.(W)}$publishTestResults(j){this.results=Object.freeze(j.map(W=>(0,P.$Vm)(t.TestResults.to(W))).concat(this.results).sort((W,N)=>N.completedAt-W.completedAt).slice(0,32)),this.d.fire()}async $expandTest(j,W){const N=this.f.get(c.$GI.fromString(j).controllerId)?.collection;N&&(await N.expand(j,W<0?1/0:W),N.flushDiff())}$acceptDiff(j){this.j.applyDiff(j.map(D.TestsDiffOp.deserialize))}async $runControllerTests(j,W){return Promise.all(j.map(N=>this.l(N,!1,W)))}async $startContinuousRun(j,W){const N=new L.$od(W),z=await Promise.all(j.map(ee=>this.l(ee,!0,N.token)));return!W.isCancellationRequested&&!z.some(ee=>ee.error)&&await new Promise(ee=>W.onCancellationRequested(ee)),N.dispose(!0),z}async l(j,W,N){const z=this.f.get(j.controllerId);if(!z)return{};const{collection:ee,profiles:X,extension:Ee}=z,De=X.get(j.profileId);if(!De)return{};const Pe=j.testIds.map(ce=>ee.tree.get(ce)).filter(k.$qf),Z=j.excludeExtIds.map(ce=>z.collection.tree.get(ce)).filter(k.$qf).filter(ce=>Pe.some($e=>$e.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const ue=new i.$sL(Pe.some(ce=>ce.actual instanceof h.$0L)?void 0:Pe.map(ce=>ce.actual),Z.map(ce=>ce.actual),De,W),ye=(0,D.$II)(j)&&this.h.prepareForMainThreadTestRun(ue,I.fromInternal(j,z.collection),Ee,N);try{return await De.runHandler(ue,N),{}}catch(ce){return{error:String(ce)}}finally{ye&&(ye.hasRunningTasks&&!N.isCancellationRequested&&await A.Event.toPromise(ye.onEnd),ye.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.h.cancelAllRuns():this.h.cancelRunById(j)}};e.$rcc=n,e.$rcc=n=Ke([Ve(0,m.$VL)],n);const a=1e4;var s;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(s||(s={}));class o extends f.$jc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(j,W,N,z){super(),this.s=j,this.u=W,this.w=N,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$ed),this.onEnd=this.m.event,this.j=this.B(new L.$od(z));const ee=this.B(new T.$Rg(()=>this.y(),a));this.B(this.j.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(j){return this.g.get(j)?.coverage}createRun(j){const W=this.s.id,N=this.s.controllerId,z=(0,u.$3f)(),ee=new E(this.u,W,z),X=Z=>(ue,...ye)=>{if(De){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ue)&&(this.C(ue),Z(ue,...ye))},Ee=(Z,ue)=>{const ye=ue instanceof Array?ue.map(t.TestMessage.from):[t.TestMessage.from(ue)];if(ye.some(ce=>ce.contextValue!==void 0)&&(0,b.$NF)(this.w,"testMessageContextValue"),Z.uri&&Z.range){const ce={range:t.Range.from(Z.range),uri:Z.uri};for(const $e of ye)$e.location=$e.location||ce}this.u.$appendTestMessagesInRun(W,z,c.$GI.fromExtHostTestItem(Z,N).toString(),ye)};let De=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:j,get coverageProvider(){return ee.coverageProvider},set coverageProvider(Z){ee.coverageProvider=Z},enqueued:X(Z=>{this.u.$updateTestStateInRun(W,z,c.$GI.fromExtHostTestItem(Z,N).toString(),1)}),skipped:X(Z=>{this.u.$updateTestStateInRun(W,z,c.$GI.fromExtHostTestItem(Z,N).toString(),5)}),started:X(Z=>{this.u.$updateTestStateInRun(W,z,c.$GI.fromExtHostTestItem(Z,N).toString(),2)}),errored:X((Z,ue,ye)=>{Ee(Z,ue),this.u.$updateTestStateInRun(W,z,c.$GI.fromExtHostTestItem(Z,N).toString(),6,ye)}),failed:X((Z,ue,ye)=>{Ee(Z,ue),this.u.$updateTestStateInRun(W,z,c.$GI.fromExtHostTestItem(Z,N).toString(),4,ye)}),passed:X((Z,ue)=>{this.u.$updateTestStateInRun(W,z,c.$GI.fromExtHostTestItem(Z,this.s.controllerId).toString(),3,ue)}),appendOutput:(Z,ue,ye)=>{De||(ye&&(this.s.isIncluded(ye)?this.C(ye):ye=void 0),this.u.$appendOutputToRun(W,z,C.$Ed.fromString(Z),ue&&t.location.from(ue),ye&&c.$GI.fromExtHostTestItem(ye,N).toString()))},end:()=>{De||(De=!0,this.u.$finishedTestRunTask(W,z),this.g.delete(z),this.g.size||this.z())}};return this.g.set(z,{run:Pe,coverage:ee}),this.u.$startedTestRunTask(W,{id:z,name:j,running:!0}),Pe}y(){for(const{run:j}of this.g.values())j.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(j){if(!(j instanceof h.$9L))throw new g.$NL(j.id);if(this.h.has(c.$GI.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const W=[],N=this.s.colllection.root;for(;;){const z=t.TestItem.from(j);if(W.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),j===N))break;j=j.parent||N}this.u.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.d.values()}constructor(j){this.f=j,this.d=new Map}prepareForMainThreadTestRun(j,W,N,z){return this.g(j,W,N,z)}cancelRunById(j){for(const W of this.d.values())if(W.id===j){W.cancel();return}}cancelAllRuns(){for(const j of this.d.values())j.cancel()}createTestRun(j,W,N,z,ee,X){const Ee=this.d.get(z);if(Ee)return Ee.createRun(ee);const De=I.fromPublic(W,N,z,X),Pe=$(z);this.f.$startedExtensionTestRun({controllerId:W,continuous:!!z.continuous,profile:Pe&&{group:B[Pe.kind],id:Pe.profileId},exclude:z.exclude?.map(ue=>c.$GI.fromExtHostTestItem(ue,N.root.id).toString())??[],id:De.id,include:z.include?.map(ue=>c.$GI.fromExtHostTestItem(ue,N.root.id).toString())??[N.root.id],persist:X});const Z=this.g(z,De,j);return A.Event.once(Z.onEnd)(()=>{this.f.$finishedExtensionTestRun(De.id),Z.dispose()}),Z.createRun(ee)}g(j,W,N,z){const ee=new o(W,this.f,N,z);return this.d.set(j,ee),A.Event.once(ee.onEnd)(()=>this.d.delete(j)),ee}}e.$scc=y;const $=V=>{if(V.profile){if(!(V.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class I{static fromPublic(j,W,N,z){return new I(j,(0,u.$3f)(),N.include?.map(ee=>c.$GI.fromExtHostTestItem(ee,j).toString())??[j],N.exclude?.map(ee=>c.$GI.fromExtHostTestItem(ee,j).toString())??[],z,W)}static fromInternal(j,W){return new I(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,W)}constructor(j,W,N,z,ee,X){this.controllerId=j,this.id=W,this.isPersisted=ee,this.colllection=X,this.d=N.map(Ee=>Ee+"\0"),this.f=z.map(Ee=>Ee+"\0")}isIncluded(j){const W=c.$GI.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const N of this.f)if(W===N||W.startsWith(N))return!1;for(const N of this.d)if(W===N||W.startsWith(N))return!0;return!1}}e.$tcc=I;class E{set coverageProvider(j){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");j&&(this.d=j,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(j,W,N){this.g=j,this.h=W,this.j=N}async provideFileCoverage(j){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(j))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(W){throw this.f=void 0,W}}async resolveFileCoverage(j,W){const N=await this.f;let z=N?.[j];return!this.d||!N||!z?[]:(z.detailedCoverage||(z=N[j]=await this.d.resolveFileCoverage?.(z,W)??z),z.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class r{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.d.add(j)}update(j){Object.assign(j.revived,t.TestItem.toPlain(j.item)),this.d.has(j)||this.f.add(j)}remove(j){if(this.d.has(j)){this.d.delete(j);return}this.f.delete(j);const W=c.$GI.parentId(j.item.extId);if(W&&this.h.has(W.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{d:j,f:W,g:N}=this;return{get added(){return[...j].map(z=>z.revived)},get updated(){return[...W].map(z=>z.revived)},get removed(){return[...N].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends D.$NI{constructor(){super(...arguments),this.s=new A.$ed,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}q(j,W){return{...j,revived:t.TestItem.toPlain(j.item),depth:W?W.depth+1:0,children:new Set}}p(){return new r(this.s)}}class v{constructor(j){this.f=j}checkout(){this.d||(this.d=this.g());const j=this.d;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(W=>W.revived)},dispose:(0,l.$bb)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(j){return this.d?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.d?.tests.apply(j)}g(){const j=new d;return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}class R{#e;#t;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(j){j!==this.h&&(this.h=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.g}set isDefault(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?t.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.d}set configureHandler(j){j!==this.d&&(this.d=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}constructor(j,W,N,z,ee,X,Ee,De=!1,Pe=void 0,Z=!1){this.controllerId=N,this.profileId=z,this.f=ee,this.kind=X,this.runHandler=Ee,this.g=De,this._tag=Pe,this.h=Z,this.#e=j,this.#t=W,W.set(z,this);const ue=B[X];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);this.#e.$publishTestRunProfile({profileId:z,controllerId:N,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:ue,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:Z})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$ucc=R;const B={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[253],Re([1,0,18,9,5,3,106,8,7]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class f{constructor(k,u){this.i=u,this.a=new C.$ed({onListenerError:T.$Z}),this.b=new C.$ed({onListenerError:T.$Z}),this.c=new C.$ed({onListenerError:T.$Z}),this.d=new C.$ed({onListenerError:T.$Z}),this.f=new C.$ed({onListenerError:T.$Z}),this.g=new C.$ed({onListenerError:T.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(L.$TJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const u=this.i.allEditors();return k?u:u.map(p=>p.value)}async showTextDocument(k,u,p){let m;typeof u=="number"?m={position:l.ViewColumn.from(u),preserveFocus:p}:typeof u=="object"?m={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?l.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:m={preserveFocus:!1};const h=await this.h.$tryShowTextDocument(k.uri,m),t=h&&this.i.getEditor(h);if(t)return t.value;throw h?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,u){return new A.$3L(this.h,k,u).value}$acceptEditorPropertiesChanged(k,u){const p=this.i.getEditor(k);if(!p)throw new Error("unknown text editor");if(u.options&&p._acceptOptions(u.options),u.selections){const m=u.selections.selections.map(l.Selection.to);p._acceptSelections(m)}if(u.visibleRanges){const m=w.$Eb(u.visibleRanges.map(l.Range.to));p._acceptVisibleRanges(m)}if(u.options&&this.b.fire({textEditor:p.value,options:{...u.options,lineNumbers:l.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const m=S.TextEditorSelectionChangeKind.fromValue(u.selections.source),h=u.selections.selections.map(l.Selection.to);this.a.fire({textEditor:p.value,selections:h,kind:m})}if(u.visibleRanges){const m=w.$Eb(u.visibleRanges.map(l.Range.to));this.c.fire({textEditor:p.value,visibleRanges:m})}}$acceptEditorPositionData(k){for(const u in k){const p=this.i.getEditor(u);if(!p)throw new Error("Unknown text editor");const m=l.ViewColumn.to(k[u]);p.value.viewColumn!==m&&(p._acceptViewColumn(m),this.d.fire({textEditor:p.value,viewColumn:m}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$Jbc=f}),define(Ae[254],Re([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0,e.$lcc=(0,T.$Ah)("IExtHostTimeline");class P{constructor(p,m){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$TJ.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(h,t)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&S.$Ul.equals(t,this.b.get(h.source)?.extension)){const i=h.uri===void 0?void 0:w.URI.revive(h.uri);return this.c.get(h.source)?.get(k(i))?.get(h.handle)}else return;return h}})}async $getTimeline(p,m,h,t){return this.b.get(p)?.provider.provideTimeline(w.URI.revive(m),h,t)}registerTimelineProvider(p,m,h,t){const i=new L.$ic,c=this.d(m.id,t,i).bind(this);let g;m.onDidChange&&(g=m.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:m.id}),this));const D=this.c;return this.f({...m,scheme:p,onDidChange:void 0,async provideTimeline(b,n,a){n?.resetCache&&(i.clear(),D.get(m.id)?.clear());const s=await m.provideTimeline(b,n,a);if(s==null)return;const o=c(b,n);return{...s,source:m.id,items:s.items.map(o)}},dispose(){for(const b of D.values())b.get(m.id)?.clear();g?.dispose(),i.dispose()}},h)}d(p,m,h){return(t,i)=>{let c;if(i?.cacheResults){let g=this.c.get(p);g===void 0&&(g=new Map,this.c.set(p,g));const D=k(t);c=g.get(D),c===void 0&&(c=new Map,g.set(D,c))}return g=>{const{iconPath:D,...b}=g,n=`${p}|${g.id??g.timestamp}`;c?.set(n,g);let a,s,o;g.iconPath&&(D instanceof A.$QK?o={id:D.id,color:D.color}:w.URI.isUri(D)?(a=D,s=D):{light:a,dark:s}=D);let y;return A.$kK.isMarkdownString(b.tooltip)?y=l.MarkdownString.from(b.tooltip):(0,f.$if)(b.tooltip)?y=b.tooltip:A.$kK.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=l.MarkdownString.from(b.detail)):(0,f.$if)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=b.detail),{...b,id:b.id??void 0,handle:n,source:p,command:g.command?m.toInternal(g.command,h):void 0,icon:a,iconDark:s,themeIcon:o,tooltip:y,accessibilityInformation:g.accessibilityInformation}}}}f(p,m){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:m}),(0,L.$hc)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$mcc=P;function k(u){return u?.toString()}}),define(Ae[86],Re([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsb=e.$csb=e.TunnelDtoConverter=void 0;class p extends S.$3z{}var m;(function(t){function i(g){return{remoteAddress:g.remoteAddress,localAddress:g.localAddress,public:!!g.public,privacy:g.privacy??(g.public?S.TunnelPrivacyId.Public:S.TunnelPrivacyId.Private),protocol:g.protocol}}t.fromApiTunnel=i;function c(g){return{remoteAddress:{host:g.tunnelRemoteHost,port:g.tunnelRemotePort},localAddress:g.localAddress,public:g.privacy!==S.TunnelPrivacyId.ConstantPrivate&&g.privacy!==S.TunnelPrivacyId.ConstantPrivate,privacy:g.privacy,protocol:g.protocol}}t.fromServiceTunnel=c})(m||(e.TunnelDtoConverter=m={})),e.$csb=(0,A.$Ah)("IExtHostTunnelService");let h=class extends C.$jc{constructor(i,c,g){super(),this.s=g,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$ed,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$TJ.MainThreadTunnelService)}async openTunnel(i,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const g=await this.a.$openTunnel(c,i.displayName);if(g){const D=new p(g.remoteAddress,g.localAddress,()=>this.a.$closeTunnel(g.remoteAddress));return this.B(D),D}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,c){const g=this.u();return this.r.set(g,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,g),new u.$VJ(()=>{this.r.delete(g),this.a.$unregisterPortsAttributesProvider(g)})}async $providePortAttributes(i,c,g,D,b){const n=[];for(const s of i){const o=this.r.get(s);if(!o)return[];n.push(...await Promise.all(c.map(async y=>{let $;try{$=await o.provider.providePortAttributes({port:y,pid:g,commandLine:D},b)}catch{$=await o.provider.providePortAttributes(y,g,D,b)}return{providedAttributes:$,port:y}})))}const a=n.filter(s=>!!s.providedAttributes);return a.length>0?a.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(D,b)=>await i.provideTunnel(D,b,new w.$od().token)??void 0;const g=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(g),Promise.resolve((0,C.$hc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const g=i.tunnelFactory??(c?this.w(c):void 0);if(g){this.b=g;let D=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&D.length===0&&(D=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const b=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:D}:void 0;this.a.$setTunnelProvider(b)}}else this.b=void 0;return(0,C.$hc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const g=this.g.get(i.host);g.has(i.port)&&(c&&g.get(i.port).disposeListener.dispose(),await g.get(i.port).tunnel.dispose(),g.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const g=this.b(i,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),g!==void 0){const D=await g;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),D===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const b=this.B(D.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(D.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:D,disposeListener:b}),m.fromApiTunnel(D)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(g){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),g instanceof Error)return g.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(D=>this.f(D.host,D.port,D.detail??""))),g=i.filter((D,b)=>c[b]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(D=>D.port).join(", ")} to ${g.map(D=>D.port).join(", ")}`),g}};e.$dsb=h,e.$dsb=h=Ke([Ve(0,k.$VL),Ve(1,P.$_L),Ve(2,l.$4i)],h)}),define(Ae[255],Re([1,0,6,12,2,3]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(S){this.c=new Map,this.b=S.getProxy(L.$TJ.MainThreadUriOpeners)}registerExternalUriOpener(S,f,P,k){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const u=k.schemes.find(p=>!A.a.has(p));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(f,P),this.b.$registerUriOpener(f,k.schemes,S,k.label),(0,w.$hc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(S,f,P){const k=this.c.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const u=C.URI.revive(f);return k.canOpenExternalUri(u,P)}async $openUri(S,f,P){const k=this.c.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(C.URI.revive(f.resolvedUri),{sourceUri:C.URI.revive(f.sourceUri)},P)}}e.$vcc=A}),define(Ae[256],Re([1,0,3,2,6,9,20]),function(be,e,w,T,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=void 0;class l{static{this.a=0}constructor(f){this.c=new A.$Vl,this.d=new Map,this.b=f.getProxy(w.$TJ.MainThreadUrls)}registerUriHandler(f,P){const k=f.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const u=l.a++;return this.c.add(k),this.d.set(u,P),this.b.$registerUriHandler(u,k,f.displayName||f.name),(0,C.$hc)(()=>{this.c.delete(k),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(f,P){const k=this.d.get(f);if(!k)return Promise.resolve(void 0);try{k.handleUri(T.URI.revive(P))}catch(u){(0,L.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(f){return T.URI.revive(await this.b.$createAppUri(f))}}e.$Lbc=l}),define(Ae[63],Re([1,0,5,6,12,24,2,170,192,77,3]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=e.$Obc=e.$Nbc=e.$Mbc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(D,b,n,a,s,o,y){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$ed,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$ed,this._onDidDispose=this.#h.event,this.#e=D,this.#t=b,this.#r=n,this.#l=a,this.#u=s,this.#n=o,this.#c=u(o),this.#d=p(o),this.#i=y}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(D){return this.#a=!0,(0,f.$Kob)(D,this.#l)}get cspSource(){const D=this.#n.extensionLocation;if(D.scheme===C.Schemas.https||D.scheme===C.Schemas.http){let b=D.toString();return b.endsWith("/")||(b+="/"),b+" "+f.$Job}return f.$Job}get html(){return this.a(),this.#s}set html(D){this.a(),this.#s!==D&&(this.#s=D,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(D)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(D)))}get options(){return this.a(),this.#r}set options(D){this.a(),L.$Ym(this.#r,D)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,D)),this.#r=D}async postMessage(D){if(this.#o)return!1;const b=(0,S.$Xbb)(D,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,b.message,...b.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(D){if(!this.#d)return D;const b=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return D.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,s,o,y,$,I)=>{const E=A.URI.from({scheme:y||"file",path:decodeURIComponent($)}),r=(0,f.$Kob)(E,{isRemote:b,authority:n}).toString();return`${s}${r}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,s,o,y,$,I)=>{const E=A.URI.from({scheme:y||"file",path:decodeURIComponent($)}),r=(0,f.$Kob)(E,{isRemote:b,authority:n}).toString();return`${s}${r}${I}`})}}e.$Mbc=k;function u(g){try{const D=(0,l.$Co)((0,l.$Bo)(g.engines.vscode));return!!D&&D.majorBase>=1&&D.minorBase>=57}catch{return!1}}e.$Nbc=u;function p(g){try{const D=(0,l.$Co)((0,l.$Bo)(g.engines.vscode));return D?D.majorBase<1||D.majorBase===1&&D.minorBase<60:!1}catch{return!1}}class m extends T.$jc{constructor(D,b,n,a,s){super(),this.c=b,this.f=n,this.g=a,this.h=s,this.b=new Map,this.a=D.getProxy(P.$TJ.MainThreadWebviews)}dispose(){super.dispose();for(const D of this.b.values())D.dispose();this.b.clear()}$onMessage(D,b,n){const a=this.j(D);if(a){const{message:s}=(0,S.$Ybb)(b,n.value);a._onMessageEmitter.fire(s)}}$onMissingCsp(D,b){this.g.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(D,b,n){const a=new k(D,this.a,i(b),this.c,this.f,n,this.h);this.b.set(D,a);const s=a._onDidDispose(()=>{s.dispose(),this.deleteWebview(D)});return a}deleteWebview(D){this.b.delete(D)}j(D){return this.b.get(D)}}e.$Obc=m;function h(g){return{id:g.identifier,location:g.extensionLocation}}e.$Pbc=h;function t(g,D,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||c(g,D)}}e.$Qbc=t;function i(g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots?.map(D=>A.URI.from(D))}}function c(g,D){return[...(D?.getWorkspaceFolders()||[]).map(b=>b.uri),g.extensionLocation]}}),define(Ae[257],Re([1,0,21,93,6,12,23,2,8,63,54,3,7]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class p{constructor(a,s){this.document=a,this.b=s,this.a=1,this.c=new P.$Iac("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,s){await this.f(a).undo(),s||this.disposeBackup()}async redo(a,s){await this.f(a).redo(),s||this.disposeBackup()}disposeEdits(a){for(const s of a)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=b(this.document.uri)+this.a++;return(0,A.$hg)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const s=this.c.get(a,0);if(!s)throw new Error("No edit found");return s}}class m{constructor(){this.a=new Map}get(a,s){return this.a.get(this.b(a,s))}add(a,s,o){const y=this.b(a,s.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${a} resource:${s.uri}`);const $=new p(s,o);return this.a.set(y,$),$}delete(a,s){const o=this.b(a,s.uri);this.a.delete(o)}b(a,s){return`${a}@@@${s}`}}var h;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(h||(h={}));class t{constructor(){this.a=new Map}addTextProvider(a,s,o){return this.b(0,a,s,o)}addCustomProvider(a,s,o){return this.b(1,a,s,o)}get(a){return this.a.get(a)}b(a,s,o,y){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:a,extension:o,provider:y}),new u.$VJ(()=>this.a.delete(s))}}class i{constructor(a,s,o,y,$){this.d=s,this.f=o,this.g=y,this.h=$,this.b=new t,this.c=new m,this.a=a.getProxy(k.$TJ.MainThreadCustomEditors)}registerCustomEditorProvider(a,s,o,y){const $=new C.$ic;return g(o)?($.add(this.b.addTextProvider(s,a,o)),this.a.$registerTextEditorProvider((0,f.$Pbc)(a),s,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,f.$Nbc)(a))):($.add(this.b.addCustomProvider(s,a,o)),c(o)&&$.add(o.onDidChangeCustomDocument(I=>{const E=this.i(s,I.document.uri);if(D(I)){const r=E.addEdit(I);this.a.$onDidEdit(I.document.uri,s,r,I.label)}else this.a.$onContentChange(I.document.uri,s)})),this.a.$registerCustomEditorProvider((0,f.$Pbc)(a),s,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,f.$Nbc)(a))),u.$VJ.from($,new u.$VJ(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(a,s,o,y,$){const I=this.b.get(s);if(!I)throw new Error(`No provider found for '${s}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${s}'`);const E=l.URI.revive(a),r=await I.provider.openCustomDocument(E,{backupId:o,untitledDocumentData:y?.buffer},$);let d;return c(I.provider)&&this.f&&(d=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(s,r,d),{editable:c(I.provider)}}async $disposeCustomDocument(a,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const y=l.URI.revive(a),{document:$}=this.i(s,y);this.c.delete(s,$),$.dispose()}async $resolveCustomEditor(a,s,o,y,$,I){const E=this.b.get(o);if(!E)throw new Error(`No provider found for '${o}'`);const r=S.ViewColumn.to($),d=this.g.createNewWebview(s,y.contentOptions,E.extension),v=this.h.createNewWebviewPanel(s,o,y.title,r,y.options,d,y.active),R=l.URI.revive(a);switch(E.type){case 1:{const{document:B}=this.i(o,R);return E.provider.resolveCustomEditor(B,v,I)}case 0:{const B=this.d.getDocument(R);return E.provider.resolveCustomTextEditor(B,v,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,s,o){this.i(s,a).disposeEdits(o)}async $onMoveCustomEditor(a,s,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const $=this.h.getWebviewPanel(a);if(!$)throw new Error("No webview found");const I=l.URI.revive(s),E=this.d.getDocument(I);await y.provider.moveCustomTextEditor(E,$,w.CancellationToken.None)}async $undo(a,s,o,y){return this.i(s,a).undo(o,y)}async $redo(a,s,o,y){return this.i(s,a).redo(o,y)}async $revert(a,s,o){const y=this.i(s,a);await this.j(s).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(a,s,o){const y=this.i(s,a);await this.j(s).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(a,s,o,y){const $=this.i(s,a);return this.j(s).saveCustomDocumentAs($.document,l.URI.revive(o),y)}async $backup(a,s,o){const y=this.i(s,a),I=await this.j(s).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(I),I.id}i(a,s){const o=this.c.get(a,l.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(a){const o=this.b.get(a)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$pcc=i;function c(n){return!!n.onDidChangeCustomDocument}function g(n){return typeof n.resolveCustomTextEditor=="function"}function D(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function b(n){const a=n.scheme===L.Schemas.file||n.scheme===L.Schemas.untitled?n.fsPath:n.toString();return(0,T.$oi)(a)+""}}),define(Ae[258],Re([1,0,5,6,2,36,8,63,3,7]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class P extends T.$jc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(m,h,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$ed),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$ed),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=h,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(m){this.c(),this.#n!==m&&(this.#n=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#s}set iconPath(m){this.c(),this.#s!==m&&(this.#s=m,this.#t.$setIconPath(this.#e,C.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(m){this.#c||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#a=m.active,this.#o=m.visible,this.#r=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:A.ViewColumn.from(m),preserveFocus:!!h})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends T.$jc{static c(){return(0,L.$3f)()}constructor(m,h,t){super(),this.j=h,this.m=t,this.g=new Map,this.h=new Map,this.f=m.getProxy(S.$TJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,h,t,i,c={}){const g=typeof i=="object"?i.viewColumn:i,D={viewColumn:A.ViewColumn.from(g),preserveFocus:typeof i=="object"&&!!i.preserveFocus},b=(0,l.$Nbc)(m),n=k.c();this.f.$createWebviewPanel((0,l.$Pbc)(m),n,h,{title:t,panelOptions:u(c),webviewOptions:(0,l.$Qbc)(m,this.m,c),serializeBuffersForPostMessage:b},D);const a=this.j.createNewWebview(n,c,m);return this.createNewWebviewPanel(n,h,t,g,c,a,!0)}$onDidChangeWebviewPanelViewStates(m){const h=Object.keys(m);h.sort((t,i)=>{const c=m[t],g=m[i];return c.active?1:g.active?-1:+c.visible-+g.visible});for(const t of h){const i=this.getWebviewPanel(t);if(!i)continue;const c=m[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,h,t){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:t,extension:m}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,l.$Nbc)(m)}),new f.$VJ(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(m,h,t,i){const c=this.h.get(h);if(!c)throw new Error(`No serializer found for '${h}'`);const{serializer:g,extension:D}=c,b=this.j.createNewWebview(m,t.webviewOptions,D),n=this.createNewWebviewPanel(m,h,t.title,i,t.panelOptions,b,t.active);await g.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(m,h,t,i,c,g,D){const b=new P(m,this.f,g,{viewType:h,title:t,viewColumn:i,panelOptions:c,active:D});return this.g.set(m,b),b}getWebviewPanel(m){return this.g.get(m)}}e.$occ=k;function u(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ae[259],Re([1,0,5,6,63,8,3,7]),function(be,e,w,T,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class S extends T.$jc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,u,p,m,h,t){super(),this.#u=!1,this.#a=this.B(new w.$ed),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$ed),this.onDidDispose=this.#c.event,this.#i=p,this.#s=m,this.#e=k,this.#t=u,this.#l=h,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class f{constructor(k,u){this.d=u,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$TJ.MainThreadWebviewViews)}registerWebviewViewProvider(k,u,p,m){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,C.$Pbc)(k),u,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Nbc)(k)}),new l.$VJ(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(k,u,p,m,h){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:c}=t,g=this.d.createNewWebview(k,{},c),D=new S(k,this.a,u,p,g,!0);this.c.set(k,D),await i.resolveWebviewView(D,{state:m},h)}async $onDidChangeWebviewViewVisibility(k,u){this.e(k)._setVisible(u)}async $disposeWebviewView(k){const u=this.e(k);this.c.delete(k),u.dispose(),this.d.deleteWebview(k)}e(k){const u=this.c.get(k);if(!u)throw new Error("No webview found");return u}}e.$ncc=f}),define(Ae[109],Re([1,0,5,3,2,12,15,4,17,26]),function(be,e,w,T,C,L,A,l,S,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=e.$Rbc=void 0;let k=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(p){const m=this.d;return{get focused(){return m.focused},get active(){return(0,f.$NF)(p,"windowActivity"),m.active}}}constructor(p){this.c=new w.$ed,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=p.getProxy(T.$TJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:h})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,m){m!==this.d[p]&&(this.d={...this.d,[p]:m},this.c.fire(this.d))}openUri(p,m){let h;if(typeof p=="string"){h=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$le)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,h,m)}async asExternalUri(p,m){if((0,A.$le)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this.b.$asExternalUri(p,m);return C.URI.from(h)}};e.$Rbc=k,e.$Rbc=k=P=Ke([Ve(0,S.$VL)],k),e.$Sbc=(0,l.$Ah)("IExtHostWindow")}),define(Ae[260],Re([1,0,227,27,17]),function(be,e,w,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;let L=class extends w.$Qcc{constructor(l,S){super(l,S)}f(l,S,f){S.apply(console,f)}};e.$Xec=L,e.$Xec=L=Ke([Ve(0,C.$VL),Ve(1,T.$_L)],L)}),define(Ae[261],Re([1,0,13,25,21,9,5,6,133,216,46]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$l3b=e.ResponsiveState=e.RequestInitiator=e.$k3b=e.$j3b=void 0;function u(v,R){try{return JSON.stringify(v,R)}catch{return"null"}}const p="$$ref$$",m={[p]:-1};class h{constructor(R,B){this.jsonString=R,this.referencedBuffers=B}}function t(v,R=null,B=!1){const V=[];return{jsonString:(B?u:JSON.stringify)(v,(W,N)=>{if(typeof N>"u")return m;if(typeof N=="object"){if(N instanceof T.$Ed){const z=V.push(N)-1;return{[p]:z}}if(R)return R(W,N)}return N}),referencedBuffers:V}}e.$j3b=t;function i(v,R,B){return JSON.parse(v,(V,j)=>{if(j){const W=j[p];if(typeof W=="number")return R[W];if(B&&j.$mid===1)return B.transformIncoming(j)}return j})}e.$k3b=i;function c(v,R){return JSON.stringify(v,R)}function g(v){return v?(R,B)=>B&&B.$mid===1?v.transformOutgoing(B):B:null}var D;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));var b;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(b||(e.ResponsiveState=b={}));const n=()=>{},a=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends l.$jc{static{k=a}static{this.a=3*1e3}constructor(R,B=null,V=null){super(),this[k]=!0,this.b=this.B(new A.$ed),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=B,this.g=V,this.h=g(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,W=P.$0z.count;j<W;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$Rg(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(R=>{const B=this.w[R];delete this.w[R],B.resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(R){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(R){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(R){this.y!==R&&(this.y=R,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(R){return this.g?(0,S.$Dm)(R,this.g):R}getProxy(R){const{nid:B,sid:V}=R;return this.s[B]||(this.s[B]=this.J(B,V)),this.s[B]}J(R,B){const V={get:(j,W)=>(typeof W=="string"&&!j[W]&&W.charCodeAt(0)===36&&(j[W]=(...N)=>this.U(R,W,N)),W===s?B:j[W])};return new Proxy(Object.create(null),V)}set(R,B){return this.m[R.nid]=B,B}assertRegistered(R){for(let B=0,V=R.length;B<V;B++){const j=R[B];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(R){if(this.j)return;const B=R.byteLength,V=$.read(R,0),j=V.readUInt8(),W=V.readUInt32();switch(j){case 1:case 2:{let{rpcId:N,method:z,args:ee}=E.deserializeRequestJSONArgs(V);this.g&&(ee=(0,S.$Dm)(ee,this.g)),this.M(B,W,N,z,ee,j===2);break}case 3:case 4:{let{rpcId:N,method:z,args:ee}=E.deserializeRequestMixedArgs(V);this.g&&(ee=(0,S.$Dm)(ee,this.g)),this.M(B,W,N,z,ee,j===4);break}case 5:{this.f?.logIncoming(B,W,0,"ack"),this.G(W);break}case 6:{this.N(B,W);break}case 7:{this.O(B,W,void 0);break}case 9:{let N=E.deserializeReplyOKJSON(V);this.g&&(N=(0,S.$Dm)(N,this.g)),this.O(B,W,N);break}case 10:{const N=E.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(B,W,N);break}case 8:{const N=E.deserializeReplyOKVSBuffer(V);this.O(B,W,N);break}case 11:{let N=E.deserializeReplyErrError(V);this.g&&(N=(0,S.$Dm)(N,this.g)),this.P(B,W,N);break}case 12:{this.P(B,W,void 0);break}default:console.error("received unexpected message"),console.error(R)}}M(R,B,V,j,W,N){this.f?.logIncoming(R,B,1,`receiveRequest ${(0,P.$_z)(V)}.${j}(`,W);const z=String(B);let ee,X;if(N){const De=new C.$od;W.push(De.token),ee=this.Q(V,j,W),X=()=>De.cancel()}else ee=this.Q(V,j,W),X=n;this.u[z]=X;const Ee=E.serializeAcknowledged(B);this.f?.logOutgoing(Ee.byteLength,B,1,"ack"),this.c.send(Ee),ee.then(De=>{delete this.u[z];const Pe=E.serializeReplyOK(B,De,this.h);this.f?.logOutgoing(Pe.byteLength,B,1,"reply:",De),this.c.send(Pe)},De=>{delete this.u[z];const Pe=E.serializeReplyErr(B,De);this.f?.logOutgoing(Pe.byteLength,B,1,"replyErr:",De),this.c.send(Pe)})}N(R,B){this.f?.logIncoming(R,B,1,"receiveCancel");const V=String(B);this.u[V]?.()}O(R,B,V){this.f?.logIncoming(R,B,0,"receiveReply:",V);const j=String(B);if(!this.w.hasOwnProperty(j))return;const W=this.w[j];delete this.w[j],W.resolveOk(V)}P(R,B,V){this.f?.logIncoming(R,B,0,"receiveReplyErr:",V);const j=String(B);if(!this.w.hasOwnProperty(j))return;const W=this.w[j];delete this.w[j];let N;V&&(V.$isError?(N=new Error,N.name=V.name,N.message=V.message,N.stack=V.stack):N=V),W.resolveErr(N)}Q(R,B,V){try{return Promise.resolve(this.S(R,B,V))}catch(j){return Promise.reject(j)}}S(R,B,V){const j=this.m[R];if(!j)throw new Error("Unknown actor "+(0,P.$_z)(R));const W=j[B];if(typeof W!="function")throw new Error("Unknown method "+B+" on actor "+(0,P.$_z)(R));return W.apply(j,V)}U(R,B,V){if(this.j)return new f.$i3b;let j=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(j=V.pop()),j&&j.isCancellationRequested)return Promise.reject(L.$4());const W=E.serializeRequestArguments(V,this.h),N=++this.t,z=String(N),ee=new f.$h3b,X=new l.$ic;j&&X.add(j.onCancellationRequested(()=>{const De=E.serializeCancel(N);this.f?.logOutgoing(De.byteLength,N,0,"cancel"),this.c.send(E.serializeCancel(N))})),this.w[z]=new y(ee,X),this.F(N);const Ee=E.serializeRequest(N,R,B,W,!!j);return this.f?.logOutgoing(Ee.byteLength,N,0,`request: ${(0,P.$_z)(R)}.${B}(`,V),this.c.send(Ee),ee}}e.$l3b=o;class y{constructor(R,B){this.a=R,this.b=B}resolveOk(R){this.a.resolveOk(R),this.b.dispose()}resolveErr(R){this.a.resolveErr(R),this.b.dispose()}}class ${static alloc(R,B,V){const j=new $(T.$Ed.alloc(V+1+4),0);return j.writeUInt8(R),j.writeUInt32(B),j}static read(R,B){return new $(R,B)}get buffer(){return this.a}constructor(R,B){this.a=R,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+R);return this.b+=R,B}static sizeMixedArray(R){let B=0;B+=1;for(let V=0,j=R.length;V<j;V++){const W=R[V];switch(B+=1,W.type){case 1:B+=this.sizeLongString(W.value);break;case 2:B+=this.sizeVSBuffer(W.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(W.value);for(let N=0;N<W.buffers.length;++N)B+=this.sizeVSBuffer(W.buffers[N]);break;case 4:break}}return B}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let B=0,V=R.length;B<V;B++){const j=R[B];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let W=0;W<j.buffers.length;++W)this.writeBuffer(j.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const B=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:B[V]=this.readLongString();break;case 2:B[V]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),N=this.readLongString(),z=[];for(let ee=0;ee<W;++ee)z.push(this.readVSBuffer());B[V]=new P.$aA(i(N,z,null));break}case 4:B[V]=void 0;break}return B}}var I;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(I||(I={}));class E{static a(R){for(let B=0,V=R.length;B<V;B++)if(R[B]instanceof T.$Ed||R[B]instanceof P.$aA||typeof R[B]>"u")return!0;return!1}static serializeRequestArguments(R,B){if(this.a(R)){const V=[];for(let j=0,W=R.length;j<W;j++){const N=R[j];if(N instanceof T.$Ed)V[j]={type:2,value:N};else if(typeof N>"u")V[j]={type:4};else if(N instanceof P.$aA){const{jsonString:z,referencedBuffers:ee}=t(N.value,B);V[j]={type:3,value:T.$Ed.fromString(z),buffers:ee}}else V[j]={type:1,value:T.$Ed.fromString(c(N,B))}}return{type:1,args:V}}return{type:0,args:c(R,B)}}static serializeRequest(R,B,V,j,W){switch(j.type){case 0:return this.b(R,B,V,j.args,W);case 1:return this.c(R,B,V,j.args,W)}}static b(R,B,V,j,W){const N=T.$Ed.fromString(V),z=T.$Ed.fromString(j);let ee=0;ee+=$.sizeUInt8(),ee+=$.sizeShortString(N),ee+=$.sizeLongString(z);const X=$.alloc(W?2:1,R,ee);return X.writeUInt8(B),X.writeShortString(N),X.writeLongString(z),X.buffer}static deserializeRequestJSONArgs(R){const B=R.readUInt8(),V=R.readShortString(),j=R.readLongString();return{rpcId:B,method:V,args:JSON.parse(j)}}static c(R,B,V,j,W){const N=T.$Ed.fromString(V);let z=0;z+=$.sizeUInt8(),z+=$.sizeShortString(N),z+=$.sizeMixedArray(j);const ee=$.alloc(W?4:3,R,z);return ee.writeUInt8(B),ee.writeShortString(N),ee.writeMixedArray(j),ee.buffer}static deserializeRequestMixedArgs(R){const B=R.readUInt8(),V=R.readShortString(),j=R.readMixedArray(),W=new Array(j.length);for(let N=0,z=j.length;N<z;N++){const ee=j[N];typeof ee=="string"?W[N]=JSON.parse(ee):W[N]=ee}return{rpcId:B,method:V,args:W}}static serializeAcknowledged(R){return $.alloc(5,R,0).buffer}static serializeCancel(R){return $.alloc(6,R,0).buffer}static serializeReplyOK(R,B,V){if(typeof B>"u")return this.d(R);if(B instanceof T.$Ed)return this.e(R,B);if(B instanceof P.$aA){const{jsonString:j,referencedBuffers:W}=t(B.value,V,!0);return this.g(R,j,W)}else return this.f(R,u(B,V))}static d(R){return $.alloc(7,R,0).buffer}static e(R,B){let V=0;V+=$.sizeVSBuffer(B);const j=$.alloc(8,R,V);return j.writeVSBuffer(B),j.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,B){const V=T.$Ed.fromString(B);let j=0;j+=$.sizeLongString(V);const W=$.alloc(9,R,j);return W.writeLongString(V),W.buffer}static g(R,B,V){const j=T.$Ed.fromString(B);let W=0;W+=$.sizeUInt32,W+=$.sizeLongString(j);for(const z of V)W+=$.sizeVSBuffer(z);const N=$.alloc(10,R,W);N.writeUInt32(V.length),N.writeLongString(j);for(const z of V)N.writeBuffer(z);return N.buffer}static deserializeReplyOKJSON(R){const B=R.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(R,B){const V=R.readUInt32(),j=R.readLongString(),W=[];for(let N=0;N<V;++N)W.push(R.readVSBuffer());return new P.$aA(i(j,W,B))}static serializeReplyErr(R,B){const V=B?u(L.$1(B),null):void 0;if(typeof V!="string")return this.h(R);const j=T.$Ed.fromString(V);let W=0;W+=$.sizeLongString(j);const N=$.alloc(11,R,W);return N.writeLongString(j),N.buffer}static deserializeReplyErrError(R){const B=R.readLongString();return JSON.parse(B)}static h(R){return $.alloc(12,R,0).buffer}}var r;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var d;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(d||(d={}))}),define(Ae[262],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;const w=function(L){const A=l=>{globalThis.removeEventListener("message",A);const S=l.data;Object.defineProperties(globalThis,{postMessage:{value(f,P){S.postMessage(f,P)}},onmessage:{get(){return S.onmessage},set(f){S.onmessage=f}}}),S.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),S.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(L,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${w})('${A}'))`,f=new Blob([S],{type:"application/javascript"}),P=URL.createObjectURL(f),k=new MessageChannel,u=P,p={type:"_newWorker",id:u,port:k.port2,url:P,options:l};L(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{L({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(m){k.port1.onmessage=m}},onmessageerror:{get(){return k.port1.onmessageerror},set(m){k.port1.onmessageerror=m}}}),k.port1.addEventListener("messageerror",m=>{const h=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(h)}),k.port1.addEventListener("message",m=>{const h=new MessageEvent("message",{data:m.data});this.dispatchEvent(h)}),k.port1.start()}}e.$Zec=T}),define(Ae[263],Re([1,0,5,30,32,4]),function(be,e,w,T,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=e.$9I=e.OutputChannelUpdateMode=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=void 0,e.$XI="text/x-code-output",e.$YI="output",e.$ZI="Log",e.$1I="text/x-code-log-output",e.$2I="log",e.$3I="log",e.$4I="workbench.panel.output",e.$5I=new C.$1i("inOutput",!1),e.$6I=new C.$1i("activeLogOutput",!1),e.$7I=new C.$1i("outputView.scrollLock",!1),e.$8I=(0,L.$Ah)("outputService");var A;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$9I={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new w.$ed,this.onDidRegisterChannel=this.b.event,this.c=new w.$ed,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(P=>f.push(P)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}T.$7m.add(e.$9I.OutputChannels,new l),e.$0I=new C.$1i("activeOutputChannel","")}),define(Ae[110],Re([1,0,3,4,17,20,14,263,61,27,39,130,25,16,38,5,6]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0;class i extends A.$0i{get disposed(){return this.n}constructor(b,n,a,s,o){super(),this.id=b,this.name=n,this.r=a,this.s=s,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,b)}replace(b){const n=this.m;this.info(b),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(b,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof b=="boolean"?b:n))}hide(){this.s.$close(this.id)}g(b,n){this.m+=u.$Ed.fromString(n).byteLength,(0,A.log)(this.r,b,n),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends i{appendLine(b){this.append(b)}}let g=class{constructor(b,n,a,s,o,y){this.i=n,this.j=a,this.k=s,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(w.$TJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[n,a]of this.g)a.visible=n===this.h}createOutputChannel(b,n,a){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,p.$if)(n)?n:void 0;if((0,p.$if)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const $=this.i.environment.extensionLogLevel?.find(([E])=>L.$Ul.equals(a.identifier,E))?.[1];$&&(y=(0,A.$hj)($));const I=s?this.o(b,y,a):this.n(b,o,a);return I.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),s?this.r(b,y??this.m.getLevel(),I):this.q(b,I)}async n(b,n,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(b,o,n,a.identifier.value);return new i($,b,y,this.a,a)}async o(b,n,a){const s=await this.p(a),o=b.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(s,`${o}.log`),$=`${a.identifier.value}.${o}`,I=this.l.createLogger(y,{id:$,name:b,logLevel:n,extensionId:a.identifier.value});return new c($,b,I,this.a,a)}p(b){let n=this.d.get(b.identifier.value);if(!n){const a=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(a)}catch(s){if((0,m.$hk)(s)!==m.FileSystemProviderErrorCode.FileExists)throw s}return a})())}return n}q(b,n){let a=!1;const s=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return b},append(o){s(),n.then(y=>y.append(o))},appendLine(o){s(),n.then(y=>y.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then(y=>y.replace(o))},show(o,y){s(),n.then($=>$.show(o,y))},hide(){s(),n.then(o=>o.hide())},dispose(){a=!0,n.then(o=>o.dispose())}}}r(b,n,a){const s=new t.$ic,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},y=s.add(new h.$ed);function $(I){n=I,y.fire(I)}return a.then(I=>{s.add(I),I.logLevel!==n&&$(I.logLevel),s.add(I.onDidChangeLogLevel(E=>$(E)))}),{...this.q(b,a),get logLevel(){return n},onDidChangeLogLevel:y.event,trace(I,...E){o(),a.then(r=>r.trace(I,...E))},debug(I,...E){o(),a.then(r=>r.debug(I,...E))},info(I,...E){o(),a.then(r=>r.info(I,...E))},warn(I,...E){o(),a.then(r=>r.warn(I,...E))},error(I,...E){o(),a.then(r=>r.error(I,...E))},dispose(){s.dispose()}}}};e.$Bbc=g,e.$Bbc=g=Ke([Ve(0,C.$VL),Ve(1,f.$_L),Ve(2,S.$ebc),Ve(3,P.$Lac),Ve(4,A.$5i),Ve(5,A.$4i)],g),e.$Cbc=(0,T.$Ah)("IExtHostOutputService")}),define(Ae[264],Re([1,0,4,13]),function(be,e,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=void 0,e.$im=(0,w.$Ah)("remoteAgentService"),e.$jm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let L=1/0;for(let l=0;l<this.maxSampleCount;l++){const S=await C.getRoundTripTime();if(S===void 0)return;L=Math.min(L,S/2),await(0,T.$Gg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((l,S)=>l+S,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((l,S)=>l+S,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[265],Re([1,0,42,12,19,22,23,2,4,187,53,209,264]),function(be,e,w,T,C,L,A,l,S,f,P,k,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.$pJ=void 0,e.$pJ=(0,S.$Ah)("pathService");let m=p=class{constructor(t,i,c,g){this.d=t,this.e=i,this.f=c,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const D=await this.e.getEnvironment();return this.c=D?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(g=>this.h(t,g,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===T.Schemas.file||t.scheme===T.Schemas.vscodeRemote?(0,w.$Ff)(c??(0,A.$eg)(t),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return T.Schemas.vscodeRemote;const c=(0,f.$mJ)(i.getWorkspace());if(c)return c;const g=i.getWorkspace().folders[0];if(g)return g.uri.scheme;const D=i.getWorkspace().configuration;return D?D.scheme:T.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$4d:C.$5d)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const g=t.indexOf("/",2);g===-1?(i=t.substring(2),t="/"):(i=t.substring(2,g),t=t.substring(g)||"/")}return l.URI.from({scheme:T.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$qJ=m,e.$qJ=m=p=Ke([Ve(1,u.$im),Ve(2,k.$$I),Ve(3,P.$Jh)],m)}),define(Ae[111],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$_H=e.$$H=void 0;class w{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new w(0,0)}with(A){return new w(0,0)}}e.$$H=w;class T{constructor(A,l,S,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,l),this.end=new w(S,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$_H=T;var C;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,111,13]),function(be,e,w,T,C,L,A,l,S,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.SearchErrorCode=e.$oI=e.$nI=e.SearchSortOrder=e.ViewMode=e.$mI=e.$lI=e.$kI=e.$jI=e.SearchCompletionExitCode=e.$iI=e.$hI=e.$gI=e.QueryType=e.SearchProviderType=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$aI="workbench.view.search",e.$bI="workbench.panel.search",e.$cI="workbench.view.search",e.$dI="search-result",e.$eI="search.exclude";const u="\u27EA ",p=" characters skipped \u27EB",m=(u.length+p.length+5)*2;e.$fI=(0,l.$Ah)("searchService");var h;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(h||(e.SearchProviderType=h={}));var t;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(t||(e.QueryType=t={}));function i(Z){return!!Z.preview}e.$gI=i;function c(Z){return!!Z.resource}e.$hI=c;function g(Z){return!!Z.message}e.$iI=g;var D;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(D||(e.SearchCompletionExitCode=D={}));class b{constructor(ue){this.resource=ue,this.results=[]}}e.$jI=b;class n{constructor(ue,ye,ce,$e){this.ranges=ye,this.webviewIndex=$e;const ie=Array.isArray(ye)?ye:[ye];if(ce&&ce.matchLines===1&&a(ie)){ue=(0,A.$bf)(ue,ce.matchLines);let O="",q=0,le=0;const we=Math.floor(ce.charsPerLine/5),ve=[];for(const me of ie){const ke=Math.max(me.startColumn-we,0),se=me.startColumn+ce.charsPerLine;if(ke>le+we+m){const he=u+(ke-le)+p;O+=he+ue.slice(ke,se),q+=ke-(le+he.length)}else O+=ue.slice(le,se);ve.push(new o(0,me.startColumn-q,me.endColumn-q)),le=se}this.preview={text:O,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const O=Array.isArray(ye)?ye[0].startLineNumber:ye.startLineNumber;this.preview={text:ue,matches:(0,w.$Yb)(ye,q=>new s(q.startLineNumber-O,q.startColumn,q.endLineNumber-O,q.endColumn))}}}}e.$kI=n;function a(Z){const ue=Z[0].startLineNumber;for(const ye of Z)if(ye.startLineNumber!==ue||ye.endLineNumber!==ue)return!1;return!0}class s{constructor(ue,ye,ce,$e){this.startLineNumber=ue,this.startColumn=ye,this.endLineNumber=ce,this.endColumn=$e}}e.$lI=s;class o extends s{constructor(ue,ye,ce){super(ue,ye,ue,ce)}}e.$mI=o;var y;(function(Z){Z.List="list",Z.Tree="tree"})(y||(e.ViewMode=y={}));var $;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function I(Z,ue=!0){const ye=Z&&Z.files&&Z.files.exclude,ce=ue&&Z&&Z.search&&Z.search.exclude;if(!ye&&!ce)return;if(!ye||!ce)return ye||ce;let $e=Object.create(null);return $e=C.$Xm($e,C.$Um(ye)),$e=C.$Xm($e,C.$Um(ce),!0),$e}e.$nI=I;function E(Z,ue){return Z.excludePattern&&T.$pj(Z.excludePattern,ue)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&T.$pj(Z.includePattern,ue)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(ye=>{const ce=ye.folder.fsPath;if(L.$Hf(ue,ce)){const $e=S.$0d(ce,ue);return!ye.includePattern||!!T.$pj(ye.includePattern,$e)}else return!1}):!1:!0}e.$oI=E;var r;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(r||(e.SearchErrorCode=r={}));class d extends Error{constructor(ue,ye){super(ue),this.code=ye}}e.$pI=d;function v(Z){const ue=Z.message;if((0,f.$2)(Z))return new d(ue,r.canceled);try{const ye=JSON.parse(ue);return new d(ye.message,ye.code)}catch{return new d(ue,r.other)}}e.$qI=v;function R(Z){const ue={message:Z.message,code:Z.code};return new Error(JSON.stringify(ue))}e.$rI=R;function B(Z){return Z.type==="error"?!0:Z.type==="success"}e.$sI=B;function V(Z){return Z.type==="success"}e.$tI=V;function j(Z){return!!Z.path}e.$uI=j;function W(Z,ue){const ye=Z.searchPath?Z.searchPath:Z.relativePath;return(0,A.$$e)(ye,ue)}e.$vI=W;class N{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$wI=N;function z(Z,ue){const ye={...Z||{},...ue||{}};return Object.keys(ye).filter(ce=>{const $e=ye[ce];return typeof $e=="boolean"&&$e})}e.$xI=z;class ee{constructor(ue,ye){this.c=null,this.a={...ue.excludePattern||{},...ye.excludePattern||{}},this.b=T.$qj(this.a);let ce=ue.includePattern;ye.includePattern&&(ce?ce={...ce,...ye.includePattern}:ce=ye.includePattern),ce&&(this.c=T.$qj(ce))}matchesExcludesSync(ue,ye,ce){return!!(this.b&&this.b(ue,ye,ce))}includedInQuerySync(ue,ye,ce){return!(this.b&&this.b(ue,ye,ce)||this.c&&!this.c(ue,ye,ce))}includedInQuery(ue,ye,ce){const $e=this.b(ue,ye,ce),ie=()=>this.c?!!this.c(ue,ye,ce):!0;return(0,k.$sg)($e)?$e.then(O=>O?!1:ie()):ie()}hasSiblingExcludeClauses(){return X(this.a)}}e.$yI=ee;function X(Z){for(const ue in Z)if(typeof Z[ue]!="boolean")return!0;return!1}function Ee(Z){if(!Z)return;let ue;return ye=>(ue||(ue=(Z()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),ue.then(ce=>!!ce[ye]))}e.$zI=Ee;function De(Z){if(!Z)return;let ue;return ye=>{if(!ue){const ce=Z();ue=ce?Pe(ce):{}}return!!ue[ye]}}e.$AI=De;function Pe(Z){const ue={};for(const ye of Z)ue[ye]=!0;return ue}}),define(Ae[33],Re([1,0,18,13,21,5,6,48,12,118,23,15,2,159,4,14,176,53,39,27,17,8,7,55,47,3]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b,n,a,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.$Xac=void 0;function y(B,V,j){return new P.$9f(W=>r(W,j)).isEqual(B,V)}function $(B,V,j){return y(B.uri,V.uri,j)?0:(0,k.$Ee)(B.uri.toString(),V.uri.toString())}function I(B,V,j){return B.index!==V.index?B.index<V.index?-1:1:y(B.uri,V.uri,j)?(0,k.$Ee)(B.name,V.name):(0,k.$Ee)(B.uri.toString(),V.uri.toString())}function E(B,V,j,W){const N=B.slice(0).sort((ee,X)=>j(ee,X,W)),z=V.slice(0).sort((ee,X)=>j(ee,X,W));return(0,w.$Bb)(N,z,(ee,X)=>j(ee,X,W))}function r(B,V){const j=V.getCapabilities(B.scheme);return!(j&&j&1024)}class d extends i.$Th{static toExtHostWorkspace(V,j,W,N){if(!V)return{workspace:null,added:[],removed:[]};const{id:z,name:ee,folders:X,configuration:Ee,transient:De,isUntitled:Pe}=V,Z=[],ue=j;j?X.forEach((ie,O)=>{const q=u.URI.revive(ie.uri),le=d.o(W||j,q,N);le?(le.name=ie.name,le.index=ie.index,Z.push(le)):Z.push({uri:q,name:ie.name,index:O})}):Z.push(...X.map(({uri:ie,name:O,index:q})=>({uri:u.URI.revive(ie),name:O,index:q}))),Z.sort((ie,O)=>ie.index<O.index?-1:1);const ye=new d(z,ee,Z,!!De,Ee?u.URI.revive(Ee):null,!!Pe,ie=>r(ie,N)),{added:ce,removed:$e}=E(ue?ue.workspaceFolders:[],ye.workspaceFolders,$,N);return{workspace:ye,added:ce,removed:$e}}static o(V,j,W){for(let N=0;N<V.folders.length;N++){const z=V.workspaceFolders[N];if(y(z.uri,j,W))return z}}constructor(V,j,W,N,z,ee,X){super(V,W.map(Ee=>new i.$Uh(Ee)),N,z,X),this.t=j,this.u=ee,this.q=[],this.s=l.$Gh.forUris(X),W.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,j){return j&&this.s.get(V)&&(V=(0,P.$gg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let v=class{constructor(V,j,W,N,z){this.c=new L.$ed,this.onDidChangeWorkspace=this.c.event,this.g=new L.$ed,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$gd,this.B=new Map,this.h=N,this.s=W,this.t=z,this.j=new f.$Il,this.k=new T.$Eg,this.o=V.getProxy(o.$TJ.MainThreadWorkspace),this.q=V.getProxy(o.$TJ.MainThreadMessageService);const ee=j.workspace;this.l=ee?new d(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,X=>r(X,W)):void 0}$initializeWorkspace(V,j){this.v=j,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:S.Schemas.untitled,path:(0,P.$eg)((0,P.$gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,j,W,...N){const z=[];if(Array.isArray(N)&&N.forEach(Pe=>{u.URI.isUri(Pe.uri)&&!z.some(Z=>y(Z.uri,Pe.uri,this.s))&&z.push({uri:Pe.uri,name:Pe.name||(0,P.$dg)(Pe.uri)})}),this.n||[j,W].some(Pe=>typeof Pe!="number"||Pe<0)||W===0&&z.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(j+W>ee.length)return!1;const X=ee.slice(0);X.splice(j,W,...z.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$dg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<X.length;Pe++){const Z=X[Pe];if(X.some((ue,ye)=>ye!==Pe&&y(Z.uri,ue.uri,this.s)))return!1}X.forEach((Pe,Z)=>Pe.index=Z);const{added:Ee,removed:De}=E(ee,X,I,this.s);if(Ee.length===0&&De.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,j,W,z).then(void 0,Z=>{this.n=void 0;const ue={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Pe,Z.toString()),ue,[])})}return this.y(X),!0}getWorkspaceFolder(V,j){if(this.x)return this.x.getWorkspaceFolder(V,j)}async getWorkspaceFolder2(V,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,j)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,j){let W,N="";if(typeof V=="string"?(W=u.URI.file(V),N=V):typeof V<"u"&&(W=V,N=V.fsPath),!W)return N;const z=this.getWorkspaceFolder(W,!0);if(!z)return N;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let ee=(0,P.$jg)(z.uri,W);return j&&z.name&&(ee=`${z.name}/${ee}`),ee}y(V){this.x&&(this.n=d.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:j,added:W,removed:N}=d.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:N}))}findFiles(V,j,W,N,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let ee;if(j===null?ee=!1:j&&(typeof j=="string"?ee=j:ee=j.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:Ee}=R(b.GlobPattern.from(V));return this.o.$startFileSearch(X??null,Ee??null,ee??null,W??null,z).then(De=>Array.isArray(De)?De.map(Pe=>u.URI.revive(Pe)):[])}async findTextInFiles(V,j,W,N,z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),X=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Ee,folder:De}=R(b.GlobPattern.from(j.include)),Pe=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,Z={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:X,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Ee,excludePattern:Pe},ue=!1;if(this.u[ee]=ye=>{if(ue)return;const ce=u.URI.revive(ye.resource);ye.results.forEach($e=>{(0,s.$gI)($e)?W({uri:ce,preview:{text:$e.preview.text,matches:(0,w.$Yb)($e.preview.matches,ie=>new n.$XJ(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$Yb)($e.ranges,ie=>new n.$XJ(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):W({uri:ce,text:$e.text,lineNumber:$e.lineNumber})})},z.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(V,De??null,Z,ee,z);return delete this.u[ee],ye||{}}catch(ye){throw delete this.u[ee],ye}}$handleTextSearchResult(V,j){this.u[j]?.(V)}async save(V){const j=await this.o.$save(V,{saveAs:!1});return u.URI.revive(j)}async saveAs(V){const j=await this.o.$save(V,{saveAs:!0});return u.URI.revive(j)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,j){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,j);const W=this.t.transformOutgoingScheme(V),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,W),(0,A.$hc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(V,j){this.h.info("Getting edit session identifier for workspaceFolder",V);const W=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const N=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!N),!N)return;const z=await N.provideEditSessionIdentity(W,j);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(V,j,W,N){this.h.info("Getting edit session identifier for workspaceFolder",V);const z=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const ee=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!ee),!ee)return;const X=await ee.provideEditSessionIdentityMatch?.(j,W,N);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(V){return(j,W,N)=>{const z=function(X){j.call(W,X)};return z.extension=V,this.A.event(z,void 0,N)}}async $onWillCreateEditSessionIdentity(V,j,W){const N=await this.resolveWorkspaceFolder(u.URI.revive(V));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},j,async(z,ee)=>{const X=Date.now();await Promise.resolve(z),Date.now()-X>W&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(V,j){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,j);const W=this.t.transformOutgoingScheme(V),N=this.z++;return this.o.$registerCanonicalUriProvider(N,W),(0,A.$hc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(V,j,W){const N=this.B.get(V.scheme);if(!N)return;const z=await N.provideCanonicalUri?.(u.URI.revive(V),j,W);if(z)return z}async $provideCanonicalUri(V,j,W){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:j},W)}};e.$Xac=v,e.$Xac=v=Ke([Ve(0,D.$VL),Ve(1,g.$_L),Ve(2,c.$Lac),Ve(3,h.$4i),Ve(4,a.$Vac)],v),e.$Yac=(0,m.$Ah)("IExtHostWorkspace");function R(B){let V,j;return B&&(typeof B=="string"?V=B:(V=B.pattern,j=u.URI.revive(B.baseUri))),{includePattern:V,folder:j}}}),define(Ae[34],Re([1,0,24,5,33,3,7,178,96,16,13,4,17,14,2]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=e.$1ac=e.$Zac=void 0;function h(a,s){if(s){const o=s.split(".");let y=a;for(let $=0;y&&$<o.length;$++)y=y[o[$]];return y}}function t(a){return a instanceof m.URI}function i(a){return a&&a.uri instanceof m.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function g(a){return a&&a.uri instanceof m.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function D(a){if(t(a))return{resource:a};if(i(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(g(a))return{resource:a.uri};if(a===null)return{resource:null}}let b=class{constructor(s,o,y){this.a=s.getProxy(L.$TJ.MainThreadConfiguration),this.c=o,this.b=y,this.d=new P.$Eg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(s,o))}};e.$Zac=b,e.$Zac=b=Ke([Ve(0,u.$VL),Ve(1,C.$Yac),Ve(2,p.$4i)],b);class n{constructor(s,o,y,$){this.a=new T.$ed,this.b=s,this.f=$,this.c=o,this.e=l.$sn.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$sn.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(s,o,y){const $=D(o)||{},I=this.g(s?h(this.e.getValue(void 0,$,this.c.workspace),s):this.e.getValue(void 0,$,this.c.workspace));s&&this.h(s,$,y?.identifier);function E(d){if(d==null)return null;if(typeof d=="boolean")return d?2:5;switch(d){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const r={has(d){return typeof h(I,d)<"u"},get:(d,v)=>{this.h(s?`${s}.${d}`:d,$,y?.identifier);let R=h(I,d);if(typeof R>"u")R=v;else{let B;const V=(j,W)=>{if((0,f.$kf)(j)){let N;const z=()=>{B=B||(0,w.$Um)(I),N=N||h(B,W)};return new Proxy(j,{get:(ee,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return z(),()=>N;if(B)return N=N||h(B,W),N[X];const Ee=ee[X];return typeof X=="string"?V(Ee,`${W}.${X}`):Ee},set:(ee,X,Ee)=>(z(),N&&(N[X]=Ee),!0),deleteProperty:(ee,X)=>(z(),N&&delete N[X],!0),defineProperty:(ee,X,Ee)=>(z(),N&&Object.defineProperty(N,X,Ee),!0)})}return Array.isArray(j)?(0,w.$Um)(j):j};R=V(R,d)}return R},update:(d,v,R,B)=>{d=s?`${s}.${d}`:d;const V=E(R);return v!==void 0?this.b.$updateConfigurationOption(V,d,v,$,B):this.b.$removeConfigurationOption(V,d,$,B)},inspect:d=>{d=s?`${s}.${d}`:d;const v=this.e.inspect(d,$,this.c.workspace);if(v)return{key:d,defaultValue:(0,w.$Um)(v.policy?.value??v.default?.value),globalValue:(0,w.$Um)(v.user?.value??v.application?.value),workspaceValue:(0,w.$Um)(v.workspace?.value),workspaceFolderValue:(0,w.$Um)(v.workspaceFolder?.value),defaultLanguageValue:(0,w.$Um)(v.default?.override),globalLanguageValue:(0,w.$Um)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,w.$Um)(v.workspace?.override),workspaceFolderLanguageValue:(0,w.$Um)(v.workspaceFolder?.override),languageIds:(0,w.$Um)(v.overrideIdentifiers)}}};return typeof I=="object"&&(0,w.$Xm)(r,I,!1),Object.freeze(r)}g(s){const o=y=>(0,f.$kf)(y)?new Proxy(y,{get:($,I)=>o($[I]),set:($,I,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:($,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:($,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(s)}h(s,o,y){const $=S.$jn.test(s)?4:this.d.get(s),I=y?`[${y.value}] `:"";if($===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const y=new l.$un(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:($,I)=>y.affectsConfiguration($,D(I))})}k(s){return s.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$1ac=n,e.$2ac=(0,k.$Ah)("IExtHostConfiguration")}),define(Ae[112],Re([1,0,2,13,5,3,7,33,59,34,21,62,17,27,4,12,22,14,80,215,9]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=e.$Xbc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var b;(function(V){function j(N){if(N!=null)return N}V.from=j;function W(N){if(N!=null)return N}V.to=W})(b||(b={}));var n;(function(V){function j(N){if(N!=null)return N}V.from=j;function W(N){if(N!=null)return N}V.to=W})(n||(n={}));var a;(function(V){function j(N){if(N!=null)return N}V.from=j;function W(N){if(N!=null)return N}V.to=W})(a||(a={}));var s;(function(V){function j(z){if(z){const ee=z;return ee&&!!ee.process}else return!1}V.is=j;function W(z){if(z==null)return;const ee={process:z.process,args:z.args};return z.options&&(ee.options=a.from(z.options)),ee}V.from=W;function N(z){if(z!=null)return new A.$EK(z.process,z.args,z.options)}V.to=N})(s||(s={}));var o;(function(V){function j(N){if(N!=null)return N}V.from=j;function W(N){if(N!=null)return N}V.to=W})(o||(o={}));var y;(function(V){function j(z){if(z){const ee=z;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}V.is=j;function W(z){if(z==null)return;const ee={};return z.commandLine!==void 0?ee.commandLine=z.commandLine:(ee.command=z.command,ee.args=z.args),z.options&&(ee.options=o.from(z.options)),ee}V.from=W;function N(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$FK(z.commandLine,z.options):new A.$FK(z.command,z.args?z.args:[],z.options)}V.to=N})(y||(y={}));var $;(function(V){function j(z){if(z){const ee=z;return ee&&ee.customExecution==="customExecution"}else return!1}V.is=j;function W(z){return{customExecution:"customExecution"}}V.from=W;function N(z,ee){return ee.get(z)}V.to=N})($||(e.CustomExecutionDTO=$={}));var I;(function(V){function j(W,N){let z;return W.scope!==void 0&&typeof W.scope!="number"?z=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?z=N.workspaceFile:z=g.$9F),{id:W._id,workspaceFolder:z}}V.from=j})(I||(e.TaskHandleDTO=I={}));var E;(function(V){function j(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}V.from=j})(E||(E={}));var r;(function(V){function j(z,ee){if(z==null)return[];const X=[];for(const Ee of z){const De=W(Ee,ee);De&&X.push(De)}return X}V.fromMany=j;function W(z,ee){if(z==null)return;let X;z.execution instanceof A.$EK?X=s.from(z.execution):z.execution instanceof A.$FK?X=y.from(z.execution):z.execution&&z.execution instanceof A.$GK&&(X=$.from(z.execution));const Ee=b.from(z.definition);let De;return z.scope?typeof z.scope=="number"?De=z.scope:De=z.scope.uri:De=A.TaskScope.Workspace,!Ee||!De?void 0:{_id:z._id,definition:Ee,name:z.name,source:{extensionId:ee.identifier.value,label:z.source,scope:De},execution:X,isBackground:z.isBackground,group:E.from(z.group),presentationOptions:n.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=W;async function N(z,ee,X){if(z==null)return;let Ee;s.is(z.execution)?Ee=s.to(z.execution):y.is(z.execution)?Ee=y.to(z.execution):$.is(z.execution)&&(Ee=$.to(z._id,X));const De=b.to(z.definition);let Pe;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Pe=z.source.scope:Pe=await ee.resolveWorkspaceFolder(w.URI.revive(z.source.scope)):Pe=A.TaskScope.Workspace),!De||!Pe)return;const Z=new A.$HK(De,Pe,z.name,z.source.label,Ee,z.problemMatchers);return z.isBackground!==void 0&&(Z.isBackground=z.isBackground),z.group!==void 0&&(Z.group=A.$DK.from(z.group._id),Z.group&&z.group.isDefault&&(Z.group=new A.$DK(Z.group.id,Z.group.label),z.group.isDefault===!0&&(Z.group.isDefault=z.group.isDefault))),z.presentationOptions&&(Z.presentationOptions=n.to(z.presentationOptions)),z._id&&(Z._id=z._id),z.detail&&(Z.detail=z.detail),Z}V.to=N})(r||(e.TaskDTO=r={}));var d;(function(V){function j(N){return N}V.from=j;function W(N){if(N)return Object.assign(Object.create(null),N)}V.to=W})(d||(d={}));class v{#e;constructor(j,W,N){this._id=W,this.a=N,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let R=class{constructor(j,W,N,z,ee,X,Ee,De){this.q=new C.$ed,this.r=new C.$ed,this.s=new C.$ed,this.t=new C.$ed,this.a=j.getProxy(L.$TJ.MainThreadTask),this.b=N,this.c=z,this.d=ee,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,W,N){if(!N)return new A.$VJ(()=>{});const z=this.w();return this.j.set(z,{type:W,provider:N,extension:j}),this.a.$registerTaskProvider(z,W),new A.$VJ(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(j,W){this.a.$registerTaskSystem(j,W)}fetchTasks(j){return this.a.$fetchTasks(d.from(j)).then(async W=>{const N=[];for(const z of W){const ee=await r.to(z,this.b,this.m);ee&&N.push(ee)}return N})}get taskExecutions(){const j=[];return this.k.forEach(W=>j.push(W)),j}terminateTask(j){if(!(j instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,W,N){const z=this.m.get(j.id);z&&(this.o.set(j.id,z),this.e.attachPtyToTerminal(W,await z.callback(N))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const W=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const W=await this.y(j.id);this.s.fire({execution:W,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const W=await this.y(j.id);this.t.fire({execution:W,exitCode:j.exitCode})}$provideTasks(j,W){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));const z=[],ee=(0,T.$yg)(()=>N.provider.provideTasks(P.CancellationToken.None)).then(X=>this.u(W,z,N,X));return new Promise(X=>{ee.then(Ee=>{Promise.all(z).then(()=>{X(Ee)})})})}async $resolveTask(j,W){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));if(W.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${N.type}].`);const z=await r.to(W,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ee=await N.provider.resolveTask(z,P.CancellationToken.None);if(!ee)return;this.z(ee,N);const X=r.from(ee,N.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(X.execution)&&await this.x(X,ee,!0),await this.v(X)}w(){return this.h++}async x(j,W,N){const z=await this.a.$createTaskId(j);!N&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,W.execution)),this.m.set(z,W.execution)}async y(j,W){if(typeof j=="string"){const ee=this.l.get(j);if(!ee)throw new D.$_("Unexpected: The specified task is missing an execution");return ee}const N=this.l.get(j.id);if(N)return N;const z=new Promise((ee,X)=>{function Ee(De,Pe,Z){Z?ee(new v(De,Pe.id,Z)):X("Unexpected: Task does not exist.")}W?Ee(this,j,W):r.to(j.task,this.b,this.m).then(De=>Ee(this,j,De))});return this.l.set(j.id,z),z.then(ee=>(this.k.set(j.id,ee),ee),ee=>Promise.reject(ee))}z(j,W){j._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const N=this.n.values();let z=N.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=N.next()}};e.$Xbc=R,e.$Xbc=R=Ke([Ve(0,u.$VL),Ve(1,p.$_L),Ve(2,l.$Yac),Ve(3,S.$7L),Ve(4,f.$2ac),Ve(5,k.$hbc),Ve(6,i.$4i),Ve(7,c.$Oac)],R);let B=class extends R{constructor(j,W,N,z,ee,X,Ee,De){super(j,W,N,z,ee,X,Ee,De),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(j,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const N=r.from(W,j);if(N===void 0)throw new Error("Task is not valid");if($.is(N.execution))await this.x(N,W,!1);else throw new D.$0;const z=await this.y(await this.a.$getTaskExecution(N),W);return this.a.$executeTask(N).catch(ee=>{throw new Error(ee)}),z}u(j,W,N,z){const ee=[];if(z)for(const X of z){this.z(X,N),(!X.definition||!j[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=r.from(X,N.extension);Ee&&$.is(Ee.execution)?(ee.push(Ee),W.push(this.x(Ee,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:N.extension}}async v(j){if($.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,W,N){}};e.$Ybc=B,e.$Ybc=B=Ke([Ve(0,u.$VL),Ve(1,p.$_L),Ve(2,l.$Yac),Ve(3,S.$7L),Ve(4,f.$2ac),Ve(5,k.$hbc),Ve(6,i.$4i),Ve(7,c.$Oac)],B),e.$Zbc=(0,m.$Ah)("IExtHostTask")}),define(Ae[266],Re([1,0,19,21,41,37,23,58,47]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;class f{constructor(u,p,m){this.k=u,this.l=p,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&L.$qj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&L.$qj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const p=this.k.folderQueries||[];return new Promise((m,h)=>{const t=i=>{this.f++,u(i)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),g=w.$_d(c);this.j&&this.j(c,g)||this.v(t,{base:i,basename:g})}),Promise.all(p.map(i=>this.p(i,t))).then(i=>{m({limitHit:this.e,stats:i[0]||void 0})},i=>{h(new Error((0,C.$li)(i)))})})}async p(u,p){const m=new T.$od,h=this.q(u),t=this.r(),i=new S.$yI(this.k,u),c=!i.hasSiblingExcludeClauses();let g;try{this.h.add(m),g=l.$ad.create();const D=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,m.token),b=g.elapsed(),n=l.$ad.create();return this.g&&!this.e||(D&&D.forEach(a=>{const s=w.$5d.relative(u.folder.path,a.path);if(c){const o=w.$_d(a.path);this.v(p,{base:u.folder,relativePath:s,basename:o});return}this.s(t,u.folder,s,p)}),this.g&&!this.e)?null:(this.u(t,i,p),{providerTime:b,postProcessTime:n.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(u){const p=(0,S.$xI)(this.k.includePattern,u.includePattern),m=(0,S.$xI)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:m,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},p,m,h){if(m===this.a){const i=w.$_d(this.a);this.v(h,{base:p,relativePath:this.a,basename:i})}function t(i){const c=w.$_d(i),g=w.$$d(i);let D=u[g];D||(D=u[g]=[],t(g)),D.push({base:p,relativePath:i,basename:c})}t(m)}u({rootEntries:u,pathToEntries:p},m,h){const t=this,i=this.a;function c(g){const D=(0,S.$AI)(()=>g.map(b=>b.basename));for(let b=0,n=g.length;b<n;b++){const a=g[b],{relativePath:s,basename:o}=a;if(m.matchesExcludesSync(s,o,i!==o?D:void 0))continue;const y=p[s];if(y)c(y);else{if(s===i)continue;t.v(h,a)}if(t.e)break}}c(u)}v(u,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(p))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,p,m,h){const t=this.c(u.cacheKey),i=new f(u,p,t&&t.token);let c=0;const g=D=>{c+=D.length,m(D.map(b=>this.d(b)))};return this.e(i,P.a,g,h).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:D.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new T.$od),this.b.get(u)}d(u){return u.relativePath?{resource:A.$hg(u.base,u.relativePath)}:{resource:u.base}}e(u,p,m,h){const t=h.onCancellationRequested(()=>{u.cancel()}),i=g=>{g&&(c.push(g),p>0&&c.length>=p&&(m(c),c=[]))};let c=[];return u.search(i).then(g=>(c.length&&m(c),t.dispose(),g),g=>(c.length&&m(c),t.dispose(),Promise.reject(g)))}}e.$0bc=P}),define(Ae[267],Re([1,0,18,100,37,90,28,12,19,23,15,16,2,282,168,43,14,53,103,265,47]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=void 0;let b=class{constructor(d,v,R,B,V){this.a=d,this.b=v,this.c=R,this.d=B,this.e=V}text(d,v,R={}){d=this.f(d,R);const B=this.a.getValue(),V=v&&v.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(v?.map(i.$Vh),R),type:2,contentPattern:d,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:B.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(d,v){const R=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const B={...d,wordSeparators:R.editor.wordSeparators};return this.j(d,v)&&(B.isCaseSensitive=!0),this.k(d)&&(B.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),B}file(d,v={}){return{...this.h(d,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(d,v){return d?(d=Array.isArray(d)?d.map(y):y(d),v?this.parseSearchPaths(d):{pattern:a(...Array.isArray(d)?d:[d])}):{}}h(d=[],v={}){const R=this.g(v.includePattern,v.expandPatterns),B=this.g(v.excludePattern,v.expandPatterns),V=d.length>1,j=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(z=>this.q(z,v,B)):d.map(z=>this.r(z,v,B,V))).filter(z=>!!z),W={_reason:v._reason,folderQueries:j,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:B.pattern,includePattern:R.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const z=w.$Eb(w.$Ob(this.c.groups.map(Ee=>Ee.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const ee=z.filter(Ee=>(0,D.$oI)(W,Ee.fsPath)),X=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...W,...X}}const N=v.extraFileResources&&v.extraFileResources.filter(z=>(0,D.$oI)(W,z.fsPath));return W.extraFileResources=N&&N.length?N:void 0,W}i(d){const v=[],R=new A.$yi,B={};let V=!1;return d.forEach(j=>{if(j.scheme===l.Schemas.walkThrough)return;if((0,f.$lg)(j)){const N=this.b.getWorkspaceFolder(j)?.uri??j.with({path:S.$$d(j.fsPath)});let z=R.get(N);z||(V=!0,z={folder:N,includePattern:{}},v.push(z),R.set(N,z));const ee=S.$0d(N.fsPath,j.fsPath);(0,k.$tf)(z.includePattern)[ee.replace(/\\/g,"/")]=!0}else j.fsPath&&(V=!0,B[j.fsPath]=!0)}),{folderQueries:v,includePattern:B,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(d,v){if(v.isSmartCase){if(d.isRegExp){if(P.$_e(d.pattern,!0))return!0}else if(P.$_e(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,p.$fC)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const v=X=>S.$7d(X)||/^\.\.?([\/\\]|$)/.test(X),B=(Array.isArray(d)?d:s(d)).map(X=>{const Ee=this.e.resolvedUserHome;return Ee?(0,L.$eA)(X,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):X}),V=T.$I(B,X=>v(X)?"searchPaths":"exprSegments"),j=(V.exprSegments||[]).map(X=>P.$ue(X,"/")).map(X=>P.$ue(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),W={},N=this.m(V.searchPaths||[]);N&&N.length&&(W.searchPaths=N);const z=w.$Ob(j),ee=a(...z);return ee&&(W.pattern=ee),W}l(d,v){return v.disregardExcludeSettings?void 0:(0,D.$nI)(d,!v.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const v=d.flatMap(B=>{let{pathPortion:V,globPortion:j}=n(B);return j&&(j=$(j)),this.n(V).flatMap(N=>this.o(N,j))}),R=new Map;return v.forEach(B=>{const V=B.searchPath.toString(),j=R.get(V);j?B.pattern&&(j.pattern=j.pattern||{},j.pattern[B.pattern]=!0):R.set(V,{searchPath:B.searchPath,pattern:B.pattern?a(B.pattern):void 0})}),Array.from(R.values())}n(d){if(S.$7d(d)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==l.Schemas.file?[{searchPath:v[0].uri.with({path:d})}]:[{searchPath:u.URI.file(S.$6d(d))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(d=y(d),d.startsWith("../")||d===".."){const B=S.$5d.resolve(v.path,d);return[{searchPath:v.with({path:B})}]}const R=$(d);return[{searchPath:v,pattern:R}]}else{if(d==="./"||d===".\\")return[];{const v=d.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(V=>{const j=v.match(new RegExp(`^${P.$pe(V.name)}(?:/(.*)|$)`));return j?{match:j,folder:V}:null}).filter(k.$qf);if(B.length)return B.map(V=>{const j=V.match[1];return{searchPath:V.folder.uri,pattern:j&&$(j)}});{const V=d.match(/\.[\/\\](.+)[\/\\]?/),j=V?V[1]:d,W=m.localize(0,null,j);throw new Error(W)}}}}o(d,v){const R=d.pattern&&v?`${d.pattern}/${v}`:d.pattern||v,B=[{searchPath:d.searchPath,pattern:R}];return R&&!R.endsWith("**")&&B.push({searchPath:d.searchPath,pattern:R+"/**"}),B}q(d,v,R){const B=this.r((0,i.$Vh)(d.searchPath),v,R,!1);return B?{...B,includePattern:d.pattern}:null}r(d,v,R,B){let V;const j=u.URI.isUri(d)?d:d.uri;if(R.searchPaths){const X=R.searchPaths.filter(Ee=>(0,f.$ag)(Ee.searchPath,j))[0];if(X&&!X.pattern)return null;X&&(V=X.pattern)}const W=this.a.getValue({resource:j}),z={...this.l(W,v)||{},...V||{}},ee=u.URI.isUri(d)?(0,f.$eg)(d):d.name;return{folder:j,folderName:B?ee:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!W.search.followSymlinks}}};e.$rJ=b,e.$rJ=b=Ke([Ve(0,h.$7h),Ve(1,i.$Jh),Ve(2,c.$2C),Ve(3,t.$4i),Ve(4,g.$pJ)],b);function n(r){const d=r.match(/[\*\{\}\(\)\[\]\?]/);if(d){const v=d.index,R=r.substr(0,v).match(/[/|\\][^/\\]*$/);if(R){let B=r.substr(0,R.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:r.substr((R.index||0)+1)}}}return{pathPortion:r}}function a(...r){return r.length?r.reduce((d,v)=>(d[v]=!0,d),Object.create(null)):void 0}function s(r){return C.$oj(r,",").map(d=>d.trim()).filter(d=>!!d.length)}function o(r){return[`**/${r}/**`,`**/${r}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function y(r){return r.replace(/\\/g,"/")}function $(r){return y(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(r){return r.replace(/([?*[\]])/g,"[$1]")}function E(r,d){r=w.$Jb(r,B=>B.toString());const v=[],R=d.getWorkspace();return r&&r.forEach(B=>{let V;if(d.getWorkbenchState()===2)V=(0,f.$jg)(R.folders[0].uri,B),V&&V!=="."&&(V="./"+V);else{const j=d.getWorkspaceFolder(B);if(j){const W=j.name;if(R.folders.filter(z=>z.name===W).length===1){const z=(0,f.$jg)(j.uri,B);z===""?V=`./${j.name}`:V=`./${j.name}/${z}`}else V=B.fsPath}}V&&v.push(I(V))}),v}e.$sJ=E}),define(Ae[268],Re([1,0,23,2,21,9,4,267,47,53]),function(be,e,w,T,C,L,A,l,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klb=e.$jlb=void 0;const P=7e3;function k(h,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],g=[];for(const o of i)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||h.forceUsingSearch?g.push(y):c.push(y)}if(c.length===0&&g.length===0)return Promise.resolve(void 0);let D;const b=new Promise((o,y)=>{D=o}),n=o=>D({activationEvent:o}),a=Promise.all(c.map(o=>u(h,o,n))).then(()=>{}),s=p(h,t.identifier,g,n);return Promise.all([a,s]).then(()=>{D(void 0)}),b}e.$jlb=k;async function u(h,t,i){for(const c of h.folders)if(await h.exists(w.$hg(T.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function p(h,t,i,c){if(i.length===0)return Promise.resolve(void 0);const g=new C.$od,D=h.checkExists(h.folders,i,g.token),b=setTimeout(async()=>{g.cancel(),h.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let n=!1;try{n=await D}catch(a){L.$2(a)||L.$Y(a)}g.dispose(),clearTimeout(b),n&&c(`workspaceContains:${i.join(",")}`)}function m(h,t,i,c){const g=h.get(A.$zh),D=h.get(S.$fI),n=g.createInstance(l.$rJ).file(t.map(a=>(0,f.$Vh)(T.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return D.fileSearch(n,c).then(a=>!!a.limitHit,a=>L.$2(a)?!1:Promise.reject(a))}e.$klb=m}),define(Ae[35],Re([1,0,149,19,87,23,13,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,71,86,62,5,268,83,191,12,81,58,22,82]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b,n,a,s,o,y,$,I,E,r,d,v,R,B,V,j,W,N,z){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=e.$vbc=e.$ubc=e.$tbc=e.$sbc=void 0,e.$sbc=(0,s.$Ah)("IHostUtils");let X=ee=class extends l.$jc{constructor(ie,O,q,le,we,ve,me,ke,se,he,re,oe){super(),this.X=oe,this.a=this.B(new d.$ed),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=O,this.g=q,this.f=me,this.j=le,this.m=we,this.s=ve,this.t=se,this.u=he,this.w=re,this.y=this.g.getProxy(k.$TJ.MainThreadWorkspace),this.z=this.g.getProxy(k.$TJ.MainThreadTelemetry),this.C=this.g.getProxy(k.$TJ.MainThreadExtensionService),this.D=new A.$Eg,this.F=new A.$Eg,this.G=new A.$Eg,this.H=new A.$Eg,this.I=new ce(this.f.activationEvents),this.L=new i.$d3b(this.I,this.f.allExtensions);const fe=new g.$Vl(this.f.myExtensions);this.J=new i.$d3b(this.I,ue(this.L,fe)),N.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new m.$_ac(this.g,this.s),this.N=new R.$lbc(this.g),this.O=ke,this.h=ie.createChild(new I.$yh([m.$abc,this.M],[R.$mbc,this.N])),this.P=this.B(new p.$$ac(this.J,this.L,{onExtensionActivationError:(Ie,F,K)=>{this.C.$onExtensionActivationError(Ie,c.$1(F),K)},actualActivateExtension:async(Ie,F)=>{if(i.$d3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,F),new p.$0ac;const K=this.J.getExtensionDescription(Ie);return this.db(K,F)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){c.$Y(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,O=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Gg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${O}`):this.s.info(`Extension host exiting with code ${O}`),this.s.flush(),this.s.dispose(),this.c.exit(O)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const O=await this.C.$getExtension(ie);return O&&{...O,identifier:new g.$Ul(O.identifier.value),extensionLocation:f.URI.revive(O.extensionLocation)}}Z(ie,O){return this.P.activateByEvent(ie,O)}$(ie,O){return this.P.activateById(ie,O)}activateByIdWithErrors(ie,O){return this.$(ie,O).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const O=await this.c.fsRealpath(ie.fsPath);return f.URI.file(O)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new ye(ie))),this.Q}async bb(ie){const O=S.$Gh.forUris(q=>L.$$f.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const le=await this.ab(q.extensionLocation);O.set(le,q)}})),O}cb(ie){let O=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return O;const q=this.P.getActivatedExtension(ie);if(!q)return O;try{typeof q.module.deactivate=="function"&&(O=Promise.resolve(q.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(le)}try{(0,l.$ec)(q.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(le)}return O}async db(ie,O){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,O).then(q=>{const le=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,O),this.eb(ie,O,"success",le),q},q=>{throw this.eb(ie,O,"failure"),q})}eb(ie,O,q,le){const we=De(ie,O);this.z.$publicLog2("extensionActivationTimes",{...we,...le||{},outcome:q})}fb(ie,O){const q=De(ie,O);this.z.$publicLog2("activatePlugin",q);const le=this.ub(ie);if(!le)return Promise.resolve(new p.$9ac(p.$6ac.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${O.startup}, activationEvent: '${O.activationEvent}'${ie.identifier.value!==O.extensionId.value?`, root cause: ${O.extensionId.value}`:""}`),this.s.flush();const we=new p.$7ac(O.startup);return Promise.all([this.vb(ie,(0,L.$hg)(ie.extensionLocation,le),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const O=new b.$cbc(ie,this.M),q=new b.$bbc(ie.identifier.value,!1,this.M),le=new B.$nbc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ve=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([O.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const me=this;let ke,se;const he=(0,t.$MF)(ie,"ipc")?this.f.messagePorts?.get(g.$Ul.toKey(ie.identifier)):void 0;return Object.freeze({globalState:O,workspaceState:q,secrets:le,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(re){return T.$8d(ie.extensionLocation.fsPath,re)},get storagePath(){return me.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me.O.globalValue(ie).fsPath},get logPath(){return T.$8d(me.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return f.URI.joinPath(me.f.logsLocation,ie.identifier.value)},get storageUri(){return me.O.workspaceValue(ie)},get globalStorageUri(){return me.O.globalValue(ie)},get extensionMode(){return we},get extension(){return ke===void 0&&(ke=new Z(me,ie.identifier,ie,ve,!1)),ke},get extensionRuntime(){return(0,t.$NF)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!se){if(!he)return;const re=d.Event.buffer(d.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),se={onDidReceiveMessage:re,postMessage:he.postMessage.bind(he)}}return se}})})}static hb(ie,O,q,le,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,O,q,le,we).then(ve=>new p.$8ac(!1,null,we.build(),q,ve,le.subscriptions))}static ib(ie,O,q,le,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${O.value}`);const ve=typeof global=="object"?global:self,me=q.activate.apply(ve,[le]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(me).then(ke=>(we.activateResolveStop(),ke))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}jb(ie,O){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:O}).then(void 0,q=>{this.s.error(q)})}kb(ie,O=0){const le=Date.now();(0,N.$A)(()=>{for(let we=O;we<ie.length;we+=1){const ve=ie[we];for(const me of ve.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-le>50){this.kb(ie,we);break}else this.jb(ve,me)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const O=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(O)this.kb(q);else for(const le of q)if(le.activationEvents)for(const we of le.activationEvents)we==="onStartupFinished"&&this.jb(le,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const O=this.j.workspace?this.j.workspace.folders:[],q=this.nb(O),le=this.pb(),we=Promise.all([le,ie,q]).then(()=>{});return Promise.race([we,(0,A.$Gg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(O=>this.ob(ie,O))).then(()=>{})}async ob(ie,O){if(this.isActivated(O.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:q||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,me,ke)=>this.y.$checkExists(ve,me,ke)},we=await(0,v.$jlb)(le,O);if(we)return this.$(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:O}=this.f.environment;if(!ie||!O)throw new Error(w.localize(0,null));const q=await this.vb(null,O,new p.$7ac(!1));if(!q||typeof q.run!="function")throw new Error(w.localize(1,null,O.toString()));return new Promise((le,we)=>{const ve=(se,he)=>{se?we(se):le(typeof he=="number"&&he>0?1:0)},me=(0,L.$8f)(O),ke=q.run(me,ve);ke&&ke.then&&ke.then(()=>{le(0)}).catch(se=>{we(se instanceof Error&&se.stack?se.stack:String(se))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Gg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,O){return this.R[ie]=O,(0,l.$hc)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:O}=await this.sb(ie);return O?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const O=ie.indexOf("+");if(O===-1)throw new n.$2J("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,O);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,O){const q=W.$ad.create(!1),le=()=>`[resolveAuthority(${(0,a.$Mk)(ie)},${O})][${q.elapsed()}ms] `,we=Q=>this.s.info(`${le()}${Q}`),ve=Q=>this.s.warn(`${le()}${Q}`),me=(Q,J=void 0)=>this.s.error(`${le()}${Q}`,J),ke=Q=>{if(Q instanceof n.$2J)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},se=async Q=>{we(`activating resolver for ${Q}...`);const{resolver:J,authorityPrefix:x}=await this.sb(Q);if(!J)throw me(`no resolver for ${x}`),new n.$2J(`No remote extension installed to resolve ${x}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:Q}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let re;try{re=await Promise.all(he.map(se)).catch(async Q=>{if(!(Q instanceof n.$2J)||Q._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return ve(`resolving nested authorities failed: ${Q.message}`),[await se(ie)]})}catch(Q){return ke(Q)}const oe=new A.$Qg;oe.cancelAndSet(()=>we("waiting..."),1e3);let fe,Ie;for(const[Q,{authorityPrefix:J,resolver:x,remoteAuthority:ae}]of re.entries())try{if(Q===re.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${J}`),fe=await x.resolve(ae,{resolveAttempt:O,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${J}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$1J.isManagedResolvedAuthority(fe)?fe:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await x.resolveExecServer?.(ae,{resolveAttempt:O,execServer:Ie}),!Ie)throw new n.$2J(`Exec server was not available for ${ae}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Le){return C.mark(`code/extHost/didResolveAuthorityError/${J}`),me("returned an error",Le),oe.dispose(),ke(Le)}oe.dispose();const F={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},K={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${n.$1J.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(n.$1J.isManagedResolvedAuthority(fe)){const Q=O;this.X.setFactory(Q,fe.makeConnection),G={authority:ie,connectTo:new a.$Jk(Q),connectionToken:fe.connectionToken}}else G={authority:ie,connectTo:new a.$Kk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:F}}}async $getCanonicalURI(ie,O){this.s.info(`$getCanonicalURI invoked for authority (${(0,a.$Mk)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const le=f.URI.revive(O);if(typeof q.getCanonicalURI>"u")return le;const we=await(0,A.$yg)(()=>q.getCanonicalURI(le));return we||le}$startExtensionHost(ie){ie.toAdd.forEach(le=>le.extensionLocation=f.URI.revive(le.extensionLocation));const{globalRegistry:O,myExtensions:q}=Ee(this.I,this.L,this.J,ie);return this.L.set(O.getAllExtensionDescriptions()),this.J.set(q),N.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,O){return O===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,O){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,O),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=f.URI.revive(ve.extensionLocation));const{globalRegistry:O,myExtensions:q}=Ee(this.I,this.L,this.J,ie),le=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(O.getAllExtensionDescriptions()),this.J.set(q),N.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const O=D.$Ed.alloc(ie),q=Math.random()%256;for(let le=0;le<ie;le++)O.writeUInt8(q,le);return O}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$tbc=X,e.$tbc=X=ee=Ke([Ve(0,s.$zh),Ve(1,e.$sbc),Ve(2,$.$VL),Ve(3,h.$Yac),Ve(4,u.$2ac),Ve(5,P.$4i),Ve(6,o.$_L),Ve(7,y.$fbc),Ve(8,E.$csb),Ve(9,r.$hbc),Ve(10,j.$pbc),Ve(11,z.$qbc)],X);function Ee($e,ie,O,q){$e.addActivationEvents(q.addActivationEvents);const le=new i.$d3b($e,ie.getAllExtensionDescriptions());le.deltaExtensions(q.toAdd,q.toRemove);const we=new g.$Vl(O.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of q.myToRemove)we.delete(me);for(const me of q.myToAdd)we.add(me);const ve=ue(le,we);return{globalRegistry:le,myExtensions:ve}}function De($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$ubc=(0,s.$Ah)("IExtHostExtensionService");class Z{#e;#t;#i;constructor(ie,O,q,le,we){this.#e=ie,this.#t=O,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=T.$6d((0,L.$8f)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=le,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$vbc=Z;function ue($e,ie){return $e.getAllExtensionDescriptions().filter(O=>ie.has(O.identifier))}class ye{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$wbc=ye;class ce{constructor(ie){this.a=new g.$Wl,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const O of Object.keys(ie))this.a.set(O,ie[O])}}}),define(Ae[269],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;let h=class{constructor(D,b,n,a,s,o,y){this.c=D,this.d=b,this.e=n,this.f=a,this.g=s,this.h=o,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const D=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const b=await this.g.getExtensionPathIndex();this.register(new i(this.c,b,this.d,D,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,b,this.h.environment.appUriScheme))}register(D){if("nodeModuleName"in D)if(Array.isArray(D.nodeModuleName))for(const b of D.nodeModuleName)this.a.set(b,D);else this.a.set(D.nodeModuleName,D);typeof D.alternativeModuleName=="function"&&this.b.push(b=>D.alternativeModuleName(b))}};e.$Scc=h,e.$Scc=h=Ke([Ve(2,P.$zh),Ve(3,L.$2ac),Ve(4,k.$ubc),Ve(5,f.$_L),Ve(6,u.$4i)],h);let t=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(D){if(D.environment.appRoot&&m.a.size){const b=(0,p.$pe)(this.c(D.environment.appRoot.fsPath)),n="[a-z0-9_.-]",a=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${b}/${s}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(D){if(!this.b)return;const b=this.b.exec(this.c(D));if(!b)return;const[,n,a,s]=b,o=m.a.get(a);if(o!==void 0)return console.warn(`${a} as been renamed to ${o}, please update your imports`),n+o+s}c(D){return D.replace(/\\/g,"/")}};t=m=Ke([Ve(0,f.$_L)],t);class i{constructor(D,b,n,a,s){this.c=D,this.d=b,this.e=n,this.f=a,this.g=s,this.nodeModuleName="vscode",this.a=new l.$Wl}load(D,b){const n=this.d.findSubstr(b);if(n){let a=this.a.get(n.identifier);return a||(a=this.c(n,this.e,this.f),this.a.set(n.identifier,a)),a}if(!this.b){let a="";this.d.forEach((s,o)=>a+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${b}. These are the extension path mappings: 
${a}`),this.b=this.c(A.$HF,this.e,this.f)}return this.b}}let c=class{constructor(D,b,n){this.e=D,this.f=b,this.nodeModuleName=["open","opn"],this.d=n.getProxy(C.$TJ.MainThreadTelemetry);const a=n.getProxy(C.$TJ.MainThreadWindow);this.c=(s,o)=>{const y=T.URI.parse(s);return o?this.g(s,o):y.scheme==="http"||y.scheme==="https"?a.$openUri(y,s,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?a.$openUri(y,s,{}):this.g(s,o)}}load(D,b,n){const a=this.e.findSubstr(b);return a&&(this.a=a.identifier.value,this.h()),this.b=n(D),this.c}g(D,b){return this.i(),this.b(D,b)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([Ve(2,S.$VL)],c)}),define(Ae[113],Re([1,0,65,6,19,74,4,59,60,35,7,33,201,34]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0,e.$3bc=(0,A.$Ah)("IExtHostVariableResolverProvider");class m extends u.$WM{constructor(i,c,g,D,b,n,a){function s(){if(g){const o=g.activeEditor();if(o)return o.document.uri;const y=D.tabGroups.all.find($=>$.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof P.$CL||y.input instanceof P.$HL)return y.input.modified;if(y.input instanceof P.$BL||y.input instanceof P.$GL||y.input instanceof P.$EL)return y.input.uri}}}super({getFolderUri:o=>{const y=n.folders.filter($=>$.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,y)=>b.getConfiguration(void 0,o).get(y),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return C.$6d(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=s();if(o){const y=c.getWorkspaceFolder(o);if(y)return C.$6d(y.uri.fsPath)}}},getSelectedText:()=>{if(g){const o=g.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(g){const o=g.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let h=class extends T.$jc{constructor(i,c,g,D,b){super(),this.b=i,this.c=c,this.g=g,this.h=D,this.j=b,this.a=new w.$T(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,n,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$4bc=h,e.$4bc=h=Ke([Ve(0,f.$ubc),Ve(1,k.$Yac),Ve(2,l.$7L),Ve(3,p.$2ac),Ve(4,S.$1bc)],h)}),define(Ae[114],Re([1,0,13,5,2,4,3,60,35,17,7,33,194,196,34,113]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.$8bc=e.$7bc=e.$6bc=e.$5bc=void 0,e.$5bc=(0,L.$Ah)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,s,o,y,$,I){this.E=s,this.F=o,this.G=y,this.H=$,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$ed,this.n=new T.$ed,this.o=new T.$ed,this.u=new T.$ed,this.k=a.getProxy(A.$TJ.MainThreadDebugService),this.y=new T.$ed,this.A=new T.$ed,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(E=>{E.onDidChange(r=>{this.J(E)}),this.J(E)})}asDebugSourceUri(a,s){const o=a;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,$="?";return s&&(y+=`${$}session=${encodeURIComponent(s.id)}`,$="&"),y+=`${$}ref=${o.sourceReference}`,C.URI.parse(y)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const s=[];for(const o of a.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const $ of y)(0,p.$jF)($)&&s.push($.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const a=[];return this.w.forEach(s=>a.push(s)),a}addBreakpoints(a){const s=a.filter($=>{const I=$.id;return this.w.has(I)?!1:(this.w.set(I,$),!0)});this.U(s,[],[]);const o=[],y=new Map;for(const $ of s)if($ instanceof P.$VK){let I=y.get($.location.uri.toString());I||(I={type:"sourceMulti",uri:$.location.uri,lines:[]},y.set($.location.uri.toString(),I),o.push(I)),I.lines.push({id:$.id,enabled:$.enabled,condition:$.condition,hitCondition:$.hitCondition,logMessage:$.logMessage,line:$.location.range.start.line,character:$.location.range.start.character})}else $ instanceof P.$WK&&o.push({type:"function",id:$.id,enabled:$.enabled,hitCondition:$.hitCondition,logMessage:$.logMessage,condition:$.condition,functionName:$.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(a){const s=a.filter(I=>this.w.delete(I.id));this.U([],s,[]);const o=s.filter(I=>I instanceof P.$VK).map(I=>I.id),y=s.filter(I=>I instanceof P.$WK).map(I=>I.id),$=s.filter(I=>I instanceof P.$XK).map(I=>I.id);return this.k.$unregisterBreakpoints(o,y,$)}startDebugging(a,s,o){return this.k.$startDebugging(a?a.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,s,o){if(!s)return new P.$VJ(()=>{});const y=this.d++;return this.f.push({type:a,handle:y,provider:s}),this.k.$registerDebugConfigurationProvider(a,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,y),new P.$VJ(()=>{this.f=this.f.filter($=>$.provider!==s),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(a,s,o){if(!o)return new P.$VJ(()=>{});if(!this.Q(a,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:s,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(s,y),new P.$VJ(()=>{this.h=this.h.filter($=>$.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(a,s){if(!s)return new P.$VJ(()=>{});const o=this.i++;return this.j.push({type:a,handle:o,factory:s}),new P.$VJ(()=>{this.j=this.j.filter(y=>y.factory!==s)})}async $runInTerminal(a,s){return Promise.resolve(void 0)}async $substituteVariables(a,s){let o;const y=await this.W(a);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,s)}K(a,s){if(a.type==="implementation")return new D(a.implementation)}L(){}async $startDASession(a,s){const o=this,y=await this.V(s);return this.S(this.N(y.type),y).then($=>{if(!$)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const I=this.M($),E=this.K(I,y);if(!E)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const r=E;return this.B.set(a,r),this.R(y).then(d=>(d&&this.C.set(a,d),r.onMessage(async v=>{if(v.type==="request"&&v.command==="handshake"){const R=v,B={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);B.body={signature:V},r.sendResponse(B)}else throw new Error("no signer")}catch(V){B.success=!1,B.message=V.message,r.sendResponse(B)}}else d&&d.onDidSendMessage&&d.onDidSendMessage(v),v=(0,p.$oF)(v,!0),o.k.$acceptDAMessage(a,v)}),r.onError(v=>{d&&d.onError&&d.onError(v),this.k.$acceptDAError(a,v.name,v.message,v.stack)}),r.onExit(v=>{d&&d.onExit&&d.onExit(v??void 0,void 0),this.k.$acceptDAExit(a,v??void 0,void 0)}),d&&d.onWillStartSession&&d.onWillStartSession(),r.startSession()))})}$sendDAMessage(a,s){s=(0,p.$nF)(s,!1);const o=this.C.get(a);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this.B.get(a)?.sendMessage(s)}$stopDASession(a){const s=this.C.get(a);this.C.delete(a),s&&s.onWillStopSession&&s.onWillStopSession();const o=this.B.get(a);return this.B.delete(a),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const s=[],o=[],y=[];if(a.added)for(const $ of a.added){const I=$.id;if(I&&!this.w.has(I)){let E;if($.type==="function")E=new P.$WK($.functionName,$.enabled,$.condition,$.hitCondition,$.logMessage);else if($.type==="data")E=new P.$XK($.label,$.dataId,$.canPersist,$.enabled,$.hitCondition,$.condition,$.logMessage);else{const r=C.URI.revive($.uri);E=new P.$VK(new P.$8J(r,new P.$WJ($.line,$.character)),$.enabled,$.condition,$.hitCondition,$.logMessage)}(0,P.$TK)(E,I),this.w.set(I,E),s.push(E)}}if(a.removed)for(const $ of a.removed){const I=this.w.get($);I&&(this.w.delete($),o.push(I))}if(a.changed){for(const $ of a.changed)if($.id){const I=this.w.get($.id);if(I){if(I instanceof P.$WK&&$.type==="function"){const E=I;E.enabled=$.enabled,E.condition=$.condition,E.hitCondition=$.hitCondition,E.logMessage=$.logMessage,E.functionName=$.functionName}else if(I instanceof P.$VK&&$.type==="source"){const E=I;E.enabled=$.enabled,E.condition=$.condition,E.hitCondition=$.hitCondition,E.logMessage=$.logMessage,E.location=new P.$8J(C.URI.revive($.uri),new P.$WJ($.line,$.character))}y.push(I)}}}this.U(s,o,y)}async $acceptStackFrameFocus(a){let s;const o=a.sessionId?await this.V(a.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?s=new P.$4K(o,a.threadId):s=new P.$3K(o,a.threadId,a.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(a,s,o){return(0,w.$yg)(async()=>{const y=this.P(a);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const $=await this.W(s);return y.provideDebugConfigurations($,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(a,s,o,y){return(0,w.$yg)(async()=>{const $=this.P(a);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(s);return $.resolveDebugConfiguration(I,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(a,s,o,y){return(0,w.$yg)(async()=>{const $=this.P(a);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(s);return $.resolveDebugConfigurationWithSubstitutedVariables(I,o,y)})}async $provideDebugAdapter(a,s){const o=this.O(a);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(s);return this.S(o,y).then($=>{if(!$)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M($)})}async $acceptDebugSessionStarted(a){const s=await this.V(a);this.m.fire(s)}async $acceptDebugSessionTerminated(a){const s=await this.V(a);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,s){(await this.V(a))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(a,s){const y={session:await this.V(a),event:s.event,body:s.body};this.u.fire(y)}M(a){if(a instanceof P.$YK)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.$ZK)return{type:"server",port:a.port,host:a.host};if(a instanceof P.$1K)return{type:"pipeServer",path:a.path};if(a instanceof P.$2K)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const s=this.h.filter(o=>o.type===a);if(s.length>0)return s[0].factory}O(a){const s=this.h.filter(o=>o.handle===a);if(s.length>0)return s[0].factory}P(a){const s=this.f.filter(o=>o.handle===a);if(s.length>0)return s[0].provider}Q(a,s){if(a.contributes){const o=a.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===s)return!0}}return!1}R(a){const o=a.configuration.type,y=this.j.filter($=>$.type===o||$.type==="*").map($=>(0,w.$yg)(()=>$.factory.createDebugAdapterTracker(a)).then(I=>I,I=>null));return Promise.race([Promise.all(y).then($=>{const I=$.filter(E=>!!E);if(I.length>0)return new g(I)}),new Promise($=>setTimeout(()=>$(void 0),1e3))]).catch($=>{})}async S(a,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$ZK(o));if(a){const $=await this.F.getExtensionRegistry();return(0,w.$yg)(()=>a.createDebugAdapterDescriptor(s,this.T(s,$))).then(I=>{if(I)return I})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,y))}T(a,s){}U(a,s,o){(a.length>0||s.length>0||o.length>0)&&this.y.fire(Object.freeze({added:a,removed:s,changed:o}))}async V(a){if(a)if(typeof a=="string"){const s=this.l.get(a);if(s)return s}else{let s=this.l.get(a.id);if(!s){const o=await this.W(a.folderUri),y=a.parent?this.l.get(a.parent):void 0;s=new i(this.k,a.id,a.type,a.name,o,a.configuration,y),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(a){if(a){const s=C.URI.revive(a);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$6bc=t,e.$6bc=t=Ke([Ve(0,f.$VL),Ve(1,k.$Yac),Ve(2,S.$ubc),Ve(3,m.$2ac),Ve(4,l.$1bc),Ve(5,h.$3bc)],t);class i{constructor(a,s,o,y,$,I,E){this.d=a,this.f=s,this.g=o,this.h=y,this.i=$,this.j=I,this.k=E}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,s){return this.d.$customDebugAdapterRequest(this.f,a,s)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.$7bc=i;class c{constructor(a){this.value=Object.freeze({append(s){a.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$8bc=c;class g{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(s=>s.onError?s.onError(a):void 0)}onExit(a,s){this.d.forEach(o=>o.onExit?o.onExit(a,s):void 0)}}class D extends u.$rcb{constructor(a){super(),this.h=a,a.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends t{constructor(a,s,o,y,$,I){super(a,s,o,y,$,I)}};e.$9bc=b,e.$9bc=b=Ke([Ve(0,f.$VL),Ve(1,k.$Yac),Ve(2,S.$ubc),Ve(3,m.$2ac),Ve(4,l.$1bc),Ve(5,h.$3bc)],b)}),define(Ae[270],Re([1,0,9,87,2,3,261,14,70,71,27,173,17,55,35,57]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=e.$Tcc=void 0;class t{static async installEarlyHandler(g){Error.stackTraceLimit=100;const D=g.get(l.$4i),n=g.get(u.$VL).getProxy(L.$TJ.MainThreadErrors);w.setUnexpectedErrorHandler(a=>{D.error(a);const s=w.$1(a);n.$onUnexpectedError(s)})}static async installFullHandler(g){const D=g.get(l.$4i),b=g.get(u.$VL),n=g.get(m.$ubc),a=g.get(h.$dM),s=b.getProxy(L.$TJ.MainThreadExtensionService),o=b.getProxy(L.$TJ.MainThreadErrors),y=await n.getExtensionPathIndex(),$=new WeakMap;function I(d,v){if($.has(d))return $.get(d).stack;let R="",B,V;for(const W of v)R+=`
	at ${W.toString()}`,V=W.getFileName(),!B&&V&&(B=y.findSubstr(C.URI.file(V)));const j=`${d.name||"Error"}: ${d.message||""}${R}`;return $.set(d,{extensionIdentifier:B?.identifier,stack:j}),j}const E=Symbol("prepareStackTrace wrapped");let r=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return r},set(d){if(d===I||!d||d[E]){r=d||I;return}r=function(v,R){return I(v,R),d.call(Error,v,R)},Object.assign(r,{[E]:!0})}}),w.setUnexpectedErrorHandler(d=>{D.error(d);const v=w.$1(d),R=$.get(d);if(!R?.extensionIdentifier){o.$onUnexpectedError(v);return}s.$onExtensionRuntimeError(R.extensionIdentifier,v);const B=a.onExtensionError(R.extensionIdentifier,d);D.trace("forwarded error to extension?",B,R)})}}e.$Tcc=t;class i{constructor(g,D,b,n,a){this.a=b,this.b=new A.$l3b(g,null,n),D=i.e(D,this.b);const s=new f.$yh(...(0,S.$lr)());s.set(P.$_L,{_serviceBrand:void 0,...D,messagePorts:a}),s.set(u.$VL,new u.$WL(this.b)),s.set(p.$Vac,new p.$Wac(n)),s.set(m.$sbc,b);const o=new k.$4p(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(l.$4i)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",D),this.c=o.invokeFunction(y=>y.get(m.$ubc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(g){const D=this.b.getProxy(L.$TJ.MainThreadExtensionService);return C.URI.revive(await D.$asBrowserUri(g))}terminate(g){this.c.terminate(g)}static e(g,D){g.allExtensions.forEach(n=>{n.extensionLocation=C.URI.revive(D.transformIncomingURIs(n.extensionLocation))}),g.environment.appRoot=C.URI.revive(D.transformIncomingURIs(g.environment.appRoot));const b=g.environment.extensionDevelopmentLocationURI;return b&&(g.environment.extensionDevelopmentLocationURI=b.map(n=>C.URI.revive(D.transformIncomingURIs(n)))),g.environment.extensionTestsLocationURI=C.URI.revive(D.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=C.URI.revive(D.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=C.URI.revive(D.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=C.URI.revive(D.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=C.URI.revive(D.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=C.URI.revive(D.transformIncomingURIs(g.logsLocation)),g.workspace=D.transformIncomingURIs(g.workspace),g}}e.$Ucc=i}),define(Ae[271],Re([1,0,18,13,21,41,12,19,23,2,47]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=e.$_bc=e.$$bc=void 0;class k{constructor(c,g,D,b){this.d=c,this.e=g,this.f=D,this.g=b,this.a=null,this.b=!1,this.c=0}search(c,g){const D=this.d.folderQueries||[],b=new C.$od(g);return new Promise((n,a)=>{this.a=new p(c);let s=!1;const o=(y,$)=>{if(!s&&!this.b){const I=this.h(y);h(y)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,s=!0,b.cancel(),y=this.j(y,this.d.maxResults-this.c));const E=this.h(y);this.c+=E,(E>0||!h(y))&&this.a.add(y,$)}};Promise.all(D.map((y,$)=>this.k(y,I=>o(I,$),b.token))).then(y=>{b.dispose(),this.a.flush();const $=y.some(I=>!!I&&!!I.limitHit);n({limitHit:this.b||$,messages:(0,w.$Ob)(y.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},y=>{b.dispose();const $=(0,L.$li)(y);a(new Error($))})})}h(c){return h(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,g){const D=Array.isArray(c.ranges)?c.ranges:[c.ranges],b=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:D.slice(0,g),preview:{matches:b.slice(0,g),text:c.preview.text},uri:c.uri}}async k(c,g,D){const b=new P.$yI(this.d,c),n=[],a={report:y=>{if(!this.l(y))return;const $=c.folder.scheme===A.Schemas.file?(0,P.$zI)(()=>this.f.readdir(S.$gg(y.uri))):void 0,I=S.$jg(c.folder,y.uri);if(I){const E=b.includedInQuery(I,l.$_d(I),$);(0,T.$sg)(E)?n.push(E.then(r=>{r&&g(y)})):E&&g(y)}}},s=this.n(c),o=await this.e.provideTextSearchResults(u(this.d.contentPattern),s,a,D);return n.length&&await Promise.all(n),o}l(c){if(h(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const g=(0,P.$xI)(this.d.includePattern,c.includePattern),D=(0,P.$xI)(this.d.excludePattern,c.excludePattern),b={folder:f.URI.from(c.folder),excludes:D,includes:g,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.$$bc=k;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,g=>this.g(g))}add(c,g){this.d&&(this.b!==g||!S.$ag(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=g,this.d={resource:c.uri,results:[]}),this.d.results.push(m(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$_bc=p;function m(i){return h(i)?{preview:{matches:(0,w.$Yb)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,w.$Yb)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function h(i){return!!i.preview}e.$acc=h;class t{static{this.a=4e3}static{this.b=50}constructor(c,g){this.g=c,this.h=g,this.c=0,this.d=[],this.e=0}addItem(c,g){c&&this.j(c,g)}addItems(c,g){c&&this.k(c,g)}j(c,g){this.d.push(c),this.e+=g,this.l()}k(c,g){this.d=this.d.concat(c),this.e+=g,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$bcc=t}),define(Ae[115],Re([1,0,6,3,4,266,17,55,14,2,271]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=e.$ccc=void 0,e.$ccc=(0,C.$Ah)("IExtHostSearch");let k=class{constructor(h,t,i){this.k=h,this.l=t,this.n=i,this.c=this.k.getProxy(T.$TJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$0bc}o(h){return this.l.transformOutgoingScheme(h)}registerTextSearchProvider(h,t){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(h)),(0,w.$hc)(()=>{this.g.delete(h),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(h,t){if(this.i.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.i.add(h);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(h)),(0,w.$hc)(()=>{this.i.delete(h),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(h,t,i,c){const g=u(i),D=this.h.get(h);if(D)return this.j.fileSearch(g,D,b=>{this.c.$handleFileMatch(h,t,b.map(n=>n.resource))},c);throw new Error("unknown provider: "+h)}$clearCache(h){return this.j.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,t,i,c){const g=this.e.get(h);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const D=u(i);return this.q(D,g).search(n=>this.c.$handleTextMatch(h,t,n),c)}$enableExtensionHostSearch(){}q(h,t){return new P.$$bc(h,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$dcc=k,e.$dcc=k=Ke([Ve(0,A.$VL),Ve(1,l.$Vac),Ve(2,S.$4i)],k);function u(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(p),extraFileResources:m.extraFileResources&&m.extraFileResources.map(h=>f.URI.revive(h))}}e.$ecc=u;function p(m){return{...m,folder:f.URI.revive(m.folder)}}}),define(Ae[272],Re([1,0,21,9,5,29,2,136,283,125,134,38,3,79,225,224,31,226,34,228,229,230,204,231,59,35,233,234,239,240,242,110,208,248,249,251,84,62,253,211,8,7,52,256,63,109,33,20,199,238,51,108,112,114,115,14,55,17,27,243,197,86,80,218,254,85,61,259,257,258,219,39,252,255,83,60,57,244,111,245,12,95,207,190,236,6,26,195,81,186,246,247,220,235,206,237,82,250,221,222,223,217,232]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b,n,a,s,o,y,$,I,E,r,d,v,R,B,V,j,W,N,z,ee,X,Ee,De,Pe,Z,ue,ye,ce,$e,ie,O,q,le,we,ve,me,ke,se,he,re,oe,fe,Ie,F,K,G,Q,J,x,ae,Le,Ue,Qe,He,et,Ze,_e,it,tt,Oe,st,_,Y,pe,je,ze,Ye,nt,gt,vt,Ft,Yt,Vt,wt,Mt,Nt,Jt,Pt,At,zt,jt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;function Bt(at){const ut=at.get(se.$_L),Ht=at.get(Le.$Lac),Ct=at.get(G.$ebc),Dt=at.get(o.$ubc),ht=at.get(ue.$Yac),St=at.get(Ze.$dM),Lt=at.get(c.$2ac),Et=at.get(me.$Vac),qe=at.get(ke.$VL),Ot=at.get(j.$abc),Ce=at.get(K.$fbc),Te=at.get(ve.$5i),ge=at.get(ve.$4i),H=at.get(oe.$csb),Fe=at.get(fe.$Oac),Be=at.get(Z.$Sbc),Ge=at.get(He.$mbc),We=at.get(et.$1bc),xe=at.get(Nt.$qbc);qe.set(u.$UJ.ExtHostFileSystemInfo,Ht),qe.set(u.$UJ.ExtHostLogLevelServiceShape,Te),qe.set(u.$UJ.ExtHostWorkspace,ht),qe.set(u.$UJ.ExtHostConfiguration,Lt),qe.set(u.$UJ.ExtHostExtensionService,Dt),qe.set(u.$UJ.ExtHostStorage,Ot),qe.set(u.$UJ.ExtHostTunnelService,H),qe.set(u.$UJ.ExtHostWindow,Be),qe.set(u.$UJ.ExtHostSecretState,Ge),qe.set(u.$UJ.ExtHostTelemetry,St),qe.set(u.$UJ.ExtHostEditorTabs,We),qe.set(u.$UJ.ExtHostManagedSockets,xe);const pt=qe.set(u.$UJ.ExtHostDecorations,at.get(O.$Wbc)),bt=qe.set(u.$UJ.ExtHostDocumentsAndEditors,at.get(s.$7L)),dt=qe.set(u.$UJ.ExtHostCommands,at.get(t.$fM)),ft=qe.set(u.$UJ.ExtHostTerminalService,at.get(W.$hbc)),mt=qe.set(u.$UJ.ExtHostDebugService,at.get(le.$5bc)),gi=qe.set(u.$UJ.ExtHostSearch,at.get(we.$ccc)),Kt=qe.set(u.$UJ.ExtHostTask,at.get(q.$Zbc)),Ei=qe.set(u.$UJ.ExtHostOutputService,at.get(d.$Cbc)),Wt=qe.set(u.$UJ.ExtHostLocalization,at.get(nt.$pbc)),mi=qe.set(u.$UJ.ExtHostUrls,new De.$Lbc(qe)),It=qe.set(u.$UJ.ExtHostDocuments,new a.$Jac(qe,bt)),Di=qe.set(u.$UJ.ExtHostDocumentContentProviders,new b.$4ac(qe,bt,ge)),Vi=qe.set(u.$UJ.ExtHostDocumentSaveParticipant,new n.$5ac(ge,It,qe.getProxy(u.$TJ.MainThreadBulkEdits))),kt=qe.set(u.$UJ.ExtHostNotebook,new he.$icc(qe,dt,bt,It,Ct)),ti=qe.set(u.$UJ.ExtHostNotebookDocuments,new Y.$Acc(kt)),$i=qe.set(u.$UJ.ExtHostNotebookEditors,new _.$zcc(ge,kt)),si=qe.set(u.$UJ.ExtHostNotebookKernels,new _e.$wcc(qe,ut,kt,dt,ge)),ki=qe.set(u.$UJ.ExtHostNotebookRenderers,new tt.$ycc(qe,kt)),Si=qe.set(u.$UJ.ExtHostNotebookDocumentSaveParticipant,new wt.$Gcc(ge,kt,qe.getProxy(u.$TJ.MainThreadBulkEdits))),Rt=qe.set(u.$UJ.ExtHostEditors,new N.$Jbc(qe,bt)),pi=qe.set(u.$UJ.ExtHostTreeViews,new z.$Kbc(qe.getProxy(u.$TJ.MainThreadTreeViews),dt,ge)),Ii=qe.set(u.$UJ.ExtHostEditorInsets,new ce.$Tbc(qe.getProxy(u.$TJ.MainThreadEditorInsets),Rt,ut.remote)),oi=qe.set(u.$UJ.ExtHostDiagnostics,new g.$Nac(qe,ge,Ht,bt)),ai=qe.set(u.$UJ.ExtHostLanguages,new E.$zbc(qe,It,dt.converter,Et)),ct=qe.set(u.$UJ.ExtHostLanguageFeatures,new I.$Rac(qe,Et,It,dt,oi,ge,Fe,St)),qi=qe.set(u.$UJ.ExtHostFileSystem,new y.$xbc(qe,ct)),Xt=qe.set(u.$UJ.ExtHostFileSystemEventService,new $.$ybc(qe,ge,bt)),ii=qe.set(u.$UJ.ExtHostQuickOpen,(0,R.$Ebc)(qe,ht,dt)),bi=qe.set(u.$UJ.ExtHostSCM,new B.$Gbc(qe,dt,It,ge)),Ci=qe.set(u.$UJ.ExtHostQuickDiff,new Ft.$Dcc(qe,Et)),Ki=qe.set(u.$UJ.ExtHostShare,new Jt.$Icc(qe,Et)),Pi=qe.set(u.$UJ.ExtHostComments,(0,i.$Uac)(qe,dt,It)),vi=qe.set(u.$UJ.ExtHostProgress,new v.$Dbc(qe.getProxy(u.$TJ.MainThreadProgress))),Ji=qe.set(u.$UJ.ExtHosLabelService,new $e.$Ubc(qe)),Ai=qe.set(u.$UJ.ExtHostTheming,new re.$jcc(qe)),ci=qe.set(u.$UJ.ExtHostAuthentication,new Ie.$kcc(qe)),Hi=qe.set(u.$UJ.ExtHostTimeline,new F.$mcc(qe,dt)),wi=qe.set(u.$UJ.ExtHostWebviews,new Pe.$Obc(qe,ut.remote,ht,ge,Fe)),Ri=qe.set(u.$UJ.ExtHostWebviewPanels,new x.$occ(qe,wi,ht)),cn=qe.set(u.$UJ.ExtHostCustomEditors,new J.$pcc(qe,It,Ce,wi,Ri)),Ti=qe.set(u.$UJ.ExtHostWebviewViews,new Q.$ncc(qe,wi)),ni=qe.set(u.$UJ.ExtHostTesting,new Ue.$rcc(qe,dt,bt)),un=qe.set(u.$UJ.ExtHostUriOpeners,new Qe.$vcc(qe)),ln=qe.set(u.$UJ.ExtHostProfileContentHandlers,new vt.$Ccc(qe));qe.set(u.$UJ.ExtHostInteractive,new pe.$Bcc(qe,kt,bt,dt,ge));const Gi=qe.set(u.$UJ.ExtHostInlineChat,new Vt.$Fcc(qe,dt,It,ge)),fi=qe.set(u.$UJ.ExtHostChatProvider,new Pt.$Jcc(qe,ge)),Qi=qe.set(u.$UJ.ExtHostChatSlashCommands,new At.$Kcc(qe,fi,ge)),Yi=qe.set(u.$UJ.ExtHostChatVariables,new zt.$Lcc(qe)),ui=qe.set(u.$UJ.ExtHostChat,new Yt.$Ecc(qe,ge)),Xi=qe.set(u.$UJ.ExtHostAiRelatedInformation,new jt.$Mcc(qe)),Fi=qe.set(u.$UJ.ExtHostAiEmbeddingVector,new qt.$Ncc(qe)),Zi=qe.set(u.$UJ.ExtHostIssueReporter,new Mt.$Hcc(qe)),Zt=qe.set(u.$UJ.ExtHostStatusBar,new V.$Ibc(qe,dt.converter)),yi=Object.values(u.$UJ);qe.assertRegistered(yi);const hn=new ae.$qcc(qe,bt),Gt=new h.$Tac(qe),li=new r.$Abc(qe,ge),Mi=new D.$3ac(qe);return m.$Sac.register(dt),function(Ne,_t,Li){const $t=function(){let te=!Ne.isUnderDevelopment;function de(){te||(ge.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Me(rt){if(Array.isArray(rt))rt.forEach(Me);else if(typeof rt=="string")de();else{const yt=rt;typeof yt.scheme>"u"&&de(),typeof yt.exclusive=="boolean"&&(0,ze.$NF)(Ne,"documentFiltersExclusive")}return rt}}(),_i={getSession(te,de,Me){return ci.getSession(Ne,te,de,Me)},getSessions(te,de){return(0,ze.$NF)(Ne,"authGetSessions"),ci.getSessions(Ne,te,de)},async hasSession(te,de){return(0,ze.$NF)(Ne,"authSession"),!!await ci.getSession(Ne,te,de,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,de,Me,rt){return ci.registerAuthenticationProvider(te,de,Me,rt)}},xi={registerCommand(te,de,Me){return dt.registerCommand(!0,te,de,Me,void 0,Ne)},registerTextEditorCommand(te,de,Me){return dt.registerCommand(!0,te,(...rt)=>{const yt=Rt.getActiveTextEditor();if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return yt.edit(Tt=>{de.apply(Me,[yt,Tt,...rt])}).then(Tt=>{Tt||ge.warn("Edits from command "+te+" were not applied.")},Tt=>{ge.warn("An error occurred while running command "+te,Tt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(te,de,Me)=>((0,ze.$NF)(Ne,"diffCommand"),dt.registerCommand(!0,te,async(...rt)=>{const yt=bt.activeEditor(!0);if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(yt.id);de.apply(Me,[Tt,...rt])},void 0,void 0,Ne)),executeCommand(te,...de){return dt.executeCommand(te,...de)},getCommands(te=!1){return dt.getCommands(te)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return ft.getDefaultShell(!1)},get onDidChangeShell(){return ft.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$NF)(Ne,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$NF)(Ne,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ze.$cM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Ze.$bM.validateSender(te),St.instantiateLogger(Ne,te,de)},openExternal(te,de){return Be.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return mi.createAppUri(te);try{return await Be.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(de){if((0,st.$DT)(te,Oe.Schemas.http)||(0,st.$DT)(te,Oe.Schemas.https))return te;throw de}},get remoteName(){return(0,ie.$Ok)(ut.remote.authority)},get remoteAuthority(){return(0,ze.$NF)(Ne,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return ge.getLevel()},get onDidChangeLogLevel(){return ge.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,ze.$NF)(Ne,"handleIssueUri"),Zi.registerIssueUriRequestHandler(Ne,te)},get appQuality(){return(0,ze.$NF)(Ne,"resolvers"),ut.quality},get appCommit(){return(0,ze.$NF)(Ne,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(te,de,Me){return ni.createTestController(Ne,te,de,Me)},createTestObserver(){return(0,ze.$NF)(Ne,"testObserver"),ni.createTestObserver()},runTests(te){return(0,ze.$NF)(Ne,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,ze.$NF)(Ne,"testObserver"),ni.onResultsChanged},get testResults(){return(0,ze.$NF)(Ne,"testObserver"),ni.results}},hi=ut.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,tn={getExtension(te,de){(0,ze.$MF)(Ne,"extensionsAny")||(de=!1);const Me=_t.mine.getExtensionDescription(te);if(Me)return new o.$vbc(Dt,Ne.identifier,Me,hi,!1);if(de){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$vbc(Dt,Ne.identifier,rt,hi,!0)}},get all(){const te=[];for(const de of _t.mine.getAllExtensionDescriptions())te.push(new o.$vbc(Dt,Ne.identifier,de,hi,!1));return te},get allAcrossExtensionHosts(){(0,ze.$NF)(Ne,"extensionsAny");const te=new ye.$Vl(_t.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),de=[];for(const Me of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Me.identifier);de.push(new o.$vbc(Dt,Ne.identifier,Me,hi,rt))}return de},get onDidChange(){return(0,ze.$MF)(Ne,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Ne.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,de){return ai.changeLanguage(te.uri,de)},match(te,de){const Me=It.getDocumentData(de.uri)?.notebook;return(0,P.$_E)(ee.LanguageSelector.from(te),de.uri,de.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(te,de,Me){return ct.registerCodeActionProvider(Ne,$t(te),de,Me)},registerDocumentPasteEditProvider(te,de,Me){return(0,ze.$NF)(Ne,"documentPaste"),ct.registerDocumentPasteEditProvider(Ne,$t(te),de,Me)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Ne,$t(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Ne,$t(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Ne,$t(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Ne,$t(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Ne,$t(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Ne,$t(te),de,Ne.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Ne,$t(te),de,Ne.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Ne,$t(te),de,Ne.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Ne,$t(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Ne,$t(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Ne,$t(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Ne,$t(te),de)},registerDocumentSymbolProvider(te,de,Me){return ct.registerDocumentSymbolProvider(Ne,$t(te),de,Me)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Ne,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Ne,$t(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Ne,$t(te),de)},registerOnTypeFormattingEditProvider(te,de,Me,...rt){return ct.registerOnTypeFormattingEditProvider(Ne,$t(te),de,[Me].concat(rt))},registerDocumentSemanticTokensProvider(te,de,Me){return ct.registerDocumentSemanticTokensProvider(Ne,$t(te),de,Me)},registerDocumentRangeSemanticTokensProvider(te,de,Me){return ct.registerDocumentRangeSemanticTokensProvider(Ne,$t(te),de,Me)},registerSignatureHelpProvider(te,de,Me,...rt){return typeof Me=="object"?ct.registerSignatureHelpProvider(Ne,$t(te),de,Me):ct.registerSignatureHelpProvider(Ne,$t(te),de,typeof Me>"u"?[]:[Me,...rt])},registerCompletionItemProvider(te,de,...Me){return ct.registerCompletionItemProvider(Ne,$t(te),de,Me)},registerInlineCompletionItemProvider(te,de,Me){return de.handleDidShowCompletionItem&&(0,ze.$NF)(Ne,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,ze.$NF)(Ne,"inlineCompletionsAdditions"),Me&&(0,ze.$NF)(Ne,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ne,$t(te),de,Me)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Ne,$t(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Ne,$t(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Ne,$t(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Ne,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Ne,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Ne,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Ne,te,de),getTokenInformationAtPosition(te,de){return(0,ze.$NF)(Ne,"tokenInformation"),ai.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Ne,te,de)},createLanguageStatusItem(te,de){return ai.createLanguageStatusItem(Ne,te,de)},registerDocumentDropEditProvider(te,de,Me){return ct.registerDocumentOnDropEditProvider(Ne,te,de,(0,ze.$MF)(Ne,"dropMetadata")?Me:void 0)}},rn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,de,Me){const rt=await(A.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Rt.showTextDocument(rt,de,Me)},createTextEditorDecorationType(te){return Rt.createTextEditorDecorationType(Ne,te)},onDidChangeActiveTextEditor(te,de,Me){return Rt.onDidChangeActiveTextEditor(te,de,Me)},onDidChangeVisibleTextEditors(te,de,Me){return Rt.onDidChangeVisibleTextEditors(te,de,Me)},onDidChangeTextEditorSelection(te,de,Me){return Rt.onDidChangeTextEditorSelection(te,de,Me)},onDidChangeTextEditorOptions(te,de,Me){return Rt.onDidChangeTextEditorOptions(te,de,Me)},onDidChangeTextEditorVisibleRanges(te,de,Me){return Rt.onDidChangeTextEditorVisibleRanges(te,de,Me)},onDidChangeTextEditorViewColumn(te,de,Me){return Rt.onDidChangeTextEditorViewColumn(te,de,Me)},onDidCloseTerminal(te,de,Me){return ft.onDidCloseTerminal(te,de,Me)},onDidOpenTerminal(te,de,Me){return ft.onDidOpenTerminal(te,de,Me)},onDidChangeActiveTerminal(te,de,Me){return ft.onDidChangeActiveTerminal(te,de,Me)},onDidChangeTerminalDimensions(te,de,Me){return(0,ze.$NF)(Ne,"terminalDimensions"),ft.onDidChangeTerminalDimensions(te,de,Me)},onDidChangeTerminalState(te,de,Me){return ft.onDidChangeTerminalState(te,de,Me)},onDidWriteTerminalData(te,de,Me){return(0,ze.$NF)(Ne,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(te,de,Me)},onDidExecuteTerminalCommand(te,de,Me){return(0,ze.$NF)(Ne,"terminalExecuteCommandEvent"),ft.onDidExecuteTerminalCommand(te,de,Me)},get state(){return Be.getState(Ne)},onDidChangeWindowState(te,de,Me){return Be.onDidChangeWindowState(te,de,Me)},showInformationMessage(te,...de){return li.showMessage(Ne,L.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return li.showMessage(Ne,L.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return li.showMessage(Ne,L.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Me){return ii.showQuickPick(Ne,te,de,Me)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return Mi.showOpenDialog(Ne,te)},showSaveDialog(te){return Mi.showSaveDialog(te)},createStatusBarItem(te,de,Me){let rt,yt,Tt;return typeof te=="string"?(rt=te,yt=de,Tt=Me):(yt=te,Tt=de),Zt.createStatusBarEntry(Ne,rt,yt,Tt)},setStatusBarMessage(te,de){return Zt.setStatusBarMessage(te,de)},withScmProgress(te){return Fe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),vi.withProgress(Ne,{location:X.ProgressLocation.SourceControl},(de,Me)=>te({report(rt){}}))},withProgress(te,de){return vi.withProgress(Ne,te,de)},createOutputChannel(te,de){return Ei.createOutputChannel(te,de,Ne)},createWebviewPanel(te,de,Me,rt){return Ri.createWebviewPanel(Ne,te,de,Me,rt)},createWebviewTextEditorInset(te,de,Me,rt){return(0,ze.$NF)(Ne,"editorInsets"),Ii.createWebviewEditorInset(te,de,Me,rt,Ne)},createTerminal(te,de,Me){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):ft.createTerminalFromOptions(te):ft.createTerminal(te,de,Me)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return ft.registerProfileProvider(Ne,te,de)},registerTerminalQuickFixProvider(te,de){return(0,ze.$NF)(Ne,"terminalQuickFixProvider"),ft.registerTerminalQuickFixProvider(te,Ne.identifier.value,de)},registerTreeDataProvider(te,de){return pi.registerTreeDataProvider(te,de,Ne)},createTreeView(te,de){return pi.createTreeView(te,de,Ne)},registerWebviewPanelSerializer:(te,de)=>Ri.registerWebviewPanelSerializer(Ne,te,de),registerCustomEditorProvider:(te,de,Me={})=>cn.registerCustomEditorProvider(Ne,te,de,Me),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,Ne)},registerUriHandler(te){return mi.registerUriHandler(Ne,te)},createQuickPick(){return ii.createQuickPick(Ne)},createInputBox(){return ii.createInputBox(Ne)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,de,Me){return Ai.onDidChangeActiveColorTheme(te,de,Me)},registerWebviewViewProvider(te,de,Me){return Ti.registerWebviewViewProvider(Ne,te,de,Me?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Me){return kt.onDidChangeActiveNotebookEditor(te,de,Me)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Me){return $i.onDidChangeNotebookEditorSelection(te,de,Me)},onDidChangeNotebookEditorVisibleRanges(te,de,Me){return $i.onDidChangeNotebookEditorVisibleRanges(te,de,Me)},showNotebookDocument(te,de){return kt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Me){return(0,ze.$NF)(Ne,"externalUriOpener"),un.registerExternalUriOpener(Ne.identifier,te,de,Me)},registerProfileContentHandler(te,de){return(0,ze.$NF)(Ne,"profileContentHandlers"),ln.registrProfileContentHandler(Ne,te,de)},registerQuickDiffProvider(te,de,Me,rt){return(0,ze.$NF)(Ne,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(te),de,Me,rt)},get tabGroups(){return We.tabGroups},registerShareProvider(te,de){return(0,ze.$NF)(Ne,"shareProvider"),Ki.registerShareProvider($t(te),de)}},sn={get rootPath(){return Fe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new T.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new T.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new T.$7("workspaceFile")},updateWorkspaceFolders:(te,de,...Me)=>ht.updateWorkspaceFolders(Ne,te,de||0,...Me),onDidChangeWorkspaceFolders:function(te,de,Me){return ht.onDidChangeWorkspace(te,de,Me)},asRelativePath:(te,de)=>ht.getRelativePath(te,de),findFiles:(te,de,Me,rt)=>ht.findFiles(te,de,Me,Ne.identifier,rt),findTextInFiles:(te,de,Me,rt)=>{(0,ze.$NF)(Ne,"findTextInFiles");let yt,Tt;return typeof de=="object"?(yt=de,Tt=Me):(yt={},Tt=de,rt=Me),ht.findTextInFiles(te,yt||{},Tt,Ne.identifier,rt)},save:te=>((0,ze.$NF)(Ne,"saveEditor"),ht.save(te)),saveAs:te=>((0,ze.$NF)(Ne,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,de){return hn.applyWorkspaceEdit(te,Ne,de)},createFileSystemWatcher:(te,de,Me,rt)=>Xt.createFileSystemWatcher(ht,Ne,te,de,Me,rt),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new T.$7("textDocuments")},openTextDocument(te){let de;const Me=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Me||typeof Me=="object")de=It.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>It.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(te,de,Me)=>It.onDidAddDocument(te,de,Me),onDidCloseTextDocument:(te,de,Me)=>It.onDidRemoveDocument(te,de,Me),onDidChangeTextDocument:(te,de,Me)=>It.onDidChangeDocument(te,de,Me),onDidSaveTextDocument:(te,de,Me)=>It.onDidSaveDocument(te,de,Me),onWillSaveTextDocument:(te,de,Me)=>Vi.getOnWillSaveTextDocumentEvent(Ne)(te,de,Me),get notebookDocuments(){return kt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Me;if(A.URI.isUri(te))Me=te,await kt.openNotebookDocument(te);else if(typeof te=="string")Me=A.URI.revive(await kt.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(te,de,Me){return ti.onDidSaveNotebookDocument(te,de,Me)},onDidChangeNotebookDocument(te,de,Me){return ti.onDidChangeNotebookDocument(te,de,Me)},onWillSaveNotebookDocument(te,de,Me){return Si.getOnWillSaveNotebookDocumentEvent(Ne)(te,de,Me)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Me,rt){return kt.registerNotebookSerializer(Ne,te,de,Me,(0,ze.$MF)(Ne,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,de,Me)=>Li.onDidChangeConfiguration(te,de,Me),getConfiguration(te,de){return de=arguments.length===1?void 0:de,Li.getConfiguration(te,de,Ne)},registerTextDocumentContentProvider(te,de){return Di.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Fe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Ne,te,de)),registerFileSystemProvider(te,de,Me){return(0,je.$gc)(qi.registerFileSystemProvider(Ne,te,de,Me),Ct.addFileSystemProvider(te,de,Me))},get fs(){return Ct.value},registerFileSearchProvider:(te,de)=>((0,ze.$NF)(Ne,"fileSearchProvider"),gi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,ze.$NF)(Ne,"textSearchProvider"),gi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,ze.$NF)(Ne,"resolvers"),Dt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,ze.$NF)(Ne,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,ze.$NF)(Ne,"resolvers"),Dt.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Me)=>Xt.onDidCreateFile(te,de,Me),onDidDeleteFiles:(te,de,Me)=>Xt.onDidDeleteFile(te,de,Me),onDidRenameFiles:(te,de,Me)=>Xt.onDidRenameFile(te,de,Me),onWillCreateFiles:(te,de,Me)=>Xt.getOnWillCreateFileEvent(Ne)(te,de,Me),onWillDeleteFiles:(te,de,Me)=>Xt.getOnWillDeleteFileEvent(Ne)(te,de,Me),onWillRenameFiles:(te,de,Me)=>Xt.getOnWillRenameFileEvent(Ne)(te,de,Me),openTunnel:te=>((0,ze.$NF)(Ne,"tunnels"),H.openTunnel(Ne,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,ze.$NF)(Ne,"tunnels"),H.getTunnels()},onDidChangeTunnels:(te,de,Me)=>((0,ze.$NF)(Ne,"tunnels"),H.onDidChangeTunnels(te,de,Me)),registerPortAttributesProvider:(te,de)=>((0,ze.$NF)(Ne,"portsAttributes"),H.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,ze.$NF)(Ne,"tunnelFactory"),H.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,ze.$NF)(Ne,"timeline"),Hi.registerTimelineProvider(te,de,Ne.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,ze.$NF)(Ne,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Me)=>ht.onDidGrantWorkspaceTrust(te,de,Me),registerEditSessionIdentityProvider:(te,de)=>((0,ze.$NF)(Ne,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Me)=>((0,ze.$NF)(Ne,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ne)(te,de,Me)),registerCanonicalUriProvider:(te,de)=>((0,ze.$NF)(Ne,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Me)=>((0,ze.$NF)(Ne,"canonicalUriProvider"),ht.provideCanonicalUri(te,de,Me))},fn={get inputBox(){return Fe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Ne)},createSourceControl(te,de,Me){return bi.createSourceControl(Ne,te,de,Me)}},on={createCommentController(te,de){return Pi.createCommentController(Ne,te,de)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(te,de,Me){return mt.onDidStartDebugSession(te,de,Me)},onDidTerminateDebugSession(te,de,Me){return mt.onDidTerminateDebugSession(te,de,Me)},onDidChangeActiveDebugSession(te,de,Me){return mt.onDidChangeActiveDebugSession(te,de,Me)},onDidReceiveDebugSessionCustomEvent(te,de,Me){return mt.onDidReceiveDebugSessionCustomEvent(te,de,Me)},onDidChangeBreakpoints(te,de,Me){return mt.onDidChangeBreakpoints(te,de,Me)},onDidChangeStackFrameFocus(te,de,Me){return(0,ze.$NF)(Ne,"debugFocus"),mt.onDidChangeStackFrameFocus(te,de,Me)},registerDebugConfigurationProvider(te,de,Me){return mt.registerDebugConfigurationProvider(te,de,Me||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return mt.registerDebugAdapterDescriptorFactory(Ne,te,de)},registerDebugAdapterTrackerFactory(te,de){return mt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Me){return!Me||typeof Me=="object"&&"configuration"in Me?mt.startDebugging(te,de,{parentSession:Me}):mt.startDebugging(te,de,Me||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,de){return mt.asDebugSourceUri(te,de)}},Ni={registerTaskProvider:(te,de)=>Kt.registerTaskProvider(Ne,te,de),fetchTasks:te=>Kt.fetchTasks(te),executeTask:te=>Kt.executeTask(Ne,te),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(te,de,Me)=>Kt.onDidStartTask(te,de,Me),onDidEndTask:(te,de,Me)=>Kt.onDidEndTask(te,de,Me),onDidStartTaskProcess:(te,de,Me)=>Kt.onDidStartTaskProcess(te,de,Me),onDidEndTaskProcess:(te,de,Me)=>Kt.onDidEndTaskProcess(te,de,Me)},zi={createNotebookController(te,de,Me,rt,yt){return si.createNotebookController(Ne,te,de,Me,rt,(0,ze.$MF)(Ne,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>kt.registerNotebookCellStatusBarItemProvider(Ne,te,de),createRendererMessaging(te){return ki.createRendererMessaging(Ne,te)},createNotebookControllerDetectionTask(te){return(0,ze.$NF)(Ne,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ne,te)},registerKernelSourceActionProvider(te,de){return(0,ze.$NF)(Ne,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ne,te,de)},onDidChangeNotebookCellExecutionState(te,de,Me){return(0,ze.$NF)(Ne,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,de,Me)}},Oi={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Me=!te||typeof te[0]!="object"?te:te[0];return Wt.getMessage(Ne.identifier.value,{message:de,args:Me})}return Wt.getMessage(Ne.identifier.value,te[0])},get bundle(){return Wt.getBundle(Ne.identifier.value)},get uri(){return Wt.getBundleUri(Ne.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,ze.$NF)(Ne,"interactive"),Gi.registerProvider(Ne,te,de={label:te.label??Ne.displayName??Ne.name})},registerInteractiveSessionProvider(te,de){return(0,ze.$NF)(Ne,"interactive"),ui.registerChatProvider(Ne,te,de)},addInteractiveRequest(te){return(0,ze.$NF)(Ne,"interactive"),ui.addChatRequest(te)},sendInteractiveRequestToProvider(te,de){return(0,ze.$NF)(Ne,"interactive"),ui.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,ze.$NF)(Ne,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(te,de){return(0,ze.$NF)(Ne,"interactive"),ui.transferChatSession(te,de)}},Ui={getRelatedInformation(te,de){return(0,ze.$NF)(Ne,"aiRelatedInformation"),Xi.getRelatedInformation(Ne,te,de)},registerRelatedInformationProvider(te,de){return(0,ze.$NF)(Ne,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(Ne,te,de)},registerEmbeddingVectorProvider(te,de){return(0,ze.$NF)(Ne,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Ne,te,de)}},ji={registerChatResponseProvider(te,de,Me){return(0,ze.$NF)(Ne,"chatProvider"),fi.registerProvider(Ne.identifier,te,de,Me)},registerSlashCommand(te,de,Me){return(0,ze.$NF)(Ne,"chatSlashCommands"),Qi.registerCommand(Ne.identifier,te,de,Me??{description:""})},requestChatAccess(te){return(0,ze.$NF)(Ne,"chatRequestAccess"),fi.requestChatResponseProvider(Ne.identifier,te)},registerVariable(te,de,Me){return(0,ze.$NF)(Ne,"chatVariables"),Yi.registerVariableResolver(Ne,te,de,Me)},registerMappedEditsProvider(te,de){return(0,ze.$NF)(Ne,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ne,te,de)}};return{version:ut.version,ai:Ui,authentication:_i,commands:xi,comments:on,chat:ji,debug:an,env:en,extensions:tn,interactive:di,l10n:Oi,languages:nn,notebooks:zi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:X.$UK,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatMessage:X.$KL,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$hK,CallHierarchyItem:X.$gK,CallHierarchyOutgoingCall:X.$iK,CancellationError:T.$3,CancellationTokenSource:w.$od,CandidatePortSource:u.CandidatePortSource,CodeAction:X.$cK,CodeActionKind:X.$dK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$jK,Color:X.$wK,ColorInformation:X.$xK,ColorPresentation:X.$yK,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$qK,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$rK,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$GK,DebugAdapterExecutable:X.$YK,DebugAdapterInlineImplementation:X.$2K,DebugAdapterNamedPipeServer:X.$1K,DebugAdapterServer:X.$ZK,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$0J,DiagnosticRelatedInformation:X.$9J,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$VJ,DocumentHighlight:X.$_J,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$vK,DocumentSymbol:X.$bK,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$5K,InlineValueText:X.$6K,InlineValueVariableLookup:X.$7K,InlineValueEvaluatableExpression:X.$8K,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:C.$ed,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$fL,FileDecoration2:X.$fL,FileSystemError:X.$0K,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:X.$$K,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$WK,InlineCompletionItem:X.$sK,InlineCompletionList:X.$tK,Hover:X.$$J,IndentAction:f.IndentAction,Location:X.$8J,MarkdownString:X.$kK,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:X.$lK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$WJ,ProcessExecution:X.$EK,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$eL,Range:X.$XJ,RelativePattern:X.$SK,Selection:X.$YJ,SelectionRange:X.$fK,SemanticTokens:X.$bL,SemanticTokensBuilder:X.$aL,SemanticTokensEdit:X.$cL,SemanticTokensEdits:X.$dL,SemanticTokensLegend:X.$_K,ShellExecution:X.$FK,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$nK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$mK,SnippetString:X.$7J,SourceBreakpoint:X.$VK,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$aK,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$HK,TaskGroup:X.$DK,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$zK,TerminalQuickFixExecuteTerminalCommand:X.$BK,TerminalQuickFixOpener:X.$AK,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$CK,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$3J,SnippetTextEdit:X.$5J,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$RK,ThemeIcon:X.$QK,TreeItem:X.$IK,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$AL,UIKind:p.UIKind,Uri:A.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$6J,DocumentDropEdit:X.$OK,DocumentPasteEdit:X.$PK,InlayHint:X.$pK,InlayHintLabelPart:X.$oK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$2J,ResolvedAuthority:X.$ZJ,ManagedResolvedAuthority:X.$1J,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$pL,NotebookRange:X.$hL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$iL,NotebookData:X.$jL,NotebookRendererScript:X.$nL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$lL,NotebookCellOutputItem:X.$kL,NotebookCellStatusBarItem:X.$mL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$4J,NotebookKernelSourceAction:X.$oL,PortAttributes:X.$rL,LinkedEditingRanges:X.$qL,TestResultState:X.TestResultState,TestRunRequest:X.$sL,TestMessage:X.$tL,TestMessage2:X.$tL,TestTag:X.$uL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$NK,DataTransferItem:X.$JK,CoveredCount:X.$vL,FileCoverage:X.$wL,StatementCoverage:X.$xL,BranchCoverage:X.$yL,FunctionCoverage:X.$zL,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$BL,TabInputTextDiff:X.$CL,TabInputTextMerge:X.$DL,TabInputCustom:X.$EL,TabInputNotebook:X.$GL,TabInputNotebookDiff:X.$HL,TabInputWebview:X.$FL,TabInputTerminal:X.$IL,TabInputInteractiveWindow:X.$JL,TelemetryTrustedValue:Ee.$$n,LogLevel:ve.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$3K,ThreadFocus:X.$4K,NotebookCodeActionKind:X.$eK,RelatedInformationType:X.RelatedInformationType}}}e.$Occ=Bt}),define(Ae[273],Re([1,0,70,110,33,108,34,31,59,62,112,114,115,84,86,80,109,61,39,83,57,60,241,14,113,81,82]),function(be,e,w,T,C,L,A,l,S,f,P,k,u,p,m,h,t,i,c,g,D,b,n,a,s,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$kr)(o.$pbc,o.$obc,1),(0,w.$kr)(a.$5i,n.$Pcc,1),(0,w.$kr)(h.$Oac,h.$Pac,1),(0,w.$kr)(l.$fM,l.$eM,0),(0,w.$kr)(A.$2ac,A.$Zac,0),(0,w.$kr)(i.$ebc,i.$dbc,0),(0,w.$kr)(k.$5bc,k.$9bc,0),(0,w.$kr)(L.$Wbc,L.$Vbc,0),(0,w.$kr)(S.$7L,S.$6L,0),(0,w.$kr)(y.$qbc,y.$rbc,0),(0,w.$kr)(c.$Lac,c.$Kac,0),(0,w.$kr)(T.$Cbc,T.$Bbc,1),(0,w.$kr)(u.$ccc,u.$dcc,0),(0,w.$kr)(p.$abc,p.$_ac,0),(0,w.$kr)(P.$Zbc,P.$Ybc,0),(0,w.$kr)(f.$hbc,f.$kbc,0),(0,w.$kr)(m.$csb,m.$dsb,0),(0,w.$kr)(t.$Sbc,t.$Rbc,0),(0,w.$kr)(C.$Yac,C.$Xac,0),(0,w.$kr)(g.$mbc,g.$lbc,0),(0,w.$kr)(D.$dM,D.$aM,0),(0,w.$kr)(b.$1bc,b.$2bc,0),(0,w.$kr)(s.$3bc,s.$4bc,0)}),define(Ae[274],Re([1,0,272,35,2,269,7,13,260]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class f extends L.$Scc{j(){}getModule(p,m){for(const h of this.b){const t=h(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends T.$tbc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(S.$Xec);const p=this.h.invokeFunction(w.$Occ);this.r=this.h.createInstance(f,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,m,h){m=m.with({path:k(m.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri(m)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const g=await c.text(),D=`${m.toString(!0)}#vscode-extension`,b=`${g}
//# sourceURL=${D}`;let n;try{n=new Function("module","exports","require",b)}catch(y){throw console.error(t?`Loading code for extension ${t} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${m.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}p&&await this.w.initializeLocalizedMessages(p);const a={},s={exports:a},o=y=>{const $=this.r.getModule(y,m);if($===void 0)throw new Error(`Cannot load module '${y}'`);return $};try{return h.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,a,o),s.exports!==a?s.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),h.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+p;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Gg)(10)}}e.$Yec=P;function k(u,p){return u.endsWith(p)?u:u+p}}),define(Ae[275],Re([1,0,69,70,14,35,188,85,274]),function(be,e,w,T,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$kr)(C.$4i,new w.$xh(A.$Rcc,[!0],!0)),(0,T.$kr)(L.$ubc,S.$Yec,0),(0,T.$kr)(l.$fbc,l.$gbc,0)}),define(Ae[284],Re([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(be,e,w,T,C,L,A,l,S,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(n){return/^(file|vscode-remote):/i.test(n)}const m=fetch.bind(self);function h(n){self.fetch=async function(a,s){return a instanceof Request||p(String(a))&&(a=(await n(P.URI.parse(String(a)))).toString(!0)),m(a,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,s,o,y,$){(async()=>(p(s.toString())&&(s=(await n(P.URI.parse(s.toString()))).toString(!0)),super.open(a,s,o??!0,y,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(a,s){if(/^file:/i.test(a.toString()))a=f.$1f.uriToBrowserUri(P.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(r){function d(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const v=fetch.bind(self);self.fetch=function(B,V){return B instanceof Request?v(B,V):v(d(B),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,V,j,W,N){return super.open(B,d(V),j??!0,W,N)}};const R=importScripts.bind(self);self.importScripts=(...B)=>{R(...B.map(d))},R(r)}.toString()}('${a}'))`;s=s||{},s.name=s.name||l.$_d(a.toString());const $=new Blob([y],{type:"application/javascript"}),I=URL.createObjectURL($);return new n(I,s)}}else self.Worker=class extends A.$Zec{constructor(n,a){super(u,n,{name:l.$_d(n.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(n){k()}};class i{constructor(){const a=new MessageChannel,s=new T.$ed;let o=!1;u(a.port2,[a.port2]),a.port1.onmessage=y=>{const{data:$}=y;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const I=w.$Ed.wrap(new Uint8Array($,0,$.byteLength));if((0,C.$4l)(I,2)){o=!0,g("received terminate message from renderer");return}s.fire(I)},this.protocol={onMessage:s.event,send:y=>{if(!o){const $=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);a.port1.postMessage($,[$])}}}}}function c(n){return new Promise(a=>{const s=n.onMessage(o=>{s.dispose();const y=JSON.parse(o.toString());n.send((0,C.$3l)(0)),a({protocol:n,initData:y})});n.send((0,C.$3l)(1))})}let g=n=>k();function D(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function b(){S.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(a){D(a)&&c(n.protocol).then(s=>{S.mark("code/extHost/didWaitForInitData");const o=new L.$Ucc(s.protocol,s.initData,t,null,a.data);h(y=>o.asBrowserUri(y)),g=y=>o.terminate(y)})}}}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f36df69328ed10f76d4be03e8a82b61794b49711/core/vs/workbench/api/worker/extensionHostWorker.js.map
